/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
/*
*
* Script de DDL e DML
*
* Versao 2.02.2
*
* Fabio Bertoldi - 20140130
*
*/

----------------
-- Ticket #21146
----------------

ALTER TABLE contabilidade.plano_conta_estrutura ALTER COLUMN codigo_estrutural TYPE VARCHAR(30);

INSERT INTO contabilidade.plano_conta_geral (cod_uf, cod_plano, versao, dt_versao) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2)+1, 1), '2.0', '2014-01-06');

INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.0.0.0.0.00.00.00.00.0000','ATIVO','COMPREENDE OS RECURSOS CONTROLADOS POR UMA ENTIDADE COMO CONSEQÜÊNCIA DE EVENTOS PASSADOS E DOS QUAIS SE ESPERA QUE FLUAM BENEFÍCIOS ECONÔMICOS OU POTENCIAL DE SERVIÇOS FUTUROS A UNIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.0.0.0.00.00.00.00.0000','ATIVO CIRCULANTE','COMPREENDE OS ATIVOS QUE ATENDAM A QUALQUER UM DOS SEGUINTES CRITÉRIOS: SEJAM CAIXA OU EQUIVALENTE DE CAIXA; SEJAM REALIZÁVEIS OU MANTIDOS PARA VENDA OU CONSUMO DENTRO DO CICLO OPERACIONAL DA ENTIDADE; SEJAM MANTIDOS PRIMARIAMENTE PARA NEGOCIAÇÃO; SEJAM REALIZÁVEIS ATÉ O TÉRMINO DO EXERCÍCIO SEGUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.0.0.00.00.00.00.0000','CAIXA E EQUIVALENTES DE CAIXA','COMPREENDE O SOMATÓRIO DOS VALORES EM CAIXA E EM BANCOS, BEM COMO EQUIVALENTES, QUE REPRESENTAM RECURSOS COM LIVRE MOVIMENTAÇÃO PARA APLICAÇÃO NAS OPERAÇÕES DA ENTIDADE E PARA OS QUAIS NÃO HAJA RESTRIÇÕES PARA USO IMEDIATO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.0.00.00.00.00.0000','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL','COMPREENDE O SOMATÓRIO DOS VALORES EM CAIXA E EM BANCOS, BEM COMO EQUIVALENTES, QUE REPRESENTAM RECURSOS COM LIVRE MOVIMENTAÇÃO PARA APLICAÇÃO NAS OPERAÇÕES DA ENTIDADE E PARA OS QUAIS NÃO HAJA RESTRIÇÕES PARA USO IMEDIATO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.00.00.00.00.0000','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - CONSOLIDAÇÃO','COMPREENDE O SOMATÓRIO DOS VALORES DE CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.01.00.00.00.0000','CAIXA','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DE NUMERÁRIO E OUTROS VALORES EM TESOURARIAS E PAGADORIAS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.02.00.00.00.0000','CONTA ÚNICA','REGISTRA OS VALORES DA CONTA ÚNICA, EXCETO RPPS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.06.00.00.00.0000','CONTA ÚNICA - RPPS','APRESENTA O SOMATÓRIO DOS VALORES DISPONÍVEIS NA CONTA ÚNICA DO RPPS, NOS AGENTES FINANCEIROS AUTORIZADOS NO ÂMBITO DO ENTE PÚBLICO. ESSA CONTA DEVERÁ SER DESDOBRADA PELO RPPS NA QUANTIDADE DE AGENTES FINANCEIROS EM QUE MANTENHA CONTA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.06.01.00.00.0000','BANCO CONTA MOVIMENTO - RPPS','REGISTRA A MOVIMENTAÇÃO DE RECURSOS NA CONTA MOVIMENTO DO RPPS ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS .','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.06.02.00.00.0000','BANCO CONTA MOVIMENTO - PLANO FINANCEIRO','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DOS RECURSOS NAS CONTAS MOVIMENTO DO PLANO FINANCEIRO DO RPPS ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.06.03.00.00.0000','BANCO CONTA MOVIMENTO - PLANO PREVIDENCIÁRIO','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DOS RECURSOS NAS CONTAS MOVIMENTO DO PLANO PREVIDENCIÁRIO DO RPPS ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.06.04.00.00.0000','BANCO CONTA MOVIMENTO - TAXA DE ADMINISTRAÇÃO','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DOS RECURSOS NAS CONTAS MOVIMENTO DA TAXA DE ADMINISTRAÇÃO, ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.19.00.00.00.0000','BANCOS CONTA MOVIMENTO - DEMAIS CONTAS','REGISTRA O SOMATÓRIO DAS DISPONIBILIDADES EXISTENTES NAS CONTAS BANCARIAS, AGREGADAS PELOS SUBITENS IDENTIFICATIVOS DOS BANCOS CORRESPONDENTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.19.02.00.00.0000','BANCO DO BRASIL','REGISTRA O SOMATÓRIO DA MOVIMENTAÇÃO FINANCEIRA DAS CONTAS EXISTENTES NA INSTITUIÇÃO FINANCEIRA BANCO DO BRASIL.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.19.03.00.00.0000','CAIXA ECONOMICA FEDERAL','REGISTRA O SOMATÓRIO DA MOVIMENTAÇÃO FINANCEIRA DAS CONTAS EXISTENTES NA INSTITUIÇÃO FINANCEIRA CAIXA ECONÔMICA FEDERAL.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.19.99.00.00.0000','DEMAIS CONTAS BANCARIAS','REGISTRA AS ARRECADAÇÕES DE RECEITAS DA ENTIDADE E DE OUTROS VALORES DESTA SOB SUA GUARDA OU RESPONSABILIDADE, ESPECIFICAMENTE QUANDO O BANCO NÃO SE ENCONTRA RELACIONADO NAS CONTAS ACIMA.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.30.00.00.00.0000','REDE BANCÁRIA - ARRECADAÇÃO','COMPREENDE O SOMATÓRIO DOS RECURSOS REFERENTES A RECEITAS ARRECADADAS E NÃO RECOLHIDAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.30.01.00.00.0000','ARRECADAÇÃO DIRETA','REGISTRA OS VALORES DAS RECEITAS ARRECADADAS DIRETAMENTE PELA ENTIDADE.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.30.02.00.00.0000','ARRECADAÇÃO INDIRETA','REGISTRA OS VALORES DA RECEITA ARRECADADA PELOS AGENTES FINANCEIROS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.50.00.00.00.0000','APLICAÇÕES FINANCEIRAS DE LIQUIDEZ IMEDIATA','COMPREENDE AS APLICAÇÕES FINANCEIRAS DE ALTA LIQUIDEZ EM MOEDA NACIONAL, QUE SAO PRONTAMENTE CONVERSÍVEIS EM VALORES CONHECIDOS DE CAIXA E QUE ESTAO SUJEITAS A UM INSIGNIFICANTE RISCO DE MUDANÇA DE VALOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.50.01.00.00.0000','TÍTULOS PÚBLICOS','REGISTRA OS VALORES DAS DISPONIBILDIADES DAS INSTITUIÇÕES, ENTIDADES E UNIDADES APLICADAS EM TÍTULOS PÚBLICOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.50.05.00.00.0000','POUPANÇA','REGISTRA O VALOR DAS APLICAÇÕES FINANCEIRAS EM POUPANCAS E SEU RENDIMENTOS (JUROS E ATUALIZAÇÃO MONETARIA) POSTERIORES. TAMBÉM UTILIZADA PELOS RPPS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.50.06.00.00.0000','FUNDO DE APLICAÇÃO FINANCEIRA','REGISTRA O VALOR DAS APLICAÇÕES FINANCEIRAS EM FUNDO DE APLICAÇÃO E SEUS RENDIMENTOS (JUROS E ATUALIZAÇÃO) POSTERIORES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.50.10.00.00.0000','CDB','REGISTRA OS VALORES DAS DISPONIBILIDADES DAS INSTITUICOES, ENTIDADES OU UNIDADES APLICADAS CERTIFICADOS DE DEPOSITOS BANCARIOS.(CDB)','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.1.50.99.00.00.0000','OUTRAS APLICAÇÕES FINANCEIRAS DE LIQUIDEZ IMEDIATA','REGISTRA OUTRAS APLICAÇÕES FINANCEIRAS, NÃO CLASSIFICADAS EM ITENS ANTERIORES, DAS DISPONIBILIDADES FINANCEIRAS DAS ENTIDADES, INSTITUICOES OU UNIDADES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.2.00.00.00.00.0000','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - INTRA OFSS','COMPREENDE O SOMATÓRIO DOS VALORES DE CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL. . COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.2.06.00.00.00.0000','CONTA ÚNICA - RPPS','COMPREENDE O SOMATÓRIO DOS VALORES DISPONÍVEIS NA CONTA ÚNICA DO RPPS, NOS AGENTES FINANCEIROS AUTORIZADOS NO ÂMBITO DO ENTE PÚBLICO. ESSA CONTA DEVERÁ SER DESDOBRADA PELO RPPS NA QUANTIDADE DE AGENTES FINANCEIROS EM QUE MANTENHA CONTA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.2.06.01.00.00.0000','BANCO CONTA MOVIMENTO - RPPS','REGISTRA A MOVIMENTAÇÃO DE RECURSOS NA CONTA MOVIMENTO DO RPPS ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS .','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.2.06.02.00.00.0000','BANCO CONTA MOVIMENTO - PLANO FINANCEIRO','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DOS RECURSOS NAS CONTAS MOVIMENTO DO PLANO FINANCEIRO DO RPPS ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.2.06.03.00.00.0000','BANCO CONTA MOVIMENTO - PLANO PREVIDENCIÁRIO','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DOS RECURSOS NAS CONTAS MOVIMENTO DO PLANO PREVIDENCIÁRIO DO RPPS ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.2.06.04.00.00.0000','BANCO CONTA MOVIMENTO - TAXA DE ADMINISTRAÇÃO','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DOS RECURSOS NAS CONTAS MOVIMENTO DA TAXA DE ADMINISTRAÇÃO, ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.2.20.00.00.00.0000','RECURSOS LIBERADOS PELO TESOURO MUNIUCIPAL','COMPREENDE OS RECURSOS LIBERADOS PELO TESOURO MUNICIPAL, PARA ATENDER A DESPESAS DO EXERCÍCIO E DE EXERCÍCIO ANTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.2.20.01.00.00.0000','LIMITE DE SAQUE COM VINCULAÇÃO DE PAGAMENTO','REGISTRA O VALOR DO LIMITE DE SAQUE DA CONTA UNICA DA ENTIDADE, PARA ATENDER DESPESAS COM VINCULAÇÃO DE PAGAMENTO.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.1.2.20.08.00.00.0000','REPASSES A RECEBER','REGISTRA OS RECURSOS A RECEBER REFERENTES AS PARCELAS NAO RECEBIDAS DO ORCAMENTO PELAS ENTIDADES DA ADMINISTRACAO INDIRETA.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.2.0.00.00.00.00.0000','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA','COMPREENDE O SOMATÓRIO DOS VALORES DE CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.2.1.00.00.00.00.0000','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA - CONSOLIDAÇÃO','COMPREENDE O SOMATÓRIO DOS VALORES DE CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.2.1.01.00.00.00.0000','CAIXA','REGISTRA O SOMATÓRIO DE NUMERÁRIO EM ESPÉCIE E OUTROS VALORES EM TESOURARIA NO EXTERIOR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.2.1.02.00.00.00.0000','BANCOS','REGISTRA A LIVRE MOVIMENTAÇÃO DE RECURSOS FINANCEIROS EM MOEDA EXTRANGEIRA MANTIDOS EM CONTAS BANCÁRIAS NO EXTERIOR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.1.2.1.03.00.00.00.0000','APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA','REGISTRA AS APLICAÇÕES FINANCEIRAS DE ALTA LIQUIDEZ EM MOEDA ESTRANGEIRA, QUE SÃO PRONTAMENTE CONVERSÍVEIS EM VALORES CONHECIDOS DE CAIXA E QUE ESTÃO SUJEITAS A UM INSIGNIFICANTE RISCO DE MUDANÇA DE VALOR, INCLUSIVE AS APLICAÇÕES REFERENTES AO FECHAMENTO DE CÂMBIO PARA AQUISIÇÃO DE MOEDA ESTRANGEIRA E AS APLICAÇÕES DE DEPÓSITOS COM JUROS EM MOEDA ESTRANGEIRA REALIZADAS NO CURTÍSSIMO PRAZO.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.0.0.00.00.00.00.0000','CRÉDITOS A CURTO PRAZO','COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVIÇOS, CRÉDITOS TRIBUTÁRIOS, DÍVIDA ATIVA, TRANSFERÊNCIA E EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.0.00.00.00.00.0000','CRÉDITOS TRIBUTÁRIOS A RECEBER','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SÃO : IMPOSTOS, TAXAS, CONTRIBUIÇÕES DE MELHORIA, E CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.1.00.00.00.00.0000','CRÉDITOS TRIBUTÁRIOS A RECEBER - CONSOLIDAÇÃO','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SÃO : IMPOSTOS, TAXAS, CONTRIBUIÇÕES DE MELHORIA, E CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.1.01.00.00.00.0000','IMPOSTOS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE IMPOSTOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.1.01.01.00.00.0000','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA RETIDOS NA FONTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.1.01.05.00.00.0000','IPTU','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE IPTU A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.1.01.06.00.00.0000','ITBI','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ITBI A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.1.01.07.00.00.0000','ISS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ISS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.1.01.08.00.00.0000','ITR','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ITR A RECEBER - MUNICIPIOS CONVENIADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.1.02.00.00.00.0000','TAXAS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE TAXAS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.1.02.01.00.00.0000','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.1.02.02.00.00.0000','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS PELA PRESTAÇÃO DE SERVIÇOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.1.03.00.00.00.0000','CONTRIBUIÇÕES DE MELHORIAS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE CONTRIBUIÇÕES DE MELHORIAS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.1.04.00.00.00.0000','CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.2.00.00.00.00.0000','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTRA OFSS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIA, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SÃO : IMPOSTOS, TAXAS, CONTRIBUIÇÕES DE MELHORIA, CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.2.01.00.00.00.0000','IMPOSTOS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE IMPOSTOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.2.01.01.00.00.0000','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA RETIDOS NA FONTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.2.01.05.00.00.0000','IPTU','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE IPTU A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.2.01.06.00.00.0000','ITBI','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ITBI A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.2.01.07.00.00.0000','ISS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ISS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.2.01.08.00.00.0000','ITR','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ITR A RECEBER - MUNICIPIOS CONVENIADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.2.02.00.00.00.0000','TAXAS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE TAXAS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.2.02.01.00.00.0000','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.2.02.02.00.00.0000','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS PELA PRESTAÇÃO DE SERVIÇOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.2.03.00.00.00.0000','CONTRIBUIÇÕES DE MELHORIAS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE CONTRIBUIÇÕES DE MELHORIAS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.2.04.00.00.00.0000','CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.3.00.00.00.00.0000','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS UNIÃO','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIA, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SÃO : IMPOSTOS, TAXAS, CONTRIBUIÇÕES DE MELHORIA, CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.3.01.00.00.00.0000','IMPOSTOS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE IMPOSTOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.3.01.01.00.00.0000','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA RETIDOS NA FONTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.3.01.05.00.00.0000','IPTU','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE IPTU A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.3.01.06.00.00.0000','ITBI','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ITBI A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.3.01.07.00.00.0000','ISS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ISS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.3.01.08.00.00.0000','ITR','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ITR A RECEBER - MUNICIPIOS CONVENIADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.3.02.00.00.00.0000','TAXAS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE TAXAS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.3.02.01.00.00.0000','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.3.02.02.00.00.0000','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS PELA PRESTAÇÃO DE SERVIÇOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.3.03.00.00.00.0000','CONTRIBUIÇÕES DE MELHORIAS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE CONTRIBUIÇÕES DE MELHORIAS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.3.04.00.00.00.0000','CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.4.00.00.00.00.0000','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS ESTADO','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIA, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SÃO : IMPOSTOS, TAXAS, CONTRIBUIÇÕES DE MELHORIA, CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.4.01.00.00.00.0000','IMPOSTOS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE IMPOSTOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.4.01.01.00.00.0000','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA RETIDOS NA FONTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.4.01.05.00.00.0000','IPTU','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE IPTU A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.4.01.06.00.00.0000','ITBI','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ITBI A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.4.01.07.00.00.0000','ISS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ISS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.4.01.08.00.00.0000','ITR','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ITR A RECEBER - MUNICIPIOS CONVENIADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.4.02.00.00.00.0000','TAXAS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE TAXAS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.4.02.01.00.00.0000','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.4.02.02.00.00.0000','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS PELA PRESTAÇÃO DE SERVIÇOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.4.03.00.00.00.0000','CONTRIBUIÇÕES DE MELHORIAS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE CONTRIBUIÇÕES DE MELHORIAS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.4.04.00.00.00.0000','CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.5.00.00.00.00.0000','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS MUNICÍPIO','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIA, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SÃO : IMPOSTOS, TAXAS, CONTRIBUIÇÕES DE MELHORIA, CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.5.01.00.00.00.0000','IMPOSTOS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE IMPOSTOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.5.01.01.00.00.0000','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA RETIDOS NA FONTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.5.01.05.00.00.0000','IPTU','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE IPTU A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.5.01.06.00.00.0000','ITBI','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ITBI A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.5.01.07.00.00.0000','ISS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ISS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.5.01.08.00.00.0000','ITR','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ITR A RECEBER - MUNICIPIOS CONVENIADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.5.02.00.00.00.0000','TAXAS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE TAXAS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.5.02.01.00.00.0000','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.5.02.02.00.00.0000','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS PELA PRESTAÇÃO DE SERVIÇOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.5.03.00.00.00.0000','CONTRIBUIÇÕES DE MELHORIAS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE CONTRIBUIÇÕES DE MELHORIAS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.5.04.00.00.00.0000','CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS DE CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.5.05.00.00.00.0000','DEMAIS CONTRIBUIÇÕES','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS AOS CRÉDITOS A RECEBER, DECORRENTES DA COBRANÇA DAS DEMAIS CONTRIBUIÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.5.05.01.00.00.0000','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','REGISTRA OS VALORES RELATIVOS AOS CRÉDTIOS A RECEBER DOS MUNICÍPIOS E O DISTRITO FEDERAL QUE INSTITUIREM CONTRIBUIÇÃO, NA FORMA DAS RESPECTIVAS LEIS, PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA, CONFORME ARTIGO 149-A DA CONSTITUIÇÃO FEDERAL DE 1988.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.1.5.70.00.00.00.0000','CRÉDITOS TRIBUTARIOS PARCELADOS','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS AOS CRÉDITOS A RECEBER, DECORRENTES DE CRÉDITOS TRIBUTÁRIOS PARCELADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.2.0.00.00.00.00.0000','CLIENTES','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVIÇOS QUE OCORREM NO CURSO NORMAL DAS OPERAÇÕES DA ENTIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.2.1.00.00.00.00.0000','CLIENTES- CONSOLIDAÇÃO','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVIÇOS QUE OCORREM NO CURSO NORMAL DAS OPERAÇÕES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.2.1.01.00.00.00.0000','FATURAS/DUPLICATAS A RECEBER','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVIÇOS QUE OCORREM NO CURSO NORMAL DAS OPERAÇÕES DA UNIDADE, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.2.1.01.03.00.00.0000','FATURAS/ DUPLICATAS A RECEBER- ESTOQUE PROPRIO','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.2.1.01.06.00.00.0000','FATURAS/ DUPLICATAS A RECEBER - PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.2.1.01.80.00.00.0000','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.2.1.01.97.00.00.0000','(-) DUPLICATAS DESCONTADAS - ESTOQUES PROPRIOS','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.2.1.02.00.00.00.0000','FATURAS/DUPLICATAS A FATURAR','REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.2.1.03.00.00.00.0000','FATURAS/DUPLICATAS A RECEBER VENCIDAS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.0.00.00.00.00.0000','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTES DE TRANSFERÊNCIAS OBRIGATÓRIAS DA UNIÃO, ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.1.00.00.00.00.0000','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - CONSOLIDAÇÃO','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS DA UNIÃO, ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS, CONSÓRCIOS PÚBLICOS E OUTRAS INSTITUIÇÕES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.1.01.00.00.00.0000','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS DE INSTITUIÇÕES PRIVADAS','REGISTRA OS RECURSOS A RECEBER PELOS ENTES DECORRENTE DE TRANSFERÊNCIA DE INSTITUIÇÕES PRIVADAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.1.02.00.00.00.0000','CRÉDITOS DE CONSÓRCIOS PÚBLICOS DECORRENTES DE CONTRATO DE RATEIO','REGISTRA OS RECURSOS A RECEBER PELO CONSÓRCIO DECORRENTE DO CONTRATO DE RATEIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.00.00.00.00.0000','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - UNIÃO','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE TRANSFERÊNCIAS OBRIGATÓRIAS DA UNIÃO, ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.01.00.00.00.0000','CRÉDITOS DECORRENTES DA PARTICIPAÇÃO NAS RECEITAS DA UNIÃO','COMPREENDE OS RECURSOS A RECEBER PELO ESTADO POR SUA PARTICIPAÇÃO CONSTITUCIONAL E LEGAL EM RECEITAS ARRECADADAS PELA UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.01.02.00.00.0000','COTA-PARTE DO FPM','REGISTRA A PARTICIPAÇÃO DOS MUNICÍPIOS NO PRODUTO DA ARRECADAÇÃO DOS IMPOSTOS SOBRE A RENDA E SOBRE PRODUTOS INDUSTRIALIZADOS, CONFORME COEFICIENTES FIXADOS PELO TRIBUNAL DE CONTAS DA UNIÃO, A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.01.03.00.00.0000','COTA-PARTE DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL','REGISTRA A PARTICIPAÇÃO DOS MUNICÍPIOS NO PRODUTO DA ARRECADAÇÃO DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL, TRANSFERIDO PELA UNIÃO AOS MUNICÍPIOS ONDE ESTEJAM LOCALIZADOS OS IMÓVEIS SOBRE OS QUAIS INCIDA O IMPOSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.01.04.00.00.0000','COTA-PARTE DO IPI - ESTADOS EXPORTADORES DE PRODUTOS INDUSTRIALIZADOS','REGISTRA A PARCELA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS DESTINADA AOS ESTADOS EXPORTADORES DE PRODUTOS INDUSTRIALIZADOS, A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.01.05.00.00.0000','COTA-PARTE DA CIDE','REGISTRA A PARCELA DA COTA-PARTE DA CONTRIBUIÇÃO DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO, A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.02.00.00.00.0000','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS PELA EXPLORAÇÃO DE RECURSOS NATURAIS','COMPREENDE OS RECURSOS A RECEBER PELO ESTADO OU MUNICÍPIO DECORRENTES DA EXPLORAÇÃO DE RECURSOS NATURAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.02.01.00.00.0000','COTA-PARTE DA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECUROS HÍDRICOS','REGISTRA A PARCELA DA COTA-PARTE DA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECURSOS HÍDRICOS, A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.02.02.00.00.0000','COTA-PARTE CA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECURSOS MINERAIS','REGISTRA A PARCELA DA COTA-PARTE DA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECURSOS MINERAIS, A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.02.03.00.00.0000','COTA-PARTE DO VALOR DO PETRÓLEO BRUTO DE PRODUÇÃO NACIONAL','REGISTRA A PARCELA DA COTA-PARTE DO VALOR DO PETRÓLEO BRUTO DE PRODUÇÃO NACIONAL, A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.03.00.00.00.0000','CRÉDITOS DECORRENTES DE TRASNSFERÊNCIA DO SUS','REGISTRA OS RECURSOS A RECEBER PELO ESTADO OU MUNICÍPIO DECORRENTES DAS TRANSFERÊNCIAS DO SISTEMA ÚNICO DE SAÚDE','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.04.00.00.00.0000','CRÉDITOS DECORRENTES DO FNAS','REGISTRA OS RECURSOS A RECEBER PELO ESTADO OU MUNICÍPIO DECORRENTES DAS TRANSFERÊNCIAS DO FUNDO NACIONAL DE ASSISTÊNCIA SOCIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.05.00.00.00.0000','CRÉDITOS DECORRENTES DE TRASNSFERÊNCIA DO FNDE','COMPREENDE OS RECURSOS A RECEBER PELO ESTADO OU MUNICÍPIO DECORRENTES DAS TRANSFERÊNCIAS DO FUNDO NACIONAL DE DESENVOLVIMENTO DA EDUCAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.05.01.00.00.0000','COTA-PARTE DO SALÁRIO-EDUCAÇÃO','REGISTRA A PARCELA DO PRODUTO ARRECADADO DA CONTRIBUIÇÃO DO SALÁRIO-EDUCAÇÃO, A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.06.00.00.00.0000','CRÉDITOS DECORRENTES DAS TRANSFERÊNCIAS DO ICMS - DESONERAÇÃO - LC 87/96','COMPREENDE OS RECURSOS A RECEBER PELO ESTADO OU MUNICÍPIO DECORRENTES DAS TRANSFERÊNCIAS FINANCEIRAS PELA DESONERAÇÃO DE ICMS, PREVISTA NA LEI COMPLEMENTAR 87/96.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.06.01.00.00.0000','TRANSFERÊNCIA FINANCEIRA DO ICMS - DESONERAÇÃO - LC 87/96','REGISTRA AS TRANSFERÊNCIAS FINANCEIRAS DO ICMS - DESONERAÇÃO - LEI COMPLEMENTAR 87/96, A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.07.00.00.00.0000','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS MULTIGOVERNAMENTAIS','COMPREENDE OS RECURSOS A RECEBER PELO ESTADO OU MUNICÍPIO DECORRENTES DE TRANSFERÊNCIA MULTIGOVERNAMENTAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.07.01.00.00.0000','FUNDEB','REGISTRA OS RECURSOS A RECEBER PELO ESTADO OU MUNICÍPIO DECORRENTES DAS TRANSFERÊNCIAS DO FUNDO DE MANUTENÇÃO E DESENVOLVIMENTO DA EDUCAÇÃO BÁSICA E DE VALORIZAÇÃO DOS PROFISSIONAIS DA EDUCAÇÃO (FUNDEB).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.08.00.00.00.0000','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS DE CONVÊNIOS','REGISTRA OS RECURSOS A RECEBER PELO ESTADO OU MUNICÍPIO DECORRENTES DE CONVÊNIOS FIRMADOS COM OUTRO ENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.3.09.00.00.00.0000','CRÉDITOS DECORRENTES DE OUTRAS TRANSFERÊNCIAS','COMPREENDE OS RECURSOS A RECEBER PELO ESTADO OU MUNICÍPIO DECORRENTE DE TRANSFERÊNCIAS NÃO ESPECIFICADAS NOS ITENS ACIMA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.4.00.00.00.00.0000','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - ESTADO','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE TRANSFERÊNCIAS OBRIGATÓRIAS DA UNIÃO, ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.4.01.00.00.00.0000','CRÉDITOS DECORRENTES DA PARTICIPAÇÃO NAS RECEITAS DOS ESTADOS','COMPREENDE OS RECURSOS A RECEBER PELOS MUNICÍPIOS POR SUA PARTICIPAÇÃO CONSTITUCIONAL E LEGAL EM RECEITAS ARRECADADAS PELOS ESTADOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.4.01.01.00.00.0000','COTA-PARTE DO ICMS','REGISTRA A PARCELA PERTENCENTE AOS MUNICÍPIOS, DO IMPOSTO SOBRE OPERAÇÕES RELATIVAS À CIRCULAÇÃO DE MERCADORIAS E SOBRE PRESTAÇÕES DE SERVIÇOS DE TRANSPORTE INTERESTADUAL E INTERMUNICIPAL E DE COMUNICAÇÃO, A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.4.01.02.00.00.0000','COTA-PARTE DO IPVA','REGISTRA A PARCELA PERTENCENTE AOS MUNICÍPIOS, DO IMPOSTO SOBRE A PROPRIEDADE DE VEÍCULOS AUTOMOTORES, A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.3.5.00.00.00.00.0000','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - MUNICÍPIO','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS A RECEBER ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE TRANSFERÊNCIAS OBRIGATÓRIAS DA UNIÃO, ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.0.00.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','COMPREENDE O SOMATÓRIO DOS VALORES DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.1.00.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS - CONSOLIDAÇÃO','COMPREENDE O SOMATÓRIO DOS VALORES DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.1.01.00.00.00.0000','EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA A APROPRIAÇÃO DOS VALORES DOS CRÉDITOS POR EMPRÉSTIMOS CONCEDIDOS PELO MUNICÍPIO, ENTIDADES E INSTITUICOES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS, COM VENCIMENTOS A CURTO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.1.02.00.00.00.0000','FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA A APROPRIAÇÃO DOS VALORES DOS FINANCIAMENTOS, A CURTO PRAZO,CONCEDIDOS PELO MUNICÍPIO, ENTIDADES E INSTITUICOES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.1.04.00.00.00.0000','ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','COMPREENDE OS ENCARGOS A RECEBER SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS, EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.1.04.01.00.00.0000','ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRÉSTIMOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.1.04.02.00.00.0000','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.1.07.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSÃO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.1.07.01.00.00.0000','EMPRÉSTIMOS A RECEBER – RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.1.07.02.00.00.0000','FINANCIAMENTOS A RECEBER – RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.1.07.03.00.00.0000','ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRÉSTIMOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.1.07.04.00.00.0000','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.3.00.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - UNIÃO','COMPREENDE O SOMATÓRIO DOS VALORES DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.3.01.00.00.00.0000','EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA A APROPRIAÇÃO DOS VALORES DOS CRÉDITOS POR EMPRÉSTIMOS CONCEDIDOS PELO MUNICÍPIO, ENTIDADES E INSTITUICOES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS, COM VENCIMENTOS A CURTO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.3.02.00.00.00.0000','FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA A APROPRIAÇÃO DOS VALORES DOS FINANCIAMENTOS, A CURTO PRAZO,CONCEDIDOS PELO MUNICÍPIO, ENTIDADES E INSTITUICOES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.3.04.00.00.00.0000','ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','COMPREENDE OS ENCARGOS A RECEBER SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS, EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.3.04.01.00.00.0000','ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRÉSTIMOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.3.04.02.00.00.0000','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.3.07.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSÃO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.3.07.01.00.00.0000','EMPRÉSTIMOS A RECEBER – RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.3.07.02.00.00.0000','FINANCIAMENTOS A RECEBER – RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.3.07.03.00.00.0000','ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRÉSTIMOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.3.07.04.00.00.0000','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.4.00.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - ESTADO','COMPREENDE O SOMATÓRIO DOS VALORES DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.4.01.00.00.00.0000','EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA A APROPRIAÇÃO DOS VALORES DOS CRÉDITOS POR EMPRÉSTIMOS CONCEDIDOS PELO MUNICÍPIO, ENTIDADES E INSTITUICOES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS, COM VENCIMENTOS A CURTO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.4.02.00.00.00.0000','FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA A APROPRIAÇÃO DOS VALORES DOS FINANCIAMENTOS, A CURTO PRAZO,CONCEDIDOS PELO MUNICÍPIO, ENTIDADES E INSTITUICOES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.4.04.00.00.00.0000','ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','COMPREENDE OS ENCARGOS A RECEBER SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS, EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.4.04.01.00.00.0000','ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRÉSTIMOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.4.04.02.00.00.0000','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.4.07.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSÃO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.4.07.01.00.00.0000','EMPRÉSTIMOS A RECEBER – RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.4.07.02.00.00.0000','FINANCIAMENTOS A RECEBER – RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.4.07.03.00.00.0000','ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRÉSTIMOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.4.07.04.00.00.0000','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.5.00.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - MUNICÍPIO','COMPREENDE O SOMATÓRIO DOS VALORES DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.5.01.00.00.00.0000','EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA A APROPRIAÇÃO DOS VALORES DOS CRÉDITOS POR EMPRÉSTIMOS CONCEDIDOS PELO MUNICÍPIO, ENTIDADES E INSTITUICOES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS, COM VENCIMENTOS A CURTO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.5.02.00.00.00.0000','FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA A APROPRIAÇÃO DOS VALORES DOS FINANCIAMENTOS, A CURTO PRAZO,CONCEDIDOS PELO MUNICÍPIO, ENTIDADES E INSTITUICOES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.5.04.00.00.00.0000','ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','COMPREENDE OS ENCARGOS A RECEBER SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS, EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.5.04.01.00.00.0000','ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRÉSTIMOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.5.04.02.00.00.0000','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.5.07.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSÃO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.5.07.01.00.00.0000','EMPRÉSTIMOS A RECEBER – RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.5.07.02.00.00.0000','FINANCIAMENTOS A RECEBER – RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.5.07.03.00.00.0000','ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRÉSTIMOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.4.5.07.04.00.00.0000','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.0.00.00.00.00.0000','DÍVIDA ATIVA TRIBUTÁRIA','COMPREENDE OS VALORES DOS CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA INSCRITOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.00.00.00.00.0000','DÍVIDA ATIVA TRIBUTÁRIA - CONSOLIDAÇÃO','COMPREENDE OS VALORES DOS CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA INSCRITOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.01.00.00.00.0000','DÍVIDA ATIVA TRIBUTARIA DOS IMPOSTOS','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DA MODALIDADE DE TRIBUTO CUJA OBRIGAÇÃO TEM POR FATO GERADOR UMA SITUAÇÃO INDEPENDENTE DE QUALQUER ATIVIDADE ESTATAL ESPECÍFICA RELATIVA AO CONTRIBUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.01.01.00.00.0000','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.01.05.00.00.0000','DÍVIDA ATIVA DO IPTU','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.01.06.00.00.0000','DÍVIDA ATIVA DO ITBI','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE TRANSMISSÃO "INTER VIVOS" DE BENS IMÓVEIS E DE DIREITOS REAIS SOBRE IMÓVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.01.07.00.00.0000','DÍVIDA ATIVA DO ISS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.01.08.00.00.0000','DÍVIDA ATIVA DO ITR','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL, DEVIDOS AOS MUNICÍPIOS OU AO DISTRITO FEDERAL DEVIDO A CONVÊNIOS FIRMADOS COM A UNIÃO, CONFORME INCISO III, PARÁGRAFO 4º DO ARTIGO 153 DA CONSTITUIÇÃO FEDERAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.02.00.00.00.0000','DÍVIDA ATIVA TRIBUTARIA DAS TAXAS','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DA MODALIDADE DE TRIBUTO QUE TEM COMO FATO GERADOR O EXERCÍCIO REGULAR DO PODER DE POLÍCIA OU A UTILIZAÇÃO EFETIVA OU POTENCIAL DE SERVIÇO PÚBLICO ESPECÍFICO E DIVISÍVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSIÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.02.01.00.00.0000','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.02.02.00.00.0000','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.03.00.00.00.0000','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DOS VALORES DECORRENTES DA CONTRIBUIÇÃO INSTITUÍDA PARA FAZER FACE AO CUSTO DE OBRAS PÚBLICAS DE QUE DECORRA VALORIZAÇÃO IMOBILIÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.03.01.00.00.0000','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DAS CONTRIBUIÇÕES DE MELHORIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.04.00.00.00.0000','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DOS VALORES DECORRENTES DAS DEMAIS CONTRIBUIÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.04.01.00.00.0000','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA DE CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA, CONFORME ARTIGO 149-A DA CONSTITUIÇÃO FEDERAL DE 1988.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.05.00.00.00.0000','DEMAIS DÍVIDA ATÍVA TRIBUTÁRIA','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DE OUTROS TRIBUTOS NÃO DETALHADOS ACIMA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.1.06.00.00.00.0000','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA PREVIDENCIARIA.EX: CONTRIBUIÇÃO SOCIAL PARA O RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.00.00.00.00.0000','DÍVIDA ATIVA TRIBUTÁRIA - INTRA OFSS','COMPREENDE OS VALORES DOS CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA INSCRITOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.01.00.00.00.0000','DÍVIDA ATIVA TRIBUTARIA DOS IMPOSTOS','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DA MODALIDADE DE TRIBUTO CUJA OBRIGAÇÃO TEM POR FATO GERADOR UMA SITUAÇÃO INDEPENDENTE DE QUALQUER ATIVIDADE ESTATAL ESPECÍFICA RELATIVA AO CONTRIBUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.01.01.00.00.0000','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.01.05.00.00.0000','DÍVIDA ATIVA DO IPTU','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.01.06.00.00.0000','DÍVIDA ATIVA DO ITBI','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE TRANSMISSÃO "INTER VIVOS" DE BENS IMÓVEIS E DE DIREITOS REAIS SOBRE IMÓVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.01.07.00.00.0000','DÍVIDA ATIVA DO ISS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.01.08.00.00.0000','DÍVIDA ATIVA DO ITR','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL, DEVIDOS AOS MUNICÍPIOS OU AO DISTRITO FEDERAL DEVIDO A CONVÊNIOS FIRMADOS COM A UNIÃO, CONFORME INCISO III, PARÁGRAFO 4º DO ARTIGO 153 DA CONSTITUIÇÃO FEDERAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.02.00.00.00.0000','DÍVIDA ATIVA TRIBUTARIA DAS TAXAS','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DA MODALIDADE DE TRIBUTO QUE TEM COMO FATO GERADOR O EXERCÍCIO REGULAR DO PODER DE POLÍCIA OU A UTILIZAÇÃO EFETIVA OU POTENCIAL DE SERVIÇO PÚBLICO ESPECÍFICO E DIVISÍVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSIÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.02.01.00.00.0000','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.02.02.00.00.0000','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.03.00.00.00.0000','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DOS VALORES DECORRENTES DA CONTRIBUIÇÃO INSTITUÍDA PARA FAZER FACE AO CUSTO DE OBRAS PÚBLICAS DE QUE DECORRA VALORIZAÇÃO IMOBILIÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.03.01.00.00.0000','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DAS CONTRIBUIÇÕES DE MELHORIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.04.00.00.00.0000','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DOS VALORES DECORRENTES DAS DEMAIS CONTRIBUIÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.04.01.00.00.0000','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA DE CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA, CONFORME ARTIGO 149-A DA CONSTITUIÇÃO FEDERAL DE 1988.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.05.00.00.00.0000','DEMAIS DÍVIDA ATÍVA TRIBUTÁRIA','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DE OUTROS TRIBUTOS NÃO DETALHADOS ACIMA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.2.06.00.00.00.0000','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA PREVIDENCIARIA.EX: CONTRIBUIÇÃO SOCIAL PARA O RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.00.00.00.00.0000','DÍVIDA ATIVA TRIBUTÁRIA - INTER OFSS - UNIÃO','COMPREENDE OS VALORES DOS CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA INSCRITOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.01.00.00.00.0000','DÍVIDA ATIVA TRIBUTARIA DOS IMPOSTOS','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DA MODALIDADE DE TRIBUTO CUJA OBRIGAÇÃO TEM POR FATO GERADOR UMA SITUAÇÃO INDEPENDENTE DE QUALQUER ATIVIDADE ESTATAL ESPECÍFICA RELATIVA AO CONTRIBUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.01.01.00.00.0000','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.01.05.00.00.0000','DÍVIDA ATIVA DO IPTU','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.01.06.00.00.0000','DÍVIDA ATIVA DO ITBI','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE TRANSMISSÃO "INTER VIVOS" DE BENS IMÓVEIS E DE DIREITOS REAIS SOBRE IMÓVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.01.07.00.00.0000','DÍVIDA ATIVA DO ISS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.01.08.00.00.0000','DÍVIDA ATIVA DO ITR','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL, DEVIDOS AOS MUNICÍPIOS OU AO DISTRITO FEDERAL DEVIDO A CONVÊNIOS FIRMADOS COM A UNIÃO, CONFORME INCISO III, PARÁGRAFO 4º DO ARTIGO 153 DA CONSTITUIÇÃO FEDERAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.02.00.00.00.0000','DÍVIDA ATIVA TRIBUTARIA DAS TAXAS','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DA MODALIDADE DE TRIBUTO QUE TEM COMO FATO GERADOR O EXERCÍCIO REGULAR DO PODER DE POLÍCIA OU A UTILIZAÇÃO EFETIVA OU POTENCIAL DE SERVIÇO PÚBLICO ESPECÍFICO E DIVISÍVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSIÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.02.01.00.00.0000','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.02.02.00.00.0000','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.03.00.00.00.0000','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DOS VALORES DECORRENTES DA CONTRIBUIÇÃO INSTITUÍDA PARA FAZER FACE AO CUSTO DE OBRAS PÚBLICAS DE QUE DECORRA VALORIZAÇÃO IMOBILIÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.03.01.00.00.0000','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DAS CONTRIBUIÇÕES DE MELHORIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.04.00.00.00.0000','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DOS VALORES DECORRENTES DAS DEMAIS CONTRIBUIÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.04.01.00.00.0000','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA DE CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA, CONFORME ARTIGO 149-A DA CONSTITUIÇÃO FEDERAL DE 1988.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.05.00.00.00.0000','DEMAIS DÍVIDA ATÍVA TRIBUTÁRIA','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DE OUTROS TRIBUTOS NÃO DETALHADOS ACIMA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.3.06.00.00.00.0000','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA PREVIDENCIARIA.EX: CONTRIBUIÇÃO SOCIAL PARA O RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.00.00.00.00.0000','DÍVIDA ATIVA TRIBUTÁRIA - INTER OFSS - ESTADO','COMPREENDE OS VALORES DOS CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA INSCRITOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.01.00.00.00.0000','DÍVIDA ATIVA TRIBUTARIA DOS IMPOSTOS','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DA MODALIDADE DE TRIBUTO CUJA OBRIGAÇÃO TEM POR FATO GERADOR UMA SITUAÇÃO INDEPENDENTE DE QUALQUER ATIVIDADE ESTATAL ESPECÍFICA RELATIVA AO CONTRIBUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.01.01.00.00.0000','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.01.05.00.00.0000','DÍVIDA ATIVA DO IPTU','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.01.06.00.00.0000','DÍVIDA ATIVA DO ITBI','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE TRANSMISSÃO "INTER VIVOS" DE BENS IMÓVEIS E DE DIREITOS REAIS SOBRE IMÓVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.01.07.00.00.0000','DÍVIDA ATIVA DO ISS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.01.08.00.00.0000','DÍVIDA ATIVA DO ITR','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL, DEVIDOS AOS MUNICÍPIOS OU AO DISTRITO FEDERAL DEVIDO A CONVÊNIOS FIRMADOS COM A UNIÃO, CONFORME INCISO III, PARÁGRAFO 4º DO ARTIGO 153 DA CONSTITUIÇÃO FEDERAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.02.00.00.00.0000','DÍVIDA ATIVA TRIBUTARIA DAS TAXAS','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DA MODALIDADE DE TRIBUTO QUE TEM COMO FATO GERADOR O EXERCÍCIO REGULAR DO PODER DE POLÍCIA OU A UTILIZAÇÃO EFETIVA OU POTENCIAL DE SERVIÇO PÚBLICO ESPECÍFICO E DIVISÍVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSIÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.02.01.00.00.0000','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.02.02.00.00.0000','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.03.00.00.00.0000','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DOS VALORES DECORRENTES DA CONTRIBUIÇÃO INSTITUÍDA PARA FAZER FACE AO CUSTO DE OBRAS PÚBLICAS DE QUE DECORRA VALORIZAÇÃO IMOBILIÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.03.01.00.00.0000','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DAS CONTRIBUIÇÕES DE MELHORIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.04.00.00.00.0000','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DOS VALORES DECORRENTES DAS DEMAIS CONTRIBUIÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.04.01.00.00.0000','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA DE CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA, CONFORME ARTIGO 149-A DA CONSTITUIÇÃO FEDERAL DE 1988.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.05.00.00.00.0000','DEMAIS DÍVIDA ATÍVA TRIBUTÁRIA','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DE OUTROS TRIBUTOS NÃO DETALHADOS ACIMA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.4.06.00.00.00.0000','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA PREVIDENCIARIA.EX: CONTRIBUIÇÃO SOCIAL PARA O RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.00.00.00.00.0000','DÍVIDA ATIVA TRIBUTÁRIA - INTER OFSS - MUNICÍPIO','COMPREENDE OS VALORES DOS CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA INSCRITOS, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.01.00.00.00.0000','DÍVIDA ATIVA TRIBUTARIA DOS IMPOSTOS','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DA MODALIDADE DE TRIBUTO CUJA OBRIGAÇÃO TEM POR FATO GERADOR UMA SITUAÇÃO INDEPENDENTE DE QUALQUER ATIVIDADE ESTATAL ESPECÍFICA RELATIVA AO CONTRIBUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.01.01.00.00.0000','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.01.05.00.00.0000','DÍVIDA ATIVA DO IPTU','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.01.06.00.00.0000','DÍVIDA ATIVA DO ITBI','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE TRANSMISSÃO "INTER VIVOS" DE BENS IMÓVEIS E DE DIREITOS REAIS SOBRE IMÓVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.01.07.00.00.0000','DÍVIDA ATIVA DO ISS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DO IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.01.08.00.00.0000','DÍVIDA ATIVA DO ITR','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL, DEVIDOS AOS MUNICÍPIOS OU AO DISTRITO FEDERAL DEVIDO A CONVÊNIOS FIRMADOS COM A UNIÃO, CONFORME INCISO III, PARÁGRAFO 4º DO ARTIGO 153 DA CONSTITUIÇÃO FEDERAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.02.00.00.00.0000','DÍVIDA ATIVA TRIBUTARIA DAS TAXAS','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DA MODALIDADE DE TRIBUTO QUE TEM COMO FATO GERADOR O EXERCÍCIO REGULAR DO PODER DE POLÍCIA OU A UTILIZAÇÃO EFETIVA OU POTENCIAL DE SERVIÇO PÚBLICO ESPECÍFICO E DIVISÍVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSIÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.02.01.00.00.0000','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.02.02.00.00.0000','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.03.00.00.00.0000','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DOS VALORES DECORRENTES DA CONTRIBUIÇÃO INSTITUÍDA PARA FAZER FACE AO CUSTO DE OBRAS PÚBLICAS DE QUE DECORRA VALORIZAÇÃO IMOBILIÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.03.01.00.00.0000','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DAS CONTRIBUIÇÕES DE MELHORIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.04.00.00.00.0000','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DA COBRANÇA DOS VALORES DECORRENTES DAS DEMAIS CONTRIBUIÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.04.01.00.00.0000','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA DE CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA, CONFORME ARTIGO 149-A DA CONSTITUIÇÃO FEDERAL DE 1988.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.05.00.00.00.0000','DEMAIS DÍVIDA ATÍVA TRIBUTÁRIA','COMPREENDE OS VALORES RELATIVOS AOS CRÉDITOS A RECEBER, INSCRITOS EM DÍVIDA ATIVA, DECORRENTES DE OUTROS TRIBUTOS NÃO DETALHADOS ACIMA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.5.5.06.00.00.00.0000','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA PREVIDENCIARIA.EX: CONTRIBUIÇÃO SOCIAL PARA O RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.6.0.00.00.00.00.0000','DÍVIDA ATIVA NÃO TRIBUTÁRIA','COMPREENDE OS VALORES DOS CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA INSCRITOS, DERIVADOS DE CLIENTES, REALIZÁVEIS ATÉ O TÉRMINO DO EXERCÍCIO SEGUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.6.1.00.00.00.00.0000','DÍVIDA ATIVA NÃO TRIBUTÁRIA - CONSOLIDAÇÃO','REGISTRA OS VALORES DOS CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA INSCRITOS, DERIVADOS DE CLIENTES, REALIZÁVEIS NO CURSO DO EXERCÍCIO SOCIAL SUBSEQUENTE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.0.00.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO','COMPREENDE O AJUSTE PARA PERDAS ESTIMADAS COM O NÃO RECEBIMENTO DE VALORES REFERENTES A CRÉDITOS A CURTO PRAZO, POR INADIMPLÊNCIA DE TERCEIROS E OUTRAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.1.00.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO- CONSOLIDAÇÃO','COMPREENDE O AJUSTE PARA PERDAS ESTIMADAS COM O NÃO RECEBIMENTO DE VALORES REFERENTES A CRÉDITOS A CURTO PRAZO, POR INADIMPLÊNCIA DE TERCEIROS E OUTRAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.1.01.00.00.00.0000','(-) AJUSTE DE PERDAS DE CREDITOS DE LIQUIDAÇÃO DUVIDOSA','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.1.02.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.1.03.00.00.00.0000','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.1.04.00.00.00.0000','(-) AJUSTE PARA PERDA DE DÍVIDA ATIVA NÃO TRIBUTÁRIA - CLIENTES','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDA DE DÍVIDA ATIVA NÃO TRIBUTÁRIA, DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.1.05.00.00.00.0000','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.1.06.00.00.00.0000','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA AS PERDAS ESTIMADAS DE CREDITOS RELATIVOS A EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.2.00.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTRA OFSS','COMPREENDE O AJUSTE PARA PERDAS ESTIMADAS COM O NÃO RECEBIMENTO DE VALORES REFERENTES A CRÉDITOS A CURTO PRAZO, POR INADIMPLÊNCIA DE TERCEIROS E OUTRAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.2.01.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS DE LIQUIDAÇÃO DUVIDOSA','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.2.02.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.2.03.00.00.00.0000','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.2.06.00.00.00.0000','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA AS PERDAS ESTIMADAS DE CREDITOS RELATIVOS A EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.3.00.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','COMPREENDE O AJUSTE PARA PERDAS ESTIMADAS COM O NÃO RECEBIMENTO DE VALORES REFERENTES A CRÉDITOS A CURTO PRAZO, POR INADIMPLÊNCIA DE TERCEIROS E OUTRAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.3.01.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.3.02.00.00.00.0000','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.3.03.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDA DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.3.05.00.00.00.0000','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER PROVENIENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.3.06.00.00.00.0000','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA AS PERDAS ESTIMADAS DE CREDITOS RELATIVOS A EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.4.00.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','COMPREENDE O AJUSTE PARA PERDAS ESTIMADAS COM O NÃO RECEBIMENTO DE VALORES REFERENTES A CRÉDITOS A CURTO PRAZO, POR INADIMPLÊNCIA DE TERCEIROS E OUTRAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.4.01.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.4.02.00.00.00.0000','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.4.03.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDA DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.4.05.00.00.00.0000','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER PROVENIENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.4.06.00.00.00.0000','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA AS PERDAS ESTIMADAS DE CREDITOS RELATIVOS A EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.5.00.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','COMPREENDE O AJUSTE PARA PERDAS ESTIMADAS COM O NÃO RECEBIMENTO DE VALORES REFERENTES A CRÉDITOS A CURTO PRAZO, POR INADIMPLÊNCIA DE TERCEIROS E OUTRAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.5.01.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.5.02.00.00.00.0000','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.5.03.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDA DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.5.05.00.00.00.0000','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER PROVENIENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.2.9.5.06.00.00.00.0000','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA AS PERDAS ESTIMADAS DE CREDITOS RELATIVOS A EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.0.0.00.00.00.00.0000','DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','COMPREENDE OS VALORES A RECEBER POR DEMAIS TRANSAÇÕES REALIZÁVEIS NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.1.0.00.00.00.00.0000','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','COMPREENDE AS ANTECIPAÇÕES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPAÇÕES DE SALÁRIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALÁRIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALÉM DA ENTREGA DE NUMERÁRIO A TERCEIROS SEM VINCULAÇÃO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVIÇOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.1.1.00.00.00.00.0000','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS - CONSOLIDAÇÃO','COMPREENDE AS ANTECIPAÇÕES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPAÇÕES DE SALÁRIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALÁRIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALÉM DA ENTREGA DE NUMERÁRIO A TERCEIROS SEM VINCULAÇÃO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVIÇOS.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.1.1.01.00.00.00.0000','ADIANTAMENTOS CONCEDIDOS A PESSOAL','COMPREENDE OS VALORES DAS ANTECIPAÇÕES CONCEDIDAS A SERVIDORES E A DIRIGENTES DA UNIDADE, TAIS COMO ANTECIPAÇÕES DE SALÁRIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALÁRIO, ADIANTAMENTOS DE FERIAS E DE GRATIFICAÇÕES NATALINAS, ENTRE OUTRAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.1.1.01.01.00.00.0000','13º SALÁRIO - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE AO 13º SALÁRIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.1.1.01.02.00.00.0000','1/3 DE FERIAS - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A 1/3 DE FERIAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.1.1.01.03.00.00.0000','VIAGENS - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A VIAGENS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.1.1.01.04.00.00.0000','ASSISTÊNCIA MEDICA - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A ASSISTÊNCIA MEDICA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.1.1.01.05.00.00.0000','SALÁRIOS E ORDENADOS - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A SALÁRIOS E ORDENADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.1.1.01.99.00.00.0000','OUTROS ADIANTAMENTOS CONCEDIDOS A PESSOAL','REGISTRA OUTROS ADIANTAMENTOS CONCEDIDOS A PESSOAL NÃO REGISTRADOS NAS CONTAS ACIMA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.1.1.02.00.00.00.0000','SUPRIMENTO DE FUNDOS','REGISTRA O ADIANTAMENTO A SERVIDOR PARA DESPESAS SUJEITAS A PRESTAÇÃO DE CONTAS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.1.1.05.00.00.00.0000','ADIANTAMENTOS A PRESTADORES DE SERVIÇOS','REGISTRA OS VALORES DE ANTECIPAÇÕES CONCEDIDAS A PRESTADORES DE SERVIÇOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVIÇOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.1.1.99.00.00.00.0000','ADIANTAMENTOS DIVERSOS CONCEDIDOS','REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NÃO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.0.00.00.00.00.0000','TRIBUTOS A RECUPERAR / COMPENSAR','COMPREENDE O SOMATÓRIO DOS VALORES DOS TRIBUTOS A RECUPERAR / COMPENSAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.00.00.00.00.0000','TRIBUTOS A RECUPERAR / COMPENSAR - CONSOLIDAÇÃO','COMPREENDE O SOMATÓRIO DOS VALORES DOS TRIBUTOS A RECUPERAR / COMPENSAR. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.01.00.00.00.0000','IPI A RECUPERAR/COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO IPI A RECUPERAR/COMPENSAR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.02.00.00.00.0000','ICMS A RECUPERAR/COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DE ICMS A RECUPERAR/COMPENSAR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.03.00.00.00.0000','ICMS DIFERIDO','REGISTRA OS VALORES DO ICMS DIFERIDO DOS ESTOQUES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.04.00.00.00.0000','IRRF A COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO IR RETIDO NA FONTE A COMPENSAR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.05.00.00.00.0000','IR E CSLL A RECUPERAR/COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO IR E DA CSLL A RECUPERAR/COMPENSAR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.06.00.00.00.0000','IR E CSLL DIFERIDOS','REGISTRA A PARCELA DO IR E CSLL QUE REPRESENTA A DIFERENÇA ENTRE OS VALORES DE LUCRO APURADOS SEGUINDO AS NORMAS FISCAIS E SEGUINDO O REGIME DE COMPETÊNCIA, QUANDO ESTES FOREM MENORES E AS DIFERENÇAS TEMPORÁRIAS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.07.00.00.00.0000','ISS A COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO ISS A COMPENSAR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.08.00.00.00.0000','IPVA A COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO IPVA A COMPENSAR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.09.00.00.00.0000','IPTU A COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO IPTU A COMPENSAR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.10.00.00.00.0000','ITR A COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO ITR A COMPENSAR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.11.00.00.00.0000','INSS A COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO INSS A COMPENSAR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.12.00.00.00.0000','COFINS A RECUPERAR/COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DA COFINS A RECUPERAR/COMPENSAR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.13.00.00.00.0000','PIS/PASEP A RECUPERAR/COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO PIS/PASEP A RECUPERAR/COMPENSAR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.14.00.00.00.0000','CIP A RECUPERAR/COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DA CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA A RECUPERAR/COMPENSAR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.2.1.99.00.00.00.0000','OUTROS TRIBUTOS A RECUPERAR/COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR/COMPENSAR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.3.0.00.00.00.00.0000','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','COMPREENDE OS CRÉDITOS A RECEBER DECORRENTES DA DESCENTRALIZAÇÃO DE SERVIÇOS PÚBLICOS, TANTO POR MEIO DE OUTORGA A ENTIDADES DA ADMINISTRAÇÃO INDIRETA COMO POR MEIO DE DELEGAÇÃO, NAS FORMAS DE CONCESSAO, INCLUSIVE PARCERIAS PÚBLICO-PRIVADAS - PPP, PERMISSÃO OU AUTORIZAÇÃO AO PARTICULAR DO DIREITO DE EXPLORAÇÃO DE SERVIÇOS PÚBLICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.3.1.00.00.00.00.0000','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS - CONSOLIDAÇÃO','COMPREENDE OS CRÉDITOS A RECEBER DECORRENTES DA DESCENTRALIZAÇÃO DE SERVIÇOS PÚBLICOS, TANTO POR MEIO DE OUTORGA A ENTIDADES DA ADMINISTRAÇÃO INDIRETA, COMO POR MEIO DE DELEGAÇÃO, NAS FORMAS DE CONCESSAO, INCLUSIVE PARCERIAS PÚBLICO-PRIVADAS -PPP, PERMISSÃO OU AUTORIZAÇÃO AO PARTICULAR DO DIREITO DE EXPLORAÇÃO DE SERVIÇOS PÚBLICOS.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.4.0.00.00.00.00.0000','CRÉDITOS POR DANOS AO PATRIMÔNIO','COMPREENDE OS VALORES REALIZÁVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM SINDICÂNCIA, PRESTAÇÃO DE CONTAS, TOMADA DE CONTAS, PROCESSOS JUDICIAIS E OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.4.1.00.00.00.00.0000','CRÉDITOS POR DANOS AO PATRIMONIO- CONSOLIDAÇÃO','COMPREENDE OS VALORES REALIZÁVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM SINDICÂNCIA, PRESTAÇÃO DE CONTAS, TOMADA DE CONTAS, PROCESSOS JUDICIAIS E OUTROS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.4.1.01.00.00.00.0000','CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS','COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.4.1.01.01.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','REGISTRA O CRÉDITO DO ENTE CORRESPONDENTE A DEBITOS DECORRENTES DE FOLHA DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.4.1.01.02.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','REGISTRA O CRÉDITO DO ENTE CORRESPONDENTE A DEBITO DECORRENTES DE DANOS AO PATRIMONIO PÚBLICO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.4.1.01.03.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','REGISTRA O CRÉDITO DO ENTE CORRESPONDENTE A DEBITO DECORRENTES DE ERRO DA ADMINISTRAÇÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.4.1.01.04.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE DOLO, MÁ-FÉ OU FRAUDE','REGISTRA O CRÉDITO DO ENTE CORRESPONDENTE A DEBITOS DECORRENTES DE DOLO, MÁ-FÉ OU FRAUDE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.4.1.01.05.00.00.0000','CRÉDITOS A RECEBER DE SERVIDORES NÃO RECOLHIDOS NO PRAZO LEGAL','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES, NÃO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU DETERMINAÇÃO ADMINISTRATIVA OU SEJA, QUANDO O PRODUTO A ARRECADAR NÃO TENHA SIDO RECOLHIDO NO PRAZO LEGAL. (EX: SALDO DE SUPRIMENTO DE FUNDOS)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.4.1.01.06.00.00.0000','CRÉDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTAÇÃO DE SERVIÇOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTAÇÃO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.4.1.01.07.00.00.0000','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGÃO, POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTAÇÃO DA RESPONSABILIDADE. (EX: MULTA DE TRANSITO)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.4.1.01.10.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS','REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGÃOS POR PAGAMENTOS INDEVIDOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS, PÓS MORTE DO SEGURADO (CR[EDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURAÇÃO DE TOMADA DE CONTAS ESPECIAL).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.4.1.01.11.00.00.0000','CRÉDITOS POR DANOS AO PATRIMONIO APURADOS EM PROCESSOS JUDICIAIS','REGISTRA OS VALORES REALIZÁVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMÔNIO, APURADOS EM PROCESSOS JUDICIAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.4.1.01.99.00.00.0000','OUTROS CRÉDITOS ADMINISTRATIVOS','REGISTRA O CRÉDITO DO ENTE CORRESONDENTE A OUTROS CRÉDITOS ADMINISTRATIVOS QUE NÃO SE ENQUANDRAM EM RUBRICAS ESPECÍFICAS EXISTENTES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.5.0.00.00.00.00.0000','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','COMPREENDE OS VALORES DE DEPÓSITOS E CAUÇÕES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORAÇÃO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPÓSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZÁVEIS NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.5.1.00.00.00.00.0000','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS - CONSOLIDAÇÃO','COMPREENDE OS VALORES DE DEPÓSITOS E CAUÇÕES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORAÇÃO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPÓSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZÁVEIS ATE O TÉRMINO DO EXERCÍCIO SEGUINTE. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NÃO PERTENÇA AO OFSS DE ENTE PÚBLICO, ALÉM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.5.1.01.00.00.00.0000','DEPÓSITOS E CAUÇÕES RELATIVOS A CONTRATOS OU CONVENCOES','REGISTRA OS VALORES RELATIVOS A DEPÓSITOS E CAUÇÕES, EFETUADOS POR VINCULAÇÕES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERAÇÕES ESPECIFICAS, REALIZÁVEIS NO CURTO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.5.1.02.00.00.00.0000','DEPOSITOS E CAUCOES RECEBIDOS RELATIVOS A CONTRATOS OU CONVENCOES','REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES RECEBIDOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.5.1.03.00.00.00.0000','DEPÓSITOS JUDICIAIS','REGISTRA OS VALORES A RECEBER DECORRENTES DE DEPÓSITOS EFETUADOS POR DETERMINAÇÃO JUDICIAL, REALIZÁVEIS NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.5.1.03.01.00.00.0000','DEPÓSITOS DE SENTENCAS JUDICIAIS - PODER EXECUTIVO/INDIRETAS','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE SENTENÇAS JUDICIAIS DO PODER EXECUTIVO/INDIRETAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.5.1.03.02.00.00.0000','DEPÓSITOS DE SENTENCAS JUDICIAIS - PODER LEGISLATIVO','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE SENTENÇAS JUDICIAIS DO PODER LEGISLATIVO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.5.1.03.03.00.00.0000','DEPÓSITOS DE SENTENCAS JUDICIAIS - RPPS','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE SENTENÇAS JUDICIAIS DO RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.5.1.03.04.00.00.0000','DEPÓSITOS JUDICIAIS DE RESTOS A PAGAR - PODER EXECUTIVO/INDIRETAS','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE DEMANDAS JUDICIAS , DECORRENTES DE VALORES INSCRITOS EM RESTOS A PAGAR NO PODER EXECUTIVO/INDIRETAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.5.1.03.05.00.00.0000','DEPÓSITOS JUDICIAIS DE RESTOS A PAGAR - PODER LEGISLATIVO','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE DEMANDAS JUDICIAS , DECORRENTES DE VALORES INSCRITOS EM RESTOS A PAGAR NO PODER LEGISLATIVO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.5.1.03.06.00.00.0000','DEPÓSITOS JUDICIAIS DE RESTOS A PAGAR - RPPS','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE DEMANDAS JUDICIAS , DECORRENTES DE VALORES INSCRITOS EM RESTOS A PAGAR NO RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.5.1.05.00.00.00.0000','DEPÓSITOS PARA INTERPOSICAO DE RECURSOS','REGISTRA OS VALORES RELATIVOS AOS DEPÓSITOS VINCULADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.5.1.07.00.00.00.0000','DEPÓSITOS ESPECIAIS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPÓSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGAÇÕES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.5.1.99.00.00.00.0000','OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS, REALIZÁVEIS ATE TÉRMINOEXERCÍCIO SEGUINTE NÃO ESPECIFICADOS NAS CONTAS ACIMA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.0.00.00.00.00.0000','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO','COMPREENDE OS OUTROS CRÉDITOS E VALORES REALIZÁVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.00.00.00.00.0000','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS OUTROS CRÉDITOS E VALORES REALIZÁVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.01.00.00.00.0000','ALUGUEIS A RECEBER','REGISTRA OS VALORES A RECEBER DECORRENTES DE CONTRATOS DE ALUGUEL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.02.00.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE PERMISSÃO DE USO DE BENS PÚBLICOS','REGISTRA OS VALORES A RECEBER DECORRENTES DE PERMISSÃO DE USO DE BENS PÚBLICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.03.00.00.00.0000','VALORES A RECUPERAR DECORRENTES DEINDENIZAÇÕES POR SINISTROS PAGOS','REGISTRA OS VALORES A RECUPERAR REFERENTES AINDENIZAÇÕES PELO PAGAMENTO DE SINISTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.04.00.00.00.0000','VALES, TICKETS E BILHETES','REGISTRA O VALOR DOS VALES E TICKETS ADQUIRIDOS PARA FUTURA DISTRIBUICAO AOS SERVIDORES, E AINDA BILHETES DE TRANSPORTES URBANOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.06.00.00.00.0000','VALORES EM TRANSITO REALIZÁVEIS A CURTO PRAZO','COMPREENDE O SOMATÓRIO DOS VALORES CONTABILIZADOS INDEVIDAMENTE EM CONTA BANCARIA, GUIA DE RECEBIMENTO E ORDENS BANCÁRIAS EMITIDAS A COMPENSAR.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.07.00.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE INFRAÇÕES LEGAIS E CONTRATUAIS','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICAÇÃO DE AUTOS DE INFRAÇÃO, DA APLICAÇÃO DE MULTAS POR DESCUMPRIMENTO DE OBRIGAÇÕES ACESSORIAS (VINCULADAS A CRÉDITOS TRIBUTÁRIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS. OS CRÉDITOS DECORRENTES DA QUEBRA DE CLAUSULAS CONTRATUAIS PODEM SER PAGOS EM ESPECIE, GLOSA OU ATRAVES DE FORNECIMENTOS.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.08.00.00.00.0000','CRÉDITOS A RECEBER POR REEMBOLSO DE SALÁRIO FAMILIA PAGO','REGISTRA OS VALORES RELATIVOS AO SALÁRIO-FAMILIA, INCLUIDOS EM FOLHAS DE PAGAMENTO, PAGOS AOS EMPREGADOS (CLT), COM FILHOS MENORES, A COMPENSAR COM AS CONTRIBUIÇÕES DEVIDAS PELO EMPREGADOR A PREVIDENCIA SOCIAL.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.09.00.00.00.0000','CRÉDITOS A RECEBER POR REEMBOLSO DE SALÁRIO MATERNIDADE PAGO','REGISTRA OS SALÁRIOS PAGOS AS SERVIDORAS GESTANTES, REGIDAS PELA CLT NO PERIODO QUE PERDURAR A LICENCA MATERNIDADE, PREVISTA EM LEI, A DEDUZIR DAS OBRIGAÇÕES SOCIAIS DEVIDAS PELOS ORGÃOS E ENTIDADES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.10.00.00.00.0000','AUXÍLIO NATALIDADE PAGO A RECUPERAR','REGISTRA OS VALORES RELATIVOS A AUXÍLIO NATALIDADE, PAGOS AOS EMPREGADOS REGIDOS PELA CLT, QUANDO DO NASCIMENTO DE FILHOS DESTES, A RECUPERAR, POR SE TRATAR DE OBRIGAÇÕES DA PREVIDENCIA SOCIAL.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.11.00.00.00.0000','CRÉDITOS A RECEBER POR REEMBOLSO DE AUXÍLIO DOENÇA E ACIDENTES PAGOS','REGISTRA OS SALÁRIOS PAGOS AOS SERVIDORES, REGIDOS PELA CLT, A TITULO DE AUXÍLIO DOENÇA/ACIDENTES, PREVISTO EM LEI, A SEREM REEMBOLSADOS PELO INSS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.12.00.00.00.0000','CRÉDITOS A RECEBER POR CESSAO DE PESSOAL','REGISTRA OS VALORES DE CRÉDITOS A RECEBER TAIS COMO: FOLHA DE PAGAMENTO, DESPESA DE TRANSPORTE, ALIMENTAÇÃO E OUTRAS RELATIVAS A CESSAO DE PESSOAL.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.13.00.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE CESSAO DE AREAS PÚBLICAS','REGISTRA OS VALORES A RECEBER DECORRENTES DA CESSAO DE AREAS PÚBLICAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.14.00.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE ALIENAÇÃO DE BENS MÓVEIS E IMÓVEIS','REGISTRA OS VALORES DOS CRÉDITOS A RECEBER DECORRENTES DA ALIENAÇÃO DE BENS MÓVEIS OU IMÓVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.15.00.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE PAGAMENTO DE DESPESAS DE TERCEIROS','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE PAGAMENTOS DE DESPESAS DE TERCEIROS DECORRENTES DE CLAUSULAS CONTRATUAIS, TAIS COMO: AGUA, LUZ, TELEFONE, INSTALAÇÕES, TRANSPORTE E ALUGUEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.17.00.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','REGISTRA OS VALORES DOS CRÉDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.27.00.00.00.0000','TITULOS A RECEBER','COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.28.00.00.00.0000','CRÉDITOS A RECEBER DE ENTIDADES FEDERAIS','REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ENTIDADES FEDERAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.29.00.00.00.0000','CRÉDITOS A RECEBER DE ENTIDADES ESTADUAIS, DISTRITAIS E MUNICIPAIS','REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ESTADOS, DF E MUNICÍPIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.35.00.00.00.0000','ABONO PERMANENCIA E APOSENTADORIAS','REGISTRA OS VALORES RELATIVOS AOS ADIANTAMENTOS EFETUADOS A EMPREGADOS POR CONTA DE CRÉDITOS A RECEBER DO INSS, NA FORMA DE ABONO PERMANENCIA E APOSENTADORIAS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.8.1.99.00.00.00.0000','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO','REGISTRA OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO, PARA OS QUAIS NÃO TENHAM CONTAS ESPECIFICAS NESTE SUBGRUPO DE CONTAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.9.0.00.00.00.00.0000','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NÃO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CRÉDITOS E VALORES A CURTO PRAZO, POR INADIMPLÊNCIA DE TERCEIROS E OUTRAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.9.1.00.00.00.00.0000','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NÃO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CRÉDITOS E VALORES A CURTO PRAZO, POR INADIMPLÊNCIA DE TERCEIROS E OUTRAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.9.1.02.00.00.00.0000','(-) AJUSTE DE PERDAS EM CRÉDITOS POR DANOS AO PATRIMONIO','COMPREENDE OS VALORES DOS AJUSTES PARA PERDA DE CRÉDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS OU APURADOS EM TOMADA DE CONTAS ESPECIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.9.1.03.00.00.00.0000','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA - DEMAIS CRÉDITOS','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DO AJUSTE PARA PERDA DE DÍVIDA ATIVA NÃO TRIBUTÁRIA, EXCETO AS DERIVADAS DE CLIENTES DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.3.9.1.99.00.00.00.0000','(-) OUTROS AJUSTES DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','REGISTRA OS VALORES DOS AJUSTES PARA PERDA DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO, NÃO CLASSIFICADAS ANTERIORMENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.0.0.00.00.00.00.0000','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A CURTO PRAZO','COMPREENDEM AS APLICAÇÕES DE RECURSOS EM TÍTULOS E VALORES MOBILIÁRIOS, NÃO DESTINADAS À NEGOCIAÇÃO E QUE NÃO FAÇAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATÁVEIS NO CURTO PRAZO, ALÉM DAS APLICAÇÕES TEMPORÁRIAS EM METAIS PRECIOSOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.0.00.00.00.00.0000','TÍTULOS E VALORES MOBILIÁRIOS','COMPREENDEM AS APLICAÇÕES DE RECURSOS EM TITULOS E VALORES MOBILIARIOS, NÃO DESTINADAS A NEGOCIAÇÃO E QUE NÃO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.00.00.00.00.0000','TÍTULOS E VALORES MOBILIARIOS- CONSOLIDAÇÃO','COMPREENDEM AS APLICAÇÕES DE RECURSOS EM TITULOS E VALORES MOBILIARIOS, NÃO DESTINADAS A NEGOCIAÇÃO E QUE NÃO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS NO CURTO PRAZO.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.03.00.00.00.0000','TITULOS PÚBLICOS - MERCADO ABERTO','COMPREENDE O VALOR RELATIVO A TITULOS PÚBLICOS, EMITIDOS E EM CIRCULAÇÃO NO MERCADO ABERTO PARA FINS DE NEGOCIAÇÃO NO MERCADO DE AÇÕES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.04.00.00.00.0000','AÇÕES','COMPREENDE OS VALORES DAS AÇÕES REPRESENTATIVAS DAS PARTICIPAÇÕES DOS ORGÃOS E ENTIDADES NO CAPITAL DAS SOCIEDADES POR AÇÕES HAVIDAS POR AQUISICOES, SUBSCRICOES, BONIFICAÇÕES E DOAÇÕES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.09.00.00.00.0000','APLICAÇÕES EM SEGMENTO DE RENDA FIXA','COMPREENDE O SOMATÓRIO DOS INVESTIMENTOS REALIZADOS PELO RPPS COM RECURSOS PREVIDÊNCIÁRIOS, EFETUADOS EM CONFORMIDADE COM O ART. 6º, DA RESOLUCAO CMN N° 3.790/2009.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.09.01.00.00.0000','TITULOS DE RESPONSABILIDADE DO TESOURO','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM TITULOS DE EMISSAO DO TESOURO NACIONAL, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO I, ALINEA A(INCLUI OPERAÇÕES COMPROMISSADAS) DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.09.02.00.00.0000','TITULOS DE RESPONSABILIDADE DO BANCO CENTRAL','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM TITULOS DE EMISSAO DO BANCO CENTRAL DO BRASIL; SALDOS REMANESCENTES PARA RESGATES, CONSIDERANDO QUE O BC NÃO EMITE MAIS TITULOS DA DÍVIDA PÚBLICA- ART 34 LC 101/2000.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.09.03.00.00.0000','POUPANÇA','APRESENTAR OS INVESTIMENTOS REALIZADOS PELOS RPPS, EM POUPANÇA, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO III, DA RESOLUCAO CMN N° 3.506/2007.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.09.04.00.00.0000','FUNDOS DE INVESTIMENTOS EM RENDA FIXA','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS EM RENDA FIXA, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO IV, ALINEA B DA RESOLUCAO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.09.05.00.00.0000','FUNDOS DE INVESTIMENTOS EM RENDA FIXA - CRÉDITO PRIVADO','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS EM RENDA FIXA - CRÉDITO PRIVADO, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO V, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.09.06.00.00.0000','FUNDOS DE INVESTIMENTOS REFERENCIADOS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS REFERENCIADOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO III, DA RESOLUCAO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.09.07.00.00.0000','FUNDOS DE INVESTIMENTOS EM DIREITOS CRÉDITORIOS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS EM DIREITO CRÉDITORIO, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO VI E ALÍNEA "A" DO INCISO VII, DA RESOLUCAO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.09.08.00.00.0000','FUNDOS DE INVESTIMENTOS EM TITULOS DO TESOURO','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS EM TITULOS DO TESOURO, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO I,ALíNEA B, DA RESOLUCAO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.09.09.00.00.0000','OPERAÇÕES COMPROMISSADAS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM OPERAÇÕES COMPROMISSADAS, EFETUADOS EM CONFORMIDADE COM O ART.6º , INCISO II, DA RESOLUCAO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.10.00.00.00.0000','APLICAÇÕES EM SEGMENTO DE RENDA VARIÁVEL','COMPREENDE O SOMATÓRIO DOS INVESTIMENTOS REALIZADOS PELO RPPS COM RECURSOS PREVIDÊNCIÁRIOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, DA RESOLUCAO CMN N° 3.922/2010.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.10.01.00.00.0000','FUNDO DE AÇÕES REFERÊNCIADOS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE AÇÕES REFERÊNCIADOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO III, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.10.02.00.00.0000','FUNDOS DE AÇÕES','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE AÇÕES, EFETUADOS EM CONFORMIDADE COM O ART. 8º, INCISO III, DA RESOLUCAO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.10.03.00.00.0000','FUNDO MULTIMERCADO','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE MULTIMERCADO, EFETUADOS EM CONFORMIDADE COM O ART. 8º, INCISO IV, DA RESOLUCAO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.10.04.00.00.0000','FUNDOS DE INDICES REFERENCIADOS EM AÇÕES','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INDICES REFERENCIADOS EM AÇÕES, EFETUADOS EM CONFORMIDADE COM O ART. 8º, INCISO II, DA RESOLUCAO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.10.05.00.00.0000','FUNDOS DE INVESTIMENTOS EM PARTICIPAÇÕES','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS EM PARTICIPAÇÕES, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO V, DA RESOLUCAO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.11.00.00.00.0000','FUNDOS DE INVESTIMENTOS IMOBILIARIOS - RPPS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE INVESTIMENTOS IMOBILIARIOS, EFETUADOS EM CONFORMIDADE COM O ART. 8º, INCISO VI, DA RESOLUCAO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.12.00.00.00.0000','TITULOS E VALORES EM ENQUADRAMENTO - RPPS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM DESACORDO COM AS REGRAS ESTABELECIDAS PELA RESOLUCAO CMN Nº 3.790/2009, ARTIGO 25.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.13.00.00.00.0000','TITULOS E VALORES NÃO SUJEITOS AO ENQUADRAMENTO - RPPS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM ATIVOS NÃO SUJEITOS AS REGRAS DA RESOLUCAO CMN Nº 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.1.1.14.00.00.00.0000','APLICAÇÕES COM A TAXA DE ADMINISTRAÇÃO DO RPPS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, COM RECURSOS DA TAXA DE ADMINISTRAÇÃO, SUJEITOS AS REGRAS DA RESOLUCAO CMN Nº 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.2.0.00.00.00.00.0000','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS','COMPREENDE AS APLICAÇÕES DE RECURSOS EM METAIS PRECIOSOS, NÃO DESTINADOS A NEGOCIAÇÃO E QUE NÃO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS ATE O TÉRMINO DO EXERCÍCIO SEGUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.2.1.00.00.00.00.0000','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS- CONSOLIDAÇÃO','COMPREENDE AS APLICAÇÕES DE RECURSOS EM METAIS PRECIOSOS, NÃO DESTINADOS A NEGOCIAÇÃO E QUE NÃO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.9.0.00.00.00.00.0000','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS','COMPREENDE A DIFERENÇA ENTRE O VALOR RECUPERÁVEL DO ATIVO E SEU VALOR CONTÁBIL, QUANDO O PRIMEIRO FOR MENOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.9.1.00.00.00.00.0000','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS - CONSOLIDAÇÃO','COMPREENDE A DIFERENÇA ENTRE O VALOR RECUPERÁVEL DO ATIVO E SEU VALOR CONTÁBIL, QUANDO O PRIMEIRO FOR MENOR. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.9.1.01.00.00.00.0000','(-) AJUSTE PARA PERDAS EM TITULOS E VALORES MOBILIARIOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS EM TITULOS E VALORES MOBILIARIOS A CURTO PRAZO. INCLUSIVE OS VALORES DE AJUSTES PARA PERDAS EM APLICAÇÕES DA CARTEIRA DO RPPS E EM INVESTIMENTOS COM RECURSOS DA TAXA DE ADMINISTRAÇÃO DO RPPS, SUJEITOS ÀS REGRAS DA RESOLUÇÃO DO CMN Nº 3922/2010.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.4.9.1.02.00.00.00.0000','(-) AJUSTES PARA PERDAS EM APLICAÇÕES TEMPORARIAS EM METAIS PRECIOSOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS EM APLICAÇÕES EM OURO E OUTROS METAIS PRECIOSOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.0.0.00.00.00.00.0000','ESTOQUES','COMPREENDE O VALOR DOS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORAÇÃO PELA ENTIDADE COM O OBJETIVO DE VENDA OU UTILIZAÇÃO PROPRIA NO CURSO NORMAL DAS ATIVIDADES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.1.0.00.00.00.00.0000','MERCADORIAS PARA REVENDA','COMPREENDE TODAS AS MERCADORIAS ADQUIRIDAS DE TERCEIROS PARA REVENDA, QUE NÃO SOFREM NENHUM PROCESSO DE TRANSFORMAÇÃO NA ENTIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.1.1.00.00.00.00.0000','MERCADORIAS PARA REVENDA - CONSOLIDAÇÃO','COMPREENDE TODOS OS PRODUTOS ADQUIRIDOS DE TERCEIROS PARA REVENDA, QUE NÃO SOFREM NENHUM PROCESSO DE TRANSFORMAÇÃO NA ENTIDADE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.1.1.01.00.00.00.0000','MERCADORIAS - ESTOQUES PROGRAMAS PRÓPRIOS','COMPREENDE O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA, RELATIVAS A PROGRAMAS PRÓPRIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.1.1.01.01.00.00.0000',' MERCADORIAS PARA VENDA OU REVENDA','REGISTRA O VALOR DAS MERCADORIAS PARA VENDA OU REVENDA E DOAÇÕES RELATIVAS A ESTOQUES DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.2.0.00.00.00.00.0000','PRODUTOS E SERVIÇOS ACABADOS','COMPREENDE OS PRODUTOS JA TERMINADOS E ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FÁBRICA, OU EM DEPÓSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNAÇÃO; E OS SERVIÇOS ACABADOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.2.1.00.00.00.00.0000','PRODUTOS E SERVIÇOS ACABADOS - CONSOLIDAÇÃO','COMPREENDE OS PRODUTOS JA TERMINADOS E ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FABRICA, OU EM DEPÓSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNAÇÃO; E OS SERVIÇOS ACABADOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.2.1.01.00.00.00.0000','PRODUTOS ACABADOS','REGISTRA O VALOR DE PRODUTOS MANUFATURADOS JA TERMINADOS, ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FABRICA, OU EM DEPÓSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.2.1.02.00.00.00.0000','SERVIÇOS ACABADOS','REGISTRA OS VALORES PERTINENTES A SERVIÇOS ACABADOS QUE ESTAO PENDENTES DE FATURAMENTO OU DE TRANSFERENCIA PARA OUTRAS CONTAS DO ATIVO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.3.0.00.00.00.00.0000','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','COMPREENDE OS PRODUTOS E SERVIÇOS EM ANDAMENTO NÃO CONCLUÍDOS NA DATA DO BALANÇO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.3.1.00.00.00.00.0000','PRODUTOS E SERVIÇOS EM ELABORAÇÃO - CONSOLIDAÇÃO','COMPREENDE OS PRODUTOS E SERVIÇOS EM ANDAMENTO NÃO CONCLUÍDOS NA DATA DO BALANÇO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.3.1.01.00.00.00.0000','PRODUTOS EM ELABORAÇÃO','REGISTRA A TOTALIDADE DAS MATÉRIAS-PRIMAS JA REQUISITADAS QUE ESTAO EM PROCESSO DE TRANSFORMACAO E O MONTANTE DE CUSTOS DIRETOS E INDIRETOS RELATIVOS AOS PRODUTOS EM ELABORACAO NÃO CONCLUIDOS NA DATA DO BALANCO PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.3.1.02.00.00.00.0000','SERVIÇOS EM ELABORAÇÃO','REGISTRA OS CUSTOS DIRETOS E INDIRETOS RELATIVOS AOS SERVIÇOS EM ELABORACAO NÃO CONCLUIDOS NA DATA DO BALANCO PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.4.0.00.00.00.00.0000','MATERIAS-PRIMAS','COMPREENDE O ESTOQUE DAS MATÉRIAS-PRIMAS, QUE SERÁ UTILIZADO NO PROCESSO PRODUTIVO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.4.1.00.00.00.00.0000','MATÉRIAS-PRIMAS - CONSOLIDAÇÃO','COMPREENDE O ESTOQUE DAS MATÉRIAS-PRIMAS, QUE SERÁ UTILIZADO NO PROCESSO PRODUTIVO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.4.1.01.00.00.00.0000','MATÉRIAS-PRIMAS - ARMAZENS PRÓPRIOS','REGISTRA O ESTOQUE DE MATÉRIAS-PRIMAS QUE SERAO UTILIZADOS NO PROCESSO PRODUTIVO, GUARDADAS EM ARMAZENS PRÓPRIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.5.0.00.00.00.00.0000','MATERIAIS EM TRANSITO','COMPREENDE O VALOR DOS MATERIAIS EM PROCESSO DE TRANSFERÊNCIA PARA OUTRAS UNIDADES DA ENTIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.5.1.00.00.00.00.0000','MATÉRIAIS EM TRANSITO - CONSOLIDAÇÃO','COMPREENDE O VALOR DOS MATERIAIS EM PROCESSO DE TRANSFERÊNCIA PARA OUTRAS UNIDADES DA ENTIDADE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.6.0.00.00.00.00.0000','ALMOXARIFADO','COMPREENDE O VALOR DOS MATERIAIS DESTINADOS AO CONSUMO INTERNO DA UNIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.6.1.00.00.00.00.0000','ALMOXARIFADO - CONSOLIDAÇÃO','COMPREENDE O VALOR DOS MATERIAIS DESTINADOS AO CONSUMO INTERNO DA UNIDADE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.6.1.01.00.00.00.0000','MATERIAL DE CONSUMO','REGISTRAR OS VALORES DOS MATERIAIS DE CONSUMO ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AS NECESSIDADES DA INSTITUIÇÃO E DE OUTRAS UNIDADES','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.6.1.02.00.00.00.0000','GENEROS ALIMENTICIOS','REGISTRA OS VALORES DOS GENEROS ALIMENTICIOS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AS NECESSIDADES DA ENTIDADE E DE OUTRAS UNIDADES DESSA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.6.1.03.00.00.00.0000','MATERIAIS DE CONSTRUCAO','REGISTRA OS VALORES DOS MATERIAIS DE CONSTRUCAO ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.6.1.05.00.00.00.0000','AUTOPECAS','REGISTRA OS VALORES DE AUTOPECAS ADQUIRIDAS E ESTOCADAS EM ALMOXARIFADOS, DESTINADAS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.6.1.06.00.00.00.0000','MEDICAMENTOS E MATERIAIS HOSPITALARES','REGISTRA OS VALORES DOS MEDICAMENTOS E MATERIAS HOSPITALARES ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.6.1.07.00.00.00.0000','MATERIAIS GRAFICOS','REGISTRA OS VALORES DOS MATERIAIS GRAFICOS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.6.1.08.00.00.00.0000','MATERIAL DE EXPEDIENTE','REGISTRA OS VALORES DOS MATERIAIS DE EXPEDIENTE ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.6.1.09.00.00.00.0000','MATERIAIS A CLASSIFICAR','REGISTRA OS VALORES DOS MATERIAIS ESTOCADOS PENDENTES DE CLASSIFICACAO E IDENTIFICACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.6.1.10.00.00.00.0000','ESTOQUE SOBRESSALENTES A ALIENAR','REGISTRA OS VALORES DE BENS SOBRESSALENTES QUE ESTEJAM DISPONIVEIS PARA ALIENACAO SOB DIVERSAS FORMAS (VENDA, LEILÃO, ETC).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.6.1.99.00.00.00.0000','OUTROS ALMOXARIFIDOS','REGISTRA OS VALORES DOS OUTROS ALMOXARIFADOS ADQUIRIDOS E ESTOCADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.7.0.00.00.00.00.0000','ADIANTAMENTOS A FORNECEDORES','COMPREENDE OS ADIANTAMENTOS EFETUADOS PELA ENTIDADE A FORNECEDORES, VINCULADOS A COMPRAS ESPECIFICAS DE MATERIAIS QUE SERÃO INCORPORADOS AOS ESTOQUES QUANDO DE SEU EFETIVO RECEBIMENTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.7.1.00.00.00.00.0000','ADIANTAMENTOS A FORNECEDORES - CONSOLIDAÇÃO','REGISTRA OS ADIANTAMENTOS EFETUADOS PELA ENTIDADE A FORNECEDORES, VINCULADOS A COMPRAS ESPECIFICAS DE MATERIAIS QUE SERAO INCORPORADOS AOS ESTOQUES QUANDO DE SEU EFETIVO RECEBIMENTO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.0.00.00.00.00.0000','OUTROS ESTOQUES','COMPREENDE O VALOR DOS OUTROS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORAÇÃO PELA ENTIDADE COM O OBJETIVO DE VENDA OU UTILIZAÇÃO PROPRIA NO CURSO NORMAL DAS ATIVIDADES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.00.00.00.00.0000','OUTROS ESTOQUES - CONSOLIDAÇÃO','COMPREENDE O VALOR DOS OUTROS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORAÇÃO PELA ENTIDADE COM O OBJETIVO DE VENDA OU UTILIZAÇÃO PROPRIA NO CURSO NORMAL DAS ATIVIDADES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.01.00.00.00.0000','MATERIAIS DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA OS VALORES DE ESTOQUE QUE SE DESTINAM A EMBALAGEM DO PRODUTO OU A SEU ACONDICIONAMENTO PARA REMESSA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.02.00.00.00.0000','ESTOQUES PARA DISTRIBUIÇÃO','COMPREENDE O VALOR DO MATERIAL EM ESTOQUE, DESTINADO A DISTRIBUICAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.02.01.00.00.0000','MATERIAL DE CONSUMO - ESTOQUE INTERNO - DESTINADO A DISTRIBUIÇÃO','REGISTRA OS VALORES RELATIVOS AS AQUISICOES E OU TRANSFERENCIAS DE MATERIAIS DE CONSUMO PARA A FORMACAO DE ESTOQUE INTERNO DESTINADO A DISTRIBUICAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.02.03.00.00.0000','MEDICAMENTOS - ESTOQUE INTERNO - DESTINADO A DISTRIBUIÇÃO','REGISTRA OS VALORES DOS MEDICAMENTOS E OUTROS PRODUTOS FARMACEUTICOS, ADQUIRIDOS OU FABRICADOS PELA UNIDADE, DESTINADOS A FORMACAO DE ESTOQUE DE DISTRIBUICAO PARA CONSUMO INTERNO OU REDISTRIBUICAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.02.05.00.00.0000','ESTOQUE DE MATERIAIS PARA PREMIAÇÕES','REGISTRA OS VALORES DAS PREMIAÇÕES COMO: MEDALHAS E PLACAS DESTINADOS A FORMACAO DE ESTOQUE DE DISTRIBUICAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.03.00.00.00.0000','ESTOQUES PARA DOAÇÃO E/OU PERMUTA','COMPREENDE O VALOR DAS MERCADORIAS EM ESTOQUES PARA DOACAO E/OU PERMUTA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.04.00.00.00.0000','ESTOQUES DE PRODUTOS PARA PESQUISA E ENSINO','COMPREENDE O VALOR DO MATERIAL EM ESTOQUE, RELATIVO A ANIMAL, VEGETAL OU MINERAL, DESTINADO A PESQUISA E ENSINO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.05.00.00.00.0000','IMPORTAÇÕES EM ANDAMENTO','COMPREENDE O VALOR DAS IMPORTAÇÕES EM ANDAMENTO DE BENS DE ESTOQUE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.05.01.00.00.0000','IMPORTAÇÕES EM ANDAMENTO DO EXERCÍCIO','REGISTRA O VALOR DAS IMPORTAÇÕES EM ANDAMENTO DE BENS DE ESTOQUE, DURANTE O EXERCICIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.05.02.00.00.0000','IMPORTAÇÕES EM ANDAMENTO DE EXERCÍCIOS ANTERIORES','REGISTRA O VALOR DAS IMPORTAÇÕES EM ANDAMENTO DE BENS DE ESTOQUE, INICIADAS EM EXERCICIOS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.06.00.00.00.0000','CONSTRUÇÕES CIVIS','COMPREENDE OS VALORES DOS IMOVEIS QUE DEVAM SER COLOCADOS A VENDA OU QUE TENHAM SIDO ADQUIRIDOS PARA VENDA OU REVENDA, PODENDO A COMERCIALIZACAO SER OU NÃO OBJETO PRINCIPAL DA EMPRESA, ENTIDADE, INSTITUICAO OU ORGAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.06.01.00.00.0000','TERRENOS','REGISTRA OS VALORES DE TERRENOS, INCLUINDO-SE OS CUSTOS DE FORMACAO OU DE URBANIZACAO E AJUSTES MONETARIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.06.02.00.00.0000','PROJETOS','REGISTRA OS VALORES DOS CUSTOS RELATIVOS AOS PROJETOSDE ARQUITETURA E URBANISMO PARA CONSTRUCOES E URBANIZAÇÕES DE IMOVEIS QUE DEVERAO SER COLOCADOS A VENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.06.03.00.00.0000','OBRAS EM ANDAMENTO','REGISTRA OS VALORES RELATIVOS A OBRAS EM ANDAMENTO, DESTINADAS A VENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.06.04.00.00.0000','OBRAS CONCLUÍDAS A COMERCIALIZAR','REGISTRA OS VALORES RELATIVOS AS CONSTRUCOES E AS EDIFICAÇÕES CONCLUÍDAS QUE DEVERAO SER COLOCADAS A VENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.06.05.00.00.0000','CUSTOS ACESSÓRIOS DE CONSTRUÇÃO CIVIL','REGISTRA OS VALORES DE SEGUROS, REMUNERAÇÕES A AGENTES FINANCEIROS, IMPOSTOS E TAXAS, DESPESAS COM LEGALIZAÇÕES E CARTORARIAS RELATIVOS A IMOVEIS DESTINADOS A VENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.8.1.98.00.00.00.0000','ESTOQUES DIVERSOS','REGISTRA OS ESTOQUES NÃO CLASSIFICAVEIS NAS DEMAIS CONTAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.9.0.00.00.00.00.0000','(-) AJUSTE DE PERDAS DE ESTOQUES','COMPREENDE O REGISTRO DAS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENÇAS FÍSICAS, QUANDO TAIS PERDAS NÃO PUDEREM SER BAIXADAS DAS PRÓPRIAS CONTAS, PELO FATO DE NÃO ESTAREM IDENTIFICADOS OS ITENS ESPECÍFICOS E POR CONSTITUÍREM ESTIMATIVAS, BEM COMO O REGISTRO DO AJUSTE DE PERDAS PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.9.1.00.00.00.00.0000','(-) AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','COMPREENDE O REGISTRO DAS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NÃO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NÃO ESTAREM IDENTIFICADOS OS ITENS ESPECIFICOS E POR CONSTITUIREM ESTIMATIVAS, BEM COMO O REGISTRO DA PROVISAO PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.9.1.01.00.00.00.0000','(-) AJUSTE PARA PERDAS EM ESTOQUES','REGISTRA AS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NÃO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NÃO ESTAREM IDENTIFICADOS OS ITENS ESPECIFICOS E POR CONSTITUIREM ESTIMATIVAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.5.9.1.02.00.00.00.0000','(-) AJUSTE PARA REDUÇÃO AO VALOR DE MERCADO','REGISTRA O AJUSTE PARA PERDAS DOS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.0.0.00.00.00.00.0000','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','COMPREENDE OS PAGAMENTOS DE VARIAÇÕES PATRIMONIAIS DIMINUTIVAS (VPD) ANTECIPADAS, CUJOS BENEFÍCIOS OU PRESTAÇÃO DE SERVICO A ENTIDADE OCORRERAO ATÉ O TÉRMINO DO EXERCÍCIO SEGUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.1.0.00.00.00.00.0000','PRÊMIOS DE SEGUROS A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE PRÊMIOS DE SEGURO, PENDENTES DE APROPRIAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.1.1.00.00.00.00.0000','PRÊMIOS DE SEGUROS A APROPRIAR - CONSOLIDAÇÃO','COMPREENDE OS VALORES PAGOS A TITULO DE PRÊMIOS DE SEGURO, PENDENTES DE APROPRIAÇÃO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.2.0.00.00.00.00.0000','VPD FINANCEIRAS A APROPRIAR','COMPREENDE OS VALORES PAGOS, PENDENTES DE APROPRIAÇÃO COMO VPD FINANCEIRAS A APROPRIAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.2.1.00.00.00.00.0000','VPD FINANCEIRAS A APROPRIAR - CONSOLIDAÇÃO','COMPREENDE OS VALORES PAGOS, PENDENTES DE APROPRIAÇÃO COMO VPD FINANCEIRAS A APROPRIAR.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.3.0.00.00.00.00.0000','ASSINATURAS E ANUIDADES A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.3.1.00.00.00.00.0000','ASSINATURAS E ANUIDADES A APROPRIAR - CONSOLIDAÇÃO','COMPREENDE OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.4.0.00.00.00.00.0000','ALUGUEIS PAGOS A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE ALUGUEL, PENDENTES A APROPRIAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.4.1.00.00.00.00.0000','ALUGUEIS PAGOS A APROPRIAR - CONSOLIDAÇÃO','COMPREENDE OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.5.0.00.00.00.00.0000','TRIBUTOS PAGOS A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE TRIBUTOS A APROPRIAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.5.1.00.00.00.00.0000','TRIBUTOS PAGOS A APROPRIAR - CONSOLIDAÇÃO','COMPREENDE OS VALORES PAGOS A TITULO DE TRIBUTOS A APROPRIAR. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.6.0.00.00.00.00.0000','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.6.1.00.00.00.00.0000','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR - CONSOLIDAÇÃO','COMPREENDE OS VALORES PAGOS A TITULO DE CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.7.0.00.00.00.00.0000','BENEFÍCIOS A PESSOAL A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE BENEFICIO A PESSOAL A APROPRIAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.7.1.00.00.00.00.0000','BENEFÍCIOS A PESSOAL A APROPRIAR - CONSOLIDAÇÃO','COMPREENDE OS VALORES PAGOS A TITULO DE BENEFICIO A PESSOAL A APROPRIAR. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.8.0.00.00.00.00.0000','DEMAIS VPD A APROPRIAR','COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.1.9.8.1.00.00.00.00.0000','DEMAIS VPD A APROPRIAR - CONSOLIDAÇÃO','COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.0.0.0.00.00.00.00.0000','ATIVO NÃO-CIRCULANTE','COMPREENDE O ATIVO NÃO-CIRCULANTE : O ATIVO REALIZAVEL A LONGO PRAZO, OS INVESTIMENTOS, O IMOBILIZADO E O INTANGIVEL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.0.0.00.00.00.00.0000','ATIVO REALIZAVEL A LONGO PRAZO','COMPREENDE OS BENS, DIREITOS E DESPESAS ANTECIPADAS REALIZÁVEIS NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.0.00.00.00.00.0000','CRÉDITOS A LONGO PRAZO','COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVIÇOS, CRÉDITOS TRIBUTÁRIOS, DÍVIDA ATIVA, TRANSFERÊNCIAS E EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS, COM VENCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.00.00.00.00.0000','CRÉDITOS A LONGO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVIÇOS, CRÉDITOS TRIBUTÁRIOS, DÍVIDA ATIVA, TRANSFERÊNCIAS E EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.01.00.00.00.0000','CRÉDITOS TRIBUTÁRIOS A RECEBER','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER COM VENCIMENTO NO LONGO PRAZO, ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIA.OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUIÇÕES DE MELHORIA, CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.01.01.00.00.0000','IMPOSTOS','REGISTRA OS CRÉDITOS TRIBUTÁRIOS A RECEBER PROVENIENTES DE IMPOSTOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.01.02.00.00.0000','TAXAS','REGISTRA OS CRÉDITOS TRIBUTÁRIOS A RECEBER PROVENIENTES DE TAXAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.01.03.00.00.0000','CONTRIBUIÇÕES DE MELHORIA','REGISTRA OS CRÉDITOS TRIBUTÁRIOS A RECEBER PROVENIENTES DE CONTRIBUIÇÕES DE MELHORIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.01.04.00.00.0000','DEMAIS CONTRIBUIÇÕES','REGISTRA OS CRÉDITOS TRIBUTÁRIOS A RECEBER PROVENIENTES DE CONTRIBUIÇÕES ESPECIAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.01.07.00.00.0000','CRÉDITOS TRIBUTÁRIOS PARCELADOS','REGISTRA OS VALORES RELATIVOS AOS CRÉDITOS AOS CRÉDITOS A RECEBER, DECORRENTES DE CRÉDITOS TRIBUTÁRIOS PARCELADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.02.00.00.00.0000','CLIENTES','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVIÇOS QUE OCORREM NO CURSO NORMAL DAS OPERAÇÕES DA ENTIDADE (COM VENCIMENTO APOS TÉRMINO DO EXERCÍCIO SEGUINTE), REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.02.03.00.00.0000','FATURAS/ DUPLICATAS A RECEBER- ESTOQUE PROPRIO','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.02.06.00.00.0000','FATURAS/DUPLICATAS A RECEBER - PRESTAÇÃO DE SERVIÇOS','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DOS FATURAMENTOS, A CURTO PRAZO, PROVENIENTES DE VENDAS DE PRODUTOS DO ESTOQUE','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.02.99.00.00.0000','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NÃO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.03.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','COMPREENDE O SOMATÓRIO DOS VALORES DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.03.01.00.00.0000','EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS CRÉDITOS POR EMPRÉSTIMOS CONCEDIDOS PELO MUNICÍPIO, POR AUTORIZAÇÃO LEGAL OU VINCULAÇÃO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.03.02.00.00.0000','EMPRÉSTIMOS EM COBRANCA JUDICIAL A RECEBER','REGISTRA OS VALORES RELATIVOS AOS EMPRÉSTIMOS CONCEDIDOS PELO MUNICÍPIO, ENTIDADES E INSTITUICOES POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.03.03.00.00.0000','EMPRÉSTIMOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A EMPRÉSTIMOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDÊNCIÁRIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL, REALIZÁVEIS APOS O TÉRMINO DO EXERCÍCIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.03.06.00.00.0000','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.03.08.00.00.0000','FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES RELATIVOS AOS FINANCIAMENTOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES MUNICIPAIS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.03.08.01.00.0000','FINANCIAMENTOS HABITACIONAIS','REPRESENTA O VALOR DOS CRÉDITOS DEVIDOS A ENTIDADES MUNICIPAIS DECORRENTES DE FINANCIAMENTOS HABITACIONAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.03.10.00.00.0000','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIÁRIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL, REALIZÁVEIS APOS O TERMINO DO EXERCICIO SEGUINTE (EXEMPLO: FINANCIAMENTOS IMOBILIÁRIOS)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.03.11.00.00.0000','FINANCIAMENTOS EM COBRANCA JUDICIAL A RECEBER','REGISTRA OS VALORES RELATIVOS AOS FINANCIAMENTOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES MUNICIPAIS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.03.12.00.00.0000','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER','REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.03.18.00.00.0000','RESIDUO DE EMPRESTIMOS CONCEDIDOS','REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM LONGO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.03.99.00.00.0000','OUTROS EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.04.00.00.00.0000','DÍVIDA ATIVA TRIBUTÁRIA','COMPREENDE OS VALORES DOS CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA, EM PROCESSO DE INSCRIÇÃO E JA INSCRITOS, REALIZÁVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PÚBLICAÇÃO DOS DEMONSTRATIVOS CONTABEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.04.01.00.00.0000','CREDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','COMPREENDE OS CREDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.04.01.01.00.0000','CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.04.01.01.01.0000','CREDITOS A ENCAMINHAR PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITOS A SEREM ENCAMINHADOS PELAS UG PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.04.01.01.02.0000','CREDITOS ENCAMINHADOS PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS ENCAMINHADOS PELAS UG, PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.04.01.02.00.0000','CREDITOS INSCRITOS EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS CONTRA TERCEIROS PROVENIENTES DE TRIBUTOS, MULTAS E OUTROS CREDITOS LANCADOS NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO DE ORIGEM QUE CONSTITUIREM EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.04.02.00.00.0000','CREDITOS PREVIDENCIÁRIOS INSCRITOS','COMPREENDE OS CREDITOS PREVIDENCIÁRIOS INSCRITOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.04.02.01.00.0000','CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.04.02.01.01.0000','CREDITOS A ENCAMINHAR PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITOS A SEREM ENCAMINHADOS PELAS UG PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.04.02.01.02.0000','CREDITOS ENCAMINHADOS PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS ENCAMINHADOS PELAS UG, PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.04.02.02.00.0000','CREDITOS INSCRITOS EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS CONTRA TERCEIROS PROVENIENTES DE TRIBUTOS, MULTAS E OUTROS CREDITOS LANCADOS NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO DE ORIGEM QUE CONSTITUIREM EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.05.00.00.00.0000','DÍVIDA ATIVA NÃO TRIBUTÁRIA','REGISTRA OS VALORES DOS CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA DERIVADOS DE CLIENTES , EM PROCESSO DE INSCRIÇÃO E JA INSCRITOS, REALIZÁVEIS APOS O TÉRMINO DO EXERCÍCIO SEGUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.05.01.00.00.0000','CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.05.01.01.00.0000','CREDITOS A ENCAMINHAR PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITOS A SEREM ENCAMINHADOS PELAS UG PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.05.01.02.00.0000','CREDITOS ENCAMINHADOS PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS ENCAMINHADOS PELAS UG, PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.05.02.00.00.0000','CREDITOS INSCRITOS EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS CONTRA TERCEIROS NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO DE ORIGEM QUE CONSTITUIREM EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.99.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NÃO RECEBIMENTO DE VALORES REFERENTES A CRÉDITOS A LONGO PRAZO, POR INADIMPLÊNCIA DE TERCEIROS E OUTRAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.99.01.00.00.0000','(-) AJUSTE DE PERDAS PARA CRÉDITOS DE LIQUIDAÇÃO DUVIDOSA','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.99.02.00.00.0000','(-) AJUSTE PARA PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.99.03.00.00.0000','(-) AJUSTE PARA PERDAS DE DÍVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS NA DÍVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.99.04.00.00.0000','(-) AJUSTE PARA PERDAS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA - CLIENTES','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DO AJUSTE PARA PERDAS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE .PROCEDIMENTOS DA DÍVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.1.99.05.00.00.0000','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.00.00.00.00.0000','CRÉDITOS A LONGO PRAZO - INTRA OFSS','COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVIÇOS, CRÉDITOS TRIBUTÁRIOS, DÍVIDA ATIVA, TRANSFERÊNCIAS E EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.01.00.00.00.0000','CRÉDITOS TRIBUTÁRIOS A RECEBER','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER COM VENCIMENTO APOS TÉRMINOEXERCÍCIO SEGUINTE, ORIUNDOS DA VARIAÇÃO PATRIMONIAL AUMENTATIVA TRIBUTÁRIAS.OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUIÇÕES DE MELHORIA, CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS .','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.02.00.00.00.0000','CLIENTES','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVIÇOS QUE OCORREM NO CURSO NORMAL DAS OPERAÇÕES DA ENTIDADE (COM VENCIMENTO APÓS TÉRMINO DO EXERCÍCIO SEGUINTE), REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.03.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','COMPREENDE O SOMATÓRIO DOS VALORES DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.03.01.00.00.0000','EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELO MUNICIPIO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.03.02.00.00.0000','EMPRESTIMOS EM COBRANCA JUDICIAL A RECEBER','REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.03.03.00.00.0000','EMPRÉSTIMOS A RECEBER – RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A EMPRÉSTIMOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIÁRIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL, REALIZÁVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.03.06.00.00.0000','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.03.08.00.00.0000','FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES RELATIVOS AOS FINANCIAMENTOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES MUNICIPAIS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.03.10.00.00.0000','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIÁRIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL, REALIZÁVEIS APOS O TERMINO DO EXERCICIO SEGUINTE (EXEMPLO: FINANCIAMENTOS IMOBILIÁRIOS)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.03.11.00.00.0000','FINANCIAMENTOS EM COBRANCA JUDICIAL A RECEBER','REGISTRA OS VALORES RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.03.12.00.00.0000','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER','REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.03.18.00.00.0000','RESIDUO DE EMPRESTIMOS CONCEDIDOS','REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM LONGO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.03.99.00.00.0000','OUTROS EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.04.00.00.00.0000','DIVIDA ATIVA TRIBUTÁRIA','COMPREENDE OS VALORES DOS CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA, EM PROCESSO DE INSCRIÇÃO E JA INSCRITOS, REALIZÁVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PÚBLICAÇÃO DOS DEMONSTRATIVOS CONTABEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.04.01.00.00.0000','CREDITOS NAO PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.04.02.00.00.0000','CREDITOS PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.05.00.00.00.0000','DIVIDA ATIVA NÃO TRIBUTARIA','COMPREENDE OS VALORES DOS CRÉDITOS DE DIVIDA ATIVA NÃO TRIBUTARIA, EM PROCESSO DE INSCRIÇÃO E JÁ INSCRITOS, REALIZÁVEIS NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.05.01.00.00.0000','CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.05.01.01.00.0000','CREDITOS A ENCAMINHAR PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITOS A SEREM ENCAMINHADOS PELAS UG PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.05.01.02.00.0000','CREDITOS ENCAMINHADOS PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS ENCAMINHADOS PELAS UG, PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.05.02.00.00.0000','CREDITOS INSCRITOS EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS CONTRA TERCEIROS NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO DE ORIGEM QUE CONSTITUIREM EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.99.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NÃO RECEBIMENTO DE VALORES REFERENTES A CRÉDITOS A LONGO PRAZO, POR INADIMPLÊNCIA DE TERCEIROS E OUTRAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.99.02.00.00.0000','(-) AJUSTE PARA PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.99.03.00.00.0000','(-) AJUSTE PARA PERDAS DE DÍVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS NA DÍVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.2.99.05.00.00.0000','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.3.00.00.00.00.0000','CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVIÇOS, CRÉDITOS TRIBUTÁRIOS, DÍVIDA ATIVA, TRANSFERÊNCIAS E EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS, COM VENCIMENTO APOS O TÉRMINO DO EXERCÍCIO SEGUINTE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.3.01.00.00.00.0000','CRÉDITOS TRIBUTÁRIOS A RECEBER','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER COM VENCIMENTO NO LONGO PRAZO, ORIUNDOS DAS VARIAÇÕES PATRIMONIAS AUMENTATIVAS TRIBUTÁRIAS.OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUIÇÕES DE MELHORIA, CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.3.02.00.00.00.0000','CLIENTES','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVIÇOS QUE OCORREM NO CURSO NORMAL DAS OPERAÇÕES DA ENTIDADE (COM VENCIMENTO APÓS TÉRMINO DO EXERCÍCIO SEGUINTE), REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.3.03.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','COMPREENDE O SOMATÓRIO DOS VALORES DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.3.03.01.00.00.0000','EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS CRÉDITOS POR EMPRÉSTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.3.03.03.00.00.0000','FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.3.03.99.00.00.0000','OUTROS EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS - INTER OFSS - UNIÃO','REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.3.04.00.00.00.0000','DÍVIDA ATIVA TRIBUTÁRIA','COMPREENDE OS VALORES DOS CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA, EM PROCESSO DE INSCRIÇÃO E JA INSCRITOS, REALIZÁVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PÚBLICAÇÃO DOS DEMONSTRATIVOS CONTABEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.3.04.01.00.00.0000','CREDITOS NAO PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.3.04.02.00.00.0000','CREDITOS PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.3.05.00.00.00.0000','DIVIDA ATIVA NÃO TRIBUTARIA','COMPREENDE OS VALORES DOS CRÉDITOS DE DIVIDA ATIVA NÃO TRIBUTARIA, EM PROCESSO DE INSCRIÇÃO E JÁ INSCRITOS, REALIZÁVEIS NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.3.99.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NÃO RECEBIMENTO DE VALORES REFERENTES A CRÉDITOS A LONGO PRAZO, POR INADIMPLÊNCIA DE TERCEIROS E OUTRAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.3.99.03.00.00.0000','(-) AJUSTE PARA PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.3.99.04.00.00.0000','(-) AJUSTE PARA PERDAS DE DÍVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS NA DÍVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DÍVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.3.99.06.00.00.0000','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.4.00.00.00.00.0000','CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVIÇOS, CRÉDITOS TRIBUTÁRIOS, DÍVIDA ATIVA, TRANSFERÊNCIAS E EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS, COM VENCIMENTO APOS O TÉRMINO DO EXERCÍCIO SEGUINTE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.4.01.00.00.00.0000','CRÉDITOS TRIBUTÁRIOS A RECEBER','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER COM VENCIMENTO NO LONGO PRAZO, ORIUNDOS DAS VARIAÇÕES PATRIMONIAS AUMENTATIVAS TRIBUTÁRIAS.OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUIÇÕES DE MELHORIA, CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.4.02.00.00.00.0000','CLIENTES','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVIÇOS QUE OCORREM NO CURSO NORMAL DAS OPERAÇÕES DA ENTIDADE (COM VENCIMENTO APÓS TÉRMINO DO EXERCÍCIO SEGUINTE), REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.4.03.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','COMPREENDE O SOMATÓRIO DOS VALORES DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.4.04.00.00.00.0000','DIVIDA ATIVA TRIBUTARIA','COMPREENDE OS VALORES DOS CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA, EM PROCESSO DE INSCRIÇÃO E JA INSCRITOS, REALIZÁVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PÚBLICAÇÃO DOS DEMONSTRATIVOS CONTABEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.4.05.00.00.00.0000','DIVIDA ATIVA NÃO TRIBUTARIA','COMPREENDE OS VALORES DOS CRÉDITOS DE DIVIDA ATIVA NÃO TRIBUTARIA, EM PROCESSO DE INSCRIÇÃO E JÁ INSCRITOS, REALIZÁVEIS NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.4.99.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NÃO RECEBIMENTO DE VALORES REFERENTES A CRÉDITOS A LONGO PRAZO, POR INADIMPLÊNCIA DE TERCEIROS E OUTRAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.4.99.02.00.00.0000','(-) AJUSTE PARA PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.4.99.03.00.00.0000','(-) AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS PARA A DIVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.4.99.05.00.00.0000','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.5.00.00.00.00.0000','CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVIÇOS, CRÉDITOS TRIBUTÁRIOS, DÍVIDA ATIVA, TRANSFERÊNCIAS E EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS, COM VENCIMENTO APOS O TÉRMINO DO EXERCÍCIO SEGUINTE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.5.01.00.00.00.0000','CRÉDITOS TRIBUTÁRIOS A RECEBER','REGISTRA OS VALORES RELATIVOS A CRÉDITOS A RECEBER COM VENCIMENTO NO LONGO PRAZO, ORIUNDOS DAS VARIAÇÕES PATRIMONIAS AUMENTATIVAS TRIBUTÁRIAS.OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUIÇÕES DE MELHORIA, CONTRIBUIÇÕES E EMPRÉSTIMOS COMPULSÓRIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.5.02.00.00.00.0000','CLIENTES','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVIÇOS QUE OCORREM NO CURSO NORMAL DAS OPERAÇÕES DA ENTIDADE (COM VENCIMENTO APÓS TÉRMINO DO EXERCÍCIO SEGUINTE), REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.5.03.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','COMPREENDE O SOMATÓRIO DOS VALORES DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.5.04.00.00.00.0000','DIVIDA ATIVA TRIBUTARIA','COMPREENDE OS VALORES DOS CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA, EM PROCESSO DE INSCRIÇÃO E JA INSCRITOS, REALIZÁVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PÚBLICAÇÃO DOS DEMONSTRATIVOS CONTABEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.5.05.00.00.00.0000','DIVIDA ATIVA NÃO TRIBUTARIA','COMPREENDE OS VALORES DOS CRÉDITOS DE DIVIDA ATIVA NÃO TRIBUTARIA, EM PROCESSO DE INSCRIÇÃO E JÁ INSCRITOS, REALIZÁVEIS NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.5.99.00.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NÃO RECEBIMENTO DE VALORES REFERENTES A CRÉDITOS A LONGO PRAZO, POR INADIMPLÊNCIA DE TERCEIROS E OUTRAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.5.99.02.00.00.0000','(-) AJUSTE PARA PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.5.99.03.00.00.0000','(-) AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS PARA A DIVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.1.5.99.05.00.00.0000','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.0.00.00.00.00.0000','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','COMPREENDE OS VALORES A RECEBER POR DEMAIS TRANSAÇÕES, COM VENCIMENTO APOS O TÉRMINO DO EXERCÍCIO SEGUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.00.00.00.00.0000','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS VALORES A RECEBER POR DEMAIS TRANSAÇÕES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.01.00.00.00.0000','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','COMPREENDE AS ANTECIPAÇÕES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPAÇÕES DE SALÁRIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALÁRIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALÉM DA ENTREGA DE NUMERÁRIOA TERCEIROS SEM VINCULAÇÃO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVIÇOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.01.01.00.00.0000','ADIANTAMENTOS CONCEDIDOS A PESSOAL','REGISTRA OS VALORES DAS ANTECIPAÇÕES CONCEDIDAS A SERVIDORES E A DIRIGENTES DA UNIDADE, TAIS COMO ANTECIPAÇÕES DE SALÁRIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALÁRIO, ADIANTAMENTOS DE FÉRIAS E DE GRATIFICAÇÕES NATALINAS,ENTRE OUTRAS.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.01.99.00.00.0000','ADIANTAMENTOS DIVERSOS CONCEDIDOS','REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NÃO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.00.00.00.0000','TRIBUTOS A RECUPERAR / COMPENSAR','COMPREENDE O SOMATÓRIO DOS VALORES DOS TRIBUTOS A RECUPERAR / COMPENSAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.01.00.00.0000','IPI A RECUPERAR/COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO IPI A RECUPERAR/COMPENSAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.02.00.00.0000','ICMS A RECUPERAR/COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DE ICMS A RECUPERAR/COMPENSAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.03.00.00.0000','ICMS DIFERIDO','REGISTRA OS VALORES DO ICMS DIFERIDO DOS ESTOQUES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.04.00.00.0000','IRRF A COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO IR RETIDO NA FONTE A COMPENSAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.05.00.00.0000','IR E CSLL A RECUPERAR/COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO IR E DA CSLL A RECUPERAR/COMPENSAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.06.00.00.0000','IR E CSLL DIFERIDOS','REGISTRA A PARCELA DO IR E CSLL QUE REPRESENTA A DIFERENÇA ENTRE OS VALORES DE LUCRO APURADOS SEGUINDO AS NORMAS FISCAIS E SEGUINDO O REGIME DE COMPETÊNCIA, QUANDO ESTES FOREM MENORES E AS DIFERENÇAS TEMPORÁRIAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.07.00.00.0000','ISS A COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO ISS A COMPENSAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.08.00.00.0000','IPVA A COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO IPVA A COMPENSAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.09.00.00.0000','IPTU A COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO IPTU A COMPENSAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.10.00.00.0000','ITR A COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO ITR A COMPENSAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.11.00.00.0000','INSS A COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO INSS A COMPENSAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.12.00.00.0000','COFINS A RECUPERAR/COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DA COFINS A RECUPERAR/COMPENSAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.13.00.00.0000','PIS/PASEP A RECUPERAR/COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DO PIS/PASEP A RECUPERAR/COMPENSAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.14.00.00.0000','CIP A RECUPERAR/COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DA CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA A RECUPERAR/COMPENSAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.02.99.00.00.0000','OUTROS TRIBUTOS A RECUPERAR/COMPENSAR','REGISTRA O SOMATÓRIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR/COMPENSAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.03.00.00.00.0000','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','COMPREENDE OS CRÉDITOS A RECEBER COM REALIZAÇÃO APOS OS DOZE MESES SEGUINTES A DATA DE PÚBLICAÇÃO DAS DEMONSTRAÇÕES CONTABEIS, DECORRENTES DA DESCENTRALIZAÇÃO DE SERVIÇOS PÚBLICOS, TANTO POR MEIO DE OUTORGA A ENTIDADES DA ADMINISTRAÇÃO INDIRETA COMO POR MEIO DE DELEGAÇÃO, NAS FORMAS DE CONCESSAO, PERMISSÃO OU AUTORIZAÇÃO AO PARTICULAR DO DIREITO DE EXPLORAÇÃO DE SERVIÇOS PÚBLICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.04.00.00.00.0000','CRÉDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CRÉDITOS ADMINISTRATIVOS','COMPREENDE OS VALORES REALIZÁVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PÚBLICAÇÃO DAS DEMONSTRAÇÕES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.04.01.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','REGISTRA O CRÉDITO DO ENTE CORRESPONDENTE A DEBITOS ADMINISTRATIVOS DECORRENTES DE FOLHA DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.04.02.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','REGISTRA O CRÉDITO DO ENTE CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PÚBLICO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.04.03.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','REGISTRA O CRÉDITO DO ENTE CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRAÇÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.04.04.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE','REGISTRA O CRÉDITO DO ENTE CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.04.05.00.00.0000','CRÉDITOS A RECEBER DE SERVIDORES NÃO RECOLHIDOS NO PRAZO LEGAL','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NÃO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU DETERMINAÇÃO ADMINISTRATIVA OU SEJA, QUANDO O PRODUTO A ARRECADAR NÃO TENHA SIDO RECOLHIDO NO PRAZO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.04.06.00.00.0000','CRÉDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTAÇÃO DE SERVIÇOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTAÇÃO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.04.07.00.00.0000','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGÃO, POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTAÇÃO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.04.10.00.00.0000','CRÉDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFÍCIOS PREVIDENCIÁRIOS','REGISTRA O CRÉDITO A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFÍCIOS PREVIDENCIÁRIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.04.99.00.00.0000','OUTROS CRÉDITOS ADMINISTRATIVOS','REGISTRA O CRÉDITO DO ENTE CORRESPONDENTE A OUTROS CRÉDITOS ADMINISTRATIVOS QUE NÃO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.05.00.00.00.0000','CRÉDITOS POR DANOS AO PATRIMONIO APURADOS EM TOMADA DE CONTAS ESPECIAL','COMPREENDE OS VALORES REALIZÁVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PÚBLICAÇÃO DAS DEMONSTRAÇÕES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.05.01.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.05.02.00.00.0000','CRÉDITOS A RECEBER DE SERVIDORES NÃO RECOLHIDOS NO PRAZO LEGAL - TOMADA DE CONTAS ESPECIAL','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES, NÃO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU DETERMIMANAÇÃO ADMINISTRATIVA, OU SEJA, QUANDO O PRODUTO A ARRECADAR NÃO TENHA SIDO RECOLHIDO NO PRAZO LEGAL..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.05.03.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DO MUNICÍPIO OU DE ENTIDADES PÚBLICAS, APURADAS EM PROCESSOS POR AÇÕES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.05.04.00.00.0000','CRÉDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTAÇÃO DE SERVIÇOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTAÇÃO DE SERVIÇOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTAÇÃO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.05.05.00.00.0000','CRÉDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS A FAZENDA PÚBLICA SENDO APURADOS COM IMPUTAÇÃO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.05.06.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO - TOMADA DE CONTAS ESPECIAL','REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CRÉDITO QUE AS COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICAÇÃO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTAÇÃO DA RESPONSABILIDADE','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.05.07.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE CRÉDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES PAGOS SOBRE DOTAÇÕES DECORRENTES DE CRÉDITOS ANTECIPADOS NÃO REALIZADOS ATE O FECHAMENTO DO EXERCÍCIO, APURADOS, COM IMPUTAÇÃO DA RESPONSABILIDADE','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.05.08.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVAÇÃO - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTAÇÃO COMPROBATORIA DA EXECUÇÃO DA DESPESA, INCLUSIVE AS APRESENTAÇÕES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVAÇÃO DE INSTRUMENTOS DE TRANSFERÊNCIA OU AINDA IRREGULARIDADE NA DOCUMENTA','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.05.09.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE FALTA DE LICITAÇÃO - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES RELATIVOS A BENS E SERVIÇOS ADQUIRIDOS SEM A NECESSARIA LICITAÇÃO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR DETERMINAÇÕES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTAÇÃO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.05.10.00.00.0000','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGÃO, POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTAÇÃO DA RESPONSABILIDADE .','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.05.11.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGAÇÕES PECUNIARIAS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGAÇÕES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DE OBRIGAÇÕES PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NÃO RECOLHIDOS, NÃO PAGAMENTO DE OBRIGAÇÕES PARA COM O ENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.05.13.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLAÇÃO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.05.99.00.00.0000','OUTRAS CRÉDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICAÇÕES NÃO ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NÃO HAJAM CONTAS ESPECIFICAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.06.00.00.00.0000','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','COMPREENDE OS VALORES DE DEPÓSITOS E CAUÇÕES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORAÇÃO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPÓSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZÁVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PÚBLICAÇÃO DAS DEMONSTRAÇÕES CONTABEIS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.06.01.00.00.0000','DEPÓSITOS E CAUÇÕES RELATIVOS A CONTRATOS OU CONVENCOES','REGISTRA OS VALORES RELATIVOS A DEPÓSITOS E CAUÇÕES, EFETUADOS POR VINCULAÇÕES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERAÇÕES ESPECIFICAS, REALIZÁVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PÚBLICAÇÃO DAS DEMONSTRAÇÕES CONTABEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.06.02.00.00.0000','DEPÓSITOS JUDICIAIS','REGISTRA OS VALORES A RECEBER DECORRENTES DE DEPÓSITOS EFETUADOS POR DETERMINAÇÃO JUDICIAL, REALIZÁVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PÚBLICAÇÃO DAS DEMONSTRAÇÕES CONTABEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.06.03.00.00.0000','DEPÓSITOS PARA INTERPOSICAO DE RECURSOS','REGISTRA OS VALORES RELATIVOS AOS DEPÓSITOS VINCULADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.06.04.00.00.0000','DEPÓSITOS ESPECIAIS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPÓSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGAÇÕES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.06.05.00.00.0000','VALORES APREENDIDOS POR DECISAO JUDICIAL','REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZÁVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PÚBLICAÇÃO DAS DEMONSTRAÇÕES CONTABEIS.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.06.99.00.00.0000','OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS, REALIZÁVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PÚBLICAÇÃO DAS DEMONSTRAÇÕES CONTABEIS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.07.00.00.00.0000','DIVIDA ATIVA NÃO TRIBUTÁRIA - DEMAIS CRÉDITOS','REGISTRA OS VALORES DOS CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA, EXCETO AS DERIVADAS DE CLIENTES, EM PROCESSO DE INSCRIÇÃO E JA INSCRITOS, REALIZÁVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PÚBLICAÇÃO DOS DEMONSTRATIVOS CONTABEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.07.01.00.00.0000','INSCRIÇÃO DE CERTIDAO DE DECISAO - TÍTULO EXECUTIVO DO TCE/AL','REPRESENTA CRÉDITOS DE NATUREZA NÃO-TRIBUTÁRIA EXIGÍVEIS A PARTIR DO RECEBIMENTO, PELA ENTIDADE, DE CERTIDÃO DE DECISÃO – TÍTULO EXECUTIVO, EMITIDA PELO TRIBUNAL DE CONTAS DO ESTADO COM CARACTERÍSTICA DE LIQUIDEZ E CERTEZA, PODENDO SER, FACULTATIVAMENTE INSCRITA COMO DÍVIDA ATIVA NÃO TRIBUTÁRIA','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.00.00.00.0000','OUTROS CRÉDITOS A RECEBER E VALORES A LONGO PRAZO','COMPREENDE OS OUTROS CRÉDITOS E VALORES REALIZÁVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PÚBLICAÇÃO DAS DEMONSTRAÇÕES CONTABEIS, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.01.00.00.0000','CRÉDITOS A RECEBER DE ENTIDADES FEDERAIS','REGISTRA OS VALORES REALIZÁVEIS APOS O TERMINO DO EXERCICIO SEGUINTE DECORRENTES DE DEBITO DE ENTIDADES FEDERAIS COM A UNIAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.03.00.00.0000','CRÉDITOS ORIUNDOS DE CONCESSOES DE DIREITOS DE USO E DE EXPLORAÇÃO DE BENS','REGISTRA O VALOR DOS CRÉDITOS ORIUNDOS DAS CONCESSOES DE DIREITOS DE USO E DE EXPLORAÇÃO DE BENS DO ENTE, PARA TERCEIROS OU PARA OUTRAS ENTIDADES GOVERNAMENTAIS, REALIZÁVEIS A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.04.00.00.0000','CRÉDITOS A RECEBER DE DEVEDORES DE CONVÊNIOS','REGISTRA OS VALORES ORIUNDOS DE CRÉDITOS DE CONVÊNIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.05.00.00.0000','CRÉDITOS A RECEBER DECORRENTES DE ALIENAÇÃO DE BENS MÓVEIS E IMÓVEIS','REGISTRA OS VALORES DOS CRÉDITOS A RECEBER DECORRENTES DA ALIENAÇÃO DE BENS MÓVEIS E IMÓVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.07.00.00.0000','CRÉDITOS ADMINISTRATIVOS DECORRENTES DE AUTOS DE INFRAÇÃO','REGISTRA O VALOR DOS CRÉDITOS ADMINISTRATIVOS ORIUNDOS DE AUTOS DE INFRAÇÃO E OUTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.08.00.00.0000','CRÉDITOS A RECEBER EM PARCELAS/ LOTES ORIUNDOS DE DESAPROPRIAÇÕES','REGISTRA OS VALORES A RECEBER ORIUNDOS DE DESAPROPRIAÇÕES DE IMÓVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.12.00.00.0000','VALORES A RECUPERAR DECORRENTES DE INDENIZAÇÃO DE SINISTROS PAGOS','REGISTRA OS VALORES A RECUPERAR DECORRENTES DE PAGAMENTOS DEINDENIZAÇÕES DE SINISTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.13.00.00.0000','INDENIZAÇÕES A RECEBER','REGISTRA OS VALORES DASINDENIZAÇÕES A RECEBER A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.14.00.00.0000','CRÉDITOS A RECUPERAR','REGISTRA O VALOR DOS CRÉDITOS A RECUPERAR APOS O TÉRMINO DO EXERCÍCIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.16.00.00.0000','CRÉDITOS EM LIQUIDAÇÃO','REGISTRA OS VALORES ORIUNDOS DE CRÉDITOS EM LIQUIDAÇÃO DE DIFICIL REALIZAÇÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.17.00.00.0000','CRÉDITOS PARCELADOS','REGISTRA O VALOR DOS CRÉDITOS PARCELADOS, REALIZÁVEIS APOS O TÉRMINO DO EXERCÍCIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.19.00.00.0000','CRÉDITOS A RECEBER EM PODER DA JUSTICA','REGISTRA OS VALORES A RECEBER EM PODER DA JUSTICA, SEM PREVISAO DE RECEBIMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.20.00.00.0000','TITULOS A RECEBER','COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.99.00.00.0000','OUTROS CRÉDITOS A RECEBER E VALORES A LONGO PRAZO','REGISTRA OUTROS CRÉDITOS A RECEBER E VALORES A LONGO PRAZO, NÃO CLASSIFICAVEIS EM OUTRAS CONTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.98.99.01.00.0000','INSCRIÇÃO DE CERTIDAO DE DECISAO - TÍTULO EXECUTIVO DO TCE/AL','REPRESENTA CRÉDITOS EXIGÍVEIS A PARTIR DO RECEBIMENTO, PELA ENTIDADE, DE CERTIDÃO DE DECISÃO – TÍTULO EXECUTIVO, EMITIDA PELO TRIBUNAL DE CONTAS DO ESTADO COM CARACTERÍSTICA DE LIQUIDEZ E CERTEZA, PODENDO SER, FACULTATIVAMENTE INSCRITA COMO DÍVIDA ATIVA NÃO TRIBUTÁRIA','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.99.00.00.00.0000','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','COMPREENDE OS AJUSTES DE PERDAS ESTIMADAS COM O NÃO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CRÉDITOS A LONGO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.99.02.00.00.0000','(-) AJUSTE DE PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA - DEMAIS CRÉDITOS','REGISTRA OS AJUSTE DE PERDAS COM O NÃO RECEBIMENTO DE VALORES REFERENTES A DÍVIDA ATIVA NÃO TRIBUTÁRIA DE LONGO PRAZO, EXCETO AS DERIVADAS DE CLIENTES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.99.03.00.00.0000','(-) AJUSTES DE PERDA DE CRÉDITOS ADMINISTRATIVOS','REGISTRA OS VALORES DOS AJUSTES DE PERDAS DE CRÉDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.99.04.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES DOS AJUSTES DE PERDAS DE CRÉDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.2.1.99.98.00.00.0000','(-) AJUSTE DE PERDAS DE CRÉDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES DOS AJUSTES DE PERDAS DE OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.0.00.00.00.00.0000','INVESTIMENTOS TEMPORARIOS A LONGO PRAZO','COMPREENDE AS APLICAÇÕES DE RECURSOS EM TITULOS, VALORES MOBILIARIOS E IMOBILIARIOS, NÃO DESTINADAS A NEGOCIAÇÃO E QUE NÃO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.00.00.00.00.0000','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','COMPREENDE AS APLICAÇÕES DE RECURSOS EM TíTULOS, VALORES MOBILIARIOS E IMOBILIARIOS, NÃO DESTINADAS A NEGOCIAÇÃO E QUE NÃO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.01.00.00.00.0000','TITULOS E VALORES MOBILIARIOS','COMPREENDEM AS APLICAÇÕES DE RECURSOS EM TITULOS E VALORES MOBILIARIOS, NÃO DESTINADAS A NEGOCIAÇÃO E QUE NÃO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PÚBLICAÇÃO DAS DEMONSTRAÇÕES CONTABEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.01.01.00.00.0000','TITULOS DA DIVIDA AGRARIA - TDA','REGISTRA OS VALORES RELATIVOS AOS TITULOS DA DIVIDA AGRARIA, PARA FINS DE INDENIZACOES DE PROPRIEDADES RURAIS, COM OBJETIVO DE REFORMA AGRARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.01.02.00.00.0000','TITULOS PUBLICOS - LETRAS ESPECIAIS','REGISTRA O VALOR DAS LETRAS ESPECIAIS EM TITULOS PUBLICOS EMITIDOS NO MERCADO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.01.06.00.00.0000','DEMAIS ACOES','REGISTRA OS VALORES DAS DAS DEMAIS ACOES REPRESENTATIVAS DAS PARTICIPACOES DOS ORGAOS E ENTIDADES NO CAPITAL DAS SOCIEDADES POR ACOES HAVIDAS POR AQUISICOES, SUBSCRICOES, BONIFICACOES E DOACOES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.01.07.00.00.0000','FUNDO DE APLICAÇÕES EM COTAS - RENDA VARIÁVEL','REGISTRA OS VALORES APLICADOS EM FUNDOS DE APLICAÇÕES EM COTAS - RENDA VARIÁVEL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.01.09.00.00.0000','APLICAÇÕES EM ATIVOS EM ENQUADRAMENTO - TITULOS E VALORES','REGISTRA AS APLICAÇÕES DE RECURSOS DO REGIME PROPRIO DA PREVIDENCIA SOCIAL - RPPS EM DESACORDO COM A LEGISLAÇÃO E MANTIDAS EM CARTEIRA ATE O CORRESPONDENTE VENCIMENTO OU, NA INEXISTENCIA DESSE, ATE O PRAZO ESTIPULADO EM LEGISLAÇÃO CORRESPONDENTE, CASO SEJ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.01.10.00.00.0000','APLICAÇÕES EM ATIVOS NÃO SUJEITOS A RESOLUCAO DO CMN - TITULOS E VALORES','REGISTRA OS VALORES DOS ATIVOS - TITULOS E VALORES NÃO SUJEITOS AS REGRAS ESTABELECIDAS NA RESOLUCAO CMN Nº 3790/2009, REALIZÁVEIS NO LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.01.99.00.00.0000','OUTROS TITULOS E VALORES','REGISTRA OS OUTROS TITULOS E VALORES MOBILIARIOS A LONGO PRAZO, NÃO CLASSIFICAVEIS NAS CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.02.00.00.00.0000','APLICAÇÃO TEMPORARIA EM METAIS PRECIOSOS','COMPREENDEM AS APLICAÇÕES DE RECURSOS EM METAIS PRECIOSOS, NÃO DESTINADOS A NEGOCIAÇÃO E QUE NÃO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PÚBLICAÇÃO DAS DEMONSTRAÇÕES CONTABEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.03.00.00.00.0000','APLICAÇÕES EM SEGMENTO DE IMÓVEIS','REGISTRA OS INVESTIMENTOS DE LONGO PRAZO REALIZADOS EM SEGMENTO DE IMÓVEIS, REALIZÁVEIS APOS O TÉRMINO DO EXERCÍCIO SEGUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.03.01.00.00.0000','EDIFICAÇÕES','REGISTRA OS INVESTIMENTOS EM EDIFICAÇÕES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.03.02.00.00.0000','TERRENOS','REGISTRA OS INVESTIMENTOS EM TERRENOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.03.03.00.00.0000','SALAS E ESCRITORIOS','REGISTRA OS INVESTIMENTOS EM SALAS E ESCRITORIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.03.04.00.00.0000','OUTROS BENS IMÓVEIS','REGISTRA OS INVESTIMENTOS EM OUTROS BENS IMÓVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.99.00.00.00.0000','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO','COMPREENDE A DIFERENCA ENTRE O VALOR RECUPERAVEL DO ATIVO E SEU VALOR CONTABIL, QUANDO O PRIMEIRO FOR MENOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.99.01.00.00.0000','(-) AJUSTE PARA PERDAS EM TÍTULOS, VALORES MOBILIÁRIOS E IMOVEIS','REGISTRA OS VALORES DOS AJUSTES PARA PERDAS EM TÍTULOS , VALORES MOBILIÁRIOS E IMOVEIS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.3.1.99.02.00.00.0000','(-) AJUSTE DE PERDAS COM APLICACOES TEMPORARIAS EM METAIS PRECIOSOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS EM APLICACOES EM OURO E OUTROS METAIS PRECIOSOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.4.0.00.00.00.00.0000','ESTOQUES','COMPREENDE O VALOR DOS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORAÇÃO PELA ENTIDADE PARA UTILIZAÇÃO PROPRIA OU PARA VENDA, PREVISTOS PARA PERIODO POSTERIOR AO TÉRMINO DO EXERCÍCIO SEGUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.4.1.00.00.00.00.0000','ESTOQUES - CONSOLIDAÇÃO','COMPREENDE O VALOR DOS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORAÇÃO PELA ENTIDADE PARA UTILIZAÇÃO PROPRIA OU PARA VENDA, PREVISTOS PARA PERIODO POSTERIOR AO TÉRMINO DO EXERCÍCIO SEGUINTE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.4.1.01.00.00.00.0000','MERCADORIAS PARA REVENDA','COMPREENDE TODAS AS MERCADORIAS ADQUIRIDAS DE TERCEIROS PARA REVENDA, QUE NÃO SOFREM NENHUM PROCESSO DE TRANSFORMAÇÃO NA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.4.1.02.00.00.00.0000','PRODUTOS E SERVIÇOS ACABADOS','COMPREENDE OS PRODUTOS JA TERMINADOS E ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FABRICA, OU EM DEPÓSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNAÇÃO; E OS SERVIÇOS ACABADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.4.1.03.00.00.00.0000','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','COMPREENDE OS PRODUTOS E SERVIÇOS EM ANDAMENTO QUE NÃO SERAO CONCLUIDOS ATE O TÉRMINO DO EXERCÍCIO SUBSEQUENTE A DATA DO BALANCO PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.4.1.04.00.00.00.0000','MATERIAS-PRIMAS','COMPREENDE A TOTALIDADE DAS MATÉRIAS-PRIMAS, QUE SÃO OS MATERIAIS MAIS IMPORTANTES E ESSENCIAIS QUE SOFREM TRANSFORMAÇÕES NO PROCESSO PRODUTIVO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.4.1.05.00.00.00.0000','MATERIAIS EM TRANSITO','COMPREENDE O VALOR DOS MATERIAIS EM PROCESSO DE TRANSFERÊNCIA PARA OUTRAS UNIDADES DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.4.1.06.00.00.00.0000','ALMOXARIFADO','COMPREENDE O VALOR DOS MATERIAIS DESTINADOS AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.4.1.07.00.00.00.0000','ADIANTAMENTOS A FORNECEDORES','REGISTRA OS ADIANTAMENTOS EFETUADOS PELA ENTIDADE A FORNECEDORES, VINCULADOS A COMPRAS ESPECIFICAS DE MATERIAIS QUE SERAO INCORPORADOS AOS ESTOQUES QUANDO DE SEU EFETIVO RECEBIMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.4.1.98.00.00.00.0000','OUTROS ESTOQUES','COMPREENDE O VALOR DOS OUTROS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORAÇÃO PELA ENTIDADE COM O OBJETIVO DE VENDA OU UTILIZAÇÃO PROPRIA NO CURSO NORMAL DAS ATIVIDADES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.4.1.99.00.00.00.0000','(-) AJUSTE DE PERDAS DE ESTOQUES','COMPREENDE O REGISTRO DAS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NÃO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NÃO ESTAREM IDENTIFICADOS OS ITENS ESPECIFICOS E POR CONSTITUIREM ESTIMATIVAS, BEM COMO O REGISTRO DAS PERDAS ESTIMADAS PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO. CONTA A SER UTILIZADA APENAS PARA OS ESTOQUES CLASSIFICADOS NO ATIVO REALIZAVEL A LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.4.1.99.01.00.00.0000','(-) AJUSTE PARA PERDAS EM ESTOQUES','REGISTRA AS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NÃO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NÃO ESTAREM IDENTIFICADAS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.4.1.99.02.00.00.0000','(-) AJUSTE PARA REDUÇÃO AO VALOR DE MERCADO','REGISTRA O AJUSTE PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.9.0.00.00.00.00.0000','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','COMPREENDE PAGAMENTOS DE VARIAÇÕES PATRIMONIAIS DIMINUTIVAS (VPD) ANTECIPADAS, CUJOS BENEFÍCIOS OU PRESTAÇÃO DE SERVICO A ENTIDADE OCORRERÃO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.9.1.00.00.00.00.0000','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE- CONSOLIDAÇÃO','COMPREENDE PAGAMENTOS DE VARIAÇÕES PATRIMONIAIS DIMINUTIVAS (VPD) ANTECIPADAS, CUJOS BENEFÍCIOS OU PRESTAÇÃO DE SERVICO A ENTIDADE OCORRERÃO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.9.1.01.00.00.00.0000','PRÊMIOS DE SEGUROS A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE PRÊMIOS DE SEGURO, PENDENTES DE APROPRIAÇÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.9.1.02.00.00.00.0000','VPD FINANCEIRAS A APROPRIAR','COMPREENDE OS VALORES PAGOS, PENDENTES DE APROPRIAÇÃO COMO VPD FINANCEIRAS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.9.1.03.00.00.00.0000','ASSINATURAS E ANUIDADES A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES, PENDENTES DE APROPRIAÇÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.9.1.04.00.00.00.0000','ALUGUEIS PAGOS A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE ALUGUEL, PENDENTES DE APROPRIAÇÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.9.1.05.00.00.00.0000','TRIBUTOS PAGOS A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE TRIBUTOS, PENDENTES DE APROPRIAÇÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.9.1.06.00.00.00.0000','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE CONTRIBUIÇÕES CONFEDERATIVAS, PENDENTES DE APROPRIAÇÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.9.1.07.00.00.00.0000','BENEFÍCIOS A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE BENEFICIO A PESSOAL, PENDENTES DE APROPRIAÇÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.1.9.1.99.00.00.00.0000','DEMAIS VPD A APROPRIAR','COMPREENDE OS DEMAIS VALORES PAGOS A APROPRIAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.0.0.00.00.00.00.0000','INVESTIMENTOS','COMPREENDE AS PARTICIPAÇÕES PERMANENTES EM OUTRAS SOCIEDADES, BEM COMO OS BENS E DIREITOS NÃO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO E QUE NÃO SE DESTINEM A MANUTENCAO DA ATIVIDADE DA ENTIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.0.00.00.00.00.0000','PARTICIPAÇÕES PERMANENTES','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.00.00.00.00.0000','PARTICIPAÇÕES PERMANENTES - CONSOLIDAÇÃO','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.01.00.00.00.0000','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.01.01.00.00.0000','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM SOCIEDADES CONTROLADAS, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.01.02.00.00.0000','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM SOCIEDADES CONTROLADAS EM CONJUNTO, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.01.03.00.00.0000','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM SOCIEDADES COLIGADAS, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.01.04.00.00.0000','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','REGISTRA A DIFERENÇA ENTRE O VALOR DO PERCENTUAL ADQUIRIDO DO VALOR JUSTO DOS ATIVOS LÍQUIDOS DA INVESTIDA E O VALOR DO PERCENTUAL ADQUIRIDO DO VALOR DO PATRIMÔNIO LÍQUIDO DA INVESTIDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.01.05.00.00.0000','ÁGIO SOBRE OS INVESTIMENTOS','REGISTRA A DIFERENÇA ENTRE O VALOR PAGO PELA PARTICIPAÇÃO ADQUIRIDA E O VALOR DO PERCENTUAL ADQUIRIDO DO VALOR JUSTO DOS ATIVOS LÍQUIDOS DA INVESTIDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.01.06.00.00.0000','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','REGISTRA OS VALORES REPASSADOS PELO ENTE, DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.01.07.00.00.0000','PARTICIPAÇÕES EM CONSORCIOS PÚBLICOS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM CONSORCIOS PÚBLICOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.01.08.00.00.0000','PARTICIPAÇÃO EM FUNDOS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM FUNDOS, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.01.09.00.00.0000','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM OUTRAS SOCIEDADES, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.01.95.00.00.0000','OUTRAS PARTICIPAÇÕES - MEP','REGISTRA OS VALORES DE OUTRAS PARTICIPAÇÕES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL (MEP)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.01.96.00.00.0000','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.01.97.00.00.0000','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.01.98.00.00.0000','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.01.99.00.00.0000','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - AMORTIZAÇÃO DE DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.02.00.00.00.0000','PARTICIPAÇÕES AVALIADAS PELO METODO DE CUSTO','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.02.01.00.00.0000','PARTICIPAÇÕES EM EMPRESAS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE AÇÕES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.02.03.00.00.0000','PARTICIPAÇÃO EM FUNDOS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM FUNDOS, AVALIADAS PELO CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.02.05.00.00.0000','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE CUSTO - PARTICIPAÇÃO EM ORGANISMOS INTERNACIONAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.02.06.00.00.0000','ADIANTAMENTO PARA AUMENTO DE CAPITAL','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE CUSTO - ADIANTAMENTO PARA AUMENTO DE CAPITAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.1.02.99.00.00.0000','OUTRAS PARTICIPAÇÕES - METODO DE CUSTO','REGISTRA OS VALORES DE OUTRAS PARTICIPAÇÕES AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.00.00.00.00.0000','PARTICIPAÇÕES PERMANENTES - INTRA OFSS','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA ENTIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS.COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.01.00.00.00.0000','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALENCIA PATRIMONIAL','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.01.01.00.00.0000','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM SOCIEDADES CONTROLADAS, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.01.02.00.00.0000','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM SOCIEDADES CONTROLADAS EM CONJUNTO, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.01.03.00.00.0000','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM SOCIEDADES COLIGADAS, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.01.04.00.00.0000','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','REGISTRA A DIFERENÇA ENTRE O VALOR DO PERCENTUAL ADQUIRIDO DO VALOR JUSTO DOS ATIVOS LÍQUIDOS DA INVESTIDA E O VALOR DO PERCENTUAL ADQUIRIDO DO VALOR DO PATRIMÔNIO LÍQUIDO DA INVESTIDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.01.05.00.00.0000','ÁGIO SOBRE OS INVESTIMENTOS','REGISTRA A DIFERENÇA ENTRE O VALOR PAGO PELA PARTICIPAÇÃO ADQUIRIDA E O VALOR DO PERCENTUAL ADQUIRIDO DO VALOR JUSTO DOS ATIVOS LÍQUIDOS DA INVESTIDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.01.06.00.00.0000','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','REGISTRA OS VALORES REPASSADOS PELO ENTE, DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.01.07.00.00.0000','PARTICIPAÇÕES EM CONSORCIOS PÚBLICOS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM CONSORCIOS PÚBLICOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.01.08.00.00.0000','PARTICIPAÇÃO EM FUNDOS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM FUNDOS, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.01.09.00.00.0000','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM OUTRAS SOCIEDADES, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.01.95.00.00.0000','OUTRAS PARTICIPAÇÕES - MEP','REGISTRA OS VALORES DE OUTRAS PARTICIPAÇÕES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL (MEP)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.01.96.00.00.0000','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.01.97.00.00.0000','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.01.98.00.00.0000','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.01.99.00.00.0000','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - AMORTIZAÇÃO DE DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.02.00.00.00.0000','PARTICIPAÇÕES AVALIADAS PELO METODO DE CUSTO','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.02.01.00.00.0000','PARTICIPAÇÕES EM EMPRESAS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE AÇÕES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.02.03.00.00.0000','PARTICIPAÇÃO EM FUNDOS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM FUNDOS, AVALIADAS PELO CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.02.05.00.00.0000','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE CUSTO - PARTICIPAÇÃO EM ORGANISMOS INTERNACIONAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.02.06.00.00.0000','ADIANTAMENTO PARA AUMENTO DE CAPITAL','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE CUSTO - ADIANTAMENTO PARA AUMENTO DE CAPITAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.2.02.99.00.00.0000','OUTRAS PARTICIPAÇÕES - METODO DE CUSTO','REGISTRA OS VALORES DE OUTRAS PARTICIPAÇÕES AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.00.00.00.00.0000','PARTICIPAÇÕES PERMANENTES - INTER OFSS - UNIÃO','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA ENTIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.01.00.00.00.0000','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALENCIA PATRIMONIAL','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.01.01.00.00.0000','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM SOCIEDADES CONTROLADAS, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.01.02.00.00.0000','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM SOCIEDADES CONTROLADAS EM CONJUNTO, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.01.03.00.00.0000','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM SOCIEDADES COLIGADAS, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.01.04.00.00.0000','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','REGISTRA A DIFERENÇA ENTRE O VALOR DO PERCENTUAL ADQUIRIDO DO VALOR JUSTO DOS ATIVOS LÍQUIDOS DA INVESTIDA E O VALOR DO PERCENTUAL ADQUIRIDO DO VALOR DO PATRIMÔNIO LÍQUIDO DA INVESTIDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.01.05.00.00.0000','ÁGIO SOBRE OS INVESTIMENTOS','REGISTRA A DIFERENÇA ENTRE O VALOR PAGO PELA PARTICIPAÇÃO ADQUIRIDA E O VALOR DO PERCENTUAL ADQUIRIDO DO VALOR JUSTO DOS ATIVOS LÍQUIDOS DA INVESTIDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.01.06.00.00.0000','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','REGISTRA OS VALORES REPASSADOS PELO ENTE, DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.01.07.00.00.0000','PARTICIPAÇÕES EM CONSORCIOS PÚBLICOS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM CONSORCIOS PÚBLICOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.01.08.00.00.0000','PARTICIPAÇÃO EM FUNDOS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM FUNDOS, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.01.09.00.00.0000','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM OUTRAS SOCIEDADES, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.01.95.00.00.0000','OUTRAS PARTICIPAÇÕES - MEP','REGISTRA OS VALORES DE OUTRAS PARTICIPAÇÕES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL (MEP)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.01.96.00.00.0000','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.01.97.00.00.0000','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.01.98.00.00.0000','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.01.99.00.00.0000','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - AMORTIZAÇÃO DE DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.02.00.00.00.0000','PARTICIPAÇÕES AVALIADAS PELO METODO DE CUSTO','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.02.01.00.00.0000','PARTICIPAÇÕES EM EMPRESAS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE AÇÕES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.02.03.00.00.0000','PARTICIPAÇÃO EM FUNDOS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM FUNDOS, AVALIADAS PELO CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.02.05.00.00.0000','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE CUSTO - PARTICIPAÇÃO EM ORGANISMOS INTERNACIONAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.02.06.00.00.0000','ADIANTAMENTO PARA AUMENTO DE CAPITAL','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE CUSTO - ADIANTAMENTO PARA AUMENTO DE CAPITAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.3.02.99.00.00.0000','OUTRAS PARTICIPAÇÕES - METODO DE CUSTO','REGISTRA OS VALORES DE OUTRAS PARTICIPAÇÕES AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.00.00.00.00.0000','PARTICIPAÇÕES PERMANENTES - INTER OFSS - ESTADO','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA ENTIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.01.00.00.00.0000','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALENCIA PATRIMONIAL','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.01.01.00.00.0000','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM SOCIEDADES CONTROLADAS, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.01.02.00.00.0000','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM SOCIEDADES CONTROLADAS EM CONJUNTO, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.01.03.00.00.0000','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM SOCIEDADES COLIGADAS, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.01.04.00.00.0000','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','REGISTRA A DIFERENÇA ENTRE O VALOR DO PERCENTUAL ADQUIRIDO DO VALOR JUSTO DOS ATIVOS LÍQUIDOS DA INVESTIDA E O VALOR DO PERCENTUAL ADQUIRIDO DO VALOR DO PATRIMÔNIO LÍQUIDO DA INVESTIDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.01.05.00.00.0000','ÁGIO SOBRE OS INVESTIMENTOS','REGISTRA A DIFERENÇA ENTRE O VALOR PAGO PELA PARTICIPAÇÃO ADQUIRIDA E O VALOR DO PERCENTUAL ADQUIRIDO DO VALOR JUSTO DOS ATIVOS LÍQUIDOS DA INVESTIDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.01.06.00.00.0000','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','REGISTRA OS VALORES REPASSADOS PELO ENTE, DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.01.07.00.00.0000','PARTICIPAÇÕES EM CONSORCIOS PÚBLICOS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM CONSORCIOS PÚBLICOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.01.08.00.00.0000','PARTICIPAÇÃO EM FUNDOS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM FUNDOS, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.01.09.00.00.0000','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM OUTRAS SOCIEDADES, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.01.95.00.00.0000','OUTRAS PARTICIPAÇÕES - MEP','REGISTRA OS VALORES DE OUTRAS PARTICIPAÇÕES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL (MEP)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.01.96.00.00.0000','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.01.97.00.00.0000','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.01.98.00.00.0000','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.01.99.00.00.0000','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - AMORTIZAÇÃO DE DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.02.00.00.00.0000','PARTICIPAÇÕES AVALIADAS PELO METODO DE CUSTO','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.02.01.00.00.0000','PARTICIPAÇÕES EM EMPRESAS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE AÇÕES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.02.03.00.00.0000','PARTICIPAÇÃO EM FUNDOS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM FUNDOS, AVALIADAS PELO CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.02.05.00.00.0000','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE CUSTO - PARTICIPAÇÃO EM ORGANISMOS INTERNACIONAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.02.06.00.00.0000','ADIANTAMENTO PARA AUMENTO DE CAPITAL','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE CUSTO - ADIANTAMENTO PARA AUMENTO DE CAPITAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.4.02.99.00.00.0000','OUTRAS PARTICIPAÇÕES - METODO DE CUSTO','REGISTRA OS VALORES DE OUTRAS PARTICIPAÇÕES AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.00.00.00.00.0000','PARTICIPAÇÕES PERMANENTES - INTER OFSS - MUNICÍPIOS','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA ENTIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.01.00.00.00.0000','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALENCIA PATRIMONIAL','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.01.01.00.00.0000','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM SOCIEDADES CONTROLADAS, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.01.02.00.00.0000','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM SOCIEDADES CONTROLADAS EM CONJUNTO, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.01.03.00.00.0000','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM SOCIEDADES COLIGADAS, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.01.04.00.00.0000','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','REGISTRA A DIFERENÇA ENTRE O VALOR DO PERCENTUAL ADQUIRIDO DO VALOR JUSTO DOS ATIVOS LÍQUIDOS DA INVESTIDA E O VALOR DO PERCENTUAL ADQUIRIDO DO VALOR DO PATRIMÔNIO LÍQUIDO DA INVESTIDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.01.05.00.00.0000','ÁGIO SOBRE OS INVESTIMENTOS','REGISTRA A DIFERENÇA ENTRE O VALOR PAGO PELA PARTICIPAÇÃO ADQUIRIDA E O VALOR DO PERCENTUAL ADQUIRIDO DO VALOR JUSTO DOS ATIVOS LÍQUIDOS DA INVESTIDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.01.06.00.00.0000','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','REGISTRA OS VALORES REPASSADOS PELO ENTE, DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.01.07.00.00.0000','PARTICIPAÇÕES EM CONSORCIOS PÚBLICOS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM CONSORCIOS PÚBLICOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.01.08.00.00.0000','PARTICIPAÇÃO EM FUNDOS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM FUNDOS, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.01.09.00.00.0000','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM OUTRAS SOCIEDADES, AVALIADAS POR EQUIVALÊNCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.01.95.00.00.0000','OUTRAS PARTICIPAÇÕES - MEP','REGISTRA OS VALORES DE OUTRAS PARTICIPAÇÕES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL (MEP)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.01.96.00.00.0000','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.01.97.00.00.0000','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.01.98.00.00.0000','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.01.99.00.00.0000','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL - AMORTIZAÇÃO DE DESÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.02.00.00.00.0000','PARTICIPAÇÕES AVALIADAS PELO METODO DE CUSTO','COMPREENDE AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.02.01.00.00.0000','PARTICIPAÇÕES EM EMPRESAS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE AÇÕES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.02.03.00.00.0000','PARTICIPAÇÃO EM FUNDOS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DO ENTE EM FUNDOS, AVALIADAS PELO CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.02.05.00.00.0000','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE CUSTO - PARTICIPAÇÃO EM ORGANISMOS INTERNACIONAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.02.06.00.00.0000','ADIANTAMENTO PARA AUMENTO DE CAPITAL','REGISTRA AS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE CUSTO - ADIANTAMENTO PARA AUMENTO DE CAPITAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.1.5.02.99.00.00.0000','OUTRAS PARTICIPAÇÕES - METODO DE CUSTO','REGISTRA OS VALORES DE OUTRAS PARTICIPAÇÕES AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.2.0.00.00.00.00.0000','PROPRIEDADES PARA INVESTIMENTO','COMPREENDE A PROPRIEDADE (TERRENO OU EDIFÍCIO -OU PARTE DE EDIFÍCIO - OU AMBOS) MANTIDA (PELO PROPRIETÁRIO OU PELO ARRENDATÁRIO EM ARRENDAMENTO FINANCEIRO) PARA AUFERIR ALUGUEL OU PARA VALORIZAÇÃO DO CAPITAL OU PARA AMBAS, E NÃO PARA: USO NA PRODUÇÃO OU FORNECIMENTO DE BENS OU SERVIÇOS OU PARA FINALIDADES ADMINISTRATIVAS; OU VENDA NO CURSO ORDINÁRIO DO NEGÓCIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.2.1.00.00.00.00.0000','PROPRIEDADES PARA INVESTIMENTO - CONSOLIDAÇÃO','COMPREENDE A PROPRIEDADE (TERRENO OU EDIFÍCIO -OU PARTE DE EDIFÍCIO - OU AMBOS) MANTIDA (PELO PROPRIETÁRIO OU PELO ARRENDATÁRIO EM ARRENDAMENTO FINANCEIRO) PARA AUFERIR ALUGUEL OU PARA VALORIZAÇÃO DO CAPITAL OU PARA AMBAS, E NÃO PARA: USO NA PRODUÇÃO OU FORNECIMENTO DE BENS OU SERVIÇOS OU PARA FINALIDADES ADMINISTRATIVAS; OU VENDA NO CURSO ORDINÁRIO DO NEGÓCIO.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.2.1.01.00.00.00.0000','BENS IMÓVEIS PARA FUTURA UTILIZAÇÃO','REGISTRA OS VALORES DE IMOVEIS DA UNIDADE MANTIDOS PARA FUTURA UTILIZACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.2.1.01.01.00.00.0000','TERRENOS','REGISTRA OS TERRENOS DE PROPRIEDADE DO ENTE NÃO DESTINADOS AO USO DO MESMO NAS SUAS ATIVIDADES FINS, AVALIADOS PELO CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.2.1.01.02.00.00.0000','EDIFÍCIOS','REGISTRA OS EDIFÍCIOS OU PARTE DELES, OU CASAS, DE PROPRIEDADE DO ENTE NÃO DESTINADOS AO USO DO MESMO NAS SUAS ATIVIDADES FINS, AVALIADOS PELO CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.2.1.02.00.00.00.0000','BENS IMÓVEIS NÃO DESTINADOS A USO','REGISTRA OS VALORES DE IMOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.2.1.02.01.00.00.0000','TERRENOS','REGISTRA OS TERRENOS DE PROPRIEDADE DO ENTE NÃO DESTINADOS AO USO DO MESMO NAS SUAS ATIVIDADES FINS, AVALIADOS PELO CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.2.1.02.02.00.00.0000','EDIFÍCIOS','REGISTRA OS EDIFÍCIOS OU PARTE DELES, OU CASAS, DE PROPRIEDADE DO ENTE NÃO DESTINADOS AO USO DO MESMO NAS SUAS ATIVIDADES FINS, AVALIADOS PELO CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.2.1.99.00.00.00.0000','OUTRAS PROPRIEDADES PARA INVESTIMENTOS','REGISTRA AS OUTRAS PROPRIEDADES PARA INVESTIMENTOS NÃO ABRANGIDAS NAS CONTAS ANTERIORES, AVALIADAS PELO MÉTODO DO CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.3.0.00.00.00.00.0000','INVESTIMENTOS DO RPPS DE LONGO PRAZO','COMPREENDE OS INVESTIMENTOS REALIZADOS PELO REGIME PRÓPRIO DA PREVIDÊNCIA SOCIAL, EM CONFORMIDADE COM A LEGISLAÇÃO QUE TRATA DAS APLICAÇÕES E INVESTIMENTOS DOS RPPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.3.1.00.00.00.00.0000','INVESTIMENTOS DO RPPS DE LONGO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS INVESTIMENTOS REALIZADOS PELO REGIME PRÓPRIO DA PREVIDÊNCIA SOCIAL, EM CONFORMIDADE COM A LEGISLAÇÃO QUE TRATA DAS APLICAÇÕES E INVESTIMENTOS DOS RPPS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.3.1.01.00.00.00.0000','TÍTULOS E VALORES MOBILIÁRIOS – RPPS','COMPREENDE OS INVESTIMENTOS REALIZADOS PELO REGIME PRÓPRIO DA PREVIDÊNCIA SOCIAL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.3.1.01.01.00.00.0000','APLICAÇÕES EM ATIVOS EM ENQUADRAMENTO – TÍTULOS E VALORES','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM DESACORDO COM AS REGRAS ESTABELECIDAS PELA RESOLUCAO CMN Nº 3790/2009, ARTIGO 25.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.3.1.01.02.00.00.0000','APLICAÇÕES EM ATIVOS NÃO SUJEITOS À RESOLUÇÃO DO CMN – TÍTULOS E VALORES','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM ATIVOS NÃO SUJEITOS AS REGRAS DA RESOLUCAO CMN Nº 3790/2009.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.3.1.02.00.00.00.0000','APLICAÇÕES EM SEGMENTO DE IMÓVEIS – RPPS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, NO SEGMENTO DE IMÓVEIS EFETUADOS EM CONFORMIDADE COM O ART. 8º DA RESOLUCAO CMN N° 3.790/2009.','','N','','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.3.1.02.01.00.00.0000','IMÓVEIS – RPPS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM IMÓVEIS SUJEITOS AS REGRAS DA RESOLUCAO CMN Nº 3790/2009.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.7.0.00.00.00.00.0000','DEMAIS INVESTIMENTOS PERMANENTES','COMPREENDE OS DEMAIS DIREITOS DE QUALQUER NATUREZA NÃO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO E QUE NÃO SE DESTINEM A MANUTENCAO DAS ATIVIDADES DA ENTIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.7.1.00.00.00.00.0000','DEMAIS INVESTIMENTOS PERMANENTES - CONSOLIDAÇÃO','COMPREENDE OS DEMAIS DIREITOS DE QUALQUER NATUREZA NÃO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO E QUE NÃO SE DESTINEM A MANUTENCAO DAS ATIVIDADES DA ENTIDADE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.7.1.01.00.00.00.0000','OBRAS DE ARTE','REGISTRA OS VALORES REFERENTES A OBRAS DE ARTE DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.7.1.03.00.00.00.0000','BENS MOVEIS NÃO DESTINADOS A USO','REGISTRA OS VALORES DE MOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.7.1.05.00.00.00.0000','BENS INTANGIVEIS NÃO DESTINADOS A USO','REGISTRA O VALOR DE BENS INTANGIVEIS NÃO DESTINADOS AO USO E QUE A UNIDADE NÃO EXPLORA COMERCIALMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.7.1.06.00.00.00.0000','TÍTULOS E VALORES MOBILIÁRIOS PERMANENTES','REGISTRA O VALOR DOS TÍTULOS E VALORES MOBILIÁRIOS NÃO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZÁVEL A LONGO PRAZO, COMO POR EXEMPLO AS DEBENTURES (PERPETUAS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.7.1.99.00.00.00.0000','DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA O VALOR DE INVESTIMENTOS PERMANENTES, NÃO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.8.0.00.00.00.00.0000','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS','COMPREENDE A DIMINUIÇÃO DO VALOR DOS ELEMENTOS DO ATIVO INVESTIMENTO DEVIDO A DESGASTES PELO USO, AÇÃO DA NATUREZA OU OBSOLÊNCIA, QUANDO COUBER, COMO A DEPRECIAÇÃO DAS PROPRIEDADES MANTIDAS PARA INVESTIMENTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.8.1.00.00.00.00.0000','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS - CONSOLIDAÇÃO','COMPREENDE A DIMINUIÇÃO DO VALOR DOS ELEMENTOS DO ATIVO INVESTIMENTO DEVIDO A DESGASTES PELO USO, AÇÃO DA NATUREZA OU OBSOLÊNCIA, QUANDO COUBER, COMO A DEPRECIAÇÃO DAS PROPRIEDADES MANTIDAS PARA INVESTIMENTO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.8.1.01.00.00.00.0000','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS – CONSOLIDAÇÃO - PROPRIEDADES PARA INVESTIMENTO','REGISTRA A DIMINUIÇÃO DO VALOR DOS ELEMENTOS DO ATIVO INVESTIMENTO DEVIDO A DESGASTES PELO USO, AÇÃO DA NATUREZA OU OBSOLÊNCIA, QUANDO COUBER, COMO A DEPRECIAÇÃO DAS PROPRIEDADES MANTIDAS PARA INVESTIMENTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.8.1.01.01.00.00.0000','DEPRECIAÇÃO ACUMULADA DE BENS IMÓVEIS PARA FUTURA UTILIZAÇÃO','COMPREENDE A DIMINUIÇÃO DO VALOR DOS ELEMENTOS DO ATIVO INVESTIMENTO DEVIDO A DESGASTE PELO USO, AÇÃO DA NATUREZA OU OBSOLESCÊNCIA, QUANDO COUBER, DOS VALORES DE IMOVEIS DA UNIDADE MANTIDOS PARA FUTURA UTILIZACAO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.8.1.01.02.00.00.0000','DEPRECIAÇÃO ACUMULADA DE BENS IMOVEIS NÃO DESTINADOS A USO','COMPREENDE A DIMINUIÇÃO DO VALOR DOS ELEMENTOS DO ATIVO INVESTIMENTO DEVIDO A DESGASTE PELO USO, AÇÃO DA NATUREZA OU OBSOLESCÊNCIA, QUANDO COUBER, DOS VALORES DE IMOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.8.1.01.03.00.00.0000','DEPRECIAÇÃO ACUMULADA OUTRAS PROPRIEDADES PARA INVESTIMENTOS','COMPREENDE A DIMINUIÇÃO DO VALOR DOS ELEMENTOS DO ATIVO INVESTIMENTO DEVIDO A DESGASTE PELO USO, AÇÃO DA NATUREZA OU OBSOLESCÊNCIA, QUANDO COUBER, DAS OUTRAS PROPRIEDADES MANTIDAS PARA INVESTIMENTO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.0.00.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.1.00.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.1.01.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE PARTICIPAÇÕES PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.1.01.01.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','REGISTRA O VALOR DA REDUÇÃO AO VALOR RECUPERÁVEL DAS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.1.01.02.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','REGISTRA O VALOR DA REDUÇÃO AO VALOR RECUPERÁVEL DAS PARTICIPAÇÕES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE AÇÕES OU COTAS, AVALIADAS PELO MÉTODO DE CUSTO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.1.02.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE PROPRIEDADES PARA INVESTIMENTOS','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE PROPRIEDADES PARA INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.1.02.01.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE BENS IMÓVEIS PARA FUTURA UTILIZAÇÃO','REGISTRA O VALOR DA REDUÇÃO AO VALOR RECUPERÁVEL DE IMÓVEIS DA UNIDADE MANTIDOS PARA FUTURA UTILIZAÇÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.1.02.02.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE BENS IMOVEIS NÃO DESTINADOS A USO','REGISTRA O VALOR DA REDUÇÃO AO VALOR RECUPERÁVEL DE IMÓVEIS DA UNIDADE MANTIDOS PARA GERAÇÃO DE RENDA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.1.03.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS DO RPPS','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS DO RPPS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.1.04.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE DEMAIS INVESTIMENTOS PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.2.00.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS -INTRA OFSS','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.2.01.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE PARTICIPAÇÕES PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.2.04.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE DEMAIS INVESTIMENTOS PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.3.00.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS -INTER OFSS - UNIÃO','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.3.01.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE PARTICIPAÇÕES PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.3.04.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE DEMAIS INVESTIMENTOS PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.4.00.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS -INTER OFSS - ESTADO','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.4.01.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE PARTICIPAÇÕES PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.4.04.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE DEMAIS INVESTIMENTOS PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.5.00.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS -INTER OFSS - MUNICÍPIOS','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.5.01.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE PARTICIPAÇÕES PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.2.9.5.04.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE DEMAIS INVESTIMENTOS PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.0.0.00.00.00.00.0000','IMOBILIZADO','COMPREENDE OS DIREITOS QUE TENHAM POR OBJETO BENS CORPOREOS DESTINADOS A MANUTENCAO DAS ATIVIDADES DA ENTIDADE OU EXERCIDOS COM ESSA FINALIDADE, INCLUSIVE OS DECORRENTES DE OPERAÇÕES QUE TRANSFIRAM A ELA OS BENEFÍCIOS, OS RISCOS E O CONTROLE DESSES BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.0.00.00.00.00.0000','BENS MÓVEIS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORAÇÃO DE BENS CORPOREOS, QUE TEM EXISTENCIA MATERIAL E QUE PODEM SER TRANSPORTADOS POR MOVIMENTO PROPRIO OU REMOVIDOS POR FORCA ALHEIA SEM ALTERAÇÃO DA SUBSTANCIA OU DA DESTINAÇÃO ECONOMICO-SOCIAL, QUE CONSTITUAM MEIO PARA A PRODUCAO DE OUTROS BENS OU SERVIÇOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.00.00.00.00.0000','BENS MÓVEIS- CONSOLIDAÇÃO','COMPREENDE O VALOR DA AQUISICAO OU INCORPORAÇÃO DE BENS CORPOREOS, QUE TEM EXISTENCIA MATERIAL E QUE PODEM SER TRANSPORTADOS POR MOVIMENTO PROPRIO OU REMOVIDOS POR FORCA ALHEIA SEM ALTERAÇÃO DA SUBSTANCIA OU DA DESTINAÇÃO ECONOMICO-SOCIAL, QUE CONSTITUAM MEIO PARA A PRODUCAO DE OUTROS BENS OU SERVIÇOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.00.00.00.0000','MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORAÇÃO DE MAQUINAS, FERRAMENTAS, APARELHOS, EQUIPAMENTOS, ACESSORIOS, ETC.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.01.00.00.0000','APARELHOS DE MEDICAO E ORIENTAÇÃO','REGISTRA OS APARELHOS UTILIZADOS PARA MEDICAO E ORIENTAÇÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.02.00.00.0000','APARELHOS E EQUIPAMENTOS DE COMUNICAÇÃO','REGISTRA OS APARELHOS E EQUIPAMENTOS UTILIZADOS PARA COMUNICAÇÃO','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.03.00.00.0000','APARELHOS, EQUIPAMENTOS E UTENSILIOS MEDICOS, ODONTOLOGICOS, LABORATORIAIS E HOSPITALARES','REGISTRA OS APARELHOS, EQUIPAMENTOS E UTENSILIOS PARA USO MEDICO, ODONTOLOGICO, LABORATORIAL E HOSPITALAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.04.00.00.0000','APARELHOS E EQUIPAMENTOS PARA ESPORTES E DIVERSOES','REGISTRA OS APARELHOS E EQUIPAMENTOS UTILIZADOS PARA MODALIDADES DE ESPORTES E DIVERSOES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.05.00.00.0000','EQUIPAMENTO DE PROTECAO, SEGURANCA E SOCORRO','REGISTRA OS EQUIPAMENTOS UTILIZAÇÕES PARA PROTECAO, SEGURANCA E SOCORRO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.06.00.00.0000','MAQUINAS E EQUIPAMENTOS INDUSTRIAIS','REGISTRA AS MAQUINAS E EQUIPAMENTOS DE NATUREZA INDUSTRIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.07.00.00.0000','MAQUINAS E EQUIPAMENTOS ENERGETICOS','REGISTRA AS MAQUINAS E EQUIPAMENTOS ENERGETICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.08.00.00.0000','MAQUINAS E EQUIPAMENTOS GRAFICOS','REGISTRA AS MAQUINAS E EQUIPAMENTOS EMPREGADOS NA INDUSTRIA GRAFICA OU NECESSARIOS PARA SUA INDUSTRIALIZAÇÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.09.00.00.0000','MAQUINAS, FERRAMENTAS E UTENSILIOS DE OFICINA','REGISTRA AS MAQUINAS, FERRAMENTAS E UTENSILIOS UTILIZADOS EM OFICINAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.12.00.00.0000','EQUIPAMENTOS, PECAS E ACESSORIOS PARA AUTOMÓVEIS','REGISTRA OS EQUIPAMENTOS, PECAS E ACESSORIOS PARA AUTOMÓVEIS QUE PODEM SER DESINCORPORADOS, SEM PREJUIZO DOS MESMOS, PARA APLICAÇÃO EM OUTRO VEICULO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.13.00.00.0000','EQUIPAMENTOS, PECAS E ACESSORIOS MARITIMOS','REGISTRA OS EQUIPAMENTOS, PECAS E ACESSORIOS MARITIMOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.16.00.00.0000','EQUIPAMENTOS DE MERGULHO E SALVAMENTO','REGISTRA OS EQUIPAMENTOS DE MERGULHO E SALVAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.20.00.00.0000','MAQUINAS, EQUIPAMENTOS E UTENSILIOS AGROPECUARIOS E RODOVIARIOS','REGISTRA OS VALORES RELATIVOS A MAQUINAS, EQUIPAMENTOS, FERRAMENTAS E UTENSILIOS AGROPECUARIOS E REDOVIARIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.21.00.00.0000','EQUIPAMENTOS HIDRAULICOS E ELETRICOS','REGISTRA OS EQUIPAMENTOS HIDRAULICOS E ELETRICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.22.00.00.0000','EQUIPAMENTOS E MATERIAIS PERMANENTES VINCULADOS A CONVÊNIO','REGISTRA OS EQUIPAMENTOS E MATERIAIS PERMANENTES VINCULADOS A CONVÊNIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.30.00.00.0000','MATERIAL DE USO DURADOURO','REGISTRA OS VALORES RELATIVOS AOS MATERIAIS DE CONSUMO QUE DEVIDOASUA DURABILIDADE E NATUREZA DEVEM COMPOR O ATIVO DA ENTIDADE.O CONTROLE PATRIMONIAL DOS BENS REGISTRADOS NESTA CONTA DEVERA SER SIMPLIFICADO, POR MEIO DE RELACAO DO MATERIAL (RELACAO-CARGA) E/OU VE-RIFICACAO PERIODICA DA QUANTIDADE DE ITENS REQUISITADOS, DEVIDO ASUA DURABILIDADE E CARACTERISTICAS PROPRIAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.40.00.00.0000','PECAS NAO INCORPORAVEIS A IMOVEIS','REGISTRA OS VALORES RELATIVOS A AQUISICAO DE PECAS NAO INCORPORAVEIS A IMOVEIS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.01.99.00.00.0000','OUTRAS MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','REGISTRA OS VALORES REFERENTES A MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS NÃO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.02.00.00.00.0000','BENS DE INFORMATICA','COMPREENDE O VALOR DA AQUISICAO OU INCORPORAÇÃO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E SISTEMAS APLICATIVOS, ENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.02.01.00.00.0000','EQUIPAMENTOS DE PROCESSAMENTO DE DADOS','REGISTRA OS EQUIPAMENTOS DE PROCESSAMENTO DE DADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.02.02.00.00.0000','EQUIPAMENTOS DE TECNOLOGIA DA INFORMAÇÃO','REGISTRA OS EQUIPAMENTOS RELACIONADOS COM TECNOLOGIA DA INFORMAÇÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.03.00.00.00.0000','MÓVEIS E UTENSILIOS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORAÇÃO DE MOBILIARIO EM GERAL E UTENSILIOS, ENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.03.01.00.00.0000','APARELHOS E UTENSILIOS DOMESTICOS','REGISTRA OS OBJETOS OU PECAS DE USO CASEIRO OU NECESSARIOS A VIDA FAMILIAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.03.02.00.00.0000','MAQUINAS E UTENSILIOS DE ESCRITORIO','REGISTRA AS MAQUINAS E UTENSILIOS DE ESCRITORIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.03.03.00.00.0000','MOBILIARIO EM GERAL','REGISTRA OS VALORES RELATIVOS AOS BENS MÓVEIS, DE CARATER GERAL, EM USO NA UNIDADE, NÃO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.03.04.00.00.0000','UTENSILIOS EM GERAL','REGISTRA OS VALORES RELATIVOS A UTENSILIOS, DE CARATER GERAL, EM USO NA UNIDADE, NÃO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.04.00.00.00.0000','MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','COMPREENDE O VALOR DA AQUISICAO OU INCORPORAÇÃO DE MATERIAIS BIBLIOGRAFICOS, DISCOTECAS, FILMOTECAS, DE COMUNICAÇÃO, ENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.04.01.00.00.0000','BANDEIRAS, FLAMULAS E INSIGNIAS','REGISTRA OS VALORES RELATIVOS A BANDEIRAS, FLAMULAS E INSIGNIAS, GERALMENTE UTILIZADAS COMO DISTINTIVO DA NAÇÃO E DE CORPORAÇÕES, PEQUENAS CHAMAS, ADORNOS, SINAL DISTINTIVO, EMBLEMAS, ESTANDARTES E OUTROS SIMBOLOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.04.02.00.00.0000','COLECOES E MATERIAIS BIBLIOGRAFICOS','REGISTRA OS VALORES RELATIVOS AOS OBJETOS E MATERIAIS BIBLIOGRAFICOS DESTINADOS A REUNIR, GERALMENTE, PARA FORMAÇÃO DE BIBLIOTECAS DE USO DA UNIDADE OU CUMPRIR OBJETIVOS DESSA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.04.03.00.00.0000','DISCOTECAS E FILMOTECAS','REGISTRA OS VALORES RELATIVOS A DISCOS, CDS E COLECOES DE FITAS GRAVADAS COM MUSICAS E FITAS CINEMATOGRAFICAS DE CARATER EDUCATIVO, CIENTIFICO E INFORMATIVO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.04.04.00.00.0000','INSTRUMENTOS MUSICAIS E ARTISTICOS','REGISTRA OS VALORES RELATIVOS AOS INSTRUMENTOS MUSICAIS E ARTISTICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.04.05.00.00.0000','EQUIPAMENTOS PARA AUDIO, VIDEO E FOTO','REGISTRA OS VALORES DE EQUIPAMENTOS DE AUDIO, VIDEO E FOTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.04.06.00.00.0000','OBRAS DE ARTE E PECAS PARA EXPOSICAO','REGISTRA OS VALORES RELATIVOS A OBRAS E OBJETOS DE ARTE E DE PECAS PARA DECORAÇÃO OU EXPOSICAO EM GERAL EM MUSEUS, GALERIAS, HALLS, PREDIOS PÚBLICOS E OUTROS, DESDE QUE SE DESTINEM A MANUTENCAO DE SUA ATIVIDADE, CASO CONTRARIO, DEVE SER CLASSIFICADO COMO INVESTIMENTOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.04.99.00.00.0000','OUTROS MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','REGISTRA OS VALORES REFERENTES A MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO NÃO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.05.00.00.00.0000','VEICULOS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORAÇÃO DE MEIOS DE TRANSPORTES AEREOS, AQUATICOS E TERRESTRES, ENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.05.01.00.00.0000','VEICULOS EM GERAL','REGISTRA OS VEICULOS DE DIVERSOS TIPOS, NÃO MOTORIZADOS, PARA OS QUAIS NÃO TENHAM SIDO CRIADAS CONTAS ESPECIFICAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.05.03.00.00.0000','VEICULOS DE TRAÇÃO MECANICA','REGISTRA OS VEICULOS DE TRAÇÃO MECANICA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.06.00.00.00.0000','PECAS E CONJUNTOS DE REPOSICAO','REGISTRA O VALOR DA AQUISICAO OU INCORPORAÇÃO DE PECAS E CONJUNTOS DE REPOSICAO DESTINADOS A SUBSTITUICAO EM MAQUINAS E EQUIPAMENTOS, AERONAVES E EMBARCAÇÕES, BENS DE SEGURANCA E SOCORRO, ENTRE OUTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.07.00.00.00.0000','BENS MOVEIS EM ANDAMENTO','COMPREENDE OS VALORES DE BENS MOVEIS EM ANDAMENTO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.07.01.00.00.0000','BENS MOVEIS EM ELABORAÇÃO','REGISTRA OS VALORES RELATIVOS A TODOS OS GASTOS OCORRIDOS COM BENS MOVEIS EM FASE DE ELABORACAO E ACABAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.07.02.00.00.0000','IMPORTAÇÕES EM ANDAMENTO','REGISTRA OS VALORES RELATIVOS A TODOS OS GASTOS COM IMPORTAÇÕES EM ANDAMENTO DE EQUIPAMENTOS, MAQUINAS, APARELHOS E OUTROS BENS MOVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.08.00.00.00.0000','BENS MÓVEIS EM ALMOXARIFADO','COMPREENDE OS VALORES DE BENS PERMANENTES A SEREM ESTOCADOS EM ALMOXARIFADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.08.01.00.00.0000','ESTOQUE INTERNO','REGISTRA OS VALORES DOS BENS MÓVEIS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADO, DESTINADOS A ATENDER AS NECESSIDADES DOS ORGÃOS ADQUIRENTES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.08.03.00.00.0000','BENS MÓVEIS A REPARAR','REGISTRA OS VALORES DOS BENS MOVEIS A REPARAR ESTOCADOS EM ALMOXARIFADO','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.08.04.00.00.0000','BENS MÓVEIS EM REPARO','REGISTRA OS VALORES DOS BENS MOVEIS EM REPARO ESTOCADOS EM ALMOXARIFADO','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.08.05.00.00.0000','BENS MOVEIS INSERVIVEIS','REGISTRA OS VALORES DOS BENS MOVEIS INSERVIVEIS EM ALMOXARIFADO, QUE DEPENDEM DE PARECER DA COMISSAO E HOMOLOGACAO DA AUTORIDADE COMPETENTE PARA SEREM DESCARREGADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.10.00.00.00.0000','SEMOVENTES','REGISTRA OS VALORES RELATIVOS AOS ANIMAIS DESTINADOS A PRODUCAO, REPRODUCAO, ENGORDA E AOS SERVIÇOS UTILITARIOS EM GERAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.99.00.00.00.0000','DEMAIS BENS MÓVEIS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORAÇÃO DOS DEMAIS BENS MÓVEIS NÃO CLASSIFICADOS EM GRUPOS ESPECIFICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.1.1.99.99.00.00.0000','OUTROS BENS MÓVEIS','REGISTRA O VALOR DA AQUISICAO OU INCORPORACAO DOS OUTROS BENS MOVEIS NÃO CLASSIFICADOS ANTERIORMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.0.00.00.00.00.0000','BENS IMÓVEIS','COMPREENDE O VALOR DOS BENS IMÓVEIS, OS QUAIS SAO BENS VINCULADOS AO SOLO E QUE NÃO PODEM SER RETIRADOS SEM DESTRUICAO OU DANO, DESTINADOS AO USO E QUE A ENTIDADE NÃO ESTEJA EXPLORANDO COMERCIALMENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.00.00.00.00.0000','BENS IMÓVEIS- CONSOLIDAÇÃO','COMPREENDE O VALOR DOS BENS IMÓVEIS, OS QUAIS SAO BENS VINCULADOS AO SOLO E QUE NÃO PODEM SER RETIRADOS SEM DESTRUICAO OU DANO, DESTINADOS AO USO E QUE A ENTIDADE NÃO ESTEJA EXPLORANDO COMERCIALMENTE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.00.00.00.0000','BENS DE USO ESPECIAL','COMPREENDE OS BENS, TAIS COMO EDIFICIOS OU TERRENOS DESTINADOS A SERVICO OU ESTABELECIMENTO DA ADMINISTRACAO DIRETA MUNICIPAL, INCLUSIVE OS DE SUAS AUTARQUIAS E FUNDACOES PUBLICAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.01.00.00.0000','IMÓVEIS RESIDENCIAIS/COMERCIAIS','REGISTRA OS SEGUINTES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE : APARTAMENTOS; CASAS; RESIDENCIAS; CONJUNTOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.02.00.00.0000','EDIFICIOS','REGISTRA OS VALORES RELATIVOS AOS PREDIOS EDIFICADOS, DE PROPRIEDADE DA ENTIDADE, LOCALIZADOS EM AREAS URBANAS E RURAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.03.00.00.0000','TERRENOS/GLEBAS','REGISTRA OS VALORES PERTINENTES AS PROPRIEDADES AGRICOLAS CONSTITUINDO GLEBAS E FAZENDAS, REGISTRADAS EM CARTORIO E OU TITULADAS, DE PROPRIEDADE DA UNIDADE, RESERVADAS OU NAO A EXPLORACAO AGROPECUARIA E REGISTRA OS VALORES RELATIVOS AOS TERRENOS DE PROPRIEDADE DA ENTIDADE, LOCALIZADOS EM AREAS URBANAS E RURAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.04.00.00.0000','ARMAZENS/GALPOES/SILOS','REGISTRA OS SEGUINTES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: ARMAZENS; GALPOES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.07.00.00.0000','IMOVEIS DE USO EDUCACIONAL','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL TAIS COMO: ESCOLAS; FACULDADES; UNIVERSIDADES; BIBLIOTECAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.08.00.00.0000','REPRESAS/ACUDES','REGISTRA OS SEGUINTES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: AÇUDES; REPRESAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.09.00.00.0000','FAZENDAS, PARQUES E RESERVAS','RREGISTRA OS SEGUINTES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: FAZENDAS; PARQUES; RESERVAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.10.00.00.0000','IMOVEIS DE USO RECREATIVO','REGISTRA OS SEGUINTES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: CLUBES; ESTADIOS; GINÁSIOS; TEATROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.16.00.00.0000','HOSPITAIS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL TAIS COMO HOSPITAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.19.00.00.0000','PORTOS/ESTALEIROS','REGISTRA OS SEGUINES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: ESTALEIROS; PORTOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.20.00.00.0000','COMPLEXOS/FABRICAS/USINAS','RREGISTRA OS SEGUINES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: FABRICAS; USINAS; COMPLEXOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.21.00.00.0000','CEMITERIOS','RREGISTRA OS SEGUINES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: CEMITERIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.22.00.00.0000','ESTACIONAMENTOS E GARAGENS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL TAIS COMO ESTACIONAMENTOS. TAMBEM DEVEM SER REGISTRADOS NESTA CONTA AS GARAGENS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.23.00.00.0000','LOJAS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL TAIS COMO LOJAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.24.00.00.0000','SALAS E ESCRITORIOS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL TAIS COMO SALAS E ESCRITORIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.02.98.00.00.0000','OUTROS BENS IMÓVEIS DE USO ESPECIAL','REGISTRA OUTROS OS BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.00.00.00.0000','BENS DOMINICAIS','COMPREENDE OS BENS QUE CONSTITUEM O PATRIMONIO DAS PESSOAS JURIDICAS DE DIREITO PÚBLICO, COMO OBJETO DE DIREITO PESSOAL, OU REAL, DE CADA UMA DESSAS ENTIDADES. COMPREENDE AINDA, NÃO DISPONDO A LEI EM CONTRARIO, OS BENS PERTENCENTES AS PESSOAS JURIDICAS DE DIREITO PÚBLICO A QUE SE TENHA DADO ESTRUTURA DE DIREITO PRIVADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.01.00.00.0000','EDIFICIOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS : EDIFICIOS/PREDIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.02.00.00.0000','APARTAMENTOS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS DOS SEGUINTES BENS IMOVEIS DOMINIAIS :APARTAMENTOS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.03.00.00.0000','ARMAZENS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS DOS SEGUINTES BENS IMOVEIS DOMINIAIS: ARMAZENS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.04.00.00.0000','CASAS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS DOS SEGUINTES BENS IMOVEIS DOMINIAIS: CASAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.05.00.00.0000','CEMITERIOS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS DOS SEGUINTES BENS IMOVEIS DOMINIAIS: CEMITERIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.07.00.00.0000','GARAGENS E ESTACIONAMENTOS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS DOS SEGUINTES BENS IMOVEIS DOMINIAIS: GARAGENS E ESTACIONAMENTOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.08.00.00.0000','FAZENDAS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS DOS SEGUINTES BENS IMOVEIS DOMINIAIS: FAZENDAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.09.00.00.0000','GALPOES','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS DOS SEGUINTES BENS IMOVEIS DOMINIAIS: GALPÕES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.10.00.00.0000','GLEBAS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS DOS SEGUINTES BENS IMOVEIS DOMINIAIS: GLEBAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.11.00.00.0000','LOJAS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS DOS SEGUINTES BENS IMOVEIS DOMINIAIS: LOJAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.12.00.00.0000','SALAS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS DOS SEGUINTES BENS IMOVEIS DOMINIAIS: SALAS E ESCRITÓRIOS..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.13.00.00.0000','TERRENOS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS DOS SEGUINTES BENS IMOVEIS DOMINIAIS: TERRENOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.14.00.00.0000','LOTES','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS DOS SEGUINTES BENS IMOVEIS DOMINIAIS: LOTES .','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.16.00.00.0000','GLEBAS URBANAS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS DOS SEGUINTES BENS IMOVEIS DOMINIAIS: GLEBAS URBANAS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.18.00.00.0000','GLEBAS RURAIS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS DOS SEGUINTES BENS IMOVEIS DOMINIAIS: GLEBAS RURAIS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.04.99.00.00.0000','OUTROS BENS DOMINICAIS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS A OUTROS BENS IMOVEIS DOMINIAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.05.00.00.00.0000','BENS DE USO COMUM DO POVO','COMPREENDE OS BENS DE USO COMUM DO POVO CONSTRUIDOS OU ADQUIRIDOS POR PESSOAS JURIDICAS DE DIREITO PÚBLICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.05.01.00.00.0000','RUAS','REGISTRA OS VALORES DE RUAS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRAÇÃO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.05.02.00.00.0000','PRAÇAS','REGISTRA OS VALORES DE PRAÇAS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRAÇÃO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.05.03.00.00.0000','ESTRADAS','REGISTRA OS VALORES DE ESTRADAS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRAÇÃO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.05.04.00.00.0000','PONTES','REGISTRA OS VALORES DE PONTES QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRAÇÃO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.05.05.00.00.0000','VIADUTOS','REGISTRA OS VALORES DE VIADUTOS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRAÇÃO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.05.06.00.00.0000','SISTEMAS DE ESGOTO E/OU DE ABASTECIMENTO DE ÁGUA','REGISTRA OS VALORES DE SISTEMAS DE ESGOTO E/OU DE ABASTECIMENTO DE ÁGUA QUE FORAM CONSTRUÍDOS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRAÇÃO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.05.07.00.00.0000','SISTEMAS DE ABASTECIMETNO DE ENERGIA','REGISTRA OS VALORES DE SISTEMAS DE ABASTECIMETNO DE ENERGIA QUE FORAM CONSTRUÍDOS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRAÇÃO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.05.08.00.00.0000','REDES DE TELECOMUNICAÇÕES','REGISTRA OS VALORES DE REDES DE TELECOMUNICAÇÕES QUE FORAM CONSTRUÍDOS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRAÇÃO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.05.09.00.00.0000','BENS DO PATRIMONIO CULTURAL','REGISTRA OS BENS COM SIGNIFICANCIA HISTÓRICA, CULTURAL OU AMBIENTAL TAIS COMO MONUMENTOS E PRÉDIOS HISTÓRICOS, SÍTIOS ARQUEOLÓGICOS, ÁREA DE CONSERVAÇÃO E RESERVAS NATURAIS E OBRAS DE ARTE, QUANDO PASSÍVEIS DE MENSURAÇÃO E AVALIAÇÃO. REGISTRA OS BENS COM SIGNIFICANCIA HISTÓRICA, CULTURAL OU AMBIENTAL TAIS COMO MONUMENTOS E PRÉDIOS HISTÓRICOS, SÍTIOS ARQUEOLÓGICOS, ÁREA DE CONSERVAÇÃO E RESERVAS NATURAIS E OBRAS DE ARTE, QUANDO PASSÍVEIS DE MENSURAÇÃO E AVALIAÇÃO. REGISTRA OS BENS COM SIGNIFICANCIA HISTÓRICA, CULTURAL OU AMBIENTAL TAIS COMO MONUMENTOS E PRÉDIOS HISTÓRICOS, SÍTIOS ARQUEOLÓGICOS, ÁREA DE CONSERVAÇÃO E RESERVAS NATURAIS E OBRAS DE ARTE, QUANDO PASSÍVEIS DE MENSURAÇÃO E AVALIAÇÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.05.99.00.00.0000','OUTROS BENS DE USO COMUM DO POVO','REGISTRA OS VALORES BENS DE USO COMUM, NÃO CLASSIFICADOS ANTERIORMENTE NESTE PLANO DE CONTAS, QUE FORAM ADQUIRIDOS, PRODUZIDOS OU CONSTRUIDOS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRAÇÃO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.06.00.00.00.0000','BENS IMÓVEIS EM ANDAMENTO','COMPREENDE OS VALORES DE BENS IMÓVEIS EM ANDAMENTO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.06.01.00.00.0000','OBRAS EM ANDAMENTO','REGISTRA OS VALORES PERTINENTES A OBRAS, DESDE SUA CONSTRUCAO ATE O TÉRMINODA MESMA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.06.05.00.00.0000','ESTUDOS E PROJETOS','REGISTRA OS VALORES RELATIVOS A ESTUDOS E PROJETOS, ENGLOBANDO LIMPEZA DO TERRENO, SERVIÇOS TOPOGRAFICOS, SONDAGENS DE RECONHECIMENTO, TERRAPLENAGEM, DRENAGENS, INSTALAÇÕES PROVISORIAS COMO GALPOES, INSTALAÇÕES ELETRICAS E HIDRAULICAS, UTILIZADAS DURANTE AS OBRAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.07.00.00.00.0000','INSTALAÇÕES','REGISTRA EQUIPAMENTOS, MATERIAIS E CUSTO DE IMPLANTAÇÃO DE INSTALAÇÕES QUE, NÃO OBSTANTE INTEGRADAS AOS EDIFICIOS, DEVEM SER SEGREGADAS DAS OBRAS CIVIS, COMO, POR EXEMPLO, AS INSTALCOES ELETRICAS, HIDRAULICAS, SANITARIAS, DE VAPOR, DE AR COMPRIMIDO, FRIGORIFICAS, CONTRA INCENDIO, DE COMUNICAÇÕES, DE CLIMATIZAÇÃO, PARA COMBUSTÍVEIS, GASES, DE ANTIPOLUICAO, PARA COZINHA, DENTRE OUTROS. E TAMBÉM APLICAVEL A CONSTRUCAO DE TRECHOS FERROVIARIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.08.00.00.00.0000','BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','REGISTRA CONSTRUCOES EM TERRENOS ARRENDADOS DE TERCERIOS E INSTALAÇÕES E OUTRAS BENFEITORIAS EM PREDIOS ALUGADOS. SAO CONSIDERADOS SOMENTE OS GASTOS COM CONSTRUCAO E INSTALAÇÃO QUE SE INCORPORAM AO IMOVEL E REVERTEM AO PROPRIETARIO DO IMOVEL AO FINAL DA LOCAÇÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.99.00.00.00.0000','DEMAIS BENS IMÓVEIS','COMPREENDE OS DEMAIS BENS IMÓVEIS NÃO CLASSIFICADOS ANTERIORMENTE NESSE PLANO DE CONTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.2.1.99.99.00.00.0000','OUTROS BENS IMÓVEIS','REGISTRA OS VALORES RELATIVOS A OUTROS BENS IMÓVEIS, PARA OS QUAIS NÃO TENHAM SIDO CRIADAS CONTAS PROPRIAS OU ESPECIFICAS NESTE PLANO DE CONTAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.0.00.00.00.00.0000','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS','COMPREENDE A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO DEVIDO A DESGASTE PELO USO, AÇÃO DA NATUREZA OU OBSOLESCENCIA, BEM COMO A PERDA DO VALOR, DECORRENTE DE SUA EXPLORAÇÃO, DE DIREITOS CUJO OBJETO SEJAM RECURSOS MINERAIS OU FLORESTAIS OU BENS APLICADOS NESSA EXPLORAÇÃO E A PERDA DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCÍCIO DE DURAÇÃO LIMITADA OU CUJO OBJETO SEJAM BENS DE UTILIZAÇÃO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.00.00.00.00.0000','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS - CONSOLIDAÇÃO','COMPREENDE A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO DEVIDO A DESGASTE PELO USO, AÇÃO DA NATUREZA OU OBSOLESCENCIA, BEM COMO A PERDA DO VALOR, DECORRENTE DE SUA EXPLORAÇÃO, DE DIREITOS CUJO OBJETO SEJAM RECURSOS MINERAIS OU FLORESTAIS OU BENS APLICADOS NESSA EXPLORAÇÃO E A PERDA DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCÍCIO DE DURAÇÃO LIMITADA OU CUJO OBJETO SEJAM BENS DE UTILIZAÇÃO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.01.00.00.00.0000','(-) DEPRECIAÇÃO ACUMULADA DE BENS MÓVEIS','COMPREENDE A DIMINUICAO DO VALOR DE BENS MÓVEIS DEVIDO A DESGASTE PELO USO, AÇÃO DA NATUREZA OU OBSOLESCENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.01.01.00.00.0000','DEPRECIAÇÃO ACUMULADA DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','REGISTRA A DEPRECIAÇÃO ACUMULADA DE MÁQUINAS, FERRAMENTAS, APARELHOS, EQUIPAMENTOS, ACESSÓRIOS ETC.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.01.02.00.00.0000','DEPRECIAÇÃO ACUMULADA DE BENS DE INFORMÁTICA','REGISTRA A DEPRECIAÇÃO ACUMULADA DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E SISTEMAS APLICATIVOS, ENTRE OUTROS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.01.03.00.00.0000','DEPRECIAÇÃO ACUMULADA DE MÓVEIS E UTENSÍLIOS','REGISTRA A DEPRECIAÇÃO ACUMULADA DE MOBILIÁRIO EM GERAL E UTENSÍLIOS, ENTRE OUTROS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.01.04.00.00.0000','DEPRECIAÇÃO ACUMULADA DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','REGISTRA A DEPRECIAÇÃO ACUMULADA DE MATERIAIS BIBLIOGRÁFICOS, DISCOTECAS, FILMOTECAS, DE COMUNICAÇÃO, ENTRE OUTROS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.01.05.00.00.0000','DEPRECIAÇÃO ACUMULADA DE VEÍCULOS','REGISTRA A DEPRECIAÇÃO ACUMULADA DE TRANSPORTES AÉREOS, AQUÁTICOS E TERRESTRES, ENTRE OUTROS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.01.06.00.00.0000','DEPRECIAÇÃO ACUMULADA DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','REGISTRA A DEPRECIAÇÃO ACUMULADA DE PEÇAS E CONJUNTOS DE REPOSIÇÃO DESTINADOS A SUBSTITUIÇÃO EM MÁQUINAS E EQUIPAMENTOS, AERONAVES E EMBARCAÇÕES, BENS DE SEGURANÇA E SOCORRO, ENTRE OUTROS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.01.07.00.00.0000','DEPRECIAÇÃO ACUMULADA DE BENS MÓVEIS EM ANDAMENTO','REGISTRA A DEPRECIAÇÃO ACUMULADA DE BENS MÓVEIS EM ANDAMENTO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.01.08.00.00.0000','DEPRECIAÇÃO ACUMULADA DE BENS MÓVEIS EM ALMOXARIFADO','REGISTRA A DEPRECIAÇÃO ACUMULADA DE BENS PERMANENTES A SEREM ESTOCADOS EM ALMOXARIFADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.01.09.00.00.0000','DEPRECIAÇÃO ACUMULADA DE ARMAMENTOS','REGISTRA A DEPRECIAÇÃO ACUMULADA DE ARMAS QUE CONSTITUEM OBJETOS DE DEFESA OU PREPARATIVOS DE GUERRA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.01.10.00.00.0000','DEPRECIAÇÃO ACUMULADA DE SEMOVENTES','REGISTRA A DEPRECIAÇÃO ACUMULADA DE ANIMAIS DESTINADOS A PRODUÇÃO, REPRODUÇÃO, ENGORDA E AOS SERVIÇOS UTILITÁRIOS EM GERAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.01.99.00.00.0000','DEPRECIAÇÃO ACUMULADA DE DEMAIS BENS MÓVEIS','REGISTRA A DEPRECIAÇÃO ACUMULADA DE DEMAIS BENS MÓVEIS NÃO CLASSIFICADOS EM GRUPOS ESPECÍFICOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.02.00.00.00.0000','(-) DEPRECIAÇÃO ACUMULADA DE BENS IMÓVEIS','COMPREENDE A DIMINUICAO DO VALOR BENS IMÓVEIS DEVIDO A DESGASTE PELO USO, AÇÃO DA NATUREZA OU OBSOLESCENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.02.01.00.00.0000','DEPRECIAÇÃO ACUMULADA DE BENS DE USO ESPECIAL','REGISTRA A DEPRECIAÇÃO ACUMULADA DE BENS COMO EDIFÍCIOS OU TERRENOS DESTINADOS A SERVIÇO OU ESTABELECIMENTO DA ADMINISTRAÇÃO ESTADUAL OU MUNICIPAL, INCLUSIVE OS DE SUAS AUTARQUIAS E FUNDAÇÕES PÚBLICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.02.02.00.00.0000','DEPRECIAÇÃO ACUMULADA DE BENS DOMINICAIS','REGISTRA A DEPRECIAÇÃO ACUMULADA DE BENS QUE CONSTITUEM O PATRIMÔNIO DAS PESSOAS JURÍDICAS DE DIREITO PÚBLICO, COMO OBJETO DE DIREITO PESSOAL, OU REAL, DE CADA UMA DESSAS ENTIDADES. COMPREENDE AINDA, NÃO DISPONDO A LEI EM CONTRÁRIO, OS BENS PERTENCENTES AS PESSOAS JURÍDICAS DE DIREITO PÚBLICO A QUE SE TENHA DADO ESTRUTURA DE DIREITO PRIVADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.02.03.00.00.0000','DEPRECIAÇÃO ACUMULADA DE BENS DE USO COMUM DO POVO','REGISTRA A DEPRECIAÇÃO ACUMULADA DE BENS DE USO COMUM DO POVO CONSTRUÍDOS OU ADQUIRIDOS POR PESSOAS JURÍDICAS DE DIREITO PÚBLICO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.02.04.00.00.0000','DEPRECIAÇÃO ACUMULADA DE BENS IMÓVEIS EM ANDAMENTO','REGISTRA A DEPRECIAÇÃO ACUMULADA DE VALORES DE BENS IMÓVEIS EM ANDAMENTO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.02.05.00.00.0000','DEPRECIAÇÃO ACUMULADA DE INSTALAÇÕES','REGISTRA A DEPRECIAÇÃO ACUMULADA DE EQUIPAMENTOS, MATERIAIS E CUSTO DE IMPLANTAÇÃO DE INSTALAÇÕES QUE, NÃO OBSTANTE INTEGRADAS AOS EDIFÍCIOS, DEVEM SER SEGREGADAS DAS OBRAS CIVIS, COMO, POR EXEMPLO, AS INSTALAÇÕES ELÉTRICAS, HIDRÁULICAS, SANITÁRIAS, DE VAPOR, DE AR COMPRIMIDO, FRIGORÍFICAS, CONTRA INCÊNDIO, DE COMUNICAÇÕES, DE CLIMATIZAÇÃO, PARA COMBUSTÍVEIS, GASES, DE ANTIPOLUIÇÃO, PARA COZINHA, DENTRE OUTROS. E TAMBÉM APLICÁVEL A CONSTRUÇÃO DE TRECHOS FERROVIÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.02.06.00.00.0000','DEPRECIAÇÃO ACUMULADA DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','REGISTRA A DEPRECIAÇÃO ACUMULADA DE CONSTRUÇÕES EM TERRENOS ARRENDADOS DE TERCEIROS E INSTALAÇÕES E OUTRAS BENFEITORIAS EM PRÉDIOS ALUGADOS. SÃO CONSIDERADOS SOMENTE OS GASTOS COM CONSTRUÇÃO E INSTALAÇÃO QUE SE INCORPORAM AO IMÓVEL E REVERTEM AO PROPRIETÁRIO DO IMÓVEL AO FINAL DA LOCAÇÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.02.99.00.00.0000','DEPRECIAÇÃO ACUMULADA DE DEMAIS BENS IMÓVEIS','REGISTRA A DEPRECIAÇÃO ACUMULADA DE OS DEMAIS BENS IMÓVEIS NÃO CLASSIFICADOS ANTERIORMENTE NESSE PLANO DE CONTAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.03.00.00.00.0000','(-) EXAUSTÃO ACUMULADA – BENS MÓVEIS','REGISTRA A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO, BENS MÓVEIS, DEVIDO A PERDA DO VALOR, DECORRENTE DE SUA EXPLORAÇÃO, DE DIREITOS CUJO OBJETO SEJAM RECURSOS MINERAIS OU FLORESTAIS OU BENS APLICADOS NESSA EXPLORAÇÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.04.00.00.00.0000','(-) EXAUSTÃO ACUMULADA – BENS IMÓVEIS','REGISTRA A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO, BENS IMÓVEIS, DEVIDO A PERDA DO VALOR, DECORRENTE DE SUA EXPLORAÇÃO, DE DIREITOS CUJO OBJETO SEJAM RECURSOS MINERAIS OU FLORESTAIS OU BENS APLICADOS NESSA EXPLORAÇÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.05.00.00.00.0000','(-) AMORTIZAÇÃO ACUMULADA – BENS MÓVEIS','REGISTRA A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO, BENS MÓVEIS, DEVIDO A PERDA DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCÍCIO DE DURAÇÃO LIMITADA OU CUJO OBJETO SEJAM BENS DE UTILIZAÇÃO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.8.1.06.00.00.00.0000','(-) AMORTIZAÇÃO ACUMULADA – BENS IMÓVEIS','REGISTRA A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO, BENS IMÓVEIS, DEVIDO A PERDA DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCÍCIO DE DURAÇÃO LIMITADA OU CUJO OBJETO SEJAM BENS DE UTILIZAÇÃO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.0.00.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE IMOBILIZADO','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DO IMOBILIZADO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.00.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DO IMOBILIZADO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. CONTA DE USO EXCLUSIVO PARA AS EMPRESAS ESTATAIS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.01.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE IMOBILIZADO - BENS MÓVEIS','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL BENS MÓVEIS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. CONTA DE USO EXCLUSIVO PARA AS EMPRESAS ESTATAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.01.01.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE MÁQUINAS, FERRAMENTAS, APARELHOS, EQUIPAMENTOS, ACESSÓRIOS ETC.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.01.02.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE INFORMÁTICA','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E SISTEMAS APLICATIVOS, ENTRE OUTROS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.01.03.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE MÓVEIS E UTENSÍLIOS','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE MOBILIÁRIO EM GERAL E UTENSÍLIOS, ENTRE OUTROS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.01.04.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE MATERIAIS BIBLIOGRÁFICOS, DISCOTECAS, FILMOTECAS, DE COMUNICAÇÃO, ENTRE OUTROS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.01.05.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE VEÍCULOS','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE TRANSPORTES AÉREOS, AQUÁTICOS E TERRESTRES, ENTRE OUTROS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.01.06.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE PEÇAS E CONJUNTOS DE REPOSIÇÃO DESTINADOS A SUBSTITUIÇÃO EM MÁQUINAS E EQUIPAMENTOS, AERONAVES E EMBARCAÇÕES, BENS DE SEGURANÇA E SOCORRO, ENTRE OUTROS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.01.07.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ANDAMENTO','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE BENS MÓVEIS EM ANDAMENTO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.01.08.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ALMOXARIFADO','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE BENS PERMANENTES A SEREM ESTOCADOS EM ALMOXARIFADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.01.09.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE ARMAMENTOS','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE ARMAS QUE CONSTITUEM OBJETOS DE DEFESA OU PREPARATIVOS DE GUERRA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.01.10.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE SEMOVENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE ANIMAIS DESTINADOS A PRODUÇÃO, REPRODUÇÃO, ENGORDA E AOS SERVIÇOS UTILITÁRIOS EM GERAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.01.99.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS MÓVEIS','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE DEMAIS BENS MÓVEIS NÃO CLASSIFICADOS EM GRUPOS ESPECÍFICOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.02.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE IMOBILIZADO - BENS IMÓVEIS','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL BENS IMÓVEIS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. CONTA DE USO EXCLUSIVO PARA AS EMPRESAS ESTATAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.02.01.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO ESPECIAL','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE BENS COMO EDIFÍCIOS OU TERRENOS DESTINADOS A SERVIÇO OU ESTABELECIMENTO DA ADMINISTRAÇÃO ESTADUAL OU MUNICIPAL, INCLUSIVE OS DE SUAS AUTARQUIAS E FUNDAÇÕES PÚBLICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.02.02.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DOMINICAIS','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE BENS QUE CONSTITUEM O PATRIMÔNIO DAS PESSOAS JURÍDICAS DE DIREITO PÚBLICO, COMO OBJETO DE DIREITO PESSOAL, OU REAL, DE CADA UMA DESSAS ENTIDADES. COMPREENDE AINDA, NÃO DISPONDO A LEI EM CONTRÁRIO, OS BENS PERTENCENTES AS PESSOAS JURÍDICAS DE DIREITO PÚBLICO A QUE SE TENHA DADO ESTRUTURA DE DIREITO PRIVADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.02.03.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO COMUM DO POVO','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE BENS DE USO COMUM DO POVO CONSTRUÍDOS OU ADQUIRIDOS POR PESSOAS JURÍDICAS DE DIREITO PÚBLICO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.02.04.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS EM ANDAMENTO','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE VALORES DE BENS IMÓVEIS EM ANDAMENTO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.02.05.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE INSTALAÇÕES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE EQUIPAMENTOS, MATERIAIS E CUSTO DE IMPLANTAÇÃO DE INSTALAÇÕES QUE, NÃO OBSTANTE INTEGRADAS AOS EDIFÍCIOS, DEVEM SER SEGREGADAS DAS OBRAS CIVIS, COMO, POR EXEMPLO, AS INSTALAÇÕES ELÉTRICAS, HIDRÁULICAS, SANITÁRIAS, DE VAPOR, DE AR COMPRIMIDO, FRIGORÍFICAS, CONTRA INCÊNDIO, DE COMUNICAÇÕES, DE CLIMATIZAÇÃO, PARA COMBUSTÍVEIS, GASES, DE ANTIPOLUIÇÃO, PARA COZINHA, DENTRE OUTROS. E TAMBÉM APLICÁVEL A CONSTRUÇÃO DE TRECHOS FERROVIÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.02.06.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE CONSTRUÇÕES EM TERRENOS ARRENDADOS DE TERCEIROS E INSTALAÇÕES E OUTRAS BENFEITORIAS EM PRÉDIOS ALUGADOS. SÃO CONSIDERADOS SOMENTE OS GASTOS COM CONSTRUÇÃO E INSTALAÇÃO QUE SE INCORPORAM AO IMÓVEL E REVERTEM AO PROPRIETÁRIO DO IMÓVEL AO FINAL DA LOCAÇÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.3.9.1.02.99.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS IMÓVEIS','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERÁVEL DE OS DEMAIS BENS IMÓVEIS NÃO CLASSIFICADOS ANTERIORMENTE NESSE PLANO DE CONTAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.0.0.00.00.00.00.0000','INTANGÍVEL','COMPREENDE OS DIREITOS QUE TENHAM POR OBJETO BENS INCORPOREOS DESTINADOS A MANUTENCAO DA ENTIDADE OU EXERCIDOS COM ESSA FINALIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.1.0.00.00.00.00.0000','SOFTWARES','COMPREENDE OS VALORES DOS SOFTWARES PERTENCENTES A ENTIDADE E NÃO INTEGRANTES A UM HARDWARE, ENGLOBANDO OS VALORES REFERENTES A SUA CONSTRUCAO, IMPLEMENTAÇÃO E INSTALAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.1.1.00.00.00.00.0000','SOFTWARES- CONSOLIDAÇÃO','REGISTRA OS VALORES DOS SOFTWARES PERTENCENTES A ENTIDADE E NÃO INTEGRANTES A UM HARDWARE, ENGLOBANDO OS VALORES REFERENTES A SUA CONSTRUCAO, IMPLEMENTAÇÃO E INSTALAÇÃOCOMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.2.0.00.00.00.00.0000','MARCAS, DIREITOS E PATENTES INDUSTRIAIS','COMPREENDE OS VALORES PERTINENTES A BENS INTANGÍVEIS, ENGLOBANDO OS GASTOS COM REGISTRO DE MARCA, NOME, INVENCOES PROPRIAS, DIREITOS DE USO DE COMUNICAÇÃO E DIREITOS AUTORAIS, ALÉM DE DESEMBOLSOS A TERCEIROS POR CONTRATOS DE USO DE MARCAS, PATENTES OU PROCESSOS DE FABRICAÇÃO (TECNOLOGIA).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.2.1.00.00.00.00.0000','MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS- CONSOLIDAÇÃO','COMPREENDE OS VALORES PERTINENTES A BENS INTANGIVEIS, ENGLOBANDO OS GASTOS COM REGISTRO DE MARCA, NOME, INVENCOES PROPRIAS, DIREITOS DE USO DE COMUNICAÇÃO, DIREITOS AUTORAIS E DIREITOS SOBRE RECURSOS NATURAIS, ALÉM DE DESEMBOLSOS A TERCEIROS POR CONTRATOS DE USO DE MARCAS, PATENTES OU PROCESSOS DE FABRICAÇÃO (TECNOLOGIA). COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.3.0.00.00.00.00.0000','DIREITO DE USO DE IMÓVEIS','COMPREENDE OS VALORES PERTINENTES A BENS INTANGIVEIS REPRESENTADOS PELA AQUISICAO DO DIREITO DE USO DE IMÓVEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.3.1.00.00.00.00.0000','DIREITO DE USO DE IMÓVEIS- CONSOLIDAÇÃO','REGISTRA OS VALORES PERTINENTES A BENS INTANGIVEIS REPRESENTADOS PELA AQUISICAO DE DIREITO DE USO DE IMÓVEIS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.8.0.00.00.00.00.0000','(-) AMORTIZAÇÃO ACUMULADA','COMPREENDE A DIMINUICAO DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DA PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCÍCIO DE DURAÇÃO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZAÇÃO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.8.1.00.00.00.00.0000','(-) AMORTIZAÇÃO ACUMULADA- CONSOLIDAÇÃO','COMPREENDE A DIMINUICAO DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DA PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCÍCIO DE DURAÇÃO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZAÇÃO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.8.1.01.00.00.00.0000','(-) AMORTIZAÇÃO ACUMULADA - SOFTWARES','REGISTRA A DIMINUICAO DO VALOR DO CAPITAL APLICADO EM SOFTWARES, PERTENCENTES AO ATIVO INTANGIVEL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.8.1.02.00.00.00.0000','(-) AMORTIZAÇÃO ACUMULADA - MARCAS, DIREITOS E PATENTES','REGISTRA A DIMINUICAO DO VALOR DO CAPITAL APLICADO EM MARCAS, DIREITOS E PATENTES, PERTENCENTES AO ATIVO INTANGIVEL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.8.1.03.00.00.00.0000','(-) AMORTIZAÇÃO ACUMULADA - DIREITO DE USO DE IMÓVEIS','REGISTRA A DIMINUICAO DO VALOR DO CAPITAL APLICADO EM DIREITO DE USO DE IMÓVEIS, PERTENCENTES AO ATIVO INTANGIVEL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.9.0.00.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INTANGIVEL','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DO ATIVO INTANGIVEL, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.9.1.00.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - CONSOLIDAÇÃO','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DO ATIVO INTANGIVEL, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.9.1.01.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INTANGIVEL - SOFTWARES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DO SOFTWARE PERTENCENTE AO ATIVO INTANGIVEL, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.9.1.02.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INTANGIVEL - MARCAS, DIREITOS E PATENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DAS MARCAS, DIREITOS E PATENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '1.2.4.9.1.03.00.00.00.0000','(-) REDUÇÃO AO VALOR RECUPERAVEL DE INTANGIVEL -DIREITO DE USO','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE DIREITO DE USO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.0.0.0.0.00.00.00.00.0000','PASSIVO E PATRIMÔNIO LÍQUIDO','PASSIVO COMPREENDE AS OBRIGAÇÕES EXISTENTES DA ENTIDADE ORIUNDAS DE EVENTOS PASSADOS DE CUJA LIQUIDAÇÃO SE ESPERA QUE RESULTE EM FLUXO DE SAIDA DE RECURSOS QUE INCORPOREM BENEFÍCIOS ECONOMICOS OU SERVIÇOS EM POTENCIAL. PATRIMONIO LIQUIDO COMPREENDE A DIFERENCA ENTRE O ATIVO E O PASSIVO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.0.0.0.00.00.00.00.0000','PASSIVO CIRCULANTE','COMPREENDE AS OBRIGAÇÕES CONHECIDAS E ESTIMADAS QUE ATENDAM A QUALQUER UM DOS SEGUINTES CRITERIOS: TENHAM PRAZOS ESTABELECIDOS OU ESPERADOS DENTRO DO CICLO OPERACIONAL DA ENTIDADE; SEJAM MANTIDOS PRIMARIAMENTE PARA NEGOCIAÇÃO; TENHAM PRAZOS ESTABELECIDOS OU ESPERADOS ATE O TÉRMINO DO EXERCÍCIO SEGUINTE; SEJAM VALORES DE TERCEIROS OU RETENÇÕES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PÚBLICO FOR FIEL DEPOSITÁRIA, INDEPENDENTEMENTE DO PRAZO DE EXIGIBILIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.0.0.00.00.00.00.0000','OBRIGAÇÕES TRABALHISTAS, PREVIDÊNCIÁRIAS E ASSISTÊNCIAIS A PAGAR A CURTO PRAZO','COMPREENDE AS OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, APOSENTADORIAS, REFORMAS, PENSÕES E ENCARGOS A PAGAR, BEM COMO BENEFÍCIOS ASSISTÊNCIAIS, COM VENCIMENTO ATÉ O TÉRMINO DO EXERCÍCIO SEGUINTE, INCLUSIVE OS PRECATÓRIOS DECORRENTES DESSAS OBRIGAÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.0.00.00.00.00.0000','PESSOAL A PAGAR','COMPREENDE AS OBRIGAÇÕES A CURTO PRAZO REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.00.00.00.00.0000','PESSOAL A PAGAR - CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.01.00.00.00.0000','PESSOAL A PAGAR DO EXERCÍCIO','COMPREENDE AS OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS AO EXERCÍCIO ATUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.01.01.00.00.0000','SALÁRIOS, REMUNERAÇÕES E BENEFÍCIOS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS AO EXERCÍCIO ATUAL.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.01.02.00.00.0000','DÉCIMO TERCEIRO SALÁRIO (13º)','REGISTRA AS OBRIGAÇÕES REFERENTES AO DECIMO TERCEIRO SALÁRIO, GERALMENTE APROPRIADAS NA BASE DE 1/12 DO VALOR BRUTO DA FOLHA DE PAGAMENTO DA UNIDADE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.01.03.00.00.0000','FERIAS','REGISTRA AS OBRIGAÇÕES REFERENTES A FERIAS, GERALMENTE APROPRIADAS COMO PERCENTUAIS DA FOLHA DE PAGAMENTO DA UNIDADE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.01.04.00.00.0000','LICENCA - PREMIO','REGISTRA OS VALORES DAS OBRIGAÇÕES CONSTITUIDAS COM BASE EM PERCENTUAIS DE SALÁRIOS, DESTINADOS AO PAGAMENTO DE LICENCA-PREMIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.01.05.00.00.0000','ENCARGOS SOCIAIS SOBRE PROVISÕES','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS SOBRE PROVISÕES PARA 13° .SALÁRIO, FERIAS , LICENCA-PREMIO E OUTRAS CONSTITUIDAS SOBRE A FOLHA DE PAGAMENTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.01.05.01.00.0000','INSS','REGISTRA OS VALORES PROVISIONADOS RELATIVOS A CONTRIBUICAO PARA O INSS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.01.05.02.00.0000','FGTS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS PROVISIONADOS RELATIVOS AO FGTS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.01.05.03.00.0000','RPPS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS PROVISIONADOS RELATIVOS AO RPPS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.01.07.00.00.0000','AGENTES POLÍTICOS','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DA REMUNERAÇÃO DEVIDA AOS AGENTES POLÍTICOS, RELATIVAS AO EXERCÍCIO ATUAL.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.02.00.00.00.0000','PESSOAL A PAGAR DE EXERCÍCIOS ANTERIORES','REGISTRA AS OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS A EXERCÍCIOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.02.01.00.00.0000','SALÁRIOS, REMUNERAÇÕES E BENEFÍCIOS DE EXERCÍCIOS ANTERIORES','REGISTRA AS OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS A EXERCICIOS ANTERIORES.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.03.00.00.00.0000','PRECATÓRIOS DE PESSOAL','COMPREENDE OS VALORES DE PRECATÓRIOS DE OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO A BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.03.01.00.00.0000','PRECATÓRIOS DE PESSOAL DO EXERCÍCIO','REGISTRA OS VALORES DE PRECATÓRIOS DE OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO A BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DO EXERCÍCIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.03.02.00.00.0000','PRECATÓRIOS DE PESSOAL DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA OS VALORES DE PRECATÓRIOS DE OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO A BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.03.02.01.00.0000','PRECATÓRIOS DE PESSOAL DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA OS VALORES DE PRECATÓRIOS DE OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO A BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.03.02.02.00.0000','PRECATÓRIOS DE PESSOAL - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE PESSOAL, ATE 05/05/2000 DO PODER EXCUTIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.03.02.03.00.0000','PRECATÓRIOS DE PESSOAL - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE PESSOAL, ATE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.03.02.04.00.0000','PRECATÓRIOS DE PESSOAL - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE PESSOAL, ATE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.03.03.00.00.0000','PRECATÓRIOS DE PESSOAL DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','REGISTRA OS VALORES DE PRECATÓRIOS DE OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO A BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCÍCIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.03.03.01.00.0000','PESSOAL - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE PESSOAL, A PARTIR DE 05/05/2000 DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.03.03.02.00.0000','PESSOAL - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE PESSOAL, A PARTIR DE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.1.1.03.03.03.00.0000','PESSOAL - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE PESSOAL, A PARTIR DE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.0.00.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS A PAGAR','COMPREENDE AS OBRIGAÇÕES A CURTO PRAZO REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.1.00.00.00.00.0000','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.1.01.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, INCORRIDAS NO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.1.02.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES','REGISTRA AS OBRIGAÇÕES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, INCORRIDAS EM EXERCÍCIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.1.03.00.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS','COMPREENDE AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.1.03.01.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, DO EXERCÍCIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.1.03.02.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.1.03.03.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES E EXERCÍCIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.2.00.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS A PAGAR-INTRA OFSS','REGISTRA AS OBRIGAÇÕES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA REQUISITADO TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.2.01.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, INCORRIDAS NO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.2.02.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES','REGISTRA AS OBRIGAÇÕES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, INCORRIDAS EM EXERCÍCIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.2.03.00.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS','COMPREENDE AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.2.03.01.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, DO EXERCÍCIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.2.03.02.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.2.03.03.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES E EXERCÍCIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.3.00.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS A PAGAR-INTER OFSS - UNIÃO','REGISTRA AS OBRIGAÇÕES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA REQUISITADO TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.3.01.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, INCORRIDAS NO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.3.02.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES','REGISTRA AS OBRIGAÇÕES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, INCORRIDAS EM EXERCÍCIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.3.03.00.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS','COMPREENDE AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.3.03.01.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, DO EXERCÍCIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.3.03.02.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.3.03.03.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES E EXERCÍCIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.4.00.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS A PAGAR-INTER OFSS - ESTADO','REGISTRA AS OBRIGAÇÕES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA REQUISITADO TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.4.01.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, INCORRIDAS NO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.4.02.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES','REGISTRA AS OBRIGAÇÕES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, INCORRIDAS EM EXERCÍCIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.4.03.00.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS','COMPREENDE AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.4.03.01.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, DO EXERCÍCIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.4.03.02.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.4.03.03.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES E EXERCÍCIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.5.00.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS A PAGAR-INTER OFSS - MUNICÍPIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA REQUISITADO TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.5.01.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, INCORRIDAS NO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.5.02.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES','REGISTRA AS OBRIGAÇÕES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, INCORRIDAS EM EXERCÍCIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.5.03.00.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS','COMPREENDE AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.5.03.01.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, DO EXERCÍCIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.5.03.02.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.2.5.03.03.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES E EXERCÍCIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.3.0.00.00.00.00.0000','BENEFÍCIOS ASSISTÊNCIAIS A PAGAR','COMPREENDE AS OBRIGAÇÕES A CURTO PRAZO RELATIVAS AOS BENEFÍCIOS ASSISTÊNCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.3.1.00.00.00.00.0000','BENEFÍCIOS ASSISTÊNCIAIS A PAGAR - CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES RELATIVAS AOS BENEFÍCIOS ASSISTÊNCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.3.1.01.00.00.00.0000','BENEFÍCIOS ASSISTÊNCIAIS A PAGAR DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES RELATIVAS AOS BENEFÍCIOS ASSISTÊNCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL LIQUIDADOS NO EXERCÍCIO E AINDA NÃO PAGOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.3.1.02.00.00.00.0000','BENEFÍCIOS ASSISTÊNCIAIS A PAGAR DE EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AOS BENEFÍCIOS ASSISTÊNCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, DE EXERCÍCIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.0.00.00.00.00.0000','ENCARGOS SOCIAIS A PAGAR','COMPREENDE AS OBRIGAÇÕES A CURTO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NÃO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NÃO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PÚBLICO E AS DEMAIS CONTRIBUIÇÕES SOCIAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.1.00.00.00.00.0000','ENCARGOS SOCIAIS A PAGAR- CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NÃO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NÃO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PÚBLICO E AS DEMAIS CONTRIBUIÇÕES SOCIAIS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.1.01.00.00.00.0000','INSS A PAGAR','COMPREENDE OS VALORES RELATIVOS AS CONTRIBUIÇÕES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALÁRIOS E REMUNERAÇÕES PAGOS E SOBRE SERVIÇOS DE TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.1.01.01.00.00.0000','INSS – CONTRIBUIÇÃO SOBRE SALÁRIOS E REMUNERAÇÕES','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALÁRIOS E REMUNERAÇÕES PAGOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.1.01.02.00.00.0000','INSS – DÉBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DA FOLHA DE PAGAMENTO JUNTO AO INSS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.1.01.03.00.00.0000','INSS – CONTRIBUIÇÃO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES INCIDENTES SOBRE SERVIÇOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.1.01.04.00.00.0000','INSS – FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','REGISTRA OS VALORES RELATIVOS AS FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL .','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.1.03.00.00.00.0000','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES COM O PLANO DE SEGURIDADE DO SERVIDOR .','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.1.04.00.00.00.0000','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA','COMPREENDE OS VALORES RELATIVOS AS OBRIGAÇÕES COM REGIMES PRÓPRIOS DEPREVIDENCIA, NÃO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.1.04.01.00.00.0000','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA DO ENTE','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES COM REGIMES PRÓPRIOS DEPREVIDENCIA DE PESSOAL DO ENTE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.1.04.02.00.00.0000','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA – PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES COM REGIMES PRÓPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.1.06.00.00.00.0000','FGTS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.1.08.00.00.00.0000','ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR','COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.1.08.01.00.00.0000','CONTRIBUICAO PREVIDENCIA PRIVADA E ASSISTÊNCIA MEDICO-ODONTOLOGICA - DO EXERCÍCIO','DESTINADA AOS REGISTROS DOS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA E DE ASSISTÊNCIA MEDICO-ODONTOLOGICA DO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.1.08.02.00.00.0000','CONTRIBUICAO PREVIDENCIA PRIVADA E ASSISTÊNCIA MEDICO-ODONTOLOGICA - DE EXERCÍCIOS ANTERIORES','DESTINADA AOS REGISTROS DOS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA E DE ASSISTÊNCIA MEDICO-ODONTOLOGICA DE EXERCÍCIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.1.98.00.00.00.0000','OUTROS ENCARGOS SOCIAIS - CONSOLIDAÇÃO','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGAÇÕES PARA A ENTIDADE, CUJA CLASSIFICAÇÃO NÃO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.00.00.00.00.0000','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','COMPREENDE AS OBRIGAÇÕES DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NÃO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NÃO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PÚBLICO E AS DEMAIS CONTRIBUIÇÕES SOCIAIS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.04.00.00.00.0000','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','COMPREENDE OS VALORES RELATIVOS AS OBRIGAÇÕES COM REGIMES PROPRIOS DE PREVIDENCIA, NÃO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.04.01.00.00.0000','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS) DO EXERCÍCIO','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE REFERENTES AO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.04.02.00.00.0000','OBRIGAÇÕES PATRONAIS A RECOLHER - RPPS - DO EXERCÍCIO ANTERIOR','DESTINADA AOS REGISTROS DOS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE AO RPPS LIQUIDADAS E NÃO PAGAS DENTRO DO EXERCÍCIO, FICANDO PORTANTO EM RESTOS A PAGAR','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.08.00.00.00.0000','CONTRIBUICAO A ENTIDADES DE ASSISTÊNCIA MEDICO-ODONTOLOGICA','DESTINADA AOS REGISTROS DOS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTÊNCIA MEDICO-ODONTOLOGICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.08.01.00.00.0000','CONTRIBUICAO A ENTIDADES DE ASSISTÊNCIA MEDICO-ODONTOLOGICA - DO EXERCÍCIO','DESTINADA AOS REGISTROS DOS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTÊNCIA MEDICO-ODONTOLOGICA. DO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.08.02.00.00.0000','CONTRIBUICAO A ENTIDADES DE ASSISTÊNCIA MEDICO-ODONTOLOGICA - DE EXERCÍCIOS ANTERIORES','DESTINADA AOS REGISTROS DOS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTÊNCIA MEDICO-ODONTOLOGICA. DE EXERCÍCIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.21.00.00.00.0000','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT DO RPPS','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT DO RPPS NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.21.01.00.00.0000','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT DO RPPS - DO EXERCÍCIO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT DO RPPS REFERENTES AO EXERCÍCIO EM CURSO, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.21.01.01.00.0000','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT - DO EXERCÍCIO - APOSENTADORIAS EXECUTIVO / INDIRETAS','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT DO RPPS REFERENTES AO EXERCÍCIO EM CURSO, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS APOSENTADORIAS DO EXECUTIVO / INDIRETAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.21.01.02.00.0000','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT - DO EXERCÍCIO - APOSENTADORIAS LEGISLATIVO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT DO RPPS REFERENTES AO EXERCÍCIO EM CURSO, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS APOSENTADORIAS DO LEGISLATIVO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.21.01.03.00.0000','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT - DO EXERCÍCIO - PENSÕES','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT DO RPPS REFERENTES AO EXERCÍCIO EM CURSO, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS PENSÕES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.21.02.00.00.0000','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT DO RPPS - DO EXERCÍCIO ANTERIOR','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT DO RPPS REFERENTES AO EXERCÍCIO ANTERIOR, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.21.02.01.00.0000','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT - DO EXERCÍCIO ANTERIOR - APOSENTADORIAS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT DO RPPS REFERENTES AO EXERCÍCIO ANTERIOR, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS APOSENTADORIAS DO EXECUTIVO / INDIRETAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.21.02.02.00.0000','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT - DO EXERCÍCIO ANTERIOR - APOSENTADORIAS - LEGISLATIVO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT DO RPPS REFERENTES AO EXERCÍCIO ANTERIOR, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS APOSENTADORIAS DO LEGISLATIVO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.21.02.03.00.0000','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT - DO EXERCÍCIO ANTERIOR - PENSÕES','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DÉFICIT DO RPPS REFERENTES AO EXERCÍCIO ANTERIOR, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS PENSÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.22.00.00.00.0000','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSÕES DA FONTE TESOURO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSÕES DE RESPONSABILIDADE DA FONTE TESOURO NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.22.01.00.00.0000','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSÕES DA FONTE TESOURO - DO EXERCÍCIO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSÕES DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCÍCIO, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.22.01.01.00.0000','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DA FONTE TESOURO - DO EXERCÍCIO - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DO EXECUTIVO / INDIRETAS DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCÍCIO, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.22.01.02.00.0000','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DA FONTE TESOURO - DO EXERCÍCIO - LEGISLATIVO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DO LEGISLATIVO DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCÍCIO, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.22.01.03.00.0000','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE PENSÕES DA FONTE TESOURO - DO EXERCÍCIO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE PENSÕES DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCÍCIO, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.22.02.00.00.0000','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSÕES DA FONTE TESOURO - DO EXERCÍCIO ANTERIOR','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSÕES DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCÍCIO ANTERIOR, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.22.02.01.00.0000','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DA FONTE TESOURO - DO EXERCÍCIO ANTERIOR - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DO EXECUTIVO / INDIRETAS DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCÍCIO ANTERIOR, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.22.02.02.00.0000','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DA FONTE TESOURO - DO EXERCÍCIO ANTERIOR - LEGISLATIVO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DO LEGISLATIVO DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCÍCIO ANTERIOR, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.22.02.03.00.0000','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE PENSÕES DA FONTE TESOURO - DO EXERCÍCIO ANTERIOR','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE PENSÕES DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCÍCIO ANTERIOR, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.23.00.00.00.0000','OBRIGAÇÕES PATRONAIS A RECOLHER - PLANO DE SEGURIDADE SOCIAL DO SERVIDOR','DESTINADA AOS REGISTROS DOS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE PARA O PLANO DE SEGURIDADE SOCIAL DO SERVIDOR LIQUIDADAS E AINDA NÃO PAGAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.23.01.00.00.0000','OBRIGAÇÕES PATRONAIS A RECOLHER - PLANO DE SEGURIDADE SOCIAL DO SERVIDOR - DO EXERCÍCIO','DESTINADA AOS REGISTROS DOS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE PARA O PLANO DE SEGURIDADE SOCIAL DO SERVIDOR LIQUIDADAS E AINDA NÃO PAGAS DURANTE O EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.23.02.00.00.0000','OBRIGAÇÕES PATRONAIS A RECOLHER - PLANO DE SEGURIDADE SOCIAL DO SERVIDOR - DO EXERCÍCIO ANTERIOR','DESTINADA AOS REGISTROS DOS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE PARA O PLANO DE SEGURIDADE SOCIAL DO SERVIDOR LIQUIDADAS E AINDA NÃO PAGAS REFERENTES AO EXERCÍCIO ANTERIOR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.2.98.00.00.00.0000','OUTROS ENCARGOS SOCIAIS - INTRA','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGAÇÕES PARA A ENTIDADE, CUJA CLASSIFICAÇÃO NÃO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.00.00.00.00.0000','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','COMPREENDE AS OBRIGAÇÕES DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NÃO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NÃO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PÚBLICO E AS DEMAIS CONTRIBUIÇÕES SOCIAIS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.01.00.00.00.0000','INSS A PAGAR','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALÁRIOS E REMUNERAÇÕES PAGOS E SOBRE SERVIÇOS DE TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.01.01.00.00.0000','INSS - DO EXERCÍCIO','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES INCIDENTES SOBRE SALÁRIOS PAGOS OU CREDITADOS DEVIDOS POR ENCARGOS DO EMPREGADOR (UNIDADE) A PREVIDENCIA SOCIAL. REFERENTES AO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.01.02.00.00.0000','INSS - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES INCIDENTES SOBRE SALÁRIOS PAGOS OU CREDITADOS, OU SERVIÇOS DE TERCEIROS DEVIDOS POR ENCARGOS DO EMPREGADOR (UNIDADE) A PREVIDENCIA SOCIAL. REFERENTES A RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS E DEVERAO SER DESDOBRADAS POR EXERCÍCIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.01.03.00.00.0000','INSS - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES INCIDENTES SOBRE SALÁRIOS PAGOS OU CREDITADOS, OU SERVIÇOS DE TERCEIROS DEVIDOS POR ENCARGOS DO EMPREGADOR (UNIDADE) A PREVIDENCIA SOCIAL. REFERENTES A RESTOS A PAGAR PROCESSADOS - LEGISLATIVO E DEVERAO SER DESDOBRADAS POR EXERCÍCIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.01.04.00.00.0000','INSS - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES INCIDENTES SOBRE SALÁRIOS PAGOS OU CREDITADOS, OU SERVIÇOS DE TERCEIROS DEVIDOS POR ENCARGOS DO EMPREGADOR (UNIDADE) A PREVIDENCIA SOCIAL. REFERENTES A RESTOS A PAGAR PROCESSADOS - RPPS E DEVERAO SER DESDOBRADAS POR EXERCÍCIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.01.05.00.00.0000','INSS - CONTRIBUICAO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES INCIDENTES SOBRE SERVIÇOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.01.05.01.00.0000','INSS - CONTRIBUICAO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS - DO EXERCÍCIO','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES INCIDIDAS SOBRES SERVIÇOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS DO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.01.05.02.00.0000','INSS - CONTRIBUICAO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS - DE EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES INCIDIDAS SOBRES SERVIÇOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS DE EXERCÍCIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.06.00.00.00.0000','FGTS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALÁRIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.06.01.00.00.0000','FGTS - DO EXERCÍCIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS GERADOS POR PAGAMENTOS DE SALÁRIOS A RECOLHER AO FGTS REFERENTES AO EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.06.02.00.00.0000','FGTS - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS GERADOS POR PAGAMENTOS DE SALÁRIOS A RECOLHER AO FGTS REFERENTES A RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS E DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.06.03.00.00.0000','FGTS - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS GERADOS POR PAGAMENTOS DE SALÁRIOS A RECOLHER AO FGTS REFERENTES A RESTOS A PAGAR PROCESSADOS - LEGISLATIVO E DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.06.04.00.00.0000','FGTS - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS GERADOS POR PAGAMENTOS DE SALÁRIOS A RECOLHER AO FGTS REFERENTES A RESTOS A PAGAR PROCESSADOS - RPPS E DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.08.00.00.00.0000','CONTRIBUICAO A ENTIDADES DE ASSISTÊNCIA MEDICO-ODONTOLOGICA','DESTINADA AOS REGISTROS DOS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTÊNCIA MEDICO-ODONTOLOGICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.08.01.00.00.0000','CONTRIBUICAO A ENTIDADES DE ASSISTÊNCIA MEDICO-ODONTOLOGICA - DO EXERCÍCIO','DESTINADA AOS REGISTROS DOS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTÊNCIA MEDICO-ODONTOLOGICA. DO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.08.02.00.00.0000','CONTRIBUICAO A ENTIDADES DE ASSISTÊNCIA MEDICO-ODONTOLOGICA - DE EXERCÍCIOS ANTERIORES','DESTINADA AOS REGISTROS DOS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTÊNCIA MEDICO-ODONTOLOGICA. DE EXERCÍCIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.20.00.00.00.0000','PIS/PASEP','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS,GERADOS PELO PAGAMENTO DE SALÁRIOS A RECOLHER AO FUNDO DE PARTICIPAÇÃO DESTINADO A EXECUÇÃO DO PIS E DO PASEP, GERADOS PELO PAGAMENTO DE SALÁRIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.20.01.00.00.0000','PIS/PASEP - DO EXERCÍCIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS,GERADOS PELO PAGAMENTO DE SALÁRIOS A RECOLHER AO FUNDO DE PARTICIPAÇÃO DESTINADO A EXECUÇÃO DO PIS E DO PASEP, GERADOS PELO PAGAMENTO DE SALÁRIOS RELATIVOS AO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.20.02.00.00.0000','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS,GERADOS PELO PAGAMENTO DE SALÁRIOS A RECOLHER AO FUNDO DE PARTICIPAÇÃO DESTINADO A EXECUÇÃO DO PIS E DO PASEP, GERADOS PELO PAGAMENTO DE SALÁRIOS RELATIVOS A RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS E','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.20.03.00.00.0000','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS,GERADOS PELO PAGAMENTO DE SALÁRIOS A RECOLHER AO FUNDO DE PARTICIPAÇÃO DESTINADO A EXECUÇÃO DO PIS E DO PASEP, GERADOS PELO PAGAMENTO DE SALÁRIOS RELATIVOS A RESTOS A PAGAR PROCESSADOS - LEGISLATIVO E DEVERAO SE','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.20.04.00.00.0000','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS,GERADOS PELO PAGAMENTO DE SALÁRIOS A RECOLHER AO FUNDO DE PARTICIPAÇÃO DESTINADO A EXECUÇÃO DO PIS E DO PASEP, GERADOS PELO PAGAMENTO DE SALÁRIOS RELATIVOS A RESTOS A PAGAR PROCESSADOS - RRPS E DEVERAO SER DESDO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.3.98.00.00.00.0000','OUTROS ENCARGOS SOCIAIS - INTER - UNIÃO','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGAÇÕES PARA A ENTIDADE, CUJA CLASSIFICAÇÃO NÃO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.4.00.00.00.00.0000','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','COMPREENDE AS OBRIGAÇÕES DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NÃO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NÃO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PÚBLICO E AS DEMAIS CONTRIBUIÇÕES SOCIAIS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.4.01.00.00.00.0000','OBRIGAÇÕES PATRONAIS A RECOLHER - RPPS DO ESTADO - DO EXERCICIO','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE AO RPPS DO ESTADO LIQUIDADAS E AINDA NÃO PAGAS DURANTE O EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.4.02.00.00.00.0000','OBRIGAÇÕES PATRONAIS A RECOLHER - RPPS DO ESTADO - DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE AO RPPS DO ESTADO LIQUIDADAS E NÃO PAGAS DENTRO DO EXERCICIO, FICANDO PORTANTO EM RESTOS A PAGAR','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.4.03.00.00.00.0000','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA','COMPREENDE OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.4.03.01.00.00.0000','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.4.03.02.00.00.0000','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.4.98.00.00.00.0000','OUTROS ENCARGOS SOCIAIS - INTER ESTADO','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.5.00.00.00.00.0000','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','COMPREENDE AS OBRIGAÇÕES DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NÃO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NÃO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PÚBLICO E AS DEMAIS CONTRIBUIÇÕES SOCIAIS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.5.01.00.00.00.0000','OBRIGAÇÕES PATRONAIS A RECOLHER - RPPS DE OUTROS MUNICIPIOS - DO EXERCICIO','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE AO RPPS DE OUTROS MUNICIPIOS LIQUIDADAS E AINDA NÃO PAGAS DURANTE O EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.5.02.00.00.00.0000','OBRIGAÇÕES PATRONAIS A RECOLHER - RPPS DE OUTROS MUNICIPIOS - DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE AO RPPS DE OUTROS MUNICIPIOS LIQUIDADAS E NÃO PAGAS DENTRO DO EXERCICIO, FICANDO PORTANTO EM RESTOS A PAGAR','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.5.03.00.00.00.0000','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA','COMPREENDE OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.5.03.01.00.00.0000','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.5.03.02.00.00.0000','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.1.4.5.98.00.00.00.0000','OUTROS ENCARGOS SOCIAIS - INTER - MUNICIPIOS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.0.0.00.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO','COMPREENDE AS OBRIGAÇÕES FINANCEIRAS DA ENTIDADE A TITULO DE EMPRÉSTIMOS, BEM COMO FINANCIAMENTO DE AQUISICOES EFETUADAS DIRETAMENTE DO FORNECEDOR, COM VENCIMENTOS NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.0.00.00.00.00.0000','EMPRÉSTIMOS A CURTO PRAZO - INTERNO','COMPREENDE OS EMPRÉSTIMOS CONTRATUAIS OU MOBILIÁRIOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTOS NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.1.00.00.00.00.0000','EMPRÉSTIMOS A CURTO PRAZO - INTERNO -CONSOLIDAÇÃO','COMPREENDE OS EMPRÉSTIMOS CONTRATUAIS OU MOBILIÁRIOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTOS NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.1.01.00.00.00.0000','PARCELA A CURTO PRAZO DOS EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS','REGISTRA AS PARCELAS DOS EMPRÉSTIMOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.1.02.00.00.00.0000','EMPRESTIMOS INTERNOS - EM TITULOS','REGISTRA O RECONHECIMENTO DOS EMPRÉSTIMOS DECORRENTES DE TÍTULOS MOBILIÁRIOS ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.1.02.01.00.00.0000','DÍVIDA MOBILIÁRIA','REGISTRA OS VALORES EXIGÍVEIS, DECORRENTES DA EMISSÃO DE TÍTULOS DA DÍVIDA MOBILIÁRIA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.1.02.02.00.00.0000','(-) DESÁGIO DE TÍTULOS','REGISTRA OS VALORES RELATIVOS A DESÁGIO OCORRIDOS EM TÍTULOS.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.1.02.98.00.00.0000','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','REGISTRA OS VALORES DECORRENTES DA COLOCAÇÃO NO MERCADO DE TÍTULOS, PARA OS QUAIS NÃO HAJA CONTAS ESPECÍFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.1.03.00.00.00.0000','EMPRESTIMOS INTERNOS - EM CONTRATOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.1.03.03.00.00.0000','CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.1.03.05.00.00.0000','CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.1.03.07.00.00.0000','ANTECIPACAO DE RECEITA ORCAMENTARIA','REGISTRA OS VALORES REFERENTES A OPERACOES DE CREDITO POR ANTECIPACAO DE RECEITA DESTINADA A ATENDER INSUFICIENCIA DE CAIXA DURANTE O EXERCICIO FINANCEIRO, DEVENDO CUMPRIR AS EXIGENCIAS MENCIONADAS NO ART. 32 DA LEI COMPLEMENTAR Nº 101, PUBLICADA EM 04/05/2000 E AQUELAS PREVISTAS NO ART. 38 DA REFERIDA LEI.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.1.03.10.00.00.0000','OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES - DO EXERCICIO','REGISTRA O VALOR DAS OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.1.03.98.00.00.0000','OUTROS CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS, PARA AS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.3.00.00.00.00.0000','PARCELA A CURTO PRAZO DOS EMPRÉSTIMOS E FINANCIAMENTOS -INTER OFSS - UNIÃO','COMPREENDE OS EMPRÉSTIMOS E CONTRATUAIS OU MOBILIÁRIOS ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.3.01.00.00.00.0000','PARCELA A CURTO PRAZO DOS EMPRESTIMOS INTERNOS','REGISTRA AS PARCELAS DOS EMPRESTIMOS ASSUMIDOS CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.3.02.00.00.00.0000','EMPRESTIMOS INTERNOS - EM TITULOS','REGISTRA O RECONHECIMENTO DOS EMPRÉSTIMOS DECORRENTES DE TÍTULOS MOBILIÁRIOS COM VENCIMENTO ATÉ O TERMINO DO EXERCÍCIO SEGUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.3.02.01.00.00.0000','DÍVIDA MOBILIÁRIA','REGISTRA OS VALORES EXIGÍVEIS, DECORRENTES DA EMISSÃO DE TÍTULOS DA DÍVIDA MOBILIÁRIA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.3.02.02.00.00.0000','(-) DESÁGIO DE TÍTULOS','REGISTRA OS VALORES RELATIVOS A DESÁGIO OCORRIDOS EM TÍTULOS.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.3.02.98.00.00.0000','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','REGISTRA OS VALORES DECORRENTES DA COLOCAÇÃO NO MERCADO DE TÍTULOS, PARA OS QUAIS NÃO HAJA CONTAS ESPECÍFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.3.03.00.00.00.0000','EMPRESTIMOS INTERNOS - EM CONTRATOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.3.03.01.00.00.0000','CONTRATOS DE EMPRESTIMOS DO EXERCICIO','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.3.03.02.00.00.0000','CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.3.03.03.00.00.0000','OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES - DO EXERCICIO','REGISTRA O VALOR DAS OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.3.03.98.00.00.0000','DEMAIS EMPRESTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS DEMAIS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS NÃO COMPREENDIDOS NAS CONTAS ACIMA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.4.00.00.00.00.0000','EMPRÉSTIMOS A CURTO PRAZO - INTERNO - INTER OFSS - ESTADO','COMPREENDE OS EMPRÉSTIMOS E CONTRATUAIS OU MOBILIÁRIOS ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.4.02.00.00.00.0000','EMPRESTIMOS INTERNOS - EM TITULOS','REGISTRA O RECONHECIMENTO DOS EMPRÉSTIMOS DECORRENTES DE TÍTULOS MOBILIÁRIOS COM VENCIMENTO ATÉ O TERMINO DO EXERCÍCIO SEGUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.4.02.01.00.00.0000','DÍVIDA MOBILIÁRIA','REGISTRA OS VALORES EXIGÍVEIS, DECORRENTES DA EMISSÃO DE TÍTULOS DA DÍVIDA MOBILIÁRIA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.4.02.02.00.00.0000','(-) DESÁGIO DE TÍTULOS','REGISTRA OS VALORES RELATIVOS A DESÁGIO OCORRIDOS EM TÍTULOS.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.4.02.98.00.00.0000','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','REGISTRA OS VALORES DECORRENTES DA COLOCAÇÃO NO MERCADO DE TÍTULOS, PARA OS QUAIS NÃO HAJA CONTAS ESPECÍFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.4.03.00.00.00.0000','EMPRESTIMOS INTERNOS - EM CONTRATOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.4.03.01.00.00.0000','CONTRATOS DE EMPRESTIMOS DO EXERCICIO','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.4.03.02.00.00.0000','CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.4.03.03.00.00.0000','OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES - DO EXERCICIO','REGISTRA O VALOR DAS OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.4.03.98.00.00.0000','DEMAIS EMPRESTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS DEMAIS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS NÃO COMPREENDIDOS NAS CONTAS ACIMA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.5.00.00.00.00.0000','EMPRÉSTIMOS A CURTO PRAZO - INTERNO-INTER OFSS - MUNICÍPIO','COMPREENDE OS EMPRÉSTIMOS E CONTRATUAIS OU MOBILIÁRIOS ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.5.02.00.00.00.0000','EMPRESTIMOS INTERNOS - EM TITULOS','REGISTRA O RECONHECIMENTO DOS EMPRÉSTIMOS DECORRENTES DE TÍTULOS MOBILIÁRIOS COM VENCIMENTO ATÉ O TERMINO DO EXERCÍCIO SEGUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.5.02.01.00.00.0000','DÍVIDA MOBILIÁRIA','REGISTRA OS VALORES EXIGÍVEIS, DECORRENTES DA EMISSÃO DE TÍTULOS DA DÍVIDA MOBILIÁRIA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.5.02.02.00.00.0000','(-) DESÁGIO DE TÍTULOS','REGISTRA OS VALORES RELATIVOS A DESÁGIO OCORRIDOS EM TÍTULOS.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.5.02.98.00.00.0000','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','REGISTRA OS VALORES DECORRENTES DA COLOCAÇÃO NO MERCADO DE TÍTULOS, PARA OS QUAIS NÃO HAJA CONTAS ESPECÍFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.5.03.00.00.00.0000','EMPRESTIMOS INTERNOS - EM CONTRATOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.5.03.01.00.00.0000','CONTRATOS DE EMPRESTIMOS DO EXERCICIO','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.5.03.02.00.00.0000','CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.5.03.03.00.00.0000','OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES - DO EXERCICIO','REGISTRA O VALOR DAS OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.1.5.03.98.00.00.0000','DEMAIS EMPRESTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS DEMAIS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS NÃO COMPREENDIDOS NAS CONTAS ACIMA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.2.0.00.00.00.00.0000','EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','COMPREENDE OS EMPRÉSTIMOS CONTRATUAIS OU MOBILIÁRIOS ASSUMIDOS NO EXTERIOR E TRANSACIONADOS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.2.1.00.00.00.00.0000','EMPRÉSTIMOS A CURTO PRAZO - EXTERNO CONSOLIDAÇÃO','COMPREENDE OS EMPRÉSTIMOS CONTRATUAIS OU MOBILIÁRIOS ASSUMIDOS NO EXTERIOR E TRANSACIONADOS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO CURTO PRAZO COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.2.1.01.00.00.00.0000','PARCELA A CURTO PRAZO DOS EMPRESTIMOS EXTERNOS','REGISTRA AS PARCELAS DOS EMPRESTIMOS EXTERNOS ASSUMIDOS, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.2.1.02.00.00.00.0000','EMPRÉSTIMOS EXTERNOS - EM TÍTULOS','COMPREENDE OS VALORES DAS OPERAÇÕES DE CRÉDITO EXTERNAS DECORRENTES DA EMISSÃO DE TÍTULOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.2.1.03.00.00.00.0000','EMPRÉSTIMOS EXTERNOS - EM CONTRATOS','COMPREENDE OS VALORES DAS OPERAÇÕES DE CRÉDITO INTERNAS EM CONTRATOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.2.1.03.01.00.00.0000','CONTRATOS DE EMPRESTIMOS DO EXERCÍCIO','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCÍCIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.2.1.03.02.00.00.0000','CONTRATOS DE EMPRESTIMOS DO EXEECÍCIO ANTERIOR','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCÍCIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.2.1.03.10.00.00.0000','OPERAÇÕES DE CRÉDITO EXTERNAS COM PRAZO INFERIOR A DOZE MESES - DO EXERCÍCIO','REGISTRA O VALOR DAS OPERAÇÕES DE CRÉDITO EXTERNAS COM PRAZO INFERIOR A DOZE MESES','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.2.1.03.98.00.00.0000','DEMAIS EMPRÉSTIMOS EXTERNOS - EM CONTRATOS','REGISTRA OS DEMAIS VALORES DAS OPERAÇÕES DE CRÉDITO EXTERNAS EM CONTRATOS NÃO COMPREENDIDOS NAS CONTAS ACIMA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.0.00.00.00.00.0000','FINANCIAMENTOS A CURTO PRAZO - INTERNO','COMPREENDE AS OBRIGAÇÕES DECORRENTES DE AQUISIÇÕES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUIÇÃO FINANCEIRA ASSUMIDAS DENTRO DO PAÍS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.1.00.00.00.00.0000','FINANCIAMENTOS A CURTO PRAZO- INTERNO - CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES DECORRENTES DE AQUISIÇÕES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUIÇÃO FINANCEIRA ASSUMIDAS DENTRO DO PAÍS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO.. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.1.01.00.00.00.0000','PARCELA A CURTO PRAZO DOS FINANCIAMENTOS INTERNOS','REGISTRA AS PARCELAS DOS FINANCIAMENTOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.1.02.00.00.00.0000','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGÍVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.1.02.01.00.00.0000','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.1.02.02.00.00.0000','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.1.02.98.00.00.0000','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.1.03.00.00.00.0000','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.3.00.00.00.00.0000','FINANCIAMENTOS A CURTO PRAZO-INTER OFSS - UNIÃO','COMPREENDE AS OBRIGAÇÕES DECORRENTES DE AQUISIÇÕES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUIÇÃO FINANCEIRA ASSUMIDAS DENTRO DO PAÍS E TRANSACIONAIS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.3.01.00.00.00.0000','PARCELA DE CURTO PRAZO DOS FINANCIAMENTOS INTERNOS','REGISTRA AS PARCELASDOS FINANCIAMENTOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTO A CURTO PRAZO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.3.02.00.00.00.0000','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.3.02.01.00.00.0000','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.3.02.02.00.00.0000','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.3.02.98.00.00.0000','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.3.03.00.00.00.0000','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.4.00.00.00.00.0000','FINANCIAMENTOS A CURTO PRAZO-INTER OFSS - ESTADO','COMPREENDE AS OBRIGAÇÕES DECORRENTES DE AQUISIÇÕES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUIÇÃO FINANCEIRA ASSUMIDAS DENTRO DO PAÍS E TRANSACIONAIS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.4.01.00.00.00.0000','PARCELA DE CURTO PRAZO DOS FINANCIAMENTOS INTERNOS','REGISTRA AS PARCELASDOS FINANCIAMENTOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTO A CURTO PRAZO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.4.02.00.00.00.0000','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.4.02.01.00.00.0000','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.4.02.02.00.00.0000','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.4.02.98.00.00.0000','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.4.03.00.00.00.0000','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.5.00.00.00.00.0000','FINANCIAMENTOS A CURTO PRAZO-INTER OFSS - MUNICÍPIO','COMPREENDE AS OBRIGAÇÕES DECORRENTES DE AQUISIÇÕES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUIÇÃO FINANCEIRA ASSUMIDAS DENTRO DO PAÍS E TRANSACIONAIS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.5.01.00.00.00.0000','PARCELA DE CURTO PRAZO DOS FINANCIAMENTOS INTERNOS','REGISTRA AS PARCELASDOS FINANCIAMENTOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTO A CURTO PRAZO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.5.02.00.00.00.0000','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.5.02.01.00.00.0000','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.5.02.02.00.00.0000','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.5.02.98.00.00.0000','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.3.5.03.00.00.00.0000','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.4.0.00.00.00.00.0000','FINANCIAMENTO A CURTO PRAZO - EXTERNO','COMPREENDE AS OBRIGAÇÕES DECORRENTES DE AQUISIÇÕES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUIÇÃO FINANCEIRA ASSUMIDAS NO EXTERIOR E TRANSACIONADAS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO A CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.4.1.00.00.00.00.0000','FINANCIAMENTOS A CURTO PRAZO - EXTERNO -CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES DECORRENTES DE AQUISIÇÕES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUIÇÃO FINANCEIRA ASSUMIDAS NO EXTERIOR E TRANSACIONADAS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO A CURTO PRAZO.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.4.1.01.00.00.00.0000','PARCELA A CURTO PRAZO DOS FINANCIAMENTOS EXTERNOS','REGISTRA AS PARCELAS DOS FINANCIAMENTOS EXTERNOS ASSUMIDOS CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.4.1.02.00.00.00.0000','FINANCIAMENTOS EXTERNOS','COMPREENDE OS VALORES DOS FINANCIAMENTOS EXTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.4.1.02.01.00.00.0000','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.4.1.02.98.00.00.0000','OUTROS FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.4.1.03.00.00.00.0000','FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.0.00.00.00.00.0000','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETÊNCIA E PAGÁVEIS A CURTO PRAZO, ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.1.00.00.00.00.0000','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETÊNCIA E PAGÁVEIS A CURTO PRAZO, ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.1.01.00.00.00.0000','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.1.01.01.00.00.0000','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.1.01.02.00.00.0000','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.1.01.03.00.00.0000','JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.1.02.00.00.00.0000','ENCARGOS - EMPRESTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.1.02.01.00.00.0000','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.1.02.02.00.00.0000','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.1.03.00.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.1.03.01.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.1.03.02.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.1.03.03.00.00.0000','JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.1.04.00.00.00.0000','ENCARGOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.1.04.01.00.00.0000','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.1.04.02.00.00.0000','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.3.00.00.00.00.0000','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO-INTER OFSS - UNIÃO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETÊNCIA E PAGÁVEIS A CURTO PRAZO, ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL . COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.3.01.00.00.00.0000','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.3.01.01.00.00.0000','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.3.01.02.00.00.0000','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.3.01.03.00.00.0000','JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.3.02.00.00.00.0000','ENCARGOS - EMPRESTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.3.02.01.00.00.0000','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.3.02.02.00.00.0000','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.3.03.00.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.3.03.01.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.3.03.02.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.3.03.03.00.00.0000','JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.3.04.00.00.00.0000','ENCARGOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.3.04.01.00.00.0000','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.3.04.02.00.00.0000','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.4.00.00.00.00.0000','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO-INTER OFSS - ESTADO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETÊNCIA E PAGÁVEIS A CURTO PRAZO, ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL . COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.4.01.00.00.00.0000','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.4.01.01.00.00.0000','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.4.01.02.00.00.0000','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.4.01.03.00.00.0000','JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.4.02.00.00.00.0000','ENCARGOS - EMPRESTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.4.02.01.00.00.0000','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.4.02.02.00.00.0000','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.4.03.00.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.4.03.01.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.4.03.02.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.4.03.03.00.00.0000','JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.4.04.00.00.00.0000','ENCARGOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.4.04.01.00.00.0000','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.4.04.02.00.00.0000','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.5.5.00.00.00.00.0000','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO-INTER OFSS - MUNICÍPIO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETÊNCIA E PAGÁVEIS A CURTO PRAZO, ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL . COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.6.0.00.00.00.00.0000','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - EXTERNO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETÊNCIA E PAGÁVEIS A CURTO PRAZO, ASSUMIDOS NO EXTERIOR E TRANSACIONADOS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTOS NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.6.1.00.00.00.00.0000','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – EXTERNO - CONSOLIDAÇÃO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETÊNCIA E PAGÁVEIS A CURTO PRAZO, ASSUMIDOS NO EXTERIOR E TRANSACIONADOS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTOS NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.6.1.01.00.00.00.0000','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.6.1.02.00.00.00.0000','ENCARGOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.6.1.03.00.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.6.1.04.00.00.00.0000','ENCARGOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.8.0.00.00.00.00.0000','(-) ENCARGOS FINANCEIROS A APRORIAR - INTERNO','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRÉSTIMO E DE FINANCIAMENTO A CURTO PRAZO - INTERNO, MAS QUE AINDA NÃO TRANSCORRERAM POR NÃO TER OCORRIDO AINDA O FATO GERADOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.8.1.00.00.00.00.0000','(-) ENCARGOS FINANCEIROS A APRORIAR – INTERNO - CONSOLIDAÇÃO','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRÉSTIMO E DE FINANCIAMENTO A CURTO PRAZO - INTERNO, MAS QUE AINDA NÃO TRANSCORRERAM POR NÃO TER OCORRIDO AINDA O FATO GERADOR.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.8.1.01.00.00.00.0000','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRÉ-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRÉSTIMOS INTERNOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.8.1.02.00.00.00.0000','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRÉ-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS INTERNOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.8.3.00.00.00.00.0000','(-) ENCARGOS FINANCEIROS A APRORIAR – INTERNO – INTER OFSS - UNIÃO','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRÉSTIMO E DE FINANCIAMENTO A CURTO PRAZO - INTERNO, MAS QUE AINDA NÃO TRANSCORRERAM POR NÃO TER OCORRIDO AINDA O FATO GERADOR.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS), DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.8.3.01.00.00.00.0000','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRÉ-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRÉSTIMOS INTERNOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.8.3.02.00.00.00.0000','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRÉ-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS INTERNOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.8.4.00.00.00.00.0000','(-) ENCARGOS FINANCEIROS A APRORIAR – INTERNO – INTER OFFS - ESTADO','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRÉSTIMO E DE FINANCIAMENTO A CURTO PRAZO - INTERNO, MAS QUE AINDA NÃO TRANSCORRERAM POR NÃO TER OCORRIDO AINDA O FATO GERADOR.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS), DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.8.4.01.00.00.00.0000','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRÉ-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRÉSTIMOS INTERNOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.8.4.02.00.00.00.0000','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRÉ-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS INTERNOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.8.5.00.00.00.00.0000','(-) ENCARGOS FINANCEIROS A APRORIAR – INTERNO – INTER OFSS – MUNICÍPIO','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRÉSTIMO E DE FINANCIAMENTO A CURTO PRAZO - INTERNO, MAS QUE AINDA NÃO TRANSCORRERAM POR NÃO TER OCORRIDO AINDA O FATO GERADOR.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS), DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.9.0.00.00.00.00.0000','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRÉSTIMO E DE FINANCIAMENTO A CURTO PRAZO - EXTERNO, MAS QUE AINDA NÃO TRANSCORRERAM POR NÃO TER OCORRIDO AINDA O FATO GERADOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.2.9.1.00.00.00.00.0000','(-) ENCARGOS FINANCEIROS A APROPRIAR- CONSOLIDAÇÃO','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRÉSTIMO E DE FINANCIAMENTO A CURTO PRAZO - EXTERNO, MAS QUE AINDA NÃO TRANSCORRERAM POR NÃO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.0.0.00.00.00.00.0000','FORNECEDORES E CONTAS A PAGAR A CURTO PRAZO','COMPREENDE AS OBRIGAÇÕES JUNTO A FORNECEDORES DE MATÉRIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGAÇÕES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTAÇÃO DE SERVIÇOS, TAIS COMO DE ENERGIA ELÉTRICA, ÁGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR INCLUSIVE OS PRECATÓRIOS DECORRENTES DESSAS OBRIGAÇÕES,COM VENCIMENTO NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.0.00.00.00.00.0000','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO','COMPREENDE AS OBRIGAÇÕES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGAÇÕES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTAÇÃO DE SERVIÇOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.00.00.00.00.0000','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO - CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGAÇÕES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTAÇÃO DE SERVIÇOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO NO CURTO PRAZO.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.01.00.00.00.0000','FORNECEDORES NACIONAIS DO EXERCÍCIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVIÇOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCÍCIO ATUAL.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.02.00.00.00.0000','FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVIÇOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCÍCIOS ANTERIORES.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.03.00.00.00.0000','PRECATÓRIOS DE FORNECEDORES NACIONAIS','COMPREENDE AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE FORNECEDORES NACIONAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.03.01.00.00.0000','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.03.02.00.00.0000','PRECATÓRIOS DE FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES - ANTERIORES A 05/05/2000','COMPREENDE OS VALORES RELATIVOS A PRECATÓRIOS DE FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.03.02.01.00.0000','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE FORNECEDORES, ATE 05/05/2000 DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.03.02.02.00.0000','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE FORNECEDORES, ATE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.03.02.03.00.0000','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE FORNECEDORES, ATE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.03.03.00.00.0000','PRECATÓRIOS DE FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','COMPREENDE OS VALORES RELATIVOS A PRECATÓRIOS DE FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.03.03.01.00.0000','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.03.03.02.00.0000','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.03.03.03.00.0000','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.04.00.00.00.0000','CONTAS A PAGAR CREDORES NACIONAIS DO EXERCÍCIO','REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTAÇÃO DE SERVIÇOS, REFERENTES AO EXERCÍCIO ATUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.04.01.00.00.0000','CONTAS A PAGAR DO EXERCICIO','REGISTRA O RECONHECIMENTO PATRIMONIAL DE VALORES A PAGAR AOS CREDORES NACIONAIS DE BENS, MATERIAIS E SERVIÇOS, REFERENTES AO EXERCICIO ATUAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.04.02.00.00.0000','CONTAS A PAGAR DO EXERCICIO - EMPENHADOS','REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DE BENS, MATERIAIS E SERVIÇOS, REFERENTES AO EXERCICIO ATUAL, QUE JÁ PASSARAM PELA EXECUÇÃO ORÇAMENTÁRIA DA DESPESA (EMPENHO).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.05.00.00.00.0000','CONTAS A PAGAR CREDORES NACIONAIS DE EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTAÇÃO DE SERVIÇOS, REFERENTES A EXERCÍCIOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.05.01.00.00.0000','CREDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REPRESENTA O MONTANTE DAS DESPESAS COM CREDORES REALIZADAS E LIQUIDADAS PELO PODER EXECUTIVO E ENTIDADES DA ADMINISTRAÇÃO INDIRETA E NÃO PAGAS ATÉ 31 DE DEZEMBRO DO ANO ANTERIOR E DEVEM SER DESDOBRADAS POR EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.05.02.00.00.0000','CREDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REPRESENTA O MONTANTE DAS DESPESAS COM CREDORES REALIZADAS E LIQUIDADAS PELO PODER LEGISLATIVO E NÃO PAGAS ATÉ 31 DE DEZEMBRO DO ANO ANTERIOR E DEVERAO SER DESDOBRADAS POR EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.05.03.00.00.0000','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - RPPS','REPRESENTA O MONTANTE DAS DESPESAS COM FORNECEDORES REALIZADAS E LIQUIDADAS PELO REGIME PRÓPRIO DE PREVIDÊNCIA DO SERVIDOR E NÃO PAGAS ATÉ 31 DE DEZEMBRO DO ANO ANTERIOR E DEVERAO SER DESDOBRADAS POR EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.06.00.00.00.0000','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS','COMPREENDE AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.06.01.00.00.0000','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DO EXERCÍCIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.06.02.00.00.0000','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCÍCIOS ANTERIORES','COMPREENDE OS VALORES RELATIVOS A PRECATÓRIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DE EXERCÍCIOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.06.02.01.00.0000','PRECATÓRIOS A PAGAR (ANTERIORES 05/05/2000)','REGISTRAR O VALOR DOS PRECATÓRIOS A PAGAR REFERENTE A PESSOAL, FORNECEDORES E TERCEIROS, ANTERIORES A 05/05/2000.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.06.02.01.01.0000','CREDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE CREDORES, ATE 05/05/2000 DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.06.02.01.02.0000','CREDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE CREDORES, ATE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.06.02.01.03.0000','CREDORES - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE CREDORES, ATE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.06.02.02.00.0000','FORNECEDORES - A PARTIR DE 05/05/2000','REGISTRA OS VALORES DE PRECATÓRIOS PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.06.02.02.01.0000','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.06.02.02.02.0000','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.06.02.02.03.0000','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.1.1.07.00.00.00.0000','POR INSUFICIÊNCIA DE CRÉDITOS/RECURSOS','REGISTRA OS VALORES DAS OBRIGAÇÕES TRIBUTÁRIAS DEVIDAMENTE RECONHECIDAS, DE FORDECEDORES DE BENS E/OU SERVIÇOS, NÃO CONTEMPLADAS PELA EXECUÇÃO ORCAMENTARIA EM VIRTUDE DA LIMITAÇÃO DA PROGRAMAÇÃO FINANCEIRA OU POR INSUFICIÊNCIA DE CRÉDITOS, OU AINDA EM FASE DE IDENTIFICAÇÃO DO CRÉDITO ORCAMENTARIO, CONFORME DISPOSTO NA NOTA TECNICA STN/CCONT Nº 2309, DE 28 DE DEZEMBRO DE 2007.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.2.0.00.00.00.00.0000','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO','COMPREENDE AS OBRIGAÇÕES JUNTO A FORNECEDORES ESTRANGEIROS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGAÇÕES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTAÇÃO DE SERVIÇOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.2.1.00.00.00.00.0000','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO - CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES JUNTO A FORNECEDORES ESTRANGEIROS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGAÇÕES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTAÇÃO DE SERVIÇOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO ATE O TÉRMINO DO EXERCÍCIO SEGUINTE.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.2.1.01.00.00.00.0000','FORNECEDORES ESTRANGEIROS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.2.1.02.00.00.00.0000','FORNECEDORES ESTRANGEIROS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.2.1.03.00.00.00.0000','CONTAS A PAGAR - CREDORES ESTRANGEIROS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS CREDORES ESTRANGEIROS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES AO EXERCICIO ATUAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.3.2.1.04.00.00.00.0000','CONTAS A PAGAR - CREDORES ESTRANGEIROS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS CREDORES ESTRANGEIROS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.0.0.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A CURTO PRAZO','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES COM VENCIMENTO NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.0.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIAO','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES, COM VENCIMENTO NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO- CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.01.00.00.00.0000','IPI A RECOLHER','REGISTRA O VALOR DAS OBRIGAÇÕES TRIBUTÁRIAS A RECOLHER REFERENTES AO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS DAS UNIDADES INDUSTRIAIS OU COM CARACTERISTICAS DESSAS, GERADAS PELAS VENDAS DE PRODUTOS INDUSTRIAIS E SUJEITAS A COMPENSACAO COM OS CRÉDITOS ADQUIRIDOS POR COMPRAS DE MATÉRIAS-PRIMAS, EM CONFORMIDADE COM A SISTEMATICA DE APURACAO DESSE IMPOSTO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.02.00.00.00.0000','IRPJ A RECOLHER','REGISTRA O VALOR DAS OBRIGAÇÕES A RECOLHER RELATIVAS AO IMPOSTO DE RENDA PESSOA JURIDICA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.03.00.00.00.0000','PASSIVO FISCAL DIFERIDO','REGISTRA OS VALORES DE DÉBITOS FISCAIS DE CURTO PRAZO RELATIVOS A DIFERENÇAS INTERTEMPORAIS (DELIBERAÇÃO DA CVM Nº 273, DE 20/08/98), CORRESPONDENTES AO IMPOSTO DE RENDA PESSOA JURÍDICA (IRPJ) E CONTRIBUIÇÃO SOCIAL SOBRE O LUCRO LÍQUIDO (CSSL), BEM COMO PIS/PASEP E CONFINS (LEI Nº 9718 DE 27/11/1998).J1402','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.04.00.00.00.0000','IMPOSTO DE IMPORTAÇÃO A RECOLHER','REGISTRA O VALOR DAS OBRIGAÇÕES A RECOLHER RELATIVAS AO IMPOSTO DE IMPORTAÇÃO A RECOLHER.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.05.00.00.00.0000','IOF A RECOLHER','REGISTRA O VALOR DAS OBRIGAÇÕES A RECOLHER RELATIVAS AO IMPOSTO SOBRE OPERAÇÕES FINANCEIRAS A RECOLHER.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.06.00.00.00.0000','ITR A RECOLHER','REGISTRA O VALOR DAS OBRIGAÇÕES A RECOLHER RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL (ITR).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.08.00.00.00.0000','CIDE A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO (CIDE) (LEI Nº 10.168/2000).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.09.00.00.00.0000','CSSL A RECOLHER','REGISTRA O VALOR DAS OBRIGAÇÕES EXIGÍVEIS A CURTO PRAZO RELATIVAS A CONTRIBUIÇÃO SOCIAL SOBRE O LUCRO DAS PESSOAS JURÍDICAS (CSSL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.10.00.00.00.0000','COFINS A RECOLHER','REGISTRA O VALOR DAS OBRIGAÇÕES EXIGÍVEIS A CURTO PRAZO A RECOLHER RELATIVAS À CONTRIBUIÇÃO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL (COFINS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.11.00.00.00.0000','PIS/PASEP A RECOLHER','REGISTRA O VALOR DAS OBRIGAÇÕES A RECOLHER RELATIVAS AO PROGRAMA DE INTEGRAÇÃO SOCIAL (PIS) E PROGRAMA DE FORMAÇÃO DO PATRIMONIO DO SERVIDOR PÚBLICO ( PASEP).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.11.01.00.00.0000','PIS/PASEP - DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REALTIVAS AO PIS/PASEP REFERENTE A COMPETENCIA DO EXERCÍCIO','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.11.02.00.00.0000','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA AS OBRIGAÇÕES REALTIVAS AO PIS/PASEP REFERENTE A COMPETENCIA DE EXERCICOS ANTERIORES REGISTRADAS EM RESTOS A PAGAR DO PODER EXECUTIVO E DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.11.03.00.00.0000','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA AS OBRIGAÇÕES REALTIVAS AO PIS/PASEP REFERENTE A COMPETENCIA DE EXERCICOS ANTERIORES REGISTRADAS EM RESTOS A PAGAR DO PODER LEGISLATIVO E DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.11.04.00.00.0000','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA AS OBRIGAÇÕES REALTIVAS AO PIS/PASEP REFERENTE A COMPETENCIA DE EXERCICOS ANTERIORES REGISTRADAS EM RESTOS A PAGAR DO RPPS E DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.12.00.00.00.0000','TRIBUTOS FEDERAIS RENEGOCIADOS','REGISTRA OS VALORES EXIGÍVEIS A CURTO PRAZO DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS FEDERAIS QUE TENHAM SIDO RENEGOCIADOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.13.00.00.00.0000','RECURSOS FISCAIS - DARF A EMITIR','REGISTRA O VALOR DOS CRÉDITOS FISCAIS RECEBIDOS PELAS REPARTICOES PÚBLICAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, OU SEJA, VALORES A SEREM RECOLHIDOS POR MEIO DE DARF. REGISTRA OS VALORES EXIGÍVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUIÇÕES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, POR MEIO DE DOCUMENTO DE ARRECADAÇÃO DE RECEITAS FEDERAIS (DARF).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.1.1.99.00.00.00.0000','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','REGISTRA OS VALORES EXIGÍVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUIÇÕES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.2.0.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA ESTADUAL COM VENCIMENTO NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.2.1.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS- CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA ESTADUAL COM VENCIMENTO NO CURTO PRAZO.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.2.1.01.00.00.00.0000','ICMS A RECOLHER','COMPREENDE O VALOR DAS OBRIGAÇÕES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVIÇOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVIÇOS (ICMS), SUJEITOS A COMPENSAÇÕES COM OS CRÉDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVIÇOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO OU SOBRE MERCADORIAS DE TERCEIROS ENTREGUES PARA DEPOSITO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.2.1.01.01.00.00.0000','ICMS A RECOLHER - SOBRE MERCADORIAS PARA REVENDA','REGISTRA O VALOR DAS OBRIGAÇÕES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVIÇOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVIÇOS (ICMS), SUJEITAS A COMPENSAÇÕES COM OS CRÉDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVIÇOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.2.1.01.02.00.00.0000','ICMS A RECOLHER - SOBRE MERCADORIAS DE TERCEIROS PARA DEPOSITO','REGISTRA O VALOR DAS OBRIGAÇÕES EXIGIVEIS EM FUNCAO DA ENTRADA DE MERCADORIAS DE TERCEIROS ENTREGUES A UNIDADE PARA DEPOSITO EM ARMAZEM.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.2.1.02.00.00.00.0000','IPVA A RECOLHER','REGISTRA O VALOR DAS OBRIGAÇÕES EXIGÍVEIS RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES (IPVA).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.2.1.03.00.00.00.0000','TRIBUTOS ESTADUAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.2.1.06.00.00.00.0000','TAXA DE LICENCIAMENTO ANUAL DE VEICULOS','REGISTRA O VALOR DAS OBRIGAÇÕES JUNTO AO GOVERNO ESTADUAL, REFERENTE AO PAGAMENTO DA TAXA DE LICENCIAMENTO ANUAL DE VEICULOS, DECORRENTE DO SERVICO DE LICENCIAMENTO DE VEICULOS AUTOMOTORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.2.1.07.00.00.00.0000','RECURSOS FISCAIS ESTADUAIS','REGISTRA O VALOR DOS CRÉDITOS FISCAIS ORIUNDOS DE RECEBIMENTOS DE TRIBUTOS ESTADUAIS CUJO RECOLHIMENTO E REALIZADO POR MEIO DE DAR. REGISTRA OS VALORES EXIGÍVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUIÇÕES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, POR MEIO DE DOCUMENTO DE ARRECADAÇÃO (DAR).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.2.1.08.00.00.00.0000','TAXA DE LICENCIAMENTO AMBIENTAL','REGISTRA OS COMPROMISSOS EXIGÍVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.2.1.99.00.00.00.0000','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGÍVEIS A CURTO PRAZO, DECORRENTES DA INCIDÊNCIA DE TRIBUTOS PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS. REGISTRA OS VALORES EXIGÍVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUIÇÕES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.3.0.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA MUNICIPAL COM VENCIMENTO NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.3.1.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA MUNICIPAL COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.3.1.01.00.00.00.0000','ISS A RECOLHER','REGISTRA O VALOR DAS OBRIGAÇÕES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA (ISS) EM QUE A PROPRIA UNIDADE SEJA A PRESTADORA DO SERVICO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.3.1.02.00.00.00.0000','IPTU/TLP A RECOLHER','REGISTRA O VALOR DAS OBRIGAÇÕES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA (IPTU) E TAXA DE LIMPEZA PÚBLICA (TLP).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.3.1.03.00.00.00.0000','TRIBUTOS MUNICIPAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA UNIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.3.1.04.00.00.00.0000','CONTRIBUICAO P/ CUSTEIO DE ILUM. PÚBLICA A RECOLHER','REGISTRA O VALOR DAS OBRIGAÇÕES JUNTO AO GOVERNO MUNICIPAL REFERENTES A CONTRIBUICAO PARA CUSTEIO DE ILUMINAÇÃO PÚBLICA.(ART.149-A DA CONSTITUICAO FEDERAL)','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.3.1.06.00.00.00.0000','RECURSOS FISCAIS MUNICIPAIS','REGISTRA OS VALORES EXIGÍVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUIÇÕES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO MUNICIPAL, POR MEIO DE DOCUMENTO DE ARRECADAÇÃO (DAR).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.3.1.07.00.00.00.0000','TAXA DE LICENCIAMENTO AMBIENTAL','REGISTRA OS COMPROMISSOS EXIGÍVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.3.1.08.00.00.00.0000','TAXA DE INSPEÇÃO VEICULAR','REGISTRA O VALOR DAS OBRIGAÇÕES JUNTO AO GOVERNO MUNICIPAL REFERENTES A CTAXA DE INSPEÇÃO VEICULAR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.4.3.1.99.00.00.00.0000','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGÍVEIS, DECORRENTES DA INCIDÊNCIA DE TRIBUTOS PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.5.0.0.00.00.00.00.0000','OBRIGAÇÕES DE REPARTICAO A OUTROS ENTES','COMPREENDE OS VALORES ARRECADADOS DE IMPOSTOS E OUTRAS RECEITAS A SEREM REPARTIDOS AOS ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.5.0.3.00.00.00.00.0000','OBRIGAÇÕES DE REPARTICAO A OUTROS ENTES - INTER OFSS - UNIÃO','COMPREENDE OS VALORES ARRECADADOS DE IMPOSTOS E OUTRAS RECEITAS A SEREM REPARTIDOS AOS ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.5.0.4.00.00.00.00.0000','OBRIGAÇÕES DE REPARTICAO A OUTROS ENTES - INTER OFSS - ESTADO','COMPREENDE OS VALORES ARRECADADOS DE IMPOSTOS E OUTRAS RECEITAS A SEREM REPARTIDOS AOS ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.5.0.5.00.00.00.00.0000','OBRIGAÇÕES DE REPARTICAO A OUTROS ENTES - INTER OFSS - MUNICÍPIO','COMPREENDE OS VALORES ARRECADADOS DE IMPOSTOS E OUTRAS RECEITAS A SEREM REPARTIDOS AOS ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.0.0.00.00.00.00.0000','PROVISÕES A CURTO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.1.0.00.00.00.00.0000','PROVISAO PARA RISCOS TRABALHISTAS A CURTO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO RECLAMAÇÕES TRABALHISTAS, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.1.1.00.00.00.00.0000','PROVISÃO PARA RISCOS TRABALHISTAS A CURTO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE RECLAMAÇÕES TRABALHISTAS , COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.1.1.01.00.00.00.0000','PROVISAO PARA INDENIZAÇÕES TRABALHISTAS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE INDENIZAÇÕES TRABALHISTAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.1.1.02.00.00.00.0000','PROVISAO PARA PAGAMENTO DE DISSIDIOS COLETIVOS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE DISSIDIOS COLETIVOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.3.0.00.00.00.00.0000','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUAÇÕES FISCAIS, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.3.1.00.00.00.00.0000','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUAÇÕES FISCAIS, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.3.1.01.00.00.00.0000','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTOS DE INFRAÇÃO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.3.1.01.01.00.00.0000','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO NÃO RECORRIDOS','REGISTRA OS VALORES RELATIVOS A PROVISÃO REFERENTE A AUTOS DE INFRAÇÃO NÃO RECORRIDOS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.3.1.01.02.00.00.0000','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO RECORRIDOS','REGISTRA OS VALORES RELATIVOS A PROVISÃO REFERENTE A AUTOS DE INFRAÇÃO RECORRIDOS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.3.1.02.00.00.00.0000','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS – ESFERA JUDICIAL','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUAÇÕES FICAIS - ESFERA JUDICIAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.3.1.02.01.00.00.0000','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','REGISTRA OS VALORES RELATIVOS A PROVISÃO REFERENTE A AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.3.1.02.02.00.00.0000','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','REGISTRA OS VALORES RELATIVOS A PROVISÃO REFERENTE A AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.4.0.00.00.00.00.0000','PROVISAO PARA RISCOS CIVEIS A CURTO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZAÇÕES A FORNECEDORES E CLIENTES, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.4.1.00.00.00.00.0000','PROVISÃO PARA RISCOS CÍVEIS A CURTO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZAÇÕES A FORNECEDORES E CLIENTES, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.4.1.01.00.00.00.0000','PROVISÃO PARA INDENIZAÇÕES CÍVEIS','REGISTRA OS VALORES RELATIVOS A PROVISÃO PARA PAGAMENTO DE SPARA INDENIZAÇÕES CÍVEIS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.4.1.02.00.00.00.0000','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','REGISTRA OS VALORES DAS PROVISÕES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.4.1.03.00.00.00.0000','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISÕES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JÁ CIENTIFICADOS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.4.1.04.00.00.00.0000','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS NÃO CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISÕES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS NÃO CIENTIFICADOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.5.0.00.00.00.00.0000','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CRÉDITOS TRIBUTÁRIOS E NÃO TRIBUTÁRIOS RECONHECIDOS NO LANCAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERAÇÃO. NA ARRECADAÇÃO, ESTA PROVISÃO SERÁ REVERTIDA EM CONTA ESPECÍFICA DE PASSIVO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.5.3.00.00.00.00.0000','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CRÉDITOS TRIBUTÁRIOS E NÃO TRIBUTÁRIOS RECONHECIDOS NO LANÇAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERAÇÃO. NA ARRECADAÇÃO, ESTA PROVISAO SERA REVERTIDA EM CONTA DE PASSIVO REFERENTE A OBRIGAÇÕES DE REPARTICAO A OUTROS ENTES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO. NA ARRECADAÇÃO, ESTA PROVISÃO SERÁ REVERTIDA EM CONTA ESPECÍFICA DE PASSIVO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.5.4.00.00.00.00.0000','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CRÉDITOS TRIBUTÁRIOS E NÃO TRIBUTÁRIOS RECONHECIDOS NO LANÇAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERAÇÃO. NA ARRECADAÇÃO, ESTA PROVISAO SERA REVERTIDA EM CONTA DE PASSIVO REFERENTE A OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO. NA ARRECADAÇÃO, ESTA PROVISÃO SERÁ REVERTIDA EM CONTA ESPECÍFICA DE PASSIVO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.5.5.00.00.00.00.0000','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CRÉDITOS TRIBUTÁRIOS E NÃO TRIBUTÁRIOS RECONHECIDOS NO LANÇAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERAÇÃO. NA ARRECADAÇÃO, ESTA PROVISAO SERA REVERTIDA EM CONTA DE PASSIVO REFERENTE A OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO. NA ARRECADAÇÃO, ESTA PROVISÃO SERÁ REVERTIDA EM CONTA ESPECÍFICA DE PASSIVO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.6.0.00.00.00.00.0000','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUÇÃO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.6.1.00.00.00.00.0000','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO- CONSOLIDAÇÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUÇÃO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NÃO PERTENÇA AO OFSS DE ENTE PÚBLICO, ALÉM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.9.0.00.00.00.00.0000','OUTRAS PROVISÕES A CURTO PRAZO','COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PRAZO PROVAVEL ATE O TÉRMINO DO EXERCÍCIO SEGUINTE, NÃO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.9.1.00.00.00.00.0000','OUTRAS PROVISÕES A CURTO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PRAZO PROVÁVEL NO CURTO PRAZO, NÃO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.9.1.01.00.00.00.0000','PROVISÃO PARA GARANTIAS','REGISTRA OS VALORES DAS PROVISÕES DESTINADAS A COBRIR DESPESAS COM A PRESTAÇÃO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.9.1.02.00.00.00.0000','PROVISÃO PARA REESTRUTURAÇÃO','REGISTRA OS VALORES DAS PROVISÕES DESTINADAS A COBRIR OBRIGAÇÕES ORIUNDAS DA VENDA OU EXTINÇÃO DE UMA LINHA DE NEGÓCIOS, FECHAMENTO DE FÁBRICAS OU LOCAIS DE NEGÓCIOS, MUDANÇAS NA ESTRUTUTA DA ADMINISTRAÇÃO E REORGANIZAÇÕES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERAÇÕES DA ENTIDADE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.7.9.1.99.00.00.00.0000','OUTRAS PROVISÕES A CURTO PRAZO','REGISTRA OS VALORES DAS PROVISÕES NÃO CLASSIFICÁVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.0.0.00.00.00.00.0000','DEMAIS OBRIGAÇÕES A CURTO PRAZO','COMPREENDE AS OBRIGAÇÕES DA ENTIDADE JUNTO A TERCEIROS NÃO INCLUSAS NOS SUBGRUPOS ANTERIORES, INCLUSIVE OS PRECATÓRIOS DECORRENTES DESSAS OBRIGAÇÕES, COM VENCIMENTO NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.1.0.00.00.00.00.0000','ADIANTAMENTOS DE CLIENTES','COMPREENDE AS ANTECIPAÇÕES RECEBIDAS PELO ENTE POR OPERAÇÕES DE FORNECIMENTO DE BENS OU PRESTAÇÃO DE SERVIÇOS E QUE ENSEJEM A DEVOLUÇÃO DA QUANTIA RECEBIDA, CASO A OPERAÇÃO NÃO OCORRA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.1.1.00.00.00.00.0000','ADIANTAMENTOS DE CLIENTES- CONSOLIDAÇÃO','COMPREENDE AS ANTECIPAÇÕES RECEBIDAS POR OPERAÇÕES DE FORNECIMENTO DE BENS OU PRESTAÇÃO DE SERVIÇOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERAÇÃO NÃO OCORRA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.2.0.00.00.00.00.0000','OBRIGAÇÕES POR DANOS A TERCEIROS','COMPREENDE OS VALORES EXIGÍVEIS NO CURTO PRAZO, PROVENIENTES DE DANOS A TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.2.1.00.00.00.00.0000','OBRIGAÇÕES POR DANOS A TERCEIROS - CONSOLIDAÇÃO','COMPREENDE OS VALORES EXIGÍVEIS NO CURTO PRAZO, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.3.0.00.00.00.00.0000','ARRENDAMENTO OPERACIONAL A PAGAR','COMPREENDE AS OBRIGAÇÕES A CURTO PRAZO REFERENTES A ARRENDAMENTOS MERCANTIS, NOS QUAIS NÃO SAO TRANSFERIDOS AO ARRENDADOR OS RISCOS E BENEFÍCIOS INERENTES A PROPRIEDADE, NÃO HAVENDO A POSSIBILIDADE DE OPCAO DE COMPRA DO BEM ARRENDADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.3.1.00.00.00.00.0000','ARRENDAMENTO OPERACIONAL A PAGAR- CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES A CURTO PRAZO REFERENTES A ARRENDAMENTOS MERCANTIS, NOS QUAIS NÃO SAO TRANSFERIDOS AO ARRENDADOR OS RISCOS E BENEFÍCIOS INERENTES A PROPRIEDADE, NÃO HAVENDO A POSSIBILIDADE DE OPCAO DE COMPRA DO BEM ARRENDADO.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.4.0.00.00.00.00.0000','DEBENTURES E OUTROS TITULOS DE DÍVIDA A CURTO PRAZO','COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CRÉDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO, COM VENCIMENTO NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.4.1.00.00.00.00.0000','DEBÊNTURES E OUTROS TÍTULOS DE DÍVIDA A CURTO PRAZO- CONSOLIDAÇÃO','COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CRÉDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.4.1.01.00.00.00.0000','DEBENTURES CONVERSIVEIS EM ACOES NO CURTO PRAZO','REGISTRA OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO E QUE SAO CONVERSIVEIS EM ACOES, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.4.1.02.00.00.00.0000','DEBENTURES NAO-CONVERSIVEIS EM ACOES NO CURTO PRAZO','REGISTRA OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO E QUE NAO SAO CONVERSIVEIS EM ACOES, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.4.1.96.00.00.00.0000','AGIO NA EMISSAO DE DEBENTURES','REGISTRA OS VALORES DE AGIO NA EMISSAO DE DEBENTURES, QUE SAO OS VALORES RECEBIDOS QUE SUPERA O DE RESGATE DESSES TITULOS NA DATA DO PROPRIO RECEBIMENTO OU DO VALOR FORMALMENTE ATRIBUIDO AS DEBENTURES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.4.1.97.00.00.00.0000','(-) DESAGIO NA EMISSAO DE DEBENTURES','REGISTRA OS VALORES DE DESAGIO NA EMISSAO DE DEBENTURES, QUE SAO OS VALORES RECEBIDOS INFERIORES AO VALOR DE RESGATE DESSES TITULOS NA DATA DO PROPRIO RECEBIMENTO OU DO VALOR FORMALMENTE ATRIBUIDO AS DEBENTURES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.4.1.98.00.00.00.0000','(-) CUSTO DA TRANSACAO A AMORTIZAR','REGISTRA OS CUSTOS DA TRANSACAO A AMORTIZAR, QUE SAO APENAS OS CUSTOS INCORRIDOS E DIRETAMENTE ATRIBUIVEIS AS ATIVIDADES NECESSARIAS EXCLUSIVAMENTE A CONSECUCAO DA TRANSACAO. POR EXEMPLO: TAXAS E COMISSOES. ENTRETANTO, NAO INCLUEM DESPESAS FINANCEIRAS, CUSTOS INTERNOS ADMINISTRATIVOS OU CUSTO DE CARREGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.4.1.99.00.00.00.0000','OUTROS TITULOS','REGISTRA OUTROS TITULOS DE DIVIDA COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.5.0.00.00.00.00.0000','DIVIDENDOS A PAGAR','COMPREENDE OS DIVIDENDOS APROVADOS PELA ASSEMBLEIA GERAL A SEREM PAGOS AOS ACIONISTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.5.1.00.00.00.00.0000','DIVIDENDOS A PAGAR- CONSOLIDAÇÃO','COMPREENDE OS DIVIDENDOS APROVADOS PELA ASSEMBLEIA GERAL A SEREM PAGOS AOS ACIONISTAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.0.00.00.00.00.0000','VALORES RESTITUÍVEIS','COMPREENDE OS VALORES DE TERCEIROS OU RETENÇÕES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PÚBLICO FOR FIEL DEPOSITÁRIA INDEPENDENTEMENTE DO PRAZO DE EXIGIBILIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.00.00.00.00.0000','VALORES RESTITUÍVEIS - CONSOLIDAÇÃO','COMPREENDE OS VALORES DE TERCEIROS OU RETENÇÕES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PÚBLICO FOR FIEL DEPOSITÁRIA, INDEPENDENTEMENTE DO PRAZO DE EXIGIBILIDADE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.00.00.00.0000','CONSIGNAÇÕES','COMPREENDE OS VALORES ENTREGUES EM CONFIANCA OU EM CONSIGNAÇÕES, GERALMENTE RETIDOS EM FOLHA DE PAGAMENTO DE EMPREGADOS OU SERVIDORES OU NOS PAGAMENTOS REFERENTES A COMPRAS DE BENS E SERVIÇOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.01.00.00.0000','RPPS - RETENÇÕES SOBRE VENCIMENTOS E VANTAGENS','REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE SERVIDORES A SER RECOLHIDO AO RPPS DO SERVIDOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.02.00.00.0000','INSS','REGISTRA O VALOR DAS RETENÇÕES PROCEDIDAS EM PAGAMENTOS DE EMPREGADOS REGIDOS PELA CONSOLIDAÇÃO DAS LEIS DO TRABALHO (CLT) E AGENTES POLITICOS OU DE SERVIÇOS DE TERCEIROS, A SER RECOLHIDO AO INSTITUTO NACIONAL DO SEGURO SOCIAL/PREVIDENCIA SOCIAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.03.00.00.0000','ENCARGOS SOCIAIS - OUTRAS ENTIDADES','REGISTRA O VALOR A SER RECOLHIDO A OUTRAS ENTIDADES, EM FUNÇÃO DE DISPOSITIVOS LEGAIS COM AS QUAIS A ENTIDADE MANTENHA CONVENIO DE ARRECADAÇÃO DIRETA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.04.00.00.0000','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF DEVIDO AO TESOURO NACIONAL','REGISTRA OS VALORES REFERENTES AS RETENÇÕES NA FONTE, PELA ENTIDADE, DO IMPOSTO SOBRE A RENDA, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS OU CREDITADAS A SERVIDORES OU EMPREGADOS, SOBRE AS QUAIS INCIDA O REFERIDO IMPOSTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.04.01.00.0000','RETENCAO IRRF S/ RENDIMENTO TRABALHO SERVIDORES ATIVOS','REPRESENTA VALORES MONETÁRIOS RETIDOS NA FOLHA DE PAGAMENTO DE SERVIDORES ATIVOS REFERENTE AO IRRF','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.04.02.00.0000','RETENCAO IRRF S/ RENDIMENTO TRABALHO SERVIDORES INATIVOS/PENSIONISTAS','REPRESENTA VALORES MONETÁRIOS RETIDOS NA FOLHA DE PAGAMENTO DE SERVIDORES INATIVOS E PENSIONISTAS REFERENTE AO IRRF.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.04.03.00.0000','IMPOSTOS A REPASSAR - IRRF','REPRESENTA VALORES MONETÁRIOS DE IMPOSTOS A REPASSAR - IRRF.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.04.04.00.0000','DEVOLUCAO DO IRRF','REPRESENTA VALORES MONETÁRIOS DE DEVOLUÇÃO DO IRRF.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.05.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES','REGISTRA OS VALORES RELATIVOS ASINDENIZAÇÕES E RESTITUIÇÕES DE TRIBUTOS COM AUTORIZAÇÕES CONCEDIDAS, POREM NÃO DEVOLVIDAS AOS LEGITIMOS CREDORES PELA UNIDADE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.06.00.00.0000','IMPOSTOS E CONTRIBUIÇÕES DIVERSOS','REGISTRA OS VALORES REFERENTES AS RETENÇÕES NA FONTE, PELA UNIDADE, DE IMPOSTOS E CONTRIBUIÇÕES DIVERSOS, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS, SOBRE OS QUAIS INCIDAM OS REFERIDOS TRIBUTOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.07.00.00.0000','OUTROS TRIBUTOS DO TESOURO NACIONAL','REGISTRA OS VALORES RELATIVOS A OUTROS TRIBUTOS DO TESOURO NACIONAL RETIDOS PELA UNIDADE SOBRE VALORES PAGOS OU CREDITADOS E QUE, SOBRE OS QUAIS, INCIDA O REFERIDO TRIBUTO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.08.00.00.0000','ICMS','REGISTRA OS VALORES RELATIVOS AO IMPOSTO SOBRE A CIRCULAÇÃO DE MERCADORIAS E SERVIÇOS RETIDOS POR FORCA DE LEGISLAÇÃO OU POR ACORDO ENTRE AS PARTES ENVOLVIDAS NA TRANSAÇÃO EM CONSIGNAÇÕES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.09.00.00.0000','ISS','REGISTRA OS VALORES DO IMPOSTO SOBRE SERVIÇOS RETIDO EM CONSIGNAÇÕES POR FORCA DE LEGISLAÇÃO, CIRCUNSTANCIAS OU ACORDO ENTRE AS PARTES ENVOLVIDOS NA TRANSAÇÃO, EM SITUAÇÕES QUE A UG COMO PARTE CONTRATANTE, ATUE COMO SUBSTITUTA TRIBUTÁRIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.13.00.00.0000','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS','REGISTRA OS VALORES EM CONSIGNAÇÃO RELATIVOS A TRIBUTOS DEVIDOS A ESTADOS E MUNICÍPIOS QUE NÃO POSSUEM CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.14.00.00.0000','PENSAO ALIMENTICIA','REGISTRA OS VALORES DAS RETENÇÕES PROCEDIDAS EM PAGAMENTOS A EMPREGADOS OU A SERVIDORES AUTORIZADOS POR ESSES OU POR DETERMINAÇÃO JUDICIAL, A TITULO DE PENSAO ALIMENTICIA DESTINADA A MANUTENCAO DE FAMILIAR','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.15.00.00.0000','PLANOS DE PREVIDENCIA E ASSISTÊNCIA MEDICA','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DO PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES DE PREVIDENCIA E ASSISTÊNCIA MEDICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.15.01.00.0000','RETENÇÕES - CONTRIBUIÇÕES AO RPPS A RECOLHER-EXECUTIVO/INDIRETAS','REPRESENTA VALORES MONETÁRIOS RETIDOS NA FOLHA DE PAGAMENTO DE SERVIDORES DO EXECUTIVO / INDIRETAS REFERENTES AS CONTRIBUIÇÕES PARA O RPPS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.15.02.00.0000','RETENÇÕES - CONTRIBUIÇÕES AO RPPS A RECOLHER - LEGISLATIVO','REPRESENTA VALORES MONETÁRIOS RETIDOS NA FOLHA DE PAGAMENTO DE SERVIDORES DO LEGISLATIVO REFERENTES AS CONTRIBUIÇÕES PARA O RPPS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.16.00.00.0000','ASSISTÊNCIA A SAUDE - ADMINISTRAÇÃO PROPRIA','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, QUE SERAO ADMINISTRADOS PELO PROPRIO ORGÃO/ENTIDADE PARA ASSISTÊNCIA A SAUDE DE SEUS SERVIDORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.17.00.00.0000','RETENÇÃO - ENTIDADES REPRESENTATIVAS DE CLASSES','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DE PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES REPRESENTATIVAS DE CLASSE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.21.00.00.0000','RETENÇÃO - PLANOS DE SEGUROS','REGISTRA OS VALORES DAS RETENÇÕES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES AS CONTRIBUIÇÕES A PLANOS DE SEGURO DE VIDA EM GRUPO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.22.00.00.0000','RETENÇÃO - EMPRÉSTIMOS E FINANCIAMENTOS','REGISTRA OS VALORES DAS RETENÇÕES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS POR TERCEIROS, BEM COMO RETENÇÕES DE PARCELAS DE CONSORCIOS E SEGURADOS DO INSS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.24.00.00.0000','RETENÇÃO - RELATIVA A VALE TRANSPORTE','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDAS PELA ENTIDADE A SEREM REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVIÇOS DE FORNECIMENTO DE VALE-TRANSPORTE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.25.00.00.0000','RETENÇÃO - RELATIVA A VALE ALIMENTAÇÃO','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDAS PELA ENTIDADE A SEREM REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVIÇOS DE FORNECIMENTO DE CARTAO-ALIMENTAÇÃO/REFEICAO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.01.99.00.00.0000','OUTROS CONSIGNATARIOS','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, EM CONFIANCA, POR DIVERSOS CONTRIBUINTES SUJEITOS A RECOLHIMENTOS E OU PAGAMENTOS AOS FAVORECIDOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.02.00.00.00.0000','GARANTIAS','COMPREENDE A GARANTIA DO CUMPRIMENTO DE UMA OBRIGAÇÃO, QUE SE EFETIVA COM O OFERECIMENTO DE BENS OU RECURSOS FINANCEIROS OU AINDA RETENÇÕES DE UM PERCENTUAL DO VALOR DO CONTRATO COMO GARANTIA DE CUMPRIMENTO DO MESMO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.03.00.00.00.0000','DEPÓSITOS JUDICIAIS','REGISTRA OS VALORES DE OBRIGAÇÕES, DECORRENTES DE DEPÓSITOS RECEBIDOS POR DETERMINAÇÃO JUDICIAL E DEPÓSITOS PARA RECURSOS JUDICIAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.03.01.00.00.0000','DEPOSITOS A EFETUAR POR DETERMINACAO JUDICIAL','REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS A EFETUAR PELA ENTIDADE POR DETERMINACAO JUDICIAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.03.02.00.00.0000','DEPÓSITOS RECEBIDOS POR DETERMINAÇÃO JUDICIAL','REGISTRA OS VALORES DE OBRIGAÇÕES, DECORRENTES DE DEPÓSITOS RECEBIDOS POR DETERMINAÇÃO JUDICIAL.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.03.03.00.00.0000','DEPÓSITOS A EFETUAR PARA RECURSOS JUDICIAIS','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES CONTRAIDAS POR DEPÓSITOS A EFETUAR A FAVOR DA ENTIDADE DESTINADOS AO EXERCÍCIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.03.04.00.00.0000','DEPÓSITOS RECEBIDOS PARA RECURSOS JUDICIAIS','REGISTRA OS VALORES RELATIVOS A DEPOSITOS RCEBIDOS PELA ENTIDADE DESTINADOS AO EXERCÍCIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.04.00.00.00.0000','DEPÓSITOS NÃO JUDICIAIS','REGISTRA OS VALORES DE OBRIGAÇÕES, DECORRENTES DE DEPÓSITOS RECEBIDOS, EXCETO DEPÓSITOS JUDICIAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.04.01.00.00.0000','DEPÓSITOS E CAUÇÕES A EFETUAR','REGISTRA OS VALORES DAS OBRIGAÇÕES EXIGÍVEIS REFERENTES A DEPÓSITOS E/OU CAUÇÕES VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERAÇÕES ESPECIFICAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.04.01.01.00.0000','REPASSES A FUNDOS/AUTARQUIAS REFERENTE A COMPENSAÇÃO FINANCEIRA DO RPPS, RECEBIDA UNIAO','REGISTRA OS VALORES REFERENTES A COMPENSAÇÃO FINANCEIRA RECEBIDA DA UNIAO E QUE DEVE SER REPASSADA A AUTARQUIA OU FUNDOS PREVIDENCIÁRIOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.04.01.02.00.0000','CAUÇÕES EM DINHEIRO','REGISTRA OS VALORES DAS OBRIGAÇÕES EXIGÍVEIS NO CURSO DO EXERCÍCIO SEGUINTE, CONTRAIDAS COMO RECEBIMENTO DE CAUÇÕES VINCULADOS A CONTRATOS OU A CONVENCOES, PARA GARANTIAS DE OPERAÇÕES ESPECIFICAS','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.04.02.00.00.0000','DEPOSITOS E CAUCOES RECEBIDOS','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS E/OU CAUCOES PELA ENTIDADE VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.04.05.00.00.0000','DEPÓSITOS ESPECIAIS','REGISTRA O VALOR RELATIVO A RETENÇÕES DE DEPÓSITOS VINCULADOS A RESTITUIR NO CURSO DO EXERCÍCIO SEGUINTE A ENTIDADE TRANSFERIDORA, DECORRENTE DE CONTRATOS OU INSTRUMENTOS CONGENERES, CONVENCAO, ACORDO OU AJUSTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.04.05.01.00.0000','RETENÇÕES CONTRATUAIS','REGISTRAR O VALOR RELATIVO A RETENÇÕES DE DEPÓSITOS VINCULADOS A RESTITUIÇÕES NO CURSO DO EXERCÍCIO, DECORRENTE DE CONTRATO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.04.05.02.00.0000','RETENÇÕES SEGURIDADE SOCIAL','REGISTRAR O VALOR RELATIVO A RETENÇÕES DE DEPÓSITOS VINCULADOS A RESTITUIÇÕES NO CURSO DO EXERCÍCIO, DECORRENTE DA SEGURIDADE SOCIAL','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.04.06.00.00.0000','DEPÓSITOS RETIDOS DE FORNECEDORES','REGISTRA OS VALORES DE OBRIGAÇÕES DECORRENTES DE DEPÓSITOS RECEBIDOS/RETIDOS DE FORNECEDORES EM FUNÇÃO DE APLICAÇÃO DE MULTAS E OUTRAS DETERMINAÇÕES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.04.09.00.00.0000','DEPÓSITOS DE TERCEIROS','REGISTRA OS VALORES RELATIVOS AOS DEPÓSITOS DE TERCEIROS DE DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NÃO RECLAMADOS PELOS CREDORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.04.12.00.00.0000','DEPÓSITOS DE RENDIMENTOS DO PIS/PASEP','REGISTRA OS VALORES RELATIVOS AOS DEPÓSITOS DE RENDIMENTOS DO PIS/PASEP PARA CRÉDITO EM FOLHA DE PAGAMENTO AOS SERVIDORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.04.99.00.00.0000','OUTROS DEPÓSITOS','REGISTRA COMPROMISSOS EXIGÍVEIS ATE O TÉRMINO DO EXERCÍCIO SEGUINTE, DECORRENTES DE RECEBIMENTOS A TITULO DE DEPÓSITOS, PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.8.1.99.00.00.00.0000','OUTROS VALORES RESTITUÍVEIS','OUTROS VALORES RESTITUÍVEIS EM POSSE DA ENTIDADE, NO PAPEL DE FIEL DEPOSITÁRIA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.0.00.00.00.00.0000','OUTRAS OBRIGAÇÕES A CURTO PRAZO','COMPREENDE OUTRAS OBRIGAÇÕES NÃO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.00.00.00.00.0000','OUTRAS OBRIGAÇÕES A CURTO PRAZO - CONSOLIDAÇÃO','COMPREENDE OUTRAS OBRIGAÇÕES NÃO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.01.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES','COMPREENDE AS OBRIGAÇÕES RELATIVAS AINDENIZAÇÕES E RESTITUIÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.01.01.00.00.0000','INDENIZAÇÕES A SERVIDORES','REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDAÇÃO DE PAGAMENTOS EFETUADOS COM AUXÍLIO - ALIMENTAÇÃO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTÊNCIA A SAUDE E BENEFÍCIOS SOCIAIS DO ORGÃO RESPONSAVEL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.01.02.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES DIVERSAS DO EXERCÍCIO','REGISTRA OS VALORES RELATIVOS AS DIVERSASINDENIZAÇÕES E RESTITUIÇÕES NO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.01.03.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES DIVERSAS DE EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSASINDENIZAÇÕES E RESTITUIÇÕES DE EXERCÍCIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.02.00.00.00.0000','DIÁRIAS A PAGAR','REGISTRA OS VALORES RELATIVOS AS DIÁRIAS A PAGAR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.03.00.00.00.0000','SUPRIMENTOS DE FUNDOS A PAGAR','REGISTRA OS VALORES RELATIVOS AOS SUPRIMENTOS DE FUNDOS A PAGAR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.05.00.00.00.0000','CONVÊNIOS A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.05.01.00.00.0000','CONVÊNIOS A PAGAR DO EXERCÍCIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVÊNIOS FIRMADOS NO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.05.02.00.00.0000','CONVÊNIOS A PAGAR DE EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVÊNIOS FIRMADOS EM EXERCÍCIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.13.00.00.00.0000','PRECATÓRIOS DE TERCEIROS','COMPREENDE AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS, EXCETO PRECATÓRIOS DE PESSOAL, DE BENEFÍCIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVIÇOS E UTILIDADES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.13.01.00.00.0000','PRECATÓRIOS DE TERCEIROS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS , EXCETO PRECATÓRIOS DE PESSOAL, DE BENEFÍCIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVIÇOS E UTILIDADES., INCORRIDAS NO EXERCÍCIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.13.02.00.00.0000','PRECATÓRIOS A PAGAR - TERCEIROS - DO EXERCÍCIO ANTERIOR','REGISTRA OS VALORES DE PRECATÓRIOS PARA PAGAMENTO DE TERCEIROS, NO SISTEMA PATRIMONIAL O QUAL DEVERIA TER SIDO PAGO ATÉ O FINAL DO EXERCÍCIO E NÃO OCORREU A EXECUÇÃO ORÇAMENTÁRIA','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.13.03.00.00.0000','PRECATÓRIOS DE TERCEIROS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS, EXCETO PRECATÓRIOS DE PESSOAL, DE BENEFÍCIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVIÇOS E UTILIDADES, INCORRIDAS EM EXERCÍCIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.13.03.01.00.0000','TERCEIROS - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIAÇÃO DE TERRAS E OUTRAS DE RESPONSABILIDADE DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.13.03.02.00.0000','TERCEIROS - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIAÇÃO DE TERRAS E OUTRAS DE RESPONSABILIDADE DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.13.03.03.00.0000','TERCEIROS - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIAÇÃO DE TERRAS E OUTRAS DE RESPONSABILIDADE DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.13.04.00.00.0000','PRECATÓRIOS DE TERCEIROS DE EXERCÍCIOS ANTERIORES- A PARTIR DE 05/05/2000','REGISTRA OS VALORES RELATIVOS A PRECATÓRIOS , EXCETO PRECATÓRIOS DE PESSOAL, DE BENEFÍCIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVIÇOS E UTILIDADES., INCORRIDAS EM EXERCÍCIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.13.04.01.00.0000','TERCEIROS - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIAÇÃO DE TERRAS E OUTRAS, A PARTIR DE 05/05/2000 DE RESPONSABILIDADE DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.13.04.02.00.0000','TERCEIROS - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIAÇÃO DE TERRAS E OUTRAS, A PARTIR DE 05/05/2000 DE RESPONSABILIDADE DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.13.04.03.00.0000','TERCEIROS - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATÓRIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIAÇÃO DE TERRAS E OUTRAS, A PARTIR DE 05/05/2000 DE RESPONSABILIDADE DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.14.00.00.00.0000','COMPENSAÇÃO PREVIDÊNCIÁRIA','COMPREENDE O VALOR DAS OBRIGAÇÕES COM COMPENSAÇÃO PREVIDÊNCIÁRIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3.112/1999.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.14.01.00.00.0000','COMPENSAÇÃO PREVIDÊNCIÁRIA DO EXERCÍCIO','REGISTRA O VALOR DAS OBRIGAÇÕES DO EXERCÍCIO COM COMPENSAÇÃO PREVIDÊNCIÁRIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.14.02.00.00.0000','COMPENSAÇÃO PREVIDÊNCIÁRIA DE EXERCÍCIOS ANTERIORES','REGISTRA O VALOR DAS OBRIGAÇÕES DE EXERCÍCIOS ANTERIORES COM COMPENSAÇÃO PREVIDÊNCIÁRIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.20.00.00.00.0000','CONTRATOS DE GESTAO','REGISTRA AS OBRIGAÇÕES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRAÇÃO PÚBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.23.00.00.00.0000','AUXÍLIOS FINANCEIROS A PESQUISADORES','COMPREENDE AS OBRIGAÇÕES A PAGAR RELATIVAS A AUXÍLIO FINANCEIRO A PESQUISADORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.26.00.00.00.0000','ENTIDADES CREDORAS - FEDERAIS','REGISTRA OS VALORES EXIGÍVEIS A CURTO PRAZO, DECORRENTES DE OBRIGAÇÕES JUNTO A ENTIDADES FEDERAIS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.27.00.00.00.0000','ENTIDADES CREDORAS - ESTADOS, DF E MUNICÍPIOS','REGISTRA OS VALORES EXIGÍVEIS A CURTO PRAZO DECORRENTES DE OBRIGAÇÕES JUNTO A ESTADOS, DF E MUNICÍPIOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.35.00.00.00.0000','INTERMEDIARIOS DE INVESTIMENTOS','COMPREENDE OS VALORES DE OBRIGAÇÕES A CURTO PRAZO COM INTERMEDIARIOS DE INVESTIMENTOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.35.01.00.00.0000','VALORES DE INVESTIMENTOS A PAGAR','REGISTRA OS VALORES DE INVESTIMENTOS REALIZADOS NO MERCADO FINANCEIRO E NÃO LIQUIDADOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.36.00.00.00.0000','VALORES EM TRANSITO EXIGÍVEIS','COMPREENDE O VALOR DA ORDEM BANCÁRIA OU OUTRO DOCUMENTO EMITIDO PARA SAQUE CONTRA ESTABELECIMENTO BANCARIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.37.00.00.00.0000','SUBVENCOES A PAGAR','COMPREENDE O SOMATÓRIO DAS SUBVENCOES A PAGAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.37.01.00.00.0000','SUBVENCOES A PAGAR DO EXERCÍCIO','REGISTRA O SOMATÓRIO DAS SUBVENCOES A PAGAR DO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.37.02.00.00.0000','SUBVENCOES A PAGAR DE EXERCÍCIOS ANTERIORES','REGISTRA O SOMATÓRIO DAS SUBVENCOES A PAGAR DE EXERCÍCIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.38.00.00.00.0000','RESTITUIÇÕES DE RECEITAS A PAGAR','REGISTRA O VALOR DAS RESTITUIÇÕES DE RECEITAS A PAGAR APROPRIADAS PELAS UNIDADES GESTORAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.39.00.00.00.0000','TRANSFERÊNCIAS VOLUNTARIAS DEVOLVIDAS','REGISTRA OS VALORES DE DEVOLUCOES DE RECURSOS DE TRANSFERÊNCIAS VOLUNTARIAS PARA POSTERIOR RECOLHIMENTO AO CONCEDENTE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.40.00.00.00.0000','RECURSOS ESPECIAIS A LIBERAR','COMPREENDE A DESPESA EMPENHADA E NÃO PAGA, APURADA AO FINAL DO EXERCÍCIO E INSCRITA EM RESTOS A PAGAR, PROCESSADOS E NÃO PROCESSADOS, BEM COMO OS RECURSOS APROVADOS E NÃO LIBERADOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.40.03.00.00.0000','RESTOS A PAGAR NÃO PROCESSADOS A LIQUIDAR','REGISTRA AS OBRIGAÇÕES PROVENIENTES DA INSCRIÇÃO DE RESTOS A PAGAR DEPENDENTES DO ESTÁGIO DA LIQUIDAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.40.03.01.00.0000','RESTOS A PAGAR NÃO PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA AS OBRIGAÇÕES PROVENIENTES DA INSCRIÇÃO DE RESTOS A PAGAR DEPENDENTE DO ESTÁGIO DA LIQUIDAÇÃO DE RESPONSABILIDADE DO PODER EXECUTIVO E DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.40.03.02.00.0000','RESTOS A PAGAR NÃO PROCESSADOS - LEGISLATIVO','REGISTRA AS OBRIGAÇÕES PROVENIENTES DA INSCRIÇÃO DE RESTOS A PAGAR DEPENDENTE DO ESTÁGIO DA LIQUIDAÇÃO DE RESPONSABILIDADE DO PODER LEGISLATIVO E DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.40.03.03.00.0000','RESTOS A PAGAR NÃO PROCESSADOS - RPPS','REGISTRA AS OBRIGAÇÕES PROVENIENTES DA INSCRIÇÃO DE RESTOS A PAGAR DEPENDENTE DO ESTÁGIO DA LIQUIDAÇÃO DE RESPONSABILIDADE DO RPPS E DEVERAO SER DESDOBRADAS POR EXERCÍCIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.40.07.00.00.0000','RECURSOS A LIBERAR POR VINCULAÇÃO DE PAGAMENTO','REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMAÇÃO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULAÇÃO DE PAGAMENTO, ESTABELECIDO PELO ORGÃO CENTRAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.40.10.00.00.0000','RECURSOS A LIBERAR PARA PAGAMENTO DE RP','REGISTRA O VALOR DO RECURSO A LIBERAR PARA PAGAMENTO DE RESTOS A PAGAR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.98.00.00.00.0000','OUTROS CREDORES A CURTO PRAZO','COMPREENDE OS VALORES EXIGÍVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.98.01.00.00.0000','ADIANTAMENTOS DIVERSOS RECEBIDOS','REGISTRA VALORES EXIGÍVEIS NO CURTO PRAZO, DECORRENTES DE DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.98.02.00.00.0000','OUTROS CREDORES DO EXERCÍCIO','REGISTRA OS VALORES EXIGÍVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES NO EXERCÍCIO, PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.98.03.00.00.0000','OUTROS CREDORES DE EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES EXIGÍVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCÍCIOS ANTERIORES, PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.98.04.00.00.0000','SERVIÇO DA DÍVIDA DE PARCELAMENTOS A PAGAR - DO EXERCÍCIO','REGISTRA O VALOR DO SERVIÇO DA DÍVIDA DE PARCELAMENTOS A PAGAR - DO EXERCÍCIO','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.98.05.00.00.0000','DEBITOS DIVERSOS - DO EXERCÍCIO','REGISTRA O VALOR DOS DEBITOS DIVERSOS DO EXERCICO PARA OS QUAIS NÃO HAJA CONTA ESPECIFICA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.98.06.00.00.0000','RESTOS A PAGAR PROCESSADOS - DEBITOS DIVERSOS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS REFERENTES A DEBITOS DIVERSOS PARA OS QUAIS NÃO HAJA CONTA ESPECIFICA, EXIGÍVEIS NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.98.06.01.00.0000','DEBITOS DIVERSOS - RESTOS A PAGAR PROCESSADOS - EXECUTIVO/INDIRETAS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS REFERENTES A DEBITOS DIVERSOS PARA OS QUAIS NÃO HAJA CONTA ESPECIFICA DE RESPONSABILIDADE DO PODER EXECUTIVO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.98.06.02.00.0000','DEBITOS DIVERSOS - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS REFERENTES A DEBITOS DIVERSOS PARA OS QUAIS NÃO HAJA CONTA ESPECIFICA DE RESPONSABILIDADE DO PODER LEGISLATIVO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.98.06.03.00.0000','DEBITOS DIVERSOS - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS REFERENTES A DEBITOS DIVERSOS PARA OS QUAIS NÃO HAJA CONTA ESPECIFICA DE RESPONSABILIDADE DO RPPS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.98.07.00.00.0000','RESTOS A PAGAR PROCESSADOS - SERVIÇO DA DÍVIDA DE PARCELAMENTO','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS - SERVICO DA DÍVIDA DE PARCELAMENTO','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.99.00.00.00.0000','OUTRAS OBRIGAÇÕES  CONSOLIDAÇÃO','COMPREENDE OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.99.01.00.00.0000','OUTRAS OBRIGAÇÕES  DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES NO EXERCICIO, PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.1.99.02.00.00.0000','OUTRAS OBRIGAÇÕES  DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCICIOS ANTERIORES, PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.2.00.00.00.00.0000','OUTRAS OBRIGAÇÕES A CURTO PRAZO-INTRA OFSS','COMPREENDE OUTRAS OBRIGAÇÕES NÃO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.2.01.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES','COMPREENDE AS OBRIGAÇÕES RELATIVAS A INDENIZAÇÕES E RESTITUIÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.2.01.02.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES DIVERSAS DO EXERCÍCIO','REGISTRA OS VALORES RELATIVOS AS DIVERSASINDENIZAÇÕES E RESTITUIÇÕES NO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.2.01.03.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES DIVERSAS DE EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSASINDENIZAÇÕES E RESTITUIÇÕES DE EXERCÍCIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.2.05.00.00.00.0000','CONVÊNIOS A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.2.05.01.00.00.0000','CONVÊNIOS A PAGAR DO EXERCÍCIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVÊNIOS FIRMADOS NO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.2.05.02.00.00.0000','CONVÊNIOS A PAGAR DE EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVÊNIOS FIRMADOS EM EXERCÍCIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.2.40.00.00.00.0000','RECURSOS ESPECIAIS A LIBERAR','COMPREENDE A DESPESA EMPENHADA E NÃO PAGA, APURADA AO FINAL DO EXERCÍCIO E INSCRITA EM RESTOS A PAGAR, PROCESSADOS E NÃO PROCESSADOS, BEM COMO OS RECURSOS APROVADOS E NÃO LIBERADOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.2.40.03.00.00.0000','RESTOS A PAGAR NÃO PROCESSADOS A LIQUIDAR','REGISTRA AS OBRIGAÇÕES PROVENIENTES DA INSCRIÇÃO DE RESTOS A PAGAR DEPENDENTES DO ESTÁGIO DA LIQUIDAÇÃO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.2.40.07.00.00.0000','RECURSOS A LIBERAR POR VINCULAÇÃO DE PAGAMENTO','REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMAÇÃO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULAÇÃO DE PAGAMENTO, ESTABELECIDO PELO ORGÃO CENTRAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.2.40.10.00.00.0000','RECURSOS A LIBERAR PARA PAGAMENTO DE RP','REGISTRA O VALOR DO RECURSO A LIBERAR PARA PAGAMENTO DE RESTOS A PAGAR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.2.98.00.00.00.0000','OUTROS CREDORES A CURTO PRAZO','COMPREENDE OS VALORES EXIGÍVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.2.98.01.00.00.0000','OUTROS CREDORES DO EXERCÍCIO','REGISTRA OS VALORES EXIGÍVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES NO EXERCÍCIO, PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.1.8.9.2.98.02.00.00.0000','OUTROS CREDORES DE EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES EXIGÍVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCÍCIOS ANTERIORES, PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.0.0.0.00.00.00.00.0000','PASSIVO NÃO-CIRCULANTE','COMPREENDE AS OBRIGAÇÕES CONHECIDAS E ESTIMADAS QUE NÃO ATENDAM A NENHUM DOS CRITERIOS PARA SEREM CLASSIFICADAS NO PASSIVO CIRCULANTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.0.0.00.00.00.00.0000','OBRIGAÇÕES TRABALHISTAS, PREVIDÊNCIÁRIAS E ASSISTÊNCIAIS A PAGAR A LONGO PRAZO','COMPREENDE AS OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, APOSENTADORIAS, REFORMAS, PENSÕES, ENCARGOS A PAGAR, BENEFÍCIOS ASSISTÊNCIAIS, INCLUSIVE OS PRECATÓRIOS DECORRENTES DESTAS OBRIGAÇÕES, COM VENCIMENTO APOS O TÉRMINO DO EXERCÍCIO SEGUINTE INCLUSIVE OS PRECATÓRIOS DECORRENTES DESSAS OBRIGAÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.1.0.00.00.00.00.0000','PESSOAL A PAGAR','COMPREENDE AS OBRIGAÇÕES A LONGO PRAZO REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.1.1.00.00.00.00.0000','PESSOAL A PAGAR- CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES A LONGO PRAZO REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.1.1.01.00.00.00.0000','PESSOAL A PAGAR DE EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS A VENCIMENTOS E VANTAGENS FIXAS E VARIAVEIS DEVIDAS AO SERVIDORES, BEM COMO AS APOSENTADORIAS, REFORMAS E PENSÕES, RELATIVAS A EXERCÍCIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.1.1.02.00.00.00.0000','PRECATÓRIOS DE PESSOAL','COMPREENDE OS VALORES DE PRECATÓRIOS DE OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO A BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.1.1.02.01.00.00.0000','PRECATÓRIOS DE PESSOAL DE EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES DE PRECATÓRIOS DE OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO A BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCÍCIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.1.1.02.02.00.00.0000','PRECATÓRIOS DE PESSOAL DE EXERCÍCIOS ANTERIORES - ANTERIORES A 05/05/2000','REGISTRA OS VALORES DE PRECATÓRIOS PARA PAGAMENTO DE PESSOAL, ATE 05/05/2000, EXIGÍVEIS NO LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.1.1.02.03.00.00.0000','PRECATÓRIOS DE PESSOAL DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','REGISTRA OS VALORES DE PRECATÓRIOS DE OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO A BENEFÍCIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCÍCIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.2.0.00.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS A PAGAR','COMPREENDE AS OBRIGAÇÕES A LONGO PRAZO REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.2.1.00.00.00.00.0000','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES A LONGO PRAZO REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.2.1.01.00.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS','COMPREENDE AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.2.1.01.01.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES E EXERCÍCIOS ANTERIORES','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.2.1.01.02.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES - ANTERIORES A 05/05/2000','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES E EXERCÍCIOS ANTERIORES E ATERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.2.1.01.03.00.00.0000','PRECATÓRIOS DE BENEFÍCIOS PREVIDÊNCIÁRIOS DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/05/2000','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSÕES E EXERCÍCIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.3.0.00.00.00.00.0000','BENEFÍCIOS ASSISTÊNCIAIS A PAGAR','COMPREENDE AS OBRIGAÇÕES A LONGO PRAZO RELATIVAS AOS BENEFÍCIOS ASSISTÊNCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.3.1.00.00.00.00.0000','BENEFÍCIOS ASSISTÊNCIAIS A PAGAR - CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES A LONGO PRAZO RELATIVAS AOS BENEFÍCIOS ASSISTÊNCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.3.1.01.00.00.00.0000','BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.0.00.00.00.00.0000','ENCARGOS SOCIAIS A PAGAR','COMPREENDE AS OBRIGAÇÕES A LONGO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NÃO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NÃO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PÚBLICO E AS DEMAIS CONTRIBUIÇÕES SOCIAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.1.00.00.00.00.0000','ENCARGOS SOCIAIS A PAGAR- CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES A LONGO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NÃO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NÃO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PÚBLICO E AS DEMAIS CONTRIBUIÇÕES SOCIAIS.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.1.01.00.00.00.0000','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS - DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR REFERENTE A DÉBITOS PARCELADOS JUNTO AO INSS OU ENTIDADE DE PREVIDÊNCIA, REFERENTE AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DE FOLHA DE PAGAMENTO E OUTROS AFINS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.1.02.00.00.00.0000','CONTRIBUICÕES SOCIAIS - DÉBITOS PARCELADOS','COMPREENREGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR DOS DÉBITOS PARCELADOS, REFERENTE AO NÃO RECOLHIMENTO DE CONTRIBUIÇÕES SOCIAIS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.1.03.00.00.00.0000','FGTS - DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR DOS DÉBITOS PARCELADOS, REFERENTE AO NÃO RECOLHIMENTO DE FGTS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.1.98.00.00.00.0000','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGAÇÕES PARA A ENTIDADE, CUJA CLASSIFICAÇÃO NÃO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.2.00.00.00.00.0000','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','COMPREENDE AS OBRIGAÇÕES A LONGO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NÃO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NÃO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PÚBLICO E AS DEMAIS CONTRIBUIÇÕES SOCIAIS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.2.01.00.00.00.0000','RPPS – DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR DOS DÉBITOS PARCELADOS, REFERENTE AO NÃO RECOLHIMENTO DE CONTRIBUIÇÕES SOCIAIS AO RPPS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.2.02.00.00.00.0000','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES COM REGIMES PROPRIOS DE PREVIDENCIA, NÃO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.2.98.00.00.00.0000','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGAÇÕES PARA A ENTIDADE, CUJA CLASSIFICAÇÃO NÃO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.3.00.00.00.00.0000','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','COMPREENDE AS OBRIGAÇÕES A LONGO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NÃO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NÃO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PÚBLICO E AS DEMAIS CONTRIBUIÇÕES SOCIAIS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.3.01.00.00.00.0000','INSS A PAGAR','COMPREENDE OS VALORES RELATIVOS AS CONTRIBUIÇÕES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALÁRIOS E REMUNERAÇÕES PAGOS E SOBRE SERVIÇOS DE TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.3.01.01.00.00.0000','INSS A PAGAR - DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR RELATIVO A DÉBITOS PARCELADOS JUNTO AO INSS, REFERENTE AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DE FOLHA DE PAGAMENTOS E OUTROS AFINS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.3.98.00.00.00.0000','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGAÇÕES PARA A ENTIDADE, CUJA CLASSIFICAÇÃO NÃO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.4.00.00.00.00.0000','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','COMPREENDE AS OBRIGAÇÕES A LONGO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NÃO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NÃO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PÚBLICO E AS DEMAIS CONTRIBUIÇÕES SOCIAIS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.4.02.00.00.00.0000','CONTRIBUIÇÃO A (RPPS) DO ESTADO - DÉBITO PARCELADO','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES COM INSTITUTO DE PREVIDÊNCIA DO ESTADO (IPE), NÃO IDENTIFICADOS COMO PREVIDÊNCIA PRIVADA OU COMPLEMENTAR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.4.98.00.00.00.0000','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGAÇÕES PARA A ENTIDADE, CUJA CLASSIFICAÇÃO NÃO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.5.00.00.00.00.0000','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','COMPREENDE AS OBRIGAÇÕES A LONGO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NÃO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NÃO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PÚBLICO E AS DEMAIS CONTRIBUIÇÕES SOCIAIS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.5.02.00.00.00.0000','CONTRIBUIÇÃO A (RPPS) DO MUNICÍPIO - DÉBITO PARCELADO','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES COM INSTITUTO DE PREVIDÊNCIA DO ESTADO (IPE), NÃO IDENTIFICADOS COMO PREVIDÊNCIA PRIVADA OU COMPLEMENTAR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.1.4.5.98.00.00.00.0000','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGAÇÕES PARA A ENTIDADE, CUJA CLASSIFICAÇÃO NÃO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.0.0.00.00.00.00.0000','EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO','COMPREENDE AS OBRIGAÇÕES FINANCEIRAS DA ENTIDADE A TITULO DE EMPRÉSTIMOS, BEM COMO AS AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR, COM VENCIMENTOS NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.0.00.00.00.00.0000','EMPRÉSTIMOS A LONGO PRAZO - INTERNO','COMPREENDE OS EMPRÉSTIMOS CONTRATUAIS OU MOBILIÁRIOS ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, MOEDA NACIONAL, COM VEMCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.1.00.00.00.00.0000','EMPRÉSTIMOS A LONGO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS EMPRÉSTIMOS CONTRATUAIS OU MOBILIÁRIOS ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, MOEDA NACIONAL, COM VEMCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.1.01.00.00.00.0000','EMPRÉSTIMOS INTERNOS - EM TITULOS','REGISTRA OS VALORES DAS OPERAÇÕES DE CRÉDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.1.01.01.00.00.0000','DÍVIDA MOBILIÁRIA','REGISTRA OS VALORES EXIGÍVEIS, DECORRENTES DA EMISSÃO DE TÍTULOS DA DÍVIDA MOBILIÁRIA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.1.01.02.00.00.0000','(-) DESÁGIO DE TÍTULOS','REGISTRA OS VALORES RELATIVOS A DESÁGIO OCORRIDOS EM TÍTULOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.1.01.98.00.00.0000','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','REGISTRA OS VALORES DECORRENTES DA COLOCAÇÃO NO MERCADO DE TÍTULOS, PARA OS QUAIS NÃO HAJA CONTAS ESPECÍFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.1.02.00.00.00.0000','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERAÇÕES DE CRÉDITO INTERNAS EM CONTRATOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.3.00.00.00.00.0000','EMPRÉSTIMOS A LONGO PRAZO - INTER OFSS - UNIÃO','COMPREENDE OS EMPRÉSTIMOS CONTRATUAIS OU MOBILIÁRIOS ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.3.01.00.00.00.0000','EMPRÉSTIMOS INTERNOS - EM TITULOS','REGISTRA OS VALORES DAS OPERAÇÕES DE CRÉDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.3.01.01.00.00.0000','DÍVIDA MOBILIÁRIA','REGISTRA OS VALORES EXIGÍVEIS, DECORRENTES DA EMISSÃO DE TÍTULOS DA DÍVIDA MOBILIÁRIA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.3.01.02.00.00.0000','(-) DESÁGIO DE TÍTULOS','REGISTRA OS VALORES RELATIVOS A DESÁGIO OCORRIDOS EM TÍTULOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.3.01.98.00.00.0000','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','REGISTRA OS VALORES DECORRENTES DA COLOCAÇÃO NO MERCADO DE TÍTULOS, PARA OS QUAIS NÃO HAJA CONTAS ESPECÍFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.3.02.00.00.00.0000','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERAÇÕES DE CRÉDITO INTERNAS EM CONTRATOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.4.00.00.00.00.0000','EMPRÉSTIMOS A LONGO PRAZO - INTER OFSS - ESTADO','COMPREENDE OS EMPRÉSTIMOS CONTRATUAIS OU MOBILIÁRIOS ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.4.01.00.00.00.0000','EMPRÉSTIMOS INTERNOS - EM TITULOS','REGISTRA OS VALORES DAS OPERAÇÕES DE CRÉDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.4.01.01.00.00.0000','DÍVIDA MOBILIÁRIA','REGISTRA OS VALORES EXIGÍVEIS, DECORRENTES DA EMISSÃO DE TÍTULOS DA DÍVIDA MOBILIÁRIA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.4.01.02.00.00.0000','(-) DESÁGIO DE TÍTULOS','REGISTRA OS VALORES RELATIVOS A DESÁGIO OCORRIDOS EM TÍTULOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.4.01.98.00.00.0000','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','REGISTRA OS VALORES DECORRENTES DA COLOCAÇÃO NO MERCADO DE TÍTULOS, PARA OS QUAIS NÃO HAJA CONTAS ESPECÍFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.4.02.00.00.00.0000','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERAÇÕES DE CRÉDITO INTERNAS EM CONTRATOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.5.00.00.00.00.0000','EMPRÉSTIMOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','COMPREENDE OS EMPRÉSTIMOS CONTRATUAIS OU MOBILIÁRIOS ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.5.01.00.00.00.0000','EMPRÉSTIMOS INTERNOS - EM TITULOS','REGISTRA OS VALORES DAS OPERAÇÕES DE CRÉDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.5.01.01.00.00.0000','DÍVIDA MOBILIÁRIA','REGISTRA OS VALORES EXIGÍVEIS, DECORRENTES DA EMISSÃO DE TÍTULOS DA DÍVIDA MOBILIÁRIA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.5.01.02.00.00.0000','(-) DESÁGIO DE TÍTULOS','REGISTRA OS VALORES RELATIVOS A DESÁGIO OCORRIDOS EM TÍTULOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.5.01.98.00.00.0000','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','REGISTRA OS VALORES DECORRENTES DA COLOCAÇÃO NO MERCADO DE TÍTULOS, PARA OS QUAIS NÃO HAJA CONTAS ESPECÍFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.1.5.02.00.00.00.0000','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERAÇÕES DE CRÉDITO INTERNAS EM CONTRATOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.2.0.00.00.00.00.0000','EMPRÉSTIMOS A LONGO PRAZO - EXTERNO','COMPREENDE OS EMPRÉSTIMOS CONTRATUAIS OU MOBILIÁRIOS ASSUMIDOS FORA DO PAÍS E TRANSACIONADOS, EM REGRA, MOEDA ESTRANGEIRA, COM VEMCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.2.1.00.00.00.00.0000','EMPRÉSTIMOS A LONGO PRAZO- EXTERNO CONSOLIDAÇÃO','COMPREENDE OS EMPRÉSTIMOS CONTRATUAIS OU MOBILIÁRIOS ASSUMIDOS FORA DO PAÍS E TRANSACIONADOS, EM REGRA, MOEDA ESTRANGEIRA, COM VEMCIMENTO NO LONGO PRAZO.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.2.1.01.00.00.00.0000','EMPRÉSTIMOS EXTERNOS - EM TÍTULOS','COMPREENDE OS VALORES DAS OPERAÇÕES DE CRÉDITO EXTERNAS DECORRENTES DA EMISSÃO DE TÍTULOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.2.1.02.00.00.00.0000','EMPRÉSTIMOS EXTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERAÇÕES DE CRÉDITO EXTERNAS EM CONTRATOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.2.1.03.00.00.00.0000','OUTROS EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','COMPREENDE OS EMPRÉSTIMOS A CURTO PRAZO - EXTERNO - NÃO ENQUADRADOS NAS CLASSIFICAÇÕES ANTERIORES.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.3.0.00.00.00.00.0000','FINANCIAMENTOS A LONGO PRAZO - INTERNO','COMPREENDE AS OBRIGAÇÕES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUIÇÃO FINANCEIRA ASSUMIDAS DENTRO DO PAÍS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.3.1.00.00.00.00.0000','FINANCIAMENTOS A LONGO PRAZO - INTERNO -CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUIÇÃO FINANCEIRA ASSUMIDAS DENTRO DO PAÍS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.3.1.01.00.00.00.0000','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGÍVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.3.1.01.01.00.00.0000','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO, CONTRAÍDOS PARA AQUISIÇÃO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.3.1.01.02.00.00.0000','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','REGISTRA OS VALORES EXIGÍVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO CONTRAÍDOS PARA CONSTRUÇÃO DE IMÓVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.3.1.01.03.00.00.0000','FINANCIAMENTO DE CAPITAL DE GIRO','REGISTRA OS VALORES EXIGÍVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO CONTRAÍDOS PARA O CAPITAL DE GIRO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.3.1.01.98.00.00.0000','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGÍVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO PARA OS QUAIS NÃO HAJA CONTAS ESPECÍFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.3.1.02.00.00.00.0000','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO','REGISTRA AS OBRIGAÇÕES A LONGO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SÃO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFÍCIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.3.3.00.00.00.00.0000','FINANCIAMENTOS A LONGO PRAZO - INTER OFSS - UNIÃO','COMPREENDE AS OBRIGAÇÕES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUIÇÃO FINANCEIRA ASSUMIDAS DENTRO DO PAÍS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.3.3.01.00.00.00.0000','FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.3.4.00.00.00.00.0000','FINANCIAMENTOS A LONGO PRAZO - INTER OFSS - ESTADO','COMPREENDE AS OBRIGAÇÕES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUIÇÃO FINANCEIRA ASSUMIDAS DENTRO DO PAÍS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.3.4.01.00.00.00.0000','FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.3.5.00.00.00.00.0000','FINANCIAMENTOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','COMPREENDE AS OBRIGAÇÕES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUIÇÃO FINANCEIRA ASSUMIDAS DENTRO DO PAÍS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.4.0.00.00.00.00.0000','FINANCIAMENTO A LONGO PRAZO - EXTERNO','COMPREENDE AS OBRIGAÇÕES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUIÇÃO FINANCEIRA ASSUMIDAS FORA DO PAÍS E TRANSACIONADAS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.4.1.00.00.00.00.0000','FINANCIAMENTOS A LONGO PRAZO - EXTERNO - CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUIÇÃO FINANCEIRA ASSUMIDAS FORA DO PAÍS E TRANSACIONADAS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.4.1.01.00.00.00.0000','FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A A LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.4.1.01.01.00.00.0000','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A LONGO PRAZO, CONTRAÍDOS PARA AQUISIÇÃO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.4.1.01.02.00.00.0000','FINANCIAMENTOS DE CAPITAL DE GIRO','REGISTRA OS VALORES EXIGÍVEIS, DECORRENTES DE FINANCIAMENTOS EXTERNOS A LONGO PRAZO CONTRAÍDOS PARA O CAPITAL DE GIRO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.4.1.02.00.00.00.0000','FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO','REGISTRA AS OBRIGAÇÕES A LONGO PRAZO REFERENTES A FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SÃO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFÍCIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.0.00.00.00.00.0000','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO, ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.1.00.00.00.00.0000','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO -CONSOLIDAÇÃO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO, ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.1.01.00.00.00.0000','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','COMPREENDE OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRÉSTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.1.01.01.00.00.0000','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DO EXERCÍCIO.','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRÉSTIMOS INTERNOS DO EXERCÍCIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.1.01.02.00.00.0000','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DE EXERCÍCIO ANTERIORES.','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRÉSTIMOS INTERNOS DE EXERCÍCIO ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.1.02.00.00.00.0000','ENCARGOS - EMPRÉSTIMOS INTERNOS','COMPREENDE OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRÉSTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.1.02.01.00.00.0000','ENCARGOS - EMPRÉSTIMOS INTERNOS DO EXERCÍCIO.','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRÉSTIMOS INTERNOS DO EXERCÍCIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.1.02.02.00.00.0000','ENCARGOS - EMPRÉSTIMOS INTERNOS DE EXERCÍCIO ANTERIORES.','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRÉSTIMOS INTERNOS DE EXERCÍCIO ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.1.03.00.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.1.03.01.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCÍCIO.','COMPREENDE OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCÍCIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.1.03.02.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCÍCIO ANTERIORES.','COMPREENDE OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DE EXERCÍCIO ANTERIORES..','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.1.04.00.00.00.0000','ENCARGOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.1.04.01.00.00.0000','ENCARGOS - FINANCIAMENTOS INTERNOS DO EXERCÍCIO.','COMPREENDE OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.1.04.02.00.00.0000','ENCARGOS - FINANCIAMENTOS INTERNOS DE EXERCÍCIO ANTERIORES.','COMPREENDE OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DE EXERCÍCIO ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.3.00.00.00.00.0000','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO - INTER OFSS - UNIÃO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS , RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO, ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO.COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.3.01.00.00.00.0000','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRÉSTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.3.03.00.00.00.0000','ENCARGOS - EMPRÉSTIMOS INTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRÉSTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.3.05.00.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.3.07.00.00.00.0000','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.4.00.00.00.00.0000','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO - INTER OFSS - ESTADO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS , RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO, ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO.COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.4.01.00.00.00.0000','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRÉSTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.4.02.00.00.00.0000','ENCARGOS - EMPRÉSTIMOS INTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRÉSTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.4.03.00.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.4.04.00.00.00.0000','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.5.00.00.00.00.0000','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO - INTER OFSS - MUNICÍPIO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS , RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO, ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO.COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.5.01.00.00.00.0000','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRÉSTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.5.02.00.00.00.0000','ENCARGOS - EMPRÉSTIMOS INTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRÉSTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.5.03.00.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.5.5.04.00.00.00.0000','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.6.0.00.00.00.00.0000','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - EXTERNO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO, ASSUMIDOS FORA DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.6.1.00.00.00.00.0000','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - EXTERNO - CONSOLIDAÇÃO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO, ASSUMIDOS FORA DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.6.1.01.00.00.00.0000','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRÉSTIMOS EXTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.6.1.01.01.00.00.0000','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DO EXERCÍCIO.','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRÉSTIMOS EXTERNOS DO EXERCÍCIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.6.1.01.02.00.00.0000','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DE EXERCÍCIO ANTERIORES.','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRÉSTIMOS EXTERNOS DE EXERCÍCIO ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.6.1.02.00.00.00.0000','ENCARGOS - EMPRÉSTIMOS EXTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRÉSTIMOS EXTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.6.1.02.01.00.00.0000','ENCARGOS - EMPRÉSTIMOS EXTERNOS DO EXERCÍCIO.','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRÉSTIMOS EXTERNOS DO EXERCÍCIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.6.1.02.02.00.00.0000','ENCARGOS - EMPRÉSTIMOS EXTERNOS DE EXERCÍCIO ANTERIORES.','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRÉSTIMOS EXTERNOS DE EXERCÍCIO ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.6.1.03.00.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.6.1.03.01.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCÍCIO.','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCÍCIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.6.1.03.02.00.00.0000','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCÍCIO ANTERIORES.','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DE EXERCÍCIO ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.6.1.04.00.00.00.0000','ENCARGOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.6.1.04.01.00.00.0000','ENCARGOS - FINANCIAMENTOS EXTERNOS DO EXERCÍCIO.','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCÍCIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.6.1.04.02.00.00.0000','ENCARGOS - FINANCIAMENTOS EXTERNOS DE EXERCÍCIO ANTERIORES.','REGISTRA OS VALORES EXIGÍVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DE EXERCÍCIO ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.8.0.00.00.00.00.0000','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRÉSTIMO E DE FINANCIAMENTO A LONGO PRAZO - INTERNO, MAS QUE AINDA NÃO TRANSCORRERAM POR NÃO TER OCORRIDO AINDA O FATO GERADOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.8.1.00.00.00.00.0000','(-) ENCARGOS FINANCEIROS A APROPRIAR - CONSOLIDAÇÃO','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRÉSTIMO E DE FINANCIAMENTO A LONGO PRAZO - INTERNO, MAS QUE AINDA NÃO TRANSCORRERAM POR NÃO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.8.1.01.00.00.00.0000','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRÉ-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRÉSTIMOS INTERNOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.8.1.02.00.00.00.0000','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRÉ-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS INTERNOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.8.3.00.00.00.00.0000','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - INTER OFSS - UNIÃO','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRÉSTIMO E DE FINANCIAMENTO A LONGO PRAZO - INTERNO, MAS QUE AINDA NÃO TRANSCORRERAM POR NÃO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.8.4.00.00.00.00.0000','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - INTER OFSS - ESTADO','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRÉSTIMO E DE FINANCIAMENTO A LONGO PRAZO - INTERNO, MAS QUE AINDA NÃO TRANSCORRERAM POR NÃO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.8.5.00.00.00.00.0000','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - INTER OFSS - MUNICÍPIO','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRÉSTIMO E DE FINANCIAMENTO A LONGO PRAZO - INTERNO, MAS QUE AINDA NÃO TRANSCORRERAM POR NÃO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.9.0.00.00.00.00.0000','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRÉSTIMO E DE FINANCIAMENTO A LONGO PRAZO - EXTERNO, MAS QUE AINDA NÃO TRANSCORRERAM POR NÃO TER OCORRIDO AINDA O FATO GERADOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.9.1.00.00.00.00.0000','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO -CONSOLIDAÇÃO','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRÉSTIMO E DE FINANCIAMENTO A LONGO PRAZO - EXTERNO, MAS QUE AINDA NÃO TRANSCORRERAM POR NÃO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.9.1.01.00.00.00.0000','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS EXTERNOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRÉ-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRÉSTIMOS EXTERNOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.2.9.1.02.00.00.00.0000','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS EXTERNOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRÉ-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS EXTERNOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.3.0.0.00.00.00.00.0000','FORNECEDORES A LONGO PRAZO','COMPREENDE AS OBRIGAÇÕES JUNTO A FORNECEDORES DE MATÉRIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE INCLUSIVE OS PRECATÓRIOS DECORRENTES DESSAS OBRIGAÇÕES, COM VENCIMENTO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.3.1.0.00.00.00.00.0000','FORNECEDORES NACIONAIS A LONGO PRAZO','COMPREENDE AS OBRIGAÇÕES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.3.1.1.00.00.00.00.0000','FORNECEDORES NACIONAIS A LONGO PRAZO - CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.3.1.1.01.00.00.00.0000','FORNECEDORES NACIONAIS DO EXERCÍCIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVIÇOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCÍCIO ATUAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.3.1.1.02.00.00.00.0000','FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVIÇOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCÍCIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.3.1.1.03.00.00.00.0000','PRECATÓRIOS DE FORNECEDORES NACIONAIS','COMPREENDE AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE FORNECEDORES NACIONAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.3.1.1.03.01.00.00.0000','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.3.1.1.03.02.00.00.0000','PRECATÓRIOS DE FORNECEDORES NACIONAIS - EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES A PAGAR DE PRECATÓRIOS DE FORNECEDORES DE BENS E SERVIÇOS DE EXERCÍCIOS ANTERIORES AO ANTERIOR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.3.1.1.03.03.00.00.0000','PRECATÓRIOS DE FORNECEDORES NACIONAIS - ANTERIORES A 05/05/2000','REGISTRA OS VALORES DE PRECATÓRIOS PARA PAGAMENTO DE FORNECEDORES,ATE05/05/2000, EXIGÍVEIS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.3.1.1.03.04.00.00.0000','PRECATÓRIOS DE FORNECEDORES NACIONAIS - A PARTIR DE 05/05/2000','REGISTRA OS VALORES DE PRECATÓRIOS PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000, EXIGIVEL A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.3.2.0.00.00.00.00.0000','FORNECEDORES ESTRANGEIROS A LONGO PRAZO','COMPREENDE AS OBRIGAÇÕES JUNTO A FORNECEDORES ESTRANGEIROS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.3.2.1.00.00.00.00.0000','FORNECEDORES ESTRANGEIROS A LONGO PRAZO - CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES JUNTO A FORNECEDORES ESTRANGEIROS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.3.2.1.01.00.00.00.0000','FORNECEDORES ESTRANGEIROS DO EXERCÍCIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVIÇOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCÍCIO ATUAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.3.2.1.02.00.00.00.0000','FORNECEDORES ESTRANGEIROS DE EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVIÇOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCÍCIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.0.0.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A LONGO PRAZO','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES COM VENCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.1.0.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIAO','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES, COM VENCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.1.1.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.1.1.01.00.00.00.0000','PASSIVO FISCAL DIFERIDO','REGISTRA OS VALORES DE DÉBITOS FISCAIS DE LONGO PRAZO RELATIVOS A DIFERENÇAS INTERTEMPORAIS (DELIBERAÇÃO DA CVM Nº 273, DE 20/08/98),CORRESPONDENTES AO IRPJ E CSSL, BEM COMO PIS/PASEP E COFINS (LEI Nº 9.718 DE 27/11/1998).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.1.1.02.00.00.00.0000','TRIBUTOS FEDERAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS (IPI, IRPJ CSSL, PIS, PASEP E OUTROS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.1.1.99.00.00.00.0000','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGÍVEIS A LONGO PRAZO, DECORRENTES DA INCIDÊNCIA DE TRIBUTOS PARA OS QUAIS NÃO HAJA CONTAS ESPECÍFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.1.2.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIAO - INTRA OFSS','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.1.3.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIAO - INTER OFSS - UNIÃO','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.1.3.01.00.00.00.0000','PASSIVO FISCAL DIFERIDO','REGISTRA OS VALORES DE DÉBITOS FISCAIS DE LONGO PRAZO RELATIVOS A DIFERENÇAS INTERTEMPORAIS (DELIBERAÇÃO DA CVM Nº 273, DE 20/08/98),CORRESPONDENTES AO IRPJ E CSSL, BEM COMO PIS/PASEP E COFINS (LEI Nº 9.718 DE 27/11/1998).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.1.3.02.00.00.00.0000','TRIBUTOS FEDERAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS (IPI, IRPJ CSSL, PIS, PASEP E OUTROS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.1.3.99.00.00.00.0000','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGÍVEIS A LONGO PRAZO, DECORRENTES DA INCIDÊNCIA DE TRIBUTOS PARA OS QUAIS NÃO HAJA CONTAS ESPECÍFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.1.4.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIAO - INTER OFSS - ESTADO','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.1.5.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIAO - INTER OFSS - MUNICÍPIO','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.2.0.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO ESTADUAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES, COM VENCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.2.1.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO ESTADUAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.2.1.01.00.00.00.0000','TRIBUTOS ESTADUAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS (ICMS, IPVA E OUTROS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.2.1.99.00.00.00.0000','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGÍVEIS A LONGO PRAZO, DECORRENTES DA INCIDÊNCIA DE TRIBUTOS PARA OS QUAIS NÃO HAJA CONTAS ESPECÍFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.2.2.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - INTRA OFSS','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO ESTADUAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.2.2.01.00.00.00.0000','TRIBUTOS ESTADUAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS (ICMS, IPVA E OUTROS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.2.2.99.00.00.00.0000','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGÍVEIS A LONGO PRAZO, DECORRENTES DA INCIDÊNCIA DE TRIBUTOS PARA OS QUAIS NÃO HAJA CONTAS ESPECÍFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.3.0.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO MUNICIPAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES, COM VENCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.3.1.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO MUNICIPAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.3.1.01.00.00.00.0000','TRIBUTOS MUNICIPAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS (ISS, IPTU E OUTROS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.3.1.99.00.00.00.0000','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGÍVEIS A LONGO PRAZO, DECORRENTES DA INCIDÊNCIA DE TRIBUTOS PARA OS QUAIS NÃO HAJA CONTAS ESPECÍFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.3.2.00.00.00.00.0000','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS -INTRA OFSS','COMPREENDE AS OBRIGAÇÕES DAS ENTIDADES COM O GOVERNO MUNICIPAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUIÇÕES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.3.2.01.00.00.00.0000','TRIBUTOS MUNICIPAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS (ISS, IPTU E OUTROS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.4.3.2.99.00.00.00.0000','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGÍVEIS A LONGO PRAZO, DECORRENTES DA INCIDÊNCIA DE TRIBUTOS PARA OS QUAIS NÃO HAJA CONTAS ESPECÍFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.0.0.00.00.00.00.0000','PROVISÕES A LONGO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.1.0.00.00.00.00.0000','PROVISAO PARA RISCOS TRABALHISTAS A LONGO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE RECLAMAÇÕES TRABALHISTAS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.1.1.00.00.00.00.0000','PROVISÃO PARA RISCOS TRABALHISTAS A LONGO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE RECLAMAÇÕES TRABALHISTAS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.1.1.01.00.00.00.0000','PROVISÃO PARA INDENIZAÇÕES TRABALHISTAS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE INDENIZAÇÕES TRABALHISTAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.1.1.02.00.00.00.0000','PROVISÃO PARA PAGAMENTO DE DISSÍDIOS COLETIVOS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE DISSIDIOS COLETIVOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.0.00.00.00.00.0000','PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS A LONGO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A FUTUROS BENEFÍCIOS PREVIDÊNCIÁRIOS A SEREM PAGOS AOS CONTRIBUINTES, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.00.00.00.00.0000','PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A FUTUROS BENEFÍCIOS PREVIDÊNCIÁRIOS A SEREM PAGOS AOS CONTRIBUINTES, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.01.00.00.00.0000','PLANO FINANCEIRO - PROVISÕES DE BENEFÍCIOS CONCEDIDOS','COMPREENDE, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, A PROVISAO MATEMATICA CORRESPONDENTE AO VALOR PRESENTE LIQUIDO DAS PRESTAÇÕES FUTURAS DOS BENEFÍCIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTAÇÃO CONTINUADA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.01.01.00.00.0000','APOSENTADORIAS/ PENSÕES /OUTROS BENEFÍCIOS CONCEDIDOS DO PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS PRESTAÇÕES FUTURAS DOS BENEFÍCIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTAÇÃO CONTINUADA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.01.02.00.00.0000','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUIÇÕES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFÍCIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.01.03.00.00.0000','(-) CONTRIBUIÇÕES DO APOSENTADO PARA O PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUIÇÕES FUTURAS DOS INATIVOS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFÍCIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.01.04.00.00.0000','(-) CONTRIBUIÇÕES DO PENSIONISTA PARA O PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUIÇÕES FUTURAS DOS PENSIONISTAS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFÍCIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.01.05.00.00.0000','(-) COMPENSAÇÃO PREVIDÊNCIÁRIA DO PLANO FINANCEIRO DO RPPS','REGISTRAR, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DA COMPENSAÇÃO PREVIDÊNCIÁRIA CONFORME EXPRESSA O ARTIGO 11, DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.01.06.00.00.0000','(-) PARCELAMENTO DE DEBITOS PREVIDÊNCIÁRIOS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUIÇÕES NÃO VERTIDAS AO FUNDO SOB O REGIME DE PARCELAMENTO DE DEBITOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.01.07.00.00.0000','(-) ASSUNCAO DE INSUFICIÊNCIA FINANCEIRA DO PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS INSUFICIÊNCIAS FINANCEIRAS FUTURAS DO PLANO FINANCEIRO CONSIDERANDO O § 1º DO ARTIGO 2º DA LEI 9717/98.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.02.00.00.00.0000','PLANO FINANCEIRO - PROVISÕES DE BENEFÍCIOS A CONCEDER','COMPREENDE, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, A PROVISAO MATEMATICA CORRESPONDENTE AO VALOR PRESENTE LIQUIDO DAS PRESTAÇÕES FUTURAS DOS BENEFÍCIOS A CONCEDER PARA A GERAÇÃO ATUAL (SERVIDORES ATIVOS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.02.01.00.00.0000','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS A CONCEDER DO PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DOS BENEFÍCIOS A SEREM CONCEDIDOS AOS INTEGRANTES DA GERAÇÃO ATUAL QUE AINDA NÃO ESTEJAM EM GOZO DE BENEFÍCIOS DE PRESTAÇÃO CONTINUADA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.02.02.00.00.0000','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUIÇÕES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, INCIDENTES SOBRE AS REMUNERAÇÕES DA GERAÇÃO ATUAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.02.03.00.00.0000','(-) CONTRIBUIÇÕES DO SERVIDOR PARA O PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O SOMATÓRIO DO VALOR PRESENTE DAS CONTRIBUIÇÕES FUTURAS DOS SERVIDORES ATIVOS, INCIDENTES SOBRE AS REMUNERAÇÕES DA GERAÇÃO ATUAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.02.04.00.00.0000','(-) COMPENSAÇÃO PREVIDÊNCIÁRIA DO PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DA COMPENSAÇÃO PREVIDÊNCIÁRIA CONFORME EXPRESSA O ARTIGO 11, DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.02.05.00.00.0000','(-) PARCELAMENTO DE DEBITOS PREVIDÊNCIÁRIOS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUIÇÕES NÃO VERTIDAS AO PLANO, CONSIDERANDO O PARCELAMENTO DOS VALORES NÃO RECOLHIDOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.02.06.00.00.0000','(-) COBERTURA DE INSUFICIÊNCIA FINANCEIRA DO PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS INSUFICIÊNCIAS FINANCEIRAS FUTURAS DO PLANO FINANCEIRO, CONSIDERANDO O § 1º DO ARTIGO 2º DA LEI 9717/98','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.03.00.00.00.0000','PLANO PREVIDÊNCIÁRIO - PROVISÕES DE BENEFÍCIOS CONCEDIDOS','COMPREENDE, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, A PROVISAO MATEMATICA CORRESPONDENTE AO VALOR PRESENTE LIQUIDO DAS PRESTAÇÕES FUTURAS DOS BENEFÍCIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTAÇÃO CONTINUADA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.03.01.00.00.0000','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS CONCEDIDOS DO PLANO PREVIDÊNCIÁRIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS PRESTAÇÕES FUTURAS DOS BENEFÍCIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTAÇÃO CONTINUADA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.03.02.00.00.0000','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO PREVIDÊNCIÁRIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUIÇÕES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFÍCIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.03.03.00.00.0000','(-) CONTRIBUIÇÕES DO INATIVO PARA O PLANO PREVIDÊNCIÁRIO DO RPPS','REGISTRAR, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUIÇÕES FUTURAS DOS INATIVOS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFÍCIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.03.04.00.00.0000','(-) CONTRIBUIÇÕES DO PENSIONISTA PARA O PLANO PREVIDÊNCIÁRIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUIÇÕES FUTURAS DOS PENSIONISTAS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFÍCIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.03.05.00.00.0000','(-) COMPENSAÇÃO PREVIDÊNCIÁRIA DO PLANO PREVIDÊNCIÁRIO DO RPPS','REGISTRAR, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DA COMPENSAÇÃO PREVIDÊNCIÁRIA CONFORME EXPRESSA O ARTIGO 11 DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.03.06.00.00.0000','(-) PARCELAMENTO DE DEBITOS PREVIDÊNCIÁRIOS DO PLANO PREVIDÊNCIÁRIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUIÇÕES NÃO VERTIDAS AO PLANO, CONSIDERANDO O PARCELAMENTO DE VALORES NÃO RECOLHIDOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.04.00.00.00.0000','PLANO PREVIDÊNCIÁRIO - PROVISÕES DE BENEFÍCIOS A CONCEDER','COMPREENDE, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, A PROVISAO MATEMATICA CORRESPONDENTE AO VALOR PRESENTE LIQUIDO DAS PRESTAÇÕES FUTURAS DOS BENEFÍCIOS A CONCEDER PARA A GERAÇÃO ATUAL (SERVIDORES ATIVOS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.04.01.00.00.0000','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS A CONCEDER DO PLANO PREVIDÊNCIÁRIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DOS BENEFÍCIOS A SEREM CONCEDIDOS AOS INTEGRANTES DA GERAÇÃO ATUAL QUE AINDA NÃO ESTEJAM EM GOZO DE BENEFÍCIOS DE PRESTAÇÃO CONTINUADA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.04.02.00.00.0000','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO PREVIDÊNCIÁRIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUIÇÕES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, INCIDENTES SOBRE AS REMUNERAÇÕES DA GERAÇÃO ATUAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.04.03.00.00.0000','(-) CONTRIBUIÇÕES DO SERVIDOR PARA O PLANO PREVIDÊNCIÁRIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O SOMATÓRIO DO VALOR PRESENTE DAS CONTRIBUIÇÕES FUTURAS DOS SERVIDORES ATIVOS, INCIDENTES SOBRE AS REMUNERAÇÕES DA GERAÇÃO ATUAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.04.04.00.00.0000','(-) COMPENSAÇÃO PREVIDÊNCIÁRIA DO PLANO PREVIDÊNCIÁRIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DA COMPENSAÇÃO PREVIDÊNCIÁRIA CONFORME EXPRESSA O ARTIGO 11, DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.04.05.00.00.0000','(-) PARCELAMENTO DE DEBITOS PREVIDÊNCIÁRIOS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUIÇÕES NÃO VERTIDAS AO PLANO, SOB O REGIME DE PARCELAMENTO DE DEBITOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.05.00.00.00.0000','PLANO PREVIDÊNCIÁRIO - PLANO DE AMORTIZAÇÃO','COMPREENDE, DE ACORDO COM RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE LIQUIDO DOS DIREITOS INCORPORADOS AO PATRIMONIO DO RPPS COM BASE EM LEGISLAÇÃO ESPECIFICA, BEM COMO REGISTRO TEMPESTIVO DO PLANO DE AMORTIZAÇÃO IMPLEMENTADO EM LEI DO ENTE FEDERATIVO, CONSIDERANDO QUE O AJUSTE CONTABIL DAS RESERVAS MATEMATICAS SOMENTE OCORRERA NA APRESENTAÇÃO DE UMA NOVA REAVALIAÇÃO ATUARIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.05.98.00.00.0000','(-) OUTROS CRÉDITOS DO PLANO DE AMORTIZAÇÃO','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, O VALOR PRESENTE LIQUIDO DOS DIREITOS INCORPORADOS AO PATRIMONIO DO RPPS COM BASE EM LEGISLAÇÃO ESPECIFICA, COMO EXEMPLO: DIREITOS SOBRE ROYALTIES, BEM COMO REGISTRO TEMPESTIVO DO PLANO DE AMORTIZAÇÃO IMPLEMENTADO EM LEI DO ENTE FEDERATIVO, CONSIDERANDO QUE O AJUSTE CONTABIL DAS RESERVAS MATEMATICAS SOMENTE OCORRERA NA APRESENTAÇÃO DE UMA NOVA REAVALIAÇÃO ATUARIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.06.00.00.00.0000','PROVISÕES ATUARIAIS PARA AJUSTES DO PLANO FINANCEIRO','COMPREENDE O SOMATÓRIO DAS PROVISÕES ATUARIAIS CONSTITUIDAS PARA AJUSTES DO PLANO FINANCEIRO, CONFORME O RESULTADO DA AVALIAÇÃO ATUARIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.06.01.00.00.0000','PROVISAO ATUARIAL PARA OSCILAÇÃO DE RISCOS','REGISTRA, DE ACORDO COM A NOTA TECNICA ATUARIAL, A PROVISAO ATUARIAL CORRESPONDENTE A EVENTUAIS DESVIOS DOS COMPROMISSOS ESPERADOS OU PELA ADOCAO DE BASES TECNICAS QUE NÃO SE ADAPTAM AO PLANO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.07.00.00.00.0000','PROVISÕES ATUARIAIS PARA AJUSTES DO PLANO PREVIDÊNCIÁRIO','COMPREENDE O SOMATÓRIO DAS PROVISÕES ATUARIAIS CONSTITUIDAS PARA AJUSTES DO PLANO PREVIDÊNCIÁRIO, CONFORME O RESULTADO DA AVALIAÇÃO ATUARIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.07.01.00.00.0000','AJUSTE DE RESULTADO ATUARIAL SUPERÁVITARIO','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, PROVISAO ATUARIAL PARA AJUSTE DO PLANO PREVIDÊNCIÁRIO QUANDO O PLANO APRESENTAR RESULTADO SUPERÁVITARIO, CONSIDERANDO O ARTIGO 25, DA PORTARIA MPS 403/2008.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.07.02.00.00.0000','PROVISÃO ATUARIAL PARA OSCILAÇÃO DE RISCOS','REGISTRA, DE ACORDO COM A NOTA TECNICA ATUARIAL, A PROVISAO ATUARIAL CORRESPONDENTE A EVENTUAIS DESVIOS DOS COMPROMISSOS ESPERADOS OU PELA ADOCAO DE BASES TECNICAS QUE NÃO SE ADAPTAM AO PLANO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.07.03.00.00.0000','PROVISÃO ATUARIAL PARA BENEFÍCIOS A REGULARIZAR','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, PROVISAO ATUARIAL PARA AJUSTE DO PLANO PREVIDÊNCIÁRIO QUANDO APRESENTAR BENEFÍCIOS A REGULARIZAR, CONFORME PORTARIA MPS 403/2008.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.07.04.00.00.0000','PROVISÃO ATUARIAL PARA CONTINGÊNCIAS DE BENEFÍCIOS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, PROVISAO ATUARIAL PARA AJUSTE DO PLANO PREVIDÊNCIÁRIO PARA CONTIGÊNCIAS DE BENEFÍCIOS, CONFORME PORTARIA MPS 403/2008.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.2.1.07.98.00.00.0000','OUTRAS PROVISÕES ATUARIAIS PARA AJUSTES DO PLANO','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIAÇÃO ATUARIAL, OUTRAS PROVISÕES ATUARIAS PARA AJUSTE DO PLANO PREVIDÊNCIÁRIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.3.0.00.00.00.00.0000','PROVISAO PARA RISCOS FISCAIS A LONGO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUAÇÕES FISCAIS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.3.1.00.00.00.00.0000','PROVISÃO PARA RISCOS FISCAIS A LONGO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUAÇÕES FISCAIS, COM PRAZO PROVAVEL APOS O TÉRMINO DO EXERCÍCIO SEGUINTE. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORÇAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NÃO PERTENÇA AO OFSS DE ENTE PÚBLICO, ALÉM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.3.1.01.00.00.00.0000','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO','COMPREENDE OS VALORES DAS PROVISÕES PARA PAGAMENTO DE AUTOS DE INFRAÇÃO JÁ LAVRADOS E QUE SE ENCONTRAM NA ESFERA ADMINISTRATIVA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.3.1.01.01.00.00.0000','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO NÃO RECORRIDOS','REGISTRA OS VALORES DAS PROVISÕES PARA PAGAMENTO DE AUTOS DE INFRAÇÃO JÁ LAVRADOS, PARA OS QUAIS A UNIDADE AINDA NÃO APRESENTOU RECURSO ADMINISTRATIVO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.3.1.01.02.00.00.0000','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO RECORRIDOS','REGISTRA OS VALORES DAS PROVISÕES PARA PAGAMENTO DE AUTOS DE INFRAÇÃO JÁ LAVRADOS, PARA OS QUAIS A UNIDADE APRESENTOU RECURSO ADMINISTRATIVO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.3.1.02.00.00.00.0000','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS - ESFERA JUDICIAL','COMPREENDE OS VALORES DAS PROVISÕES PARA PAGAMENTO DE AUTUAÇÕES FISCAIS QUE JÁ SE ENCONTRAM NA ESFERA JUDICIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.3.1.02.01.00.00.0000','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','REGISTRA OS VALORES DAS PROVISÕES PARA PAGAMENTO DE AUTUAÇÕES FISCAIS QUE SE ENCONTRAM NA ESFERA JUDICIAL E QUE NÃO ESTÃO EM FASE RECURSAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.3.1.02.02.00.00.0000','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','REGISTRA OS VALORES DAS PROVISÕES PARA PAGAMENTO DE AUTUAÇÕES FISCAIS QUE SE ENCONTRAM NA ESFERA JUDICIAL EM FASE RECURSAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.4.0.00.00.00.00.0000','PROVISAO PARA RISCOS CIVEIS A LONGO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZAÇÕES A FORNECEDORES E CLIENTES, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.4.1.00.00.00.00.0000','PROVISÃO PARA RISCOS CÍVEIS A LONGO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DEINDENIZAÇÕES A FORNECEDORES E CLIENTES, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.4.1.01.00.00.00.0000','PROVISÃO PARA INDENIZAÇÕES CÍVEIS','REGISTRA OS VALORES DAS PROVISÕES CONSTITUÍDAS PARA O PAGAMENTO DE INDENIZAÇÕES CÍVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.4.1.02.00.00.00.0000','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','REGISTRA OS VALORES DAS PROVISÕES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.4.1.03.00.00.00.0000','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISÕES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JÁ CIENTIFICADOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.4.1.04.00.00.00.0000','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS NÃO CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISÕES PARA PAGAMENTO DE SEGUROS, REFERENTES A SINISTROS NÃO CIENTIFICADOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.5.0.00.00.00.00.0000','PROVISAO PARA REPARTICAO DE CRÉDITOS A LONGO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CRÉDITOS TRIBUTÁRIOS E NÃO TRIBUTÁRIOS RECONHECIDOS NO LANÇAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERAÇÃO, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. NA ARRECADAÇÃO, ESTA PROVISÃO SERÁ REVERTIDA EM CONTA ESPECIFICA DE PASSIVO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.5.3.00.00.00.00.0000','PROVISAO PARA REPARTICAO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CRÉDITOS TRIBUTÁRIOS E NÃO TRIBUTÁRIOS RECONHECIDOS NO LANÇAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERAÇÃO, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. NA ARRECADAÇÃO, ESTA PROVISÃO SERÁ REVERTIDA EM CONTA ESPECIFICA DE PASSIVO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.5.4.00.00.00.00.0000','PROVISAO PARA REPARTICAO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CRÉDITOS TRIBUTÁRIOS E NÃO TRIBUTÁRIOS RECONHECIDOS NO LANÇAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERAÇÃO, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. NA ARRECADAÇÃO, ESTA PROVISÃO SERÁ REVERTIDA EM CONTA ESPECIFICA DE PASSIVO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.5.5.00.00.00.00.0000','PROVISAO PARA REPARTICAO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CRÉDITOS TRIBUTÁRIOS E NÃO TRIBUTÁRIOS RECONHECIDOS NO LANÇAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERAÇÃO, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. NA ARRECADAÇÃO, ESTA PROVISÃO SERÁ REVERTIDA EM CONTA ESPECIFICA DE PASSIVO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.6.0.00.00.00.00.0000','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUCAO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.6.1.00.00.00.00.0000','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO -CONSOLIDAÇÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUCAO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.9.0.00.00.00.00.0000','OUTRAS PROVISÕES A LONGO PRAZO','COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO, NÃO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.9.1.00.00.00.00.0000','OUTRAS PROVISÕES A LONGO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO, NÃO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.9.1.01.00.00.00.0000','PROVISÃO PARA GARANTIAS','REGISTRA OS VALORES DAS PROVISÕES DESTINADAS A COBRIR DESPESAS COM A PRESTAÇÃO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.9.1.02.00.00.00.0000','PROVISÃO PARA REESTRUTURAÇÃO','REGISTRA OS VALORES DAS PROVISÕES DESTINADAS A COBRIR OBRIGAÇÕES ORIUNDAS DA VENDA OU EXTINÇÃO DE UMA LINHA DE NEGÓCIOS, FECHAMENTO DE FÁBRICAS OU LOCAIS DE NEGÓCIOS, MUDANÇAS NA ESTRUTURA DA ADMINISTRAÇÃO E REORGANIZAÇÕES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERAÇÕES DA ENTIDADE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.9.1.03.00.00.00.0000','PROVISÕES DO FCVS','COMPREENDE, DE ACORDO COM A NOTA TÉCNICA ATUARIAL, OS VALORES ATUARIAIS DOS PASSIVOS DO FUNDO DE COMPENSAÇÃO E VARIAÇÕES SALARIAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.9.1.03.01.00.00.0000','PROVISÕES DO FCVS - RISCOS EXPIRADOS','REGISTRA OS RESÍDUOS DE CONTRATOS LIQUIDADOS PELO MUTUÁRIO COM COBERTURA DO FCVS, DE ACORDO COM A AVALIAÇÃO ATUARIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.9.1.03.02.00.00.0000','PROVISÕES DO FCVS - RISCOS NÃO EXPIRADOS','REGISTRA O MONTANTE DE CONTRATOS COM COBERTURA DO FCVS EM FASE DE PAGAMENTO PELOS MUTUÁRIOS, DE ACORDO COM A AVALIAÇÃO ATUARIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.7.9.1.99.00.00.00.0000','OUTRAS PROVISÕES A LONGO PRAZO','REGISTRA OS VALORES DAS PROVISÕES NÃO CLASSIFICÁVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.0.0.00.00.00.00.0000','DEMAIS OBRIGAÇÕES A LONGO PRAZO','COMPREENDE AS OBRIGAÇÕES DA ENTIDADE JUNTO A TERCEIROS NÃO INCLUSAS NOS SUBGRUPOS ANTERIORES, INCLUSIVE OS PRECATÓRIOS DECORRENTES DESSAS OBRIGAÇÕES, COM VENCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.1.0.00.00.00.00.0000','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO','COMPREENDE AS ANTECIPAÇÕES RECEBIDAS POR OPERAÇÕES DE FORNECIMENTO DE BENS OU PRESTAÇÃO DE SERVIÇOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERAÇÃO NÃO OCORRA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.1.1.00.00.00.00.0000','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO- CONSOLIDAÇÃO','COMPREENDE AS ANTECIPAÇÕES RECEBIDAS POR OPERAÇÕES DE FORNECIMENTO DE BENS OU PRESTAÇÃO DE SERVIÇOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERAÇÃO NÃO OCORRA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.2.0.00.00.00.00.0000','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO','COMPREENDE OS VALORES EXIGÍVEIS NO LONGO PRAZO, PROVENIENTES DE DANOS A TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.2.1.00.00.00.00.0000','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS VALORES EXIGÍVEIS NO LONGO PRAZO, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.3.0.00.00.00.00.0000','DEBENTURES E OUTROS TITULOS DE DÍVIDA A LONGO PRAZO','COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CRÉDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO, COM VENCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.3.1.00.00.00.00.0000','DEBÊNTURES E OUTROS TÍTULOS DE DÍVIDA A LONGO PRAZO- CONSOLIDAÇÃO','COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CRÉDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.4.0.00.00.00.00.0000','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','COMPREENDE OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.4.1.00.00.00.00.0000','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.0.00.00.00.00.0000','VALORES RESTITUÍVEIS','COMPREENDE OS VALORES DE TERCEIROS OU RETENÇÕES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PÚBLICO FOR FIEL DEPOSITARIA, EXIGÍVEIS NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.00.00.00.00.0000','VALORES RESTITUÍVEIS - CONSOLIDAÇÃO','COMPREENDE OS VALORES DE TERCEIROS OU RETENÇÕES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PÚBLICO FOR FIEL DEPOSITARIA, EXIGÍVEIS NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.00.00.00.0000','CONSIGNACOES','COMPREENDE OS VALORES ENTREGUES EM CONFIANCA OU EM CONSIGNACOES, GERALMENTE RETIDOS EM FOLHA DE PAGAMENTO DE EMPREGADOS OU SERVIDORES OU NOS PAGAMENTOS REFERENTES A COMPRAS DE BENS E SERVICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.01.00.00.0000','RPPS - RETENÇÕES SOBRE VENCIMENTOS E VANTAGENS','REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE SERVIDORES A SER RECOLHIDO AO RPPS DO SERVIDOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.02.00.00.0000','INSS','REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE EMPREGADOS REGIDOS PELA CONSOLIDACAO DAS LEIS DO TRABALHO (CLT) OU DE SERVIÇOS DE TERCEIROS, A SER RECOLHIDO AO INSTITUTO NACIONAL DO SEGURO SOCIAL/PREVIDENCIA SOCIAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.03.00.00.0000',' ENCARGOS SOCIAIS - OUTRAS ENTIDADES','REGISTRA O VALOR A SER RECOLHIDO A OUTRAS ENTIDADES, EM FUNCAO DE DISPOSITIVOS LEGAIS COM AS QUAIS A ENTIDADE MANTENHA CONVENIO DE ARRECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER, SEBRAE, SENAT, SESCOOP, SESC.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.04.00.00.0000','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DO IMPOSTO SOBRE A RENDA, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS OU CREDITADAS A SERVIDORES OU EMPREGADOS, SOBRE AS QUAIS INCIDA O REFERIDO IMPOSTO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.05.00.00.0000','INDENIZAÇÕES E RESTITUICOES','REGISTRA OS VALORES RELATIVOS AS INDENIZAÇÕES E RESTITUICOES DE TRIBUTOS COM AUTORIZAÇÕES CONCEDIDAS, POREM NÃO DEVOLVIDAS AOS LEGITIMOS CREDORES PELA ENTIDADE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.06.00.00.0000','IMPOSTOS E CONTRIBUIÇÕES DIVERSOS','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DE IMPOSTOS E CONTRIBUIÇÕES DIVERSOS, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS, SOBRE OS QUAIS INCIDAM OS REFERIDOS TRIBUTOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.07.00.00.0000',' ICMS','REGISTRA OS VALORES RELATIVOS AO IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E SERVIÇOS RETIDOS POR FOCA DE LEGISLACAO OU POR ACORDO ENTRE AS PARTES ENVOLVIDAS NA TRANSACAO EM CONSIGNAÇÕES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.08.00.00.0000',' ISS','REGISTRA OS VALORES DO IMPOSTO SOBRE SERVIÇOS RETIDOS EM CONSIGNAÇÕES POR FORCA DE LEGISLACAO, CIRCUNSTANCIAS OU ACORDO ENTRE AS PARTES ENVOLVIDOS NA TRANSACAO, EM SITUAÇÕES QUE A ENTIDADE COMO PARTE CONTRATANTE, ATUE COMO SUBSTITUTA TRIBUTÁRIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.09.00.00.0000','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS','REGISTRA OS VALORES EM CONSIGNACAO RELATIVOS A OUTROS TRIBUTOS A SEREM REPASSADOS AOS ESTADOS E MUNICIPIOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.10.00.00.0000','PENSAO ALIMENTICIA','REGISTRA OS VALORES DAS RETENCOES EM FOLHA PROCEDIDAS EM PAGAMENTOS A EMPREGADOS OU A SERVIDORES, AUTORIZADOS POR ESSES OU POR DETERMINACAO JUDICIAL, A TITULO DE PENSAO ALIMENTICIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.11.00.00.0000','PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DO PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES DE PREVIDENCIA E ASSISTENCIA MEDICA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.12.00.00.0000','ASSISTENCIA A SAUDE - ADMINISTRAÇÃO PROPRIA','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, QUE SERAO ADMINISTRADOS PELO PROPRIO ORGAO/ENTIDADE PARA ASSISTENCIA A SAUDE DE SEUS SERVIDORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.13.00.00.0000','RETENCOES - ENTIDADES REPRESENTATIVAS DE CLASSES','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DE PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES REPRESENTATIVAS DE CLASSE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.14.00.00.0000','RETENCOES - PLANOS DE SEGUROS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES AS CONTRIBUIÇÕES A PLANOS DE SEGURO DE VIDA EM GRUPO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.15.00.00.0000','RETENCOES - EMPRÉSTIMOS E FINANCIAMENTOS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS POR TERCEIROS, BEM COMO RETENCOES DE PARCELAS DE CONSORCIOS E SEGURADOS DO INSS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.16.00.00.0000','RETENÇÃO RELATIVA A VALE TRANSPORTE','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDAS PELA ENTIDADE A SEREM RE-PASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVIÇOS DE FORNECIMENTO DE VALE-TRANSPORTE. TRATA-SE DOS VALORES REFERENTES AOS 6% INSTITUIDOS PELO ARTIGO 9º DO DECRETO Nº 95.247/1987 E SUAS ALTERAÇÕES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.17.00.00.0000','RETENÇÃO RELATIVA A VALE ALIMENTAÇÃO','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDAS PELA ENTIDADE A SEREM REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVIÇOS DE FORNECIMENTO DE CARTAO-ALIMENTACAO/REFEICAO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.01.99.00.00.0000','OUTROS CONSIGNATARIOS','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, EM CONFIANCA, POR DIVERSOS CONTRIBUINTES SUJEITOS A RECOLHIMENTOS E OU PAGAMENTOS AOS FAVORECIDOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.02.00.00.00.0000','GARANTIAS','COMPREENDE A GARANTIA DO CUMPRIMENTO DE UMA OBRIGACAO, QUE SE EFETIVA COM O OFERECIMENTO DE BENS OU RECURSOS FINANCEIROS OU AINDA RETENCOES DE UM PERCENTUAL DO VALOR DO CONTRATO COMO GARANTIA DE CUMPRIMENTO DO MESMO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.03.00.00.00.0000','DEPOSITOS JUDICIAIS','COMPREENDE OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL E DEPOSITOS PARA RECURSOS JUDICIAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.03.01.00.00.0000','DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.03.02.00.00.0000','DEPOSITOS PARA RECURSOS JUDICIAIS','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS EFETUADOS A FAVOR DA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.04.00.00.00.0000','DEPOSITOS NAO JUDICIAIS','COMPREENDE OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS, EXCETO DEPOSITOS JUDICIAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.04.01.00.00.0000','DEPOSITOS E CAUCOES','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS E/OU CAUCOES VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.04.02.00.00.0000','DEPOSITOS ESPECIAIS','REGISTRA O VALOR RELATIVO A RETENCOES DE DEPOSITOS VINCULADOS A RESTITUIR NO CURSO DO EXERCICIO SEGUINTE A ENTIDADE TRANSFERIDORA, DECORRENTE DE CONTRATOS OU INSTRUMENTOS CONGENERES, CONVENCAO, ACORDO OU AJUSTE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.04.03.00.00.0000','DEPOSITOS DE TERCEIROS','REGISTRA OS VALORES RELATIVOS AOS DEPÓSITOS DE TERCEIROS DE DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NÃO RECLAMADOS PELOS CREDORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.04.04.00.00.0000','DEPOSITOS DE VEICULOS ALIENAVEIS','REGISTRA O VALOR DOS RECEBIMENTOS PROVENIENTES DA ALIENACAO DE VEICULOS REMOVIDOS, RECOLHIDOS OU APREENDIDOS DE ACORDO COM A RESOLUCAO DO CONTRAN Nº 178/2005, PENDENTES DE TRANSFERÊNCIAS DIVERSAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.04.05.00.00.0000','DEPOSITOS A TRANSFERIR','REGISTRA OS VALORES DAS RETENCOES DE DEPOSITOS DE DIVERSAS ORIGENS RECEBIDOS POR UG CENTRAL CUJA DEVOLUCAO DEVE SER REALIZADA NO CURSO DO EXERCICIO SEGUINTE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.04.06.00.00.0000','DEPOSITOS DE TERCEIROS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TERCEIROS DE DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NAO RECLAMADOS PELOS CREDORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.04.99.00.00.0000','OUTROS DEPOSITOS','REGISTRA COMPROMISSOS EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, DECORRENTES DE RECEBIMENTOS A TITULO DE DEPOSITOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.8.1.99.00.00.00.0000','OUTROS VALORES RESTITUIVEIS','COMPREENDE OUTROS VALORES RESTITUIVEIS EM POSSE DA ENTIDADE, NO PAPEL DE FIEL DEPOSITARIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.0.00.00.00.00.0000','OUTRAS OBRIGAÇÕES A LONGO PRAZO','COMPREENDE OUTRAS OBRIGAÇÕES NÃO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO NO LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.00.00.00.00.0000','OUTRAS OBRIGAÇÕES A LONGO PRAZO- CONSOLIDAÇÃO','COMPREENDE OUTRAS OBRIGAÇÕES NÃO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.01.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES','COMPREENDE AS OBRIGAÇÕES RELATIVAS A INDENIZAÇÕES E RESTITUIÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.01.01.00.00.0000','IINDENIZAÇÕES A SERVIDORES','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DAS OBRIGAÇÕES CONSTITUÍDAS VISANDO O PAGAMENTO DE INDENIZAÇÕES TRABALHISTAS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.01.02.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES DIVERSAS DO EXERCÍCIO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DAS OBRIGAÇÕES CONSTITUÍDAS VISANDO O PAGAMENTO DE INDENIZAÇÕES CÍVEIS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.01.03.00.00.0000','INDENIZAÇÕES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZAÇÕES E RESTITUICOES DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.01.04.00.00.0000','RESTITUICOES DE CONTRIBUIÇÕES PREVIDENCIARIAS','REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUIÇÕES PREVIDENCIARIAS A SEREM EFETIVADAS PELAS UNIDADES DO INSS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.03.00.00.00.0000','CONVÊNIOS A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.10.00.00.00.0000','PRECATÓRIOS DE TERCEIROS','COMPREENDE AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS, EXCETO PRECATÓRIOS DE PESSOAL, DE BENEFÍCIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVIÇOS E UTILIDADES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.10.01.00.00.0000','PRECATÓRIOS DE TERCEIROS DO EXERCÍCIO','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS , EXCETO PRECATÓRIOS DE PESSOAL, DE BENEFÍCIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVIÇOS E UTILIDADES., INCORRIDAS NO EXERCÍCIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.10.02.00.00.0000','PRECATÓRIOS DE TERCEIROS DE EXERCÍCIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATÓRIOS, EXCETO PRECATÓRIOS DE PESSOAL, DE BENEFÍCIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVIÇOS E UTILIDADES, INCORRIDAS EM EXERCÍCIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.10.03.00.00.0000','PRECATÓRIOS DE TERCEIROS DE EXERCÍCIOS ANTERIORES- A PARTIR DE 05/05/2000','REGISTRA OS VALORES RELATIVOS A PRECATÓRIOS , EXCETO PRECATÓRIOS DE PESSOAL, DE BENEFÍCIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVIÇOS E UTILIDADES., INCORRIDAS EM EXERCÍCIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.11.00.00.00.0000','COMPENSAÇÃO PREVIDENCIÁRIA','COMPREENDE O VALOR DAS OBRIGAÇÕES COM COMPENSAÇÃO PREVIDÊNCIÁRIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.11.01.00.00.0000','COMPENSAÇÃO PREVIDENCIÁRIA DO EXERCÍCIO','REGISTRA O VALOR DAS OBRIGAÇÕES DO EXERCÍCIO COM COMPENSAÇÃO PREVIDÊNCIÁRIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL -RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.11.02.00.00.0000','COMPENSAÇÃO PREVIDENCIÁRIA DE EXERCÍCIOS ANTERIORES','REGISTRA O VALOR DAS OBRIGAÇÕES DE EXERCÍCIOS ANTERIORES COM COMPENSAÇÃO PREVIDÊNCIÁRIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.13.00.00.00.0000','CONTRATOS DE GESTAO','REGISTRA AS OBRIGAÇÕES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRAÇÃO PÚBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.99.00.00.00.0000','OUTROS CREDORES A LONGO PRAZO','REGISTRA OS VALORES EXIGÍVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.8.9.1.99.01.00.00.0000','OPERAÇÕES DE CRÉDITO ENTRE ENTIDADES DA ADMINISTRAÇÃO MUNICIPAL','REGISTRA OS VALORES DAS OBRIGAÇÕES, EXIGÍVEIS A LONGO PRAZO, ENTRE ENTIDADES DA ADMINISTRAÇÃO MUNICIPAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.9.0.0.00.00.00.00.0000','RESULTADO DIFERIDO','COMPREENDE O VALOR DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS JÁ RECEBIDAS QUE EFETIVAMENTE DEVEM SER RECONHECIDAS EM RESULTADOS EM ANOS FUTUROS E QUE NÃO HAJA QUALQUER TIPO DE OBRIGAÇÃO DE DEVOLUÇÃO POR PARTE DA ENTIDADE. COMPREENDE TAMBÉM O SALDO EXISTENTE NA ANTIGA CONTA RESULTADO DE EXERCÍCIOS FUTUROS EM 31 DE DEZEMBRO DE 2008.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.9.1.0.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL AUMENTATIVA (VPA) DIFERIDA','COMPREENDE O VALOR DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS JA RECEBIDAS QUE EFETIVAMENTE DEVEM SER RECONHECIDAS EM RESULTADOS EM ANOS FUTUROS E QUE NÃO HAJA QUALQUER TIPO DE OBRIGAÇÃO DE DEVOLUCAO POR PARTE DA ENTIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.9.1.1.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL AUMENTATIVA DIFERIDA - CONSOLIDAÇÃO','COMPREENDE O VALOR DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS JA RECEBIDAS QUE EFETIVAMENTE DEVEM SER RECONHECIDAS EM RESULTADOS EM ANOS FUTUROS E QUE NÃO HAJA QUALQUER TIPO DE OBRIGAÇÃO DE DEVOLUCAO POR PARTE DA ENTIDADE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.9.2.0.00.00.00.00.0000','(-) CUSTO DIFERIDO','COMPREENDE O CUSTO RELACIONADO AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS (VPA) DIFERIDAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.2.9.2.1.00.00.00.00.0000','(-) CUSTO DIFERIDO - CONSOLIDAÇÃO','COMPREENDE O CUSTO RELACIONADO AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS (VPA) DIFERIDAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.0.0.0.00.00.00.00.0000','PATRIMONIO LIQUIDO','COMPREENDE O VALOR RESIDUAL DOS ATIVOS DEPOIS DE DEDUZIDOS TODOS OS PASSIVOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.1.0.0.00.00.00.00.0000','PATRIMONIO SOCIAL E CAPITAL SOCIAL','COMPREENDE O PATRIMONIO SOCIAL DAS AUTARQUIAS, FUNDAÇÕES E FUNDOS E O CAPITAL SOCIAL DAS DEMAIS ENTIDADES DA ADMINISTRAÇÃO INDIRETA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.1.1.0.00.00.00.00.0000','PATRIMONIO SOCIAL','COMPREENDE O PATRIMONIO DAS AUTARQUIAS, FUNDAÇÕES E FUNDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.1.1.1.00.00.00.00.0000','PATRIMÔNIO SOCIAL - CONSOLIDAÇÃO','REGISTRA O PATRIMONIO DAS AUTARQUIAS, FUNDAÇÕES E FUNDOS, PERTENCENTES AOS ORÇAMENTOS FISCAL E DA SEGURIDADE SOCIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.1.2.0.00.00.00.00.0000','CAPITAL SOCIAL REALIZADO','COMPREENDE O CAPITAL SOCIAL SUBSCRITO DAS EMPRESAS PÚBLICAS E SOCIEDADES DE ECONOMIA MISTA, DEDUZIDO DA PARCELA AINDA NÃO REALIZADA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.1.2.1.00.00.00.00.0000','CAPITAL SOCIAL REALIZADO - CONSOLIDAÇÃO','COMPREENDE O CAPITAL SOCIAL SUBSCRITO DAS EMPRESAS PÚBLICAS E SOCIEDADES DE ECONOMIA MISTA, DEDUZIDO DA PARCELA AINDA NÃO REALIZADA.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.1.2.2.00.00.00.00.0000','CAPITAL SOCIAL REALIZADO - INTRA OFSS','COMPREENDE O CAPITAL SOCIAL SUBSCRITO, DEDUZIDO DA PARCELA AINDA NÃO REALIZADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.1.2.3.00.00.00.00.0000','CAPITAL SOCIAL REALIZADO - INTER OFSS - UNIÃO','COMPREENDE O CAPITAL SOCIAL SUBSCRITO, DEDUZIDO DA PARCELA AINDA NÃO REALIZADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.1.2.4.00.00.00.00.0000','CAPITAL SOCIAL REALIZADO - INTER OFSS - ESTADO','COMPREENDE O CAPITAL SOCIAL SUBSCRITO, DEDUZIDO DA PARCELA AINDA NÃO REALIZADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.1.2.5.00.00.00.00.0000','CAPITAL SOCIAL REALIZADO - INTER OFSS - MUNICÍPIO','COMPREENDE O CAPITAL SOCIAL SUBSCRITO, DEDUZIDO DA PARCELA AINDA NÃO REALIZADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.2.0.0.00.00.00.00.0000','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','COMPREENDE OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO NÃO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.2.0.1.00.00.00.00.0000','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO NÃO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.2.0.2.00.00.00.00.0000','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTRA OFSS','REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO NÃO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.2.0.3.00.00.00.00.0000','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - UNIÃO','REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO NÃO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.2.0.4.00.00.00.00.0000','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - ESTADO','REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO NÃO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.2.0.5.00.00.00.00.0000','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - MUNICÍPIO','REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO NÃO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.0.0.00.00.00.00.0000','RESERVAS DE CAPITAL','COMPREENDE OS VALORES ACRESCIDOS AO PATRIMONIO QUE NÃO TRANSITARAM PELO RESULTADO COMO VARIAÇÕES PATRIMONIAIS AUMENTATIVAS (VPA).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.1.0.00.00.00.00.0000','AGIO NA EMISSAO DE AÇÕES','COMPREENDE A CONTRIBUICAO DO SUBSCRITOR DE AÇÕES QUE ULTRAPASSAR O VALOR NOMINAL E A PARTE DO PRECO DE EMISSAO DAS AÇÕES SEM VALOR NOMINAL QUE ULTRAPASSAR A IMPORTANCIA DESTINADA A FORMAÇÃO DO CAPITAL SOCIAL, INCLUSIVE NOS CASOS DE CONVERSAO EM AÇÕES DE DEBENTURES OU PARTES BENEFICIARIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.1.1.00.00.00.00.0000','ÁGIO NA EMISSÃO DE AÇÕES - CONSOLIDAÇÃO','REGISTRA A CONTRIBUICAO DO SUBSCRITOR DE AÇÕES QUE ULTRAPASSAR O VALOR NOMINAL E A PARTE DO PRECO DE EMISSAO DAS AÇÕES SEM VALOR NOMINAL QUE ULTRAPASSAR A IMPORTANCIA DESTINADA A FORMAÇÃO DO CAPITAL SOCIAL, INCLUSIVE NOS CASOS DE CONVERSAO EM AÇÕES DE DEBENTURES OU PARTES BENEFICIARIAS.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.1.2.00.00.00.00.0000','AGIO NA EMISSAO DE AÇÕES - INTRA OFSS','REGISTRA A CONTRIBUICAO DO SUBSCRITOR DE AÇÕES QUE ULTRAPASSAR O VALOR NOMINAL E A PARTE DO PRECO DE EMISSAO DAS AÇÕES SEM VALOR NOMINAL QUE ULTRAPASSAR A IMPORTANCIA DESTINADA A FORMAÇÃO DO CAPITAL SOCIAL, INCLUSIVE NOS CASOS DE CONVERSAO EM AÇÕES DE DEBENTURES OU PARTES BENEFICIARIAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.1.3.00.00.00.00.0000','AGIO NA EMISSAO DE AÇÕES - INTER OFSS - UNIÃO','REGISTRA A CONTRIBUICAO DO SUBSCRITOR DE AÇÕES QUE ULTRAPASSAR O VALOR NOMINAL E A PARTE DO PRECO DE EMISSAO DAS AÇÕES SEM VALOR NOMINAL QUE ULTRAPASSAR A IMPORTANCIA DESTINADA A FORMAÇÃO DO CAPITAL SOCIAL, INCLUSIVE NOS CASOS DE CONVERSAO EM AÇÕES DE DEBENTURES OU PARTES BENEFICIARIAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.1.4.00.00.00.00.0000','AGIO NA EMISSAO DE AÇÕES - INTER OFSS - ESTADO','REGISTRA A CONTRIBUICAO DO SUBSCRITOR DE AÇÕES QUE ULTRAPASSAR O VALOR NOMINAL E A PARTE DO PRECO DE EMISSAO DAS AÇÕES SEM VALOR NOMINAL QUE ULTRAPASSAR A IMPORTANCIA DESTINADA A FORMAÇÃO DO CAPITAL SOCIAL, INCLUSIVE NOS CASOS DE CONVERSAO EM AÇÕES DE DEBENTURES OU PARTES BENEFICIARIAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.1.5.00.00.00.00.0000','AGIO NA EMISSAO DE AÇÕES - INTER OFSS - MUNICÍPIO','REGISTRA A CONTRIBUICAO DO SUBSCRITOR DE AÇÕES QUE ULTRAPASSAR O VALOR NOMINAL E A PARTE DO PRECO DE EMISSAO DAS AÇÕES SEM VALOR NOMINAL QUE ULTRAPASSAR A IMPORTANCIA DESTINADA A FORMAÇÃO DO CAPITAL SOCIAL, INCLUSIVE NOS CASOS DE CONVERSAO EM AÇÕES DE DEBENTURES OU PARTES BENEFICIARIAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.2.0.00.00.00.00.0000','ALIENAÇÃO DE PARTES BENEFICIARIAS','COMPREENDE O PRODUTO DA ALIENAÇÃO DE PARTES BENEFICIARIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.2.1.00.00.00.00.0000','ALIENAÇÃO DE PARTES BENEFICIARIAS - CONSOLIDAÇÃO','REGISTRA O PRODUTO DA ALIENAÇÃO DE PARTES BENEFICIARIAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.2.2.00.00.00.00.0000','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTRA OFSS','REGISTRA O PRODUTO DA ALIENAÇÃO DE PARTES BENEFICIARIAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.2.3.00.00.00.00.0000','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - UNIÃO','REGISTRA O PRODUTO DA ALIENAÇÃO DE PARTES BENEFICIARIAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.2.4.00.00.00.00.0000','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - ESTADO','REGISTRA O PRODUTO DA ALIENAÇÃO DE PARTES BENEFICIARIAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.2.5.00.00.00.00.0000','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - MUNICÍPIO','REGISTRA O PRODUTO DA ALIENAÇÃO DE PARTES BENEFICIARIAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.3.0.00.00.00.00.0000','ALIENAÇÃO DE BONUS DE SUBSCRICAO','COMPREENDE O PRODUTO DA ALIENAÇÃO DE BONUS DE SUBSCRICAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.3.1.00.00.00.00.0000','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - CONSOLIDAÇÃO','REGISTRA O PRODUTO DA ALIENAÇÃO DE BONUS DE SUBSCRICAO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.3.2.00.00.00.00.0000','ALIENAÇÃO DE BONUS DE SUBSCRICAO - INTRA OFSS','REGISTRA O PRODUTO DA ALIENAÇÃO DE BONUS DE SUBSCRICAO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.3.3.00.00.00.00.0000','ALIENAÇÃO DE BONUS DE SUBSCRICAO - INTER OFSS - UNIÃO','REGISTRA O PRODUTO DA ALIENAÇÃO DE BONUS DE SUBSCRICAO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.3.4.00.00.00.00.0000','ALIENAÇÃO DE BONUS DE SUBSCRICAO - INTER OFSS - ESTADO','REGISTRA O PRODUTO DA ALIENAÇÃO DE BONUS DE SUBSCRICAO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.3.5.00.00.00.00.0000','ALIENAÇÃO DE BONUS DE SUBSCRICAO - INTER OFSS - MUNICÍPIO','REGISTRA O PRODUTO DA ALIENAÇÃO DE BONUS DE SUBSCRICAO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.4.0.00.00.00.00.0000','CORRECAO MONETARIA DO CAPITAL REALIZADO','COMPREENDE O RESULTADO DA CORRECAO MONETARIA DO CAPITAL REALIZADO, ENQUANTO NÃO-CAPITALIZADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.4.1.00.00.00.00.0000','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - CONSOLIDAÇÃO','REGISTRA O RESULTADO DA CORRECAO MONETARIA DO CAPITAL REALIZADO, ENQUANTO NÃO-CAPITALIZADO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.4.2.00.00.00.00.0000','CORRECAO MONETARIA DO CAPITAL REALIZADO - INTRA OFSS','REGISTRA O RESULTADO DA CORRECAO MONETARIA DO CAPITAL REALIZADO, ENQUANTO NÃO-CAPITALIZADO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.4.3.00.00.00.00.0000','CORRECAO MONETARIA DO CAPITAL REALIZADO - INTER OFSS - UNIÃO','REGISTRA O RESULTADO DA CORRECAO MONETARIA DO CAPITAL REALIZADO, ENQUANTO NÃO-CAPITALIZADO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.4.4.00.00.00.00.0000','CORRECAO MONETARIA DO CAPITAL REALIZADO - INTER OFSS - ESTADO','REGISTRA O RESULTADO DA CORRECAO MONETARIA DO CAPITAL REALIZADO, ENQUANTO NÃO-CAPITALIZADO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.4.5.00.00.00.00.0000','CORRECAO MONETARIA DO CAPITAL REALIZADO - INTER OFSS - MUNICÍPIO','REGISTRA O RESULTADO DA CORRECAO MONETARIA DO CAPITAL REALIZADO, ENQUANTO NÃO-CAPITALIZADO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.9.0.00.00.00.00.0000','OUTRAS RESERVAS DE CAPITAL','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.9.1.00.00.00.00.0000','OUTRAS RESERVAS DE CAPITAL - CONSOLIDAÇÃO','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLAÇÃO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.9.1.01.00.00.00.0000','PRÊMIO NA EMISSÃO DE DEBÊNTURES','REGISTRA OS VALORES DE PRÊMIO NA EMISSÃO DE DEBÊNTURES, QUE OCORREM QUANDO O PREÇO DA EMISSÃO DE DEBÊNTURES FOR SUPERIOR A SEU VALOR NOMINAL. ESTA CONTA NÃO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERÍODO NECESSÁRIO PARA UTILIZAÇÃO DOS SALDOS REMANESCENTES NELA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.9.1.02.00.00.00.0000','RESERVAS DE DOAÇÕES E SUBVENÇÕES PARA INVESTIMENTOS','REGISTRA OS VALORES DE DOAÇÕES E SUBVENÇÕES PARA INVESTIMENTOS. ESTA CONTA NÃO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERÍODO NECESSÁRIO PARA UTILIZAÇÃO DOS SALDOS REMANESCENTES NELA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.9.1.03.00.00.00.0000','RESERVA DE CORREÇÃO MONETÁRIA ESPECIAL DEC. LEI 1.598/77','REGISTRA OS VALORES DO RESULTADO DA CORREÇÃO MONETÁRIA ESPECIAL, CONFORME O DECRETO-LEI Nº 1.598/77.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.9.1.99.00.00.00.0000','DEMAIS RESERVAS DE CAPITAL','REGISTRA OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, NÃO CONTABILIZÁVEIS EM OUTRAS CONTAS DESTE PLANO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.9.2.00.00.00.00.0000','OUTRAS RESERVAS DE CAPITAL - INTRA OFSS','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLAÇÃO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.9.2.01.00.00.00.0000','PRÊMIO NA EMISSÃO DE DEBÊNTURES','REGISTRA OS VALORES DE PRÊMIO NA EMISSÃO DE DEBÊNTURES, QUE OCORREM QUANDO O PREÇO DA EMISSÃO DE DEBÊNTURES FOR SUPERIOR A SEU VALOR NOMINAL. ESTA CONTA NÃO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERÍODO NECESSÁRIO PARA UTILIZAÇÃO DOS SALDOS REMANESCENTES NELA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.9.2.02.00.00.00.0000','RESERVAS DE DOAÇÕES E SUBVENÇÕES PARA INVESTIMENTOS','REGISTRA OS VALORES DE DOAÇÕES E SUBVENÇÕES PARA INVESTIMENTOS. ESTA CONTA NÃO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERÍODO NECESSÁRIO PARA UTILIZAÇÃO DOS SALDOS REMANESCENTES NELA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.9.2.03.00.00.00.0000','RESERVA DE CORREÇÃO MONETÁRIA ESPECIAL DEC. LEI 1.598/77','REGISTRA OS VALORES DO RESULTADO DA CORREÇÃO MONETÁRIA ESPECIAL, CONFORME O DECRETO-LEI Nº 1.598/77.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.9.2.99.00.00.00.0000','DEMAIS RESERVAS DE CAPITAL','REGISTRA OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, NÃO CONTABILIZÁVEIS EM OUTRAS CONTAS DESTE PLANO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.9.3.00.00.00.00.0000','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - UNIÃO','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLAÇÃO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.9.4.00.00.00.00.0000','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - ESTADO','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLAÇÃO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.3.9.5.00.00.00.00.0000','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - MUNICÍPIO','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLAÇÃO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.4.0.0.00.00.00.00.0000','AJUSTES DE AVALIAÇÃO PATRIMONIAL','COMPREENDE AS CONTRAPARTIDAS DE AUMENTOS OU DIMINUICOES DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO E DO PASSIVO EM DECORRENCIA DA SUA AVALIAÇÃO A VALOR JUSTO, NOS CASOS PREVISTOS PELA LEI Nº 6.404/76 OU EM NORMAS EXPEDIDAS PELA COMISSÃO DE VALORES MOBILIARIOS, ENQUANTO NÃO COMPUTADAS NO RESULTADO DO EXERCÍCIO EM OBEDIENCIA AO REGIME DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.4.1.0.00.00.00.00.0000','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS','COMPREENDE AS CONTRAPARTIDAS DE AUMENTOS OU DIMINUICOES DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO EM DECORRENCIA DA SUA AVALIAÇÃO A VALOR JUSTO, NOS CASOS PREVISTOS PELA LEI Nº 6.404/76 OU EM NORMAS EXPEDIDAS PELA COMISSÃO DE VALORES MOBILIARIOS, ENQUANTO NÃO COMPUTADAS NO RESULTADO DO EXERCÍCIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.4.1.1.00.00.00.00.0000','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS - CONSOLIDAÇÃO','REGISTRA AS CONTRAPARTIDAS DE AUMENTOS OU DIMINUICOES DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO EM DECORRENCIA DA SUA AVALIAÇÃO A VALOR JUSTO, NOS CASOS PREVISTOS PELA LEI Nº 6.404/76 OU EM NORMAS EXPEDIDAS PELA COMISSÃO DE VALORES MOBILIARIOS, ENQUANTO NÃO COMPUTADAS NO RESULTADO DO EXERCÍCIO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.4.2.0.00.00.00.00.0000','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS','COMPREENDE AS CONTRAPARTIDAS DE AUMENTOS OU DIMINUICOES DE VALOR ATRIBUIDOS A ELEMENTOS DO PASSIVO EM DECORRENCIA DA SUA AVALIAÇÃO A VALOR JUSTO, NOS CASOS PREVISTOS PELA LEI Nº 6.404/76 OU EM NORMAS EXPEDIDAS PELA COMISSÃO DE VALORES MOBILIARIOS, ENQUANTO NÃO COMPUTADAS NO RESULTADO DO EXERCÍCIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.4.2.1.00.00.00.00.0000','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS - CONSOLIDAÇÃO','REGISTRA AS CONTRAPARTIDAS DE AUMENTOS OU DIMINUICOES DE VALOR ATRIBUIDOS A ELEMENTOS DO PASSIVO EM DECORRENCIA DA SUA AVALIAÇÃO A VALOR JUSTO, NOS CASOS PREVISTOS PELA LEI Nº 6.404/76 OU EM NORMAS EXPEDIDAS PELA COMISSÃO DE VALORES MOBILIARIOS, ENQUANTO NÃO COMPUTADAS NO RESULTADO DO EXERCÍCIO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.0.0.00.00.00.00.0000','RESERVAS DE LUCROS','COMPREENDE AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DAS ENTIDADES PARA FINALIDADES ESPECIFICAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.1.0.00.00.00.00.0000','RESERVA LEGAL','COMPREENDE OS VALORES DAS RESERVAS OBRIGATORIAMENTE CONSTITUIDAS COM 5% DO LUCRO LIQUIDO DO EXERCÍCIO, ATE ATINGIR O LIMITE DE 20% DO CAPITAL SOCIAL REALIZADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.1.1.00.00.00.00.0000','RESERVA LEGAL- CONSOLIDAÇÃO','REGISTRA OS VALORES DAS RESERVAS OBRIGATORIAMENTE CONSTITUIDAS COM 5% DO LUCRO LIQUIDO DO EXERCÍCIO, ATE ATINGIR O LIMITE DE 20% DO CAPITAL SOCIAL REALIZADO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.1.2.00.00.00.00.0000','RESERVA LEGAL- INTRA OFSS','REGISTRA OS VALORES DAS RESERVAS OBRIGATORIAMENTE CONSTITUIDAS COM 5% DO LUCRO LIQUIDO DO EXERCÍCIO, ATE ATINGIR O LIMITE DE 20% DO CAPITAL SOCIAL REALIZADO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.1.3.00.00.00.00.0000','RESERVA LEGAL- INTER OFSS - UNIÃO','REGISTRA OS VALORES DAS RESERVAS OBRIGATORIAMENTE CONSTITUIDAS COM 5% DO LUCRO LIQUIDO DO EXERCÍCIO, ATE ATINGIR O LIMITE DE 20% DO CAPITAL SOCIAL REALIZADO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.1.4.00.00.00.00.0000','RESERVA LEGAL- INTER OFSS - ESTADO','REGISTRA OS VALORES DAS RESERVAS OBRIGATORIAMENTE CONSTITUIDAS COM 5% DO LUCRO LIQUIDO DO EXERCÍCIO, ATE ATINGIR O LIMITE DE 20% DO CAPITAL SOCIAL REALIZADO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.1.5.00.00.00.00.0000','RESERVA LEGAL- INTER OFSS - MUNICÍPIO','REGISTRA OS VALORES DAS RESERVAS OBRIGATORIAMENTE CONSTITUIDAS COM 5% DO LUCRO LIQUIDO DO EXERCÍCIO, ATE ATINGIR O LIMITE DE 20% DO CAPITAL SOCIAL REALIZADO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.2.0.00.00.00.00.0000','RESERVAS ESTATUTÁRIAS','COMPREENDE AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A ATENDER FINALIDADES DETERMINADAS NO ESTATUTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.2.1.00.00.00.00.0000','RESERVAS ESTATUTÁRIAS - CONSOLIDAÇÃO','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A ATENDER FINALIDADES DETERMINADAS NO ESTATUTO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.2.2.00.00.00.00.0000','RESERVAS ESTATUTARIAS - INTRA OFSS','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A ATENDER FINALIDADES DETERMINADAS NO ESTATUTO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.2.3.00.00.00.00.0000','RESERVAS ESTATUTARIAS - INTER OFSS - UNIÃO','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A ATENDER FINALIDADES DETERMINADAS NO ESTATUTO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.2.4.00.00.00.00.0000','RESERVAS ESTATUTARIAS - INTER OFSS - ESTADO','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A ATENDER FINALIDADES DETERMINADAS NO ESTATUTO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.2.5.00.00.00.00.0000','RESERVAS ESTATUTARIAS - INTER OFSS - MUNICÍPIO','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A ATENDER FINALIDADES DETERMINADAS NO ESTATUTO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.3.0.00.00.00.00.0000','RESERVA PARA CONTINGENCIAS','COMPREENDE AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A COMPENSAR, EM EXERCÍCIO FUTURO, A DIMINUICAO DO LUCRO DECORRENTE DE PERDA JULGADA PROVAVEL, CUJO VALOR POSSA SER ESTIMADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.3.1.00.00.00.00.0000','RESERVA PARA CONTINGENCIAS - CONSOLIDAÇÃO','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A COMPENSAR, EM EXERCÍCIO FUTURO, A DIMINUICAO DO LUCRO DECORRENTE DE PERDA JULGADA PROVAVEL, CUJO VALOR POSSA SER ESTIMADO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.3.2.00.00.00.00.0000','RESERVA PARA CONTINGENCIAS - INTRA OFSS','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A COMPENSAR, EM EXERCÍCIO FUTURO, A DIMINUICAO DO LUCRO DECORRENTE DE PERDA JULGADA PROVAVEL, CUJO VALOR POSSA SER ESTIMADO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.3.3.00.00.00.00.0000','RESERVA PARA CONTINGENCIAS - INTER OFSS - UNIÃO','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A COMPENSAR, EM EXERCÍCIO FUTURO, A DIMINUICAO DO LUCRO DECORRENTE DE PERDA JULGADA PROVAVEL, CUJO VALOR POSSA SER ESTIMADO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.3.4.00.00.00.00.0000','RESERVA PARA CONTINGENCIAS - INTER OFSS - ESTADO','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A COMPENSAR, EM EXERCÍCIO FUTURO, A DIMINUICAO DO LUCRO DECORRENTE DE PERDA JULGADA PROVAVEL, CUJO VALOR POSSA SER ESTIMADO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.3.5.00.00.00.00.0000','RESERVA PARA CONTINGENCIAS - INTER OFSS - MUNICÍPIO','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A COMPENSAR, EM EXERCÍCIO FUTURO, A DIMINUICAO DO LUCRO DECORRENTE DE PERDA JULGADA PROVAVEL, CUJO VALOR POSSA SER ESTIMADO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.4.0.00.00.00.00.0000','RESERVA DE INCENTIVOS FISCAIS','COMPREENDE A RESERVA CONSTITUIDA COM PARCELA DO LUCRO LIQUIDO DECORRENTE DE DOAÇÕES OU SUBVENCOES GOVERNAMENTAIS PARA INVESTIMENTOS, QUE PODERA SER EXCLUIDA DA BASE DE CALCULO DO DIVIDENDO OBRIGATORIO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.4.1.00.00.00.00.0000','RESERVA DE INCENTIVOS FISCAIS - CONSOLIDAÇÃO','REGISTRA A RESERVA CONSTITUIDA COM PARCELA DO LUCRO LIQUIDO DECORRENTE DE DOAÇÕES OU SUBVENCOES GOVERNAMENTAIS PARA INVESTIMENTOS, QUE PODERA SER EXCLUIDA DA BASE DE CALCULO DO DIVIDENDO OBRIGATORIO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.4.2.00.00.00.00.0000','RESERVA DE INCENTIVOS FISCAIS - INTRA OFSS','REGISTRA A RESERVA CONSTITUIDA COM PARCELA DO LUCRO LIQUIDO DECORRENTE DE DOAÇÕES OU SUBVENCOES GOVERNAMENTAIS PARA INVESTIMENTOS, QUE PODERA SER EXCLUIDA DA BASE DE CALCULO DO DIVIDENDO OBRIGATORIO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.4.3.00.00.00.00.0000','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - UNIÃO','REGISTRA A RESERVA CONSTITUIDA COM PARCELA DO LUCRO LIQUIDO DECORRENTE DE DOAÇÕES OU SUBVENCOES GOVERNAMENTAIS PARA INVESTIMENTOS, QUE PODERA SER EXCLUIDA DA BASE DE CALCULO DO DIVIDENDO OBRIGATORIO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.4.4.00.00.00.00.0000','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - ESTADO','REGISTRA A RESERVA CONSTITUIDA COM PARCELA DO LUCRO LIQUIDO DECORRENTE DE DOAÇÕES OU SUBVENCOES GOVERNAMENTAIS PARA INVESTIMENTOS, QUE PODERA SER EXCLUIDA DA BASE DE CALCULO DO DIVIDENDO OBRIGATORIO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.4.5.00.00.00.00.0000','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - MUNICÍPIO','REGISTRA A RESERVA CONSTITUIDA COM PARCELA DO LUCRO LIQUIDO DECORRENTE DE DOAÇÕES OU SUBVENCOES GOVERNAMENTAIS PARA INVESTIMENTOS, QUE PODERA SER EXCLUIDA DA BASE DE CALCULO DO DIVIDENDO OBRIGATORIO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.5.0.00.00.00.00.0000','RESERVAS DE LUCROS PARA EXPANSÃO','COMPREENDE AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO , COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.5.1.00.00.00.00.0000','RESERVAS DE LUCROS PARA EXPANSÃO - CONSOLIDAÇÃO','REGISTRA AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO , COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.5.2.00.00.00.00.0000','RESERVAS DE LUCROS PARA EXPANSAO - INTRA OFSS','COMPREENDE AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO , COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.5.3.00.00.00.00.0000','RESERVAS DE LUCROS PARA EXPANSAO - INTER OFSS - UNIÃO','COMPREENDE AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO , COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.5.4.00.00.00.00.0000','RESERVAS DE LUCROS PARA EXPANSAO - INTER OFSS - ESTADO','COMPREENDE AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO , COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.5.5.00.00.00.00.0000','RESERVAS DE LUCROS PARA EXPANSAO - INTER OFSS - MUNICÍPIO','COMPREENDE AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO , COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.6.0.00.00.00.00.0000','RESERVA DE LUCROS A REALIZAR','COMPREENDE A RESERVA CONSTITUIDA COM O EXCESSO ENTRE O MONTANTE DO DIVIDENDO OBRIGATORIO E A PARCELA REALIZADA DO LUCRO LIQUIDO DO EXERCÍCIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.6.1.00.00.00.00.0000','RESERVA DE LUCROS A REALIZAR- CONSOLIDAÇÃO','REGISTRA A RESERVA CONSTITUIDA COM O EXCESSO ENTRE O MONTANTE DO DIVIDENDO OBRIGATORIO E A PARCELA REALIZADA DO LUCRO LIQUIDO DO EXERCÍCIO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.6.2.00.00.00.00.0000','RESERVA DE LUCROS A REALIZAR- INTRA OFSS','REGISTRA A RESERVA CONSTITUIDA COM O EXCESSO ENTRE O MONTANTE DO DIVIDENDO OBRIGATORIO E A PARCELA REALIZADA DO LUCRO LIQUIDO DO EXERCÍCIO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.6.3.00.00.00.00.0000','RESERVA DE LUCROS A REALIZAR- INTER OFSS - UNIÃO','REGISTRA A RESERVA CONSTITUIDA COM O EXCESSO ENTRE O MONTANTE DO DIVIDENDO OBRIGATORIO E A PARCELA REALIZADA DO LUCRO LIQUIDO DO EXERCÍCIO.COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.6.4.00.00.00.00.0000','RESERVA DE LUCROS A REALIZAR- INTER OFSS - ESTADO','REGISTRA A RESERVA CONSTITUIDA COM O EXCESSO ENTRE O MONTANTE DO DIVIDENDO OBRIGATORIO E A PARCELA REALIZADA DO LUCRO LIQUIDO DO EXERCÍCIO.COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.6.5.00.00.00.00.0000','RESERVA DE LUCROS A REALIZAR- INTER OFSS - MUNICÍPIO','REGISTRA A RESERVA CONSTITUIDA COM O EXCESSO ENTRE O MONTANTE DO DIVIDENDO OBRIGATORIO E A PARCELA REALIZADA DO LUCRO LIQUIDO DO EXERCÍCIO.COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.7.0.00.00.00.00.0000','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES','COMPREENDE A PARCELA DO LUCRO LIQUIDO DO EXERCÍCIO DECORRENTE DO PREMIO NA EMISSAO DE DEBENTURES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.7.1.00.00.00.00.0000','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- CONSOLIDAÇÃO','REGISTRA A PARCELA DO LUCRO LIQUIDO DO EXERCÍCIO DECORRENTE DO PREMIO NA EMISSAO DE DEBENTURES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.7.2.00.00.00.00.0000','RESERVA DE RETENCAO DE PREMIO NA EMISSAO DE DEBENTURES- INTRA OFSS','COMPREENDE A PARCELA DO LUCRO LIQUIDO DO EXERCÍCIO DECORRENTE DO PREMIO NA EMISSAO DE DEBENTURES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.7.3.00.00.00.00.0000','RESERVA DE RETENCAO DE PREMIO NA EMISSAO DE DEBENTURES- INTER OFSS - UNIÃO','COMPREENDE A PARCELA DO LUCRO LIQUIDO DO EXERCÍCIO DECORRENTE DO PREMIO NA EMISSAO DE DEBENTURES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.7.4.00.00.00.00.0000','RESERVA DE RETENCAO DE PREMIO NA EMISSAO DE DEBENTURES- INTER OFSS - ESTADO','COMPREENDE A PARCELA DO LUCRO LIQUIDO DO EXERCÍCIO DECORRENTE DO PREMIO NA EMISSAO DE DEBENTURES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.7.5.00.00.00.00.0000','RESERVA DE RETENCAO DE PREMIO NA EMISSAO DE DEBENTURES- INTER OFSS - MUNICÍPIO','COMPREENDE A PARCELA DO LUCRO LIQUIDO DO EXERCÍCIO DECORRENTE DO PREMIO NA EMISSAO DE DEBENTURES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.9.0.00.00.00.00.0000','OUTRAS RESERVAS DE LUCRO','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.9.1.00.00.00.00.0000','OUTRAS RESERVAS DE LUCRO - CONSOLIDAÇÃO','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLAÇÃO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.9.2.00.00.00.00.0000','OUTRAS RESERVAS DE LUCRO - INTRA OFSS','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLAÇÃO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.9.3.00.00.00.00.0000','OUTRAS RESERVAS DE LUCRO - INTER OFSS - UNIÃO','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLAÇÃO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.9.4.00.00.00.00.0000','OUTRAS RESERVAS DE LUCRO - INTER OFSS - ESTADO','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLAÇÃO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.5.9.5.00.00.00.00.0000','OUTRAS RESERVAS DE LUCRO - INTER OFSS - MUNICÍPIO','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLAÇÃO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.0.0.00.00.00.00.0000','DEMAIS RESERVAS','COMPREENDE AS DEMAIS RESERVAS, NÃO CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR TEREM SIDO EXTINTAS PELA LEGISLAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.0.00.00.00.00.0000','RESERVA DE REAVALIAÇÃO','COMPREENDE A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO, APURADOS PELA DIFERENCA ENTRE O VALOR DO LAUDO E O VALOR ANTERIOR (CUSTO ORIGINAL MAIS EVENTUAIS REAVALIAÇÕES ANTERIORES), NOS CASOS PERMITIDOS PELA LEGISLAÇÃO VIGENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.1.00.00.00.00.0000','RESERVA DE REAVALIAÇÃO - CONSOLIDAÇÃO','COMPREENDE A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO, APURADOS PELA DIFERENCA ENTRE O VALOR DO LAUDO E O VALOR ANTERIOR (CUSTO ORIGINAL MAIS EVENTUAIS REAVALIAÇÕES ANTERIORES). COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.1.01.00.00.00.0000','REAVALIAÇÃO DE BENS IMÓVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMÓVEIS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES, QUANDO O CONTROLE FOR POR INSCRIÇÃO GENERICA DO TIPO INDIVIDUALIZAÇÃO DE IMÓVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.1.03.00.00.00.0000','REAVALIAÇÃO DE BENS MÓVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS MÓVEIS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.1.04.00.00.00.0000','REAVALIAÇÃO DE BENS INTANGIVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS INTANGIVEIS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES, QUANDO O CONTROLE FOR POR CGC, CPF, IG OU UG.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.1.05.00.00.00.0000','REAVALIAÇÃO DE ATIVOS DE COLIGADAS E CONTROLADAS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, DAS REAVALIAÇÕES EFETUADAS NOS ATIVOS DAS COLIGADAS E CONTROLADAS AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.1.98.00.00.00.0000','OUTRAS RESERVAS DE REAVALIAÇÃO','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A OUTROS BENS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.1.99.00.00.00.0000','(-) TRIBUTOS SOBRE A RESERVA DE REAVALIAÇÃO','REGISTRA O VALOR DA CARGA TRIBUTÁRIA (IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL) DEVIDA SOBRE A FUTURA REALIZAÇÃO DE ATIVO QUE A GERARAM (PARA EFEITO DE CONTROLE FISCAL).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.2.00.00.00.00.0000','RESERVA DE REAVALIAÇÃO - INTRA OFSS','COMPREENDE A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO, APURADOS PELA DIFERENCA ENTRE O VALOR DO LAUDO E O VALOR ANTERIOR (CUSTO ORIGINAL MAIS EVENTUAIS REAVALIAÇÕES ANTERIORES), NOS CASOS PERMITIDOS PELA LEGISLAÇÃO VIGENTE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.2.01.00.00.00.0000','REAVALIAÇÃO DE BENS IMOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES, QUANDO O CONTROLE FOR POR INSCRICAO GENERICA DO TIPO INDIVIDUALIZACAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.2.03.00.00.00.0000','REAVALIAÇÃO DE BENS MOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS MOVEIS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.2.04.00.00.00.0000','REAVALIAÇÃO DE BENS INTANGIVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS INTANGIVEIS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES, QUANDO O CONTROLE FOR POR CGC, CPF, IG OU UG.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.2.05.00.00.00.0000','REAVALIAÇÃO DE ATIVOS DE COLIGADAS E CONTROLADAS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, DAS REAVALIAÇÕES EFETUADAS NOS ATIVOS DAS COLIGADAS E CONTROLADAS AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.2.98.00.00.00.0000','OUTRAS RESERVAS DE REAVALIAÇÃO','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A OUTROS BENS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.2.99.00.00.00.0000','(-) TRIBUTOS SOBRE A RESERVA DE REAVALIAÇÃO','REGISTRA O VALOR DA CARGA TRIBUTÁRIA (IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL) DEVIDA SOBRE A FUTURA REALIZACAO DE ATIVO QUE A GERARAM (PARA EFEITO DE CONTROLE FISCAL).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.3.00.00.00.00.0000','RESERVA DE REAVALIAÇÃO - INTER OFSS - UNIÃO','COMPREENDE A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO, APURADOS PELA DIFERENCA ENTRE O VALOR DO LAUDO E O VALOR ANTERIOR (CUSTO ORIGINAL MAIS EVENTUAIS REAVALIAÇÕES ANTERIORES). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.4.00.00.00.00.0000','RESERVA DE REAVALIAÇÃO - INTER OFSS - ESTADO','COMPREENDE A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO, APURADOS PELA DIFERENCA ENTRE O VALOR DO LAUDO E O VALOR ANTERIOR (CUSTO ORIGINAL MAIS EVENTUAIS REAVALIAÇÕES ANTERIORES). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.1.5.00.00.00.00.0000','RESERVA DE REAVALIAÇÃO - INTER OFSS - MUNICÍPIO','COMPREENDE A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO, APURADOS PELA DIFERENCA ENTRE O VALOR DO LAUDO E O VALOR ANTERIOR (CUSTO ORIGINAL MAIS EVENTUAIS REAVALIAÇÕES ANTERIORES). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.9.0.00.00.00.00.0000','OUTRAS RESERVAS','COMPREENDE OUTRAS RESERVAS QUE NÃO FOREM CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.9.1.00.00.00.00.0000','OUTRAS RESERVAS - CONSOLIDAÇÃO','REGISTRA OUTRAS RESERVAS QUE NÃO FOREM CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.9.1.01.00.00.00.0000','RESERVAS TECNICAS','REGISTRA O VALOR DO PATRIMONIO LIQUIDO DA RESERVA ORIGINARIA DE UM EXCEDENTE QUE NÃO PODE SER CONSIDERADO COMO LUCRO, DEVENDO SER GUARDADO COMO GARANTIA PARA USO FUTURO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.9.1.01.01.00.00.0000','RESERVAS PARA SINISTROS IMOBILIARIOS','REGISTRA O VALOR DO PATRIMONIO LIQUIDO DA RESERVA ORIGINARIA DA CONTRIBUICAO DE SEGURADOS (PREMIOS) PARA A COBERTURA, QUANDO DA OCORRENCIA DE SINISTRO IMOBILIARIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.9.1.01.02.00.00.0000','RESERVA DE GARANTIA','REGISTRA O VALOR NO PATRIMONIO LIQUIDO DA RESERVA ORIGINARIA DE CONTRIBUIÇÕES COMO FORMA DE GARANTIR O DIREITO DO SERVIDOR OU DA EMPRESA EM ACONTECIMENTOS EVENTUAIS QUE VENHAM A OCORRER.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.9.1.01.03.00.00.0000','RESERVAS ADMINISTRATIVAS','REGISTRA O VALOR DAS RESERVAS CONSTITUIDAS COM AS SOBRAS DO CUSTEIO ADMINISTRATIVO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.9.2.00.00.00.00.0000','OUTRAS RESERVAS - INTRA OFSS','REGISTRA OUTRAS RESERVAS QUE NÃO FOREM CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.9.3.00.00.00.00.0000','OUTRAS RESERVAS - INTER OFSS - UNIÃO','REGISTRA OUTRAS RESERVAS QUE NÃO FOREM CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.9.4.00.00.00.00.0000','OUTRAS RESERVAS - INTER OFSS - ESTADO','REGISTRA OUTRAS RESERVAS QUE NÃO FOREM CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.6.9.5.00.00.00.00.0000','OUTRAS RESERVAS - INTER OFSS - MUNICÍPIO','REGISTRA OUTRAS RESERVAS QUE NÃO FOREM CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.0.0.00.00.00.00.0000','RESULTADOS ACUMULADOS','COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUÍZOS LIQUIDOS DAS EMPRESAS E OS SUPERÁVITS OU DÉFICITS ACUMULADOS DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.0.00.00.00.00.0000','SUPERÁVITS OU DÉFICITS ACUMULADOS','COMPREENDE OS SUPERÁVITS OU DÉFICITS ACUMULADOS DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.1.00.00.00.00.0000','SUPERÁVITS OU DÉFICITS ACUMULADOS - CONSOLIDAÇÃO','COMPREENDE OS SUPERÁVITS OU DÉFICITS ACUMULADOS DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.1.01.00.00.00.0000','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','REGISTRA OS SUPERÁVITS OU DÉFICITS DO EXERCÍCIO DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.1.02.00.00.00.0000','SUPERÁVITS OU DÉFICITS DE EXERCÍCIOS ANTERIORES','COMPREENDE OS SUPERÁVITS OU DÉFICITS ACUMULADOS DE EXERCÍCIOS ANTERIORES DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.1.03.00.00.00.0000','AJUSTES DE EXERCÍCIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANÇA DE CRITERIO CONTABIL OU DA RETIFICAÇÃO DE ERRO IMPUTAVEL A DETERMINADO EXERCÍCIO ANTERIOR, E QUE NÃO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES. SERAO REGISTRADOS NESTA CONTA OS AJUSTES DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.1.04.00.00.00.0000','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSAO E CISAO','REGISTRA O RESULTADO APURADO POR EXTINÇÃO, CISAO OU FUSAO DE UNIDADE DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS, OCORRIDA DURANTE O EXERCÍCIO.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.2.00.00.00.00.0000','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTRA OFSS','COMPREENDE OS SUPERÁVITS OU DÉFICITS ACUMULADOS DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.2.01.00.00.00.0000','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','REGISTRA OS SUPERÁVITS OU DÉFICITS DO EXERCÍCIO DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.2.02.00.00.00.0000','SUPERÁVITS OU DÉFICITS DE EXERCÍCIOS ANTERIORES','REGISTRA OS SUPERÁVITS OU DÉFICITS DE EXERCÍCIOS ANTERIORES DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.2.03.00.00.00.0000','AJUSTES DE EXERCÍCIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANÇA DE CRITERIO CONTABIL OU DA RETIFICAÇÃO DE ERRO IMPUTAVEL A DETERMINADO EXERCÍCIO ANTERIOR, E QUE NÃO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES. SERAO REGISTRADOS NESTA CONTA OS AJUSTES DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.2.04.00.00.00.0000','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSAO E CISAO','REGISTRA O RESULTADO APURADO POR EXTINÇÃO, CISAO OU FUSAO DE UNIDADE DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS, OCORRIDA DURANTE O EXERCÍCIO.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.3.00.00.00.00.0000','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - UNIÃO','COMPREENDE OS SUPERÁVITS OU DÉFICITS ACUMULADOS DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.3.01.00.00.00.0000','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','REGISTRA OS SUPERÁVITS OU DÉFICITS DO EXERCÍCIO DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.3.02.00.00.00.0000','SUPERÁVITS OU DÉFICITS DE EXERCÍCIOS ANTERIORES','REGISTRA OS SUPERÁVITS OU DÉFICITS ACUMULADOS DE EXERCÍCIOS ANTERIORES DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.3.03.00.00.00.0000','AJUSTES DE EXERCÍCIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANÇA DE CRITERIO CONTABIL OU DA RETIFICAÇÃO DE ERRO IMPUTAVEL A DETERMINADO EXERCÍCIO ANTERIOR, E QUE NÃO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES. SERAO REGISTRADOS NESTA CONTA OS AJUSTES DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.3.04.00.00.00.0000','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSAO E CISAO','REGISTRA O RESULTADO APURADO POR EXTINÇÃO, CISAO OU FUSAO DE UNIDADE DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS, OCORRIDA DURANTE O EXERCÍCIO.','X','S','P','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.4.00.00.00.00.0000','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - ESTADO','COMPREENDE OS SUPERÁVITS OU DÉFICITS ACUMULADOS DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.4.01.00.00.00.0000','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','REGISTRA OS SUPERÁVITS OU DÉFICITS DO EXERCÍCIO DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.4.02.00.00.00.0000','SUPERÁVITS OU DÉFICITS DE EXERCÍCIOS ANTERIORES','REGISTRA OS SUPERÁVITS OU DÉFICITS ACUMULADOS DE EXERCÍCIOS ANTERIORES DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.4.03.00.00.00.0000','AJUSTES DE EXERCÍCIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANÇA DE CRITERIO CONTABIL OU DA RETIFICAÇÃO DE ERRO IMPUTAVEL A DETERMINADO EXERCÍCIO ANTERIOR, E QUE NÃO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES. SERAO REGISTRADOS NESTA CONTA OS AJUSTES DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.4.04.00.00.00.0000','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSAO E CISAO','REGISTRA O RESULTADO APURADO POR EXTINÇÃO, CISAO OU FUSAO DE UNIDADE DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS, OCORRIDA DURANTE O EXERCÍCIO.','X','S','P','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.5.00.00.00.00.0000','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - MUNICÍPIO','COMPREENDE OS SUPERÁVITS OU DÉFICITS ACUMULADOS DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.5.01.00.00.00.0000','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','REGISTRA OS SUPERÁVITS OU DÉFICITS DO EXERCÍCIO DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.5.02.00.00.00.0000','SUPERÁVITS OU DÉFICITS DE EXERCÍCIOS ANTERIORES','REGISTRA OS SUPERÁVITS OU DÉFICITS ACUMULADOS DE EXERCÍCIOS ANTERIORES DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.5.03.00.00.00.0000','AJUSTES DE EXERCÍCIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANÇA DE CRITERIO CONTABIL OU DA RETIFICAÇÃO DE ERRO IMPUTAVEL A DETERMINADO EXERCÍCIO ANTERIOR, E QUE NÃO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES. SERAO REGISTRADOS NESTA CONTA OS AJUSTES DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.1.5.04.00.00.00.0000','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSAO E CISAO','REGISTRA O RESULTADO APURADO POR EXTINÇÃO, CISAO OU FUSAO DE UNIDADE DA ADMINISTRAÇÃO DIRETA, AUTARQUIAS, FUNDAÇÕES E FUNDOS, OCORRIDA DURANTE O EXERCÍCIO.','X','S','P','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.0.00.00.00.00.0000','LUCROS E PREJUÍZOS ACUMULADOS','COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUÍZOS LIQUIDOS DAS EMPRESAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.1.00.00.00.00.0000','LUCROS E PREJUÍZOS ACUMULADOS - CONSOLIDAÇÃO','COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUÍZOS LIQUIDOS DAS EMPRESAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.1.01.00.00.00.0000','LUCROS E PREJUÍZOS DO EXERCÍCIO','REGISTRA O SALDO DOS LUCROS OU PREJUÍZOS LIQUIDOS DAS EMPRESAS NO EXERCÍCIO.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.1.02.00.00.00.0000','LUCROS/PREJUÍZOS ACUMULADOS ANTERIORES','REGISTRA O SALDO DOS LUCROS OU PREJUÍZOS ACUMULADOS NOS EXERCÍCIOS ANTERIORES DAS EMPRESAS DE EXERCÍCIOS ANTERIORES.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.1.03.00.00.00.0000','AJUSTES DE EXERCÍCIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANÇA DE CRITERIO CONTABIL OU DA RETIFICAÇÃO DE ERRO IMPUTAVEL A DETERMINADO EXERCÍCIO ANTERIOR, E QUE NÃO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.1.04.00.00.00.0000','LUCROS A DESTINAR DO EXERCÍCIO','REGISTRA O VALOR DOS LUCROS DO EXERCÍCIO PENDENTES DE DESTINAÇÃO, ATE A APROVAÇÃO DA PROPOSTA PELA ASSEMBLEIA GERAL.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.1.05.00.00.00.0000','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','REGISTRA O VALOR DOS LUCROS DE EXERCÍCIOS ANTERIORES PENDENTES DE DESTINAÇÃO, ATE A APROVAÇÃO DA PROPOSTA PELA ASSEMBLEIA GERAL.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.1.06.00.00.00.0000','RESULTADOS APURADOS POR EXTINÇÃO, FUSAO E CISAO','COMPREENDE O RESULTADO APURADO POR EXTINÇÃO, CISAO OU FUSAO DE EMPRESAS DURANTE O EXERCÍCIO.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.2.00.00.00.00.0000','LUCROS E PREJUÍZOS ACUMULADOS - INTRA OFSS','COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUÍZOS LIQUIDOS DAS EMPRESAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.2.01.00.00.00.0000','LUCROS E PREJUÍZOS DO EXERCÍCIO','REGISTRA O SALDO DOS LUCROS OU PREJUÍZOS LIQUIDOS DAS EMPRESAS NO EXERCÍCIO.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.2.02.00.00.00.0000','LUCROS/PREJUÍZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','COMPREENDE O SALDO DOS LUCROS E PREJUÍZOS ACUMULADOS NOS EXERCÍCIOS ANTERIORES DAS EMPRESAS E OS AJUSTES DE EXERCÍCIOS ANTERIORES.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.2.03.00.00.00.0000','AJUSTES DE EXERCÍCIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANÇA DE CRITERIO CONTABIL OU DA RETIFICAÇÃO DE ERRO IMPUTAVEL A DETERMINADO EXERCÍCIO ANTERIOR, E QUE NÃO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.2.04.00.00.00.0000','LUCROS A DESTINAR DO EXERCÍCIO','REGISTRA O VALOR DOS LUCROS DO EXERCÍCIO PENDENTES DE DESTINAÇÃO, ATE A APROVAÇÃO DA PROPOSTA PELA ASSEMBLEIA GERAL.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.2.05.00.00.00.0000','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','REGISTRA O VALOR DOS LUCROS DE EXERCÍCIOS ANTERIORES PENDENTES DE DESTINAÇÃO, ATE A APROVAÇÃO DA PROPOSTA PELA ASSEMBLEIA GERAL.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.2.06.00.00.00.0000','RESULTADOS APURADOS POR EXTINÇÃO, FUSAO E CISAO','REGISTRA O RESULTADO APURADO POR EXTINÇÃO, CISAO OU FUSAO DE EMPRESAS DURANTE O EXERCÍCIO.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.3.00.00.00.00.0000','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - UNIÃO','COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUÍZOS LIQUIDOS DAS EMPRESAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.3.01.00.00.00.0000','LUCROS E PREJUÍZOS DO EXERCÍCIO','REGISTRA O SALDO DOS LUCROS OU PREJUÍZOS LIQUIDOS DAS EMPRESAS NO EXERCÍCIO.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.3.02.00.00.00.0000','LUCROS/PREJUÍZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','COMPREENDE O SALDO DOS LUCROS E PREJUÍZOS ACUMULADOS NOS EXERCÍCIOS ANTERIORES DAS EMPRESAS E OS AJUSTES DE EXERCÍCIOS ANTERIORES.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.3.03.00.00.00.0000','AJUSTES DE EXERCÍCIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANÇA DE CRITERIO CONTABIL OU DA RETIFICAÇÃO DE ERRO IMPUTAVEL A DETERMINADO EXERCÍCIO ANTERIOR, E QUE NÃO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.3.04.00.00.00.0000','LUCROS A DESTINAR DO EXERCÍCIO','REGISTRA O VALOR DOS LUCROS DO EXERCÍCIO PENDENTES DE DESTINAÇÃO, ATE A APROVAÇÃO DA PROPOSTA PELA ASSEMBLEIA GERAL.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.3.05.00.00.00.0000','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','REGISTRA O VALOR DOS LUCROS DE EXERCÍCIOS ANTERIORES PENDENTES DE DESTINAÇÃO, ATE A APROVAÇÃO DA PROPOSTA PELA ASSEMBLEIA GERAL.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.3.06.00.00.00.0000','RESULTADOS APURADOS POR EXTINÇÃO, FUSAO E CISAO','COMPREENDE O RESULTADO APURADO POR EXTINÇÃO, CISAO OU FUSAO DE EMPRESAS DURANTE O EXERCÍCIO.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.4.00.00.00.00.0000','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - ESTADO','COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUÍZOS LIQUIDOS DAS EMPRESAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.4.01.00.00.00.0000','LUCROS E PREJUÍZOS DO EXERCÍCIO','REGISTRA O SALDO DOS LUCROS OU PREJUÍZOS LIQUIDOS DAS EMPRESAS NO EXERCÍCIO.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.4.02.00.00.00.0000','LUCROS/PREJUÍZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','COMPREENDE O SALDO DOS LUCROS E PREJUÍZOS ACUMULADOS NOS EXERCÍCIOS ANTERIORES DAS EMPRESAS E OS AJUSTES DE EXERCÍCIOS ANTERIORES.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.4.03.00.00.00.0000','AJUSTES DE EXERCÍCIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANÇA DE CRITERIO CONTABIL OU DA RETIFICAÇÃO DE ERRO IMPUTAVEL A DETERMINADO EXERCÍCIO ANTERIOR, E QUE NÃO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.4.04.00.00.00.0000','LUCROS A DESTINAR DO EXERCÍCIO','REGISTRA O VALOR DOS LUCROS DO EXERCÍCIO PENDENTES DE DESTINAÇÃO, ATE A APROVAÇÃO DA PROPOSTA PELA ASSEMBLEIA GERAL.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.4.05.00.00.00.0000','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','REGISTRA O VALOR DOS LUCROS DE EXERCÍCIOS ANTERIORES PENDENTES DE DESTINAÇÃO, ATE A APROVAÇÃO DA PROPOSTA PELA ASSEMBLEIA GERAL.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.4.06.00.00.00.0000','RESULTADOS APURADOS POR EXTINÇÃO, FUSAO E CISAO','COMPREENDE O RESULTADO APURADO POR EXTINÇÃO, CISAO OU FUSAO DE EMPRESAS DURANTE O EXERCÍCIO.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.5.00.00.00.00.0000','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - MUNICÍPIO','COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUÍZOS LIQUIDOS DAS EMPRESAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.5.01.00.00.00.0000','LUCROS E PREJUÍZOS DO EXERCÍCIO','REGISTRA O SALDO DOS LUCROS OU PREJUÍZOS LIQUIDOS DAS EMPRESAS NO EXERCÍCIO.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.5.02.00.00.00.0000','LUCROS/PREJUÍZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','COMPREENDE O SALDO DOS LUCROS E PREJUÍZOS ACUMULADOS NOS EXERCÍCIOS ANTERIORES DAS EMPRESAS E OS AJUSTES DE EXERCÍCIOS ANTERIORES.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.5.03.00.00.00.0000','AJUSTES DE EXERCÍCIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANÇA DE CRITERIO CONTABIL OU DA RETIFICAÇÃO DE ERRO IMPUTAVEL A DETERMINADO EXERCÍCIO ANTERIOR, E QUE NÃO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.5.04.00.00.00.0000','LUCROS A DESTINAR DO EXERCÍCIO','REGISTRA O VALOR DOS LUCROS DO EXERCÍCIO PENDENTES DE DESTINAÇÃO, ATE A APROVAÇÃO DA PROPOSTA PELA ASSEMBLEIA GERAL.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.5.05.00.00.00.0000','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','REGISTRA O VALOR DOS LUCROS DE EXERCÍCIOS ANTERIORES PENDENTES DE DESTINAÇÃO, ATE A APROVAÇÃO DA PROPOSTA PELA ASSEMBLEIA GERAL.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.7.2.5.06.00.00.00.0000','RESULTADOS APURADOS POR EXTINÇÃO, FUSAO E CISAO','COMPREENDE O RESULTADO APURADO POR EXTINÇÃO, CISAO OU FUSAO DE EMPRESAS DURANTE O EXERCÍCIO.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.9.0.0.00.00.00.00.0000','(-) AÇÕES / COTAS EM TESOURARIA','COMPREENDE O VALOR DAS AÇÕES OU COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.9.1.0.00.00.00.00.0000','(-) AÇÕES EM TESOURARIA','COMPREENDE O VALOR DAS AÇÕES DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.9.1.1.00.00.00.00.0000','(-) AÇÕES EM TESOURARIA - CONSOLIDAÇÃO','REGISTRA O VALOR DAS AÇÕES DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.9.1.2.00.00.00.00.0000','(-) AÇÕES EM TESOURARIA - INTRA OFSS','REGISTRA O VALOR DAS AÇÕES DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.9.1.3.00.00.00.00.0000','(-) AÇÕES EM TESOURARIA - INTER OFSS - UNIÃO','REGISTRA O VALOR DAS AÇÕES DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.9.1.4.00.00.00.00.0000','(-) AÇÕES EM TESOURARIA - INTER OFSS - ESTADO','REGISTRA O VALOR DAS AÇÕES DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESATDO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.9.1.5.00.00.00.00.0000','(-) AÇÕES EM TESOURARIA - INTER OFSS - MUNICÍPIO','REGISTRA O VALOR DAS AÇÕES DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.9.2.0.00.00.00.00.0000','(-) COTAS EM TESOURARIA','COMPREENDE O VALOR DAS COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.9.2.1.00.00.00.00.0000','(-) COTAS EM TESOURARIA - CONSOLIDAÇÃO','REGISTRA O VALOR DAS COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.9.2.2.00.00.00.00.0000','(-) COTAS EM TESOURARIA - INTRA OFSS','REGISTRA O VALOR DAS COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.9.2.3.00.00.00.00.0000','(-) COTAS EM TESOURARIA - INTER OFSS - UNIÃO','REGISTRA O VALOR DAS COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.9.2.4.00.00.00.00.0000','(-) COTAS EM TESOURARIA - INTER OFSS - ESTADO','REGISTRA O VALOR DAS COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '2.3.9.2.5.00.00.00.00.0000','(-) COTAS EM TESOURARIA - INTER OFSS - MUNICÍPIO','REGISTRA O VALOR DAS COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.0.0.0.0.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA','COMPREENDE O DECRESCIMO NO BENEFICIO ECONOMICO DURANTE O PERIODO CONTABIL SOB A FORMA DE SAIDA DE RECURSO OU REDUÇÃO DE ATIVO OU INCREMENTO EM PASSIVO, QUE RESULTE EM DECRESCIMO DO PATRIMONIO LIQUIDO E QUE NÃO SEJA PROVENIENTE DE DISTRIBUICAO AOS PROPRIETARIOS DA ENTIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.0.0.0.00.00.00.00.0000','PESSOAL E ENCARGOS','COMPREENDE A REMUNERAÇÃO DO PESSOAL ATIVO CIVIL OU MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SUBSÍDIOS, VENCIMENTOS, SOLDOS E VANTAGENS PECUNIÁRIAS FIXAS OU VARIÁVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCÍCIO DO CARGO, EMPREGO OU FUNÇÃO DE CONFIANÇA NO SETOR PÚBLICO. COMPREENDE AINDA, OBRIGAÇÕES TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS ÓRGÃOS E DEMAIS ENTIDADES DO SETOR PÚBLICO, CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA E BENEFÍCIOS EVENTUAIS A PESSOAL CIVIL E MILITAR , DESTACADOS OS CUSTOS DE PESSOAL E ENCARGOS INERENTES AS MERCADORIAS E PRODUTOS VENDIDOS E SERVIÇOS PRESTADOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.0.0.00.00.00.00.0000','REMUNERAÇÃO A PESSOAL','COMPREENDE A REMUNERAÇÃO DO PESSOAL ATIVO CIVIL OU MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SUBSÍDIOS, VENCIMENTOS, SOLDOS E VANTAGENS PECUNIÁRIAS FIXAS E VARIÁVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCÍCIO DO CARGO, EMPREGO OU FUNÇÃO DE CONFIANÇA NO SETOR PÚBLICO, BEM COMO AS COM CONTRATOS DE TERCEIRIZAÇÃO DE MÃO-DE-OBRA QUE SE REFIRAM À SUBSTITUIÇÃO DE SERVIDORES E EMPREGADOS PÚBLICOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.0.00.00.00.00.0000','REMUNERAÇÃO A PESSOAL ATIVO CIVIL- ABRANGIDOS PELO RPPS','COMPREENDE A REMUNERAÇÃO DO PESSOAL ATIVO CIVIL ABRANGIDOS PELO RPPS, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SUBSÍDIOS, VENCIMENTOS E VANTAGENS PECUNIÁRIAS FIXAS E VARIÁVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCÍCIO DO CARGO OU FUNÇÃO DE CONFIANÇA NO SETOR PÚBLICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.00.00.00.00.0000','REMUNERAÇÃO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO RPPS - CONSOLIDAÇÃO','COMPREENDE A REMUNERAÇÃO DO PESSOAL ATIVO CIVIL ABRANGIDOS PELO RPPS, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SUBSÍDIOS, VENCIMENTOS E VANTAGENS PECUNIÁRIAS FIXAS E VARIÁVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCÍCIO DO CARGO OU FUNÇÃO DE CONFIANÇA NO SETOR PÚBLICO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.00.00.00.0000','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RPPS','COMPREENDE O SOMATÓRIO DOS VALORES COM VENCIMENTOS E VANTAGENS FIXAS DO PESSOAL CIVIL DO TIPO: GRATIFICAÇÃO, REPRESENTAÇÃO, ADICIONAL INSALUBRIDADE, FERIAS, 13º SALÁRIO, LICENCA-PREMIO, ABONO PECUNIARIO, ADICIONAL NOTURNO, ETC.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.01.00.00.0000','VENCIMENTOS E SALÁRIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VENCIMENTOS E SALÁRIOS DO PESSOAL CIVIL REGIDOS PELO REGIME PROPRIO DE PREVIDENCIA SOCIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.02.00.00.0000','ADICIONAL NOTURNO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM REMUNERAÇÕES A SERVIDORES EM ATIVIDADE NOTURNA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.03.00.00.0000','INCORPORAÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE VENCIMENTOS E VANTAGENS POR INCORPORAÇÕES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.04.00.00.0000','ABONO DE PERMANENCIA','PARA REGISTRAR OS VALORES DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DO ABONO DE PER- MANENCIA, DEVIDO AOS SERVIDORES QUE TENDO COMPLETADO AS EXIGENCIAS PARA APOSENTADORIA VOLUNTARIA, OPTE POR PERMANECER EM ATIVIDADE. (EMENDA CONSTITUCIONAL NR.41 DE 19/12/2003 E ORIENTAÇÃO NORMATIVA DA SECRETARIA DE PREVIDENCIA SOCIAL NR.01 DE 06/01/2004).DE ACORDO COM A MEDIDA PROVISORIA 167, DE 19 DE FEVEREIRO DE 2004.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.05.00.00.0000','ADICIONAL DE PERICULOSIDADE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM REMUNERAÇÃO DE SERVIDORES QUE EXERCEM ATIVIDADES PERIGOSAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.06.00.00.0000','ADICIONAL DE INSALUBRIDADE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM REMUNERAÇÃO DE SERVIDORES EM ATIVIDADE EM LOCAIS INSALUBRES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.07.00.00.0000','ADICIONAL DE ATIVIDADES PENOSAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM REMUNERAÇÃO DE SERVIDORES QUE EXERCEM ATIVIDADES PENOSAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.08.00.00.0000','INCENTIVO Á QUALIFICAÇÃO','REGISTRA O VALOR DA DESPESA COM INCENTIVO Á QUALIFICAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.09.00.00.0000','REMUNERAÇÃO DE PESSOAL EM DISPONIBILIDADE','REGISTRA O VALOR DA DESPESA COM REMUNERAÇÃO DE PESSOAL EM DISPONIBILIDADE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.10.00.00.0000','RETRIBUIÇÃO ADICIONAL VARIÁVEL E PRÓ-LABORE (LEI 7711/88)','REGISTRA O VALOR DA DESPESA COM RETRIBUIÇÃO ADICIONAL VARIÁVEL E PRÓ-LABORE (LEI 7711/88).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.12.00.00.0000','VANTAGEM PECUNIÁRIA INDIVIDUAL','REGISTRA O VALOR DA DESPESA COM VANTAGEM PECUNIÁRIA INDIVIDUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.13.00.00.0000','ABONO PROVISORIO - PESSOAL CIVIL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ABONO PROVISORIO A PESSOAL CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.14.00.00.0000','GRATIFICAÇÃO POR EXERCÍCIO DE CARGOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICAÇÃO POR EXERCÍCIO DE CARGOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.16.00.00.0000','GRATIFICAÇÃO POR EXERCÍCIO DE FUNCOES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICAÇÃO POR EXERCÍCIO DE FUNCOES, DE COORDENAÇÃO OU ENCARGO DE ATIVIDADES ESPECIFICAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.17.00.00.0000','INDENIZAÇÃO E LOCAÇÃO','REGISTRA O VALOR DA DESPESA COM INDENIZAÇÃO E LOCAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.18.00.00.0000','GRATIFICAÇÃO DE TEMPO DE SERVICO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM GRATIFICAÇÕES ADQUIRIDAS EM FUNÇÃO DE CONTAGEM DE TEMPO DE SERVICO, PESSOAL CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.19.00.00.0000','GRATIFICAÇÕES ESPECIAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM GRATIFICAÇÕES DE NATUREZA ESPECIAL CONCEDIDAS EM VIRTUDE DE LEI A PESSOAL CIVIL, TAIS COMO: GRATIFICAÇÃO ESPECIAL DE LOCALIZAÇÃO, ETC.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.21.00.00.0000','FERIAS VENCIDAS E PROPORCIONAIS INDENIZADAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE FERIAS VENCIDAS E PROPORCIONAIS NA RESCISAO DE CONTRATO DE TRABALHO OU EXONERAÇÃO DO SERVIDOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.22.00.00.0000','13º SALÁRIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICAÇÃO DE NATAL (13º SALÁRIO) DO PESSOAL CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.23.00.00.0000','FERIAS - ABONO PECUNIARIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM A CONVERSAO EM ABONO PECUNIARIO DE UM TERCO DO VALOR DA REMUNERAÇÃO DEVIDA AO SERVIDOR NO PERIODO DE FERIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.24.00.00.0000','FERIAS - ABONO CONSTITUCIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DO VALOR DO ABONO CONCEDIDO A TODOS EMPREGADOS E SERVIDORES COMO REMUNERAÇÃO DO PERIODO DE FERIAS ANUAIS - UM TERCO A MAIS DO QUE O SALÁRIO NORMAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.25.00.00.0000','LICENCA-PREMIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCA-PREMIO POR ASSIDUIDADE NO TRABALHO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.26.00.00.0000','LICENCA CAPACITAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCA PARA CAPACITAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.27.00.00.0000','ADIANTAMENTO PECUNIARIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADIANTAMENTO PECUNIARIO DEVIDOS AOS SERVIDORES EM DECORRENCIA DE DETERMINAÇÃO LEGAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.28.00.00.0000','REPRESENTAÇÃO MENSAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM REPRESENTAÇÃO MENSAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.29.00.00.0000','COMPLEMENTAÇÃO SALARIAL','REGISTRA O VALOR DA DESPESA COM COMPLEMENTAÇÃO SALARIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.30.00.00.0000','ADICIONAL – TETO PARLAMENTAR','REGISTRA O VALOR DA DESPESA COM ADICIONAL – TETO PARLAMENTAR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.31.00.00.0000','SUBSÍDIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SUBSÍDIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.32.00.00.0000','REMUNERAÇÃO PELA PARTICIPAÇÃO EM ORGÃOS DE DELIBERAÇÃO COLETIVA','REGISTRA AS REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE REMUNERAÇÃO DE MEMBROS DE ORGÃOS DE DELIBERAÇÃO COLETIVA (CONSELHO CONSULTIVO, CONSELHO DE ADMINISTRAÇÃO, CONSELHO FISCAL OU OUTROS ORGÃOS COLEGIADOS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.32.01.00.0000','REMUNERAÇÃO DOS CONSELHEIROS TUTELARES','REGISTRA AS REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE REMUNERAÇÃO DOS MEMBROS DOS CONSELHOS TUTELARES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.32.02.00.0000','REMUNERAÇÃO DOS INTEGRANTES DAS JARIS','REGISTRA AS REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE REMUNERAÇÃO DOS INTEGRANTES DAS JARIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.33.00.00.0000','VENCIMENTOS E SALÁRIOS PRORROGAÇÃO SALÁRIO MATERNIDADE','REGISTRA O VALOR DA DESPESA COM VENCIMENTOS E SALÁRIOS PRORROGAÇÃO SALÁRIO MATERNIDADE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.35.00.00.0000','FÉRIAS - PAGAMENTO ANTECIPADO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS OCORRIDAS NO PATRIMÔNIO COM DESPESAS DE PESSOAL, REFERENTE A FÉRIAS - PAGAMENTO ANTECIPADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.36.00.00.0000','GRATIFICAÇÃO POR EXERCÍCIO DE CARGO EM COMISSÃO','REGISTRA O VALOR DA DESPESA COM GRATIFICAÇÃO POR EXERCÍCIO DE CARGO EM COMISSÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.01.99.00.00.0000','OUTROS VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RPPS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS DESPESAS FIXAS-PESSOAL CIVIL NÃO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.00.00.00.0000','OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL - RPPS','COMPREENDE O VALOR DAS APROPRIAÇÕES DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL ABRANGIDOS PELO REGIME PROPRIO, RELACIONADAS AS ATIVIDADES DO CARGO OU FUNÇÃO DO SERVIDOR E CUJO PAGAMENTO SO SE REALIZA EM CIRCUSTANCIAS ESPECIAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.01.00.00.0000','SUBSTITUICOES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE SUBSTITUICOES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.02.00.00.0000','ADICIONAL VARIÁVEL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE ADICIONAL VARIÁVEL SUJEITO A INCIDÊNCIA DE TRIBUTOS E CONTRIBUIÇÕES DE ACORDO COM A LEI 10.973/04 - DISTRIBUIÇÃO DE ROYALTIES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.03.00.00.0000','SERVIÇOS EXTRAORDINARIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE SERVIÇOS EXTRAORDINARIOS, TAIS COMO HORA EXTRA E OUTROS DE CARATER EVENTUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.04.00.00.0000','GRATIFICAÇÃO POR EMBARQUE FLUVIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS OCORRIDAS NO PATRIMÔNIO COM DESPESAS DE PESSOAL, REFERENTE A GRATIFICAÇÃO POR EMBARQUE FLUVIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.05.00.00.0000','GRATIFICAÇÃO ELEITORAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS OCORRIDAS NO PATRIMÔNIO COM DESPESAS DE PESSOAL, REFERENTE A GRATIFICAÇÃO ELEITORAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.06.00.00.0000','LICENÇA SEM REMUNERAÇÃO INCENTIVADA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS OCORRIDAS NO PATRIMÔNIO COM DESPESAS DE PESSOAL, REFERENTE A LICENÇA SEM REMUNERAÇÃO INCENTIVADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.07.00.00.0000','ADICIONAL POR PLANTÃO HOSPITALAR','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE ADICIONAL POR PLANTÃO HOSPITALAR - APH DEVIDO AOS SERVIDORES EM EFETIVO EXERCÍCIO DE ATIVIDADES HOSPITALARES, DESEMPENHADAS EM REGIME DE PLANTÃO, NAS ÁREAS INDISPENSÁVEIS AO FUNCIONAMENTO ININTERRUPTO DOS HOSPITAIS CONSTANTES NO ARTIGO 298 DA LEI 12.155, DE 2009, QUE ALTERA A LEI 11.907, DE 02 DE FEVEREIRO DE 2009.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.08.00.00.0000','CONVOCAÇÃO EXTRAORDINARIA LEGISLATIVA','REGISTRA O VALOR DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM CONVOCAÇÕES EXTRAORDINARIAS, OCORRIDAS NO RECESSO LEGISLATIVO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.09.00.00.0000','PARTICIPACAO A EMPREGADOS E ADMINISTRADORES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS OCORRIDAS NO PATRIMÔNIO COM DESPESAS DE PESSOAL, REFERENTE A PARTICIPAÇÃO A EMPREGADOS E ADMINISTRADORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.10.00.00.0000','AUXILIO MORADIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS OCORRIDAS NO PATRIMÔNIO COM DESPESAS DE PESSOAL, REFERENTE A AUXILIO MORADIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.11.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS OCORRIDAS NO PATRIMÔNIO COM INDENIZAÇÕES TRABALHISTAS, REFERENTE A INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.12.00.00.0000','INDENIZ. E RESTIT. DECORR. DE PLANOS DE DEMISSÃO VOLUNTÁRIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS OCORRIDAS NO PATRIMÔNIO COM INDENIZAÇÕES TRABALHISTAS, REFERENTE A INDENIZAÇÕES. E RESTITUIÇÕES. DECORRENTES. DE PLANOS DE DEMISSÃO VOLUNTÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.13.00.00.0000','RESSARCIMENTO DE DESP. DE PESSOAL REQUISITADO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS OCORRIDAS NO PATRIMÔNIO COM RESARCIMENTO DE DESPESAS DE PESSOAL REQUISITADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.99.00.00.0000','OUTRAS VPD VARIAVEIS - PESSOAL CIVIL - RPPS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL NÃO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.99.01.00.0000','AJUDA DE CUSTO','REGISTRA O VALOR COM AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM A AJUDA DE CUSTO PAGA A SERVIDOR QUANDO OCORRER MUDANÇA DE DOMICILIO NO INTERESSE DO SERVIÇO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.99.02.00.0000','REMOCOES','REGISTRA O VALOR COM AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM A REMOCAO PAGA A SERVIDOR QUANDO OCORRER MUDANÇA DE DOMICILIO NO INTERESSE DO SERVIÇO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.02.99.03.00.0000','SESSOES EXTRAORDINARIAS','REGISTRA O VALOR COM ASAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AS SESSOES EXTRAORDINARIAS EFETUADAS DURANTE O PERIODO LEGISLATIVO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.03.00.00.00.0000','SENTENCAS JUDICIAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SENTENCAS JUDICIAIS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.03.01.00.00.0000','PRECATÓRIOS - ATIVO CIVIL','REGISTRA O VALOR TOTAL DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PRECATÓRIOS - ATIVO CIVIL, CONSIGNADAS NO ORÇAMENTO DE PESSOAL, BEM COMO OS ENCARGOS SOCIAIS E OUTRAS DESPESAS VARIAVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.03.02.00.00.0000','SENTENCAS JUDICIAIS DE PEQUENO VALOR','REGISTRAR O VALOR TOTAL DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS EM FUNÇÃO DE PAGAMENTO DE SENTENCAS JUDICIAIS DE PEQUENO VALOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.1.1.03.05.00.00.0000','OUTRAS SENTENCAS JUDICIAIS','REGISTRA O VALOR DAS APROPRIAÇÕES DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SENTENCAS JUDICIARIAS, EM CUMPRIMENTO AO DISPOSTO NO ART. 100 E SEUS PARAGRAFOS DA CONSTITUICAO FEDERAL, BEM COMO OS ENCARGOS SOCIAIS E OUTRAS DESPESAS VARIAVEIS, NÃO CONTEMPLADAS NAS CONTAS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.0.00.00.00.00.0000','REMUNERAÇÃO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO RGPS','COMPREENDE A REMUNERAÇÃO DO PESSOAL ATIVO CIVIL ABRANGIDOS PELO RGPS, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM VENCIMENTOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCÍCIO DO EMPREGO, INCLUSIVE OS OCUPANTES DE CARGOS EM COMISSÃO NÃO INVESTIDOS EM CARGO EFETIVO, NO SETOR PÚBLICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.00.00.00.00.0000','REMUNERAÇÃO A PESSOAL ATIVO CIVIL - RGPS - CONSOLIDAÇÃO','COMPREENDE A REMUNERAÇÃO DO PESSOAL ATIVO CIVIL ABRANGIDOS PELO RGPS, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM VENCIMENTOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCÍCIO DO EMPREGO, INCLUSIVE OS OCUPANTES DE CARGOS EM COMISSÃO NÃO INVESTIDOS EM CARGO EFETIVO, NO SETOR PÚBLICO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.00.00.00.0000','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS','COMPREENDE O SOMATÓRIO DOS VALORES COM VENCIMENTOS E VANTAGENS FIXAS DO PESSOAL CIVIL DO TIPO: GRATIFICAÇÃO, REPRESENTAÇÃO, ADICIONAL INSALUBRIDADE, FERIAS, 13º SALÁRIO, LICENCA-PREMIO, ABONO PECUNIARIO, ADICIONAL NOTURNO, ETC.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.01.00.00.0000','VENCIMENTOS E SALÁRIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VENCIMENTOS E SALÁRIOS DO PESSOAL CIVIL RGPS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.02.00.00.0000','ADICIONAL NOTURNO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM REMUNERAÇÕES A SERVIDORES EM ATIVIDADE NOTURNA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.03.00.00.0000','INCORPORAÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE VENCIMENTOS E VANTAGENS POR INCORPORAÇÕES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.04.00.00.0000','ABONO DE PERMANENCIA','PARA REGISTRAR OS VALORES DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DO ABONO DE PER- MANENCIA, DEVIDO AOS SERVIDORES QUE TENDO COMPLETADO AS EXIGENCIAS PARA APOSENTADORIA VOLUNTARIA, OPTE POR PERMANECER EM ATIVIDADE. (EMENDA CONSTITUCIONAL NR.41 DE 19/12/2003 E ORIENTAÇÃO NORMATIVA DA SECRETARIA DE PREVIDENCIA SOCIAL NR.01 DE 06/01/2004).DE ACORDO COM A MEDIDA PROVISORIA 167, DE 19 DE FEVEREIRO DE 2004.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.05.00.00.0000','ADICIONAL DE PERICULOSIDADE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM REMUNERAÇÃO DE SERVIDORES QUE EXERCEM ATIVIDADES PERIGOSAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.06.00.00.0000','ADICIONAL DE INSALUBRIDADE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM REMUNERAÇÃO DE SERVIDORES EM ATIVIDADE EM LOCAIS INSALUBRES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.07.00.00.0000','REMUNERACAO PARTICIPANTES DE ORGAO DE DELIBERACAO COLETIVA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE REMUNERACAO DE MEMBROS DE ORGAOS DE DELIBERACAO COLETIVA (CONSELHO CONSULTIVO,CONSELHO DE ADMINISTRACAO, CONSELHO FISCAL OU OUTROS ORGAOS COLEGIADOS), OBSERVADO O DISPOSTO NA LEI N. 7733, DE 14/02/89.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.08.00.00.0000','INCENTIVO A QUALIFICACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM INCENTIVO A QUALIFICACAO DE EMPREGADOS QUE POSSUIREM EDUCACAO FORMAL SUPERIOR AO EXIGIDO PELO EMPREGO/CARGO QUE OCUPAM, EM AREAS DE INTERESSE DO ORGAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.09.00.00.0000','ADICIONAL DE TRANSFERÊNCIA - ART. 469/CLT','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE SERVIDORES QUE EXERCEM FORAM TRANSFERIDOS CONFORME ART.469 DA CLT.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.10.00.00.0000','RETR.ADIC.VARIAVEL E PRO-LABORE(LEI 7711/88)','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE RETRIBUICAO ADICIONAL VARIAVEL E PRO-LABORE DE EXITO CONFORME LEI 7.711/88, ARTIGOS TERCEIRO E QUINTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.11.00.00.0000','REMUNERACAO DE DIRETORES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE REMUNERACAO DE DIRETORES DE EMPRESAS PUBLICAS E DE ECONOMIA MISTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.12.00.00.0000','VANTAGEM PECUNIARIA INDIVIDUAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM A VANTAGEM PECUNIARIA INDIVIDUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.13.00.00.0000','ABONO PROVISORIO - PESSOAL CIVIL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ABONO PROVISORIO A PESSOAL CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.14.00.00.0000','GRATIFICAÇÃO POR EXERCÍCIO DE CARGOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICAÇÃO POR EXERCÍCIO DE CARGOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.16.00.00.0000','GRATIFICAÇÃO POR EXERCÍCIO DE FUNCOES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICAÇÃO POR EXERCÍCIO DE FUNCOES, DE COORDENAÇÃO OU ENCARGO DE ATIVIDADES ESPECIFICAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.18.00.00.0000','GRATIFICAÇÃO DE TEMPO DE SERVICO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM GRATIFICAÇÕES ADQUIRIDAS EM FUNÇÃO DE CONTAGEM DE TEMPO DE SERVICO, PESSOAL CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.19.00.00.0000','GRATIFICAÇÕES ESPECIAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM GRATIFICAÇÕES DE NATUREZA ESPECIAL CONCEDIDAS EM VIRTUDE DE LEI A PESSOAL CIVIL, TAIS COMO: GRATIFICAÇÃO ESPECIAL DE LOCALIZAÇÃO, ETC.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.21.00.00.0000','FERIAS VENCIDAS E PROPORCIONAIS INDENIZADAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE FERIAS VENCIDAS E PROPORCIONAIS NA RESCISAO DE CONTRATO DE TRABALHO OU EXONERAÇÃO DO SERVIDOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.22.00.00.0000','13º SALÁRIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICAÇÃO DE NATAL (13º SALÁRIO) DO PESSOAL CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.23.00.00.0000','FERIAS - ABONO PECUNIARIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM A CONVERSAO EM ABONO PECUNIARIO DE UM TERCO DO VALOR DA REMUNERAÇÃO DEVIDA AO SERVIDOR NO PERIODO DE FERIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.24.00.00.0000','FERIAS - ABONO CONSTITUCIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DO VALOR DO ABONO CONCEDIDO A TODOS EMPREGADOS E SERVIDORES COMO REMUNERAÇÃO DO PERIODO DE FERIAS ANUAIS - UM TERCO A MAIS DO QUE O SALÁRIO NORMAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.25.00.00.0000','LICENCA-PREMIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCA-PREMIO POR ASSIDUIDADE NO TRABALHO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.26.00.00.0000','LICENCA CAPACITAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCA PARA CAPACITAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.27.00.00.0000','ADIANTAMENTO PECUNIARIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADIANTAMENTO PECUNIARIO DEVIDOS AOS SERVIDORES EM DECORRENCIA DE DETERMINAÇÃO LEGAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.28.00.00.0000','REPRESENTAÇÃO MENSAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM REPRESENTAÇÃO MENSAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.31.00.00.0000','SUBSÍDIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SUBSÍDIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.32.00.00.0000','REMUNERAÇÃO PELA PARTICIPAÇÃO EM ORGÃOS DE DELIBERAÇÃO COLETIVA','REGISTRA AS REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE REMUNERAÇÃO DE MEMBROS DE ORGÃOS DE DELIBERAÇÃO COLETIVA (CONSELHO CONSULTIVO, CONSELHO DE ADMINISTRAÇÃO, CONSELHO FISCAL OU OUTROS ORGÃOS COLEGIADOS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.32.01.00.0000','REMUNERAÇÃO DOS CONSELHEIROS TUTELARES','REGISTRA AS REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE REMUNERAÇÃO DOS MEMBROS DOS CONSELHOS TUTELARES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.32.02.00.0000','REMUNERAÇÃO DOS INTEGRANTES DAS JARIS','REGISTRA AS REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE REMUNERAÇÃO DOS INTEGRANTES DAS JARIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.01.99.00.00.0000','OUTROS VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RPPS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS DESPESAS FIXAS-PESSOAL CIVIL NÃO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.02.00.00.00.0000','OUTRAS VPD VARIAVEIS - PESSOAL CIVIL - RGPS','COMPREENDE O VALOR DAS APROPRIAÇÕES DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL ABRANGIDOS PELO REGIME GERAL, RELACIONADAS AS ATIVIDADES DO CARGO OU FUNÇÃO DO EMPREGADO E CUJO PAGAMENTO SO SE REALIZA EM CIRCUSTANCIAS ESPECIAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.02.01.00.00.0000','SUBSTITUICOES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE SUBSTITUICOES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.02.02.00.00.0000','ADICIONAL VARIAVEL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE ADICIONAL VARIÁVEL SUJEITO A INCIDÊNCIA DE TRIBUTOS E CONTRIBUIÇÕES DE ACORDO COM A LEI 10.973/04 - DISTRIBUIÇÃO DE ROYALTIES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.02.03.00.00.0000','SERVIÇOS EXTRAORDINARIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE SERVIÇOS EXTRAORDINARIOS, TAIS COMO HORA EXTRA E OUTROS DE CARATER EVENTUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.02.05.00.00.0000','AVISO PREVIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AVISO PRÉVIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.02.06.00.00.0000','PARTICIPACAO A EMPREGADOS E ADMINISTRADORES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS OCORRIDAS NO PATRIMÔNIO COM DESPESAS DE PESSOAL, REFERENTE A PARTICIPAÇÃO A EMPREGADOS E ADMINISTRADORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.02.07.00.00.0000','GRATIFICACAO ELEITORAL (RGPS)','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS OCORRIDAS NO PATRIMÔNIO COM DESPESAS DE PESSOAL, REFERENTE A GRATIFICAÇÃO ELEITORAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.02.08.00.00.0000','CONVOCAÇÃO EXTRAORDINARIA LEGISLATIVA','REGISTRA O VALOR DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM CONVOCAÇÕES EXTRAORDINARIAS, OCORRIDAS NO RECESSO LEGISLATIVO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.02.09.00.00.0000','AUXILIO MORADIA (RGPS)','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS OCORRIDAS NO PATRIMÔNIO COM DESPESAS DE PESSOAL, REFERENTE A AUXILIO MORADIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.02.10.00.00.0000','LICENCA SEM REMUNERACAO INCENTIVADA (RGPS)','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS OCORRIDAS NO PATRIMÔNIO COM DESPESAS DE PESSOAL, REFERENTE A LICENÇA SEM REMUNERAÇÃO INCENTIVADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.02.99.00.00.0000','OUTRAS VPD VARIAVEIS - PESSOAL CIVIL - RPPS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL NÃO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.02.99.01.00.0000','AJUDA DE CUSTO','REGISTRA O VALOR COM AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM A AJUDA DE CUSTO PAGA A SERVIDOR QUANDO OCORRER MUDANÇA DE DOMICILIO NO INTERESSE DO SERVIÇO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.02.99.02.00.0000','REMOCOES','REGISTRA O VALOR COM AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM A REMOCAO PAGA A SERVIDOR QUANDO OCORRER MUDANÇA DE DOMICILIO NO INTERESSE DO SERVIÇO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.02.99.03.00.0000','SESSOES EXTRAORDINARIAS','REGISTRA O VALOR COM AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AS SESSOES EXTRAORDINARIAS EFETUADAS DURANTE O PERIODO LEGISLATIVO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.03.00.00.00.0000','SENTENCAS JUDICIAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SENTENCAS JUDICIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.00.00.00.0000','CONTRATAÇÃO POR TEMPO DETERMINADO','COMPREENDE O VALOR DAS APROPRIAÇÕES DE VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM A CONTRATAÇÃO DE PESSOAL POR TEMPO DETERMINADO PARA ATENDER A NECESSIDADE TEMPORARIA DE EXCEPCIONAL INTERESSE PÚBLICO, DE ACORDO COM LEGISLAÇÃO ESPECIFICA DE CADA ENTE DA FEDERAÇÃO, INCLUSIVE OBRIGAÇÕES PATRONAIS E OUTRAS DESPESAS VARIAVEIS, QUAND0 FOR O CASO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.01.00.00.0000','PROFESSORES SUBSTITUTOS/ VISITANTES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM CONTRATAÇÃO DE PROFESSORES VISITANTES, SUBSTITUTOS OU PARTICIPANTES DE BANCA EXAMINADORA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.02.00.00.0000','ADICIONAL NOTURNO DE CONTRATO TEMPORARIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADICONAL NOTURNO POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.03.00.00.0000','ADICIONAL DE PERICULOSIDADE CONTR. TEMPORARIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL DE PERICULOSIDADE POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.04.00.00.0000',' ADICIONAL DE INSALUBRIDADE CONTRATO TEMPORARIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL DE INSALUBRIDADE POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.05.00.00.0000','ADICIONAL DE ATIVIDADES PENOSAS - CONTR. TEMPORARIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL DE ATIVIDADES PENOSAS CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.06.00.00.0000','SERVICOS EVENTUAIS DE MEDICOS RESIDENTES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SERVIÇOS EVENTUAIS DE MÉDICOS RESIDENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.07.00.00.0000',' RESIDENCIA MULTIPROFISSIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM RESIDÊNCIA MULTIPROFISSIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.08.00.00.0000','ADICIONAL DE IRRADIACAO IONIZANTE CONT. TEMP.','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL DE IRRADIAÇÃO IONIZANTE POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.09.00.00.0000','GRATIFICACAO DE RAIO-X CONTRATO TEMPORARIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM GRATIFICAÇÃO DE RAIO-X POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.10.00.00.0000','SERVICOS EXTRAORDINARIOS CONTRATO TEMPORARIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SERVIÇOS EXTRAORDINÁRIOS POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.11.00.00.0000','SERVICOS EXTRAORDINARIOS NOTURNO CONT. TEMP.','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SERVIÇOS EXTRAORDINÁRIOS NOTURNOS POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.12.00.00.0000','FERIAS VENCIDAS/PROPORCIONAIS CONT.TEMPORARIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM FÉRIAS VENCIDAS OU PROPORCIONAIS POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.13.00.00.0000','13º SALARIO CONTRATO TEMPORARIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM 13º SALÁRIO POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.14.00.00.0000','FERIAS - ABONO CONSTITUCIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL DE FÉRIAS POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.15.00.00.0000','FERIAS - PAGAMENTO ANTECIPADO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO ANTECIPADO DE FÉRIAS POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.16.00.00.0000','SERVICOS EVENTUAIS DE AUXILIARES CIVIS NO EXT','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SERVIÇOS EVENTUAIS DE AUXILIARES CIVIS NO EXTERIOR POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.17.00.00.0000','SERVICOS EVENTUAIS DE PROFESSORES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SERVIÇOS EVENTUAIS DE PROFESSORES POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.18.00.00.0000','SERVICOS EVENTUAIS DE ASSISTENCIA SOCIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SERVIÇOS EVENTUAIS DE ASSISTÊNCIA SOCIAL POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.19.00.00.0000','SERV EVENT ENFERMAG FISIOT TERAPIA OCUPAC','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SERVIÇOS EVENTUAIS DE ENFERMAGEM E FISIOTERAPIA OCUPACIONAL POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.20.00.00.0000','SERVICOS EVENTUAIS DE NATUREZA INDUSTRIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SERVIÇOS EVENTUAIS DE NATUREZA INDUSTRIAL POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.21.00.00.0000','SERVICOS EVENTUAIS DE AGENTES DE SAUDE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SERVIÇOS EVENTUAIS DE AGENTES DE SAÚDE POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.22.00.00.0000','SERVICOS EVENTUAIS DE DENTISTAS E PSICOLOGOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SERVIÇOS EVENTUAIS DE DENTISTAS E PSICÓLOGOS POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.23.00.00.0000','SERVICOS EVENTUAIS DE MAO-DE-OBRA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SERVIÇOS EVENTUAIS DE MÃO DE OBRA POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.24.00.00.0000','OBRIGACOES PATRONAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM OBRIGAÇÕES PATRONAIS POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.26.00.00.0000','SERVIÇOS TEMPORÁRIOS DE AGENTES PRISIONAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SALÁRIOS DE AGENTES PRISIONAIS POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.28.00.00.0000','INSS PATRONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM INSS PATRONAL POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.29.00.00.0000','FGTS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM FGTS POR CONTRATAÇÃO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.99.00.00.0000','OUTRAS VANTAGENS CONTRATOS TEMPORARIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PAGAMENTO DE OUTRAS VANTAGENS DE PESSOAL DE CONTRATO TEMPORARIOS, TAIS COMO: GRATIFICAÇÃO NATALINA, FERIAS, ADICIONAL NOTURNO, ADICIONAL INSALUBRIDADE, ADICIONAL DE PERICULOSIDADE, ADICIONAL PARA SERVIÇOS EXTRAORDINARIOS, ETC.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.2.1.04.99.01.00.0000','CONTRATAÇÃO POR TEMPO DETERMINADO DE PROFISSIONAIS DA SAUDE','REGISTRA O VALOR DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PROFISSIONAIS DA SAUDE CONTRATADOS POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.0.00.00.00.00.0000','REMUNERAÇÃO A PESSOAL ATIVO MILITAR - ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES','COMPREENDE A REMUNERAÇÃO DO PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SOLDOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCÍCIO DO CARGO OU FUNÇÃO DE CONFIANCA NO SETOR PÚBLICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.00.00.00.00.0000','REMUNERAÇÃO A PESSOAL ATIVO MILITAR - ABRANGIDOS PELO REGIME PRÓPRIO DOS MILITARES - CONSOLIDAÇÃO','COMPREENDE A REMUNERAÇÃO DO PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SOLDOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCÍCIO DO CARGO OU FUNÇÃO DE CONFIANCA NO SETOR PÚBLICO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.00.00.00.0000','VENCIMENTOS E VANTAGENS FIXAS - PES. MILITAR','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM VENCIMENTOS E VANTAGENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.01.00.00.0000','SOLDO','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SOLDO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.02.00.00.0000','ADICIONAL DE PERMANENCIA','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL DE PERMANÊNCIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.03.00.00.0000','ADICIONAL DE TEMPO DE SERVICO','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL POR TEMPO DE SERVIÇO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.04.00.00.0000','ADICIONAL MILITAR','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL MILITAR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.05.00.00.0000','ADICIONAL DE COMPENSACAO ORGÂNICA','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL DE COMPENSAÇÃO ORGÂNICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.06.00.00.0000','ADICIONAL DE HABITACAO','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL DE HABITAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.07.00.00.0000','GRATIFICACAO DE LOCALIDADE ESPECIAL','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM LOCALIDADE ESPECIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.08.00.00.0000','GRATIFICACAO DE REPRESENTACAO','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM GRATIFICAÇÃO DE REPRESENTAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.09.00.00.0000','GRATIFICACAO DE FUNCAO DE NATUREZA ESPECIAL','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM GRATIFICAÇÃO DE FUNÇÃO DE NATUREZA ESPECIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.10.00.00.0000','GRATIFICACAO DE SERVICO VOLUNTARIO','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM GRATIFICAÇÃO DE SERVIÇO VOLUNTÁRIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.11.00.00.0000','VANTAGEM PECUNIARIA ESPECIAL - VPE','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM VANTAGEM PECUNIÁRIA ESPECIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.12.00.00.0000','INDENIZACAO DE REPRESENTACAO','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM INDENIZAÇÃO DE REPRESENTAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.13.00.00.0000','GRATIFICACAO DE EXERCICIOS DE CARGOS','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM GRATIFICAÇÃO DE EXERCÍCIOS DE CARGOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.14.00.00.0000','FERIAS VENCIDAS E PROPORCIONAIS','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM FÉRIAS VENCIDAS E PROPORCIONAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.15.00.00.0000','ADICIONAL NATALINO','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL NATALINO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.16.00.00.0000','FERIAS - ABONO CONSTITUCIONAL','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL DE FÉRIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.17.00.00.0000','COMPLEMENTACAO SALARIAL - PESSOAL MILITAR','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM COMPLEMENTAÇÃO SALARIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.01.99.00.00.0000','OUTRAS VPD FIXAS - PESSOAL MILITAR','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FIXAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.02.00.00.00.0000','OUTRAS DESPESAS VARIAVEIS - PESSOAL MILITAR','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS VARIÁVEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.02.01.00.00.0000','INDENIZACOES/MILITAR','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM INDENIZAÇÕES NÃO ESPECIFICADAS EM OUTROS ITENS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.02.02.00.00.0000','ADICIONAL TAREFA TEMPO CERTO(ART. 23 MP 2131)','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL POR TAREFA POR TEMPO CERTO (ART. 23 DA MP 2131).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.02.03.00.00.0000','ADICIONAL NOTURNO - MILITAR','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL NOTURNO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.02.04.00.00.0000','HORA-EXTRA, HORAS DE SOBREAVISO E PLANTÃO - MILITAR','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM HORA EXTRA, HORAS DE SOBREAVISO E PLANTÕES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.1.3.1.03.00.00.00.0000','SENTENCAS JUDICIAIS','REGISTRA A REMUNERAÇÃO DE PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SENTENÇAS JUDICIAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.0.0.00.00.00.00.0000','ENCARGOS PATRONAIS','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS SERVIDORES E EMPREGADOS ATIVOS, PERTENCENTES AOS ORGÃOS E DEMAIS ENTIDADES DO SETOR PÚBLICO, BEM COMO CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDENCIA E AINDA OUTRAS CONTRIBUIÇÕES PATRONAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.1.0.00.00.00.00.0000','ENCARGOS PATRONAIS - RPPS','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS SERVIDORES PÚBLICOS ATIVOS, PERTENCENTES AOS ORGÃOS E DEMAIS ENTIDADES DO SETOR PÚBLICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.1.2.00.00.00.00.0000','ENCARGOS PATRONAIS - RPPS - INTRA OFSS','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS SERVIDORES PÚBLICOS ATIVOS, PERTENCENTES AOS ORGÃOS E DEMAIS ENTIDADES DO SETOR PÚBLICO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.1.2.01.00.00.00.0000','CONTRIBUICAO PATRONAL PARA O RPPS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE CONTRIBUIÇÕES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.1.2.01.01.00.00.0000','CONTRIBUIÇÕES PATRONAIS PARA O RPPS - ATIVO CIVIL','REPRESENTA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS EXECUTADAS PELO ENTE AO REGIME PROPRIO DE PREVIDENCIA SOCIAL - RPPS, RELATIVOS A CONTRIBUICAO PATRONAL DOS SERVIDORES EFETIVOS DAS ENTIDADES MUNICIPAIS EM EXERCÍCIO DO CARGO - ATIVO CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.1.2.01.04.00.00.0000','CONTRIBUIÇÕES PATRONAIS PARA O RPPS - VEREADORES','REPRESENTA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS EXECUTADAS PELO ENTE AO REGIME PROPRIO DE PREVIDENCIA SOCIAL - RPPS, RELATIVOS A CONTRIBUICAO PATRONAL DOS VEREADORES QUE SEJAM SERVIDORES EFETIVOS DO MUNICÍPIO E ESTEJAM NO EXERCÍCIO DO MANDATO LEGISLATIVO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.1.2.02.00.00.00.0000','ENCARGOS DE PESSOAL REQUISIT. DE OUTROS ENTES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.1.2.06.00.00.00.0000','CONTRIBUIÇÃO PARA O PASEP SOBRE FOLHA DE PAGAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM A CONTRIBUIÇÃO PARA O PASEP SOBRE FOLHA DE PAGAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.1.2.99.00.00.00.0000','OUTROS ENCARGOS PATRONAIS - RPPS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS OBRIGAÇÕES PATRONAIS AO RPPS, NÃO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.1.2.99.01.00.00.0000','AMORTIZAÇÃO DO PASSIVO ATUARIAL COM O RPPS - ALÍQUOTA SUPLEMENTAR','REGISTRA O VALOR DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM A AMORTIZAÇÃO MENSAL DO PASSIVO ATUARIAL COM O RPPS FEITA SOB A FORMA DE AMORTIZAÇÃO DO PASSIVO ATUARIAL COM O RPPS - ALÍQUOTA SUPLEMENTAR','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.0.00.00.00.00.0000','ENCARGOS PATRONAIS - RGPS','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS EMPREGADOS ATIVOS, PERTENCENTES AOS ORGÃOS E DEMAIS ENTIDADES DO SETOR PÚBLICO, BEM COMO OCUPANTES DE CARGO EM COMISSÃO NÃO INVESTIDO EM CARGO EFETIVO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.1.00.00.00.00.0000','ENCARGOS PATRONAIS - RGPS - CONSOLIDAÇÃO','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS EMPREGADOS ATIVOS, PERTENCENTES AOS ORGÃOS E DEMAIS ENTIDADES DO SETOR PÚBLICO, BEM COMO OCUPANTES DE CARGO EM COMISSÃO NÃO INVESTIDO EM CARGO EFETIVO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.1.01.00.00.00.0000','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS - INSS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGÃOS, FUNDOS OU ENTIDADES QUE NÃO PERTENÇAM AOS ORÇAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUIÇÕES PREVIDÊNCIÁRIAS AO INSS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.1.04.00.00.00.0000','ENCARGOS DE PESSOAL REQUISIT. DE OUTROS ENTES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.1.05.00.00.00.0000','CONTRIBUIÇÃO PREVIDENCIÁRIA INSS PRORROGAÇÃO SALÁRIO MATERNIDADE','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ÓRGÃOS, FUNDOS OU ENTIDADES QUE NÃO PERTENÇAM AOS ORÇAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUIÇÕES PREVIDENCIÁRIAS AO INSS REFERENTE A PRORROGAÇÃO DO SALÁRIO MATERNIDADE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.1.06.00.00.00.0000','CONTRIBUIÇÃO PARA O PIS SOBRE FOLHA DE PAGAMENTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TÍTULO DE CONTRIBUIÇÃO PARA O PIS, DETERMINADA COM BASE NA FOLHA DE PAGAMENTO, A ALÍQUOTA DE 1%, PELAS FUNDAÇÕES PÚBLICAS INSTITUÍDAS OU MANTIDAS PELO PODER PÚBLICO (MP 2.158-35/2001).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.1.99.00.00.00.0000','OUTROS ENCARGOS PATRONAIS - RGPS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS OBRIGAÇÕES PATRONAIS AO RGPS, NÃO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRAÇÃO DE BALANCETES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.2.00.00.00.00.0000','ENCARGOS PATRONAIS - RGPS - INTRA OFSS','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS EMPREGADOS ATIVOS, PERTENCENTES AOS ORGÃOS E DEMAIS ENTIDADES DO SETOR PÚBLICO, BEM COMO OCUPANTES DE CARGO EM COMISSÃO NÃO INVESTIDO EM CARGO EFETIVO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.3.00.00.00.00.0000','ENCARGOS PATRONAIS - RGPS - INTER OFSS - UNIÃO','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS EMPREGADOS ATIVOS, PERTENCENTES AOS ORGÃOS E DEMAIS ENTIDADES DO SETOR PÚBLICO, BEM COMO OCUPANTES DE CARGO EM COMISSÃO NÃO INVESTIDO EM CARGO EFETIVO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.3.01.00.00.00.0000','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS - INSS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGÃOS, FUNDOS OU ENTIDADES QUE NÃO PERTENÇAM AOS ORÇAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUIÇÕES PREVIDÊNCIÁRIAS AO INSS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.3.01.01.00.00.0000','INSS - SERVIDORES','REGISTRA OS VALORES DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OBRIGAÇÕES RELATIVAS AO RECOLHIMENTO DO INSS DOS SERVIDORES ATIVOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.3.01.02.00.00.0000','INSS - AGENTES POLITICOS','REGISTRA OS VALORES DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OBRIGAÇÕES RELATIVAS AO RECOLHIMENTO DO INSS - DOS AGENTES POLITICOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.3.01.03.00.00.0000','INSS SOBRE SESSAO EXTRAORDINARIA - AGENTES POLITICOS','REGISTRA OS VALORES DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OBRIGAÇÕES RELATIVAS AO RECOLHIMENTO DO INSS SOBRE SESSAO EXTRAORDINARIA - AGENTES POLITICOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.3.01.04.00.00.0000','INSS SOBRE CONVOCAÇÃO EXTRAORDINARIA - AGENTES POLITICOS','REGISTRA OS VALORES DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OBRIGAÇÕES RELATIVAS AO RECOLHIMENTO DO INSS SOBRE CONVOCAÇÃO EXTRAORDINARIA - AGENTES POLITICOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.3.03.00.00.00.0000','SEGURO DE ACIDENTE NO TRABALHO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS RELATIVAS A CONTRIBUIÇÕES PREVIDENCIÁRIAS DE SEGURO DE ACIDENTES DO TRABALHO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.3.04.00.00.00.0000','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.3.05.00.00.00.0000','CONTRIBUIÇÃO PREVIDENCIÁRIA INSS PRORROGAÇÃO SALÁRIO MATERNIDADE','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ÓRGÃOS, FUNDOS OU ENTIDADES QUE NÃO PERTENÇAM AOS ORÇAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUIÇÕES PREVIDENCIÁRIAS AO INSS REFERENTE A PRORROGAÇÃO DO SALÁRIO MATERNIDADE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.3.06.00.00.00.0000','CONTRIBUIÇÃO PARA O PIS SOBRE FOLHA DE PAGAMENTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUIÇÃO PARA O PIS, DETERMINADA COM BASE NA FOLHA DE PAGAMENTO, A ALÍQUOTA DE 1%, PELAS FUNDAÇÕES PÚBLICAS INSTITUÍDAS OU MANTIDAS PELO PODER PÚBLICO (MP 2.158-35/2001).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.3.99.00.00.00.0000','OUTROS ENCARGOS PATRONAIS - RGPS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS OBRIGAÇÕES PATRONAIS AO RGPS, NÃO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRAÇÃO DE BALANCETES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.3.99.01.00.00.0000','OBRIGAÇÕES PATRONAIS DE PESSOAL CONTRATADO POR TEMPO DETERMINADO','REGISTRA O VALOR DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE OBRIGAÇÕES PATRONAIS RELATIVAS A PESSOAL CONTRATADO POR TEMPO DETERMINADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.4.00.00.00.00.0000','ENCARGOS PATRONAIS - RGPS - INTER OFSS - ESTADO','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS EMPREGADOS ATIVOS, PERTENCENTES AOS ORGÃOS E DEMAIS ENTIDADES DO SETOR PÚBLICO, BEM COMO OCUPANTES DE CARGO EM COMISSÃO NÃO INVESTIDO EM CARGO EFETIVO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.2.5.00.00.00.00.0000','ENCARGOS PATRONAIS - RGPS - INTER OFSS - MUNICÍPIO','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS EMPREGADOS ATIVOS, PERTENCENTES AOS ORGÃOS E DEMAIS ENTIDADES DO SETOR PÚBLICO, BEM COMO OCUPANTES DE CARGO EM COMISSÃO NÃO INVESTIDO EM CARGO EFETIVO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.3.0.00.00.00.00.0000','ENCARGOS PATRONAIS - FGTS','COMPREENDE OS VALORES RECOLHIDOS MENSALMENTE PELOS EMPREGADORES, EM CONTA BANCÁRIA VINCULADA DO TRABALHADOR NO FGTS, CORRESPONDENTE A PERCENTUAL DEFINIDO EM LEI SOBRE A REMUNERAÇÃO PAGA OU DEVIDA, NO MES ANTERIOR, A CADA TRABALHADOR, INCLUIDAS NA REMUNERAÇÃO AS PARCELAS DE QUE TRATAM OS ARTS. 457 E 458 DA CLT E A GRATIFICAÇÃO DE NATAL A QUE SE REFERE A LEI Nº 4.090, DE 13 DE JULHO DE 1962, COM AS MODIFICAÇÕES DA LEI Nº 4.749, DE 12 DE AGOSTO DE 1965. ENTENDE-SE POR EMPREGADOR A PESSOA FISICA OU A PESSOA JURIDICA DE DIREITO PRIVADO OU DE DIREITO PÚBLICO, DA ADMINISTRAÇÃO PÚBLICA DIRETA, INDIRETA OU FUNDACIONAL DE QUALQUER DOS PODERES, DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS, QUE ADMITIR TRABALHADORES A SEU SERVICO, BEM ASSIM AQUELE QUE, REGIDO POR LEGISLAÇÃO ESPECIAL, ENCONTRAR-SE NESSA CONDICAO OU FIGURAR COMO FORNECEDOR OU TOMADOR DE MAO-DE-OBRA, INDEPENDENTE DA RESPONSABILIDADE SOLIDARIA E/OU SUBSIDIARIA A QUE EVENTUALMENTE VENHA OBRIGAR-SE. CONSIDERA-SE TRABALHADOR TODA PESSOA FISICA QUE PRESTAR SERVIÇOS A EMPREGADOR, A LOCADOR OU TOMADOR DE MAO-DE-OBRA, EXCLUIDOS OS EVENTUAIS, OS AUTONOMOS E OS SERVIDORES PÚBLICOS CIVIS E MILITARES SUJEITOS A REGIME JURIDICO PROPRIO. O RECOLHIMENTO DO FGTS E OBRIGATORIO TAMBÉM NOS CASOS DE AFASTAMENTO PARA PRESTAÇÃO DO SERVICO MILITAR OBRIGATORIO E LICENCA POR ACIDENTE DO TRABALHO. NÃO SE INCLUEM NA REMUNERAÇÃO, PARA OS FINS DESTA LEI, AS PARCELAS ELENCADAS NO § 9º DO ART. 28 DA LEI Nº 8.212, DE 24 DE JULHO DE 1991.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.3.1.00.00.00.00.0000','ENCARGOS PATRONAIS - FGTS - CONSOLIDAÇÃO','COMPREENDE OS VALORES RECOLHIDOS MENSALMENTE PELOS EMPREGADORES, EM CONTA BANCÁRIA VINCULADA DO TRABALHADOR NO FGTS, CORRESPONDENTE A PERCENTUAL DEFINIDO EM LEI SOBRE A REMUNERAÇÃO PAGA OU DEVIDA, NO MES ANTERIOR, A CADA TRABALHADOR, INCLUIDAS NA REMUNERAÇÃO AS PARCELAS DE QUE TRATAM OS ARTS. 457 E 458 DA CLT E A GRATIFICAÇÃO DE NATAL A QUE SE REFERE A LEI Nº 4.090, DE 13 DE JULHO DE 1962, COM AS MODIFICAÇÕES DA LEI Nº 4.749, DE 12 DE AGOSTO DE 1965. ENTENDE-SE POR EMPREGADOR A PESSOA FISICA OU A PESSOA JURIDICA DE DIREITO PRIVADO OU DE DIREITO PÚBLICO, DA ADMINISTRAÇÃO PÚBLICA DIRETA, INDIRETA OU FUNDACIONAL DE QUALQUER DOS PODERES, DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS, QUE ADMITIR TRABALHADORES A SEU SERVICO, BEM ASSIM AQUELE QUE, REGIDO POR LEGISLAÇÃO ESPECIAL, ENCONTRAR-SE NESSA CONDICAO OU FIGURAR COMO FORNECEDOR OU TOMADOR DE MAO-DE-OBRA, INDEPENDENTE DA RESPONSABILIDADE SOLIDARIA E/OU SUBSIDIARIA A QUE EVENTUALMENTE VENHA OBRIGAR-SE. CONSIDERA-SE TRABALHADOR TODA PESSOA FISICA QUE PRESTAR SERVIÇOS A EMPREGADOR, A LOCADOR OU TOMADOR DE MAO-DE-OBRA, EXCLUIDOS OS EVENTUAIS, OS AUTONOMOS E OS SERVIDORES PÚBLICOS CIVIS E MILITARES SUJEITOS A REGIME JURIDICO PROPRIO. O RECOLHIMENTO DO FGTS E OBRIGATORIO TAMBÉM NOS CASOS DE AFASTAMENTO PARA PRESTAÇÃO DO SERVICO MILITAR OBRIGATORIO E LICENCA POR ACIDENTE DO TRABALHO. NÃO SE INCLUEM NA REMUNERAÇÃO, PARA OS FINS DESTA LEI, AS PARCELAS ELENCADAS NO § 9º DO ART. 28 DA LEI Nº 8.212, DE 24 DE JULHO DE 1991. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NÃO PERTENÇA AO OFSS DE ENTE PÚBLICO, ALÉM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.3.1.01.00.00.00.0000','FGTS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OBRIGAÇÕES RELATIVAS AO RECOLHIMENTO DO FGTS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.3.1.02.00.00.00.0000','FGTS - PDV','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM FGTS DE SERVIDORES QUE OPTARAM PELO PLANO DE DEMISSÃO VOLUNTÁRIA - PDV.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.3.1.03.00.00.00.0000','FGTS - PRORROGAÇÃO SALÁRIO MATERNIDADE','REGISTRA OS VALORES DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OBRIGAÇÕES RELATIVAS AO RECOLHIMENTO DO FGTS REFERENTE A PRORROGAÇÃO DO SALÁRIO MATERNIDADE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.4.0.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS GERAIS','COMPREENDE OS ENCARGOS PATRONAIS RELATIVAS AO SALÁRIO EDUCAÇÃO E AS CONTRIBUIÇÕES COMPULSORIAS DOS EMPREGADORES SOBRE A FOLHA DE SALÁRIOS, DESTINADOS AS ENTIDADES PRIVADAS DE SERVICO SOCIAL E DE FORMAÇÃO PROFISSIONAL, VINCULADAS AO SISTEMA SINDICAL, TAIS COMO SESI, SENAI, SESC E SENAC.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.4.1.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS GERAIS - CONSOLIDAÇÃO','COMPREENDE OS ENCARGOS PATRONAIS RELATIVAS AO SALÁRIO EDUCAÇÃO E AS CONTRIBUIÇÕES COMPULSORIAS DOS EMPREGADORES SOBRE A FOLHA DE SALÁRIOS, DESTINADOS AS ENTIDADES PRIVADAS DE SERVICO SOCIAL E DE FORMAÇÃO PROFISSIONAL, VINCULADAS AO SISTEMA SINDICAL, TAIS COMO SESI, SENAI, SESC E SENAC. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.4.1.01.00.00.00.0000','SISTEMAS SOCIAIS AUTÔNOMOS - ATIVO CIVIL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM CONTRIBUIÇÕES PATRONAIS PARA OS SISTEMAS SOCIAIS AUTÔNOMOS, COMO SESI/SENAI, REFERENTE A PESSOAL ATIVO CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.4.1.02.00.00.00.0000','CONTRIBUIÇÃO DE SALÁRIO EDUCAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUIÇÃO DE SALÁRIO-EDUCAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.4.1.03.00.00.00.0000','CONTRIBUIÇÃO DE SALÁRIO EDUCAÇÃO REFERENTE A PRORROGAÇÃO DE SALÁRIO MATERNIDADE','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUIÇÃO DE SALÁRIO-EDUCAÇÃO REFERENTE A PRORROGAÇÃO DO SALÁRIO MATERNIDADE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.4.1.99.00.00.00.0000','OUTRAS CONTRIBUIÇÕES SOCIAIS GERAIS','REGISTRA AS OUTRAS CONTRIBUIÇÕES SOCIAIS GERAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.5.0.00.00.00.00.0000','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDENCIA','COMPREENDE O VALOR TOTAL DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELACIONADAS AO REGIME DE PREVIDENCIA PRIVADA, DE CARATER COMPLEMENTAR, ORGANIZADO DE FORMA AUTONOMA EM RELAÇÃO AO REGIME GERAL DE PREVIDENCIA SOCIAL, DE CARATER FACULTATIVO, BASEADO NA CONSTITUICAO DE RESERVAS QUE GARANTAM O BENEFICIO, NOS TERMOS DO CAPUT DO ART. 202 DA CONSTITUICAO FEDERAL. ENTENDE-SE POR ENTIDADES FECHADAS AQUELAS ACESSIVEIS, NA FORMA REGULAMENTADA PELO ORGÃO REGULADOR E FISCALIZADOR, EXCLUSIVAMENTE AOS EMPREGADOS DE UMA EMPRESA OU GRUPO DE EMPRESAS E AOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS, ENTES DENOMINADOS PATROCINADORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.5.1.00.00.00.00.0000','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA - CONSOLIDAÇÃO','COMPREENDE O VALOR TOTAL DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELACIONADAS AO REGIME DE PREVIDENCIA PRIVADA, DE CARATER COMPLEMENTAR, ORGANIZADO DE FORMA AUTONOMA EM RELAÇÃO AO REGIME GERAL DE PREVIDENCIA SOCIAL, DE CARATER FACULTATIVO, BASEADO NA CONSTITUICAO DE RESERVAS QUE GARANTAM O BENEFICIO, NOS TERMOS DO CAPUT DO ART. 202 DA CONSTITUICAO FEDERAL. ENTENDE-SE POR ENTIDADES FECHADAS AQUELAS ACESSIVEIS, NA FORMA REGULAMENTADA PELO ORGÃO REGULADOR E FISCALIZADOR, EXCLUSIVAMENTE AOS EMPREGADOS DE UMA EMPRESA OU GRUPO DE EMPRESAS E AOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS, ENTES DENOMINADOS PATROCINADORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.5.1.01.00.00.00.0000','COMPLEMENTAÇÃO DE PREVIDENCIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUIÇÕES DE RESPONSABILIDADE DAS ENTIDADES PATROCINADORAS PARA ATENDER PLANO DE PREVIDENCIA COMPLEMENTAR, ADMINISTRADO POR SUAS INSTITUICOES DE SEGURIDADE SOCIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.5.1.02.00.00.00.0000','SEGUROS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUIÇÕES A ENTIDADES DE PREVIDÊNCIA FECHADA, SOB A MODALIDADE DE SEGUROS, TAIS COMO: SEGURO DE VIDA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.5.1.03.00.00.00.0000','CONTRIBUIÇÃO PATRONAL PREVIDENCIA PRIVADA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUICAO PATRONAL, DEVIDA A ENTIDADES DE PREVIDENCIA PRIVADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.5.1.04.00.00.00.0000',' COMPLEMENTAÇÃO PREVIDENCIÁRIA REFERENTE A PRORROGAÇÃO SALÁRIO MATERNIDADE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUIÇÕES DE RESPONSABILIDADE DAS ENTIDADES PATROCINADORAS P/ ATENDER PLANO DE PREVIDÊNCIA COMPLEMENTAR, ADMINISTRADO POR SUAS INSTITUIÇÕES DE SEGURIDADE SOCIAL REFERENTE A PRORROGAÇÃO DO SALÁRIO MATERNIDADE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.5.1.99.00.00.00.0000','OUTRAS CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDENCIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUIÇÕES A ENTIDADES PRIVADAS NÃO ENQUADRADAS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.0.00.00.00.00.0000','OUTROS ENCARGOS PATRONAIS','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADOS AOS ENCARGOS PATRONAIS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.1.00.00.00.00.0000','OUTROS ENCARGOS PATRONAIS - CONSOLIDAÇÃO','REGISTRA OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADOS AOS ENCARGOS PATRONAIS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.1.01.00.00.00.0000','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS EXECUTADAS A TITULO DE CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO, AS ENTIDADES DA ADMINISTRAÇÃO INDIRETA E AS UNIDADES ORÇAMENTÁRIAS, CONSTANTES DO ORÇAMENTO INTEGRADO DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.1.02.00.00.00.0000','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS EXECUTADAS A TITULO DE CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO, AS ENTIDADES DA ADMINISTRAÇÃO INDIRETA E AS UNIDADES ORÇAMENTÁRIAS, CONSTANTES DO ORÇAMENTO INTEGRADO DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.1.03.00.00.00.0000','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS EXECUTADAS A TITULO DE CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO, AS ENTIDADES DA ADMINISTRAÇÃO INDIRETA E AS UNIDADES ORÇAMENTÁRIAS, CONSTANTES DO ORÇAMENTO INTEGRADO DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.1.04.00.00.00.0000','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS EXECUTADAS A TITULO DE CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO, AS ENTIDADES DA ADMINISTRAÇÃO INDIRETA E AS UNIDADES ORÇAMENTÁRIAS, CONSTANTES DO ORÇAMENTO INTEGRADO DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.1.05.00.00.00.0000','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS EXECUTADAS A TITULO DE CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA, AS ENTIDADES DA ADMINISTRAÇÃO INDIRETA E AS UNIDADES ORÇAMENTÁRIAS, CONSTANTES DO ORÇAMENTO INTEGRADO DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.1.06.00.00.00.0000','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO PENSIONISTA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS EXECUTADAS A TITULO DE CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A ASSISTÊNCIA SOCIAL DO PENSIONISTA, AS ENTIDADES DA ADMINISTRAÇÃO INDIRETA E AS UNIDADES ORÇAMENTÁRIAS, CONSTANTES DO ORÇAMENTO INTEGRADO DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.2.00.00.00.00.0000','OUTROS ENCARGOS PATRONAIS - INTRA OFSS','REGISTRA OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADOS AOS ENCARGOS PATRONAIS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.2.01.00.00.00.0000','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS EXECUTADAS A TITULO DE CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO, AS ENTIDADES DA ADMINISTRAÇÃO INDIRETA E AS UNIDADES ORÇAMENTÁRIAS, CONSTANTES DO ORÇAMENTO INTEGRADO DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.2.02.00.00.00.0000','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS EXECUTADAS A TITULO DE CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO, AS ENTIDADES DA ADMINISTRAÇÃO INDIRETA E AS UNIDADES ORÇAMENTÁRIAS, CONSTANTES DO ORÇAMENTO INTEGRADO DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.2.03.00.00.00.0000','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS EXECUTADAS A TITULO DE CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO, AS ENTIDADES DA ADMINISTRAÇÃO INDIRETA E AS UNIDADES ORÇAMENTÁRIAS, CONSTANTES DO ORÇAMENTO INTEGRADO DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.2.04.00.00.00.0000','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS EXECUTADAS A TITULO DE CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO, AS ENTIDADES DA ADMINISTRAÇÃO INDIRETA E AS UNIDADES ORÇAMENTÁRIAS, CONSTANTES DO ORÇAMENTO INTEGRADO DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.2.05.00.00.00.0000','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS EXECUTADAS A TITULO DE CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA, AS ENTIDADES DA ADMINISTRAÇÃO INDIRETA E AS UNIDADES ORÇAMENTÁRIAS, CONSTANTES DO ORÇAMENTO INTEGRADO DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.2.06.00.00.00.0000','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO PENSIONISTA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS EXECUTADAS A TITULO DE CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A ASSISTÊNCIA SOCIAL DO PENSIONISTA, AS ENTIDADES DA ADMINISTRAÇÃO INDIRETA E AS UNIDADES ORÇAMENTÁRIAS, CONSTANTES DO ORÇAMENTO INTEGRADO DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.3.00.00.00.00.0000','OUTROS ENCARGOS PATRONAIS - INTER OFSS - UNIÃO','REGISTRA OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADOS AOS ENCARGOS PATRONAIS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.4.00.00.00.00.0000','OUTROS ENCARGOS PATRONAIS - INTER OFSS - ESTADO','REGISTRA OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADOS AOS ENCARGOS PATRONAIS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.2.9.5.00.00.00.00.0000','OUTROS ENCARGOS PATRONAIS - INTER OFSS - MUNICÍPIO','REGISTRA OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADOS AOS ENCARGOS PATRONAIS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.0.0.00.00.00.00.0000','BENEFÍCIOS A PESSOAL','COMPREENDE O VALOR TOTAL DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM BENEFÍCIOS DEVIDOS A PESSOAL CIVIL E MILITAR , TAIS COMO PARA O PESSOAL CIVIL: AJUDA-DE-CUSTO, INDENIZAÇÃO DE TRANSPORTE, AUXÍLIO-MORADIA, AUXILIA-ALIMENTAÇÃO, AUXILIA-TRANSPORTE BEM COMO OUTROS DECORRENTES DE ACORDO OU CONVENÇÃO COLETIVA NO QUE SE REFERE AOS EMPREGADOS PÚBLICOS. PARA OS MILITARES: ADICIONAL DE COMPENSAÇÃO ORGÂNICA NÃO INCORPORADA, GRATIFICAÇÃO DE LOCALIDADE ESPECIAL, GRATIFICAÇÃO DE REPRESENTAÇÃO, TRANSPORTE, AJUDA–DE-CUSTO, AUXÍLIO-FARDAMENTO, AUXÍLIO-ALIMENTAÇÃO E OUTROS BENEFÍCIOS EVENTUAIS RELATIVOS AO LOCAL OU A NATUREZA DO TRABALHO. ESTÃO EXCLUÍDAS DESTE GRUPO AS DESPESAS COM VENCIMENTOS, SOLDOS E QUAISQUER OUTRAS VANTAGENS PECUNIÁRIAS, BEM COMO AS DESPESAS RELACIONADAS AOS BENEFÍCIOS PREVIDENCIÁRIOS OU ASSISTÊNCIAIS, TAIS COMO: APOSENTADORIA, AUXÍLIO-NATALIDADE, SALÁRIO-FAMÍLIA, LICENÇA PARA TRATAMENTO DE SAÚDE, LICENÇA A GESTANTE, A ADOTANTE E LICENÇA-MATERNIDADE, LICENÇA POR ACIDENTE EM SERVIÇO, ASSISTÊNCIA A SAÚDE, GARANTIA DE CONDIÇÕES INDIVIDUAIS E AMBIENTAIS DE TRABALHO SATISFATÓRIAS, PENSÃO VITALÍCIA E TEMPORÁRIA, AUXÍLIO-FUNERAL, AUXÍLIO-RECLUSÃO, AUXÍLIO-INVALIDEZ, ASSISTÊNCIA A SAÚDE. ESTÃO EXCLUÍDAS AINDA AS INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS DECORRENTES DA PERDA DA CONDIÇÃO DE SERVIDOR OU EMPREGADO, TAIS COMO FERIAS, AVISO PRÉVIO INDENIZADOS E OUTRAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.1.0.00.00.00.00.0000','BENEFÍCIOS A PESSOAL - RPPS','COMPREENDE O VALOR TOTAL DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM BENEFÍCIOS A SERVIDOR PÚBLICO, TAIS COMO: AJUDA-DE-CUSTO, INDENIZAÇÃO DE TRANSPORTE, AUXÍLIO-MORADIA, AUXÍLIO-TRANSPORTE,AUXÍLIO-ALIMENTAÇÃO E OUTROS BENEFÍCIOS RELATIVOS AO LOCAL OU A NATUREZA DO TRABALHO. ESTÃO EXCLUÍDAS DESTE GRUPO OS VENCIMENTOS E QUAISQUER OUTRAS VANTAGENS PECUNIÁRIAS PERMANENTES, BEM COMO OS BENEFÍCIOS PREVIDENCIÁRIOS OU ASSISTÊNCIAIS, TAIS COMO: APOSENTADORIA, AUXÍLIO-NATALIDADE, SALÁRIO-FAMÍLIA, LICENÇA PARA TRATAMENTO DE SAÚDE, LICENÇA A GESTANTE, A ADOTANTE E LICENÇA-MATERNIDADE, LICENÇA POR ACIDENTE EM SERVIÇO, ASSISTÊNCIA A SAÚDE, PENSÃO VITALÍCIA E TEMPORÁRIA, AUXÍLIO-FUNERAL, AUXÍLIO-RECLUSÃO, AUXÍLIO-INVALIDEZ, ASSISTÊNCIA A SAÚDE. ESTÃO EXCLUÍDAS AINDA AS INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS DECORRENTES DA PERDA DA CONDIÇÃO DE SERVIDOR OU EMPREGADO, TAIS COMO FERIAS, AVISO PRÉVIO INDENIZADOS E OUTRAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.1.1.00.00.00.00.0000','BENEFÍCIOS A PESSOAL - RPPS - CONSOLIDAÇÃO','COMPREENDE O VALOR TOTAL DAS V VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM BENEFÍCIOS A SERVIDOR PÚBLICO, TAIS COMO: AJUDA-DE-CUSTO, INDENIZAÇÃO DE TRANSPORTE, AUXÍLIO-MORADIA, AUXÍLIO-TRANSPORTE,AUXÍLIO-ALIMENTAÇÃO E OUTROS BENEFÍCIOS RELATIVOS AO LOCAL OU A NATUREZA DO TRABALHO. ESTÃO EXCLUÍDAS DESTE GRUPO OS VENCIMENTOS E QUAISQUER OUTRAS VANTAGENS PECUNIÁRIAS PERMANENTES, BEM COMO OS BENEFÍCIOS PREVIDENCIÁRIOS OU ASSISTÊNCIAIS, TAIS COMO: APOSENTADORIA, AUXÍLIO-NATALIDADE, SALÁRIO-FAMÍLIA, LICENÇA PARA TRATAMENTO DE SAÚDE, LICENÇA A GESTANTE, A ADOTANTE E LICENÇA-MATERNIDADE, LICENÇA POR ACIDENTE EM SERVIÇO, ASSISTÊNCIA A SAÚDE, PENSÃO VITALÍCIA E TEMPORÁRIA, AUXÍLIO-FUNERAL, AUXÍLIO-RECLUSÃO, AUXÍLIO-INVALIDEZ, ASSISTÊNCIA A SAÚDE. ESTÃO EXCLUÍDAS AINDA AS INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS DECORRENTES DA PERDA DA CONDIÇÃO DE SERVIDOR OU EMPREGADO, TAIS COMO FERIAS, AVISO PRÉVIO INDENIZADOS E OUTRAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.1.1.01.00.00.00.0000','AUXÍLIO ALIMENTAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM AUXÍLIO-ALIMENTAÇÃO PAGO/FORNECIDO AOS SERVIDORES OU EMPREGADOS DA ADMINISTRAÇÃO PÚBLICA DIRETA E INDIRETA., EM PECUNIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.1.1.02.00.00.00.0000','AUXÍLIO TRANSPORTE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO-TRANSPORTE PAGAS EM FORMA DE PECUNIA DIRETAMENTE AOS SERVIDORES, DESTINADO AO CUSTEIO PARCIAL DAS DESPESAS REALIZADAS COM TRANSPORTE COLETIVO MUNICIPAL INTERMUNICIPAL OU INTERESTADUAL NOS DESLOCAMENTOS DE SUAS RESIDENCIAS PARA OS LOCAIS DE TRABALHO E VICE-VERSA, OU TRABALHO-TRABALHO NOS CASOS DE ACUMULAÇÃO LICITA DE CARGOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.1.1.04.00.00.00.0000','AJUDA DE CUSTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AJUDA DE CUSTO DE PESSOAL CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.1.1.05.00.00.00.0000','PLANO DE SAUDE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PLANO DE SAUDE AO SERVIDOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.1.1.06.00.00.00.0000','AUXÍLIO CRECHE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO-CRECHE, DEVIDO A SERVIDOR PÚBLICO, DECORRENTE DE RESSARCIMENTO DE GASTOS COM A EDUCAÇÃO PRE-ESCOLAR DE SEUS DEPENDENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.1.1.99.00.00.00.0000','OUTROS BENEFÍCIOS A PESSOAL - RPPS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTROS BENEFÍCIOS A PESSOAL - RPPS, NÃO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.2.0.00.00.00.00.0000','BENEFÍCIOS A PESSOAL - RGPS','COMPREENDE O VALOR TOTAL DAS VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BENEFÍCIOS DEVIDOS AOS EMPREGADOS PÚBLICOS, E AINDA OUTROS RELATIVOS A ACORDO OU CONVENÇÃO COLETIVA. ESTÃO EXCLUÍDAS DESTE GRUPO OS VENCIMENTOS E QUAISQUER OUTRAS VANTAGENS PECUNIÁRIAS , BEM COMO OS BENEFÍCIOS PREVIDENCIÁRIOS OU ASSISTÊNCIAIS, TAIS COMO: APOSENTADORIA, AUXÍLIO-NATALIDADE, SALÁRIO-FAMÍLIA, LICENÇA PARA TRATAMENTO DE SAÚDE, LICENÇA A GESTANTE, A ADOTANTE E LICENÇA-MATERNIDADE, LICENÇA POR ACIDENTE EM SERVIÇO, ASSISTÊNCIA A SAÚDE, GARANTIA DE CONDIÇÕES INDIVIDUAIS E AMBIENTAIS DE TRABALHO SATISFATÓRIAS, PENSÃO VITALÍCIA E TEMPORÁRIA, AUXÍLIO-FUNERAL, AUXÍLIO-RECLUSÃO, AUXÍLIO-INVALIDEZ, ASSISTÊNCIA A SAÚDE. ESTÃO EXCLUÍDAS AINDA AS INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS DECORRENTES DA PERDA DA CONDIÇÃO DE SERVIDOR OU EMPREGADO, TAIS COMO FERIAS, AVISO PRÉVIO INDENIZADOS E OUTRAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.2.1.00.00.00.00.0000','BENEFÍCIOS A PESSOAL - RGPS - CONSOLIDAÇÃO','COMPREENDE O VALOR TOTAL DAS VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BENEFÍCIOS DEVIDOS AOS EMPREGADOS PÚBLICOS, E AINDA OUTROS RELATIVOS A ACORDO OU CONVENÇÃO COLETIVA. ESTÃO EXCLUÍDAS DESTE GRUPO OS VENCIMENTOS E QUAISQUER OUTRAS VANTAGENS PECUNIÁRIAS , BEM COMO OS BENEFÍCIOS PREVIDENCIÁRIOS OU ASSISTÊNCIAIS, TAIS COMO: APOSENTADORIA, AUXÍLIO-NATALIDADE, SALÁRIO-FAMÍLIA, LICENÇA PARA TRATAMENTO DE SAÚDE, LICENÇA A GESTANTE, A ADOTANTE E LICENÇA-MATERNIDADE, LICENÇA POR ACIDENTE EM SERVIÇO, ASSISTÊNCIA A SAÚDE, GARANTIA DE CONDIÇÕES INDIVIDUAIS E AMBIENTAIS DE TRABALHO SATISFATÓRIAS, PENSÃO VITALÍCIA E TEMPORÁRIA, AUXÍLIO-FUNERAL, AUXÍLIO-RECLUSÃO, AUXÍLIO-INVALIDEZ, ASSISTÊNCIA A SAÚDE. ESTÃO EXCLUÍDAS AINDA AS INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS DECORRENTES DA PERDA DA CONDIÇÃO DE SERVIDOR OU EMPREGADO, TAIS COMO FERIAS, AVISO PRÉVIO INDENIZADOS E OUTRAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.2.1.01.00.00.00.0000','AUXÍLIO ALIMENTAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM AUXÍLIO-ALIMENTAÇÃO PAGO/FORNECIDO AOS SERVIDORES OU EMPREGADOS DA ADMINISTRAÇÃO PÚBLICA DIRETA E INDIRETA., EM PECUNIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.2.1.02.00.00.00.0000','AUXÍLIO TRANSPORTE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO-TRANSPORTE PAGAS EM FORMA DE PECUNIA DIRETAMENTE AOS SERVIDORES, DESTINADO AO CUSTEIO PARCIAL DAS DESPESAS REALIZADAS COM TRANSPORTE COLETIVO MUNICIPAL INTERMUNICIPAL OU INTERESTADUAL NOS DESLOCAMENTOS DE SUAS RESIDENCIAS PARA OS LOCAIS DE TRABALHO E VICE-VERSA, OU TRABALHO-TRABALHO NOS CASOS DE ACUMULAÇÃO LICITA DE CARGOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.2.1.04.00.00.00.0000','AJUDA DE CUSTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AJUDA DE CUSTO DE PESSOAL CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.2.1.05.00.00.00.0000','PLANO DE SAUDE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PLANO DE SAUDE AO SERVIDOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.2.1.06.00.00.00.0000','AUXÍLIO CRECHE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO-CRECHE, DEVIDO A SERVIDOR PÚBLICO, DECORRENTE DE RESSARCIMENTO DE GASTOS COM A EDUCAÇÃO PRE-ESCOLAR DE SEUS DEPENDENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.2.1.99.00.00.00.0000','OUTROS BENEFÍCIOS A PESSOAL - RGPS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTROS BENEFÍCIOS A PESSOAL - RGPS, NÃO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.3.0.00.00.00.00.0000','BENEFÍCIOS A PESSOAL - MILITAR','COMPREENDE O VALOR TOTAL DAS VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BENEFÍCIOS DEVIDOS A PESSOAL MILITAR, TAIS COMO: ADICIONAL DE COMPENSAÇÃO ORGANICA NÃO INCORPORADA, GRATIFICAÇÃO DE LOCALIDADE ESPECIAL, GRATIFICAÇÃO DE REPRESENTAÇÃO, TRANSPORTE, AJUDA–DE-CUSTO, AUXÍLIO-FARDAMENTO, AUXÍLIO-ALIMENTAÇÃO E OUTROS BENEFÍCIOS EVENTUAIS RELATIVOS AO LOCAL OU A NATUREZA DO TRABALHO. ESTAO EXCLUIDAS DESTE GRUPO OS SOLDOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS PERMANENTES, BEM COMO AS OS BENEFÍCIOS PREVIDÊNCIÁRIOS OU ASSISTÊNCIAIS, TAIS COMO: APOSENTADORIA, AUXÍLIO-NATALIDADE, SALÁRIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTÊNCIA A SAUDE, GARANTIA DE CONDICOES INDIVIDUAIS E AMBIENTAIS DE TRABALHO SATISFATORIAS, PENSAO VITALICIA E TEMPORARIA, AUXÍLIO-FUNERAL, AUXÍLIO-RECLUSAO, AUXÍLIO-INVALIDEZ, ASSISTÊNCIA A SAUDE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.3.3.1.00.00.00.00.0000','BENEFÍCIOS A PESSOAL - MILITAR - CONSOLIDAÇÃO','COMPREENDE O VALOR TOTAL DAS VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BENEFÍCIOS DEVIDOS A PESSOAL MILITAR, TAIS COMO: ADICIONAL DE COMPENSAÇÃO ORGANICA NÃO INCORPORADA, GRATIFICAÇÃO DE LOCALIDADE ESPECIAL, GRATIFICAÇÃO DE REPRESENTAÇÃO, TRANSPORTE, AJUDA–DE-CUSTO, AUXÍLIO-FARDAMENTO, AUXÍLIO-ALIMENTAÇÃO E OUTROS BENEFÍCIOS EVENTUAIS RELATIVOS AO LOCAL OU A NATUREZA DO TRABALHO. ESTAO EXCLUIDAS DESTE GRUPO OS SOLDOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS PERMANENTES, BEM COMO AS OS BENEFÍCIOS PREVIDÊNCIÁRIOS OU ASSISTÊNCIAIS, TAIS COMO: APOSENTADORIA, AUXÍLIO-NATALIDADE, SALÁRIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTÊNCIA A SAUDE, GARANTIA DE CONDICOES INDIVIDUAIS E AMBIENTAIS DE TRABALHO SATISFATORIAS, PENSAO VITALICIA E TEMPORARIA, AUXÍLIO-FUNERAL, AUXÍLIO-RECLUSAO, AUXÍLIO-INVALIDEZ, ASSISTÊNCIA A SAUDE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.8.0.0.00.00.00.00.0000','CUSTO DE PESSOAL E ENCARGOS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA A PESSOAL E ENCARGOS UTILIZADOS NA PRODUCAO DE BENS OU SERVIÇOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.8.1.0.00.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – PESSOAL E ENCARGOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.8.1.1.00.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – PESSOAL E ENCARGOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.8.1.1.01.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – PESSOAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL APROPRIADAS AS MERCADORIAS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.8.1.1.02.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – ENCARGOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A ENCARGOS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.8.2.0.00.00.00.00.0000','CUSTO DE PRODUTOS VENDIDOS – PESSOAL E ENCARGOS','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.8.2.1.00.00.00.00.0000','CUSTO DE PRODUTOS VENDIDOS – PESSOAL E ENCARGOS - CONSOLIDAÇÃO','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.8.2.1.01.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – PESSOAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL APROPRIADAS AS MERCADORIAS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.8.2.1.02.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – ENCARGOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A ENCARGOS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.8.3.0.00.00.00.00.0000','CUSTO DE SERVIÇOS PRESTADOS – PESSOAL E ENCARGOS','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE SERVIÇOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.8.3.1.00.00.00.00.0000','CUSTO DE SERVIÇOS PRESTADOS – PESSOAL E ENCARGOS - CONSOLIDAÇÃO','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE SERVIÇOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.8.3.1.01.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – PESSOAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL APROPRIADAS AS MERCADORIAS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.8.3.1.02.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – ENCARGOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A ENCARGOS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.0.0.00.00.00.00.0000','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - PESSOAL E ENCARGOS','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM PESSOAL E ENCARGOS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES, TAIS COMO ASINDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.1.0.00.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS','COMPREENDE O VALOR TOTAL COM VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RESULTANTE DO PAGAMENTO EFETUADO A SERVIDORES PÚBLICOS CIVIS E EMPREGADOS DE ENTIDADES INTEGRANTES DA ADMINISTRAÇÃO PÚBLICA, INCLUSIVE FERIAS E AVISO PREVIO INDENIZADOS, MULTAS E CONTRIBUIÇÕES INCIDENTES SOBRE OS DEPÓSITOS DO FUNDO DE GARANTIA POR TEMPO DE SERVICO, ETC, EM FUNÇÃO DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, PODENDO SER EM DECORRENCIA DA PARTICIPAÇÃO EM PROGRAMA DE DESLIGAMENTO VOLUNTARIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.1.1.00.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS - CONSOLIDAÇÃO','COMPREENDE O VALOR TOTAL COM VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RESULTANTE DO PAGAMENTO EFETUADO A SERVIDORES PÚBLICOS CIVIS E EMPREGADOS DE ENTIDADES INTEGRANTES DA ADMINISTRAÇÃO PÚBLICA, INCLUSIVE FERIAS E AVISO PREVIO INDENIZADOS, MULTAS E CONTRIBUIÇÕES INCIDENTES SOBRE OS DEPÓSITOS DO FUNDO DE GARANTIA POR TEMPO DE SERVICO, ETC, EM FUNÇÃO DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, PODENDO SER EM DECORRENCIA DA PARTICIPAÇÃO EM PROGRAMA DE DESLIGAMENTO VOLUNTARIO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.1.1.01.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS - ATIVO CIVIL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REFERENTE AINDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS DO PESSOAL ATIVO CIVIL, INCLUSIVE AS DESPESAS COM PROGRAMA DE DESLIGAMENTO VOLUNTARIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.1.1.01.01.00.00.0000','INDENIZAÇÃO PARA DEMISSAO DE SERVIDORES/ EMPREGADOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REFERENTE A INDENIZAÇÃO PAGA AOS SERVIDORES QUANDO DA SUA DEMISSÃO. SÃO PARCELAS QUE O SERVIDOR SÓ RECEBE PELO FATO DE ESTAR SAINDO DO SERVIÇO PÚBLICO. EX: MULTA DO FGTS AOS EMPREGADOS, VALORES INDENIZADOS POR ANOS TRABALHADOS, ETC.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.1.1.01.02.00.00.0000','DESPESAS RELATIVAS A PROGRAMAS DE DESLIGAMENTO VOLUNTARIO','AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REFERENTE A CUSTEAR PROGRAMAS DE DESLIGAMENTO VOLUNTÁRIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.1.1.01.03.00.00.0000','FÉRIAS, AVISO PREVIO E/OU 13° SALÁRIO INDENIZADOS','AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REFERENTE AO PAGAMENTO DE FÉRIAS, AVISO PRÉVIO E/OU 13° SALÁRIO INDENIZADO POR OCASIÃO DA DEMISSÃO OU EXONERAÇÃO DE SERVIDOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.1.1.03.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS - INATIVO CIVIL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REFERENTE AINDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS DO PESSOAL INATIVO CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.1.1.06.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS - PENSIONISTA CIVIL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTESDE DESPESAS REFERENTE AINDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS DO PESSOAL PENSIONISTA CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.1.1.99.00.00.00.0000','DIVERSAS INDENIZAÇÕES TRABALHISTAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DEINDENIZAÇÕES TRABALHISTA QUE NÃO SE PROCESSARAM NA EPOCA PROPRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.1.1.99.01.00.00.0000','ENCARGOS SOBRE INDENIZAÇÕES TRABALHISTAS','DESTINADA AOS REGISTROS DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE ENCARGOS SOBREINDENIZAÇÕES TRABALHISTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.2.0.00.00.00.00.0000','PESSOAL REQUISITADO DE OUTROS ORGÃOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM PESSOAL REQUISITADO DE OUTROS ÓRGÃOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.2.1.00.00.00.00.0000','PESSOAL REQUISITADO DE OUTROS ORGÃOS - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM PESSOAL REQUISITADO DE OUTROS ÓRGÃOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.9.0.00.00.00.00.0000','OUTRAS VPD DE PESSOAL E ENCARGOS','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM PESSOAL E ENCARGOS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.9.1.00.00.00.00.0000','OUTRAS VPD DE PESSOAL E ENCARGOS - CONSOLIDAÇÃO','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM PESSOAL E ENCARGOS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.9.1.01.00.00.00.0000','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - PESSOAL','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM PESSOAL, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES, TAIS COMO AS INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.1.9.9.1.02.00.00.00.0000','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - ENCARGOS','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM ENCARGOS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES, TAIS COMO AS INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.0.0.0.00.00.00.00.0000','BENEFÍCIOS PREVIDÊNCIÁRIOS E ASSISTÊNCIAIS','COMPREENDEM AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS AS APOSENTADORIAS, PENSÕES, REFORMAS, RESERVA REMUNERADA E OUTROS BENEFÍCIOS PREVIDÊNCIÁRIOS DE CARATER CONTRIBUTIVO, DO REGIME PROPRIO DA PREVIDENCIA SOCIAL - RPPS E DO REGIME GERAL DA PREVIDENCIA SOCIAL – RGPS, BEM COMO AS AÇÕES DE ASSISTÊNCIA SOCIAL, QUE SAO POLITICAS DE SEGURIDADE SOCIAL NÃO CONTRIBUTIVA, VISANDO AO ENFRENTAMENTO DA POBREZA, A GARANTIA DOS MINIMOS SOCIAIS, AO PROVIMENTO DE CONDICOES PARA ATENDER CONTINGENCIAS SOCIAIS E A UNIVERSALIZAÇÃO DOS DIREITOS SOCIAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.1.0.0.00.00.00.00.0000','APOSENTADORIAS E REFORMAS','COMPREENDEM OS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA ASSEGURADOS PELA PREVIDENCIA SOCIAL COM O OBJETIVO DE GARANTIR MEIOS INDISPENSAVEIS DE MANUTENCAO, POR MOTIVO DE INCAPACIDADE, IDADE AVANCADA E TEMPO DE SERVICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.1.1.0.00.00.00.00.0000','APOSENTADORIAS - RPPS','COMPREENDEM OS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA ASSEGURADOS PELA PREVIDENCIA SOCIAL COM O OBJETIVO DE GARANTIR MEIOS INDISPENSAVEIS DE MANUTENCAO, POR MOTIVO DE INCAPACIDADE, IDADE AVANCADA E TEMPO DE SERVICO, ABRANGIDAS PELO RPPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.1.1.1.00.00.00.00.0000','APOSENTADORIAS - RPPS - CONSOLIDAÇÃO','COMPREENDEM OS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA ASSEGURADOS PELA PREVIDENCIA SOCIAL COM O OBJETIVO DE GARANTIR MEIOS INDISPENSAVEIS DE MANUTENCAO, POR MOTIVO DE INCAPACIDADE, IDADE AVANCADA E TEMPO DE SERVICO, ABRANGIDAS PELO RPPS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.1.1.1.01.00.00.00.0000','PROVENTOS - PESSOAL CIVIL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PROVENTOS DE APOSENTADORIAS PESSOAL CIVIL REGIDOS PELO RPPS APROVADA PELO TRIBUNAL DE CONTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.1.1.1.06.00.00.00.0000','13º SALÁRIO - PESSOAL CIVIL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE 13º SALÁRIO - PESSOAL CIVIL - RPPS - APOSENTADORIAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.1.1.1.99.00.00.00.0000','OUTRAS APOSENTADORIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS APOSENTADORIAS NÃO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.1.2.0.00.00.00.00.0000','APOSENTADORIAS - RGPS','COMPREENDEM OS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA ASSEGURADOS PELA PREVIDENCIA SOCIAL COM O OBJETIVO DE GARANTIR MEIOS INDISPENSAVEIS DE MANUTENCAO, POR MOTIVO DE INCAPACIDADE, IDADE AVANCADA E TEMPO DE SERVICO, ABRANGIDAS PELO RGPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.1.2.1.00.00.00.00.0000','APOSENTADORIAS - RGPS - CONSOLIDAÇÃO','COMPREENDEM OS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA ASSEGURADOS PELA PREVIDENCIA SOCIAL COM O OBJETIVO DE GARANTIR MEIOS INDISPENSAVEIS DE MANUTENCAO, POR MOTIVO DE INCAPACIDADE, IDADE AVANCADA E TEMPO DE SERVICO, ABRANGIDAS PELO RGPS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.1.3.0.00.00.00.00.0000','RESERVA REMUNERADA E REFORMAS - MILITAR','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM RESERVA REMUNERADA E REFORMAS DOS MILITARES','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.1.3.1.00.00.00.00.0000','RESERVA REMUNERADA E REFORMAS - MILITAR - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM RESERVA REMUNERADA E REFORMAS DOS MILITARES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.1.9.0.00.00.00.00.0000','OUTRAS APOSENTADORIAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS APOSENTADORIAS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.1.9.1.00.00.00.00.0000','OUTRAS APOSENTADORIAS - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS APOSENTADORIAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.2.0.0.00.00.00.00.0000','PENSÕES','COMPREENDEM OS BENEFÍCIOS DA PREVIDENCIA SOCIAL QUE GARANTE UMA RENDA AOS DEPENDENTES DO SEGURADO FALECIDO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.2.1.0.00.00.00.00.0000','PENSÕES - RPPS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSÕES AO DEPENDENTES DOS SEGURADOS, APOS SEU OBITO, PELO REGIME PROPRIO DA PREVIDENCIA SOCIAL -RPPS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.2.1.1.00.00.00.00.0000','PENSÕES - RPPS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSÕES AO DEPENDENTES DOS SEGURADOS, APOS SEU OBITO, PELO REGIME PROPRIO DA PREVIDENCIA SOCIAL -RPPS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.2.1.1.01.00.00.00.0000','PENSÕES CIVIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PENSÕES ORIGINARIAS DE PESSOAL CIVIL - RPPS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.2.1.1.02.00.00.00.0000','13º SALÁRIO - PESSOAL CIVIL - PENSIONISTAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE 13º SALÁRIO – PESSOAL MILITAR - PENSIONISTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.2.1.1.99.00.00.00.0000','OUTRAS PENSÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS PENSÕES NÃO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.2.2.0.00.00.00.00.0000','PENSÕES - RGPS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSÕES AO DEPENDENTES DOS SEGURADOS, APOS SEU OBITO, REGIDOS PELO REGIME GERAL DA PREVIDENCIA SOCIAL -RGPS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.2.2.1.00.00.00.00.0000','PENSÕES - RGPS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSÕES AO DEPENDENTES DOS SEGURADOS, APOS SEU OBITO, REGIDOS PELO REGIME GERAL DA PREVIDENCIA SOCIAL -RGPS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.2.3.0.00.00.00.00.0000','PENSÕES - MILITAR','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSÕES AO DEPENDENTES DOS MILITARES, APOS SEU OBITO, REGIDOS PELO REGIME PROPRIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.2.3.1.00.00.00.00.0000','PENSÕES - MILITAR - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSÕES AO DEPENDENTES DOS MILITARES, APOS SEU OBITO, REGIDOS PELO REGIME PROPRIO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.2.9.0.00.00.00.00.0000','OUTRAS PENSÕES','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS PENSÕES','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.2.9.1.00.00.00.00.0000','OUTRAS PENSÕES - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS PENSÕES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.3.0.0.00.00.00.00.0000','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','COMPREENDEM OS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.3.1.0.00.00.00.00.0000','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO','COMPREENDEM OS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO E RENDA MENSAL VITALICIA IDADE','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.3.1.1.00.00.00.00.0000','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO - CONSOLIDAÇÃO','COMPREENDEM OS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA E RENDA MENSAL VITALICIA IDADE . COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.3.1.1.01.00.00.00.0000','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO','REGISTRA O BENEFÍCIO DE PRESTAÇÃO CONTINUADA QUE GARANTE 1 (UM) SALÁRIO MÍNIMO MENSAL AO IDOSO , QUE COMPROVE NÃO POSSUIR MEIOS DE PROVER A PRÓPRIA MANUTENÇÃO E NEM DE TÊ-LA PROVIDA POR SUA FAMÍLIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.3.2.0.00.00.00.00.0000','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIENCIA','COMPREENDEM OS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIENCIA E RENDA MENSAL VITALICIA – INVALIDEZ','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.3.2.1.00.00.00.00.0000','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA - CONSOLIDAÇÃO','COMPREENDEM OS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIENCIA E RENDA MENSAL VITALICIA – INVALIDEZ. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.3.2.1.01.00.00.00.0000','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA','REGISTRA O BENEFICIO DE PRESTAÇÃO CONTINUADA QUE GARANTE 1 (UM) SALÁRIO MÍNIMO MENSAL A PESSOA PORTADORA DE DEFICIÊNCIA, QUE COMPROVE NÃO POSSUIR MEIOS DE PROVER A PRÓPRIA MANUTENÇÃO E NEM DE TÊ-LA PROVIDA POR SUA FAMÍLIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.3.9.0.00.00.00.00.0000','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','COMPREENDEM OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.3.9.1.00.00.00.00.0000','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA - CONSOLIDAÇÃO','REGISTRA OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.4.0.0.00.00.00.00.0000','BENEFÍCIOS EVENTUAIS','COMPREENDEM AS PROVISÕES SUPLEMENTARES E PROVISORIAS, PRESTADAS AOS CIDADAOS E AS FAMILIAS EM VIRTUDE DE NASCIMENTO, MORTE, SITUAÇÕES DE VULNERABILIDADE TEMPORARIA E DE CALAMIDADE PÚBLICA.AS PROVISÕES RELATIVAS A PROGRAMAS, PROJETOS, SERVIÇOS E BENEFÍCIOS DIRETAMENTE VINCULADOS AO CAMPO DA SAUDE, EDUCAÇÃO, INTEGRAÇÃO NACIONAL E DAS DEMAIS POLITICAS SETORIAIS NÃO SE INCLUEM NA MODALIDADE DE BENEFÍCIOS EVENTUAIS DA ASSISTÊNCIA SOCIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.4.1.0.00.00.00.00.0000','AUXÍLIO POR NATALIDADE','COMPREENDE O BENEFICIO EVENTUAL QUE VISA O PAGAMENTO DE AUXÍLIO POR NATALIDADE AS FAMILIAS CUJA RENDA MENSAL PER CAPITA SEJA INFERIOR A 1/4 (UM QUARTO) DO SALÁRIO MINIMO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.4.1.1.00.00.00.00.0000','AUXÍLIO POR NATALIDADE - CONSOLIDAÇÃO','REGISTRA O BENEFICIO EVENTUAL QUE VISA O PAGAMENTO DE AUXÍLIO POR NATALIDADE AS FAMILIAS CUJA RENDA MENSAL PER CAPITA SEJA INFERIOR A 1/4 (UM QUARTO) DO SALÁRIO MINIMO.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.4.2.0.00.00.00.00.0000','AUXÍLIO POR MORTE','COMPREENDE O BENEFICIO EVENTUAL QUE VISA O PAGAMENTO DE AUXÍLIO POR MORTE AS FAMILIAS CUJA RENDA MENSAL PER CAPITA SEJA INFERIOR A 1/4 (UM QUARTO) DO SALÁRIO MINIMO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.4.2.1.00.00.00.00.0000','AUXÍLIO POR MORTE - CONSOLIDAÇÃO','REGISTRA O BENEFICIO EVENTUAL QUE VISA O PAGAMENTO DE AUXÍLIO POR MORTE AS FAMILIAS CUJA RENDA MENSAL PER CAPITA SEJA INFERIOR A 1/4 (UM QUARTO) DO SALÁRIO MINIMO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.4.3.0.00.00.00.00.0000','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORARIA','COMPREENDE AS PROVISÕES SUPLEMENTARES E PROVISORIAS, PRESTADAS AOS CIDADAOS E AS FAMILIAS EM VIRTUDE DE SITUAÇÕES DE VULNERABILIDADE TEMPORARIA, COM PRIORIDADE PARA A CRIANCA, A FAMILIA, O IDOSO, A PESSOA PORTADORA DE DEFICIENCIA, A GESTANTE E A NUTRIZ.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.4.3.1.00.00.00.00.0000','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORARIA - CONSOLIDAÇÃO','REGISTRA AS PROVISÕES SUPLEMENTARES E PROVISORIAS, PRESTADAS AOS CIDADAOS E AS FAMILIAS EM VIRTUDE DE SITUAÇÕES DE VULNERABILIDADE TEMPORARIA, COM PRIORIDADE PARA A CRIANCA, A FAMILIA, O IDOSO, A PESSOA PORTADORA DE DEFICIENCIA, A GESTANTE E A NUTRIZ. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.4.4.0.00.00.00.00.0000','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA','COMPREENDEM OS BENEFÍCIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PÚBLICA, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA. ENTENDE SE POR ESTADO DE CALAMIDADE PÚBLICA O RECONHECIMENTO PELO PODER PÚBLICO DE SITUAÇÃO ANORMAL, ADVINDA DE BAIXAS OU ALTAS TEMPERATURAS, TEMPESTADES, ENCHENTES, INVERSAO TERMICA, DESABAMENTOS, INCENDIOS, EPIDEMIAS, CAUSANDO SERIOS DANOS A COMUNIDADE AFETADA, INCLUSIVE A INCOLUMIDADE OU A VIDA DE SEUS INTEGRANTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.4.4.1.00.00.00.00.0000','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA - CONSOLIDAÇÃO','COMPREENDEM OS BENEFÍCIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PÚBLICA, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA. ENTENDE SE POR ESTADO DE CALAMIDADE PÚBLICA O RECONHECIMENTO PELO PODER PÚBLICO DE SITUAÇÃO ANORMAL, ADVINDA DE BAIXAS OU ALTAS TEMPERATURAS, TEMPESTADES, ENCHENTES, INVERSAO TERMICA, DESABAMENTOS, INCENDIOS, EPIDEMIAS, CAUSANDO SERIOS DANOS A COMUNIDADE AFETADA, INCLUSIVE A INCOLUMIDADE OU A VIDA DE SEUS INTEGRANTES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.4.9.0.00.00.00.00.0000','OUTROS BENEFÍCIOS EVENTUAIS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE OUTROS BENEFÍCIOS EVENTUAIS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.4.9.1.00.00.00.00.0000','OUTROS BENEFÍCIOS EVENTUAIS - CONSOLIDAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE OUTROS BENEFÍCIOS EVENTUAIS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.5.0.0.00.00.00.00.0000','POLITICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA','COMPREENDE AS POLITICAS PÚBLICAS QUE VISEM CONTRIBUIR PARA A REDUÇÃO DA FOME, DA POBREZA, DA DESIGUALDADE E DE OUTRAS FORMAS DE PRIVAÇÃO VIVIDAS PELAS FAMILIAS MAIS EXCLUIDAS, CONSIDERANDO TRES DIMENSOES: O ALIVIO IMEDIATO DA POBREZA, POR MEIO DA TRANSFERÊNCIA DE RENDA DIRETAMENTE AS FAMILIAS POBRES E EXTREMAMENTE POBRES; A CONTRIBUICAO PARA A REDUÇÃO DA POBREZA DA GERAÇÃO SEGUINTE, POR MEIO DO REFORCO DO DIREITO DE ACESSO AOS SERVIÇOS DE SAUDE E DE EDUCAÇÃO, COM O CUMPRIMENTO DAS CONDICIONALIDADES NESTAS AREAS; E A ARTICULAÇÃO DE AÇÕES COMPLEMENTARES, DE FORMA A DESENVOLVER AS CAPACIDADES DAS FAMILIAS BENEFICIARIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.5.0.1.00.00.00.00.0000','POLITICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA - CONSOLIDAÇÃO','COMPREENDE AS POLITICAS PÚBLICAS QUE VISEM CONTRIBUIR PARA A REDUÇÃO DA FOME, DA POBREZA, DA DESIGUALDADE E DE OUTRAS FORMAS DE PRIVAÇÃO VIVIDAS PELAS FAMILIAS MAIS EXCLUIDAS, CONSIDERANDO TRES DIMENSOES: O ALIVIO IMEDIATO DA POBREZA, POR MEIO DA TRANSFERÊNCIA DE RENDA DIRETAMENTE AS FAMILIAS POBRES E EXTREMAMENTE POBRES; A CONTRIBUICAO PARA A REDUÇÃO DA POBREZA DA GERAÇÃO SEGUINTE, POR MEIO DO REFORCO DO DIREITO DE ACESSO AOS SERVIÇOS DE SAUDE E DE EDUCAÇÃO, COM O CUMPRIMENTO DAS CONDICIONALIDADES NESTAS AREAS; E A ARTICULAÇÃO DE AÇÕES COMPLEMENTARES, DE FORMA A DESENVOLVER AS CAPACIDADES DAS FAMILIAS BENEFICIARIAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.0.0.00.00.00.00.0000','OUTROS BENEFÍCIOS PREVIDÊNCIÁRIOS E ASSISTÊNCIAIS','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFÍCIOS PREVIDÊNCIÁRIOS OU ASSITENCIAIS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.0.00.00.00.00.0000','OUTROS BENEFÍCIOS PREVIDÊNCIÁRIOS - RPPS','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFÍCIOS PREVIDÊNCIÁRIOS DO RPPS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.00.00.00.00.0000','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RPPS - CONSOLIDAÇÃO','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFÍCIOS PREVIDÊNCIÁRIOS DO RPPS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.01.00.00.00.0000','AUXÍLIO-DOENÇA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO-DOENÇA, DEVIDO AO SEGURADO QUE FICAR INCAPACITADO PARA O TRABALHO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.01.01.00.00.0000','AUXÍLIO-DOENÇA - PESSOAL ATIVO','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AUXÍLIO-DOENÇA PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS, AOS SERVIDORES ATIVOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.01.02.00.00.0000','AUXÍLIO-DOENÇA - PESSOAL INATIVO','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AUXÍLIO-DOENÇA PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS, AO PESSOAL INATIVO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.01.03.00.00.0000','AUXÍLIO-DOENÇA - PENSIONISTAS','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AUXÍLIO-DOENÇA PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS, AOS PENSIONISTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.02.00.00.00.0000','SALÁRIO MATERNIDADE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SALÁRIO-MATERNIDADE, DEVIDO A SEGURADA GESTANTE, NA FORMA DA LEI, DURANTE O PERIODO DE LICENCA GESTANTE PREVISTO EM LEI.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.02.01.00.00.0000','SALÁRIO MATERNIDADE - PESSOAL ATIVO','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SALÁRIO MATERNIDADE PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS, AOS SERVIDORES ATIVOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.02.02.00.00.0000','SALÁRIO MATERNIDADE - PESSOAL INATIVO','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SALÁRIO MATERNIDADE PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS, AO PESSOAL INATIVO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.02.03.00.00.0000','SALÁRIO MATERNIDADE - PENSIONISTAS','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SALÁRIO MATERNIDADE PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS, AOS PENSIONISTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.03.00.00.00.0000','SALÁRIO-FAMILIA','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SALÁRIO-FAMILIA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.03.01.00.00.0000','SALÁRIO FAMILIA - ATIVO PESSOAL CIVIL','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SALÁRIO FAMILIA - ATIVO PESSOAL CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.03.02.00.00.0000','SALÁRIO FAMILIA-INATIVO PESSOAL CIVIL','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SALÁRIO-FAMILIA DEVIDOS A INATIVOS PESSOAL CIVIL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.03.03.00.00.0000','SALÁRIO FAMILIA-PENSIONISTA PESSOAL CIVIL','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SALÁRIO-FAMILIA DEVIDO A PENSIONISTA PESSOAL CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.03.99.00.00.0000','OUTROS SALÁRIOS-FAMILIA','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AUXÍLIO PECUNIARIO DEVIDO AO SERVIDOR ATIVO OU INATIVO, POR DEPENDENTE ECONOMICO PAGOS COM RECURSOS DO TESOURO DO MUNICÍPIO, NÃO CLASSIFICADAS NAS CONTAS ACIMA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.04.00.00.00.0000','AUXÍLIO-RECLUSAO','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AUXÍLIO-RECLUSAO PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.04.01.00.00.0000','AUXÍLIO-RECLUSAO - PESSOAL ATIVO','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AUXÍLIO-RECLUSAO PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS, AOS SERVIDORES ATIVOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.04.02.00.00.0000','AUXÍLIO-RECLUSAO - PESSOAL INATIVO','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AUXÍLIO-RECLUSAO PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS, AO PESSOAL INATIVO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.04.03.00.00.0000','AUXÍLIO-RECLUSAO - PENSIONISTAS','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AUXÍLIO-RECLUSAO PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS, AOS PENSIONISTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.05.00.00.00.0000','AUXÍLIO-ACIDENTE','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO-ACIDENTE PREVIDÊNCIÁRIO CONCEDIDO, COMO INDENIZAÇÃO, AO SEGURADO QUANDO, DE ACORDO COM A LEGISLAÇÃO VIGENTE, APOS A CONSOLIDAÇÃO DAS LESOES DECORRENTES DE ACIDENTES DE QUALQUER NATUREZA RESULTAR SEQUELAS QUE IMPLIQUEM REDUÇÃO DA CAPACIDADE FUNCIONAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.05.01.00.00.0000','AUXÍLIO-ACIDENTE - PESSOAL CIVIL','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO-ACIDENTE PREVIDÊNCIÁRIO CONCEDIDO, COMO INDENIZAÇÃO, AO SEGURADO QUANDO, DE ACORDO COM A LEGISLAÇÃO VIGENTE, APOS A CONSOLIDAÇÃO DAS LESOES DECORRENTES DE ACIDENTES DE QUALQUER NATUREZA RESULTAR SEQUELAS QUE IMPLIQUEM REDUÇÃO DA CAPACIDADE FUNCIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.05.02.00.00.0000','AUXÍLIO-ACIDENTE - INATIVO CIVIL','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO-ACIDENTE PREVIDÊNCIÁRIO CONCEDIDO, COMO INDENIZAÇÃO, AO SEGURADO QUANDO, DE ACORDO COM A LEGISLAÇÃO VIGENTE, APOS A CONSOLIDAÇÃO DAS LESOES DECORRENTES DE ACIDENTES DE QUALQUER NATUREZA RESULTAR SEQUELAS QUE IMPLIQUEM REDUÇÃO DA CAPACIDADE FUNCIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.05.03.00.00.0000','AUXÍLIO-ACIDENTE - PENSIONISTA','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO-ACIDENTE PREVIDÊNCIÁRIO CONCEDIDO, COMO INDENIZAÇÃO, AO SEGURADO QUANDO, DE ACORDO COM A LEGISLAÇÃO VIGENTE, APOS A CONSOLIDAÇÃO DAS LESOES DECORRENTES DE ACIDENTES DE QUALQUER NATUREZA RESULTAR SEQUELAS QUE IMPLIQUEM REDUÇÃO DA CAPACIDADE FUNCIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.06.00.00.00.0000','ABONO ANUAL – 13° SALÁRIO','REGISTRAR AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ABONO ANUAL – 13º SALÁRIO, DEVIDO AOS SEGURADOS BENEFICIÁRIOS, A PARTIR DE 15 DIAS EM GOZO DE BENEFÍCIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.06.01.00.00.0000','ABONO ANUAL – 13° SALÁRIO - ATIVO CIVIL','REGISTRAR AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ABONO ANUAL – 13º SALÁRIO, DEVIDO AOS SEGURADOS BENEFICIÁRIOS, A PARTIR DE 15 DIAS EM GOZO DE BENEFÍCIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.06.02.00.00.0000','ABONO ANUAL – 13° SALÁRIO - INATIVO CIVIL','REGISTRAR AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ABONO ANUAL – 13º SALÁRIO, DEVIDO AOS SEGURADOS BENEFICIÁRIOS, A PARTIR DE 15 DIAS EM GOZO DE BENEFÍCIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.06.03.00.00.0000','ABONO ANUAL – 13° SALÁRIO - PENSIONISTA','REGISTRAR AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ABONO ANUAL – 13º SALÁRIO, DEVIDO AOS SEGURADOS BENEFICIÁRIOS, A PARTIR DE 15 DIAS EM GOZO DE BENEFÍCIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.07.00.00.00.0000','AUXILIO FUNERAL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO DEVIDO A FAMILIA DO SERVIDOR FALECIDO, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS DESPESAS COM FUNERAL DO SERVIDOR. TAMBEM SERA DEVIDO AUXILIO FUNERAL, EM CASO DE FALECIMENTO DE SERVIDOR EM SERVICO FORA DO LOCAL DE TRABALHO, INCLUSIVE NO EXTERIOR E AS DESPESAS DE TRANSPORTE DO CORPO (TRASLADO) CORRERAO A CONTA DOS RECURSOS DA UNIAO, AUTARQUIA OU FUNDACAO PUBLICA (ART. 228, LEI 8112/90)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.07.01.00.00.0000','AUXILIO FUNERAL ATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR ATIVO CIVIL, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO ATIVO CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.07.02.00.00.0000','AUXILIO FUNERAL INATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR INATIVO CIVIL, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO INATIVO CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.07.03.00.00.0000','AUXILIO FUNERAL PENSIONISTA','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO PENSIONISTA DE SERVIDOR, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO PENSIONISTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.08.00.00.00.0000','AUXILIO NATALIDADE','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE, DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.08.01.00.00.0000','AUXILIO NATALIDADE ATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE-ATIVO CIVIL, DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.08.02.00.00.0000','AUXILIO NATALIDADE INATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE INATIVO CIVIL,DEVIDO, A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO E NASCIMENTO DE FILHO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.08.03.00.00.0000','AUXILIO NATALIDADE PENSIONISTA','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE A PENSIONISTA, DEVIDO, A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO E NASCIMENTO DE FILHO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.1.1.99.00.00.00.0000','OUTROS BENEFÍCIOS PREVIDÊNCIÁRIOS','REGISTRAR AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM OUTROS BENEFÍCIOS PREVIDÊNCIÁRIOS NÃO PREVISTOS NOS ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.2.0.00.00.00.00.0000','OUTROS BENEFÍCIOS PREVIDÊNCIÁRIOS - RGPS','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFÍCIOS PREVIDÊNCIÁRIOS DO RGPS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.2.1.00.00.00.00.0000','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RGPS - CONSOLIDAÇÃO','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFÍCIOS PREVIDÊNCIÁRIOS DO RGPS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.0.00.00.00.00.0000','OUTROS BENEFÍCIOS PREVIDÊNCIÁRIOS - MILITAR','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFÍCIOS PREVIDÊNCIÁRIOS DO REGIME PROPRIO DOS MILITARES, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.00.00.00.00.0000','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - MILITAR - CONSOLIDAÇÃO','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFÍCIOS PREVIDÊNCIÁRIOS DO REGIME PROPRIO DOS MILITARES, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.01.00.00.00.0000','AUXÍLIO-DOENÇA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO-DOENÇA, DEVIDO AO SEGURADO QUE FICAR INCAPACITADO PARA O TRABALHO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.01.01.00.00.0000','AUXÍLIO-DOENÇA - PESSOAL ATIVO MILITAR','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AUXÍLIO-DOENÇA PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS, AOS SERVIDORES ATIVOS MILITARES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.01.02.00.00.0000','AUXÍLIO-DOENÇA - PESSOAL INATIVO MILITAR','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AUXÍLIO-DOENÇA PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS, AO PESSOAL INATIVO MILITAR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.01.03.00.00.0000','AUXÍLIO-DOENÇA - PENSIONISTAS DE MILITAR','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AUXÍLIO-DOENÇA PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS, AOS PENSIONISTAS DE MILITARES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.02.00.00.00.0000','SALÁRIO MATERNIDADE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SALÁRIO-MATERNIDADE, DEVIDO A SEGURADA GESTANTE, NA FORMA DA LEI, DURANTE O PERIODO DE LICENCA GESTANTE PREVISTO EM LEI.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.02.01.00.00.0000','SALÁRIO MATERNIDADE - PESSOAL ATIVO MILITAR','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SALÁRIO MATERNIDADE PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS, AOS SERVIDORES ATIVOS MILITARES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.02.02.00.00.0000','SALÁRIO MATERNIDADE - PESSOAL INATIVO MILITAR','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SALÁRIO MATERNIDADE PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS, AO PESSOAL INATIVO MILITAR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.02.03.00.00.0000','SALÁRIO MATERNIDADE - PENSIONISTAS DE MILITARES','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SALÁRIO MATERNIDADE PAGO COM RECURSOS DO TESOURO DO MUNICÍPIO OU COM RECURSOS DO RPPS, AOS PENSIONISTAS DE MILITARES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.03.00.00.00.0000','SALÁRIO-FAMILIA','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SALÁRIO-FAMILIA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.03.01.00.00.0000','SALÁRIO FAMILIA - ATIVO PESSOAL MILITAR','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SALÁRIO FAMILIA - ATIVO PESSOAL MILITAR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.03.02.00.00.0000','SALÁRIO FAMILIA-INATIVO PESSOAL MILITAR','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SALÁRIO-FAMILIA DEVIDOS A INATIVOS PESSOAL MILITAR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.03.03.00.00.0000','SALÁRIO FAMILIA-PENSIONISTA PESSOAL MILITAR','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SALÁRIO-FAMILIA DEVIDO A PENSIONISTA PESSOAL MILITAR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.04.00.00.00.0000','AUXÍLIO-RECLUSAO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR MILITAR, AFASTADO POR MOTIVO DE PRISAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.04.01.00.00.0000','AUXÍLIO-RECLUSAO - PESSOAL ATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO MILITAR, AFASTADO POR MOTIVO DE PRISAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.04.02.00.00.0000','AUXÍLIO-RECLUSAO - PESSOAL INATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR INATIVO MILITAR, AFASTADO POR MOTIVO DE PRISAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.04.03.00.00.0000','AUXÍLIO-RECLUSAO - PENSIONISTAS DE MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A PENSIONISTA DE SERVIDOR MILITAR, AFASTADO POR MOTIVO DE PRISAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.05.00.00.00.0000','AUXÍLIO-ACIDENTE','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO-ACIDENTE PREVIDÊNCIÁRIO CONCEDIDO, COMO INDENIZAÇÃO, AO SEGURADO QUANDO, DE ACORDO COM A LEGISLAÇÃO VIGENTE, APOS A CONSOLIDAÇÃO DAS LESOES DECORRENTES DE ACIDENTES DE QUALQUER NATUREZA RESULTAR SEQUELAS QUE IMPLIQUEM REDUÇÃO DA CAPACIDADE FUNCIONAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.05.01.00.00.0000','AUXÍLIO-ACIDENTE - PESSOAL ATIVO MILITAR','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO-ACIDENTE PREVIDÊNCIÁRIO CONCEDIDO, COMO INDENIZAÇÃO, AO SEGURADO QUANDO, DE ACORDO COM A LEGISLAÇÃO VIGENTE, APOS A CONSOLIDAÇÃO DAS LESOES DECORRENTES DE ACIDENTES DE QUALQUER NATUREZA RESULTAR SEQUELAS QUE IMPLIQUEM REDUÇÃO DA CAPACIDADE FUNCIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.05.02.00.00.0000','AUXÍLIO-ACIDENTE - INATIVO MILITAR','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO-ACIDENTE PREVIDÊNCIÁRIO CONCEDIDO, COMO INDENIZAÇÃO, AO SEGURADO QUANDO, DE ACORDO COM A LEGISLAÇÃO VIGENTE, APOS A CONSOLIDAÇÃO DAS LESOES DECORRENTES DE ACIDENTES DE QUALQUER NATUREZA RESULTAR SEQUELAS QUE IMPLIQUEM REDUÇÃO DA CAPACIDADE FUNCIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.05.03.00.00.0000','AUXÍLIO-ACIDENTE - PENSIONISTA DE MILITAR','REGISTRA AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO-ACIDENTE PREVIDÊNCIÁRIO CONCEDIDO, COMO INDENIZAÇÃO, AO SEGURADO QUANDO, DE ACORDO COM A LEGISLAÇÃO VIGENTE, APOS A CONSOLIDAÇÃO DAS LESOES DECORRENTES DE ACIDENTES DE QUALQUER NATUREZA RESULTAR SEQUELAS QUE IMPLIQUEM REDUÇÃO DA CAPACIDADE FUNCIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.06.00.00.00.0000','ABONO ANUAL – 13° SALÁRIO','REGISTRAR AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ABONO ANUAL – 13º SALÁRIO, DEVIDO AOS SEGURADOS BENEFICIÁRIOS, A PARTIR DE 15 DIAS EM GOZO DE BENEFÍCIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.06.01.00.00.0000','ABONO ANUAL – 13° SALÁRIO - ATIVO MILITAR','REGISTRAR AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ABONO ANUAL – 13º SALÁRIO, DEVIDO AOS SEGURADOS BENEFICIÁRIOS, A PARTIR DE 15 DIAS EM GOZO DE BENEFÍCIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.06.02.00.00.0000','ABONO ANUAL – 13° SALÁRIO - INATIVO MILITAR','REGISTRAR AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ABONO ANUAL – 13º SALÁRIO, DEVIDO AOS SEGURADOS BENEFICIÁRIOS, A PARTIR DE 15 DIAS EM GOZO DE BENEFÍCIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.06.03.00.00.0000','ABONO ANUAL – 13° SALÁRIO - PENSIONISTA DE MILITAR','REGISTRAR AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ABONO ANUAL – 13º SALÁRIO, DEVIDO AOS SEGURADOS BENEFICIÁRIOS, A PARTIR DE 15 DIAS EM GOZO DE BENEFÍCIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.07.00.00.00.0000','AUXILIO FUNERAL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO DEVIDO A FAMILIA DO SERVIDOR FALECIDO, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS DESPESAS COM FUNERAL DO SERVIDOR. TAMBEM SERA DEVIDO AUXILIO FUNERAL, EM CASO DE FALECIMENTO DE SERVIDOR EM SERVICO FORA DO LOCAL DE TRABALHO, INCLUSIVE NO EXTERIOR E AS DESPESAS DE TRANSPORTE DO CORPO (TRASLADO) CORRERAO A CONTA DOS RECURSOS DA UNIAO, AUTARQUIA OU FUNDACAO PUBLICA (ART. 228, LEI 8112/90)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.07.01.00.00.0000','AUXILIO FUNERAL ATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR ATIVO MILITAR, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO ATIVO MILITAR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.07.02.00.00.0000','AUXILIO FUNERAL INATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR INATIVO MILITAR, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO INATIVO MILITAR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.07.03.00.00.0000','AUXILIO FUNERAL PENSIONISTA DE MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO PENSIONISTA DE SERVIDOR, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO PENSIONISTA DE MILITAR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.08.00.00.00.0000','AUXILIO NATALIDADE','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE, DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.08.01.00.00.0000','AUXILIO NATALIDADE ATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE-ATIVO MILITAR, DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.08.02.00.00.0000','AUXILIO NATALIDADE INATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE INATIVO MILITAR,DEVIDO, A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO E NASCIMENTO DE FILHO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.08.03.00.00.0000','AUXILIO NATALIDADE PENSIONISTA DE MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE A PENSIONISTA, DEVIDO, A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO E NASCIMENTO DE FILHO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.3.1.99.00.00.00.0000','OUTROS BENEFÍCIOS PREVIDÊNCIÁRIOS','REGISTRAR AS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM OUTROS BENEFÍCIOS PREVIDÊNCIÁRIOS NÃO PREVISTOS NOS ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.9.0.00.00.00.00.0000','OUTROS BENEFÍCIOS PREVIDÊNCIÁRIOS E ASSISTÊNCIAIS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTROS BENEFÍCIOS PREVIDÊNCIÁRIOS E ASSISTÊNCIAIS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.2.9.9.1.00.00.00.00.0000','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTÊNCIAIS - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTROS BENEFÍCIOS PREVIDÊNCIÁRIOS E ASSISTÊNCIAIS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.0.0.0.00.00.00.00.0000','USO DE BENS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','COMPREENDE O SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM MANUTENCAO E OPERAÇÃO DA MAQUINA PÚBLICA, EXCETO DESPESAS COM PESSOAL E ENCARGOS QUE SERAO REGISTRADAS EM GRUPO ESPECIFICO (DESPESAS DE PESSOAL E ENCARGOS). COMPREENDE: DIÁRIAS, MATERIAL DE CONSUMO, MATERIAL DE DISTRIBUICAO GRATUITA, PASSAGENS E DESPESAS COM LOCOMOCAO, SERVIÇOS DE TERCEIROS, ARRENDAMENTO MERCANTIL OPERACIONAL, ALUGUEL, DEPRECIAÇÃO AMORTIZAÇÃO, EXAUSTÃO, ENTRE OUTRAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.0.0.00.00.00.00.0000','USO DE MATERIAL DE CONSUMO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA DISTRIBUICAO DO MATERIAL DE CONSUMO. UM MATERIAL E CONSIDERADO DE CONSUMO QUANDO FOR DE DURAÇÃO INFERIOR A DOIS ANOS, FRAGIL, PERECIVEL, INCORPORAVEL, TRANSFORMAVEL OU CUJA FINALIDADE SEJA PARA CONSUMO IMEDIATO OU PARA REPOSICAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.0.00.00.00.00.0000','CONSUMO DE MATERIAL','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE REQUISICAO DE MATERIAL DE CONSUMO PARA USO INTERNO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.00.00.00.00.0000','CONSUMO DE MATERIAL - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE REQUISICAO DE MATERIAL DE CONSUMO PARA USO INTERNO COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.01.00.00.00.0000','COMBUSTÍVEIS E LUBRIFICANTES AUTOMOTÍVEIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE COMBUSTÍVEIS PARA MOTORES A COMBUSTAO INTERNA DE VEICULOS RODOVIARIOS, TRATORES EM GERAL, EMBARCAÇÕES DIVERSAS E GRUPOS GERADORES ESTACIONADOS OU TRANSPORTAVEIS, E TODOS OS OLEOS LUBRIFICANTES DESTINADOS AOS SISTEMAS HIDRAULICOS, HIDRAMATICOS, DE CAIXA DE TRANSMISSAO DE FORCA E GRAXAS GRAFITADAS PARA ALTAS E BAIXAS TEMPERATURAS. ADITIVOS - ALCOOL HIDRATADO - FLUIDO PARA AMORTECEDOR - FLUIDO PARA TRANSMISSAO HIDRAULICA - GASOLINA - GRAXAS - OLEO DIESEL - OLEO PARA CARTER - OLEO PARA FREIO HIDRAULICO E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.02.00.00.00.0000','COMBUSTÍVEIS E LUBRIFICANTES DE AVIAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE COMBUSTÍVEIS E LUBRIFICANTES DESTINADOS A QUALQUER TIPO DE AERONAVE. ADITIVOS - GASOLINA - GRAXAS - OLEOS E FLUIDOS EM GERAL - QUEROSENE E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.03.00.00.00.0000','COMBUSTÍVEIS E LUBRIFICANTES PARA OUTRAS FINALIDADES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE COMBUSTÍVEIS E LUBRIFICANTES PARA OUTRAS FINALIDADES QUE NÃO SE ENQUADRAM EM ITENS ANTERIORES. CARBURETO - CARVAO MINERAL - CARVAO VEGETAL - LENHA - QUEROSENE COMUM - COMBUSTÍVEIS E LUBRIFICANTES DE USO FERROVIARIO E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.04.00.00.00.0000','GAS E OUTROS MATERIAIS ENGARRAFADOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE GAS DE USO INDUSTRIAL, DE TRATAMENTO DE AGUA, DE ILUMINAÇÃO, DE USO MEDICO, BEM COMO GASES NOBRES PARA USO EM LABORATORIO CIENTIFICO, TAIS COMO: ACETILENO - CARBONICO FREON - HELIO - HIDROGENIO - LIQUEFEITO DE PETROLEO - NITROGENIO - OXIGENIO E OUTROS. REGISTRA, AINDA, O VALOR DAS DESPESAS COM GAS, PO QUIMICO, AGUA PRESSURIZADA E OUTROS MATERIAIS UTILIZADOS NA RECARGA DE EXTINTORES DE INCENDIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.05.00.00.00.0000','EXPLOSIVOS E MUNICOES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE CARGAS DE PROJECAO EM PECAS DE ARTILHARIA, MISSEIS GUIADOS E NÃO GUIADOS, CAPSULAS OU ESTOJOS PARA RECARGA E EXPLOSIVOS DE USO MILITAR E PARAMILITAR. BALAS E SIMILARES - ESTOPIM - EXPLOSIVOS, TAIS COMO: ARTEFATOS EXPLOSIVOS - ARTIGOS PIROTECNICOS - CAPSULAS DE DETONAÇÃO - DINAMITE - ESPOLETA - FOGOS DE ARTIFICIO - GRANADA - POLVORA E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.06.00.00.00.0000','ALIMENTOS PARA ANIMAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE ALIMENTOS DESTINADOS A GADO BOVINO, EQUINO, MUAR E BUFALINO, CAPRINOS, SUINOS, OVINOS, AVES DE QUALQUER ESPECIE, COMO TAMBÉM PARA ANIMAIS SILVESTRES EM CATIVEIRO (JARDINS ZOOLOGICOS OU LABORATORIOS) E OUTROS. ALFAFA - ALPISTE - CAPIM VERDE - FARELO - FARINHAS EM GERAL - FUBA GROSSO - MILHO EM GRAO - RAÇÃO BALANCEADA - SAL MINERAL - SUPLEMENTOS VITAMINICOS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.07.00.00.00.0000','GENEROS DE ALIMENTAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE GENEROS DE ALIMENTAÇÃO AO NATURAL, BENEFICIADOS OU CONSERVADOS. ACUCAR - ADOCANTE - AGUA MINERAL - BEBIDAS - CAFE - CARNES EM GERAL - CEREAIS - CHAS - CONDIMENTOS - FRUTAS - GELO - LEGUMES - REFRIGERANTES - SUCOS - TEMPEROS - VERDURAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.08.00.00.00.0000','ANIMAIS PARA PESQUISA E ABATE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE ANIMAIS PARA PESQUISA E ABATE. INCLUEM-SE NESTA CLASSIFICAÇÃO OS PEIXES E MARISCOS, TODAS AS ESPECIES DE MAMIFEROS, ABELHAS PARA ESTUDOS, PESQUISA E PRODUCAO DE MEL, BEM ASSIM QUALQUER OUTRO ANIMAL DESTINADO A ESTUDO GENETICO OU ALIMENTAÇÃO. BOI - CABRITO - COBAIAS EM GERAL - MACACO - RATO - RA E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.09.00.00.00.0000','MATERIAL FARMACOLOGICO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MEDICAMENTOS OU COMPONENTES DESTINADOS A MANIPULAÇÃO DE DROGAS MEDICAMENTOSAS. MEDICAMENTOS - SORO - VACINAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.10.00.00.00.0000','MATERIAL ODONTOLOGICO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS PARA PACIENTES DA AREA ODONTOLOGICA, BEM COMO OS UTILIZADOS INDIRETAMENTE PELOS PROTETICOS NA CONFECCAO DE PROTESES DIVERSAS. AGULHAS - AMALGAMA - ANESTESICOS - BROCA - CIMENTO ODONTOLOGICO -ESPATULA ODONTOLOGICA - FILMES PARA RAIO X - PLATINA - RESINAS ODONTOLOGICAS - SERINGAS - SUGADOR E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.11.00.00.00.0000','MATERIAL QUIMICO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE TODOS OS ELEMENTOS OU COMPOSTOS QUIMICOS DESTINADOS AO FABRICO DE PRODUTOS QUIMICOS, ANALISES LABORATORIAIS, BEM COMO AQUELES DESTINADOS AO COMBATE DE PRAGAS OU EPIZOOTIAS. ACIDOS - INSETICIDAS - PRODUTOS QUIMICOS PARA TRATAMENTO DE AGUA -REAGENTES QUIMICOS - SAIS - SOLVENTES - SUBSTANCIAS UTILIZADAS PARA COMBATER INSETOS, FUNGOS E BACTERIAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.12.00.00.00.0000','MATERIAL DE COUDELARIA OU DE USO ZOOTECNICO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS UTILIZADOS NO ARREAMENTO DE ANIMAIS DESTINADOS A MONTARIA, COM EXCECAO DA SELA, COMO TAMBÉM AQUELES DESTINADOS AO ADESTRAMENTO DE CAES DE GUARDA OU OUTRO ANIMAL DOMESTICO. ARGOLAS DE METAL - ARREAMENTO - BARRIGUEIRAS - BRIDOES - CABRESTOS - CINCHAS - CRAVOS - ESCOVAS PARA ANIMAIS - ESTRIBOS - FERRADURAS - MANTAS DE PANO - MATERIAL PARA APICULTURA - MATERIAL DE FERRAGEM E CONTENCAO DE ANIMAIS - PEITORAIS - RASPADEIRAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.13.00.00.00.0000','MATERIAL DE CACA E PESCA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS PARA CACA E PESCA DE ANIMAIS. ANZOIS - CORDOALHAS PARA REDES CHUMBADAS - ISCAS - LINHAS DE NYLON - MASCARAS PARA VISAO SUBMARINA - MOLINETES - NADADEIRAS DE BORRACHA - REDES - ROUPAS E ACESSORIOS PARA MERGULHO - VARAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.14.00.00.00.0000','MATERIAL EDUCATIVO E ESPORTIVO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS CONSUMIDOS DIRETAMENTE NAS ATIVIDADES EDUCATIVAS E ESPORTIVAS DE CRIANCAS E ADULTOS. APITOS - BOLAS - BONES - BOTAS ESPECIAIS - BRINQUEDOS EDUCATIVOS - CALCOES - CAMISAS DE MALHA - CHUTEIRAS - CORDAS - ESTEIRAS -JOELHEIRAS - LUVAS - MATERIAIS PEDAGOGICOS - MEIAS - OCULOS PARA MOTOCICLISTAS - PATINS - QUIMONOS - RAQUETES - REDES PARA PRATICA DE ESPORTES - TENIS E SAPATILHAS - TORNOZELEIRAS - TOUCA PARA NATAÇÃO E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.15.00.00.00.0000','MATERIAL PARA FESTIVIDADES E HOMENAGENS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS DE CONSUMO UTILIZADOS EM FESTIVIDADES E HOMENAGENS, INCLUINDO ARTIGOS PARA DECORAÇÃO E BUFFET. ARRANJOS E COROAS DE FLORES - BEBIDAS - DOCES - SALGADOS - PLACAS COMEMORATIVAS (EXCETO AS PLACAS PARA DISTRIBUICAO GRATUITA) E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.16.00.00.00.0000','MATERIAL DE EXPEDIENTE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS APLICADOS DIRETAMENTE NOS TRABALHOS ADMINISTRATIVOS, NOS ESCRITORIOS PÚBLICOS, NOS CENTROS DE ESTUDOS E PESQUISAS, NAS ESCOLAS, NAS UNIVERSIDADES ETC. AGENDA - ALFINETE DE ACO - ALMOFADA P/ CARIMBOS - APAGADOR - APONTADOR DE LAPIS - ARQUIVO P/ DISQUETE - BANDEJA PARA PAPEIS - BLOCO P/ RASCU-NHO - BOBINA PAPEL P/ CALCULADORAS - BORRACHA - CADERNO - CANETA -CAPA DE PROCESSO - CARIMBOS EM GERAL - CARTOLINA - CLASSIFICADOR -CLIPE - COLA - COLCHETE - CORRETIVO - ENVELOPE - ESPATULA - ESTENCIL -ESTILETE - EXTRATOR DE GRAMPOS - FITA ADESIVA - FITA P/ MAQUINA DE ES-CREVER E CALCULAR - GIZ - GOMA ELASTICA - GRAFITE - GRAMPEADOR -GRAMPOS - GUIA P/ ARQUIVO - GUIA DE ENDERECAMENTO POSTAL - IMPRESSOS E FORMULARIOS EM GERAL - INTERCALADOR P/ FICHARIO - LACRE - LAPIS -LAPISEIRA - LIMPA TIPOS - LIVROS DE ATA, DE PONTO E DE PROTOCOLO -PAPEIS - PASTAS EM GERAL - PERCEVEJO - PERFURADOR - PINCA - PLACAS DE ACRILICO - PLASTICOS - PORTA-LAPIS - REGISTRADOR - REGUA - SELOS P/ CORRESPONDENCIA - TESOURA - TINTAS - TONER - TRANSPARENCIAS - ETIQUETAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.17.00.00.00.0000','MATERIAL DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SUPRIMENTOS DE TI, INCLUSIVE PECAS PARA REPOSICAO. CARTUCHOS DE TINTA - CAPAS PLASTICAS PROTETORAS PARA MICROS E IMPRES- SORAS - CD-ROM VIRGEM - DISQUETES - ETIQUETAS EM FORMULARIOS-CONTINUOS -LEITORA/SMARTCARD - MOUSE E TECLADO (REPOSICAO) - MOUSE PAD - PECAS E ACESSORIOS PARA COMPUTADORES E PERIFERICOS - RECARGA DE CARTUCHOS DE TINTA - TONER PARA IMPRESORAS A LASER - CARTOES MAGNETICOS - REPOSICAO DE LEITORA/TOKEN PEN-DRIVE/OUTROS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.18.00.00.00.0000','MATERIAIS E MEDICAMENTOS P/ USO VETERINARIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS E MEDICAMENTOS PARA USO VETERINARIO. VACINAS - MEDICAMENTOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.19.00.00.00.0000','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS APLICADOS DIRETAMENTE NAS PRESERVAÇÕES, ACOMODAÇÕES OU EMBALAGENS DE QUALQUER PRODUTO. ARAME - BARBANTE - CAIXAS PLASTICAS, DE MADEIRA, PAPELAO E ISOPOR -CORDAS - ENGRADADOS - FITAS DE ACO OU METALICAS - FITAS GOMADORAS -GARRAFAS E POTES - LINHA - PAPEL DE EMBRULHO - PAPELAO - SACOLAS -SACOS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.20.00.00.00.0000','MATERIAL DE CAMA, MESA E BANHO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS UTILIZADOS EM DORMITORIOS COLETIVOS, RESIDENCIAIS, HOTEIS, RESTAURANTES ETC. COBERTORES - COLCHAS - COLCHONETES - FRONHAS - GUARDANAPOS - LENCOIS -TOALHAS - TRAVESSEIROS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.21.00.00.00.0000','MATERIAL DE COPA E COZINHA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS PARA REFEITORIOS DE QUALQUER TIPO, COZINHAS RESIDENCIAIS, DE HOTEIS, DE HOSPITAIS, DEESCOLAS, DE UNIVERSIDADES, DE FABRICAS ETC. ABRIDOR DE GARRAFA - ACUCAREIROS - ARTIGOS DE VIDRO E PLASTICO -BANDEJAS - COADORES - COLHERES - COPOS - EBULIDORES - FACAS -FARINHEIROS - FOSFOROS - FRIGIDEIRAS - GARFOS - GARRAFAS TERMICAS -PALITEIROS - PANELAS - PANOS DE COZINHA - PAPEL ALUMINIO - PRATOS -RECIPIENTES PARA AGUA - SUPORTES DE COPOS P/ CAFEZINHO - TIGELAS -VELAS - XICARAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.22.00.00.00.0000','MATERIAL DE LIMPEZA E PROD. DE HIGIENIZAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS DESTINADOS A HIGIENIZAÇÃO PESSOAL, DE AMBIENTES DE TRABALHO, DE HOSPITAIS ETC. ALCOOL ETILICO - ANTICORROSIVO - APARELHO DE BARBEAR DESCARTAVEL -BALDE PLASTICO - BOMBA P/ INSETICIDA - CAPACHO - CERA - CESTO P/ LIXO- CREME DENTAL - DESINFETANTE - DESODORIZANTE - DETERGENTE - ESCOVA DEDENTES - ESCOVA P/ ROUPAS E SAPATOS - ESPANADOR - ESPONJA - ESTOPA -FLANELA - INSETICIDA - LUSTRA-MÓVEIS - MANGUEIRA - NAFTALINA - PA PARALIXO - PALHA DE ACO - PANOS P/ LIMPEZA - PAPEL HIGIENICO - PASTA PARALIMPEZA DE UTENSILIOS - PORTA-SABAO - REMOVEDOR - RODO - SABAO -SABONETE - SACO P/ LIXO - SAPONACEO - SODA CAUSTICA - TOALHA DE PAPEL- VASSOURA - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.23.00.00.00.0000','UNIFORMES, TECIDOS E AVIAMENTOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE UNIFORMES OU QUALQUER TECIDO OU MATERIAL SINTETICO QUE SE DESTINE A CONFECCAO DE ROUPAS, COM LINHAS DE QUALQUER ESPECIE DESTINADAS A COSTURAS E OUTROS MATERIAIS DE CONSUMO EMPREGADOS DIRETA OU INDIRETAMENTE NA CONFECCAO DE ROUPAS. AGASALHOS - ARTIGOS DE COSTURA - AVENTAIS - BLUSAS - BOTOES - CADARCOS- CALCADOS - CALCAS - CAMISAS - CAPAS - CHAPEUS - CINTOS - ELASTICOS -GRAVATAS - GUARDA-POS - LINHAS - MACAÇÕES - MEIAS - TECIDOS EM GERAL -UNIFORMES MILITARES OU DE USO CIVIL - ZIPERES - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.24.00.00.00.0000','MATERIAL PARA MANUTENÇÃO DE BENS IMÓVEIS/INSTALAÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS DE CONSUMO PARA APLICAÇÃO,MANUTENCAO E REPOSICAO DE QUALQUER BEM PÚBLICO. AMIANTO - APARELHOS SANITARIOS - ARAMES LISO E FARPADO - AREIA -BASCULANTE - BOCA DE LOBO - BOIA - BRITA - BROCHA - CABO METALICO -CAL - CANO - CERAMICA - CIMENTO - COLA - CONDUTORES DE FIOS - CONEXOES- CURVAS - ESQUADRIAS - FECHADURAS - FERRO - GAXETAS - GRADES -IMPERMEABILIZANTES - ISOLANTES ACUSTICOS E TERMICOS - JANELAS -JOELHOS - LADRILHOS - LAVATORIOS - LIXAS - MADEIRA - MARCOS DECONCRETO - MASSA CORRIDA - NIPLE - PAPEL DE PAREDE - PARAFUSOS - - PECAS P/ELEVADORES,PORTOES ELETRICOS, AR CONDICIONADO CENTRAL, ETC- PIAS- PIGMENTOS - PORTAS E PORTAIS - PREGOS - ROLOS SOLVENTES - SIFAO -TACOS - TAMPA P/ VASO - TAMPAO DE FERRO - TANQUE - TELA DE ESTUQUE -TELHA - TIJOLO - TINTA - TORNEIRA - TRINCHA - TUBO DE CONCRETO -VALVULAS - VERNIZ - VIDRO - AQUECEDORES A GAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.25.00.00.00.0000','MATERIAL PARA MANUTENCAO DE BENS MÓVEIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE COMPONENTES, PECAS, ACESSORIOS E SOBRESSALENTES PARA APLICAÇÃO, MANUTENCAO E REPOSICAO EM BENS MÓVEIS EM GERAL. CABOS - CHAVES - CILINDROS P/ MAQUINAS COPIADORAS - COMPRESSOR P/ AR CONDICIONADO - MANGUEIRA P/ FOGAO - PECAS DE REPOSICAO DE APARELHOS E MAQUINAS EM GERAL -MATERIAIS DE REPOSICAO PARA INSTRUMENTOS MUSICAIS - VIDRO DE MESA E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.26.00.00.00.0000','MATERIAL ELETRICO E ELETRONICO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS DE CONSUMO PARA APLICAÇÃO,MANUTENCAO E REPOSICAO DOS SISTEMAS, APARELHOS E EQUIPAMENTOS ELETRICOS E ELETRONICOS. BENJAMINS - BOCAIS - CALHAS - CAPACITORES E RESISTORES - CHAVES DE LIGAÇÃO - CIRCUITOS ELETRONICOS - CONDUTORES - COMPONENTES DE APARELHOELETRONICO - DIODOS - DISJUNTORES - ELETRODOS - ELIMINADOR DE PILHAS -ESPELHOS PARA INTERRUPTORES - FIOS E CABOS - FITA ISOLANTE - FUSIVEIS- INTERRUPTORES - LAMPADAS E LUMINARIAS - PILHAS E BATERIAS - PINOS E PLUGS - PLACAS DE BAQUELITE - REATORES - RECEPTACULOS - RESISTENCIAS -STARTS - SUPORTES - TOMADA DE CORRENTE - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.27.00.00.00.0000','MATERIAL DE MANOBRA E PATRULHAMENTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS DE CONSUMO UTILIZADOS EM CAMPANHA MILITAR OU PARAMILITAR, EM MANOBRAS DE TROPAS, EM TREINAMENTOOU EM AÇÃO EM PATRULLHAMENTO OSTENSIVO OU RODOVIARIO, EM CAMPANHA DE SAUDE PÚBLICA ETC. BINOCULO - CARTA NAUTICA - CANTIL - CORDAS - FLAMULAS E BANDEIRAS DESINALIZAÇÃO - LANTERNAS - MEDICAMENTOS DE PRONTO-SOCORRO - MOCHILAS - PIQUETES - SACOLAS - SACOS DE DORMIR - SINALEIROS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.28.00.00.00.0000','MATERIAL DE PROTECAO E SEGURANCA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS DE CONSUMO UTILIZADOS DIRETAMENTE NA PROTECAO DE PESSOAS OU BENS PÚBLICOS, PARA SOCORRO DE PESSOAS E ANIMAIS OU PARA SOCORRO DE VEICULOS, AERONAVES E EMBARCAÇÕES, ASSIM COMO QUALQUER OUTRO ITEM APLICADO DIRETAMENTE NAS ATIVIDADES DE SOBREVIVENCIA DE PESSOAS, NA SELVA, NO MAR OU EM SINISTROS DIVERSOS. BOTAS - CADEADOS - CALCADOS ESPECIAIS - CAPACETES - CHAVES - CINTOS -COLETES - DEDAIS - GUARDA-CHUVAS - LONA - LUVAS - MANGUEIRA DE LONA -MASCARAS - PASSADEIRA ANTIDERRAPANTE - OCULOS - CABINA DE PAPELAO E OUTROS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.29.00.00.00.0000','MATERIAL PARA AUDIO, VIDEO E FOTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS DE CONSUMO DE EMPREGO DIRETO EM FILMAGEM E REVELAÇÃO, AMPLIAÇÕES E REPRODUCOES DE SONS E IMAGENS. AETZE ESPECIAL P/ CHAPA DE PAPEL - ALBUNS P/ RETRATOS - ALTO-FALANTES- ANTENAS - ARTIGOS PARA GRAVAÇÃO EM ACETATO - FILMES VIRGENS - FITASVIRGENS DE AUDIO E VIDEO - LAMPADAS ESPECIAIS - MATERIAL P/ RADIOGRA-FIA, MICROFILMAGEM E CINEMATOGRAFIA - MOLDURAS - PAPEL P/ REVELAÇÃO DEFOTOGRAFIAS - PEGADORES - REVELADORES - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.30.00.00.00.0000','MATERIAL PARA COMUNICAÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS PARA COMUNICAÇÕES, ASSIM COMO OS COMPONENTES, CIRCUITOS IMPRESSOS OU INTEGRADOS, PECAS OU ACESSORIOS DE REPOSICAO, CHIPS, E PARTES DE EQUIPAMENTOS DE COMUNIC.MATERIAIS PARA INSTALAÇÕES: RADIOFONICAS, RADIOTELEGRAFICAS, TELEGRAFICAS E OUTROS. - BATERIA PARA TELEFONE CELULAR- BLOQUEADOR TELEFONICO - CHAVE COMUTADORA PARA TELEFONE - FIO PARA TELEFONE - TOMADA PARA TELEFONE - MATERIAIS PARA INSTALAÇÕES RADIOFONICAS - RADIOTELEGRAFICAS - TELEGRAFICAS - OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.31.00.00.00.0000','SEMENTES, MUDAS DE PLANTAS E INSUMOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE QUALQUER TIPO DE SEMENTE DESTINADA AAO PLANTIO E MUDAS DE PLANTAS FRUTIFERAS OU ORNAMENTAIS, ASSIM COMO TODOS OS INSUMOS UTILIZADOS PARA FERTILIZAÇÃO. ADUBOS - ARGILA - PLANTAS ORNAMENTAIS - BORBULHAS - BULBOS - ENXERTOS- FERTILIZANTES - MUDAS ENVASADAS OU COM RAIZES NUAS - SEMENTES -TERRA - TUBERCULOS - XAXIM - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.32.00.00.00.0000','SUPRIMENTO DE AVIAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS EMPREGADOS NA MANUTENCAO E REPARO DE AERONAVES. ACESSORIOS - PECAS DE REPOSICAO DE AERONAVES - SOBRESSALENTES -E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.33.00.00.00.0000','MATERIAL PARA PRODUCAO INDUSTRIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAS-PRIMAS UTILIZADAS NA TRANSFORMAÇÃO, BENEFICIAMENTO E INDUSTRIALIZAÇÃO DE UM PRODUTO FINAL. BORRACHA - COURO - MATERIAS-PRIMAS EM GERAL - MINERIOS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.34.00.00.00.0000','SUPRIMENTOS PARA MAQ.E MOTORES NAVIOS E EMBARCAÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAL PARA MANUTENCAO E REPARO DE MAQUINAS E MOTORES DE NAVIOS, INCLUSIVE DA ESQUADRA, E DE EMBARCAÇÕES EM GERAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.35.00.00.00.0000','MATERIAL LABORATORIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE TODOS OS UTENSILIOS USADOS EM ANALISES LABORATORIAIS. ALMOFARIZES - BASTOES - BICO DE GAS - CALICES - CORANTES - FILTROS DEPAPEL - FIXADORAS - FRASCOS - FUNIS - GARRA METALICA - LAMINAS DEVIDRO P/ MICROSCOPIO - LAMPADAS ESPECIAIS - LUVAS DE BORRACHA - METAISE MATALOIDES P/ ANALISE - PINCAS - ROLHAS - VIDRARIA: BALAO VOLUMETRI-CO - BECKER - CONTA-GOTAS - ERLEMEYER - PIPETA - PROVETA - TERMOMETRO- TUBO DE ENSAIO - MATERIAL DE LABORATORIO DIDATICO E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.36.00.00.00.0000','MATERIAL HOSPITALAR','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS DE CONSUMO PARA AREA HOSPITALAR OU AMBULATORIAL. AGULHAS HIPODERMICAS - ALGODAO - CANULAS - CATETERES - COMPRESSA DEGAZE - DRENOS - ESPARADRAPO - FIOS CIRURGICOS - LAMINAS P/ BISTURI -LUVAS - SERINGAS - TERMOMETRO CLINICO - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.37.00.00.00.0000','SUPRIMENTOS DE ARMAMENTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAL PARA MANUTENCAO E REPARO DE ARMAMENTO. MATERIAL DE MANUTENCAO E ARMAMENTO - PECAS DE REPOSICAO - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.38.00.00.00.0000','SUPRIMENTO DE PROTECAO AO VOO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE PECAS DE REPOSICAO DE RADARES E SISTEMAS DE COMUNICAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.39.00.00.00.0000','MATERIAL PARA MANUTENCAO DE VEICULOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS PARA APLICAÇÃO E MANUTENCAO DE VEICULOS RODOVIARIOS, VIATURAS BLINDADAS E TRATORES EM GERAL. AGUA DESTILADA - AMORTECEDORES - BATERIAS - BORRACHAS - BUZINA - CABOSDE ACELERADOR - CABOS DE EMBREAGEM - CAMARA DE AR - CARBURADOR COMPLETO - CIFA - COLAR DE EMBREAGEM - CONDENSADOR E PLATINADO - CORREIAS- DISCO DE EMBREAGEM - IGNICAO - JUNTA HOMOCINETICA - LAMPADAS E LANTERNAS P/ VEICULOS - LONAS E PASTILHAS DE FREIO - MANGUEIRAS -MATERIAL UTILIZADO EM LANTERNAGEM E PINTURA - MOTOR DE REPOSICAO -PARA-BRISA - PARA-CHOQUE - PLATO - PNEUS - REPAROS - RETENTORES -RETROVISORES - ROLAMENTOS - TAPETES - VALVULA DA MARCHA-LENTA E TERMOSTATICA - VELAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.40.00.00.00.0000','MATERIAL BIOLOGICO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE AMOSTRAS E OUTROS ITENS DE MATERIAIS BIOLOGICOS UTILIZADOS EM ESTUDOS E PESQUISAS CIENTIFICAS EM SERES VIVOS E INSEMINAÇÃO ARTIFICIAL. MEIOS DE CULTURA - SEMEN - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.41.00.00.00.0000','MATERIAL PARA UTILIZAÇÃO EM GRAFICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE TODOS OS MATERIAIS DE CONSUMO DE USO GRAFICO, TAIS COMO: CHAPAS DE OFF-SET - CLICHES - COLA - ESPIRAIS - FOTOLITOS - LOGOTIPOS - PAPEL - SOLVENTES - TINTA - TIPOS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.42.00.00.00.0000','FERRAMENTAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE TODOS OS TIPOS DE FERRAMENTAS UTILIZADAS EM OFICINAS, CARPINTARIAS, JARDINS ETC. ALICATE - BROCA - CAIXA P/ FERRAMENTAS - CANIVETE - CHAVES EM GERAL -ENXADA - ESPATULAS - FERRO DE SOLDA - FOICE - LAMINA DE SERRA - LIMA -MACHADO - MARTELO - PA - PICARETA - PONTEIRA - PRUMO - SERROTE -TESOURA DE PODAR - TRENA - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.43.00.00.00.0000','MATERIAL PARA REABILITAÇÃO PROFISSIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS PARA PROGRAMAS DE REABILITAÇÃO PROFISSIONAL. BASTOES - BENGALAS - JOELHEIRAS - MEIAS ELASTICAS E ASSEMELHADOS -OCULOS - ORTESES - PESOS - PROTESES, INSTRUMENTOS DE TRABALHO E IMPLEMENTOS PROFISSIONAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.44.00.00.00.0000','MATERIAL DE SINALIZAÇÃO VISUAL E OUTROS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS PARA IDENTIFICAÇÃO, SINALIZAÇÃO VISUAL, ENDERECAMENTO E OUTROS. PLACAS DE SINALIZAÇÃO EM GERAL, TAIS COMO, PLACAS INDICATIVAS PARA O SETORES E SECOES, PLACAS PARA VEICULOS, PLAQUETAS PARA TOMBAMENTO DE MATERIAL, PLACAS SINALIZADORAS DE TRANSITO, CONES SINALIZADORES DE TRANSITO, CRACHAS, BOTONS IDENTIFICADORES PARA SERVIDORES E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.45.00.00.00.0000','MATERIAL TECNICO PARA SELEÇÃO E TREINAMENTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS TECNICOS UTILIZADOS EM PROCESSOS DE SELEÇÃO E TREINAMENTO PELA PROPRIA UNIDADE GESTORA OU PARA DISTRIBUICAO NÃO GRATUITA, TAIS COMO: APOSTILAS E SIMILARES - FOLHETOS DE ORIENTAÇÃO - LIVROS - MANUAIS EXPLICATIVOS PARA CANDIDATOS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.46.00.00.00.0000','MATERIAL BIBLIOGRAFICO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAL BIBLIOGRAFICO TAIS COMO: JORNAIS - REVISTAS - PERIODICOS EM GERAL - ANUARIOS MEDICOS - ANUARIO ESTATISCO - LIVROS EM GERAL E OUTROS, PODENDO ESTAR NA FORMA DE CD-ROM E OS MATERIAIS BIBLIOGRAFICOS PARA BIBLIOTECAS PÚBLICAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.48.00.00.00.0000','BENS MÓVEIS NÃO ATIVÁVEIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA AQUISIÇÃO DE BENS MOVEIS DE NATUREZA PERMANENTE NÃO ATIVÁVEIS, OU SEJA, AQUELES CONSIDERADOS COMO DESPESA OPERACIONAL, PARA FINS DE DEDUÇÃO DE IMPOSTO DE RENDA, DESDE QUE ATENDA AS ESPECIFICAÇÕES CONTIDAS NO ARTIGO 301 DO RIR (REGULAMENTO DE IMPOSTO DE RENDA). ESTA CONTA É UTILIZADA EXCLUSIVAMENTE PELAS UNIDADES REGIDAS PELA LEI 6404/76.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.49.00.00.00.0000','BILHETES DE PASSAGEM','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE BILHETES DE PASSAGEM PARA GUARDA EM ESTOQUE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.50.00.00.00.0000','BANDEIRAS, FLAMULAS E INSIGNIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE BANDEIRAS, FLAMULAS E INSIGNIAS, A SABER: BRASOES, ESCUDOS, ARMAS DA REPÚBLICA, SELO NACIONAL E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.51.00.00.00.0000','DISCOTECAS E FILMOTECAS NÃO IMOBILIZAVEL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA AQUISICAO DE DISCOS, CD E COLECOES DE FITAS GRAVADAS COM MUSICAS E FITAS CINEMATOGRAFICAS DE CARATER EDUCATIVO, CIENTIFICO E INFORMATIVO, CUJA DEFASAGEM CONTABIL OCORRE EM UM PRAZO MAXIMO DE DOIS ANOS E QUE ATENDA OS PARAMETROS EXCLUDENTES DE MATERIAL PERMANENTE, CONFORME MANUAL DE CONTABILIDADE APLICADO AO SETOR PÚBLICO - MACASP, VOLUME I - PROCEDIMENTOS CONTABEIS ORCAMENTARIOS, TAIS COMO: - DISCO EDUCATIVO - FITA DE AUDIO E VIDEO COM AULA DE CARATER EDUCATIVO, MICROFILME E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.54.00.00.00.0000','MATERIAL PARA MANUTENÇÃO E CONSERVAÇÃO DE ESTRADAS E VIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS PARA REPAROS, RECUPERAÇÕES E ADAPTAÇÕES DE ESTRADAS, FERROVIAS E RODOVIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.55.00.00.00.0000','SELOS PARA CONTROLE FISCAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SELOS PARA CONTROLE FISCAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.58.00.00.00.0000','SOBRESSALENTES PARA MÁQUINAS E EQUP. PARA PRODUÇÃO INDUSTRIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SOBRESSALENTES PARA MÁQUINAS E EQUIPAMENTOS PARA PRODUÇÃO INDUSTRIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.70.00.00.00.0000','AQUISIÇÃO DE SOFTWARES DE BASE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA AQUISIÇÃO DE SOFTWARES DE BASE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.71.00.00.00.0000','MATERIAIS PARA CONSERVAÇÃO E MANUTENÇÃO DE BENS DE USO COMUM DO POVO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE MATERIAIS PARA CONSERVAÇÃO E MANUTENÇÃO DE BENS DE USO COMUM DO POVO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.98.00.00.00.0000','SENTENÇAS JUDICIAIS DE FORNECEDORES DE MATERIAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SENTENÇAS JUDICIAIS DE FORNECEDORES DE MATERIAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.1.1.99.00.00.00.0000','OUTROS MATERIAIS DE CONSUMO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE OUTROS MATERIAIS DE CONSUMO QUE NÃO SE ENQUADREM NAS RUBRICAS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.2.0.00.00.00.00.0000','DISTRIBUICAO DE MATERIAL GRATUITO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA DISTRIBUICAO DE MATERIAL GRATUITO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.2.1.00.00.00.00.0000','DISTRIBUIÇÃO DE MATERIAL GRATUITO - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA DISTRIBUICAO DE MATERIAL GRATUITO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.2.1.01.00.00.00.0000','MERCADORIAS DOADAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.2.1.02.00.00.00.0000','MATERIAL DESTINADO A ASSISTÊNCIA SOCIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MAT.DE SAUDE(FARMACOLOGICO,ODONTOLOGICO,HOSPITALAR,MEDICAMENTOS,ORTESE E PROTESE), GENEROS ALIMENTICIOS, MATER.DE CAMA, MESA, COPA, COZINHA, LIMPEZA, HIGIENIZAÇÃO, UNIFORMES, TECIDOS, AVIAMENTOS, MANUT.MOV/IMOV., FERRAMENTAS E OUTROS DISTINADOS A ASSISTÊNCIA SOCIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.2.1.03.00.00.00.0000','MATERIAL EDUCACIONAL E CULTURAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAL EDUCACIONAL,(MATERIAL ESCOLAR, DIDATICO, TECNICO, MATERIAL P/AUDIO, VIDEO E FOTO)E MATERIAL CULTURAL (MATERIAL RELIGIOSO E ESPORTIVO).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.2.1.04.00.00.00.0000','MATERIAL PARA CERIMONIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAL OFERECIDOS A TITULO DE HOMENAGEM.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.2.1.05.00.00.00.0000','MATERIAL PARA REABILITAÇÃO PROFISSIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAL OU BEM DESTINADO A SEGURADO INSCRITO EM PROGRAMA DE REABILITAÇÃO PROFISSIONAL, INDISPENSAVEIS AO DESENVOLVIMENTO DO PROCESSO DE REABILITAÇÃO, TAIS COMO: - PROTESES (APARELHOS DE SUBSTITUICAO) - ORTESES (APARELHOS DE CORRECAO OU COMPLEMENTAÇÃO) - IMPLEMENTO PROFISSIONAL (INSTRUMENTOS TECNICOS E EQUIPAMENTOS DE PROTECAO INDIVIDUAL) - MAQUINAS ACESSORIOS E FERRAMENTAS INDISPENSAVEIS PARA O DESENVOLVIMENTO DE UMA FUNÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.2.1.06.00.00.00.0000','MATERIAL PARA DIVULGAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAL PARA PUBLICIDADE E DIVULGAÇÃO DE PROGRAMAS DO GOVERNO, PARA CONSCIENTIZAÇÃO SOCIAL EX: CAMISETAS, BONES, CHAVEIROS, CANETAS, BOTONS, ETC, COM LOGOMARCAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.1.2.1.99.00.00.00.0000','OUTROS MATERIAIS DE DISTRIBUICAO GRATUITA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE MATERIAIS PARA DISTRIBUICAO GRATUITA, NÃO CONTEMPLADOS EM CONTAS ESPECIFICAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.0.0.00.00.00.00.0000','SERVIÇOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTAÇÃO DE SERVIÇOS FORNECIDA A ENTIDADE GOVERNAMENTAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.1.0.00.00.00.00.0000','DIÁRIAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE DIÁRIAS PAGAS AOS SERVIDORES, EMPREGADOS PÚBLICOS E COLABORADORES EVENTUAIS, PARA FAZER FACE A DESPESAS COM POUSADA, ALIMENTAÇÃO E LOCOMOCAO URBANA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.1.1.00.00.00.00.0000','DIÁRIAS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE DIÁRIAS PAGAS AOS SERVIDORES, EMPREGADOS PÚBLICOS E COLABORADORES EVENTUAIS, PARA FAZER FACE A DESPESAS COM POUSADA, ALIMENTAÇÃO E LOCOMOCAO URBANA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.1.1.01.00.00.00.0000','DIÁRIAS PESSOAL CIVIL','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE DIÁRIAS DE PESSOAL CIVIL,COBRINDO ALIMENTAÇÃO, POUSADA E LOCOMOCAO URBANA DO SERVIDOR PÚBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.1.1.01.01.00.00.0000','DIÁRIAS - PESSOAL CIVIL - NO PAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE DIÁRIAS DE PESSOAL CIVIL NO PAIS,COBRINDO ALIMENTAÇÃO, POUSADA E LOCOMOCAO URBANA DO SERVIDOR PÚBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.1.1.01.02.00.00.0000','DIÁRIAS - PESSOAL CIVIL - NO EXTERIOR','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE DIÁRIAS DE PESSOAL CIVIL NO EXTERIOR,COBRINDO ALIMENTAÇÃO, POUSADA E LOCOMOCAO URBANA DO SERVIDOR PÚBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.1.1.01.99.00.00.0000','DIÁRIAS - PESSOAL CIVIL - OUTRAS','REGISTRA O VALOR DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS DIÁRIAS - PESSOAL CIVIL NÃO CLASSIFICAVEIS NAS RUBRICAS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.1.1.03.00.00.00.0000','DIÁRIAS - COLABORADORES EVENTUAIS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE DIÁRIAS PAGAS A PRESTADORES DE SERVIÇOS DE CARATER EVENTUAL, SEM VINCULO COM A ADMINISTRAÇÃO PÚBLICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.1.1.03.01.00.00.0000','DIÁRIAS - COLABORADORES EVENTUAIS - NO PAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE DIÁRIAS PAGAS A PRESTADORES DE SERVIÇOS PARA A ADMINISTRAÇÃO PÚBLICA, EXCETO A SERVIDORES PÚBLICOS OU CELETISTAS. (NO PAIS)','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.1.1.03.02.00.00.0000','DIÁRIAS - COLABORADORES EVENTUAIS - NO EXTERIOR','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE DIÁRIAS PAGAS A PRESTADORES DE SERVIÇOS DE CARATER EVENTUAL, SEM VINCULO COM A ADMINISTRAÇÃO PÚBLICA (NOEXTERIOR).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.1.1.03.99.00.00.0000','DIÁRIAS - COLABORADORES EVENTUAIS - OUTRAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE OUTRAS DIÁRIAS A COLABORADORES EVENTUAIS NÃO CLASSIFICAVEIS NAS RUBRICAS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.1.1.04.00.00.00.0000','DIÁRIAS A CONSELHEIROS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE DIÁRIAS A MEMBROS DE ORGÃOS DE DELIBERAÇÃO COLETIVA (CONSELHOS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.1.1.05.00.00.00.0000','DIARIAS - PESSOAL MILITAR','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DECORRENTES DO DESLOCAMENTO DO MILITAR DA SEDE DE SUA UNIDADE POR MOTIVO DE SERVICO, DESTINADAS AA INDENIZACAO DAS DESPESAS DE ALIMENTACAO E POUSADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.0.00.00.00.00.0000','SERVIÇOS TERCEIROS - PESSOA FISICA','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTAÇÃO DE SERVIÇOS POR PESSOA FISICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICAÇÃO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIAÇÃO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVIÇOS DE TERCEIROS SE O PROPRIO ORGÃO OU ENTIDADE FORNECER A MATERIA-PRIMA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.00.00.00.00.0000','SERVIÇOS TERCEIROS - PESSOA FISICA - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTAÇÃO DE SERVIÇOS POR PESSOA FISICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICAÇÃO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIAÇÃO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVIÇOS DE TERCEIROS SE O PROPRIO ORGÃO OU ENTIDADE FORNECER A MATERIA-PRIMA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.01.00.00.00.0000','CONSULTORIA E ASSESSORIA','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.01.01.00.00.0000','CONSULTORIA E ASSESSORIA - JURIDICA E TECNICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS NAS AREAS DE CONSULTORIA TECNICA OU JURIDICA OU ASSEMELHADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.01.02.00.00.0000','CONSULTORIA E ASSESSORIA - TECNOLOGIA DA INFORMAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE CONSULTORIA OU ASSESSORIA NA AREA DE TECNOLOGIA DA INFORMAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.01.99.00.00.0000','OUTROS SERVIÇOS DE CONSULTORIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS NÃO CONTEMPLADAS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.02.00.00.00.0000','PERICIAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE PERICIAS REALIZADAS POR PROFISSIONAIS TECNICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.02.02.00.00.0000','PERICIAS MEDICA POR BENEFÍCIOS','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SERVIÇOS DE PERICIAS MEDICAS POR BENEFÍCIOS DEVIDOS AOS MEDICOS CREDENCIADOS, PARA EXAMES REALIZADOS EM SEGURADOS E/OU SERVIDORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.02.99.00.00.0000','OUTROS SERVIÇOS DE PERICIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE PERICIAS REALIZADAS POR PROFISSIONAIS TECNICOS, NÃO COMTEMPLADOS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.03.00.00.00.0000','AUDITORIA EXTERNA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE AUDITORIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.04.00.00.00.0000','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBÊNCIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBÊNCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA AÇÃO, PARA PAGAMENTO DOS HONORARIOS ADVOCATICIOS A VENCEDORA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.05.00.00.00.0000','SERVIÇOS MEDICOS E ODONTOLOGICOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS MEDICOS E ODONTOLOGICOS PRESTADOS POR PESSOA FISICA, SEM VINCULO EMPREGATICIO.CONSULTAS - RAIO X - TRATAMENTO ODONTOLOGICO - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.06.00.00.00.0000','SELEÇÃO E TREINAMENTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTAÇÃO PROFISSIONAL, RECRUTAMENTO E SELEÇÃO DE PESSOAL E TREINAMENTO, POR PESSOA FISICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.07.00.00.00.0000','COMUNICAÇÃO EM GERAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE COMUNICAÇÃO GERAL PRESTADOS POR PESSOA FISICA, TAIS COMO: CONFECCAO DE MATERIAL P/ COMUNICAÇÃO VISUAL; GERAÇÃO DE MATERIAS PARA DIVULGAÇÃO POR MEIO DOS VEICULOS DE COMUNICAÇÃO; E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.08.00.00.00.0000','LIMPEZA E CONSERVAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE LIMPEZA E CONSERVAÇÃO DE BENS IMÓVEIS.DEDETIZAÇÃO - FAXINA - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.09.00.00.00.0000','SERVIÇOS DOMESTICOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DOMESTICOS PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO, TAIS COMO: COZINHA - LAVAGEM DE ROUPAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.10.00.00.00.0000','VIGILANCIA OSTENSIVA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE VIGILANCIA OSTENSIVA NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.11.00.00.00.0000','MANUTENCAO E CONSERVAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE MANUTENCAO E CONSERVAÇÃO DE BENS MÓVEIS E IMÓVEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.11.01.00.00.0000','MANUTENCAO E CONSERVAÇÃO DE ESTRADAS E VIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE REPAROS, RECUPERAÇÕES E ADAPTAÇÕES DE ESTRADAS, FERROVIAS E RODOVIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.11.02.00.00.0000','MANUTENCAO E CONSERVAÇÃO DE BENS IMÓVEIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE REPAROS, CONSERTOS, REVISOES E ADAPTAÇÕES DE BENS IMÓVEIS. PEDREIRO, CARPINTEIRO E SERRALHEIRO - PINTURA - REPAROS EM INSTALAÇÕES ELETRICAS E HIDRAULICAS - REPAROS, RECUPERAÇÕES E ADAPTAÇÕES DE BIOMBOS, CARPETES, DIVISORIAS E LAMBRIS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.11.04.00.00.0000','MANUTENCAO E CONSERVAÇÃO DE VEICULOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE REPAROS, CONSERTOS E REVISOES DE VEICULOS. ESTOFAMENTO - FUNILARIA - INSTALAÇÃO ELETRICA - LANTERNAGEM - MECANICA - PINTURA - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.11.05.00.00.0000','MANUTENCAO E CONSERVAÇÃO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS MANUTENCAO E CONSERVAÇÃO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS - HARDWARE','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.11.06.00.00.0000','MANUTENCAO E CONSERVAÇÃO DE MAQUINAS E EQUIPAMENTOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE REPAROS, CONSERTOS, REVISOES E ADAPTAÇÕES DE: MAQUINAS E EQUIPAMENTOS GRAFICOS - APARELHOS DE FAX - APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - CALCULADORAS - ELETRODOMESTICOS - MAQUINAS DE ESCREVER- E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.11.07.00.00.0000','MANUTENCAO E CONSERVAÇÃO DE OUTROS BENS MÓVEIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE MANUTENCAO E CONSERVAÇÃO DE OUTROS BENS MÓVEIS NÃO ESPECIFICADOS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.11.99.00.00.0000','OUTROS SERVIÇOS DE MANUTENCAO E CONSERVAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE MANUTENCAO E CONSERVAÇÃO DE BENS MÓVEIS E IMÓVEIS NÃO ESPECIFICADOS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.12.00.00.00.0000','CONDOMINIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS CONDOMINIAIS A CONTA DO LOCATORIO, QUANDO PREVISTAS NO CONTRATO DE LOCAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.13.00.00.00.0000','COMISSOES E CORRETAGENS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR: CORRETORES - DESPACHANTES - LEILOEIROS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.14.00.00.00.0000','DIREITOS AUTORAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE DIREITOS AUTORAIS DE PROPRIEDADE DE TERCEIROS SOBRE OBRAS CIENTIFICAS, LITERARIAS, ETC, EM QUE A DIVULGAÇÃO SEJA DE INTERESSE DO GOVERNO. REGISTRA O VALOR REFERENTE A UTILIZAÇÃO DE SERVIÇOS DECORRENTES DE INCENTIVOS AOS AUTORES A TITULO DE ROYALTIES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.15.00.00.00.0000','SERVIÇOS TECNICOS PROFISSIONAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR PROFISSIONAIS TECNICOS, NAS SEGUINTES AREAS: ADMINISTRAÇÃO - ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA -ENGENHARIA - ESTATISTICA E OUTRAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.16.00.00.00.0000','ESTAGIÁRIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR ESTUDANTES NA CONDICAO DE ESTAGIÁRIOS OU MONITORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.19.00.00.00.0000','CONFERENCIAS, EXPOSICOES E ESPETACULOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR CONFERENCISTAS, EXPOSITORES E ARTISTAS PELOS SERVIÇOS PRESTADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.20.00.00.00.0000','ARMAZENAGEM','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE ALUGUEL DE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, OS DISPENDIOS DE GARANTIA DOS ESTOQUES ARMAZENADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.21.00.00.00.0000','LOCAÇÕES','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE LOCAÇÃO DE BENS MÓVEIS E IMÓVEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.21.01.00.00.0000','LOCAÇÃO DE IMÓVEIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE ALUGUEL DE PREDIOS, SALAS E OUTROS IMÓVEIS DE PROPRIEDADE DE PESSOA FISICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.21.02.00.00.0000','LOCAÇÃO DE BENS MÓVEIS E INTANGIVEIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE ALUGUEIS DE MAQUINAS,EQUIPAMENTOS, TELEFONE FIXO E CELULAR E OUTROS BENS MÓVEIS DE PROPRIEDADE DE PESSOA FISICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.21.03.00.00.0000','TRIBUTOS A CONTA DO LOCATARIO OU CESSIONARIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIAÇÃO DOS TRIBUTOS A CONTA DO LOCATARIO OU DO CESSIONARIO, QUANDO PREVISTOS NO CONTRATO DE LOCAÇÃO OU CESSAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.22.00.00.00.0000','FORNECIMENTO DE ALIMENTAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE REFEICOES PREPARADAS, INCLUSIVE LANCHES E SIMILARES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.24.00.00.00.0000','SERVIÇOS DE REABILITAÇÃO PROFISSIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE REABILITAÇÃO PROFISSIONAL PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO, COMO OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE) OS MEIOS INDICADOS PARA A REEDUCAÇÃO E READAPTAÇÃO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO. EX: CONTRATAÇÃO DE PROFISSIONAL PARA MINISTRAR CURSO PROFISSIONALIZANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.25.00.00.00.0000','SERVIÇOS DE ASSISTÊNCIA SOCIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE ASSISTÊNCIA SOCIAL PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO A SERVIDORES, SEGURADOS CARENTES, ABRIGADOS, INTERNADOS E A SEUS DEPENDENTES,TAIS COMO AJUDA DE CUSTO SUPLETIVA, GENEROS ALIMENTICIOS, DOCUMENTAÇÃO, TRANSPORTE E SEPULTAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.26.00.00.00.0000','SERVIÇO DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE NATUREZA EVENTUAL PRESTADOS POR PESSOA FISICA, TAIS COMO: ASSISTÊNCIA TECNICA - CAPINA - JARDINAGEM - OPERADORES DE MAQUINAS E MOTORISTAS - RECEPCIONISTAS - SERVIÇOS AUXILIARES - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.27.00.00.00.0000','SERVIÇO DE CONSERVAÇÃO E REBENEFICIAMENTO DE MERCADORIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE NATUREZA EVENTUAL PRESTADOS POR PESSOA FISICA NA CONSERVAÇÃO E REBENEFICIAMENTO DE MERCADORIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.28.00.00.00.0000','CONFECCAO DE MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR PESSOA FISICA NA CONFECCAO DE: BOLSAS - CAIXAS - MOCHILAS - SACOLAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.29.00.00.00.0000','CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE COSTUREIRAS, ALFAIATES E AFINS UTILIZADOS NA CONFECCAO DE UNIFORMES, BANDEIRAS, FLAMULAS, BRASOES E ESTANDARTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.30.00.00.00.0000','FRETES E TRANSPORTES DE ENCOMENDAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR PESSOA FISICA EM: FRETES E CARRETOS - REMESSA DE ENCOMENDAS - TRANSPORTE DE MERCADORIAS E PRODUTOS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.31.00.00.00.0000','JETONS E GRATIFICAÇÕES A CONSELHEIROS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA PARTICIPAÇÃO EM ORGÃOS DE DELIBERAÇÕES COLETIVAS(CONSELHOS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.34.00.00.00.0000','SERVIÇOS DE AUDIO, VIDEO E FOTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE FILMAGENS, GRAVAÇÕES E FOTOGRAFIAS, PRESTADOS POR PESSOA FISICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.35.00.00.00.0000','SERVICOS JUDICIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE CUSTAS PROCESSUAIS DECORRENTES DE ACOES JUDICIAIS, DILIGENCIAS(INCLUSIVE CONDUCAO) SALARIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E SERVICOS DE CARTORIO, QUANDO A NOTA E EMITIDA EM NOME DO TABELIAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.36.00.00.00.0000','SEGUROS EM GERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE PREMIOS PAGOS POR SEGUROS DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS OU BENS DE TERCEIROS, PREMIOS DE SEGUROS DE BENS DO ESTADO OU DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.37.00.00.00.0000','HOSPEDAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE HOSPEDAGENS DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS, A LOCAIS ONDE NAO EXISTEM ESBELECIMENTOS COMERCIAIS HABILITADOS EM PRESTAR ESSE TIPO DE SERVICOS, PAGOS DIRETAMENTE A PESSOAS FISICAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.38.00.00.00.0000','DESPESAS COM LOCOMOCAO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE MEIOS DE TRANSPORTES AEREOS,TERRESTRES, FLUVIAIS OU MARITIMAS, LOCAÇÃO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.38.01.00.00.0000','LOCAÇÃO DE MEIOS DE TRANSPORTE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA LOCAÇÃO DE MEIOS DE TRANSPORTE, TAIS COMO: VEICULOS, AERONAVES, EMBARCAÇÕES E ASSEMELHADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.38.03.00.00.0000','LOCOMOCAO URBANA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE MEIO DE TRANSPORTE URBANO, COMO: ONIBUS, TAXI E OUTROS VEICULOS DE TRANSPORTES URBANOS,PARA ATENDER NECESSIDADE DO SERVICO, COMPREENDENDO, TAMBEM, DESLOCAMENTOS PARA REALIZAÇÃO DE PESQUISAS E REEMBOLSO COM TRANSPORTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.38.99.00.00.0000','OUTRAS DESPESAS COM LOCOMOCAO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE MEIOS DE TRANSPORTES NÃO ESPECIFICADOS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.39.00.00.00.0000','SERVIÇOS GRAFICOS E EDITORIAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM SERVIÇOS DE ARTES GRAFICAS PRESTADOS POR PESSOA FISICA, BEM COMO COM SERVIÇOS EDITORIAIS DIVERSOS. - CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNAÇÃO DE LIVROS JORNAIS E REVISTAS - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICAÇÃO DE IMPRESSOS - SERVIÇOS DE IDENTIFICAÇÃO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVIÇOS EDITORIAIS DIVERSOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.40.00.00.00.0000','BOLSA DE INICIAÇÃO AO TRABALHO','REGISTRA O VALOR DAS VPAS COM REMUNERAÇÃO A CANDIDATOS PARTICIPANTES DE CURSO DE FORMAÇÃO PARA O EXERCÍCIO DE CARGO DECORRENTE DE CONCURSO PÚBLICO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.2.1.99.00.00.00.0000','OUTROS SERVIÇOS PRESTADOS POR PESSOA FISICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE OUTROS SERVIÇOS PRESTADOS POR PESSOA FISICA, NÃO CONTEMPLADOS EM ITENS ESPECIFICOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.0.00.00.00.00.0000','SERVIÇOS TERCEIROS - PESSOA JURIDICA','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTAÇÃO DE SERVIÇOS POR PESSOA JURIDICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICAÇÃO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIAÇÃO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVIÇOS DE TERCEIROS SE O PROPRIO ORGÃO OU ENTIDADE FORNECER A MATERIA-PRIMA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.00.00.00.00.0000','SERVIÇOS TERCEIROS - PESSOA JURIDICA - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTAÇÃO DE SERVIÇOS POR PESSOA JURIDICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICAÇÃO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIAÇÃO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVIÇOS DE TERCEIROS SE O PROPRIO ORGÃO OU ENTIDADE FORNECER A MATERIA-PRIMA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.01.00.00.00.0000','CONSULTORIA E ASSESSORIA','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.01.01.00.00.0000','CONSULTORIA E ASSESSORIA - JURIDICA E TECNICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS NAS AREAS DE CONSULTORIA TECNICA OU JURIDICA OU ASSEMELHADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.01.02.00.00.0000','CONSULTORIA E ASSESSORIA - TECNOLOGIA DA INFORMAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE CONSULTORIA OU ASSESSORIA NA AREA DE TECNOLOGIA DA INFORMAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.01.99.00.00.0000','OUTROS SERVIÇOS DE CONSULTORIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS NÃO CONTEMPLADAS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.02.00.00.00.0000','PERICIAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.02.02.00.00.0000','PERICIAS MEDICA, ODONTOLOGICA POR BENEFÍCIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTESS DA UTILIZAÇÃO DE SERVIÇOS DE PERICIAS MEDICAS/ODONTO.POR BENEFICIO, DEVIDAS A ENTIDADES MEDICAS/ODONTOLOGICAS CREDENCIADAS,PARA EXAMES REALIZADOS EM SEGURADOS E/OU SERVIDORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.02.99.00.00.0000','OUTROS SERVIÇOS DE PERICIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS, NÃO CONTEMPLADAS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.03.00.00.00.0000','AUDITORIA EXTERNA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE AUDITORIA EXTERNA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.04.00.00.00.0000','COMUNICAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE COMUNICAÇÃO, PRESTADOS POR PESSOA JURIDICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.04.01.00.00.0000','TELECOMUNICAÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE TELECOMUNICAÇÃO, INCLUSIVE TELEFONIA CELULAR, TARIFA DE HABILITAÇÃO E CARTOES TELEFONICOS PARA APARELHOS DE CELULAR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.04.02.00.00.0000','CORRESPONDENCIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE CORRESPONDECIAS, PRESTADOS POR PESSOA JURIDICA, TAIS COMO: CORREIOS E TELEGRAFOS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.04.03.00.00.0000','COMUNICAÇÃO DE DADOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE COMUNICAÇÃO DE DADOS: INTERNET ETC','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.04.99.00.00.0000','OUTROS SERVIÇOS DE COMUNICAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE COMUNICAÇÃO, PRESTADOS POR PESSOA JURIDICA, NÃO COMTEMPLADOS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.05.00.00.00.0000','PUBLICIDADE','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE PUBLICIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.05.01.00.00.0000','PUBLICIDADE LEGAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE PUBLICIDADE LEGAL, QUE SE REALIZA EM OBEDIENCIA A PRESCRICAO DE LEIS, DECRETOS, PORTARIAS, INSTRUCOES, ESTATUTOS, REGIMENTOS OU REGULAMENTOS INTERNOS DOS INTEGRANTES DO SISTEMA DE COMUNICAÇÃO DE GOVERNO, PRESTADOS POR PESSOA JURIDICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.05.02.00.00.0000','PUBLICIDADE DE UTILIDADE PÚBLICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE PUBLICIDADE REFERENTES A DIVULGAÇÃO DE AÇÕES DESTINADAS A INFORMAR, ESCLARECER, ORIENTAR, MOBILIZAR, PREVINIR OU ALERTAR A POPULAÇÃO COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE E DE ESTIMULAR A ADOCAO DE COMPORTAMENTOS QUE PERMITAM MELHORAR SUA QUALIDADE DE VIDA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.05.03.00.00.0000','PUBLICIDADE INSTITUCIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE PUBLICIDADE, PESQUISAS,ASSESSORIA DE IMPRENSA, RELAÇÕES PÚBLICAS E COMUNICAÇÃO DIGITAL REFERENTES A DIVULGAÇÃO DE ATOS, AÇÕES, PROGRAMAS, OBRAS, SERVIÇOS, CAMPANHAS METAS E RESULTADOS DOS ORGÃOS E ENTIDADES GOVERNAMENTAIS, COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE, VALORIZAR E FORTALECER AS INSTITUICOES, ESTIMULAR A PARTICIPAÇÃO SOCIAL NO DEBATE, NO CONTROLE E NA FORMULAÇÃO DE POLITICAS PÚBLICAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.05.99.00.00.0000','OUTROS SERVIÇOS DE PUBLICIDADE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE PUBLICIDADE, NÃO COMTEMPLADOS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.06.00.00.00.0000','MANUTENCAO E CONSERVAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE MANUTENCAO DE BENS MÓVEIS E IMÓVEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.06.01.00.00.0000','MANUTENÇÃO E CONSERVAÇÃO DE ESTRADAS E VIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE REPAROS, RECUPERAÇÕES E ADAPTAÇÕES DE ESTRADAS, FERROVIAS E RODOVIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.06.02.00.00.0000','MANUTENÇÃO E CONSERVAÇÃO DE BENS IMÓVEIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE REPAROS, CONSERTOS, REVISOES E ADAPTAÇÕES DE BENS IMÓVEIS. PINTURA - REPAROS E REFORMAS DE IMÓVEIS EM GERAL - REPAROS EM INSTALAÇÕES ELETRICAS E HIDRAULICAS - REPAROS, RECUPERAÇÕES E ADAPTAÇÕES DE BIOMBOS, CARPETES, DIVISORIAS E LAMBRIS - MANUTENCAO DE ELEVADORES -LIMPEZA DE FOSSA - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.06.04.00.00.0000','MANUTENÇÃO E CONSERVAÇÃO DE VEICULOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE REPAROS, MANUTENCAO, CONSERTOS, CONSERVAÇÃO E REVISOES DE VEICULOS, TAIS COMO: ALINHAMENTO E BALANCEAMENTO - ESTOFAMENTO - FUNILARIA - INSTALAÇÃO ELETRICA - LANTERNAGEM - MECANICA - PINTURA - FRANQUIA E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.06.05.00.00.0000','MANUTENÇÃO E CONSERVAÇÃO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE MANUTENCAO E CONSERVAÇÃO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS - HARDWARE','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.06.06.00.00.0000','MANUTENÇÃO E CONSERVAÇÃO DE MAQUINAS E EQUIPAMENTOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE COM SERVIÇOS DE REPAROS, CONSERTOS, REVISOES E ADAPTAÇÕES DE MAQUINAS E EQUIPAMENTOS. APARELHOS DE FAX E TELEX - APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - CALCULADORAS -ELETRODOMESTICOS - EQUIPAMENTOS DE PROTECAO E SEGURANCA - EQUIPAMENTOS GRAFICOS - EQUIPAMENTOS AGRICOLAS - MAQUINAS DE ESCREVER - TURBINAS EOUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.06.07.00.00.0000','MANUTENÇÃO E CONSERVAÇÃO DE SOFTWARE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS, ATUALIZAÇÃO E ADAPTAÇÃO DE SOFTWARE, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTAÇÃO (CORRETIVA, PREVENTIVA E ADAPTATIVA) DE SOFTWARE E RENOVAÇÃO DE LICENCA DE USO DE SOFTWARE','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.06.08.00.00.0000','MANUTENÇÃO E CONSERVAÇÃO DE OUTROS BENS MÓVEIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE REPAROS, CONSERTOS, REVISOES, INSPECOES E ADAPTAÇÕES DE BENS MÓVEIS NÃO CONTEMPLADOS EM ITENS ESPECIFICOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.06.99.00.00.0000','OUTROS SERVIÇOS DE MANUTENCAO E CONSERVAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE MANUTENCAO DE BENS MÓVEIS E IMÓVEIS, NÃO COMTEMPLADOS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.07.00.00.00.0000','SERVIÇOS DE APOIO','COMPRENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGÃOS PÚBLICOS, NOS CASOS EM QUE O CONTRATO NÃO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.07.01.00.00.0000','APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGÃOS PÚBLICOS, NOS CASOS EM QUE O CONTRATO NÃO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ASSISTÊNCIA TECNICA - COMISSARIA AEREA E APOIO SOLO - JARDINAGEM- OPERADORES DE MAQUINAS E MOTORISTAS - RECEPCIONISTAS - INSTALAÇÕES DE EQUIPAMENTOS DE SEGURANCA - DA REDE ELETRICA - REDE HIDRAULICA - TELEFONIA - COMUNICAÇÃO E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.07.02.00.00.0000','LIMPEZA E CONSERVAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERV. DE LIMPEZA,HIGIENIZAÇÃO, COLETA DE LIXO, RETIRADA DE ENTULHO,CONSERV.DEDETIZAÇÃO E ASSEIO DOS ORGÃOS PÚBLICOS (NOS CASOS EM QUE O CONTRATO NÃO ESPECIFIQUE O QUANTITATIVOFISICO DO PESSOAL A SER UTILIZADO).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.07.03.00.00.0000','VIGILANCIA OSTENSIVA/ MONITORADA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE VIGILANCIA E SEGURANCA DE REPARTICOES PÚBLICAS, DE AUTORIDADES (NOS CASOS EM QUE O CONTRATO NÃO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO),DESPESA COM MONITORAMENTO ELETRONICO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.07.05.00.00.0000','SERVIÇOS DE SOCORRO E SALVAMENTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS PARA PROTECAO,SOCORRO E SALVAMENTO DE PESSOAS E BENS PÚBLICOS.SERVIÇOS PRESTADOS POR: - AMBULANCIAS PARTICULARES - U.T.I MÓVEIS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.07.07.00.00.0000','SERVIÇOS DOMESTICOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DOMESTICOS PRESTADOS POR PESSOA JURIDICA, SEM VINCULO EMPREGATICIO, TAIS COMO: COZINHA - LAVAGEM DE ROUPAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.07.99.00.00.0000','OUTROS SERVIÇOS DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGÃOS PÚBLICOS, NOS CASOS EM QUE O CONTRATO NÃO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO, NÃO COMTEMPLADOS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.08.00.00.00.0000','SERVIÇOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','COMPRENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.08.01.00.00.0000','SERVIÇOS DE AGUA E ESGOTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE AGUA E ESGOTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.08.02.00.00.0000','SERVIÇOS DE ENERGIA ELETRICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE ENERGIA ELETRICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.08.03.00.00.0000','SERVIÇOS DE GAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVICO DE GAS CANALIZADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.08.99.00.00.0000','OUTROS SERVIÇOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE OUTROS SERVIÇOS NÃO ENQUADRADOS NAS CONTAS ACIMA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.09.00.00.00.0000','SERVIÇOS DE ALIMENTAÇÃO','COMPRENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE FORNECIMENTO DE ALIMENTAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.09.02.00.00.0000','FORNECIMENTO DE ALIMENTAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVICO DE FORNECIMENTO DE REFEICOES PREPARADAS, INCLUSIVE LANCHES E SIMILARES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.10.00.00.00.0000','LOCAÇÕES','COMPRENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE LOCAÇÃO DE BENS MÓVEIS, IMÓVEIS OU INTAGIVEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.10.01.00.00.0000','LOCAÇÃO DE IMÓVEIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE PREDIOS, SALAS E OUTROS IMÓVEIS DE INTERESSE DA ADMINISTRAÇÃO PÚBLICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.10.02.00.00.0000','LOCAÇÃO DE SOFTWARE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE PROGRAMAS DE PROCESSAMENTO DE DADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.10.03.00.00.0000','LOCAÇÃO DE MAQUINAS E EQUIPAMENTOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVASCOM ALUGUEIS DE MAQUINAS E EQUIPAMENTOS, TAIS COMO: APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - APARELHOS TELEFONICOS, TELES E FAX -CALCULADORAS - ELETRODOMESTICOS - EQUIPAMENTOS GRAFICOS - MAQUINAS DE ESCREVER - TURBINAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.10.04.00.00.0000','LOCAÇÃO DE BENS MÓVEIS DE OUTRAS NATUREZAS E INTANGIVEIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE BENS MÓVEIS NÃO CONTEMPLADOS EM ITENS ESPECIFICOS E BENS INTANGIVEIS. LOCAÇÃO DE LINHA TELEFONICA - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.10.05.00.00.0000','LOCAÇÃO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E PERIFERICOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.10.06.00.00.0000','TRIBUTOS A CONTA DO LOCATARIO OU CESSIONARIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIAÇÃO DOS TRIBUTOS A CONTA DO LOCATARIO OU DO CESSIONARIO, QUANDO PREVISTOS NO CONTRATO DE LOCAÇÃO OU CESSAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.11.00.00.00.0000','SERVIÇOS RELACIONADOS A TECNOLOGIA DA INFORMAÇÃO','COMPRENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE PROCESSAMENTO DE DADOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NA AREA DE INFORMATICA; ATUALIZAÇÃO E ADAPTAÇÃO DE PROGRAMAS DE PROCESSAMENTO DE DADOS; SUPORTE TECNICO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS,ANALISE P/ACRESCENTAR NOVAS FUNCOES, HOSPEDAGEM DE SISTEMAS E OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.11.01.00.00.0000','DESENVOLVIMENTO DE SOFTWARE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE ATUALIZAÇÃO E ADAPTAÇÃO DE SOFTWARE, COM ACRESCIMO DE FUNCOES (EVOLUTIVAS)','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.11.02.00.00.0000','SUPORTE DE INFRAESTRUTURA DE T.I.','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE OPERAÇÃO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.11.03.00.00.0000','SUPORTE A USUARIOS DE T.I.','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS AO ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVIÇOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVIÇOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVIÇOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.11.04.00.00.0000','HOSPEDAGEM DE SISTEMAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE DATACENTER POR MODELOS COMO HOSTING OU COLOCATION.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.11.05.00.00.0000','SERVIÇOS TECNICOS PROFISSIONAIS DE T.I.','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR PROFISSIONAIS TECNICOS NA AREA DE TECNOLOGIA DA INFORMAÇÃO, EXCETO QUANDO FOREM CLASSIFICADO EM UMA DAS SEGUINTES CONTAS: DESENVOLVIMENTO DE SOFTWARE; SUPORTE DE INFRAESTRUTURA DE T.I.; SUPORTE A USUARIOS DE T.I.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.12.00.00.00.0000','SERVIÇOS DE TRANSPORTE','COMPRENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE TRANSPORTE DE SERVIDORES, TRABALHADORES DE UMA ENTIDADE OU DE MERCADORIAS E PRODUTOS DIVERSOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.12.01.00.00.0000','VALE- TRANSPORTE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS DEVIDO AO FORNECIMENTO DE VALE-TRANSPORTE PARA OS TRABALHADORES DE UMA ENTIDADE, TAIS COMO, SERVIDORES, EMPREGADOS, ESTAGIÁRIOS, ENTRE OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.12.02.00.00.0000','TRANSPORTE DE SERVIDORES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUÇÃO DE TAREFAS PELOS SERVIDORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.12.03.00.00.0000','FRETE E TRANSPORTE DE ENCOMENDAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE TRANSPORTE DE MERCADORIAS E PRODUTOS DIVERSOS, PRESTADOS POR PESSOA JURIDICA.- FRETES E CARRETOS - REMESSA DE ENCOMENDAS E OUTRAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.13.00.00.00.0000','ARMAZENAGEM','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE ALUGUELDE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, AS VARIAÇÕES PROVENIENTESS DE GARANTIA DOS ESTOQUES ARMAZENADOS E A UTILIZAÇÃO DE SERVICO ESPECIALIZADO NA SOLUCAO DE GESTAO DE ESTOQUE, INCLUINDO GESTAO DE MATERIAIS E TRANSPORTE DE MATERIAIS E EQUIPAMENTOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.14.00.00.00.0000','ASSINATURAS DE PERIODICOS E ANUIDADES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE ASSINATURAS DE TV (TVA CABO), JORNAIS, INCLUSIVE DIARIO OFICIAL, REVISTAS, RECORTES DE PÚBLICAÇÕES, SOFTWARE, PODENDO ESTAR NA FORMA DE DISQUETE, CD-ROM, BOLE-INS E OUTROS QUE NÃO SE DESTINEM A COLECOES OU BIBLIOTECAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.17.00.00.00.0000','COMISSOES E CORRETAGENS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIAÇÃO DE VALOR REFERENTE A COMISSOES E CORRETAGENS DECORRENTES DE SERVIÇOS PRESTADOS POR EMPRESAS DE INTERMEDIAÇÃO E REPRESENTAÇÃO COMERCIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.18.00.00.00.0000','CONDOMINIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIAÇÃO DAS TAXAS CONDOMINIAIS A CONTA DO PROPRIETARIO, OU DO LOCATARIO, CONFORME PREVISTO NO CONTRATO DE LOCAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.19.00.00.00.0000','CONFECCAO DE MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE CONFECCAO DE MATERIAIS DESTINADOS A PRESERVAÇÃO, ACOMODAÇÃO OU EMBALAGEM DE PRODUTOS DIVERSOS, TAIS COMO:- BOLSAS - CAIXAS - MOCHILAS - SACOLAS E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVIÇOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.20.00.00.00.0000','CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE CONFECCAO DE:- BANDEIRAS - BRASOES - ESTANDARTES - FLAMULAS - UNIFORMES (INCLUSIVEAS DESPESAS RELACIONADAS COM AUXÍLIO FARDAMENTO DESCRITOS NA LEI NUM.8237/91) E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVIÇOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.21.00.00.00.0000','DIREITOS AUTORAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE DIREITOS AUTORAIS SOBRE OBRAS CIENTIFICAS, LITERARIAS OU EM QUE A DIVULGAÇÃO SEJA DE INTERESSE DO GOVERNO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.22.00.00.00.0000','EXPOSICOES, CONGRESSOS, CONFERENCIAS E OUTROS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVIÇOS UTILIZADOS NA INSTALAÇÃO E MANUTENCAO DE: CONFERENCIAS - REUNIOES TECNICAS - CONGRESSOS - EXPOSICOES - FEIRAS - FESTEJOS POPULARES - FESTIVAIS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.23.00.00.00.0000','FESTIVIDADES E HOMENAGENS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVIÇOS UTILIZADOS NA ORGANIZAÇÃO DE EVENTOS, TAIS COMO: COQUETEIS - FESTAS DE CONGRACAMENTO - RECEPCOES - E OUTRAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.24.00.00.00.0000','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBÊNCIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIAÇÃO DOS HONORARIOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBÊNCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA AÇÃO, PARA PAGAMENTO DOS HONORARIOS ADVOCATICIOS A VENCEDORA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.25.00.00.00.0000','HOSPEDAGENS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE HOSPEDAGENS E ALIMENTAÇÃO DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS OFICIAIS PAGOS DIRETAMENTE A ESTABELECIMENTOS HOTELEIROS (QUANDO NÃO HOUVER PAGAMENTO DE DIÁRIAS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.26.00.00.00.0000','PATROCINIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE PATROCINIOS A ATIVIDADES OU EVENTOS, DE NATUREZA CULTURAL, ESPORTIVA, EDUCACIONAL, AMBIENTAL, CIENTIFICA, COMUNITARIA, PROMOCIONAL ETC. PARA INFLUENCIAR FAVORAVELMENTE O PÚBLICO E/OU ATINGIR OUTROS OBJETIVOS RELACIONADOS COM A PROMOCAO DE ATOS, OBRAS, PLANOS, AÇÕES, BENS OU SERVIÇOS. NÃO INCLUI O PATROCINIO DE MIDIA, ASSIM CONSIDERADOS AQUELES EM QUE O PROPONENTE E UM VEICULO DE COMUNICAÇÃO OU UM GESTOR DE MEIOS OU INSTALAÇÕES QUE FUNCIONEM COMO VEICULO DE MIDIA ALTERNATIVA E AQUELES EM QUE UM VEICULO DE COMUNICAÇÃO E O UNICO OU O PRINCIPAL REALIZADOR DA AÇÃO PATROCINADA, AINDA QUE O PROPONENTE DO PROJETO E PROVEDOR DE CONTEUDO PARA A AÇÃO PATROCINADA NÃO SE ENQUADRE NA DEFINICAO DE VEICULO DE COMUNICAÇÃO OU MEIO DE MIDIA ALTERNATIVA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.27.00.00.00.0000','PRODUCOES JORNALISTICAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE EDICAO DE JORNAIS, REVISTAS, NOTICIARIOS E MATERIAIS JORNALISTICOS PARA VIDEOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.29.00.00.00.0000','SEGUROS EM GERAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIAÇÃO DE PREMIOS PAGOS POR SEGUROS DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS OU BENS DE TERCEIROS, PREMIOS DE SEGUROS DE BENS DO ESTADO OU DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.30.00.00.00.0000','SELEÇÃO E TREINAMENTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTAÇÃO PROFISSIONAL, RECRUTAMENTO E SELEÇÃO DE PESSOAL (CONCURSO PÚBLICO) E TREINAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.31.00.00.00.0000','SERVIÇO MEDICO-HOSPITALAR,ODONTOLÓGICO E LABORATORIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS MEDICO-HOSPITALARES, ODONTOLOGICOS E LABORATORIAIS, PRESTADOS POR PESSOAS JURIDICAS SEM VINCULO EMPREGATICIO, TAIS COMO: ANALISES CLINICAS - CIRURGIAS - CONSULTAS - ECOGRAFIAS - ENDOSCOPIAS -ENFERMAGEM - ESTERILIZAÇÃO - EXAMES DE LABORATORIO - RAIO X -TOMOGRAFIAS - TRATAMENTO ODONTOLOGICO - ULTRASSONOGRAFIAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.32.00.00.00.0000','SERVIÇOS BANCARIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIAÇÃO DE COMISSOES, TARIFAS E REMUNERAÇÕES DECORRENTES DE SERVIÇOS PRESTADOS POR BANCOS E OUTRAS INSTITUICOES FINANCEIRAS, BEM COMO DESPESAS COM AGUARDA/CUSTODIA DE VALORES (COFRES DE ALUGUEL).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.33.00.00.00.0000','SERVIÇOS DE ANALISES E PESQUISA CIENTIFICAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE ANALISES FISICO-QUIMICAS E PESQUISAS CIENTIFICAS, NÃO RELACIONADAS COM APOIO AO ENSINO - ANALISES MINERAIS - ANALISES DE SOLO - ANALISES QUIMICAS - COLETA DE DADOS EM EXPERIMENTOS - TRATAMENTO E DESTINAÇÃO DE RESIDUOS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.34.00.00.00.0000','SERVIÇOS DE APOIO DO ENSINO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS COM O OBJETIVO DE PROPORCIONAR O DESENVOLVIMENTO E O APERFEICOAMENTO DO ENSINO, EM TODOS OS NIVEIS, INCLUSIVE PESQUISAS EXPERIENCIAS E ASSEMELHADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.35.00.00.00.0000','SERVIÇOS DE ASSISTÊNCIA SOCIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVIÇOS DE ASSISTÊNCIA SOCIAL PRESTADA A SERVIDORES, SEGURADOS CARENTES, ABRIGADOS, INTERNADOS E A SEUS DEPENDENTES, TAIS COMO:- AJUDA DE CUSTO SUPLETIVA - GENEROS ALIMENTICIOS - DOCUMENTAÇÃO - TRANSPORTE E SEPULTAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.36.00.00.00.0000','SERVIÇOS DE AUDIO VIDEO E FOTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE FILMAGENS, GRAVAÇÕES, REVELAÇÕES, AMPLIAÇÕES E REPRODUCOES DE SONS E IMAGENS - CONFECCAO DE ALBUNS - CONFECCAO DE CRACHAS FUNCIONAIS POR FIRMAS ESPECIALIZADAS - EMOLDURAMENTO DE FOTOGRAFIAS - IMAGENS DE SATELITES - REVELAÇÃO DE FILMES - MICROFILMAGEM E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.37.00.00.00.0000','SERVIÇOS DE CONFECÇÃO SELOS CONTROLE FISCAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE CONFECCAO DE SELOS/CHANCELAS PARA CONTROLE FISCAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.38.00.00.00.0000','SERVIÇOS DE CONSERV. E REBENEF. DE MERCADORIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS UTILIZADOS NA CONSERVACAO E REBEFICIAMENTO DE MERCADORIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.40.00.00.00.0000','SERVIÇOS DE CONTROLE AMBIENTAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE CONTROLE AMBIENTAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.41.00.00.00.0000','SERVIÇOS DE COPIAS E REPRODUCAO DE DOCUMENTOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE COPIAS XEROGRAFICAS, INCLUSIVE A LOCAÇÃO E A MANUTENCAO DE EQUIPAMENTOS REPROGRAFICOS, COPIASE REPRODUCOES DE DOCUMENTOS E PÚBLICAÇÕES EM GERAL, INCLUSIVE POR MEIO MAGNETICO E DIGITALIZAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.42.00.00.00.0000','SERVIÇOS DE CRECHE E ASSISTÊNCIA PRE ESCOLAR','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR ENTIDADES DE ASSISTÊNCIA SOCIAL PARA ATENDER OS DEPENDENTES DE SERVIDORES DO ORGÃO, HABILITADOS A USUFRUIREM DESSE BENEFICIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.43.00.00.00.0000','SERVIÇOS DE PRODUÇÃO INDUSTRIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS DE TRANSFORMACAO, BENEFICIAMENTO E INDUSTRIALIZACAO DE MATÉRIAS-PRIMAS QUE RESULTARAO EM UM PRODUTO FINAL. SOMENTE SERAO CLASSIFICADOS COMO SERVIÇOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.45.00.00.00.0000','SERVIÇOS DE REABILITAÇÃO PROFISSIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE REABILITAÇÃO PROFISSIONAL PRESTADOS POR PESSOA JURIDICA, COM O OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE), OS MEIOS INDICADOS PARA A REEDUCAÇÃO E READAPTAÇÃO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO.EX: CONTRATAÇÃO DE EMPRESA PARA MINISTRAR CURSO PROFISSIONALIZANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.47.00.00.00.0000','SERVIÇOS FUNERARIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE REMOCOES, SEPULTAMENTOS E TRANSLADAÇÕES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.48.00.00.00.0000','SERVIÇOS GRAFICOS E EDITORIAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE ARTES GRAFICAS PRESTADOS POR PESSOA JURIDICA, BEM COMO COM SERVIÇOS EDITORIAIS DIVERSOS.- CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNAÇÃO DE LIVROS JORNAIS E REVISTAS - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICAÇÃO DE IMPRESSOS - SERVIÇOS DE IDENTIFICAÇÃO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVIÇOS EDITORIAIS DIVERSOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.49.00.00.00.0000','SERVIÇOS JUDICIARIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIAÇÃO DE CUSTAS PROCESSUAIS DECORRENTES DE AÇÕES JUDICIAIS, DILIGENCIAS (INCLUSIVE CONDUCAO) SALÁRIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E OFICIAIS DE JUSTICA E SERVIÇOS DE CARTORIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.51.00.00.00.0000','SERVIÇOS TECNICOS PROFISSIONAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NAS SEGUINTES AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA - ESTATISTICA E OUTRAS. EXCETO OS SERVIÇOS DE CONSULTORIA QUE DEVEM SER CLASSIFICADOS EM CONTA ESPECIFICA .','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.52.00.00.00.0000','TAXA DE ADMINISTRAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE ORGANIZAÇÃO E ADMINISTRAÇÃO PRESTADOS POR PESSOA JURIDICA, TAIS COMO: TAXA DE ADMINISTRAÇÃO PAGA DECORRENTE DOS SERVIÇOS DE SELEÇÃO E RECRUTAMENTO DE ESTUDANTES, TENDO COMO OBJETIVO O INGRESSO AO MERCADO DE TRABALHO E PROGRAMAS DE ESTÁGIO; E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.54.00.00.00.0000','LOCAÇÃO DE MAO-DE-OBRA','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR PESSOAS JURIDICAS PARA ORGÃOS PÚBLICOS, TAIS COMO LIMPEZA E HIGIENE, VIGILANCIA OSTENSIVA E OUTROS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.54.01.00.00.0000','LOCAÇÃO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS APOIO ADMINISTRATIVO, OPERACIONAL E ASSISTÊNCIA TECNICA NECESSARIOS A MANUTENCAO DAS ATIVIDADES DO ORGÃO, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ASSISTÊNCIA TECNICA - CAPINA - JARDINAGEM - OPERADORES DE MAQUINA - MOTORISTAS - RECEPCIONISTAS - SERVIÇOS AUXILIARES E OUTROS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.54.02.00.00.0000','LOCAÇÃO DE MAO-DE-OBRA DE LIMPEZA E CONSERVAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE LIMPEZA E CONSERVAÇÃO EM GERAL, TAIS COMO: LIMPEZA E CONSERVAÇÃO DE IMÓVEIS, LAVAGEM DE VEICULOS, LAVAGEM E HIGIENIZAÇÃO DE ROUPAS E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL A SER UTILIZADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.54.03.00.00.0000','LOCAÇÃO DE MAO-DE-OBRA DE VIGILANCIA OSTENSIVA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE VIGILANCIA OSTENSIVA NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.54.04.00.00.0000','LOCAÇÃO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVAÇÃO DE BENS IMÓVEIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE LOCAÇÃO DE MAO-DE-OBRA PARA EFETUAR REPAROS E REFORMAS DE IMÓVEIS EM GERAL, INSTAL. ELETRICAS, HIDRAUL. E CORRELATAS DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DE PESSOAL A SER UTILIZADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.54.05.00.00.0000','LOCAÇÃO DE MAO-DE-OBRA DE SERVIÇOS DE COPA E COZINHA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE LOCAÇÃO DE MAO-DE-OBRA PARA EFETUAR SERVIÇOS INERENTES A COPA E COZINHA, TAIS COMO: PREPARO DE ALIMENTAÇÃO, LANCHES, CAFE E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.54.06.00.00.0000','LOCAÇÃO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVAÇÃO DE BENS MÓVEIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS DE MANUTENCAO DE BENS MÓVEIS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.54.09.00.00.0000','LOCAÇÃO DE MAO-DE-OBRA DE MANUTENCAO DE SOFTWARE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS, ATUALIZAÇÃO E ADAPTAÇÃO DE SOFTWARE, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTAÇÃO (CORRETIVA, PREVENTIVA E ADAPTATIVA) DE SOFTWARE E RENOVAÇÃO DE LICENCA DE USO DE SOFTWARE','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.54.10.00.00.0000','LOCAÇÃO DE MAO-DE-OBRA DE SUPORTE DE INFRAESTRUTURA DE T.I.','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE OPERAÇÃO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.54.11.00.00.0000','LOCAÇÃO DE MAO-DE-OBRA DE SUPORTE A USUARIOS DE T.I.','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZAÇÃO DE SERVIÇOS DE ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVIÇOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVIÇOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVIÇOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.54.99.00.00.0000','OUTRAS LOCAÇÕES DE MAO DE OBRA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE OUTROS SERVIÇOS DE LOCAÇÕES DE MAO-DE-OBRA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.55.00.00.00.0000','ARRENDAMENTO MERCANTIL OPERACIONAL','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL OPERACIONAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.55.01.00.00.0000','ARRENDAMENTO MERCANTIL OPERACIONAL DE MAQUINAS E APARELHOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE MAQUINAS E APARELHOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.55.03.00.00.0000','ARRENDAMENTO MERCANTIL OPERACIONAL DE VEICULOS RODOVIARIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE VEICULOS RODOVIARIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.55.04.00.00.0000','ARRENDAMENTO MERCANTIL OPERACIONAL DE OUTROS BENS MÓVEIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE OUTROS BENS MÓVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.55.05.00.00.0000','ARRENDAMENTO MERCANTIL OPERACIONAL DE BENS IMÓVEIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE BENS IMÓVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.55.99.00.00.0000','OUTROS ARRENDAMENTOS MERCANTIS OPERACIONAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL, NÃO ESPECIFICADOS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.56.00.00.00.0000','PASSAGENS E DESPESAS COM LOCOMOCAO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE PASSAGENS (AEREAS,TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE, SEGUROS, FRETAMENTO, PEDAGIOS, LOCAÇÃO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.56.01.00.00.0000','PASSAGENS PARA O PAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO PAIS EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.56.02.00.00.0000','PASSAGENS PARA O EXTERIOR','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EM-BARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO EXTERIOR EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.56.03.00.00.0000','LOCAÇÃO DE MEIOS DE TRANSPORTE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIAÇÃO DA LOCAÇÃO DE MEIOS DE TRANSPORTE, TAIS COMO: VEICULOS, AERONAVES, EMBARCAÇÕES E ASSEMELHADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.56.05.00.00.0000','LOCOMOCAO URBANA','REGISTRA AS APROPRIAÇÕES DE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM LOCOMOCAO URBANA REALIZADA POR MEIO DE ONIBUS, TAXI E OUTROS VEICULOS DE TRANSPORTES URBANOS,PARA ATENDER NECESSIDADE DO SERVICO, COMPREENDENDO, TAMBEM, DESLOCAMENTOS PARA REALIZAÇÃO DE PESQUISAS E REEMBOLSO COM TRANSPORTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.56.08.00.00.0000','PEDAGIOS','REGISTRA O VALOR DAS AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM TARIFAS DE PEDAGIO, TAXA MENSAL PELA UTILIZAÇÃO DO SISTEMA E ADESAO AO SISTEMA DE IDENTIFICAÇÃO DO VEICULO SEM A NECESSIDADE DE PARA-LO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.56.09.00.00.0000','TRANSPORTE DE SERVIDORES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUÇÃO DE TAREFAS PELOS SERVIDORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.56.99.00.00.0000','OUTRAS DESPESAS COM LOCOMOCAO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE PASSAGENS E MEIOS DE TRANSPORTE NÃO ESPECIFICADOS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.3.1.99.00.00.00.0000','OUTROS SERVIÇOS PRESTADOS POR PESSOA JURIDICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZAÇÃO DE SERVIÇOS PRESTADOS POR PESSOA JURIDICA, QUE NÃO ESTEJA ESPECIFICADOS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.4.0.00.00.00.00.0000','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUICAO DE MAO DE OBRA – ART. 18 § 1, LC 101/00','COMPREENDE A APROPRIAÇÃO DAS VPDS RELATIVAS A MAO-DE-OBRA, CONSTANTES DOS CONTRATOS DE TERCEIRIZAÇÃO, CLASSIFICAVEIS NO GRUPO DE VPD COM PESSOAL E ENCARGOS EM OBEDIENCIA AO DISPOSTO NO ARTIGO 18, § 1º, DA LEI COMPLEMENTAR Nº 101, DE 2000.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.2.4.1.00.00.00.00.0000','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUIÇÃO DE MÃO DE OBRA - ART. 18 § 1, LC 101/00 - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MAO-DE-OBRA, CONSTANTES DOS CONTRATOS DE TERCEIRIZAÇÃO, CLASSIFICAVEIS NO GRUPO DE DESPESA COM PESSOAL E ENCARGOS EM OBEDIENCIA AO DISPOSTO NO ARTIGO 18, § 1º, DA LEI COMPLEMENTAR Nº 101, DE 2000. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.3.0.0.00.00.00.00.0000','DEPRECIAÇÃO, AMORTIZAÇÃO E EXAUSTÃO','COMPREENDE O DECRESCIMO NO BENEFICIO DE UM BEM DURANTE O PERIODO CONTABIL DECORRENTE DE DEPRECIAÇÃO, AMORTIZAÇÃO E EXAUSTÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.3.1.0.00.00.00.00.0000','DEPRECIAÇÃO','COMPREENDE A REDUÇÃO DO VALOR DOS BENS TANGIVEIS PELO DESGASTE OU PERDA DE UTILIDADE POR USO, AÇÃO DA NATUREZA OU OBSOLESCENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.3.1.1.00.00.00.00.0000','DEPRECIAÇÃO - CONSOLIDAÇÃO','COMPREENDE A REDUÇÃO DO VALOR DOS BENS TANGIVEIS PELO DESGASTE OU PERDA DE UTILIDADE POR USO, AÇÃO DA NATUREZA OU OBSOLESCENCIA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.3.1.1.01.00.00.00.0000','DEPRECIAÇÃO DE IMOBILIZADO','REGISTRA A REDUÇÃO DO VALOR DOS BENS TANGIVEIS ,DO ATIVO IMOBILIZADO, PELO DESGASTE OU PERDA DE UTILIDADE POR USO, AÇÃO DA NATUREZA OU OBSOLESCENCIA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.3.1.1.01.01.00.00.0000','DEPRECIAÇÃO DE BENS MÓVEIS','REGISTRA A REDUÇÃO DO VALOR DOS BENS MÓVEIS PELO DESGASTE OU PERDA DE UTILIDADE POR USO, AÇÃO DA NATUREZA OU OBSOLESCÊNCIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.3.1.1.01.02.00.00.0000','DEPRECIAÇÃO DE BENS IMÓVEIS','REGISTRA A REDUÇÃO DO VALOR DOS BENS IMÓVEIS PELO DESGASTE OU PERDA DE UTILIDADE POR USO, AÇÃO DA NATUREZA OU OBSOLESCÊNCIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.3.2.0.00.00.00.00.0000','AMORTIZAÇÃO','COMPREENDE A REDUÇÃO DO VALOR APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE E QUAISQUER OUTROS, INCLUSIVE ATIVOS INTANGIVEIS, COM EXISTENCIA OU EXERCÍCIO DE DURAÇÃO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZAÇÃO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.3.2.1.00.00.00.00.0000','AMORTIZAÇÃO - CONSOLIDAÇÃO','COMPREENDE A REDUÇÃO DO VALOR APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE E QUAISQUER OUTROS, INCLUSIVE ATIVOS INTANGIVEIS, COM EXISTENCIA OU EXERCÍCIO DE DURAÇÃO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZAÇÃO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.3.2.1.01.00.00.00.0000','AMORTIZAÇÃO DE IMOBILIZADO','REGISTRA A REDUÇÃO DO VALOR APLICADO NA AQUISICAO DE DIREITOS, DO ATIVO IMOBILIZADO, COM EXISTENCIA OU EXERCÍCIO DE DURAÇÃO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZAÇÃO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.3.2.1.02.00.00.00.0000','AMORTIZAÇÃO DE INTANGIVEL','REGISTRA A REDUÇÃO DO VALOR APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE E QUAISQUER OUTROS, INCLUSIVE ATIVOS INTANGIVEIS, COM EXISTENCIA OU EXERCÍCIO DE DURAÇÃO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZAÇÃO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.3.3.0.00.00.00.00.0000','EXAUSTÃO','COMPREENDE A REDUÇÃO DO VALOR, DECORRENTE DA EXPLORAÇÃO, DOS RECURSOS MINERAIS, FLORESTAIS E OUTROS RECURSOS NATURAIS ESGOTAVEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.3.3.1.00.00.00.00.0000','EXAUSTÃO - CONSOLIDAÇÃO','COMPREENDE A REDUÇÃO DO VALOR, DECORRENTE DA EXPLORAÇÃO, DOS RECURSOS MINERAIS, FLORESTAIS E OUTROS RECURSOS NATURAIS ESGOTAVEIS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.3.3.1.01.00.00.00.0000','EXAUSTÃO DE IMOBILIZADO','REGISTRA A REDUÇÃO DO VALOR, DECORRENTE DA EXPLORAÇÃO, DOS RECURSOS MINERAIS, FLORESTAIS E OUTROS RECURSOS NATURAIS ESGOTAVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.8.0.0.00.00.00.00.0000','CUSTO DE MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA A MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO UTILIZADOS NA PRODUCAO DE BENS OU SERVIÇOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.8.1.0.00.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.8.1.1.00.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.8.1.1.01.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – MATERIAIS E SERVIÇOS','REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL E SERVIÇOS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.8.1.1.02.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – CONSUMO DE CAPITAL FIXO','REGISTRA A APROPRIACAO DE CONSUMO DE CAPITAL FIXO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.8.2.0.00.00.00.00.0000','CUSTO DE PRODUTOS VENDIDOS – MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.8.2.1.00.00.00.00.0000','CUSTO DE PRODUTOS VENDIDOS – MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.8.2.1.01.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – MATERIAIS E SERVIÇOS','REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL E SERVIÇOS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.8.2.1.02.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – CONSUMO DE CAPITAL FIXO','REGISTRA A APROPRIACAO DE CONSUMO DE CAPITAL FIXO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.8.3.0.00.00.00.00.0000','CUSTO DE SERVIÇOS PRESTADOS – MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE SERVIÇOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.8.3.1.00.00.00.00.0000','CUSTO DE SERVIÇOS PRESTADOS – MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE SERVIÇOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.8.3.1.01.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – MATERIAIS E SERVIÇOS','REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL E SERVIÇOS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.3.8.3.1.02.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – CONSUMO DE CAPITAL FIXO','REGISTRA A APROPRIACAO DE CONSUMO DE CAPITAL FIXO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.0.0.0.00.00.00.00.0000','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM OPERAÇÕES FINANCEIRAS, TAIS COMO: JUROS INCORRIDOS, DESCONTOS CONCEDIDOS, COMISSOES, DESPESAS BANCÁRIAS E CORREÇÕES MONETARIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.0.0.00.00.00.00.0000','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS OBTIDOS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.0.00.00.00.00.0000','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL INTERNA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DÍVIDA PÚBLICA INTERNA DERIVADA DE OBRIGAÇÕES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO COM VISTAS A EXECUÇÃO DE OBRAS, FORNECIMENTO DE BENS OU PRESTAÇÃO DE SERVIÇOS, OU DA CELEBRAÇÃO DE CONTRATOS DE FINANCIAMENTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.1.00.00.00.00.0000','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL - INTERNA -CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DÍVIDA PÚBLICA INTERNA DERIVADA DE OBRIGAÇÕES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO COM VISTAS A EXECUÇÃO DE OBRAS, FORNECIMENTO DE BENS OU PRESTAÇÃO DE SERVIÇOS, OU DA CELEBRAÇÃO DE CONTRATOS DE FINANCIAMENTO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.1.01.00.00.00.0000','JUROS DA DÍVIDA CONTRATADA COM INSTITUIÇÕES FINANCEIRAS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS DA DÍVIDA PÚBLICA DERIVADA DE OBRIGAÇÕES ASSUMIDAS COM INSTITUICOES FINANCEIRAS COM VISTAS A EXECUÇÃO DE OBRAS, FORNECIMENTO DE BENS OU PRESTAÇÃO DE SERVIÇOS, OU DA CELEBRAÇÃO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.1.02.00.00.00.0000','ENCARGOS DA DÍVIDA CONTRATUAL COM INSTITUIÇÕES FINANCEIRAS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DÍVIDA PÚBLICA DERIVADA DE OBRIGAÇÕES ASSUMIDAS COM INSTITUICOES FINANCEIRAS COM VISTAS A EXECUÇÃO DE OBRAS, FORNECIMENTO DE BENS OU PRESTAÇÃO DE SERVIÇOS, OU DA CELEBRAÇÃO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.1.99.00.00.00.0000','JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATUAIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTES DE JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATADAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.3.00.00.00.00.0000','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL - INTER OFSS - UNIÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DÍVIDA PÚBLICA DERIVADA DE OBRIGAÇÕES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO COM VISTAS A EXECUÇÃO DE OBRAS, FORNECIMENTO DE BENS OU PRESTAÇÃO DE SERVIÇOS, OU DA CELEBRAÇÃO DE CONTRATOS DE FINANCIAMENTO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.3.01.00.00.00.0000','JUROS DA DÍVIDA CONTRATADA COM GOVERNOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA AOS JUROS DECORRENTES DA DÍVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.3.02.00.00.00.0000','ENCARGOS DA DÍVIDA CONTRATADA COM GOVERNOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA AOS ENCARGIOS DECORRENTES DA DÍVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.3.99.00.00.00.0000','JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATUAIS - INTERNA INTER OFSS - UNIÃO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTES DE JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATADAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.4.00.00.00.00.0000','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL - INTER OFSS - ESTADO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DÍVIDA PÚBLICA DERIVADA DE OBRIGAÇÕES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO COM VISTAS A EXECUÇÃO DE OBRAS, FORNECIMENTO DE BENS OU PRESTAÇÃO DE SERVIÇOS, OU DA CELEBRAÇÃO DE CONTRATOS DE FINANCIAMENTO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.4.01.00.00.00.0000','JUROS DA DÍVIDA CONTRATADA COM GOVERNOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA AOS JUROS DECORRENTES DA DÍVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.4.02.00.00.00.0000','ENCARGOS DA DÍVIDA CONTRATADA COM GOVERNOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA AOS ENCARGIOS DECORRENTES DA DÍVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.4.99.00.00.00.0000','JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATUAIS - INTERNA INTER OFSS - ESTADO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTES DE JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATADAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.5.00.00.00.00.0000','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL - INTER OFSS - MUNICÍPIO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DÍVIDA PÚBLICA DERIVADA DE OBRIGAÇÕES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO COM VISTAS A EXECUÇÃO DE OBRAS, FORNECIMENTO DE BENS OU PRESTAÇÃO DE SERVIÇOS, OU DA CELEBRAÇÃO DE CONTRATOS DE FINANCIAMENTO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.5.01.00.00.00.0000','JUROS DA DÍVIDA CONTRATADA COM GOVERNOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA AOS JUROS DECORRENTES DA DÍVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.5.02.00.00.00.0000','ENCARGOS DA DÍVIDA CONTRATADA COM GOVERNOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA AOS ENCARGIOS DECORRENTES DA DÍVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.1.5.99.00.00.00.0000','JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATUAIS - INTERNA INTER OFSS - MUNICÍPIO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTES DE JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATADAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.2.0.00.00.00.00.0000','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL EXTERNA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DÍVIDA PÚBLICA EXTERNA DERIVADA DE OBRIGAÇÕES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO COM VISTAS A EXECUÇÃO DE OBRAS, FORNECIMENTO DE BENS OU PRESTAÇÃO DE SERVIÇOS, OU DA CELEBRAÇÃO DE CONTRATOS DE FINANCIAMENTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.2.1.00.00.00.00.0000','JUROS E ENCARGOS DA DÍVIDA CONTRATUAL - EXTERNA -CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DÍVIDA PÚBLICA EXTERNA DERIVADA DE OBRIGAÇÕES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO COM VISTAS A EXECUÇÃO DE OBRAS, FORNECIMENTO DE BENS OU PRESTAÇÃO DE SERVIÇOS, OU DA CELEBRAÇÃO DE CONTRATOS DE FINANCIAMENTO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.2.1.01.00.00.00.0000','JUROS DA DÍVIDA CONTRATADA NO EXTERIOR','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS DA DÍVIDA PÚBLICA CONTRATADA NO EXTERIOR COM VISTAS A EXECUÇÃO DE OBRAS, FORNECIMENTO DE BENS OU PRESTAÇÃO DE SERVIÇOS, OU DA CELEBRAÇÃO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.2.1.02.00.00.00.0000','ENCARGOS DA DÍVIDA CONTRATADA NO EXTERIOR','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DÍVIDA PÚBLICA CONTRATADA NO EXTERIOR COM VISTAS A EXECUÇÃO DE OBRAS, FORNECIMENTO DE BENS OU PRESTAÇÃO DE SERVIÇOS, OU DA CELEBRAÇÃO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.3.0.00.00.00.00.0000','JUROS E ENCARGOS DA DÍVIDA MOBILIARIA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DÍVIDA PÚBLICA REPRESENTADA POR TITULOS EMITIDOS PELO GOVERNO. SAO CONSIDERADOS ENCARGOS DA DÍVIDA MOBILIARIA: COMISSOES, CORRETAGENS, SEGUROS, DESAGIO E OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.3.1.00.00.00.00.0000','JUROS E ENCARGOS DA DÍVIDA MOBILIARIA - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DÍVIDA PÚBLICA REPRESENTADA POR TITULOS EMITIDOS PELO GOVERNO. SAO CONSIDERADOS ENCARGOS DA DÍVIDA MOBILIARIA: COMISSOES, CORRETAGENS, SEGUROS, DESAGIO E OUTROS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.3.1.01.00.00.00.0000','JUROS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS DA DÍVIDA PÚBLICA MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.3.1.02.00.00.00.0000','DESAGIOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DECORRENTE DE DESAGIOS DA DÍVIDA PÚBLICA MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.3.1.03.00.00.00.0000','ENCARGOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS DA DÍVIDA PÚBLICA MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.4.0.00.00.00.00.0000','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORCAMENTARIA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONTRAIDOS POR ANTECIPAÇÃO DE RECEITA ORCAMENTARIA PARA ATENDER INSUFICIÊNCIA DE CAIXA DURANTE O EXERCÍCIO FINANCEIRO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.4.1.00.00.00.00.0000','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORÇAMENTÁRIA - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONTRAIDOS POR ANTECIPAÇÃO DE RECEITA ORCAMENTARIA PARA ATENDER INSUFICIÊNCIA DE CAIXA DURANTE O EXERCÍCIO FINANCEIRO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.4.1.01.00.00.00.0000','JUROS S/ ADIANTAMENTOS BANCARIOS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS INCIDENTES SOBRE ANTECIPAÇÕES DE CRÉDITOS CONTRATADAS COM BANCOS E OUTROS AGENTES FINANCEIROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.8.0.00.00.00.00.0000','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS QUE NÃO SEJAM REFERENTES A DÍVIDA CONTRATUAL, A DÍVIDA MOBILIARIA E A POR ANTECIPAÇÃO DE RECEITA ORCAMENTARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.8.1.00.00.00.00.0000','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - CONSOLIDAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS QUE NÃO SEJAM REFERENTES A DÍVIDA CONTRATUAL, A DÍVIDA MOBILIARIA E A POR ANTECIPAÇÃO DE RECEITA ORCAMENTARIA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.8.3.00.00.00.00.0000','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - UNIÃO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS QUE NÃO SEJAM REFERENTES A DÍVIDA CONTRATUAL, A DÍVIDA MOBILIARIA E A POR ANTECIPAÇÃO DE RECEITA ORCAMENTARIA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.8.4.00.00.00.00.0000','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - ESTADO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS QUE NÃO SEJAM REFERENTES A DÍVIDA CONTRATUAL, A DÍVIDA MOBILIARIA E A POR ANTECIPAÇÃO DE RECEITA ORCAMENTARIA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.8.5.00.00.00.00.0000','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - MUNICÍPIO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS QUE NÃO SEJAM REFERENTES A DÍVIDA CONTRATUAL, A DÍVIDA MOBILIARIA E A POR ANTECIPAÇÃO DE RECEITA ORCAMENTARIA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.9.0.00.00.00.00.0000','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS EXTERNOS QUE NÃO SEJAM REFERENTES A DÍVIDA CONTRATUAL, A DÍVIDA MOBILIARIA E A POR ANTECIPAÇÃO DE RECEITA ORCAMENTARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.1.9.1.00.00.00.00.0000','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS - CONSOLIDAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS EXTERNOS QUE NÃO SEJAM REFERENTES A DÍVIDA CONTRATUAL, A DÍVIDA MOBILIARIA E A POR ANTECIPAÇÃO DE RECEITA ORCAMENTARIA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.0.0.00.00.00.00.0000','JUROS E ENCARGOS DE MORA','COMPREENDE O MONTANTE DE VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.1.0.00.00.00.00.0000','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.1.1.00.00.00.00.0000','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.1.1.01.00.00.00.0000','JUROS DE MORA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.1.1.02.00.00.00.0000','ENCARGOS DE MORA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.1.3.00.00.00.00.0000','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - UNIÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.1.3.01.00.00.00.0000','JUROS DE MORA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.1.3.02.00.00.00.0000','ENCARGOS DE MORA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.1.4.00.00.00.00.0000','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - ESTADO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.1.4.01.00.00.00.0000','JUROS DE MORA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.1.4.02.00.00.00.0000','ENCARGOS DE MORA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.1.5.00.00.00.00.0000','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - MUNICÍPIO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.1.5.01.00.00.00.0000','JUROS DE MORA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.1.5.02.00.00.00.0000','ENCARGOS DE MORA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.2.0.00.00.00.00.0000','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.2.1.00.00.00.00.0000','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.2.1.01.00.00.00.0000','JUROS DE MORA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.2.1.02.00.00.00.0000','ENCARGOS DE MORA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PÚBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.0.00.00.00.00.0000','JUROS E ENCARGOS DE MORA DE AQUISICAO DE BENS E SERVIÇOS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTAÇÃO DE SERVIÇOS E AQUISICAO DE BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.00.00.00.00.0000','JUROS E ENCARGOS DE MORA DE AQUISIÇÃO DE BENS E SERVIÇOS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTAÇÃO DE SERVIÇOS E AQUISICAO DE BENS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.01.00.00.00.0000','JUROS DE MORA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTAÇÃO DE SERVIÇOS E AQUISICAO DE BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.01.01.00.00.0000','JUROS DE SERVIÇOS TERCEIROS - PESSOA FISICA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTAÇÃO DE SERVIÇOS COM PESSOA FISICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.01.02.00.00.0000','JUROS DE SERVIÇOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTAÇÃO DE SERVIÇOS COM PESSOA JURIDICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.01.03.00.00.0000','JUROS SOBRE FORNECIMENTOS DE BENS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.02.00.00.00.0000','MULTAS DEDUTIVEIS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.02.01.00.00.0000','MULTAS DEDUTIVEIS SERVICOS TERCEIROS - PESSOA FISICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA FISICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.02.02.00.00.0000','MULTAS DEDUTIVEIS SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.02.03.00.00.0000','MULTAS DEDUTIVEIS SOBRE FORNECIMENTOS DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.03.00.00.00.0000','MULTAS INDEDUTIVEIS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.03.01.00.00.0000','MULTAS INDEDUTIVEIS SERVICOS TERCEIROS - PESSOA FISICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA FISICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.03.02.00.00.0000','MULTAS INDEDUTIVEIS SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.03.03.00.00.0000','MULTAS INDEDUTIVEIS SOBRE FORNECIMENTOS DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.99.00.00.00.0000','OUTROS ENCARGOS DE MORA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTAÇÃO DE SERVIÇOS E AQUISICAO DE BENS, QUE NÃO SE ENQUADREM NOS ITENS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.99.01.00.00.0000','OUTROS ENCARGOS S/ SERVIÇOS TERCEIROS - PESSOA FISICA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTAÇÃO DE SERVIÇOS COM PESSOAS FISICAS, QUE NÃO SE ENQUADREM NOS ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.99.02.00.00.0000','OUTROS ENCARGOS S/ SERVIÇOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTAÇÃO DE SERVIÇOS COM PESSOAS JURIDICAS, QUE NÃO SE ENQUADREM NOS ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.3.1.99.03.00.00.0000','OUTROS ENCARGOS S/ FONECIMENTO DE BENS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS, QUE NÃO SE ENQUADREM NOS ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.4.0.00.00.00.00.0000','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DE OBRIGAÇÕES TRIBUTÁRIAS DEVIDAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.4.1.00.00.00.00.0000','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DE OBRIGAÇÕES TRIBUTÁRIAS DEVIDAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.4.1.01.00.00.00.0000','JUROS DE MORA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DAS OBRIGAÇÕES TRIBUTÁRIAS DEVIDAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.4.1.02.00.00.00.0000','MULTAS DEDUTIVEIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS DEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, APENAS AS MULTAS POR INFRACOES FISCAIS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 - RIR/99).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.4.1.03.00.00.00.0000','MULTAS INDEDUTIVEIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS INDEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, TODAS AS MULTAS POR INFRACOES FISCAIS, SALVO AS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 -RIR/99).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.9.0.00.00.00.00.0000','OUTROS JUROS E ENCARGOS DE MORA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS EM SITUAÇÕES NÃO COMPREENDIDAS NAS CLASSIFICAÇÕES ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.9.1.00.00.00.00.0000','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS EM SITUAÇÕES NÃO COMPREENDIDAS NAS CLASSIFICAÇÕES ANTERIORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.9.2.00.00.00.00.0000','OUTROS JUROS E ENCARGOS DE MORA - INTRA OFSS','Compreende A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.9.3.00.00.00.00.0000','OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - UNIÃO','Compreende A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.9.4.00.00.00.00.0000','OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - ESTADO','Compreende A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.2.9.5.00.00.00.00.0000','OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - MUNICIPIO','Compreende A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.0.0.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.1.0.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES A DÍVIDA CONTRATUAL INTERNA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.1.1.00.00.00.00.0000','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES A DÍVIDA CONTRATUAL INTERNA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.1.1.01.00.00.00.0000','VARIAÇÕES MONETARIAS DE DÍVIDA CONTRATUAL','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DÍVIDA CONTRATUAL INTERNA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.1.1.02.00.00.00.0000','VARIAÇÕES CAMBIAIS DE DÍVIDA CONTRATUAL','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES A DÍVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.1.3.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA- INTER OFSS - UNIÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES A DÍVIDA CONTRATUAL INTERNA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.1.3.01.00.00.00.0000','VARIACOES MONETARIAS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.1.3.02.00.00.00.0000','VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.1.4.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA- INTER OFSS - ESTADO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES A DÍVIDA CONTRATUAL INTERNA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.1.4.01.00.00.00.0000','VARIACOES MONETARIAS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.1.4.02.00.00.00.0000','VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.1.5.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS DE DÍVIDA CONTRATUAL INTERNA- INTER OFSS - MUNICÍPIO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES A DÍVIDA CONTRATUAL INTERNA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.1.5.01.00.00.00.0000','VARIACOES MONETARIAS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.1.5.02.00.00.00.0000','VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.2.0.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS DE DÍVIDA CONTRATUAL EXTERNA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES A DÍVIDA CONTRATUAL EXTERNA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.2.1.00.00.00.00.0000','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA CONTRATUAL EXTERNA - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES A DÍVIDA CONTRATUAL EXTERNA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.2.1.01.00.00.00.0000','VARIAÇÕES MONETARIAS DE DÍVIDA CONTRATUAL EXTERNA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DÍVIDA CONTRATUAL EXTERNA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.2.1.02.00.00.00.0000','VARIAÇÕES CAMBIAIS DE DÍVIDA CONTRATUAL EXTERNA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES A DÍVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.3.0.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS DE DÍVIDA MOBILIARIA INTERNA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES A DÍVIDA MOBILIARIA INTERNA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.3.1.00.00.00.00.0000','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA MOBILIARIA INTERNA - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES A DÍVIDA MOBILIARIA INTERNA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.3.1.01.00.00.00.0000','VARIAÇÕES MONETARIAS DE DIVIDA MOBILIARIA INTERNA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA MOBILIARIA INTERNA. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.3.1.02.00.00.00.0000','VARIAÇÕES CAMBIAIS DE DIVIDA MOBILIARIA INTERNA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA MOBILIARIA INTERNA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.4.0.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS DE DÍVIDA MOBILIARIA EXTERNA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES A DÍVIDA MOBILIARIA EXTERNA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.4.1.00.00.00.00.0000','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DÍVIDA MOBILIARIA EXTERNA - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES A DÍVIDA MOBILIARIA EXTERNA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.4.1.01.00.00.00.0000','VARIAÇÕES MONETARIAS DE DIVIDA MOBILIARIA EXTERNA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PRÓPRIA MOEDA EM RELAÇÃO AOS ÍNDICES OU COEFICIENTES APLICÁVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERÁ TRATADA COMO VARIAÇÃO MONETÁRIA APENAS A CORREÇÃO MONETÁRIA PÓS - FIXADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.4.1.02.00.00.00.0000','VARIAÇÕES CAMBIAIS DE DIVIDA MOBILIARIA EXTERNA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.0.00.00.00.00.0000','OUTRAS VARIAÇÕES MONETARIAS E CAMBIAIS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DÍVIDA CONTRATUAL E MOBILIARIA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.1.00.00.00.00.0000','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DÍVIDA CONTRATUAL E MOBILIARIA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.1.01.00.00.00.0000','OUTRAS VARIAÇÕES MONETARIAS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.1.02.00.00.00.0000','OUTRAS VARIAÇÕES CAMBIAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.1.03.00.00.00.0000','ENCARGOS FINANCEIROS DEDUTÍVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PRÓPRIA MOEDA EM RELAÇÃO AOS ÍNDICES OU COEFICIENTES APLICÁVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL, COM EXCEÇÃO A DIVIDA CONTRATUAL E MOBILIARIA. RESSALTE-SE SERÁ TRATADA COMO VARIAÇÃO MONETÁRIA APENAS A CORREÇÃO MONETÁRIA PÓS - FIXADA - ENCARGOS FINANCEIROS DEDUTÍVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.1.04.00.00.00.0000','ENCARGOS FINANCEIROS INDEDUTÍVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PRÓPRIA MOEDA EM RELAÇÃO AOS ÍNDICES OU COEFICIENTES APLICÁVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL, COM EXCEÇÃO A DIVIDA CONTRATUAL E MOBILIARIA. RESSALTE-SE SERÁ TRATADA COMO VARIAÇÃO MONETÁRIA APENAS A CORREÇÃO MONETÁRIA PÓS - FIXADA - ENCARGOS FINANCEIROS INDEDUTÍVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.1.70.00.00.00.0000','ATUALIZAÇÃO MONETÁRIA DE PRECATÓRIOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PRÓPRIA MOEDA EM RELAÇÃO AOS ÍNDICES OU COEFICIENTES APLICÁVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL, COM EXCEÇÃO A DIVIDA CONTRATUAL E MOBILIARIA. RESSALTE-SE SERÁ TRATADA COMO VARIAÇÃO MONETÁRIA APENAS A CORREÇÃO MONETÁRIA PÓS - FIXADA - ATUALIZAÇÃO MONETÁRIA DE PRECATÓRIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.1.99.00.00.00.0000','OUTRAS VARIAÇÕES CAMBIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS, COM EXCEÇÃO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.3.00.00.00.00.0000','OUTRAS VARIAÇÕES MONETARIAS E CAMBIAIS - INTER OFSS - UNIÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DÍVIDA CONTRATUAL E MOBILIARIA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE E O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.3.01.00.00.00.0000','OUTRAS VARIAÇÕES MONETARIAS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.3.02.00.00.00.0000','OUTRAS VARIAÇÕES CAMBIAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.3.03.00.00.00.0000','ENCARGOS FINANCEIROS DEDUTÍVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PRÓPRIA MOEDA EM RELAÇÃO AOS ÍNDICES OU COEFICIENTES APLICÁVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL, COM EXCEÇÃO A DIVIDA CONTRATUAL E MOBILIARIA. RESSALTE-SE SERÁ TRATADA COMO VARIAÇÃO MONETÁRIA APENAS A CORREÇÃO MONETÁRIA PÓS - FIXADA - ENCARGOS FINANCEIROS DEDUTÍVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.3.04.00.00.00.0000','ENCARGOS FINANCEIROS INDEDUTÍVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PRÓPRIA MOEDA EM RELAÇÃO AOS ÍNDICES OU COEFICIENTES APLICÁVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL, COM EXCEÇÃO A DIVIDA CONTRATUAL E MOBILIARIA. RESSALTE-SE SERÁ TRATADA COMO VARIAÇÃO MONETÁRIA APENAS A CORREÇÃO MONETÁRIA PÓS - FIXADA - ENCARGOS FINANCEIROS INDEDUTÍVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.3.70.00.00.00.0000','ATUALIZAÇÃO MONETÁRIA DE PRECATÓRIOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PRÓPRIA MOEDA EM RELAÇÃO AOS ÍNDICES OU COEFICIENTES APLICÁVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL, COM EXCEÇÃO A DIVIDA CONTRATUAL E MOBILIARIA. RESSALTE-SE SERÁ TRATADA COMO VARIAÇÃO MONETÁRIA APENAS A CORREÇÃO MONETÁRIA PÓS - FIXADA - ATUALIZAÇÃO MONETÁRIA DE PRECATÓRIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.3.71.00.00.00.0000','ATUALIZAÇÃO MONETÁRIA DE TRIBUTOS RENEGOCIADOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PRÓPRIA MOEDA EM RELAÇÃO AOS ÍNDICES OU COEFICIENTES APLICÁVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL, COM EXCEÇÃO A DIVIDA CONTRATUAL E MOBILIARIA. RESSALTE-SE SERÁ TRATADA COMO VARIAÇÃO MONETÁRIA APENAS A CORREÇÃO MONETÁRIA PÓS - FIXADA - ATUALIZAÇÃO MONETÁRIA DE TRIBUTOS RENEGOCIADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.3.99.00.00.00.0000','OUTRAS VARIAÇÕES CAMBIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS, COM EXCEÇÃO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.4.00.00.00.00.0000','OUTRAS VARIAÇÕES MONETARIAS E CAMBIAIS - INTER OFSS - ESTADO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DÍVIDA CONTRATUAL E MOBILIARIA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE E O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.4.01.00.00.00.0000','OUTRAS VARIAÇÕES MONETARIAS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.4.02.00.00.00.0000','OUTRAS VARIAÇÕES CAMBIAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.5.00.00.00.00.0000','OUTRAS VARIAÇÕES MONETARIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DÍVIDA CONTRATUAL E MOBILIARIA. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE E O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.5.01.00.00.00.0000','OUTRAS VARIAÇÕES MONETARIAS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.3.9.5.02.00.00.00.0000','OUTRAS VARIAÇÕES CAMBIAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.4.0.0.00.00.00.00.0000','DESCONTOS FINANCEIROS CONCEDIDOS','COMPREENDE O VALOR DA VARIAÇÃO PATRIMONIAL DIMINUTIVA COM DESCONTOS FINANCEIROS CONCEDIDOS A CLIENTES POR PAGAMENTOS ANTECIPADOS DE DUPLICATAS E OUTROS TITULOS.NÃO SE CONFUNDEM COM DESCONTOS NOS PRECOS DE VENDA CONCEDIDOS INCONDICIONALMENTE, OU ABATIMENTOS DE PRECOS, QUE SAO DEDUCOES DA RECEITA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.4.0.1.00.00.00.00.0000','DESCONTOS FINANCEIROS CONCEDIDOS - CONSOLIDAÇÃO','COMPREENDE O VALOR DA VARIAÇÃO PATRIMONIAL DIMINUTIVA COM DESCONTOS FINANCEIROS CONCEDIDOS A CLIENTES POR PAGAMENTOS ANTECIPADOS DE DUPLICATAS E OUTROS TITULOS. NÃO SE CONFUNDEM COM DESCONTOS NOS PRECOS DE VENDA CONCEDIDOS INCONDICIONALMENTE, OU ABATIMENTOS DE PRECOS, QUE SAO DEDUCOES DA RECEITA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.9.0.0.00.00.00.00.0000','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - FINANCEIRAS','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS, NÃO ABRANGIDAS NOS GRUPOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.9.1.0.00.00.00.00.0000','JUROS E ENCARGOS EM SENTENCAS JUDICIAIS','COMPREENDE OS JUROS E ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATÓRIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.9.1.1.00.00.00.00.0000','JUROS E ENCARGOS EM SENTENÇAS JUDICIAIS - CONSOLIDAÇÃO','COMPREENDE OS JUROS E ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATÓRIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.9.1.1.01.00.00.00.0000','JUROS EM SENTENCAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DOS JUROS RESULTANTES DE PAGAMENTO DE PRECATÓRIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.9.1.1.02.00.00.00.0000','ENCARGOS EM SENTECAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA PROVENIENTE DOS ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATÓRIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.9.2.0.00.00.00.00.0000','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COMINDENIZAÇÕES E RESTITUIÇÕES REFERENTES A JUROS E ENCARGOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.9.2.1.00.00.00.00.0000','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COMINDENIZAÇÕES E RESTITUIÇÕES REFERENTES A JUROS E ENCARGOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.9.2.1.01.00.00.00.0000','JUROS E ENCARGOS EM INDENIZAÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM INDENIZAÇÕES REFERENTES A JUROS E ENCARGOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.9.2.1.02.00.00.00.0000','JUROS E ENCARGOS EM RESTITUIÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM RESTITUIÇÕES REFERENTES A JUROS E ENCARGOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.9.9.0.00.00.00.00.0000','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OPERAÇÕES FINANCEIRAS NÃO COMPREENDIDAS NAS CONTAS ANTERIORES','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.4.9.9.1.00.00.00.00.0000','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OPERAÇÕES FINANCEIRAS NÃO COMPREENDIDAS NAS CONTAS ANTERIORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.0.0.0.00.00.00.00.0000','TRANSFERÊNCIAS E DELEGAÇÕES CONCEDIDAS','COMPREENDE O SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM TRANSFERÊNCIAS INTERGOVERNAMENTAIS, TRANSFERÊNCIAS INTRAGOVERNAMENTAIS, TRANSFERÊNCIAS A INSTITUICOES MULTIGOVERNAMENTAIS, TRANSFERÊNCIAS A INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS, TRANSFERERENCIAS A CONVÊNIOS E TRANSFERÊNCIAS AO EXTERIOR E EXECUÇÃO ORÇAMENTÁRIA DELEGADAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.0.0.00.00.00.00.0000','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERÊNCIAS FINANCEIRAS RELATIVAS A EXECUÇÃO ORCAMENTARIA, E DE BENS E VALORES, REFERENTES AS TRANSAÇÕES INTRA GOVERNAMENTAIS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.0.00.00.00.00.0000','TRANSFERÊNCIAS CONCEDIDAS PARA EXECUÇÃO ORÇAMENTÁRIA','COMPREENDE O VALOR DAS TRANSFERÊNCIAS FINANCEIRAS CONCEDIDAS E CORRESPONDÊNCIA DE CRÉDITOS EM VIRTUDE DA EXECUÇÃO ORÇAMENTÁRIA (COTA, REPASSE E SUB-REPASSE). INCLUI TAMBÉM O VALOR REPASSADO PARA A COBERTURA DO DÉFICIT FINANCEIRO DO RRPPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.00.00.00.00.0000','TRANSFERÊNCIAS CONCEDIDAS PARA EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','COMPREENDE O VALOR DAS TRANSFERÊNCIAS FINANCEIRAS CONCEDIDAS E CORRESPONDÊNCIA DE CRÉDITOS EM VIRTUDE DA EXECUÇÃO ORÇAMENTÁRIA (COTA, REPASSE E SUB-REPASSE). INCLUI TAMBÉM O VALOR REPASSADO PARA A COBERTURA DO DÉFICIT FINANCEIRO DO RRPPS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.01.00.00.00.0000','COTA CONCEDIDA','REGISTRA VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR DA CONCESSAO DE COTA DO ORGÃO CENTRAL DE PROGRAMAÇÃO FINANCEIRA PARA ORGÃO SETORIAL CORRESPONDENTE AO ORÇAMENTO ANUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.02.00.00.00.0000','REPASSE CONCEDIDO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR DOS RECURSOS CONCEDIDOS A TITULO DE TRANSFERÊNCIAS FINANCEIRAS ENTRE ORGÃOS DIFERENTES DA ADMINISTRAÇÃO DIRETA OU INDIRETA, CORRESPONDENTES AO ORÇAMENTO ANUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.02.01.00.00.0000','REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR DO REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.02.01.01.00.0000','REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE - RECURSO LIVRE','REGISTRA O VALOR DO REPASSE FINANCEIRO CONCEDIDO A OUTRA ENTIDADE COM RECURSO LIVRE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.02.01.02.00.0000','REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE - RECURSO DO MDE','REGISTRA O VALOR DO REPASSE FINANCEIRO CONCEDIDO A OUTRA ENTIDADE COM RECURSO DO MDE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.02.01.03.00.0000','REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE - RECURSO DAS ASPS','REGISTRA O VALOR DO REPASSE FINANCEIRO CONCEDIDO A OUTRA ENTIDADE COM RECURSO DAS ASPS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.02.01.04.00.0000','REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE - DEMAIS RECURSOS VINCULADOS','REGISTRA O VALOR DO REPASSE FINANCEIRO CONCEDIDO A OUTRA ENTIDADE COM OS DEMAIS RECURSOS VINCULADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.02.10.00.00.0000','REPASSES PREVIDÊNCIÁRIOS CONCEDIDOS PARA O RPPS','COMPREENDE O VALOR TOTAL DOS REPASSES PREVIDÊNCIÁRIOS CONCEDIDOS REFERENTES A CONTRIBUICAO PREVIDÊNCIÁRIA DO ENTE ESTATAL AO REGIME PROPRIODE PREVIDENCIA SOCIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.02.10.01.00.0000','REPASSE PREVIDÊNCIÁRIO CONCEDIDO P/COBERTURA DÉFICIT - APOSENTADORIAS EXECUTIVO / INDIRETAS','REGISTRA O SOMATÓRIO DOS VALORES REPASSADOS PARA O RPPS A TITULO DE COBERTURA DE DÉFICIT DO EXERCÍCIO ATUAL - APOSENTADORIAS DO PODER EXECUTIVO / INDIRETAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.02.10.02.00.0000','REPASSE PREVIDÊNCIÁRIO CONCEDIDO P/COBERTURA DÉFICIT - APOSENTADORIAS LEGISLATIVO','REGISTRA O SOMATÓRIO DOS VALORES REPASSADOS PARA O RPPS A TITULO DE COBERTURA DE DÉFICIT DO EXERCÍCIO ATUAL - APOSENTADORIAS DO PODER LEGISLATIVO','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.02.10.03.00.0000','REPASSE PREVIDÊNCIÁRIO CONCEDIDO P/COBERTURA DÉFICIT - PENSÕES','REGISTRA O SOMATÓRIO DOS VALORES REPASSADOS PARA O RPPS A TITULO DE COBERTURA DE DÉFICIT DO EXERCÍCIO ATUAL - PENSÕES','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.02.10.04.00.0000','REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS - EXECUTIVO/INDIRETAS','REGISTRA OS REPASSES CONCEDIDOS AO RPPS DO MUNICÍPIO PARA QUE ESTE EXECUTE O PAGAMENTO DE APOSENTADORIAS DE COMPETÊNCIA DAS ENTIDADES DO EXECUTIVO/INDIRETAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.02.10.05.00.0000','REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS - LEGISLATIVO','REGISTRA OS REPASSES CONCEDIDOS AO RPPS DO MUNICÍPIO PARA QUE ESTE EXECUTE O PAGAMENTO DE APOSENTADORIAS DE COMPETÊNCIA DO PODER LEGISLATIVO','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.02.10.06.00.0000','REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE PENSÕES','REGISTRA OS REPASSES CONCEDIDOS AO RPPS DO MUNICÍPIO PARA QUE ESTE EXECUTE O PAGAMENTO DE PENSÕES DE COMPETÊNCIA DAS ENTIDADES DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.02.10.07.00.0000','REPASSE CONCEDIDO AO RPPS A TITULO DE APORTE PARA AMORTIZAÇÃO DO DÉFICIT ATUARIAL','REGISTRA OS REPASSES CONCEDIDOS AO RPPS DO MUNICÍPIO A TITULO DE APORTE PARA AMORITIZAÇÃO DO DÉFICIT ATUARIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.02.10.99.00.0000','OUTROS APORTES AO RPPS','REGISTRAR OS OUTROS APORTES FINANCEIROS REPASSADOS PELO ENTE AO RPPS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.03.00.00.00.0000','SUB-REPASSE CONCEDIDO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR TOTAL DOS SUB-REPASSES CONCEDIDOS POR TRANSFERÊNCIAS FINANCEIRAS ENTRE UG DE UM MESMO ORGÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.05.00.00.00.0000','VALORES DIFERIDOS - BAIXA','REGISTRA O VALOR DA COTA, DO REPASSE E DO SUB-REPASSE DIFERIDOS NO PROCESSO DE INSCRIÇÃO E BAIXA DOS RECURSOS DIFERIDOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.1.2.06.00.00.00.0000','VALORES DIFERIDOS - INSCRIÇÃO','REGISTRA O VALOR DOS RECURSOS DE REPASSE DIFERIDO DECORRENTES DO PROCESSO DE INSCRIÇÃO DOS RECURSOS DIFERIDOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.0.00.00.00.00.0000','TRANSFERÊNCIAS CONCEDIDAS - INDEPENDENTE DE EXECUÇÃO ORCAMENTARIA','COMPREENDE O VALOR DAS TRANSFERÊNCIAS FINANCEIRAS DE BENS E VALORES CONCEDIDAS PARA RESTOS A PAGAR E OUTRAS FINALIDADES INDEPENDENTES DA EXECUÇÃO ORÇAMENTÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.2.00.00.00.00.0000','TRANSFERÊNCIAS CONCEDIDAS - INDEPENDENTE DE EXECUÇÃO ORCAMENTARIA - INTRA OFSS','COMPREENDE O VALOR DAS TRANSFERÊNCIAS FINANCEIRAS DE BENS E VALORES CONCEDIDAS PARA RESTOS A PAGAR E OUTRAS FINALIDADES INDEPENDENTES DA EXECUÇÃO ORÇAMENTÁRIA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.2.01.00.00.00.0000','TRANSFERÊNCIAS FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','COMPREENDE O VALOR DAS TRANSFERÊNCIAS FINANCEIRAS CONCEDIDAS PARA RESTOS A PAGAR E OUTRAS FINALIDADES INDEPENDENTES DA EXECUÇÃO ORÇAMENTÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.2.01.01.00.00.0000','ORDEM DE TRANSFERÊNCIAS CONCEDIDAS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA AO TOTAL DAS TRANSFERÊNCIAS NÃO VINCULADAS AO ORCAMENTO, INCLUSIVE TRANSFERÊNCIAS PARA ATENDER RESTOS A PAGAR E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.2.01.02.00.00.0000','MOVIMENTO DE FUNDOS A CRÉDITO - CORRESPONDÊNCIA DE CRÉDITOS - SALDOS NAO FINANCEIROS','REGISTRA A APROPRIAÇÃO DA TRANSFERÊNCIA DE CRÉDITOS INTERNOS ENTRE UG DE MESMA GESTÃO REFERENTES A CONTAS NÃO FINANCEIRAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.2.01.03.00.00.0000','MOVIMENTO DE FUNDOS A CRÉDITO - CORRESPONDÊNCIA DE CRÉDITOS - SALDOS FINANCEIROS','REGISTRA A APROPRIAÇÃO DA TRANSFERÊNCIA DE CRÉDITOS INTERNOS ENTRE ÓRGÃOS CORRESPONDENTES A SALDOS FINANCEIROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.2.01.04.00.00.0000','MOVIMENTO DE FUNDOS A CRÉDITOS - MOVIMENTO DE FUNDOS PRÓPRIOS','REGISTRA O SOMATÓRIO DOS SALDOS CREDORES INCORPORADOS POR INTEGRAÇÃO DE BALANCETES, FUSÃO, CISÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.2.01.99.00.00.0000','OUTRAS TRANSFERÊNCIAS FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','REGISTRA O VALOR DAS DEMAIS TRANSFERÊNCIAS FINANCEIRAS CONCEDIDAS PARA RESTOS A PAGAR E OUTRAS FINALIDADES INDEPENDENTES DA EXECUÇÃO ORÇAMENTÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.2.02.00.00.00.0000','TRANSFERÊNCIAS NÃO FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','COMPREENDE O VALOR DAS TRANSFERÊNCIAS CONCEDIDAS DE BENS OU VALORES INDEPENDENTES DA EXECUÇÃO ORÇAMENTÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.2.02.01.00.00.0000','TRANSFERÊNCIAS CONCEDIDAS DE BENS IMÓVEIS','REGISTRA O VALOR DAS TRANSFERÊNCIAS DE BENS IMÓVEIS ENTRE UNIDADES DO MESMO ORGÃO .','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.2.02.02.00.00.0000','DOAÇÕES CONCEDIDAS DE BENS IMÓVEIS','REGISTRA O VALOR DE DOAÇÕES DE BENS IMÓVEIS ENTRE UNIDADES DE ORGÃOS DIFERENTES','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.2.02.03.00.00.0000','TRANFERENCIAS CONCEDIDAS DE BENS MÓVEIS','REGISTRA O VALOR DOS BENS MÓVEIS CONCEDIDOS POR UNIDADE LOCALIZADA NO PAIS PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DO MESMO ORGÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.2.02.04.00.00.0000','DOAÇÕES CONCEDIDAS DE BENS MÓVEIS','REGISTRA O VALOR DOS BENS MÓVEIS CONCEDIDOS POR UNIDADE LOCALIZADA NO PAIS PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DE ORGÃOS DIFERENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.2.02.05.00.00.0000','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS E VALORES','REGISTRA O TOTAL DOS TÍTULOS E VALORES EM CIRCULAÇÃO CONCEDIDOS POR UNIDADE DECORRENTE DE TRANSFERÊNCIA A OUTRA UNIDADE DE MESMA GESTÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.2.02.06.00.00.0000','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS DA DÍVIDA ATIVA','REGISTRA A TRANSFERÊNCIA DE TÍTULOS DA DÍVIDA ATIVA DE UMA UG PARA A O ÓRGÃO JURÍDICO COMPETENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.2.2.02.99.00.00.0000','OUTRAS TRANSFERÊNCIAS NÃO FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','REGISTRA O VALOR DAS DEMAIS TRANSFERÊNCIAS CONCEDIDAS DE BENS OU VALORES INDEPENDENTES DA EXECUÇÃO ORÇAMENTÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.3.0.00.00.00.00.0000','TRANSFERENCIAS CONCEDIDAS PARA COBERTURA DO DÉFICIT ATUARIAL DO RPPS POR APORTE PERIÓDICO','COMPREENDE O VALOR DAS TRANSFERÊNCIAS FINANCEIRAS PARA APORTES PERIÓDICOS DESTINADOS À COBERTURA DO DÉFICIT ATUARIAL DO REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL – RPPS, CONFORME PLANO DE AMORTIZAÇÃO ESTABELECIDO EM LEI DO RESPECTIVO ENTE FEDERATIVO,EXCETO AS DECORRENTES DE ALÍQUOTA DE CONTRIBUIÇÃO SUPLEMENTAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.3.2.00.00.00.00.0000','TRANSFERENCIAS CONCEDIDAS PARA COBERTURA DO DÉFICIT ATUARIAL DO RPPS POR APORTE PERIÓDICO – INTRA OFSS','COMPREENDE O VALOR DAS TRANSFERÊNCIAS FINANCEIRAS PARA APORTES PERIÓDICOS DESTINADOS À COBERTURA DO DÉFICIT ATUARIAL DO REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL – RPPS, CONFORME PLANO DE AMORTIZAÇÃO ESTABELECIDO EM LEI DO RESPECTIVO ENTE FEDERATIVO,EXCETO AS DECORRENTES DE ALÍQUOTA DE CONTRIBUIÇÃO SUPLEMENTAR. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.3.2.01.00.00.00.0000','PLANO FINANCEIRO','COMPREENDE O VALOR TOTAL DOS VALORES CONCEDIDOS PELO RPPS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS, FORMAÇÃO DE RESERVA E OUTRAS NECESSIDADES FINANCEIRAS, NO ÂMBITO DO PLANO FINANCEIRO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.3.2.01.01.00.00.0000','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','REGISTRA OS RECURSOS ORÇAMENTÁRIOS EFETIVAMENTE UTILIZADOS PARA A COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS ENTRE AS RECEITAS E DESPESAS PREVIDENCIÁRIAS NO EXERCÍCIO DE REFERÊNCIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.3.2.01.02.00.00.0000','RECURSOS PARA FORMAÇÃO DE RESERVA','REGISTRA OS RECURSOS TRANSFERIDOS PELO ENTE FEDERATIVO AO RPPS PARA FORMAÇÃO DE RESERVA ESPONTÂNEA, PARA FUTUROS PAGAMENTOS DE BENEFÍCIOS DO PLANO FINANCEIRO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.3.2.01.99.00.00.0000','OUTROS APORTES PARA O RPPS','REGISTRA O SOMATÓRIO DE EVENTUAIS APORTES DE RECURSOS NO RPPS PARA OUTRAS NECESSIDADES FINANCEIRAS QUE NÃO A COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS E FORMAÇÃO DE RESERVAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.3.2.02.00.00.00.0000','PLANO PREVIDENCIÁRIO','COMPREENDE O VALOR TOTAL CONCEDIDO AO RPPS PARA COBERTURA DE DÉFICIT FINANCEIRO OU ATUARIAL E OUTROS APORTES, NO ÂMBITO DO PLANO PREVIDENCIÁRIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.3.2.02.01.00.00.0000','RECURSOS PARA COBERTURA DE DÉFICIT FINANCEIRO','REGISTRA O SOMATÓRIO DOS RECURSOS NECESSÁRIOS AO EQUILÍBRIO FINANCEIRO DO PLANO PREVIDENCIÁRIO, OU SEJA, À COBERTURA DE DÉFICIT ENTRE AS RECEITAS E DESPESAS PREVIDENCIÁRIAS, REFERENTES AO EXERCÍCIO ATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.3.2.02.02.00.00.0000','RECURSOS PARA COBERTURA DE DÉFICIT ATUARIAL','REGISTRA OS RECURSOS ORÇAMENTÁRIOS ALOCADOS PARA COBERTURA DE DÉFICIT ATUARIAL NO EXERCÍCIO DE REFERÊNCIA, DESDE QUE NÃO DEFINIDOS POR LEI COMO CONTRIBUIÇÕES SUPLEMENTARES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.3.2.02.99.00.00.0000','OUTROS APORTES PARA O RPPS','REGISTRA OUTROS APORTES FINANCEIROS PARA O RPPS COM OUTRAS FINALIDADES PREVIDENCIÁRIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.4.0.00.00.00.00.0000','TRANSFERÊNCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RGPS','COMPREENDE O VALOR DAS TRANSFERÊNCIAS PARA OS APORTES FINANCEIROS DA UNIÃO PARA A COBERTURA DE DÉFICITS FINANCEIROS OU ATUARIAIS DO RGPS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.4.2.00.00.00.00.0000','TRANSFERÊNCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RGPS – INTRA OFSS','COMPREENDE OS RECURSOS ORÇAMENTÁRIOS EFETIVAMENTE UTILIZADOS PARA A COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS ENTRE AS RECEITAS E DESPESAS PREVIDENCIÁRIAS NO EXERCÍCIO DE REFERÊNCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.4.2.01.00.00.00.0000',' RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','COMPREENDE OS RECURSOS ORÇAMENTÁRIOS EFETIVAMENTE UTILIZADOS PARA A COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS ENTRE AS RECEITAS E DESPESAS PREVIDENCIÁRIAS NO EXERCÍCIO DE REFERÊNCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.4.2.01.01.00.00.0000','PROVENIENTES DO ORÇAMENTO DA SEGURIDADE SOCIAL','REGISTRA O MONTANTE DO ORÇAMENTO DA SEGURIDADE SOCIAL REALOCADO DA SAÚDE OU DA ASSISTÊNCIA SOCIAL PARA A PREVIDÊNCIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.4.2.01.02.00.00.0000',' PROVENIENTES DO ORÇAMENTO FISCAL','REGISTRA OS VALORES DAS RECEITAS DO ORÇAMENTO FISCAL DESTINADOS PARA COBRIR OS DÉFICITS FINANCEIROS DA PREVIDÊNCIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.4.2.02.00.00.00.0000','RECURSOS PARA FORMAÇÃO DE RESERVA','REGISTRA OS RECURSOS TRANSFERIDOS PELA UNIÃO AO RGPS PARA FORMAÇÃO DE RESERVA ESPONTÂNEA, PARA FUTUROS PAGAMENTOS DE BENEFÍCIOS DO PLANO FINANCEIRO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.1.4.2.99.00.00.00.0000','OUTROS APORTES PARA O RGPS','REGISTRA O SOMATÓRIO DE EVENTUAIS APORTES DE RECURSOS PARA O RGPS PARA OUTRAS NECESSIDADES FINANCEIRAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.0.0.00.00.00.00.0000','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERÊNCIAS A UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.0.00.00.00.00.0000','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERÊNCIAS A OUTRAS ESFERAS DE GOVERNO DE RCEITAS TRIBUTÁRIAS, DE CONTRIBUIÇÕES EDE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUIÇÃO OU EM LEIS ESPECÍFICAS, CUJA COMPETÊNCIA DE ARRECADAÇÃO É DO ÓRGÃO TRANSFERIDOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.1.00.00.00.00.0000','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERÊNCIAS A OUTRAS ESFERAS DE GOVERNO DE RCEITAS TRIBUTÁRIAS, DE CONTRIBUIÇÕES EDE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUIÇÃO OU EM LEIS ESPECÍFICAS, CUJA COMPETÊNCIA DE ARRECADAÇÃO É DO ÓRGÃO TRANSFERIDOR. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS). POR EXEMPLO, EMPRESA INDEPENDENTE DE UM ENTE RECEBENDO TRANSFERÊNCIA DE OUTRO ENTE. ( A EMPRESA INDEPENDENTE NÃO PERTENCE AO OFSS MAS PERTENCE AO CONCEITO DE GOVERNAMENTAL).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.3.00.00.00.00.0000','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - INTER OFSS - UNIÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERÊNCIAS A OUTRAS ESFERAS DE GOVERNO DE RCEITAS TRIBUTÁRIAS, DE CONTRIBUIÇÕES EDE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUIÇÃO OU EM LEIS ESPECÍFICAS, CUJA COMPETÊNCIA DE ARRECADAÇÃO É DO ÓRGÃO TRANSFERIDOR. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, PARA PERMITIR A CONSOLIDAÇÃO NACIONAL REALIZADA PELO PODER EXECUTIVO DA UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.3.01.00.00.00.0000','PAGAMENTO DE LAUDEMIO','REPRESENTA DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA PRESTAÇÃO DE SERVIÇOS POR PESSOAS JURIDICAS PARA ORGÃOS PÚBLICOS, DECORRENTES DE PAGAMENTO DE LAUDEMIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.3.02.00.00.00.0000','CONTRIBUIÇÕES','REPRESENTA O SOMATÓRIO DAS CONTRIBUIÇÕES CONCEDIDAS A UNIAO PARA REALIZAÇÃO DE OUTRAS DESPESAS CORRENTES, OU SEJA, DESPESAS AS QUAIS NÃO CORRESPONDA CONTRAPRESTAÇÃO DIRETA EM BENS E SERVIÇOS E NÃO SEJA REEMBOLSAVEL PELO RECEBEDOR, INCLUSIVE AS DESTINADAS A ATENDER A DESPESAS DE MANUTENÇÃO DE OUTRAS ENTIDADES DE DIREITO PÚBLICO OU PRIVADO, OBSERVADO O DISPOSTO NA LEGISLAÇÃO VIGENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.3.03.00.00.00.0000','TRANSFERÊNCIAS FUNSET-FUNDO NAC.SEGURANCA EDUC.TRANSITO(LF 9503/97)','VALOR DA PARCELA DAS MULTAS DE TRÂNSITO TRANSFERIDAS PARA O FUNDO FUNSET – 5% DA PARCELA RECEBIDA PELOS MUNICÍPIOS RELATIVA À REPASSES DO ESTADO DAS MULTAS DE TRÂNSITO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.3.04.00.00.00.0000','TRANSFERÊNCIA VALORES A JUSTICA ELEITORAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE TRANSFERÊNCIAS DE VALORES À JUSTIÇA ELEITORAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.3.05.00.00.00.0000','RESTITUICAO DE TRANSFERÊNCIAS E CONVÊNIOS RECEBIDOS DA UNIÃO','AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM RESTITUIÇÕES DE CONVÊNIOS E TRANSFERÊNCIAS RECEBIDAS DA UNIÃO, COMO, POR EXEMPLO: SALDO DE JUROS DE APLICAÇÕES FINANCEIRAS; SALDOS DE VALORES NÃO UTILIZADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.4.00.00.00.00.0000','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - INTER OFSS - ESTADO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERÊNCIAS A OUTRAS ESFERAS DE GOVERNO DE RCEITAS TRIBUTÁRIAS, DE CONTRIBUIÇÕES EDE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUIÇÃO OU EM LEIS ESPECÍFICAS, CUJA COMPETÊNCIA DE ARRECADAÇÃO É DO ÓRGÃO TRANSFERIDOR. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.4.01.00.00.00.0000','CONTRIBUIÇÃO PATRONAL PARA O RPPS DO ESTADO REFERENTE A PESSOAL REQUISITADO','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PAGAMENTO DE CONTRIBUIÇÃO PATRONAL QUANDO O SERVIDOR É CONTRIBUINTE DO RPPS DO ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.4.02.00.00.00.0000','PROGRAMA TROCA-TROCA','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS QUE O MUNICÍPIO TEM QUE REPASSAR PARA O ESTADO REFERENTE AO PROGRAMA TROCA-TROCA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.4.03.00.00.00.0000','TRANSFERÊNCIAS PARA GRUPAMENTOS DE INCENDIO','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS QUE O MUNICÍPIO TEM QUE REPASSAR PARA OS GRUPAMENTOS DE INCÊNDIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.4.04.00.00.00.0000','RESTITUICAO DE TRANSFERÊNCIAS E CONVÊNIOS RECEBIDOS DO ESTADO','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM RESTITUIÇÕES DE CONVÊNIOS E TRANSFERÊNCIAS RECEBIDAS DO ESTADO, COMO, POR EXEMPLO: SALDO DE JUROS DE APLICAÇÕES FINANCEIRAS; SALDOS DE VALORES NÃO UTILIZADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.4.05.00.00.00.0000','RESTITUICAO DE IPVA','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM RESTITUIÇÕES DE IPVA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.5.00.00.00.00.0000','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - INTER OFSS - MUNICÍPIO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERÊNCIAS A OUTRAS ESFERAS DE GOVERNO DE RCEITAS TRIBUTÁRIAS, DE CONTRIBUIÇÕES EDE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUIÇÃO OU EM LEIS ESPECÍFICAS, CUJA COMPETÊNCIA DE ARRECADAÇÃO É DO ÓRGÃO TRANSFERIDOR. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.5.01.00.00.00.0000','CONTRIBUIÇÃO PATRONAL PARA RPPS DE OUTRO MUNICÍPIO','REGISTRA OS VALORES DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DAS CONTRIBUIÇÕES PATRONAIS QUE UM MUNICÍPIO DEVA REPASSAR PARA O RPPS DE OUTRO MUNICÍPIO EM RAZÃO DE OBRIGAÇAO PATRONAL DECORRENTE DE PRESTAÇÃO DE SERVIÇO DE SERVIDOR EFETIVO DE OUTRO MUNICÍPIO COM ONUS PARA O MUNICÍPIO REQUISITANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.5.02.00.00.00.0000','CONTRIBUIÇÕES A ESCOLAS MUNICIPAIS','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DAS CONTRIBUIÇÕES PARA A MANUTENÇÃO DE ALUNOS MATRICULADOS EM ESCOLAS DE OUTROS MUNICÍPIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.5.03.00.00.00.0000','CONTRIBUIÇÕES MUNICÍPIO POLO DA CONTRAPARTIDA CONVENIO C/UNIAO','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DAS CONTRIBUIÇÕES PARA O MUNICÍPIO POLO REFERENTE A CONTRAPARTIDA DE CONVÊNIOS RECEBIDOS POR VÁRIOS MUNICÍPIOS DA UNIÃO. EX: CONTRAPARTIDA FNDE','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.5.04.00.00.00.0000','TRANSFERÊNCIA A MUNICÍPIO EMANCIPADO PARA ACERTO DE CONTAS','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DAS TRANSFERÊNCIAS REALIZADAS PELO MUNICÍPIO PARA O MUNICÍPIO EMANCIPADO PARA FINS DE ACERTO DE CONTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.1.5.05.00.00.00.0000','RESTITUICAO DE TRANSFERÊNCIAS E CONVÊNIOS RECEBIDOS DOS MUNICÍPIOS','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM RESTITUIÇÕES DE CONVÊNIOS E TRANSFERÊNCIAS RECEBIDAS DOS MUNICÍPIOS, COMO, POR EXEMPLO: SALDO DE JUROS DE APLICAÇÕES FINANCEIRAS; SALDOS DE VALORES NÃO UTILIZADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.2.0.00.00.00.00.0000','TRANSFERÊNCIAS AO FUNDEB','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANFERÊNCIA DE RECURSOS DOS ENTES, INCLUINDO A COMPLEMENTAÇÃO DA UNIÃO, PARA A COMPOSIÇÃO DO FUNDO DE MANUTENÇÃO E DESENVOLVIMNETO DA EDUCAÇÃO BÁSICA E DE VALORIZAÇÃO DOS PROFISSIONAIS DA EDUCAÇÃO, INSTITUIDO PELA E.C Nº 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.2.4.00.00.00.00.0000','TRANSFERÊNCIAS AO FUNDEB - INTER OFSS - ESTADO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANFERÊNCIA DE RECURSOS DOS ENTES, INCLUINDO A COMPLEMENTAÇÃO DA UNIÃO, PARA A COMPOSIÇÃO DO FUNDO DE MANUTENÇÃO E DESENVOLVIMNETO DA EDUCAÇÃO BÁSICA E DE VALORIZAÇÃO DOS PROFISSIONAIS DA EDUCAÇÃO, INSTITUIDO PELA E.C Nº 53/2006 E REGULAMENTADO PELA LEI 11.494/2007. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.0.00.00.00.00.0000','TRANSFERÊNCIAS VOLUNTÁRIAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERÊNCIAS VOLUNTÁRIAS A UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, BEM COMO A DEMAIS ENTIDADES, DE BENS E/OU VALORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.1.00.00.00.00.0000','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERÊNCIAS VOLUNTÁRIAS A UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, BEM COMO A DEMAIS ENTIDADES, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS). POR EXEMPLO, EMPRESA INDEPENDENTE DE UM ENTE RECEBENDO TRANSFERÊNCIA DE OUTRO ENTE. ( A EMPRESA INDEPENDENTE NÃO PERTENCE AO OFSS MAS PERTENCE AO CONCEITO DE GOVERNAMENTAL).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.3.00.00.00.00.0000','TRANSFERÊNCIAS VOLUNTÁRIAS – INTER OFSS - UNIÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERÊNCIAS VOLUNTÁRIAS DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.3.01.00.00.00.0000','CONTRIBUIÇÕES','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS CORRENTES E DE CAPITAL AOS ENTES DA FEDERAÇÃO E A ENTIDADES PRIVADAS SEM FINS LUCRATIVOS, EXCETO PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.3.02.00.00.00.0000','AUXÍLIOS','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS DE CAPITAL AOS ENTES DA FEDERAÇÃO E A ENTIDADES PRIVADAS SEM FINS LUCRATIVOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.3.03.00.00.00.0000','SUBVENÇÕES SOCIAIS','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS CORRENTES ÀS ENTIDADES PÚBLICAS OU PRIVADAS SEM FINS LUCRATIVOS PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.3.04.00.00.00.0000','SUBVENÇÕES ECONÔMICAS','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS CORRENTES ÀS ENTIDADES PÚBLICAS OU PRIVADAS COM FINS LUCRATIVOS PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.3.99.00.00.00.0000','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','REGISTRA O VALOR UTILIZADO PARA AS TRANSFERÊNCIAS VOLUNTÁRIAS NÃO CLASSIFICADAS NAS CONTAS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.4.00.00.00.00.0000','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS – ESTADO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERÊNCIAS VOLUNTÁRIAS DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.4.01.00.00.00.0000','CONTRIBUIÇÕES','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS CORRENTES E DE CAPITAL AOS ENTES DA FEDERAÇÃO E A ENTIDADES PRIVADAS SEM FINS LUCRATIVOS, EXCETO PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.4.02.00.00.00.0000','AUXÍLIOS','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS DE CAPITAL AOS ENTES DA FEDERAÇÃO E A ENTIDADES PRIVADAS SEM FINS LUCRATIVOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.4.03.00.00.00.0000','SUBVENÇÕES SOCIAIS','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS CORRENTES ÀS ENTIDADES PÚBLICAS OU PRIVADAS SEM FINS LUCRATIVOS PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.4.04.00.00.00.0000','SUBVENÇÕES ECONÔMICAS','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS CORRENTES ÀS ENTIDADES PÚBLICAS OU PRIVADAS COM FINS LUCRATIVOS PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.4.99.00.00.00.0000','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','REGISTRA O VALOR UTILIZADO PARA AS TRANSFERÊNCIAS VOLUNTÁRIAS NÃO CLASSIFICADAS NAS CONTAS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.5.00.00.00.00.0000','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS – MUNICÍPIO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERÊNCIAS VOLUNTÁRIAS DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.5.01.00.00.00.0000','CONTRIBUIÇÕES','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS CORRENTES E DE CAPITAL AOS ENTES DA FEDERAÇÃO E A ENTIDADES PRIVADAS SEM FINS LUCRATIVOS, EXCETO PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.5.02.00.00.00.0000','AUXÍLIOS','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS DE CAPITAL AOS ENTES DA FEDERAÇÃO E A ENTIDADES PRIVADAS SEM FINS LUCRATIVOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.5.03.00.00.00.0000','SUBVENÇÕES SOCIAIS','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS CORRENTES ÀS ENTIDADES PÚBLICAS OU PRIVADAS SEM FINS LUCRATIVOS PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.5.04.00.00.00.0000','SUBVENÇÕES ECONÔMICAS','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS CORRENTES ÀS ENTIDADES PÚBLICAS OU PRIVADAS COM FINS LUCRATIVOS PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.3.5.99.00.00.00.0000','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','REGISTRA O VALOR UTILIZADO PARA AS TRANSFERÊNCIAS VOLUNTÁRIAS NÃO CLASSIFICADAS NAS CONTAS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.4.0.00.00.00.00.0000','OUTRAS TRANSFERÊNCIAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE DEMAIS TRANSFERÊNCIAS A UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.4.1.00.00.00.00.0000','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE DEMAIS TRANSFERÊNCIAS A UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.4.3.00.00.00.00.0000','OUTRAS TRANSFERÊNCIAS – INTER OFSS - UNIÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE DEMAIS TRANSFERÊNCIAS A UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS). DE ENTES PÚBLICOS DISTINTOS,RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.4.4.00.00.00.00.0000','OUTRAS TRANSFERÊNCIAS – INTER OFSS - ESTADO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE DEMAIS TRANSFERÊNCIAS A UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS). DE ENTES PÚBLICOS DISTINTOS,RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.2.4.5.00.00.00.00.0000','OUTRAS TRANSFERÊNCIAS – INTER OFSS - MUNICÍPIO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE DEMAIS TRANSFERÊNCIAS A UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS). DE ENTES PÚBLICOS DISTINTOS,RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.3.0.0.00.00.00.00.0000','TRANSFERÊNCIAS A INSTITUICOES PRIVADAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERÊNCIAS FINANCEIRAS A INSTITUICOES PRIVADAS, INCLUSIVE DE BENS E VALORES','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.3.1.0.00.00.00.00.0000','TRANSFERÊNCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERÊNCIAS DE BENS E VALORES A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS QUE NÃO TENHAM VINCULO COM A ADMINISTRAÇÃO PÚBLICA, EXEMPLO: ONGS,OSCIPS E OS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.3.1.1.00.00.00.00.0000','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERÊNCIAS DE BENS E VALORES A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS QUE NÃO TENHAM VINCULO COM A ADMINISTRAÇÃO PÚBLICA, EXEMPLO: ONGS,OSCIPS E OS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.3.1.1.01.00.00.00.0000','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONTRIBUIÇÕES','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIASEFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE CONTRIBUICOES - VPD AS QUAIS NÃO CORRESPONDA CONTRAPRESTACAO DIRETA EM BENS E SERVICOS E NÃO SEJA REEMBOLSAVEL PELO RECEBEDOR, INCLUSIVE AS DESTINADAS A ATENDER A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE MANUTENÇÃO DE OUTRAS ENTIDADES DE DIREITO PÚBLICO OU PRIVADO, OBSERVADO O DISPOSTO NA LEGISLACÃO VIGENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.3.1.1.01.01.00.00.0000','INSTITUIÇÃO DE CARATER ASSISTENCIAL, CULTURAL E EDUCACIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIASEFETUADAS A INSTITUICOES DE CARATER ASSISTENCIAL, CULTURAL E EDUCACIONAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.3.1.1.01.10.00.00.0000','ORGANIZAÇÕES DE SOCIEDADE CIVIL DE INTERESSE PUBLICO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIASEFETUADAS A ORGANIZAÇÕES DE SOCIEDADE CIVIL DE INTERESSE PUBLICO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.3.1.1.01.99.00.00.0000','OUTRAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIASEFETUADAS A OUTRAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE CONTRIBUIÇÕES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.3.1.1.02.00.00.00.0000','AUXÍLIOS','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS DE CAPITAL AOS ENTES DA FEDERAÇÃO E A ENTIDADES PRIVADAS SEM FINS LUCRATIVOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.3.1.1.03.00.00.00.0000','SUBVENÇÕES SOCIAIS','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS CORRENTES ÀS ENTIDADES PÚBLICAS OU PRIVADAS SEM FINS LUCRATIVOS PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.3.2.0.00.00.00.00.0000','TRANSFERÊNCIAS A INSTITUICOES PRIVADAS COM FINS LUCRATIVOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERÊNCIAS DE BENS E VALORES A INSTITUICOES PRIVADAS COM FINS LUCRATIVOS QUE NÃO TENHAM VINCULOS COM ADMINISTRAÇÃO PÚBLICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.3.2.1.00.00.00.00.0000','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERÊNCIAS DE BENS E VALORES A INSTITUICOES PRIVADAS COM FINS LUCRATIVOS, QUE NÃO TENHAM VINCULOS COM A ADMINISTRAÇÃO PÚBLICA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.3.2.1.01.00.00.00.0000','SUBVENÇÕES ECONÔMICAS','REGISTRA AS VPDS COM O PAGAMENTO DE SUBVENÇÕES ECONÔMICAS, A QUALQUER TÍTULO, AUTORIZADAS EM LEIS ESPECÍFICAS, TAIS COMO: AJUDA FINANCEIRA A ENTIDADES PRIVADAS COM FINS LUCRATIVOS; CONCESSÃO DE BONIFICAÇÕES A PRODUTORES, DISTRIBUIDORES E VENDEDORES; COBERTURA, DIRETA OU INDIRETA, DE PARCELA DE ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS E DOS CUSTOS DE AQUISIÇÃO, DE PRODUÇÃO, DE ESCOAMENTO, DE DISTRIBUIÇÃO, DE VENDA E DE MANUTENÇÃO DE BENS, PRODUTOS E SERVIÇOS EM GERAL; E, AINDA, OUTRAS OPERAÇÕES COM CARACTERÍSTICAS SEMELHANTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.4.0.0.00.00.00.00.0000','TRANSFERÊNCIAS A INSTITUICOES MULTIGOVERNAMENTAIS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERÊNCIAS A INSTITUICOES MULTIGOVERNAMENTAIS, DAS QUAIS O ENTE TRANSFERIDOR NÃO PARTICIPE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.4.0.1.00.00.00.00.0000','TRANSFERÊNCIAS A INSTITUICOES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERÊNCIAS A INSTITUICOES MULTIGOVERNAMENTAIS, DAS QUAIS O ENTE TRANSFERIDOR NÃO PARTICIPE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.5.0.0.00.00.00.00.0000','TRANSFERÊNCIAS A CONSORCIOS PÚBLICOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERÊNCIAS A CONSORCIOS PÚBLICOS, DOS QUAIS O ENTE TRANSFERIDOR PARTICIPE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.5.0.1.00.00.00.00.0000','TRANSFERÊNCIAS A CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERÊNCIAS A CONSORCIOS PÚBLICOS, DOS QUAIS O ENTE TRANSFERIDOR PARTICIPE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.6.0.0.00.00.00.00.0000','TRANSFERÊNCIAS AO EXTERIOR','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERÊNCIAS A ORGANISMOS E FUNDOS INTERNACIONAIS, DE GOVERNOS ESTRANGEIROS E INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.6.0.1.00.00.00.00.0000','TRANSFERÊNCIAS AO EXTERIOR - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERÊNCIAS A ORGANISMOS E FUNDOS INTERNACIONAIS, DE GOVERNOS ESTRANGEIROS E INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS NO EXTERIOR. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM UNIDADE QUE NÃO PERTENÇA AO OFSS DE ENTE PÚBLICO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.0.0.00.00.00.00.0000','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERÊNCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO AOS ENTES ( UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS) OU CONSÓRCIOS PÚBLICOS PARA EXECUSÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.0.00.00.00.00.0000','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERÊNCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO AOS ENTES ( UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS) PARA EXECUSAÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.3.00.00.00.00.0000','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES – INTER OFSS - UNIÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERÊNCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO AOS ENTES ( UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS) PARA EXECUSAÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS). DE ENTES PÚBLICOS DISTINTOS,RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.3.01.00.00.00.0000','DIÁRIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE DIÁRIAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.3.02.00.00.00.0000','PASSAGENS E DESPESAS COM LOCOMOÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE PASSAGENS E DESPESAS COM LOCOMOÇÃO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.3.03.00.00.00.0000','MATERIAL DE CONSUMO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE MATERIAL DE CONSUMO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.3.04.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA FÍSICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.3.05.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA JURÍDICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.3.06.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE INDENIZAÇÕES E RESTITUIÇÕES DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.3.07.00.00.00.0000','DEMAIS VPD COM DELEGAÇÃO','REGISTRA AS DEMAIS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.4.00.00.00.00.0000','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES – INTER OFSS - ESTADO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERÊNCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO AOS ENTES ( UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS) PARA EXECUSAÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS). DE ENTES PÚBLICOS DISTINTOS,RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.4.01.00.00.00.0000','DIÁRIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE DIÁRIAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.4.02.00.00.00.0000','PASSAGENS E DESPESAS COM LOCOMOÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE PASSAGENS E DESPESAS COM LOCOMOÇÃO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.4.03.00.00.00.0000','MATERIAL DE CONSUMO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE MATERIAL DE CONSUMO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.4.04.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA FÍSICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.4.05.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA JURÍDICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.4.06.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE INDENIZAÇÕES E RESTITUIÇÕES DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.4.07.00.00.00.0000','DEMAIS VPD COM DELEGAÇÃO','REGISTRA AS DEMAIS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.5.00.00.00.00.0000','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES – INTER OFSS - MUNICÍPIO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERÊNCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO AOS ENTES ( UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS) PARA EXECUSAÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS). DE ENTES PÚBLICOS DISTINTOS,RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.5.01.00.00.00.0000','DIÁRIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE DIÁRIAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.5.02.00.00.00.0000','PASSAGENS E DESPESAS COM LOCOMOÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE PASSAGENS E DESPESAS COM LOCOMOÇÃO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.5.03.00.00.00.0000','MATERIAL DE CONSUMO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE MATERIAL DE CONSUMO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.5.04.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA FÍSICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.5.05.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA JURÍDICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.5.06.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE INDENIZAÇÕES E RESTITUIÇÕES DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.1.5.07.00.00.00.0000','DEMAIS VPD COM DELEGAÇÃO','REGISTRA AS DEMAIS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.2.0.00.00.00.00.0000','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERÊNCIA DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO AOS CONSÓRCIOS PÚBLICOS PARA EXECUSAÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.2.1.00.00.00.00.0000','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERÊNCIA DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO AOS CONSÓRCIOS PÚBLICOS PARA EXECUSAÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM UNIDADE QUE NÃO PERTENÇA AO OFSS DE ENTE PÚBLICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.2.1.01.00.00.00.0000','DIÁRIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE DIÁRIAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.2.1.02.00.00.00.0000','PASSAGENS E DESPESAS COM LOCOMOÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE PASSAGENS E DESPESAS COM LOCOMOÇÃO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.2.1.03.00.00.00.0000','MATERIAL DE CONSUMO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE MATERIAL DE CONSUMO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.2.1.04.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA FÍSICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.2.1.05.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA JURÍDICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.2.1.06.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DE INDENIZAÇÕES E RESTITUIÇÕES DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.5.7.2.1.07.00.00.00.0000','DEMAIS VPD COM DELEGAÇÃO','REGISTRA AS DEMAIS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.0.0.0.00.00.00.00.0000','DESVALORIZAÇÃO E PERDA DE ATIVOS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM DESVALORIZAÇÃO E PERDAS DE ATIVOS, COM REDUÇÃO A VALOR RECUPERAVEL, COM PROVISÕES PARA PERDAS, PERDAS COM ALIENAÇÃO E PERDAS INVOLUNTARIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.0.0.00.00.00.00.0000','REAVALIAÇÃO, REDUÇÃO A VALOR RECUPERÁVEL E AJUSTE PARA PERDAS','COMPREENDE O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ITENS DO ATIVO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE OS ATIVOS NÃO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA E TAMBÉM REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AJUSTES PARA PERDAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.0.00.00.00.00.0000','REAVALIAÇÃO DE IMOBILIZADO','COMPREENDE O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NÃO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.00.00.00.00.0000','REAVALIAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','REGISTRA O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NÃO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.01.00.00.00.0000','REAVALIAÇÃO DE BENS MÓVEIS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS MÓVEIS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.01.01.00.00.0000','REAVALIAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA MÁQUINAS, FERRAMENTAS, APARELHOS, EQUIPAMENTOS, ACESSÓRIOS ETC, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.01.02.00.00.0000','REAVALIAÇÃO DE BENS DE INFORMÁTICA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E SISTEMAS APLICATIVOS, ENTRE OUTROS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.01.03.00.00.0000','REAVALIAÇÃO DE MÓVEIS E UTENSÍLIOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA MOBILIÁRIO EM GERAL E UTENSÍLIOS, ENTRE OUTROS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.01.04.00.00.0000','REAVALIAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA MATERIAIS BIBLIOGRÁFICOS, DISCOTECAS, FILMOTECAS, DE COMUNICAÇÃO, ENTRE OUTROS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.01.05.00.00.0000','REAVALIAÇÃO DE VEÍCULOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA TRANSPORTES AÉREOS, AQUÁTICOS E TERRESTRES, ENTRE OUTROS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.01.06.00.00.0000','REAVALIAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA PEÇAS E CONJUNTOS DE REPOSIÇÃO DESTINADOS A SUBSTITUIÇÃO EM MÁQUINAS E EQUIPAMENTOS, AERONAVES E EMBARCAÇÕES, BENS DE SEGURANÇA E SOCORRO, ENTRE OUTROS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.01.07.00.00.0000','REAVALIAÇÃO DE BENS MÓVEIS EM ANDAMENTO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS MÓVEIS EM ANDAMENTO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.01.08.00.00.0000','REAVALIAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS PERMANENTES A SEREM ESTOCADOS EM ALMOXARIFADO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.01.09.00.00.0000','REAVALIAÇÃO DE ARMAMENTOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ARMAS QUE CONSTITUEM OBJETOS DE DEFESA OU PREPARATIVOS DE GUERRA, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.01.10.00.00.0000','REAVALIAÇÃO DE SEMOVENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ANIMAIS DESTINADOS A PRODUÇÃO, REPRODUÇÃO, ENGORDA E AOS SERVIÇOS UTILITÁRIOS EM GERAL, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.01.99.00.00.0000','REAVALIAÇÃO DE DEMAIS BENS MÓVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA DEMAIS BENS MÓVEIS NÃO CLASSIFICADOS EM GRUPOS ESPECÍFICOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.02.00.00.00.0000','REAVALIAÇÃO DE BENS IMÓVEIS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS IMÓVEIS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.02.01.00.00.0000','REAVALIAÇÃO DE BENS DE USO ESPECIAL','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OS BENS, TAIS COMO EDIFÍCIOS OU TERRENOS DESTINADOS A SERVIÇO OU ESTABELECIMENTO DA ADMINISTRAÇÃO ESTADUAL OU MUNICIPAL, INCLUSIVE OS DE SUAS AUTARQUIAS E FUNDAÇÕES PÚBLICAS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.02.02.00.00.0000','REAVALIAÇÃO DE BENS DOMINICAIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OS BENS QUE CONSTITUEM O PATRIMÔNIO DAS PESSOAS JURÍDICAS DE DIREITO PÚBLICO, COMO OBJETO DE DIREITO PESSOAL, OU REAL, DE CADA UMA DESSAS ENTIDADES. COMPREENDE AINDA, NÃO DISPONDO A LEI EM CONTRÁRIO, OS BENS PERTENCENTES AS PESSOAS JURÍDICAS DE DIREITO PÚBLICO A QUE SE TENHA DADO ESTRUTURA DE DIREITO PRIVADO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.02.03.00.00.0000','REAVALIAÇÃO DE BENS DE USO COMUM DO POVO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OS BENS DE USO COMUM DO POVO CONSTRUÍDOS OU ADQUIRIDOS POR PESSOAS JURÍDICAS DE DIREITO PÚBLICO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.02.04.00.00.0000','REAVALIAÇÃO DE BENS IMÓVEIS EM ANDAMENTO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OS VALORES DE BENS IMÓVEIS EM ANDAMENTO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.02.05.00.00.0000','REAVALIAÇÃO DE INSTALAÇÕES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA EQUIPAMENTOS, MATERIAIS E CUSTO DE IMPLANTAÇÃO DE INSTALAÇÕES QUE, NÃO OBSTANTE INTEGRADAS AOS EDIFÍCIOS, DEVEM SER SEGREGADAS DAS OBRAS CIVIS, COMO, POR EXEMPLO, AS INSTALAÇÕES ELÉTRICAS, HIDRÁULICAS, SANITÁRIAS, DE VAPOR, DE AR COMPRIMIDO, FRIGORÍFICAS, CONTRA INCÊNDIO, DE COMUNICAÇÕES, DE CLIMATIZAÇÃO, PARA COMBUSTÍVEIS, GASES, DE ANTIPOLUIÇÃO, PARA COZINHA, DENTRE OUTROS. E TAMBÉM APLICÁVEL A CONSTRUÇÃO DE TRECHOS FERROVIÁRIOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.02.06.00.00.0000','REAVALIAÇÃO DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA CONSTRUÇÕES EM TERRENOS ARRENDADOS DE TERCEIROS E INSTALAÇÕES E OUTRAS BENFEITORIAS EM PRÉDIOS ALUGADOS. SÃO CONSIDERADOS SOMENTE OS GASTOS COM CONSTRUÇÃO E INSTALAÇÃO QUE SE INCORPORAM AO IMÓVEL E REVERTEM AO PROPRIETÁRIO DO IMÓVEL AO FINAL DA LOCAÇÃO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.1.1.02.99.00.00.0000','REAVALIAÇÃO DE DEMAIS BENS IMÓVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OS DEMAIS BENS IMÓVEIS NÃO CLASSIFICADOS ANTERIORMENTE NESSE PLANO DE CONTAS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.2.0.00.00.00.00.0000','REAVALIAÇÃO DE INTANGÍVEIS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ATIVOS INTANGÍVEIS, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTÁBIL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.2.1.00.00.00.00.0000','REAVALIAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ATIVOS INTANGÍVEIS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.3.0.00.00.00.00.0000','REAVALIAÇÃO DE OUTROS ATIVOS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OUTROS ATIVOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.3.1.00.00.00.00.0000','REAVALIAÇÃO DE OUTROS ATIVOS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OUTROS ATIVOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.0.00.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A REDUÇÃO NOS BENEFÍCIOS ECONÔMICOS FUTUROS OU NO POTENCIAL DE SERVIÇOS DE UM INVESTIMENTO, QUE REFLETE UM DECLÍNIO NA SUA UTILIDADE ALÉM DO RECONHECIMENTO SISTEMÁTICO POR MEIO DA DEPRECIAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.1.00.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A REDUÇÃO NOS BENEFÍCIOS ECONÔMICOS FUTUROS OU NO POTENCIAL DE SERVIÇOS DE UM INVESTIMENTO, QUE REFLETE UM DECLÍNIO NA SUA UTILIDADE ALÉM DO RECONHECIMENTO SISTEMÁTICO POR MEIO DA DEPRECIAÇÃO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.1.01.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES EM OUTRAS ENTIDADES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.1.02.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.1.03.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.1.04.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.2.00.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTRA OFSS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A REDUÇÃO NOS BENEFÍCIOS ECONÔMICOS FUTUROS OU NO POTENCIAL DE SERVIÇOS DE UM INVESTIMENTO, QUE REFLETE UM DECLÍNIO NA SUA UTILIDADE ALÉM DO RECONHECIMENTO SISTEMÁTICO POR MEIO DA DEPRECIAÇÃO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.2.01.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES EM OUTRAS ENTIDADES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.2.02.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.2.03.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.2.04.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.3.00.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS- UNIÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A REDUÇÃO NOS BENEFÍCIOS ECONÔMICOS FUTUROS OU NO POTENCIAL DE SERVIÇOS DE UM INVESTIMENTO, QUE REFLETE UM DECLÍNIO NA SUA UTILIDADE ALÉM DO RECONHECIMENTO SISTEMÁTICO POR MEIO DA DEPRECIAÇÃO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.3.01.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES EM OUTRAS ENTIDADES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.3.02.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.3.03.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.3.04.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.4.00.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS- ESTADO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A REDUÇÃO NOS BENEFÍCIOS ECONÔMICOS FUTUROS OU NO POTENCIAL DE SERVIÇOS DE UM INVESTIMENTO, QUE REFLETE UM DECLÍNIO NA SUA UTILIDADE ALÉM DO RECONHECIMENTO SISTEMÁTICO POR MEIO DA DEPRECIAÇÃO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.4.01.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES EM OUTRAS ENTIDADES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.4.02.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.4.03.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.4.04.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.5.00.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS- MUNICÍPIO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A REDUÇÃO NOS BENEFÍCIOS ECONÔMICOS FUTUROS OU NO POTENCIAL DE SERVIÇOS DE UM INVESTIMENTO, QUE REFLETE UM DECLÍNIO NA SUA UTILIDADE ALÉM DO RECONHECIMENTO SISTEMÁTICO POR MEIO DA DEPRECIAÇÃO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.5.01.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES EM OUTRAS ENTIDADES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.5.02.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.5.03.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.4.5.04.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.0.00.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A REDUÇÃO NOS BENEFÍCIOS ECONÔMICOS FUTUROS OU NO POTENCIAL DE SERVIÇOS DE UM ATIVO IMOBILIZADO, QUE REFLETE UM DECLÍNIO NA SUA UTILIDADE ALÉM DO RECONHECIMENTO SISTEMÁTICO POR MEIO DA DEPRECIAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.00.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A REDUÇÃO NOS BENEFÍCIOS ECONÔMICOS FUTUROS OU NO POTENCIAL DE SERVIÇOS DE UM ATIVO IMOBILIZADO, QUE REFLETE UM DECLÍNIO NA SUA UTILIDADE ALÉM DO RECONHECIMENTO SISTEMÁTICO POR MEIO DA DEPRECIAÇÃO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.01.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A REDUÇÃO NOS BENEFÍCIOS ECONÔMICOS FUTUROS OU NO POTENCIAL DE SERVIÇOS DE BENS MÓVEIS, QUE REFLETE UM DECLÍNIO NA SUA UTILIDADE ALÉM DO RECONHECIMENTO SISTEMÁTICO POR MEIO DA DEPRECIAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.01.01.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE MÁQUINAS, FERRAMENTAS, APARELHOS, EQUIPAMENTOS, ACESSÓRIOS ETC.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.01.02.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE INFORMÁTICA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E SISTEMAS APLICATIVOS, ENTRE OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.01.03.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE MÓVEIS E UTENSÍLIOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E SISTEMAS APLICATIVOS, ENTRE OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.01.04.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE MATERIAIS BIBLIOGRÁFICOS, DISCOTECAS, FILMOTECAS, DE COMUNICAÇÃO, ENTRE OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.01.05.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE VEÍCULOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE TRANSPORTES AÉREOS, AQUÁTICOS E TERRESTRES, ENTRE OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.01.06.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE PEÇAS E CONJUNTOS DE REPOSIÇÃO DESTINADOS A SUBSTITUIÇÃO EM MÁQUINAS E EQUIPAMENTOS, AERONAVES E EMBARCAÇÕES, BENS DE SEGURANÇA E SOCORRO, ENTRE OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.01.07.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ANDAMENTO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ANDAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.01.08.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ALMOXARIFADO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE BENS PERMANENTES A SEREM ESTOCADOS EM ALMOXARIFADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.01.09.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE ARMAMENTOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE ARMAS QUE CONSTITUEM OBJETOS DE DEFESA OU PREPARATIVOS DE GUERRA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.01.10.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE SEMOVENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE ANIMAIS DESTINADOS A PRODUÇÃO, REPRODUÇÃO, ENGORDA E AOS SERVIÇOS UTILITÁRIOS EM GERAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.01.99.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS MÓVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS MÓVEIS NÃO CLASSIFICADOS EM GRUPOS ESPECÍFICOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.02.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A REDUÇÃO NOS BENEFÍCIOS ECONÔMICOS FUTUROS OU NO POTENCIAL DE SERVIÇOS DE BENS IMÓVEIS, QUE REFLETE UM DECLÍNIO NA SUA UTILIDADE ALÉM DO RECONHECIMENTO SISTEMÁTICO POR MEIO DA DEPRECIAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.02.01.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO ESPECIAL','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE BENS COMO EDIFÍCIOS OU TERRENOS DESTINADOS A SERVIÇO OU ESTABELECIMENTO DA ADMINISTRAÇÃO ESTADUAL OU MUNICIPAL, INCLUSIVE OS DE SUAS AUTARQUIAS E FUNDAÇÕES PÚBLICAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.02.02.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DOMINICAIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE BENS QUE CONSTITUEM O PATRIMÔNIO DAS PESSOAS JURÍDICAS DE DIREITO PÚBLICO, COMO OBJETO DE DIREITO PESSOAL, OU REAL, DE CADA UMA DESSAS ENTIDADES. COMPREENDE AINDA, NÃO DISPONDO A LEI EM CONTRÁRIO, OS BENS PERTENCENTES AS PESSOAS JURÍDICAS DE DIREITO PÚBLICO A QUE SE TENHA DADO ESTRUTURA DE DIREITO PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.02.03.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO COMUM DO POVO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO COMUM DO POVO CONSTRUÍDOS OU ADQUIRIDOS POR PESSOAS JURÍDICAS DE DIREITO PÚBLICO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.02.04.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS EM ANDAMENTO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE VALORES DE BENS IMÓVEIS EM ANDAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.02.05.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE INSTALAÇÕES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE EQUIPAMENTOS, MATERIAIS E CUSTO DE IMPLANTAÇÃO DE INSTALAÇÕES QUE, NÃO OBSTANTE INTEGRADAS AOS EDIFÍCIOS, DEVEM SER SEGREGADAS DAS OBRAS CIVIS, COMO, POR EXEMPLO, AS INSTALAÇÕES ELÉTRICAS, HIDRÁULICAS, SANITÁRIAS, DE VAPOR, DE AR COMPRIMIDO, FRIGORÍFICAS, CONTRA INCÊNDIO, DE COMUNICAÇÕES, DE CLIMATIZAÇÃO, PARA COMBUSTÍVEIS, GASES, DE ANTIPOLUIÇÃO, PARA COZINHA, DENTRE OUTROS. E TAMBÉM APLICÁVEL A CONSTRUÇÃO DE TRECHOS FERROVIÁRIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.02.06.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE CONSTRUÇÕES EM TERRENOS ARRENDADOS DE TERCEIROS E INSTALAÇÕES E OUTRAS BENFEITORIAS EM PRÉDIOS ALUGADOS. SÃO CONSIDERADOS SOMENTE OS GASTOS COM CONSTRUÇÃO E INSTALAÇÃO QUE SE INCORPORAM AO IMÓVEL E REVERTEM AO PROPRIETÁRIO DO IMÓVEL AO FINAL DA LOCAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.5.1.02.99.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS IMÓVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA À REDUÇÃO A VALOR RECUPERÁVEL DE OS DEMAIS BENS IMÓVEIS NÃO CLASSIFICADOS ANTERIORMENTE NESSE PLANO DE CONTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.6.0.00.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A REDUÇÃO NOS BENEFÍCIOS ECONÔMICOS FUTUROS OU NO POTENCIAL DE SERVIÇOS DE UM ATIVO INTANGÍVEL, QUE REFLETE UM DECLÍNIO NA SUA UTILIDADE ALÉM DO RECONHECIMENTO SISTEMÁTICO POR MEIO DA DEPRECIAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.6.1.00.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A REDUÇÃO NOS BENEFÍCIOS ECONÔMICOS FUTUROS OU NO POTENCIAL DE SERVIÇOS DE UM ATIVO INTANGÍVEL, QUE REFLETE UM DECLÍNIO NA SUA UTILIDADE ALÉM DO RECONHECIMENTO SISTEMÁTICO POR MEIO DA DEPRECIAÇÃO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.6.1.01.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE SOFTWARES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A REDUÇÃO NOS BENEFÍCIOS ECONÔMICOS FUTUROS OU NO POTENCIAL DE SERVIÇOS DE SOFTWARES, QUE REFLETE UM DECLÍNIO NA SUA UTILIDADE ALÉM DO RECONHECIMENTO SISTEMÁTICO POR MEIO DA DEPRECIAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.6.1.02.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE MARCAS, DIREITOS E PATÉNTES','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A REDUÇÃO NOS BENEFÍCIOS ECONÔMICOS FUTUROS OU NO POTENCIAL DE SERVIÇOS DE UM ATIVO INTANGÍVEL, QUE REFLETE UM DECLÍNIO NA SUA UTILIDADE ALÉM DO RECONHECIMENTO SISTEMÁTICO POR MEIO DA DEPRECIAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.6.1.03.00.00.00.0000','REDUÇÃO A VALOR RECUPERÁVEL DE DIREITO DE USO DE IMÓVEIS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A REDUÇÃO NOS BENEFÍCIOS ECONÔMICOS FUTUROS OU NO POTENCIAL DE SERVIÇOS DE UM ATIVO INTANGÍVEL, QUE REFLETE UM DECLÍNIO NA SUA UTILIDADE ALÉM DO RECONHECIMENTO SISTEMÁTICO POR MEIO DA DEPRECIAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.0.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS POR INADIMPLÊNCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CRÉDITOS. POR EXEMPLO, A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA CRÉDITOS DE LIQUIDAÇÃO DUVIDOSA E AJUSTE PARA CRÉDITOS DA DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS POR INADIMPLÊNCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CRÉDITOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.01.00.00.00.0000','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.02.00.00.00.0000','AJUSTE PARA PERDAS EM CLIENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS CRÉDITOS RELATIVOS A CLIENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.03.00.00.00.0000','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.04.00.00.00.0000','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.00.00.00.0000','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM CRÉDITOS DA DIVIDA ATIVA TRIBUTÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.01.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.02.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - MULTA','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.03.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - JUROS','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.04.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.05.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSÃO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.06.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - MULTA','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSÃO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.07.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - JUROS','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.08.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS AS ANISTIAS/REMISSÕES DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.09.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.10.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - MULTA','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.11.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - JUROS','REGISTRA OS VALORES RELATIVOS AS ADJUDICAÇÕES DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.12.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.13.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A ANULAÇÃO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.14.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - MULTA','REGISTRA OS VALORES RELATIVOS A ANULAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.15.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - JUROS','REGISTRA OS VALORES RELATIVOS AS ANULAÇÕES DOS CRÉDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.16.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A ANULAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.17.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.18.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - MULTA','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.19.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - JUROS','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.20.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.21.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A EXTINÇÃO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.22.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - MULTA','REGISTRA OS VALORES RELATIVOS A EXTINÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.23.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - JUROS','REGISTRA OS VALORES RELATIVOS AS EXTINÇÕES DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.24.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A EXTINÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.25.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.26.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - MULTA','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.27.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - JUROS','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.05.28.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - ATUALIZ. MONETARIA','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.06.00.00.00.0000','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.1.99.00.00.00.0000','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM OUTROS CRÉDITOS, NÃO ESPECIFICADOS ACIMA, POR INADIMPLÊNCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CRÉDITOS, POR EXEMPLO, AJUSTE PARA CRÉDITOS DE LIQUIDAÇÃO DUVIDOSA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTRA OFSS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS POR INADIMPLÊNCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CRÉDITOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.01.00.00.00.0000','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.02.00.00.00.0000','AJUSTE PARA PERDAS EM CLIENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS CRÉDITOS RELATIVOS A CLIENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.03.00.00.00.0000','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.04.00.00.00.0000','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.00.00.00.0000','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM CRÉDITOS DA DIVIDA ATIVA TRIBUTÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.01.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.02.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - MULTA','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.03.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - JUROS','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.04.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.05.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSÃO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.06.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - MULTA','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSÃO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.07.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - JUROS','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.08.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS AS ANISTIAS/REMISSÕES DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.09.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.10.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - MULTA','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.11.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - JUROS','REGISTRA OS VALORES RELATIVOS AS ADJUDICAÇÕES DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.12.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.13.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A ANULAÇÃO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.14.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - MULTA','REGISTRA OS VALORES RELATIVOS A ANULAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.15.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - JUROS','REGISTRA OS VALORES RELATIVOS AS ANULAÇÕES DOS CRÉDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.16.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A ANULAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.17.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.18.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - MULTA','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.19.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - JUROS','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.20.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.21.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A EXTINÇÃO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.22.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - MULTA','REGISTRA OS VALORES RELATIVOS A EXTINÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.23.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - JUROS','REGISTRA OS VALORES RELATIVOS AS EXTINÇÕES DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.24.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A EXTINÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.25.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.26.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - MULTA','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.27.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - JUROS','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.05.28.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - ATUALIZ. MONETARIA','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.06.00.00.00.0000','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.2.99.00.00.00.0000','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM OUTROS CRÉDITOS, NÃO ESPECIFICADOS ACIMA, POR INADIMPLÊNCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CRÉDITOS, POR EXEMPLO, AJUSTE PARA CRÉDITOS DE LIQUIDAÇÃO DUVIDOSA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - UNIÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS POR INADIMPLÊNCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CRÉDITOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.01.00.00.00.0000','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.02.00.00.00.0000','AJUSTE PARA PERDAS EM CLIENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS CRÉDITOS RELATIVOS A CLIENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.03.00.00.00.0000','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.04.00.00.00.0000','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.00.00.00.0000','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM CRÉDITOS DA DIVIDA ATIVA TRIBUTÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.01.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.02.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - MULTA','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.03.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - JUROS','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.04.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.05.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSÃO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.06.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - MULTA','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSÃO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.07.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - JUROS','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.08.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS AS ANISTIAS/REMISSÕES DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.09.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.10.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - MULTA','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.11.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - JUROS','REGISTRA OS VALORES RELATIVOS AS ADJUDICAÇÕES DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.12.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.13.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A ANULAÇÃO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.14.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - MULTA','REGISTRA OS VALORES RELATIVOS A ANULAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.15.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - JUROS','REGISTRA OS VALORES RELATIVOS AS ANULAÇÕES DOS CRÉDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.16.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A ANULAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.17.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.18.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - MULTA','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.19.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - JUROS','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.20.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.21.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A EXTINÇÃO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.22.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - MULTA','REGISTRA OS VALORES RELATIVOS A EXTINÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.23.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - JUROS','REGISTRA OS VALORES RELATIVOS AS EXTINÇÕES DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.24.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A EXTINÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.25.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.26.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - MULTA','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.27.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - JUROS','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.05.28.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - ATUALIZ. MONETARIA','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.06.00.00.00.0000','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.3.99.00.00.00.0000','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM OUTROS CRÉDITOS, NÃO ESPECIFICADOS ACIMA, POR INADIMPLÊNCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CRÉDITOS, POR EXEMPLO, AJUSTE PARA CRÉDITOS DE LIQUIDAÇÃO DUVIDOSA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - ESTADO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS POR INADIMPLÊNCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CRÉDITOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.01.00.00.00.0000','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.02.00.00.00.0000','AJUSTE PARA PERDAS EM CLIENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS CRÉDITOS RELATIVOS A CLIENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.03.00.00.00.0000','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.04.00.00.00.0000','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.00.00.00.0000','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM CRÉDITOS DA DIVIDA ATIVA TRIBUTÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.01.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.02.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - MULTA','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.03.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - JUROS','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.04.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.05.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSÃO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.06.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - MULTA','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSÃO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.07.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - JUROS','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.08.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS AS ANISTIAS/REMISSÕES DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.09.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.10.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - MULTA','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.11.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - JUROS','REGISTRA OS VALORES RELATIVOS AS ADJUDICAÇÕES DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.12.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.13.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A ANULAÇÃO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.14.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - MULTA','REGISTRA OS VALORES RELATIVOS A ANULAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.15.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - JUROS','REGISTRA OS VALORES RELATIVOS AS ANULAÇÕES DOS CRÉDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.16.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A ANULAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.17.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.18.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - MULTA','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.19.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - JUROS','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.20.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.21.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A EXTINÇÃO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.22.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - MULTA','REGISTRA OS VALORES RELATIVOS A EXTINÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.23.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - JUROS','REGISTRA OS VALORES RELATIVOS AS EXTINÇÕES DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.24.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A EXTINÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.25.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.26.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - MULTA','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.27.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - JUROS','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.05.28.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - ATUALIZ. MONETARIA','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.06.00.00.00.0000','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.4.99.00.00.00.0000','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM OUTROS CRÉDITOS, NÃO ESPECIFICADOS ACIMA, POR INADIMPLÊNCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CRÉDITOS, POR EXEMPLO, AJUSTE PARA CRÉDITOS DE LIQUIDAÇÃO DUVIDOSA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - MUNICÍPIO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS POR INADIMPLÊNCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CRÉDITOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.01.00.00.00.0000','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.02.00.00.00.0000','AJUSTE PARA PERDAS EM CLIENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS CRÉDITOS RELATIVOS A CLIENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.03.00.00.00.0000','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.04.00.00.00.0000','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.00.00.00.0000','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM CRÉDITOS DA DIVIDA ATIVA TRIBUTÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.01.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.02.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - MULTA','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.03.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - JUROS','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.04.00.00.0000','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.05.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSÃO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.06.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - MULTA','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSÃO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.07.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - JUROS','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.08.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS AS ANISTIAS/REMISSÕES DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.09.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.10.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - MULTA','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.11.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - JUROS','REGISTRA OS VALORES RELATIVOS AS ADJUDICAÇÕES DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.12.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.13.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A ANULAÇÃO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.14.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - MULTA','REGISTRA OS VALORES RELATIVOS A ANULAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.15.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - JUROS','REGISTRA OS VALORES RELATIVOS AS ANULAÇÕES DOS CRÉDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.16.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ANULACAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A ANULAÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.17.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.18.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - MULTA','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.19.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - JUROS','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.20.00.00.0000','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A PRESCRIÇÃO INTERCORRENTE DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.21.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS A EXTINÇÃO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.22.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - MULTA','REGISTRA OS VALORES RELATIVOS A EXTINÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.23.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - JUROS','REGISTRA OS VALORES RELATIVOS AS EXTINÇÕES DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.24.00.00.0000','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - ATUALIZACAO MONETARIA','REGISTRA OS VALORES RELATIVOS A EXTINÇÃO DOS CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.25.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - PRINCIPAL','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - PRINCIPAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.26.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - MULTA','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - MULTA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.27.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - JUROS','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - JUROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.05.28.00.00.0000','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - ATUALIZ. MONETARIA','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CRÉDITOS INSCRITOS NA DÍVIDA ATIVA TRIBUTÁRIA - ATUALIZAÇÃO MONETÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.06.00.00.00.0000','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.7.5.99.00.00.00.0000','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS EM OUTROS CRÉDITOS, NÃO ESPECIFICADOS ACIMA, POR INADIMPLÊNCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CRÉDITOS, POR EXEMPLO, AJUSTE PARA CRÉDITOS DE LIQUIDAÇÃO DUVIDOSA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.8.0.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA REDUÇÃO A VALOR DE MERCADO DE ESTOQUES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.8.1.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS DE ESTOQUES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.8.1.01.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE MERCADORIAS PARA REVENDA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS DE MERCADORIAS PARA REVENDA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.8.1.02.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE PRODUTOS E SERVIÇOS ACABADOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS DE PRODUTOS E SERVIÇOS ACABADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.8.1.03.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE PRODUTOS E SERVIÇOS EM ELABORAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS DE PRODUTOS E SERVIÇOS EM ELABORAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.8.1.04.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE MATÉRIAS-PRIMAS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS DE MATÉRIAS-PRIMAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.8.1.05.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE MATERIAIS EM TRÂNSITO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS DE MATERIAIS EM TRÂNSITO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.8.1.06.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ALMOXARIFADO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS DE ALMOXARIFADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.8.1.07.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ADIANTAMENTOS A FORNECEDORES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS DE ADIANTAMENTOS A FORNECEDORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.1.8.1.08.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE OUTROS ESTOQUES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS DE OUTROS ESTOQUES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.0.0.00.00.00.00.0000','PERDAS COM ALIENAÇÃO','COMPREENDE A PERDA COM ALIENAÇÃO DE ATIVOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE A PERDA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.1.0.00.00.00.00.0000','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS','COMPREENDE A PERDA COM ALIENAÇÃO DE INVESTIMENTOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE A PERDA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.1.1.00.00.00.00.0000','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','COMPREENDE A PERDA COM ALIENAÇÃO DE INVESTIMENTOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.1.1.01.00.00.00.0000','PERDAS COM ALIENAÇÃO DE PARTICIPAÇÕES PERMANENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE PARTICIPAÇÕES PERMANENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.1.1.02.00.00.00.0000','PERDAS COM ALIENAÇÃO DE PROPRIEDADES PARA INVESTIMENTO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE PROPRIEDADES PARA INVESTIMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.1.1.03.00.00.00.0000','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE INVESTIMENTOS DO RPPS DE LONGO PRAZO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.1.1.04.00.00.00.0000','PERDAS COM ALIENAÇÃO DE DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE DEMAIS INVESTIMENTOS PERMANENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.2.0.00.00.00.00.0000','PERDAS COM ALIENAÇÃO DE IMOBILIZADO','COMPREENDE A PERDA COM ALIENAÇÃO DE ATIVOS IMOBILIZADOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.2.1.00.00.00.00.0000','PERDAS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','REGISTRA A PERDA COM ALIENAÇÃO DE ATIVOS IMOBILIZADOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.2.1.01.00.00.00.0000','PERDAS COM ALIENAÇÃO DE BENS MOVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE BENS MÓVEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.2.1.01.01.00.00.0000','PERDAS COM ALIENAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.2.1.01.02.00.00.0000','PERDAS COM ALIENAÇÃO DE BENS DE INFORMÁTICA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE BENS DE INFORMÁTICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.2.1.01.03.00.00.0000','PERDAS COM ALIENAÇÃO DE MÓVEIS E UTENSÍLIOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE MÓVEIS E UTENSÍLIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.2.1.01.04.00.00.0000','PERDAS COM ALIENAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.2.1.01.05.00.00.0000','PERDAS COM ALIENAÇÃO DE VEÍCULOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE VEÍCULOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.2.1.01.06.00.00.0000','PERDAS COM ALIENAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.2.1.01.07.00.00.0000','PERDAS COM ALIENAÇÃO DE BENS MÓVEIS EM ANDAMENTO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE MÓVEIS EM ANDAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.2.1.01.08.00.00.0000','PERDAS COM ALIENAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.2.1.01.09.00.00.0000','PERDAS COM ALIENAÇÃO DE ARMAMENTOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE ARMAMENTOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.2.1.01.10.00.00.0000','PERDAS COM ALIENAÇÃO DE SEMOVENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE SEMOVENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.2.1.01.99.00.00.0000','PERDAS COM ALIENAÇÃO DE DEMAIS BENS MÓVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE DEMAIS BENS MÓVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.2.1.02.00.00.00.0000','PERDAS COM ALIENAÇÃO DE BENS IMÓVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE BENS IMÓVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.3.0.00.00.00.00.0000','PERDAS COM ALIENAÇÃO DE INTANGIVEIS','COMPREENDE A PERDA COM ALIENAÇÃO DE ATIVOS INTANGIVEIS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.3.1.00.00.00.00.0000','PERDAS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','COMPREENDE A PERDA COM ALIENAÇÃO DE ATIVOS INTANGIVEIS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO É MENOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.3.1.01.00.00.00.0000','PERDAS COM ALIENAÇÃO DE SOFTWARES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE SOFTWARES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.3.1.02.00.00.00.0000','PERDAS COM ALIENAÇÃO DE MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE MARCAS, DIREITOS E PATENTES INDUSTRIAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.2.3.1.03.00.00.00.0000','PERDAS COM ALIENAÇÃO DE DIREITO DE USO DE IMÓVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS COM ALIENAÇÃO DE DIREITO DE USO DE IMÓVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.0.0.00.00.00.00.0000','PERDAS INVOLUNTÁRIAS','COMPREENDEM O DESFAZIMENTO FÍSICO INVOLUNTÁRIO DO BEM, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDAÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.1.0.00.00.00.00.0000','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO','COMPREENDEM O DESFAZIMENTO FÍSICO INVOLUNTÁRIO DE BEM DO ATIVO IMOBILIZADO, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDAÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.1.1.00.00.00.00.0000','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO - CONSOLIDAÇÃO','REGISTRA O DESFAZIMENTO FÍSICO INVOLUNTÁRIO DE BEM DO ATIVO IMOBILIZADO, COMO O QUE RESULTA DE SINISTROS COMO INCÊNDIO E INUNDAÇÕES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.1.1.01.00.00.00.0000','PERDAS INVOLUNTÁRIAS DE BENS MOVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS INVOLUNTÁRIAS DE BENS MÓVEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.1.1.01.01.00.00.0000','PERDAS INVOLUNTÁRIAS DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS INVOLUNTÁRIAS DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.1.1.01.02.00.00.0000','PERDAS INVOLUNTÁRIAS DE BENS DE INFORMÁTICA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS INVOLUNTÁRIAS DE BENS DE INFORMÁTICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.1.1.01.03.00.00.0000','PERDAS INVOLUNTÁRIAS DE MÓVEIS E UTENSÍLIOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS INVOLUNTÁRIAS DE MÓVEIS E UTENSÍLIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.1.1.01.04.00.00.0000','PERDAS INVOLUNTÁRIAS DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS INVOLUNTÁRIAS DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.1.1.01.05.00.00.0000','PERDAS INVOLUNTÁRIAS DE VEÍCULOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS INVOLUNTÁRIAS DE VEÍCULOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.1.1.01.06.00.00.0000','PERDAS INVOLUNTÁRIAS DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS INVOLUNTÁRIAS DE PEÇAS E CONJUNTOS DE REPOSIÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.1.1.01.07.00.00.0000','PERDAS INVOLUNTÁRIAS DE BENS MÓVEIS EM ANDAMENTO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS INVOLUNTÁRIAS DE MÓVEIS EM ANDAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.1.1.01.08.00.00.0000','PERDAS INVOLUNTÁRIAS DE BENS MÓVEIS EM ALMOXARIFADO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS INVOLUNTÁRIAS DE BENS MÓVEIS EM ALMOXARIFADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.1.1.01.09.00.00.0000','PERDAS INVOLUNTÁRIAS DE ARMAMENTOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS INVOLUNTÁRIAS DE ARMAMENTOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.1.1.01.10.00.00.0000','PERDAS INVOLUNTÁRIAS DE SEMOVENTES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS INVOLUNTÁRIAS DE SEMOVENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.1.1.01.99.00.00.0000','PERDAS INVOLUNTÁRIAS DE DEMAIS BENS MÓVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS INVOLUNTÁRIAS DE DEMAIS BENS MÓVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.1.1.02.00.00.00.0000','PERDAS INVOLUNTÁRIAS DE BENS IMÓVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA DE PERDAS INVOLUNTÁRIAS DE BENS IMÓVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.2.0.00.00.00.00.0000','PERDAS INVOLUNTARIAS COM INTANGIVEIS','COMPREENDEM O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ATIVO INTANGIVEL, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDAÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.2.1.00.00.00.00.0000','PERDAS INVOLUNTÁRIAS COM INTANGÍVEIS - CONSOLIDAÇÃO','REGISTRA O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ATIVO INTANGIVEL, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDAÇÕES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.2.1.01.00.00.00.0000','PERDAS INVOLUNTÁRIAS COM SOFTWARES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM PERDAS INVOLUNTÁRIAS COM SOFTWARES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.2.1.02.00.00.00.0000','PERDAS INVOLUNTÁRIAS COM MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM PERDAS INVOLUNTÁRIAS COM MARCAS, DIREITOS E PATENTES INDUSTRIAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.2.1.03.00.00.00.0000','PERDAS INVOLUNTÁRIAS COM DIREITO DE USO DE IMÓVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM PERDAS INVOLUNTÁRIAS DE DIREITOS DE USO DE IMÓVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.3.0.00.00.00.00.0000','PERDAS INVOLUNTARIAS COM ESTOQUES','COMPREENDEM O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ESTOQUE, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDAÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.3.1.00.00.00.00.0000','PERDAS INVOLUNTÁRIAS COM ESTOQUES - CONSOLIDAÇÃO','REGISTRA O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ESTOQUE, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDAÇÕES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.3.1.01.00.00.00.0000','PERDAS INVOLUNTÁRIAS COM MERCADORIAS PARA REVENDA','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM PERDAS INVOLUNTÁRIAS DE MERCADORIAS PARA REVENDAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.3.1.02.00.00.00.0000','PERDAS INVOLUNTÁRIAS COM PRODUTOS E SERVIÇOS ACABADOS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM PERDAS INVOLUNTÁRIAS DE PRODUTOS E SERVIÇOS ACABADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.3.1.03.00.00.00.0000','PERDAS INVOLUNTÁRIAS COM PRODUTOS E SERVIÇOS EM ELABORAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM PERDAS INVOLUNTÁRIAS DE PRODUTOS E SERVIÇOS EM ELABORAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.3.1.04.00.00.00.0000','PERDAS INVOLUNTÁRIAS COM MATÉRIAS-PRIMAS','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM PERDAS INVOLUNTÁRIAS DE MATÉRIAS-PRIMAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.3.1.05.00.00.00.0000','PERDAS INVOLUNTÁRIAS COM MATERIAIS EM TRÂNSITO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM PERDAS INVOLUNTÁRIAS DE MATERIAIS EM TRÂNSITO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.3.1.06.00.00.00.0000','PERDAS INVOLUNTÁRIAS COM ALMOXARIFADO','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM PERDAS INVOLUNTÁRIAS DE ALMOXARIFADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.3.1.07.00.00.00.0000','PERDAS INVOLUNTÁRIAS COM ADIANTAMENTOS A FORNECEDORES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM PERDAS INVOLUNTÁRIAS DE ADIANTAMENTOS A FORNECEDORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.3.1.99.00.00.00.0000','PERDAS INVOLUNTÁRIAS COM OUTROS ESTOQUES','REGISTRA A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM PERDAS INVOLUNTÁRIAS DE OUTROS ESTOQUES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.9.0.00.00.00.00.0000','OUTRAS PERDAS INVOLUNTARIAS','COMPREENDEM O DESFAZIMENTO FISICO INVOLUNTARIO DE OUTROS BENS, COMO AS QUE RESULTAM DE SINISTROS COMO INCENDIO E INUNDAÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.6.3.9.1.00.00.00.00.0000','OUTRAS PERDAS INVOLUNTÁRIAS - CONSOLIDAÇÃO','REGISTRA O DESFAZIMENTO FISICO INVOLUNTARIO DE OUTROS BENS, COMO AS QUE RESULTAM DE SINISTROS COMO INCENDIO E INUNDAÇÕES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.0.0.0.00.00.00.00.0000','TRIBUTÁRIAS','COMPREENDEM AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS AOS IMPOSTOS, TAXAS, CONTRIBUIÇÕES DE MELHORIA, CONTRIBUIÇÕES SOCIAIS, CONTRIBUIÇÕES ECONOMICAS E CONTRIBUIÇÕES ESPECIAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.0.0.00.00.00.00.0000','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','COMPREENDEM AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS AS OBRIGAÇÕES RELATIVAS AS PRESTAÇÕES PECUNIARIAS COMPULSORIAS, EM MOEDA OU CUJO VALOR NELA POSSA SE EXPRIMIR, QUE NÃO CONSTITUA SANCAO DE ATO ILICITO, INSTITUIDA EM LEI E COBRADA MEDIANTE ATIVIDADE VINCULADA. COMO: IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.1.0.00.00.00.00.0000','IMPOSTOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM IMPOSTOS, APURADOS NO PERIODO DE COMPETENCIA, E VINCULADOS A ATIVIDADE ADMINISTRATIVA DO CONTRIBUINTE, DEFINIDOS NO CTN.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.1.1.00.00.00.00.0000','IMPOSTOS- CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM IMPOSTOS, APURADOS NO PERIODO DE COMPETENCIA E VINCULADOS ATIVIDADE ADMINISTRATIVA DO CONTRIBUINTE, DEFINIDOS NO CTN. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.1.1.01.00.00.00.0000','IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE PROPRIEDADE TERRITORIAL RURAL DE COMPETENCIA DA UNIAO RELATIVO A PROPRIEDADE, O DOMINIO UTIL OU POSSE DE IMOVEL POR NATUREZA LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO EM 01 DE JANEIRO DE CADA ANO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.1.1.02.00.00.00.0000','IMPOSTO S/ PROPRIEDADE PREDIAL E TERRITORIAL URBANA','REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DOS MUNICÍPIOS E DISTRITO FEDERAL, SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM IMOVEL POR NATUREZA OU POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICÍPIO E DO DISTRITO FEDERAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.1.1.03.00.00.00.0000','IMPOSTO DE RENDA','REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINAÇÃO DE AMBOS; II DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NÃO COMPREENDIDOS NO ITEM ANTERIOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.1.1.04.00.00.00.0000','ADICIONAL DO IMPOSTO DE RENDA','REGISTRA O VALOR DA VPD COM O ADICIONAL AO IRPJ.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.1.1.05.00.00.00.0000','IMPOSTO S/ PROPRIEDADE DE VEICULOS AUTOMOTORES','REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.1.1.06.00.00.00.0000','IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS','REGISTRA O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO. PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.1.1.07.00.00.00.0000','IMPOSTO S/ CIRCULAÇÃO DE MERCADORIAS E SERVIÇOS','REGISTRA O VALOR DA VPD COM IMPOSTO INCIDENTE SOBRE OPERAÇÕES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTAÇÕES DE SERVIÇOS DE TRANSPORTE INTERESTADUAL, INTERMUNICIPAL E DE COMUNICACAO, E E DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.1.1.08.00.00.00.0000','IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA','REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA, DE COMPETENCIA DOS MUNICÍPIOS E DO DISTRITO FEDERAL, TEM COMO FATO GERADOR A PRESTAÇÃO DE SERVIÇOS CONSTANTES DA LISTA ANEXA DA LC 116/2003, AINDA QUE ESSES NÃO SE CONSTITUAM COMO ATIVIDADE PREPONDERANTE DO PRESTADOR. PODE SER RECOLHIDO PELO SUBSTITUTO TRIBUTÁRIO CONFORME LC 116/2003.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.1.1.09.00.00.00.0000','IMPOSTO S/ OPERAÇÕES FINANCEIRAS','REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERAÇÕES DE CRÉDITO, CAMBIO E SEGURO, E SOBRE OPERAÇÕES RELATIVAS A TÍTULOS E VALORES MOBILIÁRIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERAÇÕES DE CRÉDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERAÇÕES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERAÇÕES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERAÇÕES RELATIVAS A TÍTULOS E VALORES MOBILIÁRIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.1.1.10.00.00.00.0000','IMPOSTO S/ IMPORTAÇÃO','REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS TEM COMO FATO GERADOR A ENTRADA DESTES NO TERRITORIO NACIONAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.1.1.11.00.00.00.0000','IMPOSTO S/ TRANSMISSAO DE IMOVEL INTER VIVOS','REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE A TRANSMISSAO "INTER VIVOS", A QUALQUER TITULO, POR ATO ONEROSO, DE BENS IMOVEIS, POR NATUREZA OU ACESSAO FISICA, E DE DIREITOS REAIS SOBRE IMOVEIS, EXCETO OS DE GARANTIA, BEM COMO CESSAO DE DIREITOS A SUA AQUISICAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.1.1.99.00.00.00.0000','OUTROS IMPOSTOS','REGISTRA O VALOR DE VPDS COM OUTROS IMPOSTOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.2.0.00.00.00.00.0000','TAXAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM TAXAS COBRADAS PELA UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICÍPIOS, NO AMBITO DE SUAS RESPECTIVAS CONTRIBUIÇÕES, DECORRENTES DA CONTRAPRESTAÇÃO DE SERVIÇOS PÚBLICOS AO CONTRIBUINTE POSTOS A SUA DISPOSICAO, INCLUSIVE O EXERCÍCIO DE PODER DE POLICIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.2.1.00.00.00.00.0000','TAXAS - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM TAXAS COBRADAS PELA UNIAO,ESTADOS,DISTRITO FEDERAL OU MUNICÍPIOS, NO AMBITO DE SUAS RESPECTIVAS CONTRIBUIÇÕES,DECORRENTES DA CONTRAPRESTAÇÃO DE SERVIÇOS PÚBLICOS AO CONTRIBUINTE POSTOS A SUA DISPOSICAO, INCLUSIVE O EXERCÍCIO DE PODER DE POLICIA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.2.1.01.00.00.00.0000','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.2.1.02.00.00.00.0000','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM TAXAS PELA PRESTAÇÃO DE SERVIÇO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.3.0.00.00.00.00.0000','CONTRIBUIÇÕES DE MELHORIA','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM TRIBUTO CUJA OBRIGAÇÃO TEM POR FATO GERADOR UM BENEFICIO ESPECIAL AUFERIDO PELO CONTRIBUINTE QUE POR CONSEQUENCIA PROMOVE UMA VALORIZAÇÃO IMOBILIARIA E PATRIMONIAL DECORRENTE DE OBRA PÚBLICA DE COMPETENCIA DA UNIAO, ESTADOS, DISTRITO FEDERAL OU , AMPARADAS EM LEI E LIMITADAS AO TOTAL DA DESPESA PÚBLICA REALIZADA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.3.1.00.00.00.00.0000','CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM TITULO CUJA OBRIGAÇÃO TEM POR FATO GERADOR UM BENEFICIO ESPECIAL AUFERIDO PELO CONTRIBUINTE QUE POR CONSEQUENCIA PROMOVE UMA VALORIZAÇÃO IMOBILIARIA E PATRIM ONIAL DECORRENTE DE OBRA PÚBLICA DE COMPETENCIA DA UNIAO, ESTADOS, DISTRITO FEDERAL OU, AMPARADAS EM LEI E LIMITADAS AO TOTAL DA DESPESA PÚBLICA REALIZADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.1.3.1.01.00.00.00.0000','CONTRIBUIÇÕES DE MELHORIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUIÇÕES DE MELHORIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.0.0.00.00.00.00.0000','CONTRIBUIÇÕES','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUIÇÕES SOCIAIS, ECONOMICAS E OUTRAS, DECORRENTES DA INTERVENCAO DO ESTADO ( UNIAO, ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS) NO DOMINIO ECONOMICO E DE INTERESSE DA CATEGORIA DE PROFISSIONAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.0.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM CONTRIBUIÇÕES SOCIAIS CONSTITUIDAS POR ORDEM SOCIAL E PROFISSIONAL, INSTITUIDAS PELO ESTADO, ENTRE ELAS O PIS/PASEP, CSLL E COFINS, ETC.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.1.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM CONTRIBUIÇÕES SOCIAIS CONSTITUIDAS POR ORDEM SOCIAL E PROFISSIONAL, INSTITUIDAS PELO ESTADO,ENTRE ELAS O PIS/PASEP,CSLL E COFINS, ETC. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.1.01.00.00.00.0000','CONTRIBUIÇÃO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.1.02.00.00.00.0000','PIS/PASEP','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA O PROGRAMA DE INTEGRAÇÃO SOCIAL(PIS) OU PARA O PROGRAMA DE FORMAÇÃO DO PATRIMONIO DO SERVIDOR PÚBLICO(PASEP)','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.1.03.00.00.00.0000','CONTRIBUIÇÃO SOCIAL S/ LUCRO LIQUIDO - CSLL - CONSOLIDAÇÃO','REGISTRA O VALOR DA VPD COM CONTRIBUICAO SOCIAL INCIDENTE SOBRE O LUCRO DA PESSOA JURIDICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.1.04.00.00.00.0000','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA FISICA','REGISTRA O VALOR DA VPD COM CONTRIBUIÇÕES PREVIDÊNCIÁRIAS SOBRE SERVIÇOS DE TERCEIROS PESSOAS FISICAS CONTRATADAS PARA A EXECUÇÃO DE SERVIÇOS, SEM VINCULO COM A ADMINISTRAÇÃO, CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.1.05.00.00.00.0000','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA JURIDICA','REGISTRA O VALOR DA VPD COM ENCARGOS INCIDENTES SOBRE SERVIÇOS PRESTADOS POR PESSOAS JURIDICAS, TAIS COMO: - INSS (LEI 9876/99)','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.1.99.00.00.00.0000','OUTRAS CONTRIBUIÇÕES SOCIAIS','REGISTRA O VALOR DA VPD COM OUTRAS CONTRIBUIÇÕES SOCIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.2.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - INTRA OFSS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM CONTRIBUIÇÕES SOCIAIS CONSTITUIDAS POR ORDEM SOCIAL E PROFISSIONAL, INSTITUIDAS PELO ESTADO,ENTRE ELAS O PSI/PASEP, CSLL E COFINS, ETC. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.3.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - UNIÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM CONTRIBUIÇÕES SOCIAIS CONSTITUIDAS POR ORDEM SOCIAL E PROFISSIONAL, INSTITUIDAS PELO ESTADO,ENTRE ELAS O PIS/PSASEP,CSLL E COFINS, ETC. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.3.01.00.00.00.0000','CONTRIBUIÇÃO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.3.02.00.00.00.0000','PIS/PASEP','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA O PROGRAMA DE INTEGRAÇÃO SOCIAL(PIS) OU PARA O PROGRAMA DE FORMAÇÃO DO PATRIMONIO DO SERVIDOR PÚBLICO(PASEP)','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.3.03.00.00.00.0000','CONTRIBUIÇÃO SOCIAL S/ LUCRO LIQUIDO - CSLL - CONSOLIDAÇÃO','REGISTRA O VALOR DA VPD COM CONTRIBUICAO SOCIAL INCIDENTE SOBRE O LUCRO DA PESSOA JURIDICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.3.04.00.00.00.0000','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA FISICA','REGISTRA O VALOR DA VPD COM CONTRIBUIÇÕES PREVIDÊNCIÁRIAS SOBRE SERVIÇOS DE TERCEIROS PESSOAS FISICAS CONTRATADAS PARA A EXECUÇÃO DE SERVIÇOS, SEM VINCULO COM A ADMINISTRAÇÃO, CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.3.05.00.00.00.0000','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA JURIDICA','REGISTRA O VALOR DA VPD COM ENCARGOS INCIDENTES SOBRE SERVIÇOS PRESTADOS POR PESSOAS JURIDICAS, TAIS COMO: - INSS (LEI 9876/99)','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.3.99.00.00.00.0000','OUTRAS CONTRIBUIÇÕES SOCIAIS','REGISTRA O VALOR DA VPD COM OUTRAS CONTRIBUIÇÕES SOCIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.4.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - ESTADO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM CONTRIBUIÇÕES SOCIAIS CONSTITUIDAS POR ORDEM SOCIAL E PROFISSIONAL, INSTITUIDAS PELO ESTADO,ENTRE ELAS O PIS/PSASEP,CSLL E COFINS, ETC. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.1.5.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - MUNICÍPIO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM CONTRIBUIÇÕES SOCIAIS CONSTITUIDAS POR ORDEM SOCIAL E PROFISSIONAL, INSTITUIDAS PELO ESTADO,ENTRE ELAS O PIS/PSASEP,CSLL E COFINS, ETC. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.2.0.00.00.00.00.0000','CONTRIBUIÇÕES DE INTERVENCAO NO DOMINIO ECONOMICO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM CONTRIBUIÇÕES DE INTERVENCAO NO DOMINIO ECONOMICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.2.1.00.00.00.00.0000','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMUNITIVA COM CONTRIBUIÇÕES DE INTERVENCAO NO DOMINIO ECONOMICO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.2.1.01.00.00.00.0000','CONTRIBUIÇÃO SINDICAL','REGISTRA O VALOR DA DESPESA COM ENCARGOS PATRONAIS RELATIVO A CONTRIBUICAO SINDICAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.2.1.99.00.00.00.0000','OUTRAS CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMINIO ECONOMICO','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM OUTRAS CONTRIBUIÇÕES ECONOMICAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.3.0.00.00.00.00.0000','CONTRIBUICAO PARA O CUSTEIO DO SERVICO DE ILUMINAÇÃO PÚBLICA - COSIP','COMPREENDE O VALOR DA VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A CONTRIBUICAO PARA CUSTEIO DA ILUMINAÇÃO PÚBLICA ( ART.149-A DA CF)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.3.1.00.00.00.00.0000','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA - COSIP - CONSOLIDAÇÃO','REGISTRA O VALOR DA VARIAÇÃO PATRIMONIAL DIMINUTIVA COM A CONTRIBUICAO PARA CUSTEIO DA ILUMINAÇÃO PÚBLICA ( ART.149-A DA CF). COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.9.0.00.00.00.00.0000','OUTRAS CONTRIBUIÇÕES','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM CONTRIBUIÇÕES QUE NÃO SE ENQUADRAM NA CONDICAO DE SOCIAIS E ECONOMICAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.9.1.00.00.00.00.0000','OUTRAS CONTRIBUIÇÕES - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM CONTRIBUIÇÕES QUE NÃO SE ENQUADRAM NA CONDICAO DE SOCIAIS E ECONÔMICAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.9.1.01.00.00.00.0000','CONTRIBUIÇÃO SINDICAL','REGISTRA O VALOR DA DESPESA COM ENCARGOS PATRONAIS RELATIVO A CONTRIBUICAO SINDICAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.2.9.1.99.00.00.00.0000','DEMAIS CONTRIBUIÇÕES','REGISTRA VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR DA CONCESSÃO DE COTA DO ÓRGÃO CENTRAL DE PROGRAMAÇÃO FINANCEIRA PARA ÓRGÃO SETORIAL CORRESPONDENTE AO ORÇAMENTO ANUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.0.0.00.00.00.00.0000','CUSTO COM TRIBUTOS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA RELATIVA A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS OU SERVIÇOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.1.0.00.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS APROPRIADOS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.1.1.00.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES DIMINUTIVAS RELATIVAS A TRIBUTOS APROPRIADOS AS MERCADORIAS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.1.1.01.00.00.00.0000','CMV - IMPOSTOS','REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.1.1.02.00.00.00.0000','CMV - TAXAS','REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.1.1.03.00.00.00.0000','CMV - CONTRIBUICAO DE MELHORIA','REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.1.1.04.00.00.00.0000','CMV - CONTRIBUICOES SOCIAIS','REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.1.1.05.00.00.00.0000','CMV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.1.1.07.00.00.00.0000','CMV - OUTRAS CONTRIBUICOES','REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.1.2.00.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTRA OFSS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS APROPRIADOS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.1.3.00.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - UNIÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS APROPRIADOS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.1.4.00.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - ESTADO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS APROPRIADOS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.1.5.00.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - MUNICÍPIO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS APROPRIADOS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.2.0.00.00.00.00.0000','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.2.1.00.00.00.00.0000','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.2.1.01.00.00.00.0000','CPV - IMPOSTOS','REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.2.1.02.00.00.00.0000','CPV - TAXAS','REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.2.1.03.00.00.00.0000','CPV - CONTRIBUICAO DE MELHORIA','REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.2.1.04.00.00.00.0000','CPV - CONTRIBUICOES SOCIAIS','REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.2.1.05.00.00.00.0000','CPV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.2.1.99.00.00.00.0000','CPV - OUTRAS CONTRIBUICOES','REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.2.2.00.00.00.00.0000','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTRA OFSS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.2.3.00.00.00.00.0000','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - UNIÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.2.4.00.00.00.00.0000','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - ESTADO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.2.5.00.00.00.00.0000','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - MUNICÍPIO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.3.0.00.00.00.00.0000','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE SERVIÇOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.3.1.00.00.00.00.0000','CUSTO DE SERVIÇOS PRESTADOS -TRIBUTOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE SERVIÇOS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.3.1.01.00.00.00.0000','CSP - IMPOSTOS','REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.3.1.02.00.00.00.0000','CSP - TAXAS','REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.3.1.03.00.00.00.0000','CSP - CONTRIBUICAO DE MELHORIA','REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.3.1.04.00.00.00.0000','CSP - CONTRIBUICOES SOCIAIS','REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.3.1.05.00.00.00.0000','CSP - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.3.1.99.00.00.00.0000','CSP - OUTRAS CONTRIBUICOES','REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.3.2.00.00.00.00.0000','CUSTO DE SERVIÇOS PRESTADOS -TRIBUTOS -INTRA OFSS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE SERVIÇOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.3.3.00.00.00.00.0000','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - UNIÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE SERVIÇOS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.3.4.00.00.00.00.0000','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - ESTADO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE SERVIÇOS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.7.8.3.5.00.00.00.00.0000','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - MUNICÍPIO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE SERVIÇOS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.0.0.0.00.00.00.00.0000','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','COMPREENDE O SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS NÃO INCLUIDAS NOS GRUPOS ANTERIORES. COMPREENDE: PREMIAÇÕES, INCENTIVOS, EQUALIZAÇÕES DE PRECOS E TAXAS, PARTICIPAÇÕES E CONTRIBUIÇÕES, RESULTADO NEGATIVO COM PARTICIPAÇÕES, DENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.1.0.0.00.00.00.00.0000','PREMIAÇÕES','COMPREENDE AS AQUISICAO DE PREMIOS, CONDECORAÇÕES, MEDALHAS, TROFEUS, ETC., BEM COMO COM O PAGAMENTO DE PREMIOS EM PECUNIA, INCLUSIVE DECORRENTES DE SORTEIOS LOTERICOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.1.1.0.00.00.00.00.0000','PREMIAÇÕES CULTURAIS','COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORAÇÕES, MEDALHAS, TROFEUS, ETC, DE CARATER CULTURAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.1.1.1.00.00.00.00.0000','PREMIAÇÕES CULTURAIS - CONSOLIDAÇÃO','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORAÇÕES, MEDALHAS, TROFEUS, ETC, DE CARATER CULTURAL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.1.2.0.00.00.00.00.0000','PREMIAÇÕES ARTISTICAS','COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORAÇÕES, MEDALHAS, TROFEUS, ETC, DE CARATER ARTISTICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.1.2.1.00.00.00.00.0000','PREMIAÇÕES ARTÍSTICAS - CONSOLIDAÇÃO','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORAÇÕES, MEDALHAS, TROFEUS, ETC, DE CARATER ARTISTICO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.1.3.0.00.00.00.00.0000','PREMIAÇÕES CIENTIFICAS','COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORAÇÕES, MEDALHAS, TROFEUS, ETC, DE CARATER CIENTIFICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.1.3.1.00.00.00.00.0000','PREMIAÇÕES CIENTIFICAS - CONSOLIDAÇÃO','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORAÇÕES, MEDALHAS, TROFEUS, ETC, DE CARATER CIENTIFICO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.1.4.0.00.00.00.00.0000','PREMIAÇÕES DESPORTIVAS','COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORAÇÕES, MEDALHAS, TROFEUS, ETC, DE CARATER DESPORTIVO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.1.4.1.00.00.00.00.0000','PREMIAÇÕES DESPORTIVAS - CONSOLIDAÇÃO','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORAÇÕES, MEDALHAS, TROFEUS, ETC, DE CARATER DESPORTIVO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.1.5.0.00.00.00.00.0000','ORDENS HONORIFICAS','COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORAÇÕES, MEDALHAS, TROFEUS, INSIGNIAS ETC, RELATIVO A ORDENS HONORIFICAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.1.5.1.00.00.00.00.0000','ORDENS HONORIFICAS - CONSOLIDAÇÃO','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORAÇÕES, MEDALHAS, TROFEUS, INSIGNIAS ETC, RELATIVO A ORDENS HONORIFICAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.1.9.0.00.00.00.00.0000','OUTRAS PREMIAÇÕES','COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORAÇÕES, MEDALHAS, TROFEUS, ETC, PARA FINALIDADES DIFERENTES DAS PREVISTAS NOS DETALHAMENTOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.1.9.1.00.00.00.00.0000','OUTRAS PREMIAÇÕES - CONSOLIDAÇÃO','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORAÇÕES, MEDALHAS, TROFEUS, ETC, PARA FINALIDADES DIFERENTES DAS PREVISTAS NOS DETALHAMENTOS ANTERIORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.2.0.0.00.00.00.00.0000','RESULTADO NEGATIVO DE PARTICIPAÇÕES','COMPREENDE A APROPRIAÇÃO DO RESULTADO NEGATIVO DE PARTICIPAÇÕES, ORIUNDO DE PREJUÍZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.2.1.0.00.00.00.00.0000','RESULTADO NEGATIVO DE EQUIVALENCIA PATRIMONIAL','COMPREENDE A APROPRIAÇÃO DO RESULTADO NEGATIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE PREJUÍZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.2.1.1.00.00.00.00.0000','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','REGISTRA A APROPRIAÇÃO DO RESULTADO NEGATIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE PREJUÍZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.2.1.2.00.00.00.00.0000','RESULTADO NEGATIVO DE EQUIVALENCIA PATRIMONIAL - INTRA OFSS','REGISTRA A APROPRIAÇÃO DO RESULTADO NEGATIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE PREJUÍZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.2.1.3.00.00.00.00.0000','RESULTADO NEGATIVO DE EQUIVALENCIA PATRIMONIAL - INTER OFSS - UNIÃO','REGISTRA A APROPRIAÇÃO DO RESULTADO NEGATIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE PREJUÍZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.2.1.4.00.00.00.00.0000','RESULTADO NEGATIVO DE EQUIVALENCIA PATRIMONIAL - INTER OFSS - ESTADO','REGISTRA A APROPRIAÇÃO DO RESULTADO NEGATIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE PREJUÍZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.2.1.5.00.00.00.00.0000','RESULTADO NEGATIVO DE EQUIVALENCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','REGISTRA A APROPRIAÇÃO DO RESULTADO NEGATIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE PREJUÍZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.0.0.00.00.00.00.0000','INCENTIVOS','COMPREENDE OS INCENTIVOS FINANCEIROS CONCEDIDOS RELATIVOS A EDUCAÇÃO, A CIENCIA E A CULTURA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.1.0.00.00.00.00.0000','INCENTIVOS A EDUCAÇÃO','COMPREENDE A AJUDA FINANCEIRA CONCEDIDA PELO ESTADO A ESTUDANTES COMPROVADAMENTE CARENTES, E CONCESSAO DE AUXÍLIO PARA O DESENVOLVIMENTO DE ESTUDOS E PESQUISAS DE NATUREZA CIENTIFICA, REALIZADAS POR PESSOAS FISICAS NA CONDICAO DE ESTUDANTE','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.1.1.00.00.00.00.0000','INCENTIVOS A EDUCAÇÃO - CONSOLIDAÇÃO','COMPREENDE A AJUDA FINANCEIRA CONCEDIDA PELO ESTADO A ESTUDANTES COMPROVADAMENTE CARENTES, E CONCESSAO DE AUXÍLIO PARA O DESENVOLVIMENTO DE ESTUDOS E PESQUISAS DE NATUREZA CIENTIFICA, REALIZADAS POR PESSOAS FISICAS NA CONDICAO DE ESTUDANTE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.1.1.01.00.00.00.0000','BOLSA DE ESTUDOS NO PAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM BOLSAS DE ESTUDO NO PAIS, A QUALQUER TITULO, E DEMAIS AUXÍLIOS FINANCEIROS A ESTUDANTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.1.1.02.00.00.00.0000','BOLSA DE ESTUDOS NO EXTERIOR','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM BOLSAS DE ESTUDO NO EXTERIOR, A QUALQUER TITULO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.1.1.03.00.00.00.0000','AUXÍLIOS PARA DESENV. DE ESTUDOS E PESQUISAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM CONCESSÃO DE AUXÍLIOS FINANCEIROS A ESTUDANTES PARA DESENVOLVIMENTO DE ESTUDOS E PESQUISAS DE NATUREZA CIENTÍFICA, OBSERVADO O DISPOSTO NO ART. 26 DA LEI COMPLEMENTAR N.101, DE 2000.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.1.1.99.00.00.00.0000','OUTROS INCENTIVOS A EDUCAÇÃO','REGISTRA OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM INCENTIVOS A EDUCAÇÃO NÃO CONTEMPLADOS NOS ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.2.0.00.00.00.00.0000','INCENTIVOS A CIÊNCIA','COMPREENDE O APOIO FINANCEIRO CONCEDIDO A PESQUISADORES, INDIVIDUAL OU COLETIVAMENTE, EXCETO NA CONDICAO DE ESTUDANTE, NO DESENVOLVIMENTO DE PESQUISAS CIENTIFICAS E TECNOLOGICAS, NAS SUAS MAIS DIVERSAS MODALIDADES','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.2.1.00.00.00.00.0000','INCENTIVOS A CIÊNCIA - CONSOLIDAÇÃO','COMPREENDE O APOIO FINANCEIRO CONCEDIDO A PESQUISADORES, INDIVIDUAL OU COLETIVAMENTE, EXCETO NA CONDICAO DE ESTUDANTE, NO DESENVOLVIMENTO DE PESQUISAS CIENTIFICAS E TECNOLOGICAS, NAS SUAS MAIS DIVERSAS MODALIDADES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.2.1.01.00.00.00.0000','AUXÍLIO A PESQUISADORES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO FINANCEIRO A PESQUISADORES, INDIVIDUAL OU COLETIVAMENTE, EXCETO NA CONDICAO DE ESTUDANTE, NO DESENVOLVIMENTO DE PESQUISAS CIENTIFICAS E TECNOLOGICAS, NAS SUAS DIVERSAS MODALIDADES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.2.1.02.00.00.00.0000','AUXÍLIO AS ATIVIDADES AUXILIARES DE PESQUISA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM AUXÍLIO FINANCEIRO A PESQUISADORES RELATIVO AO APOIO AS ATIVIDADES AUXILIARES DE PESQUISA, EM ATENDIMENTO A RESOLUÇÃO N° 08/06-COPLAD.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.2.1.99.00.00.00.0000','OUTROS INCENTIVOS A CIENCIA','REGISTRA OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM INCENTIVOS A CULTURA NÃO CONTEMPLADOS NOS ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.3.0.00.00.00.00.0000','INCENTIVOS A CULTURA','COMPREENDE OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DA CULTURA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.3.1.00.00.00.00.0000','INCENTIVOS A CULTURA - CONSOLIDAÇÃO','REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DA CULTURA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.3.1.01.00.00.00.0000','INCENTIVOS A CULTURA - PESSOAS FÍSICAS','REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS A PESSOAS FÍSICAS, VISANDO A PROMOÇÃO DA CULTURA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.3.1.99.00.00.00.0000','OUTROS INCENTIVOS A CULTURA','REGISTRA OS DEMAIS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOÇÃO DA CULTURA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.4.0.00.00.00.00.0000','INCENTIVOS AO ESPORTE','COMPREENDE OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DO ESPORTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.4.1.00.00.00.00.0000','INCENTIVOS AO ESPORTE - CONSOLIDAÇÃO','REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DO ESPORTE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.4.1.01.00.00.00.0000','INCENTIVOS AO ESPORTE - PESSOAS FÍSICAS','REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS A PESSOAS FÍSICAS, VISANDO A PROMOÇÃO DO ESPORTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.4.1.99.00.00.00.0000','OUTROS INCENTIVOS AO ESPORTE','REGISTRA AS DEMAIS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM INCENTIVOS AO ESPORTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.9.0.00.00.00.00.0000','OUTROS INCENTIVOS','COMPREENDE OUTROS INCENTIVOS FINANCEIROS CONCEDIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.4.9.1.00.00.00.00.0000','OUTROS INCENTIVOS - CONSOLIDAÇÃO','REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.5.0.0.00.00.00.00.0000','SUBVENCOES ECONOMICAS','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM O PAGAMENTO DE SUBVENCOES ECONOMICAS, A QUALQUER TITULO, AUTORIZADAS EM LEIS ESPECIFICAS, TAIS COMO: AJUDA FINANCEIRA A ENTIDADES PRIVADAS COM FINS LUCRATIVOS; CONCESSAO DE BONIFICAÇÕES A PRODUTORES, DISTRIBUIDORES E VENDEDORES; COBERTURA, DIRETA OU INDIRETA, DE PARCELA DE ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS E DOS CUSTOS DE AQUISICAO, DE PRODUCAO, DE ESCOAMENTO, DE DISTRIBUICAO, DE VENDA E DE MANUTENCAO DE BENS, PRODUTOS E SERVIÇOS EM GERAL; E, AINDA, OUTRAS OPERAÇÕES COM CARACTERISTICAS SEMELHANTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.5.0.1.00.00.00.00.0000','SUBVENÇÕES ECONÔMICAS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL DIMINUTIVA COM O PAGAMENTO DE SUBVENCOES ECONÔMICAS, A QUALQUER TÍTULO, AUTORIZADAS EM LEIS ESPECIFICAS, TAIS COMO: AJUDA FINANCEIRA A ENTIDADES PRIVADAS COM FINS LUCRATIVOS; CONCESSAO DE BONIFICAÇÕES A PRODUTORES, DISTRIBUIDORES E VENDEDORES; COBERTURA, DIRETA OU INDIRETA, DE PARCELA DE ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS E DOS CUSTOS DE AQUISICAO, DE PRODUCAO, DE ESCOAMENTO, DE DISTRIBUICAO, DE VENDA E DE MANUTENCAO DE BENS, PRODUTOS E SERVIÇOS EM GERAL; E, AINDA, OUTRAS OPERAÇÕES COM CARACTERISTICAS SEMELHANTES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.5.0.1.01.00.00.00.0000','CORREÇÃO MONETÁRIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CORRECAO MONETARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.5.0.1.02.00.00.00.0000','DIFERENCIAL DE JUROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE EQUALIZACOES COM DIFERENCIAL DE TAXAS DE JUROS, PREVISTO EM CONTRATO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.5.0.1.03.00.00.00.0000','PROGRAMA DE INVESTIMENTO RURAL AGROINDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O PROGRAMA DE INVESTIMENTO RURAL AGROINDUSTRIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.5.0.1.04.00.00.00.0000','GARANTIA E SUSTENTAÇÃO DE PREÇOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GARANTIA E SUSTENTACAO DE PRECOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.5.0.1.05.00.00.00.0000','CUSTOS ADMINISTRATIVOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE EQUALIZACOES REFEREN TES AOS CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO PREVISTO EM CONTRATO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.5.0.1.06.00.00.00.0000','CUSTEIO AGROPECUÁRIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DO CUSTO DE CAPTCAO E APLICACAO DE RECURSOS NO PROGRAMA DE ASSENTAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.5.0.1.07.00.00.00.0000','SUBVENÇÃO ECONOMICA AO PREMIO DE SEGURO GARANTIA','REGISTRA A SUBVENCAO ECONOMICA AO PREMIO DO SEGURO GARANTIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.5.0.1.08.00.00.00.0000','AQUISIÇÃO E PRODUÇÃO DE BENS DE CAPITAL','REGISTRA O VALOR DE APROPRIACAO DE VARIACOES PATRIMONIAIS DIMINUTIVAS COM EQUALIZACAO DE TAXAS DE JUROS NAS OPERACOES DE FINANCIAMENTO DESTINADOS A AQUISICAO E PRODUCAO DE BENS DE CAPITAL E A INOVACAO TECNOLOGICA (MP 465, DE 2009).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.5.0.1.99.00.00.00.0000','OUTRAS SUBVENÇÕES ECONÔMICAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM OUTRAS SUBVENÇÕES ECONÔMICAS NÃO DESCRITAS ACIMA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.6.0.0.00.00.00.00.0000','PARTICIPAÇÕES E CONTRIBUIÇÕES','COMPREENDE AS PARTICIPAÇÕES DE TERCEIROS NOS LUCROS, NÃO RELATIVAS AO INVESTIMENTO DOS ACIONISTAS, TAIS COMO: PARTICIPAÇÕES DE DEBENTURES, EMPREGADOS, ADMINISTRADORES E PARTES BENEFICIARIAS, MESMO NA FORMA DE INSTRUMENTOS FINANCEIROS. ALÉM DA CONTRIBUICAO A INSTITUICOES OU FUNDOS DE ASSISTÊNCIA OU PREVIDENCIA DE EMPREGADOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.6.1.0.00.00.00.00.0000','PARTICIPAÇÕES DE DEBENTURES','COMPREENDE AS PARTICIPAÇÕES DE DEBENTURES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LÍQUIDO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.6.1.1.00.00.00.00.0000','PARTICIPAÇÕES DE DEBÊNTURES - CONSOLIDAÇÃO','REGISTRA AS PARTICIPAÇÕES DE DEBENTURES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LÍQUIDO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.6.2.0.00.00.00.00.0000','PARTICIPAÇÕES DE EMPREGADOS','COMPREENDE AS PARTICIPAÇÕES DE EMPREGADOS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LÍQUIDO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.6.2.1.00.00.00.00.0000','PARTICIPAÇÕES DE EMPREGADOS - CONSOLIDAÇÃO','REGISTRA AS PARTICIPAÇÕES DE EMPREGADOS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.6.3.0.00.00.00.00.0000','PARTICIPAÇÕES DE ADMINISTRADORES','COMPREENDE AS PARTICIPAÇÕES DE ADMINISTRADORES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.6.3.1.00.00.00.00.0000','PARTICIPAÇÕES DE ADMINISTRADORES - CONSOLIDAÇÃO','REGISTRA AS PARTICIPAÇÕES DE ADMINISTRADORES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.6.4.0.00.00.00.00.0000','PARTICIPAÇÕES DE PARTES BENEFICIARIAS','COMPREENDE AS PARTICIPAÇÕES DE PARTES BENEFICIARIAS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LÍQUIDO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.6.4.1.00.00.00.00.0000','PARTICIPAÇÕES DE PARTES BENEFICIARIAS - CONSOLIDAÇÃO','REGISTRA AS PARTICIPAÇÕES DE PARTES BENEFICIARIAS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.6.5.0.00.00.00.00.0000','PARTICIPAÇÕES DE INSTITUICOES OU FUNDOS DE ASSISTÊNCIA OU PREVIDENCIA DE EMPREGADOS','COMPREENDE AS CONTRIBUIÇÕES DA EMPRESA, INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO, PARA INSTITUICOES OU FUNDOS DE ASSISTÊNCIA OU PREVIDENCIA DE EMPREGADOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.6.5.1.00.00.00.00.0000','PARTICIPAÇÕES DE INSTITUIÇÕES OU FUNDOS DE ASSISTÊNCIA OU PREVIDÊNCIA DE EMPREGADOS - CONSOLIDAÇÃO','REGISTRA AS CONTRIBUIÇÕES DA EMPRESA, INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO, PARA INSTITUICOES OU FUNDOS DE ASSISTÊNCIA OU PREVIDENCIA DE EMPREGADOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.0.0.00.00.00.00.0000','VPD DE CONSTITUIÇÃO DE PROVISÕES','COMPREENDE A CONSTITUIÇÃO DE PROVISÕES, ENTENDIDAS COMO OS PASSIVOS DE VENCIMENTO OU MONTANTE INCERTOS. NÃO SE CONFUNDEM COM OS PASSIVOS DERIVADOS DE APROPRIAÇÃO POR COMPETÊNCIA, COMO FÉRIAS E DÉCIMO - TERCEIRO SALÁRIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.1.0.00.00.00.00.0000','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTOS DE RECLAMAÇÕES TRABALHISTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.1.1.00.00.00.00.0000','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS - CONSOLIDAÇÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTOS DE RECLAMAÇÕES TRABALHISTAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.2.0.00.00.00.00.0000',' VPD DE PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A FUTUROS BENEFÍCIOS PREVIDÊNCIÁRIOS A SEREM PAGOS AOS CONTRIBUINTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.2.1.00.00.00.00.0000',' VPD DE PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A FUTUROS BENEFÍCIOS PREVIDÊNCIÁRIOS A SEREM PAGOS AOS CONTRIBUINTES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.3.0.00.00.00.00.0000','VPD DE PROVISÕES PARA RISCOS FISCAIS','COMPREENDE A CONSTITUIÇÃO DE PROVISÕES, DE PASSIVOS DE PRAZO OU VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUAÇÕES FISCAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.3.1.00.00.00.00.0000','VPD DE PROVISÕES PARA RISCOS FISCAIS – CONSOLIDAÇÃO','COMPREENDE A CONSTITUIÇÃO DE PROVISÕES, DE PASSIVOS DE PRAZO OU VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUAÇÕES FISCAIS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.4.0.00.00.00.00.0000','VPD DE PROVISÃO PARA RISCOS CÍVEIS','COMPREENDE A CONSTITUIÇÃO DE PROVISÕES, DE PASSIVOS DE PRAZO OU VALOR INCERTOS, RELACIONADOS A PAGAMENTOS DE INDENIZAÇÕES E A FORNECEDORES E CLIENTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.4.1.00.00.00.00.0000','VPD DE PROVISÃO PARA RISCOS CÍVEIS – CONSOLIDAÇÃO','COMPREENDE A CONSTITUIÇÃO DE PROVISÕES, DE PASSIVOS DE PRAZO OU VALOR INCERTOS, RELACIONADOS A PAGAMENTOS DE INDENIZAÇÕES E A FORNECEDORES E CLIENTES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.5.0.00.00.00.00.0000','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS','COMPREENDE A CONSTITUIÇÃO DE PROVISÕES, DE PASSIVOS DE PRAZO OU VALOR INCERTOS, RELACIONADOS AOS CRÉDITOS TRIBUTÁRIOS E NÃO TRIBUTÁRIOS RECONHECIDOS NO LANÇAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.5.3.00.00.00.00.0000','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS - INTER OFSS - UNIÃO','REGISTRA A CONSTITUIÇÃO DE PROVISÕES, DE PASSIVOS DE PRAZO OU VALOR INCERTOS, RELACIONADOS AOS CRÉDITOS TRIBUTÁRIOS E NÃO TRIBUTÁRIOS RECONHECIDOS NO LANÇAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERAÇÃO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.5.4.00.00.00.00.0000','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS - INTER OFSS - ESTADO','REGISTRA A CONSTITUIÇÃO DE PROVISÕES, DE PASSIVOS DE PRAZO OU VALOR INCERTOS, RELACIONADOS AOS CRÉDITOS TRIBUTÁRIOS E NÃO TRIBUTÁRIOS RECONHECIDOS NO LANÇAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERAÇÃO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.5.5.00.00.00.00.0000','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS - INTER OFSS - MUNICÍPIO','REGISTRA A CONSTITUIÇÃO DE PROVISÕES, DE PASSIVOS DE PRAZO OU VALOR INCERTOS, RELACIONADOS AOS CRÉDITOS TRIBUTÁRIOS E NÃO TRIBUTÁRIOS RECONHECIDOS NO LANÇAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERAÇÃO. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTE DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.6.0.00.00.00.00.0000','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP','COMPREENDE A CONSTITUIÇÃO DE PROVISÕES, DE PASSIVOS DE PRAZO OU VALOR INCERTOS, RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUÇÃO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.6.1.00.00.00.00.0000','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP - CONSOLIDAÇÃO','REGISTRA A CONSTITUIÇÃO DE PROVISÕES, DE PASSIVOS DE PRAZO OU VALOR INCERTOS, RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUÇÃO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.9.0.00.00.00.00.0000','VPD DE OUTRAS PROVISÕES','COMPREENDE A CONSTITUIÇÃO DE PROVISÕES, DE PASSIVOS DE PRAZO OU VALOR INCERTOS NÃO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.7.9.1.00.00.00.00.0000','VPD DE OUTRAS PROVISÕES - CONSOLIDAÇÃO','COMPREENDE A CONSTITUIÇÃO DE PROVISÕES, DE PASSIVOS DE PRAZO OU VALOR INCERTOS NÃO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.8.0.0.00.00.00.00.0000','CUSTO DE OUTRAS VPD','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE BENS OU SERVIÇOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.8.1.0.00.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – OUTRAS VPD','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.8.1.1.00.00.00.00.0000','CUSTO DE MERCADORIAS VENDIDAS – OUTRAS VPD - CONSOLIDAÇÃO','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.8.2.0.00.00.00.00.0000','CUSTO DE PRODUTOS VENDIDOS – OUTRAS VPD','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.8.2.1.00.00.00.00.0000','CUSTO DE PRODUTOS VENDIDOS – OUTRAS VPD - CONSOLIDAÇÃO','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.8.3.0.00.00.00.00.0000','CUSTO DE SERVIÇOS PRESTADOS – OUTRAS VPD','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE SERVIÇOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.8.3.1.00.00.00.00.0000','CUSTO DE SERVIÇOS PRESTADOS – OUTRAS VPD - CONSOLIDAÇÃO','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE SERVIÇOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.0.0.00.00.00.00.0000','DIVERSAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS NÃO CLASSIFICADAS EM ITENS ESPECIFICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.1.0.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECÍPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.1.2.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.1.3.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.1.4.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.1.5.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.2.0.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PROPRIOS DE PREVIDÊNCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.2.3.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS- UNIÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PROPRIOS DE PREVIDÊNCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.2.4.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS- ESTADO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PROPRIOS DE PREVIDÊNCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.2.5.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS- MUNICÍPIO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PROPRIOS DE PREVIDÊNCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.3.0.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE BONIFICAÇÕES CONCEDIDAS NA VENDA DE MERCADORIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.3.1.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE BONIFICAÇÕES CONCEDIDAS NA VENDA DE MERCADORIAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.4.0.00.00.00.00.0000','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.4.1.00.00.00.00.0000','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.4.2.00.00.00.00.0000','AMORTIZAÇÃO DE AGIO EM INVESTIMENTOS - INTRA OFSS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE AMORTIZAÇÃO DE AGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.4.3.00.00.00.00.0000','AMORTIZAÇÃO DE AGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE AMORTIZAÇÃO DE AGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.4.4.00.00.00.00.0000','AMORTIZAÇÃO DE AGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE AMORTIZAÇÃO DE AGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.4.5.00.00.00.00.0000','AMORTIZAÇÃO DE AGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE AMORTIZAÇÃO DE AGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.9.0.00.00.00.00.0000','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.9.1.00.00.00.00.0000','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.9.1.01.00.00.00.0000','PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS','REGISTRA O VALOR DAS CONSTITUIÇÕES DAS PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '3.9.9.9.1.02.00.00.00.0000','HONRA DE AVAIS','REGISTRA OS VALORES QUE A ADMINISTRAÇÃO É COMPELIDA A REALIZAR EM DECORRÊNCIA DE HONRA DE AVAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.0.0.0.0.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL AUMENTATIVA','COMPREENDE O AUMENTO NO BENEFÍCIO ECONÔMICO DURANTE O PERÍODO CONTÁBIL SOB A FORMA DE ENTRADA DE RECURSO OU AUMENTO DE ATIVO OU DIMINUICAO DE PASSIVO, QUE RESULTE EM AUMENTO DO PATRIMONIO LÍQUIDO E QUE NÃO SEJAM PROVENIENTES DE APORTE DOS PROPRIETÁRIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.0.0.0.00.00.00.00.0000','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','COMPREENDE TODA PRESTAÇÃO PECUNIARIA COMPULSORIA, EM MOEDA OU CUJO VALOR NELA SE POSSA EXPRIMIR, QUE NÃO CONSTITUA SANCAO DE ATO ILICITO, INSTITUIDA EM LEI E COBRADA MEDIANTE ATIVIDADE ADMINISTRATIVA PLENAMENTE VINCULADA. COMO : IMPOSTOS , TAXAS E CONTRIBUIÇÕES DE MELHORIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.0.0.00.00.00.00.0000','IMPOSTOS','COMPREENDE OS TRIBUTOS CUJA OBRIGAÇÃO TEM POR FATO GERADOR UMA SITUAÇÃO INDEPENDENTE DE QUALQUER ATIVIDADE ESTATAL ESPECIFICA, RELATIVA AO CONTRIBUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.1.0.00.00.00.00.0000','IMPOSTOS SOBRE COMERCIO EXTERIOR','COMPREENDE OS IMPOSTOS SOBRE OPERAÇÕES DE COMERCIO EXTERIOR, COMO POR EXEMPLO: IMPOSTOS SOBRE A IMPORTAÇÃO E IMPOSTO SOBRE A EXPORTAÇÃO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.1.1.00.00.00.00.0000','IMPOSTOS SOBRE COMERCIO EXTERIOR - CONSOLIDAÇÃO','COMPREENDE OS IMPOSTOS SOBRE OPERAÇÕES DE COMERCIO EXTERIOR,COMO EXEMPLO: IMPOSTOS SOBRE A IMPORTAÇÃO E IMPOSTOS SOBRE A EXPORTAÇÃO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.2.0.00.00.00.00.0000','IMPOSTOS SOBRE PATRIMONIO E A RENDA','COMPREENDE OS IMPOSTOS SOBRE PATRIMONIO E A RENDA, COMO POR EXEMPLO: IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL, IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA, IMPOSTO SOBRE A TRANSMISSAO DE BENS IMÓVEIS E DE DIREITOS A ELES RELATIVOS E IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.2.1.00.00.00.00.0000','IMPOSTOS SOBRE PATRIMÔNIO E A RENDA - CONSOLIDAÇÃO','COMPREENDE OS IMPOSTOS SOBRE PATRIMONIO E A RENDA,COMO EXEMPLO: IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL,IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA,IMPOSTO SOBRE A TRANSMISSAO DE BENS IMÓVEIS E DE DIREITOS A ELES RELATIVOS E IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.2.1.01.00.00.00.0000','ITR - MUNICÍPIOS CONVENIADOS','REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICÍPIOS CONVENIADOS. FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICÍPIO, CONFORME CONVENIO COM A UNIAO PARA FISCALIZAÇÃO DO REFERIDO IMPOSTO; DESTINAÇÃO LEGAL: O MUNICÍPIO OU O DISTRITO FEDERAL OPTANTE FARA JUS A TOTALIDADE DO PRODUTO DA ARRECADAÇÃO DO ITR REFERENTE AOS IMÓVEIS RURAIS NELE SITUADOS, A PARTIR DO MOMENTO DISCIPLINADO NO CONVENIO; AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III; B)LEI 5172/1966 ART 29 A 31; C) EC 42/2003; D) LEI 9393/1996; E) LEI 11250/2005. INCLUI-SE AQUI O REGISTRO DA VPA DA DÍVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.2.1.02.00.00.00.0000','IR RETIDO NAS FONTES - TRABALHO','REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - TRABALHO. INCLUI-SE AQUI O REGISTRO DA VPA DA DÍVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.2.1.03.00.00.00.0000','IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA - IPTU','REGISTRA O VALOR TOTAL DA VPA DE IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA, DE COMPETENCIA DOS MUNICÍPIOS. TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM IMOVEL POR NATUREZA OU POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICÍPIO. INCLUI-SE AQUI O REGISTRO DA VPA DA DÍVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.2.1.04.00.00.00.0000','IMPOSTO SOBRE TRANSMISSAO "INTER-VIVOS" DE BENS IMÓVEIS E DE DIREITOS REAIS SOBRE IMÓVEIS - ITBI','REGISTRA O VALOR TOTAL DA VPA DE IMPOSTO SOBRE TRANSMISSÃO "INTER-VIVOS" DE BENS IMÓVEIS E DE DIREITOS REAIS SOBRE IMÓVEIS DE COMPETÊNCIA MUNICIPAL, INCIDE SOBRE O VALOR VENAL DOS BENS OU DIREITOS TRANSMITIDOS OU CEDIDOS. TEM O FATO GERADOR NO MOMENTO DA LAVRADURA DO INSTRUMENTO OU ATO QUE SERVIR DE TÍTULO ÀS TRANSMISSÕES OU ÀS CESSÕES. INCLUI-SE AQUI O REGISTRO DA VPA DA DÍVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.2.1.97.00.00.00.0000','(-) DEDUCOES DO IMPOSTOS SOBRE PATRIMONIO E A RENDA','COMPREENDEM AS DEDUCOES DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS COM OS IMPOSTOS SOBRE O PATRIMONIO E A RENDA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.2.1.97.01.00.00.0000','(-) DEDUÇÕES DO IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','REGISTRA AS DEDUÇÕES DAS VPA COM O IMPOSTO S/PROPRIEDADE TERRITORIAL RURAL, DE COMPETENCIA DA UNIAO. TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL POR NATUREZA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO FORA DA ZONA URBANA DO MUNICÍPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.2.1.97.02.00.00.0000','(-) DEDUÇÕES DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','REGISTRA O VALOR DAS DEDUÇÕES DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA. TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I - DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINAÇÃO DE AMBOS; II - DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NÃO COMPREENDIDOS NO ITEM ANTERIOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.2.1.97.03.00.00.0000','(-) DEDUÇÕES DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA - IPTU','REGISTRA O VALOR TOTAL DAS DEDUÇÕES DE VPA DE IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA, DE COMPETENCIA DOS MUNICÍPIOS. TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM IMOVEL POR NATUREZA OU POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICÍPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.2.1.97.04.00.00.0000','(-) DEDUÇÕES DO IMPOSTO SOBRE TRANSMISSAO "INTER-VIVOS" DE BENS IMÓVEIS E DE DIREITOS REAIS SOBRE IMÓVEIS - ITBI','REGISTRA O VALOR TOTAL DA DEDUÇÃO DA VPA DE IMPOSTO SOBRE TRANSMISSÃO "INTER-VIVOS" DE BENS IMÓVEIS E DE DIREITOS REAIS SOBRE IMÓVEIS DE COMPETÊNCIA MUNICIPAL, INCIDE SOBRE O VALOR VENAL DOS BENS OU DIREITOS TRANSMITIDOS OU CEDIDOS. TEM O FATO GERADOR NO MOMENTO DA LAVRADURA DO INSTRUMENTO OU ATO QUE SERVIR DE TÍTULO ÀS TRANSMISSÕES OU ÀS CESSÕES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.3.0.00.00.00.00.0000','IMPOSTOS SOBRE A PRODUCAO E A CIRCULAÇÃO','COMPREENDE OS IMPOSTOS SOBRE A PRODUCAO E A CIRCULAÇÃO, COMO POR EXEMPLO: IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS; IMPOSTO SOBRE OPERAÇÕES DE CRÉDITO, CAMBIO E SEGURO, E SOBRE OPERAÇÕES RELATIVAS A TITULOS E VALORES MOBILIARIOS; IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.3.1.00.00.00.00.0000','IMPOSTOS SOBRE A PRODUÇÃO E A CIRCULAÇÃO - CONSOLIDAÇÃO','COMPRENDE OS IMPOSTOS SOBRE A PRODUCAO E A CIRCULAÇÃO,COMO POR EXEMPLO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS; IMPOSTO SOBRE OPERAÇÕES DE CRÉDITO, CAMBIO E SEGURO, E SOBRE OPERAÇÕES RELATIVAS A TITULOS E VALORES MOBILIARIOS, IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.3.1.01.00.00.00.0000','IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA','REGISTRA O VALOR TOTAL DA VPA DE IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA DE COMPETÊNCIA DOS MUNICÍPIOS. TEM COMO FATO GERADOR A PRESTAÇÃO, POR EMPRESA OU PROFISSIONAL AUTÔNOMO, COM OU SEM ESTABELECIMENTO FIXO, DE SERVIÇOS CONSTANTES EM LISTA PRÓPRIA. O ADICIONAL DE ISS PARA CONSTITUIÇÃO DO FUNDO MUNICIPAL DE COMBATE À POBREZA SERÁ REGISTRADO EM NATUREZA ESPECÍFICA.INCLUI-SE AQUI O REGISTRO DA VPA DA DÍVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.3.1.02.00.00.00.0000','ADICIONAL ISS - FUNDO MUNICIPAL DE COMBATE Á POBREZA','REGISTRA O VALOR DA VPA DECORRENTE DA APLICAÇÃO DE ADICIONAL DE ATÉ MEIO PONTO PERCENTUAL NA ALÍQUOTA DO IMPOSTO SOBRE SERVIÇOS OU DO IMPOSTO QUE VIER A SUBSTITUÍ-LO, SOBRE PRODUTOS SUPÉRFLUOS, PARA A CONSTITUIÇÃO DO FUNDO MUNICIPAL DE COMBATE À POBREZA, CONFORME ESTABELECE O ARTIGO 82, § 2º, ADCT, CF/1988.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.3.1.97.00.00.00.0000','(-) DEDUÇÃO DOS IMPOSTOS SOBRE A PRODUCAO E A CIRCULAÇÃO','COMPREENDE A DEDUÇÃO DOS IMPOSTOS SOBRE A PRODUCAO E A CIRCULAÇÃO, COMO POR EXEMPLO: IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS; IMPOSTO SOBRE OPERAÇÕES DE CRÉDITO, CAMBIO E SEGURO, E SOBRE OPERAÇÕES RELATIVAS A TITULOS E VALORES MOBILIARIOS;IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA;','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.3.1.97.01.00.00.0000','(-) DEDUÇÃO DO IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA','REGISTRA O VALOR TOTAL DEDUÇÃO DA VPA DE IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA DE COMPETÊNCIA DOS MUNICÍPIOS. TEM COMO FATO GERADOR A PRESTAÇÃO, POR EMPRESA OU PROFISSIONAL AUTÔNOMO, COM OU SEM ESTABELECIMENTO FIXO, DE SERVIÇOS CONSTANTES EM LISTA PRÓPRIA. O ADICIONAL DE ISS PARA CONSTITUIÇÃO DO FUNDO MUNICIPAL DE COMBATE À POBREZA SERÁ REGISTRADO EM NATUREZA ESPECÍFICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.3.1.97.02.00.00.0000','(-) DEDUÇÃO DO ADICIONAL ISS - FUNDO MUNICIPAL DE COMBATE Á POBREZA','REGISTRA O VALOR DA DEDUÇÃO DA VPA DECORRENTE DA APLICAÇÃO DE ADICIONAL DE ATÉ MEIO PONTO PERCENTUAL NA ALÍQUOTA DO IMPOSTO SOBRE SERVIÇOS OU DO IMPOSTO QUE VIER A SUBSTITUÍ-LO, SOBRE PRODUTOS SUPÉRFLUOS, PARA A CONSTITUIÇÃO DO FUNDO MUNICIPAL DE COMBATE À POBREZA, CONFORME ESTABELECE O ARTIGO 82, § 2º, ADCT, CF/1988.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.4.0.00.00.00.00.0000','IMPOSTOS EXTRAORDINARIOS','COMPREENDE OS IMPOSTOS INSTITUIDOS PELA UNIAO, TEMPORARIAMENTE, NA IMINENCIA OU NO CASO DE GUERRA EXTERNA, SUPRIMIDOS, GRADATIVAMENTE, NO PRAZO MAXIMO DE CINCO ANOS, CONTADOS DA CELEBRAÇÃO DA PAZ.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.4.1.00.00.00.00.0000','IMPOSTOS EXTRAORDINÁRIOS - CONSOLIDAÇÃO','REGISTRA OS IMPOSTOS INSTITUIDOS PELA UNIAO, TEMPORARIAMENTE, NA IMINENCIA OU NO CASO DE GUERRA EXTERNA, SUPRIMIDOS,GRADATIVAMENTE, NO PRAZO MAXIMO DE CINCO ANOS, CONTADOS DA CELEBRAÇÃO DA PAZ. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.9.0.00.00.00.00.0000','OUTROS IMPOSTOS','COMPREENDE OS DEMAIS IMPOSTOS NÃO CLASSIFICADOS NOS GRUPOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.1.9.1.00.00.00.00.0000','OUTROS IMPOSTOS - CONSOLIDAÇÃO','COMPREENDE OS DEMAIS IMPOSTOS NÃO CLASSIFICADOS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.0.0.00.00.00.00.0000','TAXAS','COMPREENDE AS TAXAS COBRADAS PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICÍPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES. TEM COMO FATO GERADOR O EXERCÍCIO REGULAR DO PODER DE POLICIA, OU A UTILIZAÇÃO, EFETIVA OU POTENCIAL, DE SERVICO PÚBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.0.00.00.00.00.0000','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA','COMPREENDE AS TAXAS PELO PODER DE POLICIA AQUELAS DECORRENTES DAS ATIVIDADES DA ADMINISTRAÇÃO PÚBLICA QUE, LIMITANDO OU DISCIPLINANDO DIREITO, INTERESSE OU LIBERDADE, REGULA A PRATICA DE ATO OU ABSTENCAO DE FATO, EM RAZAO DE INTERESSE PÚBLICO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.00.00.00.00.0000','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA - CONSOLIDAÇÃO','COMPREENDE AS TAXAS PELO PODER DE POLICIA AQUELAS DECORRENTES DAS ATIVIDADES DA ADMINISTRAÇÃO PÚBLICA QUE, LIMITANDO OU DISCIPLINANDO DIREITO, INTERESSE OU LIBERDADE, REGULA A PRATICA DE ATO OU ABSTENCAO DE FATO EM RAZAO DE INTERESSE PÚBLICO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.01.00.00.00.0000','TAXA DE FISCALIZAÇÃO DE VIGILANCIA SANITARIA','REGISTRA A VPA COM TAXA PELA FISCALIZAÇÃO DE VIGILANCIA SANITARIA EXERCIDA PELA AGENCIA NACIONAL DE VIGILANCIA SANITARIA SOBRE AS PESSOAS FISICAS E JURIDICAS QUE EXERCAM ATIVIDADES DE FABRICAÇÃO, DISTRIBUICAO E VENDA DE PRODUTOS E A PRESTAÇÃO DE SERVIÇOS MENCIONADOS NO ARTIGO 8. DA LEI 9782/99. OS RECURSOS SAO VINCULADOS A AGENCIA NACIONAL DE VIGILANCIA SANITARIA. INCLUI-SE AQUI O REGISTRO DA VPA DA DÍVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.02.00.00.00.0000','TAXA DE CONTROLE E FISCALIZAÇÃO AMBIENTAL','REGISTRA A VPA PROVENIENTE DA TAXA DE FISCALIZAÇÃO AMBIENTAL, DEVIDA POR PESSOAS FISICAS OU JURIDICAS OBRIGADAS AO REGISTRO NO CADASTRO TECNICO FEDERAL DE ATIVIDADES POTENCIALMENTE POLUIDORAS OU UTILIZADORAS DE RECURSOS AMBIENTAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.03.00.00.00.0000','TAXA DE LICENCA PARA FUNCIONAMENTO DE ESTABELECIMENTOS COMERCIAIS, INDUSTRIAIS E PRESTADORA DE SERVIÇOS','REGISTRA O VALOR DA VPA DE TAXA DE FISCALIZAÇÃO DA LOCALIZAÇÃO DE ESTABELECIMENTOS COMERCIAIS, INDUSTRIAS E DE PRESTAÇÃO DE SERVIÇOS, INSTITUÍDA PELA LEGISLAÇÃO DO USO E OCUPAÇÃO DO SOLO URBANO ÀS POSTURAS MUNICIPAIS RELATIVAS À SEGURANÇA, ORDEM E TRANQÜILIDADE PÚBLICAS. EX: TAXA DE FISCALIZAÇÃO OU VISTORIA EM ESTABELECIMENTOS DE QUALQUER NATUREZA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.04.00.00.00.0000','TAXA DE PUBLICIDADE COMERCIAL','REGISTRA O VALOR DA VPA DE RECEITA DE TAXA DE UTILIZAÇÃO DE ESPAÇO PÚBLICO DESTINADO PARA DIVULGAÇÃO DE PRODUTOS DO COMÉRCIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.05.00.00.00.0000','TAXA DE APREENSAO E DEPÓSITO','REGISTRA O VALOR DA VPA DE TAXA DE APREENSÃO E DEPÓSITO DE BENS ORIUNDOS DE IRREGULARIDADES APRESENTADAS QUANDO DA FISCALIZAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.06.00.00.00.0000','TAXA DE FUNCIONAMENTO DE ESTABELECIMENTOS EM HORARIO ESPECIAL','REGISTRA O VALOR DA VPA DE TAXA DE FUNCIONAMENTO DE ESTABELECIMENTOS EM HORÁRIO ESPECIAL. A RESPECTIVA TAXA É DESTINADA A BARES, BOATES, BARRACAS POR OCASIÃO DE FESTAS CARNAVALESCAS, PODENDO FUNCIONAR A QUALQUER HORA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.07.00.00.00.0000','TAXA DE LICENCA PARA EXECUÇÃO DE OBRAS','REGISTRA O VALOR DA VPA DE TAXA DE LICENÇA PARA EXECUÇÃO DE OBRAS. A RESPECTIVA TAXA É COBRADA DO RESPONSÁVEL PELA EXECUÇÃO DAS OBRAS EM OBSERVÂNCIA AOS CRITÉRIOS DESCRITOS EM LEI.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.08.00.00.00.0000','TAXA DE AUTORIZAÇÃO DE FUNCIONAMENTO DE TRANSPORTE','REGISTRA O VALOR DA VPA DE TAXA DE AUTORIZAÇÃO DE FUNCIONAMENTO DE TRANSPORTE, CARACTERIZADA PELA AUTORIZAÇÃO AOS PROPRIETÁRIOS DE VEÍCULOS QUE PRESTAM SERVIÇOS À COMUNIDADE DE TRANSPORTE DE PASSAGEIROS TAIS COMO: TRANSPORTE ESCOLAR, DE FUNCIONÁRIOS E OUTROS PASSAGEIROS. EX: TAXA DE FISCALIZAÇÃO DE VEÍCULOS DE USO COLETIVO','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.09.00.00.00.0000','TAXA DE UTILIZAÇÃO DE AREA DE DOMINIO PÚBLICO','REGISTRA O VALOR DA VPA DE TAXA DE UTILIZAÇÃO DE ÁREA DE DOMÍNIO PÚBLICO, REFERENTE A ESPAÇO OCUPADO POR BALCÕES, BARRACAS, MESAS, TABULEIROS E SEMELHANTES, NAS FEIRAS, VIAS E LOGRADOUROS PÚBLICOS OU COMO DEPÓSITO DE MATERIAIS OU ESTACIONAMENTO DE VEÍCULOS EM LOCAIS DESIGNADOS PELA PREFEITURA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.10.00.00.00.0000','TAXA DE APROVAÇÃO DO PROJETO DE CONSTRUCAO CIVIL','REGISTRA O VALOR DA VPA DA TAXA DE LICENÇA E APROVAÇÃO DO PROJETO DE CONSTRUÇÃO CIVIL CORRESPONDENTE A CERTIFICAÇÃO DAS CONDIÇÕES DE UTILIZAÇÃO DE PRÉDIOS E RESIDÊNCIAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.11.00.00.00.0000','TAXA DE FISCALIZAÇÃO DE APARELHOS DE TRANSPORTE','REGISTRA O VALOR DA VPA DA TAXA DE FISCALIZAÇÃO EXERCIDA EM INSTALAÇÕES (CONSERVAÇÃO E FUNCIONAMENTO) DE ELEVADORES DE PASSAGEIROS E DE CARGAS, DE ALÇAPÕES, ESCADAS ROLANTES, PLANOS INCLINADOS MÓVEIS E OUTROS DE NATUREZA ESPECIAL, EM OBSERVÂNCIA A LEGISLAÇÃO ESPECÍFICA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.12.00.00.00.0000','TAXA DE ALINHAMENTO E NIVELAMENTO','REGISTRA O VALOR DA VPA DA TAXA DE FISCALIZAÇÃO DA METRAGEM NO TOCANTE AO ALINHAMENTO E NIVELAMENTO DE ÁREAS OU TERRENOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.13.00.00.00.0000','TAXA DE APREENSÃO, DEPÓSITO OU LIBERAÇÃO DE ANIMAIS','REGISTRA O VALOR DA VPA DA TAXA DE APREENSÃO, DEPÓSITO OU LIBERAÇÃO DE ANIMAIS RECOLHIDOS EM RUAS EM FUNÇÃO DE RISCOS CAUSADOS À POPULAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.96.00.00.00.0000','OUTRAS TAXAS PELO EXERCÍCIO DO PODER DE POLICIA','REGISTRA O VALOR DA VPA DE OUTRAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA, NÃO CLASSIFICADAS NOS ITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.1.1.97.00.00.00.0000','(-) DEDUCOES DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','COMPREENDEM AS DEDUCOES DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS REFERENTES AS TAXAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.2.0.00.00.00.00.0000','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','COMPREENDE AS TAXAS COBRADAS PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICÍPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES, TEM COMO FATO GERADOR A UTILIZAÇÃO, EFETIVA OU POTENCIAL, DE SERVICO PÚBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.2.1.00.00.00.00.0000','TAXAS PELA PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','COMPREENDE AS TAXAS COBRADAS PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICÍPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES TEM COMO FATO GERADOR A UTILIZAÇÃO, EFETIVA OU POTENCIAL, DE SERVICO PÚBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.2.1.01.00.00.00.0000','EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRATIVAS','REGISTRA A VPA PROVENIENTE DE TAXA DE EMOLUMENTOS E CUSTAS PROCESSUAIS POR ENTIDADES DA ADMINISTRAÇÃO PÚBLICA FEDERAL, ESTADUAL E MUNICIPAL, EM DECORRÊNCIA DA PRESTAÇÃO DE SERVIÇOS DE CONSULTAS E ANÁLISES DE PROCESSOS EM SUAS RESPECTIVAS COMPETENCIAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.2.1.02.00.00.00.0000','TAXAS DE SERVIÇOS CADASTRAIS','REGISTRA A VPA PROVENIENTE DAS TAXAS DE SERVIÇOS CADASTRAIS, TENDO COMO FATO GERADOR A APURAÇÃO, INSCRIÇÃO E COBRANCA DA DÍVIDA ATIVA, DA TAXA DE SERVIÇOS CADASTRAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.2.1.03.00.00.00.0000','TAXA DE CEMITERIO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TAXA DE PRESTAÇÃO DE SERVIÇOS DE ADMINISTRAÇÃO DE CEMITÉRIOS REFERENTES A UTILIZAÇÃO DE NECROTÉRIO E OCUPAÇÃO DA SALA MORTUÁRIA, BEM COMO MATRÍCULAS, ENTRADA E SAÍDA DE OSSOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.2.1.04.00.00.00.0000','EMOLUMENTOS E CUSTAS EXTRAJUDICIAIS','REGISTRA O VALOR DA VPA DA TAXA DE SERVIÇOS EXTRAJUDCIAIS REFERENTES AOS ATOS PRATICADOS EM RAZÃO DO OFÍCIO. SERVENTIAS EXTRAJUDICIAIS, ATIVIDADES PRATICADAS PELOS SERVIÇOS NOTARIAIS E DE REGISTRO: LANÇAMENTO EM LIVROS, CERTIDÕES, TRANS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.2.1.05.00.00.00.0000','TAXA DE LIMPEZA PÚBLICA','REGISTRA O VALOR DA VPA RECEBIDA PELA UTILIZAÇÃO EFETIVA OU POTENCIAL DO SERVIÇO PELO PROPRIETÁRIO DE IMÓVEL EDIFICADO OU NÃO, SITUADO EM LOGRADOURO BENEFICIADO PELA COLETA DO LIXO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.2.1.06.00.00.00.0000','TAXA DE REGISTRO/INSPECAO DE PRODUTOS AGROPECUARIOS','REGISTRA O VALOR DA VPA DA TAXA DE REGISTRO E INSPEÇÃO DE PRODUTOS AGROPECUÁRIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.2.1.07.00.00.00.0000','TAXA DE SERVIÇOS PRESTADOS - ARQUIVO HISTORICO MUNICIPAL','REGISTRA O VALOR DA VPA DA TAXA DE SERVIÇOS PRESTADOS – ARQUIVO HISTÓRICO MUNICIPAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.2.1.08.00.00.00.0000','TAXA DE REGISTRO NO CADASTRO TECNICO AMBIENTAL MUNICIPAL','REGISTRA O VALOR DA VPA DA TAXA DE REGISTRO NO CADASTRO TÉCNICO AMBIENTAL MUNICIPAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.2.1.09.00.00.00.0000','TAXA DE EMISSAO DE CERTIDOES','REGISTRA O VALOR DA VPA DA TAXA DE EMISSÃO DE CERTIDÕES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.2.1.10.00.00.00.0000','TAXA DE AGUA SOBRE TERRENOS BALDIOS','REGISTRA O VALOR DA VPA DA TAXA DE ÁGUA SOBRE TERRENOS BALDIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.2.1.96.00.00.00.0000','OUTRAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA A VPA PROVENIENTE DE OUTRAS TAXAS PELA UTILIZAÇÃO, EFETIVA OU POTENCIAL, DE SERVICO PÚBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO, QUE NÃO ESTEJAM REFERENCIADAS NAS NATUREZAS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.2.2.1.97.00.00.00.0000','(-) DEDUCOES DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','COMPREENDEM AS DEDUCOES DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS COM TAXAS PELA PRESTAÇÃO DE SERVIÇOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.0.0.00.00.00.00.0000','CONTRIBUIÇÕES DE MELHORIA','COMPREENDE COMOCONTRIBUIÇÃO DE MELHORIA O TRIBUTO COBRADO PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICÍPIOS, NO ÂMBITO DE SUAS RESPECTIVAS ATRIBUICOES, SENDO INSTITUIDA PARA FAZER FACE AO CUSTO DE OBRAS PÚBLICAS DE QUE DECORRA VALORIZAÇÃO IMOBILIARIA, TENDO COMO LIMITE TOTAL A DESPESA REALIZADA E COMO LIMITE INDIVIDUAL O ACRESCIMO DE VALOR QUE DA OBRA RESULTAR PARA CADA IMOVEL BENEFICIADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.1.0.00.00.00.00.0000','CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE AGUA POTAVEL E ESGOTO SANITARIO','COMPREENDE O VALOR DA ARRECADAÇÃO DE VPA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZAÇÃO DE PROPRIEDADES EM FUNÇÃO DA EXPANSAO DA REDE DE AGUA POTAVEL E ESGOTO SANITARIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.1.1.00.00.00.00.0000','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO - CONSOLIDAÇÃO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE CONTRIBUICAO DE MELHORIA DECORRENTE DA VALORIZAÇÃO DE PROPRIEDADE EM FUNÇÃO DA PAVIMENTAÇÃO ASFALTICA, BEM COMO PELA COLOCAÇÃO DE GUIAS, SARJETAS E CALCAMENTO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.1.1.01.00.00.00.0000','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.1.1.97.00.00.00.0000','(-) DEDUÇÃO','REGISTRA A DEDUÇÃO DE VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.2.0.00.00.00.00.0000','CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE','COMPREENDE O VALOR DA ARRECADAÇÃO DE VPA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZAÇÃO DE PROPRIEDADES EM FUNÇÃO DA EXPANSAO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.2.1.00.00.00.00.0000','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE - CONSOLIDAÇÃO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZAÇÃO DE PROPRIEDADES EM FUNÇÃO DA EXPANSAO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.2.1.01.00.00.00.0000','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.2.1.97.00.00.00.0000','(-) DEDUÇÃO','REGISTRA A DEDUÇÃO DE VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.3.0.00.00.00.00.0000','CONTRIBUICAO DE MELHORIA PELA EXPANSAO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL','COMPREENDE O VALOR DA ARRECADAÇÃO DE VPA SOBRE A COBRANCA DECORRENTE DE VALORIZAÇÃO DE PROPRIEDADES EM FUNÇÃO DA EXPANSAO DA REDE DE ILUMINAÇÃO PÚBLICA RURAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.3.1.00.00.00.00.0000','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL - CONSOLIDAÇÃO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZAÇÃO DE PROPRIEDADES EM FUNÇÃO DA EXPANSAO DA REDE DE ILUMINAÇÃO PÚBLICA RURAL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.3.1.01.00.00.00.0000','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA RURAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.3.1.97.00.00.00.0000','(-) DEDUÇÃO','REGISTRA A DEDUÇÃO DE VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA RURAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.4.0.00.00.00.00.0000','CONTRIBUICAO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES','COMPREENDE O VALOR DA ARRECADAÇÃO DE VPA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZAÇÃO DE PROPRIEDADES EM FUNÇÃO DA PAVIMENTAÇÃO ASFALTICA, BEM COMO PELA COLOCAÇÃO DE GUIAS, SARJETAS E CALCAMENTO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.4.1.00.00.00.00.0000','CONTRIBUICAO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES - CONSOLIDAÇÃO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZAÇÃO DE PROPRIEDADES EM FUNÇÃO DA PAVIMENTAÇÃO ASFALTICA, BEM COMO PELA COLOCAÇÃO DE GUIAS, SARJETAS E CALCAMENTO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.4.1.01.00.00.00.0000','CONTRIBUICAO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZAÇÃO DE PROPRIEDADES EM FUNÇÃO DA PAVIMENTAÇÃO ASFALTICA, BEM COMO PELA COLOCAÇÃO DE GUIAS, SARJETAS E CALCAMENTO','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.4.1.97.00.00.00.0000','(-) DEDUÇÃO','REGISTRA A DEDUÇÃO DE VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE VALORIZAÇÃO DE PROPRIEDADES EM FUNÇÃO DA PAVIMENTAÇÃO ASFALTICA, BEM COMO PELA COLOCAÇÃO DE GUIAS, SARJETAS E CALCAMENTO','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.9.0.00.00.00.00.0000','OUTRAS CONTRIBUIÇÕES DE MELHORIA','COMPREENDE O VALOR DE OUTRAS CONTRIBUIÇÕES DE MELHORIAS, NÃO CLASSIFICADAS EM ITENS ESPECIFICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.9.1.00.00.00.00.0000','OUTRAS CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','REGISTRA O VALOR DE OUTRAS CONTRIBUIÇÕES DE MELHORIAS, NÃO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.9.1.01.00.00.00.0000','OUTRAS CONTRIBUIÇÕES DE MELHORIA','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE OUTRAS CONTRIBUIÇÕES DE MELHORIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.1.3.9.1.97.00.00.00.0000','(-) DEDUÇÃO','REGISTRA A DEDUÇÃO DE VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE OUTRAS CONTRIBUIÇÕES DE MELHORIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.0.0.0.00.00.00.00.0000','CONTRIBUIÇÕES','COMPREENDE TODA PRESTAÇÃO PECUNIARIA COMPULSORIA, EM MOEDA OU CUJO VALOR NELA SE POSSA EXPRIMIR, QUE NÃO CONSTITUA SANCAO DE ATO ILICITO, INSTITUIDA EM LEI E COBRADA MEDIANTE ATIVIDADE ADMINISTRATIVA PLENAMENTE VINCULADA. COMO : CONTRIBUIÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.0.0.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS','COMPREENDEM COMO CONTRIBUIÇÕES SOCIAIS: A) AS DAS EMPRESAS, INCIDENTES SOBRE A REMUNERAÇÃO PAGA OU CREDITADA AOS SEGURADOS A SEU SERVICO; B) AS DOS EMPREGADORES DOMESTICOS; C) AS DOS TRABALHADORES, INCIDENTES SOBRE O SEU SALÁRIO-DE-CONTRIBUICAO; D) AS SOBRE A RECEITA E FATURAMENTO; E) AS SOBRE O LUCRO; F) DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR; G) E OUTROS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.0.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - RPPS','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - RPPS - CONSOLIDAÇÃO','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.01.00.00.00.0000','CONTRIBUIÇÕES PATRONAIS AO RPPS','COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.01.01.00.00.0000','CONTRIB. PATRONAL DE SERVIDOR CIVIL - RPPS','REGISTRA A VPA ORIUNDA DA PARTICIPACAO DOS ENTES PARA O CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, SOBRE A REMUNERACAO MENSAL DOS SERVIDORES PUBLICOS ATIVOS CIVIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.01.02.00.00.0000','CONTR.PATRONAL - PAGAMENTO DE SENTENCAS JUDICIAIS','REGISTRA A VPA DE RECOLHIMENTO DA CONTRIBUICAO PATRONAL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.02.00.00.00.0000','CONTRIBUICAO DO SEGURADO AO RPPS','COMPREENDE A CONTRIBUICAO AO RPPS DOS SEGURADOS SERVIDOR ATIVO, SERVIDOR INATIVO E PENSIONISTA SOBRE A SUA REMUNERAÇÃO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.02.01.00.00.0000','CONTRIBUICAO DO SERVIDOR ATIVO CIVIL - RPPS','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AO RPPS DO SERVIDOR ATIVO CIVIL SOBRE SUA REMUNERAÇÃO','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.02.02.00.00.0000','CONTRIBUICAO DO SERVIDOR INATIVO CIVIL - RPPS','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AO RPPS DO SERVIDOR INATIVO CIVIL','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.02.03.00.00.0000','CONTRIBUICAO DE PENSIONISTA CIVIL - RPPS','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AO RPPS DO PENSIONISTA CIVIL','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.02.04.00.00.0000','CONTRIBUIÇÃO DE SERVIDOR CIVIL – PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO DE SERVIDOR CIVIL – PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.02.05.00.00.0000','CONTRIBUIÇÃO DE APOSENTADO CIVIL – PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO DE APOSENTADO CIVIL – PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.02.06.00.00.0000','CONTRIBUIÇÃO DE PENSIONISTA CIVIL – PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO DE PENSIONISTA CIVIL – PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.03.00.00.00.0000','CONTRIBUIÇÃO PREVIDENCIÁRIA PARA AMORTIZAÇÃO DO DÉFICIT ATUARIAL','REGISTRA A VPA ORIUNDA DE CONTRIBUIÇÕES PREVIDÊNCIÁRIAS PARA AMORTIZAÇÃO DO DÉFICT ATUARIAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.04.00.00.00.0000','CONTRIBUIÇÕES PARA CUSTEIO DAS PENSÕES MILITARES','REGISTRA A VPA PROVENIENTE DE CONTRIBUIÇÃO PARA CUSTEIO PARA PENSÕES MILITARES, EFETIVADAS POR TODOS OS MILITARES, COM VALOR CORRESPONDENTE A SEU POSTO OU GRADUAÇÃO, OBSERVANDO AS EXECEÇÕES PREVISTAS NA LEI ESPECÍFICA. DE COMPETÊNCIA DA UNIÃO E DOS ESTADOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.97.00.00.00.0000','(-) DEDUÇÕES','COMPREENDEM AS DEDUCOES DAS CONTRIBUIÇÕES SOCIAIS - RPPS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.97.10.00.00.0000','(-) RENÚNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CONTRIBUIÇÕES SOCIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.1.99.00.00.00.0000','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','REGISTRA O VALOR DA VPA ORIUNDA DE CONTRIBUIÇÕES PREVIDÊNCIÁRIAS NÃO ENQUADRADAS NOS SUBITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.2.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - RPPS - INTRA OFSS','COMPREENDE A CONTRIBUIÇÃO PATRONAL E A CONTRIBUIÇÃO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.2.01.00.00.00.0000','CONTRIBUIÇÕES PATRONAIS AO RPPS','COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.2.01.01.00.00.0000','CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL - RPPS','REGISTRA A VPA DECORRENTE DA CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL - RPPS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.2.01.02.00.00.0000','CONTRIBUIÇÃO PATRONAL - PAGAMENTO DE SENTENÇA JUDICIAIS','REGISTRAR A VPA DECORRENTE DA CONTRIBUIÇÃO PATRONAL - PAGAMENTO DE SETENÇA JUDICIAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.2.97.00.00.00.0000','(-) DEDUCOES','REGISTRA A DEDUCAO POR RENUNCIA DE VARIAÇÕES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CRÉDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NÃO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUIÇÕES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.2.97.10.00.00.0000','(-) RENÚNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CONTRIBUIÇÕES SOCIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.2.99.00.00.00.0000','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUIÇÕES PREVIDENCIARIAS NÃO ENQUADRADAS NOS SUBITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.3.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - UNIÃO','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE E O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.3.01.00.00.00.0000','CONTRIBUIÇÕES PATRONAIS AO RPPS','COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.3.01.01.00.00.0000','CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL – RPPS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL – RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.3.01.02.00.00.0000','CONTRIBUIÇÃO PATRONAL – PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE CONTRIBUIÇÃO PATRONAL – PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.3.01.97.00.00.0000','(-) DEDUÇÕES','COMPREENDE AS DEDUÇÕES DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.3.01.97.10.00.0000','(-) RENÚNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.3.99.00.00.00.0000','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUIÇÕES PREVIDENCIARIAS NÃO EN-QUADRADAS NOS SUBITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.4.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - ESTADO','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE E O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.4.01.00.00.00.0000','CONTRIBUIÇÕES PATRONAIS AO RPPS','COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.4.01.01.00.00.0000','CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL – RPPS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL – RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.4.01.02.00.00.0000','CONTRIBUIÇÃO PATRONAL – PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE CONTRIBUIÇÃO PATRONAL – PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.4.01.97.00.00.0000','(-) DEDUÇÕES','COMPREENDE AS DEDUÇÕES DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.4.01.97.10.00.0000','(-) RENÚNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.4.99.00.00.00.0000','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUIÇÕES PREVIDENCIARIAS NÃO EN-QUADRADAS NOS SUBITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.5.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - MUNICÍPIO','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE E O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.5.01.00.00.00.0000','CONTRIBUIÇÕES PATRONAIS AO RPPS','COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.5.01.01.00.00.0000','CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL – RPPS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL – RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.5.01.02.00.00.0000','CONTRIBUIÇÃO PATRONAL – PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE CONTRIBUIÇÃO PATRONAL – PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.5.01.97.00.00.0000','(-) DEDUÇÕES','COMPREENDE AS DEDUÇÕES DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.5.01.97.10.00.0000','(-) RENÚNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.1.5.99.00.00.00.0000','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUIÇÕES PREVIDENCIARIAS NÃO EN-QUADRADAS NOS SUBITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.2.0.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - RGPS','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME GERAL DE PREVIDENCIA SOCIAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.2.1.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - RGPS - CONSOLIDAÇÃO','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME GERAL DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.2.2.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - RGPS - INTRA OFSS','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADAS AO CUSTEIO DO REGIME GERAL DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.2.3.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - UNIÃO','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADAS AO CUSTEIO DO REGIME GERAL DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.2.4.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - ESTADO','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADAS AO CUSTEIO DO REGIME GERAL DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.2.5.00.00.00.00.0000','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - MUNICÍPIOS','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADAS AO CUSTEIO DO REGIME GERAL DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.3.0.00.00.00.00.0000','CONTRIBUICAO SOBRE A RECEITA OU O FATURAMENTO','COMPREENDE A CONTRIBUICAO DO EMPREGADOR, DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE A RECEITA OU O FATURAMENTO, COMO POR EXEMPLO: COFINS, PIS/PASEP','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.3.1.00.00.00.00.0000','CONTRIBUIÇÃO SOBRE A RECEITA OU O FATURAMENTO - CONSOLIDAÇÃO','COMPREENDE A CONTRIBUICAO DO EMPREGADOR, DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE A RECEITA OU O FATURAMENTO, COMO POR EXEMPLO: COFINS, PIS/PASEP. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.4.0.00.00.00.00.0000','CONTRIBUICAO SOBRE O LUCRO','COMPREENDE A CONTRIBUICAO DO EMPREGADOR, DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: CSLL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.4.1.00.00.00.00.0000','CONTRIBUIÇÃO SOBRE O LUCRO - CONSOLIDAÇÃO','REGISTRA A CONTRIBUICAO DO EMPREGADOR, DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: O CSLL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.5.0.00.00.00.00.0000','CONTRIBUICAO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO','COMPREENDE A CONTRIBUICAO SOBRE A RECEITA DE CONCURSOS DE PROGNOSTICOS, QUE SAO TODOS E QUAISQUER CONCURSOS DE SORTEIOS DE NUMEROS, LOTERIAS, APOSTAS, INCLUSIVE AS REALIZADAS EM REUNIOES HIPICAS, NOS AMBITOS FEDERAL, ESTADUAL, DO DISTRITO FEDERAL E MUNICIPAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.5.1.00.00.00.00.0000','CONTRIBUIÇÃO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO - CONSOLIDAÇÃO','COMPREENDE A CONTRIBUICAO SOBRE A VPA DE CONCURSOS DE PROGNOSTICOS, QUE SAO TODOS E QUAISQUER CONCURSOS DE SORTEIOS DE NUMEROS, LOTERIAIS, APOSTAS, INCLUSIVE AS REALIZADAS EM REUNIOES HIPICAS, NOS AMBITOS FEDERAL, ESTADUAL, DO DISTRITO FEDERAL E MUNICIPAIS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.6.0.00.00.00.00.0000','CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR','COMPREENDE A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.6.1.00.00.00.00.0000','CONTRIBUIÇÃO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR - CONSOLIDAÇÃO','REGISTRA A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.9.0.00.00.00.00.0000','OUTRAS CONTRIBUIÇÕES SOCIAIS','COMPREENDE O VALOR DE OUTRAS CONTRIBUIÇÕES SOCIAIS, NÃO CLASSIFICADAS EM ITENS ESPECIFICOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.9.1.00.00.00.00.0000','OUTRAS CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','COMPREENDE O VALOR DE OUTRAS CONTRIBUIÇÕES SOCIAIS, NÃO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.9.1.01.00.00.00.0000','CONTRIBUIÇÃO SOCIAL PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL','APRESENTAR O SOMATÓRIO DAS CONTRIBUIÇÕES PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL RECEBIDAS DOS SERVIDORES MUNICIPAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.9.1.01.01.00.00.0000','CONTRIBUICAO DOS SERVIDORES ATIVOS PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR','REGISTRA O VALOR TOTAL DA CONTRIBUIÇÃO DO SERVIDOR ATIVO PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.9.1.01.02.00.00.0000','CONTRIBUICAO SERVIDORES INATIVOS E PENSIONISTAS PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR','REGISTRA O VALOR TOTAL DA CONTRIBUIÇÃO DO SERVIDOR INATIVO E PENSIONISTAS PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.9.1.01.03.00.00.0000','CONTRIBUICAO DOS SERVIDORES ATIVOS PARA A ASSISTÊNCIA MEDICA DO SERVIDOR','REGISTRA O VALOR TOTAL DA CONTRIBUIÇÃO DO SERVIDOR ATIVO PARA A ASSISTÊNCIA MEDICA DO SERVIDOR','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.9.1.01.04.00.00.0000','CONTRIBUICAO DOS SERVIDORES INATIVOS PARA A ASSISTÊNCIA MEDICA DO SERVIDOR','REGISTRA O VALOR TOTAL DA CONTRIBUIÇÃO DO SERVIDOR INATIVO PARA A ASSISTÊNCIA MEDICA DO SERVIDOR','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.9.1.01.05.00.00.0000','CONTRIBUICAO DOS PENSIONISTAS PARA A ASSISTÊNCIA MEDICA DO SERVIDOR','REGISTRA O VALOR TOTAL DA CONTRIBUIÇÃO DO PENSIONISTA PARA A ASSISTÊNCIA MEDICA DO SERVIDOR','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.9.1.96.00.00.00.0000','OUTRAS CONTRIBUIÇÕES SOCIAIS','REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUIÇÕES SOCIAIS NÃO ENQUADRADAS NOS SUBITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.1.9.1.97.00.00.00.0000','(-) DEDUÇÕES DE OUTRAS CONTRIBUIÇÕES SOCIAIS','COMPREENDEM AS DEDUCOES DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS COM OUTRAS CONTRIBUIÇÕES SOCIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.2.0.0.00.00.00.00.0000','CONTRIBUIÇÕES DE INTERVENCAO NO DOMINIO ECONOMICO','COMPREENDEM AS CONTRIBUIÇÕES DE INTERVENCAO NO DOMINIO ECONOMICO, COMO POR EXEMPLO, A CIDE-COMBUSTIVEL..','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.2.0.1.00.00.00.00.0000','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','COMPREENDEM AS CONTRIBUIÇÕES DE INTERVENCAO NO DOMINIO ECONOMICO, COMO POR EXEMPLO, A CIDE-COMBUSTIVEL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.2.0.1.03.00.00.00.0000','CONTRIBUIÇÕES PARA O DESENVOLVIMENTO E APERFEIÇOAMENTO DAS ATIVIDADES DE FISCALIZAÇÃO','REGISTRA O VALOR DA VPA DE CONTRIBUIÇÕES ECONÔMICAS PARA FINANCIAR O REAPARELHAMENTO E O REEQUIPAMENTO E A ATENDER AOS DEMAIS ENCARGOS ESPECÍFICOS INERENTES AO DESENVOLVIMENTO E AO APERFEIÇOAMENTO DAS ATIVIDADES DE FISCALIZAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.2.0.1.99.00.00.00.0000','OUTRAS CONTRIBUIÇÕES ECONOMICAS','COMPREENDE A VPA PROVENIENTE DAS OUTRAS CONTRIBUIÇÕES ECONOMICAS DE NATUREZA EVENTUAL, PARA AS QUAIS NÃO HA CONTA ESPECIFICA,INCLUSIVE RECURSOS ORIUNDOS DO PROGRAMA DE RECUPERAÇÃO FISCAL E DO PARCELAMENTO ESPECIAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.3.0.0.00.00.00.00.0000','CONTRIBUICAO DE ILUMINAÇÃO PÚBLICA','COMPREENDE AS CONTRIBUIÇÕES DE ILUMINAÇÃO PÚBLICA, CONFORME DISPOE O ARTIGO 149-A DA CONSTITUICAO FEDERAL DE 1988, ACRESCENTADO PELA EMENDA CONSTITUCIONAL Nº 39/02, SENDO FACULTADA A COBRANÇA DA CONTRIBUIÇÃO NA FATURA DE CONSUMO DE ENERGIA ELÉTRICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.3.0.1.00.00.00.00.0000','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA - CONSOLIDAÇÃO','COMPREENDE AS CONTRIBUIÇÕES DE ILUMINAÇÃO PÚBLICA, CONFORME DISPOE O ARTIGO 149-A DA CONSTITUICAO FEDERAL DE 1988, ACRESCENTADO PELA EMENDA CONSTITUCIONAL Nº 39/02, SENDO FACULTADA A COBRANÇA DA CONTRIBUIÇÃO NA FATURA DE CONSUMO DE ENERGIA ELÉTRICA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.3.0.1.01.00.00.00.0000','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA','REGISTRA AS CONTRIBUIÇÕES DE ILUMINAÇÃO PÚBLICA, NOS TERMOS DO ARTIGO 149-A DA CONSTITUIÇÃO FEDERAL, ACRESCENTADO PELA EMENDA CONSTITUCIONAL N.ºª 39/02, SENDO FACULTADA A COBRANÇA DA CONTRIBUIÇÃO NA FATURA DE CONSUMO DE ENERGIA ELÉTRICA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.4.0.0.00.00.00.00.0000','CONTRIBUIÇÕES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENINTES DE CONTRIBUIÇÕES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.2.4.0.1.00.00.00.00.0000','CONTRIBUIÇÕES DE INTERESSE DAS CATÉGORIAS PROFISSIONAIS - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENINTES DE CONTRIBUIÇÕES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.0.0.0.00.00.00.00.0000','EXPLORAÇÃO E VENDA DE BENS, SERVIÇOS E DIREITOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A EXPLORAÇÃO DE BENS E SERVIÇOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO, SEGREGANDO-SE A VENDA BRUTA DAS DEDUCOES COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.0.0.00.00.00.00.0000','VENDA DE MERCADORIAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, SEGREGANDO-SE A VENDA BRUTA DAS DEDUCOES COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.0.00.00.00.00.0000','VENDA BRUTA DE MERCADORIAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.00.00.00.00.0000','VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.01.00.00.00.0000','VENDA DE ESTOQUE PRÓPRIO - PAÍS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE NO PRÓPRIO PAÍS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.11.00.00.00.0000','VENDA DE ESTOQUE DE PRODUÇÃO VEGETAL','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE NO PRÓPRIO PAÍS PARA A PRODUÇÃO VEGETAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.11.01.00.00.0000','AGRICULTURA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE NO PRÓPRIO PAÍS PARA A PRODUÇÃO VEGETAL - AGRICULTURA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.11.02.00.00.0000','HORTA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE NO PRÓPRIO PAÍS PARA A PRODUÇÃO VEGETAL - HORTA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.11.03.00.00.0000','POMAR','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE NO PRÓPRIO PAÍS PARA A PRODUÇÃO VEGETAL - POMAR.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.11.99.00.00.0000','OUTRAS VPAS DE PRODUÇÃO VEGETAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE NO PRÓPRIO PAÍS PARA A PRODUÇÃO VEGETAL - OUTRAS VPAS DE PRODUÇÃO VEGETAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.12.00.00.00.0000','VENDA DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.12.01.00.00.0000','GRANJA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS - GRANJA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.12.02.00.00.0000','PISCICULTURA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS - PISCICULTURA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.12.03.00.00.0000','PECUÁRIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS - PECUÁRIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.12.04.00.00.0000','APICULTURA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS - APICULTURA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.12.05.00.00.0000','SUINOCULTURA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS - SUINOCULTURA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.12.06.00.00.0000','OVINOCULTURA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS - OVINOCULTURA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.12.07.00.00.0000','COELHOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS - COELHOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.12.08.00.00.0000','GADO LEITEIRO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS - GADO LEITEIRO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.12.09.00.00.0000','EQÜINOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS - EQUINOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.12.10.00.00.0000','AVÍCOLA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS - AVÍCOLA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.12.99.00.00.0000','OUTRAS VPAS DE PRODUÇÃO ANIMAL E DERIVADOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE AS VENDAS DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS - OUTRAS VPAS DE PRODUÇÃO ANIMAL E DERIVADOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.13.00.00.00.0000','VENDA DE MEDICAMENTOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE A VENDAS DE MEDICAMENTOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.14.00.00.00.0000','VENDA DE LIVROS PERIOD. MAT. ESC. E PUBLICID.','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE A VENDAS DE LIVROS PERIÓDICOS E MATERIAL DE ESCRITÓRIO E PUBLICIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.14.01.00.00.0000','VENDA DE LIVROS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE A VENDAS DE LIVROS PERIÓDICOS E MATERIAL DE ESCRITÓRIO E PUBLICIDADE - VENDA DE LIVROS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.14.02.00.00.0000','PUBLICAÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE A VENDAS DE LIVROS PERIÓDICOS E MATERIAL DE ESCRITÓRIO E PUBLICIDADE - PUBLICAÇÕES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.14.03.00.00.0000','VENDAS REVISTA RAC','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE A VENDAS DE LIVROS PERIÓDICOS E MATERIAL DE ESCRITÓRIO E PUBLICIDADE - VENDAS DE REVISTAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.14.04.00.00.0000','PUBLICAÇÕES TÉCNICAS EPAGRI','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE A VENDAS DE LIVROS PERIÓDICOS E MATERIAL DE ESCRITÓRIO E PUBLICIDADE - PUBLICAÇÕES TÉCNICAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.14.05.00.00.0000','DIVULGAÇÃO E PUBLICIDADE','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE A VENDAS DE LIVROS PERIÓDICOS E MATERIAL DE ESCRITÓRIO E PUBLICIDADE - DIVULGAÇÃO E PUBLICIDADE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.15.00.00.00.0000','VENDA DE PRODUTOS AGROPECUÁRIOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE A VENDAS DE PRODUTOS AGROPECUÁRIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.15.99.00.00.0000','OUTRAS VPAS AGROPECUÁRIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OUTRAS VPAS AGROPECUÁRIAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.1.1.16.00.00.00.0000','VENDA DE FARDAMENTOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMÔNIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE A VENDAS DE FARDAMENTO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.9.0.00.00.00.00.0000','(-) DEDUCOES DA VENDA BRUTA DE MERCADORIAS','COMPREENDE AS DEDUCOES DAS VENDAS DE MERCADORIAS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.9.1.00.00.00.00.0000','(-) DEDUÇÕES DA VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','COMPREENDE AS DEDUCOES DAS VENDAS DE MERCADORIAS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.9.1.97.00.00.00.0000','(-) DEDUÇÕES DE VENDAS','COMPREENDE AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.9.1.97.01.00.00.0000','(-) VENDAS CANCELADAS E DEVOLUÇÕES','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS CANCELADAS E DEVOLUÇÕES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.9.1.97.02.00.00.0000','(-) ABATIMENTOS','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - ABATIMENTOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.9.1.97.03.00.00.0000','(-) DESCONTOS INCONDICIONAIS','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - DESCONTOS INCONDICIONAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.9.1.97.05.00.00.0000','(-) ICMS','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - ICMS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.9.1.97.06.00.00.0000','(-) PIS/PASEP','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - PIS/PASEP.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.9.1.97.07.00.00.0000','(-) COFINS','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - COFINS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.9.1.97.08.00.00.0000','(-)AJUSTE A VALOR PRESENTE','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - AJUSTE A VALOR PRESENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.1.9.1.97.99.00.00.0000','(-) OUTRAS DEDUÇÕES DE VENDAS','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. OUTRAS DEDUÇÕES DE VENDAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.2.0.0.00.00.00.00.0000','VENDA DE PRODUTOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA DE PRODUTOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, SEGREGANDO-SE A VENDA BRUTA DAS DEDUCOES COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.2.1.0.00.00.00.00.0000','VENDA BRUTA DE PRODUTOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA BRUTA DE PRODUTOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.2.1.1.00.00.00.00.0000','VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA BRUTA DE PRODUTOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.2.9.0.00.00.00.00.0000','(-) DEDUCOES DE VENDA BRUTA DE PRODUTOS','COMPREENDE AS DEDUCOES DAS VENDAS DE PRODUTOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.2.9.1.00.00.00.00.0000','(-) DEDUÇÕES DA VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','COMPREENDE AS DEDUCOES DAS VENDAS DE PRODUTOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.2.9.1.97.00.00.00.0000','(-) DEDUÇÕES DE VENDAS','COMPREENDE AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.2.9.1.97.01.00.00.0000','(-) VENDAS CANCELADAS E DEVOLUÇÕES','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS CANCELADAS E DEVOLUÇÕES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.2.9.1.97.02.00.00.0000','(-) ABATIMENTOS','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - ABATIMENTOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.2.9.1.97.03.00.00.0000','(-) DESCONTOS INCONDICIONAIS','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - DESCONTOS INCONDICIONAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.2.9.1.97.05.00.00.0000','(-) ICMS','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - ICMS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.2.9.1.97.06.00.00.0000','(-) PIS/PASEP','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - PIS/PASEP.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.2.9.1.97.07.00.00.0000','(-) COFINS','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - COFINS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.2.9.1.97.08.00.00.0000','(-)AJUSTE A VALOR PRESENTE','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - AJUSTE A VALOR PRESENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.2.9.1.99.00.00.00.0000','(-) OUTRAS DEDUÇÕES DE VENDAS','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. OUTRAS DEDUÇÕES DE VENDAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.0.0.00.00.00.00.0000','EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A PRESTAÇÃO DE SERVIÇOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, SEGREGANDO-SE A VENDA BRUTA DAS DEDUCOES COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.0.00.00.00.00.0000','VALOR BRUTO DE EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A PRESTAÇÃO DE SERVIÇOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.00.00.00.00.0000','VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A PRESTAÇÃO DE SERVIÇOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.01.00.00.00.0000','EXPLORAÇÃO DO PATRIMONIO IMOBILIARIO','COMPREENDE O VALOR DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZAÇÃO, POR TERCEIROS, DE BENS IMÓVEIS PERTENCENTES AO SETOR PÚBLICO. EX: ALUGUEIS, ARRENDAMENTOS, FOROS, LAUDEMIOS, TAXA DE OCUPACAO DE IMOVEIS E OUTRAS VPA DE EXPLORACAO DE BENS IMOVEIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.02.00.00.00.0000','SERVIÇOS DE ESTUDOS E PESQUISAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS DE PESQUISAS E ESTUDOS TECNICO-SOCIAIS, ECONOMICOS, CIENTIFICOS, CULTURAIS ETC., REALIZADAS SOB CONTRATO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.03.00.00.00.0000','SERVIÇOS DE CONSULTORIA, ASSISTÊNCIA TECNICA E ANALISE DE PROJETOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS DE CONSULTORIA, ASSISTÊNCIA TECNICA E ANALISE DE PROJETOS PRESTADOS. VPA PROPORCIONADA POR CONSULTORIAS TECNICO-FINANCEIRAS, ASSESSORIA, ORGANIZAÇÃO E ADMINISTRAÇÃO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURAÇÃO,PERICIAS CONTABEIS, ANALISE DE PROJETOS, ETC.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.04.00.00.00.0000','PRESTAÇÃO DE SERVIÇOS RELACIONADOS A T.I','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTAÇÃO DE SERVIÇOS RELACIONADOS A TECNOLOGIA DA INFORMAÇÃO. EX: DESENVOLVIMENTO DE SOFTWARE, LICENÇA/CESSAO DE DIREITO DE USO DE PROGRAMAS, MANUTENÇÃO E ATUALIZACAO DE SOFTWARE, INSTALAÇÃO E CONFIGURACAO DE SOFTWARE, PRESTACAO DE SERVICOS DE PAGINAS ELETRONICAS, ETC.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.05.00.00.00.0000','SERVIÇOS DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VPA DECORRENTE DE PRESTAÇÃO DE SERVIÇOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITAÇÃO, CONFERENCIA, ETC.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.06.00.00.00.0000','SERVICO DE INFORMAÇÕES CIENTIFICAS E TECNOLOGICAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS DE INFORMAÇÕES CIENTIFICAS E TECNOLOGICAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.07.00.00.00.0000','SERVIÇOS DE TECNOLOGIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS TECNOLOGICOS PRESTADOS. VPA PROPORCIONADA POR: A) ANALISES QUIMICAS, ENSAIOS FISICOS E MECANICOS, CONTROLE E EXPERIMENTAÇÃO QUALITATIVA DE MATERIAS-PRIMAS, INSUMOS E PRODUTOS FABRICADOS; PADRONIZAÇÃO E ESPECIFICAÇÃO DE PRODUTOS; AJUSTES DOS PROCESSOS ETECNICAS DE PRODUCAO INDUSTRIAL (SISTEMA DE TECNOLOGIA) B) ESPECIFICAÇÃO E CONTROLE DE QUALIDADE DE MEDICAMENTOS, INSUMOS FARMACEUTICOS, DROGAS, COSMETICOS, PRODUTOS QUIMICOS, ALIMENTOS, E OUTROS, POR MEIO DE PROVAS ESPECIFICAS DE IDENTIFICAÇÃO, DE PUREZA E DE TESTES DE CONTAMINAÇÃO MICROBIOLOGICA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.08.00.00.00.0000','SERVIÇOS DE COMUNICAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMUNICAÇÃO, CONFORME DESCRICAO: A) SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; B) SERVICO DE COMUNICAÇÃO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS; C) SERVICO DE RADIODIFUSAO E DE AGENCIAMENTO DE PUBLICIDADE. INCLUSIVE DÍVIDA ATIVA. EX: SERVICOS DE PUBLICIDADE LEGAL, SERVICOS DE RADIODIFUSAO E OUTROS SERVICOS DE COMUNICACAO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.09.00.00.00.0000','PRESTAÇÃO DE SERVIÇOS DE ARMAZENAGEM','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTAÇÃO SERVIÇOS DE ARMAZENAGEM.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.10.00.00.00.0000','SERVIÇOS DE HOSPEDAGEM E ALIMENTAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS DE HOSPEDAGEM E ALIMENTAÇÃO PRESTADOS. VPA PROPORCIONADA POR HOSPEDAGEM, COM OU SEM ALIMENTAÇÃO, FORNECIMENTO DE REFEICOES, LANCHES E BEBIDAS PARA CONSUMO IMEDIATO. EXCLUEM AS VPA PROVENIENTES DE EMPRESAS FORNECEDORAS DE ALIMENTOS PREPARADOS PARA HOSPITAIS, FABRICAS, ETC... QUE SE CLASSIFICAM EM VPA DE PRODUTOS ALIMENTARES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.11.00.00.00.0000','RECEITA DE CONCESSOES E PERMISSOES','REGISTRA O VALOR TOTAL DA ARRECADAÇÃO DE VPAS ORIGINADAS DA CONCESSÃO OU PERMISSÃO AO PARTICULAR DO DIREITO DE EXPLORAÇÃO DE SERVIÇOS PÚBLICOS, OS QUAIS ESTÃO SUJEITOS AO CONTROLE, FISCALIZAÇÃO E REGULAÇÃO DO PODER PÚBLICO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.12.00.00.00.0000','COMPENSAÇÕES FINANCEIRAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DOS RECURSOS DECORRENTES DO ARTIGO 20, PARAGRAFO 1º DA CONSTITUICAO FEDERAL, O QUAL DISPOE: "E ASSEGURADA, NOS TERMOS DA LEI, AOS ESTADOS, AO DISTRI-TO FEDERAL E AOS MUNICÍPIOS, BEM COMO AOS ORGÃOS DA ADMINISTRAÇÃO DIRETA DA UNIAO, PARTICIPAÇÃO NO RESULTADO DA EXPLORAÇÃO DE PETROLEO OU GAS NATURAL, DE RECURSOS HIDRICOS PARA FINS DE GERAÇÃO DE ENERGIA ELETRICA E DE OUTROS RECURSOS MINERAIS NO RESPECTIVO TERRITORIO, PLATAFORMA CONTINENTAL, MAR TERRITORIAL OU ZONA ECONOMIA EXCLUSIVA, OU COMPENSAÇÃO FINANCEIRA POR ESSA EXPLORAÇÃO". EX: EXPLORACAO DE RECURSOS MINERAIS, ROYALTIES PELA PRODUÇÃO DE PETROLEO OU GAS NATURAL - EM TERRA, ROYALTIES PELA PRODUÇÃO DE PETROLEO OU GAS NATURAL - EM PLATAFORMA, ROYALTIES EXCEDENTES PELA PRODUÇÃO DE PETROLEO OU GAS NATURAL - EM TERRA, ROYALTIES EXCEDENTES PELA PRODUÇÃO DE PETROLEO OU GAS NATURAL - EM PLATAFORMA, PARTICIPAÇÃO ESPECIAL PELA PRODUÇÃO DE PETROLEO OU GAS NATURAL ALÉM DE OUTRAS COMPENSACOES FINANCEIRAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.13.00.00.00.0000','SERVIÇOS DE TRANSPORTE','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS DE TRANSPORTE RODOVIARIO, FERROVIARIO, HIDROVIARIO, AEREO, ESPECIAIS E TARIFA DE PEDAGIO','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.14.00.00.00.0000','SERVIÇOS PORTUARIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS PORTUARIOS. ABRANGEM OS RECURSOS ORIUNDOS DA EXPLORAÇÃO DOS PORTOS, TERMINAIS MARITIMOS, ATRACADOUROS E ANCORADOUROS, REFERENTES A ESTIVA, DESESTIVA, DRAGAGEM, ATRACAÇÃO, SINALIZAÇÃO, COMUNICAÇÃO NAUTICA, DOCAGEM, ETC....','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.15.00.00.00.0000','SERVIÇOS DE SOCORRO MARITIMO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICO DE SOCORRO MARITIMO PRESTADO. VPA DE SERVIÇOS DE SALVAMENTO, POR NAVIO DE SOCORRO OU EQUIPE DE SALVAMENTO DA MARINHA, DE EMBARCAÇÃO E CARGAS PERIGO (DESENCALHE, MERGULHO, OUTROS SOCORROS), BEM COMO SERVIÇOS DE REBOQUE MARITIMO, DENTRE OUTROS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.16.00.00.00.0000','SERVIÇOS DE SAUDE','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTAÇÃO DE SERVIÇOS DE SAUDE: HOSPITALARES GERAIS OU ESPECIALIZADOS, MATERNIDADE, CENTRO DE REABILITAÇÃO, ASSISTÊNCIA MEDICO-ODONTOLOGICA (INCLUSIVE AMBULATORIAL), SAUDE PÚBLICA, SERVICOS DE REGISTRO DE ANALISE E DE CONTROLE DE PRODUTOS SUJEITOS A NORMAS DE VIGILANCIA SANITARIA, SERVICOS RADIOLOGICOS E LABORATORIAIS, ASSIM COMO OUTROS SERVICOS DE SAUDE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.17.00.00.00.0000','SERVIÇOS DE METROLOGIA E CERTIFICAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS DE METROLOGIA E CERTIFICAÇÃO PRESTADOS.VPA DE SERVIÇOS METROLOGICOS EM GERAL, TAIS COMO AFERICAO DE MEDIDAS E INSTRUMENTOS DE MEDIR, SERVIÇOS DE ARQUEAÇÃO DE TANQUES PARA ARMAZENAGEM, METROLOGIA LEGAL E CERTIFICATORIA DELEGADA, METROLOGIA CIENTIFICA E INDUSTRIAL, CERTIFICACAO DE PRODUTOS E SERVICOS INFORMACAO TECNOLOGICA BEM COMO OUTROS SERVICO DE METROLOGIA E CERTIFICACAO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.18.00.00.00.0000','SERVIÇOS DE INSPECAO E FISCALIZAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS DE INSPECAO E FISCALIZAÇÃO PRESTADOS. VPA PROPORCIONADA PELA CONSTATAÇÃO DAS CONDICOES HIGIENICO-SANITARIAS E TECNICAS DE PRODUTOS OU ESTABELECIMENTOS, OU RESULTANTES DE AÇÃO EXTERNA E DIRETA DOS ORGÃOS DO PODER PÚBLICO DESTINADA A VERIFICAÇÃO DO CUMPRIMENTO DA LEGISLAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.19.00.00.00.0000','SERVIÇOS ADMINISTRATIVOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS ADMINISTRATIVOS PRESTADOS, DAS ATIVIDADES DE APOIO ADMINSITRATIVO EXECUTADAS EM ORGANIZAÇÕES DE QUALQUER NATUREZA, TAIS COMO: TAXAS DE EXPEDICAO DE CERTIFICADOS; TAXAS DE REGISTRO, RENOVAÇÃO, VISTORIA DE VEICULOS, LICENCA, CADASTRAMENTO, ETC. DATILOGRAFIA, MICROFILMAGEM, COPIAS XEROGRAFICAS, HELIOGRAFICAS,FOTOSTATICAS, ETC; INSCRIÇÃO EM CONCURSOS. TAXA DE ADMINISTRAÇÃO DE SERVIÇOS. VENDA DE EDITAIS. SERVIÇOS DE FORNECIMENTO DE LISTAGENS, BEM COMO OUTROS SERVIÇOS ADMINISTRATIVOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.20.00.00.00.0000','SERVIÇOS DE METEOROLOGIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS DE METEOROLOGIA PRESTADOS. VPA PROPORCIONADA PELO FORNECIMENTO DE DADOS METEOROLOGICOS E DE PARECERES TECNICOS, BEM COMO CONSERTO, COMPARAÇÃO E AFERICAO DE EQUIPAMENTOS DE METEOROLOGIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.21.00.00.00.0000','SERVIÇOS EDUCACIONAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DO SISTEMA EDUCACIONAL, CUJA NATUREZA ESTEJA DIRETAMENTE RELACIONADA A FORMAÇÃO DO EDUCANDO (MATRICULAS, ANUIDADES, ETC...). AS VPA DE ATIVIDADES AUXILIARES, DE APOIO OU DERIVADAS DOS SERVIÇOS EDUCACIONAIS PROPRIAMENTE DITOS, DEVEM SER CLASSIFICADAS NOS TITULOS APROPRIADOS. EXEMPLOS: MATRICULAS E ANUIDADES, SERVIÇOS EDUCACIONAIS, TAXAS DE EXPEDICAO DE DOCUMENTOS, COPIAS XEROGRAFICAS, HELIOGRAFICAS, ETC.., SERVICO DE CREDENCIAMENTO, AUTORIZAÇÃO E RECONHECIMENTO DE CURSOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.22.00.00.00.0000','SERVIÇOS AGROPECUARIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS AGROPECUARIO: A)PREPARO E CORRECAO DE SOLOS (DESTOCAMENTO, ARAÇÃO, GRADEAÇÃO, CALAGEM, ADUBAÇÃO, DRENAGEM, IRRIGAÇÃO, CAPINA, DESMATAMENTO, ETC.); B)SEMEADURA E PLANTIO; C)COMBATE A PRAGAS (PULVERIZAÇÃO, DEDETIZAÇÃO); D)COLHEITA E PREPARAÇÃO DE PRODUTOS AGRICOLAS; E)INSEMINAÇÃO ARTIFICIAL; F)INCUBAÇÃO DE OVOS; G)VACINAÇÃO DE ANIMAIS; H)OUTROS SERVIÇOS AUXILIARES DE AGRICULTURA E PECUARIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.23.00.00.00.0000','SERVIÇOS DE REPARAÇÃO,MANUTENCAO E INSTALAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS DE REPARAÇÃO, MANUTENCAO E INSTALAÇÃO PRESTADOS. VPA DE SERVIÇOS DE REPARAÇÃO DE ARTEFATOS DE METAL; REPARAÇÃO E MANUTENCAO DE MAQUINAS E APARELHOS DE USO DOMESTICO; REPARAÇÃO, MANUTENCAO E INSTALAÇÃO DE MAQUINAS E APARELHOS ELETRICOS E ELETRONICOS E DE COMUNICAÇÃO; REPARAÇÃO E MANUTENCAO DE INSTALAÇÕES ELETRICAS, DE GAS, DE AGUA, ETC...INCLUEM-SE TAMBEM, NESSE TITULO, OS SERVIÇOS DE CONFECCAO SOB MEDIDA. NÃO SAO CONSIDERADOS NESSE TITULO, CLASSIFICANDO-SE EM VPA INDUSTRIAL: REPARAÇÃO E MANUTENCAO DE VEICULOS FERROVIARIOS, EMBARCAÇÕES E AERONAVES (INDUSTRIA DE MATERIAL DE TRANSPORTE).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.24.00.00.00.0000','SERVIÇOS RECREATIVOS E CULTURAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS RECREATIVOS E CULTURAIS PRESTADOS. VPA PROPORCIONADA PELA EXPLORAÇÃO DE INSTALAÇÕES PARA RECREAÇÃO, PRATICA DESPORTIVA E CULTURAL (CINEMAS, TEATROS, SALOES PARA RECITAIS, CONCERTOS, CONFERENCIAS, PLANETARIOS, ESTADIOS DESPORTIVOS, AUTODROMOS, MUSEUS, BIBLIOTECAS, PROMOCAO E/OU PRODUCAO DE ESPETACULOS ARTISTICOS CULTURAIS E ESPORTIVOS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.25.00.00.00.0000','SERVIÇOS DE FORNECIMENTO DE AGUA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS PRESTADOS DE FORNECIMENTO DE AGUA AOS IRRIGANTES A AMORTIZAÇÃO DOS INVESTIMENTOS DA INFRA-ESTRUTURA DE IRRIGAÇÃO DOS PROJETOS PÚBLICOS. INCLUSIVE DÍVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.26.00.00.00.0000','SERVIÇOS DE PERFURAÇÃO E INSTALAÇÃO DE POCOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS PRESTADOS DE PERFURAÇÃO EINSTALAÇÃO DE POCOS TUBULARES PROFUNDOS, POCOS ARTESIANOS OU SIMILARES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.27.00.00.00.0000','SERVIÇOS DE GEOPROCESSAMENTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS PRESTADOS A TERCEIROS DE INTERPRETAÇÃO DE IMAGEM AERO FOTOGRAMETRICA, EXECUÇÃO DE MAPAS DIGITALIZADOS DIVERSOS, VENDA DE CARTAS E IMAGENS DE SATELITES, VIDEOGRAFICAS E SIMILARES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.28.00.00.00.0000','SERVIÇOS DE CADASTRAMENTO DE FORNECEDORES','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTAÇÃO DE SERVIÇOS DE CADASTRAMENTO DE EMPRESAS FORNECEDORAS DE BENS E SERVIÇOS AO GOVERNO FEDERAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.29.00.00.00.0000','TARIFAS DE INSCRIÇÃO EM CONCURSOS E PROCESSOS SELETIVOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE INSCRIÇÃO EM CONCURSOS E PROCESSOS SELETIVOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.30.00.00.00.0000','SERVIÇOS VETERINARIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVIÇOS VETERINARIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.31.00.00.00.0000','SERVIÇOS FINANCEIROS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM SERVICOS FINANCEIROS TAIS COMO: SERVICOS DE REMUNERACAO SOBRE REPASSE PARA PROGRAMAS DE DESENVOLVIMENTO ECONOMICO, COMISSOES PELA PRESTACAO DE GARANTIA, SERVICOS FINANCEIROS DE GARANTIA DA ATIVIDADE AGROPECUARIA, SERVIÇOS FINANCEIROS PROVENIENTES DA EXECUÇÃO DE GARANTIA - OPERAÇÕES DE CREDITO INTERNA, SERVIÇOS FINANCEIROS PROVENIENTES DA EXECUÇÃO DE GARANTIA - OPERAÇÕES DE CREDITO EXTERNAS BEM COMO OUTROS SERVICOS FINANCEIROS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.32.00.00.00.0000','SERVIÇOS COMERCIAIS','REGISTRA A VPA DE SERVICOS COMERCIAIS E FINANCEIRAS ORIUNDAS DAS ATIVIDADES DO COMERCIO VAREJISTA E ATACADISTA, OU SEJA, OPERACOES DE REVENDA DE MERCADORIAS PARA CONSUMO, USO PESSOAL OU USO DOMESTICO, BEM COMO A REVENDA DE MERCADORIAS A COMERCIANTES VAREJISTAS, A CONSUMIDORES INDUSTRIAIS, A INSTITUICOES, PROFISSIONAISE OUTROS COMERCIANTES ATACADISTAS. ABRANGE TAMBEM OS SERVICOS AUXILIARES DE COMERCIO: AGENTES, CORRETORES E INTERMEDIARIOS DE VENDA DE MERCADORIAS A BASE DE COMISSAO. NAO ESTAO INCLUIDAS AS VPA ORIUNDAS DA VENDA DE MERCADORIAS QUE TENHAM SOFRIDO PROCESSODE TRANSFORMACAO NO PROPRIO ESTABELECIMENTO, AS QUAIS DEVERAO SER CLASSIFICADAS EM VPA DA INDUSTRIA DE TRANSFORMACAO. EX: COMERCIALIZACAO DE MEDICAMENTOS, COMERCIALIZACAO DE LIVROS, PERIODICOS, MATERIAIS ESCOLARES E PUBLICIDADE, COMERCIALIZACAO E DISTRIBUICAO DE PRODUTOS AGROPECUARIOS, COMERCIALIZACAO DE PRODUTOS, DADOS E MATERIAIS DE INFORMATICA ALÉM DE OUTROS SERVICOS COMERCIAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.33.00.00.00.0000','SERVIÇOS AGROPECUARIOS','REGISTRA O VALOR TOTAL DA VPA COM SERVICOS AGROPECUARIO TAIS COMO: PREPARO E CORRECAO DE SOLOS (DESTOCAMENTO, ARACAO, GRADEACAO, CALAGEM, ADUBACAO, DRENAGEM, IRRIGACAO, CAPINA, DESMATAMENTO, ETC.); SEMEADURA E PLANTIO; COMBATE A PRAGAS (PULVERIZACAO, DEDETIZACAO); COLHEITA E PREPARACAO DE PRODUTOS AGRICOLAS; INSEMINACAO ARTIFICIAL; INCUBACAO DE OVOS; VACINACAO DE ANIMAIS; OUTROS SERVICOS AUXILIARES DE AGRICULTURA E PECUARIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.34.00.00.00.0000','SERVIÇO INDUSTRIAL','REGISTRA O VALOR TOTAL DA VPA DA INDÚSTRIA DE EXTRAÇÃO MINERAL, DE TRANSFORMAÇÃO, DE CONSTRUÇÃO E OUTROS, PROVENIENTES DAS ATIVIDADES INDUSTRIAIS DEFINIDAS COMO TAIS PELA FUNDAÇÃO INSTITUTO BRASILEIRO DE GEOGRAFIA E ESTATÍSTICA – IBGE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.35.00.00.00.0000','SERVIÇOS DE CAPTAÇÃO, ADUCAO, TRATAMENTO, RESERVAÇÃO E DISTRIBUICAO DE AGUA','REGISTRA O VALOR DA VPA DE SERVIÇOS PRESTADOS A USUÁRIOS PELO FORNECIMENTO DE ÁGUA POTÁVEL REPRESENTADOS PELO CONSUMO AUFERIDO QUANDO DA UTILIZAÇÃO DO SERVIÇO A DISPOSIÇÃO DO PROPRIETÁRIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.36.00.00.00.0000','SERVIÇOS DE COLETA, TRANSPORTE, TRATAMENTO E DESTINO FINAL DE ESGOTOS','REGISTRA O VALOR DA VPA DE SERVIÇOS PRESTADOS A USUÁRIOS BENEFICIADOS COM ESGOTAMENTO SANITÁRIO REPRESENTADOS PELO CONSUMO AUFERIDO QUANDO DA UTILIZAÇÃO DO SERVIÇO A DISPOSIÇÃO DO PROPRIETÁRIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.37.00.00.00.0000','SERVIÇOS DE COLETA, TRANSPORTE, TRATAMENTO E DESTINO FINAL DE RESIDUOS SOLIDOS','REGISTRA O VALOR DA VPA DE SERVIÇOS COM A COLETA, TRANSPORTE, TRATAMENTO E DESTINO FINAL DE RESÍDUOS SÓLIDOS REPRESENTADOS PELO CONSUMO AUFERIDO QUANDO DA UTILIZAÇÃO DO SERVIÇO A DISPOSIÇÃO DO PROPRIETÁRIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.38.00.00.00.0000','SERVIÇOS DE ABATE DE ANIMAIS','REGISTRA O VALOR DA VPA DE SERVIÇOS DE ABATE DE ANIMAIS PRATICADOS POR MATADOURO MUNICIPAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.39.00.00.00.0000','SERVIÇOS DE PREPARAÇÃO DA TERRA EM PROPRIEDADES PARTICULARES','REGISTRA O VALOR DA VPA DE SERVIÇOS DE PREPARAÇÃO DA TERRA EM PROPRIEDADES PARTICULARES, INCLUSIVE COLHEITA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.40.00.00.00.0000','SERVIÇOS DE CEMITERIO','REGISTRA O VALOR DA VPA DE SERVIÇOS DE CONSTRUÇÃO E LIMPEZA DE TÚMULOS PERPÉTUOS E OUTROS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.41.00.00.00.0000','SERVIÇOS DE ILUMINAÇÃO PÚBLICA','REGISTRA O VALOR DA VPA DE SERVIÇOS DE ILUMINAÇÃO PÚBLICA REPRESENTADO PELO CONSUMO AUFERIDO QUANDO DA UTILIZAÇÃO DO SERVIÇO A DISPOSIÇÃO DO PROPRIETÁRIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.42.00.00.00.0000','SERVIÇOS DE RELIGAMENTO DE AGUA','REGISTRA O VALOR DA VPA DE SERVIÇOS DE RELIGAMENTO DE ÁGUA, OCASIONADOS POR CORTE DE FORNECIMENTO EM FUNÇÃO DO NÃO PAGAMENTO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.43.00.00.00.0000','SERVICO DE INFORMAÇÕES ESTATISTICAS','REGISTRA O VALOR TOTAL DA VPA PROVENIENTE DA PRESTAÇÃO DE SERVIÇOS DE INFORMAÇÕES ESTATÍSTICAS, FORNECIDAS A ENTIDADES PÚBLICAS OU PRIVADAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.44.00.00.00.0000','SERVICO DE MAQUINAS','REGISTRA O VALOR DA ARRECADAÇÃO PROVENIENTE DO SERVIÇO DE MÁQUINA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.45.00.00.00.0000','SERVICO DE PAVIMENTAÇÃO E REPAVIMENTAÇÃO','REGISTRA O VALOR DA ARRECADAÇÃO PROVENIENTE DO SERVIÇO DE PAVIMENTAÇÃO E REPAVIMENTAÇÃO','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.46.00.00.00.0000','SERVIÇOS DE LIGAÇÃO DE AGUA E ESGOTO','REGISTRA O VALOR DA ARRECADAÇÃO PROVENIENTE DO SERVIÇO DE LIGAÇÃO DE ÁGUA E ESGOTO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.47.00.00.00.0000','SERVIÇOS RELATIVOS A EVENTOS EDUCACIONAIS','REGISTRA O VALOR DA ARRECADAÇÃO PROVENIENTE DO SERVIÇOS RELATIVOS A EVENTOS EDUCACIONAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.1.1.99.00.00.00.0000','OUTROS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS NÃO ENQUADRADOS NOS ITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.9.0.00.00.00.00.0000','(-) DEDUCOES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS','COMPREENDE AS DEDUCOES DAS PRESTAÇÕESDE SERVIÇOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.9.1.00.00.00.00.0000','(-) DEDUÇÕES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','COMPREENDE AS DEDUCOES DAS PRESTAÇÕES DE SERVIÇOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.9.1.01.00.00.00.0000','(-) VENDAS CANCELADAS E DEVOLUÇÕES','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS CANCELADAS E DEVOLUÇÕES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.9.1.02.00.00.00.0000','(-) ABATIMENTOS','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - ABATIMENTOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.9.1.03.00.00.00.0000','(-) DESCONTOS INCONDICIONAIS','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - DESCONTOS INCONDICIONAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.9.1.05.00.00.00.0000','(-) ISS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ISS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.9.1.06.00.00.00.0000','(-) ICMS','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - ICMS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.9.1.07.00.00.00.0000','(-) PIS/PASEP','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - PIS/PASEP.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.9.1.09.00.00.00.0000','(-) COFINS','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - COFINS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.9.1.10.00.00.00.0000','(-)AJUSTE A VALOR PRESENTE','REGISTRA AS DEDUÇÕES DAS VENDAS DE MERCADORIAS, COMO DEVOLUÇÕES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. DEDUÇÃO DE VENDAS - AJUSTE A VALOR PRESENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.3.3.9.1.99.00.00.00.0000','(-) CONTRIBUIÇÕES PREVIDENCIARIAS - INSS PATRONAL','REGISTRA O VALOR DA CONTRIBUIÇÃO PATRONAL DEVIDA PELAS EMPRESAS QUE PRESTAM EXCLUSIVAMENTE SERVIÇOS DE TECNOLOGIA DA INFORMAÇÃO (TI) E DE TECNOLOGIA DA INFORMAÇÃO E COMUNICAÇÃO (TIC), INCIDENTES SOBRE O VALOR DA RECEITA BRUTA, EXCLUÍDAS AS VENDAS CANCELADAS E OS DESCONTOS INCONDICIONAIS CONCEDIDOS, CONFORME DISPÕE O ARTIGO 7º DA LEI 12.546/2011. A PRESENTE METODOLOGIA DE CALCULO DO INSS PATRONAL TERÁ VIGÊNCIA ATE 31/12/2014.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.0.0.0.00.00.00.00.0000','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS FINANCEIRAS','COMPREENDE O SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS COM OPERAÇÕES FINANCEIRAS. COMPREENDE: DESCONTOS OBTIDOS, JUROS AUFERIDOS, PREMIO DE RESGATE DE TITULOS E DEBENTURES, ENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.1.0.0.00.00.00.00.0000','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.1.1.0.00.00.00.00.0000','JUROS E ENCARGOS DE EMPRÉSTIMOS CONCEDIDOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS RELATIVAS A APLICAÇÃO DAS TAXAS DE JUROS APLICADAS A EMPRÉSTIMOS CONCEDIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.1.1.1.00.00.00.00.0000','JUROS E ENCARGOS DE EMPRÉSTIMOS CONCEDIDOS - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS RELATIVAS A APLICAÇÃO DAS TAXAS DE JUROS APLICADAS A EMPRÉSTIMOS CONCEDIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.1.1.3.00.00.00.00.0000','JUROS E ENCARGOS DE EMPRÉSTIMOS CONCEDIDOS - INTER OFSS - UNIÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS RELATIVAS A APLICAÇÃO DAS TAXAS DE JUROS APLICADAS A EMPRÉSTIMOS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE A UNIÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.1.1.4.00.00.00.00.0000','JUROS E ENCARGOS DE EMPRÉSTIMOS CONCEDIDOS - INTER OFSS - ESTADO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS RELATIVAS A APLICAÇÃO DAS TAXAS DE JUROS APLICADAS A EMPRÉSTIMOS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.1.1.5.00.00.00.00.0000','JUROS E ENCARGOS DE EMPRÉSTIMOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS RELATIVAS A APLICAÇÃO DAS TAXAS DE JUROS APLICADAS A EMPRÉSTIMOS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.1.2.0.00.00.00.00.0000','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS RELATIVAS À APLICAÇÃO DAS TAXAS DE JUROS APLICADAS A EMPRÉSTIMOS EXTERNOS CONCEDIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.1.2.1.00.00.00.00.0000','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS RELATIVAS À APLICAÇÃO DAS TAXAS DE JUROS APLICADAS A EMPRÉSTIMOS EXTERNOS CONCEDIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.1.3.0.00.00.00.00.0000','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS INTERNOS CONCEDIDOS PELA UNIÃO, ENTIDADES E INSTITUIÇÕES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.1.3.1.00.00.00.00.0000','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS INTERNOS CONCEDIDOS PELA UNIÃO, ENTIDADES E INSTITUIÇÕES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.1.3.3.00.00.00.00.0000','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS INTERNOS CONCEDIDOS PELA UNIÃO, ENTIDADES E INSTITUIÇÕES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.1.3.4.00.00.00.00.0000','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS INTERNOS CONCEDIDOS PELA UNIÃO, ENTIDADES E INSTITUIÇÕES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.1.3.5.00.00.00.00.0000','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS INTERNOS CONCEDIDOS PELA UNIÃO, ENTIDADES E INSTITUIÇÕES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.1.4.0.00.00.00.00.0000','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS EXTERNOS CONCEDIDOS PELA UNIÃO, ENTIDADES E INSTITUIÇÕES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.1.4.1.00.00.00.00.0000','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS EXTERNOS CONCEDIDOS PELA UNIÃO, ENTIDADES E INSTITUIÇÕES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.0.0.00.00.00.00.0000','JUROS E ENCARGOS DE MORA','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO REPRESENTANDO O RESULTADO DAS APLICAÇÕES IMPOSTAS AO CONTRIBUINTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.1.0.00.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO RELATIVA A EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.1.1.00.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO RELATIVA A EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.1.3.00.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS - INTER OFSS - UNIÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO RELATIVA A EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.1.4.00.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS - INTER OFSS - ESTADO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO RELATIVA A EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.1.5.00.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO RELATIVA A EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.2.0.00.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO RELATIVA A EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.2.1.00.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO RELATIVA A EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.3.0.00.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIÁRIAS DECORRENTES DA INOBSERVÂNCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO RELATIVA A FORNECIMENTO DE BENS E SERVIÇOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.3.1.00.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIÁRIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO RELATIVA A FORNECIMENTO DE BENS E SERVIÇOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.3.1.02.00.00.00.0000','MULTAS E JUROS DE MORA DE ALUGUEIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLIC. ATRAS. PAGAMEN. DE ALUGUEIS DEVIDOS POR USO DO PATRIMONIO IMOBILIARIO DO MUNICÍPIO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.3.1.03.00.00.00.0000','MULTAS E JUROS DE MORA DE ARRENDAMENTOS','REGISTRA A VPA PROVENIENTE DE MUL.JUR. MORA APLIC.P/ ATRAS. NO PAGAMENTO DE RENDAS DEVIDAS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO SOB A FORMA DE ARRENDAMENTO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.3.1.04.00.00.00.0000','MULTAS E JUROS DE MORA DE LAUDEMIOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA ATRASOS NOS RECOLHIMEN. DAS DIFERENCAS DE LAUDEMIOS, GERADAS ANTES DA EDICAO DA M.P NUM 1647 - 14, DE 24 DE MARCO DE 1998, DE ACORDO COM O PREVISTO NO ART. 5. DO DECRETO NUM. 95.760, DE 01 DE MARCO DE 1988.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.3.1.05.00.00.00.0000','MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DO PROGRAMA TROCA-TROCA','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DO PROGRAMA TROCA-TROCA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.3.1.06.00.00.00.0000','MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DA PRESTAÇÃO DE SERVIÇOS','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DA PRESTAÇÃO DE SERVIÇOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.3.1.07.00.00.00.0000','MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DOS AUTOS DE INFRAÇÃO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DOS AUTOS DE INFRAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.3.1.99.00.00.00.0000','OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVIÇOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVIÇOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.0.00.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE APLICADA EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DE CRÉDITOS TRIBUTÁRIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.00.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE APLICADA EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DE CRÉDITOS TRIBUTÁRIOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.01.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE IMPOSTOS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE APLICADA EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DOS IMPOSTOS DEVIDOS PELOS CONTRIBUINTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.01.01.00.00.0000','MULTAS E JUROS DE MORA DO IMPOSTO SOBRE A RENDA RETIDO NAS FONTES - IRRF','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS DECORRENTES DA INOBSERVANCIA DE NORMA TRITUTARIA E JUROS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO TRIBUTÁRIA IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.01.02.00.00.0000','MULTA E JUROS DE MORA DO ITR MUNICÍPIOS CONVENIADOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTÁRIA E JUROS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO TRIBUTÁRIA IMPOSTAS AO CONTRIBUINTE REFERENTES AO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICÍPIOS CONVENIADOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.01.03.00.00.0000','MULTAS E JUROS DE MORA DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA - IPTU','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL URBANA - IPTU.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.01.04.00.00.0000','MULTAS E JUROS DE MORA DO IMPOSTO SOBRE A TRANSMISSAO INTER-VIVOS DE BENS IMÓVEIS - ITBI','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA DO IMPOSTO SOBRE A TRANSMISSÃO INTER-VIVOS DE BENS IMÓVEIS - ITBI.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.01.05.00.00.0000','MULTAS E JUROS DE MORA DO IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA - ISS','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA DO IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA– ISS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.02.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE AS TAXAS','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA DAS TAXAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.02.01.00.00.0000','MULTAS E JUROS DE MORA DA TAXA DE FISCALIZAÇÃO E VIGILANCIA SANITARIA','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE FISCALIZAÇÃO DE VIGILANCIA SANITARIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.03.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE AS CONTRIBUIÇÕES DE MELHORIA','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE MULTAS E JUROS DE MORA DAS CONTRIBUIÇÕES DE MELHORIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.04.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE A DÍVIDA ATIVA DOS IMPOSTOS','REGISTRA O VALOR TOTAL DA VPA DE MULTAS E JUROS DE MORA INCIDENTES SOBRE A DÍVIDA ATIVA DOS IMPOSTOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.04.01.00.00.0000','MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA RETIDO NA FONTE','REGISTRA O VALOR DA VARIAÇÃO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NÃO CUMPRIMENTO DE OBRIGAÇÕES PARA COM A FAZENDA PÚBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA - RETIDO NAS FONTES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.04.02.00.00.0000','MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICÍPIO CONVENIADO','REGISTRA O VALOR DA VARIAÇÃO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NÃO CUMPRIMENTO DE OBRIGAÇÕES PARA COMA FAZENDA PÚBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DÍVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICÍPIO CONVENIADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.04.03.00.00.0000','MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA - IPTU','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA INCIDENTE SOBRE A DÍVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA – IPTU.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.04.04.00.00.0000','MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DO IMPOSTO SOBRE A TRANSMISSAO INTER-VIVOS DE BENS IMÓVEIS - ITBI','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA INCIDENTE SOBRE A DÍVIDA ATIVA DO IMPOSTO SOBRE A TRANSMISSÃO INTER-VIVOS DE BENS IMÓVEIS – ITBI.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.04.05.00.00.0000','MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DO IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA - ISS','REGISTRA O VALOR DA ARRECADAÇÃO DE VPAS DE MULTAS E JUROS DE MORA INCIDENTE SOBRE A DÍVIDA ATIVA DO IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA - ISS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.05.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE A DÍVIDA ATIVA DAS TAXAS','REGISTRA O VALOR TOTAL DA VPA DE MULTAS E JUROS DE MORA INCIDENTES SOBRE A DÍVIDA ATIVA DAS TAXAS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.05.01.00.00.0000','MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DA TAXA DE FISCALIZAÇÃO E VIGILANCIA SANITARIA','REGISTRA O VALOR DA ARRECADAÇÃO DE VPAS DE MULTAS E JUROS DE MORA INCIDENTE SOBRE A DÍVIDA ATIVA DA TAXA DE FISCALIZAÇÃO E VIGILÂNCIA SANITÁRIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.06.00.00.00.0000','MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','REGISTRA O VALOR DA ARRECADAÇÃO DE VPAS DE MULTAS E JUROS DE MORA INCIDENTES SOBRE A DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.07.00.00.00.0000','MULTA E JUROS MORA DA CONTRIBUIÇÃO DO SERVIDOR PARA O RPPS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVAS PROVENIENTES DE MULTA E JUROS MORA DA CONTRIBUIÇÃO DO SERVIDOR PARA O RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.96.00.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE OUTROS CRÉDITOS TRIBUTÁRIOS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE OUTRAS CRÉDITOS TRIBUTÁRIOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.96.01.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE OUTROS TRIBUTOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE OUTROS TRIBUTOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.96.02.00.00.0000','JUROS E ENCARGOS DE MORA SOBRE DÍVIDA ATIVA DE OUTROS TRIBUTOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE DÍVIDA ATIVA DE OUTROS TRIBUTOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.4.1.97.00.00.00.0000','(-) DEDUCOES DOS JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS','COMPREENDEM AS DEDUCOES DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS INCLUSIVE DÍVIDA ATIVA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.9.0.00.00.00.00.0000','OUTROS JUROS E ENCARGOS DE MORA','COMPREENDE AS OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.9.1.00.00.00.00.0000','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','COMPREENDE AS OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.9.1.01.00.00.00.0000','MULTAS E JUROS DE MORA DA ALIENAÇÃO DE DOMINIO UTIL','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS JUROS DE MORA ALIEN. DOM.UTIL. MULTAS APLICADAS POR ATRASOS NO RECOLHIMENTO DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL DE TERRENOS DA UNIAO, DE ACORDO COM O PREVISTO NO ARTIGO 4 DO DECRETO-LEI NUM 1561, DE 13 DE JULHO DE 1977 E ARTIGOS 25 A 27 DA MP NUM. 1647-14, DE 24 DE FEVEREIRO DE 1998.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.9.1.02.00.00.00.0000','MULTAS E JUROS DE MORA DA ALIENAÇÃO DE OUTROS BENS IMÓVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE ALIEN. DE OUTROS BENS IMÓVEIS. MULTAS APLICADAS POR ATRASOS NOS RECOLHIMENTOS DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL OU PLENO DE IMÓVEIS DA UNIAO, DE ACORDO COM O PREVISTO NOS ARTIGOS 25 A 27 DA MP NUM. 1647-14 DE 24 DE MARCO DE 1998.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.9.1.04.00.00.00.0000','MULTAS E JUROS DE MORA DE DIVIDENDOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICAÇÃO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE DIVIDENDOS DEVIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.9.1.05.00.00.00.0000','MULTAS E JUROS DE MORA DE PARTICIPAÇÕES','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICAÇÃO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE PARTICIPAÇÕES DEVIDAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.2.9.1.99.00.00.00.0000','OUTROS JUROS E ENCARGOS DE MORA','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTES DE OUTROS JUROS E ENCARGOS DE MORA','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.0.0.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A A CORRECAO MONETARIA POS-FIXADA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.1.0.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS DE EMPRÉSTIMOS CONCEDIDOS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORREÇÃO MONETÁRIA PÓS-FIXADA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.1.1.00.00.00.00.0000','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS CONCEDIDOS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.1.1.01.00.00.00.0000','VARIAÇÕES MONETARIAS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.1.1.02.00.00.00.0000','VARIAÇÕES CAMBIAIS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.1.3.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS DE EMPRÉSTIMOS CONCEDIDOS - INTER OFSS - UNIÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.1.3.01.00.00.00.0000','VARIAÇÕES MONETARIAS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.1.3.02.00.00.00.0000','VARIAÇÕES CAMBIAIS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.1.4.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS DE EMPRÉSTIMOS CONCEDIDOS - INTER OFSS - ESTADO','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.1.4.01.00.00.00.0000','VARIAÇÕES MONETARIAS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.1.4.02.00.00.00.0000','VARIAÇÕES CAMBIAIS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.1.5.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS DE EMPRÉSTIMOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.2.0.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES AOS EMPRÉSTIMOS EXTERNOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.2.1.00.00.00.00.0000','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES AOS EMPRÉSTIMOS EXTERNOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA PÓS-FIXADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.3.0.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS INTERNOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA PÓS-FIXADA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.3.1.00.00.00.00.0000','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS INTERNOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA PÓS-FIXADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.3.1.01.00.00.00.0000','VARIAÇÕES MONETARIAS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO FINANCIAMENTOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.3.1.02.00.00.00.0000','VARIAÇÕES CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO FINANCIAMENTOS CONCEDIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.3.3.00.00.00.00.0000','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS- UNIÃO','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO FINANCIAMENTOS INTERNOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.3.4.00.00.00.00.0000','VARIAÇÕES MONETARIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO FINANCIAMENTOS INTERNOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.3.5.00.00.00.00.0000','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO FINANCIAMENTOS INTERNOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.4.0.00.00.00.00.0000','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS EXTERNOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA PÓS-FIXADA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.4.1.00.00.00.00.0000','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS EXTERNOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA PÓS-FIXADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.9.0.00.00.00.00.0000','OUTRAS VARIAÇÕES MONETARIAS E CAMBIAIS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.9.1.00.00.00.00.0000','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.9.1.01.00.00.00.0000','OUTRAS VARIAÇÕES MONETARIAS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.9.1.02.00.00.00.0000','OUTRAS VARIAÇÕES CAMBIAIS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.9.3.00.00.00.00.0000','OUTRAS VARIAÇÕES MONETARIAS E CAMBIAIS - INTER OFSS - UNIÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.9.4.00.00.00.00.0000','OUTRAS VARIAÇÕES MONETARIAS E CAMBIAIS - INTER OFSS - ESTADO','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.3.9.5.00.00.00.00.0000','OUTRAS VARIAÇÕES MONETARIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELAÇÃO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIAÇÃO DO VALOR DA NOSSSA MOEDA EM RELAÇÃO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE SERA TRATADA COMO VARIAÇÃO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.4.0.0.00.00.00.00.0000','DESCONTOS FINANCEIROS OBTIDOS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE DESCONTOS FINANCEIROS OBTIDOS EM VIRTUDE DE LIQUIDAÇÃO ANTECIPADA DE OBRIGAÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.4.0.1.00.00.00.00.0000','DESCONTOS FINANCEIROS OBTIDOS - CONSOLIDAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE DESCONTOS FINANCEIROS OBTIDOS EM VIRTUDE DE LIQUIDAÇÃO ANTECIPADA DE OBRIGAÇÕES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.5.0.0.00.00.00.00.0000','REMUNERAÇÃO DE DEPÓSITOS BANCARIOS E APLICAÇÕES FINANCEIRAS','COMPREENDE O VALOR TOTAL DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DA REMUNERAÇÃO DO SALDO DIARIO DOS DEPÓSITO DA UNIAO EXISTENTES NO BANCO CENTRAL, BEM COMO APLICAÇÃO DE RECURSOS DA CONTA UNICA DE ACORDO COM A RENTABILIDADE MEDIA INTRINSECA DOS TITULOS DO TESOURO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.5.1.0.00.00.00.00.0000','REMUNERAÇÃO DE DEPÓSITOS BANCARIOS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA REMUNERAÇÃO DOS DEPÓSITOS BANCARIOS DO ENTE EXISTENTES NO AGENTE FINANCEIRO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.5.1.1.00.00.00.00.0000','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS - CONSOLIDAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA REMUNERAÇÃO DOS DEPÓSITOS BANCARIOS DO ENTE EXISTENTES NO AGENTE FINANCEIRO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.5.1.1.01.00.00.00.0000','REMUNERAÇÃO DE DEPÓSITOS DE RECURSOS VINCULADOS','REGISTRA O VALOR DA VPA PROVENIENTE DA REMUNERAÇÃO DE DEPÓSITOS BANCARIOS DE RECURSOS VINCULADOS, TAIS COMO: ROYALTIES, FUNDEB, FUNDO DE SAÚDE, REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL DOS SERVIDORES, MANUTENÇÃO E DESENVOLVIMENTO DO ENSINO, AÇÕES E SERVIÇOS PÚBLICOS DE SAÚDE (ASPS), FUNDETUR, ETC.DA REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS VINCULADOS, TAIS COMO: ROYALTIES, FUNDEB, FUNDO DE SAÚDE, REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL DOS SERVIDORES, MANUTENÇÃO E DESENVOLVIMENTO DO ENSINO, ASPS, ETC.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.5.1.1.02.00.00.00.0000','REMUNERAÇÃO DE DEPÓSITOS DE RECURSOS NÃO VINCULADOS','REGISTRA O VALOR DA VPA PROVENIENTE DA REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS DE RECURSOS NÃO VINCULADOS, INCLUSIVE RECURSOS PRÓPRIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.5.1.1.03.00.00.00.0000','REMUNERAÇÃO DOS INVESTIMENTOS DO REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL','APRESENTAR O SOMATÓRIO DAS VPAS DECORRENTES DE REMUNERAÇÃO DA CARTEIRA DE INVESTIMENTOS DOS RPPS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.5.1.1.96.00.00.00.0000','REMUNERAÇÃO DE OUTROS DEPÓSITOS BANCARIOS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA REMUNERAÇÃO DE OUTROS DEPÓSITOS BANCARIOS DO ENTE EXISTENTES NO AGENTE FINANCEIRO NÃO RELACIONADOS NAS CONTAS ACIMA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.5.1.1.97.00.00.00.0000','(-) DEDUÇÃO DA REMUNERAÇÃO DE DEPÓSITOS BANCARIOS','COMPREENDE AS DEDUÇÕES DE VPA OCORRIDAS NAS CONTAS ACIMA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.5.2.0.00.00.00.00.0000','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DA REMUNERAÇÃO DE DEPÓSITOS BANCARIOS, RECURSOS ORIUNDOS DE APLICAÇÕES DE ENTIDADES DA ADMINISTRAÇÃO PÚBLICA NO MERCADO FINANCEIRO, AUTORIZADAS POR LEI, EM CADERNETA DE POUPANCA, FUNDO DE INVESTIMENTO, CONTAS REMUNERADAS E OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.5.2.1.00.00.00.00.0000','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS - CONSOLIDAÇÃO','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DA REMUNERAÇÃO DE DEPÓSITOS BANCARIOS, RECURSOS ORIUNDOS DE APLICAÇÕES DE ENTIDADES DA ADMINISTRAÇÃO PÚBLICA NO MERCADO FINANCEIRO, AUTORIZADAS POR LEI, EM CADERNETA DE POUPANCA, FUNDO DE INVESTIMENTO, CONTAS REMUNERADAS E OUTROS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.5.2.1.01.00.00.00.0000','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS VINCULADOS','REGISTRA O VALOR DA VPA PROVENIENTE DA REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS VINCULADOS, TAIS COMO: ROYALTIES, FUNDEB, FUNDO DE SAÚDE, REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL DOS SERVIDORES, MANUTENÇÃO E DESENVOLVIMENTO DO ENSINO, AÇÕES E SERVIÇOS PÚBLICOS DE SAÚDE (ASPS), FUNDETUR, ETC.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.5.2.1.02.00.00.00.0000','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS NÃO VINCULADOS','REGISTRA O VALOR DA VPA PROVENIENTE DA REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS NÃO VINCULADOS, INCLUSIVE RECURSOS PRÓPRIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.5.2.1.03.00.00.00.0000','REMUNERAÇÃO DOS INVESTIMENTOS DO REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL','REGISTRA O VALOR DA VPA DECORRENTES DE REMUNERAÇÃO DA CARTEIRA DE INVESTIMENTOS DOS RPPS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.5.2.1.96.00.00.00.0000','REMUNERAÇÃO DE OUTRAS APLICAÇÕES FINANCEIRAS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA REMUNERAÇÃO DE OUTRAS APLICAÇÕES FINANCEIRAS DO ENTE EXISTENTES NO AGENTE FINANCEIRO NÃO RELACIONADOS NAS CONTAS ACIMA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.5.2.1.97.00.00.00.0000','(-) DEDUÇÃO DA REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS','COMPREENDE AS DEDUÇÕES DE VPA OCORRIDAS NAS CONTAS ACIMA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.9.0.0.00.00.00.00.0000','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS – FINANCEIRAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERAÇÕES FINANCEIRAS NÃO COMPREENDIDAS NOS SUBGRUPOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.4.9.0.1.00.00.00.00.0000','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS – FINANCEIRAS - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERAÇÕES FINANCEIRAS NÃO COMPREENDIDAS NOS SUBGRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.0.0.0.00.00.00.00.0000','TRANSFERÊNCIAS E DELEGAÇÕES RECEBIDAS','COMPREENDE O SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS COM TRANSFERÊNCIAS INTER GOVERNAMENTAIS, TRANSFERÊNCIAS INTRAGOVERNAMENTAIS, TRANSFERÊNCIAS A INSTITUICOES MULTIGOVERNAMENTAIS, TRANSFERÊNCIAS A INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS, TRANSFERERENCIAS DE CONVÊNIOS , TRANSFERÊNCIAS DO EXTERIOR E EXECUÇÕES ORÇAMENTÁRIAS DELEGADAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.0.0.00.00.00.00.0000','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERÊNCIAS FINANCEIRAS RELATIVAS A EXECUÇÃO ORCAMENTARIA, E DE BENS E VALORES, REFERENTES AS TRANSAÇÕES INTRA GOVERNAMENTAIS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.0.00.00.00.00.0000','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA','COMPREENDE O VALOR DAS TRANSFERÊNCIAS FINANCEIRAS RECEBIDAS E CORRESPONDÊNCIA DE CRÉDITOS EM VIRTUDE DA EXECUÇÃO ORÇAMENTÁRIA (COTA, REPASSE E SUB-REPASSE). INCLUI TAMBÉM O VALOR REPASSAADO PARA A COBERTURA DO DÉFICIT FINANCEIRO DO RPPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.00.00.00.00.0000','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','COMPREENDE O VALOR DAS TRANSFERÊNCIAS FINANCEIRAS RECEBIDAS E CORRESPONDÊNCIA DE CRÉDITOS EM VIRTUDE DA EXECUÇÃO ORÇAMENTÁRIA (COTA, REPASSE E SUB-REPASSE). INCLUI TAMBÉM O VALOR REPASSAADO PARA A COBERTURA DO DÉFICIT FINANCEIRO DO RPPS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.01.00.00.00.0000','COTA RECEBIDA','REGISTRA O VALOR DOS RECURSOS RECEBIDOS PELA ADMINISTRAÇÃO DIRETA DECORRENTES DA PROGRAMAÇÃO FINANCEIRA CORRESPONDENTE AO ORÇAMENTO ANUAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.02.00.00.00.0000','REPASSE RECEBIDO','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE TRANSFERÊNCIAS FINANCEIRAS ENTRE ORGÃOS DA ADMISTRAÇÃO DIRETA E INDIRETA, CORRESPONDENTES AO ORÇAMENTO ANUAL .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.02.01.00.00.0000','TRANSFERENCIA DE COTA FINANCEIRA RECEBIDA DE OUTRA ENTIDADE','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.02.01.01.00.0000','TRANSFERENCIA DE COTA FINANCEIRA RECEBIDA DE OUTRA ENTIDADE - RECURSO LIVRE','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA. COM RECURSOS LIVRES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.02.01.02.00.0000','TRANSFERENCIA DE COTA FINANCEIRA RECEBIDA DE OUTRA ENTIDADE - RECURSO MDE','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA. COM RECURSOS DA MDE','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.02.01.03.00.0000','TRANSFERENCIA DE COTA FINANCEIRA RECEBIDA DE OUTRA ENTIDADE - RECURSO DAS ASPS','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA. COM RECURSOS DAS ASPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.02.01.04.00.0000','TRANSFERENCIA DE COTA FINANCEIRA RECEBIDA DE OUTRA ENTIDADE - DEMAIS RECURSOS VINCULADOS','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA. COM OS DEMAIS RECURSOS VINCULADOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.03.00.00.00.0000','SUB-REPASSE RECEBIDO','REGISTRA O VALOR DOS SUB-REPASSES RECEBIDOS NO EXERCÍCIO, DECORRENTES DE TRANSFERÊNCIAS ENTRE UG´S DO MESMO ORGÃO, CORRESPONDENTE AO ORÇAMENTO ANUAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.05.00.00.00.0000','VALORES DIFERIDOS - BAIXA','REGISTRA O VALOR DA COTA DIFERIDA NO PROCESSO DE INSCRIÇÃO E BAIXA DOS RECURSOS DIFERIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.06.00.00.00.0000','VALORES DIFERIDOS - INSCRIÇÃO','REGISTRA O VALOR DA COTA, REPASSE E SUB-REPASSE DIFERIDO NO PROCESSO DE INSCRIÇÃO E BAIXA DOS RECURSOS DIFERIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.08.00.00.00.0000','APORTE DE RECURSOS PARA O RPPS - PLANO FINANCEIRO','COMPREENDE O MONTANTE DOS VALORES RECEBIDOS DO PRÓPRIO ENTE, NECESSÁRIOS A COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS, FORMAÇÃO DE RESERVAS E OUTRAS NECESSIDADES DE RECURSOS PARA O RPPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.08.01.00.00.0000','APORTE DE RECURSOS PARA O RPPS - PLANO FINANCEIRO - REPASSE PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','REGISTRA OS RECURSOS ORCAMENTARIOS EFETIVAMENTE UTILIZADOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS ENTRE AS RECEITAS E DESPESAS PREVIDÊNCIÁRIAS, NO EXERCÍCIO DE REFERENCIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.08.02.00.00.0000','APORTE DE RECURSOS PARA O RPPS - PLANO FINANCEIRO - REPASSE PREVIDÊNCIÁRIO PARA FORMAÇÃO DE RESERVA','REGISTRA O MONTANTE DOS RECURSOS RECEBIDOS DO PROPRIO ENTE PARA FORMAÇÃO DE RESERVA ESPONTANEA PARA FUTUROS PAGAMENTOS DE BENEFÍCIOS DO PLANO FINANCEIRO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.08.99.00.00.0000','APORTE DE RECURSOS PARA O RPPS - PLANO FINANCEIRO - OUTROS APORTES PARA O RPPS','REGISTRA O SOMATÓRIO DOS RECEBIMENTOS DE EVENTUAIS APORTES DE RECURSOS PARA O REGIME PROPRIO DE PREVIDENCIA DO SERVIDOR - RPPS, PARA OUTRAS NECESSIDADES FINANCEIRAS QUE NÃO A COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS E FORMAÇÃO DE RESERVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.09.00.00.00.0000','APORTE DE RECURSOS PARA O RPPS - PLANO PREVIDENCIARIO','REPRESENTA O MONTANTE DOS VALORES RECEBIDOS DO PROPRIO ENTE, NECESSARIOS A COBERTURA DE DEFICIT FINANCEIRO OU ATUARIAL, NO AMBITO DO PLANO PREVIDENCIARIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.09.01.00.00.0000','APORTE DE RECURSOS PARA O RPPS - PLANO PREVIDÊNCIÁRIO - REPASSE PARA COBERTURA DE DÉFICIT FINANCEIRO','REGISTRA O MONTANTE DOS RECURSOS RECEBIDOS DO PROPRIO ENTE, NECESSARIOS AO EQUILIBRIO FINANCEIRO DO PLANO PREVIDÊNCIÁRIO, OU SEJA, A COBERTURA DE DÉFICIT ENTRE AS RECEITAS E AS DESPESAS PREVIDÊNCIÁRIAS, REFERENTES AO EXERCÍCIO ATUAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.09.02.00.00.0000','APORTE DE RECURSOS PARA O RPPS - PLANO PREVIDÊNCIÁRIO - REPASSE PARA COBERTURA DE DÉFICIT ATUARIAL','REGISTRA O MONTANTE DOS RECURSOS ORCAMENTARIOS ALOCADOS P/ COBERTURA DE DÉFICIT ATUARIAL NO EXERCÍCIO DE REFERENCIA, CUJO OBJETIVO E GARANTIR A EQUIVALENCIA, A VALOR PRESENTE, ENTRE O FLUXO DE RECEITAS ESTIMADAS E DAS OBRIGAÇÕES PROJETADAS, APURADAS ATUARIALMENTE, EM LONGO PRAZO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.09.99.00.00.0000','APORTE DE RECURSOS PARA O RPPS - PLANO PREVIDÊNCIÁRIO - OUTROS APORTES PARA O RPPS','REGISTRA OUTROS APORTES FINANCEIROS PARA O REGIME PROPRIO DE PREVIDENCIA DO SERVIDOR PÚBLICO - RPPS, TAIS COMO CAPITALIZAÇÕES DO REGIME.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.1.2.97.00.00.00.0000','(-) DEDUÇÕES DAS TRANSFERENCIAS INTRA GOVERNAMENTAIS','REGISTRA AS DEDUÇÕES DAS VPA DE TRANSFERENCIA INTRA GOVERNAMENTAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.2.0.00.00.00.00.0000','TRANSFERÊNCIAS RECEBIDAS - INDEPENDENTE DE EXECUÇÃO ORCAMENTARIA','COMPREENDE O VALOR DAS TRANSFERÊNCIAS FINANCEIRAS, DE BENS OU VALORES RECEBIDAS PARA RESTOS A PAGAR E OUTROS FINALIDADES INDEPENDENTES DA EXECUÇÃO ORÇAMENTÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.2.2.00.00.00.00.0000','TRANSFERÊNCIAS RECEBIDAS - INDEPENDENTE DE EXECUÇÃO ORCAMENTARIA - INTRA OFSS','COMPREENDE O VALOR DAS TRANSFERÊNCIAS FINANCEIRAS, DE BENS OU VALORES RECEBIDAS PARA RESTOS A PAGAR E OUTROS FINALIDADES INDEPENDENTES DA EXECUÇÃO ORÇAMENTÁRIA. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.2.2.01.00.00.00.0000','ORDEM TRANSFERÊNCIAS RECEBIDAS','REGISTRA O VALOR DA TRANSFERÊNCIA DE OTR`S LIBERADAS PELAS SETORIAIS DE PROGRAMAÇÃO FINANCEIRA DE CADA ORGÃO PARA SUAS SUBORDINADAS, NÃO VINCULADAS AO ORCAMENTO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.2.2.97.00.00.00.0000','(-) DEDUÇÕES DAS TRANSFERÊNCIAS INTRA GOVERNAMENTAIS','REGISTRA AS DEDUÇÕES DAS VPA DE TRANSFERÊNCIA INTRA GOVERNAMENTAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.3.0.00.00.00.00.0000','TRANSFERENCIAS RECEBIDAS PARA COBERTURA DO DÉFICIT ATUARIAL DO RPPS POR APORTE PERIÓDICO','COMPREENDE O VALOR DAS TRANSFERÊNCIAIS FINANCEIRAS PARA APORTES PERIÓDICOS DESTINADOS À COBERTURA DO DÉFICIT ATUARIAL DO RPPS, CONFORME PLANO DE AMORTIZAÇÃO ESTABELECIDO EM LEI DO RESPECTIVO ENTE FEDERATIVO, EXCETO AS DECORRENTES DE ALÍQUOTAS DE CONTRIBUIÇÃO SUPLEMENTAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.3.2.00.00.00.00.0000','TRANSFERENCIAS RECEBIDAS PARA COBERTURA DO DÉFICIT ATUARIAL DO RPPS POR APORTE PERIÓDICO – INTRA OFSS','COMPREENDE O VALOR DAS TRANSFERÊNCIAIS FINANCEIRAS PARA APORTES PERIÓDICOS DESTINADOS À COBERTURA DO DÉFICIT ATUARIAL DO RPPS, CONFORME PLANO DE AMORTIZAÇÃO ESTABELECIDO EM LEI DO RESPECTIVO ENTE FEDERATIVO, EXCETO AS DECORRENTES DE ALÍQUOTAS DE CONTRIBUIÇÃO SUPLEMENTAR. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.3.2.01.00.00.00.0000','PLANO FINANCEIRO','COMPREENDE O VALOR TOTAL DOS VALORES RECEBIDOS PELO RPPS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS, FORMAÇÃO DE RESERVA E OUTRAS NECESSIDADES FINANCEIRAS, NO ÂMBITO DO PLANO FINANCEIRO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.3.2.01.01.00.00.0000','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','REGISTRA OS RECURSOS ORÇAMENTÁRIOS EFETIVAMENTE UTILIZADOS PARA A COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS ENTRE AS RECEITAS E DESPESAS PREVIDENCIÁRIAS NO EXERCÍCIO DE REFERÊNCIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.3.2.01.02.00.00.0000','RECURSOS PARA FORMAÇÃO DE RESERVA','REGISTRA OS RECURSOS TRANSFERIDOS PELO ENTE FEDERATIVO AO RPPS PARA FORMAÇÃO DE RESERVA ESPONTÂNEA, PARA FUTUROS PAGAMENTOS DE BENEFÍCIOS DO PLANO FINANCEIRO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.3.2.01.99.00.00.0000','OUTROS APORTES PARA O RPPS','REGISTRA O SOMATÓRIO DO RECEBIMENTO DE EVENTUAIS APORTES DE RECURSOS NO RPPS PARA OUTRAS NECESSIDADES FINANCEIRAS QUE NÃO A COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS E FORMAÇÃO DE RESERVAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.3.2.02.00.00.00.0000','PLANO PREVIDENCIÁRIO','COMPREENDE O VALOR TOTAL RECEBIDO PELO RPPS PARA COBERTURA DE DÉFICIT FINANCEIRO OU ATUARIAL E OUTROS APORTES, NO ÂMBITO DO PLANO PREVIDENCIÁRIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.3.2.02.01.00.00.0000','RECURSOS PARA COBERTURA DE DÉFICIT FINANCEIRO','REGISTRA O SOMATÓRIO DOS RECEBIMENTOS DE RECURSOS NECESSÁRIOS AO EQUILÍBRIO FINANCEIRO DO PLANO PREVIDENCIÁRIO, OU SEJA, À COBERTURA DE DÉFICIT ENTRE AS RECEITAS E DESPESAS PREVIDENCIÁRIAS, REFERENTES AO EXERCÍCIO ATUAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.3.2.02.02.00.00.0000','RECURSOS PARA COBERTURA DE DÉFICIT ATUARIAL','REGISTRA OS RECURSOS ORÇAMENTÁRIOS ALOCADOS PARA COBERTURA DE DÉFICIT ATUARIAL NO EXERCÍCIO DE REFERÊNCIA, DESDE QUE NÃO DEFINIDOS POR LEI COMO CONTRIBUIÇÕES SUPLEMENTARES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.3.2.02.99.00.00.0000','OUTROS APORTES PARA O RPPS','REGISTRA OUTROS APORTES FINANCEIROS PARA O RPPS COM OUTRAS FINALIDADES PREVIDENCIÁRIAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.4.0.00.00.00.00.0000','TRANSFERÊNCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RGPS','COMPREENDE O VALOR DAS TRANSFERÊNCIAS RECEBIDAS PARA OS APORTES FINANCEIROS DA UNIÃO PARA A COBERTURA DE DÉFICITS FINANCEIROS OU ATUARIAIS DO RGPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.4.2.00.00.00.00.0000','TRANSFERÊNCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RGPS – INTRA OFSS','COMPREENDE O VALOR DAS TRANSFERÊNCIAS RECEBIDAS PARA OS APORTES FINANCEIROS DA UNIÃO PARA A COBERTURA DE DÉFICITS FINANCEIROS OU ATUARIAIS DO RGPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.4.2.01.00.00.00.0000',' RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','COMPREENDE OS RECURSOS ORÇAMENTÁRIOS EFETIVAMENTE UTILIZADOS PARA A COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS ENTRE AS RECEITAS E DESPESAS PREVIDENCIÁRIAS NO EXERCÍCIO DE REFERÊNCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.4.2.01.01.00.00.0000','PROVENIENTES DO ORÇAMENTO DA SEGURIDADE SOCIAL','REGISTRA O MONTANTE DO ORÇAMENTO DA SEGURIDADE SOCIAL REALOCADO DA SAÚDE OU DA ASSISTÊNCIA SOCIAL PARA A PREVIDÊNCIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.4.2.01.02.00.00.0000',' PROVENIENTES DO ORÇAMENTO FISCAL','REGISTRA OS VALORES DAS RECEITAS DO ORÇAMENTO FISCAL DESTINADOS PARA COBRIR OS DÉFICITS FINANCEIROS DA PREVIDÊNCIA','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.4.2.02.00.00.00.0000','RECURSOS PARA FORMAÇÃO DE RESERVA','REGISTRA OS RECURSOS TRANSFERIDOS PELA UNIÃO AO RGPS PARA FORMAÇÃO DE RESERVA ESPONTÂNEA, PARA FUTUROS PAGAMENTOS DE BENEFÍCIOS DO PLANO FINANCEIRO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.1.4.2.99.00.00.00.0000','OUTROS APORTES PARA O RGPS','REGISTRA O SOMATÓRIO DO RECEBIMENTO DE EVENTUAIS APORTES DE RECURSOS PARA O RGPS PARA OUTRAS NECESSIDADES FINANCEIRAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.0.0.00.00.00.00.0000','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS DA UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.0.00.00.00.00.0000','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITA','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DA TRANSFERÊNCIAS DE OUTRAS ESFERAS DE GOVERNO DE RECEITAS TRIBUTÁRIAS, DE CONTRIBUIÇÕES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUIÇÃO OU EM LEIS ESPECÍFICAS, CUJA COMPETÊNCIA DE ARRECADAÇÃO É DO ÓRGÃO TRANSFERIDOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.1.00.00.00.00.0000','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITA - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DA TRANSFERÊNCIAS DE OUTRAS ESFERAS DE GOVERNO DE RECEITAS TRIBUTÁRIAS, DE CONTRIBUIÇÕES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUIÇÃO OU EM LEIS ESPECÍFICAS, CUJA COMPETÊNCIA DE ARRECADAÇÃO É DO ÓRGÃO TRANSFERIDOR. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS). POR EXEMPLO, EMPRESA INDEPENDENTE DE UM ENTE RECEBENDO TRANSFERÊNCIA DE OUTRO ENTE (A EMPRESA INDEPENDENTE NÃO PERTECENTE AO OFSS MAS PERTENCE AO CONCEITO DE GOVERNAMENTAL).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.00.00.00.00.0000','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITA - INTER OFSS - UNIÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DA TRANSFERÊNCIAS DE OUTRAS ESFERAS DE GOVERNO DE RECEITAS TRIBUTÁRIAS, DE CONTRIBUIÇÕES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUIÇÃO OU EM LEIS ESPECÍFICAS, CUJA COMPETÊNCIA DE ARRECADAÇÃO É DO ÓRGÃO TRANSFERIDOR. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.01.00.00.00.0000','COTA-PARTE DO FUNDO DE PARTICIPAÇÃO DOS MUNICÍPIOS - FPM','REGISTRA O VALOR TOTAL DAS VPAS RECEBIDAS ATRAVÉS DE COTA-PARTE DO FUNDO DE PARTICIPAÇÃO DOS MUNICÍPIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.02.00.00.00.0000','COTA-PARTE DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - ITR','REGISTRA O VALOR TOTAL DAS VPAS RECEBIDAS ATRAVÉS DE TRANSFERÊNCIAS DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.03.00.00.00.0000','COTA-PARTE DO IMPOSTO SOBRE OPERAÇÕES DE CRÉDITO, CAMBIO E SEGURO OU RELATIVAS A TITULOS OU VALORES MOBILIARIOS - COMERCIALIZAÇÃO DO OURO','REGISTRA O VALOR TOTAL DAS VPAS RECEBIDAS ATRAVÉS DE COTA-PARTE DO IMPOSTO SOBRE OPERAÇÕES CRÉDITO CÂMBIO E SEGUROS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.04.00.00.00.0000','TRANSFERÊNCIA DA COMPENSAÇÃO FINANCEIRA PELA EXPLORAÇÃO DE RECURSOS NATURAIS','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TRANSFERÊNCIA DA COMPENSAÇÃO FINANCEIRA PELA EXPLORAÇÃO DE RECURSOS NATURAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.05.00.00.00.0000','TRANSFERÊNCIA DE RECURSOS DO SISTEMA UNICO DE SAUDE - SUS - REPASSE FUNDO A FUNDO','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS DO FUNDO NACIONAL DE SAUDE RECEBIDOS PELOS FUNDOS DE SAUDE DOS ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS, REFERENTE AO SISTEMA ÚNICO DE SAÚDE – SUS, (PISO DE ATENÇÃO BÁSICA – FIXO E VARIÁVEL)','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.06.00.00.00.0000','TRANSFERÊNCIAS DE RECURSOS DO FUNDO NACIONAL DE ASSISTÊNCIA SOCIAL - FNAS','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS DA UNIÃO RECEBIDOS PELOS ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS, REFERENTE AO FUNDO NACIONAL DE ASSISTÊNCIA SOCIAL – FNAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.07.00.00.00.0000','TRANSFERÊNCIAS DE RECURSOS DO FUNDO NACIONAL DO DESENVOLVIMENTO DA EDUCAÇÃO - FNDE','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS DA UNIÃO RECEBIDOS PELOS ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS, RELATIVOS AO FUNDO NACIONAL DO DESENVOLVIMENTO DA EDUCAÇÃO – FNDE, COMPREENDENDO OS REPASSES REFERENTES AO SALÁRIO-EDUCAÇÃO E DEMAIS PRO','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.08.00.00.00.0000','TRANSFERÊNCIA FINANCEIRA DO ICMS - DESONERAÇÃO - L.C. N° 87/96','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS DA UNIÃO AOS ESTADOS, DISTRITO FEDERAL E AOS MUNICÍPIOS, ATENDIDOS OS LIMITES, CRITÉRIOS, PRAZOS E DEMAIS CONDIÇÕES FIXADOS NO ANEXO A LEI COMPLEMENTAR Nº 87 DE 13/09/96, COM BASE NO PRODUTO DE ARRECAD','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.09.00.00.00.0000','TRANSFERÊNCIA DA UNIAO PARA O ASPS','REGISTRA O VALOR DA TRANSFERÊNCIA RECEBIDA DA UNIÃO CONFORME O QUE DETERMINA O PARÁGRAFO 2° DO ART. 77 DO ADCT DA CF/88 COM A REDAÇÃO DADA PELA EC N° 29, PARA VINCULAÇÃO ESPECÍFICA NO ATENDIMENTO DAS AÇÕES E SERVIÇOS PÚBLICOS DE SAÚDE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.10.00.00.00.0000','TRANSFERÊNCIA DA UNIAO PARA O FUNDO MUNICIPAL DA CRIANCA E DO ADOLESCENTE','REGISTRA A VPA RECEBIDA DA UNIÃO REFERENTE A INCENTIVOS FISCAIS PREVISTOS NA LEGISLAÇÃO DO IMPOSTO DE RENDA, EM ATENDIMENTO AO ESTATUTO DA CRIANÇA E DO ADOLESCENTE – ECA, LEI N° 8069/90.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.11.00.00.00.0000','TRANSFERÊNCIA DA UNIAO - PASEP','REGISTRA A VPA RECEBIDA DA UNIÃO REFERENTE AO PASEP.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.12.00.00.00.0000','AUXÍLIO FINANCEIRO – ESFORÇO EXPORTADOR (MP N° 193/04)','REGISTRA O VALOR DA TRANSFERÊNCIA RECEBIDA DA UNIAO REFERENTE AO AUXÍLIO EXPORTADOR - CEX (REGISTRA O VALOR DA ARRECADAÇÃO DE RECEITA DE TRANSFERÊNCIA DA COMPENSAÇÃO FINANCEIRA.), INSTITUIDA PELA MEDIDA PROVISORIA 193.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.13.00.00.00.0000','FPM - APOIO FINANCEIRO (MP 462/2009)','REGISTRA O VALOR DA PRESTAÇÃO DE APOIO FINANCEIRO PELA UNIÃO AOS ENTES FEDERADOS QUE RECEBEM RECURSOS DO FUNDO DE PARTICIPAÇÃO DOS MUNICÍPIOS - FPM, NO EXERCÍCIO DE 2009, COM O OBJETIVO DE SUPERAR DIFICULDADES FINANCEIRAS EMERGENCIAIS. SALIENTA-SE QUE ESS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.14.00.00.00.0000','FPM - APOIO FINANCEIRO (MP 480/2010)','REGISTRA O VALOR DA PRESTAÇÃO DE APOIO FINANCEIRO PELA UNIÃO AOS ENTES FEDERADOS QUE RECEBEM RECURSOS DO FUNDO DE PARTICIPAÇÃO DOS MUNICÍPIOS - FPM, NO EXERCÍCIO DE 2010, COM O OBJETIVO DE SUPERAR DIFICULDADES FINANCEIRAS EMERGENCIAIS. SALIENTA-SE QUE ESS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.15.00.00.00.0000','TRANSFERÊNCIAS DE CONVÊNIOS DA UNIAO E DE SUAS ENTIDADES','REGISTRA O VALOR TOTAL DOS RECURSOS ORIUNDOS DE CONVÊNIOS FIRMADOS, COM OU SEM CONTRAPRESTAÇÕES DE SERVIÇOS, COM A UNIÃO OU COM SUAS ENTIDADES, PARA REALIZAÇÃO DE OBJETIVOS DE INTERESSE COMUM DOS PARTÍCIPES, E DESTINADOS A CUSTEAR DESPESAS CORRENTES. EX: PARA O SISTEMA UNICO DE SAUDE - SUS, CONVENIOS DA UNIAO DESTINADAS A PROGRAMAS DE EDUCACAO, CONVENIOS DA UNIAO DESTINADAS A PROGRAMAS DE ASSISTENCIA SOCIAL, CONVENIOS DA UNIAO DESTINADAS A PROGRAMAS DE COMBATE A FOME, DESTINADAS A PROGRAMAS DE SANEAMENTO BASICO ALÉM DE OUTRAS TRANSFERENCIAS DE CONVENIOS DA UNIAO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.96.00.00.00.0000','OUTRAS TRANSFERÊNCIAS DA UNIAO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERÊNCIAS DA UNIAO AOS ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.3.97.00.00.00.0000','(-) DEDUÇÕES DAS TRANSFERENCIAS INTER GOVERNAMENTAIS','REGISTRA AS DEDUÇÕES DAS VPA DE TRANSFERENCIA INTER GOVERNAMENTAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.4.00.00.00.00.0000','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITA - INTER OFSS - ESTADO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DA TRANSFERÊNCIAS DE OUTRAS ESFERAS DE GOVERNO DE RECEITAS TRIBUTÁRIAS, DE CONTRIBUIÇÕES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUIÇÃO OU EM LEIS ESPECÍFICAS, CUJA COMPETÊNCIA DE ARRECADAÇÃO É DO ÓRGÃO TRANSFERIDOR. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.4.01.00.00.00.0000','COTA-PARTE DO ICMS','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TRANSFERÊNCIA DA PARTICIPAÇÃO DE MUNICÍPIOS NA ARRECADAÇÃO DO IMPOSTO SOBRE A CIRCULAÇÃO DE MERCADORIAS E PRESTAÇÃO DE SERVIÇOS – ICMS, PELO ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.4.02.00.00.00.0000','COTA-PARTE DO IPVA','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TRANSFERÊNCIA DA PARTICIPAÇÃO DE MUNICÍPIOS NA ARRECADAÇÃO DO IMPOSTO SOBRE A PROPRIEDADE DE VEÍCULOS AUTOMOTORES – IPVA, PELO ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.4.03.00.00.00.0000','COTA-PARTE DO IPI SOBRE EXPORTAÇÃO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TRANSFERÊNCIA DA PARTICIPAÇÃO DE MUNICÍPIOS NA ARRECADAÇÃO DO IMPOSTO SOBRE A PRODUTOS INDUSTRIALIZADOS – IPI, PARA EXPORTAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.4.04.00.00.00.0000','COTA-PARTE DO ANTIGO ITCD (CF/67)','DEVE SER REGISTRADO O VALOR, NO CASO DO MUNICÍPIO RECEBER DO ESTADO ALGUMA TRANSFERÊNCIA REFERENTE A ARRECADAÇÃO INCIDENTE SOBRE A TRANSMISSÃO DA PROPRIEDADE DE BENS IMÓVEIS, INCLUSIVE DOS DIREITOS A ELES RELATIVOS, BENS MÓVEIS, DIREITOS, TÍTULOS E CRÉDITOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.4.05.00.00.00.0000','TRANSFERÊNCIA DA COTA-PARTE DA COMPENSAÇÃO FINANCEIRA (25%)','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TRANSFERÊNCIA DA COTA-PARTE DA COMPENSAÇÃO FINANCEIRA PROVENIENTE DA EXPLORAÇÃO DE RECURSOS NATURAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.4.06.00.00.00.0000','TRANSFERÊNCIA DE RECURSOS DO ESTADO PARA PROGRAMAS DE SAUDE - REPASSE FUNDO A FUNDO','REGISTRA O VALOR DE VPA DA TRANSFERÊNCIA DE RECURSOS DO SISTEMA ÚNICO DE SAÚDE ORIUNDO DO FUNDO ESTADUAL DE SAUDE PARA O FUNDO MUNICIPAL DE SAUDE (AÇÕES BÁSICAS DE VIGILÂNCIA SANITÁRIA, ATENÇÃO À SAÚDE DOS POVOS INDÍGENAS, PROGRAMA DE ASSISTÊNCIA FARMACÊUTICA BÁSICA, PROGRAMA DE COMBATE ÀS CARÊNCIAS NUTRICIONAIS, PROGRAMA DE SAÚDE DA FAMÍLIA, PROGRAMA DE AGENTES COMUNITÁRIOS, PROGRAMA NACIONAL DE VIGILÂNCIA EPIDEMIOLÓGICA E CONTROLE DE DOENÇAS E OUTROS). ESTA CONTA DEVERÁ SER DESDOBRADA PELO MUNICIPIO EM TANTAS CONTAS ANALITICAS QUANTAS FOREM AS FINANLIDADES DIVERSAS DOS RECURSOS RECEBIDOS, SENDO VINCULADO UM CÓDIGO DE RECURSO PARA CADA UMA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.4.07.00.00.00.0000','COTA-PARTE DA MULTA DE TRANSITO','REGISTRA O VALOR TOTAL DAS VPAS RECEBIDAS ATRAVÉS DE COTA-PARTE DA MULTA DE TRÂNSITO TRANSFERIDA PELO ESTADO E EXECUTADAS COMO RECURSO LIVRE ATÉ 30 DE JUNHO DE 2009.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.4.08.00.00.00.0000','TRANSFERÊNCIAS DE CONVÊNIOS DOS ESTADOS E DO DISTRITO FEDERAL E DE SUAS ENTIDADES','REGISTRA O VALOR TOTAL DOS RECURSOS ORIUNDOS DE CONVÊNIOS FIRMADOS, COM OU SEM CONTRAPRESTAÇÕES DE SERVIÇOS COM ESTADOS OU COM O DISTRITO FEDERAL E RESPECTIVAS ENTIDADES PÚBLICAS, PARA REALIZAÇÃO DE OBJETIVOS DE INTERESSE COMUM DOS PARTÍCIPES, DESTINADOS A CUSTEAR DESPESAS CORRENTES. EX: CONVENIOS DOS ESTADOS PARA O SISTEMA UNICO DE SAUDE - SUS, CONVENIOS DOS ESTADOS DESTINADAS A PROGRAMAS DE EDUCACAO, PROGRAMA DE ABRIGAGEM A POPULACAO ADULTA DE RUA, REVISAO DE BENEFICIOS DE PRESTACAO CONTINUADA - BPC, PROGRAMA DE ATENDIMENTO A CRIANCA, PROGRAMA DE APOIO A PESSOA PORTADORA DE DEFICIENCIA, PROGRAMA DE ATENCAO A PESSOA IDOSA, PROGRAMA ASEMA-APOIO SOCIO-EDUCATIVO EM MEIO ABERTO, PROGRAMA OASF - ORIENTACAO E APOIO SOCIO-FAMILIAR, PROGRAMA DE ABRIGO AS CRIANCAS E ADOLESCENTES, TRANSFERENCIAS RELATIVAS AO PROSAN ALÉM DE OUTRAS TRANSFERENCIAS DE CONVENIOS DOS ESTADOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.4.96.00.00.00.0000','OUTRAS TRANSFERÊNCIAS DOS ESTADOS E DF','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERÊNCIAS DOS ESTADOS E DISTRITO FEDERAL A UNIAO E AOS MUNICÍPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.1.4.97.00.00.00.0000','(-) DEDUÇÕES DAS TRANSFERENCIAS INTER GOVERNAMENTAIS','REGISTRA AS DEDUÇÕES DAS VPA DE TRANSFERENCIA INTER GOVERNAMENTAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.2.0.00.00.00.00.0000','TRANSFERÊNCIAS DE RECURSOS DO FUNDEB','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE RECURSOS RECEBIDDOS DO FUNDO DE MANUTENÇÃO E DESENVOLVIMENTO DA EDUCAÇÃO BÁSICA E DE VALORIZAÇÃO DOS PROFISSIONAIS DA EDUCAÇÃO - FUNDEB, INSTITUÍDO PELA E.C Nº 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.2.3.00.00.00.00.0000','TRANSFERÊNCIAS DE RECURSOS DO FUNDEB - INTER OFSS - UNIÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE RECURSOS RECEBIDDOS DO FUNDO DE MANUTENÇÃO E DESENVOLVIMENTO DA EDUCAÇÃO BÁSICA E DE VALORIZAÇÃO DOS PROFISSIONAIS DA EDUCAÇÃO - FUNDEB, INSTITUÍDO PELA E.C Nº 53/2006 E REGULAMENTADO PELA LEI 11.494/2007. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.2.4.00.00.00.00.0000','TRANSFERÊNCIAS DE RECURSOS DO FUNDEB - INTER OFSS - ESTADO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE RECURSOS RECEBIDDOS DO FUNDO DE MANUTENÇÃO E DESENVOLVIMENTO DA EDUCAÇÃO BÁSICA E DE VALORIZAÇÃO DOS PROFISSIONAIS DA EDUCAÇÃO - FUNDEB, INSTITUÍDO PELA E.C Nº 53/2006 E REGULAMENTADO PELA LEI 11.494/2007. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.0.00.00.00.00.0000','TRANSFERÊNCIAS VOLUNTÁRIAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS VOLUNTÁRIAS DA UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, BEM COMO AS DEMAIS ENTIDADES, DE BENS E/OU VALORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.1.00.00.00.00.0000','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS VOLUNTÁRIAS DA UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, BEM COMO AS DEMAIS ENTIDADES, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.3.00.00.00.00.0000','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - UNIÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS VOLUNTÁRIAS DA UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, BEM COMO AS DEMAIS ENTIDADES, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.3.01.00.00.00.0000','CONTRIBUIÇÕES','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE TRANSFERÊNCIAS CORRENTES E DE CAPITAL AOS ENTES DA FEDERAÇÃO E A ENTIDADES PRIVADAS SEM FINS LUCRATIVOS, EXCETO PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.3.02.00.00.00.0000','AUXÍLIOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE TRANSFERÊNCIAS DE CAPITAL AOS ENTES DA FEDERAÇÃO E A ENTIDADES PRIVADAS SEM FINS LUCRATIVOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.3.03.00.00.00.0000','SUBVENÇÕES SOCIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE TRANSFERÊNCIAS ÀS ENTIDADES PRIVADAS SEM FINS LUCRATIVOS PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.3.04.00.00.00.0000','SUBVENÇÕES ECONÔMICAS','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS CORRENTES ÀS ENTIDADES PÚBLICAS OU PRIVADAS COM FINS LUCRATIVOS PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.3.99.00.00.00.0000','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DAS DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.4.00.00.00.00.0000','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - ESTADO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS VOLUNTÁRIAS DA UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, BEM COMO AS DEMAIS ENTIDADES, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.4.01.00.00.00.0000','CONTRIBUIÇÕES','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE TRANSFERÊNCIAS CORRENTES E DE CAPITAL AOS ENTES DA FEDERAÇÃO E A ENTIDADES PRIVADAS SEM FINS LUCRATIVOS, EXCETO PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.4.02.00.00.00.0000','AUXÍLIOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE TRANSFERÊNCIAS DE CAPITAL AOS ENTES DA FEDERAÇÃO E A ENTIDADES PRIVADAS SEM FINS LUCRATIVOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.4.03.00.00.00.0000','SUBVENÇÕES SOCIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE TRANSFERÊNCIAS ÀS ENTIDADES PRIVADAS SEM FINS LUCRATIVOS PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.4.04.00.00.00.0000','SUBVENÇÕES ECONÔMICAS','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS CORRENTES ÀS ENTIDADES PÚBLICAS OU PRIVADAS COM FINS LUCRATIVOS PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.4.99.00.00.00.0000','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DAS DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.5.00.00.00.00.0000','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - MUNICÍPIO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS VOLUNTÁRIAS DA UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, BEM COMO AS DEMAIS ENTIDADES, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.5.01.00.00.00.0000','CONTRIBUIÇÕES','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE TRANSFERÊNCIAS CORRENTES E DE CAPITAL AOS ENTES DA FEDERAÇÃO E A ENTIDADES PRIVADAS SEM FINS LUCRATIVOS, EXCETO PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.5.02.00.00.00.0000','AUXÍLIOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE TRANSFERÊNCIAS DE CAPITAL AOS ENTES DA FEDERAÇÃO E A ENTIDADES PRIVADAS SEM FINS LUCRATIVOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.5.03.00.00.00.0000','SUBVENÇÕES SOCIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE TRANSFERÊNCIAS ÀS ENTIDADES PRIVADAS SEM FINS LUCRATIVOS PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.5.04.00.00.00.0000','SUBVENÇÕES ECONÔMICAS','REGISTRA O VALOR UTILIZADO PARA TRANSFERÊNCIAS CORRENTES ÀS ENTIDADES PÚBLICAS OU PRIVADAS COM FINS LUCRATIVOS PARA OS SERVIÇOS ESSENCIAIS DE ASSISTÊNCIA SOCIAL, MÉDICA E EDUCACIONAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.3.5.99.00.00.00.0000','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DAS DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.4.0.00.00.00.00.0000','OUTRAS TRANSFERÊNCIAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS DA UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, BEM COMO AS DEMAIS ENTIDADES, DE BENS E/OU VALORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.4.1.00.00.00.00.0000','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS DA UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, BEM COMO AS DEMAIS ENTIDADES, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.4.3.00.00.00.00.0000','OUTRAS TRANSFERÊNCIAS - INTER OFSS - UNIÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS DA UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, BEM COMO AS DEMAIS ENTIDADES, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.4.4.00.00.00.00.0000','OUTRAS TRANSFERÊNCIAS - INTER OFSS - ESTADO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS DA UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, BEM COMO AS DEMAIS ENTIDADES, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.2.4.5.00.00.00.00.0000','OUTRAS TRANSFERÊNCIAS - INTER OFSS - MUNICÍPIO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS DA UNIÃO, ESTADOS, DISTRITO FEDERAL, MUNICÍPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, BEM COMO AS DEMAIS ENTIDADES, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.3.0.0.00.00.00.00.0000','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERÊNCIAS FINANCEIRAS DAS INTITUICOES PRIVADAS SEM FINS LUCRATIVOS, INCLUSIVE DE BENS E VALORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.3.1.0.00.00.00.00.0000','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERÊNCIAS FINANCEIRAS DAS INTITUICOES PRIVADAS SEM FINS LUCRATIVOS, INCLUSIVE DE BENS E VALORES. EXEMPLO: ONGS,OSCIPS E OS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.3.1.1.00.00.00.00.0000','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERÊNCIAS FINANCEIRAS DAS INTITUICOES PRIVADAS SEM FINS LUCRATIVOS, INCLUSIVE DE BENS E VALORES. EXEMPLO: ONGS,OSCIPS E OS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.3.1.1.01.00.00.00.0000','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA CONVÊNIOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DAS TRANSFERÊNCIAS FINANCEIRAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA CONVÊNIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.3.1.1.02.00.00.00.0000','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA COMBATE A FOME','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DAS TRANSFERÊNCIAS FINANCEIRAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA COMBATE À FOME.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.3.1.1.99.00.00.00.0000','OUTRAS TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE OUTRAS TRANSFERÊNCIAS FINANCEIRAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.3.2.0.00.00.00.00.0000','TRANSFERÊNCIAS DAS INSTITUICOES PRIVADAS COM FINS LUCRATIVOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERÊNCIAS FINANCEIRAS DAS INTITUICOES PRIVADAS COM FINS LUCRATIVAS, INCLUSIVE DE BENS E VALORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.3.2.1.00.00.00.00.0000','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERÊNCIAS FINANCEIRAS DAS INTITUICOES PRIVADAS COM FINS LUCRATIVAS, INCLUSIVE DE BENS E VALORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.3.2.1.01.00.00.00.0000','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS PARA CONVÊNIOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DAS TRANSFERÊNCIAS FINANCEIRAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS PARA CONVÊNIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.3.2.1.02.00.00.00.0000','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS PARA COMBATE A FOME','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DAS TRANSFERÊNCIAS FINANCEIRAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS PARA COMBATE À FOME.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.3.2.1.99.00.00.00.0000','OUTRAS TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE OUTRAS TRANSFERÊNCIAS FINANCEIRAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.4.0.0.00.00.00.00.0000','TRANSFERÊNCIAS DAS INSTITUICOES MULTIGOVERNAMENTAIS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERÊNCIAS DAS INSTITUICOES MULTIGOVERNAMENTAIS, DO QUAL O ENTE TRANSFERIDOR NÃO PARTICIPE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.4.0.1.00.00.00.00.0000','TRANSFERÊNCIAS DAS INSTITUICOES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERÊNCIAS DAS INSTITUICOES MULTIGOVERNAMENTAIS, DO QUAL O ENTE TRANSFERIDOR NÃO PARTICIPE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.4.0.1.01.00.00.00.0000','TRANSFERÊNCIAS DE RECURSOS DO FUNDEB','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS RECEBIDOS DIRETAMENTE DO FUNDEB, PELOS ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS, INDEPENDENTE DO VALOR QUE FOI DEDUZIDO NO ENTE PARA FORMAÇÃO DO FUNDEB.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.4.0.1.02.00.00.00.0000','TRANSFERÊNCIAS DE RECURSOS DA COMPLEMENTAÇÃO DA UNIÃO AO FUNDEB','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS DE COMPLEMENTAÇÃO DA UNIÃO RECEBIDOS PELO FUNDEB, PELOS ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS, NÃO PODENDO SER UTILIZADO ESTE ITEM PARA O REGISTRO DO GANHO APURADO NAS OPERAÇÕES DO FUNDEB.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.4.0.1.03.00.00.00.0000','OUTRAS TRANSFERÊNCIAS MULTIGOVERNAMENTAIS','REGISTRA O VALOR DA VPA DE OUTRAS TRANSFERÊNCIAS MULTIGOVERNAMENTAIS , NÃO CLASSIFICADOS NOS ITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.5.0.0.00.00.00.00.0000','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERÊNCIAS DE CONSORCIOS PÚBLICOS, DO QUAL O ENTE TRANSFERIDOR PARTICIPE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.5.0.1.00.00.00.00.0000','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERÊNCIAS DE CONSORCIOS PÚBLICOS, DO QUAL O ENTE TRANSFERIDOR PARTICIPE. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.6.0.0.00.00.00.00.0000','TRANSFERÊNCIAS DO EXTERIOR','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS DE ORGANISMOS E FUNDOS INTERNACIONAIS, DE GOVERNOS ESTRANGEIROS E INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.6.0.1.00.00.00.00.0000','TRANSFERÊNCIAS DO EXTERIOR - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS DE ORGANISMOS E FUNDOS INTERNACIONAIS, DE GOVERNOS ESTRANGEIROS E INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS NO EXTERIOR. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.0.0.00.00.00.00.0000','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS DE RECURSOS FINANCEIROS , DECORRENTES DE DELEGAÇÕES OU DESCENTRALIZAÇÃO DOS ENTES (UNIÃO, ESTADOS, DISTRITO FEDERAL OU MUNICÍPIOS) OU CONSÓRCIOS PÚBLICOS PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.0.00.00.00.00.0000','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS DE RECURSOS FINANCEIROS , DECORRENTES DE DELEGAÇÕES OU DESCENTRALIZAÇÃO DOS ENTES (UNIÃO, ESTADOS, DISTRITO FEDERAL OU MUNICÍPIOS) PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.3.00.00.00.00.0000','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES – INTER OFSS - UNIÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS DE RECURSOS FINANCEIROS , DECORRENTES DE DELEGAÇÕES OU DESCENTRALIZAÇÃO DOS ENTES (UNIÃO, ESTADOS, DISTRITO FEDERAL OU MUNICÍPIOS) PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.3.01.00.00.00.0000','DIÁRIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE DIÁRIAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.3.02.00.00.00.0000','PASSAGENS E DESPESAS COM LOCOMOÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE PASSAGENS E DESPESAS COM LOCOMOÇÃO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.3.03.00.00.00.0000','MATERIAL DE CONSUMO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE MATERIAL DE CONSUMO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.3.04.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA FÍSICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.3.05.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA JURÍDICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.3.06.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE INDENIZAÇÕES E RESTITUIÇÕES DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.3.99.00.00.00.0000','DEMAIS VPAS COM DELEGAÇÕES','REGISTRA AS DEMAIS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.4.00.00.00.00.0000','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES – INTER OFSS - ESTADO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS DE RECURSOS FINANCEIROS , DECORRENTES DE DELEGAÇÕES OU DESCENTRALIZAÇÃO DOS ENTES (UNIÃO, ESTADOS, DISTRITO FEDERAL OU MUNICÍPIOS) PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.4.01.00.00.00.0000','DIÁRIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE DIÁRIAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.4.02.00.00.00.0000','PASSAGENS E DESPESAS COM LOCOMOÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE PASSAGENS E DESPESAS COM LOCOMOÇÃO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.4.03.00.00.00.0000','MATERIAL DE CONSUMO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE MATERIAL DE CONSUMO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.4.04.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA FÍSICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.4.05.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA JURÍDICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.4.06.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE INDENIZAÇÕES E RESTITUIÇÕES DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.4.99.00.00.00.0000','DEMAIS VPAS COM DELEGAÇÕES','REGISTRA AS DEMAIS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.5.00.00.00.00.0000','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES – INTER OFSS - MUNICÍPIO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS DE RECURSOS FINANCEIROS , DECORRENTES DE DELEGAÇÕES OU DESCENTRALIZAÇÃO DOS ENTES (UNIÃO, ESTADOS, DISTRITO FEDERAL OU MUNICÍPIOS) PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.5.01.00.00.00.0000','DIÁRIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE DIÁRIAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.5.02.00.00.00.0000','PASSAGENS E DESPESAS COM LOCOMOÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE PASSAGENS E DESPESAS COM LOCOMOÇÃO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.5.03.00.00.00.0000','MATERIAL DE CONSUMO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE MATERIAL DE CONSUMO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.5.04.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA FÍSICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.5.05.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA JURÍDICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.5.06.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE INDENIZAÇÕES E RESTITUIÇÕES DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.1.5.99.00.00.00.0000','DEMAIS VPAS COM DELEGAÇÕES','REGISTRA AS DEMAIS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.2.0.00.00.00.00.0000','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS DE RECURSOS FINANCEIROS , DECORRENTES DE DELEGAÇÕES OU DESCENTRALIZAÇÃO DE CONSÓRCIOS PÚBLICOS PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.2.1.00.00.00.00.0000','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERÊNCIAS DE RECURSOS FINANCEIROS , DECORRENTES DE DELEGAÇÕES OU DESCENTRALIZAÇÃO DOS ENTES (UNIÃO, ESTADOS, DISTRITO FEDERAL OU MUNICÍPIOS) OU CONSÓRCIOS PÚBLICOS PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.2.1.01.00.00.00.0000','DIÁRIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE DIÁRIAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.2.1.02.00.00.00.0000','PASSAGENS E DESPESAS COM LOCOMOÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE PASSAGENS E DESPESAS COM LOCOMOÇÃO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.2.1.03.00.00.00.0000','MATERIAL DE CONSUMO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE MATERIAL DE CONSUMO DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.2.1.04.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA FÍSICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.2.1.05.00.00.00.0000','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE OUTROS SERVIÇOS DE TERCEIRO, PESSOA JURÍDICA, DECORRENTES DE DELEGAÇÃO À UNIÃO OU DESCENTRALIZAÇÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.2.1.06.00.00.00.0000','INDENIZAÇÕES E RESTITUIÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DE INDENIZAÇÕES E RESTITUIÇÕES DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.7.2.1.99.00.00.00.0000','DEMAIS VPAS COM DELEGAÇÕES','REGISTRA AS DEMAIS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE DELEGAÇÃO OU DESCENTRALIZAÇÃO À UNIÃO PARA EXECUÇÃO DE AÇÕES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.8.0.0.00.00.00.00.0000','TRANSFERÊNCIAS DE PESSOAS FISICAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CONTRIBUIÇÕES E DOAÇÕES A GOVERNOS E ENTIDADES DA ADMINISTRAÇÃO DESCENTRALIZADA REALIZADAS POR PESSOAS FISICAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.5.8.0.1.00.00.00.00.0000','TRANSFERÊNCIAS DE PESSOAS FÍSICAS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CONTRIBUIÇÕES E DOAÇÕES A GOVERNOS E ENTIDADES DA ADMINISTRAÇÃO DESCENTRALIZADA REALIZADAS POR PESSOAS FISICAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.0.0.0.00.00.00.00.0000','VALORIZAÇÃO E GANHOS COM ATIVOS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA COM REAVALIAÇÃO E GANHOS DE ATIVOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.0.0.00.00.00.00.0000','REAVALIAÇÃO DE ATIVOS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS DO ATIVO, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.0.00.00.00.00.0000','REAVALIAÇÃO DE IMOBILIZADO','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS DO ATIVO IMOBILIZADO, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.00.00.00.00.0000','REAVALIAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS DO ATIVO IMOBILIZADO, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.01.00.00.00.0000','REAVALIAÇÃO DE BENS MÓVEIS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS MÓVEIS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.01.01.00.00.0000','REAVALIAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA MÁQUINAS, FERRAMENTAS, APARELHOS, EQUIPAMENTOS, ACESSÓRIOS ETC, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.01.02.00.00.0000','REAVALIAÇÃO DE BENS DE INFORMÁTICA','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E SISTEMAS APLICATIVOS, ENTRE OUTROS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.01.03.00.00.0000','REAVALIAÇÃO DE MÓVEIS E UTENSÍLIOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA MOBILIÁRIO EM GERAL E UTENSÍLIOS, ENTRE OUTROS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.01.04.00.00.0000','REAVALIAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA MATERIAIS BIBLIOGRÁFICOS, DISCOTECAS, FILMOTECAS, DE COMUNICAÇÃO, ENTRE OUTROS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.01.05.00.00.0000','REAVALIAÇÃO DE VEÍCULOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA TRANSPORTES AÉREOS, AQUÁTICOS E TERRESTRES, ENTRE OUTROS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.01.06.00.00.0000','REAVALIAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA PEÇAS E CONJUNTOS DE REPOSIÇÃO DESTINADOS A SUBSTITUIÇÃO EM MÁQUINAS E EQUIPAMENTOS, AERONAVES E EMBARCAÇÕES, BENS DE SEGURANÇA E SOCORRO, ENTRE OUTROS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.01.07.00.00.0000','REAVALIAÇÃO DE BENS MÓVEIS EM ANDAMENTO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA PEÇAS E CONJUNTOS DE REPOSIÇÃO DESTINADOS A SUBSTITUIÇÃO EM MÁQUINAS E EQUIPAMENTOS, AERONAVES E EMBARCAÇÕES, BENS DE SEGURANÇA E SOCORRO, ENTRE OUTROS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.01.08.00.00.0000','REAVALIAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS PERMANENTES A SEREM ESTOCADOS EM ALMOXARIFADO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.01.09.00.00.0000','REAVALIAÇÃO DE ARMAMENTOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ARMAS QUE CONSTITUEM OBJETOS DE DEFESA OU PREPARATIVOS DE GUERRA, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.01.10.00.00.0000','REAVALIAÇÃO DE SEMOVENTES','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ANIMAIS DESTINADOS A PRODUÇÃO, REPRODUÇÃO, ENGORDA E AOS SERVIÇOS UTILITÁRIOS EM GERAL, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.01.99.00.00.0000','REAVALIAÇÃO DE DEMAIS BENS MÓVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA DEMAIS BENS MÓVEIS NÃO CLASSIFICADOS EM GRUPOS ESPECÍFICOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.02.00.00.00.0000','REAVALIAÇÃO DE BENS IMÓVEIS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS IMÓVEIS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.02.01.00.00.0000','REAVALIAÇÃO DE BENS DE USO ESPECIAL','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OS BENS, TAIS COMO EDIFÍCIOS OU TERRENOS DESTINADOS A SERVIÇO OU ESTABELECIMENTO DA ADMINISTRAÇÃO ESTADUAL OU MUNICIPAL, INCLUSIVE OS DE SUAS AUTARQUIAS E FUNDAÇÕES PÚBLICAS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.02.02.00.00.0000','REAVALIAÇÃO DE BENS DOMINICAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OS BENS QUE CONSTITUEM O PATRIMÔNIO DAS PESSOAS JURÍDICAS DE DIREITO PÚBLICO, COMO OBJETO DE DIREITO PESSOAL, OU REAL, DE CADA UMA DESSAS ENTIDADES. COMPREENDE AINDA, NÃO DISPONDO A LEI EM CONTRÁRIO, OS BENS PERTENCENTES AS PESSOAS JURÍDICAS DE DIREITO PÚBLICO A QUE SE TENHA DADO ESTRUTURA DE DIREITO PRIVADO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.02.03.00.00.0000','REAVALIAÇÃO DE BENS DE USO COMUM DO POVO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OS BENS DE USO COMUM DO POVO CONSTRUÍDOS OU ADQUIRIDOS POR PESSOAS JURÍDICAS DE DIREITO PÚBLICO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.02.04.00.00.0000','REAVALIAÇÃO DE BENS IMÓVEIS EM ANDAMENTO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OS VALORES DE BENS IMÓVEIS EM ANDAMENTO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.02.05.00.00.0000','REAVALIAÇÃO DE INSTALAÇÕES','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA EQUIPAMENTOS, MATERIAIS E CUSTO DE IMPLANTAÇÃO DE INSTALAÇÕES QUE, NÃO OBSTANTE INTEGRADAS AOS EDIFÍCIOS, DEVEM SER SEGREGADAS DAS OBRAS CIVIS, COMO, POR EXEMPLO, AS INSTALAÇÕES ELÉTRICAS, HIDRÁULICAS, SANITÁRIAS, DE VAPOR, DE AR COMPRIMIDO, FRIGORÍFICAS, CONTRA INCÊNDIO, DE COMUNICAÇÕES, DE CLIMATIZAÇÃO, PARA COMBUSTÍVEIS, GASES, DE ANTIPOLUIÇÃO, PARA COZINHA, DENTRE OUTROS. E TAMBÉM APLICÁVEL A CONSTRUÇÃO DE TRECHOS FERROVIÁRIOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.02.06.00.00.0000','REAVALIAÇÃO DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA CONSTRUÇÕES EM TERRENOS ARRENDADOS DE TERCEIROS E INSTALAÇÕES E OUTRAS BENFEITORIAS EM PRÉDIOS ALUGADOS. SÃO CONSIDERADOS SOMENTE OS GASTOS COM CONSTRUÇÃO E INSTALAÇÃO QUE SE INCORPORAM AO IMÓVEL E REVERTEM AO PROPRIETÁRIO DO IMÓVEL AO FINAL DA LOCAÇÃO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.1.1.02.99.00.00.0000','REAVALIAÇÃO DE DEMAIS BENS IMÓVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA À ADOÇÃO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OS DEMAIS BENS IMÓVEIS NÃO CLASSIFICADOS ANTERIORMENTE NESSE PLANO DE CONTAS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTÁBIL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.2.0.00.00.00.00.0000','REAVALIAÇÃO DE INTANGIVEIS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ATIVOS INTANGIVEIS, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.2.1.00.00.00.00.0000','REAVALIAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ATIVOS INTANGIVEIS, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.9.0.00.00.00.00.0000','REAVALIAÇÃO DE OUTROS ATIVOS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OUTROS ATIVOS, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.1.9.1.00.00.00.00.0000','REAVALIAÇÃO DE OUTROS ATIVOS - CONSOLIDAÇÃO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OUTROS ATIVOS, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.0.0.00.00.00.00.0000','GANHOS COM ALIENAÇÃO','COMPREENDE O GANHO COM ALIENAÇÃO DE ATIVOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO É MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.1.0.00.00.00.00.0000','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS','COMPREENDE O GANHO COM ALIENAÇÃO DE INVESTIMENTOS, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO É MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.1.1.00.00.00.00.0000','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','REGISTRA O GANHO COM ALIENAÇÃO DE INVESTIMENTOS, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO É MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.1.1.01.00.00.00.0000','GANHOS COM ALIENAÇÃO DE PARTICIPAÇÕES PERMANENTES','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DE GANHOS COM ALIENAÇÃO DE PARTICIPAÇÕES PERMANENTES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.1.1.02.00.00.00.0000','GANHOS COM ALIENAÇÃO DE PROPRIEDADES PARA INVESTIMENTO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DE GANHOS COM ALIENAÇÃO DE PROPRIEDADES PARA INVESTIMENTO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.1.1.03.00.00.00.0000','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DE GANHOS COM ALIENAÇÃO DE INVESTIMENTOS DO RPPS DE LONGO PRAZO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.1.1.99.00.00.00.0000','GANHOS COM ALIENAÇÃO DE DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DE GANHOS COM ALIENAÇÃO DE DEMAIS INVESTIMENTOS PERMANENTES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.0.00.00.00.00.0000','GANHOS COM ALIENAÇÃO DE IMOBILIZADO','COMPREENDE O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO É MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.00.00.00.00.0000','GANHOS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','REGISTRA O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO É MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.01.00.00.00.0000','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS MÓVEIS','COMPREENDE O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS MÓVEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.01.01.00.00.0000','GANHO LÍQUIDO COM A ALIENAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','COMPREENDE O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - GANHO LÍQUIDO COM A ALIENAÇÃO DE MÁQUINAS, EQUIPAMENTOS E FERRAMENTAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.01.02.00.00.0000','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS DE INFORMÁTICA','COMPREENDE O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS DE INFORMÁTICA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.01.03.00.00.0000','GANHO LÍQUIDO COM A ALIENAÇÃO DE MÓVEIS E UTENSÍLIOS','COMPREENDE O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - GANHO LÍQUIDO COM A ALIENAÇÃO DE MÓVEIS E UTENSÍLIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.01.04.00.00.0000','GANHO LÍQUIDO COM A ALIENAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','COMPREENDE O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - GANHO LÍQUIDO COM A ALIENAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.01.05.00.00.0000','GANHO LÍQUIDO COM A ALIENAÇÃO DE VEÍCULOS','COMPREENDE O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - GANHO LÍQUIDO COM A ALIENAÇÃO DE VEÍCULOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.01.07.00.00.0000','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS MÓVEIS EM ANDAMENTO','COMPREENDE O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS MÓVEIS EM ANDAMENTO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.01.08.00.00.0000','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','COMPREENDE O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.01.09.00.00.0000','GANHO LÍQUIDO COM A ALIENAÇÃO DE ARMAMENTOS','COMPREENDE O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - GANHO LÍQUIDO COM A ALIENAÇÃO DE ARMAMENTOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.01.10.00.00.0000','GANHO LÍQUIDO COM A ALIENAÇÃO DE SEMOVENTES','COMPREENDE O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - GANHO LÍQUIDO COM A ALIENAÇÃO DE SEMOVENTES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.01.99.00.00.0000','GANHO LÍQUIDO COM A ALIENAÇÃO DE DEMAIS BENS MÓVEIS','COMPREENDE O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - GANHO LÍQUIDO COM A ALIENAÇÃO DE DEMAIS BENS MÓVEIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.02.00.00.00.0000','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS IMÓVEIS','COMPREENDE O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS IMÓVEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.02.01.00.00.0000','PRODUTO DE ALIENAÇÕES','REGISTRA O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - PRODUTOS DE ALIENAÇÕES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.02.02.00.00.0000','ALIENAÇÃO DE IMÓVEIS RURAIS','REGISTRA O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - ALIENAÇÃO DE IMÓVEIS RURAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.02.03.00.00.0000','ALIENAÇÃO DE IMÓVEIS URBANOS','REGISTRA O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - ALIENAÇÃO DE IMÓVEIS URBANOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.02.99.00.00.0000','ALIENAÇÃO DE OUTROS BENS IMÓVEIS','REGISTRA O GANHO COM ALIENAÇÃO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTÁBIL, DE MANEIRA QUE A DIFERENÇA COMPREENDE O GANHO - ALIENAÇÃO DE OUTROS BENS IMÓVEIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.97.00.00.00.0000','(-) DEDUÇÃO DOS GANHOS COM ALIENAÇÃO DE IMOBILIZADO','COMPREENDE AS DEDUÇÕES DOS GANHOS COM ALIENAÇÃO DE ATIVO IMOBILIZADO - DEDUÇÃO DOS GANHOS COM ALIENAÇÃO DE IMOBILIZADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.97.01.00.00.0000','(-) DEDUÇÃO ALIENAÇÃO DE BENS MÓVEIS','REGISTRA AS DEDUÇÕES DOS GANHOS COM ALIENAÇÃO DE ATIVO IMOBILIZADO - DEDUÇÃO ALIENAÇÃO DE BENS MÓVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.2.1.97.02.00.00.0000','(-) DEDUÇÃO ALIENAÇÃO DE BENS IMÓVEIS','REGISTRA AS DEDUÇÕES DOS GANHOS COM ALIENAÇÃO DE ATIVO IMOBILIZADO - DEDUÇÃO ALIENAÇÃO DE BENS IMÓVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.3.0.00.00.00.00.0000','GANHOS COM ALIENAÇÃO DE INTANGIVEIS','COMPREENDE O GANHO COM ALIENAÇÃO DE ATIVOS INTANGIVEIS, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO É MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.3.1.00.00.00.00.0000','GANHOS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','REGISTRA O GANHO COM ALIENAÇÃO DE ATIVOS INTANGIVEIS, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO É MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.3.1.01.00.00.00.0000','GANHOS COM ALIENAÇÃO DE SOFTWARES','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DE GANHOS COM ALIENAÇÃO DE SOFTWARES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.3.1.02.00.00.00.0000','GANHOS COM ALIENAÇÃO DE MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DE GANHOS COM ALIENAÇÃO DE MARCAS, DIREITOS E PATENTES INDUSTRIAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.2.3.1.03.00.00.00.0000','GANHOS COM ALIENAÇÃO DE DIREITO DE USO DE IMÓVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DE GANHOS COM ALIENAÇÃO DE DIREITO DE USO DE IMÓVEIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.3.0.0.00.00.00.00.0000','GANHOS COM INCORPORAÇÃO DE ATIVOS','COMPREENDE A CONTRAPARTIDA DA INCORPORAÇÃO DE NOVOS ATIVOS DESCOBERTOS, A CONTRAPARTIDA DA INCORPORAÇÃO DE ATIVOS SEMOVENTES NASCIDOS, POR EXEMPLO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.3.1.0.00.00.00.00.0000','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS','COMPREENDE OS GANHOS COM A INCORPORAÇÃO DE NOVOS ATIVOS DESCOBERTOS, COMO POR EXEMPLO, DESCOBERTA DE JAZIDAS DE RECURSOS NATURAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.3.1.1.00.00.00.00.0000','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS - CONSOLIDAÇÃO','REGISTRA OS GANHOS COM A INCORPORAÇÃO DE NOVOS ATIVOS DESCOBERTOS, COMO POR EXEMPLO, DESCOBERTA DE JAZIDAS DE RECURSOS NATURAIS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.3.2.0.00.00.00.00.0000','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS','COMPREENDE OS GANHOS COM A INCORPORAÇÃO DE SEMOVENTES NASCIDOS, COMO POR EXEMPLO, NASCIMENTO DE BOVINOS E AVES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.3.2.1.00.00.00.00.0000','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS - CONSOLIDAÇÃO','REGISTRA OS GANHOS COM A INCORPORAÇÃO DE SEMOVENTES NASCIDOS, COMO POR EXEMPLO, NASCIMENTO DE BOVINOS E AVES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.3.3.0.00.00.00.00.0000','GANHOS COM INCORPORAÇÃO DE VALORES APREENDIDOS','COMPREENDE OS GANHOS COM A INCORPORAÇÃO DE VALORES APREENDIDOS, COMO POR EXEMPLO, OS VALORES APREENDIDOS ASSOCIADOS AO TRAFÍCO ILÍCITO DE ENTORPENCENTES E DROGAS AFINS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.3.3.1.00.00.00.00.0000','GANHOS COM INCORPORAÇÃO DE ATIVOS APREENDIDOS - CONSOLIDAÇÃO','REGISTRA OS GANHOS COM A INCORPORAÇÃO DE VALORES APREENDIDOS, COMO POR EXEMPLO, OS VALORES APREENDIDOS ASSOCIADOS AO TRAFICO ILICITO DE ENTORPENCENTES E DROGAS AFINS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.3.9.0.00.00.00.00.0000','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS','COMPREENDE A CONTRAPARTIDA DA INCORPORAÇÃO DE OUTROS NOVOS ATIVOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.3.9.1.00.00.00.00.0000','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS - CONSOLIDAÇÃO','COMPREENDE A CONTRAPARTIDA DA INCORPORAÇÃO DE OUTROS NOVOS ATIVOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.4.0.0.00.00.00.00.0000','GANHOS COM DESINCORPORAÇÃO DE PASSIVOS','COMPREENDE A CONTRAPARTIDA DA DESINCORPORAÇÃO DE PASSIVOS, INCLUSIVE AS BAIXAS DE PASSIVO DECORRENTES DO CANCELAMENTO DE RESTOS A PAGAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.6.4.0.1.00.00.00.00.0000','GANHOS COM DESINCORPORAÇÃO DE PASSIVOS - CONSOLIDAÇÃO','COMPREENDE A CONTRAPARTIDA DA DESINCORPORAÇÃO DE PASSIVOS, INCLUSIVE AS BAIXAS DE PASSIVO DECORRENTES DO CANCELAMENTO DE RESTOS A PAGAR. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.0.0.0.00.00.00.00.0000','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','COMPREENDE O SOMATÓRIO DAS DEMAIS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS NÃO INCLUIDAS NOS GRUPOS ANTERIORES,TAIS COMO: RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, DIVIDENDOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.1.0.0.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR','COMPREENDE OS RECURSOS REFERENTES A VARIAÇÃO PATRIMONIAL AUMENTATIVA RECEBIDAS E NÃO CLASSIFICADAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.1.0.1.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR - CONSOLIDAÇÃO','COMPREENDE OS RECURSOS REFERENTES A VARIAÇÃO PATRIMONIAL AUMENTATIVA RECEBIDAS E NÃO CLASSIFICADAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.1.0.1.01.00.00.00.0000','VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','REGISTRA OS VALORES REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVAS DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.1.0.1.99.00.00.00.0000','(-) DEDUCOES DA VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','REGISTRAS OS VALORES REFERENTES AS DEDUCOES DAS VARIACAO PATRIMONIAL AUMENTATIVA DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.2.0.0.00.00.00.00.0000','RESULTADO POSITIVO DE PARTICIPAÇÕES','COMPREENDE O RESULTADO POSITIVO DAS PARTICIPAÇÕES DE CARATER PERMANENTE NO CAPITAL SOCIAL DE SOCIEDADES INVESTIDAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.2.1.0.00.00.00.00.0000','RESULTADO POSITIVO DE EQUIVALENCIA PATRIMONIAL','COMPREENDE A APROPRIAÇÃO DO RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE LUCROS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.2.1.1.00.00.00.00.0000','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','REGISTRA A APROPRIAÇÃO DO RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE LUCROS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.2.1.2.00.00.00.00.0000','RESULTADO POSITIVO DE EQUIVALENCIA PATRIMONIAL - INTRA OFSS','REGISTRA A APROPRIAÇÃO DO RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE LUCROS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.2.1.3.00.00.00.00.0000','RESULTADO POSITIVO DE EQUIVALENCIA PATRIMONIAL - INTER OFSS - UNIÃO','REGISTRA A APROPRIAÇÃO DO RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE LUCROS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.2.1.4.00.00.00.00.0000','RESULTADO POSITIVO DE EQUIVALENCIA PATRIMONIAL - INTER OFSS - ESTADO','REGISTRA A APROPRIAÇÃO DO RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE LUCROS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.2.1.5.00.00.00.00.0000','RESULTADO POSITIVO DE EQUIVALENCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','REGISTRA A APROPRIAÇÃO DO RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE LUCROS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.2.2.0.00.00.00.00.0000','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS','COMPREENDE AS VARIAÇÕES AUMENTATIVAS ORIUNDAS DE LUCROS APURADOS EM OUTROS INVESTIMENTOS NÃO AVALIADOS PELO METODO DA EQUIVALENCIA PATRIMONIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.2.2.1.00.00.00.00.0000','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES AUMENTATIVAS ORIUNDAS DE LUCROS APURADOS EM OUTROS INVESTIMENTOS NÃO AVALIADOS PELO METODO DA EQUIVALENCIA PATRIMONIAL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.0.0.00.00.00.00.0000','REVERSÃO DE PROVISÕES E AJUSTES DE PERDAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVINIENTES DE REVERSÕES E AJUSTES DE PERDAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.1.0.00.00.00.00.0000','REVERSÃO DE PROVISÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVINIENTES DE REVERSÕES DE PROVISÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.1.1.00.00.00.00.0000','REVERSÃO DE PROVISÕES – CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVINIENTES DE REVERSÕES DE PROVISÕES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.1.1.01.00.00.00.0000','REVERSÃO DE PROVISÃO PARA RISCOS TRABALHISTAS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE REVERSÃO DE PROVISÃO PARA RISCOS TRABALHISTAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.1.1.02.00.00.00.0000','REVERSÃO DE PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS A LONGO PRAZO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE REVERSÃO DE PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS A LONGO PRAZO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.1.1.03.00.00.00.0000','REVERSÃO DE PROVISÕES PARA RISCOS FISCAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE REVERSÃO DE PROVISÕES PARA RISCOS FISCAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.1.1.04.00.00.00.0000','REVERSÃO DE PROVISÕES PARA RISCOS CÍVEIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE REVERSÃO DE PROVISÃO RISCOS CÍVEIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.1.1.05.00.00.00.0000','REVERSÃO DE PROVISÕES REPARTIÇÃO DE CRÉDITO','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE REVERSÃO DE PROVISÕES POR REPARTIÇÃO DE CRÉDITO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.1.1.06.00.00.00.0000','REVERSÃO DE PROVISÕES DECORRENTES DE CONTRATOS DE PPP','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE REVERSÃO DE PROVISÕES DECORRENTES DE CONTRATOS DE PPP.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.1.1.99.00.00.00.0000','REVERSÃO DE OUTRAS PROVISÕES','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE REVERSÃO DE OUTRAS PROVISÕES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.1.3.00.00.00.00.0000','REVERSÃO DE PROVISÕES – INTER OFSS - UNIÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVINIENTES DE REVERSÕES DE PROVISÕES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.1.4.00.00.00.00.0000','REVERSÃO DE PROVISÕES – INTER OFSS - ESTADOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVINIENTES DE REVERSÕES DE PROVISÕES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.1.5.00.00.00.00.0000','REVERSÃO DE PROVISÕES – INTER OFSS - MUNICÍPIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVINIENTES DE REVERSÕES DE PROVISÕES. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.2.0.00.00.00.00.0000','REVERSÃO DE AJUSTES DE PERDAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVINIENTES DE REVERSÕES E AJUSTES DE PERDAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.2.1.00.00.00.00.0000','REVERSÃO DE AJUSTES DE PERDAS – CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVINIENTES DE REVERSÕES E AJUSTES DE PERDAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.2.1.01.00.00.00.0000','REVERSÃO DE AJUSTES DE PERDAS DE CRÉDITOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE REVERSÃO DE AJUSTES DE PERDAS DE CRÉDITOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.2.1.02.00.00.00.0000','REVERSÃO DE AJUSTES DE PERDAS DE ESTOQUES','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE REVERSÃO DE AJUSTES DE PERDAS DE ESTOQUES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.2.1.03.00.00.00.0000','REVERSÃO DE AJUSTES DE INVESTIMENTOS E APLICAÇÕES','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE REVERSÃO DE AJUSTES DE INVESTIMENTOS E APLICAÇÕES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.2.2.00.00.00.00.0000','REVERSÃO DE AJUSTES DE PERDAS - INTRA OFSS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVINIENTES DE REVERSÕES E AJUSTES DE PERDAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.2.3.00.00.00.00.0000','REVERSÃO DE AJUSTES DE PERDAS –INTER OFSS – UNIÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVINIENTES DE REVERSÕES E AJUSTES DE PERDAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.2.4.00.00.00.00.0000','REVERSÃO DE AJUSTES DE PERDAS –INTER OFSS – ESTADO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVINIENTES DE REVERSÕES E AJUSTES DE PERDAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.7.2.5.00.00.00.00.0000','REVERSÃO DE AJUSTES DE PERDAS –INTER OFSS - MUNICÍPIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVINIENTES DE REVERSÕES E AJUSTES DE PERDAS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.0.0.00.00.00.00.0000','DIVERSAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','COMPREENDE OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS NÃO CLASSIFICADAS EM ITENS ESPECÍFICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.1.0.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.1.2.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.1.3.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.1.3.01.00.00.00.0000','COMPENSAÇÕES FINANCEIRAS ENTRE O REGIME GERAL E OS REGIMES PRÓPRIOS DE PREVIDÊNCIA DOS SERVIDORES – PRINCIPAL','REGISTRA A VPA DECORRENTE DE COMPENSAÇÕES FINANCEIRAS ENTRE O REGIME GERAL E OS REGIMES PRÓPRIOS DE PREVIDÊNCIA DOS SERVIDORES – PRINCIPAL','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.1.3.02.00.00.00.0000','COMPENSAÇÕES FINANCEIRAS ENTRE O REGIME GERAL E OS REGIMES PRÓPRIOS DE PREVIDÊNCIA DOS SERVIDORES – PARCELAMENTOS','REGISTRA A VPA DECORRENTE DE COMPENSAÇÕES FINANCEIRAS ENTRE O REGIME GERAL E OS REGIMES PRÓPRIOS DE PREVIDÊNCIA DOS SERVIDORES – PARCELAMENTOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.1.4.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.1.5.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.2.0.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIÃO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.2.3.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - UNIÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIÃO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.2.4.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - ESTADO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIÃO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.2.5.00.00.00.00.0000','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - MUNICÍPIO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIÃO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICÍPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NÃO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.3.0.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE BONIFICAÇÕES RECEBIDAS NAS AQUISICOES DE MERCADORIAS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.3.1.00.00.00.00.0000','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE BONIFICAÇÕES RECEBIDAS NAS AQUISICOES DE MERCADORIAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.4.0.00.00.00.00.0000','AMORTIZAÇÃO DE DESAGIO EM INVESTIMENTOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE AMORTIZAÇÃO DE DESAGIO EM INVESTIMENTOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.4.1.00.00.00.00.0000','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE AMORTIZAÇÃO DE DESAGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.4.2.00.00.00.00.0000','AMORTIZAÇÃO DE DESAGIO EM INVESTIMENTOS - INTRA OFSS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE AMORTIZAÇÃO DE DESAGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.4.3.00.00.00.00.0000','AMORTIZAÇÃO DE DESAGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE AMORTIZAÇÃO DE DESAGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E A UNIÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.4.4.00.00.00.00.0000','AMORTIZAÇÃO DE DESAGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE AMORTIZAÇÃO DE DESAGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.4.5.00.00.00.00.0000','AMORTIZAÇÃO DE DESAGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE AMORTIZAÇÃO DE DESAGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E O MUNICÍPIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.5.0.00.00.00.00.0000','MULTAS ADMINISTRATIVAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS, E COM RENDIMENTOS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO. REPRESENTANDO O RESULTADO DAS APLICAÇÕES IMPOSTAS AO CONTRIBUINTE FALTOSO, COMO SANCAO LEGAL NO CAMPO TRIBUTÁRIO (IMPOSTOS, TAXAS E CONTRIBUICAO DE MELHORIA) E NÃO-TRIBUTÁRIO (CONTRIBUIÇÕES SOCIAIS E ECONOMICAS, PATRIMONIAIS, INDUSTRIAIS, SERVIÇOS E DIVERSAS) E DE NATUREZA ADMINISTRATIVA, POR INFRAÇÕES A REGULAMENTOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.5.1.00.00.00.00.0000','MULTAS ADMINISTRATIVAS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS, E COM RENDIMENTOS DESTINADOS A INDENIZAÇÃO PELO ATRASO NO CUMPRIMENTO DA OBRIGAÇÃO. REPRESENTANDO O RESULTADO DAS APLICAÇÕES IMPOSTAS AO CONTRIBUINTE FALTOSO, COMO SANCAO LEGAL NO CAMPO TRIBUTÁRIO (IMPOSTOS, TAXAS E CONTRIBUICAO DE MELHORIA) E NÃO-TRIBUTÁRIO (CONTRIBUIÇÕES SOCIAIS E ECONOMICAS, PATRIMONIAIS, INDUSTRIAIS, SERVIÇOS E DIVERSAS) E DE NATUREZA ADMINISTRATIVA, POR INFRAÇÕES A REGULAMENTOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.5.1.03.00.00.00.0000','MULTA DE POLUICAO DE AGUAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DESTINADAS A PUNIR O INFRATOR PELA POLUICAO DE AGUAS. MULTAS DEV. LANCAMENTO OLEOS,PRODUTOS OLEOSOS E SUBSTANCIAS QUIMICAS TOXICAS NAS AGUAS PÚBLICAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.5.1.07.00.00.00.0000','MULTAS PREVISTAS NA LEGISL. SANITARIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE O DISPOSTO NA LEGISLAÇÃO SANITARIA. DEVIDASQUANDO DA INFRAÇÃO, FRAUDE, FALSIFICAÇÃO E ADULTERAÇÃO DAS MATERIAS-PRIMAS E PRODUTOS FARMACEUTICOS, BEM COMO QUAISQUER PRODUTOS OU INSUMOS QUE INTERESSEM A SAUDE PÚBLICA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.5.1.08.00.00.00.0000','MULTAS PREVISTAS LEGIS.DE REGISTRO COMERCIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE AS LEIS OU REGULAMENTOS QUE DISCIPLINAM AS ATIVIDADES DE AGENTES AUXILIARES DO COMERCIO, DE ARMAZENS GERAIS E OUTROS SUJEITOS AO CONTROLE E FISCALIZAÇÃO DOS ORGÃOS DE REGISTRO DO COMERCIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.5.1.11.00.00.00.0000','MULTAS PREVISTAS NA LEGISLAÇÃO DE TRANSITO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLAÇÃO REFERENTE A TRANSITO. CONSTITUEM VPA VINCULADA AO MINISTERIO DA JUSTICA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.5.1.14.00.00.00.0000','MULTAS E JUROS PREVISTOS EM CONTRATOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS PREVISTOS EM CONTRATOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.5.1.15.00.00.00.0000','MULTAS DECORREENTES DA OPERAÇÃO DO TRANSPORTE RODOVIARIO DE PASSAGEIROS E CARGAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRAÇÕES DAS LEGISLAÇÕES DE OPERAÇÃO DO TRANSPORTE RODOVIARIO DE PASSAGEIROS E CARGAS, BEM COMO DOS CONTRATOS DE CONCESSAO DE SERVIÇOS DE TRANSPORTE RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS E CARGAS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.5.1.21.00.00.00.0000','MULTAS POR DANOS AO MEIO AMBIENTE','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS POR DANOS AO MEIO AMBIENTE. AMPARO LEGAL: LEI 9 605 DE 12FEV1998','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.5.1.25.00.00.00.0000','MULTAS APLICADAS PELO TCE-AL','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE APLICAÇÃO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS MULTAS APLICADAS PELO TRIBUNAL DE CONTAS DO ESTADO DE ALAGOAS, PELO NÃO CUMPRIMENTO A DECISAO DO MESMO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.5.1.27.00.00.00.0000','MULTAS POR AUTOS DE INFRAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PUNITIVAS APLICADAS PELO NÃO CUMPRIMENTO NOS CASOS PREVISTOS NOS REGULAMENTOS OU NOS CONTRATOS, OU PELA REINCIDÊNCIA EM FATOS QUE TENHAM GERADO ADVERTENCIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.5.1.28.00.00.00.0000','MULTA POR INFRAÇÃO À LEGISLAÇÃO DE LICITAÇÃO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE MULTAS APLICADAS POR INFRAÇÕES PRATICADAS EM INOBSERVÂNCIA À LEGISLAÇÃO APLICADA AOS PROCEDIMENTOS DE LICITAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.5.1.99.00.00.00.0000','OUTRAS MULTAS ADMINISTRATIVAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS MULTAS ADMINISTRATIVAS NÃO ENQUADRADAS NAS CONTAS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.6.0.00.00.00.00.0000','INDENIZAÇÕES','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DEINDENIZAÇÕES DIVERSAS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.6.1.00.00.00.00.0000','INDENIZAÇÕES - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DEINDENIZAÇÕES DIVERSAS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.6.1.01.00.00.00.0000','INDENIZAÇÕES POR DANOS CAUSADOS AO PATRIMÔNIO PÚBLICO','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZAÇÃO POR DANOS CAUSADOS AO PATRIMONIO PÚBLICO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.6.1.02.00.00.00.0000','INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE INDENIZAÇÃO POR PERDA/QUEBRA DE MERCADORIAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.6.1.03.00.00.00.0000','INDENIZ. POSSE OU OCUPACAO ILIC. BENS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE INDENIZAÇÃO POR POSSE OU OCUPAÇÃO ILÍCITA DE BENS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.6.1.04.00.00.00.0000','REPOSIÇÃO/INDENIZAÇÃO DE SERVIDORES/AGENTES PÚBLICOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DE REPOSIÇÃO OU INDENIZAÇÃO POR PARTE DE SERVIDORES OU AGENTES PÚBLICOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.6.1.99.00.00.00.0000','OUTRAS INDENIZAÇÕES','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZAÇÕES QUE NÃO SE ENQUADRAM NOS ITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.7.0.00.00.00.00.0000','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS','COMPREENDE O SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS GERADAS PELA ALIENAÇÃO DE MERCADORIAS, OBJETO DA PENA DE PERDIMENTO. O PRODUTO DA ARRECADAÇÃO TEM A SEGUINTE DESTINAÇÃO: 60% AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZAÇÃO - FUNDAF E 40% AO FUNDO NACIONAL DE ASSISTÊNCIA SOCIAL - MINISTERIO DA PREVIDENCIA E ASSISTÊNCIA SOCIAL. AO FUNDO NACIONAL ANTIDROGA FUNAD, PARA APLICAÇÃO CONFORME LEGISLAÇÃO EM VIGOR, QUANDO DA APREENSAO DE BENS, DIREITOS E VALORES OBJETO DO CRIME DE TRAFICO ILICITO DE SUBSTANCIAS INTORPECENTES OU DROGAS AFINS. (LEI 6368 DE 21/10/76) LEI 7460 DE 19/12/86, LEI 9804 DE 30/06/99.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.7.1.00.00.00.00.0000','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS - CONSOLIDAÇÃO','COMPREENDE O SOMATÓRIO DAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS GERADAS PELA ALIENAÇÃO DE MERCADORIAS, OBJETO DA PENA DE PERDIMENTO. O PRODUTO DA ARRECADAÇÃO TEM A SEGUINTE DESTINAÇÃO: 60% AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZAÇÃO - FUNDAF E 40% AO FUNDO NACIONAL DE ASSISTÊNCIA SOCIAL - MINISTERIO DA PREVIDENCIA E ASSISTÊNCIA SOCIAL. AO FUNDO NACIONAL ANTIDROGA FUNAD, PARA APLICAÇÃO CONFORME LEGISLAÇÃO EM VIGOR, QUANDO DA APREENSAO DE BENS, DIREITOS E VALORES OBJETO DO CRIME DE TRAFICO ILICITO DE SUBSTANCIAS INTORPECENTES OU DROGAS AFINS. (LEI 6368 DE 21/10/76) LEI 7460 DE 19/12/86, LEI 9804 DE 30/06/99. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.7.1.01.00.00.00.0000','VPA DE ALIENAÇÃO DE BENS E/OU MERCADORIAS APREENDIDAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALIENACAO DE BENS E/OU DE MERCADORIAS APREENDIDAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.7.1.02.00.00.00.0000','VPA DE ALIENACAO DE BENS APREENDIDOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS GERADAS PELA ALIENAÇÃO DE BENS APREENDIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.7.1.03.00.00.00.0000','VPA DE ALIEN.BENS APREE.TRAF.ILIC.ENT.DROG.AFINS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS GERADAS PELA ALIENAÇÃO DE BENS APREENDIDOS POR TRÁFICO ILÍCITO DE ENTORPECENTES, DROGAS E AFINS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.7.1.70.00.00.00.0000','RECEITA DE ALIENAÇÃO DE BENS CAUCIONADOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS GERADAS PELA ALIENAÇÃO DE BENS CAUCIONADOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.7.1.99.00.00.00.0000','OUTRAS VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS','REGISTRA AS DEMAIS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS GERADAS PELA ALIENAÇÃO DE BENS APREENDIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.9.0.00.00.00.00.0000','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.9.1.00.00.00.00.0000','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.9.1.01.00.00.00.0000','VPA DE ONUS DE SUCUMBÊNCIA DE AÇÕES JUDICIAIS','COMPREENDE A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURAÇÃO, INSCRIÇÃO E COBRANCA DA DÍVIDA ATIVA DO MUNICÍPIO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA MUNICIPAL, PAGA PELO DEVEDOR DA AÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.9.1.01.01.00.00.0000','VPA DE HONORÁRIOS DE ADVOGADOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURAÇÃO, INSCRIÇÃO E COBRANCA DA DÍVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA AÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.9.1.02.00.00.00.0000','"TERCEIRIZAÇÃO" DA FOLHA DE PAGAMENTO DOS AGENTES PÚBLICOS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA PROVENIENTE DA TERCEIRIZAÇÃO DA FOLHA DE PAGAMENTO DOS AGENTES PÚBLICOS COMO CONTRAPARTIDA DA PRESTAÇÃO DE SERVIÇOS DE DISPONIBILIZAÇÃO DE CRÉDITOS EM CONTAS CORRENTES E DA CONCESSAO DE EMPRÉSTIMOS E FINANCIAMENTOS COM AMORTIZAÇÃO CONSIGNADA EM FOLHA DE PAGAMENTO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.9.1.03.00.00.00.0000','OUTRAS RECEITAS DIRETAMENTE ARRECADADAS PELO RPPS','REGISTRA O VALOR TOTAL DAS DEMAIS VPAS CORRENTES ARRECADADAS DIRETAMENTE PELO REGIME PRÓPRIO DE PREVIDÊNCIA','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.9.1.04.00.00.00.0000','RECEITAS DIRETAMENTE ARRECADADAS PELO FUNDO DE ASSISTÊNCIA SOCIAL DOS SERVIDORES','REGISTRA O VALOR TOTAL DAS VPAS CORRENTES ARRECADADAS DIRETAMENTE PELO FUNDO DE ASSISTÊNCIA SOCIAL DOS SERVIDORES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.9.1.05.00.00.00.0000','RECEITAS DIRETAMENTE ARRECADADAS PELO FUNDO DE ASSISTÊNCIA A SAUDE DOS SERVIDORES','REGISTRA O VALOR TOTAL DAS VPAS CORRENTES ARRECADADAS DIRETAMENTE PELO FUNDO DE ASSISTÊNCIA A SAÚDE DOS SERVIDORES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.9.1.06.00.00.00.0000','RECEITAS DECORRENTES DA COMPRA DE DOSES DE SEMEN DE ANIMAIS PELOS PRODUTORES','REGISTRA O VALOR TOTAL DA VPA DECORRENTE DA COMPRA PELOS PRODUTOS DE SÊMEN DE ANIMAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.9.1.07.00.00.00.0000','RECEITAS DECORRENTES DO RECEBIMENTO DE CERTIDÃO - TÍTULO EXECUTIVO DO TCE/AL','REGISTRA A VPA DECORRENTES DO RECEBIMENTO TOTAL OU PARCIAL DE CERTIDÃO - TÍTULO EXECUTIVO EMITIDO PELO TCE/AL, O QUAL FOI REGISTRADO NO ATIVO COMO CRÉDITOS A RECEBER E NÃO COMO DÍVIDA ATIVA NÃO-TRIBUTÁRIA','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.9.1.08.00.00.00.0000','PROGRAMA TROCA-TROCA','REGISTRA O VALOR TOTAL DA VPA PROVENIENTE DO PAGAMENTO PELOS AGRICULTORES DO VALOR QUE LHES FOI ENTREGUE EM SEMENTES PELO MUNICÍPIO. INCLUSIVE A VPA DA DÍVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.9.1.09.00.00.00.0000','RESTITUIÇÕES DETERMINADAS PELO TCE-AL','REGISTRA A VPA PROVENIENTE DE CRÉDITOS EXIGÍVEIS A PARTIR DO RECEBIMENTO, PELO CREDOR, DE CERTIDÃO DE DECISÃO – TÍTULO EXECUTIVO, EMITIDO PELO TRIBUNAL DE CONTAS DO ESTADO, COM CARACTERÍSTICA DE LIQUIDEZ E CERTEZA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.9.1.10.00.00.00.0000','RESTITUICAO PELO USO DE BENS DO MUNICÍPIO','REGISTRA O VALOR TOTAL DA ARRECADAÇÃO DA VPA PROVENIENTE DA UTILIZAÇÃO DE BENS DO MUNICÍPIO. EX: TELEFONE MÓVEL','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.9.1.11.00.00.00.0000','RESTITUICAO PELO PAGAMENTO INDEVIDO','REGISTRA O VALOR DA RESTITUIÇÃO PROVENIENTE DE PAGAMENTO INDEVIDO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '4.9.9.9.1.12.00.00.00.0000','RESTITUICAO DE AUXÍLIOS','REGISTRA A ARRECADAÇÃO DE RECURSOS PROVENIENTES DA DEVOLUÇÃO DE SALDOS DE AUXÍLIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.0.0.0.0.00.00.00.00.0000','CONTROLES DA APROVAÇÃO DO PLANEJAMENTO E ORCAMENTO','COMPREENDE AS CONTAS COM FUNÇÃO DE REGISTRA OS ATOS E FATOS LIGADOS A EXECUÇÃO ORCAMENTARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.1.0.0.0.00.00.00.00.0000','PLANEJAMENTO APROVADO','COMPREENDE O SOMATÓRIO DOS VALORES MONETARIOS PREVISTOS PARA EXECUÇÃO DOS PROGRAMAS E AÇÕES (PROJETOS, ATIVIDADES E OPERAÇÕES ESPECIAIS) ESTABELECIDOS NO PLANO PLURIANUAL E PROJETO DE LEI ORCAMENTARIA ANUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.1.1.0.0.00.00.00.00.0000','PPA - APROVADO','COMPREENDE O SOMATÓRIO DOS VALORES MONETARIOS PREVISTOS PARA A EXECUÇÃO DOS PROGRAMAS E AÇÕES (PROJETOS, ATIVIDADES E OPERAÇÕES ESPECIAIS) ESTABELECIDOS NO PLANO PLURIANUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.1.1.1.0.00.00.00.00.0000','APROVAÇÃO INICIAL DO PPA','REGISTRA OS VALORES MONETÁRIOS PREVISTOS INICIALMENTE PARA A EXECUÇÃO DOS PROGRAMAS E AÇÕES (PROJETOS, ATIVIDADES E OPERAÇÕES ESPECIAIS) ESTABELECIDOS NO PLANO PLURIANUAL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.1.1.2.0.00.00.00.00.0000','REVISAO DO PPA','REGISTRA O SOMATÓRIO DOS VALORES MONETARIOS DAS REVISOES ANUAIS AUTORIZADAS DURANTE O PERIODO DE VIGENCIA DO PLANO PLURIANUAL, DETALHADO POR PROGRAMA DE TRABALHO.','X','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.1.2.0.0.00.00.00.00.0000','PLOA','COMPREENDE O SOMATÓRIO DOS VALORES MONETARIOS PREVISTOS PARA A EXECUÇÃO DOS PROGRAMAS E AÇÕES (PROJETOS, ATIVIDADES E OPERAÇÕES ESPECIAIS) ESTABELECIDOS NO PROJETO DE LEI ORCAMENTARIA ANUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.1.2.1.0.00.00.00.00.0000','PROJETO INICIAL DA LEI ORCAMENTARIA - RECEITA','COMPREENDE O SOMATÓRIO DOS VALORES MONETARIOS CONSTANTES DO PROJETO DA LEI ORCAMENTARIA ANUAL REMETIDO PELO PODER EXECUTIVO AO PODER LEGISLATIVO PARA APRECIAÇÃO E APROVAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.1.2.1.1.00.00.00.00.0000','PLOA INICIAL DA RECEITA','REGISTRA O SOMATÓRIO DOS VALORES MONETARIOS DA PREVISAO DE RECEITA CONSTANTE DO PLOA INICIAL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.1.2.1.2.00.00.00.00.0000','ALTERAÇÕES DO PROJETO INICIAL DA LOA - RECEITA','REGISTRA O SOMATÓRIO DAS ALTERAÇÕES NO PROJETO INICIAL DA LOA EM RELAÇÃO A RECEITA.','X','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.1.2.2.0.00.00.00.00.0000','PROJETO INICIAL DA LOA - DESPESA','COMPREENDE O SOMATÓRIO DOS VALORES MONETARIOS CONSTANTES DO PROJETO DA LEI ORCAMENTARIA ANUAL REMETIDO PELO PODER EXECUTIVO AO PODER LEGISLATIVO PARA APRECIAÇÃO E APROVAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.1.2.2.1.00.00.00.00.0000','PLOA INICIAL DA DESPESA','REGISTRA O SOMATÓRIO DOS VALORES MONETARIOS DA FIXAÇÃO DA DESPESA CONSTANTE DO PLOA INICIAL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.1.2.2.2.00.00.00.00.0000','ALTERAÇÕES DO PROJETO INICIAL DA LOA - DESPESA','REGISTRA O SOMATÓRIO DAS ALTERAÇÕES NO PROJETO INICIAL DA LOA EM RELAÇÃO A DESPESA.','X','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.0.0.0.00.00.00.00.0000','ORCAMENTO APROVADO','COMPREENDE O SOMATÓRIO DOS VALORES RELATIVOS A PREVISAO DA RECEITA, FIXAÇÃO DA DESPESA E SUAS ALTERAÇÕES NO ORÇAMENTO GERAL DA UNIAO DURANTE O EXERCÍCIO FINANCEIRO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.1.0.0.00.00.00.00.0000','PREVISAO DA RECEITA','COMPREENDE O SOMATÓRIO DOS VALORES RELATIVOS A PREVISAO DA RECEITA PÚBLICA APROVADA PELA LEI ORCAMENTARIA ANUAL E SUAS ALTERAÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.1.1.0.00.00.00.00.0000','PREVISAO INICIAL DA RECEITA','COMPREENDE O VALOR DA PREVISAO INICIAL DA RECEITA APROVADO NA LOA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.1.1.1.00.00.00.00.0000','PREVISAO INICIAL DA RECEITA BRUTA','REGISTRA O VALOR BRUTO DA RECEITA PREVISÃO INICIAL DA RECEITA .','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.1.1.2.00.00.00.00.0000','(-) PREVISÃO DE DEDUÇÕES DA RECEITA','REGISTRA O VALOR DAS DEDUÇÕES DE RECEITA ORÇAMENTÁRIA PREVISTAS EM ORÇAMENTO PARA O EXERCÍCIO VIGENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.1.1.2.01.00.00.00.0000','(-) DEDUÇÕES POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS','REGISTRA A PREVISÃO DE DEDUÇÃO DA RECEITA APROVADA NA LOA POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.1.1.2.01.01.00.00.0000','(-) FUNDEB','REGISTRA O VALOR DAS DEDUÇÕES DA RECEITA A REALIZAR - FUNDEB','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.1.1.2.01.02.00.00.0000','(-) TRANSFERÊNCIAS CONSTITUCIONAIS A MUNICÍPIOS','REGISTRA A PREVISÃO DE DEDUÇÃO DA RECEITA APROVADA NA LOA POR TRANSFERÊNCIAS CONSTITUCIONAIS A MUNICÍPIOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.1.1.2.02.00.00.00.0000','(-) RENÚNCIA','REGISTRA O VALOR DAS DEDUÇÕES DA RECEITA A REALIZAR POR RENÚNCIA','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.1.1.2.99.00.00.00.0000','(-) OUTRAS DEDUÇÕES','REGISTRA A PREVISÃO DE OUTRAS DEDUÇÕES DA RECEITA APROVADA NA LOA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.1.2.0.00.00.00.00.0000','ALTERAÇÃO DA PREVISÃO DA RECEITA','REGISTRA O VALOR DOS CRÉDITOS PREVISTOS APOS A APROVAÇÃO DO ORÇAMENTO INDEPENDENTE DA AUTORIZAÇÃO JA CONCEDIDA NA LEI ORCAMENTARIA PARA ABERTURA DE CRÉDITO SUPLEMENTAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.1.2.1.00.00.00.00.0000','PREVISAO ADICIONAL DA RECEITA','REGISTRA O VALOR ADICIONAL DA RECEITA PARA ABERTURA DE CRÉDITOS ADICIONAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.1.2.1.01.00.00.00.0000','REESTIMATIVA','REGISTRA O VALOR ADICIONAL DA RECEITA PARA ABERTURA DE CRÉDITOS ADICIONAIS POR MOTIVO DE REESTIMATIVA DA RECEITA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.1.2.1.02.00.00.00.0000','CORREÇÃO','REGISTRA O VALOR ADICIONAL DA RECEITA PARA ABERTURA DE CRÉDITOS ADICIONAIS POR MOTIVO DE CORREÇÃO DE ERROS OU OMISSÕES NA ESTIMATIVA DA RECEITA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.1.2.9.00.00.00.00.0000','(-) ANULAÇÃO DA PREVISAO DA RECEITA','REGISTRA O VALOR DA ANULAÇÃO DA RECEITA PREVISTA NO ORCAMENTO, NA GESTAO FUNDOS E NAS ADMINISTRAÇÕES DIRETA E INDIRETA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.0.0.00.00.00.00.0000','FIXAÇÃO DA DESPESA','COMPREENDE O SOMATÓRIO DOS VALORES RELATIVOS A FIXAÇÃO DA DESPESA PÚBLICA APROVADA PELA LEI ORCAMENTARIA E SUAS ALTERAÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.0.00.00.00.00.0000','DOTAÇÃO ORCAMENTARIA','COMPREENDE O SOMATÓRIO DOS VALORES MONETARIOS DA DOTAÇÃO ORCAMENTARIA INICIAL, ADICIONAL E SEUS CANCELAMENTOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.1.00.00.00.00.0000','DOTAÇÃO INICIAL','COMPREENDE A DOTAÇÃO INICIAL AUTORIZADA NA LEI ORCAMENTARIA ANUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.1.01.00.00.00.0000','CRÉDITO INICIAL','COMPREENDE OS VALORES PERTINENTES AOS CRÉDITOS INICIALMENTE APROVADOS PARA DAR SUPORTE A EXECUÇÃO ORCAMENTARIA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.1.01.01.00.00.0000','ORIGINÁRIO DO OGM','REGISTRA OS VALORES PERTINENTES AOS CRÉDITOS INICIAIS APROVADOS PELA LEI ORCAMENTARIA, PARA EXECUÇÃO DO ORÇAMENTO DOS ORGÃOS/ENTIDADES INTEGRANTES DO OGM REFERENTES AO OFSS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.1.02.00.00.00.0000','CREDITOS ANTECIPADOS - LDO','COMPREENDE OS VALORES RELATIVOS AS ANTECIPACOES DE CREDITOS DETERMINADOS PELA LEI DE DIRETRIZES ORCAMENTARIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.1.02.01.00.00.0000','ANTECIPACAO - LDO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ANTECIPADOS PELA LEI DE DIRETRIZES ORCAMENTARIAS ATE QUE O ORCAMENTO SEJA APROVADO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.1.02.09.00.00.0000','(-) ANULACAO DA ANTECIPACAO - LDO','REGISTRA O VALOR REFERENTE AO CANCELAMENTO DE DOTACAO ANTECIPADA PREVISTA NA LEI DE DIRETRIZES ORCAMENTARIAS - LDO, APOS APROVACAO DO ORCAMENTO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.2.00.00.00.00.0000','DOTAÇÃO ADICIONAL POR TIPO DE CRÉDITO','COMPREENDE O SOMATÓRIO DOS VALORES MONETARIOS DA DOTAÇÃO ORCAMENTARIA DECORENTES DA ABERTURA DE CRÉDITOS ADICIONAIS E SEUS CANCELAMENTOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.2.01.00.00.00.0000','CRÉDITO ADICIONAL – SUPLEMENTAR','COMPREENDE O SOMATÓRIO DOS VALORES RELATIVOS AOS CRÉDITOS ADICIONAIS SUPLEMENTARES COM VISTA AO REFORÇO DA DOTAÇÃO ORÇAMENTARIA CONSTANTE DA LEI ORCAMENTARIA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.2.02.00.00.00.0000','CRÉDITO ADICIONAL - ESPECIAL','COMPREENDE O SOMATÓRIO DOS VALORES DOS CRÉDITOS ADICIONAIS ESPECIAIS DESTINADOS A ATENDER PROGRAMAS NÃO CONTEMPLADOS NA LEI ORÇAMENTARIA ANUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.2.02.01.00.00.0000','CRÉDITOS ESPECIAIS ABERTOS','REGISTRA OS VALORES REFERENTES À ABERTURA DE CRÉDITOS ESPECIAIS AUTORIZADOS EM LEI ESPECIFICA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.2.02.02.00.00.0000','CRÉDITOS ESPECIAIS REABERTOS','REGISTRA OS VALORES REFERENTES A REABERTURA DE CRÉDITOS ESPECIAIS CUJO ATO DE AUTORIZAÇÃO FOI PROMULGADO NOS ULTIMOS QUATRO MESES DO EXERCÍCIO ANTERIOR.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.2.02.03.00.00.0000','CRÉDITOS ESPECIAIS REABERTOS - SUPLEMENTAÇÃO','REGISTRA OS VALORES REFERENTES A SUPLEMENTAÇÃO DE CRÉDITOS ESPECIAIS REABERTOS NOS TERMOS DO § 2º DO ART. 167 DA CF/88.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.2.03.00.00.00.0000','CRÉDITO ADICIONAL – EXTRAORDINÁRIO','COMPREENDE O SOMATÓRIO DOS VALORES REFERENTES A ABERTURA DE CRÉDITOS ADICIONAIS EXTRAORDINARIOS DESTINADOS A DESPESAS IMPREVISIVEIS E URGENTES COMO AS DECORRENTES DE GUERRA, COMOCAO INTERNA OU CALAMIDADE PÚBLICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.2.03.01.00.00.0000','CRÉDITOS EXTRAORDINÁRIOS ABERTOS','REGISTRA OS VALORES REFERENTES AOS CRÉDITOS EXTRAORDINARIOS ABERTOS POR AUTORIZAÇÃO DO PODER EXECUTIVO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.2.03.02.00.00.0000','CRÉDITOS EXTRAORDINÁRIOS REABERTOS','REGISTRA OS VALORES REFERENTES A REABERTURA DE CRÉDITOS EXTRAORDINARIOS CUJO ATO DE AUTORIZAÇÃO FOI PROMULGADO NOS ULTIMOS QUATRO MESES DO EXERCÍCIO ANTERIOR.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.2.03.03.00.00.0000','CRÉDITOS EXTRAORDINARIOS REABERTOS - SUPLEMENTAÇÃO','REGISTRA OS VALORES REFERENTES A SUPLEMENTAÇÃO DE CRÉDITOS EXTRAORDINARIOS REABERTOS NOS TERMOS DO § 2º DO ART. 167 DA CF/88.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.00.00.00.00.0000','DOTAÇÃO ADICIONAL POR FONTE','COMPREENDE O SOMATÓRIO DOS VALORES DA DOTAÇÃO ADICIONAL POR FONTE DE RECURSOS PARA ABERTURA DO CRÉDITO ADICIONAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.01.00.00.00.0000','CRÉDITO SUPLEMENTAR','REGISTRA O SOMATÓRIO DA MOVIMENTAÇÃO DOS CRÉDITOS SUPLEMENTARES, DESTINADOS A REFORCO DE DOTAÇÃO ORCAMENTARIA JA EXISTENTE NO ORÇAMENTO EM VIGOR, PARA A REALIZAÇÃO DE DESPESAS, AUTORIZADA POR LEI E ABERTA POR DECRETOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.01.01.00.00.0000','SUPERÁVIT FINANCEIRO DE EXERCÍCIO ANTERIOR','REGISTRA OS VALORES PERTINENTES AOS CRÉDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA SUPERÁVIT FINANCEIRO APURADO NO BALANCO PATRIMONIAL DO EXERCÍCIO ANTERIOR.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.01.02.00.00.0000','EXCESSO DE ARRECADAÇÃO.','REGISTRA OS VALORES PERTINENTES AOS CRÉDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.01.02.01.00.0000','EXCESSO DE ARRECADAÇÃO PROPRIAMENTE DITA.','REGISTRA OS VALORES PERTINENTES AOS CRÉDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADAÇÃO DE VALORES RECEBIDOS A MAIOR QUE O PREVISTO NO ORÇAMENTO ORIGINAL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.01.02.02.00.0000','DOAÇÕES','REGISTRA OS VALORES PERTINENTES AOS CRÉDITOS SUPLEMENTARES ABERTOS NO EXERCÍCIO, PROVENIENTES DE DOAÇÕES RECEBIDAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.01.02.03.00.0000','AUXÍLIOS E CONVÊNIOS','RECURSO OFERECIDO PARA ABERTURA DE CRÉDITOS SUPLEMENTARES ADICIONAIS PROVENIENTE DO RECEBIMENTO DE AUXÍLIOS E CONVÊNIOS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.01.03.00.00.0000','OPERAÇÕES DE CRÉDITO','REGISTRA OS VALORES PERTINENTES AOS CRÉDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA OPERAÇÕES DE CRÉDITO AUTORIZADAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.01.04.00.00.0000','ANULAÇÃO DE DOTAÇÃO','REGISTRA OS VALORES PERTINENTES AOS CRÉDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA A ANULAÇÃO PARCIAL OU TOTAL DE DOTAÇÕES ORCAMENTARIAS OU CRÉDITOS ADICIONAIS, AUTORIZADOS EM LEI.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.02.00.00.00.0000','CRÉDITO ESPECIAL','REGISTRA O SOMATÓRIO DA MOVIMENTAÇÃO DOS CRÉDITOS ESPECIAIS, DESTINADOS A NOVAS DOTACÕES ORCAMENTARIAS NÇAO EXISTENTES NO ORÇAMENTO EM VIGOR, PARA A REALIZAÇÃO DE DESPESAS, AUTORIZADA POR LEI E ABERTA POR DECRETOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.02.01.00.00.0000','SUPERÁVIT FINANCEIRO DE EXERCÍCIO ANTERIOR','REGISTRA OS VALORES PERTINENTES AOS CRÉDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA SUPERÁVIT FINANCEIRO APURADO NO BALANCO PATRIMONIAL DO EXERCÍCIO ANTERIOR.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.02.02.00.00.0000','EXCESSO DE ARRECADAÇÃO.','REGISTRA OS VALORES PERTINENTES AOS CRÉDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.02.02.01.00.0000','EXCESSO DE ARRECADAÇÃO PROPRIAMENTE DITA.','REGISTRA OS VALORES PERTINENTES AOS CRÉDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADAÇÃO DE VALORES RECEBIDOS A MAIOR QUE O PREVISTO NO ORÇAMENTO ORIGINAL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.02.02.02.00.0000','DOAÇÕES','REGISTRA OS VALORES PERTINENTES AOS CRÉDITOS SUPLEMENTARES ABERTOS NO EXERCÍCIO, PROVENIENTES DE DOAÇÕES RECEBIDAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.02.02.03.00.0000','AUXÍLIOS E CONVÊNIOS','RECURSO OFERECIDO PARA ABERTURA DE CRÉDITOS SUPLEMENTARES ADICIONAIS PROVENIENTE DO RECEBIMENTO DE AUXÍLIOS E CONVÊNIOS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.02.03.00.00.0000','OPERAÇÕES DE CRÉDITO','REGISTRA OS VALORES PERTINENTES AOS CRÉDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA OPERAÇÕES DE CRÉDITO AUTORIZADAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.02.04.00.00.0000','ANULAÇÃO DE DOTAÇÃO','REGISTRA OS VALORES PERTINENTES AOS CRÉDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA A ANULAÇÃO PARCIAL OU TOTAL DE DOTAÇÕES ORCAMENTARIAS OU CRÉDITOS ADICIONAIS, AUTORIZADOS EM LEI.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.09.00.00.00.0000','(-) CANCELAMENTO DE DOTAÇÕES','REGISTRA O REMANEJAMENTO DE DOTAÇÕES PARA ABERTURA DE CRÉDITOS ADICIONAIS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.3.99.00.00.00.0000','VALOR GLOBAL DA DOTAÇÃO ADICIONAL POR FONTE','REGISTRA O VALOR DA CONTRAPARTIDA DOS LANCAMENTOS DAS DOTAÇÕES ADICIONAIS POR ORIGEM DE CRÉDITO.','X','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.9.00.00.00.00.0000','CANCELAMENTO / REMANEJAMENTO DE DOTAÇÃO','COMPREENDE O SOMATÓRIO DOS VALORES RELATIVOS AOS CRÉDITOS INICIAL, SUPLEMENTAR, ESPECIAL E EXTRAORDINARIO CANCELADOS OU REMANEJADOS, EM CASOS REGULARMENTE PREVISTOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.9.01.00.00.00.0000','ALTERAÇÃO DO QUADRO DE DETALHAMENTO DA DESPESA','REGISTRA A MOVIMENTAÇÃO DOS CRÉDITOS POR ACRESCIMO OU REDUÇÃO DECORRENTE DE ALTERAÇÃO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.9.01.01.00.00.0000','ACRESCIMO','REGISTRA A MOVIMENTAÇÃO DOS CRÉDITOS POR ACRESCIMO DECORRENTE DE ALTERAÇÃO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.9.01.09.00.00.0000','(-) REDUÇÃO','REGISTRA A MOVIMENTAÇÃO DOS CRÉDITOS POR REDUÇÃO DECORRENTE DE ALTERAÇÃO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.9.02.00.00.00.0000','ALTERAÇÃO DA LEI ORCAMENTARIA','REGISTRA OS VALORES DOS CRÉDITOS ORCAMENTARIOS INDISPONIVEIS PARA EXECUÇÃO DA DESPESA, POR MEDIDA DE VETO, CONTINGENCIAMENTO OU CONTENCAO, E POSTERIORMENTE CANCELADAS, NOS CASOS REGULARMENTE PREVISTOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.9.02.01.00.00.0000','ACRESCIMO','REGISTRA OS VALORES DOS ACRESCIMOS RESULTANTES DE ALTERAÇÕES DA LEI ORCAMENTARIA EM VIRTUDE DE REMANEJAMENTO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.9.02.04.00.00.0000','(-) CANCELAMENTO DE DOTACOES','REGISTRA O VALOR DA REDUCAO DA DOTACAO DEVIDO A ALTERACAO DA LEI ORCAMENTARIA EM VIRTUDE DE CANCELAMENTO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.1.9.02.09.00.00.0000','(-) REDUÇÃO','REGISTRA O VALOR DA REDUÇÃO DA DOTAÇÃO DEVIDO A ALTERAÇÃO DA LEI ORCAMENTARIA EM VIRTUDE DE REMANEJAMENTO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.0.00.00.00.00.0000','MOVIMENTAÇÃO DE CRÉDITOS RECEBIDOS','COMPREENDE O SOMATÓRIO DOS VALORES DOS RECEBIMENTOS DE CRÉDITOS ORCAMENTARIOS ATRAVES DE DESTAQUE, PROVISAO OU POR FUSAO, CISAO OU EXTINÇÃO DE UNIDADES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.1.00.00.00.00.0000','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISAO','COMPREENDE OS VALORES DOS CRÉDITOS DESCENTRALIZADOS DAS UNIDADES ORCAMENTARIAS PARA AS UNIDADES ADMINISTRATIVAS SOB SUA JURISDICAO OU ENTRE ESTAS, NO AMBITO DO PROPRIO MINISTERIO, SECRETARIA OU ORGÃO EQUIVALENTE, RECEBIDOS AO LONGO DO EXERCÍCIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.1.01.00.00.00.0000','PROVISAO RECEBIDA','REGISTRA A PARCELA DE CRÉDITO RECEBIDA POR UMA UNIDADE ADMINISTRATIVA OU ORCAMENTARIA, DECORRENTE DA DESCENTRALIZAÇÃO DO CRÉDITO ORCAMENTARIO OU ADICIONAL, DENTRO DO PROPRIO ORGÃO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.1.02.00.00.00.0000','PROVISAO RECEBIDA - BLOQUEADA','REGISTRA A PARCELA DE CREDITOS ORCAMENTARIOS RECEBIDOS MEDIANTE PROVISAO E POSTERIORMENTE BLOQUEADOS, EM HIPOTESES ESPECIAIS, PELA UNIDADE CONCEDENTE.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.1.09.00.00.00.0000','ALTERACAO DE CREDITOS MOVIMENTADOS','COMPREENDE O VALOR DA MOVIMENTACAO DE CREDITOS ORCAMENTARIOS POR ACRESCIMO OU REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD, POR UG PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.1.09.01.00.00.0000','ACRESCIMO','REGISTRA O VALOR DA MOVIMENTACAO DE CREDITOS ORCAMENTARIOS POR ACRESCIMO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.1.09.09.00.00.0000','(-) REDUCAO','REGISTRA O VALOR DA MOVIMENTACAO DE CREDITOS ORCAMENTARIOS POR REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.2.00.00.00.00.0000','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','COMPREENDE A DESCENTRALIZAÇÃO DO CRÉDITO INICIAL OU ADICIONAL RECEBIDO DE UNIDADES OU ORGÃOS PERTENCENTES A MINISTERIOS, SECRETARIAS E ORGÃOS EQUIVALENTES DISTINTOS OU ENTRE ESTES E ENTIDADES DA ADMINISTRAÇÃO INDIRETA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.2.01.00.00.00.0000','ADMINISTRAÇÃO DIRETA','COMPREENDE O VALOR REFERENTE A MOVIMENTAÇÃO DE CRÉDITOS DECORRENTES DE RECEBIMENTO OU DE TRANSFERÊNCIA DE OUTROS ORGÃOS E ENTIDADES DE IGUAL OU DE DIFERENTE UNIDADE ORCAMENTARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.2.01.01.00.00.0000','CRÉDITOS RECEBIDOS','REGISTRA O VALOR DOS CRÉDITOS RECEBIDOS PELA ADMINISTRAÇÃO DIRETA DE OUTROS ORGÃOS E ENTIDADES.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.2.01.09.00.00.0000','(-) CRÉDITOS TRANSFERIDOS','REGISTRA A MOVIMENTAÇÃO DE CRÉDITOS DE ENTIDADES DA ADMINISTRAÇÃO INDIRETA OU ENTRE ORGÃOS DA ADMINISTRAÇÃO DIRETA DE UNIDADE ORCAMENTARIA DIFERENTE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.2.02.00.00.00.0000','ADMINISTRAÇÃO INDIRETA','COMPREENDE O VALOR REFERENTE A MOVIMENTAÇÃO DE CRÉDITOS DECORRENTES DE RECEBIMENTO OU DE TRANSFERÊNCIA DE OUTROS ORGÃOS E ENTIDADES DE IGUAL OU DE DIFERENTE UNIDADE ORCAMENTARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.2.02.01.00.00.0000','CRÉDITOS RECEBIDOS','REGISTRA O VALOR DOS CRÉDITOS RECEBIDOS PELA ADMINISTRAÇÃO INDIRETA DE MESMA OU DE DIFERENTE UNIDADE ORCAMENTARIA DO ORGÃO EMITENTE.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.2.02.09.00.00.0000','(-) CRÉDITOS TRANSFERIDOS','REGISTRA A MOVIMENTAÇÃO DE CRÉDITOS DE ORGÃOS DA ADMINISTRAÇÃO DIRETA OU ENTRE ENTIDADES DA ADMINISTRAÇÃO INDIRETA DE MESMA OU DE DIFERENTE UNIDADE ORCAMENTARIA, NÃO FORMALIZADA A TERMO DE CONTRATO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.2.09.00.00.00.0000','ALTERACAO DE CREDITOS MOVIMENTADOS','COMPREENDE O VALOR DA ALTERACAO DE CREDITOS ORCAMENTARIOS POR ACRESCIMO OU REDUCAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.2.09.01.00.00.0000','ACRESCIMO','REGISTRA O VALOR DO ACRESCIMO DE CREDITO DISPONIVEL POR ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA-QDD, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.2.09.02.00.00.0000','(-) REDUCAO','REGISTRA O VALOR DA REDUCAO DO CREDITO DISPONIVEL POR ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA-QDD, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.9.00.00.00.00.0000','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','COMPREENDE AS MOVIMENTAÇÕES DE CRÉDITOS RECEBIDOS POR CISAO, FUSAO, EXTINÇÃO, COMPENSAÇÃO E OUTRAS TRANSAÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.9.01.00.00.00.0000','CREDITOS EXT. RECEB. POR FUSAO/CISAO/EXTINCAO','REGISTRA O VALOR DOS CREDITOS RECEBIDOS POR DESCENTRALIZACAO EXTERNA DECORRENTES DE FUSAO, CISAO OU EXTINCAO DE ORGAOS, ENTIDADES OU UG''S DURANTE O EXERCICIO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.2.9.02.00.00.00.0000','CREDITOS INT. RECEB. POR FUSAO/CISAO/EXTINCAO','REGISTRA O VALOR DOS CREDITOS RECEBIDOS POR DESCENTRALIZACAO INTERNA DECORRENTES DE FUSAO, CISAO OU EXTINCAO DE ORGAOS, ENTIDADES OU UG''S DURANTE O EXERCICIO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.3.0.00.00.00.00.0000','DETALHAMENTO DE CRÉDITO','COMPREENDE O SOMATÓRIO RELATIVOS AS DOTAÇÕES DETALHADAS RELATIVAS A CADA AÇÃO ORCAMENTARIA (PROJETO, ATIVIDADE OU OPERAÇÕES ESPECIAIS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.3.1.00.00.00.00.0000','CREDITOS A DETALHAR','COMPREENDE O VALOR DOS CREDITOS A DETALHAR.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.0.00.00.00.00.0000','OUTROS CONTROLES DA DESPESA ORCAMENTARIA','COMPREENDE O SOMATÓRIO DOS VALORES DAS DESPESAS PRE-EMPENHADAS E EMPENHADAS POR DETALHAMENTO ESPECIFICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.00.00.00.00.0000','EMPENHOS POR EMISSAO','COMPREENDE O SOMATÓRIO DOS VALORES EMPENHADOS POR DETALHAMENTO ESPECIFICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.01.00.00.00.0000','PRÉ-EMPENHO EMITIDOS','COMPREENDE O VALOR DAS RESERVAS DE EMPENHO (PED) REALIZADAS NO EXERCÍCIO A EMPENHAR E EMPENHADAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.01.01.00.00.0000','REFORÇO DE PRÉ-EMPENHO','REGISTRA OS VALORES DE REFORÇO DE PRÉ-EMPENHO EMITIDO PELA PRÓPRIA UNIDADE DETENTORA DO CRÉDITO DISPONÍVEL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.01.09.00.00.0000','ANULAÇÃO DE PRÉ-EMPENHO','REGISTRA A ANULAÇÃO DE PRÉ-EMPENHO EMITIDO PELA PRÓPRIA UNIDADE DETENTORA DO CRÉDITO DISPONÍVEL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.02.00.00.00.0000','EMPENHOS POR NOTA DE EMPENHO','COMPREENDE O CONTROLE DOS EMPENHOS EMITIDOS, REFORCADOS E TRANSFERIDOS, QUE ENVOLVAM DESPESAS ORCAMENTARIAS REALIZADAS PELA ADMINISTRAÇÃO PÚBLICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.02.01.00.00.0000','EMISSAO DE EMPENHOS','REGISTRA O VALOR DA EMISSAO DE EMPENHO DA DESPESA, INCLUSIVE AQUELAS QUE FORAM OBJETO DE PRE-EMPENHO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.02.02.00.00.0000','REFORÇO DE EMPENHOS','REGISTRA O VALOR DA EMISSAO DE EMPENHO DE DESPESA VISANDO A SUPLEMENTAR O EMPENHO ORIGINAL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.02.09.00.00.0000','ANULAÇÃO DE EMPENHO','COMPREENDE O VALOR DA DESPESA EXECUTADA CONTROLADA POR NOTA DE EMPENHO - TOTAL DOS EMPENHOS ANULADOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.02.09.01.00.0000','ANULAÇÃO POR INSUFICIÊNCIA FINANCEIRA','COMPREENDE O VALOR DA DESPESA EXECUTADA CONTROLADA POR NOTA DE EMPENHO - TOTAL DO EMPENHOS ANUALDOS POR INSUFICIÊNCIA FINANCEIRA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.02.09.02.00.0000','OUTRAS ANULAÇÕES','COMPREENDE O VALOR DA DESPESA EXECUTADA CONTROLADA POR NOTA DE EMPENHO - TOTAL DO EMPENHOS ANULADOS POR OUTRAS ANULAÇÕES.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.00.00.00.0000','EMPENHOS POR MODALIDADE DE LICITAÇÃO','COMPREENDE O SOMATÓRIO DOS VALORES DA EMISSAO DE EMPENHOS DE DESPESAS COM LICITAÇÕES PARA OBRAS, SERVIÇOS, FORNECIMENTOS OU ALIENAÇÕES, BEM COMO SUAS DISPENSAS E INEXIGIBILIDADES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.01.00.00.0000','CONCORRENCIA','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITAÇÃO CONCORRENCIA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.02.00.00.0000','TOMADA DE PRECOS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITAÇÃO TOMADA DE PRECOS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.03.00.00.0000','CONVITE','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITAÇÃO CONVITE.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.04.00.00.0000','CONCURSO','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITAÇÃO CONCURSO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.05.00.00.0000','PREGAO','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE PREGAO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.06.00.00.0000','CONSULTA','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE CONSULTA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.07.00.00.0000','DISPENSA DE LICITAÇÃO','REGISTRA O VALOR DO EMPENHOS EMITIDOS POR DISPENSA DE LICITAÇÃO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.09.00.00.0000','LICITAÇÃO INEXIGIVEL','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PELA REALIZAÇÃO DE DESPESAS EM QUE É INEXIGIVEL A LICITAÇÃO QUANDO HOUVER INVIABILIDADE DE COMPETICAO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.10.00.00.0000','NÃO APLICAVEL','COMPREENDE O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.10.01.00.0000','SUPRIMENTO DE FUNDOS -','REGISTRA O VALOR DOS EMPENHOS EMITIDOS RELATIVOS A SUPRIMENTOS DE FUNDOS PARA ATENDER DESPESAS EVENTUAIS, INCLUSIVE EM VIAGENS E COM SERVIÇOS ESPECIAIS, DESPESA DE CARATER SIGILOSO OU PARA ATENDER DESPESAS DE PEQUENO VULTO, DE ACORDO COM A LEGISLAÇÃO VIGENTE.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.10.02.00.0000','PESSOAL E ENCARGOS SOCIAIS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A PESSOAL E ENCARGOS SOCIAIS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.10.03.00.0000','TRANSFERÊNCIAS VOLUNTARIAS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A TRANSFERÊNCIAS VOLUNTARIAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.10.04.00.0000','AMORTIZAÇÃO DA DIVIDA','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A AMORTIZAÇÃO DA DIVIDA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.10.05.00.0000','RESSARCIMENTOS E RESTITUIÇÕES','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A RESSARCIMENTOS E RESTITUIÇÕES.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.04.10.09.00.0000','NÃO APLICAVEL - OUTRAS DESPESAS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A OUTRAS DESPESAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.06.00.00.00.0000','EMPENHOS POR CREDOR','COMPREENDE O SOMATARIO DOS VALORES DOS EMPENHOS EMITIDOS CONTROLADOS POR BENEFICIARIOS DO EMPENHO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.2.2.9.2.06.01.00.00.0000','VALORES COMPROMETIDOS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS CONTROLADOS POR BENEFICIARIO DO EMPENHO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.3.0.0.0.00.00.00.00.0000','INSCRIÇÃO DE RESTOS A PAGAR','COMPREENDE O SOMATÓRIO RELATIVO AO VALOR DA INSCRIÇÃO DAS DESPESAS EMPENHADAS E NÃO PAGAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.3.1.0.0.00.00.00.00.0000','INSCRIÇÃO DE RP NÃO PROCESSADOS','COMPREENDE O SOMATÓRIO DOS VALORES INSCRITOS EM RESTOS A PAGAR NÃO-PROCESSADOS RELATIVOS AS DESPESAS EMPENHADAS E NÃO LIQUIDADAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.3.1.1.0.00.00.00.00.0000','RP NÃO PROCESSADOS INSCRITOS','REGISTRA OS VALORES INSCRITOS EM RESTOS A PAGAR NÃO PROCESSADOS RELATIVOS AS DESPESAS EMPENHADAS E NÃO LIQUIDADAS ATE O ULTIMO DIA DO EXERCÍCIO FINANCEIRO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.3.1.2.0.00.00.00.00.0000','RP NÃO PROCESSADOS - EXERCÍCIOS ANTERIORES','REGISTRA O VALOR DE RESTOS A PAGAR NÃO PROCESSADOS RELATIVO A EXERCÍCIOS ANTERIORES QUE NÃO FORAM CANCELADOS PORQUE TIVERAM SEU PRAZO DE VALIDADE PRORROGADO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.3.1.3.0.00.00.00.00.0000','RP NÃO PROCESSADOS RESTABELECIDOS','REGISTRA O VALOR POR RESTABELECIMENTO DE EMPENHO DE RESTOS A PAGAR JA CANCELADOS EM EXERCÍCIOS ANTERIORES COM BASE EM ATO NORMATIVO ESPECIFICO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.3.1.6.0.00.00.00.00.0000','RP NÃO PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','REGISTRA O VALOR DA TRANSFERÊNCIA DE RESTOS A PAGAR NÃO PROCESSADOS DECORRENTE DE TRANSFORMAÇÃO, CISAO, FUSAO E EXTINÇÃO DE ORGÃOS OU UG.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.3.1.7.0.00.00.00.00.0000','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','REGISTRA O VALOR DAS DESPESAS EMPENHADAS INSCRITAS NO EXERCÍCIO COMO RESTOS A PAGAR NÃO PROCESSADOS, A SER TRANSFERIDO PARA O EXERCÍCIO SEGUINTE PARA A CONTA 5.3.1.1.0.00.00.00.00.0000','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.3.2.0.0.00.00.00.00.0000','INSCRIÇÃO DE RP PROCESSADOS','COMPREENDE O SOMATÓRIO DOS VALORES INSCRITOS EM RESTOS A PAGAR PROCESSADOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.3.2.1.0.00.00.00.00.0000','RP PROCESSADOS - INSCRITOS','REGISTRA O SOMATÓRIO DOS VALORES INSCRITOS EM RESTOS A PAGAR PROCESSADOS RELATIVOS AS DESPESAS EMPENHADAS, LIQUIDADAS E NÃO PAGAS NO EXERCÍCIO FINANCEIRO EM QUE FOI EMPENHADO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.3.2.2.0.00.00.00.00.0000','RP PROCESSADOS - EXERCÍCIOS ANTERIORES','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS RELATIVOS AS DESPESAS EMPENHADAS, LIQUIDADAS E NÃO PAGAS NO EXERCÍCIO FINANCEIRO SUBSEQUENTE.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.3.2.6.0.00.00.00.00.0000','RP PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','REGISTRA O VALOR DA TRANSFERÊNCIA DE RESTOS A PAGAR PROCESSADOS DECORRENTE DE TRANSFORMAÇÃO, CISAO, FUSAO E EXTINÇÃO DE ORGÃOS OU UG.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '5.3.2.7.0.00.00.00.00.0000','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','REGISTRA O VALOR DAS DESPESAS EMPENHADAS INSCRITAS NO EXERCÍCIO COMO RESTOS A PAGAR NÃO PROCESSADOS, A SER TRANSFERIDO PARA O EXERCÍCIO SEGUINTE PARA A CONTA 5.3.2.1.0.00.00.00.00.0000','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.0.0.0.0.00.00.00.00.0000','CONTROLES DA EXECUÇÃO DO PLANEJAMENTO E ORCAMENTO','COMPREENDE AS CONTAS COM FUNÇÃO DE REGISTRAR OS ATOS E FATOS LIGADOS A EXECUÇÃO ORCAMENTARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.0.0.0.00.00.00.00.0000','EXECUÇÃO DO PLANEJAMENTO','COMPREENDE O SOMATÓRIO DOS VALORES MONETARIOS RELATIVOS A EXECUÇÃO DOS PROGRAMAS E AÇÕES (PROJETOS, ATIVIDADES E OPERAÇÕES ESPECIAIS) ESTABELECIDOS NO PLANO PLURIANUAL E PROJETO DE LEI ORCAMENTARIA ANUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.1.0.0.00.00.00.00.0000','EXECUÇÃO DO PPA','COMPREENDE O SOMATÓRIO DOS VALORES MONETARIOS RELATIVOS A EXECUÇÃO DOS PROGRAMAS E AÇÕES (PROJETOS, ATIVIDADES E OPERAÇÕES ESPECIAIS) ESTABELECIDOS NO PLANO PLURIANUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.1.1.0.00.00.00.00.0000','PPA A ALOCAR NO PLOA','REGISTRA O SOMATÓRIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL DURANTE O SEU PERIODO DE VIGENCIA DETALHADO POR PROGRAMAS DE TRABALHO A SEREM SELECIONADOS NA ELABORAÇÃO DO PLOA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.1.2.0.00.00.00.00.0000','PPA ALOCADO NA LOA','REGISTRA O SOMATÓRIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL APROVADO, DETALHADO POR PROGRAMA DE TRABALHO ALOCADO NA LOA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.1.3.0.00.00.00.00.0000','PPA EXECUTADO','REGISTRA O SOMATÓRIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL EXECUTADO NO SEU PERIODO DE VIGENCIA, DETALHADO POR PROGRAMA DE TRABALHO AUTORIZADO NAS LEIS ORCAMENTARIAS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.2.0.0.00.00.00.00.0000','EXECUÇÃO DO PLOA','COMPREENDE O SOMATÓRIO DOS VALORES MONETARIOS DE RECEITAS E DESPESAS PREVISTOS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.2.1.0.00.00.00.00.0000','PROCESSAMENTO DO PLOA -RECEITA','COMPREENDE O SOMATÓRIO DOS VALORES MONETARIOS DAS RECEITAS PREVISTAS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.2.1.1.00.00.00.00.0000','PLOA COM INDICADOR DE RESULTADO - RECEITA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS DA RECEITA PREVISTOS NO PROJETO DE LEI ORCAMENTARIA COM INDICADOR DE RESULTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.2.1.1.01.00.00.00.0000','PROJ.INICIAL DA LEI ORCAMENT.C/ INDIC.RESULT.','REGISTRA OS VALORES MONETARIOS DA RECEITA PREVISTOS NO PROJETO INICIAL DE LEI ORCAMENTARIA COM INDICADOR DE RESULTADO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.2.1.1.02.00.00.00.0000','PROJ.FINAL DA LEI ORCAMENT.C/ INDIC.RESULT.','REGISTRA OS VALORES MONETARIOS DA RECEITA PREVISTOS NO PROJETO FINAL DA LEI ORCAMENTARIA COM INDICADOR DE RESULTADO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.2.1.2.00.00.00.00.0000','PLOA SEM INDICADOR DE RESULTADO - RECEITA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS PREVISTOS NO PROJETO DE LEI ORCAMENTARIA SEM INDICADOR DE RESULTADO - RECEITA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.2.1.2.01.00.00.00.0000','PROJ.INICIAL DA LEI ORCAMENT.S/ INDIC.RESULT.','REGISTRA OS VALORES MONETARIOS DA RECEITA PREVISTOS NO PROJETO INICIAL DA LEI ORCAMENTARIA SEM INDICADOR DE RESULTADO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.2.1.2.02.00.00.00.0000','PROJ.FINAL DA LEI ORCAMENT.S/ INDIC.RESULT.','REGISTRA OS VALORES MONETARIOS PREVISTOS NO PROJETO FINAL DA LEI ORCAMENTARIA SEM INDICADOR DE RESULTADO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.2.2.0.00.00.00.00.0000','PROCESSAMENTO DO PLOA -DESPESA','COMPREENDE O SOMATÓRIO DOS VALORES MONETARIOS FIXADOS PARA AS DESPESAS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.2.2.1.00.00.00.00.0000','PLOA COM INDICADOR DE RESULTADO - DESPESA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS FIXADOS PARA A DESPESA NO PROJETO DE LEI ORCAMENTARIA COM INDICADOR DE RESULTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.2.2.1.01.00.00.00.0000','PROJ.INICIAL DA LEI ORCAMENT.C/ INDIC.RESULT.','REGISTRA OS VALORES PERTINENTES AOS CREDITOS DO PROJETO INICIAL DA LEI ORCAMENTARIA COM INDICADOR DE RESULTADO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.2.2.1.02.00.00.00.0000','PROJ.FINAL DA LEI ORCAMENT.C/ INDIC.RESULT.','REGISTRA OS VALORES PERTINENTES AOS CREDITOS DO PROJETO FINAL DA LEI ORCAMENTARIA COM INDICADOR DE RESULTADO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.2.2.2.00.00.00.00.0000','PLOA SEM INDICADOR DE RESULTADO - DESPESA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS FIXADOS PARA A DESPESA NO PROJETO DE LEI ORCAMENTARIA SEM INDICADOR DE RESULTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.2.2.2.01.00.00.00.0000','PROJ.INICIAL DA LEI ORCAMENT.S/ INDIC.RESULT.','REGISTRA OS VALORES PERTINENTES AOS CREDITOS DO PROJETO INICIAL DA LEI ORCAMENTARIA SEM INDICADOR DE RESULTADO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.1.2.2.2.02.00.00.00.0000','PROJ.FINAL DA LEI ORCAMENT.S/ INDIC.RESULT.','REGISTRA OS VALORES PERTINENTES AOS CREDITOS DO PROJETO FINAL DA LEI ORCAMENTARIA SEM INDICADOR DE RESULTADO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.0.0.0.00.00.00.00.0000','EXECUÇÃO DO ORCAMENTO','COMPREENDE O SOMATÓRIO DOS VALORES RELATIVOS A REALIZAÇÃO DA RECEITA, EXECUÇÃO DA DESPESA E SUAS ALTERAÇÕES NO ORÇAMENTO GERAL DA UNIAO DURANTE O EXERCÍCIO FINANCEIRO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.1.0.0.00.00.00.00.0000','EXECUÇÃO DA RECEITA','COMPREENDE O SOMATÓRIO DOS VALORES RELATIVOS A REALIZAÇÃO DA RECEITA PÚBLICA APROVADA PELA LEI ORCAMENTARIA ANUAL E SUAS ALTERAÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.1.1.0.00.00.00.00.0000','RECEITA A REALIZAR','REGISTRA O SOMATÓRIO DOS VALORES RELATIVOS A RECEITA PÚBLICA APROVADA PELA LEI ORCAMENTARIA ANUAL E SUAS ALTERAÇÕES, DETALHADA POR NATUREZA DA RECEITA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.1.2.0.00.00.00.00.0000','RECEITA REALIZADA','REGISTRA O SOMATÓRIO DOS VALORES RELATIVOS AS RECEITAS REALIZADAS, DETALHADA POR NATUREZA DE RECEITA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.1.3.0.00.00.00.00.0000','(-) DEDUCOES DA RECEITA ORCAMENTARIA','COMPREENDE O SOMATÓRIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS (TRANSFERÊNCIA, RESTITUIÇÕES,RENUNCIAS E OUTRAS ....), DETALHADA POR NATUREZA DE RECEITA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.1.3.1.00.00.00.00.0000','(-) DEDUÇÕES POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS','COMPREENDE O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS, DETALHADA POR NATUREZA DE RECEITA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.1.3.1.01.00.00.00.0000','(-) FUNDEB','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR TRANSFERÊNCIAS AO FUNDEB.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.1.3.1.02.00.00.00.0000','(-) TRANSFERÊNCIAS CONSTITUCIONAIS A MUNICÍPIOS','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR TRANSFERÊNCIAS CONSTITUCIONAIS AOS MUNICÍPIOS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.1.3.1.03.00.00.00.0000','(-) RENÚNCIA','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR RENUNCIA, DETALHADA POR NATUREZA DE RECEITA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.1.3.1.09.00.00.00.0000','(-) OUTRAS DEDUCOES DA RECEITA REALIZADA','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS OUTRAS DEDUCOES DE RECEITAS REALIZADAS, DETALHADA POR NATUREZA DE RECEITA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.0.0.00.00.00.00.0000','EXECUÇÃO DA DESPESA','COMPREENDE O SOMATÓRIO DA DISPONIBILIDADE DE CRÉDITO ORCAMENTARIO E DA EXECUÇÃO DA DESPESA EM SUAS DIVERSAS ETAPAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.0.00.00.00.00.0000','DISPONIBILIDADES DE CRÉDITO','COMPREENDE O SOMATÓRIO DA DISPONIBILIDADE DE CRÉDITO ORCAMENTARIO E SUAS ALTERAÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.1.00.00.00.00.0000','CRÉDITO DISPONIVEL','REGISTRA O VALOR DA DISPONIBILIDADE DE CRÉDITO REFERENTE A DOTAÇÃO INICIAL E ADICIONAL APROVADA NO ORÇAMENTO GERAL DA UNIAO NA LOA OU LEI ESPECIFICA OU ANTECIPADA PELA LEI DE DIRETRIZES ORCAMENTARIAS - LDO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.2.00.00.00.00.0000','CRÉDITO INDISPONIVEL','COMPREENDE O VALOR DA INDISPONIBILIDADE DE CRÉDITO ORCAMENTARIO PELO SEU CONTINGENCIAMENTO OU LIBERAÇÃO PENDENTES DE AUTORIZAÇÃO LEGISLATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.2.01.00.00.00.0000','RESERVA DE EMPENHOS','COMPREENDE O VALOR DA DISPONIBILIDADE DE CRÉDITOS ORCAMENTARIOS POR CONTENCAO OU CONTINGENCIAMENTO PELA SETORIAL ORCAMENTARIA, SOF E OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.2.01.01.00.00.0000','CRÉDITO BLOQUEADO PARA REMANEJAMENTO','REGISTRA O VALOR DA INDISPONIBILIDADE DE CRÉDITOS ORCAMENTARIOS PELA SETORIAIS DE ORÇAMENTO PARA REMANEJAMENTO DE FONTE OU GRUPO DE DESPESA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.2.01.02.00.00.0000','CRÉDITO BLOQUEADO PARA CONTROLE INTERNO','REGISTRA OS VALORES DE CRÉDITOS INDISPONIBILIZADOS INTERNAMENTE PELOS ORGÃOS PARA CONTROLE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.2.01.99.00.00.0000','OUTRAS INDISPONIBILIDADES','REGISTRA O VALOR DAS INDISPONIBILIDADES DE CRÉDITOS ORCAMENTARIOS DE NATUREZA EVENTUAL, PARA AS QUAIS NÃO HA CONTAS ESPECIFICAS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.3.00.00.00.00.0000','CRÉDITO UTILIZADO','COMPREENDE O SOMATÓRIO DOS VALORES REFERENTES AOS CRÉDITOS ORCAMENTARIOS EMPENHADOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.3.01.00.00.00.0000','CRÉDITO EMPENHADO A LIQUIDAR','REGISTRA O VALOR DA DESPESA EMPENHADA A SER LIQUIDADA','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.3.02.00.00.00.0000','CRÉDITO EMPENHADO EM LIQUIDAÇÃO','REGISTRA O VALOR DA DESPESA CUJO FATO GERADOR JA OCORREU, MAS QUE AINDA NÃO FORAM CONFERIDOS O OBJETO, O CREDOR E O VALOR, OU SEJA, NÃO HOUVE A LIQUIDAÇÃO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.3.03.00.00.00.0000','CRÉDITO EMPENHADO LIQUIDADO A PAGAR','REGISTRA O VALOR DA APROPRIAÇÃO DAS DESPESAS EMPENHADAS COM POSTERIOR VERIFICAÇÃO DE SUA REGULARIDADE POR CONSTITUICAO DO DIRETO DO CREDOR.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.3.04.00.00.00.0000','CRÉDITO EMPENHADO LIQUIDADO – PAGO','DEMONSTRA VALOR DA DESPESA EMPENHADA LIQUIDADA PAGA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.3.05.00.00.00.0000','EMPENHOS A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NÃO PROCESSADOS','REGISTRA O MONTANTE DOS VALORES A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NÃO PROCESSADOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.3.06.00.00.00.0000','EMPENHOS EM LIQUIDAÇÃO INSCRITOS EM RESTOS A PAGAR NÃO PROCESSADOS','REGISTRA O MONTANTE DOS VALORES EM LIQUIÇÃO INSCRITOS EM RESTOS A PAGAR NÃO PROCESSADOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.3.07.00.00.00.0000','EMPENHOS LIQUIDADOS INSCRITOS EM RESTOS A PAGAR PROCESSADOS','REGISTRA O MONTANTE DOS VALORES A LIQUIDAR INSCRITOS EM RESTOS A PAGAR PROCESSADOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.1.3.99.00.00.00.0000','(-) OUTROS CRÉDITOS UTILIZADOS','REGISTRA A CONTRAPARTIDA DE DESPESAS REALIZADAS PELAS ENTIDADES OU ORGÃO DA ADM. DIRETA/INDIRETA QUE UTILIZAM O SIAFI NO MODULO PARCIAL. REGISTRA A CONTRAPARTIDA DE DESPESAS LIQUIDADAS NA ROTINA DE SUPRIMENTO DE FUNDOS PARA EVITAR A EMISSAO DE LISTA DE ITEM (LI) PARA RECLASSIFICAÇÃO DA DESPESA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.0.00.00.00.00.0000','MOVIMENTAÇÃO DE CRÉDITOS CONCEDIDOS','REGISTRA O SOMATÓRIO DOS VALORES DOS CRÉDITOS ORCAMENTARIOS CONCEDIDOS ATRAVES DE DESTAQUE, PROVISAO OU POR FUSAO, CISAO OU EXTINÇÃO DE UNIDADES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.1.00.00.00.00.0000','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISAO','COMPREENDE OS VALORES DOS CRÉDITOS DESCENTRALIZADOS DAS UNIDADES ORCAMENTARIAS PARA AS UNIDADES ADMINISTRATIVAS SOB SUA JURISDICAO OU ENTRE ESTAS, NO AMBITO DO PROPRIO MINISTERIO, SECRETARIA OU ORGÃO EQUIVALENTE, CONCEDIDOS AO LONGO DO EXERCÍCIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.1.01.00.00.00.0000','PROVISAO CONCEDIDA','REGISTRA O CRÉDITO CONCEDIDO PELA UNIDADE ORCAMENTARIA A PARTIR DE SUA PROPRIA DOTAÇÃO OU DE UM DESTAQUE A SEU FAVOR, PARA UNIDADE ADMINISTRATIVA OU ORCAMENTARIA, NO AMBITO DO PROPRIO ENTE OU ORGÃO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.1.02.00.00.00.0000','PROVISAO CONCEDIDA - BLOQUEADA','REGISTRA O BLOQUEIO DOS CREDITOS ORCAMENTARIOS CONCEDIDOS MEDIANTE PROVISAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.1.09.00.00.00.0000','ALTERACAO DE CREDITOS MOVIMENTADOS','COMPREENDE O VALOR DA VARIACAO DE CREDITOS ORCAMENTARIOS DISPONIVEIS POR ACRESCIMO OU REDUCAO DO QUADRO DE DETALHAMENTO DE DESPESA, POR UG PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.1.09.01.00.00.0000','ACRESCIMO','REGISTRA O VALOR DO ACRESCIMO DE CREDITO DISPONIVEL DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD, POR UG PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.1.09.02.00.00.0000','(-) REDUCAO','REGISTRA O VALOR DA REDUCAO DE CREDITO DISPONIVEL DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA, POR UG PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.2.00.00.00.00.0000','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','COMPREENDE A DESCENTRALIZAÇÃO DO CRÉDITO INICIAL OU ADICIONAL CONCEDIDO DE UNIDADES OU ORGÃOS PERTENCENTES A MINISTERIOS, SECRETARIAS E ORGÃOS EQUIVALENTES DISTINTOS OU ENTRE ESTES E ENTIDADES DA ADMINISTRAÇÃO INDIRETA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.2.01.00.00.00.0000','ADMINISTRAÇÃO DIRETA','REGISTRA O VALOR REFERENTE AO MOVIMENTO DE CRÉDITOS DECORRENTES DE CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGÃO DA ADMINISTRAÇÃO DIRETA TRANSFERIDORA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.2.01.01.00.00.0000','CRÉDITOS CONCEDIDOS','REGISTRA O VALOR REFERENTE A MOVIMENTAÇÃO DE CRÉDITOS DECORRENTES DE CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGÃO DA ADMINISTRAÇÃO DIRETA TRANSFERIDORA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.2.02.00.00.00.0000','ADMINISTRAÇÃO INDIRETA','REGISTRA O VALOR REFERENTE AO MOVIMENTO DE CRÉDITOS DECORRENTES DE CONCESSAO PELA UNIDADE ORCAMENTARIA DA ENTIDADE DA ADMINISTRAÇÃO INDIRETA TRANSFERIDORA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.2.02.01.00.00.0000','CRÉDITOS CONCEDIDOS','REGISTRA O VALOR REFERENTE A MOVIMENTAÇÃO DE CRÉDITOS DECORRENTES DE SUA CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGÃO DA ADMINISTRAÇÃO INDIRETA TRANSFERIDORA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.2.09.00.00.00.0000','ALTERACAO DE CREDITOS MOVIMENTADOS','COMPREENDE O VALOR DA VARIACAO DE CREDITOS ORCAMENTARIOS DISPONIVEIS POR ACRESCIMO OU REDUCAO DO QUADRO DE DETALHAMENTO DE DESPESA, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.2.09.01.00.00.0000','ACRESCIMO','REGISTRA O VALOR DO ACRESCIMO DE CREDITO DISPONIVEL DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.2.09.02.00.00.0000','(-) REDUCAO','REGISTRA O VALOR DA REDUCAO DE CREDITO DISPONIVEL DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.2.9.00.00.00.00.0000','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','COMPREENDE AS MOVIMENTAÇÕES DE CRÉDITOS CONCEDIDOS POR CISAO, FUSAO, EXTINÇÃO, COMPENSAÇÃO E OUTRAS TRANSAÇÕES.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.3.0.00.00.00.00.0000','DETALHAMENTO DE CRÉDITO','REGISTRA O DETALHAMENTO DAS DOTAÇÕES ORCAMENTARIAS RELATIVAS A CADA PROGRAMA DE TRABALHO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.3.1.00.00.00.00.0000','CREDITOS DETALHADOS','REGISTRA O VALOR DOS CREDITOS DETALHADOS POR FONTE DE RECURSOS, UG RESPONSAVEL E NATUREZA DE DESPESA (ELEMENTO DE DESPESA E / OU MODALIDADE DE APLICACAO).','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.0.00.00.00.00.0000','OUTROS CONTROLES DA DESPESA ORCAMENTARIA','COMPREENDE O SOMATÓRIO DOS VALORES EXECUTADOS DAS DESPESAS PRE-EMPENHADAS E EMPENHADAS POR DETALHAMENTO ESPECIFICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.00.00.00.00.0000','EMISSAO DE EMPENHO','COMPREENDE O SOMATÓRIO DOS VALORES EXECUTADOS DAS DESPESAS EMPENHADAS POR DETALHAMENTO ESPECIFICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.02.00.00.00.0000','EMPENHOS POR NOTA DE EMPENHO','COMPREENDE O VALOR DA EMISSAO DE DOCUMENTOS ATRAVES DOS QUAIS SAO REGISTRADOS OS ESTÁGIOS DAS DESPESAS ORCAMENTARIAS REALIZADAS PELA ADMINISTRAÇÃO PÚBLICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.02.01.00.00.0000','EMPENHOS A LIQUIDAR','REGISTRA O VALOR DOS EMPENHOS DE DESPESAS PENDENTES DE LIQUIDAÇÃO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.02.02.00.00.0000','EMPENHOS EM LIQUIDAÇÃO','REGISTRA O SOMATÓRIO DAS DESPESAS CUJO FATO GERADOR TENHA OCORRIDO, TENDO INICIADO E NÃO CONCLUIDO O PROCESSO DE LIQUIDAÇÃO DA DESPESA ORCAMENTARIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.02.03.00.00.0000','EMPENHOS LIQUIDADOS','REGISTRA O VALOR DOS EMPENHOS APOS VERIFICAÇÃO DO DIREITO ADQUIRIDO PELO CREDOR OU ENTIDADE BENEFICIARIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.02.04.00.00.0000','EMPENHOS LIQUIDADOS PAGOS','REGISTRA O VALOR DOS EMPENHOS APOS VERIFICAÇÃO DO DIREITO ADQUIRIDO PELO CREDOR E PAGO A ENTIDADE BENEFICIARIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.02.07.00.00.0000','ANULAÇÃO DE EMPENHOS','REGISTRA O VALOR REFERENTE A REVERSAO TOTAL OU PARCIAL DE DESPESA ORCAMENTARIA A DOTAÇÃO CORRESPONDENTE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.02.08.00.00.0000','CANCEL. DE EMPENHO POR FALTA DE DISPON. CAIXA','REGISTRA O VALOR REFERENTE A REVERSAO TOTAL OU PARCIAL DE DESPESA ORCAMENTARIA A DOTAÇÃO CORRESPONDENTE POR FALTA DE DISPONIBILIDADE DE CAIXA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.02.09.00.00.0000','EXECUÇÃO DA RESERVA DE EMPENHO','COMPREENDE O VALOR DAS RESERVAS DE EMPENHO (PED) REALIZADAS NO EXERCÍCIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.02.09.01.00.0000','RESERVAS DE EMPENHO A EMPENHAR','COMPREENDE O VALOR DAS RESERVAS DE EMPENHO (PED) REALIZADAS NO EXERCÍCIO A EMPENHAR','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.02.09.02.00.0000','RESERVAS DE EMPENHO EMPENHADAS','COMPREENDE O VALOR DAS RESERVAS DE EMPENHO (PED) REALIZADAS NO EXERCÍCIO JÁ EMPENHADAS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.02.10.00.00.0000','EMPENHOS A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS','REGISTRA O MONTANTE DOS VALORES A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS, CONTROLADOS POR NOTA DE EMPENHO E SUBITEM.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.02.11.00.00.0000','EMPENHOS EM LIQUIDACAO INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS','REGISTRA O MONTANTE DOS VALORES EM LIQUIDACAO INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS, CONTROLADOS POR NOTA DE EMPENHO E SUBITEM.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.02.12.00.00.0000','EMPENHOS LIQUIDADOS INSCRITOS EM RESTOS A PAGAR PROCESSADOS','REGISTRA O MONTANTE DOS VALORES LIQUIDADOS INSCRITOS EM RESTOS A PAGAR PROCESSADOS, CONTROLADOS POR NOTA DE EMPENHO E SUBITEM.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.00.00.00.0000','EMPENHOS P/ MOD. DE LICITAÇÃO - A LIQUIDAR','COMPREENDE O VALOR DOS EMPENHOS A LIQUIDAR, COM CONTROLE POR MODALIDADE DE LICITAÇÃO OU POR SUA DISPENSA OU INEXIGIBILIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.01.00.00.0000','CONCORRENCIA','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITAÇÃO - CONCORRENCIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.02.00.00.0000','TOMADA DE PRECOS','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITAÇÃO - TOMADA DE PRECOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.03.00.00.0000','CONVITE','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITAÇÃO-CONVITE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.04.00.00.0000','CONCURSO','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITAÇÃO-CONCURSO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.05.00.00.0000','PREGAO','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS NA MODALIDADE DE PREGAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.06.00.00.0000','CONSULTA','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS NA MODALIDADE DE CONSULTA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.07.00.00.0000','DISPENSAVEL POR LIMITE','REGISTRA O VALOR DO EMPENHOS A LIQUIDAR, CONTROLADOS POR DISPENSA DE LICITAÇÃO NO ASPECTO RELACIONADO AOS LIMITES MONETARIOS DE DISPENSA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.08.00.00.0000','OUTRAS DISPENSAS DE LICITAÇÃO','REGISTRA O VALOR DO EMPENHOS A LIQUIDAR, CONTROLADOS POR DISPENSA DE LICITAÇÃO EXCETO AQUELES RELACIONADOS AOS LIMITES MONETARIOS DE DISPENSA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.09.00.00.0000','LICITAÇÃO INEXIGIVEL','REGISTRA O VALOR DO EMPENHOS A LIQUIDAR, CONTROLADOS POR INEXIGIBILIDADE DE LICITAÇÃO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.10.00.00.0000','NÃO APLICAVEL','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, ONDE NÃO SE APLICA A LICITAÇÃO, DENTRE OS QUAIS CABE DESTACAR: PESSOAL E ENCARGOS SOCIAIS, TRANSFERÊNCIAS CONSTITUCIONAIS, TRANSFERÊNCIAS VOLUNTARIAS, AMORTIZAÇÃO DA DÍVIDA E RESSARCIMENTO E RESTITUIÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.10.01.00.0000','SUPRIMENTOS DE FUNDOS','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR DESTINADOS A ATENDER SUPRIMENTOS DE FUNDOS, NA FORMA DA LEGISLAÇÃO EM VIGOR.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.10.02.00.0000','PESSOAL E ENCARGOS SOCIAIS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A PESSOAL E ENCARGOS SOCIAIS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.10.03.00.0000','TRANSFERÊNCIAS VOLUNTARIAS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A TRANSFERÊNCIAS VOLUNTARIAS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.10.04.00.0000','AMORTIZAÇÃO DA DIVIDA','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A AMORTIZAÇÃO DA DIVIDA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.10.05.00.0000','RESSARCIMENTOS E RESTITUIÇÕES','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A RESSARCIMENTOS E RESTITUIÇÕES.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.04.10.09.00.0000','NÃO APLICAVEL - OUTRAS DESPESAS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A OUTRAS DESPESAS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.00.00.00.0000','EMPENHOS P/ MOD. DE LICITAÇÃO - EM LIQUIDAÇÃO','COMPREENDE O VALOR DOS EMPENHOS A LIQUIDAR, COM CONTROLE POR MODALIDADE DE LICITAÇÃO OU POR SUA DISPENSA OU INEXIGIBILIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.01.00.00.0000','CONCORRENCIA','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITAÇÃO - CONCORRENCIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.02.00.00.0000','TOMADA DE PRECOS','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITAÇÃO - TOMADA DE PRECOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.03.00.00.0000','CONVITE','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITAÇÃO-CONVITE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.04.00.00.0000','CONCURSO','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITAÇÃO-CONCURSO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.05.00.00.0000','PREGAO','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS NA MODALIDADE DE PREGAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.06.00.00.0000','CONSULTA','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS NA MODALIDADE DE CONSULTA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.07.00.00.0000','DISPENSAVEL POR LIMITE','REGISTRA O VALOR DO EMPENHOS A LIQUIDAR, CONTROLADOS POR DISPENSA DE LICITAÇÃO NO ASPECTO RELACIONADO AOS LIMITES MONETARIOS DE DISPENSA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.08.00.00.0000','OUTRAS DISPENSAS DE LICITAÇÃO','REGISTRA O VALOR DO EMPENHOS A LIQUIDAR, CONTROLADOS POR DISPENSA DE LICITAÇÃO EXCETO AQUELES RELACIONADOS AOS LIMITES MONETARIOS DE DISPENSA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.09.00.00.0000','LICITAÇÃO INEXIGIVEL','REGISTRA O VALOR DO EMPENHOS A LIQUIDAR, CONTROLADOS POR INEXIGIBILIDADE DE LICITAÇÃO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.10.00.00.0000','NÃO APLICAVEL','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, ONDE NÃO SE APLICA A LICITAÇÃO, DENTRE OS QUAIS CABE DESTACAR: PESSOAL E ENCARGOS SOCIAIS, TRANSFERÊNCIAS CONSTITUCIONAIS, TRANSFERÊNCIAS VOLUNTARIAS, AMORTIZAÇÃO DA DÍVIDA E RESSARCIMENTO E RESTITUIÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.10.01.00.0000','SUPRIMENTOS DE FUNDOS','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR DESTINADOS A ATENDER SUPRIMENTOS DE FUNDOS, NA FORMA DA LEGISLAÇÃO EM VIGOR.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.10.02.00.0000','PESSOAL E ENCARGOS SOCIAIS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A PESSOAL E ENCARGOS SOCIAIS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.10.03.00.0000','TRANSFERÊNCIAS VOLUNTARIAS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A TRANSFERÊNCIAS VOLUNTARIAS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.10.04.00.0000','AMORTIZAÇÃO DA DIVIDA','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A AMORTIZAÇÃO DA DIVIDA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.10.05.00.0000','RESSARCIMENTOS E RESTITUIÇÕES','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A RESSARCIMENTOS E RESTITUIÇÕES.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.05.10.09.00.0000','NÃO APLICAVEL - OUTRAS DESPESAS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A OUTRAS DESPESAS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.00.00.00.0000','EMPENHO P/ MODALID. DE LICITAÇÃO - LIQUIDADO','COMPREENDE O VALOR DOS EMPENHOS LIQUIDADOS, COM CONTROLE POR MODALIDADE DE LICITAÇÃO OU POR SUA DISPENSA OU INEXIGIBILIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.01.00.00.0000','CONCORRENCIA','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITAÇÃO-CONCORRENCIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.02.00.00.0000','TOMADA DE PRECOS','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITAÇÃO-TOMADA DE PRECOS .','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.03.00.00.0000','CONVITE','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITAÇÃO-CONVITE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.04.00.00.0000','CONCURSO','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITAÇÃO-CONCURSO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.05.00.00.0000','PREGAO','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITAÇÃO-PREGAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.06.00.00.0000','CONSULTA','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITAÇÃO-CONSULTA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.07.00.00.0000','DISPENSAVEL POR LIMITE','REGISTRA O VALOR DO EMPENHOS A LIQUIDADOS, CONTROLADOS POR DISPENSA DE LICITAÇÃO NO ASPECTO RELACIONADO AOS LIMITES MONETARIOS DE DISPENSA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.08.00.00.0000','OUTRAS DISPENSAS DE LICITAÇÃO','REGISTRA O VALOR DO EMPENHOS A LIQUIDADOS, CONTROLADOS POR DISPENSA DE LICITAÇÃO EXCETO AQUELES RELACIONADOS AOS LIMITES MONETARIOS DE DISPENSA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.09.00.00.0000','LICITAÇÃO INEXIGIVEL','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR INEXIGIBILIDADE DE LICITAÇÃO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.10.00.00.0000','NÃO APLICAVEL','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, ONDE NÃO SE APLICA A LICITAÇÃO, DENTRE OS QUAIS CABE DESTACAR: PESSOAL E ENCARGOS SOCIAIS, TRANSFERÊNCIAS CONSTITUCIONAIS, TRANSFERÊNCIAS VOLUNTARIAS, AMORTIZAÇÃO DA DÍVIDA E RESSARCIMENTO E RESTITUIÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.10.01.00.0000','SUPRIMENTOS DE FUNDOS','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR DESTINADOS A ATENDER SUPRIMENTOS DE FUNDOS, NA FORMA DA LEGISLAÇÃO EM VIGOR.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.10.02.00.0000','PESSOAL E ENCARGOS SOCIAIS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A PESSOAL E ENCARGOS SOCIAIS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.10.03.00.0000','TRANSFERÊNCIAS VOLUNTARIAS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A TRANSFERÊNCIAS VOLUNTARIAS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.10.04.00.0000','AMORTIZAÇÃO DA DIVIDA','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A AMORTIZAÇÃO DA DIVIDA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.10.05.00.0000','RESSARCIMENTOS E RESTITUIÇÕES','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A RESSARCIMENTOS E RESTITUIÇÕES.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.06.10.09.00.0000','NÃO APLICAVEL - OUTRAS DESPESAS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZAÇÃO DE DESPESAS EM QUE NÃO SE APLICA A LICITAÇÃO, REFERENTES A OUTRAS DESPESAS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.07.00.00.00.0000','EMPENHOS POR CREDOR','COMPREENDE O SOMATÓRIO DA EXECUÇÃO DE CRÉDITOS ORCAMENTARIOS, CONTROLADOS POR BENEFICIARIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.07.01.00.00.0000','VALORES A LIQUIDAR','REGISTRA O MONTANTE DOS VALORES A LIQUIDAR, A SEREM PAGOS, POR BENEFICIARIOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.07.02.00.00.0000','VALORES EM LIQUIDAÇÃO','REGISTRA O SOMATÓRIO DAS DESPESAS CUJO FATO GERADOR TENHA OCORRIDO, TENDO INICIADO E NÃO CONCLUIDO O PROCESSO DE LIQUIDAÇÃO DA DESPESA ORCAMENTARIA, CONTROLADOS POR BENEFICIARIO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.07.03.00.00.0000','VALORES LIQUIDADOS A PAGAR','REGISTRA O MONTANTE DOS VALORES LIQUIDADOS, A SEREM PAGOS, POR BENEFICIARIOS. O SALDO DESTA CONTA EM 31 DE DEZEMEBRO SERA TRANSFERIDO PARA A CONTA 532110000 - RP PROCESSADO INSCRITO EM 01 DE JANEIRO DO EXERCÍCIO SUBSEQUENTE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.07.04.00.00.0000','VALORES PAGOS','REGISTRA O MONTANTE DOS VALORES PAGOS, CONTROLADOS POR BENEFICIARIOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.07.05.00.00.0000','EMPENHOS INSCRITOS EM RESTOS A PAGAR','REGISTRA O MONTANTE DOS VALORES DOS EMPENHOS INSCRITOS EM RESTOS A PAGAR, CONTROLADOS POR BENEFICIARIO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.09.00.00.00.0000','EMPENHOS DE RESTOS A PAGAR - POR CREDOR','REGISTRA O VALOR DOS EMPENHOS DE RESTOS A PAGAR, CONTROLADOS POR BENEFICIARIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.09.01.00.00.0000','RESTOS A PAGAR A LIQUIDAR','REGISTRA O VALOR DOS EMPENHOS DE RESTOS A PAGAR INSCRITOS NO ENCERRAMENTO DO EXERCÍCIO FINANCEIRO DE EMISSAO DA NOTA DE EMPENHO E TRANSFERIDOS AUTOMATICAMENTE DA CONTA 292410505.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.09.02.00.00.0000','RESTOS A PAGAR LIQUIDADOS - NO EXERCÍCIO CORRENTE','REGISTRA O VALOR DOS RESTOS A PAGAR, CONTROLADOS POR BENEFICIARIO LIQUIDADOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.09.03.00.00.0000','RESTOS A PAGAR PAGOS - CONTROLE POR CNPJ','REGISTRA O VALOR DOS RESTOS A PAGAR PAGOS, CONTROLADOS POR BENEFICIARIO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.09.04.00.00.0000','INSCRIÇÃO DE RESTOS A PAGAR','REGISTRA O VALOR DOS EMPENHOS DE RESTOS A PAGAR INSCRITOS NO ENCERRAMENTO DO EXERCÍCIO FINANCEIRO DE EMISSAO DA NOTA DE EMPENHO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.09.05.00.00.0000','RESTOS A PAGAR LIQUIDADOS - NO EXERCÍCIO ANTERIOR','REGISTRAR O VALOR DOS RESTOS A PAGAR LIQUIDADOS (A PAGAR) CONTROLADOS POR NÚMERO DE EMPENHO. O SALDO DESTA CONTA É ORIGINADO DA LEITURA DO SALDO EXISTENTE NA CONTA 2.9.2.4.1.04.02, SENDO TRANSPORTADO NO EXERCÍCIO POSTERIOR PARA A CONTA 2.9.2.3.1.05.08. SE','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.09.06.00.00.0000','CANCELAMENTO DE RESTOS A PAGAR NÃO PROCESSADOS','REGISTRA OS VALORES DOS RESTOS A PAGAR CANCELADOS PELA UNIDADE GESTORA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.09.07.00.00.0000','RESTOS A PAGAR PROCESSADOS PAGOS - CONTROLE POR NE','REGISTRA O VALOR DOS RESTOS A PAGAR PAGOS, CONTROLADOS POR NUMERO DE EMPENHO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.09.08.00.00.0000','CANCELAMENTO DE RESTOS A PAGAR PROCESSADOS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS CANCELADOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.2.2.9.2.09.99.00.00.0000','OUTRAS INSCRIÇÕES DE RESTOS A PAGAR','REGISTRA A CONTRAPARTIDA DOS LANCAMENTOS EFETUADOS EM EMPENHOS DE RESTOS A PAGAR CONTROLADOS POR BENEFICIARIO, POR OCASIAO DO ENCERRAMENTO DO EXERCÍCIO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.0.0.0.00.00.00.00.0000','EXECUÇÃO DE RESTOS A PAGAR','COMPREENDE O SOMATÓRIO DOS VALORES RELATIVOS A TRANSFERÊNCIA, LIQUIDAÇÃO E PAGAMENTO DAS DESPESAS EMPENHADAS E NÃO PAGAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.1.0.0.00.00.00.00.0000','EXECUÇÃO DE RP NÃO PROCESSADOS','COMPREENDE O SOMATÓRIO DOS VALORES RELATIVOS A TRANSFERÊNCIA, LIQUIDAÇÃO E PAGAMENTO DAS DESPESAS EMPENHADAS, NÃO LIQUIDADAS NO EXERCÍCIO FINANCEIRO DE SUA INSCRIÇÃO E NÃO PAGAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.1.1.0.00.00.00.00.0000','RP NÃO PROCESSADOS A LIQUIDAR','REGISTRA O VALOR DOS RP NÃO-PROCESSADOS AINDA NÃO LIQUIDADOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.1.2.0.00.00.00.00.0000','RP NÃO PROCESSADOS EM LIQUIDAÇÃO','REGISTRA O VALOR DOS RP NÃO-PROCESSADOS AINDA NÃO LIQUIDADOS CUJO FATO GERADOR JA OCORREU.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.1.3.0.00.00.00.00.0000','RP NÃO PROCESSADOS LIQUIDADOS A PAGAR','REGISTRA O VALOR DOS RP NÃO-PROCESSADOS, LIQUIDADOS APOS SUA INSCRIÇÃO E AINDA NÃO PAGOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.1.4.0.00.00.00.00.0000','RP NÃO PROCESSADOS PAGOS','REGISTRA O VALOR DOS RP NÃO-PROCESSADOS, LIQUIDADOS APOS SUA INSCRIÇÃO E PAGOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.1.5.0.00.00.00.00.0000','RP NÃO PROCESSADOS A LIQUIDAR BLOQUEADOS','REGISTRA O VALOR DE RESTOS A PAGAR NÃO PROCESSADOS A LIQUIDAR, BLOQUEADO POR DECRETO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.1.6.0.00.00.00.00.0000','RP NÃO PROCESSADOS TRANSFERIDOS','REGISTRA O VALOR DA TRANSFERÊNCIA DE RESTOS A PAGAR NÃO PROCESSADOS PELA DESINCORPORAÇÃO DE SALDOS CREDORES DECORRENTES DE TRANSFORMAÇÃO, CISAO, FUSAO E EXTINÇÃO DE ORGÃOS OU UG.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.1.7.0.00.00.00.00.0000','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','REGISTRA O VALOR DAS DESPESAS EMPENHADAS INSCRITAS NO EXERCÍCIO COMO RESTOS A PAGAR NÃO PROCESSADOS, A SER TRANSFERIDO PARA O EXERCÍCIO SEGUINTE PARA A CONTA 631100000 e 631200000.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.1.7.1.00.00.00.00.0000','RP NAO PROCESSADOS A LIQUIDAR- INSCRICAO NO EXERCICIO','REGISTRA O VALOR DAS DESPESAS EMPENHADAS A LIQUIDAR INSCRITAS NO EXERCICIO COMO RESTOS A PAGAR NAO PROCESSADOS, A SER TRANSFERIDO PARA O EXERCICIO SEGUINTE PARA A CONTA 631100000.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.1.7.2.00.00.00.00.0000','RP NAO PROCESSADOS EM LIQUIDACAO - INSCRICAO NO EXERCICIO','REGISTRA O VALOR DAS DESPESAS EMPENHADAS EM LIQUIDACAO INSCRITAS NO EXERCICIO COMO RESTOS A PAGAR NAO PROCESSADOS, A SER TRANSFERIDO PARA O EXERCICIO SEGUINTE PARA A CONTA 631200000.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.1.9.0.00.00.00.00.0000','RP NÃO PROCESSADOS CANCELADOS','COMPREENDE O CANCELAMENTO DE RESTOS A PAGAR NÃO PROCESSADOS POR INSUFICIÊNCIA DE RECURSOS, DE FONTE PROPRIAS, PELA INSCRIÇÃO INDEVIDA OU PARA ATENDER DISPOSITIVO LEGAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.1.9.1.00.00.00.00.0000','POR INSUFICIÊNCIA DE RECURSOS','REGISTRA O VALOR DOS RESTOS A PAGAR NÃO PROCESSADOS CANCELADOS NOS EXERCÍCIOS SUBSEQUENTES AO DA SUA INSCRIÇÃO POR INSUFICIÊNCIA DE RECURSOS FINANCEIROS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.1.9.9.00.00.00.00.0000','OUTROS CANCELAMENTOS DE RP','REGISTRA O VALOR DOS RESTOS A PAGAR NÃO PROCESSADOS CANCELADOS NOS EXERCÍCIOS SUBSEQUENTES AO DA SUA INSCRIÇÃO, EXCETO OS CANCELADOS POR INSUFICIÊNCIA DE RECURSOS FINANCEIROS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.2.0.0.00.00.00.00.0000','EXECUÇÃO DE RP PROCESSADOS','COMPREENDE O SOMATÓRIO DOS VALORES RELATIVOS A TRANSFERÊNCIA, LIQUIDAÇÃO E PAGAMENTO DAS DESPESAS EMPENHADAS, LIQUIDADAS NO EXERCÍCIO FINANCEIRO DE SUA INSCRIÇÃO E NÃO PAGAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.2.1.0.00.00.00.00.0000','RP PROCESSADOS A PAGAR','REGISTRA O VALOR DOS RP PROCESSADOS E NÃO PAGOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.2.2.0.00.00.00.00.0000','RP PROCESSADOS PAGOS','REGISTRA O VALOR DOS RP PROCESSADOS PAGOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.2.6.0.00.00.00.00.0000','RP PROCESSADOS TRANSFERIDOS','REGISTRA O VALOR DA TRANSFERÊNCIA DE RESTOS A PAGAR PELA DESINCORPORAÇÃO DE SALDOS CREDORES DECORRENTE DE TRANSFORMAÇÃO, CISAO, FUSAO E EXTINÇÃO DE ORGÃOS OU UG.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.2.7.0.00.00.00.00.0000','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 632100000.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.2.9.0.00.00.00.00.0000','RP PROCESSADOS CANCELADOS','COMPREENDE O CANCELAMENTO DE RESTOS A PAGAR PROCESSADOS POR INSUFICIÊNCIA DE RECURSOS, PELA INSCRIÇÃO INDEVIDA OU PARA ATENDER DISPOSITIVO LEGAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.2.9.1.00.00.00.00.0000','POR VALORES E/OU INSCRIÇÕES INDEVIDAS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS CANCELADOS NOS EXERCÍCIOS SUBSEQUENTES AO DA SUA INSCRIÇÃO POR VALORES E/OU INSCRIÇÕES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.2.9.1.01.00.00.00.0000','CANCELAMENTO DE RP PROCESSADOS - NE','REGISTRA O VALOR DE RESTOS A PAGAR PROCESSADOS CANCELADOS NO EXERCÍCIO SEGUINTE, CONTROLADOS POR NOTA DE EMPENHO, COM A RESPECTIVA BAIXA NO PASSIVO FINANCEIRO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.2.9.1.02.00.00.00.0000','AJUSTE DE CONTROLE RP DE EXERC ANTERIORES','REGISTRA O VALOR DO AJUSTE DE RESTOS A PAGAR PROCESSADOS CANCELADOS SEM PASSIVO CORRESPONDENTE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '6.3.2.9.9.00.00.00.00.0000','OUTROS CANCELAMENTOS DE RP','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS CANCELADOS NOS EXERCÍCIOS SUBSEQUENTES AO DA SUA INSCRIÇÃO, EXCETO OS CANCELADOS POR INSUFICIÊNCIA DE RECURSOS FINANCEIROS OU POR INSCRIÇÃO INDEVIDA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.0.0.0.0.00.00.00.00.0000','CONTROLES DEVEDORES','COMPREENDE AS CONTAS EM QUE SAO REGISTRADOS ATOS POTENCIAIS E CONTROLES ESPECÍFICOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.0.0.0.00.00.00.00.0000','ATOS POTENCIAIS','COMPREENDE CONTAS RELACIONADAS AS SITUAÇÕES NÃO COMPREENDIDAS NO PATRIMONIO, MAS QUE, DIRETA OU INDIRETAMENTE, POSSAM VIR A AFETA-LO, EXCLUSIVE AS QUE DIZEM RESPEITO A ATOS E FATOS LIGADOS A EXECUÇÃO ORCAMENTARIA E FINANCEIRA E AS CONTAS COM FUNÇÃO PRECIPUA DE CONTROLE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.0.0.00.00.00.00.0000','ATOS POTENCIAIS ATIVOS','REGISTRA OS ATOS E FATOS QUE POSSAM VIR A AUMENTAR O ATIVO DA ENTIDADE GOVERNAMENTAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.0.00.00.00.00.0000','GARANTIAS E CONTRAGARANTIAS RECEBIDAS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANÇAS E HIPOTECAS RECEBIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.1.00.00.00.00.0000','GARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERAÇÃO OU ENTIDADE A ELE VINCULADA, NO PAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.1.01.00.00.00.0000','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CRÉDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.1.02.00.00.00.0000','FIANÇAS','REGISTRA O VALOR DA OBRIGAÇÃO ACESSORIA RECEBIDA NO PAIS, POR ORGÃOS E ENTIDADES, PELO CUMPRIMENTO DA OBRIGAÇÃO DO DEVEDOR, CASO ESSE NÃO CUMPRA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.1.03.00.00.00.0000','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.1.04.00.00.00.0000','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.1.05.00.00.00.0000','CAUÇÃO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUÇÃO NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.1.06.00.00.00.0000','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERAÇÕES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERAÇÕES ESPECIAIS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.1.07.00.00.00.0000','APOLICES DE SEGUROS','REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.1.99.00.00.00.0000','OUTRAS GARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NÃO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGAÇÕES CONTRAIDAS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.2.00.00.00.00.0000','GARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERAÇÃO OU ENTIDADE A ELE VINCULADA, NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.2.01.00.00.00.0000','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CRÉDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.2.02.00.00.00.0000','FIANÇAS','REGISTRA O VALOR DA OBRIGAÇÃO ACESSORIA RECEBIDA POR ORGÃOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGAÇÃO DO DEVEDOR, CASO ESSE NÃO CUMPRA, NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.2.03.00.00.00.0000','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.2.04.00.00.00.0000','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.2.05.00.00.00.0000','CAUÇÃO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUÇÃO NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.2.06.00.00.00.0000','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERAÇÕES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERAÇÕES ESPECIAIS, NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.2.07.00.00.00.0000','APOLICES DE SEGUROS','REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.2.99.00.00.00.0000','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NÃO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGAÇÕES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.3.00.00.00.00.0000','CONTRAGARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGAÇÕES CONTRAIDAS NO PAIS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.3.01.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGAÇÕES CONTRAIDAS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.3.02.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS RECEBIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS TERCEIROS DECORRENTES DAS CONCESSOES DE FIANÇAS AVAIS POR OBRIGAÇÕES CONTRAIDAS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.3.03.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANÇAS AVAIS POR OBRIGAÇÕES CONTRAIDAS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.3.99.00.00.00.0000','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NÃO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.4.00.00.00.00.0000','CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGAÇÕES CONTRAIDAS NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.4.01.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGAÇÕES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.4.02.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS RECEBIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANÇAS POR OBRIGAÇÕES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.4.03.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS EM VIRTUDE DE GARANTIAS INSTITUI-DAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGAÇÕES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.1.4.99.00.00.00.0000','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NÃO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.2.0.00.00.00.00.0000','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DOS CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.2.1.00.00.00.00.0000','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE , DOS CONVÊNIOS FIRMADOS ENTRE ENTIDADES OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.2.1.01.00.00.00.0000','DIREITOS CONVENIADOS','REGISTRA O VALOR TOTAL FIRMADO DOS CONVÊNIOS FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.2.1.02.00.00.00.0000','TERMO DE COOPERAÇÃO','COMPREENDE O VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERAÇÃO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVAÇÃO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.2.1.99.00.00.00.0000','OUTROS INSTRUMENTOS CONGÊNERES','REGISTRA O VALOR TOTAL RECEBIDO DE OUTROS INSTRUMENTROS CONGÊNERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.3.0.00.00.00.00.0000','DIREITOS CONTRATUAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.3.1.00.00.00.00.0000','DIREITOS CONTRATUAIS - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA. COMPREENDE OS SALDOS QUE NÃO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.3.1.01.00.00.00.0000','CONTRATOS DE SEGUROS','REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.3.1.02.00.00.00.0000','CONTRATOS DE SERVIÇOS','REGISTRA O VALOR DO CONTRATO DE SERVIÇOS EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.3.1.03.00.00.00.0000','CONTRATOS DE ALUGUEIS','REGISTRA O VALOR DO CONTRATO DE ALUGUEIS EM QUE O PODER PÚBLICO SEJA O LOCADOR DO BEM.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.3.1.04.00.00.00.0000','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRAÇÃO PÚBLICA A TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.3.1.05.00.00.00.0000','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','REGISTRA O VALOR DO CONTRATO DE OBRIGAÇÃO DA ENTEDADE PÚBLICA COM TERCEIROS REFEREN-E A EMPRÉSTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCÍCIO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.3.1.06.00.00.00.0000','CONTRATOS DE PPP - DO ENTE FEDERADO','REGISTRA O VALOR POR CONTRATO DAS DESPESAS DERIVADAS DE PPP CONTRATADAS PELO ENTE DA FEDERAÇÃO EXCLUÍDAS AS EMPRESAS ESTATAIS NÃO DEPENDENTES. DEVEM ABRANGER AS DESPESAS COM A PARCELA FIXA DA CONTRAPRESTAÇÃO PECUNIÁRIA, COM A PARCELA VARIÁVEL VINCULADA AO DESEMPENHO DO PARCEIRO PRIVADO E COM OS DIFERENTES RISCOS PROVISIONADOS. INCLUI OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP QUE JÁ FORAM LIQUIDADAS NO EXERCÍCIO ATUAL, BEM COMO AS PREVISÕES DE DESPESAS DE PPP PARA OS PRÓXIMOS 9 ANOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.3.1.07.00.00.00.0000','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES','REGISTRA O VALOR POR CONTRATO DAS DESPESAS DERIVADAS DE PPP CONTRATADAS PELAS EMPRESAS ESTATAIS NÃO DEPENDENTES. DEVEM ABRANGER AS DESPESAS COM A PARCELA FIXA DA CONTRAPRESTAÇÃO PECUNIÁRIA, COM A PARCELA VARIÁVEL VINCULADA AO DESEMPENHO DO PARCEIRO PRIVADO E COM OS DIFERENTES RISCOS PROVISIONADOS. INCLUI OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP QUE JÁ FORAM LIQUIDADAS NO EXERCÍCIO ATUAL, BEM COMO AS PREVISÕES DE DESPESAS DE PPP PARA OS PRÓXIMOS 9 ANOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.3.1.08.00.00.00.0000','CONTRATO DE GESTAO','REGISTRA O VALOR CONSOLIDADO DOS DESDOBRAMENTOS DA REFERIDA CONTA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.3.1.08.01.00.00.0000','CONTRATOS DE GESTAO A LIQUIDAR','REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRAÇÃO PÚBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.3.1.08.02.00.00.0000','CONTRATOS DE GESTAO LIQUIDADOS','REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRAÇÃO PÚBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.3.1.99.00.00.00.0000','OUTROS DIREITOS CONTRATUAIS','REGISTRA O VALOR DE OUTROS DIREITOS CONTRATUAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.9.0.00.00.00.00.0000','OUTROS ATOS POTENCIAIS ATIVO','COMPREENDE OS ATOS POTENCIAIS ATIVOS NÃO CONTEMPLADOS EM CONTAS ESPECIFICAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.9.1.00.00.00.00.0000','PLANO DE AMORTIZAÇÃO DO DÉFICIT ATUARIAL','. REGISTRAR, A TÍTULO DE CONTROLE, OS VALORES RELATIVOS AO PLANO DE AMORTIZAÇÃO DO DÉFICIT ATUARIAL DO RPPS PELO ENTE PÚBLICO QUE O INSTITUIU.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.9.2.00.00.00.00.0000','PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','REGISTRAR, A TÍTULO DE CONTROLE, OS VALORES RELATIVOS ÀS PARCELAS DE DÉBITOS PREVIDENCIÁRIOS DO RPPS DEVIDAS PELO ENTE PÚBLICO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.9.5.00.00.00.00.0000','SUPRIMENTO DE FUNDOS','COMPREENDE OS ATOS POTENCIAIS ATIVOS, REFERENTES A RESPONSABILIDADES POR TÍTULOS, VALORES OU BENS EM SUPRIMENTOS DE FUNDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.1.9.5.01.00.00.00.0000','SUPRIMENTO DE FUNDOS CONCEDIDOS','COMPREENDE OS ATOS POTENCIAIS ATIVOS, REFERENTES A RESPONSABILIDADES POR TÍTULOS, VALORES OU BENS EM SUPRIMENTOS DE FUNDOS QUE AINDA NÃO FOI EMPENHADO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.0.0.00.00.00.00.0000','ATOS POTENCIAIS PASSIVO','REGISTRA OS ATOS E FATOS QUE POSSAM VIR A AUMENTAR O PASSIVO OU DIMINUIR O ATIVO DA ENTIDADE GOVERNAMENTAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.0.00.00.00.00.0000','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANÇAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.1.00.00.00.00.0000','GARANTIAS CONCEDIDAS NO PAIS','REGISTRA O VALOR CONCEDIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERAÇÃO OU ENTIDADE A ELE VINCULADA, NO PAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.1.01.00.00.00.0000','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CRÉDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, CONCEDIDA A TERCEIROS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.1.02.00.00.00.0000','FIANÇAS','REGISTRA O VALOR DA OBRIGAÇÃO ACESSORIA CONCEDIDA NO PAIS, POR ORGÃOS E ENTIDADES, PELO CUMPRIMENTO DA OBRIGAÇÃO DO DEVEDOR, CASO ESSE NÃO CUMPRA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.1.03.00.00.00.0000','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.1.99.00.00.00.0000','OUTRAS GARANTIAS CONCEDIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NÃO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGAÇÕES CONTRAIDAS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.2.00.00.00.00.0000','GARANTIAS CONCEDIDAS NO EXTERIOR','REGISTRA O VALOR CONCEDIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERAÇÃO OU ENTIDADE A ELE VINCULADA, NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.2.01.00.00.00.0000','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CRÉDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.2.02.00.00.00.0000','FIANÇAS','REGISTRA O VALOR DA OBRIGAÇÃO ACESSORIA CONCEDIDA POR ORGÃOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGAÇÃO DO DEVEDOR, CASO ESSE NÃO CUMPRA, NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.2.03.00.00.00.0000','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.3.00.00.00.00.0000','CONTRAGARANTIAS CONCEDIDAS NO PAIS','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGAÇÕES CONTRAIDAS NO PAIS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.3.01.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGAÇÕES CONTRAIDAS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.3.02.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS CONCEDIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS TERCEIROS DECORRENTES DAS CONCESSOES DE FIANÇAS AVAIS POR OBRIGAÇÕES CONTRAIDAS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.3.03.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS DECORRENTES DAS CONCESSOES DE FIANÇAS AVAIS POR OBRIGAÇÕES CONTRAIDAS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.3.99.00.00.00.0000','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NÃO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.4.00.00.00.00.0000','CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGAÇÕES CONTRAIDAS NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.4.01.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDAS','REGISTRA O VALOR DAS CONTRAGARANTIASCONCEDIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGAÇÕES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.4.02.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS CONCEDIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS DECORRENTES DAS CONCESSOES DE FIANÇAS POR OBRIGAÇÕES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.4.03.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS EM VIRTUDE DE GARANTIAS INSTITUI-DAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGAÇÕES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.1.4.99.00.00.00.0000','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NÃO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.2.0.00.00.00.00.0000','OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DO VALOR DOS CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.2.1.00.00.00.00.0000','OBRIGAÇÕES CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE , DOS CONVÊNIOS FIRMADOS ENTRE ENTIDADES OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.2.1.01.00.00.00.0000','OBRIGAÇÕES CONVENIADOS','REGISTRA O VALOR TOTAL RECEBIDO DOS CONVÊNIOS FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.2.1.02.00.00.00.0000','TERMO DE COOPERAÇÃO','REGISTRA VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERAÇÃO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.2.1.99.00.00.00.0000','OUTROS INSTRUMENTOS CONGÊNERES','REGISTRA O VALOR TOTAL RECEBIDO DE OUTROS INSTRUMENTROS CONGÊNERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.0.00.00.00.00.0000','OBRIGAÇÕES CONTRATUAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE OBRIGAÇÕES CONTRATUAIS, QUANDO A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATANTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.00.00.00.00.0000','OBRIGAÇÕES CONTRATUAIS - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE OBRIGAÇÕES CONTRATUAIS, QUANDO A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA. COMPREENDE OS SALDOS QUE NÃO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.01.00.00.00.0000','CONTRATOS DE SEGUROS','REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.02.00.00.00.0000','CONTRATOS DE SERVIÇOS','REGISTRA O VALOR DO CONTRATO ASSINADO ENTRE A ADMINISTRAÇÃO PÚBLICA E O PRESTADOR DE SERVIÇOS A TITULO DE OBRAS E INSTALAÇÃO E DEMAIS SERVIÇOS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.03.00.00.00.0000','CONTRATOS DE ALUGUEIS','REGISTRA O VALOR DO CONTRATO DE LOCAÇÃO DE BENS MÓVEIS E IMÓVEIS ENTRE A ADMINISTRAÇÃO E TERCEIROS LOCADORES DE TAIS BENS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.04.00.00.00.0000','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS ENTRE A ADMINISTRAÇÃO E O FORNECEDOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.05.00.00.00.0000','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','REGISTRA A APROPRIAÇÃO DE AJUSTE OU ASSINATURA DE CONTRATOS DE CONCESSAO DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.06.00.00.00.0000','CONTRATO DE GESTAO','COMPREENDE AS CONTAS QUE REGISTRAM OS CONTRATOS DE GESTAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.06.01.00.00.0000','CONTRATOS DE GESTAO A LIQUIDAR','REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRAÇÃO PÚBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.06.02.00.00.0000','CONTRATOS DE GESTAO LIQUIDADOS','REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRAÇÃO PÚBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.07.00.00.00.0000','CONTRATOS DE OPERACOES DE CREDITO','REGISTRA O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.08.00.00.00.0000','CONTRATOS DE PPP','COMPREENDE O VALOR DOS PASSIVOS DECORRENTES DE CONTRATO DE PPP QUE DEVEM ABRANGER O VALOR PRESENTE DA MELHORIA DE UM ATIVO NÃO FINANCEIRO PASSÍVEL DE TRANSFERÊNCIA AO SETOR PÚBLICO E DAS PRESTAÇÕES DOS SERVIÇOS OBJETO DO CONTRATO, INCLUINDO A PARCELA VARIÁVEL CONDICIONADA À QUALIDADE DO SERVIÇO, E TAMBÉM AQUELES DECORRENTES DE RISCOS NÃO PROVISIONADOS, OU AINDA OUTROS VALORES QUE SE ENTENDER NECESSÁRIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.08.01.00.00.0000','CONTRAPRESTAÇÕES FUTURAS','REGISTRA O VALOR DOS ATIVOS CONTINGENTES REFERENTES A CONTRAPRESTAÇÕES FUTURAS DEVIDAS PELO ENTE AO PARCEIRO PRIVADO','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.08.02.00.00.0000','RISCOS NÃO PROVISIONADOS','REGISTRA O VALOR DOS PASSIVOS CONTINGENTES REFERENTES A RISCOS ASSUMIDOS EM DECORRÊNCIA DE GARANTIAS CONCEDIDAS AO PARCEIRO PRIVADO OU EM SEU BENEFÍCIO, QUE NÃO TENHAM SIDO REGISTRADAS COM PROVISÕES DE PPP.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.08.03.00.00.0000','OUTROS PASSIVOS CONTINGENTES','REGISTRA O VALOR DOS DEMAIS PASSIVOS CONTINGENTES REFERENTES A PPP.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.09.00.00.00.0000','TERMO DE PARCERIA','REGISTRA O VALOR DE TERMO DE PARCERIA DE TERCEIROS COM ÓRGÃO/ENTIDADE','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.3.1.99.00.00.00.0000','OUTROS OBRIGAÇÕES CONTRATUAIS','REGISTRA O VALOR DE OUTRAS OBRIGAÇÕES CONTRATUAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.9.0.00.00.00.00.0000','OUTROS ATOS POTENCIAIS PASSIVO','COMPREENDE OS ATOS POTENCIAIS PASSIVOS NÃO CONTEMPLADOS EM CONTAS ESPECIFICAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.9.1.00.00.00.00.0000','BENEFICIARIOS DE SENTENCAS JUDICIAIS INCLUIDAS NO ORÇAMENTO','NESTE GRUPO DEVEM SER REGISTRADOS OS PRECATÓRIOS, RECEBIDOS NO EXERCÍCIO ANTERIOR E INCLUÍDOS NO ORÇAMENTO PARA PAGAMENTO ATÉ O FINAL DO EXERCÍCIO. DEVE SE MANTER O CONTROLE NESTE GRUPO POR BENEFICIÁRIO','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.1.2.9.2.00.00.00.00.0000','BENEFICIARIOS DE SENTENCAS JUDICIAIS AINDA NÃO INCLUIDAS NO ORÇAMENTO','NESTE GRUPO DEVEM SER REGISTRADOS OS PRECATÓRIOS, RECEBIDOS NO EXERCÍCIO E QUE SERÃO INCLUÍDOS NO ORÇAMENTO SEGUINTE PARA PAGAMENTO ATÉ O FINAL DAQUELE EXERCÍCIO.DEVE SE MANTER O CONTROLE NESTE GRUPO POR BENEFICIÁRIO','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.0.0.0.00.00.00.00.0000','ADMINISTRAÇÃO FINANCEIRA','COMPREENDE AS CONTAS DE REGISTRO DA PROGRAMAÇÃO FINANCEIRA E DE CONTROLE DAS DISPONIBILIDADES','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.0.0.00.00.00.00.0000','DISPONIBILIDADES POR DESTINAÇÃO','COMPREENDE AS CONTAS QUE REGISTRAM OS CONTROLES SOBRE AS DISPONIBILIDADES POR DESTINAÇÃO DE RECURSOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.1.0.00.00.00.00.0000','CONTROLE DA DISPONIBILIDADE DE RECURSOS','COMPREENDE AS CONTAS QUE REGISTRAM AS DISPONIBILIDADES DE RECURSOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.1.1.00.00.00.00.0000','DISPONIBILIDADE DE RECURSOS - ORDINÁRIOS','REGISTRA O TOTAL DE RECURSOS DISPONIBILIZADOS, JA COMPROMETIDOS OU NÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.1.1.01.00.00.00.0000','DISPONIBILIDADE DE RECURSOS - RECEITA ORÇAMENTÁRIA','REGISTRA O TOTAL DE RECURSOS DISPONIBILIZADOS, JA COMPROMETIDOS OU NÃO, REFERENTES À RECEITA O.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.1.1.02.00.00.00.0000','DISPONIBILIDADE DE RECURSOS - TRANSFERÊNCIAS FINANCEIRAS','REGISTRA O TOTAL DE RECURSOS DISPONIBILIZADOS, JA COMPROMETIDOS OU NÃO, REFERENTE À TRANSFERÊNCIA FINANCEIRAS RECEBIDAS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.1.1.03.00.00.00.0000','DEPÓSITOS DE TERCEIROS RECEBIDOS E ARO','REGISTRA O TOTAL DE RECURSOS DISPONIBILIZADOS, JA COMPROMETIDOS OU NÃO, REFERENTE À DEPÓSITOS DE TERCEIROS RECEBIDOS E AINDA NÃO DEVOLVIDO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.1.1.08.00.00.00.0000','SALDOS DE EXERCÍCIOS ANTERIORES','REGISTRA O TOTAL DE RECURSOS DISPONIBILIZADOS, JA COMPROMETIDOS OU NÃO, REFERENTE AOS SALDOS DE EXERCÍCIOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.1.1.08.01.00.00.0000','SALDOS DE EXERCÍCIOS ANTERIORES','REGISTRA O TOTAL DE RECURSOS DISPONIBILIZADOS, JA COMPROMETIDOS OU NÃO, REFERENTE AOS SALDOS DE EXERCÍCIOS ANTERIORES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.1.1.08.02.00.00.0000','CONTRAPARTIDA DE SALDOS DE EXERCÍCIOS ANTERIORES','REGISTRA O TOTAL DE RECURSOS DISPONIBILIZADOS, JA COMPROMETIDOS OU NÃO, REFERENTE AOS SALDOS DE EXERCÍCIOS ANTERIORES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.1.1.09.00.00.00.0000','CANCELAMENTO DE RESTOS A PAGAR','REGISTRA O TOTAL DE RECURSOS DISPONIBILIZADOS, JA COMPROMETIDOS OU NÃO, REFERENTE AO CANCELAMENTO DE RESTOS A PAGAR REALIZADOS NO EXERCÍCIO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.1.2.00.00.00.00.0000','RECURSOS VINCULADOS','REGISTRA AS DISPONIBILIDADES POR DESTINAÇÃO DE RECURSOS VINCULADOS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.1.3.00.00.00.00.0000','RECURSOS EXTRAORÇAMENTÁRIOS','REGISTRA AS DISPONIBILIDADES POR DESTINAÇÃO DE RECURSOS EXTRAORÇAMENTÁRIOS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.2.0.00.00.00.00.0000','LIMITE DE RESTOS A PAGAR POR DESTINAÇÃO','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRIÇÃO DO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINAÇÃO DE RECURSOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.2.1.00.00.00.00.0000','INSCRIÇÃO DO LIMITE DE RESTOS A PAGAR CONCEDIDO POR DESTINAÇÃO','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRIÇÃO DO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINAÇÃO DE RECURSOS, NAS UG''S RESPONSAVEIS EM ENVIAR RECURSOS FINANCEIROS DESTINADOS AO PAGAMENTO DE RESTOS A PAGAR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.2.2.00.00.00.00.0000','INSCRIÇÃO DO LIMITE DE RESTOS A PAGAR RECEBIDO POR DESTINAÇÃO','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRIÇÃO DO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINAÇÃO DE RECURSOS, NAS UG''S RESPONSAVEIS EM ENVIAR RECURSOS FINANCEIROS DESTINADOS AO PAGAMENTO DE RESTOS A PAGAR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.1.3.0.00.00.00.00.0000','RECURSO DIFERIDO POR DESTINAÇÃO','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRIÇÃO DOS RECURSOS DIFERIDOS. RECURSOS DIFERIDOS SAO AS SOBRAS DE RECURSOS FINANCEIROS AO FINAL DO EXERCÍCIO (RECURSO DIFERIDO), QUE DEVERIAM SER DEVOLVIDAS A CONTA UNICA, POREM, AO INVES DISSO, ESSAS SOBRAS SAO LIBERADAS PARA USO (APENAS NO EXERCÍCIO SEGUINTE) ATRAVES DE DESCONTOS DAS TRANSFERÊNCIAS FINANCEIRAS (COTA, REPASSE E SUB-REPASSE) DO EXERCÍCIO SEGUINTE.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.2.0.0.00.00.00.00.0000','PROGRAMAÇÃO FINANCEIRA','COMPREENDE AS CONTAS QUE REGISTRAM AS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.2.1.0.00.00.00.00.0000','CONCESSAO DE RECURSOS FINANCEIROS','COMPREENDE AS CONTAS QUE REGISTRAM A CONCESSAO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.2.1.1.00.00.00.00.0000','COTAS FINANCEIRAS A PROGRAMAR','DEMONSTRA O SALDO DOS VALORES REGISTRADOS PARA CONTROLE DA PROGRAMAÇÃO FINANCEIRA REFERENTE AS COTAS FINANCEIRAS A PROGRAMAR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.2.1.2.00.00.00.00.0000','COTAS FINANCEIRAS EMPENHADAS','DEMONSTRA O SALDO DOS VALORES REGISTRADOS PARA CONTROLE DA PROGRAMAÇÃO FINANCEIRA REFERENTE AS COTAS FINANCEIRAS EMPENHADAS NO ORÇAMENTO PELO ORGÃO CENTRAL DE PROGRAMAÇÃO FINANCEIRA DO MUNICÍPIO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.2.1.3.00.00.00.00.0000','COTAS FINANCEIRAS LIQUIDADAS A LIBERAR','DEMONSTRA O SALDO DOS VALORES REGISTRADOS PARA CONTROLE DA PROGRAMAÇÃO FINANCEIRA REFERENTE AS COTAS FINANCEIRAS LIQUIDADAS PELA UNIDADE EXECUTORA DO ORÇAMENTO E A LIBERAR PELO ORGÃO CENTRAL DE PROGRAMAÇÃO FINANCEIRA DO MUNICÍPIO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.2.1.4.00.00.00.00.0000','COTAS FINANCEIRAS LIQUIDADAS LIBERADAS','DEMONSTRA O SALDO DOS VALORES REGISTRADOS PARA CONTROLE DA PROGRAMAÇÃO FINANCEIRA REFERENTE AS COTAS FINANCEIRAS LIQUIDADAS PELA UNIDADE EXECUTORA DO ORÇAMENTO E JÁ LIBERADAS PELO ORGÃO CENTRAL DE PROGRAMAÇÃO FINANCEIRA DO MUNICÍPIO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.2.1.5.00.00.00.00.0000','COTAS FINANCEIRAS UTILIZADAS','DEMONSTRA O SALDO DOS VALORES REGISTRADOS PARA CONTROLE DA PROGRAMAÇÃO FINANCEIRA REFERENTE AS COTAS FINANCEIRAS LIBERADAS PELO ORGÃO CENTRAL DE PROGRAMAÇÃO FINANCEIRA DO MUNICÍPIO E JÁ UTILIZADAS PELA UNIDADE EXECUTORA DO ORÇAMENTO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.2.2.0.00.00.00.00.0000','CONTROLE DAS COTAS DE RESTOS A PAGAR','DEMONSTRA O SALDO DOS VALORES REGISTRADOS PARA CONTROLE DA PROGRAMAÇÃO FINANCEIRA REFERENTE AO ORÇAMENTO APROVADO NO EXERCÍCIO E OS CRÉDITOS ADICIONAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.2.2.1.00.00.00.00.0000','COTAS FINANCEIRAS DE RP NÃO PROCESSADOS','DEMONSTRA O SALDO DOS VALORES REGISTRADOS PARA CONTROLE DA PROGRAMAÇÃO FINANCEIRA REFERENTE AS COTAS FINANCEIRAS A PROGRAMAR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.2.2.2.00.00.00.00.0000','COTAS FINANCEIRAS DE RP LIQUIDADAS A LIBERAR','DEMONSTRA O SALDO DOS VALORES REGISTRADOS PARA CONTROLE DA PROGRAMAÇÃO FINANCEIRA REFERENTE AS COTAS FINANCEIRAS LIQUIDADAS PELA UNIDADE EXECUTORA DO ORÇAMENTO E A LIBERAR PELO ORGÃO CENTRAL DE PROGRAMAÇÃO FINANCEIRA DO MUNICÍPIO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.2.2.3.00.00.00.00.0000','COTAS FINANCEIRAS DE RP LIQUIDADAS LIBERADAS','DEMONSTRA O SALDO DOS VALORES REGISTRADOS PARA CONTROLE DA PROGRAMAÇÃO FINANCEIRA REFERENTE AS COTAS FINANCEIRAS LIQUIDADAS PELA UNIDADE EXECUTORA DO ORÇAMENTO E JÁ LIBERADAS PELO ORGÃO CENTRAL DE PROGRAMAÇÃO FINANCEIRA DO MUNICÍPIO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.2.2.4.00.00.00.00.0000','COTAS FINANCEIRASDE RP UTILIZADAS','DEMONSTRA O SALDO DOS VALORES REGISTRADOS PARA CONTROLE DA PROGRAMAÇÃO FINANCEIRA REFERENTE AS COTAS FINANCEIRAS LIBERADAS PELO ORGÃO CENTRAL DE PROGRAMAÇÃO FINANCEIRA DO MUNICÍPIO E JÁ UTILIZADAS PELA UNIDADE EXECUTORA DO ORÇAMENTO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.3.0.0.00.00.00.00.0000','INSCRIÇÃO DO LIMITE ORCAMENTARIO','COMPREENDE AS CONTAS QUE CONTROLAM O LIMITE DE EMPENHO E MOVIMENTAÇÃO DE CRÉDITOS ORCAMENTARIOS, CONFORME ESTABELECIDOS EM ATO PROPRIO DOS PODERES E MINISTERIO PÚBLICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.3.1.0.00.00.00.00.0000','CONTROLE DO ORGÃO CENTRAL DE PROGRAMAÇÃO FINANCEIRA','COMPREENDE AS CONTAS QUE CONTROLAM O LIMITE ORCAMENTARIO NO OCPF','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.4.0.0.00.00.00.00.0000','CONTROLES DA ARRECADAÇÃO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADAÇÃO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADAÇÃO COMO DARF, GRU, DAR, ENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.4.1.0.00.00.00.00.0000','CONTROLES DE DOCUMENTOS DE ARRECADAÇÃO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADAÇÃO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.4.1.1.00.00.00.00.0000','CONTROLES DE DOCUMENTOS DE ARRECADAÇÃO POR CODIGO DE RECEITA','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADAÇÃO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADAÇÃO, CLASSIFICADA POR CODIGO DE RECEITA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.2.4.1.2.00.00.00.00.0000','CONTROLES DE DOCUMENTOS DE ARRECADAÇÃO POR CODIGO DE DESTINAÇÃO VINCULADA','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADAÇÃO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADAÇÃO, CLASSIFICADA POR CODIGO DE DESTINAÇÃO VINCULADA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.3.0.0.0.00.00.00.00.0000','DÍVIDA ATIVA','REGISTRA O CONTROLE DOS CRÉDITOS A SEREM INSCRITOS EM DÍVIDA ATIVA, DOS QUE SE ENCONTRAM EM PROCESSAMENTO. COMPREENDE AS CONTAS QUE CONTROLAM OS CRÉDITOS PASSIVEIS DE SEREM ENCAMINHADOS E INSCRITOS EM DÍVIDA ATIVA O DE INSCRIÇÃO E A TRAMITAÇÃO DOS CRÉDITOS INSCRITOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.3.1.0.0.00.00.00.00.0000','CONTROLE DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA','REGISTRA OS VALORES PASSIVEIS DE SEREM ENCAMINHADOS E INSCRITOS EM DÍVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.3.1.1.0.00.00.00.00.0000','ENCAMINHAMENTO DE CRÉDITOS','REGISTRA OS VALORES DOS CRÉDITOS PASSÍVEIS DE SEREM ENCAMINHADOSA E INSCRITOS EM DÍVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.3.1.1.1.00.00.00.00.0000','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA','COMPREENDE O MONTANTE DOS CRÉDITOS PASSÍVEIS DE SEREM ENCAMINHADOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.3.1.1.1.01.00.00.00.0000','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','REGISTRA O MONTANTE DOS CRÉDITOS PASSÍVEIS DE SEREM ENCAMINHADOS PARA INSCRIÇÃO EM DÍVIDA ATIVA, REFERENTES A IMPOSTOS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.3.1.1.1.02.00.00.00.0000','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','REGISTRA O MONTANTE DOS CRÉDITOS PASSÍVEIS DE SEREM ENCAMINHADOS PARA INSCRIÇÃO EM DÍVIDA ATIVA, REFERENTES A TAXAS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.3.1.1.1.03.00.00.00.0000','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','REGISTRA O MONTANTE DOS CRÉDITOS PASSÍVEIS DE SEREM ENCAMINHADOS PARA INSCRIÇÃO EM DÍVIDA ATIVA, REFERENTES A CONTRIBUIÇÕES DE MELHORIA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.3.1.1.2.00.00.00.00.0000','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','COMPREENDE O MONTANTE DOS CRÉDITOS A ENCAMINHAR E ENCAMINHADOS PARA INSCRIÇÃO EM DÍVIDA ATIVA NÃO - TRIBUTÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.3.1.1.2.01.00.00.00.0000','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','REGISTRA O MONTANTE DOS CRÉDITOS A ENCAMINHAR E ENCAMINHADOS PARA INSCRIÇÃO EM DÍVIDA ATIVA NÃO - TRIBUTÁRIA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.3.2.0.0.00.00.00.00.0000','CONTROLE DA INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA','COMPREENDE AS CONTAS QUE CONTROLAM OS CRÉDITOS PASSÍVEIS DE SEREM INSCRITOS EM DÍVIDA ATIVA PELO ORGÃO RESPONSÁVEL PELA INSCRIÇÃO EM DÍVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.3.2.1.0.00.00.00.00.0000',' INSCRIÇÃO DE CRÉDITOS','REGISTRA O VALOR DOS CRÉDITOS PASSÍVEIS DE SEREM INSCRITOS EM DÍVIDA ATIVA, PELO ORGÃO COMPETENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.3.2.1.1.00.00.00.00.0000','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA TRIBUTÁRIA','COMPREENDE O VALOR DOS CRÉDITOS DE ORIGEM TRIBUTÁRIA PASSÍVEIS DE SEREM INSCRITOS EM DÍVIDA ATIVA PELO ÓRGÃO COMPETENTE.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.3.2.1.2.00.00.00.00.0000','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','COMPREENDE O VALOR DOS CRÉDITOS DE NATUREZA NÃO - TRIBUTÁRA PASSÍVEIS DE SEREM INSCRITOS EM DÍVIDA ATIVA PELO ÓRGÃO COMPETENTE.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.4.0.0.0.00.00.00.00.0000','RISCOS FISCAIS','COMPREENDE AS CONTAS QUE CONTROLAM OS RISCOS FISCAIS QUE NÃO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.4.1.0.0.00.00.00.00.0000','CONTROLE DE PASSIVOS CONTINGENTES','COMPREENDE AS CONTAS QUE REGISTRAM O CONTROLE DOS RISCOS FISCAIS QUE NÃO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, CLASSIFICADOS COMO PASSIVOS CONTINGENTES, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.4.1.1.0.00.00.00.00.0000','PASSIVOS CONTINGENTES','REGISTRA OS RISCOS FISCAIS CLASSIFICADOS COMO PASSIVOS CONTINGENTES','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.4.1.1.1.00.00.00.00.0000','DEMANDAS JUDICIAIS','REGISTRA A ESTIMATIVA DO MONTANTE RELATIVO A AÇÕES JUDICIAIS EM ANDAMENTO CONTRA O ENTE FEDERATIVO NAS QUAIS HAJA A PROBABILIDADE DE QUE O GANHO DE CAUSA VENHA A SER DA OUTRA PARTE. AO FAZER A ESTIMATIVA, CONSIDERAR OS PRINCIPAIS TIPOS DE AÇÃO JUDICIAL, TAIS COMO: A) DEMANDAS JUDICIAIS CONTRA A ATIVIDADE REGULADORA DO ESTADO: INDEXAÇÃO E CONTROLES DE PREÇOS; DE ORDEM TRIBUTÁRIA E PREVIDENCIÁRIA; OUTRAS DEMANDAS JUDICIAIS; B) DEMANDAS JUDICIAIS CONTRA EMPRESAS ESTATAIS DEPENDENTES; C) DEMANDAS JUDICIAIS CONTRA A ADMINISTRAÇÃO DIRETA E INDIRETA: PRIVATIZAÇÕES, LIQUIDAÇÃO OU EXTINÇÃO DE ÓRGÃOS OU EMPRESAS; REAJUSTES SALARIAIS; D) DEMANDAS TRABALHISTAS CONTRA O ENTE FEDERATIVO; E) OUTRAS DEMANDAS JUDICIAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.4.1.1.2.00.00.00.00.0000','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','REGISTRA AS DÍVIDAS AINDA NÃO ASSUMIDAS FORMALMENTE QUE APRESENTAM PROBABILIDADE DE SEREM INCORPORADAS AO PASSIVO DEVIDO, POR EXEMPLO, A DECISÕES JUDICIAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.4.1.1.3.00.00.00.00.0000','AVAIS E GARANTIAS CONCEDIDAS','REGISTRA A ESTIMATIVA DO MONTANTE QUE APRESENTA PROBABILIDADE DE VIR A SER GASTO PELO ENTE FEDERATIVO PARA HONRAR FIANÇAS E AVAIS CONCEDIDOS EM OPERAÇÕES DE CRÉDITO DIRETA OU INDIRETAMENTE PELO ENTE FEDERATIVO A FAVOR DE OUTROS ENTES FEDERATIVOS E ENTIDADES DOS SETORES PÚBLICO E PRIVADO, INCLUSIVE COM RECURSOS DE FUNDOS DE AVAL, A ASSUNÇÃO DE RISCO CREDITÍCIO EM LINHAS DE CRÉDITO, O SEGURO DE CRÉDITO À EXPORTAÇÃO E OUTRAS GARANTIAS DE NATUREZA SEMELHANTE QUE REPRESENTEM COMPROMISSO DE ADIMPLÊNCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.4.1.1.4.00.00.00.00.0000','ASSUNÇÃO DE PASSIVOS','REGISTRA A ESTIMATIVA DO MONTANTE QUE APRESENTA PROBABILIDADE DE VIR A SER GASTO PELO ENTE FEDERATIVO COM O OBJETIVO DE PROTEGER O CIDADÃO OU SISTEMAS IMPORTANTES DO MERCADO CONTRA INADIMPLÊNCIAS, FALÊNCIAS, ALTOS PREJUÍZOS, OU GARANTIR A CREDIBILIDADE DESSES SISTEMAS FRENTE A FATORES AGUDOS ADVERSOS. AO FAZER A ESTIMATIVA, CONSIDERAR OS PRINCIPAIS TIPOS DE SITUAÇÕES QUE PODEM ADVIR: A) DE ÓRGÃOS DA ADMINISTRAÇÃO DIRETA OU INDIRETA; B) DE ENTIDADES PRIVADAS; C) DE REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL DOS SERVIDORES PÚBLICOS; D) DE ENTES DA FEDERAÇÃO; E) DO REGIME GERAL DE PREVIDÊNCIA SOCIAL; F) DO BANCO CENTRAL; E G) DA ASSUNÇÃO DE OUTROS PASSIVOS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.4.1.1.5.00.00.00.00.0000','ASSISTÊNCIAS DIVERSAS','REGISTRA A ESTIMATIVA DO MONTANTE QUE APRESENTA PROBABILIDADE DE VIR A SER EMPREGADO PELO ENTE FEDERATIVO COM O OBJETIVO DE FAZER FRENTE A CALAMIDADES PÚBLICAS E QUE, POR NÃO SEREM RECORRENTES, NÃO FORAM PLANEJADOS. RECOMENDA-SE QUE O ENTE FEDERATIVO EXPLICITE O TIPO DE ASSISTÊNCIA EMERGENCIAL QUE ELE ESTÁ PREVENDO, POR EXEMPLO, SE É ASSISTÊNCIA CONTRA SECA, ENCHENTES, CATÁSTROFES, EPIDEMIAS ETC.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.4.1.1.9.00.00.00.00.0000','OUTROS PASSIVOS CONTINGENTES','REGISTRA A ESTIMATIVA DO MONTANTE QUE APRESENTA PROBABILIDADE DE VIR A SER EMPREGADO PELO ENTE FEDERATIVO PARA FAZER FRENTE A OUTROS TIPOS DE PASSIVOS CONTINGENTES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.4.2.0.0.00.00.00.00.0000','CONTROLE DOS DEMAIS RISCOS FISCAIS','COMPREENDE AS CONTAS QUE REGISTRAM OS RISCOS FISCAIS QUE NÃO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, NÃO CLASSIFICADOS COMO PASSIVOS CONTINGENTES, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.4.2.1.0.00.00.00.00.0000','DEMAIS RISCOS FISCAIS','REGISTRA OS RISCOS FISCAIS NÃO CLASSIFICADOS COMO PASSIVOS CONTINGENTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.4.2.1.1.00.00.00.00.0000','FRUSTRAÇÃO DE ARRECADAÇÃO','REGISTRA A ESTIMATIVA DO MONTANTE DE REDUÇÃO DE ARRECADAÇÃO QUE APRESENTA PROBABILIDADE DE VIR A OCORRER NO EXERCÍCIO, DECORRENTE DE, POR EXEMPLO, CENÁRIOS MACROECONÔMICOS DESFAVORÁVEIS NÃO PREVISTOS NA ÉPOCA DA ELABORAÇÃO DO ORÇAMENTO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.4.2.1.2.00.00.00.00.0000','RESTITUIÇÃO DE TRIBUTOS A MAIOR','REGISTRA A ESTIMATIVA DO MONTANTE DE DEVOLUÇÃO DE TRIBUTOS A MAIOR QUE APRESENTA PROBABILIDADE DE VIR A OCORRER NO EXERCÍCIO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.4.2.1.3.00.00.00.00.0000','DISCREPÂNCIA DE PROJEÇÕES:','REGISTRA A ESTIMATIVA DO MONTANTE DE REDUÇÃO NO VALOR DOS INGRESSOS OU DE AUMENTO NO VALOR DOS DESEMBOLSOS QUE APRESENTAM PROBABILIDADE DE VIR A OCORRER NO EXERCÍCIO, DECORRENTES DE EVOLUÇÃO DESFAVORÁVEL DE INDICADORES ECONÔMICOS EMPREGADOS NA ÉPOCA DA ELABORAÇÃO DO ORÇAMENTO, TAIS COMO: A) TAXA DE CRESCIMENTO ECONÔMICO; B) TAXA DE INFLAÇÃO; C) TAXA DE CÂMBIO; D) TAXA DE JUROS; E) SALÁRIO MÍNIMO; F) OUTROS INDICADORES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.4.2.1.4.00.00.00.00.0000','OUTROS RISCOS FISCAIS','REGISTRA A ESTIMATIVA DO MONTANTE QUE APRESENTA PROBABILIDADE DE VIR A SER EMPREGADO PELO ENTE FEDERATIVO PARA FAZER FRENTE A OUTROS TIPOS DE RISCOS FISCAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.5.0.0.0.00.00.00.00.0000','CONSÓRCIOS PÚBLICOS','COMPREENDE AS CONTAS QUE CONTROLAM O REGISTRO DE ATOS DOS CONSÓRCIOS PÚBLICOS (DO ENTE CONSORCIADO E/OU DO PRÓPRIO CONSÓRCIO), INCLUINDO OS CONTROLES DO CONTRATO DE RATEIO, CONTROLE DA PRESTAÇÃO DE CONTAS, BEM COMO AS INFORMAÇÕES QUE SERÃO CONSOLIDADAS NO ENTE CONSORCIADO PARA FINS DE ELABORAÇÃO DOS DEMONSTRATIVOS DOS CONSÓRCIOS, CONFORME PORTARIA STN 72/2012.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.5.1.0.0.00.00.00.00.0000','CONTRATO DE RATEIO DE CONSÓRCIOS PÚBLICOS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE OBRIGAÇÕES CONTRATUAIS DECORRENTES DE CONSÓRCIOS PÚBLICOS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.5.2.0.0.00.00.00.00.0000','PRESTAÇÃO DE CONTAS DE CONSÓRCIOS PÚBLICOS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DO CONTROLE DA PRESTAÇÃO DE CONTAS DOS CONSÓRCIOS PÚBLICOS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.5.3.0.0.00.00.00.00.0000','CONSOLIDAÇÃO DA EXECUÇÃO DO CONSÓRCIO','COMPREENDE AS INFORMAÇÕES REFERENTES AOS CONSÓRCIOS PÚBLICOS, ATRIBUÍDAS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO,QUE SERÃO ENVIADAS PELO CONSÓRCIO PARA OS ENTES CONSORCIADOS PARA FINS DE ELABORAÇÃO DOS DEMONSTRATIVOS FISCAIS ( SAÚDE, PESSOAL, EDUCAÇÃO E DISPONIBILIDADE DE CAIXA), EM ATENDIMENTO A PORTARIA STN N.º 72/2012. CONTA PARA USO DO ENTE CONSORCIADO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.8.0.0.0.00.00.00.00.0000','CUSTOS','COMPREENDE AS CONTAS QUE CONTROLAM OS CUSTOS DE BENS E SERVIÇOS PRODUZIDOS','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.0.0.0.00.00.00.00.0000','OUTROS CONTROLES','COMPREENDE DE CONTROLES NÃO ESPECIFICADOS ANTERIORMENTE NOS GRUPOS DESSA CLASSE','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.1.0.0.00.00.00.00.0000','OUTROS CONTROLES DE PROGRAMAÇÃO FINANCEIRA','COMPREENDE AS CONTAS QUE CONTROLAM OUTRAS PECULIARIDADES DA PROGRAMAÇÃO FINANCEIRA','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.2.0.0.00.00.00.00.0000','OUTROS CONTROLES DE DISPONIBILIDADES','COMPREENDE AS CONTAS QUE CONTROLAM OUTROS CONTROLES DE DISPONIBILIDADES','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.3.0.0.00.00.00.00.0000','OUTROS CONTROLES DE BENEFÍCIOS PAGOS','COMPREENDE AS CONTAS QUE REGISTRAM O PAGAMENTO DE BENEFÍCIOS PREVIDÊNCIÁRIOS','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.4.0.0.00.00.00.00.0000','OUTROS CONTROLES DA CONTA UNICA','COMPREENDE AS CONTAS QUE CONTROLAM A CONTA UNICA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.4.1.0.00.00.00.00.0000','CONCILIAÇÃO DA CONTA UNICA POR DISPONIBILIDADE POR DESTINAÇÃO','COMPREENDE AS CONTAS QUE CONTROLAM A CONCILIAÇÃO DA CONTA UNICA','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.4.2.0.00.00.00.00.0000','CONTROLE DE APLICAÇÃO FINANCEIRA NA CONTA UNICA POR DISPONIBILIDADE POR DESTINAÇÃO','REGISTRA OS VALORES REFERENTE AO CONTROLE DE FONTE DE RECURSOS NA NA PLICAÇÃO FINANCEIRA','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.6.0.0.00.00.00.00.0000','OUTROS CONTROLES DE OPERAÇÕES DE CRÉDITOS','COMPREENDE AS CONTAS QUE CONTROLAM OPERAÇÕES DE CRÉDITO','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.7.0.0.00.00.00.00.0000','OUTROS CONTROLES DE RESPONSABILIDADES POR VALORES, TITULOS E BENS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DAS RESPONSABILIDADES POR VALORES, TITULOS E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.7.1.0.00.00.00.00.0000','RESPONSABILIDADES DE TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRAÇÃO PÚBLICA POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.7.1.1.00.00.00.00.0000','RESPONSABILIDADES DE TERCEIROS','REGISTRA AS CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRAÇÃO PÚBLICA POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.7.1.1.01.00.00.00.0000','SUPRIMENTO DE FUNDOS','REGISTRA OS VALORES CONCEDIDOS A SERVIDOR RESPONSAVEL PARA ATENDER DESPESAS QUE NÃO POSSAM SUBORDINAR-SE AO PROCESSO NORMAL DE APLICAÇÃO,ATE A SUA PRESTAÇÃO DE CONTAS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.7.1.1.02.00.00.00.0000','OUTRAS RESPONSABILIDADES DE TERCEIROS','REGISTRA O VALOR DE OUTRAS RESPONSABILIDADES DE TERCEIROS, DE NATUREZA EVENTUAL, POR TITULOS, VALORES E BENS, PARA AS QUAIS NÃO HA CONTAS ESPECIFICAS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.7.2.0.00.00.00.00.0000','RESPONSABILIDADES COM TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DA ADMINISTRAÇÃO PÚBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.7.2.1.00.00.00.00.0000','RESPONSABILIDADE COM TERCEIROS','REGISTRA AS CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DA ADMINISTRAÇÃO PÚBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.7.2.1.01.00.00.00.0000','RECEBIDOS EM CAUÇÃO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUÇÃO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.7.2.1.02.00.00.00.0000','DEPÓSITOS JUDICIAIS','REGISTRA OS DEPÓSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EM CONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOS POR ESTA PARA TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.7.2.1.03.00.00.00.0000','DEPÓSITOS COMPULSORIOS','REGISTRA O SOMATÓRIO DOS VALORES DOS DEPÓSITOS COMPULSÓRIOS REALIZADOS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.7.2.1.99.00.00.00.0000','OUTRAS RESPONSABILIDADES COM TERCEIROS','REGISTRA RESPONSABILIDADES COM TERCEIROS, NÃO INDIVIDUALIZADAS NAS OUTRAS CONTAS DESSE GRUPO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.7.3.0.00.00.00.00.0000','DIVERSOS RESPONSAVEIS EM APURAÇÃO','REGISTRA AS RESPONSABILIDADES EM FASE DE APURAÇÃO DECORRENTES DE ATOSPRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAREM PREJUÍZOS PARA A FAZENDA NACIONAL.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.9.0.0.00.00.00.00.0000','DEMAIS CONTROLES','COMPREENDE AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS SUBGRUPOS DESTE GRUPO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.9.8.0.00.00.00.00.0000','CONTROLES REFERENTES A CONSÓRCIOS PÚBLICOS','REGISTRA A CONTRAPARTIDA DAS INFORMAÇÕES ENVIADAS PELOS CONSÓRCIOS PÚBLICOS, INSTITUIDOS DE ACORDO COM A LEI FEDERAL Nº 11.107/2005 PARA FINS DE CONSOLIDAÇÃO QUANTO AS INFORMAÇÕES PARA VERIFICAÇÃO DA APLICAÇÃO DOS INDICES MINIMOS E MÁXIMOS TRAZIDOS PELA CF/88 E LRF.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '7.9.9.9.0.00.00.00.00.0000','DEMAIS CONTROLES','COMPREENDE AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS TITULOS DESTE SUBGRUPO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.0.0.0.0.00.00.00.00.0000','CONTROLES CREDORES','COMPREENDE AS CONTAS EM QUE SAO REGISTRADAS A EXECUÇÃO DE ATOS POTENCIAIS E CONTROLES ESPECIFICOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.0.0.0.00.00.00.00.0000','EXECUÇÃO DOS ATOS POTENCIAIS','COMPREENDE CONTAS RELACIONADAS A EXECUÇÃO DE SITUAÇÕES NÃO COMPREENDIDAS NO PATRIMONIO, MAS QUE, DIRETA OU INDIRETAMENTE, POSSAM VIR A AFETA-LO, EXCLUSIVE AS QUE DIZEM RESPEITO A ATOS E FATOS LIGADOS A EXECUÇÃO ORCAMENTARIA E FINANCEIRA E AS CONTAS COM FUNÇÃO PRECIPUA DE CONTROLE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.0.0.00.00.00.00.0000','EXECUÇÃO DOS ATOS POTENCIAIS ATIVOS','REGISTRA A EXECUÇÃO DOS ATOS E FATOS QUE POSSA VIR A AFETAR O ATIVO DA ENTIDADE GOVERNAMENTAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.0.00.00.00.00.0000','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS RECEBIDOS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.00.00.00.00.0000','EXECUÇÃO DE GARANTIAS RECEBIDAS NO PAIS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS RECEDIDOS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.01.00.00.00.0000','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.02.00.00.00.0000','AVAIS EM EXECUÇÃO','REGISTRA O VALOR, AINDA, NÃO RECEBIDO, DAS GARANTIAS RECEBIDAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.03.00.00.00.0000','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS RECEBIDAS POR AVAL NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.04.00.00.00.0000','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR FIANÇAS, PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.05.00.00.00.0000','FIANÇAS EM EXECUÇÃO','REGISTRA O VALOR, AINDA, NÃO RECEBIDO, DAS GARANTIAS POR FIANÇAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.06.00.00.00.0000','FIANÇAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANÇAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.07.00.00.00.0000','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.08.00.00.00.0000','HIPOTECAS EM EXECUÇÃO','REGISTRA O VALOR NÃO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUÇÃO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.09.00.00.00.0000','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.10.00.00.00.0000','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.11.00.00.00.0000','SEGUROS-GARANTIA EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.12.00.00.00.0000','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.13.00.00.00.0000','CAUÇÃO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUÇÃO PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.14.00.00.00.0000','CAUÇÃO EM EXECUÇÃO','REGISTRA O VALOR NÃO RECEBIDO DAS GARANTIAS POR CAUÇÃO EM EXECUÇÃO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.15.00.00.00.0000','CAUÇÃO EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUÇÃO NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.16.00.00.00.0000','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.17.00.00.00.0000','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.18.00.00.00.0000','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.19.00.00.00.0000','APOLICES DE SEGUROS A EXECUTAR','REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.20.00.00.00.0000','APOLICES DE SEGUROS EM EXECUÇÃO','REGISTRA O VALOR NÃO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.21.00.00.00.0000','APOLICES DE SEGUROS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.22.00.00.00.0000','OUTRAS GARANTIAS RECEBIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.23.00.00.00.0000','OUTRAS GARANTIAS RECEBIDAS NO PAIS EM EXECUÇÃO','REGISTRA O VALOR NÃO RECEBIDO DE OUTRAS GARANTIAS EM EXECUÇÃO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.1.24.00.00.00.0000','OUTRAS GARANTIAS RECEBIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.00.00.00.00.0000','EXECUÇÃO DE GARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS RECEBIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.01.00.00.00.0000','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.02.00.00.00.0000','AVAIS EM EXECUÇÃO','REGISTRA O VALOR NÃO RECEBIDO DAS GARANTIAS POR AVAL EM EXECUÇÃO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.03.00.00.00.0000','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR AVAL NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.04.00.00.00.0000','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANÇAS PENDENTES DE EXECUÇÃO , NO EXTERIOR','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.05.00.00.00.0000','FIANÇAS EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO RECEBIDO DAS GARANTIAS POR FIANÇAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.06.00.00.00.0000','FIANÇAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANÇAS, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.07.00.00.00.0000','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.08.00.00.00.0000','HIPOTECAS EM EXECUÇÃO','REGISTRA O VALOR NÃO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUÇÃO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.09.00.00.00.0000','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.10.00.00.00.0000','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUÇÃO , NO EXTERIOR','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.11.00.00.00.0000','SEGUROS-GARANTIA EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.12.00.00.00.0000','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.13.00.00.00.0000','CAUÇÃO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUÇÃO PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.14.00.00.00.0000','CAUÇÃO EM EXECUÇÃO','REGISTRA O VALOR NÃO RECEBIDO DAS GARANTIAS POR CAUÇÃO EM EXECUÇÃO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.15.00.00.00.0000','CAUÇÃO EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUÇÃO NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.16.00.00.00.0000','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.17.00.00.00.0000','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.18.00.00.00.0000','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.19.00.00.00.0000','APOLICES DE SEGUROS A EXECUTAR','REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.20.00.00.00.0000','APOLICES DE SEGUROS EM EXECUÇÃO','REGISTRA O VALOR NÃO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.21.00.00.00.0000','APOLICES DE SEGUROS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.22.00.00.00.0000','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.23.00.00.00.0000','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EM EXECUÇÃO','REGISTRA O VALOR NÃO RECEBIDO DE OUTRAS GARANTIAS EM EXECUÇÃO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.2.24.00.00.00.0000','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.3.00.00.00.00.0000','EXECUÇÃO DE CONTRAGARANTIAS RECEBIDAS NO PAIS','COMPREENDE A EXECUÇÃO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS RECEBIDAS SOBRE OBRIGAÇÕES CONTRAIDAS NO PAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.3.01.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.3.02.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUÇÃO','REGISTRA O VALOR, AINDA, NÃO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.3.03.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.3.04.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANÇAS PENDENTES DE EXECUÇÃO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.3.05.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS RECEBIDAS EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO RECEBIDO DAS DAS CONTRAGARANTIAS SOBRE FIANÇAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.3.06.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE FIANÇAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.3.07.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.3.08.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUÇÃO','REGISTRA O VALOR, AINDA, NÃO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.3.09.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.3.10.00.00.00.0000','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.3.11.00.00.00.0000','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.3.12.00.00.00.0000','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.4.00.00.00.00.0000','EXECUÇÃO DE CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE A EXECUÇÃO DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGAÇÕES CONTRAIDAS NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.4.01.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.4.02.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUÇÃO','REGISTRA O VALOR, AINDA, NÃO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.4.03.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.4.04.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANÇAS PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.4.05.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS RECEBIDAS EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO RECEBIDO DAS CONTRAGARANTIAS POR FIANÇAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.4.06.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANÇAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.4.07.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.4.08.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUÇÃO','REGISTRA O VALOR, AINDA, NÃO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.4.09.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.4.10.00.00.00.0000','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUÇÃO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.4.11.00.00.00.0000','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.1.4.12.00.00.00.0000','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.0.00.00.00.00.0000','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUÇÃO DOS CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.1.00.00.00.00.0000','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUÇÃO DOS CONVÊNIOS E OUTROS INSTRUMENTOS CONGÊNERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.1.01.00.00.00.0000','CONVÊNIOS E INSTRUMENTOS CONGENERES A RECEBER','REGISTRA A EXECUÇÃO DOS VALORES DAS PARCELAS A RECEBER DE CONVÊNIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.1.02.00.00.00.0000','CONVÊNIOS E INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUÇÃO DOS VALORES A COMPROVAR DE CONVÊNIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.1.03.00.00.00.0000','CONVÊNIOS E INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUÇÃO DOS VALORES A APROVAR DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.1.04.00.00.00.0000','CONVÊNIOS E INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUÇÃO DOS VALORES APROVADOS DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.1.05.00.00.00.0000','CONVÊNIOS E INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUÇÃO DOS VALORES IMPUGNADOS DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.1.06.00.00.00.0000','CONVÊNIOS E INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUÇÃO DOS VALORES HOMOLOGADOS DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.1.07.00.00.00.0000','CONVÊNIOS E INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO FIRMADO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.1.08.00.00.00.0000','CONVÊNIOS E INSTRUMENTOS CONGENERES NÃO RECEBIDOS','REGISTRA O VALOR NÃO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.1.09.00.00.00.0000','CONVÊNIOS E INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE CONVENIO FIRMADO , APOS A APROVAÇÃO TOTAL DA PRESTAÇÃO DE CONTAS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.1.10.00.00.00.0000','CONVÊNIOS E INSTRUMENTOS CONGENERES INADIMPLENTES','REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS NA SITUAÇÃO DE CONVENIOS RECEBIDOS INADIMPLENTES.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.2.00.00.00.00.0000','TERMO DE COOPERAÇÃO','COMPREENDE A EXECUÇÃO DOS VALORES DE TERMO DE COOPERAÇÃO PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.2.01.00.00.00.0000','TERMO DE COOPERAÇÃO A RECEBER','REGISTRA A EXECUÇÃO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERAÇÃO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.2.02.00.00.00.0000','TERMO DE COOPERAÇÃO A COMPROVAR','REGISTRA A EXECUÇÃO DOS VALORES A COMPROVAR DE TERMOS DE COOPERAÇÃO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.2.03.00.00.00.0000','TERMO DE COOPERAÇÃO A APROVAR','REGISTRA A EXECUÇÃO DOS VALORES A APROVAR DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.2.04.00.00.00.0000','TERMO DE COOPERAÇÃO APROVADOS','REGISTRA A EXECUÇÃO DOS VALORES APROVADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.2.05.00.00.00.0000','TERMO DE COOPERAÇÃO IMPUGNADOS','REGISTRA A EXECUÇÃO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.2.06.00.00.00.0000','TERMO DE COOPERAÇÃO CANCELADOS','REGISTRA O VALOR CANCELADO DO TERMOS DE COOPERAÇÃO FIRMADOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.2.07.00.00.00.0000','TERMO DE COOPERAÇÃO NÃO RECEBIDOS','REGISTRA O VALOR NÃO RECEBIDO RELATIVO AO TOTAL FIRMADOS DO TERMO DE COOPERAÇÃO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.2.2.08.00.00.00.0000','TERMO DE COOPERAÇÃO CONCLUÍDOS','REGISTRA O VALOR CONCLUIDO DE TERMOS DE COOPERAÇÃO FIRMADOS , APOS A APROVAÇÃO TOTAL DA PRESTAÇÃO DE CONTAS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.0.00.00.00.00.0000','EXECUÇÃO DE DIREITOS CONTRATUAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.00.00.00.00.0000','EXECUÇÃO DE DIREITOS CONTRATUAIS - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.01.00.00.00.0000','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONAS AO REGISTRO DA EXECUÇÃO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.01.01.00.00.0000','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIAR RELATIVOS AOS SERVIÇOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.01.02.00.00.0000','EXECUTADOS','REGISTRA A EXECUÇÃO DOS VALORES APROPRIADOS RELATIVOS AOS SERVIÇOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.02.00.00.00.0000','CONTRATOS DE SERVIÇOS','COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUÇÃO DOS VALORES DO CONTRATO DE SERVIÇOS EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.02.01.00.00.0000','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DOS VALORES A REALIZAR RELATIVOS A PRESTAÇÃO DE SERVIÇOS, CONFORME INSTRUMENTO CONTRATUAL EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATADA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.02.02.00.00.0000','EXECUTADOS','REGISTRA A EXECUÇÃO DOS VALORES REALIZADOS DO CONTRATO DE SERVIÇOS EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.03.00.00.00.0000','CONTRATOS DE ALUGUEIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PÚBLICO SEJA O LOCADOR DO BEM.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.03.01.00.00.0000','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PÚBLICO SEJA O LOCADOR DO BEM.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.03.02.00.00.0000','EXECUTADOS','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PÚBLICO SEJA O LOCADOR DO BEM.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.04.00.00.00.0000','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRAÇÃO PÚBLICA A TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.04.01.00.00.0000','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS PELA ADMINISTRAÇÃO PÚBLICA A TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.04.02.00.00.0000','EXECUTADOS','REGISTRA A EXECUÇÃO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRAÇÃO PÚBLICA A TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.05.00.00.00.0000','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUÇÃO EXECUÇÃO DE CONTRATOS DE OBRIGAÇÕES DA ENTIDADE PÚBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCÍCIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.05.01.00.00.0000','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGAÇÕES DA ENTIDADE PÚBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCÍCIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.05.02.00.00.0000','EXECUTADOS','REGISTRA A EXECUÇÃO DE VALORES LIBERADOS RELATIVOS A CONTRATOS DE OBRIGAÇÕES DA ENTIDADE PÚBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCÍCIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.06.00.00.00.0000','CONTRATOS DE OBRIGAÇÕES INTERNAS','REGISTRA A APROPRIAÇÃO DE CONTRATOS DE OBRIGAÇÕES INTERNAS CONSTANTES DO ORÇAMENTO CORRENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.06.01.00.00.0000','CONTRATOS A RECEBER','REGISTRA A APROPRIAÇÃO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGAÇÕES INTERNAS CONSTANTES DO ORÇAMENTO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.06.02.00.00.0000','CONTRATOS RECEBIDOS','REGISTRA A APROPRIAÇÃO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGAÇÕES INTERNAS CONSTANTES DO ORÇAMENTO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.06.03.00.00.0000','CONTRATOS AMORTIZADOS','REGISTRA A APROPRIAÇÃO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETARIA E CAMBIAL REFERENTE A CONTRATOS DE OBRIGAÇÕES INTERNAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.06.04.00.00.0000','JUROS APROPRIADOS','REGISTRA A APROPRIAÇÃO DOS JUROS SOBRE CONTRATOS DE OBRIGAÇÕES INTERNAS CONSTANTES DO ORÇAMENTO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.06.05.00.00.0000','JUROS PAGOS','REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGAÇÕES INTERNAS CONSTANTES DO ORÇAMENTO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.06.06.00.00.0000','ENCARGOS APROPRIADOS','REGISTRA A APROPRIAÇÃO DOS ENCARGOS REFERENTES A CONTRATOS DE OBRIGA COES INTERNAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.06.07.00.00.0000','ENCARGOS PAGOS','REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGAÇÕES INTER-NAS CONSTANTES DO ORÇAMENTO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.07.00.00.00.0000','CONTRATOS DE OBRIGAÇÕES EXTERNAS','COMPREENDE VALORES RELACIONADOA A EXECUÇÃO DE CONTRATO REFERENTE A OBRIGAÇÕES DA DÍVIDA E DAS OPERAÇÕES DE CRÉDITO EXTERNAS CONTRATADAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.07.01.00.00.0000','CONTRATOS A RECEBER','REGISTRA A APROPRIAÇÃO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGAÇÕES EXTERNAS CONSTANTES DO ORÇAMENTO DO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.07.02.00.00.0000','CONTRATOS RECEBIDOS','REGISTRA A APROPRIAÇÃO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGAÇÕES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORÇAMENTO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.07.03.00.00.0000','CONTRATOS AMORTIZADOS','REGISTRA A APROPRIAÇÃO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETA-RIA E CAMBIAL REFERENTES A CONTRATOS DE OBRIGAÇÕES EXTERNAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.07.04.00.00.0000','JUROS APROPRIADOS','REGISTRA A APROPRIAÇÃO DOS JUROS SOBRE CONTRATOS DE OBRIGAÇÕES EXTER NAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.07.05.00.00.0000','JUROS PAGOS','REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGAÇÕES EXTERNAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.07.06.00.00.0000','ENCARGOS APROPRIADOS','REGISTRA A APROPRIAÇÃO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGAÇÕES EXTERNAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.07.07.00.00.0000','ENCARGOS PAGOS','REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGAÇÕES EXTERNAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.07.08.00.00.0000','CONTRATOS TRANSFERIDOS','REGISTRA A APROPRIAÇÃO DOS VALORES TRANSFERIDOS REFERENTES A CONTRATOS DE OBRIGAÇÕES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORÇAMENTO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.08.00.00.00.0000','CONTRATOS DE PPP - DO ENTE FEDERADO','COMPREENDE O VALOR POR CONTRATO DAS DESPESAS DERIVADAS DE PPP CONTRATADAS PELO ENTE DA FEDERAÇÃO EXCLUÍDAS AS EMPRESAS ESTATAIS NÃO DEPENDENTES. DEVEM ABRANGER AS DESPESAS COM A PARCELA FIXA DA CONTRAPRESTAÇÃO PECUNIÁRIA, COM A PARCELA VARIÁVEL VINCULADA AO DESEMPENHO DO PARCEIRO PRIVADO E COM OS DIFERENTES RISCOS PROVISIONADOS. INCLUI OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP QUE JÁ FORAM LIQUIDADAS NO EXERCÍCIO ATUAL, BEM COMO AS PREVISÕES DE DESPESAS DE PPP PARA OS PRÓXIMOS 9 ANOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.08.01.00.00.0000','CONTRATOS DE PPP - DO ENTE FEDERADO - EC','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP QUE JÁ FORAM LIQUIDADAS NO EXERCÍCIO ATUAL, BEM COMO AS PREVISÕES DE DESPESAS DE PPP PARA O RESTO DO ANO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.08.02.00.00.0000','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 1','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 1º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.08.03.00.00.0000','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 2','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 2º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.08.04.00.00.0000','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 3','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 3º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.08.05.00.00.0000','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 4','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 4º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.08.06.00.00.0000','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 5','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 5º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.08.07.00.00.0000','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 6','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 6º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.08.08.00.00.0000','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 7','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 7º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.08.09.00.00.0000','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 8','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 8º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.08.10.00.00.0000','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 9','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 9º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.09.00.00.00.0000','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES','COMPREENDE O VALOR POR CONTRATO DAS DESPESAS DERIVADAS DE PPP CONTRATADAS PELAS EMPRESAS ESTATAIS NÃO DEPENDENTES. DEVEM ABRANGER AS DESPESAS COM A PARCELA FIXA DA CONTRAPRESTAÇÃO PECUNIÁRIA, COM A PARCELA VARIÁVEL VINCULADA AO DESEMPENHO DO PARCEIRO PRIVADO E COM OS DIFERENTES RISCOS PROVISIONADOS. INCLUI OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP QUE JÁ FORAM LIQUIDADAS NO EXERCÍCIO ATUAL, BEM COMO AS PREVISÕES DE DESPESAS DE PPP PARA OS PRÓXIMOS 9 ANOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.09.01.00.00.0000','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP QUE JÁ FORAM LIQUIDADAS NO EXERCÍCIO ATUAL, BEM COMO AS PREVISÕES DE DESPESAS DE PPP PARA O RESTO DO ANO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.09.02.00.00.0000','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 1','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 1º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.09.03.00.00.0000','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 2','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 2º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.09.04.00.00.0000','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 3','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 3º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.09.05.00.00.0000','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 4','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 4º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.09.06.00.00.0000','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 5','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 5º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.09.07.00.00.0000','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 6','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 6º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.09.08.00.00.0000','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 7','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 7º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.09.09.00.00.0000','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 8','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 8º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.09.10.00.00.0000','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 9','REGISTRA, POR CONTRATO, OS VALORES DAS DESPESAS DERIVADAS DE CONTRATOS DE PPP NO 9º ANO SEGUINTE AO EXERCÍCIO CORRENTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.99.00.00.00.0000','OUTROS DIREITOS CONTRATUAIS','COMPREENDE CONTAS RELACIONAS AO REGISTRO DA EXECUÇÃO DOS VALORES DE OUTROS DIREITOS CONTRATUAIS EM QUE A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.99.01.00.00.0000','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIAR RELATIVOS AOS SERVIÇOS DE SEGUROS , CONFORME PREVISÃO CONTRATUAL.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.3.1.99.02.00.00.0000','EXECUTADOS','REGISTRA A EXECUÇÃO DOS VALORES APROPRIADOS RELATIVOS AOS SERVIÇOS DE SEGUROS , CONFORME PREVISÃO CONTRATUAL.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.0.00.00.00.00.0000','EXECUÇÃO DE OUTROS ATOS POTENCIAIS ATIVOS','COMPREENDE A EXECUÇÃO DOS ATOS POTENCIAIS ATIVOS NÃO CONTEMPLADOS EM CONTAS ESPECIFICAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.1.00.00.00.00.0000','EXECUÇÃO DE OUTROS ATOS POTENCIAIS ATIVOS - CONSOLIDAÇÃO','COMPREENDE A EXECUÇÃO DOS ATOS POTENCIAIS ATIVOS NÃO CONTEMPLADOS EM CONTAS ESPECIFICAS. COMPREENDE OS SALDOS QUE NÃO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.1.01.00.00.00.0000','DEPÓSITOS EM CAUÇÕES CONCEDIDOS','COMPREENDE OS ATOS POTENCIAIS ATIVOS, REFERENTES A RESPONSABILIDADES POR TÍTULOS, VALORES OU BENS RECEDIDOS DE TERCEIROS EM DEPÓSITOS EM CAUÇÃO CONCEDIDOS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.1.02.00.00.00.0000','COMODATO DE BENS CONCEDIDOS','COMPREENDE OS ATOS POTENCIAIS ATIVOS, REFERENTES A RESPONSABILIDADES POR TÍTULOS, VALORES OU BENS EM COMODATO DE BENS CONCEDIDOS A TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.1.03.00.00.00.0000','SUPRIMENTO DE FUNDOS','COMPREENDE OS ATOS POTENCIAIS ATIVOS, REFERENTES A RESPONSABILIDADES POR TÍTULOS, VALORES OU BENS EM SUPRIMENTOS DE FUNDOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.1.03.01.00.00.0000','SUPRIMENTO DE FUNDOS A EMPENHAR','COMPREENDE OS ATOS POTENCIAIS ATIVOS, REFERENTES A RESPONSABILIDADES POR TÍTULOS, VALORES OU BENS EM SUPRIMENTOS DE FUNDOS QUE AINDA NÃO FOI EMPENHADO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.1.03.02.00.00.0000','SUPRIMENTO DE FUNDOS EMPENHADO','COMPREENDE OS ATOS POTENCIAIS ATIVOS, REFERENTES A RESPONSABILIDADES POR TÍTULOS, VALORES OU BENS EM SUPRIMENTOS DE FUNDOS EMPENHADO E AINDA NÃO LIQUIDADO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.1.03.03.00.00.0000','SUPRIMENTO DE FUNDOS LIQUIDADO','COMPREENDE OS ATOS POTENCIAIS ATIVOS, REFERENTES A RESPONSABILIDADES POR TÍTULOS, VALORES OU BENS EM SUPRIMENTOS DE FUNDOS QUE LIQUIDADO E AINDA NÃO PAGO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.1.03.04.00.00.0000','SUPRIMENTO DE FUNDOS A COMPROVAR','COMPREENDE OS ATOS POTENCIAIS ATIVOS, REFERENTES A RESPONSABILIDADES POR TÍTULOS, VALORES OU BENS EM SUPRIMENTOS DE FUNDOS PAGO E AINDA NÃO COMPROVADO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.1.03.05.00.00.0000','SUPRIMENTO DE FUNDOS A APROVAR','COMPREENDE OS ATOS POTENCIAIS ATIVOS, REFERENTES A RESPONSABILIDADES POR TÍTULOS, VALORES OU BENS EM SUPRIMENTOS DE FUNDOS PAGO E COMPROVADO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.1.03.06.00.00.0000','SUPRIMENTO DE FUNDOS APROVADO','COMPREENDE OS ATOS POTENCIAIS ATIVOS, REFERENTES A RESPONSABILIDADES POR TÍTULOS, VALORES OU BENS EM SUPRIMENTOS DE FUNDOS COM A PRESTAÇÃO DE CONTAS APROVADA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.1.03.07.00.00.0000','SUPRIMENTO DE FUNDOS IMPUGNADO','COMPREENDE OS ATOS POTENCIAIS ATIVOS, REFERENTES A RESPONSABILIDADES POR TÍTULOS, VALORES OU BENS EM SUPRIMENTOS DE FUNDOS COM IMPUGNAÇÕES DE DESPESAS NA PRESTAÇÃO DE CONTAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.1.03.08.00.00.0000','SUPRIMENTO DE FUNDOS INADIMPLENTE','COMPREENDE OS ATOS POTENCIAIS ATIVOS, REFERENTES A RESPONSABILIDADES POR TÍTULOS, VALORES OU BENS EM SUPRIMENTOS DE FUNDOS QUE VENCEU O PRAZO DE PRESTAÇÃO DE CONTAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.1.03.09.00.00.0000','SUPRIMENTO DE FUNDOS CANCELADO','COMPREENDE OS ATOS POTENCIAIS ATIVOS, REFERENTES A RESPONSABILIDADES POR TÍTULOS, VALORES OU BENS EM SUPRIMENTOS DE FUNDOS CANCELADO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.2.00.00.00.00.0000','PLANO DE AMORTIZAÇÃO DO DÉFICIT ATUARIAL','REGISTRAR, A TÍTULO DE CONTROLE, OS VALORES RELATIVOS AO PLANO DE AMORTIZAÇÃO DO DÉFICIT ATUARIAL DO RPPS PELO ENTE PÚBLICO QUE O INSTITUIU.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.1.9.3.00.00.00.00.0000','PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','REGISTRAR, A TÍTULO DE CONTROLE, OS VALORES RELATIVOS ÀS PARCELAS DE DÉBITOS PREVIDENCIÁRIOS DO RPPS DEVIDAS PELO ENTE PÚBLICO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.0.0.00.00.00.00.0000','EXECUÇÃO DOS ATOS POTENCIAIS PASSIVOS','REGISTRA A EXECUÇÃO DOS ATOS E FATOS QUE POSSA VIR A AFETAR O PASSIVO DA ENTIDADE GOVERNAMENTAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.0.00.00.00.00.0000','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.00.00.00.00.0000','EXECUÇÃO DE GARANTIAS CONCEDIDAS NO PAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS CONCEDIDAS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.01.00.00.00.0000','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.02.00.00.00.0000','AVAIS EM EXECUÇÃO','REGISTRA O VALOR, AINDA, NÃO PAGO DAS GARANTIAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.03.00.00.00.0000','AVAIS EXECUTADOS','REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.04.00.00.00.0000','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANÇAS PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.05.00.00.00.0000','FIANÇAS EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO PAGO DAS GARANTIAS POR FIANÇAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.06.00.00.00.0000','FIANÇAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANÇAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.07.00.00.00.0000','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.08.00.00.00.0000','HIPOTECAS EM EXECUÇÃO','REGISTRA O VALOR NÃO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUÇÃO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.09.00.00.00.0000','HIPOTECAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.10.00.00.00.0000','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.11.00.00.00.0000','SEGUROS-GARANTIA EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.12.00.00.00.0000','SEGUROS-GARANTIA EXECUTADOS','REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.13.00.00.00.0000','CAUÇÃO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUÇÃO PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.14.00.00.00.0000','CAUÇÃO EM EXECUÇÃO','REGISTRA O VALOR NÃO PAGO DAS GARANTIAS POR CAUÇÃO EM EXECUÇÃO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.15.00.00.00.0000','CAUÇÃO EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUÇÃO NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.16.00.00.00.0000','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.17.00.00.00.0000','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.18.00.00.00.0000','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.19.00.00.00.0000','OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.20.00.00.00.0000','OUTRAS GARANTIAS CONCEDIDAS EM EXECUÇÃO','REGISTRA O VALOR NÃO PAGO DE OUTRAS GARANTIAS EM EXECUÇÃO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.1.21.00.00.00.0000','OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.00.00.00.00.0000','EXECUÇÃO DE GARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.01.00.00.00.0000','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.02.00.00.00.0000','AVAIS EM EXECUÇÃO','REGISTRA O VALOR NÃO PAGO DAS GARANTIAS POR AVAL EM EXECUÇÃO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.03.00.00.00.0000','AVAIS EXECUTADOS','REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.04.00.00.00.0000','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANÇAS PENDENTES DE EXECUÇÃO , NO EXTERIOR','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.05.00.00.00.0000','FIANÇAS EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO PAGO DAS GARANTIAS POR FIANÇAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.06.00.00.00.0000','FIANÇAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANÇAS, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.07.00.00.00.0000','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.08.00.00.00.0000','HIPOTECAS EM EXECUÇÃO','REGISTRA O VALOR NÃO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUÇÃO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.09.00.00.00.0000','HIPOTECAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.10.00.00.00.0000','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUÇÃO , NO EXTERIOR','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.11.00.00.00.0000','SEGUROS-GARANTIA EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.12.00.00.00.0000','SEGUROS-GARANTIA EXECUTADOS','REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.13.00.00.00.0000','CAUÇÃO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUÇÃO PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.14.00.00.00.0000','CAUÇÃO EM EXECUÇÃO','REGISTRA O VALOR NÃO PAGO DAS GARANTIAS POR CAUÇÃO EM EXECUÇÃO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.15.00.00.00.0000','CAUÇÃO EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUÇÃO NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.16.00.00.00.0000','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.17.00.00.00.0000','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.18.00.00.00.0000','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.19.00.00.00.0000','OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.20.00.00.00.0000','OUTRAS GARANTIAS CONCEDIDAS EM EXECUÇÃO','REGISTRA O VALOR NÃO PAGO DE OUTRAS GARANTIAS EM EXECUÇÃO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.2.21.00.00.00.0000','OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.3.00.00.00.00.0000','EXECUÇÃO DE CONTRAGARANTIAS CONCEDIDAS NO PAIS','COMPREENDE A EXECUÇÃO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGAÇÕES CONTRAIDAS NO PAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.3.01.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.3.02.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUÇÃO','REGISTRA O VALOR, AINDA, NÃO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.3.03.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.3.04.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANÇAS PENDENTES DE EXECUÇÃO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.3.05.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS RECEBIDAS EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO PAGOS DAS CONTRAGARANTIAS SOBRE FIANÇAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.3.06.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE FIANÇAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.3.07.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.3.08.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUÇÃO','REGISTRA O VALOR, AINDA, NÃO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.3.09.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.3.10.00.00.00.0000','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.3.11.00.00.00.0000','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.3.12.00.00.00.0000','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.4.00.00.00.00.0000','EXECUÇÃO DE CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE A EXECUÇÃO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGAÇÕES CONTRAIDAS NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.4.01.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.4.02.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUÇÃO','REGISTRA O VALOR, AINDA, NÃO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.4.03.00.00.00.0000','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.4.04.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANÇAS PENDENTES DE EXECUÇÃO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.4.05.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS RECEBIDAS EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO PAGO DAS CONTRAGARANTIAS POR FIANÇAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.4.06.00.00.00.0000','CONTRAGARANTIAS SOBRE FIANÇAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS POR FIANÇAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.4.07.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.4.08.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUÇÃO','REGISTRA O VALOR, AINDA, NÃO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.4.09.00.00.00.0000','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.4.10.00.00.00.0000','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUÇÃO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.4.11.00.00.00.0000','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EM EXECUÇÃO','REGISTRA O VALOR AINDA NÃO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.1.4.12.00.00.00.0000','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.0.00.00.00.00.0000','EXECUÇÃO DE OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DA EXECUÇÃO DO VALOR DOS CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.1.00.00.00.00.0000','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUÇÃO DOS CONVÊNIOS E OUTROS INSTRUMENTOS CONGÊNERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.1.01.00.00.00.0000','CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES A LIBERAR','REGISTRA OS VALORES DAS PARCELAS A LIBERAR DE CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.1.01.01.00.00.0000','CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES A EMPENHAR','COMPREENDE O VALOR TOTAL CONCEDIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS A EMPENHAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.1.01.02.00.00.0000','CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES EMPENHADOS A LIQUIDAR','COMPREENDE O VALOR TOTAL CONCEDIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS EMPENHADOS A LIQUIDAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.1.01.03.00.00.0000','CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES A PAGAR','COMPREENDE O VALOR TOTAL CONCEDIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS LIQUIDADOS A PAGAR','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.1.02.00.00.00.0000','CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUÇÃO DOS VALORES A COMPROVAR DE CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.1.03.00.00.00.0000','CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUÇÃO DOS VALORES A APROVAR DE CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.1.04.00.00.00.0000','CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUÇÃO DOS VALORES APROVADOS DE CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.1.05.00.00.00.0000','CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUÇÃO DOS VALORES IMPUGNADOS DE CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.1.06.00.00.00.0000','CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUÇÃO DOS VALORES HOMOLOGADOS DE CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.1.07.00.00.00.0000','CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.1.08.00.00.00.0000','CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES NÃO LIBERADOS','REGISTRA O VALOR NÃO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSAÇÃO EXCCONV, TIPO DE EXECUÇÃO NR. 13.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.1.09.00.00.00.0000','CONVÊNIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVAÇÃO TOTAL DA PRESTAÇÃO DE CONTAS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.1.10.00.00.00.0000','CONVENIOS RECEBIDOS INADIMPLENTES','COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS NA SITUAÇÃO DE CONVENIOS RECEBIDOS INADIMPLENTES.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.2.00.00.00.00.0000','EXECUÇÃO DE CONTRATOS DE REPASSE DE PROGRAMAS ESPECIFICOS','COMPREENDE O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.2.01.00.00.00.0000','CONTRATOS DE REPASSE DE PROGRAMAS A LIBERAR','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS A LIBERAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.2.02.00.00.00.0000','CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS LIBERADOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.2.03.00.00.00.0000','CONTR.REPASSE DE PROGR. A APROVAR','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA ENTREGA DA PRESTAÇÃO DE CONTAS PELO CONTRATANTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.2.04.00.00.00.0000','CONTR.REPASSE DE PROGR. APROVADO','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA APROVAÇÃO DA PRESTAÇÃO DE CONTAS PELO GESTOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.2.05.00.00.00.0000','CONTR.REPASSE DE PROGR. HOMOLOGADO','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA HOMOLOGAÇÃO DA PRESTAÇÃO DE CONTAS PELO CONTROLE INTERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.2.2.06.00.00.00.0000','CONTR.REPASSE DE PROGR. IMPUGNADO','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA IMPUGNAÇÃO DA PRESTAÇÃO DE CONTAS PELO CONTROLE INTERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.0.00.00.00.00.0000','EXECUÇÃO DE OBRIGAÇÕES CONTRATUAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DOS VALORES DE OBRIGAÇÕES CONTRATUAIS, QUANDO A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATANTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.1.00.00.00.00.0000','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.1.01.00.00.00.0000','A EMPENHAR','REGISTRA VALORES A APROPRIAR RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRAÇÃO SEJA A CONTRATANTE, A EMPENHAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.1.02.00.00.00.0000','EMPENHADOS A LIQUIDAR','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIAR RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRAÇÃO SEJA A CONTRATANTE, EMPENHADOS A LIQUIDAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.1.03.00.00.00.0000','LIQUIDADOS A PAGAR','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIAR RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRAÇÃO SEJA A CONTRATANTE, LIQUIDADOS A PAGAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.1.04.00.00.00.0000','PAGOS','REGISTRA A EXECUÇÃO DOS VALORES APROPRIADOS RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRAÇÃO SEJA A CONTRATANTE, PAGOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.2.00.00.00.00.0000','CONTRATOS DE SERVIÇOS','COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUÇÃO DOS VALORES DO CONTRATO DE SERVIÇOS EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATANTE .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.2.01.00.00.00.0000','A EMPENHAR','REGISTRA VALORES A APROPRIAR RELATIVO A CONTRATOS DE SERVIÇOS , EM QUE ADMINISTRAÇÃO SEJA A CONTRATANTE, A EMPENHAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.2.02.00.00.00.0000','EMPENHADOS A LIQUIDAR','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIAR RELATIVO A CONTRATOS DE SERVIÇOS , EM QUE ADMINISTRAÇÃO SEJA A CONTRATANTE, EMPENHADOS A LIQUIDAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.2.03.00.00.00.0000','LIQUIDADOS A PAGAR','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIAR RELATIVO A CONTRATOS DE SERVIÇOS , EM QUE ADMINISTRAÇÃO SEJA A CONTRATANTE, LIQUIDADOS A PAGAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.2.04.00.00.00.0000','PAGOS','REGISTRA A EXECUÇÃO DOS VALORES APROPRIADOS RELATIVO A CONTRATOS DE SERVIÇOS , EM QUE ADMINISTRAÇÃO SEJA A CONTRATANTE, PAGOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.3.00.00.00.00.0000','CONTRATOS DE ALUGUEIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PÚBLICO SEJA O LOCATARIO DO BEM.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.3.01.00.00.00.0000','A EMPENHAR','REGISTRA VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PÚBLICO SEJA O LOCATARIO DO BEM, A EMPENHAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.3.02.00.00.00.0000','EMPENHADOS A LIQUIDAR','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PÚBLICO SEJA O LOCATARIO DO BEM, EMPENHADOS A LIQUIDAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.3.03.00.00.00.0000','LIQUIDADOS A PAGAR','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PÚBLICO SEJA O LOCATARIO DO BEM, LIQUIDADOS A PAGAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.3.04.00.00.00.0000','PAGOS','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PÚBLICO SEJA O LOCATARIO DO BEM, PAGOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.4.00.00.00.00.0000','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRAÇÃO PÚBLICA A TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.4.01.00.00.00.0000','A EMPENHAR','REGISTRA VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS POR TERCEIROS A ADMINISTRAÇÃO PÚBLICA, A EMPENHAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.4.02.00.00.00.0000','EMPENHADOS A LIQUIDAR','REGISTRA A EXECUÇÃO DOS VALORES A REALIZAR REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS POR ADMINISTRAÇÃO A PÚBLICA, EMPENHADOS A LIQUIDAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.4.03.00.00.00.0000','LIQUIDADOS A PAGAR','REGISTRA A EXECUÇÃO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS POR TERCEIROS A ADMINISTRAÇÃO PÚBLICA, LIQUIDADOS A PAGAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.4.04.00.00.00.0000','PAGOS','REGISTRA A EXECUÇÃO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS POR ADMINISTRAÇÃO A PÚBLICA, PAGOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.5.00.00.00.00.0000','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUÇÃO EXECUÇÃO DE CONTRATOS DE OBRIGAÇÕES DA ENTIDADE PÚBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCÍCIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.5.01.00.00.00.0000','A EMPENHAR','REGISTRA VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGAÇÕES DA ENTIDADE PÚBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCÍCIO, A EMPENHAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.5.02.00.00.00.0000','EMPENHADOS A LIQUIDAR','REGISTRA A EXECUÇÃO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGAÇÕES DA ENTIDADE PÚBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCÍCIO, EMPENHADOS A LIQUIDAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.5.03.00.00.00.0000','LIQUIDADOS A PAGAR','REGISTRA A EXECUÇÃO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGAÇÕES DA ENTIDADE PÚBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCÍCIO, LIQUIDADOS A PAGAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.5.04.00.00.00.0000','PAGOS','REGISTRA A EXECUÇÃO DE VALORES A LIBERADOS RELATIVOS A CONTRATOS DE OBRIGAÇÕES DA ENTIDADE PÚBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCÍCIO, PAGOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.6.00.00.00.00.0000','EXECUÇÃO DE CONTRATO DE GESTAO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUÇÃO DOS CONTRATOS DE GESTAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.6.01.00.00.00.0000','CONTRATOS DE GESTAO A LIQUIDAR','REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRAÇÃO PÚBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.6.02.00.00.00.0000','CONTRATOS DE GESTAO LIQUIDADOS','REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRAÇÃO PÚBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.7.00.00.00.00.0000','CONTRATOS DE OPERAÇÕES DE CRÉDITO','COMPREENDE A EXECUÇÃO DAS CONTAS QUE REGISTRAM O VALOR DO CONTRATO DECORRENTE DE OPERAÇÕES DE CRÉDITO ENTRE ORGÃO OU ENTIDADE CONTRATANTE E TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.7.01.00.00.00.0000','A EMPENHAR','REGISTRA O VALOR DO CONTRATO A LIBERAR DECORRENTE DE OPERAÇÕES DE CRÉDITO, A EMPENHAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.7.02.00.00.00.0000','EMPENHADOS A LIQUIDAR','REGISTRA A EXECUÇÃO DO VALOR DO CONTRATO A LIBERAR DECORRENTE DE OPERAÇÕES DE CRÉDITO, EMPENHADO A LIQUIDAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.7.03.00.00.00.0000','LIQUIDADOS A PAGAR','REGISTRA A EXECUÇÃO DO VALOR DO CONTRATO A LIBERAR DECORRENTE DE OPERAÇÕES DE CRÉDITO, LIQUIDADOS A PAGAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.3.7.04.00.00.00.0000','PAGOS','REGISTRA A EXECUÇÃO DO VALOR DO CONTRATO LIBERADO DECORRENTE DE OPERAÇÕES DE CRÉDITO, PAGO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.9.0.00.00.00.00.0000','EXECUÇÃO DE OUTROS ATOS POTENCIAIS PASSIVOS','COMPREENDE A EXECUÇÃO DOS ATOS POTENCIAIS PASSIVOS NÃO CONTEMPLADOS EM CONTAS ESPECIFICAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.9.1.00.00.00.00.0000','EXECUÇÃO DE OUTROS ATOS POTENCIAIS PASSIVOS - CONSOLIDAÇÃO','COMPREENDE A EXECUÇÃO DOS ATOS POTENCIAIS PASSIVOS NÃO CONTEMPLADOS EM CONTAS ESPECIFICAS. COMPREENDE OS SALDOS QUE NÃO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.9.1.01.00.00.00.0000','BENEFICIARIOS DE SENTENCAS JUDICIAIS INCLUIDAS NO ORCAMENTO','NESTE GRUPO DEVEM SER REGISTRADOS OS PRECATÓRIOS, RECEBIDOS NO EXERCÍCIO ANTERIOR E INCLUÍDOS NO ORÇAMENTO PARA PAGAMENTO ATÉ O FINAL DO EXERCÍCIO. DEVE SE MANTER O CONTROLE NESTE GRUPO POR BENEFICIÁRIO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.1.2.9.1.02.00.00.00.0000','BENEFICIARIOS DE SENTENCAS JUDICIAIS AINDA NÃO INCLUIDAS NO ORCAMENTO','NESTE GRUPO DEVEM SER REGISTRADOS OS PRECATÓRIOS, RECEBIDOS NO EXERCÍCIO E QUE SERÃO INCLUÍDOS NO ORÇAMENTO SEGUINTE PARA PAGAMENTO ATÉ O FINAL DAQUELE EXERCÍCIO.DEVE SE MANTER O CONTROLE NESTE GRUPO POR BENEFICIÁRIO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.0.0.0.00.00.00.00.0000','EXECUÇÃO DA ADMINISTRAÇÃO FINANCEIRA','COMPREENDE AS CONTAS DE REGISTRO DA EXECUÇÃO DA PROGRAMAÇÃO FINANCEIRA E DE CONTROLE DAS DISPONIBILIDADES','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.0.0.00.00.00.00.0000','EXECUÇÃO DAS DISPONIBILIDADES POR DESTINAÇÃO','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUÇÃO DOS CONTROLES DAS DISPONIBILIDADES POR DESTINAÇÃO DE RECURSOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.1.0.00.00.00.00.0000','EXECUÇÃO DA DISPONIBILIDADE DE RECURSOS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUÇÃO DAS DISPONIBILIDADES DE RECURSOS A UTILIZAR, COMPROMETIDAS E UTILIZADAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.1.1.00.00.00.00.0000','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS','REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS A UTILIZAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.1.1.01.00.00.00.0000','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS - ORÇAMENTÁRIA','DISPONIBILIDADE POR DESTINACAO DE RECURSOS - RECURSOS LIVRES','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.1.1.02.00.00.00.0000','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS - TRANSFERêNCIA FINANCEIRA','DISPONIBILIDADE P/DESTIN. DE RECURSOS COMP. P/TRANSF. FINANCEIRAS CONCEDIDAS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.1.2.00.00.00.00.0000','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR EMPENHO','REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS COMPROMETIDAS POR OCASIAO DO EMPENHO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.1.3.00.00.00.00.0000','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR LIQUIDAÇÃO E ENTRADAS COMPENSATORIAS','REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS COMPROMETIDAS POR OCASIAO DA LIQUIDAÇÃO E DE ENTRADAS COMPENSATORIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.1.3.01.00.00.00.0000','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR LIQUIDACAO','REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS COMPROMETIDAS POR OCASIAO DA LIQUIDACAO E DE ENTRADAS COMPENSATORIAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.1.3.02.00.00.00.0000','DISPONIBILIDADE POR DESTINACAO DE RECURSOS COMPROMETIDA POR LIQUIDACAO - CONSIGNAÇÕES','REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS COMPROMETIDAS POR OCASIAO DA LIQUIDACAO E DE ENTRADAS COMPENSATORIAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.1.3.03.00.00.00.0000','DISPONIBILIDADE POR DESTINACAO DE RECURSOS COMPROMETIDA P/ENTRADAS COMPENSATORIAS','REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS COMPROMETIDAS POR OCASIAO DA LIQUIDACAO E DE ENTRADAS COMPENSATORIAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.1.4.00.00.00.00.0000','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS UTILIZADA','REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS UTILIZADAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.1.5.00.00.00.00.0000','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR PROGRAMAÇÃO FINANCEIRA','REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS COMPROMETIDAS POR PROGRAMAÇÃO FINANCEIRA NO ÓRGÃO CENTRAL DE PROGRAMAÇÃO FINANCEIRA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.2.0.00.00.00.00.0000','EXECUÇÃO FINANCEIRA DO LIMITE DE RESTOS A PAGAR','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUÇÃO FINANCEIRA DO LIMITE DE RESTOS A PAGAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.2.1.00.00.00.00.0000','EXECUÇÃO FINANCEIRA DO LIMITE DE RESTOS A PAGAR CONCEDIDO POR DESTINAÇÃO','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUÇÃO FINANCEIRA DO LIMITE DE RESTOS A PAGAR CONCEDIDO POR DESTINAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.2.1.01.00.00.00.0000','VALORES DE LIMITE DE RP A CONCEDER','REGISTRA O VALORES A CONCEDER, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINAÇÃO DE RECURSOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.2.1.02.00.00.00.0000','VALORES DE LIMITE DE RP CONCEDIDO','REGISTRA O VALORES CONCEDIDOS, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINAÇÃO DE RECURSOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.2.2.00.00.00.00.0000','EXECUÇÃO FINANCEIRA DO LIMITE DE RESTOS A PAGAR RECEBIDO POR DESTINAÇÃO','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUÇÃO FINANCEIRA DO LIMITE DE RESTOS A PAGAR RECEBIDO POR DESTINAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.2.2.01.00.00.00.0000','VALORES DE LIMITE DE RP A RECEBER','REGISTRA O VALORES A RECEBER, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINAÇÃO DE RECURSOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.2.2.02.00.00.00.0000','VALORES DE LIMITE DE RP RECEBIDO','REGISTRA O VALORES RECEBIDOS, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINAÇÃO DE RECURSOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.1.3.0.00.00.00.00.0000','EXECUÇÃO DO RECURSO DIFERIDO POR DESTINAÇÃO','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUÇÃO DOS RECURSOS DIFERIDOS. RECURSOS DIFERIDOS SAO AS SOBRAS DE RECURSOS FINANCEIROS AO FINAL DO EXERCÍCIO (RECURSO DIFERIDO), QUE DEVERIAM SER DEVOLVIDAS A CONTA UNICA, POREM, AO INVES DISSO, ESSAS SOBRAS SAO LIBERADAS PARA USO (APENAS NO EXERCÍCIO SEGUINTE) ATRAVES DE DESCONTOS DAS TRANSFERÊNCIAS FINANCEIRAS (COTA, REPASSE E SUB-REPASSE) DO EXERCÍCIO SEGUINTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.2.0.0.00.00.00.00.0000','EXECUÇÃO DA PROGRAMAÇÃO FINANCEIRA','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUÇÃO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.2.1.0.00.00.00.00.0000','EXECUÇÃO DAS COTAS ORÇAMENTÁRIAS','COMPREENDE O CONTROLE DA EXECUÇÃO DA PROGRAMAÇÃO ORÇAMENTÁRIA DO EXERCÍCIO, REFERENTE AO CRONOGRAMA DE DESEMBOLSO DO EXERCÍCIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.2.1.1.00.00.00.00.0000','COTAS ORÇAMENTÁRIAS A PROGAMAR','COMPREENDE O CONTROLE DA EXECUÇÃO DA PROGRAMAÇÃO ORÇAMENTÁRIA DO EXERCÍCIO, REFERENTE AS COTA A PROGRAMAR NO EXERCÍCIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.2.1.2.00.00.00.00.0000','COTAS ORÇAMENTÁRIAS A EMPENHAR','COMPREENDE O CONTROLE DA EXECUÇÃO DA PROGRAMAÇÃO ORÇAMENTÁRIA DO EXERCÍCIO, REFERENTE AS COTAS PROGRAMADAS E AINDA NÃO UTILIZADAS NO EXERCÍCIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.2.1.3.00.00.00.00.0000','COTAS ORÇAMENTÁRIAS EMPENHADAS','COMPREENDE O CONTROLE DA EXECUÇÃO DA PROGRAMAÇÃO ORÇAMENTÁRIA DO EXERCÍCIO, REFERENTE AS COTAS PROGRAMADAS E JÁ UTILIZADAS NA FASE DE EMPENHO DA DESPESA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.2.1.4.00.00.00.00.0000','COTAS ORÇAMENTÁRIAS LIQUIDADAS A PAGAR','COMPREENDE O CONTROLE DA EXECUÇÃO DA PROGRAMAÇÃO ORÇAMENTÁRIA DO EXERCÍCIO, REFERENTE AS COTAS PROGRAMADAS E JÁ UTILIZADAS NA FASE DE LIQUIDAÇÃO DA DESPESA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.2.1.5.00.00.00.00.0000','COTAS ORÇAMENTÁRIAS UTILIZADAS','COMPREENDE O CONTROLE DA EXECUÇÃO DA PROGRAMAÇÃO ORÇAMENTÁRIA DO EXERCÍCIO, REFERENTE AS COTAS PROGRAMADAS E JÁ UTILIZADAS NA FASE DE PAGAMENTO DA DESPESA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.2.1.6.00.00.00.00.0000','COTAS ORÇAMENTÁRIAS INDISPONÍVEL','COMPREENDE O CONTROLE DA EXECUÇÃO DA PROGRAMAÇÃO ORÇAMENTÁRIA DO EXERCÍCIO, REFERENTE AS COTASINDISPONIBILIZADAS PELO ÓRGÃO CENTRAL.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.2.2.0.00.00.00.00.0000','COTAS DE RESTOS A PAGAR','COMPREENDE O CONTROLE DA EXECUÇÃO DA PROGRAMAÇÃO ORÇAMENTÁRIA DO EXERCÍCIO, REFERENTE COTAS DE RESTOS A PAGAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.2.2.1.00.00.00.00.0000','COTAS DE RP NÃO PROCESSADOS','COMPREENDE O CONTROLE DA EXECUÇÃO DA PROGRAMAÇÃO DE RESTOS A PAGAR, REFERENTE AOS VALORES INSCRITOS EM RESTOS A PAGAR NÃO PROCESSADOS E AINDA NÃO LIQUIDADOS..','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.2.2.2.00.00.00.00.0000','COTAS DE RP NÃO PROCESSADOS LIQUIDADOS E RP PROCESSADOS','COMPREENDE O CONTROLE DA EXECUÇÃO DA PROGRAMAÇÃO DE RESTOS A PAGAR, REFERENTE AOS VALORES INSCRITOS EM RESTOS A PAGAR NÃO PROCESSADOS LIQUIDADOS E DOS RP PROCESSADOS..','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.2.2.3.00.00.00.00.0000','COTAS DE RP UTILIZADAS','COMPREENDE O CONTROLE DA EXECUÇÃO DA PROGRAMAÇÃO DE RESTOS A PAGAR, REFERENTE AOS VALORES INSCRITOS EM RESTOS A PAGAR NÃO PROCESSADOS E DOS RP PROCESSADOS JÁ PAGOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.3.0.0.00.00.00.00.0000','EXECUÇÃO DO LIMITE ORCAMENTARIO','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUÇÃO DO LIMITE DE EMPENHO E MOVIMENTAÇÃO DE CRÉDITOS ORCAMENTARIOS, CONFORME ESTABELECIDOS EM ATO PROPRIO DOS PODERES E MINISTERIO PÚBLICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.3.1.0.00.00.00.00.0000','EXECUÇÃO DO ORGÃO CENTRAL DE PROGRAMAÇÃO FINANCEIRA','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUÇÃO DO LIMITE ORCAMENTARIO NO OCPF','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.4.0.0.00.00.00.00.0000','CONTROLES DA ARRECADAÇÃO','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADAÇÃO DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADAÇÃO COMO DARF, GRU, DAR, ENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.4.1.0.00.00.00.00.0000','CONTROLES DE DOCUMENTO DE ARRECADAÇÃO','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADAÇÃO DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTO DE ARRECADAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.4.1.1.00.00.00.00.0000','CONTROLES DE DOCUMENTO DE ARRECADAÇÃO POR CODIGO DE RECEITA','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADAÇÃO DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.2.4.1.2.00.00.00.00.0000','CONTROLES DE DOCUMENTO DE ARRECADAÇÃO POR CODIGO DE DESTINAÇÃO VINCULADA','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADAÇÃO DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTO DE ARRECADAÇÃO, CLASSIFICADAS POR CODIGO DE DESTINAÇÃO VINCULADA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.0.0.0.00.00.00.00.0000','EXECUÇÃO DA DÍVIDA ATIVA','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUÇÃO DOS CRÉDITOS PASSIVEIS DE SEREM ENCAMINHADOS E INSCRITOS EM DÍVIDA ATIVA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.0.0.00.00.00.00.0000','EXECUÇÃO DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES A SEREM ENCAMINHADOS E OS JA ENCAMINHADOS PARA O ORGÃO COMPETENTE EM INSCREVER EM DÍVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.1.0.00.00.00.00.0000','CRÉDITOS A ENCAMINHAR PARA A DÍVIDA ATIVA','REGISTRA OS VALORES A SEREM ENCAMINHADOS PARA O ORGÃO COMPETENTE EM INSCREVER EM DÍVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.1.1.00.00.00.00.0000','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA TRIBUTÁRIA','COMPREENDE OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA TRIBUTÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.1.1.01.00.00.00.0000','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','REGISTRA OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, REFERENTES A IMPOSTOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.1.1.02.00.00.00.0000','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA TRIBUTÁRIA - TAXAS','REGISTRA OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, REFERENTES A TAXAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.1.1.03.00.00.00.0000','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','REGISTRA OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, REFERENTES A CONTRIBUIÇÃO DE MELHORIA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.1.2.00.00.00.00.0000','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA NÃO-TRIBUTÁRIA','COMPREENDE OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, REFERENTES A CRÉDITOS NÃO-TRIBUTÁRIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.1.2.01.00.00.00.0000','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA NÃO-TRIBUTÁRIA','REGISTRA OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, REFERENTES A CRÉDITOS NÃO-TRIBUTÁRIOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.2.0.00.00.00.00.0000','CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA','REGISTRA OS VALORES ENCAMINHADOS PARA O ORGÃO COMPETENTE EM INSCREVER EM DÍVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.2.1.00.00.00.00.0000','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA','COMPREENDE OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA TRIBUTÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.2.1.01.00.00.00.0000','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','REGISTRA OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, REFERENTES A IMPOSTOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.2.1.02.00.00.00.0000','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA - TAXAS','REGISTRA OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, REFERENTES A TAXAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.2.1.03.00.00.00.0000','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','REGISTRA OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, REFERENTES A CONTRIBUIÇÃO DE MELHORIA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.2.2.00.00.00.00.0000','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA NÃO-TRIBUTÁRIA','COMPREENDE OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, REFERENTES A CRÉDITOS NÃO-TRIBUTÁRIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.2.2.01.00.00.00.0000','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA NÃO-TRIBUTÁRIA','REGISTRA OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, REFERENTES A CRÉDITOS NÃO-TRIBUTÁRIOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.3.0.00.00.00.00.0000','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DÍVIDA ATIVA','REGISTRA O CANCELAMENTO DOS VALORES INDEVIDAMENTE ENCAMINHADOS PARA O ORGÃO COMPETENTE EM INSCREVER EM DÍVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.3.1.00.00.00.00.0000','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA','COMPREENDE OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA TRIBUTÁRIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.3.1.01.00.00.00.0000','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','REGISTRA OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, REFERENTES A IMPOSTOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.3.1.02.00.00.00.0000','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA - TAXAS','REGISTRA OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, REFERENTES A TAXAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.3.1.03.00.00.00.0000','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','REGISTRA OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, REFERENTES A CONTRIBUIÇÃO DE MELHORIA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.3.2.00.00.00.00.0000','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA NÃO-TRIBUTÁRIA','COMPREENDE OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, REFERENTES A CRÉDITOS NÃO-TRIBUTÁRIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.1.3.2.01.00.00.00.0000','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA NÃO-TRIBUTÁRIA','REGISTRA OS CRÉDITOS A SEREM ENCAMINHADOS PARA O ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, REFERENTES A CRÉDITOS NÃO-TRIBUTÁRIOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.0.0.00.00.00.00.0000','EXECUÇÃO DA INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES A SEREM INSCRITOS EM DÍVIDA ATIVA PELO ORGÃO COMPETENTE EM INSCREVER EM DÍVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.1.0.00.00.00.00.0000','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA','REGISTRA OS VALORES A SEREM INSCRITOS EM DÍVIDA ATIVA PELO O ORGÃO COMPETENTE EM INSCREVER EM DÍVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.1.1.00.00.00.00.0000','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA TRIBUTÁRIA','REGISTRA OS CRÉDITOS A SEREM INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.1.2.00.00.00.00.0000','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','REGISTRA OS CRÉDITOS A SEREM INSCRITOS EM DIVIDA ATIVA NÃO-TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.2.0.00.00.00.00.0000','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA DEVOLVIDOS','REGISTRA OS VALORES A SEREM INSCRITOS EM DÍVIDA ATIVA QUE FORAM DEVOLVIDOS PELO ORGÃO COMPETENTE, POR INCORRECOES NA FORMALIZAÇÃO DO PROCESSO DE ENCAMINHAMENTO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.2.1.00.00.00.00.0000','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA TRIBUTÁRIA DEVOLVIDOS','COMPREENDE OS CRÉDITOS A SEREM INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA QUE FORAM DEVOLVIDOS PELO ÓRGÃO COMPETENTE, POR INCORREÇÕES NA FORMALIZAÇÃO DO PROCESSO DE ENCAMINHAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.2.2.00.00.00.00.0000','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA NÃO TRIBUTÁRIA DEVOLVIDOS','COMPREENDE OS CRÉDITOS A SEREM INSCRITOS EM DIVIDA ATIVA NÃO TRIBUTÁRIA QUE FORAM DEVOLVIDOS PELO ÓRGÃO COMPETENTE, POR INCORREÇÕES NA FORMALIZAÇÃO DO PROCESSO DE ENCAMINHAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.3.0.00.00.00.00.0000','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA A RECEBER','REGISTRA OS VALORES INSCRITOS EM DÍVIDA ATIVA PELO O ORGÃO COMPETENTE EM INSCREVER EM DÍVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.3.1.00.00.00.00.0000','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER','REGISTRA OS CRÉDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.3.1.01.00.00.00.0000','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','REGISTRA OS CRÉDITOS A RECEBER, INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, EM FASE ADMINISTRATIVA DE COBRANÇA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.3.1.02.00.00.00.0000','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','REGISTRA OS CRÉDITOS A RECEBER, INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, EM FASE JUDICIAL DE COBRANÇA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.3.2.00.00.00.00.0000','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER','COMPREENDE OS CRÉDITOS A RECEBER, INSCRITOS EM DIVIDA ATIVA NÃO-TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, EM FASE ADMINISTRATIVA DE COBRANÇA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.3.2.01.00.00.00.0000','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','REGISTRA OS CRÉDITOS A RECEBER, INSCRITOS EM DIVIDA ATIVA NÃO-TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, EM FASE ADMINISTRATIVA DE COBRANÇA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.3.2.02.00.00.00.0000','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','REGISTRA OS CRÉDITOS A RECEBER, INSCRITOS EM DIVIDA ATIVA NÃO-TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, EM FASE JUDICIAL DE COBRANÇA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.4.0.00.00.00.00.0000','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA RECEBIDOS','REGISTRA RECEBIMENTO DOS VALORES RECEBIDOS RELATIVOS AOS CRÉDITOS ANTERIORMENTE INSCRITOS EM DÍVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.4.1.00.00.00.00.0000','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER','REGISTRA RECEBIMENTO DOS CRÉDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.4.1.01.00.00.00.0000','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','REGISTRA RECEBIMENTO DOS CRÉDITOS A RECEBER, INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, EM FASE ADMINISTRATIVA DE COBRANÇA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.4.1.02.00.00.00.0000','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','REGISTRA RECEBIMENTO DOS CRÉDITOS A RECEBER, INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, EM FASE JUDICIAL DE COBRANÇA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.4.2.00.00.00.00.0000','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER','COMPREENDE OS RECEBIMENTOS DE CRÉDITOS A RECEBER, INSCRITOS EM DIVIDA ATIVA NÃO-TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, EM FASE ADMINISTRATIVA DE COBRANÇA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.4.2.01.00.00.00.0000','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','REGISTRA RECEBIMENTO DOS CRÉDITOS A RECEBER, INSCRITOS EM DIVIDA ATIVA NÃO-TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, EM FASE ADMINISTRATIVA DE COBRANÇA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.4.2.02.00.00.00.0000','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','REGISTRA RECEBIMENTO DOS CRÉDITOS A RECEBER, INSCRITOS EM DIVIDA ATIVA NÃO-TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, EM FASE JUDICIAL DE COBRANÇA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.5.0.00.00.00.00.0000','BAIXA DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AS BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.5.1.00.00.00.00.0000','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER','REGISTRA BAIXAS DOS CRÉDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.5.1.01.00.00.00.0000','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','REGISTRA BAIXAS DOS CRÉDITOS A RECEBER, INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, EM FASE ADMINISTRATIVA DE COBRANÇA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.5.1.02.00.00.00.0000','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','REGISTRA BAIXAS DOS CRÉDITOS A RECEBER, INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, EM FASE JUDICIAL DE COBRANÇA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.5.2.00.00.00.00.0000','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER','COMPREENDE BAIXAS DOS CRÉDITOS A RECEBER, INSCRITOS EM DIVIDA ATIVA NÃO-TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, EM FASE ADMINISTRATIVA DE COBRANÇA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.5.2.01.00.00.00.0000','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','REGISTRA BAIXAS DOS CRÉDITOS A RECEBER, INSCRITOS EM DIVIDA ATIVA NÃO-TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, EM FASE ADMINISTRATIVA DE COBRANÇA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.3.2.5.2.02.00.00.00.0000','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','REGISTRA BAIXAS DOS CRÉDITOS A RECEBER, INSCRITOS EM DIVIDA ATIVA NÃO-TRIBUTÁRIA PELO ÓRGÃO COMPETENTE EM INSCREVER EM DIVIDA ATIVA, EM FASE JUDICIAL DE COBRANÇA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.0.0.0.00.00.00.00.0000','EXECUÇÃO DOS RISCOS FISCAIS','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUÇÃO DOS RISCOS FISCAIS QUE NÃO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.1.0.0.00.00.00.00.0000','EXECUÇÃO DE PASSIVOS CONTINGENTES','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUÇÃO DOS RISCOS FISCAIS QUE NÃO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, CLASSIFICADOS COMO PASSIVOS CONTINGENTES, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.1.1.0.00.00.00.00.0000','PASSIVOS CONTINGENTES PREVISTOS','REGISTRA A PREVISAO DOS RISCOS FISCAIS CLASSIFICADOS COMO PASSIVOS CONTINGENTES','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.1.1.1.00.00.00.00.0000','DEMANDAS JUDICIAIS','REGISTRA A ESTIMATIVA DO MONTANTE RELATIVO A AÇÕES JUDICIAIS EM ANDAMENTO CONTRA O ENTE FEDERATIVO NAS QUAIS HAJA A PROBABILIDADE DE QUE O GANHO DE CAUSA VENHA A SER DA OUTRA PARTE. AO FAZER A ESTIMATIVA, CONSIDERAR OS PRINCIPAIS TIPOS DE AÇÃO JUDICIAL, TAIS COMO: A) DEMANDAS JUDICIAIS CONTRA A ATIVIDADE REGULADORA DO ESTADO: INDEXAÇÃO E CONTROLES DE PREÇOS; DE ORDEM TRIBUTÁRIA E PREVIDENCIÁRIA; OUTRAS DEMANDAS JUDICIAIS; B) DEMANDAS JUDICIAIS CONTRA EMPRESAS ESTATAIS DEPENDENTES; C) DEMANDAS JUDICIAIS CONTRA A ADMINISTRAÇÃO DIRETA E INDIRETA: PRIVATIZAÇÕES, LIQUIDAÇÃO OU EXTINÇÃO DE ÓRGÃOS OU EMPRESAS; REAJUSTES SALARIAIS; D) DEMANDAS TRABALHISTAS CONTRA O ENTE FEDERATIVO; E) OUTRAS DEMANDAS JUDICIAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.1.1.2.00.00.00.00.0000','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','REGISTRA AS DÍVIDAS AINDA NÃO ASSUMIDAS FORMALMENTE QUE APRESENTAM PROBABILIDADE DE SEREM INCORPORADAS AO PASSIVO DEVIDO, POR EXEMPLO, A DECISÕES JUDICIAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.1.1.3.00.00.00.00.0000','AVAIS E GARANTIAS CONCEDIDAS','REGISTRA A ESTIMATIVA DO MONTANTE QUE APRESENTA PROBABILIDADE DE VIR A SER GASTO PELO ENTE FEDERATIVO PARA HONRAR FIANÇAS E AVAIS CONCEDIDOS EM OPERAÇÕES DE CRÉDITO DIRETA OU INDIRETAMENTE PELO ENTE FEDERATIVO A FAVOR DE OUTROS ENTES FEDERATIVOS E ENTIDADES DOS SETORES PÚBLICO E PRIVADO, INCLUSIVE COM RECURSOS DE FUNDOS DE AVAL, A ASSUNÇÃO DE RISCO CREDITÍCIO EM LINHAS DE CRÉDITO, O SEGURO DE CRÉDITO À EXPORTAÇÃO E OUTRAS GARANTIAS DE NATUREZA SEMELHANTE QUE REPRESENTEM COMPROMISSO DE ADIMPLÊNCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.1.1.4.00.00.00.00.0000','ASSUNÇÃO DE PASSIVOS','REGISTRA A ESTIMATIVA DO MONTANTE QUE APRESENTA PROBABILIDADE DE VIR A SER GASTO PELO ENTE FEDERATIVO COM O OBJETIVO DE PROTEGER O CIDADÃO OU SISTEMAS IMPORTANTES DO MERCADO CONTRA INADIMPLÊNCIAS, FALÊNCIAS, ALTOS PREJUÍZOS, OU GARANTIR A CREDIBILIDADE DESSES SISTEMAS FRENTE A FATORES AGUDOS ADVERSOS. AO FAZER A ESTIMATIVA, CONSIDERAR OS PRINCIPAIS TIPOS DE SITUAÇÕES QUE PODEM ADVIR: A) DE ÓRGÃOS DA ADMINISTRAÇÃO DIRETA OU INDIRETA; B) DE ENTIDADES PRIVADAS; C) DE REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL DOS SERVIDORES PÚBLICOS; D) DE ENTES DA FEDERAÇÃO; E) DO REGIME GERAL DE PREVIDÊNCIA SOCIAL; F) DO BANCO CENTRAL; E G) DA ASSUNÇÃO DE OUTROS PASSIVOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.1.1.5.00.00.00.00.0000','ASSISTÊNCIAS DIVERSAS','REGISTRA A ESTIMATIVA DO MONTANTE QUE APRESENTA PROBABILIDADE DE VIR A SER EMPREGADO PELO ENTE FEDERATIVO COM O OBJETIVO DE FAZER FRENTE A CALAMIDADES PÚBLICAS E QUE, POR NÃO SEREM RECORRENTES, NÃO FORAM PLANEJADOS. RECOMENDA-SE QUE O ENTE FEDERATIVO EXPLICITE O TIPO DE ASSISTÊNCIA EMERGENCIAL QUE ELE ESTÁ PREVENDO, POR EXEMPLO, SE É ASSISTÊNCIA CONTRA SECA, ENCHENTES, CATÁSTROFES, EPIDEMIAS ETC.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.1.1.9.00.00.00.00.0000','OUTROS PASSIVOS CONTINGENTES','REGISTRA A ESTIMATIVA DO MONTANTE QUE APRESENTA PROBABILIDADE DE VIR A SER EMPREGADO PELO ENTE FEDERATIVO PARA FAZER FRENTE A OUTROS TIPOS DE PASSIVOS CONTINGENTES.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.1.2.0.00.00.00.00.0000','PASSIVOS CONTINGENTES CONFIRMADOS','REGISTRA A CONFIRMAÇÃO DA PREVISAO DOS RISCOS FISCAIS CLASSIFICADOS COMO PASSIVOS CONTINGENTES','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.1.2.1.00.00.00.00.0000','DEMANDAS JUDICIAIS','REGISTRA A ESTIMATIVA DO MONTANTE RELATIVO A AÇÕES JUDICIAIS EM ANDAMENTO CONTRA O ENTE FEDERATIVO NAS QUAIS HAJA A PROBABILIDADE DE QUE O GANHO DE CAUSA VENHA A SER DA OUTRA PARTE. AO FAZER A ESTIMATIVA, CONSIDERAR OS PRINCIPAIS TIPOS DE AÇÃO JUDICIAL, TAIS COMO: A) DEMANDAS JUDICIAIS CONTRA A ATIVIDADE REGULADORA DO ESTADO: INDEXAÇÃO E CONTROLES DE PREÇOS; DE ORDEM TRIBUTÁRIA E PREVIDENCIÁRIA; OUTRAS DEMANDAS JUDICIAIS; B) DEMANDAS JUDICIAIS CONTRA EMPRESAS ESTATAIS DEPENDENTES; C) DEMANDAS JUDICIAIS CONTRA A ADMINISTRAÇÃO DIRETA E INDIRETA: PRIVATIZAÇÕES, LIQUIDAÇÃO OU EXTINÇÃO DE ÓRGÃOS OU EMPRESAS; REAJUSTES SALARIAIS; D) DEMANDAS TRABALHISTAS CONTRA O ENTE FEDERATIVO; E) OUTRAS DEMANDAS JUDICIAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.1.2.2.00.00.00.00.0000','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','REGISTRA AS DÍVIDAS AINDA NÃO ASSUMIDAS FORMALMENTE QUE APRESENTAM PROBABILIDADE DE SEREM INCORPORADAS AO PASSIVO DEVIDO, POR EXEMPLO, A DECISÕES JUDICIAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.1.2.3.00.00.00.00.0000','AVAIS E GARANTIAS CONCEDIDAS','REGISTRA A ESTIMATIVA DO MONTANTE QUE APRESENTA PROBABILIDADE DE VIR A SER GASTO PELO ENTE FEDERATIVO PARA HONRAR FIANÇAS E AVAIS CONCEDIDOS EM OPERAÇÕES DE CRÉDITO DIRETA OU INDIRETAMENTE PELO ENTE FEDERATIVO A FAVOR DE OUTROS ENTES FEDERATIVOS E ENTIDADES DOS SETORES PÚBLICO E PRIVADO, INCLUSIVE COM RECURSOS DE FUNDOS DE AVAL, A ASSUNÇÃO DE RISCO CREDITÍCIO EM LINHAS DE CRÉDITO, O SEGURO DE CRÉDITO À EXPORTAÇÃO E OUTRAS GARANTIAS DE NATUREZA SEMELHANTE QUE REPRESENTEM COMPROMISSO DE ADIMPLÊNCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.1.2.4.00.00.00.00.0000','ASSUNÇÃO DE PASSIVOS','REGISTRA A ESTIMATIVA DO MONTANTE QUE APRESENTA PROBABILIDADE DE VIR A SER GASTO PELO ENTE FEDERATIVO COM O OBJETIVO DE PROTEGER O CIDADÃO OU SISTEMAS IMPORTANTES DO MERCADO CONTRA INADIMPLÊNCIAS, FALÊNCIAS, ALTOS PREJUÍZOS, OU GARANTIR A CREDIBILIDADE DESSES SISTEMAS FRENTE A FATORES AGUDOS ADVERSOS. AO FAZER A ESTIMATIVA, CONSIDERAR OS PRINCIPAIS TIPOS DE SITUAÇÕES QUE PODEM ADVIR: A) DE ÓRGÃOS DA ADMINISTRAÇÃO DIRETA OU INDIRETA; B) DE ENTIDADES PRIVADAS; C) DE REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL DOS SERVIDORES PÚBLICOS; D) DE ENTES DA FEDERAÇÃO; E) DO REGIME GERAL DE PREVIDÊNCIA SOCIAL; F) DO BANCO CENTRAL; E G) DA ASSUNÇÃO DE OUTROS PASSIVOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.1.2.5.00.00.00.00.0000','ASSISTÊNCIAS DIVERSAS','REGISTRA A ESTIMATIVA DO MONTANTE QUE APRESENTA PROBABILIDADE DE VIR A SER EMPREGADO PELO ENTE FEDERATIVO COM O OBJETIVO DE FAZER FRENTE A CALAMIDADES PÚBLICAS E QUE, POR NÃO SEREM RECORRENTES, NÃO FORAM PLANEJADOS. RECOMENDA-SE QUE O ENTE FEDERATIVO EXPLICITE O TIPO DE ASSISTÊNCIA EMERGENCIAL QUE ELE ESTÁ PREVENDO, POR EXEMPLO, SE É ASSISTÊNCIA CONTRA SECA, ENCHENTES, CATÁSTROFES, EPIDEMIAS ETC.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.1.2.9.00.00.00.00.0000','OUTROS PASSIVOS CONTINGENTES','REGISTRA A ESTIMATIVA DO MONTANTE QUE APRESENTA PROBABILIDADE DE VIR A SER EMPREGADO PELO ENTE FEDERATIVO PARA FAZER FRENTE A OUTROS TIPOS DE PASSIVOS CONTINGENTES.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.2.0.0.00.00.00.00.0000','EXECUÇÃO DOS DEMAIS RISCOS FISCAIS','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUÇÃO DOS RISCOS FISCAIS QUE NÃO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, NÃO CLASSIFICADOS COMO PASSIVOS CONTINGENTES, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.2.1.0.00.00.00.00.0000','DEMAIS RISCOS FISCAIS PREVISTOS','REGISTRA A PREVISAO DOS RISCOS FISCAIS NÃO CLASSIFICADOS COMO PASSIVOS CONTINGENTES','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.2.1.1.00.00.00.00.0000','FRUSTRAÇÃO DE ARRECADAÇÃO','REGISTRA A ESTIMATIVA DO MONTANTE DE REDUÇÃO DE ARRECADAÇÃO QUE APRESENTA PROBABILIDADE DE VIR A OCORRER NO EXERCÍCIO, DECORRENTE DE, POR EXEMPLO, CENÁRIOS MACROECONÔMICOS DESFAVORÁVEIS NÃO PREVISTOS NA ÉPOCA DA ELABORAÇÃO DO ORÇAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.2.1.2.00.00.00.00.0000','RESTITUIÇÃO DE TRIBUTOS A MAIOR','REGISTRA A ESTIMATIVA DO MONTANTE DE DEVOLUÇÃO DE TRIBUTOS A MAIOR QUE APRESENTA PROBABILIDADE DE VIR A OCORRER NO EXERCÍCIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.2.1.3.00.00.00.00.0000','DISCREPÂNCIA DE PROJEÇÕES:','REGISTRA A ESTIMATIVA DO MONTANTE DE REDUÇÃO NO VALOR DOS INGRESSOS OU DE AUMENTO NO VALOR DOS DESEMBOLSOS QUE APRESENTAM PROBABILIDADE DE VIR A OCORRER NO EXERCÍCIO, DECORRENTES DE EVOLUÇÃO DESFAVORÁVEL DE INDICADORES ECONÔMICOS EMPREGADOS NA ÉPOCA DA ELABORAÇÃO DO ORÇAMENTO, TAIS COMO: A) TAXA DE CRESCIMENTO ECONÔMICO; B) TAXA DE INFLAÇÃO; C) TAXA DE CÂMBIO; D) TAXA DE JUROS; E) SALÁRIO MÍNIMO; F) OUTROS INDICADORES.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.2.1.9.00.00.00.00.0000','OUTROS RISCOS FISCAIS','REGISTRA A ESTIMATIVA DO MONTANTE QUE APRESENTA PROBABILIDADE DE VIR A SER EMPREGADO PELO ENTE FEDERATIVO PARA FAZER FRENTE A OUTROS TIPOS DE RISCOS FISCAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.4.2.2.0.00.00.00.00.0000','DEMAIS RISCOS FISCAIS CONFIRMADOS','REGISTRA A CONFIRMAÇÃO DA PREVISAO DOS RISCOS FISCAIS NÃO CLASSIFICADOS COMO PASSIVOS CONTINGENTES','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.0.0.0.00.00.00.00.0000','EXECUÇÃO DOS CONSÓRCIOS PÚBLICOS','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUÇÃO DOS CONSÓRCIOS PÚBLICOS (DO ENTE CONSORCIADO E/OU DO PRÓPRIO CONSÓRCIO), INCLUINDO OS CONTROLES DO CONTRATO DE RATEIO, CONTROLE DA PRESTAÇÃO DE CONTAS, BEM COMO AS INFORMAÇÕES QUE SERÃO CONSOLIDADAS NO ENTE CONSORCIADO PARA FINS DE ELABORAÇÃO DOS DEMONSTRATIVOS DOS CONSÓRCIOS, CONFORME PORTARIA STN 72/2012.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.1.0.0.00.00.00.00.0000','EXECUÇÃO DO CONTRATO DE RATEIO DE CONSÓRCIO PÚBLICO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE OBRIGAÇÕES CONTRATUAIS DECORRENTES DE CONSÓRCIOS PÚBLICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.1.1.0.00.00.00.00.0000','CONTRATO DE RATEIO - EM EXECUÇÃO','REGISTRA OS VALORES DE OBRIGAÇÕES CONTRATUAIS EM EXECUÇÃO DECORRENTES DE CONSÓRCIOS PÚBLICOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.1.2.0.00.00.00.00.0000','CONTRATO DE RATEIO - EXECUTADOS','REGISTRA OS VALORES DE OBRIGAÇÕES DE OBRIGAÇÕES CONTRATUAIS EXECUTADOS DECORRENTES DE CONSÓRCIOS PÚBLICOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.2.0.0.00.00.00.00.0000','EXECUÇÃO DA PRESTAÇÃO DE CONTAS DE CONSÓRCIO PÚBLICO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DO CONTROLE DA PRESTAÇÃO DE CONTAS REFERENTES AOS VALORES TRANSFERIDOS DOS CONSÓRCIOS PÚBLICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.2.1.0.00.00.00.00.0000',' A COMPROVAR','REGISTRA OS VALORES TRANSFERIDOS DOS CONSÓRCIOS PÚBLICOS A COMPROVAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.2.2.0.00.00.00.00.0000','EM INADIMPLENCIA','REGISTRA OS VALORES TRANSFERIDOS DOS CONSÓRCIOS PÚBLICOS EM QUE NÃO HOUVE PRESTAÇÃO DE CONTAS DENTRO DO PRAZO ESTIPULADO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.2.3.0.00.00.00.00.0000','A APROVAR','REGISTRA OS VALORES TRANSFERIDOS DOS CONSÓRCIOS PÚBLICOS A APROVAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.2.4.0.00.00.00.00.0000','APROVADOS','REGISTRA OS VALORES TRANSFERIDOS DOS CONSÓRCIOS PÚBLICOS APROVADOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.2.5.0.00.00.00.00.0000','IMPUGNADOS','REGISTRA OS VALORES TRANSFERIDOS DOS CONSÓRCIOS PÚBLICOS IMPUGNADOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.0.0.00.00.00.00.0000','CONSOLIDAÇÃO DA EXECUÇÃO DO CONSÓRCIO','COMPREENDE AS INFORMAÇÕES REFERENTES AOS CONSÓRCIOS PÚBLICOS, ATRIBUÍDAS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO, QUE SERÃO ENVIADAS PELO CONSÓRCIO PARA OS ENTES CONSORCIADOS PARA FINS DE ELABORAÇÃO DOS DEMONSTRATIVOS FISCAIS (SAÚDE, PESSOAL, EDUCAÇÃO E DISPONIBILIDADE DE CAIXA), EM ATENDIMENTO A PORTARIA STN N.º 72/2012. CONTA PARA USO DO ENTE CONSORCIADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.1.0.00.00.00.00.0000','VALORES TRANSFERIDOS POR CONTRATO DE RATEIO','REGISTRA OS VALORES REPASSADOS PELO ENTE PARA EXECUÇÃO DAS DESPESAS NOS CONSÓRCIOS PÚBLICOS, COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.2.0.00.00.00.00.0000','DESPESAS EXECUTADAS EM CONSÓRCIOS PÚBLICOS','COMPREENDE AS DESPESAS EXECUTADAS EM CONSÓRCIOS PÚBLICOS ATRIBUÍDAS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.2.1.00.00.00.00.0000','CREDITO EMPENHADO A LIQUIDAR','REGISTRA O VALOR DA DESPESA EMPENHADA A SER LIQUIDADA EXECUTADAS EM CONSÓRCIOS PÚBLICOS ATRIBUÍDAS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.2.2.00.00.00.00.0000','CREDITO EMPENHADO EM LIQUIDAÇÃO','REGISTRA O VALOR DA DESPESA CUJO FATO GERADOR JÁ OCORREU, MAS QUE AINDA NÃO FORAM CONFERIDOS O OBJETO, E O VALOR, OU SEJA, NÃO HOUVE A LIQUIDAÇÃO, EXECUTADAS EM CONSÓRCIOS PÚBLICOS ATRIBUÍDAS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.2.3.00.00.00.00.0000','CREDITO EMPENHADO LIQUIDADO A PAGAR','REGISTRA O VALOR DA APROPRIAÇÃO DAS DESPESAS EMPENHADAS COM POSTERIOR VERIFICAÇÃO DE SUA REGULARIDADE POR CONSTITUIÇÃO DO DIRETO DO CREDOR, EXECUTADAS EM CONSÓRCIOS PÚBLICOS ATRIBUÍDAS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.2.4.00.00.00.00.0000','CREDITO EMPENHADO LIQUIDADO PAGO','DEMONSTRA O VALOR DA DESPESA EMPENHADA LIQUIDADA PAGA, EXECUTADAS EM CONSÓRCIOS PÚBLICOS ATRIBUÍDAS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.3.0.00.00.00.00.0000','EXECUÇÃO DE RP NÃO PROCESSADOS EM CONSÓRCIOS PÚBLICOS','COMPREENDE O SOMATÓRIO DOS VALORES RELATIVOS À TRANSFERÊNCIA, LIQUIDAÇÃO E PAGAMENTO DAS DESPESAS EMPENHADAS, NÃO LIQUIDADAS NO EXERCÍCIO FINANCEIRO DE SUA INSCRIÇÃO E NÃO PAGAS, EM CONSÓRCIOS PÚBLICOS ATRIBUÍDOS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.3.1.00.00.00.00.0000','RP NÃO PROCESSADOS A LIQUIDAR','REGISTRA O VALOR DOS RP NÃO PROCESSADOS AINDA NÃO LIQUIDADOS, EM CONSÓRCIOS PÚBLICOS ATRIBUÍDOS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.3.2.00.00.00.00.0000','RP NÃO PROCESSADOS EM LIQUIDAÇÃO','REGISTRA O VALOR DOS RP NÃO PROCESSADOS AINDA NÃO LIQUIDADOS CUJO FATO GERADOR JÁ OCORREU EM CONSÓRCIOS PÚBLICOS ATRIBUÍDOS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.3.3.00.00.00.00.0000','RP NÃO PROCESSADOS LIQUIDADOS A PAGAR','REGISTRA O VALOR DOS RP NÃO PROCESSADOS, LIQUIDADOS APÓS SUA INSCRIÇÃO E AINDA NÃO PAGOS EM CONSÓRCIOS PÚBLICOS ATRIBUÍDOS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.3.4.00.00.00.00.0000','RP NÃO PROCESSADOS PAGOS','REGISTRA O VALOR DOS RP NÃO PROCESSADOS, LIQUIDADOS APÓS SUA INSCRIÇÃO E PAGOS EM CONSÓRCIOS PÚBLICOS ATRIBUÍDOS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.3.5.00.00.00.00.0000','RP NÃO PROCESSADOS A LIQUIDAR BLOQUEADOS','REGISTRA O VALOR DE RESTOS A PAGAR NÃO PROCESSADOS A LIQUIDAR, BLOQUEADO POR DECRETO EM CONSÓRCIOS PÚBLICOS ATRIBUÍDAS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.3.6.00.00.00.00.0000','RP NÃO PROCESSADOS TRANSFERIDOS','REGISTRA O VALOR DA TRANSFERÊNCIA DE RESTOS A PAGAR NÃO PROCESSADOS PELA DESINCORPORAÇÃO DE SALDOS DECORRENTES DE TRANSFORMAÇÃO, CISÃO, FUSÃO E EXTINÇÃO DE ÓRGÃOS OU UG.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.3.7.00.00.00.00.0000','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','REGISTRA O VALOR DAS DESPESAS EMPENHADAS INSCRITAS NO EXERCÍCIO COMO RESTOS A PAGAR NÃO PROCESSADOS, A SER TRANSFERIDO NO EXERCÍCIO SEGUINTE PARA A CONTA 631100000 E 631200000, EM CONSÓRCIOS PÚBLICOS ATRIBUÍDOS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.3.8.00.00.00.00.0000','RP NÃO PROCESSADOS CANCELADOS','COMPREENDE O CANCELAMENTO DE RESTOS A PAGAR NÃO PROCESSADOS POR INSUFICIÊNCIA DE RECURSOS, PELA INSCRIÇÃO INDEVIDA OU PARA ATENDER DISPOSITIVO LEGAL, EM CONSÓRCIOS PÚBLICOS ATRIBUÍDOS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.4.0.00.00.00.00.0000','EXECUÇÃO DE RP PROCESSADOS EM CONSÓRCIOS PÚBLICOS','COMPREENDE O SOMATÓRIO DOS VALORES RELATIVOS À TRANSFERÊNCIA, LIQUIDAÇÃO E PAGAMENTO DAS DESPESAS EMPENHADAS, LIQUIDADAS NO EXERCÍCIO FINANCEIRO DE SUA INSCRIÇÃO E NÃO PAGAS, EM CONSÓRCIOS PÚBLICOS ATRIBUÍDOS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.4.1.00.00.00.00.0000','RP PROCESSADOS A PAGAR','REGISTRA O VALOR DOS RP PROCESSADOS E NÃO PAGOS EM CONSÓRCIOS PÚBLICOS ATRIBUÍDOS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.4.2.00.00.00.00.0000','RP PROCESSADOS PAGOS','REGISTRA O VALOR DOS RP PROCESSADOS PAGOS EM CONSÓRCIOS PÚBLICOS ATRIBUÍDOS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.4.3.00.00.00.00.0000','RP PROCESSADOS TRANSFERIDOS','REGISTRA O VALOR DA TRANSFERÊNCIA DE RESTOS A PAGAR PELA DESINCORPORAÇÃO DE SALDOS DECORRENTE DE TRANSFORMAÇÃO, CISÃO, FUSÃO E EXTINÇÃO DE ÓRGÃOS OU UG EM CONSÓRCIOS PÚBLICOS ATRIBUÍDOS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.4.4.00.00.00.00.0000','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','REGISTRA O VALOR DAS DESPESAS EMPENHADAS INSCRITAS NO EXERCÍCIO COMO RESTOS A PAGAR PROCESSADOS, A SER TRANSFERIDO NO EXERCÍCIO SEGUINTE PARA A CONTA 632100000, EM CONSÓRCIOS PÚBLICOS ATRIBUÍDOS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.4.5.00.00.00.00.0000','RP PROCESSADOS CANCELADOS','COMPREENDE O CANCELAMENTO DE RESTOS A PAGAR PROCESSADOS POR INSUFICIÊNCIA DE RECURSOS, PELA INSCRIÇÃO INDEVIDA OU PARA ATENDER DISPOSITIVO LEGAL, EM CONSÓRCIOS PÚBLICOS ATRIBUÍDOS AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.5.3.5.0.00.00.00.00.0000','INSUFICIÊNCIA DE CAIXA DO CONSÓRCIO PÚBLICO','REGISTRA A PARCELA TOTAL DA INSUFICIÊNCIA DE CAIXA GERADA NO CONSÓRCIO PÚBLICO ATRIBUÍDA AO ENTE CONSORCIADO COM BASE NO CONTRATO DE RATEIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.8.0.0.0.00.00.00.00.0000','APURAÇÃO DE CUSTOS','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUÇÃO DOS CUSTOS DOS BENS E SERVIÇOS PRODUZIDOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.0.0.0.00.00.00.00.0000','OUTROS CONTROLES','COMPREENDE AS CONTAS DE CONTROLES DA EXECUÇÃO NÃO ESPECIFICADOS ANTERIORMENTE NOS GRUPOS DESSA CLASSE','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.0.0.00.00.00.00.0000','EXECUÇÃO DE OUTROS CONTROLES DE PROGRAMAÇÃO FINANCEIRA','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUÇÃO DE OUTRAS PECULIARIDADES DA PROGRAMAÇÃO FINANCEIRA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.1.0.00.00.00.00.0000','EXECUÇÃO DE RESPONSABILIDADE COM TERCEIROS POR VALORES, TÍTULOS E BENS','REGISTRA AS CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.1.1.00.00.00.00.0000','DEPÓSITOS JUDICIAIS','REGISTRA OS DEPOSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EM CONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOS POR ESTA PARA TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.1.2.00.00.00.00.0000','DEPÓSITOS COMPULSÓRIOS','REGISTRA O SOMATÓRIO DOS VALORES DOS DEPÓSITOS COMPULSÓRIOS REALIZADOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.1.3.00.00.00.00.0000','OUTRAS RESPONSABILIDADES COM TERCEIROS','REGISTRA RESPONSABILIDADES COM TERCEIROS, NAO INDIVIDUALIZADAS NAS OUTRAS CONTAS DESSE GRUPO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.2.0.00.00.00.00.0000','EXECUÇÃO DE RESPONSABILIDADE DE TERCEIROS POR VALORES, TÍTULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.2.1.00.00.00.00.0000','EXECUÇÃO DE ADIANTAMENTOS/SUPRIMENTOS DE FUNDOS CONCEDIDOS','COMPREENDE OS VALORES CONCEDIDOS A SERVIDOR RESPONSAVEL PARA ATENDER DESPESAS QUE NAO POSSAM SUBORDINAR-SE AO PROCESSO NORMAL DE APLICACAO,ATE A SUA PRESTACAO DE CONTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.2.1.01.00.00.00.0000','ADIANTAMENTOS CONCEDIDOS A COMPROVAR','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS PENDENTES DE COMPROVACAO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.2.1.02.00.00.00.0000','ADIANTAMENTOS A APROVAR','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS COMPROVADOS PENDENTES DE APROVACAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.2.1.03.00.00.00.0000','ADIANTAMENTOS APROVADOS','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS APROVADOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.2.1.04.00.00.00.0000','ADIANTAMENTOS IMPUGNADOS','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS IMPUGNADOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.2.1.05.00.00.00.0000','ADIANTAMENTOS EM INDADIMPLENCIA','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS EM INADIMPLÊNCIA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.2.1.06.00.00.00.0000','ADIANTAMENTOS CANCELADOS','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS CANCELADOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.2.2.00.00.00.00.0000','EXECUÇÃO DE ATIVOS DE PPP CONTABILIZADOS NA SPE','COMPREENDE O VALOR DOS ATIVOS PRODUZIDOS POR MEIO DE PARCERIAS PÚBLICO PRIVADAS CONTABILIZADOS NA SOCIEDADE DE PROPÓSITO ESPECÍFICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.2.2.01.00.00.00.0000','ATIVOS DE PPP CONTABILIZADOS NA SPE','REGISTRA O VALOR DE OUTRAS RESPONSABILIDADES DE TERCEIROS, DE NATUREZA EVENTUAL, POR TITULOS, VALORES E BENS, PARA AS QUAIS NAO HA CONTAS ESPECIFICAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.2.2.02.00.00.00.0000','ATIVOS DE PPP CONTABILIZADOS NA SPE BAIXADOS','REGISTRA AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE ATOSPRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAREM PREJUIZOS PARA A FAZENDA NACIONAL.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.1.2.9.00.00.00.00.0000','EXECUÇÃO DE OUTRAS RESPONSABILIDADES DE TERCEIROS','REGISTRA RESPONSABILIDADES COM TERCEIROS, NAO INDIVIDUALIZADAS NAS OUTRAS CONTAS DESSE GRUPO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.2.0.0.00.00.00.00.0000','EXECUÇÃO DE OUTROS CONTROLES DE DISPONIBILIDADES','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUÇÃO DE OUTROS CONTROLES DE DISPONIBILIDADES','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.3.0.0.00.00.00.00.0000','EXECUÇÃO DE CONTROLES DE BENEFÍCIOS PAGOS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUÇÃO DO PAGAMENTO DE BENEFÍCIOS PREVIDÊNCIÁRIOS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.4.0.0.00.00.00.00.0000','EXECUÇÃO DE CONTROLES DA CONTA UNICA','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUÇÃO DA CONTA UNICA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.4.1.0.00.00.00.00.0000','EXECUÇÃO DA CONCILIAÇÃO DA CONTA UNICA POR DISPONIBILIDADE POR DESTINAÇÃO','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUÇÃO DA CONCILIAÇÃO DA CONTA UNICA','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.4.2.0.00.00.00.00.0000','EXECUÇÃO DE CONTROLE DE APLICAÇÃO FINANCEIRA NA CONTA UNICA POR DISPONIBILIDADE POR DESTINAÇÃO','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES REFERENTE AO CONTROLE DE FONTE DE RECURSOS NA NA PLICAÇÃO FINANCEIRA NA CTU','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.6.0.0.00.00.00.00.0000','CONTROLES DE OPERAÇÕES DE CRÉDITOS','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUÇÃO DE OPERAÇÕES DE CRÉDITO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.0.0.00.00.00.00.0000','OUTROS CONTROLES DE RESPONSABILIDADES POR VALORES, TITULOS E BENS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DAS RESPONSABILIDADES POR VALORES, TITULOS E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.0.00.00.00.00.0000','EXECUÇÃO DE RESPONSABILIDADES DE TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRAÇÃO PÚBLICA POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.00.00.00.00.0000','RESPONSABILIDADES DE TERCEIROS','COMPREENDE A RESPONSABILIDADE DE TERCEIROS POR TITULOS, VALORES E BENS CONCEDIDOS PELA UNIDADE GESTORA QUE EFETUA O REGISTRO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.01.00.00.00.0000','SUPRIMENTO DE FUNDOS','REGISTRA OS VALORES CONCEDIDOS A SERVIDOR RESPONSAVEL PARA ATENDERDESPESAS QUE NÃO POSSAM SUBORDINAR-SE AO PROCESSO NORMAL DE APLICAÇÃO,ATEH A SUA PRESTAÇÃO DE CONTAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.02.00.00.00.0000','CONCEDIDOS EM CUSTODIA','REGISTRA O CONTROLE DOS BENS, TITULOS E VALORES EM PODER DE TERCEIROSSOB CUSTODIA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.03.00.00.00.0000','DESPESAS MEDICAS','REGISTRA O VALOR DAS DESPESAS MEDICAS PAGAS A HOSPITAIS E CLINICAS TENDO COMO USUARIO OS VEREADORES E SERVIDORES.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.04.00.00.00.0000','EM COBRANCA - A RECEBER','REGISTRA O MONTANTE DA RESPONSABILIDADE DE TERCEIROS POR VALORES, TI-TULOS E BENS EM FASE DE COBRANCA PELA UNIDADE GESTORA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.05.00.00.00.0000','EM CAUÇÃO','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR TITULOS, VALORES E BENS OFERECIDOS EM CAUÇÃO PELA UNIDADE GESTORA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.06.00.00.00.0000','CONCEDIDOS EM CONSIGNAÇÃO','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR VALORES, TITULOS E BENSCONCEDIDOS A TITULO DE CONSIGNAÇÃO PELA UNIDADE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.07.00.00.00.0000','DIÁRIAS','REGISTRA O VALOR DAS DIÁRIAS CONCEDIDAS, COM REGISTRO DA RESPONSABILI-DADE MEDIANTE CONTROLE INDIVIDUALIZADO POR TITULAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.08.00.00.00.0000','TITULOS DE CRÉDITO','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES DE TERCEIROS PORTITULOS DE CRÉDITO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.09.00.00.00.0000','CESSAO DE USO - BENS CEDIDOS','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR BENS CEDIDOS PELA UNIDADEA TITULO DE CESSAO DE USO, FORMALIZADA MEDIANTE TERMO, NO QUAL DEVERAOCONSTAR A FINALIDADE DA SUA REALIZAÇÃO E O PRAZO PARA SEU CUMPRIMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.10.00.00.00.0000','MERCADORIAS E BENS EM PODER DE TERCEIROS','REGISTRA O VALOR DAS MERCADORIAS E DOS BENS DAS UNIDADES GESTORAS QUEESTAO EM PODER DE TERCEIROS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.11.00.00.00.0000','BENS EM MANUTENCAO','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR BENS MÓVEIS CONCEDIDOSPELA UNIDADE EM CARATER PROVISORIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.12.00.00.00.0000','PERMISSÃO DE USO - BENS CONCEDIDOS','REGISTRA O VALOR DOS BENS CONCEDIDOS A PARTICULAR MEDIANTE PERMISSÃODE USO, POR ATO NEGOCIAL, UNILATERAL, DISCRICIONARIO E PRECARIO DA AD-MINISTRAÇÃO PÚBLICA, E CUJA UTILIZAÇÃO SEJA DE INTERESSE DA COLETIVI-DADE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.13.00.00.00.0000','AUTORIZAÇÃO DE USO','REGISTRA O CONTROLE DOS BENS PERTENCENTES A ADMINISTRAÇÃO PÚBLICA,SOBRE OS QUAIS FOI A AUTORIZADA A PRATICA DE ATIVIDADE INDIVIDUAL,TRANSITORIA E IRRELEVANTE PARA O PODER PÚBLICO, POR ATO UNILATERAL,DISCRICIONARIO E PRECARIO, DISPENSANDO LEI AUTORIZATIVA E LICITAÇÃOPARA SEU DEFERIMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.14.00.00.00.0000','IMÓVEIS DE INTERESSE DO MUNICÍPIO','REGISTRA O CONTROLE DE IMÓVEIS DE TERCEIROS QUE ESTAO SENDO ADMINISTRADOS PELA ENTIDADE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.15.00.00.00.0000','CONCESSAO DE USO','REGISTRA A DELEGAÇÃO DE SERVICO PÚBLICO FEITA PELO PODER CEDENTE,MEDIANTE CONTRATO, PARA SUA EXPLORAÇÃO SEGUNDO DESTINAÇÃO ESPECIFICADE ACORDO COM A LEI 8987 DE 13/02/1995.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.1.1.99.00.00.00.0000','OUTRAS RESPONSABILIDADES DE TERCEIROS','REGISTRA O VALOR DE OUTRAS RESPONSABILIDADES DE TERCEIROS, DE NATUREZAEVENTUAL, POR TITULOS, VALORES E BENS, PARA AS QUAIS NÃO HA CONTAS ES-PECIFICAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.2.0.00.00.00.00.0000','EXECUÇÃO DE RESPONSABILIDADES COM TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DA RESPONSABILIDADE DA ADMINISTRAÇÃO PÚBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.2.1.00.00.00.00.0000','EXECUÇÃO DE RESPONSABILIDADES COM TERCEIROS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DA RESPONSABILIDADE DA ADMINISTRAÇÃO PÚBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.2.1.01.00.00.00.0000','RECEBIDOS EM CAUÇÃO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUÇÃO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.2.1.02.00.00.00.0000','DEPÓSITOS JUDICIAIS','REGISTRA OS DEPÓSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EMCONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOSPOR ESTA PARA TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.2.1.03.00.00.00.0000','DEPÓSITOS COMPULSORIOS','REGISTRA OS DEPÓSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EM CONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOS POR ESTA PARA TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.2.1.99.00.00.00.0000','OUTRAS RESPONSABILIDADES COM TERCEIROS','REGISTRA RESPONSABILIDADES COM TERCEIROS, NÃO INDIVIDUALIZADAS NAS OU-TRAS CONTAS DESSE GRUPO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.0.00.00.00.00.0000','DIVERSOS RESPONSAVEIS EM APURAÇÃO','REGISTRA AS RESPONSABILIDADES EM FASE DE APURAÇÃO DECORRENTES DE ATOSPRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAREM PREJUÍZOS PARA A FAZENDA NACIONAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.1.00.00.00.00.0000','DIVERSOS RESPONSAVEIS EM APURAÇÃO','REGISTRA AS RESPONSABILIDADES EM FASE DE APURAÇÃO DECORRENTES DE ATOSPRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAREM PREJUÍZOS PARA A FAZENDA NACIONAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.1.01.00.00.00.0000','PAGAMENTOS INDEVIDOS','REGISTRA AS RESPONSABILIDADES EM APURAÇÃO DE GESTORES E OUTROS RESPON-SAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, IN-CLUSIVE EM CASOS DE SUPERFATURAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.1.02.00.00.00.0000','SALDOS NÃO RECOLHIDOS','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NÃO RECOLHIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU AD-MINISTRATIVAS CUJOS PROCESSOS ESTEJAM EM FASE DE APURAÇÃO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.1.03.00.00.00.0000','DESFALQUES OU DESVIOS','REGISTRA OS DESFALQUES OU DESVIOS DE BENS E VALORES DA UNIAO OU DE EN-TIDADES PÚBLICAS, EM APURAÇÃO,DECORRENTES DE PROCESSOS POR AÇÕES ADMI-NINISTRATIVAS, POLICIAIS OU JUDICIAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.1.04.00.00.00.0000','DEBITOS DE TERCEIROS EM PREST. SERVIÇOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTAÇÃO DE SERVIÇOS POR TERCEIROS, CUJOS PROCESSOS ESTEJAM EM FASE DE APURAÇÃO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.1.05.00.00.00.0000','RESPONSAVEIS POR DANOS OU PERDAS','DESTINADA AO REGISTRO DAS RESPONSABILIDADES EM INQUERITOS ADMINISTRATIVOS OU POLICIAIS CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS A FAZENDA NACIONAL, E QUE ESTEJAM EM FASE DE APURAÇÃO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.1.06.00.00.00.0000','PAGAMENTOS SEM RESPALDO ORCAMENTARIO','REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CRÉDITO QUE AS COM-PORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSI-FICAÇÃO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), EM FASEDE APURAÇÃO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.1.07.00.00.00.0000','CRÉDITOS ANTECIPADOS','REGISTRA OS VALORES PAGOS SOBRE DOTAÇÕES DECORRENTES DE CRÉDITOS ANTE-CIPADOS NÃO REALIZADOS ATE O FECHAMENTO DO EXERCÍCIO, EM FASE DE APU-RAÇÃO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.1.08.00.00.00.0000','FALTA OU IRREGULARIDADE DE COMPROVAÇÃO','REGISTRA OS VALORES CORRESPOND.A FALTA DE DOCUMENTAÇÃO COMPROBAT.DA E-XECUCAO DA DESPESA, INCLUSIVE AS APRESENT.FORA DO PRAZOLEGAL, BEM CO-MO A INADIMPLENCIA NA COMPROV.DE INSTRUMENT.DE TRANSFER.OU AINDA IRRE-GULARID. NA DOCUMENT., EM FASE DE APURAÇÃO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.1.09.00.00.00.0000','FALTA DE LICITAÇÃO','REGISTRA OS VALORES RELATIVOS A BENS E SERVIÇOS ADQUIRIDOS SEM A NE-CESSARIA LICITAÇÃO, INFRINGINDO A LEGISLAÇÃO ESPECIFICA, EM PROCESSOSMOTIVADOS, POR DETERMINAÇÕES ADMINISTRATIVAS E OU INQUERITOS, EM FASEDE APURAÇÃO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.1.10.00.00.00.0000','MULTAS E JUROS','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGÃO, PO-REM DE RESPONSABILIDADE DE SERVIDORES E QUE ESTEJAM EM FASE DE APURA-CAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.1.11.00.00.00.0000','FALTA DE RECOLHIMENTO OBRIGAÇÕES PECUNIARIA','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGA-MENTO DE OBRIGAÇÕES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NÃO RECOLHIDOS,NÃO PAGAMENTO DE OBRIGAC. PARA COM A UNIAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.1.12.00.00.00.0000','FRAUDES EM BENEFÍCIOS','REGISTRAR OS DEBITOS RELATIVOS A FRAUDES EM BENEFÍCIOS DA PREVIDENCIASOCIAL QUE SE ENCONTRAM EM FASE DE APURAÇÃO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.1.13.00.00.00.0000','ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE','REGISTRA AS RESPONSABILIDADES EM APURAÇÃO DE GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR CONCESSAO DE ADIANTAMENTOS EM DESACORDOCOM A LEGISLAÇÃO PERTINENTE, TAIS COMO ADIANTAMENTOS A FORNECEDORES OUA EMPREGADOS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.7.3.1.99.00.00.00.0000','OUTRAS RESPONSABILIDADES EM APURAÇÃO','REGISTRA RESPONSABILIDADES EM APURAÇÃO NÃO INDIVIDUALIZADAS NAS OUTRAS CONTAS DESSE GRUPO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.0.0.00.00.00.00.0000','DEMAIS CONTROLES','COMPREENDE AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS SUBGRUPOS DESTE GRUPO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.0.00.00.00.00.0000','EXECUÇÃO DOS CONTROLES REFERENTES A CONSÓRCIOS PÚBLICOS','COMPREENDE A EXECUÇÃO DOS RECURSOS TRANSFERIDOS AOS CONSORCIOS PUBLICOS ATRAVÉS DAS INFORMAÇÕES ENVIADAS PELOS CONSÓRCIOS PÚBLICOS, INSTITUIDOS DE ACORDO COM A LEI FEDERAL Nº 11.107/2005 PARA FINS DE CONSOLIDAÇÃO QUANTO AS INFORMAÇÕES PARA VERIFICAÇÃO DA APLICAÇÃO DOS INDICES MINIMOS E MÁXIMOS TRAZIDOS PELA CF/88, LRF E DEMAIS CONTROLES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.1.00.00.00.00.0000','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL','COMPREENDE A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL. ESTA CONTA DEVERÁ SER DESDOBRADA POR BIMESTRE PARA COMPOR A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.1.01.00.00.00.0000','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ANTERIOR','COMPREENDE A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NOS PERIODOS DO EXERCICIO ANTERIOR UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.1.01.01.00.00.0000','DESPESA COM PESSOAL - EXERCICIO ANTERIOR - MAIO A DEZEMBRO','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO PERIODO DE MAIO A DEZEMBRO DO EXERCICIO ANTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.1.01.02.00.00.0000','DESPESA COM PESSOAL - EXERCICIO ANTERIOR - JULHO A DEZEMBRO','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO PERIODO DE JULHO A DEZEMBRO DO EXERCICIO ANTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.1.01.03.00.00.0000','DESPESA COM PESSOAL - EXERCICIO ANTERIOR - SETEMBRO A DEZEMBRO','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO PERIODO DE SETEMBRO A DEZEMBRO DO EXERCICIO ANTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.1.02.00.00.00.0000','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NOS PERIODOS DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.1.02.01.00.00.0000','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 1º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 1º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.1.02.02.00.00.0000','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 2º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 2º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.1.02.03.00.00.0000','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 3º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 3º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.1.02.04.00.00.0000','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 4º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 4º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.1.02.05.00.00.0000','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 5º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 5º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.1.02.06.00.00.0000','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 6º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 6º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.2.00.00.00.00.0000','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM ASPS','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM AÇÕES E SERVIÇOS PÚBLICOS DE SAÚDE - ASPS. ESTA CONTA DEVERÁ SER ACUMULADA NOS BIMESTRES E TRAZER APENAS A APLICAÇÃO EM SAUDE PARA FINS DE CONSOLIDAÇÃO DO MÍNIMO CONSTITUCIONAL, OU SEJA TRANSFERÊNCIAS AO CONSÓRCIO COM RECURSO VINCULADO 40.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.3.00.00.00.00.0000','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM MDE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM MANUTENÇÃO E DESENVOLVIMENTO DO ENSINO - MDE. ESTA CONTA DEVERÁ SER ACUMULADA NOS BIMESTRES E TRAZER APENAS A APLICAÇÃO EM EDUCAÇÃO PARA FINS DE CONSOLIDAÇÃO DO MÍNIMO CONSTITUCIONAL, OU SEJA TRANSFERÊNCIAS AO CONSÓRCIO COM RECURSO VINCULADO 20.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.4.00.00.00.00.0000','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM FUNDEB','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM O FUNDEB. ESTA CONTA DEVERÁ SER ACUMULADA NOS BIMESTRES E TRAZER APENAS A APLICAÇÃO NO FUNDEB PARA FINS DE CONSOLIDAÇÃO DO MÍNIMO CONSTITUCIONAL, OU SEJA TRANSFERÊNCIAS AO CONSÓRCIO COM RECURSO VINCULADO 31.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.5.00.00.00.00.0000','INFORMAÇÃO DA INSUFICIÊNCIA DE CAIXA DO CONSORCIO PUBLICO','REGISTRA A INFORMAÇÃO DA INSUFICIÊNCIA DE CAIXA DO CONSORCIO PÚBLICO PARA FINS DE ANALISE DO CUMPRIMENTO DO ART. 42 DA LRF, CONFORME ART. 11, § 2º DA PORTARIA STN Nº 72/2012.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.6.00.00.00.00.0000','OPERAÇÕES DE CREDITO IRREGULARES','REGISTRA AS OPERAÇÕES DE CREDITO NÃO AUTORIZADAS POR RESOLUÇÃO DO SENADO FEDERAL, AS VEDADAS E OUTRAS IRREGULARMENTE REALIZADAS E QUE DEVERÃO SER CONSOLIDADAS NOS DEMONSTRATIVOS DE OPERAÇÃO DE CREDITO E DIVIDA CONSOLIDADA LIQUIDA DO ENTE CONSORCIADO EM ATENDIMENTO AO ART. 18, PARÁGRAFO ÚNICO DA PORTARIA STN N° 72/2012..','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.8.7.00.00.00.00.0000','INFORMAÇÃO DO ATENDIMENTO AO ART. 25 DA LC 141/2012','REGISTRA A APLICAÇÃO DIRETA EEXECUTADA PELO CONSORCIO PUBLICO À CONTA DOS RECURSOS REFERENTES À DIFERENÇA DA APLICAÇÃO MÍNIMA EM ASPS QUE DEIXOU DE SER APLICADA EM EXERCICIOS ANTERIORES. ATENDIMENTO AO ART. 25 DA LEI COMPLEMENTAR 141/2012 E PARÁGRAFO ÚNICO DO ART. 10 DA PORTARIA STN Nº 72/2012. O CONSORCIO DEVERÁ EXECUTAR ESTA DESPESA NA MODALIDADE DE APLICAÇÃO 96.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (2, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 2), 1), '8.9.9.9.0.00.00.00.00.0000','DEMAIS CONTROLES','REGISTRA AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS TITULOS DESTE SUBGRUPO.','C','S','C','');
