/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
/*
*
* Script de DDL e DML
*
* Versao 2.01.3
*
* Fabio Bertoldi - 20121217
*
*/

----------------
-- Ticket #19768
----------------

CREATE TABLE migra_capitulo (
    id              INTEGER         NOT NULL,
    cap_portugues   VARCHAR(300)    NOT NULL,
    cap_ingles      VARCHAR(300)    NOT NULL,
    cap_espanhol    VARCHAR(300)    NOT NULL,
    CONSTRAINT pk_migra_capitulo    PRIMARY KEY (id)
);

INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (01, RTRIM('Animais vivos                                                                                                                                                                                                                                                   '), RTRIM('Live animals                                                                            '), RTRIM('Animales vivos                                                                          '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (02, RTRIM('Carnes e miudezas, comestíveis                                                                                                                                                                                                                                  '), RTRIM('Meat and edible meat offal                                                              '), RTRIM('Carne y despojos comestibles                                                            '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (03, RTRIM('Peixes e crustáceos, moluscos e outros invertebrados aquáticos                                                                                                                                                                                                  '), RTRIM('Fish and Crustaceans, Molluscs and Other Aquatic Invertebrates                          '), RTRIM('Pescados y Crustáceos, Moluscos y Demás Invertebrados Acuáticos                         '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (04, RTRIM('Leite e laticínios; Ovos de aves; Mel natural; Produtos comestíveis de origem animal, não especificados nem compreendidos em outros capítulos                                                                                                                   '), RTRIM('Dairy Produce; Birds Eggs; Natural Honey; Others                                        '), RTRIM('Leche y Productos Lácteos; Huevos De Ave; Miel Natural; Otros                           '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (05, RTRIM('Outros produtos de origem animal, não especificados nem compreendidos em outros capítulos                                                                                                                                                                       '), RTRIM('Products of Animal Origin, Not Elsewhere Specified Or Included                          '), RTRIM('Los Demás Productos De Origen Animal                                                    '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (06, RTRIM('Plantas vivas e produtos de floricultura                                                                                                                                                                                                                        '), RTRIM('Live Trees and Other Plants; Others                                                     '), RTRIM('Plantas Vivas y Productos De La Floricultura                                            '));                                     
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (07, RTRIM('Produtos hortícolas, plantas, raízes e tubérculos, comestíveis                                                                                                                                                                                                  '), RTRIM('Edible Vegetables and Certain Roots and Tubers                                          '), RTRIM('Hortalizas, Plantas, Raíces y Tubérculos Alimenticios                                   '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (08, RTRIM('Frutas; cascas de cítricos e de melões                                                                                                                                                                                                                          '), RTRIM('Edible Fruit and Nuts; Peel of Citrus Fruits Or Melons                                  '), RTRIM('Frutas; Cortezas De Agrios (Cítricos), Melones O Sandías                                '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (09, RTRIM('Café, chá, mate e especiarias                                                                                                                                                                                                                                   '), RTRIM('Coffee, tea, maté and spices                                                            '), RTRIM('Café, té, yerba mate y especias                                                         '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (10, RTRIM('Cereais                                                                                                                                                                                                                                                         '), RTRIM('Cereals                                                                                 '), RTRIM('Cereales                                                                                '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (11, RTRIM('Produtos da indústria de moagem; malte; amidos e féculas; inulina; glúten de trigo                                                                                                                                                                              '), RTRIM('Products of The Milling Industry; Malt; Starches; Inulin; Wheat Gluten                  '), RTRIM('Productos de la molinería; malta; almidón; otros                                        '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (12, RTRIM('Sementes e frutos oleaginosos; grãos, sementes e frutos diversos; plantas industriais ou medicinais; palhas e forragens                                                                                                                                         '), RTRIM('Oil Seeds and Oleaginous Fruits; Grains, Seeds, Others                                  '), RTRIM('Semillas y Frutos Oleaginosos; Paja y Forrajes; Otros                                   '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (13, RTRIM('Gomas, resinas e outros sucos e extratos vegetais                                                                                                                                                                                                               '), RTRIM('Lac; Gums, Resins and Other Vegetable Saps and Extracts                                 '), RTRIM('Gomas, Resinas y Demás Jugos y Extractos Vegetales                                      '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (14, RTRIM('Matérias para entrançar outros produtos de origem vegetal e prodorigvegetal, não especificados nem compreendidos em outros capítulos                                                                                                                            '), RTRIM('Vegetable Plaiting Materials; Vegetable Products Not Elsewhere Specified Or Included    '), RTRIM('Materias Trenzables y Demás Productos De Origen Vegetal                                 '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (15, RTRIM('Gorduras e óleos animais ou vegetais; Produtos da sua dissociação; Gorduras alimentares elaboradas; Ceras de origem animal ou vegetal                                                                                                                           '), RTRIM('Animal Or Vegetable Fats and Oils; Others                                               '), RTRIM('Grasas y Aceites Animales O Vegetales; Otros                                            '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (16, RTRIM('Preparações de carne, de peixes ou de crustáceos, de moluscos ou de outros invertebrados aquáticos                                                                                                                                                              '), RTRIM('Preparations of Meat, of Fish Or of Crustaceans, Others                                 '), RTRIM('Preparaciones De Carne, Pescado O Crustáceos, Otros                                     '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (17, RTRIM('Açúcares e produtos de confeitaria                                                                                                                                                                                                                              '), RTRIM('Sugars and Sugar Confectionery                                                          '), RTRIM('Azúcares y Artículos De Confitería                                                      '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (18, RTRIM('Cacau e suas preparações                                                                                                                                                                                                                                        '), RTRIM('Cocoa and Cocoa Preparations                                                            '), RTRIM('Cacao y Sus Preparaciones                                                               '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (19, RTRIM('Preparações à base de cereais, farinhas, amidos, féculas ou de leite; Produtos de pastelaria                                                                                                                                                                    '), RTRIM('Preparations of Cereals, Flour, Starch Or Milk; Pastrycooks Products                    '), RTRIM('Preparaciones A Base De Cereales, Harina, Almidón, Otros                                '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (20, RTRIM('Preparações de produtos hortícolas, de frutas ou de outras partes de plantas                                                                                                                                                                                    '), RTRIM('Preparations of Vegetables, Fruit, Nuts Or Other Parts of Plants                        '), RTRIM('Preparaciones De Hortalizas, De Frutas U Otros Frutos, Otros                            '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (21, RTRIM('Preparações alimentícias diversas                                                                                                                                                                                                                               '), RTRIM('Miscellaneous Edible Preparations                                                       '), RTRIM('Preparaciones Alimenticias Diversas                                                     '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (22, RTRIM('Bebidas, líquidos alcoólicos e vinagres                                                                                                                                                                                                                         '), RTRIM('Beverages, Spirits and Vinegar                                                          '), RTRIM('Bebidas, Líquidos Alcohólicos y Vinagre                                                 '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (23, RTRIM('Resíduos e desperdícios das indústrias alimentares; alimentos preparados para animais                                                                                                                                                                           '), RTRIM('Residues and Waste From The Food Industries; Others                                     '), RTRIM('Residuos y Desperdicios De Las Industrias Alimentarias; Otros                           '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (24, RTRIM('Fumo (tabaco) e seus sucedâneos manufaturados                                                                                                                                                                                                                   '), RTRIM('Tobacco and Manufactured Tobacco Substitutes                                            '), RTRIM('Tabaco y Sucedáneos Del Tabaco Elaborados                                               '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (25, RTRIM('Sal; enxofre; terras e pedras; gesso, cal e cimento                                                                                                                                                                                                             '), RTRIM('Salt; Sulphur; Earths and Stone; Plastering Materials, Lime and Cement                  '), RTRIM('Sal; Azufre; Tierras y Piedras; yesos, Cales y Cementos                                 '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (26, RTRIM('Minérios, escórias e cinzas                                                                                                                                                                                                                                     '), RTRIM('Ores, Slag and Ash                                                                      '), RTRIM('Minerales Metalíferos, Escorias y Cenizas                                               '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (27, RTRIM('Combustíveis minerais, óleos Minerais e produtos da sua destilação; Matérias betuminosas; Ceras Minerais                                                                                                                                                        '), RTRIM('Mineral Fuels, Mineral Oils, Bituminous Substances; Mineral Waxes                       '), RTRIM('Combustibles Minerales, Aceites Minerales; Ceras Minerales, Otros                       '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (28, RTRIM('Produtos químicos inorgânicos; Compostos Inorgânicos ou orgânicos de metais preciosos, de elementos radioativos, de metais de terras raras ou de isótopos                                                                                                       '), RTRIM('Inorganic Chemicals; Organic Or Inorganic Compounds of Precious Metals, Others          '), RTRIM('Productos Químicos Inorgánicos; Otros                                                   '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (29, RTRIM('Produtos químicos orgânicos                                                                                                                                                                                                                                     '), RTRIM('Organic Chemicals                                                                       '), RTRIM('Productos Químicos Orgánicos                                                            '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (30, RTRIM('Produtos farmacêuticos                                                                                                                                                                                                                                          '), RTRIM('Pharmaceutical Products                                                                 '), RTRIM('Productos Farmacéuticos                                                                 '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (31, RTRIM('Adubos ou fertilizantes                                                                                                                                                                                                                                         '), RTRIM('Fertilisers                                                                             '), RTRIM('Abonos                                                                                  '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (32, RTRIM('Extratos tanantes e tintoriais; taninos e seus derivados; pigmentos e outras matérias corantes; tintas e vernizes; mástiques; tintas de escrever                                                                                                                '), RTRIM('Tanning Or Dyeing Extracts; Tannins and Their Derivatives; Others                       '), RTRIM('Extractos Curtientes O Tintóreos; Taninos y Sus Derivados; Otros                        '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (33, RTRIM('Óleos essenciais e resinóides; Produtos de perfumaria ou de toucador preparados e preparações cosméticas                                                                                                                                                        '), RTRIM('Essential Oils and Resinoids; Perfumery, Cosmetic Or Toilet Preparations                '), RTRIM('Aceites Esenciales y Resinoides; Preparaciones De Perfumería, Otros                     '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (34, RTRIM('Sabões, agentes orgânicos de superfície, preparações para lavagem, preparações lubrificantes, ceras artificiais, ceras preparadas, produtos de conservação e limpeza, velas e artigos semelhantes, massas ou pastas para modelar, "ceras" para dentistas e Comp '), RTRIM('Soap, Organic Surface-Active Agents, Others                                             '), RTRIM('Jabones, Agentes De Superficie Orgánicos, Otros                                         '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (35, RTRIM('Materias albuminóides; Produtos à base de amidos ou de féculas modificados; Colas; Enzimas                                                                                                                                                                      '), RTRIM('Albuminoidal Substances; Modified Starches; Glues; Enzymes                              '), RTRIM('Materias Albuminoideas; Productos A Base De Almidón O De Fécula Modificados; Otros      '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (36, RTRIM('Pólvoras e explosivos; Artigos de pirotecnia; Fósforos, ligas pirofóricas; Matérias inflamáveis                                                                                                                                                                 '), RTRIM('Explosives; Pyrotechnic Products; Matches; Others                                       '), RTRIM('Pólvora y Explosivos; Artículos De Pirotecnia; Otros                                    '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (37, RTRIM('Produtos para fotografia e cinematografia                                                                                                                                                                                                                       '), RTRIM('Photographic Or Cinematographic Goods                                                   '), RTRIM('Productos Fotográficos O Cinematográficos                                               '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (38, RTRIM('Produtos diversos das indústrias químicas                                                                                                                                                                                                                       '), RTRIM('Miscellaneous chemical products                                                         '), RTRIM('Productos Diversos De Las Industrias Químicas                                           '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (39, RTRIM('Plásticos e suas obras                                                                                                                                                                                                                                          '), RTRIM('Plastics and articles thereof                                                           '), RTRIM('Plástico y sus manufacturas                                                             '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (40, RTRIM('Borracha e suas obras                                                                                                                                                                                                                                           '), RTRIM('Rubber and articles thereof                                                             '), RTRIM('Caucho y sus manufacturas                                                               '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (41, RTRIM('Peles, exceto a peleteria (peles com pêlo), e couros                                                                                                                                                                                                            '), RTRIM('Raw Hides and Skins (Other Than Furskins) and Leather                                   '), RTRIM('Pieles (Excepto La Peletería) y Cueros                                                  '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (42, RTRIM('Obras de Couro; artigos de correeiro ou de seleiro; artigos de viagem, bolsas e artefatos semelhantes; obras de tripa                                                                                                                                           '), RTRIM('Articles of Leather; Articles of Animal Gut (Other Than Silkworm Gut), Others           '), RTRIM('Manufacturas De Cuero; Artículos De Talabartería O Guarnicionería; Otros                '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (43, RTRIM('Peleteria (peles com Pêlo) e suas obras; Peleteria (peles com pêlo) artificial                                                                                                                                                                                  '), RTRIM('Furskins and Artificial Fur; Manufactures Thereof                                       '), RTRIM('Peletería y Confecciones De Peletería; Peletería Facticia O Artifical                   '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (44, RTRIM('Madeira, carvão vegetal e obras de madeira                                                                                                                                                                                                                      '), RTRIM('Wood and Articles of Wood; Wood Charcoal                                                '), RTRIM('Madera, Carbón Vegetal y Manufacturas De Madera                                         '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (45, RTRIM('Cortiça e suas obras                                                                                                                                                                                                                                            '), RTRIM('Cork and Articles of Cork                                                               '), RTRIM('Corcho y sus manufacturas                                                               '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (46, RTRIM('Obras de espartaria ou de cestaria                                                                                                                                                                                                                              '), RTRIM('Manufactures of Straw, of Esparto Or of Other Plaiting Materials                        '), RTRIM('Manufacturas De Espartería O Cestería                                                   '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (47, RTRIM('Pastas de madeira ou de outras matérias fibrosas celulósicas; papel ou cartão de reciclar (desperdícios e aparas)                                                                                                                                               '), RTRIM('Pulp of Wood Or of Other Fibrous Cellulosic Material, Others,                           '), RTRIM('Pasta De Madera O De Las Demás Materias Fibrosas Celulósicas; Otros                     '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (48, RTRIM('Papel e cartão; obras de pasta de celulose, de papel ou de cartão                                                                                                                                                                                               '), RTRIM('Paper and Paperboard; Articles of Paper Pulp, of Paper Or of Paperboard                 '), RTRIM('Papel y Cartón; Manufacturas De Pasta De Celulosa, De Papel O Cartón                    '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (49, RTRIM('Livros, jornais, gravuras e outros produtos das indústrias gráficas; textos manuscritos ou datilografados, planos e plantas                                                                                                                                     '), RTRIM('Books, Newspapers, Pictures and Other Products of The Printing Industry; Others         '), RTRIM('Productos Editoriales, De La Prensa y De Las Demás Industrias Gráficas; Otros           '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (50, RTRIM('Seda                                                                                                                                                                                                                                                            '), RTRIM('Silk                                                                                    '), RTRIM('Seda                                                                                    '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (51, RTRIM('La, pêlos finos ou grosseiros; Fios e tecidos de crina                                                                                                                                                                                                          '), RTRIM('Wool, Fine Or Coarse Animal Hair; Horsehair Yarn and Woven Fabric                       '), RTRIM('Lana y Pelo Fino U Ordinario; Hilados y Tejidos De Crin                                 '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (52, RTRIM('Algodão                                                                                                                                                                                                                                                         '), RTRIM('Cotton                                                                                  '), RTRIM('Algodón                                                                                 '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (53, RTRIM('Outras fibras têxteis vegetais; fios de papel e tecidos de fio de papel                                                                                                                                                                                         '), RTRIM('Other Vegetable Textile Fibres; Paper Yarn and Woven Fabrics of Paper Yarn              '), RTRIM('Las Demás Fibras Textiles Vegetales; Hilados De Papel y Tejidos De Hilados De Papel     '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (54, RTRIM('Filamentos sintéticos ou artificiais                                                                                                                                                                                                                            '), RTRIM('Man-made filaments                                                                      '), RTRIM('Filamentos sintéticos o artificiales                                                    '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (55, RTRIM('Fibras sintéticas ou artificiais, descontínuas                                                                                                                                                                                                                  '), RTRIM('Man-Made staple fibres                                                                  '), RTRIM('Fibras sintéticas o Artificiales Discontinuas                                           '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (56, RTRIM('Pastas ("ouates"), feltros e falsos tecidos; fios especiais; cordéis, cordas e cabos; Artigos de cordoaria                                                                                                                                                      '), RTRIM('Wadding, Felt and Nonwovens; Others                                                     '), RTRIM('Guata, Fieltro y Tela Sin Tejer; Hilados Especiales; Otros                              '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (57, RTRIM('Tapetes e outros revestimentos para pavimentos, de matérias têxteis                                                                                                                                                                                             '), RTRIM('Carpets and Other Textile Floor Coverings                                               '), RTRIM('Alfombras y Demás Revestimientos Para El Suelo, De Materia Textil                       '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (58, RTRIM('Tecidos especiais; tecidos tufados; rendas; tapeçarias; passamanarias; bordados                                                                                                                                                                                 '), RTRIM('Special Woven Fabrics; Tufted Textile Fabrics; Lace; Tapestries; Others                 '), RTRIM('Tejidos Especiales; Superficies Textiles Con Mechón Insertado; Encajes; Tapicería; Otros'));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (59, RTRIM('Tecidos impregnados, Revestidos, Recobertos ou estratificados; Artigos para usos técnicos de matérias têxteis                                                                                                                                                   '), RTRIM('Impregnated, Coated, Covered Or Laminated Textile Fabrics; Others                       '), RTRIM('Telas Impregnadas, Recubiertas, Revestidas O Estratificadas; Otros                      '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (60, RTRIM('Tecidos de malha                                                                                                                                                                                                                                                '), RTRIM('Knitted or crocheted fabrics                                                            '), RTRIM('Tejidos de Punto                                                                        '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (61, RTRIM('Vestuário e seus acessórios, de malha                                                                                                                                                                                                                           '), RTRIM('Articles of Apparel and Clothing Accessories, Knitted Or Crocheted                      '), RTRIM('Prendas y Complementos (Accesorios), De Vestir, De Punto                                '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (62, RTRIM('Vestuário e seus acessórios, exceto de Malha                                                                                                                                                                                                                    '), RTRIM('Articles of Apparel and Clothing Accessories, Not Knitted Or Crocheted                  '), RTRIM('Prendas y Complementos (Accesorios), De Vestir, Excepto Los De Punto                    '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (63, RTRIM('Outros artefatos têxteis confeccionados; sortidos; Artefatos de matérias têxteis, calçados, chapéus e artefatos de uso semelhante, usados; trapos                                                                                                               '), RTRIM('Other Made-Up Textile Articles; Sets; Rags, Others                                      '), RTRIM('Los Demás Artículos Textiles Confeccionados; Juegos; Prendería y Trapos                 '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (64, RTRIM('Calçados, polainas e artefatos semelhantes, e suas partes                                                                                                                                                                                                       '), RTRIM('Footwear, Gaiters and The Like; Parts of Such Articles                                  '), RTRIM('Calzado, Polainas y Artículos Análogos; Partes De Estos Artículos                       '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (65, RTRIM('Chapéus e artefatos semelhantes, e suas partes                                                                                                                                                                                                                  '), RTRIM('Headgear and parts thereof                                                              '), RTRIM('Sombreros, Demás Tocados, y Sus Partes                                                  '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (66, RTRIM('Guarda-chuvas, sombrinhas, guarda-sóis, Bengalas, bengalas-assentos, chicotes, rebenques e suas partes                                                                                                                                                          '), RTRIM('Umbrellas, Sun Umbrellas, Walking-Sticks, Seat-Sticks, Whips, Riding-Crops, Others      '), RTRIM('Paraguas, Sombrillas, Quitasoles, Bastones, Otros                                       '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (67, RTRIM('Penas e penugem preparadas, e suas obras; flores artificiais; Obras de cabelo                                                                                                                                                                                   '), RTRIM('Prepared Feathers and Articles Made of Feathers Or of Down; Others                      '), RTRIM('Plumas y Plumón Preparados y Artículos De Plumas O Plumón; Otros                        '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (68, RTRIM('Obras de pedra, gesso, cimento, amianto, mica ou de matérias semelhantes                                                                                                                                                                                        '), RTRIM('Articles of Stone, Plaster, Cement, Asbestos, Mica Or Similar Materials                 '), RTRIM('Manufacturas De Piedra, yeso Fraguable, Cemento, Amianto, Otros                         '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (69, RTRIM('Produtos cerâmicos                                                                                                                                                                                                                                              '), RTRIM('Ceramic Products                                                                        '), RTRIM('Productos cerámicos                                                                     '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (70, RTRIM('Vidro e suas obras                                                                                                                                                                                                                                              '), RTRIM('Glass and glassware                                                                     '), RTRIM('Vidrio y sus manufacturas                                                               '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (71, RTRIM('Pérolas naturais ou cultivadas, pedras preciosas ou semipreciosas e semelhantes, metais preciosos, metais folheados ou chapeados de metais preciosos, e suas obras; Bijuterias; Moedas                                                                          '), RTRIM('Natural Or Cultured Pearls, Precious Or Semi-Precious Stones, Others                    '), RTRIM('Perlas Finas (Naturales) O Cultivadas, Piedras Preciosas, Otros                         '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (72, RTRIM('Ferro fundido, ferro e aço                                                                                                                                                                                                                                      '), RTRIM('Iron and steel                                                                          '), RTRIM('Fundición, hierro y acero                                                               '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (73, RTRIM('Obras de ferro fundido, ferro ou aço                                                                                                                                                                                                                            '), RTRIM('Articles of Iron Or Steel                                                               '), RTRIM('Manufacturas de fundición, de hierro o acero                                            '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (74, RTRIM('Cobre e suas obras                                                                                                                                                                                                                                              '), RTRIM('Copper and articles thereof                                                             '), RTRIM('Cobre y sus manufacturas                                                                '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (75, RTRIM('Níquel e suas obras                                                                                                                                                                                                                                             '), RTRIM('Nickel and articles thereof                                                             '), RTRIM('Níquel y sus manufacturas                                                               '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (76, RTRIM('Alumínio e suas obras                                                                                                                                                                                                                                           '), RTRIM('Aluminium and articles thereof                                                          '), RTRIM('Aluminio y sus manufacturas                                                             '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (77, RTRIM('(Reservado para uma eventual utilização futura no Sistema Harmonizado)                                                                                                                                                                                          '), RTRIM('(Reserved for possible future use in the Harmonized System)                             '), RTRIM('(Reservado para una futura utilización en el Sistema Armonizado)                        '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (78, RTRIM('Chumbo e suas obras                                                                                                                                                                                                                                             '), RTRIM('Lead and articles thereof                                                               '), RTRIM('Plomo y sus manufacturas                                                                '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (79, RTRIM('Zinco e suas obras                                                                                                                                                                                                                                              '), RTRIM('Zinc and articles thereof                                                               '), RTRIM('Cinc y sus manufacturas                                                                 '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (80, RTRIM('Estanho e suas obras                                                                                                                                                                                                                                            '), RTRIM('Tin and articles thereof                                                                '), RTRIM('Estaño y sus manufacturas                                                               '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (81, RTRIM('Outros metais comuns: ceramais ("cermets"); obras dessas matérias                                                                                                                                                                                               '), RTRIM('Other base metals; cermets; articles thereof                                            '), RTRIM('Los Demás Metales Comunes; Cermets; Manufacturas De Estas Materias                      '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (82, RTRIM('Ferramentas, artefatos de cutelaria e talheres, e suas partes, de metais comuns                                                                                                                                                                                 '), RTRIM('Tools, Implements, Cutlery, Spoons and Forks, of Base Metal; parts thereof of Base Metal'), RTRIM('Herramientas y Útiles, Artículos De Cuchillería, Otros, De Metal Común                  '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (83, RTRIM('Obras diversas de metais comuns                                                                                                                                                                                                                                 '), RTRIM('Miscellaneous articles of base metal                                                    '), RTRIM('Manufacturas diversas de metal común                                                    '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (84, RTRIM('Reatores nucleares, caldeiras, máquinas, aparelhos e instrumentos mecânicos e suas partes                                                                                                                                                                       '), RTRIM('Nuclear Reactors, Boilers, Machinery and Mechanical Appliances; Others                  '), RTRIM('Reactores Nucleares, Calderas, Máquinas, Otros                                          '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (85, RTRIM('Máquinas, aparelhos e materiais elétricos, e suas partes; Aparelhos de gravação ou de reprodução de som; Aparelhos de gravação ou de reprodução de imagens e de som em televisão, e suas partes e acessórios                                                    '), RTRIM('Electrical Machinery and Equipment and parts thereof; Others                            '), RTRIM('Máquinas, Aparatos y Material Eléctrico, y Sus Partes; Otros                            '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (86, RTRIM('Veículos e material para vias férreas ou semelhantes, e suas partes; aparelhos mecânicos (incluídos os eletromecânicos) de sinalização para vias de comunicação                                                                                                 '), RTRIM('Railway Or Tramway Locomotives, Rolling-Stock and parts thereof; Others                 '), RTRIM('Vehículos y Material Para Vías Férreas O Similares, y Sus Partes; Otros                 '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (87, RTRIM('Veículos automóveis, tratores, ciclos e outros veículos terrestres, suas partes e acessórios                                                                                                                                                                    '), RTRIM('Vehicles Other Than Railway Or Tramway Rolling-Stock, and Parts and Accessories Thereof '), RTRIM('Vehículos Automóviles, Tractores, Otros, Sus Partes y Accesorios                        '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (88, RTRIM('Aeronaves e aparelhos espaciais, e suas partes                                                                                                                                                                                                                  '), RTRIM('Aircraft, spacecraft, and parts thereof                                                 '), RTRIM('Aeronaves, vehículos espaciales, y sus partes                                           '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (89, RTRIM('Embarcações e estruturas flutuantes                                                                                                                                                                                                                             '), RTRIM('Ships, boats and floating structures                                                    '), RTRIM('Barcos y demás artefactos flotantes                                                     '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (90, RTRIM('Instrumentos e aparelhos de óptica, fotografia ou cinematografia, medida ou controle de precisão; Instrumentos e aparelhos médico-Cirúrgicos; suas partes e acessórios                                                                                          '), RTRIM('Optical, Photographic, Cinematographic Instruments; Others                              '), RTRIM('Instrumentos y Aparatos De Óptica, Fotografía O Cinematografía, Otros                   '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (91, RTRIM('Aparelhos de relojoaria e suas partes                                                                                                                                                                                                                           '), RTRIM('Clocks and Watches and parts thereof                                                    '), RTRIM('Aparatos De Relojería y Sus Partes                                                      '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (92, RTRIM('Instrumentos musicais; suas partes e acessórios                                                                                                                                                                                                                 '), RTRIM('Musical Instruments; Parts and Accessories of Such Articles                             '), RTRIM('Instrumentos Musicales; Sus Partes y Accesorios                                         '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (93, RTRIM('Armas e munições; suas partes e acessórios                                                                                                                                                                                                                      '), RTRIM('Arms and Ammunition; Parts and Accessories Thereof                                      '), RTRIM('Armas, Municiones, y Sus Partes y Accesorios                                            '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (94, RTRIM('Móveis; mobiliário médico-cirúrgico, colchões, almofadas e semelhantes; aparelhos de iluminação não especificados nem compreendidos em outros capítulos; anúncios, cartazes ou tabuletas e placas indicadoras luminosos, e artigos semelhantes; construções pré '), RTRIM('Furniture; Bedding, Mattresses, Cushions and Similar Stuffed Furnishings; Others        '), RTRIM('Muebles; Mobiliario Medicoquirúrgico; Artículos De Cama y Similares; Otros              '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (95, RTRIM('Brinquedos, jogos, artigos para diveRTRIMento ou para esporte; suas partes e acessórios                                                                                                                                                                         '), RTRIM('Toys, games and sports requisites; parts and accessories thereof                        '), RTRIM('Juguetes, juegos y artículos para recreo O deporte; sus partes y accesorios             '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (96, RTRIM('Obras diversas                                                                                                                                                                                                                                                  '), RTRIM('Miscellaneous manufactured articles                                                     '), RTRIM('Manufacturas diversas                                                                   '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (97, RTRIM('Objetos de arte, de coleção e antiguidades                                                                                                                                                                                                                      '), RTRIM('Works of art, collectors pieces and antiques                                            '), RTRIM('Objetos de arte o colección y antigüedades                                              '));
INSERT INTO migra_capitulo (id, cap_portugues, cap_ingles, cap_espanhol) VALUES (99, RTRIM('Transações especiais                                                                                                                                                                                                                                            '), RTRIM('Special operations                                                                      '), RTRIM('Transaciones especiales                                                                 '));



CREATE TABLE migra_posicao(
    id              INTEGER         NOT NULL,
    pos_portugues   VARCHAR(400)    NOT NULL,
    pos_ingles      VARCHAR(400)    NOT NULL,
    pos_espanhol    VARCHAR(400)    NOT NULL,
    id_capitulo    INTEGER         NOT NULL,
    CONSTRAINT pk_migra_posicao     PRIMARY KEY                 (id),
    CONSTRAINT fk_migra_posicao     FOREIGN KEY                 (id_capitulo)
                                    REFERENCES migra_capitulo   (id)
);

-- CO_SH4,NO_SH4_POR,NO_SH4_ING,NO_SH4_ESP,SH2
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0101,'Animais vivos das espécies cavalar, asinina e muar','Live horses, asses, mules and hinnies','Caballos, asnos, mulos y burdéganos, vivos',01);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0102,'Animais vivos da espécie bovina','Live bovine animals','Animales vivos de la especie bovina',01);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0103,'Animais vivos da espécie suína','Live swine animals','Animales vivos de la especie porcina',01);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0104,'Animais vivos das espécies ovina e caprina','Live sheep and goats','Animales vivos de las especies ovina o caprina',01);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0105,'Galos, galinhas, patos, gansos, perus, peruas e pintadas, das espécies domésticas, vivos','Live poultry, that is to say, fowls of the species Gallus domesticus, ducks, geese, turkeys and guinea fowls','Gallos, gallinas, patos, gansos, pavos (gallipavos) y pintadas, de las especies domésticas, vivos:',01);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0106,'Outros animais vivos','Other live animals','Demás animales vivos',01);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0201,'Carnes de animais da espécie bovina, frescas ou refrigeradas','Meat of bovine animals, fresh or chilled','Carne de animales de la especie bovina, fresca o refrigerada',02);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0202,'Carnes de animais da espécie bovina, congeladas','Meat of bovine animals, frozen','Carne de animales de la especie bovina, congelada',02);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0203,'Carnes de animais da espécie suína, frescas, refrigeradas ou congeladas','Meat of swine, fresh, chilled or frozen','Carne de animales de la especie porcina, fresca, refrigerada o congelada',02);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0204,'Carnes de animais das espécies ovina ou caprina, frescas, refrigeradas ou congeladas','Meat of sheep or goats, fresh, chilled or frozen','Carne de animales de las especies ovina o caprina, fresca, refrigerada o congelada',02);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0205,'Carnes de cavalo, asinino e muar, frescas, refrig.ou cong.','Meat of horses, asses, mules, etc.fresh, chilled or frozen','Carnes de la esp.caball.asnal y mular, fresc.ref.o cong.',02);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0206,'Miudezas comestíveis de animais das espécies bovina, suína, ovina, caprina, cavalar, asinina e muar, frescas, refrigeradas ou congeladas','Edible offal of bovine animals, swine, sheep, goats, horses, asses, mules or hinnies, fresh, chilled or frozen','Despojos comestibles de animales de las especies bovina, porcina, ovina, caprina, caballar, asnal o mular, frescos, refrigerados o congelados',02);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0207,'Carnes e miudezas comestíveis, frescas, refrigeradas ou congeladas, das aves da posição 0105','Meat and edible offal, of the poultry of heading No 0105, fresh, chilled or frozen','Carne y despojos comestibles, de aves de la partida 0105, frescos, refrigerados o congelados',02);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0208,'Outras carnes e miudezas comestíveis, frescas, refrigeradas ou congeladas','Other meat and edible meat offal, fresh, chilled or frozen','Demás carnes y despojos comestibles, frescos, refrigerados o congelados',02);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0209,'Toucinho sem partes magras, gorduras de porco e de aves, não fundidas nem extraídas de outro modo, frescos, refrigerados, congelados, salgados ou em salmoura, secos ou defumados.','Pig & poultry fat, fresh, chilled frozen, salted, dried, or smoked','Grasa libre de carne magra, la grasa de cerdo y de ave sin fundir ni extraer de otro modo, frescos, refrigerados, congelados, salados o em salmoura, secos o ahumados.',02);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0210,'Carnes e miudezas comestíveis, salgadas ou em salmoura, secas ou fumadas; farinhas e pós comestíveis, de carnes ou de miudezas','Meat and edible meat offal, salted, in brine, dried or smoked; edible flours and meals of meat or meat offal','Carne y despojos comestibles, salados o en salmuera, secos o ahumados; harina y polvo comestibles, de carne o de despojos',02);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0301,'Peixes vivos','Live fish','Peces vivos',03);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0302,'Peixes frescos ou refrigerados, exceto filetes de peixes e outra carne de peixes da posição 0304','Fish, fresh or chilled, excluding fish fillets and other fish meat of heading No 0304','Pescado fresco o refrigerado (excepto los filetes y demás carne de pescado de la partida 0304',03);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0303,'Peixes congelados, exceto os filetes de peixes e outra carne de peixes da posição 0304','Fish, frozen, excluding fish fillets and other fish meat of heading 0304','Pescado congelado (excepto los filetes y demás carne de pescado de la partida 0304',03);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0304,'Filés de peixes e outras carnes de peixes (mesmo picada), frescos, refrigerados ou congelados','Fish fillets and other fish meat (whether or not minced), fresh, chilled or frozen','Filetes y demás carne de pescado, incluso picada, frescos, refrigerados o congelados',03);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0305,'Peixes secos, salgados ou em salmoura; peixes fumados, mesmo cozidos antes ou durante a defumação; farinhas, pó e pellets de peixe, próprios para a alimentação humana','Fish, dried, salted or in brine; smoked fish, whether or not cooked before or during the smoking process; flours, meals and pellets of fish, fit for human consumption','Pescado seco, salado o en salmuera; pescado ahumado, incluso cocido antes o durante el ahumado; harina, polvo y pellets de pescado, aptos para la alimentación humana',03);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0306,'Crustáceos, mesmo sem casca, vivos, frescos, refrigerados, congelados, secos, salgados ou em salmoura; crustáceos com casca, cozidos em água ou vapor, mesmo refrigerados, congelados, secos, salgados ou em salmoura; farinhas, pó e pellets de crustáceos, pr','Crustaceans, whether in shell or not, live, fresh, chilled, frozen, dried, salted or in brine; crustaceans, in shell, cooked by steaming or by boiling in water, whether or not chilled, frozen, dried, salted or in brine; flours, meals and pellets of crusta','Crustáceos, incluso pelados, vivos, frescos, refrigerados, congelados, secos, salados o en salmuera; crustáceos sin pelar, cocidos en agua o vapor, incluso refrigerados, congelados, secos, salados o en salmuera; harina, polvo y pellets de crustáceos, apto',03);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0307,'Moluscos, com ou sem concha, vivos, frescos, refrigerados, congelados, secos, salgados ou em salmoura; invertebrados aquáticos, exceto crustáceos e moluscos, vivos, frescos, refrigerados, congelados, secos, salgados ou em salmoura; farinhas, pó e pellets','Molluscs, whether in shell or not, live, fresh, chilled, frozen, dried, salted or in brine; aquatic invertebrates other than crustaceans and molluscs, live, fresh, chilled, frozen, dried, salted or in brine; flours, meals and pellets of aquatic invertebra','Moluscos, incluso separados de sus valvas, vivos, frescos, refrigerados, congelados, secos, salados o en salmuera; invertebrados acuáticos, (excepto los crustáceos y moluscos), vivos, frescos, refrigerados, congelados, secos, salados o en salmuera; harina',03);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0308,'Invertebrados aquáticos, exceto crustáceos e moluscos, vivos','Aquatic invertebrates other than crustaceans and molluscs, live','Invertebrados acuáticos, excepto los crustáceos y moluscos, vivos',03);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0401,'Leite e nata, não concentrados nem adicionados de açúcar ou de outros edulcorantes','Milk and cream, not concentrated nor containing added sugar or other sweetening matter','Leche y nata (crema), sin concentrar, sin adición de azúcar ni otro edulcorante',04);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0402,'Leite e nata, concentrados ou adicionados de açúcar ou de outros edulcorantes','Milk and cream, concentrated or containing added sugar or other sweetening matter','Leche y nata (crema), concentradas o con adición de azúcar u otro edulcorante',04);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0403,'Leitelho, leite e nata coalhados, iogurte, kefir e outros leites e natas fermentados ou acidificados, mesmo concentrados ou adicionados de açúcar ou de outros edulcorantes, ou aromatizados ou adicionados de frutas ou de cacau','Buttermilk, curdled milk and cream, yogurt, kephir and other fermented or acidified milk and cream, whether or not concentrated or containing added sugar or other sweetening matter or flavoured or containing added fruit, nuts or cocoa','Suero de mantequilla (de manteca), leche y nata (crema) cuajadas, yogur, kéfir y demás leches y natas (cremas), fermentadas o acidificadas, incluso concentrados, con adición de azúcar u otro edulcorante, aromatizados o con frutas u otros frutos o cacao',04);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0404,'Soro de leite, mesmo concentrado ou adicionado de açúcar ou de outros edulcorantes; produtos constituídos por componentes naturais do leite, mesmo adicionados de açúcar ou de outros edulcorantes, não especificados nem compreendidos em outras posições','Whey, whether or not concentrated or containing added sugar or other sweetening matter; products consisting of natural milk constituents, whether or not containing added sugar or other sweetening matter, not elsewhere specified or included','Lactosuero, incluso concentrado o con adición de azúcar u otro edulcorante; productos constituidos por los componentes naturales de la leche, incluso con adición de azúcar u otro edulcorante, no expresados o incluidos en otra parte',04);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0405,'Manteiga e outras matérias gordas provenientes do leite; pastas de barrar (espalhar) de produtos provenientes do leite','Butter and other fats and oils derived from milk; dairy spreads','Mantequilla (manteca) y demás materias grasas de la leche; pastas lácteas para untar',04);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0406,'Queijos e requeijão','Cheese and curd','Quesos y requesón',04);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0407,'Ovos de aves, com casca, frescos, conservados ou cozidos','Birds'' eggs, in shell, fresh, preserved or cooked','Huevos de ave con cáscara, frescos, conservados o cocidos',04);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0408,'Ovos de aves, sem casca, e gemas de ovos, frescos, secos, cozidos em água ou vapor, moldados, congelados ou conservados de outro modo, mesmo adicionados de açúcar ou de outros edulcorantes','Birds'' eggs, not in shell, and egg yolks, fresh, dried, cooked by steaming or by boiling in water, moulded, frozen or otherwise preserved, whether or not containing added sugar or other sweetening matter','Huevos de ave sin cáscara (cascarón) y yemas de huevo, frescos, secos, cocidos en agua o vapor, moldeados, congelados o conservados de otro modo, incluso con adición de azúcar u otro edulcorante',04);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0409,'Mel natural','Natural honey','Miel natural',04);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0410,'Outros produtos comestíveis de origem animal','Edible products of animal origin','Demás productos comestibles de origen animal',04);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0501,'Cabelos em bruto e desperdícios de cabelo','Human hair, unworked; wastes of human hair','Cabello en bruto y desperdicios de cabello',05);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0502,'Cerdas de porco ou de javali; pêlos de texugo e outros pêlos para escovas, pincéis e artigos semelhantes; desperdícios destas cerdas e pêlos','Pigs, hogs or boars bristles and hair; badger hair and other brush making hair; waste of such bristles or hair','Cerdas de cerdo o de jabalí; pelo de tejón y demás pelos para cepillería; desperdicios de dichas cerdas o pelos',05);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0503,'Crinas e seus desperdícios, mesmo em mantas','Horsehair and horsehair waste, whether/not put up as layer','Crin y sus desperdicios, incluso en capas c/soporte',05);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0504,'Tripas, bexigas e estômagos de animais, exceto peixes, inteiros ou em pedaços, frescos, refrigerados, congelados, salgados, secos ou defumados','Animal (not fish) guts, bladders, stomachs and parts','Tripas, vejigas y estómagos de animales (no peces), y partes',05);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0505,'Peles e outras partes de aves, com as suas penas ou penugem, penas e partes de penas (mesmo aparadas), penugem, em bruto ou simplesmente limpas, desinfectadas ou preparadas tendo em vista a sua conservação; pós e desperdícios de penas ou de partes de pena','Skins and other parts of birds, with their feathers or down, feathers and parts of feathers (whether or not with trimmed edges) and down, not further worked than cleaned, disinfected or treated for preservation; powder and waste of feathers or parts of fe','Pieles y demás partes de ave, con sus plumas o plumón, plumas y partes de plumas, incluso recortadas, y plumón, en bruto o simplemente limpiados, desinfectados o preparados para su conservación; polvo y desperdicios de plumas o de partes de plumas',05);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0506,'Ossos e núcleos córneos, em bruto, desengordurados ou simplesmente preparados (mas não cortados sob forma determinada), acidulados ou degelatinados; pós e desperdícios destas matérias','Bones and horn-cores, unworked, defatted, simply prepared (but not cut to shape), treated with acid or degelatinised; powder and waste of these products','Huesos y núcleos córneos, en bruto, desgrasados, simplemente preparados (pero sin cortar en forma determinada), acidulados o desgelatinizados; polvo y desperdicios de estas materias',05);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0507,'Marfim, carapaças de tartaruga, barbas, incluídas as franjas, de baleia ou de outros mamíferos marinhos, chifres, galhadas, cascos, unhas, garras e bicos, em bruto ou simplesmente preparados, mas não cortados em forma determinada; pós e desperdícios desta','Ivory, tortoise-shell, whalebone and whalebone hair, horns, antlers, hooves, nails, claws and beaks, unworked or simply prepared but not cut to shape; powder and waste of these products','Marfil, concha (caparazón) de tortuga, ballenas de mamíferos marinos, incluidas las barbas, cuernos, astas, cascos, pezuñas, uñas, garras y picos, en bruto o simplemente preparados, pero sin cortar en forma determinada; polvo y desperdicios de estas mater',05);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0508,'Coral, conchas, carapaças de moluscos, etc.em bruto, prepar','Coral, shells, shells of mollusks, etc.unworked, prepared','Coral, conchas, caparazones de moluscos, etc, en bruto, prep',05);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0509,'Esponjas naturais de origem animal','Natural sponges of animal origin','Esponjas naturales de origen animal',05);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0510,'Âmbar-cinzento, castóreo, algália e almíscar; bílis, mesmo seca; glândulas e outras substâncias de origem animal utilizadas na preparação de produtos farmacêuticos, frescas, refrigeradas, congeladas ou provisoriamente conservadas de outro modo','Ambergris, castoreum etc, glands etc for pharmacy','Ámbar gris, castóreo, etc, etc glándulas para la farmacia',05);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0511,'Produtos de origem animal, não especificados nem compreendidos em outras posições; animais mortos dos Capítulos 1 ou 3, impróprios para alimentação humana','Animal products not elsewhere specified or included; dead animals of Chapter 1 or 3, unfit for human consumption','Productos de origen animal no expresados ni comprendidos en otra parte; animales muertos de los capítulos 1 ó 3, impropios para la alimentación humana',05);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0601,'Bolbos, tubérculos, raízes tuberosas, rebentos e rizomas, em repouso vegetativo, em vegetação ou em flor; mudas, plantas e raízes de chicória, exceto as raízes da posição 1212','Bulbs, tubers, tuberous roots, corms, crowns and rhizomes, dormant, in growth or in flower; chicory plants and roots other than roots of heading No 1212','Bulbos, cebollas, tubérculos, raíces y bulbos tuberosos, turiones y rizomas, en reposo vegetativo, en vegetación o en flor; plantas y raíces de achicoria (excepto las raíces de la partida 1212)',06);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0602,'Outras plantas vivas (incluídas as suas raízes), estacas e enxertos; micélios de cogumelos','Other live plants (including their roots), cuttings and slips; mushroom spawn','Las demás plantas vivas, incluidas sus raíces, esquejes e injertos; micelios',06);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0603,'Flores e seus botões, cortados para ramos ou para ornamentação, frescos, secos, branqueados, tingidos, impregnados ou preparados de outro modo','Cut flowers and flower buds of a kind suitable for bouquets or for ornamental purposes, fresh, dried, dyed, bleached, impregnated or otherwise prepared','Flores y capullos, cortados para ramos o adornos, frescos, secos, blanqueados, teñidos, impregnados o preparados de otra forma',06);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0604,'Folhagem, folhas, ramos e outras partes de plantas, sem flores nem botões de flores, e ervas, musgos e líquenes, para ramos ou para ornamentação, frescos, secos, branqueados, tingidos, impregnados ou preparados de outro modo','Foliage, branches and other parts of plants, without flowers or flower buds, and grasses, mosses and lichens, being goods of a kind suitable for bouquets or for ornamental purposes, fresh, dried, dyed, bleached, impregnated or otherwise prepared','Follaje, hojas, ramas y demás partes de plantas, sin flores ni capullos, y hierbas, musgos y líquenes, para ramos o adornos, frescos, secos, blanqueados, teñidos, impregnados o preparados de otra forma',06);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0701,'Batatas, frescas ou refrigeradas','Potatoes, fresh or chilled','Patatas (papas) frescas o refrigeradas',07);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0702,'Tomates, frescos ou refrigerados','Tomato, fresh or chilled','Tomates, frescos o refrigerados',07);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0703,'Cebolas, chalotas, alho comum, alho-porro e outros produtos hortícolas aliáceos, frescos ou refrigerados','Onions, shallots, garlic, leeks and other alliaceous vegetables, fresh or chilled','Cebollas, chalotes, ajos, puerros y demás hortalizas, incluso «silvestres», aliáceas, frescos o refrigerados',07);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0704,'Couves, couve-flor, repolho ou couve frisada, couve-rábano e produtos comestíveis semelhantes do género Brassica, frescos ou refrigerados','Cabbages, cauliflowers, kohlrabi, kale and similar edible brassicas, fresh or chilled','Coles, incluidos los repollos, coliflores, coles rizadas, colinabos y productos comestibles similares del género Brassica, frescos o refrigerados',07);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0705,'Alface (Lactuca sativa) e chicórias (Cichorium spp.), frescas ou refrigeradas','Lettuce (Lactuca sativa) and chicory (Cichorium spp.), fresh or chilled','Lechugas (Lactuca sativa) y achicorias, comprendidas la escarola y la endibia (Cichorium spp.), frescas o refrigeradas',07);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0706,'Cenouras, nabos, beterrabas para salada, cercefi, aipo-rábano, rabanetes e raízes comestíveis semelhantes, frescos ou refrigerados','Carrots, turnips, salad beetroot, salsify, celeriac, radishes and similar edible roots, fresh or chilled','Zanahorias, nabos, remolachas para ensalada, salsifíes, apionabos, rábanos y raíces comestibles similares, frescos o refrigerados',07);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0707,'Pepinos e pepininhos "cornichons", frescos, refrigerados','Cucumbers and gherkins, fresh or chilled','Pepinos y pepinillos frescos,  refrigerados',07);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0708,'Legumes de vagem, com ou sem vagem, frescos ou refrigerados','Leguminous vegetables, shelled or unshelled, fresh or chilled','Hortalizas, incluso «silvestres», de vaina, aunque estén desvainadas, frescas o refrigeradas',07);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0709,'Outros produtos hortícolas, frescos ou refrigerados','Other vegetables, fresh or chilled','Las demás hortalizas, incluso «silvestres», frescas o refrigeradas',07);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0710,'Produtos hortícolas, não cozidos ou cozidos em água ou vapor, congelados','Vegetables (uncooked or cooked by steaming or boiling in water), frozen','Hortalizas, incluso «silvestres», aunque estén cocidas en agua o vapor, congeladas',07);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0711,'Produtos hortícolas conservados transitoriamente (por exemplo: com gás sulfuroso ou água salgada, sulfurada ou adicionada de outras substâncias destinadas a assegurar transitoriamente a sua conservação), mas impróprios para a alimentação nesse estado','Vegetables provisionally preserved (for example, by sulphur dioxide gas, in brine, in sulphur water or in other preservative solutions), but unsuitable in that state for immediate consumption','Hortalizas, incluso «silvestres», conservadas provisionalmente (por ejemplo: con gas sulfuroso o con agua salada, sulfurosa o adicionada de otras sustancias para asegurar dicha conservación), pero todavía impropias para consumo inmediato',07);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0712,'Produtos hortícolas secos, mesmo cortados em pedaços ou fatias, ou ainda triturados ou em pó, mas sem qualquer outro preparo','Dried vegetables, whole, cut, sliced, broken or in powder, but not further prepared','Hortalizas, incluso «silvestres», secas, incluidas las cortadas en trozos o en rodajas o las trituradas o pulverizadas, pero sin otra preparación',07);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0713,'Legumes de vagem, secos, em grão, mesmo pelados ou partidos','Dried leguminous vegetables, shelled, whether or not skinned or split','Hortalizas, incluso «silvestres», de vaina secas desvainadas, aunque estén mondadas o partidas',07);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0714,'Raízes de mandioca, de araruta e de salepo, topinambos, batatas-doces e raízes ou tubérculos semelhantes, com elevado teor de fécula ou de inulina, frescos, refrigerados, congelados ou secos, mesmo cortados em pedaços ou em pellets; medula de sagueiro','Manioc, arrowroot, salep, Jerusalem artichokes, sweet potatoes and similar roots and tubers with high starch or inulin content, fresh, chilled, frozen or dried, whether or not sliced or in the form of pellets; sago pith','Raíces de mandioca (yuca), arrurruz o salep, aguaturmas (patacas), batatas (boniatos, camotes) y raíces y tubérculos similares ricos en fécula o inulina, frescos o refrigerados, congelados o secos, incluso troceados o en pellets; médula de sagú',07);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0801,'Cocos, castanha do Brasil e castanha de caju, frescos ou secos, mesmo sem casca ou pelados','Coconuts, Brazil nuts and cashew nuts, fresh or dried, whether or not shelled or peeled','Cocos, nueces del Brasil y nueces de marañón (merey, cajuil, anacardo, cajú), frescos o secos, incluso sin cáscara o mondados',08);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0802,'Outras frutas de casca rija, frescas ou secas, mesmo sem casca ou peladas','Other nuts, fresh or dried, whether or not shelled or peeled','Los demás frutos de cáscara frescos o secos, incluso sin cáscara o mondados',08);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0803,'Bananas frescas ou secas','Fresh or dried bananas','Plátanos frescos o secos',08);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0804,'Tâmaras, figos, ananases (abacaxis), abacates, goiabas, mangas e mangostões, frescos ou secos','Dates, figs, pineapples, avocados, guavas, mangoes and mangosteens, fresh or dried','Dátiles, higos, piñas (ananás), aguacates, (paltas), guayabas, mangos y mangostanes, frescos o secos',08);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0805,'Citrinos, frescos ou secos','Citrus fruit, fresh or dried','Agrios (cítricos) frescos o secos',08);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0806,'Uvas frescas ou secas','Grapes, fresh or dried','Uvas, frescas o secas, incluidas las pasas',08);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0807,'Melões, melancias e papaias (mamões), frescos','Melons (including watermelons) and papaws (papayas), fresh','Melones, sandías y papayas, frescos',08);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0808,'Maçãs, pêras e marmelos, frescos','Apples, pears and quinces, fresh','Manzanas, peras y membrillos, frescos',08);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0809,'Damascos, cerejas, pêssegos (incluídas as nectarinas), ameixas e abrunhos, frescos','Apricots, cherries, peaches (including nectarines), plums and sloes, fresh','Albaricoques (damascos, chabacanos), cerezas, melocotones (duraznos), incluidos los griñones y nectarinas, ciruelas y endrinas, frescos',08);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0810,'Outras frutas frescas','Other fruit, fresh','Demás frutas u otros frutos, frescos',08);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0811,'Frutas, não cozidas ou cozidas em água ou vapor, congeladas, mesmo adicionadas de açúcar ou de outros edulcorantes','Fruit and nuts, uncooked or cooked by steaming or boiling in water, frozen, whether or not containing added sugar or other sweetening matter','Frutas y otros frutos, sin cocer o cocidos en agua o vapor, congelados, incluso con adición de azúcar u otro edulcorante',08);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0812,'Frutas conservadas transitoriamente (por exemplo: com gás sulfuroso ou água salgada, sulfurada ou adicionada de outras substâncias destinadas a assegurar transitoriamente a sua conservação), mas impróprias para alimentação nesse estado','Fruit and nuts, provisionally preserved (for example, by sulphur dioxide gas, in brine, in sulphur water or in other preservative solutions), but unsuitable in that state for immediate consumption','Frutas u otros frutos, conservados provisionalmente (por ejemplo: con gas sulfuroso o con agua salada, sulfurosa o adicionada de otras sustancias para dicha conservación), pero todavía impropios para consumo inmediato',08);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0813,'Frutas secas, exceto das posições 0801 a 0806; misturas de frutas secas ou de frutas de casca rija, do presente capítulo','Fruit, dried, other than that of headings 0801 to 0806; mixtures of nuts or dried fruits of this chapter','Frutas y otros frutos secos (excepto los de las partidas 0801 a 0806); mezclas de frutas u otros frutos secos o de frutos de cáscara de este capítulo',08);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0814,'Cascas de cítricos, melões, melancias, frescas, secas, etc.','Peel of citrus fruit, melons, watermelons, fresh, dried, etc','Corteza de agrios, melones, sandías, frescas, secas, etc',08);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0901,'Café, mesmo torrado ou descafeinado; cascas e películas de café; sucedâneos do café contendo café em qualquer proporção','Coffee, whether or not roasted or decaffeinated; coffee husks and skins; coffee substitutes containing coffee in any proportion','Café, incluso tostado o descafeinado; cáscara y cascarilla de café; sucedáneos del café que contengan café en cualquier proporción',09);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0902,'Chá, mesmo aromatizado','Tea, whether or not flavoured','Té, incluso aromatizado',09);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0903,'Mate','Mate','Mate',09);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0904,'Pimenta (do género Piper); pimentos dos géneros Capsicum ou Pimenta, secos ou triturados ou em pó','Pepper of the genus Piper; dried or crushed or ground fruits of the genus Capsicum or of the genus Pimenta','Pimienta del género Piper; frutos de los géneros Capsicum o Pimenta, secos, triturados o pulverizados',09);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0905,'Baunilha','Vanilla beans','Vainilla',09);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0906,'Canela e flores de caneleira','Cinnamon and cinnamon-tree flowers','Canela y flores de canelero',09);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0907,'Cravo-da-índia (frutos, flores e pedúnculos)','Cloves (whole fruit, cloves and stems)','Clavo de india (frutos, clavillos y pedúnculos)',09);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0908,'Noz-moscada, macis, amomos e cardamomos','Nutmeg, mace and cardamoms','Nuez moscada, macis, amomos y cardamomos',09);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0909,'Sementes de anis, badiana, funcho, coentro, cominho ou de alcaravia; bagas de zimbro','Seeds of anise, badian, fennel, coriander, cumin or caraway; juniper berries','Semillas de anís, badiana, hinojo, cilantro, comino o alcaravea; bayas de enebro',09);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (0910,'Gengibre, açafrão, curcuma, tomilho, louro, caril e outras especiarias','Ginger, saffron, turmeric (curcuma), thyme, bay leaves, curry and other spices','Jengibre, azafrán, cúrcuma, tomillo, hojas de laurel, curry y demás especias',09);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1001,'Trigo e mistura de trigo com centeio','Wheat and meslin','Trigo y morcajo (tranquillón)',10);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1002,'Centeio','Rye','Centeno',10);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1003,'Cevada','Barley','Cebada',10);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1004,'Aveia','Oats','Avena',10);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1005,'Milho','Maize (corn)','Maíz',10);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1006,'Arroz','Rice','Arroz',10);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1007,'Sorgo de grão','Grain sorghum','Grano de sorgo',10);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1008,'Trigo mourisco, painço e alpista; outros cereais','Buckwheat, millet and canary seed; other cereals','Alforfón, mijo y alpiste; los demás cereales',10);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1101,'Farinhas de trigo ou de mistura de trigo com centeio','Wheat or meslin flour','Harina de trigo o morcajo',11);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1102,'Farinhas de cereais, exceto de trigo ou de mistura de trigo com centeio','Cereal flours other than of wheat or meslin','Harina de cereales (excepto de trigo o de morcajo [tranquillón])',11);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1103,'Grumos, sêmolas e pellets, de cereais','Cereal groats, meal and pellets','Grañones, sémola y pellets, de cereales',11);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1104,'Grãos de cereais trabalhados de outro modo (por exemplo: descascados, pelados, esmagados, em flocos, em pérolas, cortados ou partidos), com exclusão do arroz da posição 1006; germes de cereais, inteiros, esmagados, em flocos ou moídos','Cereal grains otherwise worked (for example, hulled, rolled, flaked, pearled, sliced or kibbled), except rice of heading 1006; germ of cereals, whole, rolled, flaked or ground','Granos de cereales trabajados de otra modo (por ejemplo: mondados, aplastados, en copos, perlados, troceados o quebrantados) (excepto del arroz de la partida 1006); germen de cereales entero, aplastado, en copos o molido',11);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1105,'Farinha, sêmola, pó, flocos, grânulos e pellets de batata','Flour, meal, powder, flakes, granules and pellets of potatoes','Harina, sémola, polvo, copos, gránulos y pellets, de patata (papa)',11);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1106,'Farinhas, sêmolas e pós, de legumes de vagem secos da posição 0713, de sagu ou das raízes ou tubérculos da posição 0714 e dos produtos do Capítulo 8','Flour, meal and powder of the dried leguminous vegetables of heading 0713, of sago or of roots or tubers of heading 0714 or of the products of Chapter 8','Harina, sémola y polvo de las hortalizas, de la partida 0713, de sagú o de las raíces o tubérculos de la partida 0714 ó de los productos del capítulo 8',11);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1107,'Malte, mesmo torrado','Malt, whether or not roasted','Malta (de cebada u otros cereales) incluso tostada',11);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1108,'Amidos e féculas; inulina','Starches; inulin','Almidón y fécula; inulina',11);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1109,'Glúten de trigo, mesmo seco','Wheat gluten, even dried','Gluten de trigo, incluso seco',11);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1201,'Soja, mesmo triturada','Soya beans, whether or not broken','Soja, incluso quebrantadas',12);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1202,'Amendoins não torrados nem de outro modo cozidos, mesmo descascados ou triturados','Ground-nuts, not roasted or otherwise cooked, whether or not shelled or broken','Cacahuetes (cacahuates, maníes) sin tostar ni cocer de otro modo, incluso sin cáscara o quebrantados',12);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1203,'Copra em grãos','Copra in grains','Copra en granos',12);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1204,'Sementes de linho (linhaça), mesmo trituradas','Flaxseed (linseed), whether or not broken','Linaza (semilla de lino), incluso quebrantadas',12);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1205,'Sementes de nabo silvestre ou de colza, mesmo trituradas','Rape or colza seeds, whether or not broken','Semillas de nabo (de nabina) o de colza, incluso quebrantadas',12);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1206,'Sementes de girassol, mesmo trituradas','Sunflower seeds, whether or not broken','Semillas de girasol, incluso quebrantadas',12);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1207,'Outras sementes e frutos oleaginosos, mesmo triturados','Other oil seeds and oleaginous fruits, whether or not broken','Las demás semillas y frutos oleaginosos, incluso quebrantados',12);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1208,'Farinhas de sementes ou de frutos oleaginosos, exceto farinha de mostarda','Flours and meals of oil seeds or oleaginous fruits, other than those of mustard','Harina de semillas o de frutos oleaginosos (excepto la harina de mostaza)',12);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1209,'Sementes, frutos e esporos, para sementeira','Seeds, fruit and spores, of a kind used for sowing','Semillas, frutos y esporas, para siembra',12);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1210,'Cones de lúpulo, frescos ou secos, mesmo triturados ou moídos ou em pellets; lupulina','Hop cones, fresh or dried, whether or not ground, powdered or in the form of pellets; lupulin','Conos de lúpulo frescos o secos, incluso triturados, molidos o en pellets; lupulino',12);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1211,'Plantas, partes de plantas, sementes e frutos, das espécies utilizadas principalmente em perfumaria, medicina ou como insecticidas, parasiticidas e semelhantes, frescos ou secos, mesmo cortados, triturados ou em pó','Plants and parts of plants (including seeds and fruits), of a kind used primarily in perfumery, in pharmacy or for insecticidal, fungicidal or similar purposes, fresh or dried, whether or not cut, crushed or powdered','Plantas, partes de plantas, semillas y frutos de las especies utilizadas principalmente en perfumería, medicina o para usos insecticidas, parasiticidas o similares, frescos o secos, incluso cortados, triturados o pulverizados',12);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1212,'Alfarroba, algas, beterraba sacarina e cana-de-açúcar, frescas, refrigeradas, congeladas ou secas, mesmo em pó; caroços e amêndoas de frutos e outros produtos vegetais (incluídas as raízes de chicória não torradas, da variedade Cichorium intybus sativum) ','Locust beans, seaweeds and other algae, sugar beet and sugar cane, fresh, chilled, frozen or dried, whether or not ground; fruit stones and kernels and other vegetable products (including unroasted chicory roots of the variety Cichorium intybus sativum) o','Algarrobas, algas, remolacha azucarera y caña de azúcar, frescas, refrigeradas, congeladas o secas, incluso pulverizadas; huesos (carozos) y almendras de frutas y demás productos vegetales, incluidas las raíces de achicoria sin tostar de la variedad, Cich',12);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1213,'Palhas, cascas de cereais, em bruto, moidas, prensadas, etc.','Cereal straw and husks, unprepared, ground, pressed, etc.','Pajas, cascabillos de cereal.en bruto, molidos, prens.etc',12);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1214,'Rutabagas, beterrabas forrageiras, raízes forrageiras, feno, luzerna, trevo, sanfeno, couves forrageiras, tremoço, ervilhaca e produtos forrageiros semelhantes, mesmo em pellets','Swedes, mangolds, fodder roots, hay, lucerne (alfalfa), clover, sainfoin, forage kale, lupines, vetches and similar forage products, whether or not in the form of pellets','Nabos forrajeros, remolachas forrajeras, raíces forrajeras, heno, alfalfa, trébol, esparceta, coles forrajeras, altramuces, vezas y productos forrajeros similares, incluso en pellets',12);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1301,'Goma-laca; gomas, resinas, gomas-resinas e oleorresinas (bálsamos por exemplo), naturais','Lac; natural gums, resins, gum-resins and oleoresins (for example, balsams)','Goma laca; gomas, resinas, gomorresinas y oleorresinas (por ejemplo: bálsamos), naturales',13);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1302,'Sucos e extractos vegetais; matérias pécticas, pectinatos e pectatos; ágar-ágar e outros produtos mucilaginosos e espessantes derivados dos vegetais, mesmo modificados','Vegetable saps and extracts; pectic substances, pectinates and pectates; agar-agar and other mucilages and thickeners, whether or not modified, derived from vegetable products','Jugos y extractos vegetales; materias pécticas, pectinatos y pectatos; agar-agar y demás mucílagos y espesativos derivados de los vegetales, incluso modificados',13);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1401,'Matérias vegetais das espécies principalmente utilizadas em cestaria ou espartaria (por exemplo: bambus, rotins, canas, juncos, vimes, ráfia, palha de cereais limpa, branqueada ou tingida, casca de tília)','Vegetable materials of a kind used primarily for plaiting (for example, bamboos, rattans, reeds, rushes, osier, raffia, cleaned, bleached or dyed cereal straw, and lime bark)','Materias vegetales de las especies utilizadas principalmente en cestería o espartería (por ejemplo: bambú, roten (ratán), caña, junco, mimbre, rafia, paja de cereales, limpiada, blanqueada o teñida, corteza de tilo)',14);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1402,'Matérias vegetais para enchimento e estofamento','Vegetable materials for stuffing and padding','Materias vegetales para relleno',14);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1403,'Matérias vegetais para fabricação de vassouras','Vegetable materials for brooms','Materias vegetales de las escobas',14);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1404,'Produtos vegetais não especificados nem compreendidos noutras posições','Vegetable products not elsewhere specified or included','Productos vegetales no expresados ni comprendidos en otra parte',14);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1501,'Gorduras de porco (incluindo a banha) e gordura de aves','Pig fat (including lard) and poultry fat','Grasa de cerdo (incluso la manteca de cerdo), y grasa de ave',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1502,'Gorduras de animais das espécies bovina, ovina ou caprina, exceto as da posição 15.03','Fats of bovine animals, sheep or goats, other than those of heading 15.03','Grasa de animales de las especies bovina, ovina o caprina, excepto las de la partida 15.03',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1503,'Estearina solar, óleo de banha de porco, etc.n/preparados','Lard stearin, lard oil, etc.unprepared','Estearina solar, aceite de manteca de cerdo, etc, s/prep.',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1504,'Gorduras, óleos e respectivas fracções, de peixes ou de mamíferos marinhos, mesmo refinados, mas não quimicamente modificados','Fats and oils and their fractions, of fish or marine mammals, whether or not refined, but not chemically modified','Grasas y aceites, y sus fracciones, de pescado o de mamíferos marinos, incluso refinados, pero sin modificar químicamente',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1505,'Suarda e substâncias gordas dela derivadas, incluindo a lanolina','Wool grease & fatty substances derived therefrom (inlduing lanolin)','Grasa de lana y sustancias grasas derivadas, incluida la lanolina',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1506,'Outras gorduras, óleos, animais, incluindo refinado, mas não modificado químicamente','Other fats, oils, animals, incl.refined but n/chemic.modif','Demás grasas, aceites, anim.incl.refin.s/modif.químicam',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1507,'Óleo de soja e respectivas fracções, mesmo refinados, mas não quimicamente modificados','Soya-bean oil and its fractions, whether or not refined, but not chemically modified','Aceite de soja (soya) y sus fracciones, incluso refinado, pero sin modificar químicamente',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1508,'Óleo de amendoim e respectivas fracções, mesmo refinados, mas não quimicamente modificados','Ground-nut oil and its fractions, whether or not refined, but not chemically modified','Aceite de cacahuete (cacahuete, maní) y sus fracciones, incluso refinado, pero sin modificar químicamente',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1509,'Azeite de oliveira e respectivas fracções, mesmo refinados, mas não quimicamente modificados','Olive oil and its fractions, whether or not refined, but not chemically modified','Aceite de oliva y sus fracciones, incluso refinado, pero sin modificar químicamente',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1510,'Outros óleos de azeitonas e misturas c/azeites de oliva','Other oils of olives and mixtur.with olive oil of olive','Demás aceites de aceituna y mezclas con aceites de oliva',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1511,'Óleo de palma e respectivas fracções, mesmo refinados, mas não quimicamente modificados','Palm oil and its fractions, whether or not refined, but not chemically modified','Aceite de palma y sus fracciones, incluso refinado, pero sin modificar químicamente',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1512,'Óleos de girassol, de cártamo ou de algodão e respectivas fracções, mesmo refinados, mas não quimicamente modificados','Sunflower-seed, safflower or cotton-seed oil and fractions thereof, whether or not refined, but not chemically modified','Aceites de girasol, cártamo o algodón, y sus fracciones, incluso refinados, pero sin modificar químicamente',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1513,'Óleos de coco (óleo de copra), de palmiste ou de babaçu e respectivas fracções, mesmo refinados, mas não quimicamente modificados','Coconut (copra), palm kernel or babassu oil and fractions thereof, whether or not refined, but not chemically modified','Aceites de coco (de copra), de almendra de palma o de babasú, y sus fracciones, incluso refinados, pero sin modificar químicamente',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1514,'Óleos de nabo silvestre, de colza ou de mostarda, e respectivas fracções, mesmo refinados, mas não quimicamente modificados','Rape, colza or mustard oil and fractions thereof, whether or not refined, but not chemically modified','Aceites de nabo (de nabina), colza o mostaza, y sus fracciones, incluso refinados, pero sin modificar químicamente',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1515,'Outras gorduras e óleos vegetais (incluído o óleo de jojoba) e respectivas fracções, fixos, mesmo refinados, mas não quimicamente modificados','Other fixed vegetable fats and oils (including jojoba oil) and their fractions, whether or not refined, but not chemically modified','Las demás grasas y aceites vegetales fijos, incluido el aceite de jojoba, y sus fracciones, incluso refinados, pero sin modificar químicamente',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1516,'Gorduras e óleos animais ou vegetais, e respectivas fracções, parcial ou totalmente hidrogenados, interesterificados, reesterificados ou elaidinizados, mesmo refinados, mas não preparados de outro modo','Animal or vegetable fats and oils and their fractions, partly or wholly hydrogenated, inter-esterified, re-esterified or elaidinised, whether or not refined, but not further prepared','Grasas y aceites, animales o vegetales, y sus fracciones, parcial o totalmente hidrogenados, interesterificados, reesterificados o elaidinizados, incluso refinados, pero sin preparar de otro modo',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1517,'Margarina; misturas ou preparações alimentícias de gorduras ou de óleos animais ou vegetais ou de fracções das diferentes gorduras ou óleos do presente capítulo, exceto as gorduras e óleos alimentícios, e respectivas fracções, da posição 1516','Margarine; edible mixtures or preparations of animal or vegetable fats or oils or of fractions of different fats or oils of this chapter, other than edible fats or oils or their fractions of heading No 1516','Margarina; mezclas o preparaciones alimenticias de grasas o aceites, animales o vegetales, o de fracciones de diferentes grasas o aceites de este capítulo (excepto las grasas y aceites alimenticios y sus fracciones de la partida 1516)',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1518,'Gorduras e óleos animais ou vegetais, cozidos, oxidados, desidratados ou modificados quimicamente por qualquer outro processo','Animal/vegetable fats and oils chemically modified, inedbl mxt etc','Grasas animales/vegetales y aceites modificados químicamente',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1520,'Glicerol em bruto; águas e lixívias, glicéricas','Glycerol (glycerine), glycerol waters and lyes','Glicerol (glicerina), las aguas de glicerol y lejías',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1521,'Ceras vegetais (exceto triglicéridos), ceras de abelha ou de outros insectos e espermacete, mesmo refinados ou corados','Vegetable waxes (other than triglycerides), beeswax, other insect waxes and spermaceti, whether or not refined or coloured','Ceras vegetales (excepto los triglicéridos), cera de abejas o de otros insectos y esperma de ballena o de otros cetáceos (espermaceti) incluso refinadas o coloreadas',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1522,'Degras e resíduos do tratamentdas matérias graxas, etc.','Degras and residues from treatment greases substances, etc','Degrás y residuos del tratamiento de grasas, etc',15);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1601,'Enchidos de carne, miudezas, sangue, suas preparações alimentícias','Sausages of meat, meat offal, blood, their food preparat.','Embutidos de carne, despojos, sangre, sus prepar.aliment.',16);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1602,'Outras preparações e conservas de carne, miudezas ou sangue','Other prepared or preserved meat, meat offal or blood','Las demás preparaciones y conservas de carne, despojos o sangre',16);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1603,'Extratos e sucos, de carnes, de peixes, de crustáceos, etc.','Extracts and juices of meat,  fish or crustaceans, etc.','Extractos y jugos, de carnes, de pescados, de crustác.etc',16);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1604,'Preparações e conservas de peixes; caviar e seus sucedâneos preparados a partir de ovas de peixe','Prepared or preserved fish; caviar and caviar substitutes prepared from fish eggs','Preparaciones y conservas de pescado; caviar y sus sucedáneos preparados con huevas de pescado',16);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1605,'Crustáceos, moluscos e outros invertebrados aquáticos, preparados ou em conservas','Crustaceans, molluscs and other aquatic invertebrates, prepared or preserved','Crustáceos, moluscos y demás invertebrados acuáticos, preparados o conservados',16);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1701,'Açúcares de cana ou de beterraba e sacarose quimicamente pura, no estado sólido','Cane or beet sugar and chemically pure sucrose, in solid form','Azúcar de caña o de remolacha y sacarosa químicamente pura, en estado sólido',17);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1702,'Outros açúcares, incluídos a lactose, maltose, glicose e frutose (levulose), quimicamente puras, no estado sólido; xaropes de açúcares, sem adição de aromatizantes ou de corantes; sucedâneos do mel, mesmo misturados com mel natural; açúcares e melaços car','Other sugars, including chemically pure lactose, maltose, glucose and fructose, in solid form; sugar syrups not containing added flavouring or colouring matter; artificial honey, whether or not mixed with natural honey; caramel','Los demás azúcares, incluidas la lactosa, maltosa, glucosa y fructosa (levulosa) químicamente puras, en estado sólido; jarabe de azúcar sin adición de aromatizante ni colorante; sucedáneos de la miel, incluso mezclados con miel natural; azúcar y melaza ca',17);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1703,'Melaços resultantes da extracção ou refinação do açúcar','Molasses resulting from the extraction or refining of sugar','Melaza procedente de la extracción o del refinado del azúcar',17);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1704,'Produtos de confeitaria sem cacau (incluído o chocolate branco)','Sugar confectionery (including white chocolate), not containing cocoa','Artículos de confitería sin cacao (incluido el chocolate blanco)',17);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1801,'Cacau inteiro ou partido, em bruto ou torrado','Cocoa (whole or broken), raw or roasted','Cacao entero o partido, crudo o tostado',18);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1802,'Cascas, peliculas e outros desperdícios de cacau','Cocoa shells,  husks,  skins and other cocoa waste','Cáscaras,  películas y demás desechos de cacao',18);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1803,'Pasta de cacau, mesmo desengordurada','Cocoa paste, whether or not defatted','Pasta de cacao, incluso desgrasada',18);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1804,'Manteiga, gordura e óleo, de cacau','Butter, fat and oil, from cocoa','Manteca, grasa y aceite, de cacao',18);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1805,'Cacau em pó, sem adição de açúcar ou outros edulcorantes','Cocoa (powder), without added sugar or other sweeteners','Cacao en polvo, sin adición de azúcar ni otro edulcorante',18);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1806,'Chocolate e outras preparações alimentícias contendo cacau','Chocolate and other food preparations containing cocoa','Chocolate y demás preparaciones alimenticias que contengan cacao',18);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1901,'Extractos de malte; preparações alimentícias de farinhas, grumos, sêmolas, amidos, féculas ou extractos de malte, não contendo cacau ou contendo-o numa proporção inferior a 40 %, em peso, não especificadas nem compreendidas noutras posições; preparações a','Malt extract; food preparations of flour, groats, meal, starch or malt extract, not containing cocoa or containing less than 40 % by weight of cocoa calculated on a totally defatted basis, not elsewhere specified or included; food preparations of goods of','Extracto de malta; preparaciones alimenticias de harina, grañones, sémola, almidón, fécula o extracto de malta, que no contengan cacao o con un contenido de cacao inferior al 40 % en peso, calculado sobre una basa totalmente desgrasada, no expresadas ni c',19);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1902,'Massas alimentícias, mesmo cozidas ou recheadas (de carne ou de outras substâncias) ou preparadas de outro modo, tais como esparguete, macarrão, aletria, lasanha, nhoque, raviole e canelone; cuscuz, mesmo preparado','Pasta, whether or not cooked or stuffed (with meat or other substances) or otherwise prepared, such as spaghetti, macaroni, noodles, lasagne, gnocchi, ravioli, cannelloni; couscous, whether or not prepared','Pastas alimenticias, incluso cocidas o rellenas (de carne u otras sustancias) o preparadas de otra forma, tales como espaguetis, fideos, macarrones, tallarines, lasañas, ñoquis, ravioles, canelones; cuscús, incluso preparado',19);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1903,'Tapioca, seus sucedâneos, de féculas, em flocos, grumos, etc','Tapioca and substitutes therefor, from starch, flakes, etc','Tapioca, sus sucedáneos, c/féculas, en copos, grumos, etc',19);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1904,'Produtos à base de cereais, obtidos por expansão ou por torrefacção [por exemplo: flocos de milho (corn flakes)]; cereais (exceto milho) em grãos ou sob a forma de flocos ou de outros grãos trabalhados (com excepção da farinha, do grumo e da sêmola), pré','Prepared foods obtained by the swelling or roasting of cereals or cereal products (for example, corn flakes); cereals (other than maize (corn)) in grain form or in the form of flakes or other worked grains (except flour, groats and meal), pre-cooked or ot','Productos a base de cereales obtenidos por inflado o tostado (por ejemplo: hojuelas o copos de maíz); cereales (excepto el maíz) en grano o en forma de copos u otros granos trabajados (excepto harina, grañones y sémola), precocidos o preparados de otro mo',19);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (1905,'Produtos de padaria, pastelaria ou da indústria de bolachas e biscoitos, mesmo adicionados de cacau; hóstias, cápsulas vazias para medicamentos, obreias, pastas secas de farinha, amido ou fécula em folhas e produtos semelhantes','Bread, pastry, cakes, biscuits and other bakers'' wares, whether or not containing cocoa; communion wafers, empty cachets of a kind suitable for pharmaceutical use, sealing wafers, rice paper and similar products','Productos de panadería, pastelería o galletería, incluso con adición de cacao; hostias, sellos vacíos de los tipos utilizados para medicamentos, obleas para sellar, pastas secas de harina, almidón o fécula, en hojas, y productos similares',19);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2001,'Produtos hortícolas, frutas e outras partes comestíveis de plantas, preparados ou conservados em vinagre ou em ácido acético','Vegetables, fruit, nuts and other edible parts of plants, prepared or preserved by vinegar or acetic acid','Hortalizas, incluso «silvestres», frutas u otros frutos y demás partes comestibles de plantas, preparados o conservados en vinagre o en ácido acético',20);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2002,'Tomates preparados ou conservados, exceto em vinagre ou em ácido acético','Tomatoes prepared or preserved otherwise than by vinegar or acetic acid','Tomates preparados o conservados (excepto en vinagre o en ácido acético)',20);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2003,'Cogumelos e trufas, preparados ou conservados, exceto em vinagre ou em ácido acético','Mushrooms and truffles, prepared or preserved otherwise than by vinegar or acetic acid','Hongos y trufas, preparados o conservadoos (excepto en vinagre o en ácido acético)',20);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2004,'Outros produtos hortícolas preparados ou conservados, exceto em vinagre ou em ácido acético, congelados, com excepção dos produtos da posição 2006','Other vegetables prepared or preserved otherwise than by vinegar or acetic acid, frozen, other than products of heading 2006','Las demás hortalizas, incluso «silvestres», preparadas o conservadas (excepto en vinagre o en ácido acético), congeladas (excepto los productos de la partida 2006)',20);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2005,'Outros produtos hortícolas preparados ou conservados, exceto em vinagre ou em ácido acético, não congelados, com excepção dos produtos da posição 2006','Other vegetables prepared or preserved otherwise than by vinegar or acetic acid, not frozen, other than products of heading No 2006','Las demás hortalizas, incluso «silvestres», preparadas o conservadas (excepto en vinagre o en ácido acético), sin congelar (excepto los productos de la partida 2006)',20);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2006,'prods.hortícolas, frutas e cascas, etc.conservs.em açúcar','vegetables fruit, fruit-pee, etc.preserved by sugar','las dem.hortalizas, frutas y cortezas, etc, confit.c/azúc.',20);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2007,'Doces, geleias, marmelades, purés e pastas de frutas, obtidos por cozimento, com ou sem adição de açúcar ou de outros edulcorantes','Jams, fruit jellies, marmalades, fruit or nut purée and fruit or nut pastes, obtained by cooking, whether or not containing added sugar or other sweetening matter','Confituras, jaleas y mermeladas, purés y pastas de frutas u otros frutos, obtenidos por cocción, incluso con adición de azúcar u otro edulcorante',20);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2008,'Frutas e outras partes comestíveis de plantas, preparadas ou conservadas de outro modo, com ou sem adição de açúcar ou de outros edulcorantes ou de álcool, não especificadas nem compreendidas noutras posições','Fruit, nuts and other edible parts of plants, otherwise prepared or preserved, whether or not containing added sugar or other sweetening matter or spirit, not elsewhere specified or included','Frutas u otros frutos y demás partes comestibles de plantas, preparados o conservados de otro modo, incluso con adición de azúcar u otro edulcorante o alcohol, no expresados ni comprendidos en otra parte',20);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2009,'Sumos de frutas (incluídos os mostos de uvas) ou de produtos hortícolas, não fermentados, sem adição de álcool, com ou sem adição de açúcar ou de outros edulcorantes','Fruit juices (including grape must) and vegetable juices, unfermented and not containing added spirit, whether or not containing added sugar or other sweetening matter','Jugos de frutas u otros frutos, incluido el mosto de uva, o de hortalizas, incluso «silvestres», sin fermentar y sin adición de alcohol, incluso con adición de azúcar u otro edulcorante',20);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2101,'Extractos, essências e concentrados de café, chá ou de mate e preparações à base destes produtos ou à base de café, chá ou de mate; chicória torrada e outros sucedâneos torrados do café e respectivos extractos, essências e concentrados','Extracts, essences and concentrates, of coffee, tea or maté and preparations with a basis of these products or with a basis of coffee, tea or maté; roasted chicory and other roasted coffee substitutes, and extracts, essences and concentrates thereof','Extractos, esencias y concentrados de café, té o yerba mate y preparaciones a base de estos productos o a base de café, té o yerba mate; achicoria tostada y demás sucedáneos del café tostados y sus extractos, esencias y concentrados',21);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2102,'Leveduras (vivas ou mortas); outros microrganismos monocelulares mortos (exceto as vacinas da posição 3002); pós para levedar, preparados','Yeasts (active or inactive); other single-cell micro-organisms, dead (but not including vaccines of heading No 3002); prepared baking powders','Levaduras (vivas o muertas); los demás microorganismos monocelulares muertos (excepto las vacunas de la partida 3002); polvos de levantar preparados',21);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2103,'Preparações para molhos e molhos preparados; condimentos e temperos compostos; farinha de mostarda e mostarda preparada','Sauces and preparations therefor; mixed condiments and mixed seasonings; mustard flour and meal and prepared mustard','Preparaciones para salsas y salsas preparadas; condimentos y sazonadores, compuestos; harina de mostaza y mostaza preparada',21);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2104,'Preparações para caldos e sopas; caldos e sopas preparados; preparações alimentícias compostas homogeneizadas','Soups and broths and preparations therefor; homogenised composite food preparations','Preparaciones para sopas, potajes o caldos; sopas, potajes o caldos, preparados; preparaciones alimenticias compuestas homogeneizadas',21);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2105,'Sorvetes, mesmo contendo cacau','Ice cream and other edible ice, with cocoa or not','Helados y productos similares, a base de cacao o no',21);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2106,'Preparações alimentícias não especificadas nem compreendidas noutras posições','Food preparations not elsewhere specified or included','Preparaciones alimenticias no expresadas ni comprendidas en otra parte',21);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2201,'Águas, incluídas as águas minerais, naturais ou artificiais, e as águas gaseificadas, não adicionadas de açúcar ou de outros edulcorantes nem aromatizadas; gelo e neve','Waters, including natural or artificial mineral waters and aerated waters, not containing added sugar or other sweetening matter nor flavoured; ice and snow','Agua, incluidas el agua mineral natural o artificial y la gaseada, sin adición de azúcar u otro edulcorante ni aromatizada; hielo y nieve',22);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2202,'Águas, incluídas as águas minerais e as águas gaseificadas, adicionadas de açúcar ou de outros edulcorantes ou aromatizadas e outras bebidas não alcoólicas, exceto sumos de frutas ou de produtos hortícolas, da posição 2009','Waters, including mineral waters and aerated waters, containing added sugar or other sweetening matter or flavoured, and other non-alcoholic beverages, not including fruit or vegetable juices of heading No 2009','Agua, incluidas el agua mineral y la gaseada, con adición de azúcar u otro edulcorante o aromatizada, y demás bebidas no alcohólicas (excepto los jugos de frutas u otros frutos o de hortalizas de la partida 2009)',22);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2203,'Cervejas de malte','Beer made from malt','Cervezas de malta',22);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2204,'Vinhos de uvas frescas, incluídos os vinhos enriquecidos com álcool; mostos de uvas, excluídos os da posição 2009','Wine of fresh grapes, including fortified wines; grape must other than that of heading No 2009','Vino de uvas frescas, incluso encabezado; mosto de uva (excepto el de la partida 2009)',22);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2205,'Vermutes e outros vinhos de uvas frescas aromatizados por plantas ou substâncias aromáticas','Vermouth and other wine of fresh grapes flavoured with plants or aromatic substances','Vermut y demás vinos de uvas frescas preparados con plantas o sustancias aromáticas',22);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2206,'Sidra e outras bebidas fermentadas e misturas de bebidas fermentadas','Fermented beverages (cider, berry, mead, etc)','Bebidas fermentadas (sidra, baya, aguamiel, etc)',22);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2207,'Álcool etílico não desnaturado, com um teor alcoólico em volume igual ou superior a 80 % vol; álcool etílico e aguardentes, desnaturados, com qualquer teor alcoólico','Undenatured ethyl alcohol of an alcoholic strength by volume of 80 % vol or higher; ethyl alcohol and other spirits, denatured, of any strength','Alcohol etílico sin desnaturalizar con grado alcohólico volumétrico superior o igual al 80 % vol; alcohol etílico y aguardiente desnaturalizados, de cualquier graduación',22);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2208,'Álcool etílico não desnaturado, com um teor alcoólico em volume inferior a 80 % vol; aguardentes, licores e outras bebidas espirituosas','Undenatured ethyl alcohol of an alcoholic strength by volume of less than 80 % vol; spirits, liqueurs and other spirituous beverages','Alcohol etílico sin desnaturalizar con grado alcohólico volumétrico inferior a 80 % vol; aguardientes, licores y demás bebidas espirituosas',22);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2209,'Vinagres e sucedan.obtidos acid.acético, p/uso alimentar','Vinegar and subst.forvineg.obt.acetic acid, forhuman cons.','Vinagre y sucedáneos obt.a partir del ác.acét.p/uso al.',22);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2301,'Farinhas, pó e pellets, de carnes, miudezas, peixes ou crustáceos, moluscos ou outros invertebrados aquáticos, impróprios para a alimentação humana; torresmos','Flours, meals and pellets, of meat or meat offal, of fish or of crustaceans, molluscs or other aquatic invertebrates, unfit for human consumption; greaves','Harina, polvo y pellets, de carne, despojos, pescado o de crustáceos, moluscos o invertebrados acuáticos, impropios para la alimentación humana; chicharrones',23);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2302,'Sêmeas, farelos e outros resíduos, mesmo em pellets, da peneiração, moagem ou de outros tratamentos de cereais ou de leguminosas','Bran, sharps and other residues, whether or not in the form of pellets, derived from the sifting, milling or other working of cereals or of leguminous plants','Salvados, moyuelos y demás residuos del cernido, de la molienda o de otros tratamientos de los cereales o de las leguminosas, incluso en pellets',23);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2303,'Resíduos da fabricação do amido e resíduos semelhantes, polpas de beterraba, bagaço de cana-de-açúcar e outros desperdícios da indústria do açúcar, borras e desperdícios da indústria da cerveja e das destilarias, mesmo em pellets','Residues of starch manufacture and similar residues, beet-pulp, bagasse and other waste of sugar manufacture, brewing or distilling dregs and waste, whether or not in the form of pellets','Residuos de la industria del almidón y residuos similares, pulpa de remolacha, bagazo de caña de azúcar y demás desperdicios de la industria azucarera, heces y desperdicios de cervecería o de destilería, incluso en pellets',23);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2304,'Tortas e outros resíduos sólidos da extração do óleo de soja','Soybean oilcake and other solid residue, wh/not ground','Torta de aceite de soja y de residuos sólidos',23);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2305,'Tortas e outros resíduos sólidos, do amendoim','Oil-cake and other solid residues, of peanut','Tortas y demás residuos sólidos, del aceite de cacahuete',23);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2306,'Bagaços e outros resíduos sólidos, mesmo triturados ou em pellets, da extracção de gorduras ou óleos vegetais, exceto das posições 2304 e 2305','Oil-cake and other solid residues, whether or not ground or in the form of pellets, resulting from the extraction of vegetable fats or oils, other than those of heading 2304 or 2305','Tortas y demás residuos sólidos de la extracción de grasas o aceites vegetales, incluso molidos o en pellets (excepto los de las partidas 2304 ó 2305)',23);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2307,'Borras de vinho e tártaro em bruto','Wine lees and argol','Heces de vino y tártaro bruto',23);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2308,'Matérias vegetais e desperdícios vegetais, resíduos e subprodutos vegetais, mesmo em pellets, dos tipos utilizados na alimentação de animais','Vegetable materials and vegetable waste, vegetable residues and by-products, whether or not in the form of pellets, of a kind used in animal feeding','Materias vegetales y desperdicios vegetales, residuos y subproductos, de los tipos utilizados en la alimentación animal',23);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2309,'Preparações dos tipos utilizados na alimentação de animais','Preparations of a kind used in animal feeding','Preparaciones del tipo de las utilizadas para la alimentación de los animales',23);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2401,'Tabaco não manufacturado; desperdícios de tabaco','Unmanufactured tobacco; tobacco refuse','Tabaco en rama o sin elaborar; desperdicios de tabaco',24);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2402,'Charutos, cigarrilhas e cigarros, de tabaco ou dos seus sucedâneos','Cigars, cheroots, cigarillos and cigarettes, of tobacco or of tobacco substitutes','Cigarros (puros), incluso despuntados, cigarritos (puritos) y cigarrillos, de tabaco o de sucedáneos del tabaco',24);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2403,'Outros produtos de tabaco e seus sucedâneos, manufacturados; tabaco « homogeneizado » ou « reconstituído »; extractos e molhos de tabaco','Other manufactured tobacco and manufactured tobacco substitutes; ''homogenised'' or ''reconstituted'' tobacco; tobacco extracts and essences','Los demás tabacos y sucedáneos del tabaco, elaborados; tabaco «homogeneizado» o «reconstituido»; extractos y jugos de tabaco',24);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2501,'Sal (incluídos o sal de mesa e o sal desnaturado) e cloreto de sódio puro, mesmo em solução aquosa ou adicionados de agentes antiaglomerantes','Salt, including table and dentrd, pure sodium chloride','Sal, que incluye una mesa, sodio puro',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2502,'Piritas de ferro não ustuladas','Unroasted iron pyrites','Piritas de hierro sin tostar',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2503,'Enxofre de qualquer espécie, exceto sublimado, precipitado ou coloidal','Sulfur of all kinds','Azufre de todo tipo',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2504,'Grafite natural','Natural graphite','Grafito natural',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2505,'Areias naturais de qualquer espécie, mesmo coradas, exceto areias metalíferas do Capítulo 26','Natural sands of all kinds, whether or not coloured, other than metal-bearing sands of Chapter 26','Arenas naturales de cualquier clase, incluso coloreadas (excepto las arenas metalíferas del capítulo 26)',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2506,'Quartzo (exceto areias naturais); quartzites, mesmo desbastadas ou simplesmente cortadas à serra ou por outro meio, em blocos ou placas de forma quadrada ou rectangular','Quartz (other than natural sands); quartzite, whether or not roughly trimmed or merely cut, by sawing or otherwise, into blocks or slabs of a rectangular (including square) shape','Cuarzo (excepto las arenas naturales); cuarcita, incluso desbastada o simplemente troceada, por aserrado o de otro modo, en bloques o en placas cuadradas o rectangulares',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2507,'Caulim e outras argilas caulínicas, mesmo calcinadas','Kaolin and other kaolinic clays, including calcined','Caolín y otras arcillas de caolín, incluyendo calcinado',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2508,'Outras argilas (exceto argilas expandidas da posição 6806), andaluzite, cianite, silimanite, mesmo calcinadas; mulita; barro cozido em pó (terra de chamotte) e terra de dinas','Other clays (not including expanded clays of heading No 6806), andalusite, kyanite and sillimanite, whether or not calcined; mullite; chamotte or dinas earths','Las demás arcillas (excepto las arcillas dilatadas de la partida 6806), andalucita, cianita y silimanita, incluso calcinadas; mullita; tierras de chamota o de dinas',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2509,'Cre','Chalk','Creta',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2510,'Fosfatos de cálcio naturais, fosfatos aluminocálcicos naturais e cré fosfatado','Natural calcium phosphates, natural aluminium calcium phosphates and phosphatic chalk','Fosfatos de calcio naturales, fosfatos aluminocálcicos naturales y cretas fosfatadas',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2511,'Sulfato de bário natural (baritina); carbonato de bário natural (witherite), mesmo calcinado, exceto o óxido de bário da posição 2816','Natural barium sulphate (barytes); natural barium carbonate (witherite), whether or not calcined, other than barium oxide of heading No 2816','Sulfato de bario natural (baritina); carbonato de bario natural (witherita), incluso calcinado (excepto el óxido de bario de la partida 2816)',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2512,'Farinhas silíciosas fósseis/outs.terras silíciosas, d<=1','Siliceous fossil meals/other siliceous earths, d<=1','Harinas silíceas fósiles/demás tierras silíceas, d<=1',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2513,'Pedra-pomes; esmeril; corindo natural, granada natural e outros abrasivos naturais, mesmo tratados termicamente','Pumice stone; emery; natural corundum, natural garnet and other natural abrasives, whether or not heat-treated','Piedra pómez; esmeril; corindón natural, granate natural y demás abrasivos naturales, incluso tratados térmicamente',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2514,'Ardósia, incusive desbastada ou cortada em blocos ou placas','Slate, whether/n/roughly trimmed/merely cut, blocks slabs','Pizarra, incl.desbastada o troceada en bloques o placas',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2515,'Mármores, travertinos, granitos belgas e outras pedras calcárias de cantaria ou de construção, de densidade aparente igual ou superior a 2,5, e alabastro, mesmo desbastados ou simplesmente cortados à serra ou por outro meio, em blocos ou placas de forma q','Marble, travertine, ecaussine and other calcareous monumental or building stone of an apparent specific gravity of 2,5 or more, and alabaster, whether or not roughly trimmed or merely cut, by sawing or otherwise, into blocks or slabs of a rectangular (inc','Mármol, travertinos, ecaussines y demás piedras calizas de talla o de construcción de densidad aparente superior o igual a 2,5 y alabastro, incluso desbastados o simplemente troceados, por aserrado o de otro modo, en bloques o en placas cuadradas o rectan',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2516,'Granito, pórfiro, basalto, arenito e outras pedras de cantaria ou de construção, mesmo desbastados ou simplesmente cortados à serra ou por outro meio, em blocos ou placas de forma quadrada ou rectangular','Granite, porphyry, basalt, sandstone and other monumental or building stone, whether or not roughly trimmed or merely cut, by sawing or otherwise, into blocks or slabs of a rectangular (including square) shape','Granito, pórfido, basalto, arenisca y demás piedras de talla o de construcción, incluso desbastados o simplemente troceados, por aserrado o de otro modo, en bloques o en placas cuadradas o rectangulares',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2517,'Calhaus, cascalho, pedras britadas, dos tipos geralmente usados em betão (concreto) ou para empedramento de estradas, de vias férreas ou outros balastros, seixos rolados e sílex, mesmo tratados termicamente; macadame de escórias de altos fornos, de outras','Pebbles, gravel, broken or crushed stone, of a kind commonly used for concrete aggregates, for road metalling or for railway or other ballast, shingle and flint, whether or not heat-treated; macadam of slag, dross or similar industrial waste, whether or n','Cantos, grava, piedras machacadas, de los tipos generalmente utilizados para hacer hormigón, o para firmes de carreteras, vías férreas u otros balastos, guijarros y pedernal, incluso tratados térmicamente; macadán de escorias o de desechos industriales si',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2518,'Dolomite, mesmo sinterizada ou calcinada, incluindo a dolomite desbastada ou simplesmente cortada à serra ou por outro meio, em blocos ou placas de forma quadrada ou rectangular; aglomerado de dolomite','Dolomite, whether or not calcined or sintered, including dolomite roughly trimmed or merely cut, by sawing or otherwise, into blocks or slabs of a rectangular (including square) shape; dolomite ramming mix','Dolomita, incluso sinterizada o calcinada, incluida la dolomita desbastada o simplemente troceada, por aserrado o de otro modo, en bloques o en placas cuadradas o rectangulares; aglomerado de dolomita',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2519,'Carbonato de magnésio natural (magnesite); magnésia electrofundida; magnésia calcinada a fundo (sinterizada), mesmo contendo pequenas quantidades de outros óxidos adicionados antes da sinterização; outro óxido de magnésio, mesmo puro','Natural magnesium carbonate (magnesite); fused magnesia; dead-burned (sintered) magnesia, whether or not containing small quantities of other oxides added before sintering; other magnesium oxide, whether or not pure','Carbonato de magnesio natural (magnesita); magnesia electrofundida; magnesia calcinada a muerte (sinterizada), incluso con pequeñas cantidades de otros óxidos añadidos antes de la sinterización; otro óxido de magnesio, incluso puro',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2520,'Gipsite; anidrite; gesso, mesmo corado ou adicionado de pequenas quantidades de aceleradores ou de retardadores','Gypsum; anhydrite; plasters (consisting of calcined gypsum or calcium sulphate) whether or not coloured, with or without small quantities of accelerators or retarders','Yeso natural; anhidrita; yeso fraguable (consistente en yeso natural calcinado o en sulfato de calcio), incluso coloreado o con pequeñas cantidades de aceleradores o retardadores',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2521,'Castinas, pedras calcárias p/fabr.de cal ou de cimento','Limestone flux, calcar.stone formanufac.of lime or cement','Castinas, piedras p/la fabricación de cal o de cemento',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2522,'Cal viva, cal apagada e cal hidráulica, com exclusão do óxido e do hidróxido de cálcio da posição 2825','Quicklime, slaked lime and hydraulic lime, other than calcium oxide and hydroxide of heading 2825','Cal viva, cal apagada y cal hidráulica (excepto el óxido y el hidróxido de calcio de la partida 2825)',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2523,'Cimentos hidráulicos (incluídos os cimentos não pulverizados, denominados clinkers), mesmo corados','Portland cement, aluminous cement, slag cement, supersulphate cement and similar hydraulic cements, whether or not coloured or in the form of clinkers','Cementos hidráulicos, comprendidos los cementos sin pulverizar o clinker, incluso coloreados',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2524,'Amianto','Asbestos','Amianto',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2525,'Mica, incluída a mica clivada em lamelas irregulares (splittings); desperdícios de mica','Mica, including splittings; mica waste','Mica, incluida la exfoliada en laminillas irregulares («splittings»); desperdicios de mica',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2526,'Esteatite natural, mesmo desbastada ou simplesmente cortada à serra ou por outro meio, em blocos ou placas de forma quadrada ou rectangular; talco','Natural steatite, whether or not roughly trimmed or merely cut, by sawing or otherwise, into blocks or slabs of a rectangular (including square) shape; talc','Esteatita natural, incluso desbastada o simplemente troceada, por aserrado o de otro modo, en bloques o en placas cuadradas o rectangulares; talco',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2527,'Criolita natural e quiolita natural','Natural criolite and natural quiolite','Criolita natural y quiolita natural',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2528,'Boratos naturais e seus concentrados (calcinados ou não), exceto boratos extraídos de salmouras naturais; ácido bórico natural com um teor máximo de 85 % de H3BO3, em produto seco','Natural borates and concentrates thereof (whether or not calcined), but not including borates separated from natural brine; natural boric acid containing not more than 85 % of H3BO3 calculated on the dry weight','Boratos naturales y sus concentrados, incluso calcinados (excepto los boratos extraídos de las salmueras naturales); ácido bórico natural con un contenido de H3BO3 inferior o igual al 85 %, valorado sobre producto seco',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2529,'Feldspato; leucite; nefelina e nefelina-sienite; espatoflúor','Felspar; leucite; nepheline and nepheline syenite; fluorspar','Feldespato; leucita; nefelina y nefelina sienita; espato flúor',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2530,'Matérias minerais não especificadas nem compreendidas em outras posições','Mineral substances not elsewhere specified or included','Materias minerales no expresadas ni comprendidas en otra parte',25);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2601,'Minérios de ferro e seus concentrados, incluídas as pirites de ferro ustuladas (cinzas de pirites)','Iron ores and concentrates, including roasted iron pyrites','Minerales de hierro y sus concentrados, incluidas las piritas de hierro tostadas (cenizas de piritas)',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2602,'Minérios de manganês e seus concentrados, incluídos os minérios de manganês ferruginosos e seus concentrados, de teor de manganês de => 20%, em peso, sobre o produto seco','Manganese ores & concentrates inc mangnfrs iron ores','Minerales de manganeso y sus concentrados inc mangnfrs minerales de hierro',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2603,'Minérios de cobre e seus concentrados','Copper ores and concentrates','Minerales de cobre y sus concentrados',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2604,'Minérios de niquel e seus concentrados','Nickel ores and concentrates','Minerales de níquel y sus concentrados',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2605,'Minérios de cobalto e seus concentrados','cobalt ores and concentrates','minerales de cobalto y sus concentrados',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2606,'Minérios de alumínio e seus concentrados','Aluminum ores and concentrates','Minerales de aluminio y concentrados',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2607,'Minérios de chumbo e seus concentrados','lead ores and concentrates','minerales de plomo y sus concentrados',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2608,'Minérios de zinco e seus concentrados','Zinc ores and concentrates','Minerales y concentrados de zinc',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2609,'Minérios de estanho e seus concentrados','Tin ores and concentrates','Minerales de estaño y sus concentrados',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2610,'Minérios de cromo e seus concentrados','Chromium ores and concentrates','Minerales de cromo y sus concentrados',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2611,'Minérios de tungstênio e seus concentrados','Tungsten ores and concentrates','Minerales de tungsteno y sus concentrados',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2612,'Minérios de urânio ou de tório, e seus concentrados','Uranium or thorium ores and concentrates','Minerales de uranio o torio, y sus concentrados',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2613,'Minérios de molibdénio e seus concentrados','Molybdenum ores and concentrates','Minerales de molibdeno y sus concentrados',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2614,'Minérios de titânio e seus concentrados','Titanium ores and concentrates','Minerales de titanio y sus concentrados',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2615,'Minérios de nióbio, tântalo, vanádio ou de zircónio, e seus concentrados','Niobium, tantalum, vanadium or zirconium ores and concentrates','Minerales de niobio, tantalio, vanadio o circonio, y sus concentrados',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2616,'Minérios de metais preciosos e seus concentrados','Precious metal ores and concentrates','Minerales de los metales preciosos y sus concentrados',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2617,'Outros minérios e seus concentrados','Other ores and concentrates','Los demás minerales y sus concentrados',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2618,'Escória de altos-fornos granul.da fabr.do ferro e aço','Granulated slag from the manufacture of iron and steel','Escorias granuladas de la siderurgia',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2619,'Outras escórias e desperdícios, da fabr.do ferro e aço','Other slag and waste from the manufac.of iron and steel','Demás escorias y desperdicios, de la siderurgia',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2620,'Cinzas e resíduos (exceto provenientes da fabricação  do ferro fundido, ferro ou aço) contendo arsénio, metais ou compostos de metais','Ash and residues (other than from the manufacture of iron or steel), containing arsenic, metals or metal compounds','Cenizas y residuos (excepto los de la siderurgia), que contengan arsénico, metales o compuestos metálicas',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2621,'Outras escórias e cinzas, incluídas as cinzas de algas; cinzas e resíduos provenientes da incineração de resíduos municipais','Other slag and ash, including seaweed ash (kelp); ash and residues from the incineration of municipal waste','Las demás escorias y cenizas, incluidas las cenizas de algas; cenizas y residuos procedentes de la incineración de desechas y desperdicios municipales',26);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2701,'Hulhas; briquetes, bolas e combustíveis sólidos semelhantes, obtidos a partir da hulha','Coal; briquettes, ovoids and similar solid fuels manufactured from coal','Hullas; briquetas, ovoides y combustibles sólidos similares, obtenidos de la hulla',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2702,'Linhites, mesmo aglomeradas, exceto azeviche','Lignite, whether or not agglomerated, excluding jet','Lignitos, incluso aglomerados (excepto el azabache)',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2703,'Turfa, incl.aglomerada e a turfa para cama de animais','Peat, (including peat litter)whether or not agglomerated','Turba, incl.aglomerada y la turba para cama de animales',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2704,'Coques e semicoques de hulha, de linhita ou de turfa, mesmo aglomerados; carvão de retorta','Coke etc of coal, lignite or peat, retort carbon','Coques, etc de la hulla, lignito o turba, carbón de retorta',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2705,'Gás de hulha, água, etc.exceto de petróleo/hidrocarb.gasosos','Coal gas, water, etc.exc.petroleum/gaseous hydrocarbons','Gas de hulla, agua, etc, exc.el gas de petr/hidrocarb.gas.',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2706,'Alcatrões de hulha, de linhita ou de turfa, etc.','Tar distilled from coal,  from lignite or from peat, etc','Alquitranes de hulla,  de lignito o de turba,  etc.',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2707,'Óleos e outros produtos provenientes da destilação dos alcatrões de hulha a alta temperatura; produtos análogos em que os constituintes aromáticos predominem em peso relativamente aos constituintes não aromáticos','Oils and other products of the distillation of high temperature coal tar; similar products in which the weight of the aromatic constituents exceeds that of the non-aromatic constituents','Aceites y demás productos de la destilación de los alquitranes de hulla de alta temperatura; productos análogos en los que los constituyentes aromáticos predominen en peso sobre los no aromáticos',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2708,'Breu e coque de breu obtidos a partir do alcatrão de hulha ou de outros alcatrões minerais','Pitch and pitch coke, obtained from coal tar or from other mineral tars','Brea y coque de brea de alquitrán de hulla o de otros alquitranes minerales',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2709,'Óleos brutos de petróleo ou de minerais betuminosos','Crude oil from petroleum and bituminous minerals','Petróleo crudo de petróleo o minerales bituminosos',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2710,'Óleos de petróleo ou de minerais betuminosos, exceto óleos brutos; preparações não especificadas nem compreendidas noutras posições, contendo, em peso, 70 % ou mais de óleos de petróleo ou de minerais betuminosos, os quais devem constituir o seu elemento','Petroleum oils and oils obtained from bituminous minerals, other than crude; preparations not elsewhere specified or included, containing by weight 70 % or more of petroleum oils or of oils obtained from bituminous minerals, these oils being the basic con','Aceites de petróleo o de mineral bituminoso, excepto los aceites crudos; preparaciones no expresadas ni comprendidas en otra parte, con un contenido de aceites de petróleo o de mineral bituminoso superior o igual al 70 % en peso, en las que estos aceites ',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2711,'Gás de petróleo e outros hidrocarbonetos gasosos','Petroleum gases and other gaseous hydrocarbons','Gas de petróleo y demás hidrocarburos gaseosos',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2712,'Vaselina; parafina, cera de petróleo microcristalina, slack wax, ozocerite, cera de linhite, cera de turfa, outras ceras minerais e produtos semelhantes obtidos por síntese ou por outros processos, mesmo corados','Petroleum jelly; paraffin wax, microcrystalline petroleum wax, slack wax, ozokerite, lignite wax, peat wax, other mineral waxes, and similar products obtained by synthesis or by other processes, whether or not coloured','Vaselina; parafina, cera de petróleo microcristalina, slack wax, ozoquerita, cera de lignito, cera de turba, demás ceras minerales y productos similares obtenidos por síntesis o por otros procedimientos, incluso coloreados',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2713,'Coque de petróleo, betume de petróleo e outros resíduos dos óleos de petróleo ou de minerais betuminosos','Petroleum coke, petroleum bitumen and other residues of petroleum oils or of oils obtained from bituminous minerals','Coque de petróleo, betún de petróleo y demás residuos de los aceites de petróleo o de mineral bituminoso',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2714,'Betumes e asfaltos, naturais; xistos e areias betuminosos; asfaltites e rochas asfálticas','Bitumen and asphalt, natural; bituminous or oil shale and tar sands; asphaltites and asphaltic rocks','Betunes y asfaltos naturales; pizarras y arenas bituminosas; asfaltitas y rocas asfálticas',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2715,'Misturas betuminosas à base de asfalto, de betumes, etc.','Bituminous mixt.based on natural asphalt, of bitumen, etc','Mezclas bituminosas a base de asfalto,  de betunes,  etc.',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2716,'Energia elétrica','Electrical energy','Energía eléctrica',27);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2801,'Flúor, cloro, bromo e iodo','Fluorine, chlorine, bromine and iodine','Flúor, cloro, bromo y yodo',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2802,'Enxofre sublimado ou precipitado e enxofre coloidal','Sulphur, sublimed or precipitated and  colloidal sulphur','Azufre sublimado o precipitado y azufre coloidal',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2803,'Carbono (negros-de-carbono e outras formas não compreendidas em outras posições)','Carbon,(including carbon black)','Carbono, (incluyendo el negro de carbón)',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2804,'Hidrogénio, gases raros e outros elementos não metálicos','Hydrogen, rare gases and other non-metals','Hidrógeno, gases nobles y demás elementos no metálicos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2805,'Metais alcalinos ou alcalino-terrosos; metais de terras raras, escândio e ítrio, mesmo misturados ou ligados entre si; mercúrio','Alkali or alkaline-earth metals; rare-earth metals, scandium and yttrium, whether or not intermixed or interalloyed; mercury','Metales alcalinos o alcalinotérreos; metales de las tierras raras, escandio e itrio, incluso mezclados o aleados entre sí; mercurio',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2806,'Cloreto de hidrogénio (ácido clorídrico); ácido clorossulfúrico','Hydrogen chloride (hydrochloric acid); chlorosulphuric acid','Cloruro de hidrógeno (ácido clorhídrico); ácido clorosulfúrico',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2807,'Ácido sulfúrico e ácido sulfúrico fumante (oleum)','Sulfuric acid, oleum','Ácido sulfúrico, óleum',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2808,'Ácido nítrico; ácidos sulfonítricos','Nitric acid, sulfonitric acids','Ácido nítrico, ácidos sulfonítricos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2809,'Pentóxido de difosfóro; ácido fosfórico; ácidos polifosfóricos, de constituição química definida ou não','Diphosphorus pentaoxide; phosphoric acid; polyphosphoric acids, whether or not chemically defined','Pentaóxido de difósforo; ácido fosfórico; ácidos polifosfóricos, aunque no sean de constitución química definida',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2810,'Óxidos de boro; ácidos bóricos','Oxides of boron, boric acids','Óxidos de boro, ácidos bóricos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2811,'Outros ácidos inorgânicos e outros compostos oxigenados inorgânicos dos elementos não metálicos','Other inorganic acids and other inorganic oxygen compounds of non-metals','Los demás ácidos inorgánicos y los demás compuestos oxigenados inorgánicos de los elementos no metálicos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2812,'Halogenetos e oxialogenetos dos elementos não metálicos','Halides and halide oxides of non-metals','Halogenuros y oxihalogenuros de los elementos no metálicos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2813,'Sulfuretos dos elementos não metálicos; trissulfureto de fósforo comercial','Sulphides of non-metals; commercial phosphorus trisulphide','Sulfuros de los elementos no metálicos; trisulfuro de fósforo comercial',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2814,'Amoníaco anidro ou em solução aquosa (amónia)','Ammonia, anhydrous or in aqueous solution','Amoníaco anhidro o en disolución acuosa',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2815,'Hidróxido de sódio (soda cáustica); hidróxido de potássio (potassa cáustica); peróxidos de sódio ou de potássio','Sodium hydroxide (caustic soda); potassium hydroxide (caustic potash); peroxides of sodium or potassium','Hidróxido de sodio (sosa o soda cáustica); hidróxido de potasio (potasa cáustica); peróxidos de sodio o de potasio',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2816,'Hidróxido e peróxido de magnésio; óxidos, hidróxidos e peróxidos, de estrôncio ou de bário','Hydroxide and peroxide of magnesium; oxides, hydroxides and peroxides, of strontium or barium','Hidróxido y peróxido de magnesio; óxidos, hidróxidos y peróxidos, de estroncio o de bario',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2817,'Óxido de zinco; peróxido de zinco','Zinc oxide and zinc peroxide','Óxido de cinc y peróxido de cinc',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2818,'Corindo artificial, quimicamente definido ou não; óxido de alumínio; hidróxido de alumínio','Artificial corundum, whether or not chemically defined; aluminium oxide; aluminium hydroxide','Corindón artificial, aunque no sea químicamente definido; óxido de alumínio; hidróxido de aluminio',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2819,'Óxidos e hidróxidos de crómio','Chromium oxides and hydroxides','Óxidos e hidróxidos de cromo',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2820,'Óxidos de manganés','Manganese oxides','Óxidos de manganeso',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2821,'Óxidos e hidróxidos de ferro; terras corantes contendo, em peso, 70 % ou mais de ferro combinado, expresso em Fe2O3','Iron oxides and hydroxides; earth colours containing 70 % or more by weight of combined iron evaluated as Fe2O3','Óxidos e hidróxidos de hierro; tierras colorantes con un contenido de hierro combinado, expresado en Fe2O3 superior o igual al 70 % en peso',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2822,'Óxidos e hidróxidos de cobalto, inclusive os comerciais','Cobalt oxide and hydroxide, commercial cobalt oxides','Óxido de cobalto y el hidróxido, óxidos de cobalto comerciales',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2823,'Óxidos de titânio','Titanium oxides','Óxidos de titanio',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2824,'Óxidos de chumbo; mínio (zarcão) e mínio-laranja (mine-orange)','Lead oxides; red lead and orange lead','Óxidos de plomo; minio y minio anaranjado',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2825,'Hidrazina e hidroxilamina, e seus sais inorgânicos; outras bases inorgânicas; outros óxidos, hidróxidos e peróxidos, de metais','Hydrazine and hydroxylamine and their inorganic salts; other inorganic bases; other metal oxides, hydroxides and peroxides','Hidrazina e hidroxilamina y sus sales inorgánicas; las demás bases inorgánicas; los demás óxidos, hidróxidos y peróxidos de metales',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2826,'Fluoretos; fluorossilicatos, fluoroaluminatos e outros sais complexos de flúor','Fluorides; fluorosilicates, fluoroaluminates and other complex fluorine salts','Fluoruros; fluorosilicatos, fluoroaluminatos y demás sales complejas de flúor',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2827,'Cloretos, oxicloretos e hidroxicloretos; brometos e oxibrometos; iodetos e oxiiodetos','Chlorides, chloride oxides and chloride hydroxides; bromides and bromide oxides; iodides and iodide oxides','Cloruros, oxicloruros e hidroxicloruros; bromuros y oxibromuros; yoduros y oxiyoduros',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2828,'Hipocloritos; hipoclorito de cálcio comercial; cloritos; hipobromitos','Hypochlorites; commercial calcium hypochlorite; chlorites; hypobromites','Hipocloritos; hipoclorito de calcio comercial; cloritos; hipobromitos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2829,'Cloratos e percloratos; bromatos e perbromatos; iodatos e periodatos','Chlorates and perchlorates; bromates and perbromates; iodates and periodates','Cloratos y percloratos; bromatos y perbromatos; yodatos y peryodatos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2830,'Sulfuretos; polissulfuretos, de constituição química definida ou não','Sulphides; polysulphides, whether or not chemically defined','Sulfuros; polisulfuros, aunque no sean de constitución química definada',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2831,'Ditionites e sulfoxilatos','Dithionites and sulphoxylates','Ditionitos y sulfoxilatos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2832,'Sulfitos; tiosulfatos','Sulphites; thiosulphates','Sulfitos; tiosulfatos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2833,'Sulfatos; alúmenes; peroxosulfatos (persulfatos)','Sulphates; alums; peroxosulphates (persulphates)','Sulfatos; alumbres; peroxosulfatos (persulfatos)',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2834,'Nitritos; nitratos','Nitrites; nitrates','Nitritos; nitratos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2835,'Fosfinatos (hipofosfitos), fosfonatos (fosfitos) e fosfatos; polifosfatos, de constituição química definida ou não:','Phosphinates (hypophosphites), phosphonates (phosphites) and phosphates; polyphosphates, whether or not chemically defined','Fosfinatos (hipofosfitos), fosfonatos (fosfitos) y fosfatos; polifosfatos, aunque no sean de constitución química definida',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2836,'Carbonatos; peroxocarbonatos (percarbonatos); carbonato de amónio comercial contendo carbamato de amónio','Carbonates; peroxocarbonates (percarbonates); commercial ammonium carbonate containing ammonium carbamate','Carbonatos; peroxocarbonatos (percarbonatos); carbonato de amonio comercial que contenga carbamato de amonio',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2837,'Cianetos, oxicianetos e cianetos complexos','Cyanides, cyanide oxides and complex cyanides','Cianuros, oxicianuros y cianuros complejos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2838,'Fulminatos, cianatos e tiocianatos','Fulminates, cyanates and thiocyanates','Tiocianatos, fulmina, cianatos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2839,'Silicatos; silicatos dos metais alcalinos comerciais','Silicates; commercial alkali metal silicates','Silicatos; silicatos comerciales de los metales alcalinos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2840,'Boratos; peroxoboratos (perboratos)','Borates; peroxoborates (perborates)','Boratos; peroxoboratos (perboratos)',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2841,'Sais dos ácidos oxometálicos ou peroxometálicos','Salts of oxometallic or peroxometallic acids','Sales de los ácidos oxometálicos o peroxometálicos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2842,'Outros sais dos ácidos ou peroxoácidos inorgânicos (incluindo aluminossilicatos de constituição química definida ou não), exceto azidas','Other salts of inorganic acids or peroxoacids (including aluminosilicates whether or not chemically defined), other than azides','Las demás sales de los ácidos o peroxoácidos inorgánicos, incluidos los aluminosilicatos, aunque no sean de constitución química definida (excepto los aziduros [azidas])',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2843,'Metais preciosos no estado coloidal; compostos inorgânicos ou orgânicos de metais preciosos, de constituição química definida ou não; amálgamas de metais preciosos','Colloidal precious metals; inorganic or organic compounds of precious metals, whether or not chemically defined; amalgams of precious metals','Metal precioso en estado coloidal; compuestos inorgánicos u orgánicos de metal precioso, aunque no sean de constitución química definida; amalgamas de metal precioso',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2844,'Elementos químicos radioactivos e isótopos radioactivos (incluídos os elementos químicos e isótopos cindíveis ou férteis), e seus compostos; misturas e resíduos contendo esses produtos','Radioactive chemical elements and radioactive isotopes (including the fissile or fertile chemical elements and isotopes) and their compounds; mixtures and residues containing these products','Elementos químicos radiactivos e isótopos radiactivos, incluidos los elementos químicos e isótopos fisionables o fértiles, y sus compuestos; mezclas y residuos que contengan estos productos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2845,'Isótopos não incluídos na posição 2844; seus compostos inorgânicos ou orgânicos, de constituição química definida ou não','Isotopes other than those of heading 2844; compounds, inorganic or organic, of such isotopes, whether or not chemically defined','Isótopos (excepto los de la partida 2844); sus compuestos inorgánicos u orgánicos, aunque no sean de constitución química definida',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2846,'Compostos, inorgânicos ou orgânicos, dos metais das terras raras, de ítrio ou de escândio ou das misturas destes metais','Compounds, inorganic or organic, of rare-earth metals, of yttrium or of scandium or of mixtures of these metals','Compuestos inorgánicos u orgánicos, de metales de las tierras raras, del itrio, del escandio o de las mezclas de estos metales',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2847,'Peróxido de hidrogênio (água oxigenada)','Hydrogen peroxide','Peróxido de hidrógeno (agua oxigenada)',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2848,'Fosfetos, exceto ferrofósforos, quimicamente definidos ou não','Phosphides, excluding ferrophosphorus','Fosfuros, excepto los ferrofósforos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2849,'Carbonetos de constituição química definida ou não','Carbides, whether or not chemically defined','Carburos, aunque no sean de constitución química definida',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2850,'Hidretos, nitretos, azidas, silicietos e boretos, quimicamente definidos ou não','Hydrides, nitrides, azides, silicides and borides','Hidruros, nitruros, azidas, siliciuros y boruros',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2851,'Compostos inorgânicos nesoi: liq ar: amálgamas nesoi','Inorganic compounds nesoi: liq air: amalgams nesoi','Sulfocloretos',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2852,'Compostos, inorgânicos ou orgânicos, de mercúrio, de constituição química definida ou não, exceto as amálgamas','Inorganic or organic compounds of mercury, whether or not chemically defined','Compuestos inorgánicos u orgánicos, de mercurio, aunque no sean de constitución química definida, excepto las amalgamas',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2853,'Outros compostos inorgânicos (incluídas as águas destiladas, de condutibilidade ou de igual grau de pureza); ar líquido (incluído o ar líquido cujos gases raros foram eliminados); ar comprimido; amálgamas, exceto de metais preciosos.','Inorganic and organic compounds, incl. distilled or conductivity water and water of similar purity, n.e.s.; liquid air, whether or not rare gases have been removed; compressed air; amalgams (other than amalgams of precious metals)','Compuestos inorgánicos u orgánicos (incl. el agua destilada, de conductibilidad o del mismo grado de pureza); aire líquido, aunque se hayan eliminado los gases nobres, aire comprimido; amalgamas (exc. las de metales preciosos)',28);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2901,'Hidrocarbonetos acíclicos','Acyclic hydrocarbons','Hidrocarburos acíclicos',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2902,'Hidrocarbonetos cíclicos','Cyclic hydrocarbons','Hidrocarburos cíclicos',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2903,'Derivados halogenados dos hidrocarbonetos','Halogenated derivatives of hydrocarbons','Derivados halogenados de los hidrocarburos',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2904,'Derivados sulfonados, nitrados ou nitrosados dos hidrocarbonetos, mesmo halogenados','Sulphonated, nitrated or nitrosated derivatives of hydrocarbons, whether or not halogenated','Derivados sulfonados, nitrados o nitrosados de los hidrocarburos, incluso halogenados',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2905,'Álcoois acíclicos e seus derivados halogenados, sulfonados, nitrados ou nitrosados','Acyclic alcohols and their halogenated, sulphonated, nitrated or nitrosated derivatives','Alcoholes acíclicos y sus derivados halogenados, sulfonados, nitrados o nitrosados',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2906,'Álcoois cíclicos e seus derivados halogenados, sulfonados, nitrados ou nitrosados','Cyclic alcohols and their halogenated, sulphonated, nitrated or nitrosated derivatives','Alcoholes cíclicos y sus derivados halogenados, sulfonados, nitrados o nitrosados',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2907,'Fenóis; fenóis-álcoois','Phenols; phenol-alcohols','Fenoles; fenoles-alcoholes',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2908,'Derivados halogenados, sulfonados, nitrados ou nitrosados dos fenóis ou dos fenóis-álcoois','Halogenated, sulphonated, nitrated or nitrosated derivatives of phenols or phenol-alcohols','Derivados halogenados, sulfonados, nitrados o nitrosados, de los fenoles o de los fenoles-alcoholes',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2909,'Éteres, éteres-álcoois, éteres-fenóis, éteres-álcoois-fenóis, peróxidos de álcoois, peróxidos de éteres, peróxidos de cetonas (de constituição química definida ou não), e seus derivados halogenados, sulfonados, nitrados ou nitrosados','Ethers, ether-alcohols, ether-phenols, ether-alcohol-phenols, alcohol peroxides, ether peroxides, ketone peroxides (whether or not chemically defined), and their halogenated, sulphonated, nitrated or nitrosated derivatives','Éteres, éteres-alcoholes, éteres-fenoles, éteres-alcoholes-fenoles, peróxidos de alcoholes, peróxidos de éteres, peróxidos de cetonas (aunque no sean de constitución química definida), y sus derivados halogenados, sulfonados, nitrados o nitrosados',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2910,'Epóxidos, epoxi-álcoois, epoxi-fenóis e epoxi-éteres, com três átomos no ciclo, e seus derivados halogenados, sulfonados, nitrados ou nitrosados','Epoxides, epoxyalcohols, epoxyphenols and epoxyethers, with a three-membered ring, and their halogenated, sulphonated, nitrated or nitrosated derivatives','Epóxidos, epoxialcoholes, epoxifenoles y epoxiéteres, con tres átomos en el ciclo, y sus derivados halogenados, sulfonados, nitrados o nitrosados',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2911,'Acetais, semi-acetais, mesmo contendo outras funções oxigenadas, e seus derivados halogenados, sulfonados, nitrados ou nitrosados','Acetals and hemiacetals with or without other oxy func','Acetales y semiacetales, con o sin otras funciones oxígeno',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2912,'Aldeídos, mesmo contendo outras funções oxigenadas; polímeros cíclicos dos aldeídos; paraformaldeído','Aldehydes, whether or not with other oxygen function; cyclic polymers of aldehydes; paraformaldehyde','Aldehídos, incluso con otras funciones oxigenadas; polímeros cíclicos de los aldehídos; paraformaldehído',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2913,'Derivados halogenados, sulfonados, nitrados ou nitrosados dos produtos da posição 2912','Halogenated, sulfonated etc derivatives of aldehyde compounds','Derivados halogenados, etc sulfonados de compuestos de aldehído',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2914,'Cetonas e quinonas, mesmo contendo outras funções oxigenadas, e seus derivados halogenados, sulfonados, nitratos ou nitrosados','Ketones and quinones, whether or not with other oxygen function, and their halogenated, sulphonated, nitrated or nitrosated derivatives','Cetonas y quinonas, incluso con otras funciones oxigenadas, y sus derivados halogenados, sulfonados, nitrados o nitrosados',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2915,'Ácidos monocarboxílicos acíclicos saturados e seus anidridos, halogenetos, peróxidos e peroxiácidos; seus derivados halogenados, sulfonados, nitrados ou nitrosados','Saturated acyclic monocarboxylic acids and their anhydrides, halides, peroxides and peroxyacids; their halogenated, sulphonated, nitrated or nitrosated derivatives','Ácidos monocarboxílicos acíclicos saturados y sus anhídridos, halogenuros, peróxidos y peroxiácidos; sus derivados halogenados, sulfonados, nitrados o nitrosados',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2916,'Ácidos monocarboxílicos acíclicos não saturados e ácidos monocarboxílicos cíclicos, seus anidridos, halogenetos, peróxidos e peroxiácidos; seus derivados halogenados, sulfonados, nitrados ou nitrosados','Unsaturated acyclic monocarboxylic acids, cyclic monocarboxylic acids, their anhydrides, halides, peroxides and peroxyacids; their halogenated, sulphonated, nitrated or nitrosated derivatives','Ácidos monocarboxílicos acíclicos no saturados y ácidos monocarboxílicos cíclicos, sus anhídridos, halogenuros, peróxidos y peroxiácidos; sus derivados halogenados, sulfonados, nitrados o nitrosados',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2917,'Ácidos policarboxílicos, seus anidridos, halogenetos, peróxidos e peroxiácidos; seus derivados halogenados, sulfonados, nitrados ou nitrosados','Polycarboxylic acids, their anhydrides, halides, peroxides and peroxyacids; their halogenated, sulphonated, nitrated or nitrosated derivatives','Ácidos policarboxílicos, sus anhídridos, halogenuros, peróxidos y peroxiácidos; sus derivados halogenados, sulfonados, nitrados o nitrosados',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2918,'Ácidos carboxílicos contendo funções oxigenadas suplementares e seus anidridos, halogenetos, peróxidos e peroxiácidos; seus derivados halogenados, sulfonados, nitrados ou nitrosados','Carboxylic acids with additional oxygen function and their anhydrides, halides, peroxides and peroxyacids; their halogenated, sulphonated, nitrated or nitrosated derivatives','Ácidos carboxílicos con funciones oxigenadas suplementarias y sus anhídridos, halogenuros, peróxidos y peroxiácidos; sus derivados halogenados, sulfonados, nitrados o nitrosados',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2919,'Ésteres fosfóricos e seus sais, incluindo os lactofosfatos; seus derivados halogenados, sulfonados, nitrados ou nitrosados','Phosphoric esters and their salts, including lactophosphates; their halogenated, sulphonated, nitrated, nitrosated derivatives','Ésteres fosfóricos y sus sales, incluidos los lactofosfatos; sus derivados halogenados, sulfonados, nitrados o nitrosados',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2920,'Ésteres de outros ácidos inorgânicos de não-metais (exceto os ésteres de halogenetos de hidrogénio) e seus sais; seus derivados halogenados, sulfonados, nitrados ou nitrosados','Esters of other inorganic acids of non-metals (excluding esters of hydrogen halides) and their salts; their halogenated, sulphonated, nitrated or nitrosated derivatives','Ésteres de los demás ácidos inorgánicos de los no-metales (excepto los ésteres de halogenuros de hidrógeno) y sus sales; sus derivados halogenados, sulfonados, nitrados o nitrosados',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2921,'Compostos de função amina','Amine-function compounds','Compuestos con función amina',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2922,'Compostos aminados de funções oxigenadas','Oxygen-function amino-compounds','Compuestos aminados con funciones oxigenadas',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2923,'Sais e hidróxidos de amónio quaternários; lecitinas e outros fosfoaminolípidos, de constitução química definida ou não','Quaternary ammonium salts and hydroxides; lecithins and other phosphoaminolipids, whether or not chemically defined','Sales e hidróxidos de amonio cuaternario; lecitinas y demás fosfoaminolípidos, aunque no sean de constitución química definida',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2924,'Compostos de função carboxiamida; compostos de função amida do ácido carbónico','Carboxyamide-function compounds; amide-function compounds of carbonic acid','Compuestos con función carboxiamida; compuestos con función amida del ácido carbónico',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2925,'Compostos de função carboxiimida (incluindo a sacarina e seus sais) ou de função imina','Carboxyimide-function compounds (including saccharin and its salts) and imine-function compounds','Compuestos con función carboxiimida, incluida la sacarina y sus sales, o con función imina',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2926,'Compostos de função nitrilo','Nitrile-function compounds','Compuestos con función nitrilo',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2927,'Compostos diazóicos, azóicos e azóxicos','Diazo-, azo-, or azoxy-compounds','Diazo-, azo-, o azoxi compuestos',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2928,'Derivados orgânicos da hidrazina e hidroxilamina','Organic derivatives of hydrazine or hydroxylamine','Derivados orgánicos de la hidrazina o hidroxilamina',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2929,'Compostos de outras funções azotadas (nitrogenadas)','Compounds with other nitrogen function','Compuestos con otras funciones nitrogenadas',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2930,'Tiocompostos orgânicos','Organo-sulphur compounds','Tiocompuestos orgánicos',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2931,'Outros compostos organo-inorgânicos','Other organo-inorganic compounds','Otros compuestos órgano-inorgánicos',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2932,'Compostos heterocíclicos exclusivamente de hetero-átomo(s) de oxigénio','Heterocyclic compounds with oxygen hetero-atom(s) only','Compuestos heterocíclicos con heteroátomo(s) de oxígeno exclusivamente',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2933,'Compostos heterocíclicos, exclusivamente de hetero-átomo(s) de azoto (nitrogénio)','Heterocyclic compounds with nitrogen hetero-atom(s) only','Compuestos heterocíclicos con heteroátomo(s) de nitrógeno exclusivamente',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2934,'Ácidos nucleicos e seus sais, de constituição química definida ou não; outros compostos heterocíclicos','Nucleic acids and their salts, whether or not chemically defined; other heterocyclic compounds','Ácidos nucleicos y sus sales, aunque no sean de constitución química definida; los demás compuestos heterocíclicos',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2935,'Sulfonamidas','Sulfonamides','Sulfonamidas',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2936,'Provitaminas e vitaminas, naturais ou sintéticas (incluídos os concentrados naturais), bem como os seus derivados utilizados principalmente como vitaminas, misturados ou não entre si, mesmo em quaisquer soluções','Provitamins and vitamins, natural or reproduced by synthesis (including natural concentrates), derivatives thereof used primarily as vitamins, and intermixtures of the foregoing, whether or not in any solvent','Provitaminas y vitaminas, naturales o reproducidas por síntesis, incluidos los concentrados naturales y sus derivados utilizados principalmente como vitaminas, mezclados o no entre sí o en disoluciones de cualquier clase',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2937,'Hormonas, prostaglandinas, tromboxanos e leucotrienos, naturais ou reproduzidos por síntese; seus derivados e análogos estruturais, incluindo os polipéptidos de cadeia modificada, utilizados principalmente como hormonas','Hormones, prostaglandins, thromboxanes and leukotrienes, natural or reproduced by synthesis; derivatives and structural analogues thereof, including chain modified polypeptides, used primarily as hormones','Hormonas, prostaglandinas, tromboxanos y leucotrienos, naturales o reproducidos por síntesis; sus derivados y análogos estructurales, incluidos los polipéptidos de cadena modificada, utilizados principalmente como hormonas',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2938,'Heterósidos, naturais ou sintéticos, seus sais, éteres, ésteres e outros derivados','Glycosides, natural or reproduced by synthesis, and their salts, ethers, esters and other derivatives','Heterósidos, naturales o reproducidos por síntesis, sus sales, éteres, ésteres y demás derivados',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2939,'Alcalóides vegetais, naturais ou sintéticos, seus sais, éteres, ésteres e outros derivados','Vegetable alkaloids, natural or reproduced by synthesis, and their salts, ethers, esters and other derivatives','Alcaloides vegetales, naturales o reproducidos por síntesis, sus sales, éteres, ésteres y demás derivados',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2940,'Açúcares quimicamente puros, exceto sacarose, lactose, maltose, glicose e frutose; seus éteres e ésteres e seus sais','Sugars, chemically pure (except sucrose, lactose, fructose)','Azúcares químicamente puros (excepto sacarosa, lactosa, fructosa)',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2941,'Antibióticos','Antibiotics','Antibióticos',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (2942,'Outros compostos orgânicos','Salts of inorganic acids or peroxoacids','Sales de ácidos inorgánicos o peroxoácidos',29);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3001,'Glândulas e outros órgãos para usos opoterápicos, dessecados, mesmo em pó; extractos de glândulas ou de outros órgãos ou das suas secreções, para usos opoterápicos; heparina e seus sais; outras substâncias humanas ou animais preparadas para fins terapêuti','Glands and other organs for organo-therapeutic uses, dried, whether or not powdered; extracts of glands or other organs or of their secretions for organo-therapeutic uses; heparin and its salts; other human or animal substances prepared for therapeutic or','Glándulas y demás órganos para usos opoterápicos, desecados, incluso pulverizados; extractos de glándulas o de otros órganos o de sus secreciones, para usos opoterápicos; heparina y sus sales; las demás sustancias humanas o animales preparadas para usos t',30);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3002,'Sangue humano; sangue animal preparado para usos terapêuticos, profilácticos ou de diagnóstico; anti-soros, outras fracções do sangue, produtos imunológicos modificados, mesmo obtidos por via biotecnológica; vacinas, toxinas, culturas de microrganismos (e','Human blood; animal blood prepared for therapeutic, prophylactic or diagnostic uses; antisera and other blood fractions and modified immunological products, whether or not obtained by means of biotechnological processes; vaccines, toxins, cultures of micr','Sangre humana; sangre animal preparada para usos terapéuticos, profilácticos o de diagnóstico; antisueros (sueros con anticuerpos), demás fracciones de la sangre y productos inmunológicos modificados, incluso obtenidos por proceso biotecnológico; vacunas,',30);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3003,'Medicamentos (exceto os produtos das posições 3002, 3005 ou 3006) constituídos por produtos misturados entre si, preparados para fins terapêuticos ou profilácticos, mas não apresentados em doses nem acondicionados para venda a retalho','Medicaments (excluding goods of heading No 3002, 3005 or 3006) consisting of two or more constituents which have been mixed together for therapeutic or prophylactic uses, not put up in measured doses or in forms or packings for retail sale','Medicamentos (excepto los productos de las partidas 3002, 3005 ó 3006) constituidos por productos mezclados entre sí, preparados para usos terapéuticos o profilácticos, sin dosificar ni acondicionar para la venta al por menor',30);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3004,'Medicamentos (exceto os produtos das posições 3002, 3005 ou 3006) constituídos por produtos misturados ou não misturados, preparados para fins terapêuticos ou profilácticos, apresentados em doses (incluindo os destinados a serem administrados por via sub','Medicaments (excluding goods of heading 3002, 3005 or 3006) consisting of mixed or unmixed products for therapeutic or prophylactic uses, put up in measured doses (including those in the form of transdermal administration systems) or in forms or packings ','Medicamentos (excepto los productos de las partidas 3002, 3005 ó 3006) constituidos por productos mezclados o sin mezclar, preparados para usos terapéuticos o profilácticos, dosificados, incluidos los administrados por vía transdérmica) o acondicionados p',30);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3005,'Pastas (ouates), gazes, ataduras e artigos análogos (por exemplo: pensos, esparadrapos, sinapismos), impregnados ou recobertos de substâncias farmacêuticas ou acondicionados para venda a retalho para usos medicinais, cirúrgicos, dentários ou veterinários','Wadding, gauze, bandages and similar articles (for example, dressings, adhesive plasters, poultices), impregnated or coated with pharmaceutical substances or put up in forms or packings for retail sale for medical, surgical, dental or veterinary purposes','Guatas, gasas, vendas y artículos análogos (por ejemplo: apósitos, esparadrapos, sinapismos), impregnados o recubiertos de sustancias farmacéuticas o acondicionados para la venta al por menor con fines médicos, quirúrgicos, odontológicos o veterinarios',30);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3006,'Preparações e artigos farmacêuticos indicados na Nota 4 do presente capítulo','Pharmaceutical goods specified in note 4 to this chapter','Preparaciones y artículos farmacéuticos a que se refiere la nota 4 de este capítulo',30);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3101,'Adubos ou fertilizantes de origem animal/vegetal, etc.','Fertilisers obtained animal/vegetable, etc','Abonos de origen animal/vegetal, etc.',31);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3102,'Adubos (fertilizantes) minerais ou químicos, azotados','Mineral or chemical fertilisers, nitrogenous','Abonos minerales o químicos nitrogenados',31);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3103,'Adubos (fertilizantes) minerais ou químicos, fosfatados','Mineral or chemical fertilisers, phosphatic','Abonos minerales o químicos fosfatados',31);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3104,'Adubos (fertilizantes) minerais ou químicos, potássicos','Mineral or chemical fertilisers, potassic','Abonos minerales o químicos potásicos',31);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3105,'Adubos (fertilizantes) minerais ou químicos, contendo dois ou três dos seguintes elementos fertilizantes: azoto (nitrogénio), fósforo e potássio; outros adubos (fertilizantes); produtos do presente capítulo apresentados em tabletes ou formas semelhantes, ','Mineral or chemical fertilisers containing two or three of the fertilising elements nitrogen, phosphorus and potassium; other fertilisers; goods of this chapter in tablets or similar forms or in packages of a gross weight not exceeding 10 kg','Abonos minerales o químicos, con dos o tres de los elementos fertilizantes: nitrógeno, fósforo y potasio; los demás abonos; productos de este capítulo en tabletas o formas similares o en envases de un peso bruto inferior o igual a 10 kg',31);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3201,'Extractos tanantes de origem vegetal; taninos e seus sais, éteres, ésteres e outros derivados','Tanning extracts of vegetable origin; tannins and their salts, ethers, esters and other derivatives','Extractos curtientes de origen vegetal; taninos y sus sales, éteres, ésteres y demás derivados',32);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3202,'Produtos tanantes orgânicos sintéticos; produtos tanantes inorgânicos; preparações tanantes, mesmo contendo produtos tanantes naturais; preparações enzimáticas para a pré-curtimenta','Synthetic organic tanning substances; inorganic tanning substances; tanning preparations, whether or not containing natural tanning substances; enzymatic preparations for pre-tanning','Productos curtientes orgánicos sintéticos; productos curtientes inorgánicos; preparaciones curtientes, incluso con productos curtientes naturales; preparaciones enzimáticas para precurtido',32);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3203,'Matérias corantes de origem vegetal ou animal e preparações à base dessas matérias','Coloring matter of vegetable or animal origin','Materias colorantes de origen vegetal o animal',32);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3204,'Matérias corantes orgânicas sintéticas, mesmo de constituição química definida; preparações indicadas na Nota 3 do presente capítulo, à base de matérias corantes orgânicas sintéticas; produtos orgânicos sintéticos dos tipos utilizados como agentes de aviv','Synthetic organic colouring matter, whether or not chemically defined; preparations as specified in note 3 to this chapter based on synthetic organic colouring matter; synthetic organic products of a kind used as fluorescent brightening agents or as lumin','Materias colorantes orgánicas sintéticas, aunque sean de constitución química definida; preparaciones a que se refiere la nota 3 de este capítulo a base de materias colorantes orgánicas sintéticas; productos orgánicos sintéticos de los tipos utilizados pa',32);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3205,'Lacas corantes e suas preparações','colour lakes and its preparations','lacas colorantes y sus preparaciones',32);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3206,'Outras matérias corantes; preparações indicadas na Nota 3 do presente capítulo, exceto das posições 3203, 3204 ou 3205; produtos inorgânicos dos tipos utilizados como luminóforos, mesmo de constituição química definida','Other colouring matter; preparations as specified in note 3 to this chapter, other than those of heading 3203, 3204 or 3205; inorganic products of a kind used as luminophores, whether or not chemically defined','Las demás materias colorantes; preparaciones a que se refiere la nota 3 de este capítulo (excepto las de las partidas 3203, 3204 ó 3205); productos inorgánicos de los tipos utilizados como luminóforos, aunque sean de constitución química definida',32);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3207,'Pigmentos, opacificantes e cores preparados, composições vitrificáveis, engobos, esmaltes metálicos líquidos e preparações semelhantes, dos tipos utilizados nas indústrias da cerâmica, do esmalte e do vidro; fritas de vidro e outros vidros, em pó, em grân','Prepared pigments, prepared opacifiers and prepared colours, vitrifiable enamels and glazes, engobes (slips), liquid lustres and similar preparations, of a kind used in the ceramic, enamelling or glass industry; glass frit and other glass, in the form of ','Pigmentos, opacificantes y colores preparados, composiciones vitrificables, engobes, abrillantadores (lustres) líquidos y preparaciones similares, de los tipos utilizados en cerámica, esmaltado o en la industria del vidrio; frita de vidrio y demás vidrios',32);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3208,'Tintas e vernizes, à base de polímeros sintéticos ou de polímeros naturais modificados, dispersos ou dissolvidos em meio não aquoso; soluções definidas na Nota 4 do presente capítulo','Paints and varnishes (including enamels and lacquers) based on synthetic polymers or chemically modified natural polymers, dispersed or dissolved in a non-aqueous medium; solutions as defined in note 4 to this chapter','Pinturas y barnices a base de polímeros sintéticos o naturales modificados, dispersos o disueltos en un medio no acuoso; disoluciones definidas en la nota 4 de este capítulo',32);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3209,'Tintas e vernizes, à base de polímeros sintéticos ou de polímeros naturais modificados, dispersos ou dissolvidos num meio aquoso','Paints and varnishes (including enamels and lacquers) based on synthetic polymers or chemically modified natural polymers, dispersed or dissolved in an aqueous medium','Pinturas y barnices a base de polímeros sintéticos o naturales modificados, dispersos o disueltos en un medio acuoso',32);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3210,'Outras tintas e vernizes; pigmentos a água preparados, utilizados para acabamento de couros','Paints and varnishes, water pigments for leather','Pinturas y barnices, pigmentos al agua para el cuero',32);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3211,'Secantes preparados','prepared driers','secativos preparados',32);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3212,'Pigmentos (incluídos os pós e flocos metálicos) dispersos em meios não aquosos, no estado líquido ou pastoso, dos tipos utilizados na fabricação de tintas; folhas para marcar a ferro; tinturas e outras matérias corantes apresentadas em formas próprias ou ','Pigments (including metallic powders and flakes) dispersed in non-aqueous media, in liquid or paste form, of a kind used in the manufacture of paints (including enamels); stamping foils; dyes and other colouring matter put up in forms or packings for reta','Pigmentos, incluidos el polvo y las escamillas metálicos, dispersos en medios no acuosos, líquidos o en pasta, de los tipos utilizados para la fabricación de pinturas; hojas para el marcado a fuego; tintes y demás materias colorantes presentados en formas',32);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3213,'Cores para pintura artística, actividades educativas, pintura de tabuletas, modificação de tonalidades, recreação e cores semelhantes, em pastilhas, tubos, potes, frascos, godés ou acondicionamentos semelhantes','Artists'', students'' or signboard painters'' colours, modifying tints, amusement colours and the like, in tablets, tubes, jars, bottles, pans or in similar forms or packings','Colores para la pintura artística, la enseñanza, la pintura de carteles, para matizar o para entretenimiento y colores similares, en pastillas, tubos, botes, frascos, o en formas o envases similares',32);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3214,'Mástique de vidraceiro, cimentos de resina e outros mástiques; indutos utilizados em pintura; indutos não refractários do tipo dos utilizados em alvenaria','Glaziers'' putty, grafting putty, resin cements, caulking compounds and other mastics; painters'' fillings; non-refractory surfacing preparations for façades, indoor walls, floors, ceilings or the like','Masilla, cementos de resina y otros mástiques; plastes (enduidos) utilizados en pintura; plastes (enduidos) no refractarios de los tipos utilizados en ambañilería',32);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3215,'Tintas de impressão, tintas de escrever ou de desenhar e outras tintas, mesmo concentradas ou no estado sólido','Printing ink, writing or drawing ink and other inks, whether or not concentrated or solid','Tintas de imprenta, tintas para escribir o dibujar y demás tintas, incluso concentradas o sólidas',32);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3301,'Óleos essenciais (desterpenizados ou não), incluídos os chamados « concretos » ou « absolutos »; resinóides; oleorresinas de extracção; soluções concentradas de óleos essenciais em gorduras, em óleos fixos, em ceras ou em matérias análogas, obtidas por tr','Essential oils (terpeneless or not), including concretes and absolutes; resinoids; extracted oleoresins; concentrates of essential oils in fats, in fixed oils, in waxes or the like, obtained by enfleurage or maceration; terpenic by-products of the deterpe','Aceites esenciales (desterpenados o no), incluidos los «concretos» o «absolutos»; resinoides; oleorresinas de extracción; disoluciones concentradas de aceites esenciales en grasas, aceites fijos, ceras o materias análogas, obtenidas por enflorado o macera',33);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3302,'Misturas de substâncias odoríferas e misturas (incluídas as soluções alcoólicas) à base de uma ou mais destas substâncias, dos tipos utilizados como matérias básicas para a indústria; outras preparações à base de substâncias odoríferas, dos tipos utilizad','Mixtures of odoriferous substances and mixtures (including alcoholic solutions) with a basis of one or more of these substances, of a kind used as raw materials in industry; other preparations based on odoriferous substances, of a kind used for the manufa','Mezclas de sustancias odoríferas y mezclas, incluidas las disoluciones alcohólicas, a base de una o varias de estas sustancias, de los tipos utilizados como materias básicas para la industria; las demás preparaciones a base de sustancias odoríferas, de lo',33);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3303,'Perfumes (extratos) e águas-de-colônia','Perfumes and toilet waters','Perfumes y aguas de tocador',33);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3304,'Produtos de beleza ou de maquilhagem preparados e preparações para conservação ou cuidados da pele (exceto medicamentos), incluídas as preparações anti-solares e os bronzeadores; preparações para manicuros e pedicuros','Beauty or make-up preparations and preparations for the care of the skin (other than medicaments), including sunscreen or sun tan preparations; manicure or pedicure preparations','Preparaciones de belleza, maquillaje y para el cuidado de la piel (excepto los medicamentos), incluidas las preparaciones antisolares y las bronceadoras; preparaciones para manicuras o pedicuros',33);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3305,'Preparações capilares','Preparations for use on the hair','Preparaciones capilares',33);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3306,'Preparações para higiene bucal ou dentária, incluídos os pós e cremes para facilitar a aderência das dentaduras; fios utilizados para limpar os espaços interdentais (fio dental), em embalagens para venda a retalho','Preparations for oral or dental hygiene, including denture fixative pastes and powders; yarn used to clean between the teeth (dental floss), in individual retail packages','Preparaciones para higiene bucal o dental, incluidos los polvos y cremas para la adherencia de las dentaduras; hilo utilizado para limpieza de los espacios interdentales (hilo dental), en envases individuales para la venta al por menor',33);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3307,'Preparações para barbear (antes, durante ou após), desodorizantes corporais, preparações para banhos, depilatórios, outros produtos de perfumaria ou de toucador preparados e outras preparações cosméticas, não especificados nem compreendidos em outras posi','Pre-shave, shaving or after-shave preparations, personal deodorants, bath preparations, depilatories and other perfumery, cosmetic or toilet preparations, not elsewhere specified or included; prepared room deodorisers, whether or not perfumed or having di','Preparaciones para afeitar o para antes o después del afeitado, desodorantes corporales, preparaciones para el baño, depilatorios y demás preparaciones de perfumería, de tocador o de cosmética, no expresadas ni comprendidas en otra parte; preparaciones de',33);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3401,'Sabões; produtos e preparações orgânicos tensoactivos utilizados como sabão, em barras, pães, pedaços ou figuras moldadas, mesmo contendo sabão; produtos e preparações orgânicos tensoactivos para lavagem da pele, sob a forma de líquido ou de creme, acondi','Soap; organic surface-active products and preparations for use as soap, in the form of bars, cakes, moulded pieces or shapes, whether or not containing soap; organic surface-active products and preparations for washing the skin, in the form of liquid or c','Jabón; productos y preparaciones orgánicos tensoactivos usados como jabón, en barras, panes, trozos o piezas troqueladas o moldeadas, aunque contengan jabón; productos y preparaciones orgánico tensoactivos para el lavado de la piel, líquido o en crema, ac',34);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3402,'Agentes orgânicos de superfície (exceto sabões); preparações tensoactivas, preparações para lavagem (incluídas as preparações auxiliares de lavagem) e preparações para lavagem, mesmo contendo sabão, exceto as da posição 3401','Organic surface-active agents (other than soap); surface-active preparations, washing preparations (including auxiliary washing preparations) and cleaning preparations, whether or not containing soap, other than those of heading No 3401','Agentes de superficie orgánicos (excepto el jabón); preparaciones tensoactivas, preparaciones para lavar, incluidas las preparaciones auxiliares de lavado y preparaciones de limpieza, aunque contengan jabón (excepto las de la partida 3401)',34);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3403,'Preparações lubrificantes (incluídos os óleos de corte, as preparações antiaderentes de porcas e parafusos, as preparações antiferrugem ou anticorrosão e as preparações para desmoldagem, à base de lubrificantes) e preparações dos tipos utilizados para lub','Lubricating preparations (including cutting-oil preparations, bolt or nut release preparations, anti-rust or anti-corrosion preparations and mould release preparations, based on lubricants) and preparations of a kind used for the oil or grease treatment o','Preparaciones lubricantes, incluidos los aceites de corte, las preparaciones para aflojar tuercas, las preparaciones antiherrumbre o anticorrosión y las preparaciones para el desmoldeo, a base de lubricantes y preparaciones de los tipos utilizados para el',34);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3404,'Ceras artificiais e ceras preparadas','Artificial waxes and prepared waxes','Ceras artificiales y ceras preparadas',34);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3405,'Pomadas e cremes para calçado, encáusticos, preparações para dar brilho a pinturas de carroçarias, vidros ou metais, pastas e pós para arear e preparações semelhantes [mesmo apresentados em papel, pastas (ouates), feltros, falsos tecidos, plástico ou borr','Polishes and creams, for footwear, furniture, floors, coachwork, glass or metal, scouring pastes and powders and similar preparations (whether or not in the form of paper, wadding, felt, non-wovens, cellular plastics or cellular rubber, impregnated, coate','Betunes y cremas para el calzado, encáusticos, abrillantadores (lustres) para carrocerías, vidrio o metal, pastas y polvos para fregar y preparaciones similares, incluso papel, guata, fieltro, tela sin tejer, plástico o caucho celulares, impregnados, recu',34);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3406,'Velas, pavios, cirios e artigos semelhantes','Candles, tapers and the like','Velas, cirios y artículos similares',34);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3407,'Pastas para modelar, ceras para dentistas e outras composições para dentistas à base de gesso','Modeling pastes for child etc, dental impr compositions etc','Pastas de modelar para menores, etc, etc composiciones dentales impr',34);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3501,'Caseínas, caseinatos e outros derivados das caseínas; colas de caseína','Casein, caseinates and other casein derivatives; casein glues','Caseína, caseinatos y demás derivados de la caseína; colas de caseína',35);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3502,'Albuminas (incluídos os concentrados de várias proteínas de soro de leite, contendo, em peso calculado sobre matéria seca, mais de 80 % de proteínas do soro de leite), albuminatos e outros derivados das albuminas','Albumins (including concentrates of two or more whey proteins, containing by weight more than 80 % whey proteins, calculated on the dry matter), albuminates and other albumin derivatives','Albúminas, incluidos los concentrados de varias proteínas del lactosuero, con un contenido de proteínas de lactosuero superior al 80 % en peso, calculado sobre materia seca, albuminatos y demás derivados de las albúminas',35);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3503,'Gelatinas e seus derivados; ictiocola e outras colas de origem animal, exceto cola de caseína','Gelatin and derivatives, isinglass, glues, of animal origin','Gelatina y sus derivados, cola de pescado, colas, de origen animal',35);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3504,'Peptonas e seus derivados; outras matérias protéicas e seus derivados; pó de peles','Peptones, other proteins and derivatives, etc, hide powder','Peptonas, otras proteínas y derivados, etc, polvo de pieles',35);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3505,'Dextrina e outros amidos e féculas modificados (por exemplo: amidos e féculas pré-gelatinizados ou esterificados); colas à base de amidos ou de féculas, de dextrina ou de outros amidos ou féculas modificados','Dextrins and other modified starches (for example, pregelatinised or esterified starches); glues based on starches, or on dextrins or other modified starches','Dextrina y demás almidones y féculas modificados (por ejemplo: almidones y féculas pregelatinizados o esterificados); colas a base de almidón, fécula, dextrina o demás almidones o féculas modificados',35);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3506,'Colas e outros adesivos preparados, não especificados nem compreendidos em outras posições; produtos de qualquer espécie utilizados como colas ou adesivos, acondicionados para venda a retalho como colas ou adesivos, com peso líquido não superior a 1 kg','Prepared glues and other prepared adhesives, not elsewhere specified or included; products suitable for use as glues or adhesives, put up for retail sale as glues or adhesives, not exceeding a net weight of 1 kg','Colas y demás adhesivos preparados, no expresados ni comprendidos en otra parte; productos de cualquier clase utilizados como colas o adhesivos, acondicionados para la venta al por menor como colas o adhesivos, de peso neto inferior o igual a 1 kg',35);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3507,'Enzimas; enzimas preparadas não especificadas nem compreendidas em outras posições','Enzymes; prepared enzymes not elsewhere specified or included','Enzimas; preparaciones enzimáticas no expresadas ni comprendidas en otra parte',35);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3601,'Pólvoras propulsivas','Oropellent powders','Pólvoras propulsivas',36);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3602,'explosivos preparados, exceto pólvoras propulsivas','prepared explosives, other than propellent powders','explosivos preparados,  excepto pólvoras propulsivas',36);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3603,'Estopins/rastilhos, de segurança, cordéis detonantes, etc.','Safety fuses/detonating fuses, percussion, deton.caps, etc','Mechas de seguridad, cordones detonantes, etc.',36);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3604,'Fogos de artifício, foguetes de sinalização ou contra o granizo e semelhantes, bombas, petardos e outros artigos de pirotecnia','Fireworks, signalling flares, rain rockets, fog signals and other pyrotechnic articles','Artículos para fuegos artificiales, cohetes de señales o granífugos y similares, petardos y demás artículos de pirotecnia',36);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3605,'fósforos, exceto os artigos de pirotecnia','matches, other than pyrotechnic articles','fósforos, excepto los artículos de pirotecnia',36);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3606,'Ferrocério e outras ligas pirofóricas, sob quaisquer formas; artigos de matérias inflamáveis indicados na Nota 2 do presente capítulo','Ferro-cerium and other pyrophoric alloys in all forms; articles of combustible materials as specified in note 2 to this chapter','Ferrocerio y demás aleaciones pirofóricas en cualquier forma; artículos de materias inflamables a que se refiere la nota 2 de este capítulo',36);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3701,'Chapas e filmes planos, fotográficos, sensibilizados, não impressionados, de matérias diferentes do papel, do cartão ou dos têxteis; filmes fotográficos planos, de revelação e cópia instantâneas, sensibilizados, não impressionados, mesmo em cartuchos','Photographic plates and film in the flat, sensitized, unexposed, of any material other than paper, paperboard or textiles; instant print film in the flat, sensitised, unexposed, whether or not in packs','Placas y películas planas, fotográficas, sensibilizadas, sin impresionar, excepto las de papel, cartón o textiles; películas fotográficas planas autorrevelables, sensibilizadas, sin impresionar, incluso en cargadores',37);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3702,'Filmes fotográficos sensibilizados, não impressionados, em rolos, de matérias diferentes do papel, do cartão ou dos têxteis; filmes fotográficos de revelação e cópia instantâneas, em rolos, sensibilizados, não impressionados','Photographic film in rolls, sensitized, unexposed, of any material other than paper, paperboard or textiles; instant print film in rolls, sensitised, unexposed','Películas fotográficas en rollos, sensibilizadas, sin impresionar, excepto las de papel, cartón o textiles; películas fotográficas autorrevelables en rollos, sensibilizadas, sin impresionar',37);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3703,'Papéis, cartões e têxteis, fotográficos, sensibilizados, não impressionados','Photographic paper, paperboard and textiles, sensitised, unexposed','Papel, cartón y materias textiles, fotográficos, sensibilizados, sin impresionar',37);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3704,'Chapas, filmes, etc.fotográficos, impress.mas n/revelados','Photographic plates, film, etc.exposed but n/developed','Placas, películas, etc.fotográficas, impres.pero s/revelar',37);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3705,'Chapas e filmes, fotográficos, impressionados e revelados, exceto filmes cinematográficos','Photographic plates and film, exposed and developed, other than cinematographic film','Placas y películas, fotográficas, impresionadas y reveladas (excepto las cinematográficas [filmes])',37);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3706,'Filmes cinematográficos impressionados e revelados, contendo ou não gravação de som ou contendo apenas gravação de som','Cinematographic film, exposed and developed, whether or not incorporating sound track or consisting only of sound track','Películas cinematográficas (filmes), impresionadas y reveladas, con registro de sonido o sin él, o con registro de sonido solamente',37);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3707,'Preparações químicas para usos fotográficos, exceto vernizes, colas, adesivos e preparações semelhantes; produtos não misturados, quer doseados tendo em vista usos fotográficos, quer acondicionados para venda a retalho para esses mesmos usos e prontos pa','Chemical preparations for photographic uses (other than varnishes, glues, adhesives and similar preparations); unmixed products for photographic uses, put up in measured portions or put up for retail sale in a form ready for use','Preparaciones químicas para uso fotográfico (excepto los barnices, colas, adhesivos y preparaciones similares); productos sin mezclar para uso fotográfico, dosificados o acondicionados para la venta al por menor para uso fotográfico y listos para su emple',37);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3801,'Grafite artificial; grafite coloidal ou semicoloidal; preparações à base de grafite ou de outros carbonos, em pastas, blocos, lamelas ou outros produtos intermediários','Artificial graphite; colloidal or semi-colloidal graphite; preparations based on graphite or other carbon in the form of pastes, blocks, plates or other semi-manufactures','Grafito artificial; grafito coloidal o semicoloidal; preparaciones a base de grafito u otros carbonos, en pasta, bloques, plaquitas u otras semimanufacturas',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3802,'Carvões activados; matérias minerais naturais activadas; negros de origem animal, incluído o negro animal esgotado','Activated carbon; activated natural mineral products; animal black, including spent animal black','Carbón activado; materias minerales naturales activadas; negro de origen animal, incluido el agotado',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3803,'Tall-oil mesmo refinado','tall oil, whether or not refined','tall oil,  incluso refinado',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3804,'Lixívias residuais da fabricação de pasta de celulose, incluídos os lignossulfonatos','Residual lyes from wood pulp manufacture (except tall oil)','Lejías residuales de la fabricación de pasta de madera (a excepción del aceite de resina)',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3805,'Essências de terebintina, de pinheiro ou provenientes da fabricação da pasta de papel ao sulfato e outras essências terpénicas provenientes da destilação ou de outros tratamentos das madeiras de coníferas; dipenteno em bruto; essência proveniente da fabri','Gum, wood or sulphate turpentine and other terpenic oils produced by the distillation or other treatment of coniferous woods; crude dipentene; sulphite turpentine and other crude para-cymene; pine oil containing alpha-terpineol as the main constituent','Esencia de trementina, de madera de pino o de pasta celulósica al sulfato (sulfato de trementina) y demás esencias terpénicas procedentes de la destilación o de otros tratamientos de la madera de coníferas; dipenteno en bruto; esencia de pasta celulósica ',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3806,'Colofónias e ácidos resínicos, e seus derivados; essência de colofónia e óleos de colofónia; gomas fundidas','Rosin and resin acids, and derivatives thereof; rosin spirit and rosin oils; run gums','Colofonias y ácidos resínicos, y sus derivados; esencia y aceites de colofonia; gomas fundidas',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3807,'Alcatrões de madeira, óleos de alcatrao de madeira, etc.','Wood tar, wood tar oils, wood creosote, etc','Alquitranes de madera, aceites de alquitrán  madera, etc',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3808,'Insecticidas, rodenticidas, fungicidas, herbicidas, inibidores de germinação e reguladores de crescimento para plantas, desinfectantes e produtos semelhantes, apresentados em formas ou embalagens para venda a retalho ou como preparações ou ainda sob a for','Insecticides, rodenticides, fungicides, herbicides, anti-sprouting products and plant-growth regulators, disinfectants and similar products, put up in forms or packings for retail sale or as preparations or articles (for example, sulphur-treated bands, wi','Insecticidas, raticidas y demás antirroedores, fungicidas, herbicidas, inhibidores de germinación y reguladores del crecimiento de las plantas, desinfectantes y productos similares, presentados en formas o en envases para la venta al por menor, o como pre',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3809,'Agentes de apresto ou de acabamento, aceleradores de tingimento ou de fixação de matérias corantes e outros produtos e preparações (por exemplo: aprestos preparados e preparações mordentes) dos tipos utilizados na indústria têxtil, na indústria do papel, ','Finishing agents, dye carriers to accelerate the dyeing or fixing of dyestuffs and other products and preparations (for example, dressings and mordants), of a kind used in the textile, paper, leather or like industries, not elsewhere specified or included','Aprestos y productos de acabado, aceleradores de tintura o de fijación de materias colorantes y demás productos y preparaciones (por ejemplo: aprestos y mordientes), de los tipos utilizados en la industria textil, del papel, del cuero o industrias similar',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3810,'Preparações para decapagem de metais; fluxos para soldar e outras preparações auxiliares para soldar metais; pastas e pós para soldar, compostos de metal e outras matérias; preparações dos tipos utilizados para enchimento ou revestimento de eléctrodos ou ','Pickling preparations for metal surfaces; fluxes and other auxiliary preparations for soldering, brazing or welding; soldering, brazing or welding powders and pastes consisting of metal and other materials; preparations of a kind used as cores or coatings','Preparaciones para el decapado de metal; flujos y demás preparaciones auxiliares para soldar metal; pastas y polvos para soldar, constituidos por metal y otros productos; preparaciones de los tipos utilizados para recubrir o rellenar electrodos o varillas',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3811,'Preparações antidetonantes, inibidores de oxidação, aditivos peptizantes, beneficiadores de viscosidade, aditivos anticorrosivos e outros aditivos preparados, para óleos minerais (incluída a gasolina) ou para outros líquidos utilizados para os mesmos fins','Anti-knock preparations, oxidation inhibitors, gum inhibitors, viscosity improvers, anti-corrosive preparations and other prepared additives, for mineral oils (including gasoline) or for other liquids used for the same purposes as mineral oils','Preparaciones antidetonantes, inhibidores de oxidación, aditivos peptizantes, mejoradores de viscosidad, anticorrosivos y demás aditivos preparados para aceites minerales, incluida la gasolina u otros líquidos utilizados para los mismos fines que los acei',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3812,'Preparações denominadas « aceleradores de vulcanização »; plastificantes compostos para borracha ou plástico, não especificados nem compreendidos em outras posições; preparações antioxidantes e outros estabilizadores compostos, para borracha ou plástico','Prepared rubber accelerators; compound plasticisers for rubber or plastics, not elsewhere specified or included; anti-oxidising preparations and other compound stabilisers for rubber or plastics','Aceleradores de vulcanización preparados; plastificantes compuestos para caucho o para plástico, no expresados ni comprendidos en otra parte; preparaciones antioxidantes y demás estabilisantes compuestos para caucho o plástico',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3813,'Composições e cargas para aparelhos extintores; granadas e bombas extintoras','Preparations and charges for fire-extinguishers etc','Preparaciones y cargas para aparatos extintores de fuego, etc',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3814,'Solventes e diluentes orgânicos compostos; preparações para remover tintas ou vernizes','Organic composite solvents and thinners','Orgánicos disolventes y diluyentes compuestos',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3815,'Iniciadores de reacção, aceleradores de reacção e preparações catalíticas, não especificados nem compreendidos em outras posições','Reaction initiators, reaction accelerators and catalytic preparations, not elsewhere specified or included','Iniciadores y aceleradores de reacción y preparaciones catalíticas, no expresados ni comprendidos en otra parte',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3816,'Cimentos, argamassas, concretos e composições semelhantes, refratários','Refractory cements, mortars, concretes, etc.','Cementos, morteros, hormigones, etc',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3817,'Misturas de alquilbenzenos ou de alquilnaftalenos','Mixed alkylbenzenes and mixed alkylnaphthalenes','Mezclas de alquilbencenos y alquilnaftalenos',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3818,'Elementos químicos impurificados, para utilização eletrônica','Chemical elements doped, used in electron, discs wafers etc.','Elementos químicos dopados, utilizado en electrónica, obleas de discos, etc',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3819,'Líquidos p/freios hidráulicos, etc.c/óleos petróleo<=70%','Liquids for hydraulic brakes, etc.with petr.oils<=70%','Líquidos para frenos hidráulicos, etc.c/aceit.petróleo<=70%',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3820,'Prepars.anticongelantes/líquidos prepar.p/descongelacao','Anti-freezing preparations and prepared de-icing fluids','Prepars.anticongelantes/líquidos prepar.p/descongelar',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3821,'Meios de cultura prepars.p/desenvolv.de microrganismos','Prepared culture media for devel of microorganisms','Medios de cultivo prepars. para desarrollo de microrgs.',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3822,'Reagentes de diagnóstico ou de laboratório, em qualquer suporte ou preparados, exceto os das posições 3002 ou 3006; materiais de referência certificados','Composite diagnostic/lab reagents, except pharmaceutical preparations of heading 3002 or 3006','Compuestos para diagnóstico / laboratorio de reactivos, a excepción de los preparados farmacéuticos de la partida 3002 o 3006',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3823,'Ácidos gordos monocarboxílicos industriais; óleos ácidos de refinação; alcoóis gordos industriais','Industrial monocarboxylic fatty acids; acid oils from refining; industrial fatty alcohols','Ácidos grasos monocarboxílicos industriales; aceites ácidos del refinado; alcoholes grasos industriales',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3824,'Aglutinantes preparados para moldes ou para núcleos de fundição; produtos químicos e preparações das indústrias químicas ou das indústrias conexas (incluídos os constituídos por misturas de produtos naturais), não especificados nem compreendidos noutras p','Prepared binders for foundry moulds or cores; chemical products and preparations of the chemical or allied industries (including those consisting of mixtures of natural products), not elsewhere specified or included','Preparaciones aglutinantes para moldes o para núcleos de fundición; productos químicos y preparaciones de la industria química o de las industrias conexas (incluidas las mezclas de productos naturales), no expresados ni comprendidos en otra parte',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3825,'Produtos residuais das indústrias químicas ou das indústrias conexas, não especificados nem compreendidos em outras posições; resíduos municipais; lamas de depuração; outros resíduos mencionados na Nota 6 do presente capítulo','Residual products of the chemical or allied industries, not elsewhere specified or included; municipal waste; sewage sludge; other wastes specified in note 6 to this chapter','Productos residuales de la industria química o de las industrias conexas, no expresados ni comprendidos en otra parte; desperdicios urbanos (municipales); lodos de depuración; los demás desperdicios mencionados en la Nota 6 de este capítulo',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3826,'Biodiesel e suas misturas,c/>70% peso de pet.ou min.bet','Biodiesel and its blends','Biodiesel e suas misturas',38);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3901,'Polímeros de etileno, em formas primárias','Polymers of ethylene, in primary forms','Polímeros de etileno en formas primarias',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3902,'Polímeros de propileno ou de outras olefinas, em formas primárias','Polymers of propylene or of other olefins, in primary forms','Polímeros de propileno o de otras olefinas, en formas primarias',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3903,'Polímeros de estireno, em formas primárias','Polymers of styrene, in primary forms','Polímeros de estireno en formas primarias',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3904,'Polímeros de cloreto de vinilo ou de outras olefinas halogenadas, em formas primárias','Polymers of vinyl chloride or of other halogenated olefins, in primary forms','Polímeros de cloruro de vinilo o de otras olefinas halogenadas, en formas primarias',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3905,'Polímeros de acetato de vinilo ou de outros ésteres de vinilo, em formas primárias; outros polímeros de vinilo, em formas primárias','Polymers of vinyl acetate or of other vinyl esters, in primary forms; other vinyl polymers in primary forms','Polímeros de acetato de vinilo o de otros ésteres vinílicos, en formas primarias; los demás polímeros vinílicos en formas primarias',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3906,'Polímeros acrílicos, em formas primárias','Acrylic polymers in primary forms','Polímeros acrílicos en formas primarias',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3907,'Poliacetais, outros poliéteres e resinas epóxidas, em formas primárias; policarbonatos, resinas alquídicas, poliésteres alílicos e outros poliésteres, em formas primárias','Polyacetals, other polyethers and epoxide resins, in primary forms; polycarbonates, alkyd resins, polyallyl esters and other polyesters, in primary forms','Poliacetales, los demás poliéteres y resinas epoxi, en formas primarias; policarbonatos, resinas alcídicas, poliésteres alílicos y demás poliésteres, en formas primarias',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3908,'Poliamidas em formas primárias','Polyamides in primary forms','Poliamidas en formas primarias',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3909,'Resinas amínicas, resinas fenólicas e poliuretanos, em formas primárias','Amino-resins, phenolic resins and polyurethanes, in primary forms','Resinas amínicas, resinas fenólicas y poliuretanos, en formas primarias',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3910,'Silicones, em formas primárias','Silicones, in primary forms','Siliconas en formas primarias',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3911,'Resinas de petróleo, resinas de cumarona-indeno, politerpenos, polissulfuretos, polissulfonas e outros produtos mencionados na Nota 3 do presente capítulo, não especificados nem compreendidos em outras posições, em formas primárias','Petroleum resins, coumarone-indene resins, polyterpenes, polysulphides, polysulphones and other products specified in note 3 to this chapter, not elsewhere specified or included, in primary forms','Resinas de petróleo, resinas de cumarona-indeno, politerpenos, polisulfuros, polisulfonas y demás productos previstos en la nota 3 de este capítulo, no expresados ni comprendidos en otra parte, en formas primarias',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3912,'Celulose e seus derivados químicos, não especificados nem compreendidos em outras posições, em formas primárias','Cellulose and its chemical derivatives, not elsewhere specified or included, in primary forms','Celulosa y sus derivados químicos, no expresados ni comprendidos en otra parte, en formas primarias',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3913,'Polímeros naturais (por exemplo: ácido algínico) e polímeros naturais modificados (por exemplo: proteínas endurecidas, derivados químicos da borracha natural), não especificados nem compreendidos em outras posições, em formas primárias','Natural polymers (for example, alginic acid) and modified natural polymers (for example, hardened proteins, chemical derivatives of natural rubber), not elsewhere specified or included, in primary forms','Polímeros naturales (por ejemplo: ácido algínico) y polímeros naturales modificados (por ejemplo: proteínas endurecidas, derivados químicos del caucho natural), no expresados ni comprendidos en otra parte, en formas primarias',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3914,'Permutadores de íons à base de polímeros, em formas primárias','Ion-exchangers based on plastics, in primary forms','Intercambiadores de iones a base de plásticos, en formas primarias',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3915,'Desperdícios, resíduos e aparas, de plástico','Waste, parings and scrap, of plastics','Desechos, desperdicios y recortes , de plástico',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3916,'Monofilamentos cuja maior dimensão do corte transversal seja superior a 1 mm (monofios), varas, bastões e perfis, mesmo trabalhados à superfície mas sem qualquer outro trabalho, de plásticos','Monofilament of which any cross-sectional dimension exceeds 1 mm, rods, sticks and profile shapes, whether or not surface-worked but not otherwise worked, of plastics','Monofilamentos cuya mayor dimensión del corte transversal sea superior a 1 mm, barras, varillas y perfiles, incluso trabajados en la superficie pero sin otra labor, de plástico',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3917,'Tubos e seus acessórios (por exemplo: juntas, cotovelos, flanges, uniões), de plástico','Tubes, pipes and hoses, and fittings therefor (for example, joints, elbows, flanges), of plastics','Tubos y accesorios de tubería (por ejemplo: juntas, codos, empalmes [racores]), de plástico',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3918,'Revestimentos de pavimentos, de plástico, mesmo auto-adesivos, em rolos ou em forma de ladrilhos ou de mosaicos; revestimentos de paredes ou de tectos, de plásticos, definidos na Nota 9 do presente capítulo','Floor coverings of plastics, whether or not self-adhesive, in rolls or in the form of tiles; wall or ceiling coverings of plastics, as defined in note 9 to this chapter','Revestimientos de plástico para suelos, incluso autoadhesivos, en rollos o losetas; revestimientos de plástico para paredes o techos, definidos en la nota 9 de este capítulo',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3919,'Chapas, folhas, tiras, fitas, películas e outras formas planas, auto-adesivas, de plástico, mesmo em rolos','Self-adhesive plates, sheets, film, foil, tape, strip and other flat shapes, of plastics, whether or not in rolls','Placas, láminas, hojas, cintas, tiras y demás formas planas, autoadhesivas, de plástico, incluso en rollos',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3920,'Outras chapas, folhas, películas, tiras e lâminas, de plástico não alveolar, não reforçadas nem estratificadas, sem suporte, nem associadas a outras matérias','Other plates, sheets, film, foil and strip, of plastics, non-cellular and not reinforced, laminated, supported or similarly combined with other materials','Las demás placas, láminas, hojas y tiras, de plástico no celular y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3921,'Outras chapas, folhas, películas, tiras e lâminas, de plástico','Other plates, sheets, film, foil and strip, of plastics','Las demás placas, láminas, hojas y tiras, de plástico',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3922,'Banheiras, « chuveiros », pias, lavatórios, bidés, sanitários e seus assentos e tampas, caixas de descarga (autoclismos) e artigos semelhantes para usos sanitários ou higiénicos, de plástico','Baths, shower-baths, sinks, wash-basins, bidets, lavatory pans, seats and covers, flushing cisterns and similar sanitary ware, of plastics','Bañeras, duchas, fregaderos (piletas de lavar), lavabos, bidés, inodoros y sus asientos y tapas, cisternas (depósitos de agua) para inodoros y artículos sanitarios o higiénicos similares, de plástico',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3923,'Artigos de transporte ou de embalagem, de plástico; rolhas, tampas, cápsulas e outros dispositivos destinados a fechar recipientes, de plástico','Articles for the conveyance or packing of goods, of plastics; stoppers, lids, caps and other closures, of plastics','Artículos para el transporte o envasado, de plástico; tapones, tapas, cápsulas y demás dispositivos de cierre, de plástico',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3924,'Serviços de mesa e outros artigos de uso doméstico, de higiene ou de toucador, de plástico','Tableware, kitchenware, other household articles and toilet articles, of plastics','Vajilla y demás artículos de uso doméstico y artículos de higiene o de tocador, de plástico',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3925,'Artefactos para apetrechamento de construções, de plástico, não especificados nem compreendidos em outras posições','Builders'' ware of plastics, not elsewhere specified or included','Artículos para la construcción, de plástico, no expresados ni comprendidos en otra parte',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (3926,'Outras obras de plástico e obras de outras matérias das posições 3901 a 3914','Other articles of plastics and articles of other materials of headings 3901 to 3914','Demás manufacturas de plástico y manufacturas de las demás materias de las partidas 3901 a 3914',39);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4001,'Borracha natural, balata, guta-percha, guaiúle, chicle e gomas naturais análogas, em formas primárias ou em chapas, folhas ou tiras','Natural rubber, balata, gutta-percha, guayule, chicle and similar natural gums, in primary forms or in plates, sheets or strip','Caucho natural, balata, gutapercha, guayule, chicle y gomas naturales análogas, en formas primarias o en placas, hojas o tiras',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4002,'Borracha sintética e borracha artificial derivada dos óleos, em formas primárias ou em chapas, folhas ou tiras; misturas dos produtos da posição 4001 com produtos da presente posição, em formas primárias ou em chapas, folhas ou tiras','Synthetic rubber and factice derived from oils, in primary forms or in plates, sheets or strip; mixtures of any product of heading No 4001 with any product of this heading, in primary forms or in plates, sheets or strip','Caucho sintético y caucho facticio derivado de los aceites, en formas primarias o en placas, hojas o tiras; mezclas de productos de la partida 4001 con los de esta partida, en formas primarias o en placas, hojas o tiras',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4003,'Borracha regenerada, em formas primárias ou chapas, etc.','Reclaimed rubber in primary forms or in plates, etc.','Caucho regenerado, en formas primarias o placas, etc.',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4004,'Desperdícios, resíduos, etc.de borracha não endurecida','Waste,  parings, etc.of rubber n/hardened','Desechos, desperdicios, etc.de caucho sin endurecer',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4005,'Borracha misturada, não vulcanizada, em formas primárias ou em chapas, folhas ou tiras','Compounded rubber, unvulcanised, in primary forms or in plates, sheets or strip','Caucho mezclado sin vulcanizar, en formas primarias o en placas, hojas o tiras',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4006,'Outras formas (por exemplo: varetas, tubos, perfis) e artigos (por exemplo: discos e anilhas (arruelas)) de borracha não vulcanizada','Other forms (for example, rods, tubes and profile shapes) and articles (for example, discs and rings), of unvulcanised rubber','Las demás formas (por ejemplo: varillas, tubos, perfiles) y artículos (por ejemplo: discos, arandelas), de caucho sin vulcanizar',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4007,'Fios e cordas, de borracha vulcanizada','Vulcanized rubber thread and cord','Caucho vulcanizado hilos y cuerdas',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4008,'Chapas, folhas, tiras, varetas e perfis, de borracha vulcanizada não endurecida','Plates, sheets, strip, rods and profile shapes, of vulcanised rubber other than hard rubber','Placas, hojas, tiras, varillas y perfiles, de caucho vulcanizado sin endurecer',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4009,'Tubos de borracha vulcanizada não endurecida, mesmo providos dos respectivos acessórios (por exemplo: juntas, cotovelos, flanges, uniões)','Tubes, pipes and hoses, of vulcanised rubber other than hard rubber, with or without their fittings (for example, joints, elbows, flanges)','Tubos de caucho vulcanizado sin endurecer, incluso con sus accesorios (por ejemplo: juntas, codos, empalmes [racores])',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4010,'Correias transportadoras ou de transmissão, de borracha vulcanizada','Conveyor or transmission belts or belting, of vulcanised rubber','Correas transportadoras o de transmisión, de caucho vulcanizado',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4011,'Pneumáticos novos, de borracha','New pneumatic tyres, of rubber','Neumáticos (llantas neumáticas) nuevos de caucho',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4012,'Pneumáticos recauchutados ou usados, de borracha; protectores, bandas de rodagem para pneumáticos e flaps, de borracha','Retreaded or used pneumatic tyres of rubber; solid or cushion tyres, tyre treads and tyre flaps, of rubber','Neumáticos (llantas neumáticas) recauchutados o usados, de caucho; bandajes (llantas macizas o huecas), bandas de rodadura para neumáticos (llantas neumáticas) y protectores («flaps»), de caucho',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4013,'Câmaras-de-ar de borracha','Inner tubes, of rubber','Cámaras de caucho para neumáticos (llantas neumáticas)',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4014,'Artigos de higiene ou de farmácia (incluídas as chupetas), de borracha vulcanizada não endurecida, mesmo com partes de borracha endurecida','Hygienic or pharmaceutical articles (including teats), of vulcanised rubber other than hard rubber, with or without fittings of hard rubber','Artículos de higiene o de farmacia, comprendidas las tetinas, de caucho vulcanizado sin endurecer, incluso con partes de caucho endurecido',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4015,'Vestuário e seus acessórios (incluídas as luvas, mitenes e semelhantes), de borracha vulcanizada não endurecida, para quaisquer usos','Articles of apparel and clothing accessories (including gloves, mittens and mitts), for all purposes, of vulcanised rubber other than hard rubber','Prendas de vestir, guantes, mitones y manoplas y demás complementos (accesorios) de vestir, para cualquier uso, de caucho vulcanizado sin endurecer',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4016,'Outras obras de borracha vulcanizada não endurecida','Other articles of vulcanised rubber other than hard rubber','Las demás manufacturas de caucho vulcanizado sin endurecer',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4017,'Borracha endurecida e obras de borracha endurecida','Hard rubber and other articles of hard rubber','Caucho endurecido y manufacturas de caucho endurecido',40);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4101,'Couros e peles em bruto de bovinos (incluindo os búfalos) ou de equídeos (frescos, ou salgados, secos, tratados pela cal, « piclados » ou conservados de outro modo, mas não curtidos, nem apergaminhados nem preparados de outro modo), mesmo depilados ou div','Raw hides and skins of bovine (including buffalo) or equine animals (fresh, or salted, dried, limed, pickled or otherwise preserved, but not tanned, parchment-dressed or further prepared), whether or not dehaired or split','Cueros y pieles en bruto, de bovino, incluido el búfalo, o de equino (frescos o salados, secos, encalados, piquelados o conservados de otro modo, pero sin curtir, apergaminar ni preparar de otra forma), incluso depilados o divididos',41);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4102,'Peles em bruto de ovinos (frescas, ou salgadas, secas, tratadas pela cal, « picladas » ou conservadas de outro modo, mas não curtidas, nem apergaminhadas, nem preparadas de outro modo), mesmo depiladas ou divididas, com excepção das excluídas pela Nota 1 ','Raw skins of sheep or lambs (fresh, or salted, dried, limed, pickled or otherwise preserved, but not tanned, parchment-dressed or further prepared), whether or not with wool on or split, other than those excluded by note 1 (c) to this chapter','Cueros y pieles en bruto, de ovino (frescos o salados, secos, encalados, piquelados o conservados de otro modo, pero sin curtir, apergaminar ni preparar de otra forma), incluso depilados o divididos (excepto los excluidos por la nota 1 c) de este capítulo',41);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4103,'Outros couros e peles em bruto (frescos, ou salgados, secos, tratados pela cal, « piclados » ou conservados de outro modo, mas não curtidos, nem apergaminhados nem preparados de outro modo), mesmo depilados ou divididos, com excepção das excluídos pela No','Other raw hides and skins (fresh, or salted, dried, limed, pickled or otherwise preserved, but not tanned, parchment-dressed or further prepared), whether or not dehaired or split, other than those excluded by note 1 (b) or 1 (c) to this chapter','Los demás cueros y pieles, en bruto (frescos o salados, secos, encalados, piquelados o conservados de otro modo, pero sin curtir, apergaminar ni preparar de otra forma), incluso depilados o divididos, excepto los excluidos por las notas 1 b) ó 1 c) de est',41);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4104,'Couros e peles curtidos ou em crosta, de bovinos (incluindo os búfalos) ou de equídeos, depilados, mesmo divididos, mas não preparados de outro modo','Tanned or crust hides and skins of bovine (including buffalo) or equine animals, without hair on, whether or not split, but not further prepared','Cueros y pieles curtidos o crust, de bovino, incluido el búfalo, o de equino, depilados, incluso divididos pero sin otra preparación',41);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4105,'Peles curtidas ou em crosta de ovinos, depiladas, mesmo divididas, mas não preparadas de outro modo','Tanned or crust skins of sheep or lamb, without wool on, whether or not split, but not further prepared','Pieles curtidas o crust, de ovino, depiladas, incluso divididas, pero sin otra preparación',41);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4106,'Couros e peles, depilados, de outros animais e peles de animais desprovidos de pêlos, curtidos ou em crosta, mesmo divididos, mas não preparados de outro modo','Tanned or crust hides and skins of other animals, without wool or hair on, whether or not split, but not further prepared','Cueros y pieles depilados de los demás animales y cueros y pieles de animales son pelo, curtidos o crust, incluso divididos, pero sin preparar de otra forma',41);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4107,'Couros preparados após curtimenta ou após secagem e couros e peles apergaminhados, de bovinos (incluindo os búfalos) ou de equídeos, depilados, mesmo divididos, exceto os da posição 4114','Leather further prepared after tanning or crusting, including parchment-dressed leather, of bovine (including buffalo) or equine animals, without hair on, whether or not split, other than leather of heading 4114','Cueros preparados después del curtido o del secado y cueros y pieles apergaminados, de bovino, incluido el búfalo, o de equino, depilados, incluso divididos (excepto los de la partida 4114)',41);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4108,'Couros e peles, acamurçados, inclusive a camurça combinada','Leathers and skins, chamois, including combined chamois','Cueros y pieles, agumuzados, incl.el agumuzado combinado',41);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4109,'Couros e peles, envernizados, revestidos ou metalizados','Patent & patent laminated leather, metallized leather','Cueros y pieles, barnizados, revestidos o metalizados',41);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4110,'Aparas e outros desperd.de couros/peles, preparados, etc.','Leathers and skins, chips and other wastes, prepar.etc.','Recortes y demás desperd.de cueros/pieles, prepars., etc',41);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4111,'Couro reconstituido em chapas, folhas ou tiras','Leather reconstituted in foils, leaves or strips','Cuero regenerado en placas, hojas o tiras',41);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4112,'Couros ovinos, prepars.apos curtimenta, etc.','Leather further prepared after tanning, of sheep, etc.','Cueros de ovinos, prepars.despúes del curtido, etc.',41);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4113,'Couros preparados após curtimenta ou após secagem e couros e peles apergaminhados, de outros animais, depilados, e couros preparados após curtimenta e couros e peles apergaminhados, de animais desprovidos de pêlos, mesmo divididos, exceto os da posição 4','Leather further prepared after tanning or crusting, including parchment-dressed leather, of other animals, without wool or hair on, whether or not split, other than leather of heading 4114','Cueros preparados después del curtido o del secado y cueros y pieles apergaminados, de los demás animales, depilados, y cueros y pieles preparados después del curtido y cueros y pieles apergaminados, de animales sin pelo, incluso divididos (excepto los de',41);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4114,'Couros e peles acamurçados (incluída a camurça combinada); couros e peles envernizados ou revestidos; couros e peles metalizados','Chamois (including combination chamois) leather; patent leather and patent laminated leather; metallised leather','Cueros y pieles agamuzados, incluido el agamuzado combinado al aceite; cueros y pieles charolados y sus imitaciones de cueros o pieles chapados; cueros y pieles metalizados',41);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4115,'Couro reconstituído à base de couro ou de fibras de couro, em chapas, folhas ou tiras, mesmo enroladas; aparas e outros desperdícios de couros ou de peles preparados ou de couro reconstituído, não utilizáveis para fabricação de obras de couro; serragem, p','Composition leather with a basis of leather or leather fibre, in slabs, sheets or strip, whether or not in rolls; parings and other waste of leather or of composition leather, not suitable for the manufacture of leather articles; leather dust, powder and ','Cuero regenerado a base de cuero o de fibras de cuero, en placas, hojas o tiras, incluso enrolladas; recortes y demás desperdicios de cuero o piel, preparados, o de cuero regenerado, inutilizables para la fabricación de manufacturas de cuero; aserrín, pol',41);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4201,'Artigos de seleiro ou de correeiro para animais, de quaisquer matérias','Saddlery, harness, traces, leads etc, any material','Guarnicionería, talabartería, rastros, etc conduce, cualquier material',42);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4202,'Malas e maletas, incluídas as de toucador e as maletas e pastas para documentos e de estudantes, os estojos para óculos, binóculos, máquinas fotográficas e de filmar, instrumentos musicais, armas, e artefactos semelhantes; sacos de viagem, sacos isolantes','Trunks, suit-cases, vanity-cases, executive-cases, brief-cases, school satchels, spectacle cases, binocular cases, camera cases, musical instrument cases, gun cases, holsters and similar containers; travelling-bags, insulated food or beverage bags, toilet','Baúles, maletas (valijas), maletines, incluidos los de aseo y los portadocumentos, portafolios (carteras de mano), cartapacios, fundas y estuches para gafas (anteojos), binoculares, cámaras fotográficas o cinematográficas, instrumentos musicales o armas y',42);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4203,'Vestuário e seus acessórios, de couro natural ou reconstituído','Articles of apparel and clothing accessories, of leather or of composition leather','Prendas y complementos (accesorios) de vestir, de cuero natural o cuero regenerado',42);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4204,'Artigos de couro usados em máquinas/aplicações mecânicas','Articles of leather used in machinery/mech appliances','Artículos de cuero usados en maquinaria / aplicaciones mecánicas',42);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4205,'Outras obras de couro natural ou reconstituido','Other articles of leather or of composition leather','Otras manufacturas de cuero natural o regenerado',42);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4206,'Obras de tripa, de baudruches, de bexiga ou de tendões','Articles of gut (other than silkworm gut), of goldbeater''s skin, of bladders or of tendons','Manufacturas de tripa, vejigas o tendones',42);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4301,'Peles com pêlo em bruto (incluídas as cabeças, caudas, patas e outras partes, utilizáveis na indústria de peles), exceto as peles em bruto das posições 4101, 4102 ou 4103','Raw furskins (including heads, tails, paws and other pieces or cuttings, suitable for furriers'' use), other than raw hides and skins of heading No 4101, 4102 or 4103','Peletería en bruto, incluidas las cabezas, colas, patas y demás trozos utilizables en peletería (excepto las pieles en bruto de las partidas 4101, 4102 ó 4103)',43);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4302,'Peles com pêlo curtidas ou acabadas (incluídas as cabeças, caudas, patas e outras partes, desperdícios e aparas), não reunidas (não montadas) ou reunidas (montadas) sem adição de outras matérias, com excepção das da posição 4303','Tanned or dressed furskins (including heads, tails, paws and other pieces or cuttings), unassembled, or assembled (without the addition of other materials) other than those of heading No 4303','Peletería curtida o adobada, incluidas las cabezas, colas, patas y demás trozos, desechos y recortes, incluso ensamblada (sin otras materias), (excepto la de la partida 4303)',43);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4303,'Vestuário, seus acessórios e outros artefactos de peles com pêlo','Articles of apparel, clothing accessories and other articles of furskin','Prendas y complementos (accesorios), de vestir, y demás artículos de peletería',43);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4304,'Peleteria artificial e suas obras','Artificial fur and articles thereof','Peletería artificial y sus manufacturas',43);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4401,'Lenha em qualquer estado, madeira em estilhas ou em partículas; serradura, desperdícios e resíduos de madeira, mesmo aglomerados em bolas, briquetes, pellets ou em formas semelhantes','Fuel wood, in logs, in billets, in twigs, in faggots or in similar forms; wood in chips or particles; sawdust and wood waste and scrap, whether or not agglomerated in logs, briquettes, pellets or similar forms','Leña; madera en plaquitas o partículas; aserrín, desperdicios y desechos, de madera, incluso aglomerados en leños, briquetas, bolitas o formas similares',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4402,'Carvão vegetal (incluindo o carvão de cascas ou de caroços), mesmo aglomerado','Wood charcoal (including shell or nut charcoal), whether or not agglomerated','Carbón vegetal (incluido el carbón de conchas o piedras), incluso aglomerado',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4403,'Madeira em bruto, mesmo descascada, desalburnada ou esquadriada','Wood in the rough, whether or not stripped of bark or sapwood, or roughly squared','Madera en bruto, incluso descortezada, desalburada o escuadrada',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4404,'Arcos de madeira; estacas fendidas; estacas aguçadas, não serradas longitudinalmente; madeira simplesmente desbastada ou arredondada, não torneada, não recurvada nem trabalhada de qualquer outro modo, para fabricação de bengalas, guarda-chuvas, cabos de f','Hoopwood; split poles; piles, pickets and stakes of wood, pointed but not sawn lengthwise; wooden sticks, roughly trimmed but not turned, bent or otherwise worked, suitable for the manufacture of walking-sticks, umbrellas, tool handles or the like; chipwo','Flejes de madera; rodrigones hendidos; estacas y estaquillas de madera, apuntadas, sin aserrar longitudinalmente; madera simplemente desbastada o redondeada, pero sin tornear, curvar ni trabajar de otro modo, para bastones, paraguas, mangos de herramienta',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4405,'Lã de madeira e farinha de madeira','Wood wool and wood flour','Lana de madera y harina de madera',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4406,'Dormentes de madeira para vias férreas ou semelhantes','Railway or tramway sleepers (cross-ties) of wood','Traviesas (durmientes) de madera para vías férreas o similares',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4407,'Madeira serrada ou endireitada longitudinalmente, cortada ou desenrolada, mesmo aplainada, polida ou unida pelas extremidades, de espessura superior a 6 mm','Wood sawn or chipped lengthwise, sliced or peeled, whether or not planed, sanded or end-jointed, of a thickness exceeding 6 mm','Madera aserrada o desbastada longitudinalmente, cortada o desenrollada, incluso cepillada, lijada o unida por los extremos, de espesor superior a 6 mm',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4408,'Folhas para folheados (incluindo as obtidas por corte de madeira estratificada), folhas para contraplacados ou compensados ou para outras madeiras estratificadas semelhantes e madeira serrada longitudinalmente, cortada ou desenrolada, mesmo aplainada, pol','Sheets for veneering (including those obtained by slicing laminated wood), for plywood or for other similar laminated wood and other wood, sawn lengthwise, sliced or peeled, whether or not planed, sanded, spliced or end-jointed, of a thickness not exceedi','Hojas para chapado, incluidas las obtenidas por corte de madera estratificada, para contrachapado o para otra madera estratificada similar y demás madera, aserrada longitudinalmente, cortada o desenrollada, incluso cepillada, lijada o unida longitudinalme',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4409,'Madeira (incluídos os tacos e frisos para soalhos, não montados) perfilada (com espigas, ranhuras, filetes, entalhes, chanfrada, com juntas em V, com cercadura, boleada ou semelhantes) ao longo de uma ou mais bordas, faces ou extremidades, mesmo aplainada','Wood (including strips and friezes for parquet flooring, not assembled) continuously shaped (tongued, grooved, rebated, chamfered, V-jointed, beaded, moulded, rounded or the like) along any of its edges, ends or faces, whether or not planed, sanded or end','Madera, incluidas las tablillas y frisos para parqués, sin ensamblar, perfilada longitudinalmente (con lengüetas, ranuras, rebajes, acanalados, biselados, con juntas en V, moldurados, redondeados o similares) en una o varias caras, cantos o extremos, incl',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4410,'Painéis de partículas e painéis semelhantes (por exemplo, painéis denominados «  oriented strand board » e painéis denominados «  waferboard »), de madeira ou de outras matérias lenhosas, mesmo aglomeradas com resinas ou com outros aglutinantes orgânicos','Particle board and similar board (for example, oriented strand board and waferboard) of wood or other ligneous materials, whether or not agglomerated with resins or other organic binding substances','Tableros de partículas y tableros similares (por ejemplo: oriented strand board y waferboard), de madera u otras materias leñosas, incluso aglomeradas con resinas o demás aglutinantes orgánicos',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4411,'Painéis de fibras de madeira ou de outras matérias lenhosas, mesmo aglomeradas com resinas ou com outros aglutinantes orgânicos','Fibreboard of wood or other ligneous materials, whether or not bonded with resins or other organic substances','Tableros de fibra de madera u otras materias leñosas, incluso aglomerados con resinas u otros aglutinantes orgánicos',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4412,'Madeira contraplacada ou compensada, madeira folheada, e madeiras estratificadas semelhantes','Plywood, veneered panels and similar laminated wood','Madera contrachapada, madera chapada y madera estratificada similar',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4413,'Madeira "densificada", em blocos, pranchas, laminas, perfis','Densified wood, in blocks, plates, strips, profile','Madera densificada, en bloques, tablas, tiras, perfiles',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4414,'Molduras de madeira, p/quadros, fotografias, espelhos, etc.','Wooden frames, forpaintings, photographs, mirrors, etc','Marcos de madera, p/cuadros, fotografías, espejos, etc.',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4415,'Caixotes, caixas, engradados, barricas e embalagens semelhantes, de madeira; carretéis para cabos, de madeira; paletes simples, « paletes-caixas » e outros estrados para carga, de madeira; taipais de paletes de madeira','Packing cases, boxes, crates, drums and similar packings, of wood; cable-drums of wood; pallets, box pallets and other load boards, of wood; pallet collars of wood','Cajones, cajas jaulas, tambores y envases similares, de madera; carretes para cables, de madera; paletas, paletas caja y demás plataformas para carga, de madera; collarines para paletas, de madera',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4416,'Barris, cubas, balsas, dornas e outras obras de tanueiro, de madeira','Casks, barrels, vats, etc. and parts, of wood','Barriles, cubas, etc y sus partes, de madera',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4417,'Ferramentas, armações e cabos de ferramentas, de escovas e de vassouras, de madeira; formas, alargadeiras e esticadores, de madeira, para calçados','Tools, tool and broom bodies etc shoe last/trees wood','Herramientas, las herramientas y la escoba de zapatos, etc cuerpos última / madera',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4418,'Obras de carpintaria para construções, incluídos os painéis celulares, os painéis para soalhos e as fasquias para telhados (shingles e shakes), de madeira','Builders'' joinery and carpentry of wood, including cellular wood panels, assembled parquet panels, shingles and shakes','Obras y piezas de carpintería para construcciones, incluidos los tableros celulares, los tableros para parqués y tablillas para cubierta de tejados o fachadas (shingles y shakes), de madera',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4419,'Artefatos de madeira, para mesa ou cozinha','Tableware and kitchenware, of wood','Artículos de mesa o de cocina, de madera',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4420,'Madeira marchetada e madeira incrustada; estojos e guarda-jóias, para joalharia e ourivesaria, e obras semelhantes, de madeira; estatuetas e outros objectos de ornamentação, de madeira; artigos de mobiliário, de madeira, que não se incluam no Capítulo 94','Wood marquetry and inlaid wood; caskets and cases for jewellery or cutlery, and similar articles, of wood; statuettes and other ornaments, of wood; wooden articles of furniture not falling in Chapter 94','Marquetería y taracea; cofrecillos y estuches para joyería u orfebrería y manufacturas similares, de madera; estatuillas y demás objetos de adorno, de madera; artículos de mobiliario, de madera, no comprendidos en el capítulo 94',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4421,'Outras obras de madeira','Other articles of wood','Otras manufacturas de madera',44);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4501,'Cortiça natural em bruto ou simplesmente preparada; desperdícios de cortiça; cortiça triturada, granulada ou pulverizada','Natural cork, raw or simply prepared; waste cork; crushed, granulated or ground cork','Corcho natural en bruto o simplemente preparado; desperdicios de corcho; corcho triturado, granulado o pulverizado',45);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4502,'Cortiça natural, sem a crosta/esquadriada/em cubos, etc.','Natural cork, debacked/roughly squared/in rectang.etc','Corcho natural, descortezado/escuadrado/en bloques, etc.',45);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4503,'Obras de cortiça natural','Articles of natural cork','Manufacturas de corcho natural',45);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4504,'Cortiça aglomerada (com ou sem aglutinantes) e suas obras','Agglomerated cork (with or without a binding substance) and articles of agglomerated cork','Corcho aglomerado, incluso con aglutinante, y manufacturas de corcho aglomerado',45);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4601,'Tranças e artigos semelhantes, de matérias para entrançar, mesmo reunidos em tiras; matérias para entrançar, tranças e artigos semelhantes, de matérias para entrançar, tecidos ou paralelizados, em formas planas, mesmo acabados (por exemplo: esteiras, capa','Plaits and similar products of plaiting materials, whether or not assembled into strips; plaiting materials, plaits and similar products of plaiting materials, bound together in parallel strands or woven, in sheet form, whether or not being finished artic','Trenzas y artículos similares, de materia trenzable, incluso ensamblados en tiras; materia trenzable, trenzas y artículos similares de materia trenzable, tejidos o paralelizados, en forma plana, incluso terminados (por ejemplo: esterillas, esteras, cañizo',46);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4602,'Obras de cestaria obtidas directamente na sua forma a partir de matérias para entrançar ou fabricadas com os artigos da posição 4601; obras de lufa','Basketwork, wickerwork and other articles, made directly to shape from plaiting materials or made-up from goods of heading No 4601; articles of loofah','Artículos de cestería obtenidos directamente en su forma con materia trenzable o confeccionados con artículos de la partida 4601; manufacturas de esponja vegetal (paste o lufa)',46);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4701,'Pastas mecânicas de madeira','Mechanical wood pulp','Pastas mecánicas de madera',47);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4702,'Pasta química de madeira, para dissolução','Chemical wood pulp, dissolving grades','Pasta química de madera para disolver',47);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4703,'Pastas químicas de madeira, à soda ou ao sulfato, exceto pastas para dissolução','Chemical wood pulp, soda or sulphate, other than dissolving grades','Pasta química de madera a la sosa (soda) o al sulfato (excepto la pasta para disolver)',47);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4704,'Pastas químicas de madeira, ao bissulfito, exceto pastas para dissolução','Chemical wood pulp, sulphite, other than dissolving grades','Pasta química de madera al sulfito (excepto la pasta para disolver)',47);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4705,'Pastas semiquímicas de madeira','Wood semi-chemical pulp','Pastas semiquímicas de madera',47);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4706,'Pastas de fibras obtidas a partir de papel ou de cartão reciclados (desperdícios e aparas) ou de outras matérias fibrosas celulósicas','Pulps of fibres derived from recovered (waste and scrap) paper or paperboard or of other fibrous cellulosic material','Pasta de fibras obtenidas de papel o cartón reciclado (desperdicios y desechos) o de las demás materias fibrosas celulósicas',47);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4707,'Papel ou cartão para reciclar (desperdícios e aparas)','Recovered (waste and scrap) paper or paperboard','Papel o cartón para reciclar (desperdicios y desechos)',47);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4801,'Papel jornal, em rolos ou em folhas','Newsprint, in rolls or sheets','Papel prensa en bobinas o en hojas',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4802,'Papel e cartão, não revestidos, dos tipos utilizados para escrita, impressão ou outros fins gráficos, e papel e cartão para fabricar cartões ou tiras perfurados, não perfurados, em rolos ou em folhas de forma quadrada ou rectangular, de qualquer formato o','Uncoated paper and paperboard, of a kind used for writing, printing or other graphic purposes, and non-perforated punch-cards and punch tape paper, in rolls or rectangular (including square) sheets, of any size, other than paper of heading No 4801 or 4803','Papel y cartón, sin estucar ni recubrir, del tipo de los utilizados para escribir, imprimir u otros fines gráficos, y papel y cartón para tarjetas o cintas para perforar, sin perforar, en bobinas (rollos) o en hojas de forma cuadrada o rectangular, de qua',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4803,'Papel para fabricação de papel higiênico ou de toucador e artigos semelhantes; pasta de celulose e mantas de fibras de celulose','Toilet etc household/santry stock paper roll/sheet ov 36cm','Aseo del hogar, etc / santry acciones del rollo de papel/hoja de 36cm ov',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4804,'Papel e cartão kraft, não revestidos, em rolos ou em folhas, exceto das posições 4802 e 4803','Uncoated kraft paper and paperboard, in rolls or sheets, other than that of heading No 4802 or 4803','Papel y cartón Kraft, sin estucar ni recubrir, en bobinas (rollos) o en hojas (excepto el de las partidas 4802 ó 4803)',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4805,'Outros papéis e cartões, não revestidos nem impregnados, em rolos ou em folhas, não tendo sofrido trabalho complementar nem tratamento, exceto os especificados na Nota 3 do presente Capítulo','Other uncoated paper and paperboard, in rolls or sheets, not further worked or processed than as specified in note 3 to this chapter','Los demás papeles y cartones, sin estucar ni recubrir, en bobinas (rollos) o en hojas, que no hayan sido sometidos a trabajos complementarios o tratamientos distintos de los especificados en la nota 3 de este capítulo',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4806,'Papel-pergaminho e cartão-pergaminho (sulfurizados), papel impermeável a gorduras, papel vegetal, papel cristal e outros papéis calandrados transparentes ou translúcidos, em rolos ou em folhas','Vegetable parchment, greaseproof papers, tracing papers and glassine and other glazed transparent or translucent papers, in rolls or sheets','Papel y cartón sulfurizados, papel resistente a las grasas, papel vegetal, papel cristal y demás papeles calandrados transparentes o traslúcidos, en bobinas (rollos) o en hojas',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4807,'Papel e cartão obtidos por colagem de folhas sobrepostas, não revestidos na superfície nem impregnados, mesmo reforçados interiormente, em rolos ou em folhas','Composite paper & paperboard, no surf coat, roll etc','Papel y cartón obtenidos por pegado de hojas superpuestas, recubierto o impregnado en la superficie, mismo reforzados interiormente, en bobinas o en hojas',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4808,'Papel e cartão canelados (ondulados) (mesmo recobertos por colagem), encrespados, plissados, gofrados, estampados ou perfurados, em rolos ou em folhas, exceto o papel dos tipos descritos no texto da posição 4803','Paper and paperboard, corrugated (with or without glued flat surface sheets), creped, crinkled, embossed or perforated, in rolls or sheets, other than paper of the kind described in heading No 4803','Papel y cartón corrugados, incluso revestidos por encolado, rizados (crepés), plisados, gofrados, estampados o perforados, en bobinas (rollos) o en hojas (excepto el papel de los tipos descritos en el texto de la partida 4803)',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4809,'Papel químico (papel carbono), papel autocopiativo e outros papéis para cópia ou duplicação (incluídos os papéis revestidos ou impregnados, para stencils ou para chapas offset), mesmo impressos, em rolos ou em folhas','Carbon paper, self-copy paper and other copying or transfer papers (including coated or impregnated paper for duplicator stencils or offset plates), whether or not printed, in rolls or sheets','Papel carbón (carbónico), papel autocopia y demás papeles para copiar o transferir, incluido el estucado o cuché, recubierto o impregnado, para clisés de mimeógrafo (stencils) o para planchas offset, incluso impresos, en bobinas (rollos) o en hojas',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4810,'Papel e cartão revestidos de caulino ou de outras substâncias inorgânicas numa ou nas duas faces, com ou sem aglutinantes, sem qualquer outro revestimento, mesmo coloridos à superfície, decorados à superfície ou impressos, em rolos ou em folhas de forma q','Paper and paperboard, coated on one or both sides with kaolin (china clay) or other inorganic substances, with or without a binder, and with no other coating, whether or not surface-coloured, surface-decorated or printed, in rolls or rectangular (includin','Papel y cartón estucados por una o las dos caras con caolín u otras sustancias inorgánicas, con aglutinante o sin él, con excusión de cualquier otro estucado o recubrimiento, incluso coloreados o decorados en la superficie o impresos, en bobinas (rollos) ',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4811,'Papel, cartão, pasta (ouate) de celulose e mantas de fibras de celulose, revestidos, impregnados, recobertos, coloridos à superfície, decorados à superfície ou impressos, em rolos ou em folhas de forma quadrada ou rectangular, de qualquer formato ou dimen','Paper, paperboard, cellulose wadding and webs of cellulose fibres, coated, impregnated, covered, surface-coloured, surface-decorated or printed, in rolls or rectangular (including square) sheets, of any size, other than goods of the kind described in head','Papel, cartón, guata de celulosa y napa de fibras de celulosa, estucados, recubiertos, impregnados o revestidos, coloreados o decorados en la superficie o impresos, en bobinas (rollos) o en hojas de forma cuadrada o rectangular, de qualquier tamaño, excep',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4812,'Blocos e chapas, filtrantes, de pasta de papel','Filter blocks, slabs and plates, of paper pulp','Bloques y placas, filtrantes, de pasta de papel',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4813,'Papel para cigarros, mesmo cortado nas dimensões próprias, em livros ou em tubos','Cigarette paper, whether or not cut to size or in the form of booklets or tubes','Papel de fumar, incluso cortado al tamaño adecuado, en librillos o en tubos',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4814,'Papel de parede e revestimentos de parede semelhantes; papel para vitrais','Wallpaper and similar wall coverings; window transparencies of paper','Papel para decorar y revestimientos similares de paredes; papel para vidrieras',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4815,'Revestimentos p/pavimentos, c/suporte de papel/de cartão','Floor coverings on a base of paper or of paperboard','Cubresuelos con soporte de papel o de cartón',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4816,'Papel químico, papel autocopiativo e outros papéis para cópia ou duplicação (exceto da posição 4809), stencils completos e chapasoffset, de papel, mesmo acondicionados em caixas','Carbon paper, self-copy paper and other copying or transfer papers (other than those of heading No 4809), duplicator stencils and offset plates, of paper, whether or not put up in boxes','Papel carbón (carbónico), papel autocopia y demás papeles para copiar o transferir (excepto los de la partida 4809), clisés de mimeógrafo («stencils») completos y planchas offset, de papel, incluso acondicionados en cajas',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4817,'Envelopes, aerogramas, bilhetes-postais não ilustrados, cartões e papéis para correspondência, de papel ou cartão; caixas, sacos e semelhantes, de papel ou cartão, contendo um sortido de artigos para correspondência','Envelopes, letter cards, plain postcards and correspondence cards, of paper or paperboard; boxes, pouches, wallets and writing compendiums, of paper or paperboard, containing an assortment of paper stationery','Sobres, sobrescarta, tarjetas postales sin ilustrar y tarjetas para correspondencia, de papel o cartón; cajas, bolsas y presentaciones similares, de papel o cartón, con un surtido de artículos de correspondencia',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4818,'Papel dos tipos utilizados para a fabricação de papéis higiénicos e de toucador e semelhantes, pasta (ouate) de celulose ou mantas de fibras de celulose, dos tipos utilizados para fins domésticos ou sanitários, em rolos de largura não superior a 36 cm, ou','Toilet paper and similar paper, cellulose wadding or webs of cellulose fibres, of a kind used for household or sanitary purposes, in rolls of a width not exceeding 36 cm, or cut to size or shape; handkerchiefs, cleansing tissues, towels, tablecloths, serv','Papel de los tipos utilizados para papel higiénico y papeles similares, guata de celulosa o napa de fibras de celulosa, de los tipos utilizados para fines domésticos o sanitarios, en bobinas (rollos) de una anchura inferior o igual a 36 cm o cortados en f',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4819,'Caixas, sacos, bolsas, cartuchos e outras embalagens, de papel, cartão, pasta (ouate) de celulose ou de mantas de fibras de celulose; cartonagens para escritórios, lojas e estabelecimentos semelhantes','Cartons, boxes, cases, bags and other packing containers, of paper, paperboard, cellulose wadding or webs of cellulose fibres; box files, letter trays, and similar articles, of paper or paperboard of a kind used in offices, shops or the like','Cajas, sacos (bolsas), bolsitas, cucuruchos y demás envases de papel, cartón, guata de celulosa o napas de fibras de celulosa; cartonajes de oficina, tienda o similares',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4820,'Livros de registo e de contabilidade, blocos de notas, de encomendas, de recibos, de apontamentos, de papel para cartas, agendas e artigos semelhantes, cadernos, pastas para documentos, classificadores, capas para encadernação (de folhas soltas ou outras)','Registers, account books, note books, order books, receipt books, letter pads, memorandum pads, diaries and similar articles, exercise books, blotting pads, binders (loose-leaf or other), folders, file covers, manifold business forms, interleaved carbon s','Libros registro, libros de contabilidad, talonarios (de notas, pedidos o recibos), agendas, bloques, memorandos, bloques de papel de cartas y artículos similares, cuadernos, carpetas de mesa, clasificadores, encuadernaciones (de hojas móviles u otras), ca',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4821,'Etiquetas de qualquer espécie, de papel ou cartão, impressas ou não','Paper or paperboard labels of all kinds, whether or not printed','Etiquetas de todas clases, de papel o cartón, incluso impresas',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4822,'Carretéis, bobinas, tubos, canelas e suportes semelhantes, de pasta de papel, papel ou cartão, mesmo perfurados ou endurecidos','Bobbins, spools, cops and similar supports of paper pulp, paper or paperboard (whether or not perforated or hardened)','Carretes, bobinas, canillas y soportes similares, de pasta de papel, papel o cartón, incluso perforados o endurecidos',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4823,'Outros papéis, cartões, pasta (ouate) de celulose e mantas de fibras de celulose, cortados em forma própria; outras obras de pasta de papel, papel, cartão, pasta (ouate) de celulose ou de mantas de fibras de celulose','Other paper, paperboard, cellulose wadding and webs of cellulose fibres, cut to size or shape; other articles of paper pulp, paper, paperboard, cellulose wadding or webs of cellulose fibres','Los demás papeles, cartones, guata de celulosa y napa de fibras de celulosa, cortados en formato; los demás artículos de pasta de papel, papel, cartón, guata de celulosa o napa de fibras de celulosa',48);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4901,'Livros, brochuras e impressos semelhantes, mesmo em folhas soltas','Printed books, brochures, leaflets and similar printed matter, whether or not in single sheets','Libros, folletos e impresos similares, incluso en hojas sueltas',49);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4902,'Jornais e publicações periódicas, impressos, mesmo ilustrados ou contendo publicidade','Newspapers, journals and periodicals, whether or not illustrated or containing advertising material','Diarios y publicaciones periódicas, impresos, incluso ilustrados o con publicidad',49);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4903,'albuns ou livros de ilustracoes, etc.para crianças','drawing or colouring books, etc.for children','álbumes o libros de estampas, etc.para niños',49);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4904,'musica manuscrita ou impressa, ilustrada ou nao','music, printed or in manuscript, whether or not illustrat','música manuscrita o impresa, incluso con ilustraciones',49);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4905,'Obras cartográficas de qualquer espécie, incluídas as cartas murais, as plantas topográficas e os globos, impressos','Maps and hydrographic or similar charts of all kinds, including atlases, wall maps, topographical plans and globes, printed','Manufacturas cartográficas de todas clases, incluidos los mapas murales, planos topográficos y esferas, impresos',49);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4906,'planos, plantas, desenhos, de arquitetura, etc.feitos a mão','plans and drawings for architectural, etc.drawn by hand','planos, dibujos, de arquitectura, etc.hechos a mano',49);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4907,'Selos postais ou fiscais, não obliterados; papel selado, papel-moeda, cheques, certificados de ações ou de obrigações e títulos semelhantes','Unused postage, check forms, banknotes, stock, etc','Sellos, talonarios de cheques, billetes de banco, etc',49);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4908,'Decalcomanias de qualquer espécie','Transfers (decalcomanias)','Calcomanías de cualquier clase',49);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4909,'Cartões-postais impressos ou ilustrados, etc.','Printed or illustrated postcards','Tarjetas postales impresas o ilustradas, etc',49);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4910,'Calendarios impressos, incl.blocos-calendarios p/desfolh','Calendars of any kind, printed, incl.calendar blocks','Calendarios impresos, incluidos los tacos de calendario',49);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (4911,'Outros impressos, incluídas as estampas, gravuras e fotografias','Other printed matter, including printed pictures and photographs','Los demás impresos, incluidas las estampas, grabados y fotografías',49);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5001,'Casulos de bicho-da-seda,  proprios para dobar','Silkworm cocoons suitable for reeling','Capullos de seda, aptos para el devanado',50);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5002,'Seda crua (não fiada)','Raw silk (not thrown)','Seda cruda (sin torcer)',50);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5003,'Desperdícios de seda (incluídos os casulos de bicho-da-seda impróprios para dobar, os desperdícios de fios e os fiapos)','Silk waste (including cocoons unsuitable for reeling, yarn waste and garnetted stock)','Desperdicios de seda, incluidos los capullos no aptos para el devanado, desperdicios de hilados e hilachas',50);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5004,'Fios de seda','Silk yarn','Hilados de seda',50);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5005,'Fios de desperdícios de seda','Yarn spun from silk waste','Hilados de desperdicios de seda',50);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5006,'Fios de seda/seus desperds,  pelo messina,  p/vda.retalho','Silk yarn/its waste, by messina, f/retail sale','Hilados de seda/sus desps, pelo mesina, p/vta al p/menor',50);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5007,'Tecidos de seda ou de desperdícios de seda','Woven fabrics of silk or of silk waste','Tejidos de seda o de desperdicios de seda',50);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5101,'Lã não cardada nem penteada','Wool, not carded or combed','Lana sin cardar ni peinar',51);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5102,'Pêlos finos ou grosseiros, não cardados nem penteados','Fine or coarse animal hair, not carded or combed','Pelo fino u ordinario, sin cardar ni peinar',51);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5103,'Desperdícios de lã ou de pêlos finos ou grosseiros, incluídos os desperdícios de fios e excluídos os fiapos','Waste of wool or of fine or coarse animal hair, including yarn waste but excluding garnetted stock','Desperdicios de lana o de pelo fino u ordinario, incluidos los desperdicios de hilados (excepto las hilachas)',51);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5104,'Fiapos de lã ou de pêlos finos ou grosseiros','Garnetted stock or of fine or coarse animal hair','Hilachas de lana o pelo fino u ordinario',51);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5105,'Lã, pêlos finos ou grosseiros, cardados ou penteados (incluída a « lã penteada a granel »)','Wool and fine or coarse animal hair, carded or combed (including combed wool in fragments)','Lana y pelo fino u ordinario, cardados o peinados, incluida la «lana peinada a granel»',51);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5106,'Fios de lã cardada, não acondicionados para venda a retalho','Yarn of carded wool, not put up for retail sale','Hilados de lana cardada sin acondicionar para la venta al por menor',51);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5107,'Fios de lã penteada, não acondicionados para venda a retalho','Yarn of combed wool, not put up for retail sale','Hilados de lana peinada sin acondicionar para la venta al por menor',51);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5108,'Fios de pêlos finos, cardados ou penteados, não acondicionados para venda a retalho','Yarn of fine animal hair (carded or combed), not put up for retail sale','Hilados de pelo fino cardado o peinado, sin acondicionar para la venta al por menor',51);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5109,'Fios de lã ou de pêlos finos, acondicionados para venda a retalho','Yarn of wool or of fine animal hair, put up for retail sale','Hilados de lana o pelo fino, acondicionados para la venta al por menor',51);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5110,'Fios de pêlos grosseiros ou de crina','Yarn of coarse animal hair or of horsehair','Hilados de pelos ordinarios o de crin',51);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5111,'Tecidos de lã cardada ou de pêlos finos cardados','Woven fabrics of carded wool or of carded fine animal hair','Tejidos de lana cardada o pelo fino cardado',51);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5112,'Tecidos de lã penteada ou de pêlos finos penteados','Woven fabrics of combed wool or of combed fine animal hair','Tejidos de lana peinada o pelo fino peinado',51);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5113,'Tecidos de pêlos grosseiros ou de crina','Woven fabrics of coarse animal hair or horsehair','Tejidos de pelo ordinario o crin de caballo',51);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5201,'Algodão, não cardado nem penteado','Cotton, not carded or combed','Algodón sin cardar ni peinar',52);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5202,'Desperdícios de algodão (incluídos os desperdícios de fios e fiapos)','Cotton waste (including yarn waste and garnetted stock)','Desperdicios de algodón, incluidos los desperdicios de hilados y las hilachas',52);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5203,'Algodão cardado ou penteado','Cotton, carded or combed','Algodón cardado o peinado',52);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5204,'Linhas para costurar, de algodão, mesmo acondicionadas para venda a retalho','Cotton sewing thread, whether or not put up for retail sale','Hilo de coser de algodón, incluso acondicionado para la venta al por menor',52);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5205,'Fios de algodão (exceto linhas para costurar), contendo pelo menos 85 %, em peso, de algodão, não acondicionados para venda a retalho','Cotton yarn (other than sewing thread), containing 85 % or more by weight of cotton, not put up for retail sale','Hilados de algodón (excepto el hilo de coser) con un contenido de algodón, superior o igual al 85 % en peso, sin acondicionar para la venta al por menor',52);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5206,'Fios de algodão (exceto linhas para costurar), contendo menos de 85 %, em peso, de algodão, não acondicionados para venda a retalho','Cotton yarn (other than sewing thread), containing less than 85 % by weight of cotton, not put up for retail sale','Hilados de algodón (excepto el hilo de coser) con un contenido de algodón, inferior al 85 % en peso, sin acondicionar para la venta al por menor',52);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5207,'Fios de algodão (exceto linhas para costurar), acondicionados para venda a retalho','Cotton yarn (other than sewing thread) put up for retail sale','Hilados de algodón (excepto el hilo de coser) acondicionado para la venta al por menor',52);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5208,'Tecidos de algodão, contendo pelo menos 85 %, em peso, de algodão, com peso não superior a 200 g/m2','Woven fabrics of cotton, containing 85 % or more by weight of cotton, weighing not more than 200 g/m2','Tejidos de algodón con un contenido de algodón superior o igual al 85 % en peso, de peso inferior o igual a 200 g/m2',52);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5209,'Tecidos de algodão, contendo pelo menos 85 %, em peso, de algodão, com peso superior a 200 g/m2','Woven fabrics of cotton, containing 85 % or more by weight of cotton, weighing more than 200 g/m2','Tejidos de algodón con un contenido de algodón superior o igual al 85 % en peso, de peso superior a 200 g/m2',52);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5210,'Tecidos de algodão, contendo menos de 85 %, em peso, de algodão, combinados, principal ou unicamente, com fibras sintéticas ou artificiais, com peso não superior a 200 g/m2','Woven fabrics of cotton, containing less than 85 % by weight of cotton, mixed mainly or solely with man-made fibres, weighing not more than 200 g/m2','Tejidos de algodón con un contenido de algodón inferior al 85 % en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales , de peso inferior o igual a 200 g/m2',52);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5211,'Tecidos de algodão, contendo menos de 85 %, em peso, de algodão, combinados, principal ou unicamente, com fibras sintéticas ou artificiais, com peso superior a 200 g/m2','Woven fabrics of cotton, containing less than 85 % by weight of cotton, mixed mainly or solely with man-made fibres, weighing more than 200 g/m2','Tejidos de algodón con un contenido de algodón inferior al 85 % en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales, de peso superior a 200 g/m2',52);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5212,'Outros tecidos de algodão','Other woven fabrics of cotton','Los demás tejidos de algodón',52);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5301,'Linho em bruto ou trabalhado, mas não fiado; estopas e desperdícios de linho (incluídos os desperdícios de fios e fiapos)','Flax, raw or processed but not spun; flax tow and waste (including yarn waste and garnetted stock)','Lino en bruto o trabajado, pero sin hilar; estopas y desperdicios de lino, incluidos los desperdicios de hilados y las hilachas',53);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5302,'Cânhamo (Cannabis sativa L.), em bruto ou trabalhado, mas não fiado; estopas e desperdícios de cânhamo (incluídos os desperdícios de fios e fiapos)','True hemp (Cannabis sativa L.), raw or processed but not spun; tow and waste of true hemp (including yarn waste and garnetted stock)','Cáñamo (Cannabis sativa L.) en bruto o trabajado, pero sin hilar; estopas y desperdicios de cáñamo, incluidos los desperdicios de hilados y las hilachas',53);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5303,'Juta e outras fibras têxteis liberianas (exceto linho, cânhamo e rami), em bruto ou trabalhadas, mas não fiadas; estopas e desperdícios destas fibras (incluídos os desperdícios de fios e fiapos)','Jute and other textile bast fibres (excluding flax, true hemp and ramie), raw or processed but not spun; tow and waste of these fibres (including yarn waste and garnetted stock)','Yute y demás fibras textiles del líber (excepto del lino, cáñamo y ramio), en bruto o trabajados, pero sin hilar; estopas y desperdicios de estas fibras, incluidos los desperdicios de hilados y las hilachas',53);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5304,'Sisal e outras fibras têxteis do género Agave, em bruto ou trabalhados, mas não fiados; estopas e desperdícios destas fibras (incluídos os desperdícios de fios e fiapos)','Sisal and other textile fibres of the genus Agave, raw or processed but not spun; tow and waste of these fibres (including yarn waste and garnetted stock)','Sisal y demás fibras textiles del género Agave, en bruto o trabajados, pero sin hilar; estopas y desperdicios de estas fibras, incluidos los desperdicios de hilados y las hilachas',53);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5305,'Cairo (fibras de coco), abacá (cânhamo-de-manila ou Musa textilis Nee), rami e outras fibras têxteis vegetais não especificadas nem compreendidas noutras posições, em bruto ou trabalhados, mas não fiados; estopas e desperdícios destas fibras (incluídos os','Coconut, abaca (Manila hemp or Musa textilis Nee), ramie and other vegetable textile fibres, not elsewhere specified or included, raw or processed but not spun; tow, noils and waste of these fibres (including yarn waste and garnetted stock)','Coco, abacá (cáñamo de manila [Musa textilis Nee]), ramio y demás fibras textiles vegetales no expresadas ni comprendidas en otra partida, en bruto o trabajados, pero sin hilar; estopas y desperdicios de estas fibras, incluidos los desperdicios de hilados',53);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5306,'Fios de linho','Flax yarn','Hilados de lino',53);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5307,'Fios de juta ou de outras fibras têxteis liberianas da posição 5303','Yarn of jute or of other textile bast fibres of heading No 5303','Hilados de yute o demás fibras textiles del líber de la partida 5303',53);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5308,'Fios de outras fibras têxteis vegetais; fios de papel','Yarn of other vegetable textile fibres; paper yarn','Hilados de las demás fibras textiles vegetales; hilados de papel',53);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5309,'Tecidos de linho','Woven fabrics of flax','Tejidos de lino',53);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5310,'Tecidos de juta ou de outras fibras têxteis liberianas da posição 5303','Woven fabrics of jute or of other textile bast fibres of heading 5303','Tejidos de yute o demás fibras textiles del líber de la partida 5303',53);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5311,'Tecidos de outs.fibras têxteis veg.ou de fios de papel','fabrics of oth.vegetable textile fibres or of paper yar','tejidos de ots.fibras texts.veg.o de hilados de papel',53);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5401,'Linhas para costurar de filamentos sintéticos ou artificiais, mesmo acondicionadas para venda a retalho','Sewing thread of man-made filaments, whether or not put up for retail sale','Hilo de coser de filamentos sintéticos o artificiales, incluso acondicionado para la venta al por menor',54);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5402,'Fios de filamentos sintéticos (exceto linhas para costurar), não acondicionados para venda a retalho, incluídos os monofilamentos sintéticos com menos de 67 decitex','Synthetic filament yarn (other than sewing thread), not put up for retail sale, including synthetic monofilament of less than 67 decitex','Hilados de filamentos sintéticos (excepto el hilo de coser) sin acondicionar para la venta al por menor, incluidos los monofilamentos sintéticos de título inferior a 67 decitex',54);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5403,'Fios de filamentos artificiais (exceto linhas para costurar), não acondicionados para venda a retalho, incluídos os monofilamentos artificiais com menos de 67 decitex','Artificial filament yarn (other than sewing thread), not put up for retail sale, including artificial monofilament of less than 67 decitex','Hilados de filamentos artificiales (excepto el hilo de coser) sin acondicionar para la venta al por menor, incluidos los monofilamentos artificiales de título inferior a 67 decitex',54);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5404,'Monofilamentos sintéticos, com pelo menos 67 decitex e cuja maior dimensão da secção transversal não seja superior a 1 mm; lâminas e formas semelhantes (por exemplo: palha artificial) de matérias têxteis sintéticas, cuja largura aparente não seja superior','Synthetic monofilament of 67 decitex or more and of which no cross-sectional dimension exceeds 1 mm; strip and the like (for example, artificial straw) of synthetic textile materials of an apparent width not exceeding 5 mm','Monofilamentos sintéticos de título superior o igual a 67 decitex y cuya mayor dimensión de la sección transversal sea inferior o igual a 1 mm; tiras y formas similares (por ejemplo: paja artificial) de materia textil sintética, de anchura aparente inferi',54);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5405,'monofilamentos artifs.t>=67decitex,  sec.transv<=1mm,  etc.','artificial monofilam.t>=67 decitex, cross-sect.<=1mm, etc','monofilamentos artifs.t>=67decitex, sec.transv<=1mm, etc.',54);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5406,'Fios de filamentos sintéticos ou artificiais (exceto linhas para costurar), acondicionados para venda a retalho','Man-made filament yarn (other than sewing thread), put up for retail sale','Hilados de filamentos sintéticos o artificiales (excepto el hilo de coser), acondicionados para la venta al por menor',54);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5407,'Tecidos de fios de filamentos sintéticos, incluídos os tecidos obtidos a partir dos produtos da posição 5404','Woven fabrics of synthetic filament yarn, including woven fabrics obtained from materials of heading 5404','Tejidos de hilados de filamentos sintéticos, incluidos los tejidos fabricados con los productos de la partida 5404',54);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5408,'Tecidos de fios de filamentos artificiais, incluídos os tecidos obtidos a partir dos produtos da posição 5405','Woven fabrics of artificial filament yarn, including woven fabrics obtained from materials of heading 5405','Tejidos de hilados de filamentos artificiales, incluidos los fabricados con productos de la partida 5405',54);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5501,'Cabos de filamentos sintéticos','Synthetic filament tow','Cables de filamentos sintéticos',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5502,'Cabos de filamentos artificiais','Artificial filament tow','Filamentos artificiales',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5503,'Fibras sintéticas descontínuas, não cardadas, não penteadas nem transformadas de outro modo para fiação','Synthetic staple fibres, not carded, combed or otherwise processed for spinning','Fibras sintéticas discontinuas, sin cardar, peinar ni transformar de otro modo para la hilatura',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5504,'Fibras artificiais descontínuas, não cardadas, não penteadas nem transformadas de outro modo para fiação','Artificial staple fibres, not carded, combed or otherwise processed for spinning','Fibras artificiales discontinuas, sin cardar, peinar ni transformar de otro modo para la hilatura',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5505,'Desperdícios de fibras sintéticas ou artificiais (incluídos os desperdícios da penteação, os de fios e os fiapos)','Waste (including noils, yarn waste and garnetted stock) of man-made fibres','Desperdicios de fibras sintéticas o artificiales, incluidas las borras, los desperdicios de hilados y las hilachas',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5506,'Fibras sintéticas descontínuas, cardadas, penteadas ou transformadas de outro modo para fiação','Synthetic staple fibres, carded, combed or otherwise processed for spinning','Fibras sintéticas discontinuas, cardadas, peinadas o transformadas de otro modo para la hilatura',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5507,'fibras artificiais,  cardadas,  penteadas,  etc.p/fiação','artificial fibres, carded, combed, etc.f/spinning','fibras artificiales, cardadas, peinadas, etc.p/hilatura',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5508,'Linhas para costurar, de fibras sintéticas ou artificiais descontínuas, mesmo acondicionadas para venda a retalho','Sewing thread of man-made staple fibres, whether or not put up for retail sale','Hilo de coser de fibras sintéticas o artificiales, discontinuas, incluso acondicionado para la venta al por menor',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5509,'Fios de fibras sintéticas descontínuas (exceto linhas para costurar), não acondicionados para venda a retalho','Yarn (other than sewing thread) of synthetic staple fibres, not put up for retail sale','Hilados de fibras sintéticas discontinuas (excepto el hilo de coser) sin acondicionar para la venta al por menor',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5510,'Fios de fibras artificiais descontínuas (exceto linhas para costurar), não acondicionados para venda a retalho','Yarn (other than sewing thread) of artificial staple fibres, not put up for retail sale','Hilados de fibras artificiales discontinuas (excepto el hilo de coser) sin acondicionar para la venta al por menor',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5511,'Fios de fibras sintéticas ou artificiais descontínuas (exceto linhas para costurar), acondicionados para venda a retalho','Yarn (other than sewing thread) of man-made staple fibres, put up for retail sale','Hilados de fibras sintéticas o artificiales, discontinuas (excepto el hilo de coser) acondicionados para la venta al por menor',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5512,'Tecidos de fibras sintéticas descontínuas, contendo pelo menos 85 %, em peso, destas fibras','Woven fabrics of synthetic staple fibres, containing 85 % or more by weight of synthetic staple fibres','Tejidos de fibras sintéticas discontinuas con un contenido de fibras sintéticas discontinuas superior o igual al 85 % en peso',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5513,'Tecidos de fibras sintéticas descontínuas, contendo menos de 85 %, em peso, destas fibras, combinados, principal ou unicamente, com algodão, de peso não superior a 170 g/m2','Woven fabrics of synthetic staple fibres, containing less than 85 % by weight of such fibres, mixed mainly or solely with cotton, of a weight not exceeding 170 g/m2','Tejidos de fibras sintéticas discontinuas con un contenido de estas fibras inferior al 85 % en peso, mezcladas exclusiva o principalmente con algodón, de peso inferior o igual a 170 g/m2',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5514,'Tecidos de fibras sintéticas descontínuas, contendo menos de 85 %, em peso, destas fibras, combinados, principal ou unicamente, com algodão, de peso superior a 170 g/m2','Woven fabrics of synthetic staple fibres, containing less than 85 % by weight of such fibres, mixed mainly or solely with cotton, of a weight exceeding 170 g/m2','Tejidos de fibras sintéticas discontinuas con un contenido de estas fibras inferior al 85 % en peso, mezcladas exclusiva o principalmente con algodón, de peso superior a 170 g/m2',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5515,'Outros tecidos de fibras sintéticas descontínuas','Other woven fabrics of synthetic staple fibres','Los demás tejidos de fibras sintéticas discontinuas',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5516,'Tecidos de fibras artificiais descontínuas','Woven fabrics of artificial staple fibres','Tejidos de fibras artificiales discontinuas',55);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5601,'Pastas (ouates) de matérias têxteis e artigos destas pastas; fibras têxteis de comprimento não superior a 5 mm (tontisses), nós e borbotos de matérias têxteis','Wadding of textile materials and articles thereof; textile fibres, not exceeding 5 mm in length (flock), textile dust and mill neps','Guata de materia textil y artículos de esta guata; fibras textiles de longitud inferior o igual a 5 mm (tundizno), nudos y motas de materia textil',56);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5602,'Feltros, mesmo impregnados, revestidos, recobertos ou estratificados','Felt, whether or not impregnated, coated, covered or laminated','Fieltro, incluso impregnado, recubierto, revestido o estratificado',56);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5603,'Falsos tecidos, mesmo impregnados, revestidos, recobertos ou estratificados','Non-wovens, whether or not impregnated, coated, covered or laminated','Tela sin tejer, incluso impregnada, recubierta, revestida o estratificada',56);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5604,'Fios e cordas, de borracha, recobertos de têxteis; fios têxteis, lâminas e formas semelhantes das posições 5404 ou 5405, impregnados, revestidos, recobertos ou embainhados de borracha ou de plásticos','Rubber thread and cord, textile covered; textile yarn, and strip and the like of heading 5404 or 5405, impregnated, coated, covered or sheathed with rubber or plastics','Hilos y cuerdas de caucho, revestidos de textiles; hilados de textiles, tiras y formas similares de las partidas 5404 ó 5405, impregnados, recubiertos, revestidos o enfundados con caucho o plástico',56);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5605,'Fios metálicos constituídos por fios têxteis, lâminas ou formas semelhantes, combinados com metal','Metal yarn whether or not gimp tex yarn or strip with metal','Hilo de metal o no gimp tex hilo o cinta de metal',56);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5606,'Fios revest.por enrolam/laminas/monofilam.sint/art.etc.','Gimped yarnstrip/mono-filament synth/artif, etc.','Hilados entorchados/tiras/monofilam.sint/art.etc.',56);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5607,'Cordéis, cordas e cabos, entrançados ou não, mesmo impregnados, revestidos, recobertos ou embainhados de borracha ou de plástico','Twine, cordage, ropes and cables, whether or not plaited or braided and whether or not impregnated, coated, covered or sheathed with rubber or plastics','Cordeles, cuerdas y cordajes,  estén o no trenzados, incluso impregnados, recubiertos, revestidos o enfundados con caucho o plástico',56);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5608,'Redes de malhas com nós, em panos ou em peça, obtidas a partir de cordéis, cordas ou cabos; redes confeccionadas para a pesca e outras redes confeccionadas, de matérias têxteis','Knotted netting of twine, cordage or rope; made-up fishing nets and other made-up nets, of textile materials','Redes de mallas anudadas, en paño o en pieza, fabricadas con cordeles, cuerdas o cordajes; redes confeccionadas para la pesca y demás redes confeccionadas, de materia textil',56);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5609,'Artigos de fios, lâminas ou formas semelhantes das posições 5404 ou 5405; outros cordéis, cordas e cabos','Art of yarn like of head 5404/5405 twine or cable nesoi','Arte de hilo como el de la cabeza 5404/5405 guita o no especificado por cable',56);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5701,'Tapetes de matérias têxteis, de pontos nodados ou enrolados, mesmo confeccionados','Carpets and other textile floor coverings, knotted, whether or not made-up','Alfombras de nudo de materia textil, incluso confeccionadas',57);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5702,'Tapetes e outros revestimentos para pavimentos de matérias têxteis, tecidos, exceto os tufados e os flocados, mesmo confeccionados, incluídos os tapetes denominados « Kelim » ou « Kilim », « Schumacks » ou « Soumak », « Karamanie » e tapetes semelhantes ','Carpets and other textile floor coverings, woven, not tufted or flocked, whether or not made-up, including ''Kelem'', ''Schumacks'', ''Karamanie'' and similar hand-woven rugs','Alfombras y demás revestimientos para el suelo, de materia textil, tejidos (excepto los de mechón insertado y los flocados), aunque estén confeccionados, incluidas las alfombras llamadas «kelim» o «kilin», «schumacks» o «soumak», «karamanie» y alfombras s',57);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5703,'Tapetes e outros revestimentos para pavimentos de matérias têxteis, tufados, mesmo confeccionados','Carpets and other textile floor coverings, tufted, whether or not made-up','Alfombras y demás revestimientos para el suelo, de materias textiles, con mechón insertado, incluso confeccionados',57);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5704,'Tapetes e outros revestimentos para pavimentos, de feltro, exceto os tufados e os flocados, mesmo confeccionados','Carpets and other textile floor coverings, of felt, not tufted or flocked, whether or not made-up','Alfombras y demás revestimientos para el suelo, de fieltro (excepto los de mechón insertado y los flocados), incluso confeccionados',57);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5705,'Outs.tapetes/revestimentos p/pavim.de matérias têxteis','other carpets and other textile floor coverings,ots','alfombras/revestimientos p/suelo de mater.textiles',57);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5801,'Veludos e pelúcias tecidos e tecidos de froco (chenille), exceto os artefactos das posições 5802 ou 5806','Woven pile fabrics and chenille fabrics, other than fabrics of heading 5802 or 5806','Terciopelo y felpa (excepto los de punto), y tejidos de chenilla (excepto los productos de las partidas 5802 o 5806)',58);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5802,'Tecidos turcos», exceto os artefactos da posição 5806; tecidos tufados, exceto os artefactos da posição 5703','Terry towelling and similar woven terry fabrics, other than narrow fabrics of heading 5806; tufted textile fabrics, other than products of heading 5703','Tejidos con bucles del tipo toalla (excepto los productos de la partida 5806); superficies textiles con mechón insertado (excepto los productos de la partida 5703)',58);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5803,'Tecidos em ponto de gaze, exceto os artefactos da posição 5806','Gauze, other than narrow fabrics of heading 5806','Tejidos de gasa de vuelta (excepto los productos de la partida 5806)',58);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5804,'Tules, filó e tecidos de malhas com nós; rendas em peça, em tiras ou em motivos para aplicar, exceto os produtos das posições 6002 a 6006','Tulles and other net fabrics, not including woven, knitted or crocheted fabrics; lace in the piece, in strips or in motifs, other than fabrics of headings 6002 to 6006','Tul, tul-bobinot y tejidos de mallas anudadas; encajes en pieza, en tiras o en aplicaciones (excepto los productos de las partidas 6002 a 6006)',58);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5805,'Tapeçarias tecidas à mão (gêneros gobelino, flandres, aubusson e semelhantes) e feitas à agulha (em petit point, ponto de cruz)','Hand-woven tapestries wall hang use only','Tapicería tejida a mano la pared cuelgan utilizar sólo',58);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5806,'Fitas, exceto os artefactos da posição 5807; fitas sem trama, de fios ou fibras paralelizados e colados (bolducs)','Narrow woven fabrics, other than goods of heading 5807; narrow fabrics consisting of warp without weft assembled by means of an adhesive (bolducs)','Cintas (excepto los artículos de la partida 5807); cintas sin trama, de hilados o fibras paralelizados y aglutinados',58);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5807,'Etiquetas, emblemas e artefactos semelhantes de matérias têxteis, em peça, em fitas ou recortados em forma própria, não bordados','Labels, badges and similar articles of textile materials, in the piece, in strips or cut to shape or size, not embroidered','Etiquetas, escudos y artículos similares, de materia textil, en pieza, en cintas o recortados, sin bordar',58);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5808,'Entrançados em peça; artigos de passamanaria e artigos ornamentais análogos, em peça, não bordados, exceto de malha; borlas, pompons e artefactos semelhantes','Braids in the piece; ornamental trimmings in the piece, without embroidery, other than knitted or crocheted; tassels, pompons and similar articles','Trenzas en pieza; artículos de pasamanería y artículos ornamentales análogos, en pieza, sin bordar (excepto los de punto); bellotas, madroños, pompones, borlas y artículos similares',58);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5809,'Tecido de fios de metal, de fios têxteis metalizados, etc','Fabrics of metal thread of textile metallised yarn, etc','Tejido de hilad.de metal, de hilad.textiles metaliz., etc',58);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5810,'Bordados em peça, em tiras ou em motivos para aplicar','Embroidery in the piece, in strips or in motifs','Bordados en pieza, tiras o motivos',58);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5811,'aAtefatos têxteis matelasses em peça, etc.','Quilted textile products in the piece','Productos textiles acolchados en pieza, etc.',58);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5901,'Tecidos revestidos de cola ou de matérias amiláceas, dos tipos utilizados na encadernação, cartonagem ou usos semelhantes; telas para decalque e telas transparentes para desenho; telas preparadas para pintura; entretelas e tecidos rígidos semelhantes dos ','Textile fabrics coated with gum or amylaceous substances, of a kind used for the outer covers of books or the like; tracing cloth; prepared painting canvas; buckram and similar stiffened textile fabrics of a kind used for hat foundations','Telas recubiertas de cola o materias amiláceas, del tipo de las utilizadas para la encuadernación, cartonaje, estuchería o usos similares; transparentes textiles para calcar o dibujar; lienzos preparados para pintar; bucarán y telas rígidas similares del ',59);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5902,'Telas para pneumáticos fabricadas com fios de alta tenacidade de nylon ou de outras poliamidas, de poliésteres ou de raiom de viscose','Tyre cord fabric of high tenacity yarn of nylon or other polyamides, polyesters or viscose rayon','Napas tramadas para neumáticos fabricadas con hilados de alta tenacidad de nailon o demás poliamidas, de poliésteres o de rayon viscosa',59);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5903,'Tecidos impregnados, revestidos, recobertos ou estratificados com plástico, exceto os da posição 5902','Textile fabrics impregnated, coated, covered or laminated with plastics, other than those of heading 5902','Telas impregnadas, recubiertas, revestidas o estratificadas con plástico (excepto los de la partida 5902)',59);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5904,'Linóleos, mesmo recortados; revestimentos para pavimentos constituídos por um induto ou recobrimento aplicado sobre suporte têxtil, mesmo recortados','Linoleum, whether or not cut to shape; floor coverings consisting of a coating or covering applied on a textile backing, whether or not cut to shape','Linóleo, incluso cortado; revestimientos para el suelo formados por un recubrimiento o revestimiento aplicado sobre un soporte textil, incluso cortados',59);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5905,'revestimento para paredes, de matérias têxteis','textile wall coverings, of textile material','revestimiento de materia textil para paredes',59);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5906,'Tecidos com borracha, exceto os da posição 5902','Rubberised textile fabrics, other than those of heading No 5902','Telas cauchutadas (excepto los de la partida 5902)',59);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5907,'outros tecidos impregnados/revestidos/recobertos,  etc.','oth.fabrics impregnated/coated/covered, etc','otras telas impregnadas/revestidas/recubiertas, etc.',59);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5908,'mechas de materia têxtil, tecidas, para candeeiros, velas,  etc','textile wicks, woven, f/candles, etc.','mechas de materia textil, tejidas, p/lámparas, velas, etc',59);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5909,'mangueiras e tubos semelhantes, de matérias têxteis','textile hose-piping and similar textile tubing','mangueras y tubos similares, de materias textiles',59);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5910,'correias transportadoras/transmissão, de matéria têxtil','transmission/conveyor belts/belting, of tex.material','correas transportadoras/transmisión, de materia textil',59);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (5911,'Produtos e artefactos, de matérias têxteis, para usos técnicos, indicados na Nota 7 do presente capítulo','Textile products and articles, for technical uses, specified in note 7 to this chapter','Productos y artículos textiles para usos técnicos mencionados en la nota 7 de este capítulo',59);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6001,'Veludos e pelúcias (incluídos os tecidos denominados de « felpa longa » ou « pêlo comprido ») e tecidos de anéis, de malha','Pile fabrics, including ''long pile'' fabrics and terry fabrics, knitted or crocheted','Terciopelo, felpa, incluidos los tejidos de punto «de pelo largo», y tejidos con bucles, de punto',60);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6002,'Tecidos de malha de largura não superior a 30 cm, contendo, em peso, 5 % ou mais de fios de elastómeros ou de fios de borracha, exceto da posição 6001','Knitted or crocheted fabrics of a width not exceeding 30 cm, containing by weight 5 % or more of elastomeric yarn or rubber thread, other than those of heading 6001','Tejidos de punto de anchura inferior o igual a 30 cm, con un contenido de hilados de elastómeros o de hilos de caucho superior o igual al 5 % en peso (excepto los de la partida 6001)',60);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6003,'Tecidos de malha de largura não superior a 30 cm, exceto das posições 6001 e 6002','Knitted or crocheted fabrics of a width not exceeding 30 cm, other than those of heading 6001 or 6002','Tejidos de punto de anchura inferior o igual a 30 cm (excepto los de las partidas 6001 ó 6002)',60);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6004,'Tecidos de malha de largura superior a 30 cm, contendo, em peso, 5 % ou mais de fios de elastómeros ou de fios de borracha, exceto da posição 6001','Knitted or crocheted fabrics of a width exceeding 30 cm, containing by weight 5 % or more of elastomeric yarn or rubber thread, other than those of heading 6001','Tejidos de punto de anchura superior a 30 cm, con un contenido de hilados de elastómeros o de hilos de caucho superior o igual al 5 % en peso (excepto los de la partida 6001)',60);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6005,'Tecidos de malha-urdidura (incluídos os fabricados em teares para galões), exceto das posições 6001 a 6004','Warp knit fabrics (including those made on galloon knitting machines), other than those of headings 6001 to 6004','Tejidos de punto por urdimbre, incluidos los obtenidos en telares de pasamanería (excepto los de las partidas 6001 a 6004)',60);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6006,'Outros tecidos de malha','Other knitted or crocheted fabrics','Los demás tejidos de punto',60);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6101,'Sobretudos, japonas, gabões, capas, anoraques, blusões e semelhantes, de malha, de uso masculino, exceto os artefactos da posição 6103','Men''s or boys'' overcoats, car-coats, capes, cloaks, anoraks (including ski-jackets), wind-cheaters, wind-jackets and similar articles, knitted or crocheted, other than those of heading No 6103','Abrigos, chaquetones, capas, anoraks, cazadoras y artículos similares, de punto, para hombres o niños (excepto los artículos de la partida 6103)',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6102,'Casacos compridos, capas, anoraques, blusões e semelhantes, de malha, de uso feminino, exceto os artefactos da posição 6104','Women''s or girls'' overcoats, car-coats, capes, cloaks, anoraks (including ski-jackets), wind-cheaters, wind-jackets and similar articles, knitted or crocheted, other than those of heading 6104','Abrigos, chaquetones, capas, anoraks, cazadoras y artículos similares, de punto, para mujeres o niñas (excepto los artículos de la partida 6104)',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6103,'Fatos, conjuntos, casacos, calças, jardineiras, bermudas e calções (shorts) (exceto de banho), de malha, de uso masculino','Men''s or boys'' suits, ensembles, jackets, blazers, trousers, bib and brace overalls, breeches and shorts (other than swimwear), knitted or crocheted','Trajes (ambos o ternos), conjuntos, chaquetas (sacos), pantalones largos,  pantalones con peto, pantalones cortos (calzones) y shorts (excepto de baño), de punto, para hombres o niños',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6104,'Fatos de saia-casaco, conjuntos, casacos, vestidos, saias, saias-calças, calças, jardineiras, bermudas e calções (shorts) (exceto de banho), de malha, de uso feminino','Women''s or girls'' suits, ensembles, jackets, blazers, dresses, skirts, divided skirts, trousers, bib and brace overalls, breeches and shorts (other than swimwear), knitted or crocheted','Trajes sastre, conjuntos, chaquetas (sacos), vestidos, faldas, faldas pantalón, pantalones largos, pantalones con peto, pantalones cortos (calzones) y shorts (excepto de baño), de punto, para mujeres o niñas',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6105,'Camisas de malha, de uso masculino','Men''s or boys'' shirts, knitted or crocheted','Camisas de punto para hombres o niños',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6106,'Camiseiros, blusas, blusas-camiseiros, de malha, de uso feminino','Women''s or girls'' blouses, shirts and shirt-blouses, knitted or crocheted','Camisas, blusas y blusas camiseras, de punto, para mujeres o niñas',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6107,'Cuecas, ceroulas, camisas de noite, pijamas, roupões de banho, robes e semelhantes, de malha, de uso masculino','Men''s or boys'' underpants, briefs, nightshirts, pyjamas, bathrobes, dressing gowns and similar articles, knitted or crocheted','Calzoncillos, incluidos los largos y los slips, camisones, pijamas, albornoces de baño, batas de casa y artículos similares, de punto, para hombres o niños',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6108,'Combinações, saiotes, calcinhas, camisas de noite, pijamas, déshabillés, roupões de banho, robes de quarto e semelhantes, de malha, de uso feminino','Women''s or girls'' slips, petticoats, briefs, panties, nightdresses, pyjamas, negligees, bathrobes, dressing gowns and similar articles, knitted or crocheted','Combinaciones, enaguas, bragas (bombachas, calzones), incluso las que no llegan hasta la cintura, camisones, pijamas, saltos de cama, albornoces de baño, batas de casa y artículos similares, de punto, para mujeres o niñas',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6109,'T-shirts e camisolas interiores, de malha','T-shirts, singlets and other vests, knitted or crocheted','T-shirts y camisetas interiores de punto',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6110,'Camisolas e pulôveres, cardigans, coletes e artigos semelhantes, de malha','Jerseys, pullovers, cardigans, waistcoats and similar articles, knitted or crocheted','Suéteres (jerseys), pullovers, cardiganes, chalecos y artículos similares de punto',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6111,'Vestuário e seus acessórios, de malha, para bebés','Babies'' garments and clothing accessories, knitted or crocheted','Prendas y complementos (accesorios) de vestir, de punto, para bebés',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6112,'Fatos de treino para desporto, fatos-macacos e conjuntos de esqui, malhôs, biquinis, calções (shorts) e slips, de banho, de malha','Track suits, ski suits and swimwear, knitted or crocheted','Conjuntos de abrigo para entrenamiento o deporte (chandales), monos (overoles) y conjuntos de esquí y bañadores, de punto',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6113,'Vestuário confecc.de tecidos malha c/plástico/borracha','garments, made-up of mesh fabrics with plastic/rubber','prendas de vestir confec.c/tejidos punto c/plást/caucho',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6114,'Outro vestuário de malha','Other garments, knitted or crocheted','Las demás prendas de vestir, de punto',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6115,'Meias-calças; meias de qualquer espécie e artefactos semelhantes, incluídas as meias para varizes, de malha','Panty hose, tights, stockings, socks and other hosiery, including stockings for varicose veins and footwear without applied soles, knitted or crocheted','Calzas, panty-medias, leotardos, medias, calcetines y demás artículos de calcetería, incluso para varices, de punto',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6116,'Luvas, mitenes e semelhantes, de malha','Gloves, mittens and mitts, knitted or crocheted','Guantes, mitones y manoplas, de punto',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6117,'Outros acessórios de vestuário, confeccionados, de malha; partes de vestuário ou de seus acessórios, de malha','Other made-up clothing accessories, knitted or crocheted; knitted or crocheted parts of garments or of clothing accessories','Los demás complementos (accesorios) de vestir confeccionados, de punto; partes de prendas o de complementos (accesorios) de vestir, de punto',61);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6201,'Sobretudos, japonas, gabões, capas, anoraques, blusões e semelhantes, de uso masculino, exceto os artefactos da posição 6203','Men''s or boys'' overcoats, car-coats, capes, cloaks, anoraks (including ski-jackets), wind-cheaters, wind-jackets and similar articles, other than those of heading No 6203','Abrigos, chaquetones, capas, anoraks, cazadoras y artículos similares, para hombres o niños (excepto los artículos de la partida 6203)',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6202,'Casacos compridos, capas, anoraques, blusões e semelhantes, de uso feminino, exceto os artefactos da posição 6204','Women''s or girls'' overcoats, car-coats, capes, cloaks, anoraks (including ski-jackets), wind-cheaters, wind-jackets and similar articles, other than those of heading No 6204','Abrigos, chaquetones, capas, anoraks, cazadoras y artículos similares, para mujeres o niñas (excepto los artículos de la partida 6204)',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6203,'Fatos, conjuntos, casacos, calças, jardineiras, bermudas e calções (shorts) (exceto de banho), de uso masculino','Men''s or boys'' suits, ensembles, jackets, blazers, trousers, bib and brace overalls, breeches and shorts (other than swimwear)','Trajes (ambos o ternos), conjuntos, chaquetas (sacos), pantalones largos, pantalones con peto, pantalones cortos (calzones) y shorts (excepto los de baño), para hombres o niños',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6204,'Fatos de saia-casaco, conjuntos, casacos, vestidos, saias, saias-calças, calças, jardineiras, bermudas e calções (shorts) (exceto de banho), de uso feminino','Women''s or girls'' suits, ensembles, jackets, blazers, dresses, skirts, divided skirts, trousers, bib and brace overalls, breeches and shorts (other than swimwear)','Trajes sastre, conjuntos, chaquetas (sacos), vestidos, faldas, faldas pantalón, pantalones largos, pantalones con peto, pantalones cortos (calzones) y shorts (excepto de baño), para mujeres o niñas',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6205,'Camisas de uso masculino','Mens or boys shirts','Camisas para hombres o niños',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6206,'Camiseiros, blusas, blusas-camiseiros, de uso feminino','Women''s or girls'' blouses, shirts and shirt-blouses','Camisas, blusas y blusas camiseras, para mujeres o niñas',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6207,'Camisolas interiores, cuecas, ceroulas, camisas de noite, pijamas, roupões de banho, robes e semelhantes, de uso masculino','Men''s or boys'' singlets and other vests, underpants, briefs, nightshirts, pyjamas, bathrobes, dressing gowns and similar articles','Camisetas interiores, calzoncillos, incluidos los largos y los slips, camisones, pijamas, albornoces de baño, batas de casa y artículos similares, para hombres o niños',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6208,'Camisolas interiores, combinações, saiotes, calcinhas, camisas de noite, pijamas, déshabillés, roupões de banho, robes de quarto e artefactos semelhantes, de uso feminino','Women''s or girls'' singlets and other vests, slips, petticoats, briefs, panties, nightdresses, pyjamas, negligees, bathrobes, dressing gowns and similar articles','Camisetas interiores, combinaciones, enaguas, bragas (bombachas, calzones), incluso las que no llegan hasta la cintura, camisones, pijamas, saltos de cama, albornoces de baño, batas de casa y artículos similares, para mujeres o niñas',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6209,'Vestuário e seus acessórios, para bebés','Babies'' garments and clothing accessories','Prendas y complementos (accesorios), de vestir, para bebés',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6210,'Vestuário confeccionado com as matérias das posições 5602, 5603, 5903, 5906 ou 5907','Garments, made-up of fabrics of heading 5602, 5603, 5903, 5906 or 5907','Prendas de vestir confeccionadas con productos de las partidas 5602, 5603, 5903, 5906 ó 5907',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6211,'Fatos de treino para desporto, fatos-macacos e conjuntos de esqui, malhôs, biquinis, calções (shorts) e slips de banho; outro vestuário','Track suits, ski suits and swimwear; other garments','Conjuntos de abrigo para entrenamiento o deporte (chandales), monos (overoles) y conjuntos de esquí y bañadores; las demás prendas de vestir',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6212,'Soutiens, cintas, espartilhos, suspensórios, ligas e artefactos semelhantes, e suas partes, mesmo de malha','Brassières, girdles, corsets, braces, suspenders, garters and similar articles and parts thereof, whether or not knitted or crocheted','Sostenes (corpiños), fajas, corsés, tirantes (tiradores), ligas y artículos similares, y sus partes, incluso de punto',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6213,'Lenços de assoar e de bolso','Handkerchiefs','Pañuelos de bolsillo',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6214,'Xales, écharpes, lenços de pescoço, cachenés, cachecóis, mantilhas, véus e artefactos semelhantes','Shawls, scarves, mufflers, mantillas, veils and the like','Chales, pañuelos de cuello, bufandas, mantillas, velos y artículos similares',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6215,'Gravatas, laços e plastrões','Ties, bow ties and cravats','Corbatas y lazos similares',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6216,'Luvas,  mitenes e semelhantes','Gloves, mittens and mitts','Guantes, mitones y manoplas',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6217,'Outros acessórios confeccionados de vestuário; partes de vestuário ou dos seus acessórios, exceto da posição 6212','Other made-up clothing accessories; parts of garments or of clothing accessories, other than those of heading 6212','Los demás complementos (accesorios) de vestir confeccionados; partes de prendas o de complementos (accesorios), de vestir (excepto las de la partida 6212)',62);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6301,'Cobertores e mantas','Blankets and travelling rugs','Mantas',63);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6302,'Roupas de cama, mesa, toucador ou cozinha','Bed linen, table linen, toilet linen and kitchen linen','Ropa de cama, de mesa, de tocador o cocina',63);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6303,'Cortinados, cortinas e estores; sanefas e reposteiros','Curtains (including drapes) and interior blinds; curtain or bed valances','Visillos y cortinas; guardamalletas y rodapiés de camas',63);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6304,'Outros artefactos para guarnição de interiores, exceto da posição 9404','Other furnishing articles, excluding those of heading 9404','Los demás artículos de tapicería (excepto los de la partida 9404)',63);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6305,'Sacos de quaisquer dimensões, para embalagem','Sacks and bags, of a kind used for the packing of goods','Sacos (bolsas) y talegas, para envasar',63);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6306,'Encerados e estores de exterior; tendas; velas para embarcações, para pranchas à vela ou para carros à vela; artigos para acampamento','Tarpaulins, awnings and sunblinds; tents; sails for boats, sailboards or landcraft; camping goods','Toldos de cualquier clase; tiendas (carpas), velas para embarcaciones, deslizadores o vehículos terrestres; artículos de acampar',63);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6307,'Outros artefactos confeccionados, incluídos os moldes para vestuário','Other made-up articles, including dress patterns','Los demás artículos confeccionados, incluidos los patrones para prendas de vestir',63);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6308,'Sortidos de cortes de tecido/fios,  p/confecc.tapetes,  etc','Sets consist.of fabric/yarn, f/making up into rugs, etc.','Juegos consts.por piezas de tej./hilados, p/conf.alf.etc',63);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6309,'Artefatos de matérias têxteis, calçados, chapéus e similares, usados','Worn clothing and other worn textile articles','Ropa usada y otros artículos textiles usados',63);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6310,'Trapos, cordéis, cordas e cabos de matérias têxteis, em forma de desperdícios ou de artefactos inutilizados','Used or new rags, scrap twine, cordage, rope and cables and worn out articles of twine, cordage, rope or cables, of textile materials','Trapos, cordeles, cuerdas y cordajes, de materia textil, en desperdicios o en artículos inservibles',63);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6401,'Calçado impermeável de sola exterior e parte superior de borracha ou plástico, em que a parte superior não tenha sido reunida à sola exterior por costura ou por meio de rebites, pregos, parafusos, espigões ou dispositivos semelhantes, nem formada por dife','Waterproof footwear with outer soles and uppers of rubber or of plastics, the uppers of which are neither fixed to the sole nor assembled by stitching, riveting, nailing, screwing, plugging or similar processes','Calzado impermeable con suela y parte superior de caucho o plástico, cuya parte superior no se haya unido a la suela por costura o por medio de remaches, clavos, tornillos, espigas o dispositivos similares, ni se haya formado con diferentes partes unidas ',64);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6402,'Outro calçado com sola exterior e parte superior de borracha ou plástico','Other footwear with outer soles and uppers of rubber or plastics','Los demás calzados con suela y parte superior de caucho o plástico',64);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6403,'Calçado com sola exterior de borracha, plástico, couro natural ou reconstituído e parte superior de couro natural','Footwear with outer soles of rubber, plastics, leather or composition leather and uppers of leather','Calzado con suela de caucho, plástico, cuero natural o regenerado y parte superior de cuero natural',64);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6404,'Calçado com sola exterior de borracha, plástico, couro natural ou reconstituído e parte superior de matérias têxteis','Footwear with outer soles of rubber, plastics, leather or composition leather and uppers of textile materials','Calzado con suela de caucho, plástico, cuero natural o regenerado y parte superior de materia textil',64);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6405,'Outro calçado','Other footwear','Los demás calzados',64);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6406,'Partes de calçado (incluídas as partes superiores, mesmo fixadas a solas que não sejam as solas exteriores); palmilhas amovíveis; reforços interiores e artefactos semelhantes amovíveis; polainas, perneiras e artefactos semelhantes, e suas partes','Parts of footwear (including uppers whether or not attached to soles other than outer soles); removable insoles, heel cushions and similar articles; gaiters, leggings and similar articles, and parts thereof','Partes de calzado, incluidas las partes superiores fijadas a las palmillas distintas de la suela; plantillas, taloneras y artículos similares, amovibles; polainas, botines y artículos similares, y sus partes',64);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6501,'esbocos n/enformados,  discos,  etc.de feltro,  p/chapeus','hat-forms, plateaux, etc.of felt, f/hat','cascos sin forma, platos, etc.de fieltro, p/sombreros',65);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6502,'Esboços de chapéus, entrançados ou obtidos por reunião de tiras de qualquer matéria, sem copa nem aba enformadas e sem guarnições','Hat shapes, plaited or assembled strips, any material','Cascos para sombreros, trenzados o tiras reunidas, cualquier material',65);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6503,'Chapéus e outs.artefs.de feltro, obtidos dos esboços, etc','Felt hats and oth.felt headgear, obt. hat bodies, etc','Sombreros y demás tocados de fieltro, fabric.cascos, etc',65);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6504,'Chapéus e outros artefatos de uso semelhante, entrançados por tiras, de qualquer matéria','Hats and other headgear, plaitd/assmbled strips any material','Sombreros y demás tocados, bandas plaitd / assmbled cualquier otro material',65);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6505,'Chapéus e outros artefactos de uso semelhante, de malha ou confeccionados com rendas, feltro ou outros produtos têxteis, em peça (mas não em tiras), mesmo guarnecidos; coifas e redes, para o cabelo, de qualquer matéria, mesmo guarnecidas','Hats and other headgear, knitted or crocheted, or made-up from lace, felt or other textile fabric, in the piece (but not in strips), whether or not lined or trimmed; hairnets of any material, whether or not lined or trimmed','Sombreros y demás tocados, de punto o confeccionados con encaje, fieltro u otro producto textil en pieza (pero no en tiras), incluso guarnecidos; redecillas para el cabello, de cualquier materia, incluso guarnecidas',65);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6506,'Outros chapéus e artefactos de uso semelhante, mesmo guarnecidos','Other headgear, whether or not lined or trimmed','Demás sombreros y tocados, incluso guarnecidos',65);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6507,'Tiras p/guarn.interior,  forros,  etc.p/chapeus/outs.artefs','Strips f/interior garrison, linings, etc.f/headgear','Desudadores, forros, etc.para sombreros y demás tocados',65);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6601,'Guarda-chuvas, sombrinhas e guarda-sóis (incluindo as bengalas-guarda-chuvas e os guarda-sóis de jardim e semelhantes)','Umbrellas and sun umbrellas (including walking-stick umbrellas, garden umbrellas and similar umbrellas)','Paraguas, sombrillas y quitasoles, incluidos los paraguas bastón, los quitasoles toldo y artículos similares',66);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6602,'Bengalas, bengalas-assentos, chicotes e artefatos semelhantes','Walking-sticks, seat-sticks, whips and the like','Bastones, bastones asiento, látigos y artículos similares',66);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6603,'Partes, guarnições e acessórios, para os artefactos das posições 6601 e 6602','Parts, trimmings and accessories of articles of heading No 6601 or 6602','Partes, guarniciones y accesorios para los artículos de las partidas 6601 ó 6602',66);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6701,'Peles/outras partes de aves, com suas penas, etc.trabalhados','Skins/oth.parts of birds with their feathers, etc.worked','Pieles/demás partes de aves, c/sus plumas, etc.trabajados',67);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6702,'Flores, folhagem e frutos, artificiais, e suas partes; artefactos confeccionados com flores, folhagem e frutos, artificiais','Artificial flowers, foliage and fruit and parts thereof; articles made of artificial flowers, foliage or fruit','Flores, follaje y frutos, artificiales, y sus partes; artículos confeccionados con flores, follaje o frutos, artificiales',67);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6703,'Cabelos, lã e outs.mater.têxteis prepars.p/fabr.perucas','Human hair, wool and other textile mat.prep. for wigs production','Cabellos, lana y ots.mater.text.prepars.p/fabr.pelucas',67);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6704,'Perucas, barbas, sobrancelhas, pestanas, madeixas e artefactos semelhantes de cabelo, pêlos ou de matérias têxteis; outras obras de cabelo não especificadas nem compreendidas em outras posições','Wigs, false beards, eyebrows and eyelashes, switches and the like, of human or animal hair or of textile materials; articles of human hair not elsewhere specified or included','Pelucas, barbas, cejas, pestañas, mechones y artículos análogos, de cabello, pelo o materia textil; manufacturas de cabello no expresadas ni comprendidas en otra parte',67);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6801,'Pedra para calcetar meio-fio e placa p/pavim.de pedra nat.','setts, curbstones and flagstones, f/pav.of natural stone','adoquines, encitado y losa p/pavimentos de piedra natur.',68);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6802,'Pedras de cantaria ou de construção (exceto de ardósia) trabalhadas e obras destas pedras, exceto as da posição 6801; cubos, pastilhas e artigos semelhantes, para mosaicos, de pedra natural (incluída a ardósia), mesmo com suporte; grânulos, fragmentos e','Worked monumental or building stone (except slate) and articles thereof, other than goods of heading 6801; mosaic cubes and the like, of natural stone (including slate), whether or not on a backing; artificially coloured granules, chippings and powder, of','Piedra de talla o de construcción trabajada (excluida la pizarra) y sus manufacturas (excepto de la partida 6801); cubos, dados y artículos similares para mosaicos, de piedra natural, incluida la pizarra, aunque estén sobre soporte; gránulos, tasquiles (f',68);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6803,'Ardósia natural trabalhada e obras de ardósia nat/aglom','worked slate and articles of slate/agglomerated slate','pizarra natural trabajada y manuf.de pizarra nat/aglom',68);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6804,'Mós e artefactos semelhantes, sem armação, para moer, desfibrar, triturar, amolar, polir, rectificar ou cortar; pedras para amolar ou para polir, manualmente, e suas partes, de pedras naturais, de abrasivos naturais ou artificiais aglomerados ou de cerâmi','Millstones, grindstones, grinding wheels and the like, without frameworks, for grinding, sharpening, polishing, trueing or cutting, hand sharpening or polishing stones, and parts thereof, of natural stone, of agglomerated natural or artificial abrasives, ','Muelas y artículos similares, sin bastidor, para moler, desfibrar, triturar, afilar, pulir, rectificar, cortar o trocear, piedras de afilar o pulir a mano, y sus partes, de piedra natural, de abrasivos naturales o artificiales aglomerados o de cerámica, i',68);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6805,'Abrasivos naturais ou artificiais, em pó ou em grãos, aplicados sobre matérias têxteis, papel, cartão ou outras matérias, mesmo recortados, costurados ou reunidos de outro modo','Natural or artificial abrasive powder or grain, on a base of textile material, of paper, of paperboard or of other materials, whether or not cut to shape or sewn or otherwise made-up','Abrasivos naturales o artificiales en polvo o gránulos con soporte de materia textil, papel, cartón u otras materias, incluso recortados, cosidos o unidos de otra forma',68);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6806,'Lãs de escórias de altos fornos, de outras escórias, lã de rocha e lãs minerais semelhantes; vermiculite e argilas, expandidas, espuma de escórias e produtos minerais semelhantes, expandidos; misturas e obras de matérias minerais para isolamento do calor ','Slag wool, rock wool and similar mineral wools; exfoliated vermiculite, expanded clays, foamed slag and similar expanded mineral materials; mixtures and articles of heat-insulating, sound-insulating or sound-absorbing mineral materials, other than those o','Lana de escoria, de roca y lanas minerales similares, vermiculita dilatada, arcilla dilatada, espuma de escoria y productos minerales similares dilatados; mezclas y manufacturas de materias minerales para aislamiento térmico o acústico o para la absorción',68);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6807,'Obras de asfalto ou de produtos semelhantes (por exemplo: breu ou pez)','Articles of asphalt or of similar material (for example, petroleum bitumen or coal tar pitch)','Manufacturas de asfalto o de productos similares (por ejemplo: pez de petróleo, brea)',68);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6808,'paineis e semelh.de fibra veget/palha aglom.cimento,  etc','panels and simil.of veget.fibre/straw, agglom.cemen.etc','paneles y similar.de fibra veget/paja aglom.cemento, etc',68);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6809,'Obras de gesso ou de composições à base de gesso','Articles of plaster or of compositions based on plaster','Manufacturas de yeso fraguable o de preparaciones a base de yeso fraguable',68);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6810,'Obras de cimento, de betão (concreto) ou de pedra artificial, mesmo armadas','Articles of cement, of concrete or of artificial stone, whether or not reinforced','Manufacturas de cemento, hormigón o piedra artificial, incluso armadas',68);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6811,'Obras de fibrocimento, cimento-celulose e produtos semelhantes','Articles of asbestos-cement, of cellulose fibre-cement or the like','Manufacturas de amiantocemento, celulosacemento o similares',68);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6812,'Amianto (asbesto) trabalhado, em fibras; misturas à base de amianto ou à base de amianto e carbonato de magnésio; obras destas misturas ou de amianto (por exemplo: fios, tecidos, vestuário, chapéus e artefactos de uso semelhante, calçado, juntas), mesmo a','Fabricated asbestos fibres; mixtures with a basis of asbestos or with a basis of asbestos and magnesium carbonate; articles of such mixtures or of asbestos (for example, thread, woven fabric, clothing, headgear, footwear, gaskets), whether or not reinforc','Amianto (asbesto) en fibras trabajado; mezclas a base de amianto o a base de amianto y carbonato de magnesio; manufacturas de estas mezclas o de amianto (por ejemplo: hilados, tejidos, prendas de vestir, sombreros y demás tocados, calzado, juntas), inclus',68);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6813,'Guarnições de fricção (por exemplo: placas, rolos, tiras, segmentos, discos, anéis, pastilhas), não montadas, para travões (freios), embraiagens ou qualquer outro mecanismo de fricção, à base de amianto (asbesto), de outras substâncias minerais ou de celu','Friction material and articles thereof (for example, sheets, rolls, strips, segments, discs, washers, pads), not mounted, for brakes, for clutches or the like, with a basis of asbestos, of other mineral substances or of cellulose, whether or not combined ','Guarniciones de fricción (por ejemplo: hojas, rollos, tiras, segmentos, discos, arandelas, plaquitas) sin montar, para frenos, embragues o cualquier órgano de frotamiento, a base de amianto (asbesto), de otras sustancias minerales o de celulosa, incluso c',68);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6814,'Mica trabalhada e suas obras, incluída a mica aglomerada ou reconstituída, mesmo com suporte de papel, de cartão ou de outras matérias','Worked mica and articles of mica, including agglomerated or reconstituted mica, whether or not on a support of paper, paperboard or other materials','Mica trabajada y manufacturas de mica, incluida la aglomerada o reconstituida, incluso con soporte de papel, cartón u otras materias',68);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6815,'Obras de pedra ou de outras matérias minerais (incluídas as fibras de carbono, as obras destas matérias ou de turfa), não especificadas nem compreendidas noutras posições','Articles of stone or of other mineral substances (including carbon fibres, articles of carbon fibres and articles of peat), not elsewhere specified or included','Manufacturas de piedra o demás materias minerales, incluidas las fibras de carbono y sus manufacturas y las manufacturas de turba, no expresadas ni comprendidas en otra parte',68);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6901,'Tijolos/outs.pecas ceram.de farinhas silíciosas fosseis','Brincks/other pieces ceramic of fossil siliceous meals','Ladrillos/ots.piezas cerám.de harinas silíceas fósiles',69);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6902,'Tijolos, placas (lajes), ladrilhos e peças cerâmicas semelhantes, para construção, refractários, que não sejam de farinhas siliciosas fósseis nem de terras siliciosas semelhantes','Refractory bricks, blocks, tiles and similar refractory ceramic constructional goods, other than those of siliceous fossil meals or similar siliceous earths','Ladrillos, placas, baldosas y demás piezas cerámicas análogas de construcción, refractarios (excepto los de harinas silíceas fósiles o de tierras silíceas análogas)',69);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6903,'Outros produtos cerâmicos refractários (por exemplo: retortas, cadinhos, muflas, bocais, tampões, suportes, copelas, tubos, mangas, varetas) que não sejam de farinhas siliciosas fósseis nem de terras siliciosas semelhantes','Refractory ceramic goods, retorts, tubes, etc','Demás productos cerámicos refractarios (por ejemplo: retortas, crisoles, muflas, toberas, tapones, soportes, copelas, tubos, fundas, varillas) (excepto los de harinas silíceas fósiles o de tierras silíceas análogas)',69);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6904,'Tijolos para construção, tijoleiras, tapa-vigas e produtos semelhantes, de cerâmica','Ceramic building bricks, flooring blocks, support or filler tiles and the like','Ladrillos de construcción, bovedillas, cubrevigas y artículos similares, de cerámica',69);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6905,'Telhas, elementos de chaminés, condutores de fumo, ornamentos arquitectónicos, de cerâmica, e outros produtos cerâmicos para construção','Roofing tiles, chimney-pots, cowls, chimney liners, architectural ornaments and other ceramic constructional goods','Tejas, elementos de chimenea, conductos de humo, ornamentos arquitectónicos y otros artículos cerámicos de construcción',69);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6906,'Tubos, calhas/algerozes e acess.p/canaliz.de cerâmica','Ceramic pipes, conduits, guttering/pipe fittings','Tubos, canalones y acces.de tubería de cerámica',69);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6907,'Ladrilhos e placas (lajes), para pavimentação ou revestimento, não vidrados nem esmaltados, de cerâmica; cubos, pastilhas e artigos semelhantes, para mosaicos, não vidrados nem esmaltados, de cerâmica, mesmo com suporte','Unglazed ceramic flags and paving, hearth or wall tiles; unglazed ceramic mosaic cubes and the like, whether or not on a backing','Placas y baldosas, de cerámica, sin barnizar ni esmaltar, para pavimentación o revestimiento; cubos, dados y artículos similares, de cerámica, para mosaicos, sin barnizar ni esmaltar, incluso con soporte',69);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6908,'Ladrilhos e placas (lajes), para pavimentação ou revestimento, vidrados ou esmaltados, de cerâmica; cubos, pastilhas e artigos semelhantes, para mosaicos, vidrados ou esmaltados, de cerâmica, mesmo com suporte','Glazed ceramic flags and paving, hearth or wall tiles; glazed ceramic mosaic cubes and the like, whether or not on a backing','Placas y baldosas, de cerámica, barnizadas o esmaltadas, para pavimentación o revestimento; cubos, dados y artíciulos similares, de cerámica, para mosaicos, barnizados o esmaltados, incluso con soporte',69);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6909,'Aparelhos e artefactos para usos químicos ou para outros usos técnicos, de cerâmica; alguidares, gamelas e outros recipientes semelhantes para usos rurais, de cerâmica; bilhas e outras vasilhas próprias para transporte ou embalagem, de cerâmica','Ceramic wares for laboratory, chemical or other technical uses; ceramic troughs, tubs and similar receptacles of a kind used in agriculture; ceramic pots, jars and similar articles of a kind used for the conveyance or packing of goods','Aparatos y artículos, de cerámica, para usos químicos o demás usos técnicos; abrevaderos, pilas y recipientes similares, de cerámica, para uso rural; cántaros y recipientes similares, de cerámica, para transporte o envasado',69);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6910,'Pias, lavatórios, colunas para lavatórios, banheiras, bidés, sanitários, reservatórios de autoclismos, mictórios e aparelhos fixos semelhantes para usos sanitários, de cerâmica','Ceramic sinks, wash basins, wash basin pedestals, baths, bidets, water closet pans, flushing cisterns, urinals and similar sanitary fixtures','Fregaderos (piletas de lavar), lavabos, pedestales de lavabo, bañeras, bidés, inodoros, cisternas (depósitos de agua) para inodoros, urinarios y aparatos fijos similares, de cerámica, para usos sanitarios',69);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6911,'Louça, outros artigos de uso doméstico e artigos de higiene ou de toucador, de porcelana','Tableware, kitchenware, other household articles and toilet articles, of porcelain or china','Vajilla y demás artículos de uso doméstico, higiene o tocador, de porcelana',69);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6912,'Louças/outs.artigos,uso doméstico,etc.de outs.cerâmicas','Ceramic tableware/other household articles, etc.','Vajillas/ots.artículos, uso domést., etc.de ots.cerámicas',69);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6913,'Estatuetas e outros objectos de ornamentação, de cerâmica','Statuettes and other ornamental ceramic articles','Estatuillas y demás artículos para adorno, de cerámica',69);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (6914,'Outras obras de cerâmica','Other ceramic articles','Las demás manufacturas de cerámica',69);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7001,'Cacos/outros resíduos de vidro e vidro em blocos/massas','Cullet/other waste and scrap of glass/glass in the mass','Desperdicios y desechos de vidrio y vidrio en masas',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7002,'Vidro em esferas (exceto as microsferas da posição 7018), barras, varetas e tubos, não trabalhado','Glass in balls (other than microspheres of heading No 7018), rods or tubes, unworked','Vidrio en bolas (excepto las microesferas de la partida 7018), barras, varillas o tubos, sin trabajar',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7003,'Vidro vazado ou laminado, em chapas, folhas ou perfis, mesmo com camada absorvente, reflectora ou não, mas sem qualquer outro trabalho','Cast glass and rolled glass, in sheets or profiles, whether or not having an absorbent, reflecting or non-reflecting layer, but not otherwise worked','Vidrio colado o laminado, en placas, hojas o perfiles, incluso con capa absorbente, reflectante o antirreflectante, pero sin trabajar de otro modo',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7004,'Vidro estirado ou soprado, em folhas, mesmo com camada absorvente, reflectora ou não, mas sem qualquer outro trabalho','Drawn glass and blown glass, in sheets, whether or not having an absorbent, reflecting or non-reflecting layer, but not otherwise worked','Vidrio estirado o soplado, en hojas, incluso con capa absorbente, reflectante o antirreflectante, pero sin trabajar de otro modo',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7005,'Vidro « flotado » e vidro desbastado ou polido numa ou em ambas as faces, em chapas ou em folhas, mesmo de camada absorvente, reflectora ou não, mas sem qualquer outro trabalho','Float glass and surface ground or polished glass, in sheets, whether or not having an absorbent, reflecting or non-reflecting layer, but not otherwise worked','Vidrio flotado y vidrio desbastado o pulido por una o las dos caras, en placas u hojas, incluso con capa absorbente, reflectante o antirreflectante, pero sin trabajar de otro modo',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7006,'vidro vazado, estirado, flotado ou desbastado, trabalhado','cast glass/drawn, float or surface ground, worked','vidrio vazado, estirado, flotado o desbastado, trabajado',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7007,'Vidros de segurança consistindo em vidros temperados ou formados por folhas contracoladas','Safety glass, consisting of toughened (tempered) or laminated glass','Vidrio de seguridad constituido por vidrio templado o contrachapado',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7008,'Vidros isolantes de paredes multiplas','multiple-walled insulating units of glass','vidrieras aislantes de paredes múltiples',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7009,'Espelhos de vidro, mesmo emoldurados, incluídos os espelhos retrovisores','Glass mirrors, whether or not framed, including rear-view mirrors','Espejos de vidrio enmarcados o no, incluidos los espejos retrovisores',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7010,'Garrafões, garrafas, frascos, boiões, vasos, embalagens tubulares, ampolas e outros recipientes de vidro próprios para transporte ou embalagem; boiões de vidro, para conserva; rolhas, tampas e outros dispositivos de uso semelhante, de vidro','Carboys, bottles, flasks, jars, pots, phials, ampoules and other containers, of glass, of a kind used for the conveyance or packing of goods; preserving jars of glass; stoppers, lids and other closures, of glass','Bombonas (damajuanas), botellas, frascos, bocales, tarros, envases tubulares, ampollas y demás recipientes para el transporte o envasado, de vidrio; bocales para conservas, de vidrio; tapones, tapas y demás dispositivos de cierre, de vidrio',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7011,'Ampolas e invólucros, mesmo tubulares, abertos, e suas partes, de vidro, sem guarnições, para lâmpadas elétricas, tubos catódicos ou semelhantes','Glass envelopes (including bulbs and tubes), open, and glass parts thereof, without fittings, for electric lamps, cathode-ray tubes or the like','Ampollas y envolturas tubulares, abiertas, y sus partes, de vidrio, sin guarniciones, para lámparas eléctricas, tubos catódicos o similares',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7012,'ampolas de vidro,  p/garrafas termicas,  etc.isolam.a vácuo','glass inners f/vacuum flask, etc.vacuum vessels','ampollas de vidrio, p/botellas térmicas, etc.aisl.p/vacío',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7013,'Objectos de vidro para serviço de mesa, cozinha, toucador, escritório, ornamentação de interiores ou usos semelhantes, exceto os das posições 7010 ou 7018','Glassware of a kind used for table, kitchen, toilet, office, indoor decoration or similar purposes (other than that of heading No 7010 or 7018)','Artículos de vidrio para servicio de mesa, cocina, tocador, oficina, para adorno de interiores o usos similares (excepto los de las partidas 7010 ó 7018)',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7014,'artefatos de vidro para sinalização, etc.','signalling glassware, etc','artículos de vidrio para señalización, etc',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7015,'Vidros para relógios e aparelhos semelhantes e vidros semelhantes, vidros para lentes, mesmo correctivas, curvos ou arqueados, ocos ou semelhantes, não trabalhados opticamente; esferas ocas e segmentos de esferas, de vidro, para fabricação desses vidros','Clock or watch glasses and similar glasses, glasses for non-corrective or corrective spectacles, curved, bent, hollowed or the like, not optically worked; hollow glass spheres and their segments, for the manufacture of such glasses','Cristales para relojes y cristales análogos, cristales para gafas (anteojos), incluso correctores, abombados, curvados, ahuecados o similares, sin trabajar ópticamente; esferas huecas y sus segmentos (casquetes esféricos) de vidrio, para la fabricación de',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7016,'Blocos, placas, tijolos, ladrilhos, telhas e outros artefactos, de vidro prensado ou moldado, mesmo armado, para construção; cubos, pastilhas e outros artigos semelhantes, de vidro, mesmo com suporte, para mosaicos ou decorações semelhantes; vitrais de vi','Paving blocks, slabs, bricks, squares, tiles and other articles of pressed or moulded glass, whether or not wired, of a kind used for building or construction purposes; glass cubes and other glass smallwares, whether or not on a backing, for mosaics or si','Adoquines, boldosas, ladrillos, placas, tejas y demás artículos, de vidrio prensado o moldeado, incluso armado, para la construcción; cubos, dados y demás artículos similares, de vidrio, incluso con soporte, para mosaicos o decoraciones similares; vidrier',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7017,'Artefactos de vidro para laboratório, higiene e farmácia, mesmo graduados ou calibrados','Laboratory, hygienic or pharmaceutical glassware, whether or not graduated or calibrated','Artículos de vidrio para laboratorio, higiene o farmacia, incluso graduados o calibrados',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7018,'Contas, imitações de pérolas naturais ou cultivadas, imitações de pedras preciosas ou semipreciosas e artefactos semelhantes de vidro e suas obras, exceto de bijutaria; olhos de vidro, exceto de prótese; estatuetas e outros objectos de ornamentação, de ','Glass beads, imitation pearls, imitation precious or semi-precious stones and similar glass smallwares, and articles thereof other than imitation jewellery; glass eyes other than prosthetic articles; statuettes and other ornaments of lamp-worked glass, ot','Cuentas de vidrio, imitaciones de perlas, de piedras preciosas o semipreciosas y artículos similares de abalorio y sus manufacturas (excepto la bisutería); ojos de vidrio (excepto los de prótesis); estatuillas y demás artículos de adorno, de vidrio trabaj',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7019,'Fibras de vidro (incluída a lã de vidro) e suas obras (por exemplo: fios, tecidos)','Glass fibres (including glass wool) and articles thereof (for example, yarn, woven fabrics)','Fibra de vidrio (incluida la lana de vidrio) y manufacturas de estas materias (por ejemplo: hilados o tejidos)',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7020,'Outras obras de vidro','Articles of glass','Artículos de vidrio',70);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7101,'Pérolas naturais ou cultivadas, mesmo trabalhadas ou combinadas, mas não enfiadas, nem montadas, nem engastadas; pérolas naturais ou cultivadas, enfiadas temporariamente para facilidade de transporte','Pearls, natural or cultured, whether or not worked or graded but not strung, mounted or set; pearls, natural or cultured, temporarily strung for convenience of transport','Perlas finas (naturales o cultivadas), incluso trabajadas o clasificadas, pero sin ensartar, montar ni engarzar; perlas finas (naturales o cultivadas), ensartadas temporalmente para facilitar el transporte',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7102,'Diamantes, mesmo trabalhados, mas não montados nem engastados','Diamonds, whether or not worked, but not mounted or set','Diamantes, incluso trabajados, sin montar ni engarzar',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7103,'Pedras preciosas (exceto diamantes) ou semipreciosas, mesmo trabalhadas ou combinadas, mas não enfiadas, nem montadas, nem engastadas; pedras preciosas (exceto diamantes) ou semipreciosas, não combinadas, enfiadas temporariamente para facilidade de tran','Precious stones (other than diamonds) and semi-precious stones, whether or not worked or graded but not strung, mounted or set; ungraded precious stones (other than diamonds) and semi-precious stones, temporarily strung for convenience of transport','Piedras preciosas (excepto los diamantes) o semipreciosas, naturales, incluso trabajadas o clasificadas, sin ensartar, montar ni engarzar; piedras preciosas (excepto los diamantes) o semipreciosas, naturales, sin clasificar, ensartadas temporalmente para ',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7104,'Pedras sintéticas ou reconstituídas, mesmo trabalhadas ou combinadas, mas não enfiadas, nem montadas, nem engastadas; pedras sintéticas ou reconstituídas, não combinadas, enfiadas temporariamente para facilidade de transporte','Synthetic or reconstructed precious or semi-precious stones, whether or not worked or graded but not strung, mounted or set; ungraded synthetic or reconstructed precious or semi-precious stones, temporarily strung for convenience of transport','Piedras sintéticas o reconstituidas, incluso trabajadas o clasificadas, sin enfilar, montar ni engarzar; piedras sintéticas o reconstituidas, sin clasificar, enfiladas temporalmente para facilitar el transporte',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7105,'Pó de diamantes, de pedras preciosas ou semipreciosas ou de pedras sintéticas','Dust and powder of natural or synthetic precious or semi-precious stones','Polvo de piedras preciosas o semipreciosas, naturales o sintéticas',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7106,'Prata (incluída a prata dourada ou platinada), em formas brutas ou semimanufacturadas, ou em pó','Silver (including silver plated with gold or platinum), unwrought or in semi-manufactured forms, or in powder form','Plata, incluida la plata dorada y la platinada, en bruto, semilabrada o en polvo',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7107,'metais comuns folheados, etc.de prata, em bruto, semimanufaturado','base metals clad, etc.of silver, unwrought, semi-manuf.','chapado de plata sobre metal común, en bruto, semilabrado',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7108,'Ouro (incluído o ouro platinado), em formas brutas ou semimanufacturadas, ou em pó','Gold (including gold plated with platinum), unwrought or in semi-manufactured forms, or in powder form','Oro, incluido el oro platinado, en bruto, semilabrado o en polvo',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7109,'metais comuns/prata,  folheado/chapeado ouro,  em bruto,  etc','base metals/silver, clad with gold n/further worked, etc','metales comunes/plata/chapado oro, en bruto, etc',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7110,'Platina, em formas brutas ou semimanufacturadas, ou em pó','Platinum, unwrought or in semi-manufactured forms, or in powder form','Platino en bruto, semilabrado o en polvo',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7111,'metais comuns/prata/ouro, folh/chap.platina, em bruto, etc','base metals/silver/gold, clad with platinum, n/worked, etc','chapado de platino sobr.metal común/plata/oro, bruto, etc',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7112,'Desperdícios e resíduos de metais preciosos ou de metais folheados ou chapeados de metais preciosos; outros desperdícios e resíduos contendo metais preciosos ou compostos de metais preciosos, do tipo dos utilizados principalmente para a recuperação de met','Waste and scrap of precious metal or of metal clad with precious metal; other waste and scrap containing precious metal or precious metal compounds, of a kind used principally for the recovery of precious metal','Desperdicios y desechos, de metal precioso o de chapado de metal precioso (plaqué); demás desperdicios y desechos que contengan metal precioso o compuestos de metal precioso, de los tipos utilizados principalmente para la recuperación del metal precioso',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7113,'Artefactos de joalharia e suas partes, de metais preciosos ou de metais folheados ou chapeados de metais preciosos','Articles of jewellery and parts thereof, of precious metal or of metal clad with precious metal','Artículos de joyería y sus partes, de metal precioso o de chapado de metal precioso (plaqué)',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7114,'Artefactos de ourivesaria e suas partes, de metais preciosos ou de metais folheados ou chapeados de metais preciosos','Articles of goldsmiths'' or silversmiths'' wares and parts thereof, of precious metal or of metal clad with precious metal','Artículos de orfebrería y sus partes, de metal precioso o de chapado de metal precioso (plaqué)',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7115,'Outras obras de metais preciosos ou de metais folheados ou chapeados de metais preciosos','Other articles of precious metal or of metal clad with precious metal','Las demás manufacturas de metal precioso o de chapado de metal precioso (plaqué)',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7116,'Obras de pérolas naturais ou cultivadas, de pedras preciosas ou semipreciosas, pedras sintéticas ou reconstituídas','Articles of natural or cultured pearls, precious or semi-precious stones (natural, synthetic or reconstructed)','Manufacturas de perlas finas (naturales) o cultivadas, de piedras preciosas, semipreciosas (naturales, sintéticas o reconstituidas)',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7117,'Bijutarias','Imitation jewellery','Bisutería',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7118,'Moedas','Coin','Monedas',71);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7201,'Ferro fundido bruto e ferro spiegel (especular), em lingotes, linguados ou outras formas primárias','Pig iron and spiegeleisen in pigs, blocks or other primary forms','Fundición en bruto y fundición especular, en lingotes, bloques u otras formas primarias',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7202,'Ferro-ligas','Ferro-alloys','Ferroaleaciones',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7203,'Produtos ferrosos obtidos por redução directa dos minérios de ferro e outros produtos ferrosos esponjosos, em pedaços, esferas ou formas semelhantes; ferro de pureza mínima, em peso, de 99,94 %, em pedaços, esferas ou formas semelhantes','Ferrous products obtained by direct reduction of iron ore and other spongy ferrous products, in lumps, pellets or similar forms; iron having a minimum purity by weight of 99,94 %, in lumps, pellets or similar forms','Productos férreos obtenidos por reducción directa de minerales de hierro y demás productos férreos esponjosos, en trozos, pellets o formas similares; hierro con una pureza superior o igual al 99,94 % en peso, en trozos, pellets o formas similares',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7204,'Desperdícios, resíduos e sucata de ferro fundido, ferro ou aço; desperdícios de ferro ou aço, em lingotes','Ferrous waste and scrap; remelting scrap ingots of iron or steel','Desperdicios y desechos (chatarra), de fundición, hierro o acero; lingotes de chatarra de hierro o acero',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7205,'Granalha e pó de ferro fundido bruto, de ferro spiegel (especular), de ferro ou aço','Granules and powders, of pig iron, spiegeleisen, iron or steel','Granallas y polvo, de fundición en bruto, de fundición especular, de hierro o de acero',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7206,'Ferro e aço não ligado, em lingotes ou outras formas primárias, exceto o ferro da posição 7203','Iron and non-alloy steel in ingots or other primary forms (excluding iron of heading No 7203)','Hierro y acero sin alear, en lingotes o demás formas primarias (excepto el hierro de la partida 7203)',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7207,'Produtos semimanufacturados de ferro ou aço não ligado','Semi-finished products of iron or non-alloy steel','Productos intermedios de hierro o acero sin alear',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7208,'Produtos laminados planos, de ferro ou aço não ligado, de largura igual ou superior a 600 mm, laminados a quente, não folheados ou chapeados, nem revestidos','Flat-rolled products of iron or non-alloy steel, of a width of 600 mm or more, hot-rolled, not clad, plated or coated','Productos laminados planos de hierro o acero sin alear, de anchura superior o igual a 600 mm, laminados en caliente, sin chapar ni revestir',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7209,'Produtos laminados planos, de ferro ou aço não ligado, de largura igual ou superior a 600 mm, laminados a frio, não folheados ou chapeados, nem revestidos','Flat-rolled products of iron or non-alloy steel, of a width of 600 mm or more, cold-rolled (cold-reduced), not clad, plated or coated','Productos laminados planos de hierro o acero sin alear, de anchura superior o igual a 600 mm, laminados en frío, sin chapar ni revestir',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7210,'Produtos laminados planos de ferro ou aço não ligado, de largura igual ou superior a 600 mm, folheados ou chapeados, ou revestidos','Flat-rolled products of iron or non-alloy steel, of a width of 600 mm or more, clad, plated or coated','Productos laminados planos de hierro o acero sin alear, de anchura superior o igual a 600 mm, chapados o revestidos',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7211,'Produtos laminados planos, de ferro ou aço não ligado, de largura inferior a 600 mm, não folheados ou chapeados, nem revestidos','Flat-rolled products of iron or non-alloy steel, of a width of less than 600 mm, not clad, plated or coated','Productos laminados planos de hierro o acero sin alear, de anchura inferior a 600 mm, sin chapar ni revestir',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7212,'Produtos laminados planos de ferro ou aço não ligado, de largura inferior a 600 mm, folheados ou chapeados, ou revestidos','Flat-rolled products of iron or non-alloy steel, of a width of less than 600 mm, clad, plated or coated','Productos laminados planos de hierro o acero sin alear, de anchura inferior a 600 mm, chapados o revestidos',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7213,'Fio-máquina de ferro ou aço não ligado','Bars and rods, hot-rolled, in irregularly wound coils, of iron or non-alloy steel','Alambrón de hierro o acero sin alear',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7214,'Barras de ferro ou aço não ligado, simplesmente forjadas, laminadas, estiradas ou extrudadas, a quente, incluídas as que tenham sido submetidas a torção após laminagem','Other bars and rods of iron or non-alloy steel, not further worked than forged, hot-rolled, hot-drawn or hot-extruded, but including those twisted after rolling','Barras de hierro o acero sin alear, simplemente forjadas, laminadas o extrudidas, en caliente, así como las sometidas a torsión después del laminado',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7215,'Outras barras de ferro ou aço não ligado','Other bars and rods of iron or non-alloy steel','Las demás barras de hierro o acero sin alear',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7216,'Perfis de ferro ou aço não ligado','Angles, shapes and sections of iron or non-alloy steel','Perfiles de hierro o acero sin alear',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7217,'Fios de ferro ou aço não ligado','Wire of iron or non-alloy steel','Alambre de hierro o de acero sin alear',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7218,'Aço inoxidável, em lingotes ou outras formas primárias; produtos semimanufacturados de aço inoxidável','Stainless steel in ingots or other primary forms; semi-finished products of stainless steel','Acero inoxidable en lingotes o demás formas primarias; productos intermedios de acero inoxidable',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7219,'Produtos laminados planos de aço inoxidável, de largura igual ou superior a 600 mm','Flat-rolled products of stainless steel, of a width of 600 mm or more','Productos laminados planos de acero inoxidable, de anchura superior o igual a 600 mm',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7220,'Produtos laminados planos de aço inoxidável, de largura inferior a 600 mm','Flat-rolled products of stainless steel, of a width of less than 600 mm','Productos laminados planos de acero inoxidable, de anchura inferior a 600 mm',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7221,'Fio-máquina de aços inoxidáveis','thread-machine of stainless steel','alambrón de aceros inoxidables',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7222,'Barras e perfis de aço inoxidável','Other bars and rods of stainless steel; angles, shapes and sections of stainless steel','Barras y perfiles, de acero inoxidable',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7223,'Fios de aços inoxidáveis','wire of stainless steel','alambre de aceros inoxidables',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7224,'Outras ligas de aço, em lingotes ou outras formas primárias; produtos semimanufacturados, de outras ligas de aço','Other alloy steel in ingots or other primary forms; semi-finished products of other alloy steel','Los demás aceros aleados en lingotes o demás formas primarias; productos intermedios de los demás aceros aleados',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7225,'Produtos laminados planos, de outras ligas de aço, de largura igual ou superior a 600 mm','Flat-rolled products of other alloy steel, of a width of 600 mm or more','Productos laminados planos de los demás aceros aleados, de anchura superior o igual a 600 mm',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7226,'Produtos laminados planos, de outras ligas de aço, de largura inferior a 600 mm','Flat-rolled products of other alloy steel, of a width of less than 600 mm','Productos laminados planos de los demás aceros aleados, de anchura inferior a 600 mm',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7227,'Fio-máquina de outras ligas de aço','Bars and rods, hot-rolled, in irregularly wound coils, of other alloy steel','Alambrón de los demás aceros aleados',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7228,'Barras e perfis, de outras ligas de aço; barras ocas para perfuração, de ligas de aço ou de aço não ligado','Other bars and rods of other alloy steel; angles, shapes and sections, of other alloy steel; hollow drill bars and rods, of alloy or non-alloy steel','Barras y perfiles, de los demás aceros aleados; barras huecas para perforación, de aceros aleados o sin alear',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7229,'Fios de outras ligas de aço','Wire of other alloy steel','Alambre de los demás aceros aleados',72);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7301,'Estacas-pranchas de ferro ou aço, mesmo perfuradas ou feitas com elementos montados; perfis obtidos por soldadura, de ferro ou aço','Sheet piling of iron or steel, whether or not drilled, punched or made from assembled elements; welded angles, shapes and sections, of iron or steel','Tablestacas de hierro o acero, incluso perforadas o hechas con elementos ensamblados; perfiles de hierro o acero obtenidos por soldadura',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7302,'Elementos de vias férreas, de ferro fundido, ferro ou aço; carris, contracarris e cremalheiras, agulhas, cróssimas, alavancas para comando de agulhas e outros elementos de cruzamentos e desvios, dormentes, eclissas, coxins de carril, cantoneiras, placas d','Railway or tramway track construction material of iron or steel, the following: rails, check-rails and rack rails, switch blades, crossing frogs, point rods and other crossing pieces, sleepers (cross-ties), fish-plates, chairs, chair wedges, sole plates (','Elementos para vías férreas, de fundición, hierro o acero: carriles (rieles), contracarriles (contrarrieles), y cremalleras, agujas, puntas de corazón, varillas para mando de agujas y otros elementos para cruce o cambio de vías, traviesas (durmientes), br',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7303,'Tubos e perfis ocos,  de ferro fundido','Tubes, pipes and hollow profiles, of cast iron','Tubos y perfiles huecos, de fundición',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7304,'Tubos e perfis ocos, sem costura, de ferro ou aço','Tubes, pipes and hollow profiles, seamless, of iron (other than cast iron) or steel','Tubos y perfiles huecos, sin soldadura (sin costura), de hierro o acero',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7305,'Outros tubos (por exemplo: soldados ou rebitados), de secção circular, de diâmetro exterior superior a 406,4 mm, de ferro ou aço','Other tubes and pipes (for example, welded, riveted or similarly closed), having circular cross-sections, the external diameter of which exceeds 406,4 mm, of iron or steel','Los demás tubos (por ejemplo: soldados o remachados) de sección circular con diámetro exterior superior a 406,4 mm, de hierro o acero',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7306,'Outros tubos e perfis ocos (por exemplo: soldados, rebitados, agrafados ou com os bordos simplesmente aproximados), de ferro ou aço','Other tubes, pipes and hollow profiles (for example, open seam or welded, riveted or similarly closed), of iron or steel','Los demás tubos y perfiles huecos (por ejemplo: soldados, remachados, grapados o con los bordes simplemente aproximados), de hierro o acero',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7307,'Acessórios para tubos [por exemplo: uniões, cotovelos, mangas (luvas)], de ferro fundido, ferro ou aço','Tube or pipe fittings (for example, couplings, elbows, sleeves), of iron or steel','Accesorios de tubería (por ejemplo: empalmes [rácores], codos, manguitos), de fundición, de hierro o acero',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7308,'Construções e suas partes (por exemplo: pontes e elementos de pontes, comportas, torres, pórticos, pilares, colunas, armações, estruturas para telhados, portas e janelas, e seus caixilhos, alizares e soleiras, portas de correr, balaustradas), de ferro fun','Structures (excluding prefabricated buildings of heading 9406) and parts of structures (for example, bridges and bridge-sections, lock-gates, towers, lattice masts, roofs, roofing frameworks, doors and windows and their frames and thresholds for doors, sh','Construcciones y sus partes (por ejemplo: puentes y sus partes, compuertas de esclusas, torres, castilletes, pilares, columnas, armazones para techumbre, techados, puertas y ventanas y sus marcos, contramarcos y umbrales, cortinas de cierre, barandillas),',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7309,'Reservatórios, tonéis, cubas e recipientes semelhantes, de ferro fundido, ferro ou aço, de capacidade > 300 litros, sem dispositivos mecânicos nem térmicos','Tanks etc, over 300 liter capacity, iron or steel','Tanques, etc, más de 300 litros de capacidad, hierro o acero',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7310,'Reservatórios, barris, tambores, latas, caixas e recipientes semelhantes para quaisquer matérias (exceto gases comprimidos ou liquefeitos), de ferro fundido, ferro ou aço, de capacidade não superior a 300 litros, sem dispositivos mecânicos ou térmicos, m','Tanks, casks, drums, cans, boxes and similar containers, for any material (other than compressed or liquefied gas), of iron or steel, of a capacity not exceeding 300 l, whether or not lined or heat-insulated, but not fitted with mechanical or thermal equi','Depósitos, barriles, tambores, bidones, latas o botes, cajas y recipientes similares, para cualquier materia (excepto gas comprimido o licuado), de fundición, hierro o acero, de capacidad inferior o igual a 300 l, sin dispositivos mecánicos ni térmicos, i',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7311,'recipientes de ferro/aço,  p/gases comprimidos/liquefeit.','containers f/compressed/liquefied gas, of iron/steel','recipientes de hierro/acero, p/gas comprimido/licuado',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7312,'Cordas, cabos, entrançados, lingas e artefactos semelhantes, de ferro ou aço, não isolados para usos elétricos','Stranded wire, ropes, cables, plaited bands, slings and the like, of iron or steel, not electrically insulated','Cables, trenzas, eslingas y artículos similares, de hierro o acero, sin aislar para electricidad',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7313,'arame farpado e outros de ferro ou aço,  util.em cercas','barbed wire of other iron or steel, used f/fencing','alambre de púas y otros de hierro o acero, util.p/cercar',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7314,'Telas metálicas (incluídas as telas contínuas ou sem fim), grades e redes, de fios de ferro ou aço; chapas e tiras, distendidas, de ferro ou aço','Cloth (including endless bands), grill, netting and fencing, of iron or steel wire; expanded metal of iron or steel','Telas metálicas, incluidas las continuas o sin fin, redes y rejas, de alambre o de hierro o acero; chapas y tiras, extendidas (desplegadas), de hierro o acero',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7315,'Correntes, cadeias, e suas partes, de ferro fundido, ferro ou aço','Chain and parts thereof, of iron or steel','Cadenas y sus partes, de fundición, hierro o acero',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7316,'âncoras e fateixas e suas partes, de ferro fundido,  etc.','anchors, grapnels and parts thereof, of cast iron, etc.','anclas y rezones y sus partes, de fundición, etc',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7317,'Tachas, pregos, percevejos e artefatos semelhantes, de ferro fundido, ferro ou aço','Nails, tacks, drawing pins etc of iron or steel','Puntas, clavos, chinchetas, etc, de hierro o de acero',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7318,'Parafusos, pernos ou pinos, roscados, porcas, tira-fundos, ganchos roscados, rebites, chavetas, cavilhas, contrapinos ou troços, anilhas ou arruelas (incluídas as de pressão) e artefactos semelhantes, de ferro fundido, ferro ou aço','Screws, bolts, nuts, coach screws, screw hooks, rivets, cotters, cotter-pins, washers (including spring washers) and similar articles, of iron or steel','Tornillos, pernos, tuercas, tirafondos, escarpias roscadas, remaches, pasadores, clavijas, chavetas, arandelas, incluidas las arandelas de muelle (resorte) y artículos similares, de fundición, hierro o acero',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7319,'Agulhas de costura, agulhas de tricô, agulhas-passadoras, agulhas de croché, furadores para bordar e artefactos semelhantes, para uso manual, de ferro ou aço; alfinetes de segurança e outros alfinetes, de ferro ou aço, não especificados nem compreendidos ','Sewing needles, knitting needles, bodkins, crochet hooks, embroidery stilettos and similar articles, for use in the hand, of iron or steel; safety pins and other pins of iron or steel, not elsewhere specified or included','Agujas de coser, de tejer, pasacintas, agujas de ganchillo (croché), punzones para bordar y artículos similares, de uso manual, de hierro o acero; alfileres de gancho (imperdibles) y demás alfileres, de hierro o acero, no expresados ni comprendidos en otr',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7320,'Molas e folhas de molas, de ferro ou aço','Springs and leaves for springs, of iron or steel','Muelles (resortes), ballestas y sus hojas, de hierro o acero',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7321,'Aquecedores (fogões de sala), caldeiras de fornalha, fogões de cozinha (incluídos os que possam ser utilizados acessoriamente no aquecimento central), grelhadores (churrasqueiras), braseiras, fogareiros a gás, aquecedores de pratos, e aparelhos não eléctr','Stoves, ranges, grates, cookers (including those with subsidiary boilers for central heating), barbecues, braziers, gas-rings, plate warmers and similar non-electric domestic appliances, and parts thereof, of iron or steel','Estufas, calderas con hogar, cocinas, incluidas las que puedan utilizarse accesoriamente para calefacción central, barcacoas (parrillas), braseros, hornillos de gas, calientaplatos y aparatos no eléctricos similares, de uso doméstico, y sus partes, de fun',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7322,'Radiadores para aquecimento central, não elétricos, e suas partes, de ferro fundido, ferro ou aço; geradores e distribuidores de ar quente (incluídos os distribuidores que possam também funcionar como distribuidores de ar frio ou condicionado), não eléct','Radiators for central heating, not electrically heated, and parts thereof, of iron or steel; air heaters and hot air distributors (including distributors which can also distribute fresh or conditioned air), not electrically heated, incorporating a motor-d','Radiadores para la calefacción central, de calentamiento no eléctrico, y sus partes, de fundición, hierro o acero; generadores y distribuidores de aire caliente, incluidos los distribuidores que puedan funcionar también como distribuidores de aire fresco ',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7323,'Artefactos de uso doméstico, e suas partes, de ferro fundido, ferro ou aço; palha de ferro ou aço; esponjas, esfregões, luvas e artefactos semelhantes para limpeza, polimento e usos semelhantes, de ferro ou aço','Table, kitchen or other household articles and parts thereof, of iron or steel; iron or steel wool; pot scourers and scouring or polishing pads, gloves and the like, of iron or steel','Artículos de uso doméstico y sus partes, de fundición, hierro o acero; lana de hierro o acero; esponjas, estropajos, guantes y artículos similares para fregar, lustrar o usos análogos, de hierro o acero',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7324,'Artefactos de higiene ou de toucador, e suas partes, de ferro fundido, ferro ou aço','Sanitary ware and parts thereof, of iron or steel','Artículos de higiene o tocador, y sus partes, de fundición, hierro o acero',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7325,'Outras obras moldadas, de ferro fundido, ferro ou aço','Other cast articles of iron or steel','Las demás manufacturas moldeadas de fundición, hierro o acero',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7326,'Outras obras de ferro ou aço','Other articles of iron or steel','Las demás manufacturas de hierro o acero',73);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7401,'Mates de cobre; cobre de cementação (precipitado de cobre)','Copper mattes; cement copper (precipitated copper)','Matas de cobre; cobre de cementación (cobre precipitado)',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7402,'Cobre n/refinado e anodos de cobre p/refin.eletrolitica','unrefined copper  and anodes cop.f/electr.refining','cobre s/refinar y ánodos de cobre p/refin.electrolítico',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7403,'Cobre afinado e ligas de cobre, em formas brutas','Refined copper and copper alloys, unwrought','Cobre refinado y aleaciones de cobre, en bruto',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7404,'Desperdícios e resíduos, de cobre','copper waste and scrap','desperdicios y desechos, de cobre',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7405,'Ligas-mães de cobre','master alloys of copper','aleaciones madre de cobre',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7406,'Pó e escamas, de cobre','Copper powders and flakes','Polvo y escamillas, de cobre',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7407,'Barras e perfis de cobre','Copper bars, rods and profiles','Barras y perfiles, de cobre',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7408,'Fios de cobre','Copper wire','Alambre de cobre',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7409,'Chapas e tiras de cobre, de espessura superior a 0,15 mm','Copper plates, sheets and strip, of a thickness exceeding 0,15 mm','Chapas y tiras, de cobre, de espesor superior a 0,15 mm',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7410,'Folhas e tiras, delgadas, de cobre (mesmo impressas ou com suporte de papel, cartão, plástico ou semelhantes), de espessura não superior a 0,15 mm (excluído o suporte)','Copper foil (whether or not printed or backed with paper, paperboard, plastics or similar backing materials) of a thickness (excluding any backing) not exceeding 0,15 mm','Hojas y tiras, delgadas, de cobre, incluso impresas o fijadas sobre papel, cartón, plástico o soportes similares, de espesor inferior o igual a 0,15 mm (sin incluir el soporte)',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7411,'Tubos de cobre','Copper tubes and pipes','Tubos de cobre',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7412,'Acessórios para tubos [por exemplo: uniões, cotovelos, mangas (luvas)], de cobre','Copper tube or pipe fittings (for example, couplings, elbows, sleeves)','Accesorios de tubería [por ejemplo: empalmes (rácores), codos o manguitos] de cobre',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7413,'Cordas,  cabos,  trancas,  etc.de cobre,  n/isolad.p/uso eletr.','stranded wire, cabl.plaited bands, etc.n/electr.insulated','cables, trenzas, etc.de cobre, s/aislar, p/electr.',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7414,'Telas metálicas (incluídas as telas contínuas ou sem fim), grades e redes, de fios de cobre; chapas e tiras, distendidas, de cobre','Cloth (including endless bands), grill and netting, of copper wire; expanded metal, of copper','Telas metálicas, incluidas las continuas o sin fin), redes y rejas, de alambre de cobre; chapas y tiras, extendidas (desplegadas), de cobre',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7415,'Pontas, pregos, percevejos, escápulas e artefactos semelhantes, de cobre ou de ferro ou aço com cabeça de cobre; parafusos, pinos ou pernos, roscados, porcas, ganchos roscados, rebites, chavetas, cavilhas, contrapinos ou troços, anilhas (arruelas) incluíd','Nails, tacks, drawing pins, staples (other than those of heading 8305) and similar articles, of copper or of iron or steel with heads of copper; screws, bolts, nuts, screw hooks, rivets, cotters, cotter-pins, washers (including spring washers) and similar','Puntas, clavos, chinchetas (chinches), grapas apuntadas y artículos similares, de cobre, o con espiga de hierro o acero y cabeza de cobre; tornillos, pernos, tuercas, escarpias roscadas, remaches, pasadores, clavijas, chavetas y arandelas, incluidas las a',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7416,'Molas de cobre','Copper springs','Muelles de cobre',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7417,'Aparelhos para cozinhar/aquecer, de cobre, n/eletr.doméstico','Cooking/heating apparatus, of copper, n/electric domestic','Aparatos p/cocción/calefac., de cobre, n/eléctr.doméstico',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7418,'Artefactos de uso doméstico, de higiene ou de toucador, e suas partes, de cobre; esponjas, esfregões, luvas e artefactos semelhantes, para limpeza, polimento ou usos semelhantes, de cobre','Table, kitchen or other household articles and parts thereof, of copper; pot scourers and scouring or polishing pads, gloves and the like, of copper; sanitary ware and parts thereof, of copper','Artículos de uso doméstico, higiene o tocador, y sus partes, de cobre; estropajos, guantes y artículos similares para fregar, lustrar o usos análogos, de cobre',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7419,'Outras obras de cobre','Other articles of copper','Las demás manufacturas de cobre',74);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7501,'Mates de níquel, sinters de óxidos de níquel e outros produtos intermediários da metalurgia do níquel','Nickel mattes, nickel oxide sinters and other intermediate products of nickel metallurgy','Matas de níquel, sinters de óxidos de níquel y demás productos intermedios de la metalurgia del níquel',75);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7502,'Níquel em formas brutas','Unwrought nickel','Níquel en bruto',75);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7503,'Desperdícios e resíduos, de níquel','Nickel waste and scrap','Desperdicios y desechos, de níquel',75);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7504,'Pós e escamas, de níquel','Nickel powders and flakes','Polvos y partículas de níquel',75);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7505,'Barras, perfis e fios, de níquel','Nickel bars, rods, profiles and wire','Barras, perfiles y alambre, de níquel',75);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7506,'Chapas, tiras e folhas, de níquel','Nickel plates, sheets, strip and foil','Chapas, hojas y tiras, de níquel',75);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7507,'Tubos e seus acessórios [por exemplo: uniões, cotovelos, mangas (luvas)], de níquel','Nickel tubes, pipes and tube or pipe fittings (for example, couplings, elbows, sleeves)','Tubos y accesorios de tubería [por ejemplo: empalmes (rácores), codos, manguitos], de níquel',75);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7508,'Outras obras de níquel','Other articles of nickel','Las demás manufacturas de níquel',75);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7601,'Alumínio em formas brutas','Unwrought aluminium','Aluminio en bruto',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7602,'Desperdícios e resíduos, de alumínio','Aluminium waste and scrap','Desperdicios y desechos, de aluminio',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7603,'Pó e escamas, de alumínio','Aluminium powders and flakes','Polvo y escamillas de aluminio',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7604,'Barras e perfis, de alumínio','Aluminium bars, rods and profiles','Barras y perfiles, de aluminio',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7605,'Fios de alumínio','Aluminium wire','Alambre de aluminio',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7606,'Chapas e tiras, de alumínio, de espessura superior a 0,2 mm','Aluminium plates, sheets and strip, of a thickness exceeding 0,2 mm','Chapas y tiras de aluminio, de espesor superior a 0,2 mm',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7607,'Folhas e tiras, delgadas, de alumínio (mesmo impressas ou com suporte de papel, cartão, plástico ou semelhantes), de espessura não superior a 0,2 mm (excluído o suporte)','Aluminium foil (whether or not printed or backed with paper, paperboard, plastics or similar backing materials) of a thickness (excluding any backing) not exceeding 0,2 mm','Hojas y tiras, delgadas, de aluminio, incluso impresas o fijadas sobre papel, cartón, plástico o soportes similares, de espesor inferior o igual a 0,2 mm (sin incluir el soporte)',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7608,'Tubos de alumínio','Aluminium tubes and pipes','Tubos de aluminio',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7609,'Acessórios para tubos de alumínio','Accessories for tubes of aluminum','Accesorios de tuberías de aluminio',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7610,'Construções e suas partes (por exemplo: pontes e elementos de pontes, torres, pórticos ou pilonos, pilares, colunas, armações, estruturas para telhados, portas e janelas, e seus caixilhos, alizares e soleiras, balaustradas), de alumínio, exceto as constr','Aluminium structures (excluding prefabricated buildings of heading No 9406) and parts of structures (for example, bridges and bridge-sections, towers, lattice masts, roofs, roofing frameworks, doors and windows and their frames and thresholds for doors, b','Construcciones y sus partes (por ejemplo: puentes y partes, torres, castilletes, pilares, columnas, armazones para techumbre, techados, puertas y ventanas y sus marcos, contramarcos y umbrales, y barandillas), de aluminio (excepto las construcciones prefa',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7611,'Reservatórios, etc.de alumínio, c>300l, s/disp.mecan/term.','Reservoirs, etc.of alumin.c>300l, n/fitted mechan/therm','Depósitos, etc.de aluminio, c>300l, s/disp.mecán. n//térm.',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7612,'Reservatórios, barris, tambores, latas, caixas e recipientes semelhantes (incluídos os recipientes tubulares, rígidos ou flexíveis) para quaisquer matérias (exceto gases comprimidos ou liquefeitos), de alumínio, de capacidade não superior a 300 litros, s','Aluminium casks, drums, cans, boxes and similar containers (including rigid or collapsible tubular containers), for any material (other than compressed or liquefied gas), of a capacity not exceeding 300 litres, whether or not lined or heat-insulated, but ','Depósitos, barriles, tambores, bidones, botes, cajas y recipientes similares, de aluminio, incluidos los envases tubulares rígidos o flexibles, para cualquier materia (excepto gas comprimido o licuado), de capacidad inferior o igual a 300 l, sin dispositi',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7613,'Recipientes p/gases comprimidos/liquefeitos, de alumínio','Aluminium containers for compressed or liquefied gas','Envases p/gas comprimido/licuado, de aluminio',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7614,'Cordas, cabos, entrançados e semelhantes, de alumínio, não isolados para usos elétricos','Stranded wire, cables, plaited bands and the like, of aluminium, not electrically insulated','Cables, trenzas y artículos similares, de aluminio, sin aislar para electricidad',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7615,'Artefactos de uso doméstico, de higiene ou de toucador, e suas partes, de alumínio; esponjas, esfregões, luvas e artefactos semelhantes, para limpeza, polimento e usos semelhantes, de alumínio','Table, kitchen or other household articles and parts thereof, of aluminium; pot scourers and scouring or polishing pads, gloves and the like, of aluminium; sanitary ware and parts thereof, of aluminium','Artículos de uso doméstico, higiene o tocador y sus partes, de aluminio; estropajos, guantes y artículos similares para fregar, lustrar o usos análogos, de aluminio',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7616,'Outras obras de alumínio','Other articles of aluminium','Demás manufacturas de aluminio',76);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7801,'Chumbo em formas brutas','Unwrought lead','Plomo en bruto',78);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7802,'Desperdícios e resíduos, de chumbo','Lead waste and scrap','Desperdicios y desechos, de plomo',78);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7803,'Barras, perfis e fios, de chumbo','Lead bars, rods, profiles and wire','Barras, perfiles y alambre, de plomo',78);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7804,'Chapas, folhas e tiras, de chumbo; pó e escamas, de chumbo','Lead plates, sheets, strip and foil; lead powders and flakes','Chapas, hojas y tiras, de plomo; polvo y escamillas, de plomo',78);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7805,'Tubos e seus acessórios, de chumbo','Lead tubes and its accessories','Tubos y accesorios de tubería, de plomo',78);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7806,'Outras obras de chumbo','Articles of lead','Artículos de plomo',78);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7901,'Zinco em formas brutas','Unwrought zinc','Cinc en bruto',79);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7902,'Desperdícios e resíduos, de zinco','zinc waste and scrap','desperdicios y desechos, de cinc',79);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7903,'Poeiras, pó e escamas, de zinco','Zinc dust, powders and flakes','Polvo y escamillas, de cinc',79);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7904,'Barras, perfis e fios, de zinco','Zinc bars, rods, profiles and wire','Barras, perfiles y alambre, de cinc',79);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7905,'Chapas, folhas e tiras, de zinco','Zinc plates, sheets and strips','Chapas, hojas y tiras,  de cinc',79);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7906,'Tubos e seus acessórios, de zinco','Zinc tubes and its accessories','Tubos y accesorios de tubería, de cinc',79);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (7907,'Outras obras de zinco','Articles of zinc','Artículos de cinc',79);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8001,'Estanho em formas brutas','Unwrought tin','Estaño en bruto',80);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8002,'Desperdícios e resíduos, de estanho','Tin waste and scrap','Desperdicios y desechos, de estaño',80);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8003,'Barras, perfis e fios, de estanho','Tin bars, rods, profiles and wire','Barras, perfiles y alambre, de estaño',80);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8004,'Chapas, folhas e tiras, de estanho, espessura>0.2mm','Tin plates, sheets and strip, of a thickness>0.2mm','Chapas, hojas y tiras, de estaño, espesor>0.2mm',80);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8005,'Folha delgada de estanho','Tin foil (backed or not), n/ov .2mm, tin pow & flak','Papel de estaño',80);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8006,'Tubos e seus acessórios, de estanho','Tin tubes and its accessories','Tubos y accesorios de tubería,  de estaño',80);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8007,'Outras obras de estanho','Articles of tin','Artículos de estaño',80);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8101,'Tungsténio (volfrâmio) e suas obras, incluídos os desperdícios, resíduos e sucata','Tungsten (wolfram) and articles thereof, including waste and scrap','Volframio (tungsteno) y sus manufacturas, incluidos los desperdicios y desechos',81);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8102,'Molibdénio e suas obras, incluídos os desperdícios, resíduos e sucata','Molybdenum and articles thereof, including waste and scrap','Molibdeno y sus manufacturas, incluidos los desperdicios y desechos',81);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8103,'Tântalo e suas obras, incluídos os desperdícios, resíduos e sucata','Tantalum and articles thereof, including waste and scrap','Tántalio y sus manufacturas, incluidos los desperdicios y desechos',81);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8104,'Magnésio e suas obras, incluídos os desperdícios, resíduos e sucata','Magnesium and articles thereof, including waste and scrap','Magnesio y sus manufacturas, incluidos los desperdicios y desechos',81);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8105,'Mates de cobalto e outros produtos intermediários da metalurgia do cobalto; cobalto e suas obras, incluídos os desperdícios, resíduos e sucata','Cobalt mattes and other intermediate products of cobalt metallurgy; cobalt and articles thereof, including waste and scrap','Matas de cobalto y demás productos intermedios de la metalurgia del cobalto; cobalto y sus manufacturas, incluidos los desperdicios y desechos',81);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8106,'Bismuto e suas obras, incluídos os desperdícios e resíduos','Bismuth and articles, including waste and scrap','Bismuto y sus artículos, incluidos los desperdicios y desechos',81);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8107,'Cádmio e suas obras, incluídos os desperdícios, resíduos e sucata','Cadmium and articles thereof, including waste and scrap','Cadmio y sus manufacturas, incluidos los desperdicios y desechos',81);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8108,'Titânio e suas obras, incluídos os desperdícios, resíduos e sucata','Titanium and articles thereof, including waste and scrap','Titanio y sus manufacturas, incluidos los desperdicios y desechos',81);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8109,'Zircónio e suas obras, incluídos os desperdícios, resíduos e sucata','Zirconium and articles thereof, including waste and scrap','Circonio y sus manufacturas, incluidos los desperdicios y desechos',81);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8110,'Antimónio e suas obras, incluídos os desperdícios, resíduos e sucata','Antimony and articles thereof, including waste and scrap','Antimonio y sus manufacturas, incluidos los desperdicios y desechos',81);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8111,'Manganês e suas obras, incluídos os desperdícios e resíduos','Manganese and articles thereof, including waste and scrap','Manganeso y sus manufacturas, incluidos los desperdicios y desechos',81);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8112,'Berílio, crómio, germânio, vanádio, gálio, háfnio (céltio), índio, nióbio (colômbio), rénio e tálio, e suas obras, incluídos os desperdícios, resíduos e sucata','Beryllium, chromium, germanium, vanadium, gallium, hafnium, indium, niobium (columbium), rhenium and thallium, and articles of these metals, including waste and scrap','Berilio, cromo, germanio, vanadio, galio, hafnio (celtio), indio, niobio (colombio), renio y talio, así como las manufacturas de estos metales, incluidos los desperdicios y desechos',81);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8113,'Ceramais (cermets) e suas obras, incluídos os desperdícios e resíduos','Cermets and articles thereof, including waste and scrap','Cermet y sus manufacturas, incluidos los desperdicios y desechos',81);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8201,'Pás, alviões, picaretas, enxadas, sachos, forcados, forquilhas, ancinhos e rapadeiras; machados, podões e ferramentas semelhantes de gume; tesouras de podar de todos os tipos; foices e foicinhas, facas para feno ou para palha, tesouras para sebes, cunhas ','Hand tools, the following : spades, shovels, mattocks, picks, hoes, forks and rakes; axes, bill hooks and similar hewing tools; secateurs and pruners of any kind; scythes, sickles, hay knives, hedge shears, timber wedges and other tools of a kind used in ','Layas, palas, azadas, picos, binaderas, horcas de labranza, rastrillos y raederas; hachas, hocinos y herramientas similares con filo; tijeras de podar de cualquier tipo, hoces y guadañas; cuchillos para heno o para paja, cizallas para setos, cuñas y demás',82);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8202,'Serras manuais; folhas de serras de todos os tipos (incluídas as fresas-serras e as folhas não dentadas para serrar)','Hand saws; blades for saws of all kinds (including slitting, slotting or toothless saw blades)','Sierras de mano; hojas de sierra de cualquier clase, incluidas las fresas sierra y las hojas sin dentar',82);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8203,'Limas, grosas, alicates (mesmo cortantes), tenazes, pinças, cisalhas para metais, corta-tubos, corta-pinos, saca-bocados e ferramentas semelhantes, manuais','Files, rasps, pliers (including cutting pliers), pincers, tweezers, metal cutting shears, pipe-cutters, bolt croppers, perforating punches and similar hand tools','Limas, escofinas, alicates, incluso cortantes, tenazas, pinzas, cizallas para metales, cortatubos, cortapernos, sacabocados y herramientas similares, de mano',82);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8204,'Chaves de porcas, manuais (incluídas as chaves dinamométricas); chaves de caixa intercambiáveis, mesmo com cabos','Hand-operated spanners and wrenches (including torque meter wrenches but not including tap wrenches); interchangeable spanner sockets, with or without handles','Llaves de ajuste de mano, incluidas las llaves dinamométricas; cubos de ajuste intercambiables, incluso con mango',82);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8205,'Ferramentas manuais (incluídos os corta-vidros) não especificadas nem compreendidas em outras posições; lâmpadas ou lamparinas de soldar (maçaricos) e semelhantes; tornos de apertar, sargentos e semelhantes, exceto os acessórios ou partes de máquinas-fer','Hand tools (including glaziers'' diamonds), not elsewhere specified or included; blow-lamps; vices, clamps and the like, other than accessories for and parts of, machine tools; anvils; portable forges; hand or pedal-operated grinding wheels with frameworks','Herramientas de mano, incluidos los diamantes de vidriero no expresadas ni comprendidas en otra parte; lámparas de soldar y similares; tornillos de banco, prensas de carpintero y similares (excepto los que sean accesorios o partes de máquinas herramienta)',82);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8206,'Sortido de serras, limas, etc.uso manual, de metais comuns','Sets of saws, lime, etc.use manual, of base metals','Juego de sierras, limas, etc.uso de mano, de met.comunes',82);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8207,'Ferramentas intercambiáveis para ferramentas manuais, mesmo mecânicas, ou para máquinas-ferramentas (por exemplo: de embutir, estampar, puncionar, roscar (interior ou exteriormente), furar, escarear, mandrilar, fresar, tornear, aparafusar), incluídas as f','Interchangeable tools for hand tools, whether or not power-operated, or for machine-tools (for example, for pressing, stamping, punching, tapping, threading, drilling, boring, broaching, milling, turning or screw driving), including dies for drawing or ex','Útiles intercambiables para herramientas de mano, incluso mecánicas, o para máquinas herramienta (por ejemplo: de embutir, estampar, punzonar, roscar, incluso aterrajar, taladrar, escariar, brochar, fresar, tornear, atornillar), incluidas las hileras de e',82);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8208,'Facas e lâminas cortantes, para máquinas ou para aparelhos mecânicos','Knives and cutting blades, for machines or for mechanical appliances','Cuchillas y hojas cortantes, para máquinas o aparatos mecánicos',82);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8209,'Plaquetas, varetas, pontas e objetos semelhantes para ferramentas, não montados, de ceramais (cermets)','Plates, sticks, tips etc f tools unmounted sntrd crbds/cermets','Placas, varillas, puntas herramientas',82);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8210,'Aparelhos mecânicos de acionamento manual, pesando <= 10 kg, utilizados para preparar, acondicionar ou servir alimentos ou bebidas','Hand-op mech appl 10kg or less, food/drk prp/con/srv pt','Mano-op mecanismos 10kg apl o menos, la comida / DRK PRP / con / srv pt',82);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8211,'Facas (exceto da posição 8208) de lâmina cortante ou serrilhada, incluídas as podadeiras de lâmina móvel, e suas lâminas','Knives with cutting blades, serrated or not (including pruning knives), other than knives of heading No 8208, and blades therefor','Cuchillos, con hoja cortante o dentada, incluidas las navajas de podar, y sus hojas (excepto los artículos de la partida 8208)',82);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8212,'Navalhas e aparelhos de barbear e suas lâminas (incluídos os esboços em tiras)','Razors and razor blades (including razor blade blanks in strips)','Navajas y maquinillas de afeitar y sus hojas, incluidos los esbozos en fleje',82);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8213,'Tesouras e suas lâminas, de metais comuns','Scissors and its  blades, of base metals','Tijeras y sus hojas, de metales comunes',82);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8214,'Outros artigos de cutelaria (por exemplo: máquinas de cortar o cabelo ou tosquiar, fendeleiras, cutelos, incluídos os de açougue e de cozinha, e corta-papéis); utensílios e sortidos de utensílios, de manicuros ou de pedicuros (incluídas as limas para unha','Other articles of cutlery (for example, hair clippers, butchers'' or kitchen cleavers, choppers and mincing knives, paper knives); manicure or pedicure sets and instruments (including nail files)','Los demás artículos de cuchillería (por ejemplo: máquinas de cortar el pelo o de esquilar, cuchillas de picar carne, tajaderas de carnicería o cocina y cortapapeles); herramientas y juegos de herramientas de manicura o pedicura, incluidas las limas para u',82);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8215,'Colheres, garfos, conchas, escumadeiras, pás para tortas, facas especiais para peixe ou para manteiga, pinças para açúcar e artefactos semelhantes','Spoons, forks, ladles, skimmers, cake-servers, fish-knives, butter-knives, sugar tongs and similar kitchen or tableware','Cucharas, tenedores, cucharones, espumaderas, palas para tarta, cuchillos para pescado o mantequilla (manteca), pinzas para azúcar y artículos similares',82);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8301,'Cadeados, fechaduras e ferrolhos (de chave, de segredo ou elétricos), de metais comuns; fechos e armações com fecho, com fechadura, de metais comuns; chaves para estes artigos, de metais comuns','Padlocks and locks (key, combination or electrically operated), of base metal; clasps and frames with clasps, incorporating locks, of base metal; keys for any of the foregoing articles, of base metal','Candados, cerraduras y cerrojos (de llave, de combinación o eléctricos), de metal común; cierres y monturas cierre, con cerradura incorporada, de metal común; llaves de metal común para estos artículos',83);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8302,'Guarnições, ferragens e artigos semelhantes, de metais comuns, para móveis, portas, escadas, janelas, persianas, carroçarias, artigos de seleiro, malas, cofres, caixas de segurança e outras obras semelhantes; pateras, porta-chapéus, cabides e artigos seme','Base metal mountings, fittings and similar articles suitable for furniture, doors, staircases, windows, blinds, coachwork, saddlery, trunks, chests, caskets or the like; base metal hat-racks, hat-pegs, brackets and similar fixtures; castors with mountings','Guarniciones, herrajes y artículos similares, de metal común, para muebles, puertas, escaleras, ventanas, persianas, carrocerías, artículos de guarnicionería, baúles, arcas, cofres y demás manufacturas de esta clase; colgadores, perchas, soportes y artícu',83);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8303,'cofres-fortes, portas blindadas, etc.de metais comuns','reinforced safes, armored doors, etc.of base metals','cajas de caudales, puertas blindadas, etc.de met.comunes',83);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8304,'classificadores/outs.artefs.de escritório, de met.comuns','classifiers/other articles of office, of base metals','clasificadores/material simil.de oficina, de met.comunes',83);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8305,'Ferragens para encadernação de folhas móveis ou para classificadores, molas para papéis, cantos para cartas, clipes, indicadores para fichas ou cavaleiros e objectos semelhantes de escritório, de metais comuns; grampos apresentados em barretas (por exempl','Fittings for loose-leaf binders or files, letter clips, letter corners, paper clips, indexing tags and similar office articles, of base metal; staples in strips (for example, for offices, upholstery, packaging), of base metal','Mecanismos para encuadernación de hojas intercambiables o para clasificadores, sujetadores, cantoneras, clips, índices de señal y artículos similares de oficina, de metal común; grapas en tiras (por ejemplo: de oficina, tapicería o envase), de metal común',83);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8306,'Sinos, campainhas, gongos e artefactos semelhantes, não elétricos, de metais comuns; estatuetas e outros objectos de ornamentação, de metais comuns; molduras para fotografias, gravuras ou semelhantes, de metais comuns; espelhos de metais comuns','Bells, gongs and the like, non-electric, of base metal; statuettes and other ornaments, of base metal; photograph, picture or similar frames, of base metal; mirrors of base metal','Campanas, campanillas, gongos y artículos similares, que no sean eléctricos, de metal común; estatuillas y demás artículos de adorno, de metal común; marcos para fotografías, grabados o similares, de metal común; espejos de metal común',83);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8307,'Tubos flexíveis de metais comuns, mesmo com acessórios','Flexible tubing of base metal, with or without fittings','Tubos flexibles de metal común, incluso con sus accesorios',83);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8308,'Fechos, armações com fecho, fivelas, fivelas-fecho, grampos, colchetes, ilhoses e artefactos semelhantes, de metais comuns, para vestuário, calçado, toldos, bolsas, artigos de viagem e para quaisquer outras confecções ou equipamentos; rebites tubulares ou','Clasps, frames with clasps, buckles, buckle-clasps, hooks, eyes, eyelets and the like, of base metal, of a kind used for clothing, footwear, awnings, handbags, travel goods or other made-up articles, tubular or bifurcated rivets, of base metal; beads and ','Cierres, monturas cierre, hebillas, hebillas cierre, corchetes, ganchos, anillos para ojetes y artículos similares, de metal común, para prendas de vestir, calzado, toldos, marroquinería o demás artículos confeccionados; remaches tubulares o con espiga he',83);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8309,'Rolhas (incluídas as cápsulas de coroa, rolhas de parafuso e vertedoras), tampas, cápsulas para garrafas, batoques ou tampões roscados, protectores de batoques ou tampões, selos de garantia e outros acessórios para embalagem, de metais comuns','Stoppers, caps and lids (including crown corks, screw caps and pouring stoppers), capsules for bottles, threaded bungs, bung covers, seals and other packing accessories, of base metal','Tapones y tapas, incluidas las tapas corona, las tapas roscadas y los tapones vertedores, cápsulas para botellas, tapones roscados, sobretapas, precintos y demás accesorios para envases, de metal común',83);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8310,'Placas indicadoras, sinaliz.etc.de metais comuns, n/eletr','Sign-plates, name-plates, etc.of base metals, non-eletric','Placas indicadoras, sinaliz.etc.de met.com.q n/sean eléc',83);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8311,'Fios, varetas, tubos, chapas, eléctrodos e artefactos semelhantes, de metais comuns ou de carbonetos metálicos, revestidos interior ou exteriormente de decapantes ou de fundentes, para soldadura (soldagem) ou depósito de metal ou de carbonetos metálicos; ','Wire, rods, tubes, plates, electrodes and similar products, of base metal or of metal carbides, coated or cored with flux material, of a kind used for soldering, brazing, welding or deposition of metal or of metal carbides; wire and rods, of agglomerated ','Alambres, varillas, tubos, placas, electrodos y artículos similares, de metal común o de carburo metálico, recubiertos o rellenos de decapantes o de fundentes, para soldadura o depósito de metal o de carburo metálico; alambres y varillas, de polvo de meta',83);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8401,'Reactores nucleares; elementos combustíveis (cartuchos) não irradiados, para reactores nucleares; máquinas e aparelhos para a separação de isótopos','Nuclear reactors; fuel elements (cartridges), non-irradiated, for nuclear reactors; machinery and apparatus for isotopic separation','Reactores nucleares; elementos combustibles (cartuchos) sin irradiar para reactores nucleares; máquinas y aparatos para la separación isotópica',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8402,'Caldeiras de vapor (geradores de vapor), excluídas as caldeiras para aquecimento central concebidas para produção de água quente e vapor de baixa pressão; caldeiras denominadas « de água sobreaquecida »','Steam or other vapour generating boilers (other than central heating hot water boilers capable also of producing low pressure steam); super-heated water boilers','Calderas de vapor (generadores de vapor) (excepto las de calefacción central concebidas para producir agua caliente y también vapor a baja presión); calderas denominadas «de agua sobrecalentada»',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8403,'Caldeiras para aquecimento central, exceto as da posição 8402','Central heating boilers other than those of heading No 8402','Calderas para calefacción central (excepto las de la partida 8402)',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8404,'Aparelhos auxiliares para caldeiras das posições 8402 ou 8403 (por exemplo: economizadores, sobreaquecedores, aparelhos de limpeza de tubos ou de recuperação de gás); condensadores para máquinas a vapor','Auxiliary plant for use with boilers of heading No 8402 or 8403 (for example, economisers, super-heaters, soot removers, gas recoverers); condensers for steam or other vapour power units','Aparatos auxiliares para las calderas de las partidas 8402 u 8403 (por ejemplo: economizadores, recalentadores, deshollinadores o recuperadores de gas); condensadores para máquinas de vapor',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8405,'Geradores de gás de ar (gás pobre) ou de gás de água, com ou sem depuradores; geradores de acetileno e geradores semelhantes de gás, operados a água, com ou sem depuradores','Producer gas or water gas generators, with or without their purifiers; acetylene gas generators and similar water process gas generators, with or without their purifiers','Generadores de gas pobre (gas de aire) o de gas de agua, incluso con sus depuradores; generadores de acetileno y generadores similares de gases, por vía húmeda, incluso con sus depuradores',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8406,'Turbinas a vapor','Steam turbines and other vapour turbines','Turbinas de vapor',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8407,'Motores de pistão, alternativo ou rotativo, de ignição por faísca (motores de explosão)','Spark-ignition reciprocating or rotary internal combustion piston engines','Motores de émbolo (pistón) alternativo y motores rotativos, de encendido por chispa (motores de explosión)',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8408,'Motores de pistão, de ignição por compressão (motores diesel ou semi-diesel)','Compression-ignition internal combustion piston engines (diesel or semi-diesel engines)','Motores de émbolo (pistón) de encendido por compresión (motores Diesel o semi-Diesel)',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8409,'Partes reconhecíveis como exclusiva ou principalmente destinadas aos motores das posições 8407 ou 8408','Parts suitable for use solely or principally with the engines of heading No 8407 or 8408','Partes identificables como destinadas, exclusiva o principalmente, a los motores de las partidas 8407 u 8408',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8410,'Turbinas hidráulicas, rodas hidráulicas, e seus reguladores','Hydraulic turbines, water wheels, and regulators therefor','Turbinas hidráulicas, ruedas hidráulicas y sus reguladores',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8411,'Turborreactores, turbopropulsores e outras turbinas a gás','Turbo-jets, turbo-propellers and other gas turbines','Turborreactores, turbopropulsores y demás turbinas de gas',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8412,'Outros motores e máquinas motrizes','Other engines and motors','Los demás motores y máquinas motrices',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8413,'Bombas para líquidos, mesmo com dispositivo medidor; elevadores de líquidos','Pumps for liquids, whether or not fitted with a measuring device; liquid elevators','Bombas para líquidos, incluso con dispositivo medidor incorporado; elevadores de líquidos',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8414,'Bombas de ar ou de vácuo, compressores de ar ou de outros gases e ventiladores; exaustores (coifas aspirantes) para extracção ou reciclagem, com ventilador incorporado, mesmo filtrantes','Air or vacuum pumps, air or other gas compressors and fans; ventilating or recycling hoods incorporating a fan, whether or not fitted with filters','Bombas de aire o de vacío, compresores de aire u otros gases y ventiladores; campanas aspirantes para extracción o reciclado, con ventilador incorporado, incluso con filtro',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8415,'Máquinas e aparelhos de ar condicionado, contendo um ventilador motorizado e dispositivos próprios para modificar a temperatura e a humidade, incluindo as máquinas e aparelhos em que a humidade não seja regulável separadamente','Air-conditioning machines, comprising a motor-driven fan and elements for changing the temperature and humidity, including those machines in which the humidity cannot be separately regulated','Máquinas y aparatos para acondicionamiento de aire que comprenden un ventilador con motor y los dispositivos adecuados para modificar la temperatura y la humedad, aunque no regulen separadamente el grado higrométrico',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8416,'Queimadores para alimentação de fornalhas, de combustíveis líquidos, combustíveis sólidos pulverizados ou de gás; fornalhas automáticas, incluídas as antefornalhas, grelhas mecânicas, descarregadores mecânicos de cinzas e dispositivos semelhantes','Furnace burners for liquid fuel, for pulverised solid fuel or for gas; mechanical stokers, including their mechanical grates, mechanical ash dischargers and similar appliances','Quemadores para la alimentación de hogares, de combustibles líquidos o sólidos pulverizados o de gases; alimentadores mecánicos de hogares, parrillas mecánicas, descargadores mecánicos de cenizas y demás dispositivos mecánicos auxiliares empleados en hoga',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8417,'Fornos industriais ou de laboratório, incluídos os incineradores, não elétricos','Industrial or laboratory furnaces and ovens, including incinerators, non-electric','Hornos industriales o de laboratorio, incluidos los incineradores, que no sean eléctricos',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8418,'Refrigeradores, congeladores (freezers) e outro material, máquinas e aparelhos para a produção de frio, com equipamento eléctrico ou outro; bombas de calor, excluídas as máquinas e aparelhos de ar condicionado da posição 8415','Refrigerators, freezers and other refrigerating or freezing equipment, electric or other; heat pumps other than air-conditioning machines of heading No 8415','Refrigeradores, congeladores y demás material, máquinas y aparatos para producción de frío, aunque no sean eléctricos; bombas de calor (excepto las máquinas y aparatos para acondicionamiento de aire de la partida 8415)',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8419,'Aparelhos e dispositivos, mesmo aquecidos electricamente (exceto fornos e outros aparelhos da posição 8514), para tratamento de matérias por meio de operações que impliquem mudança de temperatura, tais como o aquecimento, cozimento, torrefacção, destilaç','Machinery, plant or laboratory equipment, whether or not electrically heated (excluding furnaces, ovens, and other equipment of heading 8514), for the treatment of materials by a process involving a change of temperature such as heating, cooking, roasting','Aparatos y dispositivos, aunque se calienten eléctricamente (excepto los hornos y demás aparatos de la partida 8514), para el tratamiento de materias mediante operaciones que impliquen un cambio de temperatura, tales como calentamiento, cocción, torrefacc',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8420,'Calandras e laminadores, exceto os destinados ao tratamento de metais ou vidro, e seus cilindros','Calendering or other rolling machines, other than for metals or glass, and cylinders therefor','Calandrias y laminadores (excepto para metal o vidrio), y cilindros para estas máquinas',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8421,'Centrifugadores, incluídos os secadores centrífugos, aparelhos para filtrar ou depurar líquidos ou gases','Centrifuges, including centrifugal dryers; filtering or purifying machinery and apparatus, for liquids or gases','Centrifugadoras, incluidas las secadoras centrífugas; aparatos para filtrar o depurar líquidos o gases',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8422,'Máquinas de lavar louça; máquinas e aparelhos para limpar ou secar garrafas ou outros recipientes; máquinas e aparelhos para encher, fechar, rolhar ou rotular garrafas, caixas, latas, sacos ou outros recipientes; máquinas e aparelhos para capsular garrafa','Dishwashing machines; machinery for cleaning or drying bottles or other containers; machinery for filling, closing, sealing or labelling bottles, cans, boxes, bags or other containers; machinery for capsuling bottles, jars, tubes and similar containers; o','Máquinas para lavar vajilla; máquinas y aparatos para limpiar o secar botellas o demás recipientes; máquinas y aparatos para llenar, cerrar, tapar, taponar o etiquetar botellas, botes o latas, cajas, sacos (bolsas) o demás continentes; máquinas y aparatos',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8423,'Aparelhos e instrumentos de pesagem, incluídas as básculas e balanças para verificar peças fabricadas, excluídas as balanças sensíveis a pesos não superiores a 5 cg; pesos para quaisquer balanças','Weighing machinery (excluding balances of a sensitivity of 5 cg or better), including weight-operated counting or checking machines; weighing machine weights of all kinds','Aparatos e instrumentos para pesar, incluidas las básculas y balanzas para comprobar o contar piezas fabricadas (excepto las balanzas sensibles a un peso inferior o igual a 5 cg); pesas para toda clase de básculas o balanzas',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8424,'Aparelhos mecânicos (mesmo manuais) para projectar, dispersar ou pulverizar líquidos ou pós; extintores, mesmo carregados; pistolas aerográficas e aparelhos semelhantes; máquinas e aparelhos de jacto de areia, de jacto de vapor e aparelhos de jacto semelh','Mechanical appliances (whether or not hand-operated) for projecting, dispersing or spraying liquids or powders; fire extinguishers, whether or not charged; spray guns and similar appliances; steam or sandblasting machines and similar jet projecting machin','Aparatos mecánicos, incluso manuales, para proyectar, dispersar o pulverizar materias líquidas o en polvo; extintores, incluso cargados; pistolas aerográficas y aparatos similares; máquinas y aparatos de chorro de arena o de vapor y aparatos de chorro sim',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8425,'Talhas; cadernais e moitões; guinchos e cabrestantes; macacos','Pulley tackle and hoists other than skip hoists; winches and capstans; jacks','Polipastos; tornos y cabrestantes; gatos',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8426,'Cábreas; guindastes, incluídos os de cabos; pontes rolantes, pórticos de descarga e de movimentação, pontes-guindastes, carros-pórticos, carros-guindastes','Ships'' derricks; cranes, including cable cranes; mobile lifting frames, straddle carriers and works trucks fitted with a crane','Grúas y aparatos de elevación sobre cable aéreo; puentes rodantes, pórticos de descarga o manipulación, puentes grúa, carretillas puente y carretillas grúa',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8427,'Empilhadores; outros veículos para movimentação de carga e semelhantes, equipados com dispositivo de elevação','Fork-lift trucks; other works trucks fitted with lifting or handling equipment','Carretillas apiladoras; las demás carretillas de manipulación con dispositivo de elevación incorporado',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8428,'Outras máquinas e aparelhos de elevação, de carga, de descarga ou de movimentação (por exemplo: elevadores, escadas rolantes, transportadores, teleféricos)','Other lifting, handling, loading or unloading machinery (for example, lifts, escalators, conveyors, teleferics)','Las demás máquinas y aparatos de elevación, carga, descarga o manipulación (por ejemplo: ascensores, escaleras mecánicas, transportadores, teleféricos)',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8429,'Bulldozers, angledozers, niveladoras, raspo-transportadoras (scrapers), pás mecânicas, escavadoras, carregadoras e pás carregadoras, compactadores e rolos ou cilindros compressores, autopropulsores','Self-propelled bulldozers, angledozers, graders, levellers, scrapers, mechanical shovels, excavators, shovel loaders, tamping machines and road rollers','Topadoras frontales (bulldozers), topadoras anguladores (angledozers), niveladoras, traíllas (scrapers), palas mecánicas, excavadoras, cargadoras, palas cargadoras, compactadoras y apisonadoras (aplanadoras), autopropulsadas',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8430,'Outras máquinas e aparelhos de terraplanagem, nivelamento, raspagem, escavação, compactação, extracção ou perfuração da terra, de minerais ou minérios; bate-estacas e arranca-estacas; limpa-neves','Other moving, grading, levelling, scraping, excavating, tamping, compacting, extracting or boring machinery, for earth, minerals or ores; piledrivers and pile-extractors; snowploughs and snow-blowers','Las demás máquinas y aparatos para explanar, nivelar, traillar (scraping), excavar, compactar, apisonar (aplanar), extraer o perforar tierra o minerales; martinetes y máquinas para arrancar pilotes, estacas o similares; quitanieves',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8431,'Partes reconhecíveis como exclusiva ou principalmente destinadas às máquinas e aparelhos das posições 8425 a 8430','Parts suitable for use solely or principally with the machinery of headings 8425 to 8430','Partes identificables como destinadas, exclusiva o principalmente, a las máquinas o aparatos de las partidas 8425 a 8430',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8432,'Máquinas e aparelhos de uso agrícola, hortícola ou florestal, para preparação ou trabalho do solo ou para cultura; rolos para relvados ou para campos de desporto','Agricultural, horticultural or forestry machinery for soil preparation or cultivation; lawn or sports-ground rollers','Máquinas, aparatos y artefactos agrícolas, hortícolas o silvícolas, para la preparación o el trabajo del suelo o para el cultivo; rodillos para césped o terrenos de deporte',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8433,'Máquinas e aparelhos para colheita ou debulha de produtos agrícolas, incluídas as enfardadeiras de palha ou forragem; cortadores de relva e ceifeiras; máquinas para limpar e seleccionar ovos, frutas ou outros produtos agrícolas, exceto as da posição 8437','Harvesting or threshing machinery, including straw or fodder balers; grass or hay mowers; machines for cleaning, sorting or grading eggs, fruit or other agricultural produce, other than machinery of heading 8437','Máquinas, aparatos y artefactos de cosechar o trillar, incluidas las prensas para paja o forraje; cortadoras de césped y guadañadoras; máquinas para limpieza o clasificación de huevos, frutos o demás productos agrícolas (excepto las de la partida 8437)',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8434,'Máquinas de ordenhar e máquinas e aparelhos, para a indústria de lacticínios','Milking machines and dairy machinery','Máquinas de ordeñar y máquinas y aparatos para la industria lechera',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8435,'Prensas, esmagadores e máquinas e aparelhos semelhantes, para fabricação de vinho, sidra, sumos de frutas ou bebidas semelhantes','Presses, crushers and similar machinery used in the manufacture of wine, cider, fruit juices or similar beverages','Prensas, estrujadoras y máquinas y aparatos análogos para la producción de vino, sidra, jugos de frutos o bebidas similares',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8436,'Outras máquinas e aparelhos para agricultura, horticultura, silvicultura, avicultura ou apicultura, incluídos os germinadores equipados com dispositivos mecânicos ou térmicos e as chocadeiras e criadeiras para avicultura','Other agricultural, horticultural, forestry, poultry-keeping or bee-keeping machinery, including germination plant fitted with mechanical or thermal equipment; poultry incubators and brooders','Las demás máquinas y aparatos para la agricultura, horticultura, silvicultura, avicultura o apicultura, incluidos los germinadores con dispositivos mecánicos o térmicos incorporados y las incubadoras y criadoras avícolas',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8437,'Máquinas para limpeza, selecção ou peneiração de grãos ou de produtos hortícolas secos; máquinas e aparelhos para a indústria de moagem ou tratamento de cereais ou de produtos hortícolas secos, exceto dos tipos utilizados em fazendas','Machines for cleaning, sorting or grading seed, grain or dried leguminous vegetables; machinery used in the milling industry or for the working of cereals or dried leguminous vegetables, other than farm-type machinery','Máquinas para limpieza, clasificación o cribado de semillas, granos u hortalizas de vaina secas; máquinas y aparatos para molienda o tratamiento de cereales u hortalizas de vaina secas (excepto las de tipo rural)',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8438,'Máquinas e aparelhos não especificados nem compreendidos em outras posições do presente capítulo, para preparação ou fabricação industrial de alimentos ou de bebidas, exceto as máquinas e aparelhos para extracção ou preparação de óleos ou gorduras vegeta','Machinery, not specified or included elsewhere in this chapter, for the industrial preparation or manufacture of food or drink, other than machinery for the extraction or preparation of animal or fixed vegetable fats or oils','Máquinas y aparatos, no expresados ni comprendidos en otra parte de este capítulo, para la preparación o fabricación industrial de alimentos o bebidas (excepto las máquinas y aparatos para la extracción o preparación de aceites o grasas, animales o vegeta',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8439,'Máquinas e aparelhos, para fabricação de pasta de matérias fibrosas celulósicas ou para fabricação ou acabamento de papel ou cartão','Machinery for making pulp of fibrous cellulosic material or for making or finishing paper or paperboard','Máquinas y aparatos para la fabricación de pasta de materias fibrosas celulósicas o para la fabricación o acabado de papel o cartón',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8440,'Máquinas e aparelhos, para brochura ou encadernação, incluídas as máquinas para costurar cadernos','Book-binding machinery, including book-sewing machines','Máquinas y aparatos para encuadernación, incluidas las máquinas para coser pliegos',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8441,'Outras máquinas e aparelhos, para o trabalho da pasta de papel, do papel ou do cartão, incluídas as cortadeiras de todos os tipos','Other machinery for making up paper pulp, paper or paperboard, including cutting machines of all kinds','Las demás máquinas y aparatos para el trabajo de la pasta de papel, del papel o cartón, incluidas las cortadoras de cualquier tipo',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8442,'Máquinas, aparelhos e material (exceto as máquinas-ferramentas das posições 8456 a 8465), para fundir ou compor caracteres tipográficos ou para preparação ou fabricação de clichés, blocos, cilindros ou outros elementos de impressão; caracteres tipográfic','Machinery, apparatus and equipment (other than the machine-tools of headings 8456 to 8465), for type-founding or type-setting, for preparing or making printing blocks, plates, cylinders or other printing components; printing type, blocks, plates, cylinder','Máquinas, aparatos y material (excepto las máquinas herramienta de las partidas 8456 a 8465) para fundir o componer caracteres o para preparar o fabricar clisés, planchas, cilindros o demás elementos impresores; caracteres de imprenta, clisés, planchas, c',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8443,'Máquinas e aparelhos para impressão por meio de caracteres tipográficos, clichés, blocos, cilindros e outros elementos de impressão da posição 8442; máquinas de impressão de jacto de tinta, exceto as da posição 8471; máquinas auxiliares para impressão','Printing machinery used for printing by means of the printing type, blocks, plates, cylinders and other printing components of heading 8442; ink-jet printing machines, other than those of heading 8471; machines for uses ancillary to printing','Máquinas y aparatos para imprimir mediante caracteres de imprenta, clisés, planchas, cilindros y demás elementos impresores de la partida 8442; máquinas para imprimir por chorro de tinta (excepto las de la partida 8471); máquinas auxiliares para la impres',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8444,'Máquinas para extrudar, estirar, texturizar ou cortar matérias têxteis sintéticas ou artificiais','Machines extruding, drawing etc manmade textiles','Máquinas de extrusión, el estirado textiles artificiales, etc',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8445,'Máquinas para preparação de matérias têxteis; máquinas para fiação, dobragem ou torção de matérias têxteis e outras máquinas e aparelhos para fabricação de fios têxteis; máquinas de bobinar (incluídas as bobinadeiras de trama) ou de dobar matérias têxteis','Machines for preparing textile fibres; spinning, doubling or twisting machines and other machinery for producing textile yarns; textile reeling or winding (including weft-winding) machines and machines for preparing textile yarns for use on the machines o','Máquinas para la preparación de materia textil; máquinas para hilar, doblar o retorcer materia textil, y demás máquinas y aparatos para la fabricación de hilados textiles; máquinas para bobinar, incluidas las canilleras, o devanar materia textil y máquina',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8446,'Teares para tecidos','Weaving machines (looms)','Telares',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8447,'Teares para fabricar malhas, máquinas de costura por entrelaçamento (couture-tricotage), máquinas para fabricar guipuras, tules, rendas, bordados, passamanarias, galões ou redes, e máquinas para inserir tufos','Knitting machines, stitch-bonding machines and machines for making gimped yarn, tulle, lace, embroidery, trimmings, braid or net and machines for tufting','Máquinas de tricotar, de coser por cadeneta, de entorchar, de fabricar tul, encaje, bordados, pasamanería, trenzas, redes o de insertar mechones',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8448,'Máquinas e aparelhos auxiliares para as máquinas das posições 8444, 8445, 8446 ou 8447 (por exemplo: maquinetas, mecanismos Jacquard, quebra-urdiduras e quebra-tramas, mecanismos troca-lançadeiras); partes e acessórios reconhecíveis como exclusiva ou prin','Auxiliary machinery for use with machines of heading 8444, 8445, 8446 or 8447 (for example, dobbies, jacquards, automatic stop motions, shuttle changing mechanisms); parts and accessories suitable for use solely or principally with the machines of this he','Máquinas y aparatos auxiliares para las máquinas de las partidas 8444, 8445, 8446 u 8447 (por ejemplo: maquinitas para lizos, mecanismos Jacquard, paraurdidumbres y paratramas, mecanismos de cambio de lanzadera); partes y accesorios identificables como de',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8449,'Máquinas e aparelhos para fabricação ou acabamento de feltro ou de falsos tecidos, inclusive chapéus de feltro; formas para chapéus e artefatos de uso semelhantes','Machinery for manufacture or finish nonwovens, hat blocks, parts','Maquinaria para la fabricación de telas no tejidas o acabado, bloques, piezas de sombrero',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8450,'Máquinas de lavar roupa, mesmo com dispositivo de secagem','Household or laundry-type washing machines, including machines which both wash and dry','Máquinas para lavar ropa, incluso con dispositivo de secado',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8451,'Máquinas e aparelhos (exceto as máquinas da posição 8450), para lavar, limpar, espremer, secar, passar, prensar (incluídas as prensas fixadoras), branquear, tingir, para apresto e acabamento, para revestir ou impregnar fios, tecidos ou obras de matérias ','Machinery (other than machines of heading 8450) for washing, cleaning, wringing, drying, ironing, pressing (including fusing presses), bleaching, dyeing, dressing, finishing, coating or impregnating textile yarns, fabrics or made-up textile articles and m','Máquinas y aparatos (excepto las máquinas de la partida 8450) para lavar, limpiar, escurrir, secar, planchar, prensar, incluidas las prensas de fijar, blanquear, teñir, aprestar, acabar, recubrir o impregnar hilados, telas o manufacturas textiles y máquin',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8452,'Máquinas de costura, exceto para costurar cadernos, da posição 8440; móveis, bases e tampas, próprios para máquinas de costura; agulhas para máquinas de costura','Sewing machines, other than book-sewing machines of heading 8440; furniture, bases and covers specially designed for sewing machines; sewing machine needles','Máquinas de coser (excepto las de coser pliegos de la partida 8440); muebles, basamentos y tapas o cubiertas especialmente concebidos para máquinas de coser; agujas para máquinas de coser',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8453,'Máquinas e aparelhos, para preparar, curtir ou trabalhar couros ou peles, ou para fabricar ou consertar calçado e outras obras de couro ou de pele, exceto máquinas de costura','Machinery for preparing, tanning or working hides, skins or leather or for making or repairing footwear or other articles of hides, skins or leather, other than sewing machines','Máquinas y aparatos para la preparación, curtido o trabajo de cuero o piel o para la fabricación o reparación de calzado u otras manufacturas de cuero o  piel (excepto las máquinas de coser)',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8454,'Conversores, cadinhos ou colheres de fundição, lingoteiras e máquinas de vazar (moldar), para metalurgia, aciaria ou fundição','Converters, ladles, ingot moulds and casting machines, of a kind used in metallurgy or in metal foundries','Convertidores, cucharas de colada, lingoteras y máquinas de colar (moldear), para metalurgia, acerías o fundiciones',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8455,'Laminadores de metais e seus cilindros','Metal-rolling mills and rolls therefor','Laminadores para metal y sus cilindros',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8456,'Máquinas-ferramentas para trabalhar quaisquer matérias por desbaste, operando por laser ou por outro feixe de luz ou de fotões, por ultra-som, electro-erosão, processos electroquímicos, por feixes de electrões, feixes iónicos ou por jacto de plasma','Machine-tools for working any material by removal of material, by laser or other light or photon beam, ultrasonic, electrodischarge, electrochemical, electron beam, ionic-beam or plasma arc processes','Máquinas herramienta que trabajen por arranque de cualquier materia mediante láser u otros haces de luz o de fotones, por ultrasonido, electroerosión, procesos electroquímicos, haces de electrones, haces iónicos o chorro de plasma',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8457,'Centros de maquinagem, máquinas de sistema monostático (single station) e máquinas de estações múltiplas, para trabalhar metais','Machining centres, unit construction machines (single station) and multi-station transfer machines, for working metal','Centros de mecanizado, máquinas de puesto fijo y máquinas de puestos múltiples, para trabajar metal',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8458,'Tornos (incluídos os centros de torneamento), para metais','Lathes (including turning centres) for removing metal','Tornos, incluidos los centros de torneado, que trabajen por arranque de metal',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8459,'Máquinas-ferramentas (incluídas as unidades com cabeça deslizante) para furar, escarear, fresar ou roscar, interior ou exteriormente, metais, por eliminação de matéria, exceto os tornos (incluídos os centros de torneamento) da posição 8458','Machine-tools (including way-type unit head machines) for drilling, boring, milling, threading or tapping by removing metal, other than lathes (including turning centres) of heading No 8458','Máquinas, incluidas las unidades de mecanizado de correderas, de taladrar, escariar, fresar o roscar, incluso aterrajar, metal por arranque de materia (excepto los tornos [incluidos los centros de torneado] de la partida 8458)',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8460,'Máquinas-ferramentas para rebarbar, afiar, amolar, rectificar, brunir ou polir ou realizar outras operações de acabamento em metais ou ceramais (cermets) por meio de mós, de abrasivos ou de produtos polidores, exceto as máquinas de cortar ou acabar engre','Machine-tools for deburring, sharpening, grinding, honing, lapping, polishing or otherwise finishing metal or cermets by means of grinding stones, abrasives or polishing products, other than gear cutting, gear grinding or gear finishing machines of headin','Máquinas de desbarbar, afilar, amolar, rectificar, lapear (bruñir), pulir o hacer otras operaciones de acabado, para metal o cermet, mediante muelas, abrasivos o productos para pulir (excepto las máquinas para tallar o acabar engranajes de la partida 8461',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8461,'Máquinas-ferramentas para aplainar, plainas-limadoras, máquinas-ferramentas para escatelar, mandrilar, cortar ou acabar engrenagens, serrar, seccionar e outras máquinas-ferramentas que operem por eliminação de metal ou de ceramais (cermets), não especific','Machine-tools for planing, shaping, slotting, broaching, gear cutting, gear grinding or gear finishing, sawing, cutting-off and other machine-tools working by removing metal or cermets, not elsewhere specified or included','Máquinas de cepillar, limar, mortajar, brochar, tallar o acabar engranajes, aserrar, trocear y demás máquinas herramienta que trabajen por arranque de metal o cermet, no expresadas ni comprendidas en otra parte',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8462,'Máquinas-ferramentas (incluídas as prensas) para forjar ou estampar, martelos, martelos-pilões e martinetes, para trabalhar metais; máquinas- -ferramentas (incluídas as prensas) para enrolar, arquear, dobrar, endireitar, aplanar, cisalhar, puncionar ou ch','Machine-tools (including presses) for working metal by forging, hammering or die-stamping; machine-tools (including presses) for working metal by bending, folding, straightening, flattening, shearing, punching or notching; presses for working metal or met','Máquinas, incluidas las prensas, de forjar o estampar, martillos pilón y otras máquinas de martillar, para trabajar metal, máquinas, incluidas la prensas, de enrollar, curvar, plegar, enderezar, aplanar, cizallar, punzonar o entallar metal; prensas para t',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8463,'Outras máquinas-ferramentas para trabalhar metais ou ceramais (cermets), operando sem eliminação de matéria','Other machine-tools for working metal or cermets, without removing material','Las demás máquinas herramienta para trabajar metal o cermet, que no trabajen por arranque de materia',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8464,'Máquinas-ferramentas para trabalhar pedra, produtos cerâmicos, betão (concreto), fibrocimento ou matérias minerais semelhantes, ou para o trabalho a frio do vidro','Machine-tools for working stone, ceramics, concrete, asbestos-cement or like mineral materials or for cold-working glass','Máquinas herramienta para trabajar piedra, cerámica, hormigón, amiantocemento o materias minerales similares, o para trabajar el vidrio en frío',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8465,'Máquinas-ferramentas (incluídas as máquinas para pregar, grampear, colar ou reunir por qualquer outro modo) para trabalhar madeira, cortiça, osso, borracha endurecida, plásticos duros ou matérias duras semelhantes','Machine-tools (including machines for nailing, stapling, glueing or otherwise assembling) for working wood, cork, bone, hard rubber, hard plastics or similar hard materials','Máquinas herramienta, incluidas las de clavar, grapar, encolar o ensamblar de otro modo para trabajar madera, corcho, hueso, caucho endurecido, plástico rígido o materias duras similares',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8466,'Partes e acessórios reconhecíveis como exclusiva ou principalmente destinados às máquinas das posições 8456 a 8465, incluídos os porta-peças e porta-ferramentas, as fieiras de abertura automática, os dispositivos divisores e outros dispositivos especiais,','Parts and accessories suitable for use solely or principally with the machines of heading Nos 8456 to 8465, including work or tool holders, self-opening dieheads, dividing heads and other special attachments for machine-tools; tool holders for any type of','Partes y accesorios identificables como destinados, exclusiva o principalmente, a las máquinas de las partidas 8456 a 8465, incluidos los portapiezas y portaútiles, dispositivos de roscar de apertura automática, divisores y demás dispositivos especiales p',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8467,'Ferramentas pneumáticas, hidráulicas ou de motor (eléctrico ou não eléctrico) incorporado, de uso manual','Tools for working in the hand, pneumatic, hydraulic or with self-contained electric or non-electric motor','Herramientas neumáticas, hidráulicas o con motor incorporado, incluso eléctrico, de uso manual',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8468,'Máquinas e aparelhos para soldar, mesmo de corte, exceto os da posição 8515; máquinas e aparelhos a gás para têmpera superficial','Machinery and apparatus for soldering, brazing or welding, whether or not capable of cutting, other than those of heading 8515; gas-operated surface tempering machines and appliances','Máquinas y aparatos para soldar, aunque puedan cortar (excepto los de la partida 8515); máquinas y aparatos de gas para temple superficial',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8469,'Máquinas de escrever exceto as impressoras da posição 8471; máquinas de tratamento de textos','Typewriters other than printers of heading 8471; word-processing machines','Máquinas de escribir (excepto las impresoras de la partida 8471); máquinas para tratamiento o procesamiento de textos',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8470,'Máquinas de calcular e máquinas de bolso que permitem gravar, reproduzir e visualizar informações, com função de cálculo incorporada; máquinas de contabilidade, máquinas de franquear, de emitir bilhetes e máquinas semelhantes, com dispositivo de cálculo i','Calculating machines and pocket-size data-recording, reproducing and displaying machines with calculating functions; accounting machines, postage-franking machines, ticket-issuing machines and similar machines, incorporating a calculating device; cash reg','Máquinas de calcular y máquinas de bolsillo registradoras, reproductoras y visualizadoras de datos, con función de cálculo; máquinas de contabilidad, de franquear, expedir boletos (tiques) y máquinas similares, con dispositivo de cálculo incorporado; caja',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8471,'Máquinas automáticas para processamento de dados e suas unidades; leitores magnéticos ou ópticos, máquinas para registar dados em suporte sob forma codificada, e máquinas para processamento desses dados, não especificadas nem compreendidas em outras posiç','Automatic data-processing machines and units thereof; magnetic or optical readers, machines for transcribing data onto data media in coded form and machines for processing such data, not elsewhere specified or included','Máquinas automáticas para tratamiento o procesamiento de datos y sus unidades; lectores magnéticos u ópticos, máquinas para registro de datos sobre soporte en forma codificada y máquinas para tratamiento o procesamiento de estos datos, no expresados ni co',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8472,'Outras máquinas e aparelhos de escritório [por exemplo: duplicadores hectográficos ou a stencil, máquinas para imprimir endereços, distribuidores automáticos de papel-moeda, máquinas para seleccionar, contar ou empacotar moedas, afiadores (apontadores) me','Other office machines (for example, hectograph or stencil duplicating machines, addressing machines, automatic banknote dispensers, coin-sorting machines, coin-counting or wrapping machines, pencil-sharpening machines, perforating or stapling machines)','Las demás máquinas y aparatos de oficina (por ejemplo: copiadoras hectográficas, mimeógrafos, máquinas de imprimir direcciones, distribuidores automáticos de billetes de banco, máquinas de clasificar, contar o encartuchar monedas, sacapuntas, perforadoras',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8473,'Partes e acessórios (exceto estojos, capas e semelhantes), reconhecíveis como exclusiva ou principalmente destinados às máquinas e aparelhos das posições 8469 a 8472','Parts and accessories (other than covers, carrying cases and the like) suitable for use solely or principally with machines of headings 8469 to 8472','Partes y accesorios (excepto los estuches, fundas y similares) identificables como destinados, exclusiva o principalmente, a las máquinas o aparatos de las partidas 8469 a 8472',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8474,'Máquinas e aparelhos, para seleccionar, peneirar, separar, lavar, esmagar, moer, misturar ou amassar terras, pedras, minérios ou outras substâncias minerais sólidas (incluídos os pós e pastas); máquinas para aglomerar ou moldar combustíveis minerais sólid','Machinery for sorting, screening, separating, washing, crushing, grinding, mixing or kneading earth, stone, ores or other mineral substances, in solid (including powder or paste) form; machinery for agglomerating, shaping or moulding solid mineral fuels, ','Máquinas y aparatos de clasificar, cribar, separar, lavar, quebrantar, triturar, pulverizar, mezclar, amasar o sobar, tierra, piedra u otra materia mineral sólida, incluido el polvo y la pasta; máquinas de aglomerar, formar o moldear combustibles minerale',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8475,'Máquinas para montagem de lâmpadas, tubos ou válvulas, elétricos ou electrónicos, ou de lâmpadas de luz-relâmpago (flash), que tenham invólucro de vidro; máquinas para fabricação ou trabalho a quente do vidro ou das suas obras','Machines for assembling electric or electronic lamps, tubes or valves or flashbulbs, in glass envelopes; machines for manufacturing or hot working glass or glassware','Máquinas para montar lámparas, tubos o válvulas eléctricos o electrónicos o lámparas de destello, que tengan envoltura de vidrio; máquinas para fabricar o trabajar en caliente el vidrio o sus manufacturas',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8476,'Máquinas automáticas de venda de produtos (por exemplo: selos, cigarros, alimentos ou bebidas), incluídas as máquinas de trocar dinheiro','Automatic goods-vending machines (for example, postage stamp, cigarette, food or beverage machines), including money-changing machines','Máquinas automáticas para la venta de productos (por ejemplo: sellos [estampillas], cigarrillos, alimentos, bebidas), incluidas las máquinas de cambiar moneda',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8477,'Máquinas e aparelhos, para trabalhar borracha ou plástico ou para fabricação de produtos dessas matérias, não especificados nem compreendidos em outras posições deste capítulo','Machinery for working rubber or plastics or for the manufacture of products from these materials, not specified or included elsewhere in this chapter','Máquinas y aparatos para trabajar caucho o plásticos o para fabricar productos de estas materias, no expresados ni comprendidos en otra parte de este capítulo',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8478,'Máquinas e aparelhos, para preparar ou transformar tabaco, não especificados nem compreendidos em outras posições deste capítulo','Machinery for preparing or making up tobacco, not specified or included elsewhere in this chapter','Máquinas y aparatos para preparar o elaborar tabaco, no expresados ni comprendidos en otra parte de este capítulo',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8479,'Máquinas e aparelhos, mecânicos, com função própria, não especificados nem compreendidos em outras posições deste capítulo','Machines and mechanical appliances having individual functions, not specified or included elsewhere in this chapter','Máquinas y aparatos mecánicos con función propia, no expresados ni comprendidos en otra parte de este capítulo',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8480,'Caixas de fundição; placas de fundo para moldes; modelos para moldes; moldes para metais (exceto lingoteiras), carbonetos metálicos, vidro, matérias minerais, borracha ou plástico','Moulding boxes for metal foundry; mould bases; moulding patterns; moulds for metal (other than ingot moulds), metal carbides, glass, mineral materials, rubber or plastics','Cajas de fundición; placas de fondo para moldes; modelos para moldes; moldes para metal (excepto las lingoteras), carburos metálicos, vidrio, materia mineral, caucho o plástico',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8481,'Torneiras, válvulas (incluídas as redutoras de pressão e as termostáticas) e dispositivos semelhantes, para canalizações, caldeiras, reservatórios, cubas e outros recipientes','Taps, cocks, valves and similar appliances for pipes, boiler shells, tanks, vats or the like, including pressure-reducing valves and thermostatically controlled valves','Artículos de grifería y órganos similares para tuberías, calderas, depósitos, cubas o continentes similares, incluidas las válvulas reductoras de presión y las válvulas termostáticas',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8482,'Rolamentos de esferas, de roletes ou de agulhas','Ball or roller bearings','Rodamientos de bolas, de rodillos o de agujas',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8483,'Veios (árvores) de transmissão [incluídas as árvores de cames (excênticos) e cambotas (virabrequins)] e manivelas; chumaceiras (mancais) e bronzes; engrenagens e rodas de fricção; eixos de esferas ou de roletes; redutores, multiplicadores, caixas de trans','Transmission shafts (including cam shafts and crank shafts) and cranks; bearing housings and plain shaft bearings; gears and gearing; ball or roller screws; gear boxes and other speed changers, including torque converters; flywheels and pulleys, including','Árboles de transmisión, incluidos los de levas y los cigüeñales y manivelas; cajas de cojinetes y cojinetes; engranajes y ruedas de fricción; husillos fileteados de bolas o rodillos; reductores, multiplicadores y variadores de velocidad, incluidos los con',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8484,'Juntas metaloplásticas; jogos ou sortidos de juntas de composições diferentes, apresentados em bolsas, envelopes ou embalagens semelhantes; juntas de vedação mecânicas','Gaskets and similar joints of metal sheeting combined with other material or of two or more layers of metal; sets or assortments of gaskets and similar joints, dissimilar in composition, put up in pouches, envelopes or similar packings; mechanical seals','Juntas metaloplásticas; surtidos de juntas  o empaquetaduras de distinta composición presentados en bolsitas, sobres o envases análogos; juntas o empaquetaduras mecánicas de estanqueidad',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8485,'Partes de máquinas ou de aparelhos, não especificadas nem compreendidas em outras posições do presente capítulo, não contendo conexões elétricas, partes isoladas electricamente, bobinas, contactos nem quaisquer outros elementos com características elétricas','Machinery parts, not containing electrical connectors, insulators, coils, contacts or other electrical features, not specified or included elsewhere in this chapter','Partes de máquinas o aparatos, no expresadas ni comprendidas en otra parte de este capítulo, sin conexiones eléctricas, partes aisladas eléctricamente, bobinados, contactos ni otras características eléctricas',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8486,'Máquinas e aparelhos dos tipos utilizados exclusiva ou principalmente na fabricação de "esferas" (boules) ou de plaquetas (wafers), de dispositivos semicondutores, de circuitos integrados eletrônicos ou de dispositivos de visualização de tela plana; máquinas e aparelhos especificados na Nota 9 C) do presente Capítulo; partes e acessórios','Machines and apparatus of a kind used solely or mainly for the manufacture of semiconductor boules or wafers','Máquinas y aparatos de los tipos utilizados exclusiva o principalmente para la fabricación de bloques o discos semiconductores',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8487,'Partes de máquinas ou de aparelhos, não especificadas nem compreendidas noutras posições do presente Capítulo, que não contenham conexões elétricas, partes isoladas eletricamente, bobinas, contatos nem quaisquer outros elementos com características elétricas','Parts of machines or apparatus','Partes de máquinas o aparatos',84);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8501,'Motores e geradores, elétricos, exceto os grupos electrogéneos','Electric motors and generators (excluding generating sets)','Motores y generadores, eléctricos (excepto los grupos electrógenos)',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8502,'Grupos electrogéneos e conversores rotativos, elétricos','Electric generating sets and rotary converters','Grupos electrógenos y convertidores rotativos eléctricos',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8503,'Partes reconhecíveis como destinadas às máquinas das posições 8501 ou 8502','Parts suitable for use with the machines of heading 8501 or 8502','Partes identificables como destinadas a las máquinas de las partidas 8501 u 8502',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8504,'Transformadores elétricos, conversores elétricos estáticos (rectificadores, por exemplo), bobinas de reactância e de auto-indução','Electrical transformers, static converters (for example, rectifiers) and inductors','Transformadores eléctricos, convertidores eléctricos estáticos (por ejemplo: rectificadores) y bobinas de reactancia (autoinducción)',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8505,'Electroímanes; ímanes permanentes e artefactos destinados a tornarem-se ímanes permanentes após magnetização; placas, mandris e dispositivos semelhantes, magnéticos ou electromagnéticos, de fixação; acoplamentos, embraiagens, variadores de velocidade e fr','Electro-magnets; permanent magnets and articles intended to become permanent magnets after magnetisation; electromagnetic or permanent magnet chucks, clamps and similar holding devices; electromagnetic couplings, clutches and brakes; electromagnetic lifti','Electroimanes; imanes permanentes y artículos destinados a ser imantados permanentemente; platos, mandriles y dispositivos magnéticos o electromagnéticos similares, de sujeción; acoplamientos, embragues, variadores de velocidad y frenos, electromagnéticos',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8506,'Pilhas e baterias de pilhas, elétricas','Primary cells and primary batteries','Pilas y baterías de pilas, eléctricas',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8507,'Acumuladores elétricos e seus separadores, mesmo de forma quadrada ou rectangular','Electric accumulators, including separators therefor, whether or not rectangular (including square)','Acumuladores eléctricos, incluidos sus separadores, aunque sean cuadrados o rectangulares',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8508,'Aspiradores','Vacuum cleaners','Aspiradoras',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8509,'Aparelhos electromecânicos com motor eléctrico incorporado, de uso doméstico','Electromechanical domestic appliances, with self-contained electric motor','Aparatos electromecánicos con motor eléctrico incorporado, de uso doméstico',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8510,'Aparelhos ou máquinas de barbear e máquinas de cortar o cabelo ou de tosquiar e aparelhos ou máquinas de depilar, de motor eléctrico incorporado','Shavers, hair clippers and hair-removing appliances, with self-contained electric motor','Afeitadoras, máquinas de cortar el pelo o esquilar y aparatos de depilar, con motor eléctrico incorporado',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8511,'Aparelhos e dispositivos elétricos de ignição ou de arranque para motores de ignição por faísca ou por compressão (por exemplo, magnetos, dínamos-magnetos, bobinas de ignição, velas de ignição ou de aquecimento, motores de arranque); geradores (dínamos e','Electrical ignition or starting equipment of a kind used for spark-ignition or compression-ignition internal combustion engines (for example, ignition magnetos, magneto-dynamos, ignition coils, sparking plugs and glow plugs, starter motors); generators (f','Aparatos y dispositivos eléctricos de encendido o de arranque, para motores de encendido por chispa o por compresión (por ejemplo: magnetos, dinamomagnetos, bobinas de encendido, bujías de encendido o calentamiento, motores de arranque); generadores (por ',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8512,'Aparelhos elétricos de iluminação ou de sinalização (exceto os da posição 8539), limpadores de pára-brisas, degeladores e desembaciadores elétricos, dos tipos utilizados em ciclos e automóveis','Electrical lighting or signalling equipment (excluding articles of heading 8539), windscreen wipers, defrosters and demisters, of a kind used for cycles or motor vehicles','Aparatos eléctricos de alumbrado o señalización (excepto los artículos de la partida 8539), limpiaparabrisas, eliminadores de escarcha o vaho, eléctricos, de los tipos utilizados en velocípedos o vehículos automóviles',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8513,'Lanternas elétricas portáteis destinadas a funcionar por meio da sua própria fonte de energia (por exemplo: de pilhas, de acumuladores, de magnetos), excluídos os aparelhos de iluminação da posição 8512','Portable electric lamps designed to function by their own source of energy (for example, dry batteries, accumulators, magnetos), other than lighting equipment of heading 8512','Lámparas eléctricas portátiles concebidas para funcionar con su propia fuente de energía (por ejemplo: de pilas, acumuladores,  electromagnéticas) (excepto los aparatos de alumbrado de la partida 8512)',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8514,'Fornos elétricos industriais ou de laboratório, incluídos os que funcionam por indução ou por perdas dielétricas; outros aparelhos industriais ou de laboratório, para tratamento térmico de matérias por indução ou por perdas dielétricas','Industrial or laboratory electric  furnaces and ovens (including those functioning by induction or dielectric loss); other industrial or laboratory equipment for the heat treatment of materials by induction or dielectric loss','Hornos eléctricos industriales o de laboratorio, incluidos los que funcionen por inducción o pérdidas dieléctricas; los demás aparatos industriales o de laboratorio para tratamiento térmico de materias por inducción o pérdidas dieléctricas',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8515,'Máquinas e aparelhos para soldar (mesmo de corte) elétricos (incluídos os a gás aquecido electricamente), a laser ou outros feixes de luz ou de fotões, a ultra-som, a feixe de electrões, a impulsos magnéticos ou a jacto de plasma; máquinas e aparelhos el','Electric (including electrically heated gas), laser or other light or photon beam, ultrasonic, electron beam, magnetic pulse or plasma arc soldering, brazing or welding machines and apparatus, whether or not capable of cutting; electric machines and appar','Máquinas y aparatos para soldar (aunque puedan cortar), eléctricos, incluidos los de gas calentado eléctricamente, de láser u otros haces de luz o de fotones, ultrasonido, haces de electrones, impulsos magnéticos o chorro de plasma; máquinas y aparatos el',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8516,'Aquecedores elétricos de água, incluídos os de imersão; aparelhos elétricos para aquecimento de ambientes, do solo ou para usos semelhantes; aparelhos electrotérmicos para arranjos do cabelo (por exemplo: secadores de cabelo, frisadores, aquecedores de ','Electric instantaneous or storage water heaters and immersion heaters; electric space heating apparatus and soil heating apparatus; electrothermic hair-dressing apparatus (for example, hair dryers, hair curlers, curling tong heaters) and hand dryers; elec','Calentadores eléctricos de agua de calentamiento instantáneo o acumulación y calentadores eléctricos de inmersión; aparatos eléctricos para calefacción de espacios o suelos; aparatos electrotérmicos para el cuidado del cabello (por ejemplo: secadores, riz',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8517,'Aparelhos elétricos para telefonia ou telegrafia por fios, incluídos os aparelhos telefónicos por fio combinados com auscultadores sem fio e os aparelhos de telecomunicação por corrente portadora ou de telecomunicação digital; videofones','Electrical apparatus for line telephony or line telegraphy, including line telephone sets with cordless handsets and telecommunication apparatus for carrier-current line systems or for digital line systems; videophones','Aparatos eléctricos de telefonía o telegrafía con hilos, incluidos los teléfonos de usuario de auricular inalámbrico combinado con micrófono y los aparatos de telecomunicación por corriente portadora o telecomunicación digital; videófonos',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8518,'Microfones e seus suportes; altifalantes, mesmo montados nos seus receptáculos; capacetes com auscultadores e auscultadores, mesmo combinados com um microfone, e conjuntos ou sortidos constituídos por um microfone e um ou vários altifalantes; amplificador','Microphones and stands therefor; loudspeakers, whether or not mounted in their enclosures; headphones and earphones, whether or not combined with a microphone, and sets consisting of a microphone and one or more loudspeakers; audio-frequency electric ampl','Micrófonos y sus soportes; altavoces (altoparlantes), incluso montados en sus cajas; auriculares, incluidos los de casco, incluso combinados con micrófono y juegos o conjuntos constituidos por un micrófono y uno o varios altavoces (altoparlantes); amplifi',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8519,'Gira-discos, electrofones, leitores de cassetes e outros aparelhos de reprodução de som, sem dispositivo de gravação de som','Turntables (record-decks), record-players, cassette-players and other sound reproducing apparatus, not incorporating a sound recording device','Giradiscos, tocadiscos, reproductores de casetes (tocacasetes) y demás reproductores de sonido, sin dispositivo de grabación de sonido incorporado',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8520,'Gravadores de suportes magnéticos e outros aparelhos de gravação de som, mesmo com dispositivo de reprodução de som incorporado','Magnetic tape recorders and other sound recording apparatus, whether or not incorporating a sound reproducing device','Magnetófonos y demás aparatos de grabación de sonido, incluso con dispositivo de reproducción de sonido incorporado',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8521,'Aparelhos videofónicos de gravação ou de reprodução, mesmo incorporando um receptor de sinais videofónicos','Video recording or reproducing apparatus, whether or not incorporating a video tuner','Aparatos de grabación o reproducción de imagen y sonido (vídeos), incluso con receptor de señales de imagen y sonido incorporado',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8522,'Partes e acessórios reconhecíveis como sendo exclusiva ou principalmente destinados aos aparelhos das posições 8519 a 8521','Parts and accessories suitable for use solely or principally with the apparatus of headings 8519 to 8521','Partes y accesorios identificables como destinados, exclusiva o principalmente, a los aparatos de las partidas 8519 a 8521',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8523,'Suportes preparados para gravação de som ou para gravações semelhantes, não gravados, exceto os produtos do Capítulo 37','Prepared unrecorded media for sound recording or similar recording of other phenomena, other than products of Chapter 37','Soportes preparados para grabar sonido o grabaciones análogas, sin grabar (excepto los productos del capítulo 37)',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8524,'Discos, fitas e outros suportes para gravação de som ou para gravações semelhantes, gravados, incluídos os moldes e matrizes galvânicos para fabricação de discos, com exclusão dos produtos do Capítulo 37','Records, tapes and other recorded media for sound or other similarly recorded phenomena, including matrices and masters for the production of records, but excluding products of Chapter 37','Discos, cintas y demás soportes para grabar sonido o grabaciones análogas, grabados, incluso las matrices y moldes galvánicos para fabricación de discos (excepto los productos del capítulo 37)',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8525,'Aparelhos emissores (transmissores) para radiotelefonia, radiotelegrafia, radiodifusão ou televisão, mesmo incorporando um aparelho de recepção ou um aparelho de gravação ou de reprodução de som; câmaras de televisão; câmaras de video de imagens fixas e o','Transmission apparatus for radio-telephony, radio-telegraphy, radio-broadcasting or television, whether or not incorporating reception apparatus or sound recording or reproducing apparatus; television cameras; still image video cameras and other video cam','Aparatos emisores de radiotelefonía, radiotelegrafía, radiodifusión o televisión, incluso con aparato receptor o de grabación o reproducción de sonido incorporado; cámaras de televisión; videocámaras, incluidas las de imagen fija; cámaras digitales',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8526,'Aparelhos de radiodetecção e de radiossondagem (radar), aparelhos de radionavegação e aparelhos de radiotelecomando','Radar apparatus, radio navigational aid apparatus and radio remote control apparatus','Aparatos de radar, radionavegación o radiotelemando',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8527,'Aparelhos receptores para radiotelefonia, radiotelegrafia ou radiodifusão, mesmo combinados, num mesmo gabinete ou invólucro, com um aparelho de gravação ou de reprodução de som, ou com um relógio','Reception apparatus for radio-telephony, radio-telegraphy or radio-broadcasting, whether or not combined, in the same housing, with sound recording or reproducing apparatus or a clock','Aparatos receptores de radiotelefonía, radiotelegrafía o radiodifusión, incluso combinados en la misma envoltura con grabador o reproductor de sonido o con reloj',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8528,'Aparelhos receptores de televisão, mesmo incorporando um aparelho receptor de radiodifusão ou um aparelho de gravação ou de reprodução de som ou de imagens; monitores e projectores de video','Reception apparatus for television, whether or not incorporating radio-broadcast receivers or sound or video recording or reproducing apparatus; video monitors and video projectors','Aparatos receptores de televisión, incluso con aparato receptor de radiodifusión o de grabación o reproducción de sonido o imagen incorporado; videomonitores y videoproyectores',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8529,'Partes reconhecíveis como exclusiva ou principalmente destinadas aos aparelhos das posições 8525 a 8528','Parts suitable for use solely or principally with the apparatus of headings 8525 to 8528','Partes identificables como destinadas, exclusiva o principalmente, a los aparatos de las partidas 8525 a 8528',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8530,'Aparelhos elétricos de sinalização (excluídos os de transmissão de mensagens), de segurança, de contrôle ou de comando, para vias férreas ou semelhantes, vias terrestres ou fluviais, para áreas ou parques de estacionamento, instalações portuárias ou para','Electrical signalling, safety or traffic control equipment for railways, tramways, roads, inland waterways parking facilities, port installations or airfields (other than those of heading 8608)','Aparatos eléctricos de señalización (excepto los de transmisión de mensajes),  seguridad, control o mando, para vías férreas o similares, carreteras, vías fluviales, áreas o parques de estacionamiento, instalaciones portuarias o aeropuertos (excepto los d',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8531,'Aparelhos elétricos de sinalização acústica ou visual (por exemplo: campainhas, sirenes, quadros indicadores, aparelhos de alarme para protecção contra roubo ou incêndio), exceto os das posições 8512 ou 8530','Electric sound or visual signalling apparatus (for example, bells, sirens, indicator panels, burglar or fire alarms), other than those of heading 8512 or 8530','Aparatos eléctricos de señalización acústica o visual (por ejemplo: timbres, sirenas, tableros indicadores, avisadores de protección contra robo o incendio) (excepto los de las partidas 8512 u 8530)',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8532,'Condensadores elétricos, fixos, variáveis ou ajustáveis','Electrical capacitors, fixed, variable or adjustable (pre-set)','Condensadores eléctricos fijos, variables o ajustables',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8533,'Resistências elétricas (incluídos os reóstatos e os potenciómetros), exceto de aquecimento','Electrical resistors (including rheostats and potentiometers), other than heating resistors','Resistencias eléctricas (excepto las de calentamiento), incluidos reóstatos y potenciómetros',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8534,'Circuito impresso','Printed circuits','Circuito impreso',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8535,'Aparelhos para interrupção, seccionamento, protecção, derivação, ligação ou conexão de circuitos elétricos (por exemplo: interruptores, comutadores, corta-circuitos, pára-raios, limitadores de tensão, eliminadores de onda, tomadas de corrente, caixas de ','Electrical apparatus for switching or protecting electrical circuits, or for making connections to or in electrical circuits (for example, switches, fuses, lightning arresters, voltage limiters, surge suppressors, plugs, junction boxes), for a voltage exc','Aparatos para corte, seccionamiento, protección, derivación, empalme o conexión de circuitos eléctricos (por ejemplo: interruptores, conmutadores, cortacircuitos, pararrayos, limitadores de tensión, supresores de sobretensión transitoria, tomas de corrien',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8536,'Aparelhos para interrupção, seccionamento, protecção, derivação, ligação ou conexão de circuitos elétricos (por exemplo: interruptores, comutadores, relés, corta-circuitos, eliminadores de onda, tomadas de corrente, machos e fêmeas, suportes para lâmpada','Electrical apparatus for switching or protecting electrical circuits, or for making connections to or in electrical circuits (for example, switches, relays, fuses, surge suppressors, plugs, sockets, lamp-holders, junction boxes), for a voltage not exceedi','Aparatos para corte, seccionamiento, protección, derivación, empalme o conexión de circuitos eléctricos [por ejemplo: interruptores, conmutadores, relés, cortacircuitos, supresores de sobretensión transitoria, clavijas y tomas de corriente (enchufes), por',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8537,'Quadros, painéis, consolas, cabinas, armários e outros suportes, com dois ou mais aparelhos das posições 8535 ou 8536, para comando eléctrico ou distribuição de energia eléctrica, incluídos os que incorporem instrumentos ou aparelhos do Capítulo 90, assim','Boards, panels, consoles, desks, cabinets and other bases, equipped with two or more apparatus of heading 8535 or 8536, for electric control or the distribution of electricity, including those incorporating instruments or apparatus of Chapter 90, and nume','Cuadros, paneles, consolas, armarios y demás soportes equipados con varios aparatos de las partidas 8535 u 8536, para control o distribución de electricidad, incluidos los que incorporen instrumentos o aparatos del capítulo 90, así como los aparatos de co',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8538,'Partes reconhecíveis como exclusiva ou principalmente destinadas aos aparelhos das posições 8535, 8536 ou 8537','Parts suitable for use solely or principally with the apparatus of heading 8535, 8536 or 8537','Partes identificables como destinadas, exclusiva o principalmente, a los aparatos de las partidas 8535, 8536 u 8537',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8539,'Lâmpadas e tubos elétricos de incandescência ou de descarga, incluídos os artigos denominados « faróis e projectores, em unidades seladas » e as lâmpadas e tubos de raios ultravioleta ou infravermelhos; lâmpadas de arco','Electric filament or discharge lamps, including sealed-beam lamp units and ultraviolet or infrared lamps; arc-lamps','Lámparas y tubos eléctricos de incandescencia o de descarga, incluidos los faros o unidades «sellados» y las lámparas y tubos de rayos ultravioletas o infrarrojos; lámparas de arco',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8540,'Lâmpadas, tubos e válvulas electrónicos, de cátodo quente, cátodo frio ou fotocátodo (por exemplo: lâmpadas, tubos e válvulas, de vácuo, de vapor ou de gás, ampolas rectificadoras de vapor de mercúrio, tubos catódicos, tubos e válvulas para câmaras de tel','Thermionic, cold cathode or photocathode valves and tubes (for example, vacuum or vapour or gas filled valves and tubes, mercury arc rectifying valves and tubes, cathode-ray tubes, television camera tubes)','Lámparas, tubos y válvulas electrónicos, de cátodo caliente, cátodo frío o fotocátodo (por ejemplo: lámparas, tubos y válvulas, de vacío, de vapor o gas, tubos rectificadores de vapor de mercurio, tubos catódicos, tubos y válvulas para cámaras de televisi',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8541,'Díodos, transístores e dispositivos semelhantes com semicondutores; dispositivos fotossensíveis semicondutores, incluídas as células fotovoltaicas, mesmo montadas em módulos ou em painéis; díodos emissores de luz; cristais piezoelétricos montados','Diodes, transistors and similar semiconductor devices; photosensitive semiconductor devices, including photovoltaic cells whether or not assembled in modules or made-up into panels; light-emitting diodes; mounted piezo-electric crystals','Diodos, transistores y dispositivos semiconductores similares; dispositivos semiconductores fotosensibles, incluidas las células fotovoltaicas, aunque estén ensambladas en módulos o paneles; diodos emisores de luz; cristales piezoeléctricos montados',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8542,'Circuitos integrados e microconjuntos electrónicos','Electronic integrated circuits and microassemblies','Circuitos integrados y microestructuras electrónicas',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8543,'Máquinas e aparelhos, elétricos, com função própria, não especificados nem compreendidos em outras posições do presente capítulo','Electrical machines and apparatus, having individual functions, not specified or included elsewhere in this chapter','Máquinas y aparatos eléctricos con función propia, no expresados ni comprendidos en otra parte de este capítulo',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8544,'Fios, cabos (incluídos os cabos coaxiais) e outros condutores, isolados para usos elétricos (incluídos os envernizados ou oxidados anodicamente), mesmo com peças de conexão; cabos de fibras ópticas, constituídos de fibras embainhadas individualmente, mes','Insulated (including enamelled or anodised) wire, cable (including coaxial cable) and other insulated electric conductors, whether or not fitted with connectors; optical fibre cables, made-up of individually sheathed fibres, whether or not assembled with ','Hilos, cables, incluidos los coaxiales y demás conductores aislados para electricidad, aunque estén laqueados, anodizados o provistos de piezas de conexión; cables de fibras ópticas constituidos por fibras enfundadas individualmente, incluso con conductor',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8545,'Eléctrodos de carvão, escovas de carvão, carvões para lâmpadas ou para pilhas e outros artigos de grafite ou de carvão, com ou sem metal, para usos elétricos','Carbon electrodes, carbon brushes, lamp carbons, battery carbons and other articles of graphite or other carbon, with or without metal, of a kind used for electrical purposes','Electrodos y escobillas de carbón, carbón para lámparas o pilas y demás artículos de grafito u otros carbonos, incluso con metal, para usos eléctricos',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8546,'Isoladores de qualquer matéria, para usos elétricos','Electrical insulators of any material','Aisladores eléctricos de cualquier materia',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8547,'Peças isolantes, inteiramente de matérias isolantes, ou com simples peças metálicas de montagem (suportes roscados, por exemplo) incorporadas na massa, para máquinas, aparelhos e instalações elétricas, exceto os isoladores da posição 8546; tubos isolado','Insulating fittings for electrical machines, appliances or equipment, being fittings wholly of insulating material apart from any minor components of metal (for example, threaded sockets) incorporated during moulding solely for purposes of assembly, other','Piezas aislantes totalmente de materia aislante o con simples piezas metálicas de ensamblado (por ejemplo: casquillos roscados) embutidas en la masa, para máquinas, aparatos o instalaciones eléctricas (excepto los aisladores de la partida 8546); tubos ais',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8548,'Desperdícios e resíduos de pilhas, de baterias de pilhas e de acumuladores, elétricos; pilhas, baterias de pilhas e acumuladores, elétricos, inservíveis; partes elétricas de máquinas e aparelhos, não especificadas nem compreendidas em outras posições d','Waste and scrap of primary cells, primary batteries and electric accumulators; spent primary cells, spent primary batteries and spent electric accumulators; electrical parts of machinery or apparatus, not specified or included elsewhere in this chapter','Desperdicios y desechos de pilas, baterías de pilas o acumuladores, eléctricos; pilas, baterías de pilas y acumuladores, eléctricos, inservibles; partes eléctricas de máquinas o aparatos, no expresadas ni comprendidas en otra parte de este capítulo',85);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8601,'Locomotivas e locotractores, de fonte externa de electricidade ou de acumuladores elétricos','Rail locomotives powered from an external source of electricity or by electric accumulators','Locomotoras y locotractores de fuente externa de electricidad o acumuladores eléctricos',86);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8602,'Outras locomotivas e locotractores; tênderes','Other rail locomotives; locomotive tenders','Las demás locomotoras y locotractores; ténderes',86);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8603,'Automotoras, mesmo para circulação urbana, exceto as da posição 8604','Self-propelled railway or tramway coaches, vans and trucks, other than those of heading 8604','Automotores para vías férreas y tranvías autopropulsados (excepto los de la partida 8604)',86);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8604,'Veículos para inspeção e manutenção de vias férreas ou semelhantes, mesmo autopropulsores','Railway or tramway maintenance or service vehicles','Vehículos de ferrocarril o tranvía o el servicio de mantenimiento',86);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8605,'Vagões de passageiros, furgões para bagagem, vagões-postais, e outros vagões especiais, para vias férreas ou semelhantes','Railway, tramway pass etc coaches not self-propelled','Ferrocarriles, tranvías, etc entrenadores de paso, no autopropulsadas',86);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8606,'Vagões para transporte de mercadorias sobre vias férreas','Railway or tramway goods vans and wagons, not self-propelled','Vagones para transporte de mercancías sobre carriles (rieles)',86);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8607,'Partes de veículos para vias férreas ou semelhantes','Parts of railway or tramway locomotives or rolling-stock','Partes de vehículos para vías férreas o similares',86);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8608,'Material fixo de vias férreas ou semelhantes; aparelhos de sinalização, segurança, controle ou comando para vias férreas, rodoviárias ou fluviais','Railway fixtures, mechanized signaling, safety, etc','Instalaciones ferroviarias, señalización mecanizada, seguridad, etc',86);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8609,'conteineres (contentores) incl.de transp.fluidos, etc.','containers includ.the transport of fluids,etc.','contenedores incl.de transp.fluidos, etc',86);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8701,'Tractores (exceto os da posição 8709)','Tractors (other than tractors of heading 8709)','Tractores (excepto las carretillas tractor de la partida 8709)',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8702,'Veículos automóveis para o transporte de dez pessoas ou mais, incluíndo o condutor','Motor vehicles for the transport of 10 or more persons, including the driver','Vehículos automóviles para transporte de diez o más personas, incluido el conductor',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8703,'Automóveis de passageiros e outros veículos automóveis principalmente concebidos para o transporte de pessoas (exceto os da posição 8702), incluídos os veículos de uso misto (station wagons) e os automóveis de corrida','Motor cars and other motor vehicles principally designed for the transport of persons (other than those of heading 8702), including station wagons and racing cars','Automóviles de turismo y demás vehículos automóviles concebidos principalmente para transporte de personas (excepto los de la partida 8702), incluidos los del tipo familiar (break o station wagon) y los de carreras',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8704,'Veículos automóveis para transporte de mercadorias','Motor vehicles for the transport of goods','Vehículos automóviles para transporte de mercancías',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8705,'Veículos automóveis para usos especiais (por exemplo: auto-socorros, camiões-guindastes, veículos de combate a incêndio, camiões-betoneiras, veículos para varrer, veículos para espalhar, veículos-oficinas, veículos radiológicos), exceto os concebidos pri','Special purpose motor vehicles, other than those principally designed for the transport of persons or goods (for example, breakdown lorries, crane lorries, fire-fighting vehicles, concrete-mixer lorries, road sweeper lorries, spraying lorries, mobile work','Vehículos automóviles para usos especiales (excepto los concebidos principalmente para transporte de personas o mercancías) [por ejemplo: coches para reparaciones (auxilio mecánico), camiones grúa, camiones de bomberos, camiones hormigonera, coches barred',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8706,'Chassis, com motor, para veículos automóveis das posições 87.01 a 87.05','Chassis, with engines, for vehicles of positions 87.01 through 87.05','Chasis con motor para vehículos de las partidas de 87.01 a 87.05',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8707,'Carroçarias para os veículos automóveis das posições 8701 a 8705, incluídas as cabinas','Bodies (including cabs), for the motor vehicles of headings 8701 to 8705','Carrocerías de vehículos automóviles de las partidas 8701 a 8705, incluidas las cabinas',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8708,'Partes e acessórios dos veículos automóveis das posições 8701 a 8705','Parts and accessories of the motor vehicles of heading 8701 to 8705','Partes y accesorios de vehículos automóviles de las partidas 8701 a 8705',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8709,'Veículos automóveis sem dispositivo de elevação, dos tipos utilizados em fábricas, armazéns, portos ou aeroportos, para o transporte de mercadorias a curtas distâncias; carros-tractores dos tipos utilizados nas estações ferroviárias; suas partes','Works trucks, self-propelled, not fitted with lifting or handling equipment, of the type used in factories, warehouses, dock areas or airports for short distance transport of goods; tractors of the type used on railway station platforms; parts of the fore','Carretillas automóvil sin dispositivo de elevación del tipo de las utilizadas en fábricas, almacenes, puertos o aeropuertos, para transporte de mercancías a corta distancia; carretillas tractor del tipo de las utilizadas en las estaciones ferroviarias; pa',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8710,'Veículos e carros blindados de combate e suas partes','Tank and other armored fight vehicle, motorized, and parts','Tanques y demás vehículos.aut.blindad.de combate y sus partes',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8711,'Motocicletas (incluídos os ciclomotores) e outros ciclos equipados com motor auxiliar, mesmo com carro lateral; carros laterais','Motor-cycles (including mopeds) and cycles fitted with an auxiliary motor, with or without side-cars; side-cars','Motocicletas, incluidos los ciclomotores, y velocípedos equipados con motor auxiliar, con sidecar o sin él; sidecares',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8712,'Bicicletas e outros ciclos (incluídos os triciclos), sem motor','Bicycles and other cycles (including tricycles), without engines','Bicicletas y demás ciclos (incluidos los triciclos), sin motores',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8713,'Cadeiras de rodas e outros veículos para inválidos, mesmo com motor ou outro mecanismo de propulsão','Carriages for disabled persons, whether or not motorised or otherwise mechanically propelled','Sillones de ruedas y demás vehículos para inválidos, incluso con motor u otro mecanismo de propulsión',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8714,'Partes e acessórios dos veículos das posições 8711 a 8713','Parts and accessories of vehicles of headings 8711 to 8713','Partes y accesorios de vehículos de las partidas 8711 a 8713',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8715,'Carrinhos, veic.semelh.e suas partes, p/transp.crianças','Baby carriages,similar vehicles and parts thereof','Coches, vehíc.simil.y sus partes, p/transp.de niños',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8716,'Reboques e semi-reboques para quaisquer veículos; outros veículos não autopropulsores; suas partes','Trailers and semi-trailers; other vehicles, not mechanically propelled; parts thereof','Remolques y semirremolques para cualquier vehículo; los demás vehículos no automóviles; sus partes',87);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8801,'Balões e dirigíveis; planadores, asas voadoras e outros veículos aéreos, não concebidos para propulsão com motor','Balloons and dirigibles; gliders, hang gliders and other non-powered aircraft','Globos y dirigibles; planeadores, alas planeadoras y demás aeronaves no concebidas para la propulsión con motor',88);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8802,'Outros veículos aéreos (por exemplo: helicópteros, aviões); veículos espaciais (incluídos os satélites) e seus veículos de lançamento e veículos suborbitais','Other aircraft (for example, helicopters, aeroplanes); spacecraft (including satellites) and suborbital and spacecraft launch vehicles','Las demás aeronaves (por ejemplo: helicópteros, aviones); vehículos espaciales, incluidos los satélites y sus vehículos de lanzamiento y vehículos suborbitales',88);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8803,'Partes dos veículos e aparelhos, das posições 8801 ou 8802','Parts of goods of heading 8801 or 8802','Partes de los aparatos de las partidas 8801 u 8802',88);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8804,'Pára-quedas/pára-quedas giratórios, suas partes e acess.','Parachutes/rotochutes,its parts and access.','Paracaídas/de aspas giratorias, sus partes y acces.',88);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8805,'Aparelhos e dispositivos para lançamento de veículos aéreos; aparelhos e dispositivos para aterragem de veículos aéreos em porta-aviões e aparelhos e dispositivos semelhantes; aparelhos simuladores de voo em terra; suas partes','Aircraft launching gear; deck-arrestor or similar gear; ground flying trainers; parts of the foregoing articles','Aparatos y dispositivos para lanzamiento de aeronaves; aparatos y dispositivos para aterrizaje en portaaviones y aparatos y dispositivos similares; aparatos de entrenamiento de vuelo en tierra; sus partes',88);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8901,'Transatlânticos, barcos de cruzeiro, ferry-boats, cargueiros, chatas e embarcações semelhantes, para o transporte de pessoas ou de mercadorias','Cruise ships, excursion boats, ferry-boats, cargo ships, barges and similar vessels for the transport of persons or goods','Transatlánticos, barcos para excursiones (de cruceros), transbordadores, cargueros, gabarras (barcazas) y barcos similares para transporte de personas o mercancías',89);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8902,'Barcos de pesca; navios-fábricas e outras embarcações para o tratamento ou conservação de produtos da pesca','Fishing vessels, factory ships and ships, vessels','Los buques pesqueros, buques factoría y los buques, embarcaciones',89);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8903,'Iates e outros barcos e embarcações de recreio ou de desporto; barcos a remos e canoas','Yachts and other vessels for pleasure or sports; rowing boats and canoes','Yates y demás barcos y embarcaciones de recreo o deporte; barcas (botes) de remo y canoas',89);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8904,'Rebocadores e barcos para empurrar outras embarcações','Tugs and pusher craft','Remolcadores y barcos empujadores',89);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8905,'Barcos-faróis, barcos-bombas, dragas, guindastes flutuantes e outras embarcações em que a navegação é acessória da função principal; docas flutuantes; plataformas de perfuração ou de exploração, flutuantes ou submersíveis','Light-vessels, fire-floats, dredgers, floating cranes, and other vessels the navigability of which is subsidiary to their main function; floating docks; floating or submersible drilling or production platforms','Barcos faro, barcos bomba, dragas, pontones grúa y demás barcos en los que la navegación sea accesoria en relación con la función principal; diques flotantes; plataformas de perforación o explotación, flotantes o sumergibles',89);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8906,'Outras embarcações, incluídos os navios de guerra e os barcos salva-vidas, exceto os barcos a remos','Other vessels, including warships and lifeboats other than rowing boats','Los demás barcos, incluidos los navíos de guerra y barcos de salvamento excepto los de remo',89);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8907,'Outras estruturas flutuantes (por exemplo: balsas, reservatórios, caixões, bóias de amarração, bóias de sinalização e semelhantes)','Other floating structures (for example, rafts, tanks, coffer-dams, landing-stages, buoys and beacons)','Artefactos flotantes (por ejemplo: balsas, depósitos, cajones, incluso de amarre, boyas y balizas)',89);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (8908,'Embarcações e outras estruturas flutuantes p/demolicao','vessels and other floating structures f/breaking up','barcos y demás artefactos flotantes p/desguace',89);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9001,'Fibras ópticas e feixes de fibras ópticas; cabos de fibras ópticas, exceto os da posição 8544; matérias polarizantes, em folhas ou em placas; lentes (incluídas as de contacto), prismas, espelhos e outros elementos de óptica de qualquer matéria, não monta','Optical fibres and optical fibre bundles; optical fibre cables other than those of heading No 8544; sheets and plates of polarising material; lenses (including contact lenses), prisms, mirrors and other optical elements, of any material, unmounted, other ','Fibras ópticas y haces de fibras ópticas; cables de fibras ópticas (excepto los de la partida 8544); hojas y placas de materia polarizante; lentes, incluso las de contacto, prismas, espejos y demás elementos de óptica de cualquier materia, sin montar (exc',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9002,'Lentes, prismas, espelhos e outros elementos de óptica, de qualquer matéria, montados, para instrumentos e aparelhos, exceto os de vidro não trabalhado opticamente','Lenses, prisms, mirrors and other optical elements, of any material, mounted, being parts of or fittings for instruments or apparatus, other than such elements of glass not optically worked','Lentes, prismas, espejos y demás elementos de óptica de cualquier materia, montados, para instrumentos o aparatos (excepto los de vidrio sin trabajar ópticamente)',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9003,'Armações para óculos e artigos semelhantes, e suas partes','Frames and mountings for spectacles, goggles or the like, and parts thereof','Monturas (armazones) de gafas (anteojos) o de artículos similares y sus partes',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9004,'Óculos para correcção, protecção ou outros fins, e artigos semelhantes','Spectacles, goggles and the like, corrective, protective or other','Gafas (anteojos) correctoras, protectoras u otras, y artículos similares',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9005,'Binóculos, lunetas, incluídas as astronómicas, telescópios ópticos, e suas armações; outros instrumentos de astronomia e suas armações, exceto os aparelhos de radioastronomia','Binoculars, monoculars, other optical telescopes, and mountings therefor; other astronomical instruments and mountings therefor, but not including instruments for radio-astronomy','Binoculares, incluidos los prismáticos, catalejos, anteojos astronómicos, telescopios ópticos y sus armazones; los demás instrumentos de astronomía y sus armazones (excepto los aparatos de radioastronomía)',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9006,'Aparelhos fotográficos; aparelhos e dispositivos, incluindo as lâmpadas e tubos de luz-relâmpago (flash) para fotografia, exceto as lâmpadas e tubos de descarga da posição 8539','Photographic (other than cinematographic) cameras; photographic flashlight apparatus and flashbulbs other than discharge lamps of heading 8539','Cámaras fotográficas; aparatos y dispositivos, incluidos las lámparas y tubos, para la producción de destellos en fotografía (excepto las lámparas y tubos de descarga de la partida 8539)',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9007,'Câmaras e projectores, cinematográficos, mesmo com aparelhos de gravação ou de reprodução de som incorporados','Cinematographic cameras and projectors, whether or not incorporating sound recording or reproducing apparatus','Cámaras y proyectores cinematográficos, incluso con grabador o reproductor de sonido incorporados',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9008,'Aparelhos de projecção fixa; aparelhos fotográficos, de ampliação ou de redução','Image projectors, other than cinematographic; photographic (other than cinematographic) enlargers and reducers','Proyectores de imagen fija; ampliadoras o reductoras, fotográficas',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9009,'Aparelhos de fotocópia, por sistema óptico ou por contacto, e aparelhos de termocópia','Photocopying apparatus incorporating an optical system or of the contact type and thermo-copying apparatus','Aparatos de fotocopia por sistema óptico o de contacto y aparatos de termocopia',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9010,'Aparelhos e material dos tipos usados nos laboratórios fotográficos ou cinematográficos (incluídos os aparelhos para projecção ou execução de traçados de circuitos sobre superfícies sensibilizadas de materiais semicondutores), não especificados nem compre','Apparatus and equipment for photographic (including cinematographic) laboratories (including apparatus for the projection or drawing of circuit patterns on sensitised semi-conductor materials), not specified or included elsewhere in this chapter; negatosc','Aparatos y material para laboratorios fotográfico o cinematográfico, incluidos los aparatos para proyectar o realizar esquemas (trazas) de circuitos sobre superficies sensibilizadas de material semiconductor, no expresados ni comprendidos en otra parte de',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9011,'Microscópios ópticos, incluídos os microscópios para fotomicrografia, cinefotomicrografia ou microprojecção','Compound optical microscopes, including those for photomicrography, cinephotomicrography or microprojection','Microscopios ópticos, incluso para fotomicrografía, cinefotomicrografía o microproyección',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9012,'Microscópios, exceto ópticos; difractógrafos','Microscopes other than optical microscopes; diffraction apparatus','Microscopios, excepto los ópticos; difractógrafos',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9013,'Dispositivos de cristais líquidos que não constituam artigos compreendidos mais especificamente em outras posições; lasers, exceto díodos laser; outros aparelhos e instrumentos de óptica, não especificados nem compreendidos em outras posições do presente','Liquid crystal devices not constituting articles provided for more specifically in other headings; lasers, other than laser diodes; other optical appliances and instruments, not specified or included elsewhere in this chapter','Dispositivos de cristal líquido que no constituyan artículos comprendidos más específicamente en otra parte; láseres (excepto los diodos láser); los demás aparatos e instrumentos de óptica, no expresados ni comprendidos en otra parte de este capítulo',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9014,'Bússolas, incluídas as agulhas de marear; outros instrumentos e aparelhos de navegação','Direction finding compasses; other navigational instruments and appliances','Brújulas, incluidos los compases de navegación; los demás instrumentos y aparatos de navegación',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9015,'Instrumentos e aparelhos de geodesia, topografia, agrimensura, nivelamento, fotogrametria, hidrografia, oceanografia, hidrologia, meteorologia ou de geofísica, exceto bússolas; telémetros','Surveying (including photogrammetrical surveying), hydrographic, oceanographic, hydrological, meteorological or geophysical instruments and appliances, excluding compasses; rangefinders','Instrumentos y aparatos de geodesia, topografía, agrimensura, nivelación, fotogrametría, hidrografía, oceanografía, hidrología, meteorología o geofísica (excepto las brújulas); telémetros',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9016,'Balanças sensíveis a pesos >= 5 cg, com ou sem pesos','Balances, sensitivity > =5 cg, w or w/o wgt, & pts','Saldos, con sensibilidad > = 5 cg, W o W / O WGT, y puntos',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9017,'Instrumentos de desenho, de traçado ou de cálculo (por exemplo: máquinas de desenhar, pantógrafos, transferidores, estojos de desenho geométrico, réguas de cálculo e discos de cálculo); instrumentos de medida de distâncias de uso manual (por exemplo: metr','Drawing, marking-out or mathematical calculating instruments (for example, drafting machines, pantographs, protractors, drawing sets, slide rules, disc calculators); instruments for measuring length, for use in the hand (for example, measuring rods and ta','Instrumentos de dibujo, trazado o cálculo (por ejemplo: máquinas de dibujar, pantógrafos, transportadores, estuches de dibujo, reglas y círculos, de cálculo); instrumentos manuales de medida de longitud (por ejemplo: metros, micrómetros, calibradores), no',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9018,'Instrumentos e aparelhos para medicina, cirurgia, odontologia e veterinária, incluídos os aparelhos de cintilografia e outros aparelhos electromédicos, bem como os aparelhos para testes visuais','Instruments and appliances used in medical, surgical, dental or veterinary sciences, including scintigraphic apparatus, other electromedical apparatus and sight-testing instruments','Instrumentos y aparatos de medicina, cirugía, odontología o veterinaria, incluidos los de centellografía y demás aparatos electromédicos, así como los aparatos para pruebas visuales',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9019,'Aparelhos de mecanoterapia; aparelhos de massagem; aparelhos de psicotécnica; aparelhos de ozonoterapia, de oxigenoterapia, de aerossolterapia, aparelhos respiratórios de reanimação e outros aparelhos de terapia respiratória','Mechano-therapy appliances; massage apparatus; psychological aptitude-testing apparatus; ozone therapy, oxygen therapy, aerosol therapy, artificial respiration or other therapeutic respiration apparatus','Aparatos de mecanoterapia; aparatos para masajes; aparatos de sicotecnia; aparatos de ozonoterapia, oxigenoterapia o aerosolterapia, aparatos respiratorios de reanimación y demás aparatos de terapia respiratoria',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9020,'Outros aparelhos respiratórios e máscaras contra gases, exceto as de proteção desprovidas de mecanismo e de elemento filtrante amovível','Breathing appliances and gas masks; parts','Aparatos respiratorios y máscaras de gas; partes',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9021,'Artigos e aparelhos ortopédicos, incluídas as cintas e fundas médico-cirúrgicas e as muletas; talas, goteiras e outros artigos e aparelhos para fracturas; artigos e aparelhos de prótese; aparelhos para facilitar a audição dos surdos e outros aparelhos par','Orthopaedic appliances, including crutches, surgical belts and trusses; splints and other fracture appliances; artificial parts of the body; hearing aids and other appliances which are worn or carried, or implanted in the body, to compensate for a defect ','Artículos y aparatos de ortopedia, incluidas las fajas y vendajes médicoquirúrgicos y las muletas; tablillas, férulas u otros artículos y aparatos para fracturas; artículos y aparatos de prótesis; audífonos y demás aparatos que lleve la propia persona o s',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9022,'Aparelhos de raios X e aparelhos que utilizem as radiações alfa, beta ou gama, mesmo para usos médicos, cirúrgicos, odontológicos ou veterinários, incluídos os aparelhos de radiofotografia ou de radioterapia, os tubos de raios X e outros dispositivos gera','Apparatus based on the use of X-rays or of alpha, beta or gamma radiations, whether or not for medical, surgical, dental or veterinary uses, including radiography or radiotherapy apparatus, X-ray tubes and other X-ray generators, high tension generators, ','Aparatos de rayos X y aparatos que utilicen radiaciones alfa, beta o gamma, incluso para uso médico, quirúrgico, odontológico o veterinario, incluidos los aparatos de radiografía o radioterapia, tubos de rayos X y demás dispositivos generadores de rayos X',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9023,'instrumentos, apars.e modelos p/demonstracao ensino, etc.','instrum.appar.and models f/demonstrat.in education,etc.','instrum., apars.y modelos conc.p/demonstr.enseñanza, etc',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9024,'Máquinas e aparelhos para ensaios de dureza, tracção, compressão, elasticidade e de outras propriedades mecânicas de materiais (por exemplo: metais, madeira, têxteis, papel, plásticos)','Machines and appliances for testing the hardness, strength, compressibility, elasticity or other mechanical properties of materials (for example, metals, wood, textiles, paper, plastics)','Máquinas y aparatos para ensayos de dureza, tracción, compresión, elasticidad u otras propiedades mecánicas de materiales (por ejemplo: metal, madera, textil, papel, plástico)',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9025,'Densímetros, areómetros, pesa-líquidos e instrumentos flutuantes semelhantes, termómetros, pirómetros, barómetros, higrómetros e psicrómetros, registadores ou não, mesmo combinados entre si','Hydrometers and similar floating instruments, thermometers, pyrometers, barometers, hygrometers and psychrometers, recording or not, and any combination of these instruments','Densímetros, areómetros, pesalíquidos e instrumentos flotantes similares, termómetros, pirómetros, barómetros, higrómetros y sicrómetros incluso registradores o combinados entre sí',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9026,'Instrumentos e aparelhos para medida ou controlo do caudal (vazão), do nível, da pressão ou de outras características variáveis dos líquidos ou gases (por exemplo: medidores de caudal, indicadores de nível, manómetros, contadores de calor), exceto os ins','Instruments and apparatus for measuring or checking the flow, level, pressure or other variables of liquids or gases (for example, flow meters, level gauges, manometers, heat meters), excluding instruments and apparatus of heading 9014, 9015, 9028 or 9032','Instrumentos y aparatos para medida o control del caudal, nivel, presión u otras características variables de líquidos o gases (por ejemplo: caudalímetros, indicadores de nivel, manómetros, contadores de calor) (excepto los instrumentos y aparatos de las ',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9027,'Instrumentos e aparelhos para análises físicas ou químicas (por exemplo: polarímetros, refractómetros, espectrómetros, analisadores de gases ou de fumos); instrumentos e aparelhos para ensaios de viscosidade, porosidade, dilatação, tensão superficial ou s','Instruments and apparatus for physical or chemical analysis (for example, polarimeters, refractometers, spectrometers, gas or smoke analysis apparatus); instruments and apparatus for measuring or checking viscosity, porosity, expansion, surface tension or','Instrumentos y aparatos para análisis físicos o químicos (por ejemplo polarímetros, refractómetros, espectrómetros, analizadores de gases o de humos); instrumentos y aparatos para ensayos de viscosidad, porosidad, dilatación, tensión superficial o similar',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9028,'Contadores de gases, de líquidos ou de electricidade, incluídos os aparelhos para a sua aferição','Gas, liquid or electricity supply or production meters, including calibrating meters therefor','Contadores de gas, líquido o electricidad, incluidos los de calibración',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9029,'Outros contadores (por exemplo: contadores de voltas, contadores de produção, taxímetros, totalizadores de caminho percorrido, podómetros); indicadores de velocidade e tacómetros, exceto os das posições 9014 ou 9015; estroboscópios','Revolution counters, production counters, taximeters, milometers, pedometers and the like; speed indicators and tachometers, other than those of heading 9014 or 9015; stroboscopes','Los demás contadores (por ejemplo: cuentarrevoluciones, contadores de producción, taxímetros, cuentakilómetros, podómetros); velocímetros y tacómetros (excepto los de las partidas 9014 ó 9015); estroboscopios',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9030,'Osciloscópios, analisadores de espectro e outros instrumentos e aparelhos para medida ou controlo de grandezas elétricas; instrumentos e aparelhos para medida ou detecção de radiações alfa, beta, gama, X, cósmicas ou outras radiações ionizantes','Oscilloscopes, spectrum analysers and other instruments and apparatus for measuring or checking electrical quantities, excluding meters of heading 9028; instruments and apparatus for measuring or detecting alpha, beta, gamma, X-ray, cosmic or other ionisi','Osciloscopios, analizadores de espectro y demás instrumentos y aparatos para medida o control de magnitudes eléctricas; instrumentos y aparatos para medida o detección de radiaciones alfa, beta, gamma, X, cósmicas o demás radiaciones ionizantes',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9031,'Instrumentos, aparelhos e máquinas de medida ou controlo, não especificados nem compreendidos em outras posições do presente capítulo; projectores de perfis','Measuring or checking instruments, appliances and machines, not specified or included elsewhere in this chapter; profile projectors','Instrumentos, máquinas y aparatos para medida o control, no expresados ni comprendidos en otra parte de este capítulo; proyectores de perfiles',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9032,'Instrumentos e aparelhos para regulação ou controlo, automáticos','Automatic regulating or controlling instruments and apparatus','Instrumentos y aparatos automáticos para regulación o control automáticos',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9033,'partes e acess.p/outs.maqs.apars.instrum.de óptica, etc.','parts and acess.f/oth.optical mach.appar.instrumen.etc.','partes y acces.p/ots.máqs.apars.instrum.de óptica, etc',90);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9101,'Relógios de pulso, relógios de bolso e relógios semelhantes (incluídos os contadores de tempo dos mesmos tipos), com caixa de metais preciosos ou de metais folheados ou chapeados de metais preciosos','Wristwatches, pocket-watches and other watches, including stopwatches, with case of precious metal or of metal clad with precious metal','Relojes de pulsera, bolsillo y similares, incluidos los contadores de tiempo de los mismos tipos, con caja de metal precioso o chapado de metal precioso (plaqué)',91);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9102,'Relógios de pulso, relógios de bolso e relógios semelhantes (incluídos os contadores de tempo dos mesmos tipos), exceto os da posição 9101','Wristwatches, pocket-watches and other watches, including stopwatches, other than those of heading 9101','Relojes de pulsera, bolsillo y similares, incluidos los contadores de tiempo de los mismos tipos (excepto los de la partida 9101)',91);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9103,'Despertadores e outros relógios de mecanismo de pequeno volume','Clocks with watch movements, excluding clocks of heading 9104','Despertadores y demás relojes de pequeño mecanismo de relojería',91);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9104,'Relógios p/paineis de instrum.p/automóveis e outs.veics','instrum.panel clocks f/motor vehicles and oth.vehicles','relojes de tablero de instr.p/automóviles y ots.vehícs',91);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9105,'Despertadores e outros relógios e aparelhos de relojoaria semelhantes, exceto de mecanismo de pequeno volume','Other clocks','Los demás relojes',91);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9106,'Aparelhos de controlo do tempo e contadores de tempo, de mecanismo de relojoaria ou motor síncrono (por exemplo: relógios de ponto, relógios datadores, contadores de horas)','Time of day recording apparatus and apparatus for measuring, recording or otherwise indicating intervals of time, with clock or watch movement or with synchronous motor (for example, time-registers, time-recorders)','Aparatos de control de tiempo y contadores de tiempo, con mecanismo de relojería o motor sincrónico (por ejemplo: registradores de asistencia, registradores fechadores, registradores contadores)',91);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9107,'Interruptores horários e outros aparelhos que permitam acionar um mecanismo em tempo determinado, com maquinismo de aparelhos de relojoaria ou de motor síncrono','Time switches with clock/watch movement/synchronous motor','Interruptores horarios con el movimiento del reloj / reloj / motor síncrono',91);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9108,'Mecanismo de pequeno volume para relógios, completos e montados','Watch movements, complete and assembled','Pequeños mecanismos de relojería completos y montados',91);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9109,'Mecanismos de relojoaria, completos e montados, exceto de pequeno volume','Clock movements, complete and assembled','Los demás mecanismos de relojería completos y montados (excepto los pequeños mecanismos)',91);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9110,'Mecanismos de relojoaria completos, não montados ou parcialmente montados (chablons); mecanismos de relojoaria incompletos, montados; esboços de relojoaria','Complete watch or clock movements, unassembled or partly assembled (movement sets); incomplete watch or clock movements, assembled; rough watch or clock movements','Mecanismos de relojería completos, sin montar o parcialmente montados (chablons); mecanismos de relojería incompletos, montados; mecanismos de relojería «en blanco» (ébauches)',91);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9111,'Caixas de relógios das posições 9101 ou 9102 e suas partes','Watch cases and parts thereof','Cajas de los relojes de las partidas 9101 ó 9102 y sus partes',91);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9112,'Caixas de outros aparelhos de relojoaria e suas partes','Clock cases and cases of a similar type for other goods of this chapter, and parts thereof','Cajas y envolturas similares para los demás aparatos de relojería y sus partes',91);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9113,'Pulseiras de relógios e suas partes','Watch straps, watch bands and watch bracelets, and parts thereof','Pulseras para reloj y sus partes',91);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9114,'Outras partes de relojoaria','Other clock or watch parts','Las demás partes de aparatos de relojería',91);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9201,'Pianos, mesmo automáticos; cravos e outros instrumentos de cordas, com teclado','Pianos, including automatic pianos; harpsichords and other keyboard stringed instruments','Pianos, incluso automáticos; clavecines y demás instrumentos de cuerda con teclado',92);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9202,'Outros instrumentos musicais de cordas (por exemplo: guitarras, violinos, harpas)','Other string musical instruments (for example, guitars, violins, harps)','Los demás instrumentos musicales de cuerda (por ejemplo: guitarras, violines, arpas)',92);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9203,'Órgãos de tubos e de teclado, harmonios e instrum.semelhantes','Keyboard pipe organs,harmon.and similar keyboard instr.','Órganos de tubos y teclado, armonios y instrum.simil.',92);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9204,'Acordeões e instrumentos semelhantes; harmónicas de boca','Accordions and similar instruments; mouth organs','Acordeones e instrumentos similares; armónicas',92);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9205,'Outros instrumentos musicais de sopro (por exemplo: clarinetes, trompetes, gaitas de foles)','Other wind musical instruments (for example, clarinets, trumpets, bagpipes)','Los demás instrumentos musicales de viento (por ejemplo: clarinetes, trompetas, gaitas)',92);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9206,'Instrumentos musicais de percussão (tambores, etc.)','Percussion musical instruments (drums ,etc.)','Instrumentos musicales de percusión (tambores, etc)',92);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9207,'Instrumentos musicais cujo som é produzido ou amplificado por meios elétricos (por exemplo: órgãos, guitarras, acordeões)','Musical instruments, the sound of which is produced, or must be amplified, electrically (for example, organs, guitars, accordions)','Instrumentos musicales en los que el sonido se produzca o tenga que amplificarse eléctricamente (por ejemplo: órganos, guitarras, acordeones)',92);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9208,'Caixas de música, órgãos mecânicos de feira, realejos, pássaros cantores mecânicos, serrotes musicais e outros instrumentos musicais não especificados em outra posição do presente capítulo; chamarizes de qualquer tipo; apitos, cornetas de sinais e outros ','Musical boxes, fairground organs, mechanical street organs, mechanical singing birds, musical saws and other musical instruments not falling within any other heading of this chapter; decoy calls of all kinds; whistles, call horns and other mouth-blown sou','Cajas de música, orquestriones, organillos, pájaros cantores, sierras musicales y demás instrumentos musicales no comprendidos en otra partida de este capítulo; reclamos de cualquier clase; silbatos, cuernos y demás instrumentos de boca, de llamada o avis',92);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9209,'Partes (mecanismos de caixas de música, por exemplo) e acessórios (por exemplo: cartões, discos e rolos para instrumentos mecânicos) de instrumentos musicais; metrónomos e diapasões de todos os tipos','Parts (for example, mechanisms for musical boxes) and accessories (for example, cards, discs and rolls for mechanical instruments) of musical instruments; metronomes, tuning forks and pitch pipes of all kinds','Partes (por ejemplo: mecanismos de cajas de música) y accesorios de instrumentos musicales (por ejemplo: tarjetas, discos y rollos para aparatos mecánicos) de instrumentos musicales; metrónomos y diapasones de cualquier tipo',92);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9301,'Armas de guerra, exceto revólveres, pistolas e armas brancas','Military weapons, other than revolvers, pistols and the arms of heading 9307','Armas de guerra (excepto los revólveres, pistolas y armas blancas)',93);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9302,'Outros revólveres e pistolas','Other revolvers and pistols','Demás revólveres y pistolas',93);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9303,'Outras armas de fogo e aparelhos semelhantes que utilizem a deflagração da pólvora (por exemplo: espingardas e carabinas de caça, armas de fogo carregáveis exclusivamente pela boca, pistolas lança-foguetes e outros aparelhos concebidos apenas para lançar ','Other firearms and similar devices which operate by the firing of an explosive charge (for example, sporting shotguns and rifles, muzzle-loading firearms, Very pistols and other devices designed to project only signal flares, pistols and revolvers for fir','Las demás armas de fuego y artefactos similares que utilicen la deflagración de la pólvora (por ejemplo: armas de caza, armas de avancarga, pistolas lanzacohete y demas artefactos concebidos únicamente para lanzar cohetes de señal, pistolas y revólveres d',93);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9304,'Outras armas (espingardas/carabinas/pistolas/cassetetes)','Oth.arms (shotguns/carbines/pistols /truncheons)','Demás armas (armas largas/carabinas/pistolas/porras)',93);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9305,'Partes e acessórios, dos artigos das posições 9301 a 9304','Parts and accessories of articles of headings 9301 to 9304','Partes y accesorios de los artículos de las partidas 9301 a 9304',93);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9306,'Bombas, granadas, torpedos, minas, mísseis, cartuchos e outras munições e projécteis, e suas partes, incluídos os zagalotes, chumbos de caça e buchas para cartuchos','Bombs, grenades, torpedoes, mines, missiles and similar munitions of war and parts thereof; cartridges and other ammunition and projectiles and parts thereof, including shot and cartridge wads','Bombas, granadas, torpedos, minas, misiles, cartuchos y demás municiones y proyectiles, y sus partes, incluidas las postas, perdigones y tacos para cartuchos',93);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9307,'Sabres, espadas, baionetas, outs.armas brancas, suas partes','Swords,cutlasses,bayonets,oth.arms and parts thereof','Sables, espadas, bayonetas, dem.armas blancas, sus partes',93);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9401,'Assentos (exceto os da posição 9402), mesmo transformáveis em camas, e suas partes','Seats (other than those of heading 9402), whether or not convertible into beds, and parts thereof','Asientos (excepto los de la partida 9402), incluso los transformables en cama, y sus partes',94);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9402,'Mobiliário para medicina, cirurgia, odontologia ou veterinária (por exemplo: mesas de operação, mesas de exames, camas dotadas de mecanismos para usos clínicos, cadeiras de dentista); cadeiras para salões de cabeleireiro e cadeiras semelhantes, com dispos','Medical, surgical, dental or veterinary furniture (for example, operating tables, examination tables, hospital beds with mechanical fittings, dentists'' chairs); barbers'' chairs and similar chairs, having rotating as well as both reclining and elevating mo','Mobiliario para medicina, cirugía, odontología o veterinaria (por ejemplo: mesas de operaciones o de reconocimiento, camas con mecanismo para uso clínico, sillones de dentista); sillones de peluquería y sillones similares, con dispositivos de orientación ',94);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9403,'Outros móveis e suas partes','Other furniture and parts thereof','Demás muebles y sus partes',94);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9404,'Suportes elásticos para camas; colchões, edredões, almofadas, pufes, travesseiros e artigos semelhantes, equipados com molas ou guarnecidos interiormente de quaisquer matérias, compreendendo esses artigos de borracha ou de plástico alveolares, mesmo recob','Mattress supports; articles of bedding and similar furnishing (for example, mattresses, quilts, eiderdowns, cushions, pouffes and pillows) fitted with springs or stuffed or internally fitted with any material or of cellular rubber or plastics, whether or ','Somieres; artículos de cama y artículos similares (por ejemplo: colchones, cubrepiés, edredones, cojines, pufes, almohadas), bien con muelles (resortes), bien rellenos o guarnecidos interiormente con cualquier materia, incluidos los de caucho o plástico c',94);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9405,'Aparelhos de iluminação (incluídos os projectores) e suas partes, não especificados nem compreendidos em outras posições; anúncios, tabuletas ou cartazes e placas indicadoras luminosos, e artigos semelhantes, que contenham uma fonte luminosa fixa permanen','Lamps and lighting fittings including searchlights and spotlights and parts thereof, not elsewhere specified or included; illuminated signs, illuminated name-plates and the like, having a permanently fixed light source, and parts thereof not elsewhere spe','Aparatos de alumbrado, incluidos los proyectores, y sus partes, no expresados ni comprendidos en otra parte; anuncios, letreros y placas indicadoras luminosos y artículos similares, con fuente de luz inseparable, y sus partes no expresadas ni comprendidas',94);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9406,'Construções pré-fabricadas','Prefabricated buildings','Construcciones prefabricadas',94);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9501,'Brinquedos de rodas para crianças e carrinhos para bonecos','Wheeled toys for children and dolls carriages','Juguetes de ruedas p/niños y coches de ruedas para muñecos',95);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9502,'Bonecos representando exclusivamente a figura humana','Dolls representing only human beings','Muñecas y muñecos que representen solamente seres humanos',95);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9503,'Outros brinquedos; modelos reduzidos e modelos semelhantes para divertimento, mesmo animados; quebra-cabeças (puzzles) de qualquer tipo','Other toys; reduced-size (''scale'') models and similar recreational models, working or not; puzzles of all kinds','Los demás juguetes; modelos reducidos y modelos similares, para entretenimiento, incluso animados; rompecabezas de cualquier clase',95);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9504,'Artigos para jogos de salão, incluídos os jogos com motor ou outro mecanismo, os bilhares, as mesas especiais para jogos de casino e os jogos de paulitos automáticos (boliche, por exemplo)','Articles for funfair, table or parlour games, including pintables, billiards, special tables for casino games and automatic bowling alley equipment','Artículos para salas de juego, juegos de mesa o salón, incluidos los juegos con motor o mecanismo, billares, mesas especiales para juegos de casino y juegos de bolos automáticos',95);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9505,'Artigos para festas, carnaval ou outros divertimentos, incluídos os artigos de magia e artigos surpresa','Festive, carnival or other entertainment articles, including conjuring tricks and novelty jokes','Artículos para fiestas, carnaval u otras diversiones, incluidos los de magia y artículos sorpresa',95);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9506,'Artigos e equipamentos para cultura física, ginástica, atletismo, outros desportos (incluído o ténis de mesa) ou jogos ao ar livre, não especificados nem compreendidos em outras posições deste capítulo; piscinas, incluídas as infantis','Articles and equipment for general physical exercise, gymnastics, athletics, other sports (including table-tennis) or outdoor games, not specified or included elsewhere in this chapter; swimming pools and paddling pools','Artículos y material para cultura física, gimnasia, atletismo, demás deportes, incluido el tenis de mesa o para juegos al aire libre, no expresados ni comprendidos en otra parte de este capítulo; piscinas, incluso infantiles',95);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9507,'Canas de pesca, anzóis e outros artigos para a pesca à linha; camaroeiros e redes semelhantes para qualquer finalidade; iscas e chamarizes (exceto os das posições 9208 ou 9705) e artigos semelhantes de caça e pesca','Fishing rods, fish-hooks and other line fishing tackle; fish landing nets, butterfly nets and similar nets; decoy ''birds'' (other than those of heading No 9208 or 9705) and similar hunting or shooting requisites','Cañas de pescar, anzuelos y demás artículos para la pesca con caña; salabardos, cazamariposas y redes similares; señuelos (excepto los de las partidas 9208 ó 9705) y artículos de caza similares',95);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9508,'Carrosséis, baloiços, instalações de tiro ao alvo e outras diversões de parques e feiras; circos ambulantes e colecções de animais ambulantes; teatros ambulantes','Roundabouts, swings, shooting galleries and other fairground amusements; travelling circuses and travelling menageries; travelling theatres','Tiovivos, columpios, casetas de tiro y demás atracciones de feria; circos, zoológicos y teatros, ambulantes',95);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9601,'Marfim, osso, carapaça de tartaruga, chifre, pontas, coral, madrepérola e outras matérias animais para entalhar, trabalhados, e suas obras (incluídas as obras obtidas por moldagem)','Worked ivory, bone, tortoiseshell, horn, antlers, coral, mother-of-pearl and other animal carving material, and articles of these materials (including articles obtained by moulding)','Marfil, hueso, concha (caparazón) de tortuga, cuerno, asta, coral, nácar y demás materias animales para tallar, trabajadas, y manufacturas de estas materias, incluso las obtenidas por moldeo',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9602,'Matérias vegetais ou minerais de entalhar, trabalhadas, e suas obras','Veg molded resin etc carving material','Veg material moldeado de resina, etc talla',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9603,'Vassouras e escovas, mesmo constituindo partes de máquinas, de aparelhos ou de veículos, vassouras mecânicas de uso manual, exceto as motorizadas, espanadores; cabeças preparadas para escovas, pincéis e artigos semelhantes; bonecas e rolos para pintura; ','Brooms, brushes (including brushes constituting parts of machines, appliances or vehicles), hand-operated mechanical floor sweepers, not motorised, mops and feather dusters; prepared knots and tufts for broom or brush making; paint pads and rollers; squee','Escobas, cepillos y brochas, aunque sean partes de máquinas, aparatos o vehículos, escobas mecánicas de uso manual (excepto las de motor), pinceles y plumeros; cabezas preparadas para artículos de cepillería; almohadillas y rodillos, para pintar; rasqueta',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9604,'Peneiras e crivos, manuais','Hand sieves and hand riddles','Tamices, cedazos y cribas, de mano',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9605,'sortidos de viagem, p/toucador, p/costura/limpeza roupas','travel sets,f/personal toilet,f/sewing/clothes cleaning','surtidos de viaje, p/aseo pers.p/cost./limp.prendas vest',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9606,'Botões, incluídos os de pressão; formas e outras partes, de botões ou de botões de pressão; esboços de botões','Buttons, press-fasteners, snap-fasteners and press-studs, button moulds and other parts of these articles; button blanks','Botones y botones de presión; formas para botones y demás partes de botones o de botones de presión; esbozos de botones',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9607,'Fechos de correr (fechos éclair) e suas partes','Slide fasteners and parts thereof','Cierres de cremallera (cierres relámpago) y sus partes',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9608,'Canetas esferográficas; canetas e marcadores de ponta de feltro ou de outras pontas porosas; canetas de tinta permanente e outras canetas; estiletes para duplicadores; lapiseiras; canetas porta-penas, porta-lápis e artigos semelhantes; suas partes (inclui','Ballpoint pens; felt-tipped and other porous-tipped pens and markers; fountain pens, stylograph pens and other pens; duplicating stylos; propelling or sliding pencils; pen-holders, pencil-holders and similar holders; parts (including caps and clips) of th','Bolígrafos; rotuladores y marcadores con punta de fieltro u otra punta porosa; estilográficas y demás plumas; estiletes o punzones para clisés de mimeógrafo («stencils»); portaminas; portaplumas, portalápices y artículos similares; partes de estos artícul',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9609,'Lápis (exceto os da posição 9608), minas, pastéis, carvões, gizes para escrever ou desenhar e gizes de alfaiate','Pencils (other than pencils of heading 9608), crayons, pencil leads, pastels, drawing charcoals, writing or drawing chalks and tailors'' chalks','Lápices, minas, pasteles, carboncillos, tizas para escribir o dibujar y jaboncillos (tizas) de sastre',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9610,'Lousas e quadros p/escrever/desenhar, mesmo emoldurados','Slates and boards,with writing/drawing surf.incl.framed','Pizarras y tableros p/escribir/dibujar, incl.enmarcados',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9611,'carimbos, datadores, numeradores, sinetes e artigos semelhantes','date,sealing,numbering stamps,signets and the like','fechadores, sellos, numeradores, timbradores y arts.simil.',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9612,'Fitas impressoras para máquinas de escrever e fitas impressoras semelhantes, tintadas ou preparadas de outra forma para imprimir, montadas ou não em carretéis ou cartuchos; almofadas de carimbo, impregnadas ou não, com ou sem caixa','Typewriter or similar ribbons, inked or otherwise prepared for giving impressions, whether or not on spools or in cartridges; ink-pads, whether or not inked, with or without boxes','Cintas para máquinas de escribir y cintas similares, entintadas o preparadas de otro modo para imprimir, incluso en carretes o cartuchos; tampones, incluso impregnados o con caja',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9613,'Isqueiros e outros acendedores (exceto os da posição 3603), mesmo mecânicos ou elétricos, e suas partes, exceto pedras e pavios','Cigarette lighters and other lighters, whether or not mechanical or electrical, and parts thereof other than flints and wicks','Encendedores y mecheros, incluso mecánicos o eléctricos, y sus partes (excepto las piedras y mechas)',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9614,'Cachimbos (incluídos os seus fornilhos) e boquilhas, e suas partes','Smoking pipes (including pipe bowls) and cigar or cigarette holders, and parts thereof','Pipas, incluidas las cazoletas, boquillas para cigarros (puros) o cigarrillos, y sus partes',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9615,'Pentes, travessas para o cabelo e artigos semelhantes; alfinetes para cabelo; picos, onduladores, bigudis e artefactos semelhantes para penteados, exceto os da posição 8516, e suas partes','Combs, hair-slides and the like; hairpins, curling pins, curling grips, hair-curlers and the like, other than those of heading 8516, and parts thereof','Peines, peinetas, pasadores y artículos similares; horquillas; rizadores, bigudíes y artículos similares para el peinado (excepto los de la partida 8516) y sus partes',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9616,'Vaporizadores de toucador, suas armações e cabeças de armações; borlas ou esponjas para pós ou para aplicação de outros cosméticos ou de produtos de toucador','Scent sprays and similar toilet sprays, and mounts and heads therefor; powder-puffs and pads for the application of cosmetics or toilet preparations','Pulverizadores de tocador, sus monturas y cabezas de monturas; borlas y similares para aplicación de polvos, otros cosméticos o productos de tocador',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9617,'Garrafas térmicas e outros recipientes isotérmicos montados, com isolamento produzido pelo vácuo, e suas partes (exceto ampolas de vidro)','Cacuum flasks and vessels with cases','Cacuum frascos y vasos con los casos',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9618,'Manequim, automato e cenas animadas p/vitrine/mostruario','Mannequin,autom.and anim.displays f/shop window/dress.','Maniquíes, autómatas y escenas animadas p/escaparates',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9619,'Absorventes e tampoes higienicos,cueiro e fralda p/bebe','Sanitary towels and tampons, diapers and diaper for infants','Compresas y tampones higiénicos, pañales y pañales para los bebés',96);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9701,'Quadros, pinturas e desenhos, feitos inteiramente à mâo, exceto os desenhos da posiçâo 4906 e os artigos manufacturados decorados à mâo; colagens e quadros decorativos semelhantes','Paintings, drawings and pastels, executed entirely by hand, other than drawings of heading 4906 and other than hand-painted or hand-decorated manufactured articles; collages and similar decorative plaques','Pinturas y dibujos, hechos totalmente a mano (excepto los dibujos de la partida 4906 y artículos manufacturados decorados a mano); collages y cuadros similares',97);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9702,'Gravuras, estampas e litografias, originais','Original engravings,prints and lithographs','Grabados, estampas y litografías, originales',97);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9703,'Produções originais de arte estatuária ou de escultura','Original sculptures and statuary','Obras originales de estatuaria o escultura',97);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9704,'Selos postais, selos fiscais, marcas postais, etc.','Postage or revenue stamps,stamp-postmarks,etc','Sellos de correo, timbres fiscales, marcas postales, etc',97);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9705,'Coleções e espécime para coleções zoológicas, botânicas, etc','Collections and collectors'' pieces of zoolog.botan.etc.','Colecciones/especímenes p/col.de zoología, botánica, etc',97);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9706,'Antiguidades com mais de 100 anos','Antiques over 100 years old','Antigüedades de más de cien años',97);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9990,'Zonas francas (free-shop)','Free-shop','Zonas francas (free-shop)',99);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9991,'Encomendas postais','Parcel post','Encomiendas postales',99);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9992,'Amostras','Samples','Muestras',99);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9993,'Comércio de combustíveis de panol, apetrechos, etc.','Trade of panol fuels,equipments,etc.','Comércio de combustibles de panol, pertrechos, etc',99);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9994,'Mercadorias em devolução','Goods in devolution','Mercancías en devolución',99);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9995,'Mercadorias em arrendamento não financeiro','goods in leasing no financial','mercaderias en arriendo',99);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9996,'Bagagem (provenientes de mudanças)','luggage (coming of changes)','equipaje (provenientes de mudanzas)',99);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9997,'Mercadorias doadas','Donated goods','Mercaderias donadas',99);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9998,'Consumo de bordo (combustíveis e lubrificantes para embarcações e aeronaves)','Consumption on board (fuels and lubricants for ships and aircraft)','Consumo a bordo (combustibles y lubricantes para embarcaciones y aeronaves)',99);
INSERT INTO migra_posicao (id, pos_portugues, pos_ingles, pos_espanhol, id_capitulo) VALUES (9999,'Conumo de bordo(exc.comb.e lubrif.); pedras do Cap.71; qq.outra mercadoria s/cobertura cambial e reexportação','Consumption on board ships and aircraft (except fuels and lubricants)','Consumo a bordo de buques y aeronaves (exc.combustibles y lubricantes)',99);



CREATE TABLE migra_sub_posicao (
    id              INTEGER     NOT NULL,
    sub_portugues   VARCHAR(300)    NOT NULL,
    sub_ingles      VARCHAR(300)    NOT NULL,
    sub_espanhol    VARCHAR(300)    NOT NULL,
    id_capitulo     INTEGER         NOT NULL,
    id_posicao      INTEGER         NOT NULL,
    CONSTRAINT pk_sub_posicao       PRIMARY KEY               (id),
    CONSTRAINT fk_sub_posicao_1     FOREIGN KEY               (id_capitulo)
                                    REFERENCES migra_capitulo (id),
    CONSTRAINT fk_sub_posicao_2     FOREIGN KEY               (id_posicao)
                                    REFERENCES migra_posicao  (id)
);

--'CO_SH6);,'NO_SH6_POR','NO_SH6_ING','NO_SH6_ESP','SH2);,'SH4);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010110,'Animais vivos das espécies cavalar, asinina e muar, reprodutores de raça pura','Pure-bred breeding horses and asses','Caballos y asnos, reproductores de raza pura',01,0101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010111,'Cavalos reprodutores, de raça pura','Pure-bred breeding horses','Caballos reproductores de raza pura',01,0101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010119,'Outros cavalos, vivos','Other live horses','Demás caballos, vivos',01,0101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010120,'Asininos e muares vivos','Asses, mules and hinnies (live)','Asnos, mulos y burdéganos, vivos',01,0101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010121,'Cavalos reprodutores de raça pura','Pure-bred breeding horses','Caballos de raza selecta para reproducción',01,0101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010129,'Cavalos vivos, exceto reprodutores de raça pura','Live horses, except pure-bred breeding','Caballos vivos, excepto reproductores de raza pura',01,0101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010130,'Animais da espécie asinina/muar, reprodutores de raça pura','Asses/mules, pure-bred breeding','Asnos o mulas, reproductores de raza pura',01,0101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010190,'Animais vivos das espécies cavalar, asinina e muar, exceto reprodutores raça pura','Live horses, asses, mules and hinnies (excl. pure-bred for breeding)','Caballos, asnos, mulos y burdéganos, vivos (exc. reproductores de raza pura)',01,0101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010210,'Bovinos reprodutores de raça pura','Pure-bred breeding bovines','Bovinos reproductores de raza pura',01,0102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010221,'Bovinos domésticos reprodutores de raça pura','Domestic cattle bred for breeding','El ganado doméstico raza selecta para reproducción',01,0102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010229,'Outros bovinos domésticos','Other domestic cattle','Otros ganados domésticos',01,0102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010231,'Búfalos reprodutores de raça pura','Buffalo pure-bred breeding','Buffalos reproductores de raza pura',01,0102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010239,'Outros búfalos','Other buffalo','Otros buffalos',01,0102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010290,'Outros bovinos vivos','Live bovine animals (excl. pure-bred for breeding)','Bovinos vivos (exc. reproductores de raza pura)',01,0102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010310,'Suínos reprodutores de raça pura','Pure-bred breeding swine','Porcinos reproductores de raza pura',01,0103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010391,'Outros suínos vivos de peso inferior a 50 kg','Live pure-bred swine, weighing < 50 kg (excl. pure-bred for breeding)','Porcinos vivos, de peso < 50 kg (exc. reproductores de raza pura)',01,0103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010392,'Outros suínos vivos de peso igual ou superior a 50 kg','Live pure-bred swine, weighing >= 50 kg (excl. pure-bred for breeding)','Porcinos vivos de peso >= 50 kg (exc. reproductores de raza pura)',01,0103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010410,'Ovinos vivos','Live sheep','Ovinos vivos',01,0104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010420,'Caprinos vivos','Live goats','Caprinos vivos',01,0104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010511,'Galos e galinhas vivos, das espécies domésticas, de peso não superior a 185 g','Live fowls of the species Gallus domesticus, weighing <= 185 g (excl. turkeys and guinea fowls)','Gallos y gallinas de las especies domésticas, vivos, de peso <= 185 g',01,0105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010512,'Peruas e perus vivos, da espécie doméstica, de peso não superior a 185 g','Live domestic turkeys, weighing <= 185 g','Pavos "gallipavos" de las especies domésticas, vivos, de peso <= 185 g',01,0105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010513,'Patos','Ducks','Patos',01,0105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010514,'Gansos','Geese','Gansos',01,0105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010515,'Galinhas dangola - pintadas','Chickens dangola - painted','Pollos dangola - pintado',01,0105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010519,'Patos, gansos, galinhas d''angola e outras aves vivas, da espécie doméstica, de peso não superior a 185 g','Live domestic ducks, geese and guinea fowls, weighing <= 185 g','Patos, gansos y pintadas de las especies domésticas, vivos, de peso <= 185 g',01,0105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010592,'Outros galos e galinhas, vivos, de peso <= 2.000 g','Other live fowls species gallus domesticus, weight <= 2.000 g','Demás gallos y gallinas vivos de peso <= 2000 g',01,0105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010593,'Galos e galinhas, vivos, de peso superior a 2.000 g','Live fowls species gallus domesticus weighing 2.000 g','Gallos y gallinas vivos de peso superior a 2000 g',01,0105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010594,'Galos e galinhas vivos, das espécies domésticas, de peso superior a 185g','Live fowls of the species Gallus domesticus, weighing > 185);','Gallos y gallinas de las especies domésticas, vivos, de peso > 185 g',01,0105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010599,'Patos, gansos, perus, galinhas d''angola e outras aves vivas, das espécies domésticas, de peso superior a 185 g','Live domestic ducks, geese, turkeys and guinea fowls, weighing > 185 g','Patos, gansos, pavos "gallipavos" y pintadas de las especies domésticas, vivos, de peso > 185 g',01,0105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010600,'Outros animais vivos','Ohter live animals','Otros animales vivos',01,0106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010611,'Mamíferos primatas vivos','Live primates','Mamíferos primates que viven',01,0106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010612,'Baleias, golfinhos e marsuínos; peixes-boi e dugongos, vivos','Live whales, dolphins and purpoises mammals of the order Cetacea and manatees and dugongs mammals of the order Sirenia','Ballenas, delfines y marsopas "mamíferos del orden Cetáceos", manatíes y dugones o dugongos "mamíferos del orden Sirenios", vivos',01,0106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010613,'Camelos e outros camelídeos (camelidae)','Camels and camelids (Camelidae)','Camellos y camélidos (Camelidae)',01,0106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010614,'Coelhos e lebres','Rabbits and hares','Conejos y liebres',01,0106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010619,'Outros mamíferos vivos','Live mammals (excl. primates, whales, dolphins and purpoises mammals of the order Cetacea, manatees and dugongs mammals of the order Sirenia and horses, asses, mules, hinnies, bovines, pigs, sheep and goats)','Mamíferos vivos (exc. primates, ballenas, delfines y marsopas "mamíferos del orden Cetáceos", manatíes y dugones o dugongos "mamíferos del orden Sirenios", caballos, asnos, mulos, burdéganos, bovinos, porcinos, ovinos y caprinos)',01,0106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010620,'Répteis vivos (incluídos as serpentes e tartarugas marinhas)','Live reptiles e.g. snakes, turtles, alligators, caymans, iguanas, gavials and lizards','Reptiles, incl. las serpientes y las tortugas de mar, vivos',01,0106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010631,'Aves de rapina vivas','Live birds of prey','Aves de rapiña, vivas',01,0106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010632,'Psitaciformes vivos (incluídos os papagaios, os periquitos, as araras e as cacatuas)','Live psittaciformes incl. parrots, parrakeets, macaws and cockatoos','Psitaciformes, incl. los loros, guacamayos, cacatúas y demás papagayos',01,0106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010633,'Avestruzes; emus (Dromaius novaehollandiae)','Ostriches; emus (Dromaius novaehollandiae)','Los avestruces, los emúes (Dromaius novaehollandiae)',01,0106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010639,'Outras aves vivas','Live birds (excl. birds of prey and psittaciformes incl. parrots, parrakeets, macaws and cockatoos)','Aves vivas (exc. aves de rapiña y psitaciformes, incl. los loros, guacamayos, cacatúas y demás papagayos)',01,0106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010641,'Abelhas','Bees','Abejas',01,0106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010649,'Outros insetos','Other insects','Otros insectos',01,0106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (010690,'Outros animais vivos','Live animals (excl. mammals, reptiles, birds, fish, crustaceans, molluscs and other aquatic invertebrates and cultures of micro-organisms, etc.)','Animales vivos (exc. mamíferos, reptiles, aves, pescados, crustáceos, moluscos y otros invertebrados acuáticos, así como cultivos de microorganismos y similares)',01,0106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020110,'Carcaças e meias carcaças de bovino, frescas ou refrigeradas - carnes','Carcases or half-carcases of bovine animals, fresh or chilled','Canales o medias canales, de bovinos, frescas o refrigeradas',02,0201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020120,'Outras peças de bovino, não desossadas, frescas ou refrigeradas - carnes','Fresh or chilled bovine cuts, with bone in (excl. carcases and 1/2 carcases)','Cortes "trozos" de bovinos, sin deshuesar, frescos o refrigerados (exc. canales o medias canales)',02,0201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020130,'Carnes de bovino, desossadas, frescas ou refrigeradas -carnes','Fresh or chilled bovine meat, boneless','Carne deshuesada, de bovinos, fresca o refrigerada',02,0201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020210,'Carcaças e meias-carcaças de bovino, congeladas - carnes','Frozen bovine carcases and half-carcases','Canales o medias canales, de bovinos, congeladas',02,0202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020220,'Outras peças de bovino, não desossadas, congeladas - carnes','Frozen bovine cuts, with bone in (excl. carcases and half-carcases)','Trozos de bovinos, sin deshuesar, congelados (exc. canales o medias canales)',02,0202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020230,'Carnes de bovino, desossadas, congeladas - carnes','Frozen, boneless meat of bovine animals','Carne deshuesada, de bovinos, congelada',02,0202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020311,'Carcaças e meias-carcaças de suíno, frescas ou refrigeradas - carnes','Fresh or chilled carcases and half-carcases of swine','Canales o medias canales, de porcinos, frescas o refrigeradas',02,0203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020312,'Pernas, pás e pedaços de suíno, não desossados, frescos ou refrigerados - carnes','Fresh or chilled hams, shoulders and cuts thereof of swine, with bone in','Piernas, paletas, y sus trozos, sin deshuesar, de porcinos, frescos o refrigerados',02,0203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020319,'Outras carnes de suíno, frescas ou refrigeradas - carnes','Fresh or chilled meat of swine (excl. carcases and half-carcases, and hams, shoulders and cuts thereof, with bone in)','Carne de porcinos, fresca o refrigerada (exc. canales o medias canales, así como piernas, paletas y sus trozos, sin deshuesar)',02,0203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020321,'Carcaças e meias-carcaças de suíno, congeladas - carnes','Frozen carcases and half-carcases of swine','Canales o medias canales de porcinos, congeladas',02,0203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020322,'Pernas, pás e pedaços de suínos, não desossados, congelados - carnes','Frozen hams, shoulders and cuts thereof of swine, boneless','Piernas, paletas, y sus trozos, sin deshuesar, de porcinos, congelados',02,0203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020329,'Outras carnes de suíno, congeladas','Frozen meat of swine (excl. carcases and half-carcases, and hams, shoulders and cuts thereof, boneless)','Carne de porcinos, congelada (exc. canales o medias canales, así como piernas, paletas y sus trozos, sin deshuesar)',02,0203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020410,'Carcaças e meias-carcaças de cordeiro, frescas ou refrigeradas - carnes','Fresh or chilled lamb carcases and half-carcases','Canales o medias canales de cordero, frescas o refrigeradas',02,0204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020421,'Carcaças e meias-carcaças de ovino, frescas ou refrigeradas - carnes','Fresh or chilled sheep carcases and half-carcases (excl. lambs)','Canales o medias canales de ovinos, frescas o refrigeradas (exc. corderos)',02,0204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020422,'Outras carnes de ovino, não desossadas, frescas ou refrigeradas','Fresh or chilled cuts of sheep, with bone in (excl. carcases and half-carcases)','Cortes "trozos" de ovinos, sin deshuesar, frescos o refrigerados (exc. canales o medias canales)',02,0204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020423,'Carnes de ovino, desossadas, frescas ou refrigeradas','Fresh or chilled boneless cuts of sheep','Carnes deshuesadas de ovinos, frescas o refrigeradas',02,0204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020430,'Carcaças e meias-carcaças de cordeiro, congeladas - carnes','Frozen lamb carcases and half-carcases','Canales o medias canales, de cordero, congeladas',02,0204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020441,'Carcaças e meias-carcaças, de ovino, congeladas - carnes','Frozen sheep carcases and half-carcases (excl. lambs)','Canales o medias canales, de ovinos, congeladas (exc. corderos)',02,0204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020442,'Outras carnes de ovino, não desossadas, congeladas','Frozen cuts of sheep, with bone in (excl. carcases and half-carcases)','Cortes "trozos" de ovinos, sin deshuesar, congelados (exc. canales o medias canales)',02,0204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020443,'Carnes de ovino, desossadas, congeladas','Frozen boneless cuts of sheep','Carnes deshuesadas de ovinos, congeladas',02,0204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020450,'Carnes de caprino, frescas, refrigeradas ou congeladas','Fresh, chilled or frozen meat of goats','Carne de caprinos, fresca, refrigerada o congelada',02,0204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020500,'Carnes de cavalo, asinino e muar, frescas, refrigeradas ou congeladas','Meat of horses, asses, mules or hinnies, fresh, chilled or frozen','Carne de animales de las especies caballar, asnal o mular, fresca, refrigerada o congelada',02,0205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020610,'Miudezas comestíveis de bovino, frescas ou refrigeradas - carnes','Fresh or chilled edible offal of bovine animals','Despojos de bovinos, comestibles, frescos o refrigerados',02,0206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020621,'Línguas de bovino, congeladas','Frozen edible bovine tongues','Lenguas de bovinos, comestibles, congeladas',02,0206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020622,'Fígados de bovino, congelados','Frozen edible bovine livers','Hígados de bovinos, comestibles, congelados',02,0206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020629,'Outras miudezas comestíveis de bovino, congeladas','Frozen edible bovine offal (excl. tongues and livers)','Despojos de bovinos, comestibles, congelados (exc. lenguas e hígados)',02,0206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020630,'Miudezas comestíveis de suíno, frescas ou refrigeradas','Fresh or chilled edible offal of swine','Despojos de porcinos, comestibles, frescos o refrigerados',02,0206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020641,'Fígados de suíno, congelados','Frozen edible livers of swine','Hígados de porcinos, comestibles, congelados',02,0206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020649,'Outras miudezas comestíveis de suíno, congeladas','Edible offal of swine, frozen (excl. livers)','Despojos de porcinos, comestibles, congelados (exc. hígados)',02,0206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020680,'Miudezas comestíveis das espécies ovino, caprino, cavalar, asinino e muar, frescas ou refrigeradas','Fresh or chilled edible offal of sheep, goats, horses, asses, mules and hinnies','Despojos de animales de las especies ovina, caprina, caballar, asnal o mular, comestibles, frescos o refrigerados',02,0206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020690,'Miudezas comestíveis das espécies ovino, caprino, cavalar, asinino e muar, congeladas','Frozen edible offal of sheep, goats, horses, asses, mules and hinnies','Despojos de animales de las especies ovina, caprina, caballar, asnal o mular, comestibles, congelados',02,0206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020711,'Carnes de galos e galinhas da espécie doméstica, não cortadas em pedaços, frescas ou refrigeradas','Fresh or chilled fowls of the species Gallus domesticus, not cut in pieces','Gallos y gallinas de especies domésticas, sin trocear, frescos o refrigerados',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020712,'Carnes de galos e galinhas da espécie doméstica não cortadas em pedaços, congeladas','Frozen fowls of the species Gallus domesticus, not cut in pieces','Gallos y gallinas de especies domésticas, sin trocear, congelados',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020713,'Pedaços e miudezas comestíveis, de galos e galinhas da espécie doméstica, frescos ou refrigerados','Fresh or chilled cuts and edible offal of fowls of the species Gallus domesticus','Trozos y despojos comestibles, de gallo o de gallina, de especies domésticas, frescos o refrigerados',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020714,'Pedaços e miudezas comestíveis de galos e galinhas da espécie doméstica, congelados','Frozen cuts and edible offal of fowls of the species Gallus domesticus','Trozos y despojos comestibles, de gallo o de gallina, de especies domésticas, congelados',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020724,'Carnes de peruas e de perus, da espécie doméstica, não cortadas em pedaços, frescas ou refrigeradas','Fresh or chilled turkeys of the species domesticus, not cut in pieces','Pavos "gallipavos" de especies domésticas, sin trocear, frescos o refrigerados',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020725,'Carnes de peruas e de perus, da espécie doméstica, não cortadas em pedaços, congeladas','Frozen turkeys of the species domesticus, not cut into pieces','Pavos "gallipavos" de especies domésticas, sin trocear, congelados',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020726,'Carnes de peruas e de perus, da espécie doméstica, em pedaços e miudezas comestíveis, frescas ou refrigeradas','Fresh or chilled cuts and edible offal of turkeys of the species domesticus','Trozos y despojos comestibles, de pavo "gallipavo", de especies domésticas, frescos o refrigerados',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020727,'Carnes de peruas e de perus, da espécie doméstica, em pedaços e miudezas comestíveis, congeladas','Frozen cuts and edible offal of turkeys of the species domesticus','Trozos y despojos comestibles, de pavo "gallipavo", de especies domésticas, congelados',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020732,'Carnes de patos, gansos e galinhas d''angola, das espécies domésticas, não cortadas em pedaços, frescas ou refrigeradas','Fresh or chilled ducks, geese and guinea fowls of the species domesticus, not cut into pieces','Patos, gansos o pintadas, de especies domésticas, sin trocear, frescos o refrigerados',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020733,'Carnes de patos, gansos e galinhas d''angola, das espécies domésticas não cortadas em pedaços, congeladas','Frozen ducks, geese and guinea fowls of the species domesticus, not cut into pieces','Patos, gansos o pintadas, de especies domésticas, sin trocear, congelados',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020734,'Fígados gordos comestíveis, de patos ou gansos, da espécie doméstica, frescos ou refrigerados','Fresh or chilled edible fatty livers of ducks or geese of the species domesticus','Hígados grasos de ganso o de pato, de especies domésticas, comestibles, frescos o refrigerados',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020735,'Outras carnes e miudezas comestíveis de patos, gansos ou galinhas d''angola, das espécies domésticas, frescas ou refrigeradas','Fresh or chilled cuts and edible offal of ducks, geese or guinea fowls of the species domesticus (excl. fatty livers)','Trozos y despojos comestibles, de pato, de ganso o de pintada, de especies domésticas, frescos o refrigerados (exc. hígados grasos)',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020736,'Outras carnes e miudezas comestíveis de patos, gansos e galinhas d''angola, das espécies domésticas, congeladas','Frozen cuts and edible offal of ducks, geese or guinea fowls of the species domesticus','Trozos y despojos comestibles, de pato, de ganso o de pintada, de especies domésticas, congelados',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020741,'Carnes de patos, não cortadas em pedaços, frescas ou refrigeradas','Meat of ducks, not cut in pieces, fresh or chilled','Carne de pato, sin trocear, frescas o refrigeradas',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020742,'Carnes de patos, não cortadas em pedaços, congeladas','Meat of ducks, not cut in pieces, frozen','Carne de pato, sin trocear, congelada',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020743,'Fígados gordos (foies gras) de patos, frescos ou refrigerados','Fatty livers (foies gras) of ducks, fresh or chilled','Hígados grasos (foie gras) patos, frescos o refrigerados',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020744,'Outras carnes de patos, frescas ou refrigeradas','Other meat of ducks, fresh or chilled','Las demás carnes de pato, frescas o refrigeradas',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020745,'Outras carnes de patos, congeladas','Other meat of ducks, frozen','Las demás carnes de pato, congeladas',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020751,'Carnes de gansos, não cortadas em pedaços, frescas ou refrigeradas','Meat of geese, not cut in pieces, fresh or chilled','La carne de ganso, sin trocear, frescas o refrigeradas',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020752,'Carnes de gansos, não cortadas em pedaços, congeladas','Meat of geese, not cut in pieces, frozen','La carne de ganso, sin trocear, congeladas',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020753,'Fígados gordos (foies gras) de gansos, frescos ou refrigerados','Fatty livers (foies gras) of geese, fresh or chilled','Hígados grasos (foie gras) de ganso, frescos o refrigerados',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020754,'Outras carnes de gansos, frescas ou refrigeradas','Other meat of geese, fresh or chilled','Demás carnes de los gansos, frescas o refrigeradas',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020755,'Outras carnes de gansos, congeladas','Other meat of geese, frozen','Demás carnes de los gansos, congeladas',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020760,'Carnes de galinhas dangola (pintadas)','Meat of chickens dangola (painted)','Carne de pollos dangola (pintado)',02,0207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020810,'Carnes e miudezas comestíveis de coelhos ou de lebres, frescas, refrigeradas ou congeladas','Fresh, chilled or frozen meat and edible offal of rabbits or hares','Carne y despojos comestibles, de conejo o de liebre, frescos, refrigerados o congelados',02,0208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020820,'Coxas de rã, frescas, refrigeradas ou congeladas','Frogs legs ( fresh/chilled/frozen)','Ancas de rana, frescas, refrigeradas o congeladas',02,0208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020830,'Carnes e miudezas comestíveis de primatas, frescas, refrigeradas ou congeladas','Fresh, chilled or frozen meat and edible offal of primates','Carne y despojos comestibles de primates, frescos, refrigerados o congelados',02,0208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020840,'Carnes e miudezas comestíveis de baleias, golfinhos, marsuínos, peixes-boi e dugongos, frescas, refrigeradas ou congeladas','Fresh, chilled or frozen meat and edible offal of whales, dolphins and purpoises mammals of the order Cetacea and of manatees and dugongs mammals of the order Sirenia','Carne y despojos comestibles de ballenas, delfines y marsopas "mamíferos del orden Cetáceos", así como de manatíes y dugones o dugongos "mamíferos del orden Sirenios", frescos, refrigerados o congelados',02,0208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020850,'Carnes e miudezas comestíveis de répteis (incluídas as serpentes e as tartarugas marinhas), frescas, refrigeradas ou congeladas','Fresh, chilled or frozen meat and edible offal of reptiles e.g. snakes, turtles, crocodiles','Carne y despojos comestibles de reptiles, incl. las serpientes y las tortugas de mar, frescos, refrigerados o congelados',02,0208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020860,'Outras carnes/miudezas comestíveis de camelos e outros camelideos','Other meat/offal of camels and camelids','Demás carnes/despojos de camellos y otros camélidos',02,0208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020890,'Carnes e miudezas comestíveis de outros animais, frescas, refrigeradas ou congeladas','Fresh, chilled or frozen meat and edible offal of pigeons, seals, game, reindeer and other animals (excl. bovine animals, swine, sheep, goats, horses, asses, mules, hinnies, poultry fowls of the species Gallus domesticus, ducks, geese, turkeys, guinea fow','Carne y despojos comestibles, de paloma, de foca, de caza, de renos y demás animales, frescos, refrigerados o congelados (exc. de bovinos, porcinos, ovinos o caprinos; de animales de las especies caballar, asnal o mular; de gallos, gallinas, patos, gansos',02,0208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020900,'Toucinho sem partes magras, gorduras de porco e de aves, não fundidos, frescos, refrigerados, congelados, salgados ou em salmoura, secos ou defumados - carnes','Pig fat, free of lean meat, and poultry fat, not rendered or otherwise extracted, fresh, chilled, frozen, salted, in brine, dried or smoked','Tocino sin partes magras y grasas de cerdo o de ave, sin fundir ni extraer de otro modo, frescos, refrigerados, congelados, salados o en salmuera, secos o ahumados',02,0209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020910,'Toucinhos ou gorduras, de porco','Pig fat','Grasa de porcinos',02,0209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (020990,'Outros toucinhos e gorduras','Other bacon grease','Grasa de tocino y otros',02,0209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (021011,'Pernas, pás e pedaços de suíno, não desossados, salgados ou em salmoura, secos ou defumados - carnes','Hams, shoulders and cuts thereof of swine, salted, in brine, dried or smoked, with bone in','Jamones, paletas, y sus trozos, sin deshuesar, de porcinos, salados o en salmuera, secos o ahumados',02,0210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (021012,'Barrigas e peitos, entremeados, e seus pedaços, de suíno, salgados ou em salmoura, secos ou defumados - carnes','Bellies streaky and cuts thereof of swine, salted, in brine, dried or smoked','Tocino entreverado de panza "panceta" y sus trozos, de porcinos, salados o en salmuera, secos o ahumados',02,0210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (021019,'Outras carnes de suíno, salgadas ou em salmoura, secas, defumadas','Meat of swine, salted, in brine, dried or smoked (excl. hams, shoulders and cuts thereof, with bone in, and bellies and cuts thereof)','Carne de porcinos, salada o en salmuera, seca o ahumada (exc. piernas, paletas, y sus trozos, sin deshuesar, así como tocino entreverado de panza "panceta" y sus trozos)',02,0210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (021020,'Carnes de bovinos, salgadas ou em salmoura, secas ou defumadas','Meat of bovine animals, salted, in brine, dried or smoked','Carne de bovinos, salada o en salmuera, seca o ahumada',02,0210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (021090,'Carnes e miudezas, de outros animais, salgados, etc.','Meat and edible meat offal of other animals, salted, etc.','Carnes y despojos de demás animales, salados,  etc',02,0210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (021091,'Carnes de primatas, comestíveis, salgadas, secas ou defumadas; miudezas, farinhas e pós','Meat and edible offal, salted, in brine, dried or smoked, and edible flours and meals of meat and meat offal, of primates','Carne y despojos comestibles, salados o en salmuera, secos o ahumados, así como harina y polvo comestibles de carne o de despojos, de primates',02,0210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (021092,'Carnes de baleias, golfinhos, marsuínos, peixes-boi e dugongos, comestíveis, salgadas, secas ou defumadas; miudezas, farinhas e pós','Meat and edible offal, salted, in brine, dried or smoked, and edible flours and meals of meat and meat offal, of whales, dolphins and purpoises mammals of the order Cetacea and manatees and dugongs mammals of the order Sirenia','Carne y despojos comestibles, salados o en salmuera, secos o ahumados, así como harina y polvo comestibles de carne o de despojos, de ballenas, delfines y marsopas "mamíferos del orden Cetáceos", así como de manatíes y dugones o dugongos "mamíferos del or',02,0210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (021093,'Carnes de répteis (incluídas as serpentes e as tartarugas marinhas), comestíveis, salgadas, secas ou defumadas; miudezas, farinhas e pós','Meat and edible offal, salted, in brine, dried or smoked, and edible flours and meals of meat and meat offal, of reptiles e.g. snakes, turtles, alligators','Carne y despojos comestibles, salados o en salmuera, secos o ahumados, así como harina y polvo comestibles de carne o de despojos, de reptiles, incl. las serpientes y tortugas de mar',02,0210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (021099,'Carnes de outros animais, comestíveis, salgadas, secas ou defumadas; miudezas, farinhas e pós','Meat and edible offal, salted, in brine, dried or smoked, and edible flours and meals of meat and meat offal (excl. meat of bovine animals and swine and meat and edible offal of primates, whales, dolphins and purpoises mammals of the order Cetacea, manate','Carne y despojos comestibles, salados o en salmuera, secos o ahumados, y harina y polvo comestibles de carne o de despojos (exc. carne de porcinos y bovinos, así como carne y despojos comestibles de primates, de reptiles, de ballenas, delfines y marsopas ',02,0210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030110,'Peixes ornamentais vivos - pescados','Live ornamental fish','Peces ornamentales, vivos',03,0301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030111,'Peixes ornamentais de água doce','Freshwater ornamental fish','Peces ornamentales de agua dulce',03,0301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030119,'Outros peixes ornamentais vivos','Other live ornamental fish','Otros peces ornamentales vivos',03,0301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030191,'Trutas vivas','Live trout Salmo trutta, Oncorhynchus mykiss, Oncorhynchus clarki, Oncorhynchus aguabonita, Oncorhynchus gilae, Oncorhynchus apache and Oncorhynchus chrysogaster','Truchas "Salmo trutta", "Oncorhynchus mykiss", "Oncorhynchus clarki", "Oncorhynchus aguabonita", "Oncorhynchus gilae", "Oncorhynchus apache" y "Oncorhynchus Chrysogaster", vivas',03,0301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030192,'Enguias vivas','Live eels Anguilla spp.','Anguilas "Anguilla spp.", vivas',03,0301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030193,'Carpas vivas','Live carp','Carpas, vivas',03,0301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030194,'Albacoras-azuis (Thunnus thynnus) vivas','Live bluefin tunas Thunnus thynnus','Atunes comunes o de aleta azul (Thunnus thynnus), vivos',03,0301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030195,'Atuns-do-sul (Thunnus maccoyii) vivos','Live southern bluefin tunas Thunnus maccoyii','Atunes del sur (Thunnus maccoyii), vivos',03,0301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030199,'Outros peixes vivos','Live fish (excl. ornamental fish, trout [Salmo trutta, Oncorhynchus mykiss, Oncorhynchus clarki, Oncorhynchus aguabonita, Oncorhynchus gilae, Oncorhynchus apache and Oncorhynchus chrysogaster], eels [Anguilla spp.], carp, bluefin tunas [Thunnus thynnus] a','Peces vivos (exc. peces ornamentales, truchas "Salmo trutta", "Oncorhynchus mykiss", "Oncorhynchus clarki", "Oncorhynchus aguabonita", "Oncorhynchus gilae", "Oncorhynchus apache" y "Oncorhynchus Chrysogaster", anguilas "Anguilla spp." y carpas)',03,0301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030211,'Trutas frescas ou refrigeradas, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled trout Salmo trutta, Oncorhynchus mykiss, Oncorhynchus clarki, Oncorhynchus aguabonita, Oncorhynchus gilae, Oncorhynchus apache and Oncorhynchus chrysogaster','Truchas "Salmo trutta", "Oncorhynchus mykiss", "Oncorhynchus clarki", "Oncorhynchus aguabonita", "Oncorhynchus gilae", "Oncorhynchus apache" y "Oncorhynchus Chrysogaster", frescas o refrigeradas',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030212,'Salmões-do-pacífico, do-atlântico e do-danúbio, frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled Pacific salmon Oncorhynchus nerka, Oncorhynchus gorbuscha, Oncorhynchus keta, Oncorhynchus tschawytscha, Oncorhynchus kisutch, Oncorhynchus masou and Oncorhynchus rhodurus, Atlantic salmon Salmo salar and Danube salmon Hucho hucho','Salmones del Pacífico "Oncorhynchus nerka", "Oncorhynchus gorbuscha", "Oncorhynchus keta", "Oncorhynchus tschawytscha", "Oncorhynchus kisutch", "Oncorhynchus masou" y "Oncorhynchus rhodurus", salmones del Atlántico "Salmo salar" y salmones del Danubio "Hu',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030213,'Salmões-do-pacifico (oncorhynchus nerka, etc), fr.ou r.','Pacific salmon, fresh or chilled','Salmón del pacífico, frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030214,'Salmão-do-atlantico e salmão-do-danubio, fr. ou refri.','Atlantic salmon and danube salmon, fresh or chilled','Salmón del atlántico y salmon del danubio, fr/ref.',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030219,'Outros salmonídeos frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled salmonidae (excl. trout Salmo trutta, Oncorhynchus mykiss, Oncorhynchus clarki, Oncorhynchus aguabonita, Oncorhynchus gilae, Oncorhynchus apache and Oncorhynchus chrysogaster, Pacific salmon Oncorhynchus nerka, Oncorhynchus gorbuscha, Onc','Salmónidos frescos o refrigerados (exc. truchas, salmones del Pacífico, salmones del Atlántico y salmones del Danubio)',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030221,'Linguados-gigantes, frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled lesser or Greenland halibut Reinhardtius hippoglossoides, Atlantic halibut Hippoglossus hippoglossus and Pacific halibut Hippoglossus stenolepis','Halibut "fletán" "Reinhardtius hippoglossoides", "Hippoglossus hippoglossus" e "Hippoglossus stenolepis", frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030222,'Solhas ou patruças, frescas ou refrigeradas, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled plaice Pleuronectes platessa','Sollas "Pleuronectes platessa", frescas o refrigeradas',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030223,'Linguados frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled sole Solea spp.','Lenguados "Solea spp.", frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030224,'Pregado (Psetta maxima), fresco ou refrigerado','Turbot (Psetta maxima), fresh or chilled','Rodaballo (Psetta maxima), fresco o refrigerado',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030229,'Outros peixes chatos, frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled flat fish Pleuronectidae, Bothidae, Cynoglossidae, Soleidae, Scophthalmidae and Catharidae (excl. halibut Reinhardtius hippoglossoides, Hippoglossus hippoglossus and Hippoglossus stenolepis, plaice Pleuronectes platessa and sole Solea spp','Pescados planos, "pleuronéctidos", "bótidos", "cynoglósidos", "soleidos", "escoftálmidos" y "citáridos", frescos o refrigerados (exc. halibut "fletán", sollas y lenguados)',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030231,'Atuns-brancos ou germões, frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled albacore or longfinned tunas Thunnus alalunga','Albacoras o atunes blancos "Thunnus alalunga", frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030232,'Albacoras ou atuns-de-barbatanas-amarelas, frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled yellowfin tunas Thunnus albacares','Atunes de aleta amarilla o rabiles "Thunnus albacares", frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030233,'Bonitos, frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled skipjack or stripe-bellied bonito','Listados o bonitos de vientre rayado "Euthynnus -Katsuwonus- pelamis", frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030234,'Albacoras-bandolim (patudos), frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled bigeye tunas Thunnus obesus','Patudos o atunes ojo grande "Thunnus obesus", frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030235,'Albacoras-azuis (atuns-azuis), frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled bluefin tunas Thunnus thynnus','Atunes comunes o de aleta azul "Thunnus thynnus", frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030236,'Atuns do sul, frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled Southern bluefin tunas Thunnus maccoyii','Atunes del sur "Thunnus maccoyii", frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030239,'Outros atuns frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled tunas of the genus Thunnus (excl. Thunnus alalunga, Thunnus albacares, Thunnus obesus, Thunnus thynnus and Thunnus maccoyii)','Atunes del género "Thunnus", frescos o refrigerados (exc. de las especies "Thunnus alalunga", "Thunnus albacares", "Thunnus obesus", "Thunnus thynnus" y "Thunnus maccoyii")',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030240,'Arenques frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled herrings Clupea harengus, clupea pallasii','Arenques "Clupea harengus" y "Clupea pallasii", frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030241,'Arenques (clupea harengus,clupea pallasii),fr.ou refri.','Herrings (Clupea harengus, Clupea pallasii), fresh or chilled','Arenques (Clupea harengus, Clupea pallasii), frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030242,'Anchovas (Engraulis spp.)','Anchovies (Engraulis spp.)','Anchoas (Engraulis spp.)',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030243,'Sardinhas (sardina pilchardus,etc),anchoveta,fr.ou ref.','Sardines (Sardina pilchardus, etc.), anchovies, fresh or chilled','Sardinas (Sardina pilchardus, etc), las anchoas, frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030244,'Cavalinhas, frescas ou refrigeradas','Mackerel, fresh or chilled','Caballa, frescas o refrigeradas',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030245,'Chicharros (trachurus spp.), frescos ou refrigerados','Mackerel (trachurus spp.), fresh or chilled','Jurel (Trachurus spp.), Frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030246,'Bijupira (rachycentron canadum), fres. ou refrig.','Cobia (Rachycentron canadum), fresh or chilled','La cobia (Rachycentron canadum), frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030247,'Espadarte (xiphias gladius), frescos ou refrigerados','Swordfish (Xiphias gladius), fresh or chilled','El pez espada (Xiphias gladius), frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030250,'Bacalhaus frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled cod gadus morhua, gadus ogac, gadus macrocephalus','Bacalaos "Gadus morhua", "Gadus ogac" y "Gadus macrocephalus", frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030251,'Bacalhau-do-atlântico,da-groelândia.e do-pacífico, frescos ou refrigerados','Cod of the Atlantic, from-the-greenland and Pacific, fresh or chilled','Bacalao del Atlántico, el Pacífico-groelândia, frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030252,'Haddock ou lubina (melanogrammus aeglefinus), f. ou r.','Haddock or lubina (melanogrammua aeglefinus), fr./ch.','Haddock o lubina (melanogrammua aeglefinus), fr./ref.',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030253,'Saithe (pollachius virens), frescos ou refrigerados','Saithe (pollachius virens), fresh or chilled','Saithe (pollachius virens), frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030254,'Merluzas e abroteas (merluccius spp., urophycis spp.),f.ou r.','Hakes (merluccius spp., urophycis spp),fresh or chilled','Merluzas y abroteas (merluccius spp), fresco o refrig.',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030255,'Merluza-do-alasca (theragra chalcogramma), fr. ou refrig.','Hake from alasca (theragra chalcogramma), fresh or chl.','Merluza del alasca (theragra chalcogramma),fr o refrig.',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030256,'Verdinhos (micromesistius poutassou, microme. australis','Blue whiting (micromesisticus poutassou)','Blue whiting (micromesisticus poutassou)',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030259,'Outros peixes das famílias bregmacerotidae, gadidae, etc.','Other fish of families Bregmacerotidae, Gadidae, etc..','Otras familias de peces, los Bregmacerotidae, Gadidae, etc.',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030261,'Sardinhas, sardinelas e espadilhas frescas ou refrigeradas, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled sardines Sardina pilchardus, Sardinops spp., sardinella Sardinella spp., brisling or sprats Sprattus sprattus','Sardinas "Sardina pilchardus", "Sardinops spp.", sardinelas "Sardinella spp." y espadines "Sprattus sprattus", frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030262,'Haddocks frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled haddock Melanogrammus aeglefinus','Eglefinos "Melanogrammus aeglefinus", frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030263,'Peixes-carvão frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled coalfish Pollachius virens','Carboneros "Pollachius virens ", frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030264,'Cavalas, cavalinhas e sardas, frescas ou refrigeradas, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled mackerel Scomber scombrus, Scomber australasicus, Scomber japonicus','Caballas "Scomber scombrus", "Scomber australasicus", "Scomber japonicus", frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030265,'Esqualos frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled dogfish and other sharks','Escualos, frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030266,'Enguias frescas ou refrigeradas, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled eels Anguilla spp.','Anguilas "Anguilla spp.", frescas o refrigeradas',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030267,'Espadartes (Xiphias gladius) frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled swordfish Xiphias gladius',' Pez espada (Xiphias gladius), frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030268,'Marlongas (Dissostichus spp.) frescas ou refrigeradas, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled toothfish Dissostichus spp.',' Róbalos de profundidad (Dissostichus spp.), frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030269,'Outros peixes frescos ou refrigerados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Fresh or chilled freshwater and saltwater fish (excl. salmonidae, flat fish, tunas, skipjack or stripe-bellied bonito, herrings, cod, sardines, sardinella, brisling or sprats, haddock, coalfish, mackerel, sharks, eels, swordfish and toothfish)','Pescado de agua dulce y de mar, comestible, fresco o refrigerado (exc. salmones, pescados planos, atunes, listados, arenques, bacalaos, sardinas, sardinelas, espadines, eglefinos, carboneros, caballas y estorninos, escualos y anguilas)',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030270,'Fígados, ovas e sêmen de peixes, frescos ou refrigerados - pescados','Fresh or chilled fish livers and roes','Hígados, huevas o lechas comestibles, frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030271,'Tilápias (oreochromis spp.), frescas ou refrigeradas','Tilapia (Oreochromis spp.), Fresh or chilled','La tilapia (Oreochromis spp.), Frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030272,'Bagres (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.)','Catfish (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.)','Pez gato (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.)',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030273,'Carpas (cyprinus carpio, carassius carassius, etc.)','Carps(cyprinus carpio, carassius carassius, etc.)','Carpas (cyprinus carpio, carassius carassius, etc.)',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030274,'Enguias (anguilla spp.), frescas ou refrigeradas','Eels (Anguilla spp.), Fresh or chilled','Las anguilas (Anguilla spp.), Frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030279,'Perca-do-nilo,peixe cabeça-de-serpente, fr.ou refrig.','Nile perch, snakehead, fresh or chilled','Perca del nilo, cabeza de la serpiente, fresco o refri.',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030281,'Cação e outros tubarões, frescos ou refrigerados','Dogfish and other sharks, fresh or chilled','Escualos, frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030282,'Raias (rajidae), fresca ou refrigerada','Skates (Rajidae), fresh or chilled','Rayas (Rajidae), frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030283,'Merluza negra e merluza antártica (Dissostichus spp.)','Toothfish (Dissostichus spp.)','Merluza negra y merluza antártica (Dissostichus spp.)',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030284,'Robalos (dicentrarchus spp.), frescos ou refrigerados','Robalos (dicentrarchus spp.), fresh or chilled','Robalos (dicentrarchus spp.), fres. ou refrig.',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030285,'Pargos ou sargos (sparidae), frescos ou refrigerados','Pargos ou sargos (sparidae), fresh or chilled','Pargos ou sargos (sparidae), fres. ou refrig.',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030289,'Outros peixes, exceto fígados, ovas e sêmen','Other fish, excluding livers and roes','Los demás pescados, excepto los hígados, huevas y lechas',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030290,'Fígados, ovas e sêmen de peixes, frescos ou refrigerados','Livers and roes of fish, fresh or chilled','Los hígados, huevas y lechas de pescado, frescos o refrigerados',03,0302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030310,'Salmões-do-pacífico, congelados, exc.filés, etc.','Pacific salmon, frozen, except fillets, etc','Salmones del pacífico, congelados, excepto filetes,  etc',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030311,'Salmões vermelhos, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen sockeye salmon [red salmon] Oncorhynchus nerka','Salmones rojos "Oncorhynchus nerka", congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030312,'Outros salmoes-do-pacifico, congelados','Other Pacific salmon, frozen','Otro salmón del Pacífico, congelado',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030313,'Salmão-do-atlântico e salmão-do-danúbio, congelados','Salmão-do-atlântico e salmão-do-danúbio, frozen','salmao-do-atlantico e salmao-do-danubio, cong.',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030314,'Trutas (salmo trutta,oncorhynchus mykiss, etc.), congeladas','Trout (Salmo trutta, Oncorhynchus mykiss, etc..), Frozen','Trucha común (Salmo trutta, Oncorhynchus mykiss, etc.), Congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030319,'Outros tipos de salmões, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen Pacific salmon Oncorhynchus gorbuscha, Oncorhynchus keta, Oncorhynchus tschawytscha, Oncorhynchus kisutch, Oncorhynchus masou and Oncorhynchus rhodurus (excl. sockeye salmon [red salmon] Oncorhynchus nerka)','Salmones del Pacífico "Oncorhynchus gorbuscha", "Oncorhynchus keta", "Oncorhynchus tschawytscha", "Oncorhynchus kisutch", "Oncorhynchus masou" y "Oncorhynchus rhodurus", congelados (exc. salmones rojos "Oncorhyncus nerka")',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030321,'Trutas congeladas, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen trout Salmo trutta, Oncorhynchus mykiss, Oncorhynchus clarki, Oncorhynchus aguabonita, Oncorhynchus gilae, Oncorhynchus apache and Oncorhynchus chrysogaster','Truchas "Salmo trutta", "Oncorhynchus mykiss", "Oncorhynchus clarki", "Oncorhynchus aguabonita", "Oncorhynchus gilae", "Oncorhynchus apache" y "Oncorhynchus Chrysogaster", congeladas',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030322,'Salmões-do-atlântico e danúbio, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen Atlantic salmon Salmo salar and Danube salmon Hucho hucho','Salmones del Atlántico "Salmo salar" y salmones del Danubio "Hucho hucho", congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030323,'Tilápias (oreochromis spp.), congeladas','Tilapia (Oreochromis spp.), Frozen','Tilapias (oreochromis spp.), congeladas',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030324,'Bagres (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.)','Catfish (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.)','Pez gato (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.)',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030325,'Carpas, congeladas','Carps, frozen','Carpas, congeladas',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030326,'Enguias congeladas (anguilla spp.), congeladas','Frozen eels (Anguilla spp.), Frozen','Anguilas congeladas (Anguilla spp.), Congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030329,'Outros salmonídeos, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen salmonidae (excl. Pacific salmon, Atlantic salmon, Danube salmon and trout)','Salmónidos, congelados (exc. salmones del Pacífico, salmones del Atlántico, salmones del Danubio y truchas)',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030331,'Linguados-gigantes, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen lesser or Greenland halibut Reinhardtius hippoglossoides, Atlantic halibut Hippoglossus hippoglossus and Pacific halibut Hippoglossus stenolepis','Halibut "fletán" "Reinhardtius hippoglossoides", "Hippoglossus hippoglossus" e "Hippoglossus stenolepis", congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030332,'Solhas ou patruças, congeladas, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen plaice Pleuronectes platessa','Sollas "Pleuronectes platessa", congeladas',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030333,'Linguados, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen sole Solea spp.','Lenguados "Solea spp.", congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030334,'Pregado (psetta maxima), congelado','pregado (psetta maxima), frozen','Pregado (psetta maxima), congelado',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030339,'Outros peixes chatos, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen flat fish Pleuronectidae, Bothidae, Cynoglossidae, Soleidae, Scophthalmidae and Citharidae (excl. halibut, plaice and sole)','Pescados planos, "Pleuronéctidos", "Bótidos", "Cynoglósidos", "Soleidos", "Escoftálmidos" y "Ccitáridos", congelados (exc. halibut "fletán", sollas y lenguados)',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030341,'Atuns-brancos ou germões, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen albacore or longfinned tunas Thunnus alalunga','Albacoras o atunes blancos "Thunnus alalunga", congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030342,'Albacoras e atuns-de-barbatana-amarela, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen yellowfin tunas Thunnus albacares','Atunes de aleta amarilla o rabiles "Thunnus albacares", congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030343,'Bonitos-listrados ou do-ventre-raiado, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen skipjack or stripe-bellied bonito Euthynnus -Katsuwonus- pelamis','Listados o bonitos de vientre rayado, congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030344,'Albacoras-bandolim (patudos), congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen bigeye tunas Thunnus obesus','Patudos o atunes ojo grande "Thunnus obesus", congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030345,'Albacoras-azuis (atuns-azuis), congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen bluefin tunas Thunnus thynnus','Atunes comunes o de aleta azul "Thunnus thynnus", congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030346,'Atuns do sul, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen Southern bluefin tunas Thunnus maccoyii','Atunes del sur "Thunnus maccoyii", congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030349,'Outros atuns, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen tunas of the genus Thunnus (excl. Thunnus alalunga, Thunnus albacares, Thunnus obesus, Thunnus thynnus and Thunnus maccoyii)','Atunes del género "Thunnus", congelados (exc. de las especies "Thunnus alalunga", "Thunnus albacares", "Thunnus obesus", "Thunnus thynnus" y "Thunnus maccoyii")',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030350,'Arenques congelados, exc.filés, outras carnes, fígados, etc','Frozen herrings, exc.fish filets oth.meats, livers, etc','Arenques congelados, exc.filetes, dem.carnes, hígados, etc',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030351,'Arenques (Clupea arengus, Clupea pallasii) congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen herrings Clupea harengus, Clupea pallasii','Arenques (Clupea harengus, Clupea pallasii), congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030352,'Bacalhaus (Gadus morhua, Gadus ogac, Gadus macrocephalus), congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Cod Gadus morhua, Gadus ogac, Gadus macrocephalus','Bacalaos (Gadus morhua, Gadus ogac, Gadus macrocephalus), congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030353,'Sardinhas, congeladas','Sardines, frozen','Sardinas, congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030354,'Cavalinhas, congeladas','Cavalinhas, frozen','Cavaliñas, congeladas',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030355,'Chicharros (trachurus spp.), congelados','Horse mackerel (trachurus spp.), frozen','Chicharros (trachurus spp.), congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030356,'Bijupira (rachcentron canadum), congelado','Cobia (rachcentron canadum), frozen','Cobia (rachcentron canadum), congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030357,'Espadarte (xiphias galdius), congelado','Swordfish (xiphias galdius), frozen','El pez espada (Xiphias Gladius), congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030360,'Bacalhaus (gadus) congelados, exc.filés, outs.carnes, etc.','Frozen cod,  except fish filets,  other fish meat,  etc.','Bacalao (gadus) congelados,  excepto filetes,  demás carnes,  etc',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030361,'Espadartes (Xiphias gladius), congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen swordfish Xiphias gladius','Pez espada (Xiphias gladius), congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030362,'Marlongas (Dissostichus spp.), congeladas, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen toothfish Dissostichus spp.','Róbalos de profundidad (Dissostichus spp.), congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030363,'bacalhau-do-atlântico e bacalhau-do-pacifico, congelado','bacalhau-do-atlantico e bacalhau-do-pacifico, congelado','bacalhau-do-atlantico e bacalhau-do-pacifico, congelado',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030364,'haddock ou lubina (melanogrammus aeglefinus), congelado','haddock ou lubina (melanogrammus aeglefinus), congelado','haddock ou lubina (melanogrammus aeglefinus), congelado',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030365,'saithe (pollachius virens), congelado','saithe (pollachius virens), congelado','saithe (pollachius virens), congelado',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030366,'merluzas e abroteas (merluccius ,urophycis ),congeladas','merluzas e abroteas (merluccius ,urophycis ),congeladas','merluzas e abroteas (merluccius ,urophycis ),congeladas',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030367,'Merluza-do-alasca (theragra chalcogramma)','merluza-do-alasca (theragra chalcogramma)','merluza-do-alasca (theragra chalcogramma)',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030368,'Verdinhos, congelados (exceto files, outras carnes)','verdinhos, congelados (exceto files, outras carnes)','verdinhos, congelados (exceto files, outras carnes)',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030369,'Outros peixes de famílias específicas, exceto fígados, ovos e sêmen','Other specific fish families, except livers, eggs and semen','Otras familias de peces específicos, excepto los hígados, huevos y semen',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030371,'Sardinhas, sardinelas e espadilhas, congeladas, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen sardines Sardina pilchardus, Sardinops spp., sardinella Sardinella spp. and brisling or sprats Sprattus sprattus','Sardinas "Sardina pilchardus", "Sardinops spp.", sardinelas "Sardinella spp." y espadines "Sprattus sprattus", congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030372,'Haddocks, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen haddock Melanogrammus aeglefinus','Eglefinos "Melanogrammus aeglefinus", congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030373,'Peixes-carvão, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen coalfish Pollachius virens','Carboneros "Pollachius virens", congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030374,'Cavalas, cavalinhas e sardas, congeladas, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen mackerel Scomber scombrus, Scomber australasicus, Scomber japonicus','Caballas "Scomber scombrus", "Scomber australasicus", "Scomber japonicus", congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030375,'Esqualos, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen dogfish and other sharks','Escualos congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030376,'Enguias, congeladas, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen eels Anguilla spp.','Anguilas "Anguilla spp.", congeladas',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030377,'Percas (robalos e bailas), congeladas, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen sea bass Dicentrarchus labrax, Dicentrarchus punctatus','Róbalos "Dicentrarchus labrax", "Dicentrarchus punctatus", congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030378,'Merluzas e abróteas, congeladas, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen hake Merluccius spp., Urophycis spp.','Merluzas "Merluccius spp.", "Urophycis spp.", congeladas',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030379,'Outros peixes, congelados, exceto fígado, ovas, sêmen, ou filés e outras carnes da posição 0304 - pescados','Frozen freshwater and saltwater fish (excl. salmonidae, flat fish, tunas, skipjack or stripe-bellied bonito, herrings, cod, swordfish, toothfish, sardines, sardinella, brisling or sprats, haddock, coalfish, mackerel, dogfish and other sharks, eels, sea ba','Pescado de agua dulce y de mar, comestible, congelado (exc. salmones, pescados planos, atunes , listados, arenques, bacalaos, sardinas, sardinelas, espadines, eglefinos, carboneros, caballas, escualos, anguilas, róbalos y merluzas)',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030380,'Fígados, ovas e sêmen, de peixes, congelados - pescados','Frozen fish livers and roes','Hígados, huevas y lechas comestibles, congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030381,'Cação e outros tubarões','Dogfish and other sharks','Escualos',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030382,'Raias (rajidae), congeladas','Skates (Rajidae), frozen','Rayas (Rajidae), congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030383,'Merluza negra e merluza antártica (Dissostichus spp.)','Toothfish (Dissostichus spp.)','Merluza negra y merluza antártica (Dissostichus spp.)',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030384,'Robalos (dicentrarchus spp.), congelados','Bass (Dicentrarchus spp.), Frozen','Bass (Dicentrarchus spp.), Congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030389,'Outros peixes, exceto fígados, ovas e sêmen','Other fish, excluding livers and roes','Los demás pescados, excepto los hígados, huevas y lechas',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030390,'Fígados, ovas e sêmen de peixes, congelados','Livers and roes of fish, frozen','Los hígados, huevas y lechas de pescado, congelados',03,0303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030410,'Filés e outras carnes de peixes, frescos ou refrigerados','Fillets and other fish meat, fresh or chilled','Filetes y demás carne de pescado, frescos o refrigerados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030411,'Filés de espadartes (Xiphias gladius)  frescos ou refrigerados - pescados','Fresh or chilled fillets and other meat whether or not minced of swordfish Xiphias gladius',' Pez espada (Xiphias gladius), frescos o refrigerados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030412,'Filés de marlongas (Dissostichus spp.) frescos ou refrigerados - pescados','Fresh or chilled fillets and other  meat whether or not minced of toothfish Dissostichus spp.',' Róbalos de profundidad (Dissostichus spp.), frescos o refrigerados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030419,'Outros filés e carnes de peixes frescos ou refrigerados - pescados','Fresh or chilled fillets and other fish meat whether or not minced (excl. swordfish and toothfish)','Los demás filetes y demás carne de pescado, incl. picada, frescos o refrigerados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030420,'Filés de peixes, congelados','Fish fillets, frozen','Filetes de pescado, congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030421,'Filés de espadartes (Xiphias gladius) congelados - pescados','Frozen fillets of swordfish Xiphias gladius',' Pez espada (Xiphias gladius), congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030422,'Filés de marlongas (Dissostichus spp.) congeladas - pescados','Frozen fillets of toothfish Dissostichus spp.',' Róbalos de profundidad (Dissostichus spp.), congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030429,'Outros filés congelados de peixes - pescados','Frozen fish fillets (excl. swordfish and toothfish)','Filetes de pescado, congelados (excl. pez espada y robálo de profundidad) ',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030431,'filés de Tilápias (frescos, refrigerados ou conelados)','files de tilapias (frescos, refrigerados ou conelados)','files de tilapias (frescos, refrigerados ou conelados)',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030432,'Filés de bagres (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.), frescos ou refrigerados','Catfish fillet (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.), fresh or chilled','Pez gato (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.), fresco o refrigerado',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030433,'Filé de perca-do-nilo, fresco, refrigerado ou congelado','Fillets of nile perch, fresh, frozen or chilled','Filetes de perca del nilo,frescos, refrigerados o cong.',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030439,'Files/out. carnes de out. peixes,frescos, ref. ou cong.','Fillets/other meats o other fish,frozen,chilled or fre.','Filetes y otras carnes de otros peces, fr., refr.o con.',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030441,'Filés de salmões-do-pacifico e salmão-do-danubio','Fillets of salmons of pacific and danube','Filetes of salmónes de pacífico e del danubio',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030442,'Filés de truta (almo trutta, oncorhynchus mykiss, etc)','Trout fillets (almo trutta, oncorhynchus mykiss, etc.)','Filetes de trucha (almo trutta, oncorhynchus mykiss,et)',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030443,'Filés de peixes chatos (pleuronectidae, soleidae, etc)','Fillets of flatfish (pleuronectidae, soleidae, etc.)','Filetes of platija (pleuronectidae, soleidae, etc.)',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030444,'Filés de peixes das famílias bregmacerotidae, etc','Fish fillets of families bregmacarotidae','Filetes de peces de las familias bregmacarotidae',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030445,'Filés e outras carnes de espadarte (Xyphias gladius)','Fillets and other meat of swordfish (Xyphias gladius)','Filetes y demás carnes de pez espada (Xyphias gladius)',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030446,'Filés de merluza negra e merluza antártica','Fillets of black hake and hake from antartica','Filetes de merluza negra y merluza antártica',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030449,'Filés de outros peixes, frescos ou refrigerados','Other fish fillets, fresh or chilled','Filetes de otros peces, frescos o refrigerados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030451,'Filés de tilápia,bagre,carpa,enguias, fr. ou refri.','Fillet of tilapia, catfish, carp, eel, fresh or chilled','Filete de tilapia, bagre, carpa, anguila, fresco o ref.',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030452,'Filé e outras carnes de salmonídeos, fr. ou refrig.','Fillet and other meats of salmon, fresh or chilled','Filete y otras carnes de salmón, frescos o refrigerados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030453,'Filé peix. das fam. breg.eucl.gad.mac.mel.mer.mor e mur','Fish fillets of specific families','Filets of peces de familias específicas',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030454,'Filé de espadartes (Xiphias gladius), fres. ou refrig.','Fillets of swordfish (xyphias gladius),fresh or chilled','Filetes de pez espada (xyphias gladius), fresco o refr.',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030455,'Filés de merluza negra e merluza antartica,fr. ou refr.','Fillets of black hake and antartica hake, fresh or chi.','Filetes de merluzas negras e antárticas, fresco o refr.',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030459,'Outros filés de peixes, frescos ou refrigerados','Other fish fillets, fresh or chilled','Otros filetes de pescados, frescos o refrigerados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030461,'Filés de tilápias (oreochromis spp.), congelados','Fillets of tilapias (oreochromis spp.), frozen','Filetes de tilapías (oreochromis spp.), congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030462,'Filés de bagres (Pangasius spp., Silurus spp., Clarias spp., Ictalurus spp.), congelado','Catfish fillet(Pangasius spp., Silurus spp., Clarias spp.,Ictalurus spp.), frozen','Filetes de pez gato (Pangasius spp., Silurus spp., Clarias spp.,Ictalurus spp.), congelado',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030463,'Filé de perca-do-nilo (lates niloticus), congelado','Fillets of nile perch (lates niloticus), frozen','Filetes of perca del nilo (lates niloticus), congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030469,'Filé de peixe cabeça-de-serpente, congelado','Fillets of snakehead fish, frozen','Filete de pece cabeza de serpiente, congelado',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030471,'Filé bacal.-do-atlantico, da-groenl., do-pacifico,cong.','Fillets of cods from atlantic,pacific,greenland, frozen','Filetes de bacalaos del atlántico, pacífico, congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030472,'Filé de haddock ou lubina, congelado','Haddock or lubina fillet, frozen','Filetes de haddock o lubina, congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030473,'Filé de saithe (pollachius virens), congelado','Fillets of saithe (pollachius virens), frozen','Filetes de saithe (pollachius virens), congelado',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030474,'Filés de merluzas e abroteas, congelados','Fillets of hake and abrotea, frozen','Filets de merluza y abroteas, congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030475,'Filé de merluza-do-alasca (theragra chalcogramma), cong','Fillet of hake from alasca(theragra chalcogramma),froze','Filete de merluza del alasca (theragra chalcogramma)com',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030479,'Outros filés de peixes, congelados','Other fish fillets, frozen','Los demás filetes de peces, congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030481,'Filé de salmão-do-pacifico,do-danubio,do-atlantico,cong','Fillets of pacific, atlantic and danube salmon, frozen','Filetes de salmónes del pacífico, etc, congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030482,'Filés de trutas, congelados','Trout fillets, frozen','Filetes de trucha, congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030483,'Filés de peixes chatos, congelados','Flatfish fillets, frozen','Filetes de peces planos, congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030484,'Filés de espadarte (xiphias gladius), congelados','Fillets of swordfish (Xiphias gladius), frozen','Filetes de pez espada (Xiphias gladius), congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030485,'Filé de merluza negra e merluza antártica (Dissostichus spp.), cong.','Toothfish fillet (Dissostichus spp.), frozen','Filetes de merluza negra y merluza antártica (Dissostichus spp.), congelado',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030486,'Filés de arenques (clupea harengus,clupea pallasii) congelados','Fillets of herring (Clupea harengus, Clupea pallasii), frozen','Filetes de arenque (Clupea harengus, Clupea pallasii), congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030487,'Filés de atuns e bonito-listrado, congelados','Tuna steaks, frozen','Filetes de atún, congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030489,'Filés de outros peixes, congelados','Other fish fillets, frozen','Filetes de otros peces, congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030490,'Outras carnes de peixes, congeladas','Other fish meat, frozen','Otras carnes de pescados, congeladas',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030491,'Outras carnes de espadartes (Xiphias gladius) exceto filés, mesmo picadas, frescas, refrigeradas ou congeladas - pescados','Frozen meat whether or not minced of swordfish Xiphias gladius (excl. fillets)','Otras carnes de pez espada (Xiphias gladius), excepto filete',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030492,'Outras carnes de marlongas (Dissostichus spp.) exceto filés, mesmo picadas, frescas, refrigeradas ou congeladas - pescados','Frozen meat whether or not minced of toothfish Dissostichus spp. (excl. fillets)','Otras carnes de róbalos de profundidad (Dissostichus spp.), excepto filete',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030493,'Outras carnes de tilápias, bagres, carpas, enguias (congeladas)','Other meat of tilapia, catfish, carp, eels (frozen)','Otros tipos de carne de tilapia, bagre, carpa, anguila (congelado)',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030494,'Outras carnes de merluza-do-alasca, congeladas','Other meat of hake-of-Alaska, frozen','Las demás carnes de merluza de Alaska-, congelados',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030495,'Out.car.pei.da fam. breg,euc,gad,mac.mel.mer.,etc,cong.','Other fish meat of determined species, frozen','Otras carnes de peces de familias específ., congeladas',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030499,'Carnes de outros peixes, exceto filés, mesmo picadas, congeladas - pescados','Frozen fish meat whether or not minced (excl. swordfish, toothfish and fillets)','Carne de pescados, incluso picada, congelada (excl. pez espada, róbalo de profundidad y filetes)',03,0304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030510,'Farinhas, pós e pellets de peixes, para alimentação humana - pescados','Flours, meals and pellets of fish, fit for human consumption','Harina, polvo y "pellets" de pescado aptos para la alimentación humana',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030520,'Fígados, ovas e sêmen de peixes, secos, defumados, salgados ou em salmoura - pescados','Fish livers and roes, dried, smoked, salted or in brine','Hígados, huevas y lechas, secos, salados, en salmuera o ahumados',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030530,'Filés de peixes, secos, salgados ou em salmoura, mas não defumados - pescados','Fish fillets, dried, salted or in brine, not smoked','Filetes de pescado, secos, salados o en salmuera, sin ahumar',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030531,'Filés de peixes, secos, salgados, em salmoura, não defumados','Fish fillets, dried, salted, in brine, not smoked','Filetes de pescado, secos, salados o en salmuera, sin ahumar',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030532,'Filés de peixes de famílias específicas, não defumado','Fish fillets of specific families, not smoked','Filetes de pescado de las familias específicas, sin ahumar',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030539,'Filés de outros peixes, não defumado','Other fish fillets, not smoked','Filetes de otros peces, sin ahumar',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030541,'Salmões-do-pacífico, do-atlântico e do-danúbio, defumados, mesmo em filés - pescados','Pacific salmon Oncorhynchus nerka, Oncorhynchus gorbuscha, Oncorhynchus keta, Oncorhynchus tschawytscha, Oncorhynchus kisutch, Oncorhynchus masou and Oncorhynchus rhodurus, Atlantic salmon Salmo salar and Danube salmon Hucho hucho, smoked, incl. fillets','Salmones del Pacífico "Oncorhynchus nerka", "Oncorhynchus gorbuscha", "Oncorhynchus keta", "Oncorhynchus tschawytscha", "Oncorhynchus kisutch", "Oncorhynchus masou" y "Oncorhynchus rhodurus", salmones del Atlántico "Salmo salar" y salmones del Danubio "Hu',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030542,'Arenques, defumados, mesmo em filés - pescados','Herrings Clupea harengus, Clupea pallasii, smoked, incl. fillets','Arenques "Clupea harengus" y "Clupea pallasii", ahumados, incl. filetes',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030543,'Truta defumada, mesmo em filés','Trout, smoked, including fillets','Trucha ahumada (incluso filetes)',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030544,'Tilápia, bagre, carpa, enguia, defumados (mesmo em filés)','Tilapia, catfish, carp, eel, smoked (including fillets)','Tilapia, bagre, carpa, anguila, ahumados (incluidos los filetes)',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030549,'Outros peixes, defumados, mesmo em filés - pescados','Smoked fish, incl. fillets (excl. Pacific salmon, Atlantic salmon, Danube salmon and herrings)','Pescado ahumado, incl. filetes (exc. salmones del Pacífico, salmones del Atlántico, salmones del Danubio y arenques)',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030551,'Bacalhaus secos, mesmo salgados, mas não defumados - pescados','Dried cod Gadus morhua, Gadus ogac, Gadus macrocephalus, whether or not salted, not smoked (excl. fillets)','Bacalaos "Gadus morhua", "Gadus ogac", "Gadus macrocephalus", secos, incl. salados, sin ahumar (exc. filetes)',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030559,'Outros peixes secos, mesmo salgados, mas não defumados - pescados','Dried fish, salted, not smoked (excl. cod and other fillets)','Pescado seco, incl. salado, sin ahumar (exc. bacalaos y filetes en general)',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030561,'Arenques salgados e em salmoura, não secos nem defumados - pescados','Herrings Clupea harengus, Clupea pallasii, salted or in brine only (excl. fillets)','Arenques "Clupea harengus", "Clupea pallasii", simplemente salados o en salmuera (exc. filetes)',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030562,'Bacalhaus salgados e em salmoura, não secos nem defumados - pescados','Cod Gadus morhua, Gadus ogac, Gadus macrocephalus, salted or in brine only (excl. fillets)','Bacalaos "Gadus morhua", "Gadus ogac", "Gadus macrocephalus", simplemente salados o en salmuera (exc. filetes)',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030563,'Anchovas salgadas e em salmoura, não secas nem defumadas - pescados','Anchovies Engraulis spp., salted or in brine only (excl. fillets)','Anchoas "Engraulis spp.", simplemente saladas o en salmuera (exc. filetes)',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030564,'Tilápias,bag.,car.enguia,salg.,nao sec., n/ defu.em sal','tilapias,bag.,car.enguia,salg.,nao sec., n/ defu.em sal','tilapias,bag.,car.enguia,salg.,nao sec., n/ defu.em sal',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030569,'Outros peixes salgados e em salmoura, não secos nem defumados - pescados','Fish, salted or in brine only (excl. herrings, cod, anchovies and fillets in general)','Pescado salado o en salmuera (exc. arenques, bacalaos, anchoas y filetes en general)',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030571,'Barbatanas de tubarão','Shark fins','Aletas de tiburón',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030572,'Cabeças, caudas e bexigas natatórias, de peixes','Heads, tails, and swim bladders of fish','Cabezas, colas, y la vejiga natatoria de los peces',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030579,'Outros desperdicios comestíveis, de peixes','Other edible waste of fish','Desechos de los peces, comestibles',03,0305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030611,'Lagostas congeladas','Rock lobster and other sea crawfish (Palinurus spp, Panulir spp, Jasus spp)','Langostas "Palinurus spp.", "Panulirus spp.", "Jasus spp.", incl. peladas, congeladas, incl. langostas sin pelar, cocidas previamente en agua o vapor',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030612,'Lavagantes (homards) congelados','Frozen lobsters Homarus spp., whether in shell or not, incl. lobsters in shell, cooked by steaming or by boiling in water','Bogavantes "Homarus spp.", incl. pelados, congelados, incl. bogavantes sin pelar, cocidos previamente en agua o vapor',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030613,'Camarões congelados','Frozen shrimps and prawns, whether in shell or not, incl. shrimps and prawns in shell, cooked by steaming or by boiling in water','Camarones, langostinos y demás Decápodos natantia, incl. pelados, congelados, incl. sin pelar, cocidos previamente en agua o vapor',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030614,'Caranguejos congelados','Frozen crabs, whether in shell or not, incl. crabs in shell, cooked by steaming or by boiling in water','Cangrejos (exc. macruros), incl. pelados, congelados, incl. sin pelar, cocidos previamente en agua o vapor',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030615,'Lagosta norueguesa (nephrops norvegicus)','Norway lobster (Nephrops norvegicus)','Langosta (Nephrops norvegicus)',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030616,'Camarões de água fria (Pandalus spp., Crangon crangon),congelados','Cold water shrimps and prawns (Pandalus spp., Crangon crangon), frozen','Gambas de agua fría (Pandalus spp., Crangon crangon), congelados',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030617,'Outros camarões, congelados','Other shrimps and prawns, frozen','Otros gambas, congelados',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030619,'Outros crustáceos congelados, incluídos as farinhas, pós e pellets próprios para alimentação humana','Frozen crustaceans, fit for human consumption, whether in shell or not, incl. crustaceans in shell, cooked beforehand by steaming or by boiling in water (excl. rock lobster and other sea crawfish, lobsters, shrimps, prawns and crabs); frozen flours, meals','Crustáceos comestibles, incl. pelados, congelados, incl. sin pelar, cocidos previamente en agua o vapor (exc. langostas, bogavantes, camarones, langostinos y demás Decápodos natantia y cangrejos [exc. macruros]); harina, polvo y "pellets" de crustáceos ap',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030621,'Lagostas não congeladas','Rock lobster and other sea crawfish Palinurus spp., Panulirus spp. and Jasus spp., whether in shell or not, live, dried, salted or in brine, incl. in shell, cooked by steaming or by boiling in water','Langostas "Palinurus spp.", "Panulirus spp." y "Jasus spp.", incl. peladas, vivas, frescas, refrigeradas, secas, saladas o en salmuera, incl. langostas sin pelar, cocidas previamente en agua o vapor',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030622,'Lavagantes (homards) não congelados','Lobsters Homarus spp., whether in shell or not, live, dried, salted or in brine, incl. lobsters in shell, cooked by steaming or by boiling in water','Bogavantes "Homarus spp.", incl. pelados, vivos, frescos, refrigerados, secos, salados o en salmuera, incl. sin pelar, cocidos previamente en agua o vapor',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030623,'Camarões não congelados','Shrimps and prawns, whether in shell or not, live, dried, salted or in brine, incl. shrimps and prawns in shell, cooked by steaming or by boiling in water','Camarones, langostinos y demás Decápodos natantia, incl. pelados, vivos, frescos, refrigerados, secos, salados o en salmuera, incl. sin pelar, cocidos previamente en agua o vapor',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030624,'Caranguejos não congelados','Crabs, whether in shell or not, live, dried, salted or in brine, incl. crabs in shell, cooked by steaming or by boiling in water','Cangrejos (exc. macruros), incl. pelados, vivos, frescos, refrigerados, secos, salados o en salmuera, incl. sin pelar, cocidos previamente en agua o vapor',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030625,'Lagosta norueguesa (nephrops norvegicus), não congelada','Norway lobster (Nephrops norvegicus), not frozen','Langosta norueguesa (nephrops norvegicus), sin congelar',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030626,'Camarões de água fria, não congelados','Cold water prawns, not frozen','Camarones de agua fría, sin congelar',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030627,'Outros camarões, não congelados','Other prawns, not frozen','Otras gambas, sin congelar',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030629,'Outros crustáceos não congelados, incluídos as farinhas, pós e pellets próprios para alimentação humana','Crustaceans, fit for human consumption, whether in shell or not, live, fresh, chilled, dried, salted or in brine, incl. crustaceans in shell, cooked beforehand by steaming or by boiling in water (excl. rock lobster and other sea crawfish, lobsters, shrimp','Crustáceos comestibles, incl. pelados, vivos, frescos, refrigerados, secos, salados o en salmuera, incl. sin pelar, cocidos previamente en agua o vapor (exc. langostas, bogavantes, camarones, langostinos y demás Decápodos natantia y cangrejos [exc. macrur',03,0306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030710,'Ostras vivas, frescas, refrigeradas, congeladas, secas, salgadas ou em salmoura','Oysters (live), fresh, chilled, frozen, dried, salted or in brine','Ostras, vivas, frescas, refrigeradas, congeladas, secas, saladas o en salmuera',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030711,'Ostras vivas, frescas ou refrigeradas','Live oysters, fresh or chilled','Ostras vivas, frescas o refrigeradas',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030719,'Outras ostras vivas','Other live oysters','Otras ostras vivas',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030721,'Vieiras e outros mariscos (gêneros pecten, chlamys ou placopecten) vivos, frescos ou refrigerados','Live, fresh or chilled scallops, incl. queen scallops, of the genera Pecten, Chlamys or Placopecten, with or without shell','Veneras o vieiras, volandeiras y otros moluscos de los géneros "Pecten", "Chlamys" o "Placopecten", incl. sin concha, vivos, frescos o refrigerados',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030729,'Vieiras e outros mariscos (gêneros pecten, chlamys ou placopecten) congelados, secos, salgados ou em salmoura','Scallops, incl. queen scallops, of the genera Pecten, Chlamys or Placopecten, frozen, dried, salted or in brine, with or without shell','Veneras o vieiras, volandeiras y otros moluscos de los géneros "Pecten", "Chlamys" o "Placopecten", congelados, secos, salados o en salmuera',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030731,'Mexilhões (Mytilus spp., Perna spp.) vivos, frescos ou refrigerados','Live, fresh or chilled mussels Mytilus spp., Perna spp., with or without shell','Mejillones "Mytilus spp.", "Perna spp.", incl. sin concha, vivos, frescos o refrigerados',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030739,'Mexilhões (Mytilus spp., Perna spp.) congelados, secos, salgados ou em salmoura','Mussels Mytilus spp., Perna spp., frozen, dried, salted or in brine, with or without shell','Mejillones "Mytilus spp.", "Perna spp.", incl. sin concha, congelados, secos, salados o en salmuera',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030741,'Sibas, sepiolas, potas e lulas, vivos, frescos ou refrigerados','Live, fresh or chilled cuttle fish Sepia officinalis, Rossia macrosoma, Sepiola spp. and squid Ommastrephes spp., Loligo spp., Nototodarus spp., Sepioteuthis spp., with or without shell','Jibias "Sepia officinalis", "Rossia macrosoma", globitos "Sepiola spp." y calamares y potas "Ommastrephes spp.", "Loligo spp.", "Nototodarus spp.", "Sepioteuthis spp.", incl. sin concha, vivos, frescos o refrigerados',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030749,'Sibas, sepiolas, potas e lulas, congelados, secos, salgados ou em salmoura','Cuttle fish Sepia officinalis, Rossia macrosoma, Sepiola spp. and squid Ommastrephes spp., Loligo spp., Nototodarus spp., Sepioteuthis spp., frozen, dried, salted or in brine, with or without shell','Jibias "Sepia officinalis", "Rossia macrosoma", globitos "Sepiola spp." y calamares y potas "Ommastrephes spp.", "Loligo spp.", "Nototodarus spp.", "Sepioteuthis spp.", incl. sin concha, congelados, secos, salados o en salmuera',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030751,'Polvos (Octopus spp.) vivos, frescos ou refrigerados','Live, fresh or chilled octopus Octopus spp., with or without shell','Pulpos "Octopus spp.", incl. sin concha, vivos, frescos o refrigerados',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030759,'Polvos (Octopus spp.) congelados, secos, salgados ou em salmoura','Octopus Octopus spp., frozen, dried, salted or in brine, with or without shell','Pulpos "Octopus spp.", incl. sin concha, congelados, secos, salados o en salmuera',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030760,'Caracóis, exceto os do mar, vivos, frescos, refrigerados, congelados, secos, salgados ou em salmoura','Snails, live, fresh, chilled, frozen, salted, dried or in brine, with or without shell (excl. sea snails)','Caracoles, incl. sin concha, vivos, frescos, refrigerados, congelados, secos, salados o en salmuera (exc. caracoles de mar)',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030771,'Ameijoas, berbigões e arcas, vivos, fre. ou refriger.','Clams, cockle, live, fresh or chilled','Almeja, berbgones y arcas, vivos,frescos o refrigerados',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030779,'Ameijoas, berbigões e arcas, em outras formas','Clams, cockle, live, in other forms','Almeja, berbgones y arcas, vivos, en otras formas',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030781,'Abalones vivos, frescos ou refrigerados','Abalones, live, fresh or chilled','Abalones vivos, frescos o refrigerados',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030789,'Abalones, em outras formas','Abalones, in other forms','Abalones, en otras formas',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030791,'Outros moluscos, invertebrados aquáticos, exceto os crustáceos, vivos, frescos ou refrigerados, incluídos as farinhas, pós e pellets próprios para alimentação humana','Live, fresh or chilled molluscs, fit for human consumption, whether in shell or not, incl. sea urchins, sea cucumbers and other aquatic invertebrates (other than crustaceans); fresh or chilled flours, meals and pellets of aquatic invertebrates (other than','Moluscos comestibles, incl. sin concha, así como erizos de mar, cohombros de mar y otros invertebrados acuáticos comestibles distintos de los crustáceos, vivos, frescos o refrigerados; harina, polvo y "pellets" de invertebrados acuáticos distintos de los ',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030799,'Outros moluscos, invertebrados aquáticos, exceto os crustáceos, congelados, secos, salgados ou em salmoura, incluídos as farinhas, pós e pellets próprios para alimentação humana','Molluscs, fit for human consumption, whether in shell or not, frozen, dried, salted or in brine, incl. sea urchins, sea cucumbers and other aquatic invertebrates (other than crustaceans); flours, meals and pellets of aquatic invertebrates (other than crus','Moluscos comestibles, incl. sin concha, así como erizos de mar, cohombros de mar y otros invertebrados acuáticos comestibles distintos de los crustáceos, congelados, secos, salados o en salmuera; harina, polvo y "pellets" de invertebrados acuáticos distin',03,0307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030811,'Pepinos-do-mar, vivos, frescos ou refrigerados','Sea cucumbers, live, fresh or chilled','Pepinos de mar, vivos, frescos o refrigerados',03,0308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030819,'Pepinos-do-mar, em outras formas','Sea cucumbers, in other forms','Pepinos de mar, en otras formas',03,0308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030821,'Ouriços-do-mar, vivos, frescos ou refrigerados','Urchins, sea, live, fresh or chilled','Erizos de mar, el mar, vivos, frescos o refrigerados',03,0308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030829,'Ouriços-do-mar, em outras formas','Urchins, sea, other forms','Erizos de mar, al mar, otras formas',03,0308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030830,'Medusas (águas-vivas) (rhopilema spp.)','Medusa (jellyfish) (rhopilema spp.)','Medusa (medusas) (Rhopilema spp.)',03,0308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (030890,'Outros invertebrados aquáticos (exceto crustáceos e moluscos), secos, congelados, etc','Other aquatic invertebrates (excluding crustaceans and molluscs), dried, frozen, etc.','Otros invertebrados acuáticos (excepto los crustáceos y moluscos), secos, congelados, etc',03,0308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040110,'Leite e creme de leite não concentrados, não adocicados, com um teor, em peso, de matérias gordas <= 1%','Milk and cream of a fat content by weight of <= 1%, not concentrated nor containing added sugar or other sweetening matter','Leche y nata "crema", sin concentrar, sin adición de azúcar ni otro edulcorante, con un contenido de materias grasas <= 1% en peso',04,0401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040120,'Leite e creme de leite, não concentrados, não adocicados, com um teor, em peso, de matérias gordas superior a 1% e <= 6%','Milk and cream of a fat content by weight of > 1% but <= 6%, not concentrated nor containing added sugar or other sweetening matter','Leche y nata "crema", sin concentrar, sin adición de azúcar ni otro edulcorante, con un contenido de materias grasas > 1% en peso pero <= 6% en peso',04,0401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040130,'Leite e creme de leite, não concentrados, não adocicados, com um teor, em peso, de matérias gordas superior a 6%','Milk and cream of a fat content by weight of > 6%, not concentrated nor containing added sugar or other sweetening matter','Leche y nata "crema", sin concentrar, sin adición de azúcar ni otro edulcorante, con un contenido de materias grasas > 6% en peso',04,0401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040140,'Leite e creme de leite, com teor em peso, de matérias gordas, superior a 6 %, mas não superior a 10 %','Milk and cream of a fat content, by weight, exceeding 6% but not exceeding 10%','Leche y nata con un contenido en peso de grasa de más de 6% pero no más de 10%',04,0401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040150,'Leite e creme de leite, com teor em peso, de matérias gordas, superior a 10 %','Milk and cream of a fat content, by weight,  exceeding 10%','Leche y nata con un contenido en peso de grasa de  más de 10%',04,0401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040210,'Leite em pó, grânulos ou outras formas sólidas, concentrados ou adocicados, com um teor, em peso, de matérias gordas <= 1,5%','Milk and cream in solid forms, of a fat content by weight of <= 1,5%','Leche y nata "crema", en polvo, gránulos o demás formas sólidas, con un contenido de materias grasas <= 1,5% en peso',04,0402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040221,'Leite em pó, grânulos ou outras formas sólidas, com um teor, em peso, de matérias gordas superior a 1,5%, concentrados, não adocicados','Milk and cream in solid forms, of a fat content by weight of > 1,5%, unsweetened','Leche y nata "crema", en polvo, gránulos o demás formas sólidas, con un contenido de materias grasas > 1,5% en peso, sin adición de azúcar ni otro edulcorante',04,0402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040229,'Leite em pó, grânulos ou outras formas sólidas, com um teor, em peso, de matérias gordas superior a 1,5%, adocicados','Milk and cream in solid forms, of a fat content by weight of > 1,5%, sweetened','Leche y nata "crema", en polvo, gránulos o demás formas sólidas, con un contenido de materias grasas > 1,5% en peso, con adición de azúcar u otro edulcorante',04,0402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040291,'Outros leites, cremes de leite, concentrados, não adocicados','Milk and cream, concentrated but unsweetened (excl. in solid forms)','Leche y nata "crema", concentradas, sin adición de azúcar ni otro edulcorante (exc. en polvo, gránulos o demás formas sólidas)',04,0402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040299,'Outros leites, cremes de leite, concentrados, adocicados','Milk and cream, concentrated and sweetened (excl. in solid forms)','Leche y nata "crema", concentradas, con adición de azúcar u otro edulcorante (exc. en polvo, gránulos o demás formas sólidas)',04,0402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040310,'Iogurte, mesmo aromatizado ou adicionado de açúcar ou de outros edulcorantes, de frutas ou de cacau','Yogurt, whether or not flavoured or containing added sugar or other sweetening matter, fruits, nuts or cocoa','Yogur, incl. aromatizado, con adición de azúcar u otro edulcorante, frutas o cacao',04,0403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040390,'Leitelho, leite, creme de leite, coalhados, quefir e outros leites e cremes de leite, fermentados ou acidificados, mesmo concentrados, adocicados ou aromatizados','Buttermilk, curdled milk and cream, kephir and other fermented or acidified milk and cream, whether or not concentrated or flavoured or containing added sugar or other sweetening matter, fruits, nuts or cocoa (excl. yogurt)','Suero de mantequilla "de manteca", leche y nata "crema" cuajadas, kéfir y demás leches y natas "cremas" fermentadas o acidificadas, incl. concentrados, con adición de azúcar u otro edulcorante, aromatizados o con frutas o cacao (exc. yogur)',04,0403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040410,'Soro de leite, modificado ou não, mesmo concentrado ou adocicado','Whey and modified whey, whether or not concentrated or containing added sugar or other sweetening matter','Lactosuero, aunque esté modificado o incluso concentrado o con adición de azúcar u otro edulcorante',04,0404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040490,'Outros produtos constituídos do leite, mesmo concentrados ou adocicados','Products consisting of natural milk constituents, whether or not sweetened, n.e.s.','Productos constituidos por los componentes naturales de la leche, incl. con adición de azúcar u otro edulcorante, n.c.o.p. (exc. lactosuero)',04,0404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040510,'Manteiga','Butter (excluding dehydrated butter and ghee)','Mantequilla "manteca" (exc. mantequilla deshidratada y "ghee")',04,0405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040520,'Pastas de espalhar (barrar) de produtos provenientes do leite','Dairy spreads of a fat content, by weight, of >= 39% but < 80%','Pastas lácteas para untar, con un contenido de materias grasas >= 39% en peso pero < 80% en peso',04,0405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040590,'Óleo butírico de manteiga (butter oil) e outras matérias gordas provenientes do leite','Fats and oils derived from milk, and dehydrated butter and ghee (excl. natural butter, recombined butter and whey butter)','Grasas de la leche, así como mantequilla "manteca" deshidratada y "ghee" (exc. mantequilla "manteca" natural, recombinada y de lactosuero)',04,0405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040610,'Queijos frescos (não curados), incluído o queijo do soro de leite e o requeijão','Fresh cheese unripened or uncured cheese, incl. whey cheese, and curd','Queso fresco "sin madurar", incl. el del lactosuero, y requesón',04,0406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040620,'Queijos ralados ou em pó, de qualquer tipo','Grated or powdered cheese','Queso de cualquier tipo, rallado o en polvo',04,0406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040630,'Queijos fundidos, exceto ralados ou em pó','Processed cheese, not grated or powdered','Queso fundido (exc. rallado o en polvo)',04,0406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040640,'Queijos de pasta mofada (azul)','Blue-veined cheese and other cheese containing veins produced by Penicillium roqueforti','Queso de pasta azul',04,0406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040690,'Outros queijos','Other cheese: Cheddar cheese , Colby , Other, including mixtures','Los demás quesos: queso Cheddar, Colby, Otros, incluidas las mezclas ',04,0406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040700,'Ovos de aves, com casca, frescos, conservados ou cozidos','Eggs of birds, in shell, fresh, preserved or cooked','Huevos de ave con cascara "cascarón", frescos, conservados o cocidos',04,0407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040711,'Ovos de aves da espécie gallus domesticus, para incubação','Eggs of birds of the species Gallus domesticus, for hatching','Los huevos de aves de la especie Gallus domesticus de la eclosión',04,0407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040719,'Ovos de outras aves, destinados para incubação','Eggs from other birds, for hatching','Huevos de otras aves, para incubar',04,0407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040721,'Ovos frescos de aves da espécie gallus domesticus','Fresh eggs of birds of the species Gallus domesticus','Huevos frescos de aves de la especie Gallus domesticus',04,0407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040729,'Ovos frescos de outras aves','Fresh eggs of other birds','Huevos frescos de otras aves',04,0407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040790,'Ovos de outras aves, não para incubação ou não frescos','Eggs from other birds, not for hatching or not fresh','Huevos de otras aves, no para incubar o no fresco',04,0407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040811,'Gemas de ovos, secas, mesmo adicionadas de açúcar','Dried egg yolks, whether or not sweetened','Yemas de huevo, secas, incl. con adición de azúcar u otro edulcorante',04,0408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040819,'Gemas de ovos, frescas, cozidas em água ou vapor, congeladas ou preservadas de outro modo, mesmo adicionadas de açúcar','Egg yolks, fresh, cooked by steaming or boiling in water, moulded, frozen or otherwise preserved, whether or not sweetened (excl. dried)','Yemas de huevo, frescas, cocidas en agua o vapor, moldeadas, congeladas o conservadas de otro modo, incl. con adición de azúcar u otro edulcorante (exc. secas)',04,0408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040891,'Ovos de aves, sem casca, secos, mesmo adicionados de açúcar','Dried birds'' eggs, not in shell, whether or not sweetened (excl. egg yolks)','Huevos de ave sin cáscara "cascarón", secos, incl. con adición de azúcar u otro edulcorante (exc. yemas)',04,0408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040899,'Outros ovos de aves, sem casca, frescos, cozidos em água ou vapor, congelados ou preservados de outro modo, mesmo adicionados de açúcar','Birds'' eggs, not in shell, fresh, cooked by steaming or boiling in water, moulded, frozen or otherwise preserved, whether or not sweetened (excl. dried)','Huevos de ave sin cáscara "cascarón", frescos, cocidos en agua o vapor, moldeados, congelados o conservados de otro modo, incl. con adición de azúcar u otro edulcorante (exc. secos)',04,0408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (040900,'Mel natural','Natural honey','Miel natural',04,0409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (041000,'Outros produtos comestíveis de origem animal','Turtles'' eggs, birds'' nests and other edible products of animal origin, n.e.s.','Huevos de tortuga, nidos de golondrina y demás productos comestibles de origen animal, n.c.o.p.',04,0410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (050100,'Cabelos em bruto, mesmo lavados e desengordurados; desperdícios de cabelo','Human hair, unworked, whether or not washed or scoured; waste of human hair','Cabello en bruto, incl. lavado o desgrasado, incl. desperdicios de cabello',05,0501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (050210,'Cerdas de porco ou de javali e seus desperdícios','Pigs'', hogs'' or boars'' bristles and waste of such bristles','Cerdas de cerdo o de jabalí, y sus desperdicios',05,0502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (050290,'Pêlos de texugo, outros pelos e desperdícios de pêlos para escovas, pincéis e artigos semelhantes','Badger and other brush making hair and waste thereof','Pelo de tejón y demás pelos para cepillería; desperdicios de dichas cerdas o pelos',05,0502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (050300,'Crinas e seus desperdícios, mesmo em mantas','Horsehair and horseh.waste, whether/not put up as layer','Crin y sus desperdicios, incluso en capas c/soporte',05,0503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (050400,'Tripas, bexigas e estômagos de animais, exceto peixes, inteiros ou em pedaços, frescos, refrigerados, congelados, salgados, secos ou defumados','Guts, bladders and stomachs of animals (other than fish), whole and pieces thereof, fresh, chilled, frozen, salted, in brine, dried or smoked','Tripas, vejigas y estómagos de animales (exc. de pescado), enteros o en trozos, frescos, refrigerados, congelados, salados o en salmuera, secos o ahumados',05,0504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (050510,'Penas para enchimento ou estofamento; penugem; em bruto ou simplesmente limpas, desinfetadas ou preparadas para conservação','Feathers used for stuffing and down, not further worked than cleaned, disinfected or treated for preservation','Plumas de las utilizadas para relleno y plumón, en bruto o simplemente limpiados, desinfectados o preparados para su conservación',05,0505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (050590,'Peles e outras partes de aves, com suas penas ou penugem','Skins and other parts of birds, with their feathers or down, feathers and parts of feathers, whether or not with trimmed edges, not further worked than cleaned, disinfected or treated for preservation; powder and waste of feathers or parts of feathers (ex','Pieles y demás partes de ave, con sus plumas o plumón, plumas y partes de plumas, incl. recortadas, en bruto o simplemente limpiados, desinfectados o preparados para su conservación, así como polvo y desperdicios de plumas o de partes de plumas (exc. util',05,0505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (050610,'Osseína e ossos acidulados','Ossein and bones treated with acid','Oseína y huesos acidulados',05,0506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (050690,'Ossos e núcleos córneos, em bruto, desengordurados, degelatinados ou simplesmente preparados; pós e desperdícios destas matérias','Bones and horn-cores and their powder and waste, unworked, defatted, degelatinised or simply prepared (excl. ossein and bones treated with acid and cut to shape)','Huesos y núcleos córneos, en bruto, desgrasados, desgelatinizados o simplemente preparados, polvo y desperdicios de estas materias (exc. oseína y huesos acidulados o cortados en forma determinada)',05,0506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (050710,'Marfim, em bruto ou simplesmente preparado; seus pós e desperdícios','Ivory, unworked or simply prepared, its powder and waste (excl. cut to shape)','Marfil, en bruto o simplemente preparado (exc. el cortado en forma determinada)',05,0507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (050790,'Carapaças de tartarugas, barbas, chifres, galhadas, cascos, em bruto ou simplesmente preparados; seus pós e desperdícios','Tortoiseshell, whalebone and whalebone hair, horns, antlers, hooves, nails, claws and beaks, unworked or simply prepared, their powder and waste (excl. cut to shape and ivory)','Concha "caparazón" de tortuga, ballenas de mamíferos marinos, incl. las barbas, cuernos, astas, cascos, pezuñas, uñas, garras y picos, en bruto o simplemente preparados, así como polvo y desperdicios de estas materias (exc. los cortados en forma determina',05,0507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (050800,'Coral, conchas, carapaças de moluscos, em bruto ou preparadas; seus pós e desperdícios','Coral and similar materials, shells of molluscs, crustaceans or echinoderms, cuttle-bone, powder and waste thereof, unworked or simply prepared but not otherwise worked or cut to shape','Coral y materias simil., valvas y caparazones, de moluscos, crustáceos o equinodermos, incl. sus polvos y desperdicios, así como jibiones, en bruto o simplemente preparados (exc. los preparados o cortados en forma determinada)',05,0508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (050900,'Esponjas naturais de origem animal','Natural sponges of animal origin','Esponjas naturales de origen animal',05,0509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (051000,'Âmbar-cinzento, castóreo, algália e almíscar; bílis, mesmo seca; glândulas e outras substâncias de origem animal utilizadas na preparação de produtos farmacêuticos, frescas, refrigeradas, congeladas ou provisoriamente conservadas de outro modo','Ambergris, castoreum, civet and musk; cantharides; bile, whether or not dried; glands and other animal products used in the preparation of pharmaceutical products, fresh, chilled, frozen or otherwise provisionally preserved','Ámbar gris, castóreo, algalia y almizcle; cantáridas; bilis, incl. desecada; glándulas y demás sustancias de origen animal utilizadas para la preparación de productos farmacéuticos, frescas, refrigeradas, congeladas o conservadas provisionalmente de otro ',05,0510);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (051110,'Sêmen de bovino','Bovine semen','Semen de bovino',05,0511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (051191,'Produtos de peixes ou crustáceos, moluscos ou de outros invertebrados aquáticos, animais mortos do capítulo 3, impróprios para alimentação humana','Products of fish or crustaceans, molluscs or other aquatic invertebrates; dead fish, crustaceans, molluscs or other aquatic invertebrates, unfit for human consumption','Productos de pescado o de crustáceos, moluscos u otros invertebrados acúaticos; pescados, crustáceos, moluscos u otros invertebrados acúaticos muertos, impropios para la alimentación humana',05,0511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (051199,'Outros produtos de origem animal, impróprios para alimentação humana; animais mortos','Products of animal origin, n.e.s., dead animals, unfit for human consumption (excl. fish, crustaceans, molluscs or other aquatic invertebrates)','Productos de origen animal, n.c.o.p.; animales muertos , impropios para la alimentación humana (exc. pescados, crustáceos, moluscos u otros invertebrados acúaticos)',05,0511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060110,'Bulbos, tubérculos, raízes tuberosas, rebentos e rizomas, em repouso vegetativo','Bulbs, tubers, tuberous roots, corms, crowns and rhizomes, dormant (excl. those used for human consumption and chicory plants and roots)','Bulbos, cebollas, tubérculos, raíces y bulbos tuberosos, turiones y rizomas, en reposo vegetativo (exc. para usos alimenticios, así como las plantas, incl. plantas jóvenes, y raíces de achicoria)',06,0601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060120,'Bulbos, tubérculos, raízes tuberosas, rebentos e rizomas, em vegetação ou em flor; mudas, plantas e raízes de chicória','Bulbs, tubers, tuberous roots, corms, crowns and rhizomes, in growth or in flower; chicory plants and roots (excl. those used for human consumption and chicory roots of the variety cichorium intybus sativum)','Bulbos, cebollas, tubérculos, raíces y bulbos tuberosos, turiones, rizomas, en vegetación o en flor; plantas, incl. plantas jóvenes, y raíces de achicoria (exc. para usos alimenticios, así como las raíces de achicoria de la variedad "Cichorium intybus sat',06,0601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060210,'Estacas não enraizadas e enxertos','Unrooted cuttings and slips','Esquejes sin enraizar e injertos',06,0602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060220,'Árvores, arbustos e silvados, de frutos comestíveis, enxertados ou não','Edible fruit or nut trees, shrubs and bushes, whether or not grafted','Árboles, arbustos y matas, de frutas o de otros frutos comestibles, incl. injertados',06,0602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060230,'Rododendros e azaléias, enxertados ou não','Rhododendrons and azaleas, grafted or not','Rododendros y azaleas, incl. injertados',06,0602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060240,'Roseiras, enxertadas ou não','Roses, whether or not grafted','Rosales, incl. injertados',06,0602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060290,'Outras plantas vivas, mudas de plantas, e micélios de cogumelos','Live plants, incl. their roots, and mushroom spawn (excl. bulbs, tubers, tuberous roots, corms, crowns and rhizomes, incl. chicory plants and roots, unrooted cuttings and slips, fruit and nut trees, rhododendrons, azaleas and roses)','Plantas vivas, incl. sus raíces, y micelios (exc. bulbos, cebollas, tubérculos, raíces y bulbos tuberosos, turiones y rizomas, y raíces de achicoria; esquejes y estaquillas, sin enraizar, e injertos; árboles, arbustos y matas, de frutas o de otros frutos ',06,0602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060310,'Flores e seus botões, frescos, cortados para buquês, etc.','Fresh cut flowers and buds for bouquets, etc.','Flores y sus capullos, frescos, cortados para ramos, etc',06,0603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060311,'Rosas frescas e seus botões, cortadas para buquês ou para ornamentação','Fresh cut roses and buds, of a kind suitable for bouquets or for ornamental purposes','Rosas frescas y sus botones, cortados para ramilletes o para ornamentación',06,0603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060312,'Cravos frescos e seus botões, cortados para buquês ou para ornamentação','Fresh cut carnations and buds, of a kind suitable for bouquets or for ornamental purposes','Claveles frescos y sus botones, cortados para ramilletes o para ornamentación',06,0603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060313,'Orquídeas frescas e seus botões, cortadas para buquês ou para ornamentação','Fresh cut orchids and buds, of a kind suitable for bouquets or for ornamental purposes','Orquídeas frescas y sus botones, cortados para ramilletes o para ornamentación',06,0603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060314,'Crisântemos frescos e seus botões, cortados para buquês ou para ornamentação','Fresh cut chrysanthemums and buds, of a kind suitable for bouquets or for ornamental purposes','Crisantemos frescos y sus botones, cortados para ramilletes o para ornamentación',06,0603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060315,'Lírios (lilium spp.)','Lilies (Lilium spp.)','Lirios (Lilium spp.)',06,0603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060319,'Outras flores frescas e seus botões, cortadas para buquês ou para ornamentação','Fresh cut flowers and buds, of a kind suitable for bouquets or for ornamental purposes (excl. roses, carnations, orchids, chrysanthemums and gladioli)','Demás flores frescas y sus botones, cortados para ramilletes o para ornamentación',06,0603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060390,'Flores e seus botões, secos, branqueados, tingidos ou preparados de outro modo, cortados para buquês ou para ornamentação','Dried, dyed, bleached, impregnated or otherwise prepared cut flowers and buds, for bouquets or for ornamental purposes','Flores y capullos, cortados para ramos o adornos, secos, blanqueados, teñidos, impregnados o preparados de otra forma',06,0603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060410,'Musgos e líquens, para buquês ou para ornamentação, frescos, secos, branqueados, tingidos, impregnados ou preparados','Mosses and lichens for bouquets or for ornamental purposes, fresh, dried, dyed, bleached, impregnated or otherwise prepared','Musgos y líquenes, para ramos o adornos, frescos, secos, blanqueados, teñidos, impregnados o preparados de otra forma',06,0604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060420,'Folhagem,folhas,ramos de plantas,frescos,p/buques,etc.','Foliage, branches of plants, fresh, for bouquets, etc','Follaje, ramas de plantas, frescos, para los ramos, etc',06,0604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060490,'Folhagem,folhas,ramos de plantas,secos,etc.p/buques,etc','Foliage, branches of plants, dried, for bouquets, etc','Follaje, ramas de plantas, secos, para los ramos, etc',06,0604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060491,'Folhagem, folhas, ramos e outras partes de plantas, ervas, sem flores nem botões de flores, frescos, para buquês ou para ornamentação','Foliage, branches and other parts of plants, without flowers or flower buds, grasses, fresh, for bouquets or ornamental purposes','Follaje, hojas, ramas y demás partes de plantas, sin flores ni capullos, así como hierbas, para ramos o adornos, frescos',06,0604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (060499,'Folhagem, folhas, ramos de plantas, secos ou preparados, para buquês ou para ornamentação','Foliage, branches and other parts of plants, without flowers or flower buds, grasses, for bouquets or ornamental purposes, dried, dyed, bleached, impregnated or otherwise prepared','Follaje, hojas, ramas y demás partes de plantas, sin flores ni capullos, así como hierbas, para ramos o adornos, secos, blanqueados, teñidos, impregnados o preparados de otra forma',06,0604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070110,'Batatas para semeadura (batata semente)','Seed potatoes','Patatas "papas" para siembra',07,0701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070190,'Batatas frescas ou refrigeradas','Fresh or chilled potatoes (excl. seed)','Patatas "papas" frescas o refrigeradas (exc. las de siembra)',07,0701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070200,'Tomates, frescos ou refrigerados','Tomatoes, fresh or chilled','Tomates frescos o refrigerados',07,0702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070310,'Cebolas e echalotes, frescas ou refrigeradas','Fresh or chilled onions and shallots','Cebollas y chalotes, frescos o refrigerados',07,0703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070320,'Alhos, frescos ou refrigerados','Garlic, fresh or chilled','Ajos frescos o refrigerados',07,0703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070390,'Alhos-porros e outros produtos hortícolas aliáceos, frescos ou refrigerados','Leeks and other alliaceous vegetables, fresh or chilled (excl. onions, shallots and garlic)','Puerros y demás hortalizas aliáceas, incl. "silvestres", frescos o refrigerados (exc. cebollas, chalotes y ajos)',07,0703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070410,'Couve-flor e brócolos, frescos ou refrigerados','Fresh or chilled cauliflowers and headed broccoli','Coles y brécoles "broccoli", frescos o refrigerados',07,0704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070420,'Couve-de-bruxelas, fresca ou refrigerada','Brussels sprouts, fresh or chilled','Coles "repollitos" de Bruselas, frescas o refrigeradas',07,0704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070490,'Couves, repolhos e produtos comestíveis semelhantes do gênero brassica, frescos ou refrigerados','Fresh or chilled cabbages, kohlrabi, kale and similar edible brassicas (excl. cauliflowers, headed broccoli and Brussels sprouts)','Coles, incl. los repollos, y coliflores, coles rizadas, colinabos y productos comestibles simil. del género "Brassica", frescos o refrigerados (exc. coliflores, brécoles "broccoli" y coles "repollitos" de Bruselas)',07,0704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070511,'Alfaces repolhudas, frescas ou refrigeradas','Fresh or chilled cabbage lettuce','Lechugas repolladas, frescas o refrigeradas',07,0705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070519,'Outras alfaces frescas ou refrigeradas','Fresh or chilled lettuce (excl. cabbage lettuce)','Lechugas "Lactuca sativa", frescas o refrigeradas (exc. lechugas repolladas)',07,0705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070521,'Chicórias (witloof), frescas ou refrigeradas','Fresh or chilled witloof chicory','Endibias "Witloof", "Cichorium intybus var. foliosum", frescas o refrigeradas',07,0705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070529,'Outras chicórias, frescas ou refrigeradas','Fresh or chilled chicory (excluding witloof chicory)','Achicorias, comprendidas la escarola y la endibia "Cichorium spp.", frescas o refrigeradas (exc. endibia "Witloof" "Cichorium intybus var. foliosum")',07,0705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070610,'Cenouras e nabos, frescos ou refrigerados','Fresh or chilled carrots and turnips','Zanahorias y nabos, frescos o refrigerados (exc. remolachas para ensalada)',07,0706);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070690,'Beterrabas, rabanetes e outras raízes, frescas ou refrigeradas','Fresh or chilled salad beetroot, salsify, celeriac, radishes and similar edible roots (excl. carrots and turnips)','Remolachas para ensalada, salsifíes, apionabos, rábanos y raíces comestibles, frescas o refrigeradas (exc. zanahorias y nabos)',07,0706);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070700,'Pepinos e pepininhos cornichons, frescos ou refrigerados','Cucumbers and gherkins, fresh or chilled','Pepinos y pepinillos, frescos o refrigerados',07,0707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070810,'Ervilhas (pisum sativum), frescas ou refrigeradas, com ou sem vagem','Fresh or chilled peas Pisum sativum, shelled or unshelled','Guisantes "arvejas, chícharos" "Pisum sativum", aunque estén desvainados, frescos o refrigerados',07,0708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070820,'Feijões (Vigna spp., Phaseolus spp.) frescos ou refrigerados, com ou sem vagem','Fresh or chilled beans Vigna spp., Phaseolus spp., shelled or unshelled','Judias "porotos, alubias, frijoles, fréjoles" "Vigna spp.", "Phaseolus spp.", frescas o refrigeradas',07,0708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070890,'Outros legumes de vagem, frescas ou refrigeradas, com ou sem vagem','Fresh or chilled leguminous vegetables, shelled or unshelled (excl. peas Pisum sativum and beans Vigna spp., Phaseolus spp.)','Hortalizas de vaina, incl. "silvestres", aunque estén desvainadas, frescas o refrigeradas (exc. guisantes "arvejas, chícharos" "Pisum sativum" y judias "porotos, alubias, frijoles, fréjoles" "Vigna spp.", "Phaseolus spp.")',07,0708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070910,'Alcachofras frescas ou refrigeradas','Fresh or chilled artichokes','Alcachofas frescas o refrigeradas',07,0709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070920,'Aspargos frescos ou refrigerados','Fresh or chilled asparagus','Espárragos, frescos o refrigerados',07,0709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070930,'Berinjelas frescas ou refrigeradas','Fresh or chilled aubergines eggplants','Berenjenas, frescas o refrigeradas',07,0709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070940,'Aipo fresco ou refrigerado, exceto aipo-rábano','Fresh or chilled celery (excl. celeriac)','Apio, fresco o refrigerado (exc. apionabo)',07,0709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070951,'Cogumelos do gênero agaricus, frescos ou refrigerados','Fresh or chilled mushrooms of the genus Agaricus','Hongos del género "Agaricus", frescos o refrigerados',07,0709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070952,'Trufas frescas ou refrigeradas','Fresh or chilled truffles','Trufas frescas o refrigeradas',07,0709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070959,'Outros cogumelos e trufas, frescos ou refrigerados','Fresh or chilled edible mushrooms (excl. mushrooms of the genus Agaricus and truffles)','Setas y demás hongos, comestibles, frescas o refrigeradas (exc. hongos del género "Agaricus" y trufas)',07,0709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070960,'Pimentões e pimentas dos gêneros capsicum ou pimenta, frescos ou refrigerados','Fresh or chilled fruits of the genus Capsicum or Pimenta','Frutos de las géneros "Capsicum" o "Pimenta", frescos o refrigerados',07,0709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070970,'Espinafres, espinafres-da-nova zelândia e espinafres gigantes, frescos ou refrigerados','Fresh or chilled spinach, New Zealand spinach and orache spinach','Espinacas, incl. las de Nueva Zelanda, y armuelles, frescas o refrigeradas',07,0709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070990,'Outros produtos hortícolas, frescos ou refrigerados','Fresh or chilled vegetables (excl. potatoes, tomatoes, vegetables of the Allium spp., cabbages of the genus Brassica, lettuces of the species Lactuca sativa and Cichorium, carrots, turnips, salad beetroot, salsify, celeriac, radishes and similar edible ro','Hortalizas, incl. "silvestres", frescas o refrigeradas (exc. patatas "papas"; tomates; cebollas, chalotes, ajos, puerros y demás hortalizas aliáceas; coles, coliflores, coles rizadas, colinabos y productos simil. del género "brassica"; lechugas "Lactuca s',07,0709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070991,'Alcachofras, frescas ou refrigeradas','Fresh or chilled artichokes','Alcachofas frescas o refrigeradas',07,0709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070992,'Azeitonas, frescas ou refrigeradas','Olives, fresh or chilled','Aceitunas, frescas o refrigeradas',07,0709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070993,'Abóboras, abobrinhas e cabaças, frescas ou refrigerada','Pumpkins, squash and gourds, fresh or chilled','Calabazas, frescos o refrigerados',07,0709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (070999,'Outros produtos hortícolas, frescos ou refrigerados','Other vegetables, fresh or chilled','Las demás hortalizas, frescas o refrigeradas',07,0709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071010,'Batatas congeladas, não cozidas ou cozidas em água ou vapor','Potatoes, uncooked or cooked by steaming or by boiling in water, frozen','Patatas "papas", aunque estén cocidas en agua o vapor, congeladas',07,0710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071021,'Ervilhas congeladas, com ou sem vagem, não cozidas ou cozidas em água ou vapor','Shelled or unshelled peas Pisum sativum, uncooked or cooked by steaming or by boiling in water, frozen','Guisantes "arvejas, chícharos" "Pisum sativum", aunque estén cocidas en agua o vapor, congelados',07,0710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071022,'Feijões congelados, com ou sem vagem, não cozidos ou cozidos em água ou vapor','Shelled or unshelled beans Vigna spp., Phaseolus spp., uncooked or cooked by steaming or by boiling in water, frozen','Judías "porotos, alubias, frijoles, fréjoles" "Vigna spp.", "Phaseolus spp.", aunque estén cocidas en agua o vapor, congeladas',07,0710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071029,'Outras legumes de vagem congeladas, com ou sem vagem, não cozidas ou cozidas em água ou vapor','Leguminous vegetables, shelled or unshelled, uncooked or cooked by steaming or by boiling in water, frozen (excl. peas and beans)','Hortalizas de vaina, incl. "silvestres", aunque estén cocidas en agua o vapor, congeladas (exc. guisantes "arvejas, chícharos" "Pisum sativum" y judías "porotos, alubias, frijoles, fréjoles" "Vigna spp.", "Phaseolus spp.")',07,0710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071030,'Espinafres, espinafres-da-nova zelândia e espinafres gigantes, congelados, não cozidos ou cozidos em água ou vapor','Spinach, New Zealand spinach and orache spinach, uncooked or cooked by steaming or by boiling in water, frozen','Espinacas, incl. las de Nueva Zelanda, y armuelles, incl. cocidas con agua o vapor, congeladas',07,0710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071040,'Milho doce congelado, não cozido ou cozido em água ou vapor','Sweetcorn, uncooked or cooked by steaming or by boiling in water, frozen','Maíz dulce, incl. cocido con agua o vapor, congelado',07,0710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071080,'Outros produtos hortícolas congelados, não cozidos ou cozidos em água ou vapor','Vegetables, uncooked or cooked by steaming or by boiling in water, frozen (excl. potatoes, leguminous vegetables, spinach, New Zealand spinach, orache spinach, and sweetcorn)','Hortalizas, incl. "silvestres", aunque estén cocidas en agua o vapor, congeladas (exc. patatas "papas", hortalizas de vaina, espinacas, incl. las de Nueva Zelanda , armuelles y maíz dulce)',07,0710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071090,'Misturas de produtos hortícolas congelados, não cozidos ou cozidos em água ou vapor','Mixtures of vegetables, uncooked or cooked by steaming or by boiling in water, frozen','Mezclas de hortalizas, incl. "silvestres", aunque estén cocidas en agua o vapor, congeladas',07,0710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071110,'Cebolas conservadas em água salgada, sulfurada, etc.','Onions preserved in brine, in sulphur water, etc.','Cebollas conservadas en agua salada,  sulfurosa,  etc',07,0711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071120,'Azeitonas conservadas transitoriamente, mas impróprias para alimentação neste estado','Olives, provisionally preserved, e.g. by sulphur dioxide gas, in brine, in sulphur water or in other preservative solutions, but unsuitable in that state for immediate consumption','Aceitunas conservadas provisionalmente, p.ej., con gas sulfuroso o con agua salada, sulfurosa o adicionada de otras sustancias para asegurar dicha conservación, pero todavía impropias para consumo inmediato',07,0711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071130,'Alcaparras conservadas','Capers preserved','Alcaparras conservadas',07,0711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071140,'Pepinos e pepininhos conservados transitoriamente, mas impróprios para alimentação neste estado','Cucumbers and gherkins provisionally preserved, e.g. by sulphur dioxide gas, in brine, in sulphur water or in other preservative solutions, but unsuitable in that state for immediate consumption','Pepinos y pepinillos, conservadas provisionalmente, p.ej., con gas sulfuroso o con agua salada, sulfurosa o adicionada de otras sustancias para asegurar dicha conservación, pero todavía impropias para consumo inmediato',07,0711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071151,'Cogumelos do gênero agaricus conservados transitoriamente, mas impróprios para alimentação nesse estado','Mushrooms of the genus Agaricus, provisionally preserved, e.g., by sulphur dioxide gas, in brine, in sulphur water or in other preservative solutions, but unsuitable in that state for immediate consumption','Setas y demás hongos del género "Agaricus", conservadas provisionalmente, p.ej., con gas sulfuroso o con agua salada, sulfurosa o adicionada de otras sustancias para asegurar dicha conservación, pero todavía impropias para consumo inmediato',07,0711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071159,'Outros cogumelos e trufas conservados transitoriamente, mas impróprios para alimentação nesse estado','Mushrooms and truffles, provisionally preserved, e.g., by sulphur dioxide gas, in brine, in sulphur water or in other preservative solutions, but unsuitable in that state for immediate consumption (excl. mushrooms of the genus Agaricus)','Setas y demás hongos, conservadas provisionalmente, p.ej., con gas sulfuroso o con agua salada, sulfurosa o adicionada de otras sustancias para asegurar dicha conservación, pero todavía impropias para consumo inmediato (exc. hongos del género "Agaricus")',07,0711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071190,'Outros produtos e misturas hortícolas conservadas transitoriamente, mas impróprios para alimentação neste estado','Vegetables and mixtures of vegetables provisionally preserved, e.g. by sulphur dioxide gas, in brine, in sulphur water or in other preservative solutions, but unsuitable in that state for immediate consumption (excl. onions, olives, cucumbers and gherkins','Hortalizas, incl. "silvestres", mezclas de hortalizas, incl. "silvestres", conservadas provisionalmente, p.ej., con gas sulfuroso o con agua salada, sulfurosa o adicionada de otras sustancias para asegurar dicha conservación, pero todavía impropias para c',07,0711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071220,'Cebolas secas, inclusive em pedaços ou fatias, trituradas ou em pó, sem qualquer outro preparo','Dried onions, whole, cut, sliced, broken or in powder, but not further prepared','Cebollas secas, incl. las cortadas en trozos o en rodajas o las trituradas o pulverizadas, pero sin otra preparación',07,0712);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071230,'Cogumelos e trufas, secos, incl.pedaços, etc.s/qq.out.prep','Dried mushrooms/truffles, incl.cut, etc.but n/fut.prep.','Hongos y trufas, secos, incl.trozos, etc, s/otra prepar.',07,0712);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071231,'Cogumelos do gênero agaricus, secos, mesmo cortados em pedaços, triturados ou em pó, mas sem qualquer outro preparo','Dried mushrooms of the genus Agaricus, whole, cut, sliced, broken or in powder, but not further prepared','Hongos del género "Agaricus", secos, incl. los cortados en trozos o en rodajas o los triturados o pulverizados, pero sin otra preparación',07,0712);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071232,'Orelhas-de-judas secas, mesmo cortadas em pedaços, trituradas ou em pó, mas sem qualquer outro preparo','Dried wood ears Auricularia spp., whole, cut, sliced, broken or in powder, but not further prepared','Orejas de Judas "Auricularia spp.", secas, incl. las cortadas en trozos o en rodajas o las trituradas o pulverizadas, pero sin otra preparación',07,0712);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071233,'Tremelas secas, mesmo cortadas em pedaços, trituradas ou em pó, mas sem qualquer outro preparo','Dried jelly fungi Tremella spp., whole, cut, sliced, broken or in powder, but not further prepared','Hongos gelatinosos "Tremella spp.", secos, incl. los cortados en trozos o en rodajas o los triturados o pulverizados, pero sin otra preparación',07,0712);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071239,'Outros cogumelos e trufas, secos, mesmo cortados em pedaços, triturados ou em pó, mas sem qualquer outro preparo','Dried mushrooms and truffles, whole, cut, sliced, broken or in powder, but not further prepared (excl. mushrooms of the genus Agaricus, wood ears Auricularia spp. and jelly fungi Tremella spp.)','Setas y demás hongos y trufas, secas, incl. las cortadas en trozos o en rodajas o las trituradas o pulverizadas, pero sin otra preparación (exc. hongos del género "Agaricus", orejas de Judas "Auricularia spp." y hongos gelatinosos "Tremella spp.")',07,0712);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071290,'Outros produtos e misturas hortícolas, secos, inclusive em pedaços ou fatias, trituradas ou em pó, sem qualquer outro preparo','Dried vegetables and mixtures of vegetables, whole, cut, sliced, broken or in powder, but not further prepared (excl. onions, mushrooms and truffles, not mixed)','Hortalizas, incl. "silvestres", mezclas de hortalizas, incl. "silvestres", secas, incl. las cortadas en trozos o en rodajas o las trituradas o pulverizadas, pero sin otra preparación (exc. cebollas, setas y demás hongos y trufas, sin mezclar entre sí)',07,0712);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071310,'Ervilhas (pisum sativum), secas, em grão, mesmo peladas ou partidas','Dried, shelled peas Pisum sativum, whether or not skinned or split','Guisantes "arvejas, chícharos" "Pisum sativum", secos, desvainados, aunque estén mondados o partidos',07,0713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071320,'Grão-de-bico, seco, em grão, mesmo pelado ou partido','Dried, shelled chickpeas garbanzos, whether or not skinned or split','Garbanzos secos desvainados, aunque estén mondados o partidos',07,0713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071331,'Feijões das espécies Vigna mungo (l.) Hepper ou Vigna radiata (l.) Wilczek, secos, em grão, mesmo pelados ou partidos','Dried, shelled beans of species Vigna mungo [L.] Hepper or Vigna radiata [L.] Wilczek, whether or not skinned or split','Judías "porotos, alubias, frijoles, fréjoles" de las especies "Vigna mungo L. Hepper" o "Vigna radiata [L.] Wilczek", secas y desvainadas, aunque estén mondadas o partidas',07,0713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071332,'Feijão adzuki (Phaseolus ou Vigna angularis), seco, em grão, mesmo pelado ou partido','Dried, shelled small red Adzuki beans Phaseolus or Vigna angularis, whether or not skinned or split','Judías "porotos, alubias, frijoles, fréjoles" Adzuki "Phaseolus", "Vigna angularis", seca y desvainada, aunque estén mondada o partida',07,0713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071333,'Feijão comum, seco, em grão, mesmo pelado ou partido','Dried, shelled kidney beans Phaseolus vulgaris, whether or not skinned or split','Judías "porotos, alubias, frijoles, fréjoles"  común "Phaseolus vulgaris", seca y desvainada, aunque estén mondada o partida',07,0713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071334,'Feijão-bambara (Vigna subterranea ou Voandzeia subterranea)','Bambara beans  (Vigna subterranea or Voandzeia subterranea)','Bambara groundnuts (Vigna subterranea subterranea or Voandzeia)',07,0713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071335,'Feijão-fradinho (Vigna unguiculata)','Cow peas  (Vigna unguiculata)','Caupí (Vigna unguiculata)',07,0713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071339,'Outros feijões (Vigna spp. ou Phaseolus spp.), secos, em grão, mesmo pelados ou partidos','Dried, shelled beans Vigna and Phaseolus, whether or not skinned or split (excl. beans of species Vigna mungo [L] Hepper or Vigna radiata [L.] Wilczek, small red Adzuki beans and kidney beans)','Judías "porotos, alubias, frijoles, fréjoles" de las especies "Vigna spp." y "Phaseolus spp.", secas y desvainadas, aunque estén mondadas o partidas (exc. judías "Vigna mungo L. Hepper" o "Vigna radiata L. Wilczek", judías Adzuki y judías común)',07,0713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071340,'Lentilhas secas, em grãos, mesmo peladas ou partidas','Dried, shelled lentils, whether or not skinned or split','Lentejas secas desvainadas, aunque estén mondadas o partidas',07,0713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071350,'Favas e fava forrageira, secas, em grãos, mesmo peladas ou partidas','Dried, shelled broad beans Vicia faba var. major and horse beans Vicia faba var. equina and Vicia faba var. minor, whether or not skinned or split','Habas "Vicia faba var. major", haba caballar "Vicia faba var. equina" y haba menor "Vicia faba var. minor", secas y desvainadas, aunque estén mondadas o partidas',07,0713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071360,'Feijão-guando (Cajanus cajan)','Pigeon peas  (Cajanus cajan)','Guando frijol (Cajanus cajan)',07,0713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071390,'Outros legumes de vagem, secos, em grãos, mesmo pelados ou partidos','Dried, shelled leguminous vegetables, whether or not skinned or split (excl. peas, chickpeas, beans, lentils, broad beans and horse beans)','Hortalizas de vaina secas desvainadas, incl. "silvestres", aunque estén mondadas o partidas (exc. guisantes "arvejas, chícharos", garbanzos, judías, lentejas, habas, haba caballar y haba menor)',07,0713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071410,'Raízes de mandioca cassava, frescas ou secas, mesmo cortadas em pedaços ou em pellets','Fresh, chilled, frozen or dried roots and tubers of manioc cassava, whether or not sliced or in the form of pellets','Raíces de mandioca "yuca", frescas, refrigeradas, congeladas o secas, incl. troceadas o en "pellets"',07,0714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071420,'Batatas-doces, frescas ou secas, mesmo cortadas em pedaços ou em pellets','Sweet potatoes, fresh, chilled, frozen or dried, whether or not sliced or in the form of pellets','Batatas "boniatos, camotes", frescas, refrigeradas, congeladas o secas, incl. troceadas o en "pellets"',07,0714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071430,'Inhames (dioscorea spp.)','Yams (Dioscorea spp.)','Ñame (Dioscorea spp.)',07,0714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071440,'Taros (colocasia spp.)','Taro (Colocasia spp.)','Taro (Colocasia spp.)',07,0714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071450,'Mangaritos (xanthosomo spp.)','Mangaritos (xanthosomo spp.)','Mangaritos (xanthosomo spp.)',07,0714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (071490,'Outras raízes ou tubérculos com elevado teor de fécula ou de inulina, frescos ou secos, mesmo em pedaços ou em pellets; medula de sagueiro','Roots and tubers of arrowroot, salep, Jerusalem artichokes and similar roots and tubers with high starch or inulin content, fresh, chilled, frozen or dried, whether or not sliced or in the form of pellets and sago pith (excl. manioc cassava and sweet pota','Raíces de arrurruz y de salep, aguaturmas "patacas" y raíces y tubérculos simil. ricos en fécula o en inulina, frescos, refrigerados, congelados o secos, incl. troceados o en "pellets", así como médula de sagú (exc. raíces de mandioca "yuca" y batatas "bo',07,0714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080111,'Cocos secos, mesmo sem casca ou ralados','Desiccated coconuts','Cocos, secos',08,0801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080112,'Cocos na casca interna (endocarpo)','Coconuts on the inner shell (endocarp)','Cocos en la capa interna (endocarpio)',08,0801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080119,'Cocos frescos, mesmo sem casca ou pelados','Fresh coconuts, whether or not shelled or peeled','Cocos, frescos, incl. sin cáscara o mondados',08,0801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080121,'Castanha-do-pará, fresca ou seca, com casca','Fresh or dried brazil nuts, in shell','Nueces del Brasil, frescas o secas, con cáscara',08,0801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080122,'Castanha-do-pará, fresca ou seca, sem casca','Fresh or dried brazil nuts, shelled','Nueces del Brasil, frescas o secas, sin cáscara',08,0801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080131,'Castanha de caju, fresca ou seca, com casca','Fresh or dried cashew nuts, in shell','Nueces de marañón [merey, cajuil, anacardo, "cajú"], frescas o secas, con cáscara',08,0801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080132,'Castanha de caju, fresca ou seca, sem casca','Fresh or dried cashew nuts, shelled','Nueces de marañón [merey, cajuil, anacardo, "cajú"], frescas o secas, sin cáscara',08,0801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080211,'Amêndoas frescas ou secas, com casca','Fresh or dried almonds in shell','Almendras, frescas o secas, con cáscara',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080212,'Amêndoas frescas ou secas, sem casca','Fresh or dried almonds, shelled and peeled','Almendras, frescas o secas, sin cáscara, incl. mondadas',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080221,'Avelãs (Corylus spp.) frescas ou secas, com casca','Fresh or dried hazelnuts or filberts Corylus spp., in shell','Avellanas "Corylus spp.", frescas o secas, con cáscara',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080222,'Avelãs (Corylus spp.) frescas ou secas, sem casca','Fresh or dried hazelnuts or filberts Corylus spp., shelled and peeled','Avellanas "Corylus spp.", frescas o secas, sin cáscara, incl. mondadas',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080231,'Nozes frescas ou secas, com casca','Fresh or dried walnuts in shell','Nueces de nogal, frescas o secas, con cáscara',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080232,'Nozes frescas ou secas, sem casca','Fresh or dried walnuts, shelled and peeled','Nueces de nogal, frescas o secas, sin cáscara, incl. mondadas',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080240,'Castanhas (Castanea spp.) frescas ou secas, mesmo sem casca ou peladas','Fresh or dried chestnuts Castanea spp., whether or not shelled or peeled','Castañas "Castanea spp.", frescas o secas, incl. sin cáscara o mondados',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080241,'Castanhas (castaneas spp.) com casca, frescas ou secas','Chestnuts (castaneas spp.) in shell, fresh or dried','Castañas (castaneas spp.) con cáscara, frescos o secos',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080242,'Castanhas (castaneas spp.), sem casca, frescas ou secas','Chestnuts (castaneas spp.), shelled, fresh or dried','Castañas (castaneas spp.), sin cáscara, frescas o secas',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080250,'Pistácios frescos ou secos, mesmo sem casca ou pelados','Fresh or dried pistachios, whether or not shelled or peeled','Pistachos, frescos o secos, incluso sin cáscara o mondados',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080251,'Pistácios, com casca, frescos ou secos','Pistachios in shell, fresh or dried','Pistachos con cáscara, frescos o secos',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080252,'Pistácios, sem casca, frescos ou secos','Pistachios, not shelled, fresh or dried','Pistachos sin cáscara, frescas o secas',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080260,'Nozes de macadâmia, frescas ou secas, mesmo sem casca ou peladas','Macadamia nuts, fresh or dried, whether or not shelled or peeled','Nueces de macadamia, frescas o secas, incl. sin cáscara o mondadas',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080261,'Nozes de macadâmia, com casca, frescas ou secas','Macadamia nuts, in shell, fresh or dried','Nueces de macadamia, con cáscara, frescos o secos',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080262,'Nozes de macadâmia, sem casca, frescas ou secas','Macadamia nuts, not shelled, fresh or dried','Nueces de macadamia, sin cáscara, frescos o secos',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080270,'Nozes de cola (cola spp.), frescas ou secas','Cola nuts (Cola spp.), fresh or dried','Cola nuts (Cola spp.), fresh or dried',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080280,'Nozes de areca (nozes de betele), frescas ou secas','Areca (betel nuts), fresh or dried','Areca (nueces de betel), frescos o secos',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080290,'Outras frutas de casca rija, frescas ou secas, mesmo sem casca ou peladas','Nuts, fresh or dried, whether or not shelled or peeled (excl. coconuts, Brazil nuts, cashew nuts, almonds, hazelnuts, walnuts, chestnuts Castania spp., pistachios and macadamia nuts)','Frutos de cáscara, frescos o secos, incl. sin cáscara o mondados (exc. cocos, nueces del Brasil, nueces de marañón [merey, cajuil, anacardo, "cajú"], almendras, avellanas, nueces de nogal, castañas y pistachos)',08,0802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080300,'Bananas frescas ou secas','Bananas, incl. plantains, fresh or dried','Bananas o plátanos, frescos o secos',08,0803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080310,'Bananas-da-terra, frescas ou secas','Bananas-da-terra, fresh or dried','Bananas-da-terra, frescos o secos',08,0803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080390,'Bananas frescas ou secas, exceto bananas-da-terra','Freh or dried bananas (except from subheading  0803.90)','Bananas frescas ou secas, exceto bananas-da-terra',08,0803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080410,'Tâmaras frescas ou secas','Fresh or dried dates','Dátiles, frescos o secos',08,0804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080420,'Figos frescos ou secos','Fresh or dried figs','Higos, frescos o secos',08,0804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080430,'Abacaxis frescos ou secos','Fresh or dried pineapples','Piñas "ananás", frescas o secas',08,0804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080440,'Abacates frescos ou secos','Fresh or dried avocados','Aguacates "paltas", frescos o secos',08,0804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080450,'Goiabas, mangas e mangostões, frescos ou secos','Fresh or dried guavas, mangoes and mangosteens','Guayabas, mangos y mangostanes, frescos o secos',08,0804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080510,'Laranjas frescas ou secas','Fresh or dried oranges','Naranjas, frescas o secas',08,0805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080520,'Tangerinas, mandarinas, satsumas; clementinas, wilkings e outros cítricos híbridos e semelhantes, frescos ou secos','Fresh or dried mandarins incl. tangerines and satsumas, clementines, wilkings and similar citrus hybrids','Mandarinas, incl. las tangerinas y satsumas; clementinas, wilkings e híbridos simil. de agrios "cítricos", frescos o secos',08,0805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080530,'Limões e limas, frescos ou secos','fresh or dried lemons and sweet oranges','limones y limas,  frescos o secos',08,0805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080540,'Pomelos (grapefruit), frescos ou secos','Fresh or dried grapefruit','Toronjas o pomelos, frescos o secos',08,0805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080550,'Limões e limas, frescos ou secos','Fresh or dried lemons Citrus limon, Citrus limonum and limes Citrus aurantifolia, Citrus latifolia','Limones "Citrus limon, Citrus limonum" y limas "Citrus aurantifolia, Citrus latifolia", frescos o secos',08,0805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080590,'Outros cítricos frescos ou secos','Fresh or dried citrus fruit (excl. oranges, lemons Citrus limon, Citrus limonum, limes Citrus aurantifolia, Citrus latifolia, grapefruit, mandarins, incl. tangerines and satsumas, clementines, wilkings and similar citrus hybrids)','Agrios "cítricos", frescos o secos (exc. naranjas, limones "Citrus limon, Citrus limonum", limas "Citrus aurantifolia, Citrus latifolia", toronjas, pomelos, mandarinas, incl. las tangerinas y satsumas, clementinas, wilkings e híbridos simil. de agrios "cí',08,0805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080610,'Uvas frescas','Fresh grapes','Uvas frescas',08,0806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080620,'Uvas secas','Dried grapes','Uvas secas, incl. las pasas',08,0806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080711,'Melancias frescas','Fresh watermelons','Sandías, frescas',08,0807);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080719,'Melões frescos','Fresh melons (excl. watermelons)','Melones, frescos (exc. sandías)',08,0807);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080720,'Mamões (papaias) frescos','Fresh pawpaws papayas','Papayas, frescas',08,0807);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080810,'Maçãs frescas','Fresh apples','Manzanas, frescas',08,0808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080820,'Pêras e marmelos frescos','Fresh pears and quinces','Peras y membrillos, frescos',08,0808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080830,'Pêras, frescas','Pears, fresh','Peras, frescas',08,0808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080840,'Marmelos, frescos','Quinces, fresh','Membrillos, frescos',08,0808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080910,'Damascos frescos','Fresh apricots','Albaricoques "damascos, chabacanos", frescos',08,0809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080920,'Cerejas frescas','Fresh cherries','Cerezas, frescas',08,0809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080921,'Cerejas-ácidas (prunus cerasus), frescas','Sour-cherry (prunus cerasus), fresh','Sour-cerezo (Prunus cerasus), frescas',08,0809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080929,'Outras cerejas, frescas','Other cherries, fresh','Otras cerezas, frescas',08,0809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080930,'Pêssegos, incluídos os brugnons e as nectarinas, frescos','Fresh peaches, including nectarines','Melocotones "duraznos", incl. los griñones y las nectarinas, frescos',08,0809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (080940,'Ameixas e abrunhos, frescos','Fresh plums and sloes','Ciruelas y endrinas, frescas',08,0809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081010,'Morangos frescos','Fresh strawberries','Fresas "frutillas", frescas',08,0810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081020,'Framboesas, amoras e amoras-framboesas, frescas','Fresh raspberries, blackberries, mulberries and loganberries','Frambuesas, zarzamoras, moras y moras-frambuesa, frescas',08,0810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081030,'Groselhas frescas, inclusive o "cassis"','Fresh currant, including the "cassis"','Grosellas frescas, incluido el casis',08,0810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081040,'Airelas, mirtilos e outras frutas do gênero vaccinium, frescos','Fresh cranberries, bilberries and other fruits of the genus Vaccinium','Arándanos rojos, mirtilos y demás frutos del género "Vaccinium", frescos',08,0810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081050,'Quivis (kiwis), frescos','Fresh kiwifruit','Kiwis, frescos',08,0810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081060,'Duriões frescos','Fresh durians','Duriones, frescos',08,0810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081070,'Caquis (diospiros), frescos','Persimmons (Persimmons), fresh','Caquis (caquis), frescos',08,0810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081090,'Outras frutas frescas','Other fresh fruits','Otras frutas frescas',08,0810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081110,'Morangos congelados, não cozidos ou cozidos em água ou vapor, mesmo adicionados de açúcar ou de outros edulcorantes','Frozen strawberries, uncooked or cooked by steaming or boiling in water, whether or not sweetened','Fresas "frutillas", sin cocer o cocidas en agua o vapor, congeladas, con adición de azúcar u otro edulcorante',08,0811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081120,'Framboesas, amoras, groselhas, congeladas, não cozidas ou cozidas em água ou vapor, mesmo adicionadas de açúcar ou de outros edulcorantes','Frozen raspberries, blackberries, mulberries, loganberries, black-, white- or red currants and gooseberries, uncooked or cooked by steaming or boiling in water, whether or not sweetened','Frambuesas, zarzamoras, moras, moras-frambuesa y grosellas, sin cocer o cocidas en agua o vapor, congeladas, incl. con adición de azúcar u otro edulcorante',08,0811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081190,'Outras frutas congeladas, não cozidas ou cozidas em água ou vapor, mesmo adicionadas de açúcar ou de outros edulcorantes','Frozen fruit and nuts, uncooked or cooked by steaming or boiling in water, whether or not sweetened (excl. strawberries, raspberries, blackberries, mulberries, loganberries, black, white or red currants and gooseberries)','Frutos comestibles, sin cocer o cocidos en agua o vapor, congelados, incl. con adición de azúcar u otro edulcorante (exc. fresas "frutillas", frambuesas, zarzamoras, moras, moras-frambuesa y grosellas)',08,0811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081210,'Cerejas conservadas transitoriamente, mas impróprias para alimentação neste estado','Cherries, provisionally preserved, e.g. by sulphur dioxide gas, in brine, in sulphur water or in other preservative solutions, but unsuitable in that state for immediate consumption','Cerezas conservadas provisionalmente, p.ej. con gas sulfuroso o con agua salada o sulfurosa o adicionada de otras sustancias para dicha conservación, pero todavía impropias para la alimentación',08,0812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081220,'Morangos conservados em água salgada, sulfurada, etc.','Strawberry preserved in brine, in sulphur water, etc','Fresas conservadas en agua salada, sulforosa, etc',08,0812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081290,'Outras frutas conservadas transitoriamente, mas impróprias para alimentação neste estado','Fruit and nuts, provisionally preserved, e.g. by sulphur dioxide gas, in brine, in sulphur water or in other preservative solutions, but unsuitable in that state for immediate consumption (excl. cherries)','Frutas y otros frutos conservados provisionalmente, p.ej. con gas sulfuroso o con agua salada o sulfurosa o adicionada de otras sustancias para dicha conservación, pero todavía impropios para la alimentación (exc. cerezas)',08,0812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081310,'Damascos secos','Dried apricots','Albaricoques "damascos, chabacanos", secos',08,0813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081320,'Ameixas secas','Dried prunes','Ciruelas, secas',08,0813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081330,'Maçãs secas','Dried apples','Manzanas, secas',08,0813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081340,'Pêras e outras frutas secas','Dried peaches, pears, papaws papayas, tamarinds and other edible fruits (excl. nuts, bananas, dates, figs, pineapples, avocados, guavas, mangoes, mangosteens, citrus fruit, grapes apricots, prunes and apples, unmixed)','Melocotones, incl. los griñones y nectarinas, peras, papayas, tamarindos y demás frutos comestibles, secos (exc. frutos de cáscara, bananas o plátanos, dátiles, higos, piñas "ananás", aguacates "paltas", guayabas, mangos y mangostanes, agrios "cítricos", ',08,0813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081350,'Misturas de frutas secas ou de frutas de casca rija','Mixtures of nuts or dried fruits','Mezclas de frutos secos comestibles o de frutos de cáscara comestibles',08,0813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (081400,'Cascas de cítricos, de melões ou de melancias, frescas, secas, congeladas ou conservadas temporariamente','Peel of citrus fruit or melons, incl. watermelons, fresh, frozen, dried or provisionally preserved in brine, or in water with other additives','Cortezas de agrios "cítricos", de melones o sandías, frescas, congeladas, secas o presentadas en agua salada, sulfurosa o adicionada de otras sustancias para su conservación provisional',08,0814);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090111,'Café não torrado, não descafeinado','Coffee (excluding roasted and decaffeinated)','Café sin tostar ni descafeinar',09,0901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090112,'Café não torrado, descafeinado','Decaffeinated coffee (excluding roasted)','Café descafeinado sin tostar',09,0901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090121,'Café torrado, não descafeinado','Roasted coffee (excluding decaffeinated)','Café tostado sin descafeinar',09,0901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090122,'Café torrado, descafeinado','Roasted, decaffeinated coffee','Café tostado descafeinado',09,0901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090190,'Cascas, películas de café e sucedâneos do café','Coffee husks and skins; coffee substitutes containing coffee in any proportion','Cáscara y cascarilla de café; sucedáneos de café que contengan café en cualquier proporción',09,0901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090210,'Chá verde (não fermentado), em embalagens imediatas <= 3 kg','Green tea in immediate packings of <= 3 kg','Té verde sin fermentar, presentado en envases inmediatos con un contenido <= 3 kg',09,0902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090220,'Chá verde (não fermentado), apresentado em qualquer outra forma','Green tea in immediate packings of > 3 kg','Té verde sin fermentar, presentado en envases inmediatos con un contenido > 3 kg',09,0902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090230,'Chá preto (fermentado ou parcialmente fermentado), em embalagens imediatas <= 3 kg','Black fermented tea and partly fermented tea, whether or not flavoured, in immediate packings of <= 3 kg','Té negro fermentado y té parcialmente fermentado, incl. aromatizado, presentado en envases inmediatos con un contenido <= 3 kg',09,0902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090240,'Chá preto (fermentado ou parcialmente fermentado) apresentado em qualquer outra forma','Black fermented tea and partly fermented tea, whether or not flavoured, in immediate packings of > 3 kg','Té negro fermentado y té parcialmente fermentado, incl. aromatizado, presentado en envases inmediatos con un contenido > 3 kg',09,0902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090300,'Mate','Mate','Yerba mate',09,0903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090411,'Pimenta (do gênero piper), seca, não triturada nem em pó','Pepper of the genus Piper, neither crushed nor ground','Pimienta del género "Piper" sin triturar ni pulverizar',09,0904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090412,'Pimenta (do gênero piper), triturada ou em pó','Pepper of the genus Piper, crushed or ground','Pimienta del género "Piper", triturada o pulverizada',09,0904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090420,'Pimentões e pimentas, dos gêneros capsicum ou pimenta, secos ou triturados ou em pó','Fruits of the genus Capsicum or of the genus Pimenta, dried or crushed or ground','Frutos de los géneros "Capsicum" o "Pimenta", secos, triturados o pulverizados',09,0904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090421,'Pimentões e pimentas, secos, não triturados nem em pó','Pimenta, neither crushed nor ground','Pimenta, sin triturar ni pulverizar',09,0904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090422,'Pimentões e pimentas, triturados ou em pó','Pimenta, crushed or powdered','Pimenta,  triturarado o pulverizado',09,0904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090500,'Baunilha','Vanilla','Vainilla',09,0905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090510,'Baunilha, não triturada nem em pó','Vanilla, not crushed or powdered','Vainilla, no triturados o pulverizados',09,0905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090520,'Baunilha, triturada ou em pó','Vanilla, crushed or powdered','Aplastado vainilla, o en polvo',09,0905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090610,'Canela e flores de caneleira, não trituradas nem em pó','Cinnamon and cinnamon-tree flowers (neither crushed nor in powder)','Canela y flores de canelero,  sin triturar ni pulverizar',09,0906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090611,'Canela (Cinnamomum zeylanicum blume), não triturada nem em pó','Cinnamon Cinnamomum eylanicum Blume (excl. crushed and ground)',' Canela (Cinnamomum zeylanicum blume), sin triturar ni pulverizar',09,0906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090619,'Outras canelas e flores de caneleira, não trituradas nem em pó','Cinnamon and cinnamon-tree flowers (excl. cinnamon Cinnamomum eylanicum Blume and crushed and ground cinnamon)','Canelas y flores de espinillera, sin triturar ni pulverizar (exc. Cinnamomum zeylanicum blume)',09,0906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090620,'Canela e flores de caneleira, trituradas ou em pó','Crushed or ground cinnamon and cinnamon-tree flowers','Canela y flores de canelero, trituradas o pulverizadas',09,0906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090700,'Cravo-da-índia (frutos, flores e pedúnculos)','Cloves (whole fruit, cloves and stems)','Clavo (frutos, clavillos y pedúnculos)',09,0907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090710,'Cravo-da-índia (frutos,flores e pedun.) não triturados nem em pó','Clove (fruit, flowers and pedun.) neither crushed nor ground','Clavo (frutas, flores y pedun.) sin triturar ni pulverizar',09,0907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090720,'Cravo-da-índia(frutos,flores e pedun.) triturado ou em pó','Clove (fruit, flowers and pedun.) crushed or ground','Clavo (frutas, flores y pedun.) triturados o pulverizados',09,0907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090810,'Noz-moscada','Nutmeg','Nuez moscada',09,0908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090811,'Noz-moscada, não triturada nem em pó','Nutmeg, not crushed or powdered','Nuez moscada, no triturados o pulverizados',09,0908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090812,'Noz-moscada, triturada ou em pó','Nutmeg, crushed or powdered','Nuez moscada, triturados o pulverizados',09,0908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090820,'Macis','Mace','Macis',09,0908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090821,'Macis, não triturado nem em pó','Mace, neither crushed nor ground','Mace, sin triturar ni pulverizar',09,0908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090822,'Macis, triturado ou em pó','Mace, crushed or powdered','Mace, triturados o pulverizados',09,0908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090830,'Amomos e cardamomos','Cardamoms','Amomos y cardamomos',09,0908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090831,'Amomos e cardamomos, não triturado nem em pó','Amomos and cardamoms, neither crushed nor ground','Amomos y cardamomos, sin triturar ni pulverizar',09,0908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090832,'Amomos e cardamomos, triturados ou em pó','Amomos and cardamoms, crushed or powdered','Amomos y cardamomos, triturados o pulverizados',09,0908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090910,'Sementes de anis (anis verde) ou de badiana','Seeds of anise or badian','Semillas de anís o badiana',09,0909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090920,'Sementes de coentro','Coriander seeds','Semillas de cilantro',09,0909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090921,'Sementes de coentro, não trituradas nem em pó','Coriander seeds, not crushed nor ground','Semillas de cilantro, sin triturar ni pulverizar',09,0909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090922,'Sementes de coentro, trituradas ou em pó','Coriander seeds, crushed or powdered','Semillas de cilantro, triturados o pulverizados',09,0909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090930,'Sementes de cominho','Cumin seeds','Semillas de comino',09,0909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090931,'Sementes de cominho, não trituradas nem em pó','Cumin seeds, not crushed nor ground','Semillas de comino, sin triturar ni pulverizar',09,0909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090932,'Sementes de cominho, trituradas ou em pó','Cumin seeds, crushed or powdered','Semillas de comino, triturados o pulverizados',09,0909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090940,'Sementes de alcaravia','Caraway seeds','Semillas de alcaravea',09,0909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090950,'Sementes de funcho e bagas de zimbro','Seeds of fennel; juniper berries','Semillas de hinojo; bayas de enebro',09,0909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090961,'Sementes de anis, badiana, funcho ou alcaravia; bagas de zimbro: não triturado nem em pó','Seeds of anise, badian, caraway, or fennel; juniper berries: neither crushed nor ground','Semillas de anís, badiana, hinojo o comino, enebro, sin triturar ni pulverizar',09,0909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (090962,'Sementes de anis, badiana, funcho ou alcaravia; bagas de zimbro: triturado ou em pó','Seeds of anise, badian, caraway, or fennel; juniper berries: crushed or ground','Semillas de anís, badiana, hinojo o comino, enebro, triturarada o pulverizarizada',09,0909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (091010,'Gengibre','Ginger','Jengibre',09,0910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (091011,'Gengibre, não triturado nem em pó','Ginger, neither crushed nor ground','Jengibre, sin triturar ni pulverizar',09,0910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (091012,'Gengibre, triturado ou em pó','Ginger, crushed or ground','Jengibre, triturada o pulverizada',09,0910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (091020,'Açafrão','Saffron','Azafrán',09,0910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (091030,'Açafrão-da-terra (curcuma)','Turmeric curcuma','Cúrcuma',09,0910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (091040,'Tomilho e louro','Thyme and bay leaves','Tomillo y hoja de laurel',09,0910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (091050,'Caril','Other spices','Curry',09,0910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (091091,'Misturas de especiarias','Mixtures of different types of spices','Mezclas de especias diversas',09,0910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (091099,'Outras especiarias','Spices (excl. pepper of the genus Piper, fruit of the genus Capsicum or of the genus Pimenta, vanilla, cinnamon, cinnamontree flowers, clove wholefruit, clove stems, nutmeg, mace, cardamoms, seeds of anise, badian, fennel, coriander, cumin and caraway, an','Especias (exc. pimienta del género "Piper"; pimientos de los géneros "Capsicum" o "Pimenta"; vainilla; canela y flores de canelero; clavo "frutos, clavillos y pedúnculos"; nuez moscada, macis, amomos y cardamomos; semillas de anís, badiana, hinojo, cilant',09,0910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100110,'Trigo duro','Durum wheat','Trigo duro',10,1001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100111,'Trigo duro, para semeadura','Durum wheat for sowing','Trigo duro para siembra',10,1001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100119,'Trigo duro, exceto para semeadura','Durum wheat, except for sowing','Trigo duro, excepto para siembra',10,1001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100190,'Trigo (exceto trigo duro) e mistura de trigo com centeio','Wheat and meslin (excluding  durum wheat)','Escanda, trigo blando y morcajo "tranquillón"',10,1001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100191,'Outros  trigos e misturas de trigo com centeio, para semeadura','Other wheat and mixed wheat and rye, for sowing','Otros tipos de trigo y el trigo con centeno, para la siembra',10,1001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100199,'Outros  trigos e misturas de trigo com centeio, exceto para semeadura','Other wheat and mixed wheat and rye, except for sowing','Otros tipos de trigo y el trigo con centeno, excepto para la siembra',10,1001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100200,'Centeio','Rye','Centeno',10,1002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100210,'Centeio, para semeadura','Rye, for sowing','Centeno, para siembra',10,1002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100290,'Centeio, exceto para semeadura','Rye, except for sowing','Centeno, exceto para siembra',10,1002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100300,'Cevada','Barley','Cebada',10,1003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100310,'Cevada, para semeadura','Barley, for sowing','Cevada, para semeadura',10,1003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100390,'Cevada, exceto para semeadura','Barley,  except for sowing','Cebada, excepto para siembra',10,1003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100400,'Aveia','Oats','Avena',10,1004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100410,'Aveia, para semeadura','Oats, for sowing','Avena, para siembra',10,1004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100490,'Aveia, exceto para semeadura','Oats, except for sowing','Avena, escepto para siembra',10,1004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100510,'Milho para semeadura','Maize seed','Maíz, para siembra',10,1005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100590,'Milho, exceto para semeadura','Maize (excl. seed)','Maíz (exc. para siembra)',10,1005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100610,'Arroz (paddy) com casca','Rice in the husk, paddy or rough','Arroz con cáscara o arroz "paddy"',10,1006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100620,'Arroz (cargo ou castanho), descascado','Husked or brown rice','Arroz descascarillado "arroz cargo" o "arroz pardo"',10,1006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100630,'Arroz semibranqueado ou branqueado, mesmo polido ou brunido (glaceado)','Semi-milled or wholly milled rice, whether or not polished or glazed','Arroz semiblanqueado o blanqueado, incl. pulido o glaseado',10,1006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100640,'Arroz quebrado (trinca de arroz)','Broken rice','Arroz partido',10,1006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100700,'Sorgo em grão','Grain sorghum','Sorgo grano',10,1007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100710,'Sorgo de grão, para semeadura','Grain sorghum, for sowing','El sorgo grano, para siembra',10,1007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100790,'Sorgo de grão, exceto para semeadura','Grain sorghum, except for sowing','El sorgo grano, excepto para siembra',10,1007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100810,'Trigo mourisco','Buckwheat','Alforfón',10,1008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100820,'Painço','Millet (excl. grain sorghum)','Mijo(exc. sorgo para grano)',10,1008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100821,'Painço, para semeadura','Millet, for sowing','Painco, para siembra',10,1008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100829,'Painço, exceto para semeadura','Millet, except for sowing','Painco, excepto para siembra',10,1008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100830,'Alpiste','Canary seed','Alpiste',10,1008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100840,'Milhã (Digitaria spp.)','Fonio (Digitaria spp.)','Cornualles (Digitaria spp.)',10,1008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100850,'Quinoa (Chenopodium quinoa)','Quinoa (Chenopodium quinoa)','Quinoa (Chenopodium quinoa)',10,1008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100860,'Triticale','Triticale','Triticale',10,1008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (100890,'Outros cereais','Cereals (excl. wheat and meslin, rye, barley, oats, maize, rice, buckwheat, millet, canary seed and grain sorghum)','Cereales (exc. trigo y morcajo o tranquillón, centeno, cebada, avena, maíz, arroz, alforfón, mijo, alpiste y sorgo para grano)',10,1008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110100,'Farinhas de trigo ou de mistura de trigo com centeio','Wheat or meslin flour','Harina de trigo y de morcajo "tranquillón"',11,1101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110210,'Farinha de centeio','Rye flour','Harina de centeno',11,1102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110220,'Farinha de milho','Maize corn flour','Harina de maíz',11,1102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110230,'Farinha de arroz','Rice flour','Harina de arroz',11,1102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110290,'Farinha de outros cereais','Cereal flours (excl. wheat, meslin, rye and maize)','Harina de cereales (exc. trigo y morcajo "tranquillón", centeno, maíz y arroz)',11,1102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110311,'Grumos e sêmolas, de trigo','Groats and meal of wheat','Grañones y sémola, de trigo',11,1103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110312,'Grumos e sêmolas, de aveia','Oats groats and meal','Grañones y sémolas,  de avena',11,1103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110313,'Grumos e sêmolas, de milho','Groats and meal of maize corn','Grañones y sémola, de maíz',11,1103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110314,'Grumos e sêmolas, de arroz','Rice groats and meal','Grañones y sémolas,  de arroz',11,1103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110319,'Grumos e sêmolas, de outros cereais','Groats and meal of cereals (excl. wheat and maize)','Grañones y sémolas, de cereales (exc. trigo y maíz)',11,1103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110320,'Pellets de cereais','Cereal pellets','Pellets',11,1103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110321,'Pellets de trigo','Wheat pellets','Pellets de trigo',11,1103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110329,'Pellets de outros cereais','Other cereals pellets','Pellets de demás cereales',11,1103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110411,'Grãos de cevada, esmagados ou em flocos','Cereal grains, rolled or flaked','Granos de cebada,  aplastados o en copos',11,1104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110412,'Grãos de aveia, esmagados ou em flocos','Rolled or flaked grains of oats','Granos de avena aplastados o en copos',11,1104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110419,'Grãos de outros cereais, esmagados ou em flocos','Rolled or flaked grains of cereals (excl. barley and oats)','Granos de cereales aplastados o en copos (exc. de cebada y avena)',11,1104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110421,'Grãos de cevada, descascados, em perolas, cortados, etc.','Barley grains,  peeled,  pearled,  cut,  etc','Granos de cebada, descascarillados, perlados, cortados, etc',11,1104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110422,'Grãos de aveia trabalhados (descascados, em pérolas, cortados ou partidos)','Hulled, pearled, sliced, kibbled or otherwise worked oat grains (excl. oat flour)','Granos de avena mondados, perlados, troceados, quebrantados o trabajados de otro modo (exc. harina de avena)',11,1104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110423,'Grãos de milho trabalhados (descascados, em pérolas, cortados ou partidos)','Hulled, pearled, sliced, kibbled or otherwise worked maize grains (excl. maize flour)','Granos de maíz mondados, perlados, troceados, quebrantados o trabajados de otro modo (exc. harina de maíz)',11,1104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110429,'Grãos de outros cereais trabalhados (descascados, em pérolas, cortados ou partidos)','Grains of cereals, hulled, pearled, sliced, kibbled or otherwise worked (excl. oats and maize, grain flour and husked and semi- or wholly milled rice and broken rice)','Granos de cereales, mondados, perlados, troceados, quebrantados o trabajados de otro modo (exc. de avena o maíz y harina de cereales, y arroz mondado y aplastado total o parcialmente, así como arroz partido)',11,1104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110430,'Germes de cereais, inteiros, esmagados, em flocos ou moídos','Germ of cereals, whole, rolled, flaked or ground','Germen de cereales entero, aplastado, en copos o molido',11,1104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110510,'Farinha, sêmola e pó, de batata','Flour, meal and powder of potatoes','Harina, sémola y polvo de patata "papa"',11,1105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110520,'Flocos, grânulos e pellets, de batata','Flakes, granules and pellets of potatoes','Copos, gránulos y "pellets" de patata "papa"',11,1105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110610,'Farinhas, sêmolas e pós, dos legumes de vagem, secos, da posição 0713','Flour, meal and powder of peas, beans, lentils and the other dried leguminous vegetables of heading 0713','Harina, sémola y polvo de guisantes "arvejas, chícharos", garbanzos, judías, lentejas y otras hortalizas de vaina secas de la partida 0713',11,1106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110620,'Farinhas, sêmolas e pós, de sagu ou de raízes e tubérculos da posição 0714','Flour, meal and powder of sago or of roots or tubers of manioc, arrowroot, salep, sweet potatoes and similar roots and tubers with a high content of starch or inulin of heading 0714','Harina, sémola y polvo de sagú y de raíces de mandioca "yuca", arrurruz, salep, aguaturmas "patacas", batatas "boniatos, camotes"" y tubérculos simil. ricos en fécula o en inulina de la partida 0714',11,1106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110630,'Farinhas, sêmolas e pós de frutas (dos produtos do capítulo 8)','Flour, meal and powder of produce of chapter 8 Edible fruit and nuts','Harina, sémola y polvo de los productos del capítulo 8 "frutos comestibles; cortezas de agrios "cítricos",  de melones o de sandías"',11,1106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110710,'Malte não torrado','Malt (excluding roasted)','Malta "de cebada u otros cereales", sin tostar',11,1107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110720,'Malte torrado','Roasted malt','Malta "de cebada u otros cereales", tostada',11,1107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110811,'Amido de trigo','Wheat starch','Almidón de trigo',11,1108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110812,'Amido de milho','Maize starch','Almidón de maíz',11,1108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110813,'Fécula de batata','Potato starch','Fécula de patata "papa"',11,1108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110814,'Fécula de mandioca','Manioc starch','Fécula de mandioca "yuca"',11,1108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110819,'Outros amidos e féculas','Starch (excl. wheat, maize, potato and manioc)','Almidones y féculas (exc. de trigo, maíz, patata "papa" y mandioca "yuca")',11,1108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110820,'Inulina','Inulin','Inulina',11,1108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (110900,'Glúten de trigo, mesmo seco','Wheat gluten, whether or not dried','Gluten de trigo, incl. seco',11,1109);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120100,'Soja, mesmo triturada','Soya beans, whether or not broken','Habas "porotos, frijoles, fréjoles" de soja "soya",  incl. quebrantadas',12,1201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120110,'Soja, mesmo triturada, para semeadura','Soya beans, whether or not broken, for sowing','La soja, incluso quebrantadas, para siembra',12,1201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120190,'Soja, mesmo triturada, exceto para semeadura','Soya beans, whether or not broken, except for sowing','La soja, incluso quebrantadas, excepto para siembra',12,1201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120210,'Amendoins com casca, não torrados nem de outro modo cozidos','Groundnuts in shell, not roasted or otherwise cooked','Cacahuetes "cacahuetes, maníes" sin tostar ni cocer de otro modo, con cáscara',12,1202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120220,'Amendoins descascados, mesmo não triturados, não torrados nem de outro modo cozidos','Shelled groundnuts, whether or not broken (excl. roasted or otherwise cooked)','Cacahuetes "cacahuetes, maníes" sin tostar ni cocer de otro modo, sin cáscara, incl. quebrantados',12,1202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120230,'Amendoins, não torrados nem cozidos, para semeadura','Groundnuts, not roasted or cooked, for sowing','Cacahuetes sin tostar ni cocer, para siembra',12,1202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120241,'Amendoins com casca, não torrados nem cozidos','Peanuts in shell, not roasted or cooked','Cacahuetes con cáscara sin tostar ni cocer',12,1202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120242,'Amendoins descascados, mesmo triturados','Ground-nuts shelled, whether or not broken','Cacahuetes sin cáscara, incluso quebrantados',12,1202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120300,'Copra em grãos','Copra','Copra',12,1203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120400,'Sementes de linho (linhaça), mesmo trituradas','Linseed, whether or not broken','Semilla de lino, incl. quebrantada',12,1204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120500,'Sementes de nabo silvestre ou de colza, mesmo trituradas','Rape or colza seeds, whether or not broken','Semillas de nabo, incluso quebrantados',12,1205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120510,'Sementes de nabo silvestre ou de colza, com baixo teor de ácido erúcico, mesmo trituradas','Low erucic acid rape or colza seeds yielding a fixed oil which has an erucic acid content of < 2% and yielding a solid component of glucosinolates of < 30 micromoles/g','Semillas de nabo "nabina" o de colza con bajo contenido de ácido erúcico "de las que se obtiene un aceite fijo con un contenido de ácido erúcico < 2% en peso y un componente sólido con un contenido de glucosinolatos < 30 micromol/g"',12,1205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120590,'Outras sementes de nabo silvestre ou de colza, mesmo trituradas','High erucic rape or colza seeds yielding a fixed oil which has an erucic acid content of >= 2% and yielding a solid component of glucosinolates of >= 30 micromoles/g, whether or not broken','Semillas de nabo "nabina" o de colza con alto contenido de ácido erúcico "de las que se obtiene un aceite fijo con un contenido de ácido erúcico >= 2% en peso y un componente sólido con un contenido de glucosinolatos >= 30 micromol/g", incl. quebrantadas',12,1205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120600,'Sementes de girassol, mesmo trituradas','Sunflower seeds, whether or not broken','Semilla de girasol, incl. quebrantada',12,1206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120710,'Nozes e amêndoas de palma (palmiste)','Palm nuts and kernels','Frutos secos y aceite de palma (palma)',12,1207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120720,'Sementes de algodão, mesmo trituradas','Cotton seeds, whether or not broken','Semilla de algodón, incl. quebrantada',12,1207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120721,'Sementes de algodão, para semeadura','Cotton seeds, for sowing','Semillas de algodón, para siembra',12,1207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120729,'Sementes de algodão, exceto para semeadura','Cotton seeds, except for sowing','Semillas de algodón, excepto para siembra',12,1207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120730,'Sementes de rícino','Castor oil seeds','Semilla de ricino',12,1207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120740,'Sementes de gergelim, mesmo trituradas','Sesamum seeds, whether or not broken','Semilla de sésamo "ajonjolí", incl. quebrantada',12,1207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120750,'Sementes de mostarda, mesmo trituradas','Mustard seeds, whether or not broken','Semilla de mostaza, incl. quebrantada',12,1207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120760,'Sementes de cártamo (Carthamus tinctorius)','Safflower (Carthamus tinctorius) seeds','Semilla de cártamo (Carthamus tinctorius)',12,1207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120770,'Sementes de melão','Melon seeds','Semillas de melón',12,1207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120791,'Sementes de dormideira ou papoula, mesmo trituradas','Poppy seeds, whether or not broken','Semilla de amapola "adormidera", incl. quebrantada',12,1207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120792,'Sementes de "Karite"','Seeds of "Shea"','Semillas de "Shea"',12,1207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120799,'Outras sementes e frutos oleaginosos, mesmo triturados','Oil seeds and oleaginous fruits, whether or not broken (excl. edible nuts, olives, soya beans, groundnuts, copra, linseed, rape or colza seeds, sunflower seeds, cotton, sesamum, mustard and poppy seeds)','Semillas y frutos oleaginosos, incl. quebrantados (exc. frutos de cáscara comestibles, aceitunas, habas de soja "soya", cacahuetes "maníes", copra, semilla de lino, semilla de nabo "de nabina" o de colza, semilla de girasol, nuez y almendra de palma y sem',12,1207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120810,'Farinha de soja','Soya bean flour and meal','Harina de habas de soja "soya"',12,1208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120890,'Farinhas de outras sementes ou de frutos oleaginosos','Flours and meal of oil seeds or oleaginous fruit (excl. soya and mustard)','Harina de semillas o de frutos oleaginosos (exc. harina de mostaza y de habas de soja "soya")',12,1208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120910,'Sementes de beterraba sacarina, para semeadura','Sugar beet seed, for sowing','Semilla de remolacha azucarera, para siembra',12,1209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120911,'Sementes de beterraba sacarina, para semeadura','Sugar beet seeds, for sowing','Semillas de remolacha azucarera,  para siembra',12,1209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120919,'Sementes de outras beterrabas, para semeadura','Other beet seeds, for sowing','Semillas de demás remolachas,  para siembra',12,1209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120921,'Sementes de alfafa (luzerna), para semeadura','Alfalfa seed for sowing','Semilla de alfalfa, para siembra',12,1209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120922,'Sementes de trevo (Trifolium spp.), para semeadura','Clover Trifolium spp seed, for sowing','Semilla de trébol "Trifolium spp.", para siembra',12,1209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120923,'Sementes de festuca, para semeadura','Fescue seed for sowing','Semilla de festucas, para siembra',12,1209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120924,'Sementes de pasto dos prados de Kentucky, para semeadura','Kentucky blue grass Poa pratensis L. seed for sowing','Semilla de pasto azul de Kentucky "Poa pratensis L.", para siembra',12,1209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120925,'Sementes de azevém, para semeadura','Ryegrass Lolium multiflorum lam., Lolium perenne L. seed, for sowing','Semilla de ballico "Lolium multiflorum Lam.", "Lolium perenne L.", para siembra',12,1209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120926,'Sementes de fleolo dos prados, para semeadura','Timothy grass seeds, for sowing','Semillas de fleo de los prados,  para siembra',12,1209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120929,'Outras sementes forrageiras, para semeadura','Seeds of forage plants for sowing (excl. of cereals and of sugar beet, alfalfa, clover Trifolium spp., fescue, Kentucky blue grass Poa pratensis L. and ryegrass Lolium multiflorum lam. and Lolium perenne L.)','Semillas forrajeras, para siembra (exc. de cereales, de remolacha azucarera, de alfalfa, de trébol "Trifolium spp.", de festucas, de pasto azul de Kentucky "Poa pratensis L.", de ballico "Lolium multiflorum Lam." y "Lolium perenne L." y de fleo de los pra',12,1209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120930,'Sementes de plantas herbáceas, cultivadas especialmente pelas suas flores, para semeadura','Seeds of herbaceous plants cultivated mainly for flowers, for sowing','Semillas de plantas herbáceas utilizadas principalmente por sus flores, para siembra',12,1209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120991,'Sementes de produtos hortícolas, para semeadura','Vegetable seeds, for sowing','Semillas de hortalizas, para siembra',12,1209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (120999,'Outras sementes, frutos e esporos, para semeadura','Seeds, fruits and spores, for sowing (excl. leguminous vegetables and sweetcorn, coffee, tea, maté and spices, cereals, oil seeds and oleaginous fruits, beets, forage plants, vegetable seeds, and seeds of herbaceous plants cultivated mainly for flowers or','Semillas, frutos y esporas, para siembra (exc. legumbres, maíz dulce, café, té, yerba mate y especias, cereales, semillas y frutos oleaginosos, remolachas, semillas forrajeras, semillas de hortalizas, semillas de plantas herbáceas utilizadas principalment',12,1209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121010,'Cones de lúpulo, frescos ou secos, não triturados, nem moídos, nem em pellets','Hop cones, fresh or dried (excl. ground, powdered or in the form of pellets)','Conos de lúpulo, frescos o secos (exc. quebrantados, molidos o en "pellets")',12,1210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121020,'Cones de lúpulo, triturados, moídos ou em pellets, lupulina','Hop cones, ground, powdered or in the form of pellets; lupulin','Conos de lúpulo, quebrantados, molidos o en "pellets"; lupulino',12,1210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121110,'Raízes de alcaçuz, frescas, secas, incl.cortadas, tritur.pó','Liquorice roots (fresh or dried)','Raíces de regaliz, frescas, secas, inc.cortad.tritur.polvo',12,1211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121120,'Raízes de ginseng, frescas ou secas, mesmo cortadas, trituradas ou em pó','Ginseng roots, fresh or dried, whether or not cut, crushed or powdered','Raíces de "ginseng", frescas o secas, incl. cortadas, trituradas o pulverizadas',12,1211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121130,'Folha de coca, fresca ou seca, mesmo cortada, triturada ou em pó, para utilização em perfumaria ou medicina','Coca leaf, fresh or dried, whether or not cut, crushed or powdered','Hojas de coca, frescas o secas, incl. cortadas, trituradas o pulverizadas',12,1211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121140,'Palha de papoula, fresca ou seca, mesmo cortada, triturada ou em pó, para utilização em perfumaria ou medicina','Poppy straw, fresh or dried, whether or not cut, crushed or powdered','Paja de adormidera, fresca o seca, incl. cortada, triturada o pulverizada',12,1211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121190,'Outras plantas, partes de plantas, sementes e frutos, frescos ou secos, mesmo cortados, triturados ou em pó, para uso em perfumaria, medicina ou como inseticidas, parasiticidas ou semelhantes','Plants, parts of plants, incl. seeds and fruits, used primarily in perfumery, in pharmacy or for insecticidal, fungicidal or similar purposes, fresh or dried, whether or not cut, crushed or powdered (excl. ginseng roots, coca leaf and poppy straw)','Plantas, partes de plantas, semillas y frutos de las especies utilizadas principalmente en perfumería, medicina o para usos insecticidas, parasiticidas o similares, frescos o secos, incl. cortados, triturados o pulverizados (exc. raíces de regaliz, raíces',12,1211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121210,'Alfarroba incl.sementes, frescas/refrig/cong/secas/em pó','Locust beans (Including locust bean seeds)','Algarrobas incl.semillas, frescas/refr/cong/secas/polvo',12,1212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121220,'Algas, frescas, refrigeradas, congeladas, ou secas, mesmo em pó','Seaweeds and other algae, fresh, chilled, frozen or dried, whether or not ground','Algas, frescas, refrigeradas, congeladas o secas, incl. pulverizadas',12,1212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121221,'Algas próprias para a alimentação humana','Algae  fit for human consumption','Algas aptos para el consumo humano',12,1212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121229,'Outras algas, frescas, refrigeradas, congeladas ou secas','Other algae, fresh, chilled, frozen or dried','Otras algas, frescas, refrigeradas, congeladas o secas',12,1212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121230,'Caroços e amêndoas de damascos, pêssegos e ameixas','Stones and almonds of apricots, peaches and plums','Huesos y almendras de albaricoque, durazno y ciruela',12,1212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121291,'Beterraba sacarina, fresca, refrigerada, congelada ou seca, mesmo em pó','Sugar beet, fresh, chilled, frozen or dried, whether or not ground','Remolacha azucarera, fresca, refrigerada, congelada o seca, incl. pulverizada',12,1212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121292,'Cana-de-açúcar fresca, refrigerada, congelada, seca, em pó','Sugar cane (fresh,  chillen,  frozen,  dry,  powder)','Saña de azúcar fresca, refrig.congel.seca, en polvo',12,1212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121293,'Cana-de-açúcar, fresca, regrigerada, congelada ou seca','Sugar cane, fresh regrigerada, frozen or dried','Caña de azúcar, frescas regrigerada, congelados o secos',12,1212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121294,'Raízes de chicória, fresca, refrigerada, congelada ou seca','Chicory roots, fresh, chilled, frozen or dried','Las raíces de achicoria, frescas, refrigeradas, congeladas o secas',12,1212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121299,'Outros produtos vegetais utilizados principalmente na alimentação humana','Fruit stones and kernels and other vegetable products, incl. unroasted chicory roots of the variety cichorium intybus sativum, of a kind used primarily for human consumption, n.e.s.','Huesos y almendras de frutos y demás poductos vegetales, incl. las raíces de achicoria sin tostar de la variedad "Cichorium intybus sativum", empleados principalmente en la alimentación humana, n.c.o.p.',12,1212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121300,'Palhas e cascas de cereais, em bruto, mesmo picadas, moídas, prensadas ou em pellets','Cereal straw and husks, unprepared, whether or not chopped, ground, pressed or in the form of pellets','Paja y cascabillo de cereales, en bruto, incl. picados, molidos, prensados o en "pellets"',12,1213);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121410,'Farinhas e pellets, de alfafa (luzerna)','Alfalfa meal and pellets','Harina y "pellets" de alfalfa',12,1214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (121490,'Rutabagas, raízes forrageiras e outros produtos forrageiros, mesmo em pellets','Swedes, mangolds, fodder roots, hay, lucerne alfalfa, clover, sainfoin, forage kale, lupines, vetches and similar forage products, whether or not in the form of pellets (excl. lucerne alfalfa meal and pellets)','Nabos forrajeros, remolachas forrajeras, raíces forrajeras, heno, alfalfa, trébol, esparceta, coles forrajeras, altramuces, vezas y productos forrajeros simil., incl. en "pellets" (exc. harina y "pellets" de alfalfa)',12,1214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (130110,'Goma-laca','lac','Goma laca',13,1301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (130120,'Goma-arábica','Natural gum Arabic','Goma arábiga',13,1301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (130190,'Outras gomas, resinas, gomas-resinas, oleorresinas, naturais','Lac; natural gums, resins, gum-resins, balsams and other natural oleoresins (excl. gum Arabic)','Gomas, resinas, gomorresinas, bálsamos y otras oleorresinas, naturales (exc. goma arábiga)',13,1301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (130211,'Ópio','Opium','Opio',13,1302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (130212,'Sucos e extratos, de alcaçuz','Extracts of liquorice (excl. that with a sucrose content by weight of > 10% or in the form of confectionery)','Extracto vegetal, de regaliz (exc. con un contenido de sacarosa > 10% en peso o acondicionado como artículo de confitería)',13,1302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (130213,'Sucos e extratos, de lúpulo','Extracts of hops','Extracto vegetal, de lúpulo',13,1302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (130214,'Sucos e extratos, de piretro ou de raízes com rotenona','Juice/extracts of pyrethrum/the root of plant containing rotenone','Jugos y extractos, de piretro o raíces q.cont.rotenona',13,1302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (130219,'Sucos e extratos de outros vegetais (mamão seco, semente de pomelo, ginkgo biloba seco)','Vegetable saps and extracts (excl. liquorice, hops and opium)','Jugos y extractos vegetales (exc. de regaliz, lúpulo, piretro "pelitre" y raíces que contengan rotenona, así como de opio)',13,1302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (130220,'Matérias pécticas, pectinatos e pectatos','Pectic substances, pectinates and pectates','Materias pécticas, pectinatos y pectatos',13,1302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (130231,'Ágar-ágar, mesmo modificado','Agar-agar, whether or not modified','Agar-agar, incl. modificado',13,1302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (130232,'Produtos mucilaginosos e espessantes, de alfarroba, de sementes de alfarroba ou de guaré, mesmo modificados','Mucilages and thickeners, derived from locust beans, locust bean seeds or guar seeds, whether or not modified','Mucílagos y espesativos de algarroba o de su semilla o de las semillas de guar, incl. modificados',13,1302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (130239,'Produtos mucilaginosos e espessantes, derivados de outros vegetais, mesmo modificados','Mucilages and thickeners derived from vegetable products, whether or not modified (excl. from locust beans, locust bean seeds, guar seeds and agar-agar)','Mucílagos y espesativos vegetales, incl. modificados (exc. de algarroba o de su semilla o de las semillas de guar, así como de agar- agar)',13,1302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (140110,'Bambus para cestaria ou espartaria','Bamboos','Bambú',14,1401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (140120,'Rotins para cestaria ou espartaria','Rattans','Roten "ratán"',14,1401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (140190,'Outras matérias vegetais para cestaria ou espartaria','Reeds, rushes, osier, raffia, cleaned, bleached or dyed cereal straw, lime bark and other vegetable materials of a kind used primarily for plaiting (excl. bamboos and rattans)','Caña, junco, mimbre, rafia, paja de cereales, limpiada, blanqueada o teñida, corteza de tilo y demás materias vegetales de las especies utilizadas principalmente en cestería o espartería (exc. bambú y roten "ratán")',14,1401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (140200,'Matérias vegetais, utiliz.cestaria/espartaria','other materials vegetables, used for plaiting','materias vegetales, utilizadas p/cestería o espartería',14,1402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (140210,'Sumauma ("kapoc") para enchimento ou estofamento','Kapok for stuffing or padding','"Kapoc" utilizadas para relleno o en capas',14,1402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (140290,'Outras matérias vegetais, para enchimento ou estofamento','Other vegetable materials, for stuffing or padding','Demás materias vegetales, utilizadas para relleno o en capas',14,1402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (140300,'Matérias vegetais, para fabricação de vassouras/escovas','Vegetable materials for production of brooms/brushes','Materias vegetales, utilizadas para fabricacción de escobas/cepillos',14,1403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (140310,'Sorgo para vassouras','Broomcorn for brooms','Sorgo para escobas',14,1403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (140390,'Outras matérias vegetais para fabricação de vassouras ou escovas','Other vegetable materials for production of brooms/brushes','Demás materias vegetables util.p/fabr.de escobas/cepillos',14,1403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (140410,'Matérias-primas vegetais para tinturaria ou curtimenta','raw vegetable materials primarily for dyeing or tanning','materias primas vegetales utilizadas p/teñir o curtir',14,1404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (140420,'Línteres de algodão','Cotton linters','Línteres de algodón',14,1404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (140490,'Outros produtos de origem vegetal não especificados nem compreendidos em outras posições','Vegetable products n.e.s','Productos vegetales, n.c.o.p.',14,1404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150100,'Gorduras de porco (incluída a banha) e gordura de aves, exceto as das posições 0209 ou 1503','Pig fat, incl. lard, and poultry fat, rendered or otherwise extracted (excl. lard stearin and lard oil)','Grasa de cerdo, incl. la manteca de cerdo, y grasas de ave, fundidas o extraídas de otro modo (exc. estearina solar y aceite de manteca de cerdo)',15,1501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150110,'Banha de porco','Fat of pork','Manteca de cerdo',15,1501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150120,'Outras gorduras de porco','Other fats, of pork','Otras grasas, de carne de cerdo',15,1501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150190,'Gordura de aves','Fat of birds','Grasa de aves',15,1501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150200,'Gorduras de animais das espécies bovina, ovina ou caprina, exceto as da posição 1503','Fats of bovine animals, sheep or goats (excl. lard stearin, lard oil, oleostearin, oleooil and tallow oil, not emulsified or mixed or otherwise prepared)','Grasa de animales de las especies bovina, ovina o caprina (exc. estearina solar, aceite de manteca de cerdo, oleoestearina, oleomargarina y aceite de sebo, sin emulsionar ni mezclar ni preparar de otra forma)',15,1502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150210,'Sebo de bovinos, ovinos ou caprinos','Tallow from cattle, sheep or goats','La grasa de bovinos, ovinos o caprinos',15,1502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150290,'Gorduras ovinas ou caprinas','Fats of sheep or goats','Las grasas de las ovejas o cabras',15,1502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150300,'Estearina solar, óleo de banha de porco, óleo estearina, óleo margarina e óleo de sebo, não emulsionados nem misturados, nem preparados de outro modo','Lard stearin, lard oil, oleostearin, oleo-oil and tallow oil (excl. emulsified, mixed or otherwise prepared)','Estearina solar, aceite de manteca de cerdo, oleoestearina, oleomargarina y aceite de sebo, sin emulsionar ni mezclar ni preparar de otra forma',15,1503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150410,'Óleos de fígados de peixes e respectivas frações, mesmo refinados, mas não modificados quimicamente','Fish-liver oils and their fractions, whether or not refined (excl. chemically modified)','Aceites de hígado de pescado y sus fracciones, incl. refinados, sin modificar químicamente',15,1504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150420,'Gorduras e óleos de peixe e respectivas frações, exceto óleos de fígados, mesmo refinados, mas não modificados quimicamente','Fats and oils of fish and their fractions, whether or not refined (excl. liver oils and chemically modified)','Grasas y aceites de pescado y sus fracciones, incl. refinados, sin modificar químicamente (exc. aceites de hígado de pescado)',15,1504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150430,'Gorduras e óleos de mamíferos marinhos e respectivas frações, mesmo refinados, mas não modificados quimicamente','Fats and oils and their fractions of marine mammals, whether or not refined (excl. chemically modified)','Grasas y aceites de mamíferos marinos y sus fracciones, incl. refinados, sin modificar químicamente',15,1504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150500,'Suarda e substâncias gordas dela derivadas, incluída a lanolina','Wool grease and fatty substances derived therefrom, incl. lanolin','Grasa de lana y sustancias grasas derivadas, incl. la lanolina',15,1505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150510,'suarda em bruto','wool grease, crude','suarda en bruto',15,1505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150590,'Lanolina e outras substâncias gordas derivadas da suarda','Lanolin and other fatty substances derived from yolk','Lanolina y otras sustancias grasas derivadas de yema',15,1505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150600,'Outras gorduras e óleos de animais, mesmo refinados, mas não quimicamente modificados','Other animal fats and oils and their fractions, whether or not refined, but not chemically modified (excl. pig fat, poultry fat, fats of bovine animals, sheep and goats, fats of fish and other marine animals, lard stearin, lard oil, oloestearin, oleo-oil,','Grasas y aceites de animales y sus fracciones, incl. refinados, sin modificar químicamente (exc. de cerdo, ave, bovinos, ovinos, caprinos, pescado y mamíferos marinos, así como estearina solar, aceite de manteca de cerdo, oleoestearina, oleomargarina, ace',15,1506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150710,'Óleo de soja, em bruto, mesmo degomado','Crude soya-bean oil, whether or not degummed','Aceite de soja "soya" en bruto, incl. desgomado',15,1507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150790,'Óleo de soja e respectivas frações, mesmo refinados, mas não quimicamente modificados','Soya-bean oil and its fractions, whether or not refined (excl. chemically modified and crude)','Aceite de soja "soya" y sus fracciones, incl. refinados, sin modificar químicamente',15,1507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150810,'Óleo de amendoim, em bruto','Crude groundnut oil','Aceite de cacahuete "cacahuate, maní" en bruto',15,1508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150890,'Outros óleos de amendoim e respectivas frações, mesmo refinados, mas não quimicamente modificados','Groundnut oil and its fractions, whether or not refined (excl. chemically modified and crude)','Aceite de cacahuete "cacahuate, maní" y sus fracciones, incl. refinados, sin modificar químicamente (exc. en bruto)',15,1508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150910,'Azeite de oliva e respectivas frações, virgem','Virgin olive oil and its fractions obtained from the fruit of the olive tree solely by mechanical or other physical means under conditions that do not lead to deterioration of the oil','Aceite de oliva y sus fracciones, obtenidos de la aceituna exclusivamente por medios mecánicos o físicos que no afecten al aceite, "virgen", sin tratar',15,1509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (150990,'Azeite de oliva refinado e outros azeites de oliva, não quimicamente modificados','Olive oil and fractions obtained from the fruit of the olive tree solely by mechanical or other physical means under conditions that do not lead to deterioration of the oil (excl. virgin and chemically modified)','Aceite de oliva y sus fracciones, obtenidos de la aceituna exclusivamente por medios mecánicos o físicos que no afecten al aceite, "virgen", tratado, sin modificar químicamente',15,1509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151000,'Outros óleos e respectivas frações, obtidos de azeitonas, mesmo refinados, mas não quimicamente modificados, e misturas desses óleos com óleos da posição 1509','Other oils and their fractions, obtained solely from olives, whether or not refined, but not chemically modified, incl. blends of these oils or fractions with oils or fractions of heading 1509','Aceites y sus fracciones obtenidos exclusivamente de la aceituna por métodos diferentes de los mencionados en la partida 1509, incl. refinados, sin modificar químicamente, incl. mezclas de estos aceites o fracciones con los aceites de la partida 1509',15,1510);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151110,'Óleos de dendê, em bruto','Crude palm oil','Aceite de palma en bruto',15,1511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151190,'Outros óleos de dendê, mesmo refinados, mas não quimicamente modificados','Palm oil and its fractions, whether or not refined (excl. chemically modified and crude)','Aceite de palma y sus fracciones, incl. refinados, sin modificar químicamente (exc. aceite de palma en bruto)',15,1511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151211,'Óleo de girassol ou de cártamo, e respectivas frações, em bruto','Crude sunflower-seed or safflower oil','Aceites de girasol o cártamo, en bruto',15,1512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151219,'Óleos de girassol ou de cártamo, e respectivas frações, mesmo refinados, mas não quimicamente modificados','Sunflower-seed or safflower oil and their fractions, whether or not refined, but not chemically modified (excl. crude)','Aceites de girasol o cártamo y sus fracciones, incl. refinados, sin modificar químicamente (exc. aceites en bruto)',15,1512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151221,'Óleo de algodão, em bruto, mesmo desprovido de gossypol','Crude cotton-seed oil','Aceite de algodón, en bruto, incl. sin el gosipol',15,1512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151229,'Óleo de algodão e respectivas frações, mesmo refinados, mas não quimicamente modificados','Cotton-seed oil and its fractions, whether or not refined, but not chemically modified (excl. crude)','Aceite de algodón y sus fracciones, incl. sin el gosipol, incl. refinados, sin modificar químicamente (exc. aceite de algodón en bruto)',15,1512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151311,'Óleo de coco (óleo de copra), em bruto','Crude coconut oil','Aceite de coco "copra", en bruto',15,1513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151319,'Outros óleos de coco (óleos de copra) e suas frações, mesmo refinados, mas não quimicamente modificados','Coconut oil and its fractions, whether or not refined, but not chemically modified (excl. crude)','Aceite de coco "copra" y sus fracciones, incl. refinados, sin modificar químicamente (exc. aceite de coco "copra" en bruto)',15,1513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151321,'Óleo de palmiste ou de babaçu, em bruto','Crude palm kernel and babassu oil','Aceites de almendra de palma  o babasú, en bruto',15,1513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151329,'Outros óleos de palmiste ou de babaçu e suas frações, mesmo refinados, mas não quimicamente modificados','Palm kernel and babassu oil and their fractions, whether or not refined, but not chemically modified (excl. crude)','Aceites de almendra de palma o babasú y sus fracciones, incl. refinados, sin modificar químicamente',15,1513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151410,'óleos de nabo silvestre, de colza, de mostarda, em bruto','rape, colza or mustard oil, in crude','aceites de nabo(de nabina), de colza, de mostaza, en bruto',15,1514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151411,'Óleos de nabo silvestre ou de colza, com baixo teor de ácido erúcico, em bruto','Low erucic acid rape or colza oil fixed oil which has an erucic acid content of < 2%, crude','Aceites de nabo "nabina" o colza con bajo contenido de ácido erúcico "aceite fijo con un contenido de ácido erúcico < 2% en peso", en bruto',15,1514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151419,'Óleos de nabo silvestre ou de colza, com baixo teor de ácido erúcico, refinados e outros','Low erucic acid rape or colza oil fixed oil which has an erucic acid content of < 2% and its fractions, whether or not refined, but not chemically modified (excl. crude)','Aceites de nabo "nabina" o colza con bajo contenido de ácido erúcico "aceite fijo con un contenido de ácido erúcico < 2% en peso" y sus fracciones, incl. refinados, pero sin modificar químicamente (exc. aceites en bruto)',15,1514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151490,'Óleos de nabo silvestre','Colza oil','Aceite de nabo',15,1514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151491,'Outros óleos de nabo silvestre, de colza ou de mostarda, em bruto','High erucic acid rape or colza oil fixed oil which has an erucic acid content of >= 2% and mustard oil, crude','Aceites de nabo "nabina" y colza con alto contenido de ácido erúcico "aceite fijo con un contenido de ácido erúcico >= 2% en peso" y aceites de mostaza, en bruto',15,1514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151499,'Outros óleos de nabo silvestre, de colza ou de mostarda, refinados e outros','High erucic acid rape or colza oil fixed oil which has an erucic acid content of >= 2%, and mustard oil, and fractions thereof, whether or not refined, but not chemically modified (excl. crude)','Aceites de nabo "nabina" y colza con alto contenido de ácido erúcico "aceite fijo con un contenido de ácido erúcico >= 2% en peso" y aceites de mostaza y sus fracciones, incl. refinados, pero sin modificar químicamente (exc. aceites en bruto)',15,1514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151511,'Óleo de linhaça, em bruto','Crude linseed oil','Aceite de lino "de linaza", en bruto',15,1515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151519,'Outros óleos de linhaça e respectivas frações, mesmo refinados, mas não quimicamente modificados','Linseed oil and fractions thereof, whether or not refined, but not chemically modified (excl. crude)','Aceite de lino "de linaza" y sus fracciones, incl. refinados, sin modificar químicamente (exc. aceite de lino "de linaza" en bruto)',15,1515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151521,'Óleo de milho, em bruto','Crude maize oil','Aceite de maíz, en bruto',15,1515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151529,'Outros óleos de milho e respectivas frações, mesmo refinados, mas não quimicamente modificados','Maize oil and fractions thereof, whether or not refined, but not chemically modified (excl. crude)','Aceite de maíz y sus fracciones, incl. refinados, sin modificar químicamente (exc. aceite de maíz en bruto)',15,1515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151530,'Óleo de rícino e respectivas frações, mesmo refinados, mas não quimicamente modificados','Castor oil and fractions thereof, whether or not refined, but not chemically modified','Aceite de ricino y sus fracciones, incl. refinados, sin modificar químicamente',15,1515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151540,'Óleo de tungue','Tung oil and its fractions','Aceite de tungue',15,1515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151550,'Óleo de gergelim e respectivas frações, mesmo refinados, mas não quimicamente modificados','Sesame oil and its fractions','Aceite de sésamo "ajonjolí" y sus fracciones, incl. refinados, sin modificar químicamente',15,1515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151560,'Óleo de jojoba','Jojoba oil and its fractions','Aceite de jojoba',15,1515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151590,'Outras gorduras e óleos vegetais fixos e respectivas frações, mesmo refinados, mas não quimicamente modificados','Fixed vegetable fats and oils and their fractions, whether or not refined, but not chemically modified (excl. soya-bean, groundnut, olive, palm, sunflower-seed, safflower, cotton-seed, coconut, palm kernel, babassu, rape, colza and mustard, linseed, maize','Grasas y aceites vegetales fijos y sus fracciones, incl. refinados, sin modificar químicamente (exc. aceites de soja "soya", cacahuete "cacahuate, maní", oliva, palma, girasol, cártamo, algodón, coco "copra", almendra de palma, babasú, nabo "nabina", colz',15,1515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151610,'Gorduras e óleos animais e respectivas frações, parcial ou totalmente hidrogenados, interesterificados, reesterificados ou elaidinizados, mesmo refinados, mas não preparados de outro modo','Animal fats and oils and their fractions, partly or wholly hydrogenated, inter-esterified, re-esterified or elaidinised, whether or not refined, but not further prepared','Grasas y aceites de origen animal o vegetal y sus fracciones, parcial o totalmente hidrogenados, interesterificados, reesterificados o elaidinizados, incl. refinados (exc. grasas y aceites y sus fracciones preparados de otra forma)',15,1516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151620,'Gorduras e óleos vegetais e respectivas frações, parcial ou totalmente hidrogenados, interesterificados, reesterificados ou elaidinizados, mesmo refinados, mas não preparados de outro modo','Vegetable fats and oils and their fractions, partly or wholly hydrogenated, inter-esterified, re-esterified or elaidinised, whether or not refined, but not further prepared','Grasas y aceites de origen vegetal y sus fracciones, parcial o totalmente hidrogenados, interesterificados, reesterificados o elaidinizados, incl. refinados (exc. grasas y aceites y sus fracciones preparados de otra forma)',15,1516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151710,'Margarina, exceto a margarina líquida','Margarine (excl. liquid)','Margarina (exc. margarina líquida)',15,1517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151790,'Misturas ou preparações alimentícias de gorduras ou de óleos animais ou vegetais','Edible mixtures or preparations of animal or vegetable fats or oils and edible fractions of different fats or oils (excl. fats, oils and their fractions, partly or wholly hydrogenated, inter-esterified, re-esterified or elaidinised, whether or not refined','Mezclas y preparaciones alimenticias de materias grasas y aceites, animales o vegetales, o de fracciones alimenticias de diferentes grasas o aceites (exc. grasas y aceites y sus fracciones, parcial o totalmente hidrogenados, interesterificados, reesterifi',15,1517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (151800,'Gorduras e óleos animais ou vegetais, cozidos, oxidados, desidratados ou modificados quimicamente por qualquer outro processo','Animal or vegetable fats and oils and their fractions, boiled, oxidised, dehydrated, sulphurised, blown, polymerised by heat in vacuum or in inert gas or otherwise chemically modified, inedible mixtures or preparations of animal or vegetable fats or oils ','Grasas y aceites, animales o vegetales, y sus fracciones, cocidos, oxidados, deshidratados, sulfurados, soplados, polimerizados por calor en vacío o atmósfera inerte [«estandolizados»] o modificados químicamente de otra forma (exc. de los de la partida 15',15,1518);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (152000,'Glicerol em bruto; águas e lixívias, glicéricas','Glycerol, crude; glycerol waters and glycerol lyes','Glicerol en bruto; aguas y lejías glicerinosas',15,1520);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (152110,'Ceras vegetais, mesmo refinadas ou coradas (exceto triglicerídeos)','Vegetable waxes, whether or not refined or coloured (excl. triglycerides)','Ceras vegetales, incl. refinadas o coloreadas (exc. ceras de triglicéridos)',15,1521);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (152190,'Ceras de abelhas ou de outros insetos e espermacete, mesmo refinados ou corados','Beeswax, other insect waxes and spermaceti, whether or not refined or coloured','Cera de abejas o de otros insectos y esperma de ballena y de otros cetáceos "espermaceti", incl. refinadas o coloreadas (exc. las ceras de triglicéridos)',15,1521);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (152200,'Dégras e resíduos do tratamento das matérias graxas ou das ceras','Degras; residues resulting from the treatment of fatty substances or animal or vegetable waxes','Degrás; residuos porcedentes del tratamiento de materias grasas o ceras, animales o vegetales',15,1522);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160100,'Enchidos e produtos semelhantes de carne, miudezas ou sangue; preparações alimentícias à base de tais produtos','Sausages and similar products, of meat, offal or blood; food preparations based on these products','Embutidos y productos simil., de carne, despojos o sangre; preparaciones alimenticias a base de estos productos',16,1601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160210,'Preparações alimentícias homogeneizadas de carnes, miudezas ou sangue','Homogenised prepared meat, offal or blood, put up for retail sale as infant food or for dietetic purposes, in containers of <= 250 g','Preparaciones de carne, despojos o sangre, finamente homogeneizados, para la alimentación infantil o para usos dietéticos, acondicionadas para la venta al por menor en recipientes con un contenido <= 250 g',16,1602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160220,'Preparações alimentícias e conservas de fígados de quaisquer animais','Preparations of liver of any animal (excl. sausages and similar products and finely homogenised preparations put up for retail sale as infant food or for dietetic purposes, in containers of a net weight of <= 250 g)','Preparaciones y conservas de hígado de cualquier animal (exc. embutidos y productos simil., así como preparaciones finamente homogeneizadas, para la alimentación infantil o para usos dietéticos, acondicionadas para la venta al por menor en recipientes con',16,1602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160231,'Preparações alimentícias e conservas de peru','Meat or offal of turkeys Gallus domesticus, prepared or preserved (excl. sausages and similar products, and finely homogenised preparations put up for retail sale as infant food or for dietetic purposes, in containers of a net weight of <= 250 g, preparat','Preparaciones y conservas de carne o despojos de pavo "gallipavo" de especies domésticas (exc. embutidos y productos simil.; preparaciones finamente homogeneizadas, para la alimentación infantil o para usos dietéticos, acondicionadas para la venta al por ',16,1602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160232,'Preparações alimentícias e conservas de galos e de galinhas','Meat or offal of fowls of the species Gallus domesticus, prepared or preserved (excl. of meat or offal of turkeys Gallus domesticus or guinea fowl, sausages and similar products, finely homogenised preparations put up for retail sale as infant food or for','Preparaciones y conservas de carne o despojos, de gallo o gallina, de especies domésticas (exc. embutidos y productos simil.; preparaciones finamente homogeneizadas, para la alimentación infantil o para usos dietéticos, acondicionadas para la venta al por',16,1602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160239,'Preparações alimentícias e conservas de patos, gansos e galinhas d''angola','Prepared or preserved meat or meat offal of ducks, geese and guinea fowl of the species domesticus (excl. sausages and similar products, finely homogenised preparations put up for retail sale as infant food or for dietetic purposes, in containers of a net','Preparaciones y conservas de carne o despojos de pato, ganso o pintada, de especies domésticas (exc. embutidos y productos simil.; preparaciones finamente homogeneizadas, para la alimentación infantil o para usos dietéticos, acondicionadas para la venta a',16,1602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160241,'Preparações alimentícias e conservas de pernas e respectivos pedaços, de suínos','Hams and cuts thereof, prepared or preserved','Piernas y trozos de pierna, de porcinos, preparadas o conservadas',16,1602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160242,'Preparações alimentícias e conservas de pás e respectivos pedaços, de suínos','Prepared or preserved shoulders and cuts thereof, of swine','Paletas y trozos de paleta, de porcinos, preparados o conservados',16,1602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160249,'Outras preparações alimentícias e conservas de suínos, incluídas as misturas','Prepared or preserved meat and offal of swine, incl. mixtures (excl. hams, shoulders and cuts thereof, sausages and similar products, finely homogenised preparations put up for retail sale as infant food or for dietetic purpose, in containers of a net wei','Preparaciones y conservas, incl. las mezclas, de carne o de despojos de porcinos (exc. preparaciones y conservas exclusivamente de piernas y de trozos de pierna, de paleta y de trozos de paleta, así como embutidos y productos simil.; preparaciones finamen',16,1602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160250,'Preparações alimentícias e conservas, de bovinos','Prepared or preserved meat or offal of bovine animals (excl. sausages and similar products, finely homogenised preparations put up for retail sale as infant food or for dietetic purposes, in containers of a net weight of <= 250 g, preparations of liver an','Preparaciones y conservas, de carne o de despojos de bovinos (exc. embutidos y productos simil.; preparaciones finamente homogeneizadas, para la alimentación infantil o para usos dietéticos, acondicionadas para la venta al por menor en recipientes con un ',16,1602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160290,'Outras preparações alimentícias e conservas de carnes, miudezas ou sangue de animais','Prepared or preserved meat, offal or blood (excl. meat or offal of poultry, swine and bovine animals, sausages and similar products, finely homogenised preparations put up for retail sale as infant food or for dietetic purposes, in containers of a net wei','Preparaciones y conservas de carne, de despojos o de sangre (exc. de carne o de despojos de aves de corral, de porcinos y de bovinos, así como embutidos y productos simil.; preparaciones finamente homogeneizadas, para la alimentación infantil o para usos ',16,1602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160300,'Extratos e sucos de carnes, de peixes ou de crustáceos ou de outros invertebrados aquáticos','Extracts and juices of meat, fish or crustaceans, molluscs and other aquatic invertebrates','Extractos y jugos de carne, pescado o crustáceos, moluscos o demás invertebrados acuáticos',16,1603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160411,'Preparações e conservas de salmões inteiros ou em pedaços, exceto peixes picados','Prepared or preserved salmon, whole or in pieces (excl. minced)','Preparaciones y conservas de salmones, entero o en trozos (exc. picado)',16,1604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160412,'Preparações e conservas de arenques inteiros ou em pedaços, exceto peixes picados','Prepared or preserved herrings, whole or in pieces (excl. minced)','Preparaciones y conservas de arenque, entero o en trozos (exc. picado)',16,1604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160413,'Preparações e conservas de sardinhas, sardinelas e espadilhas, inteiras ou em pedaços, exceto peixes picados','Prepared or preserved sardines, sardinella and brisling or sprats, whole or in pieces (excl. minced)','Preparaciones y conservas de sardina, de sardinela y de espadín, enteros o en trozos (exc. picados)',16,1604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160414,'Preparações e conservas de atuns, bonitos-listrados e bonitos-cachorros, inteiros ou em pedaços, exceto peixes picados','Prepared or preserved tunas, skipjack and Atlantic bonito, whole or in pieces (excl. minced)','Preparaciones y conservas de atún, de listado y de bonito "Sarda spp.", enteros o en trozos (exc. picados)',16,1604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160415,'Preparações e conservas de cavalas, cavalinhas e sardas, inteiras ou em pedaços, exceto peixes picados','Prepared or preserved mackerel, whole or in pieces (excl. minced)','Preparaciones y conservas de caballa, enteros o en trozos (exc. picados)',16,1604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160416,'Preparações e conservas de anchovas, inteiras ou em pedaços, exceto peixes picados','Prepared or preserved anchovies, whole or in pieces (excl. minced)','Preparaciones y conservas de anchoa, entera o en trozos (exc. picada)',16,1604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160417,'Preparações e conservas, de enguias','preparacoes e conservas, de enguias','preparacoes e conservas, de enguias',16,1604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160419,'Preparações e conservas de outros peixes, inteiros ou em pedaços, exceto peixes picados','Prepared or preserved fish, whole or in pieces (excl. minced and salmon, herrings, sardines, sardinella, brisling or sprats, tunas, skipjack and Atlantic bonito, bonito sarda spp., mackerel and anchovies)','Preparaciones y conservas de pescado, entero o en trozos (exc. picado, así como preparaciones y conservas de salmones, de arenque, de sardina, de sardinela, de espadín, de atún, de listado, de bonito "Sarda spp.", de caballa, de estornino y de anchoa)',16,1604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160420,'Outras preparações e conservas de peixes','Prepared or preserved fish (excl. whole or in pieces)','Preparaciones y conservas de pescado (exc. entero o en trozos)',16,1604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160430,'Caviar e seus sucedâneos','Caviar and caviar substitutes prepared from fish eggs','Caviar y sus sucedáneos, preparados con huevas de pescado',16,1604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160431,'Caviar','Caviar','Caviar',16,1604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160432,'Sucedâneos de caviar','Caviar substitutes','Sucedáneos del caviar',16,1604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160510,'Preparações e conservas de caranguejos','Crab, prepared or preserved','Preparaciones y conservas de cangrejo (exc. "macruro")',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160520,'Preparações e conservas de camarões','Shrimps and prawns, prepared or preserved','Preparaciones y conservas de camarón, de langostino y demás Decápodos "natantia"',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160521,'Preparações e conservas de camarões, não acondicionados em recipientes hermeticamente fechados','Prepared or preserved shrimps, not packed in airtight containers','Preparaciones y conservas de camarones, los que no estén embalados en envases herméticamente cerrados',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160529,'Preparações e conservas de camarões, exceto não acondicionados em recipientes hermeticamente fechados','Prepared or preserved shrimps, but not packed in airtight containers','Preparaciones y conservas de camarones, pero no envasados en envases herméticamente cerrados',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160530,'Preparações e conservas de lavagantes (homards)','Lobster, prepared or preserved','Preparaciones y conservas de bogavante',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160540,'Preparações e conservas de outros crustáceos','Crustaceans, prepared or preserved (excl. crabs, shrimps, prawns and lobster)','Preparaciones y conservas de crustáceos (exc. de cangrejo no "macruro", de camarón, de langostino y de demás decápodos "natantia" y de bogavante)',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160551,'Preparações e conservas, de ostras','Prepared or preserved, oyster','Preparaciones y conservas, de ostras',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160552,'Preparações e conservas, de vieiras e outros mariscos','preparacoes e conservas, de vieiras e outros mariscos','preparacoes e conservas, de vieiras e outros mariscos',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160553,'Preparações e conservas, de mexilhões','preparacoes e conservas, de mexilhoes','preparacoes e conservas, de mexilhoes',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160554,'Preparações e conservas, sepias e lulas','preparacoes e conservas, sepias e lulas','preparacoes e conservas, sepias e lulas',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160555,'Preparações e conservas, de polvos','Prepared or preserved, octopus','Preparaciones y conservas, de pulpo',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160556,'Preparações e conservas, de ameijoas, berbigoes e arcas','preparacoes e conservas, de ameijoas, berbigoes e arcas','preparacoes e conservas, de ameijoas, berbigoes e arcas',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160557,'Preparações e conservas, de abalones','preparacoes e conservas, de abalones','preparacoes e conservas, de abalones',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160558,'Preparações e conservas, de caracóis (exceto os do mar)','preparacoes e conservas, de caracois (exceto os do mar)','preparacoes e conservas, de caracois (exceto os do mar)',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160559,'Preparações e conservas, de outros moluscos','Prepared or preserved, other molluscs','Preparaciones y conservas de otros moluscos',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160561,'Preparações e conservas, de pepinos-do-mar','preparacoes e conservas, de pepinos-do-mar','preparacoes e conservas, de pepinos-do-mar',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160562,'Preparações e conservas, de ouriços-do-mar','preparacoes e conservas, de ouricos-do-mar','preparacoes e conservas, de ouricos-do-mar',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160563,'Preparações e conservas, de medusas (aguas-vivas)','preparacoes e conservas, de medusas (aguas-vivas)','preparacoes e conservas, de medusas (aguas-vivas)',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160569,'Preparações e conservas, de outros invertebrados aquáticos','Prepared or preserved, other aquatic invertebrates','Preparados o conservados, otros invertebrados acuáticos',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (160590,'Preparações e conservas de moluscos e outros invertebrados aquáticos','Molluscs and aquatic invertebrates, prepared or preserved','Preparaciones y conservas de moluscos y de los demás invertebrados acuáticos',16,1605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170111,'Açúcar de cana, em bruto, sem adição de aromatizantes ou de corantes','Raw cane sugar (excl. added flavouring or colouring)','Azúcar de caña sólido, en bruto, sin adición de aromatizante ni colorante',17,1701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170112,'Açúcar de beterraba, em bruto, sem adição de aromatizantes ou de corantes','Raw beet sugar (excl. added flavouring or colouring)','Azúcar de remolacha sólido, en bruto, sin adición de aromatizante ni colorante',17,1701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170113,'Açúcar de cana mencionado na nota 2 da subposiçao 1701','Sugar cane mentioned in footnote 2 of subheading 1701','Azúcar de caña que se menciona en la nota 2 de la subpartida 1701',17,1701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170114,'Outros açúcares de cana','Other cane sugar','Otros azúcares de caña',17,1701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170191,'Outros açúcares de cana ou de beterraba, adicionados de aromatizantes ou de corantes, no estado sólido','Refined cane or beet sugar, containing added flavouring or colouring, in solid form','Azúcar de caña o remolacha, sólido, con adición de aromatizante o colorante',17,1701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170199,'Outros açúcares de cana, de beterraba e sacarose quimicamente pura, no estado sólido','Cane or beet sugar and chemically pure sucrose, in solid form (excl. cane and beet sugar containing added flavouring or colouring and raw sugar)','Azúcar de caña o remolacha y sacarosa químicamente pura, sólidos (exc. los con adición de aromatizante o colorante, así como el azúcar en bruto)',17,1701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170211,'Lactose, no estado sólido, e xarope de lactose contendo, em peso, => 99% de lactose, expressos em lactose anidra, calculado sobre a matéria seca','Lactose in solid form and lactose syrup, not containing added flavouring or colouring matter, containing by weight >= 99% lactose, expressed as anhydrous lactose, calculated on the dry matter','Lactosa en estado sólido y jarabe de lactosa, sin adición de aromatizante ni colorante, con un contenido de lactosa >= 99% en peso, expresado en lactosa anhidra, calculado sobre producto seco',17,1702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170219,'Outras lactoses, no estado sólido, e xaropes de lactose','Lactose in solid form and lactose syrup, not containing added flavouring or colouring matter, containing by weight < 99% lactose, expressed as anhydrous lactose, calculated on the dry matter','Lactosa en estado sólido y jarabe de lactosa, sin adición de aromatizante ni colorante, con un contenido de lactosa < 99% en peso, expresado en lactosa anhidra, calculado sobre producto seco',17,1702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170220,'Açúcar de bordo (ácer), no estado sólido, e xarope de bordo (ácer), sem adição de aromatizantes ou de corantes','Maple sugar, in solid form, and maple syrup (excl. flavoured or coloured)','Azúcar sólido de arce ["maple"] y jarabe de arce ["maple"], sin adición de aromatizante ni colorante',17,1702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170230,'Glicose, no estado sólido, e xarope de glicose, contendo, em peso, no estado seco, menos de 20% de frutose','Glucose in solid form and glucose syrup, not containing added flavouring or colouring matter and not containing fructose or containing in the dry state, < 20% by weight of fructose','Glucosa sólida y jarabe de glucosa sin adición de aromatizante ni colorante, sin fructosa o con un contenido de fructosa, sobre producto seco, < 20% en peso',17,1702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170240,'Glicose, no estado sólido, e xarope de glicose, contendo, em peso, no estado seco, 20% até < 50% de frutose','Glucose in solid form and glucose syrup, not containing added flavouring or colouring matter, and containing in the dry state >= 20% and < 50% by weight of fructose (excl. invert sugar)','Glucosa sólida y jarabe de glucosa sin adición de aromatizante ni colorante, con un contenido de fructosa, sobre producto seco, >= 20% pero < 50% en peso (exc. azúcar invertido)',17,1702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170250,'Frutose quimicamente pura, no estado sólido','Chemically pure fructose in solid form','Fructosa químicamente pura',17,1702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170260,'Frutose, no estado sólido, e xarope de frutose, contendo, em peso, no estado seco, mais de 50% de frutose','Fructose in solid form and fructose syrup, not containing added flavouring or colouring matter and containing in the dry state > 50% by weight of fructose (excl. chemically pure fructose and invert sugar)','Fructosa sólida y jarabe de fructosa, sin adición de aromatizante ni colorante, con un contenido de fructosa, sobre producto seco, > 50% en peso (exc. fructosa químicamente pura y azúcar invertido)',17,1702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170290,'Outros açúcares no estado sólido, xaropes de açúcares, incluído o açúcar invertido, sucedâneos do mel, sem adição de aromatizantes ou de corantes','Sugars in solid form, incl. invert sugar and chemically pure maltose, and sugar and sugar syrup blends containing in the dry state 50% by weight of fructose, not flavoured or coloured, artificial honey, whether or not mixed with natural honey and caramel ','Los demás azúcares, incl. el azúcar invertido y la maltosa químicamente pura, en estado sólido, los demás azúcares y jarabes de azúcar con un contenido de fructosa, sobre producto seco, de 50% en peso, sin adición de aromatizante ni colorante, los sucedán',17,1702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170310,'Melaços de cana','Cane molasses resulting from the extraction or refining of sugar','Melaza de caña,  procedente de la extracción o del refinado del azúcar',17,1703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170390,'Outros melaços da extração ou refinação do açúcar','Beet molasses resulting from the extraction or refining of sugar','Melaza de remolacha,  procedente de la extracción o del refinado del azúcar',17,1703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170410,'Gomas de mascar, sem cacau, mesmo revestidas de açúcar','Chewing gum, whether or not sugar-coated','Chicle, incl. recubierto de azúcar',17,1704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (170490,'Outros produtos de confeitaria, sem cacau','Sugar confectionery not containing cocoa, incl. white chocolate (excl. chewing gum)','Artículos de confitería sin cacao, incl. el chocolate blanco (exc. chicle)',17,1704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (180100,'Cacau inteiro ou partido, em bruto ou torrado','Cocoa beans, whole or broken, raw or roasted','Cacao en grano, entero o partido, crudo o tostado',18,1801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (180200,'Cascas, películas e outros desperdícios de cacau','Cocoa shells, husks, skins and other cocoa waste','Cáscara, películas y demás desechos de cacao',18,1802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (180310,'Pasta de cacau, não desengordurada','Cocoa paste (excl. defatted)','Pasta de cacao, sin desgrasar',18,1803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (180320,'Pasta de cacau, total ou parcialmente desengordurada','Cocoa paste, wholly or partly defatted','Pasta de cacao, desgrasada total o parcialmente',18,1803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (180400,'Manteiga, gordura e óleo de cacau','Cocoa butter, fat and oil','Manteca, grasa y aceite de cacao',18,1804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (180500,'Cacau em pó, sem adição de açúcar ou outros edulcorantes','Cocoa powder, not containing added sugar or other sweetening matter','Cacao en polvo sin adición de azúcar ni otro edulcorante',18,1805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (180610,'Cacau em pó, com adição de açúcar ou outros edulcorantes','Cocoa powder, sweetened','Cacao en polvo con adición de azúcar ni otro edulcorante',18,1806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (180620,'Outras preparações alimentícias com cacau, em blocos ou barras, com peso > 2 kg','Chocolate and other food preparations containing cocoa, in blocks, slabs or bars weighing > 2 kg or in liquid, paste, powder, granular or other bulk form, in containers or immediate packings of a content > 2 kg (excl. cocoa powder)','Chocolate y demás preparaciones alimenticias que contengan cacao, bien en bloques o barras con peso > 2 kg, bien en forma líquida o pastosa, o en polvo, gránulos o formas simil., en recipientes o envases inmediatos con un contenido > 2 kg (exc. cacao en p',18,1806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (180631,'Chocolate e outras preparações alimentícias com cacau, recheadas, em tabletes, barras e paus','Chocolate and other preparations containing cocoa, in blocks, slabs or bars of <= 2 kg, filled','Chocolate y demás preparaciones alimenticias que contengan cacao, en bloques, tabletas o barras, con peso <= 2 kg, rellenas',18,1806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (180632,'Chocolate e outras preparações alimentícias com cacau, não recheadas, em tabletes, barras e paus','Chocolate and other preparations containing cocoa, in blocks, slabs or bars of <= 2 kg (excl. filled)','Chocolate y demás preparaciones alimenticias que contengan cacao, en bloques, tabletas o barras, con peso <= 2 kg, sin rellenar',18,1806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (180690,'Outros chocolates e preparações alimentícias contendo cacau','Chocolate and other preparations containing cocoa, in containers or immediate packings of <= 2 kg (excl. in blocks, slabs or bars and cocoa powder)','Chocolate y demás preparaciones alimenticias que contengan cacao, en recipientes o envases inmediatos con un contenido <= 2 kg (exc. en bloques, en tabletas o en barras, así como el cacao en polvo)',18,1806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190110,'Preparações para alimentação de crianças acondicionadas para venda a retalho','Food preparations for infant use, put up for retail sale, of flour, groats, meal, starch or malt extract, not containing cocoa or containing < 40% by weight of cocoa calculated on a totally defatted basis, n.e.s. and of milk, sour cream, whey, yogurt, kep','Preparaciones alimenticias de harina, grañones, sémola, almidón, fécula o extracto de malta, sin cacao o con un contenido de cacao < 40% en peso calculado sobre una base totalmente desgrasada, n.c.o.p., así como preparaciones alimenticias de leche, nata, ',19,1901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190120,'Misturas e pastas, para preparação de produtos de padaria, pastelaria','Mixes and doughs of flour, groats, meal, starch or malt extract, not containing cocoa or containing < 40% by weight of cocoa calculated on a totally defatted basis, n.e.s. and of mixes and doughs of milk, cream, butter milk, sour milk, sour cream, whey, y','Mezclas y pastas de harina, grañones, sémola, almidón, fécula o extracto de malta, sin cacao o con un contenido de cacao < 40% en peso calculado sobre una base totalmente desgrasada, n.c.o.p., así como mezclas y pastas de leche, nata, suero de mantequilla',19,1901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190190,'Outras preparações alimentícias de farinhas, sêmolas, amidos, féculas ou de extratos de malte sem cacau ou contendo menos de 40% de cacau em peso','Malt extract; food preparations of flour, groats, meal, starch or malt extract, not containing cocoa or containing < 40% by weight of cocoa calculated on a totally defatted basis, n.e.s. and food preparations of milk, cream, butter milk, sour milk, sour c','Extracto de malta; preparaciones alimenticias de harina, grañones, sémola, almidón, fécula o extracto de malta, sin cacao o con un contenido de cacao < 40% en peso calculado sobre una base totalmente desgrasada, n.c.o.p., así como preparaciones alimentici',19,1901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190211,'Massas alimentícias, não cozidas nem recheadas, contendo ovos','Uncooked pasta, not stuffed or otherwise prepared, containing eggs','Pastas alimenticias sin cocer, rellenar ni preparar de otra forma, que contengan huevo',19,1902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190219,'Outras massas alimentícias, não cozidas, nem recheadas, nem preparadas de outro modo','Uncooked pasta, not stuffed or otherwise prepared, not containing eggs','Pastas alimenticias sin cocer, rellenar ni preparar de otra forma, que no contengan huevo',19,1902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190220,'Massas alimentícias recheadas, mesmo cozidas ou preparadas de outro modo','Pasta, stuffed with meat or other substances, whether or not cooked or otherwise prepared','Pastas alimenticias rellenas de carne u otras sustancias, incl. cocidas o preparadas de otra forma',19,1902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190230,'Outras massas alimentícias','Pasta, cooked or otherwise prepared (excl. stuffed)','Pastas alimenticias cocidas o preparadas de otra forma (exc. las rellenas)',19,1902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190240,'Couscous','Couscous, whether or not prepared','Cuscús, incl. preparado',19,1902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190300,'Tapioca e seus sucedâneos preparados a partir de féculas, em flocos, grumos, grãos, pérolas ou formas semelhantes','Tapioca and substitutes therefor prepared from starch, in the form of flakes, grains, pearls, siftings or similar forms','Tapioca y sus sucedáneos preparados con fécula, en copos, grumos, granos perlados, cerniduras o formas simil.',19,1903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190410,'Produtos à base de cereais, obtidos por expansão ou por torrefação (por exemplo: flocos de milho)','Prepared foods obtained by swelling or roasting cereals or cereal products, e.g. corn flakes','Productos a base de cereales obtenidos por inflado o tostado, p.ej. hojuelas, copos de maíz',19,1904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190420,'Preparações alimentícias obtidas de flocos de cereais e misturas','Prepared foods obtained from unroasted cereal flakes or from mixtures of unroasted cereal flakes and roasted cereal flakes or swelled cereals','Preparaciones alimenticias obtenidas con copos de cereales sin tostar o con mezclas de copos de cereales sin tostar y copos de cereales tostados o cereales inflados',19,1904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190430,'Trigo burgol (bulgur)','Bulgur wheat in the form of worked grains, obtained by cooking hard wheat grains','Trigo bulgur en forma de granos trabajados, obtenidos cociendo granos de trigo duro',19,1904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190490,'Outros cereais em grãos, pré-cozidos ou preparados de outro modo','Cereals (excl. maize [corn]) in grain or flake form or other worked grains, pre-cooked or otherwise prepared, n.e.s. (excl. flour, groats and meal, food preparations obtained by swelling or roasting or from unroasted cereal flakes or from mixtures of unro','Cereales (exc. maíz), en grano o en forma de copos o demás granos trabajados, precocidos o preparados de otra forma, n.c.o.p. (exc. harina, grañones y sémola; productos obtenidos por insuflado o tostado; preparaciones alimenticias obtenidas con copos de c',19,1904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190510,'Pão denominado knackebrot','Crispbread','Pan crujiente llamado "Knäckebrot"',19,1905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190520,'Pão de especiarias','Gingerbread and the like, whether or not containing cocoa','Pan de especias, incl. con cacao',19,1905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190530,'Bolachas e biscoitos, adicionados de edulcorantes','Sweet biscuits','Galletas dulces',19,1905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190531,'Bolachas e biscoitos adicionados de edulcorantes','Sweet biscuits','Galletas dulces (con adición de edulcorante)',19,1905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190532,'Waffles e wafers','Waffles and wafers','Barquillos y obleas, incluso rellenos "gaufrettes, wafers" y "waffles [gaufres]"',19,1905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190540,'Torradas, pão torrado e produtos semelhantes torrados','Rusks, toasted bread and similar toasted products','Pan tostado y productos simil. tostados',19,1905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (190590,'Outros produtos de padaria, pastelaria ou da indústria de biscoitos, mesmo com adição de cacau','Bread, pastry, cakes, biscuits and other bakers'' wares, whether or not containing cocoa; communion wafers, empty cachets of a kind suitable for pharmaceutical use, sealing wafers, rice paper and similar products (excl. crispbread, gingerbread and the like','Productos de panadería, pastelería o galletería, incl. con adición de cacao; hostias, sellos vacíos de los tipos utilizados para medicamentos, obleas para sellar, pastas secas de harina, almidón o fécula, en hojas, y productos simil. (exc. "Knäckebrot", p',19,1905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200110,'Pepinos e pepininhos, preparados ou conservados em vinagre ou em ácido acético','Cucumbers and gherkins, prepared or preserved by vinegar or acetic acid','Pepinos y pepinillos, preparados o conservados en vinagre o en ácido acético',20,2001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200120,'cebolas preparadas, conservadas em vinagre, acido acético','prepared onions, preserved by vinegar, acetic acid','cebollas preparadas o conservadas en vinagre/ác.acético',20,2001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200190,'Outros produtos hortícolas, frutas e outras partes comestíveis de plantas, preparados ou conservados em vinagre ou em ácido acético','Vegetables, fruit, nuts and other edible parts of plants, prepared or preserved by vinegar or acetic acid (excl. cucumbers and gherkins)','Legumbres, hortalizas, frutos y demás partes comestibles de plantas, preparados o conservados en vinagre o en ácido acético (exc. pepinos y pepinillos)',20,2001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200210,'Tomates inteiros ou em pedaços, preparados ou conservados em vinagre ou em ácido acético','Tomatoes, whole or in pieces, prepared or preserved otherwise than by vinegar or acetic acid','Tomates, preparados o conservados sin vinagre ni ácido acético, enteros o en trozos',20,2002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200290,'Sucos de tomates e outros tomates preparados ou conservados, exceto em vinagre ou em ácido acético','Tomatoes, prepared or preserved otherwise than by vinegar or acetic acid (excl. whole or in pieces)','Tomates, preparados o conservados sin vinagre ni ácido acético (exc. enteros o en trozos)',20,2002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200310,'Cogumelos do gênero agaricus preparados ou conservados, exceto em vinagre ou em ácido acético','Mushrooms of the genus Agaricus, prepared or preserved otherwise than by vinegar or acetic acid','Hongos del género "Agaricus", preparados o conservados (exc. en vinagre o en ácido acético)',20,2003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200320,'Trufas preparadas ou conservadas, exceto em vinagre ou em ácido acético','Truffles, prepared or preserved otherwise than by vinegar or acetic acid','Trufas, preparadas o conservadas sin vinagre ni ácido acético',20,2003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200390,'Outros cogumelos, preparados ou conservados, exceto em vinagre ou ácido acético','Mushrooms, prepared or preserved otherwise than by vinegar or acetic acid (excl. mushrooms of the genus Agaricus)','Setas y demás hongos, preparadas o conservadas sin vinagre ni ácido acético (exc. del género "Agaricus)',20,2003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200410,'Batatas preparadas ou conservadas, congeladas, exceto em vinagre ou ácido acético','Potatoes, prepared or preserved otherwise than by vinegar or acetic acid, frozen','Patatas "papas", preparadas o conservadas sin vinagre ni ácido acético, congeladas',20,2004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200490,'Outros produtos hortícolas preparados ou conservados, exceto em vinagre ou em ácido acético, congelados','Vegetables and mixtures of vegetables, prepared or preserved otherwise than by vinegar or acetic acid, frozen (excl. preserved by sugar, and tomatoes, mushrooms, truffles and potatoes, unmixed)','Hortalizas, incl. "silvestres", y las mezclas de hortalizas, incl. "silvestres", preparadas o conservadas sin vinagre ni ácido acético, congeladas (exc. confitadas con azúcar, así como tomates, setas y demás hongos, trufas y patatas "papas" sin mezclar en',20,2004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200510,'Produtos hortícolas homogeneizados, preparados ou conservados, não congelados','Homogenised vegetables put up for retail sale as infant food or for dietetic purposes, in containers of <= 250 g','Hortalizas, incl. "silvestres", en forma de preparaciones homogeneizadas, para la alimentación infantil o para usos dietéticos, acondicionadas para la venta al por menor en envases con un contenido <= 250 g',20,2005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200520,'Batatas preparadas ou conservadas, exceto em vinagre ou ácido acético, não congeladas','Potatoes, prepared or preserved otherwise than by vinegar or acetic acid (excl. frozen)','Patatas "papas", preparadas o conservadas sin vinagre ni ácido acético, sin congelar',20,2005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200540,'Ervilhas preparadas ou conservadas, exceto em vinagre ou ácido acético, não congeladas','Peas Pisum Sativum, prepared or preserved otherwise than by vinegar or acetic acid (excl. frozen)','Guisantes "arvejas, chícharos" "Pisum sativum", preparados o conservados sin vinagre ni ácido acético, sin congelar',20,2005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200551,'Feijão em grão, preparado ou conservado, exceto em vinagre ou ácido acético, não congelado','Shelled beans Vigna spp., Phaseolus spp., prepared or preserved otherwise than by vinegar or acetic acid (excl. frozen)','Judías "porotos, alubias, frijoles, fréjoles" "Vigna spp.", "Phaseolus spp.", desvainadas, preparadas o conservadas sin vinagre ni ácido acético, sin congelar',20,2005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200559,'Outros feijões preparados ou conservados, exceto em vinagre ou em ácido acético, não congelados','Unshelled beans Vigna spp., Phaseolus spp., prepared or preserved otherwise than by vinegar or acetic acid (excl. frozen)','Judías "porotos, alubias, frijoles, fréjoles" "Vigna spp.", "Phaseolus spp.", preparadas o conservadas sin vinagre ni ácido acético, sin congelar (exc. desvainadas)',20,2005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200560,'Aspargos preparados ou conservados, exceto em vinagre ou ácido acético, não congelados','Asparagus, prepared or preserved otherwise than by vinegar or acetic acid (excl. frozen)','Espárragos, preparados o conservados sin vinagre ni ácido acético, sin congelar',20,2005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200570,'Azeitonas preparadas ou conservadas, exceto em vinagre ou ácido acético, não congeladas','Olives, prepared or preserved otherwise than by vinegar or acetic acid (excl. frozen)','Aceitunas, preparadas o conservadas sin vinagre ni ácido acético, sin congelar',20,2005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200580,'Milho doce, preparado ou conservado, exceto em vinagre ou ácido acético, não congelado','Sweetcorn Zea Mays var. Saccharata, prepared or preserved otherwise than by vinegar or acetic acid (excl. frozen)','Maíz dulce "Zea mays var. saccharata", preparado o conservado sin vinagre ni ácido acético, sin congelar',20,2005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200590,'outs.prods.horts.prepars/conserv.n/cong.exc.vinagre, etc','oth.vegetab.prepared/preserved, n/ froz.exc.vinager, etc.','las dem.hortalizas prep.o cons.exc.en vinag.s/cong.etc',20,2005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200591,'Brotos de bambu preparados ou conservados, exceto em vinagre ou em ácido acético, não congelados','Bamboo shoots, prepared or preserved otherwise than by vinegar or acetic acid (excl. frozen)','Brotes de bambú, preparados o conservados sin vinagre ni ácido acético, sin congelar',20,2005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200599,'Outros produtos hortícolas preparados ou conservados, exceto em vinagre ou em ácido acético, não congelados','Vegetables and mixtures of vegetables, prepared or preserved otherwise than by vinegar, non-frozen (excl. preserved by sugar, homogenised vegetables of subheading 2005.10, and tomatoes, mushrooms, truffles, potatoes, peas Pisum sativum, beans Vigna, Phase','Hortalizas, incl. "silvestres", y las mezclas de hortalizas, incl. "silvestres", preparadas o conservadas sin vinagre ni ácido acético, sin congelar (exc. las verduras confitadas al azúcar, las verduras homogenizadas del nº 2005.10, así como los tomates, ',20,2005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200600,'Produtos hortícolas, frutas e cascas, conservados em açúcar','Vegetables, fruit, nuts, fruit-peel and other edible parts of plants, preserved by sugar drained, glacé or crystallised','Hortalizas, incl. "silvestres", frutas u otros frutos o sus cortezas y demás partes de plantas, confitados con azúcar "almibarados, glaseados o escarchados"',20,2006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200710,'Preparações homogeneizadas de frutas, obtidas por cozimento','Homogenised preparations of jams, jellies, marmalades, fruit or nut purées and nut pastes, obtained by cooking, whether or not containing added sugar or other sweetening matter, put up for retail sale as infant food or for dietetic purposes, in containers','Confituras, jaleas y mermeladas, purés y pastas de frutas u otros frutos, obtenidos por cocción, incl. con adición de azúcar u otro edulcorante, en forma de preparaciones homogeneizadas, para la alimentación infantil o para usos dietéticos, acondicionadas',20,2007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200791,'Doces, geléias, marmelades, purês e pastas de cítricos','Citrus fruit jams, jellies, marmalades, purées or pastes, obtained by cooking, whether or not containing added sugar or other sweetening matter (excl. homogenised preparations of subheading 2007.10)','Confituras, jaleas y mermeladas, purés y pastas de agrios "cítricos", obtenidos por cocción, incl. con adición de azúcar u otro edulcorante (exc. preparaciones homogeneizadas)',20,2007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200799,'Geléias, doces, purês e marmelades, de outras frutas','Jams, jellies, marmalades, purées or pastes of fruit, obtained by cooking, whether or not containing added sugar or other sweetening matter (excl. citrus fruit and homogenised preparations of subheading 2007.10)','Confituras, jaleas y mermeladas, purés y pastas de frutas u otros frutos, obtenidos por cocción, incl. con adición de azúcar u otro edulcorante (exc. de agrios "cítricos", así como las preparaciones homogeneizadas)',20,2007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200811,'Amendoins preparados ou conservados','Groundnuts, prepared or preserved (excl. preserved with sugar)','Cacahuetes "cacahuetes, maníes", preparados o conservados (exc. confitados con azúcar)',20,2008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200819,'Outras frutas de casca rija e outras sementes, preparadas ou conservadas','Nuts and other seeds, incl. mixtures, prepared or preserved (excl. prepared or preserved with vinegar, preserved with sugar but not laid in syrup, jams, fruit jellies, marmalades, fruit purée and pastes, obtained by cooking, and groundnuts)','Frutos de cáscara y demás semillas, incl. mezclados entre sí, preparados o conservados (exc. preparados o conservados en vinagre o en ácido acético y confitados con azúcar pero no conservados en jarabe, así como confituras, jaleas y mermeladas, purés y pa',20,2008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200820,'Abacaxis preparados ou conservados','Pineapples, prepared or preserved, whether or not containing added sugar or other sweetening matter or spirit (excl. preserved with sugar but not laid in syrup, jams, fruit jellies, marmalades, fruit purée and pastes, obtained by cooking)','Piñas "ananás", preparadas o conservadas, incl. con adición de azúcar u otro edulcorante o alcohol (exc. confitadas con azúcar pero no conservadas en jarabe, así como confituras, jaleas y mermeladas, purés y pastas, de frutos, obtenidos por cocción)',20,2008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200830,'Cítricos preparados ou conservados','Citrus fruit, prepared or preserved, whether or not containing added sugar or other sweetening matter or spirit, n.e.s.','Agrios "cítricos", preparados o conservados, incl. con adición de azúcar u otro edulcorante o alcohol, n.c.o.p.',20,2008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200840,'Pêras preparadas ou conservadas','Pears, prepared or preserved, whether or not containing added sugar or other sweetening matter or spirit, n.e.s.','Peras, preparadas o conservadas, incl. con adición de azúcar u otro edulcorante o alcohol, n.c.o.p.',20,2008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200850,'Damascos preparados ou conservados','Apricots, prepared or preserved, whether or not containing added sugar or other sweetening matter or spirit (excl. preserved with sugar but not laid in syrup, jams, fruit jellies, marmalades, fruit purée and pastes, obtained by cooking)','Albaricoques "damascos, chabacanos", preparados o conservados, incl. con adición de azúcar u otro edulcorante o alcohol (exc. confitados con azúcar pero no conservados en jarabe, así como confituras, jaleas y mermeladas, purés y pastas, de frutos, obtenid',20,2008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200860,'Cerejas preparadas ou conservadas','Cherries, prepared or preserved, whether or not containing added sugar or other sweetening matter or spirit (excl. preserved with sugar but not laid in syrup, jams, fruit jellies, marmalades, fruit purée and pastes, obtained by cooking)','Cerezas, preparadas o conservadas, incl. con adición de azúcar u otro edulcorante o alcohol (exc. confitadas con azúcar pero no conservadas en jarabe, así como confituras, jaleas y mermeladas, purés y pastas, de frutos, obtenidos por cocción)',20,2008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200870,'Pêssegos preparados ou conservados','Peaches, incl. nectarines, prepared or preserved, whether or not containing added sugar or other sweetening matter or spirit (excl. preserved with sugar but not laid in syrup, jams, fruit jellies, marmalades, fruit purée and pastes, obtained by cooking)','Melocotones "duraznos", incl. los griñones y nectarinas, preparados o conservados, incl. con adición de azúcar u otro edulcorante o alcohol (exc. confitados con azúcar pero no conservados en jarabe, así como confituras, jaleas y mermeladas, purés y pastas',20,2008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200880,'Morangos preparados ou conservados','Strawberries, prepared or preserved, whether or not containing added sugar or other sweetening matter or spirit, n.e.s.','Fresas "frutillas", preparadas o conservadas, incl. con adición de azúcar u otro edulcorante o alcohol, n.c.o.p.',20,2008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200891,'Palmitos preparados ou conservados','Palm hearts, prepared or preserved, whether or not containing added sugar or other sweetening matter or spirit (excl. prepared or preserved with vinegar)','Palmitos, preparados o conservados, incl. con adición de azúcar u otro edulcorante o alcohol (exc. preparados o conservados en vinagre o en ácido acético)',20,2008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200892,'Misturas de frutas preparadas ou conservadas','Mixtures of fruits, nuts and other edible parts of plants, prepared or preserved, whether or not containing added sugar or other sweetening matter or spirit (excl. mixtures of nuts, groundnuts and other seeds and preparations of the Musli type based on u','Mezclas de frutas u otro frutos y demás partes comestibles de plantas, preparadas o conservadas, incl. con adición de azúcar u otro edulcorante o alcohol (exc. mezclas de frutos de cáscara, de cacahuetes "cacahuetes, maníes" y demás semillas; preparacione',20,2008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200893,'Airelas vermelhas, preparadas ou conserv. de outro modo','Cranberry red, prepared or preserved in other forms','Arándano rojo, preparadas y conservadas de otra forma',20,2008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200897,'Misturas de outras frutas','Mixtures of other fruits','Las mezclas de otras frutas',20,2008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200899,'Outras frutas e partes de plantas, preparadas ou conservadas','Fruit and other edible parts of plants, prepared or preserved, whether or not containing added sugar or other sweetening matter or spirit (excl. prepared or preserved with vinegar, preserved with sugar but not laid in syrup, jams, fruit jellies, marmalade','Frutas u otros frutos y demás partes comestibles de plantas, preparadas o conservadas, incl. con adición de azúcar u otro edulcorante o alcohol (exc. productos preparados o conservados en vinagre o en ácido acético; productos confitados con azúcar pero no',20,2008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200911,'Sucos de laranjas, congelados, não fermentados','Frozen orange juice, unfermented, whether or not containing added sugar or other sweetening matter (excl. containing spirit)','Jugo de naranja, sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante, congelado',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200912,'Sucos de laranja não congelados, não fermentados, com valor Brix <= 20','Orange juice, unfermented, Brix value <= 20 at 20°C, whether or not containing added sugar or other sweetening matter (excl. containing spirit and frozen)','Jugo de naranja, sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante, de valor Brix <= 20 a 20°C (exc. congelado)',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200919,'Outros sucos de laranjas, não fermentados','Orange juice, unfermented, whether or not containing added sugar or other sweetening matter (excl. containing spirit, frozen, and of a Brix value <= 20 at 20°C)','Jugo de naranja, sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante (exc. de valor Brix <= 20 a 20°C, así como congelado)',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200920,'sucos de pomelos ("grapefruit"), não fermentados','grapefruit juice,  unfermented','jugo de pomelo ("grapefruit"),  sin fermentar',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200921,'Suco de pomelo (grapefruit) não fermentado, com valor Brix <= 20','Grapefruit juice, unfermented, Brix value <= 20 at 20°C, whether or not containing added sugar or other sweetening matter (excl. containing spirit)','Jugo de toronja o de pomelo, sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante, de valor Brix <= 20 a 20°C',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200929,'Outros sucos de pomelo (grapefruit), não fermentados','Grapefruit juice, unfermented, Brix value > 20 at 20°C, whether or not containing added sugar or other sweetening matter (excl. containing spirit)','Jugo de toronja o de pomelo, sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante, de valor Brix > 20 a 20°C',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200930,'sucos de outros cítricos, não fermentados','other citric juices,  unfermented','jugos de demás agrios,  sin fermentar',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200931,'Suco de outros cítricos, não fermentado, com valor Brix <= 20','Single citrus fruit juice, unfermented, Brix value <= 20 at 20°C, whether or not containing added sugar or other sweetening matter (excl. containing spirit, mixtures, orange juice and grapefruit juice)','Jugo de agrios "cítricos", sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante, de valor Brix <= 20 a 20°C (exc. de naranja, de toronja o de pomelo, así como las mezclas)',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200939,'Outros sucos de outros cítricos, não fermentados','Single citrus fruit juice, unfermented, Brix value > 20 at 20°C, whether or not containing added sugar or other sweetening matter (excl. containing spirit, mixtures, orange juice and grapefruit juice)','Jugo de agrios "cítricos", sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante, de valor Brix > 20 a 20°C (exc. de naranja, de toronja o de pomelo, así como las mezclas)',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200940,'sucos de abacaxis (ananases), não fermentados','pineapple juices, unfermented','jugo de piña, sin fermentar',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200941,'Suco de abacaxi (ananás), não fermentado, com valor Brix <= 20','Pineapple juice, unfermented, Brix value <= 20 at 20°C, whether or not containing added sugar or other sweetening matter (excl. containing spirit)','Jugo de piña "ananá", sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante, de valor Brix <= 20 a 20°C',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200949,'Outros sucos de abacaxi, não fermentados','Pineapple juice, unfermented, Brix value > 20 at 20°C, whether or not containing added sugar or other sweetening matter (excl. containing spirit)','Jugo de piña "ananá", sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante, de valor Brix > 20 a 20°C',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200950,'Sucos de tomates, não fermentados','Tomato juice, unfermented, whether or not containing added sugar or other sweetening matter (excl. containing spirit)','Jugo de tomate, sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200960,'Sucos de uvas (incluso os mostos de uvas), não fermentados','Grape juice, unfermented','Jugo de uva,  (incluso el mosto) sin fermentar',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200961,'Suco de uvas (inclusive os mostos de uvas), não fermentado, com valor Brix <= 30','Grape juice, incl. grape must, unfermented, Brix value <= 30 at 20°C, whether or not containing added sugar or other sweetening matter (excl. containing spirit)','Jugo de uva, incl. el mosto, sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante, de valor Brix <= 30 a 20°C',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200969,'Outros sucos de uvas (inclusive os mostos de uvas), não fermentados','Grape juice, incl. grape must, unfermented, Brix value > 30 at 20°C, whether or not containing added sugar or other sweetening matter (excl. containing spirit)','Jugo de uva, incl. el mosto, sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante, de valor Brix > 30 a 20°C',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200970,'Sucos de maçãs, não fermentados','Apple juices, unfermented','Jugo de manzana, sin fermentar',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200971,'Suco de maçã, não fermentado, com valor Brix <= 20','Apple juice, unfermented, Brix value <= 20 at 20°C, whether or not containing added sugar or other sweetening matter (excl. containing spirit)','Jugo de manzana, sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante, de valor Brix <= 20 a 20°C',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200979,'Outros sucos de maçã, não fermentados','Apple juice, unfermented, Brix value > 20 at 20°C, whether or not containing added sugar or other sweetening matter (excl. containing spirit)','Jugo de manzana, sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante, de valor Brix > 20 a 20°C',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200980,'Sucos de outras frutas ou de produtos hortícolas, não fermentados','Juice of fruit or vegetables, unfermented, whether or not containing added sugar or other sweetening matter (excl. containing spirit, mixtures, and juice of citrus fruit, pineapples, tomatoes, grapes, incl. grape must and apples)','Jugos de frutas u otros frutos, o hortalizas, incl. "silvestres", sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante (exc. de agrios "cítricos", de piña "ananá", de tomate, de uva, incl. el mosto, y de manzana, así como',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200981,'Suco (sumo) de airela vermelha','Juice (juice) cranberry red','Jugo (zumo) de arándano rojo',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200989,'Suco (sumo) de qualquer outra fruta ou produto hortícola','Juice of any other single fruit or vegetable','Jugo (zumo) de cualquier otra fruta o vegetal',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (200990,'Misturas de sucos, não fermentados','Mixtures of fruit juices, incl. grape must, and vegetable juices, unfermented, whether or not containing added sugar or other sweetening matter (excl. containing spirit)','Mezclas de jugos de frutas u otros frutos, incl. el mosto, o de hortalizas, incl. "silvestres", sin fermentar y sin adición de alcohol, incl. con adición de azúcar u otro edulcorante',20,2009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210111,'Extratos, essências e concentrados de café','Extracts, essences and concentrates, of coffee','Extractos, esencias y concentrados de café',21,2101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210112,'Preparações à base de extratos, essências e concentrados de café','Preparations with a basis of extracts, essences or concentrates of coffee or with a basis of coffee','Preparaciones a base de extractos, esencias o concentrados de café o a base de café',21,2101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210120,'Extratos, essências, concentrados de chá ou mate e preparações à base destes produtos','Extracts, essences and concentrates, of tea or mate, and preparations with a basis of these extracts, essences or concentrates, or with a basis of tea or maté','Extractos, esencias y concentrados de té o de yerba mate y preparaciones a base de estos extractos, esencias o concentrados o a base de té o de yerba mate',21,2101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210130,'Chicória torrada e outros sucedâneos torrados do café e respectivos extratos, essências e concentrados','Roasted chicory and other roasted coffee substitutes, and extracts, essences and concentrates thereof','Achicoria tostada y demás sucedáneos del café tostados y sus extractos, esencias y concentrados',21,2101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210210,'Leveduras vivas','Active yeasts','Levaduras vivas',21,2102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210220,'Leveduras mortas e outros microorganismos monocelulares mortos','Inactive yeasts; other dead single-cell micro-organisms (excl. packaged as medicaments)','Levaduras muertas; los demás microorganismos monocelulares muertos (exc. microorganismos monocelulares acondicionados como medicamentos)',21,2102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210230,'Pós para levedar, preparados','Prepared baking powders','Polvos de levantar preparados',21,2102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210310,'Molho de soja','Soya sauce','Salsa de soja "soya"',21,2103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210320,'Ketchup e outros molhos de tomate','Tomato ketchup and other tomato sauces','"Ketchup" y demás salsas de tomate',21,2103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210330,'Farinha de mostarda e mostarda preparada','Mustard flour and meal, whether or not prepared, and mustard','Harina de mostaza y mostaza preparada',21,2103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210390,'Maionese e outros condimentos e temperos compostos','Preparations for sauces and prepared sauces; mixed condiments and seasonings (excl. soya sauce, tomato ketchup and other tomato sauces, mustard, and mustard flour and meal)','Preparaciones para salsas y salsas preparadas; condimentos y sazonadores, compuestos (exc. salsa de soja "soya", "ketchup" y demás salsas de tomate, harina de mostaza y mostaza preparada)',21,2103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210410,'Preparações para caldos e sopas; caldos e sopas preparados','Soups and broths and preparations therefor','Preparaciones para sopas, potajes o caldos; sopas, potajes o caldos, preparados',21,2104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210420,'Preparações alimentícias compostas, homogeneizadas','Food preparations consisting of finely homogenised mixtures of two or more basic ingredients, such as meat, fish, vegetables or fruit, put up for retail sale as infant food or for dietetic purposes, in containers of <= 250 g','Preparaciones para la alimentación infantil o para usos dietéticos que consistan en una mezcla finamente homogeneizada de varias sustancias básicas, tales como carne, pescado, legumbres u hortalizas o frutas, acondicionadas para la venta al por menor en e',21,2104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210500,'Sorvetes, mesmo contendo cacau','Ice cream and other edible ice, whether or not containing cocoa','Helados, incluso con cacao',21,2105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210610,'Concentrados de proteínas e substâncias protéicas texturizadas','Protein concentrates and textured protein substances','Concentrados de proteínas y sustancias proteicas texturadas',21,2106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (210690,'Outras preparações alimentícias','Food preparations, n.e.s.','Preparaciones alimenticias, n.c.o.p.',21,2106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220110,'Águas minerais e águas gaseificadas','Mineral waters and aerated waters, not containing added sugar, other sweetening matter or flavoured','Agua mineral y agua gaseada, sin adición de azúcar u otro edulcorante ni aromatizados',22,2201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220190,'Outras águas, não adicionadas de açúcar nem aromatizadas; gelo e neve','Ordinary natural water, not containing added sugar, other sweetening matter or flavoured; ice and snow (excl. mineral waters and aerated waters, sea water, distilled water, conductivity water or water of similar purity)','Agua, sin adición de azúcar u otro edulcorante ni aromatizados; hielo y nieve (exc. agua mineral, agua gaseada, agua de mar, agua destilada, de conductibilidad o del mismo grado de pureza)',22,2201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220210,'Águas, incluídas as águas minerais e as águas gaseificadas, adicionadas de açúcar ou aromatizadas','Waters, incl. mineral and aerated, with added sugar, sweetener or flavour, for direct consumption as a beverage','Agua, incl. el agua mineral y la gaseada, con adición de azúcar u otro edulcorante o aromatizada, que pueda consumirse directamente como bebida',22,2202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220290,'Outras bebidas não alcoólicas, exceto sucos de frutas ou de produtos hortícolas','Non-alcoholic beverages (excl. water, fruit or vegetable juices and milk)','Bebidas no alcohólicas (exc. agua, jugos de frutas u otros frutos o de hortalizas y leche)',22,2202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220300,'Cervejas de malte','Beer made from malt','Cerveza de malta',22,2203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220410,'Vinhos espumantes e espumosos','Sparkling wine of fresh grapes','Vino espumoso, de uvas frescas',22,2204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220421,'Outros vinhos; mostos de uvas, cuja fermentação tenha sido impedida por adição de álcool, em recipientes com capacidade <= 2 litros','Wine of fresh grapes, incl. fortified wines, and grape must whose fermentation has been arrested by the addition of alcohol, in containers of <= 2 l (excl. sparkling wine)','Vino de uvas frescas, incl. encabezado; mosto de uva, en el que la fermentación se ha impedido o cortado añadiéndole alcohol, en recipientes con capacidad <= 2 litros (exc. vino espumoso)',22,2204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220429,'Outros vinhos; mostos de uvas, cuja fermentação tenha sido impedida por adição de álcool, em recipientes com capacidade > 2 litros','Wine of fresh grapes, incl. fortified wines, and grape must whose fermentation has been arrested by the addition of alcohol, in containers of > 2 l (excl. sparkling wine)','Vino de uvas frescas, incl. encabezado, y mosto de uva en el que la fermentación se ha impedido o cortado añadiendo alcohol, en recipientes con capacidad < 2 l',22,2204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220430,'Outros mostos de uvas parcialmente fermentados','Grape must, of an actual alcoholic strength of > 0,5% vol (excl. grape must whose fermentation has been arrested by the addition of alcohol)','Mosto de uva, parcialmente fermentado, de grado alcohólico adquirido > 0,5% vol (exc. mosto en el que la fermentación se ha impedido o cortado añadiéndole alcohol)',22,2204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220510,'Vermutes e outros vinhos de uvas frescas, aromatizados, em recipientes com capacidade <= 2 litros','Vermouth and other wine of fresh grapes, flavoured with plants or aromatic substances, in containers of <= 2 l','Vermut y demás vinos de uvas frescas preparados con plantas o sustancias aromáticas, en recipientes con capacidad <= 2 l',22,2205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220590,'Outros vermutes e vinhos de uvas frescas, aromatizados','Vermouth and other wine of fresh grapes, flavoured with plants or aromatic substances, in containers of > 2 l','Vermut y demás vinos de uvas frescas preparados con plantas o sustancias aromáticas, en recipientes con capacidad > 2 l',22,2205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220600,'Sidra e outras bebidas fermentadas e misturas de bebidas fermentadas','Cider, perry, mead and other fermented beverages and mixtures of fermented beverages and non-alcoholic beverages, n.e.s. (excl. beer, wine or fresh grapes, grape must, vermouth and other wine of fresh grapes flavoured with plants or aromatic substances)','Sidra, perada, aguamiel y demás bebidas fermentadas; mezclas de bebidas fermentadas y mezclas de bebidas fermentadas y bebidas no alcohólicas, n.c.o.p. (exc. cerveza, vino de uvas, mosto de uvas, vermut y demás vinos de uvas frescas preparados con plantas',22,2206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220710,'Álcool etílico não desnaturado com volume de teor alcoólico => 80%','Undenatured ethyl alcohol, of actual alcoholic strength of >= 80%','Alcohol etílico sin desnaturalizar con grado alcohólico volumétrico >= 80% vol',22,2207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220720,'Álcool etílico e aguardentes desnaturados com qualquer teor alcoólico','Denatured ethyl alcohol and other spirits of any strength','Alcohol etílico y aguardiente desnaturalizados, de cualquier graduación',22,2207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220820,'Aguardentes de vinho ou de bagaço de uvas','Spirits obtained by distilling grape wine or grape marc','Aguardiente de vino o de orujo de uvas',22,2208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220830,'Uísques','Whiskies','Whisky',22,2208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220840,'Cachaça e caninha (rum e tafiá)','Rum and other spirits obtained by distilling fermented sugar-cane products','Ron y aguardiente de caña',22,2208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220850,'Gim e genebra','Gin and Geneva','Gin y ginebra',22,2208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220860,'Vodca','Vodka','Vodka',22,2208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220870,'Licores','Liqueurs and cordials','Licores',22,2208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220890,'Outras bebidas alcoólicas','Ethyl alcohol of an alcoholic strength of < 80% vol, not denatured; spirits and other spirituous beverages (excl. compound alcoholic preparations of a kind used for the manufacture of beverages, spirits obtained by distilling grape wine or grape marc, whi','Alcohol etílico sin desnaturalizar con un grado alcohólico volumétrico < 80% vol; aguardientes y demás bebidas espirituosas (exc. preparaciones alcohólicas compuestas del tipo de las elaboradas para la elaboración de bebidas, aguardiente de vino o de oruj',22,2208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (220900,'Vinagres e sucedâneos obtidos a partir do ácido acético, para uso alimentar','Vinegar, fermented vinegar and substitutes for vinegar obtained from acetic acid','Vinagre y sucedáneos del vinagre obtenidos a partir del ácido acético',22,2209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230110,'Farinhas, pós e pellets de carnes ou de miudezas, impróprios para alimentação humana; torresmos','Flours, meals and pellets, of meat or offal, unfit for human consumption; greaves','Harina, polvo y "pellets", de carne o de despojos, impropios para la alimentación humana; chicharrones',23,2301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230120,'Farinhas, pós e pellets de peixes ou crustáceos, impróprios para alimentação humana','Flours, meals and pellets of fish or crustaceans, molluscs or other aquatic invertebrates, unfit for human consumption','Harina, polvo y "pellets", de pescado o de crustáceos, de moluscos o demás invertebrados acuáticos, impropios para la alimentación humana',23,2301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230210,'Sêmeas, farelos e outros resíduos de milho','Bran, sharps and other residues of maize corn, whether or not in the form of pellets, derived from sifting, milling or other working','Salvados, moyuelos y demás residuos del cernido, de la molienda o de otros tratamientos del maíz, incl. en "pellets"',23,2302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230220,'Farelos e outros resíduos, de arroz','Sharps and other residues of rice','Moyuelos y demás residuos de arroz',23,2302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230230,'Sêmeas, farelos e outros resíduos de trigo','Bran, sharps and other residues of wheat, whether or not in the form of pellets, derived from sifting, milling or other working','Salvados, moyuelos y demás residuos del cernido, de la molienda o de otros tratamientos del trigo, incl. en "pellets"',23,2302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230240,'Sêmeas, farelos e outros resíduos de outros cereais','Bran, sharps and other residues of cereals, whether or not in the form of pellets, derived from sifting, milling or other working (excl. maize and wheat)','Salvados, moyuelos y demás residuos del cernido, de la molienda o de otros tratamientos de los cereales, incl. en "pellets" (exc. de maíz, de arroz o de trigo)',23,2302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230250,'Sêmeas, farelos e outros resíduos de leguminosas','Bran, sharps and other residues of leguminous plants, whether or not in the form of pellets, derived from sifting, milling or other working','Salvados, moyuelos y demás residuos del cernido, de la molienda o de otros tratamientos de las leguminosas, incl. en "pellets"',23,2302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230310,'Resíduos da fabricação do amido e resíduos semelhantes','Residues of starch manufacture and similar residues','Residuos de la industria del almidón y residuos simil.',23,2303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230320,'Polpas de beterraba, bagaços de cana-de-açúcar e outros desperdícios da indústria do açúcar','Beet-pulp, bagasse and other waste of sugar manufacture','Pulpa de remolacha, bagazo de caña de azúcar y demás desperdicios de la industria azucarera',23,2303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230330,'Borras e desperdícios da indústria da cerveja e das destilarias','Brewing or distilling dregs and waste','Heces y desperdicios de cervecería o de destilería',23,2303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230400,'Tortas e outros resíduos sólidos da extração do óleo de soja','Oilcake and other solid residues, whether or not ground or in the form of pellets, resulting from the extraction of soya-bean oil','Tortas y demás residuos sólidos de la extracción del aceite de soja "soya", incl. molidos o en "pellets"',23,2304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230500,'Tortas e outros resíduos sólidos da extração de óleo de amendoim','Oilcake and other solid residues, whether or not ground or in the form of pellets, resulting from the extraction of groundnut oil','Tortas y demás residuos sólidos de la extracción del aceite de cacahuete "cacahuate, maní", incl. molidos o en "pellets"',23,2305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230610,'Tortas e outros resíduos sólidos da extração de óleo de algodão','Oilcake and other solid residues, whether or not ground or in the form of pellets, resulting from the extraction of cotton seeds','Tortas y demás residuos sólidos de la extracción de materias grasas o aceites vegetales, de semillas de algodón, incl. molidos o en "pellets"',23,2306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230620,'Tortas e outros resíduos sólidos da extração de óleo de linhaça','Oilcake and other solid residues, whether or not ground or in the form of pellets, resulting from the extraction of linseed','Tortas y demás residuos sólidos de la extracción de materias grasas o aceites vegetales, de semillas de lino, incl. molidos o en "pellets"',23,2306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230630,'Tortas e outros resíduos sólidos da extração de óleo de girassol','Oilcake and other solid residues, whether or not ground or in the form of pellets, resulting from the extraction of sunflower seeds','Tortas y demás residuos sólidos de la extracción de materias grasas o aceites vegetales, de semillas de girasol, incl. molidos o en "pellets"',23,2306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230640,'Tortas, outros resids.sólidos, do nabo silvestre, da colza','Oilcake and other solid residues, of rape, of colza','Tortas, dem.resid.sólidos, de nabina, de colza',23,2306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230641,'Torta de sementes de nabo silvestre ou de colza, de baixo teor de ácido erúcico','Oilcake and other solid residues, whether or not ground or in the form of pellets, resulting from the extraction of low erucic acid rape or colza seeds yielding a fixed oil which has an erucic acid content of < 2% and yielding a solid component of glucosi','Tortas y demás residuos sólidos de la extracción de materias grasas o aceites vegetales, de semillas de nabo "nabina" o de colza con bajo contenido de ácido erúcico "de las que se obtiene un aceite fijo con un contenido de ácido erúcico < 2% en peso y un ',23,2306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230649,'Outras tortas de sementes de nabo silvestre ou de colza','Oilcake and other solid residues, whether or not ground or in the form of pellets, resulting from the extraction of high erucic acid rape or colza seeds yielding a fixed oil which has an erucic acid content of >= 2% and yielding a solid component of gluco','Tortas y demás residuos sólidos de la extracción de materias grasas o aceites vegetales, de semillas de nabo "nabina" o de colza con alto contenido de ácido erúcico "de las que se obtiene un aceite fijo con un contenido de ácido erúcico >= 2% en peso y un',23,2306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230650,'Tortas e outros resíduos sólidos da extração do óleo de coco ou de copra','Oilcake and other solid residues, whether or not ground or in the form of pellets, resulting from the extraction of coconut or copra','Tortas y demás residuos sólidos de la extracción de materias grasas o aceites vegetales, de coco o de copra, incl. molidos o en "pellets"',23,2306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230660,'Tortas e outros resíduos sólidos da extração do óleo de nozes ou de palmiste','Oilcake and other solid residues, whether or not ground or in the form of pellets, resulting from the extraction of palm nuts or kernels','Tortas y demás residuos sólidos de la extracción de materias grasas o aceites vegetales, de nuez o de almendra de palma, incl. molidos o en "pellets"',23,2306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230670,'Tortas e outros resíduos sólidos, do germe de milho','Oilcake and other solid residues, of maize germ','Tortas y demás residuos sólidos, de germen de maíz',23,2306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230690,'Tortas e outros resíduos sólidos da extração de outros óleos ou gorduras vegetais','Oilcake and other solid residues, whether or not ground or in the form of pellets, resulting from the extraction of vegetable fats or oils (excl. of cotton seeds, linseed, sunflower seeds, rape or colza seeds, coconut or copra, palm nuts or kernels, or fr','Tortas y demás residuos sólidos de la extracción de materias grasas o aceites vegetales, incl. molidos o en "pellets" (exc. de semillas de algodón, de lino, de girasol, de nabo "de nabina" "de nabina" o de colza, de coco o de copra, de nuez o de almendra ',23,2306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230700,'Borras de vinho; tártaro em bruto','Wine lees; argol','Lías o heces de vino; tártaro bruto',23,2307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230800,'Matérias vegetais, subprodutos, resíduos e desperdícios vegetais, utilizados na alimentação de animais','Acorns, horse-chestnuts, marc and other vegetable materials and vegetable waste, vegetable residues and by-products of a kind used in animal feeding, whether or not in the form of pellets, n.e.s.','Bellotas y castañas de Indias, orujo y demás materias vegetales y desperdicios vegetales, residuos y subproductos vegetales, de los tipos utilizados para la alimentación de los animales, incl. en "pellets", n.c.o.p.',23,2308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230810,'Bolotas de carvalho e castanhas-da-india,  para alimentação animal','Acorns of oak and chestnut-from-indian, foranimal cons.','Bellotas y castañas de indias, p/la alim.animal',23,2308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230890,'Matérias, desperdícios, resids.etc.vegetais,  para alimentação animal','Vegetable materials, waste, residues, etc.for animal consum.','Materias, desperdicios, residuos, etc, veg.p/alim.de anim.',23,2308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230910,'Alimentos para cães e gatos, acondicionados para venda a retalho','Dog or cat food, put up for retail sale','Alimentos para perros o gatos, acondicionados para la venta al por menor',23,2309);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (230990,'Outras preparações para alimentação de animais','Preparations of a kind used in animal feeding (excl. dog or cat food put up for retail sale)','Preparaciones de los tipos utilizados para la alimentación de los animales (exc. alimentos para perros o gatos, acondicionados para la venta al por menor)',23,2309);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (240110,'Fumo não manufaturado, não destalado','Tobacco, unstemmed or unstripped','Tabaco, sin desvenar o desnervar',24,2401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (240120,'Fumo não manufaturado, total ou parcialmente destalado','Tobacco, partly or wholly stemmed or stripped, otherwise unmanufactured','Tabaco, total o parcialmente desvenado o desnervado pero sin elaborar de otro modo',24,2401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (240130,'Desperdícios de fumo','Tobacco refuse','Desperdicios de tabaco',24,2401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (240210,'Charutos e cigarrilhas, de fumo','Cigars, cheroots and cigarillos containing tobacco','Cigarros "puros", incl. despuntadosy cigarritos "puritos", que contengan tabaco',24,2402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (240220,'Cigarros contendo fumo','Cigarettes, containing tobacco','Cigarrillos que contengan tabaco',24,2402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (240290,'Charutos, cigarrilhas e cigarros de sucedâneos de fumo (tabaco)','Cigars, cheroots, cigarillos and cigarettes consisting wholly of tobacco substitutes','Cigarros "puros", incl. despuntados, cigarritos "puritos" y cigarrillos, exclusivamente de sucedáneos del tabaco',24,2402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (240310,'Fumo manufaturado, para fumar, mesmo contendo sucedâneos do fumo','Smoking tobacco, whether or not containing tobacco substitutes in any proportion','Tabaco para fumar, incl. con sucedáneos de tabaco en cualquier proporción',24,2403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (240311,'Tabaco para narguile, mencionado na nota 1 da subposição 2403','Narghile tobacco, mentioned in footnote 1 of  heading 2403','Tabaco, Narguile, citado en la nota 1 de la partida 2403',24,2403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (240319,'Outros tabacos para fumar','Other tobacco for smoking','Demás tabacos para fumar',24,2403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (240391,'Fumo manufaturado, homogeneizado ou reconstituído','Tobacco, homogenised or reconstituted from finely-chopped tobacco leaves, tobacco refuse or tobacco dust','Tabaco "homogeneizado" o "reconstituido", obtenido por aglomeración de escamillas procedentes de hojas, de residuos o de polvo de tabaco',24,2403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (240399,'Extratos, molhos e outros produtos do fumo e seus sucedâneos, manufaturados','Chewing tobacco, snuff and other manufactured tobacco and manufactured tobacco substitutes, and tobacco powder, tobacco extracts and essences (excl. cigars, cheroots, cigarillos and cigarettes, smoking tobacco whether or not containing tobacco substitutes','Tabaco de mascar, rapé y demás tabacos y sucedáneos del tabaco, elaborados; polvo, extractos y jugos de tabaco (exc. cigarros "puros", incl. despuntados, cigarritos "puritos" y cigarrillos, tabaco para fumar, incl. con sucedáneos de tabaco en cualquier pr',24,2403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250100,'Sal (incluídos o sal de mesa e o sal desnaturado) e cloreto de sódio puro, mesmo em solução aquosa ou adicionados de agentes antiaglomerantes','Salts, incl. table salt and denatured salt, and pure sodium chloride, whether or not in aqueous solution or containing added anti-caking or free-flowing agents; sea water','Sal, incl. la de mesa y la desnaturalizada, y cloruro de sodio puro, incl. en disolución acuosa o con adición de antiaglomerantes o de agentes que garanticen una buena fluidez; agua de mar',25,2501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250200,'Piritas de ferro não ustuladas','Unroasted iron pyrites','Piritas de hierro, sin tostar',25,2502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250300,'Enxofre de qualquer espécie, exceto sublimado, precipitado ou coloidal','Sulphur of all kinds (excl. sublimed sulphur, precipitated sulphur and colloidal sulphur)','Azufre de cualquier clase (exc. el sublimado, el precipitado y el coloidal)',25,2503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250410,'Grafita natural, em pó ou em escamas','Natural graphite in powder or in flakes','Grafito natural, en polvo o en escamas',25,2504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250490,'Outras formas de grafita natural','Natural graphite (excl. in powder or in flakes)','Grafito natural (exc. en polvo o en escamas)',25,2504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250510,'Areias siliciosas e areias quartzosas','Silica sands and quartz sands, whether or not coloured','Arenas silíceas y arenas cuarzosas, incl. coloreadas',25,2505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250590,'Outras areias naturais, mesmo coradas','Natural sands of all kinds, whether or not coloured (excl. silica sands, quartz sands, gold- and platinum-bearing sands, zircon, rutile and ilmenite sands, monazite sands, and tar or asphalt sands)','Arenas naturales de cualquier clase, incl. coloreadas (exc. arenas auríferas y platiníferas, arenas de circón, de rutilo y de ilmenita, arenas monacíticas, arenas bituminosas o asfálticas, arenas silíceas y arenas cuarzosas)',25,2505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250610,'Quartzo','Quartz (excl. quartz sands)','Cuarzo (exc. arenas naturales cuarzosas)',25,2506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250620,'Quartzitos, mesmo desbastados ou cortados, em blocos ou placas de forma quadrada ou retangular','Quartzite, merely cut, by sawing or otherwise, in blocks or slabs of a square or rectangular shape',' Cuarcita, incl. desbastada o simplemente troceada en bloques o en placas cuadradas o rectangulares',25,2506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250621,'Quartzitos em bruto ou desbastados','Quartzite, crude or roughly trimmed','Cuarcita, en bruto o desbastados',25,2506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250629,'Outras formas de quartzitos','Other forms of quartzite','Demás formas de cuarcitas',25,2506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250700,'Caulim e outras argilas caulínicas, mesmo calcinadas','Kaolin and other kaolinic clays, whether or not calcined','Caolín y demás arcillas caolínicas, incl. calcinados',25,2507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250810,'Bentonita','Bentonite','Bentonita',25,2508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250820,'terras descorantes e terras de pisao (terras "fuller")','decolourizing earths and fuller''s earth','tierras decolorantes y tierras de batán',25,2508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250830,'Argilas refratárias','Fireclay (excl. kaolin and other kaolinic clays and expanded clay)','Arcillas refractarias (exc. arcilla dilatada, caolín y demás arcillas caolínicas)',25,2508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250840,'Outras argilas','Clays (excl. fireclay, bentonite, kaolin and other kaolinic clays and expanded clay)','Arcilla (exc. arcilla refractaria, arcilla dilatada, caolín y demás arcillas caolínicas)',25,2508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250850,'Andaluzita, cianita e silimanita','Andalusite, kyanite and sillimanite','Andalucita, cianita y silimanita',25,2508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250860,'Mulita','Mullite','Mullita',25,2508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250870,'Barro cozido em pó (terra chamotte) e terra de dinas','Chamotte or dinas earths','Tierras de chamota o de dinas',25,2508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (250900,'Cré','Chalk','Creta',25,2509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251010,'Fosfatos de cálcio naturais, fosfatos aluminocálcicos naturais, cré-fosfatado, não moídos','Natural calcium phosphates and natural aluminium calcium phosphates, natural and phosphatic chalk, unground','Fosfatos de calcio naturales, fosfatos aluminocálcicos naturales y cretas fosfatadas, sin triturar',25,2510);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251020,'Fosfatos de cálcio naturais, fosfatos aluminocálcicos naturais, cré-fosfatado, moídos','Natural calcium phosphates and natural aluminium calcium phosphates, natural and phosphatic chalk, ground','Fosfatos de calcio naturales, fosfatos aluminocálcicos naturales y cretas fosfatadas, molidos',25,2510);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251110,'Sulfato de bário natural (baritina)','Natural barium sulphate barytes','Sulfato de bario natural "baritina"',25,2511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251120,'Carbonato de bário natural (witherita)','Natural barium carbonate witherite, whether or not calcined (excl. barium oxide)','Carbonato de bario natural "witherita", incl. calcinado',25,2511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251200,'Farinhas siliciosas fósseis e outras terras siliciosas, de densidade aparente <= 1','Siliceous fossil meals, e.g. kieselguhr, tripolite and diatomite, and similar siliceous earths, whether or not calcined, of an apparent specific gravity of <= 1','"Kieselguhr", tripolita y diatomita y demás harinas silíceas y tierras silíceas simil., de densidad aparente <= 1, incl. calcinadas',25,2512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251310,'Pedra-pomes','Pumice stone',' Piedra pómez',25,2513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251311,'pedras-pomes em bruto, fragmentos irregul.incl.triturada','pumice stone, crude, in irregular pieces, includ.crushed','piedra pómez en bruto, en trozos irregul.incluso la quebrantada.',25,2513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251319,'outras formas de pedra-pomes','other forms of pumice stone','otras formas de piedra pómez',25,2513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251320,'Esmeril, corindo natural, granada natural e outros abrasivos naturais, mesmo tratados termicamente','Emery; natural corundum, natural garnet and other natural abrasives, whether or not heat-treated','Esmeril; corindón natural, granate natural y demás abrasivos naturales, incl. tratados térmicamente',25,2513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251400,'Ardósia, inclusive desbastada ou cortada em blocos ou placas','Slate, whether or not roughly trimmed or merely cut, by sawing or otherwise, into blocks or slabs of a square or rectangular shape; slate powder and slate refuse','Pizarra, incl. desbastada o simplemente troceada, por aserrado o de otro modo, en bloques o en placas cuadradas o rectangulares; polvo y desperdicios de pizarra',25,2514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251511,'Mármores e travertinos, em bruto ou desbastados','Marble and travertine, crude or roughly trimmed','Mármol y travertinos, en bruto o desbastados',25,2515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251512,'Mármores e travertinos, cortados em blocos ou placas de forma quadrada ou retangular','Marble and travertine, merely cut, by sawing or otherwise, into blocks or slabs of a square or rectangular shape','Mármol y travertinos, simplemente troceados, por aserrado o de otro modo, en bloques o en placas cuadradas o rectangulares',25,2515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251520,'Granitos belgas, outras pedras calcárias de cantaria ou de construção; alabastro','Ecaussine and other calcareous monumental or building stone of an apparent specific gravity of >= 2,5, and alabaster, whether or not roughly trimmed or merely cut, by sawing or otherwise, into blocks or slabs of a square or rectangular shape (excl. in the','"Ecaussines" y demás piedras calizas de talla o de construcción, de densidad aparente >= 2,5, y alabastro, incl. desbastadas o simplemente troceadas por aserrado o de otro modo, en bloques o en placas cuadradas o rectangulares (exc. en gránulos, tasquiles',25,2515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251611,'Granito em bruto ou desbastado','Granite, crude or roughly trimmed (excl. already with the characteristics of setts, curbstones and flagstones)','Granito, en bruto o desbastado (exc. con las características de adoquines, bordillos de aceras, veredas o losas)',25,2516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251612,'Granito, cortado em blocos ou placas de forma quadrada ou retangular','Granite, merely cut, by sawing or otherwise, into blocks or slabs of a square or rectangular shape (excl. already with the characteristics of setts, curbstones and flagstones)','Granito, simplemente troceado, por aserrado o de otro modo, en bloques o en placas cuadradas o rectangulares (exc. con las características de adoquines, bordillos de aceras, veredas o losas)',25,2516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251620,'Arenito, mesmo desbastado ou cortado em blocos ou placas de forma quadrada ou retangular','Sandstone, whether or not roughly trimmed or merely cut, by sawing or otherwise, into blocks or slabs of a square or rectangular shape (excl. already with the characteristics of setts, curbstones and flagstones)',' Arenisca, incl. desbastada o simplemente troceada en bloques o en placas cuadradas o rectangulares',25,2516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251621,'arenito em bruto ou desbastado','sandstine, in crude or roughly trimmed','arenisca en bruto o desbastada',25,2516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251622,'arenito cortado em blocos ou placas','sandstine, cut or in blocks or slabs','arenisca troceada en bloques o placas',25,2516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251690,'Outras pedras de cantaria ou de construção em formatos quadrados ou retangulares','Porphyry, basalt and other monumental or building stone, whether or not roughly trimmed or merely cut, by sawing or otherwise, into blocks or slabs of a square or rectangular shape (excl. in the form of granules, chippings or powder, or already with the c','Pórfido, basalto y demás piedras de talla o de construcción, incl. desbastadas o simplemente troceadas por aserrado o de otro modo, en bloques o en placas cuadradas o rectangulares (exc. en gránulos, tasquiles o polvo, así como piedras con las característ',25,2516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251710,'Calhaus, cascalhos e pedras britadas, para uso em concreto ou para empedramento de estradas ou de vias férreas','Pebbles, gravel, broken or crushed stone, for concrete aggregates, for road metalling or for railway or other ballast, shingle and flint, whether or not heat-treated','Cantos, grava, piedras machacadas, de los tipos generalmente utilizados para hacer hormigón, o para firmes de carreteras, vías férreas u otros balastos, guijarros y pedernal, incl. tratados térmicamente',25,2517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251720,'Macadame de escórias de altos-fornos ou de outras escórias ou resíduos','Macadam of slag, dross or similar industrial waste, whether or not incorporating pebbles, gravel, shingle and flint for concrete aggregates, for road metalling or for railway or other ballast','Macadán de escorias o de desechos industriales simil., incl. con cantos, grava, guijarros y pedernal, de los tipos generalmente utilizados para el hormigonado o para la construcción de carreteras, vías férreas u otros balastos',25,2517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251730,'Tarmacadame','Tarred macadam','Macadán alquitranado',25,2517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251741,'Grânulos, lascas e pós, de mármore','Marble granules, chippings and powder, whether or not heat-treated','Gránulos, tasquiles y polvo de mármol, incl. tratados térmicamente',25,2517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251749,'Grânulos, lascas e pós, de granito e de outras pedras de cantaria','Granules, chippings and powder, whether or not heat-treated, of travertine, ecaussine, alabaster, basalt, granite, sandstone, porphyry, syenite, lava, gneiss, trachyte and other rocks of heading 2515 and 2516 (excl. marble)','Gránulos, tasquiles y polvo de travertinos, "ecaussines", alabastro, granito, arenisca, pórfido, sienita, lava, basalto, gneis, traquita y demás piedras de las partidas 2515 y 2516, incl. tratadas térmicamente (exc. de mármol)',25,2517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251810,'Dolomita não calcinada nem sinterizada (crua), cortada em blocos ou placas de forma quadrada ou retangular','Crude dolomite, not calcined or not sintered, incl. dolomite roughly trimmed or merely cut, by sawing or otherwise, into blocks or slabs of a rectangular incl. square shape (excl. broken or crushed dolomite for concrete aggregates, road metalling or railw','Dolomita, sin calcinar ni sinterizar, llamada "cruda", incl. machacada, incluida la desbastada o simplemente troceada, por aserrado o de otro modo, en bloques o en placas cuadradas o rectangulares (exc. dolomita machacada para el hormigonado o para la con',25,2518);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251820,'Dolomita calcinada ou sinterizada, em blocos e placas em formatos quadrados ou retangulares','Calcined or sintered dolomite (excl. broken or crushed dolomite for concrete aggregates, road metalling or railway or other ballast)','Dolomita, sinterizada o calcinada (exc. dolomita machacada para el hormigonado o para la construcción de carreteras, vías férreas u otros balastos)',25,2518);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251830,'Aglomerados de dolomita','Dolomite ramming mix','Aglomerado de dolomita',25,2518);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251910,'Carbonato de magnésio natural (magnesita)','Natural magnesium carbonate magnesite','Carbonato de magnesio natural "magnesita"',25,2519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (251990,'Magnésia eletrofundida, magnésia calcinada a fundo e outros óxidos de magnésio','Fused magnesia; dead-burned sintered magnesia, whether or not containing small quantities of other oxides added before sintering  other magnesium oxide (excl. natural magnesium carbonate magnesite)','Magnesia electrofundida; magnesia calcinada a muerte "sinterizada", incl. con pequeñas cantidades de otros óxidos añadidos antes de la sinterización; otro óxido de magnesio, incl. puro (exc. carbonato de magnesio natural "magnesita")',25,2519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252010,'Gipsita; anidrita','Gypsum; anhydrite','Yeso natural; anhidrita',25,2520);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252020,'Gesso','Plasters consisting of calcined gypsum or calcium sulphate, whether or not coloured, with or without small quantities of accelerators or retarders','Yeso fraguable, incl. coloreado o con pequeñas cantidades de aceleradores o retardadores',25,2520);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252100,'Castinas; pedras calcárias para fabricação de cal ou de cimento','Limestone flux; limestone and other calcareous stone, of a kind used for the manufacture of lime or cement','Castinas; piedras para la fabricación de cal o de cemento',25,2521);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252210,'Cal viva','Quicklime','Cal viva',25,2522);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252220,'Cal apagada','Slaked lime','Cal apagada',25,2522);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252230,'Cal hidráulica','Hydraulic lime (excl. pure calcium oxide and calcium hydroxide)','Cal hidráulica (exc. el óxido y el hidróxido de calcio)',25,2522);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252310,'Cimentos não pulverizados (clinkers)','Cement clinkers','Cementos sin pulverizar "clinker"',25,2523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252321,'Cimentos portland brancos, mesmo corados artificialmente','White portland cement, whether or not artificially coloured','Cemento Portland, blanco, incl. coloreado artificialmente',25,2523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252329,'Outros tipos de cimento portland','Portland cement (excl. white, whether or not artificially coloured)','Cemento Portland, normal o moderado (exc. blanco, incl. coloreado artificialmente)',25,2523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252330,'Cimentos aluminosos','Aluminous cement','Cementos aluminosos',25,2523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252390,'Outros cimentos hidráulicos, coloridos ou não','Cement, whether or not coloured (excl. aluminous cement and portland cement)','Cementos hidráulicos, incl. coloreados (exc. cemento Portland y cementos aluminosos)',25,2523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252400,'Amianto','Asbestos','Amianto',25,2524);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252410,'Crocidolita (amianto)','Crocidolite asbestos (excl. products made from crocidolite)',' Amianto (arbesto) Crocidolita',25,2524);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252490,'Outras formas de amianto (asbesto)','Asbestos (excl. crocidolite and products made from asbestos)','Amianto (exc. crocidolita y productos en amianto)',25,2524);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252510,'Mica em bruto ou clivada em folhas ou lamelas irregulares','Crude mica and mica rifted into sheets or splittings','Mica, en bruto o exfoliada en hojas o en laminillas irregulares; desperdicios de mica ["splittings"]',25,2525);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252520,'Mica em pó','Mica powder','Mica en polvo',25,2525);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252530,'Desperdícios de mica','Mica waste','Desperdicios de mica',25,2525);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252610,'Esteatita natural, não triturada nem em pó','Natural steatite, whether or not roughly trimmed or merely cut, by sawing or otherwise, into blocks or slabs of a square or rectangular shape, and talc, uncrushed or unpowdered','Esteatita natural, incl. desbastada o simplemente troceada, por aserrado o de otro modo, en bloques o en placas cuadradas o rectangulares, y talco, sin triturar ni pulverizar',25,2526);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252620,'Esteatita natural, triturada ou em pó e talco','Natural steatite and talc, crushed or powdered','Esteatita natural y talco, incl. desbastados, triturados o pulverizados',25,2526);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252700,'Criolita natural e quiolita natural','Natural criolite and natural quiolite','Criolita natural y quiolita natural',25,2527);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252800,'Boratos naturais e seus concentrados (calcinados ou não)','Natural borates and concentrates thereof (calcined or not)','Boratos naturales y sus concentrados (calcinados o no)',25,2528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252810,'Boratos de sódio, naturais e seus concentrados','Sodium borates, natural, and concentrates thereof, whether or not calcined (excl. sodium borates separated from natural brine)','Boratos de sodio naturales y sus concentrados, incl. calcinados (exc. boratos extraídos de las salmueras naturales)',25,2528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252890,'Outros boratos naturais; ácidos bóricos naturais com teor máximo de 85% de H3BO3 em produto seco','Borates, natural, and concentrates thereof, whether or not calcined, and natural boric acids containing <= 85% of H3BO3 calculated on the dry weight (excl. sodium borates and concentrates thereof and borates separated from natural brine)','Boratos naturales y sus concentrados, incl. calcinados; ácido bórico natural con un contenido de H3BO3 <= 85%, valorado sobre producto seco (exc. boratos de sodio naturales y sus concentrados, así como los boratos extraídos de las salmueras naturales)',25,2528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252910,'Feldspato','Feldspar','Feldespato',25,2529);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252921,'Espatoflúor, contendo peso <= 97% de fluoreto de cálcio','Fluorspar containing by weight <= 97% calcium fluoride','Espato flúor, con un contenido de fluoruro de calcio <= 97% en peso',25,2529);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252922,'Espatoflúor, contendo peso > 97% de fluoreto de cálcio','Fluorspar containing by weight > 97% calcium fluoride','Espato flúor, con un contenido de fluoruro de calcio > 97% en peso',25,2529);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (252930,'Leucita, nefelina e nefelina-sienito','Leucite, nepheline and nepheline syenite','Leucita; nefelina y nefelina sienita',25,2529);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (253010,'Vermiculita, perlita e cloritas, não expandidas','Vermiculite, perlite and chlorites, unexpanded','Vermiculita, perlita y cloritas, sin dilatar',25,2530);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (253020,'Kieserita, epsomita (sulfatos de magnésio naturais)','Kieserite and epsomite natural magnesium sulphates','Kieserita y epsomita "sulfatos de magnesio naturales"',25,2530);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (253040,'óxidos de ferro micaceos naturais','oxides of iron natural micaceus','óxidos de hierro micáceos naturales',25,2530);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (253090,'Outras matérias minerais (espodumênio, areias de zircônio, terras corantes)','Arsenic sulfides, alunite, pozzuolana, earth colours and other mineral substances, n.e.s.','Sulfuros de arsénico, alunita, tierra de puzolana, tierras colorantes y demás materias minerales, n.c.o.p.',25,2530);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (260111,'Minérios de ferro não aglomerados e seus concentrados','Non-agglomerated iron ores and concentrates (excl. roasted iron pyrites)','Minerales de hierro y sus concentrados, sin aglomerar  [CECA] (exc. piritas de hierro tostadas "cenizas de piritas")',26,2601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (260112,'Minérios de ferro aglomerados e seus concentrados','Agglomerated iron ores and concentrates (excl. roasted iron pyrites)','Minerales de hierro y sus concentrados, aglomeradas  [CECA] (exc. piritas de hierro tostadas "cenizas de piritas")',26,2601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (260120,'Piritas de ferro ustuladas (cinzas de piritas)','Roasted iron pyrites','Piritas de hierro tostadas "cenizas de piritas"',26,2601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (260200,'Minérios de manganês e seus concentrados, incluídos os minérios de manganês ferruginosos e seus concentrados, de teor de manganês de => 20%, em peso, sobre o produto seco','Manganese ores and concentrates, incl. ferruginous manganese ores and concentrates, with a manganese content of >= 20%, calculated on the dry weight','Minerales de manganeso y sus concentrados, incl. los minerales de manganeso ferruginosos y sus concentrados, con un contenido de manganeso >= 20% en peso, sobre producto seco [CECA]',26,2602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (260300,'Minérios de cobre e seus concentrados','Copper ores and concentrates','Minerales de cobre y sus concentrados',26,2603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (260400,'Minérios de níquel e seus concentrados','Nickel ores and concentrates','Minerales de níquel y sus concentrados',26,2604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (260500,'Minérios de cobalto e seus concentrados','Cobalt ores and concentrates','Minerales de cobalto y sus concentrados',26,2605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (260600,'Minérios de alumínio e seus concentrados','Aluminium ores and concentrates','Minerales de aluminio y sus concentrados',26,2606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (260700,'Minérios de chumbo e seus concentrados','Lead ores and concentrates','Minerales de plomo y sus concentrados',26,2607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (260800,'Minérios de zinco e seus concentrados','Zinc ores and concentrates','Minerales de cinc y sus concentrados',26,2608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (260900,'Minérios de estanho e seus concentrados','Tin ores and concentrates','Minerales de estaño y sus concentrados',26,2609);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (261000,'Minérios de cromo e seus concentrados','Chromium ores and concentrates','Minerales de cromo y sus concentrados',26,2610);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (261100,'Minérios de tungstênio e seus concentrados','Tungsten ores and concentrates','Minerales de volframio "tungsteno" y sus concentrados',26,2611);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (261210,'Minérios de urânio e seus concentrados','Uranium ores and concentrates','Minerales de uranio y sus concentrados',26,2612);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (261220,'Minérios de tório e seus concentrados','Thorium ores and concentrates','Minerales de torio y sus concentrados',26,2612);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (261310,'Minérios de molibdênio ustulados e seus concentrados','Roasted molybdenum ores and concentrates','Minerales de molibdeno y sus concentrados, tostados',26,2613);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (261390,'Minérios de molibdênio não ustulados e concentrados','Molybdenum ores and concentrates (excl. roasted)','Minerales de molibdeno y sus concentrados (exc. tostados)',26,2613);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (261400,'Minérios de titânio e seus concentrados','Titanium ores and concentrates','Minerales de titanio y sus concentrados',26,2614);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (261510,'Minérios de zircônio e seus concentrados','Zirconium ores and concentrates','Minerales de circonio y sus concentrados',26,2615);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (261590,'Minérios de nióbio, tântalo ou vanádio, e seus concentrados','Niobium, tantalum or vanadium ores and concentrates','Minerales de niobio, tantalio o vanadio, y sus concentrados',26,2615);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (261610,'Minérios de prata e seus concentrados','Silver ores and concentrates','Minerales de plata y sus concentrados',26,2616);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (261690,'Minérios de outros metais preciosos e seus concentrados','Precious-metal ores and concentrates (excl. silver ores and oncentrates)','Minerales de los metales preciosos y sus concentrados (exc. minerales de plata y sus concentrados)',26,2616);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (261710,'Minérios de antimônio e seus concentrados','Antimony ores and concentrates','Minerales de antimonio y sus concentrados',26,2617);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (261790,'Outros minérios e seus concentrados','Ores and concentrates (excl. iron, manganese, copper, nickel, cobalt, aluminium, lead, zinc, tin, chromium, tungsten, uranium, thorium, molybdenum, titanium, niobium, tantalum, vanadium, zirconium, precious-metal or antimony ores and concentrates)','Minerales y sus concentrados (exc. minerales de hierro, de manganeso, de cobre, de níquel, de cobalto, de aluminio, de plomo, de cinc, de estaño, de cromo, de volframio "tungsteno", de uranio, de torio, de molibdeno, de titanio, de niobio, de tantalio, de',26,2617);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (261800,'Escória de altos-fornos granulada, proveniente da fabricação do ferro e aço','Granulated slag slag sand from the manufacture of iron or steel','Escorias granuladas "arena de escorias" de la siderurgia',26,2618);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (261900,'Outras escórias e desperdícios da fabricação do ferro e aço','Slag, dross, scalings and other waste from the manufacture of iron or steel (excl. granulated slag)','Escorias, batiduras y demás desperdicios de la siderurgia (exc. escorias granuladas)',26,2619);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (262011,'Mates de galvanização (contendo zinco)','Hard zinc spelter','Matas de galvanización',26,2620);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (262019,'Outras cinzas e resíduos contendo zinco','Slag, ash and residues containing mainly zinc (excl. hard zinc spelter)','Cenizas y residuos, que contengan principalmente cinc (exc. matas de galvanización)',26,2620);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (262020,'cinzas e resíduos contendo chumbo','other ash and residues containing lead','cenizas y residuos que contengan plombo',26,2620);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (262021,'Lamas de gasolina e de compostos antidetonantes, contendo chumbo','Leaded gasoline sludges and leaded anti-knock compound sludges, obtained from storage tanks of leaded gasoline and leaded anti-knock compounds and containing mainly lead, lead compounds and iron oxide','Lodos de gasolina con plomo y lodos de compuestos antidetonantes con plomo, procedentes de los depósitos de almacenamiento de gasolina y de compuestos antidetonantes con plomo, y constituidos esencialmente por plomo, compuestos de plomo y óxido de hierro',26,2620);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (262029,'Outras cinzas e resíduos, contendo principalmente chumbo','Slag, ash and residues containing mainly lead (excl. leaded gasoline sludges and leaded anti-knock compound sludges)','Cenizas y residuos, que contengan principalmente plomo (exc. lodos de gasolina con plomo y lodos de compuestos antidetonantes con plomo)',26,2620);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (262030,'Cinzas e resíduos contendo cobre','Slag, ash and residues containing mainly copper','Cenizas y residuos, que contengan principalmente cobre',26,2620);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (262040,'Cinzas e resíduos contendo alumínio','Slag, as and residues containing mainly aluminium','Cenizas y residuos, que contengan principalmente aluminio',26,2620);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (262050,'Cinzas e resíduos contendo vanádio','Ash and residues containing mainly vanadium','Cenizas y residuos que contengan vanadio',26,2620);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (262060,'Cinzas e resíduos, contendo arsênio, mercúrio, tálio ou suas misturas','Slag, ash and residues, containing arsenic, mercury, thallium or their mixtures, of a kind used for the extraction of arsenic or those metals or for the manufacture of their chemical compounds (excl. those from the manufacture of iron or steel)','Cenizas y residuos, que contengan arsénico, mercurio, talio o sus mezclas, de los tipos utilizados para la extracción de arsénico o de estos metales para la fabricación de sus compuestos químicos (exc. los de la siderurgia)',26,2620);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (262090,'Cinzas e resíduos contendo titânio ou outros materiais','Ashes and residues containing titanium or other materials','Ceniza y residuos que contienen titanio o de otros materiales',26,2620);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (262091,'Cinzas e resíduos, contendo antimônio, berílio, cádmio, cromo ou suas misturas','Slag, ash and residues, containing antimony, beryllium, cadmium, chromium or their mixtures (excl. those from the manufacture of iron or steel)','Cenizas y residuos, que contengan antimonio, berilio, cadmio, cromo o sus mezclas (exc. los de la siderurgia)',26,2620);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (262099,'Cinzas e resíduos, contendo outros metais ou compostos de metais','Slag, ash and residues, containing metals or metal compounds (excl. those from the manufacture of iron or steel, those containing primarily zinc, lead, copper or aluminium, those containing arsenic, mercury, thallium or their mixtures of a kind used for t','Cenizas y residuos, que contengan metal o compuestos de metales (exc. los de la siderurgia, así como los que contengan principalmente cinc, plomo, cobre o aluminio; los que contengan arsénico, mercurio, talio o sus mezclas, de los tipos utilizados para la',26,2620);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (262100,'Cinzas de origem vegetal','Ashes of vegetable origin','Cenizas de origen vegetal',26,2621);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (262110,'Cinzas e resíduos provenientes da incineração de lixos municipais','Ash and residues from the incineration of municipal waste','Cenizas y residuos procedentes de la incineración de desechos y desperdicios municipales',26,2621);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (262190,'Outras escórias e cinzas, incluídas as cinzas de algas','Slag and ash, incl. seaweed ash kelp (excl. slag, incl. granulated, from the manufacture of iron or steel, ashes and residues containing arsenic, metals or metal compounds and those from the incineration of municipal waste)','Escorias y cenizas, incl. las cenizas de algas (exc. escorias, incl. las granuladas, de la siderurgia, así como las cenizas y residuos que contengan arsénico, metal o compuestos de metales y las procedentes de la incineración de desechos y desperdicios mu',26,2621);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270111,'Hulha antracita, não aglomerada','Anthracite, whether or not pulverised, non-agglomerated','Antracitas  [CECA], incl. pulverizadas, pero sin aglomerar',27,2701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270112,'Hulha betuminosa, não aglomerada','Bituminous coal, whether or not pulverised, non-agglomerated','Hulla bituminosa  [CECA], incl. pulverizada, pero sin aglomerar',27,2701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270119,'Outras hulhas, mesmo em pó, mas não aglomeradas','Coal, whether or not pulverised, non-agglomerated (excl. anthracite and bituminous coal)','Hulla  [CECA], incl. pulverizada, pero sin aglomerar (exc. antracita y hulla bituminosa)',27,2701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270120,'Briquetes, bolas em aglomerados e combustíveis sólidos obtidos da hulha','Briquettes, ovoids and similar solid fuels manufactured from coal','Briquetas, ovoides y combustibles sólidos simil., obtenidos de la hulla  [CECA]',27,2701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270210,'Linhitas, mesmo em pó, mas não aglomeradas','Lignite, whether or not pulverised, non-agglomerated (excl. jet)','Lignitos, incl. pulverizados, pero sin aglomerar  [CECA]',27,2702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270220,'Linhitas aglomeradas','Agglomerated lignite (excl. jet)','Lignitos aglomerados  [CECA]',27,2702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270300,'Turfa (incluída a turfa para cama de animais), mesmo aglomerada','Peat, incl. peat litter, whether or not agglomerated','Turba, comprendida la utilizada para cama de animales, incl. aglomerada',27,2703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270400,'Coques e semicoques de hulha, de linhita ou de turfa, mesmo aglomerados; carvão de retorta','Coke and semi-coke of coal, of lignite or of peat, whether or not agglomerated; retort carbon','Coques y semicoques de hulla, lignito o turba, incl. aglomerados; carbón de retorta',27,2704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270500,'Gás de hulha, gás de água, gás pobre e gases semelhantes, exceto de gases de petróleo e outros hidrocarbonetos gasosos','Coal gas, water gas, producer gas, lean gas and similar gases (excl. petroleum gases and other gaseous hydrocarbons)','Gas de hulla, gas de agua, gas pobre y gases simil. (exc. gas de petróleo y demás hidrocarburos gaseosos)',27,2705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270600,'Alcatrões de hulha, de linhita, de turfa e outros alcatrões minerais','Tar distilled from coal, from lignite or from peat, and other mineral tars, whether or not dehydrated or partially distilled, incl. reconstituted tars','Alquitranes de hulla, lignito o turba y demás alquitranes minerales, aunque estén deshidratados o descabezados, incl. los alquitranes reconstituidos',27,2706);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270710,'Benzol (benzeno), produto da destilação dos alcatrões de hulha a alta temperatura','Benzol benzene containing > 50% of benzene (excl. chemically defined)','Benzol "benceno" con un contenido de benceno > 50% en peso (exc. de constitución química definida)',27,2707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270720,'Toluol (tolueno), produto da destilação dos alcatrões de hulha a alta temperatura','Toluol toluene containing > 50% of toluene (excl. chemically defined)','Toluol "tolueno" con un contenido de tolueno > 50% en peso (exc. de constitución química definida)',27,2707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270730,'Xilol (xilenos), produto da destilação dos alcatrões de hulha a altas temperatura','Xylol xylenes containing > 50% of xylenes (excl. chemically defined)','Xilol "xilenos" con un contenido de xilenos >50% en peso (exc. de constitución química definida)',27,2707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270740,'Naftaleno, produto da destilação dos alcatrões de hulha a alta temperatura','Naphthalene containing > 50% of naphthalene (excl. chemically defined)','Naftaleno con un contenido de naftaleno >50% (exc. de constitución química definida)',27,2707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270750,'Outras misturas de hidrocarbonetos aromáticos','Aromatic hydrocarbon mixtures of which >= 65% by volume, incl. losses, distils at 250°C by the ASTM D 86 method (excl. chemically defined compounds)','Mezclas de hidrocarburos aromáticos que destilen una proporción <= 65% en volumen, incl. las pérdidas, a 250°C, según la norma ASTM D 86 (exc. compuestos de constitución química definida)',27,2707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270760,'Cresóis e outros derivados fenólicos','Cresols and other phenolic derivatives','Cresoles y otros derivados fenólicos',27,2707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270791,'Óleos de creosoto','Creosote oils (excl. chemically defined)','Aceites de creosota (exc. de constitución química definida)',27,2707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270799,'Óleos e outros produtos da destilação dos alcatrões da hulha a alta temperatura','Oils and other products of the distillation of high temperature coal tars; similar products in which the weight of the aromatic constituents exceeds that of the non-aromatic constituents (excl. chemically-defined compounds, benzol benzene, toluol toluene,','Aceites y demás productos de la destilación de los alquitranes de hulla de alta temperatura; productos análogos en los que los constituyentes aromáticos predominen en peso sobre los no aromáticos (exc. compuestos de constitución química definida, así como',27,2707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270810,'Breu obtido a partir do alcatrão de hulha ou de outros alcatrões minerais','Pitch obtained from coal tar or from other mineral tars','Brea de alquitrán de hulla o de otros alquitranes minerales',27,2708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270820,'Coque de breu obtido de alcatrões minerais','Pitch coke obtained from coal tar or from other mineral tars','Coque de brea de alquitrán de hulla o de otros alquitranes minerales',27,2708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (270900,'Óleos brutos de petróleo ou de minerais betuminosos','Petroleum oils and oils obtained from bituminous minerals, crude','Aceites crudos de petróleo o de mineral bituminoso',27,2709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271000,'Naftas, gasolinas, querosenas, gasóleo, outros óleos combustíveis','Naphtha, gasoline, querosenas, diesel, other fuel oils','Nafta, gasolina, querosenas, diesel, otros combustibles',27,2710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271011,'Óleos leves de petróleo ou de minerais betuminosos e preparações, exceto desperdícios','Light oils and preparations, of petroleum or bituminous minerals which >= 90% by volume incl. losses distil at 210°C ASTM D 86 method','Aceites livianos "ligeros" y preparaciones, de petróleo o de mineral bituminoso, que destilen, incl. las pérdidas, una proporción >= 90% en volumen a 210ºC',27,2710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271012,'Óleos leves e preparações','Light oils and preparations','Aceites ligeros y preparaciones',27,2710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271019,'Outros óleos de petróleo ou de minerais betuminosos e preparações, exceto desperdícios','Medium oils and preparations, of petroleum or bituminous minerals, n.e.s.','Aceites medios y preparaciones, de petróleo o de mineral bituminoso, n.c.o.p.',27,2710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271020,'Óleos de petróleo ou minerais betuminosos (exceto óleo bruto)','Petroleum oils or oils obtained from bituminous minerals (except crude oil)','Aceites crudos de petróleo o de mineral bituminoso (exceto aceites crudos)',27,2710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271091,'Desperdícios de óleos, contendo difenilas policloradas ou polibromadas, ou terfenilas policloradas','Waste oils containing polychlorinated biphenyls [PCBs], polychlorinated terphenyls [PCTs] or polybrominated biphenyls [PBBs]','Desechos de aceites que contengan difenilos policlorados "PCB", terfenilos policlorados "PCT" o difenilos polibromados "PBB"',27,2710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271099,'Outros desperdícios de óleos','Waste oils containing mainly petroleum or bituminous minerals (excl. those containing polychlorinated biphenyls [PCBs], polychlorinated terphenyls [PCTs] or polybrominated biphenyls [PBBs])','Desechos de aceites que contengan principalmente aceites de petróleo o de mineral bituminoso (exc. que contengan difenilos policlorados "PCB", terfenilos policlorados "PCT" o difenilos polibromados "PBB")',27,2710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271111,'Gás natural, liquefeito','Natural gas, liquefied','Gas natural, licuado',27,2711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271112,'Propano, liquefeito','Propane, liquefied','Propano, licuado',27,2711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271113,'Butanos, liquefeitos','Butanes, liquefied (excl. of a purity of >= 95% of N-butane or isobutane)','Butanos, licuados (exc. de pureza >= 95% de n-butano o de isobutano)',27,2711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271114,'Etileno, propileno, butileno e butadieno, liquefeitos','Ethylene, propylene, butylene and butadiene, liquefied (excl. ethylene of a purity of >= 95% and propylene, butylene and butadiene of a purity of >= 90%)','Etileno, propileno, butileno y butadieno, licuados (exc. etileno de pureza >= 95% y propileno, butileno y butadieno de pureza >= 90%)',27,2711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271119,'Outros gases liquefeitos de hidrocarbonetos gasosos','Gaseous hydrocarbons, liquefied, n.e.s. (excl. natural gas, propane, butane, ethylene, propylene, butylene and butadiene)','Hidrocarburos gaseosos, licuados, n.c.o.p. (exc. gas natural, propano, butanos, etileno, propileno, butileno y butadieno)',27,2711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271121,'Gás natural no estado gasoso','Natural gas in gaseous state','Gas natural, en estado gaseoso',27,2711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271129,'Butanos, outros hidrocarbonetos e gás petróleo, no estado gasoso','Hydrocarbons in gaseous state, n.e.s. (excl. natural gas)','Hidrocarburos, en estado gaseoso (exc. gas natural)',27,2711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271210,'Vaselina','Petroleum jelly','Vaselina',27,2712);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271220,'Parafina contendo, em peso, < 0,75% de óleo','Paraffin wax containing < 0,75% by weight of oil','Parafina, con un contenido de aceite < 0,75% en peso',27,2712);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271290,'Cera de petróleo microcristalina, slack wax, ozocerite, outras ceras minerais e produtos semelhantes','Paraffin wax, microcrystalline petroleum wax, slack wax, ozokerite, lignite wax, peat wax, other mineral waxes, and similar products obtained by synthesis or by other processes, whether or not coloured (excl. petroleum jelly and paraffin wax containing < ','Parafina, cera de petróleo microcristalina, "slack wax", ozoquerita, cera de lignito, cera de turba, demás ceras minerales y productos simil. obtenidos por síntesis o por otros procedimientos, incl. coloreados (exc. vaselina y parafina con un contenido de',27,2712);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271311,'Coque de petróleo não calcinado','Petroleum coke, non-calcined','Coque de petróleo, sin calcinar',27,2713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271312,'Coque de petróleo calcinado','Petroleum coke, calcined','Coque de petróleo, calcinado',27,2713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271320,'Betume de petróleo','Petroleum bitumen','Betún de petróleo',27,2713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271390,'Outros resíduos dos óleos de petróleo ou de minerais betuminosos','Residues of petroleum oil or of oil obtained from bituminous minerals (excl. petroleum coke and petroleum bitumen)','Residuos de los aceites de petróleo o de mineral bituminoso (exc. coque y betún de petróleo)',27,2713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271410,'Xistos e areias betuminosos','Bituminous or oil-shale and tar sands','Pizarras y arenas bituminosas',27,2714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271490,'Betumes e asfaltos naturais, asfaltitas e rochas asfálticas','Bitumen and asphalt, natural; asphaltites and asphaltic rocks','Betunes y asfaltos naturales; asfaltitas y rocas asfálticas',27,2714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271500,'Misturas betuminosas à base de asfalto, de betumes, de alcatrão ou de breu de alcatrão mineral','Bituminous mastics, cut-backs and other bituminous mixtures based on natural asphalt, on natural bitumen, on petroleum bitumen, on mineral tar or on mineral tar pitch','Mastiques bituminosos, "cut backs" y demás mezclas bituminosas a base de asfalto o de betún naturales, de betún de petróleo, de alquitrán mineral o de brea de alquitrán mineral',27,2715);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (271600,'Energia elétrica','Electrical energy','Energía eléctrica',27,2716);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280110,'Cloro','Chlorine','Cloro',28,2801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280120,'Iodo','Iodine','Yodo',28,2801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280130,'Flúor e bromo','Fluorine; bromine','Flúor; bromo',28,2801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280200,'Enxofre sublimado ou precipitado; enxofre coloidal','Sulphur, sublimed or precipitated; colloidal sulphur','Azufre sublimado o precipitado; azufre coloidal',28,2802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280300,'Carbono (negros-de-carbono e outras formas não compreendidas em outras posições)','Carbon carbon blacks and other forms of carbon, n.e.s.','Negros de humo y otras formas de carbono, n.c.o.p.',28,2803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280410,'Hidrogênio','Hydrogen','Hidrógeno',28,2804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280421,'Argônio (gases raros)','Argon','Argón',28,2804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280429,'Outros gases raros','Rare gases (excl. argon)','Gases nobles (exc. argón)',28,2804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280430,'Nitrogênio','Nitrogen','Nitrógeno',28,2804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280440,'Oxigênio','Oxygen','Oxígeno',28,2804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280450,'Boro; telúrio','Boron; tellurium','Boro; telurio',28,2804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280461,'Silício, contendo, em peso, => 99,99% de silício','Silicon containing >= 99,99% by weight of silicon','Silicio, con un contenido de silicio >= 99,99% en peso',28,2804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280469,'Outros silícios','Silicon containing < 99,99% by weight of silicon','Silicio, con un contenido de silicio < 99,99% en peso',28,2804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280470,'Fósforo','Phosphorus','Fósforo',28,2804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280480,'Arsênio','Arsenic','Arsénico',28,2804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280490,'Selênio','Selenium','Selenio',28,2804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280511,'Sódio (metal alcalino)','Sodium','Sodio',28,2805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280512,'Cálcio','Calcium','Calcio',28,2805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280519,'Outros metais alcalinos ou alcalinoterrosos','Alkali or alkaline-earth metals  (excl. sodium and calcium)','Metales alcalinos o alcalinotérreos (exc. sodio y calcio)',28,2805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280521,'Cálcio (metal alcalino terroso)','Calcium (alkaline-earth metal)','Calcio (metal alcalinotérreo)',28,2805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280522,'Estrôncio e bário','Strontium and barium','Estroncio y bario',28,2805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280530,'Metais de terras raras, escândio e ítrio, mesmo misturados ou ligados entre si','Rare-earth metals, scandium and yttrium, whether or not intermixed or interalloyed','Metales de las tierras raras, escandio e itrio, incl. mezclados o aleados entre sí',28,2805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280540,'Mercúrio','Mercury','Mercurio',28,2805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280610,'Cloreto de hidrogênio (ácido clorídrico)','Hydrogen chloride hydrochloric acid','Cloruro de hidrógeno "ácido clorhídrico"',28,2806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280620,'Ácido clorossulfúrico','Chlorosulphuric acid','Ácido clorosulfúrico',28,2806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280700,'Ácido sulfúrico e ácido sulfúrico fumante (oleum)','Sulphuric acid; oleum','Ácido sulfúrico; oleum',28,2807);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280800,'Ácido nítrico; ácidos sulfonítricos','Nitric acid; sulphonitric acids','Ácido nítrico; ácidos sulfonítricos',28,2808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280910,'Pentóxido de difósforo','Diphosphorus pentaoxide','Pentaóxido de difósforo',28,2809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (280920,'Ácido fosfórico e ácidos polifosfóricos','Phosphoric acid; polyphosphoric acids, whether or not chemically defined','Ácido fosfórico; ácidos polifosfóricos, incl. de constitución química no definida',28,2809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281000,'Óxidos de boro; ácidos bóricos','Oxides of boron; boric acids','Óxidos de boro; ácidos bóricos',28,2810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281111,'Fluoreto de hidrogênio (ácido fluorídrico)','Hydrogen fluoride hydrofluoric acid','Fluoruro de hidrógeno "ácido fluorhídrico"',28,2811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281119,'Outros ácidos inorgânicos','Inorganic acids (excl. hydrogen chloride hydrochloric acid, chlorosulphuric acid, sulphuric acid, oleum, nitric acid, sulphonitric acids, phosphoric acid, polyphosphoric acids, boric acids and hydrogen fluoride hydrofluoric acid)','Ácidos inorgánicos (exc. cloruro de hidrógeno "ácido clorhídrico", ácido clorosulfúrico, ácido sulfúrico, óleum, ácido nítrico, ácidos sulfonítricos, ácido fosfórico, ácidos polifosfóricos, ácidos bóricos y fluoruro de hidrógeno "ácido fluorhídrico")',28,2811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281121,'Dióxido de carbono','Carbon dioxide','Dióxido de carbono',28,2811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281122,'Dióxido de silício','Silicon dioxide','Dióxido de silicio',28,2811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281123,'Dióxido de enxofre','Sulphur dioxide','Dióxido de azufre',28,2811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281129,'Outros compostos oxigenados inorgânicos dos elementos não metálicos','Inorganic oxygen compounds of non-metals (excl. diphosphorus pentaoxide, oxides of boron, carbon dioxide and silicon dioxide)','Compuestos oxigenados inorgánicos de los elementos no metálicos (exc. pentaóxido de difósforo, óxidos de boro, dióxido de carbono, dióxido de silicio y dióxido de azufre)',28,2811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281210,'Cloretos e oxicloretos','Chlorides and chloride oxides','Cloruros y oxicloruros',28,2812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281290,'Outros halogenetos e oxialogenetos dos elementos não metálicos','Halides and halide oxides of non-metals (excl. chlorides and chloride oxides)','Halogenuros y oxihalogenuros de los elementos no metálicos (exc. cloruros y oxicloruros)',28,2812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281310,'Dissulfeto de carbono','Carbon disulphide','Disulfuro de carbono',28,2813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281390,'Outros sulfetos dos elementos não metálicos e trissulfeto de fósforo comercial','Sulphides of non-metals (excl. carbon disulphide); commercial phosphorus trisulphide','Sulfuros de los elementos no metálicos (exc. disulfuro de carbono); trisulfuro de fósforo comercial',28,2813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281410,'Amoníaco anidro','Anhydrous ammonia','Amoníaco anhidro',28,2814);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281420,'Amoníaco em solução aquosa (amônia)','Ammonia in aqueous solution','Amoníaco en disolución acuosa',28,2814);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281511,'Hidróxido de sódio (soda cáustica) sólido','Sodium hydroxide caustic soda solid','Hidróxido de sodio "sosa o soda cáustica", sólido',28,2815);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281512,'Hidróxido de sódio (soda cáustica) em solução aquosa','Sodium hydroxide caustic soda in aqueous solution soda lye or liquid soda','Hidróxido de sodio "sosa o soda cáustica", en disolución acuosa "lejía de sosa cáustica"',28,2815);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281520,'Hidróxido de potássio (potassa cáustica)','Potassium hydroxide caustic potash','Hidróxido de potasio "potasa cáustica"',28,2815);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281530,'Peróxidos de sódio ou de potássio','Peroxides of sodium or potassium','Peróxidos de sodio o de potasio',28,2815);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281610,'Hidróxido e peróxido de magnésio','Hydroxide and peroxide of magnesium','Hidróxido y peróxido de magnesio',28,2816);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281620,'Óxido, hidróxido e peróxido de estrôncio','Oxide, hydroxide and peroxide, of strontium','Óxido,  hidróxido y peróxido de estroncio',28,2816);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281630,'Hidróxido de bário','Barium hydroxide','Hidróxido de bario',28,2816);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281640,'Óxidos, hidróxidos, peróxidos, de estrôncio ou de bário','Oxides, hydroxides and peroxides, of strontium or barium','Óxidos, hidróxidos y peróxidos, de estroncio o de bario',28,2816);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281700,'Óxido de zinco; peróxido de zinco','Zinc oxide; zinc peroxide','Óxido de cinc; peróxido de cinc',28,2817);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281810,'Corindo artificial, quimicamente definido ou não','Corundum, artificial, whether or not chemically defined','Corindón artificial, aunque no sea químicamente definido',28,2818);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281820,'Óxidos de alumínio, exceto corindo artificial','Aluminium oxide (excl. artificial corundum)','Óxido de aluminio (exc. corindón artificial)',28,2818);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281830,'Hidróxido de alumínio','Aluminium hydroxide','Hidróxido de aluminio',28,2818);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281910,'Trióxido de cromo','Chromium trioxide','Trióxido de cromo',28,2819);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (281990,'Óxidos e hidróxidos de cromo','Chromium oxides and hydroxides (excl. chromium trioxide)','Óxidos y hidróxidos de cromo (exc. trióxido de cromo)',28,2819);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282010,'Dióxido de manganês','Manganese dioxide','Dióxido de manganeso',28,2820);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282090,'Outros óxidos de manganês','Manganese oxides (excl. manganese dioxide)','Óxidos de manganeso (exc. dióxido de manganeso)',28,2820);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282110,'Óxidos e hidróxidos de ferro','Iron oxides and hydroxides','Óxidos e hidróxidos de hierro',28,2821);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282120,'Terras corantes contendo, em peso, => 70% de ferro combinado, expresso em FE2O3','Earth colours containing >= 70% by weight of combined iron evaluated as Fe2O3','Tierras colorantes con un contenido de hierro combinado >= 70% en peso, expresado en Fe2O3',28,2821);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282200,'Óxidos e hidróxidos de cobalto, inclusive os comerciais','Cobalt oxides and hydroxides; commercial cobalt oxides','Óxidos e hidróxidos de cobalto; óxidos de cobalto comerciales',28,2822);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282300,'Óxidos de titânio','Titanium oxides','Óxidos de titanio',28,2823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282410,'Monóxido de chumbo (litargírio, massicote)','Lead monoxide litharge, massicot','Monóxido de plomo "litargirio, masicot"',28,2824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282420,'mínio (zarcao) e mínio-laranja ("mine-orange")','red lead and orange lead','minio y minio anaranjado',28,2824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282490,'Outros óxidos de chumbo (minio e minio-laranja)','Lead oxides (excl. monoxide litharge, massicot)','Óxidos de plomo (exc. monóxido de plomo "litargirio, masicot")',28,2824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282510,'Hidrazina e hidroxilamina e seus sais inorgânicos','Hydrazine and hydroxylamine and their inorganic salts','Hidrazina e hidroxilamina y sus sales inorgánicas',28,2825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282520,'Óxido e hidróxido de lítio','Lithium oxide and hydroxide','Óxido e hidróxido de litio',28,2825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282530,'Óxidos e hidróxidos de vanádio','Vanadium oxides and hydroxides','Óxidos e hidróxidos de vanadio',28,2825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282540,'Óxidos e hidróxidos de níquel','Nickel oxides and hydroxides','Óxidos e hidróxidos de níquel',28,2825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282550,'Óxidos e hidróxidos de cobre','Copper oxides and hydroxides','Óxidos e hidróxidos de cobre',28,2825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282560,'Óxidos de germânio e dióxido de zircônio','Germanium oxides and zirconium dioxide','Óxidos de germanio y dióxido de circonio',28,2825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282570,'Óxidos e hidróxidos de molibdênio','Molybdenum oxides and hydroxides','Óxidos e hidróxidos de molibdeno',28,2825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282580,'Óxidos de antimônio','Antimony oxides','Óxidos de antimonio',28,2825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282590,'Outras bases inorgânicas; óxidos, hidróxidos e peróxidos de outros metais','Bases, inorganic, and metal oxides, hydroxides and peroxides, n.e.s. (excl. inorganic or organic compounds of mercury)','Bases inorgánicas, así como óxidos, hidróxidos y peróxidos de metales, n.c.o.p.',28,2825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282611,'Fluoretos de amônio ou sódio','Fluorides of ammonium or sodium','Fluoruros de amonio o de sodio',28,2826);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282612,'Fluoretos de alumínio','Fluoride of aluminium','Fluoruros de aluminio',28,2826);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282619,'Outros fluoretos','Fluorides (excl. of aluminium and mercury)','Fluoruros (exc. de amonio, sodio y aluminio)',28,2826);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282620,'fluossilicatos de sódio ou de potássio','fluorosilicates of sodium or of potassium','fluorosilicatos de sodio o potasio',28,2826);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282630,'Hexafluoraluminato de sódio (criolita sintética)','Sodium hexafluoroaluminate synthetic cryolite','Hexafluoroaluminato de sodio "criolita sintética"',28,2826);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282690,'Outros fluossilicatos, fluoraluminatos e sais complexos de flúor','Fluorosilicates, fluoroaluminates and other complex fluorine salts (excl. sodium hexafluoroaluminate synthetic cryolite and inorganic or organic compounds of mercury)','Fluorosilicatos, fluoroaluminatos y demás sales complejas del flúor (exc. fluorosilicatos de sodio o potasio y hexafluoroaluminato de sodio "criolita sintética")',28,2826);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282710,'Cloreto de amônio','Ammonium chloride','Cloruro de amonio',28,2827);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282720,'Cloreto de cálcio','Calcium chloride','Cloruro de calcio',28,2827);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282731,'Cloreto de magnésio','Magnesium chloride','Cloruro de magnesio',28,2827);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282732,'Cloreto de alumínio','Aluminium chloride','Cloruro de aluminio',28,2827);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282733,'cloreto de ferro','iron chloride','cloruro de hierro',28,2827);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282734,'cloreto de cobalto','cobalt chloride','cloruro de cobalto',28,2827);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282735,'Cloreto de níquel','Nickel chloride','Cloruro de níquel',28,2827);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282736,'Cloreto de zinco','Zinc chloride','Cloruro de cinc',28,2827);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282738,'Cloreto de bário','Barium chloride','Cloruro de bario',28,2827);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282739,'Outros cloretos','Chlorides (excl. ammonium, calcium, magnesium, aluminium, nickel and mercury chloride)','Cloruros (exc. de amonio, calcio, magnesio, aluminio, hierro, cobalto, níquel y cinc)',28,2827);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282741,'Oxicloretos e hidroxicloretos de cobre','Chloride oxides and chloride hydroxides of copper','Oxicloruros e hidroxicloruros de cobre',28,2827);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282749,'Outros oxicloretos e hidroxicloretos','Chloride oxides and chloride hydroxides (excl. copper and mercury)','Oxicloruros e hidroxicloruros (exc. de cobre)',28,2827);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282751,'Brometos de sódio ou de potássio','Bromides of sodium or of potassium','Bromuros de sodio o potasio',28,2827);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282759,'Outros brometos e oxibrometos','Bromides and bromide oxides (excl. of sodium, potassium and mercury)','Bromuros y oxibromuros (exc. bromuros de sodio o potasio)',28,2827);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282760,'Iodetos e oxiiodetos','Iodides and iodide oxides (excl. inorganic or organic compounds of mercury)','Yoduros y oxiyoduros',28,2827);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282810,'Hipocloritos de cálcio, inclusive o comercial','Calcium hypochlorites, incl. commercial calcium hypochlorite','Hipoclorito de calcio comercial y demás hipocloritos de calcio',28,2828);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282890,'Outros hipocloritos, cloritos e hipobromitos','Hypochlorites, chlorites and hypobromites (excl. calcium hypochlorites)','Hipocloritos, cloritos e hipobromitos (exc. hipocloritos de calcio)',28,2828);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282911,'Cloratos de sódio','Chlorate of sodium','Cloratos de sodio',28,2829);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282919,'Outros cloratos','Chlorates (excl. sodium)','Cloratos (exc. de sodio)',28,2829);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (282990,'Bromatos e perbromatos, iodatos e periodatos; percloratos','Perchlorates; bromates and perbromates; iodates and periodates (excl. inorganic or organic compounds of mercury)','Percloratos; bromatos y perbromatos; yodatos y peryodatos',28,2829);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283010,'Sulfeto de sódio','Sodium sulphides','Sulfuros de sodio',28,2830);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283020,'Sulfeto de zinco','Zinc sulphide','Sulfuro de cinc',28,2830);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283030,'Sulfeto de cádmio','Cadmium sulphide','Sulfuro de cadmio',28,2830);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283090,'Outros sulfetos e polissulfetos','Sulphides (excl. sodium); polysulphides, whether or not chemically defined (excl. inorganic or organic compounds of mercury)','Sulfuros (exc. de sodio, de cinc y de cadmio); polisulfuros, incl. de constitución química no definida',28,2830);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283110,'Ditionitos e sulfoxilatos de sódio','Dithionite and sulfoxylate of sodium','Ditionitos y sulfoxilatos, de sodio',28,2831);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283190,'Outros ditionitos e sulfoxilatos','Dithionites and sulfoxylates (excl. sodium)','Ditionitos y sulfoxilatos (exc. de sodio)',28,2831);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283210,'Sulfitos de sódio','Sodium sulphites','Sulfitos de sodio',28,2832);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283220,'Outros sulfitos','Sulphites (excl. sodium)','Sulfitos (exc. de sodio)',28,2832);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283230,'Tiossulfatos','Thiosulphates','Tiosulfatos',28,2832);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283311,'Sulfato dissódico','Disodium sulphate','Sulfato de disodio',28,2833);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283319,'Outros sulfatos de sódio','Sodium sulphates (excl. disodium)','Sulfatos de sodio (exc. sulfato de disodio)',28,2833);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283321,'Sulfato de magnésio','Sulphate of magnesium','Sulfatos de magnesio',28,2833);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283322,'Sulfato de alumínio','Sulphate of aluminium','Sulfatos de aluminio',28,2833);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283323,'Sulfato de cromo','Chromium sulphate','Sulfato de cromo',28,2833);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283324,'Sulfato de níquel','Sulphates of nickel','Sulfatos de níquel',28,2833);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283325,'Sulfato de cobre','Sulphates of copper','Sulfatos de cobre',28,2833);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283326,'Sulfato de zinco','Zinc sulphates','Sulfato de cinc',28,2833);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283327,'Sulfato de bário','Sulphate of barium','Sulfatos de bario',28,2833);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283329,'Outros sulfatos','Sulphates (excl. of sodium, magnesium, aluminium, nickel, copper, barium and mercury)','Sulfatos (exc. de sodio, magnesio, aluminio, cromo, níquel, cobre, cinc y bario)',28,2833);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283330,'Alumes','Alums','Alumbres',28,2833);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283340,'Peroxossulfatos (persulfatos)','Peroxosulphates persulphates','Peroxosulfatos "persulfatos"',28,2833);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283410,'Nitritos','Nitrites','Nitritos',28,2834);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283421,'Nitratos de potássio','Nitrate of potassium','Nitratos de potasio',28,2834);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283422,'Nitrato de bismuto','Bismuth nitrate','Nitrato de bismuto',28,2834);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283429,'Outros nitratos','Nitrates (excl. of potassium and of mercury)','Nitratos (exc. de potasio)',28,2834);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283510,'Fosfinatos (hipofosfito) e fosfonatos (fosfitos)','Phosphinates hypophosphites and phosphonates phosphites','Fosfinatos "hipofosfitos" y fosfonatos "fosfitos"',28,2835);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283522,'Fosfatos mono ou dissódico','Mono- or disodium phosphate','Fosfato de monosodio o disodio',28,2835);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283523,'Fosfato de trissódio','Phosphates of trisodium','Fosfato de trisodio',28,2835);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283524,'Fosfatos de potássio','Phosphates of potassium','Fosfatos de potasio',28,2835);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283525,'Fosfato hidrogeno-ortofosfato de cálcio (dicálcico)','Calcium hydrogenorthophosphate dicalcium phosphate','Hidrogenoortofosfato de calcio "fosfato dicálcico"',28,2835);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283526,'Outros fosfatos de cálcio','Phosphates of calcium (excl. calcium hydrogenorthophosphate dicalcium phosphate)','Fosfatos de calcio (exc. hidrogenoortofosfato de calcio "fosfato dicálcico")',28,2835);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283529,'Outros fosfatos','Phosphates (excl. phosphates of monosodium, disodium, potassium, calcium and mercury)','Fosfatos (exc. de monosodio, de disodio, de trisodio, de potasio y de calcio)',28,2835);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283531,'Trifosfato de sódio (tripolifosfato de sódio)','Sodium triphosphate sodium tripolyphosphate, whether or not chemically defined','Trifosfato de sodio "tripolifosfato de sodio", incl. de constitución química no definida',28,2835);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283539,'Outros polifosfatos','Polyphosphates, whether or not chemically defined (excl. sodium triphosphate sodium tripolyphosphate)','Polifosfatos, incl. de constitución química no definida (exc. trifosfato de sodio "tripolifosfato de sodio")',28,2835);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283610,'Carbonatos de amônio inclusive o comercial','Ammonium carbonate, including commercial','Carbonato de amonio, incluso el comercial',28,2836);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283620,'Carbonato dissódico','Disodium carbonate','Carbonato de disodio',28,2836);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283630,'Hidrogenocarbonato (bicarbonato) de sódio','Sodium hydrogencarbonate sodium bicarbonate','Hidrogenocarbonato "bicarbonato" de sodio',28,2836);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283640,'Carbonatos de potássio','Potassium carbonates','Carbonato de potasio',28,2836);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283650,'Carbonato de cálcio','Calcium carbonate','Carbonato de calcio',28,2836);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283660,'Carbonato de bário','Barium carbonate','Carbonato de bario',28,2836);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283670,'Carbonato de chumbo','Lead carbonate','Carbonatos de plomo',28,2836);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283691,'Carbonatos de lítio','Lithium carbonates','Carbonatos de litio',28,2836);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283692,'Carbonato de estrôncio','Strontium carbonate','Carbonato de estroncio',28,2836);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283699,'Outros carbonatos e peroxocarbonatos (percarbonatos)','Carbonates and peroxocarbonates percarbonates; commercial ammonium carbonate and other ammonium carbonates (excl. disodium carbonate, sodium hydrogencarbonate sodium bicarbonate, potassium carbonates, calcium carbonate, barium carbonate, lithium carbonate','Carbonatos y peroxocarbonatos "percarbonatos" (exc. carbonato de amonio, incl. el carbonato de amonio comercial, carbonato de disodio, hidrogenocarbonato "bicarbonato" de sodio, carbonato de potasio, calcio, bario, plomo, litio y estroncio)',28,2836);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283711,'Cianeto e oxicianeto de sódio','Sodium cyanide','Cianuros y oxicianuros, de sodio',28,2837);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283719,'Outros cianetos e oxicianetos','Cyanides and oxycyanides (excl. sodium and mercury)','Cianuros y oxicianuros (exc. de sodio)',28,2837);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283720,'Cianetos complexos','Complex cyanides (excl. inorganic or organic compounds of mercury)','Cianuros complejos',28,2837);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283800,'Fulminatos, cianatos e outros tiocianatos','Fulminates, cyanates and other thiocyanates','Fulminatos, cianatos y tiocianatos',28,2838);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283911,'Metassilicatos de sódio','Metasilicates of sodium, incl. commercial metasilicates','Metasilicatos de sodio, incl. los metasilicatos comerciales',28,2839);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283919,'Outros silicatos de sódio','Silicates of sodium, incl. commercial silicates (excl. sodium metasilicates)','Silicatos de sodio, incl. los silicatos comerciales (exc. metasilicatos)',28,2839);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283920,'silicato de potássio','potassium silicate','silicato de potasio',28,2839);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (283990,'Outros silicatos dos metais alcalinos comerciais','Silicates, incl. commercial alkali metal silicates (excl. sodium silicates)','Silicatos y silicatos comerciales (exc. de sodio o potasio)',28,2839);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284011,'Tetraborato dissódico (bórax refinado) anidro','Anhydrous disodium tetraborate refined borax','Tetraborato de disodio "bórax refinado", anhidro',28,2840);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284019,'Outros tetraboratos dissódicos (bórax refinado)','Disodium tetraborate refined borax (excl. anhydrous)','Tetraborato de disodio "bórax refinado" (exc. anhidro)',28,2840);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284020,'Outros boratos','Borates (excl. disodium tetraborate refined borax)','Boratos (exc. tetraborato de disodio "bórax refinado")',28,2840);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284030,'Peroxoboratos (perboratos)','Peroxoborates perborates','Peroxoboratos "perboratos"',28,2840);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284110,'Aluminatos','Aluminates','Aluminatos',28,2841);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284120,'Cromatos de zinco ou de chumbo','Chromates of zinc or of lead','Cromatos de cinc o plomo',28,2841);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284130,'Dicromato de sódio','Sodium dichromate','Dicromato de sodio',28,2841);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284140,'Dicromato de potássio','Potassium dichromate','Dicromato de potasio',28,2841);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284150,'Outros cromatos e dicromatos; peroxocromatos','Chromates and dichromates; peroxochromates (excl. sodium dichromate and  inorganic or organic compounds of mercury)','Cromatos, dicromatos y peroxocromatos (exc. cromatos de cinc o plomo y dicromato de sodio)',28,2841);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284161,'Permanganato de potássio','Potassium permanganate','Permanganato de potasio',28,2841);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284169,'Manganitos, manganatos e outros permanganatos','Manganites, manganates and permanganates (excl. potassium permanganate)','Manganitos, manganatos y permanganatos (exc. permanganato de potasio)',28,2841);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284170,'Molibdatos','Molybdates','Molibdatos',28,2841);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284180,'Tungstatos (volframatos)','Tungstates wolframates','Volframatos "tungstatos"',28,2841);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284190,'Outros sais dos ácidos oxometálicos ou peroxometálicos','Salts of oxometallic or peroxometallic acids (excl. chromates, dichromates, peroxochromates, manganites, manganates, permanganates, molybdates and tungstates wolframamtes)','Sales de los ácidos oxometálicos o peroxometálicos (exc. aluminatos, cromatos, dicromatos, peroxocromatos, manganitos, manganatos, permanganatos, molibdatos y volframatos "tungstatos")',28,2841);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284210,'Silicatos duplos ou complexos, incluídos os aluminossilicatos de constituição definida ou não','Double or complex silicates of inorganic acids or peroxoacids, incl. aluminosilicates whether or not chemically defined (excl. inorganic or organic compounds of mercury)','Silicatos dobles o complejos de los ácidos o peroxoácidos inorgánicos, incl. los aluminosilicatos, incl. de constitución química no definida',28,2842);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284290,'Outros sais dos ácidos ou peroxoácidos inorgânicos, exceto azidas','Salts of inorganic acids or peroxoacids (excl. of oxometallic or peroxometallic acids, double or complex silicates [incl. aluminosilicates whether or not chemically defined], azides, and inorganic or organic compounds of mercury)','Sales de los ácidos o peroxoácidos inorgánicos (exc. de los ácidos oxometálicos o peroxometálicos, así como los silicatos dobles o complejos, incl. los aluminosilicatos, incl. de constitución química no definida, y los aziduros "azidas")',28,2842);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284310,'Metais preciosos no estado coloidal','Colloidal precious metals','Metal precioso en estado coloidal',28,2843);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284321,'Nitrato de prata','Silver nitrate (excl. inorganic or organic compounds of mercury)','Nitrato de plata',28,2843);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284329,'Outros compostos de prata','Silver compounds, inorganic or organic, whether or not chemically defined (excl. of mercury and silver nitrate)','Compuestos de plata, inorgánicos u orgánicos, aunque no sean de constitución química definida (exc. nitrato de plata)',28,2843);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284330,'Compostos de ouro','Gold compounds, inorganic or organic, whether or not chemically defined','Compuestos de oro, inorgánicos u orgánicos, aunque no sean de constitución química definida',28,2843);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284390,'Outros compostos inorgânicos ou orgânicos de metais preciosos; amálgamas de metais preciosos','Inorganic or organic compounds of precious metals, whether or not chemically defined (excl. silver and gold); amalgams of precious metals','Compuestos inorgánicos u orgánicos de metal precioso, aunque no sean de constitución química definida (exc. de oro y de plata); amalgamas de metal precioso',28,2843);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284410,'Urânio natural e seus compostos; ligas, dispersões e misturas contendo urânio natural','Natural uranium and its compounds; alloys, dispersions, incl. cermets, ceramic products and mixtures containing natural uranium or natural uranium compound [Euratom]','Uranio natural y sus compuestos; aleaciones, dispersiones, incl. el cermet, productos cerámicos y mezclas, que contengan uranio natural o compuestos de uranio natural [Euratom]',28,2844);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284420,'Urânio enriquecido em U235 e seus compostos; plutônio e seus compostos; ligas, dispersões e misturas ou compostos destes produtos','Uranium enriched in U 235 and its compounds: plutonium and its compounds; alloys, dispersions, incl. cermets, ceramic products and mixtures containing uranium enriched in U 235, plutonium or compounds of these products [Euratom]','Uranio enriquecido en U 235 y sus compuestos; plutonio y sus compuestos; aleaciones, dispersiones, incl. el cermet, productos cerámicos y mezclas, que contegan uranio enriquecido en U 235, plutonio o compuestos de estos productos [Euratom]',28,2844);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284430,'Urânio empobrecido em U235 e seus compostos; tório e seus compostos; ligas, dispersões e misturas ou compostos destes produtos','Uranium depleted in U 235 and its compounds; thorium and its compounds; alloys, dispersions, incl. cermets, ceramic products and mixtures containing uranium depleted in U 235, thorium or compounds of these products','Uranio empobrecido en U 235 y sus compuestos; torio y sus compuestos; aleaciones, dispersiones, incl. el cermet, productos cerámicos y mezclas, que contegan uranio empobrecido en U 235, torio o compuestos de estos productos',28,2844);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284440,'Elementos, isótopos e compostos, radioativos; ligas, dispersões e misturas destes produtos; resíduos radiativos','Radioactive elements, isotopes and compounds, and alloys and dispersions, incl. cermets, ceramic products and mixtures, containing these elements, isotopes and compounds; radioactive residues (excl. natural uranium, uranium enriched and depleted in U 235;','Elementos e isótopos y compuestos, radiactivos, así como aleaciones, dispersiones, incl. el cermet, productos cerámicos y mezclas, que contengan estos elementos, isótopos o compuestos y residuos radiactivos (exc. uranio natural, uranio enriquecido en U 23',28,2844);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284450,'Elementos combustíveis (cartuchos), usados (irradiados), de reatores nucleares','Spent irradiated fuel elements cartridges of nuclear reactors [Euratom]','Cartuchos agotados "irradiados" de reactores nucleares [Euratom]',28,2844);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284510,'Água pesada (óxido de deutério)','Heavy water deuterium oxide [Euratom]','Agua pesada "óxido de deuterio" [Euratom]',28,2845);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284590,'Isótopos (no radioativos) e seus compostos inorgânicos ou orgânicos','Non-radioactive isotopes; inorganic or organic compounds of such isotopes, whether or not chemically defined (excl. heavy water deuterium oxide)','Isótopos no radiactivos y sus compuestos inorgánicos u orgánicos, aunque no sean de constitución química definida (exc. agua pesada "óxido de deuterio")',28,2845);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284610,'Compostos de cério','Cerium compounds','Compuestos de cerio',28,2846);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284690,'Outros compostos dos metais das terras raras, de ítrio ou de escândio ou da mistura desses metais','Compounds, inorganic or organic, of rare-earth metals, of yttrium or of scandium or of mixtures of these metals (excl. cerium)','Compuestos inorgánicos u orgánicos, de metales de las tierras raras, del itrio, del escandio o de las mezclas de estos metales (exc. compuestos de cerio)',28,2846);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284700,'Peróxido de hidrogênio (água oxigenada), mesmo solidificado com uréia','Hydrogen peroxide, whether or not solidified with urea','Peróxido de hidrógeno "agua oxigenada"',28,2847);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284800,'Fosfetos, exceto ferrofósforos, quimicamente definidos ou não','Phosphides, whether or not chemically defined (excl. ferrophosphorus)','Fosfuros, aunque no sean de constitución química definida (exc. ferrofósforos)',28,2848);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284910,'Carboneto de cálcio, quimicamente definido ou não','Carbides of calcium, whether or not chemically defined','Carburos de calcio, aunque no sean de constitución química definida',28,2849);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284920,'Carboneto de silício, quimicamente definido ou não','Carbides of silicon, whether or not chemically defined','Carburos de silicio, aunque no sean de constitución química definida',28,2849);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (284990,'Outros carbonetos de constituição química definida ou não','Carbides, whether or not chemically defined (excl. of calcium or silicon)','Carburos, aunque no sean de constitución química definida (exc. de calcio y de silicio)',28,2849);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (285000,'Hidretos, nitretos, azidas, silicietos e boretos, quimicamente definidos ou não','Hydrides, nitrides, azides, silicides and borides, whether or not chemically defined (excl. compounds which are also carbides of heading 2849)','Hidruros, nitruros, aziduros "azidas", siliciuros y boruros, aunque no sean de constitución química definida (exc. compuestos que consistan igualmente en carburos de la partida 2849)',28,2850);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (285100,'Compostos inorgânicos','Inorganic compounds','Compuestos inorgánicos',28,2851);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (285200,'Compostos, inorgânicos ou orgânicos, de mercúrio, exceto as amálgamas.','Compounds, inorganic or organic, of mercury (excl. amalgams)','Compuestos inorgánicos u orgánicos, de mercurio, excepto las amalgamas',28,2852);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (285210,'Compostos inorgânicos ou orgânicos de mercúrio, de constituição química definida','Inorganic or organic compounds of mercury, chemically defined','Compuestos inorgánicos u orgánicos de mercurio, de constitución química definida',28,2852);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (285290,'Outros compostos de mercúrio','Other compounds of mercury','Otros compuestos de mercurio',28,2852);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (285300,'Outros compostos inorgânicos (incluídas as águas destiladas, de condutibilidade ou de igual grau de pureza); ar líquido (incluído o ar líquido cujos gases raros foram eliminados); ar comprimido; amálgamas, exceto de metais preciosos.','Inorganic and organic compounds, incl. distilled or conductivity water and water of similar purity, n.e.s.; liquid air, whether or not rare gases have been removed; compressed air; amalgams (other than amalgams of precious metals)','Compuestos inorgánicos u orgánicos (incl. el agua destilada, de conductibilidad o del mismo grado de pureza); aire líquido, aunque se hayan eliminado los gases nobres, aire comprimido; amalgamas (exc. las de metales preciosos)',28,2853);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290110,'Hidrocarbonetos acíclicos saturados','Saturated acyclic hydrocarbons','Hidrocarburos acíclicos saturados',29,2901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290121,'Etileno não saturado','Ethylene','Etileno',29,2901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290122,'Propeno (propileno) não saturado','Propene propylene','Propeno "propileno"',29,2901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290123,'Buteno (butileno) não saturado e seus isômeros','Butene butylene and isomers thereof','Buteno "butileno" y sus isómeros',29,2901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290124,'Buta-1, 3-dieno e isopreno não saturados','Buta-1,3-diene and isoprene','Buta-1,3-dieno e isopreno',29,2901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290129,'Outros hidrocarbonetos acíclicos não saturados','Hydrocarbons, acyclic, unsaturated (excl. ethylene, propene propylene, butene butylene and isomers thereof and Buta-1,3-diene and isoprene)','Hidrocarburos acíclicos, no saturados (exc. etileno, propeno "propileno", buteno "butileno" y sus isómeros, así como buta-1,3- dieno e isopreno)',29,2901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290211,'Cicloexano','Cyclohexane','Ciclohexano',29,2902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290219,'Outros hidrocarbonetos ciclânicos, ciclênicos, cicloterpênicos','Cyclanes, cyclenes and cycloterpenes (excl. cyclohexane)','Hidrocarburos ciclánicos, ciclénicos o cicloterpénicos (exc. ciclohexano)',29,2902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290220,'Benzeno','Benzene','Benceno',29,2902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290230,'Tolueno','Toluene','Tolueno',29,2902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290241,'o-Xileno','o-Xylene','o-Xileno',29,2902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290242,'m-Xileno','m-Xylene','m-Xileno',29,2902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290243,'p-Xileno','p-Xylene','p-Xileno',29,2902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290244,'Mistura de isômeros do xileno','Mixed xylene isomers','Mezclas de isómeros del xileno',29,2902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290250,'Estireno','Styrene','Estireno',29,2902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290260,'Etilbenzeno','Ethylbenzene','Etilbenceno',29,2902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290270,'Cumeno','Cumene','Cumeno',29,2902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290290,'Outros hidrocarbonetos cíclicos','Cyclic hydrocarbons (excl. cyclanes, cyclenes, benzene, toluene, xylenes, styrene, ethylbenzene and cumene)','Hidrocarburos cíclicos (exc. ciclánicos, ciclénicos o cicloterpénicos, así como el benceno, el tolueno, los xilenos, el estireno, el etilbenceno y el cumeno)',29,2902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290311,'Clorometano (cloreto de metila) e cloroetano (cloreto de etila)','Chloromethane methyl chloride and chloroethane ethyl chloride','Clorometano "cloruro de metilo" y cloroetano "cloruro de etilo"',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290312,'Diclorometano (cloreto de metileno)','Dichloromethane methylene chloride','Diclorometano "cloruro de metileno"',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290313,'Clorofórmio (triclorometano)','Chloroform trichloromethane','Cloroformo "triclorometano"',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290314,'Tetracloreto de carbono','Carbon tetrachloride','Tetracloruro de carbono',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290315,'1, 2-Dicloroetano (cloreto de etileno)','Ethylene dichloride ISO 1,2 dichloroethane','1,2-Dicloroetano "dicloruro de etileno"',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290316,'1, 2-dicloropropano (cloreto propileno) e diclorobutanos','1, 2-dichloropropene(propylene chloride)and dichlorobut.','1, 2 - dicloropropano(clor.de propileno)y diclorobutanos',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290319,'Outros derivados clorados saturados dos hidrocarbonetos acíclicos','Saturated chlorinated derivatives of acyclic hydrocarbons (excl. chloromethane [methyl chloride], chloroethane [ethyl chloride], dichloromethane [methylene chloride], chloroform [trichloromethane], carbon tetrachloride and ethylene dichloride [ISO] [1,2 d','Derivados clorados saturados de los hidrocarburos acíclicos (exc. clorometano "cloruro de metilo", cloroetano "cloruro de etilo", diclorometano "cloruro de metileno", cloroformo "triclorometano", tetracloruro de carbono y 1,2-dicloroetano "dicloruro de et',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290321,'Cloreto de vinila (cloroetileno)','Vinyl chloride chloroethylene','Cloruro de vinilo "cloroetileno"',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290322,'Tricloroetileno','Trichloroethylene','Tricloroetileno',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290323,'Tetracloroetileno (percloroetileno)','Tetrachloroethylene perchloroethylene','Tetracloroetileno "percloroetileno"',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290329,'Outros derivados clorados não saturados dos hidrocarbonetos acíclicos','Unsaturated chlorinated derivatives of acyclic hydrocarbons (excl. vinyl chloride chloroethylene, trichloroethylene and tetrachloroethylene perchloroethylene)','Derivados clorados no saturados de los hidrocarburos acíclicos (exc. cloruro de vinilo "cloroetileno", tricloroetileno y tetracloroetileno "percloroetileno")',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290330,'Derivados halogenados dos hidrocarbonetos','Derivatives halogenated hydrocarbons','Hidrocarburos halogenados derivados',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290331,'Dibrometo de etileno (1,2-dibromoetano)','Ethylene dibromide ISO 1,2-dibromoethane',' Dibromuro de etileno (ISO) (1,2dibromoetano)',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290339,'Outros derivados fluorados, bromados e yodados de los hidrocarbonetos acíclicos','Fluorinated, brominated or iodinated derivatives of acyclic hydrocarbons (excl. ethylene dibromide [ISO] [1,2-dibromoethane])',' Derivados fluorados, bromurizados y yodados de los hidrocarburos acíclicos (exc. dibromuro de etileno [ISO] [1,2-dibromoetano])',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290341,'Triclorofluormetano','Trichlorofluoromethane','Triclorofluorometano',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290342,'Diclorodifluormetano','Dichlorodifluoromethane','Diclorodifluorometano',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290343,'Triclorotrifluoretanos','Trichlorotrifluoroethanes','Triclorotrifluoroetanos',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290344,'Diclorotetrafluoretanos e cloropentafluoretano','Dichlorotetrafluoroethanes and chloropentafluoroethane','Diclorotetrafluoroetanos y cloropentafluoroetano',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290345,'Outros derivados peralogenados dos hidrocarbonetos acíclicos com flúor e cloro','Derivatives of acyclic hydrocarbons, perhalogenated only with fluorine and chlorine (excl. trichlorofluoromethane, dichlorodifluoromethane, trichlorotrifluoroethanes, dichlorotetrafluoroethanes and chloropentafluoroethane)','Derivados de los hidrocarburos acíclicos, perhalogenados únicamente con flúor y cloro (exc. triclorofluorometano, diclorodifluorometano, triclorotrifluoroetanos, diclorotetrafluoroetanos y cloropentafluoroetanos)',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290346,'Bromoclorodifluormetano, bromotrifluormetano e dibromotetrafluoretanos','Bromochlorodifluoromethane, bromotrifluoromethane and dibromotetrafluoroethanes','Bromoclorodifluorometano, bromotrifluorometano y dibromotetrafluoroetanos',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290347,'Outros derivados peralogenados dos hidrocarbonetos acíclicos com pelo menos dois halogenados diferentes','Perhalogenated derivatives of acyclic hydrocarbons with two or more different halogens (excl. only fluorinated and chlorinated and bromochlorodifluoromethane, bromotrifluoromethane and dibromotetrafluoroethanes)','Derivados perhalogenados de los hidrocarburos acíclicos con dos halógenos diferentes, por lo menos (exc. bromoclorodifluorometano, bromotrifluorometano y dibromotetrafluoroetanos, así como los derivados perhalogenados únicamente con flúor y cloro)',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290349,'Outros derivados halogenados dos hidrocarbonetos acíclicos com dois halogenados diferentes','Halogenated derivatives of acyclic hydrocarbons with two or more different halogens (excl. perhalogenated derivatives)','Derivados halogenados de los hidrocarburos acíclicos con dos halógenos diferentes, por lo menos (exc. derivados perhalogenados)',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290351,'1,2,3,4,5,6-Hexaclorocicloexano','1,2,3,4,5,6-Hexachlorocyclohexane [HCH ISO], incl. lindane ISO INN','1,2,3,4,5,6-Hexaclorociclohexano',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290352,'Aldrin, clordano e heptacloro','Aldrin ISO, chlordane ISO and heptachlor ISO',' Aldrina (ISO), clordano (ISO) y heptacloro (ISO)',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290359,'Outros derivados halogenados dos hidrocarbonetos ciclânicos, ciclênicos e cicloterpênicos','Halogenated derivatives of cyclanic, cyclenic or cycloterpenic hydrocarbons (excl. 1,2,3,4,5,6-hexachlorocyclohexane [HCH [ISO]], incl. lindane [ISO] [INN], and aldrin [ISO], chlordane [ISO] and heptachlor [ISO])','Derivados halogenados de los hidrocarburos ciclánicos, ciclénicos o cicloterpénicos (exc. 1,2,3,4,5,6-hexaclorociclohexano)',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290361,'Clorobenzeno, o-diclorobenzeno e p-diclorobenzeno','Chlorobenzene, o-dichlorobenzene and p-dichlorobenzene','Clorobenceno, o-diclorobenceno y p-diclorobenceno',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290362,'Hexaclorobenzeno e DDT [1,1,1-tricloro-2,2-bis (p-clorofenil)etano]','Hexachlorobenzene ISO and DDT ISO clofenotane INN, 1,1,1-trichloro-2,2-bis[p-chlorophenyl]ethane','Hexaclorobenceno y DDT "1,1,1-tricloro-2,2-bis[p-clorofenil]etano"',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290369,'Outros derivados halogenados dos hidrocarbonetos aromáticos','Other halogenated derivatives of aromatic hydrocarbons','Otros derivados halogenados de los hidrocarburos aromáticos',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290371,'Clorodifluorometanos','Clorodifluorometanos','Clorodifluorometanos',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290372,'diclorotrifluoroetanos','diclorotrifluoroetanos','diclorotrifluoroetanos',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290373,'diclorofluoroetanos','diclorofluoroetanos','diclorofluoroetanos',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290374,'clorodifluoroetanos','clorodifluoroetanos','clorodifluoroetanos',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290375,'dicloropentafluoropropanos','dicloropentafluoropropanos','dicloropentafluoropropanos',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290376,'bromoclorodifluorometano, bromotrifluorometano, etc','bromoclorodifluorometano, bromotrifluorometano, etc','bromoclorodifluorometano, bromotrifluorometano, etc',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290377,'Outros derivados halogenados dos hidrocarbonetos acíclicos, peralogenados unicamente com flúor e cloro','Other halogenated derivatives of acyclic hydrocarbons, perhalogenated only with fluorine and chlorine','Otros derivados halogenados de los hidrocarburos acíclicos, perhalogenados únicamente con flúor y cloro',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290378,'Outros derivados peralogenados','Other perhalogenated derivatives','Otros derivados peralogenados',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290379,'Outros derivados halogenados dos hidrocarbonetos acíclicos que contenham pelo menos dois halogênios diferentes','Other halogenated acyclic hydrocarbon containing at least two different halogens','Otro hidrocarburo halogenado acíclico que contiene al menos dos halógenos diferentes',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290381,'1,2,3,4,5,6-Hexaclorocicloexano (HCH (ISO)), incluindo o lindano (ISO, DCI)',',2,3,4,5,6-hexachlorocyclohexane (HCH (ISO)), including lindane (ISO, INN)','1,2,3,4,5,6-hexaclorociclohexano (HCH (ISO)), incluido el lindano (ISO, DCI)',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290382,'Aldrin (ISO), clordano (ISO) e heptacloro (ISO)','Aldrin (ISO), chlordane (ISO) and heptachlor (ISO)','Aldrina (ISO), clordano (ISO) y heptacloro (ISO)',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290389,'Outros derivados halogenados dos hidrocarbonetos ciclânicos, ciclênicos ou cicloterpênicos','Other halogenated derivatives of hydrocarbons Cyclanic, cyclenic or cycloterpenic','Otros derivados halogenados de los hidrocarburos ciclánicos, ciclénicos o cicloterpénicos',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290391,'Clorobenzeno, o-diclorobenzeno e p-diclorobenzeno','Chlorobenzene, o-dichlorobenzene, and p-dichlorobenzene','Clorobenceno, o-diclorobenceno, y p-diclorobenceno',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290392,'Hexaclorobenzeno (ISO) e DDT (ISO) (clofenotano (DCI), 1,1,1-tricloro-2,2-bis(p-clorofenil)etano)','Hexachlorobenzene (ISO) and DTT (ISO) (clofenotano (INN), 1,1,1-trichloro-2 ,2-bis (p-chlorophenyl) ethane)','Hexaclorobenceno (ISO) y DTT (ISO) (clofenotano (DCI), 1,1,1-tricloro-2 ,2-bis (p-clorofenil) etano)',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290399,'Outros halogenados derivados de hidrocarbonetos aromáticos','Other halogenated derivatives of aromatic hydrocarbons','Otros derivados halógenos de los hidrocarburos aromáticos',29,2903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290410,'Derivados sulfonados dos hidrocarbonetos, seus sais e seus ésteres etílicos','Derivatives of hydrocarbons containing only sulpho groups, their salts and ethyl esters','Derivados de los hidrocarburos, solamente sulfonados, sus sales y sus ésteres etílicos',29,2904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290420,'Derivados apenas nitrados ou apenas nitrosados','Derivatives of hydrocarbons containing only nitro or nitroso groups','Derivados de los hidrocarburos, solamente nitrados o solamente nitrosados',29,2904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290490,'Outros derivados nitroalogenados, nitrossulfonados, sulfonados, nitrados dos hidrocarbonetos','Sulphonated, nitrated or nitrosated derivatives of hydrocarbons, whether or not halogenated (excl. those containing only sulpho, nitro or nitroso groups)','Derivados sulfonados, nitrados o nitrosados de los hidrocarburos, incl. halogenados (exc. solamente sulfonados, solamente nitrados o solamente nitrosados)',29,2904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290511,'Metanol (álcool metílico)','Methanol (methyl alcohol)','Metanol ("alcohol metílico")',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290512,'Álcool propílico (propan-1-ol) e álcool isopropílico (propan-2-ol)','Propan-1-ol propyl alcohol and propan-2-ol isopropyl alcohol','Propan-1-ol "alcohol propílico" y propan-2-ol "alcohol isopropílico"',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290513,'Butan-1-ol (álcool n-butílico)','Butan-1-ol n-butyl alcohol','Butan-1-ol "alcohol n-butílico"',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290514,'Outros butanóis','Butanols (excl. butan-1-ol n-butyl alcohol)','Butanoles (exc. butan-1-ol "alcohol n-butílico")',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290515,'Pentanol (álcool amilico) e seus isômeros','Pentanol (amyl alcohol) and their isomers','Pentanol (alcohol amílico) y sus isómeros',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290516,'Octanol (álcool octílico) e seus isômeros','Octanol octyl alcohol and isomers thereof','Octanol "alcohol octílico" y sus isómeros',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290517,'Álcool laurílico, álcool cetílico e álcool esteárico','Dodecan-1-ol lauryl alcohol, hexadecan-1-ol cetyl alcohol and octadecan-1-ol stearyl alcohol','Dodecan-1-ol "alcohol laurílico", hexadecan-1-ol "alcohol cetílico" y octadecan-1-ol "alcohol esteárílico"',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290519,'Outros monoálcoois saturados','Saturated monohydric acyclic alcohols (excl. methanol methyl alcohol, propan-1-ol propyl alcohol, propan-2-ol isopropyl alcohol, butanols, octanol octyl alcohol and isomers thereof, dodecan-1-ol lauryl alcohol, hexadecan-1-ol cetyl alcohol and octadecan-1','Monoalcoholes acíclicos saturados (exc. metanol "alcohol metílico", propan-1-ol "alcohol propílico", propan-2-ol "alcohol isopropílico", butanoles, pentanol "alcohol amílico" y sus isómeros, octanol "alcohol octílico" y sus isómeros, dodecan-1-ol "alcohol',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290522,'Álcoois terpênicos acíclicos, não saturados','Acyclic terpene alcohols','Alcoholes terpénicos acíclicos',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290529,'Outros monoálcoois acíclicos não saturados','Unsaturated monohydric acyclic alcohols (excl. acyclic terpene alcohols)','Monoalcoholes acíclicos no saturados (exc. alcoholes terpénicos acíclicos)',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290531,'Etilenoglicol (etanodiol)','Ethylene glycol ethanediol','Etilenglicol "etanodiol"',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290532,'Propilenoglicol (propano-1, 2-diol)','Propylene glycol propane-1,2-diol','Propilenglicol "propano-1,2-diol"',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290539,'Outros álcoois dióis, não saturados','Diols (excl. ethylene glycol ethanediol and propylene glycol propane-1,2-diol)','Dioles acíclicos (exc. etilenglicol "etanodiol" y propilenglicol "propano-1,2-diol")',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290541,'2-Etil-2- (hidroximetil) propano-1, 3-diol (trimetiolpropano) ','2-Ethyl-2-hydroxymethyl propane-1,3-diol trimethylolpropane','2-Etil-2-"hidroximetil"propano-1,3-diol "trimetilolpropano"',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290542,'Pentaeritritol (pentaeritrita)','Pentaerythritol','Pentaeritritol "pentaeritrita"',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290543,'Manitol','Mannitol','Manitol',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290544,'d-Glucitol (sorbitol) (poliálcool)','D-glucitol sorbitol','D-glucitol "sorbitol"',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290545,'Glicerol','Glycerol','Glicerol',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290549,'Outros poliálcoois, não saturados','Tri- and other polyhydric acyclic alcohols (excl. 2-ethyl-2-hydroxymethyl propane-1,3-diol trimethylolpropane, pentaerythritol, mannitol, d-glucitol sorbitol and glycerol)','Polialcoholes acíclicos (exc. 2-etil-2-"hidroximetil"propano-1,3-diol "trimetilolpropano", pentaeritritol "pentaeritrita", manitol, D-glucitol "sorbitol" y glicerol, así como los dioles)',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290550,'Derivados halogenados, sulfonados, nitrados ou nitrosados dos álcoois acíclicos','Halogenated, sulphonated, nitrated or nitrosated derivatives of acyclic alcohols','Derivados halogenados, sulfonados, nitrados o nitrosados de los alcoholes acíclicos',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290551,'Etclorvinol','Ethchlorvynol INN','Etclorvinol "DCI"',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290559,'Outros derivados halogenados, sulfonados, nitrados ou nitrosados dos álcoois acíclicos','Halogenated, sulphonated, nitrated or nitrosated derivatives or acyclic alcohols (excl. ethchlorvynol INN)','Derivados halogenados, sulfonados, nitrados o nitrosados de los alcoholes acíclicos (exc. etclorvinol "DCI")',29,2905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290611,'Mentol','Menthol','Mentol',29,2906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290612,'Cicloexanol, metilcicloexanóis e dimetilcicloexanóis','Cyclohexanol, methylcyclohexanols and dimethylcyclohexanols','Ciclohexanol, metilciclohexanoles y dimetilciclohexanoles',29,2906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290613,'Esteróis e inositóis','Sterols and inositols','Esteroles e inositoles',29,2906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290614,'terpineóis','terpineols','terpineoles',29,2906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290619,'Outros álcoois ciclânicos, ciclênicos e cicloterpênicos e seus derivados halogenados, sulfonados, nitrados ou nitrosados','Cyclanic, cyclenic or cycloterpenic alcohols and their halogenated, sulphonated, nitrated or nitrosated derivatives (excl. menthol, cyclohexanol, methylcyclohexanols, dimethylcyclohexanols, sterols and inositols)','Alcoholes ciclánicos, ciclénicos o cicloterpénicos y sus derivados halogenados, sulfonados, nitrados o nitrosados (exc. mentol, ciclohexanol, metilciclohexanoles, dimetilciclohexanoles, esteroles, inositoles y terpineoles)',29,2906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290621,'Álcool benzílico','Benzyl alcohol','Alcohol bencílico',29,2906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290629,'Outros álcoois cíclicos aromáticos e seus derivados halogenados, sulfonados, nitrados ou nitrosados','Aromatic cyclic alcohols and their halogenated, sulphonated, nitrated or nitrosated derivatives (excl. benzyl alcohol)','Alcoholes cíclicos aromáticos y sus derivados halogenados, sulfonados, nitrados o nitrosados (exc. alcohol bencílico)',29,2906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290711,'Fenol (hidroxibenzeno) e seus sais','Phenol hydroxybenzene and its salts','Fenol "hidroxibenceno" y sus sales',29,2907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290712,'Cresóis e seus sais','Cresols and their salts','Cresoles y sus sales',29,2907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290713,'Octilfenol, nonilfenol e seus isômeros; sais destes produtos','Octylphenol, nonylphenol and their isomers; salts thereof','Octilfenol, nonilfenol y sus isómeros; sales de estos productos',29,2907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290714,'xilenois e seus sais','xylenols and their salts','xilenoles y sus sales',29,2907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290715,'Naftóis e seus sais','Naphthols and their salts','Naftoles y sus sales',29,2907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290719,'Outros monofenóis','Monophenols (excl. phenol hydroxybenzene and its salts, cresols and their salts, octylphenol, nonylphenol and their isomers and salts thereof and naphthols and their salts)','Monofenoles (exc. fenol "hidroxibenceno" y sus sales; cresoles y sus sales; octilfenol, nonilfenol, sus isómeros y sus sales; xilenoles y sus sales; naftoles y sus sales)',29,2907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290721,'Resorcinol e seus sais','Resorcinol and its salts','Resorcinol y sus sales',29,2907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290722,'Hidroquinona e seus sais','Hydroquinone quinol and its salts','Hidroquinona y sus sales',29,2907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290723,'4,4-Isopropilidenodifenol e seus sais','4,4''-Isopropylidenediphenol bisphenol A, diphenylolpropane and its salts','4,4''-Isopropilidendifenol "bisfenol A, difenilolpropano" y sus sales',29,2907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290729,'Outros polifenóis ou fenóis-álcoois','Polyphenols and phenol-alcohols (excl. resorcinol and hydroquinone quinol and their salts, and 4,4''-isopropylidenediphenol bisphenol A, diphenylolpropane and its salts)','Polifenoles y fenoles-alcoholes (exc. resorcinol y sus sales; hidroquinona y sus sales; 4,4''-isopropilidendifenol "bisfenol A, difenilolpropano" y sus sales)',29,2907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290730,'fenóis-alcoóis','phenol-alcohols','fenoles-alcoholes',29,2907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290810,'Derivados apenas halogenados e seus sais','Derivatives containing only halogen substituents and their salts','Derivados solamente halogenados y sus sales',29,2908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290811,'Pentaclorofenol','Pentachlorophenol ISO',' Pentaclorofenol (ISO)',29,2908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290819,'Outros derivados apenas halogenados e seus sais','Derivatives containing only halogen substituents and their salts, of phenols or phenol-alcohols (excl. pentachlorophenol [ISO])','Derivados solamente halogenados de los fenoles o de los fenoles-alcoholes y sus sales (exc. pentaclorofenol [ ISO ])',29,2908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290820,'Derivados sulfonados dos fenóis, seus sais e ésteres','Sulphonated phenols, their salts and esters','Fenoles sulfonados, sus sales y ésteres',29,2908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290890,'Ácido pícrico; dinoseb e seus sais; disofenol; outros','Picric acid, dinoseb and its salts; disophenol, others','Ácido pícrico, dinoseb y sus sales; disophenol, otros',29,2908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290891,'Dinoseb e seus sais','Dinoseb ISO and its salts',' Dinoseb (ISO) y sus sales',29,2908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290892,'4,6-dinitro-o-cresol (dnoc (iso)) e seus sais','4,6-dinitro-o-cresol (dnoc (iso)) e seus sais','4,6-dinitro-o-cresol (dnoc (iso)) e seus sais',29,2908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290899,'Outros derivados halogenados, sulfonados, nitrados ou nitrosados dos fenóis ou fenóis-álcoois','Halogenated, sulphonated, nitrated or nitrosated derivatives of phenols or phenol-alcohols (excl. derivatives containing only halogen substitutes and their salts, and dinoseb [ISO] and its salts)','Derivados halogenados, sulfonados, nitrados o nitrosados de los fenoles o de los fenoles-alcoholes (exc. derivados solamente halogenados y sus sales así como dinoseb [ISO] y sus sales)',29,2908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290911,'Éter dietílico (óxido de dietila)','Diethyl ether','Éter dietílico "óxido de dietilo"',29,2909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290919,'Outros éteres acíclicos e seus derivados halogenados, sulfonados, nitrados ou nitrosados','Acyclic ethers and their halogenated, sulphonated, nitrated or nitrosated derivatives (excl. diethyl ether)','Éteres acíclicos y sus derivados halogenados, sulfonados, nitrados o nitrosados (exc. éter dietílico "óxido de dietilo")',29,2909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290920,'Éteres ciclânicos, ciclênicos, cicloterpênicos e derivados halogenados, sufonados, nitrados ou nitrosados','Cyclanic, cyclenic or cycloterpenic ethers and their halogenated, sulphonated, nitrated or nitrosated derivatives','Éteres ciclánicos, ciclénicos, cicloterpénicos y sus derivados halogenados, sulfonados, nitrados o nitrosados',29,2909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290930,'Éteres aromáticos e seus derivados halogenados, sufonados, nitrados ou nitrosados','Aromatic ethers and their halogenated, sulphonated, nitrated or nitrosated derivatives','Éteres aromáticos y sus derivados halogenados, sulfonados, nitrados o nitrosados',29,2909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290941,'2,2-Oxidietanol (dietilenoglicol)','2,2''-Oxydiethanol diethylene glycol, digol','2,2''-Oxidietanol "dietilenglicol"',29,2909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290942,'éteres monometílicos do etilenoglicol/dietilenoglicol','monomethyl ethers of ethylene glycol/diethylene glycol','éteres monometílicos del etilenglicol/dietilenglicol',29,2909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290943,'Eteres monobutilicos do etilenoglicol ou do dietilenoglicol','Monobutyl ethers of ethylene glycol or of diethylene glycol','Éteres monobutílicos del etilenglicol o del dietilenglicol',29,2909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290944,'Outros éteres monoalquílicos do etilenoglicol ou do dietilenoglicol','Monoalkylethers of ethylene glycol or of diethylene glycol (excl. monobutyl ethers)','Éteres monoalquílicos del etilenglicol o del dietilenglicol (exc. 2,2''-oxidietanol "dietilenglicol", éteres monometílicos y éteres monobutílicos)',29,2909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290949,'Outros éteres-álcoois e seus derivados halogenados, sulfonados, nitrados ou nitrosados','Ether-alcohols and their halogenated, sulphonated, nitrated or nitrosated derivatives (excl. 2,2''-Oxydiethanol diethylene glycol, digol and monoalkylethers of ethylene glycol or of diethylene glycol)','Éteres-alcoholes y sus derivados halogenados, sulfonados, nitrados o nitrosados (exc. 2,2''-oxidietanol "dietilenglicol" y éteres monoalquílicos del etilenglicol o del dietilenglicol)',29,2909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290950,'Éteres-fenóis, éteres-álcoois-fenóis e seus derivados halogenados, sulfonados, nitrados ou nitrosados','Ether-phenols, ether-alcohol-phenols and their halogenated, sulphonated, nitrated or nitrosated derivatives','Éteres-fenoles, éteres-alcoholes-fenoles y sus derivados halogenados, sulfonados, nitrados o nitrosados',29,2909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (290960,'Peróxidos de álcoois, peróxidos de éteres, peróxidos de cetonas e seus derivados halogenados, sulfonados, nitrados ou nitrosados','Alcohol peroxides, ether peroxides, ketone peroxides and their halogenated, sulphonated, nitrated or nitrosated derivatives','Peróxidos de alcoholes, peróxidos de éteres, peróxidos de cetonas, y sus derivados halogenados, sulfonados, nitrados o nitrosados',29,2909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291010,'Oxirano (óxido de etileno)','Oxirane ethylene oxide','Oxirano "óxido de etileno"',29,2910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291020,'Metiloxirano (óxido de propileno)','Methyloxirane propylene oxide','Metiloxirano "óxido de propileno"',29,2910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291030,'1-Cloro-2,3-epoxipropano (epicloridrina)','1-Chloro-2,3-epoxypropane epichlorohydrin','1-Cloro-2,3-epoxipropano "epiclorhidrina"',29,2910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291040,'Dieldrin','Dieldrin ISO INN',' Dieldrina (ISO, DCI)',29,2910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291090,'Outros epóxidos, epoxálcoois, epoxifenóis e epoxiéteres com 3 (três) átomos no ciclo e seus derivados halogenados, sulfonados, nitrados ou nitrosados','Epoxides, epoxyalcohols, epoxyphenols and epoxyethers, with a three-membered ring, and their halogenated, sulphonated, nitrated or nitrosated derivatives (excl. oxirane ethylene oxide, methyloxirane propylene oxide, 1-Chloro-2,3-epoxypropane epichlorohydr','Epóxidos, epoxialcoholes, epoxifenoles y epoxiéteres, con tres átomos en el ciclo, y sus derivados halogenados, sulfonados, nitrados o nitrosados (exc. oxirano "óxido de etileno", metiloxirano "óxido de propileno" y 1-cloro-2,3-epoxipropano "epiclorhidrin',29,2910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291100,'Acetais, semi-acetais, mesmo contendo outras funções oxigenadas, e seus derivados halogenados, sulfonados, nitrados ou nitrosados','Acetals and hemiacetals, whether or not with other oxygen function, and their halogenated, sulphonated, nitrated or nitrosated derivatives','Acetales y semiacetales, incl. con otras funciones oxigenadas, y sus derivados halogenados, sulfonados, nitrados o nitrosados',29,2911);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291211,'Metanal (formaldeído)','Methanal formaldehyde','Metanal "formaldehído"',29,2912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291212,'Etanal (acetaldeído)','Ethanal acetaldehyde','Etanal "acetaldehído"',29,2912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291213,'butanal (butiraldeído, isômero normal)','butanal (butyraldehyde, normal isomer)','butanal (butiraldehído,  isómero normal)',29,2912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291219,'Outros aldeídos acíclicos não contendo outras funções oxigenadas','Acyclic aldehydes, without other oxygen function (excl. methanal [formaldehyde] and ethanal [acetaldehyde])','Aldehídos acíclicos sin otras funciones oxigenadas (exc. metanal "formaldehído", etanal "acetaldehído" y butanal "butiraldehído, isómero normal")',29,2912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291221,'Benzaldeído (aldeído benzóico)','Benzaldehyde','Benzaldehído "aldehído benzoico"',29,2912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291229,'Outros aldeídos cíclicos não contendo outras funções oxigenadas','Cyclic aldehydes, without other oxygen function (excl. benzaldehyde)','Aldehídos cíclicos sin otras funciones oxigenadas (exc. benzaldehído "aldehído benzoico")',29,2912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291230,'Aldeídos-álcoois','Aldehyde-alcohols','Aldehídos-alcoholes',29,2912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291241,'Vanilina (aldeído metilprotocatéquico)','Vanillin 4-hydroxy-3-methoxybenzaldehyde','Vainillina "aldehído metilprotocatéquico"',29,2912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291242,'Etilvanilina (aldeído etilprotocatéquico)','Ethylvanillin 3-ethoxy-4-hydroxybenzaldehyde','Etilvainillina "aldehído etilprotocatéquico"',29,2912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291249,'Outros aldeídos-éteres, aldeídos-fenóis e aldeídos contendo funções oxigenadas','Aldehyde-ethers, aldehyde-phenols and aldehydes with other oxygen function (excl. ethylvanillin 3-ethoxy-4-hydroxybenzaldehyde and vanillin 4-hydroxy-3-methoxybenzaldehyde)','Aldehídos-éteres, aldehídos-fenoles y aldehídos con otras funciones oxigenadas (exc. vainillina "aldehído metilprotocatéquico" y etilvainillina "aldehído etilprotocatéquico")',29,2912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291250,'Polímeros cíclicos dos aldeídos','Cyclic polymers of aldehydes','Polímeros cíclicos de los aldehídos',29,2912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291260,'Paraformaldeído','Paraformaldehyde','Paraformaldehído',29,2912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291300,'Derivados halogenados, sulfonados, nitrados ou nitrosados dos produtos da posição 2912','Halogenated, sulphonated, nitrated or nitrosated derivatives of cyclic polymers of aldehydes or paraformaldehyde','Derivados halogenados, sulfonados, nitrados o nitrosados de los aldehídos, de los polímeros cíclicos de los aldehídos o del formaldehído',29,2913);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291411,'Acetona não contendo outras funções oxigenadas','Acetone','Acetona',29,2914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291412,'Butanona (metiletilcetona)','Butanone methyl ethyl ketone','Butanona "metiletilcetona"',29,2914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291413,'4-Metilpentan-2-ona (metilisobutilcetona)','4-Methylpentan-2-one methyl isobutyl ketone','4-Metilpentan-2-ona "metilisobutilcetona"',29,2914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291419,'Outras cetonas acíclicas não contendo outras funções oxigenadas','Acyclic ketones, without other oxygen function (excl. acetone, butanone methyl ethyl ketone and 4-Methylpentan-2-one Methyl isobutyl ketone)','Cetonas acíclicas sin otras funciones oxigenadas (exc. acetona, butanona "metiletilcetona" y 4-metilpentan-2-ona "metilisobutilcetona")',29,2914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291421,'Cânfora','Camphor','Alcanfor',29,2914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291422,'Cicloexanona e metilcicloexanonas','Cyclohexanone and methylcyclohexanones','Ciclohexanona y metilciclohexanonas',29,2914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291423,'Iononas e metiliononas','Ionones and methylionones','Iononas y metiliononas',29,2914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291429,'Outras cetonas ciclânicas, ciclênicas e cicloterpênicas não contendo outras funções oxigenadas','Cyclanic, cyclenic or cycloterpenic ketones, without other oxygen function (excl. camphor, cyclohexanone, methylcyclohexanones, ionones and methylionones)','Cetonas ciclánicas, ciclénicas o cicloterpénicas, sin otras funciones oxigenadas (exc. alcanfor, ciclohexanona, metilciclohexanonas, iononas y metiliononas)',29,2914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291431,'Fenilacetona (fenilpropan-2-ona)','Phenylacetone phenylpropan-2-one','Fenilacetona "fenilpropan-2-ona"',29,2914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291439,'Outras cetonas aromáticas não contendo outras funções oxigenadas','Ketones, aromatic, without other oxygen function (excl. phenylacetone [phenylpropan-2-one])','Cetonas aromáticas sin otras funciones oxigenadas (exc. fenilacetona "fenilpropan-2-ona")',29,2914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291440,'Cetonas-álcoois e cetonas-aldeídos','Ketone-alcohols and ketone-aldehydes','Cetonas-alcoholes y cetonas-aldehídos',29,2914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291450,'Cetonas-fenóis e cetonas contendo outras funções oxigenadas','Ketone-phenols and ketones with other oxygen function','Cetonas-fenoles y cetonas con otras funciones oxigenadas',29,2914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291461,'Antraquinona','Anthraquinone','Antraquinona',29,2914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291469,'Outras quinonas','Quinones (excl. anthraquinone)','Quinonas (exc. antraquinona)',29,2914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291470,'Derivados halogenados, sulfonados, nitrados ou nitrosados das cetonas ou quinonas','Halogenated, sulphonated, nitrated or nitrosated derivatives of ketones or quinones (excl. inorganic or organic compounds of mercury)','Derivados halogenados, sulfonados, nitrados o nitrosados, de las cetonas o de las quinonas',29,2914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291511,'Ácido fórmico','Formic acid','Ácido fórmico',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291512,'Sais do ácido fórmico','Salts of formic acid','Sales del ácido fórmico',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291513,'Ésteres do ácido fórmico','Esters of formic acid','Ésteres del ácido fórmico',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291521,'Ácido acético','Acetic acid','Ácido acético',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291522,'Acetato de sódio','sodium acetate','acetato de sodio',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291523,'acetato de cobalto','cobalt acetates','acetato de cobalto',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291524,'Anidrido acético','Acetic anhydride','Anhídrido acético',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291529,'Outros sais do ácido acético','Salts of acetic acid (excl. inorganic or organic compounds of mercury)','Sales del ácido acético (exc. acetato de sodio y acetatos de cobalto)',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291531,'Acetato de etila','Ethyl acetate','Acetato de etilo',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291532,'Acetato de vinila','Vinyl acetate','Acetato de vinilo',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291533,'Acetato de n-butila','n-Butyl acetate','Acetato de n-butilo',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291534,'acetato de isobutila','isobutyl acetate','acetato de isobutilo',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291535,'acetato de 2-etoxietila','2-ethoxyethyl acetate','acetato de 2-etoxietilo',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291536,'Acetato de dinoseb','Dinoseb acetate ISO',' Acetato de Dinoseb (ISO)',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291539,'Outros ésteres do ácido acético','Esters of acetic acid (excl. ethyl, vinyl, n-butyl and dinoseb [ISO] acetates)','Ésteres del ácido acético (exc. acetato de etilo, acetato de vinilo, acetato de n-butilo, acetato de isobutilo y acetato de 2-etoxietilo)',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291540,'Ácidos mono-, di- ou tricloroacéticos, seus sais e ésteres','Mono- di- or trichloroacetic acids, their salts and esters','Ácidos mono-, di- o tricloroacéticos, sus sales y sus ésteres',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291550,'Ácido propiónico, seus sais e ésteres','Propionic acid, its salts and esters','Ácido propiónico, sus sales y sus ésteres',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291560,'Ácidos butíricos, ácidos valéricos, seus sais e ésteres','Butanoic acids, pentanoic acids, their salts and esters','Ácidos butanoicos, ácidos pentanoicos, sus sales y sus ésteres',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291570,'Ácidos palmítico, ácido esteárico, seus sais e ésteres','Palmitic acid, stearic acid, their salts and esters','Ácido palmítico, ácido esteárico, sus sales y sus ésteres',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291590,'Outros ácidos monocarboxílicos acíclicos saturados, seus anidridos, peróxidos e perácidos e seus derivados','Saturated acyclic monocarboxylic acids, their anhydrides, halides, peroxides and peroxyacids; their halogenated, sulphonated, nitrated or nitrosated derivatives (excl. formic acid and acetic acid, mono-, di- or trichloroacetic acids, proprionic acid, buta','Ácidos monocarboxílicos acíclicos saturados y sus anhídridos, halogenuros, peróxidos y peroxiácidos; sus derivados halogenados, sulfonados, nitrados o nitrosados (exc. ácido fórmico, ácido acético, ácidos mono-, di- o tricloroacéticos, ácido propiónico, á',29,2915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291611,'Ácido acrílico e seus sais','Acrylic acid and its salts','Ácido acrílico y sus sales',29,2916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291612,'Ésteres do ácido acrílico','Esters of acrylic acid','Ésteres del ácido acrílico',29,2916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291613,'Ácido metacrílico e seus sais','Methacrylic acid and its salts','Ácido metacrílico y sus sales',29,2916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291614,'Ésteres do ácido metacrílico','Esters of methacrylic acid','Ésteres del ácido metacrílico',29,2916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291615,'Ácidos oléico, linoléico e ácido linonênico, seus sais e ésteres','Oleic, linoleic or linolenic acids, their salts and esters (excl. inorganic or organic compounds of mercury)','Ácidos oléico, linoléico o linolénico, sus sales y sus ésteres',29,2916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291616,'binapacril (isso)','binapacril (isso)','binapacril (isso)',29,2916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291619,'Outros ácidos monocarboxílicos acíclicos não saturados; seus anidridos, halogenetos, peróxidos e perácidos, e seus derivados','Unsaturated acyclic monocarboxylic acids, their anhydrides, halides, peroxides, peroxyacids and halogenated, sulphonated, nitrated or nitrosated derivatives (excl. acrylic acid and its salts and esters, methacrylic acid and its salts and esters, and oleic','Ácidos monocarboxílicos acíclicos no saturados, sus anhídridos, halogenuros, peróxidos, peroxiácidos y sus derivados halogenados, sulfonados, nitrados o nitrosados (exc. ácido acrílico, sus sales y sus ésteres; ácido metacrílico, sus sales y sus ésteres; ',29,2916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291620,'Ácidos monocarboxílicos ciclânicos, ciclênicos ou cicloterpêncicos, seus anidridos, peróxidos, perácidos e seus derivados','Cyclanic, cyclenic or cycloterpenic monocarboxylic acids, their anhydrides, halides, peroxides, peroxyacids and their halogenated, sulphonated, nitrated or nitrosated derivatives (excl. inorganic or organic compounds of mercury)','Ácidos monocarboxílicos ciclánicos, ciclénicos o cicloterpénicos, sus anhídridos, halogenuros, peróxidos, peroxiácidos y sus derivados halogenados, sulfonados, nitrados o nitrosados',29,2916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291631,'Ácido benzóico, seus sais e ésteres','Benzoic acid, its salts and esters (excl. inorganic or organic compounds of mercury)','Ácido benzoico, sus sales y sus ésteres',29,2916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291632,'Peróxido de benzoíla e cloreto de benzoíla','Benzoyl peroxide and benzoyl chloride','Peróxido de benzoilo y cloruro de benzoilo',29,2916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291634,'Ácido fenilacético e seus sais','Phenylacetic acid and its salts','Ácido fenilacético y sus sales',29,2916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291635,'Ésteres do ácido fenilacético','Esters of phenylacetic acid','Ésteres del ácido fenilacético',29,2916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291636,'Binapacril','Binapacryl ISO',' Binapacril (ISO)',29,2916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291639,'Outros ácidos monocarboxílicos aromáticos, seus anidridos, halogenetos, peróxidos, perácidos e derivados','Aromatic monocarboxylic acids, their anhydrides, halides, peroxides, peroxyacids and their halogenated, sulphonated, nitrated or nitrosated derivatives (excl. benzoic acid, its salts and esters, benzoyl peroxide, benzoyl chloride, binapacryl [ISO], phenyl','Ácidos monocarboxílicos aromáticos, sus anhídridos, halogenuros, peróxidos, peroxiácidos y sus derivados halogenados, sulfonados, nitrados o nitrosados (exc. ácido benzoico, sus sales y sus ésteres; peróxido de benzoilo y cloruro de benzoilo; ácido fenila',29,2916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291711,'Ácido oxálico, seus sais e ésteres','Oxalic acid, its salts and esters (excl. inorganic or organic compounds of mercury)','Ácido oxálico, sus sales y sus ésteres',29,2917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291712,'Ácido adípico, seus sais e ésteres','Adipic acid, its salts and esters','Ácido adípico, sus sales y sus ésteres',29,2917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291713,'Ácido azeláico, ácido sebácico, seus sais e ésteres','Azelaic acid, sebacic acid, their salts and esters','Ácido azelaico, ácido sebácico, sus sales y sus ésteres',29,2917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291714,'Anidrido maléico','Maleic anhydride','Anhídrido maleico',29,2917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291719,'Outros ácidos policarboxílicos acíclicos, seus anidridos, halogenetos, peróxidos, perácidos e seus derivados','Acyclic polycarboxylic acids, their anhydrides, halides, peroxides, peroxyacids and their halogenated, sulphonated, nitrated or nitrosated derivatives (excl. oxalic acid, its salts and esters, adipic acid, its salts and esters, azelaic acid, sebacic acid,','Ácidos policarboxílicos acíclicos, sus anhídridos, halogenuros, peróxidos, peroxiácidos y sus derivados halogenados, sulfonados, nitrados o nitrosados (exc. ácido oxálico, sus sales y sus ésteres; ácido adípico, sus sales y sus ésteres; ácido azelaico, ác',29,2917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291720,'Ácidos policarboxílicos ciclânicos, ciclênicos ou cicloterpênicos, seus anidridos, halogenetos, peróxidos, perácidos e derivados','Cyclanic, cyclenic or cycloterpenic polycarboxylic acids, their anhydrides, halides, peroxides, peroxyacids and their derivatives','Ácidos policarboxílicos ciclánicos, ciclénicos o cicloterpénicos, sus anhídridos, halogenuros, peróxidos, peroxiácidos y sus derivados',29,2917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291731,'ortoftalatos de dibutila','dibutyl orthophthalates','ortoftalatos de dibutilo',29,2917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291732,'Ortoftalatos de dioctila','Dioctyl orthophthalates','Ortoftalatos de dioctilo',29,2917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291733,'Ortoftalatos de dinonila ou de didecila','Dinonyl or didecyl orthophthalates','Ortoftalatos de dinonilo o didecilo',29,2917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291734,'Outros ésteres do ácido ortoftálico','Esters of orthophthalic acid (excl. dioctyl, dinonyl or didecyl orthophthalates)','Ésteres del ácido ortoftálico (exc. ortoftalatos de dibutilo, de dioctilo, de dinonilo o de didecilo)',29,2917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291735,'Anidrido ftálico','Phthalic anhydride','Anhídrido ftálico',29,2917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291736,'Ácido tereftálico e seus sais','Terephthalic acid and its salts','Ácido tereftálico y sus sales',29,2917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291737,'Tereftalato de dimetila','Dimethyl terephthalate','Tereftalato de dimetilo',29,2917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291739,'Outros ácidos policarboxílicos aromáticos, seus anidridos, halogenetos, peróxidos, perácidos e seus derivados','Aromatic polycarboxylic acids, their anhydrides, halides, peroxides, peroxyacids and their halogenated, sulphonated, nitrated or nitrosated derivatives (excl. esters of orthophthalic acid, phthalic anhydride, terephthalic acid and its salts and dimethyl t','Ácidos policarboxílicos aromáticos, sus anhídridos, halogenuros, peróxidos, peroxiácidos y sus derivados halogenados, sulfonados, nitrados o nitrosados (exc. ésteres del ácido ortoftálico, anhídrido ftálico, ácido tereftálico y sus sales, así como el tere',29,2917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291811,'Ácido láctico, seus sais e ésteres','Lactic acid, its salts and esters (excl. inorganic or organic compounds of mercury)','Ácido láctico, sus sales y sus ésteres',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291812,'Ácido tartárico','Tartaric acid','Ácido tartárico',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291813,'Sais e ésteres do ácido tartárico','Salts and esters of tartaric acid','Sales y ésteres del ácido tartárico',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291814,'Ácido cítrico','Citric acid','Ácido cítrico',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291815,'Sais e ésteres do ácido cítrico','Salts and esters of citric acid (excl. inorganic or organic compounds of mercury)','Sales y ésteres del ácido cítrico',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291816,'Ácido glucônico, seus sais e ésteres','Gluconic acid, its salts and esters','Ácido glucónico, sus sales y sus ésteres',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291817,'ácido fenilglicolico (ac.mandelico), seus sais e ésteres','phenyl glicolic acid(mandelic ac.), its salts and esters','ácido fenilglicólico (ác.mandélico), sus sales y ésteres',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291818,'Clorobenzilato','Chlorobenzilate ISO','Clorobencilato (ISO)',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291819,'Outros ácidos carboxílicos de função álcool, mas sem outra função oxigenada, seus anidridos, halogenetos, peróxidos, perácidos e seus derivados','Carboxylic acids with additional oxygen function and their anhydrides, halides, peroxides and peroxyacids; their halogenated, sulphonated, nitrated or nitrosated derivatives (excl. lactic acid, tartaric acid, citric acid, gluconic acid and their salts and','Ácidos carboxílicos con función alcohol, pero sin otra función oxigenada, sus anhídridos, halogenuros, peróxidos y peroxiácidos; sus derivados halogenados, sulfonados, nitrados o nitrosados (exc. ácido láctico, ácido tartárico, ácido cítrico y ácido glucó',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291821,'Ácido salicílico e seus sais','Salicylic acid and its salts (excl. inorganic or organic compounds of mercury)','Ácido salicílico y sus sales',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291822,'Ácido o-acetilsalicílico, seus sais e ésteres','o-Acetylsalicylic acid, its salts and esters','Ácido o-acetilsalicílico, sus sales y sus ésteres',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291823,'Outros ésteres do ácido salicílico e seus sais','Esters of salicylic acid and their salts (excl. o-acetylsalicylic acid, its salts and esters)','Ésteres del ácido salicílico y sus sales (exc. ácido o-acetilsalicílico, sus sales y sus ésteres)',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291829,'Outros ácidos carboxílicos de função fenol, mas sem outra função oxigenada, seus anidridos, halogenetos, peróxidos, perácidos e seus derivados','Carboxylic acids with phenol function but without other oxygen function, their anhydrides, halides, peroxides, peroxyacids and their halogenated, sulphonated, nitrated or nitrosated derivatives (excl. salicylic acid and o-Acetylsalicylic acid, and their s','Ácidos carboxílicos con función fenol, pero sin otra función oxigenada, sus anhídridos, halogenuros, peróxidos, peroxiácidos y sus derivados halogenados, sulfonados, nitrados o nitrosados (exc. ácido salicílico, ácido o-acetilsalicílico, sus sales y sus é',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291830,'Ácidos carboxílicos de função aldeído ou cetona, mas sem outra função oxigenada, seus anidridos, halogenetos, peróxidos, perácidos e seus derivados','Carboxylic acids with aldehyde or ketone function but without other oxygen function, their anhydrides, halides, peroxides, peroxyacids and their halogenated, sulphonated, nitrated or nitrosated derivatives','Ácidos carboxílicos con función aldehído o cetona, pero sin otra función oxigenada, sus anhídridos, halogenuros, peróxidos, peroxiácidos y sus derivados halogenados, sulfonados, nitrados o nitrosados',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291890,'Ácidos carboxílicos','Carboxylic acids','Ácidos carboxílicos',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291891,'Ácido 2,4,5-triclorofenoxiacético, seus sais e ésteres','2,4,5-T ISO 2,4,5-trichlorophenoxyacetic acid, its salts and esters',' 2,4,5T (ISO) (acido 2,4,5triclorofenoxiacético) y sus sales y sus ésteres',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291899,'Outros ácidos carboxílicos contendo funções oxigenadas suplementares e seus anidridos, halogenetos, peróxidos, perácidos e seus derivados','Carboxylic acids with additional oxygen function and their anhydrides, halides, peroxides and peroxyacids; their halogenated, sulphonated, nitrated or nitrosated derivatives (excl. only with alcohol, phenol, aldehyde or ketone function, and 2,4,5-T [ISO] ','Ácidos carboxílicos con funciones oxigenadas suplementarias y sus anhídridos, halogenuros, peróxidos, peroxiácidos; sus derivados halogenados, sulfonados, nitrados o nitrosados (exc. ácidos con solamente la función alcohol, fenol, aldehído o cetona así co',29,2918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291900,'Ésteres fosfóricos','Phosphoric esters','Ésteres fosfóricos',29,2919);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291910,'Fosfato de tris (2,3-dibromopropila)','Tris2,3-dibromopropyl phosphate','Fosfato de tris(2,3dibromopropilo)',29,2919);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (291990,'Outros ésteres fosfóricos e seus sais, incluídos os lactofosfatos; seus derivados halogenados, sulfonados, nitrados ou nitrosados','Phosphoric esters and their salts, incl. lactophosphates; their halogenated, sulphonated, nitrated or nitrosated derivatives (excl. tris2,3-dibromopropyl phosphate)','Ésteres fosfóricos y sus sales, inclusos los lactophosphates; sus derivados halogenados, sulfonados, nitrados o nitrosados ( exc. fosfato de tris[2,3-dibromopropyle])',29,2919);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292010,'Ésteres tiofosfóricos e seus sais. seus derivados halogenados, sulfonados','Thiophosphoric Esters and Their Salts; their halogenated, sulfonated derivatives','Esteres tiofosfóricos y sus sales; sus derivados halogenados, sulfonados',29,2920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292011,'Paration e Paration-metila (metil paration)','Parathion ISO and parathion-methyl ISO methyl-parathion','Paratión (ISO) y paratiónmetilo (ISO) (metil paratión)',29,2920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292019,'Ésteres tiofosfóricos (fosforotioatos) e seus sais','Thiophosphoric esters phosphorothioates and their salts','Ésteres thiophosphoricos (phosphorothioates) y sus sales;',29,2920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292090,'Outros ésteres dos ácidos inorgânicos, seus sais e derivados halogenados, sulfonados, nitrados ou nitrosados','Esters of other inorganic acids of non-metals and their salts; their halogenated, sulphonated, nitrated or nitrosated derivatives (excl. esters of hydrogen halides, and thiophosphoric esters phosphorothioates, their salts and their halogenated, sulphonate','Ésteres de ácidos inorgánicos de los no metales y sus sales; sus derivados halogenados, sulfonados, nitrados o nitrosados (exc. ésteres de halogenuros de hidrógeno y de los ácidos fosfóricos, así como los ésteres tiofosfóricos "fosforotioatos", sus sales ',29,2920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292111,'Mono-, di- ou trimetilamina e seus sais','Methylamine, dimethylamine or trimethylamine and their salts','Mono-, di- o trimetilamina y sus sales',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292112,'Dietilamina e seus sais','Diethylamine and its salts','Dietilamina y sus sales',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292119,'Outras monoaminas acíclicas, seus derivados e seus sais','Acyclic monoamines and their derivatives; salts thereof (excl. methylamine, dimethylamine, trimethylamine, and their salts)','Monoaminas acíclicas y sus derivados; sales de estos productos (exc. mono-, di- o trimetilamina, dietilamina y sus sales)',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292121,'Etilenodiamina e seus sais','Ethylenediamine and its salts','Etilendiamina y sus sales',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292122,'Hexametilenodiamina e seus sais','Hexamethylenediamine and its salts','Hexametilendiamina y sus sales',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292129,'Outras poliaminas acíclicas, seus derivados e seus sais','Acyclic polyamines and their derivatives; salts thereof (excl. ethylenediamine and hexamethylenediamine, and their salts)','Poliaminas acíclicas y sus derivados; sales de estos productos (exc. etilendiamina, hexametilendiamina y sus sales)',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292130,'Monoaminas e poliaminas ciclânicas, ciclênicas ou cicloterpênicas, seus derivados e sais','Cyclanic, cyclenic or cycloterpenic mono- or polyamines, and their derivatives; salts thereof','Monoaminas y poliaminas, ciclánicas, ciclénicas o cicloterpénicas, y sus derivados; sales de estos productos',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292141,'Anilina e seus sais','Aniline and its salts (excl. inorganic or organic compounds of mercury)','Anilina y sus sales',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292142,'Derivados da anilina e seus sais','Aniline derivatives and their salts','Derivados de la anilina y sus sales',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292143,'Toluidinas e seus derivados e sais','Toluidines and their derivatives; salts thereof','Toluidinas y sus derivados; sales de estos productos',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292144,'Difenilamina, seus derivados e seus sais','Diphenylamine and its derivatives; salts thereof','Difenilamina y sus derivados; sales de estos productos',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292145,'1-Naftilamina (alfa), 2-naftilamina (beta), seus derivados e sais','1-Naphthylamine alpha-naphthylamine, 2-naphthylamine beta-naphthylamine and their derivatives; salts thereof','1-Naftilamina "alfa-naftilamina", 2-naftilamina "beta-naftilamina" y sus derivados; sales de estos productos',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292146,'Anfetamina, benzofetamina, dexanfetamina, etilanfetamina, fencanfamina, fentermina, lefetamina, levanfetamina e mefenorex; sais destes produtos','Amfetamine INN, benzfetamine INN, dexamfetamine INN, etilamfetamine INN, fencamfamine INN, lefetamine INN, levamfetamine INN, mefenorex INN and phentermine INN, and salts thereof','Anfetamina "DCI", benzfetamina "DCI", dexanfetamina "DCI", etilanfetamina "DCI", fencanfamina "DCI", fentermina "DCI", lefetamina "DCI", levanfetamina "DCI" y mefenorex "DCI"; sales de estos productos',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292149,'Outras monoaminas aromáticas, seus derivados e seus sais','Aromatic monoamines and derivatives; salts thereof (excl. aniline, toluidines, diphenylamine, 1-naphthylamine alpha-naphthylamine, 2-naphthylamine beta-naphthylamine and their derivatives, and salts thereof, and amfetamine INN, benzfetamine INN, dexamfeta','Monoaminas aromáticas y sus derivados; sales de estos productos (exc. anilina, toluidinas, difenilamina, 1-naftilamina "alfa-naftilamina" y 2-naftilamina "beta-naftilamina", derivados y sales de estos productos; anfetamina "DCI", benzfetamina "DCI", dexan',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292151,'o-, m-, p-Fenilenodiamina, diamanotoluenos e seus derivados e sais','o-Phenylenediamine, m-phenylenediamine, p-phenylenediamine or diaminotoluenes and their derivatives; salts thereof','o-, m- y p-Fenilendiamina, diaminotoluenos y sus derivados; sales de estos productos',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292159,'Outras poliaminas aromáticas, seus derivados e seus sais','Aromatic polyamines and their derivatives; salts thereof (excl. o-phenylenediamine, m-phenylenediamine, p-phenylenediamine or diaminotoluenes and their derivatives, and salts thereof)','Poliaminas aromáticas y sus derivados; sales de estos productos (exc. o-, m- y p-fenilendiamina, diaminotoluenos y sus derivados; sales de estos productos)',29,2921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292211,'Monoetanolamina e seus sais','Monoethanolamine and its salts','Monoetanolamina y sus sales',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292212,'Dietanolamina e seus sais','Diethanolamine and its salts','Dietanolamina y sus sales',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292213,'Trietanolamina e seus sais','Triethanolamine and its salts','Trietanolamina y sus sales',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292214,'Dextropropoxifeno e seus sais','Dextropropoxyphene INN and its salts','Dextropropoxifeno "DCI" y sus sales',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292219,'Outros aminoálcoois, seus éteres, ésteres e sais','Amino-alcohols, their ethers and esters; salts thereof (other than those containing > one kind of oxygen function and excl. monoethanolamine, diethanolamine, triethanolamine, dextropropoxyphene INN, and salts thereof)','Amino-alcoholes, sus éteres y sus ésteres; sales de estos productos (exc. con otras funciones oxigenadas, así como monoetanolamina, dietanolamina, trietanolamina, dextropropoxifeno "DCI" y sus sales)',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292221,'Ácido aminonaftolsulfônicos e seus sais','Aminohydroxynaphthalenesulphonic acids and their salts','Ácidos aminonaftolsulfónicos y sus sales',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292222,'Anisidinas, dianisidinas, fenetidinas, seus sais','Anisidines, Dianisidines, Phenetidines, their salts','Anisidines, dianisidinas, fenetidinas, sus sales',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292229,'Outros aminonaftóis, aminofenóis, seus éteres, ésteres e sais','Amino-naphthols and other amino-phenols, their ethers and esters (excl. those containing > one kind of oxygen function; aminohydroxynaphthalenesulphonic acids and their salts)','Amino-naftoles y demás amino-fenoles, sus éteres y sus ésteres; sales de estos productos (exc. los que contengan funciones oxigenadas diferentes; ácidos aminonaftolsulfónicos, anisidinas, dianisidinas, fenetidinas y sus sales)',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292230,'Amino-aldeídos, cetonas, Amino-amino-quinonas, sais destes','Amino-aldehydes, Amino-ketones, Amino-quinones, salts thereof','Amino-aldehidos, amino-cetonas y amino-quinonas, sales de los mismos',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292231,'Anfepramona, metadona e normetadona; sais destes produtos ','Amfepramone INN, methadone INN and normethadone INN, and salts thereof','Anfepramona "DCI", metadona "DCI" y normetadona "DCI"; sales de estos productos',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292239,'Outros aminoaldeídos, aminocetonas e aminoquinonas, exceto os de funções oxigenadas diferentes; sais destes produtos','Amino-aldehydes, amino-ketones and amino-quinones; salts thereof (excl. those containing > one kind of oxygen function, and amfepramone INN, methadone INN and normethadone INN, and salts thereof)','Amino-aldehídos, amino-cetonas y amino-quinonas; sales de estos productos (exc. los que contengan funciones oxigenadas diferentes, así como anfepramona "DCI", metadona "DCI", normetadona "DCI" y sus sales)',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292241,'Lisina e seus ésteres e sais','Lysine and its esters; salts thereof','Lisina y sus ésteres; sales de estos productos',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292242,'Ácido glutâmico e seus sais','Glutamic acid and its salts','Ácido glutámico y sus sales',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292243,'Ácido antranílico e seus sais','Anthranilic acid and its salts','Ácido antranílico y sus sales',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292244,'Tilidina e seus sais','Tilidine INN and its salts','Tilidina "DCI" y sus sales',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292249,'Outros aminoácidos, exceto que contenham mais de um tipo de função oxigenada, seus ésteres e sais','Amino-acids and their esters; salts thereof (excl. those with > one kind of oxygen function, lysine and its esters, and salts thereof, and glutamic acid, anthranilic acid, tilidine INN, and salts thereof)','Aminoácidos y sus ésteres; sales de estos productos (exc. los que contengan funciones oxigenadas diferentes; lisina, sus ésteres y sales de estos productos; ácido glutámico y sus sales; ácido antranílico y sus sales; tilidina "DCI" y sus sales)',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292250,'Aminoálcooisfenóis, aminoácidosfenóis e outros compostos aminados de funções oxigenadas','Amino-alcohol-phenols, amino-acid-phenols and other amino-compounds with oxygen function (excl. amino-alcohols, amino-naphthols and other amino-phenols, their ethers and esters and salts thereof, amino-aldehydes, amino-ketones and amino-quinones, and salt','Amino-alcoholes-fenoles, aminoácidos-fenoles y demás compuestos aminados con funciones oxigenadas (exc. amino-alcoholes, amino- naftoles y demás amino-fenoles, sus éteres, sus ésteres y sales de estos productos; amino-aldehídos, amino-cetonas, amino-quino',29,2922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292310,'Colina e seus sais','Choline and its salts','Colina y sus sales',29,2923);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292320,'Lecitinas e outros fosfoaminolipídios','Lecithins and other phosphoaminolipids, whether or not chemically defined','Lecitinas y demás fosfoaminolípidos, incl. de constitución química no definida',29,2923);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292390,'Outros sais e hidróxidos de amônio quaternários','Quaternary ammonium salts and hydroxides (excl. choline and its salts)','Sales e hidróxidos de amonio cuaternario (exc. colina y sus sales)',29,2923);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292410,'Amidas acíclicos e seus derivados, seus sais','Acyclic amides and their derivatives, salts thereof','Amidas acíclicas y sus derivados, sales de los mismos',29,2924);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292411,'Meprobamato','Meprobamate INN','Meprobamato "DCI"',29,2924);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292412,'Fluoroacetamida, fosfamidona e monocrotofós','Fluoroacetamide ISO, monocrotophos ISO and phosphamidon ISO','Fluoroacetamida (ISO), fosfamidón (ISO) y monocrotofós (ISO)',29,2924);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292419,'Outras amidas acíclicas (incluídos os carbomatos) e seus derivados; sais destes produtos','Acyclic amides, incl. acyclic carbamates, and their derivatives, and salts thereof (excl. meprobamate [INN], luoroacetamide [ISO], monocrotophos [ISO] and phosphamidon [ISO])','Amidas acíclicas, incl. los carbamatos, y sus derivados; sales de estos productos (exc. meprobamato "DCI")',29,2924);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292421,'Ureínas, seus derivados e sais','Ureines and their derivatives; salts thereof','Ureínas y sus derivados; sales de estos productos',29,2924);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292422,'acido 2-acetamidobenzoico','2-acetamidobenzoic acid','ácido 2-acetamidobenzoico',29,2924);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292423,'Ácido 2-acetamidobenzoico (acido N-acetilantranílico) e seus sais','2-Acetamidobenzoic acid N-acetylanthranilic acid and its salts','Ácido 2-acetamidobenzoico "ácido N-acetilantranílico" y sus sales',29,2924);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292424,'Etinamato','Ethinamate INN','Etinamato "DCI"',29,2924);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292429,'Outras amidas cíclicas, seus derivados e sais','Cyclic amides, incl. cyclic carbamates, and their derivatives; salts thereof (excl. ureines and their derivatives, salts thereof, 2-acetamidobenzoic acid N-acetylanthranilic acid and its salts and ethinamate INN)','Amidas cíclicas, incl. los carbamatos, y sus derivados; sales de estos productos (exc. ureínas, sus derivados y sales de estos productos; ácido 2-acetamidobenzoico "ácido N-acetilantranílico" y sus sales; etinamato "DCI")',29,2924);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292511,'Sacarina e seus sais','Saccharin and its salts','Sacarina y sus sales',29,2925);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292512,'Glutetimida','Glutethimide INN','Glutetimida "DCI"',29,2925);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292519,'Outros imidas, seus derivados e sais','Imides and their derivatives; salts thereof (excl. saccharin and its salts, glutethimide [INN] and inorganic or organic compounds of mercury)','Imidas y sus derivados; sales de estos productos (exc. sacarina y sus sales; glutetimida "DCI")',29,2925);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292520,'Iminas e seus derivados; sais destes produtos','Imines and their derivatives, salts thereof','Iminas y sus derivados, sales de los mismos',29,2925);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292521,'Clordimeforme','Chlordimeform ISO','Clordimeformo (ISO)',29,2925);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292529,'Outros iminas, seus derivados e sais','Imines and their derivatives; salts thereof (excl. chlordimeform [ISO])','Iminas y sus derivados; sales de estos productos (exc. clordiméforme [ISO])',29,2925);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292610,'Acrilonitrila','Acrylonitrile','Acrilonitrilo',29,2926);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292620,'1-Cianoguanidina (diciandiamida)','1-Cyanoguanidine dicyandiamide','1-Cianoguanidina "diciandiamida"',29,2926);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292630,'Fenproporex e seus sais; intermediário da metadona (4-ciano-2-dimetilamino-4,4-difenilbutano)','Fenproporex INN and its salts','Fenproporex "DCI" y sus sales; intermediario de la metadona "DCI" "4-ciano-2-dimetilamino-4,4-difenilbutano"',29,2926);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292690,'Outros compostos de função nitrila','Nitrile-function compounds (excl. acrylonitrile, 1-cyanoguanidine dicyandiamide, fenproporex INN and its salts, and methadone INN-intermediate 4-cyano-2-dimethylamino-4,4-diphenylbutane)','Compuestos con función nitrilo (exc. acrilonitrilo; 1-cianoguanidina "diciandiamida"; fenproporex "DCI" y sus sales; intermediario de la metadona "DCI" "4-ciano-2-dimetilamino-4,4-difenilbutano")',29,2926);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292700,'Compostos diazóicos, azóicos e azóxicos','Diazo-, azo- or azoxy-compounds','Compuestos diazoicos, azoicos o azoxi',29,2927);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292800,'Derivados orgânicos da hidrazina e hidroxilamina','Organic derivatives of hydrazine or of hydroxylamine','Derivados orgánicos de la hidrazina o de la hidroxilamina',29,2928);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292910,'Isocianatos','Isocyanates','Isocianatos',29,2929);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (292990,'Outros compostos de funções nitrogenadas','Compounds with nitrogen function (excl. amine-function compounds; oxygen-function amino-compounds; quaternary ammonium salts and hydroxides; lecithin and other phosphoaminolipids; carboxyamide-function compounds; amide-function compounds of carbonic acid;','Compuestos con funciones nitrogenadas (exc. compuestos con función amina; compuestos aminados con funciones oxigenadas; sales e hidróxidos de amonio cuaternario; lecitinas y otros fosfoaminolípidos; compuestos con función carboxiamida, con función amida d',29,2929);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293010,'ditiocarbonatos (xantatos e xantogenatos)','dithiocarbonates (xanthates)','ditiocarbonatos (xantatos y xantogenatos)',29,2930);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293020,'Tiocarbamatos e ditiocarbamatos','Thiocarbamates and dithiocarbamates (excl. inorganic or organic compounds of mercury)','Tiocarbamatos y ditiocarbamatos',29,2930);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293030,'Mono-, di- ou tetrassulfetos de tiourama','Thiuram mono-, di- or tetrasulphides','Mono-, di- o tetrasulfuros de tiourama',29,2930);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293040,'Metionina','Methionine','Metionina',29,2930);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293050,'Captafol e metamidofós','Captafol ISO and methamidophos ISO','Captafol (ISO) y metamidofos (ISO)',29,2930);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293090,'Outros tiocompostos orgânicos','Organo-sulphur compounds (excl. thiocarbamates and dithiocarbamates, thiuram mono-, di- or tetrasulphides, methionine, captafol [ISO] and methamidophos [ISO])','Tiocompuestos orgánicos (exc. ditiocarbonatos "xantatos y xantogenatos", tiocarbamatos y ditiocarbamatos, mono-, di- o tetrasulfuros de tiourama y metionina)',29,2930);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293100,'Outros compostos organo-inorgânicos','Separate chemically defined organo-inorganic compounds, n.e.s. (excl. inorganic or organic compounds of mercury)','Compuestos órgano-inorgánicos de composición química definida, n.c.o.p.',29,2931);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293110,'chumbo tetrametila e chumbo tetraetileno','chumbo tetrametila e chumbo tetraetileno','chumbo tetrametila e chumbo tetraetileno',29,2931);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293120,'compostos de tributilestanho','compostos de tributilestanho','compostos de tributilestanho',29,2931);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293190,'Outros compostos organo-inorgânicos','Other organo-inorganic compounds','Demás compuestos órgano-inorgánicos',29,2931);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293211,'Tetraidrofurano','Tetrahydrofuran','Tetrahidrofurano',29,2932);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293212,'2-Furaldeído (furfural)','2-Furaldehyde furfuraldehyde','2-Furaldehído "furfural"',29,2932);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293213,'Álcool furfurílico e álcool tetraidrofurfurílico','Furfuryl alcohol and tetrahydrofurfuryl alcohol','Alcohol furfurílico y alcohol tetrahidrofurfurílico',29,2932);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293219,'Outros compostos heterocíclicos com 1 (hum) ciclo furano não condensado','Heterocyclic compounds with oxygen hetero-atom[s] only, containing an unfused furan ring, whether or not hydrogenated, in the structure (excl. tetrahydrofuran, 2-furaldehyde furfuraldehyde, furfuryl alcohol and tetrahydrofurfuryl alcohol)','Compuestos heterocíclicos con heteroátomo/s de oxígeno exclusivamente, cuya estructura contenga ciclo furano, incl. hidrogenado, sin condensar (exc. tetrahidrofurano, 2-furaldehído "furfural", alcohol furfurílico y alcohol tetrahidrofurfurílico)',29,2932);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293220,'lactonas','lactonas','lactonas',29,2932);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293221,'Cumarina, metilcumarinas e etilcumarinas','Coumarin, methylcoumarins and ethylcoumarins','Cumarina, metilcumarinas y etilcumarinas',29,2932);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293229,'Outras lactonas','Lactones (excl. coumarin, methylcoumarins, ethylcoumarins, and inorganic or organic compounds of mercury)','Lactonas (exc. cumarina, metilcumarinas y etilcumarinas)',29,2932);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293291,'Isossafrol','Isosafrole','Isosafrol',29,2932);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293292,'1-(1,3-Benzodioxol-5-il) propan-2-ona','1-1,3-Benzodioxol-5-ylpropan-2-one','1-"1,3-Benzodioxol-5-il"propan-2-ona',29,2932);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293293,'Piperonal','Piperonal','Piperonal',29,2932);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293294,'Safrol','Safrole','Safrol',29,2932);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293295,'Tetraidrocanabinóis (todos os isômeros)','Tetrahydrocannabinols all isomers','Tetrahidrocannabinoles "todos los isómeros"',29,2932);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293299,'Outros compostos heterocíclicos exclusivamente de heteroátomos de oxigênio','Heterocyclic compounds with oxygen hetero-atom[s] only (excl. compounds containing unfused furan ring, whether or not hydrogenated, in the structure, and lactones, isosafrole, 1-[1,3-benzodioxol-5-yl]propan-2-one, piperonal, safrole, tetrahydrocannabinols','Compuestos heterocíclicos con heteroátomo/s de oxígeno exclusivamente (exc. compuestos con un ciclo furano, incl. hidrogenado, sin condensar; lactonas, isosafrol, 1-"1,3-benzodioxol-5-il"propan-2-ona, piperonal, safrol y tetrahidrocannabinoles "todos los ',29,2932);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293311,'Fenazona (antipirina) e seus derivados','Phenazone antipyrin and its derivatives','Fenazona "antipirina" y sus derivados',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293319,'Outros compostos heterocíclicos com 1 (hum) ciclo pirazol não condensado','Heterocyclic compounds with nitrogen hetero-atom[s] only, containing an unfused pyrazole ring, whether or not hydrogenated, in the structure (excl. phenazone antipyrin and its derivatives)','Compuestos heterocíclicos con heteroátomo/s de nitrógeno exclusivamente, cuya estructura contenga ciclo pirazol, incl. hidrogenados, sin condensar (exc. fenazona "antipirina" y sus derivados)',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293321,'Hidantoína e seus derivados','Hydantoin and its derivatives','Hidantoína y sus derivados',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293329,'Outros compostos heterocíclicos com 1 (hum) ciclo imidazol não condensado','Heterocyclic compounds with nitrogen hetero-atom[s] only, containing an unfused imidazole ring, whether or not hydrogenated, in the structure (excl. hydantoin and its derivatives)','Compuestos heterocíclicos con heteroátomo/s de nitrógeno exclusivamente, cuya estructura contenga ciclo imidazol, incl. hidrogenados, sin condensar (exc. hidantoína y sus derivados)',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293331,'Piridina e seus sais','Pyridine and its salts','Piridina y sus sales',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293332,'Piperidina e seus sais','Piperidine and its salts','Piperidina y sus sales',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293333,'Alfentanil, anileridina, bezitramida, bromazepam, cetobermidona, difenoxilato, difenoxina, dipipanona, fenciclidina, fenoperidina, fentanil, metilfenidato, pentazocina, petidina, intermediário A da petidina, pipradrol, pritramida, propiram e trimeperidina','Alfentanil INN, anileridine INN, bezitramide INN, bromazepam INN, difenoxin INN, diphenoxylate INN, dipipanone INN, fentanyl INN, ketobemidone INN, methylphenidate INN, pentazocine INN, pethidine INN, pethidine INN intermediate A, phencyclidine INN PCP, p','Alfentanil "DCI", anileridina "DCI"; becitramida "DCI", bromazepam "DCI", cetobemidona "DCI", difenoxina "DCI", difenoxilato "DCI", dipipanona "DCI", fentanil "DCI", metilfenidato "DCI", pentazocina "DCI", petidina "DCI", intermediario A de la petidina "D',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293339,'Outros compostos heterocíclicos 1 (hum) ciclo piridina não condensado','Heterocyclic compounds with nitrogen hetero-atom[s] only, containing an unfused pyridine ring, whether or not hydrogenated, in the structure (excl. pyridine, piperidine, alfentanil INN, anileridine INN, bezitramide INN, bromazepam INN, difenoxin INN, diph','Compuestos heterocíclicos con heteroátomo/s de nitrógeno exclusivamente, cuya estructura contenga ciclo piridina, incl. hidrogenados, sin condensar (exc. piridina, piperidina, alfentanil "DCI", anileridina "DCI"; becitramida "DCI", bromazepam "DCI", cetob',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293340,'Compostos de nitrogênio contendo um sistema de anel quinolina ou isoquinolina','Nitrogen compounds containing a quinoline or isoquinoline ring system','Ccompuestos de nitrógeno que contienen un sistema de anillo de quinolina o isoquinolina',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293341,'Levorfanol e seus sais','Levorphanol INN and its salts','Levorfanol "DCI" y sus sales',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293349,'Outros compostos heterocíclicos, contendo ciclos de quinoleína ou de isoquinoleína sem outras condensações','Heterocyclic compounds with nitrogen hetero-atom[s] only, containing in the structure a quinoline or isoquinoline ring-system, whether or not hydrogenated, but not further fused (excl. levorphanol INN and its salts, and inorganic or organic compounds of m','Compuestos heterocíclicos con heteroátomo/s de nitrógeno exclusivamente, cuya estructura contenga ciclos de quinoleína o isoquinoleína, incl. hidrogenados, sin otras condensaciones (exc. levorfanol "DCI" y sus sales)',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293351,'Malonilureia (ácido barbitúrico) e seus derivados; seus sais','Malonylurea (barbituric acid) and its derivatives, salts thereof','Ácido barbitúrico y sus derivados, sales de los mismos',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293352,'Maloniluréia (ácido barbitúrico) e seus sais','Malonylurea barbituric acid and its salts','Malonilurea "ácido barbitúrico" y sus sales',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293353,'Alobarbital, amobarbital, barbital, butalbital, butobarbital, ciclobarbital, fenobarbital, metilfenobarbital, pentobarbital, secbutabarbital, secobarbital, e venilbital; sais destes produtos','Allobarbital INN, amobarbital INN, barbital INN, butalbital INN, butobarbital INN, cyclobarbital INN, methylphenobarbital INN, pentobarbital INN, phenobarbital INN, secbutabarbital INN, secobarbital INN and vinylbital INN, and salts thereof','Alobarbital "DCI", amobarbital "DCI", barbital "DCI", butalbital "DCI", butobarbital, ciclobarbital "DCI", metilfenobarbital "DCI", pentobarbital "DCI", fenobarbital "DCI", secbutabarbital "DCI", secobarbital "DCI" y vinilbital "DCI"; sales de estes produ',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293354,'Outros derivados da manolinuréia (ácido barbitúrico); sais destes produtos','Derivatives of malonylurea barbituric acid and salts thereof (excl. salts of malonylurea)','Derivados de la malonilurea "ácido barbitúrico"; sales de estos productos (exc. sales de malonilurea "ácido barbitúrico")',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293355,'Loprazolam, mecloqualona, metaqualona e zipeprol; sais destes produtos','Loprazolam INN, mecloqualone INN, methaqualone INN and zipeprol INN, and salts thereof','Loprazolam "DCI", meclocualona "DCI", metacualona "DCI" y zipeprol "DCI"; sales de estos productos',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293359,'Outros compostos heterocíclicos com 1 (hum) ciclo pirimidina ou piperazina','Heterocyclic compounds with nitrogen hetero-atom[s] only, containing a pyrimidine ring, whether or not hydrogenated, or piperazine ring in the structure (excl. malonylurea barbituric acid and its derivatives, allobarbital INN, amobarbital INN, barbital IN','Compuestos heterocíclicos con heteroátomo/s de nitrógeno exclusivamente, cuya estructura contenga ciclo pirimidina, incl. hidrogenados, o piperazina (exc. malonilurea "ácido barbitúrico" y sus derivados; alobarbital "DCI", amobarbital "DCI", barbital "DCI',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293361,'Melamina','Melamine','Melamina',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293369,'Outros compostos heterocíclicos com 1 (hum) ciclo triazina não condensado','Heterocyclic compounds with nitrogen hetero-atom[s] only, containing an unfused triazine ring, whether or not hydrogenated, in the structure (excl. melamine)','Compuestos heterocíclicos con heteroátomo/s de nitrógeno exclusivamente, cuya estructura contenga ciclo triazina, incl. hidrogenados, sin condensar (exc. melamina)',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293371,'6-Hexanolactama (epsilon-caprolactama)','6-Hexanelactam epsilon-caprolactam','6-Hexanolactama "epsilón caprolactama"',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293372,'Clobazam e metilprilona','Clobazam INN and methyprylon INN','Clobazam "DCI" y metiprilona "DCI"',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293379,'Outras lactamas','Lactams (excl. 6-hexanelactam epsilon-caprolactam, clobazam INN, methyprylon INN, and inorganic or organic compounds of mercury)','Lactamas (exc. 6-hexanolactama "epsilón caprolactama", clobazam "DCI" y metiprilona "DCI")',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293390,'Outros compostos heterocíclicos exclusivamente de hetero-átomo só','Other heterocyclic compounds with nitrogen hetero-atom only','Otros compuestos heterocíclicos con heteroátomo sólo',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293391,'Alprazolam, camazepam, clonazepam, clorazepato, clorodiazepóoxido, delorazepam, diazepam, estazolam, fludiazepam, flunitrazepam, flurazepam, halazepam, loflazepato de etila, lorazepam, lormetazepam, mazindol, medazepam, midazolam, nimetazepam, nitrazepam,','Alprazolam INN, camazepam INN, chlordiazepoxide INN, clonazepam INN, clorazepate, delorazepam INN, diazepam INN, estazolam INN, ethyl loflazepate INN, fludiazepam INN, flunitrazepam INN, flurazepam INN, halazepam INN, lorazepam INN, lormetazepam INN, mazi','Alprazolam "DCI", camazepam "DCI", clorodiazepóxido "DCI", clonazepam "DCI", clorazepato, delorazepam "DCI", diazepam "DCI", estazolam "DCI", fludiazepam "DCI", flunitrazepam "DCI", flurazepam "DCI", halazepam "DCI", loflazepato de etilo "DCI", lorazepam ',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293399,'Outros compostos heterocíclicos exclusivamente de heteroátomo(s) de nitrogênio','Heterocyclic compounds with nitrogen hetero-atom[s] only (excl. those containing an unfused pyrazole, imidazole, pyridine or triazine ring, whether or not hydrogenated, a quinoline or isoquinoline ring-system, not further fused, whether or not hydrogenate','Compuestos heterocíclicos con heteroátomo/s de nitrógeno exclusivamente (exc. compuestos cuya estructura contenga ciclo pirazol, imidazol, piridina o triazina, incl. hidrogenados, sin condensar; compuestos cuya estructura contenga ciclos quinoleína o isoq',29,2933);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293410,'Compostos heterocíclicos com 1 (hum) ciclo tiazol não condensado','Heterocyclic compounds containing an unfused thiazole ring, whether or not hydrogenated, in the structure','Compuestos heterocíclicos cuya estructura contenga ciclo tiazol, incl. hidrogenado, sin condensar',29,2934);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293420,'Compostos heterocíclicos com ciclos de benzotiazol sem outras condensações','Heterocyclic compounds containing in the structure a benzothiazole ring-system, whether or not hydrogenated, but not further fused (excl. inorganic or organic compounds of mercury)','Compuestos heterocíclicos cuya estructura contenga ciclos benzotiazol, incl. hidrogenados, sin otras condensaciones',29,2934);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293430,'Compostos heterocíclicos com ciclos fenotiazina sem outras condensações','Heterocyclic compounds containing in the structure a phenothiazine ring-system, whether or not hydrogenated, but not further fused','Compuestos heterocíclicos cuya estructura contenga ciclos fenotiazina, incl. hidrogenados, sin otras condensaciones',29,2934);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293490,'Outros compostos heterocíclicos','Other heterocyclic compounds','Otros compuestos heterocíclicos',29,2934);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293491,'Aminorex, brotizolan, clotiazepam, cloxazolam, dextromoramida, fendimetrazina, fenmetrazina, haloxazolam, ketazolam, mesocarb, oxazolam, permolina, sufentanila; sais destes produtos','Aminorex, brotizolan, clotiazepam, Cloxazolam, dextromoramide, phendimetrazine, phenmetrazine, haloxazolam, ketazolam, mesocarb, Oxazolam, permolina, sufentanil; salts thereof','Aminorex "DCI", brotizolam "DCI", clotiazepam "DCI", cloxazolam "DCI", dextromoramida "DCI", haloxazolam "DCI", ketazolam "DCI", mesocarb "DCI", oxazolam "DCI", pemolina "DCI", fendimetrazina "DCI", fenmetrazina "DCI" y sufentanil "DCI"; sales de estos pr',29,2934);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293499,'Outros ácidos nucleicos e seus sais e outros compostos heterocíclicos','Nucleic acids and their salts, whether or not chemically defined; heterocyclic compounds (excl. with oxygen only or with nitrogen hetero-atom[s] only, compounds containing in the structure an unfused thiazole ring or a benzothiazole or phenothiazine ring-','Ácidos nucleicos y sus sales, incl. de constitución química no definida; compuestos heterocíclicos (exc. con heteroátomo/s de oxígeno exclusivamente o de nitrógeno exclusivamente; compuestos cuya estructura contenga ciclo tiazol, incl. hidrogenado, sin co',29,2934);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293500,'Sulfonamidas','Sulphonamides','Sulfonamidas',29,2935);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293610,'Provitaminas, não misturadas','Provitamins, unmixed','Provitaminas,  sin mezclar',29,2936);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293621,'Vitamina A e seus derivados','Vitamins A and their derivatives, used primarily as vitamins','Vitaminas A y sus derivados utilizados principalmente como vitaminas',29,2936);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293622,'Vitamina B1 e seus derivados','Vitamin B1 and its derivatives, used primarily as vitamins','Vitamina B1 y sus derivados utilizados principalmente como vitaminas',29,2936);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293623,'Vitamina B2 (ribofiavina)','Vitamin B2 and its derivatives, used primarily as vitamins','Vitamina B2 y sus derivados utilizados principalmente como vitaminas',29,2936);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293624,'Ácido D- ou DL-pantoténico (vitamina B3 ou B5) e seus derivados','D-Pantothenic or DL-pantothenic acid Vitamin B3 or B5 and their derivatives, used primarily as vitamins','Ácido D- o DL-pantoténico "vitamina B3 o vitamina B5" y sus derivados utilizados principalmente como vitaminas',29,2936);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293625,'Vitamina B6 e seus derivados','Vitamin B6 and its derivatives, used primarily as vitamins','Vitamina B6 y sus derivados utilizados principalmente como vitaminas',29,2936);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293626,'Vitamina B12 e seus derivados','Vitamin B12 and its derivatives, used primarily as vitamins','Vitamina B12 y sus derivados utilizados principalmente como vitaminas',29,2936);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293627,'Vitamina C e seus derivados','Vitamin C and its derivatives, used primarily as vitamins','Vitamina C y sus derivados utilizados principalmente como vitaminas',29,2936);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293628,'Vitamina E e seus derivados','Vitamin E and its derivatives, used primarily as vitamins','Vitamina E y sus derivados utilizados principalmente como vitaminas',29,2936);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293629,'Outras vitaminas e seus derivados','Vitamins and their derivatives, used primarily as vitamins, unmixed (excl. vitamins A, B1, B2, B3, B5, B6, B12, C, E and their derivatives)','Vitaminas y sus derivados utilizados principalmente como vitaminas, sin mezclar (exc. vitaminas A, B1, B2, B3, B5, B6, B12, C, E y sus derivados utilizados principalmente como vitaminas)',29,2936);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293690,'Concentrados naturais de vitaminas e misturas de vitaminas e provitaminas','Provitamins and mixtures of vitamins, whether or not in any solvent, and natural concentrates','Mezclas de provitaminas o de vitaminas, incl. los concentrados naturales, en disoluciones de cualquier clase',29,2936);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293710,'Hipófise (anterior) ou hormônios semelhantes, seus derivados','Pituitary (anterior) or similar hormones, their derivatives','Hipófisis (anterior) o las hormonas similares, sus derivados',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293711,'Somatotropina, seus derivados e análogos estruturais','Somatropin, its derivatives and structural analogues, used primarily as hormones','Somatropina, sus derivados y análogos estructurales, utilizados principalmente como hormonas',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293712,'Insulina e seus sais','Insulin and its salts, used primarily as hormones','Insulina y sus sales',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293719,'Outros hormônios polipeptídeos, protéicos e glicoprotéicos, seus derivados e análogos estruturais','Polypeptide hormones, protein hormones and glycoprotein hormones, their derivatives and structural analogues, used primarily as hormones (excl. somatropin, its derivatives and structural analogues, and insulin and its salts)','Hormonas polipeptídicas, hormonas proteicas y hormonas glucoproteicas, sus derivados y análogos estructurales, utilizados principalmente como hormonas (exc. somatotropina, sus derivados y análogos estructurales, así como la insulina y sus sales)',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293721,'Cortisona, hidrocortisona, prednisona (deidrocortisona) e prednisolona (deidroidrocortisona)','Cortisone, hydrocortisone, prednisone dehydrocortisone and prednisolone dehydrohydrocortisone','Cortisona, hidrocortisona, prednisona "dehidrocortisona" y prednisolona "dehidrocortisona"',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293722,'Derivados halogenados dos hormônios corticossuprarenais','Halogenated derivatives of corticosteroidal hormones','Derivados halogenados de las hormonas corticosteroides',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293723,'Estrogênios e progestogênios','Oestrogens and progestogens','Estrógenos y progestógenos',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293729,'Outros hormônios esteróides, seus derivados e análogos estruturais','Steroidal hormones, their derivatives and structural analogues, used primarily as hormones (excl. cortisone, hydrocortisone, prednisone dehydrocortisone, prednisolone dehydrohydrocortisone, halogenated derivatives of corticosteroidal hormones, oestrogens ','Hormonas corticosteroides, sus derivados y análogos estructurales, utilizados principalmente como hormonas (exc. cortisona, hidrocortisona, prednisona "dehidrocortisona" y prednisolona "dehidrohidrocortisona"; derivados halogenados de las hormonas cortico',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293731,'Epinefrina','Epinephrine','Epinefrina',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293739,'Outros hormônios de catecolamina, seus derivados e análogos estruturais','Catecholamine hormones, their derivatives and structural analogues, used primarily as hormones (excl. epinephrine)','Hormonas de la catecolamina, sus derivados y análogos estructurales, utilizados principalmente como hormonas (exc. epinefrina)',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293740,'Derivados de aminoácidos utilizados principalmente como hormônios','Amino-acid derivatives, used primarily as hormones','Derivados de los aminoácidos, utilizados principalmente como hormonas',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293750,'Prostaglandinas, tromboxanas e leucotrienos; seus derivados e análogos estruturais','Prostaglandins, thromboxanes and leukotrienes, their derivatives and structural analogues, used primarily as hormones','Prostaglandinas, tromboxanos y leucotrienos, sus derivados y análogos estructurales, utilizados principalmente como hormonas',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293790,'Outros hormônios naturais ou reproduzidos por síntese, seus derivados e análogos estruturais','Hormones, natural or reproduced by synthesis; derivatives and structural analogues thereof, used primarily as hormones (excl. polypeptide hormones, protein hormones, glycoprotein hormones, steroidal hormones, catecholamine hormones, prostaglandins, thromb','Hormonas naturales o reproducidas por síntesis; sus derivados y análogos estructurales, utilizados principalmente como hormonas (exc. hormonas polipeptídicas, hormonas proteicas, hormonas glucoproteicas, hormonas esteroideas, hormonas de la catecolamina, ',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293791,'Insulina e seus sais','Insulin and its salts','Insulina y sus sales',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293792,'Estrogênios, progestagênios','Oestrogens, progestogens','Estrógenos, progestágenos',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293799,'Outros hormônios e seus derivados; outros esteróides utilizados principalmente como','Other hormones and their Derivatives;  other steroids used primarily as','Otras hormonas y sus derivados; otros esteroides utilizados principalmente como',29,2937);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293810,'Rutosídeo (rutina) e seus derivados','Rutoside rutin and its derivatives','Rutósido "rutina" y sus derivados',29,2938);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293890,'Outros heterosídeos, seus sais, éteres, ésteres e derivados','Glycosides, natural or reproduced by synthesis, and their salts, ethers, esters and other derivatives (excl. rutoside rutin and its derivatives)','Heterósidos, naturales o reproducidos por síntesis; sus sales, éteres, ésteres y demás derivados (exc. rutósido "rutina" y sus derivados)',29,2938);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293910,'Alcalóides do ópio e seus derivados e seus sais','Alkaloids of opium and their derivatives, salts thereof','Alcaloides del opio y sus derivados, sales de los mismos',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293911,'Concentrados de palha de papoula, buprenorfina, codeína, diidrocodeína, etilmorfina, etorfina, folcodina, heroína, hidrocodona, hidromorfona, morfina, nicomorfina, oxicodona, oximorfona, tebacona e tebaína; sais destes produtos','Concentrates of poppy straw; buprenorphine INN, codeine, dihydrocodeine INN, ethylmorphine, etorphine INN, heroin, hydrocodone INN, hydromorphone INN, morphine, nicomorphine INN, oxycodone INN, oxymorphone INN, pholcodine INN, thebacon INN and thebaine, a','Concentrado de paja de adormidera; buprenorfina "DCI", codeína, dihidrocodeína "DCI", etilmorfina, etorfina "DCI", folcodina "DCI", heroína, hidrocodona "DCI", hidromorfona "DCI", morfina, nicomorfina "DCI", oxicodona "DCI", oximorfona "DCI", tebacona "DC',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293919,'Outros alcalóides do ópio, seus derivados e sais','Alkaloids of opium and their derivatives, and salts thereof (excl. concentrates of poppy straw; buprenorphine INN, codeine, dihydrocodeine INN, ethylmorphine, etorphine INN, heroin, hydrocodone INN, hydromorphone INN, morphine, nicomorphine INN, oxycodone','Alcaloides del opio y sus derivados; sales de estos productos (exc. concentrado de paja de adormidera; buprenorfina "DCI", codeína, dihidrocodeína "DCI", etilmorfina, etorfina "DCI", folcodina "DCI", heroína, hidrocodona "DCI", hidromorfona "DCI", morfina',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293920,'Alcalóides da quina, seus derivados e sais','Alkaloids of cinchons and their derivatives; salts thereof','Alcaloides de la quina (chinchona) y sus derivados; sales de estos Productos',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293921,'Quinina e seus sais','Quinine and its salts','Quinina y sus sales',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293929,'outros alcalóides da quina, seus derivados e sais','other alkaloids of quine, its derivatives and its salts','los demás alcaloides de la quina,  sus derivados y sales',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293930,'Cafeína e seus sais','Caffeine and its salts','Cafeína y sus sales',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293941,'Efedrina e seus sais','Ephedrine and its salts','Efedrina y sus sales',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293942,'Pseudoefedrina e seus sais','Pseudoephedrine INN and its salts','Pseudoefedrina "DCI" y sus sales',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293943,'Catina e seus sais','Cathine INN and its salts','Catina "DCI" y sus sales',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293944,'Norefedrina e seus sais','Norephedrine and its salts','Norefedrina y sus sales',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293949,'Outros derivados da efedrina e seus sais','Ephedrines and their salts (excl. ephedrine, pseudoephedrine INN, cathine INN, and salts thereof)','Efedrinas y sus sales (exc. efedrina, pseudoefedrina "DCI", catina y sales de estos productos)',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293950,'Teofilina e aminofilina e seus derivados; seus sais','Theophylline and aminophylline and their derivatives; salts thereof','Teofilina y aminofilina y sus derivados; sales de estos productos',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293951,'Fenetilina e seus sais','Fenetylline INN and its salts','Fenetilina "DCI" y sus sales',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293959,'Teofilina e aminofilina (teofilina-etilenodiamina), seus derivados e sais ','Theophylline and aminophylline theophylline-ethylenediamine and their derivatives, and salts thereof (excl. fenetylline INN and its salts)','Teofilina y aminofilina "teofilina-etilendiamina" y sus derivados; sales de estos productos (exc. fenetilina "DCI" y sus sales)',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293961,'Ergometrina e seus sais','Ergometrine INN and its salts','Ergometrina "DCI" y sus sales',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293962,'Ergotamina e seus sais','Ergotamine INN and its salts','Ergotamina "DCI" y sus sales',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293963,'Ácido lisérgico e seus sais','Lysergic acid and its salts','Ácido lisérgico y sus sales',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293969,'Outros alcalóides da cravagem do centeio, seus derivados e sais','Alkaloids of rye ergot and their derivatives; salts thereof (excl. lysergic acid, ergotamine and ergometrine, and their salts)','Alcaloides del cornezuelo del centeno y sus derivados; sales de estos productos (exc. ergometrina, ergotamina, ácido lisérgico y sales de estos productos)',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293970,'Nicotina e seus sais','Nicotine and salts','Nicotina y sus sales',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293990,'Outros alcalóides vegetais, os seus sais, éteres, ésteres, outros derivados','Other vegetable alkaloids, their salts, ethers, esters, other derivatives','Otros alcaloides vegetales, sus sales, éteres, ésteres y otros derivados',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293991,'Cocaína, ecgonina, levometanfetamina, metanfetamina, racemato de metanfetamina; sais, ésteres e outros derivados destes produtos','Cocaine, ecgonine, levometamfetamine, metamfetamine INN, metamfetamine racemate, and salts, esters and other derivatives thereof','Cocaína, ecgonina, levometanfetamina, metanfetamina "DCI", racemato de metanfetamina; sales, ésteres y demás derivados de estos productos',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (293999,'Outros alcalóides vegetais, naturais ou reproduzidos por síntese, seus sais, ésteres e outros derivados','Vegetable alkaloids, natural or reproduced by synthesis, and their salts, ethers, esters and other derivatives (excl. alkaloids of opium, alkaloids of cinchons, theophylline, aminophylline theophylline-ethylenediamine alkaloids of rye ergot and their salt','Alcaloides vegetales, naturales o reproducidos por síntesis, sus sales, éteres, ésteres y demás derivados (exc. alcaloides del opio y sus derivados, sales de estos productos; alcaloides de la quina "chinchona" y sus derivados, sales de estos productos; te',29,2939);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (294000,'Açúcares quimicamente puros, exceto sacarose, lactose, maltose, glicose e frutose; seus éteres e ésteres e seus sais','Sugars, chemically pure (excl. sucrose, lactose, maltose, glucose and fructose); sugar ethers, sugar acetals and sugar esters, and their salts (excl. natural or reproduced by synthesis, provitamins, vitamins, hormones, glycosides, vegetable alkaloids and ','Azúcares químicamente puros (exc. sacarosa, lactosa, maltosa, glucosa y fructosa "levulosa"); éteres, acetales y ésteres de los azúcares y sus sales (exc. provitaminas, vitaminas, hormonas, heterósidos y alcaloides vegetales, naturales o reproducidos por ',29,2940);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (294110,'Penicilinas e seus derivados com estrutura de ácido penicilânico; sais destes produtos','Penicillins and their derivatives with a penicillanic acid structure; salts thereof','Penicilinas y sus derivados con la estructura del ácido penicilánico; sales de estos productos',29,2941);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (294120,'Estreptomicinas e derivados; sais destes produtos','Streptomycins and their derivatives; salts thereof','Estreptomicinas y sus derivados; sales de estos productos',29,2941);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (294130,'Tetraciclina e derivados; sais destes produtos','Tetracyclines and their derivatives; salts thereof','Tetraciclinas y sus derivados; sales de estos productos',29,2941);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (294140,'Cloranfenicol e derivados; sais destes produtos','Chloramphenicol and its derivatives; salts thereof','Cloranfenicol y sus derivados; sales de estos productos',29,2941);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (294150,'Eritromicina e derivados; sais destes produtos','Erythromycin and its derivatives; salts thereof','Eritromicina y sus derivados; sales de estos productos',29,2941);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (294190,'Outros antibióticos','Antibiotics (excl. penicillins and their derivatives with a penicillanic acid structure, salts thereof, streptomycins, tetracyclines, chloramphenicol and erythromycin, their derivatives and salts thereof)','Antibióticos (exc. penicilinas, sus derivados con la estructura del ácido penicilánico y sales de estos productos; estreptomicinas, tetraciclinas, cloranfenicol y eritromicina, sales y derivados de estos productos)',29,2941);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (294200,'Outros compostos orgânicos','Separate chemically defined organic compounds, n.e.s.','Compuestos orgánicos de composición química definida, n.c.o.p.',29,2942);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300110,'Fígados, glândulas e outros órgãos, para uso opoterápico','Liver, glands and other organs for ophoterapic use','Hígado, las glándulas y demás órganos para uso opoterápico',30,3001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300120,'Extratos de glândulas ou de outros órgãos ou das suas secreções, para usos opoterápicos','Extracts of glands or other organs or of their secretions, for organo-therapeutic uses','Extractos de glándulas o de otros órganos o de sus secreciones, para usos opoterápicos',30,3001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300190,'Outras substâncias humanas ou animais para fins terapêuticos ou profiláticos','Dried glands and other organs for organo-therapeutic uses, whether or not powdered; heparin and its salts; other human or animal substances prepared for therapeutic or prophylactic uses, n.e.s.','Heparina y sus sales; las demás sustancias humanas o animales preparadas para usos terapeúticos o profilácticos, n.c.o.p.',30,3001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300210,'Anti-soros; outras frações do sangue; produtos imunológicos modificados, mesmo obtidos por via biotecnológica','Antisera and other blood fractions and modified immunological products, whether or not obtained by means of biotechnological processes','Antisueros "sueros con anticuerpos", demás fracciones de la sangre y productos inmunológicos modificados, incl. obtenidos por proceso biotecnológico',30,3002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300220,'Vacinas para medicina humana','Vaccines for human medicine','Vacunas para medicina humana',30,3002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300230,'Vacinas para medicina veterinária','Vaccines for veterinary medicine','Vacunas para medicina veterinaria',30,3002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300290,'Outras toxinas, culturas de microorganismos e produtos semelhantes','Human blood; animal blood prepared for therapeutic, prophylactic or diagnostic uses; toxins, cultures of micro-organisms and similar products (excl. yeasts and vaccines)','Sangre humana; sangre animal preparada para usos terapéuticos, profilácticos o de diagnóstico; toxinas, cultivos de microorganismos y productos simil. (exc. levaduras y vacunas)',30,3002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300310,'Medicamentos contendo penicilinas ou seus derivados, com estrutura de ácido penicilânico, ou estreptomicinas ou seus derivados, mas não para venda a retalho','Medicaments containing penicillins or derivatives thereof with a penicillanic acid structure, or streptomycins or derivatives thereof, not in measured doses or put up for retail sale','Medicamentos, que contengan penicilinas o derivados de estos productos con la estructura del ácido penicilánico o estreptomicinas o derivados de estos productos, sin dosificar ni acondicionar para la venta al por menor',30,3003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300320,'Medicamento contendo outros antibióticos, mas não para venda a retalho','Medicaments containing antibiotics, not in measured doses or put up for retail sale (excl. medicaments containing penicillins or derivatives thereof with a penicillanic acid structure, or streptomycins or derivatives thereof)','Medicamentos, que contengan antibióticos, sin dosificar ni acondicionar para la venta al por menor (exc. que contengan penicilinas o derivados de estos productos con la estructura del ácido penicilánico o estreptomicinas o derivados de estos productos)',30,3003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300331,'Medicamentos contendo insulina, mas não antibióticos e não para venda a retalho','Medicaments containing insulin, not in measured doses or put up for retail sale','Medicamentos, que contengan insulina, sin dosificar ni acondicionar para la venta al por menor',30,3003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300339,'Outros medicamentos contendo hormônios ou outros produtos da posição 2937, mas não antibióticos e não para venda a retalho','Medicaments containing hormones or steroids used as hormones, not containing antibiotics, not in measured doses or put up for retail sale (excl. those containing insulin)','Medicamentos, que contengan hormonas o esteroides utilizados como hormonas, sin antibióticos, sin dosificar ni acondicionar para la venta al por menor (exc. que contengan insulina)',30,3003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300340,'Medicamentos contendo alcalóides ou seus derivados, mas não contendo hormônios nem outros produtos da posição 2937, nem antibióticos, e não para venda a retalho','Medicaments containing alkaloids or derivatives thereof, not containing hormones, steroids used as hormones or antibiotics, not in measured doses or put up for retail sale','Medicamentos, que contengan alcaloides o sus derivados, sin hormonas ni esteroides utilizados como hormonas ni antibióticos, sin dosificar ni acondicionar para la venta al por menor',30,3003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300390,'Outros medicamentos contendo produtos misturados, para fins terapêuticos ou profiláticos, mas não para venda a retalho','Medicaments consisting of two or more constituents mixed together for therapeutic or prophylactic uses, not in measured doses or put up for retail sale (excl. antibiotics containing hormones or steroids used as hormones, but not containing antibiotics, al','Medicamentos constituidos por productos mezclados entre sí, preparados para usos terapéuticos o profilácticos, sin dosificar ni acondicionar para la venta al por menor (exc. productos con antibióticos, con hormonas o esteroides utilizados como hormonas pe',30,3003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300410,'Medicamentos contendo penicilinas ou seus derivados, com estrutura de ácido penicilânico, ou estreptomicinas ou seus derivados, em doses, para venda a retalho','Medicaments containing penicillins or derivatives thereof with a penicillanic acid structure, or streptomycins or derivatives thereof, put up in measured doses incl. those in the form of transdermal administration or in forms or packings for retail sale','Medicamentos, que contengan penicilinas o derivados de estos productos con la estructura del ácido penicilánico o estreptomicinas o derivados de estos productos, dosificados "incl. los administrados por vía transdérmica" o acondicionados para la venta al ',30,3004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300420,'Medicamento contendo outros antibióticos, em doses, para venda a retalho','Medicaments containing antibiotics, put up in measured doses incl. those in the form of transdermal administration or in forms or packings for retail sale (excl. medicaments containing penicillins or derivatives thereof with a penicillanic structure, or s','Medicamentos, que contengan antibióticos, dosificados "incl. los administrados por vía transdérmica" o acondicionados para la venta al por menor (exc. que contengan penicilinas o derivados de estos productos con la estructura del ácido penicilánico o estr',30,3004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300431,'Medicamentos contendo insulina, mas não antibióticos, em doses, para venda a retalho','Medicaments containing insulin but not antibiotics, put up in measured doses incl. those in the form of transdermal administration or in forms or packings for retail sale','Medicamentos, que contengan insulina pero sin antibióticos, dosificados "incl. los administrados por vía transdérmica" o acondicionados para la venta al por menor',30,3004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300432,'Medicamentos contendo hormônios corticosteróides, mas não antibióticos, seus derivados e análogos estruturais, em doses, para venda a retalho','Medicaments containing corticosteroid hormones, their derivatives or structural analogues but not antibiotics, put up in measured doses incl. those in the form of transdermal administration or in forms or packings for retail sale','Medicamentos, que contengan hormonas corticosteroides, sus derivados y análogos estructurales pero sin antibióticos, dosificados "incl. los administrados por vía transdérmica" o acondicionados para la venta al por menor',30,3004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300439,'Outros medicamentos contendo hormônios ou outros produtos da posição 2937, mas não antibióticos, em doses, para venda a retalho','Medicaments containing hormones or steroids used as hormones but not antibiotics, put up in measured doses incl. those in the form of transdermal administration or in forms or packings for retail sale (excl. medicaments containing insulin or corticosteroi','Medicamentos, que contengan hormonas o esteroides utilizados como hormonas pero sin antibióticos, dosificados "incl. los administrados por vía transdérmica" o acondicionados para la venta al por menor (exc. que contengan insulina u hormonas corticosteroid',30,3004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300440,'Medicamentos contendo alcalóides ou seus derivados, mas não contendo hormônios nem outros produtos da posição 2937, nem antibióticos, em doses, para venda a retalho','Medicaments containing alkaloids or derivatives thereof, not containing hormones, steroids used as hormones or antibiotics, put up in measured doses incl. those in the form of transdermal administration or in forms or packings for retail sale','Medicamentos, que contengan alcaloides o sus derivados pero sin hormonas ni esteroides utilizados como hormonas ni antibióticos, dosificados "incl. los administrados por vía transdérmica" o acondicionados para la venta al por menor',30,3004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300450,'Outros medicamentos contendo vitaminas ou provitaminas, em doses, para venda a retalho','Medicaments containing provitamins, vitamins, incl. natural concentrates and derivatives thereof used primarily as vitamins, put up in measured doses incl. those in the form of transdermal administration or in forms or packings for retail sale','Medicamentos, que contengan provitaminas, vitaminas, incl. los concentrados naturales, o sus derivados utilizados principalmente como vitaminas, dosificados "incl. los administrados por vía transdérmica" o acondicionados para la venta al por menor',30,3004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300490,'Outros medicamentos contendo produtos misturados, para fins terapêuticos ou profiláticos, em doses, para venda a retalho','Medicaments consisting of mixed or unmixed products for therapeutic or prophylactic purposes, put up in measured doses incl. those in the form of transdermal administration or in forms or packings for retail sale (excl. medicaments containing antibiotics,','Medicamentos constituidos por productos mezclados o sin mezclar, preparados para usos terapéuticos o profilácticos, dosificados "incl. los administrados por vía transdérmica" o acondicionados para la venta al por menor (exc. medicamentos que contengan ant',30,3004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300510,'Pensos adesivos e outros artigos com uma camada adesiva, impregnados ou recobertos de substâncias farmacêuticas ou acondicionados para venda a retalho, para usos medicinais, cirúrgicos dentários ou veterinários, ','Adhesive dressings and other articles having an adhesive layer, impregnated or covered with pharmaceutical substances or put up for retail sale for medical, surgical, dental or veterinary purposes','Apósitos y demás artículos con una capa adhesiva, impregnados o recubiertos de sustancias farmacéuticas o acondicionados para la venta al por menor con fines médicos, quirúrgicos, odontólogicos o veterinarios',30,3005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300590,'Pastas, gazes, ataduras e artigos análogos, impregnados ou recobertos de substâncias farmacêuticas ou acondicionados para venda a retalho, para usos medicinais, cirúrgicos dentários ou veterinários','Wadding, gauze, bandages and the like, e.g. dressings, adhesive plasters, poultices, impregnated or covered with pharmaceutical substances or put up for retail sale for medical, surgical, dental or veterinary purposes (excl. adhesive dressings and other a','Esparadrapos, sinapismos, guatas, gasas, vendas y artículos simil., impregnados o recubiertos de sustancias farmacéuticas o acondicionados para la venta al por menor con fines médicos, quirúrgicos, odontólogicos o veterinarios (exc. apósitos y demás artíc',30,3005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300610,'Categutes esterilizados e materiais esterilizados semelhantes para suturas cirúrgicas; laminárias esterilizadas, hemostáticos absorvíveis esterilizados, barreiras antiaderentes esterilizadas, para cirugia ou odontologia.','Sterile surgical catgut, similar sterile suture materials, incl. sterile absorbable surgical or dental yarns, and sterile tissue adhesives for surgical wound closure; sterile laminaria and sterile laminaria tents; sterile absorbable surgical or dental hae','Catguts estériles y ligaduras estériles simil., para suturas quirúrgicas y adhesivos estériles para tejidos orgánicos utilizados en cirugía para cerrar heridas; laminarias estériles; hemostáticos reabsorbibles estériles para cirugía u odontología',30,3006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300620,'Reagentes para a determinação dos grupos ou fatores sangüíneos','Reagents for determining blood groups or blood factors','Reactivos para la determinación de los grupos o de los factores sanguíneos',30,3006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300630,'Preparações opacificantes para exames radiográficos; reagentes de diagnóstico para serem administrados a pacientes','Opacifying preparations for x-ray examinations; diagnostic reagents for administration to patients','Preparaciones opacificantes para exámenes radiológicos; reactivos de diagnóstico concebidos para usar en el paciente',30,3006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300640,'Cimentos e outros produtos para obturação dentária e para reconstituição óssea','Dental cements and other dental fillings; bone reconstruction cements','Cementos y demás productos de obturación dental; cementos para la refección de los huesos',30,3006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300650,'Estojos e caixas de primeiros-socorros, guarnecidos','First-aid boxes and kits','Botiquines equipados para primeros auxilios',30,3006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300660,'Preparações químicas contraceptivas à base de hormônios, de outros produtos da posição 2937 ou de espermicidas','Chemical contraceptive preparations based on hormones, prostaglandins, thromboxanes, leukotrienes, derivatives and structural analogues thereof or on spermicides','Preparaciones químicas anticonceptivas a base de hormonas, prostaglandinas, tromboxanos y leucotrienos, sus derivados y análogos estructurales o a base de espermicidas',30,3006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300670,'Preparações na forma de gel para uso como lubrificante em medicina ou veterinária','Gel preparations designed to be used  in human or veterinary medicine as a lubricant for parts of the body for surgical operations or physical examinations or as a coupling agent between the body and medical instruments','Preparaciones en forma de gel, concebidas para ser utilizadas en medicina o veterinaria como lubricante para ciertas partes del cuerpo en operaciones quirúrgicas o exámenes médicos o como nexo entre el cuerpo y los instrumentos médicos',30,3006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300680,'desperdícios farmacêuticos','pharmaceuticals waste','desperdicios farmacéuticos',30,3006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300691,'Equipamentos identificáveis para uso em ostomia','Appliances identifiable for ostomy use','Dispositivos identificables para uso en estomas',30,3006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (300692,'Desperdícios farmacêuticos','Waste pharmaceuticals','Desechos farmacéuticos',30,3006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310100,'Adubos ou fertilizantes de origem animal ou vegetal, mesmo misturados entre si ou tratados quimicamente','Animal or vegetable fertilisers, whether or not mixed together or chemically treated; fertilisers produced by the mixing or chemical treatment of animal or vegetable products (excl. those in pellet or similar forms, or in packages with a gross weight of <','Abonos de origen animal o vegetal, incl. mezclados entre sí o tratados químicamente; abonos procedentes de la mezcla o del tratamiento químico de productos de origen animal o vegetal (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg',31,3101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310210,'Uréia, mesmo em solução aquosa','Urea, whether or not in aqueous solution (excl. that in pellet or similar forms, or in packages with a gross weight of <= 10 kg)','Urea, incl. en disolución acuosa (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg)',31,3102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310221,'Sulfato de amônio','Ammonium sulphate (excl. that in pellet or similar forms, or in packages with a gross weight of <= 10 kg)','Sulfato de amonio (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg)',31,3102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310229,'Outros sais duplos e misturas de sulfato e nitrato de amônio','Double salts and mixtures of ammonium sulphate and ammonium nitrate (excl. goods of this chapter in tablets or similar forms or in packages of a gross weight of <= 10 kg)','Sales dobles y mezclas entre sí de sulfato de amonio y de nitrato de amonio (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg)',31,3102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310230,'Nitrato de amônio, mesmo em solução aquosa','Ammonium nitrate, whether or not in aqueous solution (excl. that in pellet or similar forms, or in packages with a gross weight of <= 10 kg)','Nitrato de amonio, incl. en disolución acuosa (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg)',31,3102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310240,'Misturas de nitrato de amônio com carbonato de cálcio ou com matérias inorgânicas desprovidas de poder fertilizante','Mixtures of ammonium nitrate with calcium carbonate or other inorganic non-fertilising substances for use as fertilisers (excl. those in pellet or similar forms, or in packages with a gross weight of <= 10 kg)','Mezclas de nitrato de amonio con carbonato de calcio o con otras materias inorgánicas sin poder fertilizante, para su utilización como abono (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg)',31,3102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310250,'Nitrato de sódio','Sodium nitrate (excl. that in pellet or similar forms, or in packages with a gross weight of <= 10 kg)','Nitrato de sodio (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg)',31,3102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310260,'Sais duplos e misturas de nitratos de cálcio e amônio','Double salts and mixtures of calcium nitrate and ammonium nitrate (excl. those in pellet or similar forms, or in packages with a gross weight of <= 10 kg)','Sales dobles y mezclas entre sí de nitrato de calcio y de nitrato de amonio (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg)',31,3102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310270,'cianamida calcica','calcium cyanamide','cianamida cálcica',31,3102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310280,'Misturas de uréia com nitrato de amônio, em solução aquosa ou amoniacal','Mixtures of urea and ammonium nitrate in aqueous or ammoniacal solution (excl. those in packages with a gross weight of <= 10 kg)','Mezclas de urea con nitrato de amonio en disolución acuosa o amoniacal (exc. en envases de un peso bruto <= 10 kg)',31,3102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310290,'Outros adubos ou fertilizantes minerais ou químicos nitrogenados, incluídas as misturas','Mineral or chemical nitrogen fertilisers (excl. urea; ammonium sulphate; ammonium nitrate; sodium nitrate; double salts and mixtures of ammonium nitrate with ammonium sulphate or calcium; mixtures of urea and ammonium nitrate in aqueous or ammoniacal solu','Abonos minerales o químicos nitrogenados (exc. urea; sulfato de amonio; nitrato de amonio y de Na; sales dobles y mezclas entre sí de sulfato de amonio o de nitrato de Ca con nitrato de amonio; mezclas de nitrato de amonio con carbonato de calcio o con ot',31,3102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310310,'Superfosfatos','Superphosphates (excl. those in pellet or similar forms, or in packages with a gross weight of <= 10 kg)','Superfosfatos (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg)',31,3103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310320,'escórias de desfosforacao','basic slag','escorias de desfosforación',31,3103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310390,'Outros adubos ou fertilizantes minerais ou químicos fosfatados','Mineral or chemical phosphatic fertilisers (excl. superphosphates, those in pellet or similar forms, or in packages with a gross weight of <= 10 kg)','Abonos minerales o químicos fosfatados (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg, así como los superfosfatos y las escorias de desfosforación)',31,3103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310410,'carnalita e outros sais de potássio, naturais, em bruto','carnalite and other crude natural potassium salts','carnalita y demás sales de potasio,  naturales,  en bruto',31,3104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310420,'Cloreto de potássio para uso como fertilizante','Potassium chloride for use as fertiliser (excl. that in pellet or similar forms, or in packages with a gross weight of <= 10 kg)','Cloruro de potasio, para su utilización como abono (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg)',31,3104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310430,'Sulfato de potássio','Potassium sulphate (excl. that in pellet or similar forms, or in packages with a gross weight of <= 10 kg)','Sulfato de potasio (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg)',31,3104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310490,'Outros adubos ou fertilizantes minerais ou químicos potássicos','Carnallite, sylvite and other crude natural potassium salts, potassium magnesium sulphate and mixtures of potassic fertilisers, e.g. mixtures of potassium chloride and potassium sulphate (excl. those in pellet or similar forms, or in packages with a gross','Sulfato de magnesio y de potasio, mezclas de cloruro de potasio y sulfato de potasio y demás mezclas de abonos potásicos entre sí (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg)',31,3104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310510,'Adubos ou fertilizantes em tabletes ou em embalagens com peso <= 10 kg','Mineral or chemical fertilisers of animal or vegetable origin, in pellet or similar forms, or in packages with a gross weight of <= 10 kg','Abonos de origen animal, vegetal, mineral o químico, en tabletas o formas simil. o en envases de un peso bruto <= 10 kg',31,3105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310520,'Adubos ou fertilizantes contendo nitrogênio, fósforo e potássio','Mineral or chemical fertilisers containing the three fertilising elements nitrogen, phosphorus and potassium (excl. those in pellet or similar forms, or in packages with a gross weight of <= 10 kg)','Abonos minerales o químicos con los tres elementos fertilizantes nitrógeno, fósforo y potasio (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg)',31,3105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310530,'Hidrogeno-ortofosfato de diamônio','Diammonium hydrogenorthophosphate diammonium phosphate (excl. that in pellet or similar forms, or in packages with a gross weight of <= 10 kg)','Hidrogenoortofosfato de diamonio "fosfato diamónico" (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg)',31,3105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310540,'Diidrogeno-ortofosfato de amônio, inclusive misturas com hidrogeno-ortofosfato de diamônio','Ammonium dihydrogenorthophosphate monoammonium phosphate, whether or not mixed with diammonium hydrogenorthophosphate diammonium phosphate (excl. that in pellet or similar forms, or in packages with a gross weight of <= 10 kg)','Dihidrogenoortofosfato de amonio "fosfato monoamónico", incl. mezclado con el hidrogenoortofosfato de diamonio "fosfato diamónico" (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg)',31,3105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310551,'Adubos ou fertilizantes contendo nitrato e fosfato','Mineral or chemical fertilisers containing nitrates and phosphates (excl. ammonium dihydrogenorthophosphate Monoammonium phosphate, diammonium hydrogenorthophosphate Diammonium phosphate, and those in pellet or similar forms, or in packages with a gross w','Abonos minerales o químicos, que contengan nitratos y fosfatos (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg, así como abonos que contengan hidrogenoortofosfato de diamonio "fosfato diamónico" o dihidrogenoortofosfato de amonio ',31,3105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310559,'Outros adubos ou fertilizantes minerais ou químicos contendo nitrogênio e fósforo','Mineral or chemical fertilisers containing the two fertilising elements nitrogen (excl. nitrate) and phosphorus but not nitrates (excl. ammonium dihydrogenorthophosphate monoammonium phosphate, diammonium hydrogenorthophosphate diammonium phosphate in pel','Abonos minerales o químicos, que contengan los dos elementos fertilizantes nitrógeno y fósforo (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg, así como abonos que contengan nitratos y fosfatos y abonos que contengan hidrogenoorto',31,3105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310560,'Adubos ou fertilizantes contendo fósforo e potássio','Mineral or chemical fertilisers containing the two fertilising elements phosphorus and potassium (excl. those in pellet or similar forms, or in packages with a gross weight of <= 10 kg)','Abonos minerales o químicos, que contengan los dos elementos fertilizantes fósforo y potasio (exc. en tabletas o formas simil. o en envases de un peso bruto <= 10 kg)',31,3105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (310590,'Outros adubos ou fertilizantes minerais ou químicos','Mineral or chemical fertilisers containing the two fertilising elements nitrogen and potassium or one principal fertilising substance only, incl. mixtures of animal or vegetable fertilisers with chemical or mineral fertilisers (excl. those in pellet or si','Abonos minerales o químicos, que contengan los dos elementos fertilizantes nitrógeno y potasio o que contengan un único elemento fertilizante principal, incl. las mezclas de abonos de origen animal o vegetal con abonos minerales o químicos (exc. en tablet',31,3105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320110,'Extrato tanante de quebracho','Quebracho extract','Extracto de quebracho',32,3201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320120,'Extrato tanante de mimosa','Wattle extract','Extracto de mimosa "acacia"',32,3201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320190,'Outros extratos tanantes de origem vegetal; taninos, sais, éteres, ésteres e outros derivados dos taninos','Tanning extracts of vegetable origin (excl. quebracho extract and wattle extract); tannins and their salts, ethers, esters and other derivatives','Extractos curtientes de origen vegetal (exc. extractos de quebracho y de mimosa "acacia"); taninos y sus sales, éteres, ésteres y demás derivados',32,3201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320210,'Produtos tanantes orgânicos sintéticos','Synthetic organic tanning substances','Productos curtientes orgánicos sintéticos',32,3202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320290,'Produtos tanantes inorgânicos; preparações tanantes; preparações enzimáticas para a pré-curtimenta','Inorganic tanning substances; tanning preparations, whether or not containing natural tanning substances; enzymatic preparations for pre-tanning','Productos curtientes inorgánicos; preparaciones curtientes, incl. con productos curtientes naturales; preparaciones enzimáticas para precurtido',32,3202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320300,'Matérias corantes de origem vegetal ou animal e preparações à base dessas matérias','Colouring matter of vegetable or animal origin, incl. dye extracts (excl. animal black), whether or not chemically defined; preparations based on colouring matter of vegetable or animal origin of a kind used to dye fabrics or produce colorant preparations','Materias colorantes de origen vegetal o animal, incl. los extractos tintóreos (exc. los negros de origen animal) de constitución química definida; preparaciones a base de materias de origen vegetal o animal, del tipo de las usadas para colorear cualquier ',32,3203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320411,'Corantes orgânico-sintéticos dispersos e suas preparações','Synthetic organic disperse dyes; preparations based on synthetic organic disperse dyes of a kind used to dye fabrics or produce colorant preparations (excl. preparations of heading 3207, 3208, 3209, 3210, 3213 and 3215)','Colorantes dispersos sintéticos orgánicos; preparaciones a base de colorantes dispersos sintéticos orgánicos, del tipo de las usadas para colorear cualquier materia o como ingredientes para fabricar preparaciones colorantes (exc. preparaciones de las part',32,3204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320412,'Corantes ácidos, mesmo metalizados e suas preparações','Synthetic organic acid dyes, whether or not metallised, and synthetic organic mordant dyes; preparations based on synthetic organic acid or mordant dyes of a kind used to dye fabrics or produce colorant preparations (excl. preparations of heading 3207, 32','Colorantes ácidos sintéticos orgánicos, incl. metalizados, y colorantes mordientes sintéticos orgánicos; preparaciones a base de colorantes ácidos y colorantes mordientes sintéticos orgánicos, del tipo de las usadas para colorear cualquier materia o como ',32,3204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320413,'Corantes básicos e suas preparações','Basic synthetic organic dyes; preparations based on basic synthetic organic dyes of a kind used to dye fabrics or produce colorant preparations (excl. preparations of heading 3207, 3208, 3209, 3210, 3213 and 3215)','Colorantes básicos sintéticos orgánicos; preparaciones a base de colorantes básicos sintéticos orgánicos, del tipo de las usadas para colorear cualquier materia o como ingredientes para fabricar preparaciones colorantes (exc. preparaciones de las partidas',32,3204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320414,'Corantes diretos e suas preparações','Direct synthetic organic dyes; preparations based on direct synthetic organic dyes of a kind used to dye fabrics or produce colorant preparations (excl. preparations of heading 3207, 3208, 3209, 3210, 3213 and 3215)','Colorantes directos sintéticos orgánicos; preparaciones a base de colorantes directos sintéticos orgánicos, del tipo de las usadas para colorear cualquier materia o como ingredientes para fabricar preparaciones colorantes (exc. preparaciones de las partid',32,3204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320415,'Corantes à cuba e suas preparações','Synthetic organic vat dyes, incl. those usable in that state as pigments; preparations based on synthetic organic vat dyes of a kind used to dye fabrics or produce colorant preparations (excl. preparations of heading 3207, 3208, 3209, 3210, 3213 and 3215)','Colorantes sintéticos orgánicos a la tina o a la cuba, incl. los que ya sean utilizables como colorantes pigmentarios; preparaciones a base de colorantes sintéticos orgánicos a la tina o a la cuba, del tipo de las usadas para colorear cualquier materia o ',32,3204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320416,'Corantes reagentes e suas preparações','Synthetic organic reactive dyes; preparations based on synthetic organic reactive dyes of a kind used to dye fabrics or produce colorant preparations (excl. preparations of heading 3207, 3208, 3209, 3210, 3213 and 3215)','Colorantes reactivos sintéticos orgánicos; preparaciones a base de colorantes reactivos sintéticos orgánicos, del tipo de las usadas para colorear cualquier materia o como ingredientes para fabricar preparaciones colorantes (exc. preparaciones de las part',32,3204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320417,'Pigmentos e suas preparações','Synthetic organic pigments; preparations based on synthetic organic pigments of a kind used to dye fabrics or produce colorant preparations (excl. preparations of heading 3207, 3208, 3209, 3210, 3213 and 3215)','Colorantes pigmentarios sintéticos orgánicos; preparaciones a base de colorantes pigmentarios sintéticos orgánicos, del tipo de las usadas para colorear cualquier materia o como ingredientes para fabricar preparaciones colorantes (exc. preparaciones de la',32,3204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320419,'Outras matérias corantes orgânicas sintéticas e suas preparações','Synthetic organic colouring matter (excl. disperse dyes, acid dyes, mordant dyes, basic dyes, direct dyes, vat dyes and reactive dyes and organic pigments); preparations of the kind used for colouring any materials or for the production of prepared colour','Materias colorantes orgánicas sintéticas (exc. colorantes dispersos, ácidos, para mordinete, básicos, directos, a la tina o a la cuba, reactivos y pigmentarios); preparaciones a base de materias colorantes orgánicas sintéticas, del tipo de las usadas para',32,3204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320420,'Produtos orgânicos sintéticos utilizados como agentes de avivamento fluorescentes','Synthetic organic products of a kind used as fluorescent brightening agents, whether or not chemically defined','Productos orgánicos sintéticos de los tipos utilizados para el avivado fluorescente, incl. de constitución química definida',32,3204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320490,'Outros produtos corantes orgânicos sintéticos','Synthetic organic products of a kind used as luminophores, whether or not chemically defined','Productos orgánicos sintéticos de los tipos utilizados como luminóforos, incl. de constitución química definida',32,3204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320500,'Lacas corantes e suas preparações','Colour lakes (other than Chinese or Japanese lacquer and paints); preparations based on colour lakes of a kind used to dye fabrics or produce colorant preparations (excl. preparations of heading 3207, 3208, 3209, 3210, 3213 and 3215)','Lacas colorantes (exc. goma laca de China o del Japón y pinturas laqueadas); preparaciones a base de lacas colorantes, del tipo de las usadas para colorear cualquier materia o como ingredientes para fabricar preparaciones colorantes (exc. preparaciones de',32,3205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320611,'Pigmentos contendo, em peso, calculado sobre matéria seca, => 80% de dióxido de titânio','Pigments and preparations based on titanium dioxide of a kind used to dye fabrics or produce colorant preparations, containing >= 80% by weight of titanium dioxide calculated on the dry matter (excl. preparations of heading 3207, 3208, 3209, 3210, 3212, 3','Pigmentos y preparaciones a base de dióxido de titanio, con un contenido de dióxido de titanio >= 80% en peso, calculado sobre materia seca, del tipo de las usadas para colorear cualquier materia o como ingredientes para fabricar preparaciones colorantes ',32,3206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320619,'Outros pigmentos e preparações à base de dióxido de titânio','Pigments and preparations based on titanium dioxide of a kind used to dye fabrics or produce colorant preparations, containing < 80% by weight of titanium dioxide calculated on the dry matter (excl. preparations of heading 3207, 3208, 3209, 3210, 3212, 32','Pigmentos y preparaciones a base de dióxido de titanio, con un contenido de dióxido de titanio < 80% en peso, calculado sobre materia seca, del tipo de las usadas para colorear cualquier materia o como ingredientes para fabricar preparaciones colorantes (',32,3206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320620,'Pigmentos e preparações à base de compostos de cromo','Pigments and preparations of a kind used for colouring any material or used as ingredients in the manufacture of colouring preparations based on chromium compounds (excl. preparations of headings 3207, 3208, 3209, 3210, 3212, 3213 and 3215)','Pigmentos y preparaciones a base de compuestos de cromo, del tipo de las usadas para colorear cualquier materia o como ingredientes para fabricar preparaciones colorantes (exc. preparaciones de las partidas 3207 a 3210, 3212, 3213 y 3215)',32,3206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320630,'pigmentos e preparações à base de compostos de cádmio','pigments and preparations based on cadmium compounds','pigmentos y preparaciones a base de compuests.de cadmio',32,3206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320641,'Ultramar e suas preparações','Ultramarine and preparations based thereon of a kind used to dye fabrics or produce colorant preparations (excl. preparations of heading 3207, 3208, 3209, 3210, 3213 and 3215)','Ultramar y sus preparaciones, del tipo de las usadas para colorear cualquier materia o como ingredientes para fabricar preparaciones colorantes (exc. preparaciones de las partidas 3207 a 3210, 3212, 3213 y 3215)',32,3206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320642,'Litopônio e outros pigmentos e preparações à base de sulfeto de zinco','Lithopone and other pigments and preparations based on zinc sulphide of a kind used to dye fabrics or produce colorant preparations (excl. preparations of heading 3207, 3208, 3209, 3210, 3213 and 3215)','Litopón, otros pigmentos y preparaciones a base de sulfuro de cinc, del tipo de las usadas para colorear cualquier materia o como ingredientes para fabricar preparaciones colorantes (exc. preparaciones de las partidas 3207 a 3210, 3212, 3213 y 3215)',32,3206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320643,'pigmentos e preparações à base de hexacianoferratos','pigments and preparations based on hexacyanoferrates','pigmentos y preparaciones a base de hexacianoferratos',32,3206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320649,'Outras matérias corantes e preparações','Inorganic or mineral colouring matter, n.e.s.; preparations based on inorganic or mineral colouring matter of a kind used to dye fabrics or produce colorant preparations, n.e.s. (excl. preparations of heading 3207, 3208, 3209, 3210, 3213 and 3215 and inor','Materias colorantes inorgánicas o minerales, n.c.o.p.; preparaciones a base de materias colorantes inorgánicas o minerales, n.c.o.p., del tipo de las usadas para colorear cualquier materia o como ingredientes para fabricar preparaciones colorantes (exc. p',32,3206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320650,'Produtos inorgânicos utilizados como luminóforos','Inorganic products of a kind used as luminophores, whether or not chemically defined','Productos inorgánicos de los tipos utilizados como luminóforos, incl. de constitución química definida',32,3206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320710,'Pigmentos opacificantes e cores preparados e preparações semelhantes','Prepared pigments, prepared opacifiers, prepared colours and similar preparations of a kind used in the ceramic, enamelling or glass industry','Pigmentos, opacificantes y colores preparados y preparaciones simil., del tipo de las usadas en cerámica, esmaltado o en la industria del vidrio',32,3207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320720,'Composições vitrificáveis, engobos e preparações semelhantes','Vitrifiable enamels and glazes, engobes slips and similar preparations of the kind used in the ceramic, enamelling or glass industry','Composiciones vitrificables, engobes y preparaciones simil., del tipo de las usadas en cerámica, esmaltado o en la industria del vidrio',32,3207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320730,'Polimentos líquidos e preparações semelhantes','Liquid lustres and similar preparations of the kind used in the ceramic, enamelling or glass industry','Abrillantadores "lustres" líquidos y preparaciones simil., del tipo de las usadas en cerámica, esmaltado o en la industria del vidrio',32,3207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320740,'Fritas e outros vidros, em pó, em grânulos, em lamelas ou flocos','Glass frit and other glass in the form of powder, granules or flakes','Frita de vidrio y demás vidrios, en polvo, gránulos, copos o escamillas',32,3207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320810,'Tintas, vernizes e soluções à base de poliésteres, dispersos ou dissolvidos em meio não aquoso','Paints and varnishes, incl. enamels and lacquers, based on polyesters, dispersed or dissolved in a non-aqueous medium; solutions based on polyesters in volatile organic solvents, containing > 50% solvent by weight','Pinturas y barnices a base de poliésteres, dispersos o disueltos en un medio no acuoso; disoluciones a base de poliésteres en disolventes orgánicos volátiles, con una proporción de disolvente > 50% del peso de la disolución',32,3208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320820,'Tintas, vernizes e soluções à base de polímeros acrílicos ou vinílicos, dispersos ou dissolvidos em meio não aquoso','Paints and varnishes, incl. enamels and lacquers, based on acrylic or vinyl polymers, dispersed or dissolved in a non-aqueous medium; solutions based on acrylic or vinyl polymers in volatile organic solvents, containing > 50% solvent by weight','Pinturas y barnices a base de polímeros acrílicos o vinílicos, dispersos o disueltos en un medio no acuoso; disoluciones a base de polímeros acrílicos o vinílicos en disolventes orgánicos volátiles, con una proporción de disolvente > 50% del peso de la di',32,3208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320890,'Tintas, vernizes e soluções de outros polímeros sintéticos, dispersos ou dissolvidos em meio não aquoso','Paints and varnishes based, incl. enamels and lacquers, on synthetic polymers or chemically modified natural polymers, dispersed or dissolved in a non-aqueous medium, and solutions of products of headings 3901 to 3913 in volatile organic solvents, contain','Pinturas y barnices a base de polímeros sintéticos o naturales modificados, dispersos o disueltos en un medio no acuoso; disoluciones en disolventes orgánicos volátiles de productos citados en las partidas 3901 a 3913, con una proporción de disolvente > 5',32,3208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320910,'Tintas e vernizes à base de polímeros acrílicos ou vinílicos dispersos ou dissolvidos em meio aquoso','Paints and varnishes, incl. enamels and lacquers, based on acrylic or vinyl polymers, dispersed or dissolved in an aqueous medium','Pinturas y barnices a base de polímeros acrílicos o vinílicos, dispersos o disueltos en un medio acuoso',32,3209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (320990,'Tintas e vernizes de outros polímeros sintéticos, dispersos ou dissolvidos em meio aquoso','Paints and varnishes, incl. enamels and lacquers, based on synthetic or chemically modified natural polymers, dispersed or dissolved in an aqueous medium (excl. those based on acrylic or vinyl polymers)','Pinturas y barnices a base de polímeros sintéticos o naturales modificados, dispersos o disueltos en un medio acuoso (exc. a base de polímeros acrílicos o vinílicos)',32,3209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (321000,'Outras tintas e vernizes; pigmentos a água preparados, utilizados para acabamento de couros','Paints and varnishes, incl. enamels, lacquers and distempers (excl. those based on synthetic polymers or chemically modified natural polymers); prepared water pigments of a kind used for finishing leather','Pinturas y barnices (exc. a base de polímeros sintéticos o naturales modificados); pigmentos al agua preparados de los tipos utilizados para el acabado de cuero',32,3210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (321100,'Secantes preparados','Prepared driers','Secativos preparados',32,3211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (321210,'Folhas para marcar a ferro','Stamping foils of a kind used in the printing of book bindings or hatband leather','Hojas para el marcado a fuego de los tipos utilizados para encuadernaciones o guarniciones interiores de sombreros',32,3212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (321290,'Outros pigmentos dispersos em meios não aquosos, no estado líquido ou pastoso','Pigments, incl. metallic powders and flakes, dispersed in non-aqueous media, in liquid or paste form, of a kind used in the manufacture of paints; colorants and other colouring matter, n.e.s. put up for retail sale','Pigmentos, incl. el polvo y laminillas metálicos, dispersos en medios no acuosos, líquidos o en pasta, de los tipos utilizados para la fabricación de pinturas; tintes y demás materias colorantes, n.c.o.p., presentados en formas o envases para la venta al ',32,3212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (321310,'Cores em sortidos para pintura artística, atividades educativas e similares','Sets of artist''s, student''s or signboard painter''s colours, modifying tints, amusement colours and the like, in tablets, tubes, jars, bottles, pans or similar packages','Colores en juegos para pintura artística, la enseñanza, la pintura de carteles, para matizar o para entretenimiento y colores simil., en pastillas, tubos, botes, frascos, o en formas o envases simil.',32,3213);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (321390,'Outras cores para pintura artística e atividades educativas','Artist''s, student''s or signboard painter''s colours, modifying tints, amusement colours and the like, in tablets, tubes, jars, bottles, pans or similar packages (excl. those in sets)','Colores para pintura artística, la enseñanza, la pintura de carteles, para matizar o para entretenimiento y colores simil., en pastillas, tubos, botes, frascos, o en formas o envases simil. (exc. colores en juegos)',32,3213);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (321410,'Mástique de vidraceiro, cimentos de resinas, outros mástiques; indutos utilizados em pintura','Glaziers'' putty, grafting putty, resin cements, caulking compounds and other mastics; painters'' fillings','Masilla, cementos de resina y demás mástiques; plastes "enduidos" utilizados en pintura',32,3214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (321490,'Indutos não refratários do tipo utilizado em alvenaria','Non-refractory surfacing preparations for facades, inside walls, floors, ceilings and the like','Plastes no refractarios de los tipos utilizados en albañilería',32,3214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (321511,'Tintas de impressão pretas','Black printing ink, whether or not concentrated or solid','Tintas de imprenta, negras, incl. concentradas o sólidas',32,3215);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (321519,'Outras tintas de impressão','Printing ink, whether or not concentrated or solid (excl. black ink)','Tintas de imprenta, incl. concentradas o sólidas (exc. negras)',32,3215);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (321590,'Tintas de escrever ou de desenhar e outras tintas','Writing or drawing ink and other inks, whether or not concentrated or solid','Tintas para escribir o dibujar y demás tintas, incl. concentradas o sólidas',32,3215);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330111,'Óleo essencial, de bergamota','Essential oil, of bergamot','Aceite esencial, de bergamota',33,3301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330112,'Óleo essencial de laranja','Oils of sweet and bitter orange, whether or not terpeneless, incl. concretes and absolutes (excl. orange-flower oil)','Aceites esenciales de naranja, desterpenados o no, incl. los "concretos" o "absolutos" (exc. esencias de azahar)',33,3301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330113,'Óleo essencial de limão','Oils of lemon, whether or not terpeneless, incl. concretes and absolutes','Aceites esenciales de limón, desterpenados o no, incl. los "concretos" o "absolutos"',33,3301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330114,'Óleo essencial, de lima','Essential oil, of lime','Aceite esencial, de lima',33,3301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330119,'Óleo essencial de outros cítricos','Essential oils of citrus fruit, whether or not terpeneless, incl. concretes and absolutes (excl. those of sweet and bitter orange and lemon)','Aceites esenciales de agrios "cítricos", desterpenados o no, incl. los "concretos" o "absolutos" (exc. de bergamota, de naranja, de limón y de lima)',33,3301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330121,'Óleo essencial, de gerânio','Essential oil, of geranium','Aceite esencial, de geranio',33,3301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330122,'Óleo essencial, de jasmim','Essential oil, of jasmin','Aceite esencial, de jazmín',33,3301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330123,'Óleo essencial, de alfazema ou lavanda','Essential oil,  of lavender or of lavandin','Aceite esencial,  de lavanda o de lavandín',33,3301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330124,'Óleo essencial de hortelã-pimenta (mentha piperita)','Oils of peppermint Mentha piperita, whether or not terpeneless, incl. concretes and absolutes','Aceites esenciales de menta piperita "Mentha piperita", desterpenados o no, incl. los "concretos" o "absolutos"',33,3301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330125,'Óleo essencial de outras mentas','Oils of mints, whether or not terpeneless, incl. concretes and absolutes (excl. those of peppermint Mentha piperita)','Aceites esenciales de menta, desterpenados o no, incl. los "concretos" o "absolutos" (exc. de menta piperita "Mentha piperita")',33,3301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330126,'Óleo essencial, de vetiver','Essential oil, of vetiver','Aceite esencial, de espicanardo (vetiver)',33,3301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330129,'Outros óleos essenciais','Essential oils, whether or not terpeneless, incl. concretes and absolutes (excl. those of citrus fruit and mint)','Aceites esenciales, desterpenados o no, incl. los "concretos" o "absolutos" (exc. de agrios "cítricos", de geranio, de jazmín, de lavanda "espliego", de lavandín, de mentas y de espicanardo "vetiver")',33,3301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330130,'Resinóides','Resinoids','Resinoides',33,3301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330190,'Soluções concentradas, subprodutos terpênicos e soluções aquosas de óleos essenciais; óleoressinas de extração','Extracted oleoresins; concentrates of Essential oils in fats, fixed oils, waxes and the like, obtained by enfleurage or maceration; terpenic by-products of the deterpenation of Essential oils; aromatic aqueous distillates and aqueous solutions of essentia','Oleorresinas de extracción; disoluciones concentradas de aceites esenciales en grasas, aceites fijos, ceras o materias simil., obtenidas por enflorado o maceración; subproductos terpénicos residuales de la desterpenación de los aceites esenciales; destila',33,3301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330210,'Misturas de substâncias odoríferas utilizadas como matéria básica para indústrias alimentares ou de bebida','Mixtures of odoriferous substances and mixtures, incl. alcoholic solutions, with a basis of one or more of these substances, of a kind used in the food and drink industries; other preparations based on odoriferous substances, of a kind used for the manufa','Mezclas de sustancias odoríferas y mezclas, incl. las disoluciones alcohólicas, a base de una o varias de estas sustancias, de los tipos utilizados en las industrias alimentarias o de bebidas; las demás preparaciones a base de sustancias odoríferas, de lo',33,3302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330290,'Outras misturas de substâncias odoríferas utilizadas como matéria básica para a indústria','Mixtures of odoriferous substances and mixtures, incl. alcoholic solutions, based on one or more of these substances, of a kind used as raw materials in industry (excl. food or drink industries)','Mezclas de sustancias odoríferas y mezclas, incl. las disoluciones alcohólicas, a base de una o varias de estas sustancias, de los tipos utilizados como materias básicas para la industria (exc. en las industrias alimentarias o de bebidas)',33,3302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330300,'Perfumes (extratos) e águas-de-colônia','Perfumes and toilet waters (excl. aftershave lotions, personal deodorants and hair lotions)','Perfumes y aguas de tocador (exc. lociones para después del afeitado y desodorantes corporales)',33,3303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330410,'Produtos de maquilagem para os lábios','Lip make-up preparations','Preparaciones para el maquillaje de los labios',33,3304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330420,'Produtos de maquilagem para os olhos','Eye make-up preparations','Preparaciones para el maquillaje de los ojos',33,3304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330430,'Preparações para manicuros e pedicuros','Manicure or pedicure preparations','Preparaciones para manicuras o pedicuros',33,3304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330491,'Pós, incluídos os compactos, para maquilagem','Make-up or skin care powders, incl. baby powders, whether or not compressed (excl. medicaments)','Polvos de belleza o maquillaje y polvos para bebés, incl. los compactos (exc. medicamentos)',33,3304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330499,'Outros produtos de beleza ou de maquilagem preparados','Beauty or make-up preparations and preparations for the care of the skin (other than medicaments), incl. sunscreen or suntan preparations (excl. medicaments, lip and eye make-up preparations, manicure or pedicure preparations and make-up or skin care powd','Preparaciones de belleza, maquillaje y para el cuidado de la piel, incl. las preparaciones antisolares y las bronceadoras (exc. medicamentos, preparaciones para el maquillaje de los labios o de los ojos, preparaciones para manicuras o pedicuros y polvos, ',33,3304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330510,'Xampus para os cabelos','Shampoos','Champúes',33,3305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330520,'Preparações para ondulação ou alisamento permanentes dos cabelos','Preparations for permanent waving or straightening','Preparaciones para ondulación o desrizado permanentes',33,3305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330530,'Laquês para o cabelo','Hair lacquers','Lacas para el cabello',33,3305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330590,'Outras preparações capilares','Preparations for use on the hair (excl. shampoos, preparations for permanent waving or straightening and hair lacquers)','Preparaciones capilares (exc. champúes, preparaciones para ondulación o desrizado permanentes y lacas para el cabello)',33,3305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330610,'Dentifrícios','Dentifrices, incl. those used by dental practitioners','Dentífricos, incl. los utilizados por los dentistas',33,3306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330620,'Fios utilizados para limpar espaços interdentais (fio dental)','Yarn used to clean between the teeth dental floss, in individual retail packages','Hilo utilizado para limpieza de los espacios interdentales "hilo dental", en envases individuales para la venta al por menor',33,3306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330690,'Outras preparações para higiene bucal ou dentária','Preparations for oral or dental hygiene, incl. denture fixative pastes and powders (excl. dentifrices and yarn used to clean between the teeth dental floss)','Preparaciones para higiene bucal o dental, incl. los polvos y cremas para la adherencia de las dentaduras (exc. dentífricos e hilo utilizado para limpieza de los espacios interdentales "hilo dental")',33,3306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330710,'Preparações para barbear (antes, durante ou após)','Shaving preparations, incl. pre-shave and aftershave products','Preparaciones para afeitar o para antes o después del afeitado',33,3307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330720,'Desodorantes corporais e antiperspirantes','Personal deodorants and antiperspirants','Desodorantes corporales y antitranspirantes',33,3307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330730,'Sais perfumados e outras preparações para banhos','Perfumed bath salts and other bath and shower preparations','Sales perfumadas y demás preparaciones para el baño',33,3307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330741,'Agarbate e outras preparações odoríferas que atuem por combustão','Agarbatti and other odoriferous preparations which operate by burning','"Agarbatti" y demás preparaciones odoríferas que actúen por combustión',33,3307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330749,'Outros preparações para perfumar ou desodorizar ambientes','Preparations for perfuming or deodorising rooms, incl. odoriferous preparations used during religious rites (excl. agarbatti and other odoriferous preparations which operate by burning)','Preparaciones para perfumar o desodorizar locales, incl. las preparaciones odoríferas para ceremonias religiosas (exc. "agarbatti" y demás preparaciones odoríferas que actúen por combustión)',33,3307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (330790,'Outros produtos ou preparados de perfumaria, toucador ou cosmética','Depilatories and other perfumery, toilet or cosmetic preparations, n.e.s.','Depilatorios y demás preparaciones de perfumería, de tocador o de cosmética, n.c.o.p.',33,3307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340111,'Sabões, produtos ou preparações tensoativos de toucador, incluídos os de uso medicinal','Soap and organic surface-active products and preparations, in the form of bars, cakes, moulded pieces or shapes, and paper, wadding, felt and nonwovens, impregnated, coated or covered with soap or detergent, for toilet use, incl. medicated products','Jabón, productos y preparaciones orgánicos tensoactivos usados como jabón, en barras, panes, trozos o piezas troqueladas o moldeadas, y papel, guata, fieltro y tela sin tejer, impregnados, recubiertos o revestidos de jabón o de detergentes, de tocador, in',34,3401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340119,'Outros sabões, produtos ou preparações tensoativas, em barras, pedaços','Soap and organic surface-active products and preparations, in the form of bars, cakes, moulded pieces or shapes, and paper, wadding, felt and nonwovens, impregnated, coated or covered with soap or detergent (excl. those for toilet use, incl. medicated pro','Jabón, productos y preparaciones orgánicos tensoactivos usados como jabón, en barras, panes, trozos o piezas troqueladas o moldeadas, y papel, guata, fieltro y tela sin tejer, impregnados, recubiertos o revestidos de jabón o de detergentes (exc. de tocado',34,3401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340120,'Sabões sob outras formas','Soap in the form of flakes, granules, powder, paste or in aqueous solution','Jabón en copos, en gránulos, en polvo, en pasta o en disolución acuosa',34,3401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340130,'Produtos e preparações orgânicos tensoativos destinados à lavagem de pele, acondicionados para venda a retalho','Organic surface-active products and preparations for washing the skin, in the form of liquid or cream and put up for retail sale, whether or not containing soap','Productos y preparaciones orgánicos tensoactivos para el lavado de la piel, líquidos o en crema, acondicionados para la venta al por menor, aunque contengan jabón',34,3401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340211,'Agentes orgânicos de superfície, aniônicos, mesmo acondicionados para venda a retalho','Anionic organic surface-active agents, whether or not put up for retail sale (excl. soap)','Agentes de superficie orgánicos, aniónicos, incl. acondicionados para la venta al por menor (exc. jabones)',34,3402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340212,'Agentes orgânicos de superfície, catiônicos, mesmo acondicionados para venda a retalho','Cationic organic surface-active agents, whether or not put up for retail sale (excl. soap)','Agentes de superficie orgánicos, catiónicos, incl. acondicionados para la venta al por menor (exc. jabones)',34,3402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340213,'Agentes orgânicos de superfície, não iônicos, mesmo acondicionados para venda a retalho','Non-ionic organic surface-active agents, whether or not put up for retail sale (excl. soap)','Agentes de superficie orgánicos, no iónicos, incl. acondicionados para la venta al por menor (exc. jabones)',34,3402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340219,'Outros agentes orgânicos de superfície, mesmo acondicionados para venda a retalho','Organic surface-active agents, whether or not put up for retail sale (excl. anionic, cationic or non-ionic agents and soap)','Agentes de superficie orgánicos, incl. acondicionados para la venta al por menor (exc. aniónicos, catiónicos y no iónicos, así como los jabones)',34,3402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340220,'Preparações tensoativas, preparações para lavagem e preparações para limpeza, acondicionadas para venda a retalho','Surface-active preparations, washing preparations, auxiliary washing preparations and cleaning preparations put up for retail sale (excl. organic surface-active agents, soap and organic surface-active preparations in the form of bars, cakes, moulded piece','Preparaciones tensoactivas, preparaciones para lavar, incl. las preparaciones auxiliares de lavado, y preparaciones de limpieza, incl. que contengan jabón, acondicionadas para la venta al por menor (exc. agentes de superficie orgánicos, jabones y preparac',34,3402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340290,'Outras preparações tensoativas e preparações para lavagem e limpeza','Surface-active preparations, washing preparations, incl. auxiliary washing preparations and cleaning preparations (excl. those put up for retail sale, organic surface-active agents, soap and organic surface-active preparations in the form of bars, cakes, ','Preparaciones tensoactivas, preparaciones para lavar, incl. las preparaciones auxiliares de lavado, y preparaciones de limpieza (exc. acondicionadas para la venta al por menor, así como agentes de superficie orgánicos; jabones y preparaciones orgánicas te',34,3402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340311,'Preparações contendo óleos de petróleo ou de minerais betuminosos para tratamento de matérias têxteis, couro, peleteria ou de outras matérias','Textile lubricant preparations and preparations of a kind used for the oil or grease treatment of leather, furskins or other material containing petroleum oil or bituminous mineral oil (excl. preparations containing, as basic constituents, >= 70% petroleu','Preparaciones para tratamiento de materia textil, cueros y pieles, peletería u otras materias, que contengan aceites de petróleo o de mineral bituminoso (exc. aquellas con un contenido de aceites de petróleo o de mineral bituminoso, como componente básico',34,3403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340319,'Outras preparações contendo óleos de petróleo ou de minerais betuminosos','Lubricant preparations, incl. cutting-oil preparations, bolt or nut release preparations, anti-rust or anti-corrosion preparations and mould-release preparations, based on lubricants and containing petroleum oil or bituminous mineral oil (excl. preparatio','Preparaciones lubricantes, incl. los aceites de corte, las preparaciones para aflojar tuercas, las preparaciones antiherrumbre o anticorrosión y las preparaciones para el desmoldeo, a base de lubricantes, que contengan aceites de petróleo o de mineral bit',34,3403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340391,'Outras preparações para tratamento de matéria têxtil, couros, peleteria ou de outras matérias','Textile lubricant preparations and preparations of a kind used for the oil or grease treatment of leather, furskins or other material not containing petroleum oil or bituminous mineral oil','Preparaciones para tratamiento de materia textil, cueros y pieles, peletería u otras materias, que no contengan aceites de petróleo o mineral bituminoso',34,3403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340399,'Outras preparações lubrificantes, antiaderentes ou antiferruginosas','Lubricant preparations, incl. cutting-oil preparations, bolt or nut release preparations, anti-rust or anti-corrosion preparations and mould-release preparations, based on lubricants but not containing petroleum oil or bituminous mineral oil (excl. prepar','Preparaciones lubricantes, incl. los aceites de corte, las preparaciones para aflojar tuercas, las preparaciones antiherrumbre o anticorrosión y las preparaciones para el desmoldeo, a base de lubricantes, que no contengan aceites de petróleo o mineral bit',34,3403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340410,'cera de linhita modificada químicamente','waxes of chemically modified lignite','cera de lignito modificado químicamente',34,3404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340420,'Ceras artificiais e ceras preparadas de polietileno-glicóis','Polyoxyethylene [polyethylene glycol] waxes','Cera de poli"oxietileno" [polietilenglicol]',34,3404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340490,'Outras ceras artificiais ou preparadas','Artificial waxes and prepared waxes (excl. polyoxyethylene [polyethylene glycol] waxes)','Ceras artificiales y ceras preparadas (exc. cera de lignito modificado químicamente y cera de poli"oxietileno" [polietilenglicol])',34,3404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340510,'Pomadas, cremes e preparações semelhantes para calçados ou para couros','Polishes, creams and similar preparations, for footwear or leather, whether or not in the form of paper, wadding, felt, nonwovens, cellular plastics or cellular rubber, impregnated, coated or covered with such preparations (excl. artificial and prepared w','Betunes, cremas y preparaciones simil. para el calzado o para el cuero y pieles, incl. papel, guata, fieltro, tela sin tejer, plástico o caucho celulares, impregnados, recubiertos o revestidos de estas preparaciones (exc. ceras artificiales y ceras prepar',34,3405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340520,'Encáusticas e preparações semelhantes para conservação e limpeza de móveis, soalhos e artigos de madeira','Polishes, creams and similar preparations, for the maintenance of wooden furniture, floors or other woodwork, whether or not in the form of paper, wadding, felt, nonwovens, cellular plastics or cellular rubber, impregnated, coated or covered with such pre','Encáusticos y preparaciones simil. para la conservación de muebles de madera, parqués u otras manufacturas de madera, incl. papel, guata, fieltro, tela sin tejer, plástico o caucho celulares, impregnados, recubiertos o revestidos de estas preparaciones (e',34,3405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340530,'Preparações para dar brilho a pintura de carroçarias e produtos semelhantes, exceto para dar brilho a metais','Polishes and similar preparations for coachwork, whether or not in the form of paper, wadding, felt, nonwovens, cellular plastics or cellular rubber, impregnated, coated or covered with such preparations (excl. artificial and prepared waxes of heading 340','Abrillantadores "lustres" y preparaciones simil. para carrocerías, incl. papel, guata, fieltro, tela sin tejer, plástico o caucho celulares, impregnados, recubiertos o revestidos de estas preparaciones (exc. ceras artificiales y ceras preparadas de la par',34,3405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340540,'Pastas, pós e outros preparações para arear','Scouring pastes and powders and other scouring preparations, whether or not in the form of paper, wadding, felt, nonwovens, cellular plastics or cellular rubber, impregnated, coated or covered with such preparations','Pastas, polvos y demás preparaciones para fregar, incl. papel, guata, fieltro, tela sin tejer, plástico o caucho celulares, impregnados, recubiertos o revestidos de estas preparaciones',34,3405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340590,'Outras preparações para dar brilho em vidros ou metais','Glass or metal polishes, whether or not in the form of paper, wadding, felt, nonwovens, cellular plastics or cellular rubber, impregnated, coated or covered with such preparations','Abrillantadores "lustres" para vidrio o metal, incl. papel, guata, fieltro, tela sin tejer, plástico o caucho celulares, impregnados, recubiertos o revestidos de estas preparaciones',34,3405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340600,'Velas, pavios, círios e artigos semelhantes','Candles and the like','Velas, cirios y artículos simil.',34,3406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (340700,'Pastas para modelar, ceras para dentistas e outras composições para dentistas à base de gesso','Modelling pastes, incl. those put up for children''s amusement; preparations known as dental wax or as dental impression compounds, put up in sets, in packings for retail sale or in plates, horseshoe shapes, sticks or similar forms;  other preparations fo','Pastas para modelar, incl. las presentadas para entretenimiento de los niños; preparaciones llam. ceras para odontología o "compuestos para impresión dental", presentadas en juegos o en juegos, en envases para la venta al por menor o en plaquitas, herradu',34,3407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (350110,'Caseínas','Casein','Caseína',35,3501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (350190,'Caseinatos, outros derivados das caseínas, colas de caseína','Caseinates and other casein derivatives; casein glues (excl. those put up for retail sale as glue and weighing <= 1 kg)','Caseinatos y demás derivados de la caseína; colas de caseína (exc. acondicionadas para la venta al por menor, de peso neto <= 1 kg)',35,3501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (350211,'Ovalbumina seca','Egg albumin, dried e.g. in sheets, scales, flakes, powder','Ovoalbúmina seca "p.ej. en hojas, escamas, cristales, polvos"',35,3502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (350219,'Ovalbumina (exceto seca)','Egg albumin (excl. dried [e.g. in sheets, scales, flakes, powder])','Ovoalbúmina (exc. seca "p.ej. en hojas, escamas, cristales, polvos")',35,3502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (350220,'Lactalbumina, incluídos os concentrados de duas ou mais proteínas de soro de leite, contendo, em peso, calculado sobre matéria seca, mais de 80% de proteínas de soro de leite','Milk albumin lactalbumin, incl. concentrates of two or more whey proteins containing by weight > 80% whey proteins, calculated on the dry matter','Lactoalbúmina, incl. los concentrados de dos o más proteínas del lactosuero, con un contenido de proteínas del lactosuero > 80% en peso, calculado sobre materia seca',35,3502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (350290,'Outros albuminas, albuminatos e derivados das albuminas','Albumins, albuminates and other albumin derivatives (excl. egg albumin and milk albumin [incl. concentrates of two or more whey proteins containing by weight > 80% whey proteins, calculated on the dry matter])','Albúminas, albuminatos y demás derivados de las albúminas (exc. ovoalbúmina y lactoalbúmina, incl. los concentrados de dos o más proteínas del lactosuero, con un contenido de proteínas del lactosuero > 80% en peso, calculado sobre materia seca)',35,3502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (350300,'Gelatinas e seus derivados; ictiocola e outras colas de origem animal, exceto cola de caseína','Gelatin, whether or not in square or rectangular sheets, whether or not surface-worked or coloured, and gelatin derivatives; isinglass; other glues of animal origin (excl. those packaged as glue for retail sale and weighing <= 1 kg, and casein glues of he','Gelatinas, aunque se presenten en hojas cuadradas o rectangulares, incl. trabajadas en la superficie o coloreadas, y sus derivados; ictiocola; otras colas de origen animal (exc. acondicionadas para la venta al por menor, de peso neto <= 1 kg, así como las',35,3503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (350400,'Peptonas e seus derivados; outras matérias protéicas e seus derivados; pó de peles','Peptones and their derivatives; other albuminous substances and their derivatives, n.e.s.; hide powder, whether or not chromed','Peptonas y sus derivados; las demás materias proteínicas y sus derivados, n.c.o.p.; polvo de cueros y pieles, incl. tratado al cromo',35,3504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (350510,'Dextrina e outros amidos e féculas modificados','Dextrins and other modified starches, e.g. pregelatinised or esterified starches','Dextrina, almidones y féculas pregelatinizados o esterificados y demás almidones o féculas modificados',35,3505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (350520,'Colas à base de amidos ou de féculas, de dextrina ou de outros amidos ou féculas modificados','Glues based on starches, dextrins or other modified starches (excl. those put up for retail sale and weighing <= 1 kg)','Colas a base de almidón, fécula, dextrina o demás almidones o féculas modificados (exc. acondicionadas para la venta al por menor, de peso neto <= 1 kg)',35,3505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (350610,'Produtos utilizados como colas ou adesivos, acondicionados para venda a retalho, com peso líquido <= 1 kg','Products suitable for use as glues or adhesives put up for retail sale as glues or adhesives, with a net weight of <= 1 kg','Productos de cualquier clase utilizados como colas o adhesivos, acondicionados para la venta al por menor como colas o adhesivos, de un peso neto <= 1 kg',35,3506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (350691,'Adesivos à base de polímeros das posições 3901 a 3913 ou de borracha','Adhesives based on polymers of heading 3901 to 3913 or on rubber (excl. products suitable for use as glues or adhesives put up for retail sale as glues or adhesives, with a net weight of <= 1 kg)','Adhesivos a base de polímeros de las subpartidas 3901 a 3913 o de caucho (exc. acondicionados para la venta al por menor como colas o adhesivos, de un peso neto <= 1 kg)',35,3506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (350699,'Outras colas e adesivos preparados','Glues, prepared, and other prepared adhesives, n.e.s.','Colas y demás adhesivos preparados, n.c.o.p.',35,3506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (350710,'Coalho e seus concentrados','Rennet and concentrates thereof','Cuajo y sus concentrados',35,3507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (350790,'Outras enzimas preparadas','Enzymes and prepared enzymes, n.e.s. (excl. rennet and concentrates thereof)','Enzimas y preparaciones enzimáticas, n.c.o.p. (exc. cuajo y sus concentrados)',35,3507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (360100,'Pólvoras propulsivas','Propellent powders','Pólvora',36,3601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (360200,'Explosivos preparados, exceto pólvoras propulsivas','Prepared explosives (excl. propellent powders)','Explosivos preparados (exc. la pólvora)',36,3602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (360300,'Estopins ou rastilhos de segurança; cordéis detonantes; fulminantes e cápsulas fulminantes; detonadores elétricos','Safety fuses; detonating fuses; percussion or detonating caps; igniters; electric detonators (excl. grenade detonators and cartridge cases, whether or not with percussion caps)','Mechas de seguridad; cordones detonantes; cebos y cápsulas fulminantes; inflamadores; detonadores eléctricos (exc. espoletas de proyectiles y vainas, con cebos o sin ellos)',36,3603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (360410,'Fogos de artifício','Fireworks','Artículos para fuegos artificiales',36,3604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (360490,'Foguetes de sinalização ou contra o granizo, bombas, petardos e outros artigos de pirotecnia','Signalling flares, rain rockets, fog signals and other pyrotechnic articles (excl. fireworks and cartridge blanks)','Cohetes de señales o granífugos y simil., petardos y demás artículos de pirotecnia (exc. cartuchos sin proyectil)',36,3604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (360500,'Fósforos, exceto os artigos de pirotecnia','Matches (excl. pyrotechnic articles of heading 3604)','Fósforos "cerillas" (exc. artículos de pirotecnia de la partida 3604)',36,3605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (360610,'Combustíveis líquidos ou gasosos liquefeitos, utilizados para carregar isqueiros, com capacidade <= 300 cm3','Liquid or liquefied-gas fuels in containers of a kind used for filling or refilling cigarette or similar lighters, with a capacity of <= 300 cm³','Combustibles líquidos y gases combustibles licuados en recipientes de los tipos utilizados para cargar o recargar encendedores o mecheros, de capacidad = 300 m³',36,3606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (360690,'Ferrocério e outros ligas pirofosfóricas; artigos de matérias inflamáveis','Ferro-cerium and other pyrophoric alloys in all forms; metaldehyde, hexamethylenetetramine and similar products in tablets, sticks or similar forms, for use as fuel; alcohol-based fuels and prepared fuels of a similar kind, whether solid or in paste form;','Ferrocerio y demás aleaciones pirofóricas en cualquier forma; metaldehído, hexametilenotetramina y productos simil., en tabletas, barritas o formas análogas, que impliquen su utilización como combustibles; combustibles a base de alcohol y combustibles pre',36,3606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370110,'Chapas e filmes planos, para raios x, sensibilizados, não impressionados','Photographic plates and film in the flat, sensitised, unexposed, for X-ray (excl. of paper, paperboard or textiles)','Placas y películas planas, sensibilizadas, sin impresionar, para rayos X (exc. de papel, de cartón o de textiles)',37,3701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370120,'Filmes planos de revelação e copiagem instantâneas, sensibilizados, não impressionados','Instant print film in the flat, sensitised, unexposed, whether or not in packs','Películas planas autorrevelables, sensibilizadas, sin impresionar, incl. en cargadores',37,3701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370130,'Outras chapas e filmes planos, sensibilizados, não impressionados, com um dos lados > 255 mm','Photographic plates and film in the flat, sensitised, unexposed, with any side > 255 mm','Placas y películas planas, fotográficas, sensibilizadas, sin impresionar, en las que por lo menos un lado sea > 255 mm',37,3701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370191,'Outras chapas e filmes, planos, sensibilizados, não impressionados, para foto a cores','Photographic plates and film in the flat, sensitised, unexposed, of any material other than paper, paperboard or textiles, for colour photography polychrome (excl. instant print film)','Placas y películas planas, fotográficas, sensibilizadas, sin impresionar, para fotografía en colores "policroma" (exc. de papel, de cartón o de textiles, así como las placas y películas en las que por lo menos un lado sea > 255 mm y las películas planas a',37,3701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370199,'Outras chapas e filmes, planos, sensibilizados, não impressionados, para fotografia monocromática','Photographic plates and film in the flat for monochrome photography, sensitised, unexposed, of any material other than paper, paperboard or textiles (excl. X-ray film and photographic plates, film in the flat with any side > 255 mm, and instant print film','Placas y películas planas, fotográficas, sensibilizadas, sin impresionar, para fotografía en blanco y negro (exc. de papel, de cartón o de textiles, así como las placas y películas en las que por lo menos un lado sea > 255 mm, las películas planas autorre',37,3701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370210,'Filmes para raios X, sensibilizados, não impressionados, em rolos','Photographic film in rolls, unexposed, for X-ray (excl. of paper, paperboard or textiles)','Películas en rollos, sensibilizadas, sin impresionar, para rayos X (exc. de papel, de cartón o de textiles)',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370220,'Filmes de revelação instantânea','Films of instant disclosure','Películas de difusión instantánea',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370231,'Outros filmes para foto a cores, sensibilizados, não impressionados, não perfurados, de largura <= 105 mm, em rolos','Photographic film incl. instant print film, in rolls, sensitised, unexposed, without perforations, width <= 105 mm, for colour photography polychrome (excl. that of paper, paperboard or textiles)','Películas fotográficas en rollos, sensibilizadas, sin impresionar, sin perforar, de anchura <= 105 mm, para fotografía en colores "policroma" (exc. de papel, de cartón o de textiles)',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370232,'Outros filmes para fotografia monocromática, com emulsão de halogenetos de prata, sensibilizados, não impressionados, não perfurados, de largura <= 105 mm, em rolos','Photographic film incl. instant print film, in rolls, sensitised, unexposed, without perforations, width <= 105 mm, with silver halide emulsion for monochrome photography (excl. that of paper, paperboard or textiles and X-ray film)','Películas fotográficas en rollos, sensibilizadas, sin impresionar, sin perforar, de anchura <= 105 mm, con emulsión de halogenuros de plata, para fotografía en blanco y negro (exc. de papel, de cartón o de textiles, así como películas para rayos X)',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370239,'Outros filmes para fotografia monocromática, sensibilizados, não impressionados, não perfurados, de largura <= 105 mm, em rolos','Photographic film incl. instant print film, sensitised, in rolls, unexposed, without perforations, width <= 105 mm, for monochrome photography (excl. film with silver halide emulsion, film made of paper, paperboard or textiles and X-ray film)','Películas fotográficas en rollos, sensibilizadas, sin impresionar, sin perforar, de anchura <= 105 mm, para fotografía en blanco y negro (exc. con emulsión de halogenuros de plata, así como películas de papel, de cartón o de textiles y películas para rayo',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370241,'Filmes para fotografia a cores, sensibilizados, não impressionados, não perfurados, de largura > 610 mm e comprimento > 200 m, em rolos','Photographic film incl. instant print film, sensitised, in rolls, unexposed, without perforations, width > 610 mm, length > 200 m, for colour photography polychrome (excl. that of paper, paperboard or textiles)','Películas fotográficas en rollos, sensibilizadas, sin impresionar, sin perforar, de anchura > 610 mm y longitud > 200 m, para fotografía en colores "policroma" (exc. de papel, de cartón o de textiles)',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370242,'Filmes, sensibilizados, não impressionados, não perfurados, exceto para fotografia a cores, de largura > 610 mm e comprimento > 200 m, em rolos','Photographic film incl. instant print film, sensitised, in rolls, unexposed, without perforations, width > 610 mm, length > 200 m, for monochrome photography (excl. that of paper, paperboard or textiles)','Películas fotográficas en rollos, sensibilizadas, sin impresionar, sin perforar, de anchura > 610 mm y longitud > 200 m, para fotografía en blanco y negro (exc. de papel, de cartón o de textiles)',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370243,'Filmes sensibilizados, não impressionados, não perfurados, de largura > 610 mm e comprimento <= 200 m, em rolos','Photographic film incl. instant print film, sensitised, in rolls, unexposed, without perforations, width > 610 mm, length <= 200 m (excl. that of paper, paperboard or textiles)','Películas fotográficas en rollos, sensibilizadas, sin impresionar, sin perforar, de anchura > 610 mm y longitud <= 200 m, para fotografía en blanco y negro (exc. de papel, de cartón o de textiles)',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370244,'Filmes, sensibilizados, não impressionados, não perfurados, de largura > 105 mm, mas <= 610 mm, em rolos','Photographic film incl. instant print filmm, sensitised, in rolls, unexposed, without perforations, width > 105 mm to 610 mm (excl. that of paper, paperboard or textiles)','Películas fotográficas en rollos, sensibilizadas, sin impresionar, sin perforar, de anchura > 105 mm pero <= 610 mm (exc. de papel, de cartón o de textiles)',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370251,'Filmes para fotografia a cores, sensibilizados, não impressionados, de largura <= 16 mm e comprimento <= 14 m, em rolos','Films, photographic, sensitised, in rolls, unexposed, with perforations, for colour photography polychrome, with a width of <= 16 mm and a length of <= 14 m (excl. of paper, paperboard or textiles)','Películas fotográficas en rollos, sensibilizadas, sin impresionar, perforadas, para fotografía en colores "policroma", de anchura <= 16 mm y de longitud <= 14 m (exc. de papel, de cartón o de textiles)',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370252,'Filmes para fotografia a cores, sensibilizados, não impressionados, de largura <= 16 mm e comprimento > 14 m, rolos','Photographic film, sensitised, in rolls, unexposed, with perforations, for colour photography polychrome, width <= 16 mm, length > 14 m (excl. of paper, paperboard or textiles)','Películas fotográficas en rollos, sensibilizadas, sin impresionar, perforadas, para fotografía en colores "policroma", de anchura <= 16 mm y de longitud > 14 m (exc. de papel, de cartón o de textiles)',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370253,'Filmes para diapositivos a cores, sensibilizados, não impressionados, de largura > 16 mm e <= 35 mm e comprimento <= 30 m, em rolos','Photographic film, sensitised, in rolls, unexposed, with perforations, for colour photography polychrome, width > 16 mm to 35 mm, length <= 30 m, for slides','Películas fotográficas en rollos, sensibilizadas, sin impresionar, perforadas, para fotografía en colores "policroma", de anchura > 16 mm pero <= 35 mm y de longitud <= 30 m, para diapositivas',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370254,'Filmes para fotografia a cores, exceto diapositivos, sensibilizados, não impressionados, de largura > 16 mm, mas <= 35 mm, e comprimento <= 30 m, em rolos','Photographic film, sensitised, in rolls, unexposed, with perforations, for colour photography polychrome, width > 16 mm but <= 35 mm, length <= 30 m (excl. of paper, paperboard and textiles  slide and instant print roll film)','Películas fotográficas en rollos, sensibilizadas, sin impresionar, perforadas, para fotografía en colores "policroma", de anchura > 16 mm pero <= 35 mm y de longitud <= 30 m (exc. de papel, de cartón o de textiles, así como películas para diapositivas y p',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370255,'Filmes para fotografia a cores, sensibilizados, não impressionados, de largura > 16 mm, mas <= 35 mm, e comprimento > 30 m, em rolos','Photographic film, sensitised, in rolls, unexposed, with perforations, for colour photography polychrome, width > 16 mm but <= 35 mm, length > 30 m (excl. of paper, paperboard and textiles  slide and instant print roll film) ','Películas fotográficas en rollos, sensibilizadas, sin impresionar, perforadas, para fotografía en colores "policroma", de anchura > 16 mm pero <= 35 mm y de longitud > 30 m (exc. de papel, de cartón o de textiles, así como películas para diapositivas y pe',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370256,'Filmes para fotografia a cores, sensibilizados, não impressionados, de largura > 35 mm, em rolos','Photographic film, sensitised, in rolls, unexposed, with perforations, for colour photography polychrome, width > 35 mm (excl. that of paper, paperboard or textiles)','Películas fotográficas en rollos, sensibilizadas, sin impresionar, perforadas, para fotografía en colores "policroma", de anchura > 35 mm (exc. de papel, de cartón o de textiles)',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370291,'Outros filmes sensibilizados, não impressionados, de largura <= 16 mm, em rolos','Photographic film, sensitised, in rolls, unexposed, with perforations, for monochrome photography, width <= 16 mm (excl. of paper, paperboard or textiles)','Películas fotográficas en rollos, sensibilizadas, sin impresionar, perforadas, para fotografía en blanco y negro, de anchura <= 16 mm (exc. de papel, de cartón o de textiles)',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370292,'outros filmes sensib.n/impress.l<=16mm, c>14m, em rolos','other films sensitized unexpos.w<=16mm, l>14m, in rolls','las dem.películas sensib.s/impr.a<=16mm, l>14m, en rollos',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370293,'Outros filmes, sensibilizados, não impressionados, de largura > 16 mm, mas <= 35 mm, e comprimento <= 30 m, em rolos','Photographic film, sensitised, in rolls, unexposed, with perforations, for monochrome photography, width > 16 mm but <= 35 mm, length <= 30 m (excl. of paper, paperboard and textiles; X-ray film and instant print roll film)','Películas fotográficas en rollos, sensibilizadas, sin impresionar, perforadas, para fotografía en blanco y negro, de anchura > 16 mm pero <= 35 mm y de longitud <= 30 m (exc. de papel, de cartón o de textiles, así como películas para rayos X y películas a',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370294,'Outros filmes, sensibilizados, não impressionados, de largura > 16 mm, mas <= 35 mm, e comprimento > 30 m, em rolos','Photographic film, sensitised, in rolls, unexposed, with perforations, for monochrome photography, width > 16 mm but <= 35 mm, length > 30 m (excl. of paper, paperboard and textiles; X-ray film and instant print roll film)','Películas fotográficas en rollos, sensibilizadas, sin impresionar, perforadas, para fotografía en blanco y negro, de anchura > 16 mm pero <= 35 mm y de longitud > 30 m (exc. de papel, de cartón o de textiles, así como películas para rayos X y películas au',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370295,'Outros filmes, sensibilizados, não impressionados, de largura > 35 mm, em rolos','Photographic film, sensitised, in rolls, unexposed, with perforations, for monochrome photography, width > 35 mm (excl. that of paper, paperboard or textiles, X-ray film, microfilm and film for the graphic arts)','Películas fotográficas en rollos, sensibilizadas, sin impresionar, perforadas, para fotografía en blanco y negro, de anchura > 35 mm (exc. de papel, de cartón o de textiles, así como películas para rayos X, microfilmes y películas para las artes gráficas)',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370296,'outros filmes sensib.n/impress.l<=35mm e comp<=30m','outros filmes sensib.n/impress.l<=35mm e comp<=30m','outros filmes sensib.n/impress.l<=35mm e comp<=30m',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370297,'outros filmes sensib.n/impress.l<=35mm e comp>30m','outros filmes sensib.n/impress.l<=35mm e comp>30m','outros filmes sensib.n/impress.l<=35mm e comp>30m',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370298,'outros filmes sensibilziados,nao impresso,largura >35mm','outros filmes sensibilziados,nao impresso,largura >35mm','outros filmes sensibilziados,nao impresso,largura >35mm',37,3702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370310,'Papel, cartões, têxteis, sensibilizados, não impressionados, em rolos de largura > 610 mm','Photographic paper, paperboard and textiles, sensitised, unexposed, in rolls > 610 mm wide','Papel, cartón y textiles, fotográficos, sensibilizados, sin impresionar, en rollos de anchura > 610 mm',37,3703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370320,'Outros papéis, cartões, têxteis, para fotografia a cores, sensibilizados, não impressionados','Photographic paper, paperboard and textiles, sensitised, unexposed, for colour photography polychrome (excl. products in rolls > 610 mm wide)','Papel, cartón y textiles, fotográficos, sensibilizados, sin impresionar, para fotografía en colores "policroma" (exc. en rollos de anchura > 610 mm)',37,3703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370390,'Outros papeis, cartões e têxteis fotográficos, sensibilizados, não impressionados','Photographic paper, paperboard and textiles, sensitised, unexposed, for monochrome photography (excl. products in rolls > 610 mm wide)','Papel, cartón y textiles, fotográficos, sensibilizados, sin impresionar, para fotografía en blanco y negro (exc. en rollos de anchura > 610 mm)',37,3703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370400,'Chapas, filmes, papéis, cartões e têxteis fotográficos, impressionados, mas não revelados','Photographic plates, film, paper, paperboard and textiles, exposed but not developed','Placas, películas, papel, cartón y textiles, fotográficos, impresionados pero sin revelar',37,3704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370510,'Chapas e filmes fotográficos, impressionados e revelados, para reprodução offset','Photographic plates and film, exposed and developed, for offset reproduction (excl. products made of paper, paperboard or textiles and ready-to-use plates)','Placas y películas, fotográficas, impresionadas y reveladas, para la reproducción offset (exc. de papel, de cartón o de textiles, así como las placas para la impresión listas para el uso)',37,3705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370520,'microfilmes impressionados e revelados','microfilms exposed and developed','microfilmes impresionados y revelados',37,3705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370590,'Outras chapas e filmes fotográficos, impressionados e revelados, exceto os cinematográficos','Photographic plates and film, exposed and developed (excl. products made of paper, paperboard or textiles, cinematographic film and film for offset reproduction)','Placas y películas, fotográficas, impresionadas y reveladas (exc. de papel, de cartón o de textiles, así como las películas cinematográficas "filmes", las películas para la reproducción offset y los microfilmes)',37,3705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370610,'Filmes cinematográficos impressionados e revelados, contendo ou não gravação de som ou contendo apenas gravação de som, de largura => 35 mm','Cinematographic film, exposed and developed, whether or not incorporating soundtrack or consisting only of soundtrack, width >= 35 mm','Películas cinematográficas "filmes", impresionadas y reveladas, con registro de sonido o sin él, o con registro de sonido solamente, de anchura >= 35 mm',37,3706);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370690,'Outros filmes cinematográficos impressionados e revelados, contendo ou não gravação de som ou contendo apenas gravação de som','Cinematographic film, exposed and developed, whether or not incorporating soundtrack or consisting only of soundtrack, width < 35 mm','Películas cinematográficas "filmes", impresionadas y reveladas, con registro de sonido o sin él, o con registro de sonido solamente, de anchura < 35 mm',37,3706);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370710,'Emulsões para sensibilização de superfícies para uso fotográfico','Sensitising emulsions for photographic uses','Emulsiones para sensibilizar de superficies, para usos fotográficos',37,3707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (370790,'Outras preparações químicas (fixadores, reveladores) para usos fotográficos, exceto vernizes, colas ou adesivos, dosados ou acondicionados para venda a retalho  ','Preparation of chemicals for photographic uses, incl. unmixed products put up in measured portions or put up for retail sale in a form ready for use (excl. varnishes, glues, adhesives and similar preparations, sensitising emulsions and salts and precious-','Preparaciones químicas para uso fotográfico y productos sin mezclar para uso fotográfico, dosificados o acondicionados para la venta al por menor para uso fotográfico y listos para su empleo (exc. barnices, colas, adhesivos y preparaciones simil., emulsio',37,3707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380110,'Grafita artificial','Artificial graphite (excl. retort graphite, retort carbon and goods of artificial graphite, incl. refractory materials based on artificial graphite)','Grafito artificial (exc. grafito de retorta o carbón de retorta, productos a base de grafito artificial, incl. manufacturas refractarias al fuego a base de grafito artificial)',38,3801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380120,'Grafita coloidal ou semicoloidal','Colloidal or semi-colloidal graphite','Grafito coloidal o semicoloidal',38,3801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380130,'Pastas carbonadas para eletrodos e pastas semelhantes para revestimento interior de fornos','Carbonaceous pastes for electrodes and similar pastes for furnace linings','Pastas carbonosas para electrodos y pastas simil. para el revestimiento interior de hornos',38,3801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380190,'Outras preparações à base de grafita ou de outros carbonos, em pasta, blocos, lamelas ou outros produtos intermediários','Preparations based on graphite or other carbon in the form of pastes, blocks, plates or other semi-manufactures (excl. carbonaceous pastes for electrodes and similar pastes for furnace linings)','Preparaciones a base de grafito u otros carbonos, en pasta, bloques, plaquitas u otras semimanufacturas (exc. pastas carbonosas para electrodos y pastas simil. para el revestimiento interior de hornos)',38,3801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380210,'Carvões ativados','Activated carbon (excl. medicaments or deodorant products for fridges, vehicles etc., put up for retail sale)','Carbón activado (exc. con el carácter de medicamento o acondicionados para la venta al por menor como desodorantes para refrigeradores, vehículos, etc.)',38,3802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380290,'Outras matérias minerais naturais ativadas; negros de origem animal','Activated kieselguhr and other activated natural mineral products; animal black, whether or not spent (excl. activated carbon, calcinated diatomite without the addition of sintering agents and activated chemical products)','"Kieselguhr" activado y demás materias minerales naturales activadas; negro de origen animal, incl. el agotado (exc. carbón activado, diatomita calcinada sin la presencia de productos sinterizantes y productos químicos activados)',38,3802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380300,'Tall-oil mesmo refinado','Tall oil, whether or not refined','"Tall oil", incl. refinado',38,3803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380400,'Lixívias residuais da fabricação de pasta de celulose, incluídos os lignossulfonatos','Residual lyes from the manufacture of wood pulp, whether or not concentrated, desugared or chemically treated, incl. lignin sulphonates (excl. crude tall oil, sodium hydroxide caustic soda and sulphate pitch)','Lejías residuales de la fabricación de pastas de celulosa, aunque estén concentradas, desazucaradas o tratadas químicamente, incl. los lignosulfonatos (exc. "tall oil", sosa cáustica y pez de sulfato "pez de «tall oil»")',38,3804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380510,'Essências de terebintina, de pinheiro ou da pasta de papel ao sulfato','Gum, wood or sulphate turpentine oils','Esencia de trementina, de madera de pino o de pasta celulósica al sulfato "sulfato de trementina"',38,3805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380520,'oleo de pinho','pine oil','aceite de pino',38,3805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380590,'Outras essências terpênicas da destilação ou do tratamento de madeiras','Crude dipentene; sulphate turpentine and other crude para-cymene; terpenic oils produced by the distillation or other treatment of coniferous woods (excl. gum turpentine, wood turpentine and sulphate turpentine)','Dipenteno en bruto; esencia de pasta celulósica al bisulfito "bisulfito de trementina" y demás paracimenos en bruto; esencias terpénicas procedentes de la destilación o de demás tratamientos de la madera de coníferas (exc. esencia de trementina, de madera',38,3805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380610,'Colofônias e ácidos resínicos','Rosin and resin acids','Colofonia y ácidos resínicos',38,3806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380620,'Sais de colofônias, de ácidos resínicos ou de seus derivados','Salts of rosin, of resin acids or of derivatives of rosin or resin acids (excl. salts of rosin adducts)','Sales de colofonias, de ácidos resínicos o de derivados de colofonias o de ácidos resínicos (exc. sales de aductos de colofonias)',38,3806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380630,'Gomas ésteres (gomas fundidas)','Ester gums','Gomas éster',38,3806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380690,'Outras essências e derivados de colofônias ou de ácidos resínicos e óleos de colofônia','Derivatives of rosin, incl. salts of rosin adducts, and of resin acids, light and heavy resin oils and modified natural resins obtained by heat treatment run gums (excl. salts of rosin, of resin acids or salts of derivatives of rosin or resin acids, and e','Derivados de colofonia, incl. las sales de aductos de colofonias, o de ácidos resínicos; esencia y aceite de colofonia; gomas fundidas (exc. sales de colofonias, sales de ácidos resínicos, sales de derivados de colofonias y sales de derivados de ácidos re',38,3806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380700,'Alcatrões de madeira; óleos de alcatrão de madeira; creosoto de madeira; metileno; breu vegetal','Wood tar; wood tar oils; wood creosote; wood naphtha; vegetable pitch; brewer''s pitch and similar preparations based on rosin, resin acids or vegetable pitch (excl. Burgundy pitch, yellow pitch, stearin pitch, fatty acid pitch, fatty tar and glycerin pit','Alquitranes de madera; aceites de alquitrán de madera; creosota de madera; metileno "nafta de madera"; pez vegetal; pez de cervecería y preparaciones simil. a base de colofonia, de ácidos resínicos o de pez vegetal',38,3807);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380810,'Inseticidas','Insecticides','Insecticidas',38,3808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380820,'Fungicidas','Fungicides','Fungicidas',38,3808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380830,'Herbicidas, inibidores de germinação e reguladores de crescimento para plantas','Herbicides, anti-sprouting products and plant-growth regulators','Herbicidas, inhibidores de germinación y reguladores del crecimiento de las plantas',38,3808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380840,'Desinfetantes','Disinfectants','Desinfectantes',38,3808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380850,'Mercaderias contendo uma ou várias das substâncias mencionadas na Nota 1 do Capítulo 38 (aldrin; binapacril; canfecloro; captafol; clordano; clordimeforme; clorobenzilato; compostos de mercúrio; DDT; p-clorofeniletano; dibrometo de etileno; dicloreto de e','Goods containing one or more of aldrin ISO, binapacryl ISO, camphechlor ISO toxaphene, captafol ISO, chlordane ISO, chlordimeform ISO, chlorobenzilate ISO, DDT ISO clofenotane INN, 1,1,1-trichloro-2,2-bisp-chlorophenylethane], dieldrin ISO INN, dinoseb IS','Productos mencionados en la Nota 1 de subpartida de este Capítulo',38,3808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380890,'Raticidas, outros produtos semelhantes','Rodenticides, other similar products','Los raticidas, otros productos similares',38,3808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380891,'Inseticidas','Insecticides','Insecticidas',38,3808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380892,'Fungicidas','Fungicides','Fungicidas',38,3808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380893,'Herbicidas, inibidores de germinação e reguladores de crescimento para plantas','Herbicides, anti-sprouting products and plant-growth regulators','Herbicidas, inhibidores de germinación y reguladores del crecimiento de las plantas',38,3808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380894,'Desinfetantes','Disinfectants','Desinfectantes',38,3808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380899,'Rodenticidas, acaricidas, nematicidas, raticidas e produtos semelhantes','Rodenticides and other plant protection products put up for retail sale or as preparations or articles (excl. insecticides, fungicides, herbicides, disinfectants, and goods of subheading 3808.50.00)','Antiroedores y otros productos fitosanitarios, presentados en formas o embalajes de venta al por menor o en estado de preparaciones o en forma de artículos (exc. insecticidas, fungicidas, herbicidas, desinfectantes así como mercancías del nº 3808.50.00)',38,3808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380910,'Preparações à base de matérias amiláceas','Finishing agents, dye carriers to accelerate the dyeing or fixing of dyestuffs and other products and preparations such as dressings and mordants of a kind used in the textile, paper, leather or like industries, n.e.s., based on starch or derivatives ther','Aprestos y productos de acabado, aceleradores de tintura o de fijación de materias colorantes y demás productos y preparaciones "p.ej. aprestos y mordientes", de los tipos utilizados en la industria textil, del papel, del cuero o industrias simil., n.c.o.',38,3809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380991,'Outros agentes de apresto ou acabamento, aceleradores de tingimento ou de fixação e outros produtos para a indústria têxtil ou indústrias similares','Finishing agents, dye carriers to accelerate the dyeing or fixing of dyestuffs, and other products and preparations, e.g. dressings and mordants of a kind used in the textile or similar industries, n.e.s. (excl. those with a basis of amylaceous substances','Aprestos y productos de acabado, aceleradores de tintura o de fijación de materias colorantes y demás productos y preparaciones "p.ej. aprestos y mordientes", de los tipos utilizados en la industria textil o industrias simil., n.c.o.p. (exc. a base de mat',38,3809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380992,'Outros agentes de apresto ou acabamento para a indústria do papel','Finishing agents, dye carriers to accelerate the dyeing or fixing of dyestuffs, and other products and preparations, e.g. dressings and mordants of a kind used in the paper or similar industries, n.e.s. (excl. those with a basis of amylaceous substances)','Aprestos y productos de acabado, aceleradores de tintura o de fijación de materias colorantes y demás productos y preparaciones "p.ej. aprestos y mordientes", de los tipos utilizados en la industria del papel o industrias simil., n.c.o.p. (exc. a base de ',38,3809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (380993,'Outros agentes de apresto ou acabamento para a indústria do couro','Finishing agents, dye carriers to accelerate the dyeing or fixing of dyestuffs, and other products and preparations, e.g. dressings and mordants of a kind used in the leather or similar industries, n.e.s. (excl. those with a basis of amylaceous substances','Aprestos y productos de acabado, aceleradores de tintura o de fijación de materias colorantes y demás productos y preparaciones "p.ej. aprestos y mordientes", de los tipos utilizados en la industria del cuero o industrias simil., n.c.o.p. (exc. a base de ',38,3809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381010,'Preparações para decapagem de metais; pastas e pós para soldar, constituídos por metal e outras matérias','Pickling preparations for metal surfaces; soldering, brazing or welding pastes and powders consisting of metal and other materials','Preparaciones para el decapado de metal; pastas y polvos para soldar, constituidos por metal y otros productos',38,3810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381090,'Outros fluxos e preparações auxiliares para enchimento ou revestimento de eletrodos ou varetas, para soldar','Fluxes and other auxiliary preparations for soldering, brazing or welding; preparations of a kind used as cores or coatings for welding electrodes or rods (excl. soldering, brazing or welding powders and pastes consisting of metal and other materials, and','Flujos desoxidantes y demás preparaciones auxiliares para soldar metal; preparaciones de los tipos utilizados para recubrir o rellenar electrodos o varillas de soldadura (exc. pastas y polvos para soldar, constituidos por metal u otros productos, así como',38,3810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381111,'Preparações antidetonantes para combustíveis à base de compostos de chumbo','Anti-knock preparations for motor fuels based on lead compounds','Preparaciones antidetonantes para gasolina, a base de compuestos de plomo',38,3811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381119,'Outras preparações antidetonantes para combustíveis','Anti-knock preparations for motor fuels (excl. those based on lead compounds)','Preparaciones antidetonantes para gasolina (exc. a base de compuestos de plomo)',38,3811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381121,'Aditivos contendo óleo de petróleo ou de minerais betuminosos, para óleos lubrificantes','Prepared additives for oil lubricants containing petroleum oil or bituminous mineral oil','Aditivos para aceites lubricantes, que contengan aceites de petróleo o de mineral bituminoso',38,3811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381129,'Outros aditivos para óleos lubrificantes','Prepared additives for oil lubricants not containing petroleum oil or bituminous mineral oil','Aditivos para aceites lubricantes, que no contengan aceites de petróleo o de mineral bituminoso',38,3811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381190,'Outros aditivos preparados, para óleos minerais ou para outros líquidos com fins semelhantes','Oxidation inhibitors, gum inhibitors, viscosity improvers, anti-corrosive preparations and other prepared additives for mineral oils, incl. gasoline, or for other liquids used for the same purposes as mineral oils (excl. anti-knock preparations and oil lu','Inhibidores de oxidación, aditivos peptizantes, mejoradores de viscosidad, anticorrosivos y demás aditivos preparados para aceites minerales, incl. la gasolina u otros líquidos utilizados para los mismos fines que los aceites minerales (exc. preparaciones',38,3811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381210,'Preparações denominadas aceleradores de vulcanização','Prepared rubber accelerators','Aceleradores de vulcanización preparados',38,3812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381220,'Plastificantes compostos para borracha ou plástico','Compound plasticisers for rubber or plastics, n.e.s.','Plastificantes compuestos para caucho o plástico, n.c.o.p.',38,3812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381230,'Preparações antioxidantes e outros estabilizadores compostos, para borracha ou plástico','Anti-oxidising preparations and other compound stabilisers for rubber or plastics','Preparaciones antioxidantes y demás estabilizantes compuestos para caucho o plástico',38,3812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381300,'Composições e cargas para aparelhos extintores; granadas e bombas extintoras','Preparations and charges for fire-extinguishers; charged fire-extinguishing grenades (excl. full or empty fire-extinguishing devices, whether or not portable, unmixed chemically undefined products with fire-extinguishing properties in other forms)','Preparaciones y cargas para aparatos extintores; granadas y bombas extintoras (exc. aparatos extintores, incl. portátiles, cargados o no y productos químicos, de composición definida, sin mezclar, con propiedades extintoras y presentados aisladamente sin ',38,3813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381400,'Solventes e diluentes orgânicos compostos; preparações para remover tintas ou vernizes','Organic composite solvents and thinners, n.e.s.; prepared paint or varnish removers (excl. nail varnish remover)','Disolventes y diluyentes orgánicos compuestos, n.c.o.p.; preparaciones para quitar pinturas o barnices (exc. disolventes para barnices de uñas)',38,3814);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381511,'Catalisador em suporte, tendo como substância ativa o níquel ou um composto de níquel','Supported catalysts with nickel or a nickel compound as the active substance, n.e.s.','Catalizadores sobre soporte, con níquel o sus compuestos como sustancia activa, n.c.o.p.',38,3815);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381512,'Catalisador em suporte, tendo como substância ativa um metal precioso ou um composto de metal precioso','Supported catalysts with precious metal or a precious-metal compound as the active substance, n.e.s.','Catalizadores sobre soporte, con metal precioso o sus compuestos como sustancia activa, n.c.o.p.',38,3815);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381519,'Outros catalisadores em suporte','Supported catalysts, n.e.s. (excl. with precious metal, a precious-metal compound, nickel or a nickel compound as the active substance)','Catalizadores sobre soporte, n.c.o.p. (exc. con níquel o sus compuestos o con metal precioso o sus compuestos como sustancia activa)',38,3815);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381590,'Outras preparações catalíticas','Reaction initiators, reaction accelerators and catalytic preparations, n.e.s. (excl. rubber accelerators and supported catalysts)','Iniciadores y aceleradores de reacción y preparaciones catalíticas, n.c.o.p. (exc. aceleradores de vulcanización y catalizadores sobre soporte)',38,3815);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381600,'Cimentos, argamassas, concretos e composições semelhantes, refratários','Refractory cements, mortars, concretes and similar compositions (excl. preparations based on graphite or other carbonaceous substances)','Cementos, morteros, hormigones y preparaciones simil., refractarias (exc. preparaciones a base de grafito u otros carbonos)',38,3816);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381700,'Misturas de alquilbenzenos ou alquilnaftalenos, exceto as das posições 2707 ou 2902','Mixed alkylbenzenes and mixed alkylnaphthalenes produced by the alkylation of benzene and naphthalene (excl. mixed isomers of cyclic hydrocarbons)','Mezclas de alquilbencenos y mezclas de alquilnaftalenos, obtenidas por alquilación del benceno y del naftaleno (exc. mezclas de isómeros de hidrocarburos cíclicos)',38,3817);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381710,'misturas de alquilbenzenos','mixed alkylbenzenes','mezclas de alquilbencenos',38,3817);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381720,'misturas de alquilnaftalenos','mixed alkylnaphthalene','mezclas de alquilnaftalenos',38,3817);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381800,'Elementos químicos impurificados, para utilização eletrônica','Chemical elements and compounds doped for use in electronics, in the form of discs, wafers, cylinders, rods or similar forms, or cut into discs, wafers or similar forms, whether or not polished or with a uniform epitaxial coating (excl. elements that have','Elementos químicos y compuestos químicos, dopados para uso en electrónica, en discos, discos "wafers", plaquitas, cilindros, barras o formas simil. o cortados en discos, plaquitas o formas simil., incl. pulidos o recubiertos con una capa epitaxial uniform',38,3818);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (381900,'Líquidos para freios hidráulicos ou líquidos para transmissões hidráulicas, contendo óleos petróleo em proporção <= 70%, em peso','Hydraulic brake fluids and other prepared liquids for hydraulic transmission not containing petroleum oil or bituminous mineral oil, or containing < 70% petroleum oil or bituminous mineral oil by weight','Líquidos para frenos hidráulicos y demás líquidos preparados para transmisiones hidráulicas, sin aceites de petróleo ni de mineral bituminoso o con un contenido de dichos aceites < 70% en peso',38,3819);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382000,'Preparações anticongelantes e líquidos preparados para descongelação','Anti-freezing preparations and prepared de-icing fluids (excl. prepared additives for mineral oils or other liquids used for the same purposes as mineral oils)','Preparaciones anticongelantes y líquidos preparados para descongelar (exc. aditivos preparados para aceites minerales o para otros líquidos utilizados para los mismos fines que los aceites minerales)',38,3820);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382100,'Meios de cultura preparados para o desenvolvimento de microrganismos ou de células vegetais, humanas ou animais','Prepared culture media for the development or maintenance of micro-organisms incl. viruses and the like or of plant, human or animal cells','Medios de cultivo preparados para el desarrollo de microorganismos',38,3821);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382200,'Reagentes de diagnóstico ou de laboratório, em qualquer suporte ou preparados, exceto os das posições 3002 ou 3006; materiais de referência certificados','Diagnostic or laboratory reagents on a backing, prepared diagnostic or laboratory reagents whether or not on a backing, and certified reference materials (excl. compound diagnostic reagents designed to be administered to the patient, blood-grouping reagen','Reactivos de diagnóstico o de laboratorio sobre cualquier soporte y reactivos de diagnóstico o de laboratorio preparados, incl. sobre soporte; materiales de referencia certificados (exc. reactivos compuestos de diagnóstico concebidos para usar en el pacie',38,3822);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382311,'Ácido esteárico (ácido graxo monocarboxílico industrial)','Stearic acid, industrial','Ácido esteárico, industrial',38,3823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382312,'Ácido oléico (ácido graxo monocarboxílico industrial)','Oleic acid, industrial','Ácido oleico, industrial',38,3823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382313,'Ácido graxo (gordo) do tall oil','Tall oil fatty acids, industrial','Ácidos grasos del "tall-oil", industriales',38,3823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382319,'Outros ácidos graxos monocarboxílicos industriais e óleos ácidos de refinação','Fatty acids, industrial, monocarboxylic; acid oils from refining (excl. stearic acid, oleic acid and tall oil fatty acids)','Ácidos grasos monocarboxílicos industriales; aceites ácidos del refinado (exc. ácido esteárico, ácido oleico y ácidos grasos del "tall oil")',38,3823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382370,'Outros álcoois graxos (gordos) industriais','Fatty alcohols, industrial','Alcoholes grasos industriales',38,3823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382410,'Aglutinantes preparados para moldes ou núcleos de fundição','Prepared binders for foundry moulds or cores','Preparaciones aglutinantes para moldes o núcleos de fundición',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382420,'Ácido naftênico e seus ésteres; sais dos ácidos naftênicos','Naphthenic acid and their esters, salts of naphthenic acids','Ácido nafténico y sus ésteres, sales de ácidos nafténicos',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382430,'Carbonetos metálicos não aglomerados misturados entre si ou com aglutinantes metálicos','Non-agglomerated metal carbides mixed together or with metallic binders','Carburos metálicos, sin aglomerar, mezclados entre sí o con aglutinantes metálicos',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382440,'Aditivos preparados para cimentos, argamassas ou concretos','Prepared additives for cements, mortars or concretes','Aditivos preparados para cementos, morteros u hormigones',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382450,'Argamassas e concretos, não refratários','Non-refractory mortars and concretes','Morteros y hormigones, no refractarios',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382460,'Sorbitol, exceto o poliálcool D-glucitol','Sorbitol (excl. D-glucitol [sorbitol])','Sorbitol (exc. D-glucitol "sorbitol")',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382471,'Misturas contendo clorofluorcarbonetos (CFC), mesmo que contenham hidroclorofluorcarbonetos (HCFC), perfluorcarbonetos (PFC) ou hidrofluorcarbonetos (HFC)','Mixtures containing chlorofluorocarbons CFCs, whether or not containing hydrochlorofluorocarbons HCFCs, perfluorocarbons PFCs or hydrofluorocarbons HFCs','Mezclas que contengan hidrocarburos acíclicos perhalogenados únicamente con flúor y cloro',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382472,'Misturas contendo bromoclorodifluormetano, bromotrifluormetano ou dibromotetrafluoretanos','Mixtures containing bromochlorodifluoromethane, bromotrifluoromethane or dibromotetrafluoroethanes','Mezclas que contengan bromoclorodifluorometano, bromotrifluorometano o dibromotetrafluoroetanos',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382473,'Misturas contendo hidrobromofluorcarbonetos (HBFC)','Mixtures containing hydrobromofluorocarbons HBFCs','Mezclas que contengan hidrobromofluorocarburos (HBFC)',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382474,'Misturas contendo hidroclorofluorcarbonetos (HCFC), mesmo que contenham perfluorcarbonetos (PFC) ou hidrofluorcarbonetos (HFC), mas que não contenham clorofluorcarbonetos (CFC)','Mixtures containing hydrochlorofluorocarbons HCFCs, whether or not containing perfluorocarbons PFCs or hydrofluorocarbons HFCs, but not containing chlorofluorocarbons CFCs','Mezclas que contengan hidroclorofluorocarburos (HCFC), incluso con perfluorocarburos (PFC) o hidrofluorocarburos (HFC), pero que no contengan clorofluorocarburos (CFC)',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382475,'Misturas contendo tetracloreto de carbono','Mixtures containing carbon tetrachloride','Mezclas que contengan Tetracloruro de carbono',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382476,'Misturas contendo 1, 1, 1-tricloroetano (metilclorofórmio)','Mixtures containing 1,1,1-trichloroethane methyl chloroform','Mezclas que contengan 1,1,1tricloroetano (metilcloroformo)',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382477,'Misturas contendo bromometano (brometo de metila) ou bromoclorometano','Mixtures containing bromomethane methyl bromide or bromochloromethane','Mezclas que contengan bromometano (bromuro de metilo) o bromoclorometano',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382478,'Misturas contendo perfluorcarbonetos (PFC) ou hidrofluorcarbonetos (HFC), mas que não contenham clorofluorcarbonetos (CFC) ou hidroclorofluorcarbonetos (HCFC)','Mixtures containing perfluorocarbons PFCs or hydrofluorocarbons HFCs, but not containing chlorofluorocarbons CFCs or hydrochlorofluorocarbons HCFCs','Mezclas que contengan perfluorocarburos (PFC) o hidrofluorocarburos (HFC), pero que no contengan clorofluorocarburos (CFC) o hidroclorofluorocarburos (HCFC)',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382479,'Outras misturas contendo derivados halogenados do metano, do etano ou do propano','Mixtures containing halogenated derivatives of methane, ethane or propane (excl. those of subheadings 3824.71.00 to 3824.78.00)','Mezclas que contengan derivados perhalogenados de hidrocarburos acíclicos con dos halógenos diferentes, por lo menos (exc. únicamente con flúor y cloro)',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382481,'Misturas e preparações contendo oxirano (óxido de etileno)','Mixtures and preparations containing oxirane ethylene oxide','Mezclas que contengan oxirano (óxido de etileno)',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382482,'Misturas contendo polibromobifenilas (PBB), policloroterfenilas (PCT) ou policlorobifenilas (PCB)','Mixtures and preparations containing polychlorinated biphenyls PCBs, polychlorinated terphenyls PCTs or polybrominated biphenyls PBBs','Mezclas que contengan bifenilos policlorados (PCB), terfenilos policlorados (PCT) o bifenilos polibromados (PBB)',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382483,'Misturas contendo fosfato de tris (2, 3-dibromopropila)','Mixtures and preparations containing tris2,3-dibromopropyl phosphate','Mezclas que contengan Fosfato de tris(2,3dibromopropilo)',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382490,'Outros produtos e preparações das indústrias químicas e conexas não incluídos em outras posições','Chemical products and preparations of the chemical or allied industries, incl. those consisting of mixtures of natural products, n.e.s.','Productos químicos y preparaciones de la industria química o de las industrias conexas, incl. las mezclas de productos naturales, n.c.o.p.',38,3824);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382510,'Lixos municipais','Municipal waste','Desechos y desperdicios municipales',38,3825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382520,'Lamas de tratamento de esgotos','Sewage sludge','Lodos de depuración',38,3825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382530,'Lixos clínicos','Clinical waste','Desechos clínicos',38,3825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382541,'Resíduos halogenados de solventes orgânicos','Waste organic solvents, halogenated','Desechos de disolventes orgánicos, halogenados',38,3825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382549,'Outros resíduos de solventes orgânicos','Waste organic solvents, non-halogenated','Desechos de disolventes orgánicos, no halogenados',38,3825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382550,'Resíduos de soluções desoxidantes para metais, de fluidos hidráulicos, de fluidos para freios e de líquidos anticongelantes','Wastes of metal pickling liquors, of hydraulic fluids, brake fluids and anti-freeze fluids','Desechos de soluciones decapantes, fluidos hidráulicos, líquidos para frenos y líquidos anticongelantes',38,3825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382561,'Outros resíduos das indústrias químicas ou das indústrias conexas, contendo principalmente constituintes orgânicos','Wastes from chemical or allied industries, mainly containing organic constituents (excl. anti-freeze fluids)','Desechos de la industria química o de las industrias conexas, que contengan principalmente componentes orgánicos (exc. líquidos anticongelantes)',38,3825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382569,'Outros resíduos das industrias químicas ou das indústrias conexas','Wastes from chemical or allied industries (excl. wastes of metal pickling liquors, of hydraulic fluids, brake fluids and anti-freeze fluids and those mainly containing organic constituents)','Desechos de la industria química o de las industrias conexas (exc. desechos de soluciones decapantes, fluidos hidráulicos, líquidos para frenos y líquidos anticongelantes; desechos que contengan principalmente componentes orgánicos)',38,3825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382590,'Outros produtos residuais das indústrias químicas ou das indústrias conexas não especificados','Residual products of the chemical or allied industries, n.e.s. (excl. waste)','Productos residuales de la industria química o de las industrias conexas, n.c.o.p. (exc. desechos)',38,3825);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (382600,'biodiesel e suas misturas,c/>70% peso de pet.ou min.bet','biodiesel e suas misturas,c/>70% peso de pet.ou min.bet','biodiesel e suas misturas,c/>70% peso de pet.ou min.bet',38,3826);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390110,'Polietileno de densidade < 0,94, em forma primária','Polyethylene with a specific gravity of < 0,94, in primary forms','Polietileno de densidad < 0,94, en formas primarias',39,3901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390120,'Polietileno de densidade => 0,94, em forma primária','Polyethylene with a specific gravity of >= 0,94, in primary forms','Polietileno de densidad >= 0,94, en formas primarias',39,3901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390130,'Copolímeros de etileno e acetato vinila, em formas primárias','Ethylene-vinyl acetate copolymers, in primary forms','Copolímeros de etileno y acetato de vinilo, en formas primarias',39,3901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390190,'Outros polímeros de etileno, em formas primárias','Polymers of ethylene, in primary forms (excl. polyethylene and ethylene-vinyl acetate copolymers)','Polímeros de etileno, en formas primarias (exc. polietileno y copolímeros de etileno y acetato de vinilo)',39,3901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390210,'Polipropileno, em forma primária','Polypropylene, in primary forms','Polipropileno, en formas primarias',39,3902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390220,'Polisobutileno, em forma primária','Polyisobutylene, in primary forms','Poliisobutileno, en formas primarias',39,3902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390230,'Copolímeros de propileno, em formas primárias','Propylene copolymers, in primary forms','Copolímeros de propileno, en formas primarias',39,3902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390290,'Outros polímeros de propileno ou de outras olefinas, em formas primárias','Polymers of propylene or of other olefins, in primary forms (excl. polypropylene, polyisobutylene and propylene copolymers)','Polímeros de propileno o de otras olefinas, en formas primarias (exc. polipropileno, poliisobutileno y copolímeros de propileno)',39,3902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390311,'Poliestireno expansível, em forma primária','Expansible polystyrene, in primary forms','Poliestireno, en formas primarias, expandible',39,3903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390319,'Outros poliestirenos, em formas primárias','Polystyrene, in primary forms (excl. expansible)','Poliestireno, en formas primarias (exc. expandible)',39,3903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390320,'Copolímeros de estireno-acrilonitrila, em formas primárias','Styrene-acrylonitrile copolymers SAN, in primary forms','Copolímeros de estireno-acrilonitrilo "SAN", en formas primarias',39,3903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390330,'Copolímeros de acrilonitrila-butadieno-estireno','Acrylonitrile-butadiene-styrene copolymers ABS, in primary forms','Copolímeros de acrilonitrilo-butadieno-estireno "ABS", en formas primarias',39,3903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390390,'Outros polímeros de estireno, em formas primárias','Polymers of styrene, in primary forms (excl. polystyrene, styrene-acrylonitrile copolymers SAN and acrylonitrile-butadiene-styrene ABS)','Polímeros de estireno, en formas primarias (exc. poliestireno, copolímeros de estireno-acrilonitrilo "SAN" y copolímeros de acrilonitrilo-butadieno-estireno "ABS")',39,3903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390410,'Policloreto de vinila, não misturado com outras substâncias, forma primária','Polyvinyl chloride, in primary forms, not mixed with any other substances','Poli"cloruro de vinilo", en formas primarias, sin mezclar con otras sustancias',39,3904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390421,'Policloreto de vinila, não plastificado, em forma primária','Non-plasticised polyvinyl chloride, in primary forms, mixed with other substances','Poli"cloruro de vinilo", en formas primarias, mezclado con otras sustancias, sin plastificar',39,3904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390422,'Policloreto de vinila, plastificado, em forma primária','Plasticised polyvinyl chloride, in primary forms, mixed with other substances','Poli"cloruro de vinilo", en formas primarias, mezclado con otras sustancias, plastificado',39,3904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390430,'Copolímeros de cloreto de vinila e acetato de vinila, formas primárias','Vinyl chloride-vinyl acetate copolymers, in primary forms','Copolímeros de cloruro de vinilo y acetato de vinilo, en formas primarias',39,3904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390440,'Outros copolímeros de cloreto de vinila, formas primárias','Vinyl chloride copolymers, in primary forms (excl. vinyl chloride-vinyl acetate copolymers)','Copolímeros de cloruro de vinilo, en formas primarias (exc. copolímeros de vinilo y acetato de vinilo)',39,3904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390450,'Polímeros de cloreto vinilideno, formas primárias','Vinylidene chloride polymers, in primary forms','Polímeros de cloruro de vinilideno, en formas primarias',39,3904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390461,'Politetrafluoretileno, em forma primária','Polytetrafluoroethylene, in primary forms','Politetrafluoroetileno, en formas primarias',39,3904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390469,'Outros polímeros fluorados, em formas primárias','Fluoropolymers of vinyl chloride or of other halogenated olefins, in primary forms (excl. polytetrafluoroethylene)','Polímeros de cloruro de vinilo o de otras olefinas halogenadas, en formas primarias, fluorados (exc. politetrafluoroetileno)',39,3904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390490,'Outros polímeros de cloreto vinila ou olefinas halogenadas, formas primárias','Polymers of vinyl chloride or other halogenated olefins, in primary forms (excl. polyvinyl chloride, copolymers of vinyl chloride, polymers of vinyl chloride and fluoropolymers)','Polímeros de cloruro de vinilo o de otras olefinas halogenadas, en formas primarias (exc. poli"cloruro de vinilo", copolímeros de cloruro de vinilo, polímeros de cloruro de vinilideno y polímeros fluorados)',39,3904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390512,'Acetato de polivinila, em dispersão aquosa, em forma primária','Polyvinyl acetate, in aqueous dispersion','Poli"acetato de vinilo", en dispersión acuosa',39,3905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390519,'Outros polímeros de acetato de polivinila, formas primárias','Polyvinyl acetate, in primary forms (excl. in aqueous dispersion)','Poli"acetato de vinilo", en formas primarias (exc. en dispersión acuosa)',39,3905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390521,'Copolímeros de acetato de vinila, em dispersão aquosa','Vinyl acetate copolymers, in aqueous dispersion','Copolímeros de acetato de vinilo, en dispersión acuosa',39,3905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390529,'Outros copolímeros de acetato de vinila, formas primárias','Vinyl acetate copolymers, in primary forms (excl. in aqueous dispersion)','Copolímeros de acetato de vinilo, en formas primarias (exc. en dispersión acuosa)',39,3905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390530,'Álcool polivinílico, mesmo contendo grupos acetato não hidrolisados, em forma primária','Polyvinyl alcohol, in primary forms, whether or not containing unhydrolyzed acetate groups','Poli"alcohol vinílico", incl. con grupos acetato sin hidrolizar, en formas primarias',39,3905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390591,'Outros copolímeros de vinila, em formas primárias','Copolymers of vinyl, in primary forms (excl. vinyl chloride-vinyl acetate copolymers and other vinyl chloride copolymers, and vinyl acetate copolymers)','Copolímeros de vinilo, en formas primarias (exc. copolímeros de cloruro de vinilo y acetato de vinilo, copolímeros del cloruro de vinilo y copolímeros del acetato de vinilo)',39,3905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390599,'Outros polímeros de ésteres de vinila e outros polímeros de vinila, em formas primárias','Polymers of vinyl esters and other vinyl polymers, in primary forms (excl. those of vinyl chloride or other halogenated olefins, polyvinyl acetate, vinyl acetate copolymers and polyvinyl alcohol, whether or not containing unhydrolised acetate groups)','Polímeros de ésteres vinílicos y demás polímeros vinílicos, en formas primarias (exc. polímeros del cloruro de vinilo o de otras olefinas halogenadas, poli"acetato de vinilo", copolímeros del acetato de vinilo y poli"alcohol vinílico", incl. con grupos ac',39,3905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390610,'Polimetacrilato de metila, em forma primária','Polymethyl methacrylate, in primary forms','Poli"metacrilato de metilo", en formas primarias',39,3906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390690,'Outros polímeros acrílicos, em formas primárias','Acrylic polymers, in primary forms (excl. polymethyl methacrylate)','Polímeros acrílicos, en formas primarias (exc. poli"metacrilato de metilo")',39,3906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390710,'Poliacetais, em formas primárias','Polyacetals, in primary forms','Poliacetales, en formas primarias',39,3907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390720,'Outros poliéteres, em formas primárias','Polyethers, in primary forms (excl. polyacetals)','Poliéteres, en formas primarias (exc. poliacetales)',39,3907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390730,'Resinas epóxidas, em formas primárias','Epoxide resins, in primary forms','Resinas epoxi, en formas primarias',39,3907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390740,'Policarbonatos, em formas primárias','Polycarbonates, in primary forms','Policarbonatos, en formas primarias',39,3907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390750,'Resinas alquídicas, em formas primárias','Alkyd resins, in primary forms','Resinas alcídicas, en formas primarias',39,3907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390760,'Tereftalato de polietileno, em forma primária','Polyethylene terephthalate, in primary forms','Poli"tereftalato de etileno", en formas primarias',39,3907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390770,'Poli(ácido láctico)','Polylactic acid, in primary forms','Poli(ácido láctico)',39,3907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390791,'Outros poliésteres, não saturados, em formas primárias','Unsaturated polyallyl esters and other polyesters, in primary forms (excl. polycarbonates, alkyd resins, polyethylene terephthalate and polylactic acid)','Poliésteres alílicos y demás poliésteres, no saturados, en formas primarias (exc. plicarbonatos, resinas alcídas y poli"tereftalato de etileno")',39,3907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390799,'Outros poliésteres, em formas primárias','Saturated polyesters in primary forms (excl. polycarbonates, alkyd resins, polyethylene terephthalate and polylactic acid)','Poliésteres, saturados, en formas primarias (exc. plicarbonatos, resinas alcídas y poli"tereftalato de etileno")',39,3907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390810,'Poliamidas -6, -11, -12, -6,6, -6,9, -6,10, ou -6,12, em forma primária','Polyamides-6, -11, -12, -6,6, -6,9, -6,10 or -6,12, in primary forms','Poliamidas-6, -11, -12, -6,6, -6,9, -6,10, ó -6,12, en formas primarias',39,3908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390890,'Outras poliamidas, em formas primárias','Polyamides, in primary forms (excl. polyamides-6, -11, -12, -6,6, -6,9, -6,10 and -6,12)','Poliamidas, en formas primarias (exc. poliamidas-6, -11, -12, -6,6, -6,9, -6,10, ó -6,12)',39,3908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390910,'Resinas uréicas; resinas de tiouréia, em formas primárias','Urea resins and thiourea resins, in primary forms','Resinas ureicas y resinas de tiourea, en formas primarias',39,3909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390920,'Resinas melamínicas, em formas primárias','Melamine resins, in primary forms','Resinas melamínicas, en formas primarias',39,3909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390930,'Outras resinas amínicas, em formas primárias','Amino-resins, in primary forms (excl. urea resins, thiourea resins and melamine resins)','Resinas amínicas, en formas primarias (exc. resinas ureicas, resinas de tiourea y resinas melamínicas)',39,3909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390940,'Resinas fenólicas, em formas primárias','Phenolic resins, in primary forms','Resinas fenólicas, en formas primarias',39,3909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (390950,'Poliuretanos, em formas primárias','Polyurethanes, in primary forms','Poliuretanos, en formas primarias',39,3909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391000,'Silicones, em formas primárias','Silicones in primary forms','Siliconas, en formas primarias',39,3910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391110,'Resinas de petróleo, de cumarona, de indeno, de cumarona-indeno e politerpenos, em formas primárias','Petroleum resins, coumarone, indene or coumarone-indene resins and polyterpenes, in primary forms','Resinas de petróleo, resinas de cumarona, resinas de indeno, resinas de cumarona-indeno y politerpenos, en formas primarias',39,3911);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391190,'Outros politerpenos, polissulfetos, polissulfonas, em formas primárias','Polysulphides, polysulphones and other polymers and prepolymers produced by chemical synthesis, n.e.s., in primary forms','Polisulfuros, polisulfonas y demás polímeros y prepolímeros obtenidos por síntesis química, n.c.o.p., en formas primarias',39,3911);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391211,'Acetato de celulose, não plastificado, forma primária','Non-plasticised cellulose acetates, in primary forms','Acetatos de celulosa, sin plastificar, en formas primarias',39,3912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391212,'Acetato de celulose, plastificado, em forma primária','Plasticised cellulose acetates, in primary forms','Acetatos de celulosa, plastificados, en formas primarias',39,3912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391220,'Nitrato de celulose, em forma primária','Cellulose nitrates, incl. collodions, in primary forms','Nitratos de celulosa, incl. los colodiones, en formas primarias',39,3912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391231,'Carboximetilcelulose e seus sais, em formas primárias','Carboxymethylcellulose and its salts, in primary forms','Carboximetilcelulosa y sus sales, en formas primarias',39,3912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391239,'Outros éteres de celulose, em formas primárias','Cellulose ethers, in primary forms (excl. carboxymethylcellulose and its salts)','Éteres de celulosa, en formas primarias (exc. carboximetilcelulosa y sus sales)',39,3912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391290,'Outros celuloses e seus derivados químicos, em formas primárias','Cellulose and chemical derivatives thereof, n.e.s., in primary forms (excl. cellulose acetates, cellulose nitrates and cellulose ethers)','Celulosa y sus derivados químicos, n.c.o.p., en formas primarias (exc. acetatos de celulosa, nitratos de celulosa y éteres de celulosa)',39,3912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391310,'Ácido algínico, seus sais e ésteres, em forma primária','Alginic acid, its salts and esters, in primary forms','Ácido algínico, sus sales y sus ésteres, en formas primarias',39,3913);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391390,'Outros polímeros naturais, inclusive modificados, em formas primárias','Natural polymers and modified natural polymers, e.g. hardened proteins, chemical derivatives of natural rubber, n.e.s., in primary forms (excl. alginic acid and its salts and esters)','Polímeros naturales, así como proteínas endurecidas, derivados químicos del caucho natural y demás polímeros naturales modificados, n.c.o.p., en formas primarias (exc. ácido algínico, sus sales y sus ésteres)',39,3913);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391400,'Permutadores de íons à base de polímeros, em formas primárias','Ion-exchangers based on polymers of heading 3901 to 3913, in primary forms','Intercambiadores de iones a base de polímeros de las partidas 3901 a 3913, en formas primarias',39,3914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391510,'Desperdícios, resíduos e aparas, de polímeros de etileno','Waste, parings and scrap, of polymers of ethylene','Desechos, desperdicios y recortes, de polímeros de etileno',39,3915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391520,'Desperdícios, resíduos e aparas, de polímeros de estireno','Waste, parings and scrap, of polymers of styrene','Desechos, desperdicios y recortes, de polímeros de estireno',39,3915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391530,'Desperdícios, resíduos, e aparas de polímeros de cloreto de vinila','Waste, parings and scrap, of polymers of vinyl chloride','Desechos, desperdicios y recortes,, de polímeros de cloruro de vinilo',39,3915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391590,'Desperdícios, resíduos e aparas, de outros plásticos','Waste, parings and scrap of plastics (excl. that of polymers of ethylene, styrene and vinyl chloride)','Desechos, desperdicios y recortes, de plástico (exc. de polímeros de etileno, de polímeros de estireno y de polímeros de cloruro de vinilo)',39,3915);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391610,'Monofilamentos cuja maior dimensão do corte transversal seja > 1 mm, varas, bastões e perfis de polímeros de etileno, mesmo trabalhados à superfície','Monofilament of which any cross-sectional dimension > 1 mm, rods, sticks and profile shapes, of polymers of ethylene, whether or not surface-worked but not further worked','Monofilamentos cuya mayor dimensión del corte transversal sea > 1 mm, barras, varillas y perfiles, incl. trabajados en la superficie, pero sin otra labor, de polímeros de etileno',39,3916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391620,'Monofilamentos cuja maior dimensão do corte transversal seja > 1 mm, varas, bastões e perfis de polímeros de cloreto de vinila, mesmo trabalhados à superfície','Monofilament of which any cross-sectional dimension > 1 mm, rods, sticks and profile shapes, of polymers of vinyl chloride, whether or not surface-worked but not further worked','Monofilamentos cuya mayor dimensión del corte transversal sea > 1 mm, barras, varillas y perfiles, incl. trabajados en la superficie, pero sin otra labor, de polímeros de cloruro de vinilo',39,3916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391690,'Monofilamentos cuja maior dimensão do corte transversal seja > 1 mm, varas, bastões e perfis de polímeros de outros plásticos, mesmo trabalhados à superfície','Monofilament of which any cross-sectional dimension > 1 mm, rods, sticks and profile shapes, of plastics, whether or not surface worked but not further worked (excl. that of polymers of ethylene and vinyl chloride)','Monofilamentos cuya mayor dimensión del corte transversal sea > 1 mm, barras, varillas y perfiles, incl. trabajados en la superficie, pero sin otra labor, de plástico (exc. de polímeros de etileno y de polímeros de cloruro de vinilo)',39,3916);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391710,'Tripas artificiais de proteínas endurecidas ou de plásticos celulósicos','Artificial guts sausage casings of hardened protein or cellulose materials','Tripas artificiales de proteínas endurecidas o de plástico celulósico',39,3917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391721,'Tubos rígidos, de polímeros de etileno, inclusive com acessórios','Rigid tubes, pipes and hoses, of ethylene','Tubos rígidos, de polímeros de etileno, incl. con accesorios',39,3917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391722,'Tubos rígidos, de polímeros de propileno, inclusive com acessórios','Rigid tubes, pipes and hoses of polymers of propylene','Tubos rígidos, de polímeros de propileno, incl. con accesorios',39,3917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391723,'Tubos rígidos, de polímeros de cloreto de vinila, inclusive com acessórios','Rigid tubes, pipes and hoses, of polymers of vinyl chloride','Tubos rígidos, de polímeros de cloruro de vinilo, incl. con accesorios',39,3917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391729,'Tubos rígidos, de outros plásticos, inclusive com acessórios','Rigid tubes, pipes and hoses, of plastics (excl. tubes of polymers of ethylene, propylene and vinyl chloride)','Tubos rígidos, de plástico, incl. con accesorios (exc. de polímeros de etileno, de propileno y de cloruro de vinilo)',39,3917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391731,'Tubos flexíveis, de plásticos, para suportar pressão => 27,6 MPa, inclusive com acessórios','Flexible tubes, pipes and hoses, of plastics, burst pressure >= 27,6 MPa','Tubos flexibles, de plástico, para una presión >= 27,6 MPa, incl. con accesorios',39,3917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391732,'Outros tubos flexíveis de plástico, não reforçados, sem acessórios','Flexible tubes, pipes and hoses of plastics, not reinforced or otherwise combined with other materials, without fittings','Tubos flexibles, de plástico, sin reforzar ni combinar con otras materias, sin accesorios',39,3917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391733,'Tubos flexíveis de plásticos, não reforçados, com acessórios','Flexible tubes, pipes and hoses of plastics, not reinforced or otherwise combined with other materials, with fittings, seals or connectors','Tubos flexibles, de plástico, sin reforzar ni combinar con otras materias, con accesorios',39,3917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391739,'Outros tubos flexíveis de plástico, inclusive com acessórios','Flexible tubes, pipes and hoses, of plastics, reinforced or otherwise combined with other materials (excl. those with a burst pressure of >= 27,6 MPa)','Tubos flexibles, de plástico, reforzados o combinados con otras materias, incl. con accesorios (exc. tubos para una presión >= 27,6 MPa)',39,3917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391740,'Acessórios para tubos de plástico','Fittings, e.g. joints, elbows, flanges, of plastics, for tubes, pipes and hoses','Juntas, codos, empalmes "eacores" y demás accesorios de tubería, de plástico',39,3917);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391810,'Revestimentos de pavimentos, paredes ou tetos, de polímeros de cloreto vinila','Floor coverings, whether or not self-adhesive, in rolls or in the form of tiles, and wall or ceiling coverings in rolls with a width of >= 45 cm, consisting of a layer of plastics fixed permanently on a backing of any material other than paper, the face s','Revestimientos para suelos, incl. autoadhesivos, en rollos o losetas y revestimientos para paredes o techos, presentados en rollos de anchura >= 45 cm, con cara vista graneada, gofrada, coloreada con motivos impresos o decorada de otro modo y fijada perma',39,3918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391890,'Revestimentos de pavimentos, paredes ou tetos, de outros plásticos','Floor coverings of plastics, whether or not self-adhesive, in rolls or in the form of tiles, and wall or ceiling coverings in rolls with a width of >= 45 cm, consisting of a layer of plastics fixed permanently on a backing of any material other than paper','Revestimientos para suelos, incl. autoadhesivos, en rollos o losetas y revestimientos para paredes o techos, presentados en rollos de anchura >= 45 cm, con cara vista graneada, gofrada, coloreada con motivos impresos o decorada de otro modo y fijada perma',39,3918);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391910,'Chapas, folhas, tiras, fitas e outras formas planas, de plásticos, auto-adesivas, em rolos de largura <= 20 cm','Self-adhesive plates, sheets, film, foil, tape, strip and other flat shapes, of plastics, in rolls <= 20 cm wide','Láminas, cintas, tiras y demás formas planas, autoadhesivas, de plástico, en rollos de anchura <= 20 cm',39,3919);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (391990,'Chapas, folhas, tiras, fitas, películas e outras formas planas, de plásticos, auto-adesivas','Self-adhesive plates, sheets, film, foil, tape, strip and other flat shapes, of plastics, whether or not in rolls > 20 cm wide (excl. floor, wall and ceiling coverings of heading 3918)','Placas, láminas, hojas, cintas, tiras y demás formas planas, autoadhesivas, de plástico, incl. en rollos de anchura > 20 cm (exc. revestimientos para suelos, paredes o techos de la partida 3918)',39,3919);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392010,'Chapas, folhas, tiras, fitas, películas, de polímeros de etileno, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular plastics, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles (excl. self-adhesi','Placas, láminas, hojas y tiras, de polímeros no celulares de etileno y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc.',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392020,'Chapas, folhas, tiras, fitas, películas, de polímeros de propileno, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular polymers of ethylene, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles (excl.','Placas, láminas, hojas y tiras, de polímeros no celulares de propileno y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (ex',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392030,'Chapas, folhas, tiras, fitas, películas, de polímeros de estireno, sem suporte, não reforçadas','Plates, sheets, foil, film and strip, of non-cellular polymers of styrene, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles (excl. ','Placas, láminas, hojas y tiras, de polímeros no celulares de estireno y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392041,'Chapas, etc.de polim.cloreto vinila, rígidas, s/suport.etc','Plates, etc.polym.of vinyl chloride without supp.etc','Placas, etc.de polím.cloruro vinilo, rigidas, s/soport.etc',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392042,'Chapas de ploricloreto de vinila','Sheets of vinyl ploricloreto','Lámina de vinilo ploricloreto',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392043,'Chapas, folhas, tiras, fitas, películas, de polímeros de cloreto de vinila, com conteúdo de plastificante => 6% em peso, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular polymers of vinyl chloride, containing by weight >= 6% of plasticisers, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-work','Placas, láminas, hojas y tiras, de polímeros de cloruro de vinilo, con un contenido de plastificantes >= 6% en peso, sin reforzar, estratificar ni combinar de forma similar con otras materias, sin soporte, sin trabajar o trabajadas sólo en la superficie o',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392049,'Outras chapas, folhas, tiras, fitas, películas, de polímeros de cloreto de vinila, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular polymers of vinyl chloride, containing by weight < 6% of plasticisers, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worke','Placas, láminas, hojas y tiras, de polímeros de cloruro de vinilo, con un contenido de plastificantes < 6% en peso, sin reforzar, estratificar ni combinar de forma similar con otras materias, sin soporte, sin trabajar o trabajadas sólo en la superficie o ',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392051,'Chapas, folhas, tiras, fitas, películas, de polimetacrilato de metila, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular polymethyl methacrylate, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles (ex','Placas, láminas, hojas y tiras, de poli"metacrilato de metilo" no celular y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular ',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392059,'Chapas, folhas, tiras, fitas, películas de outros polímeros acrílicos, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular acrylic polymers, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles (excl. tho','Placas, láminas, hojas y tiras, de polímeros acrílicos no celulares y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc. ',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392061,'Chapas, folhas, tiras, fitas, películas, de policarbonatos, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular polycarbonates, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles (excl. those','Placas, láminas, hojas y tiras, de policarbonatos no celulares y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc. autoa',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392062,'Chapas, folhas, tiras, fitas, películas, de poli(tereftalato de etileno), sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular polyethylene terephthalate, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles ','Placas, láminas, hojas y tiras, de poli"tereftalato de etileno" no celular y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392063,'Chapas, folhas, tiras, fitas, películas de poliésteres não saturados, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular unsaturated polyesters, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles (exc','Placas, láminas, hojas y tiras, de poliésteres no saturados y no celulares y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392069,'Chapas, folhas, tiras, fitas, películas, de outros poliésteres, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular polyesters, not reinforced, laminated, supported or similarly combined with other materials, not worked or only surface-worked, or only cut to rectangular, incl. square, shapes (excl. polycarbonates, p','Placas, láminas, hojas y tiras, de poliésteres no celulares y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc. de polic',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392071,'Chapas, folhas, tiras, fitas, películas, de celulose regenerada, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular regenerated cellulose, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles (excl','Placas, láminas, hojas y tiras, de celulosa regenerada no celular y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc. au',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392072,'Chapas de fibras vulcanizadas','Sheets of vulcanized fiber','Hojas de fibra vulcanizada',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392073,'Chapas, folhas, tiras, fitas, películas, de acetatos de celulose, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular cellulose acetates, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles (excl. s','Placas, láminas, hojas y tiras, de acetato de celulosa no celular y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc. au',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392079,'Chapas, folhas, tiras, fitas, películas, de outros derivados de celulose, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular cellulose derivatives, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles (excl','Placas, láminas, hojas y tiras, de derivados no celulares de la celulosa y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392091,'Chapas, folhas, tiras, fitas, películas, de poli(butiral de vinila), sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular polyvinyl butyral, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles (excl. se','Placas, láminas, hojas y tiras, de poli"butiral de vinilo" no celular y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392092,'Chapas, folhas, tiras, fitas, películas, de poliamidas, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular polyamides, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles (excl. self-adhe','Placas, láminas, hojas y tiras, de poliamidas no celulares y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc. autoadhes',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392093,'Chapas, folhas, tiras, fitas, películas, de resinas amínicas, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular amino-resins, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles (excl. self-ad','Placas, láminas, hojas y tiras, de resinas amínicas no celulares y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc. aut',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392094,'Chapas, folhas, tiras, fitas, películas, de resinas fenólicas, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular phenolic resins, not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles (excl. self','Placas, láminas, hojas y tiras, de resinas fenólicas no celulares y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc. au',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392099,'Chapas, folhas, tiras, fitas, películas, de outros plásticos, sem suporte, não reforçadas','Plates, sheets, film, foil and strip, of non-cellular plastics, n.e.s., not reinforced, laminated, supported or similarly combined with other materials, without backing, unworked or merely surface-worked or merely cut into squares or rectangles (excl. sel','Placas, láminas, hojas y tiras, de plástico no celular, n.c.o.p. y sin esfuerzo, estratificación ni soporte o combinación similar con otras materias, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc. aut',39,3920);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392111,'Chapas, folhas, tiras, fitas, películas, de polímeros de estireno, alveolares','Plates, sheets, film, foil and strip, of cellular polymers of styrene, unworked or merely surface-worked or merely cut into squares or rectangles (excl. self-adhesive products, floor, wall and ceiling coverings of heading 3918 and sterile surgical or dent','Placas, láminas, hojas y tiras, de polímeros celulares de estireno, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc. autoadhesivas, así como los revestimientos para suelos, paredes o techos de la partid',39,3921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392112,'Chapas, folhas, tiras, fitas, películas, de polímeros de cloreto vinila, alveolares','Plates, sheets, film, foil and strip, of cellular polymers of vinyl chloride, unworked or merely surface-worked or merely cut into squares or rectangles (excl. self-adhesive products, floor, wall and ceiling coverings of heading 3918 and sterile surgical ','Placas, láminas, hojas y tiras, de polímeros celulares de cloruro de vinilo, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc. autoadhesivas, así como los revestimientos para suelos, paredes o techos de ',39,3921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392113,'Chapas, folhas, tiras, fitas, películas, de poliuretanos, alveolares','Plates, sheets, film, foil and strip, of cellular polyurethanes, unworked or merely surface-worked or merely cut into squares or rectangles (excl. self-adhesive products, floor, wall and ceiling coverings of heading 3918 and sterile surgical or dental adh','Placas, láminas, hojas y tiras, de poliuretanos celulares, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc. autoadhesivas, así como los revestimientos para suelos, paredes o techos de la partida 3918)',39,3921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392114,'Chapas, folhas, tiras, fitas, películas, de celulose regenerada, alveolares','Plates, sheets, film, foil and strip, of regenerated cellular cellulose, unworked or merely surface-worked or merely cut into squares or rectangles (excl. self-adhesive products, floor, wall and ceiling coverings of heading 3918 and sterile surgical or de','Placas, láminas, hojas y tiras, de celulosa celular regenerada, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc. autoadhesivas, así como los revestimientos para suelos, paredes o techos de la partida 39',39,3921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392119,'Chapas, folhas, tiras, fitas, películas, de outros plásticos, alveolares','Plates, sheets, film, foil and strip, of cellular plastic, unworked or merely surface-worked or merely cut into squares or rectangles (excl.those of polymers of styrene, vinyl chloride, polyurethanes and regenerated cellulose, self-adhesive products, floo','Placas, láminas, hojas y tiras, de plástico celular, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc. de polímeros de estireno, de polímeros de cloruro de vinilo, de poliuretanos o de celulosa regenerad',39,3921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392190,'Outras chapas, folhas, películas, tiras, lâminas, de plásticos','Plates, sheets, film, foil and strip, of plastics, reinforced, laminated, supported or similarly combined with other materials, unworked or merely surface-worked or merely cut into squares or rectangles (excl. of cellular plastic; self-adhesive products, ','Placas, láminas, hojas y tiras, de plástico, reforzadas, estratificadas o combinadas de forma similar con otras materias, con soporte, sin trabajar o trabajadas solo en la superficie o solo cortadas en forma cuadrada o rectangular (exc. productos celulare',39,3921);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392210,'Banheiras, banheiras para duchas, pias e lavatórios, de plásticos','Baths, shower-baths, sinks and washbasins, of plastics','Bañeras, duchas, fregaderos "piletas de lavar" y lavabos, de plástico',39,3922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392220,'Assentos e tampas de sanitários, de plásticos','Lavatory seats and covers, of plastics','Asientos y tapas de inodoro, de plástico',39,3922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392290,'Outros artigos para usos sanitários ou higiênicos, de plásticos','Bidets, lavatory pans, flushing cisterns and similar sanitary ware, of plastics (excl. baths, shower-baths, sinks, washbasins, lavatory seats and covers)','Bidés, inodoros, cisternas "depósitos de agua" y artículos sanitarios o higiénicos similares, de plástico (exc. bañeras, duchas, lavabos y fregaderos "piletas de lavar", así como asientos y tapas de inodoros)',39,3922);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392310,'Caixas, caixotes, engradados, artigos semelhantes, de plásticos','Boxes, cases, crates and similar articles for the conveyance or packaging of goods, of plastics','Cajas, cajones, jaulas y artículos simil. para transporte o envasado, de plástico',39,3923);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392321,'Sacos, bolsas, cartuchos, de polímeros de etileno','Sacks and bags, incl. cones, of polymers of ethylene','Sacos "bolsas", bolsitas y cucuruchos, de polímeros de etileno',39,3923);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392329,'Sacos, bolsas e cartuchos, de outros plásticos','Sacks and bags, incl. cones, of plastics (excl. those of polymers of ethylene)','Sacos "bolsas", bolsitas y cucuruchos, de plástico (exc. de polímeros de etileno)',39,3923);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392330,'Garrafões, garrafas, frascos, artigos semelhantes, de plásticos','Carboys, bottles, flasks and similar articles for the conveyance or packaging of goods, of plastics','Bombonas "damajuanas" botellas, frascos y artículos simil. para transporte o envasado, de plástico',39,3923);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392340,'Bobinas, carretéis e suportes semelhantes, de plásticos','Spools, cops, bobbins and similar supports, of plastics','Bobinas, carretes, canillas y soportes simil., de plástico',39,3923);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392350,'Rolhas, tampas, cápsulas e outros dispositivos para fechar recipientes, de plástico','Stoppers, lids, caps and other closures, of plastics','Tapones, tapas, cápsulas y demás dispositivos de cierre, de plástico',39,3923);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392390,'Outros artigos de transporte ou de embalagem, de plásticos','Articles for the conveyance or packaging of goods, of plastics (excl. boxes, cases, crates and similar articles; sacks and bags, incl. cones; carboys, bottles, flasks and similar articles; sppols, spindles, bobbins and similar supports; stoppers, lids, ca','Artículos para transporte o envasado, de plástico (exc. cajas, jaulas y artículos simil.; sacos "bolsas", bolsitas y cucuruchos; bombonas "damajuanas", botellas, frascos y artículos simil.; bobinas "rollos", carretes, canillas y soportes simil.; tapones, ',39,3923);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392410,'Serviços de mesa e outros artigos de mesa ou cozinha, de plásticos','Tableware and kitchenware, of plastics','Vajilla y demás artículos para servicio de mesa o de cocina, de plástico',39,3924);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392490,'Outros artigos de higiene ou de toucador, de plásticos','Household articles and toilet articles, of plastics (excl. tableware, kitchenware, baths, shower-baths, washbasins, bidets, lavatory pans, seats and covers, flushing cisterns and similar sanitary ware)','Artículos de uso doméstico y artículos de higiene o tocador, de plástico (exc. vajilla y demás artículos para servicio de mesa o de cocina, así como bañeras, duchas, lavabos, bidés, inodoros y sus asientos y tapas, cisternas y artículos sanitarios o higié',39,3924);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392510,'Reservatórios, cisternas, cubas e recipientes análogos, de plásticos, com capacidade > 300 litros','Reservoirs, tanks, vats and similar containers, of plastics, with a capacity of > 300 l','Depósitos, cisternas, cubas y recipientes simil., de plástico, de capacidad > 300 l',39,3925);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392520,'Portas, janelas, seus caixilhos, alizares e soleiras, de plásticos','Doors, windows and their frames and thresholds for doors, of plastics','Puertas, ventanas, y sus marcos, contramarcos y umbrales, de plástico',39,3925);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392530,'Postigos, estores e artefatos semelhantes e suas partes, de plásticos','Shutters, blinds, incl. Venetian blinds, and similar articles and parts thereof, of plastics (excl. fittings and similar articles)','Contraventanas, persianas, incl. las venecianas, y artículos simil. y sus partes, de plástico (exc. accesorios y guarniciones)',39,3925);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392590,'Outros artefatos para apetrechamento de construções, de plásticos','Building elements for the manufacture of floors, walls, partition walls, ceilings, roofs, etc., of plastics; gutters and accessories of plastics; railings, fences and similar barriers, of plastics; large shelves, for assembly and permanent installation in','Elementos estructurales para la construcción de suelos, paredes, tabiques, techos o tejados, de plástico; canalones y sus accesorios, de plástico; barandillas, balaustradas y barreras simil., de plástico; estanterías de grandes dimensiones para montar y f',39,3925);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392610,'Artigos de escritório e artigos escolares, de plásticos','Office or school supplies, of plastics, n.e.s.','Artículos para oficina y artículos escolares, de plástico, n.c.o.p.',39,3926);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392620,'Vestuário e seus acessórios, inclusive luvas, mitenes e semelhantes, de plásticos','Articles of apparel and clothing accessories produced by the stitching or sticking together of plastic sheeting, incl. gloves, mittens and mitts','Prendas y complementos de vestir "accesorios", confeccionados por costura o pegado a partir de plástico en hojas, incl. los guantes, mitones y manoplas',39,3926);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392630,'Guarnições para móveis, carroçarias ou semelhantes, de plásticos','Fittings for furniture, coachwork and the like, of plastics (excl. building components for permanent mounting on parts of buildings)','Guarniciones para muebles, carrocerías o simil., de plástico (exc. artículos para la construcción destinados a ser fijados permanentemente en partes de edificios)',39,3926);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392640,'Estatuetas e outros objetos de ornamentação, de plásticos','Statuettes and other ornamental articles, of plastics','Estatuillas y demás artículos de adorno, de plástico',39,3926);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (392690,'Outras obras de plásticos e obras de outras matérias das posições 39.01 a 39.04','Articles of plastics and articles of other materials of heading 3901 to 3914, n.e.s','Manufacturas de plástico y manufacturas de las demás materias de las partidas 3901 a 3914, n.c.o.p.',39,3926);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400110,'Látex de borracha natural, mesmo pré-vulcanizado','Natural rubber latex, whether or not prevulcanised','Látex de caucho natural, incl. prevulcanizado',40,4001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400121,'Borracha natural em folhas fumadas','Smoked sheets of natural rubber','Hojas ahumadas de caucho natural',40,4001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400122,'Borracha natural tecnicamente especificada (TSNR)','Technically specified natural rubber TSNR','Cauchos naturales técnicamente especificados "TSNR"',40,4001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400129,'Borracha natural, em formas primárias ou em chapas, folhas ou tiras','Natural rubber in primary forms or in plates, sheets or strip (excl. smoked sheets, technically specified natural rubber TSNR and natural rubber latex, whether or not prevulcanised)','Caucho natural, en formas primarias o en placas, hojas o tiras (exc. hojas ahumadas, cauchos técnicamente especificados "TSNR" y látex de caucho natural, incl. prevulcanizado)',40,4001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400130,'Balata, guta-percha, guaiúle, chicle e gomas naturais análogas','Balata, gutta-percha, guayule, chicle and similar natural gums, in primary forms or in plates, sheets or strip (excl. natural rubber, whether or not prevulcanised)','Balata, gutapercha, guayule, chicle y gomas naturales análogas, en formas primarias o en placas, hojas o tiras (exc. caucho natural, incl. prevulcanizado)',40,4001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400211,'Látex de borracha sintética ou artificial','Styrene-butadiene rubber latex SBR;  carboxylated styrene-butadiene rubber latex XSBR','Látex de caucho estireno-butadieno "SBR" o de caucho estireno- butadieno carboxilado "XSBR"',40,4002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400219,'Outras borrachas de estireno-butadieno ou de estireno-butadieno-carboxiladas, em formas primárias ou em chapas, folhas ou tiras','Styrene-butadiene rubber SBR;  carboxylated styrene-butadiene rubber XSBR, in primary forms or in plates, sheets or strip (excl. latex)','Caucho estireno-butadieno "SBR" o caucho estireno-butadieno carboxilado "XSBR", en formas primarias o en placas, hojas o tiras (exc. látex)',40,4002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400220,'Borracha de butadieno (BR), em formas primárias ou em chapas, folhas ou tiras','Butadiene rubber BR, in primary forms or in plates, sheets or strip','Caucho butadieno "BR", en formas primarias o en placas, hojas o tiras',40,4002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400231,'Borracha de isobuteno-isopreno (butila) (IIR),em formas primárias ou em chapas, folhas ou tiras','Isobutylene isoprene rubber IIR, in primary forms or in plates, sheets or strip','Caucho isobuteno-isopreno "butilo" "IIR", en formas primarias o en placas, hojas o tiras',40,4002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400239,'Borracha de isobuteno-isopreno halogenada (CIIR ou BIIR), em formas primárias ou em chapas, folhas ou tiras','Halo-isobutene-isoprene rubber CIIR or BIIR, in primary forms or in plates, sheets or strip','Caucho isobuteno-isopreno halogenado "CIIR o BIIR", en formas primarias o en placas, hojas o tiras',40,4002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400241,'Látex de borracha de cloropreno (clorobutadieno) (CR)','Chloroprene latex chlorobutadiene rubber, CR','Látex de caucho cloropreno "clorobutadieno" "CR"',40,4002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400249,'Borracha de cloropreno (clorobutadieno), em formas primárias ou em chapas, folhas ou tiras','Chloroprene chlorobutadiene rubber, CR, in primary forms or in plates, sheets or strip (excl. latex)','Caucho cloropreno "clorobutadieno" "CR", en formas primarias o en placas, hojas o tiras (exc. látex)',40,4002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400251,'Látex de borracha de acrilonitrila-butadieno (NBR)','Latex of acrylonitrile-butadiene rubber NBR','Látex de caucho acrilonitrilo-butadieno "NBR"',40,4002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400259,'Borracha de acrilonitrila-butadieno (NBR), em formas primárias ou em chapas, folhas ou tiras','Acrylonitrile-butadiene rubber NBR, in primary forms or in plates, sheets or strip (excl. latex)','Caucho acrilonitrilo-butadieno "NBR", en formas primarias o en placas, hojas o tiras (exc. látex)',40,4002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400260,'Borracha de isopreno (IR) em formas primárias ou em chapas, folhas ou tiras','Isoprene rubber IR, in primary forms or in plates, sheets or strip','Caucho isopreno "IR", en formas primarias o en placas, hojas o tiras',40,4002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400270,'Borracha de etileno-propileno-dieno (EPDM) não conjugada, em formas primárias ou em chapas, folhas ou tiras','Ethylene-propylene diene rubber EPDM, non-conjugated, in primary forms or in plates, sheets or strip','Caucho etileno-propileno-dieno no conjugado "EPDM", en formas primarias o en placas, hojas o tiras',40,4002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400280,'Misturas de borracha natural com borracha sintética ou artificial, em formas primárias ou em chapas, folhas ou tiras','Mixtures of natural rubber, balata, gutta-percha, guayule, chicle or similar types of natural rubber with synthetic rubber or factice, in primary forms or in plates, sheets or strip','Mezclas de caucho natural, balata, gutapercha, guayule, chicle y gomas naturales simil. con caucho sintético y caucho facticio derivado de los aceites, en formas primarias o en placas, hojas o tiras',40,4002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400291,'Látex de outras borrachas sintéticas ou artificiais','Synthetic rubber and factice derived from oils, in primary forms or in plates, sheets or strip (excl. styrene-butadiene rubber SBR, carboxylated styrene-butadiene rubber XSBR, butadiene rubber BR, isobutylene isoprene rubber IIR, halo-isobutene-isoprene r','Látex de caucho sintético (exc. de caucho estireno-butadieno "SBR"; de caucho estireno-butadieno carboxilado "XSBR"; de caucho butadieno "BR"; de caucho isobuteno-isopreno "butilo" "IIR"; de caucho isobuteno-isopreno halogenado "CIIR o BIIR"; de caucho cl',40,4002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400299,'Outras borrachas sintéticas e artificiais, em formas primárias ou em chapas, folhas ou tiras','Synthetic rubber and factice derived from oils, in primary forms or in plates, sheets or strip (excl. latex, styrene-butadiene rubber SBR, carboxylated styrene-butadiene rubber XSBR, butadiene rubber BR, isobutylene isoprene rubber IIR, halo-isobutene-iso','Caucho sintético y caucho facticio derivado de los aceites, en formas primarias o en placas, hojas o tiras (exc. látex; caucho estireno- butadieno "SBR"; caucho estireno-butadieno carboxilado "XSBR"; caucho butadieno "BR"; caucho butilo "IIR"; caucho isob',40,4002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400300,'Borracha regenerada, em formas primárias ou em chapas, folhas ou tiras','Reclaimed rubber in primary forms or in plates, sheets or strip','Caucho regenerado, en formas primarias o en placas, hojas o tiras',40,4003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400400,'Desperdícios, resíduos e aparas, de borracha não endurecida','Waste, parings and scrap of soft rubber and powders and granules obtained therefrom','Desechos, desperdicios y recortes, de caucho sin endurecer, incl. en polvo o gránulos',40,4004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400510,'Borracha, não vulcanizada, adicionada de negro de fumo ou de sílica, em formas primárias ou em chapas, folhas ou tiras','Rubber, unvulcanised, compounded with carbon black or silica, in primary forms or in plates, sheets or strip','Caucho mezclado sin vulcanizar, con adición de negro de humo o de sílice, en formas primarias o en placas, hojas o tiras',40,4005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400520,'Borracha misturada, não vulcanizada, em soluções ou dispersões','Compounded rubber, unvulcanised, in the form of solutions or dispersions (excl. rubber compounded with carbon black or silica, and mixtures of natural rubber, balata, gutta-percha, guayule, chicle and similar natural gums containing synthetic rubber or fa','Caucho mezclado sin vulcanizar, en forma de disoluciones o dispersiones (exc. caucho con adición de negro de humo o de sílice, así como las mezclas de caucho natural, balata, gutapercha, guayule, chicle y gomas naturales simil. con caucho sintético y cauc',40,4005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400591,'Outras borrachas misturadas, não vulcanizadas, em chapas, folhas ou tiras','Compounded rubber, unvulcanised, in the form of plates, sheets or strip (excl. rubber compounded with carbon black or silica, and mixtures of natural rubber, balata, gutta-percha, guayule, chicle and similar natural gums containing synthetic rubber or fac','Caucho mezclado sin vulcanizar, en forma de placas, hojas o tiras (exc. caucho con adición de negro de humo o de sílice, así como las mezclas de caucho natural, balata, gutapercha, guayule, chicle y gomas naturales simil. con caucho sintético y caucho fac',40,4005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400599,'Outras borrachas misturadas, não vulcanizadas, em formas primárias','Compounded, unvulcanised rubber in primary forms (excl. solutions and dispersions, those containing carbon black or silica, mixtures of natural rubber, balata, gutta-percha, guayule, chicle or similar types of natural rubber with synthetic rubber or facti','Caucho mezclado sin vulcanizar, en formas primarias (exc. disoluciones, dispersiones y caucho con adición de negro de humo o de sílice, así como las mezclas de caucho natural, balata, gutapercha, guayule, chicle y gomas naturales simil. con caucho sintéti',40,4005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400610,'Perfis para recauchutagem, de borracha não vulcanizada','''Camel-back'' strips of unvulcanised rubber, for retreading rubber tyres','Perfiles para recauchutar, de caucho sin vulcanizar, para neumáticos',40,4006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400690,'Outras formas e artigos, de borracha não vulcanizada','Rods, bars, tubes, profiles and other forms of unvulcanised rubber, incl. mixed rubber, and articles of unvulcanised rubber, incl. mixed rubber (excl. plates, sheets and strip which, apart from basic surface-working, have not been cut, or have merely been','Varillas, tubos, perfiles y demás formas de caucho sin vulcanizar, incl. mezclado, así como discos, arandelas y demás artículos de caucho sin vulcanizar, incl. mezclados (exc. en placas, hojas o tiras de forma regular, sin cortar o simplemente cortadas de',40,4006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400700,'Fios e cordas, de borracha vulcanizada','Vulcanised rubber thread and cord (excl. ungimped single thread with a diameter of > 5 mm and textiles combined with rubber thread, e.g. textile-covered thread and cord)','Hilos y cuerdas, de caucho vulcanizado (exc. hilos desnudos sencillos cuya mayor dimensión del corte transversal sea > 5 mm, así como los hilos y cuerdas de caucho recubiertos de textiles y las demás materias textiles combinadas con hilos de caucho)',40,4007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400811,'Chapas, folhas e tiras, de borracha vulcanizada alveolar não endurecida','Plates, sheets and strip of cellular rubber','Placas, hojas y tiras, de caucho celular',40,4008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400819,'Varetas e perfis, de borracha vulcanizada alveolar não endurecida','Strip, rods and profile shapes, of cellular rubber','Varillas y perfiles, de caucho celular',40,4008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400821,'Chapas, folhas e tiras de borracha vulcanizada não alveolar, não endurecida','Plates, sheets and strip, of non-cellular rubber','Placas, hojas y tiras, de caucho no celular, vulcanizado y sin endurecer',40,4008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400829,'Varetas e perfis de borracha vulcanizada não alveolar, não endurecida','Rods, tubes and profile shapes, of non-cellular rubber','Varillas y perfiles, de caucho no celular, vulcanizado y sin endurecer',40,4008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400910,'Tubo de borracha vulcan.n/endurec.n/reforcado, s/acess.','Tubes of vulcanised rubber n/hardened, without fittings','tubo de caucho vulcan.s/endurec.s/reforzar, sus acces.',40,4009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400911,'Tubos de borracha vulcanizada não endurecida, não reforçados com outras matérias, sem acessórios','Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), not reinforced or otherwise combined with other materials, without fittings','Tubos de caucho vulcanizado sin endurecer, sin reforzar ni combinar de otro modo con otras materias, sin accesorios "incl. juntas, codos, empalmes [racores]"',40,4009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400912,'Tubos de borracha vulcanizada não endurecida, não reforçados com outras matérias, com acessórios','Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), not reinforced or otherwise combined with other materials, with fittings','Tubos de caucho vulcanizado sin endurecer, sin reforzar ni combinar de otro modo con otras materias, con accesorios "incl. juntas, codos, empalmes [racores]"',40,4009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400920,'Tubos de borracha sem acessórios','Rubber tubes without accessories','Tubos de caucho sin accesorios',40,4009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400921,'Tubos de borracha vulcanizada não endurecida, reforçados ou associados apenas com metal, sem acessórios','Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), reinforced or otherwise combined only with metal, without fittings','Tubos de caucho vulcanizado sin endurecer, reforzados o combinados de otro modo solamente con metal, sin accesorios "incl. juntas, codos, empalmes [racores]"',40,4009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400922,'Tubos de borracha vulcanizada não endurecida, reforçados ou associados apenas com metal, com acessórios','Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), reinforced or otherwise combined only with metal, with fittings','Tubos de caucho vulcanizado sin endurecer, reforzados o combinados de otro modo solamente con metal, con accesorios "incl. juntas, codos, empalmes [racores]"',40,4009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400930,'Tubo de borracha vulcan.n/endur.c/mater.têxtil, s/acess.','Tubes vulc.rubb.n/hard.reinfor.text.mat.without fit.','Tubos de caucho vulc.s/end.c/mater.textil, s/acces.',40,4009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400931,'Tubos de borracha vulcanizada não endurecida, reforçados ou associados apenas com matérias têxteis, sem acessórios','Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), reinforced or otherwise combined only with textile materials, without fittings','Tubos de caucho vulcanizado sin endurecer, reforzados o combinados de otro modo solamente con materia textil, sin accesorios "incl. juntas, codos, empalmes [racores]"',40,4009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400932,'Tubos de borracha vulcanizada não endurecida, reforçados ou associados apenas com matérias têxteis, com acessórios','Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), reinforced or otherwise combined only with textile materials, with fittings','Tubos de caucho vulcanizado sin endurecer, reforzados o combinados de otro modo solamente con materia textil, con accesorios "incl. juntas, codos, empalmes [racores]"',40,4009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400940,'Tubo de borracha vulcan.n/endur.c/outs.matérias, s/acess','Rubber tube vulc.n/hard.with oth.mater.without fittings','Tubo de caucho vulc.s/endur.c/ots.materias, c/acces.',40,4009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400941,'Tubos de borracha vulcanizada não endurecida, reforçados ou associados apenas com outras matérias, sem acessórios','Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), reinforced or otherwise combined with materials other than metal or textile materials, without fittings','Tubos de caucho vulcanizado sin endurecer, reforzados o combinados de otro modo con otras materias, sin accesorios "incl. juntas, codos, empalmes [racores]" (exc. reforzados o combinados de otro modo solamente con metal o solamente con materia textil)',40,4009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400942,'Tubos de borracha vulcanizada não endurecida, reforçados ou associados apenas com outras matérias, com acessórios','Tubes, pipes and hoses, of vulcanised rubber (excl. hard rubber), reinforced or otherwise combined with materials other than metal or textile materials, with fittings','Tubos de caucho vulcanizado sin endurecer, reforzados o combinados de otro modo con otras materias, con accesorios "incl. juntas, codos, empalmes [racores]" (exc. reforzados o combinados de otro modo solamente con metal o solamente con materia textil)',40,4009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (400950,'Tubos de borracha com acessórios','Rubber tubes with accessories','Tubos de caucho con accesorios',40,4009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401011,'Correia transportadora de borracha vulcanizada reforçada apenas com metal','Conveyor belts or belting, of vulcanised rubber, reinforced only with metal','Correas transportadoras, de caucho vulcanizado, reforzadas solamente con metal',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401012,'Correia transportadora de borracha vulcanizada reforçada apenas com matérias têxteis','Conveyor belts or belting, of vulcanised rubber, reinforced only with textile materials','Correas transportadoras, de caucho vulcanizado, reforzadas solamente con materia textil',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401013,'Correia transportad.de borracha vulcan.reforc.plásticos','Conveyor belt of rubber vulcan.reinfor.with plastics','Correa transportad.de caucho vulcan.reforzado mat.text',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401019,'Outras correias transportadoras, de borracha vulcanizada','Conveyor belts or belting, of vulcanised rubber (excl. reinforced only with metal or only with textile materials)','Correas transportadoras, de caucho vulcanizado (exc. correas reforzadas solamente con metal, materia textil o plástico)',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401021,'Correia transm.s/fim, trapez.6dm<c<=18dm, borracha vulcan','Conveyor belt endless trapez.6dm<c<=18dm, vulcan.rub','Correa transm.s/fin, trapez.6dm<c<=18dm, caucho vulcan.',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401022,'Correia transm.s/fim, trapez.18<c<=24dm, borracha vulcan.','Conveyor belt endless trapez.18<c<=24dm, vulcan.rub','Correa transm.s/fin, trapez.6dm<c<=18dm, caucho vulcan.',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401023,'Correia transm.s/fim, sincron.6<c<=15dm, borracha vulcan.','Conveyor belt endless synch.6<c<=15dm, vulcan.rub','Correa transm.s/fin, c/muescas, 6<c<=15dm, caucho vulcan.',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401024,'Correia transm.s/fim, sincr.150<c<=198cm, borracha vulcan','Conveyor belt endless synch.150<c<=198dm, vulc.rub','Correa transport.s/fin, c/muesc.150<c<=198cm, caucho vulc',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401029,'Outras correias de transmissão, de borracha vulcanizada','Other conveyor belt, of vulcanised rubber','Otras correas de transm., de caucho vulcanizado',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401031,'Correias de transmissão sem fim, de borracha vulcanizada, de seção trapezoidal, estriadas, com uma circunferência externa > 60 cm e <= 180 cm','Endless transmission belts of trapezoidal cross-section V-belts, of vulcanised rubber, V-ribbed, of an outside circumference > 60 cm but <= 180 cm','Correas de transmisión, sin fin, estriadas, de sección trapezoidal, de circunferencia exterior > 60 cm pero <= 180 cm, de caucho vulcanizado',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401032,'Correias de transmissão sem fim, de borracha vulcanizada, de seção trapezoidal, não estriadas, com uma circunferência externa > 60 cm e <= 180 cm','Endless transmission belts of trapezoidal cross-section V-belts, of vulcanised rubber, of an outside circumference > 60 cm but <= 180 cm (excl. V-ribbed)','Correas de transmisión, sin fin, de sección trapezoidal, de circunferencia exterior > 60 cm pero <= 180 cm, de caucho vulcanizado (exc. estriadas)',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401033,'Correias de transmissão sem fim, de borracha vulcanizada, de seção trapezoidal, estriadas, com uma circunferência externa > 180 cm e <= 240 cm','Endless transmission belts of trapezoidal cross-section V-belts, of vulcanised rubber, V-ribbed, of an outside circumference > 180 cm but <= 240 cm','Correas de transmisión, sin fin, estriadas, de sección trapezoidal, de circunferencia exterior > 180 cm pero <= 240 cm, de caucho vulcanizado',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401034,'Correias de transmissão sem fim, de borracha vulcanizada, de seção trapezoidal, não estriadas, com uma circunferência externa > 180 cm e <= 240 cm','Endless transmission belts of trapezoidal cross-section V-belts, of vulcanised rubber, of an outside circumference > 180 cm but <= 240 cm (excl. V-ribbed)','Correas de transmisión, sin fin, de sección trapezoidal, de circunferencia exterior > 180 cm pero <= 240 cm, de caucho vulcanizado (exc. estriadas)',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401035,'Correias de transmissão sem fim, de borracha vulcanizada, síncronas, com uma circunferência externa > 60 cm e <= 150 cm','Endless synchronous belts, of vulcanised rubber, of an outside circumference > 60 cm but <= 150 cm','Correas de transmisión, sin fin, con muescas "sincrónicas", de circunferencia exterior > 60 cm pero <= 150 cm, de caucho vulcanizado',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401036,'Correias de transmissão sem fim, de borracha vulcanizada, síncronas, com uma circunferência externa > 150 cm e <= 198 cm','Endless synchronous belts, of vulcanised rubber, of an outside circumference > 150 cm but <= 198 cm','Correas de transmisión, sin fin, con muescas "sincrónicas", de circunferencia exterior > 150 cm pero <= 198 cm, de caucho vulcanizado',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401039,'Outras correias de transmissão, de borracha vulcanizada','Transmission belts or belting, of vulcanised rubber (excl. endless transmission belts of trapezoidal cross-section V-belts, V-ribbed, of an outside circumference > 60 cm but <= 240 cm and endless synchronous belts of an outside circumference > 60 cm but <','Correas de transmisión, de caucho vulcanizado (exc. correas de transmisión, sin fin, estriadas, de sección trapezoidal, de circunferencia exterior > 60 cm pero <= 240 cm; correas de transmisión, sin fin, con muescas "sincrónicas", de circunferencia exteri',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401099,'Outras correias transportadoras para a transmissão, de borracha vulcanizada','Other belt for conveyor, transmission of vulcanized rubber','Otro cinturón para transmisión, de caucho vulcanizado',40,4010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401110,'Pneus novos de borracha dos tipos utilizados em automóveis de passageiros','New pneumatic tyres, of rubber, of a kind used for motor cars, incl. station wagons and racing cars','Neumáticos "llantas neumáticas" nuevos de caucho, de los tipos utilizados en automóviles de turismo, incl. los del tipo familiar "break" o "station wagon" [«break» o «station wagon»] y los de carreras',40,4011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401120,'Pneus novos de borracha dos tipos utilizados em ônibus ou caminhões','New pneumatic tyres, of rubber, of a kind used for buses and lorries (excl. typres with lug, corner or similar treads)','Neumáticos "llantas neumáticas" nuevos de caucho, de los tipos utilizados en autobuses o camiones (exc. con dibujo en alto relieve, de taco, en ángulo o similar)',40,4011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401130,'Pneus novos de borracha dos tipos utilizados em aviões','New pneumatic tyres, of rubber, of a kind used for aircraft','Neumáticos "llantas neumáticas" nuevos de caucho, de los tipos utilizados en aeronaves',40,4011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401140,'Pneus novos de borracha dos tipos utilizados em motocicletas','New pneumatic tyres, of rubber, of a kind used for motorcycles','Neumáticos "llantas neumáticas" nuevos de caucho, de los tipos utilizados en motocicletas',40,4011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401150,'Pneus novos de borracha dos tipos utilizados em bicicletas','New pneumatic tyres, of rubber, of a kind used for bicycles','Neumáticos "llantas neumáticas" nuevos de caucho, de los tipos utilizados en bicicletas',40,4011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401161,'Pneus novos de borracha dos tipos utilizados em veículos e máquinas agrícolas ou florestais, com bandas de rodagem em forma de espinha de peixe e semelhantes','Pneumatic tyres, new, of rubber, having a herring-bone or similar tread, of a kind used on agricultural or forestry vehicles and machines','Neumáticos "llantas neumáticas" nuevos de caucho, con altos relieves en forma de taco, ángulo o similares, de los tipos utilizados en vehículos y máquinas agrícolas o forestales',40,4011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401162,'Pneus novos de borracha dos tipos utilizados em veículos e máquinas próprios para construções ou manutenção industrial, para aros de diâmetro <= 61 cm, com bandas de rodagem em forma de espinha de peixe e semelhantes','Pneumatic tyres, new, of rubber, having a herring-bone or similar tread, of a kind used on construction or industrial handling vehicles and machines and having a rim size <= 61 cm','Neumáticos "llantas neumáticas" nuevos de caucho, con altos relieves en forma de taco, ángulo o similares, de los tipos utilizados en vehículos y máquinas para la construcción o mantenimiento industrial, para llantas de diámetro <= 61 cm',40,4011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401163,'Pneus novos de borracha dos tipos utilizados em veículos e máquinas próprios para construções ou manutenção industrial, para aros de diâmetro > 61 cm, com bandas de rodagem em forma de espinha de peixe e semelhantes','Pneumatic tyres, new, of rubber, having a herring-bone or similar tread, of a kind used on construction or industrial handling vehicles and machines and having a rim size > 61 cm','Neumáticos "llantas neumáticas" nuevos de caucho, con altos relieves en forma de taco, ángulo o similares, de los tipos utilizados en vehículos y máquinas para la construcción o mantenimiento industrial, para llantas de diámetro > 61 cm',40,4011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401169,'Outros pneus novos de borracha, com bandas de rodagem em forma de espinha de peixe e semelhantes','Pneumatic tyres, new, of rubber, having a herring-bone or similar tread (excl. of a kind used on agricultural or forestry and construction or industrial handling vehicles and machines)','Neumáticos "llantas neumáticas" nuevos de caucho, con altos relieves en forma de taco, ángulo o similares (exc. de los tipos utilizados en vehículos y máquinas agricolas o forestales y de los tipos utilizados en vehículos y máquinas para la construcción o',40,4011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401191,'Pneumáticos de aro largo','Pneumatic tyres of rubber, having a "herring-bone" or similar tread','Los neumáticos de caucho, que tienen una "espiga", ángulo o similares',40,4011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401192,'Outros pneus novos de borracha dos tipos utilizados em veículos e máquinas agrícolas ou florestais','Pneumatic tyres, of rubber, new, of a kind used on agricultural or forestry vehicles and machines (excl. having a herring-bone or similar tread)','Neumáticos "llantas neumáticas" nuevos de caucho, de los tipos utilizados en vehículos y máquinas agrícolas o forestales (exc. con altos relieves en forma de taco, ángulo o similares)',40,4011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401193,'Outros pneus novos de borracha dos tipos utilizados em veículos e máquinas próprios para construções ou manutenção industrial, para aros de diâmetro <= 61 cm','Pneumatic tyres, new, of rubber, of a kind used on construction or industrial handling vehicles and machines and having a rim size <= 61 cm (excl. having a herring-bone or similar tread)','Neumáticos "llantas neumáticas" nuevos de caucho, de los tipos utilizados en vehículos y máquinas para la construcción o mantenimiento industrial, para llantas de diámetro <= 61 cm (exc. con altos relieves en forma de taco, ángulo o similares)',40,4011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401194,'Outros pneus novos de borracha dos tipos utilizados em veículos e máquinas próprios para construções ou manutenção industrial, para aros de diâmetro > 61 cm','Pneumatic tyres, new, of rubber, of a kind used on construction or industrial handling vehicles and machines and having a rim size > 61 cm (excl. having a herring-bone or similar tread)','Neumáticos "llantas neumáticas" nuevos de caucho, de los tipos utilizados en vehículos y máquinas para la construcción o mantenimiento industrial, para llantas de diámetro > 61 cm (exc. con altos relieves en forma de taco, ángulo o similares)',40,4011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401199,'Outros pneus novos de borracha','Pneumatic tyres, new, of rubber (excl. having a herring-bone or similar tread and pneumatic tyres of a kind used on agricultural or forestry and construction or industrial handling vehicles and machines, on motor cars, station wagons, racing cars, buses, ','Neumáticos "llantas neumáticas" nuevos de caucho (exc. con altos relieves en forma de taco, ángulo o similares; neumáticos de los tipos utilizados en vehículos y máquinas agrícolas o forestales; neumáticos de los tipos utilizados en vehículos y máquinas p',40,4011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401210,'Pneus recauchutados de borracha','Retreaded pneumatic rubber tires','Neumáticos recauchutados de caucho',40,4012);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401211,'Pneus recauchutados, dos tipos utilizados em automóveis de passageiros (incluídos os veículos de uso misto e automóveis de corrida)','Retreaded pneumatic tyres, of rubber, of a kind used on motor cars incl. station wagons and racing cars','Neumáticos "llantas neumáticas" recauchutados, de caucho, de los tipos utilizados en automóviles de turismo, incl. los del tipo familiar "break" o "station wagon" [«break» o «station wagon»] y los de carreras',40,4012);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401212,'Pneus recauchutados, dos tipos utilizados em ônibus e caminhões','Retreaded pneumatic tyres, of rubber, of a kind used on buses or lorries','Neumáticos "llantas neumáticas" recauchutados, de caucho, de los tipos utilizados en autobuses o camiones',40,4012);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401213,'Pneus recauchutados, dos tipos utilizados em veículos aéreos','Retreaded pneumatic tyres, of rubber, of a kind used on aircraft','Neumáticos "llantas neumáticas" recauchutados, de caucho, de los tipos utilizados en aeronaves',40,4012);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401219,'Outros pneus recauchutados','Retreaded pneumatic tyres, of rubber (excl. of a kind used on motor cars, station wagons, racing cars, buses, lorries and aircraft)','Neumáticos "llantas neumáticas" recauchutados, de caucho (exc. de los tipos utilizados en automóviles de turismo, incl. los del tipo familiar "break" o "station wagon", y en los de carreras; de los tipos utilizados en autobuses o camiones; de los tipos ut',40,4012);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401220,'Pneus usados de borracha','Used pneumatic tyres of rubber','Neumáticos "llantas neumáticas" usados, de caucho',40,4012);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401290,'Flaps, protetores, bandas de rodagem, para pneus de borracha','Solid or cushion tyres, interchangeable tyre treads and tyre flaps, of rubber','Bandajes "llantas macizas o huecas", tiras de rodadura intercambiables para neumáticos "llantas neumáticas" y protectores [«flaps»], de caucho',40,4012);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401310,'Câmaras-de-ar de borracha, dos tipos utilizados em automóveis de passageiros, ônibus ou caminhões','Inner tubes, of rubber, of a kind used on motor cars, incl. station wagons and racing cars, buses and lorries','Cámaras de caucho para neumáticos "llantas neumáticas", de los tipos utilizados en automóviles de turismo, incl. los del tipo familiar "break" o "station wagon" [«break» o «station wagon»] y los de carreras, autobuses y camiones',40,4013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401320,'Câmaras-de-ar de borracha, dos tipos utilizados em pneus de bicicletas','Inner tubes, of rubber, of a kind used for bicycles','Cámaras de caucho para neumáticos "llantas neumáticas", de los tipos utilizados en bicicletas',40,4013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401390,'Outras câmaras-de-ar de borracha','Inner tubes, of rubber (excl. those of a kind used on motor cars, incl. station wagons and racing cars, buses, lorries and bicycles)','Cámaras de caucho para neumáticos "llantas neumáticas" (exc. de los tipos utilizados en automóviles de turismo, incl. los del tipo familiar "break" o "station wagon" [«break» o «station wagon»] y los de carreras, autobuses, camiones y bicicletas)',40,4013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401410,'Preservativos de borracha vulcanizada, não endurecida','Sheath contraceptives, of vulcanised rubber (excl. hard rubber)','Preservativos, de caucho vulcanizado sin endurecer',40,4014);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401490,'Outros artigos de higiene ou de farmácia, de borracha vulcanizada não endurecida, mesmo com partes de borracha endurecida','Hygienic or pharmaceutical articles, incl. teats, of vulcanised rubber (excl. hard rubber), with or without fittings of hard rubber, n.e.s. (excl. sheath contraceptives and articles of apparel and clothing accessories, incl. gloves, for all purposes)','Artículos de higiene o de farmacia, incl. las tetinas, de caucho vulcanizado sin endurecer, incl. con partes de caucho endurecido, n.c.o.p. (exc. preservativos, así como prendas, guantes y demás complementos de vestir, para cualquier uso)',40,4014);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401511,'Luvas para cirurgia, de borracha vulcanizada, não endurecida','Surgical gloves, of vulcanised rubber (excl. fingerstalls)','Guantes de caucho vulcanizado sin endurecer, para cirugía (exc. dediles)',40,4015);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401519,'Outras luvas de borracha vulcanizada, não endurecida','Gloves, mittens and mitts, of vulcanised rubber (excl. surgical gloves)','Guantes, mitones y manoplas, de caucho vulcanizado sin endurecer (exc. para cirugía)',40,4015);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401590,'Outros vestuários e acessórios, de borracha vulcanizada não endurecida','Articles of apparel and clothing accessories, for all purposes, of vulcanised rubber (excl. hard rubber and footwear and headgear and parts thereof, and gloves, mittens and mitts)','Prendas de vestir y demás complementos "accesorios" de vestir, para cualquier uso, de caucho vulcanizado sin endurecer (exc. calzado, artículos de sombrerería y sus partes, así como los guantes, mitones y manoplas)',40,4015);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401610,'Obras de borracha vulcanizada alveolar não endurecida','Articles of cellular rubber, n.e.s.','Manufacturas de caucho celular sin endurecer, n.c.o.p.',40,4016);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401691,'Revestimentos para pavimentos e capachos, de borracha vulcanizada não endurecida','Floor coverings and mats, of vulcanised rubber (excl. hard rubber), with chamfered sides, rounded corners or shaped edges or otherwise worked (excl. those simply cut to rectangular or square shape and goods of cellular rubber)','Revestimientos para el suelo y alfombras, de caucho vulcanizado sin endurecer, con bordes biselados o moldurados, esquinas redondeadas, bordes calados, trabajados de otro modo o cortados en forma distinta de la cuadrada o rectangular (exc. de caucho celul',40,4016);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401692,'Borrachas de apagar, de borracha vulcanizada não endurecida','Erasers, of vulcanised rubber (excl. hard rubber), conditioned (excl. those simply cut to rectangular or square shape)','Gomas de borrar, de caucho vulcanizado sin endurecer, trabajadas y listas para el uso, cortadas en forma distinta de la cuadrada o rectangular',40,4016);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401693,'Juntas, gaxetas e semelhantes de borracha vulcanizada não endurecida','Gaskets, washers and other seals, of vulcanised rubber (excl. hard rubber and those of cellular rubber)','Juntas o empaquetaduras, de caucho vulcanizado sin endurecer (exc. de caucho celular)',40,4016);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401694,'Defensas, mesmo infláveis, para atracação de embarcações, de borracha vulcanizada não endurecida','Boat or dock fenders, whether or not inflatable, of vulcanised rubber (excl. hard rubber and those of cellular rubber)','Defensas, incl. inflables, para el atraque de barcos, de caucho vulcanizado sin endurecer (exc. de caucho celular)',40,4016);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401695,'Artigos infláveis de salvamento e outros artigos infláveis, de borracha vulcanizada não endurecida','Inflatable mattresses and cushions and other inflatable articles, of vulcanised rubber (excl. hard rubber and fenders, boats, rafts and other floating devices, and hygienic or pharmaceutical articles)','Colchones, almohadas, cojines y demás artículos inflables, de caucho vulcanizado sin endurecer (exc. defensas para el atraque de barcos; canoas, balsas y demás artículos flotantes; artículos de higiene o de farmacia)',40,4016);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401699,'Outras obras de borracha vulcanizada, não endurecida','Articles of vulcanised rubber (excl. hard rubber), n.e.s.','Manufacturas de caucho vulcanizado sin endurecer, n.c.o.p.',40,4016);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (401700,'Borracha endurecida; obras de borracha endurecida','Hard rubber, e.g. ebonite, in all forms, incl. waste and scrap; articles of hard rubber, n.e.s.','Ebonita y demás cauchos endurecidos, en cualquier forma, incl. los desechos y desperdicios; manufacturas de caucho endurecido, n.c.o.p.',40,4017);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410110,'Peles em bruto, de bovino, inteiras, qdo.secas<=8kg, etc.','Raw skins of bovine, whole, when dried<=8kg, etc.','Pieles en bruto, de bovino, enteras, cdo.secas<=8kg, etc.',41,4101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410120,'Couros e peles de bovinos ou de eqüídeos, inteiros, de peso <= 8 kg quando secas, <= 10 kg quando salgadas-secas e <= 16 kg quando frescas, salgadas-úmidas ou conservadas de outro modo','Whole raw hides and skins of bovine incl. buffalo or equine animals, whether or not dehaired or split, of a weight per skin <= 8 kg when simply dried, <= 10 kg when dry-salted, or <= 16 kg when fresh, wet-salted or otherwise preserved (excl. tanned and pa','Cueros y pieles, en bruto, enteros, de bovino, incl. el búfalo, o de equino, incl. depilados o divididos, de peso unitario <= 8 kg para los secos, <= 10 kg para los salados secos e <= 16 kg para los frescos, salados verdes "húmedos" o conservados de otro ',41,4101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410121,'Couros e peles inteiros de bovinos (frescas ou em salmoura)','Whole hides and skins of bovine animals (fresh or wet-salted)','Cueros y pieles enteros de bovino (frescos o salados)',41,4101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410122,'Buttes e curvas (peles de bovinos)','Buttes and bends (skins of bovine animals)','Buttes y curvas (pieles de bovino)',41,4101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410129,'Outros couros e peles inteiros de bovinos (frescas ou em salmoura)','Other hides and skins of bovine animals (fresh or wet-salted)','Otros cueros y pieles enteros de bovino (frescos o salados)',41,4101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410130,'Couros e peles de bovinos (conservados de outro modo)','Hides and skins of bovine animals (otherwise preserved)','Cueros y pieles de bovino (conservados de otro modo)',41,4101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410140,'Couros e peles de animais equinos','Hides and skins of equine animals','Cueros y pieles de equino',41,4101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410150,'Couros e peles de bovinos ou de eqüídeos, inteiros, de peso unitário > 16 kg','Whole raw hides and skins of bovine incl. buffalo or equine animals, whether or not dehaired or split, of a weight per skin > 16 kg, fresh, or salted, dried, limed, pickled or otherwise preserved (excl. tanned, parchment-dressed or further prepared)','Cueros y pieles, en bruto, enteros, de bovino, incl. el búfalo, o de equino, incl. depilados o divididos, de peso unitario >16 kg, frescos o salados, secos, encalados, piquelados o conservados de otro modo (exc. curtidos, apergaminados o preparados de otr',41,4101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410190,'Outros couros e peles de bovinos ou de eqüídeos, incluídos os dorsos, meios-dorsos e flancos','Butts, bends, bellies and split raw hides and skins of bovine incl. buffalo or equine animals, whether or not dehaired, fresh, or salted, dried, limed, pickled or otherwise preserved, and whole raw hides and skins of a weight per skin > 8 kg but < 16 kg w','Crupones, medios crupones, faldas y cueros y pieles divididos, en bruto, de bovino, incl. el búfalo, o de equino, incl. depilados, frescos o salados, secos, encalados, piquelados o conservados de otro modo; cueros y pieles, en bruto, enteros, de peso unit',41,4101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410210,'Peles em bruto, de ovinos, com lã (não depiladas)','Raw skins of sheep or lambs, with wool on, fresh or salted, dried, limed, pickled or otherwise preserved (excl. those of Astrakhan, Caracul, Persian, Broadtail or similar lambs, or of Indian, Chinese, Mongolian or Tibetan lambs)','Cueros y pieles en bruto, con lana, de ovino, frescos o salados, secos, encalados, piquelados o conservados de otro modo, pero sin curtir, apergaminar ni preparar de otra forma (exc. de corderos de astracán, "breitschwanz", caracul, persas o simil. y las ',41,4102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410221,'Peles em bruto, de ovinos, sem lã, picladas','Raw skins of sheep or lambs, without wool on, pickled, whether or not split','Cueros y pieles, en bruto, sin lana "depilados", de ovino, piquelados, incl. divididos',41,4102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410229,'Outras peles em bruto, de ovinos, depiladas ou sem lã','Raw skins of sheep or lambs, without wool on, fresh or salted, dried, limed or otherwise preserved, whether or not split (excl. pickled or parchment-dressed)','Cueros y pieles, en bruto, sin lana "depilados", de ovino, frescos o salados, secos, encalados, piquelados o conservados de otro modo, pero sin curtir, apergaminar ni preparar de otra forma, incl. divididos (exc. piquelados o apergaminados)',41,4102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410310,'Peles em bruto, de caprinos','Skin in brute, of goats','Pieles en bruto, de caprino',41,4103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410320,'Peles em bruto, de répteis','Raw hides and skins of reptiles, fresh or salted, dried, limed, pickled or otherwise preserved (excl. parchment-dressed)','Cueros y pieles, en bruto, de reptil, frescos o salados, secos, encalados, piquelados o conservados de otro modo, incl. divididos (exc. apergaminados)',41,4103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410330,'Couros e peles de suínos, em bruto, mesmo depilados ou divididos ','Raw hides and skins of swine, fresh, or salted, dried, limed, pickled or otherwise preserved, whether or not dehaired or split (excl. parchment-dressed)','Cueros y pieles, en bruto, de porcino, frescos o salados, secos, encalados, piquelados o conservados de otro modo, incl. depilados o divididos (exc. curtidos, apergaminados o preparados de otra forma)',41,4103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410390,'Couros e peles em bruto, de outros animais, mesmo depilados ou divididos','Raw hides and skins, fresh, or salted, dried, limed, pickled or otherwise preserved, whether or not dehaired, incl. birdskins without feathers or down (excl. parchment-dressed, hides and skins of bovine incl. buffalo animals, equine animals, sheep, lambs,','Cueros y pieles, en bruto, frescos o salados, secos, encalados, piquelados o conservados de otro modo, incl. depilados o divididos, incl. los cueros y pieles de aves sin las plumas ni el plumón (exc. curtidos, apergaminados o preparados de otra forma, así',41,4103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410410,'Couros e peles de bovinos, inteiros','Whole bovine skin leather','Cueros enteros de bovinos',41,4104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410411,'Couros e peles curtidos, de bovinos ou de eqüídeos, depilados, no estado úmido (incluindo wet blue), plena flor, não divididos; divididos, com a flor','Full grains, unsplit and grain splits, in the wet state incl. wet-blue, of hides and skins of bovine incl. buffalo or equine animals, tanned, without hair on (excl. further prepared)','Plena flor sin dividir o divididos con la flor, en estado húmedo, incl. el "wet blue", de cueros y pieles de bovino, incl. el búfalo, o de equino, curtidos, depilados (exc. preparados de otra forma)',41,4104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410419,'Outros couros e peles curtidos, de bovinos ou de eqüídeos, depilados, no estado úmido (incluindo wet blue)','Hides and skins of bovine incl. buffalo or equine animals, in the wet state incl. wet-blue, tanned, without hair on, whether or not split (excl. further prepared and full grains, unsplit and grain splits)','Cueros y pieles, de bovino, incl. el búfalo, o de equino, en estado húmedo incl. el "wet blue", curtidos, depilados, incl. divididos (exc. preparados de otra forma, así como plena flor sin dividir o divididos con la flor)',41,4104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410421,'Couros e peles, de bovinos, com pre-curtimenta vegetal','Leathers/skins, bovines, vegetable pre-tanned','Cueros y pieles, de bovinos, con precurtido vegetal',41,4104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410422,'Couro bovino (com outro tipo de pré-curtimenta)','Bovine leather (otherwise pre-tanned)','Piel de vacuno (de lo contrario con precurtido)',41,4104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410429,'Outros couros e peles, de bovinos/equídeos, curtidos, recurtidos','oth.leathers/skins, of bovines/equine, tanned or retanned','ots.cueros y pieles, de bovinos/equinos, curtidos, recurt.',41,4104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410431,'Outros couros de bovinos e de equinos','Other bovine leather and equine leather (full grains and grain splits)','Otros cueros de bovinos y equinos',41,4104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410439,'Outros couros de bovinos e de equinos (apergaminhados)','Other bovine leather and equine leather (parchment-dressed)','Otros cueros de bovinos y equinos (apergaminar)',41,4104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410441,'Couros e peles curtidos, de bovinos ou de eqüídeos, depilados, no estado seco (crust), plena flor; não divididos; divididos, com a flor','Full grains leather, unsplit and grain splits leather, in the dry state crust, of hides and skins of bovine incl. buffalo or equine animals, without hair on (excl. further prepared)','Plena flor sin dividir o divididos con la flor, en estado seco "crust", de cueros y pieles de bovino, incl. el búfalo, o de equino, depilados (exc. preparados de otra forma)',41,4104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410449,'Outros couros e peles curtidos, de bovinos ou de eqüídeos, depilados, no estado seco (crust)','Hides and skins of bovine incl. buffalo or equine animals, in the dry state crust, without hair on, whether or not split (excl. further prepared and full grains, unsplit and grain splits)','Cueros y pieles, de bovino, incl. el búfalo, o de equino, en estado seco "crust", depilados, incl. divididos (exc. preparados de otra forma, así como plena flor sin dividir o divididos con la flor)',41,4104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410510,'Peles de ovinos, depiladas, mesmo divididas, no estado úmido (incluindo wet blue)','Skins of sheep or lambs, in the wet state incl. wet-blue, tanned, without wool on, whether or not split (excl. further prepared and pre-tanned only)','Cueros y pieles, de ovino, en estado húmedo, incl. el "wet blue", curtidos, depilados, incl. divididos (exc. preparados de otra forma o solamente precurtidos)',41,4105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410511,'peles depiladas, de ovinos, com pre-curtimenta vegetal','dehaired skins, of sheep, with vegetable pre-tanned','pieles depiladas, de ovinos, con precurtido vegetal',41,4105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410512,'Couro de pele de ovelha ou carneiro (sem lã, pré-curtimenta de outro modo)','Sheep or lamb skin leather (without wool on; otherwise pre-tanned)','Cueros de piel de oveja o de cordero (sin lana, de lo contrario el precurtido)',41,4105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410519,'outras peles depiladas, de ovinos, curtidas ou recurtidas','other dehaired skins, of sheep, tanned or retanned','otras pieles depiladas, de ovinos, curtidas o recurtidas',41,4105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410520,'Couro de pele de ovelha ou carneiro (sem lã, pré-curtimenta)','Sheep or lamb skin leather (without wool on; parchment-dressed)','Cueros de piel de oveja o de cordero (sin lana,  precurtido)',41,4105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410530,'Peles depiladas de ovinos, mesmo divididas, no estado seco (crust)','Skins of sheep or lambs, in the dry state crust, without wool on, whether or not split (excl. further prepared and pre-tanned only)','Cueros y pieles, de ovino, en estado seco "crust", depilados, incl. divididos (exc. preparados de otra forma o solamente precurtidos)',41,4105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410611,'Peles depiladas, de caprinos, com pre-curtimenta vegetal','Dehaired skins, of goats, with vegetable pre-tanned','Pieles depiladas, de caprinos, con precurtido vegetal',41,4106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410612,'Couro de pele de cabra (sem cabelo; pré-curtido de outro modo)','Goat or kid skin leather (without hair on; otherwise pre-tanned)','Cueros de pieles de cabra (sin pelo,  precurtido de otra manera)',41,4106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410619,'Outras peles depiladas, de caprinos, curtidas ou recurtidas','Other dehaired skins, of goats, tanned or retanned','Otras pieles depiladas, de caprinos, curtidas o recurtidas',41,4106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410620,'Couro de pele de cabra (sem cabelo; pré-curtimenta)','Goat or Kid Skin Leather (Without Hair On; Parchment-dressed)','Cueros de pieles de cabra (sin pelo,  precurtido)',41,4106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410621,'Couros e peles depilados de caprinos, mesmo divididos, no estado úmido (incluindo wet blue)','Hides and skins of goats or kids, in the wet state incl. wet-blue, tanned, without wool on, whether or not split (excl. further prepared and pre-tanned only)','Cueros y pieles de caprino, en estado húmedo, incl. el "wet blue", curtidas, depiladas, incl. divididas (exc. preparadas de otra manera o solamente precurtidas)',41,4106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410622,'Couros e peles depilados de caprinos, mesmo divididos, no estado seco (crust)','Hides and skins of goats or kids, in the dry state crust, without wool on, whether or not split (excl. further prepared and pre-tanned only)','Cueros y pieles de caprino, en estado seco "crust", depiladas, incl. divididas (exc. preparadas de otra manera o solamente precurtidas)',41,4106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410631,'Couros e peles depilados de suínos, mesmo divididos, curtidos, no estado úmido (incluindo wet blue)','Hides and skins of swine, in the wet state incl. wet-blue, tanned, without wool on, whether or not split (excl. further prepared and pre-tanned only)','Cueros y pieles, de porcino, en estado húmedo, incl. el "wet blue", curtidos, depilados, incl. divididos (exc. preparados de otra manera o solamente precurtidos)',41,4106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410632,'Couros e peles depilados de suínos, mesmo divididos, curtidos, no estado seco (crust)','Hides and skins of swine, in the dry state crust, without wool on, whether or not split (excl. further prepared and pre-tanned only)','Cueros y pieles, de porcino, en estado seco "crust", depilados, incl. divididos (exc. preparados de otra manera o solamente precurtidos)',41,4106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410640,'Couros e peles de répteis, mesmo divididos, curtidos ou crust','Tanned or crust hides and skins of reptiles, whether or not split (excl. further prepared)','Cueros y pieles de reptil, curtidos o "crust", incl. divididos (exc. preparados de otra manera)',41,4106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410691,'Couros e peles depilados de outros animais, mesmo divididos, curtidos, no estado úmido (incluindo wet blue)','Hides and skins of antelopes, deer, elks, elephants and other animals, incl. sea animals, without wool or hair on, and leather of hairless animals, in the wet state incl. wet-blue, tanned, whether or not split (excl. further prepared and of bovine and equ','Cueros y pieles, depilados, de antílopes, corzos, gamuzas, renos, alces, elefantes y demás animales, incl. marinos, así como las y pieles de animales sin pelo, en estado húmedo, incl. el "wet blue", curtidos, incl. divididos (exc. preparados de otra maner',41,4106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410692,'Couros e peles depilados de outros animais, mesmo divididos, curtidos, no estado seco (crust)','Hides and skins of antelopes, deer, elks, elephants and other animals, incl. sea animals, without wool or hair on, and leather of hairless animals, in the dry state crust,  whether or not split (excl. further prepared and of bovine and equine animals, she','Cueros y pieles, depilados, de antílopes, corzos, gamuzas, renos, alces, elefantes y demás animales, incl. marinos, así como las pieles de animales sin pelo, en estado seco "crust", incl. divididos (exc. preparados de otra manera o solamente precurtidos, ',41,4106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410710,'Couro depilado de suínos','Leather of swine (without hair on)','Cuero, sin pelo, de cerdo',41,4107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410711,'Couros e peles inteiros, de bovinos ou de eqüídeos, preparados após curtimenta ou secagem e couros e peles apergaminhados, depilados, plena flor, não divididos ','Full grains leather incl. parchment-dressed leather, unsplit, of the whole hides and skins of bovine incl. buffalo or equine animals, further prepared after tanning or crusting, without hair on (excl. chamois leather, patent leather and patent laminated l','Plena flor sin dividir, de cueros preparados después del curtido o del secado y cueros y pieles apergaminados, enteros, de bovino, incl. el búfalo, o de equino, depilados (exc. cueros y pieles agamuzados, charolados y sus imitaciones de cueros o pieles ch',41,4107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410712,'Couros e peles inteiros, de bovinos ou de eqüídeos, preparados após curtimenta ou secagem e couros e peles apergaminhados, depilados, divididos, com a flor','Grain splits leather incl. parchment-dressed leather, of the whole hides and skins of bovine incl. buffalo or equine animals, further prepared after tanning or crusting, without hair on (excl. chamois leather, patent leather and patent laminated leather, ','Cueros preparados después del curtido o del secado y cueros y pieles apergaminados, divididos con la flor, enteros, de bovino, incl. el búfalo, o de equino, depilados (exc. cueros y pieles agamuzados, charolados y sus imitaciones de cueros o pieles chapad',41,4107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410719,'Outros couros e peles inteiros, de bovinos ou de eqüídeos, preparados após curtimenta ou secagem e couros e peles apergaminhados, depilados','Leather incl. parchment-dressed leather of the whole hides and skins of bovine incl. buffalo or equine animals, further prepared after tanning or crusting, without hair on (excl. unsplit full grains leather, grain splits leather, chamois leather, patent l','Cueros preparados después del curtido o del secado y cueros y pieles apergaminados, enteros, de bovino, incl. el búfalo, o de equino, depilados (exc. plena flor sin dividir o divididos con la flor; cueros y pieles agamuzados, charolados y sus imitaciones ',41,4107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410721,'Peles de répteis, com pre-curtimenta vegetal','reptiles skins, with vegetal pre-tanning','pieles de reptil, con precurtido vegetal',41,4107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410729,'outras peles de répteis, preparadas','other reptiles skins, prepared','otras pieles de reptil, preparadas',41,4107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410790,'peles depiladas, de outros animais, preparadas','waxed skin, of other animals, prepared','pieles depiladas, de otros animales, preparadas',41,4107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410791,'Couros e peles, incluídas as ilhargas, de bovinos ou de eqüídeos, preparados após curtimenta ou secagem e couros e peles apergaminhados, depilados, plena flor, não divididos','Full grains leather incl. parchment-dressed leather, unsplit, of the portions, strips or sheets of  hides and skins of bovine incl. buffalo or equine animals, further prepared after tanning or crusting, without hair on (excl. chamois leather, patent leath','Plena flor sin dividir, de trozos, hojas o placas de cueros preparados después del curtido o del secado y cueros y pieles apergaminados, de bovino, incl. el búfalo, o de equino, depilados (exc. cueros y pieles agamuzados, charolados y sus imitaciones de c',41,4107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410792,'Couros e peles, incluídas as ilhargas, de bovinos ou de eqüídeos, preparados após curtimenta ou secagem, divididos, com a flor','Grain splits leather incl. parchment-dressed leather, of the portions, strips or sheets of  hides and skins of bovine incl. buffalo or equine animals, further prepared after tanning or crusting, without hair on (excl. chamois leather, patent leather and p','Trozos, hojas o placas de cueros preparados después del curtido o del secado y cueros y pieles apergaminados, divididos con la flor, de bovino, incl. el búfalo, o de equino, depilados (exc. cueros y pieles agamuzados, charolados y sus imitaciones de cuero',41,4107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410799,'Outros couros e peles, incluídas as ilhargas, de bovinos ou de eqüídeos, preparados após curtimenta ou secagem','Leather incl. parchment-dressed leather of the portions, strips or sheets of  hides and skins of bovine incl. buffalo or equine animals, further prepared after tanning or crusting, without hair on (excl. unsplit full grains leather, grain splits leather, ','Trozos, hojas o placas de cueros preparados después del curtido o del secado y cueros y pieles apergaminados, de bovino, incl. el búfalo, o de equino, depilados (exc. plena flor sin dividir y divididos con la flor; cueros y pieles agamuzados, charolados y',41,4107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410800,'Couros e peles, acamurçados, incluindo a camurça combinada','Leathers and skins, chamois, incl.combined chamois','Cueros y pieles, agumuzados, incl.el agumuzado combinado',41,4108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (410900,'Patente de couro, peles envernizados, couro metalizado','Patent leather, patent laminated leather, metallized leather','Patentes de cuero, charol laminado, cueros y pieles metalizados',41,4109);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (411000,'aparas e outros desperd.de couros/peles, preparados, etc.','leathers and skins, chips and other wastes, prepar.etc.','recortes y demás desperd.de cueros/pieles, prepars., etc',41,4110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (411100,'couro reconstituido em chapas, folhas ou tiras','leather reconstituted in foils, leaves or strips','cuero regenerado en placas, hojas o tiras',41,4111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (411200,'Couros de ovinos, preparados após curtimenta ou após secagem e couros e peles apergaminhados, depilados, mesmo divididos ','Leather further prepared after tanning or crusting incl. parchment-dressed leather, of sheep or lambs, without wool on, whether or not split (excl. chamois leather, patent leather and patent laminated leather, and metallised leather)','Cueros preparados después del curtido o del secado y cueros y pieles apergaminados, de ovino, depilados, incl. divididos (exc. cueros y pieles agamuzados, charolados y sus imitaciones de cueros o pieles chapados, así como los cueros y pieles metalizados)',41,4112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (411310,'Couros de caprinos, preparados após curtimenta ou após secagem e couros e peles apergaminhados, depilados, mesmo divididos','Leather further prepared after tanning or crusting incl. parchment-dressed leather, of goats or kids, without wool or hair on, whether or not split (excl. chamois leather, patent leather and patent laminated leather, and metallised leather)','Cueros preparados después del curtido o del secado y cueros y pieles apergaminados, de caprino, depilados, incl. divididos (exc. cueros y pieles agamuzados, charolados y sus imitaciones de cueros o pieles chapados, así como los cueros y pieles metalizados',41,4113);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (411320,'Couros de suínos, preparados após curtimenta ou após secagem e couros e peles apergaminhados, depilados, mesmo divididos','Leather further prepared after tanning or crusting incl. parchment-dressed leather, of pigs, without hair on, whether or not split (excl. chamois leather, patent leather and patent laminated leather, and metallised leather)','Cueros preparados después del curtido o del secado y cueros y pieles apergaminados, de porcino, depilados, incl. divididos (exc. cueros y pieles agamuzados, charolados y sus imitaciones de cueros o pieles chapados, así como los cueros y pieles metalizados',41,4113);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (411330,'Couros de répteis, preparados após curtimenta ou após secagem e couros e peles apergaminhados, depilados, mesmo divididos','Leather further prepared after tanning or crusting incl. parchment-dressed leather, of reptiles,, whether or not split (excl. chamois leather, patent leather and patent laminated leather, and metallised leather)','Cueros preparados después del curtido o del secado y cueros y pieles apergaminados, de reptil, incl. divididos (exc. cueros y pieles agamuzados, charolados y sus imitaciones de cueros o pieles chapados, así como los cueros y pieles metalizados)',41,4113);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (411390,'Couros de outros animais, preparados após curtimenta ou após secagem e couros e peles apergaminhados, depilados, mesmo divididos','Leather further prepared after tanning or crusting incl. parchment-dressed leather, of antelopes, deer, elks, elephants and other animals, incl. sea animals, without wool or hair on, and leather of hairless animals, whether or not split (excl. leather of ','Cueros preparados después del curtido o del secado y cueros y pieles apergaminados, de antílopes, corzos, gamuzas, renos, alces, elefantes y demás animales, incl. marinos, depilados, incl. divididos; cueros preparados después del curtido o del secado y cu',41,4113);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (411410,'Couros e peles acamurçados (incluída a camurça combinada)','Chamois leather, incl. combination chamois leather (excl. glacé-tanned leather subsequently treated with formaldehyde and leather stuffed with oil only after tanning)','Cueros y pieles agamuzados, incl. el agamuzado combinado al aceite (exc. cueros y pieles previamente adobados al alumbre y después tratados con formol, así como los cueros y pieles simplemente engrasados con aceite después de curtidos por otros procedimie',41,4114);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (411420,'Couros e peles envernizados ou revestidos; couros e peles metalizados ','Patent leather and patent laminated leather; metallised leather (excl. lacquered or metallised reconstituted leather)','Cueros y pieles charolados y sus imitaciones de cueros o pieles chapados; cueros y pieles metalizados (exc. cuero regenerado charoladoado o metalizado)',41,4114);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (411510,'Couro reconstituído, à base de couro ou de fibras de couro, em placas, folhas ou tiras, mesmo enroladas','Composition leather based on leather or leather fibre, in slabs, sheets or strip, whether or not in rolls','Cuero regenerado a base de cuero o de fibras de cuero, en placas, hojas o tiras, incl. enrolladas',41,4115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (411520,'Aparas e outros desperdícios de couros ou de peles preparados ou reconstituídos; serragem, pó e farinha de couro','Parings and other waste of leather or of composition leather, not suitable for the manufacture of leather articles; leather dust, powder and flour','Recortes y demás desperdicios de cuero o piel, preparados, o de cuero regenerado, inutilizables para la fabricación de manufacturas de cuero; aserrín, polvo y harina de cuero',41,4115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420100,'Artigos de seleiro ou de correeiro para animais, de quaisquer matérias','Saddlery and harness for any animal, incl. traces, leads, knee pads, muzzles, saddle cloths, saddlebags, dog coats and the like, of any material (excl. harnesses for children and adults, riding whips and other goods of heading 6602)','Artículos de talabartería o guarnicionería para todos los animales, incl. los tiros, traíllas, rodilleras, bozales, sudaderos, alforjas, abrigos para perros y artículos simil., de cualquier materia (exc. arneses para niños o adultos, así como los látigos,',42,4201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420211,'Malas, maletas, pastas e artefatos semelhantes, com a superfície exterior de couro natural ou reconstituído ou de couro envernizado','Trunks, suitcases, vanity cases, executive-cases, briefcases, school satchels and similar containers, with outer surface of leather, composition leather or patent leather','Baúles, maletas "valijas", maletines, incl. los de aseo y los portadocumentos, portafolios "carteras de mano", cartapacios y continentes simil., con la superficie exterior de cuero natural, cuero regenerado o cuero charolado',42,4202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420212,'Malas, maletas, pastas e artefatos semelhantes, com a superfície exterior de plástico ou de matérias têxteis','Trunks, suitcases, vanity cases, executive-cases, briefcases, school satchels and similar containers, with outer surface of plastics or textile materials','Baúles, maletas "valijas", maletines, incl. los de aseo y los portadocumentos, portafolios "carteras de mano", cartapacios y continentes simil., con la superficie exterior de plástico o de materia textil',42,4202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420219,'Malas, maletas, pastas e artefatos semelhantes, de outras matérias','Trunks, suitcases, vanity cases, executive-cases, briefcases, school satchels and similar containers (excl. with outer surface of leather, composition leather, patent leather, plastics or textile materials)','Baúles, maletas "valijas", maletines, incl. los de aseo y los portadocumentos, portafolios "carteras de mano", cartapacios y continentes simil., con la superficie exterior de aluminio o de otras materias (exc. con la superficie exterior de cuero natural, ',42,4202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420221,'Bolsas, mesmo com tiracolo ou sem alças, com a superfície exterior de couro natural, reconstituído ou envernizado','Handbags, whether or not with shoulder straps, incl. those without handles, with outer surface of leather, composition leather or patent leather','Bolsos de mano "carteras", incl. con bandolera o sin asas, con la superficie exterior de cuero natural, cuero o regenerado o cuero charolado',42,4202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420222,'Bolsas, mesmo com tiracolo ou sem alças, com a superfície exterior de plástico ou de matérias têxteis','Handbags, whether or not with shoulder straps, incl. those without handles, with outer surface of plastic sheeting or textile materials','Bolsos de mano "carteras", incl. con bandolera o sin asas, con la superficie exterior de hojas de plástico o de materia textil',42,4202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420229,'Bolsas, mesmo com tiracolo ou sem alças, com a superfície exterior de outras matérias','Handbags, whether or not with shoulder strap, incl. those without handle, with outer surface of vulcanised fibre or paperboard, or wholly or mainly covered with such materials or with paper','Bolsos de mano "carteras", incl. con bandolera o sin asas, con la superficie exterior de fibra vulcanizada o cartón, o recubiertos totalmente o en su mayor parte con estas materias o papel',42,4202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420231,'Artigos do tipo dos normalmente levados nos bolsos ou bolsas, com a superfície exterior de couro natural, reconstituído ou envernizado','Wallets, purses, key-pouches, cigarette-cases, tobacco-pouches and similar articles carried in the pocket or handbag, with outer surface of leather, composition leather or patent leather','Billeteras, portamonedas, llaveros, petacas, pitilleras, bolsas para tabaco y demás artículos de bolsillo o de bolso de mano "carteras", con la superficie exterior de cuero natural, cuero regenerado o cuero charolado',42,4202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420232,'Artigos do tipo dos normalmente levados nos bolsos ou bolsas, com a superfície exterior de folhas de plástico ou de matérias têxteis','Wallets, purses, key-pouches, cigarette-cases, tobacco-pouches and similar articles carried in the pocket or handbag, with outer surface of plastic sheeting or textile materials','Billeteras, portamonedas, llaveros, petacas, pitilleras, bolsas para tabaco y demás artículos de bolsillo o de bolso de mano "carteras", con la superficie exterior de hojas de plástico o de materia textil',42,4202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420239,'Artigos do tipo dos normalmente levados nos bolsos ou bolsas, com a superfície exterior de outras matérias','Wallets, purses, key-cases, cigarette-cases, tobacco-pouches and similar articles of a kind normally carried in the pocket or handbag, with outer surface of vulcanised fibre or paperboard, or wholly or mainly covered with such materials or with paper, inc','Billeteras, portamonedas, llaveros, petacas, pitilleras, bolsas para tabaco y demás artículos de bolsillo o de bolso de mano "carteras", con la superficie exterior de fibra vulcanizada o cartón, o recubiertos totalmente o en su mayor parte con estas mater',42,4202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420291,'Outros artefatos com a superfície exterior de couro natural, reconstituído ou envernizado','Travelling-bags, insulated food or beverage bags, toilet bags, rucksacks, shopping-bags, map-cases, tool bags, sports bags, jewellery boxes, cutlery cases, binocular cases, camera cases, musical instrument cases, gun cases, holsters and similar containers','Sacos "bolsas" de viaje, sacos "bolsas" aislantes para alimentos y bebidas, bolsas de aseo, mochilas y bolsas para artículos de deporte, bolsas para la compra, mochilas, portamapas, bolsas para herramientas, estuches para frascos y botellas, estuches para',42,4202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420292,'Outros artefatos com a superfície exterior de folhas de plástico ou matérias têxteis','Travelling-bags, insulated food or beverage bags, toilet bags, rucksacks, shopping-bags, map-cases, tool bags, sports bags, jewellery boxes, cutlery cases, binocular cases, camera cases, musical instrument cases, gun cases, holsters and similar containers','Sacos "bolsas" de viaje, sacos "bolsas" aislantes para alimentos y bebidas, bolsas de aseo, mochilas y bolsas para artículos de deporte, bolsas para la compra, mochilas, portamapas, bolsas para herramientas, estuches para frascos y botellas, estuches para',42,4202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420299,'Outros artefatos com a superfície exterior de outras matérias','Travelling-bags, shopping or tool bags, jewellery boxes, cutlery cases and similar, with outer surface of vulcanised fibre or paperboard; cases for binoculars, cameras, musical instruments, guns, holsters and similar containers with outer surface of mater','Sacos de viaje, bolsas de aseo, mochilas y bolsas para artículos de deporte, bolsas para la compra, mochilas, portamapas, bolsas para herramientas, estuches para frascos y botellas, estuches para joyas, polveras, estuches para orfebrería y continentes sim',42,4202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420310,'Vestuário de couro natural ou reconstituído','Articles of apparel, of leather or composition leather (excl. clothing accessories, footware and headgear and parts thereof, and goods of chapter 95, e.g. shin guards, fencing masks)','Prendas de vestir, de cuero natural o cuero regenerado (exc. complementos "accesorios" de vestir, calzado y artículos de sombrerería, así como espinilleras, máscaras de esgrima y demás artículos del capítulo 95)',42,4203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420321,'Luvas, mitenes e semelhantes, concebidas para a prática de esportes, de couro natural ou reconstituído','Specially designed gloves for use in sport, of leather or composition leather','Guantes y manoplas, concebidos especialmente para la práctica del deporte, de cuero natural cuero regenerado',42,4203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420329,'Outras luvas, mitenes ou semelhantes, para outros usos, de couro natural ou reconstituído','Gloves, mittens and mitts, of leather or composition leather (excl. special sports gloves)','Guantes, mitones y manoplas, de cuero natural cuero regenerado (exc. concebidos especialmente para la práctica del deporte)',42,4203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420330,'Cintos, cinturões, bandoleiras ou talabartes de couro natural ou reconstituído','Belts and bandoliers, of leather or composition leather','Cintos, cinturones y bandoleras, de cuero natural cuero regenerado',42,4203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420340,'Outros acessórios de vestuário, de couro natural ou reconstituído','Clothing accessories of leather or composition leather (excl. gloves, mittens and mitts, belts, bandoliers, footware and headgear and parts thereof, and goods of chapter 95 [e.g. shin guards, fencing masks])','Complementos "accesorios" de vestir, de cuero natural cuero regenerado (exc. guantes, mitones y manoplas, cintos, cinturones y bandoleras, calzado y artículos de sombrerería y sus partes, así como espinilleras, máscaras de esgrima y demás artículos del ca',42,4203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420400,'Artigos para uso técnico, de couro natural','Articles for technical use, of leather','Artículos para usos técnicos, de cuero',42,4204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420500,'Outras obras de couro natural ou reconstituído','Articles of leather or composition leather (excl. saddlery and harness bags; cases and similar containers; apparel and clothing accessories; whips, riding-crops and similar of heading 6602; furniture; lighting appliances; toys; games; sports articles; but','Manufacturas de cuero natural cuero regenerado (exc. artículos de talabartería o guarnicionería y marroquinería; prendas y complementos "accesorios" de vestir; artículos para usos técnicos.; látigos y artículos simil. de la partida 6602; muebles y aparato',42,4205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420600,'Obras de tripa, de baudruches, de bexiga ou de tendões','Articles of gut, goldbeater''s skin, bladders or tendons (excl. silkworm gut, sterile catgut, other sterile surgical suture material and strings for musical instruments)','Manufacturas de tripa, vejigas o tendones',42,4206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420610,'Cordas de tripa','Catgut','Cuerdas de tripa',42,4206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (420690,'Outras obras de tripa, "baudruches", bexiga ou de tendoes','Other works of gut, "baudruches", bladder or of tendons','Otras manufacturas de tripa, vejigas o de tendones',42,4206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430110,'Peleteria em bruto, de vison, inteira, mesmo sem cabeça, cauda ou patas','Raw furskins of mink, whole, with or without heads, tails or paws','Pieles en bruto, de visón, enteras, incl. sin la cabeza, cola o patas',43,4301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430120,'peleteria em bruto, de coelho ou de lebre, inteira','raw furskins, of rabbit or of hare, whole','peleteria en bruto, de conejo o liebre, entera',43,4301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430130,'Peleteria em bruto, de cordeiros astracã, breitschwanz, caracul, persianer ou semelhantes, de cordeiros da Índia, da China, da Mongólia ou do Tíbete, inteira, mesmo sem cabeça, cauda ou patas','Raw furskins of the following types of lamb: Astrakhan, Caracul, Persian, Broadtail and similar, and Indian, Chinese, Mongolian or Tibetan, whole, with or without heads, tails or paws','Pieles en bruto, de cordero llam. "astracán", "breitschwanz", "caracul", "persa" o simil., de cordero de Indias, de China, de Mongolia o del Tíbet, enteras, incl. sin la cabeza, cola o patas',43,4301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430140,'Peleteria em bruto, de castor, inteira','Raw furskins, of beaver, whole','Peleteria en bruto, de castor, entera',43,4301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430150,'Peleteria em bruto, de rato-almiscarado, inteira','Raw furskins, of mouse-musky, whole','Peleteria en bruto, de rata almizclera, entera',43,4301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430160,'Peleteria em bruto, de raposa, inteira, mesmo sem cabeça, cauda ou patas','Raw furskins of fox, with or without heads, tails or paws','Pieles en bruto, de zorro, enteras, incl. sin la cabeza, cola o patas',43,4301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430170,'Peleteria em bruto, de foca ou de otaria, inteira','Raw furskins, of seal, whole','peleteria en bruto, de foca u otaria, entera',43,4301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430180,'Peleteria em bruto, de outros animais, inteira, mesmo sem cabeça, cauda ou patas','Raw furskins, whole, with or without heads, tails or paws (excl. those of mink, lamb - Astrachan, Caracul, Persian, Broadtail and similar, and Indian, Chinese, Mongolian or Tibetan - and fox)','Pieles en bruto, enteras, incl. sin la cabeza, cola o patas (exc. de visón, de cordero llamadas "astracán", "breitschwanz", "caracul", "persa" o similares, de cordero de Indias, de China, de Mongolia o del Tíbet, zorro, foca u otaria)',43,4301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430190,'Cabeças, caudas, patas e outras partes utilizáveis na indústria de peles','Heads, tails, paws and other pieces or cuttings of furskins suitable for use in furriery','Cabezas, colas, patas y trozos utilizables en peletería',43,4301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430211,'Peleteria (peles com pêlo) curtida ou acabada, de vison, inteira, mesmo sem cabeça, cauda ou patas, não reunida','Tanned or dressed furskins of mink, whole, with or without heads, tails or paws, not assembled','Pieles curtidas o adobadas, enteras, incl. sin la cabeza, cola o patas, sin ensamblar, de visón',43,4302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430212,'Peleteria curtida/acab.de coelho/lebre, inteir.n/reunida','Tanned/dressed furskins, rabbit/, whole, unassembled','Peleteria curtida/adobada, de conejo, entera, s/ensamblar',43,4302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430213,'Peleteria curtida/acabada, de cordeiros, inteir.n/reunida','Tanned/dressed furskins, of lamb, whole, unassembled','Peleteria curtida/adobada, de cordero, entera, s/ensamblar',43,4302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430219,'Peleteria (peles com pêlo) curtida ou acabada de outros animais, inteira, não reunida','Tanned or dressed furskins, whole, with or without heads, tails or paws, not assembled (excl. those of mink, Astrachan, Caracul, Persian, Broadtail or similar lamb, and Indian, Chinese, Mongolian or Tibetan lamb)','Pieles curtidas o adobadas, enteras, incl. sin la cabeza, cola o patas, sin ensamblar (exc. de visón, de cordero llamadas "astracán", "breitschwanz", "caracul", "persa" o similares, de cordero de Indias, de China, de Mongolia o del Tíbet)',43,4302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430220,'Cabeças, caudas, patas, desperdícios e aparas, curtidas ou acabadas, não reunidas','Heads, tails, paws and other pieces or cuttings of tanned or dressed furskins, not assembled','Cabezas, colas, patas y demás trozos, desechos y recortes, de pieles curtidas o adobadas, sin ensamblar',43,4302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430230,'Peleteria (peles com pêlo) curtida ou acabada, inteira e respectivos pedaços, reunidos (montados)','Tanned or dressed whole furskins and pieces or cuttings thereof, assembled, without the addition of other materials (excl. clothing, clothing accessories and other furskin articles)','Pieles enteras, trozos y recortes de pieles, curtidos o adobados, ensamblados, sin otras materias (exc. prendas, complementos "accesorios" de vestir y demás artículos de peletería)',43,4302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430310,'Vestuário e seus acessórios, de peleteria','Articles of apparel and clothing accessories of furskin (excl. gloves made of leather and furskin, footware and headgear and parts thereof)','Prendas y complementos "accesorios", de vestir, de peletería (exc. guantes mixtos de cuero y de peletería, calzado, artículos de sombrerería y sus partes)',43,4303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430390,'Outros artefatos de peleteria','Articles of furskin (excl. articles of apparel, clothing accessories and goods of chapter 95, e.g. toys, games and sports equipment)','Artículos de peletería (exc. prendas y complementos "accesorios" de vestir, así como juegos, juguetes, artefactos deportivos y demás artículos del capítulo 95)',43,4303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (430400,'Peleteria artificial e suas obras','Artificial fur and articles thereof (excl. gloves made of leather and artificial fur, footware and headgear and parts thereof, and goods of chapter 95, e.g. toys, games and sports equipment)','Peletería facticia o artificial  y artículos de peletería facticia o artificial (exc. guantes mixtos de cuero y de peletería facticia o artificial, calzado, artículos de sombrerería y sus partes, así como juegos, juguetes, artefactos deportivos y demás ar',43,4304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440110,'Lenha em qualquer estado','Fuel wood, in logs, billets, twigs, faggots or similar forms','Leña',44,4401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440121,'Madeira de coníferas, em estilhas ou em partículas','Coniferous wood in chips or particles (excl. those of a kind used principally for dying or tanning purposes)','Madera en plaquitas o escamillas, de coníferas (exc. de las especies utilizadas principalmente como tintóreas o curtientes)',44,4401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440122,'Madeira de não coníferas, em estilhas ou em partículas','Wood in chips or particles (excl. those of a kind used principally for dying or tanning purposes, and coniferous wood)','Madera en plaquitas o escamillas (exc. de las especies utilizadas principalmente como tintóreas o curtientes, así como de coníferas)',44,4401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440130,'Serragem, desperdícios e resíduos, de madeira','Sawdust and wood waste and scrap, whether or not agglomerated in logs, briquettes, pellets or similar forms','Aserrín, desperdicios y desechos, de madera, incl. aglomerados en  leños , briquetas, bolitas o formas simil.',44,4401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440131,'pellets de madeira','pellets de madeira','pellets de madeira',44,4401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440139,'outras serragens, desperdicios e residuos, de madeira','outras serragens, desperdicios e residuos, de madeira','outras serragens, desperdicios e residuos, de madeira',44,4401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440200,'carvão vegetal','wood charcoal','carbón vegetal',44,4402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440210,'Carvão vegetal de bambu, mesmo aglomerado','Bamboo charcoal, incl. shell or nut charcoal, whether or not agglomerated (excl. used as a medicament, mixed with incense, activated bamboo charcoal and in the form of crayons)','Carbón vegetal de bambú, incl. aglomerado',44,4402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440290,'Outros carvões vegetais, mesmo aglomerados','Wood charcoal, incl. shell or nut charcoal, whether or not agglomerated (excl. bamboo charcoal, wood charcoal used as a medicament, charcoal mixed with incense, activated charcoal and charcoal in the form of crayons)','Los demás carbones vegetales, incl. aglomerado',44,4402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440310,'Madeira em bruto, tratada com tinta, creosoto, ou com outros agentes de conservação','Wood in the rough, treated with paint, stains, creosote or other preservatives (excl. rough-cut wood for walking sticks, umbrellas, tool shafts and the like; wood in the form of railway sleepers; wood cut into boards or beams, etc.)','Madera en bruto, tratada con pintura, creosota u otros agentes de conservación (exc. madera simplemente desbastada o redondeada, para bastones, paraguas, mangos de herramientas o simil.; traviesas o durmientes para vías férreas o simil.; madera aserrada e',44,4403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440320,'Madeira de coníferas, em bruto','Coniferous wood in the rough, whether or not stripped of bark or sapwood, or roughly squared (excl. rough-cut wood for walking sticks, umbrellas, tool shafts and the like; wood in the form of railway sleepers; wood cut into boards or beams, etc.; wood tre','Madera de coníferas, en bruto, incl. descortezada, desalburada o escuadrada (exc. madera simplemente desbastada o redondeada, para bastones, paraguas, mangos de herramientas o simil.; traviesas o durmientes para vías férreas o simil.; madera aserrada en p',44,4403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440341,'Dark Red Meranti, Light Red Meranti e Meranti Bakau, em bruto, mesmo descascadas, desalburnadas ou esquadriadas','Dark red meranti, light red meranti and meranti bakau wood in the rough, whether or not stripped of bark or sapwood, or roughly squared (excl. rough-cut wood for walking sticks, umbrellas, tool shafts and the like; wood cut into boards or beams, etc.; woo','"Dark red meranti", "light red meranti" y "meranti bakau", en bruto, incl. descortezadas, desalburadas o escuadradas (exc. madera simplemente desbastada o redondeada, para bastones, paraguas, mangos de herramientas o simil.; madera aserrada en planchas, v',44,4403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440349,'Outras madeiras tropicais, em bruto','Tropical wood specified in the Subheading Note 1 to this chapter in the rough, whether or not stripped of bark or sapwood, or roughly squared (excl. dark red meranti, light red meranti, meranti bakau; rough-cut wood for walking sticks, umbrellas, tool sha','Maderas tropicales citadas en la nota de subpartida 1 del capítulo 44, en bruto, incl. descortezadas, desalburadas o escuadradas (exc. "dark red meranti", "light red meranti" y "meranti bakau"; madera simplemente desbastada o redondeada, para bastones, pa',44,4403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440391,'Madeira de carvalho (Quercus spp.), em bruto, mesmo descascada, desalburnada ou esquadriada','Oak Quercus spp. in the rough, whether or not stripped of bark or sapwood, or roughly squared (excl. rough-cut wood for walking sticks, umbrellas, tool shafts and the like;  wood in the form of railway sleepers;  wood cut into boards or beams, etc.;  wood','Madera de encina, roble, alcornoque y demás belloteros "Quercus spp.", en bruto, incl. descortezada, desalburada o escuadrada (exc. madera simplemente desbastada o redondeada, para bastones, paraguas, mangos de herramientas o simil.; traviesas o durmiente',44,4403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440392,'Madeira de faia (Fagus spp.), em bruto, mesmo descascada, desalburnada ou esquadriada','Beech Fagus spp. in the rough, whether or not stripped of bark or sapwood, or roughly squared (excl. rough-cut wood for walking sticks, umbrellas, tool shafts and the like;  wood in the form of railway sleepers;  wood cut into boards or beams, etc.;  wood','Madera de haya "Fagus spp.", en bruto, incl. descortezada, desalburada o escuadrada (exc. madera simplemente desbastada o redondeada, para bastones, paraguas, mangos de herramientas o simil.; traviesas o durmientes para vías férreas o simil.; madera aserr',44,4403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440399,'Outras madeiras em bruto','Wood in the rough, whether or not stripped of bark or sapwood, or roughly squared (excl. rough-cut wood for walking sticks, umbrellas, tool shafts and the like; wood cut into boards or beams, etc.; wood treated with paint, stains, creosote or other preser','Madera en bruto, incl. descortezada, desalburada o escuadrada (exc. de coníferas, de encina, roble, alcornoque y demás belloteros "Quercus spp.", de haya "Fagus spp." y maderas tropicales citadas en la nota de subpartida 1 del capítulo 44; madera simpleme',44,4403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440410,'Arcos de madeira, estacas fendidas, estacas aguçadas; madeira simplesmente desbastada ou arredondada para fabricação de bengalas, cabos de ferramenta e semelhantes; de coníferas','Hoopwood; split poles; piles, pickets and stakes of wood, pointed but not sawn lengthwise; wooden sticks, roughly trimmed but not turned, bent or otherwise worked, suitable for the manufacture of walking sticks, umbrellas, tool handles or the like; chipwo','Flejes de coníferas; rodrigones hendidos; estacas y estaquillas de coníferas, apuntadas, sin aserrar longitudinalmente; coníferas simplemente desbastadas o redondeadas, pero sin tornear, curvar ni trabajar de otro modo, para bastones, paraguas, mangos de ',44,4404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440420,'Arcos de madeira, estacas fendidas, estacas aguçadas; madeira simplesmente desbastada ou arredondada para fabricação de bengalas, cabos de ferramenta e semelhantes; madeira em fasquias, lâminas, fitas e semelhantes; de não coníferas','Hoopwood; split poles; piles, pickets and stakes of wood, pointed but not sawn lengthwise; wooden sticks, roughly trimmed but not turned, bent or otherwise worked, suitable for the manufacture of walking sticks, umbrellas, tool handles and the like; chipw','Flejes de madera; rodrigones hendidos; estacas y estaquillas de madera, apuntadas, sin aserrar longitudinalmente; madera simplemente desbastada o redondeada, pero sin tornear, curvar ni trabajar de otro modo, para bastones, paraguas, mangos de herramienta',44,4404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440500,'Lã de madeira e farinha de madeira','Wood wool; wood flour wood powder able to pass through a fine, 0,63 mm mesh, sieve with a residue of <= 8% by weight','Lana de madera; harina de madera, entendiendo por tal el polvo de madera que pase por un tamiz con abertura de mallas de 0,63 mm con un desperdicio <= 8% en peso',44,4405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440610,'Dormentes de madeira, para vias férreas ou semelhantes, não impregnados','Railway or tramway sleepers cross-ties of wood, not impregnated','Traviesas "durmientes" de madera para vías férreas o simil., sin impregnar',44,4406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440690,'Dormentes de madeira, para vias férreas ou semelhantes, impregnados','Railway or tramway sleepers cross-ties of wood, impregnated','Traviesas "durmientes" de madera para vías férreas o simil., impregnadas',44,4406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440710,'Madeira de coníferas, serrada, cortada em folhas ou desenrolada, de espessura > 6 mm','Coniferous wood sawn or chipped lengthwise, sliced or peeled, whether or not planed, sanded or end-jointed, of a thickness of > 6 mm','Madera de coníferas, aserrada o desbastada longitudinalmente, cortada o desenrollada, incl. cepillada, lijada o unida por los extremos, de espesor > 6 mm',44,4407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440721,'Madeira de mogno (Swietenia spp), serrada, cortada em folhas ou desenrolada, de espessura > 6mm','Mahogany Swietenia spp., sawn or chipped lengthwise, sliced or peeled, whether or not planed, sanded or end-jointed, of a thickness of > 6 mm','Madera de Mahogany (Swietenia spp.), aserrada o desbastada longitudinalmente, cortada o desenrollada, incl. cepillada, lijada o unida por los extremos, de espesor > 6 mm',44,4407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440722,'Madeira de virola, imbuia ou balsa,serrada, cortada em folhas ou desenrolada, de espessura > 6mm','Virola, imbuia and balsa, sawn or chipped lengthwise, sliced or peeled, of a thickness of > 6 mm, sanded, or end-jointed, whether or not planed','Madera de Virola, Imbuya y Balsa, aserrada o desbastada longitudinalmente, cortada o desenrollada, incl. cepillada, lijada o unida por los extremos, de espesor > 6 mm',44,4407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440724,'Madeiras serradas, cortadas em folhas, espessura >6mm','Sawn, sliced??, thick> 6mm','Aserrada, cortada, de espesor> 6 mm',44,4407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440725,'Madeira de Dark Red Meranti, Light Red Meranti e Meranti Bakau, serrada, cortada em folhas ou desenrolada, de espessura > 6 mm','Dark red meranti, light red meranti and meranti bakau, sawn or chipped lengthwise, sliced or peeled, whether or not planed, sanded or end-jointed, of a thickness of > 6 mm','"Dark red meranti", "light red meranti" y "meranti bakau", aserradas o desbastadas longitudinalmente, cortadas o desenrolladas, incl. cepilladas, lijadas o unidas por los extremos, de espesor > 6 mm',44,4407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440726,'Madeira de White Lauan, White Meranti, White Seraya Yellow Meranti e Alan, serradas, cortadas em folhas ou desenroladas, de espessura > 6 mm','White lauan, white meranti, white seraya, yellow meranti and alan, sawn or chipped lengthwise, sliced or peeled, whether or not planed, sanded or end-jointed, of a thickness of > 6 mm','"White lauan", "white meranti", "white seraya", "yellow meranti" y "alan", aserradas o desbastadas longitudinalmente, cortadas o desenrolladas, incl. cepilladas, lijadas o unidas por los extremos, de espesor > 6 mm',44,4407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440727,'Madeira de sapelli, serrada, cortada em folhas ou desenrolada, de espessura > 6mm','Sapelli, sawn or chipped lengthwise, sliced or peeled, whether or not planed, sanded or end-jointed, of a thickness of > 6 mm','Madera de Sapelli, aserrada o desbastada longitudinalmente, cortada o desenrollada, incl. cepillada, lijada o unida por los extremos, de espesor > 6 mm',44,4407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440728,'Madeira de iroco, serrada, cortada em folhas ou desenrolada, de espessura > 6mm','Iroko, sawn or chipped lengthwise, sliced or peeled, whether or not planed, sanded or end-jointed, of a thickness of > 6 mm','Madera de Iroko, aserrada o desbastada longitudinalmente, cortada o desenrollada, incl. cepillada, lijada o unida por los extremos, de espesor > 6 mm',44,4407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440729,'Outras madeiras tropicais (cedro, ipê, pau-marfim, louro, etc), serradas, cortadas em folhas ou desenroladas, de espessura > 6 mm','Tropical wood specified in Subheading Note 1 to this chapter, sawn or chipped lengthwise, sliced or peeled, whether or not planed, sanded or end-jointed, of a thickness of > 6 mm (excl. virola, mahogany Swietenia spp., imbuia, balsa, dark red meranti, lig','Maderas tropicales citadas en la nota de subpartida 1 del capítulo 44, aserradas o desbastadas longitudinalmente, cortadas o desenrolladas, incl. cepilladas, lijadas o unidas por los extremos, de espesor > 6 mm (exc. "virola", "mahogany" "Swietenia spp.",',44,4407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440791,'Madeira de carvalho (Quercus spp.), serrada, cortada em folhas ou desenrolada, de espessura > 6 mm','Oak Quercus spp., sawn or chipped lengthwise, sliced or peeled, whether or not planed, sanded or end-jointed, of a thickness of > 6 mm','Madera de encina, roble, alcornoque y demás belloteros "Quercus spp.", aserrada o desbastada longitudinalmente, cortada o desenrollada, incl. cepillada, lijada o unida por los extremos, de espesor > 6 mm',44,4407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440792,'Madeira de faia (Fagus spp.), serrada, cortada em folhas ou desenrolada, de espessura > 6 mm','Beech Fagus spp., sawn or chipped lengthwise, sliced or peeled, whether or not planed, sanded or end-jointed, of a thickness of > 6 mm','Madera de haya "Fagus spp.", aserrada o desbastada longitudinalmente, cortada o desenrollada, incl. cepillada, lijada o unida por los extremos, de espesor > 6 mm',44,4407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440793,'Madeira de ácer (Acer spp.), serrada, cortada em folhas ou desenrolada, de espessura > 6mm','Maple Acer spp., sawn or chipped lengthwise, sliced or peeled, whether or not planed, sanded or end-jointed, of a thickness of > 6 mm','Madera de arce (Acer spp.), aserrada o desbastada longitudinalmente, cortada o desenrollada, incl. cepillada, lijada o unida por los extremos, de espesor > 6 mm',44,4407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440794,'Madeira de cerejeira (Prunus spp.), serrada, cortada em folhas ou desenrolada, de espessura > 6mm','Cherry Prunus spp., sawn or chipped lengthwise, sliced or peeled, whether or not planed, sanded or end-jointed, of a thickness of > 6 mm','Madera de cerezo (Prunus spp.), aserrada o desbastada longitudinalmente, cortada o desenrollada, incl. cepillada, lijada o unida por los extremos, de espesor > 6 mm',44,4407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440795,'Madeira de freixo (Fraxinus spp.), serrada, cortada em folhas ou desenrolada, de espessura > 6mm','Ash Fraxinus spp., sawn or chipped lengthwise, sliced or peeled, whether or not planed, sanded or end-jointed, of a thickness of > 6 mm','Madera de fresno (Fraxinus spp.), aserrada o desbastada longitudinalmente, cortada o desenrollada, incl. cepillada, lijada o unida por los extremos, de espesor > 6 mm',44,4407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440799,'Outras madeiras, serradas, cortadas em folhas ou desenroladas, de espessura > 6 mm','Wood, sawn or chipped lengthwise, sliced or peeled, whether or not planed, sanded or end-jointed, of a thickness of > 6 mm (excl. tropical wood specified in Subheading Note 1 to this chapter, coniferous wood, oak Quercus spp., beech Fagus spp., maple Acer','Madera aserrada o desbastada longitudinalmente, cortada o desenrollada, incl. cepillada, lijada o unida por los extremos, de espesor > 6 mm (exc. maderas tropicales citadas en la nota de subpartida 1 del capítulo 44, así como madera de coníferas, de encin',44,4407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440810,'Folhas de madeira para folheados e para compensados, de coníferas, de espessura <= 6 mm','Sheets for veneering, incl. those obtained by slicing laminated wood, for coniferous plywood or for other similar laminated coniferous wood and other coniferous wood, sawn lengthwise, sliced or peeled, whether or not planed, sanded, spliced or end-jointed','Madera de coníferas en hojas para chapado, incl. las obtenidas por cortado de madera estratificada, para contrachapado o para otras maderas estratificadas similares y demás maderas de coníferas aserradas longitudinalmente, cortadas o desenrolladas, incl. ',44,4408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440831,'Folhas de madeira para folheados e para compensados, de dark ou light red meranti ou meranti bakau, de espessura <= 6 mm','Sheets for veneering, incl. those obtained by slicing laminated wood, for plywood or for other similar laminated wood and other wood, sawn lengthwise, sliced or peeled, whether or not planed, sanded, spliced or end-jointed, of a thickness of <= 6 mm, of d','Madera de "dark red meranti", "light red meranti" y "meranti bakau", en hojas para chapado, incl. las obtenidas por cortado de madera estratificada, para contrachapado o para otras maderas estratificadas similares y demás maderas de este tipo, aserradas l',44,4408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440839,'Folhas para folheados e para compensados, de outras madeiras tropicais, de espessura <= 6 mm','Sheets for veneering, incl. those obtained by slicing laminated wood, for plywood or for other similar laminated wood and other wood, sawn lengthwise, sliced or peeled, whether or not planed, sanded, spliced or end-jointed, of a thickness of <= 6 mm, of t','Maderas tropicales citadas en la nota de subpartida 1 del capítulo 44, en hojas para chapado, incl. las obtenidas por cortado de madera estratificada, para contrachapado o para otras maderas estratificadas similares y demás maderas tropicales citadas en l',44,4408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440890,'Folhas para folheados e para compensados, de outras madeiras, de espessura <= 6 mm','Sheets for veneering, incl. those obtained by slicing laminated wood, for plywood or for other similar laminated wood and other wood, sawn lengthwise, sliced or peeled, whether or not planed, sanded, spliced or end-jointed, of a thickness of <= 6 mm (excl','Hojas para chapado, incl. las obtenidas por cortado de madera estratificada, para contrachapado o para otras maderas estratificadas similares y demás maderas, aserradas longitudinalmente, cortadas o desenrolladas, incl. cepilladas, lijadas, unidas longitu',44,4408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440910,'Madeira de coníferas, perfilada','Coniferous wood, incl. strips and friezes for parquet flooring, not assembled, continuously shaped tongued, grooved, rebated, chamfered, V-jointed beaded, moulded, rounded or the like along any of its edges, ends or faces, whether or not planed, sanded or','Madera de coníferas, incl. las tablillas y frisos para parqués sin ensamblar, perfilada longitudinalmente con lengüetas, ranuras, rebajes, acanalados, biselados, con juntas en V, moldurados, redondeados o similares, en una o varias caras, cantos o extremo',44,4409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440920,'Madeira de não coníferas, perfilada','Non-coniferous wood, continuously shaped','Madera de distinta de las coníferas, perfilada long.',44,4409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440921,'Madeira de bambu, perfilada','Bamboo, incl. strips and friezes for parquet flooring, not assembled, continuously shaped tongued, grooved, rebated, chamfered, V-jointed beaded, moulded, rounded or the like along any of its edges, ends or faces, whether or not planed, sanded or end-join','Madera de bambú, perfilada',44,4409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (440929,'Outras madeiras perfiladas de não coníferas','Wood, incl. strips and friezes for parquet flooring, not assembled, continuously shaped tongued, grooved, rebated, chamfered, V-jointed beaded, moulded, rounded or the like along any of its edges, ends or faces, whether or not planed, sanded or end-jointe','Madera (incl. las tablillas y frisos para parqués, sin ensamblar) perfilada longitudinalmente (con lenguëtas, ranuras, rebajes, abanalados, biselados, con juntas en V, moldurados, redondeados o similares) en una o varias caras o cantos, incluso acepillada',44,4409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441011,'Painéis de partículas, de madeira','Particle board of wood, whether or not agglomerated with resins or other organic binding substances (excl. oriented strand board and waferboard, fibreboard and hollow-core composite panels)','Tableros de partículas, de madera',44,4410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441012,'Painéis denominados "oriented strand board" (OSB)','Oriented strand board OSB, of wood','Tableros llamados «oriented strand board» (OSB)',44,4410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441019,'Outros painéis de madeira (waferboard e outros)','Waferboard and similar board, of wood, whether or not agglomerated with resins or other organic binding substances (excl. unworked or not further worked than sanded, and oriented strand board, fibreboard and hollow-core composite panels)','Tableros llamados "waferboard" y tableros similares, de madera, incluso aglomerados con resinas u otros aglutinantes orgánicos (exc. brutos o simpl. lijados así como tableros dichos "oriented strand board", tableros de fibras y tableros celulares)',44,4410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441021,'Painéis de particul."waferboard", etc.em bruto','Particle board "waferboard", etc.unworked','Tableros de partícul.llamados "waferboard", etc.en bruto',44,4410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441029,'Outs.paineis de particulas "waferboard", etc.','Other particle board"waferboard", etc.','Ots.tableros de partícul.llamados "waferboard", etc.',44,4410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441031,'Outs.painéis de madeira em bruto/simpl.polido','Oth.board wood in brute/simply polished','Ots.tableros de madera en bruto/simplemente lijado',44,4410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441032,'Outs.painéis de madeira, recob.papel melamina','Other board wood, covered, melanine paper','Ots.tableros de madera, recubiertos c/papel melamina',44,4410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441033,'Outs.painéis de madeira recob.placas plástico','Other board wood, covered, laminates of plastics','Ots.tableros de madera, recubiertos c/placas de plástico',44,4410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441039,'Outros painéis de madeira','Other wood panels','Otros tableros de madera',44,4410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441090,'Outros painéis de matérias lenhosas, mesmo aglomeradas com resinas ou aglutinantes','Board of bagasse, bamboo or cereal straw particles or other ligneous materials, whether or not agglomerated with resins or other organic binding substances (excl. of wood, and fibreboard, cellular wood panels, veneered panels, panels of ligneous materials','Tableros de escamillas y tableros simil., de bagazo, de bambú, de paja de cereales u otras materias leñosas, incl. aglomerados con resinas o demás aglutinantes orgánicos (exc. tableros de fibra, tabl. de escamillas chapados, tabl. celulares y tabl. consti',44,4410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441111,'painéis de fibras de madeira, n/trab.mecan.d>0.8g/cm3','fibreboard of wood, n/mechanically worked d>0.8g/cm3','tableros de fibras de madera, s/trab.mecán.d>0.8g/cm3',44,4411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441112,'Painéis de média densidade (MDF), de espessura não superior a 5mm ','Medium density fibreboard MDF of wood, of a thickness <=Â 5Â mm','Tableros de media densidade, de espesor inferior o igual à 5 mm',44,4411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441113,'Painéis de média densidade (MDF) de espessura superior a 5mm, mas não superior a 9mm','Medium density fibreboard MDF of wood, of a thickness >Â 5Â mm but <=Â 9Â mm','Tableros de media densidade, de espesor superior à 5 mm pero inferior o igual à 9 mm',44,4411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441114,'Painéis de média densidade (MDF), de espessura superior a 9mm','Medium density fibreboard MDF of wood, of a thickness >Â 9Â mm','Tableros de media densidade, de espesor superior à 9 mm',44,4411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441119,'Outros painéis de fibras de madeira, densidade>0.8g/cm3','Other fibreboard of wood, density>0.8g/cm3','Ots.tableros de fibras de madera, densidad>0.8g/cm3',44,4411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441121,'Painéis de fibras de madeira, n/trab.mec.0.5<d<=0.8g/cm3','Fibreboard of wood, n/mechan.worked 0.5<d<=0.8g/cm3','Tableros de fibras de mad., s/trab.mecán.0.5<d<=0.8g/cm3',44,4411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441129,'Outs.painéis de fibras de madeira, 0.5g/cm3<d<=0, 8g/cm3','Oth.fibreboard of wood, 0.5g/cm3<d<=0.8g/cm3','Ots.tableros de fibras de madera, 0.5g/cm3<d<=0.8g/cm3',44,4411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441131,'Painéis de fibras madeira, n/trab.mecan.0.35<d<=0.5g/cm3','Fibreboard of wood, n/mechally worked 0.35<d<=0.5g/cm3','Tableros de fibras de mad, s/trab.mecán.0.35<d<=0.5g/cm3',44,4411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441139,'Outs.painéis de fibras de madeira, 0.35g/cm3<d<=0.5g/cm3','Other fibreboard of wood, 0.35<d<=0.5g/cm3','Ots.tableros de fibras de madera, 0.35<d<=0.5g/cm3',44,4411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441191,'Outs.painéis de fibras de madeira, n/trab.mecan.n/recob.','Other fibreboard of wood, n/mechally worked n/coved','Ots.tableros de fibras de madera, s/trab.mecán.ni recubr',44,4411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441192,'Painéis de fibra de madeira ou de outras matérias lenhosas, mesmo aglomeradas com resinas ou outros algutinantes orgânicos, com densidade superior a 0,8g/cm3','Fibreboard of wood or other ligneous materials, whether or not agglomerated with resins or other organic bonding agents, of a density of > 0,8 g/cm³ (excl. medium density fibreboard MDF;  particle board, whether or not bonded with one or more sheets of fi','Tableros de fibra de madera u otras materias leñosas, incl. aglomeradas con resinas o demás aglutinantes orgánicos, de densidad > 0,8 g/cm³',44,4411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441193,'Painéis de fibra de madeira ou de outras matérias lenhosas, mesmo aglomeradas com resinas ou outros algutinantes orgânicos, com densidade superior a 0,5g/cm3 mas não superior a 0,8g/cm3','Fibreboard of wood or other ligneous materials, whether or not agglomerated with resins or other organic bonding agents, of a density of > 0,5 g to 0,8 g/cm³ (excl. medium density fibreboard MDF; particle board, whether or not bonded with one or more shee','Tableros de fibra de madera u otras materias leñosas, incl. aglomeradas con resinas o demás aglutinantes orgánicos, de densidad entre 0,5 g/cm³ y 0,8 g/cm³',44,4411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441194,'Painéis de fibra de madeira ou de outras matérias lenhosas, mesmo aglomeradas com resinas ou outros algutinantes orgânicos, com densidade não superior a 0,5g/cm3','Fibreboard of wood or other ligneous materials, whether or not agglomerated with resins or other organic bonding agents, of a density of <= 0,5 g/cm³ (excl. medium density fibreboard MDF; particle board, whether or not bonded with one or more sheets of fi','Tableros de fibra de madera u otras materias leñosas, incl. aglomeradas con resinas o demás aglutinantes orgánicos, de densidad <= 0,5 g/cm³',44,4411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441199,'Outros painéis de fibras de madeira','Other fibreboard of wood','Ots.tableros de fibras de madera',44,4411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441210,'Madeira compensada ou folheada, e madeiras estratificadas semelhantes, de bambu','Veneered panels and similar laminated wood, of bamboo, not containing particle board and without blockboard, laminboard or battenboard (excl. plywood, sheets of compressed wood, hollow-core composite panels, parquet panels or sheets, inlaid wood and sheet','Maderas en bambú, chapadas, y maderas laminadas similares en bambú, sin tableros de partículas, sin tableros denominados "blockboard", "laminboard" y "battenboard" (exc. maderas contrachapadas, tableros en madera dichos "densificados", tableros celulares,',44,4412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441213,'Madeira compensada c/fls<=6mm, face de madeira tropical','Plywood consist.sheets<=6mm, face of tropical wood','Madera contrachapada c/hjs<=6mm, c/hj.ext.de mad.tropic.',44,4412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441214,'Madeira compensada c/fls<=6mm, face de madeira n/conifer','Plywood consist.sheets<=6mm, face of non-conferous wood','Mad.contrachapada c/hjs<=6mm, c/hj.ext.de mad.dist.coníf',44,4412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441219,'Outs.madeiras compensadas, com folhas de espessura<=6mm','Other plywood consisting in sheets of thickness<=6mm','Ots.maderas contrachapadas c/hojas<=6mm',44,4412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441222,'Outs.madeiras compens.face mad.n/conif.camada mad.trop.','Oth.plywood, ply of non-conferous wood, layer trop.wood','Ots.mad.contrach.c/hj.ext.de mad.dist.coníf.cam.m.trop.',44,4412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441223,'Outs.madeiras compens.face mad.n/conif.painel particula','Oth.plywood, ply of non-conferous wood, panel particle','Ots.mads.contrach.c/hj.ext.mad.dist.coníf.tablero part.',44,4412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441229,'Outs.madeiras compensadas, c/face de madeira n/conifera','Other plywood, with ply of tropical wood n/ coniferous','Ots.maderas contrachapadas c/hj.ext.de mad.dist.coníf.',44,4412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441231,'Madeira compensada, constituída por folhas de madeira (exceto bambu), cada uma das quais de espessura não superior a 6 mm, com pelo menos uma face de madeira tropicais','Plywood consisting solely of sheets of wood <= 6 mm thick, with at least one outer ply of tropical wood specified in Subheading Note 1 to this chapter (excl. sheets of compressed wood, hollow-core composite panels, inlaid wood and sheets identifiable as f','Madera contrachapada constituida exclusivamente de hojas de madera de espesor unitario <= 6 mm., teniendo al menos una hoja externa de las maderas tropicales citadas en la nota de subpartida 1 de este capítulo (exc. tableros en madera llamados "densificad',44,4412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441232,'Outras madeiras compensadas constituídas por folhas de madeira (exceto bambu), cada uma das quais de espessura não superior a 6 mm, com pelo menos uma face de madeira não conífera','Plywood consisting solely of sheets of wood <= 6 mm thick, with at least one outer ply of non-coniferous wood or other tropical wood than specified in Subheading Note 1 to this chapter (excl. of bamboo, and sheets of compressed wood, hollow-core composite','De maderas contrachapadas constituidas exclusivamente de hojas de madera de espesor unitario <= 6 mm., teniendo al menos una hoja externa de maderas otras que de coníferas y otras citadas en la nota de subpartida 1 de este capítulo (excl. bamboo, tableros',44,4412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441239,'Outras madeiras compensadas constituídas por folhas de madeira, cada uma das quais de espessura não superior a 6 mm','Plywood consisting solely of sheets of wood <= 6 mm thick (excl. of bamboo, plywood of subheadings 4412.31 and 4412.32; sheets of compressed wood, hollow-core composite panels, inlaid wood and sheets identifiable as furniture components)','Maderas contrachapadas constituidas exclusivamente de hojas de madera de espesor unitario <= 6 mm. (exc. bambú, maderas contrachapadas de las subpartidas 4412.31 y 4412.32, tableros de madera llamada "densificada'', tableros celulares, maderas incrustadas',44,4412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441292,'Outs.madeiras compensadas, c/camada de madeira tropical','Other plywood, with layer of tropical wood','Ots.maderas contrachapadas c/una hoja de madera tropic.',44,4412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441293,'Outras madeiras compensadas, com painel de partículas','Other plywood, with particle board','Ots.maderas contrachapadas c/un tablero de partículas',44,4412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441294,'Outras madeiras compensadas com alma aglomerada, alveolada ou lamelada','Veneered panels and similar laminated wood with  blockboard, laminboard or battenboard (excl. of bamboo, plywood consisting solely of sheets of wood <= 6 mm thick, sheets of compressed wood, inlaid wood and sheets identifiable as furniture components)','Maderas chapadas y maderas laminadas similares, con tableros denominados "blockboard", "laminboard" y "battenboard" (exc.bamboo, maderas contrachapadas constituidas exclusivamente de hojas de madera de espesor unitario <= 6 mm., tableros de madera llamada',44,4412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441299,'Outras madeiras compensadas, folheadas ou estratificadas','Veneered panels and similar laminated wood without blockboard, laminboard or battenboard (excl. of bamboo, such with at least one outer ply of non-coniferous wood, plywood consisting solely of sheets of wood <= 6 mm thick, sheets of compressed wood, hollo','Madera chapada y madera estratificada similar, sin tableros de escamillas (exc. madera de las subpartidas 4412.29 y 4412.92, madera contrachapada, tableros de madera llam. "densificada", tableros celulares, tableros para parqués, marquetería, madera tarac',44,4412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441300,'Madeira densificada, em blocos, pranchas, lâminas ou perfis','Metallised wood and other densified wood in blocks, plates, strips or profile shapes','Madera metalizada y demás madera densificada en bloques, tablas, tiras o perfiles',44,4413);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441400,'Molduras de madeira, para quadros, fotografias, espelho ou objetos semelhantes','Wooden frames for paintings, photographs, mirrors or similar objects','Marcos de madera para cuadros, fotografías, espejos u objetos simil.',44,4414);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441510,'Caixotes, caixas, engradados, barricas e embalagens semelhantes, de madeira; carretéis para cabos, de madeira','Cases, boxes, crates, drums and similar packings, of wood; cable-drums of wood','Cajones, cajas, jaulas, tambores y envases simil., de madera; carretes para cables, de madera',44,4415);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441520,'Paletes simples, paletes-caixas e estrados para carga, de madeira; taipais de paletes','Pallets, box pallets and other load boards, of wood; pallet collars of wood (excl. containers specially designed and equipped for one or more modes of transport)','Paletas, paletas caja y demás plataformas para carga, de madera; collarines para paletas, de madera (exc. contenedores especialmente concebidos y equipados para uno o varios medios de transporte)',44,4415);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441600,'Barris, cubas, balsas, dornas e outras obras de tanueiro, de madeira','Casks, barrels, vats, tubs and other coopers'' products parts thereof, of wood, incl. staves','Barriles, cubas, tinas y demás manufacturas de tonelería y sus partes, de madera, incl. las duelas',44,4416);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441700,'Ferramentas, armações e cabos de ferramentas, de escovas e de vassouras, de madeira; formas, alargadeiras e esticadores, de madeira, para calçados','Tools, tool bodies, tool handles, broom or brush bodies and handles, of wood; boot or shoe lasts and shoetrees, of wood (excl. forms used in the manufacture of hats, forms of heading 8480, other machines and machine components, of wood)','Herramientas, monturas y mangos de herramientas, monturas y mangos de cepillos, brochas o escobas, de madera; hormas, ensanchadores y tensores para el calzado, de madera (exc. hormas para sombrerería, moldes de madera de la partida 8480 y máquinas o parte',44,4417);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441810,'Janelas, janelas de sacada e respectivos caixilhos e alizares, de madeira','Windows, French windows and their frames, of wood','Ventanas, puertas vidriera, y sus marcos y contramarcos, de madera',44,4418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441820,'Portas e respectivos caixilhos, alizares e soleiras, de madeira','Doors and their frames and thresholds, of wood','Puertas y sus marcos, contramarcos y umbrales, de madera',44,4418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441830,'painéis de madeira, para soalhos','wood panels, for parquet','tableros de madera, para parqués',44,4418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441840,'Armações de madeira, para concreto','Wooden shuttering for concrete constructional work (excl. plywood boarding)','Encofrados de madera para hormigón (exc. de madera contrachapada)',44,4418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441850,'Fasquias de madeira, para telhados (shingles e shakes)','Shingles and shakes, of wood','Tablillas para cubierta de tejados o fachadas ["shingles" y"shakes"], de madera',44,4418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441860,'Postes e vigas de madeira','Posts and beams, of wood','Postes y vigas de madera',44,4418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441871,'Painéis montados para revestimentos de pavimentos (pisos) em mosaico','Flooring panels for mosaic floors, assembled, of wood','Tableros para suelos en mosaico',44,4418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441872,'Outros painéis montados para soalhos, de camadas múltiplas','Flooring panels, multilayer, assembled, of wood (excl. for mosaic floors)','Tableros para recubrimiento de suelos, multicapas, ensamblados, en madera (exc. tableros para recubrimiento de suelos en mosaico)',44,4418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441879,'Outros painéis montados para soalhos','Flooring panels, assembled, of wood (excl. multilayer panels and flooring panels for mosaic floors)','Tableros para recubrimiento de suelos, ensamblados, en madera (exc. tableros multicapas y tableros para recubrimiento de suelos en mosaico)',44,4418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441890,'Outras obras de marcenaria ou carpintaria, para construções','Builders'' joinery and carpentry, of wood, incl. cellular wood panels (excl. windows, French windows and their frames, doors and their frames and thresholds, posts and beams, assembled flooring panels, wooden shuttering for concrete constructional work, s','Obras y piezas de carpintería para construcciones, incl. los tableros celulares (exc. ventanas, puertas vidriera, y sus marcos y contramarcos; puertas y sus marcos, contramarcos y umbrales, tableros para parqués; encofrados para hormigón; tablillas para c',44,4418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (441900,'Artefatos de madeira, para mesa ou cozinha','Tableware and kitchenware, of wood (excl. interior fittings, ornaments, cooperage products, tableware and kitchenware components of wood, brushes, brooms and hand sieves)','Artículos de mesa o de cocina, de madera (exc. artículos de amoblado o de ornamentación, artículos de tonelería, partes de madera para artículos de mesa o de cocina, cepillos, escobas, cribas y cedazos de mano)',44,4419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (442010,'Estatuetas e outros objetos, de madeira, para ornamentação','Statuettes and other ornaments, of wood (excl. wood marquetry and inlaid wood)','Estatuillas y demás objeto de adorno, de madera (exc. marquetería y taracea)',44,4420);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (442090,'Madeira marchetada e madeira incrustada; cofres e estojos para joalharia, de madeira','Wood marquetry and inlaid wood; caskets and cases for jewellery or cutlery, and similar articles, of wood; wooden articles of furniture (excl. statuettes and other ornaments; furniture, lighting fixtures and parts thereof)','Marquetería y taracea; cofrecillos y estuches para joyería u orfebrería y manufacturas simil., de madera; artículos de mobiliario, de madera (exc. estatuillas y demás objetos de adorno, así como muebles, aparatos de alumbrado y sus partes)',44,4420);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (442110,'Cabides de madeira, para vestuário','Clothes hangers of wood','Perchas para prendas de vestir, de madera',44,4421);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (442190,'Outras obras de madeira','Other articles of wood, n.e.s.','Manufacturas de madera, n.c.o.p.',44,4421);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (450110,'Cortiça natural, em bruto ou simplesmente preparada','Natural cork, raw or simply prepared merely surface-worked or otherwise cleaned','Corcho natural en bruto o simplemente preparado "simplemente limpiado en la superficie o con los bordes limpios"',45,4501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (450190,'Desperdícios de cortiça, cortiça triturada, granulada ou pulverizada','Cork waste; crushed, powdered or ground cork','Desperdicios de corcho; corcho triturado, granulado o pulverizado',45,4501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (450200,'Cortiça natural, sem a crosta ou esquadriada, ou em cubos, chapas, folhas ou tiras de forma quadrada ou retangular','Natural cork, debacked or roughly squared, or in square or rectangular blocks, plates, sheets or strip, incl. sharp-edged blanks for corks or stoppers','Corcho natural, descortezado o simplemente escuadrado o en bloques, placas, hojas o tiras cuadradas o rectangulares, incl. los esbozos con aristas vivas para tapones',45,4502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (450310,'Rolhas de cortiça natural','Corks and stoppers of all types, of natural cork, incl. round-edged blanks','Tapones de todo tipo, de corcho natural, incl. los esbozos para tapones con aristas redondeadas',45,4503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (450390,'Outras obras de cortiça natural','Articles of natural cork (excl. cork in square or rectangular blocks, plates, sheets or strips; corks, stoppers and cork blanks; footware and parts thereof; insoles, whether or not removable; headgear and parts thereof; plugs and dividers for shotgun cart','Manufacturas de corcho natural (exc. cubos, planchas, hojas o tiras cuadradas o rectangulares; tapones y esbozos para tapones; calzado y sus partes, principalmente las plantillas no fijas; artículos de sombrerería y sus partes; tacos y separadores para ca',45,4503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (450410,'Cortiça aglomerada, em cubos, blocos, chapas, folhas e tiras; cilindros maciços, incluídos os discos','Tiles of any shape, blocks, plates, sheets and strip, solid cylinders, incl. discs, of agglomerated cork','Bloques, placas, hojas y tiras; baldosas y revestimientos simil. de pared, cualquier forma; cilindros macizos, incl. los discos',45,4504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (450490,'Outras obras de cortiça aglomerada','Agglomerated cork, with or without a binding substance, and articles of agglomerated cork (excl. footware and parts thereof; insoles, whether or not removable; headgear and parts thereof; plugs and dividers for shotgun cartridges; toys, games and sports e','Corcho aglomerado, incl. con aglutinante, y manufacturas de corcho aglomerado (exc. calzado y sus partes, principalmente las plantillas no fijas; artículos de sombrerería y sus partes; tacos y separadores para cartuchos de caza; juegos, juguetes, artefact',45,4504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (460110,'Tranças e artigos semelhs.de matérias para entrançar','plaits and similar products of plaiting materials','trenzas y artículos similares de materia trenzable',46,4601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (460120,'esteiras, capachos e divisórias, de matérias vegetais','mats, matting and screens, of vegetable materials','esterillas, esteras y cañizos, de materia vegetal',46,4601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (460121,'Esteiras, capachos, divisórias, de bambu','Mats, matting and screens of bamboo plaiting materials, flat-woven or bound together in parallel','Esterillas, esteras y cañizos, de bambú',46,4601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (460122,'Esteiras, capachos, divisórias, de ratã','Mats, matting and screens, of rattan plaiting materials, flat-woven or bound together in parallel','Esterillas, esteras y cañizos, de roten (ratán)',46,4601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (460129,'Esteiras, capachos, divisórias de outras matérias vegetais','Mats, matting and screens, of vegetable plaiting materials, flat-woven or bound together in parallel (excl. of bamboo and rattan)','Esterillas, esteras y cañizos, de otras materias vegetales',46,4601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (460191,'Tranças/etc.de matérias vegetais, tecidas/paralelizadas','Plaits/etc.of vegetable materials, strands/woven','Trenzas/etc.de materia vegetal, tejidas/paralelizadas',46,4601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (460192,'Tranças e artigos semelhantes de bambu,mesmo reunidos em tiras','Plaits and similar products, of bamboo plaiting materials, whether or not assembled into strips; plaiting materials, plaits and similar products of bamboo, flat-woven or bound together in parallel (excl. mats, matting and screens; wallcoverings of heading','Trenzas y artículos similares, de banbú, incl. ensamblados en tiras; materia trenzable, trenzas y artículos similares de materia trenzable vegetal, tejidos o paralelizados en forma plana (exc. esterillas, esteras y cañizos; revestimientos de p',46,4601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (460193,'Tranças e artigos semelhantes de ratã, mesmo reunidos em tiras','Plaits and similar products, of rattan plaiting materials, whether or not assembled into strips; plaiting materials, plaits and similar products of rattan, flat-woven or bound together in parallel (excl. mats, matting and screens; wallcoverings of heading','Trenzas y artículos similares, de roten (ratán), incl. ensamblados en tiras; materia trenzable, trenzas y artículos similares de materia trenzable vegetal, tejidos o paralelizados en forma plana (exc. esterillas, esteras y cañizos; revestimientos de p',46,4601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (460194,'Tranças e artigos semelhantes de outras matérias vegetais, mesmo reunidas em tiras','Plaits and similar products of vegetable plaiting materials, whether or not assembled into strips; plaiting materials, plaits and similar products of vegetable plaiting materials, flat-woven or bound together in parallel (excl. of bamboo and rattan; mats,','Trenzas y artículos similares de otras materias vegetales, incl. ensamblados en tiras; materia trenzable, trenzas y artículos similares de materia trenzable vegetal, tejidos o paralelizados en forma plana (exc. esterillas, esteras y cañizos; revestimiento',46,4601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (460199,'Tranças e matérias semelhantes de outras matérias, tecidas ou paralelizadas','Plaiting materials, plaits and similar products of non-vegetable plaiting materials, flat-woven or bound together in parallel (excl. wallcoverings of heading 4814; parts of footware or headgear)','Materia trenzable, trenzas y artículos simil. de materia trenzable no vegetal, tejidos o paralelizados en forma plana (exc. esterillas, esteras y cañizos; revestimientos de paredes de la partida 4814; calzado, artículos de sombrerería y sus partes)',46,4601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (460210,'obras de cestaria, de matérias vegetais','basketwork, of vegetable materials','artículos de cestería de materia vegetal',46,4602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (460211,'Obras de cestaria de bambu','Basketwork, wickerwork and other articles, made directly to shape from bamboo plaiting materials or made up from goods of bamboo plaiting materials of heading 4601, and articles of loofah (excl. wallcoverings of heading 4814; twine, cord and rope; footwar','Artículos de cestería de bambú obtenidos directamente en su forma con materia trenzable o confeccionados con artículos de la partida 4601; manufacturas de esponja vegetal [paste o "lufa"] (exc. revestimientos de paredes de la partida 8414; cordeles, cuerd',46,4602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (460212,'Obras de cestaria de ratã','Basketwork, wickerwork and other articles, made directly to shape from rattan plaiting materials or made up from goods of rattan plaiting materials of heading 4601, and articles of loofah (excl. wallcoverings of heading 4814; twine, cord and rope; footwar','Artículos de cestería de roten (ratán) obtenidos directamente en su forma con materia trenzable o confeccionados con artículos de la partida 4601; manufacturas de esponja vegetal [paste o "lufa"] (exc. revestimientos de paredes de la partida 8414; cordele',46,4602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (460219,'Obras de cestaria de outras matérias vegetais','Basketwork, wickerwork and other articles, made directly to shape from vegetable plaiting materials or made up from goods of vegetable plaiting materials of heading 4601, and articles of loofah (excl. of bamboo and rattan; wallcoverings of heading 4814; t','Artículos de cestería de otras materias vegetales obtenidos directamente en su forma con materia trenzable o confeccionados con artículos de la partida 4601; manufacturas de esponja vegetal [paste o "lufa"] (exc. revestimientos de paredes de la partida 84',46,4602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (460290,'Obras bucha; obras de cestaria de outras matérias para entrançar','Basketwork, wickerwork and other articles, made directly to shape from non-vegetable plaiting materials or made up from goods of non-vegetable plaiting materials of heading 4601 (excl. wallcoverings of heading 4814; twine, cord and rope; footware and head','Artículos de cestería obtenidos directamente en su forma con materia trenzable no vegetal o confeccionados con artículos de materia no vegetal de la partida 4601; manufacturas de esponja vegetal [paste o "lufa"] (exc. revestimientos de paredes de la parti',46,4602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470100,'Pastas mecânicas de madeira - celulose','Mechanical wood pulp, not chemically treated','Pasta mecánica, de madera, sin tratar químicamente',47,4701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470200,'Pasta química de madeira, para dissolução - celulose','Chemical wood pulp, dissolving grades','Pasta química, de madera, para disolver',47,4702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470311,'Pasta química de madeira de conífera, à soda ou sulfato, crua - celulose','Unbleached coniferous chemical wood pulp, soda or sulphate (excl. dissolving grades)','Pasta química, de madera de coníferas, a la sosa "soda" o al sulfato, cruda (exc. pasta para disolver)',47,4703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470319,'Pasta química de madeira de não conífera, à soda ou sulfato, crua - celulose','Unbleached non-coniferous chemical wood pulp, soda or sulphate (excl. dissolving grades)','Pasta química, de madera distinta de la de coníferas, a la sosa "soda" o al sulfato, cruda (exc. pasta para disolver)',47,4703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470321,'Pasta química de madeira de conífera, à soda ou ao sulfato semibranqueada ou branqueada - celulose','Semi-bleached or bleached coniferous chemical wood pulp, soda or sulphate (excl. dissolving grades)','Pasta química, de madera de coníferas, a la sosa "soda" o al sulfato, semiblanqueada o blanqueada (exc. pasta para disolver)',47,4703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470329,'Pasta química de madeira de não conífera, à soda ou sulfato, semibranqueada ou branqueada - celulose','Semi-bleached or bleached non-coniferous chemical wood pulp, soda or sulphate (excl. dissolving grades)','Pasta química, de madera distinta de la de coníferas, a la sosa "soda" o al sulfato, semiblanqueada o blanqueada (exc. pasta para disolver)',47,4703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470411,'Pasta química de madeira de conífera, ao bissulfito, crua - celulose','Unbleached coniferous chemical wood pulp, sulphite (excl. dissolving grades)','Pasta química de madera de coníferas, al sulfito, cruda (exc. pasta para disolver)',47,4704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470419,'Pasta química de madeira de não conífera, ao bissulfito, crua - celulose','Unbleached non-coniferous chemical wood pulp, sulphite (excl. dissolving grades)','Pasta química de madera distinta de la de coníferas, al sulfito, cruda (exc. pasta para disolver)',47,4704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470421,'Pasta química de madeira de conífera, ao bissulfito, semibranqueada ou branqueada - celulose','Semi-bleached or bleached coniferous chemical wood pulp, sulphite (excl. dissolving grades)','Pasta química de madera de coníferas, al sulfito, semiblanqueada o blanqueada (exc. pasta para disolver)',47,4704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470429,'Pasta química de madeira de não conífera, ao bissulfito, semibranqueada ou branqueada - celulose','Semi-bleached or bleached non-coniferous chemical wood pulp, sulphite (excl. dissolving grades)','Pasta química de madera distinta de la de coníferas, al sulfito, semiblanqueada o blanqueada (exc. pasta para disolver)',47,4704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470500,'Pastas de madeira obtidas pela combinação de um tratamento mecânico e de um tratamento químico - celulose','Wood pulp obtained by a combination of mechanical and chemical pulping processes','Pasta de madera obtenida por la combinación de tratamientos mecánico y químico',47,4705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470610,'Pastas de línteres de algodão - celulose','Pulp of cotton linters','Pasta de línter de algodón',47,4706);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470620,'Pastas de fibras obtidas do papel ou cartão reciclados (desperdícios e aparas) - celulose','Pulps of fibres derived from recovered waste and scrap paper or paperboard','Pasta de fibras obtenidas de papel o cartón reciclado "desperdicios y desechos"',47,4706);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470630,'Pastas de fibras celulósicas obtidas de bambu - celulose','Pulps of fibrous cellulosic bamboo material','Pasta de fibras celulósicas de bambú ',47,4706);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470691,'Pastas mecânicas de outras matérias fibrosas celulósicas - celulose','Mechanical pulp of fibrous cellulosic material (excl. that of bamboo, wood, cotton linters and fibres derived from recovered [waste and scrap] paper or paperboard)','Pasta de materias fibrosas celulósicas, mecánicas (exc. de madera y de línter de algodón, así como la pasta de fibras obtenidas de papel o cartón reciclado "desperdicios y desechos")',47,4706);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470692,'Pastas químicas de outras matérias fibrosas celulósicas - celulose','Chemical pulp of fibrous cellulosic material (excl. that of bamboo, wood, cotton linters and fibres derived from recovered [waste and scrap] paper or paperboard)','Pasta de materias fibrosas celulósicas, químicas (exc. de madera y de línter de algodón, así como la pasta de fibras obtenidas de papel o cartón reciclado "desperdicios y desechos")',47,4706);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470693,'Pastas semiquímicas de outras matérias fibrosas celulósicas - celulose','Semi-chemical pulp of fibrous cellulosic material (excl. that of bamboo, wood, cotton linters and fibres derived from recovered [waste and scrap] paper or paperboard)','Pasta de materias fibrosas celulósicas, semiquímicas (exc. de madera y de línter de algodón, así como la pasta de fibras obtenidas de papel o cartón reciclado "desperdicios y desechos")',47,4706);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470710,'Desperdícios de papel ou cartões, kraft, crus ou papéis ou cartões ondulados, de reciclar - celulose','Recovered waste and scrap paper or paperboard of unbleached kraft paper, corrugated paper or corrugated paperboard','Papel o cartón para reciclar "desperdicios y desechos", de papel o cartón Kraft crudo o de papel o cartón ondulado',47,4707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470720,'Outros papéis e cartões obtidos da pasta química branqueada, de reciclar - celulose','Recovered waste and scrap paper or paperboard made mainly of bleached chemical pulp, not coloured in the mass','Papel o cartón para reciclar "desperdicios y desechos", obtenido principalmente a partir de pasta química blanqueada sin colorear en la masa',47,4707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470730,'Desperdícios de papel e cartão obtidos da pasta mecânica, de reciclar - celulose','Recovered waste and scrap paper or paperboard made mainly of mechanical pulp, e.g. newspapers, journals and similar printed matter','Papel o cartón para reciclar "desperdicios y desechos", obtenido principalmente a partir de pasta mecánica, como, p.ej., diarios, periódicos e impresos simil.',47,4707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (470790,'Desperdícios de outros papéis ou cartões, de reciclar, inclusive não selecionados - celulose','Recovered waste and scrap paper or paperboard, incl. unsorted waste and scrap (excl. waste and scrap of unbleached kraft paper or kraft paperboard, or of corrugated paper or corrugated paperboard, that of paper or paperboard made mainly of bleached chemic','Papel o cartón para reciclar "desperdicios y desechos", incl. los desperdicios y desechos sin clasificar (exc. de papel o cartón Kraft crudo o de papel o cartón ondulado, de papeles o cartones obtenidos principalmente a partir de pasta química blanqueada ',47,4707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480100,'Papel jornal, em rolos ou em folhas','Newsprint as specified in Note 4 to chapter 48, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state','Papel prensa, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar',48,4801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480210,'Papel e cartão feitos à mão (folha a folha)','Handmade paper and paperboard of any size or shape','Papel y cartón hechos a mano "hoja a hoja", con cualquier forma y dimensión',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480220,'Papel e cartão próprios para fabricação de papéis ou cartões fotossensíveis, termossensíveis ou eletrossensíveis, em rolos ou folhas','Paper and paperboard of a kind used as a base for photosensitive, heat-sensitive or electrosensitive paper and paperboard, uncoated, in rolls or in square or rectangular sheets, of any size','Papel y cartón soporte para papel y cartón fotosensibles, termosensibles o electrosensibles, sin estucar ni recubrir, en bobinas "rollos" o en hojas de forma cuadrada o rectangular, de cualquier tamaño',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480230,'Papel para fabricação de papel carbono','Paper for the manufacture of carbon paper','Papel para la fabricación de papel carbón',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480240,'Papel próprio para fabricação de papéis de parede, em rolos ou folhas','Wallpaper base, uncoated','Papel soporte para papeles de decorar paredes, sin estucar ni recubrir',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480251,'papel e cartão c/fibra processo mecânico<=10%, p<40g/m2','paper/paperboard with fibre obt.mech.proc<=10%, w<40g/m2','papel y cartón c/fibra obt.proced.mecán.<=10%, p<40g/m2',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480252,'Papel para papel-moeda','Paper for paper money','Papel para el papel moneda',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480253,'Peso superior a 150 g/m2','Weighing more than 150 g/m2','De peso superior a 150 g/m2',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480254,'Papéis e cartões, não revestidos, contendo <= 10%, em peso, de fibras obtidas por processo mecânico ou químico-mecânico, de peso < a 40 g/m2, em rolos','Uncoated paper and paperboard, of a kind used for writing, printing or other graphic purposes, and non-perforated punchcards and punch-tape paper, in rolls or in square or rectangular sheets, of any size, not containing fibres obtained by a mechanical or ','Papeles y cartones, sin estucar ni recubrir, de los tipos utilizados para escribir, imprimir u otros fines gráficos, y papel y cartón para tarjetas o cintas para perforar, sin perforar, en bobinas "rollos" o en hojas de forma cuadrada o rectangular, de cu',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480255,'Papéis e cartões, não revestidos, contendo <= 10% de fibras obtidas por processo mecânico ou químico-mecânico, de peso => 40 g/m2 mas não > 150 g/m2, em rolos','Uncoated paper and paperboard, of a kind used for writing, printing or other graphic purposes, and non-perforated punchcards and punch-tape paper, in rolls of any size, not containing fibres obtained by a mechanical or chemi-mechanical process or of which','Papeles y cartones, sin estucar ni recubrir, de los tipos utilizados para escribir, imprimir u otros fines gráficos, y papel y cartón para tarjetas o cintas para perforar, sin perforar, en bobinas "rollos", de cualquier tamaño, sin fibras obtenidas por pr',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480256,'Papéis e cartões, não revestidos, contendo <= 10% de fibras obtidas por processo mecânico ou químico -mecânico, de peso => 40 g/m2 mas não > 150 g/m2, em folhas nas quais um lado <= 435 mm e o outro <= 297 mm, quando não dobradas','Uncoated paper and paperboard, of a kind used for writing, printing or other graphic purposes, and non-perforated punchcards and punch-tape paper, in square or rectangular sheets with one side <= 435 mm and the other side <= 297 mm in the unfolded state, ','Papeles y cartones, sin estucar ni recubrir, de los tipos utilizados para escribir, imprimir u otros fines gráficos, y papel y cartón para tarjetas o cintas para perforar, sin perforar, en hojas de forma cuadrada o rectangular con un lado <= 435 mm y el o',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480257,'Outros papéis e cartões não revestidos, contendo <= 10% de fibras obtidas por processo mecânico ou químico-mecânico, de peso => 40 g/m2 mas não > 150 g/m2, em rolos ou folhas','Uncoated paper and paperboard, of a kind used for writing, printing or other graphic purposes, and non-perforated punchcards and punch-tape paper, in square or rectangular sheets with one side > 435 mm or with one side <= 435 mm and the other side > 297 m','Papeles y cartones, sin estucar ni recubrir, de los tipos utilizados para escribir, imprimir u otros fines gráficos, y papel y cartón para tarjetas o cintas para perforar, sin perforar, en hojas de forma cuadrada o rectangular, con un lado <= 435 mm y el ',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480258,'Papéis e cartões, não revestidos, contendo <= 10% de fibras obtidas por processo mecânico ou químico-mecânico, de peso > 150 g/m2, em rolos ou folhas','Uncoated paper and paperboard, of a kind used for writing, printing or other graphic purposes, and non-perforated punchcards and punch-tape paper, in rolls or in square or rectangular sheets, of any size, not containing fibres obtained by a mechanical or ','Papeles y cartones, sin estucar ni recubrir, de los tipos utilizados para escribir, imprimir u otros fines gráficos, y papel y cartón para tarjetas o cintas para perforar, sin perforar, en bobinas "rollos" o en hojas de forma cuadrada o rectangular, de cu',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480260,'Outro papel e cartão, em que mais de 10 por cento em peso do conteúdo total de fibras é constituído por fibras obtidas por um processo mecânico','Other paper and paperboard, of which more than 10 percent by weight of the total fiber content consists of fibers obtained by a mechanical process','Otro tipo de papel y cartón, de los cuales más de 10 por ciento en peso del contenido total de fibras son obtenidas por un proceso mecánico',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480261,'Papéis e cartões, não revestidos, contendo > 10% de fibras obtidas por processo mecânico ou químico-mecânico, em rolos','Uncoated paper and paperboard, of a kind used for writing, printing or other graphic purposes, and non-perforated punchcards and punch-tape paper, in rolls of any size, of which > 10% by weight of the total fibre content consists of fibres obtained by a m','Papeles y cartones, sin estucar ni recubrir, de los tipos utilizados para escribir, imprimir u otros fines gráficos, y papel y cartón para tarjetas o cintas para perforar, sin perforar, en bobinas "rollos", de cualquier tamaño, con un contenido total de f',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480262,'Papéis e cartões, não revestidos, contendo > 10% de fibras obtidas por processo mecânico ou químico-mecânico, em folhas nas quais um lado <= 435 mm e o outro <= 297 mm, quando não dobradas','Uncoated paper and paperboard, of a kind used for writing, printing or other graphic purposes, and non-perforated punchcards and punch-tape paper, in square or rectangular sheets with one side <= 435 mm and the other side <= 297 mm in the unfolded state, ','Papeles y cartones, sin estucar ni recubrir, de los tipos utilizados para escribir, imprimir u otros fines gráficos, y papel y cartón para tarjetas o cintas para perforar, sin perforar, en hojas de forma cuadrada o rectangular con un lado <= 435 mm y el o',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480269,'Outros papéis e cartões não revestidos, contendo > 10% de fibras obtidas por processo mecânico ou químico-mecânico','Uncoated paper and paperboard, of a kind used for writing, printing or other graphic purposes, and non-perforated punchcards and punch-tape paper, in square or rectangular sheets with one side > 435 mm or with one side <= 435 mm and the other side > 297 m','Papeles y cartones, sin estucar ni recubrir, de los tipos utilizados para escribir, imprimir u otros fines gráficos, y papel y cartón para tarjetas o cintas para perforar, sin perforar, en hojas de forma cuadrada o rectangular con un lado > 435 mm o con u',48,4802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480300,'Papel para fabricação de papel higiênico ou de toucador e artigos semelhantes; pasta de celulose e mantas de fibras de celulose','Toilet or facial tissue stock, towel or napkin stock and similar paper for household or sanitary purposes, cellulose wadding and webs of cellulose fibres, whether or not creped, crinkled, embossed, perforated, surface-coloured, surface-decorated or printe','Papel del tipo utilizado para papel higiénico, toallitas para desmaquillar, toallas, servilletas o papeles simil. de uso doméstico, de higiene o tocador, guata de celulosa y napa de fibras de celulosa, incluso rizados ["crepes"], plisados, gofrados, estam',48,4803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480411,'Papel e cartão kraftliner, não revestidos, para cobertura, crus, em rolos ou folhas','Unbleached kraftliner, uncoated, in rolls of a width > 36 cm','Papel y cartón para caras "cubiertas" ["kraftliner"], sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm, crudos',48,4804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480419,'Outros papéis e cartões kraftliner, não revestidos, para cobertura, em rolos ou folhas','Kraftliner, uncoated, in rolls of a width > 36 cm (excl. unbleached and goods of heading 4802 and 4803)','Papel y cartón para caras "cubiertas" ["kraftliner"], sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm (exc. crudos, así como los artículos de las partidas 4802 ó 4803)',48,4804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480421,'Papel kraft para sacos de grande capacidade, não revestido, cru, em rolos ou folhas','Unbleached sack kraft paper, uncoated, in rolls of a width > 36 cm (excl. goods of heading 4802, 4803 or 4808)','Papel Kraft para sacos "bolsas", sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm, crudo (exc. artículos de las partidas 4802, 4803 ó 4808)',48,4804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480429,'Outros papéis kraft para sacos de grande capacidade, não revestidos, em rolos ou folhas','Sack kraft paper, uncoated, in rolls of a width > 36 cm (excl. unbleached, and goods of heading 4802, 4803 or 4808)','Papel Kraft para sacos "bolsas", sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm (exc. crudo, así como los artículos de las partidas 4802, 4803 ó 4808)',48,4804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480431,'Papel e cartão kraft, crus, não revestidos, de peso <= 150 g/m2, em rolos ou folhas','Unbleached kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state, weighing <= 150 g/m² (excl. kraftliner, sack kraft paper and goods of h','Papel y cartón Kraft, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar, de peso <= 150 g/m², crudos (exc. papel y cartón para caras "cubiertas" ["k',48,4804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480439,'Outros papéis e cartões kraft, não revestidos, de peso <= 150 g/m2, em rolos ou folhas','Kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state, weighing <= 150 g/m² (excl. unbleached, kraftliner, sack kraft paper and goods of ','Papel y cartón Kraft, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar, de peso <= 150 g/m² (exc. crudos, así como papel y cartón para caras "cubie',48,4804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480441,'Papel e cartão kraft, crus, não revestidos, de peso > 150 g/m2 e < 225 g/m2, em rolos ou folhas','Unbleached kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state, weighing > 150 g to < 225 g/m² (excl. kraftliner, sack kraft paper, and','Papel y cartón Kraft, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar, de peso > 150 g/m² pero < 225 g/m², crudos (exc. papel y cartón para caras ',48,4804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480442,'Papel e cartão kraft, branqueados, não revestidos, de peso > 150 g/m2 e < 225 g/m2, contendo mais de 95% em peso das fibras de madeira obtidas por processo químico, em rolos ou em folhas','Kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state, weighing > 150 g to < 225 g/m², bleached uniformly in the mass, containing > 95% c','Papel y cartón Kraft, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar, de peso > 150 g/m² pero < 225 g/m², blanqueados uniformemente en la masa y ',48,4804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480449,'Outros papéis e cartões kraft, não revestidos, de peso > 150 g/m2 e < 225 g/m2, em rolos ou folhas','Kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state, weighing > 150 g to < 225 g/m² (excl. unbleached, bleached uniformly in the mass a','Papel y cartón Kraft, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar, de peso > 150 g/m² pero < 225 g/m² (exc. crudos o blanqueados uniformemente',48,4804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480451,'Papel e cartão kraft, crus, não revestidos, de peso => 225 g/m2, em rolos ou folhas','Unbleached kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state, weighing >= 225 g/m² (excl. kraftliner, sack kraft paper and goods of h','Papel y cartón Kraft, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar, de peso >= 225 g/m², crudos (exc. papel y cartón para caras "cubiertas" ["k',48,4804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480452,'Papel e cartão kraft, branqueados, não revestidos, de peso => 225 g/m2, contendo em peso mais de 95% das fibras de madeira obtidas por processo químico, em rolos ou em folhas','Kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state, weighing >= 225 g/m², bleached uniformly in the mass, containing > 95% chemically ','Papel y cartón Kraft, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar, de peso >= 225 g/m², blanqueados uniformemente en la masa, con un contenido',48,4804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480459,'Outros papéis e cartões kraft, não revestidos, de peso => 225 g/m2, em rolos ou folhas','Kraft paper and paperboard, uncoated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state, weighing >= 225 g/m² (excl. unbleached or bleached uniformly in the mass and conta','Papel y cartón Kraft, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar, de peso >= 225 g/m² (exc. crudos o blanqueados uniformemente en la masa, co',48,4804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480510,'Papel semiquímico p/ondular, nao revestido, em rolos/fls.','Semi-chemical paper forcorrugated, uncoated, rolls/sheets','Papel semiquímico p/acanalar, sin recubrir, en bobs./hjs.',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480511,'Papel semiquímico para ondular, não revestido, em rolos ou em folhas','Semi-chemical fluting paper, uncoated, in rolls of a width > 36 cm','Papel semiquímico para acanalar, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480512,'Papel palha para ondular, não revestido, em rolos ou em folhas','Straw fluting paper, in rolls of a width > 36 cm, weighing >= 130 g/m²','Papel paja para acanalar, en bobinas "rollos" de anchura > 36 cm, de peso >= 130 g/m²',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480519,'Outros papéis para ondular, não revestidos, em rolos ou em folhas','Fluting paper, uncoated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state (excl. semi-chemical fluting paper and straw fluting paper)','Papel para acanalar, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar (exc. papel semiquímico para acanalar y papel paja para acanalar)',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480521,'Papel e cartão c/camadas múltiplas, branq.em rolos/fls','Multi-ply paper/paperb., bleached, rolls/sheets','Papel y cartón c/multicapas, blanq.en bobinas/hjs',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480522,'Papel/cartão c/camadas múltiplas, 1 camada exter.branq.','Multi-ply paper/paperb., 1 external bleached ply','Papel/cartón c/multicapas, una capa exterior blanqueada',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480523,'Papel/cartão c/camadas múltiplas, 2 camadas exter.branq.','Multi-ply paper/paperb., 2 external bleached ply','Papel/cartón c/multicapas, dos capas exter.blanqueadas',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480524,'Papel testliner (fibras recicladas), não revestido, em rolos ou em folhas, de peso <= 150 g/m2','Testliner recycled liner board, uncoated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state, weighing <= 150 g/m²','"Testliner", reciclado, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar, de peso <= 150 g/m²',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480525,'Papel testliner (fibras recicladas), não revestido, em rolos ou em folhas, de peso > 150 g/m2','Testliner recycled liner board, uncoated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state, weighing > 150 g/m²','"Testliner", reciclado, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar, de peso > 150 g/m²',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480529,'Outs.papéis/cartões de camadas multipl.n/rev.rolos/fls.','Oth.paper/paperb.of multiple layers, uncoat.rolls/sheets','Ots.papeles/cartones de multicapas, s/recub.bobinas/hjs.',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480530,'Papel sulfito para embalagem, não revestido, em rolos ou folhas','Sulphite wrapping paper, uncoated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state','Papel sulfito para envolver, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480540,'Papel-filtro e cartão-filtro, não revestidos, em rolos ou folhas','Filter paper and paperboard, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state','Papel y cartón filtro, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480550,'Papel-feltro, cartão-feltro e papel e cartão lanosos, não revestidos, em rolos ou folhas','Felt paper and paperboard, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state','Papel y cartón fieltro y papel y cartón lana, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480560,'Outs.papéis e cartões, n/revest.em rolos/fls.p<=150g/m2','Oth.paper/paperboard, uncoat.rolls/sheets w<=150g/m2','Ots.papeles y cartones, s/recubr.en bobs./fls.p<=150g/m2',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480570,'Outros papéis e cartões, peso superior a 150 g/m2, mas inferior a 225 g/m2','Other paper and paperboard, weighing more than 150 g/m2, but less than 225 g/m2','Los demás papeles y cartones, de gramaje superior a 150 g/m2, pero inferior a 225 g/m2',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480580,'Outs.papéis/cartões, p>=225g/m2, n/revest.em rolos/folhas','Oth.paper/paperboard, w<225g/m2, uncoat.rolls/sheets','Ots.papeles/cartones, p>=225g/m2, s/recubr.en bobinas/hjs',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480591,'Outros papéis e cartões, não revestidos, em rolos ou em folhas, de peso <= 150 g/m2','Paper and paperboard, uncoated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state, weighing <= 150 g/m², n.e.s.','Papeles y cartones, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar, de peso <= 150 g/m², n.c.o.p.',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480592,'Outros papéis e cartões, não revestidos, em rolos ou em folhas, de peso > 150 g/m2 e < 225 g/m2','Paper and paperboard, uncoated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state, weighing > 150 g to < 225 g/m², n.e.s.','Papeles y cartones, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar, de peso > 150 g/m² pero < 225 g/m², n.c.o.p.',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480593,'Outros papéis e cartões, não revestidos, em rolos ou em folhas, de peso => 225 g/m2','Paper and paperboard, uncoated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state, weighing >= 225 g/m², n.e.s.','Papeles y cartones, sin estucar ni recubrir, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar, de peso >= 225 g/m², n.c.o.p.',48,4805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480610,'Papel-pergaminho e cartão-pergaminho (sulfurizados), em rolos ou folhas','Vegetable parchment, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state','Papel y cartón sulfurizados "pergamino vegetal", en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar',48,4806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480620,'Papel impermeável a gorduras, em rolos ou folhas','Greaseproof papers, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state','Papel resistente a las grasas ["greaseproof"], en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar',48,4806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480630,'Papel vegetal, em rolos ou folhas','Tracing papers, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state','Papel vegetal "papel calco", en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar',48,4806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480640,'Papel cristal e outros papéis calandrados transparentes ou translúcidos, em rolos ou folhas','Glassine and other glazed transparent or translucent papers, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state (excl. vegetable parchment, greaseproof papers and tracing p','Papel cristal y demás papeles calandrados transparentes o traslúcidos, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar (exc. papel y cartón sulfurizados "pergamino vegetal',48,4806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480700,'Papel e cartão obtidos por colagem de folhas sobrepostas, não revestidos na superfície nem impregnados, mesmo reforçados interiormente, em rolos ou em folhas','Composite paper and paperboard made by sticking flat layers of paper or paperboard together with an adhesive, not surface-coated or impregnated, whether or not internally reinforced, in rolls of a width > 36 cm or in square or rectangular sheets with one ','Papel y cartón obtenidos por pegado de hojas planas, sin estucar ni recubrir en la superficie y sin impregnar, incl. reforzados interiormente, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro ',48,4807);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480710,'papel e cartão estratif.c/betume, etc.n/revest.em rolos,','stratified paper/paperb.with bitumen, etc.unc.rolls,','papel y cartón unidos c/betún, etc.s/recubr.en bobs.',48,4807);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480790,'outs.papéis/cartões da colag.de fls.n/revest.rolos/fls.','ot.comp.paper/paperb.(made stick.flat layers)unc.rolls,','ots.papeles/cartones de pegado de hjs.s/recub.bobs/hjs.',48,4807);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480810,'Papel e cartão ondulados, mesmo perfurados, em rolos ou folhas','Corrugated paper and paperboard with or without glued flat surface sheets, whether or not perforated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state','Papel y cartón corrugados, incl. revestidos por encolado, incl. perforado, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar',48,4808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480820,'Papel kraft para sacos de grande capacidade encrespado, mesmo gofrado, estampado ou perfurado, em rolos ou folhas','Sack kraft paper, creped or crinkled, whether or not embossed or perforated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state','Papel Kraft para sacos "bolsas", rizado ["crepé"] o plisado, incl. gofrado, estampado o perforado, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar',48,4808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480830,'Outros papéis kraft, encrespados ou plissados, mesmo gofrados, estampados ou perfurados, em rolos ou folhas','Kraft paper, creped or crinkled, whether or not embossed or perforated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state (excl. sack kraft paper)','Papeles Kraft, rizados o plisados, incl. gofrados, estampados o perforados, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar (exc. papel Kraft para sacos "bolsas")',48,4808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480840,'Papéis kraft,encrespados/plissados,mês.gof.est.ou per.','Papéis kraft,encrespados/plissados,mês.gof.est.ou per.','Papéis kraft,encrespados/plissados,mês.gof.est.ou per.',48,4808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480890,'Outros papéis e cartões ondulados, encrespados, em rolos ou folhas','Paper and paperboard, creped, crinkled, embossed or perforated, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state (excl. sack kraft and other kraft paper, and goods of hea','Papel y cartón, rizados ["crepés"], plisados, gofrados, estampados o perforados, en bobinas "rollos" de anchura > 36 cm o en hojas de forma cuadrada o rectangular con un lado > 36 cm y el otro > 15 cm, sin plegar (exc. papel Kraft para sacos "bolsas" y de',48,4808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480910,'Papel-carbono e semelhs.em rolos ou em folhas','carbon paper or similar, in rolls and sheets','papel carbón y similares, en bobinas o en hojas',48,4809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480920,'Papel autocopiativo, em rolos ou em folhas','Self-copy paper, whether or not printed, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state (excl. carbon and similar copying papers)','Papel autocopia, incl. impreso, en bobinas "rollos" de anchura > 36 cm o en hojas cuadradas o rectangulares > 36 cm en un lado y > 15 cm en el otro sin plegar (exc. papel carbón "carbónico" y papeles simil. para copiar)',48,4809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (480990,'Outros papéis para cópia ou duplicação, em rolos ou folhas','Transfer papers, incl. coated or impregnated paper for duplicator stencils or offset plates, whether or not printed, in rolls of a width > 36 cm or in square or rectangular sheets with one side > 36 cm and the other side > 15 cm in the unfolded state (exc','Papeles para copiar o transferir, incl. el cuché o estucado, recubierto o impregnado, para clises de multicopista o para planchas offset, incl. impresos, en bobinas "rollos" de anchura > 36 cm o en hojas cuadradas o rectangulares > 36 cm en un lado y > 15',48,4809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481011,'Papel p/escrever, etc.fibra proc.mec<=10%, p<=150g/m2','Paper for writing, etc.fibre mec.proc.<=10%, w<=150g/m2','Papel p/escribir, etc.fibra proc.mec<=10%, p<=150g/m2',48,4810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481012,'Papel para escrever, peso superior a 150 g/m2','Paper and paperboard, weighing more than 150 g/m2','Papel para escribir, peso superior a 150 g/m2',48,4810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481013,'Papel e cartão para escrita, impressão e outras finalidades gráficas, contendo <= 10% em peso de fibras obtidas por processo mecânico ou químico-mecânico, revestidos, em rolos','Paper and paperboard used for writing, printing or other graphic purposes, not containing fibres obtained by a mechanical or chemi-mechanical process or of which <= 10% by weight of the total fibre content consists of such fibres, coated on one or both si','Papel y cartón de los tipos utilizados para escribir, imprimir u otros fines gráficos, sin fibras obtenidas por procedimiento mecánico o químico-mecánico o con un contenido total de estas fibras <= 10% en peso del contenido total de fibras, estucados por ',48,4810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481014,'Papel e cartão para escrita, impressão e outras finalidades gráficas, contendo <= 10% em peso de fibras obtidas por processo mecânico ou químico-mecânico, revestidos, em folhas nas quais um dos lados <= 435 mm e o outro <= 297 mm, quando não dobradas','Paper and paperboard used for writing, printing or other graphic purposes, not containing fibres obtained by a mechanical or chemi-mechanical process or of which <= 10% by weight of the total fibre content consists of such fibres, coated on one or both si','Papel y cartón de los tipos utilizados para escribir, imprimir u otros fines gráficos, sin fibras obtenidas por procedimiento mecánico o químico-mecánico o con un contenido de estas fibras <= 10% en peso del contenido total de fibras, estucados por una o ',48,4810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481019,'Outros papéis e cartões para escrita, impressão e outras finalidades gráficas, contendo <= 10% em peso de fibras obtidas por processo mecânico ou químico-mecânico, revestidos, em folhas','Paper and paperboard used for writing, printing or other graphic purposes, not containing fibres obtained by a mechanical or chemi-mechanical process or of which <= 10% by weight of the total fibre content consists of such fibres, coated on one or both si','Papel y cartón de los tipos utilizados para escribir, imprimir u otros fines gráficos, sin fibras obtenidas por procedimiento mecánico o químico-mecánico o con un contenido de estas fibras <= 10% en peso del contenido total de fibras, estucados por una o ',48,4810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481021,'Papel cuche leve, util.p/escrita, etc.fibra proc.mec>10%','Light weight coat.paper used forwrit.etc.fib.mec>10%','Papel cuché leve, util.p/escribir, etc.fibra proc.mec>10%',48,4810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481022,'Papel cuché leve (LWC -light weight coated), contendo > 10% de fibras obtidas por processo mecânico','Lightweight coated paper used for writing, printing or other graphic purposes, total weight <= 72 g/m², coating weight <= 15 g/m² per side, on a base of which >= 50% by weight of the total fibre content consists of fibres obtained by a mechanical process,','Papel estucado o cuché ligero "liviano" ["L.W.C."], de los tipos utilizados para escribir, imprimir u otros fines gráficos, con un contenido total de fibras obtenidas por procedimiento mecánico o químico-mecánico > 10% en peso del contenido total de fibra',48,4810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481029,'Outros papéis e cartões, para escrita ou impressão, revestidos de caulim, contendo mais de 10% das fibras obtidas por processo mecânico, em rolos ou folhas','Paper and paperboard used for writing, printing or other graphic purposes, of which > 10% by weight of the total fibre content consists of fibres obtained by a mechanical or chemi-mechanical process, coated on one or both sides with kaolin or other inorga','Papel y cartón de los tipos utilizados para escribir, imprimir u otros fines gráficos, con un contenido total de fibras obtenidas por procedimiento mecánico o químico-mecánico > 10% en peso del contenido total de fibras, estucados por una o las dos caras ',48,4810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481031,'Papel e cartão kraft, exceto dos tipos utilizados para escrita ou finalidades gráficas, revestidos de caulim, branqueados, de peso <= 150 g/m2, contendo mais de 95% em peso das fibras obtidas por processo químico, em rolos ou folhas','Kraft paper and paperboard, bleached uniformly throughout the mass and containing > 95% chemically processed wood fibres by weight in relation to the total fibre content, coated on one or both sides with kaolin or other inorganic substances, in rolls or i','Papel y cartón Kraft, blanqueados uniformemente en la masa y con un contenido de fibras de madera obtenidas por procedimiento químico > 95% en peso del contenido total de fibras, estucados por una o las dos caras exclusivamente con caolín u otras sustanci',48,4810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481032,'Papel e cartão kraft, exceto dos tipos utilizados para escrita ou finalidades gráficas, branqueados, revestidos de caulim, de peso > 150 g/m2, contendo mais de 95% das fibras obtidas por processo químico, em rolos ou folhas','Kraft paper and paperboard, bleached uniformly throughout the mass and containing > 95% chemically processed wood fibres by weight in relation to the total fibre content, coated on one or both sides with kaolin or other inorganic substances, in rolls or i','Papel y cartón Kraft, blanqueados uniformemente en la masa y con un contenido de fibras de madera obtenidas por procedimiento químico > 95% en peso del contenido total de fibras, estucados por una o las dos caras exclusivamente con caolín u otras sustanci',48,4810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481039,'Outros papéis e cartões kraft, exceto dos tipos utilizados para escrita ou finalidades gráficas, revestidos de caulim ou de outras substâncias inorgânicas, em rolos ou folhas','Kraft paper and paperboard, coated on one or both sides with kaolin or other inorganic substances, in rolls or in square or rectangular sheets, of any size (excl. that for writing, printing or other graphic purposes; paper and paperboard bleached uniforml','Papel y cartón Kraft, estucados por una o las dos caras exclusivamente con caolín u otras sustancias inorgánicas, en bobinas "rollos" de anchura > 15 cm o en hojas cuadradas o rectangulares > 36 cm en un lado y > 15 cm en el otro sin plegar (exc. para esc',48,4810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481091,'outs.papéis/cartões, camadas multipl.revest.em rolos/fls','oth.papers/paperb.multiple layers, in rolls/sheets','ots.papeles/cartones, multicapa, estucados, en bobinas/hjs',48,4810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481092,'Outros papéis e cartões de camadas múltiplas, exceto dos tipos utilizados para escrita ou finalidades gráficas, revestidos de caulim, em rolos ou em folhas','Multi-ply paper and paperboard, coated on one or both sides with kaolin or other inorganic substances, in rolls or in square or rectangular sheets, of any size (excl. that for writing, printing or other graphic purposes, kraft paper and paperboard)','Papel y cartón multicapas, estucados por una o las dos caras con caolín u otras sustancias inorgánicas, en bobinas "rollos" o en hojas de forma cuadrada o rectangular, de cualquier tamaño (exc. para escribir, imprimir u otros fines gráficos, así como el p',48,4810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481099,'Outros papéis e cartões, exceto dos tipos utilizados para escrita ou finalidades gráficas, revestidos de caulim ou de outras substâncias inorgânicas, em rolos ou folhas','Paper and paperboard, coated on one or both sides with kaolin China clay or other inorganic substances, with or without a binder, and with no other coating, whether or not surface-coloured, surface-decorated or printed, in rolls or in square or rectangula','Papel y cartón, estucados por una o las dos caras con caolín u otras sustancias inorgánicas, incl. con aglutinante, incl. coloreados o decorados en la superficie o impresos, en bobinas "rollos" o en hojas de forma cuadrada o rectangular, de cualquier tama',48,4810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481110,'Papel e cartão alcatroados, betuminados, ou asfaltados, em rolos ou folhas','Tarred, bituminised or asphalted paper and paperboard, in rolls or in square or rectangular sheets, of any size','Papel y cartón alquitranados, embetunados o asfaltados, en bobinas "rollos" o en hojas de forma cuadrada o rectangular, de cualquier tamaño',48,4811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481121,'papel e cartão auto-adesivos, em rolos ou em folhas','paper/paperboard self-adhesive, in rolls or sheets','papel y cartón autoadhesivos, en bobinas o en hojas',48,4811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481129,'outs.papéis e cartões gomados/adesivos, em rolos/folhas','other gummed paper/paperb./self-adhesive, in rolls/sheets','ots.papeles y cartones engomados/adhesivos, en bobs./hjs',48,4811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481131,'Branqueado, pesando mais de 150 g/m2: 03 milímetros ou mais de espessura','Bleached, weighing more than 150 g/m2: 03 mm or more in thickness','Blanqueados, de gramaje superior a 150 g/m2: 03 mm o más de espesor',48,4811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481139,'Outros papéis/cartões','Other paper/cards','Otros papeles/tarjetas',48,4811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481140,'Papel/cartão revest/impregn.cera, parafina, etc.rolos/fls','Paper/paperb.coated/impreg.wax, paraf.etc.rolls/sheets','Papel/cartón revest/impregn.cera, parafina, etc.bobs./hjs',48,4811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481141,'Papel e cartão auto-adesivos, coloridos ou decorados à superfície ou impressos, em rolos ou folhas','Self-adhesive paper and paperboard, surface-coloured, surface-decorated or printed, in rolls or in square or rectangular sheets, of any size (excl. goods of heading 4810)','Papel y cartón, autoadhesivos, coloreados o decorados en la superficie o impresos, en bobinas "rollos" o en hojas de forma cuadrada o rectangular, de cualquier tamaño (exc. artículos de la partida 4810)',48,4811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481149,'Outros papéis e cartões gomados ou adesivos, coloridos ou decorados à superfície ou impressos, em rolos ou folhas','Gummed or adhesive paper and paperboard, surface-coloured, surface-decorated or printed, in rolls or in square or rectangular sheets, of any size (excl. self-adhesive and goods of heading 4810)','Papel y cartón, coloreados o decorados en la superficie o impresos, engomados o adhesivos pero no autoadhesivos, en bobinas "rollos" o en hojas de forma cuadrada o rectangular, de cualquier tamaño (exc. artículos de la partida 4810)',48,4811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481151,'Papel e cartão, coloridos ou decorados à superfície ou impressos, branqueados, revestidos, impregnados ou recobertos de plástico, de peso > 150 g/m2, em rolos ou folhas','Paper and paperboard, surface-coloured, surface-decorated or printed, coated, impregnated or covered with artificial resins or plastics, in rolls or in square or rectangular sheets, of any size, bleached and weighing > 150 g/m² (excl. adhesives)','Papel y cartón, coloreados o decorados en la superficie o impresos, recubiertos, impregnados o revestidos de plástico, en bobinas "rollos" o en hojas de forma cuadrada o rectangular, de cualquier tamaño, blanqueados, de peso > 150 g/m² (exc. papel y cartó',48,4811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481159,'Outros papéis e cartões coloridos ou decorados à superfície ou impressos, revestidos, impregnados ou recobertos de plástico, em rolos ou folhas','Paper and paperboard, surface-coloured, surface-decorated or printed, coated, impregnated or covered with artificial resins or plastics, in rolls or in square or rectangular sheets, of any size (excl. bleached and weighing > 150 g/m², and adhesives)','Papel y cartón, coloreados o decorados en la superficie o impresos, recubiertos, impregnados o revestidos de plástico, en bobinas "rollos" o en hojas de forma cuadrada o rectangular, de cualquier tamaño (exc. blanqueados y de peso > 150 g/m², así como el ',48,4811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481160,'Papel e cartão revestidos impregnados ou recobertos de cera, parafina, estearina, óleo ou glicerol, em rolos ou folhas','Paper and paperboard, coated, impregnated or covered with wax, paraffin wax, stearin, oil or glycerol, in rolls or in square or rectangular sheets, of any size (excl. goods of heading 4803, 4809 and 4818)','Papel y cartón recubiertos, impregnados o revestidos de cera, parafina, estearina, aceite o glicerol, en bobinas "rollos" o en hojas de forma cuadrada o rectangular, de cualquier tamaño (exc. artículos de las partidas 4803, 4809 ó 4818)',48,4811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481190,'Outros papéis, cartões, pasta de celulose e mantas de fibras de celulose, em rolos ou folhas','Paper, paperboard, cellulose wadding and webs of soft cellulose, coated, impregnated, covered, surface-coloured, surface-decorated or printed, in rolls or in square or rectangular sheets, of any size (excl. goods of heading 4803, 4809, 4810 and 4818, and ','Papel, cartón, guata de celulosa y napa de fibras de celulosa, estucados, recubiertos, impregnados o revestidos, coloreados o decorados en la superficie o impresos, en bobinas "rollos" o en hojas de forma cuadrada o rectangular, de cualquier tamaño (exc. ',48,4811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481200,'Blocos e chapas, filtrantes, de pasta de papel','Filter blocks, slabs and plates, of paper pulp','Bloques y placas, filtrantes, de pasta de papel',48,4812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481310,'Papel para cigarros, em cadernos ou em tubos','Cigarette paper in the form of booklets or tubes','Papel de fumar, en librillos o en tubos',48,4813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481320,'Papel para cigarros, em rolos de largura <= 5 cm','Cigarette paper in rolls of a width of <= 5 cm','Papel de fumar, en bobinas "rollos" de anchura <= 5 cm',48,4813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481390,'Outros papéis para cigarros','Cigarette paper, whether or not cut to size (excl. in the form of booklets or tubes, and rolls of a width of <= 5 cm)','Papel de fumar, incl. cortado al tamaño adecuado (exc. en librillos o en tubos, así como en bobinas "rollos" de anchura <= 5 cm)',48,4813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481410,'Papel denominado "Ingrain"','''Ingrain'' paper','Papel granito "ingrain"',48,4814);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481420,'Papel de parede, revestido do lado direito por uma camada de plástico granida, colorida ou decorada','Wallpaper and similar wallcoverings of paper, consisting of paper coated or covered, on the face side, with a grained, embossed, coloured or design-printed or otherwise decorated layer of plastics','Papel para decorar y revestimientos simil. de paredes, constituidos por papel recubierto o revestido, en la cara vista, con una capa de plástico graneada, gofrada, coloreada, impresa con motivos o decorada de otro modo',48,4814);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481430,'Papel de parede, revestido de matérias para entrançar','wallpaper, covered with plaiting material','papel p/decorar, revest.con materias trenzables',48,4814);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481490,'Outros papéis de parede e revestimentos de paredes; papel para vitrais','Wallpaper and similar wallcoverings of paper, and window transparencies of paper (excl. ''ingrain'' paper and wallcoverings of paper, consisting of paper coated or covered, on the face side, with a grained, embossed, coloured or design-printed or otherwis','Papel para decorar y revestimientos de papel simil. para paredes; papel para vidrieras (exc. papel granito "ingrain", así como los artículos de las subpartidas 4814.20 ó 4814.30)',48,4814);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481500,'revestimentos p/pavimentos, c/suporte de papel/de cartão','floor coverings on a base of paper or of paperboard','cubresuelos con soporte de papel o de cartón',48,4815);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481610,'papel-carbono e semelhs.mesmo em caixas','carbon paper and similar even in boxes','papel carbón y papeles similares, incluso en cajas',48,4816);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481620,'Papel autocopiativo, mesmo em caixas','Self-copy paper, in rolls of a width of <= 36 cm or in rectangular or square sheets with no side measuring > 36 cm in the unfolded state, or cut into shapes other than rectangles or squares, whether or not in boxes (excl. carbon or similar copying papers)','Papel autocopia, en bobinas "rollos" de anchura <= 36 cm o en hojas cuadradas o rectangulares en que no haya ningún lado > 36 cm sin plegar, o cortados de forma distinta de la cuadrada o rectangular, incl. acondicionados en cajas (exc. papel carbón "carbó',48,4816);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481630,'Estenceis completos','Duplicator stencils','Clisés de mimeógrafo ("stencils") completos',48,4816);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481690,'Outros papéis para cópia ou duplicação, mesmo em caixas','Copying or transfer papers, in rolls of a width of <= 36 cm or in rectangular or square sheets with no side measuring > 36 cm in the unfolded state, or cut into shapes other than rectangles or squares, whether or not in boxes, together with offset plates ','Papel para copiar o transferir, en bobinas "rollos" de anchura <= 36 cm o en hojas cuadradas o rectangulares en que no haya ningún lado > 36 cm sin plegar, o cortados de forma distinta de la cuadrada o rectangular, así como planchas offset, de papel, incl',48,4816);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481710,'Envelopes de papel ou cartão','Envelopes of paper or paperboard (excl. letter cards)','Sobres de papel o cartón (exc. sobres carta)',48,4817);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481720,'Aerogramas, bilhetes-postais não ilustrados, cartões para correspondência','Letter cards, plain postcards and correspondence cards, of paper or paperboard (excl. those with imprinted postage stamps)','Sobres carta, tarjetas postales sin ilustrar y tarjetas para correspondencia, de papel o cartón (exc. franqueados con el valor postal impreso)',48,4817);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481730,'Caixas, sacos e semelhantes, de papel ou cartão, contendo um sortido de artigos para correspondência','Boxes, pouches, wallets and writing compendiums, of paper or paperboard, containing an assortment of paper stationery','Cajas, bolsas y presentaciones simil. de papel o cartón, con un surtido de artículos para correspondencia de papel o cartón',48,4817);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481810,'Papel higiênico','Toilet paper in rolls of a width of <= 36 cm','Papel higiénico, en rollos, de anchura <= 36 cm',48,4818);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481820,'Lenços e toalhas de mão, de papel','Handkerchiefs, cleansing or facial tissues and towels, of paper pulp, paper, cellulose wadding or webs of cellulose fibres','Pañuelos, toallitas de desmaquillaje y toallas, de pasta de papel, de papel, de guata de celulosa o de napa de fibras de celulosa',48,4818);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481830,'Toalhas e guardanapos, de papel, de mesa','Tablecloths and serviettes of paper pulp, paper, cellulose wadding or webs of cellulose fibres','Manteles y servilletas, de pasta de papel, de papel, de guata de celulosa o de napa de fibras de celulosa',48,4818);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481840,'Absorventes e tampões higiênicos, fraldas para bebês e artigos higiênicos semelhantes, de papel','Sanitary towels and tampons, napkins and napkin for babies and similar sanitary articles, of paper pulp, paper, cellulose wadding or webs of cellulose fibres','Compresas y tampones higiénicos, pañales para bebés y artículos higiénicos simil., de pasta de papel, de papel, de guata de celulosa o de napa de fibras de celulosa',48,4818);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481850,'Vestuário e seus acessórios, de pasta de papel, papel, pasta (ouate) de celulose ou de mantas de fibras de celulose','Articles of apparel and clothing accessories, of paper pulp, paper, cellulose wadding or webs of cellulose fibres (excl. footware and parts thereof, incl. insoles, heel pieces and similar removable products, gaiters and similar products, headgear and part','Prendas y complementos "accesorios" de vestir, de pasta de papel, de papel, de guata de celulosa o de napa de fibras de celulosa (exc. calzado, partes de calzado, incl. las plantillas, taloneras para bebés y artículos simil. amovibles; polainas, botines y',48,4818);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481890,'Outros artigos de papel, para uso sanitário, da espécie doméstica ou hospitalar','Paper, cellulose wadding or webs of cellulose fibres, of a kind used for household or sanitary purposes, in rolls of a width <= 36 cm, or cut to size or shape; articles of paper pulp, paper, cellulose wadding or webs of cellulose fibres for household, san','Papel, guata de celulosa o napa de fibras de celulosa, de los tipos utilizados para fines domésticos o sanitarios, en bobinas "rollos" de anchura <= 36 cm o cortados en formato; artículos de pasta de papel, de papel, de guata de celulosa o de napa de fibr',48,4818);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481910,'Caixas de papel ou cartão, ondulados (canelados)','Cartons, boxes and cases, of corrugated paper or paperboard','Cajas de papel o cartón corrugado',48,4819);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481920,'Caixas e cartonagens, dobráveis, de papel ou cartão, não ondulados','Folding cartons, boxes and cases, of non-corrugated paper or paperboard','Cajas y cartonajes, plegables, de papel o cartón, sin corrugar',48,4819);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481930,'Sacos de papel ou cartão, cuja base tenha largura => 40 cm','Sacks and bags, of paper, paperboard, cellulose wadding or webs of cellulose fibres, having a base of a width of >= 40 cm','Sacos "bolsas" de papel, cartón, guata de celulosa o napa de fibra de celulosa, con una anchura en la base >= 40 cm',48,4819);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481940,'Outros sacos, bolsas e cartuchos, de papel ou cartão','Sacks and bags, incl. cones, of paper, paperboard, cellulose wadding or webs of cellulose fibres (excl. those having a base of a width of >= 40 cm, and record sleeves)','Sacos "bolsas" y cucuruchos, de papel, cartón, guata de celulosa o napa de fibra de celulosa (exc. sacos "bolsas" con una anchura en la base >= 40 cm, así como las fundas para discos)',48,4819);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481950,'Outros embalagens de papel ou cartão, incluídas as capas para discos','Packing containers, incl. record sleeves, of paper, paperboard, cellulose wadding or webs of cellulose fibres (excl. cartons, boxes and cases, of corrugated paper or paperboard, folding cartons, boxes and cases, of uncorrugated paper or paperboard, sacks ','Envases, incl. las fundas para discos, de papel, cartón, guata de celulosa o napa de fibra de celulosa (exc. cajas de papel o cartón corrugado; cajas y cartonajes, plegables, de papel o cartón sin corrugar; sacos "bolsas" y cucuruchos)',48,4819);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (481960,'Cartonagens para escritórios, lojas e estabelecimentos semelhantes','Box files, letter trays, storage boxes and similar articles, of paperboard, of a kind used in offices, shops or the like (excl. packing containers)','Cartonajes en forma de recipientes rígidos de los tipos utilizados en oficinas, tiendas "carpas" o simil. (exc. envases)',48,4819);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482010,'Livros de registro, de contabilidade, blocos de notas, agendas e artigos semelhantes','Registers, account books, notebooks, order books, receipt books, letter pads, memorandum pads, diaries and similar articles, of paper or paperboard','Libros registro, libros de contabilidad, talonarios "de notas, pedidos o recibos", bloques memorandos, bloques de papel de cartas, agendas y artículos simil.',48,4820);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482020,'Cadernos','Exercise books of paper or paperboard','Cuadernos',48,4820);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482030,'Classificadores, capas para encadernação, de papel ou cartão','Binders (other than book covers), folders and file covers, of paper or paperboard','Clasificadores, encuadernaciones distintas de las cubiertas para libros, carpetas y cubiertas para documentos, de papel o cartón',48,4820);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482040,'Formulários em blocos tipo manifold, mesmo com papel-carbono','Manifold business forms and interleaved carbon sets, of paper or paperboard','Formularios en paquetes o plegados ["manifold"], aunque lleven papel carbón "carbónico"',48,4820);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482050,'Álbuns para amostras ou coleções, de papel ou cartão','Albums for samples or collections, of paper or paperboard','Álbumes para muestras o para colecciones, de papel o cartón',48,4820);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482090,'Outros artigos de papel ou cartão, para escritório ou papelaria','Blotting pads and similar articles of stationery, of paper and paperboard, and book covers of paper or paperboard (excl. registers, account books, notebooks, order books, receipt books, letter pads, memorandum pads, diaries, exercise books, binders, folde','Carpetas de mesa y demás artículos escolares, para oficina o papelería, de papel o cartón; cubiertas para libros, de papel o cartón (exc. libros registro o de contabilidad, talonarios, agendas, bloques memorandos, bloques de papel de cartas y artículos si',48,4820);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482110,'Etiquetas de papel ou cartão, impressas','Paper or paperboard labels of all kinds, printed','Etiquetas de todas clases, de papel o cartón, impresas',48,4821);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482190,'Outros etiquetas de papel ou cartão','Paper or paperboard labels of all kinds, non-printed','Etiquetas de todas clases, de papel o cartón, sin imprimir',48,4821);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482210,'Carretéis, bobinas, canelas e suportes semelhantes, de papel ou cartão, para enrolamento de fios têxteis','Bobbins, spools, cops and similar supports of paper pulp, paper or paperboard, whether or not perforated or hardened, for winding textile yarn','Carretes, bobinas, canillas y soportes simil. de pasta de papel, de papel o cartón, incl. perforados o endurecidos, de los tipos utilizados para el bobinado de hilados textiles',48,4822);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482290,'Carretéis, bobinas, canelas e suportes semelhantes, de papel ou cartão, para outros usos','Bobbins, spools, cops and similar supports of paper pulp, paper or paperboard, whether or not perforated or hardened (excl. those for winding textile yarn)','Carretes, bobinas, canillas y soportes simil. de pasta de papel, de papel o cartón, incl. perforados o endurecidos (exc. de los tipos utilizados para el bobinado de hilados textiles)',48,4822);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482311,'Papel auto-adesivo, em tiras ou em rolos','Self-adhesive paper, in strips or rolls','Papel autoadhesivo, en tiras o en bobinas',48,4823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482312,'Papel de celulose, auto-adesivo, em tiras/rolos','Cellulose paper, self-adhesive, in strips/rolls','Papel de celulosa, autoadhesivo, en tiras/bobinas',48,4823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482319,'Outros papéis gomados ou adesivos, em tiras ou em rolos','Other gummed or adhesivos paper, in strip/rolls','Otros papeles engomados o adhesivos, en tiras o en bobs.',48,4823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482320,'Papel-filtro e cartão-filtro, cortados em forma própria','Filter paper and paperboard, in strips or rolls of a width <= 36 cm, in rectangular or square sheets, of which no side > 36 cm in the unfolded state, or cut to shape other than rectangular or square','Papel y cartón filtro, en tiras o en bobinas "rollos" de anchura <= 36 cm o en hojas de forma cuadrada o rectangular en las que no haya ningún lado > 36 cm, sin plegar, o cortados en forma distinta de la cuadrada o rectangular',48,4823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482340,'Papel-diagrama para aparelhos registradores, em bobinas, folhas ou discos','Rolls, sheets and dials, printed for self-recording apparatus, in rolls of a width <= 36 cm, in rectangular or square sheets of which no side > 36 cm in the unfolded state, or cut into dials','Papel diagrama para aparatos registradores, en bobinas "rollos" de anchura <= 36 cm o en hojas de forma cuadrada o rectangular en las que no haya ningún lado > 36 cm, sin plegar, o cortado en forma de discos',48,4823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482351,'Papel/cartão p/escrita, etc.impressos/estampados/perfur.','Paper/paperboard forwriting etc.printed/perforated','Papel/cartón p/escrit., etc.impresos/estampados/perfor.',48,4823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482359,'Outros papéis/cartões p/escrita/impressão/fins graficos','Oth.paper/paperb.forwriting etc.printed/graphic uses','Otros papeles/cartones p/escrit./impres./fines gráficos',48,4823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482360,'Bandejas, travessas, pratos, xícaras, etc.de papel/cartão','Trays, dishes, plates, cups, etc.of paper/paperboard','Bandejas, fuentes, platos, tazas, etc.de papel/cartón',48,4823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482361,'Bandejas, travessas, pratos, xícaras ou chávenas, taças, copos e artigos semelhantes, de bambu','Trays, dishes, plates, cups and the like, of bamboo paper or bamboo paperboard','Bandejas, fuentes, platos, tazas, vasos y artículos simil., de papel o cartón, de bambú',48,4823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482369,'Bandejas, travessas, pratos, xícaras ou chávenas, taças, copos e artigos semelhantes, de papel ou cartão','Trays, dishes, plates, cups and the like, of paper or paperboard (excl. of bamboo paper or bamboo paperboard)','Bandejas, fuentes, platos, tazas, vasos y artículos simil., de papel o cartón',48,4823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482370,'Artigos moldados ou prensados, de pasta de papel','Moulded or pressed articles of paper pulp, n.e.s.','Artículos de pasta de papel, moldeados o prensados, n.c.o.p.',48,4823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (482390,'Outros papéis, cartões, pasta de celulose e mantas de fibras de celulose, cortados em forma própria, e suas obras','Paper, paperboard, cellulose wadding and webs of cellulose fibres, in strips or rolls of a width <= 36 cm, in rectangular or square sheets, of which no side > 36 cm in the unfolded state, or cut to shape other than rectangular or square, and articles of p','Papel, cartón, guata de celulosa y napa de fibra de celulosa, en tiras o en bobinas "rollos" de anchura <= 36 cm o en hojas de forma cuadrada o rectangular en las que no haya ningún lado > 36 cm, sin plegar, o cortados en forma distinta de la cuadrada o r',48,4823);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (490110,'Livros, brochuras, impressos semelhantes, em folhas soltas, mesmo dobradas','Printed books, brochures and similar printed matter, in single sheets, whether or not folded (excl. periodicals and publications which are essentially devoted to advertising)','Libros, folletos e impresos simil., en hojas sueltas, incl. plegadas (exc. publicaciones periódicas impresas, así como las publicaciones consagradas esencialmente a la publicidad)',49,4901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (490191,'Dicionários e enciclopédias, mesmo em fascículos','Dictionaries and encyclopaedias, and serial instalments thereof','Diccionarios y enciclopedias, incluso en fascículos',49,4901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (490199,'Outros livros, brochuras e impressos semelhantes','Printed books, brochures and similar printed matter (excl. those in single sheets; dictionaries, encyclopaedias, periodicals and publications which are essentially devoted to advertising)','Libros, folletos e impresos simil. (exc. en hojas sueltas, así como diccionarios, enciclopedias, publicaciones periódicas impresas y publicaciones consagradas esencialmente a la publicidad)',49,4901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (490210,'Jornais e publicações periódicas, impressos, mesmo ilustrados, com freqüência => 4 vezes/semana','Newspapers, journals and periodicals, whether or not illustrated or containing advertising material, appearing at least four times a week','Diarios y publicaciones periódicas, impresos, incl. ilustrados o con publicidad, que se publiquen cuatro veces por semana como mínimo',49,4902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (490290,'Outros jornais e publicações periódicas ou impressos, mesmo ilustrados','Newspapers, journals and periodicals, whether or not illustrated or containing advertising material (excl. those appearing at least four times a week)','Diarios y publicaciones periódicas, impresos, incl. ilustrados o con publicidad (exc. los que se publiquen cuatro veces por semana como mínimo)',49,4902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (490300,'Álbuns ou livros de ilustrações e álbuns para desenhar ou colorir, para crianças','Children''s picture, drawing or colouring books','Álbumes o libros de estampas y cuadernos para dibujar o colorear',49,4903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (490400,'Música manuscrita ou impressa, ilustrada ou não, mesmo encadernada','Music, printed or in manuscript, whether or not bound or illustrated','Música manuscrita o impresa, incl. con ilustraciones o encuadernada',49,4904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (490510,'Globos (obra cartográfica, impressa)','Globes, printed (excl. relief globes)','Esferas cartógraficas, impresas (exc. esferas en relieve)',49,4905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (490591,'Obras cartográficas, impressas sob a forma de livros ou brochuras','Maps and hydrographic or similar charts of all kinds, incl. atlases and topographical plans, printed and in book form (excl. globes, and maps and plans, in relief)','Manufacturas cartógraficas de todas clases, incl. los planos topográficos, impresos, en forma de libros o de folletos (exc. esferas, así como los mapas y planos en relieve)',49,4905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (490599,'Outros obras cartográficas, impressas','Maps and hydrographic or similar charts of all kinds, incl. atlases, wall maps and topographical plans, printed (excl. those in book form, and maps, plans and globes, in relief)','Manufacturas cartógraficas de todas clases, incl. los mapas murales y planos topográficos, impresos (exc. en forma de libros o de folletos, así como los mapas y planos en relieve y las esferas)',49,4905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (490600,'Planos, plantas e desenhos de arquitetura ou de engenharia e desenhos industriais ou semelhantes, feitos a mão; textos manuscritos; reproduções ou cópias do material acima referido','Plans and drawings for architectural, engineering, industrial, commercial, topographical or similar purposes, being originals drawn by hand; handwritten texts; photographic reproductions on sensitised paper and carbon copies of the foregoing','Planos y dibujos originales hechos a mano, de arquitectura, ingeniería, industriales, comerciales, topográficos o simil.; textos manuscritos; reproducciones fotográficas sobre papel sensibilizado y copias con papel carbón "carbónico", de los planos, dibuj',49,4906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (490700,'Selos postais ou fiscais, não obliterados; papel selado, papel-moeda, cheques, certificados de ações ou de obrigações e títulos semelhantes','Unused postage, revenue or similar stamps of current or new issue in the country in which they have, or will have, a recognised face value; stamp-impressed paper; banknotes; cheque forms; stock, share or bond certificates and similar documents of title','Sellos "estampillas" de correos, timbres fiscales y análogos, sin obliterar, que tengan o estén destinados a tener curso legal en el país en el que su valor facial sea reconocido; papel timbrado; billetes de banco; cheques; títulos de acciones u obligacio',49,4907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (490810,'Decalcomanias vitrificáveis','Transfers decalcomanias, vitrifiable','Calcomanías vitrificables',49,4908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (490890,'Outras decalcomanias de qualquer espécie','Transfers decalcomanias (excl. vitrifiable)','Calcomanías de cualquier clase (exc. vitrificables)',49,4908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (490900,'Cartões-postais, impressos ou ilustrados; cartões impressos, mesmo ilustrados, com ou sem envelopes','Printed or illustrated postcards; printed cards bearing personal greetings, messages or announcements, whether or not illustrated, with or without envelopes or trimmings','Tarjetas postales impresas o ilustradas; tarjetas impresas con felicitaciones o comunicaciones personales, incl. con ilustraciones, adornos o aplicaciones, o con sobres',49,4909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (491000,'Calendários impressos, inclusive blocos-calendário para desfolhar','Calendars of any kinds, printed, incl. calendars blocks','Calendarios de cualquier clase impresos, incl. los tacos de calendario',49,4910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (491110,'Impressos publicitários, catálogos comerciais e semelhantes','Trade advertising material, commercial catalogues and the like','Impresos publicitarios, catálogos comerciales y simil.',49,4911);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (491191,'Estampas, gravuras e fotografias','Pictures, prints and photographs, n.e.s.','Estampas, grabados y fotografías, n.c.o.p.',49,4911);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (491199,'Outros impressos','Printed matter, n.e.s.','Impresos, n.c.o.p.',49,4911);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (500100,'Casulos de bicho-da-seda próprios para dobar','Silkworm cocoons suitable for reeling','Capullos de seda aptos para el devanado',50,5001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (500200,'Seda crua (não fiada)','Raw silk non-thrown','Seda cruda "sin torcer"',50,5002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (500300,'Desperdícios de seda (incluídos os casulos de bicho-da-seda impróprios para dobar, os desperdícios de fios e os fiapos).','Silk waste, incl. cocoons unsuitable for reeling, yarn waste and garnetted stock','Desperdicios de seda (incluidos los capullos no aptos para el devanado, desperdicios de hilados e hilachas)',50,5003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (500310,'desperdícios de seda,  nao cardados,  nem penteados','silk waste, not carded or combed','desperdicios de seda, sin cardar ni peinar',50,5003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (500390,'outros desperdícios de seda','other silk wastes','otros desperdicios de seda',50,5003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (500400,'Fios de seda, não acondicionados para venda a retalho','Silk yarn (excl. that spun from silk waste and that put up for retail sale)','Hilados de seda (exc. hilados de desperdicios de seda e hilados acondicionados para la venta al por menor)',50,5004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (500500,'Fios de desperdícios de seda, não acondicionados para venda a retalho','Yarn spun from silk waste (excl. that put up for retail sale)','Hilados de desperdicios de seda (exc. acondicionados para la venta al por menor)',50,5005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (500600,'Fios de seda ou de desperdícios de seda, para venda a retalho; pêlo de Messina (crina de Florença) ','Silk yarn and yarn spun from silk waste, put up for retail sale; silkworm gut','Hilados de seda o desperdicios de seda, acondicionados para la venta al por menor; "pelo de Mesina" ["crin de Florencia"]',50,5006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (500710,'Tecidos de bourrette, de seda','Woven fabrics of noil silk','Tejidos de borrilla',50,5007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (500720,'Outros tecidos de seda e seus desperdícios, exceto bourrette, contendo => 85%, em peso de seda','Woven fabrics containing >= 85% silk or schappe by weight','Tejidos con un contenido de seda o desperdicios de seda, distintos de la borrilla >= 85% en peso',50,5007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (500790,'Outros tecidos de seda e seus desperdícios','Woven fabrics containing predominantly, but < 85% silk or silk waste by weight','Tejidos con alto contenido de seda o desperdicios de seda, distintos de la borrilla, pero < 85% en peso',50,5007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510111,'Lã de tosquia suja, incluída a lã lavada a dorso, não cardada nem penteada','Greasy shorn wool, incl. fleece-washed wool, neither carded nor combed','Lana esquilada, sucia, incl. la lavada en vivo, sin cardar ni peinar',51,5101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510119,'Outras lãs sujas, incluída a lã lavada a dorso, não cardadas nem penteadas','Greasy wool, incl. fleece-washed wool, neither carded nor combed (excl. shorn wool)','Lana sucia, incl. la lavada en vivo, sin cardar ni peinar (exc. lana esquilada)',51,5101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510121,'Lã de tosquia, desengordurada, não carbonizada, não cardada nem penteada','Shorn wool, degreased, non-carbonised, neither carded nor combed','Lana esquilada, desgrasada, sin carbonizar, sin cardar ni peinar',51,5101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510129,'Outras lãs, desengorduradas, não carbonizadas, não cardadas nem penteadas','Degreased wool, non-carbonised, neither carded nor combed (excl. shorn wool)','Lana desgrasada, sin carbonizar, sin cardar ni peinar (exc. lana esquilada)',51,5101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510130,'Lã desengordurada, carbonizada, não cardada nem penteada','Carbonised wool, neither carded nor combed','Lana carbonizada, sin cardar ni peinar',51,5101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510210,'pêlos finos, não cardados nem penteados','fine or coarse animal hair, not carded or combed','pelos finos, sin cardar ni peinar',51,5102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510211,'Pêlos finos, de cabra de Cachemira, não cardados nem penteados','Hair of Kashmir cashmere goats, neither carded nor combed','Pelo de cabra de Cachemira, sin cardar ni peinar',51,5102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510219,'Outros pêlos finos, não cardados nem penteados','Fine animal hair, neither carded nor combed (excl. wool and hair of Kashmir cashmere goats)','Pelo fino, sin cardar ni peinar (exc. lana y pelo de cabra de Cachemira)',51,5102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510220,'Pêlos grosseiros, não cardados nem penteados','Coarse animal hair, neither carded nor combed (excl. wool, hair and bristles used in the manufacture of brooms and brushes, and horsehair from the mane or tail)','Pelo ordinario, sin cardar ni peinar (exc. pelo y cerdas de cepillería y crin, tanto de la crin como de la cola)',51,5102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510310,'Desperdícios da penteação de lã ou de pêlos finos','Noils of wool or of fine animal hair (excl. garnetted stock)','Borras del peinado de lana o pelo fino (exc. las hilachas)',51,5103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510320,'Outros desperdícios de lã ou de pêlos finos','Waste of wool or of fine animal hair, incl. yarn waste (excl. noils and garnetted stock)','Desperdicios de lana o pelo fino, incl. los desperdicios de hilados (exc. borras e las hilachas)',51,5103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510330,'Desperdícios de pêlos grosseiros','Waste of coarse animal hair, incl. yarn waste (excl. garnetted stock, waste of hair or bristles used in the manufacture of brooms and brushes, and of horsehair from the mane or tail)','Desperdicios de pelo ordinario, incl. los desperdicios de hilados (exc. las hilachas, desperdicios de pelo y cerdas de cepillería y desperdicios de crin, tanto de la crin como de la cola)',51,5103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510400,'Fiapos de lã ou de pêlos finos ou grosseiros','Garnetted stock of wool or of fine or coarse animal hair, neither carded nor combed','Hilachas de lana o pelo fino u ordinario, sin cardar ni peinar',51,5104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510510,'Lã cardada','Wool, carded','Lana cardada',51,5105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510521,'Lã penteada a granel','Wool, combed, in fragments open tops','"Lana peinada a granel" ["open tops"]',51,5105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510529,'Outra lã penteada','Wool, combed (excl. that in fragments open tops)','Lana peinada (exc. "a granel" ["open tops"])',51,5105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510530,'pêlos finos, cardados ou penteados','fine animal hair, carded or combed','pelos finos, cardados o peinados',51,5105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510531,'Pêlos finos, de cabra de Cachemira, cardados ou penteados','Hair of Kashmir cashmere goats, carded or combed','Pelo de cabra de Cachemira, cardado o peinado',51,5105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510539,'Outros pêlos finos, cardados ou penteados','Fine animal hair, carded or combed (excl. wool and hair of Kashmir cashmere goats)','Pelo fino, cardado o peinado (exc. lana y pelo de cabra de Cachemira)',51,5105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510540,'Pêlos grosseiros, cardados ou penteados','Coarse animal hair, carded or combed','Pelo ordinario cardado o peinado',51,5105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510610,'Fios de lã cardada, contendo => 85%, em peso, de lã','Carded wool yarn containing >= 85% wool by weight (excl. that put up for retail sale)','Hilados de lana cardada, con un contenido de lana >= 85% en peso (exc. acondicionados para la venta al por menor)',51,5106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510620,'Fios de lã cardada, contendo < 85%, em peso, de lã','Carded wool yarn containing predominantly, but < 85% wool by weight (excl. that put up for retail sale)','Hilados de lana cardada, con un alto contenido de lana, pero < 85% en peso (exc. acondicionados para la venta al por menor)',51,5106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510710,'Fios de lã penteada, contendo => 85%, em peso, de lã','Yarn of combed wool containing >= 85% wool by weight (excl. that put up for retail sale)','Hilados de lana peinada, con un contenido de lana >= 85% en peso (exc. acondicionados para la venta al por menor)',51,5107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510720,'Fios de lã penteada, contendo < 85%, em peso, de lã','Yarn of combed wool containing predominantly, but < 85% wool by weight (excl. that put up for retail sale)','Hilados de lana peinada, con un alto contenido en lana, pero < 85% en peso (exc. acondicionados para la venta al por menor)',51,5107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510810,'Fios de pêlos finos, cardados, não acondicionados para venda a retalho','Carded yarn of fine animal hair (excl. that of wool or that put up for retail sale)','Hilados de pelo fino cardado (exc. de lana y acondicionados para la venta al por menor)',51,5108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510820,'Fios de pêlos finos, penteados, não acondicionados para venda a retalho','Combed yarn of fine animal hair (excl. that of wool and that put up for retail sale)','Hilados de pelo fino peinado (exc. de lana y acondicionados para la venta al por menor)',51,5108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510910,'Fios de lã ou de pêlos finos, contendo => 85%, em peso de lã ou de pêlos finos, para venda a retalho','Yarn containing >= 85% wool or fine animal hair by weight, put up for retail sale','Hilados con un contenido de lana o pelo fino >= 85% en peso, acondicionados para la venta al por menor',51,5109);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (510990,'Outros fios de lã ou de pêlos finos, para venda a retalho','Yarn containing predominantly, but < 85% wool or fine animal hair by weight, put up for retail sale','Hilados con un alto contenido de lana o pelo fino, pero < 85% en peso, acondicionados para la venta al por menor',51,5109);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (511000,'Fios de pêlos grosseiros ou de crina (incluídos os fios de crina revestidos por enrolamento), mesmo acondicionados para venda a retalho','Yarn of coarse animal hair or of horsehair, incl. gimped horsehair yarn, whether or not put up for retail sale (excl. horsehair and yarn not joined together)','Hilados de pelo ordinario o de crin, incl. los hilados de crin entorchados, incl. acondicionados para la venta al por menor (exc. crin no anudada)',51,5110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (511111,'Tecidos contendo => 85% em peso de lã cardada ou de pêlos finos cardados, de peso <= 300 g/m2','Woven fabrics containing >= 85% carded wool or carded fine animal hair by weight and weighing <= 300 g/m²','Tejidos de lana cardada o pelo fino cardado, con un contenido de lana o pelo fino >= 85% en peso, de peso <= 300 g/m²',51,5111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (511119,'Outros tecidos contendo => 85% em peso de lã cardada ou de pêlos finos cardados','Woven fabrics containing >= 85% carded wool or carded fine animal hair by weight and weighing > 300 g/m² (excl. fabrics for technical uses specificed in heading 5911)','Tejidos de lana cardada o pelo fino cardado, con un contenido de lana o pelo fino >= 85% en peso, de peso > 300 g/m²',51,5111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (511120,'Tecidos de lã cardada ou de pêlos finos cardados, combinados com filamentos sintéticos ou artificiais','Woven fabrics containing predominantly, but < 85% carded wool or carded fine animal hair by weight, mixed principally or solely with synthetic or artificial filaments','Tejidos con un alto contenido de lana cardada o pelo fino cardado, pero < 85% en peso, mezclados exclusiva o principalmente con filamentos sintéticos o artificiales',51,5111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (511130,'Tecidos de lã cardada ou de pêlos finos cardados, combinados com fibras sintéticas ou artificiais descontínuas','Woven fabrics containing predominantly, but < 85% carded wool or carded fine animal hair by weight, mixed principally or solely with synthetic or artificial staple fibres','Tejidos con un alto contenido de lana cardada o pelo fino cardado, pero < 85% en peso, mezclados exclusiva o principalmente con fibras sintéticas o artificiales discontinuas',51,5111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (511190,'Outros tecidos de lã cardada ou de pêlos finos cardados','Woven fabrics containing predominantly, but < 85% carded wool or carded fine animal hair by weight (excl. those mixed principally or solely with synthetic or artificial filaments or staple fibres)','Tejidos con un alto contenido de lana cardada o pelo fino cardado, pero < 85% en peso (exc. mezclados exclusiva o principalmente con filamentos sintéticos o artificiales o con fibras sintéticas o artificiales discontinuas)',51,5111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (511211,'Tecidos contendo => 85% em peso de lã penteada ou de pêlos finos penteados, de peso <= 200 g/m2','Woven fabrics containing >= 85% combed wool or combed fine animal hair by weight and weighing <= 200 g/m² (excl. fabrics for technical uses of heading 5911)','Tejidos de lana peinada o pelo fino peinado, con un contenido de lana o pelo fino >= 85% y de peso <= 200 g/m²',51,5112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (511219,'Outros tecidos contendo => 85% em peso de lã penteada ou de pêlos finos penteados','Woven fabrics containing >= 85% combed wool or combed fine animal hair by weight and weighing > 200 g/m²','Tejidos de lana peinada o pelo fino peinado, con un contenido de lana o pelo fino >= 85% y de peso > 200 g/m²',51,5112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (511220,'Tecidos de lã penteada ou de pêlos finos penteados, combinados com filamentos sintéticos ou artificiais','Woven fabrics containing predominantly, but < 85% combed wool or combed fine animal hair by weight, mixed principally or solely with synthetic or artificial filaments (excl. fabrics for technical uses of heading 5911)','Tejidos con un alto contenido de lana peinada o pelo fino peinado, pero < 85% en peso, mezclados exclusiva o principalmente con filamentos sintéticos o artificiales',51,5112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (511230,'Tecidos de lã penteada ou de pêlos finos penteados, combinados com fibras sintéticas ou artificiais descontínuas','Woven fabrics containing predominantly, but < 85% combed wool or combed fine animal hair by weight, mixed principally or solely with synthetic or artificial staple fibres (excl. fabrics for technical uses of heading 5911)','Tejidos con un alto contenido de lana peinada o pelo fino peinado, pero < 85% en peso, mezclados exclusiva o principalmente con fibras sintéticas o artificiales discontinuas',51,5112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (511290,'Outros tecidos de lã penteada ou de pêlos finos penteados','Woven fabrics containing predominantly, but < 85% combed wool or combed fine animal hair by weight (excl. those mixed principally or solely with synthetic or artificial filaments or staple fibres and fabrics for technical uses of heading 5911)','Tejidos con un alto contenido de lana peinada o pelo fino peinado, pero < 85% en peso (exc. mezclados exclusiva o principalmente con filamentos sintéticos o artificiales o con fibras sintéticas o artificiales discontinuas)',51,5112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (511300,'Tecidos de pêlos grosseiros ou de crina','Woven fabrics of coarse animal hair or of horsehair (excl. fabrics for technical uses of heading 5911)','Tejidos de pelo ordinario o de crin (exc. tejidos para usos técnicos de la partida 5911)',51,5113);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520100,'Algodão, não cardado nem penteado','Cotton, neither carded nor combed','Algodón, sin cardar ni peinar',52,5201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520210,'Desperdícios de fios de algodão','Cotton yarn waste, incl. thread waste','Desperdicios de hilados de algodón',52,5202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520291,'Desperdícios de fiapos de algodão','Garnetted stock of cotton','Hilachas de algodón',52,5202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520299,'Outros desperdícios de algodão','Cotton waste (excl. yarn waste, thread waste and garnetted stock)','Desperdicios de algodón (exc. desperdicios de hilados e hilachas)',52,5202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520300,'Algodão cardado ou penteado','Cotton, carded or combed','Algodón cardado o peinado',52,5203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520411,'Linhas para costurar, contendo => 85% em peso de algodão, não acondicionadas para venda a retalho','Sewing thread, containing >= 85% cotton by weight (excl. that put up for retail sale)','Hilo de coser de algodón, con un contenido de algodón >= 85% en peso (exc. acondicionado para la venta al por menor)',52,5204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520419,'Outras linhas para costurar, de algodão, não acondicionadas para venda a retalho','Sewing thread, containing predominantly, but < 85% cotton by weight (excl. that put up for retail sale)','Hilo de coser de algodón, con un alto contenido de algodón, pero < 85% en peso (exc. acondicionado para la venta al por menor)',52,5204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520420,'Linhas para costurar, de algodão, para venda a retalho','Cotton sewing thread, put up for retail sale','Hilo de coser de algodón, acondicionado para la venta al por menor',52,5204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520511,'Fios de algodão simples, de fibras não penteadas, contendo => 85% em peso de algodão, título => 714,29 decitex, não acondicionadas para venda a retalho','Single cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and with a linear density of >= 714,29 decitex <= MN 14 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, sencillos, de fibras sin peinar, con un contenido de algodón >= 85% en peso, de título >= 714,29 decitex "<= número métrico 14" (exc. acondicionados para la venta al por menor, así como el hilo de coser)',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520512,'Fios de algodão simples, de fibras não penteadas, contendo => 85% em peso de algodão, título => 232,56 decitex, mas < 714,29 decitex, não acondicionados para venda a retalho','Single cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and with a linear density of 232,56 decitex to < 714,29 decitex > MN 14 to MN 43 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, sencillos, de fibras sin peinar, con un contenido de algodón >= 85% en peso, de título < 714,29 decitex pero >= 232,56 decitex "> número métrico 14 pero <= número métrico 43" (exc. acondicionados para la venta al por menor, así como el',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520513,'Fios de algodão simples, de fibras não penteadas, contendo => 85% em peso de algodão, título => 192,31 decitex, mas < 232,56 decitex, não acondicionados para venda a retalho','Single cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and with a linear density of 192,31 decitex to < 232,56 decitex > MN 43 to MN 52 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, sencillos, de fibras sin peinar, con un contenido de algodón >= 85% en peso, de título < 232,56 decitex pero >= 192,31 decitex "> número métrico 43 pero <= número métrico 52" (exc. acondicionados para la venta al por menor, así como el',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520514,'Fios de algodão simples, de fibras não penteadas, contendo => 85% em peso de algodão, título => 125 decitex, mas < 192,31 decitex, não acondicionados para venda a retalho','Single cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and with a linear density of 125 decitex to < 192,31 decitex > MN 52 to MN 80 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, sencillos, de fibras sin peinar, con un contenido de algodón >= 85% en peso, de título < 192,31 decitex pero >= 125 decitex "> número métrico 52 pero <= número métrico 80" (exc. acondicionados para la venta al por menor, así como el hi',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520515,'Fios de algodão simples, de fibras não penteadas, contendo => 85% em peso de algodão, título < 125 decitex, não acondicionados para venda a retalho','Single cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and with a linear density of < 125 decitex > MN 80 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, sencillos, de fibras sin peinar, con un contenido de algodón >= 85% en peso, de título < 125 decitex "> número métrico 80" (exc. acondicionados para la venta al por menor, así como el hilo de coser)',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520521,'Fios de algodão simples, de fibras penteadas, contendo => 85% em peso de algodão, título => 714,29 decitex, não acondicionados para venda a retalho','Single cotton yarn, of combed fibres, containing >= 85% cotton by weight and with a linear density of >= 714,29 decitex <= MN 14 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, sencillos, de fibras peinadas, con un contenido de algodón >= 85% en peso, de título >= 714,29 decitex "<= número métrico 14" (exc. acondicionados para la venta al por menor, así como el hilo de coser)',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520522,'Fios de algodão simples, de fibras penteadas, contendo => 85% em peso de algodão, título => 232,56 decitex, mas < 714,29 decitex, não acondicionados para venda a retalho','Single cotton yarn, of combed fibres, containing >= 85% cotton by weight and with a linear density of 232,56 decitex to < 714,29 decitex > MN 14 to MN 43 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, sencillos, de fibras peinadas, con un contenido de algodón >= 85% en peso, de título < 714,29 decitex pero >= 232,56 decitex "> número métrico 14 pero <= número métrico 43" (exc. acondicionados para la venta al por menor, así como el h',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520523,'Fios de algodão simples, de fibras penteadas, contendo => 85% em peso de algodão, título => 192,31 decitex, mas < 232,56 decitex, não acondicionados para venda a retalho','Single cotton yarn, of combed fibres, containing >= 85% cotton by weight and with a linear density of 192,31 decitex to < 232,56 decitex > MN 43 to MN 52 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, sencillos, de fibras peinadas, con un contenido de algodón >= 85% en peso, de título < 232,56 decitex pero >= 192,31 decitex "> número métrico 43 pero <= número métrico 52" (exc. acondicionados para la venta al por menor, así como el h',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520524,'Fios de algodão simples, de fibras penteadas, contendo => 85% em peso de algodão, título => 125 decitex, mas < 192,31 decitex, não acondicionados para venda a retalho','Single cotton yarn, of combed fibres, containing >= 85% cotton by weight and with a linear density of 125 decitex to < 192,31 decitex > MN 52 to MN 80 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, sencillos, de fibras peinadas, con un contenido de algodón >= 85% en peso, de título < 192,31 decitex pero >= 125 decitex "> número métrico 52 pero <= número métrico 80" (exc. acondicionados para la venta al por menor, así como el hilo',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520526,'Fios de algodão simples, de fibras penteadas, contendo => 85% em peso de algodão, título => 106,38 decitex, mas < 125 decitex, não acondicionados para venda a retalho','Single cotton yarn, of combed fibres, containing >= 85% cotton by weight and with a linear density of 106,38 decitex to < 125 decitex > MN 80 to MN 94 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, sencillos, de fibras peinadas, con un contenido de algodón >= 85% en peso, de título < 125 decitex pero >= 106,38 decitex "> número métrico 80 pero <= número métrico 94" (exc. acondicionados para la venta al por menor, así como el hilo',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520527,'Fios de algodão simples, de fibras penteadas, contendo => 85% em peso de algodão, título => 83,33 decitex, mas < 106,38 decitex, não acondicionados para venda a retalho','Single cotton yarn, of combed fibres, containing >= 85% cotton by weight and with a linear density of 83,33 decitex to < 106,38 decitex > MN 94 to MN 120 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, sencillos, de fibras peinadas, con un contenido de algodón >= 85% en peso, de título < 106,38 decitex pero >= 83,33 decitex "> número métrico 94 pero <= número métrico 120" (exc. acondicionados para la venta al por menor, así como el h',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520528,'Fios de algodão simples, de fibras penteadas, contendo => 85% em peso de algodão, título < 83,33 decitex, não acondicionados para venda a retalho','Single cotton yarn, of combed fibres, containing >= 85% cotton by weight and with a linear density of < 83,33 decitex > MN 120 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, sencillos, de fibras peinadas, con un contenido de algodón >= 85% en peso, de título < 83,33 decitex "> número métrico 120" (exc. acondicionados para la venta al por menor, así como el hilo de coser)',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520531,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras não penteadas, contendo => 85% em peso de algodão, título => 714,29 decitex, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and with a linear density of >= 714,29 decitex <= MN 14 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, retorcidos o cableados, de fibras sin peinar, con un contenido de algodón >= 85% en peso, de título >= 714,29 decitex por hilo sencillo "<= número métrico 14 por hilo sencillo" (exc. acondicionados para la venta al por menor, así como ',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520532,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras não penteadas, contendo => 85% em peso de algodão, título => 232,56 decitex, mas < 714,29 decitex, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and with a linear density of 232,56 decitex to < 714,29 decitex > MN 14 to MN 43 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, retorcidos o cableados, de fibras sin peinar, con un contenido de algodón >= 85% en peso, de título < 714,29 decitex pero >= 232,56 decitex por hilo sencillo "> número métrico 14 pero <= número métrico 43 por hilo sencillo" (exc. acond',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520533,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras não penteadas, contendo => 85% em peso de algodão, título => 192,31 decitex, mas < 232,56 decitex, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and with a linear density of 192,31 decitex to < 232,56 decitex > MN 43 to MN 52 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, retorcidos o cableados, de fibras sin peinar, con un contenido de algodón >= 85% en peso, de título < 232,56 decitex pero >= 192,31 decitex por hilo sencillo "> número métrico 43 pero <= número métrico 52 por hilo sencillo" (exc. acond',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520534,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras não penteadas, contendo => 85% em peso de algodão, título => 125 decitex, mas < 192,31 decitex por fio simples, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and with a linear density of 125 decitex to < 192,31 decitex > MN 52 to MN 80 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, retorcidos o cableados, de fibras sin peinar, con un contenido de algodón >= 85% en peso, de título < 192,31 decitex pero >= 125 decitex por hilo sencillo "> número métrico 52 pero <= número métrico 80 por hilo sencillo" (exc. acondici',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520535,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras não penteadas, contendo => 85% em peso de algodão, título < 125 decitex por fio simples, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn, of uncombed fibres, containing >= 85% cotton by weight and with a linear density of < 125 decitex > MN 80 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, retorcidos o cableados, de fibras sin peinar, con un contenido de algodón >= 85% en peso, de título < 125 decitex por hilo sencillo "> número métrico 80 por hilo sencillo" (exc. acondicionados para la venta al por menor, así como el hi',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520541,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras penteadas, contendo => 85% em peso de algodão, título => 714,29 decitex por fio simples, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn, of combed fibres, containing >= 85% cotton by weight and with a linear density of >= 714,29 decitex <= MN 14 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, retorcidos o cableados, de fibras peinadas, con un contenido de algodón >= 85% en peso, de título >= 714,29 decitex por hilo sencillo "<= número métrico 14 por hilo sencillo" (exc. acondicionados para la venta al por menor, así como el',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520542,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras penteadas, contendo => 85% em peso de algodão, título => 232,56 decitex, mas < 714,29 decitex, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn, of combed fibres, containing >= 85% cotton by weight and with a linear density of 232,56 decitex to < 714,29 decitex > MN 14 to MN 43 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, retorcidos o cableados, de fibras peinadas, con un contenido de algodón >= 85% en peso, de título < 714,29 decitex pero >= 232,56 decitex por hilo sencillo "> número métrico 14 pero <= número métrico 43 por hilo sencillo" (exc. acondic',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520543,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras penteadas, contendo => 85% em peso de algodão, título => 192,31 decitex, mas < 232,56 decitex, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn, of combed fibres, containing >= 85% cotton by weight and with a linear density of 192,31 decitex to < 232,56 decitex > MN 43 to MN 52 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, retorcidos o cableados, de fibras peinadas, con un contenido de algodón >= 85% en peso, de título < 232,56 decitex pero >= 192,31 decitex por hilo sencillo "> número métrico 43 pero <= número métrico 52 por hilo sencillo" (exc. acondic',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520544,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras penteadas, contendo => 85% em peso de algodão, título => 125 decitex, mas < 192,31 decitex, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn, of combed fibres, containing >= 85% cotton by weight and with a linear density of 125 decitex to < 192,31 decitex > MN 52 to MN 80 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, retorcidos o cableados, de fibras peinadas, con un contenido de algodón >= 85% en peso, de título < 192,31 decitex pero >= 125 decitex por hilo sencillo "> número métrico 52 pero <= número métrico 80 por hilo sencillo" (exc. acondicion',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520546,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras penteadas, contendo => 85% em peso de algodão, título => 106,38 decitex, mas < 125 decitex, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn, of combed fibres, containing >= 85% cotton by weight and with a linear density of 106,38 decitex to < 125 decitex > MN 80 to MN 94 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, retorcidos o cableados, de fibras peinadas, con un contenido de algodón >= 85% en peso, de título < 125 decitex pero >= 106,38 decitex por hilo sencillo "> número métrico 80 pero <= número métrico 94 por hilo sencillo" (exc. acondicion',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520547,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras penteadas, contendo => 85% em peso de algodão, título => 83,33 decitex, mas < 106,38 decitex, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn, of combed fibres, containing >= 85% cotton by weight and with a linear density of 83,33 decitex to < 106,38 decitex > MN 94 to MN 120 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, retorcidos o cableados, de fibras peinadas, con un contenido de algodón >= 85% en peso, de título < 106,38 decitex pero >= 83,33 decitex por hilo sencillo "> número métrico 94 pero <= número métrico 120 por hilo sencillo" (exc. acondic',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520548,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras penteadas, contendo => 85% em peso de algodão, título < 83,33 decitex, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn, of combed fibres, containing >= 85% cotton by weight and with a linear density of < 83,33 decitex > MN 120 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, retorcidos o cableados, de fibras peinadas, con un contenido de algodón >= 85% en peso, de título < 83,33 decitex por hilo sencillo "> número métrico 120 por hilo sencillo" (exc. acondicionados para la venta al por menor, así como el h',52,5205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520611,'Fios de algodão simples, de fibras não penteadas, contendo < 85% em peso de algodão, título => 714,29 decitex, não acondicionados para venda a retalho','Single cotton yarn containing predominantly, but < 85% cotton by weight, of uncombed fibres and with a linear density of >= 714,29 decitex <= MN 14 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, sencillos, de fibras sin peinar, de título >= 714,29 decitex "<= número métrico 14" (exc. acondicionados para la venta al por menor, así como el hilo de coser)',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520612,'Fios de algodão simples, de fibras não penteadas, contendo < 85% em peso de algodão, título => 232,56 decitex, mas < 714,29 decitex, não acondicionados para venda a retalho','Single cotton yarn containing predominantly, but < 85% cotton by weight, of uncombed fibres and with a linear density of 232,56 decitex to < 714,29 decitex > MN 14 to MN 43 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, sencillos, de fibras sin peinar, de título < 714,29 decitex pero >= 232,56 decitex "> número métrico 14 pero <= número métrico 43" (exc. acondicionados para la venta al por menor, a',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520613,'Fios de algodão simples, de fibras não penteadas, contendo < 85% em peso de algodão, título => 192,31 decitex, mas < 232,56 decitex, não acondicionados para venda a retalho','Single cotton yarn containing predominantly, but < 85% cotton by weight, of uncombed fibres and with a linear density of 192,31 decitex to < 232,56 decitex > MN 43 to MN 52 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, sencillos, de fibras sin peinar, de título < 232,56 decitex pero >= 192,31 decitex "> número métrico 43 pero <= número métrico 52" (exc. acondicionados para la venta al por menor, a',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520614,'Fios de algodão simples, de fibras não penteadas, contendo < 85% em peso de algodão, título => 125 decitex, mas < 192,31 decitex, não acondicionados para venda a retalho','Single cotton yarn containing predominantly, but < 85% cotton by weight, of uncombed fibres and with a linear density of 125 decitex to < 192,31 decitex > MN 52 to MN 80 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, sencillos, de fibras sin peinar, de título < 192,31 decitex pero >= 125 decitex "> número métrico 52 pero <= número métrico 80" (exc. acondicionados para la venta al por menor, así ',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520615,'Fios de algodão simples, de fibras não penteadas, contendo < 85% em peso de algodão, título < 125 decitex, não acondicionados para venda a retalho','Single cotton yarn containing predominantly, but < 85% cotton by weight, of uncombed fibres and with a linear density of < 125 decitex > MN 80 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, sencillos, de fibras sin peinar, de título < 125 decitex "> número métrico 80" (exc. acondicionados para la venta al por menor, así como el hilo de coser)',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520621,'Fios de algodão simples, de fibras penteadas, contendo < 85% em peso de algodão, título => 714,29 decitex, não acondicionados para venda a retalho','Single cotton yarn containing predominantly, but < 85% cotton by weight, of combed fibres and with a linear density of >= 714,29 decitex <= MN 14 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, sencillos, de fibras peinadas, de título >= 714,29 decitex "<= número métrico 14" (exc. acondicionados para la venta al por menor, así como el hilo de coser)',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520622,'Fios de algodão simples, de fibras penteadas, contendo < 85% em peso de algodão, título => 232,56 decitex, mas < 714,29 decitex, não acondicionados para venda a retalho','Single cotton yarn containing predominantly, but < 85% cotton by weight, of combed fibres and with a linear density of 232,56 decitex to < 714,29 decitex > MN 14 to MN 43 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, sencillos, de fibras peinadas, de título < 714,29 decitex pero >= 232,56 decitex "> número métrico 14 pero <= número métrico 43" (exc. acondicionados para la venta al por menor, así',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520623,'Fios de algodão simples, de fibras penteadas, contendo < 85% em peso de algodão, título => 192,31 decitex, mas < 232,56 decitex, não acondicionados para venda a retalho','Single cotton yarn containing predominantly, but < 85% cotton by weight, of combed fibres and with a linear density of 192,31 decitex to < 232,56 decitex > MN 43 to MN 52 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, sencillos, de fibras peinadas, de título < 232,56 decitex pero >= 192,31 decitex "> número métrico 43 pero <= número métrico 52" (exc. acondicionados para la venta al por menor, así',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520624,'Fios de algodão simples, de fibras penteadas, contendo < 85% em peso de algodão, título => 125 decitex, mas < 192,31 decitex, não acondicionados para venda a retalho','Single cotton yarn containing predominantly, but < 85% cotton by weight, of combed fibres and with a linear density of 125 decitex to < 192,31 decitex > MN 52 to MN 80 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, sencillos, de fibras peinadas, de título < 192,31 decitex pero >= 125 decitex "> número métrico 52 pero <= número métrico 80" (exc. acondicionados para la venta al por menor, así co',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520625,'Fios de algodão simples, de fibras penteadas, contendo < 85% em peso de algodão, título < 125 decitex, não acondicionados para venda a retalho','Single cotton yarn containing predominantly, but < 85% cotton by weight, of combed fibres and with a linear density of < 125 decitex > MN 80 (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, sencillos, de fibras peinadas, de título < 125 decitex "> número métrico 80" (exc. acondicionados para la venta al por menor, así como el hilo de coser)',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520631,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras não penteadas, contendo < 85% em peso de algodão, título => 714,29 decitex por fio simples, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn containing predominantly, but < 85% cotton by weight, of uncombed fibres and with a linear density of >= 714,29 decitex <= MN 14 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, retorcidos o cableados, de fibras sin peinar, de título >= 714,29 decitex por hilo sencillo "<= número métrico 14 por hilo sencillo" (exc. acondicionados para la venta al por menor,',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520632,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras não penteadas, contendo < 85% em peso de algodão, título => 232,56 decitex, mas < 714,29 decitex por fio simples, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn containing predominantly, but < 85% cotton by weight, of uncombed fibres and with a linear density of 232,56 decitex to < 714,29 decitex > MN 14 to MN 43 per single yarn (excl. sewing thread and yarn put up for retail','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, retorcidos o cableados, de fibras sin peinar, de título < 714,29 decitex pero >= 232,56 decitex por hilo sencillo "> número métrico 14 pero <= número métrico 43 por hilo sencillo" (',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520633,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras não penteadas, contendo < 85% em peso de algodão, título => 192,31 decitex, mas < 232,56 decitex, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn containing predominantly, but < 85% cotton by weight, of uncombed fibres and with a linear density of 192,31 decitex to < 232,56 decitex > MN 43 to MN 52 per single yarn (excl. sewing thread and yarn put up for retail','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, retorcidos o cableados, de fibras sin peinar, de título < 232,56 decitex pero >= 192,31 decitex por hilo sencillo "> número métrico 43 pero <= número métrico 52 por hilo sencillo" (',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520634,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras não penteadas, contendo < 85% em peso de algodão, título => 125 decitex, mas < 192,31 decitex por fio simples, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn containing predominantly, but < 85% cotton by weight, of uncombed fibres and with a linear density of 125 decitex to < 192,31 decitex > MN 52 to MN 80 per single yarn (excl. sewing thread and yarn put up for retail sa','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, retorcidos o cableados, de fibras sin peinar, de título < 192,31 decitex pero >= 125 decitex por hilo sencillo "> número métrico 52 pero <= número métrico 80 por hilo sencillo" (exc',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520635,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras não penteadas, contendo < 85% em peso de algodão, título < 125 decitex por fio simples, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn containing predominantly, but < 85% cotton by weight, of uncombed fibres and with a linear density of < 125 decitex > MN 80 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, retorcidos o cableados, de fibras sin peinar, de título < 125 decitex por hilo sencillo "> número métrico 80 por hilo sencillo" (exc. acondicionados para la venta al por menor, así ',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520641,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras penteadas, contendo < 85% em peso de algodão, título => 714,29 decitex por fio simples, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn containing predominantly, but < 85% cotton by weight, of combed fibres and with a linear density of >= 714,29 decitex < MN 14 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, retorcidos o cableados, de fibras peinadas, de título >= 714,29 decitex por hilo sencillo "<= número métrico 14 por hilo sencillo" (exc. acondicionados para la venta al por menor, a',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520642,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras penteadas, contendo < 85% em peso de algodão, título => 232,56 decitex, mas < 714,29 decitex por fio simples, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn containing predominantly, but < 85% cotton by weight, of combed fibres and with a linear density of 232,56 decitex to < 714,29 decitex > MN 14 to MN 43 per single yarn (excl. sewing thread and yarn put up for retail s','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, retorcidos o cableados, de fibras peinadas, de título < 714,29 decitex pero >= 232,56 decitex por hilo sencillo "> número métrico 14 pero <= número métrico 43 por hilo sencillo" (ex',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520643,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras penteadas, contendo < 85% em peso de algodão, título => 192,31 decitex, mas < 232,56 decitex por fio simples, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn containing predominantly, but < 85% cotton by weight, of combed fibres and with a linear density of 192,31 decitex to < 232,56 decitex > MN 43 to MN 52 per single yarn (excl. sewing thread and yarn put up for retail s','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, retorcidos o cableados, de fibras peinadas, de título < 232,56 decitex pero >= 192,31 decitex por hilo sencillo "> número métrico 43 pero <= número métrico 52 por hilo sencillo" (ex',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520644,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras penteadas, contendo < 85% em peso de algodão, título => 125 decitex, mas < 192,31 decitex por fio simples, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn containing predominantly, but < 85% cotton by weight, of combed fibres and with a linear density of 125 decitex to < 192,31 decitex > MN 52 to MN 80 per single yarn (excl. sewing thread and yarn put up for retail sale','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, retorcidos o cableados, de fibras peinadas, de título < 192,31 decitex pero >= 125 decitex por hilo sencillo "> número métrico 52 pero <= número métrico 80 por hilo sencillo" (exc. ',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520645,'Fios de algodão retorcidos ou retorcidos múltiplos, de fibras penteadas, contendo < 85% em peso de algodão, título < 125 decitex por fio simples, não acondicionados para venda a retalho','Multiple folded or cabled cotton yarn containing predominantly, but < 85% cotton by weight, of combed fibres and with a linear density of < 125 decitex > MN 80 per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, retorcidos o cableados, de fibras peinadas, de título < 125 decitex por hilo sencillo "> número métrico 80 por hilo sencillo" (exc. acondicionados para la venta al por menor, así co',52,5206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520710,'Fios de algodão, para venda a retalho, contendo => 85% em peso de algodão','Cotton yarn containing >= 85% cotton by weight, put up for retail sale (excl. sewing thread)','Hilados de algodón, con un contenido de algodón >= 85%, acondicionados para la venta al por menor (exc. hilo de coser)',52,5207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520790,'Outros fios de algodão, para venda a retalho','Cotton yarn containing predominantly, but < 85% cotton by weight, put up for retail sale (excl. sewing thread)','Hilados de algodón, con un alto contenido de algodón, pero < 85% en peso, acondicionados para la venta al por menor (exc. hilo de coser)',52,5207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520811,'Tecido de algodão cru, em ponto de tafetá, contendo => 85% em peso de algodão, com peso <= 100 g/m2','Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 100 g/m², unbleached','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso <= 100 g/m², de ligamento tafetán, crudos',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520812,'Tecido de algodão cru, em ponto de tafetá, contendo => 85% em peso de algodão, com peso > 100 g/m2 e <= 200 g/m2','Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 100 g to 200 g/m², unbleached','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 100 g/m² pero <= 200 g/m², de ligamento tafetán, crudos',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520813,'Tecido de algodão cru, em ponto sarjado, contendo => 85% em peso de algodão, com peso <= 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200 g/m², in three-thread or four-thread twill, incl. cross twill, unbleached','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso <= 200 g/m², de ligamento sarga o cruzado de curso <= 4, crudos',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520819,'Outros tecidos de algodão cru, contendo => 85% em peso de algodão, com peso <= 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200 g/m², unbleached (excl. those in three-thread or four-thread twill, incl. cross twill, and plain woven fabrics)','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso <= 200 g/m², crudos (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520821,'Tecido de algodão branqueado, em ponto de tafetá, contendo => 85% em peso de algodão,com peso <= 100 g/m2','Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200 g/m², unbleached','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso <= 100 g/m², de ligamento tafetán, blanqueados',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520822,'Tecido de algodão branqueado, em ponto de tafetá, contendo => 85% em peso de algodão, com peso > 100 g/m2 e <= 200 g/m2','Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 100 g to 200 g/m², bleached','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 100 g/m² pero <= 200 g/m², de ligamento tafetán, blanqueados',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520823,'Tecido de algodão branqueado, em ponto sarjado, contendo => 85% em peso de algodão, com peso <= 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200 g/m², in three-thread or four-thread twill, incl. cross twill, bleached','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso <= 200 g/m², de ligamento sarga o cruzado de curso <= 4, blanqueados',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520829,'Outros tecidos de algodão branqueado, contendo => 85% em peso de algodão, com peso <= 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200 g/m², bleached (excl. those in three-thread or four-thread twill, incl. cross twill, and plain woven fabrics)','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso <= 200 g/m², blanqueados (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520831,'Tecido de algodão tinto, em ponto de tafetá, contendo => 85% em peso de algodão, com peso <= 100 g/m2','Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 100 g/m², dyed','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso <= 100 g/m², de ligamento tafetán, teñidos',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520832,'Tecido de algodão tinto, em ponto de tafetá, contendo => 85% em peso de algodão, com peso > 100 g/m2 e <= 200 g/m2','Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 100 g to 220 g/m², dyed','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 100 g/m² pero <= 200 g/m², de ligamento tafetán, teñidos',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520833,'Tecido de algodão tinto, em ponto sarjado, contendo => 85% em peso de algodão, com peso <= 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200 g/m², in three-thread or four-thread twill, incl. cross twill, dyed','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso <= 200 g/m², de ligamento sarga o cruzado de curso <= 4, teñidos',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520839,'Outros tecidos de algodão tinto, contendo => 85% em peso de algodão, com peso <= 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200 g/m², dyed (excl. those in three-thread or four-thread twill, incl. cross twill, and plain woven fabrics)','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso <= 200 g/m², teñidos (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520841,'Tecido de algodão, fios de diversas cores, em ponto de tafetá, contendo => 85% em peso de algodão, com peso <= 100 g/m2','Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 100 g/m², made from yarn of different colours','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso <= 100 g/m², de ligamento tafetán, fabricados con hilos de distintos colores',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520842,'Tecido de algodão, fios de diversas cores, em ponto de tafetá, contendo => 85% em peso de algodão, com peso => 100 g/m2 e <= 200 g/m2','Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 100 g to 200 g/m², made from yarn of different colours','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 100 g/m² pero <= 200 g/m², de ligamento tafetán, fabricados con hilos de distintos colores',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520843,'Tecido de algodão, fios de diversas cores, em ponto sarjado, contendo => 85% em peso de algodão, com peso <= 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200 g/m², in three-thread or four-thread twill, incl. cross twill, made from yarn of different colours','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso <= 200 g/m², de ligamento sarga o cruzado de curso <= 4, fabricados con hilos de distintos colores',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520849,'Outros tecidos de algodão, fios de diversas cores, contendo => 85% em peso de algodão, com peso <= 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200 g/m², made from yarn of different colours (excl. those in three-thread or four-thread twill, incl. cross twill, and plain woven fabrics)','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso <= 200 g/m², fabricados con hilos de distintos colores (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520851,'Tecido de algodão estampado, em ponto de tafetá, contendo => 85% em peso de algodão, com peso <= 100 g/m2','Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 100 g/m², printed','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso <= 100 g/m², de ligamento tafetán, estampados',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520852,'Tecido algodão estampado, em ponto de tafetá, contendo => 85% em peso de algodão, com peso > 100 g/m2 e <= 200 g/m2','Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 100 g to 200 g/m², printed','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 100 g/m² pero <= 200 g/m², de ligamento tafetán, estampados',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520853,'Tecido de algodão>=85%,  estampado,  pto.sarjado,  p<=200g/m2','Fabric of cotton>=85%, printed, point twill, w<=100g/m2','Tejido de algodón>=85%, estampado, lig.sarga, p<=200g/m2',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520859,'Outros tecidos de algodão estampado, contendo => 85% em peso de algodão, com peso <= 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing <= 200 g/m², printed (excl. plain woven fabrics)','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso <= 200 g/m², estampados (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520911,'Tecido de algodão cru, em ponto de tafetá, contendo => 85% em peso de algodão, com peso > 200 g/m2','Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g/m², unbleached','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 200 g/m², de ligamento tafetán, crudos',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520912,'Tecido de algodão cru, em ponto sarjado, contendo => 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g/m², in three-thread or four-thread twill, incl. cross twill, unbleached','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 200 g/m², de ligamento sarga o cruzado de curso <= 4, crudos',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520919,'Outros tecidos de algodão cru, contendo => 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g/m², unbleached (excl. those in three-thread or four-thread twill, incl. cross twill, and plain woven fabrics)','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 200 g/m², crudos (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520921,'Tecido de algodão branqueado, em ponto de tafetá, contendo => 85% em peso de algodão, com peso > 200 g/m2','Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g/m², bleached','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 200 g/m², de ligamento tafetán, blanqueados',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520922,'Tecido de algodão branqueado, em ponto sarjado, contendo => 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g/m², in three-thread or four-thread twill, incl. cross twill, bleached','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 200 g/m², de ligamento sarga o cruzado de curso <= 4, blanqueados',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520929,'Outros tecidos de algodão branqueado, contendo => 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g/m², bleached (excl. those in three-thread or four-thread twill, incl. cross twill, and plain woven fabrics)','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 200 g/m², blanqueados (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520931,'Tecido de algodão tinto, em ponto de tafetá, contendo => 85% em peso de algodão, com peso > 200 g/m2','Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g/m², dyed','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 200 g/m², de ligamento tafetán, teñidos',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520932,'Tecido de algodão tinto, em ponto sarjado, contendo => 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g/m², in three-thread or four-thread twill, incl. cross twill, dyed','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 200 g/m², de ligamento sarga o cruzado de curso <= 4, teñidos',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520939,'Outros tecidos de algodão tinto, contendo => 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g/m², dyed (excl. those in three-thread or four-thread twill, incl. cross twill, and plain woven fabrics)','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 200 g/m², teñidos (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520941,'Tecido de algodão, fios de diversas cores, em ponto tafetá, contendo => 85% em peso de algodão, com peso > 200 g/m2','Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g/m², made of yarn of different colours','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 200 g/m², de ligamento tafetán, fabricados con hilos de distintos colores',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520942,'Tecidos de algodão, fios de diversas cores, denim, contendo => 85% em peso de algodão, com peso > 200 g/m2','Denim, containing >= 85% cotton by weight and weighing > 200 g/m², made of yarn of different colours','Tejidos de mezclilla "denim", con un contenido de algodón >= 85% en peso, de peso > 200 g/m², fabricados con hilos de distintos colores',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520943,'Tecido de algodão, fios de diversas cores, em ponto sarjado, contendo => 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g/m², in three-thread or four-thread twill, incl. cross twill, made of yarn of different colours','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 200 g/m², de ligamento sarga o cruzado de curso <= 4, fabricados con hilos de distintos colores',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520949,'Outros tecidos de algodão, fios de diversas cores, contendo => 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g/m², made of yarn of different colours (excl. those in three-thread or four-thread twill, incl. cross twill, and plain woven fabrics)','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 200 g/m², fabricados con hilos de distintos colores (exc. de ligamento sarga o cruzado de curso <= 4, tejidos de mezclilla "denim" y de ligamento tafetán)',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520951,'Tecido de algodão estampado, em ponto de tafetá, contendo => 85% em peso de algodão, com peso > 200 g/m2','Plain woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g/m², printed','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 200 g/m², de ligamento tafetán, estampados',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520952,'Tecido de algodão estampado, em ponto sarjado, contendo => 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g/m², in three-thread or four-thread twill, incl. cross twill, printed','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 200 g/m², de ligamento sarga o cruzado de curso <= 4, estampados',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (520959,'Outros tecidos de algodão estampado, contendo => 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing >= 85% cotton by weight and weighing > 200 g/m², printed (excl. those in three-thread or four-thread twill, incl. cross twill, and plain woven fabrics)','Tejidos de algodón, con un contenido de algodón >= 85% en peso, de peso > 200 g/m², estampados (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521011,'Tecido de algodão cru, com fibras sintéticas ou artificiais, em ponto de tafetá, contendo < 85% em peso de algodão, com peso <= 200 g/m2','Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing <= 200 g/m², unbleached','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso <= 200 g/m², de ligamento tafetán, crudos',52,5210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521012,'Tecido algodão<85%,  cru/fibra sint/art.sarjad.p<=200g/m2','Fabric of cotton<85%, raw/fibre syn/art.twill, w<=200g/m2','Tejido algodón<85%, crudo/fibra sint/art.sar., p<=200g/m2',52,5210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521019,'Outros tecidos de algodão cru, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso <= 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing <= 200 g/m², unbleached (excl. plain woven fabrics)','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso <= 200 g/m², crudos (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521021,'Tecido de algodão branqueado, em ponto de tafetá, com fibras sintéticas ou artificiais, contendo < 85%em peso de algodão, com peso <= 200 g/m2','Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing <= 200 g/m², bleached','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso <= 200 g/m², de ligamento tafetán, blanqueados',52,5210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521022,'Tecido algod<85%,  branq/fibra sint/art.sarjad.p<=200g/m2','Fabric of cot.<85%, bleac/fibr.synt/art.twill, w<=200g/m2','Tejido algodón<85%, blanq/fibra sint/art.sar., p<=200g/m2',52,5210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521029,'Outros tecidos de algodão branqueados, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso <= 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing <= 200 g/m², bleached (excl. plain woven fabrics)','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso <= 200 g/m², blanqueados (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521031,'Tecido de algodão tinto, em ponto de tafetá, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso <= 200 g/m2','Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing <= 200 g/m², dyed','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso <= 200 g/m², de ligamento tafetán, teñidos',52,5210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521032,'Tecido de algodão tinto, em ponto sarjado, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso <= 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing <= 200 g/m², in three-thread or four-thread twill, incl. cross twill, dyed','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso <= 200 g/m², de ligamento sarga o cruzado de curso <= 4, teñidos',52,5210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521039,'Outros tecidos de algodão tinto, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso <= 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing <= 200 g/m², dyed (excl. those in three-thread or four-thread twill, incl. cross twill, and plain woven fabrics)','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso <= 200 g/m², teñidos (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521041,'Tecido de algodão, fios de diversas cores, em ponto de tafetá, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso <= 200 g/m2','Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing <= 200 g/m², made of yarn of different colours','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso <= 200 g/m², de ligamento tafetán, fabricados con hilos de distintos colores',52,5210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521042,'tecido algod<85%,  color/fibra sint/art.sarjad.p<=200g/m2','fabric of cotton<85%, col./fibr.syn/art.twill, w<=200g/m2','tejido algodón<85%, color./fibr.sint/art.sar., p<=200g/m2',52,5210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521049,'Outros tecidos de algodão, de fios de diversas cores, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso <= 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing <= 200 g/m², made from yarn of different colours (excl. plain woven fabrics)','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso <= 200 g/m², fabricados con hilos de distintos colores (exc. de ligamento sarga o cruzado de curso',52,5210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521051,'Tecido de algodão estampado, em ponto de tafetá, com fibras sintéticas ou artificiais, contendo < 85%em peso de algodão, com peso <= 200 g/m2','Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing <= 200 g/m², printed','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso <= 200 g/m², de ligamento tafetán, estampados',52,5210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521052,'Tecido algod<85%, estamp/fibr.sint/art.sarjad.p<=200g/m2','Fabric cotton<85%, printed/fib.synt/art.twill, w<=200g/m2','Tejido algodón<85%, estamp/fibr.sint/art.sar., p<=200g/m2',52,5210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521059,'Outros tecidos de algodão estampados, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso <= 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing <= 200 g/m², printed (excl. plain woven fabrics)','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso <= 200 g/m², estampados (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521111,'Tecido de algodão cru, em ponto de tafetá, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso > 200 g/m2','Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing > 200 g/m², unbleached','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso > 200 g/m², de ligamento tafetán, crudos',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521112,'Tecido de algodão cru, em ponto sarjado, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing > 200 g/m², in three-thread or four-thread twill, incl. cross twill, unbleached','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso > 200 g/m², de ligamento sarga o cruzado de curso <= 4, crudos',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521119,'Outros tecidos de algodão cru, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing > 200 g/m², unbleached (excl. those in three-thread or four-thread twill, incl. cross twill, and plain woven fabri','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso > 200 g/m², crudos (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521120,'Tecidos de algodão, branqueados, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing > 200 g/m², bleached','Tejidos de algodón, blanqueados, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso > 200 g/m²',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521121,'tecido algodão<85%,  branq/fibr.sint/art.tafeta,  p>200g/m2','fabric of cotton<85%, bleac/fibr.synt/art.taf., w>200g/m2','tejido algodón<85%, blanq/fibra sint/art.taf., p>200g/m2',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521122,'tecido algodão<85%,  branq/fibr.sint/art.sarjad.p>200g/m2','fabric of cotton<85%, bleac/fibr.syn/art.twill, w>200g/m2','tejido algodón<85%, blanq/fibra sint/art.sar., p>200g/m2',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521129,'outs.tecidos algodão<85%,  branq/fibra sint/art.p>200g/m2','ot.fabrics of cotton<85%, bleac/fibr.synt/art, w>200g/m2','ots.tejidos algodón<85%, blanq/fibra sint/art, p>200g/m2',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521131,'Tecido de algodão tinto, em ponto de tafetá, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso > 200 g/m2','Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing > 200 g/m², dyed','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso > 200 g/m², de ligamento tafetán, teñidos',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521132,'Tecido de algodão tinto, em ponto sarjado, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing > 200 g/m², in three-thread or four-thread twill, incl. cross twill, dyed','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso > 200 g/m², de ligamento sarga o cruzado de curso <= 4, teñidos',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521139,'Outros tecidos de algodão tinto, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing > 200 g/m², dyed (excl. those in three-thread or four-thread twill, incl. cross twill, and plain woven fabrics)','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso > 200 g/m², teñidos (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521141,'Tecido de algodão, de fios de diversas cores, em ponto de tafetá, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso > 200 g/m2','Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing > 200 g/m², made of yarn of different colours','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso > 200 g/m², de ligamento tafetán, fabricados con hilos de distintos colores',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521142,'Tecidos de algodão, de fios de diversas cores, denim, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso > 200 g/m2','Denim, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing > 200 g/m², made of yarn of different colours','Tejidos de mezclilla "denim", con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso > 200 g/m², fabricados con hilos de distintos colores',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521143,'Tecido de algodão, de fios de diversas cores, em ponto sarjado, contendo < 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing > 200 g/m², in three-thread or four-thread twill, incl. cross twill, made of yarn of different colours','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso > 200 g/m², de ligamento sarga o cruzado de curso <= 4, fabricados con hilos de distintos colores',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521149,'Outros tecidos de algodão, de fios de diversas cores, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing > 200 g/m², made of yarn of different colours (excl. those in three-thread or four-thread twill, incl. cross twill','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso > 200 g/m², fabricados con hilos de distintos colores (exc. de ligamento sarga o cruzado de curso ',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521151,'Tecido de algodão estampado, em ponto de tafetá, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso > 200 g/m2','Plain woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing > 200 g/m², printed','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso > 200 g/m², de ligamento tafetán, estampados',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521152,'Tecido de algodão estampado, em ponto sarjado, com fibras sintéticas ou artificiais, contendo < 85%em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing > 200 g/m², in three-thread or four-thread twill, incl. cross twill, printed','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso > 200 g/m², de ligamento sarga o cruzado de curso <= 4, estampados',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521159,'Outros tecidos de algodão estampados, com fibras sintéticas ou artificiais, contendo < 85% em peso de algodão, com peso > 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, mixed principally or solely with man-made fibres and weighing > 200 g/m², printed (excl. those in three-thread or four-thread twill, incl. cross twill, and plain woven fabrics)','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, mezclado exclusiva o principalmente con fibras sintéticas o artificiales y de peso > 200 g/m², estampados (exc. de ligamento sarga o cruzado de curso <= 4 y de ligamento tafetán)',52,5211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521211,'Outros tecidos de algodão crus, com peso <= 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, other than those mixed principally or solely with man-made fibres, weighing <= 200 g/m², unbleached','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, distintos de aquéllos en que el algodón esté mezclado exclusiva o principalmente con fibras sintéticas o artificiales, de peso <= 200 g/m², crudos',52,5212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521212,'Outros tecidos de algodão branqueados, com peso <= 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, other than those mixed principally or solely with man-made fibres, weighing <= 200 g/m², bleached','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, distintos de aquéllos en que el algodón esté mezclado exclusiva o principalmente con fibras sintéticas o artificiales, de peso <= 200 g/m², blanqueados',52,5212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521213,'Outros tecidos de algodão tintos, com peso <= 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, other than those mixed principally or solely with man-made fibres, weighing <= 200 g/m², dyed','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, distintos de aquéllos en que el algodón esté mezclado exclusiva o principalmente con fibras sintéticas o artificiales, de peso <= 200 g/m², teñidos',52,5212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521214,'Outros tecidos de algodão, de fios de diversas cores, com peso <= 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, other than those mixed principally or solely with man-made fibres, weighing <= 200 g/m², made of yarn of different colours','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, distintos de aquéllos en que el algodón esté mezclado exclusiva o principalmente con fibras sintéticas o artificiales, de peso <= 200 g/m², fabricados con hilos de distintos colores',52,5212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521215,'Outros tecidos de algodão estampados, com peso <= 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, other than those mixed principally or solely with man-made fibres, weighing <= 200 g/m², printed','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, distintos de aquéllos en que el algodón esté mezclado exclusiva o principalmente con fibras sintéticas o artificiales, de peso <= 200 g/m², estampados',52,5212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521221,'Outros tecidos de algodão crus, com peso > 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, other than those mixed principally or solely with man-made fibres, weighing > 200 g/m², unbleached','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, distintos de aquéllos en que el algodón esté mezclado exclusiva o principalmente con fibras sintéticas o artificiales, de peso > 200 g/m², crudos',52,5212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521222,'Outros tecidos de algodão branqueados, com peso > 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, other than those mixed principally or solely with man-made fibres, weighing > 200 g/m², bleached','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, distintos de aquéllos en que el algodón esté mezclado exclusiva o principalmente con fibras sintéticas o artificiales, de peso > 200 g/m², blanqueados',52,5212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521223,'Outros tecidos de algodão tintos, com peso > 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, other than those mixed principally or solely with man-made fibres, weighing > 200 g/m², dyed','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, distintos de aquéllos en que el algodón esté mezclado exclusiva o principalmente con fibras sintéticas o artificiales, de peso > 200 g/m², teñidos',52,5212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521224,'Outros tecidos de algodão, de fios de diversas cores, com peso > 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, other than those mixed principally or solely with man-made fibres, weighing > 200 g/m², made of yarn of different colours','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, distintos de aquéllos en que el algodón esté mezclado exclusiva o principalmente con fibras sintéticas o artificiales, de peso > 200 g/m², fabricados con hilos de distintos colores',52,5212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (521225,'Outros tecidos de algodão estampados, com peso > 200 g/m2','Woven fabrics of cotton, containing predominantly, but < 85% cotton by weight, other than those mixed principally or solely with man-made fibres, weighing > 200 g/m², printed','Tejidos de algodón, con un alto contenido de algodón, pero < 85% en peso, distintos de aquéllos en que el algodón esté mezclado exclusiva o principalmente con fibras sintéticas o artificiales, de peso > 200 g/m², estampados',52,5212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530110,'Linho em bruto ou macerado','Flax, raw or retted','Lino en bruto o enriado',53,5301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530121,'Linho quebrado ou espadelado, mas não fiado','Flax, broken or scutched','Lino agramado o espadado',53,5301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530129,'Linho penteado ou trabalhado de outra forma, mas não fiado','Flax, hackled or otherwise processed, but not spun (excl. broken, scutched and retted flax)','Lino peinado o trabajado de otro modo, pero sin hilar (exc. lino agramado, espadado o enriado)',53,5301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530130,'Estopas e desperdícios de linho','Flax tow and waste, incl. yarn waste and garnetted stock','Estopas y desperdicios de lino, incl. los desperdicios de hilados y las hilachas',53,5301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530210,'Cânhamo em bruto ou macerado','True hemp Cannabis sativa L., raw or retted','Cáñamo "Cannabis sativa L.", en bruto o enriado',53,5302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530290,'Cânhamo trabalhado, mas não fiado; estopas e desperdícios','True hemp Cannabis sativa L., processed but not spun;  tow and waste of hemp, incl. yarn waste and garnetted stock (excl. retted hemp)','Cáñamo "Cannabis Sativa L.", trabajado, pero sin hilar; estopas y desperdicios de cáñamo, incl. los desperdicios de hilados y las hilachas (exc. cáñamo enriado)',53,5302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530310,'Juta e outras fibras têxteis liberianas, em bruto ou maceradas','Jute and other textile bast fibres, raw or retted (excl. flax, true hemp and ramie)','Yute y demás fibras textiles del líber, en bruto o enriadas (exc. lino, cáñamo y ramio)',53,5303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530390,'Juta e outras fibras têxteis liberianas trabalhadas, mas não fiadas; estopas e desperdícios','Jute and other textile bast fibres, processed but not spun; tow and waste of such fibres, incl. yarn waste and garnetted stock (excl. retted fibres of this kind, flax, true hemp and ramie)','Yute y demás fibras textiles del líber, trabajadas, pero sin hilar; estopas y desperdicios de estas fibras, incl. los desperdicios de hilados y las hilachas (exc. yute y demás fibras textiles del líber enriadas, así como lino, cáñamo y ramio)',53,5303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530410,'Sisal/outras fibras têxteis "agave",  em bruto','Sisal and other textile fibres of the genus agave, raw','Sisal/demás fibras textiles del género agave, en bruto',53,5304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530490,'Sisal/outs.fibras têxteis "agave",  trabalh.n/fiados,  etc.','Other sisal and other textile fibres of the genus agave, tow, waste thereof','sisal/demás fibras textiles agave, trabaj.s/hilar, etc',53,5304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530500,'Cairo (fibras de coco), abacá (cânhamo-de-manilha ou Musa textilis Nee), rami e outras fibras têxteis vegetais não especificadas nem compreendidas noutras posições, em bruto ou trabalhados, mas não fiados; estopas e desperdícios destas fibras (incluídos o','Coconut, abaca Manila hemp or Musa textilis Nee, ramie, agave and other vegetable textile fibres, n.e.s., raw or processed, but not spun;  tow, noils and waste of such fibres, incl. yarn waste and garnetted stock','Fibras de coco, abacá [cáñamo de manila (Musa textilis Nee)], ramio y demás fibras textiles vegetales no expresadas ni comprendidas en otra parte, en bruto o trabajadas, pero sin hilar; estopas y desperdicios de estas fibras, (incluidos los desperdicios d',53,5305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530511,'Cairo (fibras de coco) em bruto','Coir (fibres of coconut) raw','Fibras de coco en bruto',53,5305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530519,'Cairo (fibras de coco) trabalh.n/fiado, estopas, desperds','Other textile fibres of coconut, tow, noils, waste of these fibres','Fibras de coco trabaj.s/hilar, estopas, desperds',53,5305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530521,'Abaca em bruto','Raw abaca','Abacá en bruto',53,5305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530529,'Abaca trabalhado, não fiado, estopas e desperdícios','Other textile fibres of abaca, tow, noils, waste of these fibres','Abacá trabajado, sin hilar, estopas y desperdicios',53,5305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530590,'Rami','Ramie','Ramio',53,5305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530591,'Fibras vegetais','Vegetable fibers','Fibras vegetales',53,5305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530599,'Rami penteado ou trabalhado de outra forma','Rami hackled or otherwise','Ramio peinado o de lo contrario',53,5305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530610,'Fios de linho, simples','Single flax yarn','Hilados de lino, sencillos',53,5306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530620,'Fios de linho, retorcidos ou retorcidos múltiplos','Multiple folded or cabled flax yarn','Hilados de lino, retorcidos o cableados',53,5306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530710,'Fios simples de juta ou de outras fibras liberianas da posição 5303','Single yarn of jute or of other textile bast fibres of heading 5303','Hilados de yute o demás fibras textiles del líber de la partida 5303, sencillos',53,5307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530720,'Fios múltiplos de juta ou de outras fibras liberianas da posição 5303, retorcidos ou retorcidos','Multiple folded or cabled yarn of jute or of other textile bast fibres of heading 5303','Hilados de yute o demás fibras textiles del líber de la partida 5303, retorcidos o cableados',53,5307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530810,'Fios de cairo (fios de fibras de coco)','Coconut coir yarn','Hilados de coco',53,5308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530820,'Fios de cânhamo','Hemp yarn','Hilados de cáñamo',53,5308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530830,'fios de papel','paper yarn','hilados de papel',53,5308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530890,'Fios de outras fibras têxteis vegetais','Yarn of vegetable textile fibres (excl. flax yarn, yarn of jute or of other textile bast fibres of heading 5303, coconut coir yarn, hemp yarn and cotton yarn)','Hilados de fibras textiles vegetales (exc. hilados de lino, hilados de yute o demás fibras textiles del líber de la partida 5303, hilados de coco, hilados de cáñamo e hilados de algodón)',53,5308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530911,'Tecidos de linho crus ou branqueados, contendo => 85% em peso de linho','Woven fabrics of flax, containing >= 85% flax by weight, unbleached or bleached','Tejidos de lino, con un contenido de lino >= 85% en peso, crudos o blanqueados',53,5309);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530919,'Outros tecidos de linho, contendo => 85% em peso de linho','Woven fabrics of flax, containing >= 85% flax by weight, dyed, made of yarn of different colours, or printed','Tejidos de lino, con un contenido de lino >= 85% en peso, teñidos, fabricados con hilos de distintos colores o estampados',53,5309);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530921,'Tecidos de linho crus ou branqueados, contendo < 85% em peso de linho','Woven fabrics of flax, containing predominantly, but < 85% flax by weight, unbleached or bleached','Tejidos de lino, con un alto contenido de lino, pero < 85% en peso, crudos o blanqueados',53,5309);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (530929,'Outros tecidos de linho, contendo < 85% em peso de linho','Woven fabrics of flax, containing predominantly, but < 85% flax by weight, dyed, made of yarn of different colours, or printed','Tejidos de lino, con un alto contenido de lino, pero < 85% en peso, teñidos, fabricados con hilos de distintos colores o estampados',53,5309);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (531010,'Tecidos de juta crus ou de outras fibras têxteis liberianas da posição 5303','Woven fabrics of jute or of other textile bast fibres of heading 5303, unbleached','Tejidos de yute o demás fibras textiles del líber de la partida 5303, crudos',53,5310);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (531090,'Outros tecidos de juta ou outras fibras têxteis liberianas da posição 5303','Woven fabrics of jute or of other textile bast fibres of heading 5303, bleached, dyed, made of yarn of different colours, or printed','Tejidos de yute o demás fibras textiles del líber de la partida 5303, blanqueados, teñidos, fabricados con hilos de distintos colores o estampados',53,5310);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (531100,'Tecidos de outras fibras têxteis vegetais ou de fios de papel','Woven fabrics of other vegetable textile fibres; woven fabrics of paper yarn (excl. those of flax, jute, other textile bast fibres of heading 5303 and cotton yarn)','Tejidos de fibras textiles vegetales y tejidos de hilados de papel (exc. tejidos de lino, tejidos de yute o demás fibras textiles del líber de la partida 5303 y tejidos de algodón)',53,5311);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540110,'Linhas para costurar, de filamentos sintéticos, mesmo acondicionados para venda a retalho','Sewing thread of synthetic filaments, whether or not put up for retail sale','Hilos de coser de filamentos sintéticos, incl. acondicionados para la venta al por menor',54,5401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540120,'Linhas para costurar, de filamentos artificiais, mesmo acondicionados para venda a retalho','Sewing thread of artificial filaments, whether or not put up for retail sale','Hilos de coser de filamentos artificiales, incl. acondicionados para la venta al por menor',54,5401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540210,'Fios de alta tenacidade','High tenacity yarn','Hilados de alta tenacidad',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540211,'Fios de alta tenacidade de aramidas','High-tenacity filament yarn of aramids (excl. sewing thread and yarn put up for retail sale)','Hilados de alta tenacidad de aramidas',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540219,'Outros fios de alta tenacidade, de náilon ou de outras poliamidas','High-tenacity filament yarn of nylon or other polyamides (excl. sewing thread, yarn put up for retail sale and high-tenacity filament yarn of aramids)','Hilados de alta tenacidad, de filamentos de nailon o demás poliamidas (exc. hilos de coser e hilados acondicionados para la venta al por menor)',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540220,'Fios de alta tenacidade, de poliésteres','High-tenacity filament yarn of polyesters (excl. that put up for retail sale)','Hilados de alta tenacidad, de filamentos de poliésteres (exc. hilos de coser e hilados acondicionados para la venta al por menor)',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540231,'Fios texturizados, de náilon ou de outras poliamidas, título <= 50 tex por fio simples','Textured filament yarn of nylon or other polyamides, with a linear density of <= 50 tex per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados texturados, de filamentos de nailon o demás poliamidas, de título <= 50 tex por hilo sencillo (exc. hilos de coser e hilados acondicionados para la venta al por menor)',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540232,'Fios texturizados, de náilon de outras poliamidas, título > 50 tex por fio simples','Textured filament yarn of nylon or other polyamides, with a linear density of > 50 tex per single yarn (excl. sewing thread and yarn put up for retail sale)','Hilados texturados, de filamentos de nailon o demás poliamidas, de título > 50 tex por hilo sencillo (exc. hilos de coser e hilados acondicionados para la venta al por menor)',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540233,'Fios texturizados de poliésteres','Textured filament yarn of polyester (excl. that put up for retail sale)','Hilados texturados, de filamentos de poliésteres (exc. hilos de coser e hilados acondicionados para la venta al por menor)',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540234,'Fios texturizados de polipropileno','Textured synthetic filament yarn of polypropylene (excl. sewing thread and yarn put up for retail sale)','Hilados texturados, de filamentos de polipropileno (exc. hilos de coser e hilados acondicionados para la venta al por menor)',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540239,'Outros fios texturizados de filamentos sintéticos','Textured synthetic filament yarn (excl. sewing thread, yarn put up for retail sale and textured filament yarn of polypropylene, polyester, nylon or other polyamides)','Hilados texturados, de filamentos sintéticos (exc. hilos de coser, hilados acondicionados para la venta al por menor e hilados texturados de filamentos de poliésteres, de nailon o demás poliamidas)',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540241,'Fios de poliamidas','Yarn of polyamides','Hilos de poliamidas',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540242,'Fio de poliésteres,  simples,  parcialm.orient.torc<=50v/m','Yarn of polyesters, single, partial.orient.sprain<=50 t/m','Hilado de poliésteres, senc., parcialm.orient.tor.<=50v/m',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540243,'Fio de outs.poliésteres, simples, torção<=50voltas/metro','Yarn of polyesters, single, sprain<=50 turn/meter','Hilado de ots.poliésteres, sencillo, torsión<=50vueltas/m',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540244,'Outros fios simples de elastômeros, sem torçao ou  com torção <= 50 voltas por metro','Synthetic filament elastomeric yarn, single, untwisted or with a twist of <= 50 turns per metre (excl. sewing thread, yarn put up for retail sale, textured yarn and filament yarn of polyester, nylon or other polyamides)','Hilos simples, de elastómeros de filamentos sintéticos, sin torsión o con una torsión <= 50 vueltas/m, no condicionados para la venta al por menor (exc. hilos de coser, hilos texturados así como hilos de poliésteres, nilón u otras poliamidas)',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540245,'Outros fios simples de náilon ou de outras poliamidas, sem torção ou com torção <= 50 voltas por metro','Filament yarn of nylon or other polyamides, incl. monofilament of < 67 decitex, single, untwisted or with a twist of <= 50 turns per metre (excl. sewing thread, yarn put up for retail sale, elastomeric yarn, high-tenacity yarn and textured yarn)','Hilos simples, de filamentos de nilón u otros poliamidas, sin torsión o de una torsión <= 50 vueltas/m, no condicionados para la venta al por menor, incl. los monofilamentos de menos de 67 decitex (exc. hilos de coser, hilos de elastómeros, hilos de alta ',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540246,'Outros fios simples de poliésteres parcialmente orientados, sem torção ou com torção <= 50 voltas por metro','Filament yarn of polyester, incl. monofilament of < 67 decitex, single, untwisted or with a twist of <= 50 turns per metre, partially oriented (excl. elastomeric yarn, sewing thread, yarn put up for retail sale and textured yarn)','Hilos simples, de filamentos de poliésteres, parcialmente orientados, sin torsión o de una torsión <= 50 vueltas/m, no condicionados para la venta al por menor, incl. los monofilamentos de menos de 67 decitex (exc. hilos de elastómeros, hilos que deben co',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540247,'Outros fios simples de poliésteres, sem torção ou com torção <= 50 voltas por metro','Filament yarn of polyester, incl. monofilament of < 67 decitex, single, untwisted or with a twist of <= 50 turns per metre (excl. elastomeric yarn, sewing thread, yarn put up for retail sale, textured yarn and yarn of partially oriented polyester filament','Hilos simples, de filamentos de poliésteres, sin torsión o de una torsión 50 vultas/m, no condicionados para la venta al por menor, incl. los monofilamentos de menos de 67 decitex (exc. hilos de elastómeros, hilos de coser, hilos texturados e hilos de pol',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540248,'Outros fios simples de polipropileno, sem torção ou com torção <= 50 voltas por metro','Filament yarn of polypropylene, incl. monofilament of < 67 decitex, single, untwisted or with a twist of <= 50 turns per metre (excl. elastomeric yarn, sewing thread, yarn put up for retail sale and textured yarn)','Hilos simples, de filamentos de polipropileno, sin torsión o de una torsión 50 vueltas/m, no condicionados para la venta al por menor, incl. los monofilamentos de menos de 67 decitex (exc. hilos de elastómeros, hilos de coser y hilos texturados)',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540249,'Outros fios simples de filamentos sintéticos, sem torção ou com torção <= 50 voltas por metro','Synthetic filament yarn, incl. synthetic monofilament of < 67 decitex, single, untwisted or with a twist of <= 50 turns per metre (excl. sewing thread, yarn put up for retail sale, textured yarn, elastomeric yarn and filament yarn of polyester, nylon or o','Hilados de filamentos sintéticos, incl. los monofilamentos sintéticos de título < 67 decitex, sencillos, sin torsión o con una torsión <= 50 vueltas por metro (exc. hilos de coser, hilados acondicionados para la venta al por menor, hilados texturados e hi',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540251,'Fios simples, de náilon ou de outras poliamidas, com torção > 50 voltas por metro','Filament yarn of nylon or other polyamides, incl. monofilament of < 67 decitex, single, with a twist of > 50 turns per metre (excl. sewing thread, yarn put up for retail sale, high-tenacity yarn or textured yarn)','Hilados de filamentos de nailon o demás poliamidas, incl. los monofilamentos de título < 67 decitex, sencillos, con una torsión > 50 vueltas por metro (exc. hilos de coser, hilados acondicionados para la venta al por menor, hilados de alta tenacidad e hil',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540252,'Fios simples, de poliésteres, com torção > 50 voltas por metro','Filament yarn of polyester, incl. monofilament of < 67 decitex, single, with a twist of > 50 turns per metre (excl. sewing thread, yarn put up for retail sale and textured yarn)','Hilados de filamentos de poliésteres, incl. los monofilamentos de título < 67 decitex, sencillos, con una torsión > 50 vueltas por metro (exc. hilos de coser, hilados acondicionados para la venta al por menor e hilados texturados)',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540259,'Outros fios simples, de filamentos sintéticos, com torção > 50 voltas por metro','Synthetic filament yarn, incl. synthetic monofilament of < 67 decitex, single, with a twist of > 50 turns per metre (excl. sewing thread, yarn put up for retail sale, textured yarn and filament yarn of polyester, nylon or other polyamides)','Hilados de filamentos sintéticos, incl. los monofilamentos sintéticos de título < 67 decitex, sencillos, con una torsión > 50 vueltas por metro (exc. hilos de coser, hilados acondicionados para la venta al por menor, hilados texturados e hilados de filame',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540261,'Fios de náilon ou de outras poliamidas, retorcidos ou retorcidos múltiplos','Multiple folded or cabled filament yarn of nylon or other polyamides, incl. monofilament of < 67 decitex (excl. sewing thread, yarn put up for retail sale and high-tenacity yarn or textured yarn)','Hilados de filamentos de nailon o demás poliamidas, incl. los monofilamentos de título < 67 decitex, retorcidos o cableados (exc. hilos de coser, hilados acondicionados para la venta al por menor, hilados de alta tenacidad e hilados texturados)',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540262,'Fios de poliésteres, retorcidos ou retorcidos múltiplos','Multiple folded or cabled filament yarn of polyester, incl. monofilament of < 67 decitex (excl. sewing thread, yarn put up for retail sale and textured yarn)','Hilados de filamentos de poliésteres, incl. los monofilamentos de título < 67 decitex, retorcidos o cableados (exc. hilos de coser, hilados acondicionados para la venta al por menor y los texturados)',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540269,'Outros fios de filamentos sintéticos, retorcidos ou retorcidos múltiplos','Multiple folded or cabled synthetic filament yarn, incl. synthetic monofilament of < 67 decitex (excl. sewing thread, yarn put up for retail sale, textured yarn and filament yarn of polyester, nylon or other polyamides)','Hilados de filamentos sintéticos, incl. los monofilamentos sintéticos de título < 67 decitex, retorcidos o cableados (exc. hilos de coser, hilados acondicionados para la venta al por menor, hilados texturados e hilados de filamentos de poliésteres, de nai',54,5402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540310,'Fios de alta tenacidade, de raiom viscose','High-tenacity yarn of viscose rayon filament (excl. sewing thread and yarn put up for retail sale)','Hilados de alta tenacidad, de filamentos de rayón viscosa (exc. hilos de coser e hilados acondicionados para la venta al por menor)',54,5403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540320,'Fio texturizado de acetato de celulose ou de outros filamentos artificiais','Textured yarn of cellulose acetate  or other artificial filaments','Hilados texturados de acetato de celulosa o otros filamentos artificiales',54,5403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540331,'Fios simples, de raiom viscose, sem torção ou com torção <= 120 voltas por metro','Yarn of viscose rayon filament, incl. monofilament of < 67 decitex, single, untwisted or with a twist of <= 120 turns per metre (excl. sewing thread, high-tenacity yarn and yarn put up for retail sale)','Hilados de filamentos de rayón viscosa, incl. los monofilamentos de título < 67 decitex, sencillos, sin torsión o con una torsión <= 120 vueltas por metro (exc. hilos de coser, hilados acondicionados para la venta al por menor e hilados de alta tenacidad ',54,5403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540332,'Fios simples, de raiom viscose, com torção > 120 voltas por metro','Yarn of viscose rayon filament, incl. monofilament of < 67 decitex, single, with a twist of > 120 turns per metre (excl. sewing thread, high-tenacity yarn and yarn put up for retail sale)','Hilados de filamentos de rayón viscosa, incl. los monofilamentos de título < 67 decitex, sencillos, con una torsión > 120 vueltas por metro (exc. hilos de coser, hilados acondicionados para la venta al por menor e hilados de alta tenacidad o texturados)',54,5403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540333,'Fios simples, de filamentos de acetato de celulose','Filament yarn of cellulose acetate, incl. monofilament of < 67 decitex, single (excl. sewing thread, high-tenacity yarn and yarn put up for retail sale)','Hilados de filamentos de acetato de celulosa, incl. los monofilamentos de título < 67 decitex, sencillos (exc. hilos de coser, hilados acondicionados para la venta al por menor e hilados texturados)',54,5403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540339,'Fios simples, de outros filamentos artificiais','Artificial filament yarn, incl. artificial monofilament of < 67 decitex, single (excl. sewing thread, filament yarn of viscose or cellulose acetate and yarn put up for retail sale)','Hilados de filamentos artificiales, incl. los monofilamentos artificiales de título < 67 decitex, sencillos (exc. hilos de coser, hilados acondicionados para la venta al por menor, hilados texturados e hilados de filamentos de rayón viscosa o de acetato d',54,5403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540341,'Fios de raiom de viscose, retorcidos ou retorcidos múltiplos','Multiple folded or cabled filament rayon yarn of viscose, incl. monofilament of < 67 decitex (excl. sewing thread, high-tenacity yarn and yarn put up for retail sale)','Hilados de filamentos de rayón viscosa, incl. los monofilamentos de título < 67 decitex, retorcidos o cableados (exc. hilos de coser, hilados acondicionados para la venta al por menor e hilados de alta tenacidad o texturados)',54,5403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540342,'Fios de filamentos de acetato de celulose, retorcidos ou retorcidos múltiplos','Multiple folded or cabled filament yarn of cellulose acetate, incl. monofilament of < 67 decitex (excl. sewing thread, high-tenacity yarn and yarn put up for retail sale)','Hilados de filamentos de acetato de celulosa, incl. los monofilamentos de título < 67 decitex, retorcidos o cableados (exc. hilos de coser, hilados acondicionados para la venta al por menor e hilados texturados)',54,5403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540349,'Outros fios de filamentos artificiais, retorcidos ou retorcidos múltiplos','Multiple folded or cabled artificial filament yarn, incl. artificial monofilament of < 67 decitex (excl. sewing thread, filament yarn of viscose or cellulose acetate and yarn put up for retail sale)','Hilados de filamentos artificiales, incl. los monofilamentos artificiales de título < 67 decitex, retorcidos o cableados (exc. hilos de coser, hilados acondicionados para la venta al por menor, hilados texturados e hilados de filamentos de rayón viscosa o',54,5403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540410,'Monofilamentos','Monofilament','Monofilamentos',54,5404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540411,'Monofilamentos de elastômeros, título => 67 decitex e seção transversal <= 1 mm, com largura <= 5mm','Elastomeric monofilament of >= 67 decitex and with a cross sectional dimension of <= 1 mm','Monofilamentos de elastómeros de >= 67 decitex y  mayor dimensión del corte transversal <= 1 mm.',54,5404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540412,'Outros monofilamentos de polipropileno, título => 67 decitex e seção transversal <= 1 mm, com largura <= 5mm','Polypropylene monofilament of >= 67 decitex and with a cross sectional dimension of <= 1 mm (excl. elastomers)','Monofilamentos de polipropileno de 67 décitex y mayor dimensión del corte transversal <= 1 mm. (exc. monofilamentos de elastómeros) otros, de polipropileno',54,5404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540419,'Outros monofilamentos sintéticos, título => 67 decitex e seção transversal <= 1 mm, com largura <= 5mm','Synthetic monofilament of >= 67 decitex and with a cross sectional dimension of <= 1 mm (excl. of elastomers and polypropylene)','Monofilamentos sintéticos de >= 67 décitex y la que mayor dimensión del corte transversal <= 1 mm. (exc. monofilamentos de elastómeros e de polipropileno)',54,5404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540490,'Outras lâminas e formas semelhantes, de matérias têxteis sintéticas, largura <= 5 mm','Strip and the like, e.g. artificial straw, of synthetic textile material, with an apparent width of <= 5 mm','Paja artificial, tiras y formas simil., de materia textil sintética, de anchura aparente <= 5 mm',54,5404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540500,'Monofilamentos artificiais, título => 67 decitex e seção transversal <= 1 mm; lâminas e formas semelhantes de matérias têxteis artificiais, com largura < = 5mm','Artificial monofilament of >= 67 decitex and with a cross sectional dimension of <= 1 mm; strip and the like, e.g. artificial straw, of synthetic textile material, with an apparent width of <= 5 mm','Monofilamentos artificiales de título >= 67 decitex y cuya mayor dimensión de la sección transversal sea <= 1 mm; paja artificial, tiras y formas simil. de materia textil artificial, de anchura aparente <= 5 mm',54,5405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540600,'Fios de filamentos sintéticos ou artificiais (exceto linhas para costurar), acondicionados para venda a retalho.','Man-made filament yarn, put up for retail sale (excl. sewing thread)','Hilados de filamentos sintéticos o artificiales (excepto el hilo de coser), acondicionados para la venta al por menor',54,5406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540610,'fios de filamentos sintéticos,  para venda a retalho','synthetic filament yarn, for retail sale','hilados filamentos sintéticos, p/la venta al por menor',54,5406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540620,'fios de filamentos artificiais,  para venda a retalho','artificial filament yarn, for retail sale','hilados filamentos artificiales, p/la venta al por menor',54,5406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540710,'Tecidos obtidos a partir de fios de alta tenacidade, de náilon ou de outras poliamidas ou de poliésteres','Woven fabrics of high-tenacity yarn, nylon, other polyamides or polyesters, incl. monofilament of >= 67 decitex and with a cross sectional dimension of <= 1 mm','Tejidos de hilados de alta tenacidad, de nailon o demás poliamidas o de poliésteres, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540720,'Tecidos de filamentos sintéticos obtidos a partir de lâminas ou de formas semelhantes','Woven fabrics of strip or the like, of synthetic filament, incl. monofilament of >= 67 decitex and with a cross sectional dimension of <= 1 mm','Tejidos de tiras o formas simil. de filamentos sintéticos, incl. los monofilamentos de título >= 67 decitex y cuya mayor dimensión de la sección transversal sea <= 1 mm',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540730,'Tecidos (mantas) de fios de filamento sintético','Woven fabrics of synthetic filament yarn, incl. monofilament of >= 67 decitex and with a cross sectional dimension of <= 1 mm, consisting of layers of parallel textile yarns superimposed on each other at acute or right angles, the layers being bonded at t','Tejidos de hilados de filamentos sintéticos, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, constituidos por napas de hilados textiles paralelizados que se superponen en ángulo recto o agudo',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540741,'Outros tecidos, crus ou branqueados, contendo => 85%, em peso, de filamentos de náilon ou de outras poliamidas','Woven fabrics of yarn containing >= 85% by weight of filaments of nylon or other polyamides, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, unbleached or bleached','Tejidos de hilados con un contenido de filamentos de nailon o demás poliamidas >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, crudos o blanqueados',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540742,'Outros tecidos tintos, contendo => 85%, em peso, de filamentos de náilon ou de outras poliamidas','Woven fabrics of filament yarn containing >= 85% nylon or other polyamides by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, dyed','Tejidos de hilados con un contenido de filamentos de nailon o demás poliamidas >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, teñidos',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540743,'Outros tecidos, de fios de diversas cores, contendo => 85% em peso de filamentos de náilon ou de outras poliamidas','Woven fabrics of yarn containing >= 85% by weight of filaments of nylon or other polyamides by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, made of yarn of different colours','Tejidos de hilados con un contenido de filamentos de nailon o demás poliamidas >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, fabricados con hilos de distintos colores',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540744,'Outros tecidos estampados, contendo => 85% em peso de filamentos de náilon ou de outras poliamidas','Woven fabrics of yarn containing >= 85% by weight of filaments of nylon or other polyamides by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, printed','Tejidos de hilados con un contenido de filamentos de nailon o demás poliamidas >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, estampados',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540751,'Outros tecidos crus ou branqueados, contendo => 85% em peso de filamentos de poliéster texturizados','Woven fabrics of yarn containing >= 85% by weight of textured polyester filaments, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, unbleached or bleached','Tejidos de hilados con un contenido de filamentos de poliésteres texturado >= 85% en peso, incl. los monofilamentos de título >= 67 decitex y cuya mayor dimensión de la sección transversal sea <= 1 mm, crudos o blanqueados',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540752,'Outros tecidos tintos, contendo => 85% em peso de filamentos de poliéster texturizados','Woven fabrics of yarn containing >= 85% by weight of textured polyester filaments, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, dyed','Tejidos de hilados con un contenido de filamentos de poliésteres texturados >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, teñidos',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540753,'Outros tecidos, de fios de diversas cores, contendo => 85% em peso de filamentos de poliéster texturizados','Woven fabrics of yarn containing >= 85% by weight of textured polyester filaments, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, made of yarn of different colours','Tejidos de hilados con un contenido de filamentos de poliésteres texturado >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, fabricados con hilos de distintos colores',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540754,'Outros tecidos estampados, contendo => 85%, de filamentos de poliéster texturizados','Woven fabrics of yarn containing >= 85% by weight of textured polyester filaments, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, printed','Tejidos de hilados con un contenido de filamentos de poliésteres texturados >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, estampados',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540761,'Outros tecidos, contendo => 85% em peso, de filamentos de poliéster não texturizados','Woven fabrics of yarn containing >= 85% by weight of non-textured polyester filaments, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm','Tejidos de hilados con un contenido de filamentos de poliésteres sin texturar >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540769,'Outros tecidos, contendo => 85% em peso de outros filamentos de poliéster','Woven fabrics of yarn containing >= 85% by weight of mixtures of textured and non-textured polyester filaments, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm','Tejidos de hilados con un contenido >= 85% en peso de filamentos de poliésteres sin texturar mezclados con filamentos de poliésteres texturados, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540771,'Outros tecidos crus ou branqueados, contendo => 85% em peso de filamentos sintéticos','Woven fabrics of yarn containing >= 85% synthetic filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, untreated or not further treated than bleached (excl. those of polyester, nylon or other polyamide filaments or mo','Tejidos de hilados con un contenido de filamentos sintéticos >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, crudos o blanqueados (exc. de filamentos o de monofilamentos de po',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540772,'Outros tecidos tintos, contendo => 85% em peso de filamentos sintéticos','Woven fabrics of yarn containing >= 85% synthetic filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, dyed (excl. those of polyester, nylon or other polyamide filaments or monofilaments, and of mixtures of textured a','Tejidos de hilados con un contenido de filamentos sintéticos >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, teñidos (exc. de filamentos o de monofilamentos de poliésteres, de',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540773,'Outros tecidos, de fios de diversas cores, contendo => 85% em peso de filamentos sintéticos','Woven fabrics of yarn containing >= 85% synthetic filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, made of yarn of different colours (excl. those of polyester, nylon or other polyamide filaments or monofilaments, ','Tejidos de hilados con un contenido de filamentos sintéticos >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, fabricados con hilos de distintos colores (exc. de filamentos o de',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540774,'Outros tecidos estampados, contendo => 85% em peso de filamentos sintéticos','Woven fabrics of yarn containing >= 85% synthetic filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, printed (excl. those of polyester, nylon or other polyamide filaments or monofilaments, and of mixtures of texture','Tejidos de hilados con un contenido de filamentos sintéticos >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, estampados (exc. de filamentos o de monofilamentos de poliésteres,',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540781,'Outros tecidos crus ou branqueados, contendo < 85% em peso de filamentos sintéticos, combinados com algodão','Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, mixed principally or solely with wool, unbleached or bleached','Tejidos de hilados con un alto contenido de filamentos sintéticos, pero < 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, mezclados exclusiva o principalmente con algodón, crudos',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540782,'Outros tecidos tintos, contendo < 85% em peso de filamentos sintéticos, combinados com algodão','Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, mixed principally or solely with wool, dyed','Tejidos de hilados con un alto contenido de filamentos sintéticos, pero < 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, mezclados exclusiva o principalmente con algodón, teñido',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540783,'Outros tecidos, de fios de diversas cores, contendo < 85% em peso de filamentos sintéticos, combinados com algodão','Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, mixed principally or solely with wool, made of yarn of different colours','Tejidos de hilados con un alto contenido de filamentos sintéticos, pero < 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, mezclados exclusiva o principalmente con algodón, fabric',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540784,'Outros tecidos estampados, contendo < 85% em peso de filamentos sintéticos, combinados com algodão','Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, mixed principally or solely with wool, printed','Tejidos de hilados con un alto contenido de filamentos sintéticos, pero < 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, mezclados exclusiva o principalmente con algodón, estamp',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540791,'Outros tecidos de filamentos sintéticos, crus ou branqueados','Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, other than those mixed principally or solely with wool, unbleached or bleached','Tejidos de hilados con un alto contenido de filamentos sintéticos, pero < 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, distintos de los mezclados exclusiva o principalmente co',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540792,'Outros tecidos de filamentos sintéticos, tintos','Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, other than those mixed principally or solely with wool, dyed','Tejidos de hilados con un alto contenido de filamentos sintéticos, pero < 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, distintos de los mezclados exclusiva o principalmente co',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540793,'Outros tecidos de filamentos sintéticos, de fios de diversas cores','Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, other than those mixed principally or solely with wool, made of yarn of different colours','Tejidos de hilados con un alto contenido de filamentos sintéticos, pero < 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, distintos de los mezclados exclusiva o principalmente co',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540794,'Outros tecidos estampados, contendo < 85% em peso de filamentos sintéticos','Woven fabrics of yarn containing predominantly, but < 85% synthetic filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, other than those mixed principally or solely with wool, printed','Tejidos de hilados con un alto contenido de filamentos sintéticos, pero < 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, distintos de los mezclados exclusiva o principalmente co',54,5407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540810,'Tecidos de fios de alta tenacidade, de raiom viscose','Woven fabrics of high-tenacity viscose yarn, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm','Tejidos de hilados de alta tenacidad de rayón viscosa, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm',54,5408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540821,'Tecidos crus ou branqueados, contendo => 85% em peso de filamentos artificiais','Woven fabrics of yarn containing >= 85% artificial filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, unbleached or bleached (excl. those of high-tenacity viscose yarn)','Tejidos de hilados con un contenido de filamentos artificiales >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, crudos o blanqueados (exc. de hilados de alta tenacidad de rayón',54,5408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540822,'Tecidos tintos, contendo => 85% em peso de filamentos artificiais','Woven fabrics of yarn containing >= 85% artificial filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, dyed (excl. those of high-tenacity viscose yarn)','Tejidos de hilados con un contenido de filamentos artificiales >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, teñidos (exc. de hilados de alta tenacidad de rayón viscosa)',54,5408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540823,'Tecidos, de fios de diversas cores, contendo => 85% em peso de filamentos artificiais','Woven fabrics of yarn containing >= 85% artificial filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, made of yarn of different colours (excl. those of high-tenacity viscose yarn)','Tejidos de hilados con un contenido de filamentos artificiales >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, fabricados con hilos de distintos colores (exc. de hilados de al',54,5408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540824,'Tecidos estampados, contendo => 85% em peso de filamentos artificiais','Woven fabrics of yarn containing >= 85% artificial filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, printed (excl. those of high-tenacity viscose yarn)','Tejidos de hilados con un contenido de filamentos artificiales >= 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, estampados (exc. de hilados de alta tenacidad de rayón viscosa)',54,5408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540831,'Outros tecidos de filamentos artificiais, crus ou branqueados ','Woven fabrics of yarn containing predominantly, but < 85% artificial filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, unbleached or bleached (excl. those of high-tenacity viscose yarn)','Tejidos de hilados con un alto contenido de filamentos artificiales, pero < 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, crudos o blanqueados (exc. de hilados de alta tenacida',54,5408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540832,'Outros tecidos de filamentos artificiais, tintos','Woven fabrics of yarn containing predominantly, but < 85% artificial filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, dyed (excl. those of high-tenacity viscose yarn)','Tejidos de hilados con un alto contenido de filamentos artificiales, pero < 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, teñidos (exc. de hilados de alta tenacidad de rayón vi',54,5408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540833,'Outros tecidos de filamentos artificiais, de fios de diversas cores','Woven fabrics of yarn containing predominantly, but < 85% artificial filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, made of yarn of different colours (excl. those of high-tenacity viscose yarn)','Tejidos de hilados con un alto contenido de filamentos artificiales, pero < 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, fabricados con hilos de distintos colores (exc. de hil',54,5408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (540834,'Outros tecidos de filamentos artificiais, estampados ','Woven fabrics of yarn containing predominantly, but < 85% artificial filament by weight, incl. monofilament of >= 67 decitex and a maximum diameter of <= 1 mm, printed (excl. those of high-tenacity viscose yarn)','Tejidos de hilados con un alto contenido de filamentos artificiales, pero < 85% en peso, incl. los monofilamentos de título >= 67 decitex, y cuya mayor dimensión de la sección transversal sea <= 1 mm, estampados (exc. de hilados de alta tenacidad de rayón',54,5408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550110,'Cabos de náilon ou de outras poliamidas','Filament tow as specified in Note 1 to chapter 55, of nylon or other polyamides','Cables de filamentos de nailon o demás poliamidas, de conformidad con la nota 1 del capítulo 55',55,5501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550120,'Cabos de poliésteres','Filament tow as specified in Note 1 to chapter 55, of polyesters','Cables de filamentos de poliésteres, de conformidad con la nota 1 del capítulo 55',55,5501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550130,'Cabos acrílicos ou modacrílicos','Filament tow as specified in Note 1 to chapter 55, acrylic or modacrylic','Cables de filamentos acrílicos o modacrílicos, de conformidad con la nota 1 del capítulo 55',55,5501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550140,'Cabos de filamentos sintéticos de polipropileno','Synthetic filament tow as specified in Note 1 to chapter 55, of polypropylene','Cables de filamentos sintéticos de polipropileno',55,5501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550190,'Cabos de outros filamentos sintéticos','Synthetic filament tow as specified in Note 1 to chapter 55 (excl. that of acrylic, modacrylic, polyesters, polypropylene, nylon or other polyamide filament)','Cables de filamentos sintéticos, de conformidad con la nota 1 del capítulo 55 (exc. de filamentos acrílicos, modacrílicos, de poliésteres, de nailon o demás poliamidas)',55,5501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550200,'Cabos de filamentos artificiais','Artificial filament tow as specified in Note 1 to chapter 55','Cables de filamentos artificiales, de conformidad con la nota 1 del capítulo 55',55,5502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550310,'Fibras de náilon e outras poliamidas','Fibers of nylon or other polyamides','Fibras de nailon u otras poliamidas',55,5503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550311,'Fibras de aramida, não cardadas, não penteadas, para fiação','Staple fibres of aramids, not carded, combed or otherwise processed for spinning','Fibras de aramidas, sin cardar, peinar ni transformar de otra forma para la hilatura',55,5503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550319,'Outras fibras de náilon ou de outras poliamidas, não cardadas, não penteadas, para fiação','Staple fibres of nylon or other polyamides, not carded, combed or otherwise processed for spinning (excl. those of aramids)','Las demás fibras de nailon o de poliamidas, sin cardar, peinar ni transformar de outra forma para la hilatura',55,5503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550320,'Fibras descontínuas de poliésteres, não cardadas, não penteadas, para fiação','Staple fibres of polyesters, not carded, combed or otherwise processed for spinning','Fibras discontinuas de poliésteres, sin cardar, peinar ni transformar de otra forma para la hilatura',55,5503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550330,'Fibras descontínuas acrílicas ou modacrílicas, não cardadas, não penteadas, para fiação','Acrylic or modacrylic staple fibres, not carded, combed or otherwise processed for spinning','Fibras discontinuas acrílicas o modacrílicas, sin cardar, peinar ni transformar de otra forma para la hilatura',55,5503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550340,'Fibras descontínuas de polipropileno, não cardadas, não penteadas, para fiação','Staple fibres of polypropylene, not carded, combed or otherwise processed for spinning','Fibras discontinuas de polipropileno, sin cardar, peinar ni transformar de otra forma para la hilatura',55,5503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550390,'Outras fibras sintéticas descontínuas, não cardadas, não penteadas, para fiação','Synthetic staple fibres, not carded, combed or otherwise processed for spinning (excl. those of polypropylene, acrylic, modacrylic, polyesters, nylon or other polyamides)','Fibras sintéticas discontinuas, sin cardar, peinar ni transformar de otra forma para la hilatura (exc. de polipropileno, acrílicas, modacrílicas, de poliésteres, de nailon o demás poliamidas)',55,5503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550410,'Fibras descontínuas de raiom viscose, não cardadas, não penteadas, para fiação','Staple fibres of viscose rayon, not carded, combed or otherwise processed for spinning','Fibras discontinuas de rayón viscosa, sin cardar, peinar ni transformar de otra forma para la hilatura',55,5504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550490,'Outras fibras artificiais descontínuas, não cardadas, não penteadas','Artificial staple fibres, not carded, combed or otherwise processed for spinning (excl. those of viscose rayon)','Fibras artificiales discontinuas, sin cardar, peinar ni transformar de otra forma para la hilatura (exc. de rayón viscosa)',55,5504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550510,'Desperdícios de fibras sintéticas','Waste of synthetic staple fibres, incl. noils, yarn waste and garnetted stock','Desperdicios de fibras sintéticas, incl. las borras, los desperdicios de hilados y las hilachas',55,5505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550520,'Desperdícios de fibras artificiais','Waste of artificial staple fibres, incl. noils, yarn waste and garnetted stock','Desperdicios de fibras artificiales, incl. las borras, los desperdicios de hilados y las hilachas',55,5505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550610,'Fibras de náilon ou de outras poliamidas, cardadas, penteadas, para fiação','Staple fibres of nylon or other polyamides, carded, combed or otherwise processed for spinning','Fibras discontinuas de nailon o demás poliamidas, cardadas, peinadas o transformadas de otro modo para la hilatura',55,5506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550620,'Fibras de poliésteres, cardadas, penteadas, para fiação','Staple fibres of polyesters, carded, combed or otherwise processed for spinning','Fibras discontinuas de poliésteres, cardadas, peinadas o transformadas de otro modo para la hilatura',55,5506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550630,'Fibras acrílicas ou modacrílicas, cardadas, penteadas','Acrylic or modacrylic staple fibres, carded, combed or otherwise processed for spinning','Fibras discontinuas acrílicas o modacrílicas, cardadas, peinadas o transformadas de otro modo para la hilatura',55,5506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550690,'Outras fibras sintéticas descontínuas, cardadas, penteadas','Synthetic staple fibres carded, combed or otherwise processed for spinning (excl. acrylic, modacrylic, polyester, nylon or other polyamides)','Fibras sintéticas discontinuas, cardadas, peinadas o transformadas de otro modo para la hilatura (exc. acrílicas, modacrílicas, de poliésteres, de nailon o demás poliamidas)',55,5506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550700,'Fibras artificiais descontínuas, cardadas, penteadas, para fiação','Artificial staple fibres, carded, combed or otherwise processed for spinning','Fibras artificiales discontinuas, cardadas, peinadas o transformadas de otro modo para la hilatura',55,5507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550810,'Linhas para costurar, de fibras sintéticas descontínuas, mesmo para venda a retalho','Sewing thread of synthetic staple fibres, whether or not put up for retail sale','Hilos de coser de fibras sintéticas discontinuas, incl. acondicionados para la venta al por menor',55,5508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550820,'Linhas para costurar, de fibras artificiais descontínuas, mesmo para venda a retalho','Sewing thread of artificial staple fibres, whether or not put up for retail sale','Hilos de coser de fibras artificiales discontinuas, incl. acondicionados para la venta al por menor',55,5508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550911,'Fios simples de fibras descontínuas de náilon ou de outras poliamidas, contendo => 85% em peso destas fibras, não para venda a retalho','Single yarn containing >= 85% nylon or other polyamide staple fibres by weight (excl. sewing thread and yarn put up for retail sale)','Hilados con un contenido de fibras discontinuas de nailon o demás poliamidas >= 85% en peso, sencillos (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550912,'Fios retorcidos ou retorcidos múltiplos, de fibras descontínuas de náilon ou de outras poliamidas, contendo => 85% em peso destas fibras, não para venda a retalho','Multiple folded or cabled yarn containing >= 85% nylon or other polyamide staple fibres by weight (excl. sewing thread and yarn put up for retail sale)','Hilados con un contenido de fibras discontinuas de nailon o demás poliamidas >= 85% en peso, retorcidos o cableados (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550921,'Fios simples, de fibras descontínuas de poliéster, contendo => 85% em peso destas fibras, não para venda a retalho','Single yarn containing >= 85% polyester staple fibres by weight (excl. sewing thread and yarn put up for retail sale)','Hilados con un contenido de fibras discontinuas de poliéster >= 85% en peso, sencillos (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550922,'Fios retorcidos ou retorcidos múltiplos, de fibras descontínuas de poliéster, contendo => 85% em peso destas fibras, não para venda a retalho','Multiple folded or cabled yarn containing >= 85% polyester staple fibres by weight (excl. sewing thread and yarn put up for retail sale)','Hilados con un contenido de fibras discontinuas de poliéster >= 85% en peso, retorcidos o cableados (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550931,'Fios simples, de fibras descontínuas acrílicas ou modacrílicas, contendo => 85% em peso destas fibras, não para venda a retalho','Single yarn containing >= 85% acrylic or modacrylic staple fibres by weight (excl. sewing thread and yarn put up for retail sale)','Hilados con un contenido de fibras discontinuas acrílicas o modacrílicas >= 85% en peso, sencillos (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550932,'Fios retorcidos ou retorcidos múltiplos, de fibras descontínuas acrílicas ou modacrílicas, contendo => 85% em peso destas fibras, não para venda a retalho','Multiple folded or cabled yarn containing >= 85% acrylic or modacrylic staple fibres by weight (excl. sewing thread and yarn put up for retail sale)','Hilados con un contenido de fibras discontinuas acrílicas o modacrílicas >= 85% en peso, retorcidos o cableados (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550941,'Outros fios simples, de fibras sintéticas descontínuas, contendo => 85% em peso destas fibras, não para venda a retalho','Single yarn containing >= 85% synthetic staple fibres by weight (excl. sewing thread, yarn put up for retail sale and yarn of acrylic, modacrylic, polyester, nylon or other polyamide staple fibres)','Hilados con un contenido de fibras sintéticas discontinuas >= 85% en peso, sencillos (exc. acondicionados para la venta al por menor y los hilos de coser, así como los hilados de fibras discontinuas acrílicas, modacrílicas, de poliésteres, de nailon o dem',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550942,'Outros fios retorcidos ou retorcidos múltiplos, de fibras sintéticas descontínuas, contendo => 85% em peso destas fibras, não para venda a retalho','Multiple folded or cabled yarn containing >= 85% synthetic staple fibres by weight (excl. sewing thread, yarn put up for retail sale and yarn of acrylic, modacrylic, polyester, nylon or other polyamide staple fibres)','Hilados con un contenido de fibras sintéticas discontinuas >= 85% en peso, retorcidos o cableados (exc. acondicionados para la venta al por menor y los hilos de coser, así como los hilados de fibras discontinuas acrílicas, modacrílicas, de poliésteres, de',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550951,'Fios de fibras descontínuas de poliéster combinadas com fibras artificiais descontínuas, não para venda a retalho','Yarn containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with artificial staple fibres (excl. sewing thread and yarn put up for retail sale)','Hilados con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezclados exclusiva o principalmente con fibras artificiales discontinuas (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550952,'Fios de fibras descontínuas de poliéster combinadas com lã ou pêlos finos, não para venda a retalho','Yarn containing > 50% to < 85% polyester staple fibres by weight, mixed principally or solely with wool or fine animal hair (excl. sewing thread and yarn put up for retail sale)','Hilados con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezclados exclusiva o principalmente con lana o pelo fino (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550953,'Fios de fibras descontínuas de poliéster combinadas com algodão, não para venda a retalho','Yarn containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton (excl. sewing thread and yarn put up for retail sale)','Hilados con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezclados exclusiva o principalmente con algodón (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550959,'Outros fios de fibras descontínuas de poliéster, não para venda a retalho','Yarn containing predominantly, but < 85% polyester staple fibres by weight, other than that mixed principally or solely with cotton, wool, fine animal hair or artificial staple fibres (excl. sewing thread and yarn put up for retail sale)','Hilados con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, distintos de los mezclados exclusiva o principalmente con algodón, con lana o pelo fino o con fibras artificiales discontinuas (exc. acondicionados para la venta al por',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550961,'Fios de fibras descontínuas acrílicas ou modacrílicas combinadas com lã ou pêlos finos, não para venda a retalho','Yarn containing predominantly, but < 85% acrylic or modacrylic staple fibres by weight, mixed principally or solely with wool or fine animal hair (excl. sewing thread and yarn put up for retail sale)','Hilados con un alto contenido de fibras discontinuas acrílicas o modacrílicas, pero < 85% en peso, mezclados exclusiva o principalmente con lana o pelo fino (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550962,'Fios de fibras descontínuas acrílicas ou modacrílicas combinadas com algodão, não para venda a retalho','Yarn containing predominantly, but < 85% acrylic or modacrylic staple fibres by weight, mixed principally or solely with cotton (excl. sewing thread and yarn put up for retail sale)','Hilados con un alto contenido de fibras discontinuas acrílicas o modacrílicas, pero < 85% en peso, mezclados exclusiva o principalmente con algodón (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550969,'Outros fios de fibras descontínuas acrílicas ou modacrílicas, não para venda a retalho','Yarn containing predominantly, but < 85% acrylic or modacrylic staple fibres by weight, other than that mixed principally or solely with cotton, wool or fine animal hair (excl. sewing thread and yarn put up for retail sale)','Hilados con un alto contenido de fibras discontinuas acrílicas o modacrílicas, pero < 85% en peso, distintos de los mezclados exclusiva o principalmente con algodón o con lana o pelo fino (exc. acondicionados para la venta al por menor, así como los hilos',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550991,'Fios de outras fibras sintéticas descontínuas combinadas com lã ou pêlos finos, não para venda a retalho','Yarn containing predominantly, but < 85% synthetic staple fibres by weight, mixed principally or solely with wool or fine animal hair (excl. sewing thread, yarn put up for retail sale and yarn of polyester, acrylic or modacrylic staple fibres)','Hilados con un alto contenido de fibras sintéticas discontinuas, pero < 85% en peso, mezclados exclusiva o principalmente con lana o pelo fino (exc. acondicionados para la venta al por menor, así como los hilos de coser y los hilados de fibras discontinua',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550992,'Fios de outras fibras sintéticas descontínuas combinadas com algodão, não para venda a retalho','Yarn containing predominantly, but < 85% synthetic staple fibres by weight, mixed principally or solely with cotton (excl. sewing thread, yarn put up for retail sale and yarn of polyester, acrylic or modacrylic staple fibres)','Hilados con un alto contenido de fibras sintéticas discontinuas, pero < 85% en peso, mezclados exclusiva o principalmente con algodón (exc. acondicionados para la venta al por menor, así como los hilos de coser y los hilados de fibras discontinuas de poli',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (550999,'Outros fios de fibras sintéticas descontínuas, não para venda a retalho','Yarn containing predominantly, but < 85% synthetic staple fibres by weight, other than that mixed principally or solely with cotton, wool or fine animal hair (excl. sewing thread, yarn put up for retail sale and yarn of polyester, acrylic or modacrylic st','Hilados con un alto contenido de fibras sintéticas discontinuas, pero < 85% en peso, distintos de los mezclados exclusiva o principalmente con algodón o con lana o pelo fino (exc. acondicionados para la venta al por menor, así como los hilos de coser y lo',55,5509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551011,'Fios simples de fibras artificiais descontínuas, contendo => 85% em peso destas fibras, não para venda a retalho','Single yarn, containing >= 85% artificial staple fibres by weight (excl. sewing thread and yarn put up for retail sale)','Hilados con un contenido de fibras artificiales discontinuas >= 85% en peso, sencillos (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5510);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551012,'Fios retorcidos ou retorcidos múltiplos, de fibras artificiais descontínuas, contendo => 85% em peso destas fibras, não para venda a retalho','Multiple folded or cabled yarn containing >= 85% artificial staple fibres by weight (excl. sewing thread and yarn put up for retail sale)','Hilados con un contenido de fibras artificiales discontinuas >= 85% en peso, retorcidos o cableados (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5510);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551020,'Fios de fibras artificiais descontínuas combinados com lã ou pêlos finos, não para venda a retalho','Yarn containing predominantly, but < 85% artificial staple fibres by weight, mixed principally or solely with wool or fine animal hair (excl. sewing thread and yarn put up for retail sale)','Hilados con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, mezclados exclusiva o principalmente con lana o pelo fino (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5510);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551030,'Fio de fibras artificiais descontínuas combinados com algodão, não para venda a retalho','Yarn containing predominantly, but < 85% artificial staple fibres by weight, mixed principally or solely with cotton (excl. sewing thread and yarn put up for retail sale)','Hilados con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, mezclados exclusiva o principalmente con algodón (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5510);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551090,'Outros fios de fibras artificiais descontínuas, não para venda a retalho','Yarn containing predominantly, but < 85% artificial staple fibres by weight, other than that mixed principally or solely with cotton, wool or fine animal hair (excl. sewing thread and yarn put up for retail sale)','Hilados con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, distintos de los mezclados exclusiva o principalmente con algodón o con lana o pelo fino (exc. acondicionados para la venta al por menor, así como los hilos de coser)',55,5510);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551110,'Fios de fibras sintéticas descontínuas, contendo => 85% em peso destas fibras, para venda a retalho','Yarn containing >= 85% synthetic staple fibres by weight, put up for retail sale (excl. sewing thread)','Hilados con un contenido de fibras sintéticas discontinuas >= 85% en peso, acondicionados para la venta al por menor (exc. hilos de coser)',55,5511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551120,'Fios de fibras sintéticas descontínuas, contendo < 85% em peso destas fibras, para venda a retalho','Yarn containing predominantly, but < 85% synthetic staple fibres by weight, put up for retail sale (excl. sewing thread)','Hilados con un alto contenido de fibras sintéticas discontinuas, pero < 85% en peso, acondicionados para la venta al por menor (exc. hilos de coser)',55,5511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551130,'Fios de fibras artificiais descontínuas, para venda a retalho','Yarn of artificial staple fibres, put up for retail sale (excl. sewing thread)','Hilados de fibras artificiales discontinuas, acondicionados para la venta al por menor (exc. hilos de coser)',55,5511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551211,'Tecidos crus ou branqueados de fibras descontínuas de poliéster, contendo => 85% em peso destas fibras','Woven fabrics containing >= 85% polyester staple fibres by weight, unbleached or bleached','Tejidos de fibras sintéticas discontinuas, con un contenido de fibras discontinuas de poliéster >= 85% en peso, crudos o blanqueados',55,5512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551219,'Outros tecidos de fibras descontínuas de poliéster, contendo => 85% em peso destas fibras','Woven fabrics containing >= 85% polyester staple fibres by weight, dyed, made of yarn of different colours, or printed','Tejidos de fibras sintéticas discontinuas, con un contenido de fibras discontinuas de poliéster >= 85% en peso, teñidos, fabricados con hilos de distintos colores o estampados',55,5512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551221,'Tecidos crus ou branqueados de fibras descontínuas acrílicas ou modacrílicas, contendo => 85% em peso destas fibras','Woven fabrics containing >= 85% acrylic or modacrylic staple fibres by weight, unbleached or bleached','Tejidos de fibras sintéticas discontinuas, con un contenido de fibras discontinuas acrílicas o modacrílicas >= 85% en peso, crudos o blanqueados',55,5512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551229,'Outros tecidos de fibras descontínuas acrílicas ou modacrílicas, contendo => 85% em peso destas fibras','Woven fabrics containing >= 85% acrylic or modacrylic staple fibres by weight, dyed, made of yarn of different colours or printed','Tejidos de fibras sintéticas discontinuas, con un contenido de fibras discontinuas acrílicas o modacrílicas >= 85% en peso, teñidos, fabricados con hilos de distintos colores o estampados',55,5512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551291,'Outros tecidos crus ou branqueados de fibras sintéticas descontínuas, contendo => 85% em peso destas fibras','Woven fabrics containing >= 85% synthetic staple fibres by weight, unbleached or bleached (excl. those of acrylic, modacrylic or polyester staple fibres)','Tejidos de fibras sintéticas discontinuas, con un contenido de fibras sintéticas discontinuas >= 85% en peso, crudos o blanqueados (exc. de fibras discontinuas acrílicas, modacrílicas o de poliésteres)',55,5512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551299,'Outros tecidos de fibras sintéticas descontínuas, contendo => 85% em peso destas fibras','Woven fabrics containing >= 85% synthetic staple fibres by weight, dyed, made of yarn of different colours or printed (excl. those of acrylic, modacrylic or polyester staple fibres)','Tejidos de fibras sintéticas discontinuas, con un contenido de fibras sintéticas discontinuas >= 85% en peso, teñidos, fabricados con hilos de distintos colores o estampados (exc. de fibras discontinuas acrílicas, modacrílicas o de poliésteres)',55,5512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551311,'Tecido cru ou branqueado de fibras descontínuas de poliéster, contendo < 85% em peso destas fibras, combinadas com algodão, de peso <= 170 g/m2, em ponto de tafetá','Plain woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton and weighing <= 170 g/m², unbleached or bleached','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso <= 170 g/m², de ligamento tafetán, crudos o blanqueados',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551312,'Tecido cru ou branqueado de fibras descontínuas de poliéster, contendo < 85% em peso destas fibras, combinadas com algodão, de peso <= 170 g/m2, em ponto sarjado','Woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton and weighing <= 170 g/m², in three-thread or four-thread twill, incl. cross twill, unbleached or bleached','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso <= 170 g/m², de ligamento sarga o cruzado de curso <= 4, crudos o blanquead',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551313,'Outros tecidos crus ou branqueados de fibras descontínuas de poliéster, contendo < 85% em peso destas fibras, combinadas com algodão, de peso <= 170 g/m2','Woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton and weighing <= 170 g/m², unbleached or bleached (excl. those in three-thread or four-thread twill, incl. cross twill, and plain w','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso <= 170 g/m², crudos o blanqueados (exc. de ligamento sarga o cruzado de cur',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551319,'Outros tecidos crus ou branqueados de fibras sintéticas descontínuas, contendo < 85% em peso destas fibras, combinadas com algodão, de peso <= 170 g/m2','Woven fabrics containing predominantly, but < 85% synthetic staple fibres by weight, mixed principally or solely with cotton and weighing <= 170 g/m², unbleached or bleached (excl. those of polyester staple fibres)','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras sintéticas discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso <= 170 g/m², crudos o blanqueados (exc. de fibras discontinuas de poliéster)',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551321,'Tecido tinto de fibras descontínuas de poliéster, contendo < 85% em peso destas fibras, combinadas com algodão, de peso <= 170 g/m2, em ponto de tafetá','Plain woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton and weighing <= 170 g/m², dyed','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso <= 170 g/m², de ligamento tafetán, teñidos',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551322,'tecido poliéster<85% c/algodão,  p<=170g/m2,  sarjado,  tinto','fabric polyester<85% with cot.w<=170g/m2, twill, dyed','tejido poliéster<85% c/algodón, p<=170g/m2, sarga, teñido',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551323,'Outros tecidos tintos de fibras descontínuas de poliéster, contendo < 85% em peso destas fibras, combinadas com algodão, de peso <= 170 g/m2','Woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton and weighing <= 170 g/m², dyed (excl. plain woven fabrics)','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso <= 170 g/m², teñidos (exc. de ligamento sarga o cruzado de curso <= 4 ó de ',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551329,'Outros tecidos tintos de fibras sintéticas descontínuas, contendo < 85% em peso destas fibras, combinadas com algodão, de peso <= 170 g/m2','Woven fabrics containing predominantly, but < 85% synthetic staple fibres by weight, mixed principally or solely with cotton and weighing <= 170 g/m², dyed (excl. those of polyester staple fibres)','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras sintéticas discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso <= 170 g/m², teñidos (exc. de fibras discontinuas de poliéster)',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551331,'Tecido de fios de diversas cores de fibras descontínuas de poliéster, contendo < 85% em peso destas fibras, combinadas com algodão, de peso <= 170 g/m2, em ponto de tafetá','Plain woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton and weighing <= 170 g/m², made of yarn of different colours','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso <= 170 g/m², de ligamento tafetán, fabricados con hilos de distintos colore',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551332,'tecido poliest<85% c/algod.p<=170g/m2,  sarjad.divs.cores','fabric polyest<85% with cot.w<=170g/m2, twill, dif.col.','tejido poliést<85% c/algod.p<=170g/m2, sarga, dist.color.',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551333,'outs.tecidos poliest<85% c/algod.p<=170g/m2,  divs.cores','oth.fabrics polyest<85% with cot.w<=170g/m2, dif.col.','ots.tejidos poliést<85% c/algod.p<=170g/m2, dist.colores',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551339,'Outros tecidos de fios de diversas cores de fibras sintéticas descontínuas, contendo < 85% em peso destas fibras, combinadas com algodão, de peso <= 170 g/m2','Woven fabrics containing predominantly, but < 85% synthetic staple fibres by weight, mixed principally or solely with cotton and weighing <= 170 g/m², made of yarn of different colours (excl. plain woven fabrics of polyester staple fibres)','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras sintéticas discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso <= 170 g/m², fabricados con hilos de distintos colores (exc. de fibras discon',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551341,'Tecido estampado de fibras descontínuas de poliéster, contendo < 85% em peso destas fibras, combinadas com algodão, de peso <= 170 g/m2, em ponto de tafetá','Plain woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton and weighing <= 170 g/m², printed','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso <= 170 g/m², de ligamento tafetán, estampados',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551342,'tecido poliéster<85% c/algodão,  p<=170g/m2,  sarjad.estamp','fabric polyest<85% with cot.w<=170g/m2, twill, printed','tejido poliéster<85% c/algodón, p<=170g/m2, sarga, estamp.',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551343,'outs.tecidos poliéster<85% c/algodão,  p<=170g/m2,  estamp.','other fabrics polyest<85% with cot.w<=170g/m2, printed','ots.tejidos poliéster<85% c/algodón, p<=170g/m2, estamp.',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551349,'Outros tecidos estampados de fibras sintéticas descontínuas, contendo < 85% em peso destas fibras, combinadas com algodão, de peso <= 170 g/m2','Woven fabrics containing predominantly, but < 85% synthetic staple fibres by weight, mixed principally or solely with cotton and weighing <= 170 g/m², printed (excl. plain woven fabrics of polyester staple fibres)','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras sintéticas discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso <= 170 g/m², estampados (exc. de fibras discontinuas de poliéster)',55,5513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551411,'Tecido cru o branqueado de fibras descontínuas de poliéster, contendo < 85% em peso destas fibras, combinadas com algodão, de peso > 170 g/m2, em ponto de tafetá','Plain woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton and weighing > 170 g/m², unbleached or bleached','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso > 170 g/m², de ligamento tafetán, crudos o blanqueados',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551412,'Tecido cru ou branqueado de fibras descontínuas de poliéster, contendo < 85% em peso destas fibras, combinadas com algodão, de peso > 170 g/m2, em ponto sarjado','Woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton and weighing > 170 g/m², in three-thread or four-thread twill, incl. cross twill, unbleached or bleached','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso > 170 g/m², de ligamento sarga o cruzado de curso <= 4, crudos o blanqueado',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551413,'Outs.tecidos poliéster<85% c/algod.p>170g/m2,  cru/branq.','Other fabric polyester<85% with cot.w>170g/m2, raw/bleac','Oots.tejidos poliéster<85% c/algod.p>170g/m2, crudo/blanq',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551419,'Outros tecidos crus ou branqueados de fibras sintéticas descontínuas, contendo < 85% em peso destas fibras, combinadas com algodão, de peso > 170 g/m2','Woven fabrics containing predominantly, but < 85% synthetic staple fibres by weight, mixed principally or solely with cotton and weighing > 170 g/m², unbleached or bleached (excl. those of plain woven polyester staple fibres and polyester staple fibres in','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras sintéticas discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso > 170 g/m², crudos o blanqueados (exc. de fibras discontinuas de poliéster)',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551421,'Tecido tinto de fibras descontínuas de poliéster, contendo < 85% em peso destas fibras, combinadas com algodão, de peso > 170 g/m2, em ponto de tafetá','Plain woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton and weighing > 170 g/m², dyed','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso > 170 g/m², de ligamento tafetán, teñidos',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551422,'Tecido tinto de fibras descontínuas de poliéster, contendo < 85% em peso destas fibras, combinadas com algodão, de peso > 170 g/m2, em ponto sarjado','Woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton and weighing > 170 g/m², in three-thread or four-thread twill, incl. cross twill, dyed','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso > 170 g/m², de ligamento sarga o cruzado de curso <= 4, teñidos',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551423,'Outros tecidos tintos de fibras descontínuas de poliéster, contendo < 85% em peso destas fibras, combinadas com algodão, de peso > 170 g/m2','Woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton and weighing > 170 g/m², dyed (excl. those in three-thread or four-thread twill, incl. cross twill, and plain woven fabrics)','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso > 170 g/m², teñidos (exc. de ligamento sarga o cruzado de curso <= 4 ó de l',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551429,'Outros tecidos tintos de fibras sintéticas descontínuas, contendo < 85% em peso destas fibras, combinadas com algodão, de peso > 170 g/m2','Woven fabrics containing predominantly, but < 85% synthetic staple fibres by weight, mixed principally or solely with cotton and weighing > 170 g/m², dyed (excl. those of polyester staple fibres)','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras sintéticas discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso > 170 g/m², teñidos (exc. de fibras discontinuas de poliéster)',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551430,'Tecido de fios de diversas cores, de fibras sintéticas descontínuas, contendo < 85% em peso destas fibras, combinadas com algodão, de peso > 170 g/m2','Woven fabrics containing predominantly, but < 85% synthetic staple fibres by weight, mixed principally or solely with cotton and weighing > 170 g/m², made of yarn of different colours','Tejidos con hilados de distintos colores, de fibras sintéticas discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso > 170 g/m²',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551431,'tecido poliest<85% c/algodão,  p>170g/m2,  tafeta,  div.cores','fabric polyest<85% with cot.w>170g/m2, taf.difer.colours','tejido poliést<85% c/algod., p>170g/m2, tafet.dist.color.',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551432,'tecido poliest<85% c/algodão,  p>170g/m2,  sarjad.div.cores','fabric polyest<85% with cot.w>170g/m2, twill, dif.colours','tejido poliést<85% c/algod., p>170g/m2, sarga, dist.color.',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551433,'outs.tecidos poliéster<85% c/algod.p>170g/m2,  div.cores','oth.fabrics polyest<85% with cot.w>170g/m2, dif.colours','ots.tejidos poliéster<85% c/algod.p>170g/m2, dist.color.',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551439,'outs.tecidos fibra sint<85% c/algod.p>170g/m2,  div.cores','other fabrics synt.fibr<85% with cot.w>170g/m2, dif.col.','ots.tejidos fibra sint<85% c/alg.p>170g/m2, dist.colores',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551441,'Tecido estampado de fibras descontínuas de poliéster, contendo < 85% em peso destas fibras, combinadas com algodão, de peso > 170 g/m2, em ponto de tafetá','Plain woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton and weighing > 170 g/m², printed','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso > 170 g/m², de ligamento tafetán, estampados',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551442,'Tecido estampado de fibras descontínuas de poliéster, contendo < 85% em peso destas fibras, combinadas com algodão, de peso > 170 g/m2, em ponto sarjado','Woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton and weighing > 170 g/m², in three-thread or four-thread twill, incl. cross twill, printed','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso > 170 g/m², de ligamento sarga o cruzado de curso <= 4, estampados',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551443,'Outros tecidos estampados de fibras descontínuas de poliéster, contendo < 85% em peso destas fibras, combinadas com algodão, de peso > 170 g/m2','Woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton and weighing > 170 g/m², printed (excl. those in three-thread or four-thread twill, incl. cross twill, and plain woven fabrics)','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso > 170 g/m², estampados (exc. de ligamento sarga o cruzado de curso <= 4 ó d',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551449,'Outros tecidos estampados de fibras sintéticas descontínuas, contendo < 85% em peso destas fibras, combinadas com algodão, de peso > 170 g/m2','Woven fabrics containing predominantly, but < 85% synthetic staple fibres by weight, mixed principally or solely with cotton and weighing > 170 g/m², printed (excl. those of polyester staple fibres)','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras sintéticas discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, de peso > 170 g/m², estampados (exc. de fibras discontinuas de poliéster)',55,5514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551511,'Tecido de fibras descontínuas de poliéster combinadas com fibras descontínuas de raiom viscose','Woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with viscose staple fibres','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con fibras discontinuas de rayón viscosa',55,5515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551512,'Tecido de fibras descontínuas de poliéster combinadas com filamentos sintéticos ou artificiais','Woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with man-made filament','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con filamentos sintéticos o artificiales',55,5515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551513,'Tecido de fibras descontínuas de poliéster combinadas com lã ou pêlos finos','Woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, mixed principally or solely with cotton or fine animal hair','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, mezcladas exclusiva o principalmente con lana o pelo fino',55,5515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551519,'Outros tecidos de fibras descontínuas de poliéster','Woven fabrics containing predominantly, but < 85% polyester staple fibres by weight, other than those mixed principally or solely with wool or fine animal hair, man-made filament, viscose staple fibres or cotton','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas de poliéster, pero < 85% en peso, distintas de las mezcladas exclusiva o principalmente con lana o pelo fino, con filamentos sintéticos o artificiales, con fibras disc',55,5515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551521,'Tecido de fibras descontínuas acrílicas ou modacrílicas combinadas com filamentos sintéticos ou artificiais','Woven fabrics containing predominantly, but < 85% acrylic or modacrylic staple fibres by weight, mixed principally or solely with man-made filament','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas acrílicas o modacrílicas, pero < 85% en peso, mezcladas exclusiva o principalmente con filamentos sintéticos o artificiales',55,5515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551522,'Tecido de fibras descontínuas acrílicas ou modacrílicas combinadas com lã ou pêlos finos','Woven fabrics containing predominantly, but < 85% acrylic or modacrylic staple fibres by weight, mixed principally or solely with carded wool or carded fine animal hair','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas acrílicas o modacrílicas, pero < 85% en peso, mezcladas exclusiva o principalmente con lana o pelo fino',55,5515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551529,'Outros tecidos de fibras descontínuas acrílicas ou modacrílicas','Woven fabrics containing predominantly, but < 85% acrylic or modacrylic staple fibres by weight, other than those mixed principally or solely with wool, fine animal hair, man-made filaments or cotton','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras discontinuas acrílicas o modacrílicas, pero < 85% en peso, distintas de las mezcladas exclusiva o principalmente con lana o pelo fino, con filamentos sintéticos o artificiales o co',55,5515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551591,'Outros tecidos de fibras sintéticas descontínuas com filamentos sintéticos ou artificiais','Woven fabrics containing predominantly, but < 85% synthetic staple fibres, mixed principally or solely with man-made filament (excl. those of acrylic, modacrylic or polyester staple fibres)','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras sintéticas discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con filamentos sintéticos o artificiales (exc. tejidos de fibras discontinuas acrílicas, modacríli',55,5515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551592,'Tecido de outs.fibras sintéticas com la ou pêlos finos','Fabric of oth.synthetic fibres with wool/fine anim.hair','Tejido de ots.fibras sintéticas con lana o pelo fino',55,5515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551599,'Outros tecidos de fibras sintéticas descontínuas','Woven fabrics containing predominantly, but < 85% synthetic staple fibres, other than those mixed principally or solely with man-made filament or cotton (excl. those of acrylic, modacrylic or polyester staple fibres)','Tejidos de fibras sintéticas discontinuas, con un alto contenido de fibras sintéticas discontinuas, pero < 85% en peso, distintas de las mezcladas exclusiva o principalmente con lana o pelo fino, con filamentos sintéticos o artificiales o con algodón (exc',55,5515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551611,'Tecido cru ou branqueado, contendo => 85% em peso de fibras artificiais descontínuas ','Woven fabrics containing >= 85% artificial staple fibres by weight, unbleached or bleached','Tejidos con un contenido de fibras artificiales discontinuas >= 85% en peso, crudos o blanqueados',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551612,'Tecido tinto, contendo => 85% em peso de fibras artificiais descontínuas ','Woven fabrics containing >= 85% artificial staple fibres by weight, dyed','Tejidos con un contenido de fibras artificiales discontinuas >= 85% en peso, teñidos',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551613,'Tecido de fios de diversas cores, contendo => 85% em peso de fibras artificiais descontínuas ','Woven fabrics containing >= 85% artificial staple fibres by weight, made of yarn of different colours','Tejidos con un contenido de fibras artificiales discontinuas >= 85% en peso, fabricados con hilos de distintos colores',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551614,'Tecido estampado, contendo => 85% em peso de fibras artificiais descontínuas ','Woven fabrics containing >= 85% artificial staple fibres by weight, printed','Tejidos con un contenido de fibras artificiales discontinuas >= 85% en peso, estampados',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551621,'Tecido cru o branqueado, contendo < 85% em peso de fibras artificiais descontínuas, combinadas com filamentos sintéticos ou artificiais','Woven fabrics containing predominantly, but < 85% artificial staple fibres, mixed principally or solely with man-made filament, unbleached or bleached','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con filamentos sintéticos o artificiales, crudos o blanqueados',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551622,'Tecido tinto, contendo < 85% em peso de fibras artificiais descontínuas, combinadas com filamentos sintéticos ou artificiais','Woven fabrics containing predominantly, but < 85% artificial staple fibres, mixed principally or solely with man-made filament, dyed','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con filamentos sintéticos o artificiales, teñidos',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551623,'Tecido de fios de diversas cores, contendo < 85% em peso de fibras artificiais descontínuas, combinadas com filamentos sintéticos ou artificiais','Woven fabrics containing predominantly, but < 85% artificial staple fibres, mixed principally or solely with man-made filament, made of yarn of different colours','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con filamentos sintéticos o artificiales, fabricados con hilos de distintos colores',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551624,'Tecido estampado, contendo < 85% em peso de fibras artificiais descontínuas, combinadas com filamentos sintéticos ou artificiais','Woven fabrics containing predominantly, but < 85% artificial staple fibres by weight, mixed principally or solely with man-made filament, printed','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con filamentos sintéticos o artificiales, estampados',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551631,'Tecido cru ou branqueado, contendo < 85% em peso de fibras artificiais descontínuas, combinadas com lã ou pêlos finos','Woven fabrics containing predominantly, but < 85% artificial staple fibres by weight, mixed principally or solely with wool or fine animal hair, unbleached or bleached','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con lana o pelo fino, crudos o blanqueados',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551632,'Tecido tinto, contendo < 85% em peso de fibras artificiais descontínuas, combinadas com lã ou pêlos finos','Woven fabrics containing predominantly, but < 85% artificial staple fibres by weight, mixed principally or solely with wool or fine animal hair, dyed','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con lana o pelo fino, teñidos',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551633,'Tecido de fios de diversas cores, contendo < 85% em peso de fibras artificiais descontínuas, combinadas com lã ou pêlos finos','Woven fabrics containing predominantly, but < 85% artificial staple fibres by weight, mixed principally or solely with wool or fine animal hair, made of yarn of different colours','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con lana o pelo fino, fabricados con hilos de distintos colores',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551634,'Tecido estampado, contendo < 85% em peso de fibras artificiais descontínuas, combinadas com lã ou pêlos finos','Woven fabrics containing predominantly, but < 85% artificial staple fibres by weight, mixed principally or solely with wool or fine animal hair, printed','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con lana o pelo fino, estampados',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551641,'Tecido cru ou branqueado, contendo < 85% em peso de fibras artificiais descontínuas, combinadas com algodão','Woven fabrics containing predominantly, but < 85% artificial staple fibres by weight, mixed principally or solely with cotton, unbleached or bleached','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, crudos o blanqueados',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551642,'Tecido tinto, contendo < 85% em peso de fibras artificiais descontínuas, combinadas com algodão','Woven fabrics containing predominantly, but < 85% artificial staple fibres by weight, mixed principally or solely with cotton, dyed','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, teñidos',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551643,'Tecido de fios de diversas cores, contendo < 85% em peso de fibras artificiais descontínuas, combinadas com algodão','Woven fabrics containing predominantly, but < 85% artificial staple fibres by weight, mixed principally or solely with cotton, made of yarn of different colours','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, fabricados con hilos de distintos colores',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551644,'Tecido estampado, contendo < 85% em peso de fibras artificiais descontínuas, combinadas com algodão','Woven fabrics containing predominantly, but < 85% artificial staple fibres by weight, mixed principally or solely with cotton, printed','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, mezcladas exclusiva o principalmente con algodón, estampados',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551691,'Outros tecidos crus ou branqueados de fibras artificiais descontínuas','Woven fabrics containing predominantly, but < 85% artificial staple fibres by weight, other than those mixed principally or solely with cotton, wool, fine animal hair or man-made filament, unbleached or bleached','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, distintas de las mezcladas exclusiva o principalmente con algodón, con lana o pelo fino o con filamentos sintéticos o artificiales, crudos o blanqueados',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551692,'Outros tecidos tintos de fibras artificiais descontínuas','Woven fabrics containing predominantly, but < 85% artificial staple fibres by weight, other than those mixed principally or solely with cotton, wool, fine animal hair or man-made filament, dyed','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, distintas de las mezcladas exclusiva o principalmente con algodón, con lana o pelo fino o con filamentos sintéticos o artificiales, teñidos',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551693,'Outros tecidos de fios de diversas cores de fibras artificiais descontínuas','Woven fabrics containing predominantly, but < 85% artificial staple fibres by weight, other than those mixed principally or solely with cotton, wool, fine animal hair or man-made filament, made of yarn of different colours','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, distintas de las mezcladas exclusiva o principalmente con algodón, con lana o pelo fino o con filamentos sintéticos o artificiales, fabricados con hilos de distintos co',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (551694,'Outros tecidos estampados de fibras artificiais descontínuas','Woven fabrics containing predominantly, but < 85% artificial staple fibres by weight, other than those mixed principally or solely with cotton, wool, fine animal hair or man-made filament, printed','Tejidos con un alto contenido de fibras artificiales discontinuas, pero < 85% en peso, distintas de las mezcladas exclusiva o principalmente con algodón, con lana o pelo fino o con filamentos sintéticos o artificiales, estampados',55,5516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560110,'Absorventes e tampões higiênicos, fraldas para bebês e artigos semelhantes, de pastas (ouates) de matérias têxteis','Sanitary towels and tampons, napkins and napkin liners for babies and similar sanitary articles, of wadding','Compresas y tampones higiénicos, pañales para bebés y artículos higiénicos simil., de guata',56,5601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560121,'Pastas (ouates); outros artigos de pastas (ouates), de algodão','Wadding of cotton and articles thereof (excl. sanitary towels and tampons, napkins and napkin liners for babies and similar sanitary articles, wadding and articles thereof impregnated or coated with pharmaceutical substances or put up for retail sale for ','Guata de algodón y artículos de esta guata (exc. compresas y tampones higiénicos, pañales para bebés y artículos higiénicos simil., guata y artículos de guata impregnados o recubiertos de sustancias farmacéuticas o acondicionados para la venta al por meno',56,5601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560122,'Pastas (ouates); outros artigos de pastas (ouates), de fibras sintéticas ou artificiais','Wadding of man-made fibres and articles thereof (excl. sanitary towels and tampons, napkins and napkin liners for babies and similar sanitary articles, wadding and articles thereof impregnated or coated with pharmaceutical substances or put up for retail ','Guata de fibras sintéticas o artificiales y artículos de esta guata (exc. compresas y tampones higiénicos, pañales para bebés y artículos higiénicos simil., guata y artículos de guata impregnados o recubiertos de sustancias farmacéuticas o acondicionados ',56,5601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560129,'Pastas (ouates) e outros artigos, de matérias têxteis','Wadding of textile materials and articles thereof (excl. of cotton or man-made fibres; sanitary towels and tampons, napkins and napkin liners for babies and similar sanitary articles, wadding and articles thereof, impregnated or covered with medicated sub','Guata de materia textil y artículos de esta guata (exc. de algodón o de fibras sintéticas o artificiales, así como compresas y tampones higiénicos, pañales para bebés y artículos higiénicos simil., guata y artículos de guata impregnados o recubiertos de s',56,5601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560130,'Tontisses, nós e bolotas, de matérias têxteis','Textile flock and dust and mill neps','Tundiznos, nudos y motas, de materia textil',56,5601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560210,'Feltros agulhados e artefatos de costura por entrelaçamento','Needleloom felt and stitch-bonded fibre fabrics, whether or not impregnated, coated, covered or laminated, n.e.s.','Fieltro punzonado y productos obtenidos mediante costura por cadeneta, incl. impregnado, recubierto, revestido o estratificado, n.c.o.p.',56,5602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560221,'Feltros de lã ou de pêlos finos, não impregnados, não revestidos, não recobertos nem estratificados','Felt, not impregnated, coated, covered or laminated, of wool or fine animal hair, n.e.s. (excl. needleloom felt and stitch-bonded fibre fabrics)','Fieltro, sin impregnar, recubrir, revestir ni estratificar, de lana o pelo fino, n.c.o.p. (exc. fieltro punzonado y productos obtenidos mediante costura por cadeneta)',56,5602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560229,'Feltros de outras matérias têxteis, não impregnados, não revestidos, não recobertos nem estratificados','Felt, not impregnated, coated, covered or laminated (excl. that of wool or fine animal hair; needleloom felt and stitch-bonded fibre fabrics)','Fieltro, sin impregnar, recubrir, revestir ni estratificar (exc. de lana o pelo fino, así como el fieltro punzonado y productos obtenidos mediante costura por cadeneta)',56,5602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560290,'Outros feltros, impregnados, revestidos, recobertos ou estratificados','Felt, impregnated, coated, covered or laminated (excl. needleloom felt and stitch-bonded fibre fabrics)','Fieltro impregnado, recubierto, revestido o estratificado (exc. fieltro punzonado y productos obtenidos mediante costura por cadeneta)',56,5602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560311,'Falsos tecidos de filamentos sintéticos ou artificiais, de peso <= 25 g/m2','Nonwovens, whether or not impregnated, coated, covered or laminated, n.e.s., of synthetic or man-made filaments, weighing <= 25 g/m²','Tela sin tejer, incl. impregnada, recubierta, revestida o estratificada, n.c.o.p., de filamentos sintéticos o artificiales, de peso <= 25 g/m²',56,5603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560312,'Falsos tecidos de filamentos sintéticos ou artificiais, de peso > 25 g/m2 e <= 70 g/m2','Nonwovens, whether or not impregnated, coated, covered or laminated, n.e.s., of man-made filaments, weighing > 25 g/m² but <= 70 g/m²','Tela sin tejer, incl. impregnada, recubierta, revestida o estratificada, n.c.o.p., de filamentos sintéticos o artificiales, de peso > 25 g/m² pero <= 70 g/m²',56,5603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560313,'Falsos tecidos de filamentos sintéticos ou artificiais, de peso > 70 g/m2 e <= 150 g/m2','Nonwovens, whether or not impregnated, coated, covered or laminated, n.e.s., of man-made filaments, weighing > 70 g/m² but <= 150 g/m²','Tela sin tejer, incl. impregnada, recubierta, revestida o estratificada, n.c.o.p., de filamentos sintéticos o artificiales, de peso > 70 g/m² pero <= 150 g/m²',56,5603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560314,'Falsos tecidos de filamentos sintéticos ou artificiais, de peso > 150 g/m2','Nonwovens, whether or not impregnated, coated, covered or laminated, n.e.s., of man-made filaments, weighing > 150 g','Tela sin tejer, incl. impregnada, recubierta, revestida o estratificada, n.c.o.p., de filamentos sintéticos o artificiales, de peso > 150 g/m²',56,5603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560391,'Outros falsos tecidos, de peso <= 25 g/m2','Nonwovens, whether or not impregnated, coated, covered or laminated, n.e.s., weighing <= 25 g/m² (excl. of man-made filaments)','Tela sin tejer, incl. impregnada, recubierta, revestida o estratificada, n.c.o.p., de peso <= 25 g/m² (exc. de filamentos sintéticos o artificiales)',56,5603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560392,'Outros falsos tecidos, de peso > 25 g/m2 e <= 70 g/m2','Nonwovens, whether or not impregnated, coated, covered or laminated, n.e.s., weighing > 25 g/m² but <= 70 g/m² (excl. of man-made filaments)','Tela sin tejer, incl. impregnada, recubierta, revestida o estratificada, n.c.o.p., de peso > 25 g/m² pero <= 70 g/m² (exc. de filamentos sintéticos o artificiales)',56,5603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560393,'Outros falsos tecidos, de peso > 70 g/m2 e <= 150 g/m2','Nonwovens, whether or not impregnated, coated, covered or laminated, n.e.s., weighing > 70 g/m² but <= 150 g/m² (excl. of man-made filaments)','Tela sin tejer, incl. impregnada, recubierta, revestida o estratificada, n.c.o.p., de peso > 70 g/m² pero <= 150 g/m² (exc. de filamentos sintéticos o artificiales)',56,5603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560394,'Outros falsos tecidos, de peso > 150 g/m2','Nonwovens, whether or not impregnated, coated, covered or laminated, n.e.s., weighing > than 150 g/m² (excl. of man-made filaments)','Tela sin tejer, incl. impregnada, recubierta, revestida o estratificada, n.c.o.p., de peso > 150 g/m² (exc. de filamentos sintéticos o artificiales)',56,5603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560410,'Fios e cordas, de borracha, recobertos de têxteis','Textile-covered rubber thread and cord','Hilos y cuerdas de caucho, revestidos de textiles',56,5604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560420,'Fios de alta tenacidade de poliésteres','High tenacity yarn of polyesters','Hilados de alta tenacidad de poliésteres',56,5604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560490,'Outros fios têxteis, lâminas e formas semelhantes, impregnados, revestidos, recobertos ou embainhados de borracha ou plástico','Textile yarn, strip and the like of heading 5404 and 5405, impregnated, coated, covered or sheathed with rubber or plastics (excl. imitation catgut, thread and cord with fish-hook attachments or otherwise put up as fishing line)','Hilados de textiles, tiras y formas simil. de las partidas 5404 ó 5405, impregnadas, recubiertas, revestidas o enfundadas con caucho o plástico (exc. hilados de alta tenacidad de poliésteres, de nailon o demás poliamidas o de rayón viscosa, impregnados o ',56,5604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560500,'Fios metálicos constituídos por fios têxteis, lâminas ou formas semelhantes, combinados com metal','Metallised yarn, whether or not gimped, being textile yarn, or strip or the like of heading 5404 or 5405, of textile fibres, combined with metal in the form of thread, strip or powder or covered with metal (excl. yarns manufactured from a mixture of texti','Hilados metálicos e hilados metalizados, incl. entorchados, constituidos por hilados textiles, tiras o formas simil. de las partidas 5404 ó 5405, bien combinados con metal en forma de hilos, tiras o polvo, de metal, bien revestidos de metal (exc. hilados ',56,5605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560600,'Fios revestidos por enrolamento, lâminas e formas semelhantes das posições 5404 ou 5405, revestidas por enrolamento; fios de froco (chenille) e de cadeia (chainette)','Gimped yarn, gimped strip and the like of heading 5404 or 5405; chenille yarn, incl. flock chenille yarn, and loop wale-yarn (excl. metal yarn and metallised yarn of heading 5605; gimped horsehair yarn; textile-covered rubber thread; twine, cord and other','Hilados entorchados, tiras y formas simil. de las partidas 5404 ó 5405, entorchadas, así como hilados de chenilla e hilados "de cadeneta" (exc. hilados metálicos e hilados metalizados de la partida 5605; hilados de crin entorchados; hilos de caucho revest',56,5606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560710,'Cordéis, cordas e cabos de jutas ou outros materiais têxteis','Twine, cordage, ropes and cables of jutes or other textile materials','Cordeles, cuerdas y cordajes de jutos y otros materiales textiles',56,5607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560721,'Cordéis de sisal ou de outras fibras têxteis do gênero agave, para atadeiras ou enfardadeiras','Binder or baler twine, of sisal or other textile fibres of the genus Agave','Cordeles para atar o engavillar, de sisal o demás fibras textiles del género Ágave',56,5607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560729,'Outros cordéis, cordas e cabos, de sisal ou de outras fibras têxteis agave','Twine, cordage, ropes and cables, of sisal or other textile fibres of the genus Agave, whether or not plaited or braided and whether or not impregnated, coated, covered or sheathed with rubber or plastics (excl. binder or baler twine)','Cordeles, cuerdas y cordajes, estén o no trenzados, incl. impregnados, recubiertos, revestidos o enfundados con caucho o plástico, de sisal o demás fibras textiles del género Ágave (exc. cordeles para atar o engavillar)',56,5607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560730,'Cordéis,  cordas e cabos,  de abaca ou outras fibras duras','Twine, cordage, ropes and cables, of abaca or ot.hard fibr','Cordeles, cuerdas y cordajes, de abacá o ots.fibras duras',56,5607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560741,'Cordéis de polietileno ou polipropileno, para atadeiras ou enfardadeiras','Binder or baler twine, of polyethylene or polypropylene','Cordeles para atar o engavillar, de polietileno o de polipropileno',56,5607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560749,'Outros cordéis, cordas e cabos de polietileno ou polipropileno','Twine, cordage, ropes and cables of polyethylene or polypropylene, whether or not plaited or braided and whether or not impregnated, coated, covered or sheathed with rubber or plastics (excl. binder or baler twine)','Cordeles, cuerdas y cordajes, estén o no trenzados, incl. impregnados, recubiertos, revestidos o enfundados con caucho o plástico, de polietileno o de polipropileno (exc. cordeles para atar o engavillar)',56,5607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560750,'Cordéis, cordas e cabos, de outras fibras sintéticas','Twine, cordage, ropes and cables, of synthetic fibres, whether or not plaited or braided and whether or not impregnated, coated, covered or sheathed with rubber or plastics (excl. polyethylene and polypropylene)','Cordeles, cuerdas y cordajes, estén o no trenzados, incl. impregnados, recubiertos, revestidos o enfundados con caucho o plástico, de fibras sintéticas (exc. de polietileno o de polipropileno)',56,5607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560790,'Outros cordéis, cordas e cabos, de outras matérias têxteis','Twine, cordage, ropes and cables, whether or not plaited or braided and whether or not impregnated, coated, covered or sheathed with rubber or plastics (excl. that of synthetic fibres and of sisal or other textile fibres of the genus Agave)','Cordeles, cuerdas y cordajes, estén o no trenzados, incl. impregnados, recubiertos, revestidos o enfundados con caucho o plástico (exc. de fibras sintéticas, de yute o demás fibras textiles del líber de la partida 5303, de sisal o de otras fibras textiles',56,5607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560811,'Redes confeccionadas de matérias têxteis sintéticas ou artificiais, para a pesca','Made-up knotted fishing nets of man-made textile materials (excl. landing nets)','Redes de mallas anudadas, confeccionadas para la pesca, de materia textil sintética o artificial (exc. las utilizadas para la pesca con caña)',56,5608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560819,'Outras redes confeccionadas de matérias têxteis sintéticas ou artificiais','Knotted netting of twine, cordage, ropes or cables, by the piece or metre; made-up nets, of man-made textile materials (excl. made-up fishing nets, hairnets, nets for sporting purposes, incl. landing nets, butterfly nets and the like)','Redes de mallas anudadas, en paño o pieza, fabricadas con cordeles, cuerdas o cordajes, así como redes confeccionadas de materia textil sintética o artificial (exc. redes confeccionadas para la pesca, redecillas y redes para el cabello y redes para deport',56,5608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560890,'Outras redes de malhas com nós, em pano ou em peça, de matérias têxteis','Knotted netting of twine, cordage, ropes or cables, by the piece or metre; made-up fishing nets and other made-up nets, of vegetable textile materials (excl. hairnets, nets for sporting purposes, incl. landing nets, butterfly nets and the like)','Redes de mallas anudadas, en paño o en pieza, fabricadas con cordeles, cuerdas o cordajes, así como redes confeccionadas para la pesca, de fibra textil vegetal (exc. redecillas y redes para el cabello y redes para deportes, incl. las utilizadas para la pe',56,5608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (560900,'Artigos de fios, lâminas ou formas semelhantes das posições 5404 ou 5405; outros cordéis, cordas e cabos','Articles of yarn, strip or the like of heading 5404 or 5405, or of twine, cordage, ropes or cables of heading 5607, n.e.s.','Artículos de hilados, tiras o formas simil. de las partidas 5404 ó 5405, o de cordeles, cuerdas o cordajes de la partida 5607, n.c.o.p.',56,5609);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570110,'Tapetes de lã ou de pêlos finos, de pontos nodados ou enrolados','Carpets and other textile floor coverings, of wool or fine animal hair, knotted, whether or not made up','Alfombras de nudo, de lana o pelo fino, incl. confeccionadas',57,5701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570190,'Tapetes de outras matérias têxteis, de pontos nodados ou enrolados','Carpets and other textile floor coverings, of textile materials, knotted, whether or not made up (excl. those of wool or fine animal hair)','Alfombras de nudo de materia textil, incl. confeccionadas (exc. de lana o pelo fino)',57,5701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570210,'Tapetes Kelim, Schumacks, Karamanie e semelhantes, tecidos à mão','Kelem, Schumacks, Karamanie and similar hand-woven rugs, whether or not made up','Alfombras llam. "Kelim" o "Kilim", "Schumaks" o "Soumak", "Karamanie" y alfombras simil. tejidas a mano, aunque estén confeccionadas',57,5702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570220,'Revestimentos para pavimentos, de cairo (fibras de coco), obtidos por tecelagem, mesmo confeccionados','Floor coverings of coconut fibres coir, woven, whether or not made up','Revestimientos para el suelo de fibras de coco, tejidas, aunque estén confeccionados',57,5702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570231,'Tapetes e outros revestimentos para pavimentos, de lã ou pêlos finos, aveludados, não confeccionados','Carpets and other floor coverings, of wool or fine animal hair, woven, not tufted or flocked, of pile construction, not made up (excl. Kelem, Schumacks, Karamanie and similar hand-woven rugs)','Alfombras y demás revestimientos para el suelo, de lana o pelo fino, tejidos, distintos de los de pelo insertado y los flocados, aterciopelados, sin confeccionar (exc. alfombras llam. "Kelim" o "Kilim", "Schumaks" o "Soumak", "Karamanie" y alfombras simil',57,5702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570232,'Tapetes e outros revestimentos para pavimentos, de matérias têxteis sintéticas ou artificiais, aveludados, não confeccionados','Carpets and other floor coverings, of man-made textile materials, woven, not tufted or flocked, of pile construction, not made up (excl. Kelem, Schumacks, Karamanie and similar hand-woven rugs)','Alfombras y demás revestimientos para el suelo, de materia textil sintética o artificial, tejidas, distintos de los de pelo insertado y los flocados, aterciopelados, sin confeccionar (exc. alfombras llam. "Kelim" o "Kilim", "Schumaks" o "Soumak", "Karaman',57,5702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570239,'Tapetes e outros revestimentos para pavimentos, de outras matérias têxteis, aveludados, não confeccionados','Carpets and other floor coverings, of vegetable textile materials or coarse animal hair, woven, not tufted or flocked, of pile construction, not made up (excl. Kelem, Schumacks, Karamanie and similar hand-woven rugs, and floor coverings of coconut fibres ','Alfombras y demás revestimientos para el suelo, de materia textil vegetales o de pelo ordinario, tejidos, distintos de los de pelo insertado y los flocados, aterciopelados, sin confeccionar (exc. alfombras llam. "Kelim" o "Kilim", "Schumaks" o "Soumak", "',57,5702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570241,'Tapetes e outros revestimentos para pavimentos, de lã ou pêlos finos, aveludados, confeccionados','Carpets and other floor coverings, of wool or fine animal hair, woven, not tufted or flocked, of pile construction, made up (excl. Kelem, Schumacks, Karamanie and similar hand-woven rugs)','Alfombras y demás revestimientos para el suelo, de lana o pelo fino, tejidos, distintos de los de pelo insertado y los flocados, aterciopelados, confeccionados (exc. alfombras llam. "Kelim" o "Kilim", "Schumaks" o "Soumak", "Karamanie" y alfombras simil. ',57,5702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570242,'Tapetes e outros revestimentos para pavimentos, de matérias têxteis sintéticas ou artificiais, aveludados, confeccionados','Carpets and other floor coverings, of man-made textile materials, woven, not tufted or flocked, of pile construction, made up (excl. Kelem, Schumacks, Karamanie and similar hand-woven rugs)','Alfombras y demás revestimientos para el suelo, de materia textil sintética o artificial, tejidas, distintos de los de pelo insertado y los flocados, aterciopelados, confeccionados (exc. alfombras llam. "Kelim" o "Kilim", "Schumaks" o "Soumak", "Karamanie',57,5702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570249,'Tapetes e outros revestimentos para pavimentos, de outras matérias têxteis, aveludados, confeccionados','Carpets and other floor coverings, of vegetable textile materials or coarse animal hair, woven, not tufted or flocked, of pile construction, made up (excl. Kelem, Schumacks, Karamanie and similar hand-woven rugs, and floor coverings of coconut fibres coir','Alfombras y demás revestimientos para el suelo, de materia textil vegetal o de pelo ordinario, tejidos, distintos de los de pelo insertado y los flocados, aterciopelados, confeccionados (exc. alfombras llam. "Kelim" o "Kilim", "Schumaks" o "Soumak", "Kara',57,5702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570250,'Outros tapetes e revestimentos para pavimentos, não aveludados, não confeccionados','Carpets and other textile floor coverings, woven, not tufted or flocked, not of pile construction, not made up (excl. Kelem, Schumacks, Karamanie and similar hand-woven rugs, and floor coverings of coconut fibres coir)','Las demás alfombras y demás revestimientos para el suelo, sin aterciopelar ni confeccionar',57,5702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570251,'tapete,  etc.de la ou pêlos finos,  n/aveludado,  n/confecc.','carpet, etc.of fine animal hair, n/velvet, n/made-up','alfombra, etc.de lana o pelo fino, s/aterciopelar n/conf.',57,5702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570252,'tapete,  etc.de mat.têxtil sint/artif.n/avelud.n/confecc.','carpet, etc.of textile mat.syn/artif.n/velvet, n/made-up','alfombra, etc.de mat.textil sint/art.s/aterciop. n/conf.',57,5702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570259,'tapete,  etc.de outs.mater.têxteis,  n/aveludado,  n/confecc.','carpet, etc.of oth.textile materials, n/velvet, n/made-up','alfombra, etc.de ots.mat.textiles, s/aterciopelar n/conf.',57,5702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570291,'Tapetes e outros revestimentos para pavimentos, de lã ou pêlos finos, não aveludados, confeccionados','Carpets and other floor coverings, of wool or fine animal hair, woven, not tufted or flocked, not of pile construction, made up (excl. Kelem, Schumacks, Karamanie and similar hand-woven rugs)','Alfombras y demás revestimientos para el suelo, de lana o pelo fino, tejidos, distintos de los de pelo insertado y los flocados, sin aterciopelar, confeccionados (exc. alfombras llam. "Kelim" o "Kilim", "Schumaks" o "Soumak", "Karamanie" y alfombras simil',57,5702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570292,'Tapetes e outros revestimentos para pavimentos, de matérias têxteis sintéticas ou artificiais, não aveludados, confeccionados','Carpets and other floor coverings, of man-made textile materials, woven, not tufted or flocked, not of pile construction, made up (excl. Kelem, Schumacks, Karamanie and similar hand-woven rugs)','Alfombras y demás revestimientos para el suelo, de materia textil sintética o artificial, tejidas, distintos de los de pelo insertado y los flocados, sin aterciopelar, confeccionados (exc. alfombras llam. "Kelim" o "Kilim", "Schumaks" o "Soumak", "Karaman',57,5702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570299,'Tapetes e outros revestimentos para pavimentos, de outras matérias têxteis, não aveludados, confeccionados','Carpets and other floor coverings, of vegetable textile materials or coarse animal hair, woven, not tufted or flocked, not of pile construction, made up (excl. Kelem, Schumacks, Karamanie and similar hand-woven rugs, and floor coverings of coconut fibres ','Alfombras y demás revestimientos para el suelo, de materia textil vegetal o de pelo ordinario, tejidos, distintos de los de pelo insertado y los flocados, sin aterciopelar, confeccionados (exc. alfombras llam. "Kelim" o "Kilim", "Schumaks" o "Soumak", "Ka',57,5702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570310,'Tapetes e outros revestimentos para pavimentos, de lã ou pêlos finos, tufados, mesmo confeccionados','Carpets and other floor coverings, of wool or fine animal hair, tufted needle punched, whether or not made up','Alfombras y demás revestimientos para el suelo, de lana o pelo fino, con pelo insertado, aunque estén confeccionados',57,5703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570320,'Tapetes e outros revestimentos para pavimentos, de náilon ou de outras poliamidas, tufados, mesmo confeccionados','Carpets and other floor coverings, of nylon or other polyamides, tufted needle punched, whether or not made up','Alfombras y demás revestimientos para el suelo, de nailon o demás poliamidas, con pelo insertado, aunque estén confeccionados',57,5703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570330,'Tapetes e outros revestimentos para pavimentos, de outras matérias têxteis sintéticas ou artificiais, tufados, mesmo confeccionados','Carpets and other floor coverings, of man-made textile materials, tufted needle punched, whether or not made up (excl. those of nylon or other polyamides)','Alfombras y demás revestimientos para el suelo, de materia textil sintética o artificial, con pelo insertado, aunque estén confeccionados (exc. de nailon o demás poliamidas)',57,5703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570390,'Tapetes e outros revestimentos para pavimentos, de outras matérias têxteis, tufados, mesmo confeccionados','Carpet tiles of vegetable textile materials or coarse animal hair, tufted needle punched, whether or not made up','Alfombras y demás revestimientos para el suelo, de materia textile vegetal o de pelo ordinario, con pelo insertado, aunque estén confeccionados',57,5703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570410,'Ladrilhos de feltro, para revestimentos de pavimentos, de superfície <= 0,3 m2','Floor tiles, of felt, not tufted or flocked, with an area of <= 0,3 m²','Losas para el suelo, de fieltro, distintas de las de pelo insertado y las flocadas, con una superficie <= 0,3 m²',57,5704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570490,'Outros tapetes e revestimentos para pavimentos, de feltro','Carpets and other floor coverings, of felt, not tufted or flocked, whether or not made up (excl. floor tiles with an area of <= 0,3 m²)','Alfombras y demás revestimientos para el suelo, de fieltro, distintos de los de pelo insertado y los flocados, aunque estén confeccionados (exc. losas para el suelo con una superficie <= 0,3 m²)',57,5704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (570500,'Outros tapetes e revestimentos para pavimentos, de matérias têxteis','Carpets and other textile floor coverings, whether or not made up (excl. knotted, woven or tufted needle punched, and of felt)','Alfombras y demás revestimientos para el suelo, de materia textil, aunque estén confeccionados (exc. tejidos o con pelo insertado)',57,5705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580110,'Veludos e pelúcias, tecidos, de lã ou de pêlos finos','Woven pile fabrics and chenille fabrics, of wool or fine animal hair (excl. terry towelling and similar woven terry fabrics, tufted textile fabrics and narrow woven fabrics of heading 5806)','Terciopelo y felpa y tejidos de chenilla, de lana o pelo fino (exc. los de punto y tejidos con bucles para toallas, superficies textiles con pelo insertado y cintas de la partida 5806)',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580121,'Veludos e pelúcias, tecidos, de algodão, obtidos por trama, não cortados','Uncut weft pile fabrics, of cotton (excl. terry towelling and similar woven terry fabrics, tufted textile fabrics and narrow woven fabrics of heading 5806)','Terciopelo y felpa por trama, sin cortar, de algodón (exc. los de punto y tejidos con bucles para toallas, superficies textiles con pelo insertado y cintas de la partida 5806)',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580122,'Veludos e pelúcias, tecidos, de algodão, obtidos por trama, cortados, canelados (côtelés)','Cut corduroy, of cotton (excl. terry towelling and similar woven terry fabrics, tufted textile fabrics and narrow woven fabrics of heading 5806)','Terciopelo y felpa por trama, cortados, rayados "pana rayada" ["corduroy"], de algodón (exc. los de punto y tejidos con bucles para toallas, superficies textiles con pelo insertado y cintas de la partida 5806)',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580123,'Outros veludos e pelúcias, tecidos, de algodão, obtidos por trama','Cut weft pile fabrics, of cotton (excl. terry towelling and similar woven terry fabrics, tufted textile fabrics and narrow woven fabrics of heading 5806)','Terciopelo y felpa por trama, cortados, de algodón (exc. los de punto y tejidos con bucles para toallas, superficies textiles con pelo insertado y cintas de la partida 5806)',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580124,'Veludos e pelúcias, tecidos, de algodão, obtidos por urdidura, não cortados (''epinglés)','Uncut warp pile fabrics épinglé, of cotton (excl. terry towelling and similar woven terry fabrics, tufted textile fabrics and narrow woven fabrics of heading 5806)','Terciopelo y felpa por urdimbre, sin cortar "rizados", de algodón (exc. los de punto y tejidos con bucles para toallas, superficies textiles con pelo insertado y cintas de la partida 5806)',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580125,'Veludos e pelúcias, tecidos, de algodão, obtidos por urdidura, cortados','Cut warp pile fabrics, of cotton (excl. terry towelling and similar woven terry fabrics, tufted textile fabrics and narrow woven fabrics of heading 5806)','Terciopelo y felpa por urdimbre, cortados, de algodón (exc. los de punto y tejidos con bucles para toallas, superficies textiles con pelo insertado y cintas de la partida 5806)',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580126,'Tecidos de froco (chenille), de algodão','Chenille fabrics, of cotton (excl. terry towelling and similar woven terry fabrics, tufted textile fabrics and narrow woven fabrics of heading 5806)','Tejidos de chenilla, de algodón (exc. los de punto y tejidos con bucles para toallas, superficies textiles con pelo insertado y cintas de la partida 5806)',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580127,'veludos e pelucias obtidos por urdi.,de algodão','veludos e pelucias obtidos por urdi.,de algodao','veludos e pelucias obtidos por urdi.,de algodao',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580131,'Veludos e pelúcias, tecidos, de fibras sintéticas ou artificiais, obtidos por trama, não cortados','Uncut weft pile fabrics, of man-made fibres (excl. terry towelling and similar woven terry fabrics, tufted textile fabrics and narrow woven fabrics of heading 5806)','Terciopelo y felpa por trama, sin cortar, de fibras sintéticas o artificiales (exc. los de punto y tejidos con bucles para toallas, superficies textiles con pelo insertado y cintas de la partida 5806)',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580132,'Veludos e pelúcias, tecidos, de fibras sintéticas ou artificiais, obtidos por trama, cortados, canelados (côtelés)','Cut corduroy, of man-made fibres (excl. terry towelling and similar woven terry fabrics, tufted textile fabrics and narrow woven fabrics of heading 5806)','Terciopelo y felpa por trama, cortados, rayados "pana rayada" ["corduroy"], de fibras sintéticas o artificiales (exc. los de punto y tejidos con bucles para toallas, superficies textiles con pelo insertado y cintas de la partida 5806)',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580133,'Outros veludos e pelúcias, tecidos, de fibras sintéticas ou artificiais, obtidos por trama, cortados','Cut weft pile fabrics, of man-made fibres (excl. terry towelling and similar woven terry fabrics, tufted textile fabrics and narrow woven fabrics of heading 5806)','Terciopelo y felpa por trama, cortados, de fibras sintéticas o artificiales (exc. los de punto y tejidos con bucles para toallas, superficies textiles con pelo insertado y cintas de la partida 5806)',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580134,'Veludos e pelúcias, tecidos, de fibras sintéticas ou artificiais, obtidos por urdidura, não cortados (épinglés)','Uncut warp pile fabrics épinglé, of man-made fibres (excl. terry towelling and similar woven terry fabrics, tufted textile fabrics and narrow woven fabrics of heading 5806)','Terciopelo y felpa por urdimbre, sin cortar "rizados", de fibras sintéticas o artificiales (exc. los de punto y tejidos con bucles para toallas, superficies textiles con pelo insertado y cintas de la partida 5806)',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580135,'Veludos e pelúcias, tecidos, de fibras sintéticas ou artificiais, obtidos por urdidura, cortados','Cut warp pile fabrics, of man-made fibres (excl. terry towelling and similar woven terry fabrics, tufted textile fabrics and narrow woven fabrics of heading 5806)','Terciopelo y felpa por urdimbre, cortados, de fibras sintéticas o artificiales (exc. los de punto y tejidos con bucles para toallas, superficies textiles con pelo insertado y cintas de la partida 5806)',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580136,'Tecidos de froco (chenille) de fibras sintéticas ou artificiais','Chenille fabrics, of man-made fibres (excl. terry towelling and similar woven terry fabrics, tufted textile fabrics and narrow woven fabrics of heading 5806)','Tejidos de chenilla, de fibras sintéticas o artificiales (exc. los de punto y tejidos con bucles para toallas, superficies textiles con pelo insertado y cintas de la partida 5806)',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580137,'Veludos e pelucias obtidos por urdi.,de fib.sin ou art.','Veludos e pelucias obtidos por urdi.,de fib.sin ou art.','Veludos e pelucias obtidos por urdi.,de fib.sin ou art.',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580190,'Veludos e pelúcias, tecidos, de outras matérias têxteis','Woven pile fabrics and chenille fabrics (excl. those of man-made fibres, wool or fine animal hair, terry towelling and similar woven terry fabrics, tufted textile fabrics and narrow woven fabrics of heading 5806)','Terciopelo y felpa y tejidos de chenilla (exc. de fibras sintéticas o artificiales, de lana o pelo fino, así como los de punto, con bucles para toallas, superficies textiles con pelo insertado y cintas de la partida 5806)',58,5801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580211,'Tecidos atoalhados, de algodão, crus','Terry towelling and similar woven terry fabrics, of cotton, unbleached (excl. narrow woven fabrics of heading 5806, carpets and other floor coverings)','Tejidos con bucles del tipo toalla, de algodón, crudos (exc. cintas de la partida 5806, así como alfombras y demás revestimientos para el suelo)',58,5802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580219,'Outros tecidos atoalhados, de algodão','Terry towelling and similar woven terry fabrics, of cotton (excl. unbleached, narrow woven fabrics of heading 5806, carpets and other floor coverings)','Tejidos con bucles del tipo toalla, de algodón (exc. crudos, así como cintas de la partida 5806 y alfombras y demás revestimientos para el suelo)',58,5802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580220,'Tecidos atoalhados, de outras matérias têxteis','Terry towelling and similar woven terry fabrics (excl. those of cotton, narrow woven fabrics of heading 5806, carpets and other floor coverings)','Tejidos con bucles del tipo toalla (exc. de algodón, así como cintas de la partida 5806 y alfombras y demás revestimientos para el suelo)',58,5802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580230,'Tecidos tufados','Tufted textile fabrics (excl. carpets and other floor coverings)','Superficies textiles con mechón insertado (exc. alfombras y demás revestimientos para el suelo)',58,5802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580300,'Tecidos em ponto de gaze, exceto os artefatos da posição 58.06.','Gauze (excl. narrow woven fabrics of heading 5806)','Tejidos de gasa de vuelta (excepto los productos de la partida 5806)',58,5803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580310,'Tecido de algodão, em ponto de gaze','Fabric of cotton, in point of gauze','Tejido de algodón, de gasa de vuelta',58,5803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580390,'Tecido de outras matérias têxteis, em ponto de gaze','Fabric of other textile materials, in point of gauze','Tejido de otras materias textiles, de gasa de vuelta',58,5803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580410,'Tules, filó e tecidos de malhas com nós','Tulles and other net fabrics (excl. woven, knitted or crocheted fabrics)','Tules, tules-bobinot y tejidos de mallas anudadas',58,5804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580421,'Rendas de fibras sintéticas ou artificiais, de fabricação mecânica','Mechanically made lace of man-made fibres in the piece, in strips or in motifs (excl. fabrics of heading 6002 to 6006)','Encajes en pieza, en tiras o en aplicaciones, fabricados a máquina, de fibras sintéticas o artificiales (exc. productos de las partidas 6002 a 6006)',58,5804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580429,'Rendas de outras matérias têxteis, de fabricação mecânica','Mechanically made lace in the piece, in strips or in motifs (excl. that of man-made fibres and fabrics of heading 6002 to 6006)','Encajes en pieza, en tiras o en aplicaciones, fabricados a máquina (exc. de fibras sintéticas o artificiales, así como los productos de las partidas 6002 a 6006)',58,5804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580430,'Rendas de fabricação manual','Handmade lace in the piece, in strips or in motifs (excl. fabrics of heading 6002 to 6006)','Encajes en pieza, en tiras o en aplicaciones, hechos a mano (exc. productos de las partidas 6002 a 6006)',58,5804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580500,'Tapeçarias tecidas à mão (gêneros gobelino, flandres, aubusson e semelhantes) e feitas à agulha (em petit point, ponto de cruz)','Hand-woven tapestries of the type Gobelin, Flanders, Aubusson, Beauvais and the like, and needle-worked tapestries, e.g. petit point, cross-stitch, whether or not made up (excl. Kelem, Schumacks, Karamanie and the like, and tapestries > 100 years old)','Gobelinos, Flandes, "Aubusson", "Beauvois" y demás tapicería tejida a mano, así como tapicería de "petit point", de punto de cruz y demás tapicería de aguja, incl. confeccionadas (exc. alfombras llam. "Kelim" o "Kilim", "Schumaks" o "Soumak", "Karamanie" ',58,5805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580610,'Fitas de veludo, de pelúcia, de tecidos de froco (chenille) ou atoalhados','Narrow woven pile fabrics, incl. terry towelling and similar terry fabrics, and chenille fabrics, with a width of <= 30 cm (excl. labels, badges and similar articles)','Cintas de terciopelo, de felpa, de tejidos de chenilla o de tejidos con bucles para toallas (exc. etiquetas, escudos y artículos simil.)',58,5806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580620,'Outras fitas, contendo, em peso, => 5% de fios de elastômeros ou de fios de borracha','Narrow woven fabrics of textile materials, containing >= 5% elastomeric yarn or rubber thread by weight, with a width of <= 30 cm (excl. woven pile fabrics, incl. terry towelling and similar terry fabrics, chenille fabrics, and labels, badges and similar ','Cintas de materia textil, tejidas, con un contenido de hilos de elastómeros o de hilos de caucho >= 5% en peso (exc. cintas de terciopelo, de felpa, de tejidos de chenilla o de tejidos con bucles para toallas y etiquetas, escudos y artículos simil.)',58,5806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580631,'Outras fitas de algodão','Narrow woven fabrics of cotton, with a width of <= 30 cm, n.e.s.','Cintas de algodón, tejidas, n.c.o.p.',58,5806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580632,'Outras fitas de fibras sintéticas ou artificiais','Narrow woven fabrics of man-made fibres, with a width of <= 30 cm, n.e.s.','Cintas de fibras sintéticas o artificiales, tejidas, n.c.o.p.',58,5806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580639,'Fitas de outras matérias têxteis','Narrow woven fabrics of textile materials other than cotton or man-made fibres, with a width of <= 30 cm, n.e.s.','Cintas de materia textil distintas del algodón o de las fibras sintéticas o artificiales, tejidas, n.c.o.p.',58,5806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580640,'Fitas sem trama, de fios ou fibras paralelizados e colados (bolducs)','Narrow fabrics consisting of warp without weft assembled by means of an adhesive bolducs, with a width of <= 30 cm','Cintas sin trama, de hilados o fibras paralelizados y aglutinados',58,5806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580710,'Etiquetas, emblemas e artefatos semelhantes, de matérias têxteis, não bordados, tecidos','Labels, badges and similar articles, of textile materials, in the piece, in strips or cut to shape or size, woven, not embroidered','Etiquetas, escudos y artículos simil., de materia textil, en pieza, en cintas o recortados, tejidos, sin bordar',58,5807);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580790,'Outras etiquetas, emblemas e artefatos semelhantes, de matérias têxteis, não bordados','Labels, badges and similar articles, of textile materials, in the piece, in strips or cut to shape or size, not embroidered (excl. woven)','Etiquetas, escudos y artículos simil., de materia textil, en pieza, en cintas o recortados, sin bordar (exc. tejidos)',58,5807);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580810,'Entrançados em peças','Braids in the piece','Trenzas de materis textil, en pieza',58,5808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580890,'Outros artigos de passamanaria e ornamentais análogos; borlas, pompons e artigos semelhantes','Ornamental trimmings of textile materials, in the piece, not embroidered, other than knitted or crocheted; tassels, pompons and similar articles of textile materials (excl. braids in the piece)','Artículos de pasamanería y ornamentales análogos, de materia textil, en pieza, sin bordar (exc. los de punto); bellotas, madroños, pompones, borlas y artículos simil., de materia textil (exc. trenzas en pieza)',58,5808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (580900,'Tecidos de fios de metal ou de fios têxteis metalizados da posição 5605, para vestuário, guarnição de interiores ou usos semelhantes','Woven fabrics of metal thread and woven fabrics of metallised yarn of heading 5605, of a kind used in apparel, as furnishing fabrics or for similar purposes, n.e.s.','Tejidos de hilos de metal y tejidos de hilados metálicos o de hilados textiles metalizados de la partida 5605, de los tipos utilizados para prendas de vestir, tapicería o usos simil., n.c.o.p.',58,5809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (581010,'Bordados químicos ou aéreos e bordados com fundo recortado','Embroidery on a textile fabric ground without visible ground, in the piece, in strips or in motifs','Bordados químicos o aéreos sobre materia textil y bordados con fondo recortado, en pieza, tiras o motivos',58,5810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (581091,'Outros bordados de algodão, em peca, em tiras ou em motivos','Embroidery of cotton on a textile fabric ground, in the piece, in strips or in motifs (excl. embroidery without visible ground)','Bordados de algodón, sobre materia textil, en pieza, tiras o motivos (exc. bordados químicos o aéreos y bordados con fondo recortado)',58,5810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (581092,'Outros bordados de fibras sintéticas ou artificiais, em peça, em tiras ou em motivos','Embroidery of man-made fibres on a textile fabric base, in the piece, in strips or in motifs (excl. embroidery without visible ground)','Bordados de fibras sintéticas o artificiales, sobre materia textil, en pieza, tiras o motivos (exc. bordados químicos o aéreos y bordados con fondo recortado)',58,5810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (581099,'Bordados de outras matérias têxteis, em peça, em tiras ou em motivos','Embroidery of materials other than cotton or man-made fibres, on a textile fabric base, in the piece, in strips or in motifs (excl. embroidery without visible ground)','Bordados distintos de los de algodón o de fibras sintéticas o artificiales, sobre materia textil, en pieza, tiras o motivos (exc. bordados químicos o aéreos y bordados con fondo recortado)',58,5810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (581100,'Artefatos têxteis matelassês em peça, constituídos por uma ou várias camadas têxteis associadas a uma matéria de enchimento','Quilted textile products in the piece, composed of one or more layers of textile materials assembled with padding by stitching or otherwise (excl. embroidery of heading 5810 and quilted fabrics for bedding and furnishings)','Productos textiles acolchados en pieza, constituidos por una o varias capas de materia textil combinadas con una materia de relleno y mantenidas mediante puntadas u otra forma de sujeción (exc. bordados de la partida 5810, así como ropa de cama y artículo',58,5811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590110,'Tecidos revestidos de cola ou de matérias amiláceas, para encadernação, cartonagem e usos semelhantes','Textile fabrics coated with gum or amylaceous substances, of a kind used for the outer covers of books, the manufacture of boxes and articles of cardboard or the like','Telas recubiertas de cola o materias amiláceas, de los tipos utilizados para la encuadernación, cartonaje, estuchería o usos simil.',59,5901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590190,'Telas para decalque, telas transparentes para desenho, telas preparadas para pintura, entretelas do tipo utilizado em chapéus e para usos semelhantes','Tracing cloth; prepared painting canvas; buckram and similar stiffened textile fabrics of a kind used for hat foundations (excl. plastic-coated textile fabrics)','Transparentes textiles para calcar o dibujar; lienzos preparados para pintar; bucarán y telas rígidas simil. de los tipos utilizados en sombrerería (exc. tejidos recubiertos con plástico)',59,5901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590210,'Telas para pneumáticos com fios de alta tenacidade, de náilon ou de outras poliamidas','Tyre cord fabric of high-tenacity yarn of nylon or other polyamides, whether or not dipped or impregnated with rubber or plastic','Napas tramadas para neumáticos fabricadas con hilados de alta tenacidad de nailon o demás poliamidas, incl. adherizadas o impregnadas de caucho o plástico',59,5902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590220,'Telas para pneumáticos com fios de alta tenacidade, de poliésteres','Tyre cord fabric of high-tenacity polyester yarn, whether or not dipped or impregnated with rubber or plastic','Napas tramadas para neumáticos fabricadas con hilados de alta tenacidad de poliésteres, incl. adherizadas o impregnadas de caucho o plástico',59,5902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590290,'Outras telas para pneumáticos com fios de alta tenacidade, de raiom viscose','Tyre cord fabric of high-tenacity viscose rayon yarn, whether or not dipped in rubber or plastic','Napas tramadas para neumáticos fabricadas con hilados de alta tenacidad de rayón viscosa, incl. adherizadas o impregnadas de caucho o plástico',59,5902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590310,'Tecidos impregnados, revestidos, recobertos ou estratificados com policloreto de vinila','Textile fabrics impregnated, coated, covered or laminated with polyvinyl chloride (excl. wallcoverings of textile materials impregnated or covered with polyvinyl chloride; floor coverings consisting of a textile backing and a top layer or covering of poly','Telas impregnadas, recubiertas, revestidas o estratificadas con poli"cloruro de vinilo" (exc. revestimientas de materia textil para paredes, impregnadas o revestidas de poli"cloruro de vinilo"; revestimientas para suelos con una base de materia textil con',59,5903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590320,'Tecidos impregnados, revestidos, recobertos ou estratificados com poliuretano','Textile fabrics impregnated, coated, covered or laminated with polyurethane (excl. wallcoverings of textile materials impregnated or covered with polyurethane; floor coverings consisting of a textile backing and a top layer or covering of polyurethane)','Telas impregnadas, recubiertas, revestidas o estratificadas con poliuretano (exc. revestimientas de materia textil para paredes, impregnadas o revestidas de poliuretano; revestimientas para suelos con una base de materia textil con un recubrimiento o reve',59,5903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590390,'Outros tecidos impregnados, revestidos, recobertos ou estratificados com plásticos','Textile fabrics impregnated, coated, covered or laminated with plastics other than polyvinyl chloride or polyurethane (excl. tyre cord fabric of high-tenacity yarn of nylon or other polyamides, polyesters or viscose rayon; wallcoverings of textile materia','Telas impregnadas, recubiertas, revestidas o estratificadas con plástico distinto del poli"cloruro de vinilo" y del poliuretano (exc. napas tramadas para neumáticos fabricadas con hilados de alta tenacidad de nailon o demás poliamidas, de poliésteres o de',59,5903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590410,'Linóleos, mesmo recortados','Linoleum, whether or not cut to shape','Linóleo, incl. cortado',59,5904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590490,'Revestimentos para pavimentos constituídos por um induto ou recobrimento aplicado sobre suporte têxtil, mesmo recortados','Floor coverings consisting of a coating or covering applied on a textile backing, whether or not cut to shape (excl. linoleum)','Revestimientos para el suelo formados por un recubrimiento o revestimiento aplicado sobre un soporte textil, incl. cortados (exc. linóleo)',59,5904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590491,'revestim.p/pavim.c/suporte feltro agulhado/falso tecido','floor coverings with support holed felt/false fabric','revestim.p/suelo, c/sop.fieltro punzonado/tela s/tejer',59,5904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590492,'revestim.p/pavim.c/outros suportes têxteis','floor coverings with other textile support','revestim.p/suelo, c/otros soportes textiles',59,5904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590500,'Revestimentos para paredes, de matérias têxteis','Textile wallcoverings','Revestimientos de materia textil para paredes',59,5905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590610,'Fitas adesivas de largura <= 20 cm','Adhesive tape of rubberised textile fabrics, of a width of <= 20 cm (excl. that impregnated or coated with pharmaceutical substances or put up for retail sale for medical, surgical, dental or veterinary purposes)','Cintas adhesivas de tejidos cauchutados, de anchura <= 20 cm (exc. impregnadas o recubiertas de sustancias farmacéuticas o acondicionadas para la venta al por menor con fines médicos, quirúrgicos, odontológicos o veterinarios)',59,5906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590691,'Tecidos de malha, com borracha','Knitted or crocheted textile fabrics, rubberised, n.e.s.','Telas de punto, cauchutadas, n.c.o.p.',59,5906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590699,'Outros tecidos com borracha','Rubberised textile fabrics (excl. knitted or crocheted textile fabrics, adhesive tape of a width of <= 20 cm, and tyre cord fabric of high-tenacity yarn of nylon or other polyamides, polyesters or viscose rayon)','Telas cauchutadas, n.c.o.p. (exc. telas de punto, de punto y cintas adhesivas de anchura <= 20 cm, y napas tramadas para neumáticos fabricadas con hilados de alta tenacidad de nailon o demás poliamidas, de poliésteres o de rayón viscosa)',59,5906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590700,'Outros tecidos impregnados, revestidos ou recobertos; telas pintadas para cenários ou usos semelhantes','Impregnated, coated or covered textile fabrics; painted canvas being theatrical scenery, studio backcloths or the like, n.e.s.','Telas impregnadas, recubiertas o revestidas, así como lienzos pintados para decoraciones de teatro, fondos de estudio o usos análogos, n.c.o.p.',59,5907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590800,'Mechas de matérias têxteis, tecidas, entrançadas ou tricotadas, para candeeiros, velas e semelhantes','Textile wicks, woven, plaited or knitted, for lamps, stoves, lighters, candles or the like; incandescent gas mantles and tubular knitted gas-mantle fabric for incandescent gas mantles, whether or not impregnated (excl. wax-covered wicks of the taper varie','Mechas de materia textil tejida, trenzada o de punto (exc. croché o ganchillo), para lámparas, hornillos, mecheros, velas o simil.; manguitos de incandescencia y tejidos de punto (exc. croché o ganchillo) tubulares utilizados para su fabricación, incl. im',59,5908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (590900,'Mangueiras e tubos semelhantes, de matérias têxteis','Textile hosepiping and similar textile tubing, whether or not impregnated or coated, with or without lining, armour or accessories of other materials','Mangueras para bombas y tubos simil., de materia textil, incl. impregnadas o recubiertas y con armaduras o accesorios de otras materias',59,5909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (591000,'Correias transportadoras ou de transmissão, de matérias têxteis, mesmo impregnadas, revestidas ou recobertas de outras matérias','Transmission or conveyor belts or belting, of textile material, whether or not impregnated, coated, covered or laminated with plastics, or reinforced with metal or other material (excl. those of a thickness of < 3 mm and of indeterminate length or cut to ','Correas transportadoras o de transmisión, de materia textil, incl. impregnadas, recubiertas, revestidas o estratificadas con plástico o reforzadas con metal u otra materia (exc. de espesor < 3 mm, de longitud indeterminada o cortadas solo en determinadas ',59,5910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (591110,'Tecidos, feltros e tecidos forrados de feltro, combinados com camadas de borracha, utilizados na fabricação de guarnições de cardas e produtos análogos','Textile fabrics, felt and felt-lined woven fabrics, coated, covered or laminated with rubber, leather or other material, of a kind used for card clothing, and similar fabrics of a kind used for other technical purposes, incl. narrow fabrics made of velvet','Tela, fieltro y tejidos forrados de fieltro, combinados con una o varias capas de caucho, cuero u otra materia, de los tipos utilizados para la fabricación de guarniciones de cardas y productos análogos para otros usos técnicos, incl. las cintas de tercio',59,5911);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (591120,'Gazes e telas para peneirar, mesmo confeccionadas','Bolting cloth, whether or not made up','Gasas y tela para cerner, incl. confeccionadas',59,5911);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (591131,'Tecidos e feltros sem fim, utilizados em máquinas para fabricação de papel, de peso < 650 g/m2','Textile fabrics and felts, endless or fitted with linking devices, of a kind used in papermaking or similar machines, e.g. for paper pulp or asbestos-cement, weighing < 650 g/m²','Tela y fieltro sin fin o con dispositivos de unión, de los tipos utilizados en las máquinas para fabricar papel o en máquinas simil., p.ej. para pasta de papel o para amiantocemento, de peso < 650 g/m²',59,5911);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (591132,'Tecidos e feltros sem fim, utilizados em máquinas para fabricação de papel, de peso => 650 g/m2','Textile fabrics and felts, endless or fitted with linking devices, of a kind used in papermaking or similar machines, e.g. for paper pulp or asbestos-cement, weighing >= 650 g/m²','Tela y fieltro sin fin o con dispositivos de unión, de los tipos utilizados en las máquinas para fabricar papel o en máquinas simil., p.ej. para pasta de papel o para amiantocemento, de peso >= 650 g/m²',59,5911);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (591140,'Tecidos filtrantes (étreindelles) e espessos, utilizados em prensas de óleo e outros usos técnicos análogos','Straining cloth of a kind used in oil-presses or for similar technical purposes, incl. that of human hair','Capachos y telas gruesas de los tipos utilizados en las prensas de aceite o para usos técnicos análogos, incl. los de cabello',59,5911);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (591190,'Outros produtos e artefatos, de matérias têxteis, para usos técnicos','Textile products and articles, for technical purposes, specified in Note 7 to chapter 59, n.e.s.','Productos y artículos textiles para usos técnicos mencionados en la nota 7 del capítulo 59, n.c.o.p.',59,5911);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600110,'Tecidos denominados de felpa longa ou pêlo comprido','Long pile fabrics, knitted or crocheted','Tejidos de punto "de pelo largo"',60,6001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600121,'Tecidos atoalhados, de malha de algodão','Looped pile fabrics of cotton, knitted or crocheted','Tejidos con bucles, de punto, de algodón',60,6001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600122,'Tecidos atoalhados, de malha de fibras sintéticas ou artificiais','Looped pile fabrics of man-made fibres, knitted or crocheted','Tejidos con bucles, de punto, de fibras sintéticas o artificiales',60,6001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600129,'Tecidos atoalhados, de malha de outras matérias têxteis','Looped pile fabrics, knitted or crocheted (excl. of cotton or man-made fibres)','Tejidos con bucles, de punto (exc. de algodón o de fibras sintéticas o artificiales)',60,6001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600191,'Outros veludos e pelúcias, de malha de algodão','Pile fabrics of cotton, knitted or crocheted (excl. long pile fabrics)','Terciopelo y felpa, de punto, de algodón (exc. los tejidos "de pelo largo")',60,6001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600192,'Outros veludos e pelúcias, de malha de fibras sintéticas ou artificiais','Pile fabrics of man-made fibres, knitted or crocheted (excl. long pile fabrics)','Terciopelo y felpa, de punto, de fibras sintéticas o artificiales (exc. los tejidos "de pelo largo")',60,6001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600199,'Veludos e pelúcias, de malha de outras matérias têxteis','Pile fabrics, knitted or crocheted (excl. cotton or man-made fibres and long pile fabrics)','Terciopelo y felpa, de punto (exc. de algodón o de fibras sintéticas o artificiales, así como los tejidos "de pelo largo")',60,6001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600210,'Tecidos de malha de largura não superior a 30cm','Knitted or crocheted fabrics of a width not exceeding 30cm','Tejidos de punto o de punto de anchura inferior o igual a 30 cm',60,6002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600220,'Tecidos de malha de largura não superior a 30cm','Knitted or crocheted fabrics of a width not exceeding 30cm','Tejidos de punto o de punto de anchura inferior o igual a 30 cm',60,6002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600230,'Tecidos de malhas contendo elastômeros, largura maior que 30cm','Knitted or crocheted fabrics containing elastomers, width greater than 30cm','ejidos de mallas que contengan elastómeros, una anchura superior a 30 cm',60,6002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600240,'Tecidos de malha de largura <= 30 cm, contendo em peso => 5% fios de elastômeros, mas não contendo fios de borracha','Knitted or crocheted fabrics, of a width of <= 30 cm, containing >= 5% by weight elastomeric yarn (excl. containing rubber thread, pile fabrics, incl. long pile, looped pile fabrics, labels, badges and similar articles, and knitted or crocheted fabrics, i','Tejidos de punto, de anchura <= 30 cm, con un contenido de hilados de elastómeros >= 5% en peso (exc. con hilos de caucho; terciopelo, felpa, incl. los tejidos "de pelo largo", y tejidos con bucles, de punto; etiquetas, escudos y artículos similares, así ',60,6002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600241,'Tecido de malha-urdidura de la ou de pêlos finos','Mesh-warp fabric of wool or fine animal hair','Tejido de punto por urdimbre de lana o de pelo fino',60,6002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600242,'Tecido de malha-urdidura de algodão','Mesh-warp fabric of cotton','Tejido de punto por urdimbre de algodón',60,6002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600243,'Tecido de malha-urdidura, de fibra sintética/artificial','Mesh-warp fabric of synthetic/artificial fibre','Tejido de punto por urdimbre de fibra sintética/artif',60,6002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600249,'Tecido de malha-urdidura de outras matérias têxteis','Mesh-warp fabric of other textile materials','Tejido de punto por urdimbre de ots.materias textiles',60,6002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600290,'Outros tecidos de malha de largura <= 30 cm, contendo em peso => 5% fios de elastômeros ou de borracha','Knitted or crocheted fabrics, of a width of <= 30 cm, containing >= 5% by weight elastomeric yarn and rubber thread or rubber thread only (excl. pile fabrics, incl. long pile, looped pile fabrics, labels, badges and similar articles, knitted or crocheted ','Tejidos de punto, de anchura <= 30 cm, con un contenido de hilados de elastómeros y de hilos de caucho o solamente de hilos de caucho >= 5% en peso (exc. terciopelo, felpa, incl. los tejidos "de pelo largo", y tejidos con bucles, de punto; etiquetas, escu',60,6002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600291,'Outros tecidos de malha de lã ou de pêlos finos','Other mesh-warp fabric of wool or fine animal hair','Otros tejidos de punto de lana o de pelos finos',60,6002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600292,'Outros tecidos de malha de algodão','Other fabrics of cotton mesh','Otros tejidos de punto de algodón',60,6002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600293,'Outros tecidos de malha de fibras sintet/artificiais','Other fabrics of fibres mesh synt/artif','Otros tejidos de punto de fibras sintét/artificiales',60,6002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600299,'Outros tecidos de malha de outros matérias têxteis','Other fabrics of mesh of other textile materials','Otros tejidos de punto de otras materias textiles',60,6002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600310,'Tecidos de malha de lã ou de pêlos finos, de largura <= 30 cm','Knitted or crocheted fabrics of wool or fine animal hair, of a width of <= 30 cm (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pile fabrics, labels, badges and similar articles, an','Tejidos de punto, de anchura <= 30 cm, de lana o pelo fino (exc. con un contenido de hilados de elastómeros o de hilos de caucho >= 5% en peso; terciopelo, felpa, incl. los tejidos "de pelo largo", y tejidos con bucles, de punto; etiquetas, escudos y artí',60,6003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600320,'Tecidos de malha de algodão, de largura <= 30 cm','Knitted or crocheted fabrics of cotton, of a width of <= 30 cm (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pile fabrics, labels, badges and similar articles, and knitted or croch','Tejidos de punto, de anchura <= 30 cm, de algodón (exc. con un contenido de hilados de elastómeros o de hilos de caucho >= 5% en peso; terciopelo, felpa, incl. los tejidos "de pelo largo", y tejidos con bucles, de punto; etiquetas, escudos y artículos sim',60,6003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600330,'Tecidos de malha de fibras sintéticas, de largura <= 30 cm','Knitted or crocheted fabrics of synthetic fibres, of a width of <= 30 cm (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pile fabrics, labels, badges and similar articles, knitted or','Tejidos de punto, de anchura <= 30 cm, de fibras sintéticas (exc. con un contenido de hilados de elastómeros o de hilos de caucho >= 5% en peso; terciopelo, felpa, incl. los tejidos "de pelo largo", y tejidos con bucles, de punto; etiquetas, escudos y art',60,6003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600340,'Tecidos de malha de fibras artificiais, de largura <= 30 cm','Knitted or crocheted fabrics of artificial fibres, of a width of <= 30 cm (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pile fabrics, labels, badges and similar articles, knitted o','Tejidos de punto, de anchura <= 30 cm, de fibras artificiales (exc. con un contenido de hilados de elastómeros o de hilos de caucho >= 5% en peso; terciopelo, felpa, incl. los tejidos "de pelo largo", y tejidos con bucles, de punto; etiquetas, escudos y a',60,6003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600390,'Tecidos de outras matérias têxteis, de largura <= 30 cm','Knitted or crocheted fabrics of a width of <= 30 cm (excl. of cotton, man-made fibres, wool or fine animal hair, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pile fabrics, labels, badges','Tejidos de punto, de anchura <= 30 cm (exc. de lana o pelo fino, de algodón, de fibras sintéticas o de fibras artificiales; tejidos de punto con un contenido de hilados de elastómeros o de hilos de caucho >= 5% en peso; terciopelo, felpa, incl. los tejido',60,6003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600410,'Tecidos de malha, de largura > 30 cm, contendo em peso => 5% de fios de elastômeros, mas não contendo fios de borracha','Knitted or crocheted fabrics, of a width of > 30 cm, containing >= 5% by weight elastomeric yarn (excl. containing rubber thread, pile fabrics, incl. long pile, looped pile fabrics, labels, badges and similar articles, and knitted or crocheted fabrics, im','Tejidos de punto de anchura > 30 cm, con un contenido de hilados de elastómeros >= 5% en peso (exc. con hilos de caucho; terciopelo, felpa, incl. los tejidos "de pelo largo", y tejidos con bucles, de punto; etiquetas, escudos y artículos similares, así co',60,6004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600490,'Outros tecidos de malha, de largura > 30 cm, contendo em peso => 5% fios de elastômeros ou de borracha','Knitted or crocheted fabrics, of a width of > 30 cm, containing >= 5% by weight elastomeric yarn and rubber thread or rubber thread only (excl. pile fabrics, incl. long pile, looped pile fabrics, labels, badges and similar articles, and knitted or crochet','Tejidos de punto de anchura > 30 cm, con un contenido de hilados de elastómeros y de hilos de caucho o solamente de hilos de caucho >= 5% en peso (exc. terciopelo, felpa, incl. los tejidos "de pelo largo", y tejidos con bucles, de punto; etiquetas, escudo',60,6004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600510,'tecidos de malha-urdidura, de lã/pêlos finos','fabrics of warp mesh, of wool/fine animal hair','tejidos de punto por urdimbre, de lana/pelo fino',60,6005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600521,'Tecidos de malha-urdidura (incluídos os obtidos em teares para galões), de algodão, crus ou branqueados, de largura > 30 cm','Unbleached or bleached cotton warp knit fabrics incl. those made on galloon knitting machines, of a width of > 30 cm  (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pile fabrics, la','Tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería, de anchura > 30 cm, de algodón, crudos o blanqueados (exc. con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo, felpa, incl. los tejidos "de p',60,6005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600522,'Tecidos de malha-urdidura (incluídos os obtidos em teares para galões), de algodão, tingidos, de largura > 30 cm','Dyed cotton warp knit fabrics incl. those made on galloon knitting machines, of a width of > 30 cm  (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pile fabrics, labels, badges and s','Tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería, de anchura > 30 cm, de algodón, teñidos (exc. con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo, felpa, incl. los tejidos "de pelo largo", y',60,6005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600523,'Tecidos de malha-urdidura (incluídos os obtidos em teares para galões), de algodão, com fios de diversas cores, de largura > 30 cm','Cotton warp knit fabrics of yarns of different colours incl. those made on galloon knitting machines, of a width of > 30 cm  (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pile fabr','Tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería, de anchura > 30 cm, de algodón, con hilados de distintos colores (exc. con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo, felpa, incl. los t',60,6005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600524,'Tecidos de malha-urdidura (incluídos os obtidos em teares para galões), de algodão, estampados, de largura > 30 cm','Printed cotton warp knit fabrics incl. those made on galloon knitting machines, of a width of > 30 cm  (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pile fabrics, labels, badges an','Tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería, de anchura > 30 cm, de algodón, estampados (exc. con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo, felpa, incl. los tejidos "de pelo largo"',60,6005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600531,'Tecidos de malha-urdidura (incluídos os obtidos em teares para galões), de fibras sintéticas, crus ou branqueados, de largura > 30 cm','Unbleached or bleached warp knit fabrics of synthetic fibres incl. those made on galloon knitting machines, of a width of > 30 cm  (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pil','Tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería, de anchura > 30 cm, de fibras sintéticas, crudos o blanqueados (exc. con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo, felpa, incl. los tej',60,6005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600532,'Tecidos de malha-urdidura (incluídos os obtidos em teares para galões), de fibras sintéticas, tingidos, de largura > 30 cm','Dyed warp knit fabrics of synthetic fibres incl. those made on galloon knitting machines, of a width of > 30 cm  (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pile fabrics, labels,','Tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería, de anchura > 30 cm, de fibras sintéticas, teñidos (exc. con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo, felpa, incl. los tejidos "de pelo',60,6005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600533,'Tecidos de malha-urdidura (incluídos os obtidos em teares para galões), de fibras sintéticas, com fios de diversas cores, de largura > 30 cm','Warp knit fabrics of synthetic fibres, of yarns of different colours incl. those made on galloon knitting machines, of a width of > 30 cm  (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, lo','Tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería, de anchura > 30 cm, de fibras sintéticas, con hilados de distintos colores (exc. con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo, felpa, i',60,6005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600534,'Tecidos de malha-urdidura (incluídos os obtidos em teares para galões), de fibras sintéticas, estampados, de largura > 30 cm','Printed warp knit fabrics of synthetic fibres incl. those made on galloon knitting machines, of a width of > 30 cm  (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pile fabrics, labe','Tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería, de anchura > 30 cm, de fibras sintéticas, estampados (exc. con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo, felpa, incl. los tejidos "de p',60,6005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600541,'Tecidos de malha-urdidura (incluídos os obtidos em teares para galões), de fibras artificiais, crus ou branqueados, de largura > 30 cm','Unbleached or bleached warp knit fabrics of artificial fibres incl. those made on galloon knitting machines, of a width of > 30 cm  (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pi','Tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería, de anchura > 30 cm, de fibras artificiales, crudos o blanqueados (exc. con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo, felpa, incl. los t',60,6005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600542,'Tecidos de malha-urdidura (incluídos os obtidos em teares para galões), de fibras artificiais, tingidos, de largura > 30 cm','Dyed warp knit fabrics of artificial fibres incl. those made on galloon knitting machines, of a width of > 30 cm  (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pile fabrics, labels','Tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería, de anchura > 30 cm, de fibras artificiales, teñidos (exc. con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo, felpa, incl. los tejidos "de pe',60,6005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600543,'Tecidos de malha-urdidura (incluídos os obtidos em teares para galões), de fibras artificiais, com fios de diversas cores, de largura > 30 cm','Warp knit fabrics of artificial fibres, of yarns of different colours incl. those made on galloon knitting machines, of a width of > 30 cm  (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, l','Tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería, de anchura > 30 cm, de fibras artificiales, con hilados de distintos colores (exc. con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo, felpa,',60,6005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600544,'Tecidos de malha-urdidura (incluídos os obtidos em teares para galões), de fibras artificiais, estampados, de largura > 30 cm','Printed warp knit fabrics of artificial fibres incl. those made on galloon knitting machines, of a width of > 30 cm  (excl. those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pile fabrics, lab','Tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería, de anchura > 30 cm, de fibras artificiales, estampados (exc. con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo, felpa, incl. los tejidos "de',60,6005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600590,'Outros tecidos de malha-urdidura (incluídos os obtidos em teares para galões), de largura > 30 cm','Warp knit fabrics incl. those made on galloon knitting machines, of a width of > 30 cm (excl. of cotton, man-made fibres, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pile fabrics, label','Tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería, de anchura > 30 cm (exc. de lana o pelo fino, de algodón, de fibras sintéticas o de fibras artificiales; tejidos de punto con un contenido de hilados de elastómeros o hilos de c',60,6005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600610,'Outros tecidos de malha, de lã ou de pêlos finos, de largura > 30 cm','Fabrics, knitted or crocheted, of a width of > 30 cm, of wool or fine animal hair (excl. warp knit fabrics incl. those made on galloon knitting machines, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long ','Tejidos de punto, de anchura > 30 cm, de lana o pelo fino (exc. tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería; tejidos de punto con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo, felpa, i',60,6006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600621,'Outros tecidos de malha, de algodão, crus ou branqueados, de largura > 30 cm','Unbleached or bleached cotton fabrics, knitted or crocheted, of a width of > 30 cm (excl. warp knit fabrics incl. those made on galloon knitting machines, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long','Tejidos de punto, de anchura > 30 cm, de algodón, crudos o blanqueados (exc. tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería; tejidos de punto con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciop',60,6006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600622,'Outros tecidos de malha, de algodão, tintos, de largura > 30 cm','Dyed cotton fabrics, knitted or crocheted, of a width of > 30 cm (excl. warp knit fabrics incl. those made on galloon knitting machines, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped pile','Tejidos de punto, de anchura > 30 cm, de algodón, teñidos (exc. tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería; tejidos de punto con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo, felpa, i',60,6006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600623,'Outros tecidos de malha, de algodão, com fios de diversas cores, de largura > 30 cm','Cotton fabrics, knitted or crocheted, of yarns of different colours, of a width of > 30 cm (excl. warp knit fabrics incl. those made on galloon knitting machines, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, in','Tejidos de punto, de anchura > 30 cm, de algodón, con hilados de distintos colores (exc. tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería; tejidos de punto con un contenido de hilados de elastómeros o hilos de caucho >= 5% en p',60,6006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600624,'Outros tecidos de malha, de algodão, estampados, de largura > 30 cm','Printed cotton fabrics, knitted or crocheted, of a width of > 30 cm (excl. warp knit fabrics incl. those made on galloon knitting machines, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pile, looped p','Tejidos de punto, de anchura > 30 cm, de algodón, estampados (exc. tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería; tejidos de punto con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo, felpa',60,6006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600631,'Outros tecidos de malha, de fibras sintéticas, crus ou branqueados, de largura > 30 cm','Unbleached or bleached fabrics, knitted or crocheted, of synthetic fibres, of a width of > 30 cm (excl. warp knit fabrics incl. those made on galloon knitting machines, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabri','Tejidos de punto, de anchura > 30 cm, de fibras sintéticas, crudos o blanqueados (exc. tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería; tejidos de punto con un contenido de hilados de elastómeros o hilos de caucho >= 5% en pes',60,6006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600632,'Outros tecidos de malha, de fibras sintéticas, tingidos, de largura > 30 cm','Dyed fabrics, knitted or crocheted, of synthetic fibres, of a width of > 30 cm (excl. warp knit fabrics incl. those made on galloon knitting machines, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pil','Tejidos de punto, de anchura > 30 cm, de fibras sintéticas, teñidos (exc. tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería; tejidos de punto con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciopelo',60,6006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600633,'Outros tecidos de malha, de fibras sintéticas, com fios de diversas cores, de largura > 30 cm','Fabrics, knitted or crocheted, of synthetic fibres, of yarns of different colours, of a width of > 30 cm (excl. warp knit fabrics incl. those made on galloon knitting machines, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pi','Tejidos de punto, de anchura > 30 cm, de fibras sintéticas, con hilados de distintos colores (exc. tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería; tejidos de punto con un contenido de hilados de elastómeros o hilos de caucho ',60,6006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600634,'Outros tecidos de malha, de fibras sintéticas, estampados, de largura > 30 cm','Printed fabrics, knitted or crocheted, of synthetic fibres, of a width of > 30 cm (excl. warp knit fabrics incl. those made on galloon knitting machines, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long ','Tejidos de punto, de anchura > 30 cm, de fibras sintéticas, estampados (exc. tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería; tejidos de punto con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciop',60,6006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600641,'Outros tecidos de malha, de fibras artificiais, crus ou branqueados, de largura > 30 cm','Unbleached or bleached fabrics, knitted or crocheted, of artificial fibres, of a width of > 30 cm (excl. warp knit fabrics incl. those made on galloon knitting machines, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabr','Tejidos de punto, de anchura > 30 cm, de fibras artificiales, crudos o blanqueados (exc. tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería; tejidos de punto con un contenido de hilados de elastómeros o hilos de caucho >= 5% en p',60,6006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600642,'Outros tecidos de malha, de fibras artificiais, tingidos, de largura > 30 cm','Dyed fabrics, knitted or crocheted, of artificial fibres, of a width of > 30 cm (excl. warp knit fabrics incl. those made on galloon knitting machines, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long pi','Tejidos de punto, de anchura > 30 cm, de fibras artificiales, teñidos (exc. tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería; tejidos de punto con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terciope',60,6006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600643,'Outros tecidos de malha, de fibras artificiais, com fios de diversas cores, de largura > 30 cm','Fabrics, knitted or crocheted, of artificial fibres, of yarns of different colours, of a width of > 30 cm (excl. warp knit fabrics incl. those made on galloon knitting machines, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and p','Tejidos de punto, de anchura > 30 cm, de fibras artificiales, con hilados de distintos colores (exc. tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería; tejidos de punto con un contenido de hilados de elastómeros o hilos de cauch',60,6006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600644,'Outros tecidos de malha, de fibras artificiais, estampados, de largura > 30 cm','Printed fabrics, knitted or crocheted, of artificial fibres, of a width of > 30 cm (excl. warp knit fabrics incl. those made on galloon knitting machines, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and pile fabrics, incl. long','Tejidos de punto, de anchura > 30 cm, de fibras artificiales, estampados (exc. tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería; tejidos de punto con un contenido de hilados de elastómeros o hilos de caucho >= 5% en peso; terci',60,6006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (600690,'Outros tecidos de malha, de outras matérias têxteis, de largura > 30 cm','Fabrics, knitted or crocheted, of a width of > 30 cm (excl. of man-made fibres, cotton, wool or fine animal hair, warp knit fabrics incl. those made on galloon knitting machines, those containing by weight >= 5% of elastomeric yarn or  rubber thread, and ','Tejidos de punto, de anchura > 30 cm (exc. de lana o pelo fino, de algodón, de fibras sintéticas o de fibras artificiales; tejidos de punto por urdimbre, incl. los obtenidos en telares de pasamanería; tejidos de punto con un contenido de hilados de elastó',60,6006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610110,'sobretudos, etc.de malha de lã/pêlos finos, uso masculino','overcoats, etc.of wool/fine animal hair mesh, mascul.uses','abrigos, etc.de punto de lana/pelo fino, para hombres',61,6101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610120,'Sobretudos, japonas, gabões, capas, casacos e semelhantes, de malha de algodão, de uso masculino','Overcoats, car coats, capes, cloaks, anoraks, incl. ski jackets, windcheaters, wind-jackets and similar articles of cotton, for men or boys, knitted or crocheted (excl. suits, ensembles, jackets, blazers, bib and brace overalls and trousers)','Abrigos, chaquetones, capas, anoraks, cazadoras y artículos simil., de punto de algodón, para hombres o niños (exc. trajes o ternos, conjuntos, chaquetas "sacos", incl. los "blazer", y pantalones)',61,6101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610130,'Sobretudos, japonas, gabões, capas, casacos e semelhantes, de malha de fibras sintéticas ou artificiais, de uso masculino','Overcoats, car coats, capes, cloaks, anoraks, incl. ski jackets, windcheaters, wind-jackets and similar articles of man-made fibres, for men or boys, knitted or crocheted (excl. suits, ensembles, jackets, blazers, bib and brace overalls and trousers)','Abrigos, chaquetones, capas, anoraks, cazadoras y artículos simil., de punto de fibras sintéticas o artificiales, para hombres o niños (exc. trajes o ternos, conjuntos, chaquetas "sacos", incl. los "blazer", y pantalones)',61,6101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610190,'Sobretudos, japonas, gabões, capas, casacos e semelhantes, de malha de outras matérias têxteis, de uso masculino','Overcoats, car coats, capes, cloaks, anoraks, incl. ski jackets, windcheaters, wind-jackets and similar articles of textile materials, for men or boys, knitted or crocheted (excl. of cotton and man-made fibres, suits, ensembles, jackets, blazers, bib and ','Abrigos, chaquetones, capas, anoraks, cazadoras y artículos simil., de punto de materia textil, para hombres o niños (exc. de lana o pelo fino, de algodón o de fibras sintéticas o artificiales, así como trajes o ternos, conjuntos, chaquetas "sacos", incl.',61,6101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610210,'Mantôs, casacos, capas, anoraques e semelhantes, de malha de lã ou pêlos finos, de uso feminino','Women''s or girls'' overcoats, car coats, capes, cloaks, anoraks, incl. ski jackets, windcheaters, wind-jackets and similar articles, of wool or fine animal hair, knitted or crocheted (excl. suits, ensembles, jackets, blazers, dresses, skirts, divided ski','Abrigos, chaquetones, capas, anoraks, cazadoras y artículos simil., de punto de lana o pelo fino, para mujeres o niñas (exc. trajes sastre, conjuntos, chaquetas "sacos", incl. los "blazer", vestidos, faldas, faldas pantalón y pantalones)',61,6102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610220,'Mantôs, casacos, capas, anoraques e semelhantes, de malha de algodão, de uso feminino','Women''s or girls'' overcoats, car coats, capes, cloaks, anoraks, incl. ski jackets, windcheaters, wind-jackets and similar articles of cotton, knitted or crocheted (excl. suits, ensembles, jackets, blazers, dresses, skirts, divided skirts, trousers, bib ','Abrigos, chaquetones, capas, anoraks, cazadoras y artículos simil., de punto de algodón, para mujeres o niñas (exc. trajes sastre, conjuntos, chaquetas "sacos", incl. los "blazer", vestidos, faldas, faldas pantalón y pantalones)',61,6102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610230,'Mantôs, casacos, capas, anoraques e semelhantes, de malha, de fibras sintéticas ou artificiais, de uso feminino','Women''s or girls'' overcoats, car coats, capes, cloaks, anoraks, incl. ski jackets, windcheaters, wind-jackets and similar articles of man-made fibres, knitted or crocheted (excl. suits, ensembles, jackets, blazers, dresses, skirts, divided skirts, trous','Abrigos, chaquetones, capas, anoraks, cazadoras y artículos simil., de punto de fibras sintéticas o artificiales, para mujeres o niñas (exc. trajes sastre, conjuntos, chaquetas "sacos", incl. los "blazer", vestidos, faldas, faldas pantalón y pantalones)',61,6102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610290,'Mantôs, casacos, capas, anoraques e semelhantes, de malha, de outras matérias têxteis, de uso feminino','Women''s or girls'' overcoats, car coats, capes, cloaks, anoraks, incl. ski jackets, windcheaters, wind-jackets and similar articles, of textile materials, knitted or crocheted (excl. of wool, fine animal hair, cotton and man-made fibres, suits, ensembles','Abrigos, chaquetones, capas, anoraks, cazadoras y artículos simil., de punto de materia textil, para mujeres o niñas (exc. de lana o pelo fino, de algodón o de fibras sintéticas o artificiales, así como trajes sastre, conjuntos, chaquetas "sacos", incl. l',61,6102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610310,'Ternos de malha, de uso masculino','Men''s or boys'' suits of textile materials, knitted or crocheted (excl. tracksuits, ski suits and swimwear)','Trajes (ambos o ternos), para hombres o niños',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610311,'ternos (fatos) de malha de lã ou pêlos finos','men''s or boys'' suits of wool or fine animal hair','trajes (ambos o ternos) de punto de lana o de pelo fino',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610312,'ternos (fatos) de malha de fibras sintéticas','men''s or boys'' suits of synthetic fibres','trajes (ambos o ternos) de punto de fibras sintéticas',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610319,'ternos (fatos) de malha de outras matérias têxteis','men''s or boys'' suits of other textile materials','trajes (ambos o ternos) de punto de ots.maters.textiles',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610321,'conjuntos de malha de lã ou pêlos finos, uso masculino','ensembles of mesh of wool/fine anim.hair, masculine uses','conjuntos de punto de lana o pelo fino, para hombres',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610322,'Conjuntos de malha, de algodão, de uso masculino','Men''s or boys'' ensembles of cotton, knitted or crocheted (excl. ski ensembles and swimwear)','Conjuntos de punto, de algodón, para hombres o niños (exc. monos y conjuntos de esquí y trajes de baño)',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610323,'Conjuntos de malha, de fibras sintéticas, de uso masculino','Men''s or boys'' ensembles of synthetic fibres, knitted or crocheted (excl. ski ensembles and swimwear)','Conjuntos de punto, de fibras sintéticas, para hombres o niños (exc. monos y conjuntos de esquí y trajes de baño)',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610329,'Conjuntos de malha, de outras matérias têxteis, de uso masculino','Men''s or boys'' ensembles of textile materials (excl. wool, fine animal hair, cotton or synthetic fibres, ski ensembles and swimwear)','Conjuntos de punto, de materia textil, para hombres o niños (exc. de lana o pelo fino, de algodón o de fibras sintéticas, así como monos y conjuntos de esquí y trajes de baño)',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610331,'Paletós de malha, de lã ou de pêlos finos, de uso masculino','Men''s or boys'' jackets and blazers of wool or fine animal hair, knitted or crocheted (excl. wind-jackets and similar articles)','Chaquetas "sacos" de punto, de lana o pelo fino, para hombres o niños (exc. cazadoras y artículos simil.)',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610332,'Paletós de malha, de algodão, de uso masculino','Men''s or boys'' jackets and blazers of cotton, knitted or crocheted (excl. wind-jackets and similar articles)','Chaquetas "sacos" de punto, de algodón, para hombres o niños (exc. cazadoras y artículos simil.)',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610333,'Paletós de malha, de fibras sintéticas, de uso masculino','Men''s or boys'' jackets and blazers of synthetic fibres, knitted or crocheted (excl. wind-jackets and similar articles)','Chaquetas "sacos" de punto, de fibras sintéticas, para hombres o niños (exc. cazadoras y artículos simil.)',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610339,'Paletós de malha, de outras matérias têxteis, de uso masculino','Men''s or boys'' jackets and blazers of textile materials (excl. of wool, fine animal hair, cotton or synthetic fibres, wind-jackets and similar articles)','Chaquetas "sacos" de punto, de materia textil, para hombres o niños (exc. de lana o pelo fino, de algodón o de fibras sintéticas, así como cazadoras y artículos simil.)',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610341,'Calças, jardineiras, bermudas e shorts (calções), de malha, de lã ou de pêlos finos, de uso masculino','Men''s or boys'' trousers, bib and brace overalls, breeches and shorts of wool or fine animal hair, knitted or crocheted (excl. swimwear and underpants)','Pantalones largos, pantalones con peto, pantalones cortos "calzones" y "shorts", de punto, de lana o pelo fino, para hombres o niños (exc. calzoncillos y pantalones de baño)',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610342,'Calças, jardineiras, bermudas e shorts (calções), de malha, de algodão, de uso masculino','Men''s or boys'' trousers, bib and brace overalls, breeches and shorts of cotton, knitted or crocheted (excl. swimwear and underpants)','Pantalones largos, pantalones con peto, pantalones cortos "calzones" y "shorts", de punto, de algodón, para hombres o niños (exc. calzoncillos y pantalones de baño)',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610343,'Calças, jardineiras, bermudas e shorts (calções), de malha, de fibras sintéticas, de uso masculino','Men''s or boys'' trousers, bib and brace overalls, breeches and shorts of synthetic fibres, knitted or crocheted (excl. swimwear and underpants)','Pantalones largos, pantalones con peto, pantalones cortos "calzones" y "shorts", de punto, de fibras stintéticas, para hombres o niños (exc. calzoncillos y pantalones de baño)',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610349,'Calças, jardineiras, bermudas e shorts (calções), de malha, de outras matérias têxteis, de uso masculino','Men''s or boys'' trousers, bib and brace overalls, breeches and shorts of textile materials, knitted or crocheted (excl. of wool, fine animal hair, cotton or synthetic fibres, swimwear and underpants)','Pantalones largos, pantalones con peto, pantalones cortos "calzones" y "shorts", de punto, de materia textil, para hombres o niños (exc. de lana o pelo fino, de algodón o de fibras sintéticas, así como calzoncillos y pantalones de baño)',61,6103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610411,'tailleurs de malha de lã ou de pêlos finos','suits of mesh of wool or fine animal hair','trajes sastre de punto de lana o de pelo fino',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610412,'tailleurs de malha de algodão','suits of cotton mesh','trajes sastre de punto de algodón',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610413,'Tailleurs de malha, de fibras sintéticas, de uso feminino','Women''s or girls'' suits of synthetic fibres, knitted or crocheted (excl. ski overalls and swimwear)','Trajes sastre de punto, de fibras sintéticas, para mujeres o niñas (exc. monos de esquí y trajes de baño)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610419,'Tailleurs de malha, de outras matérias têxteis, de uso feminino','Women''s or girls'' suits of textile materials, knitted or crocheted (excl. of synthetic fibres, and ski overalls and swimwear)','Trajes sastre de punto, de materia textil, para mujeres o niñas (exc. de lana o pelo fino, de algodón o de fibras sintéticas, así como monos de esquí y trajes de baño)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610421,'Conjuntos de malha de lã ou pêlos finos,  de uso feminino','Ensembles of mesh of wool/fine animal hair, femin.uses','Conjuntos de punto de lana o pelo fino, para mujeres',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610422,'Conjuntos de malha, de algodão, de uso feminino','Women''s or girls'' ensembles of cotton, knitted or crocheted (excl. ski ensembles and swimwear)','Conjuntos de punto, de algodón, para mujeres o niñas (exc. conjuntos de esquí y trajes de baño)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610423,'Conjuntos de malha, de fibras sintéticas, de uso feminino','Women''s or girls'' ensembles of synthetic fibres, knitted or crocheted (excl. ski ensembles and swimwear)','Conjuntos de punto, de fibras sintéticas, para mujeres o niñas (exc. conjuntos de esquí y trajes de baño)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610429,'Conjuntos de malha, de outras matérias têxteis, de uso feminino','Women''s or girls'' ensembles of textile materials (excl. of cotton or synthetic fibres, ski ensembles and swimwear)','Conjuntos de punto, de materia textil, para mujeres o niñas (exc. de lana o pelo fino, de algodón o de fibras sintéticas, así como conjuntos de esquí y trajes de baño)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610431,'Blazers de malha, de lã ou de pêlos finos, de uso feminino','Women''s or girls'' jackets and blazers of wool or fine animal hair, knitted or crocheted (excl. wind-jackets and similar articles)','Chaquetas "sacos" de punto, de lana o pelo fino, para mujeres o niñas (exc. cazadoras y artículos simil.)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610432,'Blazers de malha, de algodão, de uso feminino','Women''s or girls'' jackets and blazers of cotton, knitted or crocheted (excl. wind-jackets and similar articles)','Chaquetas "sacos" de punto, de algodón, para mujeres o niñas (exc. cazadoras y artículos simil.)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610433,'Blazers de malha, de fibras sintéticas, de uso feminino','Women''s or girls'' jackets and blazers of synthetic fibres, knitted or crocheted (excl. wind-jackets and similar articles)','Chaquetas "sacos" de punto, de fibras sintéticas, para mujeres o niñas (exc. cazadoras y artículos simil.)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610439,'Blazers de malha, de outras matérias têxteis, de uso feminino','Women''s or girls'' jackets and blazers of textile materials, knitted or crocheted (excl. of wool, fine animal hair, cotton or synthetic fibres, wind-jackets and similar articles)','Chaquetas "sacos" de punto, de materia textil, para mujeres o niñas (exc. de lana o pelo fino, de algodón o de fibras sintéticas, así como cazadoras y artículos simil.)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610441,'Vestidos de malha, de lã ou de pêlos finos, de uso feminino','Women''s or girls'' dresses of wool or fine animal hair, knitted or crocheted (excl. petticoats)','Vestidos de punto, de lana o pelo fino, para mujeres o niñas (exc. combinaciones)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610442,'Vestidos de malha, de algodão, de uso feminino','Women''s or girls'' dresses of cotton, knitted or crocheted (excl. petticoats)','Vestidos de punto, de algodón, para mujeres o niñas (exc. combinaciones)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610443,'Vestidos de malha, de fibras sintéticas, de uso feminino','Women''s or girls'' dresses of synthetic fibres, knitted or crocheted (excl. petticoats)','Vestidos de punto, de fibras sintéticas, para mujeres o niñas (exc. combinaciones)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610444,'Vestidos de malha, de fibras artificiais, de uso feminino','Women''s or girls'' dresses of artificial fibres, knitted or crocheted (excl. petticoats)','Vestidos de punto, de fibras artificiales, para mujeres o niñas (exc. combinaciones)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610449,'Vestidos de malha, de outras matérias têxteis, de uso feminino','Women''s or girls'' dresses of textile materials, knitted or crocheted (excl. of wool, fine animal hair, cotton, man-made fibres and petticoats)','Vestidos de punto, de materia textil, para mujeres o niñas (exc. de lana o pelo fino, de algodón o de fibras sintéticas o artificiales, así como combinaciones)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610451,'Saias e saias-calças, de malha, de lã ou de pêlos finos, de uso feminino','Women''s or girls'' skirts and divided skirts of wool or fine animal hair, knitted or crocheted (excl. petticoats)','Faldas y faldas pantalón de punto, de lana o pelo fino, para mujeres o niñas (exc. enaguas)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610452,'Saias e saias-calças, de malha, de algodão, de uso feminino','Women''s or girls'' skirts and divided skirts of cotton, knitted or crocheted (excl. petticoats)','Faldas y faldas pantalón de punto, de algodón, para mujeres o niñas (exc. enaguas)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610453,'Saias e saias-calças, de malha, de fibras sintéticas, de uso feminino','Women''s or girls'' skirts and divided skirts of synthetic fibres, knitted or crocheted (excl. petticoats)','Faldas y faldas pantalón de punto, de fibras sintéticas, para mujeres o niñas (exc. enaguas)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610459,'Saias e saias-calças, de malha, de outras matérias têxteis, de uso feminino','Women''s or girls'' skirts and divided skirts of textile materials, knitted or crocheted (excl. of wool, fine animal hair, cotton or synthetic fibres, and petticoats)','Faldas y faldas pantalón de punto, de materia textil, para mujeres o niñas (exc. de lana o pelo fino, de algodón o de fibras sintéticas, así como enaguas)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610461,'Calças, jardineiras, bermudas e shorts, de malha, de lã ou de pêlos finos, de uso feminino','Women''s or girls'' trousers, bib and brace overalls, breeches and shorts of wool or fine animal hair, knitted or crocheted (excl. panties and swimwear)','Pantalones largos, pantalones con peto, pantalones cortos "calzones" y "shorts", de punto, de lana o pelo fino, para mujeres o niñas (exc. bragas y trajes de baño)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610462,'Calças, jardineiras, bermudas e shorts, de malha, de algodão, de uso feminino','Women''s or girls'' trousers, bib and brace overalls, breeches and shorts of cotton, knitted or crocheted (excl. panties and swimwear)','Pantalones, pantalones con peto, calzones y pantalones cortos de punto, de algodón, para mujeres o niñas (exc. bragas y trajes de baño)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610463,'Calças, jardineiras, bermudas e shorts, de malha, de fibras sintéticas, de uso feminino','Women''s or girls'' trousers, bib and brace overalls, breeches and shorts of synthetic fibres, knitted or crocheted (excl. panties and swimwear)','Pantalones, pantalones con peto, calzones y pantalones cortos de punto, de fibras sintéticas, para mujeres o niñas (exc. bragas y trajes de baño)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610469,'Calças, jardineiras, bermudas e shorts, de malha, de outras matérias têxteis, de uso feminino','Women''s or girls'' trousers, bib and brace overalls, breeches and shorts of textile materials, knitted or crocheted (excl. of wool, fine animal hair, cotton or synthetic fibres, panties and swimwear)','Pantalones, pantalones con peto, calzones y pantalones cortos de punto, de materia textil, para mujeres o niñas (exc. de lana o pelo fino, de algodón o de fibras sintéticas, así como bragas y trajes de baño)',61,6104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610510,'Camisas de malha de algodão, de uso masculino','Men''s or boys'' shirts of cotton, knitted or crocheted (excl. nightshirts, T-shirts, singlets and other vests)','Camisas de punto, de algodón, para hombres o niños (exc. camisones, "T-shirts" y camisetas)',61,6105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610520,'Camisas de malha, de fibras sintéticas ou artificiais, de uso masculino','Men''s or boys'' shirts of man-made fibres, knitted or crocheted (excl. nightshirts, T-shirts, singlets and other vests)','Camisas de punto, de fibras sintéticas o artificiales, para hombres o niños (exc. camisones, "T-shirts" y camisetas)',61,6105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610590,'Camisas de malha, de outras matérias têxteis, de uso masculino','Men''s or boys'' shirts of textile materials, knitted or crocheted (excl. of cotton or man-made fibres, nightshirts, T-shirts, singlets and other vests)','Camisas de punto, de materia textil, para hombres o niños (exc. de algodón o de fibras sintéticas o artificiales, así como camisones, "T- shirts" y camisetas)',61,6105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610610,'Camisas, blusas, blusas chemisier, de malha, de algodão, de uso feminino','Women''s or girls'' blouses, shirts and shirt-blouses of cotton, knitted or crocheted (excl. T-shirts and vests)','Camisas, blusas y blusas camiseras, de punto, de algodón, para mujeres o niñas (exc. "T-shirts" y camisetas)',61,6106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610620,'Camisas, blusas, blusas chemisier, de malha, de fibras sintéticas ou artificiais, de uso feminino','Women''s or girls'' blouses, shirts and shirt-blouses of man-made fibres, knitted or crocheted (excl. T-shirts and vests)','Camisas, blusas y blusas camiseras, de punto, de fibras sintéticas o artificiales, para mujeres o niñas (exc. "T-shirts" y camisetas)',61,6106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610690,'Camisas, blusas, blusas, chemisier, de malha, de outras matérias têxteis, de uso feminino','Women''s or girls'' blouses, shirts and shirt-blouses of textile materials, knitted or crocheted (excl. of cotton or man-made fibres, T-shirts and vests)','Camisas, blusas y blusas camiseras, de punto, de materia textil, para mujeres o niñas (exc. de algodón o de fibras sintéticas o artificiales, así como "T-shirts" y camisetas)',61,6106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610711,'Cuecas e ceroulas, de malha, de algodão','Men''s or boys'' underpants and briefs of cotton, knitted or crocheted','Calzoncillos de punto, de algodón, para hombres o niños',61,6107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610712,'Cuecas e ceroulas, de malha, de fibras sintéticas ou artificiais','Men''s or boys'' underpants and briefs of man-made fibres, knitted or crocheted','Calzoncillos de punto, de fibras sintéticas o artificiales, para hombres o niños',61,6107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610719,'Cuecas e ceroulas, de malha, de outras matérias têxteis','Men''s or boys'' underpants and briefs of other textile materials, knitted or crocheted (excl. of cotton or man-made fibres)','Calzoncillos de punto, de materia textil, para hombres o niños (exc. de algodón o de fibras sintéticas o artificiales)',61,6107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610721,'Camisolões e pijamas, de malha, de algodão, de uso masculino','Men''s or boys'' nightshirts and pyjamas of cotton, knitted or crocheted (excl. vests and singlets)','Camisones y pijamas, de punto, de algodón, para hombres o niños (exc. camisetas)',61,6107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610722,'Camisolões e pijamas, de malha, de fibras sintéticas ou artificiais, de uso masculino','Men''s or boys'' nightshirts and pyjamas of man-made fibres, knitted or crocheted (excl. vests and singlets)','Camisones y pijamas, de punto, de fibras sintéticas o artificiales, para hombres o niños (exc. camisetas)',61,6107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610729,'Camisolões e pijamas, de malha, de outras matérias têxteis, de uso masculino','Men''s or boys'' nightshirts and pyjamas of textile materials, knitted or crocheted (excl. of cotton or man-made fibres, and vests and singlets)','Camisones y pijamas, de punto, de materia textil, para hombres o niños (exc. de algodón o de fibras sintéticas o artificiales, así como camisetas)',61,6107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610791,'Roupões de banho e semelhantes, de malha, de algodão, de uso masculino','Men''s or boys'' bathrobes, dressing gowns and similar articles of cotton, knitted or crocheted','Albornoces de baño, batas de casa y artículos simil., de punto, de algodón, para hombres o niños',61,6107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610792,'Roupões, etc.de malha de fibra sint/artif.uso masculino','Robes, etc.of mesh of synth/artif fibres, masculine uses','Albornoces de baño, etc.de punt.de fib.sint/art, p/hombr.',61,6107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610799,'Roupões de banho e semelhantes, de malha, de outras matérias têxteis, de uso masculino','Men''s or boys'' bathrobes, dressing gowns and similar articles of textile materials, knitted or crocheted (excl. of cotton)','Albornoces de baño, batas de casa y artículos simil., de punto, de materia textil, para hombres o niños (exc. de algodón o de fibras sintéticas o artificiales)',61,6107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610811,'Combinações e anáguas, de malha, de fibras sintéticas ou artificiais','Women''s or girls'' slips and petticoats of man-made fibres, knitted or crocheted (excl. T-shirts and vests)','Combinaciones y enaguas, de punto, de fibras sintéticas o artificiales, para mujeres o niñas (exc. "T-shirts" y camisetas)',61,6108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610819,'Combinações e anáguas, de malha, de outras matérias têxteis','Women''s or girls'' slips and petticoats of textile materials, knitted or crocheted (excl. man-made fibres, T-shirts and vests)','Combinaciones y enaguas, de punto, de materia textil, para mujeres o niñas (exc. de fibras sintéticas o artificiales, así como "T-shirts" y camisetas)',61,6108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610821,'Calcinhas de malha de algodão','Women''s or girls'' briefs and panties of cotton, knitted or crocheted','Bragas "bombachas, calzones" de punto, de algodón, para mujeres o niñas',61,6108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610822,'Calcinhas de malha, de fibras sintéticas ou artificiais','Women''s or girls'' briefs and panties of man-made fibres, knitted or crocheted','Bragas "bombachas, calzones" de punto, de fibras sintéticas o artificiales, para mujeres o niñas',61,6108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610829,'Calcinhas de malha, de outras matérias têxteis','Women''s or girls'' briefs and panties of textile materials, knitted or crocheted (excl. cotton or man-made fibres)','Bragas "bombachas, calzones" de punto, de materia textil, para mujeres o niñas (exc. de algodón o de materias sintéticas o artificiales)',61,6108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610831,'Camisolas e pijamas, de malha de algodão, de uso feminino','Women''s or girls'' nightdresses and pyjamas of cotton, knitted or crocheted (excl. T-shirts, vests and négligés)','Camisones y pijamas, de punto, de algodón, para mujeres o niñas (exc. "T-shirts", camisetas y saltos de cama)',61,6108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610832,'Camisolas e pijamas, de malha, de fibras sintéticas ou artificiais, de uso feminino','Women''s or girls'' nightdresses and pyjamas of man-made fibres, knitted or crocheted (excl. T-shirts, vests and négligés)','Camisones y pijamas, de punto, de fibras sintéticas o artificiales, para mujeres o niñas (exc. "T-shirts", camisetas y saltos de cama)',61,6108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610839,'Camisolas e pijamas, de malha, de outras matérias têxteis, de uso feminino','Women''s or girls'' nightdresses and pyjamas of textile materials, knitted or crocheted (excl. of cotton and man-made fibres, T-shirts, vests and négligés)','Camisones y pijamas, de punto, de materia textil, para mujeres o niñas (exc. de algodóno de fibras sintéticas o artificiales, así como "T-shirts", camisetas y saltos de cama)',61,6108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610891,'Roupões de banho, penhoares e semelhantes, de malha, de algodão, de uso feminino','Women''s or girls'' négligés, bathrobes, dressing gowns, housejackets and similar articles of cotton, knitted or crocheted (excl. vests, slips, petticoats, briefs and panties, nightdresses, pyjamas, brassiéres, girdles, corsets and similar articles)','Saltos de cama, albornoces de baño, batas de casa y artículos simil., de punto, de algodón, para mujeres o niñas (exc. camisetas, combinaciones, enaguas, bragas "bombachas, calzones", camisones, pijamas, sostenes, fajas, corsés y artículos simil.)',61,6108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610892,'Roupões de banho, penhoares e semelhantes, de malha, de fibras sintéticas ou artificiais, de uso feminino','Women''s or girls'' négligés, bathrobes, dressing gowns, housejackets and similar articles of man-made fibres, knitted or crocheted (excl. vests, slips, petticoats, briefs and panties, nightdresses, pyjamas, brassiéres, girdles, corsets and similar articl','Saltos de cama, albornoces de baño, batas de casa y artículos simil., de punto, de fibras sintéticas o artificiales, para mujeres o niñas (exc. camisetas, combinaciones, enaguas, bragas "bombachas, calzones", camisones, pijamas, sostenes, fajas, corsés y ',61,6108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610899,'Roupões de banho, penhoares e semelhantes, de malha, de outras matérias têxteis, de uso feminino','Women''s or girls'' négligés, bathrobes, dressing gowns, housejackets and similar articles of textile materials, knitted or crocheted (excl. of cotton or man-made fibres, vests, slips, petticoats, briefs and panties, nightdresses, pyjamas, brassiéres, gir','Saltos de cama, albornoces de baño, batas de casa y artículos simil., de punto, de materia textil, para mujeres o niñas (exc. de algodón o de fibras sintéticas o artificiales, así como camisetas, combinaciones, enaguas, bragas "bombachas, calzones", camis',61,6108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610910,'Camisetas (T-shirts) e camisetas interiores, de malha, de algodão','T-shirts, singlets and other vests of cotton, knitted or crocheted','"T-shirts" y camisetas, de punto, de algodón',61,6109);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (610990,'Camisetas (T-shirts) e camisetas interiores, de malha, de outras matérias têxteis','T-shirts, singlets and other vests of textile materials, knitted or crocheted (excl. cotton)','"T-shirts" y camisetas, de punto, de materia textil (exc. de algodón)',61,6109);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611010,'Suéteres, pulôveres, etc.de malha de lã ou pêlos finos','Sweaters, pullovers, etc.of mesh of wool/fine anim.hair','Suéteres, pullovers, etc.de punto de lana o pelo fino',61,6110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611011,'Suéteres, pulôveres, cardigãs, coletes e artigos semelhantes, de malha, de lã','Jerseys, pullovers, cardigans, waistcoats and similar articles, of wool, knitted or crocheted (excl. wadded waistcoats)','Suéteres "jerseys", "pulllovers", cardiganes, chalecos y artículos similares, de punto, de lana (exc. chalecos acolchados)',61,6110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611012,'Suéteres, pulôveres, cardigãs, coletes e artigos semelhantes, de malha, de pêlo fino de cabra de Cachemira','Jerseys, pullovers, cardigans, waistcoats and similar articles, of hair of Kashmir cashmere goats, knitted or crocheted (excl. quilted articles)','Suéteres "jerseys", "pulllovers", cardiganes, chalecos y artículos similares, de punto, de pelo fino de cabra de Cachemira (exc. chalecos acolchados)',61,6110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611019,'Suéteres, pulôveres, cardigãs, coletes e artigos semelhantes, de malha, de outros pêlos finos','Jerseys, pullovers, cardigans, waistcoats and similar articles, of fine animal hair, knitted or crocheted (excl. from hair of Kashmir cashmere goats and quilted articles)','Suéteres "jerseys", "pullovers", cardiganes, chalecos y artículos similares, de punto, de pelo fino (exc. de pelo de cabra de Cachemira, así como los chalecos acolchados)',61,6110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611020,'Suéteres, pulôveres, cardigãs, coletes e artigos semelhantes, de malha, de algodão','Jerseys, pullovers, cardigans, waistcoats and similar articles, of cotton, knitted or crocheted (excl. wadded waistcoats)','Suéteres "jerseys", "pullovers", cardiganes, chalecos y artículos simil., de punto, de algodón (exc. chalecos acolchados)',61,6110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611030,'Suéteres, pulôveres, cardigãs, coletes e artigos semelhantes, de malha, de fibras sintéticas ou artificiais','Jerseys, pullovers, cardigans, waistcoats and similar articles, of man-made fibres, knitted or crocheted (excl. wadded waistcoats)','Suéteres "jerseys", "pullovers", cardiganes, chalecos y artículos simil., de punto, de fibras sintéticas o artificiales (exc. chalecos acolchados)',61,6110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611090,'Suéteres, pulôveres, cardigãs, coletes e artigos semelhantes, de malha, de outras matérias têxteis','Jerseys, pullovers, cardigans, waistcoats and similar articles, of textile materials, knitted or crocheted (excl. of wool, fine animal hair, cotton or man-made fibres, and wadded waistcoats)','Suéteres "jerseys", "pullovers", cardiganes, chalecos y artículos simil., de punto, de materia textil (exc. de lana o pelo fino, de algodón y de fibras sintéticas o artificiales, así como chalecos acolchados)',61,6110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611110,'vestuário p/bebes e acess.de malha de lã ou pêlos finos','babies'' garm./cloth.acces.mesh of wool/fine anim.hair','prendas y complem.p/bebés, de punto de lana/pelo fino',61,6111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611120,'Vestuário e seus acessórios, de malha, de algodão, para bebês','Babies'' garments and clothing accessories of cotton, knitted or crocheted (excl. hats)','Prendas y complementos "accesorios" de vestir, de punto, de algodón, para bebés (exc. gorras)',61,6111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611130,'Vestuário e seus acessórios, de malha, de fibras sintéticas, para bebês','Babies'' garments and clothing accessories of synthetic fibres, knitted or crocheted (excl. hats)','Prendas y complementos "accesorios" de vestir, de punto, de fibras sintéticas, para bebés (exc. gorras)',61,6111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611190,'Vestuário e seus acessórios, de malha, de outras matérias têxteis, para bebês','Babies'' garments and clothing accessories of textile materials, knitted or crocheted (excl. of cotton or synthetic fibres, and hats)','Prendas y complementos "accesorios" de vestir, de punto, de materia textil, para bebés (exc. de lana o pelo fino, de algodón o de fibras sintéticas, así como gorras)',61,6111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611211,'Abrigos para esportes, de malha, de algodão','Track-suits of cotton, knitted or crocheted','Conjuntos de abrigo para entrenamiento o deporte "chandales", de punto, de algodón',61,6112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611212,'Abrigos para esportes, de malha, de fibras sintéticas','Track-suits of synthetic fibres, knitted or crocheted','Conjuntos de abrigo para entrenamiento o deporte "chandales", de punto, de fibras sintéticas',61,6112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611219,'Abrigos para esportes, de malha, de outras matérias têxteis','Track-suits of textile materials, knitted or crocheted (excl. cotton or synthetic fibres)','Conjuntos de abrigo para entrenamiento o deporte "chandales", de punto, de materia textil (exc. algodón o fibras sintéticas)',61,6112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611220,'Macacões e conjuntos, de esqui, de malha','Ski-suits, knitted or crocheted','Monos "overoles" y conjuntos de esquí, de punto',61,6112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611231,'Shorts e sungas, de banho, de malha, de fibras sintéticas, de uso masculino','Men''s or boys'' swimwear of synthetic fibres, knitted or crocheted','Bañadores de punto, de fibras sintéticas, para hombres o para niños',61,6112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611239,'Shorts e sungas, de banho, de malha, de outras matérias têxteis, de uso masculino','Men''s or boys'' swimwear of textile materials, knitted or crocheted (excl. synthetic fibres)','Bañadores de punto, de materia textil, para hombres o para niños (exc. de fibras sintéticas)',61,6112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611241,'Maiôs e biquínis, de banho, de malha, de fibras sintéticas, de uso feminino','Women''s or girls'' swimwear of synthetic fibres, knitted or crocheted','Bañadores de punto, de fibras sintéticas, para mujeres o niñas',61,6112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611249,'Maiôs e biquínis, de banho, de malha, de outras matérias, de uso feminino','Women''s or girls'' swimwear of textile materials, knitted or crocheted (excl. synthetic fibres)','Bañadores de punto, de materia textil, para mujeres o niñas (exc. de fibras sintéticas)',61,6112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611300,'Vestuário confeccionado com tecidos de malha, com plástico ou borracha','Garments, knitted or crocheted, rubberised or impregnated, coated or covered with plastics or other materials (excl. babies'' garments and clothing accessories)','Prendas de vestir confeccionadas con tejidos de punto, cauchutados o impregnados, recubiertos o revestidos con plástico u otra materia (exc. prendas para bebés y complementos "accesorios" de vestir)',61,6113);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611410,'Outros vestuários de malha de lã ou de pêlos finos','Other Garments of Wool or Fine Animal Hair, Knitted or crocheted','Ots.prendas de vestir de punto de lana o de pelo fino',61,6114);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611420,'Outro vestuário de malha, de algodão','Special garments for professional, sporting or other purposes, n.e.s., of cotton, knitted or crocheted','Prendas de vestir especiales, para usos específicos "p.ej., profesional, deportivo, etc.", n.c.o.p., de punto, de algodón',61,6114);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611430,'Outro vestuário de malha, de fibras sintéticas ou artificiais','Special garments for professional, sporting or other purposes, n.e.s., of man-made fibres, knitted or crocheted','Prendas de vestir especiales, para usos específicos "p.ej., profesional, deportivo, etc.", n.c.o.p., de punto, de fibras sintéticas o artificiales',61,6114);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611490,'Outro vestuário de malha, de outras matérias têxteis','Special garments for professional, sporting or other purposes, n.e.s., of textile materials, knitted or crocheted (excl. of cotton and man-made fibres)','Prendas de vestir especiales, para usos específicos "p.ej., profesional, deportivo, etc.", n.c.o.p., de punto, de materia textil (exc. de lana o pelo fino, de algodón o de fibras sintéticas o artificiales)',61,6114);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611510,'Meias-calças, meias até o joelho e meias acima do joelho, de malha, de compressão degressiva (por exemplo, meias para varizes)','Graduated compression hosiery [e.g., stockings for varicose veins], of textile materials, knitted or crocheted (excl. hosiery for babies)','Calzas, "panty-medias", leotardos y medias de compresión progresiva (por ejemplo, medias para varices)',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611511,'Meias-calças de malha de fibra sintética,  tit<67decitex','Panty hose of synthetic fibres mesh, tit<67decitex','Panty-medias de punto de fibra sintética, tít<67decitex',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611512,'Meias-calças de malha de fibra sintética,  tit>=67decitex','Panty hose of synthetic fibres mesh, tit>=67decitex','Panty-medias de punto de fibra sintética, tít>=67decitex',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611519,'Meias-calças de malha e de outras matérias têxteis','Pantyhose knittered and of other textile materials','Panti Prendas de punto y otros materiales textiles',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611520,'Meias de senhoras, de malhas e de outras matérias têxteis','Ladies socks, knitting and other textile materials','Señoras calcetines, de tejido y otros materiales textiles',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611521,'Meias-calças de fibras sintéticas, de malha, de título inferior a 67decitex, por fio simples','Pantyhose and tights of synthetic fibres, knitted or crocheted, measuring per single yarn < 67 decitex (excl. graduated compression hosiery)','"Panty-medias" y leotardos de fibras sintéticas, de título inferior a 67 decitex por hilo sencillo',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611522,'Meias-calças de fibras sintéticas, de malha, de título maior ou igual a 67decitex, por fio simples','Pantyhose and tights of synthetic fibres, knitted or crocheted, measuring per single yarn >= 67 decitex (excl. graduated compression hosiery)','"Panty-medias" y leotardos  de fibras sintéticas de título superior o igual à 67 decitex por hilo sencillo',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611529,'Outras meias-calças de malha, de outras matérias têxteis','Pantyhose and tights of textile materials, knitted or crocheted (excl. graduated compression hosiery, those of synthetic fibres and hosiery for babies)','"Panty-medias" y leotardos, de punto, de materias textiles (exc. a compresión regresiva, de fibras sintéticas y al excl. de los artículos de calcetería para bebés)',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611530,'Outras meias até o joelho e meias acima do joelho, de uso feminino, de título inferior a 67 decitex por fio simples','Women''s full-length or knee-length hosiery, knitted or crocheted, measuring per single yarn < 67 decitex (excl. graduated compression hosiery, pantyhose and tights)','Medias de mujer, de título inferior a 67 decitex por hilo sencillo (exc. a compresión regresiva, "panty-medias" y leotardos)',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611591,'Outras meias de malha de lã ou de pêlos finos','Stockings, socks, of wool or fine animal hair, knitted or crocheted','Otras medias de punto de lana o de pelo fino',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611592,'Outras meias de malha de algodão','Stockings, socks, of cotton, knitted or crocheted','Otras medias de punto de algodón',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611593,'Outras meias de malha de fibras sintéticas','Stockings, socks, of synthetic fibres, knitted or crocheted','Otras medias de punto de fibras sintéticas',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611594,'Outras meias e artefatos semelhantes de malha, de lã ou de pêlos finos','Full-length or knee-length stockings, socks and other hosiery, incl. footwear without applied soles, of wool or fine animal hair, knitted or crocheted (excl. graduated compression hosiery, pantyhose and tights, women''s full-length or knee-length stocking','Medias, calcetines y otros artículos de calcetería, de punto, de lana o pelos finos (exc. a compresión regresiva y  médias, panty-medias y leotardos para mujeres a título en hilos simples < 67 decitex y artículos de calcetería para bebés)',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611595,'Outras meias e artefatos semelhantes de malha, de algodão','Full-length or knee-length stockings, socks and other hosiery, incl. footwear without applied soles, of cotton, knitted or crocheted (excl. graduated compression hosiery, pantyhose and tights, women''s full-length or knee-length stockings, measuring per s','Medias, calcetines y otros artículos de calcetería, de punto, de algodón (excepto a compresión regresiva y al excl. de los pegajosos bajocalzones parte baja y miparte baja para mujeres a título en hilos simples < 67 decitex y calzados para bebés)',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611596,'Outras meias e artefatos semelhantes de malha, de fibras sintéticas','Full-length or knee-length stockings, socks and other hosiery, incl. footwear without applied soles, of synthetic fibres, knitted or crocheted (excl. graduated compression hosiery, pantyhose and tights, women''s full-length or knee-length stockings, measu','Medias, calcetines y otros artículos de calcetería, de punto, de fibras sintéticas (exc. a compresión regresiva y  médias, panty-medias y leotardos de mujeres a título en hilos simples < 67 decitex y artículos de calcetería para bebés)',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611599,'Outras meias e artefatos semelhantes de malha, de outras matérias têxteis','Full-length or knee-length stockings, socks and other hosiery, incl. footwear without applied soles, of textile materials, knitted or crocheted (excl. of wool, fine animal hair, cotton or synthetic fibres, graduated compression hosiery, pantyhose and tigh','Medias, calcetines y artículos simil., incl. para varices, de punto, de materia textil (exc. de lana o pelo fino, de algodón o de fibras sintéticas; calzas, "panty-medias", leotardos, medias de mujer de título < 67 decitex y artículos para bebés)',61,6115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611610,'Luvas, mitenes e semelhantes, de malha, impregnadas, revestidas ou recobertas, de plástico ou de borracha','Gloves, mittens and mitts, impregnated, coated or covered with plastics or rubber, knitted or crocheted','Guantes, mitones y manoplas, de punto, impregnados, recubiertos o revestidos con plástico o caucho',61,6116);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611691,'Luvas, mitenes e semelhantes, de malha, de lã ou de pêlos finos','Gloves, mittens and mitts, of wool or fine animal hair, knitted or crocheted (excl. for babies)','Guantes, mitones y manoplas, de punto, de lana o pelo fino (exc. para bebés)',61,6116);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611692,'Luvas, mitenes e semelhantes, de malha, de algodão','Gloves, mittens and mitts, of cotton, knitted or crocheted (excl. impregnated, coated or covered with plastics or rubber, and for babies)','Guantes, mitones y manoplas, de punto, de algodón (exc. los impregnados, recubiertos o revestidos con plástico o caucho, así como guantes, mitones y manoplas para bebés)',61,6116);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611693,'Luvas, mitenes e semelhantes, de malha, de fibras sintéticas','Gloves, mittens and mitts, of synthetic fibres, knitted or crocheted (excl. impregnated, coated or covered with plastics or rubber, and for babies)','Guantes, mitones y manoplas, de punto, de fibras sintéticas (exc. los impregnados, recubiertos o revestidos con plástico o caucho, así como guantes, mitones y manoplas para bebés)',61,6116);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611699,'Luvas, mitenes e semelhantes, de malha, de outras matérias têxteis','Gloves, mittens and mitts, of textile materials, knitted or crocheted (excl. of wool, fine animal hair, cotton or synthetic fibres, impregnated, coated or covered with plastics or rubber, and for babies)','Guantes, mitones y manoplas, de punto, de materia textil (exc. de lana o pelo fino, de algodón o de fibras sintéticas, así como los impregnados, recubiertos o revestidos con plástico o caucho y los guantes, mitones y manoplas para bebés)',61,6116);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611710,'Xales, echarpes, lenços de pescoço, cachenés, mantilhas, véus e semelhantes, de malha','Shawls, scarves, mufflers, mantillas, veils and the like, knitted or crocheted','Chales, pañuelos para de cuello, bufandas, mantillas, velos y artículos simil., de punto',61,6117);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611720,'Gravatas,  gravatas-borboletas e plastrons,  de malha','Ties, bow ties and cravats, of mesh','Corbatas y lazos similares, de punto',61,6117);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611780,'Outros acessórios de vestuário, confeccionados, de malha','Ties, bow ties, cravats and other made-up clothing accessories, knitted or crocheted, n.e.s. (excl. shawls, scarves, mufflers, mantillas, veils and the like)','Complementos "accesorios" de vestir confeccionados, de punto, n.c.o.p. (exc. chales, pañuelos de cuello, bufandas, mantillas, velos y artículos simil.; corbatas y lazos simil.)',61,6117);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (611790,'Partes de vestuários ou de seus acessórios, de malha','Parts of garments or clothing accessories, knitted or crocheted, n.e.s.','Partes de prendas o de complementos "accesorios" de vestir, de punto, n.c.o.p.',61,6117);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620111,'Sobretudos, impermeáveis, japonas, gabões, capas e semelhantes, de lã ou de pêlos finos, de uso masculino','Men''s or boys'' overcoats, raincoats, car coats, capes, cloaks and similar articles, of wool or fine animal hair (excl. knitted or crocheted)','Abrigos, impermeables, chaquetones, capas y artículos simil., de lana o pelo fino, para hombres o niños (exc. de punto)',62,6201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620112,'Sobretudos, impermeáveis, japonas, gabões, capas e semelhantes, de algodão, de uso masculino','Men''s or boys'' overcoats, raincoats, car coats, capes, cloaks and similar articles, of cotton (excl. knitted or crocheted)','Abrigos, impermeables, chaquetones, capas y artículos simil., de algodón, para hombres o niños (exc. de punto)',62,6201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620113,'Sobretudos, impermeáveis, japonas, gabões, capas e semelhantes, de fibras sintéticas ou artificiais, de uso masculino','Men''s or boys'' overcoats, raincoats, car coats, capes, cloaks and similar articles, of man-made fibres (excl. knitted or crocheted)','Abrigos, impermeables, chaquetones, capas y artículos simil., de fibras sintéticas o artificiales, para hombres o niños (exc. de punto)',62,6201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620119,'Sobretudos, impermeáveis, japonas, gabões, capas e semelhantes, de outras matérias têxteis, de uso masculino','Men''s or boys'' overcoats, raincoats, car coats, capes, cloaks and similar articles, of textile materials (excl. of wool or fine animal hair, cotton or man-made fibres, knitted or crocheted)','Abrigos, impermeables, chaquetones, capas y artículos simil., de materia textil, para hombres o niños (exc. de lana o pelo fino, de algodón o de fibras sintéticas o artificiales, así como de punto)',62,6201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620191,'Outros sobretudos, anoraques e artigos semelhantes, de lã ou de pêlos finos, de uso masculino','Men''s or boys'' anoraks, incl. ski jackets, windcheaters, wind-jackets and similar articles, of wool or fine animal hair (excl. knitted or crocheted, suits, ensembles, jackets, blazers and trousers)','Anoraks, cazadoras y artículos simil., de lana o pelo fino, para hombres o niños (exc. de punto, así como trajes o ternos, conjuntos, chaquetas "sacos", incl. los "blazer", y pantalones)',62,6201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620192,'Outros sobretudos, anoraques e artigos semelhantes, de algodão, de uso masculino','Men''s or boys'' anoraks, windcheaters, wind jackets and similar articles, of cotton (not knitted or crocheted and excl. suits, ensembles, jackets, blazers, trousers and tops of ski suits)','Anoraks, cazadoras y artículos simil., de algodón, para hombres o niños (exc. de punto, así como trajes o ternos, conjuntos, chaquetas "sacos", incl. los "blazer", pantalones y la parte superior de los conjuntos de esquí)',62,6201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620193,'Outros sobretudos, anoraques e semelhantes, de fibras sintéticas ou artificiais, de uso masculino','Men''s or boys'' anoraks, windcheaters, wind jackets and similar articles, of man-made fibres (not knitted or crocheted and excl. suits, ensembles, jackets, blazers, trousers and tops of ski suits)','Anoraks, cazadoras y artículos simil., de fibras sintéticas o artificiales, para hombres o niños (exc. de punto, así como trajes o ternos, conjuntos, chaquetas "sacos", incl. los "blazer", pantalones y la parte superior de los conjuntos de esquí)',62,6201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620199,'Outros sobretudos, anoraques e semelhantes, de outras matérias têxteis, de uso masculino','Men''s or boys'' anoraks, incl. ski jackets, windcheaters, wind-jackets and similar articles of textile materials (excl. of wool, fine animal hair, cotton or man-made fibres, knitted or crocheted, suits, ensembles, jackets, blazers and trousers)','Anoraks, cazadoras y artículos simil., de materia textil, para hombres o niños (exc. de lana o pelo fino, de algodón y de fibras sintéticas o artificiales, así como de punto y los trajes o ternos, conjuntos, chaquetas "sacos", incl. los "blazer", y pantal',62,6201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620211,'Mantôs, impermeáveis, capas e semelhantes, de lã ou de pêlos finos, de uso feminino','Women''s or girls'' overcoats, raincoats, car coats, capes, cloaks and similar articles, of wool or fine animal hair (excl. knitted or crocheted)','Abrigos, impermeables, chaquetones, capas y artículos simil., de lana o pelo fino, para mujeres o niñas (exc. de punto)',62,6202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620212,'Mantôs, impermeáveis, capas e semelhantes, de algodão, de uso feminino','Women''s or girls'' overcoats, raincoats, car coats, capes, cloaks and similar articles, of cotton (excl. knitted or crocheted)','Abrigos, impermeables, chaquetones, capas y artículos simil., de algodón, para mujeres o niñas (exc. de punto)',62,6202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620213,'Mantôs, impermeáveis, capas e semelhantes, de fibras sintéticas ou artificiais, de uso feminino','Women''s or girls'' overcoats, raincoats, car coats, capes, cloaks and similar articles, of man-made fibres (excl. knitted or crocheted)','Abrigos, impermeables, chaquetones, capas y artículos simil., de fibras sintéticas o artificiales, para mujeres o niñas (exc. de punto)',62,6202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620219,'Mantôs, impermeáveis, capas e semelhantes, de outras matérias têxteis, de uso feminino','Women''s or girls'' overcoats, raincoats, car coats, capes, cloaks and similar articles, of textile materials (excl. of wool or fine animal hair, cotton or man-made fibres, knitted or crocheted)','Abrigos, impermeables, chaquetones, capas y artículos simil., de materia textil, para mujeres o niñas (exc. de lana o pelo fino, de algodón o de fibras sintéticas o artificiales, así como de punto)',62,6202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620291,'Outros mantôs, anoraques e semelhantes, de lã ou pêlos finos, de uso feminino','Women''s or girls'' anoraks, incl. ski jackets, windcheaters, wind-jackets and similar articles, of wool or fine animal hair (excl. knitted or crocheted, suits, ensembles, jackets, blazers and trousers)','Anoraks, cazadoras y artículos simil., de lana o pelo fino, para mujeres o niñas (exc. de punto, así como trajes sastre, conjuntos, chaquetas "sacos", incl. los "blazer", vestidos, faldas, faldas pantalón y pantalones)',62,6202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620292,'Outros mantôs, anoraques e semelhantes, de algodão, de uso feminino','Women''s or girls'' anoraks, windcheaters, wind jackets and similar articles, of cotton (not knitted or crocheted and excl. suits, ensembles, jackets, blazers, trousers and tops of ski suits)','Anoraks, cazadoras y artículos simil., de algodón, para mujeres o niñas (exc. de punto, así como trajes sastre, conjuntos, chaquetas "sacos", incl. los "blazer", vestidos, faldas, faldas pantalón, pantalones y la parte superior de los conjuntos de esquí)',62,6202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620293,'Outros mantôs, anoraques e semelhantes, de fibras sintéticas ou artificiais, de uso feminino','Women''s or girls'' anoraks, windcheaters, wind jackets and similar articles, of man-made fibres (not knitted or crocheted and excl. suits, ensembles, jackets, blazers, trousers and tops of ski suits)','Anoraks, cazadoras y artículos simil., de fibras sintéticas o artificiales, para mujeres o niñas (exc. de punto, así como trajes sastre, conjuntos, chaquetas "sacos", incl. los "blazer", vestidos, faldas, faldas pantalón, pantalones y la parte superior de',62,6202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620299,'Outros mantôs, anoraques e semelhantes, de outras matérias têxteis, de uso feminino','Women''s or girls'' anoraks, incl. ski jackets, windcheaters, wind-jackets and similar articles, of textile materials (excl. of wool, fine animal hair, cotton or man-made fibres, knitted or crocheted, suits, ensembles, jackets, blazers and trousers)','Anoraks, cazadoras y artículos simil., de materia textil, para mujeres o niñas (exc. de lana o pelo fino, de algodón y de fibras sintéticas o artificiales, así como de punto y los trajes sastre, conjuntos, chaquetas "sacos", incl. los "blazer", vestidos, ',62,6202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620311,'Ternos (fatos), de lã ou de pêlos finos, de uso masculino','Men''s or boys'' suits of wool or fine animal hair (excl. knitted or crocheted, tracksuits, ski suits and swimwear)','Trajes "ambos o ternos" de lana o pelo fino, para hombres o niños (exc. de punto, así como prendas de deporte, monos "overoles", conjuntos de esquí y trajes de baño)',62,6203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620312,'Ternos (fatos), de fibras sintéticas, de uso masculino','Men''s or boys'' suits of synthetic fibres (excl. knitted or crocheted, tracksuits, ski suits and swimwear)','Trajes "ambos o ternos" de fibras sintéticas, para hombres o niños (exc. de punto, así como prendas de deporte, monos "overoles", conjuntos de esquí y trajes de baño)',62,6203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620319,'Ternos (fatos), de outras matérias têxteis, de uso masculino','Men''s or boys'' suits of textile materials (excl. of wool, fine animal hair or synthetic fibres, knitted or crocheted, tracksuits, ski suits and swimwear)','Trajes "ambos o ternos" de materia textil, para hombres o niños (exc. de lana o pelo fino o de fibras sintéticas o de punto, así como prendas de deporte, monos "overoles", conjuntos de esquí y trajes de baño)',62,6203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620321,'Conjuntos de lã ou de pêlos finos, de uso masculino','Men''s or boys'' ensembles, of wool or fine animal hair','Conjuntos de lana o pelo fino, para hombres',62,6203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620322,'Conjuntos de algodão, de uso masculino','Men''s or boys'' ensembles of cotton (excl. knitted or crocheted, ski ensembles and swimwear)','Conjuntos de algodón, para hombres o niños (exc. de punto, monos "overoles", conjuntos de esquí y trajes de baño)',62,6203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620323,'Conjuntos de fibras sintéticas, de uso masculino','Men''s or boys'' ensembles of synthetic fibres (excl. knitted or crocheted, ski ensembles and swimwear)','Conjuntos de fibras sintéticas, para hombres o niños (exc. de punto, monos "overoles", conjuntos de esquí y trajes de baño)',62,6203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620329,'Conjuntos de outras matérias têxteis, de uso masculino','Men''s or boys'' ensembles of textile materials (excl. of cotton or synthetic fibres, knitted or crocheted, ski ensembles and swimwear)','Conjuntos de materia textil, para hombres o niños (exc. de lana o pelo fino, de algodón o de fibras sintéticas o de punto, así como monos "overoles", conjuntos de esquí y trajes de baño)',62,6203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620331,'Paletós (casacos), de lã ou de pêlos finos, de uso masculino','Men''s or boys'' jackets and blazers of wool or fine animal hair (excl. knitted or crocheted, and wind-jackets and similar articles)','Chaquetas "sacos" de lana o pelo fino, para hombres o niños (exc. de punto, así como cazadoras y artículos simil.)',62,6203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620332,'Paletós (casacos), de algodão, de uso masculino','Men''s or boys'' jackets and blazers of cotton (excl. knitted or crocheted, and wind-jackets and similar articles)','Chaquetas "sacos" de algodón, para hombres o niños (exc. de punto, cazadoras y artículos simil.)',62,6203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620333,'Paletós (casacos), de fibras sintéticas, de uso masculino','Men''s or boys'' jackets and blazers of synthetic fibres (excl. knitted or crocheted, and wind-jackets and similar articles)','Chaquetas "sacos" de fibras sintéticas, para hombres o niños (exc. de punto, cazadoras y artículos simil.)',62,6203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620339,'Paletós (casacos), de outras matérias têxteis, de uso masculino','Men''s or boys'' jackets and blazers of textile materials (excl. of wool, fine animal hair, cotton or synthetic fibres, knitted or crocheted, and wind-jackets and similar articles)','Chaquetas "sacos" de materia textil, para hombres o niños (exc. de lana o pelo fino, de algodón o de fibras sintéticas y de punto, así como cazadoras y artículos simil.)',62,6203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620341,'Calças, jardineiras, bermudas e shorts, de lã ou de pêlos finos, de uso masculino','Men''s or boys'' trousers, bib and brace overalls, breeches and shorts, of wool or fine animal hair (excl. knitted or crocheted, underpants and swimwear)','Pantalones largos, pantalones con peto, pantalones cortos "calzones" y "shorts", de lana o pelo fino, para hombres o niños (exc. de punto, calzoncillos y pantalones de baño)',62,6203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620342,'Calças, jardineiras, bermudas e shorts, de algodão, de uso masculino','Men''s or boys'' trousers, bib and brace overalls, breeches and shorts, of cotton (excl. knitted or crocheted, underpants and swimwear)','Pantalones largos, pantalones con peto, pantalones cortos "calzones" y "shorts", de algodón, para hombres o niños (exc. de punto, calzoncillos y pantalones de baño)',62,6203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620343,'Calças, jardineiras, bermudas e shorts, de fibras sintéticas, de uso masculino','Men''s or boys'' trousers, bib and brace overalls, breeches and shorts of synthetic fibres (excl. knitted or crocheted, underpants and swimwear)','Pantalones largos, pantalones con peto, pantalones cortos "calzones" y "shorts", de fibras sintéticas, para hombres o niños (exc. de punto, calzoncillos y pantalones de baño)',62,6203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620349,'Calças, jardineiras, bermudas e shorts, de outras matérias têxteis, de uso masculino','Men''s or boys'' trousers, bib and brace overalls, breeches and shorts of textile materials (excl. of wool, fine animal hair, cotton or synthetic fibres, knitted or crocheted, underpants and swimwear)','Pantalones largos, pantalones con peto, pantalones cortos "calzones" y "shorts", de materia textil, para hombres o niños (exc. de lana o pelo fino, de algodón, de fibras sintéticas o de punto, así como calzoncillos y pantalones de baño)',62,6203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620411,'Tailleurs (fatos saia-casaco), de lã ou de pêlos finos, de uso feminino','Women''s or girls'' suits of wool or fine animal hair (excl. knitted or crocheted, ski overalls and swimwear)','Trajes sastre, de lana o pelo fino, para mujeres o niñas (exc. de punto, así como monos de esquí y trajes de baño)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620412,'Tailleurs (fatos de saia-casaco), de algodão, de uso feminino','Women''s or girls'' suits of cotton (excl. knitted or crocheted, ski overalls and swimwear)','Trajes sastre, de algodón, para mujeres o niñas (exc. de punto, así como monos de esquí y trajes de baño)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620413,'Tailleurs (fatos de saia-casaco), de fibras sintéticas, de uso feminino','Women''s or girls'' suits of synthetic fibres (excl. knitted or crocheted, ski overalls and swimwear)','Trajes sastre, de fibras sintéticas, para mujeres o niñas (exc. de punto, así como monos de esquí y trajes de baño)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620419,'Tailleurs (fatos de saia-casaco), de outras matérias têxteis, de uso feminino','Women''s or girls'' suits of textile materials (excl. of wool, fine animal hair, cotton or synthetic fibres, knitted or crocheted, ski overalls and swimwear)','Trajes sastre, de materia textil, para mujeres o niñas (exc. de lana o pelo fino, de algodón o de fibras sintéticas o de punto, así como monos de esquí y trajes de baño)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620421,'Conjuntos de lã ou de pêlos finos, de uso feminino','Women''s or girls'' ensembles of wool or fine animal hair (excl. knitted or crocheted, ski overalls and swimwear)','Conjuntos de lana o pelo fino, para mujeres o niñas (exc. de punto, así como conjuntos de esquí y trajes de baño)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620422,'Conjuntos de algodão, de uso feminino','Women''s or girls'' ensembles of cotton (excl. knitted or crocheted, ski overalls and swimwear)','Conjuntos de algodón, para mujeres o niñas (exc. de punto, así como conjuntos de esquí y trajes de baño)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620423,'Conjuntos de fibras sintéticas, de uso feminino','Women''s or girls'' ensembles of synthetic fibres (excl. knitted or crocheted, ski overalls and swimwear)','Conjuntos de fibras sintéticas, para mujeres o niñas (exc. de punto, así como conjuntos de esquí y trajes de baño)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620429,'Conjuntos de outras matérias têxteis, de uso feminino','Women''s or girls'' ensembles of textile materials (excl. of wool, fine animal hair, cotton or synthetic fibres, knitted or crocheted, ski overalls and swimwear)','Conjuntos de materia textil, para mujeres o niñas (exc. de lana o pelo fino, de algodón o de fibras sintéticas o de punto, así como conjuntos de esquí y trajes de baño)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620431,'Blazers (casacos) de lã ou de pêlos finos, de uso feminino','Women''s or girls'' jackets and blazers of wool or fine animal hair (excl. knitted or crocheted, wind-jackets and similar articles)','Chaquetas "sacos" de lana o pelo fino, para mujeres o niñas (exc. de punto, así como cazadoras y artículos simil.)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620432,'Blazers (casacos) de algodão, de uso feminino','Women''s or girls'' jackets and blazers of cotton (excl. knitted or crocheted, wind-jackets and similar articles)','Chaquetas "sacos" de algodón, para mujeres o niñas (exc. de punto, así como cazadoras y artículos simil.)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620433,'Blazers (casacos) de fibras sintéticas, de uso feminino','Women''s or girls'' jackets and blazers of synthetic fibres (excl. knitted or crocheted, wind-jackets and similar articles)','Chaquetas "sacos" de fibras sintéticas, para mujeres o niñas (exc. de punto, así como cazadoras y artículos simil.)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620439,'Blazers (casacos) de outras matérias têxteis, de uso feminino','Women''s or girls'' jackets and blazers of textile materials (excl. of wool, fine animal hair, cotton or synthetic fibres, knitted or crocheted, wind-jackets and similar articles)','Chaquetas "sacos" de materia textil, para mujeres o niñas (exc. de lana o pelo fino, de algodón, de fibras sintéticas y de punto, así como cazadoras y artículos simil.)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620441,'Vestidos de lã ou de pêlos finos, de uso feminino','Women''s or girls'' dresses of wool or fine animal hair (excl. knitted or crocheted and petticoats)','Vestidos de lana o pelo fino, para mujeres o niñas (exc. de punto, así como combinaciones)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620442,'Vestidos de algodão, de uso feminino','Women''s or girls'' dresses of cotton (excl. knitted or crocheted and petticoats)','Vestidos de algodón, para mujeres o niñas (exc. de punto, así como combinaciones)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620443,'Vestidos de fibras sintéticas, de uso feminino','Women''s or girls'' dresses of synthetic fibres (excl. knitted or crocheted and petticoats)','Vestidos de fibras sintéticas, para mujeres o niñas (exc. de punto, así como combinaciones)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620444,'Vestidos de fibras artificiais, de uso feminino','Women''s or girls'' dresses of artificial fibres (excl. knitted or crocheted and petticoats)','Vestidos de fibras artificiales, para mujeres o niñas (exc. de punto, así como combinaciones)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620449,'Vestidos de outras matérias têxteis, de uso feminino','Women''s or girls'' dresses of textile materials (excl. of wool, fine animal hair, cotton or man-made fibres, knitted or crocheted and petticoats)','Vestidos de materia textil, para mujeres o niñas (exc. de lana o pelo fino, de algodón o de fibras sintéticas o artificiales, así como de punto y las combinaciones)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620451,'Saias e saias-calças, de lã ou de pêlos finos, de uso feminino','Women''s or girls'' skirts and divided skirts of wool or fine animal hair (excl. knitted or crocheted and petticoats)','Faldas y faldas pantalón, de lana o pelo fino, para mujeres o niñas (exc. de punto, así como las enaguas)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620452,'Saias e saias-calças, de algodão, de uso feminino','Women''s or girls'' skirts and divided skirts of cotton (excl. knitted or crocheted and petticoats)','Faldas y faldas pantalón, de algodón, para mujeres o niñas (exc. de punto, así como las enaguas)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620453,'Saias e saias-calças, de fibras sintéticas, de uso feminino','Women''s or girls'' skirts and divided skirts of synthetic fibres (excl. knitted or crocheted and petticoats)','Faldas y faldas pantalón, de fibras sintéticas, para mujeres o niñas (exc. de punto, así como las enaguas)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620459,'Saias e saias-calças, de outras matérias têxteis, de uso feminino','Women''s or girls'' skirts and divided skirts of textile materials (excl. of wool, fine animal hair, cotton or synthetic fibres, knitted or crocheted and petticoats)','Faldas y faldas pantalón, de materia textil, para mujeres o niñas (exc. de lana o pelo fino, de algodón o de fibras sintéticas, así como de punto y las enaguas)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620461,'Calças, jardineiras, bermudas e shorts, de lã ou de pêlos finos, de uso feminino','Women''s or girls'' trousers, bib and brace overalls, breeches and shorts of wool or fine animal hair (excl. knitted or crocheted, panties and swimwear)','Pantalones largos, pantalones con peto, pantalones cortos "calzones" y "shorts", de lana o pelo fino, para mujeres o niñas (exc. de punto, así como bragas y trajes de baño)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620462,'Calças, jardineiras, bermudas e shorts, de algodão, de uso feminino','Women''s or girls'' trousers, bib and brace overalls, breeches and shorts of cotton (excl. knitted or crocheted, panties and swimwear)','Pantalones largos, pantalones con peto, pantalones cortos "calzones" y "shorts", de algodón, para mujeres o niñas (exc. de punto, así como bragas y trajes de baño)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620463,'Calças, jardineiras, bermudas e shorts, de fibras sintéticas, de uso feminino','Women''s or girls'' trousers, bib and brace overalls, breeches and shorts of synthetic fibres (excl. knitted or crocheted, panties and swimwear)','Pantalones largos, pantalones con peto, pantalones cortos "calzones" y "shorts", de fibras sintéticas, para mujeres o niñas (exc. de punto, bragas y trajes de baño)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620469,'Calças, jardineiras, bermudas e shorts, de outras matérias têxteis, de uso feminino','Women''s or girls'' trousers, bib and brace overalls, breeches and shorts of textile materials (excl. of wool, fine animal hair, cotton or synthetic fibres, knitted or crocheted, panties and swimwear)','Pantalones largos, pantalones con peto, pantalones cortos "calzones" y "shorts", para mujeres o niñas (exc. de lana o pelo fino, de algodón, de fibras sintéticas o de punto, así como bragas y trajes de baño)',62,6204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620510,'Camisas de lã ou de pêlos finos, de uso masculino','Men''s or boys'' shirts, of wool or fine animal air','Camisas de lana o pelo fino, para hombres',62,6205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620520,'Camisas de algodão, de uso masculino','Men''s or boys'' shirts of cotton (excl. knitted or crocheted, nightshirts, singlets and other vests)','Camisas de algodón, para hombres o niños (exc. de punto, así como camisones y camisetas)',62,6205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620530,'Camisas de fibras sintéticas ou artificiais, de uso masculino','Men''s or boys'' shirts of man-made fibres (excl. knitted or crocheted, nightshirts, singlets and other vests)','Camisas de fibras sintéticas o artificiales, para hombres o niños (exc. de punto, así como camisones y camisetas)',62,6205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620590,'Camisas de outras matérias têxteis, de uso masculino','Men''s or boys'' shirts of textile materials (excl. of cotton or man-made fibres, knitted or crocheted, nightshirts, singlets and other vests)','Camisas de materia textil, para hombres o niños (exc. de lana o pelo fino, de algodón, de fibras sintéticas o artificiales y de punto, así como camisones y camisetas)',62,6205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620610,'Camisas, blusas, blusas chemisiers, de seda ou de seus desperdícios, de uso feminino','Women''s or girls'' blouses, shirts and shirt-blouses of silk or silk waste (excl. knitted or crocheted and vests)','Camisas, blusas y blusas camiseras, de seda o desperdicios de seda, para mujeres o niñas (exc. de punto y camisetas)',62,6206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620620,'Camisas, blusas, blusas chemisiers, de lã ou de pêlos finos, de uso feminino','Women''s or girls'' blouses, shirts and shirt-blouses of wool or fine animal hair (excl. knitted or crocheted and vests)','Camisas, blusas y blusas camiseras, de lana o pelo fino, para mujeres o niñas (exc. de punto y camisetas)',62,6206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620630,'Camisas, blusas, blusas chemisiers, de algodão, de uso feminino','Women''s or girls'' blouses, shirts and shirt-blouses of cotton (excl. knitted or crocheted and vests)','Camisas, blusas y blusas camiseras, de algodón, para mujeres o niñas (exc. de punto y camisetas)',62,6206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620640,'Camisas, blusas, blusas chemisiers, de fibras sintéticas ou artificiais, de uso feminino','Women''s or girls'' blouses, shirts and shirt-blouses of man-made fibres (excl. knitted or crocheted and vests)','Camisas, blusas y blusas camiseras, de fibras sintéticas o artificiales, para mujeres o niñas (exc. de punto y camisetas)',62,6206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620690,'Camisas, blusas, blusas chemisiers, de outras matérias têxteis, de uso feminino','Women''s or girls'' blouses, shirts and shirt-blouses of textile materials (excl. of silk, silk waste, wool, fine animal hair, cotton or man-made fibres, knitted or crocheted and vests)','Camisas, blusas y blusas camiseras, de materia textil, para mujeres o niñas (exc. de seda o desperdicios de seda, de lana o pelo fino, de algodón y de fibras sintéticas o artificiales, así como de punto y camisetas)',62,6206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620711,'Cuecas e ceroulas, de algodão','Men''s or boys'' underpants and briefs of cotton (excl. knitted or crocheted)','Calzoncillos, incl. los largos y los "slips", de algodón, para hombres o niños (exc. de punto)',62,6207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620719,'Cuecas e ceroulas, de outras matérias têxteis','Men''s or boys'' underpants and briefs of textile materials (excl. cotton and knitted or crocheted)','Calzoncillos, incl. los largos y los "slips", de materia textil, para hombres o niños (exc. de algodón y de punto)',62,6207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620721,'Camisolões e pijamas, de algodão, de uso masculino','Men''s or boys'' nightshirts and pyjamas of cotton (excl. knitted or crocheted, vests, singlets and underpants)','Camisones y pijamas, de algodón, para hombres o niños (exc. de punto, así como camisetas y calzoncillos)',62,6207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620722,'Camisolões e pijamas, de fibras sintéticas ou artificiais, de uso masculino','Men''s or boys'' nightshirts and pyjamas of man-made fibres (excl. knitted or crocheted, vests, singlets and underpants)','Camisones y pijamas, de fibras sintéticas o artificiales, para hombres o niños (exc. de punto, así como camisetas y calzoncillos)',62,6207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620729,'Camisolões e pijamas, de outras matérias têxteis, de uso masculino','Men''s or boys'' nightshirts and pyjamas of textile materials (excl. of cotton or man-made fibres, knitted or crocheted, vests, singlets and underpants)','Camisones y pijamas, de materia textil, para hombres o niños (exc. de algodón, de fibras sintéticas o artificiales y de punto, así como camisetas y calzoncillos)',62,6207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620791,'Camisetas interiores, robes e semelhantes, de algodão, de uso masculino','Men''s or boys'' singlets and other vests, bathrobes, dressing gowns and similar articles of cotton (excl. knitted or crocheted, underpants, nightshirts and pyjamas)','Camisetas interiores, albornoces de baño, batas de casa y artículos simil., de algodón, para hombres o niños (exc. de punto, así como calzoncillos, camisones y pijamas)',62,6207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620792,'Camisetas interiores, etc.de fibras sint/artif.masculino','Singlets, etc.of synth/artific fibres, feminine uses','Samisetas interiores, etc.de fibras sint/artif, p/hombres',62,6207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620799,'Camisetas interiores, robes e semelhantes, de outras matérias têxteis, de uso masculino','Men''s or boys'' singlets and other vests, bathrobes and dressing gowns of textile materials (excl. of cotton, knitted or crocheted, underpants, nightshirts and pyjamas)','Camisetas interiores, albornoces de baño, batas de casa y artículos simil., de materia textil, para hombres o niños (exc. de algodón, de fibras sintéticas o artificiales y de punto, así como calzoncillos, camisones y pijamas)',62,6207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620811,'Combinações e anáguas, de fibras sintéticas ou artificiais, de uso feminino','Women''s or girls'' slips and petticoats of man-made fibres (excl. knitted or crocheted and vests)','Combinaciones y enaguas, de fibras sintéticas o artificiales, para mujeres o niñas (exc. de punto, así como las camisetas)',62,6208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620819,'Combinações e anáguas, de outras matérias têxteis, de uso feminino','Women''s or girls'' slips and petticoats of textile materials (excl. man-made fibres, knitted or crocheted and vests)','Combinaciones y enaguas, de materia textil, para mujeres o niñas (exc. de fibras sintéticas o artificiales y de punto, así como las camisetas)',62,6208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620821,'Camisolas e pijamas, de algodão, de uso feminino','Women''s or girls'' nightdresses and pyjamas of cotton (excl. knitted or crocheted, vests and négligés)','Camisones y pijamas, de algodón, para mujeres o niñas (exc. de punto, así como camisetas y saltos de cama)',62,6208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620822,'Camisolas e pijamas, de fibras sintéticas ou artificiais, de uso feminino','Women''s or girls'' nightdresses and pyjamas of man-made fibres (excl. knitted or crocheted, vests and négligés)','Camisones y pijamas, de fibras sintéticas o artificiales, para mujeres o niñas (exc. de punto, así como camisetas y saltos de cama)',62,6208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620829,'Camisolas e pijamas, de outras matérias têxteis, de uso feminino','Women''s or girls'' nightdresses and pyjamas of textile materials (excl. cotton and man-made fibres, knitted or crocheted, vests and négligés)','Camisones y pijamas, de materia textil, para mujeres o niñas (exc. de algodón, de fibras sintéticas o artificiales y de punto, así como camisetas y saltos de cama)',62,6208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620891,'Corpetes, calcinhas, penhoares e artefatos semelhantes, de algodão','Women''s or girls'' singlets and other vests, briefs, panties, négligés, bathrobes, dressing gowns, housecoats and similar articles of cotton (excl. knitted or crocheted, slips, petticoats, nightdresses and pyjamas, brassières, girdles, corsets and simila','Camisetas interiores, bragas "bombachas, calzones", incl. las que no llegan hasta la cintura, saltos de cama, albornoces de baño, batas de casa y artículos simil., de algodón, para mujeres o niñas (exc. de punto, así como combinaciones, enaguas, pijamas, ',62,6208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620892,'Corpetes, calcinhas, penhoares e artefatos semelhantes, de fibras sintéticas ou artificiais','Women''s or girls'' singlets and other vests, briefs, panties, négligés, bathrobes, dressing gowns, housecoats and similar articles of man-made fibres (excl. knitted or crocheted, slips, petticoats, nightdresses and pyjamas, brassières, girdles, corsets a','Camisetas interiores, bragas "bombachas, calzones", incl. las que no llegan hasta la cintura, saltos de cama, albornoces de baño, batas de casa y artículos simil., de fibras sintéticas o artificiales, para mujeres o niñas (exc. de punto, así como combinac',62,6208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620899,'Corpetes, calcinhas, penhoares e artefatos semelhantes, de outras matérias têxteis','Women''s or girls'' singlets and other vests, briefs, panties, négligés, bathrobes, dressing gowns, housecoats and similar articles of textile materials (excl. of cotton or man-made fibres, knitted or crocheted, slips, petticoats, nightdresses and pyjamas','Camisetas interiores, bragas "bombachas, calzones", incl. las que no llegan hasta la cintura, saltos de cama, albornoces de baño, batas de casa y artículos simil., de materia textil, para mujeres o niñas (exc. de algodón, de fibras sintéticas o artificial',62,6208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620910,'vestuário p/bebes e acessórios,  de la ou de pêlos finos','babies'' garments/clothing acces.of wool/fine anim.hair','prendas y complementos para bebés, de lana o pelo fino',62,6209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620920,'Vestuários e seus acessórios de algodão, para bebês','Babies'' garments and clothing accessories of cotton (excl. knitted or crocheted and hats)','Prendas y complementos "accesorios", de vestir, de algodón, para bebés (exc. de punto, así como las gorras)',62,6209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620930,'Vestuários e seus acessórios de fibras sintéticas, para bebês','Babies'' garments and clothing accessories of synthetic fibres (excl. knitted or crocheted and hats)','Prendas y complementos "accesorios", de vestir, de fibras sintéticas, para bebés (exc. de punto, así como las gorras)',62,6209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (620990,'Vestuários e seus acessórios de outras matérias têxteis, para bebês','Babies'' garments and clothing accessories of textile materials (excl. of cotton or synthetic fibres, knitted or crocheted and hats)','Prendas y complementos "accesorios", de vestir, de materia textil, para bebés (exc. de lana o pelo fino, de algodón, de fibras sintéticas y de punto, así como las gorras)',62,6209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621010,'Vestuário confeccionado com feltros ou falsos tecidos','Garments made up of felt or nonwovens, whether or not impregnated, coated, covered or laminated (excl. babies'' garments and clothing accessories)','Prendas de vestir confeccionadas con fieltro y tela sin tejer, incl. impregnadas, recubiertas, revestidas o estratificadas (exc. prendas para bebés y complementos "accesorios" de vestir)',62,6210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621020,'Sobretudos, impermeáveis e artigos semelhantes, confeccionados com feltros, filamentos sintéticos ou tecidos revestidos de plástico ou borracha, de uso masculino','Garments of the type described in subheading 6201,11 to 6201,19, rubberised or impregnated, coated, covered or laminated with plastics or other substances','Prendas de vestir del tipo de las citadas en las subpartidas 6201.11 a 6201.19, cauchutadas o impregnados, recubiertos o revestidos de plástico u otra materia',62,6210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621030,'Outros mantôs, impermeáveis, capas e semelhantes, confeccionados com feltro, falsos tecidos, tecidos com borracha, plástico ou demais tecidos impregnados, revestidos ou recobertos ou estratificados, de uso feminino','Garments of the type described in subheading 6202,11 to 6202,19, rubberised or impregnated, coated, covered or laminated with plastics or other substances','Prendas de vestir del tipo de las citadas en las subpartidas 6202.11 a 6202.19, cauchutadas o impregnados, recubiertos o revestidos de plástico u otra materia',62,6210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621040,'Outro vestuário confeccionado com feltros, filamentos sintéticos ou tecidos revestidos de plástico ou borracha, de uso masculino','Men''s or boys'' garments of textile fabrics, rubberised or impregnated, coated, covered or laminated with plastics or other substances (excl. of the type described in subheading 6201,11 to 6201,19, and babies'' garments and clothing accessories)','Prendas de vestir confeccionadas con tejidos distintos de los de punto, cauchutados o impregnados, recubiertos o revestidos de plástico u otra materia, para hombres o niños (exc. las prendas de vestir del tipo de las citadas en las subpartidas 6201.11 a 6',62,6210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621050,'Outro vestuário confeccionado com feltro, falsos tecidos, tecidos com borracha, plástico ou demais tecidos impregnados, revestidos ou recobertos ou estratificados, de uso feminino','Women''s or girls'' garments of textile fabrics, rubberised or impregnated, coated, covered or laminated with plastics or other substances (excl. of the type described in subheading 6202,11 to 6202,19, and babies'' garments and clothing accessories)','Prendas de vestir confeccionadas con tejidos distintos de los de punto, cauchutados o impregnados, recubiertos o revestidos de plástico u otra materia, para mujeres o niñas (exc. las prendas de vestir del tipo de las citadas en las subpartidas 6202.11 a 6',62,6210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621111,'Shorts e sungas, de banho, exceto de malha, de uso masculino','Men''s or boys'' swimwear (excl. knitted or crocheted)','Bañadores para hombres o niños (exc. de punto)',62,6211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621112,'Maiôs e biquínis, de banho, exceto de malha, de uso feminino','Women''s or girls'' swimwear (excl. knitted or crocheted)','Bañadores para mujeres o niñas (exc. de punto)',62,6211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621120,'Macacões e conjuntos, de esqui, exceto de malha','Ski suits (excl. knitted or crocheted)','Monos "overoles" y conjuntos de esquí (exc. de punto)',62,6211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621131,'outros vestuários de la ou pêlos finos, de uso masculino','other garments of wool or fine animal hair, masculine uses','otras prendas de vestir de lana/pelo fino, para hombres',62,6211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621132,'Abrigos (fatos de treino) para esporte e outro vestuário não classificado em outra parte, de algodão, de uso masculino','Men''s or boys'' tracksuits and other garments, n.e.s. of cotton (excl. knitted or crocheted)','Prendas de vestir para entrenamiento o deporte "chandales", así como otras prendas de vestir, n.c.o.p., de algodón, para hombres o niños (exc. de punto)',62,6211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621133,'Abrigos (fatos de treino) para esporte e outro vestuário não classificado em outra parte, de fibras sintéticas ou artificiais, de uso masculino','Men''s or boys'' tracksuits and other garments, n.e.s. of man-made fibres (excl. knitted or crocheted)','Conjuntos de abrigo para entrenamiento o deporte "chandales", así como otras prendas de vestir, n.c.o.p., de fibras sintéticas o artificiales, para hombres o niños (exc. de punto)',62,6211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621139,'Abrigos (fatos de treino) para esporte e outro vestuário não classificado em outra parte, de outras matérias têxteis, de uso masculino','Men''s or boys'' tracksuits and other garments, n.e.s. of textile materials (excl. of cotton or man-made fibres, knitted or crocheted)','Conjuntos de abrigo para entrenamiento o deporte "chandales", así como otras prendas de vestir, n.c.o.p., de materia textil, para hombres o niños (exc. de lana o pelo fino, de algodón, de fibras sintéticas o artificiales y de punto)',62,6211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621141,'Abrigos (fatos de treino) para esporte e outro vestuário não classificado em outra parte, de lã ou de pêlos finos, de uso feminino','Women''s or girls'' tracksuits and other garments, n.e.s. of wool or fine animal hair (excl. knitted or crocheted)','Conjuntos de abrigo para entrenamiento o deporte "chandales", así como otras prendas de vestir, n.c.o.p., de lana o pelo fino, para mujeres o niñas (exc. de punto)',62,6211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621142,'Abrigos (fatos de treino) para esporte e outro vestuário não classificado em outra parte, de algodão, de uso feminino','Women''s or girls'' tracksuits and other garments, n.e.s. of cotton (excl. knitted or crocheted)','Conjuntos de abrigo para entrenamiento o deporte "chandales", así como otras prendas de vestir, n.c.o.p., de algodón, para mujeres o niñas (exc. de punto)',62,6211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621143,'Abrigos (fatos de treino) para esporte e outro vestuário não classificado em outra parte, de fibras sintéticas ou artificiais, de uso feminino','Women''s or girls'' tracksuits and other garments, n.e.s. of man-made fibres (excl. knitted or crocheted)','Conjuntos de abrigo para entrenamiento o deporte "chandales", así como otras prendas de vestir, n.c.o.p., de fibras sintéticas o artificiales, para mujeres o niñas (exc. de punto)',62,6211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621149,'Abrigos (fatos de treino) para esporte e outro vestuário não classificado em outra parte, de outras matérias têxteis, de uso feminino','Women''s or girls'' tracksuits and other garments, n.e.s. of textile materials (excl. of wool, fine animal hair, cotton or man-made fibres, knitted or crocheted)','Conjuntos de abrigo para entrenamiento o deporte "chandales", así como otras prendas de vestir, n.c.o.p., de materia textil, para mujeres o niñas (exc. de lana o pelo fino, de algodón, de fibras sintéticas o artificiales y de punto)',62,6211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621210,'Sutiãs e bustiers (soutiens de cós alto)','Brassieres of all types of textile materials, whether or not elasticated, incl. knitted or crocheted','Sostenes "corpiños" de todo tipo de materia textil, incl. elásticas y de punto',62,6212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621220,'Cintas e cintas-calças','Girdles and panty girdles of all types of textile materials, whether or not elasticated, incl. knitted or crocheted (excl. belts and corselets made entirely of rubber)','Fajas y fajas braga "fajas bombacha" de todo tipo de materia textil, incl. elásticas y de punto (exc. las fajas enteramente de caucho)',62,6212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621230,'Modeladores de torso inteiro (cintas soutiens)','Corselettes of all types of textile materials, whether or not elasticated, incl. knitted or crocheted','Fajas sostén "fajas corpiño" de todo tipo de materia textil, incl. elásticas y de punto',62,6212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621290,'Espartilhos, suspensórios, ligas, e artefatos semelhantes, e suas partes','Corsets, braces, garters, suspenders and similar articles and parts thereof, incl. parts of brassieres, girdles, panty girdles and corselettes, of all types of textile materials, whether or not elasticated, incl. knitted or crocheted (excl. complete brass','Corsés, tirantes "tiradores", ligas y artículos simil. y sus partes, incl. las partes de sostenes, fajas, fajas braga "fajas bombacha" y fajas sostén, de todo tipo de materia textil, incl. elásticas y de punto (exc. sostenes "corpiños", fajas, fajas braga',62,6212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621310,'lenços de assoar e de bolso, de seda/desperds.de seda','handkerchiefs of silk/silk waste','pañuelos de bolsillo de seda/desperds.de seda',62,6213);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621320,'Lenços de assoar e de bolso, de algodão','Handkerchiefs of cotton, of which no side exceeds 60 cm (excl. knitted or crocheted)','Pañuelos de bolsillo, cuyos lados sean de longitud <= 60 cm, de algodón (exc. de punto)',62,6213);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621390,'Lenços de assoar e de bolso, de outras matérias têxteis','Handkerchiefs of textile materials, of which no side exceeds 60 cm (excl. of cotton, and knitted or crocheted)','Pañuelos de bolsillo, cuyos lados sean de longitud <= 60 cm, de materia textil (exc. de seda o desperdicios de seda, de algodón y de punto)',62,6213);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621410,'Xales, echarpes, cachecóis, mantilhas, véus e artefatos semelhantes, de seda ou de desperdícios de seda','Shawls, scarves, mufflers, mantillas, veils and similar articles of silk or silk waste (excl. knitted or crocheted)','Chales, pañuelos de cuello, pasamontañas, bufandas, mantillas, velos y artículos simil., de seda o desperdicios de seda (exc. de punto)',62,6214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621420,'Xales, echarpes, cachecóis, mantilhas, véus e artefatos semelhantes, de lã ou de pêlos finos','Shawls, scarves, mufflers, mantillas, veils and similar articles of wool or fine animal hair (excl. knitted or crocheted)','Chales, pañuelos de cuello, pasamontañas, bufandas, mantillas, velos y artículos simil., de lana o pelo fino (exc. de punto)',62,6214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621430,'Xales, echarpes, cachecóis, mantilhas, véus e artefatos semelhantes, de fibras sintéticas','Shawls, scarves, mufflers, mantillas, veils and similar articles of synthetic fibres (excl. knitted or crocheted)','Chales, pañuelos de cuello, pasamontañas, bufandas, mantillas, velos y artículos simil., de fibras sintéticas (exc. de punto)',62,6214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621440,'Xales, echarpes, cachecóis, mantilhas, véus e artefatos semelhantes, de fibras artificiais','Shawls, scarves, mufflers, mantillas, veils and similar articles of artificial fibres (excl. knitted or crocheted)','Chales, pañuelos de cuello, pasamontañas, bufandas, mantillas, velos y artículos simil., de fibras artificiales (exc. de punto)',62,6214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621490,'Xales, echarpes, cachecóis, mantilhas, véus e artefatos semelhantes, de outras matérias têxteis','Shawls, scarves, mufflers, mantillas, veils and similar articles of textile materials (excl. of silk, silk waste, wool, fine animal hair or man-made fibres, knitted or crocheted)','Chales, pañuelos de cuello, pasamontañas, bufandas, mantillas, velos y artículos simil., de materia textil (exc. de seda o desperdicios de seda, de lana o pelo fino, de fibras sintéticas o artificiales y de punto)',62,6214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621510,'Gravatas, gravatas-borboleta e plastrons, de seda ou de desperdícios de seda','Ties, bow ties and cravats of silk or silk waste (excl. knitted or crocheted)','Corbatas y lazos simil., de seda o desperdicios de seda (exc. de punto)',62,6215);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621520,'Gravatas, gravatas-borboleta e plastrons, de fibras sintéticas ou artificiais','Ties, bow ties and cravats of man-made fibres (excl. knitted or crocheted)','Corbatas y lazos simil., de fibras sintéticas o artificiales (exc. de punto)',62,6215);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621590,'Gravatas, gravatas-borboleta e plastrons, de outras matérias têxteis','Ties, bow ties and cravats of textile materials (excl. of silk, silk waste or man-made fibres, knitted or crocheted)','Corbatas y lazos simil., de materia textil (exc. de seda o desperdicios de seda, de fibras sintéticas o artificiales y de punto)',62,6215);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621600,'Luvas, mitenes e semelhantes','Gloves, mittens and mitts, of all types of textile materials (excl. knitted or crocheted and for babies)','Guantes, mitones y manoplas, de todo tipo de materia textil (exc. de punto, así como guantes, mitones y manoplas para bebés)',62,6216);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621710,'Outros acessórios de vestuário, confeccionados','Made-up clothing accessories, of all types of textile materials, n.e.s. (excl. knitted or crocheted)','Complementos "accesorios" de vestir confeccionados, de todo tipo de materia textil, n.c.o.p. (exc. de punto)',62,6217);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (621790,'Outras partes de vestuário ou dos seus acessórios','Parts of garments or clothing accessories, of all types of textile materials, n.e.s. (excl. knitted or crocheted)','Partes de prendas o de complementos "accesorios" de vestir, de todo tipo de materia textil, n.c.o.p. (exc. de punto)',62,6217);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630110,'Cobertores e mantas, elétricos','Electric blankets of all types of textile materials','Mantas eléctricas, de todo tipo de materia textil',63,6301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630120,'Cobertores e mantas, de lã ou de pêlos finos, não elétricos','Blankets and travelling rugs of wool or fine animal hair (excl. electric, table covers, bedspreads and articles of bedding and similar furnishing of heading 9404)','Mantas de lana o pelo fino (exc. mantas eléctricas, manteles y colchas, así como artículos de cama y artículos simil. de la partida 9404)',63,6301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630130,'Cobertores e mantas, de algodão, não elétricos','Blankets and travelling rugs of cotton (excl. electric, table covers, bedspreads and articles of bedding and similar furnishing of heading 9404)','Mantas de algodón (exc. mantas eléctricas, manteles y colchas, así como artículos de cama y artículos simil. de la partida 9404)',63,6301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630140,'Cobertores e mantas, de fibras sintéticas, não elétricos','Blankets and travelling rugs of synthetic fibres (excl. electric, table covers, bedspreads and articles of bedding and similar furnishing of heading 9404)','Mantas de fibras sintéticas (exc. mantas eléctricas, manteles y colchas, así como artículos de cama y artículos simil. de la partida 9404)',63,6301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630190,'Outros cobertores e mantas de matérias têxteis','Blankets and travelling rugs of textile materials (excl. of wool or fine animal hair, cotton or synthetic fibres, electric, table covers, bedspreads and articles of bedding and similar furnishing of heading 9404)','Mantas de materia textil (exc. de lana o pelo fino, de algodón, de fibras sintéticas, mantas eléctricas, manteles y colchas, así como artículos de cama y artículos simil. de la partida 9404)',63,6301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630210,'Roupas de cama, de malha','Bedlinen, knitted or crocheted','Ropa de cama, de punto',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630221,'Outras roupas de cama, de algodão, estampadas','Printed bedlinen of cotton (excl. knitted or crocheted)','Ropa de cama de algodón, estampada (exc. de punto)',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630222,'Outras roupas de cama, de fibras sintéticas ou artificiais, estampadas','Printed bedlinen of man-made fibres (excl. knitted or crocheted)','Ropa de cama de fibras sintéticas o artificiales, estampada (exc. de punto)',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630229,'Outras roupas de cama, de outras matérias têxteis, estampadas','Printed bedlinen of textile materials (excl. cotton and man-made fibres, knitted or crocheted)','Ropa de cama de materia textil, estampada (exc. de algodón y de fibras sintéticas o artificiales, así como de punto)',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630231,'Outras roupas de cama, de algodão','Bedlinen of cotton (excl. printed, knitted or crocheted)','Ropa de cama, de algodón (exc. estampada y de punto)',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630232,'Outras roupas de cama, de fibras sintéticas ou artificiais','Bedlinen of man-made fibres (excl. printed, knitted or crocheted)','Ropa de cama de fibras sintéticas o artificiales (exc. estampada y de punto)',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630239,'Outras roupas de cama, de outras matérias têxteis','Bedlinen of textile materials (excl. of cotton and man-made fibres, printed, knitted or crocheted)','Ropa de cama de materia textil (exc. de algodón y de fibras sintéticas o artificiales, así como estampada y de punto)',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630240,'Roupas de mesa, de malha','Table linen, knitted or crocheted','Ropa de mesa, de punto',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630251,'Outras roupas de mesa, de algodão, exceto de malha','Table linen of cotton (excl. knitted or crocheted)','Ropa de mesa, de algodón (exc. de punto)',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630252,'Roupas de mesa, de linho, exceto de malha','table linen, of flax, except knitted or crocheted','ropas de mesa, de lino, exc.de punto',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630253,'Outras roupas de mesa, de fibras sintéticas ou artificiais, exceto de malha','Table linen of man-made fibres (excl. knitted or crocheted)','Ropa de mesa de fibras sintéticas o artificiales (exc. de punto)',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630259,'Outras roupas de mesa, de outras matérias têxteis','Table linen of textile materials (excl. of cotton or man-made fibres, knitted or crocheted)','Ropa de mesa de materia textil (exc. de algodón, de lino o de fibras sintéticas o artificiales, así como de punto)',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630260,'Roupas de toucador ou de cozinha, de tecidos atoalhados, de algodão','Toilet linen and kitchen linen, of terry towelling or similar terry fabrics of cotton (excl. floorcloths, polishing cloths, dishcloths and dusters)','Ropa de tocador o cocina, de tejido con bucles, del tipo toalla, de algodón (exc. bayetas, franelas y artículos simil. de limpieza para encerar, aclarar, desempolvar, etc.)',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630291,'Outras roupas de toucador ou de cozinha, de algodão','Toilet linen and kitchen linen of cotton (excl. of terry fabrics, floorcloths, polishing cloths, dishcloths and dusters)','Ropa de tocador o cocina, de algodón (exc. tejido con bucles, del tipo toalla, así como bayetas, franelas y artículos simil. de limpieza para encerar, aclarar, desempolvar, etc.)',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630292,'roupas de toucador/cozinha,  de linho','toilet linen/kitchen linen, of flax','ropas de tocador o cocina, de lino',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630293,'Roupas de toucador ou de cozinha, de fibras sintéticas ou artificiais','Toilet linen and kitchen linen of man-made fibres (excl. floorcloths, polishing cloths, dishcloths and dusters)','Ropa de tocador o cocina, de fibras sintéticas o artificiales (exc. bayetas, franelas y artículos simil. de limpieza para encerar, aclarar, desempolvar, etc.)',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630299,'Roupas de toucador ou de cozinha, de outras matérias têxteis','Toilet linen and kitchen linen of textile materials (excl. of cotton or man-made fibres, floorcloths, polishing cloths, dishcloths and dusters)','Ropa de tocador o cocina, de materia textil (exc. de algodón, de lino y de fibras sintéticas o artificiales, así como bayetas, franelas y artículos simil. de limpieza para encerar, aclarar, desempolvar, etc.)',63,6302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630311,'cortinas, sanefas, etc.de malha de algodão','curtains, valances, etc.of cotton mesh','cortinas, guardamalletas, etc.de punto de algodón',63,6303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630312,'Cortinas, sanefas e artigos semelhantes para cama, de malha, de fibras sintéticas','Curtains, incl. drapes, and interior blinds, curtain or bed valances of synthetic fibres, knitted or crocheted (excl. awnings and sunblinds)','Visillos y cortinas; guardamalletas y ropadiés de cama, de punto, de fibras sintéticas (exc. toldos)',63,6303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630319,'Cortinas, sanefas e artigos semelhantes para cama, de malha, de outras matérias têxteis','Curtains, incl. drapes, and interior blinds, curtain or bed valances, knitted or crocheted (excl. of synthetic fibres, awnings and sunblinds)','Visillos y cortinas; guardamalletas y ropadiés de cama, de punto (exc. de algodón o de fibras sintéticas, así como toldos)',63,6303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630391,'Cortinas, sanefas e artigos semelhantes para cama, de algodão, exceto malha','Curtains, incl. drapes, and interior blinds, curtain or bed valances of cotton (excl. knitted or crocheted, awnings and sunblinds)','Visillos y cortinas; guardamalletas y ropadiés de cama, de algodón (exc. de punto, así como toldos)',63,6303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630392,'Cortinas, sanefas e artigos semelhantes para cama, de fibras sintéticas, exceto malha','Curtains, incl. drapes, and interior blinds, curtain or bed valances of synthetic fibres (excl. knitted or crocheted, awnings and sunblinds)','Visillos y cortinas; guardamalletas y ropadiés de cama, de fibras sintéticas (exc. de punto, así como toldos)',63,6303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630399,'Cortinas, sanefas e artigos semelhantes para cama, de outras matérias têxteis, exceto malha','Curtains, incl. drapes, and interior blinds, curtain or bed valances of textile materials (excl. of cotton and synthetic fibres, knitted or crocheted, awnings and sunblinds)','Visillos y cortinas; guardamalletas y ropadiés de cama, de materia textil (exc. de algodón, de fibras sintéticas y de punto, así como toldos)',63,6303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630411,'Colchas de malha','Knitted or crocheted bedspreads (excl. bedlinen, quilts and eiderdowns)','Colchas de punto (exc. ropa de cama, cubrepiés o edredones)',63,6304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630419,'Outras colchas, exceto de malha','Bedspreads of all types of textile materials (excl. knitted or crocheted, bedlinen, quilts and eiderdowns)','Colchas de todo tipo de materia textil (exc. de punto, así como ropa de cama, cubrepiés o edredones)',63,6304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630491,'Outros artefatos para guarnição de interiores, de malha','Articles for interior furnishing, knitted or crocheted (excl. blankets and travelling rugs, bedlinen, table linen, toilet linen, kitchen linen, curtains, incl. drapes, interior blinds, curtain or bed valances, bedspreads, lampshades and articles of headin','Artículos de moblaje de punto (exc. mantas, ropa de cama, de mesa, de tocador o cocina, visillos y cortinas, guardamalletas y ropadiés de cama, colchas, pantallas para lámparas y artículos de la partida 9404)',63,6304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630492,'Outros artefatos para guarnição de interiores, de algodão, exceto de malha','Articles for interior furnishing, of cotton (excl. knitted or crocheted, blankets and travelling rugs, bedlinen, table linen, toilet linen, kitchen linen, curtains, incl. drapes, interior blinds, curtain or bed valances, bedspreads, lampshades and article','Artículos de moblaje de algodón (exc. de punto, así como mantas, ropa de cama, de mesa, de tocador o cocina, visillos y cortinas, guardamalletas y ropadiés de cama, colchas, pantallas para lámparas y artículos de la partida 9404)',63,6304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630493,'Outros artefatos para guarnição de interiores, de fibras sintéticas, exceto de malha','Articles for interior furnishing, of synthetic fibres (excl. knitted or crocheted, blankets and travelling rugs, bedlinen, table linen, toilet linen, kitchen linen, curtains, incl. drapes, interior blinds, curtain or bed valances, bedspreads, lampshades a','Artículos de moblaje de fibras sintéticas (exc. de punto, así como mantas, ropa de cama, de mesa, de tocador o cocina, visillos y cortinas, guardamalletas y ropadiés de cama, colchas, pantallas para lámparas y artículos de la partida 9404)',63,6304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630499,'Outros artefatos para guarnição de interiores, de outras matérias têxteis, exceto de malha','Articles for interior furnishing, of textile materials (excl. of cotton or synthetic fibres, knitted or crocheted, blankets and travelling rugs, bedlinen, table linen, toilet linen, kitchen linen, curtains, incl. drapes, interior blinds, curtain or bed va','Artículos de moblaje de materia textil (exc. de algodón, de fibras sintéticas y de punto, así como mantas, ropa de cama, de mesa, de tocador o cocina, visillos y cortinas, guardamalletas y ropadiés de cama, colchas, pantallas para lámparas y artículos de ',63,6304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630510,'Sacos para embalagem, de juta ou de outras fibras têxteis liberianas','Sacks and bags, for the packing of goods, of jute or other textile bast fibres of heading 5303','Sacos "bolsos" y talegas, para envasar, de yute o demás fibras textiles del líber de la partida 5303',63,6305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630520,'Sacos para embalagem, de algodão','Sacks and bags, for the packing of goods, of cotton','Sacos "bolsos" y talegas, para envasar, de algodón',63,6305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630532,'Contêineres flexíveis para produtos a granel, de matérias têxteis sintéticas ou artificiais','Flexible intermediate bulk containers, for the packing of goods, of synthetic or man-made textile materials','Continentes intermedios flexibles para productos a granel, para envasar, de materia textil sintética o artificial',63,6305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630533,'Outros sacos para embalagem, de lâminas ou formas semelhantes de polietileno ou polipropileno','Sacks and bags, for the packing of goods, of polyethylene or polypropylene strip or the like (excl. flexible intermediate bulk containers)','Sacos "bolsos" y talegas, para envasar, de tiras o formas simil., de polietileno o polipropileno (exc. continentes intermedios flexibles para productos a granel)',63,6305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630539,'Sacos para embalagem, de outras matérias têxteis sintéticas ou artificiais','Sacks and bags, for the packing of goods, of man-made textile materials (excl. of polyethylene or polypropylene strip or the like, and flexible intermediate bulk containers)','Sacos "bolsos" y talegas, para envasar, de fibras sintéticas o artificiales (exc. de tiras o formas simil., de polietileno o de polipropileno, así como los continentes intermedios flexibles para productos a granel)',63,6305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630590,'Outros sacos para embalagem, de outras matérias têxteis','Sacks and bags, for the packing of goods, of textile materials (excl. man-made, cotton, jute or other textile bast fibres of heading 5303)','Sacos "bolsos" y talegas, para envasar, de materia textil (exc. de fibras sintéticas o artificiales, de algodón, de yute o demás fibras textiles del líner de la partida 5303)',63,6305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630611,'Encerados e toldos, de algodão','Tarpaulins and awnings,  of cotton','Toldos de cualquier clase,  de algodon',63,6306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630612,'Encerados e toldos, de fibras sintéticas','Tarpaulins, awnings and sunblinds of synthetic fibres (excl. flat covers of light fabrics made up as tarpaulins)','Toldos de cualquier clase, de fibras sintéticas (exc. protectores planos de tejidos ligeros confeccionados como los toldos)',63,6306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630619,'Encerados e toldos, de outras matérias têxteis','Tarpaulins, awnings and sunblinds of textile materials (excl. of synthetic fibres and flat covers of light fabrics made up as tarpaulins)','Toldos de cualquier clase, de materia textil (exc. de algodón o de fibras sintéticas, así como los protectores planos de tejidos ligeros confeccionados como los toldos)',63,6306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630621,'Tendas de algodão','Tents of cotton','Tiendas de algodón',63,6306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630622,'Tendas de fibras sintéticas','Tents of synthetic fibres (excluding fly sheets)','Tiendas "carpas" de fibras sintéticas (exc. quitasoles-tienda)',63,6306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630629,'Tendas de outras matérias têxteis','Tents of textile materials (excl. of synthetic fibres and fly sheets)','Tiendas "carpas" de materia textil (exc. de algodón o de fibras sintéticas, así como las quitasoles-tienda)',63,6306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630630,'Velas para embarcações, pranchas ou carros à vela, de matérias têxteis','Sails for boats, sailboards or landcraft, of textile materials','Velas para embarcaciones, deslizadores o vehículos terrestres a vela, de materias textiles',63,6306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630631,'Velas para embarcações, etc.de fibras sintéticas','Sails for boats,  etc,  of synthetic fibers','Velas para embarcaciones, etc.de fibras sintéticas',63,6306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630639,'Velas para embarcações,  etc.de outras matérias têxteis','Sails of other textile materials','Las velas para embarcaciones de las demás materias textiles',63,6306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630640,'Colchões pneumáticos de matérias têxteis','Pneumatic mattresses, of textile materials','Colchones neumáticos de materias textiles',63,6306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630641,'Colchões pneumáticos, de algodão','Pneumatic mattresses, of cotton','Colchones neumáticos,  de algodon',63,6306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630649,'Colchões pneumáticos,  de outras matérias têxteis','Pneumatic mattresses,  of other textile materials','Colchones neumáticos, de ots.mat.textiles',63,6306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630690,'out.art.p/ acampamento, out.encer.e toldos','out.art.p/ acampamento, out.encer.e toldos','out.art.p/ acampamento, out.encer.e toldos',63,6306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630691,'Artigos para acampamento, de algodão','Camping goods of cotton (excl. tents, awnings and sunblinds, sails, pneumatic mattresses, rucksacks, knapsacks and similar receptacles, filled sleeping bags, mattresses and cushions)','Artículos de acampar de algodón (exc. tiendas "carpas", toldos, velas y colchones neumáticos, mochilas, cartapacios y continentes simil., así como sacos de dormir, colchones y cojines, rellenos)',63,6306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630699,'Artigos para acampamento, de outras matérias têxteis','Camping goods of textile materials (excl. of cotton, tents, awnings and sunblinds, sails, pneumatic mattresses, rucksacks, knapsacks and similar receptacles, filled sleeping bags, mattresses and cushions)','Artículos de acampar de materia textil (exc. de algodón y tiendas "carpas", toldos, velas y colchones neumáticos, mochilas, cartapacios y continentes simil., así como sacos de dormir, colchones y cojines, rellenos)',63,6306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630710,'Rodilhas, esfregões, panos de prato ou de cozinha, flanelas e artefatos de limpeza semelhantes','Floorcloths, dishcloths, dusters and similar cleaning cloths, of all types of textile materials','Paños para fregar o lavar "bayetas, paños rejilla", franelas y artículos simil. para limpieza, de todo tipo de materia textil',63,6307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630720,'Cintos e coletes salva-vidas','Life jackets and life belts, of all types of textile materials','Cinturones y chalecos salvavidas, de todo tipo de materia textil',63,6307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630790,'Outros artefatos têxteis confeccionados','Made-up articles of textile materials, incl. dress patterns, n.e.s.','Artículos de materia textil, confeccionados, incl. los patrones para prendas de vestir, n.c.o.p.',63,6307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630800,'Sortidos de cortes de tecidos e fios, para confecção de tapetes, tapeçarias, toalhas de mesa ou de artefatos têxteis semelhantes, para venda a retalho','Sets consisting of woven fabric and yarn, whether or not with accessories, for making up into rugs, tapestries, embroidered tablecloths or serviettes, or similar textile articles, put up in packings for retail sale (excl. sets for making up into articles ','Juegos constituidos por piezas de tejido e hilados, incl. con accesorios, para la confección de alfombras, tapicería, manteles o servilletas bordados o de artículos simil., en envases para la venta al por menor (exc. juegos para la confección de prendas d',63,6308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (630900,'Artefatos de matérias têxteis, calçados, chapéus e similares, usados','Worn clothing and clothing accessories, blankets and travelling rugs, household linen and articles for interior furnishing, of all types of textile materials, incl. all types of footwear and headgear, showing signs of appreciable wear and presented in bul','Artículos de prendería consistentes en prendas y complementos "accesorios" de vestir, mantas, ropa de cama, de mesa, de tocador o de cocina y artículos de moblaje, de todo tipo de materia textil, incl. el calzado y los artículos de sombrerería de todo tip',63,6309);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (631010,'Trapos; cordéis, cordas e cabos, de matérias têxteis, em forma de desperdícios, escolhidos','Used or new rags, scrap twine, cordage, rope and cables and worn-out articles thereof, of textile materials, sorted','Trapos de todo tipo de materia textil, así como cordeles, cuerdas y cordajes, de materia textil, en desperdicios o en artículos inservibles, clasificados',63,6310);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (631090,'Trapos, cordéis, cordas e cabos, de matérias têxteis, em forma de desperdícios, não classificados','Used or new rags, scrap twine, cordage, rope and cables and worn-out articles thereof, of textile materials (excl. sorted)','Trapos de todo tipo de materia textil, así como cordeles, cuerdas y cordajes, de materia textil, en desperdicios o en artículos inservibles, sin clasificar',63,6310);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640110,'Calçados impermeáveis de borracha ou plástico, com biqueira protetora de metal','Waterproof footwear incorporating a protective metal toe-cap','Calzado impermeable con puntera protectora de metal',64,6401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640191,'Calçados impermeáveis de borracha ou plástico, cobrindo o joelho','Waterproof footwear covering the knee','Calzado impermeable que cubran la rodilla',64,6401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640192,'Calçados impermeáveis de borracha ou plástico, cobrindo o tornozelo, mas não o joelho','Waterproof footwear covering the ankle, but not the knee','Calzado impermeable que cubra el tobillo, pero no la rodilla',64,6401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640199,'Outros calçados impermeáveis de borracha ou plástico, sem costura','Waterproof footwear covering neither the ankle nor the knee, with outer soles and uppers of rubber or of plastics, the uppers of which are neither fixed to the sole nor assembled by stitching, riveting, nailing, screwing, plugging or similar processes (ex','Calzado impermeable con suela y parte superior de caucho o de plástico, cuya parte superior no esté unida a la suela por costura o por remaches, clavos, tornillos, espigas o dispositivos simil. ni esté formada con distintas partes unidas de la misma maner',64,6401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640212,'Calçados para esqui e para surfe de neve, de borracha ou plástico - sapatos','Ski-boots, cross-country ski footwear and snowboard boots, with outer soles and uppers of rubber or plastics (excl. waterproof footwear of heading 6401)','Calzado de esquí y calzado para la práctica de "snowboard" "tabla para nieve", con suela y parte superior de caucho o plástico (exc. calzado impermeable de la partida 6401)',64,6402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640219,'Calçados para outros esportes, de borracha ou plástico - sapatos','Sports footwear with outer soles and uppers of rubber or plastics (excl. waterproof footwear of heading 6401, ski-boots, cross-country ski footwear, snowboard boots and skating boots with ice or roller skates attached)','Calzado de deporte con suela y parte superior de caucho o plástico (exc. calzado impermeable de la partida 6401, calzado de esquí, calzado para la práctica de "snowboard" "tabla para nieve" y calzado con patines fijos, para hielo o de ruedas)',64,6402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640220,'Calçados de borracha ou plástico, com parte superior em tiras ou correias, com saliências (espigões) que se encaixam na sola - sapatos','Footwear with outer soles and uppers of rubber or plastics, with upper straps or thongs assembled to the sole by means of plugs (excl. toy footwear)','Calzado con suela y parte superior de caucho o plástico, con la parte superior de tiras o bridas fijas a la suela por tetones "espigas" (exc. calzado con características de juguete)',64,6402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640230,'Outros calçados de borracha/plástico, c/biq.prot.de meta','Oth.footwear of rubber/plastic c/prot.metal toecap','Ots.calzados de caucho/plást, c/puntera metál.protección',64,6402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640291,'Outros calçados de borracha ou plástico, cobrindo o tornozelo - sapatos','Footwear covering the ankle, with outer soles and uppers of rubber or plastics (excl. waterproof footwear of heading 6401, sports footwear, orthopaedic footwear and toy footwear)','Calzado con suela y parte superior de caucho o plástico, que cubran el tobillo (exc. con puntera metálica de protección, así como calzado impermeable de la partida 6401, calzado de deporte y calzado ortopédico)',64,6402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640299,'Outros calçados de borracha ou plástico - sapatos','Footwear with outer soles and uppers of rubber or plastics (excl. covering the ankle or with upper straps or thongs assembled to the sole by means of plugs, waterproof footwear of heading 6401, sports footwear, orthopaedic footwear and toy footwear)','Calzado con suela y parte superior de caucho o plástico (exc. el que cubra el tobillo o con parte superior de tiras o bridas fijas a la suela por tetones "espigas", así como calzado impermeable de la partida 6401, calzado de deporte, calzado ortopédico y ',64,6402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640312,'Calçados para esqui e para surfe de neve, parte superior de couro natural - sapatos','Ski-boots, cross-country ski footwear and snowboard boots, with outer soles of rubber, plastics, leather or composition leather and uppers of leather','Calzado de esquí y calzado para la práctica de "snowboard" "tabla para nieve", con suela de caucho, plástico, cuero natural o regenerado y parte superior de cuero natural',64,6403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640319,'Calçados para outros esportes, parte superior de couro natural - sapatos','Sports footwear, with outer soles of rubber, plastics, leather or composition leather and uppers of leather (excl. ski-boots, cross-country ski footwear, snowboard boots and skating boots with ice or roller skates attached)','Calzado de deporte con suela de caucho, plástico, cuero natural o regenerado y parte superior de cuero natural (exc. calzado de esquí y calzado para la práctica de "snowboard" "tabla para nieve", así como calzado con patines fijos, para hielo o de ruedas)',64,6403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640320,'Calçados com sola exterior de couro natural e parte superior constituída por tiras de couro natural, passando pelopeito do pé e envolvendo o dedo grande - sapatos','Footwear with outer soles of leather, and uppers which consist of leather straps across the instep and around the big toe','Calzado con suela de cuero natural y parte superior de tiras de cuero natural que pasen por el empeine y rodean el dedo pulgar',64,6403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640330,'calçados de couro natural,  c/sola madeira,  s/palmilha,  etc','footw.of leather, made on base of wood, n/inner sole, etc','calzados de cuero nat.c/palm.de madera, s/plantilla, etc',64,6403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640340,'Outros calçados com biqueira protetora de metal, parte superior de couro natural - sapatos','Footwear, incorporating a protective metal toecap, with outer soles of rubber, plastics, leather or composition leather and uppers of leather (excl. sports footwear and orthopaedic footwear)','Calzado con suela de caucho, plástico, cuero natural o regenerado y parte superior de cuero natural, con puntera metálica de protección (exc. calzado de deporte y calzado ortopédico)',64,6403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640351,'Outros calçados, com sola exterior de couro natural, cobrindo o tornozelo, parte superior de couro natural - sapatos','Footwear with outer soles and uppers of leather, covering the ankle (excl. incorporating a protective metal toecap, sports footwear, orthopaedic footwear and toy footwear)','Calzado con suela y parte superior de cuero natural, que cubra el tobillo (exc. con puntera metálica de protección, así como calzado de deporte, calzado ortopédico y calzado con características de juguete)',64,6403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640359,'Outros calçados, com sola exterior de couro natural, parte superior de couro natural - sapatos','Footwear with outer soles and uppers of leather (excl. covering the ankle, incorporating a protective metal toecap, with uppers which consist of leather straps across the instep and around the big toe, sports footwear, orthopaedic footwear and toy footwea','Calzado con suela y parte superior de cuero natural (exc. el que cubra el tobillo o con puntera metálica de protección o con palmilla o plataforma de madera sin plantillas, así como calzado con parte superior de tiras de cuero natural que pasen por el emp',64,6403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640391,'Outros calçados, cobrindo o tornozelo, parte superior de couro natural - sapatos','Footwear with outer soles of rubber, plastics or composition leather, with uppers of leather, covering the ankle (excl. incorporating a protective metal toecap, sports footwear, orthopaedic footwear and toy footwear)','Calzado con suela de caucho, plástico, cuero regenerado y parte superior de cuero natural, que cubra el tobillo (exc. con puntera metálica de protección, así como calzado de deporte, calzado ortopédico y calzado con características de juguete)',64,6403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640399,'Outros calçados, parte superior de couro natural - sapatos','Footwear with outer soles of rubber, plastics or composition leather, with uppers of leather (excl. covering the ankle, incorporating a protective metal toecap, sports footwear, orthopaedic footwear and toy footwear)','Calzado con suela de caucho, plástico, cuero regenerado y parte superior de cuero natural (exc. el que cubra el tobillo o con puntera metálica de protección o con palmilla o plataforma de madera sin plantillas, así como calzado de deporte y calzado ortopé',64,6403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640411,'Calçados para esporte; calçados para tênis, basquetebol, ginástica, de matérias têxteis, com sola de borracha ou plástico - sapatos','Sports footwear, incl. tennis shoes, basketball shoes, gym shoes, training shoes and the like, with outer soles of rubber or plastics and uppers of textile materials','Calzado de deporte, incl. calzado de tenis, baloncesto, gimnasia, entrenamiento y calzados simil., con suela de caucho o plástico y parte superior de materia textil',64,6404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640419,'Outros calçados de matérias têxteis, com sola de borracha ou plástico - sapatos','Footwear with outer soles of rubber or plastics and uppers of textile materials (excl. sports footwear, incl. tennis shoes, basketball shoes, gym shoes, training shoes and the like, and toy footwear)','Calzado con suela de caucho o plástico y parte superior de materia textil (exc. calzado de deporte, incl. calzado de tenis, de baloncesto, de gimnasia, de entrenamiento y demás calzados simil., así como calzados con características de juguete)',64,6404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640420,'Calçados de matérias têxteis, com sola exterior de couro natural - sapatos','Footwear with outer soles of leather or composition leather and uppers of textile materials (excl. toy footwear)','Calzado con suela de cuero natural o regenerado y parte superior de materia textil (exc. calzado con características de juguete)',64,6404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640510,'Outros calçados de couro natural ou reconstituído - sapatos','Footwear with uppers of leather or composition leather (excl. with outer soles of rubber, plastics, leather or composition leather and uppers of leather, orthopaedic footwear and toy footwear)','Calzado con parte superior de cuero natural o regenerado (exc. con suela de caucho, plástico, cuero natural o regenerado y parte superior de cuero natural, así como calzado ortopédico y calzado con características de juguete)',64,6405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640520,'Outros calçados com a parte superior de matérias têxteis - sapatos','Footwear with uppers of textile materials (excl. with outer soles of rubber, plastics, leather or composition leather, orthopaedic footwear and toy footwear)','Calzado con parte superior de materia textil (exc. con suela de caucho, plástico o cuero natural o regenerado, así como calzado ortopédico y calzado con características de juguete)',64,6405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640590,'Outros calçados com solas exteriores de borracha ou plástico - sapatos','Footwear with outer soles of rubber or plastics, with uppers other than rubber, plastics, leather or textile materials; footwear with outer soles of leather or composition leather, with uppers other than leather or textile materials; footwear with outer s','Calzado con suela de caucho o plástico y parte superior de materia distinto del caucho, el plástico, el cuero natural o las materias textiles; calzado con suela de cuero natural o regenerado y parte superior de materia distinto del cuero natural o las mat',64,6405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640610,'Partes superiores de calçados e seus componentes, exceto contrafortes e biqueiras rígidas - sapatos','Uppers and parts thereof (excl. stiffeners and general parts made of asbestos)','Partes superiores de calzado y sus partes (exc. contrafuertes y punteras duras, así como artículos de amianto "asbesto")',64,6406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640620,'Solas exteriores e saltos, de borracha ou plástico - calçados sapatos','Outer soles and heels, of rubber or plastics','Suelas y tacones "tacos", de caucho o plástico',64,6406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640690,'Solas, saltos, palmilhas e outras partes de calçados','Soles, heels and other parts of footwear','Suelas, tacones y otras partes de calzados',64,6406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640691,'Outras partes de calçados, de madeira - sapatos','Parts of footwear, of wood','Partes de calzado, de madera',64,6406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (640699,'Outras partes de calçados, de outras matérias - sapatos','Parts of footwear (excl. outer soles and heels of rubber or plastics, uppers and parts thereof, and general parts made of wood or asbestos)','Partes de calzado (exc. suelas y tacones tacos", de caucho o plástico, partes superiores y sus partes, así como partes de madera o de amianto "asbesto")',64,6406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (650100,'Esboços não enformados nem na copa nem na aba, discos e cilindros, de feltro, para chapéus','Hat-forms, hat bodies and hoods of felt, neither blocked to shape nor with made brims; plateaux and manchons, incl. slit manchons, of felt','Cascos sin forma ni acabado, platos "discos" y cilindros aunque estén cortados en el sentido de la altura, de fieltro, para sombreros',65,6501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (650200,'Esboços de chapéus, entrançados ou obtidos por reunião de tiras de qualquer matéria, sem copa nem aba enformadas e sem guarnições','Hat-shapes, plaited or made by assembling strips of any material (excl. blocked to shape, with made brims, lined, or trimmed)','Cascos para sombreros, trenzados o fabricados por unión de tiras de cualquier materia, sin formar, acabar ni guarnecer',65,6502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (650300,'chapeus e outs.artefs.de feltro,  obtidos dos esbocos,  etc','felt hats and oth.felt headgear, obt. hat bodies, etc','sombreros y demás tocados de fieltro, fabric.cascos, etc',65,6503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (650400,'Chapéus e outros artefatos de uso semelhante, entrançados por tiras, de qualquer matéria','Hats and other headgear, plaited or made by assembling strips of any material, whether or not lined or trimmed (excl. headgear for animals, and toy and carnival headgear)','Sombreros y demás tocados, trenzados o fabricados por unión de tiras de cualquier materia, incl. guarnecidos',65,6504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (650500,'Chapéus e artigos de uso semelhante a chapéus','Hats and other articles to use like hats','Sombreros y artículos de uso como sombreros',65,6505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (650510,'Coifas e redes, para o cabelo, de qualquer matéria, mesmo guarnecidas','Hairnets of any material, whether or not lined or trimmed','Redecillas para el cabello, de cualquier materia, incl. guarnecidas',65,6505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (650590,'Chapéus e outros artefatos de uso semelhante, de malha ou confeccionados com rendas, feltro ou outros produtos têxteis','Hats and other headgear, knitted or crocheted, or made up from lace, felt or other textile fabric, in the piece (but not in strips), whether or not lined or trimmed (excl. hairnets, headgear for animals, and toy and fancy-dress headgear)','Sombreros y demás tocados, de punto o confeccionados con encaje, fieltro u otro producto textil, en pieza, pero no en tiras, incl. guarnecidos (exc. redecillas para el cabello, así como sombreros y demás tocados para animales o con características de jugu',65,6505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (650610,'Capacetes e outros artefatos de uso semelhante, de proteção','Safety headgear, whether or not lined or trimmed','Cascos de seguridad, incluso guarnecidos',65,6506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (650691,'Chapéus e outros artefatos de uso semelhante, de borracha ou de plástico','Bathing caps, hoods and other headgear, whether or not lined or trimmed, of rubber or plastics (other than safety headgear and headgear having the character of toys or festive articles)','Gorros de baño, capuchas y demás tocados, incl. guarnecidos, de caucho o plástico (exc. cascos de seguridad, así como sombreros y demás tocados con características de juguete o de artículos de carnaval)',65,6506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (650692,'Chapéus e outros artefs.de peleteria natural','Other headgear of furskin','Sombreros y demás tocados de peletería natural',65,6506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (650699,'Chapéus e outros artefatos de uso semelhante, de outras matérias','Headgear, whether or not lined or trimmed, n.e.s.','Sombreros y demás tocados, incl. guarnecidos, n.c.o.p.',65,6506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (650700,'Tiras para guarnição interior, forros, capas, armações, para chapéus e artefatos de uso semelhante','Headbands, linings, covers, hat foundations, hat frames, peaks and chinstraps, for headgear (excl. headbands used by sportsmen as sweatbands, knitted or crocheted)','Desudadores, forros, fundas, armaduras, viseras y barboquejos "barbijos", para sombreros y demás tocados (exc. las tiras para la cabeza de los tipos utilizados por los deportistas para absorber la transpiración "sudaderas", de punto)',65,6507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (660110,'Guarda-sóis de jardim e artefatos semelhantes','Garden or similar umbrellas (excl. beach tents)','Quitasoles toldo y artículos simil. (exc. carpas de playa)',66,6601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (660191,'Guarda-chuvas de haste ou cabo telescópico','Umbrellas having a telescopic shaft (excl. toy umbrellas)','Artículos con astil o mango telescópico (exc. destinados al entretenimiento de los niños)',66,6601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (660199,'Outros guarda-chuvas e sombrinhas','Umbrellas and sun umbrellas, incl. walking-stick umbrellas (excl. umbrellas having a telescopic shaft, garden umbrellas and the like, and toy umbrellas)','Paraguas, sombrillas y quitasoles, incl. los paraguas-bastón (exc. artículos con astil o mango telescópico, quitasoles toldo y artículos simil. y artículos destinados al entretenimiento de los niños)',66,6601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (660200,'Bengalas, bengalas-assentos, chicotes e artefatos semelhantes','Walking sticks, seat-sticks, whips, riding-crops and the like (excl. measure walking sticks, crutches, firearm-sticks and sports sticks)','Bastones, bastones asiento, látigos, fustas y artículos simil. (exc. bastones medida, muletas, bastones con características de armas y bastones de deporte)',66,6602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (660310,'Punhos, cabos e castões para guarda-chuvas, sombrinhas,  etc.','Handles and knobs f/umbrellas, etc.','Puños y pomos para paraguas, sombrillas, etc.',66,6603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (660320,'Armações montadas, mesmo com hastes ou cabos, para guarda-chuvas, sobrinhas ou guarda-sóis','Umbrella frames, incl. frames mounted on shafts sticks, for umbrellas and sun umbrellas of heading 6601','Monturas ensambladas, reconocibles como tales, incl. con el ástil o mango, para paraguas, sombrillas y quitasoles de la partida 6601',66,6603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (660390,'Outras partes, guarnições e acessórios, para artigos das posições 6601 e 6602','Parts, trimmings and accessories for umbrellas and sun umbrellas of heading 6601 or for walking sticks, seat-sticks, whips, riding-crops and the like of heading 6602 (excl. umbrella frames, incl. frames mounted on shafts sticks)','Partes, guarniciones y accesorios, reconocibles como tales, para paraguas, sombrillas y quitasoles de la partida 6601 ó para bastones, bastones asiento, látigos, fustas y artículos simil. de la partida 6602 (exc. puños y pomos, así como monturas ensamblad',66,6603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (670100,'Peles e outras partes de aves, com suas penas ou penugem; penas, partes de penas, penugem e artefatos de estas matérias','Skins and other parts of birds with their feathers or down, feathers, parts of feathers, down and articles thereof (excl. goods of heading 0505, worked quills and scapes, footwear and headgear, articles of bedding and similar furnishing of heading 9404, t','Pieles y demás partes de ave, con sus plumas o plumón; plumas, partes de plumas, plumón y artículos de estas materias (exc. los productos de la partida 0505, los cañones y ástiles de plumas trabajados, el calzado y los artículos de sombrerería y los artíc',67,6701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (670210,'Flores, folhagem e frutos, artificiais e suas partes; artefatos confeccionados com flores, folhagem e frutos, artificiais, de plástico','Artificial flowers, foliage and fruit and parts thereof, and articles made of artificial flowers, foliage or fruit, by binding, glueing, fitting into one another or similar methods, of plastics','Flores, follaje y frutos, artificiales, y sus partes; artículos confeccionados con flores, follaje o frutos, artificiales obtenidos por atado, pegado, encajado u otros procedimientos simil., de plástico',67,6702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (670290,'Flores, folhagem e frutos, artificiais e suas partes, de outras matérias','Artificial flowers, foliage and fruit and parts thereof, and articles made of artificial flowers, foliage or fruit, by binding, glueing, fitting into one another or similar methods (excl. of plastics)','Flores, follaje y frutos, artificiales, y sus partes; artículos confeccionados con flores, follaje o frutos, artificiales obtenidos por atado, pegado, encajado u otros procedimientos simil. (exc. de plástico)',67,6702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (670300,'Cabelos, lã, pêlos e outras matérias têxteis, preparados para a fabricação de perucas ou artefatos semelhantes','Human hair, dressed, thinned, bleached or otherwise worked; wool, other animal hair or other textile materials, prepared for use in making wigs or the like (excl. natural plaits of human hair, whether or not washed and degreased, but not otherwise process','Cabello peinado, afinado, blanqueado o preparado de otra forma; lana, pelo u otra materia textil, preparados para la fabricación de pelucas o artículos simil. (exc. las trenzas naturales de cabello en bruto, incl. lavado y desgrasado, que no se hayan some',67,6703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (670411,'Perucas completas, de matérias têxteis sintéticas','Complete wigs of synthetic textile materials','Pelucas que cubran toda la cabeza, de fibras sintéticas',67,6704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (670419,'Barbas, sobrancelhas, pestanas, madeixas e semelhantes, de matérias têxteis sintéticas','False beards, eyebrows and eyelashes, switches and the like, of synthetic textile materials (excl. complete wigs)','Barbas, cejas, pestañas, mechones y artículos análogos, de fibras sintéticas (exc. pelucas que cubran toda la cabeza)',67,6704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (670420,'Perucas, barbas, sobrancelhas, pestanas, madeixas e semelhantes, de cabelo','Wigs, false beards, eyebrows and eyelashes, switches and the like, of human hair, and articles of human hair, n.e.s.','Pelucas, barbas, cejas, pestañas, mechones y artículos análogos, de cabello, así como manufacturas de cabello, n.c.o.p.',67,6704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (670490,'Perucas, barbas, sobrancelhas, pestanas, madeixas e semelhantes, de pêlos ou de matérias têxteis','Wigs, false beards, eyebrows and eyelashes, switches and the like, of animal hair or textile materials (excl. synthetic textile materials)','Pelucas, barbas, cejas, pestañas, mechones y artículos análogos, de pelo o materia textil (exc. de fibras sintéticas)',67,6704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680100,'Pedras para calcetar, meios-fios e placas (lajes), para pavimentação, de pedra natural','Setts, curbstones and flagstones, of natural stone (excl. slate)','Adoquines, encintado "bordillos" y losas para pavimentos de piedra natural (exc. la pizarra)',68,6801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680210,'Ladrilhos, cubos, pastilhas e artigos semelhantes, de pedra natural, de lado < 7 cm','Tiles, cubes and other processed articles of natural stone, incl. slate, for mosaics and the like, whether or not rectangular or square, the largest surface area of which is capable of being enclosed in a square of side of < 7 cm; artificially coloured gr','Losetas, cubos, dados y demás piedras naturales trabajadas, incl. la pizarra, para mosaicos y simil., incl. de forma disctinta a la cuadrada o rectangular, en los que la superficie mayor pueda inscribirse en un cuadrado de lado < 7 cm; gránulos, tasquiles',68,6802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680221,'Mármore, travertino e alabastro, talhados ou serrados, de superfície plana ou lisa','Marble, travertine and alabaster articles thereof, simply cut or sawn, with a flat or even surface (excl. with a completely or partly planed, sand-dressed, coarsely or finely ground or polished surface, tiles, cubes and similar articles of subheading 6802','Mármol, travertinos, alabastro y sus manufacturas, simplemente talladas o aserradas, con superficie plana o lisa (exc. las manufacturas de piedra en que toda o parte de la superficie haya sido cepillada, desgastada con arena, pulida o pulimentada; losetas',68,6802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680222,'Outs.pedras calcárias, talhadas/serrad.superf.plana/lisa','Oth.calcareous stone, slice/sawed planed/flat surface','Ots.piedras calizas, talladas/aserrad.superf.plana/lisa',68,6802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680223,'Granito, talhado ou serrado, de superfície plana ou lisa','Granite and articles thereof, simply cut or sawn, with a flat or even surface (excl. with a completely or partly planed, sand-dressed, coarsely or finely ground or polished surface, tiles, cubes and similar articles of subheading 6802,10, setts, curbstone','Granito y sus manufacturas, simplemente talladas o aserradas, con superficie plana o lisa (exc. las manufacturas de piedra en que toda o parte de la superficie haya sido cepillada, desgastada con arena, pulida o pulimentada; losetas, cubos, dados y artícu',68,6802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680229,'Outras pedras de cantaria, talhadas ou serradas, de superfície plana ou lisa','Monumental or building stone and articles thereof, simply cut or sawn, with a flat or even surface (excl. marble, travertine, alabaster, granite and slate, those with a completely or partly planed, sand-dressed, coarsely or finely ground or polished surfa','Piedra de talla, natural, distinta de las piedras calizas, el granito y la pizarra, y sus manufacturas, simplemente talladas o aserradas, con superficie plana o lisa (exc. las manufacturas de piedra en que toda o parte de la superficie haya sido cepillada',68,6802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680291,'Mármore, travertino e alabastro, trabalhados de outro modo e suas obras','Marble, travertine and alabaster, in any form, polished, decorated or otherwise worked (excl. tiles, cubes and similar articles of subheading 6802,10, imitation jewellery, clocks, lamps and lighting fittings and parts thereof, buttons, original sculptures','Mármol, travertinos y alabastro, de cualquier forma, pulimentado, decorado o trabajado de otro modo (exc. losetas, cubos, dados y artículos simil. de la subpartida 6802 10; bisutería; relojes; aparatos de alumbrado y sus partes; botones; obras originales ',68,6802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680292,'Outras pedras calcárias, trabalhadas de outro modo e suas obras','Calcareous stone, in any form, polished, decorated or otherwise worked (excl. marble, travertine and alabaster, tiles, cubes and similar articles of subheading 6802.10, imitation jewellery, clocks, lamps and lighting fittings and parts thereof, original s','Piedras calizas distintas del mármol,  travertinos y alabastro, de cualquier forma, pulimentado, decorado o trabajado de otro modo (exc. losetas, cubos, dados y artículos simil. de la subpartida 6802 10; bisutería; relojes; aparatos de alumbrado y sus par',68,6802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680293,'Granitos trabalhados de outro modo e suas obras','Granite, in any form, polished, decorated or otherwise worked (excl. tiles, cubes and similar articles of subheading 6802.10, imitation jewellery, clocks, lamps and lighting fittings and parts thereof, original sculptures and statuary, setts, curbstones a','Granito de cualquier forma, pulimentado, decorado o trabajado de otro modo (exc. losetas, cubos, dados y artículos simil. de la subpartida 6802 10; bisutería; relojes; aparatos de alumbrado y sus partes; obras originales de estatuaria o de escultura; adoq',68,6802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680299,'Outras pedras de cantaria trabalhadas de outro modo e suas obras','Monumental or building stone, in any form, polished, decorated or otherwise worked (excl. calcareous stone, granite and slate, tiles, cubes and similar articles of subheading 6802.10, articles of fused basalt, articles of natural steatite, ceramically cal','Piedra de talla, natural, distintas de las piedras calizas, el granito y la pizarra, de cualquier forma, pulimentado, decorado o trabajado de otro modo (exc. losetas, cubos, dados y artículos simil. de la subpartida 6802 10; adoquines, encintado y losas p',68,6802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680300,'Ardósia natural trabalhada e obras de ardósia natural ou aglomerada','Worked slate and articles of slate or of agglomerated slate (excl. slate granules, chippings and powder, mosaic cubes and the like, slate pencils, and ready-to-use slates or boards with writing or drawing surfaces)','Pizarra natural trabajada y manufacturas de pizarra natural o aglomerada (exc. gránulos "granalla", tasquiles y polvo de pizarra; piedras para mosaicos y artículos simil.; pizarrines, pizarras listas para usar y pizarras para escribir o dibujar)',68,6803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680410,'Mós para moer ou desfibrar','Millstones and grindstones, without frameworks, for milling, grinding or pulping','Muelas, sin bastidor, para triturar o desfibrar',68,6804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680421,'Outros mós de diamante natural ou sintético, aglomerado','Millstones, grindstones, grinding wheels and the like, without frameworks, for sharpening, polishing, trueing or cutting, of agglomerated synthetic or natural diamond (excl. hand sharpening or polishing stones, and grinding wheels etc. specifically for de','Muelas y artículos simil., sin bastidor, para triturar, afilar, pulir, rectificar, cortar o trocear, de diamante natural o sintético aglomerado (exc. piedras de afilar o pulir a mano, así como pequeñas muelas especiales para tornos de dentista)',68,6804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680422,'Outros mós de outros abrasivos aglomerados ou de cerâmica','Millstones, grindstones, grinding wheels and the like, without frameworks, for sharpening, polishing, trueing or cutting, of agglomerated abrasives or ceramics (excl. of agglomerated synthetic or natural diamond, hand sharpening or polishing stones, perfu','Muelas y artículos simil., sin bastidor, para triturar, afilar, pulir, rectificar, cortar o trocear, de abrasivos aglomerados o de cerámica (exc. de diamante natural o sintético aglomerado, así como piedras de afilar o pulir a mano, piedra pómez perfumada',68,6804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680423,'Outros mós de pedras naturais e artefatos semelhantes','Millstones, grindstones, grinding wheels and the like, without frameworks, for sharpening, polishing, trueing or cutting, of natural stone (excl. of agglomerated natural abrasives or ceramics, perfumed pumice stones, hand sharpening or polishing stones, a','Muelas y artículos simil., sin bastidor, para triturar, afilar, pulir, rectificar, cortar o trocear, de piedras naturales (exc. de abrasivos naturales aglomerados o de cerámica, así como piedra pómez perfumada, piedras de afilar o pulir a mano y pequeñas ',68,6804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680430,'Pedras para amolar ou polir, manualmente, de pedra natural ou artificial aglomerada','Hand sharpening or polishing stones','Piedras de afilar o de pulir a mano',68,6804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680510,'Abrasivos naturais ou artificiais, em pó ou em grãos, aplicados apenas sobre tecidos de matérias têxteis','Natural or artificial abrasive powder or grain, on a base of woven textile fabric only, whether or not cut to shape, sewn or otherwise made up','Abrasivos naturales o artificiales en polvo o gránulos con soporte de tejidos de materia textil solamente, incl. recortados, cosidos o unidos de otra forma',68,6805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680520,'Abrasivos naturais ou artificiais, em pó ou em grãos, aplicados apenas sobre papel ou cartão','Natural or artificial abrasive powder or grain, on a base of paper or paperboard only, whether or not cut to shape, sewn or otherwise made up','Abrasivos naturales o artificiales en polvo o gránulos con soporte de papel o cartón solamente, incl. recortados, cosidos o unidos de otra forma',68,6805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680530,'Abrasivos naturais ou artificiais, em pó ou em grãos, aplicados sobre outras matérias','Natural or artificial abrasive powder or grain, on a base of materials other than woven textile fabric only or paper or paperboard only, whether or not cut to shape, sewn or otherwise made up','Abrasivos naturales o artificiales en polvo o gránulos con soporte que no sea solamente de tejidos de materia textil o solamente de papel o cartón, incl. recortados, cosidos o unidos de otra forma',68,6805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680610,'Lãs de escórias de altos-fornos, de outras escórias, lã de rocha e lãs minerais semelhantes, mesmo misturadas entre si, em massa, em folhas ou rolos','Slag-wool, rock-wool and similar mineral wools, incl. intermixtures thereof, in bulk, sheets or rolls','Lana de escoria, de roca y lanas minerales simil., incl. mezcladas entre sí, en masa, hojas o enrollados',68,6806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680620,'Vermiculita e argilas, expandidas, espuma de escórias e produtos minerais semelhantes','Exfoliated vermiculite, expanded clays, foamed slag and similar expanded mineral materials, incl. intermixtures thereof','Vermiculita dilatada, arcilla dilatada, espuma de escoria y productos minerales simil. dilatados, incl. mezclados entre sí',68,6806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680690,'Outras misturas e obras de matérias minerais para isolamento do calor e do som','Mixtures and articles of heat-insulating, sound-insulating or sound absorbing mineral materials (excl. slag-wool, rock-wool and similar mineral wools, exfoliated vermiculite, expanded clays, foamed slag and similar expanded mineral materials, articles of ','Mezclas y manufacturas de materias minerales para aislamiento térmico o acústico o para la absorción del sonido (exc. lana de escoria, de roca y lanas minerales simil.; vermiculita dilatada, arcilla dilatada, espuma de escoria y productos minerales simil.',68,6806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680710,'Obras de asfalto ou de produtos semelhantes, em rolos','Articles of asphalt or of similar materials, e.g. petroleum bitumen or coal tar pitch, in rolls','Manufacturas de asfalto o de productos simil., p.ej. pez de petróleo o brea, en rollos',68,6807);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680790,'Outras obras de asfalto ou de produtos semelhantes','Articles of asphalt or of similar materials, e.g. petroleum bitumen or coal tar pitch (excl. in rolls)','Manufacturas de asfalto o de productos simil., p.ej. pez de petróleo o brea (exc. en rollos)',68,6807);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680800,'Painéis, chapas, ladrilhos e semelhantes, de fibras vegetais, de palha, ou de desperdícios aglomerados com aglutinantes','Panels, boards, tiles, blocks and similar articles of vegetable fibre, of straw or of shavings, chips, particles, sawdust or other waste of wood, agglomerated with cement, plaster or other mineral binders (excl. articles of asbestos-cement, cellulose fibr','Paneles, placas, losetas, bloques y artículos simil., de fibra vegetal,  paja o  viruta, de plaquitas o escamillas, o de aserrín o demás desperdicios de madera, aglomerados con cemento, yeso fraguable o demás aglutinantes minerales (exc. manufacturas de a',68,6808);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680911,'Chapas, placas, painéis e ladrilhos, de gesso ou de composições à base de gesso, não ornamentados, revestidos ou reforçados exclusivamente com papel ou cartão','Boards, sheets, panels, tiles and similar articles, of plaster or compositions based on plaster, faced or reinforced with paper or paperboard only (excl. ornamented and with plaster agglomerated articles for heat-insulation, sound-insulation or sound abso','Placas, hojas, paneles, losetas y artículos simil., de yeso o de preparaciones a base de yeso, sin adornos, revestidos o reforzados exclusivamente con papel o cartón (exc. manufacturas aglomeradas con yeso para aislamiento térmico o acústico)',68,6809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680919,'Outras chapas, placas, painéis e ladrilhos, de gesso ou de composições à base de gesso, não ornamentados','Boards, sheets, panels, tiles and similar articles, of plaster or compositions based on plaster (excl. ornamented, faced or reinforced with paper or paperboard only, and with plaster agglomerated articles for heat-insulation, sound-insulation or sound abs','Placas, hojas, paneles, losetas y artículos simil., de yeso o de preparaciones a base de yeso, sin adornos (exc. revestidos o reforzados exclusivamente con papel o cartón, así como manufacturas aglomeradas con yeso para aislamiento térmico o acústico)',68,6809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (680990,'Outras obras de gesso ou de composições à base de gesso','Articles of plaster or of compositions based on plaster (excl. plaster bandages for straightening fractures, put up for retail sale; plaster splints for the treatment of fractures; lightweight with plaster agglomerated building boards or articles for heat','Manufacturas de yeso fraguable o de preparaciones a base de yeso fraguable (exc. vendas enyesadas para fracturas, acondicionadas para la venta al por menor, así como tablillas enyesadas para fracturas; placas aglomeradas con yeso para construcciones liger',68,6809);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681011,'Blocos e tijolos para construção, de cimento, de concreto, ou de pedra artificial','Building blocks and bricks of cement, concrete or artificial stone, whether or not reinforced','Bloques y ladrillos para la construcción, de cemento, hormigón o piedra artificial, incl. armados',68,6810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681019,'Outras telhas, ladrilhos, placas (lajes), tijolos e artefatos semelhantes, de cimento, de concreto ou de pedra artificial','Tiles, flagstones, bricks and similar articles, of cement, concrete or artificial stone (excl. building blocks and bricks)','Tejas, losetas, losas, ladrillos y artículos simil., de cemento, hormigón o piedra artificial (exc. bloques y ladrillos para la construcción)',68,6810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681091,'Elementos pré-fabricados para construção ou engenharia civil, de cimento, de concreto ou de pedra artificial','Prefabricated structural components for building or civil engineering of cement, concrete or artificial stone, whether or not reinforced','Elementos prefabricados para la construcción o ingeniería civil, de cemento, hormigón o piedra artificial, incl. armados',68,6810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681099,'Outras obras de cimento, concreto ou de pedra artificial','Articles of cement, concrete or artificial stone, whether or not reinforced (excl. prefabricated structural components for building or civil engineering, tiles, paving, bricks and the like)','Manufacturas de cemento, hormigón o piedra artificial, incl. armadas (exc. elementos prefabricados para la construcción o ingeniería civil; tejas, losetas, losas, ladrillos y artículos simil.)',68,6810);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681110,'chapas onduladas de fibrocimento,  cimento-celulose,  etc.','corrugated sheets, of cellulose fibre-cement, etc','placas onduladas de amiantocemento, celulosacemento, etc',68,6811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681120,'outras chapas e semelh.de fibrocimento, cimento-celulose','other sheets and similar, of cellulose fibre-cement','ots.placas y similar.de amiantocemento, celulosacemento',68,6811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681130,'tubo, conduto e acess.de fibrocimento, cimento-celulose','tubes, pipes and tube or pipe fit.of cellul.fibre-cement','tubos, fundas y acces.de amiantocemento, celulosacemento',68,6811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681140,'Obras de fibrocimento, cimento-celulose ou semelhantes, contendo amianto','Articles of asbestos-cement, cellulose fibre-cement or the like, containing asbestos','Obras en amiantocemento, celulosacemento o similares, que contengan amianto (asbesto)',68,6811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681181,'Chapas onduladas de fibrocimento, cimento-celulose ou semelhantes, não contendo amianto','Corrugated sheets of asbestos-cement, cellulose fibre-cement or the like, not containing asbestos','Placas onduladas de amiantocemento, celulosacemento o simil.,que no contengan amianto (arbesto)',68,6811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681182,'Outras chapas, painéis, ladrilhos, telhas e produtos semelhantes de fibrocimento, cimento-celulose ou semelhantes, não contendo amianto','Sheets, panels, paving tiles and similar articles, of asbestos-cement, cellulose fibre-cement or the like, not containing asbestos (excl. corrugated sheets)','Placas, tableros, losetas, tejas y artículos simil., de amiantocemento, celulosacemento o simil.,que no contengan amianto (arbesto) (exc. placas onduladas)',68,6811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681183,'Tubos, condutos e seus acessórios de fibrocimento, cimento-celulose, não contendo amianto','Tubes, pipes and tube or pipe fittings of asbestos-cement, cellulose fibre-cement or the like, not containing asbestos','Tubos, fundas y accesorios de tubería, de amiantocemento, celulosacemento o simil.,que no contengan amianto (arbesto)',68,6811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681189,'Outras obras de fibrocimento, cimento-celulose ou semelhantes, não contendo amianto','Articles of asbestos-cement, cellulose fibre-cement or the like, not containing asbestos (excl. tubes, pipes and tube or pipe fittings, corrugated and other sheets, panels, paving, tiles and similar articles)','Obras en amiantocemento, celulosacemento o similares,que no contengan amianto (asbesto) (exc. tubos, fundas y accesorios de tubería, placas onduladas y demás, tableros, losetas, tejas y artículos similares) ',68,6811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681190,'Outras obras de fibrocimento,  cimento-celulose e semelhantes','Other articles of cellulose fibre-cement and similar','Ots.manufact.de amiantocemento, celulosacemento y simil.',68,6811);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681210,'Amianto em fibras e misturas de amianto','Asbestos fibers and mixtures of asbestos','Las fibras de asbesto y mezclas de amianto',68,6812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681220,'Fios de amianto ou das misturas','Yarn of asbestos or mixtures','Hilados de amianto o de las mezclas',68,6812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681230,'Cordas e cordões, de amianto ou das misturas','Cord and strings, of asbestos or mixtures','Cuerdas y cordones, de amianto o de las mezclas',68,6812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681240,'Tecidos e tecidos de malha, de amianto ou das misturas','Fabris and mesh fabrics, of asbestos or mixtures','Tejidos y tejidos de punto, de amianto o de las mezclas',68,6812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681250,'Vestuário e acess.calçados, etc.de amianto/das misturas','Clothing and access.footwear, etc.of asbestos/mixtures','Prendas y compl.de vest.calzad., etc.de amian/de mezclas',68,6812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681260,'Papéis, cartões e feltros, de amianto ou das misturas','Paper, millboard and felt, of asbestos or mixtures','Papeles, cartones y fieltros, de amianto o de las mezclas',68,6812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681270,'Folhas de amianto e elastomeros,  comprimidos,  para juntas','Compressed asbestos sheets and elastom.f/gaskets','Hojas de amianto y elastómeros, comprimidos, para juntas',68,6812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681280,'Obras de crocidolita (amianto)','Fabricated crocidolite asbestos fibres; mixtures with a basis of crocidolite asbestos or with a basis of crocidolite asbestos and magnesium carbonate; articles of such mixtures or of crocidolite asbestos, e.g., thread, woven fabric, clothing, headgear, fo','Amianto crocidolita [arbesto] en fibras  trabajado; mezclas a base de amianto crocidolita o a base de amianto crocidolita y carbonato de magnesio; manufacturas de estas mezclas o de amianto crocidolita [ p.ej. hilos, tejidos, prendas de vestir, sombreros,',68,6812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681290,'Amianto trabalhado; juntas e outros elementos de amianto','Asbestos, gaskets and other elements of asbestos','Amianto, juntas y otros elementos de asbesto',68,6812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681291,'Vestuário e acessórios, calçados, chapéus e artefatos de uso semelhante, de amianto ou de misturas à base de amianto','Clothing, clothing accessories, footwear and headgear of asbestos or of mixtures with a basis of asbestos or a basis of asbestos and magnesium carbonate (excl. of crocidolite asbestos)','Prendas y complementos (accesorios), de vestir, calzado y sombreros y demás tocados, en amianto o en mezclas a base de amianto o a base de amianto y carbonato de magnesio (exc en amianto crocidolita)',68,6812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681292,'Papéis, cartões e feltros, de amianto ou de misturas à base de amianto','Paper, millboard and felt of asbestos or of mixtures with a basis of asbestos or a basis of asbestos and magnesium carbonate (excl. containing < 35% by weight of asbestos and of crocidolite asbestos)','Papeles, cartones y fieltros, en amianto o en mezclas a base de amianto o a base de amianto y carbonato de magnesio (exc. a contenido en peso de amianto',68,6812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681293,'Folhas de amianto e elastômeros, comprimidos, para juntas, mesmo apresentadas em rolos ','Compressed asbestos fibre jointing, in sheets or rolls (excl. of crocidolite asbestos)','Hojas en amianto y elastómeros comprimidos, para juntas, incluso presentado en rodillos (exc. en amianto crocidolita)',68,6812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681299,'Outras obras de amianto ou de misturas à base de amianto','Fabricated asbestos fibres; mixtures with a basis of asbestos or with a basis of asbestos and magnesium carbonate; articles of such mixtures or of asbestos, e.g., yarn, thread, cords, string, woven or knitted fabric, whether or not reinforced (excl. of cr','Amianto [arbesto] trabajado en fibras; mezclas a base de amianto o a base de amianto y carbonato de magnesio; manufaturas en estas mezclas o en amianto [p.ej. hilos cuerdas, cordones, tejidos, juntas], incluso armadas (exc. en amianto crocidolita; hojas e',68,6812);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681310,'Pastilhas e guarnições não montadas de amianto, para freios','Brake pads and gaskets, not mounted, of asbestos, for brakes','Pastillas y juntas para frenos, sin montar, de amianto',68,6813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681320,'Guarnição de fricção para freios, embreagens ou qualquer outro mecanismo de fricção, não montadas, contendo amianto','Friction material and articles thereof, e.g. sheets, rolls, strips, segments, discs, washers and pads, for clutches and the like, with a basis of asbestos, other mineral substances or cellulose, whether or not combined with textile or other materials, con','Guarniciones de fricción [ p.ej. hojas, rodillas, tiras, segmentos, discos, arandelas, plaquitas], sin montar, para frenos, embragues o cualquier órgano de frotamiento, a base de amianto [arbesto], otras sustancias mineral o celulosa, incluso combinadas c',68,6813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681381,'Guarnições para freios, não montadas, não contendo amianto','Brake linings and pads with a basis of asbestos, of other mineral substances or of cellulose, whether or not combined with textile or other materials, not containing asbestos','Guarniciones de frenos y pastillas de freno, a base de amianto, otras sustancias mineral o celulosa, incluso combinadas a textiles u otras materias, que no contengan amianto [arbesto]',68,6813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681389,'Outras guarnições de fricção, não montadas, não contendo amianto','Friction material and articles thereof, e.g. sheets, rolls, strips, segments, discs, washers and pads, for clutches and the like, with a basis of asbestos, other mineral substances or cellulose, whether or not combined with textile or other materials, not','Guarniciones de fricción [ p.ej. hojas, rodillas, tiras, segmentos, discos, arandelas, plaquitas], sin montar, para frenos, embragues o cualquier órgano de frotamiento, a base de amianto [arbesto], otras sustancias mineral o celulosa, incluso combinadas c',68,6813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681390,'Discos de fricção e outras guarnições, não montadas, de amianto','Friction discs and other mountings, not mounted, of asbestos','Discos de fricción y los montajes, sin montar, de amianto',68,6813);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681410,'Placas, folhas ou tiras, de mica aglomerada ou reconstituída','Plates, sheets and strips of agglomerated or reconstituted mica, whether or not on a support of paper, paperboard or other materials, in rolls or merely cut into square or rectangular shapes','Placas, hojas y tiras de mica aglomerada o reconstituida, incl. con soporte de papel, cartón u otras materias, en rollos o simplemente cortadas en forma cuadrada o rectangular',68,6814);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681490,'Outras obras de mica trabalhada','Worked mica and articles of mica (excl. electrical insulators, insulating fittings, resistors and capacitors, protective goggles of mica and their glasses, mica in the form of Christmas tree decorations, and plates, sheets and strips of agglomerated or re','Mica trabajada y manufacturas de mica (exc. aisladores eléctricos, piezas aislantes, resistencias y condensadores; gafas protectoras de mica y sus lentes; adornos de mica para árboles de Navidad; placas, hojas y tiras de mica aglomerada o reconstituida, i',68,6814);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681510,'Obras de grafita ou de outros carbonos, para usos não elétricos','Articles of graphite or other carbon, incl. carbon fibres, for non-electrical purposes','Manufacturas de grafito u otros carbonos (exc. para usos eléctricos)',68,6815);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681520,'Obras de turfa','Articles of peat (excl. textile products from peat fibres)','Manufacturas de turba (exc. productos textiles de fibras de turba)',68,6815);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681591,'Outras obras contendo magnesita, dolomita ou cromita','Articles of stone or other mineral substances, n.e.s. containing magnesite, dolomite or chromite','Manufacturas de piedra o de otras materias minerales, n.c.o.p., que contengan magnesita, dolomita o cormita',68,6815);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (681599,'Outras obras de pedras ou de outras matérias minerais','Articles of stone or other mineral substances, n.e.s. (excl. containing magnesite, dolomite or chromite and articles of graphite or other carbon)','Manufacturas de piedra o de otras materias minerales, n.c.o.p. (exc. que contengan magnesita, dolomita o cormita, así como manufacturas de grafito u otros carbonos)',68,6815);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690100,'Tijolos, placas (lajes), ladrilhos e outras peças cerâmicas de farinhas siliciosas fósseis ou de terras siliciosas','Bricks, blocks, tiles and other ceramic goods of siliceous fossil meals, e.g. kieselguhr, tripolite or diatomite, or of similar siliceous earths','Ladrillos, placas, baldosas y demás piezas cerámicas de harinas silíceas fósiles, p.ej. "Kieselguhr", tripolita o diatomita, o de tierras silíceas simil.',69,6901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690210,'Tijolos, placas, ladrilhos e peças cerâmicas semelhantes, para construção, refratários, contendo > 50% em peso dos elementos Mg, Ca, ou Cr, tomados isoladamente ou em conjunto, expressos em MgO, CaO2 ou Cr2O3','Refractory bricks, blocks, tiles and similar refractory ceramic constructional goods containing, by weight, singly or together, > 50% of the elements Mg, Ca or Cr, expressed as MgO, CaO or Cr2O3','Ladrillos, placas, baldosas y demás piezas cerámicas análogas de construcción, refractarios, con un contenido de los elementos Mg "magnesio", Ca "calcio" o Cr "cromo" > 50% en peso, considerados aislada o conjuntamente, expresados en MgO "óxido de magnesi',69,6902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690220,'Tijolos, placas, ladrilhos e peças cerâmicas semelhantes, para construção, refratários, contendo > 50% em peso de alumina e/ou sílica, ou de uma mistura destes produtos','Refractory bricks, blocks, tiles and similar refractory ceramic constructional goods containing, by weight, > 50% alumina, silica or a mixture or compound of these products (excl. those of siliceous fossil meals or similar siliceous earths)','Ladrillos, placas, baldosas y demás piezas cerámicas análogas de construcción, refractarios, con un contenido de alúmina "Al2O3", sílice "SiO2" o de una mezcla o combinación de estos productos > 50% en peso (exc. los de harinas silíceas fósiles o de tierr',69,6902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690290,'Outros tijolos, placas, ladrilhos e peças cerâmicas, para construção, refratários','Refractory bricks, blocks, tiles and similar refractory ceramic constructional goods (excl. containing, by weight, singly or together, > 50% of the elements Mg, Ca or Cr, expressed as MgO, CaO or Cr2O3, containing, by weight, > 50% alumina, silica or a mi','Ladrillos, placas, baldosas y demás piezas cerámicas análogas de construcción, refractarios (exc. artículos con un contenido de los elementos Mg, Ca o Cr > 50% en peso, considerados aislada o conjuntamente, expresado en MgO, CaO o Cr2O3; artículos con un ',69,6902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690310,'Outros produtos cerâmicos refratários, contendo em peso > 50% de grafita ou de outro carbono','Retorts, crucibles, mufflers, nozzles, plugs, supports, cupels, tubes, pipes, sheaths, rods and other refractory ceramic goods, containing, by weight, > 50% graphite, other carbon or a mixture thereof (excl. refractory bricks, blocks, tiles and similar re','Retortas, crisoles, muflas, toberas, tapones, soportes, copelas, tubos, fundas, varillas y demás productos cerámicos refractarios, con un contenido de grafito u otro carbono o de una mezcla de estos productos > 50% en peso (exc. ladrillos, placas, baldosa',69,6903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690320,'Outros produtos cerâmicos refratários, contendo em peso > 50% de alumina ou alumina e sílica','Retorts, crucibles, mufflers, nozzles, plugs, supports, cupels, tubes, pipes, sheaths, rods and other refractory ceramic goods, containing > 50% alumina, or a compound of alumina and silica (excl. refractory bricks, blocks, tiles and similar refractory ce','Retortas, crisoles, muflas, toberas, tapones, soportes, copelas, tubos, fundas, varillas y demás productos cerámicos refractarios, con un contenido de alúmina "Al2O3" o de una mezcla o combinación de alúmina y de sílice "SiO2" > 50% en peso (exc. ladrillo',69,6903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690390,'Outros produtos cerâmicos refratários','Retorts, crucibles, mufflers, nozzles, plugs, supports, cupels, tubes, pipes, sheaths, rods and other refractory ceramic goods (excl. those of siliceous fossil meals or similar siliceous earths, those of heading 6902, containing > 50% carbon or containing','Retortas, crisoles, muflas, toberas, tapones, soportes, copelas, tubos, fundas, varillas y demás productos cerámicos refractarios (exc. artículos de harinas silíceas fósiles o de tierras silíceas simil.; ladrillos, placas, baldosas y demás productos cerám',69,6903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690410,'Tijolos para construção, de cerâmica','Building bricks (excl. those of siliceous fossil meals or similar siliceous earths, and refractory bricks of heading 6902)','Ladrillos de construcción (exc. de harinas silíceas fósiles o de tierras silíceas análogas, así como ladrillos refractarios de la partida 6902)',69,6904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690490,'Tijoleiras, tapa-vigas e outros produtos semelhantes, para construção, de cerâmica','Ceramic flooring blocks, support or filler tiles and the like (excl. those of siliceous fossil meals or similar siliceous earths, refractory bricks of heading 6902, and flags and pavings, hearth and wall tiles of heading 6907 and 6908, and building bricks','Bovedillas, cubrevigas y artículos simil., de cerámica (exc. productos de harinas silíceas fósiles o de tierras silíceas análogas, ladrillos refractarios de la partida 6902, así como placas y baldosas de cerámica y losas para pavimentación o revestimiento',69,6904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690510,'Telhas de cerâmicas','Roofing tiles','Tejas',69,6905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690590,'Outros produtos cerâmicos para construção','Ceramic chimney pots, cowls, chimney liners, architectural ornaments and other ceramic constructional goods (excl. of siliceous fossil meals or similar siliceous earths, refractory ceramic constructional components, pipes and other components for drainage','Tejas, elementos de chimenea, conductos de humo, ornamentos arquitectónicos u artículos simil., de cerámica, de construcción (exc. de harinas silíceas fósiles o de tierras silíceas análogas, piezas cerámicas de construcción refractarias, así como tubos y ',69,6905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690600,'Tubos, calhas ou algerozes e acessórios para canalizações, de cerâmica','Ceramic pipes, conduits, guttering and pipe fittings (excl. of siliceous fossil meals or similar siliceous earths, refractory ceramic goods, chimney liners, pipes specifically manufactured for laboratories, insulating tubing and fittings and other piping ','Tubos, canalones y accesorios de tubería, de cerámica (exc. productos de harinas silíceas fósiles o de tierras silíceas análogas, artículos de cerámica refractarios, conductos de humo, tubos fabricados especialmente para laboratorios, así como tubos aisla',69,6906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690710,'Ladrilhos, cubos, pastilhas e artigos semelhantes, de lado < 7 cm, de cerâmica, não vidrados nem esmaltado','Unglazed ceramic tiles, cubes and similar articles, for mosaics, whether or not square or rectangular, the largest surface area of which is capable of being enclosed in a square of side of < 7 cm, whether or not on a backing','Plaquitas, cubos, dados u artículos simil., de cerámica, incl. de forma distinta de la cuadrada o rectangular, en los que la superficie mayor pueda inscribirse en un cuadrado de lado < 7 cm, incl. con soporte',69,6907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690790,'Outros ladrilhos e artigos semelhantes, de cerâmica, não vidrados nem esmaltados','Unglazed ceramic flags and paving, hearth or wall tiles (excl. of siliceous fossil meals or similar siliceous earths, refractory ceramic goods, tiles made into stands, ornamental articles and tiles specifically manufactured for stoves)','Placas y baldosas, de cerámica, sin barnizar ni esmaltar, para pavimentación o revestimiento (exc. productos de harinas silíceas fósiles o de tierras silíceas análogas, artículos de cerámica refractarios, azulejos utilizados como posavasos, objetos de ado',69,6907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690810,'Ladrilhos, cubos, pastilhas e artigos semelhantes, de lado < 7 cm, de cerâmica, vidrados ou esmaltados','Glazed ceramic tiles, cubes and similar articles, for mosaics, whether or not square or rectangular, the largest surface area of which is capable of being enclosed in a square of side of < 7 cm, whether or not on a backing','Plaquitas, cubos, dados u artículos simil., de cerámica, para mosaicos, barnizados o esmaltados, incl. de forma distinta de la cuadrada o rectangular, en los que la superficie mayor pueda inscribirse en un cuadrado de lado < 7 cm, incl. con soporte',69,6908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690890,'Outros ladrilhos e artigos semelhantes, de cerâmica, vidrados ou esmaltados','Glazed ceramic flags and paving, hearth or wall tiles (excl. of siliceous fossil meals or similar siliceous earths, refractory ceramic goods, tiles made into stands, ornamental articles and tiles specifically manufactured for stoves)','Placas y baldosas, de cerámica, para pavimentación o revestimiento, barnizadas o esmaltadas (exc. productos de harinas silíceas fósiles o de tierras silíceas análogas, artículos de cerámica refractarios, azulejos utilizados como posavasos, objetos de ador',69,6908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690911,'Aparelhos e artefatos de porcelana, para usos químicos ou técnicos','Ceramic wares for laboratory, chemical or other technical uses, of porcelain or china (excl. refractory ceramic goods, electrical devices, insulators and other electrical insulating fittings)','Aparatos y artículos de porcelana, para usos químicos o demás usos técnicos (exc. productos cerámica refractarios, así como aparatos eléctricos, aisladores eléctricos y demás piezas aislantes)',69,6909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690912,'Outros artefatos de cerâmica, com dureza => 9 Mohs','Ceramic articles having a hardness equivalent to >= 9 on the Mohs scale, for chemical or other technical uses (excl. of porcelain or china, refractory ceramic goods, electrical devices, insulators and other electrical insulating fittings)','Artículos de cerámica con una dureza >= 9 en la escala de Mohs, para usos químicos o demás usos técnicos (exc. de porcelana, así como productos cerámica refractarios, aparatos eléctricos, aisladores eléctricos y demás piezas aislantes)',69,6909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690919,'Outros aparelhos e artefatos de cerâmica, para usos químicos ou técnicos','Ceramic wares for chemical or other technical uses (excl. of porcelain or china, articles having a hardness equivalent to >= 9 on the Mohs scale, millstones, polishing stones, grindstones and the like of heading 6804, refractory ceramic goods, electrical ','Aparatos y artículos de cerámica, para usos químicos o demás usos técnicos (exc. de porcelana, así como artículos con una dureza >= 9 en la escala de Mohs, muelas, piedras de afilar o pulir y demás artículos de la partida 6804, artículos de cerámica refra',69,6909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (690990,'Alguidares, gamelas e outros recipientes semelhantes, de cerâmica, para usos rurais','Ceramic troughs, tubs and similar receptacles of a kind used in agriculture; ceramic pots, jars and similar articles of a kind used for the conveyance or packing of goods (excl. general-purpose storage vessels for laboratories, containers for shops and ho','Abrevaderos, pilas y recipientes simil., de cerámica, para uso rural; cántaros y recipientes simil., de cerámica, para transporte o envasado (exc. vasijas de pie de uso general para laboratorio, cántaros y jarros para el comercio y artículos de uso domést',69,6909);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (691010,'Pias, lavatórios, banheiras, bidês e semelhantes, de porcelana, para usos sanitários','Ceramic sinks, washbasins, washbasin pedestals, baths, bidets, water closet pans, flushing cisterns, urinals and similar sanitary fixtures of porcelain or china (excl. soap dishes, sponge holders, tooth-brush holders, towel hooks and toilet paper holders)','Fregaderos "piletas para lavar", lavabos, pedestales de lavabo, bañeras, bidés, inodoros, cisternas "depósitos de agua" para inodoros, urinarios y aparatos fijos simil., para usos sanitarios, de porcelana (exc. soportes para jabón, para esponjas, para cep',69,6910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (691090,'Pias, lavatórios, banheiras, bidês e semelhantes, de cerâmica, exceto porcelana, para usos sanitários','Ceramic sinks, washbasins, washbasin pedestals, baths, bidets, water closet pans, flushing cisterns, urinals and similar sanitary fixtures (excl. of porcelain or china, soap dishes, sponge holders, tooth-brush holders, towel hooks and toilet paper holders','Fregaderos "piletas para lavar", lavabos, pedestales de lavabo, bañeras, bidés, inodoros, cisternas "depósitos de agua" para inodoros, urinarios y aparatos fijos simil., de cerámica, para usos sanitarios (exc. de porcelana, así como soportes para jabón, p',69,6910);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (691110,'Artigos para serviço de mesa ou cozinha, de porcelana','Tableware and kitchenware, of porcelain or china (excl. ornamental articles, pots, jars, carboys and similar receptacles for the conveyance or packing of goods, and coffee grinders and spice mills with receptacles made of ceramics and working parts of met','Artículos para servicio de mesa o cocina, de porcelana (exc. objetos de adorno; cántaros, bombonas y recipientes simil. de transporte o envasado; molinos de café y de especias con recipientes de cerámica y parte operante de metal)',69,6911);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (691190,'Outros artigos de uso doméstico e de higiene ou de toucador, de porcelana','Household and toilet articles, of porcelain or china (excl. tableware and kitchenware, baths, bidets, sinks and similar sanitary fixtures, statuettes and other ornamental articles, pots, jars, carboys and similar receptacles for the conveyance or packing ','Vajilla y demás artículos de uso doméstico, higiene o tocador, de porcelana (exc. artículos para servicio de mesa o cocina, así como bañeras, bidés, fregaderos y aparatos fijos simil.; estatuillas y demás objetos de adorno; cántaros, bombonas y recipiente',69,6911);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (691200,'Louças, outros artigos de uso da espécie doméstica e de higiene ou de toucador, de cerâmica, exceto de porcelana','Tableware, kitchenware, other household articles and toilet articles, of ceramics other than porcelain or china (excl. baths, bidets, sinks and similar sanitary fixtures, statuettes and other ornamental articles, pots, jars, carboys and similar receptacle','Vajilla y demás artículos de uso doméstico, higiene o tocador, de cerámica distinta de la porcelana (exc. bañeras, bidés, fregaderos y aparatos fijos simil.; estatuillas y demás objetos de adorno; cántaros, bombonas y recipientes simil. de transporte o en',69,6912);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (691310,'Estatuetas e outros objetos de ornamentação, de porcelana','Statuettes and other ornamental articles of porcelain or china, n.e.s.','Estatuillas y demás artículos para adorno, de porcelana, n.c.o.p.',69,6913);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (691390,'Estatuetas e outros objetos de ornamentação, de cerâmica','Statuettes and other ornamental ceramic articles, n.e.s. (excl. of porcelain or china)','Estatuillas y demás artículos para adorno, de cerámica distinta de la porcelana, n.c.o.p.',69,6913);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (691410,'Outras obras de porcelana','Ceramic articles of porcelain or china, n.e.s.','Manufacturas de porcelana, n.c.o.p.',69,6914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (691490,'Outras obras de cerâmica','Ceramic articles, n.e.s. (excl. of porcelain or china)','Manufacturas de cerámica distinta de la porcelana, n.c.o.p.',69,6914);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700100,'Cacos, fragmentos e outros desperdícios e resíduos de vidro; vidro em blocos ou massas','Cullet and other waste and scrap of glass; glass in the mass (excl. glass in the form of powder, granules or flakes)','Desperdicios y desechos de vidrio, así como vidrio en masa (exc. vidrio en forma de polvo, gránulos, lentejuelas o escamas)',70,7001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700210,'Esferas de vidro, não trabalhado','Glass in balls, unworked (excl. glass microspheres <= 1 mm in diameter, glass balls of the nature of a toy)','Vidrio en bolas, sin trabajar (exc. microesferas de vidrio con un diámetro <= 1 mm, así como bolas de vidrio con características de juguete)',70,7002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700220,'Barras ou varetas, de vidro, não trabalhado','Rods of glass, unworked','Barras o varillas de vidrio, sin trabajar',70,7002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700231,'Tubos de quartzo ou de outras sílicas fundidos, não trabalhados','Tubes of fused quartz or other fused silica, unworked','Tubos, de cuarzo o demás sílices fundidos, sin trabajar',70,7002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700232,'Tubos de outros vidros, com coeficiente de dilatação linear <= 5x106 por Kelvin, não trabalhados','Tubes of glass having a linear coefficient of expansion <= 5 x 10-6 per kelvin within a temperature range of 0°C to 300°C, unworked (excl. tubes of glass having a linear coefficient of expansion <= 5 x 10-6 per kelvin within a temperature range of 0°C to ','Tubos de vidrio, con un coeficiente de dilatación lineal <= 5 x 10-6 por Kelvin, entre 0°C y 300°C, sin trabajar',70,7002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700239,'Tubos de outros vidros, não trabalhados','Tubes of glass, unworked (excl. tubes of glass having a linear coefficient of expansion <= 5 x 10-6 per kelvin within a temperature range of 0°C to 300°C or of fused quartz or other fused silica)','Tubos de vidrio, sin trabajar (exc. con un coeficiente de dilatación lineal <= 5 x 10-6 por Kelvin, entre 0°C y 300°C, así como de cuarzo o demás sílices fundidos)',70,7002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700312,'Chapas e folhas não armadas, de vidro vazado ou laminado, coradas na massa, opacificadas, folheadas (chapeadas), ou com camada absorvente, refletora ou não','Cast glass and rolled glass, in non-wired sheets, coloured throughout the mass body tinted, opacified, flashed or having an absorbent, reflecting or non-reflecting layer, but not otherwise worked','Placas u hojas de vidrio colado o laminado, coloreadas en la masa, opacificadas, chapadas o con capa absorbente, reflectante o antirreflectante, pero sin trabajar de otro modo (exc. armadas)',70,7003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700319,'Outras chapas e folhas, não armadas, de vidro vazado ou laminado','Cast glass and rolled glass, in non-wired sheets, not otherwise worked (excl. glass coloured throughout the mass body tinted, opacified, flashed or having an absorbent, reflecting or non-reflecting layer)','Placas u hojas de vidrio colado o laminado, pero sin trabajar de otro modo (exc. armadas, así como coloreadas en la masa, opacificadas, chapadas o con capa absorbente, reflectante o antirreflectante)',70,7003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700320,'Chapas e folhas armadas, de vidro vazado ou laminado','Cast glass and rolled glass, in wired sheets, whether or not with absorbent, reflecting or non-reflecting layer, but not otherwise worked','Placas u hojas de vidrio colado o laminado, armadas, incl. con capa absorbente, reflectante o antirreflectante, pero sin trabajar de otro modo',70,7003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700330,'Perfis de vidro vazado ou laminado','Profiles of glass, whether or not having an absorbent, reflecting or non-reflecting layer, but not otherwise worked','Perfiles de vidrio, incl. con capa absorbente, reflectante o antirreflectante, pero sin trabajar de otro modo',70,7003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700420,'Folhas de vidro estirado ou soprado, corado na massa, opacificado, folheado (chapeado), ou com camada absorvente, refletora ou não','Sheets of glass, drawn or blown, coloured throughout the mass body tinted opacified, flashed or having an absorbent, reflecting or non-reflecting layer, but not otherwise worked','Hojas de vidrio estirado o soplado, coloreadas en la masa, opacificadas, chapadas o con capa absorbente, reflectante o antirreflectante, pero sin trabajar de otro modo',70,7004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700490,'Outro vidro estirado ou soprado, em folhas','Sheets of glass, drawn or blown, but not otherwise worked (excl. glass coloured throughout the mass body tinted opacified, flashed or having an absorbent, reflecting or non-reflecting layer)','Hojas de vidrio estirado o soplado, pero sin trabajar de otro modo (exc. coloreadas en la masa, opacificadas, chapadas o con capa absorbente, reflectante o antirreflectante)',70,7004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700510,'Vidro flotado não armado, com camada absorvente, refletora ou não, em chapas ou em folhas','Float glass and surface ground or polished glass, in sheets, having an absorbent, reflecting or non-reflecting layer, but not otherwise worked (excl. wired glass)','Vidrio flotado y vidrio desbastado o pulido por una o las dos caras, en placas o en hojas, incl. con capa absorbente, reflectante o antirreflectante, pero sin trabajar de otro modo (exc. armadas)',70,7005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700521,'Outro vidro flotado não armado, corado na massa, opacificado, folheado (chapeado), ou simplesmente desbastado, em chapas ou folhas','Float glass and surface ground glass, in sheets, coloured throughout the mass body tinted, opacified, flashed or merely surface ground, but not otherwise worked (excl. wired glass or glass having an absorbent, reflecting or non-reflecting layer)','Vidrio flotado y vidrio desbastado o pulido por una o las dos caras, en placas o en hojas, coloreados en la masa, opacificados, chapados o simplemente desbastados, pero sin trabajar de otro modo (exc. armadas o con capa absorbente, reflectante o antirrefl',70,7005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700529,'Outros vidros flotados e desbastados não armados, em chapas ou em folhas','Float glass and surface ground and polished glass, in sheets, but not otherwise worked (excl. wired glass or glass coloured throughout the mass body tinted, opacified, flashed or merely surface ground, or glass having an absorbent, reflecting or non-refle','Vidrio flotado y vidrio desbastado o pulido por una o las dos caras, en placas o en hojas, pero sin trabajar de otro modo (exc. armadas o coloreados en la masa, opacificados, chapados o simplemente desbastados, así como las lunas con capa absorbente, refl',70,7005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700530,'Vidros flotados e desbastados armados, em chapas ou em folhas','Float glass and surface ground and polished glass, in sheets, whether or not having an absorbent, reflecting or non-reflecting layer, wired, but not otherwise worked','Vidrio flotado y vidrio desbastado o pulido por una o las dos caras, en placas o en hojas, incl. con capa absorbente, reflectante o antirreflectante, armadas, pero sin trabajar de otro modo',70,7005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700600,'Vidro recurvado, biselado, gravado, brocado ou trabalhado de outro modo, mas não emoldurado','Sheets or profiles of glass, whether or not having an absorbent, reflecting or non-reflecting layer, bent, edge-worked, engraved, enamelled or otherwise worked, but not framed or fitted with other materials (excl. safety glass, multiple-walled insulating ','Placas, hojas o perfiles de vidrio, incl. con capa absorbente, reflectante o antirreflectante, curvado, biselado, grabado, taladrado, esmaltado o trabajado de otro modo, pero sin enmarcar ni combinar con otras materias (exc. vidrio de seguridad, vidrieras',70,7006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700711,'Vidros de segurança, temperados, de dimensões e formatos para uso em automóveis, barcos ou outros veículos','Toughened tempered safety glass, of size and shape suitable for incorporation in motor vehicles, aircraft, spacecraft, vessels and other vehicles','Vidrio templado, de dimensiones y formatos que permitan su empleo en automóviles, aeronaves, barcos u otros vehículos',70,7007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700719,'Outros vidros de segurança, temperados','Toughened tempered safety glass (excl. glass of size and shape suitable for incorporation in motor vehicles, aircraft, spacecraft, vessels and other vehicles, and lenses for spectacles and goggles, etc., and for clocks and watches)','Vidrio templado (exc. de dimensiones y formatos que permitan su empleo en automóviles, aeronaves, barcos u otros vehículos, así como cristales para reloj y para gafas)',70,7007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700721,'Vidros de segurança, formados de folhas contracoladas, de dimensões e formatos para aplicação em automóveis, barcos ou outros veículos','Laminated safety glass, of size and shape suitable for incorporation in motor vehicles, aircraft, spacecraft, vessels and other vehicles (excl. multiple-walled insulating units of glass)','Vidrio contrachapado, de dimensiones y formatos que permitan su empleo en automóviles, aeronaves, barcos u otros vehículos (exc. vidrieras aislantes de paredes múltiples)',70,7007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700729,'Outros vidros de segurança, formados de folhas contracoladas','Laminated safety glass (excl. glass of size and shape suitable for incorporation in motor vehicles, aircraft, spacecraft, vessels or other vehicles, multiple-walled insulating units)','Vidrio contrachapado (exc. de dimensiones y formatos que permitan su empleo en automóviles, aeronaves, barcos u otros vehículos, así como vidrieras aislantes de paredes múltiples)',70,7007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700800,'Vidros isolantes de paredes múltiplas','Multiple-walled insulating units of glass','Vidrieras aislantes de paredes múltiples',70,7008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700910,'Espelhos retrovisores para veículos','Rear-view mirrors, whether or not framed, for vehicles','Espejos retrovisores enmarcados o no, incl. los espejos retrovisores, con marco o sin él, para vehículos',70,7009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700991,'Espelhos de vidro, não emoldurados','Glass mirrors, unframed (excl. rear-view mirrors for vehicles, optical mirrors, optically worked, mirrors > 100 years old)','Espejos de vidrio, sin enmarcar (exc. espejos retrovisores para vehículos, espejos de óptica de vidrio trabajado ópticamente y espejos de más de 100 años)',70,7009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (700992,'Espelhos de vidro, emoldurados','Glass mirrors, framed (excl. rear-view mirrors for vehicles, optical mirrors, optically processed, and mirrors of an age of > 100 years)','Espejos de vidrio, enmarcados (exc. espejos retrovisores para vehículos, espejos de óptica de vidrio trabajado ópticamente y espejos de más de 100 años)',70,7009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701010,'Ampolas de vidro, para transporte ou embalagem','Glass ampoules','Ampollas de vidrio',70,7010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701020,'Rolhas, tampas e outros dispositivos de uso semelhantes, de vidro','Stoppers, lids and other closures, of glass','Tapones, tapas y demás dispositivos de cierre, de vidrio',70,7010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701090,'Garrafões, garrafas, frascos, boiões, vasos e outros recipientes, de vidro, próprios para transporte ou embalagem','Carboys, bottles, flasks, jars, pots, phials and other containers, of glass, of a kind used for the commercial conveyance or packing of goods, and preserving jars, of glass (excl. ampoules, glass inners for containers, with vacuum insulation, perfume atom','Bombonas "damajuanas", botellas, frascos, bocales, tarros, envases tubulares y demás recipientes para el transporte o envasado comerciales, de vidrio (exc. ampollas y demás recipientes isotérmicos aislados por vacío y pulverizadores de tocador, así como b',70,7010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701091,'Garrafões, garrafas, boiões, vasos (de vidro), capacidade > 1 litro','Carboys, bottles, jars, pots (of  glass), capacity > 1 liter','Bombonas, botellas, tarros, envases (de vidrio), capacidad > 1 litro',70,7010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701092,'Garrafões, garrafas, boiões, vasos (de vidro), capacidade <= 1 litro','Carboys, bottles, jars, pots (of  glass), capacity <= 1 liter','Bombonas, botellas, tarros, envases (de vidrio), capacidad <= 1 litro',70,7010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701093,'Garrafões, garrafas, frascos, etc.de vidro, 0.15l<c<=0.33l','Carboys, bottles, flasks, etc.of glass, 0.15l<c<=0.33l','Bombonas, botellas, frascos, etc.de vidrio, 0.15l<c<=0.33l',70,7010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701094,'Garrafões, garrafas, frascos, etc.de vidro, capacid<=0.15l','Carboys, bottles, flasks, etc.of glass, capacity<=0.15l','Bombonas, botellas, frascos, etc.de vidrio, capacid.<=0.15l',70,7010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701110,'Ampolas e invólucros de vidro, para iluminação elétrica','Glass envelopes, incl. bulbs and tubes, open, and glass parts thereof, without fittings, for electric lighting','Ampollas y envolturas tubulares, abiertas, y sus partes, de vidrio, sin guarniciones, manifiestamente destinadas a lámparas de alumbrado eléctrico',70,7011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701120,'Ampolas e invólucros de vidro, para tubos catódicos','Glass envelopes, incl. bulbs and tubes, open, and glass parts thereof, without fittings, for cathode ray tubes','Ampollas y envolturas tubulares, abiertas, y sus partes, de vidrio, sin guarniciones, manifiestamente destinadas a tubos catódicos',70,7011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701190,'Outras ampolas e invólucros abertos, e suas partes, de vidro','Glass envelopes, incl. bulbs and tubes, open, and glass parts thereof, without fittings, for electric lamps and the like (excl. cathode ray tubes and for electric lighting)','Ampollas y envolturas tubulares, abiertas, y sus partes, de vidrio, sin guarniciones, manifiestamente destinadas a lámparas eléctricas o simil. (exc. para tubos catódicos y para lámparas de alumbrado eléctrico)',70,7011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701200,'ampolas de vidro,  p/garrafas termicas,  etc.isolam.a vácuo','glass inners f/vacuum flask, etc.vacuum vessels','ampollas de vidrio, p/botellas térmicas, etc.aisl.p/vacío',70,7012);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701310,'Objetos de vitrocerâmica, para serviço de mesa, cozinha, toucador, ornamentação ou usos semelhantes','Glassware of glass ceramics, of a kind used for table, kitchen, toilet, office, indoor decoration or similar purposes (excl. goods of heading 7018, cooking hobs, leaded lights and the like, lighting fittings and parts thereof, atomizers for perfume and th','Artículos de vitrocerámica para servicio de mesa, de cocina, de tocador, para oficina, de adorno de interiores o usos simil. (exc. los objetos de la partida 7010 ó 7018, así como placas de cocina, vidrieras artísticas, aparatos de alumbrado y sus partes y',70,7013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701321,'Recipientes para beber, de cristal de chumbo','Drinking glasses, of lead crystal','Recipientes para beber, de cristal al plomo',70,7013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701322,'Copos com pé, de cristal de chumbo','Drinking glasses, stemware, of lead crystal','Vasos com pie de cristal al plomo',70,7013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701328,'Outros copos com pé, de vidro, exceto de vitrocerâmica','Drinking glasses, stemware (excl. of glass ceramics or of lead crystal)','Los demás vasos com pie, de vidrio, exc. de vitrocerámica ',70,7013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701329,'Outros recipientes para beber, de vidro','Other drinking glasses, of glass','Los demás recipientes para beber, de vidrio',70,7013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701331,'Objetos de cristal de chumbo, p/serviços de mesa/cozinha','Glassware of lead crystal, used f/table/kitchen','Artícs.de cristal al plomo, p/servicio de mesa/cocina',70,7013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701332,'Cafeteiras, chaleiras e outros objetos de vidro','Coffee makers, kettles and other glass objects','Cafeteras, teteras y otros objetos de vidrio',70,7013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701333,'Outros copos de cristal de chumbo','Drinking glasses of lead crystal (excl. stemware)','Los demás vasos de cristal al plomo',70,7013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701337,'Outros copos de vidro, exceto de vitrocerâmica','Drinking glasses (excl. glasses of glass ceramics or of lead crystal and stemware)','Los demás vasos, de vidrio, exc. de vitrocerámica ',70,7013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701339,'Outros objetos de vidro, para serviços de mesa/cozinha','Oth.glassware of a kind used f/table, kitchen','Los demás artícs.de vidrio, p/servicio de mesa/cocina',70,7013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701341,'Objetos para serviço de mesa ou de cozinha (exceto copos), de cristal de chumbo','Glassware of lead crystal, of a kind used for table or kitchen purposes (excl. articles of heading 7018, drinking glasses, glass preserving jars sterilising jars, vacuum flasks and other vacuum vessels)','Artículos para servicio de mesa o de cocina (exc. vasos), de cristal al plomo',70,7013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701342,'Objetos para serviço de mesa, de vidro (exceto de vitrocerãmica), com coeficiente de dilatação linear não superior a 5x10-6 por Kelvin, entre 0°C e 300°C','Glassware for table or kitchen purposes of glass having a linear coefficient of expansion <= 5 x 10 -6 per kelvin within a temperature range of 0°C to 300°C (excl. glassware of glass ceramics or lead crystal, articles of heading 7018, drinking glasses, gl','Artículos de vidrio, para servicio de mesa o de cocina (exc. artículos de vitrocerámica), con un coeficiente de dilatación lineal <= 5 x 10-6 por Kelvin, entre 0°C y 300°C',70,7013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701349,'Outros objetos de serviço de mesa ou de cozinha, exceto de vitrocerâmica','Glassware for table or kitchen purposes (excl. glass having a linear coefficient of expansion <= 5 x 10 -6 per kelvin within a temperature range of 0°C to 300°C, glassware of glass ceramics or lead crystal, articles of heading 7018, drinking glasses, glas','Los demás artículos de vidrio, para servicio de mesa o de cocina (exc. artículos de vitrocerámica)',70,7013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701391,'Outros objetos de cristal de chumbo, para toucador, escritório decoração e usos semelhantes','Glassware, of lead crystal, of a kind used for toilet, office, indoor decoration or similar purposes (excl. glassware of a kind used for table or kitchen purposes, glassware of glass ceramics or lead crystal, articles of heading 7018, mirrors, leaded ligh','Artículos de cristal al plomo, de tocador, para oficina, de adorno de interiores o usos simil. (exc. para servicio de mesa o de cocina, objetos de la partida 7018, así como espejos, vidrieras artísticas, aparatos de alumbrado y sus partes y pulverizadores',70,7013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701399,'Outros objetos de vidro (exceto vitrocerãmica), para toucador, escritório, decoração e usos semelhantes','Glassware of a kind used for toilet, office, indoor decoration or similar purposes (excl. glassware of lead crystal or of a kind used for table or kitchen purposes, articles of heading 7018, mirrors, leaded lights and the like, lighting fittings and parts','Artículos de vidrio, de tocador, para oficina, de adorno de interiores o usos simil. (exc. de cristal al plomo, objetos para servicio de mesa o de cocina, objetos de la partida 7018, así como espejos, vidrieras artísticas, aparatos de alumbrado y sus part',70,7013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701400,'Artefatos de vidro para sinalização e elementos de óptica de vidro','Signalling glassware and optical elements of glass, not optically worked (excl. clock or watch glasses, glasses for non-corrective or corrective spectacles, incl. hollow glass spheres and their segments, for the manufacture of such glasses, microspheres, ','Vidrio para señalización y elementos de óptica de vidrio, sin trabajar ópticamente (exc. cristales para reloj y cristales simil.; cristales para gafas "anteojos", incl. correctores, así como esferas huecas y sus segmentes "casquetes esféricos", de vidrio,',70,7014);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701510,'Vidros para lentes corretivas, não trabalhados opticamente','Glasses for corrective spectacles, curved, bent, hollowed or the like, but not optically worked (excl. flat glass for such purposes)','Cristales correctores para gafas "anteojos", abombados, curvados, ahuecados o simil., sin trabajar ópticamente (exc. vidrio plano para los mismos usos)',70,7015);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701590,'Vidros para relógios e aparelhos semelhantes, lentes não corretivas, não trabalhados opticamente, esferas de vidro ocas e seus segmentos','Clock or watch glasses and similar glasses, glasses for non-corrective spectacles, curved, bent, hollowed or the like, but not optically worked, hollow glass spheres and their segments, for the manufacture of such glasses incl. glasses for corrective spec','Cristales para reloj y cristales análogos, cristales para gafas "anteojos", incl. correctores, abombados, curvados, ahuecados o simil., sin trabajar ópticamente; esferas huecas y sus segmentos "casquetes esféricos", de vidrio, para la fabricación de estos',70,7015);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701610,'Cubos, pastilhas e outros artigos semelhantes, de vidro, mesmo com suporte, para mosaicos ou decorações semelhantes','Glass cubes and other glass smallwares, whether or not on a backing, for mosaics or similar decorative purposes (excl. finished panels and other finished decorative motifs, made from glass cubes for mosaics)','Cubos, dados y demás artículos simil., de vidrio, incl. con soporte, para mosaicos y decoraciones simil. (exc. hojas completas y motivos completos para mosaicos fabricados con dados de vidrio)',70,7016);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701690,'Blocos, placas, tijolos e outros artefatos, de vidro prensado ou moldado, para a construção','Paving blocks, slabs, bricks, squares, tiles and other articles of pressed or moulded glass, whether or not wired, for building or construction purposes (excl. laminated safety glass and multiple-walled insulating units of glass); leaded lights and the li','Adoquines, boldosas, ladrillos, placas, tejas y demás artículos, de vidrio prensado o moldeado, incl. armado, para la construcción; vidrieras artísticas "vitrales, incl. de vidrios incoloros"; vidrio multicelular o vidrio "espuma", en bloques, paneles, pl',70,7016);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701710,'Artefatos de quartzo ou de outras sílicas fundidos, para laboratório','Laboratory, hygienic or pharmaceutical glassware, whether or not graduated or calibrated, of fused quartz or other fused silica (excl. containers for the conveyance or packing of goods, measuring, checking or medical instruments and apparatus of chapter 9','Artículos de vidrio para laboratorio, higiene o farmacia, incl. graduados o calibrados, de cuarzo o demás sílices fundidos (exc. recipientes para transporte o envasado, así como instrumentos y aparatos de medida, control y médicos del capítulo 90)',70,7017);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701720,'Artefatos de outro vidro, com coeficiente de dilatação linear <= 5x106 por Kelvin, para laboratório','Laboratory, hygienic or pharmaceutical glassware, whether or not graduated or calibrated, having a linear coefficient of expansion <= 5 x 10 -6 per kelvin within a temperature range of 0°C to 300°C (excl. glass of fused quartz or other fused silica, conta','Artículos de vidrio para laboratorio, higiene o farmacia, incl. graduados o calibrados, con coeficiente de dilatación lineal <= 5 x 10-6 por Kelvin, entre 0°C y 300°C (exc. de cuarzo o demás sílices fundidos, y recipientes para transporte o envasado, así ',70,7017);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701790,'Outros artefatos de vidro, para laboratório, higiene e farmácia','Laboratory, hygienic or pharmaceutical glassware, whether or not graduated or calibrated (excl. glass having a linear coefficient of expansion <= 5 x 10 -6 per kelvin within a temperature range of 0°C to 300°C or of fused quartz or other fused silica, con','Artículos de vidrio para laboratorio, higiene o farmacia, incl. graduados o calibrados (exc. con coeficiente de dilatación lineal <= 5 x 10-6 por Kelvin, entre 0°C y 300°C, de cuarzo o demás sílices fundidos, y recipientes para transporte o envasado, así ',70,7017);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701810,'Contas, imitações de pérolas naturais ou cultivadas, de pedras preciosas ou semipreciosas e artefatos semelhantes, de vidro','Glass beads, imitation pearls, imitation precious or semi-precious stones and similar glass smallwares, and articles thereof (excl. imitation jewellery); glass eyes (excl. prosthetic articles); statuettes and other ornaments of lamp-worked glass (excl. im','Cuentas de vidrio, imitaciones de perlas, de piedras preciosas o semipreciosas y artículos simil. de abalorio y sus manufacturas (exc. la bisutería)',70,7018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701820,'Microesferas de vidro, de diâmetro <= 1 mm','Glass microspheres <= 1 mm in diameter','Microesferas de vidrio con un diámetro <= 1 mm',70,7018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701890,'Outras obras e objetos de ornamentação, de vidro','Glass eyes (excl. prosthetic articles); articles of glass beads, or of imitation pearls, imitation precious or semi-precious stones, statuettes and other ornaments of lamp-worked glass (excl. imitation jewellery)','Ojos de vidrio (exc. los de prótesis); objetos de cuentas de vidrio o de imitaciones de perlas, de imitaciones de piedras preciosas o semipreciosas o de otros objetos de abalorio, así como estatuillas y demás objetos de ornamentación, de vidrio trabajado ',70,7018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701911,'Fios de fibras de vidro, cortados, de comprimento <= 50 mm','Glass fibre threads chopped strands, cut into lengths <= 50 mm','Hilados de fibra de vidrio "chopped strands" de longitud <= 50 mm',70,7019);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701912,'Mechas ligeiramente torcidas (rovings), de fibras de vidro','Rovings of glass fibres','Mechas "rovings", "stratifils", de fibra de vidrio',70,7019);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701919,'Outras mechas e fios, de fibras de vidro','Glass staple fibres, yarn of glass fibres and filaments (excl. yarn in chopped strands of a length of <= 50 mm, and rovings)','Fibras de vidrio discontinuas e hilados, incl. cortados, de fibra de vidrio (exc. hilados de longitud <= 50 mm, así como mechas "rovings", "stratifils")',70,7019);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701920,'Fibras de vidro (incluída a lã de vidro) e artigos: tecidos, incluindo fitas','Glass fibers (including glass wool) and articles: woven fabrics, including narrow fabrics','Fibras de vidrio (incluida la lana de vidrio) y manufacturas: Tejidos, incluidas las cintas',70,7019);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701931,'Esteiras (mats) de fibras de vidro, não tecidos','Mats of irregularly laminated glass fibres','"Mats" de capas de fibras de vidrio desorientadas',70,7019);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701932,'Véus de fibras de vidro, não tecidos','Thin sheets voiles of irregularly laminated glass fibres','Velos de capas de fibras de vidrio desorientadas',70,7019);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701939,'Mantas, colchões, painéis e produtos semelhantes, de fibras de vidro, não tecidos','Webs, mattresses, boards and similar nonwoven products, of glass fibres (excl. mats and thin sheets voiles)','Napas, colchones, paneles y productos simil. sin tejer, de fibras de vidrio (exc. "mats" y velos)',70,7019);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701940,'Tecidos de mechas ligeiramente torcidas (*rovings*), de fibras de vidro','Woven fabrics of glass fibres made from rovings','Tejidos de mechas "rovings", "stratifils", de fibra de vidrio',70,7019);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701951,'Outros tecidos de fibras de vidro, de largura <= 30 cm','Woven fabrics, incl. narrow fabrics, of glass, of a width of <= 30 cm (excl. rovings)','Tejidos, incl. cintas, de fibra de vidrio, de anchura <= 30 cm (exc. de mechas "rovings", "stratifils")',70,7019);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701952,'Outros tecidos de fibras de vidro, de largura > 30 cm, em ponto de tafetá, com peso < 250 g/m2','Woven fabrics, incl. narrow fabrics, of glass filaments, of width of > 30 cm, plain weave, weighing < 250 g/m², made of yarn of a linear density of <= 136 tex per single yarn (excl. fabrics made from rovings)','Tejidos, incl. cintas, de filamentos de fibra de vidrio, de anchura > 30 cm, de ligamento tafetán, de peso < 250 g/m², de filamentos de título <= 136 tex por hilo sencillo (exc. de mechas "rovings", "stratifils")',70,7019);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701959,'Outros tecidos de fibras de vidro','Woven fabrics, incl. narrow fabrics, of glass fibres, of a width of > 30 cm (excl. plain weave, weighing < 250 g/m², of a linear density of <= 136 tex per single yarn, and fabrics made from rovings)','Tejidos, incl. cintas, de fibra de vidrio, de anchura > 30 cm (exc. tejidos de filamentos de vidrio, de ligamento tafetán, gramaje < 250 g/m² y filamentos de título <= 136 tex por hilo sencillo, así como tejidos de mechas "rovings", "stratifils")',70,7019);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (701990,'Outras obras de fibras de vidro','Glass fibres, incl. glass wool, and articles thereof (excl. staple fibres, rovings, yarn, chopped strands, woven fabrics, incl. narrow fabrics, thin sheets voiles, webs, mats, mattresses and boards and similar nonwoven products, mineral wool and articles ','Fibra de vidrio, incl. la lana de vidrio, y sus manufacturas (exc. fibras de vidrio discontinuas; mechas "rovings", "stratifils" e hilados, incl. cortados "chopped strands"; velos, napas, "mats", colchones, paneles y productos simil. sin tejer; lanas mine',70,7019);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (702000,'Outras obras de vidro','Articles of glass, n.e.s.','Manufacturas de vidrio, n.c.o.p.',70,7020);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710110,'Pérolas naturais, não montadas, nem engastadas','Pearls, natural, whether or not worked or graded, but not strung, mounted or set, natural pearls, temporarily strung for convenience of transport (excl. mother-of-pearl)','Perlas finas "naturales", incl. trabajadas o clasificadas, pero sin ensartar, montar ni engarzar; perlas finas "naturales", ensartadas temporalmente para facilitar el transporte (exc. nácar)',71,7101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710121,'Pérolas cultivadas, em bruto','Cultured pearls, unworked, whether or not graded','Perlas cultivadas, en bruto, incl. clasificadas',71,7101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710122,'Pérolas cultivadas, trabalhadas, não montadas, nem engastadas','Cultured pearls, worked, whether or not graded, but not strung, mounted or set, worked cultured pearls, temporarily strung for convenience of transport','Perlas cultivadas, trabajadas, incl. clasificadas, pero sin ensartar, montar ni engarzar; perlas cultivadas, enfiladas temporalmente para facilitar el transporte',71,7101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710210,'Diamantes não selecionados, não montados, nem engastados','Diamonds, unsorted','Diamantes, sin clasificar',71,7102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710221,'Diamantes industriais, em bruto ou serrados, clivados ou desbastados','Industrial diamonds unworked or simply sawn, cleaved or bruted','Diamantes industriales, en bruto o simplemente aserrados, exfoliados o desbastados',71,7102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710229,'Outros diamantes industriais, não montados, nem engastados','Industrial diamonds, worked, but not mounted or set (excl. unmounted stones for pick-up styluses, stones suitable for use as parts of meters, measuring instruments or other articles of chapter 90)','Diamantes industriales, trabajados, sin montar ni engarzar (exc. piedras sin montar para agujas de fonocaptores, así como piedras reconocibles como partes de contadores, de instrumentos de medida o de otros productos del capítulo 90)',71,7102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710231,'Diamantes não industriais, em bruto ou serrados, clivados ou desbastados','Non-industrial diamonds unworked or simply sawn, cleaved or bruted (excl. industrial diamonds)','Diamantes, en bruto o simplemente aserrados, exfoliados o desbastados (exc. diamantes industriales)',71,7102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710239,'Outros diamantes não industriais, não montados, nem engastados','Diamonds, worked, but not mounted or set (excl. industrial diamonds)','Diamantes, trabajados, sin montar ni engarzar (exc. diamantes industriales)',71,7102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710310,'Pedras preciosas ou semipreciosas, em bruto ou simplesmente serradas ou desbastadas','Precious stones and semi-precious stones, unworked or simply sawn or roughly shaped, whether or not graded (excl. diamonds and imitation precious stones and semi-precious stones)','Piedras preciosas o semipreciosas, naturales, en bruto o simplemente aserradas o desbastadas, incl. clasificadas (exc. diamantes e imitaciones de piedras preciosas o semipreciosas)',71,7103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710391,'Rubis, safiras e esmeraldas, trabalhadas de outro modo','Rubies, sapphires and emeralds, worked, whether or not graded, but not strung, mounted or set, rubies, sapphires and emeralds, worked, ungraded, temporarily strung for convenience of transport (excl. rubies, sapphires and emeralds, simply sawn or roughly ','Rubíes, zafiros y esmeraldas, trabajados, incl. clasificados, pero sin ensartar, montar ni engarzar; rubíes, zafiros y esmeraldas, sin clasificar, ensartados temporalmente para facilitar el transporte (exc. simplemente aserrados o desbastados, así como im',71,7103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710399,'Outras pedras preciosas ou semipreciosas, trabalhadas de outro modo','Precious and semi-precious stones, worked, whether or not graded, but not strung, mounted or set, precious and semi-precious stones, worked, ungraded, temporarily strung for convenience of transport (excl. precious and semi-precious stones, simply sawn or','Piedras preciosas o semipreciosas "naturales", trabajadas, incl. clasificadas, pero sin ensartar, montar ni engarzar; piedras preciosas y semipreciosas "naturales", trabajadas, sin clasificar, enfiladas temporalmente para facilitar el transporte (exc. sim',71,7103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710410,'Quartzo piezo elétrico','Quartz, piezoelectric, of synthetic or reconstructed stone whether or not worked or graded, but not mounted or set','Cuarzo piezoeléctrico, de piedras sintéticas o reconstituidas, incl. trabajado o clasificado, pero sin montar o engarzar',71,7104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710420,'Outras pedras sintéticas ou reconstituídas, em bruto ou simplesmente serradas ou desbastadas','Precious and semi-precious stones, synthetic or reconstructed, unworked or simply sawn or roughly shaped, whether or not graded (excl. piezoelectric quartz)','Piedras preciosas o semipreciosas, sintéticas o reconstituidas, en bruto o simplemente aserradas o desbastadas, incl. clasificadas (exc. cuarzo piezoeléctrico)',71,7104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710490,'Outras pedras sintéticas ou reconstituídas, mesmo trabalhadas ou combinadas, mas não enfiadas, nem montadas nem engastadas','Precious and semi-precious stones, synthetic or reconstructed, worked, whether or not graded but not strung, mounted or set, ungraded synthetic or reconstructed precious or semi-precious stones, temporarily strung for convenience of transport (excl. stone','Piedras preciosas o semipreciosas, sintéticas o reconstituidas, trabajadas, incl. clasificadas, pero sin ensartar, montar ni engarzar; piedras preciosas o semipreciosas, sintéticas o reconstituidas, trabajadas, sin clasificar, ensartadas temporalmente par',71,7104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710510,'Pó de diamantes','Dust and powder of diamonds, including synthetic diamonds','Polvo de diamante, incluso de diamante sintético',71,7105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710590,'Outros pós de pedras preciosas, semipreciosas ou sintéticas','Dust and powder of natural or synthetic precious or semi-precious stones (excl. dust and powder of diamonds)','Polvo de piedras preciosas, semipreciosas "naturales" o sintéticas (exc. de diamante)',71,7105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710610,'Pó de prata','Powder of silver, incl. silver plated with gold or platinum','Plata, incl. la plata dorada y la platinada, en polvo',71,7106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710691,'Prata em formas brutas','Silver, incl. silver plated with gold or platinum, unwrought (excl. silver in powder form)','Plata, incl. la plata dorada y la platinada, en bruto (exc. en polvo)',71,7106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710692,'Prata em outras formas semimanufaturadas','Silver, incl. silver plated with gold or platinum, semi-manufactured','Plata, incl. la plata dorada y la platinada, semilabrada',71,7106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710700,'Metais comuns folheados ou chapeados de prata, em formas brutas ou semimanufaturadas','Base metals clad with silver, not further worked than semi-manufactured','Chapado "plaqué" de plata sobre metal común, en bruto o semilabrado',71,7107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710811,'Pó de ouro (incluído o ouro platinado), para usos não monetários','Gold, incl. gold plated with platinum, for non-monetary purposes','Oro, incl. el oro platinado, en polvo, para uso no monetario',71,7108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710812,'Ouro (incluído o ouro platinado) em outras formas brutas, para usos não monetários','Gold, incl. gold plated with platinum, unwrought, for non-monetary purposes (excl. gold in powder form)','Oro, incl. el oro platinado, en bruto, para uso no monetario (exc. en polvo)',71,7108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710813,'Ouro (incluído o ouro platinado) em outras formas semimanufaturadas, para usos não monetários','Gold, incl. gold plated with platinum, in semi-manufactured forms, for non-monetary purposes','Oro, incl. el oro platinado, semilabrado, para uso no monetario',71,7108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710820,'Ouro (incluído o ouro platinado) em formas brutas ou semimanufaturadas, para uso monetário','Monetary gold','Oro para uso monetario',71,7108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (710900,'Metais comuns ou prata, folheados ou chapeados de ouro, em formas brutas ou semimanufaturadas','Base metals or silver, clad with gold, not further worked than semi-manufactured','Chapado "plaqué" de oro sobre metal común o sobre plata, en bruto o semilabrado',71,7109);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711011,'Platina em formas brutas ou em pó','Platinum, unwrought or in powder form','Platino, en bruto o en polvo',71,7110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711019,'Platina em outras formas semimanufaturadas','Platinum, in semi-manufactured forms','Platino, semilabrado',71,7110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711021,'Paládio em formas brutas ou em pó','Palladium, unwrought or in powder form','Paladio, en bruto o en polvo',71,7110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711029,'Paládio em formas semimanufaturadas','Palladium in semi-manufactured forms','Paladio, semilabrado',71,7110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711031,'Ródio em formas brutas ou em pó','Rhodium, unwrought or in powder form','Rodio, en bruto o en polvo',71,7110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711039,'Ródio em formas semimanufaturadas','Rhodium in semi-manufactured forms','Rodio, semilabrado',71,7110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711041,'Irídio, ósmio e rutênio, em formas brutas ou em pó','Iridium, osmium and ruthenium, unwrought or in powder form','Iridio, osmio y rutenio, en bruto o en polvo',71,7110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711049,'Irídio, ósmio e rutênio, em formas semimanufaturadas','Iridium, osmium and ruthenium, in semi-manufactured forms','Iridio, osmio y rutenio, semilabrados',71,7110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711100,'Metais comuns, prata ou ouro, folheados ou chapeados de platina, em formas brutas ou semimanufaturadas','Base metals, silver or gold, clad with platinum, not further worked than semi-manufactured','Chapado "plaqué" de platino sobre metal común, plata u oro, en bruto o semilabrado',71,7111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711210,'desperds/resid.de ouro/metais folheado/chapeado de ouro','waste and scrap of gold/metal clad/plated of gold','desperds/desec.de oro/chapado de metal/chapado de oro',71,7112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711220,'desperds/resid.de platina/metais folhd/chapd.de platina','waste/scrap of platinum/metal clad/plated of platinum','desperds/desec.de platino/chapado de metal y de platino',71,7112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711230,'Cinzas contendo metais preciosos ou compostos de metais preciosos','Ash containing precious metal or precious-metal compounds','Cenizas que contengan metal precioso o compuestos de metal precioso',71,7112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711290,'desperds/resid.de outs.met.prec/met.folh/chap.met.prec.','waste/scrap of oth.prec.met, /metal clad/plat.prec.metal','despers/desec.de ots.met.prec/de met./chap.de met.prec.',71,7112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711291,'Resíduos e desperdícios de ouro ou de metais folheados ou chapeados de ouro','Waste and scrap of gold, incl. metal clad with gold, and other waste and scrap containing gold or gold compounds, of a kind used principally for the recovery of precious metal (excl. ash containing gold or gold compounds, waste and scrap of gold melted do','Desperdicios y desechos, de oro o de chapado "plaqué" de oro, así como los demás desperdicios y desechos de oro o de compuestos de oro de los tipos utilizados principalmente para la recuperación del metal precioso (exc. cenizas que contengan oro o compues',71,7112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711292,'Resíduos e desperdícios de platina ou de metais folheados ou chapeados de platina','Waste and scrap of platinum, incl. metal clad with platinum, and other waste and scrap containing platinum or platinum compounds, of a kind used principally for the recovery of precious metal (excl. ash containing platinum or platinum compounds, waste and','Desperdicios y desechos, de platino o de chapado "plaqué" de platino, así como los demás desperdicios y desechos de platino o de compuestos de platino de los tipos utilizados principalmente para la recuperación del metal precioso (exc. cenizas que conteng',71,7112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711299,'Resíduos e desperdícios de prata ou de metais folheados ou chapeados de prata','Waste and scrap of silver, incl. metal clad with silver, and other waste and scrap containing silver or silver compounds, of a kind used principally for the recovery of precious metal (excl. ash, and waste and scrap of precious metals melted down into unw','Desperdicios y desechos, de plata o de chapado "plaqué" de plata, así como los demás desperdicios y desechos que contengan plata o compuestos de plata de los tipos utilizados principalmente para la recuperación del metal precioso (exc. cenizas que conteng',71,7112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711311,'Artefatos de joalharia, de prata, mesmo revestida, folheada ou chapeada de metais preciosos - jóias','Articles of jewellery and parts thereof, of silver, whether or not plated or clad with other precious metal (excl. articles > 100 years old)','Artículos de joyería y sus partes, de plata, incl. revestida o chapada de metal precioso "plaqué" (exc. con más de 100 años)',71,7113);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711319,'Artefatos de joalharia, de outros metais preciosos, mesmo revestidos, folheados ou chapeados de metais preciosos - jóias','Articles of jewellery and parts thereof, of precious metal other than silver, whether or not plated or clad with precious metal (excl. articles > 100 years old)','Artículos de joyería y sus partes, de metales preciosos distintos de la plata, incl. revestidos o chapado de metal precioso "plaqué" (exc. con más de 100 años)',71,7113);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711320,'Artefatos de joalharia, de metais comuns folheados ou chapeados de metais preciosos - jóias','Articles of jewellery and parts thereof, of base metal clad with precious metal (excl. articles > 100 years old)','Artículos de joyería y sus partes, de chapado de metal precioso "plaqué" sobre metal común (exc. con más de 100 años)',71,7113);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711411,'Artefatos de ourivesaria e suas partes, de prata, mesmo revestida, folheada ou chapeada de outros metais preciosos - jóias','Articles of goldsmiths'' or silversmiths'' wares or parts thereof, of silver, whether or not plated or clad with other precious metal (excl. jewellery, watch-and clockmakers'' wares, musical instruments, weapons, perfume atomizers and heads for these, ori','Artículos de orfebrería y sus partes, de plata, incl. revestidos o chapado de metal precioso "plaqué" (exc. artículos de joyería, artículos de relojería, instrumentos de música, armas, pulverizadores de tocador y sus cabezas, obras orginales de estatuaria',71,7114);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711419,'Artefatos de ourivesaria e suas partes, de outros metais preciosos, mesmo revestidos, folheados ou chapeados de metais preciosos - jóias','Articles of goldsmiths'' or silversmiths'' wares or parts thereof, of precious metal other than silver, whether or not plated or clad with precious metal (excl. jewellery, watch- and clockmakers'' wares, musical instruments, weapons, perfume atomizers and','Artículos de orfebrería y sus partes, de metales preciosos distintos de la plata, incl. revestidos o chapado de metal precioso "plaqué" (exc. artículos de joyería, artículos de relojería, instrumentos de música, armas, pulverizadores de tocador y sus cabe',71,7114);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711420,'Artefatos de ourivesaria e suas partes, de metais comuns folheados ou chapeados de metais preciosos - jóias','Articles of goldsmiths'' or silversmiths'' wares and parts thereof, of base metal clad with precious metal (excl. jewellery, watch-and clockmakers'' wares, musical instruments, weapons, perfume atomizers and heads for these, original sculptures or statuar','Artículos de orfebrería y sus partes, de chapado de metal precioso "plaqué" sobre metal común (exc. artículos de joyería, artículos de relojería, instrumentos de música, armas, pulverizadores de tocador y sus cabezas, obras orginales de estatuaria o de es',71,7114);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711510,'Telas ou grades catalisadoras, de platina','Catalysts in the form of wire cloth or grill, of platinum','Catalizadores de platino en forma de tela o enrejado',71,7115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711590,'Outras obras de metais preciosos ou de metais folheados ou chapeados de metais preciosos','Articles of precious metal or of metal clad with precious metal, n.e.s.','Manufacturas de metal precioso o chapado de metal precioso "plaqué", n.c.o.p.',71,7115);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711610,'Obras de pérolas naturais ou cultivadas','Articles of natural or cultured pearls, n.e.s.','Manufacturas de perlas finas "naturales" o cultivadas, n.c.o.p.',71,7116);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711620,'Outras obras de pedras preciosas ou semipreciosas, ou de pedras sintéticas ou reconstituídas','Articles of precious or semi-precious stones natural, synthetic or reconstructed, n.e.s.','Manufacturas de piedras preciosas o semipreciosas "naturales, sintéticas o reconstituidas", n.c.o.p.',71,7116);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711711,'Abotoaduras (botões de punho) e outros botões, de metais comuns, mesmo prateados, dourados ou platinados','Cuff links and studs, of base metal, whether or not clad with silver, gold or platinum','Gemelos y pasadores simil., de metal común, incl. plateados, dorados o platinados',71,7117);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711719,'Outras bijuterias de metais comuns','Imitation jewellery, of base metal, whether or not plated with precious metal (excl. cuff links and studs)','Bisutería, de metal común, incl. plateado, dorado o platinado (exc. gemelos y pasadores simil.)',71,7117);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711790,'Outras bijuterias','Imitation jewellery (excl. jewellery, of base metal, whether or not clad with silver, gold or platinum)','Bisutería (exc. de metal común, incl. plateado, dorado o platinado)',71,7117);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711810,'Moedas sem curso legal, exceto de ouro','Coin (excl. legal tender, gold coins, medals, jewellery made from coins, collectors'' items of numismatic value, waste and scrap)','Monedas (exc. de curso legal, monedas de oro, condecoraciones, artículos de joyería hechos con monedas, objetos de colección con valor numismático, desperdicios y residuos)',71,7118);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (711890,'Outras moedas','Coin of legal tender','Monedas de oro; monedas de curso legal (exc. condecoraciones, artículos de joyería hechos con monedas, objetos de colección con valor numismático, desperdicios y residuos)',71,7118);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720110,'Ferro fundido bruto não ligado, contendo, em peso <= 0,5% de fósforo','Non-alloy pig iron in pigs, blocks or other primary forms, containing, by weight, <= 0,5% of phosphorous','Fundición en bruto, en lingotes, bloques o demás formas primarias, sin alear, con un contenido de fósforo <= 0,5% en peso [CECA]',72,7201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720120,'Ferro fundido bruto não ligado, contendo, em peso > 0,5% de fósforo','Non-alloy pig iron in pigs, blocks or other primary forms, containing by weight >= 0,5% phosphorus','Fundición en bruto, en lingotes, bloques o demás formas primarias, sin alear, con un contenido de fósforo > 0,5% en peso [CECA]',72,7201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720150,'Ligas de ferro fundido bruto, ferro spiegel (especular)','Alloy pig iron and spiegeleisen, in pigs, blocks or other primary forms','Fundición en bruto aleada y fundición especular, en lingotes, bloques o demás formas primarias [CECA]',72,7201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720211,'Ferromanganês, contendo, em peso > 2% de carbono','Ferro-manganese, containing by weight > 2% of carbon','Ferromanganeso, con un contenido de carbono > 2% en peso [CECA]',72,7202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720219,'Outras ligas de ferromanganês','Ferro-manganese, containing by weight <= 2% carbon','Ferromanganeso, con un contenido de carbono <= 2% en peso',72,7202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720221,'Ferrossilício, contendo em peso > 55% de silício','Ferro-silicon, containing by weight > 55% of silicon','Ferrosilicio, con un contenido de silicio > 55% en peso',72,7202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720229,'Outras ligas de ferrossilício','Ferro-silicon, containing by weight <= 55% silicon','Ferrosilicio, con un contenido de silicio <= 55% en peso',72,7202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720230,'Ferrossilício-manganês','Ferro-silico-manganese','Ferro-sílico-manganeso',72,7202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720241,'Ferrocromo, contendo, em peso > 4% de carbono','Ferro-chromium, containing by weight > 4% of carbon','Ferrocromo, con un contenido de carbono > 4% en peso',72,7202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720249,'Outras ligas de ferrocromo','Ferro-chromium, containing by weight <= 4% of carbon','Ferrocromo, con un contenido de carbono <= 4% en peso',72,7202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720250,'Ferrossilício-cromo','Ferro-silico-chromium','Ferro-sílico-cromo',72,7202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720260,'Ferroníquel','Ferro-nickel','Ferroníquel',72,7202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720270,'Ferromolibdênio','Ferro-molybdenum','Ferromolibdeno',72,7202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720280,'Ferrotungstênio e ferrossilício-tungstênio','Ferro-tungsten and ferro-silico-tungsten','Ferrovolframio "tungsteno" y ferro-sílico-volframio "tungsteno"',72,7202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720291,'Ferrotitânio e ferrossilício-titânio','Ferro-titanium and ferro-silico-titanium','Ferrotitanio y ferro-sílico-titanio',72,7202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720292,'Ferrovanádio','Ferro-vanadium','Ferrovanadio',72,7202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720293,'Ferronióbio','Ferro-niobium','Ferroniobio',72,7202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720299,'Outros ferroligas','Ferro-alloys (excl. ferro-manganese, ferro-silicon, ferro-silico-manganese, ferro-chromium, ferro-silico-chromium, ferro-nickel, ferro-molybdenum, ferro-tungsten, ferro-silico-tungsten, ferro-titanium, ferro-silico-titanium, ferro-vanadium and ferro-niobi','Ferroaleaciones (exc. ferromanganeso, ferrosilicio, ferro-sílico- manganeso, ferrocromo, ferro-sílico-cormo, ferroníquel, ferromolibdeno, ferrovolframio "tungsteno", ferro-sílico-volframio "tungsteno", ferrotitanio, ferro-sílico-titanio, ferrovanadio y fe',72,7202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720310,'Produtos ferrosos obtidos por redução direta dos minérios de ferro','Ferrous products obtained by direct reduction of iron ore, in lumps, pellets or similar forms','Productos férreos obtenidos por reducción directa de minerales de hierro, en trozos, "pellets" o formas simil. [CECA]',72,7203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720390,'Outros produtos ferrosos esponjosos, em pedaços, esferas ou formas semelhantes; ferro de pureza mínima, em peso, de 99,94%, em pedaços, esferas ou formas semelhantes ','Spongy ferrous products, obtained from molten pig iron by atomisation, iron of a purity of >= 99,94%, in lumps, pellets or similar forms','Productos férreos esponjosos, obtenidos por atomización de fundición en bruto, y hierro con una pureza >= 99,94% en peso, en trozos, "pellets" o formas simil. [CECA]',72,7203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720410,'Desperdícios e resíduos de ferro fundido','Waste and scrap, of cast iron (excl. radioactive)','Desperdicios y desechos "chatarra", de fundición [CECA] (exc. radiactivos)',72,7204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720421,'Desperdícios e resíduos de aços inoxidáveis','Waste and scrap of stainless steel (excl. radioactive, and waste and scrap of batteries and electric accumulators)','Desperdicios y desechos "chatarra", de acero inoxidable [CECA] (exc. radiactivos, así como desperdicios y desechos de pilas, de baterías de pilas y de acumuladores eléctricos)',72,7204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720429,'Desperdícios e resíduos de outras ligas de aços','Waste and scrap of alloy steel (excl. stainless steel, and waste and scrap, radioactive, or waste and scrap from batteries and electric accumulators)','Desperdicios y desechos "chatarra", de aceros aleados [CECA] (exc. de acero inoxidable, así como desperdicios y desechos radiactivos y desperdicios y desechos de pilas, de baterías de pilas y de acumuladores eléctricos)',72,7204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720430,'Desperdícios e resíduos de ferro ou aço estanhados','Waste and scrap of tinned iron or steel (excl. radioactive, and waste and scrap of batteries and electric accumulators)','Desperdicios y desechos "chatarra", de hierro o acero estañados [CECA] (exc. radiactivos, así como desperdicios y desechos de pilas, de baterías de pilas y de acumuladores eléctricos)',72,7204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720441,'Resíduos do torno e da fresa, aparas, lascas, limalhas e desperdícios da estampagem ou do corte, de ferro ou aço','Turnings, shavings, chips, milling waste, sawdust, filings, trimmings and stampings of iron or steel, whether or not in bundles (excl. those of cast iron, alloy steel or tinned iron or steel)','Torneaduras, virutas "esquirlas", esquirlas, limaduras "de amolado, aserrado, limado" y recortes de estampado o de corte, incl. en paquetes [CECA] (exc. de fundición, de aceros aleados o de hierro o acero estañados)',72,7204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720449,'Outros desperdícios e resíduos de ferro ou aço','Waste and scrap of iron or steel (excl. slag, scale and other waste of the production of iron and steel; radioactive waste and scrap; fragments of pigs, blocks or other primary forms of pig iron or spiegeleisen; waste and scrap of cast iron, alloy steel o','Desperdicios y desechos "chatarra", de hierro o acero [CECA] (exc. escorias, batiduras y otros desperdicios de la fabricación de fundición; desperdicios y desechos radiactivos; trozos procedentes de la rotura de tochos, galápagos o demás formas primarias ',72,7204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720450,'Desperdícios de ferro ou aço, em lingotes','Remelting scrap ingots of iron or steel (excl. products whose chemical composition conforms to the definitions of pig iron, spiegeleisen, or ferro-alloys)','Lingotes de chatarra de hierro o acero (exc. productos cuya composición química responda a la definición de fundición en bruto, de fundición especular o de ferroaleación)',72,7204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720510,'Granalhas de ferro fundido bruto, spiegel, ferro ou aço','Granules, of pig iron, spiegeleisen, iron or steel (excl. granules of ferro-alloys, turnings and filings of iron or steel, certain small calibre items, defective balls for ball-bearings)','Granallas, de fundición en bruto, de fundición especular, de hierro o acero (exc. granallas de ferroaleaciones, torneaduras o limaduras de hierro o acero, así como determinadas bolas defectuosas y de pequeño calibre para rodamientos de bolas)',72,7205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720521,'Pós de ligas de aços','Powders, of alloy steel (excl. powders of ferro-alloys and radioactive iron powders isotopes)','Polvo, de aceros aleados (exc. polvo de ferroaleaciones y polvo de hierro radiactivo "isótopo")',72,7205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720529,'Outros pós de ferro fundido bruto, spiegel, de ferro ou aço','Powders, of pig iron, spiegeleisen, iron or non-alloy steel (excl. powders of ferro-alloys and radioactive iron powders isotopes)','Polvo, de fundición en bruto, de fundición especular, de hierro o acero sin alear (exc. polvo de ferroaleaciones y polvo de hierro radiactivo "isótopo")',72,7205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720610,'Ferro e aços não ligados, em lingotes','Ingots, of iron and non-alloy steel (excl. remelted scrap ingots, continuous cast products, iron of heading 7203)','Hierro y acero sin alear, en lingotes [CECA] (exc. lingotes de chatarra, productos obtenidos por colada continua, así como el hierro de la partida 7203)',72,7206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720690,'Ferro e aços não ligados, em outras formas primárias','Iron and non-alloy steel, in puddled bars or other primary forms (excl. ingots, remelted scrap ingots, continuous cast products, iron of heading 7203)','Hierro y acero sin alear, en otras formas primarias [CECA] (exc. lingotes, lingotes de chatarra, productos obtenidos por colada continua, así como el hierro de la partida 7203)',72,7206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720711,'Produtos semimanufaturados, de ferro ou aços, não ligados, contendo em peso < 0,25% de carbono, de seção transversal quadrada ou retangular e largura < 2 vezes a espessura - siderúrgicos','Semi-finished products of iron or non-alloy steel containing, by weight, < 0,25% of carbon, of square or rectangular cross-section, the width measuring < twice the thickness','Productos intermedios de hierro o acero sin alear, con un contenido de carbono < 0,25% en peso, de sección transversal cuadrada o rectangular, cuya anchura sea inferior al doble del espesor',72,7207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720712,'Outros produtos semimanufaturados, de ferro ou aços, não ligados, contendo em peso < 0,25% de carbono, de seção transversal retangular - siderúrgicos','Semi-finished products of iron or non-alloy steel containing, by weight, < 0,25% of carbon, of rectangular other than square cross-section, the width measuring >= twice the thickness','Productos intermedios de hierro o acero sin alear, con un contenido de carbono < 0,25% en peso, de sección transversal rectangular, cuya anchura sea superior o igual al doble del espesor',72,7207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720719,'Outros produtos semimanufaturados, de ferro ou aços, não ligados, contendo, em peso, < 0,25% de carbono - siderúrgicos','Semi-finished products of iron or non-alloy steel containing, by weight, < 0,25% of carbon, of circular cross-section, or of a cross-section other than square or rectangular','Productos intermedios de hierro o acero sin alear, con un contenido de carbono < 0,25% en peso, de sección transversal circular o poligonal',72,7207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720720,'Outros produtos semimanufaturados, de ferro ou aços, não ligados, contendo em peso => 0,25% de carbono - siderúrgicos','Semi-finished products of iron or non-alloy steel containing, by weight, >= 0,25% of carbon','Productos intermedios de hierro o acero sin alear, con un contenido de carbono >= 0,25% en peso',72,7207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720810,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, em rolos, laminados a quente, com motivos em relevo, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coils, simply hot-rolled, not clad, plated or coated, with patterns in relief directly due to the rolling process','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, enrollados, simplemente laminados en caliente, sin chapar ni revestir, con motivos en relieve obtenidos directamente durante el laminado [CECA]',72,7208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720825,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, em rolos, laminados a quente, decapados, de espessura => 4,75 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coils, simply hot-rolled, not clad, plated or coated, of a thickness of >= 4,75 mm, pickled, without patterns in relief','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, enrollados, simplemente laminados en caliente, sin chapar ni revestir, sin motivos en relieve, de espesor >= 4,75 mm, decapados [CECA]',72,7208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720826,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, em rolos, laminados a quente, decapados, de espessura => 3 mm e < 4,75 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coils, simply hot-rolled, not clad, plated or coated, of a thickness of >= 3 mm but < 4,75 mm, pickled, without patterns in relief','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, enrollados, simplemente laminados en caliente, sin chapar ni revestir, sin motivos en relieve, de espesor >= 3 mm pero < 4,75 mm, decapados [CECA]',72,7208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720827,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, em rolos, laminados a quente, decapados, de espessura < 3 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coils, simply hot-rolled, not clad, plated or coated, of a thickness of < 3 mm, pickled, without patterns in relief','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, enrollados, simplemente laminados en caliente, sin chapar ni revestir, sin motivos en relieve, de espesor < 3 mm, decapados [CECA]',72,7208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720836,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, em rolos, laminados a quente, de espessura > 10 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coils, simply hot-rolled, not clad, plated or coated, of a thickness of >= 10 mm, not pickled, without patterns in relief','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, enrollados, simplemente laminados en caliente, sin chapar ni revestir, sin motivos en relieve y sin decapar, de espesor > 10 mm [CECA]',72,7208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720837,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, em rolos, laminados a quente, de espessura => 4,75 mm e <= 10 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coils, simply hot-rolled, not clad, plated or coated, of a thickness of >= 4,75 mm but < 10 mm, not pickled, without patterns in relief','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, enrollados, simplemente laminados en caliente, sin chapar ni revestir, sin motivos en relieve y sin decapar, de espesor >= 4,75 mm pero <= 10 mm [CECA]',72,7208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720838,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, em rolos, laminados a quente, de espessura => 3 mm e < 4,75 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coils, simply hot-rolled, not clad, plated or coated, of a thickness of >= 3 mm but < 4,75 mm, not pickled, without patterns in relief','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, enrollados, simplemente laminados en caliente, sin chapar ni revestir, sin motivos en relieve y sin decapar, de espesor >= 3 mm pero < 4,75 mm [CECA]',72,7208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720839,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, em rolos, laminados a quente, de espessura < 3 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coils, simply hot-rolled, not clad, plated or coated, of a thickness of < 3 mm, not pickled, without patterns in relief','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, enrollados, simplemente laminados en caliente, sin chapar ni revestir, sin motivos en relieve y sin decapar, de espesor < 3 mm [CECA]',72,7208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720840,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, não enrolados, laminados a quente, motivos em relevo, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in coils, simply hot-rolled, not clad, plated or coated, with patterns in relief directly due to the rolling process','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, sin enrollar, simplemente laminados en caliente, sin chapar ni revestir, con motivos en relieve obtenidos durante el laminado [CECA]',72,7208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720851,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, não enrolados, laminados a quente, de espessura > 10 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width >= 600 mm, not in coils, simply hot-rolled, not clad, plated or coated, of a thickness of > 10 mm, without patterns in relief','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, sin enrollar, simplemente laminados en caliente, sin chapar ni revestir, de espesor > 10 mm, sin motivos en relieve [CECA]',72,7208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720852,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, não enrolados, laminados a quente, de espessura => 4,75 mm e <= 10 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in coils, simply hot-rolled, not clad, plated or coated, of a thickness of >= 4,75 mm but <= 10 mm, without patterns in relief','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, sin enrollar, simplemente laminados en caliente, sin chapar ni revestir, de espesor >= 4,75 mm pero <= 10 mm, sin motivos en relieve [CECA]',72,7208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720853,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, não enrolados, laminados a quente, de espessura => 3 mm e < 4,75 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in coils, simply hot-rolled, not clad, plated or coated, of a thickness of >= 3 mm but < 4,75 mm, without patterns in relief','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, no enrollados, simplemente laminados en caliente, sin chapar ni revestir, sin motivos en relieve, de espesor >= 3 mm pero < 4,75 mm [CECA]',72,7208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720854,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, não enrolados, laminados a quente, de espessura < 3 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in coils, simply hot-rolled, not clad, plated or coated, of a thickness of < 3 mm, without patterns in relief','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, sin enrollar, simplemente laminados en caliente, sin chapar ni revestir, de espesor < 3 mm, sin motivos en relieve [CECA]',72,7208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720890,'Outros produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, laminados a quente, não folheados ou chapeados, nem revestidos - siderúrgicos','Flat-rolled products of iron or steel, of a width >= 600 mm, hot-rolled and further worked, but not clad, plated or coated','Productos planos de hierro o acero, de anchura >= 600 mm, laminados en caliente y trabajados, sin chapar ni revestir',72,7208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720915,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, em rolos, laminados a frio, de espessura => 3 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coils, simply cold-rolled cold-reduced, not clad, plated or coated, of a thickness of >= 3 mm','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, enrollados, simplemente laminados en frío, sin chapar ni revestir, de espesor >= 3 mm [CECA]',72,7209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720916,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, em rolos, laminados a frio, de espessura > 1 mm e < 3 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coils, simply cold-rolled cold-reduced, not clad, plated or coated, of a thickness of > 1 mm but < 3 mm','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, enrollados, simplemente laminados en frío, sin chapar ni revestir, de espesor > 1 mm pero < 3 mm [CECA]',72,7209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720917,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, em rolos, laminados a frio, de espessura => 0,5 mm e <= 1 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coils, simply cold-rolled cold-reduced, not clad, plated or coated, of a thickness of >= 0,5 mm but <= 1 mm','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, enrollados, simplemente laminados en frío, sin chapar ni revestir, de espesor >= 0,5 mm pero <= 1 mm [CECA]',72,7209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720918,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, em rolos, laminados a frio, de espessura < 0,5 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, in coils, simply cold-rolled cold-reduced, not clad, plated or coated, of a thickness of < 0,5 mm','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, enrollados, simplemente laminados en frío, sin chapar ni revestir, de espesor < 0,5 mm [CECA]',72,7209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720925,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, não enrolados, laminados a frio, de espessura => 3 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in coils, simply cold-rolled cold-reduced, not clad, plated or coated, of a thickness of >= 3 mm','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, sin enrollar, simplemente laminados en frío, sin chapar ni revestir, de espesor >= 3 mm [CECA]',72,7209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720926,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, não enrolados, laminados a frio, de espessura > 1 mm e < 3 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in coils, simply cold-rolled cold-reduced, not clad, plated or coated, of a thickness of > 1 mm but < 3 mm','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, sin enrollar, simplemente laminados en frío, sin chapar ni revestir, de espesor > 1 mm pero < 3 mm [CECA]',72,7209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720927,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, não enrolados, laminados a frio, de espessura => 0,5 mm e <= 1 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in coils, simply cold-rolled cold-reduced, not clad, plated or coated, of a thickness of >= 0,5 mm but <= 1 mm','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, sin enrollar, simplemente laminados en frío, sin chapar ni revestir, de espesor >= 0,5 mm pero <= 1 mm [CECA]',72,7209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720928,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, não enrolados, laminados a frio, de espessura < 0,5 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, not in coils, simply cold-rolled cold-reduced, not clad, plated or coated, of a thickness of < 0,5 mm','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, sin enrollar, simplemente laminados en frío, sin chapar ni revestir, de espesor < 0,5 mm [CECA]',72,7209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (720990,'Outros produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, laminados a frio, não folheados ou chapeados, nem revestidos - siderúrgicos','Flat-rolled products of iron or steel, of a width of >= 600 mm, cold-rolled cold-reduced, and further worked, but not clad, plated or coated','Productos planos de hierro o acero, de anchura >= 600 mm, laminados en frío y trabajados, sin chapar ni revestir',72,7209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721011,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, estanhados, de espessura => 0,5 mm - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-rolled or cold-rolled cold-reduced, tinned, of a thickness of >= 0,5 mm','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, laminados en frío o en caliente, estañados, de espesor >= 0,5 mm',72,7210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721012,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, estanhados, de espessura < 0,5 mm - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-rolled or cold-rolled cold-reduced, tinned, of a thickness of < 0,5 mm','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, laminados en frío o en caliente, estañados, de espesor < 0,5 mm',72,7210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721020,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, revestidos de chumbo, incluídos os revestidos de chumbo-estanho - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-rolled or cold-rolled cold-reduced, plated or coated with lead, incl. terne-plate','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, laminados en frío o en caliente, emplomados, incl. los revestidos con una aleación de plomo y estaño',72,7210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721030,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, galvanizados eletroliticamente - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-rolled or cold-rolled cold-reduced, electrolytically plated or coated with zinc','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, laminados en frío o en caliente, cincados electrolíticamente',72,7210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721041,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, galvanizados por outro processo, ondulados - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-rolled or cold-rolled cold-reduced, corrugated, tinned (excl. electrolytically plated or coated with zinc)','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, laminados en frío o en caliente, ondulados, cincados (exc. cincados electrolíticamente)',72,7210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721049,'Outros produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, galvanizados por outro processo - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-rolled or cold-rolled cold-reduced, not corrugated, tinned (excl. electrolytically plated or coated with zinc)','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, laminados en frío o en caliente, sin ondular, cincados (exc. cincados electrolíticamente)',72,7210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721050,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, revestidos de óxido de cromo ou de cromo e óxido de cromo - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-rolled or cold-rolled cold-reduced, plated or coated with chromium oxides or with chromium and chromium oxides','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, laminados en frío o en caliente, revestidos de óxidos de cromo o de cromo y óxidos de cromo',72,7210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721061,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, revestidos de ligas de alumínio-zinco - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-rolled or cold-rolled cold-reduced, plated or coated with aluminium-zinc alloys','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, laminados en frío o en caliente, revestidos de aleaciones de aluminio y cinc',72,7210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721069,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, revestidos de alumínio - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-rolled or cold-rolled cold-reduced, plated or coated with aluminium (excl. products plated or coated with aluminium-zinc alloys)','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, laminados en frío o en caliente, revestidos de aluminio (exc. revestidos de aleaciones de aluminio y cinc)',72,7210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721070,'Produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, pintados, envernizados ou revestidos de plásticos - siderúrgicos','Flat products of iron or non-alloy steel, of a width of >= 600 mm, hot-rolled or cold-rolled cold-reduced, painted, varnished or coated with plastics','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, laminados en frío o en caliente, pintados, barnizados o revestidos de plástico',72,7210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721090,'Outros produtos laminados planos, de ferro ou aços não ligados, de largura => 600 mm, folheados ou chapeados ou revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of >= 600 mm, hot-rolled or cold-rolled cold-reduced, clad, plated or coated (excl. tinned, plated or coated with lead, zinc, chromium oxides, chromium and chromium oxides, or aluminium, painted,','Productos planos de hierro o acero sin alear, de anchura >= 600 mm, laminados en frío o en caliente, chapados o revestidos (exc. estañados, emplomados, cincados, revestidos de óxidos de cromo, de cromo y óxidos de cromo o de aluminio, pintados, barnizados',72,7210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721113,'Produtos laminados planos, de ferro ou aços não ligados, de largura > 150 mm e < 600 mm, de espessura => 4 mm, laminados a quente nas quatro faces, não enrolados, sem motivos em relevo - siderúrgicos','Flat-rolled products of iron or non-alloy steel, simply hot-rolled on four faces or in a closed box pass, not clad, plated or coated, of a width of > 150 mm but < 600 mm and a thickness of >= 4 mm, not in coils, without patterns in relief, commonly known ','Productos planos anchos, también llam. "planos universales", de hierro o acero sin alear, simplemente laminados en caliente en las cuatro caras o en acanaladuras cerradas, sin chapar ni revestir, de anchura > 150 mm pero < 600 mm y espesor >= 4 mm, sin en',72,7211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721114,'Outros produtos laminados planos, de ferro ou aços não ligados, de largura < 600 mm, laminados a quente, de espessura => 4,75 mm, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width < 600 mm, not further worked than hot-rolled, not clad, plated or coated, of a thickness of >= 4,75 mm (excl. wide flats)','Productos planos de hierro o acero sin alear, de anchura < 600 mm, simplemente laminados en caliente, sin chapar ni revestir, de espesor >= 4,75 mm [CECA] (exc. los planos anchos, también llam. "planos universales", de acero)',72,7211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721119,'Outros produtos laminados planos, de ferro ou aços não ligados, de largura < 600 mm, laminados a quente, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width < 600 mm, simply hot-rolled, not clad, plated or coated, of a thickness < 4,75 mm (excl. wide flats)','Productos planos de hierro o acero sin alear, de anchura < 600 mm, simplemente laminados en caliente, sin chapar ni revestir, de espesor < 4,75 mm [CECA] (exc. los planos anchos, también llam. "planos universales", de acero)',72,7211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721123,'Produtos laminados planos, de ferro ou aços não ligados, de largura < 600 mm, laminados a frio, contendo em peso < 0,25% de carbono, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, simply cold-rolled cold-reduced, not clad, plated or coated, containing by weight < 0,25% of carbon','Productos planos de hierro o acero sin alear, de anchura < 600 mm, simplemente laminados en frío, sin chapar ni revestir, con un contenido de carbono < 0,25% en peso',72,7211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721129,'Outros produtos laminados planos, de ferro ou aços não ligados, de largura < 600 mm, laminados a frio, não folheados nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, simply cold-rolled cold-reduced, not clad, plated or coated, containing by weight >= 0,25% of carbon','Productos planos de hierro o acero sin alear, de anchura < 600 mm, simplemente laminados en frío, sin chapar ni revestir, con un contenido de carbono >= 0,25% en peso',72,7211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721190,'Outros produtos laminados planos, de ferro ou aços não ligados, de largura < 600 mm, laminados a frio, não folheados ou chapeados, nem revestidos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rolled or cold-rolled cold-reduced and further worked, but not clad, plated or coated','Productos planos de hierro o acero sin alear, de anchura < 600 mm, laminados en frío o en caliente y trabajados, pero sin chapar ni revestir',72,7211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721210,'Produtos laminados planos, de ferro ou aços não ligados, de largura < 600 mm, estanhados - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rolled or cold-rolled cold-reduced, tinned','Productos planos de hierro o acero sin alear, de anchura < 600 mm, estañados',72,7212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721220,'Produtos laminados planos, de ferro ou aços não ligados, de largura < 600 mm, galvanizados eletroliticamente - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rolled or cold-rolled cold-reduced, electrolytically plated or coated with zinc','Productos planos de hierro o acero sin alear, de anchura < 600 mm, laminados en frío o en caliente, cincados electrolíticamente',72,7212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721230,'Produtos laminados planos, de ferro ou aços não ligados, de largura < 600 mm, galvanizados por outro processo - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rolled or cold-rolled cold-reduced, tinned (excl. electrolytically plated or coated with zinc)','Productos planos de hierro o acero sin alear, de anchura < 600 mm, laminados en frío o en caliente, cincados (exc. cincados electrolíticamente)',72,7212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721240,'Produtos laminados planos, de ferro ou aços não ligados, de largura < 600 mm, pintados, envernizados ou revestidos de plásticos - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rolled or cold-rolled cold-reduced, painted, varnished or coated with plastics','Productos planos de hierro o acero sin alear, de anchura < 600 mm, laminados en frío o en caliente, pintados, barnizados o revestidos de plástico',72,7212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721250,'Produtos laminados planos, de ferro ou aços não ligados, de largura < 600 mm, revestidos de outras matérias - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rolled or cold-rolled cold-reduced, plated or coated (excl. tinned, plated or coated with zinc, painted, varnished or coated with plastics)','Productos planos de hierro o acero sin alear, de anchura < 600 mm, laminados en frío o en caliente, revestidos (exc. estañados, cincados, pintados, barnizados o revestidos de plástico)',72,7212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721260,'Produtos laminados planos, de ferro ou aços não ligados, de largura < 600 mm, folheados ou chapeados - siderúrgicos','Flat-rolled products of iron or non-alloy steel, of a width of < 600 mm, hot-rolled or cold-rolled cold-reduced, clad','Productos planos de hierro o acero sin alear, de anchura < 600 mm, laminados en frío o en caliente, chapados',72,7212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721310,'Fio-máquina de ferro ou aços não ligados, dentados, com nervuras, sulcos ou relevos, obtidos durante a laminagem - siderúrgicos','Bars and rods, hot-rolled, in irregularly wound coils of iron or non-alloy steel, with indentations, ribs, grooves or other deformations produced during the rolling process','Alambrón de hierro o acero sin alear, enrollado en espiras irregulares "coronas", con muescas, cordones, huecos o relieves, producidos en el laminado [CECA]',72,7213);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721320,'Fio-máquina de aços para tornear - siderúrgicos','Bars and rods, hot-rolled, in irregularly wound coils, of non-alloy free-cutting steel (excl. bars and rods containing indentations, ribs, grooves or other deformations produced during the rolling process)','Alambrón de acero de fácil mecanización, sin alear, enrollado en espiras irregulares "coronas" [CECA] (exc. con muescas, cordones, surcos o relieves, producidos en el laminado)',72,7213);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721391,'Fio-máquina de ferro ou aços não ligados, de seção circular de diâmetro < 14 mm - siderúrgicos','Bars and rods, hot-rolled, in irregularly wound coils, of iron or non-alloy steel, of circular cross-section measuring < 14 mm in diameter (excl. bars and rods of free-cutting steel, and bars and rods with indentations, ribs, grooves or other deformations','Alambrón de hierro o acero sin alear, enrollado en espiras irregulares "coronas", de sección circular con diámetro < 14 mm [CECA] (exc. de acero de fácil mecanización, así como el alambrón con muescas, cordones, huecos o relieves, producidos en el laminad',72,7213);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721399,'Outros fios-máquinas de ferro ou aços não ligados - siderúrgicos','Bars and rods, hot-rolled, in irregularly wound coils, of iron or non-alloy steel (excl. products of circular cross-section measuring < 14 mm in diameter, bars and rods of free-cutting steel, and bars and rods with indentations, ribs, grooves or other def','Alambrón de hierro o acero sin alear, enrollado en espiras irregulares "coronas" [CECA] (exc. de sección circular con diámetro < 14 mm; alambrón de acero de fácil mecanización; alambrón con muescas, cordones, huecos o relieves, producidos en el laminado)',72,7213);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721410,'Barras de ferro ou aços não ligados, forjadas a quente-siderúrgicos','Bars and rods, of iron or non-alloy steel, not further worked than forged (excl. in irregularly wound coils)','Barras de hierro o acero sin alear, simplemente forjadas',72,7214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721420,'Barras de ferro ou aços não ligadas, laminadas a quente, dentadas, com nervuras, sulcos ou relevos, obtidos durante a laminagem, ou torcidas após a laminagem - siderúrgicos','Bars and rods, of iron or non-alloy steel, with indentations, ribs, groves or other deformations produced during the rolling process','Barras de hierro o acero sin alear, con muescas, cordones, huecos o relieves, producidos en el laminado o sometidas a torsión después del laminado [CECA]',72,7214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721430,'Barras de aços para tornear, laminadas a quente - siderúrgicos','Bars and rods, of non-alloy free-cutting steel, not further worked than hot-rolled, hot-drawn or hot-extruded (excl. containing indentations, ribs, grooves or other deformations produced during the rolling process or twisted after rolling)','Barras de acero de fácil mecanización, sin alear, simplemente laminadas o extrudidas en caliente, incl. sometidas a torsión después del laminado [CECA] (exc. barras con muescas, cordones, huecos o relieves, producidos en el laminado o sometidas a torsión ',72,7214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721491,'Barras de ferro ou aços não ligados, laminadas a quente, de seção transversal retangular - siderúrgicos','Bars and rods, of iron or non-alloy steel, not further worked than hot-rolled, hot-drawn or hot-extruded, of rectangular other than square cross-section (excl. containing indentations, ribs, grooves or other deformations produced during the rolling proces','Barras de hierro o acero sin alear, simplemente laminadas o extrudidas en caliente, de sección transversal rectangular [CECA] (exc. con muescas, cordones, huecos o relieves, producidos en el laminado o sometidas a torsión después del laminado, así como ba',72,7214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721499,'Outras barras de ferro ou aços não ligados, estiradas ou extrudadas a quente - siderúrgicos','Bars and rods, of iron or non-alloy steel, only hot-rolled, only hot-drawn or only hot-extruded (excl. of rectangular [other than square] cross-section and those containing indentations, ribs, grooves or other deformations produced during the rolling proc','Barras de hierro o acero sin alear, simplemente laminadas o extrudidas en caliente [CECA] (exc. con muescas, cordones, huecos o relieves, producidos en el laminado o sometidas a torsión después del laminado, así como barras de acero de fácil mecanización ',72,7214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721510,'Barras de aços para tornear, simplesmente obtidas ou completamente acabadas a frio - siderúrgicos','Bars and rods, of non-alloy free-cutting steel, not further worked than cold-formed or cold-finished','Barras de acero de fácil mecanización, sin alear, simplemente obtenidas o acabadas en frío',72,7215);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721550,'Outras barras de ferro ou aços não ligados, simplesmente obtidas ou completamente acabadas a frio - siderúrgicos','Bars and rods, of iron or non-alloy steel, not further worked than cold-formed or cold-finished (excl. of free-cutting steel)','Barras de hierro o acero sin alear, simplemente obtenidas o acabadas en frío (exc. de acero de fácil mecanización)',72,7215);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721590,'Outras barras de ferro ou aços não ligados - siderúrgicos','Bars or rods, of iron or non-alloy steel, cold-formed or cold-finished and further worked or hot-formed and further worked, n.e.s.','Barras de hierro o acero sin alear, obtenidas o acabadas en frío y trabajadas u obtenidas en caliente y trabajadas, n.c.o.p.',72,7215);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721610,'Perfis de ferro ou aços não ligados, em U, I ou H, laminados, estirados ou extrudados a quente, de altura < 80 mm - siderúrgicos','U, I or H sections of iron or non-alloy steel, not further worked than hot-rolled, hot-drawn or extruded, of a height of < 80 mm','Perfiles en U, en I o en H, de hierro o acero sin alear, simplemente laminados o extrudidos en caliente, de altura < 80 mm [CECA]',72,7216);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721621,'Perfis de ferro ou aços não ligados, em L, laminados, estirados ou extrudados a quente, de altura < 80 mm - siderúrgicos','L sections of iron or non-alloy steel, not further worked than hot-rolled, hot-drawn or extruded, of a height of < 80 mm','Perfiles en L, de hierro o acero sin alear, simplemente laminados o extrudidos en caliente, de altura < 80 mm [CECA]',72,7216);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721622,'Perfis de ferro ou aços não ligados, em T, laminados, estirados ou extrudados a quente, de altura < 80 mm - siderúrgicos','T sections of iron or non-alloy steel, not further worked than hot-rolled, hot-drawn or extruded, of a height of < 80 mm','Perfiles en T, de hierro o acero sin alear, simplemente laminados o extrudidos en caliente, de altura < 80 mm [CECA]',72,7216);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721631,'Perfis de ferro ou aços não ligados, em U, laminados, estirados ou extrudados a quente, altura => 80 mm - siderúrgicos','U sections of iron or non-alloy steel, not further worked than hot-rolled, hot-drawn or hot-extruded, of a height >= 80 mm','Perfiles en U, de hierro o acero sin alear, simplemente laminados o extrudidos en caliente, de altura >= 80 mm [CECA]',72,7216);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721632,'Perfis de ferro ou aços não ligados, em I, laminados, estirados ou extrudados a quente, altura => 80 mm - siderúrgicos','I sections of iron or non-alloy steel, not further worked than hot-rolled, hot-drawn or hot-extruded, of a height >= 80 mm','Perfiles en I, de hierro o acero sin alear, simplemente laminados o extrudidos en caliente, de altura >= 80 mm [CECA]',72,7216);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721633,'Perfis de ferro ou aços não ligados, em H, laminados, estirados ou extrudados a quente, altura => 80 mm - siderúrgicos','H sections of iron or non-alloy steel, not further worked than hot-rolled, hot-drawn or hot-extruded, of a height >= 80 mm','Perfiles en H, de hierro o acero sin alear, simplemente laminados o extrudidos en caliente, de altura >= 80 mm [CECA]',72,7216);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721640,'Perfis de ferro ou aços não ligados, em L ou T, laminados, estirados ou extrudados a quente, altura => 80 mm - siderúrgicos','L sections of iron or non-alloy steel, not further worked than hot-rolled, hot-drawn or hot-extruded, of a height >= 80 mm','Perfiles en L o en T, de hierro o acero sin alear, simplemente laminados o extrudidos en caliente, de altura >= 80 mm [CECA]',72,7216);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721650,'Outros perfis de ferro ou aços não ligados, laminados, estirados ou extrudados a quente - siderúrgicos','Sections of iron or non-alloy steel, not further worked than hot-rolled, hot-drawn or hot-extruded (excl. U, I, H, L or T sections)','Perfiles de hierro o acero sin alear, simplemente laminados o extrudidos en caliente [CECA] (exc. perfiles en U, en I, en H, en L o en T)',72,7216);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721661,'Perfis de ferro ou aços não ligados, obtidos de produtos laminados planos, acabados a frio - siderúrgicos','Angles, shapes and sections, of iron or non-alloy steel, from flat-rolled products simply cold-formed or cold-finished (excl. profiled sheet)','Perfiles de hierro o acero sin alear, simplemente obtenidos o acabados en frío a partir de productos laminados planos (exc. chapas con nervaduras)',72,7216);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721669,'Outros perfis de ferro ou aços não ligados, acabados a frio - siderúrgicos','Angles, shapes and sections, of iron or non-alloy steel, not further worked than cold-formed or cold-finished (excl. profiled sheet)','Perfiles de hierro o acero sin alear, simplemente obtenidos o acabados en frío (exc. perfiles obtenidos a partir de productos planos, así como chapas con nervaduras)',72,7216);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721691,'Outros perfis de ferro ou aços não ligados, obtidos ou completamente acabados a frio a partir de produtos laminados planos - siderúrgicos','Angles, shapes and sections, of iron or non-alloy steel, cold-formed or cold-finished from flat-rolled products and further worked','Perfiles de hierro o acero sin alear, obtenidos o acabados en frío a partir de productos laminados planos y trabajados (exc. chapas con nervaduras)',72,7216);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721699,'Outros perfis de ferro ou aços não ligados - siderúrgicos','Angles, shapes and sections, of iron or non-alloy steel, cold-formed or cold-finished and further worked, or not further worked than forged, or forged, or hot-formed by other means and further worked, n.e.s. (excl. from flat-rolled products)','Perfiles de hierro o acero sin alear, obtenidos o acabados en frío y trabajados o simplemente forjados o forjados u obtenidos en caliente de otro modo y trabajados, n.c.o.p. (exc. perfiles obtenidos o acabados en frío a partir de productos laminados plano',72,7216);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721710,'Fios de ferro ou aços não ligados, não revestidos, mesmo polidos - siderúrgicos','Wire of iron or non-alloy steel, in coils, not plated or coated, whether or not polished (excl. bars and rods)','Alambre de hierro o acero sin alear, enrollado, sin revestir, incl. pulido (exc. alambrón)',72,7217);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721720,'Fios de ferro ou aços não ligados, galvanizados - siderúrgicos','Wire of iron or non-alloy steel, in coils, plated or coated with zinc (excl. bars and rods)','Alambre de hierro o acero sin alear, enrollado, cincado (exc. alambrón)',72,7217);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721730,'Fios de ferro ou aços não ligados, revestidos de outros metais comuns - siderúrgicos','Wire of iron or non-alloy steel, in coils, plated or coated with base metals (excl. plated or coated with zinc, and bars and rods)','Alambre de hierro o acero sin alear, enrollado, revestido de metal común (exc. cincado, así como el alambrón)',72,7217);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721790,'Outros fios de ferro ou aços não ligados - siderúrgicos','Wire of iron or non-alloy steel, in coils, plated or coated (excl. plated or coated with base metals, and bars and rods)','Alambre de hierro o acero sin alear, enrollado, revestido (exc. revestido con metales comunes, así como el alambrón)',72,7217);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721810,'Aços inoxidáveis, em lingotes ou outras formas primárias - siderúrgicos','Steel, stainless, in ingots and other primary forms (excl. waste and scrap in ingot form, and products obtained by continuous casting)','Acero inoxidable, en lingotes o demás formas primarias [CECA] (exc. lingotes de chatarra y productos obtenidos por colada continua)',72,7218);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721891,'Produtos semimanufaturados, de aços inoxidáveis, de seção transversal retangular - siderúrgicos','Semi-finished products of stainless steel, of rectangular other than square cross-section','Productos intermedios de acero inoxidable, de sección transversal rectangular',72,7218);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721899,'Outros produtos semimanufaturados, de aços inoxidáveis - siderúrgicos','Semi-finished products of stainless steel (excl. of rectangular [other than square] cross-section)','Productos intermedios de acero inoxidable (exc. de sección transversal rectangular)',72,7218);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721911,'Produtos laminados planos, de aços inoxidáveis, laminados a quente, de largura => 600 mm, em rolos, de espessura > 10 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of >= 600 mm, not further worked than hot-rolled, in coils, of a thickness of > 10 mm','Productos laminados planos de acero inoxidable, de anchura >= 600 mm, simplemente laminados en caliente, enrollados, de espesor > 10 mm [CECA]',72,7219);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721912,'Produtos laminados planos, de aços inoxidáveis, laminados a quente, de largura => 600 mm, em rolos, de espessura => 4,75 mm e <= 10 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of>= 600 mm, not further worked than hot-rolled, in coils, of a thickness of >= 4,7 mm and <= 10 mm','Productos laminados planos de acero inoxidable, de anchura >= 600 mm, simplemente laminados en caliente, enrollados, de espesor >= 4,75 mm pero <= 10 mm [CECA]',72,7219);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721913,'Produtos laminados planos, de aços inoxidáveis, laminados a quente, de largura => 600 mm, em rolos, de espessura => 3 mm e < 4,75 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of >= 600 mm, not further worked than hot-rolled, in coils, of a thickness of >= 3 mm and < 4,75 mm','Productos laminados planos de acero inoxidable, de anchura >= 600 mm, simplemente laminados en caliente, enrollados, de espesor >= 3 mm pero < 4,75 mm [CECA]',72,7219);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721914,'Produtos laminados planos, de aços inoxidáveis, laminados a quente, de largura => 600 mm, em rolos, de espessura < 3 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of >= 600 mm, not further worked than hot-rolled, in coils, of a thickness of < 3 mm','Productos laminados planos de acero inoxidable, de anchura >= 600 mm, simplemente laminados en caliente, enrollados, de espesor < 3 mm [CECA]',72,7219);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721921,'Produtos laminados planos, de aços inoxidáveis, laminados a quente, de largura => 600 mm, não enrolados, de espessura > 10 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of >= 600 mm, not further worked than hot-rolled, in coils, of a thickness of > 10 mm','Productos laminados planos de acero inoxidable, de anchura >= 600 mm, simplemente laminados en caliente, sin enrollar, de espesor > 10 mm [CECA]',72,7219);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721922,'Produtos laminados planos, de aços inoxidáveis, laminados a quente, de largura => 600 mm, não enrolados, de espessura => 4,75 mm e <= 10 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of >= 600 mm, not further worked than hot-rolled, not in coils, of a thickness of >= 4,75 mm and <= 10 mm','Productos laminados planos de acero inoxidable, de anchura >= 600 mm, simplemente laminados en caliente, sin enrollar, de espesor >= 4,75 mm pero <= 10 mm [CECA]',72,7219);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721923,'Produtos laminados planos, de aços inoxidáveis, laminados a quente, de largura => 600 mm, não enrolados, de espessura => 3 mm e < 4,75 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of >= 600 mm, not further worked than hot-rolled, not in coils, of a thickness of >= 3 mm and < 4,75 mm','Productos laminados planos de acero inoxidable, de anchura >= 600 mm, simplemente laminados en caliente, sin enrollar, de espesor >= 3 mm pero < 4,75 mm [CECA]',72,7219);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721924,'Produtos laminados planos, de aços inoxidáveis, laminados a quente, de largura => 600 mm, de espessura < 3 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of >= 600 mm, not further worked than hot-rolled, not in coils, of a thickness of < 3 mm','Productos laminados planos de acero inoxidable, de anchura >= 600 mm, simplemente laminados en caliente, sin enrollar, de espesor < 3 mm [CECA]',72,7219);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721931,'Produtos laminados planos, de aços inoxidáveis, laminados a frio, de largura => 600 mm, de espessura => 4,75 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of >= 600 mm, not further worked than cold-rolled cold-reduced, of a thickness of >= 4,75 mm','Productos laminados planos de acero inoxidable, de anchura >= 600 mm, simplemente laminados en frío, de espesor >= 4,75 mm [CECA]',72,7219);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721932,'Produtos laminados planos, de aços inoxidáveis, laminados a frio, de largura => 600 mm, de espessura => 3 mm e < 4,75 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of >= 600 mm, not further worked than cold-rolled cold-reduced, of a thickness of >= 3 mm but < 4,75 mm','Productos laminados planos de acero inoxidable, de anchura >= 600 mm, simplemente laminados en frío, de espesor >= 3 mm pero < 4,75 mm [CECA]',72,7219);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721933,'Produtos laminados planos, de aços inoxidáveis, laminados a frio, de largura => 600 mm, de espessura > 1 mm e < 3 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of >= 600 mm, not further worked than cold-rolled cold-reduced, of a thickness of > 1 mm but < 3 mm','Productos laminados planos de acero inoxidable, de anchura >= 600 mm, simplemente laminados en frío, de espesor > 1 mm pero < 3 mm [CECA]',72,7219);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721934,'Produtos laminados planos, de aços inoxidáveis, laminados a frio, de largura => 600 mm, de espessura => 0,5 mm e <= 1 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of >= 600 mm, not further worked than cold-rolled cold-reduced, of a thickness of >= 0,5 mm but <= 1 mm','Productos laminados planos de acero inoxidable, de anchura >= 600 mm, simplemente laminados en frío, de espesor >= 0,5 mm pero <= 1 mm [CECA]',72,7219);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721935,'Produtos laminados planos, de aços inoxidáveis, laminados a frio, de largura => 600 mm e espessura < 0,5 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of >= 600 mm, not further worked than cold-rolled cold-reduced, of a thickness of < 0,5 mm','Productos laminados planos de acero inoxidable, de anchura >= 600 mm, simplemente laminados en frío, de espesor < 0,5 mm [CECA]',72,7219);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (721990,'Outros produtos laminados planos, de aços inoxidáveis, de largura => 600 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of >= 600 mm, hot-rolled or cold-rolled cold-reduced and further worked','Productos laminados planos de acero inoxidable, de anchura >= 600 mm, laminados en frío o en caliente y trabajados',72,7219);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722011,'Produtos laminados planos, de aços inoxidáveis, laminados a quente, de largura < 600 mm e espessura => 4,75 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of < 600 mm, not further worked than hot-rolled, of a thickness of >= 4,75 mm','Productos laminados planos de acero inoxidable, de anchura < 600 mm, simplemente laminados en caliente, de espesor >= 4,75 mm [CECA]',72,7220);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722012,'Produtos laminados planos, de aços inoxidáveis, laminados a quente, de largura < 600 mm e espessura < 4,75 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of < 600 mm, not further worked than hot-rolled, of a thickness of < 4,75 mm','Productos laminados planos de acero inoxidable, de anchura < 600 mm, simplemente laminados en caliente, de espesor < 4,75 mm [CECA]',72,7220);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722020,'Produtos laminados planos, de aços inoxidáveis, laminados a frio, de largura < 600 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of < 600 mm, not further worked than cold-rolled cold-reduced','Productos laminados planos de acero inoxidable, de anchura < 600 mm, simplemente laminados en frío',72,7220);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722090,'Outros produtos laminados planos, de aços inoxidáveis, de largura < 600 mm - siderúrgicos','Flat-rolled products of stainless steel, of a width of < 600 mm, hot-rolled or cold-rolled cold-reduced and further worked','Productos laminados planos de acero inoxidable, de anchura < 600 mm, laminados en frío o en caliente y trabajados',72,7220);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722100,'Fio-máquina de aços inoxidáveis - siderúrgicos','Bars and rods of stainless steel, hot-rolled, in irregularly wound coils','Alambrón de acero inoxidable, enrollado en espiras irregulares "coronas" [CECA]',72,7221);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722211,'Barras de aços inoxidáveis, laminadas, estiradas ou extrudadas a quente, de seção circular - siderúrgicos','Bars and rods of stainless steel, only hot-rolled, only hot-drawn or only hot-extruded, of circular cross-section','Barras de acero inoxidable, simplemente laminadas o extrudidas en caliente, de sección circular [CECA]',72,7222);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722219,'Outras barras de aços inoxidáveis, laminadas, estiradas ou extrudadas a quente - siderúrgicos','Bars and rods of stainless steel, only hot-rolled, only hot-drawn or only extruded (excl. of circular cross-section)','Barras de acero inoxidable, simplemente laminadas o extrudidas en caliente [CECA] (exc. de sección circular)',72,7222);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722220,'Barras de aços inoxidáveis, obtidas ou completamente acabadas a frio - siderúrgicos','Other bars and rods of stainless steel, not further worked than cold-formed or cold-finished','Barras de acero inoxidable, simplemente obtenidas o acabadas en frío',72,7222);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722230,'Outras barras de aços inoxidáveis - siderúrgicos','Other bars and rods of stainless steel, cold-formed or cold-finished and further worked, or not further worked than forged, or forged, or hot-formed by other means and further worked, n.e.s.','Barras de acero inoxidable, obtenidas o acabadas en frío y trabajadas, o simplemente forjadas o forjadas o obtenidas de otro modo en caliente y trabajadas, n.c.o.p.',72,7222);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722240,'Perfis de aços inoxidáveis - siderúrgicos','Angles, shapes and sections of stainless steel, n.e.s.','Perfiles de acero inoxidable, n.c.o.p.',72,7222);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722300,'Fios de aços inoxidáveis - siderúrgicos','Wire of stainless steel, in coils (excl. bars and rods)','Alambre de acero inoxidable, enrollado (exc. el alambrón)',72,7223);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722410,'Outras ligas de aços, em lingotes e outras formas primárias - siderúrgicos','Steel, alloy, other than stainless, in ingots or other primary forms (excl. waste and scrap in ingot form, and products obtained by continuous casting)','Acero aleado, distinto del acero inoxidable, en lingotes o demás formas primarias [CECA] (exc. lingotes de chatarra y productos obtenidos por colada continua)',72,7224);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722490,'Produtos semimanufaturados, de outras ligas de aços - siderúrgicos','Semi-finished products of alloy steel other than stainless','Productos intermedios de aceros aleados, distinto del acero inoxidable',72,7224);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722511,'Produtos laminados planos, de largura => 600 mm, de ligas de aços ao silício, denominados magnéticos, de grãos orientados - siderúrgicos','Flat-rolled products of silicon-electrical steel, of a width of >= 600 mm, grain-oriented','Productos laminados planos de acero al silicio llamado "magnético" "acero magnético al silicio", de anchura >= 600 mm, de grano orientado [CECA]',72,7225);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722519,'Outros produtos laminados planos, de largura => 600 mm, de ligas de aços ao silício - siderúrgicos','Flat-rolled products of silicon-electrical steel, of a width of >= 600 mm, non-grain-oriented','Productos laminados planos de acero al silicio llamado "magnético" "acero magnético al silicio", de anchura >= 600 mm, de grano sin orientar [CECA]',72,7225);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722520,'Lamin.ligas de aços de corte rapido,  l>=600mm','Rolled produc.of alloy of high speed steel, w>=600mm','Lamin.de acero rápido, a>=600mm',72,7225);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722530,'Produtos laminados planos, de outras ligas de aços, de largura => 600 mm, laminados a quente, em rolos - siderúrgicos','Flat-rolled products of alloy steel other than stainless, of a width of >= 600 mm, not further worked than hot-rolled, in coils (excl. products of silicon-electrical steel)','Productos planos de aceros aleados, distinto del acero inoxidable, de anchura >= 600 mm, simplemente laminados en caliente, enrollados [CECA] (exc. de acero rápido o de acero al silicio llamado "magnético" "acero magnético al silicio")',72,7225);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722540,'Produtos laminados planos, de outras ligas de aços, de largura => 600 mm, laminados a quente, não enrolados - siderúrgicos','Flat-rolled products of alloy steel other than stainless, of a width of >= 600 mm, not further worked than hot-rolled, not in coils (excl. products of silicon-electrical steel)','Productos planos de aceros aleados, distinto del acero inoxidable, de anchura >= 600 mm, simplemente laminados en caliente, sin enrollar [CECA] (exc. de acero rápido o de acero al silicio llamado "magnético" "acero magnético al silicio")',72,7225);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722550,'Produtos laminados planos, de outras ligas de aços, de largura => 600 mm, laminados a frio - siderúrgicos','Flat-rolled products of alloy steel other than stainless, of a width of >= 600 mm, not further worked than hot-rolled (excl. products of silicon-electrical steel)','Productos planos de aceros aleados, distinto del acero inoxidable, de anchura >= 600 mm, simplemente laminados en frío [CECA] (exc. de acero rápido o de acero al silicio llamado "magnético" "acero magnético al silicio")',72,7225);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722591,'Produtos laminados planos, de outras ligas de aços, de largura => 600 mm, galvanizados eletroliticamente - siderúrgicos','Flat-rolled products of alloy steel other than stainless, of a width of >= 600 mm, hot-rolled or cold-rolled cold-reduced and electrolytically plated or coated with zinc (excl. products of silicon-electrical steel)','Productos planos de aceros aleados, distinto del acero inoxidable, de anchura >= 600 mm, laminados en frío o en caliente y cincados electrolíticamente (exc. de acero rápido o de acero al silicio llamado "magnético" "acero magnético al silicio")',72,7225);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722592,'Produtos laminados planos, de outras ligas de aços, de largura => 600 mm, galvanizados por outro processo - siderúrgicos','Flat-rolled products of alloy steel other than stainless, of a width of >= 600 mm, hot-rolled or cold-rolled cold-reduced and plated or coated with zinc (excl. electrolytically plated or coated and products of silicon-electrical steel)','Productos planos de aceros aleados, distinto del acero inoxidable, de anchura >= 600 mm, laminados en frío o en caliente y cincados (exc. cincados electrolíticamente, así como productos de acero rápido o de acero al silicio llamado "magnético" "acero magn',72,7225);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722599,'Outros produtos laminados planos, de outras ligas de aços, de largura => 600 mm - siderúrgicos','Flat-rolled products of alloy steel other than stainless, of a width of >= 600 mm, hot-rolled or cold-rolled cold-reduced and further worked (excl. plated or coated with zinc and products of silicon-electrical steel)','Productos planos de aceros aleados, distinto del acero inoxidable, de anchura >= 600 mm, laminados en frío o en caliente y trabajados (exc. cincados, así como productos de acero rápido o de acero al silicio llamado "magnético" "acero magnético al silicio"',72,7225);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722611,'Produtos laminados planos, de largura < 600 mm, de ligas de aços ao silício, denominados magnéticos, de grãos orientados - siderúrgicos','Flat-rolled products of silicon-electrical steel, of a width of < 600 mm, hot-rolled or cold-rolled cold-reduced, grain-oriented','Productos planos de acero al silicio llamado "magnético" "acero magnético al silicio", de anchura < 600 mm, laminados en frío o en caliente, de grano orientado',72,7226);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722619,'Produtos laminados planos, de largura < 600 mm, de ligas de aços ao silício - siderúrgicos','Flat-rolled products of silicon-electrical steel, of a width of < 600 mm, hot-rolled or cold-rolled cold-reduced, not grain-oriented','Productos planos de acero al silicio llamado "magnético" "acero magnético al silicio", de anchura < 600 mm, laminados en frío o en caliente, de grano sin orientar',72,7226);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722620,'Produtos laminados planos, de largura < 600 mm, de ligas de aços de corte rápido - siderúrgicos','Flat-rolled products of high-speed steel, of a width of <= 600 mm, hot-rolled or cold-rolled cold-reduced','Productos planos de acero rápido, de anchura < 600 mm, laminados en frío o en caliente',72,7226);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722691,'Produtos laminados planos, de largura < 600 mm, de outras ligas de aços, laminados a quente - siderúrgicos','Flat-rolled products of alloy steel other than stainless, of a width of < 600 mm, not further worked than hot-rolled (excl. products of high-speed steel or silicon-electrical steel)','Productos planos de aceros aleados, distinto del acero inoxidable, de anchura < 600 mm, simplemente laminados en caliente [CECA] (exc. de acero rápido o de acero al silicio llamado "magnético" "acero magnético al silicio")',72,7226);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722692,'Produtos laminados planos, de largura < 600 mm, de outras ligas de aços, laminados a frio - siderúrgicos','Flat-rolled products of alloy steel other than stainless, of a width of < 600 mm, not further worked than cold-rolled cold-reduced (excl. products of high-speed steel or silicon-electrical steel)','Productos planos de aceros aleados, distinto del acero inoxidable, de anchura < 600 mm, simplemente laminados en frío (exc. de acero rápido o de acero al silicio llamado "magnético" "acero magnético al silicio")',72,7226);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722693,'lamin.de outras ligas de aços,  l<600mm,  galvan.eletrolit.','rolled of other alloy steel, w<600mm, electr.galvan.','lamin.de los demás aceros aleados, a<600mm, cinc.elect.',72,7226);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722694,'lamin.de outs.ligas de aços,  l<600mm,  galvan.por out.proc','rolled of other alloy steel, w<600mm, otherw.galvan.','lam.de los demás aceros aleados, a<600mm, cinc.de ot.modo',72,7226);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722699,'Produtos laminados planos, de outras ligas de aços, de largura < 600 mm - siderúrgicos','Flat-rolled products of alloy steel other than stainless, of a width of < 600 mm, hot-rolled or cold-rolled cold-reduced and further worked (excl. products of high-speed steel or silicon-electrical steel)','Productos planos de aceros aleados, distinto del acero inoxidable, de anchura < 600 mm, laminados en frío o en caliente y trabajados (exc. cincados, así como productos de acero rápido o de acero al silicio llamado "magnético" "acero magnético al silicio")',72,7226);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722710,'Fio-máquina de aços de corte rápido - siderúrgicos','Bars and rods of high-speed steel, hot-rolled, in irregularly wound coils','Alambrón de acero rápido, enrollado en espiras irregulares "coronas" [CECA]',72,7227);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722720,'Fio-máquina de ligas de aços silício-manganês - siderúrgicos','Bars and rods of silico-manganese steel, hot-rolled, in irregularly wound coils','Alambrón de acero silico-manganoso, enrollado en espiras irregulares "coronas" [CECA]',72,7227);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722790,'Outros fio-máquinas de outras ligas de aços - siderúrgicos','Bars and rods of alloy steel other than stainless, hot-rolled, in irregularly wound coils (excl. products of high-speed steel or silicon-electrical steel)','Alambrón de aceros aleados, distinto del acero inoxidable, enrollado en espiras irregulares "coronas" (exc. de acero rápido o de acero sílico- manganoso)',72,7227);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722810,'Barras de aços de corte rápido - siderúrgicos','Bars and rods of high-speed steel (excl. semi-finished products, flat-rolled products and hot-rolled bars and rods in irregularly wound coils)','Barras de acero rápido',72,7228);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722820,'Barras de aços silício-manganês - siderúrgicos','Bars and rods of silico-manganese steel (excl. semi-finished products, flat-rolled products and hot-rolled bars and rods in irregularly wound coils)','Barras de acero silico-manganoso',72,7228);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722830,'Barras de outras ligas de aços laminadas, estiradas ou extrudadas a quente - siderúrgicos','Bars and rods of alloy steel other than stainless, not further worked than hot-rolled, hot-drawn or extruded (excl. products of high-speed steel or silico-manganese steel, semi-finished products, flat-rolled products and hot-rolled bars and rods in irregu','Barras de aceros aleados, distinto del acero inoxidable, simplemente laminadas o extrudidas en caliente [CECA] (exc. de acero rápido o de acero silico-manganoso)',72,7228);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722840,'Barras de outras ligas de aços, forjadas - siderúrgicos','Bars and rods of alloy steel other than stainless, not further worked than forged (excl. products of high-speed steel or silico-manganese steel, semi-finished products, flat-rolled products and hot-rolled bars and rods in irregularly wound coils)','Barras de aceros aleados, distinto del acero inoxidable, simplemente forjadas (exc. de acero rápido o de acero silico-manganoso)',72,7228);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722850,'Barras de outras ligas de aços, obtidas ou completamente acabadas a frio - siderúrgicos','Bars and rods of alloy steel other than stainless, not further worked than cold-formed or cold-finished (excl. products of high-speed steel or silico-manganese steel, semi-finished products, flat-rolled products and hot-rolled bars and rods in irregularly','Barras de aceros aleados, distinto del acero inoxidable, simplemente obtenidas o acabadas en frío (exc. de acero rápido o de acero sílico- manganoso)',72,7228);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722860,'Outras barras de outras ligas de aços - siderúrgicos','Bars and rods of alloy steel other than stainless, cold-formed or cold-finished and further worked or hot-formed and further worked, n.e.s. (excl. products of high-speed steel or silico-manganese steel, semi-finished products, flat-rolled products and hot','Barras de aceros aleados, distinto del acero inoxidable, obtenidas o acabadas en frío y trabajadas u obtenidas en caliente y trabajadas [CECA] (exc. de acero rápido o de acero silico-manganoso)',72,7228);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722870,'Perfis de outras ligas de aços - siderúrgicos','Angles, shapes and sections of alloy steel other than stainless, n.e.s.','Perfiles de aceros aleados, distinto del acero inoxidable, n.c.o.p.',72,7228);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722880,'Barras ocas para perfuração, de ligas de aços - siderúrgicos','Hollow drill bars and rods, of alloy or non-alloy steel','Barras huecas para perforación, de aceros aleados o sin alear',72,7228);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722910,'fios de ligas de aços de corte rápido','wire of other alloy of high-speed steel','alambre de acero rápido',72,7229);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722920,'Fios de ligas de aços silício-manganês - siderúrgicos','Wire of silico-manganese steel, in coils (excl. bars and rods)','Alambre de acero silico-manganoso, enrollado (exc. el alambrón)',72,7229);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (722990,'Outros fios de outras ligas de aços - siderúrgicos','Wire of alloy steel other than stainless, in coils (excl. bars and rods and wire of silico-manganese steel)','Alambre de aceros aleados, distinto del acero inoxidable, enrollado (exc. el alambrón, así como el alambre de acero rápido o de acero silico-manganoso)',72,7229);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730110,'Estacas-pranchas de ferro ou aço, mesmo perfuradas ou constituídas por junção de elementos reunidos','Sheet piling of iron or steel, whether or not drilled, punched or made from assembled elements','Tablestacas de hierro o acero, incl. perforadas o hechas con elementos ensamblados [CECA]',73,7301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730120,'Perfis de ferro ou aço, obtidos por soldadura','Angles, shapes and sections, of iron or steel, welded','Perfiles de hierro o acero, obtenidos por soldadura',73,7301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730210,'Trilhos (carris) de vias férreas, de ferro fundido, ferro ou aço','Rails of iron or steel, for railway or tramway track (excl. check-rails)','Carriles "rieles" de fundición, hierro o acero, para vías férreas (exc. contracarriles "rieles" "contrarrieles")',73,7302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730220,'Dormentes de ferro fundido, ferro ou aço','Sleepers of cast iron/iron/steel','Traviesas(durmientes), de fundición, hierro o acero',73,7302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730230,'Agulhas, cróssimas, alavancas para comando de agulhas e outros elementos de cruzamento e desvios, de ferro fundido, ferro ou aço','Switch blades, crossing frogs, point rods and other crossing pieces, for railway or tramway track, of iron or steel','Agujas, puntas de corazón, varillas para el mando de agujas y demás elementos para el cruce y cambio de vías, de fundición, hierro o acero',73,7302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730240,'Talas de junção e placas de apoio ou assentamento, de ferro fundido, ferro ou aço','Fish-plates and sole plates of iron or steel, for railways or tramways','Bridas y placas de asiento, de fundición, hierro o acero, para vías',73,7302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730290,'Outros elementos de vias férreas, de ferro fundido, ferro ou aço','Sleepers cross-ties, check-rails, rack rails, chairs, chair wedges, rail clips, bedplates and ties and other specialised material for the jointing or fixing of railway or tramway track, of iron or steel (excl. rails, switch blades, crossing frogs, point r','Traviesas "durmientes", contracarriles "contrarrieles", cremalleras, cojinetes, cuñas, placas de unión, placas y tirantes de separación y demás piezas concebidas especialmente para la colocación, unión o fijación de carriles "rieles", de fundición, hierro',73,7302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730300,'Tubos e perfis ocos, de ferro fundido','Tubes, pipes and hollow profiles, of cast iron','Tubos y perfiles huecos, de fundición',73,7303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730410,'Tubos dos tipos utilizados em oleodutos e gasodutos','Pipe of a kind used in oil and gas pipelines','Tubos de los tipos utilizados en oleoductos y gasoductos',73,7304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730411,'Tubos sem costura, de aços inoxidáveis, para oleodutos e gasodutos','Line pipe of a kind used for oil or gas pipelines, seamless, of stainless steel','Tubos sin soldadura, de acero inoxidable, de los tipos utilizados en oleoductos o gasoductos',73,7304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730419,'Outros tubos, sem costura, de ferro ou aço, para oleodutos e gasodutos','Line pipe of a kind used for oil or gas pipelines, seamless, of iron or steel (excl. products of stainless steel or of cast iron)','Los demás tubos sin soldadura, de hierro o acero, de los tipos utilizados en oleoductos o gasoductos',73,7304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730421,'Tubos de aços','Steel tubes','Tubos de acero',73,7304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730422,'Tubos de perfuração, sem costura, de aços inoxidáveis, para extração de petróleo e gás','Drill pipe, seamless, of stainless steel, of a kind used in drilling for oil or gas','Tubos de perforación, sin soldadura, de acero inoxidable, de los tipos utilizados para la extracción de petróleo o gas',73,7304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730423,'Outros tubos de perfuração, sem costura, de ferro ou aço, para extração de petróleo e gás','Drill pipe, seamless, of a kind used in drilling for oil or gas, of iron or steel (excl. products of stainless steel or of cast iron)','Los demás tubos de perforación, sin soldadura, de hierro o acero, de los tipos utilizados para la extracción de petróleo o gas ',73,7304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730424,'Outros tubos de revestimento de poços, de suprimento ou de produção, sem costura, de aços inoxidáveis, utilizados na extração de petróleo e gás','Casing and tubing, seamless, of a kind used for drilling for oil or gas, of stainless steel (excl. drill pipe)','Los demás tubos de entubación "casing" o de producción "tubing", sin soldadura, de acero inoxidable, de los tipos utilizados para la extracción de petróleo o gas ',73,7304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730429,'Outros tubos de revestimento de poços, de suprimento ou de produção, de ferro ou aço, sem costura, utilizados na extração de petróleo e gás','Casing and tubing, seamless, of iron or steel, of a kind used in drilling for oil or gas (excl. products of cast iron)','Tubos de entubación "casing" o de producción "tubing", sin soldadura, de hierro o acero, de los tipos utilizados para la extracción de petróleo o gas (exc. de fundición)',73,7304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730431,'Outros tubos de ferro ou de aços não ligados, sem costura, de seção circular, estirados ou laminados a frio','Tubes, pipes and hollow profiles, seamless, of circular cross-section, of iron or non-alloy steel, cold-drawn or cold-rolled cold-reduced (excl. cast iron products and line pipe of a kind used for oil or gas pipelines or casing and tubing of a kind used f','Tubos y perfiles huecos, sin soldadura, de sección circular, de hierro o acero sin alear, estirados o laminados en frío (exc. de fundición, así como tubos de los tipos utilizados en oleoductos o gasoductos o de los utilizados para la extracción de petróle',73,7304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730439,'Outros tubos de ferro ou de aços não ligados, sem costura, de seção circular','Tubes, pipes and hollow profiles, seamless, of circular cross-section, of iron or non-alloy steel, not cold-drawn or cold-rolled cold-reduced (excl. cast iron products, line pipe of a kind used for oil or gas pipelines, casing and tubing of a kind used fo','Tubos y perfiles huecos, sin soldadura, de sección circular, de hierro o acero sin alear, distintos de los estirados o laminados en frío (exc. de fundición, así como tubos de los tipos utilizados en oleoductos o gasoductos o de los utilizados para la extr',73,7304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730441,'Tubos de aços inoxidáveis, sem costura, de seção circular, estirados ou laminados a frio','Tubes, pipes and hollow profiles, seamless, of circular cross-section, of stainless steel, cold-drawn or cold-rolled cold-reduced (excl. line pipe of a kind used for oil or gas pipelines, casing and tubing of a kind used for drilling for oil or gas)','Tubos y perfiles huecos, sin soldadura, de sección circular, de acero inoxidable, estirados o laminados en frío (exc. tubos de los tipos utilizados en oleoductos o gasoductos o de los utilizados para la extracción de petróleo o gas)',73,7304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730449,'Outros tubos de aços inoxidáveis, sem costura, de seção circular','Tubes, pipes and hollow profiles, seamless, of circular cross-section, of stainless steel, not cold-drawn or cold-rolled cold-reduced (excl. line pipe of a kind used for oil or gas pipelines or of a kind used for drilling for oil or gas)','Tubos y perfiles huecos, sin soldadura, de sección circular, de acero inoxidable, distintos de los estirados o laminados en frío (exc. tubos de los tipos utilizados en oleoductos o gasoductos o de los utilizados para la extracción de petróleo o gas)',73,7304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730451,'Tubos e perfis ocos de outras ligas de aços, sem costura, de seção circular, estirados ou laminados a frio','Tubes, pipes and hollow profiles, seamless, of circular cross-section, of alloy steel other than stainless, cold-drawn or cold-rolled cold-reduced (excl. line pipe of a kind used for oil or gas pipelines, casing and tubing of a kind used for drilling for ','Tubos y perfiles huecos, sin soldadura, de sección circular, de aceros aleados distinto del acero inoxidable, estirados o laminados en frío (exc. tubos de los tipos utilizados en oleoductos o gasoductos o de los utilizados para la extracción de petróleo o',73,7304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730459,'Outros tubos de outras ligas de aços, sem costura, de seção circular','Tubes, pipes and hollow profiles, seamless, of circular cross-section, of alloy steel other than stainless, not cold-drawn or cold-rolled cold-reduced (excl. line pipe of a kind used for oil or gas pipelines, casing and tubing of a kind used for drilling ','Tubos y perfiles huecos, sin soldadura, de sección circular, de aceros aleados distinto del acero inoxidable, distintos de los estirados o laminados en frío (exc. tubos de los tipos utilizados en oleoductos o gasoductos o de los utilizados para la extracc',73,7304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730490,'Outros tubos e perfis ocos, de ferro ou aço, sem costura','Tubes, pipes and hollow profiles, seamless, of non-circular cross-section, of iron or steel (excl. products of cast iron)','Tubos y perfiles huecos, sin soldadura, de sección distinta de la circular, de hierro o acero (exc. de fundición)',73,7304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730511,'Tubos de ferro ou aço, de seção circular, de diâmetro exterior > 406,4 mm, soldados longitudinalmente por arco imerso, utilizados para oleodutos ou gasodutos','Line pipe of a kind used for oil or gas pipelines, having circular cross-sections and an external diameter of > 406,4 mm, of iron or steel, longitudinally submerged arc welded','Tubos de los tipos utilizados en oleoductos o gasoductos, de sección circular, de diámetro exterior > 406,4 mm, de fundición, hierro o acero, soldados longitudinalmente con arco sumergido',73,7305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730512,'Tubos de ferro ou aço, de seção circular, de diâmetro exterior > 406,4 mm, soldados longitudinalmente, utilizados para oleodutos ou gasodutos','Line pipe of a kind used for oil or gas pipelines, having circular cross-sections and an external diameter of > 406,4 mm, of iron or steel, longitudinally arc welded (excl. products longitudinally submerged arc welded)','Tubos de los tipos utilizados en oleoductos o gasoductos, de sección circular, de diámetro exterior > 406,4 mm, de fundición, hierro o acero, soldados longitudinalmente (exc. con arco sumergido)',73,7305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730519,'Outros tubos de ferro aço, soldados, de seção circular, de diâmetro exterior > 406,4 mm, utilizados para oleodutos ou gasodutos','Line pipe of a kind used for oil or gas pipelines, having circular cross-sections and an external diameter of > 406,4 mm, of flat-rolled products of iron or steel (excl. products longitudinally arc welded)','Tubos de los tipos utilizados en oleoductos o gasoductos, de sección circular, de diámetro exterior > 406,4 mm, fabricados a partir de productos laminados planos, de fundición, hierro o acero (exc. soldados longitudinalmente)',73,7305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730520,'Tubos de ferro ou aço, soldados, de seção circular, de diâmetro exterior > 406,4 mm, para revestimento de poços, utilizados na extração de petróleo ou de gás','Casing of a kind used in drilling for oil or gas, having circular cross-sections and an external diameter of > 406,4 mm, of flat-rolled products of iron or steel','Tubos de entubación "casing" de los tipos utilizados para la extracción de petróleo o gas, de sección circular, de diámetro exterior > 406,4 mm, fabricados a partir de productos laminados planos, de fundición, hierro o acero',73,7305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730531,'Outros tubos de ferro ou aço, soldados longitudinalmente, de seção circular, de diâmetro exterior > 406,4 mm','Tubes and pipes having circular cross-sections and an external diameter of > 406,4 mm, of iron or steel, longitudinally welded (excl. products of a kind used for oil or gas pipelines or of a kind used in drilling for oil or gas)','Tubos de sección circular, de diámetro exterior > 406,4 mm, de fundición, hierro o acero, soldados longitudinalmente (exc. tubos de los tipos utilizados en oleoductos o gasoductos o de los utilizados para la extracción de petróleo o gas)',73,7305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730539,'Outros tubos de ferro ou aço, soldados, de seção circular, de diâmetro exterior > 406,4 mm','Tubes and pipes having circular cross-sections and an external diameter of > 406,4 mm, of iron or steel, welded (excl. products longitudinally welded or of a kind used for oil or gas pipelines or of a kind used in drilling for oil or gas)','Tubos de sección circular, de diámetro exterior > 406,4 mm, de fundición, hierro o acero, soldados (exc. soldados longitudinalmente, así como tubos de los tipos utilizados en oleoductos o gasoductos o de los utilizados para la extracción de petróleo o gas',73,7305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730590,'Outros tubos de ferro ou aço, rebitados, de seção circular, de diâmetro exterior > 406,4 mm','Tubes and pipes having circular cross-sections and an external diameter of > 406,4 mm, of flat-rolled products of iron or steel, welded (excl. welded products or products of a kind used for oil or gas pipelines or of a kind used in drilling for oil or gas','Tubos de sección circular, de diámetro exterior > 406,4 mm, fabricados a partir de productos laminados planos de hierro o acero (exc. soldados, así como tubos de los tipos utilizados en oleoductos o gasoductos o de los utilizados para la extracción de pet',73,7305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730610,'tubos ferro/aço,  sold/rebitad/agrafad.p/oleoduto/gasod.','pipes iron/steel, weld/rivet/similar/pipeline/gas pipel.','tubos hierro/acero, remachados, grapado, en oleod./gasod.',73,7306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730611,'Tubos soldados, de aços inoxidáveis, dos tipos utilizados em oleodutos ou gasodutos','Line pipe of a kind used for oil or gas pipelines, welded, of flat-rolled products of stainless steel, of an external diameter of <= 406,4 mm','Tubos soldados, de acero inoxidable, de los tipos utilizados en oleoductos o gasoductos',73,7306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730619,'Outros tubos, de ferro e aço, dos tipos utilizados em oleodutos ou gasodutos','Line pipe of a kind used for oil or gas pipelines, welded, of flat-rolled products of iron or steel, of an external diameter of <= 406,4 mm (excl. products of stainless steel or of cast iron)','Los demás tubos, de hierro o acero, de los tipos utilizados en oleoductos o gasoductos',73,7306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730620,'tubos ferro/aço,  sold/rebitad/agrafad.p/revest.pocos,  etc','pipes iron/steel, weld/rivet/similar/f/coat.weels, etc','tubos hierro/acero, sold.remach.grap.p/reves.pocos, etc',73,7306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730621,'Tubos soldados, de aços inoxidáveis, de revestimento de poços, de suprimento ou de produção, dos tipos utilizados na extração de petróleo ou gás','Casing and tubing of a kind used in drilling for oil or gas, welded, of flat-rolled products of stainless steel, of an external diameter of <= 406,4 mm','Tubos soldados, de acero inoxidable, de entubación "casing" o de producción "tubing" de los tipos utilizados para la extracción de petróleo o gas ',73,7306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730629,'Outros tubos, de ferro ou aço, de revestimento de poços, de suprimento ou de produção, dos tipos utilizados na extração de petróleo ou gás','Casing and tubing of a kind used in drilling for oil or gas, welded, of flat-rolled products of iron or steel, of an external diameter of <= 406,4 mm (excl. products of stainless steel or of cast iron)','Los demás tubos , de hierro o acero, de entubación "casing" o de producción "tubing" de los tipos utilizados para la extracción de petróleo o gas ',73,7306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730630,'Outros tubos, soldados, de seção circular, de ferro ou de aço não ligados','Tubes, pipes and hollow profiles, welded, of circular cross-section, of iron or non-alloy steel (excl. products having internal and external circular cross-sections and an external diameter of > 406,4 mm, or line pipe of a kind used for oil or gas pipelin','Tubos y perfiles huecos, soldados, de sección circular, de hierro o acero sin alear (exc. tubos de secciones interior y exterior circulares y diámetro exterior > 406,4 mm, así como tubos de los tipos utilizados en oleoductos y gasoductos o para la extracc',73,7306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730640,'Outros tubos de aços inoxidáveis, soldados, de seção circular','Tubes, pipes and hollow profiles, welded, of circular cross-section, of stainless steel (excl. products having internal and external circular cross-sections and an external diameter of > 406,4 mm, and products of a kind used for oil or gas pipelines or of','Tubos y perfiles huecos, soldados, de sección circular, de acero inoxidable (exc. tubos de secciones interior y exterior circulares y diámetro exterior > 406,4 mm, así como tubos de los tipos utilizados en oleoductos y gasoductos o para la extracción de p',73,7306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730650,'Outros tubos de outras ligas de aços, soldados, de seção circular','Tubes, pipes and hollow profiles, welded, of circular cross-section, of alloy steel other than stainless (excl. tubes and pipes having internal and external circular cross-sections and an external diameter of > 406,4 mm, and line pipe of a kind used for o','Tubos y perfiles huecos, soldados, de sección circular, de aceros aleados distinto del acero inoxidable (exc. tubos de secciones interior y exterior circulares y diámetro exterior > 406,4 mm y tubos de los tipos utilizados en oleoductos y gasoductos o par',73,7306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730660,'outros tubos de ferro/aço,  sold.sec.n/circ.','other pipes of iron/steel, welded, n/circular','otros tubos de hierro/acero, sold.excep.sec.circ.',73,7306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730661,'Outros tubos e perfis ocos soldados, de ferro ou aço, de seção quadrada ou retangular','Tubes and pipes and hollow profiles, welded, of square or rectangular cross-section, of iron or steel','Tubos y perfiles huecos, soldados, de sección cuadrada o rectangular, en hierro o en acero',73,7306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730669,'Outros tubos soldados e perfis ocos, de ferro ou aço, de seção não circular (exceto quadrada ou retangular)','Tubes, pipes and hollow profiles, welded, of non-circular cross-section, of iron or steel (excl. tubes and pipes having internal and external circular cross-sections and an external diameter of > 406,4 mm, line pipe of a kind used for oil or gas pipelines','Tubos y perfiles huecos, soldados, de sección no circular, en hierro o en acero (otros que tubos a secciones interiores o exteriores circulares y de diámetro exterior > 406,4 mm., excepto tubos de los tipos utilizados para oleoductos o gaseoductos o para ',73,7306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730690,'Outros tubos e perfis ocos, de ferro ou aço, soldados, rebitados, agrafados','Tubes, pipes and hollow profiles e.g., open seam, riveted or similarly closed, of iron or steel (excl. of cast iron, seamless or welded tubes and pipes and tubes and pipes having internal and external circular cross-sections and an external diameter of > ','Tubos y perfiles huecos, remachados, grapados o con los bordes simplemente aproximados, de hierro o acero (exc. tubos soldados y tubos de secciones interior y exterior circulares y diámetro exterior > 406,4 mm)',73,7306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730711,'Acessórios moldados para tubos, de ferro fundido não maleável','Tube or pipe fittings of non-malleable cast iron','Accesorios de tubería, de fundición no maleable',73,7307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730719,'Outros acessórios moldados para tubos, de ferro fundido, ferro ou aço','Cast tube or pipe fittings of iron or steel (excl. products of non-malleable cast iron)','Accesorios de tubería, de fundición, hierro o acero, moldeados (exc. de fundición no maleable)',73,7307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730721,'Flanges para tubos, de aços inoxidáveis','Flanges of stainless steel (excl. cast products)','Bridas de tubería, de acero inoxidable (exc. moldeadas)',73,7307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730722,'Cotovelos, curvas e luvas (mangas), roscados, para tubos, de aços inoxidáveis','Threaded elbows, bends and sleeves of stainless steel (excl. cast products)','Codos, curvas y manguitos de tubería, de acero inoxidable, roscados (exc. moldeados)',73,7307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730723,'Acessórios para soldar topo a topo, de aços inoxidáveis','Butt welding tube or pipe fittings of stainless steel (excl. cast products)','Accesorios de tubería para soldar a tope, de acero inoxidable (exc. moldeados)',73,7307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730729,'Outros acessórios para tubos, de aços inoxidáveis','Tube or pipe fittings of stainless steel (excl. cast products, flanges, threaded elbows, bends and sleeves and butt weldings fittings)','Accesorios de tubería, de acero inoxidable (exc. moldeados, así como codos, curvas y manguitos roscados, bridas y accesorios para soldar a tope)',73,7307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730791,'Outros flanges para tubos, de ferro fundido, ferro ou aço','Flanges of iron or steel (excl. cast or stainless products)','Bridas de tubería, de hierro o acero (exc. moldeadas o de acero inoxidable)',73,7307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730792,'Outros cotovelos, curvas e luvas (mangas), roscados, para tubos, de ferro fundido, ferro ou aço','Threaded elbows, bends and sleeves, of stainless steel (excl. cast or stainless products)','Codos, curvas y manguitos de tubería, de hierro o acero, roscados (exc. moldeados o de acero inoxidable)',73,7307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730793,'Outros acessórios para soldar topo a topo, de ferro fundido, ferro ou aço','Butt welding fittings of iron or steel (excl. cast iron or stainless steel products, and flanges)','Accesorios de tubería, de hierro o acero, para soldar a tope (exc. moldeados o de acero inoxidable, así como bridas)',73,7307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730799,'Outros acessórios para tubos, de ferro fundido, ferro ou aço','Tube or pipe fittings, of iron or steel (excl. cast iron or stainless steel products; flanges; threaded elbows, bends and sleeves; butt welding fittings)','Accesorios de tubería, de hierro o acero (exc. moldeados o de acero inoxidable, así como codos, curvas y manguitos roscados, bridas y accesorios para soldar a tope)',73,7307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730810,'Pontes e elementos de pontes, de ferro fundido, ferro ou aço','Bridges and bridge-sections, of iron or steel','Puentes y partes de puentes, de fundición, hierro o acero',73,7308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730820,'Torres e pórticos, de ferro fundido, ferro ou aço','Towers and lattice masts, of iron or steel','Torres y castilletes, de fundición, hierro o acero',73,7308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730830,'Portas e janelas, e seus caixilhos, alizares e soleiras, de ferro fundido, ferro ou aço','Doors, windows and their frames and thresholds for doors, of iron or steel','Puertas, ventanas y sus marcos, contramarcos y umbrales, de fundición, hierro o acero',73,7308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730840,'Material para andaimes, armações e escoramentos, de ferro fundido, ferro ou aço','Equipment for scaffolding, shuttering, propping or pit-propping (excl. composite sheetpiling products and formwork panels for poured-in-place concrete, which have the characteristics of moulds)','Material de andamiaje, encofrado, apeo o apuntalamiento, de fundición, hierro o acero (exc. tablestacas hechas con elementos ensamblados y paneles de encofrado para hormigón con características de molde)',73,7308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730890,'Construções e suas partes, de ferro fundido, ferro ou aço','Structures and parts of structures, of iron or steel, n.e.s. (excl. bridges and bridge-sections, towers and lattice masts, doors and windows and their frames, thresholds for doors, props and similar equipment for scaffolding, shuttering, propping or pit-p','Construcciones y partes de construcciones, de fundición, hierro o acero (exc. puentes y partes de puentes; torres y castilletes; puertas, ventanas y sus marcos, contramarcos y umbrales; material de andamiaje, encofrado, apeo o apuntalamiento)',73,7308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (730900,'Reservatórios, tonéis, cubas e recipientes semelhantes, de ferro fundido, ferro ou aço, de capacidade > 300 litros, sem dispositivos mecânicos nem térmicos','Reservoirs, tanks, vats and similar containers, of iron or steel, for any material other than compressed or liquefied gas, of a capacity of > 300 l, not fitted with mechanical or thermal equipment, whether or not lined or heat-insulated (excl. containers ','Depósitos, cisternas, cubas y recipientes simil., de fundición, hierro o acero, para cualquier materia, de capacidad > 300 l, sin dispositivos mecánicos ni térmicos, incl. con revestimiento interior o calorífugo (exc. contenedores especialmente concebidos',73,7309);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731010,'Reservatórios, barris, tambores, caixas e recipientes semelhantes, de ferro fundido, ferro ou aço, sem dispositivos mecânicos nem térmicos, de capacidade => 50 litros e <= 300 litros','Tanks, casks, drums, cans, boxes and similar containers, of iron or steel, for any material, of a capacity of >= 50 l but <= 300 l, n.e.s. (excl. containers for compressed or liquefied gas, or containers fitted with mechanical or thermal equipment)','Depósitos, barriles, tambores, bidones, latas o botes, cajas y recipientes simil., de fundición, hierro o acero, para cualquier materia, de capacidad >= 50 l pero <= 300 l, n.c.o.p. (exc. recipientes para gas comprimido o licuado o recipientes con disposi',73,7310);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731021,'Latas de ferro fundido, ferro ou aço, para fechar por soldadura ou cravação, de capacidade < 50 litros','Cans of iron or steel, of a capacity of < 50 l, which are to be closed by soldering or crimping (excl. containers for compressed or liquefied gas)','Latas o botes, de fundición, hierro o acero, de capacidad < 50 l, para cerrar por soldadura o rebordeado (exc. para gas comprimido o licuado)',73,7310);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731029,'Outros reservatórios e semelhantes, de ferro fundido, ferro ou aço, de capacidade < 50 litros','Tanks, casks, drums, cans, boxes and similar containers, of iron or steel, for any material, of a capacity of < 50 l, n.e.s. (excl. containers for compressed or liquefied gas, or containers fitted with mechanical or thermal equipment, and cans which are t','Depósitos, barriles, tambores, bidones y recipientes simil., de fundición, hierro o acero, para cualquier materia, de capacidad < 50 l, n.c.o.p. (exc. recipientes para gas comprimido o licuado o recipientes con dispositivos mecánicos o térmicos, así como ',73,7310);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731100,'Recipientes para gases comprimidos ou liquefeitos, de ferro fundido, ferro ou aço','Containers of iron or steel, for compressed or liquefied gas (excl. containers specifically constructed or equipped for one or more types of transport)','Recipientes de fundición, hierro o acero, para gas comprimido o licuado (exc. contenedores especialmente concebidos y equipados para uno o varios medios de transporte)',73,7311);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731210,'Cordas e cabos, de ferro ou aço, não isolados para usos elétricos','Stranded wire, ropes and cables, of iron or steel (excl. electrically insulated products and twisted fencing wire and barbed wire)','Cables, de hierro o acero (exc. artículos aislados para electricidad, así como alambre con púas y alambre torcido para cercar)',73,7312);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731290,'Tranças, lingas e artefatos semelhantes, de ferro ou aço, não isolados para usos elétricos','Plaited bands, slings and the like, of iron or steel (excl. electrically insulated products)','Eslingas y artículos simil., de hierro o acero (exc. artículos aislados para electricidad)',73,7312);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731300,'Arame farpado, arames ou tiras retorcidos, de ferro ou aço, dos tipos utilizados em cercas','Barbed wire of iron or steel; twisted hoop or single flat wire, barbed or not, and loosely twisted double wire, of a kind used for fencing, of iron or steel','Alambre de púas, de hierro o acero; alambre "simple o doble" y fleje, torcidos, incl. con púas, de hierro o acero, del tipo utilizado para cercar',73,7313);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731412,'Telas metálicas tecidas, de aços inoxidáveis, contínuas ou sem fim, para máquinas','Endless bands of stainless steel wire, for machinery','Telas metálicas tejidas, continuas o sin fin, de acero inoxidable, para máquinas',73,7314);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731413,'outs.telas metal.tecid.de ferro/aço,  contin.s/fim,  p/maqs','oth.woven cloth, of iron/steel, endless bands f/machin.','ots.telas met.tejidas, de hierro/acer.cont., s/fin.p/maqs',73,7314);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731414,'Outras telas metálicas tecidas, de aços inoxidáveis','Woven cloth, incl. endless bands, of stainless steel wire (excl. woven products of metal fibres of a kind used for cladding, lining or similar purposes and endless bands for machinery)','Telas metálicas tejidas, incl. las continuas o sin fin, de acero inoxidable (exc. tejidos de hilos de metal, de los tipos utilizados para prendas de vestir, mobiliario o usos simil., así como las telas continuas o sin fin para máquinas)',73,7314);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731419,'Outras telas metálicas tecidas, de fios de ferro ou aço','Woven cloth, incl. endless bands, of iron or steel wire (excl. stainless and woven products of metal fibres of a kind used for cladding, lining or similar purposes)','Telas metálicas tejidas, incl. las continuas o sin fin, de hierro o acero distinto del acero inoxidable (exc. tejidos de hilos de metal, de los tipos utilizados para prendas de vestir, mobiliario o usos simil., así como las telas continuas o sin fin para ',73,7314);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731420,'Grades e redes soldadas nos pontos de interseção, de fios de ferro ou aço => 3 mm na maior dimensão do corte transversal, com malha de superfície => 100 cm2','Grill, netting and fencing, welded at the intersection, having a mesh size of >= 100 cm², of iron or steel wire with a maximum cross-sectional dimension of >= 3 mm','Redes y rejas, de alambre de hierro o acero, soldados en los puntos de cruce, de alambre cuya mayor dimensión de la sección transversal sea >= 3 mm y con mallas de superficie >= 100 cm²',73,7314);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731431,'Grades e redes, de fios de ferro ou aço, soldadas nos pontos de interseção, galvanizadas','Grill, netting and fencing, of iron or steel wire, welded at the intersection, plated or coated with zinc (excl. products of wire with a maximum cross-sectional dimension of >= 3 mm and having a mesh size of >= 100 cm²)','Redes y rejas, de alambre de hierro o acero, soldados en los puntos de cruce, cincados (exc. de alambre cuya mayor dimensión de la sección transversal sea >= 3 mm y con mallas de superficie >= 100 cm²)',73,7314);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731439,'Outras grades e redes, de fios de ferro ou aço, soldadas nos pontos de interseção','Grill, netting and fencing, of iron or steel wire, welded at the intersection (excl. products of wire with a maximum cross-sectional dimension of >= 3 mm and having a mesh size of >= 100 cm², and grill, netting and fencing plated or coated with zinc)','Redes y rejas, de alambre de hierro o acero, soldados en los puntos de cruce (exc. cincados, así como enrejadas de alambre cuya mayor dimensión de la sección transversal sea >= 3 mm y con mallas de superficie >= 100 cm²)',73,7314);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731441,'Outras telas metálicas, grades e redes, de fios de ferro ou aço, galvanizadas','Grill, netting and fencing, of iron or steel wire, not welded at the intersection, plated or coated with zinc','Telas metálicas, redes y rejas, de alambre de hierro o acero, sin soldar en los puntos de cruce, cincados',73,7314);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731442,'Outras telas metálicas, grades e redes, de fios de ferro ou aço, recobertas de plásticos','Grill, netting and fencing, of iron or steel wire, not welded at the intersection, coated with plastics','Telas metálicas, redes y rejas, de alambre de hierro o acero, sin soldar en los puntos de cruce, revestidas de plástico',73,7314);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731449,'Outras telas metálicas, grades e redes, de fios de ferro ou aço','Grill, netting and fencing, of iron or steel wire, not welded at the intersection (excl. plated or coated with zinc or coated with plastics)','Telas metálicas, redes y rejas, de alambre de hierro o acero, sin soldar en los puntos de cruce (exc. cincados o revestidas de plástico)',73,7314);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731450,'Chapas e tiras, distendidas, de ferro ou aço','Expanded metal, of iron or steel','Chapas y tiras, extendidas "desplegadas", de hierro o acero',73,7314);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731511,'Correntes de rolos, de ferro fundido, ferro ou aço','Roller chain of iron or steel','Cadenas de rodillos, de fundición, hierro o acero',73,7315);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731512,'Outras correntes de elos articulados, de ferro fundido, ferro ou aço','Articulated link chain of iron or steel (excl. roller chain)','Cadenas de eslabones articulados, de fundición, hierro o acero (exc. las de rodillos)',73,7315);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731519,'Partes de correntes de elos articulados, de ferro fundido ou aço','Parts of articulated link chain, of iron or steel','Partes de cadenas de eslabones articulados, de fundición, hierro o acero',73,7315);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731520,'Correntes antiderrapantes, de ferro fundido, ferro ou aço','Skid chain for motor vehicles, of iron or steel','Cadenas antideslizantes para vehículos, de fundición, hierro o acero',73,7315);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731581,'Correntes de elos com suporte, de ferro fundido, ferro ou aço','Stud-link of iron or steel','Cadenas de eslabones con contrete "travesaño", de fundición, hierro o acero',73,7315);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731582,'Correntes de elos soldados, de ferro fundido, ferro ou aço','Welded link chain of iron or steel (excl. articulated link chain, skid chain and stud-link chain)','Cadenas de fundición, hierro o acero, de eslabones soldados (exc. cadenas de dispositivos de seguridad para cerrar puertas)',73,7315);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731589,'Outras correntes e cadeias, de ferro fundido, ferro ou aço','Chain of iron or steel (excl. articulated link chain, skid chain, stud-link chain, welded link chain and parts thereof; watch chains, necklace chains and the like, cutting and saw chain, skid chain, scraper chain for conveyors, toothed chain for textile m','Cadenas de fundición, hierro o acero (exc. cadenas de eslabones articulados, antideslizantes, de eslabones con contrete "travesaño", de eslabones soldados y sus partes; cadenas de reloj, cadenas de joyería, etc.; cadenas cortantes; orugas para vehículos; ',73,7315);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731590,'Partes de outras correntes e cadeias, de ferro ou aço','Parts of skid chain, stud-link chain and other chains of heading 7315 (excl. articulated link chain)','Partes de cadenas antideslizantes, cadenas de eslabones con contrete "travesaño" y demás cadenas de la partida 7315 (exc. de cadenas con eslabones articulados)',73,7315);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731600,'Âncoras, fateixas e suas partes, de ferro fundido, ferro ou aço','Anchors, grapnels and parts thereof, of iron or steel','Anclas, rezones y sus partes, de fundición, hierro o acero',73,7316);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731700,'Tachas, pregos, percevejos e artefatos semelhantes, de ferro fundido, ferro ou aço','Nails, tacks, drawing pins, corrugated nails, staples and similar articles of iron or steel, whether or not with heads of other material (excl. such articles with heads of copper and staples in strips)','Puntas, clavos, chinchetas "chinches", grapas apuntadas, onduladas o biseladas, y artículos simil., de fundición, hierro o acero, incl. con cabeza de otras materias (exc. con cabeza de cobre, así como las grapas en tiras)',73,7317);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731811,'Tira-fundos (roscados), de ferro fundido, ferro ou aço','Coach screws of iron or steel','Tirafondos, de fundición, hierro o acero',73,7318);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731812,'Outros parafusos para madeira, de ferro fundido, ferro ou aço','Wood screws of iron or steel (excl. coach screws)','Tornillos para madera, de fundición, hierro o acero (exc. tirafondos)',73,7318);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731813,'Ganchos e armelas (pitões), de ferro fundido, ferro ou aço','Screw hooks and screw rings, of iron or steel','Escarpias y armellas, roscadas, de fundición, hierro o acero',73,7318);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731814,'Parafusos perfurantes, de ferro fundido, ferro ou aço','Self-tapping screws, of iron or steel (excl. wook screws)','Tornillos taladradores, de fundición, hierro o acero (exc. tornillos para madera)',73,7318);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731815,'Outros parafusos e pinos ou pernos, mesmo com as porcas e arruelas, de ferro fundido, ferro ou aço','Threaded screws and bolts, of iron or steel, whether or not with their nuts and washers (excl. coach screws and other wood screws, screw hooks and screw rings, self-tapping screws, lag screws, stoppers, plugs and the like, threaded)','Tornillos y pernos, roscados, de fundición, hierro o acero, incl. con sus tuercas y arandelas (exc. tirafondos y demás tornillos para madera; escarpias y armellas, roscadas; tornillos taladradores; clavos-tornillo, tapones metálicos roscados y sobretapas ',73,7318);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731816,'Porcas de ferro fundido, ferro ou aço','Nuts of iron or steel','Tuercas, de fundición, hierro o acero',73,7318);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731819,'Outros artefatos roscados, de ferro fundido, ferro ou aço','Threaded articles, of iron or steel, n.e.s.','Elementos y dispositivos de fijación, roscados, de fundición, hierro o acero, n.c.o.p.',73,7318);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731821,'Arruelas de pressão e de segurança, não roscadas, de ferro fundido, ferro ou aço','Spring washers and other lock washers, of iron or steel','Arandelas de muelle "resorte" y las demás de seguridad, de fundición, hierro o acero',73,7318);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731822,'Outras arruelas de ferro fundido, ferro ou aço','Washers of iron or steel (excl. spring washers and other lock washers)','Arandelas, de fundición, hierro o acero (exc. de muelle "resorte" y las demás de seguridad)',73,7318);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731823,'Rebites de ferro fundido, ferro ou aço','Rivets of iron or steel (excl. tubular and bifurcated rivets for particular uses)','Remaches, de fundición, hierro o acero (exc. remaches tubulares o con espiga hendida, para cualquier uso)',73,7318);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731824,'Chavetas, cavilhas e contrapinos ou troços, de ferro fundido, ferro ou aço','Cotters and cotter pins, of iron or steel','Pbarcacoas "parrillas", clavijas o chavetas, de fundición, hierro o acero',73,7318);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731829,'Outros artefatos não roscados, de ferro fundido, ferro ou aço','Non-threaded articles, of iron or steel','Elementos y dispositivos de fijación, sin roscar, de fundición, hierro o acero, n.c.o.p.',73,7318);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731910,'Agulhas de costura, cerzir ou bordar, de ferro ou aço','Sewing, darning or embroidery needles, of iron or steel','Agujas de coser, zurcir o bordar, de hierro o acero',73,7319);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731920,'Alfinetes de segurança, de ferro ou aço','Safety pins of iron or steel','Alfileres de gancho "imperdibles", de hierro o acero',73,7319);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731930,'Outros alfinetes de uso manual, de ferro ou aço','Pins of iron or steel, n.e.s.','Alfileres, de hierro o acero, n.c.o.p.',73,7319);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731940,'Alfinetes de segurança e outros alfinetes','Safety pins and other pins','Imperdibles y otros alfileres',73,7319);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (731990,'Agulhas de costura, de tricô, de crochê, agulhas-passadoras, furadores para bordar e artefatos semelhantes para uso manual, de ferro ou aço','Knitting needles, bodkins, crochet hooks, embroidery stilettos and similar articles, of iron or steel','Agujas de tejer, pasacintas, agujas de ganchillo "croché", punzones para bordar y artículos simil., de uso manual, de hierro o acero (exc. agujas de coser, zurcir o bordar)',73,7319);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732010,'Molas de folhas e suas folhas, de ferro ou aço','Leaf-springs and leaves therefor, of iron or steel (excl. clock and watch springs and shock absorbers and torque rod or torsion bar springs of Section 17)','Ballestas y sus hojas, de hierro o acero (exc. muelles de relojería y barras de torsión de la sección XVII)',73,7320);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732020,'Molas helicoidais de ferro ou aço','Helical springs, of iron or steel (excl. flat spiral springs, clock and watch springs, springs for sticks and handles of umbrellas or parasols, and shock absorbers of Section 17)','Muelles "resortes" helicoidales, de hierro o acero (exc. resortes espirales planos, muelles de relojería, muelles para astiles o mangos de paraguas o de sombrillas y amortiguadores de la sección XVII)',73,7320);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732090,'Outras molas de ferro ou aço','Springs and leaves for springs, of iron or steel, incl. flat spiral springs (excl. helical springs, spiral springs, leaf-springs and leaves therefor, clock and watch springs, spring washers and other lock washers and shock absorbers and torque rod or tors','Muelles "resortes" y sus hojas, de hierro o acero, incl. los resortes espirales planos (exc. muelles helicoidales, ballestas y sus hojas, muelles de relojería, arandelas abiertas y demás arandelas de muelle "resorte", amortiguadores y barras de torsión de',73,7320);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732111,'Aparelhos para cozinhar e aquecedores de pratos, de uso doméstico, de ferro fundido, ferro ou aço, a combustíveis gasosos ou a gás e outros combustíveis','Appliances for baking, frying, grilling and cooking and plate warmers, for domestic use, of iron or steel, for gas fuel or for both gas and other fuels (excl. large cooking appliances)','Aparatos de cocción y calientaplatos, de uso doméstico, de fundición, hierro o acero, de combustibles gaseosos o de gas y otros combustibles (exc. aparatos para cocinas industriales)',73,7321);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732112,'Aparelhos para cozinhar e aquecedores de pratos, de uso doméstico, de ferro fundido, ferro ou aço, a combustíveis líquidos','Appliances for baking, frying, grilling and cooking and plate warmers, for domestic use, of iron or steel, for liquid fuel (excl. large cooking appliances)','Aparatos de cocción y calientaplatos, de uso doméstico, de fundición, hierro o acero, de combustibles líquidos (exc. aparatos para cocinas industriales)',73,7321);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732113,'aparelhos p/cozinhar/aquecer,  de ferro,  etc.combustiv.sol','cooking/warmers appliances, of iron, etc.solid fuels','aparatos p/cocción/calefac., de hierro, etc.combust.sól.',73,7321);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732119,'Outros aparelhos para cozinhar e aquecedores de pratos, de uso doméstico, de ferro fundido, ferro ou aço, não elétricos, incluídos os aparelhos a combustíveis sólidos','Appliances for baking, frying, grilling and cooking and plate warmers, for domestic use, of iron or steel, for solid fuel or other source of energy (excl. liquid or gaseous fuel, and large cooking appliances)','Los demás aparatos de cocción y calientaplatos, de uso doméstico, de fundición, hierro o acero, incluidos los aparatos de combustibles sólidos',73,7321);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732181,'Aquecedores de ambientes (fogões de sala) e caldeiras de fornalha, de uso doméstico, de ferro fundido, ferro ou aço, a combustíveis gasosos ou a gás','Stoves, heaters, grates, fires, wash boilers, braziers and similar appliances, of iron or steel, for gas fuel or for both gas and other fuels (excl. cooking appliances, whether or not with oven, separate ovens, plate warmers, central heating boilers, geys','Estufas, calderas con hogar para la colada, braseros y apararatos simil. de uso doméstico, de fundición, hierro o acero, de combustibles gaseosos o de gas y otros combustibles (exc. aparatos de cocción, incl. con horno, hornos separados, calientaplatos, c',73,7321);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732182,'Aquecedores de ambientes (fogões de sala) e caldeiras de fornalha, de uso doméstico, de ferro fundido, ferro ou aço, a combustíveis líquidos','Stoves, heaters, grates, fires, wash boilers, braziers and similar appliances, of iron or steel, for liquid fuel (excl. cooking appliances, whether or not with oven, separate ovens, plate warmers, central heating boilers, geysers, hot water cylinders and ','Estufas, calderas con hogar para la colada, braseros y apararatos simil. de uso doméstico, de fundición, hierro o acero, de combustibles líquidos (exc. aparatos de cocción, incl. con horno, hornos separados, calientaplatos, calderas de calefacción central',73,7321);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732183,'outros aquecedores,  etc.de ferro/aço,  a combustiv.sólidos','other heaters, etc.of iron/steel, for solid fuels','los dem.calent.etc.de hierro/acero, de combustib.sól',73,7321);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732189,'Outros aquecedores de ambientes (fogões de sala) e caldeiras de fornalha, de uso doméstico, de ferro fundido, ferro ou aço, não elétricos, incluídos os aparelhos a combustíveis sólidos','Stoves, heaters, grates, fires, wash boilers, braziers and similar appliances, of iron or steel, for solid fuel or other source of energy (excl. liquid or gaseous fuel, and cooking appliances, whether or not with oven, separate ovens, plate warmers, centr','Las demás estufas, calderas con hogar para la colada, braseros y apararatos simil. de uso doméstico, de fundición, hierro o acero, incluidos los aparatos de combustibles sólidos',73,7321);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732190,'Partes de aparelhos para cozinhar e de aquecedores de ambientes, de uso doméstico, de ferro fundido, ferro ou aço, não elétricos','Parts of domestic appliances non-electrically heated of heading 7321, n.e.s.','Partes de los aparatos de calentamiento no eléctrico y de uso doméstico de la partida 7321, n.c.o.p.',73,7321);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732211,'Radiadores para aquecimento central e suas partes, não elétricos, de ferro fundido','Radiators for central heating, non-electrically heated, and parts thereof, of iron or steel (excl. parts, elsewhere specified or included, and central-heating boilers)','Radiadores para la calefacción central, de calentamiento no eléctrico, y sus partes, de fundición (exc. partes clasificadas en otra parte y calderas para la calefacción central)',73,7322);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732219,'Radiadores para aquecimento central e suas partes, não elétricos, de ferro e aço','Radiators for central heating, non-electrically heated, and parts thereof, of iron other than cast iron or steel (excl. parts, elsewhere specified or included, and central-heating boilers)','Radiadores para la calefacción central, de calentamiento no eléctrico, y sus partes, de hierro o acero (exc. de fundición, así como las partes clasificadas en otra parte y las calderas para la calefacción central)',73,7322);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732290,'Geradores e distribuidores de ar quente e suas partes, não elétricos, de ferro fundido, ferro ou aço','Air heaters and hot-air distributors, incl. distributors which can also distribute fresh or conditioned air, non-electrically heated, incorporating a motor-driven fan or blower, and parts thereof, of iron or steel','Generadores y distribuidores de aire caliente, incl. los distribuidores que puedan funcionar también como distribuidores de aire fresco o acondicionado, de calentamiento no eléctrico, que lleven un ventilador o un soplador con motor, y sus partes, de fund',73,7322);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732310,'Palha de ferro ou aço; esponjas, esfregões, luvas e artefatos semelhantes para limpeza ou polimento','Iron or steel wool; pot scourers and scouring or polishing pads, gloves and the like, of iron or steel','Lana de hierro o acero; esponjas, estropajos, guantes y artículos simil. para fregar, lustrar o usos análogos, de hierro o acero',73,7323);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732391,'Outros artefatos de uso doméstico e suas partes, de ferro fundido, não esmaltados','Table, kitchen or other household articles, and parts thereof, of cast iron, not enamelled (excl. cans, boxes and similar containers of heading 7310; waste baskets; shovels, corkscrews and other articles of the nature of a work implement; articles of cutl','Artículos de uso doméstico y sus partes, de fundición, sin esmaltar (exc. bidones, latas o botes, cajas y recipientes simil. de la partida 7310; papeleras; moldes para obleas y demás artículos con carácter de herramientas; cucharas, cucharones, etc. de la',73,7323);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732392,'Outros artefatos de uso doméstico e suas partes, de ferro fundido, esmaltados','Table, kitchen or other household articles, and parts thereof, of cast iron, enamelled (excl. cans, boxes and similar containers of heading 7310; waste baskets; shovels, corkscrews and other articles of the nature of a work implement; articles of cutlery,','Artículos de uso doméstico y sus partes, de fundición, esmaltados (exc. bidones, cajas y recipientes simil. de la partida 7310; papeleras; palas y demás artículos con carácter de herramientas; cucharas, cucharones, etc. de la partida 8215; objetos de ador',73,7323);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732393,'Outros artefatos de uso doméstico e suas partes, de aços inoxidáveis','Table, kitchen or other household articles, and parts thereof, of stainless steel (excl. cans, boxes and similar containers of heading 7310; waste baskets; shovels, corkscrews and other articles of the nature of a work implement; articles of cutlery, spoo','Artículos de uso doméstico y sus partes, de acero inoxidable (exc. bidones, latas o botes, cajas y recipientes simil. de la partida 7310; papeleras; palas, sacacorchos y demás artículos con carácter de herramientas; artículos de cuchillería, así como las ',73,7323);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732394,'Outros artefatos de uso doméstico e suas partes, de ferro ou aço, esmaltados','Table, kitchen or other household articles, and parts thereof, of iron other than cast iron or steel other than stainless, enamelled (excl. cans, boxes and similar containers of heading 7310; waste baskets; shovels, corkscrews and other articles of the na','Artículos de uso doméstico y sus partes, de hierro o acero distinto del acero inoxidable, esmaltados (exc. bidones, cajas y recipientes simil. de la partida 7310; papeleras; palas y demás artículos con carácter de herramientas; cucharas, cucharones, etc. ',73,7323);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732399,'Outros artefatos de uso doméstico e suas partes, de ferro fundido, ferro ou aço','Table, kitchen or other household articles, and parts thereof, of iron other than cast iron or steel other than stainless (excl. enamelled articles; cans, boxes and similar containers of heading 7310; waste baskets; shovels and other articles of the natur','Artículos de uso doméstico y sus partes, de hierro o acero distinto del acero inoxidable (exc. artículos esmaltados; bidones, latas o botes, cajas y recipientes simil. de la partida 7310; papeleras; palas, sacacorchos y demás artículos con carácter de her',73,7323);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732410,'Pias e lavatórios, de aços inoxidáveis','Sinks and washbasins, of stainless steel','Fregaderos "piletas para lavar" y lavabos, de acero inoxidable',73,7324);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732421,'Banheiras de ferro fundido, mesmo esmaltadas','Baths of cast iron, whether or not enamelled','Bañeras de fundición, incl. esmaltadas',73,7324);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732429,'Outras banheiras de ferro ou aço','Baths of steel sheet','Bañeras de chapa de acero',73,7324);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732490,'Outros artefatos de higiene ou de toucador e suas partes, de ferro fundido, ferro ou aço','Sanitary ware, incl. parts thereof (excl. cans, boxes and similar containers of heading 7310, small wall cabinets for medical supplies or toiletries and other furniture of chapter 94, and fittings, complete sinks and washbasins, of stainless steel, comple','Artículos de higiene o tocador, y sus partes, de fundición, hierro o acero (exc. bidones, latas o botes, cajas y recipientes simil. de la partida 7310, pequeños armarios de farmacia o de tocador para colgar y demás muebles del capítulo 94, fregaderos y la',73,7324);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732510,'Outras obras moldadas, de ferro fundido, não maleável','Articles of iron or steel, of non-malleable cast iron, n.e.s.','Manufacturas moldeadas, de fundición no maleable, de hierro o acero, n.c.o.p.',73,7325);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732591,'Esferas e artefatos semelhantes, para moinhos, moldadas, de ferro fundido, ferro ou aço','Grinding balls and similar articles for mills, cast (excl. such articles of non-malleable cast iron)','Bolas y artículos simil. para molinos, moldeados (exc. de fundición no maleable)',73,7325);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732599,'Outras obras moldadas, de ferro fundido, ferro ou aço','Cast articles of iron or steel, n.e.s. (excl. articles of non-malleable cast iron, and grinding balls and similar articles for mills)','Manufacturas moldeadas, de fundición, hierro o acero, n.c.o.p. (exc. de fundición no maleable, así como bolas y artículos simil. para molinos)',73,7325);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732611,'Esferas e artefatos semelhantes, para moinhos, forjadas ou estampadas, de ferro ou aço','Grinding balls and similar articles for mills, of iron or steel, forged or stamped, but not further worked','Bolas y artículos simil. para molinos, de hierro o acero, forjadas o estampadas pero sin trabajar de otro modo',73,7326);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732619,'Outras obras forjadas ou estampadas, de ferro ou aço','Articles of iron or steel, forged or stamped, but not further worked, n.e.s. (excl. grinding balls and similar articles for mills)','Manufacturas de hierro o acero, forjadas o estampadas pero sin trabajar de otro modo, n.c.o.p. (exc. bolas y artículos simil. para molinos)',73,7326);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732620,'Obras de fios de ferro ou aço','Articles of iron or steel wire, n.e.s.','Manufacturas de alambre de hierro o acero, n.c.o.p.',73,7326);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (732690,'Outras obras de ferro ou aço','Articles of iron or steel, n.e.s. (excl. cast articles or articles of iron or steel wire)','Manufacturas de hierro o acero, n.c.o.p. (exc. moldeadas, o forjadas o estampadas pero sin trabajar de otro modo o de alambre de hierro o acero)',73,7326);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740100,'Mates de cobre, cobre de cementação (precipitado de cobre)','Copper mattes; cement copper precipitated copper','Matas de cobre; cobre de cementación (cobre precipitado)',74,7401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740110,'mates de cobre','copper mattes','matas de cobre',74,7401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740120,'cobre de cementacao (precipitado de cobre)','cement copper (precipitated copper)','cobre de cementación (cobre precipitado)',74,7401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740200,'Cobre não refinado (afinado); ânodos de cobre para refinação (afinação) eletrolítica','Copper, unrefined; copper anodes for electrolytic refining','Cobre sin refinar; ánodos de cobre para refinado electrolítico',74,7402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740311,'Cátodos de cobre refinado e seus elementos, em formas brutas','Copper, refined, in the form of cathodes and sections of cathodes','Cobre refinado en forma de cátodos y de secciones de cátodos',74,7403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740312,'Barras de cobre refinado, para obtenção de fios (wire-bars)','Copper, refined, in the form of wire-bars','Cobre refinado en forma de barras para alambrón "wire-bars"',74,7403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740313,'Palanquilhas de cobre refinado','Copper, refined, in the form of billets','Cobre refinado en forma de tochos',74,7403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740319,'Outros produtos de cobre refinado, em formas brutas','Copper, refined, unwrought (excl. copper in the form of billets, wire-bars, cathodes and sections of cathodes)','Cobre refinado, en bruto (exc. en forma de tochos, de barras para alambrón "wire-bars", de cátodos y de secciones de cátodos)',74,7403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740321,'Ligas de cobre-zinco (latão), em formas brutas','Copper-zinc base alloys brass unwrought','Aleaciones a base de cobre-cinc "latón", en bruto',74,7403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740322,'Ligas de cobre-estanho (bronze), em formas brutas','Copper-tin base alloys bronze unwrought','Aleaciones a base de cobre-estaño "bronce", en bruto',74,7403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740323,'ligas de cobre-niquel/cobre-niquel-zinco, em forma bruta','copper-nickel base alloys/copper-nickel-zinc, unwrought','aleaciones de cobre-níquel/cobre-níquel-cinc, en bruto',74,7403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740329,'Outras ligas de cobre (exceto ligas-mães), em formas brutas','Copper alloys unwrought (excl. copper-zinc base alloys brass, copper-zinc base alloys bronze, and copper alloys of heading 7405)','Aleaciones de cobre, en bruto (exc. a base de cobre-cinc "latón", de cobre-estaño "bronce", de cobre-níquel "cuproníquel" y de cobre- níquel-cinc "alpaca", así como las aleaciones madre de cobre)',74,7403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740400,'Desperdícios e resíduos, de cobre','Waste and scrap, of copper (excl. ingots or other similar unwrought shapes, of remelted copper waste and scrap, ashes and residues containing copper, and waste and scrap of primary cells, primary batteries and electric accumulators)','Desperdicios y desechos, de cobre (exc. lingotes y formas simil. brutas coladas a partir de desperdicios o desechos de cobre refundidos, así como las cenizas y residuos que contengan cobre y los desperdicios y desechos de pilas, de baterías de pilas y de ',74,7404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740500,'Ligas-mães de cobre','Master alloys of copper (excl. phosphorus-copper compounds copper phosphide containing by weight > 15% phosphorus)','Aleaciones madre de cobre (exc. combinaciones de fósforo y de cobre "fosfuros de cobre" con un contenido de fósforo > 15% en peso)',74,7405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740610,'Pós de cobre, de estrutura não lamelar','Copper powders, of non-lamellar structure (excl. grains of copper)','Polvo de estructura no laminar, de cobre (exc. granallas de cobre)',74,7406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740620,'Pós de cobre, de estrutura lamelar; escamas de cobre','Copper powders, of lamellar structure, and flakes of copper (excl. grains of copper and spangles of heading 8308)','Polvo de estructura laminar y escamillas, de cobre (exc. granallas de cobre y lentejuelas de la partida 8308)',74,7406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740710,'Barras e perfis de cobre refinado','Bars, rods and profiles, of refined copper, n.e.s.','Barras y perfiles, de cobre refinado, n.c.o.p.',74,7407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740721,'Barras e perfis de ligas de cobre, à base de cobre-zinco (latão)','Bars, rods and profiles, of copper-zinc base alloys brass, n.e.s.','Barras y perfiles, de aleaciones a base de cobre-cinc "latón", n.c.o.p.',74,7407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740722,'Barras e perfis de ligas de cobre-níquel ou cobre-níquel-zinco','Bars and rods of copper-nickel alloys or copper-nickel-zinc','Barras de aleaciones de cobre-níquel o cobre-níquel-zinc',74,7407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740729,'Outras barras e perfis, de ligas de cobre','Bars, rods and profiles of copper alloys, n.e.s. (excl. such articles of copper-zinc base alloys brass)','Barras y perfiles, de aleaciones de cobre, n.c.o.p. (exc. de aleaciones a base de cobre-cinc "latón", de cobre-níquel "cuproníquel" y de cobre-níquel-cinc "alpaca")',74,7407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740811,'Fios de cobre refinado, com a maior dimensão da seção transversal > 6 mm','Wire of refined copper, with a maximum cross-sectional dimension of > 6 mm','Alambre de cobre refinado, con la mayor dimensión de la sección transversal > 6 mm',74,7408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740819,'Outros fios de cobre refinado','Wire of refined copper, with a maximum cross-sectional dimension of <= 6 mm','Alambre de cobre refinado, con la mayor dimensión de la sección transversal <= 6 mm',74,7408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740821,'Fios de ligas de cobre-zinco (latão)','Wire of copper-zinc base alloys brass','Alambre de aleaciones a base de cobre-cinc "latón"',74,7408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740822,'Fios de ligas de cobre-níquel (cuproníquel) ou de cobre-níquel-zinco (maillechort)','Wire of copper-nickel alloys cupro-nickel or copper-nickel-zinc alloys nickel silver','Alambre de aleaciones a base de cobre-níquel "cuproníquel" o de cobre-níquel-cinc "alpaca"',74,7408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740829,'Outros fios de ligas de cobre','Wire of copper alloys (other than copper-zinc alloys [brass], copper-nickel alloys [cupro-nickel] or copper-nickel-zinc alloys [nickel silver])','Alambre de aleaciones de cobre (exc. de aleaciones a base de cobre-cinc "latón", de cobre-níquel "cuproníquel" y de cobre-níquel-cinc "alpaca")',74,7408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740911,'Chapas e tiras, de cobre refinado, de espessura > 0,15 mm, em rolos','Plates, sheets and strip, of refined copper, in coils, of a thickness of > 0,15 mm (excl. expanded sheet and strip and electrically insulated strip)','Chapas y tiras, de cobre refinado, de espesor > 0,15 mm, enrolladas (exc. chapas y tiras extendidas "desplegadas" y tiras aisladas para electricidad)',74,7409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740919,'Outras chapas e tiras, de cobre refinado, de espessura > 0,15 mm','Plates, sheets and strip, of refined copper, not in coils, of a thickness of > 0,15 mm (excl. expanded sheet and strip and electrically insulated strip)','Chapas y tiras, de cobre refinado, de espesor > 0,15 mm, sin enrollar (exc. chapas y tiras extendidas "desplegadas" y tiras aisladas para electricidad)',74,7409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740921,'Chapas e tiras de ligas à base cobre-zinco, (latão), de espessura > 0,15 mm, em rolos','Plates, sheets and strip, of copper-zinc base alloys brass, of a thickness of > 0,15 mm, in coils (excl. expanded sheet and strip and electrically insulated strip)','Chapas y tiras, de aleaciones a base de cobre-cinc "latón", de espesor > 0,15 mm, enrolladas (exc. chapas y tiras extendidas "desplegadas" y tiras aisladas para electricidad)',74,7409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740929,'Outras chapas e tiras, de ligas de cobre-zinco (latão), de espessura > 0,15 mm','Plates, sheets and strip, of copper-zinc base alloys brass, of a thickness of > 0,15 mm, not in coils (excl. expanded sheet and strip and electrically insulated strip)','Chapas y tiras, de aleaciones a base de cobre-cinc "latón", de espesor > 0,15 mm, sin enrollar (exc. chapas y tiras extendidas "desplegadas" y tiras aisladas para electricidad)',74,7409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740931,'Chapas e tiras de ligas à base de cobre-estanho (bronze), de espessura > 0,15 mm, em rolos','Plates, sheets and strip, of copper-tin base alloys bronze, of a thickness of > 0,15 mm, in coils (excl. expanded sheet and strip and electrically insulated strip)','Chapas y tiras, de aleaciones a base de cobre-estaño "bronce", de espesor > 0,15 mm, enrolladas (exc. chapas y tiras extendidas "desplegadas" y tiras aisladas para electricidad)',74,7409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740939,'Outras chapas e tiras, de ligas à base de cobre-estanho (bronze), de espessura > 0,15 mm','Plates, sheets and strip, of copper-tin base alloys bronze, of a thickness of > 0,15 mm, not in coils (excl. expanded sheet and strip and electrically insulated strip)','Chapas y tiras, de aleaciones a base de cobre-estaño "bronce", de espesor > 0,15 mm, sin enrollar (exc. chapas y tiras extendidas "desplegadas" y tiras aisladas para electricidad)',74,7409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740940,'Chapas e tiras, de ligas à base de cobre-níquel, (cuproníquel) ou de cobre-níquel-zinco (maillechort), de espessura > 0,15 mm','Plates, sheets and strip, of copper-nickel base alloys cupro-nickel or copper-nickel-zinc base alloys nickel silver, of a thickness of > 0,15 mm, not in coils (excl. expanded sheet and strip and electrically insulated strip)','Chapas y tiras, de aleaciones a base de cobre-níquel "cuproníquel" o de cobre-níquel-cinc "alpaca", de espesor > 0,15 mm (exc. chapas y tiras extendidas "desplegadas" y tiras aisladas para electricidad)',74,7409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (740990,'Chapas e tiras, de outras ligas de cobre, de espessura > 0,15 mm','Plates, sheets and strip, of copper alloys, of a thickness of > 0,15 mm (excl. copper-zinc base alloys brass, copper-zinc base alloys bronze, copper-nickel base alloys cupro-nickel, copper-nickel-zinc base alloys nickel silver, and expanded sheet and stri','Chapas y tiras, de aleaciones de cobre, de espesor > 0,15 mm (exc. de aleaciones a base de cobre-cinc "latón", de cobre-estaño "bronce", de cobre-níquel "cuproníquel" o de cobre-níquel-cinc "alpaca", así como chapas y tiras extendidas "desplegadas" y tira',74,7409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741011,'Folhas e tiras, de cobre refinado (afinado), sem suporte, de espessura <= 0,15 mm','Refined copper foil, not backed, of a thickness of <= 0,15 mm (excl. stamping foils of heading 3212, metal yarns and metallised yarns and foil made up as christmas tree decorating material)','Hojas y tiras delgadas, de cobre refinado, sin soporte, de espesor <= 0,15 mm (exc. hojas delgadas para marcado a fuego de la partida 3212, hilos metálicos e hilados metalizados y hojas delgadas acondicionadas como accesorios de árboles de Navidad)',74,7410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741012,'Folhas e tiras, de ligas de cobre, sem suporte, de espessura <= 0,15 mm','Copper alloy foil, not backed, of a thickness of <= 0,15 mm (excl. stamping foils of heading 3212, metal yarns and metallised yarns and foil made up as christmas tree decorating material)','Hojas y tiras delgadas, de aleaciones de cobre, sin soporte, de espesor <= 0,15 mm (exc. hojas delgadas para marcado a fuego de la partida 3212, hilos metálicos e hilados metalizados y hojas delgadas acondicionadas como accesorios de árboles de Navidad)',74,7410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741021,'Folhas e tiras, de cobre refinado (afinado), com suporte, de espessura <= 0,15 mm (excluído o suporte)','Refined copper foil, backed, of a thickness excl. any backing of <= 0,15 mm (excl. stamping foils of heading 3212, metal yarns and metallised yarns and foil made up as christmas tree decorating material)','Hojas y tiras delgadas, de cobre refinado, con soporte, de espesor <= 0,15 mm, sin incluir el soporte (exc. hojas delgadas para marcado a fuego de la partida 3212, hilos metálicos e hilados metalizados y hojas delgadas acondicionadas como accesorios de ár',74,7410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741022,'Folhas e tiras, de ligas de cobre, com suporte, de espessura <= 0,15 mm (excluído o suporte)','Copper alloy foil, backed, of a thickness excl. any backing of <= 0,15 mm (excl. stamping foils of heading 3212, metal yarns and metallised yarns and foil made up as christmas tree decorating material)','Hojas y tiras delgadas, de aleaciones de cobre, con soporte, de espesor <= 0,15 mm, sin incluir el soporte (exc. hojas delgadas para marcado a fuego de la partida 3212, hilos metálicos e hilados metalizados y hojas delgadas acondicionadas como accesorios ',74,7410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741110,'Tubos de cobre refinado (afinado)','Tubes and pipes of refined copper','Tubos de cobre refinado',74,7411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741121,'Tubos de ligas de cobre-zinco (latão)','Tubes and pipes of copper-zinc base alloys brass','Tubos de aleaciones a base de cobre-cinc "latón"',74,7411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741122,'Tubos de ligas de cobre-níquel (cuproníquel) ou de cobre-níquel-zinco (maillechort)','Tubes and pipes of copper-nickel base alloys cupro-nickel or copper-nickel-zinc base alloys nickel silver','Tubos de aleaciones a base de cobre-níquel "cuproníquel" o de cobre-níquel-cinc "alpaca"',74,7411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741129,'Tubos de outras ligas de cobre','Tubes and pipes of copper alloys (excl. copper-zinc base alloys brass, copper-nickel base alloys cupro-nickel and copper-nickel-zinc base alloys nickel silver)','Tubos a base de aleaciones de cobre (exc. de aleaciones a base de cobre-cinc "latón", de cobre-níquel "cuproníquel" o de cobre-níquel- cinc "alpaca")',74,7411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741210,'Acessórios para tubos de cobre refinado (afinado)','Refined copper tube or pipe fittings e.g., couplings, elbows, sleeves','Empalmes "rácores", codos, manguitos y demás accesorios de tubería, de cobre refinado',74,7412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741220,'Acessórios para tubos de ligas de cobre','Copper alloy tube or pipe fittings e.g., couplings, elbows, sleeves','Empalmes "rácores", codos, manguitos y demás accesorios de tubería, de aleaciones de cobre',74,7412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741300,'Cordas, cabos, tranças e semelhantes, de cobre, não isolados para usos elétricos','Stranded wire, cables, plaited bands and the like, of copper (excl. electrically insulated products)','Cables, trenzas y artículos simil., de cobre, sin aislar para electricidad',74,7413);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741420,'Telas metálicas, de fios de cobre','Cloth, of copper wires','Telas metálicas, de alambre de cobre',74,7414);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741490,'grades e redes, de fios de cobre, chapas e tiras, de cobre','grill and netting, of copper wire, plastes, strips, copper','redes y rejas, de alamb.de cobre, chapas y tiras, de cobre',74,7414);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741510,'Tachas, pregos, percevejos, escápulas e artefatos semelhantes, de cobre ou de ferro ou aço com cabeça de cobre','Nails, tacks, drawing pins, staples and similar articles, of copper or with shafts of iron or steel and heads of copper (excl. staples in strips)','Puntas, clavos, chinchetas "chinches", grapas apuntadas y artículos simil., de cobre o con la espiga de hierro o acero y la cabeza de cobre (exc. grapas en tiras)',74,7415);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741521,'Arruelas de cobre','Washers, incl. spring washers and spring lock washers, of copper','Arandelas, incl. las arandelas de muelle "resorte", de cobre',74,7415);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741529,'Outros artefatos não roscados, de cobre','Rivets, cotters, cotter pins and the like, not threaded, of copper (excl. spring washers and spring lock washers)','Pernos, remaches, pasadores, clavijas, chavetas y artículos simil., sin roscar, de cobre (exc. arandelas, incl. las arandelas de muelle "resorte")',74,7415);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741531,'parafusos de cobre, para madeira','screws of copper, for wood','tornillos de cobre, para madera',74,7415);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741532,'outros parafusos, pinos ou pernos e porcas, de cobre','other screws, bolts and nuts, of copper','los demás tornillos, pernos y tuercas, de cobre',74,7415);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741533,'Parafusos, pinos ou pernos e porcas de cobre, ou de ferro e aço com cabeça de cobre','Screws, bolts, nuts and similar articles, threaded, of copper (other than screw hooks, ring- and eyebolts, lag screws, plugs, bungs and the like, with screw thread)','Tornillos, pernos, tuercas y artículos similares, roscados, de cobre (exc. escarpias roscadas, armellas, clavos-tornillo, tapones metálicos roscados y sobretapas roscadas)',74,7415);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741539,'Outros artefatos roscados, de cobre','Screw hooks, screw rings and the like, threaded, of copper (excl. standard screws and bolts and nuts)','Escarpias roscadas, armellas y artículos simil., roscados, de cobre (exc. tornillos ordinarios, pernos y tuercas)',74,7415);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741600,'Molas de cobre','Copper springs','Muelles de cobre',74,7416);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741700,'aparelhos para cozinhar/aquecer, de cobre, n/eletr.doméstico','cooking/heating apparatus, of copper, n/electric domestic','aparatos p/cocción/calefac., de cobre, n/eléctr.doméstico',74,7417);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741810,'art.uso dom.e part.;esponjas,esfregao,luva,et.p/lim.cob','art.uso dom.e part.;esponjas,esfregao,luva,et.p/lim.cob','art.uso dom.e part.;esponjas,esfregao,luva,et.p/lim.cob',74,7418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741811,'Esponjas, esfregões, luvas e artefatos semelhantes, para limpeza, polimento e usos semelhantes, de cobre','Pot scourers and scouring or polishing pads, gloves and the like, of copper (excl. sanitary ware)','Esponjas, estropajos, guantes y artículos simil. para fregar, lustrar o usos análogos, de cobre (exc. artículos de higiene o de tocador)',74,7418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741819,'Outros artefatos de uso doméstico e suas partes, de cobre','Table, kitchen or other household articles, parts thereof, of copper (excl. pot scourers and scouring or polishing pads, gloves and the like, cans, boxes and similar containers of heading 7419, articles of the nature of a work implement, articles of cutle','Artículos de uso doméstico y sus partes, de cobre (exc. esponjas, estropajos, guantes y artículos simil. para fregar, lustrar o usos análogos; aparatos de cocción o de calefacción de la partida 7417; bidones, cajas y recipientes simil. de la partida 7419;',74,7418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741820,'Artefatos de higiene ou de toucador e suas partes, de cobre','Sanitary ware and parts thereof, of copper (excl. cooking and heating appliances of heading 7417, and fittings)','Aparatos de higiene o tocador y sus partes, de cobre (exc. bidones, cajas y recipientes simil. de la partida 7419 y artículos de grifería)',74,7418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741910,'Correntes, cadeias e suas partes, de cobre','Chain and parts thereof, of copper (excl. watch chains, necklace chains and the like)','Cadenas y sus partes, de cobre (exc. cadenas de reloj, de joyería, etc.)',74,7419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741991,'Outras obras de cobre, vazadas, moldadas, estampadas ou forjadas, mas sem qualquer outro trabalho','Articles of copper, cast, moulded, stamped or forged, but not further worked, n.e.s.','Manufacturas de cobre, moldeadas, estampadas o forjadas pero sin trabajar de otro modo, n.c.o.p.',74,7419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (741999,'Outras obras de cobre','Articles of copper, n.e.s.','Manufacturas de cobre, n.c.o.p.',74,7419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750110,'Mates de níquel','Nickel mattes','Matas de níquel',75,7501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750120,'Sinters de óxidos de níquel e outros produtos intermediários da metalurgia do níquel','Nickel oxide sinters and other intermediate products of nickel metallurgy (excl. nickel mattes)','"Sinters" de óxidos de níquel y demás productos intermedios de la metalurgia del níquel',75,7501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750210,'Níquel não ligado, em formas brutas','Nickel, not alloyed, unwrought','Níquel sin alear, en bruto',75,7502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750220,'Ligas de níquel, em formas brutas','Unwrought nickel alloys','Aleaciones de níquel, en bruto',75,7502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750300,'Desperdícios e resíduos, de níquel','Waste and scrap, of nickel (excl. ingots or other similar unwrought shapes, of remelted nickel waste and scrap, ashes and residues containing nickel and waste and scrap of primary cells, primary batteries and electric accumulators)','Desperdicios y desechos de níquel (exc. lingotes y formas simil. brutas coladas a partir de desperdicios o desechos de níquel refundidos, así como las cenizas y residuos que contengan níquel y los desperdicios y desechos de pilas, de baterías de pilas y d',75,7503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750400,'Pós e escamas, de níquel','Powders and flakes, of nickel (excl. nickel oxide sinters)','Polvo y escamillas, de níquel (exc. "sinters" de óxidos de níquel)',75,7504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750511,'Barras e perfis, de níquel não ligado','Bars, rods, profiles and wire, of non-alloy nickel, n.e.s. (excl. electrically insulated products)','Barras y perfiles, de níquel sin alear, n.c.o.p. (exc. artículos aislados, para electricidad)',75,7505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750512,'Barras e perfis, de ligas de níquel','Bars, rods, profiles and wire, of nickel alloys, n.e.s. (excl. electrically insulated products)','Barras y perfiles, de aleaciones de níquel, n.c.o.p. (exc. artículos aislados, para electricidad)',75,7505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750521,'Fios de níquel não ligado','Wire of non-alloy nickel (excl. electrically insulated products)','Alambre, de níquel sin alear (exc. artículos aislados, para electricidad)',75,7505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750522,'Fios de ligas de níquel','Wire of nickel alloys (excl. electrically insulated products)','Alambre, de aleaciones de níquel (exc. artículos aislados, para electricidad)',75,7505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750610,'Chapas, tiras e folhas, de níquel não ligado','Plates, sheets, strip and foil, of non-alloy nickel (excl. expanded plates, sheets or strip)','Chapas, hojas y tiras, de níquel sin alear (exc. chapas y tiras extendidas "desplegadas")',75,7506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750620,'Chapas, tiras e folhas, de ligas de níquel','Plates, sheets, strip and foil, of nickel alloys (excl. expanded plates, sheets or strip)','Chapas, hojas y tiras, de aleaciones de níquel (exc. chapas y tiras extendidas "desplegadas")',75,7506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750711,'Tubos de níquel não ligado','Tubes and pipes of non-alloy nickel','Tubos, de níquel sin alear',75,7507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750712,'Tubos de ligas de níquel','Tubes and pipes of nickel alloys','Tubos, de aleaciones de níquel',75,7507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750720,'Acessórios para tubos, de níquel','Tube or pipe fittings, of nickel','Accesorios de tubería, de níquel',75,7507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750810,'Telas metálicas e grades, de fio de níquel','Cloth, grill, netting and fencing, of nickel wire','Telas metálicas, redes y rejas, de alambre de níquel',75,7508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (750890,'Outras obras de níquel','Articles of nickel, n.e.s.','Manufacturas de níquel, n.c.o.p.',75,7508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760110,'Alumínio não ligado em forma bruta','Aluminium, not alloyed, unwrought','Aluminio sin alear, en bruto',76,7601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760120,'Ligas de alumínio, em formas brutas','Unwrought aluminium alloys','Aleaciones de aluminio, en bruto',76,7601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760200,'Desperdícios e resíduos, de alumínio','Waste and scrap, of aluminium (excl. slags, scale and the like from iron and steel production, containing recoverable aluminium in the form of silicates, ingots or other similar unwrought shapes, of remelted waste and scrap, of aluminium, ashes and residu','Desperdicios y desechos, de aluminio (exc. escorias de la fabricación de metales férreos que contengan aluminio recuperable en forma de silicatos; lingotes o formas simil. en bruto coladas a partir de desperdicios y desechos de aluminio refundido; cenizas',76,7602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760310,'Pós de alumínio, de estrutura não lamelar','Powders of aluminium, of non-lamellar structure (excl. pellets of aluminium)','Polvo de aluminio, de estructura no laminar (exc. granalla de aluminio)',76,7603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760320,'Pós de estrutura lamelar; escamas, de alumínio','Powders of aluminium, of lamellar structure, and flakes of aluminium (excl. pellets of aluminium, and spangles)','Polvo de aluminio, de estructura laminar; escamillas de aluminio (exc. granalla de aluminio y lentejuelas)',76,7603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760410,'Barras e perfis, de alumínio não ligado','Bars, rods and profiles, of non-alloy aluminium, n.e.s.','Barras y perfiles, de aluminio sin alear, n.c.o.p.',76,7604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760421,'Perfis ocos, de ligas de alumínio','Hollow profiles of aluminium alloys, n.e.s.','Perfiles huecos, de aleaciones de aluminio, n.c.o.p.',76,7604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760429,'Outras barras e perfis, de ligas de alumínio','Bars, rods and solid profiles, of aluminium alloys, n.e.s.','Barras y perfiles macizos, de aleaciones de aluminio, n.c.o.p.',76,7604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760511,'Fios de alumínio não ligado, com a maior dimensão da seção transversal > 7 mm','Wire of non-alloy aluminium, with a maximum cross-sectional dimension of > 7 mm (excl. stranded wire, cables, plaited bands and the like and other articles of heading 7614, and electrically insulated wires)','Alambre de aluminio sin alear, cuya mayor dimensión de la sección transversal sea > 7 mm (exc. cables, trenzas y artículos simil. de la partida 7614 y alambre aislado para electricidad)',76,7605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760519,'Outros fios de alumínio não ligado','Wire of non-alloy aluminium, with a maximum cross-sectional dimension of <= 7 mm (other than stranded wires, cables, ropes and other articles of heading 7614, electrically insulated wires, strings for musical instruments)','Alambre de aluminio sin alear, cuya mayor dimensión de la sección transversal sea <= 7 mm (exc. cables, trenzas y artículos simil. de la partida 7614, alambre aislado para electricidad y cuerdas armónicas para instrumentos de música)',76,7605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760521,'Fios de ligas alumínio, com a maior dimensão da seção transversal > 7 mm','Wire of aluminium alloys, with a maximum cross-sectional dimension of > 7 mm (excl. stranded wire, cables, plaited bands and the like and other articles of heading 7614, and electrically insulated wires)','Alambre de aleaciones de aluminio, cuya mayor dimensión de la sección transversal sea > 7 mm (exc. cables, trenzas y artículos simil. de la partida 7614 y alambre aislado para electricidad)',76,7605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760529,'Outros fios de ligas alumínio','Wire, of aluminium alloys, having a maximum cross-sectional dimension of <= 7 mm (other than stranded wires, cables, ropes and other articles of heading 7614, electrically insulated wires, strings for musical instruments)','Alambre de aleaciones de aluminio, cuya mayor dimensión de la sección transversal sea <= 7 mm (exc. cables, trenzas y artículos simil. de la partida 7614, alambre aislado para electricidad y cuerdas armónicas para instrumentos de música)',76,7605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760611,'Chapas e tiras, de alumínio não ligado, de espessura > 0,2 mm, de forma quadrada ou retangular','Plates, sheets and strip, of non-alloy aluminium, of a thickness of > 0,2 mm, square or rectangular (excl. expanded plates, sheets and strip)','Chapas y tiras, de aluminio sin alear, de espesor > 0,2 mm, cuadradas o rectangulares (exc. chapas y tiras extendidas "desplegadas")',76,7606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760612,'Chapas e tiras, de ligas alumínio, de espessura > 0,2 mm, de forma quadrada ou retangular','Plates, sheets and strip, of non-alloy aluminium, of a thickness of > 0,2 mm, square or rectangular (excl. expanded plates, sheets and strip)','Chapas y tiras, de aleaciones de aluminio, de espesor > 0,2 mm, cuadradas o rectangulares (exc. chapas y tiras extendidas "desplegadas")',76,7606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760691,'Outras chapas e tiras, de alumínio não ligado, de espessura > 0,2 mm','Plates, sheets and strip, of non-alloy aluminium, of a thickness of > 0,2 mm (other than square or rectangular)','Chapas y tiras, de aluminio sin alear, de espesor > 0,2 mm, de forma distinta a la cuadrada o rectangular',76,7606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760692,'Outras chapas e tiras, de ligas de alumínio, de espessura > 0,2 mm','Plates, sheets and strip, of aluminium alloys, of a thickness of > 0,2 mm (other than square or rectangular)','Chapas y tiras, de aleaciones de aluminio, de espesor > 0,2 mm, de forma distinta a la cuadrada o rectangular',76,7606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760711,'Folhas e tiras, de alumínio, de espessura <= 0,2 mm, sem suporte, simplesmente laminadas','Aluminium foil, not backed, rolled but not further worked, of a thickness of <= 0,2 mm (excl. stamping foils of heading 3212, and foil made up as christmas tree decorating material)','Hojas y tiras, delgadas, de aluminio, sin soporte, simplemente laminadas, de espesor <= 0,2 mm (exc. hojas delgadas para el marcado a fuego de la partida 3212, así como las hojas y tiras delgadas que constituyan accesorios par árboles de Navidad)',76,7607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760719,'Outras folhas e tiras, de alumínio, de espessura <= 0,2 mm, sem suporte','Aluminium foil, not backed, rolled and further worked, of a thickness of <= 2 mm (excl. stamping foils of heading 3212, and foil made up as christmas tree decorating material)','Hojas y tiras, delgadas, de aluminio, sin soporte, laminadas y trabajadas, de espesor <= 0,2 mm (exc. hojas delgadas para el marcado a fuego de la partida 3212, así como las hojas y tiras delgadas que constituyan accesorios par árboles de Navidad)',76,7607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760720,'Folhas e tiras, de alumínio, de espessura <= 0,2 mm, com suporte','Aluminium foil, backed, of a thickness excl. any backing of <= 0,2 mm (excl. stamping foils of heading 3212, and foil made up as christmas tree decorating material)','Hojas y tiras, delgadas, de aluminio, con soporte, de espesor <= 0,2 mm, sin incluir el soporte (exc. hojas delgadas para el marcado a fuego de la partida 3212, así como las hojas y tiras delgadas que constituyan accesorios par árboles de Navidad)',76,7607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760810,'Tubos de alumínio não ligado','Tubes and pipes of non-alloy aluminium (excl. hollow profiles)','Tubos de aluminio sin alear (exc. perfiles huecos)',76,7608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760820,'Tubos de ligas de alumínio','Tubes and pipes of aluminium alloys (excl. hollow profiles)','Tubos de aleaciones de aluminio (exc. perfiles huecos)',76,7608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (760900,'Acessórios para tubos de alumínio','Aluminium tube or pipe fittings e.g., couplings, elbows, sleeves','Empalmes "rácores", codos, manguitos y demás accesorios de tuberías, de aluminio',76,7609);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (761010,'Portas e janelas, e seus caixilhos, alizares e soleiras, de alumínio','Doors, windows and their frames and thresholds for door, of aluminium (excl. door furniture)','Puertas, ventanas y sus marcos, contramarcos y umbrales (exc. guarniciones)',76,7610);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (761090,'Outros, chapas, barras, tubos e semelhantes, de alumínio, para construções','Structures and parts of structures, of aluminium, n.e.s., and plates, rods, profiles, tubes and the like, prepared for use in structures, of aluminium, n.e.s. (excl. prefabricated buildings of heading 9406, doors and windows and their frames and threshold','Construcciones y partes de construcciones, de aluminio, n.c.o.p.; chapas, barras, perfiles, tubos y simil., de aluminio, preparados para la construcción, n.c.o.p. (exc. construcciones prefabricadas de la partida 9406, así como puertas, ventanas y sus marc',76,7610);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (761100,'Reservatórios, tonéis, cubas e recipientes semelhantes, de alumínio, de capacidade > 300 litros, sem dispositivos mecânicos ou térmicos','Reservoirs, tanks, vats and similar containers, of aluminium, for any material (other than compressed or liquefied gas), of a capacity of > 300 l, not fitted with mechanical or thermal equipment, whether or not lined or heat-insulated (excl. containers sp','Depósitos, cisternas, cubas y recipientes simil. para cualquier materia (exc. gas comprimido o licuado), de aluminio, de capacidad > 300 l, sin dispositivos mecánicos ni térmicos, incl. con revestimiento interior o calorífugo (exc. contenedores especialme',76,7611);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (761210,'Recipientes tubulares, flexíveis, de alumínio, de capacidade <= 300 litros, sem dispositivos mecânicos ou térmicos','Collapsible tubular containers, of aluminium','Envases tubulares flexibles, de aluminio',76,7612);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (761290,'Outros reservatórios, de alumínio, de capacidade <= 300 litros, sem dispositivos mecânicos ou térmicos','Casks, drums, cans, boxes and similar containers, incl. rigid or collapsible tubular containers, of aluminium, for any material (other than compressed or liquefied gas), of a capacity of <= 300 l, n.e.s.','Depósitos, barriles, tambores, bidones, botes, cajas y recipientes simil., de aluminio, incl. los envases tubulares rígidos, para cualquier materia (exc. gas comprimido o licuado), de capacidad <= 300 l, n.c.o.p.',76,7612);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (761300,'Recipientes para gases comprimidos ou liquefeitos, de alumínio','Aluminium containers for compressed or liquefied gas','Recipientes de aluminio para gas comprimido o licuado',76,7613);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (761410,'Cordas, cabos e tranças, de alumínio, com alma de aço, não isolados para usos elétricos','Stranded wire, cables, plaited bands and the like, of aluminium, with steel core (excl. such products electrically insulated)','Cables, trenzas y artículos simil., de aluminio, con alma de acero, sin aislar para electricidad',76,7614);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (761490,'Outras cordas, cabos, tranças e semelhantes, de alumínio, não isolados para usos elétricos','Stranded wires, cables, ropes and similar articles, of aluminium (other than with steel core and electrically insulated products)','Cables, trenzas y artículos simil., de aluminio, sin aislar para electricidad (exc. con alma de acero)',76,7614);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (761510,'Mesa, cozinha, ou outros artigos de uso doméstico e suas partes; esponjas e limpeza, polimento ou almofadas, luvas e semelhantes, de alumínio','Table, kitchen or other household articles and parts thereof; pot scourers and scouring or polishing pads, gloves and the like , of aluminium','Higiene o tocador Artículos de uso doméstico y sus partes; esponjas, estropajos, guantes y artículos, lustrar o almohadillas, guantes y artículos similares, de aluminio',76,7615);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (761511,'Esponjas, esfregões, luvas e artefatos semelhantes, para limpeza, polimento e usos semelhantes, de alumínio','Pot scourers and scouring or polishing pads, gloves and the like, of aluminium (excl. sanitary ware)','Esponjas, estropajos, guantes y artículos simil. para fregar, lustrar o usos análogos, de aluminio (exc. artículos de higiene o de tocador)',76,7615);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (761519,'Outros artefatos e suas partes, de alumínio, de uso da espécie doméstica','Table, kitchen or other household articles, parts thereof, of aluminium (excl. pot scourers and scouring or polishing pads, gloves and the like, cans, boxes and similar containers of heading 7612, articles of the nature of a work implement, spoons, ladles','Artículos de uso doméstico y sus partes, de aluminio (exc. estropajos, guantes y artículos simil. para fregar, lustrar o usos simil.; bidones, cajas y recipientes simil. de la partida 7612; artículos con carácter de herramientas; cucharas, cucharones, ten',76,7615);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (761520,'Artefatos de higiene ou toucador, e suas partes, de alumínio','Sanitary ware and parts thereof, of aluminium (excl. cans, boxes and similar containers of heading 7612, and fittings)','Artículos de higiene o tocador y sus partes, de aluminio (exc. bidones, cajas y recipientes simil. de la partida 7612, así como artículos de grifería)',76,7615);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (761610,'Tachas, pregos, escápulas, parafusos, pinos, roscados, porcas, rebites, chavetas, cavilhas, contrapinos, arruelas e artefatos semelhantes, de alumínio','Nails, tacks, staples, screws, bolts, nuts, screw hooks, rivets, cotters, cotter pins, washers and similar articles, of aluminium (excl. staples in strips, plugs, bungs and the like, threaded)','Puntas, clavos, grapas apuntadas, tornillos, pernos, tuercas, escarpias roscadas, remaches, pasadores, clavijas, chavetas, arandelas y artículos simil., de aluminio (exc. grapas en tiras, así como tapones roscados y sobretapas roscadas)',76,7616);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (761691,'Telas metálicas, grades e redes, de fio de alumínio','Cloth, grill, netting and fencing, of aluminium wire (excl. cloth of metal fibres for clothing, lining and similar uses, and cloth, grill and netting made into hand sieves or machine parts)','Telas metálicas, redes y rejas, de alambre de aluminio (exc. tejidos de hilos de metal para prendas, tapicería o usos simil., así como telas, redes y rejas montados en forma de tamices y de cribas de mano o para formar piezas de máquinas)',76,7616);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (761699,'Outras obras de alumínio','Articles of aluminium, n.e.s.','Manufacturas de aluminio, n.c.o.p.',76,7616);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (780110,'Chumbo refinado (afinado), em formas brutas','Unwrought lead, refined','Plomo refinado, en bruto',78,7801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (780191,'Chumbo contendo antimônio como segundo elemento predominante em peso, em formas brutas','Unwrought lead, containing by weight antimony as the principal other element','Plomo en bruto, con antimonio como el otro elemento predominante en peso',78,7801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (780199,'Outros chumbos em formas brutas','Unwrought lead (excl. refined lead and lead containing by weight antimony as the principal other element)','Plomo en bruto (exc. plomo refinado y plomo con antimonio como el otro elemento predominante en peso)',78,7801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (780200,'Desperdícios e resíduos, de chumbo','Lead waste and scrap (excl. ashes and residues from lead production heading No 2620, and ingots or other similar unwrought shapes, of remelted waste and scrap, of lead heading No 7801 and waste and scrap of primary cells, primary batteries et electric acc','Desperdicios y desechos, de plomo (exc. cenizas y residuos de la fabricación del plomo de la partida 2620; lingotes y formas en bruto simil. coladas a partir de desperdicios y desechos de plomo refundidos de la partida 7801; desperdicios y desechos de pil',78,7802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (780300,'Barras, perfis e fios, de chumbo','Lead bars, rods, profiles and wire','Barras, perfiles y alambre, de plomo',78,7803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (780411,'Folhas e tiras, de chumbo, de espessura <= 0,2 mm','Lead sheets, strip and foil, of a thickness excl. any backing of <= 0,2 mm','Hojas y tiras, de plomo, de espesor <= 0,2 mm, sin incluir el soporte',78,7804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (780419,'Outras chapas, folhas e tiras, de chumbo','Lead plates; lead sheets, strip and foil, of a thickness excl. any backing of > 0,2 mm','Chapas de plomo; hojas y tiras, de plomo, de espesor > 0,2 mm, sin incluir el soporte',78,7804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (780420,'Pós e escamas, de chumbo','Lead powders and flakes (excl. grains of lead, and spangles of heading 8308)','Polvo y escamillas, de plomo (exc. granallas de plomo y lentejuelas de la partida 8308)',78,7804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (780500,'tubos e seus acessórios, de chumbo','lead tubes and its accessories','tubos y accesorios de tubería, de plomo',78,7805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (780600,'Outras obras de chumbo','Articles of lead, n.e.s.','Manufacturas de plomo, n.c.o.p.',78,7806);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (790111,'Zinco não ligado, em formas brutas, contendo, em peso, => 99,99% de zinco','Unwrought zinc, not alloyed, containing by weight >= 99,99% of zinc','Cinc en bruto, sin alear, con un contenido de cinc >= 99,99% en peso',79,7901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (790112,'Zinco não ligado, em formas brutas, contendo, em peso, < 99,99% de zinco','Unwrought zinc, not alloyed, containing by weight < 99,99% of zinc','Cinc en bruto, sin alear, con un contenido de cinc < 99,99% en peso',79,7901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (790120,'Ligas de zinco, em formas brutas','Unwrought zinc alloys','Aleaciones de cinc, en bruto',79,7901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (790200,'Desperdícios e resíduos, de zinco','Zinc waste and scrap (excl. ash and residues from zinc production heading 2620, ingots and other similar unwrought shapes, of remelted waste and scrap, of zinc heading 7901 and waste and scrap of primary cells, primary batteries and electric accumulators)','Desperdicios y desechos, de cinc (exc. cenizas y residuos de la fabricación del cinc, partida 2620; lingotes y formas en bruto simil. coladas a partir de desperdicios y desechos de cinc refundidos, partida 7901; desperdicios y desechos de pilas, de baterí',79,7902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (790310,'Poeiras de zinco','Zinc dust','Polvo de condensación, de cinc',79,7903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (790390,'Pós e escamas, de zinco','Zinc powders and flakes (excl. grains of zinc, and spangles of heading 8308, and zinc dust)','Polvo y escamillas, de cinc (exc. granallas de cinc, lentejuelas de la partida 8308 y polvo de condensación)',79,7903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (790400,'Barras, perfis e fios, de zinco','Zinc bars, rods, profiles and wire, n.e.s.','Barras, perfiles y alambre, de cinc, n.c.o.p.',79,7904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (790500,'Chapas, folhas e tiras, de zinco','Zinc plates, sheets, strip and foil','Chapas, hojas y tiras, de cinc',79,7905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (790600,'Tubos e seus acessórios, de zinco','Zinc tubes and its accessories','Tubos y accesorios de tubería, de cinc',79,7906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (790700,'Outras obras de zinco','Articles of zinc, n.e.s.','Manufacturas de cinc, n.c.o.p.',79,7907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (800110,'Estanho não ligado, em formas brutas','Unwrought tin, not alloyed','Estaño en bruto, sin alear',80,8001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (800120,'Ligas de estanho, em formas brutas','Unwrought tin alloys','Aleaciones de estaño, en bruto',80,8001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (800200,'Desperdícios e resíduos, de estanho','Tin waste and scrap (excl. ash and residues from the manufacture of tin of heading 2620, and ingots and similar unwrought tin produced from melted tin waste and scrap of heading 8001)','Desperdicios y desechos de estaño (exc. cenizas y residuos de la fabricación del estaño, partida 2620; lingotes y formas en bruto simil. coladas a partir de desperdicios y desechos de estaño refundidos, partida 8001)',80,8002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (800300,'Barras, perfis e fios, de estanho','Tin bars, rods, profiles and wire, n.e.s.','Barras, perfiles y alambre, de estaño, n.c.o.p.',80,8003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (800400,'Chapas, folhas e tiras, de estanho, espessura>0.2mm','Tin plates, sheets and strip, of a thickness>0.2mm','Chapas, hojas y tiras, de estaño, espesor>0.2mm',80,8004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (800500,'Folhas, tiras, pós e escamas, de estanho','Sheets, strips, powders and flakes, of tin','Hojas, bandas, polvo y partículas, de estaño',80,8005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (800600,'tubos e seus acessórios, de estanho','tin tubes and its accessories','tubos y accesorios de tubería,  de estaño',80,8006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (800700,'Outras obras de estanho','Articles of tin, n.e.s.','Manufacturas de estaño, n.c.o.p.',80,8007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810110,'Pós de tungstênio (volfrâmio)','Tungsten powders','Polvo de volframio "tungsteno"',81,8101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810191,'tungstênio em forma bruta, incl.barra sinter.desperd.etc','unwrought tungsten, incl.bars obt.by sinter.waste, etc','volframio en bruto, incl.barra obt.sinter.desperd.etc',81,8101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810192,'outs.barras e perfis/chapas/tiras/folhas, de tungstênio','oth.bars and profiles/plastes/strips/sheets, of tungsten','las dem.barras y perfiles/chapas/tiras/hojas, de tungst.',81,8101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810193,'fios de tungstênio','wires of tungsten','alambre de tungsteno',81,8101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810194,'Tungstênio em formas brutas, incluídas as barras simplesmente obtidas por sinterização','Unwrought tungsten, incl. bars and rods of tungsten obtained simply by sintering','Volframio "tungsteno" en bruto, incl. las barras simplemente obtenidas por sinterizado',81,8101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810195,'barras, perfis, chapas, folhas, etc.de tungstênio','bars/profiles/plastes/strips/sheets, etc.of tungsten','barras, perfiles, chapas, hojas, etc.de tungsteno',81,8101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810196,'Fios de tungstênio','Tungsten wire','Alambre de volframio "tungsteno"',81,8101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810197,'Desperdícios e resíduos de tungstênio','Tungsten waste and scrap (excl. ash and residues containing tungsten)','Desperdicios y desechos de volframio "tungsteno" (exc. cenizas y residuos que contengan volframio "tungsteno")',81,8101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810199,'Outras obras de tungstênio','Articles of tungsten, n.e.s.','Manufacturas de volframio "tungsteno", n.c.o.p.',81,8101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810210,'Pós de molibdênio','Molybdenum powders','Polvo de molibdeno',81,8102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810291,'molibdénio em forma bruta, incl.barra sinter.desperd.etc','unwrought molybdenum, incl.bars obt.by sinter.waste, etc','molibdeno en bruto, incl.barra obt.sinter.desperd.etc',81,8102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810292,'outs.barras e perfis/chapas/tiras/folhas, de molibdénio','oth.bars/profiles/plastes/strips/sheets, of molybdenum','las dem.barras y perf./chapas/tiras/hojas, de molibdeno',81,8102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810293,'fios de molibdénio','molybdenum wires','alambre de molibdeno',81,8102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810294,'Molibdênio em formas brutas, incluídas as barras simplesmente obtidas por sinterização','Unwrought molybdenum, incl. bars and rods obtained simply by sintering','Molibdeno en bruto, incl. las barras simplemente obtenidas por sinterizado',81,8102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810295,'Barras, exceto as simplesmente obtidas por sinterização, perfis, chapas, tiras e folhas, de molibdênio','Molybdenum bars and rods (other than those obtained simply by sintering), profiles, plates, sheets, strip and foil, n.e.s.','Barras, perfiles, chapas, hojas y tiras, de molibdeno, n.c.o.p. (exc. barras obtenidas simplemente por sinterizado)',81,8102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810296,'Fios de molibdênio','Molybdenum wire','Alambre de molibdeno',81,8102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810297,'Desperdícios e resíduos de molibdênio','Molybdenum waste and scrap (excl. ash and residues containing molybdenum)','Desperdicios y desechos de molibdeno (exc. cenizas y residuos que contengan molibdeno)',81,8102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810299,'Outras obras de molibdênio','Articles of molybdenum, n.e.s.','Manufacturas de molibdeno, n.c.o.p.',81,8102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810310,'Tântalo em forma bruta, incl.barra sinter.desperd.resid.','Unwrought tantalum, incl.bars obt.by sinter.waste scrap','Tántalio en brut, incl.barra obt.sinter.desperd.desech.',81,8103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810320,'Tântalo em formas brutas, incluídas as barras simplesmente obtidas por sinterização; pós','Unwrought tantalum, incl. bars and rods of tantalum obtained simply by sintering; tantalum powders','Tantalio en bruto, incl. las barras simplemente obtenidas por sinterizado; polvo de tantalio',81,8103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810330,'Desperdícios e resíduos de tântalo','Tantalum waste and scrap (excl. ash and residues containing tantalum)','Desperdicios y desechos de tantalio (exc. cenizas y residuos que contengan tantalio)',81,8103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810390,'Outras obras de tântalo','Articles of tantalum, n.e.s.','Manufacturas de tantalio, n.c.o.p.',81,8103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810411,'Magnésio em formas brutas, contendo => 99,80%, em peso, de magnésio','Unwrought magnesium, containing >= 99,8% by weight of magnesium','Magnesio en bruto, con un contenido de magnesio >= 99,8% en peso',81,8104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810419,'Outras formas brutas de magnésio','Unwrought magnesium, containing < 99,8% by weight of magnesium','Magnesio en bruto, con un contenido de magnesio < 99,8% en peso',81,8104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810420,'Desperdícios e resíduos, de magnésio','Magnesium waste and scrap (excl. ash and residues containing magnesium, and raspings, turnings and granules graded according to size)','Desperdicios y desechos, de magnesio (exc. cenizas y residuos que contengan magnesio, así como torneaduras y gránulos de magnesio calibrados)',81,8104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810430,'Resíduos de torno e grânulos, calibrados; pós, de magnésio','Magnesium raspings, turnings and granules, graded according to size; magnesium powders','Torneaduras y gránulos, de magnesio, calibrados; polvo de magnesio',81,8104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810490,'Outras obras de magnésio','Articles of magnesium, n.e.s.','Manufacturas de magnesio, n.c.o.p.',81,8104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810510,'Pós e maltes de cobalto; cobalto em bruto','Cobalt powder and malts; raw cobalt','Polvo y maltas de cobalto; cobalto en bruto',81,8105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810520,'Mates de cobalto e outros produtos intermediários da metalurgia do cobalto; cobalto em formas brutas; pós','Cobalt mattes and other intermediate products of cobalt metallurgy; unwrought cobalt; cobalt powders','Matas de cobalto y demás productos intermedios de la metalurgia del cobalto; cobalto en bruto; polvo de cobalto',81,8105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810530,'Desperdícios e resíduos da metalurgia do cobalto','Cobalt waste and scrap (excl. ash and residues containing cobalt)','Desperdicios y desechos, de cobalto (exc. cenizas y residuos que contengan cobalto)',81,8105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810590,'Outras obras de cobalto','Articles of cobalt, n.e.s.','Manufacturas de cobalto, n.c.o.p.',81,8105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810600,'Bismuto e suas obras, incluídos os desperdícios e resíduos','Bismuth and articles thereof, n.e.s.; bismuth waste and scrap (excl. ash and residues containing bismuth)','Bismuto y sus manufacturas, n.c.o.p.; desperdicios y desechos, de bismuto (exc. cenizas y residuos que contengan bismuto)',81,8106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810710,'Cádmio em bruto; pós de cádmio','Cadmium in the rough;  cadmium powder','Cadmio en bruto, cadmio pulverizado',81,8107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810720,'Cádmio em formas brutas; pós','Unwrought cadmium; cadmium powders','Cadmio en bruto; polvo de cadmio',81,8107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810730,'Desperdícios e resíduos do cádmio','Cadmium waste and scrap (excl. ashes and residues containing cadmium)','Desperdicios y desechos, de cadmio (exc. cenizas y residuos que contengan cadmio)',81,8107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810790,'Obras e outros produtos de cádmio','Articles of cadmium, n.e.s.','Manufacturas de cadmio, n.c.o.p.',81,8107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810810,'Titânio em forma bruta, desperd.resid.e pós de titânio','Unwrought titanium, waste, scrap and powders of titanium','Titanio en bruto, desperd.desech.y polvo de titanio',81,8108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810820,'Titânio em formas brutas; pós','Unwrought titanium; titanium powders','Titanio en bruto; polvo de titanio',81,8108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810830,'Desperdícios e resíduos do titânio','Titanium waste and scrap (excl. ash and residues containing titanium)','Desperdicios y desechos, de titanio (exc. cenizas y residuos que contengan titanio)',81,8108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810890,'Obras e outros produtos de titânio','Articles of titanium, n.e.s.','Manufacturas de titanio, n.c.o.p.',81,8108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810910,'zircônio em forma bruta, desperd.resid.e pos de zircônio','unwrought zirconium, waste, scrap and powders of zircon.','circonio en bruto, desperd.desech.y polvo de circonio',81,8109);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810920,'Zircônio em formas brutas; pós','Unwrought zirconium; zirconium powders','Circonio en bruto; polvo de circonio',81,8109);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810930,'Desperdícios e resíduos do zircônio','Zirconium waste and scrap (excl. ash and residues containing zirconium)','Desperdicios y desechos, de circonio (exc. cenizas y residuos que contengan circonio)',81,8109);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (810990,'Obras e outros produtos de zircônio','Articles of zirconium, n.e.s.','Manufacturas de circonio, n.c.o.p.',81,8109);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811000,'Antimônio em bruto; obras, desperdícios e resíduos de antimônio','Antimony, crude; works, waste and scrap of antimony','Antimonio en bruto; obras, desperdicios y desechos de antimonio',81,8110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811010,'Antimônio em formas brutas; pós','Unwrought antimony; antimony powders','Antimonio en bruto; polvo de antimonio',81,8110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811020,'Desperdícios e resíduos do antimônio','Antimony waste and scrap (excl. ash and residues containing antimony)','Desperdicios y desechos, de antimonio (exc. cenizas y residuos que contengan antimonio)',81,8110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811090,'Obras e outros produtos do antimônio','Articles of antimony, n.e.s.','Manufacturas de antimonio, n.c.o.p.',81,8110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811100,'Manganês e suas obras, incluídos os desperdícios e resíduos','Manganese and articles thereof, n.e.s.; manganese waste and scrap (excl. ash and residues containing manganese)','Manganeso y sus manufacturas, n.c.o.p.; desperdicios y desechos, de manganeso (exc. cenizas y residuos que contengan manganeso)',81,8111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811211,'Berílio em forma bruta, desperd.resid.e pos de berílio','Unwrought beryllium, including waste, scrap and powders','Berilio en bruto, desperd.desech.y polvo de berilio',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811212,'Berílio em formas brutas; pós','Unwrought beryllium; beryllium powders','Berilio en bruto; polvo de berilio',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811213,'Desperdícios e resíduos do berílio','Beryllium waste and scrap (excl. ashes and residues containing beryllium)','Desperdicios y desechos, de berilio (exc. cenizas y residuos que contengan berilio)',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811219,'Obras e outros produtos de berílio','Articles of beryllium, n.e.s.','Manufacturas de berilio, n.c.o.p.',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811220,'Cromo em bruto; obras, desperdícios e resíduos de cromo','Chromium, crude; works, waste and scrap of chromium','Cromo en bruto; las obras, los residuos del cromo',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811221,'Cromo em formas brutas; pós','Unwrought chromium; chromium powders','Cromo en bruto; polvo de cromo',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811222,'Desperdícios e resíduos do cromo','Chromium waste and scrap (excl. ash and residues containing chromium and chromium alloys containing > 10% by weight of nickel)','Desperdicios y desechos, de cromo (exc. cenizas y residuos que contengan cromo, así como aleaciones de cromo, con un contenido de níquel > 10% en peso)',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811229,'Obras e outros produtos do cromo','Articles of chromium, n.e.s.','Manufacturas de cromo, n.c.o.p.',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811230,'Germânio e suas obras, desperd.e resíduos, de germânio','Germanium and its articles, including waste and scrap','Germanio y sus manufact., desperd.y desechos, de germanio',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811240,'Vanádio e suas obras, desperdícios e resíduos, de vanádio','Vanadium and its articles, including waste and scrap','Vanadio y sus manuf., desperdicios y desechos, de vanadio',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811251,'Tálio em formas brutas; pós','Unwrought thallium; thallium powders','Talio, en bruto; polvo de talio',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811252,'Desperdícios e resíduos do tálio','Thallium waste and scrap (excl. ashes and residues containing thallium)','Desechos y desperdicios, de talio (exc. cenizas y residuos que contengan talio)',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811259,'Obras e outros produtos do tálio','Articles of thallium, n.e.s.','Manufacturas de talio, n.c.o.p.',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811291,'gálio, hafnio, indio, nióbio, etc.em bruto, desperd.resid.po','gallium, hafnium, indium, niobium, etc.brute, wast.scrap, pow','galio, hafnio, indio, niobio, etc.en bruto, desper.des.polvo',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811292,'Gálio, germânio, háfnio, índio, nióbio, rênio e vanádio, em formas brutas; desperdícios e resíduos; pós','Unwrought hafnium celtium, niobium columbium, rhenium, gallium, indium, vanadium and germanium; powders and waste and scrap of these metals (excl. ash and residues containing these metals)','Hafnio "celtio", niobio "colombio", renio, galio e indio, en bruto; desechos, desperdicios y polvo de estos metales (exc. cenizas y residuos que contengan estos metales)',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811299,'Obras e outros produtos de gálio, germánio, háfnio, índio, nióbio, rênio e vanádio','Articles of hafnium celtium, niobium columbium, rhenium, gallium, indium, vanadium and germanium, n.e.s.','Manufacturas de hafnio "celtio", niobio "colombio", renio, galio o indio, n.c.o.p.',81,8112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (811300,'Ceramais (cermets) e suas obras, incluídos os desperdícios e resíduos','Cermets and articles thereof, n.e.s.; waste and scrap of cermets (excl. ash and residues containing cermets)','Cermet y sus manufacturas, n.c.o.p.; desperdicios y desechos, de cermet (exc. cenizas y residuos que contengan cermet)',81,8113);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820110,'Pás, de metais comuns','Spades and shovels, with working parts of base metal','Layas y palas, con parte operante de metal común',82,8201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820120,'Forçados e forquilhas, de metais comuns','Forks, incl. pitchforks, with working parts of base metal','Horcas de labranza, con parte operante de metal común',82,8201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820130,'Alviões, picaretas, enxadas, sachos, ancinhos e raspadeiras, de metais comuns','Mattocks, picks, hoes and rakes, with working parts of base metal (excl. ice axes)','Azadas, picos, binaderas, rastrillos y raederas, con parte operante de metal común (exc. picos de alpinista)',82,8201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820140,'Machados, podões e ferramentas semelhantes com gume, de metais comuns','Axes, billhooks and similar hewing tools, with working parts of base metal (excl. ice axes)','Hachas, hocinos y herramientas simil., con filo de metal común',82,8201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820150,'Tesouras de podar, (incluídas as tesuras para aves) manipuladas com uma das mãos, de metais comuns','Secateurs and similar one-handed pruners and shears, incl. poultry shears, with working parts of base metal','Tijeras de podar, incl. las de aves, para usar con una sola mano, con parte operante de metal común',82,8201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820160,'Tesouras para sebes, tesouras de podar e ferramentas semelhantes, manipuladas com as duas mãos, de metais comuns','Hedge shears, two-handed pruning shears and similar two-handed shears, with working parts of base metal','Cizallas para setos, tijeras de podar y herramientas simil., para usar con las dos manos, con parte operante de metal común',82,8201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820190,'Outras ferramentas manuais, para agricultura, horticultura e silvicultura, de metais comuns','Scythes, sickles, hay knives, timber wedges and other hand tools of a kind used in agriculture, horticulture or forestry, with working parts of base metal (excl. spades, shovels, forks, mattocks, picks, hoes, rakes, axes, billhooks and similar hewing tool','Hoces, guadañas, cuchillos para heno o para paja y demás herramientas de mano, agrícolas, hortícolas o forestales, con parte operante de metal común, n.c.o.p.',82,8201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820210,'Serras manuais, de metais comuns','Handsaws, with working parts of base metal (excl. power-operated saws)','Sierras de mano, con parte operante de metal común (exc. con motor incorporado)',82,8202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820220,'Folhas de serras de fita, de metais comuns','Bandsaw blades of base metal','Hojas de sierra de cinta, de metal común',82,8202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820231,'Folhas de serras circulares, com parte operante de aço, de metais comuns','Circular saw blades, incl. slitting or slotting saw blades, of base metal, with working parts of steel','Hojas de sierra circulares, incl. las fresas sierra, de metal común, con parte operante de acero',82,8202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820239,'Outras folhas de serras circulares (incluídas as fresas-serras), de metais comuns','Circular saw blades, incl. slitting or slotting saw blades, and parts thereof, of base metal, with working parts of materials other than steel','Hojas de sierra circulares, incl. las fresas sierra, incl. las partes, de metal común, con parte operante de materias distintas del acero',82,8202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820240,'Correntes cortantes de serras, de metais comuns','Chainsaw blades of base metal','Cadenas cortantes, de metal común',82,8202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820291,'Folha de serras retilíneas, para trabalhar metais, de metais comuns','Straight saw blades, of base metal, for working metal','Hojas de sierra rectas, de metal común, para trabajar metal',82,8202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820299,'Outras folhas de serras, de metais comuns','Saw blades, incl. toothless saw blades, of base metal (excl. bandsaw blades, circular saw blades, slitting or slotting saw blades, chainsaw blades and straight saw blades for working metal)','Hojas de sierra, incl. las hojas sin dentar, de metal común (exc. hojas de sierra de cinta, hojas de sierra circulares, hojas de fresas sierra, cadenas cortantes y hojas de sierra rectas para trabajar metal)',82,8202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820310,'Limas e grosas, de metais comuns','Files, rasps and similar hand tools of base metal','Limas, escofinas y herramientas simil., de mano, de metal común',82,8203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820320,'Alicates (mesmo cortantes), tenazes, pinças e ferramentas semelhantes, manuais, de metais comuns','Pliers, incl. cutting pliers, pincers and tweezers for non-medical use and similar hand tools, of base metal','Alicates, incl. cortantes, tenazas, pinzas y herramientas simil., de mano, de metal común (exc. pinzas de medicina)',82,8203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820330,'Cisalhas para metais e ferramentas semelhantes, manuais, de metais comuns','Metal-cutting shears and similar hand tools, of base metal','Cizallas para metal y herramientas simil., de mano, de metal común',82,8203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820340,'Corta-tubos, corta-pinos, saca-bocados e ferramentas semelhantes, manuais, de metais comuns','Pipe-cutters, bolt croppers, perforating punches and similar hand tools, of base metal','Cortatubos, cortapernos, sacabocados y herramientas simil., de mano, de metal común',82,8203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820411,'Chaves de porcas, manuais, de abertura fixa, de metais comuns','Hand-operated spanners and wrenches, incl. torque meter wrenches, of base metal, non-adjustable','Llaves de ajuste de mano, incl. las llaves dinamométricas, de metal común, de boca fija',82,8204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820412,'Chaves de porcas, manuais, de abertura variáveis, de metais comuns','Hand-operated spanners and wrenches, incl. torque meter wrenches, of base metal, adjustable (excl. tap wrenches)','Llaves de ajuste de mano, incl. las llaves dinamométricas, de metal común, de boca ajustable',82,8204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820420,'Chaves de caixa intercambiáveis, mesmo com cabos, de metais comuns','Interchangeable spanner sockets, with or without handles, of base metal','Cubos de ajuste intercambiables, incl. con mango, de metal común',82,8204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820510,'Ferramentas manuais de furar ou de roscar, de metais comuns','Hand-operated drilling, threading or tapping hand tools','Herramientas de taladrar o roscar, incl. las terrajas, de mano',82,8205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820520,'Martelos e marretas, manuais, de metais comuns','Hammers and sledge hammers with working parts of base metal','Martillos y mazas, con parte operante de metal común',82,8205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820530,'Plainas, formões, goivas e ferramentas cortantes semelhantes, para trabalhar madeira, manuais, de metais comuns','Planes, chisels, gouges and similar cutting tools for working wood','Cepillos, formones, gubias y herramientas cortantes simil., para trabajar madera',82,8205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820540,'Chaves de fenda, manuais, de metais comuns','Hand-operated screwdrivers','Destornilladores de mano',82,8205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820551,'Outras ferramentas manuais, de uso da espécie doméstica, de metais comuns','Household hand tools, non-mechanical, with working parts of base metal, n.e.s.','Herramientas de mano, de uso doméstico, no mecánicas, con parte operante de metal común, n.c.o.p.',82,8205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820559,'Outras ferramentas manuais, de metais comuns','Hand tools, incl. glaziers'' diamonds, of base metal, n.e.s.','Herramientas de mano, incl. los diamantes de vidriero, de metal común, n.c.o.p.',82,8205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820560,'Lamparinas ou lâmpadas de soldar, (maçaricos) e semelhantes, de metais comuns','Blowlamps and the like (excl. gas-powered blowlamps)','Lámparas para soldar y simil. (exc. máquinas y aparatos de gas para soldadura)',82,8205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820570,'Tornos de apertar, sargentos e semelhantes, de metais comuns','Vices, clamps and the like (excl. accessories for and parts of machine tools)','Tornillos de banco, prensas de carpintero y simil. (exc. partes o accesorios de máquinas herramienta)',82,8205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820580,'Bigornas; forjas-portáteis; mós com armação, manuais ou de pedal, de metais comuns','Anvils; portable forges; hand-operated or pedal-operated grinding wheels with frameworks','Yunques; fraguas portáitles; muelas de mano o pedal, con bastidor',82,8205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820590,'Sortidos de dois ou mais artefatos das subposições 8205.70 e 8205.80','Sets of two or more tools of the subheading of heading 8205','Juegos de artículos de dos o más de las subpartidas de la partida 8205',82,8205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820600,'Sortidos de dois ou mais artefatos das posições 8202 até 8205, para venda a retalho','Sets of two or more tools of heading 8202 to 8205, put up in sets for retail sale','Herramientas de dos o más de las partidas 8202 a 8205, acondicionadas en juegos para la venta al por menor',82,8206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820713,'Ferramentas intercambiáveis de perfuração ou de sondagem, com parte operante de ceramais (cermets), de metais comuns','Rock-drilling or earth-boring tools, interchangeable, with working parts of sintered metal carbides or cermets','Útiles de perforación o sondeo, intercambiables, con parte operante de carburo metálico sinterizados o cermet',82,8207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820719,'Outras ferramentas intercambiáveis de perfuração ou de sondagem, incluídas as partes, de metais comuns','Rock-drilling or earth-boring tools, interchangeable, and parts therefor, with working parts of materials other than sintered metal carbide or cermets','Útiles de perforación o sondeo, intercambiables, incl. las partes, con parte operante de materias distintas de los carburos metálicos sinterizados o cermet',82,8207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820720,'Fieiras de estiragem ou de extrusão, para metais, de metais comuns','Interchangeable dies for drawing or extruding metal','Hileras intercambiables de extrudir metal',82,8207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820730,'Ferramentas intercambiáveis de embutir, estampar ou de puncionar, de metais comuns','Interchangeable tools for pressing, stamping or punching','Útiles de embutir, estampar o punzonar, intercambiables',82,8207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820740,'Ferramentas intercambiáveis de roscar interior ou exteriormente, de metais comuns','Tools for tapping or threading, interchangeable','Útiles de roscar "incl. aterrajar", intercambiables',82,8207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820750,'Ferramentas intercambiáveis de furar, de metais comuns','Tools for drilling, interchangeable (excl. rock-drilling or earth-boring tools and tools for tapping)','Útiles de taladrar, intercambiables (exc. de perforación o sondeo, así como de roscar "incl. aterrajar")',82,8207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820760,'Ferramentas intercambiáveis de mandrilar ou de brochar, de metais comuns','Interchangeable tools for boring or broaching','Útiles de escariar o brochar, intercambiables',82,8207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820770,'Ferramentas intercambiáveis de fresar, de metais comuns','Interchangeable tools for milling','Útiles de fresar, intercambiables',82,8207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820780,'Ferramentas intercambiáveis de tornear, de metais comuns','Interchangeable tools for turning','Útiles de tornear, intercambiables',82,8207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820790,'Outras ferramentas intercambiáveis para ferramentas manuais, de metais comuns','Interchangeable tools for hand tools, whether or not power-operated, or for machine tools, n.e.s.','Útiles intercambiables, para herramientas de mano, incl. mecánicas, o para máquinas herramienta, n.c.o.p.',82,8207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820810,'Facas e lâminas cortantes, para máquinas ou aparelhos mecânicos, para trabalhar metais, de metais comuns','Knives and cutting blades, of base metal, for machines or for mechanical appliances, for metalworking','Cuchillas y hojas cortantes, de metal común, para máquinas o aparatos mecánicos, para trabajar metal',82,8208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820820,'Facas e lâminas cortantes para aparelhos mecânicos, para trabalhar madeira, de metais comuns','Knives and cutting blades, of base metal, for machines or for mechanical appliances, for wood-working','Cuchillas y hojas cortantes, de metal común, para máquinas o aparatos mecánicos, para trabajar madera',82,8208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820830,'Facas e lâminas cortantes, para aparelhos de cozinha ou para máquinas das indústrias alimentares, de metais comuns','Knives and cutting blades, of base metal, for kitchen appliances or for machines used by the food industry','Cuchillas y hojas cortantes, de metal común, para aparatos de cocina o máquinas de la industria alimentaria',82,8208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820840,'Facas e lâminas cortantes, para máquinas de agricultura, horticultura ou silvicultura, de metais comuns','Knives and cutting blades, of base metal, for agricultural, horticultural or forestry machines (excl. those for wood-working)','Cuchillas y hojas cortantes, de metal común, para máquinas agrícolas, hortícolas o forestales (exc. para trabajar madera)',82,8208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820890,'Outras facas e lâminas cortantes, para máquinas ou para aparelhos mecânicos, de metais comuns','Knives and cutting blades, of base metal, for machines or for mechanical appliances (excl. those for metal or wood-working, kitchen appliances or machines used by the food industry and those for agricultural, horticultural or forestry machines)','Cuchillas y hojas cortantes, de metal común, para máquinas o aparatos mecánicos (exc. para trabajar metal, para trabajar madera, para aparatos de cocina o máquinas de la industria alimentaria, para máquinas agrícolas, hortícolas o forestales)',82,8208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (820900,'Plaquetas, varetas, pontas e objetos semelhantes para ferramentas, não montados, de ceramais (cermets)','Plates, sticks, tips and the like for tools, unmounted, of sintered metal carbides or cermets','Plaquitas, varillas, puntas y artículos simil. para útiles, sin montar, de carburo metálico sinterizados o de cermet',82,8209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821000,'Aparelhos mecânicos de acionamento manual, pesando <= 10 kg, utilizados para preparar, acondicionar ou servir alimentos ou bebidas','Hand-operated mechanical devices, of base metal, weighing <= 10 kg, used in the preparation, conditioning or serving of food or drink','Aparatos mecánicos accionados a mano, de metal común, con un peso <= 10 kg, utilizados para preparar, acondicionar o servir alimentos o bebidas',82,8210);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821110,'Facas de lâmina cortante ou serrilhada e suas lâminas, sortidos','Sets of assorted articles of knives of heading 8211; sets in which there is a higher number of knives of heading 8211 than of any other article','Juegos de distintos cuchillos de la partida 8211; juegos en que los cuchillos de la partida 8211 predominen en número sobre los demás artículos',82,8211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821191,'Facas de mesa, de lâmina fixa, de metais comuns','Table knives having fixed blades of base metal, incl. handles (excl. butter knives and fish knives)','Cuchillos de mesa de hoja fija, de metal común, incl. los mangos (exc. cuchillos para pescado y cuchillos para mantequilla)',82,8211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821192,'Outras facas de lâmina fixa, de metais comuns','Knives with fixed blades of base metal (excl. straw knives, machetes, knives and cutting blades for machines or mechanical appliances, table knives, fish knives, butter knives, razors and razor blades and knives of heading 8214)','Cuchillos de hoja fija de metal común (exc. cuchillas para heno y para paja, machetes y cuchillos de injertar para jardineros, cuchillas y hojas cortantes para máquinas o para aparatos mecánicos, cuchillos de mesa, cuchillos para pescado, cuchillos para m',82,8211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821193,'Facas, exceto as de lâminas fixas, incluídas as podadeiras de lâmina móvel, de metais comuns','Knives having other than fixed blades, incl. pruning knives, of base metal (excl. razors)','Cuchillos, incl. las de podar, de metal común (exc. los de hoja fija y navajas de afeitar)',82,8211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821194,'Lâminas para facas, de metais comuns','Blades of base metal for table knives, pocket knives and other knives of heading 8211','Hojas de metal común, para cuchillos de mesa y demás cuchillos de la partida 8211',82,8211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821195,'Cabos de metais comuns para facas','Handles of base metal for table knives, pocket knives and other knives of heading 8211','Mangos para cuchillos, con hoja cortante o dentada, incl. las navajas de podar, de metal común',82,8211);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821210,'Navalhas e aparelhos, de barbear, de metais comuns','Non-electric razors of base metal','Navajas y maquinillas no eléctricas de afeitar, de metal común',82,8212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821220,'Laminas de barbear, de segurança, incluídos os esboços em tiras, de metais comuns','Safety razor blades of base metal, incl. razor blade blanks in strips','Hojas para maquinillas de afeitar, de metal común, incl. los esbozos en fleje',82,8212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821290,'Outras partes de navalhas e aparelhos, de barbear, de metais comuns','Parts of non-electric razors of base metal (excl. safety razor blades and razor blade blanks in strips)','Partes de navajas y de maquinillas no eléctricas de afeitar, de metal común (exc. hojas de maquinillas de afeitar, incl. los esbozos en fleje)',82,8212);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821300,'Tesouras e suas lâminas, de metais comuns','Scissors, tailors'' shears and similar shears, and blades therefor, of base metal (excl. hedge shears, two-handed pruning shears and similar two-handed shears, secateurs and similar one-handed pruners and shears and hoof nippers for farriers)','Tijeras y sus hojas, de metal común (exc. cizallas para setos, tijeras de podar y herramientas simil. para usar con las dos manos; tijeras de podar para usar con una sola mano; tijeras especiales de herradores para cortar cascos)',82,8213);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821410,'Espátulas, abre-cartas, raspadeiras, apontadores de lápis (apara-lápis) e suas lâminas, de metais comuns','Paperknives, letter openers, erasing knives, pencil sharpeners and blades therefor, of base metal (excl. machinery and mechanical appliances of chapter 83)','Cortapapeles, abrecartas, raspadores, sacapuntas y sus cuchillas, de metal común (exc. máquinas y aparatos del capítulo 84)',82,8214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821420,'Utensílios e sortidos de utensílios de manicuros ou de pedicuros (incluídas as limas para unhas), de metais comuns','Manicure or pedicure sets and instruments, incl. nail files, of base metal (excl. ordinary scissors)','Herramientas y juegos de herramientas de manicura o pedicuro, incl. las limas uñas, de metal común (exc. tijeras ordinarias)',82,8214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821490,'Outros artigos de cutelaria e suas partes, de metais comuns','Hair clippers, butchers'' or kitchen cleavers and other articles of cutlery of base metal, n.e.s.','Máquinas de cortar el pelo o de esquilar y demás artículos de cuchillería, n.c.o.p., de metal común',82,8214);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821510,'Sortidos de colheres, garfos, conchas e outros artigos de posição 8215, contendo pelo menos um objeto prateado, dourado ou platinado, de metais comuns','Sets of spoons, forks or other articles of heading 8215, which may also contain up to an equivalent number of knives, of base metal, containing at least one article plated with precious metal','Juegos formados por uno o varios cuchillos y un número, por lo menos, igual de cucharas, tenedores u otros artículos de la partida 8215, de metal común, que contengan por lo menos un objeto plateado, dorado o platinado',82,8215);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821520,'Outros sortidos de colheres, garfos, conchas ou outros artigos da posição 8215, de metais comuns','Sets consisting of one or more knives of heading 8211 and at least an equal number of spoons, forks or other articles of heading 8215, of base metal, containing no articles plated with precious metal','Juegos formados por uno o varios cuchillos y un número, por lo menos, igual de cucharas, tenedores u otros artículos de la partida 8215, de metal común, que no contengan ningún objeto plateado, dorado o platinado',82,8215);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821591,'Colheres, garfos, conchas e semelhantes, prateados, dourados ou platinados, de metais comuns','Spoons, forks, ladles, skimmers, cake-servers, fish-knives, butter-knives, sugar tongs and similar kitchen or tableware of base metal, plated with precious metal (excl. sets of articles such as lobster cutters and poultry shears)','Cucharas, tenedores, cucharones, espumaderas, palas para tarta, cuchillos para pescado o para mantequilla, pinzas para azúcar y artículos simil., de metal común, plateados, dorados o platinados (exc. juegos, así como tijeras para aves o para langostas)',82,8215);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (821599,'Outras colheres, garfos, conchas e artefatos semelhantes, de metais comuns','Spoons, forks, ladles, skimmers, cake-servers, fish-knives, butter-knives, sugar tongs and similar kitchen or tableware of base metal, not plated with precious metal (excl. sets of articles such as lobster cutters and poultry shears)','Cucharas, tenedores, cucharones, espumaderas, palas para tarta, cuchillos para pescado o para mantequilla, pinzas para azúcar y artículos simil., de metal común, sin platear, dorar ni platinar (exc. juegos, así como tijeras para aves o para langostas)',82,8215);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830110,'Cadeados de metais comuns','Padlocks of base metal','Candados de metal común',83,8301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830120,'Fechaduras utilizadas em veículos automóveis, de metais comuns','Locks used for motor vehicles, of base metal','Cerraduras de los tipos utilizados en vehículos automóviles, de metal común',83,8301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830130,'Fechaduras para móveis, de metais comuns','Locks used for furniture, of base metal','Cerraduras de los tipos utilizados en muebles, de metal común',83,8301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830140,'Outras fechaduras e ferrolhos, de metais comuns','Locks of base metal (excl. padlocks and locks for motor vehicles or furniture)','Cerraduras y cerrojos, de metal común (exc. candados y cerraduras de los tipos utilizados en muebles o en vehículos automóviles)',83,8301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830150,'Fechos e armações com fecho, com fechadura, de metais comuns','Clasps and frames with clasps, incorporating locks, of base metal','Cierres y monturas cierre, con cerradura, de metal común',83,8301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830160,'Partes de cadeados ou fechaduras, de metais comuns','Parts of padlocks, locks, clasps and frames with clasps, incorporating locks, of base metal, n.e.s.','Partes de candados, de cerraduras y de cerrojos, así como de cierres y de monturas cierre, con cerradura, de metal común, n.c.o.p.',83,8301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830170,'Chaves apresentadas isoladamente, de metais comuns','Keys presented separately for padlocks, locks, clasps and frames with clasps incorporating locks, of base metal, n.e.s','Llaves presentadas aisladamente, para candados, cerraduras, cerrojos, cierres y monturas cierre con cerradura, de metal común',83,8301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830210,'Dobradiças de qualquer tipo (incluídos os gonzos e as charneiras), de metais comuns','Hinges of all kinds, of base metal','Bisagras de cualquier clase, incl. los pernios y demás goznes, de metal común',83,8302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830220,'Rodízios com armação, de metais comuns','Castors with mountings of base metal','Ruedas con montura, de metal común',83,8302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830230,'Guarnições, ferragens e artefatos semelhantes, para veículos automóveis, de metais comuns','Base metal mountings, fittings and similar articles suitable for motor vehicles (excl. hinges and castors)','Guarniciones, herrajes y artículos simil., de metal común, para vehículos automóviles (exc. cerraduras y bisagras)',83,8302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830241,'Guarnições, ferragens e artefatos semelhantes, para construções, de metais comuns','Base metal mountings and fittings suitable for buildings (excl. locks with keys and hinges)','Guarniciones, herrajes y artículos simil., de metal común, para edificios (exc. cerraduras, cerrojos con cerradura y bisagras)',83,8302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830242,'Guarnições, ferragens e artefatos semelhantes, para móveis, de metais comuns','Base metal mountings, fittings and similar articles suitable for furniture (excl. locks with keys, hinges and castors)','Guarniciones, herrajes y artículos simil., de metal común, para muebles (exc. cerraduras, cerrojos con cerradura, bisagras y ruedas con montura)',83,8302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830249,'Outras guarnições, ferragens e artefatos semelhantes, de metais comuns','Base metal mountings, fittings and similar articles (excl. locks with keys, clasps and frames with clasps incorporating locks, hinges, castors and mountings and fittings suitable for buildings, motor vehicles or furniture)','Guarniciones, herrajes y artículos simil., de metal común (exc. para vehículos automóviles, para edificios y para muebles, así como cerraduras, cerrojos con cerradura, cierres, monturas cierre con cerradura, bisagras y ruedas con montura)',83,8302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830250,'Pateras, porta-chapéus, cabides e artefatos semelhantes, de metais comuns','Hat-racks, hat-pegs, brackets and similar fixtures of base metal','Colgadores, perchas, soportes y artículos simil., de metal común',83,8302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830260,'Fechos automáticos para portas, de metais comuns','Automatic door closers of base metal','Cierrapuertas automáticos, de metal común',83,8302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830300,'Cofres-fortes, portas blindadas e compartimentos para casas-fortes, cofres e caixas de segurança e artefatos semelhantes, de metais comuns','Armoured or reinforced safes, strongboxes and doors and safe deposit lockers for strongrooms, cash or deed boxes and the like, of base metal','Cajas de caudales, puertas blindadas y compartimientos para cámaras acorazadas, cofres y cajas de seguridad y artículos simil., de metal común',83,8303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830400,'Classificadores, fichários, porta-canetas, porta-carimbos e outros artefatos semelhantes, de escritório, de metais comuns','Filing cabinets, card-index cabinets, paper trays, paper rests, pen trays, office-stamp stands and similar office or desk equipment, of base metal (excl. office furniture of heading 9403 and waste paper bins)','Clasificadores, ficheros, cajas de clasificación, bandejas de correspondencia, plumeros "vasos o cajas para plumas de escribir", portasellos y material similar para oficina, de metal común (exc. muebles para oficina de la partida 9403 y papeleras)',83,8304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830510,'Ferragens para encadernação de folhas móveis, ou para classificadores, de metais comuns','Fittings for loose-leaf binders or files, of base metal (excl. drawing pins and clasps for books or registers)','Mecanismos para encuadernación de hojas intercambiables o para clasificadores, de metal común (exc. cierres o manecillas para libros o registros)',83,8305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830520,'Grampos apresentados em barretas, de metais comuns','Staples in strips, of base metal','Grapas en tiras, de metal común',83,8305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830590,'Molas para papéis e outros objetos de escritório, de metais comuns','Office articles such as letter clips, letter corners, paper clips and indexing tags, of base metal, incl. parts of articles of heading 8305 (excl. fittings for loose-leaf binders or files, staples in strips, drawing pins and clasps for books or registers)','Sujetadores, cantoneras, clips, índices de señal y objetos simil. para oficina, de metal común, incl. las partes de artículos de la partida 8305 (exc. mecanismos completos para encuadernación de hojas intercambiables o para clasificadores, grapas en tiras',83,8305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830610,'Sinos, campainhas, gongos e artefatos semelhantes, não elétricos, de metais comuns','Bells, gongs and the like, non-electric, of base metal (excl. musical instruments)','Campanas, campanillas, gongos y artículos simil., que no sean eléctricos, de metal común (exc. instrumentos de música)',83,8306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830621,'Estatuetas e outros objetos de ornamentação, prateados, dourados ou platinados, de metais comuns','Statuettes and other ornaments, of base metal, plated with precious metal (excl. works of art, collectors'' pieces and antiques)','Estatuillas y demás artículos de adorno, de metal común, plateados, dorados o platinados (exc. objetos de arte o de colección y antigüedades)',83,8306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830629,'Outras estatuetas e outros objetos de ornamentação, de metais comuns','Statuettes and other ornaments, of base metal, not plated with precious metal (excl. works of art, collectors'' pieces and antiques)','Estatuillas y demás artículos de adorno, de metal común, sin platear, dorar ni platinar (exc. objetos de arte o de colección y antigüedades)',83,8306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830630,'Molduras para fotografias, gravuras, ou semelhantes; espelhos, de metais comuns','Photograph, picture or similar frames, of base metal; mirrors of base metal (excl. optical elements)','Marcos para fotografías, grabados o simil., de metal común; espejos de metal común (exc. elementos de óptica)',83,8306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830710,'Tubos flexíveis de ferro ou aço, mesmo com acessórios','Flexible tubing of iron or steel, with or without fittings','Tubos flexibles de hierro o acero, incl. con sus accesorios',83,8307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830790,'Tubos flexíveis de outros metais comuns','Flexible tubing of base metal other than iron or steel, with or without fittings','Tubos flexibles de metales distintos del hierro o del acero, incl. con sus accesorios',83,8307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830810,'Grampos, colchetes e ilhoses, de metais comuns, para vestuário','Hooks, eyes and eyelets, of base metal, of a kind used for clothing, footwear, awnings, handbags, travel goods or other made-up articles','Corchetes, ganchos y anillos para ojetes, de metal común, para prendas de vestir, calzado, toldos, marroquinería o para cualquier confección o artículo',83,8308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830820,'Rebites tubulares ou de haste fendida, de metais comuns','Tubular or bifurcated rivets, of base metal','Remaches tubulares o con espiga hendida, de metal común',83,8308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830890,'Outros fechos, fivelas e artefatos semelhantes, de metais comuns, para vestuário, calçados, bolsas','Clasps, frames with clasps without locks, buckles and buckle-clasps, of base metal, for clothing, footwear, handbags, travel goods or other made-up articles, incl. parts of articles of heading 8308, of base metal (excl. hooks, eyes, eyelets and tubular or','Cierres, monturas cierre sin cerradura, hebillas, hebillas cierre y artículos simil., de metal común, para prendas de vestir, calzado, toldos, marroquinería y demás, incl. las partes de artículos de la partida 8308, de metal común (exc. corchetes, ganchos',83,8308);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830910,'Cápsulas de coroa, de metais comuns, para embalagem','Crown corks of base metal','Tapas corona de metal común',83,8309);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (830990,'Rolhas, outras tampas e acessórios para embalagem, de metais comuns','Stoppers, caps and lids, incl. screw caps and pouring stoppers, capsules for bottles, threaded bungs, bung covers, seals and other packing accessories of base metal (excl. crow corks)','Tapones, tapas, incl. las tapas roscadas y los tapones vertedores, cápsulas para botellas, tapones roscados, sobretapas, precintos y demás accesorios para envases, de metal común (exc. tapas corona)',83,8309);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (831000,'Placas indicadoras e sinalizadoras, placas-endereços e semelhantes, números, letras e sinais diversos, de metais comuns, não elétricos','Sign-plates, nameplates, address-plates and similar plates, numbers, letters and other symbols, of base metal, incl. traffic signs (excl. those of heading 9405, type and the like, and signal boards, signal discs and signal arms for traffic of heading 8608','Placas indicadoras, placas rótulo, placas de direcciones y placas simil., cifras, letras y signos diversos, de metal común (exc. placas y señales de la partida 9405, caracteres de imprenta y simil., así como placas, discos y semáforos para vías de comunic',83,8310);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (831110,'Eletrodos revestidos exteriormente para soldar a arco, de metais comuns','Coated electrodes of base metal, for electric arc-welding','Electrodos recubiertos para soldadura de arco, de metal común',83,8311);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (831120,'Fios revestidos interiormente para soldar a arco, de metais comuns','Cored wire of base metal, for electric arc-welding','Alambre "relleno" para soldadura de arco, de metal común',83,8311);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (831130,'Varetas revestidas exteriormente e fios revestidos interiormente, para soldar à chama, de metais comuns','Coated rods and cored wire, of base metal, for soldering, brazing or welding by flame (excl. wire and rods cored with solder which, excl. the flux material, contains >= 2% by weight of precious metal)','Varillas recubiertas y alambre "relleno" para soldar al soplete, de metal común (exc. alambres y varillas para soldar rellenos en los que, dejando aparte los decapantes y fundentes, la soldadura contenga >= 2% en peso de un metal precioso)',83,8311);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (831190,'Outros fios, varetas, tubos, chapas e semelhantes, de metais comuns, para soldagem ou depósito de metal','Wire, rods, tubes, plates, electrodes and the like, of base metal or of metal carbides, coated or cored with flux material, for soldering, brazing, welding or deposition of metal or metal carbides, n.e.s., and wire and rods of agglomerated base metal powd','Alambres, varillas, tubos, placas, electrodos y artículos simil., de metal común o de carburo metálico, recubiertos o rellenos de decapantes o de fundentes, para soldadura o depósito de metal o de carburo metálico, n.c.o.p.; alambres y varillas, de polvo ',83,8311);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840110,'Reatores nucleares','Nuclear reactors [Euratom]','Reactores nucleares [Euratom]',84,8401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840120,'Máquinas e aparelhos para separação de isótopos e suas partes','Machinery and apparatus for isotopic separation and parts thereof, n.e.s. [Euratom]','Máquinas y aparatos para la separación isotópica y sus partes, n.c.o.p. [Euratom]',84,8401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840130,'Elementos combustíveis (cartuchos) não irradiados, para reatores nucleares','Fuel elements cartridges, non-irradiated, in casing with handling fixtures, for nuclear reactors [Euratom]','Elementos combustibles "cartuchos", sin irradiar, en vaina con dispositivos especiales para permitir su manipulación [Euratom]',84,8401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840140,'Partes de reatores nucleares','Parts of nuclear reactors, n.e.s. [Euratom]','Partes de reactores nucleares, n.c.o.p. [Euratom]',84,8401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840211,'Caldeiras aquatubulares com produção de vapor > 45 t por hora','Watertube boilers with a steam production > 45 t/hour','Calderas acuotubulares, con una producción de vapor > 45 t/h',84,8402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840212,'Caldeiras aquatubulares com produção de vapor <= 45 t por hora','Watertube boilers with a steam production <= 45 t/hour (excl. central heating hot water boilers capable also of producing low pressure steam)','Calderas acuotubulares, con una producción de vapor <= 45 t/h (exc. las de calefacción central concebidas para producir agua caliente y también vapor a baja presión)',84,8402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840219,'Outras caldeiras para produção de vapor, incluídas as caldeiras mistas','Vapour generating boilers, incl. hybrid boilers (excl. central heating hot water boilers capable also of producing low pressure steam)','Calderas de vapor, incl. las calderas mixtas (exc. calderas acuotubulares, así como las de calefacción central concebidas para producir agua caliente y también vapor a baja presión)',84,8402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840220,'Caldeiras denominadas de água superaquecida','Superheated water boilers','Calderas denominadas "de agua sobrecalentada"',84,8402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840290,'Partes de caldeiras de vapor e de água superaquecida','Parts of vapour generating boilers and superheated water boilers, n.e.s.','Partes de calderas de vapor y de calderas denominadas "de agua sobrecalentada"',84,8402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840310,'Caldeiras para aquecimento central, exceto as da posição 8402','Central heating boilers, non-electric (excl. vapour generating boilers and superheated water boilers of heading 8402)','Calderas para calefacción central, no eléctricas (exc. calderas de vapor y calderas denominadas "de agua sobrecalentada" de la partida 8402)',84,8403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840390,'Partes de caldeiras para aquecimento central','Parts of central heating boilers, n.e.s.','Partes de calderas para calefacción central, n.c.o.p.',84,8403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840410,'Aparelhos auxiliares para caldeiras das posições 8402 ou 8403','Auxiliary plant for use with boilers of heading 8402 or 8403, e.g. economizers, superheaters, soot removers and gas recoverers;','Economizadores, recalentadores, deshollinadores, recuperadores de gas y demás aparatos auxiliares para las calderas de las partidas 8402 u 8403',84,8404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840420,'Condensadores para máquinas a vapor','Condensers for steam or other vapour power units','Condensadores para máquinas de vapor',84,8404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840490,'Partes de aparelhos auxiliares para caldeiras das posições 8402 ou 8403 e partes de condensadores para máquinas a vapor','Parts of auxiliary plant of heading 8402 or 8403 and condensers for steam or other vapour power units, n.e.s.','Partes de aparatos auxiliares para las calderas de las partidas 8402 u 8403 y partes de condensadores para máquinas de vapor, n.c.o.p.',84,8404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840510,'Geradores de gás de ar ou de água, de acetileno e geradores semelhantes de gás, operados a água, com ou sem depuradores','Producer gas or water gas generators, with or without their purifiers; acetylene gas generators and similar water process gas generators, with or without their purifiers (excl. coke ovens, electrolytic process gas generators and carbide lamps)','Generadores de gas pobre "gas de aire" o de gas de agua, incl. con sus depuradores; generadores de acetileno y generadores simil. de gases, por vía húmeda, incl. con sus depuradores (exc. hornos de coque, gasógenos por procedimiento electrolítico y lámpar',84,8405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840590,'Partes de geradores de gás de ar ou de água, de acetileno e geradores semelhantes de gás, operados a água, com ou sem depuradores','Parts of producer gas or water gas generators and acetylene gas generators or similar water process gas generators, n.e.s.','Partes de generadores de gas pobre "gas de aire" o de gas de agua; partes de generadores de acetileno y generadores simil. de gases, por vía húmeda, n.c.o.p.',84,8405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840610,'Turbinas a vapor para propulsão de embarcações','Steam and other vapour turbines for marine propulsion','Turbinas de vapor para la propulsión de barcos',84,8406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840681,'Outras turbinas a vapor, de potência > 40 MW','Steam and other vapour turbines, of an output > 40 MW (excl. those for marine propulsion)','Turbinas de vapor, de potencia > 40 MW (exc. para la propulsión de barcos)',84,8406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840682,'Outras turbinas a vapor, de potência <= 40 MW','Steam and other vapour turbines, of an output <= 40 MW (excl. those for marine propulsion)','Turbinas de vapor, de potencia <= 40 MW (exc. para la propulsión de barcos)',84,8406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840690,'Partes de turbinas a vapor','Parts of steam and other vapour turbines, n.e.s.','Partes de turbinas de vapor, n.c.o.p.',84,8406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840710,'Motores para aviação','Spark-ignition reciprocating or rotary internal combustion piston engine, for aircraft','Motores de émbolo "pistón" alternativo de encendido por chispa o motores rotativos, de encendido por chispa "motores de explosión", de aviación',84,8407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840721,'Motores de explosão para propulsão de embarcações, de fixação externa ao casco (tipo outboard)','Spark-ignition outboard motors for marine propulsion','Motores del tipo fueraborda, de encendido por chispa "motores de explosión", para la propulsión de barcos',84,8407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840729,'Outros motores de pistão alternativo, de ignição por centelha, para propulsão de embarcações','Spark-ignition reciprocating or rotary internal combustion piston engine for marine propulsion (excl. outboard motors)','Motores de émbolo "pistón" alternativo de encendido por chispa y motores rotativos, de encendido por chispa "motores de explosión", para la propulsión de barcos (exc. del tipo fueraborda)',84,8407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840731,'Motores de pistão alternativo, de ignição por centelha, para propulsão de veículos do capítulo 87, de cilindrada até 50 cm3','Spark-ignition reciprocating piston engine, of a kind used for the propulsion of vehicles of chapter 87, of a cylinder capacity <= 50 cm³','Motores de émbolo "pistón" alternativo de encendido por chispa de encendido por chispa "motores de explosión", de los tipos utilizados para la propulsión de vehículos del capítulo 87, de cilindrada <= 50 cm³',84,8407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840732,'Motores de pistão alternativo, de ignição por centelha, para propulsão de veículos do capítulo 87, de cilindrada superior a 50 cm3 até 250 cm3','Spark-ignition reciprocating piston engine, of a kind used for the propulsion of vehicles of chapter 87, of a cylinder capacity > 50 cm³ but <= 250 cm³','Motores de émbolo "pistón" alternativo de encendido por chispa de encendido por chispa "motores de explosión", de los tipos utilizados para la propulsión de vehículos del capítulo 87, de cilindrada > 50 cm³ pero <= 250 cm³',84,8407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840733,'Motores de pistão alternativo, de ignição por centelha, para propulsão de veículos do capítulo 87, de cilindrada > 250 cm3 e <= 1.000 cm3','Spark-ignition reciprocating piston engine, of a kind used for vehicles of chapter 87, of a cylinder capacity > 250 cm³ but <= 1.000 cm³','Motores de émbolo "pistón" alternativo de encendido por chispa de encendido por chispa "motores de explosión", de los tipos utilizados para la propulsión de vehículos del capítulo 87, de cilindrada > 250 cm³ pero <= 1.000 cm³',84,8407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840734,'Motores de pistão alternativo, de ignição por centelha, para propulsão de veículos do capítulo 87, de cilindrada > 1.000 cm3','Spark-ignition reciprocating piston engine, of a kind used for vehicles of chapter 87, of a cylinder capacity > 1.000 cm³','Motores de émbolo "pistón" alternativo de encendido por chispa de encendido por chispa "motores de explosión", de los tipos utilizados para la propulsión de vehículos del capítulo 87, de cilindrada > 1.000 cm³',84,8407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840790,'Outros motores de pistão alternativo ou rotativo, de ignição por centelha','Spark-ignition reciprocating or rotary internal combustion piston engine (excl. those for aircraft or marine propulsion and reciprocating piston engine of a kind used for vehicles of chapter 87)','Motores de émbolo "pistón" alternativo de encendido por chispa y motores rotativos, de encendido por chispa "motores de explosión" (exc. de aviación, para la propulsión de barcos y motores de émbolo "pistón" alternativo de encendido por chispa de los tipo',84,8407);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840810,'Motores de pistão, de ignição por compressão, diesel ou semi-diesel, para propulsão de embarcações','Compression-ignition internal combustion piston engine diesel or semi-diesel engine, for marine propulsion','Motores de émbolo "pistón" de encendido por compresión "motores diesel o semi-diesel", para la propulsión de barcos',84,8408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840820,'Motores de pistão, de ignição por compressão, diesel ou semi-diesel, utilizados para propulsão de veículos do capítulo 87','Compression-ignition internal combustion piston engine diesel or semi-diesel engine, for the propulsion of vehicles of chapter 87','Motores de émbolo "pistón" de encendido por compresión "motores diesel o semi-diesel", de los tipos utilizados para la propulsión de vehículos automóviles del capítulo 87',84,8408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840890,'Outros motores de pistão, de ignição por compressão, diesel ou semidiesel','Compression-ignition internal combustion piston engine diesel or semi-diesel engine (excl. engines for marine propulsion and engines for vehicles of chapter 87)','Motores de émbolo "pistón" de encendido por compresión "motores diesel o semi-diesel" (exc. motores para la propulsión de barcos y motores de los tipos utilizados para la propulsión de vehículos automóviles del capítulo 87)',84,8408);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840910,'Partes de motores para aviação','Parts suitable for use solely or principally with internal combustion piston engine for aircraft, n.e.s.','Partes identificables como destinadas exclusiva o principalmente a motores de émbolo "pistón" de aviación, n.c.o.p.',84,8409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840991,'Outras partes exclusiva ou principalmente destinadas aos motores de pistão, de ignição por centelha','Parts suitable for use solely or principally with spark-ignition internal combustion piston engine, n.e.s.','Partes identificables como destinadas exclusiva o principalmente a motores de émbolo "pistón" de encendido por chispa, n.c.o.p.',84,8409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (840999,'Outras partes para motores diesel ou semidiesel','Parts suitable for use solely or principally with compression-ignition internal combustion piston engine diesel or semi-diesel engine, n.e.s.','Partes identificables como destinadas exclusiva o principalmente a motores de émbolo "pistón" de encendido por compresión "motores diesel o semi-diesel", n.c.o.p.',84,8409);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841011,'Turbinas e rodas hidráulicas, de potência <= 1.000 kW','Hydraulic turbines and water wheels, of a power <= 1.000 kW (excl. hydraulic power engines and motors of heading 8412)','Turbinas hidráulicas y ruedas hidráulicas, de potencia <= 1.000 kW (exc. motores hidráulicos de la partida 8412)',84,8410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841012,'Turbinas e rodas hidráulicas, de potência > 1.000 kW e <= 10.000 kW','Hydraulic turbines and water wheels, of a power > 1.000 kW but <= 10.000 kW (excl. hydraulic power engines and motors of heading 8412)','Turbinas hidráulicas y ruedas hidráulicas, de potencia > 1.000 kW pero <= 10.000 kW (exc. motores hidráulicos de la partida 8412)',84,8410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841013,'Turbinas e rodas hidráulicas, de potência > 10.000 kW','Hydraulic turbines and water wheels, of a power > 10.000 kW (excl. hydraulic power engines and motors of heading 8412)','Turbinas hidráulicas y ruedas hidráulicas, de potencia > 10.000 kW (exc. motores hidráulicos de la partida 8412)',84,8410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841090,'Partes de turbinas e rodas hidráulicas, incluídos os reguladores','Parts of hydraulic turbines and water wheels, n.e.s.; hydraulic turbine regulators','Partes de turbinas hidráulicas y de ruedas hidráulicas, n.c.o.p.; reguladores para turbinas hidráulicas',84,8410);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841111,'Turborreatores, de empuxo <= 25 kN','Turbojets of a thrust <= 25 kN','Turborreactores, de empuje <= 25 kN',84,8411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841112,'Turborreatores, de empuxo > 25 kN','Turbojets of a thrust > 25 kN','Turborreactores, de empuje > 25 kN',84,8411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841121,'Turbopropulsores, de potência <= 1.100 kW','Turbopropellers of a power <= 1.100 kW','Turbopropulsores, de potencia <= 1.100 kW',84,8411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841122,'Turbopropulsores, de potência > 1.100 kW','Turbopropellers of a power > 1.100 kW','Turbopropulsores, de potencia > 1.100 kW',84,8411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841181,'Outras turbinas a gás, de potência <= 5.000 kW','Gas turbines of a power <= 5.000 kW (excl. turbojets and turbopropellers)','Turbinas de gas, de potencia <= 5.000 kW (exc. turborreactores y turbopropulsores)',84,8411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841182,'Outras turbinas a gás, de potência > 5.000 kW','Gas turbines of a power > 5.000 kW (excl. turbojets and turbopropellers)','Turbinas de gas, de potencia > 5.000 kW (exc. turborreactores y turbopropulsores)',84,8411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841191,'Partes de turborreatores ou de turbopropulsores','Parts of turbojets or turbopropellers, n.e.s.','Partes de turborreactores o de turbopropulsores, n.c.o.p.',84,8411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841199,'Partes de outras turbinas a gás','Parts of gas turbines, n.e.s.','Partes de turborreactores o de turbopropulsores, n.c.o.p.',84,8411);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841210,'Propulsores a reação, excluídos os turborreatores','Reaction engines other than turbojets','Propulsores a reacción, distintos de los turborreactores',84,8412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841221,'Motores hidráulicos, de movimento retilíneo (cilindros)','Hydraulic power engines and motors, linear acting cylinders','Motores hidráulicos, con movimiento rectilíneo "cilindros"',84,8412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841229,'Outros motores hidráulicos','Hydraulic power engines and motors (excl. hydraulic turbines and water wheels of heading 8410, steam turbines and hydraulic power engines and motors, linear acting)','Motores hidráulicos (exc. turbinas hidráulicas o ruedas hidráulicas de la partida 8410, turbinas de vapor de la partida 8410, turbinas de vapor y motores hidráulicos con movimiento rectilíneo "cilindros")',84,8412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841231,'Motores pneumáticos, de movimento retilíneo (cilindros)','Pneumatic power engines and motors, linear-acting, cylinders','Motores neumáticos, con movimiento rectilíneo "cilindros"',84,8412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841239,'Outros motores pneumáticos','Pneumatic power engines and motors (excl. linear acting)','Motores neumáticos (exc. con movimiento rectilíneo "cilindros")',84,8412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841280,'Outros motores e máquinas motrizes','Engines and motors (excl. steam turbines, internal combustion piston engine, hydraulic turbines, water wheels, gas turbines, reaction engines, hydraulic power engines and motors, pneumatic power engines and motors and electric motors)','Motores y máquinas motrices (exc. turbinas de vapor, motores de émbolo "pistón", turbinas hidráulicas y ruedas hidráulicas, turbinas de gas, propulsores, motores hidráulicos y neumáticos y motores eléctricos)',84,8412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841290,'Partes de outros motores e máquinas motrizes','Parts of non-electrical engines and motors, n.e.s.','Partes de motores y de máquinas motrices, n.c.o.p.',84,8412);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841311,'Bombas para distribuição de combustíveis ou lubrificantes, com dispositivo medidor, utilizadas em postos de serviço ou garagens','Pumps fitted or designed to be fitted with a measuring device, for dispensing fuel or lubricants, of the type used in filling stations or in garages','Bombas con dispositivo medidor incorporado o concebidas para llevarlo, para distribución de carburantes o de lubricantes, de los tipos utilizados en gasolineras, estaciones de servicio o garajes',84,8413);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841319,'Outras bombas para líquidos, com dispositivo medidor ou concebidas para comportá-lo','Pumps for liquids, fitted or designed to be fitted with a measuring device (excl. pumps for dispensing fuel or lubricants, of the type used in filling stations or in garages)','Bombas con dispositivo medidor incorporado o proyectadas para llevarlo (exc. para distribución de carburantes o de lubricantes, de los tipos utilizados en gasolineras, estaciones de servicio o garajes)',84,8413);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841320,'Bombas manuais para líquidos','Hand pumps for liquids (excl. those of subheading 8413.11 and 8413.19)','Bombas manuales (exc. bombas de las subpartidas 8413.11 u 8413.19)',84,8413);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841330,'Bombas para combustíveis, lubrificantes ou líquidos de arrefecimento, para motores de ignição por centelha ou por compressão','Fuel, lubricating or cooling medium pumps for internal combustion piston engine','Bombas de carburante, aceite o refrigerante, para motores de encendido por chispa o compresión',84,8413);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841340,'Bombas para concreto (betão)','Concrete pumps','Bombas para hormigón',84,8413);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841350,'Outras bombas volumétricas alternativas','Reciprocating positive displacement pumps for liquids, power-driven (excl. those of subheading 8413.11 and 8413,19, fuel, lubricating or cooling medium pumps for internal combustion piston engine and concrete pumps)','Bombas volumétricas alternativas, accionadas mecánicamente (exc. bombas de las subpartidas 8413.11 u 8413.19, bombas de carburante, aceite o refrigerante para motores de encendido por chispa o compresión y bombas para hormigón)',84,8413);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841360,'Outras bombas volumétricas rotativas','Rotary positive displacement pumps for liquids, power-driven (excl. those of subheading 8413.11 and 8413.19 and fuel, lubricating or cooling medium pumps for internal combustion piston engine)','Bombas volumétricas rotativas, accionadas mecánicamente (exc. bombas de las subpartidas 8413.11 u 8413.19 y bombas de carburante, aceite o refrigerante para motores de encendido por chispa o compresión)',84,8413);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841370,'Outras bombas centrífugas','Centrifugal pumps, power-driven (excl. those of subheading 8413.11 and 8413.19, fuel, lubricating or cooling medium pumps for internal combustion piston engine and concrete pumps)','Bombas centrífugas, accionadas mecánicamente (exc. bombas de las subpartidas 8413.11 u 8413.19, bombas de carburante, aceite o refrigerante para motores de encendido por chispa o compresión y bombas para hormigón)',84,8413);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841381,'Outras bombas para líquidos','Pumps for liquids, power-driven (excl. those of subheading 8413.11 and 8413.19, fuel, lubricating or cooling medium pumps for internal combustion piston engine, concrete pumps, general reciprocating or rotary positive displacement pumps and centrifugal pu','Bombas para líquidos, accionadas mecánicamente (exc. bombas de las subpartidas 8413.11 u 8413.19, bombas de carburante, aceite o refrigerante para motores de encendido por chispa o compresión, bombas de hormigón y, en general, bombas volumétricas alternat',84,8413);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841382,'Elevadores de líquidos','Liquid elevators (excl. pumps)','Elevadores de líquidos (exc. bombas)',84,8413);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841391,'Partes de bombas para líquidos','Parts of pumps for liquids, n.e.s.','Partes de bombas para líquidos, n.c.o.p.',84,8413);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841392,'Partes de elevadores de líquidos','Parts of liquid elevators, n.e.s.','Partes de elevadores de líquidos, n.c.o.p.',84,8413);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841410,'Bombas de vácuo','Vacuum pumps','Bombas de vacío',84,8414);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841420,'Bombas de ar, de mão ou de pé','Hand-operated or foot-operated air pumps','Bombas de aire, de mano o pedal',84,8414);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841430,'Compressores para equipamentos frigoríficos','Compressors for refrigerating equipment','Compresores de los tipos utilizados en los equipos frigoríficos',84,8414);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841440,'Compressores de ar montados sobre chassis com rodas e rebocáveis','Air compressors mounted on a wheeled chassis for towing','Compresores de aire montados en chasis remolcable de ruedas',84,8414);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841451,'Ventiladores de mesa, de pé, de parede, de teto ou de janela, com motor elétrico incorporado, de potência <= 125 W','Table, floor, wall, window, ceiling or roof fans, with a self-contained electric motor of an output <= 125 W','Ventiladores de mesa, pie, pared, cielo raso, techo, tejado o ventana, con motor eléctrico incorporado de potencia <= 125 W',84,8414);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841459,'Outros ventiladores','Fans (excl. table, floor, wall, window, ceiling or roof fans, with a self-contained electric motor of an output <= 125 W)','Ventiladores (exc. de mesa, pie, pared, cielo raso, techo, tejado o ventana, con motor eléctrico incorporado de potencia <= 125 W)',84,8414);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841460,'Coifas com dimensão horizontal máxima <= 120 cm','Hoods incorporating a fan, whether or not fitted with filters, having a maximum horizontal side <= 120 cm','Campanas aspirantes con ventilador, incl. con filtro, en las que el mayor lado horizontal sea <= 120 cm',84,8414);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841480,'Outras bombas de ar, coifas aspirantes para extração ou reciclagem','Air pumps, air or other gas compressors and ventilating or recycling hoods incorporating a fan, whether or not fitted with filters, having a maximum horizontal side > 120 cm (excl. vacuum pumps, hand- or foot-operated air pumps, compressors for refrigerat','Bombas de aire, compresores de aire u otros gases; campanas aspirantes para extracción o reciclado, con ventilador, incl. con filtro, en las que el mayor lado horizontal sea > 120 cm (exc. bombas de vacío; bombas de aire, mano o pedal; compresores de los ',84,8414);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841490,'Outras partes de compressores de ar ou de outros gases','Parts of : air or vacuum pumps, air or other gas compressors, fans and ventilating or recycling hoods incorporating a fan, n.e.s.','Partes de bombas de aire o vacío, partes de compresores de aire u otros gases y de ventiladores, partes de campanas aspirantes para extracción o reciclado con ventilador, n.c.o.p.',84,8414);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841510,'Aparelhos de ar condicionado, dos tipos utilizados em paredes ou janelas, formando corpo único ou do tipo splitsystem (sistema com elementos separados)','Window or wall air conditioning machines, self-contained or split-system','Máquinas y aparatos para acondicionamiento de aire, de pared o para ventanas, formando un solo cuerpo o del tipo sistema de elementos separados "split-system"',84,8415);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841520,'Aparelhos de ar condicionado, do tipo utilizado nos veículos automóveis','Air conditioning machines of a kind used for persons, in motor vehicles','Máquinas y aparatos para acondicionamiento de aire, de los tipos utilizados en vehículos automóviles para sus ocupantes',84,8415);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841581,'Outros aparelhos de ar condicionado, com dispositivo de refrigeração e válvula de inversão do ciclo térmico','Air conditioning machines incorporating a refrigerating unit and a valve for reversal of the cooling-heat cycle reversible heat pumps (excl. of a kind used for persons in motor vehicles and self-contained or split-system window or wall air conditioning ma','Máquinas y aparatos para acondicionamiento de aire, con equipo de enfriamiento y válvula de inversión del ciclo térmico "bombas de calor reversibles" (exc. máquinas y aparatos de pared o para ventanas, formando un solo cuerpo o del tipo sistema de element',84,8415);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841582,'Outros aparelhos de ar condicionado, com dispositivos de refrigeração','Air conditioning machines incorporating a refrigerating unit but without a valve for reversal of the cooling-heat cycle (excl. of a kind used for persons in motor vehicles, and self-contained or split-system window or wall air conditioning machines)','Máquinas y aparatos para acondicionamiento de aire, con equipo de enfriamiento pero sin válvula de inversión del ciclo térmico (exc. máquinas y aparatos de pared o para ventanas, formando un solo cuerpo o del tipo sistema de elementos separados "split-sys',84,8415);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841583,'Outros aparelhos de ar condicionado, sem dispositivo de refrigeração','Air conditioning machines comprising a motor-driven fan, not incorporating a refrigerating unit but incorporating elements for changing the temperature and humidity (excl. of a kind used for persons in motor vehicles, and self-contained or split-system wi','Máquinas y aparatos para acondicionamiento de aire que contengan un ventilador con motor, sin equipo de enfriamiento pero con los dispositivos adecuados para modificar la temperatura y la humedad (exc. máquinas y aparatos de pared o para ventanas, formand',84,8415);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841590,'Partes de máquinas e aparelhos de ar condicionado','Parts of air conditioning machines, comprising a motor-driven fan and elements for changing the temperature and humidity, n.e.s.','Partes de máquinas y aparatos para acondicionamiento de aire que comprenden un ventilador con motor y los dispositivos adecuados para modificar la temperatura y la humedad, n.c.o.p.',84,8415);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841610,'Queimadores para alimentação de fornalhas, de combustíveis líquidos','Furnace burners for liquid fuel','Quemadores para la alimentación de hogares, de combustibles líquidos',84,8416);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841620,'Outros queimadores para alimentação de fornalhas, incluídos os mistos','Furnace burners for pulverised solid fuel or gas, incl. combination burners','Quemadores para la alimentación de hogares, de combustibles sólidos pulverizados o gases, incl. los quemadores mixtos',84,8416);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841630,'Fornalhas automáticas, incluídas as antefornalhas, grelhas mecânicas, descarregadores mecânicos de cinzas e dispositivos semelhantes','Mechanical stokers, incl. their mechanical grates, mechanical ash dischargers and similar appliances (excl. burners)','Alimentadores mecánicos de hogares, parrillas mecánicas, descargadores mecánicos de cenizas y demás dispositivos mecánicos auxiliares empleados en hogares (exc. quemadores)',84,8416);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841690,'Partes de queimadores, fornalhas automáticas e dispositivos semelhantes','Parts of furnace burners such as mechanical stokers, incl. their mechanical grates, mechanical ash dischargers and similar appliances, n.e.s.','Partes de quemadores para la alimentación de hogares; partes de alimentadores mecánicos de hogares, parrillas mecánicas, descargadores mecánicos de cenizas y demás dispositivos mecánicos auxiliares empleados en hogares, n.c.o.p.',84,8416);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841710,'Fornos para ustulação, fusão ou outros tratamentos térmicos de minérios ou de metais, não elétricos','Industrial or laboratory furnaces and ovens, non-electric, for the roasting, melting or other heat treatment of ores, pyrites or metals (excl. drying ovens)','Hornos industriales o de laboratorio, que no sean eléctricos, para tostación, fusión u otros tratamientos térmicos de los minerales metalíferos "incl. las piritas" o de los metales (exc. hornos de secado)',84,8417);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841720,'Fornos industriais de padaria, pastelaria ou da indústria de bolachas e biscoitos, não elétricos','Bakery ovens, incl. biscuit ovens, non-electric','Hornos, que no sean eléctricos, de panadería, pastelería o galletería',84,8417);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841780,'Outros fornos industriais ou de laboratório, não elétricos','Industrial or laboratory furnaces and ovens, non-electric, incl. incinerators (excl. those for the roasting, melting or other heat treatment of ores, pyrites or metals, bakery ovens, drying ovens and ovens for cracking operations)','Hornos industriales o de laboratorio, que no sean eléctricos, incl. los incineradores (exc. hornos para tostación, fusión u otros tratmientos térmicos de los minerales metalíferos "incl. las piritas" o de los metales; hornos de panadería, pastelería o gal',84,8417);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841790,'Partes de fornos industriais ou de laboratório, não elétricos','Parts of industrial or laboratory furnaces, non-electric, incl. incinerators, n.e.s.','Partes deornos industriales o de laboratorio, incl. los incineradores, que no sean eléctricos, n.c.o.p.',84,8417);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841810,'Combinações de refrigeradores e congeladores (freezers), com portas exteriores separadas','Combined refrigerator-freezers, with separate external doors','Combinaciones de refrigerador y congelador con puertas exteriores separadas',84,8418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841821,'Refrigeradores de compressão, de tipo doméstico','Household refrigerators, compression-type','Refrigeradores de compresión, domésticos',84,8418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841822,'Refrigeradores de absorção, elétricos, de uso doméstico','refrigerators of absorption, electrical, household type','refrigeradores de absorción, eléctricos, de uso doméstico',84,8418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841829,'Outros refrigeradores, de tipo doméstico','Household refrigerators, absorption-type','Refrigeradores de absorción, no eléctricos, domésticos',84,8418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841830,'Congeladores (freezers) horizontais tipo arca, de capacidade <= 800 litros','Freezers of the chest type, of a capacity <= 800 l','Congeladores horizontales del tipo arcón "cofre", de capacidad <= 800 l',84,8418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841840,'Congeladores (freezers) verticais tipo armário, de capacidade <= 900 litros','Freezers of the upright type, of a capacity <= 900 l','Congeladores verticales del tipo armario, de capacidad <= 900 l',84,8418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841850,'Outros móveis (arcas, armários, vitrines, balcões e móveis semelhantes), para a conservação e exposição de produtos que incorporem um equipamento para a produção de drio','Furniture chests, cabinets, display counters, show-cases and the like for storage and display, incorporating refrigerating or freezing equipment (excl. combined refrigerator-freezers with separate external doors, household refrigerators and freezers of th','Armarios, arcones "cofres", vitrinas, mostradores y muebles simil. para la producción de frío, con grupo frigorífico o evaporador incorporado (exc. combinaciones de refrigerador y congelador con puertas exteriores separadas; refrigeradores domésticos; con',84,8418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841861,'Bombas de calor, exceto as máquinas e aparelhos de ar-condicionado da posição 8415','Heat pumps (excl. air conditioning machines of heading 8415)','Bombas de calor, excepto las máquinas de la maquinaria y el aire acondicionado de la partida 8415',84,8418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841869,'Outros materiais, máquinas e aparelhos, para produção de frio','Refrigerating or freezing equipment (excl. refrigerating and freezing furniture)','Materiales, máquinas y aparatos para producción de frío; bombas de calor (exc. muebles para la producción de frío)',84,8418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841891,'Gabinetes ou móveis para receber um equipamento para a produção de frio','Furniture designed to receive refrigerating or freezing equipment','Muebles concebidos para incorporarles un equipo de producción de frío',84,8418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841899,'Outras partes de refrigeradores, congeladores e bombas de calor','Parts of refrigerating or freezing equipment and heat pumps, n.e.s.','Partes de refrigeradores, de congeladores y demás material, máquinas y aparatos para producción de frío, así como de bombas de calor, n.c.o.p.',84,8418);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841911,'Aquecedores de água, de aquecimento instantâneo, a gás','Instantaneous gas water heaters (excl. boilers or water heaters for central heating)','Calentadores de calentamiento instantáneo, de gas (exc. calderas de calefacción central)',84,8419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841919,'Outros aquecedores de água, não elétricos, de aquecimento instantâneo ou de acumulação','Instantaneous or storage water heaters, non-electric (excl. instantaneous gas water heaters and boilers or water heaters for central heating)','Calentadores de agua de calentamiento instantáneo o de acumulación, no eléctricos (exc. de calentamiento instantáneo de gas, así como las calderas de calefacción central)',84,8419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841920,'Esterilizadores médico-cirúrgicos ou de laboratórios','Medical, surgical or laboratory sterilizers','Esterilizadores médicos, quirúrgicos o de laboratorio',84,8419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841931,'Secadores para produtos agrícolas','Dryers for agricultural products','Secadores para productos agrícolas',84,8419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841932,'Secadores para madeiras, pastas de papel, papéis ou cartões','Dryers for wood, paper pulp, paper or paperboard','Secadores para madera, pasta para papel, papel o cartón',84,8419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841939,'Outros secadores','Dryers (excl. dryers for agricultural products, paper pulp, paper or paperboard, yarns, fabrics and other textile products, dryers for bottles or other containers, hairdryers, hand dryers and domestic appliances)','Secadores (exc. para productos agrícolas; para madera, pasta para papel, papel o cartón; para hilados, tejidos o manufacturas de materia textil; para botellas u otros recipientes; secadores para el cabello; aparatos para secar las manos y demás aparatos p',84,8419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841940,'Aparelhos de destilação ou de retificação','Distilling or rectifying plant','Aparatos de destilación o rectificación',84,8419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841950,'Trocadores (permutadores) de calor','Heat-exchange units (excl. instantaneous heaters, storage water heaters, boilers and equipment without a separating wall)','Intercambiadores de calor (exc. calentadores de agua de calentamiento instantáneo o de acumulación, calderas de calefacción y aparatos en que el intercambio térmico entre dos fluidos no se realiza a través de una pared)',84,8419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841960,'Aparelhos e dispositivos para liqüefação do ar ou de outros gases','Machinery for liquefying air or other gases','Aparatos o dispositivos para licuefacción de aire u otros gases',84,8419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841981,'Outros aparelhos e dispositivos para preparação de bebidas quentes ou para cozimento ou aquecimento de alimentos','Machinery, plant and equipment for making hot drinks or for cooking or heating food (excl. domestic appliances)','Aparatos y dispositivos para la preparación de bebidas calientes o la cocción o calentamiento de alimentos (exc. aparatos domésticos)',84,8419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841989,'Outros aparelhos e dispositivos para tratamento de matérias por meio de operações que impliquem mudança de temperatura','Machinery, plant or laboratory equipment, whether or not electrically heated, for the treatment of materials by a process involving a change of temperature such as heating, cooking, roasting, sterilising, pasteurising, steaming, evaporating, vaporising, c','Aparatos y dispositivos, aunque se calienten eléctricamente, para tratamiento de materias mediante operaciones que impliquen un cambio de temperatura, tales como calentamiento, cocción, torrefacción, destilación, pasteurización, baño de vapor de agua, eva',84,8419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (841990,'Partes de aparelhos e dispositivos para tratamento de matérias por meio de operações que impliquem mudança de temperatura','Parts of machinery, plant and laboratory equipment, whether or not electrically heated, for the treatment of materials by a process involving a change of temperature, and of non-electric instantaneous and storage water heaters, n.e.s.','Partes de aparatos y de dispositivos, aunque se calienten eléctricamente, para tratamiento de materias mediante operaciones que impliquen un cambio de temperatura, así como partes de calentadores de agua de calentamiento instantáneo o de acumulación, no e',84,8419);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842010,'Calandras e laminadores','Calendering or other rolling machines (other than for metals or glass)','Calandrias y laminadores (exc. metal o vidrio)',84,8420);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842091,'Cilindros para calandras e laminadores','Cylinders for calendering or other rolling machines (other than for metals or glass)','Cilindros para calandrias y para laminadores (exc. para metal o vidrio)',84,8420);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842099,'Outras partes para calandras e laminadores','Parts for calendering or rolling machines, n.e.s. (other than for metals or glass and excl. cylinders)','Partes distintas de los cilindros para calandrias y para laminadores, n.c.o.p. (exc. para metal o vidrio)',84,8420);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842111,'Desnatadeiras centrífugas','Centrifugal cream separators','Desnatadoras "descremadoras" y clarificadoras centrífugas para tratamiento de la leche',84,8421);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842112,'Secadores de roupa, centrífugos','Centrifugal clothes-dryers','Secadoras de ropa',84,8421);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842119,'Outros centrifugadores','Centrifuges, incl. centrifugal dryers (excl. isotope separators, cream separators and clothes dryers)','Centrifugadoras, incl. las secadoras centrífugas (exc. para la separación de isótopos, así como las desnatadoras y las secadoras de ropa)',84,8421);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842121,'Aparelhos para filtrar ou depurar água','Machinery and apparatus for filtering or purifying water','Aparatos de filtrar o depurar agua',84,8421);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842122,'Aparelhos para filtrar ou depurar bebidas, exceto água','Machinery and apparatus for filtering or purifying beverages (excl.water)','Aparatos de filtrar o depurar bebidas (exc. agua)',84,8421);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842123,'Aparelhos para filtrar óleos minerais nos motores de ignição por centelha ou por compressão','Oil or petrol-filters for internal combustion engines','Aparatos de filtrar lubricantes o carburantes en los motores de encendido por chispa o compresión',84,8421);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842129,'Outros aparelhos para filtrar ou depurar líquidos','Machinery and apparatus for filtering or purifying liquids (excl. such machinery and apparatus for water and other beverages, oil or petrol-filters for internal combustion engines and artificial kidneys)','Aparatos de filtrar o depurar líquidos (exc. de filtrar o depurar agua y bebidas o lubricantes o carburantes para motores de encendido por chispa o compresión, así como los aparatos llam. "riñones artificiales")',84,8421);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842131,'Filtros de entrada de ar para motores de ignição por centelha ou por compressão','Intake air filters for internal combustion engines','Filtros de entrada de aire para motores de encendido por chispa o compresión',84,8421);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842139,'Outros aparelhos para filtrar ou depurar gases','Machinery and apparatus for filtering or purifying gases (excl. isotope separators and intake air filters for internal combustion engines)','Aparatos de filtrar o depurar gases (exc. para la separación de isótopos, así como los filtros de entrada de aire para motores de encendido por chispa o compresión)',84,8421);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842191,'Outras partes de centrifugadores, incluídas as dos secadores centrífugos','Parts of centrifuges, incl. centrifugal dryers, n.e.s.','Partes de centrifugadoras y de secadoras centrífugas, n.c.o.p.',84,8421);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842199,'Outras partes de aparelhos para filtrar ou depurar líquidos ou gases','Parts of machinery and apparatus for filtering or purifying liquids or gases, n.e.s.','Partes de aparatos para filtrar o depurar líquidos o gases, n.c.o.p.',84,8421);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842211,'Máquinas de lavar louça, do tipo da espécie doméstica','Dishwashing machines of the household type','Máquinas para lavar vajilla, de tipo doméstico',84,8422);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842219,'Outras máquinas de lavar louça','Dishwashing machines (excl. those of the household type)','Máquinas para lavar vajilla (exc. de tipo doméstico)',84,8422);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842220,'Máquinas e aparelhos para limpar ou secar garrafas ou outros recipientes','Machinery for cleaning or drying bottles or other containers (excl. dishwashing machines)','Máquinas y aparatos para limpiar o secar botellas o demás recipientes (exc. máquinas para lavar vajilla)',84,8422);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842230,'Máquinas e aparelhos para encher, fechar, arrolhar ou rotular garrafas, caixas, latas, sacos ou outros recipientes; máquinas e aparelhos para gaseificar bebidas','Machinery for filling, closing, sealing or labelling bottles, cans, boxes, bags or other containers; machinery for capsuling bottles, jars, tubes and similar containers; machinery for aerating beverages','Máquinas y aparatos para llenar, cerrar, tapar o etiquetar botellas, botes o latas, cajas, sacos "bolsas" y demás continentes; máquinas y aparatos de capsular botellas, tarros, tubos o continentes análogos; máquinas y aparatos para gasear bebidas',84,8422);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842240,'Outras máquinas e aparelhos para empacotar ou embalar mercadorias','Packing or wrapping machinery, incl. heat-shrink wrapping machinery (excl. machinery for filling, closing, sealing or labelling bottles, cans, boxes, bags or other containers and machinery for capsuling bottles, jars, tubes and similar containers)','Máquinas y aparatos para empaquetar o envolver mercancías, incl. las de envolver con película termorretráctil (exc. máquinas y aparatos para llenar, cerrar, tapar o etiquetar botellas o latas, cajas, sacos "bolsas" y demás continentes; máquinas y aparatos',84,8422);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842290,'Partes de máquinas e aparelhos da posição 8422','Parts of dishwashing machines, packing or wrapping machinery and other machinery and apparatus of heading 8422, n.e.s.','Partes de máquinas para lavar vajilla, de máquinas para empaquetar y de demás máquinas y aparatos de la partida 8422, n.c.o.p.',84,8422);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842310,'Balanças para pessoas, incluídas aquelas para bebês, de uso da espécie doméstica','Personal weighing machines, incl. baby scales; household scales','Instrumentos e aparatos de pesar personas, incl. los pesabebés; balanzas domésticas',84,8423);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842320,'Básculas de pesagem contínua em transportadores','Scales for continuous weighing of goods on conveyors','Básculas y balanzas de pesada continua sobre transportadores',84,8423);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842330,'Básculas de pesagem constante e balanças e básculas ensacadoras ou dosadoras','Constant weight scales and scales for discharging a pre-determined weight of material into a bag or container, incl. hopper scales (excl. scales for continuous weighing of goods on conveyors)','Básculas y balanzas para pesada constante, incl. las dedescargar pesos determinados en sacos "bolsas" u otros recipientes, así como los dosificadores de tolva (exc. básculas y balanzas de pesada continua sobre transportadores)',84,8423);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842381,'Outros aparelhos e instrumentos de pesagem, de capacidade <= 30 kg','Weighing machinery having a maximum weighing capacity <= 30 kg (excl. balances of a sensitivity of 5 cg or better, personal weighing machines, household scales, scales for continuous weighing of goods on conveyors, constant weight scales and scales for di','Instrumentos e aparatos de pesar, con capacidad <= 30 kg (exc. balanzas sensibles a un peso <= 5 cg, instrumentos e aparatos de pesar personas, balanzas domésticas, básculas y balanzas de pesada continua sobre transportadores, básculas y balanzas de pesad',84,8423);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842382,'Outros aparelhos e instrumentos de pesagem, de capacidade > 30 kg e <= 5.000 kg','Weighing machinery of a maximum weighing capacity > 30 kg but <= 5.000 kg (excl. personal weighing machines, scales for continuous weighing of goods on conveyors, constant weight scales and scales for discharging a pre-determined weight of material into a','Instrumentos e aparatos de pesar, con capacidad > 30 kg pero <= 5.000 kg (exc. instrumentos y aparatos de pesar personas, básculas y balazas de pesada continua sobre transportadores, básculas y balazas de pesada constante y básculas y balanzas ensacadoras',84,8423);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842389,'Outros aparelhos e instrumentos de pesagem','Weighing machinery of a maximum weighing capacity > 5.000 kg','Instrumentos e aparatos de pesar, con capacidad > 5.000 kg',84,8423);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842390,'Pesos para balanças e partes de aparelhos ou instrumentos de pesagem, incluídas as básculas','Weighing machine weights of all kinds; parts of weighing machinery, n.e.s.','Pesas para toda clase de básculas o balanzas; partes de instrumentos o aparatos de pesar, n.c.o.p.',84,8423);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842410,'Extintores, mesmo carregados','Fire extinguishers, whether or not charged (excl. fire-extinguishing bombs and grenades)','Extintores, incl. cargados (exc. bombas y granadas extintoras)',84,8424);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842420,'Pistolas aerográficas e aparelhos semelhantes','Spray guns and similar appliances (other than electrical machines, appliances and other devices for spraying molten metals or metal carbides of heading 8515, sand blasting machines and similar jet projecting machines)','Pistolas aerográficas y aparatos simil. (exc. máquinas y aparatos eléctricos para proyectar en caliente metales o carburos metálicos sinterizados de la partida 8515, así como máquinas y aparatos de chorro de arena, de chorro de vapor y aparatos de chorro ',84,8424);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842430,'Máquinas e aparelhos de jato de areia, de jato de vapor e aparelhos de jato semelhantes','Steam or sand blasting machines and similar jet projecting machines, incl. water cleaning appliances with built-in motor (excl. appliances for cleaning special containers)','Máquinas y aparatos de chorro de arena o de vapor y aparatos de chorro simil., incl. aparatos para limpieza con agua, con motor incorporado (exc. máquinas y aparatos para limpiar recipientes especiales)',84,8424);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842481,'Outros aparelhos para agricultura ou horticultura, para projetar ou pulverizar líquidos ou pós','Agricultural or horticultural mechanical appliances, whether or not hand-operated, for projecting, dispersing or spraying liquids or powders','Aparatos mecánicos, incl. de mano, para proyectar, dispersar o pulverizar materias líquidas o en polvo, para agricultura u horticultura',84,8424);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842489,'Outros aparelhos mecânicos (mesmo manuais) para projetar ou pulverizar líquidos ou pós','Mechanical appliances, whether or not hand-operated, for projecting, dispersing or spraying liquids or powders, n.e.s.','Aparatos mecánicos, incl. de mano, para proyectar, dispersar o pulverizar materias líquidas o en polvo, n.c.o.p.',84,8424);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842490,'Partes de aparelhos mecânicos para projetar, dispersar ou pulverizar líquidos ou pós','Parts of fire extinguishers, spray guns and similar appliances, steam or sand blasting machines and similar jet projecting machines and machinery and apparatus for projecting, dispersing or spraying liquids or powders, n.e.s.','Partes de extintores, de pistolas aerográficas y de aparatos simil.; partes de máquinas y de aparatos de chorro de arena o de vapor y de aparatos de chorro simil.; partes de aparatos mecánicos, incl. de mano, para proyectar, dispersar o pulverizar materia',84,8424);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842511,'Talhas, cadernais e moitões, de motor elétrico','Pulley tackle and hoists, powered by electric motor (other than skip hoists or hoists of a kind used for raising vehicles)','Polipastos, con motor eléctrico',84,8425);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842519,'Outras talhas, cadernais e moitões','Pulley tackle and hoists, non-powered by electric motor (other than skip hoists or hoists of a kind used for raising vehicles)','Polipastos, sin motor eléctrico',84,8425);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842520,'Guinchos para elevação, descida de gaiolas em minas, etc.','pit-head wind.gear, winches spec.desig.f/use under.etc','tornos p/ascenso/descenso de jaulas en pozos minas, etc',84,8425);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842531,'Outros guinchos; cabrestantes, de motor elétrico','Winches and capstans powered by electric motor','Tornos y cabrestantes, con motor eléctrico (exc. tornos para el ascenso y descenso de jaulas o montacargas en pozos de minas y tornos especialmente concebidos para el interior de minas)',84,8425);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842539,'Outros guinchos e cabrestantes','Winches and capstans non-powered by electric motor','Tornos y cabrestantes, sin motor eléctrico (exc. tornos para el ascenso y descenso de jaulas o montacargas en pozos de minas y tornos especialmente concebidos para el interior de minas)',84,8425);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842541,'Elevadores fixos de veículos, para garagens','Built-in jacking systems of a type used in garages','Elevadores fijos para vehículos, de los tipos utilizados en talleres',84,8425);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842542,'Outros macacos hidráulicos','Jacks and hoists, hydraulic (excl. built-in jacking systems used in garages)','Gatos hidráulicos (exc. elevadores fijos para vehículos, de los tipos utilizados en talleres)',84,8425);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842549,'Outros macacos','Jacks and hoists of a kind used for raising vehicles, not hydraulic','Gatos no hidráulicos',84,8425);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842611,'Pontes e vigas, rolantes, de suportes fixos','Overhead travelling cranes on fixed support','Puentes, incl. las vigas, rodantes, sobre soporte fijo',84,8426);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842612,'Pórticos móveis de pneumáticos e carros-pórticos','Mobile lifting frames on tyres and straddle carriers','Pórticos móviles sobre neumáticos y carretillas puente',84,8426);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842619,'Outros pórticos e pontes-guindastes','Overhead travelling cranes, transporter cranes, gantry cranes, bridge cranes and mobile lifting frames (excl. overhead travelling cranes on fixed support, mobile lifting frames on tyres, straddle carriers and portal or pedestal jib cranes)','Puentes (exc. puentes rodantes sobre soporte fijo, pórticos móviles sobre neumáticos y carretillas puente)',84,8426);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842620,'Guindastes de torre','Tower cranes','Grúas de torre',84,8426);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842630,'Guindastes de pórtico','Portal or pedestal jib cranes','Grúas de pórtico',84,8426);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842641,'Máquinas e aparelhos autopropulsores, de pneumáticos','Mobile cranes and works trucks fitted with a crane, self-propelled, on tyres (excl. wheel-mounted cranes, mobile lifting frames on tyres and straddle carriers)','Grúas móviles y carretillas grúa, sobre neumáticos (exc. camiones grúa, pórticos móviles sobre neumáticos y carretillas puente)',84,8426);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842649,'Outras máquinas e aparelhos autopropulsores','Mobile cranes and works trucks fitted with a crane, self-propelled (excl. those on tyres and straddle carriers)','Grúas móviles y carretillas grúa (exc. sobre neumáticos y carretillas puente)',84,8426);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842691,'Outras máquinas e aparelhos de elevação, próprios para serem montados em veículos rodoviários','Cranes designed for mounting on road vehicles','Grúas concebidas para montarlas en un vehículo de carretera',84,8426);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842699,'Cábreas e outros guindastes','Ships'' derricks; cranes, incl. cable cranes (excl. overhead travelling cranes, transporter cranes, gantry cranes, portal or pedestal jib cranes, bridge cranes, mobile lifting frames and straddle carriers, tower cranes, works trucks fitted with a crane, m','Grúas y aparatos de elevación sobre cable aéreo y demás grúas (exc. puentes rodantes, grúas de pórtico, pórticos de descarga, puentes grúa, carretillas puente, carretillas grúa, grúas móviles y grúas concebidas para montarlas sobre vehículo de carretera)',84,8426);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842710,'Autopropulsores, de motor elétrico','Self-propelled trucks fitted with lifting or handling equipment, powered by an electric motor','Carretillas autopropulsadas, con motor eléctrico, con dispositivo de elevación incorporado',84,8427);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842720,'Outros autopropulsores','Self-propelled trucks fitted with lifting or handling equipment, non-powered by an electric motor','Carretillas autopropulsadas sin motor eléctrico, con dispositivo de elevación incorporado',84,8427);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842790,'Outras empilhadeiras, outros veículos para movimentação de carga e semelhantes, com dispositivos de elevação','Works trucks fitted with lifting or handling equipment, not self-propelled','Carretillas no autopropulsadas, con dispositivo de elevación incorporado',84,8427);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842810,'Elevadores e monta-cargas','Lifts and skip hoists','Ascensores y montacargas',84,8428);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842820,'Aparelhos elevadores ou transportadores, pneumáticos','Pneumatic elevators and conveyors','Aparatos elevadores o transportadores, neumáticos',84,8428);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842831,'Aparelhos elevadores ou transportadores de mercadorias, para uso subterrâneo','Continuous-action elevators and conveyors for goods or materials, for underground use (excl. pneumatic elevators and conveyors)','Aparatos elevadores o transportadores, de acción continua, para mercancías, especialmente concebidos para el interior de minas u otros trabajos subterráneos (exc. neumáticos)',84,8428);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842832,'Outros aparelhos elevadores ou transportadores de mercadorias, de caçamba','Continuous-action elevators and conveyors for goods or materials, bucket type (excl. for underground use)','Aparatos elevadores o transportadores, de acción continua, para mercancías, de cuchara (exc. especialmente concebidos para el interior de minas u otros trabajos subterráneos)',84,8428);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842833,'Outros aparelhos elevadores ou transportadores de mercadorias, de tira ou correia','Continuous-action elevators and conveyors for goods or materials, belt type (excl. those for underground use)','Aparatos elevadores o transportadores, de acción continua, para mercancías, de banda o de correa (exc. especialmente concebidos para el interior de minas u otros trabajos subterráneos)',84,8428);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842839,'Outros aparelhos elevadores ou transportadores, de ação contínua, para mercadorias','Continuous-action elevators and conveyors, for goods or materials (excl. those for underground use and bucket, belt or pneumatic types)','Aparatos elevadores o transportadores, de acción continua, para mercancías (exc. especialmente concebidos para el interior de minas u otros trabajos subterráneos, de cuchara, de banda o de correa, así como los aparatos neumáticos)',84,8428);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842840,'Escadas e tapetes, rolantes','Escalators and moving walkways','Escaleras mecánicas y pasillos móviles',84,8428);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842850,'apars.p/empurrar vagonetas de minas e manip.veic.ferrov','Mine wagon pushers, locomot.and railway wagon hand.equip','Empujadores de vagonetes de minas/manip.mat.móv.carriles',84,8428);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842860,'Teleféricos (incluídos as telecadeiras e os telesquis); mecanismos de tração para funiculares','Teleferics, chairlifts, ski-draglines; traction mechanisms for funiculars','Teleféricos, incl. las telesillas y los telesquís; mecanismos de tracción para funiculares',84,8428);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842890,'Outras máquinas e aparelhos de elevação, de carga, de descarga ou de movimentação','Machinery for lifting, handling, loading or unloading, n.e.s.','Máquinas y aparatos de elevación, carga, descarga o manipulación, n.c.o.p.',84,8428);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842911,'Bulldozers e angledozers, de lagartas, autopropulsores','Self-propelled bulldozers and angledozers, track laying','Topadoras frontales "bulldozers" y topadoras anguladores "angledozers", de orugas',84,8429);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842919,'Outros bulldozers e angledozers','Self-propelled bulldozers and angledozers, on wheels','Topadoras frontales "bulldozers" y topadoras anguladores "angledozers", de ruedas',84,8429);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842920,'Niveladores','Self-propelled graders and levellers','Niveladoras autopropulsadas',84,8429);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842930,'Raspo-transportadores (scrapers), autopropulsores','Self-propelled scrapers','Traíllas "scrapers" autopropulsadas',84,8429);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842940,'Compactadores e rolos ou cilindros compressores, autopropulsores','Self-propelled tamping machines and roadrollers','Compactadoras y apisonadoras "aplanadoras", autopropulsados',84,8429);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842951,'Carregadoras e pás carregadoras, de carregamento frontal, autopropulsores','Self-propelled front-end shovel loaders','Cargadoras y palas cargadoras de carga frontal, autopropulsadas',84,8429);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842952,'Máquinas escavadoras, com capacidade de efetuar uma rotação de 360 graus, autopropulsores','Self-propelled mechanical shovels, excavators and shovel loaders, with a 360° revolving superstructure','Palas mecánicas, autopropulsadas, cuya superestructura pueda girar 360°',84,8429);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (842959,'Outras pás mecânicas, escavadores e carregadoras, autopropulsores','Self-propelled mechanical shovels, excavators and shovel loaders (excl. self-propelled mechanical shovels with a 360° revolving superstructure and front-end shovel loaders)','Palas mecánicas, excavadoras, cargadoras y palas cargadoras, autopropulsadas (exc. palas mecánicas cuya superestructura pueda girar 360°, así como cargadoras y palas cargadoras de carga frontal)',84,8429);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843010,'Bate-estacas e arranca-estacas','Pile-drivers and pile-extractors (excl. those mounted on railway wagons, motor vehicle chassis or lorries)','Martinetes y máquinas para arrancar pilotes, estacas o simil. (exc. aparatos montados en vagones para redes ferroviarias o artefactos montados en chasis automóviles o camiones)',84,8430);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843020,'Limpa-neves','Snowploughs and snowblowers (excl. those mounted on railway wagons, motor vehicle chassis or lorries)','Quitanieves (exc. aparatos montados en vagones para redes ferroviarias o artefactos montados en chasis automóviles o camiones)',84,8430);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843031,'Máquinas para perfuração de túneis e galerias, autopropulsoras','Self-propelled coal or rock cutters and tunnelling machinery (excl. hydraulically operated self-advancing supports for mines)','Cortadoras y arrancadoras, de carbón o rocas, y máquinas para hacer túneles o galerías, autopropulsadas (exc. sostenimiento hidráulico autodesplazable)',84,8430);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843039,'Outras máquinas para perfuração de túneis e galerias','Coal or rock cutters and tunnelling machinery, not self-propelled (excl. hand-operated tools and hydraulically operated self-advancing supports for mines)','Cortadoras y arrancadoras, de carbón o rocas, y máquinas para hacer túneles o galerías, no autopropulsadas (exc. herramientas de uso manual y sostenimiento hidráulico autodesplazable)',84,8430);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843041,'Outras máquinas de sondagem ou perfuração, autopropulsores','Self-propelled boring or sinking machinery for boring earth or extracting minerals or ores (excl. those mounted on railway or tramway wagons, motor vehicle chassis or lorries and tunnelling machinery)','Máquinas de sondeo o perforación, de extraer o perforar tierra o minerales, autopropulsadas (exc. aparatos montados en vagones para redes ferroviarias, artefactos montados en chasis automóviles o camiones y máquinas para hacer túneles o galerías)',84,8430);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843049,'Outras máquinas de sondagem ou perfuração','Boring or sinking machinery for boring earth or extracting minerals or ores, not self-propelled and not hydraulic (excl. tunnelling machinery and hand-operated tools)','Máquinas de sondeo o perforación, de extraer o perforar tierra o minerales, no autopropulsadas, no hidráulicas (exc. máquinas para hacer túneles o galerías y herramientas de uso manual)',84,8430);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843050,'Outras máquinas e aparelhos de terraplanagem, autopropulsores','Self-propelled earth-moving machinery, n.e.s.','Máquinas y aparatos para explanar, autopropulsados, n.c.o.p.',84,8430);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843061,'Máquinas de comprimir ou compactar terra, exceto autopropulsores','Tamping or compacting machinery, not self-propelled (excl. hand-operated tools)','Máquinas y aparatos para compactar o apisonar "aplanar", no autopropulsados (exc. herramientas de uso manual)',84,8430);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843062,'outs.raspo-transportadores de terra, etc.exc.autopropuls','ot.scraping-transpor.of earth, etc.exc.self-propelled','traíllas, etc.exc.autopropulsadas',84,8430);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843069,'Outras máquinas e aparelhos de terraplanagem, exceto autopropulsados','Earth moving machinery, not self-propelled, n.e.s.','Máquinas y aparatos para explanar, no autopropulsados, n.c.o.p.',84,8430);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843110,'Partes das máquinas e aparelhos da posição 8425','Parts of pulley tackles and hoists (other than skip hoists), winches, capstans and jacks, n.e.s.','Partes de polipastos; tornos, cabrestantes y gatos, n.c.o.p.',84,8431);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843120,'Partes das máquinas e aparelhos da posição 8427','Parts of fork-lift trucks and other works trucks fitted with lifting or handling equipment, n.e.s.','Partes de carretillas apiladoras y las demás carretillas de manipulación con dispositivo de elevación incorporado, n.c.o.p.',84,8431);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843131,'Partes de elevadores, monta-cargas ou de escadas rolantes','Parts of lifts, skip hoists or escalators, n.e.s.','Partes de ascensores, montacargas o escaleras mecánicas, n.c.o.p.',84,8431);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843139,'Partes de outras máquinas e aparelhos da posição 8428','Parts of machinery of heading 8428, n.e.s.','Partes de máquinas o aparatos de la partida 8428, n.c.o.p.',84,8431);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843141,'Caçambas, pás, ganchos e tenazes, para máquinas e aparelhos das posições 8426, 8429 e 8430','Buckets, shovels, grabs and grips for machinery of heading 8426, 8429 and 8430','Cangilones, cucharas, cucharas de almeja, palas y garras o pinzas, para máquinas o aparatos de las partidas 8426, 8429 u 8430',84,8431);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843142,'Lâminas para bulldozers ou angledozers','Bulldozer or angledozer blades, n.e.s.','Hojas de topadoras frontales "bulldozers" o de topadoras angulares "angledozers", n.c.o.p.',84,8431);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843143,'Partes de máquinas de sondagem ou de perfuração, das subposições 8430.41 ou 8430.49','Parts for boring or sinking machinery of subheading 8430.41 or 8430.49, n.e.s.','Partes de máquinas de sondeo o perforación de las subpartidas 8430.41 u 8430.49, n.c.o.p.',84,8431);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843149,'Partes de outras máquinas e aparelhos das posições 8426, 8429 e 8430','Parts of machinery of heading 8426, 8429 and 8430, n.e.s.','Partes de máquinas o aparatos de las partidas 8426, 8429 u 8430, n.c.o.p.',84,8431);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843210,'Arados e charruas','Ploughs for use in agriculture, horticulture or forestry','Arados agrícolas, hortícolas o silvícolas',84,8432);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843221,'Grades de discos, de uso agrícola, para preparação ou trabalho do solo','Disc harrows for use in agriculture, horticulture or forestry','Gradas "rastras" de discos, agrícolas, hortícolas o silvícolas',84,8432);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843229,'Outras grades, escarificadores, cultivadores, extirpadores, enxadas e sachadores','Harrows, scarifiers, cultivators, weeders and hoes for use in agriculture, horticulture or forestry (excl. disc harrows)','Gradas "rastras", escarificadores, cultivadores, estirpadores, azadas, rotativas "rotocultores", escardadores y binadoras, agrícolas, hortícolas o silvícolas (exc. gradas "ratras" de discos)',84,8432);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843230,'Semeadores, plantadores e transplantadores','Seeders, planters and transplanters for use in agriculture, horticulture and forestry','Sembradoras, plantadoras y transplantadoras, agrícolas, hortícolas o silvícolas',84,8432);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843240,'Espalhadores de estrume e distribuidores de adubos ou fertilizantes','Manure spreaders and fertiliser distributors for use in agriculture, horticulture and forestry','Esparcidores de estiércol y distribuidores de abono, agrícolas, hortícolas o silvícolas',84,8432);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843280,'Outras máquinas e aparelhos agrícolas, hortícolas ou florestais, para preparação do solo','Agricultural, horticultural or forestry machinery for soil preparation or cultivation; lawn or sports-ground rollers (excl. sprayers and dusters, ploughs, harrows, scarifiers, cultivators, weeders, hoes, seeders, planters, manure spreaders and fertiliser ','Máquinas, aparatos y artefactos agrícolas, hortícolas o silvícolas, para la preparación o el trabajo del suelo; rodillos para césped o terrenos de deporte (exc. aparatos para proyectar, dispersar o pulverizar; arados, gradas "rastras", escarificadores, cu',84,8432);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843290,'Partes de máquinas e aparelhos agrícolas, hortícolas ou florestais, para preparação do solo','Parts of agricultural, horticultural or forestry machinery for soil preparation or cultivation or of lawn or sports-ground rollers, n.e.s.','Partes de máquinas, de aparatos y de artefactos agrícolas, hortícolas o silvícolas, para la preparación o el trabajo del suelo; partes de rodillos para césped o terrenos de deporte, n.c.o.p.',84,8432);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843311,'Cortadores de grama, motorizados, cujo dispositivo de corte gira num plano horizontal','Mowers for lawns, parks or sports grounds, powered, with the cutting device rotating in a horizontal plane','Cortadoras de césped, con motor, en las que el dispositivo de corte gire en un plano horizontal',84,8433);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843319,'Outros cortadores de grama (relva)','Mowers for lawns, parks or sports grounds, powered, with the cutting device rotating in a vertical plane or with cutter bars','Cortadoras de césped, con motor, en las que el dispositivo de corte gire en un plano vertical o con barra de corte',84,8433);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843320,'Ceifeiras, incluídas as barras de corte para montagem em tratores','Mowers, incl. cutter bars for tractor mounting (excl. mowers for lawns, parks or sports grounds)','Guadañadoras, incl. las barras de corte para montar sobre un tractor (exc. cortadoras de césped)',84,8433);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843330,'Outras máquinas e aparelhos para colher e dispor o feno','Haymaking machinery (excl. mowers)','Máquinas y aparatos de henificar (exc. guadañadoras)',84,8433);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843340,'Enfardadeiras de palha ou de forragem, incluídas as enfardadeiras- apanhadeiras','Straw or fodder balers, incl. pick-up balers','Prensas para paja o forraje, incl. las prensas recogedoras',84,8433);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843351,'Ceifeiras-debulhadoras','Combine harvester-threshers','Cosechadoras-trilladoras',84,8433);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843352,'Outras máquinas e aparelhos para debulhar','Threshing machinery (excl. combine harvester-threshers)','Máquinas y aparatos de trillar (exc. cosechadoras-trilladoras)',84,8433);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843353,'Máquinas para colheita de raízes ou tubérculos','Root or tuber harvesting machines','Máquinas de cosechar raíces o tubérculos',84,8433);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843359,'Outras máquinas e aparelhos para colheita','Harvesting machinery for agricultural produce (excl. mowers, haymaking machinery, straw and fodder balers, incl. pick-up balers, combine harvester-threshers, other threshing machinery and root or tuber harvesting machines)','Máquinas y aparatos de cosechar productos agrícolas (exc. guadañadoras; máquinas y aparatos de henificar; prensas para paja o forraje, incl. las prensas recogedoras; cosechadoras-trilladoras y demás máquinas y aparatos de trillar; máquinas de cosechar raí',84,8433);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843360,'Máquinas para limpar ou selecionar ovos, frutas ou outros produtos agrícolas','Machines for cleaning, sorting or grading eggs, fruit or other agricultural produce (excl. machines for cleaning, sorting or grading seed, grain or dried leguminous vegetables of heading 8437)','Máquinas para limpieza o clasificación de huevos, frutos o demás productos agrícolas (exc. para limpieza o clasificación de semillas, granos o legumbres secas de la partida 8437)',84,8433);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843390,'Partes de máquinas e aparelhos para colheita ou debulha de produtos agrícolas, ou para limpar ou selecionar ovos, frutas ou outros produtos agrícolas','Parts of harvesting machinery, threshing machinery, mowers and machines for cleaning, sorting or grading agricultural produce, n.e.s.','Partes de máquinas, de aparatos y de artefactos de cosechar o trillar; partes de cortadoras de césped y de guadañadoras; partes de máquinas para limpieza o clasificación de productos agrícolas, n.c.o.p.',84,8433);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843410,'Máquinas de ordenhar','Milking machines','Máquinas de ordeñar',84,8434);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843420,'Máquinas e aparelhos para a indústria de laticínios','Dairy machinery (excl. refrigerating or heat treatment equipment, cream separators, clarifying centrifuges, filter presses and other filtering equipment)','Máquinas y aparatos para la industria lechera (exc. aparatos frigoríficos o instalaciones de calentamiento, desnatadoras, clarificadoras centrífugas, filtros y filtros-prensa)',84,8434);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843490,'Partes de máquinas e aparelhos de ordenhar e da indústria de laticínios','Parts of milking machines and dairy machinery, n.e.s.','Partes de máquinas de ordeñar y de máquinas y de aparatos para la industria lechera, n.c.o.p.',84,8434);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843510,'Prensas, esmagadores e máquinas e aparelhos para fabricação de vinho, sidra, suco de frutas ou bebidas semelhantes','Presses, crushers and similar machinery used in the manufacture of wine, cider, fruit juices or similar beverages (excl. machinery for the treatment of these beverages, incl. centrifuges, filter presses, other filtering equipment and domestic appliances)','Prensas, estrujadoras y máquinas y aparatos análogos para la producción de vino, sidra, jugos de frutos o bebidas simil. (exc. máquinas y aparatos para tratamiento de estas bebidas, incl. los aparatos centrifugadores, los filtros, los filtros-prensa y apa',84,8435);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843590,'Partes de máquinas e aparelhos para fabricação de vinho, sidra, suco de frutas ou bebidas semelhantes','Parts of presses, crushers and similar machinery used in the manufacture of wine, cider, fruit juices or similar beverages, n.e.s.','Partes de prensas, de estrujadoras y de máquinas y de aparatos análogos para la producción de vino, sidra, jugos de frutos o bebidas simil., n.c.o.p.',84,8435);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843610,'Máquinas e aparelhos para preparação de alimentos ou rações para animais','Machinery for preparing animal feedingstuffs in agricultural holdings and similar undertakings (excl. machinery for the feedingstuff industry, forage harvesters and autoclaves for cooking fodder)','Máquinas y aparatos para preparar alimentos o piensos para animales, en explotaciones agrícolas o simil. (exc. máquinas y aparatos destinados a la industria forrajera, recogedoras-picadoras, autoclaves para forraje y simil.)',84,8436);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843621,'Chocadeiras e criadeiras','Poultry incubators and brooders','Incubadoras y criadoras, para la avicultura',84,8436);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843629,'Outras máquinas e aparelhos para avicultura','Poultry-keeping machinery (excl. machines for sorting or grading eggs, poultry pickers of heading 8438 and incubators and brooders)','Máquinas y aparatos para la avicultura (exc. clasificadoras de huevos y desplumadoras de la partida 8438, así como incubadoras y criadoras)',84,8436);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843680,'Outras máquinas e aparelhos para agricultura, horticultura, silvicultura, avicultura ou apicultura','Agricultural, horticultural, forestry or bee-keeping machinery, n.e.s.','Máquinas y aparatos para la agricultura, horticultura, silvicultura o apicultura, n.c.o.p.',84,8436);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843691,'Partes de máquinas e aparelhos para avicultura','Parts of poultry-keeping machinery or poultry incubators and brooders, n.e.s.','Partes de máquinas y aparatos para la avicultura, n.c.o.p.',84,8436);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843699,'Outras partes de máquinas e aparelhos para agricultura, horticultura, silvicultura ou apicultura','Parts of agricultural, horticultural, forestry or bee-keeping machinery, n.e.s.','Partes de máquinas y aparatos para la agricultura, horticultura, silvicultura o apicultura, n.c.o.p.',84,8436);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843710,'Máquinas para limpeza, seleção ou peneiração de grãos ou de produtos hortícolas secos','Machines for cleaning, sorting or grading seed, grain or dried leguminous vegetables','Máquinas para limpieza, clasificación o cribado de semillas, granos u hortalizas de vaina seca',84,8437);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843780,'Outras máquinas e aparelhos para a indústria de moagem ou tratamento de cereais ou de produtos hortícolas secos','Machinery used in the milling industry or for the working of cereals or dried leguminous vegetables (excl. farm-type machinery, heat treatment equipment, centrifugal dryers, air filters and machines for cleaning, sorting or grading seed, grain or dried le','Máquinas y aparatos para molienda o tratamiento de cereales u hortalizas de vaina seca; sus partes (exc. de tipo rural, así como máquinas y aparatos cuyo funcionamiento se base en un cambio de temperatura, columnas secadoras centrífugas, filtros de aire y',84,8437);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843790,'Partes de máquinas da posição 8437','Parts of machinery used in the milling industry or for the working of cereals or dried leguminous vegetables or machines for cleaning, sorting or grading seed, grain or dried leguminous vegetables, n.e.s.','Partes de máquinas para limpieza, clasificación o cribado de semillas, granos u hortalizas de vaina seca; partes de máquinas y de aparatos para la molienda o el tratamiento de cereales u hortalizas de vaina seca, n.c.o.p.',84,8437);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843810,'Máquinas e aparelhos para as indústrias de panificação, pastelaria, bolachas e biscoitos e de massas alimentícias','Bakery machinery and machinery for the industrial preparation or manufacture of macaroni, spaghetti or similar products (excl. ovens, macaroni drying machines and dough rollers)','Máquinas y aparatos para panadería, pastelería, galletería o la fabricación de pastas alimenticias (exc. hornos, secadores de pastas alimenticias y laminadores)',84,8438);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843820,'Máquinas e aparelhos para as indústrias de confeitaria e de cacau ou chocolate','Machinery for the industrial preparation or manufacture of confectionery, cocoa or chocolate (excl. centrifuges and filtering, heating or refrigerating equipment)','Máquinas y aparatos, de tipo industrial, para confitería, elaboración de cacao o la fabricación de chocolate (exc. centrifugadoras, filtros y aparatos de calentamiento o de refrigeración)',84,8438);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843830,'Máquinas e aparelhos para a indústria de açúcar','Machinery for sugar manufacture (excl. centrifuges and filtering, heating or refrigerating equipment)','Máquinas y aparatos para la industria azucarera (exc. centrifugadoras, filtros y aparatos de calentamiento o de refrigeración)',84,8438);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843840,'Máquinas e aparelhos para a indústria cervejaria','Brewery machinery (excl. centrifuges and filtering, heating or refrigerating equipment)','Máquinas y aparatos para la industria cervecera (exc. centrifugadoras, filtros y aparatos de calentamiento o de refrigeración)',84,8438);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843850,'Máquinas e aparelhos para preparação de carnes','Machinery for the industrial preparation of meat or poultry (excl. cooking and other heating appliances and refrigerating or freezing equipment)','Máquinas y aparatos para la preparación de carne (exc. de cocer o de calentamiento y las instalaciones de refrigeración o congelación)',84,8438);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843860,'Máquinas e aparelhos para preparação de frutas ou produtos hortícolas','Machinery for the industrial preparation of fruits, nuts or vegetables (excl. cooking and other heating appliances, refrigerating or freezing equipment and machinery for the sorting or grading of fruit and vegetables)','Máquinas y aparatos para la preparación industrial de frutos u hortalizas, incl. "silvestres" (exc. de cocer o de calentamiento, las instalaciones de refrigeración o congelación y las clasificadoras de frutos o hortalizas)',84,8438);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843880,'Outras máquinas e aparelhos para preparação ou fabricação industriais de alimentos ou de bebidas','Machinery for the industrial preparation or manufacture of food or drink, n.e.s.','Máquinas y aparatos para la preparación o fabricación industrial de alimentos o bebidas, n.c.o.p.',84,8438);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843890,'Partes de máquinas e aparelhos para preparação ou fabricação industriais de alimentos ou de bebidas','Parts of machinery for the industrial preparation or manufacture of food or drink, n.e.s.','Partes de máquinas y de aparatos para la preparación o fabricación industrial de alimentos o bebidas, n.c.o.p.',84,8438);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843910,'Máquinas e aparelhos para fabricação de pasta de matérias fibrosas celulósicas','Machinery for making pulp of fibrous cellulosic material (excl. autoclaves, boilers and other heating appliances)','Máquinas y aparatos para la fabricación de pasta de materias fibrosas celulósicas (exc. autoclaves, cocedores y demás aparatos de calentamiento)',84,8439);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843920,'Máquinas e aparelhos para fabricação de papel ou cartão','Machinery for making paper or paperboard (excl. dryers and other heating appliances, calenders and machinery for making pulp)','Máquinas y aparatos para la fabricación de papel o cartón (exc. secadoras y demás aparatos de calentamiento, así como las calandrias y las máquinas y aparatos para la fabricación de pasta de papel)',84,8439);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843930,'Máquinas e aparelhos para acabamento de papel ou cartão','Machinery for finishing paper or paperboard (excl. calenders)','Máquinas y aparatos para el acabado de papel o cartón (exc. calandrias)',84,8439);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843941,'Não definido','Not defined','No definido',84,8439);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843991,'Partes de máquinas ou aparelhos para fabricação de pasta de matérias fibrosas celulósicas','Parts of machinery for making pulp of fibrous cellulosic material, n.e.s.','Partes de máquinas y aparatos para la fabricación de pasta de materias fibrosas celulósicas, n.c.o.p.',84,8439);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (843999,'Partes de máquinas e aparelhos para fabricação ou acabamento de papel ou cartão','Parts of machinery for making or finishing paper or paperboard, n.e.s.','Partes de máquinas y aparatos para la fabricación o acabado de papel o cartón, n.c.o.p.',84,8439);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844010,'Máquinas e aparelhos para brochura ou encadernação','Bookbinding machinery, incl. book-sewing machines (excl. machinery of heading 8441, general-purpose presses, printing machinery of heading 8443 and machines of uses ancillary to printing)','Máquinas y aparatos para encuadernación, incl. las máquinas para coser pliegos (exc. máquinas y aparatos de la partida 8441, prensas de uso general, máquinas y aparatos para imprimir de la partida 8443 y sus máquinas auxiliares)',84,8440);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844090,'Partes de máquinas e aparelhos para brochura ou encadernação','Parts of bookbinding machinery, n.e.s.','Partes de máquinas y aparatos para encuadernación, n.c.o.p.',84,8440);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844110,'Cortadeiras de papel ou cartão','Cutting machines for making up paper pulp, paper or paperboard (excl. bookbinding machinery of heading 8440)','Cortadoras para pasta de papel, para papel o para cartón (exc. máquinas para encuadernación de la partida 8440)',84,8441);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844120,'Máquinas para fabricação de sacos de quaisquer dimensões ou de envelopes','Machines for making bags, sacks or envelopes out of paper pulp, paper or paperboard (excl. sewing machines and eyeletting machines)','Máquinas para la fabricación de sacos, bolsas "bolsas" o sobres, de pasta de papel, de papel o cartón (exc. máquinas de coser y máquinas para poner los anillos de ojetes)',84,8441);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844130,'Máquinas para fabricação de caixas, tubos, tambores ou de recipientes semelhantes, por qualquer processo, exceto moldagem','Machines for making cartons, boxes, cases, tubes, drums or similar containers (other than by moulding) out of paper pulp, paper or paperboard (excl. drying equipment and sewing machines)','Máquinas para la fabricación de cajas, tubos, tambores o continentes simil. (no obtenidos por moldeado) de pasta de papel, de papel o cartón (exc. secadoras y máquinas de coser)',84,8441);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844140,'Máquinas de moldar artigos de pasta de papel, papel ou de cartão','Machines for moulding articles in paper pulp, paper or paperboard (excl. drying equipment)','Máquinas para moldear artículos de pasta de papel, de papel o cartón (exc. secadoras)',84,8441);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844180,'Outras máquinas e aparelhos para o trabalho da pasta de papel, do papel ou cartão','Machinery for making up paper pulp, paper or paperboard, n.e.s.','Máquinas y aparatos para el trabajo de la pasta de papel, del papel o cartón, n.c.o.p.',84,8441);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844190,'Partes de máquinas e aparelhos para o trabalho da pasta de papel, do papel ou do cartão','Parts of machinery for making up paper pulp, paper or paperboard, n.e.s.','Partes de máquinas y de aparatos para el trabajo de la pasta de papel, del papel o cartón, n.c.o.p.',84,8441);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844210,'Maqs.de compor caracteres tipograf.por proc.fotográfico','Machinery for phototype-setting f/process photogr.','Máqs.p/componer caracteres imprent.por proc.fotográfico',84,8442);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844220,'Outras máquinas/aparelhos e material para compor caracteres tipográficos','other mach./appl. for composing phototype-setting','las dem.máqs.apars.y mat.p/componer caracteres imprenta',84,8442);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844230,'Máquinas, aparelhos e equipamentos para preparação ou fabricação de clichês, blocos, cilindros e outros elementos de impressão','Machinery, apparatus and equipment for preparing or making printing blocks, plates, cylinders or other printing components (excl. machine tools of heading 8456 to 8465 and machinery for type founding and typesetting)','Máquinas, aparatos y material para fundir caracteres o para preparar o fabricar clisés, planchas, cilindros u otros elementos impresores (exc. máquinas herramienta de las partidas 8456 a 8465, así como las máquinas para fundir y componer)',84,8442);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844240,'Partes de máquinas, aparelhos e equipamentos da subposição 8442.30','Parts of machinery, apparatus and equipment for preparing or making printing blocks, plates, cylinders or other printing components, n.e.s.','Partes de máquinas, aparatos y material para fundir o componer caracteres o para preparar o fabricar clisés, planchas, cilindros u otros elementos impresores, n.c.o.p.',84,8442);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844250,'Clichês, blocos, cilindros e outros elementos de impressão; pedras litográficas, blocos, placas e cilindros, preparados para impressão','Plates, cylinders and other printing components; plates, cylinders and lithographic stones, prepared for printing purposes, e.g. planed, grained or polished','Caracteres de imprenta, clisés, planchas, cilindros y demás elementos impresores; piedras litográficas, planchas, placas y cilindros aplanados, graneados, pulidos o preparados de otra forma para la impresión',84,8442);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844311,'Máquinas e aparelhos de impressão por offset, alimentados por bobinas','Offset printing machinery, reel fed','Máquinas y aparatos para imprimir offset, alimentados con bobinas',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844312,'Máquinas e aparelhos de impressão por offset, alimentados por folhas de formato <= 22x36 cm','Offset printing machinery, sheet fed [office type], using sheets of a side <= 22 x 36 cm in the unfolded state','Máquinas y aparatos para imprimir offset, alimentados con hojas de formato <= 22 x 36 cm "offset para oficina"',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844313,'Outras máquinas e aparelhos de impressão, por offset','Offset printing machinery (excl. sheet fed offset printing machinery, sheet size <= 22 x 36 cm, and reel fed offset printing machinery)',' Las demás máquinas y aparatos para imprimir, offset',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844314,'Máquinas e aparelhos de impressão, tipográficos, alimentados por bobinas, exceto máquinas e aparelhos flexográficos','Letterpress printing machinery, reel fed (excl. flexographic printing machinery)',' Máquinas y aparatos para imprimir, tipográficos, alimentados con bobinas, excepto las máquinas y aparatos flexográficos',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844315,'Máquinas e aparelhos de impressão, tipográficos, não alimentados por bobinas, exceto máquinas e aparelhos flexográficos','Letterpress printing machinery (excl. flexographic printing and reel fed machinery)',' Máquinas y aparatos para imprimir, tipográficos, distintos de los alimentados con bobinas, excepto las máquinas y aparatos flexográficos',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844316,'Máquinas e aparelhos de impressão, flexográficos','Flexographic printing machinery',' Máquinas y aparatos para imprimir, flexográficos',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844317,'Máquinas e aparelhos de impressão, heliográficos','Gravure printing machinery',' Máquinas y aparatos para imprimir, heliográficos (huecograbado)',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844319,'Outras máquinas e aparelhos de impressão por meio de blocos, cilindoros e outros elementos de impressão','Printing machinery used for printing by means of plates, cylinders and other printing components of heading 8442 (excl. hectograph or stencil duplicating machines, addressing machines and other office printing machines of heading 8469 to 8472, ink jet pri','Máquinas y aparatos para imprimir offset (exc. alimentados con bobinas o con hojas de formato <= 22 x 36 cm "offset para oficina")',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844321,'Máquinas e apars.impressão, tipograf.alim.por bobinas','printing machinery, typographic, reel fed','máquinas y apars.p/imprimir, tipográf., alim.con bobinas',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844329,'Outras máquinas e aparelhos de impressão, tipográficos','other printing machinery, typographic','las dem.máquinas y aparatos p/imprimir, tipográficos',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844330,'Máquinas e aparelhos de impressão, flexográficos','Flexographic printing machinery','Máquinas y aparatos p/imprimir, flexográficos',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844331,'Máquinas que executem pelo menos duas das seguintes funções: impressão, cópia ou transmissão de telecópia (fax), capazes de ser conectadas a uma máquina automática de processamento de dados ou a uma rede','Machines which perform two or more of the functions of printing, copying or facsimile transmission, capable of connecting to an automatic data processing machine or to a network',' Máquinas que efectúan dos o más de las siguientes funciones: impresión, copia o fax, aptas para ser conectadas a una máquina automática para tratamiento o procesamiento de datos o a una red',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844332,'Outras impressoras, copiadoras e telecopiadoras, capazes de ser conectadas a uma máquina automática para processamento de dados ou a uma rede','Machines which only perform one of the functions of printing, copying or facsimile transmission, capable of connecting to an automatic data processing machine or to a network',' Las demás, aptas para ser conectadas a una máquina automática para tratamiento o procesamiento de datos o a una red',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844339,'Outras impressoras, copiadoras e telecopiadoras','Machines which only perform one of the functions of printing, copying or facsimile transmission (excl. those capable of connecting to an automatic data processing machine or to a network)','Máquinas que efectúan solamente una de las funciones de impresión, copia o transmisión de fax (excl. las aptas conectarse a una máquina automática de tratamiento de datos o a una red)',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844340,'Máquinas e aparelhos para impressão','Machinery for printing','Maquinaria para la impresión',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844351,'Máquinas de impressão de jato de tinta','Inkjet printing machines','Máquinas p/imprimir por chorro de tinta',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844359,'Máquinas de impressão','Printing machines','Máquinas de impresión',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844360,'Máquinas auxiliares de impressão','Auxiliary machinery for printing','Máquinas y aparatos auxiliares de impresión',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844390,'Partes de máquinas e aparelhos de impressão','Parts, of printing machinery, of machines for uses ancillary to printing','Partes de máquinas de impresión',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844391,'Partes e acessórios de máquinas e aparelhos de impressão que operem por meio de blocos, cilindros e outros elementos de impressão da posição 84.42','Parts and accessories of printing machinery used for printing by means of plates, cylinders and other printing components of heading 8442',' Partes y accesorios de máquinas y aparatos para imprimir mediante planchas, cilindros y demás elementos impresores de la partida 8442',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844399,'Partes e acessórios de impressoras ou traçadores gráficos (plotters), copiadoras e telecopiadoras','Parts and accessories of printers, copying machines and facsimile machines, n.e.s. (excl. of printing machinery used for printing by means of plates, cylinders and other printing components of heading 8442)','Partes y accesorios de máquinas impresoras, copiadoras y de fax, n.c.o.p. (excl. máquinas y aparatos para imprimir mediante planchas, cilindros y demás elementos impresores de la partida 8442)',84,8443);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844400,'Máquinas para extrudar, estirar, texturizar ou cortar matérias têxteis sintéticas ou artificiais','Machines for extruding, drawing, texturing or cutting man-made textile materials','Máquinas para extrudir, estirar, texturar o cortar materia textil sintética o artificial',84,8444);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844511,'Cardas para preparação de matérias têxteis','Carding machines for preparing textile fibres','Cardas para la preparación de materia textil',84,8445);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844512,'Penteadoras de matérias têxteis','Combing machines for preparing textile fibres','Peinadoras para la preparación de materia textil',84,8445);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844513,'Bancas de estiramento (bancas de fusos) para matérias têxteis','Drawing or roving machines','Mecheras para la preparación de materia textil',84,8445);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844519,'Outras máquinas para preparação de matérias têxteis','Machines for preparing textile fibres (excl. carding, combing, drawing or roving machines)','Máquinas para la preparación de materia textil (exc. cardas, peinadoras y mecheras)',84,8445);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844520,'Máquinas para fiação de matérias têxteis','Textile spinning machines (excl. extruding and drawing or roving machines)','Máquinas para hilar materia textil (exc. máquinas de extrusión y mecheras)',84,8445);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844530,'Máquinas para dobragem ou torção, de matérias têxteis','Textile doubling or twisting machines','Máquinas para doblar o retorcer materia textil',84,8445);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844540,'Máquinas de bobinar ou de dobar, matérias têxteis','Textile winding, incl. weft-winding, or reeling machines','Máquinas para bobinar, incluidas las canilleras, o devanar materia textil',84,8445);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844590,'Outras máquinas e aparelhos para fabricação e preparação de fios têxteis','Machines for producing textile yarns and machines for preparing textile yarns for use on machines of heading 8446 or 8447 (excl. machines of heading 8444 and spinning, doubling or twisting machines)','Máquinas y aparatos para la fabricación de hilados textiles, así como máquinas para la preparación de hilados textiles para su utilización en las máquinas de las partidas 8446 u 8447 (exc. máquinas de la partida 8444, así como máquinas para hilar, doblar ',84,8445);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844610,'Teares para tecidos de largura <= 30 cm','Weaving machines for weaving fabrics of a width <= 30 cm','Telares para tejidos de anchura <= 30 cm',84,8446);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844621,'Teares para tecidos de largura > 30 cm, de lançadeiras a motor','Power looms for weaving fabrics of a width > 30 cm, shuttle type','Telares para tejidos de anchura > 30 cm, de lanzadera, de motor',84,8446);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844629,'Teares para tecidos de largura > 30 cm, de lançadeiras, de mão','Hand looms for weaving fabrics of a width > 30 cm, shuttle type','Telares para tejidos de anchura > 30 cm, de lanzadera, de mano',84,8446);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844630,'Teares para tecidos, de largura > 30 cm, sem lançadeiras','Weaving machines for weaving fabrics of a width > 30 cm, shuttleless type','Telares para tejidos de anchura > 30 cm, sin lanzadera',84,8446);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844711,'Teares circulares para malhas, com cilindro de diâmetro <= 165 mm','Circular knitting machines, with cylinder diameter <= 165 mm','Máquinas circulares de tricotar, con cilindro de diámetro <= 165 cm',84,8447);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844712,'Teares circulares para malhas, com cilindro de diâmetro > 165 mm','Circular knitting machines, with cylinder diameter > 165 mm','Máquinas circulares de tricotar, con cilindro de diámetro > 165 cm',84,8447);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844720,'Teares retilíneos para malhas; máquinas de costura por entrelaçamento (couture-tricotage)','Flat knitting machines; stitch-bonding machines','Máquinas rectilíneas de tricotar; máquinas de coser por cadeneta',84,8447);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844790,'Outras máquinas para fabricar guipuras, tules, rendas, bordados, passamanarias, galões ou redes; máquinas para inserir tufos','Machines for making gimped yarn, tulle, lace, embroidery, trimmings, braid or net and machines for tufting (excl. chain or blanket stitch machines)','Máquinas  de entorchar, para fabricar tul, encaje, bordados, pasamanería, trenzas,  redes o de insertar mechones (exc. máquinas cosedoras-bordadoras)',84,8447);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844811,'Ratieras e mecanismos jacquard; redutores, perfuradores e copiadores de cartões; máquinas para enlaçar cartões após perfuração','Doobies and jacquards; card reducing, copying, punching or assembling machines for use therewith','Maquinitas para lizos mecanismos Jacquard; reductoras, perforadoras y copiadoras de cartones; máquinas para unir los cartones después de perforados',84,8448);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844819,'Outras máquinas e aparelhos auxiliares para as máquinas das posições 8444, 8445, 8446 ou 8447','Auxiliary machinery for machines of heading 8444, 8445, 8446 or 8447 (excl. doobies and jacquards, card reducing, copying, punching or assembling machines for use therewith)','Máquinas y aparatos auxiliares para las máquinas de las partidas 8444, 8445, 8446 u 8447 (exc. maquinitas para lizos mecanismos Jacquard; reductoras, perforadoras y copiadoras de cartones; máquinas para unir los cartones después de perforados)',84,8448);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844820,'Partes e acessórios de máquinas da posição 8444 ou das suas máquinas e aparelhos auxiliares','Parts and accessories of machines for extruding, drawing, texturing or cutting man-made textile materials or of their auxiliary machinery, n.e.s.','Partes y accesorios de las máquinas para extrudir, estirar, texturar o cortar materia textil sintética o artificial ó de sus máquinas o aparatos auxiliares, n.c.o.p.',84,8448);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844831,'Guarnições de cardas','Card clothing for machines for preparing textile fibres','Guarniciones de cardas para máquinas para la preparación de materia textil',84,8448);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844832,'Partes e acessórios de máquinas para preparação de matérias têxteis, exceto as guarnições de carda','Parts and accessories of machines for preparing textile fibres, n.e.s. (other than card clothing)','Partes y accesorios de máquinas para la preparación de materia textil, n.c.o.p. (exc. guarniciones de cardas)',84,8448);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844833,'Fusos e suas aletas, anéis e cursores, para máquinas da posição 8445','Spindles, spindle flyers, spinning rings and ring travellers, for machines of heading 8445','Husos y sus aletas, anillos y cursores, para máquinas de la partida 8445',84,8448);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844839,'Outras partes e acessórios de máquinas e aparelhos da posição 8445','Parts and accessories of machines of heading 8445, n.e.s.','Partes y accesorios para máquinas de la partida 8445 ó de sus máquinas o aparatos auxiliares, n.c.o.p.',84,8448);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844841,'Lançadeiras de teares para tecidos','Shuttles of looms for fabric','Lanzaderas de telares para tejidos',84,8448);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844842,'Pentes, liços e quadros de liços, de teares para tecidos','Reeds for looms, healds and heald-frames','Peines, lizos y cuadros de lizos, para telares',84,8448);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844849,'Outras partes e acessórios de teares para tecidos ou das suas máquinas e aparelhos auxiliares','Parts and accessories of weaving machines looms and their auxiliary machinery, n.e.s.','Partes y accesorios de telares o de sus máquinas o aparatos auxiliares, n.c.o.p.',84,8448);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844851,'Platinas, agulhas e outros artigos utilizados na formação de malhas','Sinkers, needles and other articles used in forming stitches, for machines of heading 8447','Platinas, agujas y demás artículos que participen en la formación de mallas, para máquinas de la partida 8447',84,8448);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844859,'Outras partes e acessórios dos teares, máquinas ou aparelhos da posição 8447 ou das suas máquinas e aparelhos auxiliares','Parts and accessories of machines of heading 8447, n.e.s.','Partes y accesorios para máquinas de la partida 8447, n.c.o.p.',84,8448);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (844900,'Máquinas e aparelhos para fabricação ou acabamento de feltro ou de falsos tecidos, inclusive chapéus de feltro; formas para chapéus e artefatos de uso semelhantes','Machinery for the manufacture or finishing of felt or nonwovens in the piece or in shapes, incl. machinery for making felt hats; blocks for making hats; parts thereof (excl. machinery for preparing fibres for felt and calenders)','Máquinas y aparatos para la fabricación o acabado del fieltro o tela sin tejer, en pieza o con forma, incl. las máquinas y aparatos para la fabricación de sombreros de fieltro; sus partes (exc. máquinas para la preparación de fibras antes del afieltrado, ',84,8449);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845011,'Máquinas de lavar roupa, inteiramente automáticas, de capacidade <= 10 kg em peso de roupa seca','Fully-automatic household or laundry-type washing machines, of a dry linen capacity <= 6 kg','Máquinas totalmente automáticas, para lavar ropa, de capacidad unitaria, expresada en peso de ropa seca <= 6 kg',84,8450);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845012,'Outras máquinas de lavar roupa, com secador centrífugo incorporado, de capacidade <= 10 kg em peso de roupa seca','Household or laundry-type washing machines, with built-in centrifugal drier (excl. fully-automatic machines)','Máquinas para lavar ropa, con secadora centrífuga incorporada (exc. máquinas totalmente automáticas)',84,8450);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845019,'Outras máquinas de lavar roupa, de capacidade <= 10 kg em peso de roupa seca','Household or laundry-type washing machines, of a dry linen capacity <= 6 kg (excl. fully-automatic machines and washing machines with built-in centrifugal drier)','Máquinas para lavar ropa, de capacidad unitaria, expresada en peso de ropa seca <= 6 kg (exc. máquinas totalmente automáticas, así como con secadora centrífuga incorporada)',84,8450);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845020,'Máquinas de lavar roupa, de capacidade > 10 kg, em peso de roupa seca','Laundry-type washing machines, of a dry linen capacity > 10 kg','Máquinas para lavar ropa, de capacidad unitaria, expresada en peso de ropa seca > 10 kg',84,8450);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845090,'Partes de máquinas de lavar roupa, mesmo com dispositivo de secagem','Parts of household or laundry-type washing machines, n.e.s.','Partes de máquinas para lavar ropa, n.c.o.p.',84,8450);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845110,'Máquinas para lavar a seco','Dry-cleaning machines for made-up textile articles','Máquinas para limpieza en seco de manufacturas textiles',84,8451);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845121,'Máquinas para secar roupa, de capacidade <= 10 kg em peso de roupa seca','Drying machines, of a dry linen capacity <= 10 kg (excl. centrifugal driers)','Máquinas para secar ropa, de capacidad unitaria, expresada en peso de ropa seca <= 10 kg (exc. secadoras centrífugas)',84,8451);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845129,'Outras máquinas para secar roupa','Drying machines for textile yarns, fabrics or made-up textile articles (excl. machines of a dry linen capacity <= 10 kg and centrifugal driers)','Máquinas para secar hilados, telas o manufacturas textiles (exc. máquinas para secar ropa, de capacidad unitaria, expresada en peso de ropa seca <= 10 kg, así como secadoras centrífugas)',84,8451);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845130,'Máquinas e prensas para passar roupa, incluídas as fixadoras','Ironing machines and presses, incl. fusing presses (excl. calenders)','Máquinas y prensas para planchar, incl. las prensas para fijar (exc. alisadoras o máquinas para planchar del tipo de las calandrias)',84,8451);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845140,'Máquinas para lavar, branquear ou tingir','Machines for washing, bleaching or dyeing textile yarns, fabrics or made-up textile articles (excl. household or laundry-type washing machines)','Máquinas para lavar, blanquear o teñir hilados, telas o manufacturas textiles (exc. máquinas para lavar ropa)',84,8451);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845150,'Máquinas para enrolar, desenrolar, dobrar, cortar ou dentear tecidos','Machines for reeling, unreeling, folding, cutting or pinking textile fabrics','Máquinas para enrollar, desenrollar, plegar, cortar o dentar telas',84,8451);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845180,'Outras máquinas e aparelhos para trabalhar matérias têxteis','Machinery for dressing, finishing, coating or impregnating textile yarns, fabrics or other made-up textile articles and machines used in the manufacture of linoleum or other floor coverings for applying the paste to the base fabric or other support (excl.','Máquinas y aparatos para aprestar, acabar, recubrir o impregnar hilados, telas o manufacturas textiles y máquinas para el revestimiento de telas u otros soportes utilizados en la fabricación de cubresuelos, tales como el linóleo (exc. para aprestar o acab',84,8451);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845190,'Partes de máquinas e aparelhos para trabalhar matérias têxteis','Parts of machines for washing, cleaning, wringing, drying, ironing, pressing, bleaching, dyeing, dressing, finishing, coating or impregnating textile yarns, fabrics or made-up textile articles; parts of machines used in the manufacture of linoleum or othe','Partes de máquinas y aparatos para lavar, limpiar, escurrir, secar, planchar, prensar, blanquear, teñir, arpestar, acabar, recubrir o impregnar hilados, telas o manufacturas textiles; partes de máquinas para el revestimiento de telas u otros soportes util',84,8451);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845210,'Máquinas de costura de uso da espécie doméstica','Sewing machines of the household type','Máquinas de coser domésticas',84,8452);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845221,'Outras máquinas de costura, unidades automáticas','Automatic sewing machines, industrial type','Unidades automáticas para máquinas de coser industriales',84,8452);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845229,'Outras máquinas de costura, não automáticas','Sewing machines, industrial type (excl. automatic units)','Máquinas de coser industriales (exc. unidades automáticas)',84,8452);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845230,'Agulhas para máquinas de costura','Sewing machine needles','Agujas para máquinas de coser',84,8452);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845240,'Móveis, bases e tampas, para máquinas de costura e suas partes','Furniture, bases and covers for sewing machines and parts thereof','Muebles, basamentos y tapas o cubiertas para máquinas de coser, y sus partes',84,8452);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845290,'Outras partes de máquinas de costura','Parts of sewing machines, n.e.s.','Partes para máquinas de coser, n.c.o.p.',84,8452);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845310,'Máquinas e aparelhos para preparar, curtir ou trabalhar couros ou peles','Machinery for preparing, tanning or working hides, skins or leather (excl. drying machines, spray guns, machines for the dehairing of pigs, sewing machines and general purpose presses)','Máquinas y aparatos para la preparación, curtido o trabajo de cuero o piel (exc. secadoras, máquinas con pistola aerográfica, máquinas para depilar cerdos y prensas de uso general)',84,8453);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845320,'Máquinas e aparelhos para fabricar ou consertar calçados','Machinery for making or repairing footwear of hides, skins or leather (excl. sewing machines)','Máquinas y aparatos para la fabricación o reparación de calzado de cuero o piel (exc. máquinas de coser)',84,8453);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845380,'Outras máquinas e aparelhos para fabricar ou consertar outras obras de couros ou pele','Machinery for making or repairing articles of hides, skins or leather (excl. footwear and sewing machines)','Máquinas y aparatos para la fabricación o reparación de manufacturas de cuero o piel (exc. de calzado, así como las máquinas de coser)',84,8453);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845390,'Partes de máquinas e aparelhos para preparar, curtir ou trabalhar couros ou peles ou para fabricar ou consertar calçados e outras obras de couro ou peles','Parts of machinery for preparing, tanning or working hides, skins or leather or for making or repairing footwear or other articles of hides, skins or leather, n.e.s.','Partes de máquinas y de aparatos para la preparación, curtido o trabajo de cuero o piel o para la fabricación o reparación de calzado u otras manufacturas de cuero o  piel, n.c.o.p.',84,8453);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845410,'Conversores para metalurgia, aciaria ou fundição','Converters of a kind used in metallurgy or in metal foundries','Convertidores para metalurgia, acerías o fundiciones',84,8454);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845420,'Lingoteiras e cadinhos ou colheres de fundição','Ingot moulds and ladles, of a kind used in metallurgy or in metal foundries','Lingoteras y cucharas de colada para metalurgia, acerías o fundiciones',84,8454);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845430,'Máquinas de vazar (moldar), para metalurgia, aciaria ou fundição','Casting machines of a kind used in metallurgy or in metal foundries','Máquinas de colar "moldear", para metalurgia, acerías o fundiciones',84,8454);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845490,'Partes de conversores, lingoteiras e máquinas de vazar, para metalurgia, aciaria ou fundição','Parts of converters, ladles, ingot moulds and casting machines of a kind used in metallurgy or in metal foundries, n.e.s.','Partes de convertidores, de cucharas de colada, de lingoteras y de máquinas de colar "moldear", para metalurgia, acerías o fundiciones, n.c.o.p.',84,8454);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845510,'Laminadores de tubos metálicos','Mills for rolling metal tubes','Laminadores de tubos para tubos de metal',84,8455);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845521,'Outros laminadores a quente e laminadores a quente e a frio, de metais','Hot or combination hot and cold metal-rolling mills (excl. tubes mills)','Laminadores para metal, para laminar en caliente o combinados para laminar en caliente y en frío (exc. laminadores de tubos)',84,8455);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845522,'Laminadores a frio, de metais','Cold-rolling mills for metal (excl. tube mills)','Laminadores para metal, para laminar en frío (exc. laminadores de tubos)',84,8455);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845530,'Cilindros de laminadores, de metais','Rolls for metal-rolling mills','Cilindros de laminadores para metal',84,8455);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845590,'Outras partes de laminadores de metais','Parts of metal-rolling mills, n.e.s.','Partes de laminadores para metal, n.c.o.p.',84,8455);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845610,'Máquinas-ferramentas operando por laser ou por outros feixes de luz de fótons','Machine tools for working any material by removal of material, operated by laser or other light or photon beam processes (excl. soldering and welding machines, incl. those which can be used for cutting, material testing machines and machines for the manuf','Máquinas herramienta que operen mediante láser u otros haces de luz o de fotones (exc. máquinas y aparatos para soldar, aunque puedan cortar, y máquinas para ensayos de metales)',84,8456);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845620,'Máquinas-ferramentas operando por ultra-som','Machine tools for working any material by removal of material, operated by ultrasonic processes (excl. cleaning apparatus operated by ultrasonic processes and material testing machines)','Máquinas herramienta que operen por ultrasonido (exc. aparatos para limpieza por ultrasonido y máquinas para ensayos de metales)',84,8456);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845630,'Máquinas-ferramentas operando por eletro-erosão','Machine tools for working any material by removal of material, operated by electro-discharge processes','Máquinas herramienta que operen por electroerosión',84,8456);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845690,'Outras máquinas-ferramenta que trabalhem por eliminação de qualquer matéria, operando por processos eletroquímicos, feixes de elétrons, feixes iônicos ou por jato de plasma','Machine tools for working any material by removal of material, operated by electro-chemical processes or electron beam, ion beam or plasma arc processes (excl. for soldering and welding machines, materials testing machines and machines for the manufacture','Máquinas herramienta que trabajen por arranque de cualquier materia, por procesos electroquímicos, por haces de electrones, por haces iónicos o por chorro de plasma (excl. aparatos para soldar, aparatos para pruebas de materias así como máquinas para la f',84,8456);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845691,'maqs.ferram.p/grav.a seco do traco em mater.semicondut.','mach.tools f/dry-etching patterns on semicond.mater.','máqs.herram.p/grab.en seco la traza en mater.semicond.',84,8456);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845699,'outras máquinas ferram.oper.por proc.eletroquímicos, etc','oth.mach.tools oper.by process eletro-chemical, etc','las dem.máqs.herram.q.oper.por proc.electroquímicos, etc',84,8456);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845710,'Centros de usinagem, para trabalhar metais','Machining centres for working metal','Centros de mecanizado, para trabajar metal',84,8457);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845720,'Máquinas de sistema monostático, para trabalhar metais','Unit construction machines single station, for working metal','Máquinas de puesto fijo, para trabajar metal',84,8457);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845730,'Máquinas de estações múltiplas, para trabalhar metais','Multi-station transfer machines for working metal','Máquinas de puestos múltiples, para trabajar metal',84,8457);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845811,'Tornos horizontais, de comando numérico, para trabalhar metais','Horizontal lathes, incl. turning centres, for removing metal, numerically controlled','Tornos horizontales, incl. los centros de torneado, que operen por arranque de metal, de control numérico',84,8458);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845819,'Outros tornos horizontais, sem comando numérico, para trabalhar metais','Horizontal lathes, incl. turning centres, for removing metal, not numerically controlled','Tornos horizontales, incl. los centros de torneado, que operen por arranque de metal, de control no numérico',84,8458);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845891,'Outros tornos, de comando numérico, para trabalhar metais','Lathes, incl. turning centres, for removing metal, numerically controlled (excl. horizontal lathes)','Tornos, incl. los centros de torneado, que operen por arranque de metal, de control numérico (exc. tornos horizontales)',84,8458);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845899,'Outros tornos, sem comando numérico, para trabalhar metais','Lathes, incl. turning centres, for removing metal, not numerically controlled (excl. horizontal lathes)','Tornos, incl. los centros de torneado, que operen por arranque de metal (exc. de control numérico, así como tornos horizontales)',84,8458);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845910,'Máquinas-ferramentas para furar, mandrilar, fresar ou roscar metais, unidades com cabeça deslizante','Way-type unit head machines for drilling, boring, milling, threading or tapping metal','Unidades de mecanizado de correderas, de taladrar, fresar o roscar metal',84,8459);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845921,'Outras máquinas para furar metais, de comando numérico','Drilling machines for working metal, numerically controlled (excl. way-type unit head machines)','Máquinas de taladrar metal, de control numérico (exc. unidades de mecanizado de correderas)',84,8459);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845929,'Outras máquinas-ferramentas para furar metais','Drilling machines for working metal, not numerically controlled (excl. way-type unit head machines and hand-operated machines)','Máquinas de taladrar metal, de control no numérico (exc. unidades de mecanizado de correderas, así como las máquinas accionadas manualmente)',84,8459);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845931,'Outras mandriladoras-fresadoras de metais, de comando numérico','Boring-milling machines for metals, numerically controlled (excl. way-type unit head machines)','Escariadoras-fresadoras, para metal, de control numérico (exc. unidades de mecanizado de correderas)',84,8459);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845939,'Outras mandriladoras-fresadoras de metais, sem comando numérico','Boring-milling machines for metals, not numerically controlled (excl. way-type unit head machines)','Escariadoras-fresadoras, para metal, de control no numérico (exc. unidades de mecanizado de correderas)',84,8459);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845940,'Outras máquinas-ferramentas para mandrilar metais','Boring machines for metals (excl. way-type unit head machines and boring-milling machines)','Escariadoras para metal (exc. unidades de mecanizado de correderas y escariadoras-fresadoras)',84,8459);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845951,'Máquinas-ferramentas para fresar metais, de console, de comando numérico','Milling machines for metals, knee-type, numerically controlled','Máquinas de fresar de consola, para metal, de control numérico',84,8459);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845959,'Outras máquinas-ferramentas para fresar metais, de console, sem comando numérico','Milling machines for metals, knee-type, not numerically controlled','Máquinas de fresar de consola, para metal, de control no numérico',84,8459);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845961,'Máquinas-ferramentas para fresar metais, sem console, de comando numérico','Milling machines for metals, numerically controlled (excl. way-type unit head machines, boring-milling machines, knee-type milling machines and gear cutting machines)','Máquinas de fresar para metal, de control numérico (exc. unidades de mecanizado de correderas, escariadoras-fresadoras, máquinas de fresar de consola y máquinas para tallar engranajes)',84,8459);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845969,'Outras máquinas-ferramentas para fresar metais, sem console, sem comando numérico','Milling machines for metals, not numerically controlled (excl. way-type unit head machines, boring-milling machines, knee-type milling machines and gear cutting machines)','Máquinas de fresar para metal, de control no numérico (exc. unidades de mecanizado de corredera, escariadoras-fresadoras, máquinas de fresar de consola y máquinas para tallar engranajes)',84,8459);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (845970,'Outras máquinas-ferramentas para roscar interior ou exteriormente metais','Threading or tapping machines for metals (excl. way-type unit head machines)','Máquinas de roscar "incl. aterrajar" metal (exc. unidades de mecanizado de corredera)',84,8459);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846011,'Máquinas-ferramentas para retificar superfícies planas, de metais, de comando numérico, cujo posicionamento pode ser estabelecido com precisão de pelo menos 0,01 mm','Flat-surface grinding machines, for working metal, in which the positioning in any one axis can be set up to an accuracy of at least 0,01 mm, numerically controlled','Máquinas de rectificar superficies planas, para metal, en las que la posición de la pieza pueda reglarse en uno de los ejes con una precisión >= 0,01 mm, de control numérico',84,8460);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846019,'Outras máquinas-ferramentas para retificar superfícies planas de metais, cujo posicionamento pode ser estabelecido com precisão de pelo menos 0,01 mm','Flat-surface grinding machines, for working metal, in which the positioning in any one axis can be set up to an accuracy of at least 0,01 mm, not numerically controlled','Máquinas de rectificar superficies planas, para metal, en las que la posición de la pieza pueda reglarse en uno de los ejes con una precisión >= 0,01 mm, de control no numérico',84,8460);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846021,'Máquinas-ferramentas para retificar metais, cujo posicionamento pode ser estabelecido com precisão de pelo menos 0,01 mm, de comando numérico','Grinding machines, for working metal, in which the positioning in any one axis can be set up to an accuracy of at least 0,01 mm, numerically controlled (excl. flat-surface grinding machines and gear cutting, gear grinding and gear finishing machines)','Máquinas de rectificar para metal, en las que la posición de la pieza pueda reglarse en uno de los ejes con una precisión >= 0,01 mm, de control numérico (exc. máquinas de rectificar superficies planas y máquinas para acabar engranajes)',84,8460);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846029,'Outras máquinas-ferramentas para retificar metais ou ceramais, cujo posicionamento pode ser estabelecido com precisão de pelo menos 0,01 mm','Grinding machines, for working metals, metal carbides or cermets, in which the positioning in any one axis can be set up to an accuracy of at least 0,01 mm, not numerically controlled (excl. flat-surface grinding machines and gear cutting, gear grinding a','Máquinas de rectificar para metal, en las que la posición de la pieza pueda reglarse en uno de los ejes con una precisión >= 0,01 mm, de control no numérico (exc. máquinas de rectificar superficies planas y máquinas para acabar engranajes)',84,8460);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846031,'Máquinas-ferramentas para afiar metais ou ceramais, de comando numérico','Sharpening tool or cutter grinding machines, numerically controlled','Máquinas de afilar para metal, de control numérico',84,8460);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846039,'Outras máquinas-ferramentas para afiar metais ou ceramais','Sharpening tool or cutter grinding machines, not numerically controlled','Máquinas de afilar para metal, de control no numérico',84,8460);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846040,'Máquinas-ferramentas para brunir metais ou ceramais','Honing or lapping machines, for working metals, metal carbides or cermets (excl. gear cutting, gear grinding or gear finishing machines)','Máquinas de lapear "bruñir", para metal (exc. máquinas para acabar engranajes)',84,8460);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846090,'Outras máquinas-ferramentas para amolar, polir ou realizar outros acabamentos em metais ou ceramais','Machines for deburring, grinding or polishing metals, metal carbides or cermets (excl. grinding machines in which the positioning in any one axis can be set up to an accuracy of at least 0,01 mm, gear cutting, gear grinding or gear finishing machines and ','Máquinas de desbarbar, amolar, pulir o hacer, para metal (exc. máquinas de rectificar en las que la posición de la pieza pueda reglarse en uno de los ejes con una precisión >= 0,01 mm, máquinas para acabar engranajes y máquinas accionadas manualmente)',84,8460);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846110,'Máquinas e ferramentas para aplainar engrenagens','Machine-tools for planing gears','Máquinas y herramientas de cepillar engrenajes',84,8461);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846120,'Plainas-limadoras e máquinas para escatelar','Shaping or slotting machines, for working metals, metal carbides or cermets','Máquinas de limar o mortajar, para metal',84,8461);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846130,'Máquinas-ferramentas para brochar','Broaching machines, for working metals, metal carbides or cermets','Máquinas de brochar para metal',84,8461);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846140,'Máquinas-ferramentas para cortar ou acabar engrenagens','Gear cutting, gear grinding or gear finishing machines, for working metals, metal carbides or cermets (excl. planing, slotting and broaching machines)','Máquinas de tallar o acabar engranajes, para metal (exc. máquinas de cepillar, limar, mortajar o brochar)',84,8461);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846150,'Máquinas-ferramentas para serrar ou seccionar metais','Sawing or cutting-off machines, for working metals, metal carbides or cermets (excl. machines for working in the hand)','Máquinas de aserrar o trocear, para metal (exc. máquinas accionadas manualmente)',84,8461);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846190,'Outras máquinas-ferramentas que operem por eliminação de metal ou de ceramais','Planing machines and other machine tools for working metals, metal carbides or cermets by removing material, n.e.s.','Máquinas de cepillar y demás máquinas herramienta que operen por arranque de metal o cermet, n.c.o.p.',84,8461);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846210,'Máquinas-ferramentas (incluídas as prensas) para forjar ou estampar, martelos, martelos-pilões e martinetes','Forging or die-stamping machines, incl. presses, and hammers','Máquinas, incl. las prensas, de forjar o estampar; martillos pilón y otras máquinas de martillar',84,8462);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846221,'Máquinas-ferramentas (incluídas as prensas) para enrolar, arquear, dobrar, endireitar ou aplanar metais, de comando numérico','Bending, folding, straightening or flattening machines, incl. presses, numerically controlled, for working metal','Máquinas, incl. las prensas, para enrollar, curvar, plegar, enderezar o aplanar, de control numérico, para trabajar metal',84,8462);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846229,'Outras máquinas-ferramentas (incluídas as prensas) para enrolar, arquear, dobrar, endireitar ou aplanar metais','Bending, folding, straightening or flattening machines, incl. presses, not numerically controlled, for working metal','Máquinas, incl. las prensas, para enrollar, curvar, plegar, enderezar o aplanar, de control no numérico, para trabajar metal',84,8462);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846231,'Máquinas-ferramentas (incluídas as prensas) para cisalhar metais, de comando numérico','Shearing machines, incl. presses, numerically controlled, for working metal (other than combined punching and shearing machines)','Máquinas, incl. las prensas, de cizallar, de control numérico, para trabajar metal (exc. máquinas combinadas de cizallar y punzonar)',84,8462);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846239,'Outras máquinas-ferramentas (incluídas as prensas) para cisalhar metais','Shearing machines, incl. presses, not numerically controlled, for working metal (excl. combined punching and shearing machines)','Máquinas, incl. las prensas, de cizallar, de control no numérico, para trabajar metal (exc. máquinas combinadas de cizallar y punzonar)',84,8462);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846241,'Máquinas-ferramentas (incluídas as prensas) para puncionar ou chanfrar metais, de comando numérico','Punching or notching machines, incl. presses, and combined punching and shearing machines, numerically controlled, for working metal','Máquinas, incl. las prensas, de punzonar o entallar, incl. las combinadas de cizallar y punzonar, de control numérico, para trabajar metal',84,8462);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846249,'Outras máquinas-ferramentas (incluídas as prensas) para puncionar ou chanfrar metais','Punching or notching machines, incl. presses, and combined punching and shearing machines, not numerically controlled, for working metal','Máquinas, incl. las prensas, de punzonar o entallar, incl. las combinadas de cizallar y punzonar, de control no numérico, para trabajar metal',84,8462);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846291,'Prensas hidráulicas, para trabalhar metais','Hydraulic presses for working metal (excl. forging, bending, folding, straightening and flattening presses)','Prensas hidráulicas, para trabajar metales (exc. prensas de forjar, estampar, enrollar, curvar, plegar, enderezar o aplanar)',84,8462);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846299,'Outras prensas para trabalhar metais ou carbonetos metálicos','Presses, not hydraulic, for working metal (excl. forging, bending, folding, straightening and flattening presses)','Prensas no hidráulicas, para trabajar metal (exc. prensas de forjar, estampar, enrollar, curvar, plegar, enderezar o aplanar)',84,8462);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846310,'Bancas para estirar barras, perfis, fios ou semelhantes','Draw-benches for metal bars, tubes, profiles, wire or the like','Bancos de estirar barras, tubos, perfiles, alambre o simil., de metal',84,8463);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846320,'Máquinas-ferramentas para fazer roscas internas ou externas por laminagem','Thread rolling machines, for working metal','Máquinas laminadoras para hacer roscas, para trabajar metal',84,8463);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846330,'Máquinas-ferramentas para trabalhar arames e fios de metal','Machine tools for working metal wire, without removing material (excl. wire bending machines of heading 8461 and machines for working in the hand)','Máquinas para trabajar alambres, que no trabajen por arranque de materia (exc. bancos de estirar alambres de la partida 8461 y máquinas accionadas manualmente)',84,8463);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846390,'Outras máquinas-ferramentas para trabalhar metais ou ceramais, sem eliminação de matérias','Machine tools for working metal, sintered metal carbides or cermets, without removing metal (excl. forging, bending, folding, straightening and flattening presses, shearing machines, punching or notching machines, presses, draw-benches, thread rolling mac','Máquinas herramienta para trabajar metal, carburos metálicos sinterizados o cermet, que no trabajen por arranque de materia (exc. prensas, máquinas de forjar, estampar, enrollar, curvar, plegar, enderezar, aplanar, cizallar, punzonar o entallar, bancos de',84,8463);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846410,'Máquinas-ferramentas para serrar pedra, produtos cerâmicos, concreto ou matérias minerais semelhantes, inclusive trabalho a frio do vidro','Sawing machines for working stone, ceramics, concrete, asbestos-cement or like mineral materials or for cold-working glass (excl. machines for working in the hand)','Máquinas de aserrar para trabajar piedra, cerámica, hormigón, amiantocemento o materias minerales simil. o para trabajar el vidrio en frío (exc. máquinas accionadas manualmente)',84,8464);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846420,'Máquinas-ferramentas para esmerar ou polir pedra, produtos cerâmicos, concreto ou matérias minerais semelhantes, inclusive trabalho a frio do vidro','Grinding or polishing machines, for working stone, ceramics, concrete, asbestos-cement or like mineral materials or for cold-working glass (excl. machines for working in the hand)','Máquinas de amolar o pulir, para trabajar piedra, cerámica, hormigón, amiantocemento o materias minerales simil. o para trabajar el vidrio en frío (exc. máquinas accionadas manualmente)',84,8464);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846490,'Outras máquinas-ferramentas para trabalhar pedra, produtos cerâmicos, concreto ou matérias minerais semelhantes','Machine tools for working stone, ceramics, concrete, asbestos-cement or like mineral materials or for cold-working glass (excl. sawing, grinding or polishing machines and machines for working in the hand)','Máquinas herramienta para trabajar piedra, cerámica, hormigón, amiantocemento o materias minerales simil. o para trabajar el vidrio en frío (exc. sierras y máquinas de amolar o de pulir, así como las máquinas accionadas manualmente)',84,8464);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846510,'Máquinas-ferramentas para trabalhar madeira, cortiça, plásticos duros e semelhantes, capazes de realizar diferentes tipos de operações sem troca de ferramentas','Machines for working wood, cork, bone, hard rubber, hard plastics or similar hard materials, which can carry out different types of machining operations without tool change between such operations','Máquinas herramienta, para trabajar madera, plástico rígido o materias duras simil., que efectúen distintas operaciones de mecanizado sin cambio de útil entre dichas operaciones',84,8465);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846591,'Outras máquinas-ferramentas de serrar madeira, cortiça, osso, borracha endurecida ou matérias duras semelhantes','Sawing machines for working wood, cork, bone, hard rubber, hard plastics or similar hard materials (excl. machines for working in the hand)','Máquinas de aserrar para trabajar madera, plástico rígido o materias duras simil. (exc. accionadas manualmente)',84,8465);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846592,'Máquinas-ferramentas para desbastar ou aplainar; máquinas para fresar ou moldurar madeira, plásticos duros ou matérias duras semelhantes','Planing, milling or moulding -by cutting- machines, for working wood, cork, bone, hard rubber, hard plastics or similar hard materials (excl. machines for working in the hand and machines of subheading 8465.10)','Máquinas de cepillar; máquinas de fresar o moldurar, para trabajar madera, plástico rígido o materias duras simil. (exc. máquinas accionadas manualmente y máquinas de la subpartida 8465.10)',84,8465);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846593,'Máquinas para esmerilar, lixar ou polir madeira, plásticos duros ou matérias duras semelhantes','Grinding, sanding or polishing machines for working wood, cork, bone, hard rubber, hard plastics or similar hard materials (excl. machines for working in the hand)','Máquinas de amolar, lijar o pulir, para trabajar madera, plástico rígido o materias duras simil. (exc. máquinas accionadas manualmente)',84,8465);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846594,'Máquinas-ferramentas para arquear ou reunir madeira, plásticos duros ou matérias duras semelhantes','Bending or assembling machines for working wood, cork, bone, hard rubber, hard plastics or similar hard materials (excl. machines for working in the hand)','Máquinas de curvar o ensamblar, para trabajar madera, plástico rígido o materias duras simil. (exc. máquinas accionadas manualmente)',84,8465);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846595,'Máquinas-ferramentas para furar ou escatelar madeira, plásticos duros ou matérias duras semelhantes','Drilling or mortising machines for working wood, cork, bone, hard rubber, hard plastics or similar hard materials (excl. machines for working in the hand and machines of subheading 8465.10)','Máquinas de taladrar o mortajar, para trabajar madera, plástico rígido o materias duras simil. (exc. máquinas accionadas manualmente y máquinas de la subpartida 8465.10)',84,8465);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846596,'Máquinas-ferramentas para fender, seccionar ou desenrolar madeira, cortiça, plásticos duros ou matérias semelhantes','Splitting, slicing or paring machines, for working wood','Máquinas de hendir, rebanar o desenrollar la madera',84,8465);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846599,'Outras máquinas-ferramentas para trabalhar madeira, cortiça, osso, plásticos duros e matérias duras semelhantes','Machine tools for working wood, cork, bone, hard rubber, hard plastics or similar hard materials (excl. machines for working in the hand, machines of subheading 8465.10, sawing machines, planing, milling or moulding -by cutting- machines, grinding, sandin','Máquinas herramienta para trabajar madera, plástico rígido o materias duras simil. (exc. máquinas accionadas manualmente y máquinas de la subpartida 8465.10, así como máquinas de aserar, cepillar, de fresar, moldurar, amolar, lijar, pulir, curvar, ensambl',84,8465);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846610,'Porta-ferramentas e fieiras de abertura automática','Tool holders, incl. tool holders for any type of tool for working in the hand, and self-opening dieheads, for machine tools','Portaútiles para máquinas herramienta y para herramientas de mano de cualquier tipo; dispositivos de roscar de apertura automática',84,8466);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846620,'Porta-peças para outras máquinas-ferramentas','Work holders for machine tools','Portapiezas para máquinas herramienta',84,8466);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846630,'Dispositivos divisores e outros especiais, para máquinas-ferramentas','Dividing heads and other special attachments for machine tools, n.e.s.','Divisores y demás dispositivos especiales para montar en máquinas herramienta, n.c.o.p.',84,8466);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846691,'Partes e acessórios de máquinas-ferramentas da posição 8464','Parts and accessories for machine tools for working stone, ceramics, concrete, asbestos-cement or like mineral materials or for cold-working glass, n.e.s.','Partes y accesorios de máquinas herramienta para trabajar piedra, cerámica, hormigón, amiantocemento o materias simil. o para trabajar el vidrio en frío, n.c.o.p.',84,8466);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846692,'Partes e acessórios de máquinas-ferramentas da posição 8465','Parts and accessories for machine tools for working wood, cork, bone, hard rubber, hard plastics or similar hard materials, n.e.s.','Partes y accesorios de máquinas herramienta para trabajar madera, corcho, hueso, caucho endurecido, plástico rígido o materias duras simil., n.c.o.p.',84,8466);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846693,'Partes e acessórios de máquinas-ferramentas das posições 8456 a 8461','Parts and accessories for machine tools for working metal by removing material, n.e.s.','Partes y accesorios de máquinas herramienta para trabajar metal con arranque de materia, n.c.o.p.',84,8466);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846694,'Partes e acessórios de máquinas-ferramentas da posições 8462 ou 8463','Parts and accessories for machine tools for working metal without removing material, n.e.s.','Partes y accesorios de máquinas herramienta para trabajar metal sin arranque de materia, n.c.o.p.',84,8466);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846711,'Ferramentas pneumáticas rotativas, de uso manual','Tools for working in the hand, pneumatic, rotary type, incl. combined rotary-percussion','Herramientas neumáticas, de uso manual, rotativas, incl. de percusión',84,8467);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846719,'Outras ferramentas pneumáticas, de uso manual','Pneumatic tools for working in the hand, non-rotary type','Herramientas neumáticas, de uso manual, no rotativas',84,8467);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846721,'Furadeiras de todos os tipos, incluídas as perfuratrizes rotativas, com motor elétrico incorporado, de uso manual','Drills of all kinds for working in the hand, with self-contained electric motor','Taladros de toda clase, incl. las perforadoras rotativas, con motor eléctrico incorporado, de uso manual',84,8467);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846722,'Serras, com motor elétrico incorporado, de uso manual','Saws for working in the hand, with self-contained electric motor','Sierras, incl. las tronzadoras, con motor eléctrico incorporado, de uso manual',84,8467);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846729,'Tesouras, cortadoras de tecidos, parafusadeiras, rosqueadeiras, martelos e outras ferramentas, com motor elétrico incorporado, de uso manual','Electromechanical tools for working in the hand, with self-contained electric motor (excl. saws and drills)','Herramientas con motor eléctrico incorporado, de uso manual (exc. taladros de toda clase, incl. las perforadoras rotativas, y sierras, incl. las tronzadoras)',84,8467);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846781,'Serras de corrente, hidráulicas o de motor não elétrico, de uso manual','Chainsaws for working in the hand, with self-contained non-electric motor','Sierras o tronzadoras, de cadena, de uso manual, con motor incorporado que no sea eléctrico',84,8467);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846789,'Outras ferramentas hidráulicas ou de motor não elétrico, de uso manual','Tools for working in the hand, hydraulic or with self-contained non-electric motor (excl. chainsaws and pneumatic tools)','Herramientas de uso manual, hidráulicas o con motor incorporado que no sea eléctrico (exc. sierras o tronzadoras de cadena y herramientas neumáticas)',84,8467);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846791,'Partes de serras de corrente, de uso manual','Parts of chainsaws, for working in the hand, with self-contained electric or non-electric motor, n.e.s.','Partes de sierras o tronzadoras de cadena, con motor incorporado, de uso manual, incl. eléctrico, n.c.o.p.',84,8467);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846792,'Partes de ferramentas pneumáticas, de uso manual','Parts of pneumatic tools for working in the hand, n.e.s.','Partes de herramientas neumáticas, de uso manual, n.c.o.p.',84,8467);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846799,'Outras partes de ferramentas hidráulicas ou de motor não elétrico, de uso manual','Parts of pneumatic tools for working in the hand, hydraulic or with self-contained electric or non-electric motor, n.e.s.','Partes de herramientas hidráulicas o con motor incorporado, incl. eléctrico, de uso manual, n.c.o.p.',84,8467);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846810,'Maçaricos de uso manual','Hand-held blow pipes, gas-operated, for soldering, brazing or welding','Sopletes manuales para soldar',84,8468);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846820,'Outras máquinas e aparelhos a gás, para têmpera superficial','Gas-operated machinery and apparatus for soldering, brazing, welding or surface tempering (excl. hand-held blow pipes)','Máquinas y aparatos de gas, para soldar o para temple superficial (exc. sopletes manuales)',84,8468);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846880,'Outras máquinas e aparelhos para soldar','Machinery and apparatus for welding, not gas-operated (excl. electric machines and apparatus of heading 8515)','Máquinas y aparatos para soldar sin gas (exc. máquinas y aparatos eléctricos de la partida 8515)',84,8468);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846890,'Partes de máquinas e aparelhos para soldar e de máquinas e aparelhos a gás para têmpera superficial','Parts of machinery and apparatus for soldering, brazing, welding or surface tempering, non-electric, n.e.s.','Partes de máquinas y aparatos para soldar o para temple superficial, no eléctricos, n.c.o.p.',84,8468);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846900,'Máquinas de escrever, exceto as impressoras da posição 84.43; máquinas de tratamento de textos.','Typewriters and word-processing machines (excl. automatic data-processing machines and units thereof of heading 8443 and laser, thermal and electrosensitive printers)',' Máquinas de escribir, excepto las impresoras de la partidà 8443; máquinas para tratamiento o procesamiento de textos',84,8469);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846911,'Máquinas de tratamento de textos','Word-processing machines','Máquinas para tratamiento de textos',84,8469);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846912,'Máquinas de escrever, automáticas','Typewriters, automatic','Máquinas de escribir, automáticas',84,8469);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846920,'Máquinas de escrever, elétricas','Automatic typewriters, electric','Máquinas de escribir, eléctricas',84,8469);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (846930,'Outras máquinas de escrever, não elétricas','Other typewriters, non-electrical','Otras máquinas de escribir, no eléctricas',84,8469);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847010,'Calculadoras eletrônicas com funcionamento sem fonte externa de energia elétrica e máquinas de bolso com função de cálculo que permitam gravar, reproduzir e visualizar informações','Electronic calculators capable of operation without an external source of electric power and pocket-size dimensions <= 170 mm x 100 mm x 45 mm data recording, reproducing and displaying machines with calculating functions','Calculadoras electrónicas que funcionen sin fuente de electricidad exterior y máquinas de bolsillo "dimensiones <= 170 mm x 100 mm x 45 mm" registradoras, reproductoras y visualizadoras de datos, con función para cálculo',84,8470);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847021,'Máquinas de calcular, eletrônicas, com dispositivo impressor incorporado','Electronic calculating machines incorporating a printing device, with mains connection (excl. data-processing machines of heading 8471)','Máquinas de calcular electrónicas, con dispositivo de impresión incorporado, conectadas a la red (exc. máquinas para tratamiento o procesamiento de datos de la partida 8471)',84,8470);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847029,'Outras máquinas de calcular, eletrônicas','Electronic calculating machines not incorporating a printing device, with mains connection (excl. data-processing machines of heading 8471)','Máquinas de calcular electrónicas, sin dispositivo de impresión incorporado, conectadas a la red (exc. máquinas para tratamiento o procesamiento de datos de la partida 8471)',84,8470);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847030,'Outras máquinas de calcular','Calculating machines, non-electronic','Máquinas de calcular no electrónicas',84,8470);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847040,'Máquinas de contabilidade','Accounting machines','Máquinas de contabilidad',84,8470);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847050,'Caixas registradoras','Cash registers incorporating a calculating device','Cajas registradoras con dispositivo para cálculo incorporado',84,8470);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847090,'Máquinas de contabilidade, máquinas de franquear, emitir bilhetes e máquinas semelhantes, com dispositivo de cálculo incorporado','Postage-franking machines, ticket-issuing machines and similar machines, incorporating a calculating device (excl. cash registers and automatic vending machines)','Máquinas de franquear, expedir boletos "tiques" y máquinas simil., con dispositivo para cálculo incorporado (exc. máquinas de contabilidad, cajas registradoras y máquinas automáticas para la venta de productos)',84,8470);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847110,'Máquinas p/processam.de dados, analogicas/hibridas','Machines f/data-processing, analogue/ hybrid','Máquinas p/procesam.de datos, analógicas/híbridas',84,8471);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847130,'Máquinas automáticas para processamento de dados, portáteis, de peso <= 10 kg, contendo pelo menos uma unidade central de processamento, um teclado e uma tela - computadores','Data-processing machines, automatic, portable, weighing <= 10 kg, consisting of at least a central processing unit, a keyboard and a display (excl. peripheral units)','Máquinas automáticas para tratamiento o procesamiento de datos, digitales, portátiles, de peso <= 10 kg, que estén constituidas, al menos, por una unidad central de proceso, un teclado y un visualizador (exc. unidades periféricas)',84,8471);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847141,'Outras máquinas automáticas para processamento de dados, contendo, no mesmo corpo, pelo menos uma unidade central de processamento e, mesmo combinadas, uma unidade de entrada e uma unidade de saída - computadores','Data-processing machines, automatic, comprising in the same housing at least a central processing unit, and one input unit and one output unit, whether or not combined (excl. portable weighing <= 10 kg and excl. those presented in the form of systems and ','Máquinas automáticas para tratamiento o procesamiento de datos, digitales, que incluyan en la misma envoltura, al menos, una unidad central de proceso y, aunque estén combinadas, una unidad de entrada y una de salida (exc. unidades periféricas, así como l',84,8471);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847149,'Outras máquinas automáticas para processamento de dados, apresentadas sob a forma de sistemas - computadores','Data-processing machines, automatic, presented in the form of systems comprising at least a central processing unit, one input unit and one output unit (excl. portable weighing <= 10 kg and excl. peripheral units)','Máquinas automáticas para tratamiento o procesamiento de datos, digitales, presentadas con el resto de un sistema "que que estén constituidas, al menos, por una unidad central de proceso, un teclado y un visualizador" (exc. unidades periféricas, así como ',84,8471);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847150,'Unidades de processamento (exceto as das subposições 8471.41 ou 8471.49), podendo conter, no mesmo corpo, um ou dois dos seguintes tipos de unidades: de memória, de entrada e de saída','Processing units for automatic data-processing machines, whether or not containing in the same housing one or two of the following types of unit: storage units, input units, output units (excl. those of heading 8471.41 or 8471.49 and excl. peripheral unit','Unidades de proceso digitales, para máquinas automáticas para tratamiento o procesamiento de datos, aunque incluyan en la misma envoltura uno o dos de los tipos siguientes de unidades: unidad de memoria, unidad de entrada y unidad de salida (exc. unidades',84,8471);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847160,'Unidades de entrada ou de saída, podendo conter, no mesmo corpo, unidades de memória','Input or output units for automatic data-processing machines, whether or not containing storage units in the same housing','Unidades de entrada o salida, digitales, para máquinas automáticas para tratamiento o procesamiento de datos, aunque incluyan unidades de memoria en la misma envoltura',84,8471);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847170,'Unidades de memória','Storage units for automatic data-processing machines','Unidades de memoria para máquinas automáticas para tratamiento o procesamiento de datos, digitales',84,8471);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847180,'Outras unidades de máquinas automáticas para processamento de dados','Units for automatic data-processing machines (excl. processing units, input or output units and storage units)','Unidades de máquinas automáticas para tratamiento o procesamiento de datos, digitales (exc. unidades de proceso, de entrada, de salida y de memoria)',84,8471);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847190,'Outras máquinas automáticas para processamento de dados e suas unidades','Magnetic or optical readers, machines for transcribing data onto data media in coded form and machines for processing such data, n.e.s.','Lectores magnéticos y ópticos, máquinas para registro de datos sobre soporte en forma codificada y máquinas para tratamiento o procesamiento de estos datos, n.c.o.p.',84,8471);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847210,'Duplicadores hectográficos ou a estêncil, para escritório','Duplicating machines hectograph or stencil (excl. printing machines and photocopying or thermo-copying machines)','Copiadoras hectográficas, incl. los mimeógrafos (exc. máquinas para imprimir, así como los aparatos de fotocopia y de termocopia)',84,8472);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847220,'Máqs.p/imprimir enderecos, p/estampar placa de enderecos','Addressing machines/address plate embossing machine','Máqs.de imprimir direcciones, p/estampar placa de direc.',84,8472);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847230,'Máquinas para selecionar, dobrar, abrir, fechar, envelopar ou cintar correspondência e máquinas para colar ou obliterar selos','Machines for sorting or folding mail or for inserting mail in envelopes or bands, machines for opening, closing or sealing mail and machines for affixing or cancelling postage stamps','Máquinas de clasificar, plegar, meter en sobres o colocaren fajas, correspondencia, máquinas de abrir, cerrar o precintar correspondencia y máquinas de colocar u obliterar los sellos "estampillas"',84,8472);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847290,'Outras máquinas e aparelhos de escritório, máquinas para uso bancário e semelhantes','Office machines, n.e.s.','Máquinas y aparatos de oficina, n.c.o.p.',84,8472);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847310,'Partes e acessórios de máquinas da posição 8469','Parts and accessories for typewriters or word-processing machines of heading 8469, n.e.s.','Partes y accesorios para máquinas de escribir y máquinas para tratamiento de textos de la partida 8469, n.c.o.p.',84,8473);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847321,'Partes e acessórios de máquinas de calculadoras eletrônicas das subposições 8470.10, 84.70.21 ou 8470.29','Parts and accessories of electronic calculating machines of subheading 8470.10, 8470.21 or 8470.29, n.e.s.','Partes y accesorios para máquinas de calcular electrónicas de las subpartidas 8470.10, 8470.21 u 8470.29, n.c.o.p.',84,8473);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847329,'Outras partes e acessórios de máquinas da posição 8470','Parts and accessories of non-electronic calculators for accounting machines, cash registers or other machines, incorporating a calculating device, of heading 8470, n.e.s.','Partes y accesorios para máquinas de calcular no electrónicas o para máquinas de contabilidad, cajas registradoras y máquinas simil., con dispositivo para cálculo incorporado, de la partida 8470, n.c.o.p.',84,8473);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847330,'Partes e acessórios para máquinas automáticas de processamento de dados e outras máquinas da posição 8471','Parts and accessories of automatic data-processing machines or for other machines of heading 8471, n.e.s.','Partes y accesorios para máquinas automáticas para tratamiento de información y demás máquinas de la partida 8471, n.c.o.p.',84,8473);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847340,'Partes e acessórios para máquinas e aparelhos da posição 8472','Parts and accessories of other office machines of heading 8472, n.e.s.','Partes y accesorios para máquinas y aparatos de oficina de la partida 8472, n.c.o.p.',84,8473);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847350,'Partes e acessórios que possam ser usados com as máquinas ou aparelhos de duas ou mais das posições 8469 a 8472','Parts and accessories equally suitable for use with two or more typewriters, word-processing machines, calculating machines, automatic data-processing machines or other machines, equipment or devices of heading 8469 to 8472, n.e.s.','Partes y accesorios que puedan utilizarse indistintamente con máquinas de escribir, máquinas para tratamiento de textos, máquinas de calcular, máquinas automáticas para tratamiento o procesiamento de datos u otras máquinas o aparatos de dos o más de las p',84,8473);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847410,'Máquinas e aparelhos para selecionar, peneirar, separar ou lavar substâncias minerais sólidas','Sorting, screening, separating or washing machines for solid mineral substances, incl. those in powder or paste form (excl. centrifuges and filter presses)','Máquinas y aparatos de clasificar, cribar, separar o lavar materias minerales sólidas, incl. el polvo y las pastas (exc. centrifugadoras y filtros prensa)',84,8474);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847420,'Máquinas e aparelhos para esmagar, moer ou pulverizar substâncias minerais sólidas','Crushing or grinding machines for solid mineral substances','Máquinas y aparatos de quebrantar, triturar, triturar o pulverizar materias minerales sólidas',84,8474);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847431,'Betoneiras e aparelhos para amassar cimento','Concrete or mortar mixers (excl. those mounted on railway wagons or lorry chassis)','Hormigoneras y aparatos de amasar mortero (exc. montadas en chasis de vagones o de vehículos automóviles)',84,8474);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847432,'Máquinas para misturar matérias minerais com betume','Machines for mixing mineral substances with bitumen','Máquinas de mezclar materia mineral con asfalto',84,8474);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847439,'Outras máquinas e aparelhos para misturar ou amassar substâncias minerais sólidas','Machinery for mixing or kneading solid mineral substances, incl. those in powder or paste form (excl. concrete and mortar mixers, machines for mixing mineral substances with bitumen and calenders)','Máquinas y aparatos de mezclar o malaxar materias minerales sólidas, incl. el polvo y las pastas (exc. hormigoneras y aparatos de amasar mortero, máquinas de mezclar materia mineral con asfalto y calandrias)',84,8474);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847480,'Outras máquinas e aparelhos para aglomerar ou moldar combustíveis minerais sólidos, pastas cerâmicas, cimento ou gesso, em pó ou em pasta','Machinery for agglomerating, shaping or moulding solid mineral fuels, ceramic paste, unhardened cements, plastering materials and other mineral products in powder or paste form; machines for forming foundry moulds of sand (excl. those for the casting or p','Máquinas de aglomerar, conformar o moldear combustibles minerales sólidos, pastas cerámicas, mortero, yeso y demás materias minerales en polvo o en pasta; máquinas para hacer moldes de arena para fundición (exc. para moldear o prensar el vidrio)',84,8474);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847490,'Partes de máquinas e aparelhos da posição 8474','Parts of machinery for working mineral substances of heading 8474, n.e.s.','Partes de máquinas y de aparatos para preparar y trabajar materias minerales de la partida 8474, n.c.o.p.',84,8474);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847510,'Máquinas para montagem de lâmpadas, tubos ou válvulas, elétricos ou eletrônicos, ou de lâmpadas de luz relâmpago (flash)','Machines for assembling electric or electronic lamps, tubes or valves or flashbulbs, in glass envelopes','Máquinas para montar lámparas, tubos o válvulas eléctricos o electrónicos o lámparas de destello, que tengan envoltura de vidrio',84,8475);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847521,'Máquinas para fabricação de fibras ópticas e seus esboços','Machines for making optical fibres and preforms thereof','Máquinas para fabricar fibras ópticas y sus esbozos',84,8475);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847529,'Outras máquinas para fabricação ou trabalho a quente do vidro e suas obras','Machines for manufacturing or hot working glass or glassware (excl. machines for making optical fibres and preforms thereof and furnaces and heating apparatus for manufacturing toughened glass)','Máquinas para fabricar o trabajar en caliente el vidrio o suss manufacturas (exc. hornos y máquinas de calentamiento para la fabricación de vidrio templado, así como las máquinas para fabricar fibras ópticas y sus esbozos)',84,8475);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847590,'Partes de máquinas para fabricação ou trabalho a quente de vidro e suas obras','Parts of machines for assembling electric or electronic lamps, tubes or valves or flashbulbs, in glass envelopes and of machines for manufacturing or hot working glass or glassware, n.e.s.','Partes de máquinas para montar lámparas, tubos o válvulas eléctricos o electrónicos o lámparas de destello, que tengan envoltura de vidrio; máquinas para fabricar o trabajar en caliente el vidrio o sus manufacturas, n.c.o.p.',84,8475);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847621,'Máquinas automáticas de venda de bebidas, com dispositivo de aquecimento ou de refrigeração incorporado','Automatic beverage-vending machines incorporating heating or refrigerating devices','Máquinas automáticas para la venta de bebidas, con dispositivo de calentamiento o refrigeración incorporado',84,8476);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847629,'Máquinas automáticas de venda de bebidas, sem dispositivo de aquecimento ou de refrigeração incorporado','Automatic beverage-vending machines, without heating or refrigerating devices','Máquinas automáticas para la venta de bebidas, sin dispositivo de calentamiento o refrigeración incorporado',84,8476);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847681,'Máquinas automáticas de venda de produtos (por exemplo:alimentos), com dispositivo de aquecimento ou de refrigeração incorporado','Automatic goods-vending machines incorporating heating or refrigerating devices (excl. automatic beverage-vending machines)','Máquinas automáticas para la venta de productos, con dispositivo de calentamiento o refrigeración incorporado (exc. máquinas automáticas para la venta de bebidas)',84,8476);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847689,'Máquinas automáticas de venda de produtos (por exemplo: cigarros, selos), sem dispositivo de aquecimento ou de refrigeração incorporado, incluídas as máquinas de trocar dinheiro','Automatic goods-vending machines, without heating or refrigerating devices; money changing machines (excl. automatic beverage-vending machines)','Máquinas automáticas para la venta de productos, sin dispositivo de calentamiento o refrigeración incorporado, así como máquinas para cambiar moneda (exc. máquinas automáticas para la venta de bebidas)',84,8476);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847690,'Partes de máquinas automáticas de venda de produtos, incluídas as máquinas de trocar dinheiro','Parts of automatic goods-vending machines, incl. money changing machines, n.e.s.','Partes de máquinas automáticas para la venta de productos, incl. las máquinas de cambiar monedas, n.c.o.p.',84,8476);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847710,'Máquinas de moldar borracha ou plásticos, por injeção','Injection-moulding machines for working rubber or plastics','Máquinas de moldear caucho o plástico por inyección',84,8477);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847720,'Extrusoras para borracha ou plástico','Extruders for working rubber or plastics','Extrusoras, para trabajar caucho o plástico',84,8477);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847730,'Máquinas de moldar borracha ou plásticos, por insuflação','Blow-moulding machines for working rubber or plastics','Máquinas de moldear por soplado, para trabajar caucho o plástico',84,8477);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847740,'Máquinas de moldar borracha ou plásticos a vácuo, e outras máquinas de termoformar','Vacuum-moulding machines and other thermoforming machines for working rubber or plastics','Máquinas de moldear en vacío y demás máquinas para termoformado, para trabajar caucho o plástico',84,8477);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847751,'Máquinas e aparelhos para moldar ou recauchutar pneumáticos ou moldar câmaras-de-ar','Machinery for moulding or retreading pneumatic tyres or for moulding or otherwise forming inner tubes of rubber or plastics','Máquinas de moldear o recauchutar neumáticos "llantas neumáticos" o de moldear o formar cámaras para neumáticos, de caucho o plástico',84,8477);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847759,'Outras máquinas e aparelhos para moldar ou dar forma a borrachas ou plásticos','Machinery for moulding or otherwise forming products from rubber or plastics (excl. injection-moulding machines, extruders, blow-moulding machines, vacuum-moulding and other thermoforming machines; machinery for moulding or retreading pneumatic tyres or f','Máquinas y aparatos de moldear o formar productos de caucho o plástico (exc. máquinas de moldear por inyección, extrusoras, máquinas de moldear por soplado, máquinas de moldear en vacío y demás máquinas para termoformado, así como las máquinas y aparatos ',84,8477);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847780,'Outras máquinas e aparelhos para trabalhar borracha ou plásticos ou para fabricação de seus produtos','Machinery for working rubber or plastics or for the manufacture of products from these materials, not specified or included elsewhere in this chapter','Máquinas y aparatos de trabajar caucho o plástico o para fabricar productos de estas materias, no expresados ni comprendidos en otra parte del capítulo 84',84,8477);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847790,'Partes de máquinas e aparelhos para trabalhar borracha ou plásticos ou para fabricação de seus produtos','Parts of machinery for working rubber or plastics or for the manufacture of products from these materials, n.e.s.','Partes de máquinas y de aparatos de trabajar caucho o plástico o para fabricar productos de estas materias, n.c.o.p.',84,8477);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847810,'Máquinas e aparelhos para preparar ou transformar fumo (tabaco)','Machinery for preparing or making up tobacco (excl. dryers and other heating equipment, centrifuges and filter presses)','Máquinas y aparatos para preparar o elaborar tabaco (exc. aparatos de secado y de calentamiento, así como centrifugadoras y filtros prensa)',84,8478);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847890,'Partes de máquinas e aparelhos para preparar ou transformar fumo (tabaco)','Parts of machinery for preparing or making up tobacco, n.e.s.','Partes de máquinas y de aparatos para preparar o elaborar tabaco, n.c.o.p.',84,8478);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847910,'Máquinas e aparelhos para obras públicas, construção civil ou semelhantes','Machinery for public works, building or the like, n.e.s.','Máquinas y aparatos para obras públicas, la construcción o trabajos análogos',84,8479);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847920,'Máquinas e aparelhos para extração ou preparação de óleos ou gorduras vegetais fixos ou de óleos ou gorduras animais','Machinery for the extraction or preparation of animal or fixed vegetable fats or oils (other than centrifuges, filters and heating appliances)','Máquinas y aparatos para extracción o preparación de  grasas o aceites  vegetales fijos o animales (exc. centrifugadoras y aparatos de filtrado o de calentamiento)',84,8479);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847930,'Prensas para fabricação de painéis de partículas, de fibras de madeira ou matérias lenhosas, e outras máquinas e aparelhos para tratamento de madeira ou cortiça','Presses for the manufacture of particle board or fibre building board of wood or other ligneous materials and other machinery for treating wood or cork (excl. dryers, spray guns and the like and machine tools)','Prensas para fabricar tableros de escamillas, de fibra de madera u otras materias leñosas y demás máquinas y aparatos para trabajar madera o corcho (exc. secadoras, pistolas aerográficas y aparatos simil., así como máquinas herramienta)',84,8479);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847940,'Máquinas para fabricação de cordas ou cabos','Rope or cable-making machines (excl. twisting machines of the type used in spinning mills)','Máquinas de cordelería o cablería (exc. máquinas para retorcer de los tipos utilizados en hilatura)',84,8479);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847950,'Robôs industriais','Industrial robots, n.e.s.','Robots industriales, n.c.o.p.',84,8479);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847960,'Aparelhos de evaporação para arrefecimento do ar','Evaporative air coolers, n.e.s.','Aparatos de evaporación para refrigerar el aire',84,8479);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847971,'Pontes de embarque para passageiros, usado em aeroportos','Boarding bridges for passengers, airport use','Puentes de embarque para pasajeros, uso en aeropuerto',84,8479);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847979,'Outras pontes de embarque','Other boarding bridges','Otras puentes de embarque',84,8479);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847981,'Máquinas e aparelhos para tratamento de metais, incluídas as bobinadoras para enrolamentos elétricos','Machinery for treating metal, incl. electric wire coil-winders, n.e.s. (excl. industrial robots, furnaces, dryers, spray guns and the like, high-pressure cleaning equipment and other jet cleaners, rolling millls or machines, machine tools and rope or cabl','Máquinas y aparatos para trabajar metal, incl. las bobinadoras de hilos eléctricos, n.c.o.p. (exc. robots industriales, hornos, secadoras, pistolas aerográficas y aparatos simil., máquinas para limpiar mediante chorro de agua a alta presión y demás máquin',84,8479);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847982,'Máquinas e aparelhos para misturar, amassar, moer, separar, peneirar, homogeneizar, emulsionar ou agitar','Mixing, kneading, crushing, grinding, screening, sifting, homogenising, emulsifying or stirring machines, n.e.s. (excl. industrial robots)','Máquinas y aparatos para mezclar, amasar o sobar, quebrantar, triturar, pulverizar, cribar, tamizar, homogeneizar, emulsionar o agitar, n.c.o.p. (exc. robots industriales)',84,8479);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847989,'Outras máquinas e aparelhos mecânicos com função própria','Machines and mechanical appliances, n.e.s.','Máquinas y aparatos mecánicos, n.c.o.p.',84,8479);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (847990,'Partes de máquinas e aparelhos mecânicos com função própria','Parts of machines and mechanical appliances, n.e.s.','Partes de máquinas y de aparatos mecánicos, n.c.o.p.',84,8479);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848010,'Caixas de fundição','Moulding boxes for metal foundry','Cajas de fundición',84,8480);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848020,'Placas de fundo para moldes','Mould bases (other than of graphite or other carbon, ceramic meterials or glass)','Placas de fondo para moldes (exc. de grafito u otros carbonos, de materia cerámica o de vidrio)',84,8480);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848030,'Modelos para moldes','Moulding patterns (excl. moulds of graphite or other carbons and ceramic or glass moulds)','Modelos para moldes (exc. de grafito u otros carbonos, de materia cerámica o de vidrio)',84,8480);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848041,'Moldes para moldagem de metais ou carbonetos metálicos, por injeção ou compressão','Injection or compression-type moulds for metal or metal carbides (excl. moulds of graphite or other carbons and ceramic or glass moulds)','Modelos para metal o carburos metálicos, para el moldeo por inyección o compresión (exc. de grafito u otros carbonos, de materia cerámica o de vidrio)',84,8480);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848049,'Outros moldes para metais ou carbonetos metálicos','Moulds for metal or metal carbides (excl. moulds of graphite or other carbons, ceramic or glass moulds, linotype moulds or matrices, injection or compression-type moulds and ingot moulds)','Modelos para metal o carburos metálicos (exc. de grafito u otros carbonos, de materia cerámica o de vidrio, así como cartones de estereotipia, matrices o moldes para linotipias de la partida 8442, modelos para el moldeo por inyección o compresión y lingot',84,8480);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848050,'Moldes para vidro','Moulds for glass (excl. moulds of graphite or other carbons and ceramic moulds)','Moldes para vidrio (exc. de grafito u otros carbonos o de materia cerámica)',84,8480);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848060,'Moldes para matérias minerais','Moulds for mineral materials (excl. moulds of graphite or other carbons and ceramic or glass moulds)','Moldes para materia mineral (exc. de grafito u otros carbonos, de materia cerámica o de vidrio)',84,8480);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848071,'Moldes para moldagem de borracha ou plásticos, por injeção ou compressão','Injection or compression-type moulds for rubber or plastics','Moldes para caucho o plástico, para moldeo por inyección o compresión',84,8480);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848079,'Outros moldes para borracha ou plásticos','Moulds for rubber or plastics (other than injection or compression types)','Moldes para caucho o plástico (exc. para moldeo por inyección o compresión)',84,8480);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848110,'Válvulas redutoras de pressão','Pressure-reducing valves','Válvulas reductoras de presión',84,8481);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848120,'Válvulas para transmissões óleo-hidráulicas ou pneumáticas','Valves for oleohydraulic or pneumatic transmission','Válvulas para transmisiones oleohidráulicas o neumáticas',84,8481);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848130,'Válvulas de retenção','Check non-return valves for pipes, boiler shells, tanks, vats or the like','Válvulas de retención para tuberías, calderas, depósitos, cubas o continentes simil.',84,8481);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848140,'Válvulas de segurança ou de alívio','Safety or relief valves','Válvulas de alivio o seguridad',84,8481);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848180,'Torneiras e outros dispositivos semelhantes para canalizações, caldeiras, reservatórios, cubas e outros recipientes','Appliances for pipes, boiler shells, tanks, vats or the like (excl. pressure-reducing valves, valves for the control of pneumatic power transmission, check non-return valves and safety or relief valves)','Artículos de grifería y órganos reguladores simil. para tuberías (exc. válvulas reductoras de presión, válvulas para transmisiones oleohidráulicas o neumáticas, válvulas de retención y válvulas de alivio o seguridad)',84,8481);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848190,'Partes de válvulas, torneiras e outros dispositivos semelhantes','Parts of valves and similar articles for pipes, boiler shells, tanks, vats or the like, n.e.s.','Partes de artículos de grifería y de órganos de regulación simil., para tuberías, etc., n.c.o.p.',84,8481);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848210,'Rolamentos de esferas','Ball bearings','Rodamientos de bolas',84,8482);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848220,'Rolamentos de roletes cônicos','Tapered roller bearings, incl. cone and tapered roller assemblies','Rodamientos de rodillos cónicos, incl. los ensamblados de conos y rodillos cónicos',84,8482);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848230,'Rolamentos de roletes em forma de tonel','Spherical roller bearings','Rodamientos de rodillos en forma de tonel',84,8482);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848240,'Rolamentos de agulhas','Needle roller bearings','Rodamientos de agujas',84,8482);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848250,'Rolamentos de roletes cilíndricos','Cylindrical roller bearings (excl. needle roller bearings)','Rodamientos de rollos cilíndricos',84,8482);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848280,'Outros rolamentos de roletes, incluídos os rolamentos combinados','Roller bearings, incl. combined ball-roller bearings (excl. ball bearings, tapered roller bearings, incl. cone and tapered roller assemblies, spherical roller bearings, needle and cylindrical roller bearings)','Rodamientos, incl. los combinados (exc. rodamientos de bolas, de rodillos cónicos, incl. los ensamblados de conos y rodillos cónicos, de rodillos en forma de tonel, de agujas y de rodillos cilíndricos)',84,8482);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848291,'Esferas, roletes e agulhas para rolamentos','Balls, needles and rollers for bearings (excl. steel balls of heading 7326)','Bolas, rodillos y agujas para rodamientos (exc. bolas de acero de la partida 7326)',84,8482);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848299,'Outras partes de rolamentos','Parts of ball or roller bearings (excl. balls, needles and rollers), n.e.s.','Partes de rodamientos, n.c.o.p. (exc. bolas, rodillos y agujas)',84,8482);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848310,'Árvores (veios) de transmissão, incluídas as de excêntricos (cames) e virabrequins (cambotas) e manivelas','Transmission shafts, incl. cam shafts and crank shafts, and cranks','Árboles de transmisión, incl. los de levas y los cigüeñales, y manivelas',84,8483);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848320,'Mancais (chumaceiras) com rolamentos incorporados','Bearing housings, incorporating ball or roller bearings, for machinery','Cajas de cojinetes con rodamientos incorporados, para máquinas',84,8483);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848330,'Mancais (chumaceiras) sem rolamentos; bronzes','Bearing housings for machinery, not incorporating ball or roller bearings; plain shaft bearings for machinery','Cajas de cojinetes sin rodamientos incorporados y cojinetes, para máquinas',84,8483);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848340,'Engrenagens e rodas de fricção, eixos de esferas ou de roletes; caixas de transmissão, redutores, multiplicadores e variadores de velocidade','Gears and gearing for machinery (excl. toothed wheels, chain sprockets and other transmission elements presented separately); ball or roller screws; gear boxes and other speed changers, incl. torque converters','Engranajes y ruedas de fricción (exc. ruedas dentadas y demás órganos elementales de transmisión presentados aisladamente); husillos fileteados de bolas o rodillos; reductores, multiplicadores y variadores de velocidad, incl. los convertidores de par',84,8483);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848350,'Volantes e polias, incluídas as cadernais','Flywheels and pulleys, incl. pulley blocks','Volantes y poleas, incluso los motones',84,8483);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848360,'Embreagens e dispositivos de acoplamento, incluídas as juntas de articulação','Clutches and shaft couplings, incl. universal joints, for machinery','Embragues y órganos de acoplamiento, incl. las juntas de articulación, para máquinas',84,8483);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848390,'Rodas dentadas e outros órgãos elementares de transmissão apresentados separadamente; partes de produtos da posição 8483','Toothed wheels, chain sprockets and other transmission elements presented separately; parts of transmission shafts, ball screws, couplings and other articles of heading 8483, n.e.s.','Ruedas dentadas y demás órganos elementales de transmisión presentados aisladamente; partes de árboles de transmisión, de engranajes, de embragues y de otros productos de la partida 8483, n.c.o.p.',84,8483);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848410,'Juntas metaloplásticas','Gaskets and similar joints of metal sheeting combined with other material or of two or more layers of metal','Juntas o empaquetaduras metaloplásticas',84,8484);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848420,'Juntas de vedação, mecânicas','Mechanical seals','Juntas o empaquetaduras mecánicas de estanqueidad',84,8484);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848490,'Outros jogos ou sortidos de juntas, em bolsas, envelopes ou embalagens semelhantes','Sets or assortments of gaskets and similar joints, dissimilar in composition, put up in pouches, envelopes or similar packings','Surtidos de juntas o empaquetaduras de distinta composición presentados en bolsitas, sobres o envases análogos',84,8484);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848499,'Não existente','Do not exit','No hay',84,8484);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848510,'Hélices para embarcações e suas pás','Ships'' or boats'' propellers and blades therefor','Hélices para barcos y sus paletas',84,8485);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848590,'Partes de outs.máquinas ou apars.sem conexões eletr.etc','Parts of other mach.n/contain.electrical connectors, etc','Partes de dem.máquinas o apars.s/conexiones eléctr.etc',84,8485);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848610,'Máquinas e aparelhos para fabricação de esferas (boules) ou de plaquetas (wafers)','Machines and apparatus for the manufacture of boules or wafers','Máquinas y aparatos para la fabricación de semiconductores en forma de monocristales periformes u obleas (wafers)',84,8486);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848620,'Máquinas e aparelhos para fabricação de dispositivos semicondutores ou de circuitos integrados eletrônicos','Machines and apparatus for the manufacture of semiconductor devices or of electronic integrated circuits','Máquinas y aparatos para la fabricación de dispositivos semiconductores o circuitos electrónicos integrados',84,8486);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848630,'Máquinas e aparelhos para fabricação de dispositivos de visualização de tela plana','Machines and apparatus for the manufacture of flat panel displays','Máquinas y aparatos para la fabricación de dispositivos de visualización (display) de pantalla plana',84,8486);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848640,'Outras máquinas e aparelhos especificados na Nota 9 C do Capítulo 84','Machines and apparatus specified in NoteÂ 9 (C) to chapter 84','Máquinas y aparatos descritos en la nota 9 C de este capítulo',84,8486);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848690,'Partes e acessórios para máquinas e aparelhos das subposições 8486.10, 8486.20, 8486.30 e 8486.40','Parts and accessories for machines and apparatus of a kind used solely or principally for the manufacture of semiconductor boules or wafers, semiconductor devices, electronic integrated circuits or flat panel displays, and for machines and apparatus speci','Partes y accesorios de máquinas y aparatos utilizados exclusiva o principalmente para la fabricación de lingotes, placas o dispositivos a semiconductor, circuitos integrados electrónicos o dispositivos de visualización a pantalla plana así como de máquina',84,8486);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848710,'Hélices para embarcações e suas pás','Ships'' or boats'' propellers and blades therefor','Hélices para barcos y sus paletas',84,8487);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (848790,'Outras partes de máquinas e aparelhos, que não contenham conexão elétrica, bobinas, contatos, nem quaisquer outros elementos com características elétricas, não compreendidas em outras posições do Capítulo 84.','Parts of machinery of chapter 84, not intended for a specific purpose, n.e.s.','Partes de máquinas y aparatos del capítulo 84, sin características especiales de utilización, n.c.o.p.',84,8487);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850110,'Motores elétricos de potência <= 37,5 W','Motors of an output <= 37,5 W','Motores eléctricos de potencia <= 37,5 W',85,8501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850120,'Motores elétricos universais de potência > 37,5 W','Universal AC-DC motors of an output > 37,5 W','Motores universales de potencia > 37,5 W',85,8501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850131,'Motores e geradores elétricos, de corrente contínua, de potência <= 750 W','DC motors of an output > 37,5 W but <= 750 W and DC generators of an output <= 750 W','Motores de corriente continua de potencia > 37,5 W pero <= 750 W y generadores de corriente continua de potencia <= 750 W',85,8501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850132,'Motores e geradores elétricos de corrente contínua de potência > 750 W e <= 75 kW','DC motors and DC generators of an output > 750 W but <= 75 kW','Motores de corriente continua y generadores de corriente continua, de potencia > 750 W pero <= 75 kW',85,8501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850133,'Motores e geradores, elétricos, de corrente contínua de potência > 75 kW e <= 375 kW','DC motors and DC generators of an output > 75 kW but <= 375 kW','Motores de corriente continua y generadores de corriente continua, de potencia > 75 kW pero <= 375 kW',85,8501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850134,'Motores e geradores, elétricos de corrente contínua, de potência > 375 kW','DC motors and DC generators of an output > 375 kW','Motores de corriente continua y generadores de corriente continua, de potencia > 375 kW',85,8501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850140,'Outros motores, elétricos, de corrente alternada, monofásicos','AC motors, single-phase, of an output > 37,5 W','Motores de corriente alterna, monofásicos, de potencia > 37,5 W',85,8501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850151,'Outros motores elétricos de corrente alternada, polifásicos, de potência <= 750 W','AC motors, multi-phase, of an output > 37,5 W but <= 750 W','Motores de corriente alterna, polifásicos, de potencia > 37,5 W pero <= 750 W',85,8501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850152,'Outros motores elétricos de corrente alternada, polifásicos, de potência > 750 W e <= 75 kW','AC motors, multi-phase, of an output > 750 W but <= 75 kW','Motores de corriente alterna, polifásicos, de potencia > 750 W pero <= 75 kW',85,8501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850153,'Outros motores elétricos de corrente alternada, polifásicos, de potência > 75 kW','AC motors, multi-phase, of an output > 75 kW','Motores de corriente alterna, polifásicos, de potencia > 75 kW',85,8501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850161,'Geradores de corrente alternada, de potência <= 75 kVA','AC generators alternators, of an output <= 75 kVA','Generadores de corriente alterna "alternadores" de potencia <= 75 kVA',85,8501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850162,'Geradores de corrente alternada, de potência > 75 kVA e <= 375 kVA','AC generators alternators, of an output > 75 kVA but <= 375 kVA','Generadores de corriente alterna "alternadores" de potencia > 75 kVA pero <= 375 kVA',85,8501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850163,'Geradores de corrente alternada, de potência > 375 kVA e <= 750 kVA','AC generators alternators, of an output > 375 kVA but <= 750 kVA','Generadores de corriente alterna "alternadores" de potencia > 375 kVA pero <= 750 kVA',85,8501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850164,'Geradores de corrente alternada, de potência > 750 kVA','AC generators alternators, of an output > 750 kVA','Generadores de corriente alterna "alternadores" de potencia > 750 kVA',85,8501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850211,'Grupos eletrogêneos de motor de pistão, de ignição por compressão, de potência <= 75 kVA','Generating sets with compression-ignition internal combustion piston engine diesel or semi-diesel engine of an output <= 75 kVA','Grupos electrógenos con motor de émbolo "pistón" de encendido por compresión "motores diesel o semi-diesel", de potencia <= 75 kVA',85,8502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850212,'Grupos eletrogêneos de motor de pistão, de ignição por compressão, de potência > 75 kVA e <= 375 kVA','Generating sets with compression-ignition internal combustion piston engine diesel or semi-diesel engine of an output > 75 kVA but <= 375 kVA','Grupos electrógenos con motor de émbolo "pistón" de encendido por compresión "motores diesel o semi-diesel", de potencia > 75 kVA pero <= 375 kVA',85,8502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850213,'Grupos eletrogêneos de motor de pistão, de ignição por compressão, de potência > 375 kVA','Generating sets with compression-ignition internal combustion piston engine diesel or semi-diesel engine of an output > 375 kVA','Grupos electrógenos con motor de émbolo "pistón" de encendido por compresión "motores diesel o semi-diesel", de potencia > 375 kVA',85,8502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850220,'Grupos eletrogêneos de motor de pistão, de ignição por centelha (faísca) (motor de explosão)','Generating sets with spark-ignition internal combustion piston engine','Grupos electrógenos con motor de émbolo "pistón" de encendido por chispa "motor de explosión"',85,8502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850231,'Outros grupos eletrogêneos, de energia eólica','Generating sets, wind-powered','Grupos electrógenos de energía eólica',85,8502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850239,'Outros grupos eletrogêneos','Generating sets (excl. wind-powered and powered by spark-ignition internal combustion piston engine)','Grupos electrógenos con motor distinto de los de émbolo (exc. de energía eólica)',85,8502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850240,'Conversores rotativos elétricos','Electric rotary converters','Convertidores rotativos eléctricos',85,8502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850300,'Partes reconhecíveis como destinadas às máquinas das posições 8501ou 8502','Parts suitable for use solely or principally with electric motors and generators, electric generating sets and rotary converters, n.e.s.','Partes identificables como destinadas, exclusiva o principalmente, a motores y generadores eléctricos, a grupos electrógenos o a convertidores rotativos eléctricos, n.c.o.p.',85,8503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850410,'Reatores para lâmpadas ou tubos de descargas','Ballasts for discharge lamps or tubes','Balastos "reactancias" para lámparas o tubos de descarga',85,8504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850421,'Transformadores de dielétrico líquido, de potência <= 650 kVA','Liquid dielectric transformers, having a power handling capacity <= 650 kVA','Transformadores de dieléctrico líquido, de potencia <= 650 kVA',85,8504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850422,'Transformadores de dielétrico líquido, de potência > 650 kVA e <= 10.000 kVA','Liquid dielectric transformers, having a power handling capacity > 650 kVA but <= 10.000 kVA','Transformadores de dieléctrico líquido, de potencia > 650 kVA pero <= 10.000 kVA',85,8504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850423,'Transformadores de dielétrico líquido, de potência > 10.000 kVA','Liquid dielectric transformers, having a power handling capacity > 10.000 kVA','Transformadores de dieléctrico líquido, de potencia > 10.000 kVA',85,8504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850431,'Outros transformadores elétricos, de potência <= 1 kVA','Transformers having a power handling capacity <= 1 kVA (excl. liquid dielectric transformers)','Transformadores de tipo seco de potencia <= 1 kVA',85,8504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850432,'Outros transformadores elétricos, de potência > 1 kVA e <= 16 kVA','Transformers, having a power handling capacity > 1 kVA but <= 16 kVA (excl. liquid dielectric transformers)','Transformadores de tipo seco de potencia > 1 kVA pero <= 16 kVA',85,8504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850433,'Outros transformadores elétricos, de potência > 16 kVA e <= 500 kVA','Transformers having a power handling capacity > 16 kVA but <= 500 kVA (excl. liquid dielectric transformers)','Transformadores de tipo seco de potencia > 16 kVA pero <= 500 kVA',85,8504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850434,'Outros transformadores elétricos, de potência > 500 kVA','Transformers having a power handling capacity > 500 kVA (excl. liquid dielectric transformers)','Transformadores de tipo seco de potencia > 500 kVA',85,8504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850440,'Conversores elétricos estáticos','Static converters','Convertidores estáticos',85,8504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850450,'Outras bobinas de reatância e de auto-indução','Inductors (excl. inductors for discharge lamps or tubes)','Bobinas de reactancia "autoinducción" (exc. bobinas de reactancia para lámparas o tubos de descarga)',85,8504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850490,'Partes de transformadores, conversores elétricos estáticos e bobinas de reatância e auto-indução','Parts of electrical transformers and inductors, n.e.s.','Partes de transformadores, de rectificadores y demás convertidores estáticos y de bobinas de reactancia "autoinducción", n.c.o.p.',85,8504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850511,'Ímãs permanentes de metal','Permanent magnets of metal and articles intended to become permanent magnets after magnetization (excl. chucks, clamps and similar holding devices)','Imanes permanentes y artículos destinados a ser imantados permanentemente, de metal (exc. platos, mandriles y dispositivos simil. de sujeción)',85,8505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850519,'Outros ímãs permanentes e artefatos destinados a tornarem-se ímãs permanentes','Permanent magnets and articles intended to become permanent magnets after magnetization, of materials other than metal','Imanes permanentes y artículos destinados a ser imantados permanentemente, de materias distintas del metal',85,8505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850520,'Acoplamentos, embreagens, variadores de velocidade e freios (travões), eletromagnéticos','Electromagnetic couplings, clutches and brakes','Acoplamientos, embragues, variadores de velocidad y frenos, electromagnéticos',85,8505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850530,'Cabeças de elevação eletromagnéticas','Electro-magnetic lifting heads','Cabezas elevadoras electromagnéticas',85,8505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850590,'Eletroímãs; placas, mandris e outros dispositivos semelhantes magnéticos ou eletromagnéticos de fixação; cabeças de elevação eletromagnéticas; suas partes','Electromagnets and electromagnetic lifting heads, and their parts (excl. magnets for medical use); electromagnetic or permanent magnet chucks, clamps and similar holding devices and their parts, n.e.s.','Electroimanes (exc. los usados en medicina); platos, mandriles y dispositivos magnéticos o electromagnéticos simil., de sujeción; sus partes, n.c.o.p.',85,8505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850610,'Pilhas e baterias de pilhas, elétricas, de dióxido de manganês','Manganese dioxide cells and batteries (excl. spent)','Pilas y baterías de pilas, de dióxido de manganeso (exc. inservibles)',85,8506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850630,'Pilhas e baterias elétricas, de óxido de mercúrio','Mercuric oxide cells and batteries (excl. spent)','Pilas y baterías de pilas, de óxido de mercurio (exc. inservibles)',85,8506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850640,'Pilhas e baterias elétricas, de óxido de prata','Silver oxide cells and batteries (excl. spent)','Pilas y baterías de pilas, de óxido de plata (exc. inservibles)',85,8506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850650,'Pilhas e baterias elétricas, de lítio','Lithium cells and batteries (excl. spent)','Pilas y baterías de pilas, de litio (exc. inservibles)',85,8506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850660,'Pilhas e baterias elétricas, de ar-zinco','Air-zinc cells and batteries (excl. spent)','Pilas y baterías de pilas, de aire-cinc (exc. inservibles)',85,8506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850680,'Outras pilhas e baterias, elétricas','Primary cells and primary batteries, electric (excl. spent, and those of silver oxide, mercuric oxide, manganese dioxide, lithium and air-zinc)','Pilas y baterías de pilas, eléctricas (exc. inservibles, así como pilas y baterías de pilas de óxido de manganeso, de óxido de mercurio, de óxido de plata, de litio y de aire-cinc)',85,8506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850690,'Partes de pilhas e baterias de pilhas, elétricas','Parts of primary cells and primary batteries, n.e.s.','Partes de pilas y de baterías de pilas, eléctricas, n.c.o.p.',85,8506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850710,'Acumuladores elétricos, de chumbo, utilizados para arranque dos motores de pistão','Lead-acid accumulators of a kind used for starting piston engine starter batteries (excl. spent)','Acumuladores de plomo, de los tipos utilizados para arranque de motores de émbolo "pistón" (exc. inservibles)',85,8507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850720,'Outros acumuladores elétricos, de chumbo','Lead acid accumulators (excl. spent and starter batteries)','Acumuladores de plomo (exc. inservibles, así como los acumuladores de los tipos utilizados para arranque de motores de émbolo "pistón")',85,8507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850730,'Acumuladores elétricos, de níquel-cádmio','Nickel-cadmium accumulators (excl. spent)','Acumuladores de níquel-cadmio (exc. inservibles)',85,8507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850740,'Acumuladores elétricos, de níquel-ferro','Nickel-iron accumulators (excl. spent)','Acumuladores de níquel-hierro (exc. inservibles)',85,8507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850750,'Acumuladores elétricos de niquel-hidreto metálico','Electric accumulators nickel-hydride metalic','Acumuladores eléctricos de níquel-hidreto metálico',85,8507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850760,'Acumuladores elétricos de ion de lítio','Electric storage batteries lithium ion','Baterias de  almacenamiento eléctrico de iones de litio',85,8507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850780,'Outros acumuladores elétricos','Electric accumulators (excl. spent and lead-acid, nickel-cadmium or nickel-iron accumulators)','Acumuladores eléctricos (exc. inservibles, así como los acumuladores de plomo, de níquel-cadmio y de níquel- hierro)',85,8507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850790,'Partes de acumuladores elétricos','Plates, separators and other parts of electric accumulators, n.e.s.','Placas, separadores y los demás partes de acumuladores eléctricos, n.c.o.p.',85,8507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850810,'Perfuradoras com motor elétrico incorporado, de uso manual','Drills of all kinds','Perforadoras con motor eléctrico incorporado, de uso manual',85,8508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850811,'Aspiradores de pó com motor elétrico incorporado de potência não superior a 1.500W e cujo volume de reservatório não exceda 20 litros','Vacuum cleaners, incl. dry cleaners and wet vacuum cleaners, with self-contained electric motor, power <= 1.500 W and having a dust bag or other receptacle capacity <= 20 l','Aspiradoras, incl. las de materias secas y líquidas, con motor eléctrico incorporado, de potencia inferior o igual a 1.500 W y de capacidad del depósito o bolsa para el polvo inferior o igual à 20 l',85,8508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850819,'Outros aspiradores de pó com motor elétrico incorporado','Vacuum cleaners, incl. dry cleaners and wet vacuum cleaners, with self-contained electric motor ( excl. of a power <= 1Â 500Â W and having a dust bag or other receptacle capacity <= 20Â l)','Aspiradoras, incl. las de materias secas y materias líquidas, a motor eléctrico incorporado (excl. aspiradoras de potencia inferior o igual a 1.500 W y de capacidad del depósito o bolsa para el polvo inferior o igual à 20 l)',85,8508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850820,'Serras com motor elétrico incorporado, de uso manual','Saws for working in the hand, with self-contained electric motor','Sierras con motor eléctrico incorporado, de uso manual',85,8508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850860,'Outros aspiradores','Vacuum cleaners, incl. dry cleaners and wet vacuum cleaners (excl. with self-contained electric motor)','Aspiradoras, incl. las de materias secas y líquidas (exc. aspiradoras a motor eléctrico incorporado)',85,8508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850870,'Partes de aspiradores','Parts of vacuum cleaners, dry cleaners and wet vacuum cleaners, n.e.s.','Partes de las aspiradoras, n.c.o.p.',85,8508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850880,'Ferramentas e equipamentos diversos, de uso manual, com motor elétrico','Tools and other equipments. hand use, with electric motor','Herramientas y otros equipos, uso manual, con motor eléctrico',85,8508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850890,'Partes de ferramentas eletromecan.c/motor eletr.manual','Parts of electromech.tools with electric motor, manual','Partes de herramientas electromec.c/motor eléct.manual',85,8508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850910,'Aspiradores de pó, com motor elétrico, de uso doméstico','Vacuum cleaners, with electric motor, domestic use','Aspiradoras de polvo, con motor eléctrico, de uso doméstico',85,8509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850920,'Enceradeiras de piso, com motor elétrico, de uso doméstico','Floor polishers, with electric motor, domestic use','Enceradoras de piso, com motor eléctrico, uso doméstico',85,8509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850930,'Triturador de restos de cozinha, com motor elétrico, uso doméstico','Kitchen waste disposers, with electric motor, domestic use','Triturador de desper.de cocina, con motor eléctrico, doméstico',85,8509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850940,'Trituradores e misturadores de alimentos; espremedores de frutas ou produtos hortícolas, de uso doméstico','Domestic food grinders and mixers and fruit or vegetable juice extractors, with self-contained electric motor','Trituradoras y mezcladoras de alimentos, así como exprimidoras de frutas y de verduras, con motor eléctrico incorporado, de uso doméstico',85,8509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850980,'Outros aparelhos eletromecânicos, com motor elétrico incorporado, de uso doméstico','Electromechanical household appliances, with self-contained electric motor (excl. vacuum cleaners, dry and wet vacuum cleaners, food grinders and mixers, fruit or vegetable juice extractors, and hair-removing appliances)','Aparatos electromecánicos con motor eléctrico incorporado, de uso doméstico (exc. aspiradoras, incl. las de materias secas y líquidas, enceradoras "lustradoras" de pisos, trituradoras de desperdicios de cocina, trituradoras y mezcladoras de alimentos, así',85,8509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (850990,'Partes de aparelhos eletromecânicos, com motor elétrico incorporado, de uso doméstico','Parts of electromechanical domestic appliances, with self-contained electric motor, n.e.s. (excl. of vacuum cleaners, dry and wet vacuum cleaners)','Partes de aparatos electromecánicos con motor eléctrico incorporado, de uso doméstico, n.c.o.p.',85,8509);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851010,'Aparelhos ou máquinas de barbear, com motor elétrico','Shavers, electric','Afeitadoras, eléctricas',85,8510);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851020,'Máquinas de cortar o cabelo ou de tosquiar, com motor elétrico','Hair clippers with self-contained electric motor','Máquinas de cortar el pelo o esquilar, con motor eléctrico incorporado',85,8510);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851030,'Aparelhos de depilar, com motor elétrico','Hair-removing appliances with self-contained electric motor','Aparatos de depilar, con motor eléctrico incorporado',85,8510);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851090,'Partes de aparelhos ou máquinas de barbear, cortar cabelo ou tosquiar, depilar, de motor elétrico incorporado','Parts of electric shavers, hair clippers and hair-removing appliances, with self-contained electric motor, n.e.s.','Partes de afeitadoras, de máquinas de cortar el pelo o esquilar y de aparatos de depilar, con motor eléctrico incorporado, n.c.o.p.',85,8510);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851110,'Velas de ignição para motores de ignição por centelha ou por compressão','Sparking plugs of a kind used for spark-ignition or compression-ignition internal combustion engines','Bujías de encendido, para motores de combustión',85,8511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851120,'Magnetos; dínamos-magnetos; volantes magnéticos, para motores de ignição por centelha ou por compressão','Ignition magnetos, magneto-dynamos and magnetic flywheels, for spark-ignition or compression-ignition internal combustion engines','Magnetos, dinamomagnetos y volantes magnéticos, para motores de combustión',85,8511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851130,'Distribuidores e bobinas de ignição para motores de ignição por centelha ou por compressão','Distributors and ignition coils of a kind used for spark-ignition or compression-ignition internal combustion engines','Distribuidores y bobinas de encendido, para motores de combustión',85,8511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851140,'Motores de arranque, mesmo funcionando como geradores, para motores de ignição por centelha ou por compressão','Starter motors and dual purpose starter-generators of a kind used for spark-ignition or compression-ignition internal combustion engines','Motores de arranque eléctricos, aunque funcionen también como generadores, para motores de combustión',85,8511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851150,'Outros geradores elétricos para motores de ignição por centelha ou por compressão','Generators of a kind used for internal combustion engines (excl. magneto dynamos and dual purpose starter-generators)','Generadores, para motores de combustión (exc. dinamomagnetos y motores de arranque)',85,8511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851180,'Outros aparelhos e dispositivos elétricos de ignição ou de arranque para motores de ignição por centelha ou por compressão','Electrical ignition or starting equipment, incl. cut-outs, of a kind used for spark-ignition or compression-ignition internal combustion engines (excl. generators, starter motors, distributors, ignition coils, ignition magnetos, magnetic flywheels and spa','Aparatos y dispositivos eléctricos de encendido o de arranque, incl. los reguladores disyuntores, para motores de encendido por chispa o compresión (exc. generadores, motores de arranque, distribuidores, bobinas de encendido, magnetos, volantes magnéticos',85,8511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851190,'Partes de aparelhos e dispositivos elétricos de ignição ou de arranque da posição 8511','Parts of electrical ignition or starting equipment, generators, etc. of heading 8511, n.e.s.','Partes de aparatos y de dispositivos eléctricos de encendido o de arranque, para motores de encendido por chispa o compresión, y partes de generadores y de reguladores disyuntores utilizados con estos motores, n.c.o.p.',85,8511);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851210,'Aparelhos elétricos de iluminação ou sinalização visual utilizados em bicicletas','Electric lighting or visual signalling equipment of a kind used for bicycles (other than lamps of heading 8539)','Aparatos de alumbrado o señalización visual, eléctricos, de los tipos utilizados en bicicletas (exc. lámparas de la partida 8539)',85,8512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851220,'Outros aparelhos elétricos de sinalização visual para automóveis','Electrical lighting or visual signalling equipment for motor vehicles (excl. lamps of heading 8539)','Aparatos de alumbrado o señalización visual, eléctricos, de los tipos utilizados en vehículos automóviles (exc. lámparas de la partida 8539)',85,8512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851230,'Aparelhos elétricos de sinalização acústica utilizados em ciclos e automóveis','Electrical sound signalling equipment for cycles or motor vehicles','Aparatos de señalización acústica, eléctricos, de los tipos utilizados en velocípedos o vehículos automóviles',85,8512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851240,'Limpadores de pára-brisas, degeladores e desembaçadores para automóveis, elétricos','Electrical windscreen wipers, defrosters and demisters, for motor vehicles','Limpiaparabrisas y eliminadores de escarcha y de vaho, eléctricos, de los tipos utilizados en vehículos automóviles',85,8512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851290,'Partes de aparelhos elétricos de iluminação ou de sinalização para ciclos e automóveis','Parts of electrical lighting or signalling equipment, windscreen wipers, defrosters and demisters of a kind used for motor vehicles, n.e.s.','Partes de aparatos eléctricos de alumbrado o señalización, de limpiaparabrisas y de eliminadores de escarcha y de vaho, de los tipos utilizados en velocípedos o vehículos automóviles;, n.c.o.p.',85,8512);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851310,'Lanternas','Portable electrical lamps designed to function by their own source of energy','Lámparas eléctricas portátiles concebidas para funcionar con su propia fuente de energía',85,8513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851390,'Partes de lanternas elétricas portáteis','Parts of portable electrical lamps designed to function by their own source of energy, n.e.s.','Partes de lámparas eléctricas portátiles concebidas para funcionar con su propia fuente de energía, n.c.o.p.',85,8513);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851410,'Fornos de resistência industriais ou de laboratório (de aquecimento indireto)','Resistance heated industrial or laboratory furnaces and ovens (excl. drying ovens)','Hornos eléctricos industriales o de laboratorio, de resistencia "de calentamiento indirecto" (exc. hornos de secado)',85,8514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851420,'Fornos elétricos industriais ou de laboratório, funcionando por indução ou por perdas dielétricas','Furnaces and ovens functioning by induction or dielectric loss','Hornos que funcionen por inducción o pérdidas dieléctricas',85,8514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851430,'Outros fornos elétricos industriais ou de laboratório','Electric industrial or laboratory furnaces and ovens (excl. resistance heated, induction, dielectric and drying furnaces and ovens)','Hornos eléctricos industriales o de laboratorio (exc. hornos de resistencia "de calentamiento indirecto" y hornos que funcionen por inducción o por pérdidas dieléctricas, así como los hornos de secado)',85,8514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851440,'Outros aparelhos industriais ou de laboratório para tratamento térmico de matérias, por indução ou por perdas dielétricas','Equipment for the heat treatment of materials by induction or dielectric loss (excl. ovens and furnaces)','Aparatos para tratamiento térmico de materias por inducción o pérdidas dieléctricas (exc. hornos)',85,8514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851490,'Partes de fornos elétricos industriais ou de laboratório','Parts of electric industrial or laboratory furnaces and ovens, incl. of those functioning by induction or dielectric loss, and of industrial or laboratory equipment for the heat treatment of materials by induction or dielectric loss, n.e.s. (other than fo','Partes de hornos eléctricos industriales o de laboratorio, incl. los que funcionen por inducción o pérdidas dieléctricas; partes de los demás aparatos industriales o de laboratorio para tratamiento térmico de materias por inducción o pérdidas dieléctricas',85,8514);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851511,'Ferros e pistolas para soldadura','Soldering irons and guns, electric','Soldadores y pistolas para soldar',85,8515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851519,'Outras máquinas e aparelhos para soldadura forte ou fraca','Brazing or soldering machines (excl. soldering irons and guns)','Máquinas y aparatos para soldadura fuerte o para soldadura blanda (exc. soldadores y pistolas para soldar)',85,8515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851521,'Máquinas e aparelhos para soldar metais por resistência, inteira ou parcialmente automáticos','Fully or partly automatic machines for resistance welding of metals','Máquinas y aparatos para soldar metal por resistencia, total o parcialmente automáticos',85,8515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851529,'Outras máquinas e aparelhos para soldar metais por resistência','Machines for resistance welding of metals, neither fully nor partly automatic','Máquinas y aparatos para soldar metal por resistencia, no automáticos, ni siquiera parcialmente',85,8515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851531,'Máquinas e aparelhos para soldar metais por arco ou jato de plasma, inteira ou parcialmente automáticos','Fully or partly automatic machines for arc welding of metals, incl. plasma arc welding','Máquinas y aparatos para soldar metal, de arco o de chorro de plasma, total o parcialmente automáticos',85,8515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851539,'Outras máquinas e aparelhos para soldar metais por arco ou jato de plasma','Machines for arc welding of metals, incl. plasma arc welding, neither fully nor partly automatic','Máquinas y aparatos para soldar metal, de arco o de chorro de plasma, no automáticos, ni siquiera parcialmente',85,8515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851580,'Outras máquinas e aparelhos para soldar por outros processos, elétricos','Electric machines and apparatus for laser or other light or photon beam, ultrasonic, electron beam, magnetic pulse or plasma arc welding; electric machines and apparatus for hot spraying of metals, metal carbides or cermets (excl. metal spray guns specifi','Máquinas y aparatos para soldar, de láser u otros haces de luz o de fotones, de ultrasonidos, haces de electrones, impulsos magnéticos o chorro de plasma; máquinas y aparatos eléctricos para proyectar en caliente metal o carburos metálicos sinterizados o ',85,8515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851590,'Partes de máquinas e aparelhos para soldar ou para projeção a quente de metais ou ceramais, elétricos','Parts of machines and apparatus for soldering or welding or for hot spraying of metals, metal carbides or cermets, n.e.s. (excl. wire bonders of a kind used for the manufacture of semiconductor devices)','Partes de máquinas y de aparatos eléctricos para soldar o para proyectar en caliente metal o carburos metálicos sinterizados o cermet, n.c.o.p.',85,8515);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851610,'Aquecedores elétricos de água, incluídos os de imersão','Electric instantaneous or storage water heaters and immersion heaters','Calentadores eléctricos de agua de calentamiento instantáneo o acumulación y calentadores eléctricos de inmersión',85,8516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851621,'Radiadores de acumulação, elétricos, para aquecimento de ambientes','Electric storage heating radiators, for space-heating','Radiadores de acumulación, eléctricos, para la calefacción de locales',85,8516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851629,'Outros aparelhos elétricos para aquecimento de ambientes, do solo ou para usos semelhantes','Electric space-heating and soil-heating apparatus (excl. storage heating radiators)','Aparatos eléctricos para calefacción de espacios o suelos (exc. radiadores de acumulación)',85,8516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851631,'Secadores de cabelo, eletrotérmicos','Electric hairdryers','Secadores para el cabello, eléctricos',85,8516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851632,'Outros aparelhos eletrotérmicos para arranjos do cabelo','Electro-thermic hairdressing apparatus (excl. hairdryers)','Aparatos electrotérmicos para el cuidado del cabello (exc. secadores)',85,8516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851633,'Aparelhos eletrotérmicos para secar as mãos','Electric hand-drying apparatus','Aparatos electrotérmicos para secar las manos',85,8516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851640,'Ferros elétricos de passar','Electric smoothing irons','Planchas eléctricas',85,8516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851650,'Fornos de microondas','Microwave ovens','Hornos de microondas',85,8516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851660,'Outros fornos; fogões de cozinha, fogareiros, grelhas e assadeiras, eletrotérmicos, de uso doméstico','Electric ovens, cookers, cooking plates and boiling rings, electric grillers and roasters, for domestic use (excl. space-heating stoves and microwave ovens)','Hornos; cocinas, calentadores, incl. las mesas de cocción, parrillas y barcacoas "parrillas" (exc. estufas y hornos de microondas)',85,8516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851671,'Aparelhos eletrotérmicos para preparação de café ou de chá, de uso doméstico','Electro-thermic coffee or tea makers, for domestic use','Aparatos electrotérmicos para la preparación de café o té, de uso doméstico',85,8516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851672,'Torradeiras de pão, eletrotérmicas, de uso doméstico','Electric toasters, for domestic use','Tostadoras de pan, eléctricos, de uso doméstico',85,8516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851679,'Outros aparelhos eletrotérmicos, de uso doméstico','Electro-thermic appliances, for domestic use (excl. hairdressing appliances and hand dryers, space-heating and soil-heating apparatus, water heaters, immersion heaters, smoothing irons, microwave ovens, ovens, cookers, cooking plates, boiling rings, grill','Aparatos electrotérmicos, de uso doméstico (exc. para el cuidado del cabello o para secar las manos, para calefacción de espacios o suelos, así como calentadores de agua y calentadores de inmersión, planchas, hornos de microondas, hornos y cocinas, calent',85,8516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851680,'Resistências de aquecimento','Electric heating resistors (excl. those of agglomerated coal and graphite)','Resistencias calentadoras, eléctricas (exc. de carbón aglomerado o de grafito)',85,8516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851690,'Partes de aquecedores elétricos, aparelhos elétricos para aquecimento e outros aparelhos da posição 8516','Parts of electric water heaters, immersion heaters, space-heating apparatus and soil-heating apparatus, hairdressing apparatus and hand dryers, electro-thermic appliances of a kind used for domestic purposes and electric heating resistors, n.e.s.','Partes de calentadores eléctricos de agua de calentamiento instantáneo o acumulación y calentadores eléctricos de inmersión, de aparatos eléctricos para calefacción de espacios o suelos, de aparatos electrotérmicos para el cuidado del cabello o para secar',85,8516);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851711,'Aparelhos telefônicos por fio com unidade auscultador-microfone sem fio','Line telephone sets with cordless handsets','Teléfonos de abonado para la telefonia por hilo, de auricular (combinado con micrófono) inalámbrico',85,8517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851712,'Telefones para redes celulares e para outras redes sem fio','Telephones for cellular networks mobile telephones or for other wireless networks',' Teléfonos móviles (celulares) y los de otras redes inalámbricas',85,8517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851718,'Outros aparelhos telefônicos','Telephone sets (excl. line telephone sets with cordless handsets and telephones for cellular networks or for other wireless networks)','Teléfonos  de abonado (exc. teléfonos de abonado para la telefonia por hilo, de auricular (combinado con micrófono) inalámbrico y teléfonos para redes celulares y para otras redes inalámbricas)',85,8517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851719,'Interfones; aparelhos telefones públicos; outros aparelhos telefônicos','Interphone, public telephones devices, other phones','Interphone, dispositivos de teléfonos públicos, otros teléfonos',85,8517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851721,'Telecopiadores (fax), com impressão','Fax machines (fax), with printing capability','Máquinas de fax, con impresión',85,8517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851722,'Aparelhos de transmissão e recepção automáticas (Telex) ; outros teleimpressores','Apparatus for transmitting and receiving stations (Telex), other teleprinters','Aparatos para la transmisión y recepción de las estaciones (Telex), teletipos otros',85,8517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851730,'Aparelhos de comutação para telegrafia e telefonia','Telephonic or telegraphic switching apparatus','Aparatos de conmutación telefónica o telegráfica',85,8517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851750,'Moduladores/demoduladores','Modulators / demodulators','Moduladores/demoduladores',85,8517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851761,'Estações base de telecomunicações para a transmissão ou recepção de voz, imagens ou outros dados','Base stations of apparatus for the transmission or reception of voice, images or other data','Estaciones de base de aparatos de transmisión o recepción de voz, imágen u otros datos',85,8517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851762,'Aparelhos de recepção, conversão e transmissão ou regeneração de voz, imagens ou outros dados, incluindo os aparelhos de comutação e roteamento ','Machines for the reception, conversion and transmission or regeneration of voice, images or other data, incl. switching and routing apparatus (excl. telephone sets, telephones for cellular networks or for other wireless networks)',' Aparatos para la recepción, conversión y transmisión o regeneración de voz, imagen u otros datos, incluidos los de conmutación y encaminamiento (Â«switching and routing apparatusÂ»)',85,8517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851769,'Outros aparelhos para transmissão ou recepção de voz, imagem ou outros dados, incluidos os aparelhos de comunicação em rede local (LAN) ou em área estendida (WAN)','Apparatus for the transmission or reception of voice, images or other data, incl. apparatus for communication in a wired or wireless network [such as a local or wide area network] (excl. telephone sets, telephones for cellular networks or for other wirele','Aparatos para transmisión o recepción de voz, imagen u otros datos, incl. aparatos para comunicación en red con o sin cable [tales como redes locales (LAN) o extendidas (WAN) (exc. los teléfonos de abonados, teléfonos para redes celulares y para otras red',85,8517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851770,'Partes de aparelhos telefônicos, telefones para redes celulares ou redes sem fio, aparelhos de  transmissão ou recepção de voz, imagens ou outros dados','Parts of telephone sets, telephones for cellular networks or for other wireless networks and of other apparatus for the transmission or reception of voice, images or other data, n.e.s.','Partes de teléfonos de abonado, teléfonos para redes celulares y otras redes inalámbricas así como de otros aparatos para la transmisión o la recepción de voz, imagen u otros datos, n.c.o.p',85,8517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851780,'Concentradores para telefonia ou telegrafia','Concentrators for telephony or telegraphy','Concentrados para telefónica o telegráfica',85,8517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851790,'Partes de aparelhos elétricos para telefonia ou telegrafia','Parts of electrical apparatus for line telephony or line telegraphy','Partes de los aparatos eléctricos para telefonía o telegrafía con hilos',85,8517);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851810,'Microfones e seus suportes','Microphones and stands therefor (excl. cordless microphones with built-in transmitter)','Micrófonos y sus soportes (exc. sin hilos, con emisor incorporado)',85,8518);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851821,'Alto-falante único montado no seu próprio receptáculo','Single loudspeakers, mounted in their enclosures','Cajas acústicas con un altavoz "altoparlante" montado en su caja',85,8518);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851822,'Alto-falantes múltiplos montados no mesmo receptáculo','Multiple loudspeakers, mounted in the same enclosure','Cajas acústicas con varios altavoces "altoparlantes" montados en una misma caja',85,8518);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851829,'Outros alto-falantes','Loudspeakers, without enclosure','Altavoces "altoparlantes" sin montar en cajas',85,8518);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851830,'Fones de ouvido (auscultadores), mesmo cobinados com microfone, e conjuntos ou sortidos constituídos por um microfone e um ou mais alto-falantes','Headphones and earphones, whether or not combined with microphone, and sets consisting of a microphone and one or more loudspeakers (excl. telephone sets, hearing aids and helmets with built-in headphones, whether or not incorporating a microphone)','Auriculares electroacústicos, incl. los de casco, incl. combinados con micrófono y juegos o conjuntos constituidos por un micrófono y uno o varios altavoces "altoparlantes" (exc. teléfonos, audífonos y cascos con auriculares telefónicos integrados, incl. ',85,8518);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851840,'Amplificadores elétricos de audiofreqüência','Audio-frequency electric amplifiers','Amplificadores eléctricos de audiofrecuencia',85,8518);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851850,'Aparelhos elétricos de amplificação de som','Electric sound amplifier sets','Equipos eléctricos para amplificación de sonido',85,8518);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851890,'Partes de microfones, fones de ouvido, amplificadores, alto-falantes','Parts of microphones, loudspeakers, headphones and earphones, earphones, audio-frequency electric amplifiers or electric sound amplifier sets, n.e.s.','Partes de micrófonos, de altavoces "altoparlantes", de auriculares electroacústicos, incl. los de casco, de amplificadores eléctricos de audiofrecuencia o de equipos eléctricos para amplificación del sonido, n.c.o.p.',85,8518);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851910,'Eletrofones comandados por moeda ou ficha','Coin- or token-operated record-players','Tocadiscos que funcionen por ficha o moneda',85,8519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851920,'Aparelhos de gravação que funcionem por introdução de moedas, papel-moeda, cartões de banco, fichas ou por outros meios de pagamento','Sound recording or sound reproducing apparatus, operated by coins, banknotes, bank cards, tokens or by other means of payment [juke boxes]',' Aparatos de grabación o reproducción de sonido, activados con monedas, billetes, tarjetas, fichas o cualquier otro medio de pago',85,8519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851921,'Eletrofones sem alto-falante','Record-players without loudspeaker','Electrófonos sin altavoces',85,8519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851929,'Outros eletrofones','Other record-players','Los demás electrófonos',85,8519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851930,'Toca-discos sem dispositivos de amplificação de som','Turntables record-decks','Giradiscos',85,8519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851931,'Toca-discos com permutador automático de discos','Turntables with automatic exchanging  of disks','Giradiscos con cambiador automático de discos',85,8519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851939,'Outros toca-discos','Other turntables','Los demás giradiscos',85,8519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851940,'Máquinas de ditar sem dispositivo de gravação de som','Transcribing mach.without dispos.of sound recording','Aparatos p/reprod.dictados s/disposit.de grab.de sonido',85,8519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851950,'Secretárias eletrônicas (atendimento automático)','Telephone answering machines','Contestadores telefónicos',85,8519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851981,'Outros aparelhos de gravação de som que utilizem um suporte magnético, óptico ou de semicondutor','Sound recording or sound reproducing apparatus, using magnetic, optical or semiconductor media (excl. those operated by coins, banknotes, bank cards, tokens or by other means of payment, turntables and telephone answering machines)','Aparatos de grabación o reproducción de sonido, utilizando un soporte magnético, óptico o a semiconductores (exc. aparatos activados con monedas, billetes, tarjetas, fichas o cualquier otro medio de pago, giradiscos así como contestadores telefónicos)',85,8519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851989,'Outros aparelhos de gravação e de reprodução de som','Sound recording or sound reproducing apparatus (excl. using magnetic, optical or semiconductor media, those operated by coins, banknotes, bank cards, tokens or by other means of payment, turntables and telephone answering machines)','Aparatos de grabación o reproducción de sonido (exc. aparatos utilizando un soporte magnético, óptico o a semiconductores, los activados con monedas, billetes, tarjetas, fichas o cualquier otro medio de pago, giradiscos así como contestadores telefónicos)',85,8519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851992,'Toca-fitas (leitores de cassetes), de bolso','Pocket-size cassette-players','Tocacasetes (lectores de casetes), de bolsillo',85,8519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851993,'Outros toca-fitas (leitores de cassetes)','Other cassette-players','Demás tocacasetes (lectores de casetes)',85,8519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (851999,'Outros aparelhos de reprodução de som','Other sound reproducing apparatus','Otros aparatos de reproducción de sonido',85,8519);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852010,'Máquinas de ditar com dispositivo de gravação de som, fonte externa de energia','dictating mac.with disp.of sound recor.ext.source power','apars.p/dictar c/disp.de grab.sonido, fuente energía ext',85,8520);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852020,'Secretárias eletrônicas (atendedores automáticos)','Telephone answering machines','Contestadores telefónicos',85,8520);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852032,'Aparelhos digitais de gravação/reprodução de som, de fita magnética','digital of recor.appar./reprod.of sound, of magn.tape','apars.digitales de grabac/repr.de sonido, de cinta magn',85,8520);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852033,'Aparelhos de gravação/repdorução de som, de fitas magnéticas de cassete','Recording apparatus for  reprod.of sound, of magn.tape, of cassette','apars.de grab/repr.de sonido, de cinta magnét.de casete',85,8520);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852039,'Outros aparelhos de gravação/reprodução do.som, de fitas magnéticas','Other recor.appar./reprod.of sound, of magnetic tape','los dem.aparatos de grab/reprod.sonido, de cintas magnét',85,8520);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852090,'Outros aparelhos de gravação de som e gravadores de fita magnética','Other sound recording apparatus and magnetic tape recorders','Otros aparatos de grabación de sonido y grabadoras de cintas magnéticas',85,8520);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852110,'Aparelhos videofônicos de gravação ou de reprodução, de fita magnética','Magnetic tape-type video recording or reproducing apparatus, whether or not incorporating a video tuner (excl. video camera recorders)','Aparatos de grabación o reproducción de imagen y sonido "vídeos", de cinta magnética, incl. con receptor de señales de imagen y sonido incorporado (exc. videocámaras)',85,8521);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852190,'Outros aparelhos videofônicos de gravação ou de reprodução','Video recording or reproducing apparatus, whether or not incorporating a video tuner (excl. magnetic tape-type and video camera recorders)','Aparatos de grabación o reproducción de imagen y sonido "vídeos", incl. con receptor de señales de imagen y sonido incorporado (exc. de cinta magnética, así como las videocámaras)',85,8521);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852210,'Fonocaptores para aparelhos das posições 8519 a 8521','Pick-up cartridges','Cápsulas fonocaptoras',85,8522);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852290,'Outras partes e acessórios para aparelhos das posições 8519 a 8521','Parts and accessories suitable for use solely or principally with sound reproducing and recording apparatus and with video equipment for recording and reproducing pictures and sound (excl. pick-up devices for grooved recording media)','Partes y accesorios identificables como destinados, exclusiva o principalmente, a los aparatos de reproducción de sonido, a los aparatos de grabación de sonido y a los aparatos de grabación o reproducción de imagen y sonido "vídeos" (exc. cápsulas fonocap',85,8522);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852311,'Fitas magnéticas, não gravadas, de largura não superior a quatro milímetros','Magnetic tapes, unrecorded, of a width not exceeding 4mm','Cintas magnéticas, sin grabar, de anchura no superior a 4 mm',85,8523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852312,'Fitas magnéticas, não gravadas, 4mm < largura <=6.5mm','Magnetic tapes, unrecorded, width exceeding 4mm but not exceeding 6.5mm','Cintas magnéticas, sin grabar, 4mm < anchura <=6.5mm',85,8523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852313,'Fitas magnéticas, não gravadas, de largura superior a 6,5 milímetros','Magnetic tapes, unrecorded, of a width exceeding 6.5mm','Cintas magnéticas, sin grabar, de anchura superior a 6,5 mm',85,8523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852320,'Discos magnéticos, não gravados','Magnetic discs, unrecorded','Discos magnéticos, sin grabar',85,8523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852321,'Cartões com tarja magnética','Cards incorporating a magnetic stripe for the recording of sound or of other phenomena','Tarjetas con banda magnética incorporada',85,8523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852329,'Discos, fitas e outros suportes magnéticos para gravação','Magnetic media for the recording of sound or of other phenomena (excl. cards incorporating a magnetic stripe and goods of chapter 37)','Soportes magnéticos para el registro del sonido o para registros similares (exc. tarjetas con banda magnética incorporada y productos del capítulo 37)',85,8523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852330,'Cartões magnéticos não gravados','cards incorporating a magnetic stripe, no recorded','tarjetas con tira magnét.incorporadas, no grab.',85,8523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852340,'Suportes ópticos, para gravação e reprodução','Optical media for the recording of sound or of other phenomena (excl. goods of chapter 37)','Soportes ópticos para el registro del sonido o para registros similares (exc. productos del capítulo 37)',85,8523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852341,'Discos para sistema de leitura por raio laser','Disks for laser reading systems','Los discos de sistema de lectura por láser',85,8523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852349,'Outros discos para leitura','Other discs for reading','Otros discos de lectura',85,8523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852351,'Dispositivos de armazenamento não-volátil de dados à base de semicondutores','Solid-state, non-volatile data storage devices for recording data from an external source [flash memory cards or flash electronic storage cards] (excl. goods of chapter 37)','Dispositivos de almacenamiento permanente de datos a base de semiconductores',85,8523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852352,'Cartões inteligentes (smart cards)','Cards incorporating one or more electronic integrated circuits smart cards',' Tarjetas inteligentes (smart cards)',85,8523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852359,'Outros suportes semicondutores para gravação ou reprodução','Semiconductor media, unrecorded, for the recording of sound or of other phenomena (excl. solid-state non-volatile data storage devices, smart cards and goods of chapter 37)','Soportes a semiconductor, sin grabar, para el registro del sonido o para registros similares (exc. dispositivos de almacenamiento permanente de  datos a base de semiconductores, tarjetas inteligentes y productos del capítulo 37) ',85,8523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852380,'Outros suportes para gravação de som ou semelhantes','Gramophone records and other media for the recording of sound or of other phenomena, whether or not recorded, incl. matrices and masters for the production of discs (excl. magnetic, optical and semiconductor media, and products of chapter 37)','Discos y otros soportes para el registro del sonido o para registros similares, grabados o no, incl. matrices y moldes galvánicos para fabricación de discos (exc. soportes magnéticos, ópticos y a semiconductor y productos del capítulo 37)',85,8523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852390,'Outros suportes preparados para gravação de som','Other prepared unrecorded media for sound recording','Otros medios preparados para grabar sonido',85,8523);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852410,'Discos fonográficos, gravados','Gramophone records, recorded','Discos para tocadiscos, grabados',85,8524);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852431,'Discos gravad.p/leit.raio "laser", de fenom.dif.som/imag','Recorded disks for laser reading, of difer.phen.sound/image','Discos grabad.p/lect.rayo láser, de fenóm.dist.son./imag',85,8524);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852432,'Discos gravad.p/leit.raio "laser", reprod.apenas do som','record.disks f/laser reading, reproducing sound only','discos grabad.p/lect.rayo láser, p/reprod.únic.sonido',85,8524);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852439,'Outros discos gravados, para leitura por raio "laser"','Other recorded disks, for laser reading','Demás discos grabados, para lectura por rayo láser',85,8524);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852440,'fitas magnet.gravadas, p/reprod.de fenom.dif.som/imagem','magnetic tapes recorded, f/reprod.dif.phen.sound/image','Cintas magnét.grabadas, p/repr.de fenóm.dist.sonido/imag',85,8524);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852451,'Fitas magnéticas','Magnetic tapes','Tarjetas magnéticas',85,8524);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852452,'Outras fitas magnet.gravadas, 4mm<l<=6.5mm','Other magnetic tapes recorded, 4mm<w<=6.5mm','Las demás cintas magnét.grabadas, 4mm<a<=6.5mm',85,8524);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852453,'Outras fitas magnéticas gravadas, largura > 6.5 mm','Other magnetic tapes recorded, w>6.5mm','Las demás cintas magnét.grabadas, a>6.5mm',85,8524);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852460,'Cartões magnéticos gravados','Cards incorporating a magnetic stripe, recorded','Tarjetas con tira magnética incorporadas',85,8524);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852491,'Outs.suportes gravados, p/reprod.de fenom.dif.som/imagem','Oth.prepar.recorded media f/reprod.dif.phen.sound/image','los dem.soportes grabados, p/repr.de fen.dist.son./imag',85,8524);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852499,'Outros suportes p/grav.de som/semelhs.gravados, etc.','Oth.prepar.recorded media f/sound recording/similar, etc','Los dem.soportes p/grab.som./análogas, grabados, etc',85,8524);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852510,'Aparelhos transmissores','Transmission apparatus','Emisores',85,8525);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852520,'Aparelhos transmissores com aparelho receptor incorporado','Transmission apparatus incorporating reception apparatus','Aparatos emisores con aparato receptor incorporado',85,8525);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852530,'Câmeras de televisão','Television cameras','Cámaras de televisión',85,8525);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852540,'Câmaras de vídeo','Video cameras','Cámaras de video',85,8525);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852550,'Aparelhos transmissores (emissores) para radiodifusão ou televisão','Transmission apparatus for radio-broadcasting or television, not incorporating reception apparatus','Aparatos emisores para la radiodifusión o la televisión, sin aparato receptor incorporado',85,8525);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852560,'Aparelhos transmissores (emissores) para radiodifusão ou televisão incorporando um aparelho receptor','Transmission apparatus for radio-broadcasting or television, incorporating reception apparatus','Aparatos emisores para la radiodifusión o la televisión, con aparato receptor incorporado',85,8525);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852580,'Câmeras de televisão, câmeras fotográficas digitais e câmeras de vídeo','Television cameras, digital cameras and video camera recorders','Cámaras de televisión, cámaras fotográficas digitales y videocámaras',85,8525);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852610,'Aparelhos de radiodetecção e de radiossondagem (radar)','Radar apparatus','Aparatos de radar',85,8526);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852691,'Aparelhos de radionavegação','Radio navigational aid apparatus','Aparatos de radionavegación',85,8526);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852692,'Aparelhos de radiotelecomando','Radio remote control apparatus','Aparatos de radiotelemando',85,8526);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852712,'Rádio toca-fitas (rádio-cassetes), de bolso','Pocket-size radiocassette players [dimensions <= 170 mm x 100 mm x 45 mm], with built-in amplifier, without built-in loudspeakers, capable of operating without an external source of electric power','Radiocasetes de bolsillo "dimensiones <= 170 mm x 100 mm x 45 mm", con amplificador incorporado, sin altavoz "altoparlante" incorporado, que pueden funcionar sin fuente de energía exterior',85,8527);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852713,'Outros aparelhos receptores de radiodifusão, suscetíveis de funcionarem sem uma fonte externa de energia, combinados com um aparelho de gravação ou de reprodução de som','Radio-broadcast receivers capable of operating without an external source of power, combined with sound recording or reproducing apparatus (excl. pocket-size radiocassette players)','Aparatos receptores de radiodifusión que pueden funcionar sin fuente de energía exterior, incl. los que puedan recibir señales de radiotelefonía o radiotelegrafía, combinados con grabador o reproductor de sonido (exc. radiocasetes de bolsillo)',85,8527);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852719,'Outros aparelhos receptores de radiodifusão, suscetíveis de funcionarem sem uma fonte externa de energia','Radio-broadcast receivers capable of operating without an external source of power, not combined with sound-reproducing apparatus','Aparatos receptores de radiodifusión que pueden funcionar sin fuente de energía exterior, incl. los que puedan recibir señales de radiotelefonía o radiotelegrafía, sin grabador o reproductor de sonido',85,8527);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852721,'Aparelhos receptores de radiodifusão que só funcionem com fonte externa de energia combinados com aparelho de gravação ou de reprodução de som, dos tipos utilizados nos veículos automóveis','Radio-broadcast receivers not capable of operating without an external source of power, of a kind used in motor vehicles, combined with sound recording or reproducing apparatus','Aparatos receptores de radiodifusión, que solo funcionen con fuente de energía exterior, de los tipos utilizados en vehículos automóviles, incl. los que puedan recibir señales de radiotelefonía o radiotelegrafía, combinados con grabador o reproductor de s',85,8527);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852729,'Outros aparelhos receptores de radiodifusão, que só funcionem com uma fonte externa de energia, utilizados nos veículos automóveis','Radio-broadcast receivers not capable of operating without an external source of power, of a kind used in motor vehicles, not combined with sound recording or reproducing apparatus','Aparatos receptores de radiodifusión, que solo funcionen con fuente de energía exterior, de los tipos utilizados en vehículos automóviles, incl. los que puedan recibir señales de radiotelefonía o radiotelegrafía, sin grabador o reproductor de sonido',85,8527);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852731,'Outros receptores de rádio-difusão, com aparelho de gravação ou de reprodução','Other radio-broadcast receiver, with recording or reproducing apparatus','Otros receptores de radiodifusión, con la grabación o reproducción de sonido',85,8527);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852732,'Aparelhos receptores de rádio, com relógio, a eletricidade','Recep.appar.of radio with clock, by electricity','Aparatos recept.de radio c/reloj, a electricidad',85,8527);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852739,'Outros aparelhos amplificadores de radiodifusão','Other radio-broadcast receivers','Otros amplificadores de radiodifusión',85,8527);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852790,'Outros aparelhos receptores para radiodifusão','Other reception apparatus for radio-broadcasting','Otros receptores de radiodifusión',85,8527);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852791,'Outros aparelhos receptores para radiodifusão combinados com um aparelho de gravação ou de reprodução de som','Other receivers for broadcasting combined with sound recording or reproducing sound','Receptores de radiodifusión, que solo funcionen con una fuente de energía exterior, combinados a un aparato de registro o reproducción del sonido (otros que para vehículos automóviles)',85,8527);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852792,'Outros aparelhos receptores para radiodifusão não combinados com um aparelho de gravação ou de reprodução de som, mas combinados com relógio','Radio-broadcast receivers, for mains operation only, not combined with sound recording or reproducing apparatus but combined with a clock (excl. those of a kind used in motor vehicles)','Receptores de radiodifusión, que solo funcionen con una fuente de energía exterior, no combinados a un aparato de registro o reproducción del sonido, pero combinados a un aparato de relojería (otros que para vehículos automóviles)',85,8527);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852799,'Outros aparelhos receptores para radiodifusão','Radio-broadcast receivers, for mains operation only, not combined with sound recording or reproducing apparatus and not combined with a clock (excl. those of a kind used in motor vehicles)','Receptores de radiodifusión, que solo funcionen con una fuente de energía, no combinados a un aparato de registro o reproducción del sonido y no combinados a un aparato de relojería (otros que para vehículos automóviles)',85,8527);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852812,'Receptores e decodificadores integrados','Integrated receivers and decoders','Receptores y decodificadores integrados',85,8528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852813,'apars.recept.de tv em preto/branco, mesmo c/rádio, etc.','recep.appar.f/blakc/white telev.incl.radio, etc.','apars.recept.de tv en blanco/negro, incl.c/radio, etc',85,8528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852821,'Monitores de vídeo','Video monitors','Monitores de vídeo',85,8528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852822,'Monitores de vídeo, em preto e branco ou outs.monocromos','video monitors, black and white or oth.monochrome','videomonitores, en blanco y negro o demás monocromos',85,8528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852830,'Projetores de video','Video projectors','Proyectores de video',85,8528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852841,'Monitores com tubo de raios catódicos dos tipos utilizados exclusiva ou principalmente com uma máquina automática para processamento de dados da posição 84.71','Cathode-ray tube monitors of a kind solely or principally used in an automatic data-processing machine of heading 8471','Monitores con tubo de rayos catódicos de los tipos utilizados exclusiva o principalmente con máquinas automáticas para tratamiento o procesamiento de datos de la partida 8471',85,8528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852849,'Outros monitores com tubo de raios catódicos','Cathode-ray tube monitors, not incorporating television reception apparatus (excl. of a kind solely or principally used in an automatic data-processing machine of heading 8471)','Monitores con tubo de rayos catódicos, que no incorporen aparato de recepción de televisión (exc. los tipos utilizados exclusiva o principalmente con máquinas automáticas para tratamiento o procesamiento de datos de la partida 8471l)',85,8528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852851,'Outros monitores, dos tipos utilizados exclusiva ou principalmente com uma máquina automática para processamento de dados da posição 84.71','Monitors of a kind solely or principally used in an automatic data-processing machine of heading 8471 (excl. with cathode ray tube)','Monitores de los tipos utilizados exclusiva o principalmente con máquinas automáticas para tratamiento o procesamiento de datos de la partida 8471 (exc. los monitores con tubo de rayos catódicos)',85,8528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852859,'Outros monitores','Monitors, not incorporating television reception apparatus (excl. with cathode ray tube and those of a kind solely or principally used in an automatic data-processing machine of heading 8471)','Monitores que no incorporen aparato de recepción de televisión (exc. los monitores con tubos de rayos catódicos y los de los tipos utilizados exclusiva o principalmente con máquinas automáticas para tratamiento o procesamiento de datos de la partida 8471)',85,8528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852861,'Projetores dos tipos exclusiva ou principalmente utilizados num sistema automático para processamento de dados da posição 84.71','Projectors of a kind solely or principally used in an automatic data-processing machine of heading 8471','Proyectores de los tipos utilizados exclusiva o principalmente con máquinas automáticas para tratamiento o procesamiento de datos de la partida 8471',85,8528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852869,'Outros projetores','Projectors, not incorporating television reception apparatus (excl. of a kind solely or principally used in an automatic data-processing machine of heading 8471)','Proyectores que no incorporen aparato de recepción de televisión (exc.los tipos utilizados exclusiva o principalmente con máquinas automáticas para tratamiento o procesamiento de datos de la partida 8471)',85,8528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852871,'Aparelhos receptores de televisão, não concebidos para incorporar um dispositivo de visualização (visual display) ou uma tela de vídeo','Reception apparatus for television, whether or not incorporating radio-broadcast receivers or sound or video recording or reproducing apparatus, not designed to incorporate a video display or screen','Aparatos receptores de televisión, incluso con aparato receptor de radiodifusión o aparato de registro o reproducción de sonido o imágenes, no concebidos para incorporar dispositivo de visualización o pantalla de vídeo',85,8528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852872,'Outros aparelhos receptores de televisão em cores','Reception apparatus for television, colour, whether or not incorporating radio-broadcast receivers or sound or video recording or reproducing apparatus, designed to incorporate a video display or screen','Aparatos receptores de televisión en colores, incluso incorporando aparato receptor de radiodifusión o aparato de registro o reproducción de sonido o imágenes, concebidos para incorporar dispositivo de visualización o pantalla de vídeo',85,8528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852873,'Outros aparelhos receptores de televisão preto e branco ou em outros monocromos','Reception apparatus for television, black and white or other monochrome, whether or not incorporating radio-broadcast receivers or sound or video recording or reproducing apparatus, designed to incorporate a video display or screen','Aparatos receptores de televisión blanco y negro o demás monocromos, incluso incorporando aparato receptor de radiodifusión o aparato de registro o reproducción de sonido o imágenes, concebidos para incorporar dispositivo de visualización o pantalla de ví',85,8528);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852910,'Antenas e refletores de antenas de qualquer tipo; partes reconhecíveis como de utilização conjunta com esses artefatos','Aerials and aerial reflectors of all kinds; parts suitable for use therewith, n.e.s.','Antenas y reflectores de antena de cualquier tipo; partes apropiadas para su utilización con dichos artículos, n.c.o.p.',85,8529);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (852990,'Outras partes destinadas aos aparelhos das posições 85.25 a 85.28','Parts suitable for use solely or principally with transmission and reception apparatus for radio-broadcasting or television, television cameras,digital cameras, video camera recorders, radar apparatus, radio navigational aid apparatus or radio remote cont','Partes identificables como destinadas, exclusiva o principalmente, a emisores y a receptores de radiotelefonía, radiotelegrafía, radiodifusión o televisión, a cámaras de televisión y a videocámaras, incl. las de imagen fija, así como a aparatos de radar, ',85,8529);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853010,'Aparelhos elétricos de sinalização, de segurança, de controle ou de comando para vias férreas ou semelhantes','Electrical signalling, safety or traffic control equipment for railways or tramways (excl. mechanical or electromechanical equipment of heading 8608)','Aparatos eléctricos de señalización, seguridad, control o mando, para vías férreas o simil. (exc. aparatos para transmisión de mensajes y aparatos electromecánicos de la partida 8608)',85,8530);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853080,'Outros aparelhos elétricos de sinalização, de segurança, de controle ou de comando para vias terrestres ou fluviais, para áreas ou parques de estacionamento, instalações portuárias ou para aeródromos (exceto os da posição 86.88)','Electrical signalling, safety or traffic control equipment (excl. that for railways or tramways and mechanical or electromechanical equipment of heading 8608)','Aparatos eléctricos de señalización, seguridad, control o mando (exc. para vías férreas o simil., así como aparatos para transmisión de mensajes y aparatos electromecánicos de la partida 8608)',85,8530);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853090,'Partes de aparelhos elétricos de sinalização, de segurança, de controle ou de comando','Parts of electrical signalling, safety or traffic control equipment, n.e.s.','Partes de aparatos eléctricos de señalización, seguridad, control o mando, n.c.o.p.',85,8530);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853110,'Aparelhos elétricos de alarme, para proteção contra roubo ou incêndio e aparelhos semelhantes','Burglar or fire alarms and similar apparatus','Avisadores eléctricos de protección contra robo o incendio y aparatos simil.',85,8531);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853120,'Painéis indicadores com dispositivos de cristais líquidos (LCD) ou de diodos emissores de luz (LED)','Indicator panels with liquid crystal devices LCD or light emitting diodes LED (excl. those for cycles, motor vehicles and traffic signalling)','Tableros indicadores con dispositivos de cristal líquid "LCD" o diodos emisores de luz "LED", incorporados (exc. del tipo utilizado en ciclos, automóviles y vías de circulación)',85,8531);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853180,'Outros aparelhos elétricos de sinalização acústica ou visual','Electric sound or visual signalling apparatus (excl. indicator panels with liquid crystal devices or light emitting diodes, burglar or fire alarms and similar apparatus and apparatus for cycles, motor vehicles and traffic signalling)','Aparatos eléctricos de señalizacion acústica o visual (exc. tableros indicadores con dispositivos de LCD o de LDE, avisadores de protección contra robo o incendio y aparatos simil., así como los aparatos del tipo utilizado en velocípedos,vehículos automóv',85,8531);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853190,'Partes de aparelhos elétricos de sinalização acústica ou visual','Parts of electric sound or visual signalling apparatus, n.e.s.','Partes de aparatos eléctricos de señalizacion acústica o visual, n.c.o.p.',85,8531);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853210,'Condensadores fixos para linhas elétricas de 50/60 Hz e capazes de absorver uma potência reativa => 0,5 kvar','Fixed capacitors designed for use in 50/60 Hz circuits and having a reactive power-handling capacity of >= 0,5 kvar power capacitors','Condensadores fijos concebidos para redes eléctricas de 50/60 Hz, para una potencia reactiva >= 0,5 kvar "condensadores de potencia"',85,8532);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853221,'Condensadores fixos elétricos, de tântalo','Fixed electrical capacitors, tantalum (excl. power capacitors)','Condensadores de tantalio (exc. condensadores de potencia)',85,8532);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853222,'Condensadores fixos eletrolíticos, de alumínio','Fixed electrical capacitors, aluminium electrolytic (excl. power capacitors)','Condensadores electrolíticos de aluminio (exc. condensadores de potencia)',85,8532);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853223,'Condensadores fixos, com dielétrico de cerâmica, de uma só camada','Fixed electrical capacitors, ceramic dielectric, single layer (excl. power capacitors)','Condensadores con dieléctrico de cerámica, de una sola capa (exc. condensadores de potencia)',85,8532);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853224,'Condensadores fixos com dielétrico de cerâmica, de camadas múltiplas','Fixed electrical capacitors, ceramic dielectric, multilayer (excl. power capacitors)','Condensadores con dieléctrico de cerámica, multicapas (exc. condensadores de potencia)',85,8532);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853225,'Condensadores fixos com dielétricos de papel ou de plásticos','Fixed electrical capacitors, dielectric of paper or plastics (excl. power capacitors)','Condensadores con dieléctrico de papel o de plástico (exc. condensadores de potencia)',85,8532);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853229,'Outros condensadores fixos, elétricos','Fixed electrical capacitors (excl. tantalum, aluminium electrolytic, ceramic, paper, plastic and power capacitors)','Condensadores fijos (exc. condensadores de tantalio, condensadores electrolíticos de aluminio, condensadores con dieléctricos de cerámica, de papel o de plástico y condensadores de potencia)',85,8532);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853230,'Condensadores variáveis ou ajustáveis, elétricos','Variable or adjustable pre-set electrical capacitors','Condensadores variables o ajustables, eléctricos',85,8532);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853290,'Partes de condensadores elétricos, fixos, variáveis ou ajustáveis','Parts of electrical pre-set capacitors, fixed, variable or adjustable, n.e.s.','Partes de condensadores eléctricos fijos, variables o ajustables, n.c.o.p.',85,8532);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853310,'Resistências elétricas fixas, de carbono, aglomeradas ou de camada','Fixed carbon resistors, composition or film types (excl. heating resistors)','Resistencias fijas de carbono, aglomeradas o de capa (exc. resistencias de calentamiento)',85,8533);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853321,'Outras resistências elétricas fixas, para potência <= 20 W','Fixed electrical resistors for a power handling capacity <= 20 W (excl. heating resistors)','Resistencias fijas, de potencia <= 20 W (exc. resistencias de calentamiento)',85,8533);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853329,'Outras resistências elétricas fixas','Fixed electrical resistors for a power handling capacity > 20 W (excl. heating resistors)','Resistencias fijas de potencia > 20 W (exc. resistencias de calentamiento)',85,8533);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853331,'Resistências variáveis bobinadas, elétricas, para potência <= 20 W','Wirewound variable electrical resistors, incl. rheostats and potentiometers, for a power handling capacity <= 20 W (excl. heating resistors)','Resistencias variables bobinadas, incl. los reóstatos y los potenciómetros, de potencia <= 20 W (exc. resistencias de calentamiento)',85,8533);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853339,'Outras resistências, elétricas, variáveis bobinadas','Wirewound variable electrical resistors, incl. rheostats and potentiometers, for a power handling capacity > 20 W (excl. heating resistors)','Resistencias variables bobinadas, incl. los reóstatos y los potenciómetros, de potencia > 20 W (exc. resistencias de calentamiento)',85,8533);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853340,'Outras resistências, elétricas, variáveis (incluídos os reostatos e os potenciômetros)','Electrical variable resistors, incl. rheostats and potentiometers (excl. wirewound variable resistors and heating resistors)','Resistencias variables, incl. los reóstatos y los potenciómetros (exc. bobinadas, así como las resistencias de calentamiento)',85,8533);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853390,'Partes de resistências elétricas','Parts of electrical resistors, incl. rheostats and potentiometers, n.e.s.','Partes de resistencias eléctricas, incl. los reóstatos y los potenciómetros, n.c.o.p.',85,8533);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853400,'Circuitos impressos','Printed circuits','Circuitos impresos',85,8534);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853510,'Fusíveis e corta-circuito de fusíveis, para tensão > 1.000 V','Fuses for a voltage > 1.000 V','Fusibles y cortacircuitos de fusible, para una tensión > 1.000 V',85,8535);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853521,'Disjuntores, para tensão > 1 kV e < 72,5 kV','Automatic circuit breakers for a voltage > 1.000 V but < 72,5 kV','Disyuntores, para una tensión > 1.000 V pero < 72,5 kV',85,8535);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853529,'Outros disjuntores para tensão => 72,5 kV','Automatic circuit breakers for a voltage >= 72,5 kV','Disyuntores, para una tensión >= 72,5 kV',85,8535);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853530,'Seccionadores e interruptores, para tensão de > 1 kV','Isolating switches and make-and-break switches, for a voltage > 1.000 V','Seccionadores e interruptores, para una tensión > 1.000 V',85,8535);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853540,'Pára-raios, limitadores de tensão e eliminadores de onda, elétricos, para tensão > 1 kV','Lightning arresters, voltage limiters and surge suppressors, for a voltage > 1.000 V','Pararrayos, limitadores de tensión y supresores de sobretensión transitorias, para una tensión > 1.000 V',85,8535);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853590,'Outros aparelhos para interrupção, seccionamento, ligação de circuitos elétricos, para tensão > 1 kV','Electrical apparatus for switching or protecting electrical circuits, or for making connections to or in electrical circuits, for a voltage > 1.000 V (excl. fuses, automatic circuit breakers, isolating switches, make-and-break switches, lightning arrester','Aparatos eléctricos para corte, seccionamiento, protección, derivación, empalme o conexión de circuitos eléctricos, para una tensión > 1.000 V (exc. fusibles y cortacircuitos de fusible; disyuntores; seccionadores e interruptores; pararrayos, limitadores ',85,8535);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853610,'Fusíveis e corta-circuito de fusíveis, para tensão <= 1 kV','Fuses for a voltage <= 1.000 V','Fusibles y cortacircuitos de fusible, para una tensión <= 1.000 V',85,8536);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853620,'Disjuntores para tensão <= 1 kV','Automatic circuit breakers for a voltage <= 1.000 V','Disyuntores, para una tensión <= 1.000 V',85,8536);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853630,'Outros aparelhos para proteção de circuitos elétricos, para tensão <= 1 kV','Apparatus for protecting electrical circuits for a voltage <= 1.000 V (excl. fuses and automatic circuit breakers)','Aparatos para protección de circuitos eléctricos, para una tensión <= 1.000 V (exc. fusibles, cortacircuitos de fusible y disyuntores)',85,8536);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853641,'Relés, para tensão <= 60 V','Relays for a voltage <= 60 V','Relés, para una tensión <= 60 V',85,8536);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853649,'Outros relés, para tensão > 60 V e <= 1.000 V','Relays for a voltage > 60 V but <= 1.000 V','Relés, para una tensión > 60 V pero <= 1.000 V',85,8536);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853650,'Outros interruptores, seccionadores e comutadores, de circuitos elétricos para tensão <= 1 kV','Switches for a voltage <= 1.000 V (excl. relays and automatic circuit breakers)','Interruptores, seccionadores y conmutadores, para una tensión <= 1.000 V (exc. relés y disyuntores)',85,8536);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853661,'Suportes para lâmpadas, para tensão <= 1 kV','Lamp holders for a voltage <= 1.000 V','Portalámparas, para una tensión <= 1.000 V',85,8536);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853669,'Plugues e tomadas de corrente (machos-e-fêmeas), para tensão <= 1 kV','Plugs and sockets for a voltage <= 1.000 V (excl. lamp holders)','Clavijas y tomas de corriente, para una tensión de <= 1.000 V (exc. portalámparas)',85,8536);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853670,'Conectores para fibras óticas, feixes ou cabos de fibra óptica','Connectors for optical fibres, optical fibre bundles or cables','Conectores de fibras ópticas, haces o cables de fibras ópticas',85,8536);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853690,'Outros aparelhos para interrupção, seccionamento, proteção, ligação de circuitos elétricos, para tensão <= 1 Kv','Electrical apparatus for switching electrical circuits, or for making connections to or in electrical circuits, for a voltage <= 1.000 V (excl. fuses, automatic circuit breakers and other apparatus for protecting electrical circuits, relays and other swit','Aparatos eléctricos para corte, seccionamiento, protección, derivación, empalme o conexión de circuitos eléctricos, para una tensión <= 1.000 V (exc. fusibles y cortacircuitos de fusible; disyuntores y demás aparatos para protección de circuitos eléctrico',85,8536);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853710,'Quadros, painéis, consoles e outros suportes com dois ou mais aparelhos das posições 85.35 ou 85.36, para comando ou distribuição de energia elétrica, para tensão <= 1 kV','Boards, cabinets and similar combinations of apparatus for electric control or the distribution of electricity, for a voltage <= 1.000 V','Cuadros y armarios de interruptores y combinaciones simil. de aparatos, para control o distribución de electricidad, para una tensión <= 1.000 V',85,8537);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853720,'Quadros, painéis, consoles com dois ou mais aparelhos das posições 85.35 ou 85.36, para comando ou distribuição de energia elétrica, para tensão > 1 kV','Boards, cabinets and similar combinations of apparatus for electric control or the distribution of electricity, for a voltage > 1.000 V','Cuadros y armarios de interruptores y combinaciones simil. de aparatos, para control o distribución de electricidad, para una tensión > 1.000 V',85,8537);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853810,'Partes para quadros, painéis e outros artefatos da posição 8537','Boards, panels, consoles, desks, cabinets and other bases for the goods of heading 8537, not equipped with their apparatus','Cuadros, paneles, consolas, armarios y demás soportes de la partida 8537, sin los aparatos',85,8538);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853890,'Outras partes destinadas aos aparelhos das posições 85.35, 85.36 e 85.37','Parts suitable for use solely or principally with the apparatus of heading 8535, 8536 or 8537, n.e.s. (excl. boards, panels, consoles, desks, cabinets and other bases for the goods of heading 8537, not equipped with their apparatus)','Partes identificables como destinadas, exclusiva o principalmente, a los aparatos de las partidas 8535, 8536 u 8537, n.c.o.p. (exc. cuadros, paneles, consolas, armarios y demás soportes de la partida 8537, sin los aparatos)',85,8538);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853910,'Faróis e projetores, em unidades seladas','Sealed beam lamp units','Faros o unidades "sellados"',85,8539);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853921,'Lâmpadas e tubos de incandescência, halogêneos, de tungstênio','Tungsten halogen filament lamps (excl. sealed beam lamp units)','Lámparas y tubos de incandescencia, halógenos, de volframio "tungsteno" (exc. faros o unidades "sellados")',85,8539);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853922,'Outras lâmpadas e tubos de incandescência, de potência <= 200 W e tensão > 100 V','Filament lamps of a power <= 200 W and for a voltage > 100 V (excl. tungsten halogen filament lamps and ultraviolet or infra-red lamps)','Lámparas y tubos de incandescencia, de potencia <= 200 W, para una tensión > 100 V (exc. lámparas y tubos halógenos de volframio "tungsteno" y de rayos ultravioletass o infrarrojos)',85,8539);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853929,'Outras lâmpadas e tubos de incandescência','Filament lamps, electric (excl. tungsten halogen lamps, lamps of a power <= 200 W and for a voltage > 100 V and ultraiolet or infra-red lamps)','Lámparas y tubos eléctricos de incandescencia (exc. lámparas y tubos halógenos de volframio "tungsteno", lámparas y tubos de potencia <= 200 W para una tensión > 100 V y lámparas y tubos de rayos ultravioletass o infrarrojos)',85,8539);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853931,'Lâmpadas e tubos de descarga, fluorescentes, de cátodo quente','Discharge lamps, fluorescent, hot cathode','Lámparas y tubos fluorescentes, de cátodo caliente',85,8539);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853932,'Lâmpadas de vapor de mercúrio ou de sódio; lâmpadas de halogeneto metálico','Mercury or sodium vapour lamps; metal halide lamps','Lámparas de vapor de mercurio o sodio; lámparas de halogenuro metálico',85,8539);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853939,'Outras lâmpadas e tubos de descarga','Discharge lamps (excl. flourescent, hot cathode lamps, mercury or sodium vapour lamps, metal halide lamps and ultraviolet lamps)','Lámparas y tubos de descarga (exc. lámparas y tubos fluorescentes de cátodo caliente, así como lámparas de rayos ultravioletass, de vapor de mercurio o sodio y de halogenuro metálico)',85,8539);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853941,'Lâmpadas de arco','Arc lamps','Lámparas de arco',85,8539);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853949,'Lâmpadas e tubos de raios ultravioleta ou infravermelhos','Ultraviolet or infra-red lamps','Lámparas y tubos de rayos ultravioletass o infrarrojos',85,8539);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (853990,'Partes para lâmpadas e tubos elétricos de incandescência ou de descarga, de raios ultravioletas e semelhantes','Parts of electric filament or discharge lamps, sealed beam lamp units, ultraviolet or infra-red lamps and arc lamps, n.e.s.','Partes de lámparas y de tubos eléctricos de incandescencia o de descarga, incl. los faros o unidades "sellados" y las lámparas y tubos de rayos ultravioletass o infrarrojos, así como las lámparas de arco, n.c.o.p.',85,8539);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854011,'Tubos catódicos para receptores de televisão e monitores de vídeo, a cores','Cathode ray television picture tubes, incl. video monitor cathode ray tubes, colour','Tubos catódicos para aparatos receptores de televisión, incl. para monitores, en colores',85,8540);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854012,'Tubos catódicos para receptores de televisão, incluídos os tubos para monitores de vídeo, em preto e branco ou outros monocromos','Cathode ray television picture tubes, incl. video monitor cathode ray tubes, black and white or other monochrome, with a screen width-to-height ratio of < 1,5 and a diagonal measurement of the screen > 72 cm','Tubos catódicos para aparatos receptores de televisión, incl. para videomonitores, en blanco y negro o demás monocromos',85,8540);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854020,'Tubos para câmeras de televisão; tubos conversores ou intensificadores de imagens; outros tubos de fotocátodo','Television camera tubes; image converters and intensifiers; other photo cathode tubes (excl. cathode ray television picture tubes incl. video monitor cathode ray tubes)','Tubos para cámaras de televisión; tubos convertidores o intensificadores de imagen; los demás tubos de fotocátodo (exc. tubos catódicos para aparatos receptores de televisión, incl. para monitores)',85,8540);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854040,'Tubos de visualização de dados gráficos, a cores, com uma tela (écran) fosfórica de espaçamento entre os pontos inferior a 0,4 mm','Data-graphic display tubes, colour, with a phosphor dot screen pitch of < 0,4 mm (excl. photo cathode tubes and cathode ray tubes)','Tubos para visualizar datos gráficos, en colores, con pantalla fosfórica de separación de puntos < 0,4 mm (exc. tubos catódicos y tubos de fotocátodo)',85,8540);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854050,'Tubos de visualização de dados gráficos, em preto e branco ou em outros monocromos','Data-graphic display tubes, black and white or other monochrome (excl. photo cathode tubes and cathode ray tubes)','Tubos para visualizar datos gráficos, en blanco y negro o demás monocromos (exc. tubos catódicos y tubos de fotocátodo)',85,8540);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854060,'Outros tubos catódicos','Cathoderay tubes (excl. television and video-monitor cathoderay tubes, television camera tubes, image converters or intensifiers, other photo-cathode tubes, black and white or other monochrome data-graphic display tubes and colour data-graphic display tub','Tubos catódicos (exc. tubos catódicos para aparatos receptores de televisión y videomonitores, tubos para cámaras de televisión, tubos convertidores o intensificadores de imagen y demás tubos de fotocátodo, así como tubos para visualizar datos gráficos, e',85,8540);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854071,'Tubos para microondas, magnétrons','Magnetrons','Magnetrones',85,8540);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854072,'Tubos para microondas, clístrons','Klystrons','Klistrones',85,8540);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854079,'Outros tubos para microondas (por exemplo: guias de ondas progressivas, carcinotrons e outros)','Microwave tubes, e.g. travelling wave tubes and carcinotrons (excl. magnetrons, klystrons and grid-controlled tubes)','Tubos de ondas progresivas, carcinotrones y demás tubos para hiperfrecuencias (exc. magnetrones, klistrones y tubos controlados por rejillas)',85,8540);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854081,'Tubos de recepção ou de amplificação','Receiver or amplifier valves and tubes (excl. microwave tubes, photo-cathode tubes and cathode ray tubes)','Tubos receptores o amplificadores (exc. tubos para hiperfrecuencias, tubos de fotocátodos y demás tubos catódicos)',85,8540);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854089,'Outras válvulas e tubos eletrônicos','Electronic valves and tubes (excl. receiver or amplifier valves and tubes, microwave tubes, photo-cathode tubes, cathode ray tubes, black and white or other monochrome data-graphic display tubes and colour data-graphic display tubes with a phosphor dot sc','Lámparas, tubos y válvulas electrónicos (exc. tubos receptores o amplificadores, tubos para hiperfrecuencias, tubos catódicos, tubos de fotocátodos, tubos para visualizar datos gráficos, en blanco y negro o demás monocromos o en color con pantalla fosfóri',85,8540);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854091,'Partes para tubos catódicos','Parts of cathode ray tubes, n.e.s.','Partes de tubos catódicos, n.c.o.p.',85,8540);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854099,'Partes para lâmpadas, tubos e válvulas, eletrônicos','Parts of thermionic, cold cathode or photo cathode valves and tubes, n.e.s. (excl. parts of cathode ray tubes)','Partes de lámparas, de tubos y de válvulas electrónicos de cátodo caliente, cátodo frío o fotocátodo, n.c.o.p. (exc. de tubos catódicos)',85,8540);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854110,'Diodos, exceto fotodiodos e diodos emissores de luz','Diodes (excl. photosensitive or light emitting diodes)','Diodos (distintos de los fotodiodos y de los diodos emisores de luz)',85,8541);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854121,'Transistores com capacidade de dissipação < 1 W, exceto fototransistores','Transistors with a dissipation rate < 1 W (excl. photosensitive transistors)','Transistores con una capacidad de disipación < 1 W (distintos de los fototransistores)',85,8541);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854129,'Outros transistores, exceto fototransistores','Transistors with a dissipation rate >= 1 W (excl. photosensitive transistors)','Transistores con una capacidad de disipación >= 1 W (distintos de los fototransistores)',85,8541);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854130,'Tiristores, diacs e triacs, exceto os dispositivos fotossensíveis','Thyristors, diacs and triacs (excl. photosensitive semiconductor devices)','Tiristores, diacs y triacs (exc. dispositivos de material semiconductor fotosensibles)',85,8541);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854140,'Dispositivos fotossensíveis semicondutores, incluídas as células fotovoltaicas, mesmo montadas em módulos ou em painéis; diodos emissores de luz','Photosensitive semiconductor devices, incl. photovoltaic cells whether or not assembled in modules or made up into panels; light emitting diodes (excl. photovoltaic generators)','Dispositivos material semiconductor fotosensibles, incl. las células fotovoltaicas aunque estén ensambladas en módulos o paneles (exc. generadores fotovoltaicos); diodos emisores de luz',85,8541);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854150,'Outros dispositivos semicondutores','Semiconductor devices, n.e.s.','Dispositivos de material semiconductor, n.c.o.p.',85,8541);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854160,'Cristais piezo elétricos montados','Mounted piezoelectric crystals','Cristales piezoeléctricos montados',85,8541);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854190,'Partes de diodos, transistores, semicondutores e semelhantes','Parts of diodes, transistors and similar semiconductor devices; photosensitive semiconductor devices, light emitting diodes and mounted piezoelectric crystals, n.e.s.','Partes de diodos, de transistores y de dispositivos de material semiconductor simil., partes de dispositivos de material semiconductor fotosensibles, partes de diodos emisores de luz, partes de cristales piezoeléctricos montados, n.c.o.p.',85,8541);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854210,'Cartões munidos de um circuito integrado eletrônico','Cards incorporating an electronic integrated circuit','tarjetas provistas de un circuito integrado electrónico',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854212,'Cartões incorporando 1 circuito integrado eletrônico','Cards incorporating 1 electronic integrated circuit','tarjetas provistas de un circuito integrado electrónico',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854213,'Memórias, semicondutores, microprocessadores, microcontroladores','Memory, semiconductors, microprocessors, microcontrollers','Memoria, semiconductores, microprocesadores, microcontroladores',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854214,'Circuitos obtidos por tecnologia bipolar','Circuits obtained by bipolar technology','Circuitos obtenidos por tecnología bipolar',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854219,'Outros circuitos integrados e memórias','Other integrated circuits and memories','Demás circuitos integrados y memorias',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854221,'Microprocessadores, microcontroladores, outras memórias, outros circuitos integrados','Microprocessors, microcontrollers, other memories, other integrated circuits','Microprocesadores, microcontroladores, otras memorias, otros circuitos integrados',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854229,'Outros circuitos integrados','Other integrated circuits','Otros circuitos integrados',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854230,'Outros circuitos integrados monolíticos','Other monolithic integrated circuits','Otros circuitos integrados monolíticos',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854231,'Processadores e controladores, mesmo combinados com memórias, conversores, circuitos lógicos, amplificadores, circuitos temporizadores e de sincronização, ou outros circuitos','Electronic integrated circuits as processors and controllers, whether or not combined with memories, converters, logic circuits, amplifiers, clock and timing circuits, or other circuits','Procesadores y controladores, incluso combinados con memorias, convertidores, circuitos lógicos, amplificadores, relojes y circuitos de sincronización, u otros circuitos',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854232,'Memórias','Electronic integrated circuits as memories','Memorias',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854233,'Amplificadores','Electronic integrated circuits as amplifiers','Amplificadores',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854239,'Outros circuitos integrados eletrônicos','Electronic integrated circuits (excl. such as processors, controllers, memories and amplifiers)','Circuitos integrados electrónicos (exc los utilizados como procesadores, controladores, memorias y amplificadores)',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854240,'Circuitos integrados híbridos, espessura de camada <=1 micron','Hybrid integrated circuits, layer thickness <= 1 micron','Circuitos integrados híbridos, espesor de la capa <= 1 micra',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854250,'Microconjuntos eletrônicos','Electronic microassemblies','Microestructuras electrónicas',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854260,'Circuitos integrados híbridos','Hybrid integrated circuits','Circuitos integrados híbridos',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854270,'Microconjuntos eletrônicos','Electronic microassemblies','Microestructuras electrónicas',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854290,'Partes para circuitos integrados eletrônicos','Parts of electronic integrated circuits, n.e.s.','Partes de circuitos integrados y de microestructuras electrónicas, n.c.o.p.',85,8542);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854310,'Aceleradores de partículas','Electrical particle accelerators for electrons, protons, etc. (excl. ion implanters for doping semiconductor materials)','Aceleradores de partículas',85,8543);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854311,'apars.de implantação iônica, p/impurif.mater.semicondut.','ion implanters for doping semiconductor materials','apars.de implantación iónica, p/dopar mater.semiconduct.',85,8543);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854319,'Outros aceleradores de partículas, elétricos','Other electric particle accelerators','Los demás aceleradores de partículas, eléctricos',85,8543);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854320,'Geradores de sinais, elétricos','Signal generators, electrical','Generadores de señales, eléctricos',85,8543);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854330,'Máquinas e aparelhos de galvanoplastia, eletrólise ou eletroforese','Machines and apparatus for electroplating, electrolysis or electrophoresis','Máquinas y aparatos de galvanotecnia, electrólisis o electroforesis',85,8543);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854340,'Eletrificadores de cercas','Electric fence energisers','Electrificadores de cercas',85,8543);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854370,'Outras máquinas e aparelhos com função própria','Electrical machines and apparatus, having individual functions, n.e.s. in chapter 85',' Máquinas y aparatos eléctricos que tienen una función propia, n.c.o.p. en el capítulo 85',85,8543);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854381,'Cartões e etiquetas de acionam.por aproxim.','Proximity cards and tags','Tarjetas y etiquetas de activación por proxim.',85,8543);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854389,'Amplificadores de radiofrequencia','Radiofrequency amplifiers','Amplificadores de radiofrecuencia',85,8543);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854390,'Partes de máquinas e aparelhos elétricos com função própria','Parts of electrical machines and apparatus, having individual functions, n.e.s. in chapter 85','Partes de máquinas y de aparatos eléctricos, con función propia, no expresados ni comprendidos en otra parte del capítulo 85',85,8543);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854411,'Fios de cobre para bobinar, isolados para usos elétricos','Winding wire for electrical purposes, of copper, insulated','Alambre para bobinar, para electricidad, de cobre, aislado',85,8544);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854419,'Outros fios para bobinar, isolados para usos elétricos','Winding wire for electrical purposes, of material other than copper, insulated','Alambre para bobinar, para electricidad, de materias distintas del cobre, aislado',85,8544);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854420,'Cabos coaxiais e outros condutores elétricos coaxiais','Coaxial cable and other coaxial electric conductors, insulated','Cables y demás conductores eléctricos coaxiales, aislados',85,8544);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854430,'Jogos de fios para velas de ignição e outros utilizados em quaisquer veículos','Ignition wiring sets and other wiring sets for vehicles, aircraft or ships','Juegos de cables para bujías de encendido y demás juegos de cables de los tipos utilizados en los medios de transporte',85,8544);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854441,'Outs.condutores eletr.munidos pecas conexão, tensao<=80v','oth.electr.conductors with connection fitting,tens<=80v','los dem.conduct.eléctr.prov.piezas conexión, tens<=80v',85,8544);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854442,'Outros condutores elétricos para tensão não superior a 1000 V, munidos de peças de conexão','Electric conductors for a voltage <= 1.000 V, insulated, fitted with connectors, n.e.s.','Conductores eléctricos, para tensión  <= 1.000 V, aislados, con piezas de conexión, n.c.o.p.',85,8544);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854449,'Outros condutores elétricos, para tensão não superior a 1000 V','Electric conductors, for a voltage <= 1.000 V, insulated, not fitted with connectors, n.e.s.','Conductores eléctricos, para una tensión <= 1000 V, aislados, sin piezas de conexión, n.c.o.p.',85,8544);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854451,'outs.condutores eletr.munidos pecas conexão, 80<t<=1000v','oth.elect.conductors with connect.fittngs,80<t<=1000v','los dem.conductores eléct.prov.piezas conex.80<t<=1000v',85,8544);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854459,'outros condutores eletr.80v<tensao<=1.000v','other electric conductors 80v<tension<=1.000v','los demás conductores eléctr.80v<tensión<=1.000v',85,8544);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854460,'Outros condutores elétricos, para tensão > 1.000 V','Electric conductors, for a voltage > 1.000 V, insulated, n.e.s.','Conductores eléctricos, para una tensión > 1.000 V, n.c.o.p.',85,8544);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854470,'Cabos de fibras ópticas','Optical fibre cables made up of individually sheathed fibres, whether or not containing electric conductors or fitted with connectors','Cables de fibras ópticas constituidos por fibras enfundadas individualmente, incl. con conductores eléctricos o piezas de conexión',85,8544);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854511,'Eletrodos de carvão, dos tipos utilizados em fornos, para usos elétricos','Electrodes of graphite or other carbon, for electric furnaces','Electrodos de grafito u otros carbonos, de los tipos utilizados en hornos eléctricos',85,8545);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854519,'Outros eletrodos de carvão, para usos elétricos','Electrodes of graphite or other carbon, for electrical purposes (excl. those used for furnaces)','Electrodos de grafito u otros carbonos, para usos eléctricos (exc. de los tipos utilizados en hornos eléctricos)',85,8545);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854520,'Escovas de carvão, para usos elétricos','Carbon brushes for electrical purposes','Escobillas de carbón, para usos eléctricos',85,8545);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854590,'Carvões para lâmpadas, pilhas e artigos de grafita ou carvão, com ou sem metal, para usos elétricos','Articles of graphite or other carbon, for electrical purposes (excl. electrodes and carbon brushes)','Artículos de grafito u otros carbonos, para usos eléctricos (exc. electrodos y escobillas)',85,8545);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854610,'Isoladores de vidro, para usos elétricos','Electrical insulators of glass (excl. insulating fittings)','Aisladores eléctricos de vidrio (exc. piezas aislantes)',85,8546);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854620,'Isoladores de cerâmica, para usos elétricos','Electrical insulators of ceramics (excl. insulating fittings)','Aisladores eléctricos de cerámica (exc. piezas aislantes)',85,8546);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854690,'Outros isoladores de qualquer matéria, para usos elétricos','Electrical insulators (excl. those of glass or ceramics and insulating fittings)','Aisladores eléctricos (exc. de vidrio y de cerámica, así como las piezas aislantes)',85,8546);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854710,'Peças isolantes de cerâmica, para máquinas, aparelhos e instalações elétricas','Insulating fittings for electrical purposes, of ceramics','Piezas aislantes para electricidad, de cerámica',85,8547);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854720,'Peças isolantes de plásticos, para máquinas, aparelhos e instalações elétricas','Insulating fittings for electrical purposes, of plastics','Piezas aislantes para electricidad, de plástico',85,8547);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854790,'Outras peças isolantes, para usos elétricos; tubos isoladores e suas peças de ligação','Insulating fittings for electrical purposes, of materials other than ceramics or plastics; electrical conduit tubing and joints therefor, of base metal lined with insulating material','Piezas aislantes para electricidad, de materias distintas de la cerámica y del plástico, así como tubos y sus piezas de unión, de metal común, aislados interiormente',85,8547);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854810,'Desperdícios e resíduos de pilhas, de baterias de pilhas e de acumuladores elétricos','Waste and scrap of primary cells, primary batteries and electric accumulators; spent primary cells, spent primary batteries and spent electric accumulators','Desperdicios y desechos de pilas, baterías de pilas o acumuladores, eléctricos; pilas, baterías de pilas y acumuladores eléctricos, inservibles',85,8548);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (854890,'Partes elétricas de máquinas e aparelhos não especificadas nem compreendidas em outras posições do Capítulo 85','Electrical parts of machinery or apparatus, not specified or included elsewhere in chapter 85','Partes eléctricas de máquinas o de aparatos, no expresadas ni comprendidas en otra parte del capítulo 85',85,8548);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860110,'Locomotivas e locotratores, de fonte externa de eletricidade','Rail locomotives powered from an external source of electricity','Locomotoras y locotractores, de fuente externa de eléctricidad',86,8601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860120,'Locomotivas e locotratores, de acumuladores elétricos','Rail locomotives powered by electric accumulators','Locomotoras y locotractores, de acumuladores eléctricos',86,8601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860210,'Locomotivas diesel-elétricas','Diesel-electric locomotives','Locomotoras diesel-eléctricas',86,8602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860290,'Outras locomotivas e locotratores; tênderes','Rail locomotives (excl. those powered from an external source of electricity or by accumulators and diesel-electric locomotives)','Locomotoras y locotractores (exc. los de fuente externa de eléctricidad o de acumuladores eléctricos, así como las locomotoras diesel-eléctricas)',86,8602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860310,'Litorinas (automotoras), de fonte externa de eletricidade','Self-propelled railway or tramway coaches, vans and trucks, powered from an external source of electricity (excl. those of heading 8604)','Automotores para vías férreas y tranvías autopropulsados, de fuente externa de electricidad (exc. vehículos para mantenimiento o servicio de vías férreas o simil. de la partida 8604)',86,8603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860390,'Outras litorinas (automotoras)','Self-propelled railway or tramway coaches, vans and trucks (excl. those powered from an external source of electricity and those of heading 8604)','Automotores para vías férreas y tranvías autopropulsados (exc. los de fuente externa de electricidad, así como vehículos para mantenimiento o servicio de vías férreas o simil. de la partida 8604)',86,8603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860400,'Veículos para inspeção e manutenção de vias férreas ou semelhantes, mesmo autopropulsores','Railway or tramway maintenance or service vehicles, whether or not self-propelled, e.g., workshops, cranes, ballast tampers, trackliners, testing coaches and track inspection vehicles','Vagones taller, vagones grúa, vagones equipados para apisonar balasto, alinear vías, coches para ensayos y vagonetas de inspección de vías y demás vehículos para mantenimiento o servicio de vías férreas o simil., incl. autopropulsados',86,8604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860500,'Vagões de passageiros, furgões para bagagem, vagões-postais, e outros vagões especiais, para vias férreas ou semelhantes','Railway or tramway passenger coaches, luggage vans, post office coaches and other special purpose railway or tramway coaches (excl. self-propelled railway or tramway coaches, vans and trucks, railway or tramway maintenance or service vehicles and goods va','Coches de viajeros, furgones de equipajes, coches correo y demás coches especiales, para vías férreas o simil. (exc. automotores  para vías férreas y tranvías autopropulsados, vehículos para mantenimiento o servicio de vías férreas o simil., así como vago',86,8605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860610,'Vagões-tanques e semelhantes, para transporte de mercadorias em vias férreas','Railway or tramway tank wagons and the like (excl. self-propelled)','Vagones cisterna y simil., sobre carriles "rieles"',86,8606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860620,'Vagões isotermicos, refrigeradores, etc.p/vias férreas','Insulated or refrigerated vans and wagons,etc.f/railway','Vagones isotérmicos, refrigerantes, etc.sobre carriles',86,8606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860630,'Vagões de descarga automática, para transporte de mercadorias em vias férreas','Railway or tramway self-discharging goods vans and wagons (excl. tank wagons and the like and insulated or refrigerated goods vans and wagons)','Vagones de descarga automática, sobre carriles "rieles" (exc. vagones cisterna y simil., vagones isotérmicos, refrigerantes o frigoríficos)',86,8606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860691,'Vagões cobertos e fechados, para transporte de mercadorias em vias férreas','Railway or tramway goods vans and wagons, covered and closed (excl. self-discharging goods vans and wagons and tank wagons and the like)','Vagones para transporte de mercancías, sobre carriles "rieles", cubiertos y cerrados (exc. vagones de descarga automática, vagones cisterna y simil., vagones isotérmicos, refrigerantes o frigoríficos)',86,8606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860692,'Vagões abertos com paredes fixas de altura > 60 cm, para vias férreas','Railway or tramway goods vans and wagons, open, with non-removable sides of a height > 60 cm (excl. self-discharging wagons)','Vagones para transporte de mercancías, sobre carriles "rieles", abiertos, con pared fija de altura > 60 cm (exc. vagones de descarga automática)',86,8606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860699,'Outros vagões para transporte de mercadorias em vias férreas','Railway or tramway goods vans and wagons (excl. those specially designed for the transport of highly radioactive materials, tank wagons and the like, insulated, refrigerated or self-discharging goods vans and wagons and open goods vans and wagons with non','Vagones para transporte de mercancías, sobre carriles "rieles" (exc. los especialmente concebidos para transporte de productos muy radiactivos [Euratom], vagones cisterna y simil., vagones isotérmicos, refrigerantes o frigoríficos, vagones de descarga aut',86,8606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860711,'Bogiese bísseis, de tração, de veículos para vias férreas ou semelhantes','Driving bogies and bissel-bogies for railway or tramway locomotives or rolling stock','Bojes y "bissels", de tracción propios de vehículos para vías férreas o simil.',86,8607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860712,'Outros bogies e bísseis de veículos para vias férreas','Bogies and driving bissel-bogies for railway or tramway locomotives or rolling stock (excl. driving bogies)','Bojes y "bissels", propios de vehículos para vías férreas o simil. (exc. bojes y "bissels" de tracción)',86,8607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860719,'Eixos e rodas e suas partes, de veículos para vias férreas','Axles, for electrical purposes, and wheels and parts thereof for railway or tramway locomotives or rolling stock; parts of bogies and bissel-bogies, n.e.s.','Ejes montados y sin montar, ruedas y sus partes, así como partes de bojes y "bissels" propios de vehículos para vías férreas, n.c.o.p.',86,8607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860721,'Freios (travões) à ar comprimido e suas partes, de veículos para vias férreas','Air brakes and parts thereof for railway or tramway locomotives or rolling stock, n.e.s.','Frenos de aire comprimido y sus partes, propios de vehículos para vías férreas, n.c.o.p.',86,8607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860729,'Outros freios e suas partes, de veículos para vias férreas','Brakes (other than air brakes), and parts thereof, for railway or tramway locomotives or rolling stock, n.e.s.','Frenos (distintos de los de aire comprimido), y sus partes, propios de vehículos para vías férreas, n.c.o.p.',86,8607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860730,'Ganchos, e outros sistemas de engate, pára-choques e suas partes, de veículos para vias férreas','Hooks and other coupling devices, buffers, and parts thereof, for railway or tramway locomotives or rolling stock, n.e.s.','Ganchos y demás sistemas de enganche, topes, y sus partes, propios de vehículos para vías férreas, n.c.o.p.',86,8607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860791,'Outras partes de locomotivas ou de locotratores','Parts of railway or tramway locomotives, n.e.s.','Partes de locomotoras o de locotractores, n.c.o.p.',86,8607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860799,'Outras partes de veículos para vias férreas','Parts of rolling stock of heading 8603, 8604, 8605 or 8606, n.e.s.','Partes de los vehículos para vías férreas de las partidas 8603, 8604, 8605 u 8606, n.c.o.p.',86,8607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860800,'Material fixo de vias férreas ou semelhantes; aparelhos de sinalização, segurança, controle ou comando para vias férreas, rodoviárias ou fluviais','Railway or tramway track fixtures and fittings (excl. sleepers of wood, concrete or steel, sections of track and other track fixtures not yet assembled and railway or tramway track construction material); mechanical, incl. electromechanical, signalling, s','Material fijo de vías férreas o simil.; aparatos mecánicos, incl. electromecánicos, de señalización, seguridad, control o mando para vías férreas o simil., carreteras o vías fluviales, áreas o parques de estacionamiento, instalaciones portuarias o aeropue',86,8608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (860900,'Contêineres (contentores), incluídos os de transporte de fluidos','Containers, incl. containers for the transport of fluids, specially designed and equipped for carriage by one or more modes of transport','Contenedores, incl. los contenedores cisterna y contenedores depósito, especialmente concebidos y equipados para uno o varios medios de transporte',86,8609);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870110,'Tratores motocultores','Pedestrian-controlled agricultural tractors and similar tractors for industry (excl. tractor units for articulated lorries)','Motocultores y tractores de características simil. para la industria (exc. cabezas tractoras para vehículos articulados)',87,8701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870120,'Tratores rodoviários para semi-reboques','Road tractors for semi-trailers','Tractores de carretera para semirremolques',87,8701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870130,'Tratores de lagartas','Track-laying tractors (excl. pedestrian-controlled)','Tractores de orugas (exc. motocultores de orugas)',87,8701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870190,'Outros tratores','Tractors (excl. those of heading 8709, pedestrian-controlled tractors, road tractors for semi-trailers and track-laying tractors)','Tractores o "automotores" (exc. carretillas tractor de la partida 8709, así como motocultores, tractores de carretera para semirremolques y tractores de orugas)',87,8701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870210,'Veículos automóveis para transporte => 10 pessoas, com motor de pistão, de ignição por compressão - ônibus microônibus','Motor vehicles for the transport of >= 10 persons, incl. driver, with compression-ignition internal combustion piston engine diesel or semi-diesel engine','Vehículos automóviles para transporte de >= 10 personas, incl. el conductor, con motor de émbolo "pistón", de encendido por compresión "diesel o semi-diesel"',87,8702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870290,'Outros veículos automóveis para transporte => 10 pessoas - ônibus microônibus','Motor vehicles for the transport of >= 10 persons, incl. driver, not with compression-ignition internal combustion piston engine diesel or semi-diesel engine, of a cylinder capacity of > 2.500 cm³, new','Vehículos automóviles para transporte de >= 10 personas, incl. el conductor, con motor que no sea de émbolo y de encendido por compresión "diesel o semi-diesel"',87,8702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870310,'Veículos automóveis para deslocamento sobre a neve; veículos para transportar pessoas nos campos de golfe e veículos semelhantes','Vehicles for the transport of persons on snow; golf cars and similar vehicles','Vehículos especialmente concebidos para desplazarse sobre nieve, incl. los trineos con motor, para transporte de personas en campos de golf y vehículos simil.',87,8703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870321,'Automóveis de passageiros, incluídos os veículos de uso misto (station wagons) e os automóveis de corrida, com motor de pistão alternativo, de ignição por centelha, de cilindrada <= 1.000 cm3 - automóvel carros','Motor cars and other motor vehicles principally designed for the transport of persons, incl. station wagons and racing cars, with spark-ignition internal combustion reciprocating piston engine of a cylinder capacity <= 1.000 cm³ (excl. vehicles for the tr','Automóviles de turismo, incl. los del tipo familiar "break" o "station wagon" y los de carreras, con motor de émbolo "pistón" alternativo de encendido por chispa, de cilindrada <= 1.000 cm³ (exc. vehículos de nieve y demás vehículos especiales de la subpa',87,8703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870322,'Automóveis de passageiros, incluídos os veículos de uso misto (station wagons) e os automóveis de corrida, com motor de pistão alternativo, de ignição por centelha, de cilindrada > 1.000 cm3 e <= 1.500 cm3 - automóvel carros','Motor cars and other motor vehicles principally designed for the transport of persons, incl. station wagons and racing cars, with spark-ignition internal combustion reciprocating piston engine of a cylinder capacity > 1.000 cm³ but <= 1.500 cm³ (excl. veh','Automóviles de turismo, incl. los del tipo familiar "break" o "station wagon" y los de carreras, con motor de émbolo "pistón" alternativo de encendido por chispa, de cilindrada > 1.000 cm³ e <= 1.500 cm³ (exc. vehículos de nieve y demás vehículos especial',87,8703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870323,'Automóveis de passageiros, incluídos os veículos de uso misto (station wagons) e os automóveis de corrida, com motor de pistão alternativo, de ignição por centelha, de cilindrada > 1.500 cm3 e <= 3.000 cm3 - automóvel carros','Motor cars and other motor vehicles principally designed for the transport of persons, incl. station wagons and racing cars, with spark-ignition internal combustion reciprocating piston engine of a cylinder capacity > 1.500 cm³ but <= 3.000 cm³ (excl. veh','Automóviles de turismo, incl. los del tipo familiar "break" o "station wagon" y los de carreras, con motor de émbolo "pistón" alternativo de encendido por chispa, de cilindrada > 1.500 cm³ e <= 3.000 cm³ (exc. vehículos de nieve y demás vehículos especial',87,8703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870324,'Automóveis de passageiros, incluídos os veículos de uso misto (station wagons) e os automóveis de corrida, com motor de pistão alternativo, de ignição por centelha, de cilindrada > 3.000 cm3 - automóvel carros','Motor cars and other motor vehicles principally designed for the transport of persons, incl. station wagons and racing cars, with spark-ignition internal combustion reciprocating piston engine of a cylinder capacity > 3.000 cm³ (excl. vehicles for the tra','Automóviles de turismo, incl. los del tipo familiar "break" o "station wagon" y los de carreras, con motor de émbolo "pistón" alternativo de encendido por chispa, de cilindrada > 3.000 cm³ (exc. vehículos de nieve y demás vehículos especiales de la subpar',87,8703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870331,'Automóveis de passageiros, incluídos os veículos de uso misto (station wagons) e os automóveis de corrida, com motor de pistão, de ignição por compressão (diesel ou semidiesel), de cilindrada <= 1.500 cm3 - automóvel carros','Motor cars and other motor vehicles principally designed for the transport of persons, incl. station wagons and racing cars, with compression-ignition internal combustion piston engine diesel or semi-diesel engine of a cylinder capacity <= 1.500 cm³ (excl','Automóviles de turismo, incl. los del tipo familiar "break" o "station wagon" y los de carreras, con motor de émbolo "pistón", de encendido por compresión y de cilindrada <= 1.500 cm³ (exc. vehículos de nieve y demás vehículos especiales de la subpartida ',87,8703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870332,'Automóveis de passageiros, incluídos os veículos de uso misto (station wagons) e os automóveis de corrida, com motor de pistão, de ignição por compressão, de cilindrada > 1.500 cm3 e <= 2.500 cm3 - automóvel carros','Motor cars and other motor vehicles principally designed for the transport of persons, incl. station wagons and racing cars, with compression-ignition internal combustion piston engine diesel or semi-diesel engine of a cylinder capacity > 1.500 cm³ but <=','Automóviles de turismo, incl. los del tipo familiar "break" o "station wagon" y los de carreras, con motor de émbolo "pistón", de encendido por compresión y de cilindrada > 1.500 cm³ e <= 2.500 cm³ (exc. vehículos de nieve y demás vehículos especiales de ',87,8703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870333,'Automóveis de passageiros, incluídos os veículos de uso misto (station wagons) e os automóveis de corrida, com motor de pistão, de ignição por compressão, de cilindrada > 2.500 cm3 - automóvel carros','Motor cars and other motor vehicles principally designed for the transport of persons, incl. station wagons and racing cars, with compression-ignition internal combustion piston engine diesel or semi-diesel engine of a cylinder capacity > 2.500 cm³ (excl.','Automóviles de turismo, incl. los del tipo familiar "break" o "station wagon" y los de carreras, con motor de émbolo "pistón", de encendido por compresión y de cilindrada > 2.500 cm³ (exc. vehículos de nieve y demás vehículos especiales de la subpartida 8',87,8703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870390,'Outros automóveis de passageiros, incluídos os veículos de uso misto e os automóveis de corrida - automóvel carros','Motor cars and other vehicles principally designed for the transport of persons, incl. station wagons and racing cars, with engines other than spark-ignition internal combustion reciprocating piston engine diesel or semi-diesel engine (excl. vehicles for ','Automóviles de turismo, incl. los del tipo familiar "break" o "station wagon" y los de carreras, con motor que no sea de émbolo alternativo (exc. vehículos de nieve y demás vehículos especiales de la subpartida 8703.10)',87,8703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870410,'Dumpers concebidos para serem utilizados fora de rodovias - caminhão caminhões','Dumpers for off-highway use','Volquetes automotores concebidos para utilizarlos fuera de la red de carreteras',87,8704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870421,'Veículos automóveis para transporte de mercadorias, com motor de pistão, de ignição por compressão, de peso em carga máxima <= 5 t - caminhão caminhões carros','Motor vehicles for the transport of goods, with compression-ignition internal combustion piston engine diesel or semi-diesel engine of a gross vehicle weight <= 5 t (excl. dumpers for off-highway use of subheading 8704.10 and special purpose motor vehicle','Vehículos automóviles para transporte de mercancías, con motor de émbolo "pistón" de encendido por compresión "diesel o semi-diesel", de peso total con carga máxima <= 5 t (exc. volquetes automotores de la subpartida 8704.10 y vehículos automóviles para u',87,8704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870422,'Veículos automóveis para transporte de mercadorias, com motor de pistão, de ignição por compressão, de peso em carga máxima > 5 t e <= 20 t - caminhão caminhões','Motor vehicles for the transport of goods, with compression-ignition internal combustion piston engine diesel or semi-diesel engine of a gross vehicle weight > 5 t but <= 20 t (excl. dumpers for off-highway use of subheading 8704.10 and special purpose mo','Vehículos automóviles para transporte de mercancías, con motor de émbolo "pistón" de encendido por compresión "diesel o semi-diesel", de peso total con carga máxima > 5 t e <= 20 t (exc. volquetes automotores de la subpartida 8704.10 y vehículos automóvil',87,8704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870423,'Veículos automóveis para transporte de mercadorias, com motor de pistão, de ignição por compressão, de peso em carga máxima > 20 t - caminhão caminhões','Motor vehicles for the transport of goods, with compression-ignition internal combustion piston engine diesel or semi-diesel engine of a gross vehicle weight > 20 t (excl. dumpers for off-highway use of subheading 8704.10 and special purpose motor vehicle','Vehículos automóviles para transporte de mercancías, con motor de émbolo "pistón" de encendido por compresión "diesel o semi-diesel", de peso total con carga máxima > 20 t (exc. volquetes automotores de la subpartida 8704.10 y vehículos automóviles para u',87,8704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870431,'Veículos automóveis para transporte de mercadorias, com motor de pistão, de ignição por centelha, de peso em carga máxima <= 5 t - caminhão caminhões carros','Motor vehicles for the transport of goods, with spark-ignition internal combustion piston engine, of a gross vehicle weight <= 5 t (excl. dumpers for off-highway use of subheading 8704.10 and special purpose motor vehicles of heading 8705)','Vehículos automóviles para transporte de mercancías, con motor de émbolo "pistón" de encendido por chispa, de peso total con carga máxima <= 5 t (exc. volquetes automotores de la subpartida 8704.10 y vehículos automóviles para usos especiales de la partid',87,8704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870432,'Veículos automóveis para transporte de mercadorias, com motor de pistão, de ignição por centelha, de peso em carga máxima > 5 t - caminhão caminhões','Motor vehicles for the transport of goods, with spark-ignition internal combustion piston engine, of a gross vehicle weight > 5 t (excl. dumpers for off-highway use of subheading 8704.10 and special purpose motor vehicles of heading 8705)','Vehículos automóviles para transporte de mercancías, con motor de émbolo "pistón" de encendido por chispa, de peso total con carga máxima > 5 t (exc. volquetes automotores de la subpartida 8704.10 y vehículos automóviles para usos especiales de la partida',87,8704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870490,'Outros veículos automóveis para transporte de mercadorias - caminhão caminhões','Motor vehicles for the transport of goods, with engines other than internal combustion piston engine (excl. dumpers for off-highway use of subheading 8704.10 and special purpose motor vehicles of heading 8705)','Vehículos automóviles para transporte de mercancías, con motor que no sea de émbolo "pistón" alternativo (exc. volquetes automotores de la subpartida 8704.10 y vehículos automóviles para usos especiales de la partida 8705)',87,8704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870510,'Caminhões-guindastes','Crane lorries (excluding breakdown lorries)','Camiones grúa (exc. coches para reparaciones "auxilio mecánico")',87,8705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870520,'Torres (derricks) automóveis, para sondagem de perfuração','Mobile drilling derricks','Camiones automóviles de sondeo o perforación',87,8705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870530,'Veículos automóveis de combate a incêndios','Fire fighting vehicles (excl. vehicles for transporting persons)','Camiones de bomberos (exc. los destinados al transporte de personal y dotaciones)',87,8705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870540,'Caminhões-betoneiras','Concrete-mixer lorries','Camiones hormigonera',87,8705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870590,'Outros veículos automóveis para usos especiais','Special purpose motor vehicles (other than those principally designed for the transport of persons or goods and excl. concrete-mixer lorries, fire fighting vehicles, mobile drilling derricks and crane lorries)','Vehículos automóviles para usos especiales (exc. camiones hormigonera, camiones de bomberos, camiones automóviles de sondeo o perforación y camiones grúa)',87,8705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870600,'Chassis com motor para veículos automóveis das posições 8701 a 8705','Chassis fitted with engines, for tractors, motor vehicles for the transport of ten or more persons, motor cars and other motor vehicles principally designed for the transport of persons, motor vehicles for the transport of goods and special purpose motor ','Chasis de tractores, vehículos automóviles para transporte de >= 10 personas, automóviles de turismo y vehículos automóviles para transporte de mercancías o para usos especiales de las partidas 8701 a 8705, equipados con su motor (exc. los dotados de moto',87,8706);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870710,'Carroçarias para os veículos da posição 87.03, incluídas as cabinas','Bodies for motor cars and other motor vehicles principally designed for the transport of persons','Carrocerías de automóviles de turismo',87,8707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870790,'Outras carroçarias para tratores, veículos automóveis para transporte de => 10 passageiros, carga ou usos especiais','Bodies for tractors, motor vehicles for the transport of ten or more persons, motor vehicles for the transport of goods and special purpose motor vehicles of heading 8705','Carrocerías de tractores, vehículos automóviles para transporte de >= 10 personas, para transporte de mercancías y para usos especiales',87,8707);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870810,'Pára-choques e suas partes, para veículos automóveis das posições 87.01 a 87.05','Bumpers and parts thereof for tractors, motor vehicles for the transport of ten or more persons, motor cars and other motor vehicles principally designed for the transport of persons, motor vehicles for the transport of goods and special purpose motor veh','Parachoques "paragolpes, defensas" y sus partes, de tractores, vehículos automóviles para transporte de >= 10 personas, automóviles de turismo, vehículos automóviles para transporte de mercancías o para usos especiales de las partidas 8701 a 8705, n.c.o.p',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870821,'Cintos de segurança, para veículos automóveis das posições 87.01 a 87.05','Safety seat belts for motor vehicles','Cinturones de seguridad para protección de personas en vehículos automóviles',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870829,'Outras partes e acessórios de carroçarias (incluídas as cabinas) para veículos automóveis das posições 87.01 a 87.05','Parts and accessories of bodies for tractors, motor vehicles for the transport of ten or more persons, motor cars and other motor vehicles principally designed for the transport of persons, motor vehicles for the transport of goods and special purpose mot','Partes y accesorios de carrocerías de tractores, vehículos automóviles para transporte de >= 10 personas, automóviles de turismo, vehículos automóviles para transporte de mercancías o para usos especiales (exc. parachoques "paragolpes, defensas" y sus par',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870830,'Freios e servo-freios, suas partes, para veículos automóveis das posições 87.01 a 87.05','Brakes and servo-brakes and their parts, for tractors, motor vehicles for the transport of ten or more persons, motor cars and other motor vehicles principally designed for the transport of persons, motor vehicles for the transport of goods and special pu',' Frenos y servofrenos; sus partes',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870831,'Guarnições de freios montadas','Mounted brake linings','Guarniciones de frenos montadas',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870839,'Outros freios e suas partes, p/tratores/veic.automóveis','Other brakes and its parts,f/tractors/motor vehicles','Los dem.frenos y sus partes, p/tractores/vehíc.automóv.',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870840,'Caixas de marchas (velocidade) e suas partes, para veículos automóveis das posições 8701 a 8705','Gear boxes and parts thereof, for tractors, motor vehicles for the transport of ten or more persons, motor cars and other motor vehicles principally designed for the transport of persons, motor vehicles for the transport of goods and special purpose motor','Cajas de cambio para tractores, vehículos automóviles para transporte de >= 10 personas, automóviles de turismo, vehículos automóviles para transporte de mercancías o para usos especiales',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870850,'Eixos de transmissão com diferencial, mesmo providos de outros órgãos de transmissão, e suas partes, para veículos automóveis das posições 8701 a 8705','Drive-axles with differential, whether or not provided with other transmission components, and non-driving axles, and parts thereof, for tractors, motor vehicles for the transport of ten or more persons, motor cars and other motor vehicles principally des','Ejes con diferencial, incl. provistos con otros órganos de transmisión, para vehículos automóviles',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870860,'Outros eixos e suas partes, para veículos','Other axles and parts thereof, for vehicles','Otros ejes y sus partes para vehículos',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870870,'Rodas, suas partes e acessórios, para veículos automóveis das posições 87.01 a 87.05','Road wheels and parts and accessories thereof, for tractors, motor vehicles for the transport of ten or more persons, motor cars and other motor vehicles principally designed for the transport of persons, motor vehicles for the transport of goods and spec','Ruedas, sus partes y accesorios, para tractores, vehículos automóviles para transporte de >= 10 personas, automóviles de turismo, vehículos automóviles para transporte de mercancías o para usos especiales, n.c.o.p.',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870880,'Sistemas de suspensão e suas partes (incluídos os amortecedores de suspensão), para veículos automóveis das posições 87.01 a 87.05','Suspension systems and parts thereof, incl. shock-absorbers, for tractors, motor vehicles for the transport of ten or more persons, motor cars and other motor vehicles principally designed for the transport of persons, motor vehicles for the transport of ','Amortiguadores de suspensión para tractores, vehículos automóviles para transporte de >= 10 personas, automóviles de turismo, vehículos automóviles para transporte de mercancías o para usos especiales',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870891,'Radiadores e suas partes, para veículos automóveis das posições 87.01 a 87.05','Radiators and parts thereof, for tractors, motor vehicles for the transport of ten or more persons, motor cars and other motor vehicles principally designed for the transport of persons, motor vehicles for the transport of goods and special purpose motor ','Radiadores de tractores, vehículos automóviles para transporte de >= 10 personas, automóviles de turismo, vehículos automóviles para transporte de mercancías o para usos especiales',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870892,'Silenciosos e tubos de escape, e suas partes, para veículos automóveis das posições 87.01 a 87.05','Silencers mufflers and exhaust pipes, and parts thereof, for tractors, motor vehicles for the transport of ten or more persons, motor cars and other motor vehicles principally designed for the transport of persons, motor vehicles for the transport of good','Silenciadores y tubos "caños" de escape de tractores, vehículos automóviles para transporte de >= 10 personas, automóviles de turismo, vehículos automóviles para transporte de mercancías o para usos especiales',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870893,'Embreagens e suas partes, para veículos automóveis das posições 87.01 a 87.05','Clutches and parts thereof, for tractors, motor vehicles for the transport of ten or more persons, motor cars and other motor vehicles principally designed for the transport of persons, motor vehicles for the transport of goods and special purpose motor v','Embragues y sus partes, para tractores, vehículos automóviles para transporte de >= 10 personas, automóviles de turismo, vehículos automóviles para transporte de mercancías o para usos especiales, n.c.o.p.',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870894,'Volantes, barras, caixas de direção, e suas partes, para veículos automóveis das posições 87.01 a 87.05','Steering wheels, steering columns and steering boxes, and parts thereof, for tractors, motor vehicles for the transport of ten or more persons, motor cars and other motor vehicles principally designed for the transport of persons, motor vehicles for the t','Volantes, columnas y cajas, de dirección, para tractores, vehículos automóviles para transporte de >= 10 personas, automóviles de turismo, vehículos automóviles para transporte de mercancías o para usos especiales',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870895,'Bolsas infláveis de segurança com sistema de insuflação ("airbags), suas partes, para veículos automóveis das posições 87.01 a 87.05','Safety airbags with inflator system and parts thereof, for tractors, motor vehicles for the transport of ten or more persons, motor cars and other motor vehicles principally designed for the transport of persons, motor vehicles for the transport of goods ',' Bolsas inflables de seguridad con sistema de inflado (airbag); sus partes',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870899,'Outras partes e acessórios, para veículos automóveis das posições 87.01 a 87.05','Parts and accessories, for tractors, motor vehicles for the transport of ten or more persons, motor cars and other motor vehicles principally designed for the transport of persons, motor vehicles for the transport of goods and special purpose motor vehicl','Partes y accesorios de tractores, vehículos automóviles para transporte de >= 10 personas, automóviles de turismo, vehículos automóviles para transporte de mercancías o para usos especiales, n.c.o.p.',87,8708);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870911,'Veículos automóveis, elétricos, sem dispositivo de elevação, para transporte de mercadorias a curtas distâncias','Electrical vehicles not fitted with lifting or handling equipment, of the type used in factories, warehouses, dock areas or airports for short distance transport of goods; tractors of the type used on railway station platforms','Carretillas eléctricas sin dispositivo de elevación de los tipos utilizados para transporte de mercancías a corta distancia o para el arrastre de pequeños remolques en estaciones ferroviarias',87,8709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870919,'Outros veículos automóveis, sem dispositivo de elevação, para transporte de mercadorias a curtas distâncias','Works trucks, self-propelled, not fitted with lifting or handling equipment, of the type used in factories, warehouses, dock areas or airports for short distance transport of goods; tractors of the type used on railway station platforms (excl. electrical ','Carretillas automóvil sin dispositivo de elevación de los tipos utilizados para transporte de mercancías a corta distancia o para el arrastre de pequeños remolques en estaciones ferroviarias (exc. carretillas eléctricas)',87,8709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (870990,'Partes de veículos automóveis, sem dispositivo de elevação, para transporte de mercadorias a curtas distâncias','Parts of self-propelled works trucks, not fitted with lifting or handling equipment, of the type used in factories, warehouses, dock areas or airports for short distance transport of goods, incl. tractors for railways station platforms, n.e.s.','Partes de carretillas automóvil sin dispositivo de elevación de los tipos utilizados para transporte de mercancías a corta distancia o para el arrastre de pequeños remolques en estaciones ferroviarias, n.c.o.p.',87,8709);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871000,'Veículos e carros blindados de combate, armados ou não, e suas partes','Tanks and other armoured fighting vehicles, motorised, whether or not fitted with weapons, and parts of such vehicles, n.e.s.','Tanques y demás vehículos automóviles blindados de combate, incl. con su armamento; sus partes, n.c.o.p.',87,8710);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871110,'Motocicletas e outros ciclos equipados com motor de pistão alternativo de cilindrada <= 50 cm3','Motorcycles, incl. mopeds, and cycles fitted with an auxiliary motor, with reciprocating internal combustion piston engine of a cylinder capacity <= 50 cm³','Ciclomotores y velocípedos equipados con motor auxiliar, con motor de émbolo "pistón" alternativo de cilindrada <= 50 cm³',87,8711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871120,'Motocicletas e outros ciclos com motor de pistão alternativo, de cilindrada > 50 cm3 e <= 250 cm3','Motorcycles, incl. mopeds, with reciprocating internal combustion piston engine of a cylinder capacity > 50 cm³ but <= 250 cm³','Motocicletas, incl. los ciclomotores, con motor de émbolo "pistón" alternativo de cilindrada > 50 cm³ e <= 250 cm³',87,8711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871130,'Motocicletas e outros ciclos com motor de pistão alternativo, de cilindrada > 250 cm3 e <= 500 cm3','Motorcycles, incl. mopeds, with reciprocating internal combustion piston engine of a cylinder capacity > 250 cm³ but <= 500 cm³','Motocicletas con motor de émbolo "pistón" alternativo de cilindrada > 250 cm³ e <= 500 cm³',87,8711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871140,'Motocicletas e outros ciclos com motor de pistão alternativo, de cilindrada > 500 cm3 e <= 800 cm3','Motorcycles, incl. mopeds, with reciprocating internal combustion piston engine of a cylinder capacity > 500 cm³ but <= 800 cm³','Motocicletas con motor de émbolo "pistón" alternativo de cilindrada > 500 cm³ e <= 800 cm³',87,8711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871150,'Motocicletas e outros ciclos com motor de pistão alternativo de cilindrada > 800 cm3','Motorcycles, incl. mopeds, with reciprocating internal combustion piston engine of a cylinder capacity > 800 cm³','Motocicletas con motor de émbolo "pistón" alternativo de cilindrada > 800 cm³',87,8711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871190,'Outras motocicletas (incluídos os ciclomotores) e outros ciclos equipados com motor auxiliar, mesmo com carro lateral; carros laterais','Side cars for motorcycles','Sidecares para motocicletas',87,8711);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871200,'Bicicletas e outros ciclos (incluídos os triciclos), sem motor','Bicycles and other cycles, incl. delivery tricycles, not motorised','Bicicletas y demás velocípedos, incl. los triciclos de reparto, sin motor',87,8712);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871310,'Cadeiras de rodas e outros veículos para inválidos, sem mecanismo de propulsão','Carriages for disabled persons, not mechanically propelled','Sillones de ruedas y demás vehículos para inválidos, sin motor u otro mecanismo de propulsión',87,8713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871390,'Cadeiras de rodas e outros veículos para inválidos, com motor ou outro mecanismo de propulsão','Carriages for disabled persons, motorised or otherwise mechanically propelled (excl. specially designed motor vehicles and bicycles)','Sillones de ruedas y demás vehículos para inválidos, con motor u otro mecanismo de propulsión (exc. automóviles y ciclos con mecanismos especiales)',87,8713);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871410,'Partes e acessórios de motocicletas (inclusive ciclomotores)','Parts and accessories of motorcycles (including mopeds)','Partes y accesorios de motocicletas, incluidos los ciclomotores)',87,8714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871411,'Selins de motocicletas (incluídos os ciclomotores)','Saddles for motorcycles, incl. mopeds','Sillines "asientos" de motocicletas, incl. los ciclomotores',87,8714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871419,'Outras partes e acessórios para motocicletas (incluídos os ciclomotores)','Parts and accessories for motorcycles, incl. mopeds, n.e.s.','Partes y accesorios de motocicletas, incl. los ciclomotores, n.c.o.p.',87,8714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871420,'Partes e acessórios para cadeiras de rodas ou outros veículos para inválidos','Parts and accessories for carriages for disabled persons, n.e.s.','Partes y accesorios de sillones de ruedas y demás vehículos para inválidos, n.c.o.p.',87,8714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871491,'Quadros, garfos e suas partes, para bicicletas e outros ciclos','Frames and forks, and parts thereof, for bicycles, n.e.s.','Cuadros y horquillas de ciclos, y sus partes, n.c.o.p.',87,8714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871492,'Aros e raios para bicicletas e outros ciclos','Wheel rims and spokes, for bicycles','Llantas y radios de ciclos',87,8714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871493,'Cubos, exceto de freios (travões), e pinhões de rodas livres, para bicicletas e outros ciclos','Hubs (other than coaster braking hubs) and hub brakes, and free-wheel sprocket-wheels, for bicycles','Bujes (sin freno) y piñones libres, de ciclos',87,8714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871494,'Outros freios (travões), incluídos os cubos de freios, e suas partes, para bicicletas e outros ciclos','Brakes, incl. coaster braking hubs and hub brakes, and parts thereof, for bicycles','Frenos de ciclos, incl. los bujes con freno, y sus partes',87,8714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871495,'Selins de bicicletas e outros ciclos','Saddles for bicycles','Sillines "asientos" de ciclos',87,8714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871496,'Pedais e pedaleiros e suas partes, para bicicletas e outros ciclos','Pedals and crank-gear, and parts thereof, for bicycles, n.e.s.','Pedales y mecanismos de pedal, y sus partes, n.c.o.p.',87,8714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871499,'Outras partes e acessórios para bicicletas e outros ciclos','Parts and accessories, for bicycles, n.e.s.','Partes y accesorios de ciclos, n.c.o.p.',87,8714);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871500,'Carrinhos e veículos semelhantes e suas partes, para transporte de crianças','Baby carriages and parts thereof, n.e.s.','Coches, sillas y vehículos simil. para transporte de niños, y sus partes, n.c.o.p.',87,8715);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871610,'Reboques e semi-reboques, para habitação ou para acampar, do tipo trailer','Trailers and semi-trailers of the caravan type, for housing or camping','Remolques y semirremolques para vivienda o acampar, del tipo caravana',87,8716);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871620,'Reboques e semi-reboques, autocarregáveis ou autodescarregáveis, para usos agrícolas','Self-loading or self-unloading trailers and semi-trailers for agricultural purposes','Remolques y semirremolques, autocargadores o autodescargadores, para uso agrícola',87,8716);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871631,'Reboques-cisternas para transporte de mercadorias','Tanker trailers and tanker semi-trailers, not designed for running on rails','Cisternas no desplazables sobre carriles "rieles"',87,8716);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871639,'Outros reboques e semi-reboques, para transporte de mercadorias','Trailers and semi-trailers for the transport of goods, not designed for running on rails (excl. self-loading or self-unloading trailers and semi-trailers for agricultural purposes and tanker trailers and tanker semi-trailers)','Remolques y semirremolques para transporte de mercancías, no desplazables sobre carriles "rieles" (exc. remolques y semirremolques, autocargadores o autodescargadores, para uso agrícola, así como cisternas)',87,8716);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871640,'Outros reboques e semi-reboques','Trailers and semi-trailers, not designed for running on rails (excl. trailers and semi-trailers for the transport of goods and those of the caravan type for housing or camping)','Remolques y semirremolques no desplazables sobre carriles "rieles" (exc. para transporte de mercancías, así como para vivienda o acampada, del tipo caravana)',87,8716);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871680,'Outros veículos não autopropulsores','Vehicles pushed or drawn by hand and other vehicles not mechanically propelled (excl. trailers and semi-trailers)','Vehículos de mano y otros vehículos no automóviles (exc. remolques para cualquier vehículo)',87,8716);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (871690,'Partes de reboques e semi-reboques, para quaisquer veículos e outros veículos não autopropulsores','Parts of trailers and semi-trailers and other vehicles not mechanically propelled, n.e.s.','Partes de remolques y semirremolques y de otros vehículos no automóviles, n.c.o.p.',87,8716);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880100,'Balões e dirigíveis; planadores, asas voadoras e outros veículos aéreos, não concebidos para propulsão com motor','Balloons and dirigibles; gliders, hang gliders and other non-powered aircraft',' Globos y dirigibles; planeadores, alas planeadoras y demás aeronaves no concebidas para la propulsión con motor',88,8801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880110,'Planadores e asas voadoras','Gliders and hang gliders','Planeadores y alas planeadoras',88,8801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880190,'Balões, dirigíveis e outs.veículos aéreos n/motorizados','Balloons,dirigibles and other aircraft n/motorized','Globos, dirigibles y demás aeronaves s/motor',88,8801);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880211,'Helicópteros, de peso <= 2.000 kg, vazios','Helicopters of an unladen weight <= 2.000 kg','Helicópteros de peso en vacío <= 2.000 kg',88,8802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880212,'Helicópteros, de peso > 2.000 kg, vazios','Helicopters of an unladen weight > 2.000 kg','Helicópteros de peso en vacío > 2.000 kg',88,8802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880220,'Aviões e outros veículos aéreos, de peso <= 2.000 kg, vazios','Aeroplanes and other powered aircraft of an unladen weight <= 2.000 kg (excl. helicopters and dirigibles)','Aviones y demás aeronaves para la propulsión con motor, de peso en vacío <= 2.000 kg (exc. helicópteros y dirigibles)',88,8802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880230,'Aviões e outros veículos aéreos, de peso > 2.000 kg e <= 15.000 kg, vazios','Aeroplanes and other powered aircraft of an unladen weight > 2.000 kg but <= 15.000 kg (excl. helicopters and dirigibles)','Aviones y demás aeronaves para la propulsión con motor, de peso en vacío > 2.000 kg e <= 15.000 kg (exc. helicópteros y dirigibles)',88,8802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880240,'Aviões e outros veículos aéreos, de peso > 15.000 kg, vazios','Aeroplanes and other powered aircraft of an of an unladen weight > 15.000 kg (excl. helicopters and dirigibles)','Aviones y demás aeronaves para la propulsión con motor, de peso en vacío > 15.000 kg (exc. helicópteros y dirigibles)',88,8802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880260,'Veículos espaciais (incluídos os satélites) e seus veículos de lançamento e veículos suborbitais','Spacecraft, incl. satellites, and suborbital and spacecraft launch vehicles','Vehículos espaciales, incl. los satélites, y sus vehículos de lanzamiento y vehículos suborbitales',88,8802);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880310,'Hélices e rotores, e suas partes, para veículos aéreos','Propellers and rotors and parts thereof, for aircraft, n.e.s.','Hélices y rotores, y sus partes, para aeronaves, n.c.o.p.',88,8803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880320,'Trens de aterrissagem e suas partes, para veículos aéreos','Under-carriages and parts thereof, for aircraft, n.e.s.','Trenes de aterrizaje, y sus partes, para aeronaves, n.c.o.p.',88,8803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880330,'Outras partes para aviões ou helicópteros','Parts of aeroplanes or helicopters, n.e.s. (excl. those for gliders)','Partes de aviones o de helicópteros, n.c.o.p. (exc. planeadores "parapentes")',88,8803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880390,'Outras partes para outros veículos aéreos e espaciais','Parts of aircraft and spacecraft, n.e.s.','Partes de aeronaves y de vehículos espaciales y sus vehículos de lanzamiento y vehículos suborbitales, n.c.o.p.',88,8803);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880400,'Pára-quedas (incluídos os dirigíveis e os parapentes) e os pára-quedas giratórios, suas partes e acessórios','Parachutes, incl. dirigible parachutes and paragliders, and rotochutes; parts thereof and accessories thereto, n.e.s.','Paracaídas, incl. los paracaídas dirigibles, planeadores "parapentes" o giratorios; sus partes y accesorios, n.c.o.p.',88,8804);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880510,'Aparelhos e dispositivos para lançamento de veículos aéreos; aparelhos e dispositivos para aterrissagem de veículos aéreos em porta-aviões e aparelhos e dispositivos semelhantes; aparelhos de treinamento de vôo em terra; suas partes','Aircraft launching gear and parts thereof, n.e.s. (excl. motor winches for launching gliders); deck-arrestor or similar gear and parts thereof, n.e.s.','Aparatos y dispositivos para lanzamiento de aeronaves, aparatos y dispositivos para aterrizaje en portaaviones y aparatos y dispositivos simil., aparatos de entrenamiento de vuelo, y sus partes, n.c.o.p. (exc. tornos automotores para arranque de planeador',88,8805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880520,'Aparelhos simuladores de voo em terra e suas partes','Flight simulators apparatus and parts thereof','Aparatos entrenamiento de vuelo en tierra y sus partes',88,8805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880521,'Simuladores de combate aéreo e suas partes','Air combat simulators and parts thereof','Simuladores de combate aéreo y sus partes',88,8805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (880529,'Outros aparelhos de treinamento de vôo em terra e suas partes','Ground flying trainers and parts thereof, n.e.s. (excl. air combat simulators and parts thereof)','Aparatos de entrenamiento de vuelo en tierra y sus partes, n.c.o.p. (exc. simuladores de combate aéreo y sus partes)',88,8805);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890110,'Transatlânticos, barcos de cruzeiro e embarcações semelhantes para o transporte de pessoas, ferry-boats','Cruise ships, excursion boats and similar vessels principally designed for the transport of persons; ferry-boats of all kinds','Transatlánticos, barcos para excursiones "de cruceros" y barcos simil. concebidos principalmente para transporte de personas, así como transbordadores',89,8901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890120,'Navios-tanque','Tankers','Barcos cisterna',89,8901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890130,'Barcos frigoríficos, exceto os navios-tanque','Refrigerated vessels (excl. tankers)','Barcos frigorífico (exc. barcos cisterna)',89,8901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890190,'Outras embarcações para o transporte de mercadorias ou de pessoas e de mercadorias','Vessels for the transport of goods and vessels for the transport of both persons and goods (excl. refrigerated vessels, tankers, ferry-boats and vessels principally designed for the transport of persons)','Barcos para transporte de mercancías, así como los concebidos para transporte mixto de personas y mercancías (exc. barcos frigorífico, barcos cisterna, transbordadores y barcos concebidos principalmente para transporte de personas)',89,8901);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890200,'Barcos de pesca; navios-fábricas e outras embarcações para o tratamento ou conservação de produtos da pesca','Fishing vessels; factory ships and other vessels for processing or preserving fishery products (excl. fishing boats for sport)','Barcos de pesca, así como barcos factoría y demás barcos para tratamiento o preparación de productos de la pesca (exc. barcos para la pesca deportiva)',89,8902);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890310,'Barcos infláveis de recreio ou de esporte','Inflatable vessels for pleasure or sports','Embarcaciones inflables de recreo o deporte',89,8903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890391,'Barcos a vela, de recreio ou de esporte, mesmo com motor auxiliar','Sailboats and yachts, with or without auxiliary motor, for pleasure or sports','Barcos y yates de vela de recreo o deporte, incl. con motor auxiliar',89,8903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890392,'Barcos a motor, de recreio ou de esporte, exceto com motor fora-de-borda (tipo out-board)','Motor boats and motor yachts, for pleasure or sports (other than outboard motor boats)','Barcos y yates con motor interior, de recreo o deporte',89,8903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890399,'Outros barcos e embarcações de recreio ou de esporte; barcos a remo e canoas','Vessels for pleasure or sports; rowing boats (excl. motor boats and motor yachts powered other than by outboard motors, sailboats and yachts with or without auxiliary motor and inflatable boats)','Barcos de recreo o deporte, así como barcas de remo (exc. barcos y yates con motor interior, barcos y yates de vela, incl. con motor auxiliar, así como embarcaciones inflables)',89,8903);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890400,'Rebocadores e barcos para empurrar outras embarcações','Tugs and pusher craft','Remolcadores y barcos empujadores',89,8904);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890510,'Dragas','Dredgers','Dragas',89,8905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890520,'Plataformas de perfuração ou de exploração, flutuantes ou submersíveis','Floating or submersible drilling or production platforms','Plataformas de perforación o explotación, flotantes o sumergibles',89,8905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890590,'Barcos-faróis, guindastes, docas, diques flutuantes e outras embarcações em que a navegação e acessória da função principal','Light-vessels, fire-floats, floating cranes and other vessels, the navigability of which is subsidiary to their main function (excl. dredgers, floating or submersible drilling or production platforms; fishing vessels and warships)','Barcos faro, barcos bomba, pontones grúa y demás barcos en los que la navegación sea accesoria en relación con la función principal (exc. dragas, plataformas de perforación o explotación, flotantes o sumergibles, barcos de pesca y navíos de guerra)',89,8905);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890600,'Outras embarcações','Other vessels','Los demás barcos',89,8906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890610,'Navios de guerra','Warships of all kinds','Navíos de guerra de todo tipo',89,8906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890690,'Outras embarcações, incluídos os barcos salva-vidas, exceto os barcos a remo','Vessels, incl. lifeboats (excl. warships, rowing boats and other vessels of heading 8901 to 8905 and vessels for breaking up)','Barcos, incl. los barcos de salvamento (exc. navíos de guerra, barcas de remos y otros barcos de las partidas 8901 a 8905, así como barcos para desguace)',89,8906);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890710,'Balsas infláveis','Inflatable rafts','Balsas inflables',89,8907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890790,'Outras estruturas flutuantes','Rafts, tanks, coffer-dams, landing stages, buoys, beacons and other floating structures (excl. inflatable rafts, vessels of heading 8901 to 8906 and floating structures for breaking up)','Balsas, depósitos, cajones, incl. de amarre, boyas, balizas y demás artefactos flotantes (exc. balsas inflables, barcos de las partidas 8901 a 8905 y artefactos flotantes para desguace)',89,8907);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (890800,'Embarcações e outras estruturas flutuantes, para demolição','Vessels and other floating structures for breaking up','Barcos y demás artefactos flotantes para desguace',89,8908);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900110,'Fibras ópticas, feixes e cabos de fibras ópticas','Optical fibres, optical fibre bundles and cables (excl. made up of individually sheathed fibres of heading 8544)','Fibras ópticas, haces y cables de fibras ópticas (exc. cables constituidos por fibras ópticas enfundadas individualmente)',90,9001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900120,'Matérias polarizantes, em folhas e placas','Sheets and plates of polarising material','Hojas y placas de materia polarizante',90,9001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900130,'Lentes de contato','Contact lenses','Lentes de contacto',90,9001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900140,'Lentes de vidro, para óculos','Spectacle lenses of glass','Lentes de vidrio para para gafas "anteojos"',90,9001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900150,'Lentes de outras matérias, para óculos','Spectacle lenses of materials other than glass','Lentes de otras materias distintas del vidrio para gafas "anteojos"',90,9001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900190,'Prismas, espelhos e outros elementos de óptica, de qualquer matéria, não montados','Lenses, prisms, mirrors and other optical elements, of any material, unmounted (excl. such elements of glass not optically worked, contact lenses and spectacle lenses)','Lentes, prismas, espejos y demás elementos de óptica de cualquier materia, sin montar (exc. los de vidrio sin trabajar ópticamente, así como lentes de contacto y lentes de vidrio para gafas "anteojos")',90,9001);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900211,'Lentes objetivas, montadas, para câmeras, para projetores ou para aparelhos fotográficos ou cinematográficos, de ampliação ou de redução','Objective lenses for cameras, projectors or photographic enlargers or reducers','Objetivos para cámaras, proyectores o ampliadoras o reductoras fotográficos o cinematográficos',90,9002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900219,'Outras lentes objetivas, montadas','Objective lenses (excl. for cameras, projectors or photographic enlargers or reducers)','Objetivos (exc. para cámaras, proyectores o ampliadoras o reductoras fotográficos o cinematográficos)',90,9002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900220,'Filtros ópticos, montados','Filters, optical, being parts of or fittings for instruments, apparatus and appliances, framed or mounted','Filtros ópticos, montados, para instrumentos o aparatos',90,9002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900290,'Outros elementos de óptica, de qualquer matéria, montados','Lenses, prisms, mirrors and other optical elements, mounted, of any material, being parts of or fittings for instruments or apparatus (excl. objective lenses for cameras, projectors or photographic enlargers or reducers, such elements of glass not optical','Lentes, prismas, espejos y demás elementos de óptica de cualquier materia, montados, para instrumentos o aparatos (exc. los de vidrio sin trabajar ópticamente, así como filtros y objetivos)',90,9002);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900311,'Armações para óculos e artigos semelhantes, de plásticos','Frames and mountings for spectacles, goggles or the like, of plastics','Monturas "armazones" de gafas "anteojos" o de artículos simil., de plástico',90,9003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900319,'Armações para óculos e artigos semelhantes, de outras matérias','Frames and mountings for spectacles, goggles or the like (excl. of plastics)','Monturas "armazones" de gafas "anteojos" o de artículos simil. (exc. de plástico)',90,9003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900390,'Partes para armações de óculos e artigos semelhantes','Parts of frames and mountings for spectacles, goggles or the like, n.e.s.','Partes de monturas "armazones" de gafas "anteojos" o de artículos simil., n.c.o.p.',90,9003);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900410,'Óculos de sol','Sunglasses','Gafas "anteojos" de sol',90,9004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900490,'Óculos para correção, proteção ou outros fins, e artigos semelhantes','Spectacles, goggles and the like, corrective, protective or other (excl. spectacles for testing eyesight, sunglasses, contact lenses, spectacle lenses and frames and mountings for spectacles)','Gafas "anteojos" correctoras, protectoras u otras, y artículos simil. (exc. gafas "anteojos" para medir la vista, gafas "anteojos" de sol, lentes de contacto y vidrios y monturas "armazones" para gafas "anteojos")',90,9004);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900510,'Binóculos','Binoculars','Binoculares, incl. los prismáticos',90,9005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900580,'Lunetas e outros instrumentos de astronomia e suas armações','Monoculars, astronomical and other optical telescopes and other astronomical instruments (excl. binoculars, instruments for radio-astronomy and other instruments or apparatus specified elsewhere)','Catalejos, anteojos astronómicos, telescopios ópticos y sus armazones; los demás instrumentos de astronomía y sus armazones (exc. binoculares, incl. los prismáticos, los aparatos de radioastronomía y otros instrumentos o aparatos, n.c.o.p.)',90,9005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900590,'Partes e acessórios de lunetas e outros instrumentos de astronomia e suas armações','Parts and accessories, incl. mountings, for binoculars, monoculars, astronomical and other optical telescopes, and other astronomical instruments, n.e.s.','Partes y accesorios, incl. las armazones, de binoculares, prismáticos, catalejos, anteojos astronómicos, telescopios ópticos y sus armazones; los demás instrumentos de astronomía, n.c.o.p.',90,9005);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900610,'Câmeras fotográficas para preparação de clichês ou cilindros de impressão','Cameras of a kind used for preparing printing plates or cylinders','Cámaras fotográficas de los tipos utilizados para preparar clisés o cilindros de imprenta',90,9006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900620,'apars.fotograf.p/registro de docum.em microfilmes, etc.','photog.cameras f/recording documents on microfilm,etc','cám.fotográf.p/registrar docum.en microfilmes, etc',90,9006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900630,'Câmeras fotográficas para fotografia submarina ou aérea, para exame médico de órgão internos, para laboratórios de medicina legal ou investigação judicial','Cameras specially designed for underwater use, for aerial survey or for medical or surgical examination of internal organs; comparison cameras for forensic or criminological laboratories','Cámaras especiales para fotografía submarina o aérea, examen médico de órganos internos o para laboratorios de medicina legal o identificación judicial',90,9006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900640,'Câmeras fotográficas para filmes de revelação e copiagem instantâneas','Instant print cameras (excl. special cameras of subheading 9006.10 or 9006.30)','Cámaras fotográficas con autorrevelado (exc. cámeras especiales de las subpartidas 9006.10, 9006.20 y 9006.30)',90,9006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900651,'Câmeras fotográficas com visor de reflexão através da objetiva (reflex), para películas, em rolos, de largura <= 35 mm','Cameras with a through-the-lens viewfinder [single lens reflex SLR] for roll film of a width of <= 35 mm (excl. instant print cameras and special camereas of subheading 9006.10 or 9006.30)','Cámaras fotográficas con visor de reflexión a través del objetivo, para películas en rollo de anchura <= 35 mm (exc. cámeras fotográficas con autorrevelado y cámeras especiales de las subpartidas 9006.10, 9006.20 y 9006.30)',90,9006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900652,'Outras câmeras fotográficas para películas, em rolos, de largura < 35 mm','Cameras for roll film of a width of < 35 mm (excl. instant print cameras, single lens reflex SLR cameras and special cameras of subheading 9006.10 or 9006.30)','Cámaras fotográficas para películas en rollo de anchura < 35 mm (exc. cámeras fotográficas con autorrevelado, cámeras fotográficas con visor de reflexión a través del objetivo y cámeras especiales de las subpartidas 9006.10, 9006.20 y 9006.30)',90,9006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900653,'Outras câmeras fotográficas para películas, em rolos, de largura = 35 mm','Cameras for roll film of a width of 35 mm (excl. instant print cameras, single lens reflex cameras and special cameras of subheading 9006.10 or 9006.30)','Cámaras fotográficas para películas en rollo de anchura = 35 mm (exc. cámeras fotográficas con autorrevelado, cámeras fotográficas con visor de reflexión a través del objetivo y cámeras especiales de las subpartidas 9006.10, 9006.20 y 9006.30)',90,9006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900659,'Outras câmeras fotográficas','Cameras for roll film of a width of > 35 mm or for film in the flat (excl. instant print cameras and special cameras of subheading 9006.10 or 9006.30)','Cámaras fotográficas para películas en rollo de anchura > 35 mm o para películas planas (exc. cámeras fotográficas con autorrevelado y cámeras especiales de las subpartidas 9006.10, 9006.20 y 9006.30)',90,9006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900661,'Aparelhos de tubo de descarga para produção de luz-relâmpago (flashes eletrônicos)','Electronic discharge lamp flashlight apparatus for photographic purposes','Aparatos de tubo de descarga para producir destellos para fotografía "flashes electrónicos"',90,9006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900662,'Lâmpadas, cubos e semelhantes, de luz relampago para fotografia','Flashbulbs,flashcubes and the like f/picture','Lámparas, cubos de destello p/fotografía',90,9006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900669,'Outros aparelhos e dispositivos de luz-relâmpago para fotografia','Photographic flashlights and flashlight apparatus (excl. with electronic discharge lamps)','Aparatos y dispositivos para producir destellos para fotografía (exc. aparatos de tubo de descarga "flashes electrónicos", lámparas y cubos de destello y simil.)',90,9006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900691,'Partes e acessórios de aparelhos fotográficos','Parts and accessories for photographic cameras, n.e.s.','Partes y accesorios de cámeras fotográficas, n.c.o.p.',90,9006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900699,'Outras partes e acessórios para aparelhos e dispositivos para fotografia','Parts and accessories for photographic flashlights and flashlight apparatus, n.e.s.','Partes y accesorios de aparatos y dispositivos para producir destellos para fotografía, n.c.o.p.',90,9006);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900710,'Câmeras','Cameras','Cámaras',90,9007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900711,'Câmeras cinematográficas para filmes de largura < 16 mm ou duplo-8 mm','Cinematographic cameras for film of < 16 mm width or for double-8 mm film','Cámaras cinematográficas para película cinematográfica "filme" de anchura < 16 mm o doble-8 mm',90,9007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900719,'Outras câmeras cinematográficas','Cinematographic cameras for film of >= 16 mm width (excl. for double-8 mm film)','Cámaras cinematográficas para película cinematográfica "filme" de anchura >= 16 mm (exc. de doble-8 mm)',90,9007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900720,'Projetores cinematográficos','Cinematographic projectors','Proyectores cinematográficos',90,9007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900791,'Partes e acessórios de câmeras cinematográficas','Parts and accessories for cinematographic cameras, n.e.s.','Partes y accesorios de cámaras cinematográficas, n.c.o.p.',90,9007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900792,'Partes e acessórios de projetores cinematográficos','Parts and accessories for cinematographic projectors, n.e.s.','Partes y accesorios de proyectores cinematográficos, n.c.o.p.',90,9007);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900810,'Projetores de diapositivos','Slide projectors','Proyectores de diapositivas',90,9008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900820,'Leitoras de microfilmes, microfichas e de outros microformatos, mesmo permitindo a obtenção de cópias','Microfilm, microfiche or other microform readers, whether or not capable of producing copies','Lectores de microfilmes, microfichas u otros microformatos, incl. copiadores',90,9008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900830,'Outros projetores de imagens fixas','Image projectors (excl. slide projectors and microfilm, microfiche or other microform readers)','Proyectores de imagen fija (exc. proyectores de diapositivas y lectores de microfilmes, microfichas u otros microformatos)',90,9008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900840,'Aparelhos fotográficos, de ampliação ou de redução','Photographic enlargers and reducers','Ampliadoras o reductoras, fotográficas',90,9008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900850,'Projetores e aparelhos de ampliação ou redução','Projectors and apparatus for enlarging or reducing','Proyectores y aparatos para la ampliación o la reducción',90,9008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900890,'Partes e acessórios para aparelhos de projeção fixa e aparelhos fotográficos de ampliação ou de redução','Parts and accessories for image projectors, photographic enlargers and reducers, n.e.s.','Partes y accesorios de proyectores de imagen fija, ampliadoras o reductoras, fotográficas, n.c.o.p.',90,9008);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900911,'Aparelhos de reprodução direta de fotocópia, eletrostático','Appar.f/repr.original image direc.onto copy,electr.','Aparatos por proced.directo de fotocopia, electrostático',90,9009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900912,'Aparelhos de fotocópia','Photocopying apparatus','Aparatos de fotocopia',90,9009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900921,'Aparelhos de fotocópia, por sistema óptico','Photocopying apparatus,incorporating an optical system','Aparatos de fotocopia, por sistema óptico',90,9009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900922,'Aparelhos de fotocópia, por contato','Photocopying apparatus,of the contact type','Aparatos de fotocopia, de contacto',90,9009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900930,'Aparelhos de termocópia','Thermo-copying apparatus','Aparatos de termocopia',90,9009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900990,'Partes para aparelhos de fotocópia ou termocópia','Parts of photocopying apparatus','Partes de fotocopiadoras',90,9009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900991,'Dispositiv.automat.alim.docum.p/apars.fotocop','Automatic document feeders f/photocopyng apparatus','Alimentadores automát.docum.p/apars.fotocop.',90,9009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900992,'Dispositiv.aliment.de papel p/apars.fotocópia','paper feeders f/photocopyng apparatus','Alimentadores de papel p/apars.fotocopia',90,9009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900993,'Dispositivos de triagem p/apars.fotocópia','Sorters f/photocopyng apparatus','Clasificadores p/apars.fotocopia',90,9009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (900999,'Partes para aparelhos de fotocópia ou termocópia','Parts of photocopying apparatus','Partes de fotocopiadoras',90,9009);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901010,'Aparelhos e material para revelação automática de películas fotográficas, de filmes cinematográficos ou de papel fotográfico, em rolos, ou para copiagem automática de películas reveladas em rolos de papel fotográfico','Apparatus and equipment for automatically developing photographic or cinematographic film or paper in rolls or for automatically exposing developed film to rolls of photographic paper','Aparatos y material para revelado automático de película fotográfica, película cinematográfica "filme" o papel fotográfico en rollo o para la impresión automática de películas reveladas en rollos de papel fotográfico',90,9010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901041,'Aparelhos para inscrição em disco ("wafers")','Direct write-on-wafer apparatus','Aparatos p/trazado directo sobre obleas ("wafers")',90,9010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901042,'Fotorrepetidores','step and repeat aligners','fotorrepetidores',90,9010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901049,'outs.apars.p/projeção, etc.de tracados de circuitos, etc.','oth.appar.f/projection,etc of circuits patterns,etc.','los dem.apars.p/proyectar, etc.esquemas de circuitos, etc',90,9010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901050,'Outros aparelhos e material para laboratórios fotográficos ou cinematográficos; negatoscópios','Apparatus and equipment for photographic or cinematographic laboratories, n.e.s.; negatoscopes','Aparatos y material para laboratorios fotográfico o cinematográfico, n.c.o.p.; negatoscopios',90,9010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901060,'Telas (écran) para projeção fotográfica ou cinematográfica','Projection screens','Pantallas de proyección',90,9010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901090,'Partes e acessórios para aparelhos utilizados nos laboratórios fotográficos ou cinematográficos, para negatoscópios e telas de projeção','Parts and accessories for apparatus and equipment for photographic or cinematographic laboratories, negatoscopes and projection screens, n.e.s.','Partes y accesorios de aparatos y material para laboratorios fotográfico o cinematográfico, así como de negatoscopios y pantallas de proyección, n.c.o.p.',90,9010);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901110,'Microscópios estereoscópicos','Stereoscopic optical microscopes','Microscopios estereoscópicos ópticos',90,9011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901120,'Outros microscópios, para fotomicrografia, cinefotomicrografia ou microprojeção','Optical microscopes, for photomicrography, cinephotomicrography or microprojection (excl. stereoscopic microscopes)','Microscopios ópticos para fotomicrografía, cinefotomicrografía o microproyección (exc. microscopios estereoscópicos ópticos)',90,9011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901180,'Outros microscópios ópticos','Optical microscopes (excl. for photomicrography, cinephotomicrography or microprojection, stereoscopic microscopes, binocular microscopes for ophthalmology and instruments, appliances and machines of heading 9031)','Microscopios ópticos (exc. para fotomicrografía, cinefotomicrografía o microproyección, microscopios estereoscópicos ópticos, microscopios binoculares para oftalmología, así como instrumentos y aparatos de la partida 9031)',90,9011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901190,'Partes e acessórios para microscópios ópticos','Parts and accessories for compound optical microscopes, n.e.s.','Partes y accesorios de microscopios ópticos, n.c.o.p.',90,9011);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901210,'Microscópios (exceto ópticos) e difratógrafos','Electron microscopes, proton microscopes and diffraction apparatus','Microscopios de electrones, microscopios de protones y difractógrafos',90,9012);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901290,'Partes e acessórios para microscópios, exceto ópticos, e difratógrafos','Parts and accessories for electron microscopes, proton microscopes and diffraction apparatus, n.e.s.','Partes y accesorios de microscopios de electrones, microscopios de protones y difractógrafos, n.c.o.p.',90,9012);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901310,'Miras telescópicas para armas; periscópios; lunetas para máquinas, aparelhos ou instrumentos ópticos do presente capítulo ou da seção XVI','Telescopic sights for fitting to arms; periscopes; telescopes designed to form parts of machines, appliances, instruments or apparatus of chapter 90 or Section 16, chapters 84 and 85','Miras telescópicas para armas; periscopios; visores para máquinas, instrumentos o aparatos de este capítulo o de la sección XVI "capítulos 84 y 85"',90,9013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901320,'Lasers, exceto os diodos laser','Lasers (excl. laser diodes)','Láseres (exc. los diodos láser)',90,9013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901380,'Outros dispositivos de cristais líquidos e outros aparelhos e instrumentos ópticos','Liquid crystal devices, n.e.s. and other optical appliances and instruments not elsewhere specified in chapter 90','Dispositivos de cristal líquido, n.c.o.p. y los demás instrumentos e aparatos de óptica de este capítulo, n.c.o.p.',90,9013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901390,'Partes e acessórios de miras telescópicas, periscópios, lunetas, lasers e dispositivos de cristais líquidos','Parts and accessories for liquid crystal devices LCD, lasers and other appliances and instruments not elsewhere specified in chapter 90, n.e.s.','Partes y accesorios de dispositivos de cristal líquido "LCD", láseres y los demás instrumentos e aparatos de óptica de este capítulo, n.c.o.p.',90,9013);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901410,'Bússolas, incluídas as agulhas de marear','Direction finding compasses','Brújulas, incl. los compases de navegación',90,9014);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901420,'Instrumentos e aparelhos para navegação aérea ou espacial (exceto bússolas)','Instruments and appliances for aeronautical or space navigation (excl. compasses and radio navigational equipment)','Instrumentos y aparatos para navegación aérea o espacial (exc. brújulas y aparatos para radionavegación)',90,9014);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901480,'Outros aparelhos e instrumentos para navegação','Navigational instruments and apparatus (excl. for aeronautical or space navigation, compasses and radio navigational equipment)','Instrumentos y aparatos para navegación (exc. los destinados para la navegación aérea o espacial, brújulas y aparatos para radionavegación)',90,9014);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901490,'Partes e acessórios para instrumentos e aparelhos de navegação','Parts and accessories for compasses and other navigational instruments and appliances, n.e.s.','Partes y accesorios de brújulas u otros instrumentos y aparatos para navegación, n.c.o.p.',90,9014);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901510,'Telêmetros','Rangefinders','Telémetros',90,9015);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901520,'Teodolitos e taqueômetros','Theodolites and tachymeters tacheometers','Teodolitos y taquímetros',90,9015);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901530,'Níveis','Levels','Niveles',90,9015);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901540,'Instrumentos e aparelhos de fotogrametria','Photogrammetrical surveying instruments and appliances','Instrumentos y aparatos de fotogrametría',90,9015);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901580,'Outros instrumentos e aparelhos de geodésia, topografia, hidrografia, oceanografia, meteorologia ou de geofísica','Instruments and appliances used in geodesy, topography, hydrography, oceanography, hydrology, meteorology or geophysics (excl. compasses, rangefinders, theodolites, tachymeters tacheometers, levels and photogrammetrical surveying instruments and appliance','Instrumentos y aparatos de geodesia, topografía, agrimensura, nivelación, hidrografía, oceanografía, hidrología, meteorología o geofísica (exc. brújulas, telémetros, teodolitos, taquímetros, niveles e instrumentos y aparatos de fotogrametría)',90,9015);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901590,'Partes e acessórios de instrumentos e aparelhos de geodésia, topografia, hidrografia, oceanografia, meteorologia ou de geofísica','Parts and accessories for instruments and appliances used in geodesy, topography, photogrammetrical surveying, hydrography, oceanography, hydrology, meteorology or geophysics, and for rangefinders, n.e.s.','Partes y accesorios de instrumentos y aparatos de geodesia, topografía, agrimensura, nivelación, hidrografía, oceanografía, hidrología, meteorología y geofísica, así como de telémetros, n.c.o.p.',90,9015);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901600,'Balanças sensíveis a pesos <= 5 cg, com ou sem pesos','Balances of a sensitivity of 50 mg or better, with or without weights','Balanzas sensibles a un peso <= 50 mg, incl. con pesas',90,9016);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901710,'Mesas e máquinas de desenhar, mesmo automáticas','Drafting tables and machines, whether or not automatic (excl. units for automatic data-processing equipment)','Mesas y máquinas de dibujar, incl. automáticas (exc. unidades para máquinas automáticas de tratamiento de datos)',90,9017);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901720,'Outros instrumentos de desenho, de traçado ou de cálculo','Drawing, marking-out and mathematical calculating instruments (excl. drafting tables and machines and calculating machines)','Instrumentos de dibujo, trazado o cálculo (exc. mesas y máquinas de dibujar, así como calculadoras)',90,9017);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901730,'Micrômetros, paquímetros; calibres e semelhantes (instrumentos de medida de distância, de uso manual)','Micrometers, callipers and gauges (excl. gauges without adjustable devices of subheading 9031.80)','Micrómetros, pies de rey, calibradores y galgas (exc. galgas sin órganos regulables)',90,9017);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901780,'Outros instrumentos de medida de distâncias de uso manual','Instruments for measuring length, for use in the hand, n.e.s.','Instrumentos manuales de medida de longitud, n.c.o.p.',90,9017);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901790,'Partes e acessórios de instrumentos de desenho, cálculo ou de medida de distância de uso manual','Parts and accessories for drawing, marking-out or mathematical calculating instruments and instruments for measuring length for use in the hand, n.e.s.','Partes y accesorios de instrumentos de dibujo, trazado o cálculo e instrumentos manuales de medida de longitud, n.c.o.p.',90,9017);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901811,'Eletrocardiógrafos','Electro-cardiographs','Electrocardiógrafos',90,9018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901812,'Aparelhos de diagnóstico por varredura ultra-sônica (scanners)','Ultrasonic scanning apparatus','Aparatos de diagnóstico por exploración ultrasónica "scanners"',90,9018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901813,'Aparelhos de diagnóstico por visualização de ressonância magnética','Magnetic resonance imaging apparatus','Aparatos de diagnóstico de visualización por resonancia magnética',90,9018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901814,'Aparelhos de cintilografia','Scintigraphic apparatus','Aparatos de centellografía',90,9018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901819,'Outros aparelhos de eletrodiagnóstico','Electro-diagnostic apparatus, incl. apparatus for functional exploratory examination or for checking physiological parameters (excl. electro-cardiographs, ultrasonic scanning apparatus, magnetic resonance imaging apparatus and scintigraphic apparatus)','Aparatos de electrodiagnóstico, incl. los aparatos par exploración funcional o para vigilancia de parámetros fisiológicos (exc. electrocardiógrafos, aparatos de diagnóstico por exploración ultrasónica "scanners", aparatos de diagnóstico de visualización p',90,9018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901820,'Aparelhos de raios ultravioleta ou infravermelhos, para uso médico, cirúrgico, odontológico ou veterinário','Ultraviolet or infra-red ray apparatus used in medical, surgical, dental or veterinary sciences','Aparatos de rayos ultravioletas o infrarrojos para uso médico',90,9018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901831,'Seringas, mesmo com agulhas, para uso médico, cirúrgico, odontológico ou veterinário','Syringes, with or without needles, used in medical, surgical, dental or veterinary sciences','Jeringas, incl. con aguja, para uso médico',90,9018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901832,'Agulhas tubulares de metal e agulhas para suturas, para uso médico, cirúrgico, odontológico ou veterinário','Tubular metal needles and needles for sutures, used in medical, surgical, dental or veterinary sciences','Agujas tubulares de metal y agujas de sutura, para uso médico',90,9018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901839,'Outras agulhas, cateteres, sondas e semelhantes, para uso médico, cirúrgico, odontológico ou veterinário','Needles, catheters, cannulae and the like, used in medical, surgical, dental or veterinary sciences (excl. syringes, tubular metal needles and needles for sutures)','Agujas, catéteres, cánulas e instrumentos simil., para uso médico (exc. jeringas, agujas tubulares de metal y agujas de sutura)',90,9018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901841,'Aparelhos dentários de brocar, mesmo combinados com outros equipamentos dentários','Dental drill engines, whether or not combined on a single base with other dental equipment','Tornos dentales, incl. combinados con otros equipos dentales sobre basamento común',90,9018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901849,'Outros instrumentos e aparelhos para odontologia','Instruments and appliances used in dental sciences, n.e.s.','Instrumentos y aparatos de odontología, n.c.o.p.',90,9018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901850,'Outros instrumentos e aparelhos para oftalmologia','Ophthalmic instruments and appliances, n.e.s.','Instrumentos y aparatos de oftalmología, n.c.o.p.',90,9018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901890,'Outros instrumentos e aparelhos para medicina, cirurgia ou veterinária','Instruments and appliances used in medical, surgical or veterinary sciences, n.e.s.','Instrumentos y aparatos de medicina, cirugía o veterinaria, n.c.o.p.',90,9018);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901910,'Aparelhos de mecanoterapia, de massagem ou de psicotécnica','Mechano-therapy appliances; massage apparatus; psychological aptitude-testing apparatus','Aparatos de mecanoterapia, masajes y sicotecnia',90,9019);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (901920,'Aparelhos de ozonoterapia, de oxigenoterapia, de aerossolterapia e outros de terapia respiratória','Ozone therapy, oxygen therapy, aerosol therapy, artificial respiration or other therapeutic respiration apparatus','Aparatos de ozonoterapia, oxigenoterapia y aerosolterapia, aparatos respiratorios de reanimación y demás aparatos de terapia respiratoria',90,9019);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902000,'Outros aparelhos respiratórios e máscaras contra gases, exceto as de proteção desprovidas de mecanismo e de elemento filtrante amovível','Breathing appliances and gas masks (excl. protective masks having neither mechanical parts nor replaceable filters, and artificial respiration or other therapeutic respiration apparatus)','Aparatos respiratorios y máscaras antigás (exc. máscaras de protección sin mecanismo ni elemento filtrante amovibles, así como aparatos respiratorios de reanimación y demás aparatos de terapia respiratoria)',90,9020);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902110,'Artigos e aparelhos ortopédicos ou para fraturas, inclusive partes e acessórios','Orthopaedic or fracture appliances','Artículos y aparatos de ortopedia o para fracturas',90,9021);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902111,'Próteses articulares','Artificial joints','Articulaciones artificiales',90,9021);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902119,'Artigos e aparelhos ortopédicos e para fraturas','Orthopedic devices and materials for  fractures','Dispositivos ortopédicos y materiales para fracturas',90,9021);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902121,'Dentes artificiais','Artificial teeth','Dientes artificiales',90,9021);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902129,'Outros artigos e aparelhos de prótese dentária','Dental fittings (excl. artificial teeth)','Artículos y aparatos de prótesis dental (exc. dientes)',90,9021);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902130,'Outros artigos e aparelhos de prótese','Other articles and prosthetic devices','Otros artículos y dispositivos protésicos',90,9021);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902131,'Próteses articulares','Artificial joints for orthopaedic purposes','Prótesis ortopédicas articulares',90,9021);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902139,'Válvulas cardíacas, lentes intra-oculares e outros artigos e aparelhos de prótese, inclusive partes e acessórios','Artificial parts of the body (excl. artificial teeth and dental fittings and artificial joints)','Artículos y aparatos de prótesis (exc. prótesis dentales y articulares)',90,9021);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902140,'Aparelhos para facilitar a audição dos surdos, exceto as partes e acessórios','Hearing aids (excl. parts and accessories)','Audífonos (exc. sus partes y accesorios)',90,9021);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902150,'Marca-passos (estimuladores) cardíacos, exceto as partes e acessórios','Pacemakers for stimulating heart muscles (excl. parts and accessories)','Estimuladores cardíacos (exc. sus partes y accesorios)',90,9021);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902190,'Outros aparelhos transportados à mão ou sobre as pessoas ou implantados no organismo para compensar deficiências','Articles and appliances, which are worn or carried, or implanted in the body, to compensate for a defect or disability (excl. artificial parts of the body, complete hearing aids and complete pacemakers for stimulating heart muscles)','Aparatos que lleve la propia persona o se le implanten para compensar un defecto o incapacidad (exc. artículos y aparatos de prótesis, así como audífonos y estimuladores cardíacos, completos)',90,9021);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902212,'Aparelhos de tomografia computadorizada','Computer tomography apparatus','Aparatos de tomografía regidos por una máquina automática de tratamiento o procesamiento de datos',90,9022);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902213,'Aparelhos baseados no uso de raios X, para uso odontológico','Apparatus based on the use of X-rays for dental uses','Aparatos de rayos X para uso odontológico',90,9022);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902214,'Aparelhos baseados no uso de raios X, para usos médicos, cirúrgicos ou veterinários','Apparatus based on the use of X-rays, for medical, surgical or veterinary uses (excl. for dental purposes and computer tomography apparatus)','Aparatos de rayos X y aparatos para uso médico, quirúrgico o veterinario (exc. para uso odontológico, así como aparatos de tomografía regidos por una máquina automática de tratamiento o procesamiento de datos)',90,9022);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902219,'Aparelhos de raios X, de radiofotografia ou de radioterapia, para outros usos','Apparatus based on the use of X-rays (other than for medical, surgical, dental or veterinary uses)','Aparatos de rayos X (exc. para uso médico, quirúrgico, odontológico o veterinario)',90,9022);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902221,'Aparelhos de radiação alfa, beta, gama, para usos médicos, cirúrgicos, odontológicos ou veterinários','Apparatus based on the use of alpha, beta or gamma radiations, for medical, surgical, dental or veterinary uses','Aparatos que utilicen radiaciones alfa, beta o gamma, para uso médico, quirúrgico, odontológico o veterinario',90,9022);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902229,'Aparelhos de radiação alfa, beta, gama, para outros usos','Apparatus based on the use of alpha, beta or gamma radiations (other than for medical, surgical, dental or veterinary uses)','Aparatos que utilicen radiaciones alfa, beta o gamma (exc. para uso médico, quirúrgico, odontológico o veterinario)',90,9022);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902230,'Tubos de raios X','X-ray tubes','Tubos de rayos X',90,9022);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902290,'Outros dispositivos geradores de raios X, mesas de comando, telas de visualização e partes e acessórios da posição 9022','X-ray generators other than X-ray tubes, high tension generators, control panels and desks, screens, examination or treatment tables, chairs and the like, and general parts and accessories for apparatus of heading 9022, n.e.s.','Dispositivos generadores de rayos X, generadores de tensión, consolas de mando, pantallas, mesas, sillones y soportes simil. para examen o tratamiento, sus partes y accesorios en general, n.c.o.p. (exc. tubos de rayos X)',90,9022);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902300,'Instrumentos, aparelhos e modelos, para demonstração (ensino, exposições) não suscetíveis de outros usos','Instruments, apparatus and models designed for demonstrational purposes, e.g. in education or exhibitions, unsuitable for other uses (excl. ground flying trainers of heading 8805, collectors'' pieces of heading 9705 and antiques of an age > 100 years of h','Instrumentos, aparatos y modelos, concebidos para demostraciones "p.ej. en la enseñanza o exposiciones", no susceptibles de otros usos (exc. aparatos de entrenamiento de vuelo, piezas de colección y antigüedades de más de 100 años)',90,9023);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902410,'Máquinas e aparelhos para ensaios de metais','Machines and appliances for testing metals','Máquinas y aparatos para ensayo de dureza, tracción, compresión, elasticidad u otras propiedades mecánicas de metales',90,9024);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902480,'Outras máquinas e aparelhos para ensaios de propriedades mecânicas (dureza, tração, elasticidade) de materiais','Machines and appliances for testing the mechanical properties of materials (excl. metals)','Máquinas y aparatos para ensayo de las propiedades mecánicas de materiales (exc. de metales)',90,9024);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902490,'Partes e acessórios de máquinas e aparelhos para ensaios de propriedades mecânicas de materiais','Parts and accessories for machines and appliances for testing the mechanical properties of materials, n.e.s.','Partes y accesorios de máquinas y aparatos no electrónicos para ensayo de las propiedades mecánicas de materiales, n.c.o.p.',90,9024);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902511,'Termômetros e pirômetros, de líquido, de leitura direta, não combinados com outros instrumentos','Thermometers, liquid-filled, for direct reading, not combined with other instruments','Termómetros de líquido con lectura directa, sin combinar con otros instrumentos',90,9025);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902519,'Outros termômetros e pirômetros, não combinados com outros instrumentos','Thermometers and pyrometers, not combined with other instruments (excl. liquid-filled thermometers for direct reading)','Termómetros y pirómetros, sin combinar con otros instrumentos (exc. termómetros de líquido con lectura directa)',90,9025);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902580,'Densímetros, areômetros, higrômetros e outros instrumentos semelhantes','Hydrometers, areometers and similar floating instruments, barometers, hygrometers and psychrometers, whether or not combined with each other or with thermometers','Densímetros, areómetros, pesalíquidos e instrumentos flotantes simil., barómetros, higrómetros y sicrómetros, incl. combinados entre sí o con termómetros',90,9025);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902590,'Partes e acessórios de termômetros e outros instrumentos da posição 9025','Parts and accessories for hydrometers, areometers and similar floating instruments, thermometers, pyrometers, barometers, hygrometers and psychrometers, n.e.s.','Partes y accesorios de densímetros, areómetros, pesalíquidos e instrumentos flotantes simil., termómetros, pirómetros, barómetros, higrómetros y sicrómetros, n.c.o.p.',90,9025);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902610,'Instrumentos e aparelhos para medida ou controle de vazão (caudal) ou do nível dos líquidos','Instruments and apparatus for measuring or checking the flow or level of liquids (excl. meters and regulators)','Instrumentos y aparatos para medida o control del caudal o nivel de líquidos (exc. contadores y reguladores)',90,9026);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902620,'Instrumentos e aparelhos para medida ou controle da pressão dos líquidos ou gases','Instruments and apparatus for measuring or checking pressure of liquids or gases (excl. regulators)','Instrumentos y aparatos para medida o control de presión de líquidos o gases (exc. reguladores)',90,9026);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902680,'Outros instrumentos e aparelhos para medida ou controle de líquidos ou gases','Instruments or apparatus for measuring or checking variables of liquids or gases, n.e.s.','Instrumentos y aparatos para medida o control de las características variables de líquidos o gases, n.c.o.p.',90,9026);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902690,'Partes e acessórios para instrumentos e aparelhos para medida ou controle de líquidos ou gases','Parts and accessories for instruments and apparatus for measuring or checking the flow, level, pressure or other variables of liquids or gases, n.e.s.','Partes y accesorios de instrumentos y aparatos para medida o control del caudal, nivel, presión u otras características variables de líquidos o gases, n.c.o.p.',90,9026);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902710,'Analisadores de gases ou de fumaça (fumo)','Gas or smoke analysis apparatus','Analizadores de gases o humos',90,9027);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902720,'Cromatógrafos e aparelhos de eletroforese','Chromatographs and electrophoresis instruments','Cromatógrafos y aparatos de electroforesis',90,9027);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902730,'Espectrômetros, espectrofotômetros e espectrógrafos que utilizem radiações ópticas (UV, visíveis, IV)','Spectrometers, spectrophotometers and spectrographs using optical radiations, such as UV, visible, IR','Espectrómetros, espectrofotómetros y espectrógrafos que utilicen radiaciones ópticas "UV, visibles, IR"',90,9027);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902740,'indicadores de tempo de exposição','exposure meters','exposímetros',90,9027);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902750,'Outros aparelhos e instrumentos para análises físicas ou químicas que utilizem radiações ópticas (uv, visíveis, iv)','Instruments and apparatus for physical or chemical analysis, using UV, visible or IR optical radiations (excl. spectrometers, spectrophotometers, spectrographs, and gas or smoke analysis apparatus)','Instrumentos y aparatos para análisis físicos o químicos que utilicen radiaciones ópticas "UV, visibles, IR" (exc. espectrómetros, espectrofotómetros y espectrógrafos, así como analizadores de gases o humos)',90,9027);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902780,'Outros instrumentos e aparelhos para análises físicas ou químicas, para ensaios de viscosidade porosidade, tensão superficial ou semelhantes, ou para medidas calorimétricas, acústicas ou fotométricas (incluídos os indicadores de tempo de exposição)','Instruments and apparatus for physical or chemical analysis, or for measuring or checking viscosity, porosity, expansion, surface tension or the like, or for measuring or checking quantities of heat, sound or light, n.e.s.','Instrumentos y aparatos para análisis físicos o químicos, para ensayo de viscosidad, porosidad, dilatación, tensión superficial o simil. o para medidas calorimétricas, acústicas o fotométricas, n.c.o.p.',90,9027);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902790,'Micrótomos; partes e acessórios de polarógrafos, espectrômetros, espectrógrafos e outros instrumentos e aparelhos para análises físicas ou químicas','Microtomes; parts and accessories of instruments and apparatus for physical or chemical analysis, instruments and apparatus for measuring or checking viscosity, porosity, expansion, surface tension or the like, instruments and apparatus for measuring or c','Micrótomos, sus partes y accesorios; partes y accesorios de polarímetros, refractómetros, espectrómetros y demás instrumentos y aparatos para análisis físicos o químicos; partes de instrumentos y aparatos para ensayo de viscosidad, porosidad, dilatación, ',90,9027);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902810,'Contadores de gases','Gas meters, incl. calibrating meters therefor','Contadores de gas, incl. los de calibración',90,9028);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902820,'Contadores de líquidos','Liquid meters, incl. calibrating meters therefor','Contadores de líquido, incl. los de calibración',90,9028);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902830,'Contadores de eletricidade','Electricity supply or production meters, incl. calibrating meters therefor','Contadores de electricidad, incl. los de calibración',90,9028);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902890,'Partes e acessórios para contadores de gases, líquidos ou de eletricidade','Parts and accessories for gas, liquid or electricity supply or production meters, n.e.s.','Partes y accesorios de contadores de gas, líquido o electricidad, n.c.o.p.',90,9028);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902910,'Contadores de voltas ou de produção, taxímetros, podômetros e contadores semelhantes','Revolution counters, production counters, taximeters, milometers, pedometers and the like (excl. gas, liquid and electricity meters)','Cuentarrevoluciones, contadores de producción, taxímetros, cuentakilómetros, podómetros y demás contadores (exc. de gas, líquido o electricidad)',90,9029);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902920,'Indicadores de velocidade e tacômetros; estroboscópios','Speed indicators and tachometers, stroboscopes','Velocímetros y tacómetros; estroboscopios',90,9029);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (902990,'Partes e acessórios para instrumentos da posição 9029','Parts and accessories for revolution counters, production counters, taximeters, milometers, pedometers and the like, speed indicators and tachometers, and stroboscopes, n.e.s.','Partes y accesorios de cuentarrevoluciones, contadores de producción, taxímetros, cuentakilómetros, podómetros y demás contadores, velocímetros, tacómetros, estroboscopios, n.c.o.p.',90,9029);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903010,'Instrumentos e aparelhos para medida ou detecção de radiações ionizantes','Instruments and apparatus for measuring or detecting ionising radiations','Instrumentos y aparatos para medida o detección de radiaciones ionizantes',90,9030);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903020,'Osciloscópios e oscilógrafos, catódicos','Oscilloscopes and oscillographs','Osciloscopios y oscilógrafos catódicos',90,9030);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903031,'Multímetros, sem dispositivo registrador','Multimeters for voltage, current, resistance or electrical power, without recording device','Multímetros para medida de tensión, intensidad, resistencia o potencia eléctricas, sin dispositivo registrador',90,9030);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903032,'Multímetros, com dispositivo registrador','Multimeters with recording device',' Multímetros, con dispositivo registrador',90,9030);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903033,'Outros aparelhos e instrumentos para medida ou controle da tensão, intensidade, resistência ou potência, sem dispositivo registrador','Instruments and apparatus for measuring or checking voltage, current, resistance or electrical power, without recording device (excl. multimeters, and oscilloscopes and oscillographs)','Instrumentos y aparatos para la medida o control de la tensión, intensidad, resistencia o potencia, sin registrador (exc. los multímetros así como los osciloscopios y oscilógrafos)',90,9030);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903039,'Outros aparelhos e instrumentos para medida ou controle da tensão, intensidade, resistência ou potência, com dispositivo registrador','Instruments and apparatus for measuring or checking voltage, current, resistance or electrical power, with recording device (excl. multimeters, and oscilloscopes and oscillographs)','Instrumentos y aparatos para medida de tensión, intensidad, resistencia o potencia eléctricas, sin dispositivo registrador (exc. multímetros y osciloscopios y oscilógrafos catódicos)',90,9030);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903040,'Instrumentos e aparelhos, especialmente concebidos para telecomunicação','Instruments and apparatus for measuring or checking electrical quantities, specifically for telecommunications, e.g. cross-talk meters, gain measuring instruments, distortion factor meters, psophometers','Hipsómetros, kerdómetros, distorsiómetros, sofómetros y demás instrumentos y aparatos para medida o control de magnitudes eléctricas, especialmente concebidos para las técnicas de telecomunicación',90,9030);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903082,'Instrumentos e aparelhos para medida ou controle de discos (wafers) ou de dispositivos semicondutores','Instruments and apparatus for measuring or checking semiconductor wafers or devices','Instrumentos y aparatos para medida o control de obleas "wafers" o dispositivos, semiconductores',90,9030);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903083,'Aparelhos de testes de circuito impresso','Apparatus for testing printed circuit','Aparato para el ensayo de circuito impreso',90,9030);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903084,'Outros instrumentos e aparelhos, com dispositivo registrador','Instruments and appliances for measuring or checking electrical quantities, with recording device (excl. appliances specially designed for telecommunications, multimeters, oscilloscopes and oscillographs, and apparatus for measuring or checking semiconduc','Instrumentos y aparatos para la medida o control de magnitudes eléctricas, con dispositivo registrador (exc. los instrumentos y aparatos especialmente concebidos para las técnicas de telecomunicación, multímetros, osciloscopios y oscilógrafos así como par',90,9030);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903089,'Outros instrumentos e aparelhos para medida ou verificação de tensão, intensidade, resistência e potência de grandezas elétricas','Instruments and apparatus for measuring or checking electrical quantities, without recording device, n.e.s.','Instrumentos y aparatos para medida o control de magnitudes eléctricas, sin dispositivo registrador, n.c.o.p.',90,9030);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903090,'Partes e acessórios para instrumentos e aparelhos das subposições 9030.10/31/39/82/83','Parts and accessories for instruments and apparatus for measuring or checking electrical quantities or for detecting ionising radiations, n.e.s.','Partes y accesorios de instrumentos y aparatos para medida o control de magnitudes eléctricas o para medida o detección de radiaciones ionizantes, n.c.o.p.',90,9030);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903110,'Máquinas de equilibrar peças mecânicas','Machines for balancing mechanical parts','Máquinas para equilibrar piezas mecánicas',90,9031);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903120,'Bancos de ensaio','Test benches for motors, generators, pumps, etc.','Bancos de pruebas para motores, generadores, bombas, etc.',90,9031);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903130,'Projetores de perfis','Profile projectors','Proyectores de perfiles',90,9031);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903141,'Instrumentos e aparelhos ópticos, para controle de discos (wafers) ou de dispositivos semicondutores ou para controle de máscaras ou retículas utilizadas na fabricação de dispositivos semicondutores','Optical instruments and appliances for inspecting semiconductor wafers or devices or for inspecting photomasks or reticles used in manufacturing semiconductor devices','Instrumentos, máquinas y aparatos ópticos, para control de obleas "wafers" o dispositivos, semiconductores o para control de máscaras o retículas utilizadas en la fabricación de dispositivos semiconductores',90,9031);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903149,'Outros instrumentos e aparelhos ópticos','Optical instruments, appliances and machines for measuring or checking, not elsewhere specified or included in chapter 90','Instrumentos, máquinas y aparatos ópticos para medida o control, n.c.o.p. del capítulo 90',90,9031);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903180,'Outros instrumentos, aparelhos e máquinas de medida ou controle','Instruments, appliances and machines for measuring or checking, not elsewhere specified in chapter 90 (excl. optical)','Instrumentos, máquinas y aparatos, no ópticos, para medida o control, n.c.o.p. de este capítulo',90,9031);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903190,'Partes e acessórios para instrumentos e aparelhos de medida ou controle','Parts and accessories for instruments, appliances and machines for measuring and checking, n.e.s.','Partes y accesorios de instrumentos, máquinas y aparatos para medida o control, n.c.o.p.',90,9031);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903210,'Termostatos automáticos','Thermostats','Termostatos para regulación o control',90,9032);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903220,'Manostatos automáticos (pressostatos)','Manostats (excl. taps, cocks and valves of heading 8481)','Manostatos "presostatos" (exc. artículos y órganos de la partida 8481)',90,9032);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903281,'Instrumentos e aparelhos hidráulicos ou pneumáticos, para regulação ou controle, automáticos','Hydraulic or pneumatic regulating or controlling instruments and apparatus (excl. manostats and taps, cocks and valves of heading 8481)','Instrumentos y aparatos para regulación o control, hidráulicos o neumáticos (exc. manostatos y artículos y órganos de la partida 8481)',90,9032);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903289,'Outros instrumentos e aparelhos para regulação ou controle, automáticos','Regulating or controlling instruments and apparatus (excl. hydraulic or pneumatic, manostats, thermostats, and taps, cocks and valves of heading 8481)','Instrumentos y aparatos para regulación o control (exc. los hidráulicos o neumáticos, manostatos, termostatos y artículos y órganos de la partida 8481)',90,9032);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903290,'Partes e acessórios para instrumentos e aparelhos para regulação ou controle, automáticos','Parts and accessories for regulating or controlling instruments and apparatus, n.e.s.','Partes y accesorios de instrumentos y aparatos para regulación o control, n.c.o.p.',90,9032);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (903300,'Partes e acessórios para máquinas, aparelhos e instrumentos ou artigos do capítulo 90','Parts and accessories for machines, appliances, instruments or other apparatus in chapter 90, specified neither in this chapter nor elsewhere','Partes y accesorios para máquinas, aparatos, instrumentos o artículos de este capítulo, n.c.o.p.',90,9033);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910111,'Relógio de pulso, funcionando eletricamente, com caixa de metais preciosos folheados ou chapeados, de mostrador exclusivamente mecânico','Wrist-watches of precious metal or of metal clad with precious metal, whether or not incorporating a stop-watch facility, electrically operated, with mechanical display only (excl. with backs made of steel)','Relojes de pulsera, eléctricos, incl. con contador de tiempo incorporado, de metal precioso o chapado de metal precioso "plaqué", con indicador mecánico solamente (exc. con fondo de acero)',91,9101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910112,'Relógio de pulso, cx.met.prec.func.eletr.mostr.optoeletr','Wrist watches, battery powered, with opto-electronic display only','Relojes de pulsera, pilas, con indicador optoelectrónico solamente',91,9101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910119,'Outros relógios de pulso, funcionando eletricamente, com caixa de metais preciosos folheados ou chapeados','Wrist-watches of precious metal or of metal clad with precious metal, whether or not incorporating a stop-watch facility, electrically operated, with opto-electronic display and with combined mechanical and opto-electronic display (excl. with backs made o','Relojes de pulsera, eléctricos, incl. con contador de tiempo incorporado, de metal precioso o chapado de metal precioso "plaqué", con indicador combinado, mecánico y optoelectrónico (exc. con fondo de acero)',91,9101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910121,'Relógios de pulso, com caixa de metais preciosos folheados ou chapeados, de corda automática','Wrist-watches of precious metal or of metal clad with precious metal, whether or not incorporating a stop-watch facility, with automatic winding (excl. with backs made of steel)','Relojes de pulsera de metal precioso o chapado de metal precioso "plaqué", automáticos (exc. con fondo de acero)',91,9101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910129,'Outros relógios de pulso, com caixa de metais preciosos folheados ou chapeados, operado manualmente','Wrist-watches of precious metal or of metal clad with precious metal, whether or not incorporating a stop-watch facility, with hand winding only (excl. with backs made of steel)','Relojes de pulsera de metal precioso o chapado de metal precioso "plaqué", de mano (exc. con fondo de acero)',91,9101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910191,'Relógios de bolso e semelhantes, com caixa de metais preciosos folheados ou chapeados, funcionando eletricamente','Pocket-watches and the like, incl. stop-watches, of precious metal or of metal clad with precious metal, electrically operated (excl. with backs made of steel and wrist-watches)','Relojes de bolsillo y relojes simil., incl. los contadores de tiempo de los mismos tipos, eléctricos, con caja de metal precioso o chapado de metal precioso "plaqué" (exc. con fondo de acero, así como relojes de pulsera)',91,9101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910199,'Outros relógios de bolso e semelhantes, com caixa de metais preciosos folheados ou chapeados, com corda manual ou automática','Pocket-watches and the like, incl. stop-watches, of precious metal or of metal clad with precious metal, with hand or automatic winding (excl. with backs made of steel and wrist-watches)','Relojes de bolsillo y relojes simil., incl. los contadores de tiempo de los mismos tipos, con caja de metal precioso o chapado de metal precioso "plaqué", de mano o automáticos (exc. con fondo de acero, así como relojes de pulsera)',91,9101);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910211,'Relógios de pulso, funcionando eletricamente, de mostrador exclusivamente mecânico','Wrist-watches, whether or not incorporating a stop-watch facility, electrically operated, with mechanical display only (excl. of precious metal or of metal clad with precious metal)','Relojes de pulsera, eléctricos, incl. con contador de tiempo incorporado, con indicador mecánico solamente (exc. con caja de metal precioso o chapado de metal precioso "plaqué")',91,9102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910212,'Relógios de pulso, funcionando eletricamente, de mostrador exclusivamente opto-eletrônico','Wrist-watches, whether or not incorporating a stop-watch facility, electrically operated, with opto-electronic display only (excl. of precious metal or of metal clad with precious metal)','Relojes de pulsera, eléctricos, incl. con contador de tiempo incorporado, con indicador optoelectrónico solamente (exc. con caja de metal precioso o chapado de metal precioso "plaqué")',91,9102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910219,'Outros relógios de pulso, funcionando eletricamente','Wrist-watches, whether or not incorporating a stop-watch facility, electrically operated, with combined mechanical and opto-electronic display (excl. of precious metal or of metal clad with precious metal)','Relojes de pulsera, eléctricos, incl. con contador de tiempo incorporado, con indicador combinado mecánico y optoelectrónico (exc. con caja de metal precioso o chapado de metal precioso "plaqué")',91,9102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910221,'Outros relógio de pulso, de corda automática','Wrist-watches, whether or not incorporating a stop-watch facility, with automatic winding (excl. of precious metal or of metal clad with precious metal)','Relojes de pulsera automáticos, incl. con contador de tiempo incorporado (exc. con caja de metal precioso o chapado de metal precioso "plaqué")',91,9102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910229,'Outros relógios de pulso, operados apenas manualmente','Wrist-watches, whether or not incorporating a stop-watch facility, with hand winding only (excl. of precious metal or of metal clad with precious metal)','Relojes de pulsera manuales, incl. con contador de tiempo incorporado (exc. con caja de metal precioso o chapado de metal precioso "plaqué")',91,9102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910291,'Outros relógios de bolso e semelhantes, funcionando eletricamente','Pocket-watches and the like, incl. stop-watches, electrically operated (excl. of precious metal or of metal clad with precious metal)','Relojes de bolsillo y simil., incl. los contadores de tiempo de los mismos tipos, eléctricos (exc. con caja de metal precioso o chapado de metal precioso "plaqué")',91,9102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910299,'Outros relógios de bolso e semelhantes','Pocket-watches and the like, incl. stop-watches, with hand or automatic winding (excl. of precious metal or of metal clad with precious metal)','Relojes de bolsillo y simil., incl. los contadores de tiempo de los mismos tipos, manuales o automáticos (exc. con caja de metal precioso o chapado de metal precioso "plaqué")',91,9102);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910310,'Despertadores e outros relógios, com maquinismo de pequeno volume, funcionando eletricamente','Clocks with watch movements, electrically operated (excl. wrist-watches, pocket-watches and other watches of heading 9101 or 9102, and instrument panel clocks and the like of heading 9104)','Despertadores y demás relojes de pequeño mecanismo de relojería, eléctricos (exc. relojes de pulsera, bolsillo y relojes simil. de las partidas 9101 ó 9102, así como relojes de tablero de instrumentos y relojes simil. de la partida 9104)',91,9103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910390,'Outros despertadores e outros relógios, com maquinismo de pequeno volume','Clocks with watch movements (excl. electrically operated, wrist-watches, pocket-watches and other watches of heading 9101 or 9102, and instrument panel clocks and the like of heading 9104)','Despertadores y demás relojes de pequeño mecanismo de relojería, distintos de los eléctricos (exc. relojes de pulsera, bolsillo y relojes simil. de las partidas 9101 ó 9102, así como relojes de tablero de instrumentos y relojes simil. de la partida 9104)',91,9103);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910400,'Relógios para painéis de instrumentos e relógios semelhantes para automóveis, veículos aéreos, embarcações ou outros veículos','Instrument panel clocks and clocks of a similar type for vehicles, aircraft, vessels and other vehicles','Relojes de tablero de instrumentos y relojes simil., para automóviles, aeronaves, barcos o demás vehículos',91,9104);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910511,'Outros despertadores, funcionando eletricamente, exceto com maquinismo de pequeno volume','Alarm clocks, electrically operated','Despertadores eléctricos',91,9105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910519,'Outros despertadores, exceto com maquinismo de pequeno volume','Alarm clocks (excl. electrically operated)','Despertadores (exc. eléctricos)',91,9105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910521,'Pêndulas e relógios de parede, funcionando eletricamente, exceto com maquinismo de pequeno volume','Wall clocks, electrically operated','Relojes de pared, eléctricos',91,9105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910529,'Outras pêndulas e relógios de parede, exceto com maquinismo de pequeno volume','Wall clocks (excl. electrically operated)','Relojes de pared (exc. eléctricos)',91,9105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910591,'Outros aparelhos de relojoaria, funcionando eletricamente, exceto com maquinismo de pequeno volume','Clocks, electrically operated (excl. wrist-watches, pocket-watches and other watches of heading 9101 or 9102, clocks with watch movements of heading 9103, instrument panel clocks and the like of heading 9104, alarm clocks and wall clocks)','Relojes eléctricos (exc. relojes de pulsera, bolsillo y relojes simil. de las partidas 9101 ó 9102, así como relojes de tablero de instrumentos y relojes simil. de la partida 9104, los despertadores y los relojes de pared)',91,9105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910599,'Outros aparelhos de relojoaria, exceto com maquinismo de pequeno volume','Clocks (excl. electrically operated, wrist-watches, pocket-watches and other watches of heading 9101 or 9102, clocks with watch movements of heading 9103, instrument panel clocks and the like of heading 9104, alarm clocks and wall clocks)','Relojes (exc. eléctricos, así como los relojes de pulsera, bolsillo y relojes simil. de las partidas 9101 ó 9102, los relojes de tablero de instrumentos y relojes simil. de la partida 9104, los despertadores y los relojes de pared)',91,9105);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910610,'Relógios de ponto; relógios datadores e contadores de horas','Time registers and time recorders','Registradores de asistencia; registradores fechadores y registradores contadores',91,9106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910620,'Parquímetros','Parking meters','Parquímetros',91,9106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910690,'Outros aparelhos de controle de tempo e contadores de tempo, com maquinismo de aparelhos de relojoaria ou com motor síncrono','Time of day recording apparatus and apparatus for measuring, recording or otherwise indicating intervals of time, with clock or watch movement or with synchronous motor (excl. clocks of heading 9101 to 9105, time registers and time recorders)','Aparatos de control de tiempo y contadores de tiempo, con mecanismo de relojería o motor sincrónico (exc. relojes de las partidas 9101 a 9105, registradores de asistencia, registradores fechadores, registradores contadores y parquímetros)',91,9106);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910700,'Interruptores horários e outros aparelhos que permitam acionar um mecanismo em tempo determinado, com maquinismo de aparelhos de relojoaria ou de motor síncrono','Time switches with clock or watch movement or with synchronous motor','Interruptores horarios y demás aparatos que permitan accionar un dispositivo en un momento dado, con mecanismo de relojería o motor sincrónico',91,9107);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910811,'Maquinismos de pequeno volume para relógios, completos e montados, funcionando eletricamente, de mostrador mecânico','Watch movements, complete and assembled, electrically operated, with mechanical display only or with a device to which a mechanical display can be incorporated','Pequeños mecanismos de relojería completos y montados, eléctricos, con indicador mecánico solamente o con dispositivo que permita incorporarlo',91,9108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910812,'Maquinismos de pequeno volume para relógios, completos e montados, funcionando eletricamente, de mostrador opto-eletrônico','Watch movements, complete and assembled, electrically operated, with opto-electronic display only','Pequeños mecanismos de relojería completos y montados, eléctricos, con indicador optoelectrónico solamente',91,9108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910819,'Outros maquinismos de pequeno volume para relógios, completos e montados, funcionando eletricamente','Watch movements, complete and assembled, electrically operated, with combined opto-electronic and mechanical display, whether or not with dial and hands','Pequeños mecanismos de relojería completos y montados, eléctricos, con indicador combinado mecánico, incl. sin esfera ni agujas, y optoelectrónico',91,9108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910820,'Maquinismos de pequeno volume para relógios, completos e montados, de corda automática','Watch movements, complete and assembled, with automatic winding','Pequeños mecanismos de relojería completos y montados, automáticos',91,9108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910890,'Maquinismos de pequeno volume para relógios, completos e montados, manuais','Watch movements, complete and assembled, with hand winding only','Pequeños mecanismos de relojería completos y montados, manuales',91,9108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910891,'Outros maquinismos montados med<=33.8mm, p/outs.relógios','Oth.watch movements meas.<=33.8mm,f/oth.watches','Los dem.mecanismos montados q.mid<=33.8mm, p/dem.relojes',91,9108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910899,'Outs.maquinismos montados peq.vol.compl.p/outs.relógios','Oth.watch movements, assembled for other watches','Los dem.mecanismos montados peq.vol.compl.p/dem.relojes',91,9108);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910910,'Maquinismo de art.relojoaria, funcionando eletricamente','Machinery of clocks and watches, electrically operated','Maquinaria de relojes, accionamiento eléctrico',91,9109);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910911,'Maquinismos para despertadores, completos e montados, funcionando eletricamente','Clock movements of alarm clocks, complete and assembled, electrically operated, for alarm clocks (excl. watch movements)','Mecanismos de relojería completos y montados, eléctricos, de despertadores (exc. pequeños mecanismos)',91,9109);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910919,'Maquinismos para relógios, exceto os de pequeno volume e para despertadores, completos e montados, funcionando eletricamente','Clock movements, complete and assembled, electrically operated (excl. alarm clocks and watch movements)','Mecanismos de relojería completos y montados, eléctricos (exc. de despertadores, así como pequeños mecanismos)',91,9109);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (910990,'Outros maquinismos de relojoaria, completos e montados, exceto os de pequeno volume','Clock movements, complete and assembled (excl. electrically operated and watch movements)','Mecanismos de relojería completos y montados (exc. eléctricos, así como los pequeños mecanismos)',91,9109);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911011,'Maquinismos completos, não montados ou parcialmente montados (chablons), para relógios de pequeno volume','Complete watch movements, unassembled or partly assembled movement sets','Pequeños mecanismos completos, sin montar o parcialmente montados "chablons"',91,9110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911012,'Maquinismos incompletos, montados, para aparelhos de relojoaria, de pequeno volume','Incomplete watch movements, assembled','Pequeños mecanismos completos y montados',91,9110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911019,'Esboços de maquinismos para aparelhos de relojoaria, de pequeno volume','Rough clock movements','Mecanismos en blanco "ébauches"',91,9110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911090,'Maquinismos de aparelhos de relojoaria, completos, não montados, exceto de pequeno volume','Complete, unassembled or partly assembled clock movements movement sets','Mecanismos de relojería completos, sin montar o parcialmente montados "chablons", así como mecanismos de relojería incompletos, montados (exc. mecanismos de relojería en blanco "ébauches")',91,9110);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911110,'Caixas de metais preciosos ou de metais folheados ou chapeados, para relógios de pulso e de bolso','Cases for wrist-watches, pocket-watches and other watches of heading 9101 or 9102, of precious metal or of metal clad with precious metal','Cajas de relojes de pulsera, bolsillo y relojes simil., de metal precioso o chapado de metal precioso "plaqué"',91,9111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911120,'Caixas de metais comuns, mesmo dourados ou prateados, para relógios de pulso e de bolso','Cases for wrist-watches, pocket-watches and other watches of heading 9101 or 9102, of base metal, whether or not gold- or silver-plated','Cajas de relojes de pulsera, bolsillo y relojes simil., de metal común, incl. dorado o plateado',91,9111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911180,'Caixas de outros materiais, para relógios de pulso e de bolso','Cases for wrist-watches, pocket-watches and other watches of heading 9101 or 9102, of materials other than precious metal, clad with precious metal or base metal','Cajas de relojes de pulsera, bolsillo y relojes simil., de materiales distintos de metal precioso, chapado de metal precioso "plaqué" y metal común',91,9111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911190,'Partes para caixas de relógio de pulso e de bolso','Parts of cases for wrist-watches, pocket-watches and other watches of heading 9101 or 9102, n.e.s.','Partes de cajas de relojes de pulsera, bolsillo y relojes simil., n.c.o.p.',91,9111);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911210,'Caixas e semelh.p/aparelhos de relojoaria, de metal','Cases and similar f/watch apparatus,of metal','Cajas y simil.p/mecanismos de relojería, de metal',91,9112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911220,'Caixas e semelhantes de aparelhos de relojoaria','Clock and watch cases (excl. for wrist-watches, pocket-watches and other watches of heading 9101 or 9102)','Cajas y envolturas similares para aparatos de relojería (exc. para relojes de pulsera, bolsillo y similares)',91,9112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911280,'Caixas e semelh.p/apars.de relojoaria, de outs.matérias','Cases and similar f/watch apparatus,of other material','Cajas y simil.p/mecan.de relojería, de dem.materias',91,9112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911290,'Partes para caixas e semelhantes de aparelhos de relojoaria','Parts of clock and watch cases, n.e.s. (excl. for wrist-watches, pocket-watches and other watches of heading 9101 or 9102)','Partes de cajas y envolturas simil. para aparatos de relojería distintos de los relojes de pulsera, bolsillo y simil., n.c.o.p.',91,9112);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911310,'Pulseiras de relógios, e suas partes, de metais preciosos ou de metais folheados ou chapeados de metais preciosos','Watch straps, watch bands and watch bracelets, and parts thereof, of precious metal or of metal clad with precious metal, n.e.s.','Pulseras para reloj y sus partes, de metal precioso o chapado de metal precioso "plaqué"',91,9113);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911320,'Pulseiras de relógios, e suas partes, de metais comuns, mesmo dourados ou prateados','Watch straps, watch bands and watch bracelets, and parts thereof, of base metal, whether or not gold- or silver-plated, n.e.s.','Pulseras para reloj y sus partes, de metal común, incl. dorado o plateado, n.c.o.p.',91,9113);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911390,'Outras pulseiras para relógios, e suas partes, de outras matérias','Watch straps, watch bands and watch bracelets, and parts thereof, n.e.s.','Pulseras para reloj y sus partes, n.c.o.p.',91,9113);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911410,'Molas, incluídas as espirais, para aparelhos de relojoaria','Springs for clocks or watches, incl. hairsprings','Muelles "resortes", incl. las espirales',91,9114);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911420,'Pedras para aparelhos de relojoaria','Jewels for clocks or watches (excl. gems for clock and watch cases)','Piedras (exc. piedras preciosas para cajas)',91,9114);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911430,'Quadrantes para aparelhos relojoaria','Dials for clocks or watches','Esferas o cuadrantes',91,9114);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911440,'Platinas e pontes para aparelhos de relojoaria','Plates and bridges for clocks or watches','Platinas y puentes',91,9114);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (911490,'Outras partes e acessórios de aparelhos de relojoaria','Clock or watch parts, n.e.s.','Partes de aparatos de relojería, n.c.o.p.',91,9114);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920110,'Pianos verticais','Upright pianos','Pianos verticales',92,9201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920120,'Pianos de cauda','Grand pianos','Pianos de cola',92,9201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920190,'Outros pianos, mesmo automáticos; cravos e outros instrumentos de cordas, com teclado','Harpsichords and other keyboard stringed instruments (excl. pianos)','Clavecines y demás instrumentos de cuerda con teclado (exc. pianos)',92,9201);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920210,'Instrumentos musicais de cordas, tocados com auxílio de um arco','Violins and other string instruments','Violines y demás instrumentos musicales de arco',92,9202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920290,'Outros instrumentos musicais de cordas','Guitars, harps and other string musical instruments (excl. with keyboard and those played with a bow)','Guitarras, arpas y demás instrumentos musicales de cuerda (exc. con teclado, así como de arco)',92,9202);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920300,'Órgãos de tubos e de teclado, harmonios e instrum.semelhantes','keyboard pipe organs,harmon.and similar keyboard instr.','órganos de tubos y teclado, armonios y instrum.simil.',92,9203);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920410,'Acordeões e instrumentos semelhantes','Accordions and similar instruments','Acordeones y instrumentos similares',92,9204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920420,'Harmônicas (gaitas) de boca','Mouth harmonics','Armónicas',92,9204);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920510,'Instrumentos musicais de sopro denominados metais','Brass-wind instruments','Instrumentos llam. "metales"',92,9205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920590,'Outros instrumentos musicais de sopro','Wind musical instruments (excl. brass-wind instruments)','Instrumentos musicales de viento (exc. órganos y instrumentos llam. "metales")',92,9205);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920600,'Instrumentos musicais de percussão (tambores, caixas, xilofones, pratos, castanholas e maracas)','Percussion musical instruments, e.g. drums, xylophones, cymbals, castanets, maracas','Tambores, cajas, xilófonos, platillos, castañuelas, maracas y demás instrumentos musicales de percusión',92,9206);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920710,'Instrumentos musicais de teclado, cujo som é produzido ou amplificado por meios elétricos, exceto acordeões','Keyboard instruments, the sound of which is produced, or must be amplified, electrically (excl. accordions)','Instrumentos musicales de teclado en los que el sonido se produzca o tenga que amplificarse eléctricamente (exc. acordeones)',92,9207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920790,'Outros instrumentos musicais cujo som é produzido ou amplificado por meios elétricos (órgãos, guitarras, acordeões)','Accordions and musical instruments without keyboards, the sound of which is produced, or must be amplified, electrically','Acordeones e instrumentos musicales sin teclado en los que el sonido se produzca o tenga que amplificarse eléctricamente',92,9207);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920810,'Caixas de música','Musical boxes','Cajas de música',92,9208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920890,'Órgãos mecânicos de feira, realejos, serrotes musicais e outros instrumentos musicais','Fairground organs, mechanical street organs, mechanical singing birds, musical saws and other musical instruments not falling within any other heading in chapter 92; decoy calls of all kinds; whistles, call horns and other mouth-blown sound signalling ins','Orquestriones, organillos, pájaros cantores, sierras musicales y demás instrumentos musicales, n.c.o.p. de este capítulo; reclamos de cualquier clase, silbatos, cuernos y demás instrumentos de boca, de llam. o aviso',92,9208);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920910,'Metrônomos e diapasões para instrumentos musicais','Metronomes, tuning forks and pitch pipes','Metrónomos y diapasones para instrumentos musicales',92,9209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920920,'Mecanismo de caixas de música','Mechanisms for musical boxes','Mecanismo de cajas de música',92,9209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920930,'Cordas para instrumentos musicais','Musical instrument strings','Cuerdas armónicas',92,9209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920991,'Partes e acessórios para pianos','Parts and accessories for pianos','Partes y accesorios de pianos',92,9209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920992,'Partes e acessórios de instrumentos musicais de cordas','Parts and accessories for string musical instruments without keyboards, n.e.s. (excl. strings and those for musical instruments, the sound of which is produced, or must be amplified, electrically)','Partes y accesorios de instrumentos musicales de cuerda sin teclado, n.c.o.p. (exc. cuerdas armónicas e partes y accesorios de instrumentos musicales en los que el sonido se produzca o tenga que amplificarse eléctricamente)',92,9209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920993,'Partes e acessórios para órgãos de tubos e de teclados, etc.','Parts and access f/organs of tubes and of keyboards,etc','partes y acces.p/órganos de tubos y teclados, etc',92,9209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920994,'Partes e acessórios de instrumentos musicais cujo som produzido ou amplificado por meios elétricos','Parts and accessories for musical instruments, the sound of which is produced, or must be amplified, electrically, n.e.s.','Partes y accesorios de instrumentos musicales en los que el sonido se produzca o tenga que amplificarse eléctricamente, n.c.o.p.',92,9209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (920999,'Partes e acessórios para outros instrumentos musicais','Parts and accessories for musical instruments e.g. mechanisms for musical boxes, cards, discs and rolls for mechanical instruments n.e.s.; metronomes, tuning forks and pitch pipes of all kinds (excl. musical instrument strings and arts and accessories for','Partes y accesorios "tarjetas, discos y rollos para aparatos mecánicos" de acordeones e instrumentos simil., armónicas,  instrumentos musicales de viento o de percusión, cajas de música, orquestriones, organillos, pájaros cantores y demás instrumentos mus',92,9209);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930100,'Armas de guerra, exceto revólveres, pistolas e armas brancas','Military weapons,exc.revolvers,pitols and the arms','Armas de guerra, exc.revólveres, pistolas y armas blancas',93,9301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930110,'Peças de artilharia (exemplo: canhões, obuses, morteiros)','Artillery weapons (eg guns, howitzers, mortars)','Piezas de artillería (cañones por ejemplo, obuses, morteros)',93,9301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930111,'Peças de artilharia, autopropulsadas','Artillery weapons e.g. guns, howitzers and mortars, self-propelled','Cañones, obuses, morteros y demás piezas de artillería, autopropulsadas',93,9301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930119,'Outras peças de artilharia (não autopropulsadas)','Artillery weapons e.g. guns, howitzers and mortars,  not self-propelled','Cañones, obuses, morteros y demás piezas de artillería, no autopropulsadas',93,9301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930120,'Lança foguetes; lança-chamas; lança-granadas; tubos lança-torpedos e lançadores similares','Rocket launchers; flame-throwers; grenade launchers; torpedo tubes and similar projectors','Lanzacohetes; lanzallamas; lanzagranadas; lanzatorpedos y lanzadores similares',93,9301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930190,'Outras armas de guerra, exceto revólveres, pistolas e armas brancas','Military weapons, incl. sub-machine guns (excl. artillery weapons, rocket launchers, flame-throwers, grenade launchers, torpedo tubes and similar projectors,  revolvers and pistols of heading 9302 and cutting and thrusting weapons of heading 9307)','Armas de guerra, incl. pistolas ametralladoras (exc. cañones, obuses morteros y demás piezas de artillería; lanzacohetes, lanzallamas, lanzagranadas, lanzatorpedos y lanzadores similares; revólveres y pistolas de la partida 9302; armas blancas de la parti',93,9301);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930200,'Revólveres e pistolas, exceto os das posições 9303 ou 9304','Revolvers and pistols (excl. those of heading 9303 or 9304 and sub-machine guns for military purposes)','Revólveres y pistolas (exc. los de las partidas 9303 y 9304, así como pistolas ametralladoras de guerra)',93,9302);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930310,'Armas de fogo carregáveis exclusivamente pela boca','Muzzle-loading firearms, neither designed nor suitable for projecting cartridges','Armas de avancarga "black powder", no concebidas ni adecuadas para disparar cartuchos',93,9303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930320,'Outras espingardas e carabinas, de caça ou de tiro-ao-alvo, com pelo menos um cano liso','Sporting, hunting or target-shooting shotguns, with at least one smooth barrel (excl. muzzle-loading firearms and spring, air or gas guns)','Armas largas de caza o tiro deportivo que tengan, por lo menos, un cañón de ánima lisa (exc. armas de avancarga y fusiles de muelle, aire comprimido o gas)',93,9303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930330,'Outras espingardas e carabinas, de caça ou de tiro-ao-alvo','Sporting, hunting and target-shooting shotguns with one or more rifled bores (other than spring, air or gas guns)','Armas largas de caza o tiro deportivo con uno o más cañones de ánima rayada (exc. fusiles de muelle, aire comprimido o gas)',93,9303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930390,'Outras armas de fogo e aparelhos semelhantes que utilizem deflagração da pólvora','Firearms and similar devices which operate by the firing of an explosive charge (excl. sporting, hunting or target-shooting rifles, revolvers and pistols of heading 9302 and military weapons)','Armas de fuego y artefactos simil. que utilicen la deflagración de la pólvora (exc. escopetas y rifles de caza o de tiro deportivo, revólveres, pistolas y armas de guerra)',93,9303);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930400,'Outras armas (espingardas, carabinas e pistolas, de mola, de ar comprimido ou de gás, cassetetes)','Spring, air or gas guns and pistols, truncheons and other non-firearms (excl. swords, cutlasses, bayonettes and similar arms of heading 9307)','Armas largas y pistolas de muelle "resorte", aire comprimido o gas, porras y otras armas que no sean de fuego (exc. sables, espadas, bayoneta, lanzas y demás armas blancas)',93,9304);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930510,'Partes e acessórios de revólveres ou pistolas','Parts and accessories for revolvers or pistols','Partes y accesorios de revólveres o pistolas',93,9305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930520,'Partes e acessórios de espingardas ou carabinas da posição 9303','Parts and accessories of shotguns or rifles of heading 9303','Partes y accesorios de escopetas o rifles de la partida 9303',93,9305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930521,'Canos lisos de espingardas o de carabinas da posição 9303','Smooth barrels for sporting, hunting and target-shooting rifles of heading 9303','Cañones de ánima lisa para escopetas y rifles de caza o tiro deportivo',93,9305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930529,'Outras partes e acessórios para espingardas e carabinas da posição 9303','Parts and accessories for sporting, hunting and target-shooting rifles of heading 9303, n.e.s. (excl. shotgun barrels)','Partes y accesorios para escopetas y rifles de caza o tiro deportivo de la partida 9303, n.c.o.p. (exc. cañones de ánima lisa)',93,9305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930590,'Partes e acessórios para armas','Parts and accessories for weapons','Partes y accesorios para las armas',93,9305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930591,'Partes e acessórios de armas de guerra da posição 9301','Parts and accessories of military weapons of heading 9301, n.e.s.','Partes y accesorios de armas de guerra de la partida 9301, n.c.o.p.',93,9305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930599,'Partes e acessórios de outras armas','Parts and accessories for weapons and the like of heading 9303 or 9304, n.e.s. (excl. of shotguns or rifles of heading 9303)','Partes y accesorios de armas y artefactos similares de las partidas 9303 y 9304, n.c.o.p. (exc. para escopetas y rifles de la partida 9303)',93,9305);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930610,'Cartuchos para pistolas de rebitar/embolo para abater animais','Cartridges for riveting/captive-bolt humane killers','Cartuchos p/pistolas de remachar/usos simil/de matarife',93,9306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930621,'Cartuchos para espingardas e carabinas de cano liso','Cartridges for smooth-barrelled shotguns','Cartuchos para escopetas y rifles con cañón de ánima lisa',93,9306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930629,'Chumbos para carabinas de ar comprimido; partes de cartuchos','Parts of cartridges for smooth-barrelled shotguns; lead shot for air rifles and pistols','Partes de cartuchos para escopetas y rifles con cañón de ánima lisa; balines de plomo para armas de aire comprimido',93,9306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930630,'Outros cartuchos e suas partes','Cartridges for smooth-barrelled shotguns, revolvers and pistols and cartridges for riveting or similar tools or for captive-bolt humane killers, and parts thereof','Cartuchos y sus partes para escopetas y rifles con cañón de ánima rayada, así como para revólveres y pistolas',93,9306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930690,'Bombas, granadas, e outras munições e projéteis e suas partes','Bombs, grenades, torpedos, mines, missiles, and other ammunition and projectiles, and parts thereof, n.e.s. (excl. cartridges)','Bombas, granadas, torpedos, minas, misiles y demás municiones y proyectiles, así como sus partes, n.c.o.p. (exc. cartuchos)',93,9306);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (930700,'Sabres, espadas, baionetas, lanças e outras armas brancas, suas partes e bainhas','Swords, cutlasses, bayonets, lances and similar arms and parts thereof, and scabbards and sheaths therefor (excl. of precious metal or of metal clad with precious metal, blunt weapons for fencing, hunting knives and daggers, camping knives and other knive','Sables, espadas, bayonetas, lanzas y demás armas blancas, sus partes y fundas (exc. fundas de metal precioso o chapado de metal precioso "plaqué", armas de esgrima con punta embotada, cuchillos y puñales de monte, cuchillos de acampada y demás artículos d',93,9307);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940110,'Assentos para veículos aéreos','Seats for aircraft','Asientos de los tipos utilizados en aeronaves',94,9401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940120,'Assentos para veículos automóveis','Seats for motor vehicles','Asientos de los tipos utilizados en vehículos automóviles',94,9401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940130,'Assentos giratórios, de altura ajustável','Swivel seats with variable height adjustments (excl. medical, surgical, dental or veterinary, and barbers'' chairs)','Asientos giratorios de altura ajustable (exc. asientos para medicina, cirugía, odontología o veterinaria, así como sillones de peluquería)',94,9401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940140,'Assentos (exceto de jardim ou de acampar) transformáveis em camas','Seats, convertible into beds (excl. garden seats and camping equipment, and medical, dental or surgical furniture)','Asientos transformables en cama (exc. material de acampada o de jardín, así como muebles para medicina, cirugía u odontología)',94,9401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940150,'Assentos de cana, vime, bambu ou de matérias semelhantes','Seats of cane, osier, bamboo or similar materials','Asientos de roten, mimbre, bambú o materias similares',94,9401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940151,'Assentos de bambu ou ratã','Seats of bamboo or rattan','Asientos de bambú o roten (ratán)',94,9401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940159,'Assentos de outras matérias, exceto de ratã ou bambu','Seats of cane, osier or similar materials (excl. of bamboo or rattan)','Asientos de otras materias textiles, exc. de bambú o roten (ratán)',94,9401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940161,'Assentos estofados, com armação de madeira','Upholstered seats, with wooden frames (excl. convertible into beds)','Asientos con armazón de madera, con relleno (exc. los transformables en cama)',94,9401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940169,'Outros assentos com armação de madeira','Seats, with wooden frames (excl. upholstered)','Asientos con armazón de madera, no con relleno',94,9401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940171,'Assentos estofados, com armação de metal','Upholstered seats, with metal frames (excl. seats for aircraft or motor vehicles, swivel seats with variable height adjustments and medical, dental or surgical furniture)','Asientos con armazón de metal, con relleno (exc. de los tipos utilizados en aeronaves o en vehículos automóviles, asientos giratorios de altura ajustable, así como muebles para medicina, cirugía u odontología)',94,9401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940179,'Outros assentos com armação de metal','Seats, with metal frames (excl. upholstered, swivel seats with variable height adjustments and medical, dental or surgical furniture)','Asientos con armazón de metal, no con relleno (exc. asientos giratorios de altura ajustable, así como muebles para medicina, cirugía u odontología)',94,9401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940180,'Outros assentos','Seats, n.e.s.','Asientos, n.c.o.p.',94,9401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940190,'Partes de assentos','Parts of seats, n.e.s.','Partes de asientos, n.c.o.p.',94,9401);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940210,'Cadeiras de dentista, para salões de cabeleireiro e cadeiras semelhantes, e suas partes','Dentists'', barbers'' or similar chairs having rotating as well as both reclining and elevating movement, and parts thereof, n.e.s.','Sillones de dentista, de peluquería y sillones simil., con dispositivos de orientación y elevación; sus partes, n.c.o.p.',94,9402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940290,'Outros mobiliários para medicina, cirurgia, odontologia ou veterinária','Operating tables, examination tables, and other medical, dental, surgical or veterinary furniture (excl. dentists'' or similar chairs, special tables for X-ray examination, and stretchers and litters, incl. trolley-stretchers)','Mesas de operaciones, mesas de reconocimiento y demás mobiliario especial para medicina, cirugía, odontología o veterinaria (exc. sillones de dentista y otros asientos y mesas especialmente destinados a reconocimientos radiológicos, así como camillas y pa',94,9402);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940310,'Móveis de metal para escritórios','Metal furniture for offices (excl. seats)','Muebles de metal de los tipos utilizados en oficinas (exc. asientos)',94,9403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940320,'Outros móveis de metal','Metal furniture (excl. for offices, seats and medical, surgical, dental or veterinary furniture)','Muebles de metal (exc. de los tipos utilizados en oficinas, asientos y mobiliario para medicina, cirugía, odontología o veterinaria)',94,9403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940330,'Móveis de madeira para escritórios','Wooden furniture for offices (excl. seats)','Muebles de madera de los tipos utilizados en oficinas (exc. asientos)',94,9403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940340,'Móveis de madeira para cozinhas','Wooden furniture for kitchens (excl. seats)','Muebles de madera de los tipos utilizados en cocinas (exc. asientos)',94,9403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940350,'Móveis de madeira para quartos de dormir','Wooden furniture for bedrooms (excl. seats)','Muebles de madera de los tipos utilizados en dormitorios (exc. asientos)',94,9403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940360,'Outros móveis de madeira','Wooden furniture (excl. for offices, kitchens and bedrooms, and seats)','Muebles de madera (exc. de los tipos utilizados en oficinas, cocinas o dormitorios, así como asientos)',94,9403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940370,'Móveis de plásticos','Furniture of plastics (excl. medical, dental, surgical or veterinary, and seats)','Muebles de plástico (exc. asientos y mobiliario para medicina, cirugía, odontología o veterinaria)',94,9403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940380,'moveis de outras matérias, incl.rotim, vime, bambu, etc.','furniture of oth.materials,incl.cane,osier,bamboo,etc.','muebles de otras materias, incl.roten, mimbre, bambú, etc',94,9403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940381,'Móveis de bambu ou ratã','Furniture of bamboo or rattan (excl. seats and medical, surgical, dental or veterinary furniture)','Muebles de bambú o roten (ratán)',94,9403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940389,'Móveis de outras matérias, exceto de ratã ou bambu','Furniture of cane, osier or similar materials (excl. of bamboo, rattan, metal, wood and plastics, and seats and medical, surgical, dental or veterinary furniture)','Muebles de otras materias, exc de bambú o roten (ratán)',94,9403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940390,'Partes para móveis','Parts of furniture, n.e.s. (excl. of seats and medical, surgical, dental or veterinary furniture)','Partes de muebles, distintas de los asientos, n.c.o.p.',94,9403);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940410,'Suportes elásticos para camas','Mattress supports for bed frames (excl. spring interiors for seats)','Somieres para armazones de camas (exc. muelles metálicos para asientos)',94,9404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940421,'Colchões de borracha ou de plásticos alveolares, mesmo recobertos','Mattresses of cellular rubber or plastics, whether or not covered','Colchones de caucho o plástico celulares, recubiertos o no',94,9404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940429,'Colchões de outras matérias','Mattresses, fitted with springs or stuffed or internally filled with any material (excl. cellular rubber or plastics, pneumatic or water mattresses and pillows)','Colchones con muelles "resortes", bien rellenos o guarnecidos interiormente con cualquier materia (exc. de caucho o plástico celulares, así como colchones de agua, colchones, almohadones y cojines neumáticos)',94,9404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940430,'Sacos de dormir','Sleeping bags, whether or non-electrically heated','Sacos "bolsas" de dormir, incl. con sistema eléctrico de calefacción',94,9404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940490,'Ededrões, almofadas, pufes, travesseiros e artigos semelhantes','Articles of bedding and similar furnishing, fitted with springs or stuffed or internally filled with any material or of cellular rubber or plastics (excl. mattress supports, mattresses, sleeping bags, pneumatic or water mattresses and pillows, blankets an','Artículos de cama y simil., con muelles "resortes", bien rellenos o guarnecidos interiormente con cualquier materia, o de caucho o plástico celulares (exc. somieres, colchones, sacos "bolsas" de dormir, colchones de agua, colchones, almohadones y cojines ',94,9404);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940510,'Lustres e outros aparelhos de iluminação, elétricos, próprios para serem suspensos ou fixados no teto ou na parede, exceto os utilizados na iluminação pública','Chandeliers and other electric ceiling or wall lighting fittings (excl. for lighting public open spaces or thoroughfares)','Lámparas y demás aparatos eléctricos de alumbrado, para colgar o fijar al techo o a la pared (exc. de los tipos utilizados para el alumbrado de espacios o vías públicos)',94,9405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940520,'Abajures (candeeiros) de cabeceira, de escritório e lampadários de interior, elétricos','Electric table, desk, bedside or floor-standing lamps','Lámparas eléctricas de cabecera, mesa, oficina o de pie',94,9405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940530,'Guirlandas elétricas para árvores de natal','Electric lighting sets of a kind used for Christmas trees','Guirnaldas eléctricas de los tipos utilizados en árboles de Navidad',94,9405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940540,'Outros aparelhos elétricos de iluminação','Electric lamps and lighting fittings, n.e.s.','Aparatos eléctricos de alumbrado, n.c.o.p.',94,9405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940550,'Aparelhos não elétricos de iluminação','Non-electrical lamps and lighting fittings, n.e.s.','Aparatos de alumbrado no eléctricos, n.c.o.p.',94,9405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940560,'Anúncios, cartazes ou tabuletas e placas indicadoras luminosos, e artigos semelhantes','Illuminated signs, illuminated nameplates and the like, with a permanently fixed light source','Anuncios, letreros y placas indicadoras luminosos y artículos simil., con fuente de luz inseparable',94,9405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940591,'Partes de aparelhos de iluminação, de vidro','Parts of lamps and lighting fittings, illuminated signs and nameplates and the like, of glass, n.e.s.','Partes de aparatos de alumbrado, anuncios, letreros y placas indicadoras luminosos y artículos simil., de vidrio, n.c.o.p.',94,9405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940592,'Partes de aparelhos de iluminação, de plásticos','Parts of lamps and lighting fittings, illuminated signs and nameplates and the like, of plastics, n.e.s.','Partes de aparatos de alumbrado, anuncios, letreros y placas indicadoras luminosos y artículos simil., de plástico, n.c.o.p.',94,9405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940599,'Partes de aparelhos de iluminação, de outras matérias','Parts of lamps and lighting fittings, illuminated signs and nameplates and the like, n.e.s.','Partes de aparatos de alumbrado, anuncios, letreros y placas indicadoras luminosos y artículos simil., n.c.o.p.',94,9405);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (940600,'Construções pré-fabricadas','Prefabricated buildings, whether or not complete or already assembled','Construcciones prefabricadas, incl. incompletas o sin montar',94,9406);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950100,'Brinquedos de rodas para crianças e carrinhos para bonecos','Wheeled toys for children and dolls'' carriages','Juguetes de ruedas p/niños y coches de ruedas p/muñecos',95,9501);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950210,'Bonecos de figura humana','Dolls representing humans','Muñecas que representan humana',95,9502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950291,'Vestuário e seus acess.etc.para bonecos de figura humana','Garments and acces.therefor f/dolls repres.human beings','Prendas de vest.y sus compl.etc.p/muñec.q.repr.ser.hum.',95,9502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950299,'Outras partes e acess.p/bonecos de figura humana','Other parts and access.f/dolls repres.human beings','Las demás partes y acces.p/muñecos q.repr.seres humanos',95,9502);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950300,'Triciclos, patinetes, carros de pedais e outros brinquedos semelhantes de rodas; carrinhos para bonecos; bonecos; outros brinquedos; modelos reduzidos e modelos semelhantes para divertimento, mesmo animados; quebra-cabeças ("puzzles") de qualquer tipo.','Tricycles, scooters, pedal cars and similar wheeled toys; dolls'' carriages; dolls; other toys; reduced-size scale recreational models, working or not;  puzzles of all kinds','Triciclos, patinetes, coches de pedal y juguetes similares con ruedas; coches y sillas de ruedas para muá±ecas o muá±ecos; muá±ecas o muá±ecos; los demás juguetes; modelos reducidos y modelos similares, para entretenimiento, incluso animados; rompecabezas',95,9503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950310,'Trens elétricos de brinquedo, inclusive trilhos, sinais, outros acessórios','ElectrIc trains of toy.incl.tracks/signals/acces.therefor','Trenes eléctr.de juguet.incl.carriles/señales/dem.acces',95,9503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950320,'Modelos reduzidos (em escala) para kits de montagem, exceto trens elétricos','Reduced-size ("scale") model assembly kits, excluding electric trains','Demás modelos reducidos, de juguete, p/ensamblar',95,9503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950330,'Outros conjuntos e brinquedos, para construção','Other kits and toys for construction','los demás juegos y juguetes de construcción',95,9503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950341,'Brinquedos com enchimento, de figura animal ou não-humana','Filled toys representing animals or non-human creatures','Juguetes rellenos, q.repr.animales o seres no humanos',95,9503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950349,'Outros brinquedos de figura animal ou não humana','other toys representing animals or non-human creatures','los dem.juguetes q.repr.animales o seres no humanos',95,9503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950350,'Instrumentos e aparelhos musicais, de brinquedo','Toy musical instruments and apparatus','Instrumentos y aparatos musicales, de juguete',95,9503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950360,'Quebra-cabeças ("puzzles")','Puzzles','Rompecabezas',95,9503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950370,'Outros brinquedos em sortidos ou em panóplias','Other toys, put up in sets or outfits','Demás juguetes en juegos o surtidos o en panoplias',95,9503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950380,'Brinquedos motorizados ou elétricos','Toys - electric or motorized','Juguetes motorizados o eléctricos',95,9503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950390,'Outros brinquedos','Other toys','Otros juguetes',95,9503);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950410,'Jogos de vídeo utilizáveis com receptor de televisão','Video games for use with a television receiver','Videojuegos de los tipos utilizados con receptor de televisión',95,9504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950420,'Bilhares e seus acessórios','Billiards of all kinds and accessories','Billares y sus accesorios',95,9504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950430,'Outros jogos funcionando por introdução de uma moeda, papel-moeda, ficha ou de outros artigos similares, exceto os jogos de balizas (paulitos) automáticas (boliche)','Games with screens, flipper and other games, operated by coins, banknotes, bank cards, tokens or by other means of payment (excl. bowling alley equipment)','Juegos con pantalla, "flippers" y demás juegos activados con monedas, billetes de banco, fichas o demás artículos similares (exc. juegos de bolos automáticos "bowlings")',95,9504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950440,'Cartas de jogar','Playing cards','Naipes',95,9504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950450,'Consoles e máquinas de jogos de vídeo (exceto da subposição 9504.30)','onsoles and video gaming machines (except subheading 9504.30)','Consolas y máquinas de video juegos (excepto de la subpartida 9504.30)',95,9504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950490,'Outros artigos para jogos de salão','Tables for casino games, automatic bowling alley equipment, and other funfair, table or parlour games, incl. pintables (excl. operated by coins, banknotes paper currency, discs or other similar articles, billiards, video games for use with a television re','Juegos de casino, juegos de bolos automáticos "bowlings" y otros artículos para salas de juego, juegos de mesa o salón, incl. los juegos con motor o mecanismo (exc. juegos activados con monedas, billetes de banco, fichas o demás artículos similares; billa',95,9504);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950510,'Artigos para festas de natal','Christmas articles (excl. candles and electric lighting sets, natural Christmas trees and Christmas tree stands)','Artículos para fiestas de Navidad (exc. velas y guirnaldas eléctricas, árboles de Navidad naturales y sus soportes)',95,9505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950590,'Artigos para outras festas, carnaval ou outros divertimentos, incluídos os de magia e artigos-surpresa','Festival, carnival or other entertainment articles, incl. conjuring tricks and novelty jokes, n.e.s.','Artículos para fiestas, carnaval u otras diversiones, incl. los de magia y los artículos sorpresa, n.c.o.p.',95,9505);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950611,'Esquis para neve','Skis, for winter sports','Esquís para nieve',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950612,'Fixadores para esquis','Ski bindings','Fijadores de esquí',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950619,'Outros equipamentos para esquiar na neve','Ski equipment for winter sports (other than skis and ski-fastenings [ski-bindings])','Artículos para práctica del esquí de nieve (exc. esquís y fijadores de esquí)',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950621,'Pranchas a vela','Sailboards','Deslizadores de vela para la práctica de deportes acuíticos',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950629,'Esquis aquáticos e outros equipamentos para prática de esportes aquáticos','Water-skis, surfboards and other water-sport equipment (other than sailboards)','Esquís acuáticos, tablas y demás artículos para la práctica de deportes acuíticos (exc. deslizadores de vela)',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950631,'Tacos completos para golfe','Golf clubs, complete','Palos de golf "clubs" completos',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950632,'Bolas para golfe','Golf balls','Pelotas de golf',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950639,'Outros equipamentos para golfe','Golf equipment (excl. balls and complete clubs)','Artículos para la práctica del golf (exc. pelotas y palos "clubs" completos)',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950640,'Artigos e equipamentos para tênis de mesa','Articles and equipment for table-tennis','Artículos y material para tenis de mesa',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950651,'Raquetes de tênis, mesmo não encordoadas','Tennis rackets, whether or not strung (excl. table-tennis bats)','Raquetas de tenis, incl. sin cordaje (exc. raquetas de tenis de mesa)',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950659,'Raquetes de badminton e outras raquetes semelhantes, mesmo não encordoadas','Badminton and similar rackets, whether or not strung (other than tennis rackets and table-tennis bats)','Raquetas de "badminton" o simil., incl. sin cordaje (exc. raquetas de tenis y de tenis de mesa)',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950661,'Bolas de tênis, exceto tênis de mesa','Tennis balls (excl. table tennis balls)','Pelotas de tenis (exc. de tenis de mesa)',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950662,'Bolas infláveis','Inflatable balls','Balones y pelotas de deporte, inflables',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950669,'Outras bolas','Balls (excl. inflatable, tennis balls, golf balls, and table-tennis balls)','Balones y pelotas de deporte (exc. los inflables, asi como las pelotas de golf, tenis y tenis de mesa)',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950670,'Patins para gelo e patins de rodas, incluídos os fixados em calçados','Ice skates and roller skates, incl. skating boots with skates or rollers attached','Patines para hielo y patines de ruedas, incl. el calzado con patines fijos',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950691,'Artigos e equipamentos para cultura física, ginástica ou atletismo','Articles and equipment for general physical exercise, gymnastics or athletics','Artículos y material para cultura física, gimnasia o atletismo',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950699,'Artigos e equipamentos para outros esportes ou jogos ao ar livre; piscinas, incluídas as infantis','Articles and equipment for sport and outdoor games n.e.s; swimming and paddling pools','Artículos y material para deportes o juegos al aire libre, n.c.o.p.; piscinas y piscinas infantiles',95,9506);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950710,'Varas (canas) de pesca','Fishing rods','Cañas de pescar',95,9507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950720,'Anzóis, mesmo montados em sedelas (terminais)','Fish-hooks, whether or not snelled','Anzuelos, incl. montados en sedal "tanza"',95,9507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950730,'Molinetes (carretes) de pesca','Fishing reels','Carretes de pesca',95,9507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950790,'Outros artigos para pesca à linha, puçás e redes semelhantes para qualquer finalidade','Line fishing tackle n.e.s; fish landing nets, butterfly nets and similar nets; decoys and similar hunting or shooting requisites (excl. decoy calls of all kinds and stuffed birds of heading 9705)','Artículos para la pesca con caña, n.c.o.p.; salabardos, cazamariposas y redes simil.; señuelos y artículos de caza simil. (exc. reclamos de cualquier clase y pájaros disecados)',95,9507);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950800,'Carrosséis/balanços/outras diversões para parques, circos, etc','Roundabouts,swings/oth.fairground amusemen.circuses,etc','Tiovivos/columpios/dem.atracciones de feria, circos, etc',95,9508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950810,'Circos e coleções de animais ambulantes','Travelling circuses and travelling menageries','Circos y zoológicos ambulantes',95,9508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (950890,'Carrosséis, balanços e outras diversões de parques e feiras','Roundabouts, swings, shooting galleries and other fairground amusements; travelling theatres (excl. travelling circuses and travelling menageries, booths, incl. the goods on sale, goods for distribution as prizes, gaming machines accepting coins or tokens','Tiovivos, columpios, casetas de tiro y demás atracciones de feria; teatros ambulantes (exc. circos y zoológicos ambulantes; instalaciones de feria para la venta de determinadas mercancías; artículos ofrecidos como premio; juegos activados con monedas, bil',95,9508);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960110,'Marfim trabalhado e obras de marfim','Worked ivory and articles of ivory, n.e.s.','Marfil trabajado y sus manufacturas, n.c.o.p.',96,9601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960190,'Outras matérias animais para entalhar, trabalhadas, e suas obras','Worked bone, tortoiseshell, horn, antlers, coral, mother-of-pearl and other animal carving material, and articles of these materials, n.e.s. (excl. ivory)','Hueso, concha "caparazón" de tortuga, cuerno, asta, coral, nácar y demás materias animales para tallar, trabajadas, y manufacturas de estas materias, incl. las obtenidas por moldeo, n.c.o.p. (exc. marfil)',96,9601);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960200,'Matérias vegetais ou minerais de entalhar, trabalhadas, e suas obras','Worked vegetable or mineral carving material and articles of these materials n.e.s; moulded or carved articles of wax, of paraffin, of stearin, of natural gums or natural resins or of modelling pastes, and other moulded or carved articles n.e.s; worked, u','Materias vegetales o minerales para tallar, trabajadas, y sus manufacturas, n.c.o.p.; manufacturas moldeadas o talladas de cera, parafina, estearina, gomas o resinas naturales o pasta para modelar y demás manufacturas moldeadas o talladas, n.c.o.p.; gelat',96,9602);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960310,'Vassouras e escovas, de matérias vegetais em feixes, com ou sem cabo','Brooms and brushes, consisting of twigs or other vegetable materials bound together, with or without handles','Escobas y escobillas de ramitas u otra materia vegetal atadas en haces, incl. con mango',96,9603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960321,'Escovas de dentes, incluídas as escovas para dentaduras','Tooth brushes, incl. dental-plate brushes','Cepillos de dientes, incl. para dentaduras postizas',96,9603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960329,'Outras escovas e pincéis de barba, escovas para cabelos, cílios ou para unhas e outras escovas de toucador','Shaving brushes, hair brushes, nail brushes, eyelash brushes and other brushes for use on the person (excl. tooth brushes)','Brochas de afeitar, cepillos para cabello, pestañas, uñas y demás cepillos para aseo personal (exc. cepillos de dientes)',96,9603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960330,'Pincéis e escovas para artistas, pincéis de escrever e semelhantes para aplicação de produtos cosméticos','Artists'' brushes, writing brushes and similar brushes for the application of cosmetics','Pinceles y brochas para pintura artística, pinceles para escribir y pinceles simil. para aplicación de cosméticos',96,9603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960340,'Escovas e pincéis para pintar, caiar, envernizar ou semelhantes; bonecas e rolos para pintura','Paint, distemper, varnish or similar brushes, paint pads and rollers (excl. artists'' and similar brushes of subheading 9603.30)','Brochas y pinceles para pintar, enlucir, barnizar o simil., así como muñequillas y rodillos para pintar (exc. pinceles y brochas para pintura artística y pinceles simil.)',96,9603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960350,'Outras escovas que constituam partes de máquinas, aparelhos ou de veículos','Brushes constituting parts of machines, appliances or vehicles','Cepillos que constituyan partes de máquinas, aparatos o vehículos',96,9603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960390,'Rodos de borracha ou de outros materiais flexíveis; outras vassouras e pincéis','Mops and leather dusters; prepared knots and tufts for broom or brush making; squeegees of rubber or other flexible materials; brooms and brushes, n.e.s.','Pinceles y plumeros; cabezas preparadas para artículos de cepillería; rasquetas de caucho o de materia flexible análoga; escobas, cepillos y brochas, n.c.o.p.',96,9603);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960400,'Peneiras e crivos, manuais','Hand sieves and hand riddles (excl. colanders)','Tamices, cedazos y cribas, de mano (exc. simples escurridores)',96,9604);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960500,'Sortidos de viagem, para toucador de pessoas, para costura ou limpeza de calçado ou de roupas','Travel sets for personal toilet, sewing or shoe or clothes cleaning (excl. manicure sets)','Juegos de viaje para aseo personal, costura o limpieza del calzado o de prendas de vestir (exc. juegos de manicura)',96,9605);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960610,'Botões de pressão e suas partes','Press-fasteners, snap-fasteners and press studs and parts therefor','Botones de presión y sus partes',96,9606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960621,'Botões de plásticos, não recobertos de matérias têxteis','Buttons of plastics, not covered with textile material (excl. press-fasteners, snap-fasteners, press studs and cuff links)','Botones de plástico, sin forrar con materia textil (exc. botones de presión y gemelos)',96,9606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960622,'Botões de metais comuns, não recobertos de matérias têxteis','Buttons of base metal, not covered with textile material (excl. press-fasteners, snap-fasteners, press studs and cuff links)','Botones de metal común, sin forrar con materia textil (exc. botones de presión y gemelos)',96,9606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960629,'Outros botões','Buttons (excl. of plastics or base metal, not covered with textile material, press-fasteners, snap-fasteners, press studs and cuff links)','Botones (exc. de plástico o de metal común, sin forrar con materia textile, así como botones de presión y gemelos)',96,9606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960630,'Formas e outras partes, de botões; esboços de botões','Button moulds and other parts of buttons; button blanks','Formas para botones y demás partes de botones; esbozos de botones',96,9606);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960711,'Fechos ecler com grampos de metal comum','Slide fasteners fitted with chain scoops of base metal','Cierres de cremallera "cierres relámpago" con dientes de metal común',96,9607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960719,'Outros fechos ecler','Slide fasteners (excl. fitted with chain scoops of base metal)','Cierres de cremallera "cierres relámpago" (exc. con dientes de metal común)',96,9607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960720,'Partes de fechos ecler','Parts of slide fasteners','Partes de cierres de cremalleras "cierres relámpago"',96,9607);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960810,'Canetas esferográficas','Ball-point pens','Bolígrafos',96,9608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960820,'Canetas e marcadores, com ponta de feltro ou com outras pontas porosas','Felt-tipped and other porous-tipped pens and markers','Rotuladores y marcadores con punta de fieltro u otra punta porosa',96,9608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960830,'canetas-tinteiro e outras canetas','canetas-tinteiro e outras canetas','canetas-tinteiro e outras canetas',96,9608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960831,'Canetas para desenhar com nanquim (tinta-da-china)','Indian ink drawing pens','Estilográficas y demás plumas para dibujar con tinta china',96,9608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960839,'Outras canetas-tinteiro e outras canetas','Fountain pens, stylograph pens and other pens (excl. indian ink drawing pens)','Estilográficas y demás plumas (exc. para dibujar con tinta china)',96,9608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960840,'Lapiseiras','Propelling or sliding pencils','Portaminas',96,9608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960850,'Sortidos de canetas com lapiseiras','Sets of articles from two or more of the following: ball-point pens, felt or fibre-tipped pens and markers, fountain pens and propelling pencils','Juegos de artículos pertenecientes, por lo menos, a dos de los artículos siguientes: bolígrafos, rotuladores y marcadores con punta de fieltro o de fibra, plumas y portaminas',96,9608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960860,'Cargas com ponta, para canetas esferográficas','Refills for ball-point pens, comprising the ball-point and ink-reservoir','Cartuchos de repuesto con su punta para bolígrafo',96,9608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960891,'Penas (aparos) e suas pontas, para canetas-tinteiro','Pen nibs and nib points','Plumillas y puntos para plumillas',96,9608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960899,'Estiletes para duplicadores, porta-lápis e outros artigos semelhantes','Parts of ball-point pens, felt-tipped and other porous-tipped pens and markers, fountain pens and propelling pencils n.e.s, pencil-holders, pen-holders and the like, and duplicating stylos','Partes de bolígrafos, rotuladores y marcadores con punta de fieltro u otra punta porosa, plumas y portaminas, n.c.o.p.; portaplumas, portalápices y artículos simil., así como estiletes o punzones para clisés',96,9608);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960910,'Lápis','Pencils and crayons, with leads encased in a rigid sheath','Lápices',96,9609);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960920,'Minas para lápis ou lapiseiras','Pencil leads, black or coloured','Minas para lápices o portaminas',96,9609);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (960990,'Pastéis, carvões, gizes para escrever ou desenhar e de alfaiate','Pencils, pastels, drawing charcoals, writing or drawing chalks and tailors'' chalks','Pasteles, carboncillos, tizas para escribir o dibujar y jaboncillos "tizas" de sastre',96,9609);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961000,'Lousas e quadros para escrever ou desenhar, mesmo emoldurados','Slates and boards, with writing or drawing surfaces, whether or not framed','Pizarras y tableros para escribir o dibujar, incl. enmarcados',96,9610);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961100,'Carimbos, datadores, numeradores, sinetes e artigos semelhantes (incluídos os aparelhos para impressão de etiquetas), manuais','Hand-operated date, sealing or numbering stamps, and the like; hand-operated composing sticks and hand printing sets','Fechadores, sellos, numeradores, timbradores y artículos simil., incl. los aparatos para imprimir etiquetas, de mano; componedores e imprentillas, de mano',96,9611);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961210,'Fitas impressoras','Typewriter or similar ribbons, inked or otherwise prepared for giving impressions, whether or not on spools or in cartridges','Cintas para máquinas de escribir y cintas simil., entintadas o preparadas de otro modo para imprimir, incl. en carretes o cartuchos',96,9612);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961220,'Almofadas de carimbo','Ink-pads, whether or not inked, with or without boxes','Tampones, incl. impregnados o con caja',96,9612);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961310,'Isqueiros de bolso, a gás, não recarregáveis','Pocket lighters, gas fuelled, non-refillable','Encendedores de gas no recargables, de bolsillo',96,9613);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961320,'Isqueiros de bolso, a gás, recarregáveis','Pocket lighters, gas fuelled, refillable','Encendedores de gas recargables, de bolsillo',96,9613);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961330,'isqueiros de mesa','table lighters','encendedores de mesa',96,9613);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961380,'Outros isqueiros e acendedores','Lighters (excl. gas fuelled pocket lighters, and fuses and primers for propellent powders and explosives)','Encendedores y mecheros (exc. de gas de bolsillo, así como las piedras y mechas)',96,9613);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961390,'Partes de isqueiros e acendedores','Parts of lighters, n.e.s.','Partes de encendedores y mecheros, n.c.o.p.',96,9613);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961400,'Cachimbos e piteiras para charutos e para cigarros, e suas partes','Smoking pipes, incl. pipe bowls, cigar or cigarette holders, and parts thereof, n.e.s.','Pipas (incluidas las cazoletas), boquillas para cigarros (puros) o cigarrillos, y sus partes',96,9614);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961420,'Cachimbos e seus fornilhos','Pipes and pipe bowls','Pipas y cazoletas',96,9614);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961490,'Piteiras (boquilhas) e suas partes','Cigarette-holders (mouthpieces) and parts thereof','Boquillas para cigarros y sus partes',96,9614);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961511,'Pentes e travessas para cabelo, de borracha endurecida ou de plásticos','Combs, hair-slides and the like of hard rubber or plastics','Peines, peinetas, pasadores y artículos simil., de caucho endurecido o plástico',96,9615);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961519,'Outros pentes e travessas para cabelo, de outras matérias','Combs, hair-slides and the like (excl. of hard rubber or plastics)','Peines, peinetas, pasadores y artículos simil., de otras materias distintas del caucho endurecido o plástico',96,9615);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961590,'Grampos para cabelo, pinças, onduladores, bobs (rolos) e outros artigos para penteados, e suas partes','Hairpins, curling pins, curling grips, hair-curlers and the like, and parts thereof, n.e.s. (excl. electro-thermic appliances of heading 8516)','Horquillas, rizadores, bigudíes y artículos simil. para el peinado, y sus partes, n.c.o.p. (exc. aparatos eléctricos de la partida 8516)',96,9615);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961610,'Vaporizadores de toucador, armações e suas cabeças','Scent sprays and similar toilet sprays, and mounts and heads therefor (excl. coin or token-operated)','Pulverizadores de tocador, sus monturas y cabezas de monturas (exc. los activados con monedas o fichas)',96,9616);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961620,'Borlas ou esponjas para pós ou para aplicação de outros cosméticos ou de produtos de toucador','Powder puffs and pads for the application of cosmetics or toilet preparations','Borlas y simil. para aplicación de polvos, otros cosméticos o productos de tocador',96,9616);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961700,'Garrafas térmicas e outros recipientes isotérmicos montados, com isolamento produzido pelo vácuo, e suas partes (exceto ampolas de vidro)','Vacuum flasks and other vacuum vessels, and parts thereof (excl. glass inners)','Termos y demás recipientes isotérmicos, montados y aislados por vacío, así como sus partes (exc. ampollas de vidrio)',96,9617);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961800,'Manequins e artigos semelhantes; autômatos e cenas animadas, para vitrines e mostruários','Tailors'' dummies and other lay figures, automata and other animated displays used for shop window dressing (excl. the articles actually on display, educational models and toy dolls)','Maniquíes y artículos simil., autómatas y escenas animadas para escaparates (exc. modelos para demostraciones, muñecas de juguete y los propios artículos expuestos)',96,9618);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (961900,'Absorventes e tampões higiênicos, cueiro e fralda para bebê','Sanitary towels and tampons, diapers and diaper for infants','Compresas y tampones higiénicos, pañales y pañales para los bebés',96,9619);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (970110,'Quadros, pinturas e desenhos, feitos inteiramente à mão','Paintings, e.g. oil paintings, watercolours and pastels, and drawings executed entirely by hand (excl. technical drawings and the like of heading 4906, and hand-painted or hand-decorated manufactured articles)','Pinturas y dibujos, hechos totalmente a mano (exc. dibujos de la partida 4906 y artículos manufacturados decorados a mano)',97,9701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (970190,'Colagens e quadros decorativos semelhantes','Collages and similar decorative plaques','Collages y cuadros simil.',97,9701);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (970200,'Gravuras, estampas e litografias, originais','Original engravings, prints and lithographs','Grabados, estampas y litografías originales',97,9702);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (970300,'Produções originais de arte estatuária ou de escultura, de quaisquer matérias','Original sculptures and statuary, in any material','Obras originales de estatuaria o escultura, de cualquier materia',97,9703);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (970400,'Selos postais e fiscais, marcas postais e artigos semelhantes, sem curso nem destinados a ter curso no país de destino','Postage or revenue stamps, stamp-postmarks, first-day covers, postal stationery, stamped paper and the like, used, or if unused, not of current or new issue in which they have, or will have, a recognised face value','Sellos "estampillas" de correos, timbres fiscales, marcas postales, sobres primer día, enteros postales, demás artículos franqueados y análogos, incl. obliterados, que no tengan ni estén destinados a tener curso legal en el país en el que su valor facial ',97,9704);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (970500,'Coleções e espécimes para coleções, de zoologia, botânica, mineralogia, anatomia, ou apresentando interesse histórico, arqueológico, paleontológico, etnográfico ou numismático','Collections and collector''s pieces of zoological, botanical, mineralogical, anatomical, historical, archaeological, palaeontological, ethnographic or numismatic interest','Colecciones y especímenes para colecciones de zoología, botánica, mineralogía o anatomía o que tengan interés histórico, arqueológico, paleontológico, etnográfico o numismático',97,9705);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (970600,'Antigüidades com mais de 100 anos','Antiques of  > 100 years old','Antigüedades de más de cien años',97,9706);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (999000,'Zonas francas (free-shop)','Free-shop','Zonas francas (free-shop)',99,9990);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (999100,'Encomendas postais','Parcel post','Encomiendas postales',99,9991);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (999200,'Amostras','Samples','Muestras',99,9992);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (999300,'Comércio de combustíveis de panol, apetrechos, etc.','Trade of panol fuels,equipments,etc.','Comercio de combustibles de panol, pertrechos, etc',99,9993);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (999400,'Mercadorias em devolução','Goods in devolution','Mercancías en devolución',99,9994);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (999500,'Mercadorias em arrendamento não financeiro','Goods in leasing no financial','Mercaderias en arriendo',99,9995);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (999600,'Bagagem (provenientes de mudanças)','Luggage (coming of changes)','Equipaje (provenientes de mudanzas)',99,9996);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (999700,'Mercadorias doadas','Donated goods','Mercaderias donadas',99,9997);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (999801,'Consumo de bordo (combustíveis e lubrificantes para embarcações e aeronaves)','Consumption on board (fuels and lubricants for ships and aircraft)','Consumo a bordo (combustibles y lubricantes para embarcaciones y aeronaves)',99,9998);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (999802,'Consumo de bordo para embarcações e aeronaves (exceto combustíveis e lubrificantes)','Consumption on board ships and aircraft (except fuels and lubricants)','Consumo a bordo de buques y aeronaves (exc.combustibles y lubricantes)',99,9998);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (999971,'Pedras, em bruto ou trabalhadas, do Capítulo 71','Stones, raw or worked, from Chapter 71','Piedras, en bruto o no, del capítulo 71',99,9999);
INSERT INTO migra_sub_posicao (id, sub_portugues, sub_ingles, sub_espanhol, id_capitulo, id_posicao) VALUES (999999,'Qualquer outra mercadoria sem cobertura cambial; reexportação','Any other goods without exchange cover; reexport','Todos otros bienes  sin cobertura de cambios y reexportación',99,9999);



CREATE TABLE migra_digito(
    id              CHAR(8)         NOT NULL,
    dig_portugues   VARCHAR(150)    NOT NULL,
    dig_ingles      VARCHAR(150)    NOT NULL,
    dig_espanhol    VARCHAR(150)    NOT NULL,
    id_unidade      CHAR(2)         NOT NULL,
    id_capitulo     CHAR(2)         NOT NULL,
    id_posicao      CHAR(4)         NOT NULL,
    id_sub_posicao  CHAR(6)         NOT NULL,
    CONSTRAINT pk_digito            PRIMARY KEY (id)--,
--    CONSTRAINT fk_digito_1          FOREIGN KEY                     (id_capitulo)
--                                    REFERENCES migra_capitulo       (id),
--    CONSTRAINT fk_digito_2          FOREIGN KEY                     (id_posicao)
--                                    REFERENCES migra_posicao        (id),
--    CONSTRAINT fk_digito_3          FOREIGN KEY                     (id_sub_posicao)
--                                    REFERENCES migra_sub_posicao    (id)
);

--'CO_SH8','NO_SH8_POR','NO_SH8_ING','NO_SH8_ESP','CO_UNID','SH2','SH4','SH6'
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01011010','Cavalos reprodutores de raça pura','Pure-bred breeding horses','Caballos reproductores de raza pura',11,'01','0101','010110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01011090','Animais espec.asinina/muar, reprodutores, raça pura','Asses/mules/hinnies animals, pure-bred breeding','Asnos, mulos y burdéganos, reprod.de raza pura',11,'01','0101','010110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01011100','Cavalos reprodutores, de raça pura','Pure-bred breeding horses','Caballos reproductores de raza pura',11,'01','0101','010111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01011900','Outros cavalos, vivos','Other live horses','Los demás caballos vivos',11,'01','0101','010119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01012000','Asininos e muares vivos','Live asses, mules and hinnies','Asnos, mulos y burdéganos, vivos',11,'01','0101','010120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01012100','Cavalos reprodutores de raça pura','Pure-bred horses','Caballos de pura raza, para procreación',11,'01','0101','010121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01012900','Cavalos vivos, exceto reprodutores de raça pura','Lives horses, except pure-bred breeding','Caballos vivos, excepto reproductores de raza pura',11,'01','0101','010129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01013000','Animais espécie asinina/muar, reprodutores de raça pura','Asses, pure-bred breeding','Especies asnales/muar, de raza pura, para procreación',11,'01','0101','010130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01019000','Animais espécie asinina/muar, exceto reprod. raça pura','Asses, except pure-bred breeding','Especies asnales/muar, de raza pura,ex.para procreación',11,'01','0101','010190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01019010','Cavalos vivos, exceto reprodutores raça pura','Live horses, except pure-bred breeding','Caballos vivos,  excepto reproductores de raza pura',11,'01','0101','010190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01019090','Animais esp.asinina/muar, exc.reprod.raça pura','Asses/mules/hinnies, except pure-bred breeding','Asnos, mulos y burdéganos, exc.reprod.raza pura',11,'01','0101','010190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01021010','Bovinos reprodutores de raça pura, prenhe ou cria ao pé','Pure-bred breeding bovine, pregnant or lactating','Bovinos reproduct.de raza pura, preñad.o c/cría al pie',11,'01','0102','010210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01021090','Outros bovinos reprodutores de raça pura','Other pure-bred breeding bovines','Otros bovinos reproductores de raza pura',11,'01','0102','010210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01022110','Bovinos reprodutores raça pura, prenhe ou c/ cria ao pé','Purebred breeding cattle, pregnant or lactating','Bovinos repoductores de pura raza, embarazado',11,'01','0102','010221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01022190','Outros bovinos reprodutores de raça pura','Other pure-bred cattle, for breeding','Otros bovinos procreadores de pura raza',11,'01','0102','010221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01022911','Outros bovinos para reprodução, prenhe ou c/ cria ao pé','Other bovine animals for breeding,pregnant or lactating','Otros bovinos para procreación, embarazado',11,'01','0102','010229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01022919','Outros bovinos para reprodução','Other bovine animals for breeding','Otros bovinos para procreación',11,'01','0102','010229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01022990','Outros bovinos vivos','Other live catlle','Otros bovinos vivos',11,'01','0102','010229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01023110','Búfalos reprodutores de raça pura, prenhe ou c/cria pé','Pure-bred breeding buffalo, pregnant or lactating','Búfalos para procreación, pura raza, embarazado',11,'01','0102','010231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01023190','Outros búfalos reprodutores de raça pura','Other pure-bred breeding buffalo','Otros búfalos para procreación, de pura raza',11,'01','0102','010231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01023911','Outros búfalos p/reprod.,exc.raça pura,pren.ou c/cria pé','Other buffalo for breeding, ex. pure-bred or pregnant','Otros búfalos p/ procreacíon,ex.embarazado o pura raza',11,'01','0102','010239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01023919','Outros búfalos para reprodução,exc.reprod. raça pura','Other buffalo for breeding, except pure-bred breeding','Otros búfalos para procreación, excepto de pura raza',11,'01','0102','010239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01023990','Outros búfalos','Other buffalos','Otros búfalos',11,'01','0102','010239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01029000','Outros animais vivos da espécie bovina','Other live animals of bovine species','Otros animales vivos de la especie bovina',11,'01','0102','010290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01029011','Outros bovinos para reprodução, prenhe ou com cria ao pé','Other pure-bred breeding bovines pregnant/lactanting','Los dem.bovinos p/reproducción, preñad.o c/cría al pie',11,'01','0102','010290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01029019','Outros bovinos para reprodução','Other pure-bred breeding bovines','Otros bovinos para reproducción',11,'01','0102','010290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01029090','Outros bovinos vivos','Other live bovines','Otros bovinos vivos',11,'01','0102','010290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01031000','Suínos reprodutores de raça pura','Pure-bred breedig swines','Porcinos reproductores de raza pura',11,'01','0103','010310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01039100','Outros suínos vivos, de peso inferior a 50 Kg','Other live swine, weighing less than 50 kg','Los demás porcinos vivos, con peso inferior a 50 kg',11,'01','0103','010391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01039200','Outros suínos vivos, de peso igual ou superior a 50Kg','Other live swine, weighing 50 kg or more','Los dem.porcinos vivos, c/peso igual o superior a 50 kg',11,'01','0103','010392');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01041011','Ovinos reprodutores de raça pura, prenhe/com cria ao pé','Pure-bred breeding, pregnant or lactating, sheep','Ovinos reproductores de raza pura, preñad.c/cría al pie',11,'01','0104','010410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01041019','Outros ovinos reprodutores de raça pura','Other pure-bred breeding sheep','Los demás ovinos reproductores de raza pura',11,'01','0104','010410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01041090','Outros ovinos vivos','Others live sheep','Otros ovinos vivos',11,'01','0104','010410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01042010','Caprinos reprodutores de raça pura','Pure-bred breeding goats','Caprinos reproductores de raza pura',11,'01','0104','010420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01042090','Outros caprinos vivos','Other live goats','Los demás caprinos vivos',11,'01','0104','010420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01051110','Galos e galinhas, p<=185g, de linha pura/hibrida, para reprodução','Fowls spec.gallus domestic.w<=185g pure-bred breeding','Gallos y gallinas, p<= 185 g, de línea pura/híbr.p/reprod',11,'01','0105','010511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01051190','Outros galos e galinhas, vivos, peso não superior a 185g','Oth.live fowls spec.gall.domest.weig.not more than 185g','Los dem.gallos y gallinas vivos, p.infer.o igual a 185 g',11,'01','0105','010511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01051200','Peruas e perus, vivos, de peso não superior a 185g','Live turkeys, weighing not more than 185g','Pavos(gallipavos) vivos de peso inferior o igual a185 g',11,'01','0105','010512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01051300','Patos','Ducks','Patos',11,'01','0105','010513');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01051400','Gansos','Geese','Gansos',11,'01','0105','010514');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01051500','Galinhas dangola - pintadas','Dangola chickens - painted','Pollos dangola - pintados',11,'01','0105','010515');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01051900','Patos, gansos e galinhas d''angola, vivos, de peso<=185g','Live ducks/geese/guine fowls, weighing<=185g','Patos, gansos y pintadas vivos de peso<=185g',11,'01','0105','010519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01059200','Outros galos e galinhas, vivos, de peso<=2.000g','Other live fowls species gallus domesticus, w<=2.000g','Los demás gallos y gallinas vivos de peso <= 2000 g',11,'01','0105','010592');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01059300','Galos e galinhas, vivos, de peso superior a 2.000g','Live fowls species gallus domesticus weighing 2.000g','Gallos y gallinas vivos de peso superior a 2000 g',11,'01','0105','010593');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01059400','Outros galos e galinhas, vivos, de peso<=2.000g','Other live fowls species gallus domesticus, w<=2.000g','Los demás gallos y gallinas vivos de peso <= 2000 g',11,'01','0105','010594');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01059900','Patos, gansos, perus, peruas e pintadas, vivos, de peso >185 g','Live ducks/geese/turkeys/guinea fowls, weighing>185g','Patos, gansos, pavos y pintadas vivos de peso>185g',11,'01','0105','010599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01060000','Outros animais vivos','Other live animals','Otros animales vivos',11,'01','0106','010600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01060010','Avestruzes (Struthio camelus) para reprodução','Ostriches (Struthio camelus) for breeding','Avestruz (Struthio camelus) para reproducción',11,'01','0106','010600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01060090','Outros animais vivos','Other live animals','Otros animales vivos',11,'01','0106','010600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01061100','Mamíferos primatas vivos','Primate mammals, alive','Mamíferos primitivos vivos',11,'01','0106','010611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01061200','Baleias, golfinhos e outros mamíferos vivos','Whales, dolphins and other live mammals','Ballenas, delfines y demás mamíferos vivos',11,'01','0106','010612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01061300','Camelos e outros camelídeos (Camelidae)','Camels and camelids (Camelidae)','Camellos y camélidos (Camelidae)',11,'01','0106','010613');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01061400','Coelhos e lebres','Rabbits and hares','Conejos y liebres',11,'01','0106','010614');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01061900','Outros mamíferos vivos','Other live mammals','Los demás mamíferos vivos',11,'01','0106','010619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01062000','Répteis vivos (inclusive serpentes e tartarugas)','Live reptiles (incl.snakes and turtles)','Reptiles vivos(incl.las serpientes y tortugas de mar)',11,'01','0106','010620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01063100','Aves de rapina, vivas','Live birds of prey','Aves de rapiña vivas',11,'01','0106','010631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01063200','Psitaciformes vivos (inclusive papagaio, arara, etc)','Live psittaciformes (incl.parrots, macaws, etc)','Psitaciformes vivos(incl.los loros, cacatuas, etc)',11,'01','0106','010632');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01063310','Avestruzes (struthio camelus), para reprodução','Ostriches (struthio camelus) for breeding','Avestruces (struthio camelus) para la procreación',11,'01','0106','010633');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01063390','Outros avestruzes','Other ostrich','Otros avestruces',11,'01','0106','010633');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01063900','Outras aves vivas','Other living birds','Otras aves vivas',11,'01','0106','010639');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01063910','Avestruzes para reprodução','Ostriches (struthio camelus) for breeding','Avestruz para reproducción',11,'01','0106','010639');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01063990','Outras aves vivas','Other live birds','Otras aves vivas',11,'01','0106','010639');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01064100','Abelhas','Bees','Abejas',10,'01','0106','010641');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01064900','Outros insetos','Other insects','Otros insectos',10,'01','0106','010649');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('01069000','Outros animais vivos','Other live animals','Otros animales vivos',11,'01','0106','010690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02011000','Carcaças e meias carcaças de bovino, frescas ou refrigeradas','Carcases/half-carcases of bovine fresh/chilled','Canales y medias canales de esp.bovina, fresca/refr',10,'02','0201','020110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02012010','Quartos dianteiros n/desossad.de bovino, frescos/refrigerados','Fresh/chilled forequarters of bovine with bone in','Cuartos delanteros c/huesos de la esp.bov.fresc.refrig.',10,'02','0201','020120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02012020','Quartos traseiros não desossad.de bovino, frescos/refrigados','Fresh/chilled hindquaters of bovine with bone in','Cuartos traseros s/deshues.de la esp.bov.fresc.refrig.',10,'02','0201','020120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02012090','Outras peças não desossadas de bovino, frescas ou refrigeradas','Other fresh/chilled cuts of bovine with bone in','Los dem.cortes s/deshues.de la esp.bovina, fresc.o refr',10,'02','0201','020120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02013000','Carnes desossadas de bovino, frescas ou refrigeradas','Fresh or chilled bovine meat, boneless','Carnes deshuesadas de la esp.bovina, frescas o refriger.',10,'02','0201','020130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02021000','Carcaças e meias-carcaças de bovino, congeladas','Frozen bovine carcases and half-carcases','Canales o medias canales de la esp.bovina, congeladas',10,'02','0202','020210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02022010','Quartos dianteiros não desossados de bovino, congelados','Frozen  forequarters of bovines,  with bone in,  frozen','Cuartos delanteros s/deshues.de la esp.bov.congelados',10,'02','0202','020220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02022020','Quartos traseiros não desossados de bovino, congelados','Frozen hindquarter of bovines, with bone in, frozen','Cuartos traseros s/deshues.de la esp.bovina, congelados',10,'02','0202','020220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02022090','Outras peças não desossadas de bovino, congeladas','Other frozen bovine cuts','Las dem.piezas s/deshues.de la esp.bovina, congeladas',10,'02','0202','020220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02023000','Carnes desossadas de bovino, congeladas','Frozen bovine meat, boneless','Carnes deshuesadas de la especie bovina, congeladas',10,'02','0202','020230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02031100','Carcaças e meias-carcaças de suíno, frescas ou refriger.','Fresh or chilled carcases and half-carcases of swine','Canales o medias can.de la esp.porcina, fresca/refr',10,'02','0203','020311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02031200','Pernas, pas, etc.nao desossad.de suíno, frescos ou refrig.','Fresh/chilled hams/shoulders/cuts of swine with bone in','Piernas, paletas, etc s/deshues.de la esp.porc.fresc/ref',10,'02','0203','020312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02031900','Outras carnes de suíno, frescas ou refrigeradas','Other fresh or chilled meat of swine','Las dem.carnes de la esp.porcina, frescas o refrigeradas',10,'02','0203','020319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02032100','Carcaças e meias-carcaças de suíno, congeladas','Frozen carcases and half-carcases of swine','Canales o medias canales de la esp.porcina, congeladas',10,'02','0203','020321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02032200','Pernas, pás e pedaços não desossados de suíno, cong.','Frozen hams, shoulders and cuts of swine, fr.','Piernas, paletas y pedazos s/deshues.de la esp.porc, cong',10,'02','0203','020322');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02032900','Outras carnes de suíno, congeladas','Other swine meat, frozen','Las demás carnes de la esp.porcina, congeladas',10,'02','0203','020329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02041000','Carcaças e meias-carcaças de cordeiro, frescas ou refrigeradas','Lamb carcases and half-carcases, fresh or chilled','Canales o medias canales de cordero, fresc.refrig',10,'02','0204','020410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02042100','Carcaças e meias-carcaças de ovino, frescas ou refrigeradas','Sheep carcases and half-carcases, fresh or chilled','Canales o medias canales de ovino, fresc.refrig',10,'02','0204','020421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02042200','Outras peças nao desossadas de ovino, frescas ou refrigeradas','Other sheep cuts, with bone in, fresh or chilled','Los dem.cortes c/huesos de la esp.ovina, fresc.refrig.',10,'02','0204','020422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02042300','Carnes desossadas de ovino, frescas ou refrigeradas','Other meat of sheep, boneless, fresh or chilled','Carnes deshues.de la esp.ovina, frescas o refrigeradas',10,'02','0204','020423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02043000','Carcaças e meias-carcaças de cordeiro, congeladas','Carcases and half-carcases of lamb, frozen','Canales o medias canales de cordero, congeladas',10,'02','0204','020430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02044100','Carcaças e meias-carcaças de ovino, congeladas','Carcases and half-carcases of sheep, frozen','Canales o medias canales de la esp.ovina, congeladas',10,'02','0204','020441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02044200','Outras peças não desossadas de ovino, congeladas','Other lamb cuts with bone in, frozen','Los demás cortes s/deshuesar de la esp.ovina, congeladas',10,'02','0204','020442');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02044300','Carnes desossadas de ovino, congeladas','Meat of sheep, boneless, frozen','Carnes deshuesadas de la esp.ovina, congeladas',10,'02','0204','020443');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02045000','Carnes de caprino, frescas, refrigeradas ou congeladas','Meat of goats, fresh, chilled or frozen','Carnes de la esp.capr.frescas,  refrigeradas o congeladas',10,'02','0204','020450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02050000','Carnes de cavalo, asinino e muar, frescas, refrig.ou cong.','Meat of horses, asses, mules, etc.fresh, chilled or frozen','Carnes de la esp.caball.asnal y mular, fresc.ref.o cong.',10,'02','0205','020500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02061000','Miudezas comestíveis de bovino, frescas ou refrigeradas','Edible offal of bovine, fresh or chilled','Despojos comestibles de la esp.bovina, frescos o refrig.',10,'02','0206','020610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02062100','Línguas de bovino, congeladas','Frozen edible bovine tongues','Lenguas de la esp.bovina, congeladas',10,'02','0206','020621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02062200','Fígados de bovino, congelados','Frozen edible bovine livers','Hígado de la esp.bovina, congelados',10,'02','0206','020622');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02062910','Rabos de bovino, congelados','Frozen edible bovine tails','Rabos de la esp.bovina, congelados',10,'02','0206','020629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02062990','Outras miudezas comestíveis de bovino, congeladas','Other frozen edible bovine offal','Los dem.despojos comestibles de la esp.bovina, congel.',10,'02','0206','020629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02063000','Miudezas comestíveis de suíno, frescas ou refrigeradas','Fresh or chilled edible offal of swine','Despojos comestibles de la esp.porc.frescos o refrig.',10,'02','0206','020630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02064100','Fígados de suíno, congelados','Frozen edible livers of swine','Hígados de la esp.porcina, congelados',10,'02','0206','020641');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02064900','Outras miudezas comestíveis de suíno, congeladas','Other edible offal of swine, frozen','Los dem.despojos comestibles de la esp.porcina, congel.',10,'02','0206','020649');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02068000','Miudezas comestíveis, de ovino, etc.frescas/refrigeradas','Fresh or chilled edible offal of goats','Despojos comestibles, de ovino, etc, fresc/refrig.',10,'02','0206','020680');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02069000','Miudezas comestíveis, de ovino, caprino, etc.congeladas','Edible offal of sheep, goats, etc.frozen','Despojos comestibles, de la esp.ovina, caprina, etc, cong.',10,'02','0206','020690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02071100','Carnes de galos/galinhas, n/cort.pedaços, frescas/refrig.','Fresh/chilled fowls spec.gallus domestic.n/cut in piece','Carnes de gallo/gallina, s/trocear, frescas/refrig.',10,'02','0207','020711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02071200','Carnes de galos/galinhas, n/cortadas em pedaços, congel.','Frozen fowls spec.gallus domest.n/cut in piece','Carnes de gallo/gallina, s/trocear, congeladas',10,'02','0207','020712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02071300','Pedaços e miudezas, de galos/galinhas, frescos/refriger.','Fowls spec.gal.domest.cuts and offal, fresh/chilled','Trozos y despojos comest.de gallo/gallina, fresc.refrig',10,'02','0207','020713');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02071400','Pedaços e miudezas, comestíveis de galos/galinhas, congelados','Fowls spec.gal.domest.cuts and offal, frozen','Trozos y despojos comest.de gallo/gallina, congelados',10,'02','0207','020714');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02072400','Carnes de peruas/perus, n/cort.pedaços, frescas/refriger.','Fresh/chilled meat of turkeys, n/cut in piece','Carnes de pavo, s/trocear, fresco/refrigerado',10,'02','0207','020724');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02072500','Carnes de peruas/perus, n/cortadas em pedaços, congeladas','Frozen meat of turkeys, not cut in piece','Carnes de pavo, s/trocear, congelados',10,'02','0207','020725');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02072600','Carnes de peruas/perus, em pedaços, miudez.frescos/refrig','Fresh/chilled meat of turkeys, cuts and offal','Carnes de pavos, trozos frescos/refrigerados',10,'02','0207','020726');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02072700','Carnes de peruas/perus, em pedaços e miudezas, congeladas','Frozen meat of turkeys, cuts and offal','Carnes de pavos en trozos y despojos, congelados',10,'02','0207','020727');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02073200','Carnes de patos, etc.n/cort.em pedaços, frescas/refrigeradas','Fresh/chilled meat of ducks, etc.not cut in piece','Carnes de pato, etc, s/trocear, fresco/refrigerado',10,'02','0207','020732');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02073300','Carnes de patos, gansos, etc.n/cort.em pedaços, congeladas','Frozen meat of ducks, geese, etc.n/cut in piece','Carnes de pato, etc, s/trocear, fresco/refrigerado',10,'02','0207','020733');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02073400','Fígados gordos, de patos/gansos/pintadas, frescos/refrig.','Fresh/chill.edible fatty livers of ducks/geese/guinea','Hígados grasos, de patos/gansos/pintadas, fresc/refrig.',10,'02','0207','020734');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02073500','Outs.carnes/miudezas, de patos, gansos, etc.frescas, refrig','Fresh/chill.oth.edible fatty livers of ducks, geese, etc','Las dem.carnes/despoj.com.de pato, ganso, etc, fresc.refr.',10,'02','0207','020735');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02073600','Outras carnes, miudezas, de patos, gansos, etc.congeladas','Frozen other edible meat offal of duck, geese, etc','Las dem.carnes, desp.comest.de pato, ganso, etc, congelado',10,'02','0207','020736');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02074100','Carnes de patos, nao cort. em pedaços,frescas ou refrig','Meat of ducks, not cut in pieces, fresh or chilled','Carne de pato, sin trocear, frescas o refrigeradas',10,'02','0207','020741');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02074200','Carnes de patos, não cortadas em pedaços, congeladas','Meat of ducks, not cut in pieces, frozen','Carne de pato, no cortado en trozos, congeladas',10,'02','0207','020742');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02074300','Figados gordos (foies gras) de patos, fres. ou refrig.','Fatty livers of ducks, fresh or chilled','Los hígados grasos de patos, frescos o refrigerados',10,'02','0207','020743');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02074400','Outras carnes de patos, frescas ou refrigeradas','Other meats of ducks, fresh or chilled','Las demás carnes de pato, frescas o refrigeradas',10,'02','0207','020744');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02074500','Outras carnes de patos, congeladas','Other meats of ducks, frozen','Las demás carnes de pato, congeladas',10,'02','0207','020745');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02075100','Carnes de gansos, não cort. em ped., frescas ou refrig','Meat of geese, not cut in pieces, fresh or chilled','Carne de ganso, sin trocear, frescas o refrigeradas',10,'02','0207','020751');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02075200','Carnes de gansos, não cortadas em pedaços, congeladas','Meat of geese, not cut in pieces, frozen','Las demás carnes de los gansos, congeladas',10,'02','0207','020752');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02075300','Figados gordos (foies gras) de gansos,frescos ou refrig','Fatty livers of geese, fresh or chilled','Los hígados grasos de gansos, frescos o refrigerados',10,'02','0207','020753');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02075400','Outras carnes de gansos, frescas ou refrigeradas','Other meat of geese, fresh or chilled','Las demás carnes de los gansos, frescas o refrigeradas',10,'02','0207','020754');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02075500','Outras carnes de gansos, congeladas','Other meat of geese, frozen','Las demás carnes de los gansos, congelados',10,'02','0207','020755');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02076000','Carnes de galinhas dangola (pintadas)','Meat of dangola chicken (painted)','Carne de pollo dangola (pintado)',10,'02','0207','020760');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02081000','Carnes/miudezas, de coelhos/lebres, frescas/refrig/congel','Fres/chil/froz oth.meat/edib.meat offal of rabib./hares','Carnes/desp.comest.de conejo/liebre, fresc.refrig.cong.',10,'02','0208','020810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02082000','Coxas de rã, frescas, refrigeradas ou congeladas','Fresh/chilled/frozen frogs'' legs','Ancas de rana, frescas, refrigeradas o congeladas',10,'02','0208','020820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02083000','Carnes de primatas, congeladas, frescas, refrigeradas','Meat of primates, fresh/chilled/frozen','Carnes de primates, congeladas, frescas, refrigeradas',10,'02','0208','020830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02084000','Carnes de baleias, etc.cong.frescas, refriger.','Meat of whales, etc, fresh/chilled/frozen','Carnes de ballenas, etc, congelado, fresco, refrigerado',10,'02','0208','020840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02085000','Carnes de répteis, cong.frescas, refrigeradas','Meat of reptiles, fresh/chilled/frozen','Carnes de reptiles, congeladas, frescas, refrigeradas',10,'02','0208','020850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02086000','Outras carnes/miud.comes,de camelos e outros camelideos','Other meat and edible offal, of camels and camilídeos','Demás carnes y despojos comestibles, de los camellos',10,'02','0208','020860');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02089000','Carnes e miudezas, de outs.animais, frescos/refrig/cong.','Fresh/chilled/frozen meat/edib.meat offal,  of other animals','Carnes y despojos com.de dem.animales, fresc.refr.cong.',10,'02','0208','020890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02090011','Toucinho sem partes magras, fresco/refrigerado/congelado','Fresh/chilled/frozen pig fat, free of lean meat','Tocino sin partes magras, fresco/refrigerado/congelado',10,'02','0209','020900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02090019','Toucinho s/ partes magras, salgado/salmoura/seco/defumado','Salted/in brine/dried/smoked pig fat,  free of lean meat','Tocino s/partes magras, salado/en salmuera/seco/ahumado',10,'02','0209','020900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02090021','Gordura de porco, fresca, refrigerada ou congelada','Fresh, chilled or frozen pig fat','Grasa de cerdo, fresca, refrigerada o congelada',10,'02','0209','020900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02090029','Gordura de porco,n/fundida,salgada,em salmoura,seca,etc','Salted, in brine, dried, smoked, etc. pig fat','Grasa de cerdo,  s/fundir,  salada,  en salmuera,  seca,  etc',10,'02','0209','020900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02090090','Gordura de aves, n/fundida,fresca, efriger., congel.etc','Bird fat,  not rendered,  fresh,  chilled,  frozen, etc.','Grasa de ave,  s/fundir,  fresca,  refrigerada,  congelada, etc',10,'02','0209','020900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02091011','Toucinho de porco, fresco, refrigerado ou congelado','Bacon pork, fresh, chilled or frozen','Tocino de cerdo, fresco, refrigerado o congelado',10,'02','0209','020910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02091019','Outros toucinhos de porco','Other pork fat','Otros tocinos de cerdos',10,'02','0209','020910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02091021','Gordura de porco, fresca, refrigerada ou congelada','Fat of pork, fresh, chilled or frozen','Grasa de cerdo, fresca, refrigerada o congelada',10,'02','0209','020910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02091029','Outras gorduras de porco','Other pork fat','Otras grasas de cerdo',10,'02','0209','020910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02099000','Outros toucinhos e gorduras','Bacon and other fats','Otros tocinos y grasas',10,'02','0209','020990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02101100','Pernas/pas/pedaços,de suíno,n/desossados,salgados,etc.','Hams, should.and cuts of swine, with bone in, salted, etc.','Piernas/paletas/trozos de la esp.porc.s/desh.salad.etc',10,'02','0210','021011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02101200','Barrigas e peitos, entremeados, de suíno, salgados, etc.','Bellies and chest "streaky" of swine, salted, etc.','Tocino entreverado de panza, salado,  etc',10,'02','0210','021012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02101900','Outs.carnes de suíno, salgadas ou em salmoura, secas, etc.','Other meat of swine, salted, brine, dried, etc.','Las dem.carnes de la esp.porc.salad.o en salm.secas, etc',10,'02','0210','021019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02102000','Carnes de bovinos, salgadas/em salmoura/secas/defumadas','Meat of bovine, salted/in brine/dried/smoked','Carnes de la esp.bovina, saladas/en salm./secas/ahumad.',10,'02','0210','021020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02109000','Carnes e miudezas, de outros animais, salgados, etc.','Meat and edible meat offal of oth.animals, salted, etc.','Carnes y despojos de demás animales, salados,  etc',10,'02','0210','021090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02109100','Carnes de primatas, salgadas, secas, etc.','Meat of primates, salted, dried, in brine, etc.','Carnes de primitivos, saladas, secas, etc',10,'02','0210','021091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02109200','Carnes de baleias, etc.salgadas, secas, etc.','Meat of whales, etc, salted, dried, etc.','Carnes de ballenas, etc, saladas, secas, etc',10,'02','0210','021092');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02109300','Carnes de répteis, salgadas, secas, etc.','Meat of reptiles, salted, dried, etc.','Carnes de reptiles, saladas, secas, etc',10,'02','0210','021093');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('02109900','Carnes de outros animais, salgadas, secas, etc.','Meat of other animals, salted, dried, etc.','Carnes de demás animales, saladas, secas, etc',10,'02','0210','021099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03011000','Peixes ornamentais, vivos','Ornamental live fish','Peces ornamentales, vivos',11,'03','0301','030110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03011010','Aruana (Osteoglossum bicirrhosum), peixes ornament.vivos','Live aruwana (Osteoglossum bicirrhosum)ornam.live fish','Arahuana(Osteoglossum bicirrhosum), peces ornament.vivos',11,'03','0301','030110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03011090','Outros peixes ornamentais vivos','Other ornamental live fish','Los dem.peces ornamentales vivos',11,'03','0301','030110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03011110','Aruana (Osteoglossum bicirrhosum)','Aruana (Osteoglossum bicirrhosum)','Aruana (Osteoglossum bicirrhosum)',11,'03','0301','030111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03011190','Outros peixes ornamentais, vivos, de água doce','Other ornamental fish, live, freshwater','Otros peces ornamentales, vivos, de agua dulce',11,'03','0301','030111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03011900','Outros peixes ornamentais vivos','Other ornamental fish, live','Otros peces ornamentales, vivos',11,'03','0301','030119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019110','Trutas (salmo trutta e oncorhynchus), para reprodução','Trout (salmo trutta oncorhynchus), for breeding','Truchas(salmo trutta y oncorhynchus), p/reproducción',10,'03','0301','030191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019190','Outras trutas (salmo trutta e oncorhynchus), vivas','Other live trout (salmo trutta oncorhynchus)','Las dem.truchas (salmo trutta y oncorhynchus) vivas',10,'03','0301','030191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019210','Enguias (anguilla spp.) para reprodução','Live eels (anguilla spp.) for breeding','Anguilas (anguilla spp.) para reproducción',10,'03','0301','030192');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019290','Outras enguias (anguilla spp.) vivas','Other live eels  (anguillas spp.)','Las dem.anguilas (anguillas spp.) vivas',10,'03','0301','030192');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019310','Carpas para reprodução','Carp for breeding','Carpas para reproducción',10,'03','0301','030193');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019390','Outras carpas vivas','Other live carp','Las demás carpas vivas',10,'03','0301','030193');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019410','Albacoras-azuis(thunnus thynnus)p/reprodução','Blue yellowfin (thunnus thynnus), for breeding','Amarilla (thunnus thynnus) for breeding',10,'03','0301','030194');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019490','Outs.albacoras-azuis(thunnus thynnus)p/repr.','Others blue yellowfin (thunnys thynnus) for breeding','Otros amarillas (thunnus thynnus) for breeding',10,'03','0301','030194');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019510','Outros peixes para reprodução','Other breeding fish','Otros peces para reproducción',10,'03','0301','030195');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019590','Outros peixes vivos','Other fishes, alive','Otros peces, vivos',10,'03','0301','030195');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019910','Outros peixes para reprodução','Other fish, for breeding','Otros peces para reproducción',10,'03','0301','030199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019911','Tilápias, peixes para reprodução','Tilapias, fishes for breeding','Tilapia. peces para reproduccion',10,'03','0301','030199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019912','Esturjões, peixes para reprodução','Sturgeons, fishes for breeding','Esturiones, peces para reproduccion',10,'03','0301','030199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019919','Outros peixes para reprodução','Other fish, for breeding','Otros peces para reproducción',10,'03','0301','030199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019990','Outros peixes vivos','Other live fish','Otros peces vivos',10,'03','0301','030199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019991','Outros peixes tilápias, vivos','Other tilapia fishes, alive','Otros peces tilapia, vivos',10,'03','0301','030199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019992','Outros peixes esturjões, vivos','Other sturgeon fishes, alive','Otros peces esturiones, vivos',10,'03','0301','030199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03019999','Outros peixes vivos','Other live fish','Los demás peces vivos',10,'03','0301','030199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03021100','Trutas frescas, refrig.exc.files, outs.carnes, fígados, etc','Fresh or chilled trout exc.filets, oth.meat liver, etc.','Truchas fresc.refrig.exc.filetes, dem.carnes, hígados, etc',10,'03','0302','030211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03021200','Salmões-do-pacífico, etc.frescos, refrig.exc.filés, etc.','Fresh or chilled pacific salmon, etc.except filets, etc.','Salmones del pacífico, etc, fresc.refrig.exc.filetes, etc',10,'03','0302','030212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03021300','Salmões-do-pacifico (oncorhynchus nerka, etc), fr.ou r.','Pacific salmon, fresh or chilled','Salmón del pacífico, frescos o refrigerados',10,'03','0302','030213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03021400','Salmão-do-atlantico e salmão-do-danubio, fr. ou refri.','Atlantic salmon and danube salmon, fresh or chilled','Salmón del atlántico y salmon del danubio, fr/ref.',10,'03','0302','030214');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03021900','Outros salmonídeos frescos, refrig.exc.filés, etc.','Other fresh or chilled salmonidae exc.fish filets, etc.','Los dem.salmónidos frescos, refrigerados, exc.filetes, etc',10,'03','0302','030219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03022100','Linguados-gigantes, frescos, refrig.exc.filés, etc.','Fresh/chilled halibut exc.filets, etc.','Lenguados gigantes, frescos, refrigerados, exc.filetes, etc',10,'03','0302','030221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03022200','Solhas ou patrucas, frescas, refrig.exc.filés, etc.','Fresh/chilled plaice exc.filets, etc.','Sollas, frescas, refrigeradas, excepto filetes, etc',10,'03','0302','030222');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03022300','Linguados frescos, refrig.exc.filés, outras carnes, etc.','Fresh/chilled sole exc.fish filets, oth.fish meat, etc','Lenguados frescos, refriger.exc.filetes, dem.carnes, etc',10,'03','0302','030223');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03022400','Pregado (Psetta maxima), fresco ou refrigerado','Turbot (Psetta maxima), fresh or chilled','Rodaballo (Psetta maxima), fresco o refrigerado',10,'03','0302','030224');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03022900','Outros peixes chatos, frescos, refrig.exc.filés, etc.','Other fresh/chilled flat fish exc.fish filets, etc.','Los dem.pescados planos, frescos, refrig.exc.filetes, etc',10,'03','0302','030229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03023100','Atuns-brancos ou germoes, frescos/refriger.exc.filés, etc','Fresh/chilled tunas or skipjack exc.fish filets, etc.','Albacoras o atunes blancos, fresc/refr.exc.filetes, etc',10,'03','0302','030231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03023200','Albacoras/atuns barbat.amarela, frescas/refrig.exc.filés','Fresh/chilled yellowfin tunas exc.fish filets','Atunes de aleta amarilla, fresc/refr.exc.filetes',10,'03','0302','030232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03023300','Bonitos-listrados, etc.frescos, refrig.exc.filés, etc.','Fresh/chilled skipjack, etc.exc.fish filets, etc.','Listados o bonitos, etc, frescos, refriger.exc.filetes, etc',10,'03','0302','030233');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03023400','Albacoras-bandolim (patudos) frescos, refrig.','Fresh or chilled bigeye tunas "thunnus obesus"','Patudos o atunes ojos grandes, frescos, refrigerados',10,'03','0302','030234');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03023500','Albacoras-azuis (atuns-azuis) frescos, refrig.','Fresh/chilled bluefin tunas "thunnus thynnus"','Atunes de aleta azul, frescos, refrigerados',10,'03','0302','030235');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03023600','Atuns do sul frescos ou refrigerados','Fresh/chilled southern bluefin tunas','Atunes del sur,  frescos o refrigerados',10,'03','0302','030236');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03023900','Outros atuns frescos, refrig.exc.filés, outs.carnes, etc.','Other fresh/chilled tunas, exc.fish filets oth.fish meat, ','Los dem.atunes frescos, refr.exc.filetes, dem.carnes, etc',10,'03','0302','030239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03024000','Arenques frescos/refrigerados, exc.filés, outs.carnes, etc','Fresh/chilled herrings, exc.fish filets oth.fish meat, ','Arenques frescos/refriger.exc.filetes, dem.carnes, etc',10,'03','0302','030240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03024100','Arenques (clupea harengus, clupea pallasii), fr. ou refrig.','Herring(clupea harengus,clupea pallasii), fresh/chilled','Arenque(clupea harengus,clupea pallasii), fresco/refri.',10,'03','0302','030241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03024210','Anchoita (engraulis anchoita), frescas ou refrigeradas','Anchoita (engraulis anchoita), fresh or frozen','Anchoita (engraulis anchoita), frescas o refrigeradas',10,'03','0302','030242');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03024290','Outras anchovas, frescas ou refrigeradas','Other anchovies, fresh or chilled','Otras anchoas, frescas o refrigeradas',10,'03','0302','030242');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03024300','Sardinhas (sardina pilchardus, etc), anchoveta, fr.ou ref.','Sardines (sardina pilchardus, etc), fresh or chilled','Sardinas (sardina pilchardus, etc),fresca o refrigerada',10,'03','0302','030243');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03024400','Cavalinhas, frescas ou refrigeradas','Cavalinhas, fresh or frozen','Cavalinhas, frescas o refrigeradas',10,'03','0302','030244');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03024500','Chicharros (trachurus spp.), frescos ou refrigerados','Horse mackerel (trachurus spp.), fresh or chilled','Chicharros (trachurus spp.), frescos o refrigerados',10,'03','0302','030245');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03024600','Bijupira (rachycentron canadum), fres. ou refrig.','Cobia (rachycentron canadum), fresh or chilled','Cobia (rachycentron canadum), fresco o refrigerado',10,'03','0302','030246');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03024700','Espadarte (Xiphias gladius), frescos ou refrigerados','Swordfish (Xiphias gladius), fresh or chilled','Pez espada (Xiphias gladius), frescos o refrigerados',10,'03','0302','030247');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03025000','Bacalhaus (gadus) frescos/refrigerados, exc.filés, etc.','Fresh/chilled cod (gadus), exc.fish filets, etc.','Bacalao(gadus)frescos/refrigerados, exc.filetes, etc',10,'03','0302','030250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03025100','Bacalhau-do-atlantico, da-groelandia e do-pacifico, f.ou r.','Cod of Atlantic, Pacific, Greenland, fresh or chilled','Bacalao del atlántico,pacífico,groenlandia, fr. o refr.',10,'03','0302','030251');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03025200','Haddock ou lubina (melanogrammus aeglefinus), f. ou r.','Haddock or lubina (melanogrammua aeglefinus), fr./ch.','Haddock o lubina (melanogrammua aeglefinus), fr./ref.',10,'03','0302','030252');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03025300','Saithe (pollachius virens), frescos ou refrigerados','Saithe (pollachus virens), fresh or chilled','Saithe (pollachus virens), frescos o refrigerados',10,'03','0302','030253');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03025400','Merluzas e abroteas (merluccius spp., urophycis spp.),f.ou r.','Hakes (merluccius spp., urophycis spp),fresh or chilled','Merluzas y abroteas (merluccius spp), fresco o refrig.',10,'03','0302','030254');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03025500','Merluza-do-alasca (theragra chalcogramma), fr. ou refrig.','Hake from alasca (theragra chalcogramma), fresh or chl.','Merluza del alasca (theragra chalcogramma),fr o refrig.',10,'03','0302','030255');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03025600','Verdinhos (micromesistius poutassou, microme. australis','Blue whiting (micromesisticus poutassou)','Blue whiting (micromesisticus poutassou)',10,'03','0302','030256');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03025900','Outros peixes das fam. bregmacerotidae, gadidae, etc.','Other fish of families bregmacerotidae, gadidae, etc.','Otros peces de familias bregmacerotidae,gadidae,etc.',10,'03','0302','030259');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026100','Sardinhas, sardinelas, etc.frescas, refrig.exc.filés, etc.','Fresh/chilled sardines, etc.except fish filets, etc.','Sardinas, sardinelas, etc, frescas, refrig.exc.filetes, etc',10,'03','0302','030261');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026200','Haddocks frescos ou refrig.exc.filés, outras carnes, etc.','Fresh/chilled haddocks, exc.fish filets oth.fish meat, ','Eglefinos frescos o refriger.exc.filetes, dem.carnes, etc',10,'03','0302','030262');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026300','Peixes-carvão frescos, refrig.exc.filés, outs.carnes, etc.','Fresh/chilled coalfish, exc.fish filets oth.fish meat, ','Carboneros frescos, refriger.exc.filetes, dem.carnes, etc',10,'03','0302','030263');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026400','Cavalas, cavalinhas, etc.frescas, refrig.exc.filés, etc.','Fresh/chilled mackerel, etc.except fish filets, etc.','Caballas, etc, frescas, refrigeradas, exc.filetes, etc',10,'03','0302','030264');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026500','Esqualos frescos, refrig.exc.filés, outras carnes, etc.','Fresh/chilled dogfish, exc.fish filets oth.fish meat, etc','Escualos frescos, refriger.exc.filetes, dem.carnes, etc',10,'03','0302','030265');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026600','Enguias frescas, refrig.exc.filés, outras carnes, etc.','Fresh/chilled eels, exc.fish filets oth.fish meat, etc.','Anguilas frescas, refriger.exc.filetes, dem.carnes, etc',10,'03','0302','030266');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026700','Espadartes frescos ou refrigerados','Swordfish, fresh or chilled','Pez espada, fresco o refrigerado',10,'03','0302','030267');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026800','Outros peixes frescos, refrig.exc.filés, outs.carnes, etc.','Other fishes,  fresh,  chilled (except fillets),  etc,  other meat,  etc','Otros peces,  frescos,  refrigerados (excepto filetes),  otras carnes,  etc',10,'03','0302','030268');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026810','Marlongas-negras, peixes frescos/refrig.exc.filés, etc.','Black whiting,  frozen/chilled fishes,  except fillets,  etc','Merluza negra,  peces frescos/refrigerados,  excepto filetes,  etc',10,'03','0302','030268');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026820','Marlongas-do-antartico, peixes frescos/refrig.exc.filés, ','Antarctic whiting,  frozen/chilled fishes,  except fillets','Merluza del antarctico,  peces frescos/refrigerados,  excepto filetes,  etc',10,'03','0302','030268');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026910','Merluzas frescas, refrig.exc.filés, outras carnes, etc.','Fresh/chilled hakes, exc.fish filets oth.fish meat, etc','Merluzas frescas,  refriger.exc.filetes, dem.carnes, etc',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026921','Espadartes frescos ou refrigerados','Swordfish, fresh or chilled','Pez espada, fresco o refrigerado',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026922','Agulhões frescos ou refrigerados','Fresh/chilled sailfishes','Agujones frescos o refrigerados',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026923','Pargos frescos ou refrigerados','Fresh/chilled southern red snapper','Pagros frescos o refrigerados',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026931','Chernes-poveiro frescos ou refrigerados','Fresh/chilled wreckfish','Chernas frescos o refrigerados',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026932','Garoupas frescos ou refrigerados','Fresh/chilled wirrahs','Meros frescos o refrigerados',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026933','Esturjões frescos ou refrigerados','Fresh/chilled sturgeons','Esturiones frescos o refrigerados',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026934','Peixes-rei frescos ou refrigerados','Fresh/chilled silversides','Pejerreyes frescos o refrigerados',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026935','Bagres frescos ou refrigerados','Fresh/chilled catfish','Bagres frescos o refrigerados',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026941','Curimatas, peixes frescos, refrig.exc.filés, outs.carnes, ','Fresh/chilled shad, exc.fish filets oth.fish meat, etc','Sábalos, pescados frescos, refr.exc.filetes, dem.carnes',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026942','Tilápias, peixes frescos, refrig.exc.filés, outs.carnes, ','Fresh/chilled tilapia spp.exc.fish filets, oth.fish meat','Tilapias, pescados frescos, refrig.exc.filetes, dem.carnes',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026943','Surubins, peixes frescos, refrig.exc.filés, outs.carnes, ','Fresh/chilled surubins, exc.fish filets oth.fish meat, ','Surubíes, pescados frescos, refrig.exc.filetes, dem.carnes',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026944','Trairas, peixes frescos, refrig.exc.filés, outs.carnes, etc','Fresh/chilled tahira, exc.fish filets oth.fish meat, etc','Tarariras, pesc.frescos, refr.exc.filetes, dem.carnes, etc',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026945','Piaus, peixes frescos, refrig.exc.filés, outs.carnes, etc','Fresh/chilled piau, exc.fish filets oth.fish meat, etc','Bogas, pescados frescos, refr.exc.filetes, dem.carnes, etc',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026946','Tainhas, peixes frescos, refrig.exc.filés, outs.carnes, etc','Fresh/chilled grey mullet, exc.fish filets, oth.fish meat','Lisas, pescados frescos, refr.exc.filetes, dem.carnes, etc',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026947','Pirarucus, peixes frescos, refrig.exc.filés, outs.carnes, ','Fresh/chilled pirarucu, exc.fish filets oth.fish meat, ','Arapaimas, pescados frescos, refr.exc.filetes, dem.carnes',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026948','Pescadas, peixes frescos, refrig.exc.filés, outs.carnes, ','Fresh/chilled weakfish, exc.fish filets oth.fish meat, ','Pescadilla, pescados frescos, refr.exc.filetes, dem.carnes',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026949','Anchoitas, peixes frescos, refrig.exc.filés, outs.carnes, ','Fresh/chilled argentine anchoita, exc.fish filets, oth.','Anchoitas, pescados frescos, refr.exc.filetes, dem.carnes',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026951','Piramutabas, peixes frescos, refrig.exc.filés, outs.carnes','Fresh/chilled brachyplatistoma vailianti, exc.filets, oth','Piramutabas, pescad.fresc.refr.exc.filetes, dem.carnes',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026952','Douradas, peixes frescos, refrig.exc.filés, outs.carnes','Fresh/chil.gilded catfish, exc.fish filets, oth.fish meat','Dorados, pescados frescos, refrig.exc.filetes, dem.carnes',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026953','Pacus, peixes frescos, refrig.exc.filés, outs.carnes, etc.','Fresh/chilled pacu, exc.fish filets oth.fish meat, etc','Pacúes, pescados frescos, refr.exc.filetes, dem.carnes, etc',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026954','Tambaquis, peixes frescos, refrig.exc.filés, outs.carnes, ','Fresh/chil.black pacum, exc.fish filets oth.fish meat, ','Tambaquíes, pescados frescos, refr.exc.filetes, dem.carnes',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026955','Tambacus, peixes frescos, refrig.exc.filés, outs.carnes, ','Fresh/chill.tambacúe, exc.fish filets oth.fish meat, etc','Tambacúes, pescados frescos, refr.exc.filetes, dem.carnes',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03026990','Outros peixes frescos, refrig.exc.filés, outs.carnes, etc.','Oth.fresh/chilled fishe, exc.fish filets, oth.fish meats, ','Los dem.pescados fresc.refr.exc.filetes, dem.carnes, etc',10,'03','0302','030269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03027000','Fígados, ovas e sêmen, de peixes, frescos ou refrigerados','Fresh/chilled fish livers and  roes','Hígados, huevas y lechas de pescados, frescos o refrig.',10,'03','0302','030270');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03027100','Tilápias (oreochromis spp.), frescas ou refrigeradas','Tilapias (oreochromis spp.), fresh or chilled','Tilapias (oreochromis spp.), frescas o refrigeradas',10,'03','0302','030271');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03027210','Bagre (Ictalurus puntactus), fresco ou refrigerado','Catfish (Ictalurus puntactus), fresh or chilled','Bagre (Ictalurus puntactus), frescos o refrigerados',10,'03','0302','030272');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03027290','Outros bagres frescos ou refrigerados','Other catfish, fresh or chilled','Otros bagres, frescos o refrigerados',10,'03','0302','030272');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03027300','Carpas (cyprinus carpio, carassius carassius, etc.)','Carp (cyprinus carpio, carassius carassius, etc.)','Carpa (cyprinus carpio, carassius carassius, etc.)',10,'03','0302','030273');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03027400','Enguias (anguilla spp.), frescas ou refrigeradas','Eels (anguila spp.), fresh or chilled','Anguilas (anguilla spp.), frescas o refrigeradas',10,'03','0302','030274');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03027900','Perca-do-nilo,peixe cabeça-de-serpente, fr.ou refrig.','Nile perch, snakehead, fresh or chilled','Perca del nilo, cabeza de la serpiente, fresco o refri.',10,'03','0302','030279');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028100','Cação e outros tubarões, frescos ou refrigerados','Dogfish and other sharks, fresh or chilled','Escualos y otros tiburones, frescos o refrigerados',10,'03','0302','030281');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028200','Raias (Rajidae), fresca ou refrigerada','Skates (Rajidae), fresh or chilled','Rayas (Rajidae), frescas o refrigeradas',10,'03','0302','030282');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028310','Merluza negra (dissostichus eleginoides), fr. ou ref.','Black hake (dissostichus eleginoides), fresh or chilled','Merluza negra (dissostichus eleginoides), fr.o refrig.',10,'03','0302','030283');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028320','Merluza antartica (dissostichus mawsoni)','Hake from antartica (dissostichus mawson)','Merluza antártica (dissostichus mawson)',10,'03','0302','030283');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028400','Robalos (dicentrarchus spp.), fres. ou refrig.','Bass (dicentrarchus spp.), fresh or chilled','Bajo (dicentrarchus spp.), fresco o refrigerado',10,'03','0302','030284');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028500','Pargos ou sargos (sparidae), fres. ou refrig.','Porgies, sea breams (sparidae), fresh or chilled','Pargos o sargos (sparidae), fresco o refrigerado',10,'03','0302','030285');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028911','Agulhoes (istiophorus spp,tetrapturus spp,makaira spp)','Marlin (istiophorus spp, tetrapturus spp, makaira spp)','Marlin (istiophorus spp, tetrapturus spp, makaira spp)',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028912','Pargo (Lutjanus purpureus), fres. ou refrig.','Snapper (Lutjanus purpureus), fresh or chilled','Pargo (Lutjanus purpureus), fresco o refrigerado',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028921','Cherne-poveiro (polypirion americanus), fres. ou refrig.','Atlantic wreckfish(polyprion americanus),fresh or chil.','Mero-poveiro (polyprion americanus), fresco o refrig.',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028922','Garoupas (acanthistius spp.), fresco ou refrigerado','Groupers (acanthistius spp.), fresh or chilled','Meros (acanthistius spp.), frescos o refrigerados',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028923','Esturjão (acipenser baeri), fresco ou refrigerado','Sturgeon (acipenser baeri), fresh or chilled','Esturión  (acipenser baeri), fresco o refrigerado',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028924','Peixes-rei (atherina spp.), fresco ou refrigerado','Sand smelt (atherina spp.), fresh or chilled','Peces-rei (atherina spp.), fresco o refrigerado',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028931','Curimatas (prochilodus spp.), fresco ou refrigerado','Curimatas (prochilodus spp.), fresh or chilled','Curimatas (prochilodus spp.), fresco o refrigerado',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028932','Tialapias (Tilápia,sarotherodon,danakilia; seus hibrido','Tilapias (tilapia,sarotherodon,danakilia); its hybrids','Tilapias (tilapia,sarotherodon,danakilia); sus híbridos',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028933','Surubins (pseudoplatystoma spp.), fres. ou refrig.','Surubins (pseudoplatystoma spp.), fresh or chilled','Surubins (pseudoplatystoma spp.), fresco o refrigerado',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028934','Traíra (hoplias malabaricus & h. cf. lacerdae)','Trahira (tiger fish) (hoplias malabaricus)','Trahira (tiger fish) (hoplias malabaricus)',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028935','Piaus (leporinus spp.), fresco ou refrigerado','Piaus (leporinus spp.), fresh or chilled','Piaus (leporinus spp.), fresco o refrigerado',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028936','Tainhas (mugil spp), fresco ou refrigerado','Tainhas (mugil spp.), fresh or chilled','Tainhas (mugil spp.), fresco o refrigerado',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028937','Pirarucu (arapaima gigas), fresco ou refrigerado','Pirarucu (arapaima gigas), fresh or chilled','Pirarucú (arapaima gigas), frescos o refrigerados',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028938','Pescadas (cynocion spp.), fresca ou refrigerada','Pescadas (cynocion spp.), fresh or chilled','Pescadas (cynocion spp.), fresco o refrigerado',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028941','Piramutaba (brachyplatystoma vaillantii), fr. ou refrig.','Piramutaba (brachyplatystoma vaillantii),fresh or chi.','Piramutaba (brachyplatystoma vaillantii), fr. o refr.',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028942','Dourada (brachyplatystoma flavicans), fr. ou refrig.','Jau (brachyplatystoma flavicans), fresh or chilled','Dourada (brachyplatystoma flavicans), fresco o refrig.',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028943','Pacu (Piaractus mesopotamicus), fr. ou refrig.','Pacu (Piaractus mesopotamicus), fresh or chilled','Pacu (Piaractus mesopotamicus), fresco o refrigerado',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028944','Tambaqui (colossoma macropomum)','Tambaqui (colossoma macropomum)','Tambaqui (colossoma macropomum)',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028945','Tambacu (híbrido de tambaqui e pacu)','Tambacu (hybrid of tambaqui and pacu)','Tambacu (híbrido tambaqui y el pacu)',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03028990','Outros peixes frescos ou refrigerados','Other fish, fresh or chilled','Otros pescados frescos o refrigerados',10,'03','0302','030289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03029000','Fígados, ovas e sêmen,de peixes,frescos ou refrigerados','Livers and roes of fish, fresh or chilled','Hígados,huevas y lechas de peces,frescos o refrigerados',10,'03','0302','030290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03031000','Salmões-do-pacífico, congelados, exc.filés, etc.','Pacific salmon, frozen, except fillets, etc ','Salmones del pacífico, congelados, excepto filetes, etc',10,'03','0303','030310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03031100','Salmões vermelhos congelados','Frozen red salmon','Salmones rojos congelados',10,'03','0303','030311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03031200','Outros salmões-do-Pacifico, congelados','Other pacific salmon, frozen','Otros salmón del pacífico, congelado',10,'03','0303','030312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03031300','Salmão-do-Atlântico e salmão-do-Danúbio, congelados','Atlantic salmon and Danube salmon, frozen','Salmón del Atlántico y Salmón del Danubio, congelados',10,'03','0303','030313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03031400','Trutas (salmo trutta, oncorhynchus mykiss, etc.),congeladas','Trout (salmo trutta, oncorhynchus mykiss, etc), frozen','Truta (salmo trutta, oncorhynchus mykiss, etc), congel.',10,'03','0303','030314');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03031900','Outros tipos de salmões, congelados','Other frozen salmon','Los demás tipos de salmones, congelados',10,'03','0303','030319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03032100','Trutas (Salmo trutta, etc.) congeladas, exc.filés, etc.','Frozen trout (Salmo trutta, etc.) except filets, etc.','Truchas(Salmo truttas,  etc) congeladas, exc.filetes, etc',10,'03','0303','030321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03032200','Salmões-do-atlântico e danúbio, congelados, exc.filés, etc','Frozen atlantic salmon and danube salmon, exc.filets, etc','Salmones del atlántico y danubio, congel.exc.filetes, etc',10,'03','0303','030322');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03032300','Tilápias (oreochromis spp.), congeladas','Tilapias (oreochromis spp.), frozen','Tilapias  (oreochromis spp.), congeladas',10,'03','0303','030323');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03032410','Bagre (Ictalurus puntactus) congelado','Catfish (Ictalurus puntactus) frozen','Catfish (Ictalurus puntactus), congelados',10,'03','0303','030324');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03032490','Perca-do-nilo e cabeças-de-serpente, congelados','Nile persh and snakehead, frozen','Perca del nilo y cabeza de serpiente, congelados',10,'03','0303','030324');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03032500','Carpas, congeladas','Carps, frozen','Carpas, congeladas',10,'03','0303','030325');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03032600','Enguias congeladas (anguilla spp.), congeladas','Eels (anguilla spp.), frozen','Anguilas (anguilla spp.), congeladas',10,'03','0303','030326');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03032900','Outros salmonídeos congelados, exc.filés, outs.carnes, etc','Oth.frozen salmonidae, exc.fish filets oth.fish meat, etc','Los dem.salmónidos congel.exc.filetes, dem.carnes, et',10,'03','0303','030329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03033100','Linguados-gigantes congelados, exc.filés.outs.carnes, etc','Frozen halibut, exc.fish filets oth.fish meat, etc','Lenguado gigante congelado, exc.filetes, dem.carnes, etc',10,'03','0303','030331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03033200','Solhas ou patrucas, congeladas, exc.filés, outs.carnes, etc','Frozen plaice exc.fish filets, oth.fish meat, etc','Sollas, congelados, excepto filetes, dem.carnes, etc',10,'03','0303','030332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03033300','Linguados congelados, exc.filés, outs.carnes, fígados, etc.','Frozen sole, exc.fish filets oth.fish meat, etc','Lenguados congelados, exc.filetes, dem.carnes, hígados, etc',10,'03','0303','030333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03033400','Pregado (Psetta maxima), congelado','Turbot (Psetta maxima), frozen','Rodaballo (Psetta maxima), congelado',10,'03','0303','030334');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03033900','Outs.peixes chatos, congelados, exc.filés, outs.carnes, etc','Oth.frozen flat fish, exc.fish filets oth.fish meat, etc','Los dem.pescados planos, cong.exc.filetes, dem.carnes, etc',10,'03','0303','030339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03034100','Atuns-brancos ou germões, congelados, exc.filés, etc.','Frozen albacore or longfinned tunas exc.fish filets, etc','Albacoras o atunes blancos, congelados, exc.filetes, etc',10,'03','0303','030341');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03034200','Albacoras/atuns barbat.amarela, congeladas, exc.filés, etc','Frozen yellowfin tunas, exc.fish filets, etc.','Atunes de aleta amarilla, congel.exc.filetes, etc',10,'03','0303','030342');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03034300','Bonitos-listrados, etc.congelados, exc.filés, etc.','Frozen skipjack, etc.except fish filets, etc.','Listados o bonitos, etc, congelados, excepto filetes,  etc',10,'03','0303','030343');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03034400','Albacoras-bandolim (patudos) congelados','Frozen bigeye tunas "thunnus obesus"','Patudos o atunes ojos grandes congelados',10,'03','0303','030344');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03034500','Albacoras-azuis (atuns-azuis) congelados','Frozen bluefin tunas "thunnus thynnus"','Atunes de aleta azul congelados',10,'03','0303','030345');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03034600','Atuns do sul congelados','Frozen southerm bluefin tunas (thunnus maccoyii)','Atunes del sur congelados',10,'03','0303','030346');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03034900','Outs.atuns congelados, exc.filés, outs.carnes, fígados,etc','Oth.frozen tunas, exc.fish filets, oth.meats, livers, etc','Los dem.atunes cong.exc.filetes, dem.carnes, hígados, et',10,'03','0303','030349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03035000','Arenques congelados, exc.filés, outras carnes, fígados, etc','Frozen herrings, exc.fish filets oth.meats, livers, etc','Arenques congelados, exc.filetes, dem.carnes, hígados, etc',10,'03','0303','030350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03035100','Arenques, cong., exc.fígado, ovas, sêmen','Herrings, frozen, except liver, eggs, semen','Arenques, congelados, excepto hígado, huevos, semen',10,'03','0303','030351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03035200','Bacalhaus (Gadus morhua, Gadus ogac), congelado','Cod (Gadus morhua, Gadus ogac), frozen','Bacalao (Gadus morhua, Gadus ogac) congelados',10,'03','0303','030352');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03035300','Sardinhas, congeladas','Sardines, frozen','Sardinas, congeladas',10,'03','0303','030353');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03035400','Cavalinhas, congeladas','Cavalinhas, frozen','Cavaliñas, congeladas',10,'03','0303','030354');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03035500','Chicharros (trachurus spp.), congelados','Horse mackerel (trachurus spp.), frozen','Chicharros (trachurus spp.), congelados',10,'03','0303','030355');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03035600','Bijupira (Rachcentron canadum), congelado','Cobia (Rachcentron canadum), frozen','Cobia (Rachcentron canadum), congelados',10,'03','0303','030356');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03035700','Espadarte (xiphias galdius), congelado','Swordfish (Xiphias gladius), frozen','Pez espada (Xiphias gladius), congelados',10,'03','0303','030357');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036000','Bacalhaus (gadus) congelados, exc.filés, outs.carnes, etc.','Frozen cod,  except fish filets,  other fish meat,  etc.','Bacalao (gadus) congelados,exc.filetes, demás carnes, etc',10,'03','0303','030360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036100','Espadartes (Xiphias gladius) congelados','Swordfish (Xiphias gladius), frozen','Pez espada (Xiphias gladius),  congelado',10,'03','0303','030361');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036210','Marlongas-negras (dissosts.eleginoides) cong.','Black whiting (dissosts.eleginoides), frozen','Merluza negra (dissosts,  eleginoides),  congelada',10,'03','0303','030362');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036211','Marlongas-negras, peixes cong.eviscerad.s/cabeça, s/calda','Black whiting,  frozen fishes,  gutted,  no head,  no tail','Merluza negra,  peces congelados,  eviscerado,  sin cabeza,  sin cola',10,'03','0303','030362');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036212','Cabeças de peixes marlongas-negras, congelados','Black whiting heads, frozen','Cabezas de merluza negra,  congeladas',10,'03','0303','030362');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036219','Outros peixes marlongas-negras, congelados','Others black whiting, frozen','Otras merluzas negras,  congeladas',10,'03','0303','030362');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036221','Marlongas-do-antártico, peixes cong.eviscerados, s/cabeça','Antarctic whiting,  frozen/gutted fishes,  no head,  no tail','Merluza del antarctico,  peces congelados/eviscerados,  sin cabeza,  sin cola ',10,'03','0303','030362');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036222','Cabeças de peixes marlongas-do-antártico, congeladas','Antarctic whiting heads, frozen','Cabezas de merluza del antárctico,  congeladas',10,'03','0303','030362');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036229','Outros peixes marlongas-do-antartico, congelados','Other antarctic whiting, frozen','Otras merluzas del antarctico,  congeladas',10,'03','0303','030362');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036290','Outros peixes congelados, exc.fíg., ovas, sêmen','Other frozen fishes,  except liver,  eggs,  semen','Otros peces congelados,  excepto hígado,  huevos,  semen',10,'03','0303','030362');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036300','Bacalhau-do-Atlântico e bacalhau-do-Pacífico, congelado','Cod of Atlantic and cod of Pacific, frozen','Bacalao del Atlántico y bacalao del Pacífico,congelados',10,'03','0303','030363');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036400','Haddock ou lubina (melanogrammus aeglefinus), congelado','Haddock or lubina (Melanogramua aeglefinus), frozen','Haddock or lubina (Melanogramua aeglefinus), congelado',10,'03','0303','030364');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036500','Saithe (pollachius virens), congelado','Saithe (pollachius virens), frozen','Saithe (pollachius virens), congelado',10,'03','0303','030365');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036600','Merluzas e abroteas (merluccius ,urophycis ),congeladas','Hakea amd abroteas (merluccius, urophycis), frozen','Merluzas y abroteas (merluccius, urophycis), congeladas',10,'03','0303','030366');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036700','Merluza-do-alasca (theragra chalcogramma)','Hake from alasca (theragra chalcogramma)','Merluza del alasca (theragra chalcogramma)',10,'03','0303','030367');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036800','Verdinhos, congelados (exceto filés, outras carnes)','Verdinhos, frozen (except fillet, other meat)','Verdinhos, congelados (xceto filetes, otras carnes)',10,'03','0303','030368');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036910','Merluza rosada (macruronus megellanicus), congelada','Pink hake (macruronus megellanicus), frozen','Merluza rosada  (macruronus megellanicus), congelada',10,'03','0303','030369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03036990','Outros peixes congelados, exceto filé e outras carnes','Other fish, frozen, excluding fillets and other meat','Demás pescados,cong.,exc. los filetes y otras carnes',10,'03','0303','030369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037100','Sardinhas, sardinelas, etc.congeladas, exc.filés, etc.','Frozen sardines, etc.except fish filets, etc.','Sardinas, sardinelas, etc, congeladas, exc.filetes, etc',10,'03','0303','030371');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037200','Haddocks congelados, exc.filés, outras carnes, fígados, etc','Frozen haddock, exc.fish filets, oth.meats, livers, etc.','Eglefinos congelados, exc.filetes, dem.carnes, hígados, etc',10,'03','0303','030372');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037300','Peixes-carvão congelados, exc.filés, outras carnes, etc.','Frozen coalfish, exc.fish filets oth.fish meat, etc.','Carboneros congelados, exc.filetes, dem.carnes, etc',10,'03','0303','030373');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037400','Cavalas, cavalinhas e sardas, congeladas, exc.filés, etc.','Frozen mackerel, exc.fish filets, etc.','Caballas, etc, congeladas, exc.filetes, etc',10,'03','0303','030374');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037500','Esqualos congelados, exc.filés, outras carnes, fígados, etc','Frozen dogfish/oth.sh.exc.fish filets, oth.meats, livers, ','Escualos congelados, exc.filetes, dem.carnes, hígados, etc',10,'03','0303','030375');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037511','Tubarões-azuis inteiros, congelados','Blue shark, whole, frozen','Tiburón azul, entero, congelado',10,'03','0303','030375');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037512','Tubarões-azuis, congelad.eviscerad.s/cabeça, s/barbatana','Blue shark, frozen/gutted, no head, no fin','Tiburón azul,  congelado/eviscerado,  sin cabeza,  sin aleta',10,'03','0303','030375');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037513','Tubarões-azuis, congelados, em pedaços, com pele','Blue shark, frozen, in pieces, with skin','Tiburón azul, congelado, com piel',10,'03','0303','030375');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037514','Tubarões-azuis, congelados, em pedaços, sem pele','Blue shark,  frozen,  in pieces,  skinless','Tiburón azul, congelado, en pedazos',10,'03','0303','030375');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037519','Outros tubarões-azuis, congelados','Others blue sharks, frozen','Otros tiburones azules, congelados',10,'03','0303','030375');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037590','Outros peixes esqualos, congelados','Other squaliform fishes, frozen','Otros tiburones, congelados',10,'03','0303','030375');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037600','Enguias congeladas, exc.files, outras carnes, fígados, etc.','Frozen eels, exc.fish filets, oth.meats, livers, etc','Anguilas congeladas, exc.filetes, dem.carnes, hígados, etc',10,'03','0303','030376');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037700','Percas (robalos e bailas) congeladas, exc.files, etc.','Frozen sea bass except fish filets, etc.','Róbalos congelados, excepto filetes,  etc',10,'03','0303','030377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037800','Merluzas e abroteas, congeladas, exc.files, etc.','Frozen hake except fish filets, etc.','Merluzas y brótola, congeladas, excepto filetes,  etc',10,'03','0303','030378');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037910','Corvinas congeladas, exc.files, outras carnes, fígados, etc','Frozen croakers, exc.fish filets, oth.meats, livers, etc','Corvinas congeladas, exc.filetes, dem.carnes, hígados, ',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037920','Pescadas congeladas, exc.files, outras carnes, fígados, etc','Froz.weakfish cynosc.spp.exc fish fil.ot.meat, liver, etc','Pescadillas congelad.exc.filetes, dem.carnes, hígados, etc',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037931','Espadartes congelados','Frozen swordfish','Espadartes congelados',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037932','Agulhões congelados','Frozen sailfishes','Agujas congeladas',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037933','Pargos congelados','Frozen southern red snapper','Pargos congelados',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037934','Peixes-sapo congelados','Frozen blackfin goosefish','Rapes congelados',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037941','Chernes-poveiro congelados','Frozen wreckfish','Cherna congeladas',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037942','Garoupas congelados','Frozen wirrahs','Garoupas congelados',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037943','Tainhas congelados','Frozen grey mullet','Lisas congeladas',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037944','Esturjões congelados','Frozen sturgeon','Esturiones congelados',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037945','Peixes-rei congelados','Frozen silversides','Pejerreyes congelados',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037946','Merluzas rosadas congelados','Frozen patagonian grenadiers','Merluzas de cola congeladas',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037947','Nototenias congelados','Frozen nototheniiforms','Nototenias congeladas',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037948','Bagres congelados','Frozen channel catfish','Bagres congelados',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037949','Merluzas negras congelados','Frozen patagonian toothfish','Merluzas negras congeladas',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037951','Curimatas, peixes congelados, exc.filés, outros carnes, etc','Frozen shad, exc.fish fillets and other fish meat, etc.','Curitamas, pescados congel.exc.filetes, dem.carnes, etc',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037952','Tilápias, peixes congelados, exc.filés, outros carnes, etc','Frozen tilapia spp.exc.fish fillets, oth.fish meat, etc','Tilapias, pescados congelados, exc.filetes, dem.carnes, etc',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037953','Surubins, peixes congelados, exc.filés, outros carnes, etc','Frozen surubins, exc.fish fillets, other fish meat, etc','Surubíes, pescados congelados, exc.filetes, dem.carnes, etc',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037954','Trairas, peixes congelados, exc.filés, outros carnes, etc','Frozen tahira, exc.fish fillets, other fish meat, etc','Tarariras, pescados congelad.exc.filetes, dem.carnes, etc',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037955','Piaus, peixes congelados, exc.filés, outros carnes, etc','Frozen piau, exc.fish fillets, other fish meat, etc','Bogas, pescados congelados, exc.filetes, dem.carnes, etc',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037956','Pirarucus, peixes congelados, exc.filés, outros carnes, etc','Frozen pirarucu, exc.fish fillets, other fish meat, etc','Arapaimas, pescados congelad.exc.filetes, dem.carnes, etc',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037957','Anchoitas, peixes congelados, exc.filés, outros carnes, etc','Frozen argen.anchoita, exc.fish fillets, ot.fish meat, etc','Anchoitas, pescados congel.exc.filetes, dem.carnes, etc',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037961','Piramutabas, peixes congelados, exc.filés, outros carnes, ','Frozen brachyplat.vailliant, exc.fish fil.oth.fish meat, ','Piramutabas, pescados congelados, exc.filetes, dem.carnes',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037962','Douradas, peixes congelados, exc.filés, outros carnes, etc.','Frozen gilded catfish, exc.fish filets, oth.fish meat, etc','Dorados, pescados congelados, exc.filetes, dem.carnes, etc',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037963','Pacus, peixes congelados, exc.filés, outros carnes, etc.','Frozen pacu, exc.fish filets, oth.fish meat, etc.','Pacúes, pescados congelados, exc.filetes, dem.carnes, etc',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037964','Tambaquis, peixes congelados, exc.filés, outros carnes, etc','Frozen black pacum, exc.fish filets, oth.fish meat, etc','Tambaquíes, pescados congelad.exc.filetes, dem.carnes, etc',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037965','Tambacus, peixes congelados, exc.filés, outros carnes, etc.','Frozen tambacués, exc.fish filets, oth.fish meat, etc','Tambacúes, pescados congelad.exc.filetes, dem.carnes, etc',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03037990','Outros peixes congelados, exc.filés, outros carnes, etc.','Other frozen fish, exc.fish filets, oth.fish meat, etc','Los dem.pescados congelados, exc.filetes, dem.carnes, etc',10,'03','0303','030379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038000','Fígados, ovas e sêmen, de peixes, congelados','Frozen fish livers and roes','Hígados, huevas y lechas,  de pescados,  congelados',10,'03','0303','030380');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038111','Tubarão-azul (prionace glauca) inteiro, congelado','Blue shark (prionace glauca) full, frozen','Tiburón azul (prionace glauca) intero, congelado',10,'03','0303','030381');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038112','Tubarão-azul,eviscerado, s/ cabeca e s/ barbatana,cong.','Blue shark gutted, finess, headless, frozen','Tibuones azules destripados,sin cola,sin cabeza,cong.',10,'03','0303','030381');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038113','Tubarão-azul em pedaços, com pele, congelado','Blue shark in chunks, with skin, frozen','Tiburón azul en trozos, con la piel, congelado',10,'03','0303','030381');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038114','Tuabarão-azul em pedaços, sem pele, congelado','Blue shark in pieces,  without skin, frozen','Tiburón azul en trozos, sin piel, congelados',10,'03','0303','030381');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038119','Outros tubarões-azuis, congelados','Other blue sharks, frozen','Otros tiburones azules, congelados',10,'03','0303','030381');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038190','Outros tubarões, congelados','Other sharks, frozen','Otros tiburones, congelados',10,'03','0303','030381');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038200','Raias (rajidae), congeladas','Skates (rajidae), frozen','Rayas (rajidae), congeladas',10,'03','0303','030382');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038311','Merluza negra, evisceradas, s/cabeça e s/cauda,cong.','Black hake, eviscerated, without head or tail, frozen','Merluza negra, eviscerada. sin cabeza o cola, congelada',10,'03','0303','030383');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038312','Cabeças de merluza negra, congeladas','Head of black hakes, frozen','Cabezas de merluza negra, congeladas',10,'03','0303','030383');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038319','Outras partes de merluza negra, congeladas','Other parts of black hakes, frozen','Otras partes de merluza negra, congeladas',10,'03','0303','030383');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038321','Merluza antartica, evisceradas, s/cabeca e s/cauda, cong.','Hake from antartica,evisc.,frozen, without head or tail','Merluza de antártica,evisceradas,sin cabeza o cola,co.',10,'03','0303','030383');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038322','Cabecas de merluza antártica, congeladas','Heads of hakes from antarctica, frozen','Cabeza de merluza antártica, congeladas',10,'03','0303','030383');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038329','Outras partes de merluza antártica, congeladas','Other parts of hakes from antarctica, frozen','Otras partes de merluza antártica, congeladas',10,'03','0303','030383');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038400','Robalos (dicentrarchus spp.), congelados','Seabass (dicentrarchus spp.), frozen','Lubina (dicentrarchus spp.), congelados',10,'03','0303','030384');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038910','Corvina (Micropogonias furnieri), congelada','Corvina (Micropogonias furnieri), frozen','Corvina (Micropogonias furnieri), congelada',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038920','Pescadas (cynoscion spp.), congeladas','Pescadas (cynoscion spp.), frozen','Pescadas (cynoscion spp.), congeladas',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038931','Agulhões (istiophorus, tetrapturus, makaira),congelados','Marlin (istiophorus, tetrapturus, makaira), frozen','Marlin (istiophorus, tetrapturus, makaira), congelados',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038932','Pargo (Lutjanus purpureus), congelado','Snapper (Lutjanus purpureus), frozen','Pargo (Lutjanus purpureus), congelados',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038933','Peixe-sapo (lophius gastrophysus), congelado','Frog fish (lophius gastrophysus), frozen','Pece sapo (lophius gastrophysus), congelado',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038941','Cherne-poveiro (polyprion americanus), congelado','Atlantic wreckfish (polyprion americanus), frozen','Mero-poveiro (polyprion americanus), congelado',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038942','Garoupas (acanthistius spp.), congeladas','Groupers (acanthistius spp.), frozen','Meros (acanthistius spp.), congelados',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038943','Tainhas (mujil spp.), congeladas','Mullet (mujil spp.), frozen','Salmonete (mujil spp.), congelados',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038944','Esturjões (acipenser), congelados','Sturgeon (acipenser), frozen','Esturión (acipenser), congelados',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038945','Peixes-rei (atherina spp.), congelados','Sand smelt (atherina spp.), frozen','Peces-rei (atherina spp.), congelados',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038946','Nototenias (patagonotothen spp.), congeladas','Nototenias (patagonotothen spp.), frozen','Nototenias (patagonotothen spp.), congeladas',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038951','Curimatas (prochilodus spp.), congelados','Curimatas (prochilodus spp.), frozen','Curimatas (prochilodus spp.), congelados',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038952','Tilápias congeladas, exc.filés, outras carnes, etc','Frozen tilapias, except filetts, other meat, etc.','Tilapias congeladas, excepto filetes,otras carnes, etc.',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038953','Surubins (congelados), exceto files, outras carnes, etc','Frozen surubins, except filetts, other meat, etc.','Surubins congelados, excepto filetes,otras carnes, etc.',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038954','Trairas (congeladas), exceto files, outras carnes, etc','Frozen trahira, except filetts, other meat, etc.','Traíras congeladas, excepto filetes,otras carnes, etc.',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038955','Piaus (leporinus spp.) congelados','Piaus (leporinus spp.), frozen','Piaus (leporinus spp.), congelados',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038956','Pirarucu (congelado) ,exceto filés, outras carnes, etc','Frozen pirarucu, except filetts, other meat, etc.','Pirarucu congelados, excepto filetes,otras carnes, etc.',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038957','Anchoitas  (congeladas) ,exc.filés,outros carnes,etc','Frozen anchoita, except filetts, other meat, etc.','Anchoita congelados, excepto filetes,otras carnes, etc.',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038961','Piramutabas, congelado, exc. filés, outras carnes, etc','Frozen piramutuba, except filetts, other meat, etc.','Piramutuba congel., excepto filetes, otras carnes, etc.',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038962','Douradas (congeladas), exc.filés, outras carnes,etc.','Jau, frozen, except filetts, other meat, etc.','Douradas congeladas, excepto filetes,otras carnes, etc.',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038963','Pacu (congelado) exceto filés, outras carnes, etc.','Pacu, frozen, except filetts, other meat, etc.','Pacu, congelado, excepto filetes, otras carnes, etc.',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038964','Tambaqui (congelado) ,exceto filés, outras carnes, etc','Tambaqui, frozen, except filetts, other meat, etc.','Tambaqui, congelado, excepto filetes,otras carnes, etc.',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038965','Tambacu(hibrido de tambaqui e pacu),cong. exc.file, etc','Tambacu, frozen, except filetts, other meat, etc.','Tambacu, congelado, excepto filetes, otras carnes, etc',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03038990','Outros peixes congelados, exc.filés, outras carnes,etc.','Other frozen fish, except filets, other meats, etc','Otros peces congelados, exc. filetes, otras carnes, etc',10,'03','0303','030389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03039000','Fígados, ovas e sêmen de peixes, congelados','Livers and roes of fish, frozen','Hígados, huevas y lechas de pescado, congelados',10,'03','0303','030390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03041000','Filés e outras carnes de peixes, frescos ou refrigerad.','Fresh/chilled filets and other fish meats','Filetes y dem.carnes de pescados, frescos o refrigerados',10,'03','0304','030410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03041011','Filés de cherne-poveiro, frescos ou refrigerados','Fresh/chilled filets of wreckfish"polyprion americanus"','Filetes de cherna, frescos o refrigerados',10,'03','0304','030410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03041012','Filés de garoupa, frescos ou refrigerados','Fresh/chilled filets of wirrah (acanthistius spp.)','Filetes de mero, frescos o refrigerados',10,'03','0304','030410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03041013','Filés de bagre, frescos ou refrigerados','Fresh/chilled filets of channel catfish','Filetes de bagre, frescos o refrigerados',10,'03','0304','030410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03041019','Filés de outros peixes, frescos ou refrigerados','Fresh/chilled other fish filets','Filetes de demás pescados, frescos o refrigerados',10,'03','0304','030410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03041090','Outras carnes de peixes, frescas ou refrigeradas','Fresh/chilled other fish meats','Las demás carnes de pescados, frescas o refrigeradas',10,'03','0304','030410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03041100','Espadartes (Xiphias gladius) fescos/refrigerados','Sword fish (Xiphias gladius) fresh or chilled','Pez espada (Xiphias gladius), fresco o refrigerado',10,'03','0304','030411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03041200','Marlongas (dissostichus spp.) frescos/refrigerados','Whiting (dissostichus spp.) fresh or chilled','Merluzas (dissostichus spp), fresco o refrigerado',10,'03','0304','030412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03041911','Filé/cher-pov.(polyprion amer.)fresc/refrigerados','Filet/cher-pov.(polyprion americanus.) fresh or chilled','Filete/cher-pov.(polyprion americanus.) frescos o refrigerados',10,'03','0304','030419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03041912','Filé de garoupa(acanthistius spp)fresc/refr.','Wirrah (acanthistius spp) fillet,  fresh or chilled','Filetes de garoupa, frescos o refrigerados',10,'03','0304','030419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03041913','Filé de bagre(Ictalurus puntactus)fresc/refr.','Fillet from channel catfish (Ictalurus puntactus),  fresh or chilled','Filetes de bagre (Ictalurus puntactus),  frescos o refrigerados',10,'03','0304','030419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03041919','Filé de outros peixes frescos refrigerados','Fillet from other fishes, fresh or chilled','Filetes de otros peces, frescos o refrigerados',10,'03','0304','030419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03041990','Outras carnes de peixes frescos ou refrigerados','Other fish meat, fresh or chilled ','Otras carnes de pescados, frescas o refrigeradas',10,'03','0304','030419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042010','Filés de merluzas, congelados','Frozen filets of hake (merluccius spp.)','Filetes de merluza, congelados',10,'03','0304','030420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042020','Filés de pargo, congelados','Frozen filets of southern red snapper','Filetes de pargo, congelados',10,'03','0304','030420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042030','Filés de tilápia, congelados','Frozen filets of tilapia','Filetes de tilapia, congelados',10,'03','0304','030420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042040','Filés de cherne-poveiro, congelados','Frozen filets of wreckfish','Filetes de cherna, congelados',10,'03','0304','030420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042050','Filés de garoupa, congelados','Frozen filets of wirrah','Filetes de garoupa, congelados',10,'03','0304','030420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042060','Filés de bagre, congelados','Frozen filets of channel catfish','Filetes de bagre, congelados',10,'03','0304','030420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042070','Filés de merluza negra, congelados','Frozen filets of patagonian toothfish','Filetes de merluza negra, congelados',10,'03','0304','030420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042090','Filés de outros peixes, congelados','Frozen filets of fish','Filetes de demás pescados, congelados',10,'03','0304','030420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042100','Espadartes (Xiphias gladius) congelados','Sword fish (xiphias galdius),  frozen','Pez espada (Xiphias gladius), congelados',10,'03','0304','030421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042210','Marlongas-negras (dissostichus elegin.)cong.','Black whiting (dissostichus eleginoides), frozen','Merluzas negras (dissostichus eleginoides.),  congeladas',10,'03','0304','030422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042290','Outros filés de peixes, congelados','Other fish fillets, frozen','Otros filetes de peces, congelados',10,'03','0304','030422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042910','Filé/merluza (merluccius spp.) congelados','Fillet/whiting (merluccius spp.), frozen','Filete/merluza (merluccius spp.), congelados',10,'03','0304','030429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042920','Filé/pargo (Lutjanus purpureus) congelados','Frozen filets of southern red snapper (Lutjanus purpureus)','Filetes de pargo (Lutjanus purpureus), congelados',10,'03','0304','030429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042930','Filé/tilápia (oreochromis niloticus) congel.','Filet/tilapia (oreochromis niloticus), frozen','Filetes de tilapia (oreochromis niloticus),  congelados',10,'03','0304','030429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042940','Filé/cher-pov. (polyprion amer.)congelados','Filet/cher-pov.(polyprion americanus.) frozen','Filete/cher-pov.(polyprion amer.) congelados',10,'03','0304','030429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042950','Filé/garoupa (acanthistius spp.) congelados','Frozen filets of wirrah (acanthistius spp)','Filetes de tilapia (acanthistius spp),  congelados',10,'03','0304','030429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042960','Filé/bagre (Ictalurus puntactus) congelados','Frozen filets of channel catfish (Ictalurus puntactus)','Filetes de bagre (Ictalurus puntactus),  congelados',10,'03','0304','030429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042970','Filé de tubarões-azuis, congelados','Blue shark fillet, frozen','Filete de tiburón azul, congelado',10,'03','0304','030429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03042990','Outros filés congelados de peixes','Others fish fillets, frozen','Otros filetes de peces, congelados',10,'03','0304','030429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03043100','Filés de Tilápias (frescos, refrigerados ou conelados)','Fillets of tilapia (fresh, chilled or frozen)','Filetes de tilapia(frescos, refrigerados ou congelados)',10,'03','0304','030431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03043210','Filés de bagre(Ictalurus puntactus),fr.,refrig.ou cong.','Fillets of catfish (Ictalurus puntactus), fre,.ch. fr.','Filetes de bagre (Ictalurus puntactus),fr.,refrig.,con.',10,'03','0304','030432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03043290','Filés de outros bagres,frescos,refrigerados ou congel.','Fillets of other catfish, fresh, chilled or frozen','Filetes de otros bagres, frescos, refrigerados o cong.',10,'03','0304','030432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03043300','Filé de perca-do-nilo, fresco, refrigerado ou congelado','Fillets of nile perch, fresh, frozen or chilled','Filetes de perca del nilo,frescos, refrigerados o cong.',10,'03','0304','030433');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03043900','Files/out. carnes de out. peixes,frescos, ref. ou cong.','Fillets/other meats o other fish,frozen,chilled or fre.','Filetes y otras carnes de otros peces, fr., refr.o con.',10,'03','0304','030439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03044100','Filés de salmões-do-pacifico e salmão-do-danubio','Fillets of salmons of pacific and danube','Filetes of salmónes de pacífico e del danubio',10,'03','0304','030441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03044200','Filés de truta (almo trutta, oncorhynchus mykiss, etc)','Trout fillets (almo trutta, oncorhynchus mykiss, etc.)','Filetes de trucha (almo trutta, oncorhynchus mykiss,et)',10,'03','0304','030442');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03044300','Filés de peixes chatos (pleuronectidae, soleidae, etc)','Fillets of flatfish (pleuronectidae, soleidae, etc.)','Filetes of platija (pleuronectidae, soleidae, etc.)',10,'03','0304','030443');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03044400','Filés de peixes das famílias bregmacerotidae, etc','Fish fillets of families bregmacarotidae','Filetes de peces de las familias bregmacarotidae',10,'03','0304','030444');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03044500','Filés e outras carnes de espadarte (Xyphias gladius)','Fillets and other meat of swordfish (Xyphias gladius)','Filetes y demás carnes de pez espada (Xyphias gladius)',10,'03','0304','030445');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03044600','Filés de merluza negra e merluza antártica','Fillets of black hake and hake from antartica','Filetes de merluza negra y merluza antártica',10,'03','0304','030446');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03044910','Filé de cherne-poveiro, fresco/refrigerado','Fillets of atlantic wreckfish, fresh or chilled','Filetes de mero-poveiro, fresco o refrigerado',10,'03','0304','030449');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03044920','Filé de garoupa(acanthistius spp)fresc/refr','Fillets of groupers (acanthistius spp),fresh or chilled','Filetes de meros (acanthistius spp), fresco o refrig.',10,'03','0304','030449');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03044990','Filés de outros peixes, frescos ou refrigerados','Other fish fillets, fresh or chilled','Los demás filetes de peces, frescos o refrigerados',10,'03','0304','030449');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03045100','Filés de tilápia,bagre,carpa,enguias, fr. ou refri.','Fillet of tilapia, catfish, carp, eel, fresh or chilled','Filete de tilapia, bagre, carpa, anguila, fresco o ref.',10,'03','0304','030451');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03045200','Filé e outras carnes de salmonídeos, fr. ou refrig.','Fillet and other meats of salmon, fresh or chilled','Filete y otras carnes de salmón, frescos o refrigerados',10,'03','0304','030452');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03045300','Filé peix. das fam. breg.eucl.gad.mac.mel.mer.mor e mur','Fish fillets of specific families','Filets of peces de familias específicas',10,'03','0304','030453');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03045400','Filé de espadartes (Xiphias gladius), fres. ou refrig.','Fillets of swordfish (xyphias gladius),fresh or chilled','Filetes de pez espada (xyphias gladius), fresco o refr.',10,'03','0304','030454');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03045500','Filés de merluza negra e merluza antartica,fr. ou refr.','Fillets of black hake and antartica hake, fresh or chi.','Filetes de merluzas negras e antárticas, fresco o refr.',10,'03','0304','030455');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03045900','Outros filés de peixes, frescos ou refrigerados','Other fish fillets, fresh or chilled','Los demás filetes de peces, fresco o refrigerado',10,'03','0304','030459');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03046100','Filés de tilápias (oreochromis spp.), congelados','Fillets of tilapias (oreochromis spp.), frozen','Filetes de tilapías (oreochromis spp.), congelados',10,'03','0304','030461');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03046210','Filés de bagre (ictalarus puntactus), congelados','Fillets of catfish (ictalarus puntactus), frozen','Filetes de bagre (ictalarus puntactus), congelados',10,'03','0304','030462');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03046290','Outros filés de peixes, congelados','Other fish fillets, frozen','Los demás filetes de peces, congelado',10,'03','0304','030462');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03046300','Filé de perca-do-nilo (lates niloticus), congelado','Fillets of nile perch (lates niloticus), frozen','Filetes of perca del nilo (lates niloticus), congelados',10,'03','0304','030463');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03046900','Filé de peixe cabeça-de-serpente, congelado','Fillets of snakehead fish, frozen','Filete de pece cabeza de serpiente, congelado',10,'03','0304','030469');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03047100','Filé bacal.-do-atlantico, da-groenl., do-pacifico,cong.','Fillets of cods from atlantic,pacific,greenland, frozen','Filetes de bacalaos del atlántico, pacífico, congelados',10,'03','0304','030471');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03047200','Filé de haddock ou lubina, congelado','Haddock or lubina fillet, frozen','Filetes de haddock o lubina, congelados',10,'03','0304','030472');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03047300','Filé de saithe (pollachius virens), congelado','Fillets of saithe (pollachius virens), frozen','Filetes de saithe (pollachius virens), congelado',10,'03','0304','030473');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03047400','Filés de merluzas e abroteas, congelados','Fillets of hake and abrotea, frozen','Filets de merluza y abroteas, congelados',10,'03','0304','030474');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03047500','Filé de merluza-do-alasca (theragra chalcogramma), cong','Fillet of hake from alasca(theragra chalcogramma),froze','Filete de merluza del alasca (theragra chalcogramma)com',10,'03','0304','030475');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03047900','Outros filés de peixes, congelados','Other fish fillets, frozen','Los demás filetes de peces, congelados',10,'03','0304','030479');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03048100','Filé de salmão-do-pacifico,do-danubio,do-atlantico,cong','Fillets of pacific, atlantic and danube salmon, frozen','Filetes de salmónes del pacífico, etc, congelados',10,'03','0304','030481');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03048200','Filés de trutas, congelados','Trout fillets, frozen','Filetes de trucha, congelados',10,'03','0304','030482');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03048300','Filés de peixes chatos, congelados','Fillets of flatfish, frozen','Filetes of platija, congelados',10,'03','0304','030483');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03048400','Filés de espadarte (Xiphias gladius), congelados','Fillets of swordfish (xyphias gladius), frozen','Filetes de pez espada (xyphias gladius), congelados',10,'03','0304','030484');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03048510','Filé de merluza negra (dissostichus eleginoides),cong','Fillets of black hake (dissostichus eleginoides),frozen','Filete de merluza negra (dissostichus eleginoides),co.',10,'03','0304','030485');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03048520','Filé de merluza antartica(dissostichus mawsoni),cong.','Fillets of antartic hake (dissostichus mawson), frozen','Filete de merluza de antártica(dissostichus mawson),co.',10,'03','0304','030485');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03048600','Filés de arenques(clupea harengus,clupea pallasii)cong.','Fillet of herring (clupea harengus y pallasii), frozen','Filetes de arenque (clupea harengus y pallasii), conge.',10,'03','0304','030486');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03048700','Filés de atuns e bonito-listrado, congelados','Tuna fillets, frozen','Filetes de atún y lindo rayado, congelados',10,'03','0304','030487');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03048910','Filé de pargo (Lutjanus purpureus)','Fillet of porgies, frozen','Filetes de pargo (Lutjanus purpureus), congelado',10,'03','0304','030489');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03048920','Filé de cherne-poveiro (poluprion americanus),cong.','Fillet of atlantic wreckfish, frozen','Filetes de mero-poveiro, congelado',10,'03','0304','030489');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03048930','Filé de garoupa (acanthistius spp.), congelados','Fillets of grouper (acanthistius spp.), frozen','Filete de mero (acanthistius spp.), congelados',10,'03','0304','030489');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03048940','Filé de tubarão-azul (prionace glauca), congelados','Fillets of blue shark (prionace glauca), frozen','Filete de tiburón azul (prionace glauca), congelados',10,'03','0304','030489');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03048990','Outros filés  congelados, de peixes','Other frozen fillets, of fish','Los demás filetes congelados de pescado',10,'03','0304','030489');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03049000','Outras carnes de peixes, congeladas','Other fish meat, frozen','Otras carnes de pescados, congeladas',10,'03','0304','030490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03049100','Espadartes (Xiphias gladius)fresc/refr/cong.','Sword fish (Xiphias gladius),  fresh,  chilled,  frozen','Pez espada (Xiphias gladius),  fresco,  refrigerado o congelado',10,'03','0304','030491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03049200','Marlongas (dissostichus spp.)fresc/refr/cong.','Whiting (dissostichus spp.), fresh, chilled, frozen','Merluza (dissostichus spp.), fresca, refrigerada, congelada',10,'03','0304','030492');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03049211','Bochecha de peixes marlongas-negras, frescos/refrig.cong','Whiting cheeks, fresh, chilled, frozen','Mejilla de merluzas, frescas, secas o refrigeradas',10,'03','0304','030492');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03049212','Colares de peixex marlongas-negras, frescos/refrig.cong.','Withing necklaces, fresh, chilled, frozen','Collares de merluza, frescos, secos, refrigerados',10,'03','0304','030492');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03049219','Outs.peixes marlongas-negras, frescos/refriger.congelad.','Other black whiting, fresh, chilled, frozen','Otras merluzas negras, frescas, refrigeradas, congeladas',10,'03','0304','030492');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03049221','Bochecha de peixes marlongas-antart.frescos/refrig/cong','Antarctic whiting cheeks, fresh, chilled, frozen','Mejilla de merluzas, frescas, secas o refrigeradas',10,'03','0304','030492');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03049222','Colares de peixes marlongas-antart.frescos/refrig/cong.','Antarctic withing necklaces, fresh, chilled, frozen','Collares de merluza, frescos, secos, refrigerados',10,'03','0304','030492');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03049229','Outs.peixes marlongas-do-antart) frescos/refriger/cong.','Other antarctic whiting, fresh, chilled, frozen','Otras merluzas, frescas, refrigeradas, congeladas',10,'03','0304','030492');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03049300','Outras carnes de tilápias,bagres,carpas,enguias, cong.','Other meat of tilapia, catfish, carp, eel, frozen','Otras carnes de tilapias,bagres,carpas,anguilas, cong.',10,'03','0304','030493');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03049400','Outras carnes de merluza-do-alasca, congeladas','Other meats of hakes from alasca, frozen','Otras carnes de merluzas del alasca, congeladas',10,'03','0304','030494');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03049500','Out.car.pei.da fam. breg,euc,gad,mac.mel.mer.,etc,cong.','Other fish meat of determined species, frozen','Otras carnes de peces de familias específ., congeladas',10,'03','0304','030495');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03049900','Outs.carn.de peixes, fresc., refrig.ou congelados','Other fish meat,  fresh,  chilled or frozen','Otras carnes de peces, frescas, refrigeradas ou congeladas',10,'03','0304','030499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03051000','Farinhas, pos e "pellets" de peixes, p/alimentação humana','Flours/meals/pellets of fish for human consumption','Harinas, polvos y pellets de pescados, p/aliment.humana',10,'03','0305','030510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03052000','Fígados, ovas e semen, de peixes, secos, defumados, etc.','Livers/roes of fish, dried, smoked, etc.','Hígados, huevas y lechas de pescados, secos, ahumados, etc',10,'03','0305','030520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03053000','Filés de peixes, secos, salgados, em salmoura, n/defumados','Fish filets,  dried, salted or in brine, but not smoked','Filetes de pescados, secos, salados, en salmuera, s/ahumar',10,'03','0305','030530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03053010','Bacalhaus(gadus)morhua, gadus ogac, gadus macrocephalus','Bacalhaus(gadus)morhua, gadus ogac, gadus macrocephalus','Bacalhaus(gadus)morhua, gadus ogac, gadus macrocephalus',10,'03','0305','030530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03053020','Saithes(polachius virens),lings e zarbos(brosme brosme)','Saithes(polachius virens),lings e zarbos(brosme brosme)','Saithes(polachius virens),lings e zarbos(brosme brosme)',10,'03','0305','030530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03053090','Outros filés de peixes,secos,salgados/salmoura,n/defum.','Outros files de peixes,secos,salgados/salmoura,n/defum.','Outros files de peixes,secos,salgados/salmoura,n/defum.',10,'03','0305','030530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03053100','Filés de peixes,secos,salgados,em salmoura,n/defumados','Fish fillets, dried, salted, in brine, not smoked','Filetes de peces, secos,salados, en salmuera,no ahumado',10,'03','0305','030531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03053210','Filés de bacalhau,secos,salgados,em salmoura,n/defumado','Cod fillets, dried, salted, in brine, not smoked','Filetes de bacalao,secos,salados,en salmuera,no ahumado',10,'03','0305','030532');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03053220','Filés de saithe, secos,salgados,em salmoura,n/defumados','Saithe fillets, dried, salted, in brine, not smoked','Filetes de saithe,secos,salados,en salmuera,no ahumado',10,'03','0305','030532');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03053290','Outros filés de peixes, secos,salgados/salmoura,n/defu.','Other fish fillets, dried, salted, in brine, not smoked','Ot.fil. de peces, secos,salados, en salmuera,no ahumado',10,'03','0305','030532');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03053910','Filés de ling e zarbo,secos,salgados,em salmoura,n/defu','Fillets of ling and tusk,dried,salted,in brine, not smk','Filetes de ling y zarbo,salados,en salmuera,no ahumado',10,'03','0305','030539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03053990','Filés de outros peixes,secos,salgados,em salm.,n/defu.','Fillets of other fish,dried,salted,in brine,not smoked','Filetes de ot. peces, secos,salados,en salmuera,no ahu.',10,'03','0305','030539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03054100','Salmões-do-pacífico, do atlântico e do danúbio, defumados','Pacific salmon, atlantic salmon and danube salmon, smoked','Salmones del pacífico y del danubio, ahumados',10,'03','0305','030541');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03054200','Arenques defumados, mesmo em filés','Herrings in filets, smoked','Arenques ahumados, incluso en filetes',10,'03','0305','030542');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03054300','Truta defumada, mesmo em filés','Smoked trout, even in fillets','Truta ahumada, mismo en filetes',10,'03','0305','030543');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03054400','Tilápia, bagre, carpa, enguia, defumados, mesmo em filés','Tilapia, catfish, carp, eel, smoked, even in fillets','Tilapia, bagre, carpa, enguia, ahumado, mismo en filete',10,'03','0305','030544');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03054910','Bacalhaus (Gadus) defumados, mesmo em filés','Smoked cod (Gadus), including filets','Bacalaos (Gadus) ahumados, incluso en filetes',10,'03','0305','030549');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03054920','Saithes(polachius virens),lings e zarbos(brosme brosme)','Saithes(polachius virens),lings e zarbos(brosme brosme)','Saithes(polachius virens),lings e zarbos(brosme brosme)',10,'03','0305','030549');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03054990','Outros peixes defumados, mesmo em filés','Other smoked fish, including filets','Los demás pescados ahumados, incluso en filetes',10,'03','0305','030549');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03055100','Bacalhaus (gadus) secos, mesmo salgados, mas n/defumados','Dried cod (gadus), incl.salted but not smoked','Bacalaos (gadus) secos, incluso salados, sin ahumar',10,'03','0305','030551');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03055910','Bacalhaus polares, lings, zarbos, etc.secos, não defumados','Polar cod/lings/zarbos, etc.dried but not smoked','Bacalaos polares, lings, zarbos, etc, secos, s/ahumar',10,'03','0305','030559');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03055920','Barbatanas de tubarão, secas, mesmo salg.n/def.','Shark fins, dried, incl.salted but not smoked','Aletas de tiburón,  secas, incluso saladas, sin ahumar',10,'03','0305','030559');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03055990','Outros peixes secos, mesmo salgados, mas não defumados','Other dried fish, incl.salted but not smoked','Los dem.pescados secos, incluso salados, sin ahumar',10,'03','0305','030559');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03056100','Arenques salgados, não secos, não defumados e em salmoura','Salted herrings, but not dried, not smoked and in brine','Arenques salados, sin secar ni ahumar o en salmuera',10,'03','0305','030561');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03056200','Bacalhaus (gadus) salgados, não secos, não defumados, salmoura','Salted cod (gadus),  but n/ dried, n/ smoked, in brine','Bacalaos(gadus)salados, s/secar ni ahumar, en salmuera',10,'03','0305','030562');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03056300','Anchovas salgadas, não secas, não defumadas e em salmoura','Salted anchovies, n/dried, n/smoked and in brine','Anchoas saladas, sin secar  ni ahumar o en salmuera',10,'03','0305','030563');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03056400','Tilápias,bag.,car.enguia,salg.,nao sec., n/ defu.em sal','Tilapia, catfish, carp, eel,salted, not dried, in brine','Tilapia,bagre,carpa,enguia,no secos,no ahumado,en salm.',10,'03','0305','030564');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03056900','Outros peixes salgados, n/secos, n/defumad. e em salmoura','Other salted fish, n/dried, n/smoked and in brine','Los dem.pescados salados, s/secar n/ahumar o en salmuera',10,'03','0305','030569');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03056910','Saithes(polachius virens),lings e zarbos(brosme brosme)','Saithes(polachius virens),lings e zarbos(brosme brosme)','Saithes(polachius virens),lings e zarbos(brosme brosme)',10,'03','0305','030569');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03056990','Outros peixes salgados n/secos, n/defum e em salmoura','Outros peixes salgados n/secos, n/defum e em salmoura','Outros peixes salgados n/secos, n/defum e em salmoura',10,'03','0305','030569');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03057100','Barbatanas de tubarão','Shark fins','Aletas de tiburón',10,'03','0305','030571');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03057200','Cabeças, caudas e bexigas natatórias, de peixes','Heads, tails, and swim bladders, of fish','Cabezas, colas, y la vejiga natatoria de los peces',10,'03','0305','030572');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03057900','Outros desperdicios comestiveis, de peixes','Other edible waste, fish','Desechos de los peces, comestibles',10,'03','0305','030579');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061100','Lagostas (palinurus, panulirus e jasus) congeladas','Frozen rock lobsters (palinurus, panulirus and jasus)','Langostas (palinurus,  panulirus y jasus) congeladas',10,'03','0306','030611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061110','Lagostas inteiras, congeladas','Whole lobsters,  frozen','Langostas enteras,  congeladas',10,'03','0306','030611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061190','Outras lagostas, congeladas, exceto as inteiras','Other frozen rock lobster, except whole','Las demás langostas, congeladas, excepto las enteras',10,'03','0306','030611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061200','Lavagantes ("homards")(homarus spp) congelados','Frozen lobster (homards spp.)(homarus spp.)','Bogavantes ("homards")(homarus spp) congelados',10,'03','0306','030612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061300','Camarões congelados','Frozen shrimps','Camarones congelados',10,'03','0306','030613');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061310','Camarões "krill", congelados','Frozen shrimps "krill"','Camarones "krill",  congelados',10,'03','0306','030613');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061391','Camarões, inteiros, congelados, exceto "krill"','Frozen whole shrimps, except "krill"','Camarones, enteros, congelados, excepto "krill"',10,'03','0306','030613');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061399','Outros camarões congelados, exceto "krill"','Other frozen shrimps, except "krill"','Los demás camarones congelados, excepto "krill"',10,'03','0306','030613');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061400','Caranguejos congelados','Frozen crabs','Cangrejos congelados',10,'03','0306','030614');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061500','Lagosta norueguesa (nephrops norvegicus)','Norwegian lobster (nephros norvegicus)','Langosta noruega (nephrops norvegicus)',10,'03','0306','030615');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061610','Camarões de água fria (pandalus spp.) inteiros, congel.','Shrimp of cold water (pandalus spp.), whole, frozen','Gambas de agua fría (pandalus spp) enteros, congelados',10,'03','0306','030616');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061690','Camarões de água fria, que não inteiros, congelados','Shrimp of cold water, not whole, frozen','Gambas de agua fría, no enteros, congelados',10,'03','0306','030616');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061710','Outros camarões inteiros, congelados','Other whole prawns, frozen','Otras gambas enteras, congelados',10,'03','0306','030617');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061790','Outros camarões, que não inteiros, congelados','Other prawns, not whole, frozen','Otras gambas, no enteros, congelados',10,'03','0306','030617');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061900','Outros crustáceos congel.incl.farinhas, etc.p/alim.humana','Other frozen crustaceans, incl.flours, etc.forhuman cons.','Los dem.cangrejos congelados, inc.harinas, etc, p/alim.hum',10,'03','0306','030619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061910','Krill (euphasia superba), congelado','Krill (euphasia superba), frozen','Krill (euphasia superba), congelado',10,'03','0306','030619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03061990','Outr. crustáceos congel.incl.farinhas,etc,p/alim.humana','Oth.frozen crustaceans,inclu.flours,f/human consump.','Otros crustáceos congelados, para consumo humano',10,'03','0306','030619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03062100','Lagostas (palinurus, panulirus e jasus) não congeladas','Not frozen rock lobster (palinurus, panulirus, jasus)','Langostas (palinurus,  panulirus y jasus) sin congelar',10,'03','0306','030621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03062200','Lavagantes ("homards")(homarus spp) não congelados','Not frozen lobster ("homards")(homarus spp)','Bogavantes ("homards")( homarus spp) sin congelar',10,'03','0306','030622');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03062300','Camarões não congelados','Shrimps, not frozen','Camarones sin congelar',10,'03','0306','030623');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03062400','Caranguejos não congelados','Crabs, not frozen','Cangrejos sin congelar',10,'03','0306','030624');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03062500','Lagosta norueguesa (nephrops norvegicus), nao congelada','Norwegian lobster (nephrops norvegicus), not frozen','Langosta noruega (nephrops norvegicus), no congelada',10,'03','0306','030625');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03062600','Camarões de água fria, não congelados','Shrimp of cold water, not frozen','Gambas de agua fría, sin congelar',10,'03','0306','030626');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03062700','Outros camarões, não congelados','Other prawns, not frozen','Otras gambas, no congeladas',10,'03','0306','030627');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03062900','Outros crustáceos não congel.incl.farinhas p/alim.humana','Oth.n/frozen crustaceans, incl.flours, etc.forhuman cons.','Los dem.crustáceos s/congelar, inc.harinas p/alim.humana',10,'03','0306','030629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03062910','Lagostas de água doce não congeladas','Fresh water lobsters, not frozen','Langosta de agua dulce, sin congelar',10,'03','0306','030629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03062990','Outros crustáceos não congel.inclusive farinhas p/alim.humana','Oth.n/frozen crustaceans, incl.flours, etc.forhuman cons.','Los dem.crustáceos s/congelar, inc.harinas p/alim.humana',10,'03','0306','030629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03071000','Ostras vivas, frescas, refrigeradas, congeladas, secas, etc.','Oysters, live, fresh, chilled, frozen, dried, etc.','Ostras vivas, frescas, refrigeradas, congeladas, secas, etc',10,'03','0307','030710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03071100','Ostras vivas, frescas ou refrigeradas','Live oysters, fresh or chilled','Ostras vivas, frescas o refrigeradas',10,'03','0307','030711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03071900','Outras ostras vivas','Other live oysters','Otras ostras vivas',10,'03','0307','030719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03072100','Vieiras, outs.mariscos (pecten, etc) vivos, frescos, refrig','Live/fresh/chilled scallops, other shellfishes (pecten, etc)','Veneras, dem.moluscos(pecten,  etc)vivos, frescos, refrig.',10,'03','0307','030721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03072900','Vieiras, outs.mariscos (pecten, etc) congelados, secos, etc','Frozen/dried/etc.scallops, oth.shellfishes (pecten, etc)','Veneras, dem.moluscos(pecten,  etc)congelados, secos, etc',10,'03','0307','030729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03073100','Mexilhoes (mytilus, perna) vivos, frescos, refrigeraos','Live/fresh/chilled mussels (mytilus spp., perna spp.)','Mejillones(mytilus,  perna)vivos, frescos, refrigerados',10,'03','0307','030731');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03073900','Mexilhoes (mytilus, perna) congelados, secos, salgados, etc','Frozen/dried/salted/etc.mussels(mytilus spp.perna spp)','Mejillones(mytilus,  perna)congelados, secos, salados, etc',10,'03','0307','030739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03074100','Sibas, sepíolas, potas e lulas, vivos, frescos, refrigerados','Liv/fres/chil.sepia officin., rossia macr., sepiola, squid','Jibias, globitos, potas y calamares, vivos, frescos, refrig.',10,'03','0307','030741');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03074911','Potas e lulas (ommastrephes, loligo, etc), congelados','Frozen rossia macrosoma/squid (ommastrephes, loligo, etc)','Potas y calamares(ommastrephes,  loligo,  etc), congelados',10,'03','0307','030749');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03074919','Sibas (chocos)(etc) e sepiolas, congelados','Frozen sepia officinalis and sepiola','Jibias (chocos)(etc) y globitos,  congelados',10,'03','0307','030749');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03074920','Sibas, sepiolas, potas e lulas, secos, salgados, em salmoura','Salt./dried/brin.sepia offic.rossia macr.sepioloa, squid','Jibias, globitos, potas y calamares, secos, salad.en salm.',10,'03','0307','030749');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03074990','Sépias e lulas, em outras formas','Cuttlefish and squid, in other ways','Sepias y calamares, de otras maneras',10,'03','0307','030749');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03075100','Polvos (octopus spp) vivos, frescos ou refrigerados','Live, fresh or chilled octopus (octopus spp.)','Pulpos (octopus spp) vivos,  frescos o refrigerados',10,'03','0307','030751');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03075910','Polvos (octopus spp) congelados','Frozen octopus (octopus spp.)','Pulpos (octopus spp) congelados',10,'03','0307','030759');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03075920','Polvos (octopus spp) secos, salgados ou em salmoura','Octopus dried, salted or in brine','Pulpos (octopus spp) secos, salados o en salmuera',10,'03','0307','030759');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03075990','Polvos, em outras formas','Octopus, in other forms','Pulpos, en otras formas',10,'03','0307','030759');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03076000','Caracóis, exc.os do mar, vivos, frescos, refrigerados, etc.','Live, fresh, chilled, etc.snails exc.sea snails','Caracoles, exc.los de mar, vivos, frescos, refrigerados, etc',10,'03','0307','030760');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03077100','Ameijoas, berbigões e arcas, vivos, fre. ou refriger.','Clams, cockle, live, fresh or chilled','Almeja, berbgones y arcas, vivos,frescos o refrigerados',10,'03','0307','030771');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03077900','Ameijoas, berbigões e arcas, em outras formas','Clams, cockle, live, in other forms','Almeja, berbgones y arcas, vivos, en otras formas',10,'03','0307','030779');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03078100','Abalones vivos, frescos ou refrigerados','Abalones, live, fresh or chilled','Abalones vivos, frescos o refrigerados',10,'03','0307','030781');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03078900','Abalones, em outras formas','Abalones, in other forms','Abalones, en otras formas',10,'03','0307','030789');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03079100','Outros moluscos, invertebr.aquatic.vivos, frescos, refrig.','Oth.live/fresh/chilled invertebrates aquatic  molluscs','Los dem.moluscos, invertebrados acuát.vivos, frescos, refr',10,'03','0307','030791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03079900','Outros moluscos, invertebr.aquatic.congelados, secos, etc.','Oth.live/frosen/dried/etc.aquatic invert.mollusc','Los dem.moluscos, invertebrados acuát.congel.secos, etc',10,'03','0307','030799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03081100','Pepinos-do-mar, vivos, frescos ou refrigerados','Sea cucumbers, live, fresh or chilled','Pepinos de mar, vivos, frescos o refrigerados',10,'03','0308','030811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03081900','Pepinos-do-mar, em outras formas','Sea cucumbers, in other forms','Pepinos de mar, en otras formas',10,'03','0308','030819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03082100','Ouriços-do-mar, vivos, frescos ou refrigerados','Sea urchins, live, fresh or chilled','Erizos de mar, vivos, frescos o refrigerados',10,'03','0308','030821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03082900','Ouriços-do-mar, em outras formas','Sea urchins, in other forms','Erizos de mar, en otras formas',10,'03','0308','030829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03083000','Medusas (aguas-vivas) (rhopilema spp.)','Medusas (jellyfish) (rhopilema spp.)','Medusas (rhopilema spp.)',10,'03','0308','030830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('03089000','Out. inver. aquat, exc. crust. e molu.,cong,seco, etc','Other aquatic invertebrates, frozen, dried, etc.','Otros invertebrados acuáticos congelados, secos, etc',10,'03','0308','030890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04011010','Leite uht, cont.matéria gorda<=1%, não concentrado, n/adoc','Milk/cream fat content by weight<=1% n/concent.n/sug.','Leche uht, cont.materia grasa<=1%, s/concentr.ni edulcor.',10,'04','0401','040110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04011090','Outs.leites e cremes, mater.gorda<=1%, n/concentr.n/adoc.','Other milk/cream fat content by weight<=1% n/conc.n/sug','Las dem.leches y cremas, mat.grasa<=1%, s/conc.ni edulc.',10,'04','0401','040110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04012010','Leite uht, 1%<matéria gorda<=6%, não concentrado, n/adoc.','Milk/cream  fat cont.b/wei exceed.1%but n/6%n/con.n/sug','Leche uht, 1%<materia grasa<=6%, s/concentrar ni edulcor',10,'04','0401','040120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04012090','Outs.leites e cremes, 1%<mat.gorda<=6%, n/concentr.n/adoc','Oth.milk/cream fat cont.b/wei exc.1%but n/6%n/con n/sug','Las dem.leches y cremas, 1%<mat.grasa<=6%, s/conc.ni edul',10,'04','0401','040120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04013010','Leite cont.matéria gorda>6%, não concentrado, n/adocicado','Milk of a  fat content  by exceeding 6% n/con n/sug','Leche c/un cont.materia grasa>6%, s/conc.ni edulcor.',10,'04','0401','040130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04013021','Creme de leite, uht, matéria gorda>6%, nao concentr.n/adoc','Cream of milk, uht, of fat cont.by exceed.6% n/con.n/sug','Nata(crema), uht, materia grasa>6%, s/conc.ni edulcor.',10,'04','0401','040130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04013029','Outros cremes de leite, mater.gorda>6%, n/concentr.n/adoc','Oth.cream milk of fat content by exceed.6%, n/con n/sug','Las dem.natas(cremas), mat.grasa>6%, s/conc.ni edulcor.',10,'04','0401','040130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04014010','Leite,c/teor,em peso,de mat. gordas, > 6 %,mas <=  10 %','Milk with content, by weight, of fat 6<fat<= 10%','Leche con el contenido, en peso, 6<grasa<= 10%',10,'04','0401','040140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04014021','Creme de leite uht,c/teor em p.,de mat.gor >6%,mas<=10%','Milk cream uht, fat > 6º, but <= 10% of weight','Cremas de leche uht, grasa > 6, pero <= 10% del peso',10,'04','0401','040140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04014029','Outros cremes de leite,mater.gorda>6%,mas menor que 10%','Other milk cream, fat > 6º, but < 10% of weight','Outros cremas de leche, grasa > 6, pero < 10% del peso',10,'04','0401','040140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04015010','Leite, com teor, em peso,de mat. gordas,superior a 10 %','Milk with content, by weight, of fat > 10%','Leche con el contenido, en peso, de grasa> 10%',10,'04','0401','040150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04015021','Creme de leite uht,com teor,em peso,de mat. gordas>10 %','Milk cream uht, fat material >10% of its weight','Crema de leche uht, grasa > 10% del peso',10,'04','0401','040150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04015029','Outs.creme de leite,c/teor,em peso,de mat. gor.>10 %','Other milk cream, fat > 10% of its weight','Outros cremas de leche,  grasa > 10% del peso',10,'04','0401','040150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04021010','Leite em pó, mat.gorda<=1, 5%, arsênio<5ppm, concentr.adoc.','Milk in powder, fat content<=1, 5%arsenic<5ppm, con/ad sug','Leche en polvo, mat.grasa<=1, 5%, arsén<5ppm, conc.c/edulc.',10,'04','0402','040210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04021090','Outs.leites, cremes, em pó, mat.gorda<=1, 5%, concentr.adoc.','Other milk, cream, in powder, fat content<=1, 5% con/ad sug','Las dem.leches, natas, polvo, mat.grasa<1, 5%conc.c/edulc.',10,'04','0402','040210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04022110','Leite integral, em pó, matéria gorda>1.5%, concentr.n/adoc','Integral milk, in powder, fat cont.>1, 5%, concen.n/sugar','Leche entera, en polvo, mat.grasa>1, 5%concentr.s/edulcor.',10,'04','0402','040221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04022120','Leite parc.desnat.em pó, mat.gorda>1.5%, concentr.n/adoc.','Semi-ski.milk, powder, fat content>1, 5%, concent.n/sugar','Leche en polvo parc.descrem.mat.grasa>1, 5%, conc.s/edulc',10,'04','0402','040221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04022130','Creme de leite, em pó, matéria gorda>1.5%, concentr.n/adoc','Cream of milk, powder, fat cont>1, 5%, concent.n/sugar','Nata(crema), en polvo, mat.grasa>1, 5%, concentr.s/edulcor.',10,'04','0402','040221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04022910','Leite integral, em pó, etc.matéria gorda>1.5%, adocicado','Integral milk, powder, etc.fat cont>1, 5%, conc.added sugar','Leche entera, en polvo, etc, materia grasa>1.5%, c/edulcor.',10,'04','0402','040229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04022920','Leite parcialm.desnatado, em pó, matéria gorda>1.5%, adoc.','Semi-skim.milk, powder, etc.fat cont>1, 5%, con.added sug','Leche en polvo parc.descremada, mat.grasa>1, 5%, c/edulc.',10,'04','0402','040229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04022930','Creme de leite, em pó, etc.matéria gorda>1.5%, adocicado','Cream of milk, powder, etc.fat cont>1, 5% con.added sugar','Nata(crema), en polvo, etc, materia grasa>1.5%, c/edulc.',10,'04','0402','040229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04029100','Outros leites, cremes de leite, concentrados, n/adocicados','Other milk, cream of milk, concentrated, n/sugar','Las dem.leches, natas(cremas), concentradas, s/edulc.',10,'04','0402','040291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04029900','Outros leites, cremes de leite, concentrados, adocicados','Other milk, cream of milk, concentrated, added sugar','Las dem.leches, natas(crema), concentradas, c/edulcor.',10,'04','0402','040299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04031000','Iogurte','Yoghurt','Yogur',10,'04','0403','040310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04039000','Leitelho, leite, creme de leite, coalhados, fermentados, etc','Buttermilk, curdled milk and cream, kephir, fermented, etc.','Suero de manteq.leche, nata(crema), cuajados, ferm.etc',10,'04','0403','040390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04041000','Soro de leite, modificado ou não, mesmo concentrado, adoc.','Whey and modified whey, whether or n/concent.added sugar','Lactosuero, inc.concentrado, c/edulcorante',10,'04','0404','040410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04049000','Outros produtos constituídos do leite, mesmo adocicados, etc','Oth.products consisting of milk, whether or n/sweet., etc','Los dem.productos constituidos de leche, inc.c/edulc.etc',10,'04','0404','040490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04051000','Manteiga','Butter','Mantequilla',10,'04','0405','040510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04052000','Pastas de espalhar (barrar) de produtos provenientes do leite','Dairy spreads derived from milk','Pastas lácteas para untar',10,'04','0405','040520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04059010','Óleo butírico de manteiga ("butter oil")','Butter oil','Aceite butírico de mantequilla ("butter oil")',10,'04','0405','040590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04059090','Outras matérias gordas provenientes do leite','Other fats and oils derived from milk','Las demás materias grasas de la leche',10,'04','0405','040590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04061010','Queijo tipo mussarela, fresco (não curado)','Fresh (unripened or uncured) cheese, muzzarella type','Queso tipo mozzarella,  fresco (sin madurar)',10,'04','0406','040610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04061090','Outs.queijos frescos (não curados), incl.requeijão, etc.','Other fresh cheese (unripened or uncured), incl.curd, etc','Los dem.quesos frescos(s/madurar), incl.requesón,  etc',10,'04','0406','040610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04062000','Queijos ralados ou em pó, de qualquer tipo','Grated or powdered cheese, of all kinds','Quesos rallados o en polvo,  de cualquier tipo',10,'04','0406','040620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04063000','Queijos fundidos, exceto ralados ou em pó','Processed cheese, except grated or powdered cheese','Quesos fundidos,  excepto rallados o en polvo',10,'04','0406','040630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04064000','Queijos de pasta mofada (azul)','Blue-veined cheese','Quesos de pasta azul',10,'04','0406','040640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04069010','Queijos cont.teor de umidade<36%, em peso (massa dura)','Hard cheese of a moisture content, by weight <36%','Quesos con contenido de humedad<36%, en peso(pasta dura)',10,'04','0406','040690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04069020','Queijos cont.36%<=teor de umidade<46%, (massa semidura)','Semi hard cheese of a moist.cont.<=36%but less than 46%','Quesos c/contenido de 36%<= humedad<46%(pasta semidura)',10,'04','0406','040690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04069030','Queijos cont.46%<=teor de umidade<55%, (massa macia)','Soft cheese of a moisture content<=36%but less than 55%','Quesos con contenido de 46%<= humedad<55%(pasta blanda)',10,'04','0406','040690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04069090','Outros queijos','Other cheeses','Los demás quesos',10,'04','0406','040690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04070011','Ovos de galinha, para incubação','Hens'' eggs for incubation','Huevos de gallina, para incubación','20','04','0407','040700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04070019','Ovos de outras aves, para incubação','Other birds'' eggs, for incubation','Huevos de demás aves, para incubación','20','04','0407','040700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04070090','Outros ovos de aves, com casca, frescos, conservad.cozidos','Other birds'' eggs, in shell, fresh, preserved or cooked','Los dem.huevos de aves, c/cáscara, frescos, conserv.cocid.','20','04','0407','040700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04071100','Ovos de aves da especie gallus domesticus, p/ incubacao','Fresh eggs of birds ot  the species g.domesticus,hatch.','Huevos frescos de aves de la especie g.domesticus, inc.','20','04','0407','040711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04071900','Ovos de outras aves, destinados para incubação','Fresh eggs of other birds, for hatching','Huevos frescos de otras aves, para incubar','20','04','0407','040719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04072100','Ovos frescos de aves da espécie gallus domesticus','Fresh eggs of birds of  the species gallus domesticus','Huevos frescos de aves de la especie gallus domesticus','20','04','0407','040721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04072900','Ovos frescos de outras aves','Fresh eggs of other birds','Huevos frescos de otras aves','20','04','0407','040729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04079000','Ovos de outras aves, nao para incubacao ou nao frescos','Eggs of other birds, neither fresh nor for hatching','Huevos de otras aves, no frescos ni pra incubar',10,'04','0407','040790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04081100','Gemas de ovos, secas','Dried egg yolks','Yemas de huevos, secas',10,'04','0408','040811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04081900','Gemas de ovos, frescas, cozidas em água ou vapor, etc.','Fresh/cooked by steaming/by boiling in water egg yolks','Yemas de huevos,  frescas,  cocidas en agua o vapor,  etc',10,'04','0408','040819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04089100','Ovos de aves, sem casca, secos','Bird''s eggs, not in shell, dried','Huevos de aves, sin cáscara, secos',10,'04','0408','040891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04089900','Outs.ovos de aves, sem casca, frescos, cozidos em água, etc','Oth.birds'' eggs, n/shell, fresh, cooked b/boiling wat., etc','Los dem.huevos, sin cáscara, frescos, cocidos en agua, etc',10,'04','0408','040899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04090000','Mel natural','Natural honey','Miel natural',10,'04','0409','040900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('04100000','Outros produtos comestíveis de origem animal','Edible products of animal origin','Los demás productos comestibles de origen animal',10,'04','0410','041000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05010000','Cabelos em bruto e desperdícios de cabelo','Human hair, unworked;waste of human hair','Cabello en bruto y desperdicios de cabello',10,'05','0501','050100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05021011','Cerdas de porco, lavadas, alvejadas ou desengorduradas','Bristles of pig, washed, whitened or degreased','Cerdas de cerdo, lavadas, blanqueadas o desgrasadas',10,'05','0502','050210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05021019','Outras cerdas de porco e seus desperdícios','Other bristles of pig and waste thereof','Las demás cerdas de cerdo y sus desperdicios',10,'05','0502','050210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05021090','Cerdas de javali e seus desperdícios','Bristles of boar and waste thereof','Cerdas de jabalí y sus desperdicios',10,'05','0502','050210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05029010','Pelos de texugo e outros pelos p/escovas, pincéis, etc.','Hair of badger and other brush making hair, etc','Pelos de tejón y dem.pelos p/cepillos, pinceles, etc',10,'05','0502','050290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05029020','Desperdícios de pêlos','Wastes of hair','Desperdicios de pelos',10,'05','0502','050290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05030000','Crinas e seus desperdícios, mesmo em mantas','Horsehair and horseh.waste, whether/not put up as layer','Crin y sus desperdicios, incluso en capas con soporte',10,'05','0503','050300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05040011','Tripas de bovinos, frescas, refrig.congel.salg.defumadas','Fresh/chilled/frozen/salted/smoked guts of bovine','Tripas de bovino, frescas, refriger.congel.salad.ahumad.',10,'05','0504','050400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05040012','Tripas de ovinos, frescas, refrig.congel.salgad.defumadas','Fresh/chilled/frozen/salted/smoked guts of sheep','Tripas de ovino, frescas, refriger.congel.salad.ahumad.',10,'05','0504','050400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05040013','Tripas de suínos, frescas, refrig.congel.salgad.defumadas','Fresh/chilled/frozen/salted/smoked guts of swine','Tripas de porcino, frescas, refrig.congel.salad.ahumad.',10,'05','0504','050400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05040019','Tripas de outros animais, exc.peixes, frescas, refrig.etc.','Fresh/chil./froz./salt./smok.guts of oth.anim.exc.fish','Tripas de dem.animales, exc.pescados, frescas, refrig.etc',10,'05','0504','050400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05040090','Bexigas e estomagos, de animais, exc.peixes, frescas, etc.','Fresh, etc.bladders and stomach of anim.exc.fish','Vejiga y estómago, de animales, exc.pescados, frescas, etc',10,'05','0504','050400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05051000','Penas para enchimento ou estofamento, e penugem','Feathers of a kind used for stuffing and down','Plumas para relleno o estofar y plumón',10,'05','0505','050510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05059000','Peles e outs.partes de aves, com suas penas, penugem, etc.','Skins and other parts of birds, with their feathers, etc.','Pieles y dem.partes de ave, c/sus plumas, plumón, etc',10,'05','0505','050590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05061000','Osseína e ossos acidulados','Ossein and bones treated with acid','Oseína y huesos acidulados',10,'05','0506','050610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05069000','Outros ossos e núcleos corneos, em bruto, desengord.etc.','Other bones and horn-cores, unworked, defatted, etc.','Los dem.huesos y núcleos córneos, en brut.desgrasad.etc',10,'05','0506','050690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05071000','Marfim, seus pós e desperdícios','Ivory powders and wastes','Marfil, polvos y desperdicios de marfil',10,'05','0507','050710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05079000','Carapaças de tartarugas, chifres, galhadas, cascos, etc.','Tortoise-shell, horns, nails, claws, etc','Concha (carapazón) de tortuga, cuernos, astas, cascos, etc',10,'05','0507','050790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05080000','Coral, conchas, carapaças de moluscos, etc.em bruto, prepar','Coral, shells, shells of mollusks, etc.unworked, prepared','Coral, conchas, caparazones de moluscos, etc, en bruto, prep',10,'05','0508','050800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05090000','Esponjas naturais de origem animal','Natural sponges of animal origin','Esponjas naturales de origen animal',10,'05','0509','050900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05100010','Pâncreas de bovinos, p/prepar.prod.farmaceut.frescas, etc','Fresh pancreases of bovine, forprep.produc.pharmaceut.etc','Páncreas de bov.p/prepar.de prod.farmacéuticos, fresc.et',10,'05','0510','051000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05100090','Outras substâncias de animais, p/prepar.prods.farmaceut.','Other substances of animal, forprep.produc.pharmaceut.etc','Las dem.sustancias de animales, p/prep.prod.farmacéutic.',10,'05','0510','051000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05111000','Sêmen de bovino','Bovine semen','Semen de bovino','22','05','0511','051110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05119110','Ovas de peixes, fecundadas para reprodução','Roes of fish, fecundated for reproduction','Huevas de pescado, fecundadas p/la reproducción',10,'05','0511','051191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05119190','Outros prods.de peixes, etc.improprios p/aliment.humana','Other products of fish, etc.inappropriate forhuman consum','Los dem.prod.de pescado, etc, impropios p/la alim.humana',10,'05','0511','051191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05119910','Embriões de animais','Embryos of animals','Embriones de animales',10,'05','0511','051199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05119920','Sêmen animal','Animal semen','Semen de animal',10,'05','0511','051199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05119930','Ovos de bicho-da-seda','Silk-worm eggs','Huevos de gusano de seda',10,'05','0511','051199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05119990','Outros prods.de animais, improprios p/alimentação humana','Oth.products of anim., etc.inappropriate forhuman consum.','Los dem.prod.de animales, etc, impropios p/la alim.humana',10,'05','0511','051199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05119991','Crinas e desperdícios, mesmo em mantas','Horsehair and waste,  even in webs','Crina de caballo y desperdicios,  incluso en mantas',10,'05','0511','051199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('05119999','Outros produtos de origem animal, impróprios para alimentação humana','Other products ofanimal origin,  inappropriate for human consumption','Otros productos de origen animal , etc,  impropios para el consumo humano',10,'05','0511','051199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06011000','Bulbos, tubérculos, rizomas, etc.em repouso vegetativo','Bulbs, tubers, rhizomes, etc.in vegetative rest','Bulbos,  tubérculos,  rizomas,  etc en reposo vegetativo',11,'06','0601','060110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06012000','Bulbos, tubérculos, etc.em veget.em flor, muda de chicoria','Bulbs, tubers, rhizomes, etc.in veg.in flow.chicory plants','Bulbos, tubérculos, etc, en veget.en flor, raíces de achic',11,'06','0601','060120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06021000','Estacas não enraizadas e enxertos','Unrooted cuttings and slips','Esquejes sin enraizar e injertos',11,'06','0602','060210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06022000','Árvores, arbustos e silvados, de frutos comestíveis','Trees, shrubs and bushes, grafted, with edible fruit','Árboles,  arbustos y matas,  de frutos comestibles',11,'06','0602','060220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06023000','Rododendros e azaleias, enxertados ou não','Rhododendrons and azaleas, grafted or not','Rododendros y azaleas, incl.injertados',11,'06','0602','060230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06024000','Roseiras, enxertadas ou não','Roses, grafted or not','Rosales, inclusos injertados',11,'06','0602','060240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06029010','Micélios de cogumelos','Mushroom spawn','Micelios de hongos',10,'06','0602','060290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06029021','Mudas de orquídeas','Orchids cuttings and slips','Raíces de orquídeas',11,'06','0602','060290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06029029','Mudas de outras plantas ornamentais','Other cuttings and slips of ornamental plants','Raíces de las demás plantas ornamentales',11,'06','0602','060290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06029081','Mudas de cana-de-açúcar','Sugar cane cuttings and slips','Raíces de caña de azúcar',11,'06','0602','060290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06029082','Mudas de videira','Grape vines cuttings and slips','Raíces de vid',11,'06','0602','060290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06029083','Mudas de café','Coffee cuttings and slips of shrubs or trees','Raíces de café',11,'06','0602','060290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06029089','Mudas de outras plantas','Other cuttings and slips of plants','Raíces de las demás plantas',11,'06','0602','060290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06029090','Outras plantas vivas','Other live plants','Las demás plantas vivas',11,'06','0602','060290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06031000','Flores e seus botões, frescos, cortados para buquês, etc.','Fresh cut flowers and buds forbouquets, etc.','Flores y sus capullos, frescos, cortados para ramos, etc','20','06','0603','060310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06031100','Rosas e seus botões, cort.p/buquês, orn.fres.','Roses and their buttons, cut, for bouquets, ornamented, fresh','Rosa y sus botones, cortados, ornamento, frescas','20','06','0603','060311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06031200','Cravos e seus botôes, cort.p/buquês, orn.fres.','Carnation and their buttons, cut, for bouquets, ornamented, fresh','Clavo y sus botones, cortados, ornamento, frescas','20','06','0603','060312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06031300','Orquídeas seus bots., cort.p/buquês, orn.fres.','Orchids and their buttons, cut, for bouquets, ornamented, fresh','Orquídeas y sus botones, cortados, ornamento, frescas','20','06','0603','060313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06031400','Crisântemos seus bots.cort.p/buqs., orn.fres.','Chrysanthemums and their buttons, cut, for bouquets, ornamented, fresh','Crisantemo y sus botones, cortados, ornamento, frescas','20','06','0603','060314');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06031500','Lírios (lilium spp.)','Lilies (lilium spp.)','Lirios (lilium spp.)','20','06','0603','060315');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06031900','Outros flors.seus bots.cort.p/buquês, orn.fres.','Other flowers and their buttons, cut, for bouquets, ornamented, fresh','Otras flores y sus botones, cortados, ornamento, frescas','20','06','0603','060319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06039000','Flores e seus botoes, secos, etc.cortados p/buquês, etc.','Cut flowers and buds for bouquets, etc. dried, etc.','Flores y sus capullos, secos, etc, cortados para ramos, etc',10,'06','0603','060390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06041000','Musgos e linquens, para buquês ou ornamentação','Mosses and lichens for bouquets or ornamental','Musgos y líquenes,  para ramos o adornos',10,'06','0604','060410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06042000','Folhagem,folhas,ramos de plantas,frescos,p/buques,etc.','Foliage, branches of plants, fresh, for bouquets, etc','Follaje, ramas de plantas, frescos, para los ramos, etc',10,'06','0604','060420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06049000','Folhagem,folhas,ramos de plantas,secos,etc.p/buques,etc','Foliage, branches of plants, dried, for bouquets, etc','Follaje, ramas de plantas, secos, para los ramos, etc',10,'06','0604','060490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06049100','Folhagem, folhas, ramos de plantas, frescos, p/buquês, etc.','Fresh foliage/branches/other part of plants forbouq.etc','Follaje, hojas, ramas de plantas, frescos, p/ramos, etc',10,'06','0604','060491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('06049900','Folhagem, folhas, ramos de plantas, secos, etc.p/buquês, etc','Dried foliage/branches/other part of plants for bouq.etc','Follaje, hojas, ramas de plantas, secos, p/ramos, etc',10,'06','0604','060499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07011000','Batatas para semeadura (batata semente)','Seed potatoes','Patatas para siembra',10,'07','0701','070110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07019000','Outras batatas frescas ou refrigeradas','Other fresh or chilled potatoes','Las demás patatas frescas o congeladas',10,'07','0701','070190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07020000','Tomates, frescos ou refrigerados','Tomato, fresh or chilled','Tomates, frescos o refrigerados',10,'07','0702','070200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07031011','Cebolas para semeadura','Onions for sowing','Cebollas para siembra',10,'07','0703','070310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07031019','Outras cebolas frescas ou refrigeradas','Other fresh/chilled onions','Las dem.cebollas frescas o refrigeradas',10,'07','0703','070310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07031021','Echalotes para semeadura','Shallots for sowing','Chalotes para siembra',10,'07','0703','070310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07031029','Outras "echalotes" frescas ou refrigeradas','Other fresh/chilled shallots','Las demás chalotes frescas o refrigeradas',10,'07','0703','070310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07032010','Alho para semeadura','Garlic for sowing','Ajo para siembra',10,'07','0703','070320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07032090','Outros alhos frescos ou refrigerados','Other fresh/chilled garlic','Los demás ajos frescos o refrigerados',10,'07','0703','070320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07039010','Alho-porro e outs.prods.hortícolas aliaceos, p/semeadura','Leeks and other alliaceous vegetables for sowing','Puerros y demás hortalizas aliáceas,  para siembra',10,'07','0703','070390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07039090','Outs.alhos-porros, prods.hortícolas aliaceos, frescos, etc','Oth.fresh leeks/oth.alliaceous vegetables forsowing, etc','Los demás puerros,  hortalizas aliáceas,  frescos,  etc',10,'07','0703','070390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07041000','Couve-flor e brocolos, frescos ou refrigerados','Fresh/chilled cauliflowers and broccoli','Coliflores y brécoles,  frescos o refrigerados',10,'07','0704','070410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07042000','Couve-de-bruxelas, fresca ou refrigerada','Fresh/chilled brussels sprouts','Coles de bruselas,  fresca o refrigerada',10,'07','0704','070420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07049000','Couves, repolho, etc.do genero "brassica", frescos, refrig.','Fresh/chilled kale, cabbage, etc.similar brassicas','Coles, repollos, etc del género brassica, frescos, refrig.',10,'07','0704','070490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07051100','Alfaces repolhudas, frescas ou refrigeradas','Fresh/chilled lettuce','Lechugas repolladas,  frescas o refrigeradas',10,'07','0705','070511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07051900','Outras alfaces frescas ou refrigeradas','Fresh/chilled cabbage lettuce','Las demás lechugas frescas o refrigeradas',10,'07','0705','070519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07052100','Chicórias "witloof", frescas ou refrigeradas','Fresh/chilled "witloof" chicory','Achicorias "witloof", frescas o refrigeradas',10,'07','0705','070521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07052900','Outras chicórias, frescas ou refrigeradas','Other fresh/chilled "witloof" chicory','Las demás achicorias, frescas o refrigeradas',10,'07','0705','070529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07061000','Cenouras e nabos, frescos ou refrigerados','Fresh/chilled carrots and turnips','Zanahorias y nabos, frescos o refrigerados',10,'07','0706','070610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07069000','Beterrabas, rabanetes e outras raízes, frescas, refrigerad','Fresh/chilled beets, radishes and other roots','Remolachas, rábanos y dem.raíces, frescas, refrigeradas',10,'07','0706','070690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07070000','Pepinos e pepininhos "cornichons", frescos, refrigerados','Cucumbers and gherkins, fresh or chilled','Pepinos y pepinillos frescos, refrigerados',10,'07','0707','070700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07081000','Ervilhas (pisum sativum), frescas ou refrigeradas','Fresh/chilled peas (pisum sativum)','Guisantes (pisum sativum), frescos o refrigerados',10,'07','0708','070810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07082000','Feijões (vigna, phaseolus spp) frescos ou refrigerados','Fresh/chilled beans (vigna, phaseolus spp)','Judias (vigna,  phaseolus spp) frescos o refrigerados',10,'07','0708','070820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07089000','Outros legumes de vagem, frescos ou refrigerados','Other fresh/chilled leguminous vegetables','Los demás legumbres de vaina, frescos o refirgerados',10,'07','0708','070890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07091000','Alcachofras frescas ou refrigeradas','Fresh or chilled artichokes','Alcachofas frescas o refrigeradas',10,'07','0709','070910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07092000','Aspargos frescos ou refrigerados','Fresh or chilled asparagus','Espárragos frescos o refrigerados',10,'07','0709','070920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07093000','Berinjelas frescas ou refrigeradas','Fresh/chilled aubergines (egg-plants)','Berenjenas frescas o refrigeradas',10,'07','0709','070930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07094000','Aipo fresco ou refrigerado, exceto aipo-rabano','Fresh/chilled celery, except celeriac','Apio, frescos o refrigerados, excepto el apionabo',10,'07','0709','070940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07095100','Cogumelos frescos ou refrigerados','Fresh/chilled mushrooms of the genus agaricus','Setas frescas o refrigeradas',10,'07','0709','070951');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07095200','Trufas frescas ou refrigeradas','Fresh/chilled truffles','Trufas frescas o refrigeradas',10,'07','0709','070952');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07095900','Outros cogumelos frescos ou refrigerados','Other fresh/chilled mushrooms','Los demás hongos frescos o refrigerados',10,'07','0709','070959');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07096000','Pimentões e pimentas, frescos ou refrigerados','Fresh/chilled fruits of the genus capsicum or pimenta','Ajíes y pimientos, frescos o refrigerados',10,'07','0709','070960');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07097000','Espinafres frescos ou refrigerados','Fresh/chilled spinach','Espinacas frescas o refrigeradas',10,'07','0709','070970');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07099000','Outros produtos hortícolas, frescos ou refrigerados','Other vegetables, fresh or chilled','Las demás hortalizas, frescas o refrigeradas',10,'07','0709','070990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07099011','Milho doce, para semeadura','Sweet corn, for sowing','Maíz dulce, para siembra',10,'07','0709','070990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07099019','Milho doce, fresco ou refrigerad, exceto para semeadura','Fresh/chilled sweet corn, except for sowing','Maíz dulce,  fresco o refrigerado,  excepto para siembra',10,'07','0709','070990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07099020','Alcachofras, frescas ou refrigeradas','Artichokes, fresh or chilled','Alcachofas frescas o refrigeradas',10,'07','0709','070990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07099090','Outros produtos hortícolas, frescos ou refrigerados','Other vegetables, fresh or chilled','Las demás hortalizas, frescas o refrigeradas',10,'07','0709','070990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07099100','Alcachofras, frescas ou refrigeradas','Artichokes, fresh or chilled','Alcachofas, frescas o refrigeradas',10,'07','0709','070991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07099200','Azeitonas, frescas ou refrigeradas','Olives, fresh or chilled','Aceitunas, frescas o refrigeradas',10,'07','0709','070992');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07099300','Abóboras, abobrinhas e cabaças, fre.ou refrigerada','Pumpkins, squash and gourds, fresh or chilled','Calabazas y cabalacíns, frescas o refrigeradas',10,'07','0709','070993');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07099911','Milho doce, para semeadura','Sweet corn for sowing','Maíz dulce, para siembra',10,'07','0709','070999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07099919','Milho doce, fresco ou refrigerado,exceto para semeadura','Sweet corn, fresh or chilled, except for sowing','Maíz dulce, fresco o refrigerado, excep para siembra',10,'07','0709','070999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07099990','Outros produtos hortícolas, frescos ou refrigerados','Other vegetables, fresh or chilled','Las demás hortalizas, frescas o refrigeradas',10,'07','0709','070999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07101000','Batatas congeladas, não cozidas ou cozidas em água/vapor','Potatoes (froz/uncook/cooked by steaming/boiling water)','Patatas congeladas, aunque estén cocidas en agua/vapor',10,'07','0710','071010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07102100','Ervilhas congeladas, não cozidas/cozidas em água/vapor','Peas (froz/uncooked/cooked by steaming/boiling water)','Guisantes congelados, aunque estén cocidos en agua/vapor',10,'07','0710','071021');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07102200','Feijões congelados, não cozidos ou cozidos em água/vapor','Beans (froz/uncooked/cooked by steaming/boiling water)','Judías congeladas, aunque estén cocidas en agua/vapor',10,'07','0710','071022');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07102900','Outros legumes de vagem, cong.n/cozidos/cozidos água/etc','Oth.legum/veget(fro/uncook/cooked b/steam/boil.wat, etc)','Los dem.legumbres de vain.cong.aunq.est.coc.en agua, etc',10,'07','0710','071029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07103000','Espinafres congelad.n/cozidos ou cozidos em água/vapor','Spinach (froz/uncooked/cooked by steam/boiling water)','Espinacas congeladas, aunque estén cocidas en agua/vapor',10,'07','0710','071030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07104000','Milho doce congelado, n/cozido ou cozido em água/vapor','Sweet corn(froz/uncooked/cooked by steam/boiling water)','Maíz dulce congelado, aunque esté cocido en agua/vapor',10,'07','0710','071040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07108000','Outros prods.hortícolas cong.n/cozidos/cozidos água/etc','Oth.vegetab(froz/uncook/cooked by steam/boil.water, etc)','Las dem.hortalizas cong.aunque estén coc.en agua/vapor',10,'07','0710','071080');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07109000','Misturas de prods.horts.cong.n/cozidos/cozidos água/etc','Mix/vegetables(fro/uncook/cooked b/steam/boil.wat., etc)','Mezclas de hortalizas cong.aunque estén coc.en agua, etc',10,'07','0710','071090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07111000','Cebolas conservadas em água salgada, sulfurada, etc.','Onions preserved in brine, in sulphur water, etc.','Cebollas conservadas en agua salada,  sulfurosa,  etc',10,'07','0711','071110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07112010','Azeitonas conservadas com água salgada','Olives provisionally preserved in brine','Aceitunas conservadas con agua salada',10,'07','0711','071120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07112020','Azeitonas conserv.com água sulfurada/adic.de outs subst','Olives preserved in sulphur/added of other substances','Aceitunas conserv.c/agua sulforosa/adic.de dem.sustanc.',10,'07','0711','071120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07112090','Outras azeitonas conservadas transitoriamente','Other olives provisionally preserved','Las dem.aceitunas conservadas provisionalmente',10,'07','0711','071120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07113010','Alcaparras conservadas em água salgada, sulfurada, etc.','Capers provision.preserv.in brine, in sulphur water, etc.','Alcaparras conservadas en agua salada,  sulforosa,  etc',10,'07','0711','071130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07113090','Outras alcaparras conservadas transitoriamente','Other capers provisionally preserved','Las dem.alcaparras conservadas provisionalmente',10,'07','0711','071130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07114000','Pepinos e pepininhos conservados em água salgada, etc.','Cucumbers/gherkins provision.preser in brine, etc','Pepinos y pepinillos conservados en agua salada,  etc',10,'07','0711','071140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07115100','Cogumelos "agaricus" conserv.água salg.etc.','Mushrooms(agaricus)provisionally preserved in brine, etc','Hongos "agaricus" conservados en agua salada,  etc',10,'07','0711','071151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07115900','Outs.cogumelos e trufas conserv.água salg.etc','Oth.mushrooms/truffles provis./preserved in brine, etc','Los dem.hongos y trufas conservados en agua salada,  etc',10,'07','0711','071159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07119000','Outros prods.horts/misturas, conserv.em água salgada, etc','Other veget./mixt.veget., provis/preserved in brine, etc.','Las dem.hortalizas, mezclas, conserv.en agua salada, etc',10,'07','0711','071190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07122000','Cebolas secas, incl.pedaços, fatias, po, etc.s/qq.out.prep.','Dried onions, incl.pieces, slices, powder, etc.but n/fut.pr','Cebollas secas, inc.trozos, rodajas, polvo, pero s/otr.prep',10,'07','0712','071220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07123000','Cogumelos e trufas, secos, incl.pedaços, etc.s/qq.out.prep','Dried mushrooms/truffles, incl.cut, etc.but n/fut.prep.','Hongos y trufas, secos, incl.trozos, etc, s/otra prepar.',10,'07','0712','071230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07123100','Cogumelos "agaricus" secos, mesmo cortad.etc.','Dried mushrooms(agaricus), sliced, cut, etc.','Hongos "agaricus" secos, incl.cortados,  etc',10,'07','0712','071231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07123200','Orelhas-de-judas secos, mesmo cortados, etc.','Dried wood ears, cut, sliced, etc.','Orejas de judas secos, incluso cortados,  etc',10,'07','0712','071232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07123300','Tremelas secos, mesmo cortados, etc.','Dried jelly fungi, cut, sliced, etc.','Hongos gelatinosos secos, incluso cortados, etc',10,'07','0712','071233');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07123900','Outros cogumelos e trufas, secos, mesmo cortados, etc.','Other dried mushrooms/truffles, cut, liced, etc.','Los dem.hongos y trufas, secos, incluso cortados, etc',10,'07','0712','071239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07129010','Alho comum em pó sem qualquer outro preparo','Powdered garlic but not further prepared','Ajo común en polvo pero sin otra preparación',10,'07','0712','071290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07129090','Outs.prods.horts/misturas, secos, incl.pedaços, fatias, etc','Oth.dried vegetables/mixtures veget.incl.piec, slic., etc','Las dem.hortalizas/mezclas, secas, inc.trozos, rodajas, etc',10,'07','0712','071290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07131010','Ervilhas (pisum sativum), secas, em grãos, para semeadura','Dried peas (pisum sativum) in grain, for sowing','Guisantes (pisum sativum), secos, desvainadas, p/siembra',10,'07','0713','071310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07131090','Outras ervilhas (pisum sativum), secas, em grãos','Other dried peas (pisum sativum) in grain, for sowing','Los dem.guisantes (pisum sativum), secos, desvainadas',10,'07','0713','071310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07132010','Grão-de-bico, seco, para semeadura','Dried chickpeas(garbanzos), for sowing','Garbanzo, seco, para siembra',10,'07','0713','071320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07132090','Outros grãos-de-bico, secos','Other dried chickpeas','Los demás garbanzos, secos',10,'07','0713','071320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133110','Feijões (vigna mungo ou radiata) secos, para semeadura','Dried beans (vigna mungo), for sowing','Judías (vigna mungo o radiata) secos, para siembra',10,'07','0713','071331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133190','Outros feijões (vigna mungo ou radiata), secos, em grãos','Other dried beans (vigna mungo), in grain','Las dem.judías (vigna mungo o radiata), secos, desvainad.',10,'07','0713','071331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133210','Feijão adzuki, seco, para semeadura','Dried small red(adzuk)beans(phas./vigna angul.)forsowing','Judía adzuki,  seca,  para siembra',10,'07','0713','071332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133290','Outros feijões adzuki, secos, em grãos','Other dried beans (adzuki), in grain','Las demás judías adzuki, secas, desvainadas',10,'07','0713','071332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133311','Feijão comum, preto, seco, para semeadura','Dried kidney beans(phas. vulgaris)incl.black/for sowing','Judía común, negra, seca, para siembra',10,'07','0713','071333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133319','Outros feijões comuns, pretos, secos, em grãos','Dried kidney beans (phas. vulgaris), incl.black/in grain','Las dem.judías comunes, negras, secas, desvainadas',10,'07','0713','071333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133321','Feijão comum, branco, seco, para semeadura','Dried kidney beans, incl.white beans for sowing','Judía común, blanca, seca, para siembra',10,'07','0713','071333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133329','Outros feijões comuns, brancos, secos, em grãos','Dried kidney beans, incl.white beans in grain','Las dem.judías comunes, blancas, secas, desvainadas',10,'07','0713','071333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133391','Outros feijões comuns, secos, para semeadura','Dried other kidney beans, for sowing','Las dem.judías comunes, secas, para siembra',10,'07','0713','071333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133399','Outros feijões comuns, secos, em grãos','Other dried kidney beans, in grain','Las dem.judías comunes, secas, desvainadas',10,'07','0713','071333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133410','Feijão-bambara (vigna subterranea), para semeadura','Bambara bean (vigna subterranea), for sowing','Frijole-bambara (vigna subterranea), para siembra',10,'07','0713','071334');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133490','Feijão-bambara, exceto para semeadura','Bambara bean (vigna subterranea), except for sowing','Frijole-bambara(vigna subterranea),excepto para siembra',10,'07','0713','071334');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133510','Feijão-fradinho (vigna unguiculata), para semeadura','Fradinho bean (vigna unguiculata), for sowing','Frijole-fradinho (vigna unguiculata), para siembra',10,'07','0713','071335');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133590','Feijão-fradinho, exceto para semeadura','Fradinho bean (vigna unguiculata), except for sowing','Frijole-fradinho (vigna unguiculata), exc. para siembra',10,'07','0713','071335');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133910','Outros feijões (vigna ou phaseolus), secos, p/semeadura','Other dried beans(vigna/phaseolus), forsowing','Las dem.judías (vigna o phaseolus),  secas,  para siembra',10,'07','0713','071339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07133990','Outros feijões (vigna ou phaseolus), secos, em grãos','Other dried beans(vigna/phaseolus), in grain','Las dem.judías (vigna o phaseolus), secas, desvainadas',10,'07','0713','071339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07134010','Lentilhas secas, para semeadura','Dried lentils, for sowing','Lentejas secas, para siembra',10,'07','0713','071340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07134090','Outras lentilhas secas, em grãos','Other dried lentils, in grain','Las demás lentejas secas, desvainadas',10,'07','0713','071340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07135010','Favas e fava forrageira, secas, para semeadura','Dried broad beans/horse beans, for sowing','Habas, haba caballar y haba menor, secas, para siembra',10,'07','0713','071350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07135090','Outras favas e fava forrageira, secas, em grãos','Other dried broad beans/horse beans, in grain','Las demás habas, haba caballar y haba menor, secas, desvainadas',10,'07','0713','071350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07136010','Feijão-guando (cajanus cajan), para semeadura','Guando bean (cajanus cajan), for sowing','Frijole-guando (cajanus cajan), para siembra',10,'07','0713','071360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07136090','Feijão-guando (cajanus cajan), exceto para semeadura','Guando bean (cajanus cajan), except for sowing','Frijole-guando (cajanus cajan), excepto para siembra',10,'07','0713','071360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07139010','Outros legumes de vagem, secos, em grãos, para semeadura','Other dried leguminous vegetables, in grain, for sowing','Otros legumbres de vaina, secos, desvainados.para siembra',10,'07','0713','071390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07139090','Outros legumes de vagem, secos, em grãos','Other dried leguminous vegetables, in grain','Los dem. legumbres de vaina, secos, desvain.',10,'07','0713','071390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07141000','Raízes de mandioca, frescas, refrigeradas, congel.ou secas','Fresh/chilled/frozen/dried roots of manioc(cassava)','Raíces de mandioca, frescas, refriger.congeladas o secas',10,'07','0714','071410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07142000','Batatas-doces, frescas, refrigeradas, congeladas ou secas','Fresh/chilled/frozen/dried sweet potatoes','Batatas(boniato, camotes), frescas, refrig.congel.o secas',10,'07','0714','071420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07143000','Inhames (dioscorea spp.)','Yams (dioscorea spp.)','Ñame (dioscorea spp.)',10,'07','0714','071430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07144000','Taros (colocasia spp.)','Taros (colocasia spp.)','Taros (colocasia spp.)',10,'07','0714','071440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07145000','Mangaritos (xanthosomo spp.)','Mangaritos (xanthosomo spp.)','Mangaritos (xanthosomo spp.)',10,'07','0714','071450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('07149000','Outs.raízes, tubérculos, frescos, etc.e medula de sagueiro','Oth.fresh/chilled/frozen/dried roots/tubers, sago pith','Las dem.raíces, tubérculos, frescos, etc y médula de sagú',10,'07','0714','071490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08011110','Cocos secos, sem casca, mesmo ralados','Dried coconuts, shelled, whether or not shredded','Cocos secos, sin cáscara, incluso rallados',10,'08','0801','080111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08011190','Outros cocos secos','Other dried coconuts','Los demás cocos secos',10,'08','0801','080111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08011200','Cocos na casca interna (endocarpo)','Coconuts in the inner bark (endocarp)','Cocos en el interior de la corteza (endocarpo)',10,'08','0801','080112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08011900','Cocos frescos','Other fresh coconuts','Cocos frescos',10,'08','0801','080119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08012100','Castanha-do-pará, fresca ou seca, com casca','Fresh/dried, brazil nuts, in shell','Nuez de brasil fresca o seca, con cáscara',10,'08','0801','080121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08012200','Castanha-do-pará, fresca ou seca, sem casca','Fresh/dried, brazil nuts, shelled','Nuez de brasil, fresca o seca, sin cáscara',10,'08','0801','080122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08013100','Castanha de caju, fresca ou seca, com casca','Fresh/dried, cashew nuts, shelled','Nuez del marañón, fresca o seca, con cáscara',10,'08','0801','080131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08013200','Castanha de caju, fresca ou seca, sem casca','Fresh/dried, cashew nuts, shelled','Nuez de marañón, fresca o seca, sin cáscara',10,'08','0801','080132');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08021100','Amêndoas frescas ou secas, com casca','Fresh/dried almonds, shelled','Almendras frescas o secas, con cáscara',10,'08','0802','080211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08021200','Amêndoas frescas ou secas, sem casca','Fresh/dried almonds, shelled','Almendras frescas o secas, sin cáscara',10,'08','0802','080212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08022100','Avelãs (corylus spp) frescas ou secas, com casca','Fresh/dried hazelnuts/filberts(corylus spp.), in shell','Avellanas (corylus spp) frescas o secas, con cáscara',10,'08','0802','080221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08022200','Avelãs (corylus spp) frescas ou secas, sem casca','Fresh/dried hazelnuts/filberts (corylus), shelled','Avellanas (coryls spp) frescas o secas, sin cáscara',10,'08','0802','080222');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08023100','Nozes frescas ou secas, com casca','Fresh/chilled nuts, shelled','Nueces de nogal frescas o secas, con cáscara',10,'08','0802','080231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08023200','Nozes frescas ou secas, sem casca','Fresh/chilled nuts, shelled','Nueces de nogal frescas o secas, sin cáscara',10,'08','0802','080232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08024000','Castanhas (castanea spp) frescas ou secas','Dried/fresh chestnuts (castanea spp.)','Castañas (castanea spp) frescas o secas',10,'08','0802','080240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08024100','Castanhas (castaneas spp.) com casca, frescas ou secas','Chestnuts (castaneas spp.), in shell, fresh or dried','Castañas (castaneas spp.), con cáscara, frescas o secas',10,'08','0802','080241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08024200','Castanhas (castaneas spp.), sem casca, frescas ou secas','Chestnuts (castaneas spp.),not in shell, fresh or dried','Castañas (castaneas spp.), sin cáscara, frescas o secas',10,'08','0802','080242');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08025000','Pistácios frescos ou secos','Fresh/dried pistachios','Pistachos frescos o secos',10,'08','0802','080250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08025100','Pistácios, com casca, frescos ou secos','Pistachios, in shell, fresh or dried','Pistachos, con cáscara, frescos o secos',10,'08','0802','080251');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08025200','Pistácios, sem casca, frescos ou secos','Pistachios, not in shell, fresh or dried','Pistachos, sin cáscara, frescos o secos',10,'08','0802','080252');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08026000','Nozes de macadâmia mesmo sem casca, frescos/secos','Macadamia nuts, even peeled, fresh/dried','Macadamia, mismo sin cáscara, frescas/secas',10,'08','0802','080260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08026100','Nozes de macadâmia, com casca, frescas ou secas','Macadamia nuts, in shell, fresh or dried','Nueces de macadamia, con cáscara, frescas o secas',10,'08','0802','080261');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08026200','Nozes de macadâmia, sem casca, frescas ou secas','Macadamia nuts, not in shell, fresh or dried','Nueces de macadamia, sin cáscara, frescas o secas',10,'08','0802','080262');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08027000','Nozes de cola (cola spp.), frescas ou secas','Kola nuts (cola spp.), fresh or dried','Nueces de cola (cola spp.), frescas o secas',10,'08','0802','080270');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08028000','Nozes de areca (nozes de betele), frescas ou secas','Areca (betel nuts), fresh or dried','Areca (nueces de betel), frescos o secos',10,'08','0802','080280');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08029000','Outras frutas de casca rija, frescas ou secas','Other fresh/dried fruit in shell','Los dem.frutos de cáscara comestibles,  frescas o secas',10,'08','0802','080290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08030000','Bananas frescas ou secas','Fresh or dried bananas','Plátanos frescos o secos',10,'08','0803','080300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08031000','Bananas-da-terra, frescas ou secas','Bananas-of-the-earth, fresh or dried','Plátanos de la tierra, frescos o secos',10,'08','0803','080310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08039000','Bananas frescas ou secas, exceto bananas-da-terra','Bananas fresh or dried, except bananas-of-the-earth','Plátanos frescos o secos, excepto plátano de la tie.',10,'08','0803','080390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08041010','Tâmaras frescas','Fresh dates','Dátiles frescos',10,'08','0804','080410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08041020','Tâmaras secas','Dried dates','Dátiles secos',10,'08','0804','080410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08042010','Figos frescos','Fresh figs','Higos frescos',10,'08','0804','080420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08042020','Figos secos','Dried figs','Higos secos',10,'08','0804','080420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08043000','Abacaxis frescos ou secos','Fresh/dried pineapples','Piñas frescas o secas',10,'08','0804','080430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08044000','Abacates frescos ou secos','Fresh/dried avocados','Aguacates frescos o secos',10,'08','0804','080440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08045000','Goiabas, mangas e mangostões, frescos ou secos','Fresh/dried guavas/mangoes/mangosteens','Guayabas, mangos, mangostanes, frescos o secos',10,'08','0804','080450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08045010','Goiabas frescas ou secas','Fresh/dried guavas','Guayabas frescas o secas',10,'08','0804','080450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08045020','Mangas frescas ou secas','Fresh/dried mangoes','Mangos frescos o secos',10,'08','0804','080450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08045030','Mangostões frescos ou secos','Fresh/dried mangosteens','Mangostanes frescos o secos',10,'08','0804','080450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08051000','Laranjas frescas ou secas','Fresh/dried oranges','Naranjas frescas o secas',10,'08','0805','080510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08052000','Tangerinas, mandarinas, satsumas, etc.frescos ou secos','Fres/dried mandarins(incl.tanger./satsumas)clement.etc','Tangerinas,  mandarinas,  satsumas,  etc,  frescos o secos',10,'08','0805','080520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08053000','Limões e limas, frescos ou secos','Fresh or dried lemons and sweet oranges','Limones y limas, frescos o secos',10,'08','0805','080530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08054000','Pomelos ("grapefruit") frescos ou secos','Fresh/dried grapefruit','Pomelos ("grapefruit") frescos o secos',10,'08','0805','080540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08055000','Limões e limas, frescos ou secos','Fresh/dried lemons and sweet oranges','Limones y limas,  frescos o secos',10,'08','0805','080550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08059000','Outros cítricos frescos ou secos','Other fresh/dried citrus fruit','Los demás agrios frescos o secos',10,'08','0805','080590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08061000','Uvas frescas','Fresh grapes','Uvas frescas',10,'08','0806','080610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08062000','Uvas secas','Dry grapes','Uvas secas',10,'08','0806','080620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08071100','Melancias frescas','Fresh watermelons','Sandías frescas',10,'08','0807','080711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08071900','Melões frescos','Fresh melons','Melones frescos',10,'08','0807','080719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08072000','Mamões (papaias) frescos','Fresh papaws (papayas)','Papayas frescas',10,'08','0807','080720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08081000','Maçãs frescas','Fresh apples','Manzanas frescas',10,'08','0808','080810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08082010','Pêras frescas','Fresh pears','Peras frescas',10,'08','0808','080820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08082020','Marmelos frescos','Fresh quinces','Membrillos frescos',10,'08','0808','080820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08083000','Pêras, frescas','Pears, fresh','Peras, frescas',10,'08','0808','080830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08084000','Marmelos, frescos','Quinces, fresh','Membrillos, frescos',10,'08','0808','080840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08091000','Damascos frescos','Fresh apricots','Albaricoques frescos',10,'08','0809','080910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08092000','Cerejas frescas','Fresh cherries','Cerezas frescas',10,'08','0809','080920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08092100','Cerejas-ácidas (Prunus cerasus), frescas','Acid cherries (Prunus cerasus), fresh','Cerezas ácidas (Prunus cerasus), frescas',10,'08','0809','080921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08092900','Outras cerejas, frescas','Other cherries, fresh','Otras cerezas, frescas',10,'08','0809','080929');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08093010','Pêssegos frescos','Fresh peaches','Duraznos frescos',10,'08','0809','080930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08093020','Brugnons e nectarinas, frescos','Fresh nectarines','Griñones y nectarinas, frescos',10,'08','0809','080930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08094000','Ameixas e abrunhos, frescos','Fresh plums and sloes','Ciruelas y endrinas, frescas',10,'08','0809','080940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08101000','Morangos frescos','Fresh strawberries','Fresas frescas',10,'08','0810','081010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08102000','Framboesas, amoras e amoras-framboesas, frescas','Fresh raspberries, blackberries, mulberries and longanb.','Frambuesas, zarzamoras, moras y moras-frambuesa, frescas',10,'08','0810','081020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08103000','Groselhas frescas, inclusive o "cassis"','Fresh currant, including the "cassis"','Grosellas frescas, incluido el casis',10,'08','0810','081030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08104000','Airelas, mirtilos e outs.frutas genero vaccinium, frescos','Fresh cranberries and oth.fruits of the genus vaccinium','Arándanos rojos, mirtilos y dem.frut.gén.vaccinium, fresc',10,'08','0810','081040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08105000','Quivis "kiwis", frescos','Fresh kiwifruit','Kiwis, frescos',10,'08','0810','081050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08106000','Duriões frescos','Fresh durians','Duriones frescos',10,'08','0810','081060');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08107000','Caquis (diospiros), frescos','Persimmons, fresh','Caquis (los caquis), frescos',10,'08','0810','081070');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08109000','Outras frutas frescas','Other fresh fruits','Los demás frutos frescos',10,'08','0810','081090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08111000','Morangos congelados, nao cozidos/cozidos em água/vapor','Strawberries froz/uncook/cooked b/steaming/boil.in wat.','Fresas congeladas, sin cocer/cocidos en agua/vapor',10,'08','0811','081110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08112000','Framboesas, amoras, groselhas, congeladas, cozidas ou não','Raspberries, blackberries frozen/uncooked/cooked','Frambuesas,  moras,  grosellas,  congeladas,  cocidas o no',10,'08','0811','081120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08119000','Outras frutas congelad.n/cozidas, cozidas em água/vapor','Oth.fruits froz/uncook/cooked b/steaming/boil.in wat.','Los dem.frutos congelados, s/cocer, cocidos en agua/vapor',10,'08','0811','081190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08121000','Cerejas conservadas em água salgada, sulfurada, etc.','Cherries provision.preser.in brine, in sulphur water, etc','Cerezas conservadas en agua salada,  sulforosa,  etc',10,'08','0812','081210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08122000','Morangos conservados em água salgada, sulfurada, etc.','Strawber.provision.preser.in brine, in sulphur water, etc','Fresas conservadas en agua salada, sulforosa, etc',10,'08','0812','081220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08129000','Outras frutas conservadas em água salgada, sulfurada, etc.','Oth.fruit provison.preser.in brine, in sulphur water, etc','Los dem.frutos conservados en agua salada, sulforosa, etc',10,'08','0812','081290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08131000','Damascos secos','Dried apricots','Albaricoques secos',10,'08','0813','081310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08132010','Ameixas secas, com caroço','Dried prunes, not stoned','Ciruelas secas, con hueso',10,'08','0813','081320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08132020','Ameixas secas, sem caroço','Dried prunes, stoned','Ciruelas secas, sin hueso',10,'08','0813','081320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08133000','Maçãs secas','Dried apples','Manzanas secas',10,'08','0813','081330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08134010','Pêras secas','Dried pears','Peras secas',10,'08','0813','081340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08134090','Outras frutas secas','Other dried fruits','Las demás frutas secas',10,'08','0813','081340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08135000','Misturas de frutas secas ou de frutas de casca rija','Mixtures of dried fruits or fruits with hard peel','Mezclas de frutos secos o de frutos de cáscara comestib',10,'08','0813','081350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('08140000','Cascas de cítricos, melões, melancias, frescas, secas, etc.','Peel of citrus fruit, melons, watermelons, fresh, dried, etc','Corteza de agrios, melones, sandías, frescas, secas, etc',10,'08','0814','081400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09011110','Café não torrado, não descafeinado, em grão','Coffee not roasted or decaffeinated, in grain','Café sin tostar ni descafeinar, en grano','21','09','0901','090111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09011190','Café não torrado, não descafeinado, exceto em grão','Coffee not roasted or decaffeinated, except in grain','Café sin tostar ni descafeinar, excepto en grano',10,'09','0901','090111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09011200','Café não torrado, descafeinado','Coffee not roasted or decaffeinated','Café descafeinado, sin tostar',10,'09','0901','090112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09012100','Café torrado, não descafeinado','Coffee roasted, not decaffeinated','Café tostado, sin descafeinar',10,'09','0901','090121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09012200','Café torrado, descafeinado','Roasted, decaffeinated coffee','Café tostado, descafeinado',10,'09','0901','090122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09019000','Cascas, películas de café e sucedâneos do café','Coffee husks, skins and coffee substitutes','Cáscaras, cascarillas de café y sucedáneos del café',10,'09','0901','090190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09021000','Chá verde (não fermentado), em embalagens imediatas<=3kg','Green tea (not fermented) in immediate packings<=3kg','Té verde (sin fermentar),  en envases inmediatos <= 3 kg',10,'09','0902','090210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09022000','Chá verde (não fermentado), apresentado em qq.out.forma','Other green tea (not fermented)','Té verde (sin fermentar), presentado de otra forma',10,'09','0902','090220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09023000','Chá preto (fermentado/parcialm.), embalag.imediatas<=3kg','Black tea (ferme./partly fermented), immed.packin.<=3kg','Té negro(fermentado/parcialm.), envases inmediatos<=3kg',10,'09','0902','090230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09024000','Chá preto (fermentado/parcialm.) apresent.qq.out.forma','Other black tea (fermented/partly fermented)','Té negro(fermentado/parcialm.), presentado de otra forma',10,'09','0902','090240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09030010','Mate simplesmente cancheado','Cut mate','Yerba mate canchada',10,'09','0903','090300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09030090','Outros tipos de mate','Other kinds of mate','Los demás tipos de yerba mate',10,'09','0903','090300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09041100','Pimenta "piper", seca','Dried pepper','Pimienta del género piper, seca',10,'09','0904','090411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09041200','Pimenta "piper", triturada ou em pó','Pepper of the genus piper, crushed or ground','Pimienta del género piper, triturada o en polvo',10,'09','0904','090412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09042000','Pimentões e pimentas "capsicum"/"pimenta", secos, po, etc.','Fruits of the genus capsicum/pimenta, dried/ground/etc.','Ajís y pimientas"capsicum"/"pimienta", secos, polvo, etc',10,'09','0904','090420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09042100','Pimentões e pimentas, secos, não triturados nem em pó','Pepper and green bell pepper, dried, not crushed or po.','Pimienta y morrón, secos, no triturados ni pulverizados',10,'09','0904','090421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09042200','Pimentões e pimentas, triturados ou em pó','Pepper and green bell pepper, dried, crushed or powder.','Pimienta y morrón, secos, triturados o pulverizados',10,'09','0904','090422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09050000','Baunilha','Vanilla','Vainilla',10,'09','0905','090500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09051000','Baunilha, não triturada nem em pó','Vanilla, not crushed or powdered','Vainilla, no triturados o pulverizados',10,'09','0905','090510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09052000','Baunilha, triturada ou em pó','Vanilla, crushed or powdered','Vainilla, triturados o pulverizados',10,'09','0905','090520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09061000','Canela e flores de caneleira, não trituradas nem em pó','Cinnamon and cinnamon-tree flowers(neither crushed nor in powder)','Canela y flores de canelero,  sin triturar ni pulverizar',10,'09','0906','090610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09061100','Canela e flores de caneleira, não trituradas nem em pó','Cinnamon and cinnamon-tree flowers(neither crushed nor in powder)','Canela y flores de canelero,  sin triturar ni pulverizar',10,'09','0906','090611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09061900','Outs.canela/flor canel. ñ/triturs. nem em pó','Other cinnamon and cinnamon-tree flowers(neither crushed nor in powder)','Otras canelas y flores de canelero,  sin triturar ni pulverizar',10,'09','0906','090619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09062000','Canela e flores de caneleira, trituradas ou em pó','Cinnamon and cinnamon-tree flowers crushed or ground','Canela y flores de canelero, triturados o pulverizados',10,'09','0906','090620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09070000','Cravo-da-índia (frutos, flores e pedúnculos)','Cloves (whole fruit, cloves and stems)','Clavo de india (frutos, clavillos y pedúnculos)',10,'09','0907','090700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09071000','Cravo-da-índia (frutos,flores e pedun.),n/tri,nem em po','Clavel de la india, neither crushed nor powdered','Clavel de la india, sin triturar ni pulverizar',10,'09','0907','090710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09072000','Cravo-da-índia(frutos,flores e pedun.),tritur. ou em po','Clavel de la india, crushed or powdered','Clavel de la india, triturados o pulverizados',10,'09','0907','090720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09081000','Noz-moscada','Nutmeg','Nuez moscada',10,'09','0908','090810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09081100','Noz-moscada, não triturada nem em pó','Nutmeg, neither crushed nor powdered','Nuez moscada, sin  triturar ni pulverizar',10,'09','0908','090811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09081200','Noz-moscada, triturada ou em pó','Nutmeg, crushed or powdered','Nuez moscada, trituradas o pulverizadas',10,'09','0908','090812');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09082000','Macis','Mace','Macis',10,'09','0908','090820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09082100','Macis, não triturado nem em pó','Mace, neither crushed nor powdered','Mace, no triturados ni pulverizados',10,'09','0908','090821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09082200','Macis, triturado ou em pó','Mace, crushed or powdered','Mace, triturados o pulverizados',10,'09','0908','090822');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09083000','Amomos e cardamomos','Cardamoms','Amomos y cardamomos',10,'09','0908','090830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09083100','Amomos e cardamomos, não triturado nem em pó','Amomos and cardamoms, not crushed nor powdered','Amomos y cardamomo, sin triturar ni pulverizar',10,'09','0908','090831');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09083200','Amomos e cardamomos, triturados ou em pó','Amomos and cardamoms, crushed or powdered','Amomos y cardamomo, trituraos o pulverizados',10,'09','0908','090832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09091010','Sementes de anis (anis verde)','Seeds of anise or badian','Semillas de anís (anís verde)',10,'09','0909','090910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09091020','Sementes de badiana (anis estrelado)','Seeds of badiane (star anise)','Semillas de badiana (anís estrellado)',10,'09','0909','090910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09092000','Sementes de coentro','Seeds of coriander','Semillas de cilantro',10,'09','0909','090920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09092100','Sementes de coentro, não trituradas nem em pó','Coriander seeds, neither crushed nor powdered','Semillas de cilantro, no trituradas ni pulverizadas',10,'09','0909','090921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09092200','Sementes de coentro, trituradas ou em pó','Coriander seeds, crushed or powdered','Semillas de cilantro, trituradas o pulverizadas',10,'09','0909','090922');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09093000','Sementes de cominho','Seeds of cumin','Semillas de comino',10,'09','0909','090930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09093100','Sementes de cominho, não trituradas nem em pó','Cumin seeds, neither crushed nor powdered','Semillas de comino, no trituradas ni pulverizadas',10,'09','0909','090931');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09093200','Sementes de cominho, trituradas ou em pó','Cumin seeds, crushed or powdered','Semillas de comino, trituradas o pulverizadas',10,'09','0909','090932');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09094000','Sementes de alcaravia','Seeds of caraway','Semillas de alcaravea',10,'09','0909','090940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09095000','Sementes de funcho e bagas de zimbro','Seeds of fennel and juniper berries','Semillas de hinojo y bayas de enebro',10,'09','0909','090950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09096110','Sementes de anis (erva-doce), não trituradas nem em pó','Seeds of anise, not crushed nor powdered','Semillas de anís, no trituradas ni pulverizadas',10,'09','0909','090961');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09096120','Sementes de badiana(anis-estrelado),nao trit. nem em po','Badian seeds, not crushed nor powdered','Semillas de anís estrellado, no trituradas o pulveriza.',10,'09','0909','090961');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09096190','Outras sementes, não trituradas nem em pó','Other seeds, neither crushed nor powdered','Las demás semillas, no trituradas o pulverizadas',10,'09','0909','090961');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09096210','Sementes de anis (erva-doce), trituradas ou em pó','Aniseed, crushed or powdered','Semillas de anís, trituradas o pulverizadas',10,'09','0909','090962');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09096220','Sementes de badiana(anis-estrelado),trituradas ou em po','Badian seeds, crushed or powdered','Semillas de anís estrellado, trituradas o pulverizadas',10,'09','0909','090962');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09096290','Outras sementes, trituradas ou em pó','Other seeds, crushed or powdered','Las demás semillas, trituradas o pulverizadas',10,'09','0909','090962');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09101000','Gengibre','Ginger','Jengibre',10,'09','0910','091010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09101100','Gengibre, não triturado nem em pó','Ginger, neither crushed nor powdered','Jengibre, sin triturar ni pulverizar',10,'09','0910','091011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09101200','Gengibre, triturado ou em pó','Ginger, crushed or powdered','Jengibre, triturarado o pulverizado',10,'09','0910','091012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09102000','Açafrão','Saffron','Azafrán',10,'09','0910','091020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09103000','Açafrão-da-terra (curcuma)','Turmeric (curcuma)','Cúrcuma',10,'09','0910','091030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09104000','Tomilho e louro','Thyme and bay leaves','Tomillo y hoja de laurel',10,'09','0910','091040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09105000','Caril','Curry','Curry',10,'09','0910','091050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09109100','Misturas de especiarias','Mixtures of spices','Mezclas de especias',10,'09','0910','091091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('09109900','Outras especiarias','Other spices','Las demás especias',10,'09','0910','091099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10011010','Trigo duro para semeadura','Durum wheat for sowing','Trigo duro para siembra',10,'10','1001','100110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10011090','Trigo duro, exceto para semeadura','Durum wheat, except for sowing','Trigo duro, excepto para siembra',10,'10','1001','100110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10011100','Trigo duro, para semeadura','Durum wheat, for sowing','Trigo duro, para siembra',10,'10','1001','100111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10011900','Trigo duro, exceto para semeadura','Durum wheat, except for sowing','Trigo duro, excepto para siembra',10,'10','1001','100119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10019010','Trigo (exceto trigo duro) para semeadura','Wheat (except durum wheat), for sowing','Trigo (excepto trigo duro) para siembra',10,'10','1001','100190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10019090','Trigo (exceto trigo duro ou para semeadura), e trigo com centeio','Wheat(exc.durum wheat orto sow)and wheat with rye','Trigo (excepto trigo duro o para siembra), y morcajo',10,'10','1001','100190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10019100','Outr. trigos e misturas de trigo c/ centeio,p/semeadura','Other wheat and mixed wheat and rye, for sowing','Otros trigos y el trigo mixto con centeno,p/ la siembra',10,'10','1001','100191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10019900','Out.trigos e misturas de trigo c/centeio, exc.p/ semead','Other mixtures of wheat and rye, except for sowing','Ot. trigos y trigo mixto con centeno, ex.p/ la siembra',10,'10','1001','100199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10020010','Centeio para semeadura','Rye for sowing','Centeno para siembra',10,'10','1002','100200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10020090','Centeio, exceto para semeadura','Rye, except for sowing','Centeno, excepto para siembra',10,'10','1002','100200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10021000','Centeio, para semeadura','Rye for sowing','Centeno, para siembra',10,'10','1002','100210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10029000','Centeio, exceto para semeadura','Rye, except for sowing','Centeno, excepto para siembra',10,'10','1002','100290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10030010','Cevada para semeadura','Barley for sowing','Cebada para siembra',10,'10','1003','100300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10030091','Cevada cervejeira','Barley brewer','Cebada para cerveza',10,'10','1003','100300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10030098','Cevada em grão, exceto cervejeira ou para semeadura','Barley in grain, except brewer or for sowing','Cebada en grano, excepto para cerveza o para siembra',10,'10','1003','100300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10030099','Outras espécies de cevada, exceto em grão','Other barley species, except in grain','Las demás especies de cebada, excepto en granos',10,'10','1003','100300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10031000','Cevada, para semeadura','Barley for sowing','Cebada, para siembra',10,'10','1003','100310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10039010','Cevada cervejeira','Malting barley','Cebada cervecera',10,'10','1003','100390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10039080','Outras cevadas, em grão','Other barley, grains','Otras cebadas, en grano',10,'10','1003','100390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10039090','Outras cevadas, exceto em grão','Other barley, except in grains','Otras cebadas, excepto en el grano',10,'10','1003','100390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10040010','Aveia para semeadura','Oat, for sowing','Avena para siembra',10,'10','1004','100400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10040090','Aveia, exceto para semeadura','Oat, except for sowing','Avena, excepto para siembra',10,'10','1004','100400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10041000','Aveia, para semeadura','Oats, for sowing','Avena, para siembra',10,'10','1004','100410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10049000','Aveia, exceto para semeadura','Oats, except for sowing','Avena, excepto para siembra',10,'10','1004','100490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10051000','Milho para semeadura','Corn seed','Maíz para siembra',10,'10','1005','100510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10059010','Milho em grão, exceto para semeadura','Maize (corn) in grain, except for sowing','Maíz en grano, excepto para siembra',10,'10','1005','100590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10059090','Milho, exceto em grão','Maize (corn), except in grain','Maíz, excepto en grano',10,'10','1005','100590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10061010','Arroz ("paddy") com casca, para semeadura','Rice in the husk (paddy), for sowing','Arroz ("paddy") con cáscara, para siembra',10,'10','1006','100610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10061091','Arroz ("paddy") com casca, parboilizado (estufado)','Rice in the husk (paddy), parboiled (stewed)','Arroz ("paddy") con cáscara, parboilizado (estufado)',10,'10','1006','100610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10061092','Arroz ("paddy") com casca, não parboilizado (n/estufado)','Rice in the husk (paddy), parboiled (n/stewed)','Arroz ("paddy") con cáscara, no parboilizado',10,'10','1006','100610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10062010','Arroz ("cargo" ou castanho), descascado, parboilizado','Husked (brown) shelled, parboiled','Arroz ("cargo" o castaño),  descascarillado, parboilizado',10,'10','1006','100620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10062020','Arroz ("cargo" ou castanho), descascado, não parboilizado','Husked (brown) shelled, not parboiled','Arroz("cargo" o castaño), descascarillado, no parboiliz.',10,'10','1006','100620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10063011','Arroz semibranqueado, etc.parboilizado, polido ou brunido','Semi-milled/wholly milled rice, etc.parboiled/polished','Arroz semiblaqueado, etc, parbolizado, pulido o glaseado',10,'10','1006','100630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10063019','Outros tipos de arroz semibranqueado, etc.parboilizado','Ot.kind of semi-milled/wholly milled rice, etc.parboiled','Otros tipos de arroz semiblanqueado,  etc,  parbolizado',10,'10','1006','100630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10063021','Arroz semibranqueado, etc.n/parboilizado, polido, brunido','Semi-mil/wholly milled rice, etc.not parboiled, polished','Arroz semiblaqueado, etc, parbolizado, pulido o glaseado',10,'10','1006','100630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10063029','Outros tipos de arroz semibranqueado, etc.n/parboilizado','Ot.kind of semi-mil/wholly milled rice, etc.not parboiled','Los dem.tipos de arroz semiblanqueado, etc, n/parbolizado',10,'10','1006','100630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10064000','Arroz quebrado (trinca de arroz)','Broken rice','Arroz partido',10,'10','1006','100640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10070010','Sorgo em grão para semeadura','Grain sorghum, for sowing','Sorgo de grano para siembra',10,'10','1007','100700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10070090','Sorgo em grão, exceto para semeadura','Grain sorghum, except for sowing','Sorgo de grano, excepto para siembra',10,'10','1007','100700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10071000','Sorgo de grao, para semeadura','Grain sorghum, for sowing','Sorgo grano, para siembra',10,'10','1007','100710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10079000','Sorgo de grao, exceto para semeadura','Grain sorghum, except for sowing','Sorgo grano, excepto para siembra',10,'10','1007','100790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10081010','Trigo mourisco para semeadura','Buckwheat for sowing','Alforfón para siembra',10,'10','1008','100810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10081090','Trigo mourisco, exceto para semeadura','Buckwheat, except for sowing','Alforfón, excepto para siembra',10,'10','1008','100810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10082010','Painço para semeadura','Millet for sowing','Mijo para siembra',10,'10','1008','100820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10082090','Painço, exceto para semeadura','Millet, except for sowing','Mijo, excepto para siembra',10,'10','1008','100820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10082100','Painço, para semeadura','Millet, for sowing','Mijo, para siembra',10,'10','1008','100821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10082900','Painço, exceto para semeadura','Millet, except for sowing','Mijo, excepto para siembra',10,'10','1008','100829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10083010','Alpiste para semeadura','Canary seed','Alpiste para siembra',10,'10','1008','100830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10083090','Alpiste, exceto para semeadura','Canary seed, except for sowing','Alpiste, excepto para siembra',10,'10','1008','100830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10084010','Milha (digitaria spp.), para semeadura','Mile (digitaria spp.), for sowing','Mile (digitaria spp.), para siembra',10,'10','1008','100840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10084090','Milha (digitaria spp.), exceto para semeadura','Mile (digitaria spp.), except for sowing','Mile (digitaria spp.), excepto para siembra',10,'10','1008','100840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10085010','Quinoa (chenopodium quinoa), para semeadura','Quinoa, for sowing','Quinua (chenopodium quinoa), para siembra',10,'10','1008','100850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10085090','Quinoa (chenopodium quinoa), exceto para semeadura','Quinoa, except for sowing','Quinua (chenopodium quinoa), excepto para siembra',10,'10','1008','100850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10086010','Triticale, para semeadura','Triticale, for sowing','Triticale, para siembra',10,'10','1008','100860');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10086090','Triticale, exceto para semeadura','Triticale, except for sowing','Triticale, excepto para siembra',10,'10','1008','100860');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10089010','Outros cereais para semeadura','Other cereals for sowing','Los demás cereales para siembra',10,'10','1008','100890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('10089090','Outros cereais, exceto para semeadura','Other cereals, except for sowing','Los demás cereales, excepto para siembra',10,'10','1008','100890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11010010','Farinha de trigo','Wheat flour','Harina de trigo',10,'11','1101','110100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11010020','Farinha de mistura de trigo com centeio','Flour mixture of wheat and rye','Harina de morcajo',10,'11','1101','110100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11021000','Farinha de centeio','Rye flour','Harina de centeno',10,'11','1102','110210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11022000','Farinha de milho','Maize (corn) flour','Harina de maíz',10,'11','1102','110220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11023000','Farinha de arroz','Rice flour','Harina de arroz',10,'11','1102','110230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11029000','Farinha de outros cereais','Flour of other cereals','Harina de demás cereales',10,'11','1102','110290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11031100','Grumos e sêmolas, de trigo','Groats and meal of wheat','Grañones y sémolas, de trigo',10,'11','1103','110311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11031200','Grumos e sêmolas, de aveia','Oats groats and meal','Grañones y sémolas, de avena',10,'11','1103','110312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11031300','Grumos e sêmolas, de milho','Maize groats and meal','Grañones y sémolas, de maíz',10,'11','1103','110313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11031400','Grumos e sêmolas, de arroz','Rice groats and meal','Grañones y sémolas, de arroz',10,'11','1103','110314');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11031900','Grumos e sêmolas, de outros cereais','Groats and meal of other cereals','Grañones y sémolas, de demás cereales',10,'11','1103','110319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11032000','Pellets de cereais','Pellets of cereals','Pellets de cereales',10,'11','1103','110320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11032100','Pellets de trigo','Wheat pellets','Pellets de trigo',10,'11','1103','110321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11032900','Pellets de outros cereais','Other cereals pellets','Pellets de demás cereales',10,'11','1103','110329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11041100','Grãos de cevada, esmagados ou em flocos','Barley grains, rolled or flaked','Granos de cebada, aplastados o en copos',10,'11','1104','110411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11041200','Grãos de aveia, esmagados ou em flocos','Grains of oats, rolled or flaked','Granos de avena, aplastados o en copos',10,'11','1104','110412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11041900','Grãos de outros cereais, esmagados ou em flocos','Grains of other cereals, rolled or flaked','Granos de dem.cereales, aplastados o en copos',10,'11','1104','110419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11042100','Grãos de cevada, descascados, em perolas, cortados, etc.','Barley grain, peeled, pearled, cut, etc','Granos de cebada, descascarillados, perlados, cortados, etc',10,'11','1104','110421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11042200','Grãos de aveia, descascados, em pérolas, cortados, etc.','Grains of oats, shelled, in pearls, cut, etc.','Granos de avena, descascarillados, perlados, cortados, etc',10,'11','1104','110422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11042300','Grãos de milho, descascados, em pérolas, cortados, etc.','Grains of corn, shelled, in pearls, cut, etc.','Granos de maíz, descascarillados, perlados, cortados, etc',10,'11','1104','110423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11042900','Grãos de outros cereais, descascados, em pérolas, etc.','Grains of other cereals, shelled, in pearls, cut, etc.','Granos de dem.cereales, descascarillados, perlados, etc',10,'11','1104','110429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11043000','Germes de cereais, inteiros, esmagados, em flocos, moidos','Germs of cereals, whole, rolled,  flaked or ground','Germen de cereales, entero, aplastado, en copos, molido',10,'11','1104','110430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11051000','Farinha, semola e pó, de batata','Flour, meal and powder of potato','Harina, sémola y polvo, de patata',10,'11','1105','110510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11052000','Flocos, grânulos e "pellets", de batata','Flakes, granules and pellets of potato','Copos, gránulos y "pellets", de patata',10,'11','1105','110520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11061000','Farinhas, sêmolas e pós, dos legumes de vagem, secos','Flour, meal and powder of dried leguminous vegetables','Harinas, sémolas y polvos, de los legumbres de vaina, sec.',10,'11','1106','110610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11062000','Farinhas, sêmolas e pós, de sagu, de raízes e tubérculos','Flour, meal and powder of roots and tubers','Harinas, sémolas y polvos, de sagú, de raíces y tubérculos',10,'11','1106','110620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11063000','Farinhas, sêmolas e pós, de frutas, cascas de cítricos, etc','Flour, meal and powder of fruits, peels of citric, etc','Harinas, sémolas y polvos, de frut.cortezas de agrios, etc',10,'11','1106','110630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11071010','Malte não torrado, inteiro ou partido','Malt not roasted, whole or cut','Malta sin tostar, entera o partida',10,'11','1107','110710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11071020','Malte não torrado, moído ou em farinha','Malt, not roasted, ground or in flour','Malta sin tostar, molida o en harina',10,'11','1107','110710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11072010','Malte torrado, inteiro ou partido','Malt, roasted, whole or cut','Malta tostada, entera o partida',10,'11','1107','110720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11072020','Malte torrado, moído ou em farinha','Malt, roasted, ground or in flour','Malta tostada, molida o en harina',10,'11','1107','110720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11081100','Amido de trigo','Wheat starch','Almidón de trigo',10,'11','1108','110811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11081200','Amido de milho','Maize (corn) starch','Almidón de maíz',10,'11','1108','110812');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11081300','Fécula de batata','Potato starch','Fécula de patata',10,'11','1108','110813');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11081400','Fécula de mandioca','Manioc (cassava) starch','Fécula de mandioca',10,'11','1108','110814');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11081900','Outros amidos e féculas','Other starches','Los demás almidones y féculas',10,'11','1108','110819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11082000','Inulina','Inulin','Inulina',10,'11','1108','110820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('11090000','Glúten de trigo, mesmo seco','Wheat gluten, even dried','Gluten de trigo, incluso seco',10,'11','1109','110900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12010010','Soja para semeadura','Soybean for sowing','Soja para siembra',10,'12','1201','120100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12010090','Outros grãos de soja, mesmo triturados','Other soybeans, even crushed','Otros granos de soja, incluso quebrantados','21','12','1201','120100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12011000','Soja, mesmo triturada, para semeadura','Soybeans, whether or not crushed, for sowing','Soja, incluso quebrantadas, para siembra',10,'12','1201','120110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12019000','Soja, mesmo triturada, exceto para semeadura','Soybeans, whether or not crushed, except for sowing','Soja, incluso quebrantadas, excepto para siembra','21','12','1201','120190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12021000','Amendoins com casca, não torrados, nem cozidos','Ground-nuts in shell, not roasted, n/cooked','Cacahuetes con cáscara, sin tostar ni cocer',10,'12','1202','120210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12022010','Amendoins descascados, para semeadura','Shelled ground-nuts, for sowing','Cacahuetes sin cáscara, para siembra',10,'12','1202','120220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12022090','Outros grãos de amendoins, descascad.n/torrados, n/cozid.','Other ground-nuts grains, shelled, not roasted, n/cooked','Los dem.granos de cacahuetes, s/cáscara, tostar ni cocer',10,'12','1202','120220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12023000','Amendoins, não torrados nem cozidos, para semeadura','Peanuts, not roasted or cooked, for sowing','Cacahuetes sin tostar ni cocer, para siembra',10,'12','1202','120230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12024100','Amendoins com casca, não torrados, nem cozidos','Peanuts in shell, not roasted or ground','Cacahuetes con cáscara, sin tostar ni molido',10,'12','1202','120241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12024200','Amendoins descascados, mesmo triturados','Peanuts shelled, whether or not broken','Cacahuetes sin cáscara, incluso quebrantados',10,'12','1202','120242');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12030000','Copra em grãos','Copra in grains','Copra en granos',10,'12','1203','120300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12040010','Sementes de linho (linhaça) para semeadura','Linseed seeds for sowing','Semillas de lino (linaza) para siembra',10,'12','1204','120400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12040090','Outras sementes de linho (linhaça), mesmo trituradas','Other linseed seeds, whether or not broken','Las demás semillas de lino(linaza), incluso quebrantadas',10,'12','1204','120400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12050010','Sementes de nabo silvestre ou de colza, para semeadura','Rape or colza seeds, for sowng','Semillas de nabo silvestre o de colza,  para siembra',10,'12','1205','120500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12050090','Outras sementes de nabo silvestre, de colza, mesmo trituradas','Oth.rape or colza seeds, whether or not broken','Las dem.semillas de nabo silvest.de colza, inc.quebrant.',10,'12','1205','120500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12051010','Sementes de nabo silvestre, bx.teor, p/semead.','Low erucic acid rape seeds, for sowing','Semillas de nabo silvestre, con bajo contenido, p/siembra',10,'12','1205','120510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12051090','Sementes de nabo silvest.bx.teor, exc.p/semead','Low erucic acid rape seeds, except for sowing','Semillas de nabo silvestre, c/bajo cont.exc.p/siembra',10,'12','1205','120510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12059010','Outras sementes de nabo silvestre, para semeadura','Other rape seeds, for sowing','Las demás semillas de nabo silvestre,  para siembra',10,'12','1205','120590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12059090','Outras sementes de nabo silvestre, exceto para semeadura','Other rape seeds, except for sowing','Las dem.semillas de nabo silvestre, excepto para siembra',10,'12','1205','120590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12060010','Sementes de girassol, para semeadura','Sunflower seeds, for sowing','Semillas de girasol, para siembra',10,'12','1206','120600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12060090','Outras sementes de girassol, mesmo trituradas','Other sunflower seed, even crushed','Las dem.semillas de girasol, incluso quebrantadas',10,'12','1206','120600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12071010','Nozes e "palmiste", para semeadura','Palm nuts and kernels, for sowing','Nueces y almendra de palma, para siembra',10,'12','1207','120710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12071090','Outras nozes e "palmiste", mesmo triturados','Other palm nuts and kernels, whether or not broken','Las dem.nueces y almendras de palma, incl.quebrantados',10,'12','1207','120710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12072010','Sementes de algodão, para semeadura','Cotton seeds, for sowing','Semillas de algodón, para siembra',10,'12','1207','120720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12072090','Outras sementes de algodão, mesmo trituradas','Other cotton seeds, whether or not broken','Las dem.semillas de algodón, incluso quebrantadas',10,'12','1207','120720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12072100','Sementes de algodão, para semeadura','Cotton seeds for sowing','Semillas de algodón para siembra',10,'12','1207','120721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12072900','Sementes de algodão, exceto para semeadura','Cotton seeds, except for sowing','Semillas de algodón, excepto para siembra',10,'12','1207','120729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12073010','Sementes de rícino, para semeadura','Castor seeds, for sowing','Semillas de ricino, para siembra',10,'12','1207','120730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12073090','Outras sementes de rícino, mesmo trituradas','Other castor seeds, whether or not broken','Las demás semillas de ricino, incluso quebrantadas',10,'12','1207','120730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12074010','Sementes de gergelim, para semeadura','Sesamum seeds, for sowing','Semillas de sésamo, para siembra',10,'12','1207','120740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12074090','Outras sementes de gergelim, mesmo trituradas','Other sesamum seeds, whether or not broken','Las demás semillas de sésamo, incluso quebrantadas',10,'12','1207','120740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12075010','Sementes de mostarda, para semeadura','Mustard seeds, for sowing','Semillas de mostaza, para siembra',10,'12','1207','120750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12075090','Outras sementes de mostarda, mesmo trituradas','Other mustard seeds, whether or not broken','Las demás semillas de mostaza, incluso quebrantadas',10,'12','1207','120750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12076010','Sementes de cártamo, para semeadura','Safflower seeds, for sowing','Semillas de cártamo, para siembra',10,'12','1207','120760');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12076090','Outras sementes de cártamo, mesmo trituradas','Other safflower seeds, whether or not broken','Las demás semillas de cártamo, incluso quebrantadas',10,'12','1207','120760');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12077010','Sementes de melão, para semeadura','Melon seeds for sowing','Semillas de melón, para siembra',10,'12','1207','120770');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12077090','Sementes de melão, exceto para semeadura','Melon seeds, except for sowing','Semillas de melón, excepto para siembra',10,'12','1207','120770');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12079110','Sementes de dormideira ou papoula, para semeadura','Poppy seeds, for sowing','Semillas de amapola (adormidera), para siembra',10,'12','1207','120791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12079190','Outras sementes de dormideira ou papoula, mesmo triturad','Other poppy seeds, whether or not broken','Otras semillas de amapola (adormidera) incluso quebrantadas',10,'12','1207','120791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12079210','Sementes de "karite", para semeadura','Karite seeds for sowing','Semillas de karité, para siembra',10,'12','1207','120792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12079290','Outras sementes de "karite", mesmo trituradas','Other karite seeds, whether or not broken','Las demás semillas de karité, incluso quebrantadas',10,'12','1207','120792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12079910','Outras sementes e frutos oleaginosos, para semeadura','Other oil seeds and oleaginous fruits, for sowing','Las demás semillas y frutos oleaginosos,  para siembra',10,'12','1207','120799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12079911','Sementes de rícino, mesmo trituradas, para semeadura','Castor seeds, even crushed, for sowing','Semillas de ricino, mismo quebrantadas, para siembra',10,'12','1207','120799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12079919','Outras sem.e frutos oleag., mmo trit. p/sem.','Other seeds and oleaginous fruits, even crushed, for sowing','Otras semillas y frutos oleaginosos, mismo quebrantadas, para siembra',10,'12','1207','120799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12079990','Outras sementes e frutos oleaginosos, mesmo triturados','Other oil seeds and oleaginous fruits, whether or not broken','Las dem.semillas y frutos oleaginosos, incl.quebrantados',10,'12','1207','120799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12079991','Outras nozes e amêndoas de palma, mesmo trituradas','Other nuts and almonds, whether or not broken','Otros frutos de cáscara y almendra, incluso quebrantados',10,'12','1207','120799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12079992','Outras sementes de rícino, mesmo trituradas','Other castor seeds, whether or not broken','Las demás semillas de ricino, incluso quebrantadas',10,'12','1207','120799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12079999','Outras sementes e frutos oleaginosos, mesmo triturados','Other seeds and oleaginous fruits,  wheter or not crushed','Otras semillas y frutos oleaginosos,  incluso quebrantadas',10,'12','1207','120799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12081000','Farinha de soja','Soy flour','Harina de soja',10,'12','1208','120810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12089000','Farinhas de outs.sementes, frutos oleag.exc.de mostarda','Flours of other seeds, oleaginous fruits exc.mustard','Harinas de dem.semillas, frutos oleaginosos, exc.mostaza',10,'12','1208','120890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12091000','Sementes de beterraba sacarina, para semeadura','Sugar beet seeds, for sowing','Semillas de remolacha azucarera, para siembra',10,'12','1209','120910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12091100','Sementes de beterraba sacarina, para semeadura','Sugar beet seeds, for sowing','Semillas de remolacha azucarera, para siembra',10,'12','1209','120911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12091900','Sementes de outras beterrabas, para semeadura','Other beet seeds, for sowing','Semillas de demás remolachas, para siembra',10,'12','1209','120919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12092100','Sementes de alfafa (luzerna), para semeadura','Lucerne (alfalfa) seeds, for sowing','Semillas de alfalfa, para siembra',10,'12','1209','120921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12092200','Sementes de trevo (trifolium spp), para semeadura','Clover (trifolium spp.) seeds, for sowing','Semillas de trébol (trifolim spp), para siembra',10,'12','1209','120922');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12092300','Sementes de festuca, para semeadura','Fescue seeds, for sowing','Semillas de festucas, para siembra',10,'12','1209','120923');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12092400','Sementes de pasto dos prados do kentucky, para semeadura','Kentucky blue grass (poa pratensis l.)seeds, for sowing','Semillas de pasto azul de kentucky, para siembra',10,'12','1209','120924');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12092500','Sementes de azevém, para semeadura','Rye grass(lolium mult.lam., lolium per.l.)seeds, forsowing','Semillas de ballico, para siembra',10,'12','1209','120925');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12092600','Sementes de fleolo dos prados, para semeadura','Timothy grass seeds, for sowing','Semillas de fleo de los prados, para siembra',10,'12','1209','120926');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12092900','Outras sementes forrageiras, para semeadura','Forage plants seeds, for sowing','Las demás semillas forrajeras, para siembra',10,'12','1209','120929');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12093000','Sementes de plantas herbáceas, cult.p/flores, p/semeadura','Seed of herbaceous plants cult.princ.for flowers, forsowing','Semillas de plant.herbác.util.princ.sus flores, p/siembr',10,'12','1209','120930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12099100','Sementes de produtos hortícolas, para semeadura','Seeds of horticultural products, for sowing','Semillas de hortalizas, para siembras',10,'12','1209','120991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12099900','Outras sementes, frutos e esporos, para semeadura','Other seeds, fruit and spores, for sowing','Las demás semillas, frutos y esporas, para siembra',10,'12','1209','120999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12101000','Cones de lúpulo, frescos, secos, n/triturados, não moídos, etc','Hop cones, fresh, dried, n/ground, n/powdered, etc.','Conos de lúpulo, frescos, secos, s/triturar ni moler, etc',10,'12','1210','121010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12102010','Cones de lúpulo, triturados ou moídos, ou em "pellets"','Hop cones, ground, powdered or in the form of pellets','Conos de lúpulo, triturados o molidos, o en pellets',10,'12','1210','121020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12102020','Lupulina','Lupulin','Lupulino',10,'12','1210','121020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12111000','Raízes de alcaçuz, frescas, secas, incl.cortadas, tritur.pó','Liquorice roots, fresh, dried, incl.cut, ground, powder','Raíces de regaliz, frescas, secas, inc.cortad.tritur.polvo',10,'12','1211','121110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12112000','Raízes de "ginseng", frescas, secas, incl.cortad.tritur.pó','Ginseng roots, fresh, dried, incl.cut, ground, powder','Raíces de ginseng, frescas, secas, inc.cort.tritur.polvo',10,'12','1211','121120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12113000','Coca (folha de), p/util.perfum.medicina, etc.','Coca (leafs of), used in perfumery, medicine, etc.','Hojas de coca, util.princ.en perfumería, medicina, etc',10,'12','1211','121130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12114000','Palha de papoula, p/util.perfum.medicina, etc.','Poppy straw, used in perfumery, medicine, etc.','Paja de adormidera, util.princ.perfumería, medicina, etc',10,'12','1211','121140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12119010','Oregano fresco ou seco, p/perfumaria, medicina, etc.','Oregano, fresh or dried forperfumery, medicine, etc.','Orégano fresco o seco,  para perfumería,  medicina,  etc.',10,'12','1211','121190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12119020','Coca (folhas) fresca ou seca, p/perfumaria, medicina, etc.','Coca ( leafs of), fresh/dried, forperfumery, medicine, etc.','Hojas de coca, fresca/seca, util.princ.en perf.medic.etc',10,'12','1211','121190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12119030','Palha de papoula, fresca/seca, p/perfumaria, medicina, etc.','Straw of poppy, fresh/dried, forperfumery, medicine, etc.','Paja de adorm.fresca/seca, util.princ.en perf.medic.etc',10,'12','1211','121190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12119090','Outras plantas e partes, p/perfumaria, medicina e semelhs','Oth.plants/part, fresh/dried, forperfumery, medicine, etc','Las dem.plantas y partes, util.princ.perf.medicina y sim',10,'12','1211','121190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12121000','Alfarroba incl.sementes, frescas/refrig/cong/secas/em pó','Loc.beans incl.seeds, fresh/chilled/dried/frozen/powder','Algarrobas incl.semillas, frescas/refr/cong/secas/polvo',10,'12','1212','121210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12122000','Algas frescas, refrigeradas, congeladas, secas ou em pó','Seaweeds, fresh/chilled/dried/frozen/powder','Algas frescas, refrigeradas, congeladas, secas o en polvo',10,'12','1212','121220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12122100','Algas próprias para a alimentação humana','Algae that are fit for human consumption','Algas para el consumo humano',10,'12','1212','121221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12122900','Outras algas,frescas, refrigeradas, congeladas ou secas','Other algae, fresh, chilled, frozen or dried','Otras algas, frescas, refrigeradas, congeladas o secas',10,'12','1212','121229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12123000','Carocos e amêndoas de damascos, pêssegos e ameixas','Stones and almonds of apricots, peaches and plums','Huesos y almendras de albaricoque, durazno y ciruela',10,'12','1212','121230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12129100','Beterraba sacarina, fresca, refriger.congelada, seca, em pó','Sugar beet, fresh/chilled/dried/frozen/powder','Remolacha azucarera, fresca, refrig.congel.seca, en polvo',10,'12','1212','121291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12129200','Cana-de-açúcar fresca, refrigerada, congelada, seca, em pó','Sugar cane (fresh,  chillen,  frozen,  dry,  powder)','Caña de azúcar fresca, refrig.congel.seca, en polvo',10,'12','1212','121292');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12129300','Cana-de-açúcar, fresca, regrigerada, congelada ou seca','Cane sugar, fresh, chilled, frozen or dried','Caña de azúcar, fresca, refrigerada, congelada o seca',10,'12','1212','121293');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12129400','Raízes de chicória,fresca,refrigerada,congelada ou seca','Roots of chicory, fresh, frozen, dried or chilled','Raíces de achicoria,frescas,congeladas,secas o refrig.',10,'12','1212','121294');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12129900','Outros prods.vegetais util.principalm.na aliment.humana','Other vegetable products used mainly for human','Los dem.productos vegetales util.princ.en la alim.hum.',10,'12','1212','121299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12129910','Stevia rebaudiana','Stevia rebaudiana','Stevia rebaudiana',10,'12','1212','121299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12129990','Outros prods.vegetais util.principalm.na aliment.humana','Other vegetable products used mainly forhuman','Los dem.productos vegetales util.princ.en la alim.hum.',10,'12','1212','121299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12130000','Palhas, cascas de cereais, em bruto, moidas, prensadas, etc.','Cereal straw and husks, unprepared, ground, pressed, etc.','Pajas, cascabillos de cereal.en bruto, molidos, prens.etc',10,'12','1213','121300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12141000','Farinhas e "pellets", de alfafa (luzerna)','Lucerne (alfalfa) meal and pellets','Harinas y pellets de alfalfa',10,'12','1214','121410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('12149000','Rutabagas, raízes forrageiras e outros produtos forrageiros','Swedes, fodder roots, and oth.forage products','Nabos forrajeros, raíces forrajer.y los dem.prod.forraj.',10,'12','1214','121490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13011000','Goma-laca','Lac','Goma laca',10,'13','1301','130110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13012000','Goma-arábica','Gum arabic','La goma árabe',10,'13','1301','130120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13019000','Outras gomas, resinas, gomas-resinas, oleorresinas, naturais','Other gums,  resins,  gum-resins,  oleoresins,  natural','Las dem.gomas, resinas, gomorresinas, oleorresinas, natur.',10,'13','1301','130190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13019010','Goma-laca','Lac','Goma laca',10,'13','1301','130190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13019090','Outs gomas,res., goma-resinas, bálsamos nat.','Other gums,  resins,  gum-resins,  oleoresins,  natural','Las dem.gomas, resinas, gomorresinas, oleorresinas, natur.',10,'13','1301','130190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13021100','Sucos e extratos, de ópio','Juices and extracts, of opium','Jugos y extractos, de opio',10,'13','1302','130211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13021110','Concentrado de palha de papoula','Concentrated of straw of poppy','Concentrado de paja de adormidera',10,'13','1302','130211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13021190','Outros sucos e extratos vegetais, de ópio','Other juices and vegetable extracts, of opium','Los demás jugos y extractos vegetales, de opio',10,'13','1302','130211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13021200','Sucos e extratos, de alcaçuz','Juices and extracts, of liquorice','Jugos y extractos, de regaliz',10,'13','1302','130212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13021300','Sucos e extratos, de lúpulo','Juices and extracts, of hop','Jugos y extractos, de lúpulo',10,'13','1302','130213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13021400','Sucos e extratos, de piretro ou de raízes c/rotenona','Juice/extracts of pyrethrum/the root of plant containing rotenone','Jugos y extractos, de piretro o raíces q.cont.rotenona',10,'13','1302','130214');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13021910','Sucos e extratos, de mamão ("carica papaya"), seco','Juices and extracts,  of papaya ("carica papaya"), dried','Jugos y extractos, de mamón ("carica papaya"), seco',10,'13','1302','130219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13021920','Sucos e extratos, de semente de pomelo ("grapefruit")','Juices and extracts, of seed of pomelo ("grapefruit")','Jugos y extractos,  de semillas de pomelo ("grapefruit")',10,'13','1302','130219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13021930','Sucos e extratos de ginkgo biloba seco','Juices and extracts of ginkgo biloba dried','Jugos y extractos de ginkgo biloba, seco',10,'13','1302','130219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13021940','Sucos e extratos, valepotriatos','Juices and extracts, valepotriates (valerian extracts)','Jugos y extractos, valepotriatos',10,'13','1302','130219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13021950','Sucos e extratos, de "ginseng"','Juices and extracts, of ginseng','Jugos y extractos, de ginseng',10,'13','1302','130219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13021960','Sucos e extratos, silimarina','Juices and extracts, of silymarin','Jugos y extractos, silimarina',10,'13','1302','130219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13021990','Sucos e extratos, de outros vegetais','Juices and extracts, of other vegetables','Jugos y extractos, de demás vegetales',10,'13','1302','130219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13021991','Suc.extrat.de piretro, raízes, cont.rotenona','Juice/extracts of pyrethrum/the root of plant containing rotenone','Jugos y extractos, de piretro o raíces q.cont.rotenona',10,'13','1302','130219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13021999','Outros sucos e extratos vegetais','Other juices and vegetable extracts','Otros jugos y extractos vegetales',10,'13','1302','130219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13022010','Matérias pécticas (pectinas)','Pectic substances','Materias péctinas (pectinas)',10,'13','1302','130220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13022090','Outras matérias pécticas, pectinatos e pectatos','Other pectic substances, pectinates and pectates','Las demás materias péctinas, pectinatos y pectatos',10,'13','1302','130220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13023100','Agar-agar','Agar-agar','Agar-agar',10,'13','1302','130231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13023211','Farinha de endosperma','Endosperm flour','Harina de endosperma',10,'13','1302','130232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13023219','Outs.prods.mucilag.espessantes, de alfarroba e sementes','Oth.mucilages prod.thickeners, derived from locust beans','Los dem.mucílagos y espesativos de algarroba y sem.',10,'13','1302','130232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13023220','Produtos mucilaginosos e espessantes, de sementes de guaré','Mucilages products, thickeners, of guar seeds','Mucílagos y espesativos, de semilas de guar',10,'13','1302','130232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13023910','Produtos mucilaginosos e espessantes, de carragenina','Mucilages products, thickeners, of carrageenan','Mucílagos y espesativos, de carragenina',10,'13','1302','130239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('13023990','Prods.mucilaginosos e espessantes, deriv.outros vegetais','Mucilages prod.thickeners, derived from oth.vegetable','Mucílagos y  espesativos,  derivados de demás vegetales',10,'13','1302','130239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('14011000','Bambus para cestaria ou espartaria','Bamboos used primarily for plaiting','Bambú para cestería o espartería',10,'14','1401','140110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('14012000','Rotins para cestaria ou espartaria','Rattans used primarily for plaiting','Roten para cestería o espartería',10,'14','1401','140120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('14019000','Outras matérias vegetais para cestaria ou espartaria','Other materials vegetables for plaiting','Las demás materias vegetales para cestería o espartería',10,'14','1401','140190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('14020000','Matérias vegetais, utiliz.cestaria/espartaria','Other materials vegetables, used for plaiting','Materias vegetales, utilizadas p/cestería o espartería',10,'14','1402','140200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('14021000','Sumauma ("kapoc") para enchimento ou estofamento','Kapok for stuffing or padding','"kapoc" utilizadas para relleno o en capas',10,'14','1402','140210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('14029000','Outras matérias vegetais, para enchimento ou estofamento','Other vegetable materials, for stuffing or padding','Las dem.materias vegetales, util.p/relleno o en capas',10,'14','1402','140290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('14030000','Matérias vegetais, para fabricação de vassouras/escovas','Vegetable materials for production of brooms/brushes','Materias vegetales, utilizadas para fabricacción de escobas/cepillos',10,'14','1403','140300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('14031000','Sorgo para vassouras','Broomcorn for brooms','Sorgo para escobas',10,'14','1403','140310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('14039000','Outras matérias vegetais p/fabr.de vassouras ou escovas','Oth.vegetable materials forproduction of brooms/brushes','Las dem.materias veget.util.p/fabr.de escobas/cepillos',10,'14','1403','140390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('14041000','Matérias-primas vegetais para tinturaria ou curtimenta','Raw vegetable materials primarily for dyeing or tanning','Materias primas vegetales utilizadas p/teñir o curtir',10,'14','1404','140410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('14042010','Línteres de algodão, em bruto','Cotton linters, in brute','Línteres de algodón, en bruto',10,'14','1404','140420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('14042090','Outros línteres de algodão','Other cotton linters','Los demás línteres de algodón',10,'14','1404','140420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('14049000','Outros produtos de origem vegetal, para entrançar','Other products of vegetable origin, for twisting','Otros productos de origen vegetal,  para trenzar',10,'14','1404','140490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('14049010','Matérias vegetais, para fabricação de vassouras/escovas','Vegetable materials for production of brooms/brushes','Materias vegetales, utilizadas para fabricacción de escobas/cepillos',10,'14','1404','140490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('14049090','Outros  produtos de origem vegetal, para entrançar','Other products of vegetable origin, for twisting','Otros productos de origen vegetal, para trenzar',10,'14','1404','140490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15010000','Gorduras de porco (incluindo a banha) e gordura de aves','Pig fat (including lard) and poultry fat','Grasa de cerdo (incluso la manteca de cerdo), y grasa de ave',10,'15','1501','150100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15011000','Banha de porco','Lard','Manteca de cerdo',10,'15','1501','150110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15012000','Outras gorduras de porco','Other fats, pork','Otras grasas de carne de cerdo',10,'15','1501','150120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15019000','Gordura de aves','Birds fat','Grasa de aves',10,'15','1501','150190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15020011','Sebo bovino, em bruto','Fat of bovine, raw','Sebo bovino, en bruto',10,'15','1502','150200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15020012','Sebo bovino, fundido','Fat of bovine, rendered','Sebo bovino, fundido',10,'15','1502','150200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15020019','Outros sebos bovinos','Other fat of bovine','Los demás sebos bovinos',10,'15','1502','150200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15020090','Outras gorduras bovinas, ovinas ou caprinas','Other fat bovine, sheep or goats','Las demás grasas bovinas, ovinas o caprinas',10,'15','1502','150200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15021011','Sebo bovino, em bruto','Beef tallow, crude','Sebo de vaca, cruda',10,'15','1502','150210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15021012','Sebo bovino fundido (incluindo o premier jus)','Melted tallow','Sebo derretido de bovino',10,'15','1502','150210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15021019','Outros sebos bovinos','Other beef tallow','Otros sebo de vacuno',10,'15','1502','150210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15021090','Outras gorduras bovinas','Other bovine fats','Otras grasas de la especie bovina',10,'15','1502','150210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15029000','Gorduras ovinas ou caprinas','Fats of sheep or goats','Grasa ovina o caprina',10,'15','1502','150290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15030000','Estearina solar, óleo de banha de porco, etc.n/preparados','Lard stearin, lard oil, etc.unprepared','Estearina solar, aceite de manteca de cerdo, etc, s/prep.',10,'15','1503','150300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15041011','Óleos de fígados de bacalhau, em bruto','Oils of livers of cod, crude','Aceites de hígado de bacalao, en bruto',10,'15','1504','150410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15041019','Outros óleos de fígados de bacalhau','Other oils of livers of cod','Los demás aceites de hígado de bacalao',10,'15','1504','150410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15041090','Óleos de fígados de outros peixes e respectivas frações','Other oils of livers of oth.fish  and their fractions','Aceites de hígado de dem.pescados y sus fracciones',10,'15','1504','150410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15042000','Gorduras e óleos, de peixe e respectivas frações','Fats and oils and their fractions, of fish','Grasas y aceites,  de pescado y sus fracciones',10,'15','1504','150420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15043000','Gorduras e óleos, de mamíferos marinhos, respectivas frações','Fats and oils and their fractions, of marine mammals','Grasas y aceites, de mamíferos marinos y sus fracciones',10,'15','1504','150430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15050010','Lanolina','Lanolin','Lanolina',10,'15','1505','150500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15050090','Outs.subst.gordas deriv.da lanolina, inclusive a suarda','Obter fatty substances deriv.of lanolin, incl.wool grease','Otras sustancias grasas derivadas de lanolina, incluso suarda',10,'15','1505','150500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15051000','Suarda em bruto','Wool grease, crude','Suarda en bruto',10,'15','1505','150510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15059010','Lanolina','Lanolin','Lanolina',10,'15','1505','150590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15059090','Outras substâncias gordas derivadas da suarda','Other fatty substances derived of wool grease','Las demás sustancias grasas derivadas de la suarda',10,'15','1505','150590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15060000','Outras gorduras, óleos, animais, incluindo refinado, mas não modificado quimicamente','Other fats, oils, animals, incl.refined but n/chemic.modif','Las dem.grasas, aceites, anim.incl.refin.s/modif.químicam',10,'15','1506','150600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15071000','Óleo de soja, em bruto, mesmo degomado','Crude soya-bean oil, whether or not degummed','Aceite de soja, en bruto, incluso desgomado','21','15','1507','150710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15079010','Óleo de soja, refinado','Soya-bean oil, refined','Aceite de soja, refinado','21','15','1507','150790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15079011','Óleo de soja, refinado, em recipientes com capacidade<=5l','Soya-bean oil, refined, in containers with capacity<= 5l','Aceite de soja, refinado, en envases c/capacidad<=5l','21','15','1507','150790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15079019','Óleo de soja, refinado, em recipientes com capacidade>5l','Soya-bean oil, refined, in containers with capacity>5l','Aceite de soja, refinado, en envases c/capacidad>5l','21','15','1507','150790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15079090','Outros óleos de soja','Other soya-bean oils','Los demás aceites de soja','21','15','1507','150790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15081000','Óleo de amendoim, em bruto','Ground-nut oil, in crude','Aceite de cacahuete,  en bruto',10,'15','1508','150810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15089000','Outros óleos de amendoim','Other ground-nut oil','Los demás aceites de cacahuete',10,'15','1508','150890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15091000','Azeite de oliva, virgem','Olive oil, virgin','Aceite de oliva, virgen',10,'15','1509','150910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15099010','Azeite de oliva, refinado','Olive oil, refined','Aceite de oliva, refinado',10,'15','1509','150990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15099090','Outros azeites de oliva','Other olive oil','Otros aceites de oliva',10,'15','1509','150990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15100000','Outros óleos de azeitonas e misturas c/azeites de oliva','Other oils of olives and mixtur.with olive oil of olive','Los dem.aceites de aceituna y mezclas c/aceites de oliv',10,'15','1510','151000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15111000','Óleos de dende, em bruto','Palm oil, in crude','Aceites de palma, en bruto',10,'15','1511','151110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15119000','Outros óleos de dende','Other palm oil','Los demás aceites de palma',10,'15','1511','151190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15121110','Óleo de girassol, em bruto','Sunflower-seed oil, in crude','Aceite de girasol, en bruto',10,'15','1512','151211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15121120','Óleo de cártamo, em bruto','Safflower oil, in crude','Aceite de cártamo, en bruto',10,'15','1512','151211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15121910','Outros óleos de girassol','Other sunflower-seed oil','Los demás aceites de girasol',10,'15','1512','151219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15121911','Óleo de girassol, refinado, em recipiente com capacidade <=5l','Soya-bean oil, refined, in containers with capacity<= 5l','Aceite de girasol, refinado, en envases c/capacidad<=5l',10,'15','1512','151219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15121919','Outros óleos de girassol','Other sunflower-seed oil','Los demás aceites de girasol',10,'15','1512','151219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15121920','Outros óleos de cártamo','Other safflower oil','Los demás aceites de cártamo',10,'15','1512','151219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15122100','Óleo de algodão,  em bruto,  mesmo desprovido de "gossypol"','Crude cotton-seed oil, containing or not gossypol','Aceite de algodón, en bruto, incluso sin gosipol',10,'15','1512','151221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15122910','Óleo de algodão, refinado','Cotton-seed oil, refined','Aceite de algodón, refinado',10,'15','1512','151229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15122990','Outros óleos de algodão','Other cotton-seed oil','Los demás aceites de algodón',10,'15','1512','151229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15131100','Óleo de coco (óleo de copra), em bruto','Coconut (copra) oil, crude','Aceite de coco (de copra), en bruto',10,'15','1513','151311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15131900','Outros óleos de coco (óleos de copra)','Other coconut (copra) oil','Los demás aceites de coco (de copra)',10,'15','1513','151319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15132110','Óleo de "palmiste", em bruto','Palm kernel oil, crude','Aceite de almendra de palma, en bruto',10,'15','1513','151321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15132120','Óleo de babaçu, em bruto','Babassu oil, crude','Aceite de babasú, en bruto',10,'15','1513','151321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15132910','Outros óleos de "palmiste"','Other palm kernel oil','Los demás aceites de palmiste',10,'15','1513','151329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15132920','Outros óleos de babaçu','Other babassu oil','Los demás aceites de babasú',10,'15','1513','151329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15141000','Óleos de nabo silvestre, de colza, de mostarda, em bruto','Rape, colza or mustard oil, in crude','Aceites de nabo(de nabina), de colza, de mostaza, en bruto',10,'15','1514','151410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15141100','Óleos de nabo silvestre, baixo teor, em bruto','Wild turnip oil, low content, in crude','Aceites de nabo(de nabina),  bajo contenido,  en bruto',10,'15','1514','151411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15141910','Óleos de nabo silvestre, baixo teor, refinados','Wild turnip oil, low content, refined','Aceites de nabo(de nabina), bajo contenido, refinados',10,'15','1514','151419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15141990','Outros óleos de nabo silvestre, baixo teor','Other wild turnip oil, content tenor','Los demás aceites de nabo(de nabina), bajo contenido',10,'15','1514','151419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15149010','Óleos de nabo silvestre, de colza, de mostarda, refinados','Rape, colza or mustard oil, refined','Aceites de nabo (de nabina), de colza, de mostaza, refinado',10,'15','1514','151490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15149090','Outros óleos de nabo silvestre, de colza ou de mostarda','Other rape, colza or mustard oil','Otros aceites de nabo (de nabina), de colza o mostaza',10,'15','1514','151490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15149100','Outros óleos de nabo silvestre, em bruto','Other wild turnip oil, low content, in crude','Los demás aceites de nabo (de nabina), en bruto',10,'15','1514','151491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15149910','Outros óleos de nabo silvestre, refinados','Other wild turnip oil, low content, refined','Los demás aceites de nabo (de nabina), refinados',10,'15','1514','151499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15149990','Outros óleos de nabo silvestre','Other wild turnip oil','Los demás aceites de nabo (de nabina)',10,'15','1514','151499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15151100','Óleo de linhaça, em bruto','Linseed oil, in crude','Aceite de linaza, en bruto',10,'15','1515','151511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15151900','Outros óleos de linhaça','Other linseed oil','Los demás aceites de linaza',10,'15','1515','151519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15152100','Óleo de milho, em bruto','Maize (corn) oil, in crude','Aceite de maíz, en bruto',10,'15','1515','151521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15152900','Outros óleos de milho','Other maize (corn) oil','Los demás aceites de maíz',10,'15','1515','151529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15152910','Óleo de milho,  refinado,  em recipiente com capacidade<=5l','Maize (corn) oil, refined, in container with capacity<=5l','Aceite de maíz, refinado, en envases c/capacidad<=5l',10,'15','1515','151529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15152990','Outros óleos de milho','Other maize (corn) oil','Los demás aceites de maíz',10,'15','1515','151529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15153000','Óleo de ricino','Castor oil','Aceite de ricino',10,'15','1515','151530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15154010','Óleo de tungue, em bruto','Tung oil, crude','Aceite de tung, en bruto',10,'15','1515','151540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15154020','Óleo de tungue, refinado','Tung oil, refined','Aceite de tung, refinado',10,'15','1515','151540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15154090','Outros óleos de tungue','Other tung oil','Los demás aceites de tung',10,'15','1515','151540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15155000','Óleo de gergelim','Sesame oil','Aceite de sésamo',10,'15','1515','151550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15156000','Óleo de jojoba','Jojoba oil','Aceite de jojoba',10,'15','1515','151560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15159000','Outras gorduras e óleos, vegetais, fixos, mesmo refinados','Other fixed vegetable fats and oils, refined or not','Las dem.grasas y aceites, vegetales, fijos, incl.refinados',10,'15','1515','151590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15159010','Óleo de jojoba e respectivas frações','Jojoba oil and their fractions','Aceite de jojoba y sus fracciones',10,'15','1515','151590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15159021','Óleo de tungue em bruto, não modificado químicamente','Tung oil, in crude, not chemically modified','Aceite de tung,  en bruto, sin modificar químicamente',10,'15','1515','151590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15159022','Óleos de tungue, refinado, não modificado químicamente','Tung oil, refined, not chemically modified','Aceite de tung,  refinado, sin modificar químicamente',10,'15','1515','151590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15159090','Outras gorduras e óleos vegetais, mesmo refinado','Other fixed vegetable fats and oils, refined or not','Las demás grasas y aceites vegetales, incluso refinados',10,'15','1515','151590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15161000','Gorduras e óleos, animais, hidrogens.interesterifs.etc.','Animal fats and oils, hydrogenated, inter-esterified, etc.','Grasas y aceites, anim.hidrogenados, interesterificad.etc',10,'15','1516','151610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15162000','Gorduras e óleos, vegetais, hidrogens.interesterifs.etc.','Vegetable fats and oils, hydrog., inter-esterified, etc.','Grasas y aceites, veg.hidrogenados, interesterificad.etc',10,'15','1516','151620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15171000','Margarina, exceto a margarina líquida','Margarine (excluding liquid margarine)','Margarina (excepto la margarina líquida)',10,'15','1517','151710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15179000','Misturas, prepar.aliment.de gorduras, óleos, animais, etc.','Edible mixtures preparations of fats, oils, animals, etc.','Mezclas, prep.alimentic.de grasas, aceites, animales, etc',10,'15','1517','151790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15179010','Misturas de óleos refinados, em recipiente c/capacid<=5l','Mixtures of refined oils, in container with capacity<=5l','Mezclas de aceites refinados, en envases c/capacidad<=5l',10,'15','1517','151790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15179090','Outras misturas, prepar.aliment.de gorduras, óleos, etc.','Other edible mixtures preparations of fats, oils,  etc.','Otras mezclas, preparaciones alimenticias de grasas, aceites, etc',10,'15','1517','151790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15180000','Gorduras e óleos, animais, vegetais, cozidos, oxidados, etc.','Animal or vegetable fats and oils, boiled, oxidized, etc.','Grasas y aceites, animales, veget.cocidos, oxidados, etc',10,'15','1518','151800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15180010','Óleo vegetal epoxidado','Epoxidized vegetable oil','Aceite vegetal epoxidado',10,'15','1518','151800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15180090','Outras gorduras e óleos animais/vegetais cozidos, oxidados.etc.','Other animal fat and oil/cooked vegetables/oxidized,  etc','Otras grasas y aceites animales/verduras cocidas,  oxidado,  etc.',10,'15','1518','151800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15200010','Glicerol em bruto','Crude glycerol','Glicerol en bruto',10,'15','1520','152000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15200020','Água e lixívia, glicéricas','Glycerol waters and glycerol lyes','Aguas y lejías, glicerinosas',10,'15','1520','152000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15211000','Ceras vegetais','Vegetable waxes','Ceras vegetales',10,'15','1521','152110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15219011','Cera de abelha, em bruto','Bee wax, in crude','Cera de abejas, en bruto',10,'15','1521','152190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15219019','Outras ceras de abelha','Other bee waxes, in crude','Las demás ceras de abejas',10,'15','1521','152190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15219090','Ceras de outs.insetos e espermacete, mesmo refin.corados','Veget.waxes, ot.insect waxes/spermac.refin/colour.or not','Ceras de dem.insect.y espermaceti, incl.refin.coloreadas',10,'15','1521','152190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('15220000','Degras e resíduos do tratam.das matérias graxas, etc.','Degras and residues from treatment greases substan.etc','Degrás y residuos del tratamiento de grasas, etc',10,'15','1522','152200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16010000','Enchidos de carne, miudezas, sangue, suas preparações alimentícias','Sausages of meat, meat offal, blood, their food preparat.','Embutidos de carne, despojos, sangre, sus prepar.aliment.',10,'16','1601','160100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16021000','Prepars.aliments.homogeneiz.de carnes, miudezas, sangue','Homogenized prepared of meat, edible offal, blood','Preparaciones alimenticias homogeneizadas de carnes, despojos, sangre',10,'16','1602','160210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16022000','Preparações alimentícias e conservas,  de fígados de animais','Prepared preserved edible, of liver of animals','Preparaciones alimenticias y conservas, de hígados de animales',10,'16','1602','160220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16023100','Preparações alimentícias e conservas, de peru','Prepared preserved edible, of turkey','Preparaciones alimenticias y conservas,  de pavo',10,'16','1602','160231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16023200','Preparações alimentícias e conservas,  de galos,  galinhas','Prepared preser.edible, of fowls, of spec.gallus domestic','Preparac.alimenticias y conservas, de gallo o gallina',10,'16','1602','160232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16023210','Galo/galinha c/cont.carne/miud.>=57% em peso nao cozida','Rooster/chicken, uncooked, meat > 57% weight','Gallo/pollo, sin cocer, carne > 57% peso',10,'16','1602','160232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16023220','Galo/galinha c/cont.carne/miud.>=57% em peso cozidas','Rooster/chicken, cooked, meat > 57% weight','Gallo/pollo, cocido, carne > 57% peso',10,'16','1602','160232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16023230','Galo/galinha c/cont.carne/miud.>=25 e <57% em peso','Rooster/chicken, meat 25 <= weight < 57%','Gallo/pollo, carne 25 <= peso < 57%',10,'16','1602','160232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16023290','Outras preparações/conservas de galo e galinhas','Other prepared/preserved, of fowls','Otras preparaciones y conservados, de aves de corral',10,'16','1602','160232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16023900','Preparações alimentícias e conservas,  de outras aves','Prepared preserved edible, of other birds','Preparaciones alimenticias y conservas,  de demás aves',10,'16','1602','160239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16024100','Prepars.alim.conservas, de pernas,  seus pedaços,  de suínos','Prepared preserved edible, hams, cuts thereof, of swine','Prep.alim.y conservas, de piern.trozos de piern.de porc.',10,'16','1602','160241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16024200','Prepars.aliment.conservas, de pas,  seus pedaços,  de suínos','Prepared preserv.edible, shoulders, cuts thereof, of swine','Prep.alim.y conservas, de paletas, trozos de pal.de porc.',10,'16','1602','160242');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16024900','Outras prepars.aliment.e conservas, de suínos e misturas','Oth.prepared preserved edible, of swine and mixtures','Las dem.prep.alimenticias y conservas, de porc.y mezclas',10,'16','1602','160249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16025000','Preparações alimentícias e conservas, de bovinos','Prepared preserved edible, of bovine','Preparaciones alimenticias y conservas,  de bovinos',10,'16','1602','160250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16029000','Outras prepars.aliment.conserv.de carnes, miudez.sangue','Prepared preserved edible, of meat offal, blood','Las dem.prep.alim.y conservas de carnes, despojos, sangre',10,'16','1602','160290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16030000','Extratos e sucos, de carnes, de peixes, de crustáceos, etc.','Extracts and juices of meat,  fish or crustaceans, etc.','Extractos y jugos, de carnes, de pescados, de crustác.etc',10,'16','1603','160300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16041100','Preparações e conservas, de salmões, inteiros ou em pedaços','Prepared preserved, of salmon, whole or in pieces','Preparaciones y conservas, de salmones, enteros o trozos',10,'16','1604','160411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16041200','Preparações e conservas, de arenques, inteiros ou em pedaços','Prepared preserved, of herrings, whole or in pieces','Preparaciones y conservas, de arenque, enteros o en troz.',10,'16','1604','160412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16041310','Preparações e conservas, de sardinhas, inteiras ou em pedaços','Prepared preserved, of sardines, whole or in pieces','Preparac.y conservas, de sardinas, enteras o en trozos',10,'16','1604','160413');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16041390','Preparações e conservas, de sardinelas, espadilhas, int.pedaços','Prepar./preserv.of sardinella, brisling, whole/in pieces','Prep.y conser.de sardinelas, espadines, enteros o trozos',10,'16','1604','160413');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16041410','Preparações e conservas, de atuns, inteiros ou em pedaços','Prepared preserved, of tunas, whole or in pieces','Preparaciones y conservas, de atunes, enteros o en trozos',10,'16','1604','160414');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16041420','Prepars.conservas, de bonitos-listrados, inteiros, pedaços','Prepared preserved, of skipjack, whole or in pieces','Preparaciones y conservas, de listados, enteros o en troz',10,'16','1604','160414');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16041430','Prepars.conservas, de bonitos-cachorros, inteiros, pedaços','Prepared preserved, of bonito, whole or in pieces','Preparaciones y conservas, de bonitos, enteros o en troz.',10,'16','1604','160414');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16041500','Prepars.conservas, de cavalas, cavalinhas, etc.int.pedaços','Prepared preserved, of mackerel, etc.whole or in pieces','Prep.y conserv.de caballas, etc, enteros/troz.',10,'16','1604','160415');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16041600','Prepars.e conservas, de anchovas, inteiras ou em pedaços','Prepared preserved, of anchovies, whole or in pieces','Preparaciones y conservas, de anchoas, enteras o en troz.',10,'16','1604','160416');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16041700','Preparações e conservas, de enguias','Prepared or preserved, eel','Preparaciones y conservas, de anguila',10,'16','1604','160417');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16041900','Prepars.e conservas, de outs.peixes, inteiros, em pedaços','Prepared preserved, of other fish, whole or in pieces','Preparaciones y conservas, de dem.pescados, enteros/troz.',10,'16','1604','160419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16042010','Outras preparações e conservas, de atuns','Other prepared preserved, of tunas','Las demás preparaciones y conservas,  de atunes',10,'16','1604','160420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16042020','Outras preparações e conservas, de bonitos-listrados','Other prepared preserved, of bonito','Las demáspreparaciones y conservas,  de listados',10,'16','1604','160420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16042030','Outras prepars.e conservas, de sardinhas, sardinelas, etc.','Other prepared preserved, of sardines, sardinelas, etc.','Las dem.preparac.y conservas, de sardinas, sardinelas, etc',10,'16','1604','160420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16042090','Outras preparações e conservas, de outros peixes','Other prepared preserved, of other fish','Las demás preparaciones y conservas,  de otros pescados',10,'16','1604','160420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16043000','Caviar e seus sucedâneos','Caviar and caviar substitutes','Caviar y sus sucedáneos',10,'16','1604','160430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16043100','Caviar','Caviar','Caviar',10,'16','1604','160431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16043200','Sucedâneos de caviar','Caviar substitutes','Sucedáneos de caviar',10,'16','1604','160432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16051000','Preparações e conservas, de caranguejos','Prepared preserved, of crab','Preparaciones y conservas, de cangrejos',10,'16','1605','160510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16052000','Preparações e conservas, de camarões','Prepared preserved, of shrimps','Preparaciones y conservas, de camarones',10,'16','1605','160520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16052100','Prep. e cons.de camarões,n/acondic.em recip.herm.fechados','Prepared or preserved,shrimp, not in closed container','Preparaciones y conservas,gambas,no en rec.cerrado',10,'16','1605','160521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16052900','Prep.e cons.de camarões,exc.n/acond.em recip.herm.fech.','Prepared or preserved,shrimp,ex.not in closed container','Preparaciones y conservas,gambas,exc. no en rec.cerrado',10,'16','1605','160529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16053000','Preparações e conservas, de lavagantes ("homards")','Prepared preserved, of lobster','Preparaciones y conservas, de bogavante ("homards")',10,'16','1605','160530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16054000','Preparações e conservas, de outros crustáceos','Prepared preserved, of other crustaceans','Preparaciones y conservas, de demás crustáceos',10,'16','1605','160540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16055100','Preparações e conservas, de ostras','Prepared or preserved, oysters','Preparaciones y conservas, de ostras',10,'16','1605','160551');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16055200','Preparações e conservas, de vieiras e outros mariscos','Prepared or preserved, scallop and other seafood','Preparaciones y conservas, de vieiras y otros mariscos',10,'16','1605','160552');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16055300','Preparações e conservas, de mexilhões','Prepared or preserved, mussels','Preparaciones y conservas, de mejillones',10,'16','1605','160553');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16055400','Preparações e conservas, sépias e lulas','Prepared or preserved, squid and cuttlefish','Preparaciones y conservas, de calamar y de la sepia',10,'16','1605','160554');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16055500','Preparações e conservas, de polvos','Prepared or preserved, octopus','Preparaciones y conservas, de pulpo',10,'16','1605','160555');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16055600','Preparações e conservas, de ameijoas, berbigões e arcas','Prepared or preserved, clams, cockles','Preparaciones y conservas, de almejas, berberechos',10,'16','1605','160556');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16055700','Preparações e conservas, de abalones','Prepared or preserved, abalones','Preparaciones y conservas, de abalones',10,'16','1605','160557');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16055800','Preparações e conservas, de caracóis (exceto os do mar)','Prepared or preserved, snails (except from sea)','Preparaciones y conservas,de caracoles(excepto del mar)',10,'16','1605','160558');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16055900','Preparações e conservas, de outros moluscos','Prepared or preserved, other mollusks','Preparaciones y conservas, de otros moluscos',10,'16','1605','160559');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16056100','Preparações e conservas, de pepinos-do-mar','Prepared or preserved, sea ??cucumbers','Preparaciones y conservas, pepinos de mar',10,'16','1605','160561');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16056200','Preparações e conservas, de ouriços-do-mar','Prepared or preserved, sea urchin','Preparaciones y conservas, erizo de mar',10,'16','1605','160562');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16056300','Preparações e conservas, de medusas (águas-vivas)','Prepared or preserved, jellyfish','Preparaciones y conservas de medusas (aguamalas)',10,'16','1605','160563');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16056900','Preparações e conservas,de outros invertebrados aquáti.','Prepared or preserved, other aquatic invertebrates','Preparaciones y conservas,otros invertebrados acuáticos',10,'16','1605','160569');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('16059000','Prepars.e conservas, de moluscos e outs.invertebr.aquát.','Prepared preserved, of molluscs and ot.aquatic invertebr','Prep.y conservas, de moluscos y dem.invertebrados acuát.',10,'16','1605','160590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17011100','Açúcar de cana, em bruto','Cane sugar, in crude','Azúcar de caña, en bruto','21','17','1701','170111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17011200','Açúcar de beterraba, em bruto','Beet sugar, in crude','Azúcar de remolacha, en bruto',10,'17','1701','170112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17011300','Açúcar de cana mencionado na nota 2 da posição 1701','Cane sugar mentioned in note 2 of heading 1701','Azúcar de caña mencionado en nota 2 de la partida 1701','21','17','1701','170113');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17011400','Outros açúcares de cana','Other cane sugar','Otros azúcares de caña','21','17','1701','170114');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17019100','Outros açúcares de cana, beterraba, com aromatiz.corante','Other cane or beet sugar added flavouring or colouring','Los dem.azúcares de caña, remolacha, c/aromatiz.colorante',10,'17','1701','170191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17019900','Outros açúcares de cana, beterraba, sacarose químicamented pura, sol.','Other cane/beet sugar/chemically pure sucrose, in solid','Los dem.azúc.de caña, remolacha, sacarosa quím.pura, sól.','21','17','1701','170199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17021100','Lactose e xarope de lactose, peso>=99% de lactose, etc.','Lactose and lactose syrup,  by weight>= 99% lactose, etc','Lactosa y jarabe de lactosa, c/cont.de lact.>=99%en peso',10,'17','1702','170211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17021900','Outras lactoses e xaropes de lactose','Other lactose and lactose syrup','Las demás lactosas y jarabes de lactosa',10,'17','1702','170219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17022000','Açúcar e xarope, de bordo (acer)','Maple sugar and maple syrup','Azúcar y jarabe, de arce',10,'17','1702','170220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17023011','Glicose quimicamente pura','Chemically pure glucose','Glucosa químicamente pura',10,'17','1702','170230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17023019','Outras glicoses contend.estado seco, peso<20% de frutose','Oth.fructose containing dry state, by weight<20%fructose','Las dem.glucosas c/cont.de fruct.sob.prod.seco<20%en p.',10,'17','1702','170230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17023020','Xarope de glicose cont.estado seco, peso<20% de frutose','Glucose syrup contan. dry state, by weight<20%fructose','Jarabe de glucosa c/cont.de fruct.sob.pr.seco<20%en p.',10,'17','1702','170230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17024010','Glicose contendo estado seco, 20%<=peso<50% de frutose','Glucose contan.dry state, 20%<=weight<50% of fructose','Glucosa c/cont.de fruct.sob.prod.seco 20%<=en peso<50%',10,'17','1702','170240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17024020','Xarope de glicose, cont.estado seco, 20%<=p<50% frutose','Glucose syrup contan.dry state, 20%<=weight<50%fructose','Jarabe gluc.c/cont.de fruct.sob.pr.seco 20%<=en p.<50%',10,'17','1702','170240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17025000','Frutose quimicamente pura','Chemically pure fructose','Fructosa químicamente pura',10,'17','1702','170250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17026010','Frutose contendo,no estado seco,peso>50% de frutose','Fructose contan.dry state, weight>50% of fructose','Fructosa c/cont.de fruct.sob.prod.seco, >50%en peso',10,'17','1702','170260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17026020','Xarope de frutose, cont.no estado seco, p>50% de frutose','Glucose syrup contan.dry state, weight>50%of fructose','Jarabe fruct.c/cont.de fruct.sob.prod.seco, >50%en peso',10,'17','1702','170260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17029000','Outros açúcares, xaropes de açúcares, sucedan.do mel, etc.','Other sugar, sugar syrup, honey substitute, etc','Los dem.azúcares, jarabes de azúc.sucedáneos de miel, etc',10,'17','1702','170290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17031000','Melaços de cana','Cane molasses','Melaza de caña',10,'17','1703','170310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17039000','Outros melaços da extração ou refinação do açúcar','Molasses resulting from the extraction or refining sug.','Las dem.melazas de la extracción o refinac.del azúcar',10,'17','1703','170390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17041000','Gomas de mascar, sem cacau, mesmo revestidas de açúcar','Chewing gums, without cocoa, whether or n/sugar-coated','Chicles, sin cacao, incluso recubiertos de azúcar',10,'17','1704','170410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17049010','Chocolate branco, sem cacau','White chocolate, not containing cocoa','Chocolate blanco, sin cacao',10,'17','1704','170490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17049020','Bombons, caramelos, confeitos e pastilhas, sem cacau','Chocolates, caramels, sweets, tablets, not containing cocoa','Bombones, caramelos, confites y pastillas, sin cacao',10,'17','1704','170490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('17049090','Outros produtos de confeitaria, sem cacau','Oth.products sugar confectionery, no cocoa','Los demás productos de confitería, sin cacao',10,'17','1704','170490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('18010000','Cacau inteiro ou partido, em bruto ou torrado','Cocoa (whole or broken), raw or roasted','Cacao entero o partido, crudo o tostado','21','18','1801','180100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('18020000','Cascas, películas e outros desperdícios de cacau','Cocoa shells, husks, skins and other cocoa waste','Cáscaras, películas y demás desechos de cacao',10,'18','1802','180200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('18031000','Pasta de cacau, não desengordurada','Cocoa paste, not defatted','Pasta de cacao, sin desgrasar','21','18','1803','180310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('18032000','Pasta de cacau, total ou parcialmente desengordurada','Cocoa paste, wholly or partly defatted','Pasta de cacao, desgrasada total o parcialmente','21','18','1803','180320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('18040000','Manteiga, gordura e óleo, de cacau','Butter, fat and oil, from cocoa','Manteca, grasa y aceite, de cacao','21','18','1804','180400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('18050000','Cacau em pó, sem adição de açúcar ou outros edulcorantes','Cocoa (powder),  without added sugar or other sweeteners','Cacao en polvo, s/adición de azúcar ni otro edulcorante','21','18','1805','180500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('18061000','Cacau em pó, com adição de açúcar ou outros edulcorantes','Cocoa powder, cont.added sugar or oth.sweetening matter','Cacao en polvo, con adición de azúcar o otr.edulcorantes',10,'18','1806','180610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('18062000','Outs.prepars.aliment.c/cacau, em blocos, barras, p>2kg, etc','Oth.prepar.in blocks, slabs, bars with cocoa, wei.>2kg, etc','Las dem.prep.alim.c/cacao, en bloques/barras c/p>2kg, etc',10,'18','1806','180620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('18063110','Chocolate recheado, em tabletes, barras e paus','Filled chocolate, in tablets, slabs or bars','Chocolate rellenos, en bloques, tabletas y barras',10,'18','1806','180631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('18063120','Outras prepars.aliment.c/cacau, rechead.em tabletes, etc.','Oth.food preparat..containing cocoa, filled, tablets, etc','Las dem.prep.aliment.c/cacao, rellenos, en tabletas, etc',10,'18','1806','180631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('18063210','Chocolate não recheado, em tabletes, barras e paus','Chocolate not filled, in tablets, slabs and bars','Chocolate sin rellenar, en bloques, tabletas y barras',10,'18','1806','180632');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('18063220','Outs.prepars.aliment.c/cacau, n/rechead.em tabletes, etc.','Oth.food prepar.containing cocoa, not filled, tablets, etc','Las dem.prep.alimenticias, s/rellenar en tabletas, etc',10,'18','1806','180632');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('18069000','Outros chocolates e preparações alimentícias contendo cacau','Other chocolate and  food preparations containing cocoa','Demás chocolates y prepar.alimenticias con cacao',10,'18','1806','180690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19011010','Leite modificado, para alimentação de crianças','Modified milk, preparations for infant use','Leche modificada, para la alimentación infantil',10,'19','1901','190110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19011020','Farinha láctea, para alimentação de crianças','Lactea flour, preparations for infant use','Harina lacteada, p/la aliment.infantil',10,'19','1901','190110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19011030','Preparações à base de farinha, semola, amido, para alimentação de crianças','Prep.basis of flours, meals or starch, for infant use','Preparación a base de harina, sémola, almidón, p/alim.inf.',10,'19','1901','190110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19011090','Outras preparações para alimentação de crianças','Other preparations for infant use','Las demás preparaciones para la alimentación infantil',10,'19','1901','190110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19012000','Misturas e pastas, p/prepar.prods.padaria, pastelaria, etc','Mixes and doughs for the preparation of baker, etc','Mezclas y pastas, p/prep.de pr.panadería, pastelaría, etc',10,'19','1901','190120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19019010','Extrato de malte','Malt extract','Extracto de malta',10,'19','1901','190190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19019020','Doce de leite','Cream with a basis of cooked milk with added sugar','Dulce de leche',10,'19','1901','190190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19019090','Outras preparações aliment.de farinhas, etc.cacau<40%','Other food preparations of flour, etc.cocoa<40%','Las dem.prepar.alimenticias de harina, etc, cacao<40%',10,'19','1901','190190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19021100','Massas alimentícias, cont.ovos, n/cozidas, n/recheadas, etc','Uncooked pasta, not stuffed, containing eggs','Pastas alimenticias, s/cocer n/rellenar, etc, q.cont.huevo',10,'19','1902','190211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19021900','Outras massas alimentícias, não cozidas, não recheada.etc.','Other uncooked pasta, not stuffed, etc.','Las dem.pastas alimenticias, sin cocer ni  rellenar,  etc',10,'19','1902','190219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19022000','Massas aliment.recheadas, incl.cozidas, prepars.out.modo','Stuffed pasta, incl.cooked, prepared another way','Pastas alim.rellenas, cocidas o preparadas de ot.forma',10,'19','1902','190220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19023000','Outras massas alimentícias','Other pasta','Las demás pastas alimenticias',10,'19','1902','190230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19024000','Couscous','Couscous','Cuscús',10,'19','1902','190240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19030000','Tapioca, seus sucedâneos, de féculas, em flocos, grumos, etc','Tapioca and substitutes therefor, from starch, flakes, etc','Tapioca, sus sucedáneos, c/féculas, en copos, grumos, etc',10,'19','1903','190300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19041000','Prods.à base de cereais, obtidos por expansao, torrefacao','Cereal products, obtained by the swelling or roasting','Productos a base de cereales, obt.por inflado o tostado',10,'19','1904','190410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19042000','Prepars.aliment.obtidas de flocos de cereais e misturas','Prepar.foods obtained from cereal flake and mixturures','Preparaciones aliment.obt.c/copos de cereales y mezclas',10,'19','1904','190420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19043000','Trigo burgol ("bulgur")','Bulgur wheat','Trigo bulgur',10,'19','1904','190430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19049000','Outros cereais em grãos, pre-cozidos, preparados de outro modo','Other cereal in grain,  pre-cooked or otherwise prepared','Los dem.cereales en grano, precocidos o prep.de ot.form',10,'19','1904','190490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19051000','Pão denominado "knackebrot"','Crispbread','Pan crujiente llamado knäckebrot',10,'19','1905','190510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19052000','Pão de especiarias','Gingerbread and the like','Pan de especias',10,'19','1905','190520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19052010','Panetone','Panettone','Pan dulce',10,'19','1905','190520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19052090','Outros pães de especiarias','Other gingerbread and the like','Los demás panes de especias',10,'19','1905','190520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19053010','Bolachas e biscoitos, adicionados de edulcorantes','Sweet biscuits, containing added sugar','Galletas dulces, con adición de edulcorantes',10,'19','1905','190530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19053090','"Waffles" e "wafers"','Waffles and waffers','Barquillos, obleas y waffles',10,'19','1905','190530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19053100','Bolachas e biscoitos, adicionados de edulcorantes','Sweet biscuits, containing sweetener added','Galletas dulces, con adición de edulcorantes',10,'19','1905','190531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19053200','"Waffles" e "wafers"','Waffles and wafers','Barquillos, obleas y waffles',10,'19','1905','190532');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19054000','Torradas, pão torrado e produtos semelhantes torrados','Rusks, toasted bread and similar toasted products','Pan tostado y productos similares tostados',10,'19','1905','190540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19059000','Outros produtos de padaria, pastelaria, indústria de biscoitos, etc','Other products of bakery, pastry shop, biscuits ind.etc','Los dem.productos de panadería, galletería, etc',10,'19','1905','190590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19059010','Pão de forma','Pan loaf','Pan de molde',10,'19','1905','190590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19059020','Bolachas','Cookies','Galletas',10,'19','1905','190590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('19059090','Outros produtos de padaria, pastelaria, indústria de biscoitos, etc','Other products of bakery, pastry shop, biscuits ind.etc','Demás produc. de panadería, pastelaría, galletería, etc',10,'19','1905','190590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20011000','Pepinos e pepininhos, prepars/conserv.vinagre, ac.acético','Cucumbers/gherkin, prep.preserv.vinegar or acetic acid','Pepinos y pepinillos, prep.o conserv.en vinagre/ác.acét.',10,'20','2001','200110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20012000','Cebolas preparadas, conservadas em vinagre, acido acético','Prepared onions, preserved by vinegar, acetic acid','Cebollas preparadas o conservadas en vinagre/ác.acético',10,'20','2001','200120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20019000','Outs.prods.horts, etc.prepars/conserv.vinagre, ac.acético','Oth.vegetables prod.etc.prep.preser.vinegar, acetic acid','Las dem.hortalizas, etc, prep.o conser.en vinagre/ác.acét',10,'20','2001','200190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20021000','Tomates inteiros ou pedaços, preparados ou conservados','Tomatoes, whole or in pieces, prepared or preserved','Tomates enteros o en trozos,  preparados o conservados',10,'20','2002','200210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20029010','Sucos de tomates','Tomatoe juice','Jugos de tomates',10,'20','2002','200290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20029090','Outs.tomates prepars.conservs.exc.em vinagre, ac.acético','Oth.tomatoes prep.preserved, exc.by vinegar/acetic acid','Los dem.tomates prepar.o conserv.exc.en vinagre/ác.acét',10,'20','2002','200290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20031000','Cogumelos preparados ou conservados','Mushrooms of the genus agaricus, prepared or preserved','Hongos preparados o conservados',10,'20','2003','200310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20032000','Trufas preparadas ou conservadas','Truffles, prepared or preserved','Trufas preparadas o conservadas',10,'20','2003','200320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20039000','Outros cogumelos, prepar.ou conserv.exc.vinagre','Mushrooms, prepared or preserved, exc.vinegar','Los dem.hongos, preparados o conservados exc.en vinagre',10,'20','2003','200390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20041000','Batatas preparadas ou conservadas, congeladas','Potatoes prepared or preserved, frozen','Patatas preparadas o conservadas, congeladas',10,'20','2004','200410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20049000','Outs.prods.horts.prepar/conserv.cong.exc.em vinagre, etc','Oth.veget.prod.prepared/preserved, froz.exc.vinegar, etc','Las dem.hortalizas prepar.o conserv.cong.exc.vinag.etc',10,'20','2004','200490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20051000','Prods.hortícolas homogen.prepars/conserv.n/congelados','Homogenized vegetables prod.prepared/preserved n/ froz.','Hortalizas homogeneizadas, prepar.o conserv.s/cong.',10,'20','2005','200510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20052000','Batatas preparadas ou conservadas, não congeladas','Potatoes prepared/preserved, not frozen','Patatas preparadas o conservadas, sin congelar',10,'20','2005','200520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20054000','Ervilhas preparadas ou conservadas, não congeladas','Pears prepared/preserved, not frozen','Guisantes preparados o conservados, sin congelar',10,'20','2005','200540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20055100','Feijao em grão, preparado ou conservado, não congelado','Beans in grain prepared/preserved, not frozen','Judías desvainadas, preparadas o conservadas, s/congelar',10,'20','2005','200551');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20055900','Outs.feijões prepars/conservs.n/cong.exc.em vinagre, etc','Oth.beans prepared/preserved, n/ froz.exc.vinager, etc.','Las dem.judías prepar.o conserv.exc.en vinagre, s/cong.',10,'20','2005','200559');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20056000','Aspargos preparados ou conservados, não congelados','Asparagus prepared/preserved, not frozen','Espárragos preparados o conservados, sin congelar',10,'20','2005','200560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20057000','Azeitonas preparadas/conserv.n/cong.exc.em vinagre, etc.','Olives prepared/preserved, n/ froz.exc.vinager, etc.','Aceitunas prepar.o conserv.exc.en vinagre, s/cong.etc',10,'20','2005','200570');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20058000','Milho doce, preparado ou conservado, não congelado','Sweet corn, prepared/preserved, not frozen','Maíz dulce, preparado o conservado, sin congelar',10,'20','2005','200580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20059000','Outs.prods.horts.prepars/conserv.n/cong.exc.vinagre, etc','Oth.vegetab.prepared/preserved, n/ froz.exc.vinager, etc.','Las dem.hortalizas prep.o cons.exc.en vinag.s/cong.etc',10,'20','2005','200590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20059100','Brotos de bambu ñ(cong.cons.)vin./ácid.acétic','Bambu shoots, not frozen, conserved in vinegar/acetic acid','Brotes de bambu, sin congelar, conservado en vinagre/ácido acético',10,'20','2005','200591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20059900','Outs.prod.hort.ñ cong./cons.vin./ác.acético','Other vegetable products, not frozen, conserved in vinegar/acid acetic','Otros productos vegetales, sin congelar, conservado en vinagre/ácido acético',10,'20','2005','200599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20060000','Prods.hortícolas, frutas e cascas, etc.conservs.em açúcar','Vegetables fruit, fruit-pee, etc.preserved by sugar','Las dem.hortalizas, frutas y cortezas, etc, confit.c/azúc.',10,'20','2006','200600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20071000','Prepars.homogen.de frutas, por cozimento, p/alim.crianças','Homogenised preparations of fruit, forcooked, forinfant use','Prepar.homogeneizadas de frut.obt.p/cocción, p/alim.inf.',10,'20','2007','200710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20079100','Doces, geléias, "marmelades", pures e pastas, de cítricos','Jams, fruit jellies, marmalad.purée and pastes, of citric','Confituras, jaleas, mermeladas, purés y pastas, de agrios',10,'20','2007','200791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20079910','Geléias e "marmelades", de outras frutas','Jellies, marmalades, of other fruits','Jaleas y mermeladas, de otros frutos',10,'20','2007','200799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20079990','Doces, pures e pastas, de outras frutas','Jams, purée, pastes, of other fruits','Confituras, purés y pastas, de otros frutos',10,'20','2007','200799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20081100','Amendoins preparados ou conservados','Ground-nuts prepared or preserved','Cacahuetes preparados o conservados',10,'20','2008','200811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20081900','Outras frutas de casca rija, outras.sementes, prepars/conserv','Other hard peel fruits, other seeds prepared/preserved','Las dem.frutas de cáscara, dem.semillas,  prep.o conserv.',10,'20','2008','200819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20082010','Abacaxis preparados ou conservados em água edulcorada, etc.','Pineapples prepared/preserved with sweetening water, etc','Piñas preparadas o conservadas en agua edulcorada,  etc',10,'20','2008','200820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20082090','Abacaxis preparados ou conservados de outro modo','Pineapples otherwise prepared or preserved','Piñas preparadas o conservadas de otra forma',10,'20','2008','200820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20083000','Cítricos preparados ou conservados','Citrus fruit prepared or preserved','Agrios preparados o conservados',10,'20','2008','200830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20084010','Pêras prepars/conservs.em água edulcorada, incl.xarope','Pears prepar./preser., sweetening water, incl.syrup','Peras prepar.o conserv.en agua edulcorada, inc.jarabe',10,'20','2008','200840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20084090','Pêras preparadas ou conservadas de outro modo','Pears otherwise prepared or preserved','Peras preparadas o conservadas de otra forma',10,'20','2008','200840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20085000','Damascos preparados ou conservados','Apricots, prepared or preserved','Albaricoques preparados o conservados',10,'20','2008','200850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20086010','Cerejas prepars/conservs.em água edulcorada, inclusive xarope','Cherries, prepared/preserved, sweetening water, incl.syrup','Cerezas prepar.o conserv.en agua edulcorada, inc.jarabe',10,'20','2008','200860');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20086090','Cerejas preparadas ou conservadas de outro modo','Cherries, otherwise prepared or preserved','Cerezas preparadas o conservadas de otra forma',10,'20','2008','200860');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20087010','Pêssegos prepars/conserv.em água edulcorada, inclusive xarope','Peaches, prepared/preserved, sweetening water, incl.syrup','Duraznos prepar.o conserv.en agua edulcorada, incluso jarabe',10,'20','2008','200870');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20087020','Pêssegos prepars/conserv.em água, com valor brix >= 20','Peaches prepared/preserved in water, brix value > = 20','Duraznos prepa./conservados en agua, de valor Brix>= 20',10,'20','2008','200870');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20087090','Pêssegos preparados ou conservados de outro modo','Peaches, otherwise prepared or preserved','Duraznos preparados o conservados de otra forma',10,'20','2008','200870');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20088000','Morangos preparados ou conservados','Strawberries, prepared or preserved','Fresas preparadas o conservadas',10,'20','2008','200880');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20089100','Palmitos preparados ou conservados','Palm heart, prepared or preserved','Palmitos preparados o conservados',10,'20','2008','200891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20089210','Misturas de frutas preparadas, conservs.em água edulcora','Mixtures of fruits, prepared or preserved','Mezclas de frutas prepar.o conserv.en agua edulcorada',10,'20','2008','200892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20089290','Misturas de frutas preparadas, conservadas de outro modo','Mixtures of fruits, otherwise prepared or preserved','Mezclas de frutas preparadas,  conservadas de otra forma',10,'20','2008','200892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20089300','Airelas vermelhas, preparadas ou conserv. de outro modo','Cranberry red, prepared or preserved in other forms','Arándano rojo, preparadas y conservadas de otra forma',10,'20','2008','200893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20089710','Misturas de frutas prep. em agua edulcorada,incl.coran.','Mixtures of fruits, prepared in water sweetened','Mezclas de frutas, preparadas en agua edulcorada',10,'20','2008','200897');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20089790','Misturas de frutas preparadas,conservadas de outro modo','Mixtures of prepared fruit, otherwise preserved','Mezclas de fruta preparadas, conservadas de otro modo',10,'20','2008','200897');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20089900','Outs.frutas, partes de plantas, prepars/conservs.out.modo','Fruit and other parts of plants, otherwise prepar/preser','Las dem.frutas, part.de plantas, prepar.o cons.de ot.modo',10,'20','2008','200899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20091100','Sucos de laranjas, congelados, não fermentados','Frozen/unfermented, orange juice','Jugo de naranja, congelado, sin fermentar',10,'20','2009','200911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20091200','Sucos de laranja não congelados com valor brix<=20','Orange juice, not frozen, brix value <= 20','Jugo de naranja, sin congelar, con valor brix <= 20',10,'20','2009','200912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20091900','Outros sucos de laranjas, não fermentados','Other unfermented, orange juice','Los demás jugos de naranjas,  sin fermentar',10,'20','2009','200919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20092000','Sucos de pomelos ("grapefruit"), não fermentados','Grapefruit juice, unfermented','Jugo de pomelo ("grapefruit"),  sin fermentar',10,'20','2009','200920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20092100','Suco de pomelo com valor brix <= 20','Grapefruit juice, of a brix value <= 20','Jugo de pomelo con valor brix <= 20',10,'20','2009','200921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20092900','Outros sucos de pomelo','Other grapefruit juice','Los demás jugos de pomelo',10,'20','2009','200929');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20093000','Sucos de outros cítricos, não fermentados','Other citric juices, unfermented','Jugos de demás agrios, sin fermentar',10,'20','2009','200930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20093100','Suco de outros cítricos com valor brix <= 20','Other citric juice of a brix value <= 20','Jugo de demás agrios con valor brix <= 20',10,'20','2009','200931');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20093900','Outros sucos de outros cítricos','Other juice of other citric','Los demás jugos de demás agrios',10,'20','2009','200939');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20094000','Sucos de abacaxis (ananases), não fermentados','Pineapple juices, unfermented','Jugo de piña, sin fermentar',10,'20','2009','200940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20094100','Suco de abacaxi com valor brix <= 20','Pineapple juice of a brix value <= 20','Jugo de piña con valor brix <= 20',10,'20','2009','200941');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20094900','Outros sucos de abacaxi','Other pineapple juices','Los demás jugos de piñas',10,'20','2009','200949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20095000','Sucos de tomates, não fermentados','Tomato juices, unfermented','Jugo de tomate, sin fermentar',10,'20','2009','200950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20096000','Sucos de uvas (incl.os mostos de uvas), não fermentados','Grape juice, unfermented','Jugo de uva, (incluso el mosto) sin fermentar',10,'20','2009','200960');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20096100','Suco de uvas com valor brix <= 30','Grape juice of a brix value <= 30','Jugo de uva con valor brix <= 30',10,'20','2009','200961');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20096900','Outros sucos de uvas','Other grape juices','Los demás jugos de uva',10,'20','2009','200969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20097000','Sucos de maçãs, não fermentados','Apple juices, unfermented','Jugo de manzana, sin fermentar',10,'20','2009','200970');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20097100','Suco de maçã com valor brix <= 20','Apple juice of a brix value <= 20','Jugo de manzana con valor brix <= 20',10,'20','2009','200971');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20097900','Outros sucos de maçã','Other apple juices','Los demás jugos de manzana',10,'20','2009','200979');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20098000','Sucos de outras frutas, produtos hortícolas, não fermentados','Juices of any other single fruit/vegetable unfermented','Jugos de demás frutas, hortalizas, sin fermentar',10,'20','2009','200980');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20098100','Suco (sumo) de airela vermelha','Juice of cranberry red','Jugo (sumo) de arándano rojo',10,'20','2009','200981');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20098900','Sucos (sumo) de outras frutas,n/fermen.s/adição de açú','Juice of other fruits, not fermented, not sweetened','Jugo (sumo) de otras frutas,sin fermentar, sin endulzar',10,'20','2009','200989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20098910','Suco (sumo) de pêssego, com valor brix >= 60','Juice of peach, brix value >= 60','Jugo (zumo) de durazno, de valor Brix >= 60',10,'20','2009','200989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20098990','Sucos (sumo) de outras frutas,n/fermen.s/adição de acú.','Other fruit juice, unfermented, without added sugar','Jugo de otras frutas, sin fermentar, sin adición azúcar',10,'20','2009','200989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('20099000','Misturas de sucos, não fermentados','Mixtures of juices, unfermented','Mezclas de jugos, sin fermentar',10,'20','2009','200990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21011110','Café solúvel, mesmo descafeinado','Soluble coffee, including decaffeinated','Café soluble, incluso descafeinado','21','21','2101','210111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21011190','Outros extratos, essências e concentrados, de café','Other extracts, essences and concentrates, of coffee','Los demás extractos,  esencias y concentrados,  de café','21','21','2101','210111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21011200','Preparações à base de extratos, essências, concentrados, de café','Preparations with a basis of these extracts, ess./conc.of coffee','Preparaciones a base de extractos, esencias, concentrados, de café','21','21','2101','210112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21012010','Extratos, essências, concentrados e suas preparações, de chá','Extracts, essences and concentrates, of tea','Extractos, esencias, concentrados y sus prepar.de té',10,'21','2101','210120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21012020','Extratos, essências, concentrados e suas preparações, de mate','Extracts, essences and concentrates, of mate','Extractos, esencias, concentr.y sus prepar.de yerba mate',10,'21','2101','210120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21013000','Chicoria torrada, outros sucedâneos torrados do café, etc','Roasted chicory and other roasted coffee substitute, etc','Achicoria tostada, dem.sucedáneos del café tostados, etc',10,'21','2101','210130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21021000','Leveduras vivas','Active yeasts','Levaduras vivas',10,'21','2102','210210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21021010','Leveduras vivas "saccharomyces boulardii"','Leveduras vivas "saccharomyces boulardii"','Leveduras vivas "saccharomyces boulardii"',10,'21','2102','210210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21021090','Outras leveduras vivas','Outras leveduras vivas','Outras leveduras vivas',10,'21','2102','210210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21022000','Leveduras mortas, outros microorgan.monocelulares mortos','Inactive yeasts;other single-cell micro-organisms, dead','Levaduras muertas, dem.microorganism.monocelulares muert',10,'21','2102','210220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21023000','Pós para levedar, preparados','Prepared baking powders','Polvos de levantar preparados',10,'21','2102','210230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21031010','Molhos de soja, preparados, embalagens imediatas, p<=1kg','Soya sauce, prepared, immediate packings, weighing<=1kg','Salsa de soja, prepar.envases inmediatos, de cont.<=1kg',10,'21','2103','210310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21031090','Outros molhos de soja, preparados','Other soya sauce, prepared','Las demás salsas de soja,  preparadas',10,'21','2103','210310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21032010','Ketchup e outros molhos de tomate, embal.imediat.p<=1kg','Tomato ketchup and other tomato sauces immed.pac.w<=1kg','"ketchup" y dem.sals.de tomate, env.inmed.de cont.<=1kg',10,'21','2103','210320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21032090','Outros "ketchup" e molhos de tomate, preparados','Other tomato ketchup and other tomato sauces, prepared','Los dem."ketchup" y salsas de tomates,  preparados',10,'21','2103','210320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21033010','Farinha de mostarda','Mustard flour','Harina de mostaza',10,'21','2103','210330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21033021','Mostarda preparada, em embalagens imediatas, peso<=1kg','Mustard prepared, in immediate packings wei.<=1kg','Mostaza preparada, en envases inmediatos, de cont.<=1kg',10,'21','2103','210330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21033029','Outras mostardas preparadas','Other prepared mustard','Las demás mostazas preparadas',10,'21','2103','210330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21039011','Maionese em embalagens imediatas, peso<=1kg','Mayonnaise immediate packings, weighing<= 1kg','Mayonesa en envases inmediatos,  con peso <= 1kg',10,'21','2103','210390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21039019','Outras maioneses','Other mayonnaise','Las demás mayonesas',10,'21','2103','210390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21039021','Condimentos e temperos, compostos, embalag.imediat.p<=1kg','Condiments/mixed seasonings, comp., immed.pack.w<=1kg','Condimentos y sazonadores, comp.env.inmed.de cont.<=1kg',10,'21','2103','210390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21039029','Outros condimentos e temperos, compostos','Other condiments and mixed seasonings, composed','Los dem.condimentos y sazonadores,  compuestos',10,'21','2103','210390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21039091','Outs.prepars.p/molhos, molhos prepars.embal.imed.p<=1kg','Other sauces preparations, sauce prep.immed.pac.wei<=1kg','Las dem.prep.p/salsas, salsas prep.env.inm.de cont.<=1kg',10,'21','2103','210390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21039099','Outras preparações para molhos e molhos preparados','Other sauces preparations and sauce prepared','Las dem.preparaciones para salsas y salsas preparadas',10,'21','2103','210390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21041011','Preparações para caldos e sopas, embalagens imediatas, p<=1kg','Preparations soups and broths, immed.pac.wei.<=1kg','Preparaciones p/sopas, pot.caldos, env.inmed.de cont<=1kg',10,'21','2104','210410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21041019','Outras preparações para caldos e sopas','Other preparations for soups and broths','Las demás preparaciones para sopas, potajes o caldos',10,'21','2104','210410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21041021','Caldos e sopas, preparados, embalagens imediatas, p<=1kg','Soups and broths, prepared, immed.pack.wei.<=1kg','Sopas, potajes, caldos prepar.env.inmediatos, c/cont.<=1kg',10,'21','2104','210410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21041029','Outros caldos e sopas, preparados','Other soups and broths, prepared','Los demás sopas, potajes o caldos, preparados',10,'21','2104','210410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21042000','Preparações alimentícias compostas, homogeneizadas','Homogenised composite food preparations','Preparaciones alimenticias compuestas,  homogeneizadas',10,'21','2104','210420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21050010','Sorvetes, mesmo contendo cacau, embalagens imediatas, p<=2kg','Ice cream, whether or n/contain.cocoa, immed.pack.w<=2kg','Helados, incluso c/cacao, env.inmediatos, de cont.<=2kg',10,'21','2105','210500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21050090','Outros sorvetes, mesmo contendo cacau','Other ice cream, even containing cocoa','Los demás helados, incluso con cacao',10,'21','2105','210500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21061000','Concentrados de proteínas, substs.proteicas texturizadas','Protein concentrates and textured protein substances','Concentrados de proteín.sustancias proteicas texturadas',10,'21','2106','210610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21069010','Outras preparações para elaboração de bebidas','Other preparations for elaboration of drinks','Las demás preparaciones para la elabor.de bebidas',10,'21','2106','210690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21069021','Pós para preparações de pudins, embalagens imediatas, p<=1kg','Powder forpreparations of puddings, immed.pack.wei.<=1kg','Prep.p/la fabric.de budines en env.inmed.de cont.<=1kg',10,'21','2106','210690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21069029','Pós p/prepars.de cremes, sorvetes, gelatinas, flans, etc.','Powder forpreparations of cream, ice cream, jelly, etc.','Prep.p/la fabric.de cremas, helados, gelatinas, flanes, etc',10,'21','2106','210690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21069030','Complementos alimentares','Alimentary complements','Complementos alimenticios',10,'21','2106','210690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21069040','Misturas à base de ascorbato sódio, glucose, para embutidos','Mixtures with a basis of sodium ascorbate/glucose forpre','Mezclas a base de ascorbato de sodio, glucosa, p/chacinad',10,'21','2106','210690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21069050','Gomas de mascar, sem açúcar','Chewing gum, without sugar','Chicles, sin azúcar',10,'21','2106','210690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21069060','Caramelos, confeitos, pastilhas e prod.semelhantes,s/açúcar','Caramels, sweets, tablets and similar prod., ithout sugar','Caramelos, confites, pastillas y productos simil.s/azúcar',10,'21','2106','210690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('21069090','Outras preparações alimentícias','Other food preparations','Las demás preparaciones alimenticias',10,'21','2106','210690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22011000','Água mineral/gaseif.n/adicion.açúcar, n/aromatizada, etc.','Mineral waters/aerated waters n/ad.sug.n/flavoured, etc','Agua mineral/gaseada, s/adición de azúcar ni aromat.etc',17,'22','2201','220110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22019000','Outras águas, sem açúcar, n/aromatizadas, etc.gelo e neve','Other waters n/add.sug.n/flavoured, etc.ice/snow','Las dem.aguas, s/adic.azúcar ni aromat.etc, hielo y nieve',17,'22','2201','220190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22021000','Água incl.mineral/gaseif.adicion.açúcar, aromatizada, etc','Waters, incuding mineral/aerated, ad.sugar, flavoured, etc','Agua inc.el agua min/gasead.c/adic.de azúcar o arom.etc',17,'22','2202','220210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22029000','Outras bebidas não alcoólicas, exceto suco frutas, produtos hortícolas','Non-alcoholic beverages (excl.water, fruit/veget.juice)','Las dem.bebidas no alcohólicas, exc.jugos de frutas, hort',17,'22','2202','220290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22030000','Cervejas de malte','Beer made from malt','Cervezas de malta',17,'22','2203','220300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22041010','Vinhos de uvas frescas, tipo champanha ("champagne")','Wine of fresh grapes, "champagne" type','Vinos de uvas frescas, tipo cava (champaña)',17,'22','2204','220410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22041090','Outros vinhos de uvas frescas, espumantes e espumosos','Other wine of fresh grapes and sparkling','Los demás vinos de uvas frescas, cavas y vinos espumosos',17,'22','2204','220410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22042100','Outros vinhos, mostos de uvas, ferm.imped.álcool, recips<=2l','Other wine, grape must, fermen.alcohol containers<=2l','Los dem.vin.most.uv.en q.fer.se ha imp.añ.al.rec.c.<=2l',17,'22','2204','220421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22042900','Outros vinhos, mostos de uvas, ferm.imped.por adicao alco','Other wine, grape must, fermented to added alcohol','Los dem.vinos, most.de uvas, en q.ferm.se ha imp.añad.alc',17,'22','2204','220429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22042911','Vinhos em recipientes de capacidade não superior a 5 litros','Wines in containers with capacity not over 5 liters','Vinos en envases de capacidad no superior a 5 litros',17,'22','2204','220429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22042919','Vinhos em recipientes de capacidade superior a 5 litros','Wines in containers with capacity over 5 liter','Vinos en envases de capacidad más de 5 litros',17,'22','2204','220429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22042920','Mostos','Grape must','Mostos de uvas',17,'22','2204','220429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22043000','Outros mostos de uvas','Other grape must','Los demás mostos de uvas',17,'22','2204','220430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22051000','Vermutes, outros vinhos uvas frescas, aromatiz.recip.<=2l','Vermouth, other wine of fresh grapes flavoured cont.<=2l','Vermut, dem.vinos de uvas frescas, aromat.en recip.<=2l',17,'22','2205','220510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22059000','Outros vermutes e vinhos de uvas frescas, aromatizados','Oth.vermouth and other wine of fresh grapes, flavoured','Los dem.vermutes y vinos de uvas frescas,  aromatizados',17,'22','2205','220590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22060010','Sidra','Cider','Sidra',17,'22','2206','220600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22060090','Outras bebidas fermentadas e misturas de bebidas fermentadas','Oth.ferm.beverages and mixtures of ferm.beverages','Demás bebidas fermentadas y mezclas de bebidas ferm.',17,'22','2206','220600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22071000','Álcool etílico n/desnaturado c/vol.teor alcoólico>=80%','Undenatured ethyl alcohol of an alcoholic cont.>=80%vol','Alcohol etílico s/desnaturalizar c/grado alcohól.>=80%',17,'22','2207','220710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22071010','Álcool etílico n/desnaturado c/teor água <= 1% vol','Ethyl alcohol, not undenatured, water content<=1%','Alcohol etílico sin desnaturalizar, a<= 1% del volumen',17,'22','2207','220710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22071090','Outros álcool etílico não desnaturado','Other ethyl alcohol, not undenatured','Outro alcohol etílico, sin desnaturalizar',17,'22','2207','220710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22072010','Álcool etílico desnaturado c/qq.teor alcoólico','Ethyl alcohol, denatured, of any strength','Alcohol etílico desnaturalizado de cualquier graduación',17,'22','2207','220720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22072011','Álcool etilico com teor água <= 1% volume','Ethyl alcohol with water content <= 1% volume','Alcohol etílico con contenido de agua <= 1% del volumen',17,'22','2207','220720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22072019','Outros álcool etílico desnaturado','Other ethyl alcohol, undenatured','Otro alcohol etílico, desnaturalizado',17,'22','2207','220720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22072020','Aguardente desnaturado com qualquer teor alcoólico','Spirits, denatured, of any strength','Aguardiente desnaturalizado de cualquier graduación',17,'22','2207','220720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22082000','Aguardente de vinho ou de bagaço de uvas','Spirits obtained by distilling grape wine or grape marc','Aguardiente de vino o de orujo de uvas',17,'22','2208','220820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22083010','Uísques, vol.teor alcoólico>50%, recips.capac>=50 litros','Whiskies, alcoholic content>50%vol, in container cap>=50l','Whisky c/grado alcohólico volum.>50%, en rec.c/cap>=50l',17,'22','2208','220830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22083020','Uísques, embalagens de capacidade <= 2 litros','Whiskies, capacity container <= 2 L','Whisky, en recipientes con capacidad <= 2 L',17,'22','2208','220830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22083090','Outros uísques','Other whiskies','Los demás whiskies',17,'22','2208','220830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22084000','Cachaça e caninha (rum e tafia)','Rum and tafia','Ron y aguardiente de caña',17,'22','2208','220840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22085000','Gim e genebra','Gin and geneva','Gin y ginebra',17,'22','2208','220850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22086000','Vodca','Vodka','Vodka',17,'22','2208','220860');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22087000','Licores','Liqueurs','Licores',17,'22','2208','220870');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22089000','Outras bebidas alcoólicas','Other alcohol drinks','Las demás bebidas alcohólicas',17,'22','2208','220890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('22090000','Vinagres e sucedan.obtidos acid.acético, p/uso alimentar','Vinegar and subst.forvineg.obt.acetic acid, forhuman cons.','Vinagre y sucedáneos obt.a partir del ác.acét.p/uso al.',17,'22','2209','220900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23011010','Farinhas, pós e "pellets" de carne, impróprio para alimentação humana','Flours, meals and pellets, of meat, unfit forhuman consump.','Harinas, polvos y"pellets" de carne, impropios p/alim.hum',10,'23','2301','230110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23011090','Farinha de miudezas, impropr.p/alim.humana e torresmos','Flours, meat offal/greaves, unfit forhuman consumption','Harinas de despojos, impropios p/alim.hum.y chicharrones',10,'23','2301','230110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23012010','Farinhas, pós, "pellets" de peixes, improprs.p/alim.humana','Flours, meals and pellets, of fish, unfit forhuman consup.','Harina, polvo, pellets de pescado, improp.p/alim.hum.',10,'23','2301','230120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23012090','Farinhas, pós, de crustáceos, etc.impróprios para alimentação humana','Flours/meals/pellets, of crustaceans, unfit forhum.consup.','Harinas, polvos, pellets de crustáceos, impr.p/alim.hum.',10,'23','2301','230120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23021000','Sêmeas, farelos e outros resíduos, de milho','Bran, sharps and other residues, of maize','Salvados, moyuelos y dem.residuos del cernido, de maíz',10,'23','2302','230210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23022010','Farelo de arroz','Sharps of rice','Moyuelo de arroz',10,'23','2302','230220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23022090','Sêmeas e outros resíduos, de arroz','Bran and other residues, of rice','Salvados y demás residuos del cernido, de arroz',10,'23','2302','230220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23023010','Farelo de trigo','Sharps of wheat','Moyuelos de trigo',10,'23','2302','230230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23023090','Sêmeas e outros resíduos, de trigo','Bran and other residues, of wheat','Salvados y demás residuos del cernido, de trigo',10,'23','2302','230230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23024000','Sêmeas, farelos e outros resíduos, de outros cereais','Bran, sharps and other residues, of other cereals','Salvados, moyuelos y dem.resid.del cern.de dem.cereales',10,'23','2302','230240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23025000','Sêmeas, farelos e outros resíduos, de leguminosas','Bran, sharps and other residues, of leguminous plants','Salvados, moyuelos y dem.resid.del cern., de leguminosas',10,'23','2302','230250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23031000','Resíduos da fabricação do amido e resíduos semelhantes','Residues of starch manufacture and similar','Residuos de la industria del almidón y residuos simil.',10,'23','2303','230310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23032000','Polpas, bagaços e outros desperdícios da indústria do açúcar','Pulp, bagasse and other waste of sugar manufacture','Pulpas, bagazos y dem.desperdicios de industr.azucarera',10,'23','2303','230320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23033000','Borras e desperdícios da indústria da cerveja e das destilarias','Brewing or distilling dregs and waste','Heces y desperdicios de cervecería y de destilería',10,'23','2303','230330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23040010','Farinhas e "pellets", da extração do óleo de soja','Flours and pellets, from the extraction of soya-bean oil','Harinas y pellets, de la extracción del aceite de soja','21','23','2304','230400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23040090','Bagaços e outros resíduos sólidos, da extração do óleo de soja','Soybean waste, solid','Tortas y dem.resid.sólidos, de extr.del aceite de soja','21','23','2304','230400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23050000','Tortas e outros resíduos sólidos, do amendoim','Oil-cake and other solid residues, of peanut','Tortas y demás residuos sólidos, del aceite de cacahuete',10,'23','2305','230500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23061000','Tortas e outros resíduos sólidos, do algodão','Oil-cake and other solid residues, of the cotton','Tortas y dem.residuos sólidos, de la semilla de algodón',10,'23','2306','230610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23062000','Tortas e outros resíduos sólidos, da linhaça','Oil-cake and other solid residues, of linseed','Tortas y demás residuos sólidos, de lino',10,'23','2306','230620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23063010','Tortas, farinhas e "pellets", do girassol','Oil-cake, flour and pellets, sunflower seeds','Tortas, harinas y pellets, de girasol',10,'23','2306','230630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23063090','Outros resíduos sólidos, do girassol','Other solid residues, of sunflower seeds','Los demás residuos sólidos, de girasol',10,'23','2306','230630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23064000','Tortas, outros resids.sólidos, do nabo silvestre, da colza','Oil-cake and other solid residues, of rape, of colza','Tortas, dem.resid.sólidos, de nabina, de colza',10,'23','2306','230640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23064100','Torta de nabo silvestre ou colza, baixo teor','Oil-cake of low erucic acid rape or colza seeds','Torta de nabina o de colza, con bajo contenido',10,'23','2306','230641');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23064900','Outras tortas de nabo silvestre ou colza','Other oil-cake of low erucic acid rape or colza seeds','Las demás tortas de nabina o colza',10,'23','2306','230649');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23065000','Tortas e outros resíduos sólidos, do coco ou da copra','Oil-cake and other solid residues, of coconut or copra','Tortas de demás residuos sólidos,  de coco o de copra',10,'23','2306','230650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23066000','Tortas e outros resíduos sólidos, de nozes ou de "palmiste"','Oil-cake and other solid residues, of palm nuts/kernels','Tortas de dem.resid.sólidos, de nuez o de alm.de palma',10,'23','2306','230660');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23067000','Tortas e outros resíduos sólidos, do germe de milho','Oil-cake and other solid residues, of maize germ','Tortas y demás residuos sólidos, de germen de maíz',10,'23','2306','230670');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23069000','Outs.tortas e resid.sólidos da extr.gordura/óleos veget','Obter oil-cake/ot.solid res.result.from extr.veg.fats/oil','Las dem.tortas y resid.sól.de extr.de mat.gras.y ac.veg',10,'23','2306','230690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23069010','Tortas, resíduos, etc. de germe de trigo','Oil cake, residues, etc, of wheat germ','Tortas, residuos, etc, de germen de trigo',10,'23','2306','230690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23069090','Tortas, res.etc, d/ext.d/outs.óleos vegetais','Oil cake, residues, etc, of other vegetable oils','Tortas, residuos, etc, de otros aceites vegetales',10,'23','2306','230690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23070000','Borras de vinho e tártaro em bruto','Wine lees and argol','Heces de vino y tártaro bruto',10,'23','2307','230700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23080000','Matérias vegetais e desperdícios de outros vegetais','Vegetable materials and other vegetable waste','Materias vegetales y desperdicios de demás vegetales',10,'23','2308','230800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23081000','Bolotas de carvalho e castanhas-da-india,  para alimentação animal','Acorns of oak and chestnut-from-indian, foranimal cons.','Bellotas y castañas de indias, p/la alim.animal',10,'23','2308','230810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23089000','Matérias, desperdícios, resids.etc.vegetais,  para alimentação animal','Vegetable materials, waste, residues, etc.for animal consum.','Materias, desperdicios, residuos, etc, veg.p/alim.de anim.',10,'23','2308','230890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23091000','Alimentos para cães e gatos','Food for dogs and cats','Alimentos para perros y gatos',10,'23','2309','230910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23099010','Alimentos compostos completos, para animais','Complete/composed foods, for animals','Alimentos compuestos completos, para animales',10,'23','2309','230990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23099020','Preparações à base de sal iodado, etc.p/aliment.animal','Preparations with a basis of iodized salt, etc.foranim.fe','Preparaciones a base de sal yodada, etc, p/alim.de anim.',10,'23','2309','230990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23099030','Bolachas e biscoitos, para alimentação de animais','Biscuits, for animal feeding','Galletas para la alimentación de los animales',10,'23','2309','230990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23099040','Preparações cont.diclazuril, util.na aliment.de animais','Preparations containing diclazuril, for animal feeding','Preparaciones q.contengan diclazuril, p/la alim.de anim.',10,'23','2309','230990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23099050','Prepar c/cloridrato de ractopamina =>2%.c/sup far.soja','Preparations with ractopamine hydrochloride =>2%','Preparaciones con clorhidrato de ractopamina => 2%',10,'23','2309','230990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23099060','Preparações contendo xilanase e betagluconase,  com suporte de farinha de trigo','Preparations containing xylanase and betagluconase, with support of wheat flour','Los preparados que contengan xilanasa y betagluconase, con apoyo de trigo',10,'23','2309','230990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('23099090','Outras preparações para alimentação de animais','Other preparations for animal feeding','Las dem.preparaciones p/la alimentación de los animales',10,'23','2309','230990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24011010','Fumo n/manufat.n/destalado, em folhas, s/secar, n/ferment.','Unman.tobac.n/stem./stripped, leaves, wit.drying, unfer','Tabaco sin elaborar ni desvenar, en ramas, s/secar n/ferm',10,'24','2401','240110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24011020','Fumo n/manufat.n/destal.em fls.secas, etc.tipo capeiro','Unman.wrapper tobacco n/stemmed, n/stripped, leaves, etc','Tabaco s/elaborar n/desvenar, en ramas secas, etc, tip.cap',10,'24','2401','240110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24011030','Fumo n/manufat.n/destal.em fls.secas, etc.tipo virgínia','Unman.tobacco n/stem.n/stripped, leaves, etc.virgin.type','Tabaco s/elaborar n/desvenar, en ramas secas, etc, tip.vir',10,'24','2401','240110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24011040','Fumo n/manufat.n/destal.em fls.secas, etc.tipo turco','Unman.tobacco n/stem.n/stripped, leaves, etc.turkish type','Tabaco s/elaborar n/desvenar, en ramas secas, etc, tip.tur',10,'24','2401','240110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24011090','Outros fumos não manufaturados, não destalados','Other unman.tobacco, not stemmed, not stripped','Los dem.tabacos s/elaborar ni desvenar o desnervar',10,'24','2401','240110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24012010','Fumo n/manuf.total/parc.destal.em fls.s/secar, n/fermen.','Unman.tobac.part./whol.stem./strip., leav.wit.dryin.unf','Tabaco s/elab.total/parc.desven.en ramas s/secar n/ferm',10,'24','2401','240120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24012020','Fumo n/manuf.total/parc.destal.fls.secas, fermen.capeiro','Unman.wrap.tobac.part./whol.stem./strip., leav.dryin.fer','Tabaco s/elab.total/parc.desven.en ramas secas, ferm.cap',10,'24','2401','240120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24012030','Fumo n/manuf.total/parc.destal.fls.secas, etc.virgínia','Unman.tobac.partly/wholly stem./strip.leav.dr., etc.vir','Tabaco s/elab.total/parc.desven.en ramas secas, etc, virg',10,'24','2401','240120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24012040','Fumo n/manuf.total/parc.destal.fls.secas,  tipo "burley"','Unman.tobac.part./whol.stem./strip.leaves, dr.burley','Tabaco s/elab.total/parc.desv.en ramas secas, tip.burl.',10,'24','2401','240120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24012090','Outros fumos nao manufaturad.total/parcialm.destalados','Other unman.tobacco partly/wholly stemmed/stripped','Los dem.tabacos s/elab.total/parc.desvenados o desnerv.',10,'24','2401','240120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24013000','Desperdícios de fumo','Tobacco refuse','Desperdicios de tabaco',10,'24','2401','240130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24021000','Charutos e cigarrilhas, de fumo','Cigars, cheroots and cigarillos, containing tobacco','Cigarros puros y cigarritos, de tabaco','12','24','2402','240210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24022000','Cigarros de fumo','Cigarettes containing tobacco','Cigarrillos de tabaco','12','24','2402','240220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24029000','Charutos, cigarrilhas e cigarros, de sucedâneos do fumo','Cigars/cheroots/cigarillos/cigarettes, of tobacco subst.','Cig.puros, cigarritos y cigarrillos, de sucedáneos de tab','12','24','2402','240290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24031000','Fumo manufaturado, para fumar, mesmo contendo sucedâneos do fumo','Manufactured tobacco, forsmoking, cont.tobac.subst.or not','Tabaco elaborado, p/fumar, inc.c/sucedáneos de tab.',10,'24','2403','240310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24031100','Tabaco para narguile, menc.na nota 1 da subposição 2403','Tobacco for narghile (note 1 heading 2403)','Tabaco para narguile (nota 1 partida 2403)',10,'24','2403','240311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24031900','Outros tabacos para fumar','Other tobacco for smoking','Demás tabacos para fumar',10,'24','2403','240319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24039100','Fumo manufaturado, "homogeneizado" ou "reconstituido"','Manufactured tobacco, ''homogenised'' or ''reconstituted''','Tabaco elaborado, homogeneizado o reconstituido',10,'24','2403','240391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24039910','Extratos e molhos, de fumo','Extractos y jugos, de tabaco','Extractos y jugos, de tabaco',10,'24','2403','240399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('24039990','Outros produtos do fumo e seus sucedâneos, manufaturados','Other manufactured tobacco and manufactured tobacco sub','Los dem.tabacos y sus sucedáneos, elaborados',10,'24','2403','240399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25010011','Sal marinho, a granel, sem agregados','Salt in bulk, without attachés','Sal marina, a granel, sin agregados',10,'25','2501','250100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25010019','Outros tipos de sal a granel, sem agregados','Other types of salt in bulk, without attachés','Los demás tipos de sal a granel, sin agragados',10,'25','2501','250100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25010020','Sal de mesa','Table salt','Sal de mesa',10,'25','2501','250100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25010090','Outros tipos de sal, cloreto de sódio puro e água do mar','Other salt types, pure sodium chloride and sea water','Los dem.tip.de sal, cloruro de sodio puro y agua de mar',10,'25','2501','250100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25020000','Piritas de ferro não ustuladas','Unroasted iron pyrites','Piritas de hierro sin tostar',10,'25','2502','250200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25030010','Enxofre a granel, exceto sublimado, precipitado ou coloidal','Sulphur in bulk, exc.sublimed, precipitated or colloidal','Azufre de cualq.clase, exc.el sublim.precip.o coloidal',10,'25','2503','250300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25030090','Outs.formas de enxofre, exceto sublimado, precipit.coloidal','Oth.forms of sulphur, exc.sublimed, precipitat.colloidal','Las dem.formas de azufre, exc.el sublim.precip.coloidal',10,'25','2503','250300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25041000','Grafita natural em pó ou em escamas','Natural graphite, in powder or in flakes','Grafito natural en polvo o en escamas',10,'25','2504','250410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25049000','Outras formas de grafita natural','Other forms of natural graphite','Las demás formas de grafito natural',10,'25','2504','250490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25051000','Areias silíciosas e areias quartzosas','Silica sands and quartz sands','Arenas silíceas y arenas cuarzosas',10,'25','2505','250510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25059000','Outras areias naturais, mesmo coradas','Other natural sands, including coloured','Las demás arenas naturales, incluso coloreadas',10,'25','2505','250590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25061000','Quartzo','Quartz','Cuarzo',10,'25','2506','250610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25062000','Quartzitos, em bruto ou desbastados','Quartzite, crude or roughly trimmed','Cuarcita, en bruto o desbastados',10,'25','2506','250620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25062100','Quartzitos em bruto ou desbastados','Quartzite, crude or roughly trimmed','Cuarcita, en bruto o desbastados','16','25','2506','250621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25062900','Outras formas de quartzitos','Other forms of quartzite','Las demás formas de cuarcitas',10,'25','2506','250629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25070010','Caulim','Kaolin','Caolín',10,'25','2507','250700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25070090','Outras argilas caulínicas, mesmo calcinadas','Other kaolinic clays, whether or not calcined','Las demás arcillas caolínicas, incluso calcinadas',10,'25','2507','250700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25081000','Bentonita','Bentonite','Bentonita',10,'25','2508','250810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25082000','Terras descorantes e terras de pisao (terras "fuller")','Decolourizing earths and fuller''s earth','Tierras decolorantes y tierras de batán',10,'25','2508','250820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25083000','Argilas refratárias','Fire-clay','Arcillas refractarias',10,'25','2508','250830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25084010','Argilas plásticas, teor de f2o3<1.5%, perda p/calcin>12%','Plast.clays, of an fe2o3 cont.wei.<1, 5% a calc.loss>12%','Arcillas plást.c/cont.f2o3<1, 5%, c/pérd.por calc.>12%',10,'25','2508','250840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25084090','Outras argilas','Other clays','Las demás arcillas',10,'25','2508','250840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25085000','Andaluzita, cianita e silimanita','Andalusite, kyanite and sillimanite','Andalucita, cianita y silimanita',10,'25','2508','250850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25086000','Mulita','Mullite','Mullita',10,'25','2508','250860');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25087000','Barro cozido em pó (terra "chamotte") e terra de dinas','Chamotte or dinas earths','Tierras de chamota o de dinas',10,'25','2508','250870');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25090000','Cré','Chalk','Creta',10,'25','2509','250900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25101010','Fosfatos de cálcio, naturais, não moídos','Natural calcium phosphates, unground','Fosfatos de calcio, naturales, sin moler',10,'25','2510','251010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25101090','Fosfatos aluminocalcicos, naturs.cre-fosfatado, n/moidos','Calcium phosphates, natural alumin.phosphatiic unground','Fosfatos aluminocálcicos, nat.cretas fosfatadas, s/moler',10,'25','2510','251010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25102010','Fosfatos de cálcio, naturais, moídos','Calcium phosphates, natural, ground','Fosfatos de calcio, naturales, molidos',10,'25','2510','251020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25102090','Fosfatos aluminocalcicos, naturais, cre-fosfatado, moidos','Calcium phosphates, natural aluminium phosphatiic, ground','Fosfatos aluminocálcicos, natur.cretas fosfatadas, molid.',10,'25','2510','251020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25111000','Sulfato de bário natural (baritina)','Natural barium sulphate (barytes)','Sulfato de bario natural (baritina)',10,'25','2511','251110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25112000','Carbonato de bário natural (witherita)','Natural barium carbonate (witherite)','Carbonato de bario natural (witherita)',10,'25','2511','251120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25120000','Farinhas silíciosas fosseis/outs.terras silíciosas, d<=1','Siliceous fossil meals/other siliceous earths, d<=1','Harinas silíceas fósiles/demás tierras silíceas, d<=1',10,'25','2512','251200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25131000','Pedra-pomes;esmeril/outs.abrs.nat.trat.term.','Pumice stone; emery/other natural garnett','Piedra pómez; esmeril/other granate naturales',10,'25','2513','251310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25131100','Pedras-pomes em bruto, fragmentos irregul.incl.triturada','Pumice stone, crude, in irregular pieces, includ.crushed','Piedra pómez en bruto, en trozos irregul.incluso la quebrantada.',10,'25','2513','251311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25131900','Outras formas de pedra-pomes','Other forms of pumice stone','Otras formas de piedra pómez',10,'25','2513','251319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25132000','Esmeril, corindo/granada naturais, outs.abrasivos natur.','Emery, natural corundum, natural garnet/ot.nat.abrasives','Esmeril, corindón/granate naturales, dem.abrasivos nat.',10,'25','2513','251320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25140000','Ardósia incl.desbastada ou cortada em blocos ou placas','Slate, whether/n/roughly trimmed/merely cut, blocks slabs','Pizarra, incl.desbastada o troceada en bloques o placas',10,'25','2514','251400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25151100','Mármores e travertinos, em bruto ou desbastados','Marble and travertine, crude or roughly trimmed','Mármol y travertinos, en bruto o desbastados','16','25','2515','251511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25151210','Mármores cortados em blocos ou placas','Merely cut into blocks or slabs','Marmoles troceados en bloques o placas','16','25','2515','251512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25151220','Travertinos cortados em blocos ou placas','Travertine cut into blocks or slabs','Travertinos troceados en bloques o en placas','16','25','2515','251512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25152000','Granitos belgas, outs.pedras calcárias de cantaria, etc.','Granite ecaussine and other calcareous monumental, etc.','Ecaussines, demás piedras calizas de talla,  etc','16','25','2515','251520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25161100','Granito em bruto ou desbastado','Granite, in crude or roughly trimmed','Granito en bruto o desbastado','16','25','2516','251611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25161200','Granito cortado em blocos ou placas','Granite, cut or in blocks or slabs','Granito troceado en bloques o en placas','16','25','2516','251612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25162000','Arenito cortado blocos, placas, quadr.,ret.','Sandstine, cut in blocks, plates, squares, rectangular','Arenisca troceada, bloques, placas, cuadrados, rectangulares','16','25','2516','251620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25162100','Arenito em bruto ou desbastado','Sandstine, in crude or roughly trimmed','Arenisca en bruto o desbastada','16','25','2516','251621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25162200','Arenito cortado em blocos ou placas','Sandstine, cut or in blocks or slabs','Arenisca troceada en bloques o placas','16','25','2516','251622');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25169000','Outras pedras de cantaria ou de construção','Other monumental or building stone','Las demás piedras de talla o de construcción',10,'25','2516','251690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25171000','Calhaus, cascalhos e pedras britadas, para concreto, etc.','Pebbles, gravel, broken, crushed stone used forconcrete, etc','Cantos, gravas y piedras machacadas, p/hacer hórmigon, etc',10,'25','2517','251710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25172000','Macadame de escórias de altos-fornos, outs.escórias, etc.','Macadam of slag, dross, other slags, etc','Macadán de escorias o de desechos industr.simil., etc',10,'25','2517','251720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25173000','Tarmacadame','Tarred macadam','Macadán alquitranado',10,'25','2517','251730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25174100','Grânulos, lascas e pós, de mármore','Granules, chippings and powder, of marble','Gránulos, tasquiles y polvos, de mármol',10,'25','2517','251741');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25174900','Grânulos, lascas e pos, granito e outs.pedras de cantaria','Granules, chippings, powder, granite and oth.stone quarry','Gránulos, tasquiles y polvos, granit.y dem.piedr.de talla',10,'25','2517','251749');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25181000','Dolomita não calcinada nem sinterizada, "crua"','Dolomite, not calcined or sintered, "raw"','Dolomita sin calcinar ni sinterizar, llamada "cruda"',10,'25','2518','251810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25182000','Dolomita calcinada ou sinterizada','Calcined or sintered dolomite','Dolomita calcinada o sinterizada',10,'25','2518','251820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25183000','Aglomerados de dolomita','Dolomite ramming mix','Aglomerados de dolomita',10,'25','2518','251830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25191000','Carbonato de magnésio natural (magnesita)','Natural magnesium carbonate (magnesite)','Carbonato de magnesio natural (magnesita)',10,'25','2519','251910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25199010','Magnésia eletrofundida','Fused magnesia','Magnesia electrofundida',10,'25','2519','251990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25199090','Magnésia calcinada a fundo e outros óxidos de magnésio','Fused magnesia and other oxides of magnesium','Magnesia calcinada a muerte y demás óxidos de magnesio',10,'25','2519','251990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25201011','Gipsita em pedaços irregulares (pedras)','Gypsum in irregular pieces (stone)','Yeso en trozos irregulares (piedras)',10,'25','2520','252010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25201019','Outras formas de gipsitas','Other forms of gypsum','Las demás formas de yesos',10,'25','2520','252010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25201020','Anidrita','Anhydrite','Anhidrita',10,'25','2520','252010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25202010','Gesso moído, apto para uso odontológico','Milled plaster ground, for use in dentistry','Yeso fraguable molido, apto para el uso odontológico',10,'25','2520','252020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25202090','Outras formas de gesso','Other forms of plasters','Las demás formas de yeso fraguable',10,'25','2520','252020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25210000','Castinas, pedras calcárias p/fabr.de cal ou de cimento','Limestone flux, calcar.stone formanufac.of lime or cement','Castinas, piedras p/la fabricación de cal o de cemento',10,'25','2521','252100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25221000','Cal viva','Quicklime','Cal viva',10,'25','2522','252210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25222000','Cal apagada','Slaked lime','Cal apagada',10,'25','2522','252220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25223000','Cal hidráulica','Hydraulic lime','Cal hidráulica',10,'25','2522','252230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25231000','Cimentos não pulverizados ("clinkers")','Cement clinkers','Cementos sin pulverizar (clinkers)',10,'25','2523','252310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25232100','Cimentos "portland", brancos','Portland cement, white','Cementos portland, blancos',10,'25','2523','252321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25232910','Cimentos "portland", comuns','Portland cement, common','Cementos portland, normales',10,'25','2523','252329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25232990','Outros tipos de cimento "portland"','Other kind of portland cement','Los demás tipos de cementos portland',10,'25','2523','252329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25233000','Cimentos aluminosos','Aluminous cement','Cementos aluminosos',10,'25','2523','252330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25239000','Outros cimentos hidráulicos','Other hydraulic cements','Los demás cementos hidráulicos',10,'25','2523','252390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25240010','Amianto (arbesto) em fibras, não trabalhado','Asbestos in fibers, not worked','Amianto (asbesto) en fibras, sin trabajar',10,'25','2524','252400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25240011','Crocidolita (amianto) em fibras, não trabalhada','Crocidolite in fibers, not worked','Crocidolita (amianto) en fibras, sin trabajar',10,'25','2524','252400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25240019','Outros amiantos em fibras, não trabalhados','Other asbestos in fibers, not worked','Los demás amiantos en fibras, sin trabajar',10,'25','2524','252400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25240020','Amianto (arbesto) em pó','Asbestos in powder','Amianto (asbesto) en polvo',10,'25','2524','252400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25240021','Crocidolita (amianto) em pó','Crocidolite in powder','Crocidolita (amianto) en polvo',10,'25','2524','252400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25240029','Outros amiantos em pó','Other asbestos in powder','Los demás amiantos en polvo',10,'25','2524','252400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25240090','Outras formas de amianto (arbesto)','Other forms of asbestos','Las demás formas de amianto (asbesto)',10,'25','2524','252400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25241000','Crocidolita (amianto) mesmo corados','Crocidolite (asbestos) even stained','Crocidolita (amianto), incluso manchadas',10,'25','2524','252410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25249000','Outras formas de amianto (asbesto)','Other forms of asbestos (asbestos)','Otras formas de amianto (asbestos)',10,'25','2524','252490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25251000','Mica em bruto ou clivada em folhas, lamelas irregulares','Crude mica and mica rifted into sheets or splittings','Mica en bruto o exfoliada en hojas, en laminillas irreg.',10,'25','2525','252510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25252000','Mica em pó','Mica powder','Mica en polvo',10,'25','2525','252520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25253000','Desperdícios de mica','Mica waste','Desperdicios de mica',10,'25','2525','252530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25261000','Esteatita natural, não triturada nem em pó','Natural steatite, not crushed, not powdered','Esteatita natural, sin triturar ni pulverizar',10,'25','2526','252610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25262000','Esteatita natural, triturada ou em pó e talco','Natural steatite, crushed or powdered','Esteatita natural, triturada o pulveriz.en polvo y talco',10,'25','2526','252620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25270000','Criolita natural e quiolita natural','Natural criolite and natural quiolite','Criolita natural y quiolita natural',10,'25','2527','252700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25280000','Boratos naturais e seus concentrados(calcinados ou não)','Natural borates and concen.thereof(calcined or not)','Boratos naturales y sus concent. (incluso calcinados)',10,'25','2528','252800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25281000','Boratos de sódio, naturais e seus concentrados','Natural sodium borates and concentrates thereof','Boratos de sodio,  naturales y sus concentrados',10,'25','2528','252810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25289000','Outros boratos naturais, acido bórico, natural, h3bo3<=85%','Other natural borates, natural boric acid, h3bo3<=85%','Los dem.boratos natur.ác.bórico, nat.c/cont.h3bo3<=85%',10,'25','2528','252890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25291000','Feldspato','Felspar','Feldespato',10,'25','2529','252910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25292100','Espatofluor contendo peso<=97% de fluoreto de cálcio','Fluorspar containing weight<=97% of fluoride of calcium','Espato flúor c/cont.de fluoruro de calcio<=97%en peso',10,'25','2529','252921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25292200','Espatofluor contendo peso>97% de fluoreto de cálcio','Fluorspar containing weight>97% of fluoride of calcium','Espato flúor c/cont.de fluoruro de calcio>97%en peso',10,'25','2529','252922');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25293000','Leucita, nefelina e nefelina-sienito','Leucite, nepheline and nepheline syenite','Leucita, nefelina y nefelina sienita',10,'25','2529','252930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25301010','Perlita não expandida','Perlite unexpanded','Perlita sin dilatar',10,'25','2530','253010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25301090','Vermiculita e cloritas, não expandidas','Vermiculite and chlorites, unexpanded','Vermiculita y cloritas, sin dilatar',10,'25','2530','253010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25302000','Kieserita, epsomita (sulfatos de magnésio naturais)','Kieserite, epsomite (natural magnesium sulphates)','Kieserita, epsomita (sulfatos de magnesio naturales)',10,'25','2530','253020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25304000','Óxidos de ferro micáceos naturais','Oxides of iron natural micaceus','Óxidos de hierro micáceos naturales',10,'25','2530','253040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25309010','Espodumênio','Spodumene','Espodumenio',10,'25','2530','253090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25309020','Areias de zircônio microniz.p/prepar.de esmaltes cerâm.','Microniz.zircon.sand suitable foruse manufac.ceram.enam.','Arenas de circonio microniz.p/la prep.de esmalte cerám.',10,'25','2530','253090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25309030','Minerais de metais das terras raras','Minerals of metals of the rare lands','Minerales de metales de las tierras raras',10,'25','2530','253090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25309040','Terras corantes','Coloring lands','Tierras colorantes',10,'25','2530','253090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('25309090','Outras matérias minerais','Other mineral substances','Las demás materias minerales',10,'25','2530','253090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26011100','Minérios de ferro não aglomerados e seus concentrados','Iron ores not agglomerated, and concentrates','Minerales de hierro sin aglomerar y sus concentrados',10,'26','2601','260111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26011200','Minérios de ferro aglomerados e seus concentrados','Iron ores agglomerated and concentrates','Minerales de hierro aglomerados y sus concentrados',10,'26','2601','260112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26012000','Piritas de ferro ustuladas (cinzas de piritas)','Roasted iron pyrites (gray pyrites)','Piritas de hierro tostadas (cenizas de piritas)',10,'26','2601','260120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26020010','Minérios de manganês aglomerados e seus concentrados','Manganese ores, agglomerated and concentrates','Minerales de manganeso aglomerados y sus concentrados',10,'26','2602','260200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26020090','Outros minérios de manganês','Other manganese ores','Los demás minerales de manganeso',10,'26','2602','260200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26030010','Sulfetos de minérios de cobre','Sulphides of copper ores','Sulfetos de minerales de cobre',10,'26','2603','260300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26030090','Outros minérios de cobre e seus concentrados','Other ores and concentrates','Los demás minerales de cobre y sus concentrados',10,'26','2603','260300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26040000','Minérios de niquel e seus concentrados','Nickel ores and concentrates','Minerales de níquel y sus concentrados',10,'26','2604','260400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26050000','Minérios de cobalto e seus concentrados','Cobalt ores and concentrates','Minerales de cobalto y sus concentrados',10,'26','2605','260500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26060011','Bauxita não calcinada (minério de alumínio)','Bauxite not calcined (aluminium ores)','Bauxita sin calcinar (minerales de aluminio)',10,'26','2606','260600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26060012','Bauxita calcinada (minério de alumínio)','Bauxite calcined (aluminium ores)','Bauxita calcinada (minerales de aluminio)',10,'26','2606','260600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26060090','Outros minérios de alumínio e seus concentrados','Other aluminium ores and concentrates','Los demás minerales de aluminio y sus concentrados',10,'26','2606','260600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26070000','Minérios de chumbo e seus concentrados','Lead ores and concentrates','Minerales de plomo y sus concentrados',10,'26','2607','260700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26080010','Sulfetos de minérios de zinco','Sulphides of zinc ores','Sulfetos de minerales de cinc',10,'26','2608','260800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26080090','Outros minérios de zinco e seus concentrados','Other zinc ores and concentrates','Los demás minerales de cinc y sus concentrados',10,'26','2608','260800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26090000','Minérios de estanho e seus concentrados','Tin ores and concentrates','Minerales de estaño y sus concentrados',10,'26','2609','260900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26100010','Cromita (minérios de cromo)','Chromite (chromium ores)','Cromita (minerales de cromo)',10,'26','2610','261000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26100090','Outros minérios de cromo e seus concentrados','Other chromium ores and concentrates','Los demás minerales de cromo y sus concentrados',10,'26','2610','261000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26110000','Minérios de tungstênio e seus concentrados','Tungsten ores and concentrates','Minerales de tungsteno y sus concentrados',10,'26','2611','261100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26121000','Minérios de urânio e seus concentrados','Uranium ores and concentrates','Minerales de uranio y sus concentrados',10,'26','2612','261210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26122000','Minérios de tório e seus concentrados','Thorium ores and concentrates','Minerales de torio y sus concentrados',10,'26','2612','261220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26131010','Molibdenita ustulada (minérios de molibdénio)','Molybdenum roasted (molybdenum ores)','Molibdenita tostada (minerales de molibdeno)',10,'26','2613','261310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26131090','Outs.minérios de molibdénio, ustulados, seus concentrados','Other molybdenum ores, roasted and concentrates','Los dem.minerales de molibdeno, tostados, sus concentr.',10,'26','2613','261310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26139010','Molibdenita não ustulada (minérios de molibdénio)','Molybdenum n/roasted (molybdenum ores)','Molibdenita sin tostar (minerales de molibdeno)',10,'26','2613','261390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26139090','Outs.minérios de molibdénio não ustulados e concentrados','Other molybdenum ores, n/roasted and concentrates','Los dem.minerales de molibdeno s/tostar y concentrados',10,'26','2613','261390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26140010','Ilmenita (minérios de titânio)','Ilmenite (titanium ores)','Ilmenita (minerales de titanio)',10,'26','2614','261400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26140090','Outros minérios de titânio e seus concentrados','Other titanium ores and concentrates','Los dem.minerales de titanio y sus concentrados',10,'26','2614','261400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26151010','Badeleita (minério de zircônio)','Zirconium (zirconium ores)','Badeleyta (minerales de circonio)',10,'26','2615','261510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26151020','Zirconita (minério de zircônio)','Zircon (zirconium ores)','Circonita (minerales de circonio)',10,'26','2615','261510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26151090','Outros minérios de zircônio e seus concentrados','Other zirconium ores and concentrates','Los demás minerales de circonio y sus concentrados',10,'26','2615','261510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26159000','Minérios de nióbio, tântalo ou vanádio, seus concentrados','Niobiumtantalum or vanadium ores and concentrates','Minerales de niobio, tantalio o vanadio, sus concentrados',10,'26','2615','261590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26161000','Minérios de prata e seus concentrados','Silver ores and concentrates','Minerales de plata y sus concentrados',10,'26','2616','261610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26169000','Minérios de outros metais preciosos e seus concentrados','Other precious metal ores and concentrates','Minerales de demás metales preciosos y sus concentrados',10,'26','2616','261690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26171000','Minérios de antimônio e seus concentrados','Antimony ores and concentrates','Minerales de antimonio y sus concentrados',10,'26','2617','261710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26179000','Outros minérios e seus concentrados','Other ores and concentrates','Los demás minerales y sus concentrados',10,'26','2617','261790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26180000','Escória de altos-fornos granul.da fabr.do ferro e aço','Granulated slag from the manufacture of iron and steel','Escorias granuladas de la siderurgia',10,'26','2618','261800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26190000','Outras escórias e desperdícios, da fabr.do ferro e aco','Other slag and waste from the manufac.of iron and steel','Las dem.escorias y desperdicios, de la siderurgia',10,'26','2619','261900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26201100','Mates de galvanização (contendo zinco)','Hard zinc spelter(containing mainly zinc)','Mates de galvanización (que contengan cinc)',10,'26','2620','262011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26201900','Outras cinzas e resíduos contendo zinco','Other ash and residues containing zinc','Las demás cenizas y residuos q.contengan cinc',10,'26','2620','262019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26202000','Cinzas e resíduos contendo chumbo','Other ash and residues containing lead','Cenizas y residuos que contengan plombo',10,'26','2620','262020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26202100','Lamas de gasolina contendo chumbo, etc.','Muds of gasoline containing lead, etc.','Lodos de gasolina que contengan plomo,  etc.',10,'26','2620','262021');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26202900','Outras cinzas e resíduos contendo principalmente chumbo','Other ash and residues containing mainly lead','Las dem.cenizas y residuos q.cont.principalm.plomo',10,'26','2620','262029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26203000','Cinzas e resíduos contendo cobre','Ash and residues containing mainly copper','Cenizas y residuos que contengan cobre',10,'26','2620','262030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26204000','Cinzas e resíduos contendo alumínio','Ash and residues containing mainly aluminium','Cenizas y residuos que contengan aluminio',10,'26','2620','262040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26205000','Cinzas e resíduos contendo vanádio','Ash and residues containing mainly vanadium','Cenizas y residuos que contengan vanadio',10,'26','2620','262050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26206000','Cinzas e resíduos, contendo arsênio, mercúrio, etc.','Ash and residues containing arsenic, mercury, etc.','Cenizas y residuos, qu contengan arsénico, mercurio,  etc',10,'26','2620','262060');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26209010','Cinzas e resíduos contendo titânio','Ash and residues containing mainly titanium','Cenizas y residuos que contengan titanio',10,'26','2620','262090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26209090','Cinzas e resíduos contendo outros metais ou compostos','Ash and residues containing other metals or compounds','Cenizas y residuos q.contengan los dem.met.o compuestos',10,'26','2620','262090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26209100','Cinzas e resíduos, contendo antimônio, berílio, etc.','Ash and residues containing antimony, beryllium, etc','Cenizas y residuos, q.contengan antimonio, berilio, etc',10,'26','2620','262091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26209910','Cinzas e resíduos, contendo principalmente titânio','Ash and residues containing mainly titanium','Cenizas y residuos,  q.contengan principalmente titanio',10,'26','2620','262099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26209990','Cinzas e resíduos, contendo outros metais','Ash and residues containing other metals','Cenizas y residuos, q.contengan los demás metales',10,'26','2620','262099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26210010','Cinzas de origem vegetal','Ash of vegetable origin','Cenizas de origen vegetal',10,'26','2621','262100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26210090','Outras escórias e cinzas, incl.as cinzas de algas','Other slag and ash, including seaweed ash (kelp)','Las dem.escorias y cenizas, incl.las cenizas de algas',10,'26','2621','262100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26211000','Cinzas e resíduos da incineração de lixo municipal','Ash/residues from the incineration of municipal waste','Cenizas y residuos de inciner.de desechas y desp.munic.',10,'26','2621','262110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26219010','Cinzas de origem vegetal','Ash of vegetable origin','Cenizas de origen vegetal',10,'26','2621','262190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('26219090','Outras escórias e cinzas','Other slag and ash','Las demás escorias y cenizas',10,'26','2621','262190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27011100','Hulha antracita, não aglomerada','Anthracite coal, not agglomerated','Hulla antracita, sin aglomerar',10,'27','2701','270111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27011200','Hulha betuminosa, não aglomerada','Bituminous coal, not agglomerated','Hulla bituminosa, sin aglomerar',10,'27','2701','270112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27011900','Outras hulhas, mesmo em pó, mas não aglomeradas','Other coal, in powder or not, but not agglomerated','Las demás hullas, incluso pulverizadas, pero s/aglomerar',10,'27','2701','270119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27012000','Briquetes, bolas em aglomerados, etc.obtidos da hulha','Briquettes, ovoids in agglomerated, etc from coal','Briquetas, ovoides, etc, obtenidos de la hulla',10,'27','2701','270120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27021000','Linhitas, mesmo em pó, mas não aglomeradas','Lignite,  in powder or not, but n/agglomerated','Lignitos, incluso pulverizados, pero sin aglomerar',10,'27','2702','270210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27022000','Linhitas aglomeradas','Agglomerated lignite','Lignitos aglomerados',10,'27','2702','270220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27030000','Turfa, incl.aglomerada e a turfa p/cama de animais','Peat, (including peat litter)whether or not agglomerated','Turba, incl.aglomerada y la turba para cama de animales',10,'27','2703','270300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27040010','Coques de hulha, de linhita ou de turfa','Coke of coal, of lignite or of peat','Coques de hulla, lignito o turba',10,'27','2704','270400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27040090','Semicoques de hulha, linhita ou turfa, carvão de retorta','Semi-coke of coal,  of lignite or of peat, retort carbon','Semicoque de hulla, lignito o turba, carbón de retorta',10,'27','2704','270400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27050000','Gás de hulha, água, etc.exceto de petróleo/hidrocarb.gasosos','Coal gas, water, etc.exc.petroleum/gaseous hydrocarbons','Gas de hulla, agua, etc, exc.el gas de petr/hidrocarb.gas.',10,'27','2705','270500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27060000','Alcatrões de hulha, de linhita ou de turfa, etc.','Tar distilled from coal,  from lignite or from peat, etc','Alquitranes de hulla, de lignito o de turba, etc.',10,'27','2706','270600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27071000','Benzóis (produtos da destilação dos alcatrões de hulha)','Benzol (products of the distillation of coal tar)','Benzoles(prod.de la destil.de los alquitranes de hulla)',10,'27','2707','270710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27072000','Toluóis (produtos da destilação dos alcatrões de hulha)','Toluol (products of the distillation of coal tar)','Toluoles(prod.de la destil.de los alquitranes de hulla)',10,'27','2707','270720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27073000','Xilóis (produtos da destilação dos alcatrões de hulha)','Xylol (products of the distillation of coal tar)','Xiloles(prod.de la destil.de los alquitranes de hulla)',10,'27','2707','270730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27074000','Naftaleno (produtos da destilação dos alcatrões de hulha)','Naphthalene (products of the distillation of coal tar)','Naftaleno(prod.de la dest.de los alquitranes de hulla)',10,'27','2707','270740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27075000','Outras misturas dos hidrocarb.aromat.destil>=65% a 250gc','Oth.aromatic hydrocarb.mix.which>= 65%distils at 250gc','Las dem.mezclas de los hidroc.arom.q.dest.>=65%a 250ºc',10,'27','2707','270750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27076010','Cresóis (fenólico)','Cresols','Cresoles',10,'27','2707','270760');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27076090','Outros derivados fenólicos','Other phenols','Los demás derivados fenólicos',10,'27','2707','270760');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27079100','Óleos de creosoto','Creosote oils','Aceites de creosota',10,'27','2707','270791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27079900','Outros óleos e produtos da destilação dos alcatrões da hulha, etc','Oils and other prod.of the distillation of coal tar, etc','Los dem.aceites y prod.de dest.de alquitr.de hulla, etc',10,'27','2707','270799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27079910','Cresóis','Cresols','Cresoles',10,'27','2707','270799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27079990','Outros óleos e produtos da destilação do alcatrão de hulha','Other oils and products of tar distillation','Otros aceites y productos de destilación de alquitran',10,'27','2707','270799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27081000','Breu obtido de alcatrões minerais','Pitch, obtained from mineral tar','Brea de alquitranes minerales',10,'27','2708','270810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27082000','Coque de breu obtido de alcatrões minerais','Pitch coke,  obtained from mineral tar','Coque de brea de alquitranes minerales',10,'27','2708','270820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27090010','Óleos brutos de petróleo','Petroleum oils, crude','Aceites crudos de petróleo','16','27','2709','270900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27090090','Óleos brutos de minerais betuminosos','Oils obtained from bituminous minerals, crude','Aceites crudos de minerales bituminosos','16','27','2709','270900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100011','Naftas para petroquímica','Naphthas for petro-chemistry','Naftas para petroquímica','16','27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100019','Outras naftas','Other naphthas','Otras naftas','16','27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100021','Gasolinas de aviação','Aviation gasoline','Gasolinas de aviación','16','27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100029','Outras gasolinas','Other gasolines','Las demás gasolinas','16','27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100031','Querosenes de aviação','Kerosenes of aviation','Queroseno de aviación','16','27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100039','Outros querosenes','Other kerosenes','Los demás querosenos','16','27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100041','Gasóleo (óleo diesel)','Diesel oil','Gasoleo ("gas oil")','16','27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100042','Fuel-oil (óleo combustivel)','Fuel-oil','Fuel oil (aceite combustible)','16','27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100049','Outros óleos combustíveis','Other fuel-oil','Los demás aceites combustibles','16','27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100051','Diisobutileno (mistura de alquilidenos)','Diisobutylene','Diisobutileno (mezcla de alquilidenos)',10,'27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100059','Outras misturas de alquilidenos','Other mixtures of alkylenes','Las demás mezclas de alquilidenos',10,'27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100061','Óleos lubrificantes sem aditivos','Lubricating oils without addictive','Aceites lubricantes sin aditivos',10,'27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100062','Óleos lubrificantes com aditivos','Lubricating oils with addictive','Aceites lubricantes con aditivos',10,'27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100091','Hexano comercial','Commercial hexane','Hexano comercial',10,'27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100092','Aguarrás mineral','Mineral turpentine','Aguarrás mineral',10,'27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100093','Óleos minerais brancos (óleos de vaselina ou parafina)','White mineral oils (oils of vaseline or paraffin)','Aceites mineral.blancos(aceites de vaselina o parafina)',10,'27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100094','Líquidos para transmissões hidráulicas','Liquids for hydraulic transmissions','Líquidos para transmisiones hidráulicas',10,'27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100095','Óleos para isolamento elétrico','Oils for electric isolation','Aceites para aislación eléctrica',10,'27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27100099','Ouros óleos de petróleo, minerais betuminosos e preparações','Oth.petroleum oils, bituminous minerals and preparations','Los dem.aceites de petróleo, min.bituminosos y preparac.',10,'27','2710','271000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101110','Hexano comercial','Commercial hexane','Hexano comercial',10,'27','2710','271011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101121','Diisobutileno','Diisobutylene','Diisobutileno',10,'27','2710','271011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101129','Outras misturas de alquilidenos','Other mixtures of alkylenes','Las demás mezclas de alquilidenos',10,'27','2710','271011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101130','Aguarrás mineral ("white spirit")','White spirit','Aguarrás mineral ("white spirit")',10,'27','2710','271011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101141','Naftas para petroquímica','Naphtha for the petro-chemical industry','Naftas para petroquímica','16','27','2710','271011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101149','Outras naftas','Other naphtha','Las demás naftas','16','27','2710','271011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101151','Gasolinas de aviação','Gasoline of aviation','Gasolinas de aviación','16','27','2710','271011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101159','Outras gasolinas','Other gasoline','Las demás gasolinas','16','27','2710','271011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101160','Mistura hidrocarb.satur.frac.petr>=90%, 70ºc<=pto<210ºc','Mixt.satur.hydroc.frac.forpetroc>=90%, 70°<=pto<210ºc','Mezcla hidr.saturados frac.p/petroq>=90%, 70°<=pto<210ºc',10,'27','2710','271011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101190','Outros óleos leves de petróleo/de minerais betuminosos','Oth.light oils of petroleum/from bituminous minerals','Los demás aceites de petróleo/de mineral bituminoso',10,'27','2710','271011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101210','Hexano comercial','Commercial hexane','Hexano comercial',10,'27','2710','271012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101221','Diisobutileno','Diisobutylene','Diisobutileno',10,'27','2710','271012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101229','Outras misturas de alquilidenos','Other mixtures of alquilidenes','Otras mezclas de alquilidenos',10,'27','2710','271012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101230','Aguarrás mineral (white spirit)','Mineral spirits (white spirit)','Alcoholes minerales (white spirit)',10,'27','2710','271012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101241','Naftas para petroquimica','Naphtha for petrochemical','Naftas para petroquímica','16','27','2710','271012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101249','Outras naftas, exceto para petroquímica','Others naphthas, except for petrochemical','Otras naftas, excepto para petroquímica','16','27','2710','271012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101251','Gasolinas para aviação','Gasoline for aviation','Gasolina para la aviación','16','27','2710','271012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101259','Outras gasolinas, exceto para aviação','Other gasolines, except for aviation','Otras gasolinas, excepto para la aviación','16','27','2710','271012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101260','Mistura de hidrocarbonetos acíclicos e cíclicos','Mixture of hydrocarbons, acyclic and cyclic','Mezcla de hidrocarburos acíclicos y cíclicos',10,'27','2710','271012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101290','Outros óleos leves e preparações','Other light oils and preparations','Otros aceites ligeros y preparaciones',10,'27','2710','271012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101911','Querosenes de aviação','Kerosene oils for aviation','Queroseno de aviación','16','27','2710','271019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101919','Outros querosenes','Other kerosene oils','Los demás querosenos','16','27','2710','271019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101921','"Gasóleo" (óleo diesel)','Diesel oil','Gasóleo ("gas oil")','16','27','2710','271019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101922','"Fuel-oil"','Fuel oil','Fuel oil','16','27','2710','271019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101929','Outros óleos combustíveis','Other fuel oils','Los demás aceites combustibles','16','27','2710','271019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101931','Óleos lubrificantes sem aditivos','Lubricating oils without addictive','Aceites lubricantes sin aditivos',10,'27','2710','271019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101932','Óleos lubrificantes com aditivos','Lubricating oils with addictive','Aceites lubricantes con aditivos',10,'27','2710','271019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101991','Óleos minerais brancos (de vaselina/parafina)','White mineral oils (of vaseline/paraffin)','Aceites minerales blancos (de vaselina/parafina)',10,'27','2710','271019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101992','Líquidos para transmissões hidráulicas','Liquids for hydraulic transmissions','Líquidos para transmisiones hidráulicas',10,'27','2710','271019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101993','Óleos para isolamento elétrico','Oils for electric isolation','Aceites para aislación eléctrica',10,'27','2710','271019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101994','Mistura hidrocarb.satur.frac.petr<90%vol.210ºc<pt<360ºc','Mixt.satur.hydroc.frac.forpetroc.>=90%, 210<=pt<360ºc','Mezcla hidrocarb.satur.frac.p/petroq.>=90%, 210<=p<360ºc',10,'27','2710','271019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27101999','Outros óleos de petróleo ou de minerais betuminosos','Oils of petroleum or of betuminous minerals','Los dem.aceites de petróleo o de minerales bituminosos',10,'27','2710','271019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27102000','Óleos de petróleo ou minerais betuminosos(exc.ol.bru)','Petroleum oil or bituminous oils (exc.crude oil)','Aceites de petróleo y aceites de minerales bituminosos',10,'27','2710','271020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27109100','Desperdícios de óleos contendo difenilas, etc.','Wastes of oils containing biphenyls, etc.','Desperdicios de aceites que contengan difenilos,  etc.',10,'27','2710','271091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27109900','Outros desperdícios de óleos','Other wastes of oils','Los demás desperdicios de aceites',10,'27','2710','271099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27111100','Gás natural, liquefeito','Natural gas, liquefied','Gas natural, licuado',10,'27','2711','271111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27111210','Propano em bruto, liquefeito','Propane in crude, liquefied','Propano en bruto, licuado',10,'27','2711','271112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27111290','Outros propanos liquefeitos','Other propane, liquefied','Los demás propanos licuados',10,'27','2711','271112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27111300','Butanos liquefeitos','Butanes, liquefied','Butanos licuados',10,'27','2711','271113');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27111400','Etileno, propileno, butileno e butadieno, liquefeitos','Ethylene, propylene, butylene and butadiene, liquefied','Etileno, propileno, butileno y butadieno, licuados',10,'27','2711','271114');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27111910','Gás liquefeito de petróleo (GLP)','Liquefied petroleum gas (LPG)','Gas licuado de petróleo (GLP)',10,'27','2711','271119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27111990','Outros gases liquefeitos de hidrocarbonetos gasosos','Other liquefied gases of gaseous hydrocarbons','Los demás gases licuados de hidrocarburos gaseosos',10,'27','2711','271119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27112100','Gás natural no estado gasoso','Natural gas in the state gaseous','Gas natural en estado gaseoso',10,'27','2711','271121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27112910','Butanos no estado gasoso','Butanes in the state gaseous','Butano en estado gaseoso',10,'27','2711','271129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27112990','Outs.hidrocarb.gasosos e gas petróleo, no estado gasoso','Oth.gaseous hydrocarbons/petr.gases, in state gaseous','Los dem.hidrocarburos gaseosos y gas pet.en est.gaseoso',10,'27','2711','271129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27121000','Vaselina','Petroleum jelly','Vaselina',10,'27','2712','271210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27122000','Parafina contendo peso <0.75% de óleo','Paraffin wax containing by weight < 0,75 % of oil','Parafina con contenido de aceite inferior < 0.75% en peso',10,'27','2712','271220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27129000','Cera de petróleo microcristalina, ceras minerais, etc.','Microcrystalline petroleum wax, minerals waxes, etc.','Cera de petróleo microcristalina,  ceras minerales,  etc.',10,'27','2712','271290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27131100','Coque de petróleo não calcinado','Petroleum coke not calcined','Coque de petróleo sin calcinar',10,'27','2713','271311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27131200','Coque de petróleo calcinado','Petroleum coke calcined','Coque de petróleo calcinado',10,'27','2713','271312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27132000','Betume de petróleo','Petroleum bitumen','Betún de petróleo',10,'27','2713','271320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27139000','Outros resíduos dos óleos de petróleo, minerais betuminosos','Other residues of petroleum oils, bituminous minerals','Los dem.residuos de los aceites de petróleo, min.bitum.',10,'27','2713','271390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27141000','Xistos e areias betuminosos','Bituminous or oil shale and tar sands','Pizarras y arenas bituminosas',10,'27','2714','271410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27149000','Betumes, asfaltos naturais, asfaltitas, rocha alfalticas','Bitumen and asphalt, natural, asphaltites, asphaltic rocks','Betunes, asfaltos naturales, asfaltitas y rocas asfált.',10,'27','2714','271490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27150000','Misturas betuminosas à base de asfalto, de betumes, etc.','Bituminous mixt.based on natural asphalt, of bitumen, etc','Mezclas bituminosas a base de asfalto,  de betunes,  etc.',10,'27','2715','271500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('27160000','Energia elétrica','Electrical energy','Energía eléctrica','18','27','2716','271600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28011000','Cloro','Chlorine','Cloro',10,'28','2801','280110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28012010','Iodo sublimado','Iodine sublimed','Yodo sublimado',10,'28','2801','280120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28012090','Outras formas de iodo','Other forms of iodine','Las demás formas de yodo',10,'28','2801','280120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28013000','Fluor e bromo','Fluorine and bromine','Flúor y bromo',10,'28','2801','280130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28020000','Enxofre sublimado ou precipitado e enxofre coloidal','Sulphur, sublimed or precipitated and  colloidal sulphur','Azufre sublimado o precipitado y azufre coloidal',10,'28','2802','280200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28030011','Negros de acetileno (negros de carbono)','Carbon blacks','Negros de acetileno (negros de carbono)',10,'28','2803','280300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28030019','Outros negros de carbono','Other carbon blacks','Los demás negros de carbono',10,'28','2803','280300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28030090','Outras formas de carbono','Other forms of carbon','Las demás formas de carbono',10,'28','2803','280300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28041000','Hidrogênio','Hydrogen','Hidrógeno','16','28','2804','280410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28042100','Argônio (gases raros)','Argon (rare gases)','Argón (gases nobles)','16','28','2804','280421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28042910','Hélio líquido (gases raros)','Liquid helium (rare gases)','Helio líquido (gases nobles)','16','28','2804','280429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28042990','Outros gases raros','Other gases rare','Los demás gases nobles','16','28','2804','280429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28043000','Nitrogênio','Nitrogen','Nitrógeno','16','28','2804','280430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28044000','Oxigênio','Oxygen','Oxígeno','16','28','2804','280440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28045000','Boro e telúrio','Boron and tellurium','Boro y telurio',10,'28','2804','280450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28046100','Silício contendo em peso>=99.99% de silício','Silicon,  containing by weight>= 99.99% of silicon','Silicio,  con un contenido de silicio en peso >= 99.99%',10,'28','2804','280461');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28046900','Outros silícios','Other silicons','Los demás silicios',10,'28','2804','280469');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28047010','Fósforo branco','White phosphorus','Fósforo blanco',10,'28','2804','280470');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28047020','Fósforo vermelho ou amorfo','Red or amorphous phosphorus','Fósforo rojo o amorfo',10,'28','2804','280470');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28047030','Fósforo negro','Black phosphorus','Fósforo negro',10,'28','2804','280470');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28048000','Arsênio','Arsenic','Arsénico',10,'28','2804','280480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28049000','Selênio','Selenium','Selenio',10,'28','2804','280490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28051100','Sódio (metal alcalino)','Sodium (alkali metals)','Sodio (metal alcalino)',10,'28','2805','280511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28051200','Cálcio','Calcium','Calcio',10,'28','2805','280512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28051900','Outros metais alcalinos','Other alkali metals','Los demás metales alcalinos',10,'28','2805','280519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28051910','Estrôncio','Strontium','Estroncio',10,'28','2805','280519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28051920','Bário','Barium','Bario',10,'28','2805','280519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28051990','Outros metais alcalinos ou alcalinoterrosos','Other alkali or alkaline-earth metals','Los dem.metales alcalinos o alcalinotérreos',10,'28','2805','280519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28052100','Cálcio (metal alcalino terroso)','Calcium (alkaline-earth metal)','Calcio (metal alcalinotérreo)',10,'28','2805','280521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28052210','Estrôncio (metal alcalino terroso)','Strontium (alkaline-earth metal)','Estroncio (metal alcalinotérreo)',10,'28','2805','280522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28052220','Bário (metal alcalino terroso)','Barium (alkaline-earth metal)','Bario (metal alcalinotérreo)',10,'28','2805','280522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28053010','Liga de cério com peso<=5% de ferro ("mischmetal")','Cerium alloys cont.<=5%, by weight of iron (mischmetal)','Aleación de cerio, c/cont.de hierro<=al 5%en peso',10,'28','2805','280530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28053090','Outros metais de terras raras, escândio e ítrio','Other rare-earth metals,  scandium and yttrium','Los demás metales de las tierras raras, escandio y itrio',10,'28','2805','280530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28054000','Mercúrio','Mercury','Mercurio',10,'28','2805','280540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28061010','Cloreto de hidrogênio (ac.cloridrico), gasoso, liquefeito','Hydrogen chloride(hydrochloric acid)), gaseuos, liquefied','Cloruro de hidrógeno(ácido clorhídrico), gaseoso, licuado',10,'28','2806','280610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28061020','Cloreto de hidrogênio (ac.cloridrico), em solução aquosa','Hydrogen chloride(hydrochloric acid)), in aqueous solut.','Cloruro de hidrógeno(ácido clorhídrico), en soluc.acuosa',10,'28','2806','280610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28062000','Ácido clorossulfúrico','Chlorosulphuric acid','Ácido clorosulfúrico',10,'28','2806','280620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28070010','Ácido sulfúrico','Sulphuric acid','Ácido sulfúrico',10,'28','2807','280700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28070020','Oleum (ácido sulfúrico fumante)','Oleum (smoking sulphuric acid)','Oleum (ácido sulfúrico fumante)',10,'28','2807','280700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28080010','Ácido nítrico','Nitric acid','Ácido nítrico',10,'28','2808','280800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28080020','Ácido sulfonítrico','Sulphonitric acid','Ácido sulfonítrico',10,'28','2808','280800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28091000','Pentóxido de difósforo','Diphosphorus pentaoxide','Pentaóxido de difósforo',10,'28','2809','280910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28092011','Ácido fosfórico com teor de ferro<750ppm','Phosphoric acid with tenor of iron<750 ppm','Ácido fosfórico con cont.de hierro <750 ppm',10,'28','2809','280920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28092019','Outros ácidos fosfóricos','Other phosphoric acid','Los demás ácidos fosfóricos',10,'28','2809','280920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28092020','Ácido metafosfórico','Metaphosphoric acid','Ácido metafosfórico',10,'28','2809','280920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28092030','Ácido pirofosfórico','Pyrophosphoric acid','Ácido pirofosfórico',10,'28','2809','280920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28092090','Outros ácidos polifosfóricos','Other polyphosphoric acids','Los demás ácidos pirofosfóricos',10,'28','2809','280920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28100010','Ácido ortobórico','Orthoboric acid','Ácido ortobórico',10,'28','2810','281000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28100090','Óxidos de boro e outros ácidos bóricos','Oxides of boron and other boric acids','Óxidos de boro y demás ácidos bóricos',10,'28','2810','281000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28111100','Fluoreto de hidrogênio (ácido fluorídrico)','Hydrogen fluoride (hydrofluoric acid)','Fluoruro de hidrógeno (ácido fluorhídrico)',10,'28','2811','281111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28111910','Ácido aminossulfonico (ácido sulfâmico)','Aminosulphonic acid (sulphamic acid)','Ácido aminosulfónico (ácido sulfámico)',10,'28','2811','281119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28111920','Ácido fosfônico (ácido fósforoso)','Phosphonic acid (phosphorous acid)','Ácido fosfónico (ácido fosforoso)',10,'28','2811','281119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28111930','Ácido perclórico','Perchloric acid','Ácido perclórico',10,'28','2811','281119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28111940','Fluorácidos e outros compostos de flúor','Fluoroacids and other compounds of fluorine','Fluoroácidos y demás compuestos de flúor',10,'28','2811','281119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28111950','Cianeto de hidrogênio','Hydrogen cyanide','Cianuro de hidrógeno',10,'28','2811','281119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28111990','Outros ácidos inorgânicos','Other inorganic acids','Los demás ácidos inorgánicos',10,'28','2811','281119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28112100','Dióxido de carbono','Carbon dioxide','Dióxido de carbono',10,'28','2811','281121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28112210','Dióxido de silício obtido por precipitação química','Silicon dioxide obtained by chemical precipitation','Dióxido de silicio obtenido por precipitación química',10,'28','2811','281122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28112220','Dióxido de silício tipo aerogel','Silica aerogel (silicon dioxide)','Dióxido de silicio tipo aerogel',10,'28','2811','281122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28112230','Gel de silica (dióxido de silício)','Silica gel (silicon dioxide)','Gel de silica (dióxido de silicio)',10,'28','2811','281122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28112290','Outros dióxidos de silício','Other silicon dioxide','Los demás dióxidos de silicio',10,'28','2811','281122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28112300','Dióxido de enxofre','Sulphur dioxide','Dióxido de azufre',10,'28','2811','281123');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28112900','Outs.compostos oxigen.inorgan.dos elementos n/metálicos','Other inorganic oxygen compounds of non-metals','Otros compuestos oxigenados inorgánicos de los elementos no metálicos',10,'28','2811','281129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28112910','Dióxido de enxofre','Sulphur dioxide','Dióxido de azufre',10,'28','2811','281129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28112990','Outros compostos oxigenados inorgânicos de elemento não metal.','Other inorganic oxygen compounds of non-metals','Otros compuestos oxigenados inorgánicos de los elementos no metálicos',10,'28','2811','281129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28121011','Tricloreto de fósforo','Phosphorus trichloride','Tricloruro de fósforo',10,'28','2812','281210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28121012','Pentacloreto de fósforo','Phosphorous pentachloride','Pentacloruro de fósforo',10,'28','2812','281210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28121013','Monocloreto de enxofre','Sulphur chloride','Monocloruro de azufre',10,'28','2812','281210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28121014','Dicloreto de enxofre','Sulphur dichloride','Dicloruro de azufre',10,'28','2812','281210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28121015','Tricloreto de arsênio','Arsenic trichloride','Tricloruro de arsénico',10,'28','2812','281210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28121019','Outros derivados do cloreto','Derived of the chloride','Los demás derivados de cloruro',10,'28','2812','281210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28121021','Oxidicloreto de enxofre (cloreto de tionila)','Sulphur dichloride oxide (thionyl chloride)','Oxidicloruro de azufre (cloruro de tionilo)',10,'28','2812','281210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28121022','Oxitricloreto de fósforo (cloreto de fosforila)','Phosphorus trichloride oxide (phosphoryl chloride)','Oxitricloruro de fósforo (cloruro de fosforilo)',10,'28','2812','281210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28121023','Oxidicloreto de carbono (fosgenio ou cloreto carbonila)','Carbon chloride oxide (carbonyl chloride, phosgene','Oxidicloruro de carbono(fosgeno o cloruro de carbonilo)',10,'28','2812','281210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28121029','Outros oxicloretos dos elementos nao metálicos','Other chloride oxides of non-metals','Los demás oxicloruros de los elementos no metálicos',10,'28','2812','281210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28129000','Outros halogenetos, oxialogenetos dos elem.n/metálicos','Other halogen and halogen oxide compounds of non-metals','Los dem.halogenosos, oxihalogenuros de los elem.n/met.',10,'28','2812','281290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28131000','Dissulfeto de carbono','Carbon disulphide','Disulfuro de carbono',10,'28','2813','281310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28139010','Pentassulfeto de difósforo','Diphosphorus pentasulphide','Pentasulfuro de difósforo',10,'28','2813','281390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28139090','Outs.sulfetos dos elem.n/metal.e trissulf.fósforo com.','Oth.sulphides of non-metals com.phosphorus trisulphide','Los dem.sulfuros de elem.n/met.y trisulf.de fósf.com.',10,'28','2813','281390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28141000','Amoníaco anidro','Anhydrous ammonia','Amoníaco anhidro',10,'28','2814','281410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28142000','Amoníaco em solução aquosa (amônia)','Ammonia in aqueous solution (ammonia)','Amoníaco en disolución acuosa',10,'28','2814','281420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28151100','Hidróxido de sódio (soda cáustica) sólido','Sodium hydroxide (caustic soda) solid','Hidróxido de sodio (sosa cáustica),  sólido',10,'28','2815','281511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28151200','Hidróxido de sódio em sol.aquosa (lixiv.soda cáustica)','Sodium hydroxide in aqueous solut.(soda lye)','Hidróxido de sodio en disol.acuosa(lejía de sosa cáust)',10,'28','2815','281512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28152000','Hidróxido de potássio (potassa cáustica)','Potassium hydroxide (caustic potash)','Hidróxido de potasio (potasa cáustica)',10,'28','2815','281520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28153000','Peróxidos de sódio ou de potássio','Peroxides of sodium or potassium','Peróxidos de sodio o de potasio',10,'28','2815','281530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28161010','Hidróxido de magnésio','Hydroxide of magnesium','Hidróxido de magnesio',10,'28','2816','281610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28161020','Peróxido de magnésio','Peroxide of magnesium','Peróxido de magnesio',10,'28','2816','281610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28162000','Óxido, hidróxido e peróxido de estrôncio','Oxide, hydroxide and peroxide, of strontium','Óxido,  hidróxido y peróxido de estroncio',10,'28','2816','281620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28163010','Hidróxido de bário','Hydroxide of barium','Hidróxido de bario',10,'28','2816','281630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28163090','Óxido e peróxido de bário','Oxide and peroxide of barium','Óxido y peróxido de bario',10,'28','2816','281630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28164010','Hidróxido de bário','Hydroxide of barium','Hidróxido de bario',10,'28','2816','281640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28164090','Óxidos, hidróxidos, peróxidos de estrôncio, etc.','Oxides, hydroxides and peroxides of strontium,  etc','Óxidos,  hidróxidos,  peróxidos de estroncio,  etc',10,'28','2816','281640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28170010','Óxido de zinco (branco de zinco)','Zinc oxide','Óxido de cinc (blanco de cinc)',10,'28','2817','281700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28170020','Peróxido de zinco','Zinc peroxide','Peróxido de cinc',10,'28','2817','281700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28181010','Corindo artificial, branco, de grânulometria<=63 microns','Artif.corundum, white, through sieve with apert.of<=63 m','Corindón art.blanc.q.pase a través tam.abert.<=63 micr.',10,'28','2818','281810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28181090','Outros corindos artificiais, químicam.definido ou nao','Oth.artific.corundum, whether or not chemically defined','Los dem.corindones artif.aunque q.no sean químic.defin.',10,'28','2818','281810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28182010','Alumina calcinada','Calcined alumina','Alúmina calcinada',10,'28','2818','281820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28182090','Outros óxidos de alumínio','Other aluminium oxide','Los demás óxidos de aluminio',10,'28','2818','281820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28183000','Hidróxido de alumínio','Aluminium hydroxide','Hidróxido de aluminio',10,'28','2818','281830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28191000','Trióxido de cromo','Chromium trioxide','Trióxido de cromo',10,'28','2819','281910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28199010','Óxidos de cromo','Chromium oxides','Óxidos de cromo',10,'28','2819','281990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28199020','Hidróxidos de cromo','Chromium hydroxides','Hidróxidos de cromo',10,'28','2819','281990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28201000','Dióxido de manganês','Manganese dioxide','Dióxido de manganeso',10,'28','2820','282010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28209010','Óxido manganoso','Manganese oxide','Óxido manganoso',10,'28','2820','282090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28209020','Trióxido de dimanganês (sesquióxido de manganês)','Dimanganese trioxide (manganese sesquioxide)','Trióxido de dimanganeso (sesquióxido de manganeso)',10,'28','2820','282090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28209030','Tetraóxido de trimanganês (óxido salino de manganês)','Manganomanganic oxide (manganese saline oxide)','Tetraóxido de trimanganeso (óxido salino de manganeso)',10,'28','2820','282090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28209040','Heptaóxido de dimanganês (anidrido permanganico)','Permanganic anhydride','Heptaóxido de dimanganeso (anhídrido permangánico)',10,'28','2820','282090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28211011','Óxido férrico com teor de fe2o3>=85%, em peso','Iron oxides containing 85% or more by weight of fe2o3','Óxido férrico con cont.de fe2o3 >= 85%, en peso',10,'28','2821','282110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28211019','Outros óxidos férricos','Other ferric oxides','Los demás óxidos férricos',10,'28','2821','282110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28211020','Óxido ferroso-férrico (óxido magnético de ferro)','Ferrosoferric oxide (magnetic iron oxide)','Óxido ferrosoférrico (óxido magnético de hierro)',10,'28','2821','282110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28211030','Hidróxidos de ferro','Iron hydroxides','Hidróxidos de hierro',10,'28','2821','282110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28211090','Outros óxidos de ferro','Other iron oxides','Los demás óxidos de hierro',10,'28','2821','282110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28212000','Terras corantes, peso>=70% de ferro combinado, em fe2o3','Earth colours, contain.>=70%comb.iron, evaluat.as fe203','Tierras colorantes, c/cont.de hierro comb.>= 70%en fe2o3',10,'28','2821','282120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28220010','Tetraóxido de tricobalto (óxido salino de cobalto)','Tricobalt tetraoxide (cobalt saline oxide)','Tetraóxido de tricobalto (óxido salino de cobalto)',10,'28','2822','282200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28220090','Outs.óxidos e hidróxidos de cobalto, incl.os comerciais','Oth.cobalt oxides and hydroxides, incl.commercial','Los dem.óxidos y hidróxidos de cobalto, inc.los comerc.',10,'28','2822','282200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28230010','Óxidos de titânio, tipo anatase','Titanium oxides, anatase type','Óxidos de titanio, tipo anatasa',10,'28','2823','282300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28230020','Óxidos de titânio, tipo rutilo','Titanium oxides, rutile type','Óxidos de titanio, tipo rutilo',10,'28','2823','282300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28230090','Outros óxidos de titânio','Other titanium oxides','Los demás óxidos de titanio',10,'28','2823','282300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28241000','Monóxido de chumbo (litargirio, massicote)','Lead monoxide (litharge, massicot)','Monóxido de plomo (litargirio, masicotc)',10,'28','2824','282410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28242000','Mínio (zarcao) e mínio-laranja ("mine-orange")','Red lead and orange lead','Minio y minio anaranjado',10,'28','2824','282420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28249000','Outros óxidos de chumbo','Other lead oxides','Los demás óxidos de plomo',10,'28','2824','282490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28249010','Mínio (zarcão) e mínio-laranja ("mine-orange")','Red lead and orange lead','Minio y minio anaranjado',10,'28','2824','282490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28249090','Outros óxidos de chumbo','Other lead oxides','Otros óxidos de plomo',10,'28','2824','282490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28251010','Hidrazina e seus sais inorgânicos','Hydrazine and their inorganic salts','Hidrazina y sus sales inorgánicas',10,'28','2825','282510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28251020','Hidroxilamina e seus sais inorgânicos','Hydroxylamine and their inorganic salts','Hidroxilamina y sus sales inorgánicas',10,'28','2825','282510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28252010','Óxido de litio','Lithium oxide','Óxido de litio',10,'28','2825','282520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28252020','Hidróxido de litio','Lithium hydroxide','Hidróxido de litio',10,'28','2825','282520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28253010','Pentóxido de divanádio','Divanadium pentoxide','Pentóxido de divanadio',10,'28','2825','282530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28253090','Outros óxidos e hidróxidos de vanádio','Other vanadium oxides and hydroxides','Los demás óxidos y hidróxidos de vanadio',10,'28','2825','282530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28254010','Óxido niqueloso','Nickel oxides','Óxido niqueloso',10,'28','2825','282540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28254090','Outros óxidos e hidróxidos de níquel','Other nickel oxides and hydroxides','Los demás óxidos y hidróxidos de níquel',10,'28','2825','282540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28255010','Óxido cuprico, com teor de cuo>=98%, em peso','Copper oxides, containing>=98% of cuo,  by weight','Óxido cúprico,  con un contenido de cuo >= 98%,  en peso',10,'28','2825','282550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28255090','Outros óxidos e hidróxidos de cobre','Other copper oxides and hydroxides','Los demás óxidos e hidróxidos de cobre',10,'28','2825','282550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28256010','Óxidos de germanio','Germanium oxides','Óxidos de germanio',10,'28','2825','282560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28256020','Dióxido de zircônio','Zirconium dioxide','Dióxido de circonio',10,'28','2825','282560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28257010','Trióxido de molibdénio','Molybdenum trioxide','Trióxido de molibdeno',10,'28','2825','282570');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28257090','Outros óxidos e hidróxidos de molibdénio','Other molybdenum oxides and hydroxides','Los demás óxidos y hidróxidos de molibdeno',10,'28','2825','282570');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28258010','Trióxido de antimônio','Antimony trioxide','Trióxido de antimonio',10,'28','2825','282580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28258090','Outros óxidos de antimônio','Other antimony trioxide','Los demás óxidos de antimonio',10,'28','2825','282580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28259010','Óxido de cádmio','Cadmium oxide','Óxido de cadmio',10,'28','2825','282590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28259020','Trióxido de tungstênio (volframio)','Tungsten trioxide (volframio)','Trióxido de tungsteno (volframio)',10,'28','2825','282590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28259030','Óxidos de mercúrio','Mercuric oxide','Óxidos de mercurio',10,'28','2825','282590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28259090','Óxidos, hidróxidos e peróxidos de outros metais, etc.','Oxide, hydroxides and peroxides of other metals, etc','Óxidos,  hidróxidos y peróxidos de demás metales,  etc.',10,'28','2825','282590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28261110','Fluoreto acido de amônio','Ammonium acid fluoride','Fluoruros de ácido de amonio',10,'28','2826','282611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28261190','Outros fluoretos de amônio ou de sódio','Other fluoride of ammonium or of sodium','Los demás fluoruros de amonio o de sodio',10,'28','2826','282611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28261200','Fluoretos de alumínio','Fluoride of aluminium','Fluoruros de aluminio',10,'28','2826','282612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28261910','Trifluoreto de cromo','Fluoride of aluminium','Trifluoruro de cromo',10,'28','2826','282619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28261920','Fluoreto ácido de amônio','Ammonium acid fluoride','Fluoruros de ácido de amonio',10,'28','2826','282619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28261990','Outros fluoretos','Other fluoride','Los demás fluoruros',10,'28','2826','282619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28262000','Fluossilicatos de sódio ou de potássio','Fluorosilicates of sodium or of potassium','Fluorosilicatos de sodio o potasio',10,'28','2826','282620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28263000','Hexafluoraluminato de sódio (criolita sintética)','Sodium hexafluoroaluminate (synthetic cryolite)','Hexafluoroaluminato de sodio (criolita sintética)',10,'28','2826','282630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28269000','Outs.fluossilicatos, fluoraluminatos, sais complexs.fluor','Other fluorosilicates, fluoroaluminates, complex fluorine salts','Otros fluorosilicatos, fluorolumin.sales compl.flúor',10,'28','2826','282690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28269010','Fluoraluminato de potássio','Fluoroaluminates of potassium','Fluoroluminato de potasio',10,'28','2826','282690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28269020','Fluossilicatos de sódio ou de potássio','Other fluorosilicates, fluoroaluminates, complex fluorine salts','Otros fluorosilicatos, fluorolumin.sales compl.flúor',10,'28','2826','282690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28269090','Outs.fluossilicatos, fluoraliminatos, sais complexs.fluor','Ot.fluorosilicates, fluoroaluminates, comp.fluorine salts','Los dem.fluorosilicatos, fluorolumin.sales compl.flúor',10,'28','2826','282690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28271000','Cloreto de amônio','Ammonium chloride','Cloruro de amonio',10,'28','2827','282710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28272010','Cloreto de cálcio, com teor>=98% de cacl2, em base seca','Calcium chlor.cont>=98%by wei.on the dry prod.of cacl2','Cloruro de calcio, c/un cont.de cacl2 >= 98%en base seca',10,'28','2827','282720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28272090','Outros cloretos de cálcio','Other calcium chloride','Los demás cloruros de calcio',10,'28','2827','282720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273110','Cloreto de magnésio, com teor<98% mgcl2 e teor<=0.5% ca','Magnesium chloride cont.<98%by wei.of mgcl2 and<=0.5%ca','Cloruro de magnesio, c/cont.mgcl2<98%, c/cont.ca<=0.5%',10,'28','2827','282731');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273190','Outros cloretos de magnésio','Other magnesium chloride','Los demás cloruros de magnesio',10,'28','2827','282731');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273200','Cloreto de alumínio','Aluminium chloride','Cloruro de aluminio',10,'28','2827','282732');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273300','Cloreto de ferro','Iron chloride','Cloruro de hierro',10,'28','2827','282733');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273400','Cloreto de cobalto','Cobalt chloride','Cloruro de cobalto',10,'28','2827','282734');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273500','Cloreto de níquel','Nickel chloride','Cloruro de níquel',10,'28','2827','282735');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273600','Cloreto de zinco','Zinc chloride','Cloruro de cinc',10,'28','2827','282736');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273800','Cloreto de bário','Barium chloride','Cloruro de bario',10,'28','2827','282738');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273910','Cloreto de cobre i (cloreto cuproso, monocloreto cobre)','Cuprous chloride (copper monochloride)','Cloruro de cobre i(cloruro cuproso o monocloruro cobre)',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273920','Cloreto de titânio','Titanium chloride','Cloruro de titanio',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273930','Cloreto de mercúrio i (cloreto mercuroso)','Mercuric chloride (mercuric chloride)','Cloruro de mercurio i (cloruro mercuroso)',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273931','Cloreto de mercúrio i (cloreto mercuroso)','Mercuric chloride (mercuric chloride)','Cloruro de mercurio i (cloruro mercuroso)',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273932','Cloreto de mercúrio ii (cloreto mercurico)','Mercuric chloride (mercuric chloride)','Cloruro de mercurio ii (cloruro mercúrico)',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273940','Cloreto de zircônio','Zirconium chloride','Cloruro de circonio',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273950','Cloreto de antimônio','Antimony chloride','Cloruro de antimonio',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273960','Cloreto de litio','Lithium chloride','Cloruro de litio',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273970','Cloreto de bismuto','Bismuth chloride','Cloruro de bismuto',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273991','Cloreto de cádmio','Cadmium chloride','Cloruro de cadmio',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273992','Cloreto de césio','Caesium chloride','Cloruro de cesio',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273993','Cloreto de cromo','Chromium clhoride','Cloruro de cromo',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273994','Cloreto de estrôncio','Strontium chloride','Cloruro de estroncio',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273995','Cloreto de manganês','Manganese chloride','Cloruro de manganeso',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273996','Cloreto de ferro','Iron chloride','Cloruro de hierro',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273997','Cloreto de cobalto','Cobalt chloride','Cloruro de cobalto',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273998','Cloreto de zinco','Zinc chloride','Cloruro de cinc',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28273999','Outros cloretos','Other chloride','Los demás cloruros',10,'28','2827','282739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28274110','Oxicloretos de cobre','Copper chloride oxides','Oxicloruros de cobre',10,'28','2827','282741');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28274120','Hidroxicloretos de cobre','Copper chloride hydroxides','Hidroxicloruros de cobre',10,'28','2827','282741');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28274911','Oxicloretos de bismuto','Bismuth chloride oxides','Oxicloruros de bismuto',10,'28','2827','282749');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28274912','Oxicloretos de zircônio','Zirconium chloride oxides','Oxicloruros de circonio',10,'28','2827','282749');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28274919','Outros oxicloretos','Other chloride oxides','Los demás oxicloruros',10,'28','2827','282749');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28274921','Hidroxicloretos de alumínio','Aluminium chloride hydroxides','Hidroxicloruros de aluminio',10,'28','2827','282749');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28274929','Outros hidroxicloretos','Other chloride oxides','Los demás hidroxicloruros',10,'28','2827','282749');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28275100','Brometos de sódio ou de potássio','Bromides of sodium or of potassium','Bromuros de sodio o de potasio',10,'28','2827','282751');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28275900','Outros brometos e oxibrometos','Other bromides and bromide oxides','Los demás bromuros y oxibromuros',10,'28','2827','282759');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28276011','Iodetos de sódio','Iodides of sodium','Yoduros de sodio',10,'28','2827','282760');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28276012','Iodetos de potássio','Iodides  of potassium','Yoduros de potasio',10,'28','2827','282760');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28276019','Outros iodetos','Other iodides oxides','Los demás yoduros',10,'28','2827','282760');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28276021','Oxiiodetos de potássio','Potassium iodides oxides','Oxiyoduros de potasio',10,'28','2827','282760');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28276029','Outros oxiiodetos','Other iodides oxides','Los demás oxiyoduros',10,'28','2827','282760');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28281000','Hipocloritos de cálcio, inclusive o comercial','Calcium hypochlorite, incl.commercial','Hipocloritos de calcio,  incluso el comercial',10,'28','2828','282810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28289011','Hipocloritos de sódio','Sodium hypochlorite','Hipocloritos de sodio',10,'28','2828','282890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28289019','Outros hipocloritos','Other hypochlorite','Los demás hipocloritos',10,'28','2828','282890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28289020','Clorito de sódio','Sodium chlorite','Clorito de sodio',10,'28','2828','282890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28289090','Outros cloritos e hipobromitos','Other hypobromites chlorite','Los demás cloritos y hipobromitos',10,'28','2828','282890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28291100','Cloratos de sódio','Sodium chlorates','Cloratos de sodio',10,'28','2829','282911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28291910','Cloratos de cálcio','Calcium chlorates','Cloratos de calcio',10,'28','2829','282919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28291920','Cloratos de potássio','Potassium chlorates','Cloratos de potasio',10,'28','2829','282919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28291990','Outros cloratos','Others chlorates','Los demás cloratos',10,'28','2829','282919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28299011','Bromatos de sódio','Sodium bromates','Bromatos de sodio',10,'28','2829','282990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28299012','Bromatos de potássio','Potassium bromates','Bromatos de potasio',10,'28','2829','282990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28299019','Outros bromatos','Other bromates','Los demás bromatos',10,'28','2829','282990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28299021','Perbromatos de sódio','Sodium perbromates','Perbromatos de sodio',10,'28','2829','282990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28299022','Perbromatos de potássio','Potassium perbromates','Perbromatos de potasio',10,'28','2829','282990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28299029','Outros perbromatos','Other perbromates','Los demás perbromatos',10,'28','2829','282990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28299031','Iodatos de potássio','Potassium iodates','Yodatos de potasio',10,'28','2829','282990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28299032','Iodatos de cálcio','Calcium iodates','Yodatos de calcio',10,'28','2829','282990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28299039','Outros iodatos','Others iodates','Los demás yodatos',10,'28','2829','282990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28299040','Periodatos','Periodates','Peryodatos',10,'28','2829','282990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28299050','Percloratos','Perchlorates','Percloratos',10,'28','2829','282990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28301010','Sulfeto de dissódio','Sodium sulphides','Sulfuros de disodio',10,'28','2830','283010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28301020','Sulfeto de monossódio (hidrogenossulfeto de sódio)','Sodium hydrogen sulphide','Sulfuros de monosodio (hidrogenosulfuro de sodio)',10,'28','2830','283010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28302000','Sulfeto de zinco','Zinc sulphide','Sulfuro de cinc',10,'28','2830','283020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28303000','Sulfeto de cádmio','Cadmium sulphide','Sulfuro de cadmio',10,'28','2830','283030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28309011','Sulfetos de molibnedio iv (dissulfeto de molibdénio)','Molybdenum disulphide','Sulfuro de molibdeno iv (disulfuro de molibdeno)',10,'28','2830','283090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28309012','Sulfeto de bário','Barium sulphides','Sulfuro de bario',10,'28','2830','283090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28309013','Sulfeto de potássio','Potassium sulphides','Sulfuro de potasio',10,'28','2830','283090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28309014','Sulfeto de chumbo','Lead sulphides','Sulfuro de plomo',10,'28','2830','283090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28309015','Sulfeto de estrôncio','Strontium sulphides','Sulfuro de estroncio',10,'28','2830','283090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28309016','Sulfeto de zinco','Zinc sulphide','Sulfuro de cinc',10,'28','2830','283090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28309019','Outros sulfetos','Other sulphides','Los demás sulfuros',10,'28','2830','283090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28309020','Polissulfetos','Polysulphides','Polisulfuros',10,'28','2830','283090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28311011','Ditionitos (hidrossulfitos) de sódio estabilizados','Dithionites(sulphides hydroxides)of sodium stabilized','Ditionitos (hidrosulfitos) de sodio estabilizados',10,'28','2831','283110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28311019','Outros ditionitos (hidrossulfitos) de sódio','Other dithionites(sulphides hydroxides)of sodium','Los dem.ditionitos (hidrosulfitos) de sodio',10,'28','2831','283110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28311021','Sulfoxilatos de sódio, estabilizados com formaldeído','Sodium sulphoxylates, stabilized with formaldehyde','Sulfoxilatos de sodio, estabilizados con formaldehído',10,'28','2831','283110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28311029','Outros sulfoxilatos de sódio','Other sodium sulphoxylates','Los demás sulfoxilatos de sodio',10,'28','2831','283110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28319010','Ditionito de zinco','Zinc dithionites','Ditionito de cinc',10,'28','2831','283190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28319090','Outros ditionitos e sulfoxilatos','Other dithionites and sulphoxylates','Los demás ditionitos y sulfoxilatos',10,'28','2831','283190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28321010','Sulfito de dissódio','Disodium sulphites','Sulfitos de disodio',10,'28','2832','283210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28321090','Outros sulfitos de sódio','Other disodium sulphites','Los demás sulfitos de sodio',10,'28','2832','283210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28322000','Outros sulfitos','Other sulphites','Los demás sulfitos',10,'28','2832','283220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28323010','Tiossulfato de amônio','Ammonium thiosulphates','Tiosulfato de amonio',10,'28','2832','283230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28323020','Tiossulfato de sódio','Sodium thiosulphates','Tiosulfato de sodio',10,'28','2832','283230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28323090','Outros tiossulfatos','Other thiosulphates','Los demás tiosulfatos',10,'28','2832','283230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28331110','Sulfato dissódico anidro','Anhydrous disodium sulphate','Sulfato de disodio anhidro',10,'28','2833','283311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28331190','Outros sulfatos dissódicos','Other disodium sulphate','Los demás sulfatos de disodio',10,'28','2833','283311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28331900','Outros sulfatos de sódio','Other sodium sulphate','Los demás sulfatos de sodio',10,'28','2833','283319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332100','Sulfato de magnésio','Magnesium sulphate','Sulfato de magnesio',10,'28','2833','283321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332200','Sulfato de alumínio','Aluminiium sulphate','Sulfato de aluminio',10,'28','2833','283322');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332300','Sulfato de cromo','Chromium sulphate','Sulfato de cromo',10,'28','2833','283323');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332400','Sulfato de niquel','Nickel sulphate','Sulfato de níquel',10,'28','2833','283324');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332510','Sulfato cuproso','Cuprous sulphate','Sulfato cuproso',10,'28','2833','283325');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332520','Sulfato cuprico','Cupric sulphate','Sulfato cúprico',10,'28','2833','283325');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332600','Sulfato de zinco','Zinc sulphates','Sulfato de cinc',10,'28','2833','283326');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332710','Sulfato de bário com teor em peso>=97.5% de baso4','Barium sulphate containing>=97.5%, by weight of baso4','Sulfato de bario c/cont.de baso4>=97, 5%en peso',10,'28','2833','283327');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332790','Outros sulfatos de bário','Other barium sulphates','Los demás sulfatos de bario',10,'28','2833','283327');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332910','Sulfato de antimônio','Antimony sulphate','Sulfato de antimonio',10,'28','2833','283329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332920','Sulfato de lítio','Lithium sulphate','Sulfato de litio',10,'28','2833','283329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332930','Sulfato de estrôncio','Strontium sulphate','Sulfato de estroncio',10,'28','2833','283329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332940','Sulfato ferroso','Mercury sulphate','Sulfato de mercurio',10,'28','2833','283329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332950','Sulfato neutro de chumbo','Lead neutral sulphate','Sulfato neutro de plomo',10,'28','2833','283329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332960','Sulfatos de cromo','Cromium sulphates','Sulfato de cromo',10,'28','2833','283329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332970','Sulfatos de zinco','Zinc sulphates','Sulfatos de cinc',10,'28','2833','283329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28332990','Outros sulfatos','Other sulphates','Los demás sulfatos',10,'28','2833','283329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28333000','Alumes','Alums','Alumbres',10,'28','2833','283330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28334010','Peroxossulfato (persulfato) de sódio','Peroxosulphates (persulphates) of sodium','Peroxosulfatos (persulfatos) de sodio',10,'28','2833','283340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28334020','Peroxossulfato (persulfato) de amônio','Peroxosulphates (persulphates) of antimony','Peroxosulfatos (persulfatos) de amonio',10,'28','2833','283340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28334090','Outros peroxossulfatos (persulfatos)','Other peroxosulphates (persulphates)','Los demás peroxosulfatos (persulfatos)',10,'28','2833','283340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28341010','Nitrito de sódio','Sodium nitrite','Nitrito de sodio',10,'28','2834','283410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28341090','Outros nitritos','Other nitrites','Los demás nitritos',10,'28','2834','283410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28342110','Nitrato de potássio, com teor em peso<=98% de kno3','Potassium nitrite containing<=98% by weight of kno3','Nitrato de potasio, c/contenido de kno3<= al 98% en peso',10,'28','2834','283421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28342190','Outros nitratos de potássio','Other potassium nitrites','Los demás nitratos de potasio',10,'28','2834','283421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28342200','Nitrato de bismuto','Bismuth nitrate','Nitrato de bismuto',10,'28','2834','283422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28342910','Nitrato de cálcio com teor em peso<=16% de nitrogênio','Calcium nitrite cont.<=16% by weight of nitrogen','Nitrato de calcio, c/cont.de nitrógeno<= al 16%, en peso',10,'28','2834','283429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28342920','Nitrato de mercucio','Mercury nitrite','Nitrato de mercurio',10,'28','2834','283429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28342930','Nitrato de alumínio','Aluminium nitrite','Nitrato de aluminio',10,'28','2834','283429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28342940','Nitrato de litio','Lithium nitrite','Nitrato de litio',10,'28','2834','283429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28342990','Outros nitratos','Other nitrates','Los demás nitratos',10,'28','2834','283429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28351011','Fosfinato (hipofosfito) de sódio','Phosphinate (hypophosphites) of sodium','Fosfinatos (hipofosfitos) de sodio',10,'28','2835','283510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28351019','Outros fosfinatos (hipofosfitos)','Other phosphinates (hypophosphites)','Los demás fosfinatos (hipofosfitos)',10,'28','2835','283510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28351021','Fosfonato (fosfito) dibasico de chumbo','Phosphinates (phosphites) dibasic of lead','Fosfonatos (fosfitos) dibásico de plomo',10,'28','2835','283510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28351029','Outros fosfonatos (fosfitos)','Other phosphonates (phosphites)','Los demás fosfonatos (fosfitos)',10,'28','2835','283510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28352200','Fosfato mono ou dissódico','Phosphates of mono or disodium','Fosfato de monosodio o disodio',10,'28','2835','283522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28352300','Fosfato de trissódio','Phosphates of trisodium','Fosfato de trisodio',10,'28','2835','283523');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28352400','Fosfato de potássio','Phosphates of potassium','Fosfato de potasio',10,'28','2835','283524');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28352500','Fosfato hidrogeno-ortofosfato de cálcio (dicalcico)','Calcium hydrogenorthophosphate (dicalcium phosphate)','Hidrogenoortofosfato de calcio (dicálcico)',10,'28','2835','283525');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28352600','Outros fosfatos de cálcio','Other phosphates of calcium','Los demás fosfatos de calcio',10,'28','2835','283526');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28352910','Fosfato de ferro','Iron phosphate','Fosfato de hierro',10,'28','2835','283529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28352920','Fosfato de cobalto','Phosphate cobalt','Fosfato de cobalto',10,'28','2835','283529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28352930','Fosfato de cobre','Phosphaste copper','Fosfato de cobre',10,'28','2835','283529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28352940','Fosfato de cromo','Phosphate chromium','Fosfato de cromo',10,'28','2835','283529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28352950','Fosfato de estrôncio','Phosphate strontium','Fosfato de estroncio',10,'28','2835','283529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28352960','Fosfato de manganês','Manganese phosphates','Fosfato de manganeso',10,'28','2835','283529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28352970','Fosfato de triamônio','Triammonium phosphate','Fosfato de triamonio',10,'28','2835','283529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28352980','Fosfato de trissódio','Trisodium phosphate','Fosfato de trisodio',10,'28','2835','283529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28352990','Outros fosfatos','Other phosphates','Los demás fosfatos',10,'28','2835','283529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28353100','Trifosfato de sódio (tripolifosfato de sódio)','Sodium triphosphate (sodium polyphosphates)','Trifosfato de sodio (tripolifosfato de sodio)',10,'28','2835','283531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28353110','Trifosfato de sódio, grau alimenticio (fao-oms)','Sodium triphosphates, nutritious degree (fao-oms)','Trifosfato de sodio,  grado alimentício (fao-oms)',10,'28','2835','283531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28353190','Outs.trifosfatos de sódio (tripolifosfato de sódio)','Other sodium triphosphate (sodium tripolyphosphate)','Los demás trifosfatos de sodio(tripolifosfato de sodio)',10,'28','2835','283531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28353910','Metafosfatos de sódio','Sodium metaphosphate','Metafosfatos de sodio',10,'28','2835','283539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28353920','Pirofosfatos de sódio','Sodium pyrophosphate','Pirofosfatos de sodio',10,'28','2835','283539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28353930','Pirofosfato de zinco','Zinc pyrophosphate','Pirofosfato de cinc',10,'28','2835','283539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28353990','Outros polifosfatos','Other phosphinates','Los demás polifosfatos',10,'28','2835','283539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28361000','Carbonatos de amônio inclusive o comercial','Ammonium carbonate, including commercial','Carbonato de amonio,  incluso el comercial',10,'28','2836','283610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28362010','Carbonato dissódico anidro','Anhydrous disodium carbonate','Carbonato de disodio anhidro',10,'28','2836','283620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28362090','Outros carbonatos dissódicos','Other disodium carbonate','Los demás carbonatos de disodio',10,'28','2836','283620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28363000','Hidrogenocarbonato (bicarbonato) de sódio','Sodium hydrogencarbonate (bicarbonate) of sodium','Hidrogenocarbonato (bicarbonato) de sodio',10,'28','2836','283630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28364000','Carbonatos de potássio','Potassium carbonates','Carbonatos de potasio',10,'28','2836','283640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28365000','Carbonato de cálcio','Calcium carbonate','Carbonatos de calcio',10,'28','2836','283650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28366000','Carbonato de bário','Barium carbonate','Carbonatos de bario',10,'28','2836','283660');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28367000','Carbonato de chumbo','Lead carbonate','Carbonatos de plomo',10,'28','2836','283670');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28369100','Carbonatos de litio','Lithium carbonates','Carbonatos de litio',10,'28','2836','283691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28369200','Carbonato de estrôncio','Strontium carbonate','Carbonatos de estroncio',10,'28','2836','283692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28369911','Carbonato de magnésio com densidade<200kg/m3','Magnesium carbonate with density<200 kg/m3','Carbonato de magnesio,  de densidad < 200 kg/m³',10,'28','2836','283699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28369912','Carbonato de zircônio','Zirconium carbonate','Carbonato de circonio',10,'28','2836','283699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28369913','Carbonatos de amônio, inclusive o comercial','Ammonium carbonate, including commercial','Carbonato de amonio,  incluso el comercial',10,'28','2836','283699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28369919','Outros carbonatos','Other carbonates','Otros carbonatos',10,'28','2836','283699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28369920','Peroxocarbonatos (percarbonatos)','Peroxocarbonates (percarbonates)','Peroxocarbonatos (percarbonatos)',10,'28','2836','283699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28371100','Cianeto e oxicianeto de sódio','Sodium cyanides and cyanide oxides','Cianuro y oxicianuro de sodio',10,'28','2837','283711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28371911','Cianeto de potássio','Potassium cyanide','Cianuro de potasio',10,'28','2837','283719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28371912','Cianeto de zinco','Zinc cyanide','Cianuro de cinc',10,'28','2837','283719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28371913','Cianeto de mercúrio','Cyanides of mercury','Cianuro de mercurio',10,'28','2837','283719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28371914','Cianeto de cobre i (cianeto cuproso)','Cuprous cyanides','Cianuro de cobre i (cianuro cuproso)',10,'28','2837','283719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28371915','Cianeto de cobre ii (cianeto cuprico)','Cupric cyanide','Cianuro de cobre ii (cianuro cúprico)',10,'28','2837','283719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28371919','Outros cianetos','Other cyanides','Los demás cianuros',10,'28','2837','283719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28371920','Outros oxianetos','Other cyanides oxides','Los demás oxicianuros',10,'28','2837','283719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28372011','Ferrocianeto de sódio','Sodium ferrocyanide','Ferrocianuro de sodio',10,'28','2837','283720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28372012','Ferrocianeto de ferro ii (ferrocianeto ferroso)','Ferrous ferrocyanide (ferrous ferrocyanide)','Ferrocianuro de hierro ii (ferrocianuro ferroso)',10,'28','2837','283720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28372019','Outros ferrocianetos','Other ferrocyanides','Los demás ferrocianuros',10,'28','2837','283720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28372021','Ferricianeto de potássio','Potassium ferricyanide','Ferricianuros de potasio',10,'28','2837','283720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28372022','Ferricianeto de ferro ii (ferricianeto ferroso)','Ferrous ferricyanide (ferrous ferricyanide)','Ferricianuro de hierro ii (ferrocianuro ferroso)',10,'28','2837','283720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28372023','Ferricianeto de ferro iii (ferricianeto ferrico)','Ferrous ferricyanide (ferrous ferricyanide)','Ferricianuro de hierro iii (ferrocianuro)',10,'28','2837','283720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28372029','Outros ferricianetos','Other ferricyanides','Los demás ferricianuros',10,'28','2837','283720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28372090','Outros cianetos complexos','Other complex cyanides','Los demás cianuros complejos',10,'28','2837','283720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28380010','Tiocianato de sódio','Sodium thiocyanates','Tiocianato de sodio',10,'28','2838','283800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28380090','Fulminatos, cianatos e outros tiocianatos','Fulminates, cyanates and other thiocyanates','Fulminatos,  cianatos y demás tiocianatos',10,'28','2838','283800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28391100','Metassilicatos de sódio','Sodium metasilicates','Metasilicato de sodio',10,'28','2839','283911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28391900','Outros silicatos de sódio','Other sodium silicates','Los demás silicatos de sodio',10,'28','2839','283919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28392000','Silicato de potássio','Potassium silicate','Silicato de potasio',10,'28','2839','283920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28399010','Silicato de magnésio','Magnesium metasilicates','Silicato de magneso',10,'28','2839','283990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28399020','Silicato de alumínio','Aluminium silicates','Silicato de aluminio',10,'28','2839','283990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28399030','Silicato de zircônio','Zirconium silicates','Silicato de circonio',10,'28','2839','283990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28399040','Silicato de chumbo','Lead silicates','Silicato de plomo',10,'28','2839','283990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28399050','Silicato de potássio','Potassium silicate','Silicato de potasio',10,'28','2839','283990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28399090','Outros silicatos','Other silicates','Los demás silicatos',10,'28','2839','283990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28401100','Tetraborato dissódico (borax refinado) anidro','Anhydrous disodium tetraborate (refined borax)','Tetraborato de disodio (bórax rerfinado) anhidro',10,'28','2840','284011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28401900','Outros tetraboratos dissódicos (borax refinado)','Other disodium tetraborate (refined borax)','Los demás tetraboratos de disodio (bórax rerfinado)',10,'28','2840','284019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28402000','Outros boratos','Other borates','Los demás boratos',10,'28','2840','284020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28403000','Peroxoboratos (perboratos)','Peroxoborates (perborates)','Peroxoboratos (perboratos)',10,'28','2840','284030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28411010','Aluminato de sódio','Sodium aluminate','Aluminato de sodio',10,'28','2841','284110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28411020','Aluminato de magnésio','Magnesium aluminate','Aluminato de magnesio',10,'28','2841','284110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28411030','Aluminato de bismuto','Bismuth aluminate','Aluminato de bismuto',10,'28','2841','284110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28411090','Outros aluminatos','Other aluminates','Los demás aluminatos',10,'28','2841','284110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28412000','Cromatos de zinco ou de chumbo','Chromates of zinc or of lead','Cromatos de cinc o plomo',10,'28','2841','284120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28413000','Dicromato de sódio','Sodium dichromate','Dicromato de sodio',10,'28','2841','284130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28414000','Dicromato de potássio','Potassium dichromate','Dicromato de potasio',10,'28','2841','284140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28415011','Cromato de amônio e dicromato de amônio','Ammonium chromate and ammonium dichromate','Cromato de amonio y dicromato de amonio',10,'28','2841','284150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28415012','Cromato de potássio','Potassium chromate','Cromato de potasio',10,'28','2841','284150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28415013','Cromato de sódio','Sodium chromate','Cromato de sodio',10,'28','2841','284150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28415014','Dicromato de potássio','Potassium dichromate','Dicromato de potasio',10,'28','2841','284150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28415015','Cromato de zinco','Zinc chromate','Cromato de zinc',10,'28','2841','284150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28415016','Cromato de chumbo','Lead chromate','Cromato de plomo',10,'28','2841','284150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28415019','Outros cromatos e dicromatos','Other chromates and dichromate','Los demás cromatos y dicromatos',10,'28','2841','284150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28415020','Peroxocromatos','Peroxochromates','Peroxocromatos',10,'28','2841','284150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28416100','Permanganato de potássio','Potassium permanganates','Permanganato de potassio',10,'28','2841','284161');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28416910','Manganitos','Manganites','Manganitos',10,'28','2841','284169');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28416920','Manganatos','Manganates','Manganatos',10,'28','2841','284169');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28416930','Outros permanganatos','Other permanganates','Los demás permanganatos',10,'28','2841','284169');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28417010','Molibdato de amônio','Ammonium molybdate','Molibdato de amonio',10,'28','2841','284170');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28417020','Molibdato de sódio','Sodium molybdate','Molibdato de sodio',10,'28','2841','284170');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28417090','Outros molibdatos','Other molybdates','Los demás molibdatos',10,'28','2841','284170');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28418010','Tungstato (volframato) de amônio','Tungstate (wolframates) of ammonium','Volframato (tungstato) de amonio',10,'28','2841','284180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28418020','Tungstato (volframato) de chumbo','Tungstate (wolframates) of lead','Volframato (tungstato) de plomo',10,'28','2841','284180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28418090','Outros tungstatos (volframatos)','Other tungstates (wolframates)','Los demás volframatos (tungstatos)',10,'28','2841','284180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419011','Titanato de chumbo','Lead titanate','Titanato de plomo',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419012','Titanatos de bário ou de bismuto','Titanate of barium or of bismuth','Titanatos de bario o de bismuto',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419013','Titanatos de cálcio ou de estrôncio','Titanate of calcium or of stroncium','Titanatos de calcio o de estroncio',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419014','Titanato de magnésio','Magnesium titanate','Titanato de magnesio',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419015','Titanatos de lantanio ou de neodimio','Titanate of lanthanum or of neodymium','Titanatos de lantanio o de neodimio',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419019','Outros titanatos','Other titanate','Los demás titanatos',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419021','Ferrito de bário','Barium ferrite','Ferrito de bario',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419022','Ferrito de estrôncio','Strontium ferrite','Estroncio de ferrita',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419029','Outros ferritos e ferratos','Other ferrites ferrates','Los demás ferritos y ferratos',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419030','Vanadatos','Vanadates','Vanadatos',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419041','Estanato de bário','Barium stannate','Estannato de bario',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419042','Estanato de bismuto','Bismuth stannate','Estannato de bismuto',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419043','Estanato de cálcio','Calcium stannate','Estannato de calcio',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419049','Outros estanatos','Other stannates','Los demás estannatos',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419050','Plumbatos','Plumbates','Plumbatos',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419060','Antimoniatos','Antimonates','Antimoniatos',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419070','Zincatos','Zincates','Cincatos',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419081','Aluminatos de sódio','Sodium aluminate','Aluminato de sodio',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419082','Aluminato de magnésio','Magnesium aluminate','Aluminato de magnesio',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419083','Aluminato de bismuto','Bismuth aluminate','Aluminato de bismuto',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419089','Outros aluminatos','Other aluminates','Otros aluminatos',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28419090','Outros sais dos acidos oxometálicos ou peroxometálicos','Other salts of oxometallic or peroxometallic acids','Los dem.sales de los ác.oxometalicos o peroxometalicos',10,'28','2841','284190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28421000','Silicatos duplos ou complexos','Double or complex silicates','Silicatos dobles o complejos',10,'28','2842','284210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28421010','Zeolitas utilizados como trocadores de íons','Zeolites of a kind used as ion exchangers fortreat.water','Zeolitas de los tip.util.como intercambiadores de iones',10,'28','2842','284210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28421090','Silicatos duplos ou complexos, exc.zeolitas','Double or complex silicates, except zeolites','Silicatos duplos o complexos,  excepto zeolitas',10,'28','2842','284210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28429000','Outros sais dos ácidos ou peroxoácidos inorgânicos','Other salts of inorganic acids or peroxoacids','Los dem.sales de los ácidos o peroxoacidos inorgánicos',10,'28','2842','284290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28431000','Metais preciosos no estado coloidal','Colloidal precious metals','Metales preciosos en estado coloidal',10,'28','2843','284310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28432100','Nitrato de prata','Silver nitrate','Nitrato de plata',10,'28','2843','284321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28432910','Vitelinato de prata','Silver vitellinate','Vitelinato de plata',10,'28','2843','284329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28432990','Outros compostos de prata','Other silver compounds','Otros compuestos de plata',10,'28','2843','284329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28433010','Sulfeto de ouro em dispersão de gelatina','Gold sulphide dispersed in gelatin','Sulfuro de oro en dispersión de gelatina',10,'28','2843','284330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28433090','Outs.compostos de ouro, exclusivamente auranofina, etc.','Oth.gold compounds  exclusively auranofin, etc.','Los dem.compuestos de oro, exclusivamente auranofina, etc',10,'28','2843','284330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28439000','Outs.compostos;amálgamas, exclusivam.carboplatina, etc.','Other compounds, amalgams, exclus.carboplatine, etc.','Los dem.compuestos;amalgamas, exclusiv.carboplatina, etc',10,'28','2843','284390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28439010','Tricloreto de rutênio','Ruthenium trichloride','Tricloruro de rutenio',10,'28','2843','284390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28439011','Dexormaplatina, enloplatina, etc.apresent.como medicam.','Dexormaplatine, enloplatine, etc.presented as medicine','Dexormaplatina, enloplatina, etc, present.como medicament.',10,'28','2843','284390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28439019','Dexormaplatina, enloplatina, etc.apresent.de out.forma','Dexormaplatine, enloplatine, etc.presented as other form','Dexormaplatina, enloplatina, etc, present.de otra forma',10,'28','2843','284390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28439090','Outs.compostos inorg/org.amálgamas, de metais preciosos','Ot.compounds, amalgams inorganic/organic, of precious met','Los dem.compuestos inorgán/orgán.amalgamas, de met.prec.',10,'28','2843','284390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28441000','Urânio natural e seus compostos, ligas, dispersões, etc.','Natural uranium and its compounds, alloys, dispers, etc','Uranio nat.y sus compuestos, aleaciones, dispersiones, etc',10,'28','2844','284410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28442000','Urânio enriquecido em u235, plutônio, seus compostos, etc.','Uranium enriched in u 235, plutonium, its compoundsm, etc','Uranio enriquecido en u235, plutonio, sus compuestos, etc',10,'28','2844','284420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28443000','Urânio empobrecido em u235, tório, seus compostos, etc.','Uranium depleted in u 235, thorium, its compounds, etc','Uranio empobrecido en u235,  torio,  sus compuestos,  etc.',10,'28','2844','284430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28444010','Molibdênio 99 absorv.em alumina, p/obtenção tecnecio 99','Molybdenum 99 abs.in alumina, forobtain.of tecnecio 99','Molibdeno 99 abs.en alúmina, apto p/la obt.de tecnecio99',10,'28','2844','284440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28444020','Cobalto 60','Cobalt 60','Cobalto 60',10,'28','2844','284440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28444030','Iodo 131','Iodine 131','Yodo 131',10,'28','2844','284440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28444090','Outros elementos, isotopos e compostos, radioativos, etc.','Oth.radioactive elements and isotopes and compounds, etc','Los dem.element.isótopos y compuestos, radiactivos, etc',10,'28','2844','284440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28445000','Elementos combustíveis, usados, de reatores nucleares','Spent fuel elements of nuclear reactors','Elementos combustibles, agotados, de reactores nucleares',10,'28','2844','284450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28451000','Água pesada (óxido de deutério)','Heavy water (deuterium oxide)','Agua pesada (óxido de deuterio)',10,'28','2845','284510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28459000','Outros isotopos e seus compostos inorgan.ou orgânicos','Other isotopes and their compounds inorg.or organic','Los dem.isótopos y sus compuest.inorgánicos o orgánicos',10,'28','2845','284590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28461010','Óxido cérico','Ceric oxide','Óxido cérico',10,'28','2846','284610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28461090','Outros compostos de cério','Other ceric compounds','Los demás compuestos de cério',10,'28','2846','284610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28469010','Óxido de praseodímio','Praseodymium oxide','Óxido de praseodimio',10,'28','2846','284690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28469020','Cloretos dos demais metais das terras raras','Other rare-earth metal chlorides','Cloruros de los demás metales de las tierras raras',10,'28','2846','284690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28469030','Gadopentetato de dimeglumina','Dimeglumine gadopentate','Gadopentetato de dimeglumina',10,'28','2846','284690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28469090','Outros compostos dos metais das terras raras, de ítrio, etc','Other compounds rare-earth metal, of yttrium, etc','Los dem.comp.de los met.de las tier.raras, de itrio, etc',10,'28','2846','284690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28470000','Peróxido de hidrogênio (água oxigenada)','Hydrogen peroxide','Peróxido de hidrógeno (agua oxigenada)',10,'28','2847','284700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28480010','Fosfeto de alumínio','Aluminium phosphide','Fosfuro de aluminio',10,'28','2848','284800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28480020','Fosfeto de magnésio','Magnesium phosphide','Fosfuro de magnesio',10,'28','2848','284800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28480030','Fosfeto de cobre, contendo peso > 15% de fósforo','Copper phosphide, weighing >15% phosphorus','Fosfuro de cobre, con contenido de fósforo>al 15%en peso',10,'28','2848','284800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28480090','Outros fosfetos de constituicao química definida ou nao','Other phosphides, whether or not chemically defined','Los dem.fosfuros aunq.n/sean de constit.quím.definida',10,'28','2848','284800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28491000','Carboneto de cálcio','Carbide of calcium','Carburo de calcio',10,'28','2849','284910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28492000','Carboneto de silício','Silicon carbide','Carburo de silicio',10,'28','2849','284920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28499010','Carboneto de boro','Boron carbide','Carburo de boro',10,'28','2849','284990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28499020','Carboneto de tântalo','Tantalum carbide','Carburo de tantalio',10,'28','2849','284990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28499030','Carboneto de tungstênio (volfrâmio)','Tungsten carbide (wolframates)','Carburo de tungsteno (volframio)',10,'28','2849','284990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28499090','Outros carbonetos de constit.química definida ou não','Other carbides whether or not chemically defined','Los dem.carburos aunq.n/sean de constit.quím.definida',10,'28','2849','284990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28500010','Nitreto de boro','Boron nitride','Nitruro de boro','19','28','2850','285000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28500020','Silicieto de cálcio','Calcium silicides','Siliciuro de calcio',10,'28','2850','285000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28500090','Hidretos, azidas, boretos e outros nitretos e silicietos','Hydrides, azides, borides and oth.nitrides and silicides','Hidruros, aziduros(azidas), boruros y dem.nitruros/silic.',10,'28','2850','285000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28510010','Cianamida e seus derivados metálicos','Cyanamide and its metal derivatives','Cianamida y sus derivados metálicos',10,'28','2851','285100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28510020','Sulfocloretos de fósforo','Phosphorus sulphide chlorides','Sulfocloruros de fósforo',10,'28','2851','285100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28510031','Cloreto de cianogênio','Cyanogen chloride','Cloruro de cianógeno',10,'28','2851','285100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28510039','Cianogenio e seus outros halogenetos','Cyanogen and its other halides','Cianógeno y sus demás halogenuros',10,'28','2851','285100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28510090','Outs.compostos inorgânicos, ar líquido, ar comprimido, etc','Other inorganic compounds, liquid air, compressed air, etc','Los dem.comp.inorgán., aire líquido, aire comprimido, etc',10,'28','2851','285100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28520011','Óxidos de mercúrio','Mercuric oxide','Óxido de mercurio',10,'28','2852','285200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28520012','Cloreto de mercúrio i; cloreto de mercúrio ii','Mercuric chloride i; mercurci chloride ii','Cloruro de mercurio i; cloruro de mercurio ii',10,'28','2852','285200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28520013','Cloreto de mercúrio ii, para uso fotográfico, para venda a varejo','Mercuric chloride ii, for photographic use, for retail sales','Cloruro de mercurio ii, para uso fotográfico, para venta a menudeo',10,'28','2852','285200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28520014','Cloreto de mercúrio ii, apresentado de outro modo','Mercuric chloride ii, presented in other form','Cloruro de mercurio ii, presentado de outra forma',10,'28','2852','285200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28520019','Outros comps. inorgs./organs. exc. amálgamas','Other organic and inorganic compounds, except amalgams','Otros compuestos orgánicos e inorgánicos, excepto amalgamas',10,'28','2852','285200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28520021','Acetato de mercúrio','Mercury acetate','Acetato de mercurio',10,'28','2852','285200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28520022','Timerosal','Thimerosal','Timerosal',10,'28','2852','285200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28520023','Estearato de mercúrio','Mercury stearate','Estearato de mercurio',10,'28','2852','285200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28520024','Lactato de mercúrio','Mercurt lactate','Lactato de mercurio',10,'28','2852','285200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28520025','Salicilato de mercúrio','Mercury salicylate','Salicilato de mercurio',10,'28','2852','285200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28520029','Outros compostos orgânicos de mercúrio','Other mercury organic compounds','Otros compuestos orgánicos de mercurio',10,'28','2852','285200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28521011','Oxidos de mercúrio, inorganicos','Oxides of mercury, inorganic','Oxidos de mercurio, inorgánicos',10,'28','2852','285210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28521012','Cloreto de mercúrio i (cloreto mercuroso)','Chloride mercury i (mercurous chloride)','Cloruro de mercurio i (cloruro de mercurio)',10,'28','2852','285210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28521013','Cloreto de mercúrio  ii (cloreto mercurico),p/uso foto.','Chloride mercury ii (cloruro de mercurio),f/photo','Cloruro de mercurio ii (cloruro de mercurio), p/foto',10,'28','2852','285210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28521014','Cloreto de mercúrio ii(cloreto mercurico),em outro modo','Chloride mercury ii (cloruro de mercurio),another form','Cloruro de mercurio ii(cloruro de mercurio),en outro mo',10,'28','2852','285210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28521019','Outros compostos inorgânicos de mercúrio','Other inorganic mercury compounds','Otros compuestos inorgánicos de mercurio',10,'28','2852','285210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28521021','Acetato de mercúrio','Acetate of mercury','Acetato de mercurio',10,'28','2852','285210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28521022','Timerosal','Thimerosal','Timerosal',10,'28','2852','285210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28521023','Estearato de mercúrio','Stereate of mercury','Estearato de mercurio',10,'28','2852','285210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28521024','Lactato de mercúrio','Lactate of mercury','Lactato de mercurio',10,'28','2852','285210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28521025','Salicilato de mercúrio','Salicylate of mercury','Salicitato de mercurio',10,'28','2852','285210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28521029','Outros compostos orgânicos de mercúrio','Other organic mercury compounds','Otros compuestos orgánicos de mercurio',10,'28','2852','285210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28529000','Outros compostos de mercúrio','Other compounds of mercury','Otros compuestos de mercurio',10,'28','2852','285290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28530010','Cianamida e seus derivados metálicos','Cyanamide and its metal derivatives','Cianamida y sus derivados metálicos',10,'28','2853','285300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28530020','Sulfocloretos de fósforo','Phosphorus sulphide chlorides','Sulfocloruros de fósforo',10,'28','2853','285300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28530031','Cloreto de cianogênio','Cyanogen chloride','Cloruro de cianógeno',10,'28','2853','285300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28530039','Outros cianogênios e seus halogenetos','Other cyanogen and their halides','Otros cianógenos y sus halogenuros',10,'28','2853','285300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('28530090','Outs.comp.inorg.;amálgamas, exc.d/met.prec.','Other inorganic compounds; amalgams, except of precious metals','Otros compuestos inorgánicos; amalgamas, excepto de metales preciosos',10,'28','2853','285300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29011000','Hidrocarbonetos acíclicos saturados','Acyclic hydrocarbons saturated','Hidrocarburos acíclicos saturados',10,'29','2901','290110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29012100','Etileno nao saturado','Ethylene not saturated','Etileno no saturado',10,'29','2901','290121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29012200','Propeno (propileno) não saturado','Propene (propylene) not saturated','Propeno (propileno) no saturado',10,'29','2901','290122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29012300','Buteno (butileno) não saturado e seus isômeros','Butene (butylene) not saturated and their isomers','Buteno (butileno) no saturado y sus isómeros',10,'29','2901','290123');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29012410','Buta-1, 3-dieno não saturado','Buta-1, 3-diene not saturated','Buta-1, 3-dieno no saturado',10,'29','2901','290124');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29012420','Isopreno nao saturado','Isoprene not saturated','Isopreno no saturado',10,'29','2901','290124');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29012900','Outros hidrocarbonetos acíclicos não saturados','Other acyclic hydrocarbons not saturated','Los demás hidrocarburos acíclicos no saturados',10,'29','2901','290129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29021100','Cicloexano','Cyclohexane','Ciclohexano',10,'29','2902','290211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29021910','Limoneno','Limonene','Limoneno',10,'29','2902','290219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29021990','Outs.hidrocarbonetos ciclanicos, ciclenicos, cicloterpen.','Other cyclanic, cyclenic, cycloterpenic hydrocarbons','Los dem.hidrocarburos ciclánicos, ciclénicos o cicloterp',10,'29','2902','290219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29022000','Benzeno','Benzene','Benceno',10,'29','2902','290220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29023000','Tolueno','Toluene','Tolueno',10,'29','2902','290230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29024100','O-xileno','Xylenes','O-xileno',10,'29','2902','290241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29024200','M-xileno','M-xylene','M-xileno',10,'29','2902','290242');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29024300','P-xileno','P-xylene','P-xileno',10,'29','2902','290243');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29024400','Mistura de isômeros do xileno','Mixed xylene isomers','Mezclas de isómeros del xileno',10,'29','2902','290244');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29025000','Estireno','Styrene','Estireno',10,'29','2902','290250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29026000','Etilbenzeno','Ethylbenzene','Etilbenceno',10,'29','2902','290260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29027000','Cumeno','Cumene','Cumeno',10,'29','2902','290270');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29029010','Difenila (1, 1-bifenila)','Diphenyl (1-biphenyl)','Difenilo (1, 1- bifenilo)',10,'29','2902','290290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29029020','Naftaleno (hidrocarboneto cíclico)','Naphthalene (cyclic hydrocarbon)','Naftaleno (hidrocarburo cíclico)',10,'29','2902','290290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29029030','Antraceno','Anthracene','Antraceno',10,'29','2902','290290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29029040','Alfa-metilestireno','A-methylstyrene','Alfa-metilestireno',10,'29','2902','290290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29029090','Outros hidrocarbonetos cíclicos','Other cyclic hydrocarbons','Los demás hidrocarburos cíclicos',10,'29','2902','290290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29031110','Clorometano (cloreto de metila)','Chloromethane (methyl chloride)','Clorometano (cloruro de metilo)',10,'29','2903','290311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29031120','Cloroetano (cloreto de etila)','Chloroethane (ethyl chloride)','Cloroetano (cloruro de etilo)',10,'29','2903','290311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29031200','Diclorometano (cloreto de metileno)','Dichloromethane (methylene chloride)','Diclorometano (cloruro de metileno)',10,'29','2903','290312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29031300','Cloroformio (triclorometano)','Chloroform (trichloromethane)','Cloroformo (triclorometano)',10,'29','2903','290313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29031400','Tetracloreto de carbono','Carbon tetrachloride','Tetracloruro de carbono',10,'29','2903','290314');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29031500','1, 2-dicloroetano (cloreto de etileno)','1, 2-dichloroethane (ethylene dichloride)','1, 2 - dicloroetano (dicloruro de etileno)',10,'29','2903','290315');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29031600','1, 2-dicloropropano (cloreto propileno) e diclorobutanos','1, 2-dichloropropene(propylene chloride)and dichlorobut.','1, 2 - dicloropropano(clor.de propileno)y diclorobutanos',10,'29','2903','290316');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29031910','1, 1, 1-tricloroetano (metilcloroformio)','1, 1, 1-trichloroethane (methyl chloroform)','1, 1, 1- tricloroetano (metilcloroformo)',10,'29','2903','290319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29031920','1, 1, 2-tricloroetano','1, 1, 2-trichloroethane','1, 1, 2 - tricloroetano',10,'29','2903','290319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29031990','Outs.derivados clorados saturad.dos hidrocarb.acíclicos','Other derivatives chlorinated saturated of cyclic hydrocarbons','Otros derivados clorados saturados de los hidrocarbonetos acíclicos',10,'29','2903','290319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29032100','Cloreto de vinila (cloroetileno)','Vinyl chloride (chloroethylene)','Cloruro de vinilo (cloroetileno)',10,'29','2903','290321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29032200','Tricloroetileno','Trichloroethylene','Tricloroetileno',10,'29','2903','290322');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29032300','Tetracloroetileno (percloroetileno)','Tetrachloroethylene (perchloroethylene)','Tetracloroetileno (percloroetileno)',10,'29','2903','290323');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29032900','Outs.derivs.clorados n/saturad.dos hidrocarb.acíclicos','Ot.derivatives chlor.n/satureted of cyclic hydrocarbons','Los dem.derivados clorad.n/satur.de los hidrocarb.acícl',10,'29','2903','290329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033011','1, 1, 1, 2-tetrafluoretano','1, 1, 1, 2-tetrafluoroethane','1, 1, 1, 2 -tetrafluoroetano',10,'29','2903','290330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033012','1, 1, 3, 3, 3-pentafluor-2-(trifluormetil)prop-1-eno','1, 1, 3, 3, 3-pentafluoro-2-(trifluoromethyl)prop-1-ene','1, 1, 3, 3, 3 - pentafluoro -2- (trifluorometil) prop-1-eno',10,'29','2903','290330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033019','Outs.derivados fluorados dos hidrocarbonetos acíclicos','Others fluorinated derivatives of acyclic hydrocarbons','Los dem.deriv.fluorados de los hidrocarburos acíclicos',10,'29','2903','290330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033021','Bromometano','Bromomethane','Bromometano',10,'29','2903','290330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033022','1, 2-dibromoetano','1, 2-dibromomethane','1, 2 - dibromoetano',10,'29','2903','290330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033029','Outs.derivados bromados dos hidrocarbonetos acíclicos','Others bromomethane derivatives of acyclic hydrocarbons','Los dem.derivad.bromados de los hidrocarburos acíclicos',10,'29','2903','290330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033031','Iodoetano','Iodoethane','Yodoetano',10,'29','2903','290330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033032','Iodoformio','Iodoform','Yodoformo',10,'29','2903','290330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033039','Outros derivados iodados dos hidrocarbonetos acíclicos','Others iodoethane derivatives of acyclic hydrocarbons','Otros derivados yodados de los hidrocarburos acíclicos',10,'29','2903','290330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033100','Dibrom.d/etileno (iso) (1, 2-dibromoetano)','Ethylene dibromomethane (iso) 1, 2-dibromomethane','Dibromometano de etileno (iso) 1, 2-dibromomethane',10,'29','2903','290331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033911','1, 1, 1, 2-tetrafluoretano','1, 1, 1, 2-tetrafluoroethane','1, 1, 1, 2 -tetrafluoroetano',10,'29','2903','290339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033912','1, 1, 3, 3, 3-pentafluor-2-(trifluormetil)prop-1-eno','1, 1, 3, 3, 3-pentafluoro-2-(trifluoromethyl)prop-1-ene','1, 1, 3, 3, 3 - pentafluoro -2- (trifluorometil) prop-1-eno',10,'29','2903','290339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033919','Outros derivados fluorados','Other fluorinated derivatives','Otros derivados fluorados',10,'29','2903','290339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033921','Bromometano','Bromomethane','Bromometano',10,'29','2903','290339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033929','Outros derivados bromados','Other brominated derivatives','Otros derivados bromados',10,'29','2903','290339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033931','Iodoetano','Iodoethane','Yodoetano',10,'29','2903','290339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033932','Iodofórmio','Iodoform','Yodoformo',10,'29','2903','290339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29033939','Outros derivados íodados','Others iodoethane derivatives','Los demás derivados yodados',10,'29','2903','290339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034100','Triclorofluormetano','Trichlorofluoromethane','Triclorofluorometano',10,'29','2903','290341');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034200','Diclorodifluormetano','Dichlorodifluoromethane','Diclorodifluorometano',10,'29','2903','290342');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034300','Triclorotrifluoretanos','Trichlorotrifluoroethanes','Triclorotrifluoroetanos',10,'29','2903','290343');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034400','Diclorotetrafluoretanos e cloropentafluoretano','Dichlorotetrafluoroethanes and chloropentafluoroethane','Diclorotetrafluoroetanos y cloropentafluoroetano',10,'29','2903','290344');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034510','Clorotrifluormetano','Chlorotrifluoromethane','Clorotrifluorometano',10,'29','2903','290345');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034520','Pentaclorofluoretano','Chlorotrifluoromethane','Pentaclorofluoroetano',10,'29','2903','290345');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034530','Tetraclorodifluoretanos','Tetrachlorodifluoroethanes','Tetraclorodifluoroetanos',10,'29','2903','290345');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034541','Heptaclorofluorpropanos','Heptachlorofluoropropanes','Heptaclorofluoropropanos',10,'29','2903','290345');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034542','Hexaclorodifluorpropanos','Hexachlorodifluoropropanes','Hexaclorodifluoropropanos',10,'29','2903','290345');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034543','Pentaclorotrifluorpropanos','Pentachlorotrifluoropropanes','Pentaclorotrifluoropropanos',10,'29','2903','290345');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034544','Tetraclorotetrafluorpropanos','Tetrachlorotetrafluoropropanes','Tetraclorotetrafluoropropanos',10,'29','2903','290345');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034545','Tricloropentafluorpropanos','Trichloropentafluoropropanes','Tricloropentafluoropropanos',10,'29','2903','290345');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034546','Dicloroexafluorpropanos','Dichlorohexafluoropropanes','Diclorohexafluoropropanos',10,'29','2903','290345');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034547','Cloroeptafluorpropanos','Chloroheptafluoropropanes','Cloroheptafluoropropanos',10,'29','2903','290345');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034590','Outs.derivs.peralog.dos hidrocarb.acicl.c/fluor e cloro','Ot.deriv.perhalogenat.acycl.hydr.with fluorine/chlorine','Los dem.deriv.perhalogenad.de hidroc.acíc.c/flúor/cloro',10,'29','2903','290345');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034600','Bromoclorodifluormetano, bromotrifluormetano, etc.','Bromochlorodifluoromethane, bromotrifluoromethane,  etc.','Bromoclorodifluorometano,  bromotrifluorometano,  etc.',10,'29','2903','290346');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034700','Outs.derivs.peralog.dos hidrocarb.acicl.c/2 halog.difer','Ot.deriv.perhalogenat.acycl.hydrocarb.with 2 halog.diff','Los dem.der.perhalog.de hidrocarb.acícl.c/dos halóg.dif',10,'29','2903','290347');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034911','Clorodifluormetano','Chlorodifluoromethane','Clorodifluorometano',10,'29','2903','290349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034912','Clorofluoretanos','Chlorodifluoromethane','Clorofluoroetanos',10,'29','2903','290349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034913','Diclorotrifluoretanos','Dichlorotrifluoroethanes','Diclorotrifluoroetanos',10,'29','2903','290349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034914','Clorotetrafluoretanos','Chlorotetrafluoroethanes','Clorotetrafluoroetanos',10,'29','2903','290349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034915','Diclorofluoretanos','Diclorofluoroethanes','Diclorofluoroetanos',10,'29','2903','290349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034916','Clorodifluoretanos','Clorodifluoroethanes','Clorodifluoroetanos',10,'29','2903','290349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034917','Dicloropentafluorpropanos','Dicloropentafluoropropanes','Dicloropentafluoropropanos',10,'29','2903','290349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034919','Outs.derivs.do metano, etano, etc.halogen.c/fluor e cloro','Ot.deriv.methane, ethane, etc.hal.with fluorine/chlorine','Los dem.deriv.del metano, etano, etc, halóg.c/flúor/cloro',10,'29','2903','290349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034920','Derivs.do metano, etano, propano, halogen.c/fluor e bromo','Deriva.methane, ethane, propane hal.with fluorine/bromine','Derivados del metano, etano, propano, halóg.c/flúor/bromo',10,'29','2903','290349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034931','Halotano (bromoclorotrifluoretano)','Halothane (bromochlorodifluoromethane)','Halotano (bromoclorotrifluoroetano)',10,'29','2903','290349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034939','Outros derivados do bromoclorotrifluoretano','Other derivatives of bromotrifluoromethane','Los demás derivados del bromoclorotrifluoroetano',10,'29','2903','290349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29034990','Outs.derivs.halogen.dos hidroc.acicl.c/2 halogen.difer.','Oth.deriv.halogenat.acycl.hydrocarb.with 2 halog.differ','Los dem.deriv.de los hidrocarbur.acícl.c/dos halóg.dif.',10,'29','2903','290349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29035110','Lindano (1, 2, 3, 4, 5, 6-hexaclorocicloexano)','Lindane (1, 2, 3, 4, 5, 6- hexachlorocyclohexane)','Lindano (1, 2, 3, 4, 5, 6- hexaclorocicloexano)',10,'29','2903','290351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29035190','Outros derivados do 1, 2, 3, 4, 5, 6-hexaclorocicloexano','Other derivative of(1, 2, 3, 4, 5, 6- hexachlorocyclohexane)','Los dem.derivados del 1, 2, 3, 4, 5, 6- hexaclorocicloexano',10,'29','2903','290351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29035210','Aldrin','Aldrin','Aldrin',10,'29','2903','290352');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29035220','Clordano','Chlordane','Clordano',10,'29','2903','290352');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29035230','Heptacloro','Heptachlor','Heptacloro',10,'29','2903','290352');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29035910','Aldrin (deriv.halogen.dos hidrocarbon.ciclanicos, etc.)','Aldrin (halogenated derivat.cyclanic hydrocarbons, etc.)','Aldrin(deriv.halogenados de los hidroc.ciclánicos, etc)',10,'29','2903','290359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29035920','Heptacloro (deriv.halogen.dos hidrocarb.ciclanicos, etc)','Heptachlor(halogen.derivat.cyclanic hydrocarb., etc.)','Heptacloro(deriv.halogenados de los hidroc.ciclán.etc)',10,'29','2903','290359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29035930','Clordano (deriv.halogen.dos hidrocarb.ciclanicos, etc)','Chlordan(halogen.derivat.cyclanic hydrocarb., etc.)','Clordano(deriv.halogenados de los hidrocar.ciclán.etc)',10,'29','2903','290359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29035940','Mirex (dodecacloro)(deriv.halogen.hidrocarb.ciclanicos)','Mirex (dechlorane) (halogen.deriv.cycl.hydrocarb.)','Mirex(dodecacloro)(deriv.halogen.de los hidroc.ciclán.)',10,'29','2903','290359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29035990','Outs.derivs.halogen.dos hidrocarbonetos ciclanicos, etc.','Other halogenated derivativ.cyclanic hydrocarbons, etc','Los dem.deriv.halogen.de los hidrocarburos ciclánic.etc',10,'29','2903','290359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036110','Clorobenzeno','Chlorobenzene','Clorobenceno',10,'29','2903','290361');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036120','O-diclorobenzeno','O-dichlorobenzene','O-diclorobenceno',10,'29','2903','290361');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036130','P-diclorobenzeno','P-dichlorobenzene','P-diclorobenceno',10,'29','2903','290361');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036210','Hexaclorobenzeno','Hexachlorobenzene','Hexaclorobenceno',10,'29','2903','290362');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036220','Ddt [1, 1, 1-tricloro-2, 2-bis(p-clorofenil)etano]','Ddt (1, 1, 1-trichloro-2, 2-bis(p-chlorophenyl)ethane','Ddt [1, 1, 1-tricloro-2, 2-bis (p-clorofenil) etano]',10,'29','2903','290362');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036911','Cloreto de benzila','Benzyl chloride','Cloruro de bencilo',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036912','P-clorotolueno','P-chlorotoluene','P-clorotolueno',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036913','Cloreto de neofila','Neophyl chloride','Cloruro de neófilo',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036914','Triclorobenzenos','Trichlorobenzenes','Triclorobencenos',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036915','Cloronaftalenos','Chloronaphthalenes','Cloronaftalenos',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036916','Cloreto de benzilideno','Benzylidene chloride','Cloruro de bencilideno',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036917','Cloretos de xilila','Xylyl chlorides','Cloruros de xililo',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036918','Bifenilas (pcb) ou terfenilas (pct) policloradas','Biphenyls(pcbs) terphenyls(pcts) polychlorinated','Bifenilos (pcb) o terfenilos (pct) policlorados',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036919','Outs.derivs.halogen.dos hidrocarb.aromáticos com cloro','Oth.halogenat.derivat.of hydrocar.aromatic w/chlorine','Los dem.deriv.halogen.de los hidrocarb.aromát.c/cloro',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036921','Bromobenzeno','Bromobenzene','Bromobenceno',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036922','Brometos de xilila','Xylyl bromides','Bromuros de xililo',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036923','Bromodifenilmetano','Bromodiphenylmethane','Bromodifenilmetano',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036924','Bifenilas polibromadas (pbb)','Polybrominated biphenyls (pbbs)','Bifenilos polibromados (pbb)',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036929','Outs.derivados halogen.dos hidrocarb.aromáticos c/bromo','Oth.halogenat.derivat.of hydrocar.aromatic w/bromine','Los dem.deriv.halogen.de los hidrocarb.aromát.c/bromo',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036931','4-cloro-alfa, alfa, alfa-trifluortolueno','4-chloro-a, a, a-trifluorotoluene','4- cloro- alfa,  alfa,  alfa- trifluorotolueno',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036939','Outs.derivs.halogen.dos hidrocarb.aromat.c/cloro, fluor','Oth.halogenat.derivat.of hydrocar.aromat.w/fluorin., chl','Los dem.deriv.halog.de los hidroc.aromát.c/cloro, flúor',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29036990','Outs.derivs.halogenados dos hidrocarbonetos aromáticos','Oth.halogenated derivatives of hydrocarborn aromatic','Los dem.deriv.halogenados de los hidrocarburos aromát.',10,'29','2903','290369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037100','Clorodifluorometanos','Clorodifluorometanos','Clorodifluorometanos',10,'29','2903','290371');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037200','Diclorotrifluoroetanos','Diclorotrifluoroetanos','Diclorotrifluoroetanos',10,'29','2903','290372');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037300','Diclorofluoroetanos','Diclorofluoroetanos','Diclorofluoroetanos',10,'29','2903','290373');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037400','Clorodifluoroetanos','Clorodifluoroetanos','Clorodifluoroetanos',10,'29','2903','290374');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037500','Dicloropentafluoropropanos','Dicloropentafluoropropanos','Dicloropentafluoropropanos',10,'29','2903','290375');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037600','Bromoclorodifluorometano, bromotrifluorometano, etc','Bromoclorodifluorometano, bromotrifluorometano, etc','Bromoclorodifluorometano, bromotrifluorometano, etc',10,'29','2903','290376');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037711','Triclorofluorometano','Triclorofluorometano','Triclorofluorometano',10,'29','2903','290377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037712','Diclorodifluorometano','Diclorodifluorometano','Diclorodifluorometano',10,'29','2903','290377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037713','Clorotrifluorometano','Clorotrifluorometano','Clorotrifluorometano',10,'29','2903','290377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037721','Triclorotrifluoroetanos','Triclorotrifluoroetanos','Triclorotrifluoroetanos',10,'29','2903','290377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037722','Diclorotetrafluoroetanos e cloropentafluoroetano','Diclorotetrafluoroetanos e cloropentafluoroetano','Diclorotetrafluoroetanos e cloropentafluoroetano',10,'29','2903','290377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037723','Pentaclorofluoroetano','Pentaclorofluoroetano','Pentaclorofluoroetano',10,'29','2903','290377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037724','Tetraclorodifluoroetanos','Tetraclorodifluoroetanos','Tetraclorodifluoroetanos',10,'29','2903','290377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037731','Heptaclorofluoropropanos','Heptaclorofluoropropanos','Heptaclorofluoropropanos',10,'29','2903','290377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037732','Hexaclorodifluoropropanos','Hexaclorodifluoropropanos','Hexaclorodifluoropropanos',10,'29','2903','290377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037733','Pentaclorotrifluoropropanos','Pentaclorotrifluoropropanos','Pentaclorotrifluoropropanos',10,'29','2903','290377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037734','Tetraclorotetrafluoropropanos','Tetraclorotetrafluoropropanos','Tetraclorotetrafluoropropanos',10,'29','2903','290377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037735','Tricloropentafluoropropanos','Tricloropentafluoropropanos','Tricloropentafluoropropanos',10,'29','2903','290377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037736','Dicloroexafluoropropanos','Dicloroexafluoropropanos','Dicloroexafluoropropanos',10,'29','2903','290377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037737','Cloroeptafluoropropanos','Cloroeptafluoropropanos','Cloroeptafluoropropanos',10,'29','2903','290377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037790','Outs.derivs.peralog.dos hidrocarb.acicl.c/fluor e cloro','Outs.derivs.peralog.dos hidrocarb.acicl.c/fluor e cloro','Outs.derivs.peralog.dos hidrocarb.acicl.c/fluor e cloro',10,'29','2903','290377');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037800','Outros derivados peralogenados','Other perhalogenated derivatives','Otros derivados perhalogenados',10,'29','2903','290378');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037911','Clorofluoroetanos','Clorofluoroetanos','Clorofluoroetanos',10,'29','2903','290379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037912','Clorotetrafluoroetanos','Clorotetrafluoroetanos','Clorotetrafluoroetanos',10,'29','2903','290379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037919','Outros derivados peralogenados','Other perhalogenated derivatives','Otros derivados perhalogenados',10,'29','2903','290379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037920','Derivados metano,etano ou propano,hal.com fluor e bromo','Derivados metano,etano ou propano,hal.com fluor e bromo','Derivados metano,etano ou propano,hal.com fluor e bromo',10,'29','2903','290379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037931','Halotano','Halothane','Halotano',10,'29','2903','290379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037939','Outros bromoclorotrifluoroetanos','Outros bromoclorotrifluoroetanos','Outros bromoclorotrifluoroetanos',10,'29','2903','290379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29037990','Outs.deriva. hal.dos hidrocar..aciclicos,min.2 hal.dif.','Outs.deriva. hal.dos hidrocar..aciclicos,min.2 hal.dif.','Outs.deriva. hal.dos hidrocar..aciclicos,min.2 hal.dif.',10,'29','2903','290379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29038110','Lindano','Lindane','Lindano',10,'29','2903','290381');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29038190','Outros 1,2,3,4,5,6-hexaclorocicloexano','Outros 1,2,3,4,5,6-hexaclorocicloexano','Outros 1,2,3,4,5,6-hexaclorocicloexano',10,'29','2903','290381');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29038210','Aldrin','Aldrin','Aldrin',10,'29','2903','290382');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29038220','Clordano','Chlordane','Clordano',10,'29','2903','290382');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29038230','Heptacloro','Heptachlor','Heptacloro',10,'29','2903','290382');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29038910','Mirex (dodecacloro)','Mirex (dodecachlorine)','Mirex (dodecacloro)',10,'29','2903','290389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29038990','Out.der.hal.dos hid.ciclanicos,ciclenicos ou cicloterp.','Out.der.hal.dos hid.ciclanicos,ciclenicos ou cicloterp.','Out.der.hal.dos hid.ciclanicos,ciclenicos ou cicloterp.',10,'29','2903','290389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039110','Clorobenzeno','Chlorobenzene','Clorobenceno',10,'29','2903','290391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039120','O-diclorobenzeno','O-dichlorobenzene','O-diclorobenceno',10,'29','2903','290391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039130','P-diclorobenzeno','P-dichlorobenzene','P-diclorobenceno',10,'29','2903','290391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039210','Hexaclorobenzeno','Hexachlorobenzene','Hexaclorobenceno',10,'29','2903','290392');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039220','DDT','DDT','DDT',10,'29','2903','290392');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039911','Cloreto de benzila','Benzyl chloride','Cloruro de bencilo',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039912','P-clorotolueno','P-chlorotoluene','P-clorotolueno',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039913','Cloreto de neofila','Neofila chloride','Cloruro de neofila',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039914','Triclorobenzenos','Trichlorobenzenes','Triclorobencenos',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039915','Cloronaftalenos','Cloronaftalenos','Cloronaftalenos',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039916','Cloreto de benzilideno','Benzylidene chloride','Cloruro de bencilideno',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039917','Cloretos de xilila','Xilila chloride','Cloruro de xilila',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039918','Bifenilas policloradas(pcb);terfenilas policloradas(pct','Bifenilas policloradas(pcb);terfenilas policloradas(pct','Bifenilas policloradas(pcb);terfenilas policloradas(pct',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039919','Outros derivados halogenados, unicamente com cloro','Other halogenated derivatives, solely with chlorine','Otros derivados halogenados, únicamente con cloro',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039921','Bromobenzeno','Bromobenzene','Bromobenceno',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039922','Brometos de xilila','Bromides xilila','Bromuros de xilila',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039923','Bromodifenilmetano','Brominediphenylmethane','Bromodifenilmetano',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039924','Bifenilas polibromadas (pbb)','Bifenilas polibromadas (pbb)','Bifenilas polibromadas (pbb)',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039929','Outros derivados halogenados, unicamente com bromo','Other halogenated derivatives, only with bromine','Otros derivados halogenados, sólo con bromo',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039931','4-cloro-alfa,alfa,alfa-trifluortolueno','4-cloro-alfa, alfa, alfa-trifuortoluene','4-cloro-alfa, alfa, alfa-trifluortolueno',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039939','Outros derivados halogenados,unicamente com fluor/cloro','Other halogenated derivatives, only with fluorine/chlo.','Otros derivados halogenados, sólo con flúor y cloro',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29039990','Outros derivados halogenados','Other halogenated derivatives','Otros derivados halogenados',10,'29','2903','290399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29041011','Acido metanossulfônico','Methane sulphonic acid','Ácido metanosulfónico',10,'29','2904','290410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29041012','Metanossulfonato de chumbo','Lead methanesulphonate','Metanosulfonato de plomo',10,'29','2904','290410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29041013','Metanossulfonato de estanho','Tin methanesulphonate','Metanosulfonato de estaño',10,'29','2904','290410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29041019','Outros derivados do ácido metanossulfonico e seus sais','Oth.derivatives of metasulphonates acid and their salts','Los dem.derivados del ácido metanosulfonico y sus sales',10,'29','2904','290410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29041020','Ácido dodecilbenzenossulfonico e seus sais','Dodecylbenzenesulphonic acid and its salts','Ácido dodecilbencenosulfonico y sus sales',10,'29','2904','290410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29041030','Ácido toluenossulfonico, xilenossulfonico e seus sais','Toluenesulphonic acids, xylenesulphonic and salts','Ácidos toluenosulfónicos,  xilenosulfónicos y sus sales',10,'29','2904','290410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29041040','Ácido etanossulfonico e ácido etilenossulfonico','Ethane sulphonic acid ethylenesulphonic acid','Ácido etanosulfónico y ácido etilenosulfónico',10,'29','2904','290410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29041051','Naftalenossulfonatos de sódio','Sodium naphthalenesulphonates','Naftalenosulfonatos de sodio',10,'29','2904','290410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29041052','Ácido beta-naftalenossulfonico','Beta-naphthalenesulphonic acid','Ácido beta-naftalenosulfónico',10,'29','2904','290410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29041053','Ácido alquil e diaquilnaftalenossulfonico e seus sais','Alkyl and dialkylnaphthalenesulphonic acids, their salts','Ác.alquil- y dialquil-naftalenosulfónico y sus sales',10,'29','2904','290410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29041059','Outs.ácidos naftalenossulfonicos, sais, ésteres etílicos','Oth.naphthalenesulphonic acid, salts and ethyl esters','Los dem.ác.naftalenosulfónicos, sales, ésteres etílicos',10,'29','2904','290410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29041060','Ácido benzenossulfonico e seus sais','Benzenesulphonic acid and its salts','Ácido bencenosulfónico y sus sales',10,'29','2904','290410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29041090','Outs.derivados sulfonados dos hidrocarbonetos, sais, etc.','Other derivatives sulphonated hydrocarbons, salts, etc','Los dem.deriv.sulfonados de los hidrocarburos, sales, etc',10,'29','2904','290410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29042010','Mononitrotoluenos (MNT)','Mononitrotoluenes (MNT)','Mononitrotoluenos (MNT)',10,'29','2904','290420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29042020','Nitropropanos','Nitropropanes','Nitropropanos',10,'29','2904','290420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29042030','Dinitrotoluenos','Dinitrotoluenes','Dinitrotoluenos',10,'29','2904','290420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29042041','2, 4, 6-trinitrotolueno (TNT)','2, 4, 6-trinitrotoluene (TNT)','2, 4, 6- trinitrotolueno (TNT)',10,'29','2904','290420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29042049','Outros trinitrotoluenos','Other nitrotoluenes','Los demás trinitrotoluenos',10,'29','2904','290420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29042051','Nitrobenzeno','Nitrobenzene','Nitrobenceno',10,'29','2904','290420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29042052','1, 3, 5-trinitrobenzeno','1, 3, 5-trinitrobenzene','1, 3, 5- trinitrobenceno',10,'29','2904','290420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29042059','Outros derivados nitrados do benzeno','Other nitrated derivative of benzene','Los demás derivados nitrados del benceno',10,'29','2904','290420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29042060','Derivados nitrados do xileno','Nitrated derivatives of xylene','Derivados nitrados del xileno',10,'29','2904','290420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29042070','Mononitroetano e nitrometanos','Nitroethane and nitromethanes','Mononitroetano y nitrometanos',10,'29','2904','290420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29042090','Outs.derivs.nitrados ou nitrosados dos hidrocarbonetos','Oth.nitrated or nitrosated derivatives of hydrocarbons','Los dem.deriv.nitrados o nitrosados de los hidrocarb.',10,'29','2904','290420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29049011','1-cloro-4-nitrobenzeno','1-chloro-4-nitrobenzene','1-cloro-4-nitrobenceno',10,'29','2904','290490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29049012','1-cloro-2, 4-dinitrobenzeno','1-chloro-2.4-dinitrobenzene','1-cloro-2, 4-dinitrobenceno',10,'29','2904','290490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29049013','2-cloro-1, 3-dinitrobenzeno','2-chloro-1, 3-dinitrobenzene','2-cloro-1, 3-dinitrobenceno',10,'29','2904','290490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29049014','4-cloro-alfa, alfa, alfa-trifluor-3, 5-dinitrotolueno','4-chloro-alpa, alpha, alpha-trifluoro-3, 5-dinitrotoluene','4-cloro-alfa, alfa, alfa-trifluoro-3, 5-dinitrotolueno',10,'29','2904','290490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29049015','O-nitroclorobenzeno e m-nitroclorobenzeno','O-nitrochlorobenzene and m-nitrochlorobenzene','0-nitroclorobenceno y m-nitroclorobenceno',10,'29','2904','290490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29049016','1, 2-dicloro-4-nitrobenzeno','1, 2-dichloro-4-nitrobenzene','1, 2-dicloro-4-nitrobenceno',10,'29','2904','290490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29049017','Tricloronitrometano (cloropicrina)','Trichloronitromethane (chloropicrin)','Tricloronitrometano (cloropicrina)',10,'29','2904','290490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29049019','Outros derivados nitroalogenados dos hidrocarbonetos','Other nitrohalogenated  derivatives of hydrocarbons','Los dem.derivados nitrohalogenados de los hidrocarburos',10,'29','2904','290490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29049021','Acido dinitroestilbenodissulfonico','Dinitrostylbenedisulphonic acids','Ácido dinitroestilbenodisulfónico',10,'29','2904','290490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29049029','Outros derivados nitrossulfonados dos hidrocarbonetos','Other nitrosulphonated derivatives of hydrocarbons','Los dem.derivados nitrosulfonados de los hidrocarburos',10,'29','2904','290490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29049030','Cloreto de p-toluenossulfonila (cloreto de tosila)','P-toluenesulphonyl chloride (tosyl chloride)','Cloruro de p-toluensulfonilo (cloruro de tosilo)',10,'29','2904','290490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29049040','Cloreto de o-toluenossulfonila','O-toluenesulphonyl chloride','Cloruro de p-toluensulfonilo',10,'29','2904','290490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29049090','Outs.derivs.sulfonados, nitrados, etc.dos hidrocarbonetos','Ot.sulphonated, nitrated, etc.derivatives of hydrocarbons','Los dem.deriv.sulfonados, nitrados, etc de los hidrocarb.',10,'29','2904','290490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051100','Metanol (álcool metílico)','Methanol (methyl alcohol)','Metanol (alcohol metílico)',10,'29','2905','290511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051210','Álcool propilico (propan-1-ol)','Propyl alcohol (propan-1-ol)','Alcohol propílico (propan-1-ol)',10,'29','2905','290512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051220','Álcool isopropilico (propan-2-ol)','Isopropyl alcohol (propan-2-ol)','Alcohol isopropílico (propan-2-ol)',10,'29','2905','290512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051300','Butan-1-ol (álcool n-butílico)','Butan-1-ol (n-butyl alcohol)','Butan-1-ol (alcohol n-butílico',10,'29','2905','290513');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051410','Álcool isobutílico','Isobutyl alcohol','Alcohol isobutílico',10,'29','2905','290514');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051420','Álcool sec-butílico','Sec-butyl alcohol','Alcohol sec-butílico',10,'29','2905','290514');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051430','Álcool ter-butílico','Tert-butyl alcohol','Alcohol ter-butílico',10,'29','2905','290514');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051500','Pentanol (álcool amilico) e seus isômeros','Pentanol (amyl alcohol) and their isomers','Pentanol (alcohol amílico) y sus isómeros',10,'29','2905','290515');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051600','Octanol (álcool octilico) e seus isômeros','Octanol (octyl alcohol) and their isomers','Octanol (alcohol octílico) y sus isómeros',10,'29','2905','290516');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051710','Álcool láurico','Lauryl alcohol','Alcohol láurico',10,'29','2905','290517');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051720','Álcool cetílico (hexadecan-1-ol)','Cetyl alcohol (hexadecan-1-ol)','Alcohol cetílico (hexadecan-1-ol)',10,'29','2905','290517');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051730','Álcool esteárico (octadecan-1-ol)','Stearyl alcohol (octadecan-1-ol)','Alcohol estearílico (octadecan-1-ol)',10,'29','2905','290517');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051911','N-decanol','N-decanol','N-decanol',10,'29','2905','290519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051912','Isodecanol','Isodecanol','Isodecanol',10,'29','2905','290519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051919','Outros decanóis, saturados','Other decanols, saturated','Los demás decanoles,  saturados',10,'29','2905','290519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051921','Etilato de magnésio','Magnesium ethylate','Etilato de magnesio',10,'29','2905','290519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051922','Metilato de sódio','Sodium methylate','Metilato de sodio',10,'29','2905','290519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051923','Etilato de sódio','Sodium ethylate','Etilato de sodio',10,'29','2905','290519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051929','Outros álcoolatos metálicos','Other metallic alcoholates','Los demás alcoholatos metálicos',10,'29','2905','290519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051991','4-metilpentan-2-ol','4-methylpentan-2-ol','4-metilpentan-2-ol',10,'29','2905','290519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051992','Isononanol','Isononanol','Isonanol',10,'29','2905','290519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051993','Isotridecanol','Isotridecanol','Isotridecanol',10,'29','2905','290519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051994','Tetraidrolinalol (3, 7-dimetiloctan-3-ol)','Tetrahydrolinalol (3, 7-dimethyloctan-3-ol)','Tetrahidrolinalol (3, 7-dimetiloctan-3-ol)',10,'29','2905','290519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051995','3, 3-dimetilbutan-2-ol (álcool pinacolilico)','3, 3-dimethylbutan-2-ol (pinacol alcohol)','3, 3-dimetilbutan-2-ol (alcohol pinacolílico)',10,'29','2905','290519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051996','Pentanol (álcool amílico) e seus isômeros','Petanol (amyl alcohol) and its isomers','Pentanol (alcohol amilico) y sus isomeros',10,'29','2905','290519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29051999','Outros monoalcoóis saturados','Other monoalcohols saturated','Los demás monoalcoholes saturados',10,'29','2905','290519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29052210','Linalol','Linalol','Linalol',10,'29','2905','290522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29052220','Geraniol','Geraniol','Geraniol',10,'29','2905','290522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29052230','Diidromircenol (2, 6-dimetil-7-octen-2-ol)','Dihydromyrcenol (2, 6-dimethyl-7-octen-2-ol)','Dihidromircenol (2, 6-dimetil-7-octen-2-ol)',10,'29','2905','290522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29052290','Outros alcoóis terpenicos acíclicos, não saturados','Other unsaturated acyclic terpene alcohols','Los demás alcoholes terpénicos acíclicos,  no saturados',10,'29','2905','290522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29052910','Álcool alílico','Allyl alcohol','Alcohol alílico',10,'29','2905','290529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29052990','Outros monoalcoóis não saturados','Other unsaturated monoalcohols','Los demás monoalcoholes no saturados',10,'29','2905','290529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29053100','Etilenoglicol (etanodiol)','Ethylene glycol (ethanediol)','Etilenglicol (etanodiol)',10,'29','2905','290531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29053200','Propilenoglicol (propano-1, 2-diol)','Propylene glycol (propane-1, 2-diol)','Propilenglicol (propano-1, 2-diol)',10,'29','2905','290532');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29053910','2-metil-2, 4-pentanodiol (hexilenoglicol)','2-methylpentanediol-2, 4-diol (hexylene glycol)','2-metil-2, 4-pentanodiol (hexilenglicol)',10,'29','2905','290539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29053920','Trimetilenoglicol (1, 3-propanodiol)','Trimethylene glycol (propane-1, 3-diol)','Trimetilenglicol (1, 3-propanodiol)',10,'29','2905','290539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29053930','1, 3-butilenoglicol (1, 3-butanodiol)','1, 3-butyleneglycol (buta-1, 3-diol)','1, 3-butilenglicol (1, 3-butanodiol)',10,'29','2905','290539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29053990','Outros alcoóis diois, não saturados','Other unsaturated adiols alcohols','Los demás alcoholes dioles,  no saturados',10,'29','2905','290539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29054100','2-etil-2-(hidroximetil)propano-1, 3-diol (trimetiolprop.','2-ethyl-2-(hydroxymethyl)propane-1, 3-diol (trimethyl.)','2-étil-2-(hidroximetil)propan-1, 3-diol(trimetilol-prop)',10,'29','2905','290541');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29054200','Pentaeritritol (pentaeritrita)','Pentaerythritol','Pentaeritritol (pentaeritrita)',10,'29','2905','290542');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29054300','Manitol','Mannitol','Manitol',10,'29','2905','290543');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29054400','D-glucitol (sorbitol) (poliálcool)','D-glucitol (sorbitol) (polialcohol)','D-glucitol (sorbitol) (polialcohol)',10,'29','2905','290544');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29054500','Glicerol','Glycerol','Glicerol',10,'29','2905','290545');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29054900','Outros polialcoóis, não saturados','Other unsaturated polyalcohols','Los demás polialcoholes,  no saturados',10,'29','2905','290549');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29055010','Hidrato de cloral','Chloral hydrate','Hidrato de cloral',10,'29','2905','290550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29055020','Etclorvinol ("ethchlorvynol")','Ethchlorvynol','Etclorvinol ("ethchlorvynol")',10,'29','2905','290550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29055090','Outs.derivs.halogen.etc.dos alcoóis acíclicos, n/saturad','Oth.halogenated deriv.etc.of acyclic alcohols, unsatur.','Los dem.deriv.halogen.etc de los alcoholes acícl.n/sat.',10,'29','2905','290550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29055100','Etclorvinol (dci)','Ethchlorvynol (inn)','Etclorvinol (dci)',10,'29','2905','290551');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29055910','Hidrato de cloral','Chloral hydrate','Hidrato de cloral',10,'29','2905','290559');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29055990','Outs.deriv.hidrogen.etc.dos alcoóis acíclicos','Oth.hydrogenated deriv.etc.of acyclic alcohols','Los dem.deriv.hidrogenados, etc de los alcoholes acícl.',10,'29','2905','290559');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29061100','Mentol','Menthol','Mentol',10,'29','2906','290611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29061200','Cicloexanol, metilcicloexanois e dimetilcicloexanois','Cyclohexanol, methylcyclohexanols and dimethylcyclohex.','Ciclohexanol, metilciclohexanoles y dimetilciclohexan.',10,'29','2906','290612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29061300','Esteróis e inositois','Sterols and inositols','Esteroles e inositoles',10,'29','2906','290613');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29061400','Terpineóis','Terpineols','Terpineoles',10,'29','2906','290614');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29061910','Derivados do mentol','Menthol derivatives','Derivados del mentol',10,'29','2906','290619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29061920','Borneol e isoborneol','Borneol and isoborneol','Borneol y isoborneol',10,'29','2906','290619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29061930','Terpina e seu hidrato','Terpin and terpin hydrate','Terpina y su hidrato',10,'29','2906','290619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29061940','Álcool fenchilico (1, 3, 3-trimetil-2-norbornanol)','Fenchyl alcohol (1, 3, 3-trimethyl-2-norbornanol)','Alcohol fenchílico (1, 3, 3-trimetil-2-norbornanol)',10,'29','2906','290619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29061950','Terpineóis','Terpineols','Terpineoles',10,'29','2906','290619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29061990','Outros alcoóis ciclanicos, ciclenicos e cicloterpenicos','Other cyclanic, cyclenic and cycloterpenic alcohols','Los dem.alcoholes ciclánicos, ciclénicos, cicloterpénicos',10,'29','2906','290619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29062100','Álcool benzilico','Benzyl alcohol','Alcohol bencílico',10,'29','2906','290621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29062910','2-feniletanol','2-phenylethanol','2-feniletanol',10,'29','2906','290629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29062920','Dicofol','Dicofol','Dicofol',10,'29','2906','290629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29062990','Outros alcoóis cíclicos aromáticos e seus derivados','Other aromatic cyclic alcohols and their derivatives','Los demás alcoholes cíclicos aromáticos y sus derivados',10,'29','2906','290629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29071100','Fenol (hidroxibenzeno) e seus sais','Phenol (hydroxybenzene) and its salts','Fenol (hidroxibenceno) y sus sales',10,'29','2907','290711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29071200','Cresóis e seus sais','Cresols and their salts','Cresoles y sus sales',10,'29','2907','290712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29071300','Octilfenol, nonilfenol, seus isômeros e sais','Octylphenol, nonylphenol and their isomers and salts','Octifenol,  nonifenol,  sus isómeros y sales',10,'29','2907','290713');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29071400','Xilenois e seus sais','Xylenols and their salts','Xilenoles y sus sales',10,'29','2907','290714');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29071510','Beta-naftol e seus sais','Beta-naphthol and its salts','Beta-naftol y sus sales',10,'29','2907','290715');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29071590','Outros naftois e seus sais','Other naphthols and its salts','Los demás naftoles y sus sales',10,'29','2907','290715');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29071910','2, 6-di-ter-butil-p-cresol e seus sais','2, 6-di-tert-butyl-p-cresol and its salts','2, 6-di-ter-butil-p-cresol y sus sales',10,'29','2907','290719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29071920','O-fenilfenol e seus sais','O-phenylphenol and its salts','O-fenilfenol y sus sales',10,'29','2907','290719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29071930','P-ter-butilfenol e seus sais','P-tert-butylphenol and its salts','P-ter-butilfenol y sus sales',10,'29','2907','290719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29071940','Xilenóis e seus sais','Xylenols and their salts','Xilenoles y sus sales',10,'29','2907','290719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29071990','Outros monofenóis','Other monophenols','Los demás monofenoles',10,'29','2907','290719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29072100','Resorcinol e seus sais','Resorcinol and its salts','Resorcinol y sus sales',10,'29','2907','290721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29072200','Hidroquinona e seus sais','Hydroquinone (quinol) and its salts','Hidroquinona y sus sales',10,'29','2907','290722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29072300','4-4''-isopropilidenodifenol e seus sais','4, 4''-isopropylidenediphenol and its salts','4, 4''-isopropilidendifenol y sus sales',10,'29','2907','290723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29072900','Outros polifenóis','Other polyphenols','Los demás polifenoles',10,'29','2907','290729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29073000','Fenóis-alcoóis','Phenol-alcohols','Fenoles-alcoholes',10,'29','2907','290730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081011','4-cloro-m-cresol e seus sais','4-chloro-m-cresol and its salts','4-cloro-m-cresol y sus sales',10,'29','2908','290810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081012','Diclorofenóis e seus sais','Dichorophenols and their salts','Diclorofenoles y sus sales',10,'29','2908','290810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081013','P-clorofenol','P-chlorophenol','P-clorofenol',10,'29','2908','290810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081014','Triclorofenóis e seus sais','Trichlorophenols and their salts','Triclorofenoles y sus sales',10,'29','2908','290810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081015','Tetraclorofenóis e seus sais','Tetrachlorophenols and their salts','Tetraclorofenoles y sus sales',10,'29','2908','290810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081016','Pentaclorofenol e seus sais','Pentachlorophenol and its salts','Pentaclorofenoles y sus sales',10,'29','2908','290810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081019','Outs.deriv.halog.dos fenóis/fenóis-alcoóis, sais, c/cloro','Ot.deriv.phenols halog./alcohols phenols salts, w/chloro','Los dem.deriv.hal.de fenoles/fenoles-alc.sales, c/cloro',10,'29','2908','290810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081021','2, 4, 6-tribromofenol','2, 4, 6-tribromophenol','2, 4, 6-tribromofenol',10,'29','2908','290810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081029','Outs.deriv.halog.dos fenóis/fenóis-alcoóis, sais, c/bromo','Ot.deriv.phenols halog./alcohols phenols salts, w/bromin','Los dem.deriv.hal.de fenoles/fenoles-alc.sales, c/bromo',10,'29','2908','290810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081090','Outs.derivs.halog.dos fenóis/fenóis-alcoóis e seus sais','Ot.deriv.phenols halog./alcoh.phenols and their salts','Los dem.deriv.hal.de fenoles/fenoles-alcoh.y sus sales',10,'29','2908','290810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081100','Pentaclorofenol e seus sais','Pentachlorophenol and its salts','Pentaclorofenoles y sus sales',10,'29','2908','290811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081911','4-cloro-m-cresol e seus sais','4-chloro-m-cresol and its salts','4-cloro-m-cresol y sus sales',10,'29','2908','290819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081912','Diclorofenóis e seus sais','Dichorophenols and their salts','Diclorofenoles y sus sales',10,'29','2908','290819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081913','P-clorofenol','P-chlorophenol','P-clorofenol',10,'29','2908','290819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081914','Triclorofenóis e seus sais','Trichlorophenols and their salts','Triclorofenoles y sus sales',10,'29','2908','290819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081915','Tetraclorofenóis e seus sais','Tetrachlorophenols and their salts','Tetraclorofenoles y sus sales',10,'29','2908','290819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081919','Outros derivados halogenados e seus sais, com cloro','Otther deriv.phenols halog./alcohols phenols salts, with chloro','Otros derivados halogenos de fenoles/fenoles-alc.sales, con cloro',10,'29','2908','290819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081921','2, 4, 6-tribromofenol','2, 4, 6-tribromophenol','2, 4, 6-tribromofenol',10,'29','2908','290819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081929','Outros derivados halogenados e seus sais, com bromo','Other derived.phenols halog./alcohols phenols salts, w/bromin','Otros derivados halogenos de fenoles/fenoles-alc.sales, con bromo',10,'29','2908','290819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29081990','Outros derivados halogenados e seus sais','Other derived phenols halog./alcoh.phenols and their salts','Otros derivados halogenos de fenoles/fenoles-alcoh.y sus sales',10,'29','2908','290819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29082010','Derivados sulfonados dos fenóis, seus sais e ésteres','Sulphontes derivatives of phenols, their salts and esters','Derivados sulfonados de los fenóles, sus sales y ésteres',10,'29','2908','290820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29082090','Derivados sulfonados dos fenóis-alcoóis, sais e ésteres','Deriv.phenols-alcoh.sulphonated their salts and esters','Deriv.sulfonados de fenoles-alcoh.sus sales y ésteres',10,'29','2908','290820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089011','4, 6-dinitro-o-cresol e seus sais','4, 6-dinitro-o-cresol and its salts','4, 6-dinitro-o-cresol y sus sales',10,'29','2908','290890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089012','P-nitrofenol e seus sais','P-nitrophenol and its salts','P-nitrofenol y sus sales',10,'29','2908','290890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089013','Acido pícrico','Picric acid','Ácido pícrico',10,'29','2908','290890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089014','Dinoseb e seus sais','Dinoseb and its salts','Dinoseb y sus sales',10,'29','2908','290890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089019','Outs.deriv.nitrados dos fenóis/fenóis-alcoóis, seus sais','Ot.deriv.phen.nitrated/alcoh.phenols and their salts','Los dem.deriv.nitrados de fenoles/fenoles-alc.sus sales',10,'29','2908','290890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089021','Disofenol','Diisophenol','Disofenol',10,'29','2908','290890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089029','Outs.derivs.nitroalogenados dos fenóis/fenóis-alcoóis','Oth.derivatives phenols nitratedhalog/alcohols-phenols','Los dem.deriv.nitrohalogenados de fenoles/fenoles-alcoh',10,'29','2908','290890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089090','Outs.derivados nitrosados, etc.dos fenóis/fenóis-alcoóis','Oth.derivativ.phenols nitrosated,  etc/alcohols phenols','Los dem.deriv.nitrosados,  etc de fenoles/fenoles-alcoh.',10,'29','2908','290890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089100','Dinoseb e seus sais','Dinoseb and its salts','Dinoseb y sus sales',10,'29','2908','290891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089200','4,6-dinitro-o-cresol (dnoc (iso)) e seus sais','4,6-dinitro-o-cresol (dnoc (iso)) e seus sais','4,6-dinitro-o-cresol (dnoc (iso)) e seus sais',10,'29','2908','290892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089911','4, 6-dinitro-o-cresol e seus sais','4, 6-dinitro-o-cresol and its salts','4, 6-dinitro-o-cresol y sus sales',10,'29','2908','290899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089912','P-nitrofenol e seus sais','P-nitrophenol and its salts','P-nitrofenol y sus sales',10,'29','2908','290899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089913','Ácido pícrico','Picric acid','Ácido pícrico',10,'29','2908','290899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089919','Outros derivados nitrados e seus sais','Other nitrate derivatives and their salts','Otros derivados nitratos y sus sales',10,'29','2908','290899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089921','Disofenol','Diisophenol','Disofenol',10,'29','2908','290899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089929','Outros derivados nitroalogenados','Other nitrohalogenated derivatives','Otros derivados nitroalogenados',10,'29','2908','290899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089930','Deriv. sulfonados d/fenol, s/sais e s/ésteres','Sulphontes derivatives of phenols, their salts and esters','Derivados sulfonados de los fenóles, sus sales y ésteres',10,'29','2908','290899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29089990','Outs.der.hal.sulf.nitra, nitr.d/fen.-alcoóis','Other der.hal.sulf.nitrat.-alcohols','Otros derivados alogenados, sulf.nitra.d/fe alcohólicos',10,'29','2908','290899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29091100','Éter dietílico (óxido de dietila)','Diethyl ether (diethyl oxide)','Éter dietílico (óxido de dietilo)',10,'29','2909','290911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29091910','Éter metil-ter-butílico (mtbe)','Methyl tert-butyl ether (mtbe)','Éter metil-ter-butílico (mtbe)',10,'29','2909','290919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29091990','Outs.éteres acíclicos e seus derivados halogenados, etc.','Oth.acyc.ethers and their halogenated derivatives, etc.','Los dem.éteres acíclicos y sus derivad.halogenados, etc',10,'29','2909','290919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29092000','Éteres ciclanicos, ciclenicos, cicloterpenicos e derivs.','Cyclanic, cyclenic or cycloterpenic ethers and derivat.','Éteres ciclánicos, ciclénicos, cicloterpénicos y deriv.',10,'29','2909','290920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29093011','Anetol','Anethole','Anetol',10,'29','2909','290930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29093012','Eter difenílico (eter fenilico)','Diphenyl ether (phenyl ether)','Éter difenílico (éter fenílico)',10,'29','2909','290930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29093013','Eter dibenzilico (eter benzilico)','Dibenzyl ether (benzyl ether)','Éter dibencílico (éter bencílico)',10,'29','2909','290930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29093014','Eter feniletil-isoamilico','Phenylethyl isoamyl ether','Éter feniletil-isoamílico',10,'29','2909','290930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29093019','Outros éteres aromáticos','Other aromatic ethers','Los demás éteres aromáticos',10,'29','2909','290930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29093021','Oxifluorfeno','Oxyfluorfen','Oxifluorfeno',10,'29','2909','290930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29093029','Outros derivados halogenados, etc.dos éteres aromáticos','Other halogenated derivatives, etc.of aromatic ethers','Los dem.derivados halogenados, etc de los éteres aromát.',10,'29','2909','290930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094100','2, 2''-oxidietanol (dietilenoglicol)','2, 2''-oxydiethanol (diethylene glycol,  digol)','2, 2''-oxidietanol (dietilenglicol)',10,'29','2909','290941');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094200','Éteres monometílicos do etilenoglicol/dietilenoglicol','Monomethyl ethers of ethylene glycol/diethylene glycol','Éteres monometílicos del etilenglicol/dietilenglicol',10,'29','2909','290942');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094310','Éteres monobutílicos do etilenoglicol','Monobutyl ethers of ethylene glycol','Éteres monobutílicos del etilenglicol',10,'29','2909','290943');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094320','Éteres monobutílicos do dietilenoglicol','Monobutyl ethers of diethylene glycol','Éteres monobutílicos del dietilenglicol',10,'29','2909','290943');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094411','Éter etílico do etilenoglicol','Ethers of ethylene glycol','Éter etílico del etilenglicol',10,'29','2909','290944');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094412','Éter isobutílico do etilenoglicol','Ether of ethylene glycol isobutyl','Éter isobutílico del etilenglicol',10,'29','2909','290944');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094413','Éter hexilico do etilenoglicol','Ether of ethylene glycol  hexyl','Éter hexílico del etilenglicol',10,'29','2909','290944');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094419','Outros éteres monoalquilicos do etilenoglicol','Other monoalkylethers of ethylene glycol','Los demás éteres monoalquílicos del etilenoglicol',10,'29','2909','290944');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094421','Éter etílico do dietilenoglicol','Ethylene ether of diethylene glycol','Éter etílico del dietilenoglicol',10,'29','2909','290944');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094429','Outros éteres monoalquilicos do dietilenoglicol','Other monoalkylethers ethers of diethylene glycol','Los demás éteres monoalquílicos del dietilenoglicol',10,'29','2909','290944');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094910','Guaifenesina','Guiafenesin','Guaifenesina',10,'29','2909','290949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094921','Trietilenoglicol','Triethylene glycol','Trietilenglicol',10,'29','2909','290949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094922','Tetraetilenoglicol','Tetraethylene glycol','Tetraetilenglicol',10,'29','2909','290949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094923','Pentaetilenoglicol e seus éteres','Pentaethylene glycol and its ethers','Pentaetilenglicol y sus éteres',10,'29','2909','290949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094924','Eter fenilico do etilenoglicol','Ethylene glycol phenyl ether','Éter fenílico del etilenglicol',10,'29','2909','290949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094929','Outros etilenoglicois e seus éteres','Other ethylene glycols and its ethers','Los demás etilenglicoles y sus éteres',10,'29','2909','290949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094931','Dipropilenoglicol','Dipropylene glycol','Dipropilenglicol',10,'29','2909','290949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094932','Éteres do mono-, di- e tripropilenoglicol','Ethers of mono-,  di- and tripropylene glycol','Éteres del mono-,  di- e tripropilenglicol',10,'29','2909','290949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094939','Outros propilenoglicois e seus éteres','Other propylene glycols and its ethers','Los demás propilenglicoles y sus éteres',10,'29','2909','290949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094941','Éter etílico do butilenoglicol','Butylene glycol ethyl ether','Éter etílico del butilenglicol',10,'29','2909','290949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094949','Butilenoglicois e outros éteres','Other butylene glycol and other ether','Butilenglicoles y demás éteres',10,'29','2909','290949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094950','Álcool fenoxibenzilico','Phenoxybenzyl alcohols','Alcohol fenoxibencílicos',10,'29','2909','290949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29094990','Outros éteres-alcoóis e seus derivados halogenados, etc.','Oth.ethers-alcohols and their deriv.halogenated, etc','Los dem.éteres-alcoholes y sus deriv.halogenados, etc',10,'29','2909','290949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29095011','Triclosan','Triclosan','Triclosan',10,'29','2909','290950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29095012','Eugenol','Eugenol','Eugenol',10,'29','2909','290950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29095013','Isoeugenol','Isoeugenol','Isoeugenol',10,'29','2909','290950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29095019','Outros éteres-fenóis','Other ether-phenols','Los demás éteres-fenoles',10,'29','2909','290950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29095090','Éteres-alcoóis-fenóis e seus derivados halogenados, etc.','Ether-alcohol-phenols and their halogenated deriv., etc','Éteres-alcoholes-fenoles y sus derivad.halogenados, etc',10,'29','2909','290950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29096011','Hidroperóxido de diisopropilbenzeno','Alcohol peroxides of diisopropylbenzene','Hidroperóxido de  diisopropilbenceno',10,'29','2909','290960');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29096012','Hidroperóxido de ter-butila','Alcohol peroxides of tert-butyl','Hidroperóxido de ter-butilo',10,'29','2909','290960');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29096013','Hidroperóxido de p-mentano','Alcohol peroxides of p-menthane','Hidroperóxido de p-mentano',10,'29','2909','290960');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29096019','Outs.hidroperóxidos de alcoóis, éteres, cetonas e derivs.','Other alcohol peroxides, ethers, acetone and derivat.','Los dem.hidroperóxidos de alcoh.éteres, cetonas y deriv.',10,'29','2909','290960');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29096020','Peróxidos de alcoóis, éteres, cetonas, derivs.halogen.etc.','Alcohol peroxides, ethers, acetone, deriv.halogenated, etc','Peróxidos de alcoholes, éteres, cetonas, deriv.halogen.etc',10,'29','2909','290960');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29101000','Oxirano (óxido de etileno)','Oxirane (ethylene oxide)','Oxirano (óxido de etileno)',10,'29','2910','291010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29102000','Metiloxirano (óxido de propileno)','Methyloxirane (propylene oxide)','Metiloxirano (óxido de propileno)',10,'29','2910','291020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29103000','1-cloro-2, 3-epoxipropano (epicloridrina)','1-chloro-2, 3-epoxypropane (epichlorohydrin)','1-cloro-2, 3-epoxipropano (epiclorhidrina)',10,'29','2910','291030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29104000','Dieldrin','Dieldrin','Dieldrina',10,'29','2910','291040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29109010','Óxido de estireno','Styrene oxide','Óxido de estireno',10,'29','2910','291090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29109020','Dieldrin','Dieldrin','Dieldrina',10,'29','2910','291090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29109030','Endrin','Endrin','Endrín',10,'29','2910','291090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29109090','Outros epóxidos, epoxialcoóis, etc.com 3 atomos no ciclo','Oth.epoxides, epoxyalcohols, etc.with 3-membered ring','Los dem.epóxidos, epoxialcoholes, etc, c/tres átom.en cicl',10,'29','2910','291090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29110010','Dimetilacetal do 2-nitrobenzaldeído','2-nitrobenzaldehyde dimethylacetal','Dimetilacetal del 2-nitrobenzaldehído',10,'29','2911','291100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29110090','Outros acetais, semi-acetais e seus derivs.halogen.etc.','Oth.acetals, semi-acetals and its halogen.deriv.etc.','Los dem.acetales, semiacetales y sus deriv.halogen.etc',10,'29','2911','291100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29121100','Metanal (formaldeído)','Methanal (formaldehyde)','Metanal (formaldehído)',10,'29','2912','291211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29121200','Etanal (acetaldeído)','Ethanal (acetaldehyde)','Etanal (acetaldehído)',10,'29','2912','291212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29121300','Butanal (butiraldeído, isômero normal)','Butanal (butyraldehyde, normal isomer)','Butanal (butiraldehído, isómero normal)',10,'29','2912','291213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29121911','Glioxal','Glyoxal','Glioxal',10,'29','2912','291219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29121912','Glutaraldeído','Glutaraldehyde','Glutaraldehído',10,'29','2912','291219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29121919','Outros dialdeídos','Other dialdehyde','Los demás dialdehídos',10,'29','2912','291219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29121921','Citral','Citral','Citral',10,'29','2912','291219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29121922','Citronelal (3, 7-dimetil-6-octenal)','Citronellal (3, 7-dimethyl-6-octenal)','Citronelal (3, 7-dimetil-6-octenal)',10,'29','2912','291219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29121923','Bergamal (3, 7-dimetil-2-metileno-6-octenal)','Bergamal (3, 7-dimethyl-2-methylene-6-octenal)','Bergamal (3, 7-dimetil-2-metilen-6-octenal)',10,'29','2912','291219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29121929','Outros monoaldeídos não saturados','Other unsaturared monoaldehydes','Los demás monoaldehídos no saturados',10,'29','2912','291219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29121991','Heptanal','Heptanal','Heptanal',10,'29','2912','291219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29121999','Outs.aldeídos acíclicos n/cont.outs.funcoes oxigenadas','Other acyclic aldheydes n/cont.ot.oxygenated functions','Los dem.aldehídos acíclicos s/dem.funciones oxigenadas',10,'29','2912','291219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29122100','Benzaldeído (aldeído benzóico)','Benzaldehyde','Benzaldehído (aldehído benzoico)',10,'29','2912','291221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29122910','Aldeído alfa-amilcinâmico','Alpha-amylcinnamaldehyde','Aldehídos alfa-amilcinámico',10,'29','2912','291229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29122920','Aldeído alfa-hexilcinâmico','Alpha-hexylcinnamaldehyde','Aldehídos alfa-hexilcinámico',10,'29','2912','291229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29122990','Outros aldeídos cíclicos n/cont.outs.funcoes oxigenadas','Other cyclic aldehyde n/cont.oth.oxygen function','Los dem.aldehídos cíclicos s/otras funciones oxigenadas',10,'29','2912','291229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29123010','4-(4-hidroxi-4metilpentil)-3-cicloexeno-1-carboxialdeid','4-(4-hydroxy-4-methylpentyl)-3-cyclohexen-1-carboxyald.','4-(4-hidroxi-4-metilpentil)-3-ciclohexen-1-carboxiald.',10,'29','2912','291230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29123090','Outros aldeídos-alcoóis','Other aldehyde-alcohols','Los demás aldehídos-alcoholes',10,'29','2912','291230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29124100','Vanilina (aldeído metilprotocatequico)','Vanillin (4-hydroxy-3-methoxybenzaldehyde)','Vainillina (aldehído metilprotocatéquico)',10,'29','2912','291241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29124200','Etilvanilina (aldeído etilprotocatequico)','Ethylvanillin (3-ethoxy-4-hydroxybenzaldehyde)','Etilvainillina (aldehído etilprotocatéquico)',10,'29','2912','291242');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29124910','3-fenoxibenzaldeído','3-phenoxybenzaldehyde','3-fenoxibenzaldehído',10,'29','2912','291249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29124920','3-hidroxibenzaldeído','3-hydroxybenzaldehyde','3-hidroxibenzaldehído',10,'29','2912','291249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29124930','3, 4, 5-trimetoxibenzaldeído','3, 4, 5-trimethoxybenzaldehyde','3, 4, 5-trimetoxibenzaldehído',10,'29','2912','291249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29124941','4-(4-hidroxi-4-metilpentil)-3-cicloexeno-1-carboxialde','4-(4-hidroxi-4-metilpentil)-3-cicloexeno-1-carboxialde','4-(4-hidroxi-4-metilpentil)-3-cicloexeno-1-carboxialde',10,'29','2912','291249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29124949','Outros aldeídos-alcoóis','Other aldehydes-alcohols','Otros aldehídos-alcoholes',10,'29','2912','291249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29124990','Outros aldeídos-éteres, aldeídos-fenóis e c/funcoes oxig','Ot.ether-aldehydes, phen-aldehydes w/ot.oxygen function','Los dem.aldehídos-éteres, aldehídos-fenoles y c/func.oxi',10,'29','2912','291249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29125000','Polímeros cíclicos dos aldeídos','Cyclic polymers of aldehydes','Polímeros cíclicos de los aldehídos',10,'29','2912','291250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29126000','Paraformaldeído','Paraformaldehyde','Paraformaldehído',10,'29','2912','291260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29130010','Tricloroacetaldeído','Trichloroacetaldehyde','Tricloroacetaldehído',10,'29','2913','291300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29130090','Outs.derivados halogenados, sulfonados, etc.dos aldeídos','Other aldehydes halog.deriv., sulphonated, etc','Los dem.deriv.halogenados, sulfonados, etc de los aldehíd',10,'29','2913','291300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29141100','Acetona não contendo outras funções oxigenadas','Acetone n/containing other fuction oxygen','Acetona sin otras funciones oxigenadas',10,'29','2914','291411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29141200','Butanona (metiletilcetona)','Butanone (methyl ethyl ketone)','Butanona (metiletilcetona)',10,'29','2914','291412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29141300','4-metilpentan-2-ona (metilisobutilcetona)','4-methylpentan-2-one (methyl isobutyl ketone)','4-metilpentan-2-ona (metilisobutilcetona)',10,'29','2914','291413');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29141910','Forona','Phorone','Forona',10,'29','2914','291419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29141921','Acetilacetona','Acetylacetone','Acetilacetona',10,'29','2914','291419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29141922','Acetonilacetona','Acetonylacetone','Acetonilacetona',10,'29','2914','291419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29141923','Diacetila','Diacetyl','Diacetilo',10,'29','2914','291419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29141929','Outras dicetonas','Other diacetone','Las demás dicetonas',10,'29','2914','291419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29141930','Metilexilcetona','Methyl hexyl ketone','Metilhexilcetona',10,'29','2914','291419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29141940','Pseudoiononas','Pseudoionones','Pseudoiononas',10,'29','2914','291419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29141950','Metilisopropilcetona','Methyl isopropyl ketone','Metilisopropilcetona',10,'29','2914','291419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29141990','Outras cetonas acíclicas n/cont.outs.funcoes oxigenadas','Other cyclic ketones n/cont.oth.fuction oxygen','Las dem.cetonas acíclicas s/otras funciones oxigenadas',10,'29','2914','291419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29142100','Cânfora','Camphor','Alcanfor',10,'29','2914','291421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29142210','Cicloexanona','Cyclohexanone','Ciclohexanona',10,'29','2914','291422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29142220','Metilcicloexanonas','Methylcyclohexanones','Metilciclohexanona',10,'29','2914','291422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29142310','Iononas','Ionones','Iononas',10,'29','2914','291423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29142320','Metiliononas','Methylionones','Metiliononas',10,'29','2914','291423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29142910','Carvona','Carvone','Carvona',10,'29','2914','291429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29142920','1-mentona','1-menthone','1-mentona',10,'29','2914','291429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29142990','Outs.cetonas ciclanicas, etc.n/cont.outs.funcoes oxigen.','Other cyclanic ketones n/ cont.oth.fuction oxygen','Las dem.cetonas ciclánicas, etc, s/otras func.oxig.',10,'29','2914','291429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29143100','Fenilacetona (fenilpropan-2-ona)','Phenylacetone (phenylpropan-2-one)','Fenilacetona (fenilpropan-2-ona)',10,'29','2914','291431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29143910','Acetofenona','Acetophenone','Acetofenona',10,'29','2914','291439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29143990','Outras cetonas aromáticas n/cont.outras funcoes oxigen.','Other aromatic ketones n/ cont.oth.fuction oxygen','Las dem.cetonas aromáticas s/otras funciones oxigenadas',10,'29','2914','291439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29144010','4-hidroxi-4-metilpentano-2-ona (diacetona álcool)','4-hydroxy-4-methylpentan-2-one (diacetone alcohol)','4-hidroxi-4-metilpentan-2-ona (diacetona alcohol)',10,'29','2914','291440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29144091','Benzoína','Benzoin','Benzoína',10,'29','2914','291440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29144099','Outras cetonas-alcoóis e cetonas-aldeídos','Other ketone-alcohols and ketone-aldehydes','Las demás cetonas-alcoholes y cetonas-aldehídos',10,'29','2914','291440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29145010','Nabumetona','Nabumetone','Nabumetona',10,'29','2914','291450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29145020','1, 8-diidroxi-3-metil-9-antrona e sua forma enolica','1, 8-dihydroxy-3-methyl-9-anthrone and its enol form','1, 8-dihidroxi-3-metil-9-antrona y su forma enólica',10,'29','2914','291450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29145090','Outs.cetonas-fenóis e cetonas cont.outs.funcoes oxigen.','Oth.ketone-phenols and ketones with other oxygen func.','Las dem.cetonas-fenoles y cetonas c/otras func.oxig.',10,'29','2914','291450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29146100','Antraquinona','Anthraquinone','Antraquinona',10,'29','2914','291461');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29146910','Lapachol','Lapachol','Lapachol',10,'29','2914','291469');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29146920','Menadiona','Menadione','Menadiona',10,'29','2914','291469');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29146990','Outras quinonas','Other quinones','Las demás quinonas',10,'29','2914','291469');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29147011','1-cloro-5-hexanona','1-chloro-5-hexanone','1-cloro-5-hexanona',10,'29','2914','291470');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29147019','Outros derivados halogenados das cetonas e quinonas','Other deriv.halogenated of ketones and quinones','Los dem.derivados halogenados de las cetonas y quinonas',10,'29','2914','291470');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29147021','Bissulfito sódico de menadiona','Menadione sodium bisulphite','Bisulfito sódico de menadiona',10,'29','2914','291470');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29147022','Ácido 2-hidroxi-4-metoxibenzofenona-5-sulfon.','5-sulphonated-2-hydroxy-4-methoxybenzenesulphonic acid','Ácido 2-hidroxi-4-metoxibenzofenona-5-sulfónico',10,'29','2914','291470');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29147029','Outros derivados sulfonados das cetonas e quinonas','Other derivatives of ketones quinones sulphonated','Los dem.derivados sulfonados de las cetonas y quinonas',10,'29','2914','291470');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29147090','Outras cetonas, mesmo contendo outras funcoes oxigenadas','Oth.ketones, containing or not, other oxygen fuctions','Las dem.cetonas,  incluso con otras funciones oxigenadas',10,'29','2914','291470');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29151100','Ácido fórmico','Formic acid','Ácido fórmico',10,'29','2915','291511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29151210','Sal de sódio, do ácido fórmico','Sodium salts and formic acid','Sal de sodio,  del ácido fórmico',10,'29','2915','291512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29151290','Outros sais do ácido fórmico','Other salts of formic acid','Los demás sales del ácido fórmico',10,'29','2915','291512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29151310','Éster de geranila, do ácido fórmico','Geranyl esters, of formic acid','Éster de geranilo, del ácido fórmico',10,'29','2915','291513');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29151390','Outros ésteres do ácido fórmico','Other esters of formic acid','Los demás ésteres del ácido fórmico',10,'29','2915','291513');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29152100','Ácido acético','Acetic acid','Ácido acético',10,'29','2915','291521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29152200','Acetato de sódio','Sodium acetate','Acetato de sodio',10,'29','2915','291522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29152300','Acetato de cobalto','Cobalt acetates','Acetato de cobalto',10,'29','2915','291523');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29152400','Anidrido acético','Acetic anhydride','Anhídrido acético',10,'29','2915','291524');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29152900','Outros sais do ácido acético','Other salts acetic acid','Los demás sales del ácido acético',10,'29','2915','291529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29152910','Acetato de sódio','Sodium acetate','Acetato de sodio',10,'29','2915','291529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29152920','Acetatos de cobalto','Cobalt acetates','Acetato de cobalto',10,'29','2915','291529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29152990','Outros sais do ácido acético','Other salts of acetic acid','Los demás sales del ácido acético',10,'29','2915','291529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153100','Acetato de etila','Ethyl acetate','Acetato de etilo',10,'29','2915','291531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153200','Acetato de vinila','Vinyl acetate','Acetato de vinilo',10,'29','2915','291532');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153300','Acetato de n-butila','N-butyl acetate','Acetato de n-butilo',10,'29','2915','291533');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153400','Acetato de isobutila','Isobutyl acetate','Acetato de isobutilo',10,'29','2915','291534');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153500','Acetato de 2-etoxietila','2-ethoxyethyl acetate','Acetato de 2-etoxietilo',10,'29','2915','291535');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153600','Acetato de dinoseb','Dinoseb acetate','Acetato de dinoseb',10,'29','2915','291536');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153910','Acetato de linalila','Linalyl acetate','Acetato de linalilo',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153921','Triacetina','Triacetin','Triacetina',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153929','Outros acetatos de glicerila','Other glycerin acetate','Los demás acetatos de glicerilo',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153931','Acetato de n-propila','N-propyl acetate','Acetato de n-propilo',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153932','Acetato de 2-etoxietila','2-ethoxyethyl acetate','Acetato de 2-etoxietilo',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153939','Outros acetatos monoalcoóis acicl.satur., atomo de c<=8','Other satured acyclic monoalcohol acetate atom of c<=8','Los dem.acetatos monoalcoholes acícl.sat.átomo de c<=8',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153941','Acetato de decila','Decyl acetate','Acetato de decilo',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153942','Acetato de hexenila','Hexyl acetate','Acetato de hexenilo',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153951','Acetato de benzestrol','Benzoestrol acetate','Acetato de bencestrol',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153952','Acetato de dienoestrol','Dienoestrol acetate','Acetato de dienoestrol',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153953','Acetato de hexestrol','Hexoestrol acetate','Acetato de hexestrol',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153954','Acetato de mestilbol','Mestilbol acetate','Acetato de mestilbol',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153955','Acetato de estildestrol','Stilboestrol acetate','Acetato de estilbestrol',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153961','Acetato de tricloro-alfa-feniletila','Trichloro-alfa-phenylethyl acetate','Acetato de tricloro-alfa-feniletilo',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153962','Acetato de triclorometilfenilcarbinila','Trichloromethylphenylcarbinol acetate','Acetato de triclorometilfenilcarbinol',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153963','Diacetato de etilenoglicol (diacetato de etileno)','Ethylene glycol diacetate (ethylene diacetate)','Diacetato de etilenglicol (diacetato de etileno)',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153991','Ésteres de 2-ter-butilcicloexila','2-tert-butylcyclohexyl esters','Ésteres de 2-ter-buticiclohexilo',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153992','Ésteres de bornila','Bornyl esters','Ésteres de bornilo',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153993','Ésteres de dimetilbenzilcarbinila','Dimethylbenzylcarbinyl esters','Ésteres de dimetilbencilcarbinilo',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153994','Bis(p-acetoxifenil)cicloexilidenometano (ciclofenil)','Bis(p-acetoxyphenyl)cyclohexylidenemethane(cyclophen.)','Bis(p-acetoxifenil) ciclohexilidenmetano (ciclofenil)',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29153999','Outros ésteres do ácido acético','Other acetate acid esters','Los demás ésteres del ácido acético',10,'29','2915','291539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29154010','Acido monocloroacético','Monochloroacetic acid','Ácido monocloroacético',10,'29','2915','291540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29154020','Monocloroacetato de sódio','Sodium monochloroacetate','Monocloroacetato de sodio',10,'29','2915','291540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29154090','Acido di- ou tricloroacético, seus sais e ésteres','Di- or trichloroacetic acids, and their salts/esters','Ácido di- o tricloroacético,  sus sales y ésteres',10,'29','2915','291540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29155010','Acido propiônico','Propionic acid','Ácido propiónico',10,'29','2915','291550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29155020','Sais do ácido propiônico','Propionic acid salts','Sales del ácido propiónico',10,'29','2915','291550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29155030','Ésteres do ácido propiônico','Esters of propionic acid','Ésteres del ácido propiónico',10,'29','2915','291550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29156011','Acido butírico e seus sais','Butanoic acids and their salts','Ácido butírico y sus sales',10,'29','2915','291560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29156012','Butirato de etila','Ethyl butanoate','Butirato de etilo',10,'29','2915','291560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29156019','Outros ésteres do ácido butírico','Other esters of butanoic acids','Los demás ésteres del ácido butírico',10,'29','2915','291560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29156021','Acido piválico','Pivalic acid','Ácido piválico',10,'29','2915','291560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29156029','Ácido valérico e seus outs.sais e ésteres','Valeric acid and other salts and esters','Ácido valérico y sus demás sales y ésteres',10,'29','2915','291560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29157010','Ácido palmítico, seus sais e ésteres','Palmitic acid,  its salts and esters','Ácido palmítico,  sus sales y ésteres',10,'29','2915','291570');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29157011','Ácido palmítico','Palmitic acid','Ácido palmitico',10,'29','2915','291570');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29157019','Outros sais e ésteres do ácido palmítico','Other salts and esters from palmitic acid','Otros sales e esteres del acido palmitico',10,'29','2915','291570');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29157020','Acido esteárico (ac.monocarboxilico acíclico saturado)','Stearic acid (acyclic saturated monocarboxylic acid )','Ácido esteárico (ác.monocarboxílico acíclico saturado)',10,'29','2915','291570');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29157031','Sais de zinco do ácido esteárico','Zinc salts of stearic acid','Sales de cinc del ácido esteárico',10,'29','2915','291570');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29157039','Outros sais do ácido esteárico','Other salts of stearic acid','Los demás sales del ácido esteárico',10,'29','2915','291570');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29157040','Ésteres do ácido esteárico','Esters of stearic acid','Ésteres del ácido esteárico',10,'29','2915','291570');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29159010','Cloreto de cloroacetila','Chloroacetyl chloride','Cloruro de cloroacetilo',10,'29','2915','291590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29159021','Acido 2-etilexanoico (acido 2-etilexoico)','2-ethylhexanoic acid','Ácido 2-etilhexanoico (ácido 2-etilhexoico)',10,'29','2915','291590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29159022','2-etilexanoato de estanho ii','Tin 2-ethylhexanoate','2-etilhexanoato de estaño ii',10,'29','2915','291590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29159023','Di(2-etilexanoato)de trietilenoglicol','Triethylene glycol di(2-ethylhexanoate)','Di(2-etilhexanoato) de trietilenglicol',10,'29','2915','291590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29159024','Cloreto de 2-etilexanoila','Chloride 2-etilexanoila','Cloruro 2-etilexanoila',10,'29','2915','291590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29159029','Outros sais e ésteres do ácido 2-etilexanóico','Other salts and esters of 2-ethylhexanoic acid','Los demás sales y ésteres del ácido 2-etilhexanoico',10,'29','2915','291590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29159031','Ácido mirístico','Myristic acid','Ácido mirístico',10,'29','2915','291590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29159032','Ácido caprílico','Caprilic acid','Ácido caprílico',10,'29','2915','291590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29159033','Miristato de isopropila','Isopropyl myristate','Miristato de isopropilo',10,'29','2915','291590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29159039','Outros sais e ésteres dos ácidos mirístico ou caprílico','Other salts and esters of myristic/caprilic acid','Los dem.sales y ésteres de los ác.mirístico o caprílico',10,'29','2915','291590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29159041','Ácido láurico','Lauric acid','Ácido láurico',10,'29','2915','291590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29159042','Sais e ésteres do ácido láurico','Salts and esters of lauric acid','Sales y ésteres del ácido láurico',10,'29','2915','291590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29159050','Peróxidos dos acidos monocarboxilicos acíclicos satur.','Acid peroxides saturated acyclic monocarboxylic acids','Peróxidos de los ácidos monocarboxílicos acíc. satur.',10,'29','2915','291590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29159060','Peracidos dos acidos monocarboxilicos acíclicos satur.','Acid peroxides saturated acyclic monocarboxylic acids','Perácidos de los ácidos monocarboxílicos acíc. satur.',10,'29','2915','291590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29159090','Outros acidos monocarboxilicos acíclicos saturados, etc.','Oth.acid peroxides satur.acycl.monocarboxylic acids, etc','Los dem.ácidos monocarboxílicos acíclicos saturados, etc',10,'29','2915','291590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161110','Ácido acrílico','Acrylic acid','Ácido acrílico',10,'29','2916','291611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161120','Sais do ácido acrílico','Acrylic acid salts','Sales del ácido acrílico',10,'29','2916','291611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161210','Ésteres de metila do ácido acrílico','Esters of methyl of acrylic acid','Ésteres de metilo del ácido acrílico',10,'29','2916','291612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161220','Ésteres de etila do ácido acrílico','Esters of ethyl of acrylic acid','Ésteres de etilo del ácido acrílico',10,'29','2916','291612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161230','Ésteres de butila do ácido acrílico','Esters of butyl of acrylic acid','Ésteres de butilo del ácido acrílico',10,'29','2916','291612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161240','Ésteres de 2-etilexila do ácido acrílico','Esters of 2-ethylhexyl of acrylic acid','Ésteres de 2-etilhexilo del ácido acrílico',10,'29','2916','291612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161290','Outros ésteres do ácido acrílico','Other esters of acrylic acid','Los demás ésteres del ácido acrílico',10,'29','2916','291612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161310','Ácido metacrílico','Methacrylic acid','Ácido metacrílico',10,'29','2916','291613');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161320','Sais do ácido metacrílico','Methacrylic acid and its salts','Sales del ácido metacrílico',10,'29','2916','291613');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161410','Ésteres de metila do ácido metacrílico','Esters of methyl of methacrylic acid','Ésteres de metilo del ácido metacrílico',10,'29','2916','291614');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161420','Ésteres de etila do ácido metacrílico','Esters of ethyl of methacrylic acid','Ésteres de etilo del ácido metacrílico',10,'29','2916','291614');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161430','Ésteres de n-butila do ácido metacrílico','Esters of n-butyl of methacrylic acid','Ésteres de n-butilo del ácido metacrílico',10,'29','2916','291614');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161490','Outros ésteres do ácido metacrílico','Other esters of methacrylic acid','Los demás ésteres del ácido metacrílico',10,'29','2916','291614');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161511','Oleato de manitol','Mannitol oleate','Oleato de manitol',10,'29','2916','291615');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161519','Acido oleico, outs.sais e ésteres (ac.monocarbox.acicl.)','Oleic acid, oth.salts/esters(acycl.monocarboxylic acids)','Ácido oleico, dem.sales y ésteres (ác.monocarbox.acicl.)',10,'29','2916','291615');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161520','Acido linoleico e acido linonenico, seus sais e ésteres','Linoleic acid, linolenic acid, their salts and esters','Ácido linoleico y ácido linolenico,  sus sales y ésteres',10,'29','2916','291615');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161600','Binapacril (isso)','Binapacryl (iso)','Binapacril (iso)',10,'29','2916','291616');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161911','Sorbato de potássio','Potassium sorbate','Sorbato de potasio',10,'29','2916','291619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161919','Ácido sórbico, seus outros sais e ésteres','Sorbic acid, their salts and esters','Ácido sórbico,  sus demás sales y ésteres',10,'29','2916','291619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161921','Ácido undecilênico','Undecylenic acid','Ácido undecilénico',10,'29','2916','291619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161922','Undecilinato de metila','Methyl undecylinate','Undecilenato de metilo',10,'29','2916','291619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161923','Undecilenato de zinco','Zinc undecylenate','Undecilenato de cinc',10,'29','2916','291619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161929','Outros sais e ésteres do ácido undecilênico','Other salts and esters of undecylenic acid','Los demás sales y ésteres del ácido undecilénico',10,'29','2916','291619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29161990','Outros acidos monocarboxilicos acíclicos n/saturad.etc.','Other unsaturated acyclic monocarboxylic acids, etc.','Los dem.ácidos monocarboxílicos acíclicos n/satur.etc.',10,'29','2916','291619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29162011','Acido 3(2, 2dibromovinil)-2, 2dimetilciclopropanocarboxil','3-(2, 2-dibromovinyl)-2, 2-dimethylcyclopropanecarb. acid','Ác. 3(2, 2-dibromovinil)-2, 2-dimetilciclopropanocarboxil',10,'29','2916','291620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29162012','Cloreto do ac.3(2, 2diclorovinil)2, 2dimetilciclopr.(dvo)','3-(2, 2-dichlorovinyl)-2, 2-dimethylcyclop.ac.chlor.(dvd)','Cloruro delác.3(2, 2diclorovinil)2, 2dimetilciclopr.(dvo)',10,'29','2916','291620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29162013','Aletrinas','Allethrins','Aletrinas',10,'29','2916','291620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29162014','Permetrina','Permethrin','Permetrina',10,'29','2916','291620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29162015','Bifentrin','Bifenthrin','Bifentrin',10,'29','2916','291620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29162019','Outros derivados do ácido ciclopropanocarboxilico','Other derivat.of cyclopropanecarboxylic acid','Los demás derivados del ácido ciclopropanocarboxílico',10,'29','2916','291620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29162090','Outros acidos monocarboxil.ciclanicos, ciclenicos, etc.','Oth.cyclanic, cyclenic, cycloterpenic monocarboxyl.ac.etc','Los dem.ácid.monocarboxílicos, ciclánicos, ciclénicos, etc',10,'29','2916','291620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163110','Ácido benzóico','Benzoic acid','Ácido benzoico',10,'29','2916','291631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163121','Sais de sódio do ácido benzóico','Benzoic acid, its salts','Sales de sodio del ácido benzoico',10,'29','2916','291631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163122','Sais de amônio do ácido benzóico','Salts of ammonium of benzoic acid','Sales de amonio del ácido benzoico',10,'29','2916','291631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163129','Outros sais do ácido benzóico','Other salts of benzoic acid','Los demás sales del ácido benzoico',10,'29','2916','291631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163131','Ésteres de metila do ácido benzóico','Esters of methyl of benzoic acid','Ésteres de metilo del ácido benzoico',10,'29','2916','291631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163132','Ésteres de benzila do ácido benzóico','Esters of benzyl of benzoic acid','Ésteres de bencilo del ácido benzoico',10,'29','2916','291631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163139','Outros ésteres do ácido benzóico','Other esters of benzoic acid','Los demás ésteres del ácido benzoico',10,'29','2916','291631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163210','Peróxido de benzoila','Benzoyl peroxide','Peróxido de benzoilo',10,'29','2916','291632');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163220','Cloreto de benzoila','Benzoyl chloride','Cloruro de benzoilo',10,'29','2916','291632');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163400','Ácido fenilacético e seus sais','Phenylacetic acid and its salts','Ácido fenilacético y sus sales',10,'29','2916','291634');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163500','Ésteres do ácido fenilacético','Esters of phenylacetic acid','Ésteres del ácido fenilacético',10,'29','2916','291635');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163600','Binapacril','Binapacril','Binapacril',10,'29','2916','291636');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163910','Cloreto de 4-cloro-alfa-(1-metiletil)benzenoacetila','4-chloro-alpha-(1-methylethyl)benzeneacetyl chloride','Cloruro de 4-cloro-alfa-(1-metiletil)bencenoacet',10,'29','2916','291639');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163920','Ibuprofeno','Ibuprofen','Ibuprofeno',10,'29','2916','291639');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163930','Acido 4-cloro-3-nitrobenzoico','4-chloro-3-nitrobenzoic acid','Ácido 4-cloro-3-nitrobenzoico',10,'29','2916','291639');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163940','Perbenzoato de ter-butila','Tert-butyl perbenzoate','Perbenzoato de ter-butilo',10,'29','2916','291639');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29163990','Outros acidos monocarboxilicos aromáticos, etc.','Other aromatic monocarboxylic acids,  etc.','Los dem.ácidos monocarboxílicos aromáticos,  etc',10,'29','2916','291639');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29171110','Ácido oxálico e seus sais','Oxalic acid and its salts','Ácido oxálico y sus sales',10,'29','2917','291711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29171120','Ésteres do ácido oxálico','Oxalic acid and its esters','Ésteres del ácido oxálico',10,'29','2917','291711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29171210','Acido adípico','Adipic acid','Ácido adípico',10,'29','2917','291712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29171220','Sais e ésteres do ácido adípico','Adipic acid, its salts and esters','Sales y ésteres del ácido adípico',10,'29','2917','291712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29171310','Ácido azelaico, seus sais e ésteres','Azelaic acid, its salts and esters','Ácido azelaico, sus sales y ésteres',10,'29','2917','291713');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29171321','Ácido sebácico','Sebacic acid','Ácido sebácico',10,'29','2917','291713');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29171322','Sebacato de dibutila','Dibutyl sebacate','Sebacato de dibutilo',10,'29','2917','291713');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29171323','Sebacato de dioctila','Dioctyl sebacate','Sebacato de dioctilo',10,'29','2917','291713');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29171329','Outros sais e ésteres do ácido sebacico','Other sebacic acid, their salts and esters','Los demás sales y ésteres del ácido sebácico',10,'29','2917','291713');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29171400','Anidrido maleico','Maleic anhydride','Anhídrido maleico',10,'29','2917','291714');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29171910','Dioctilsulfossuccinato de sódio','Sodium dioctylsulphosuccinate','Dioctilsulfosuccinato de sodio',10,'29','2917','291719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29171921','Ácido maleico','Maleic acid','Ácido maleico',10,'29','2917','291719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29171922','Sais e ésteres do ácido maleico','Maleic acid, its salts and esters','Sales y ésteres del ácido maleico',10,'29','2917','291719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29171930','Ácido fumarico, seus sais e ésteres','Fumaric acid, its salts and esters','Ácido fumárico,  sus sales y ésteres',10,'29','2917','291719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29171990','Outros ácidos policarboxílicos acíclicos, etc.','Other acyclic polycarboxylic acids, etc.','Los demás ácidos policarboxílicos acíclicos,  etc',10,'29','2917','291719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29172000','Ácido policarboxílico ciclânico, ciclênico, etc.','Cyclanic, cyclenic, etc.polycarboxylic acids, etc','Ácido policarboxílico ciclánico, ciclénico,  etc',10,'29','2917','291720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29173100','Ortoftalatos de dibutila','Dibutyl orthophthalates','Ortoftalatos de dibutilo',10,'29','2917','291731');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29173200','Ortoftalatos de dioctila','Dioctyl orthophthalates','Ortoftalatos de dibutilo',10,'29','2917','291732');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29173300','Ortoftalatos de dinonila ou de didecila','Dinonyl or didecyl orthophthalates','Ortoftalatos de dinonilo o de didecilo',10,'29','2917','291733');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29173400','Outros ésteres do ácido ortoftálico','Other esters of orthophthalic acid','Los demás ésteres del ácido ortoftálico',10,'29','2917','291734');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29173500','Anidrido ftalico','Phthalic anhydride','Anhídrido ftálico',10,'29','2917','291735');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29173600','Ácido tereftalico e seus sais','Terephthalic acid and its salts','Ácido tereftálico y sus sales',10,'29','2917','291736');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29173700','Tereftalato de dimetila','Dimethyl terephthalate','Tereftalato de dimetilo',10,'29','2917','291737');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29173911','Ésteres do ácido m-ftalico','M-phthalic acid esters','Ésteres del ácido m-ftálico',10,'29','2917','291739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29173919','Ácido m-ftalico e seus sais','M-phthalic acid, its salts','Ácido m-ftálico y sus sales',10,'29','2917','291739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29173920','Ácido o-ftalico e seus sais','O-phthalic acid, its salts','Ácido o-ftálico y sus sales',10,'29','2917','291739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29173931','Ésteres de dioctila do ácido tereftalico','Dioctyl esters of terephthalic acid','Ésteres de dioctilo del ácido tereftálico',10,'29','2917','291739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29173939','Outros ésteres do ácido tereftalico','Other terephthalic acid esters','Los demás ésteres del ácido tereftálico',10,'29','2917','291739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29173940','Sais e ésteres do ac.trimelitico (1, 2, 4-benzenotricarb)','Salts and esters of trimellitic acid (1, 2, 4-benzenetr.)','Sales y ésteres del ác trimelítico(1, 2, 4bencenotricarb)',10,'29','2917','291739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29173950','Anidrido trimelitico (ac.1, 3dioxo-5isobenzofuranocarb.)','Trimellitic anhydride(1, 3-dihydro-1, 3-dioxo-5-isobenz.)','Anhídrido trimelítico (ác.1, 3dioxo-5isobenzofuranocarb)',10,'29','2917','291739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29173990','Outros ácidos policarboxilicos aromáticos, etc.','Other aromatic polycarboxylic acids, etc','Los demás ácidos policarboxílicos aromáticos,  etc',10,'29','2917','291739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181100','Ácido láctico, seus sais e ésteres','Lactic acid, its salts and esters','Ácido láctico, sus sales y ésteres',10,'29','2918','291811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181200','Ácido tartárico','Tartaric acid','Ácido tartárico',10,'29','2918','291812');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181310','Sais do ácido tartárico','Tartaric acid, its salts','Sales del ácido tartárico',10,'29','2918','291813');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181320','Ésteres do ácido tartárico','Tartaric acid, its esters','Ésteres del ácido tartárico',10,'29','2918','291813');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181400','Ácido cítrico','Citric acid','Ácido cítrico',10,'29','2918','291814');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181500','Sais e ésteres do ácido cítrico','Salts and esters of citric acid','Sales y ésteres del ácido cítrico',10,'29','2918','291815');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181610','Gluconato de cálcio','Calcium gluconate','Gluconato de calcio',10,'29','2918','291816');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181690','Ácido glucônico, seus outros sais e ésteres','Gluconic acid, its other salts and esters','Ácido glucónico,  sus demás sales y ésteres',10,'29','2918','291816');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181700','Ácido fenilglicolico (ac.mandelico), seus sais e ésteres','Phenyl glicolic acid(mandelic ac.), its salts and esters','Ácido fenilglicólico (ác.mandélico), sus sales y ésteres',10,'29','2918','291817');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181800','Clorobenzilato','Chlorobenzilate','Clorobencilato',10,'29','2918','291818');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181910','Bromopropilato','Bromopropylate','Bromopropilato',10,'29','2918','291819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181921','Ursodiol (ácido ursodeoxicólico)','Ursodiol (ursodeoxycholic acid)','Ursodiol (ácido ursodeoxicólico)',10,'29','2918','291819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181922','Ácido quenodeoxicólico','Chenodeoxycholic acid','Ácido quenodeoxicólico',10,'29','2918','291819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181929','Ácido biliar, seus outros sais, ésteres e derivados','Biliar acid, its other salts, esters and derivatives','Ácido biliar,  sus demás sales,  ésteres y derivados',10,'29','2918','291819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181930','Ácido 12-hidroxiesteárico','12-hydroxystearic acid','Ácido 12-hidroxiesteárico',10,'29','2918','291819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181941','Acido benzilico (acido 2, 2-difenil-2-hidroxiacético)','Benzylic acid (2, 2-diphenil-2-hidroxyacetic acid)','Ácido benzílico (ácido 2, 2-difenil-2-hidroxiacético)',10,'29','2918','291819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181942','Sais do ácido benzílico','Salts of benzylic acid','Sales del ácido benzílico',10,'29','2918','291819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181943','Ésteres do ácido benzílico','Esters of benzylic acid','Ésteres del ácido benzílico',10,'29','2918','291819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29181990','Outros ácidos carboxilicos função álcool, anidridos, etc.','Other carboxylic acids alcohol function, anhydrides, etc','Los dem.ác.carboxílicos c/función alcoh., anhídridos, etc',10,'29','2918','291819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182110','Ácido salicílico','Salicylic acid','Ácido salicílico',10,'29','2918','291821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182120','Sais do ácido salicílico','Salts of salicylic acid','Sales del ácido salicílico',10,'29','2918','291821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182211','Ácido o-acetilsalicílico','O-acetylsalicylic acid','Ácido o-acetilsalicílico',10,'29','2918','291822');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182212','O-acetilsalicilato de alumínio','Aluminium o-acetylsalicylate','O-acetilsalicilato de aluminio',10,'29','2918','291822');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182219','Outros sais do ácido o-acetilsalicílico','Other salts of o-acetylsalicylate acid','Los demás sales del ácido o-acetilsalicílico',10,'29','2918','291822');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182220','Ésteres do ácido o-acetilsalicílico','Other esters of o-acetylsalicylate acid','Ésteres del ácido o-acetilsalicílico',10,'29','2918','291822');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182300','Outros ésteres do ácido salicílico e seus sais','Other esters of salicylic acid and their salts','Los demás ésteres del ácido salicílico y sus sales',10,'29','2918','291823');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182910','Ácido hidroxinaftóico','Hydroxynaphthoic acid','Ácido hidroxinaftoico',10,'29','2918','291829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182921','Ácido p-hidroxibenzóico','P-hydroxybenzoic acid','Ácido p-hidroxibenzoico',10,'29','2918','291829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182922','Metilparabeno','Methylparaben','Metilparabeno',10,'29','2918','291829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182923','Propilparabeno','Propylparaben','Propilparabeno',10,'29','2918','291829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182929','Outros sais e ésteres do ácido p-hidroxibenzóico','Other salts and esters of p-hydroxybenzoic acid','Los demás sales y ésteres del ácido p-hidroxibenzoico',10,'29','2918','291829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182930','Ácido gálico, seus sais e ésteres','Gallic acid, its salts and esters','Ácido gálico,  sus sales y ésteres',10,'29','2918','291829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182940','Tetrakis(3(3, 5d.t.butil-4hidroxif.)prop.pentaeritritila','Pentaerythrityl tetrakis(3(3, 5-di-tert-butyl-4-hyd.)pr.','Tetrakis(3-(3, 5-di-ter-butil-4hidroxif.)prop.pentaerit.',10,'29','2918','291829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182950','3-(3, 5-d.t.butil-4hidroxifenil)propionato de octadecila','Octadecyl 3-(3, 5-di-tert-butyl-4-hydroxyphenyl)propion.','3(3, 5-di-ter-butil-4-hidroxifenil)propionato de octadec',10,'29','2918','291829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29182990','Outros ácidos carboxilicos função fenol, anidridos, etc.','Others carboxylic acids, phenol function, anhydrides, etc','Los dem.ác.carboxílicos c/ función fenol, anhídridos, etc',10,'29','2918','291829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29183010','Cetoprofeno','Ketoprofen','Ketoprofeno',10,'29','2918','291830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29183020','Butirilacetato de metila','Methylbutryl acetate','Butirilacetato de metilo',10,'29','2918','291830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29183031','Ácido deidrocólico','Dehydrocholic acid','Ácido dehidrocólico',10,'29','2918','291830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29183032','Deidrocolato de sódio','Sodium dehydrocholate','Dehidrocolato de sodio',10,'29','2918','291830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29183033','Deidrocolato de magnésio','Magnesium dehydrocholate','Dehidrocolato de magnesio',10,'29','2918','291830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29183039','Outros sais do ácido deidrocólico','Others salts of dehydrocholic acid','Los demás sales del ácido dehidrocólico',10,'29','2918','291830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29183040','Acetilacetato de 2-nitrometilbenzilideno','2-nitromethylbenzylidene acetyl acetate','Acetilacetato de 2-nitrometilbencilideno',10,'29','2918','291830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29183090','Outros ácidos carboxilicos função aldeído, cetona, etc.','Others carboxylic acids aldehyde fuction,  ketone, etc','Los dem.ácidos carboxílicos c/func.aldehído, cetona, etc',10,'29','2918','291830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189011','Ácido fenoxiacético, seus sais e ésteres','Phenoxyacetic acid, its salts and esters','Ácido fenoxiacético,  sus sales y ésteres',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189012','Ácido 2, 4-diclorofenoxiacético, seus sais e seus ésteres','2, 4-dichlorophenoxyacetic acid, its salts and esters','Ácido 2, 4-diclorofenoxiacético, sus sales y sus ésteres',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189013','Ácido 2, 4, 5-triclorofenoxiacético','2, 4, 5-trichlorophenoxyacetic acid','Ácido 2, 4, 5-triclorofenoxiacético',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189019','Outros derivados do ácido fenoxiacético, sais e ésteres','Other deriv.phenoxyacetic acid, its salts and esters','Los dem.derivados del ác.fenoxiacético, sales y ésteres',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189021','Ácido diclorofenoxibutírico, seus sais e ésteres','Dichlorophenoxybutyric acid, its salts and esters','Ácido diclorofenoxibutírico,  sus sales y ésteres',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189029','Outros ácidos fenoxibutíricos, seus sais, ésteres, derivs.','Others phenoxybutyric acids, its salts, esters, derivativ.','Los dem.ácid.fenoxibutíricos, sus sales, ésteres, derivs.',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189030','Acifluorfen sódico','Acifluorfen sodium','Acifluorfen sódico',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189040','Naproxeno','Naproxen','Naproxeno',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189050','Ácido 3(2cloroalfa, alfa, alfatrifluor-ptoliloxi)benzoico','3-(2-chloro-a, a, a-trifluoro-p-tolyloxy)benzoic acid','Ác. 3(2cloroalfa, alfa, alfatrifluoro-ptoliloxi) benzoico',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189060','Diclofop-metila','Diclofop-methyl','Diclofop-metilo',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189091','Fenofibrato','Fenofibrate','Fenofibrato',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189092','Acido metilclorofenoxiacético, seus sais e ésteres','Methylchlorophenoxyacetic acid, their salts/esters','Ácido metilclorofenoxiacético, sus sales y ésteres',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189093','5-(2-cloro-4-trifluormetilfenox)-2nitrob.etc.(lactofen)','5-(2-chloro-4-trifluoromethylphenoxy)2-nitrob.etc(lac.)','5-(2-cloro-4-trifluorometilfenox)-2nitrob, etc(lactofen)',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189094','Acido 4-(4-hidroxifenoxi)-3, 5-diiodofenilacético','4-(4-hydroxyphenoxy)-3, 5-diiodophenyl acetic acid','Ácido 4-(4-hidroxifenoxi)-3, 5-diiodofenilacetico',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189095','Tiratricol (triac) e seu sal sódico','Triac and its sodic salt','Tiratricol (triac) y su sal sódica',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189099','Outros acidos carboxilicos função oxigen.suplement.etc.','Oth.carboxylic acids with supplemen.oxygen function, etc','Los dem.ác.carboxílicos c/función oxigen.suplement.etc.',10,'29','2918','291890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189100','Ácido 2, 4, 5-triclorofenoxiacético','2, 4, 5-trichlorophenoxyacetic acid','Ácido 2, 4, 5-triclorofenoxiacético',10,'29','2918','291891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189911','Ácido fenoxiacético, seus sais, seus ésteres','Phenoxyacetic acid, its salts and esters','Ácido fenoxiacético,  sus sales y ésteres',10,'29','2918','291899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189912','Ácido 2, 4-diclorofenoxiacético, sais e ésteres','2, 4-dichlorophenoxyacetic acid, its salts and esters','Ácido 2, 4-diclorofenoxiacético, sus sales y sus ésteres',10,'29','2918','291899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189919','Outs.derivados d/ac.fenoxiacéticos, sais, ést.','Other deriv.phenoxyacetic acid, its salts and esters','Otros derivados del ácido fenoxiacético, sales y ésteres',10,'29','2918','291899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189921','Ácidos diclorofenoxibutanóicos, sais/ést.','Dichlorophenoxybutyric acid, its salts and esters','Ácido diclorofenoxibutírico,  sus sales y ésteres',10,'29','2918','291899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189929','Outs.ác.diclorofenoxibutanóicos, sais/éster.','Other dichlorophenoxybutyric acids, its salts and esters','Otros ácidos diclorofenoxibutírico,  sus sales y ésteres',10,'29','2918','291899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189930','Acifluorfen sódico','Acifluorfen sodium','Acifluorfen sódico',10,'29','2918','291899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189940','Naproxeno','Naproxen','Naproxeno',10,'29','2918','291899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189950','Ác.3-(2''-cl.-alfa, alfa, alfa-trifl.-toliloxi)benz.','Ác.3-(2''-cl.-alfa,alfa,alfa-trifl.-toliloxi)benz.','Ác.3-(2''-cl.-alfa,alfa,alfa-trifl.-toliloxi)benz.',10,'29','2918','291899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189960','Diclofop-metila','Diclofop-methyl','Diclofop-metilo',10,'29','2918','291899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189991','Fenofibrato','Fenofibrate','Fenofibrato',10,'29','2918','291899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189992','Ácido metilclorofenoxiacético, sais , ésteres','Methylchlorophenoxyacetic acid, their salts/esters','Ácido metilclorofenoxiacético, sus sales y ésteres',10,'29','2918','291899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189993','5-(2-cloro-4-trifluormetilf.)-2-nitr.(lactofen)','5-(2-chloro-4-trifluoromethylphenoxy)2-nitrob.etc(lac.)','5-(2-cloro-4-trifluorometilfenox)-2nitrob, etc(lactofen)',10,'29','2918','291899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189994','Ácido 4-(4-hidroxifenoxi)-3, 5-diiodofenilacético','4-(4-hydroxyphenoxy)-3, 5-diiodophenyl acetic acid','Ácido 4-(4-hidroxifenoxi)-3, 5-diiodofenilacetico',10,'29','2918','291899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29189999','Outs.ác.carb.c/func.oxig.supl.e s/anid., s/der.','Other ac.carb. with/func.oxig.supland s/anid., s/der.','Otros.ác.carb.c/func.oxig.supl.y s/anid., s/der.',10,'29','2918','291899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29190010','Ester fosfórico de tributila','Phosphoric ester of tributyl','Éster fosfórico de tributilo',10,'29','2919','291900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29190020','Ester fosfórico de tricresila','Phosphoric ester of tricresyl','Éster fosfórico de tricresilo',10,'29','2919','291900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29190030','Ester fosfórico de trifenila','Phosphoric ester of triphenyl','Éster fosfórico de trifenilo',10,'29','2919','291900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29190040','Diclorvos (ddvp)','Dichlorvos (ddvp)','Diclorvos',10,'29','2919','291900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29190050','Lactofosfato de cálcio','Calcium lactophosphate','Lactofosfato de calcio',10,'29','2919','291900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29190060','Clorfenvinfos','Chlorfenvinphos','Clorfenvinfos',10,'29','2919','291900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29190070','Fosfato de tris(2, 3-dibromopropila)','Tris (2, 3-dibromopropyl) phospahte','Fosfato de tris (2, 3-dibromopropil)',10,'29','2919','291900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29190090','Outs.ésteres fosfóricos, seus sais, deriv.halogenados, etc','Oth.phosphoric ester, its salt, halogen.derivative, etc','Los dem.ésteres fosfóricos, sus sales, deriv.halogen.etc',10,'29','2919','291900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29191000','Fosfato de tris(2, 3-dibromopropila)','Tris (2, 3-dibromopropyl) phospahte','Fosfato de tris (2, 3-dibromopropil)',10,'29','2919','291910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29199010','Ésteres fosfóricos e sais de tributila','Phosphoric ester and salts of tributyl','Éster fosfórico y sales de tributilo',10,'29','2919','291990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29199020','Ésteres fosfóricos e sais de tricresila','Phosphoric ester and salts of tricresyl','Éster fosfórico y sales de tricresilo',10,'29','2919','291990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29199030','Ésteres fosfóricos e sais de trifenila','Phosphoric ester and salts of triphenyl','Éster fosfórico e sales de trifenilo',10,'29','2919','291990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29199040','Diclorvós (ddvp)','Dichlorvos (ddvp)','Diclorvos',10,'29','2919','291990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29199050','Lactofosfato de cálcio','Calcium lactophosphate','Lactofosfato de calcio',10,'29','2919','291990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29199060','Clorfenvinfós','Chlorfenvinphos','Clorfenvinfos',10,'29','2919','291990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29199090','Outs.est.fosfóricos, s/sais, lactofosf.deriv.','Obter phosphoric ester, its salt, halogen.derivative, etc','Otros ésteres fosfóricos, sus sales, deriv.halogen.etc',10,'29','2919','291990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29201010','Fenitrotion','Fenitrothion','Fenitrotión',10,'29','2920','292010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29201020','Metil paration','Methylparathion','Metil paratión',10,'29','2920','292010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29201030','Cloreto de fósforotioato de dimetila','Dimethyl phosphorothioate chloride','Cloruro de fosforotioato de dimetilo',10,'29','2920','292010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29201031','Cloreto de fósforotioato de dimetila, concentr.peso>98%','Dimethyl phosphorothioate chloride, concentr.>98% weight','Cloruro de fosforotioato dedimetilo, concentr>98%en peso',10,'29','2920','292010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29201039','Outros cloretos de fósforotioato de dimetila','Other dimethyl phosphorothioate chloride','Los demás cloruros de fosforotioato de dimetilo',10,'29','2920','292010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29201040','Etilparation','Ethylparathion','Etilparation',10,'29','2920','292010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29201090','Outs.ésteres tiofosfóricos, seus sais, derivs.halogen.etc','Other thiophosphoric esters, its salts, deriv. halog.etc','Los dem.éster.tiofosfóricos, sus sales, derivs.halog.etc',10,'29','2920','292010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29201110','Paration (etil paration)','Ethylparathion','Etilparation',10,'29','2920','292011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29201120','Paration-metila (metil paration)','Methyl paration','Metil paratión',10,'29','2920','292011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29201910','Fenitrotion','Fenitrothion','Fenitrotión',10,'29','2920','292019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29201920','Cloreto de fósforotioato de dimetila','Dimethyl phosphorothioate chloride','Cloruro de fosforotioato de dimetilo',10,'29','2920','292019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29201990','Outs.ésteres tiofosfóricos, sais e derivados','Other thiophosphoric esters, salts and derivatives','Otros ésteres tiofosfóricos, sales y derivados',10,'29','2920','292019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209011','Fosfito de dimetila','Dimethyl phosphite','Fosfito de dimetilo',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209012','Fosfito de trimetila','Trimethyl phosphite','Fosfito de trimetilo',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209013','Fosfito de alquila de c3 a c13 ou de alquil-arila','Alkyl phosphite (c3 to c13) or alkylaryl','Fosfito de alquilo de c3 a c13 o de alquil-arilo',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209014','Fosfito de difenila','Diphenyl phosphite','Fosfito de difenilo',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209015','Outros fosfitos de arila','Aryl phosphite','Los demás fosfitos de arilo',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209016','Fosetil al','Fosetyl al','Fosetil al',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209017','Fosfito de tris-(2, 4-di-ter-butilfenila)','Tris(2, 4-di-tert-butylphenyl) phosphite','Fosfito de tris-(2, 4-di-ter-butilfenilo)',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209019','Outros fosfitos,  exceto os de metila e de etila','Other phosphite, except those of methyl and ethyl','Los demás fosfitos, excepto los de metilo y de etilo',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209021','Endossulfan','Endosulfan','Endosulfan',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209022','Propargite','Propargite','Propargite',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209029','Outros sulfitos de ésteres de acidos inorgânicos','Other sulphide of esters of inorganic acid','Los demás sulfitos de ésteres de ácidos inorgánicos',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209031','Nitrato de propatila','Propatyl nitrate','Nitrato de propatilo',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209032','Nitroglicerina','Nitroglycerol','Nitroglicerina',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209033','Tetranitrato de pentaeritritol (petn, nitropenta, etc.)','Pentaerythritol tetranitrate (petn,  penthrite, etc)','Tetranitrato de pentaeritritol(petn,  nitropenta, etc)',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209039','Outros nitratos de ésteres de acidos inorgânicos','Other nitrates of esters of inorganic acid','Los demás nitratos de ésteres de ácidos inorgánicos',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209041','Sulfato de alquila de c6 a c22','Alky (c6 to c22) sulphide','Sulfato de alquilo de c6 a c22',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209042','Sulfato de monoalquil(di ou tri)etilenoglicol','Sulphide of monoalkyldiethylene glycols(di or tri)','Sulfato de monoalquil (di o tri) etilenglicol',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209049','Outros sulfatos de ésteres de ácidos inorgânicos','Other esters sulphide of inorganic acids','Los demás sulfatos de ésteres de ácidos inorgánicos',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209051','Silicato de etila','Ethyl silicate','Silicato de etilo',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209059','Outros silicatos de ésteres de ácidos inorgânicos','Other esters silicates of inorganic acids','Los demás silicatos de ésteres de ácidos inorgánicos',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209061','Fosfitos de dimetila','Dimethyl phosphite','Fosfitos de dimetilo',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209062','Fosfitos de trimetila','Trimethyl phosphite','Fosfitos de trimetilo',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209063','Fosfitos de dietila','Diethyl phosphite','Fosfitos de dietilo',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209064','Fosfitos de trietila','Triethyl phosphite','Fosfitos de trietilo',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209069','Outros fosfitos de metila ou de etila','Other phosphite of methyl and ethyl','Los demás fosfitos de metilo o de etilo',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29209090','Outs.ésteres dos acidos inorgan.sais, derivs.halogen.etc','Other esters of inorg.acid, salts, deriv.halog.etc','Los dem.ésteres de los ác. inorg.sales, derivs.halog.etc',10,'29','2920','292090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211111','Monometilamina','Methylamine','Monometilamina',10,'29','2921','292111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211112','Sais de monometilamina','Salts of methylamine','Sales de monometilamina',10,'29','2921','292111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211121','Dimetilamina','Dimethylamine','Dimetilamina',10,'29','2921','292111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211122','2, 4-diclorofenoxiacetato de dimetilamina','Dimethylamine 2, 4-dichlorophenoxyacetate','2, 4-diclorofenoxiacetato de dimetilamina',10,'29','2921','292111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211123','Metilclorofenoxiacetato de dimetilamina','Dimethylamine methylchlorophenoxyacetate','Metilclorofenoxiacetato de dimetilamina',10,'29','2921','292111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211129','Outros sais de dimetilamina','Other salts of dimethylamine','Los demás sales de dimetilamina',10,'29','2921','292111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211131','Trimetilamina','Trimethylamine','Trimetilamina',10,'29','2921','292111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211132','Cloridrato de trimetilamina','Trimethylamine hydrochloride','Clorhidrato de trimetilamina',10,'29','2921','292111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211139','Outros sais de trimetilamina','Other salts of trimethylamine','Los demás sales de trimetilamina',10,'29','2921','292111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211210','Dietilamina','Diethylamine','Dietilamina',10,'29','2921','292112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211220','Etansilato ("ethamsylate")','Ethamsylate ("ethamsylate")','Etamsilato ("ethamsylate")',10,'29','2921','292112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211290','Outros sais de dietilamina','Other salts of diethylamine','Los demás sales de dietilamina',10,'29','2921','292112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211911','Monoetilamina e seus sais','Monoethylamine and its salts','Monoetilamina y sus sales',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211912','Trietilamina','Triethylamine','Trietilamina',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211913','Bis(2-cloroetil)etilamina','Bis(2-chloroethyl)ethylamine)','Bis(2-cloroetil)etilamina',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211914','Triclormetina (tris(2-cloroetil)amina)','Trichlormethine (inn) (tris(ß-chlororethyl)amine)','Triclometina (tris(2-cloroetil)amina)',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211915','Dietilamina sais, exc.etansilato(ethamsylate)','Salts of dimethylamine, except ethamsylate','Sales de dimetilamina, excepto etansilato',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211919','Outras etilaminas, seus derivados e seus sais','Other ethylamine and its salts','Las demás etilaminas,  sus derivados y sus sales',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211921','Mono-n-propilamina e seus sais','Mono-n-propylamine and its salts','Mono-n-propilamina y sus sales',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211922','Di-n-propilamina e seus sais','Di(n-propylamine) and its salts','Di-n-propilamina y sus sales',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211923','Monoisopropilamina e seus sais','Monoisopropylamine and its salts','Monoisopropilamina y sus sales',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211924','Diisopropilamina e seus sais','Diisopropylamine and its salts','Diisopropilamina y sus sales',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211929','Outras n-propilaminas, isopropilaminas e seus sais','Other n-propylamine, isopropylamine and its salts','Las demás n-propilaminas,  isopropilaminas y sus sales',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211931','Diisobutilamina e seus sais','Diisobutylamine and its salts','Diisobutilamina y sus sales',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211939','Outras butilaminas e seus sais','Other butylamine and its salts','Las demás butilaminas y sus sales',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211941','Metildialquilaminas','Methyldialkylamines','Metildialquilaminas',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211949','Monoalquil- e outs.dialquilaminas, alquila de c10 a c18','Monoakyl and other dialkilamines, alkyla(c10 to c18)','Monoalquil- y otras dialquilaminas, alquilo de c10 a c18',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211990','Outras monoaminas acíclicas, seus derivados e seus sais','Other acyclic amine and its salts and derivatives','Las dem.monoaminas acíclicas,  sus derivados y sus sales',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211991','Clormetina (bis(2-cloroetil)metilamina)','Chlormethine (inn) (di(chloroethyl)methylamine)','Clormetina (bis(2-cloroetil)metilamina)',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211992','N, n-diaquil-2-cloroetilamina, c/grup.alquila c1 a c3, etc','N, n-dialkyl(c1 to c3)-2-chloroethylamines, etc','N, n-diaquil-2-cloroetilamina, c/grup.alquilo c1 a c3, etc',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211993','Mucato de isometepteno','Isometheptene mucate','Mucato de isometepteno',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29211999','Outs.monoaminas acíclicas e seus derivados e seus sais','Other acyclic amine and its salts and derivatives','Las dem.monoaminas acíclicas,  sus derivs.y sus sales',10,'29','2921','292119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29212100','Etilenodiamina e seus sais','Ethylenediamine and its salts','Etilendiamina y sus sales',10,'29','2921','292121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29212200','Hexametilenodiamina e seus sais','Hexamethylenediamine and its salts','Hexametilendiamina y sus sales',10,'29','2921','292122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29212910','Dietilenotriamina e seus sais','Diethylenetriamine and its salts','Dietilentriamina y sus sales',10,'29','2921','292129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29212920','Trietilenotetramina e seus sais','Triethyltetramine and its salts','Trietilentetramina y sus sales',10,'29','2921','292129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29212990','Outras poliaminas acíclicas, seus derivados e seus sais','Other polyamines acyclics, its derivatives and its salts','Las dem.poliaminas acíclicas, sus derivados y sus sales',10,'29','2921','292129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29213011','Monocicloexilamina e seus sais','Cyclohexylamine and its salts','Monociclohexilamina y sus sales',10,'29','2921','292130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29213012','Dicicloexilamina','Dicyclohexylamine','Diciclohexilamina',10,'29','2921','292130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29213019','Outras cicloexilaminas e seus sais','Other cyclohexylamine and its salts','Las demás ciclohexilaminas y sus sales',10,'29','2921','292130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29213020','Propilexedrina','Propylhexedrine','Propilhexedrina',10,'29','2921','292130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29213090','Outs.monoaminas e poliaminas ciclanicas, ciclenicas, etc.','Other amines/polyamines cyclanic, cyclenic, etc.','Las dem.monoaminas y poliaminas ciclánicas, ciclénic.etc',10,'29','2921','292130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214100','Anilina e seus sais','Aniline and its salts','Anilina y sus sales',10,'29','2921','292141');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214211','Acido sulfanilico e seus sais','Sulphanilic acid and its salts','Ácido sulfanílico y sus sales',10,'29','2921','292142');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214219','Outros acidos aminobenzenossulfonicos e seus sais','Other aminebenzenesulphonics acid, and their salts','Los demás ácidos aminobencenosulfónicos y sus sales',10,'29','2921','292142');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214221','3, 4-dicloroanilina e seus sais','3, 4-dichloroaniline and its salts','3, 4-dicloroanilina y sus sales',10,'29','2921','292142');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214229','Outras cloroanilinas e seus sais','Other chloroaniline and its salts','Las demás dicloroanilinas y sus sales',10,'29','2921','292142');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214231','4-nitroanilina','4-nitroaniline','4-nitroanilina',10,'29','2921','292142');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214239','Outras nitroanilinas e seus sais','Other nitroaniline and their salts','4-nitroanilina',10,'29','2921','292142');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214241','5-cloro-2-nitroanilina','5-chloro-2-nitroaniline','5-cloro-2-nitroanilina',10,'29','2921','292142');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214249','Outras cloronitroanilinas e seus sais','Other chloronitroaniline and its salts','Las demás cloronitroanilinas y sus sales',10,'29','2921','292142');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214290','Outros derivados da anilina e seus sais','Other aniline derivatives and their salts','Los demás derivados de la anilina y sus sales',10,'29','2921','292142');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214311','O-toluidina','O-toluidine','O-toluidina',10,'29','2921','292143');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214319','Outras toluidinas e seus sais','Other o-toluidines and their salts','Las demás toluidinas y sus sales',10,'29','2921','292143');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214321','3-nitro-4-toluidina e seus sais','3-nitro-4-toluidine and its salts','3-nitro-4-toluidina y sus sales',10,'29','2921','292143');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214322','Trifluralina','Trifluralin','Trifluralina',10,'29','2921','292143');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214323','4-cloro-2-toluidina','4-chloro-2-toluidine','4-cloro-2-toluidina',10,'29','2921','292143');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214329','Outros derivados das toluidinas e seus sais','Other toluidines and their derivatives and salts','Los demás derivados de las toluidinas y sus sales',10,'29','2921','292143');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214410','Difenilamina e seus sais','Diphenylamine and its salts','Difenilamina y sus sales',10,'29','2921','292144');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214421','N-octildifenilamina','N-octyldiphenylamine','N-octildifenilamina',10,'29','2921','292144');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214422','N-nonildifenilamina','N-nonyldiphenylamine','N-nonildifenilamina',10,'29','2921','292144');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214429','Outros derivados da difenilamina e seus sais','Oth.diphenylamine and its derivatives salts thereof','Los demás derivados de la difenilamina y sus sales',10,'29','2921','292144');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214500','1-naftilamina (alfa), 2-naftilamina (beta), derivs.e sais','1-naphthylamine(alpha)2-naphthylamine(beta)deriv./salts','1-naftilamina (alfa), 2-naftilamina(beta), derivs.y sales',10,'29','2921','292145');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214610','Anfetamina e seus sais','Amfetamine and its salts','Anfetamina y sus sales',10,'29','2921','292146');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214620','Benzofetamina e seus sais','Benzfetamine and its salts','Benzfetamina y sus sales',10,'29','2921','292146');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214630','Dexanfetamina e seus sais','Dexamfetamine and its salts','Dexanfetamina y sus sales',10,'29','2921','292146');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214640','Etilanfetamina e seus sais','Etilamfetamine and its salts','Etilanfetamina y sus sales',10,'29','2921','292146');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214650','Fencanfamina e seus sais','Fencamfetamine and its salts','Fencanfamina y sus sales',10,'29','2921','292146');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214660','Fentermina e seus sais','Phentermine and its salts','Fentermina y sus sales',10,'29','2921','292146');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214670','Lefetamina e seus sais','Lefetamine and its salts','Lefetamina y sus sales',10,'29','2921','292146');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214680','Levanfetamina e seus sais','Levamfetamine and its salts','Levanfetamina y sus sales',10,'29','2921','292146');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214690','Mefenorex e seus sais','Mefenorex and its salts','Mefenorex y sus sales',10,'29','2921','292146');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214910','Cloridrato de fenfluramina','Fenfluramine hydrochloride','Clorhidrato de fenfluramina',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214921','2, 4-xilidina e seus sais','2, 4-xylidine and its salts','2, 4-xilidina y sus sales',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214922','Pendimetalina','Pendimethalin','Pendimetalina',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214929','Outras xilidinas, seus derivados e seus sais','Other xylidine, its derivatives and its salts','Las demás xilidinas, sus derivados y sus sales',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214931','Sulfato de tranilcipromina','Tranylcypromine sulphate','Sulfato de tranilcipromina',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214939','Outras tranilciprominas e seus sais','Other tranylcypromine and its salts','Los demás tranilciprominas y sus sales',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214941','Anfetamina (di-alfa-metilfenetilamina) e seus sais','Amfetamine (di-alpha-methylphenetylamine) and its salts','Anfetamina (di-alfa-metilfenetilamina) y sus sales',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214942','Levanfetamina (i-alfa-metilfenetilamina) e seus sais','Levamfetamine(di-alpha-methylphenetylamine)and its salts','Levanfetamina (i-alfa-metilfenetilamina) y sus sales',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214943','Desanfetamina ("dexamphetamine") e seus sais','Dexamfetamine ("dexamphetamine") and its salts','Desanfetamina ("dexamphetamine") y sus sales',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214944','Etilanfetamina ("n-ethylamphetamine") e seus sais','Etilamfetamine ("n-ethylamphetamine") and its salts','Etilanfetamina ("n-ethylamphetamine") y sus sales',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214945','Benzfetamina e seus sais','Benzfetamine and its salts','Benzfetamina y sus sales',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214946','Mefenorex e seus sais','Mefenorex and its salts','Mefenorex y sus sales',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214949','Outs.metilfenetilamina, seus derivados e seus sais','Oth.methylphenetylamine, its derivatives and its salts','Las demás metilfenetilaminas,  sus derivados y sus sales',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214951','Fencanfamina e seus sais','Fencamfamine and its salts','Fencanfamina y sus sales',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214952','Lefetamina e seus sais','Lefetamine and its salts','Lefetamina y sus sales',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214953','Fentermina e seus sais','Phentermine and its salts','Fentermina y sus sales',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29214990','Outras monoaminas aromáticas, seus derivados e seus sais','Oth.aromatic monoamine, its derivatives and its salts','Las dem.monoaminas aromáticas, sus derivados y sus sales',10,'29','2921','292149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215111','M-fenilenodiamina e seus sais','M-phenylenediamine and its salts','M-fenilendiamina y sus sales',10,'29','2921','292151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215112','Diaminotoluenos (toluilenodiaminas)','Diaminotoluenes','Diaminotoluenos (toluilendiaminas)',10,'29','2921','292151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215119','O-fenilenodiamina, p-fenilenodiamina e seus sais','O-phenylenediamine, p-phenylenediamine and its salts','O-fenilendiamina, p-fenilendiamina y sus sales',10,'29','2921','292151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215120','Derivados sulfonados das fenilenodiaminas, derivs.e sais','O-phenylenediamine, p-phenylenediamine and its salts','Derivs sulfonados de las fenilendiaminas, derivs.y sales',10,'29','2921','292151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215131','N, n''-di-sec-butil-p-fenilenodiamina','N, n''-di-sec-butyl-p-phenylenediamine','N, n''-di-sec-butil-p-fenilendiamina',10,'29','2921','292151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215132','N-isopropil-n''-fenil-p-fenilenodiamina','N-isopropyl-n''-phenyl- p-phenylenediamine','N-isopropil-n''-fenil-p-fenilendiamina',10,'29','2921','292151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215133','N-(1, 3-dimetilbutil)-n''-fenil-p-fenilenodiamina','N-(1, 3-dimethylbutyl)-n''-phenyl-p-phenylenediamine','N-(1, 3-dimetilbutil)-n''-fenil-p-fenilendiamina',10,'29','2921','292151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215134','N-(1, 4-dimetilpentil)-n''-fenil-p-fenilenodiamina','N-(1, 4-dimethylpentyl)-n''-phenyl-p-phenylenediamine','N-(1, 4-dimetilpentil)-n''-fenil-p-fenilendiamina',10,'29','2921','292151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215135','N-fenil-p-fenilenodiamina (4-aminodifenilamina) e sais','N-phenyl-p-phenylenediamine (4-aminodiphen.) and salts','N-fenil-p-fenilendiamina (4-aminodifenilamina) y sales',10,'29','2921','292151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215139','Outros derivados das fenilenodiaminas e seus sais','Other derivatives of phenylenediamine and its salts','Los dem.derivados de las fenilendiaminas y sus sales',10,'29','2921','292151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215190','Outros derivados de diaminotulenos e seus sais','Other derivatives of diaminotoluenes and its salts','Los demás derivados de diaminotoluenos y sus sales',10,'29','2921','292151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215911','3, 3''-diclorobenzidina','3, 3''-dichlorobenzidine','3, 3''-diclorobencidina',10,'29','2921','292159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215919','Benzidina, seus outros derivados e sais','Benzidine, its other derivatives and salts','Bencidina, sus demás derivados y sales',10,'29','2921','292159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215921','4, 4''-diaminodifenilmetano','4, 4''-diaminophenylmethane','4, 4''-diaminodifenilmetano',10,'29','2921','292159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215929','Outros diaminodifenilmetanos','Other diaminophenylmethane','Los demás diaminodifenilmetanos',10,'29','2921','292159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215931','4, 4''-diaminodifenilamina e seus sais','4, 4''-diaminodiphenylamine and its salts','4, 4''-diaminodifenilamina y sus sales',10,'29','2921','292159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215932','Acido 4, 4''-diaminodifenilamino-2-sulfonico e seus sais','4, 4''-diaminodiphenylamino-2-sulphonic acid and salts','Ácido 4, 4''-diaminodifenilamino-2-sulfónico y sus sales',10,'29','2921','292159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215939','Outras diaminodifenilaminas, seus derivados e seus sais','Other diaminodiphenylamine, its derivatives/salts','Las dem.diaminodifenilaminas,  sus derivados y sus sales',10,'29','2921','292159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29215990','Outras poliaminas aromáticas, seus derivados e seus sais','Other aromatic polyamine, its derivatives and its salts','Las dem.poliaminas aromáticas, sus derivados y sus sales',10,'29','2921','292159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221100','Monoetanolamina e seus sais','Monoethanolamine and its salts','Monoetanolamina y sus sales',10,'29','2922','292211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221200','Dietanolamina e seus sais','Diethanolamine and its salts','Dietanolamina y sus sales',10,'29','2922','292212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221310','Trietanolamina','Triethanolamine','Trietanolamina',10,'29','2922','292213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221320','Sais de trietanolamina','Triethanolamine salts','Sales de trietanolamina',10,'29','2922','292213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221400','Dextropropoxifeno (dci) e seus sais','Dextropropoxyphene (inn) and its salts','Dextropropoxifeno (dci) y sus sales',10,'29','2922','292214');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221911','Monoisopropanolamina','Monoisopropanolamine','Monoisopropanolamina',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221912','2, 4-diclorofenoxiacetato de triisopropanolamina','Triisopropanolamine 2, 4-dichlorophenoxyacetate','2, 4-diclorofenoxiacetato de triisopropanolamina',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221913','2, 4-diclorofenoxiacetato de dimetilpropanolamina','Dimethylpropanolamine 2, 4-dichlorophenoxyacetate','2, 4-diclorofenoxiacetato de dimetilpropanolamina',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221919','Propanolaminas, seus outros sais e derivados','Propanolamine, its other salts and derivatives','Propanolaminas, sus demás sales y derivados',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221921','Citrato de orfenadrina','Orphenadrine citrate','Citrato de orfenadrina',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221929','Orfenadrina e seus outros sais','Orphenadrine and its others salts','Orfenadrina y sus demás sales',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221931','Cloridrato de ambroxol','Hydrochloride ambroxol','Clorhidrato de ambroxol',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221939','Ambroxol e seus outros sais','Ambroxol and its salts','Ambroxol y sus demás sales',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221941','Cloridrato de clobutinol','Hydrochloride clobutinol','Clorhidrato de clobutinol',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221949','Clobutinol e seus outros sais','Clobutinol and its salts','Clobutinol y sus demás sales',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221951','N, n-dimetil-2-aminoetanol e seus sais protonados','N, n-dimethyl-2-aminoethanol and its protonated salts','N, n-dimetil-2-aminoetanol y sus sales protonados',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221952','N, n-dietil-2-aminoetanol e seus sais protonados','N, n-diethyl-2-aminoethanol and its protonated salts','N, n-dietil-2-aminoetanol y sus sales protonados',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221959','Outros n, n-dialquil-2-aminoetanol, seus sais protonados','Oth.n, n-dialkyl 2-aminoethanol and its protonated salts','Los dem.n, n-dialquil-2-aminoetanol, sus sales protonados',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221961','Metildietanolamina e seus sais protonados','Methyldiethanolamine and its protonated salts','Metildietanolamina y sus sales protonados',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221962','Etildietanolamina e seus sais protonados','Ethyldiethanolamine and its protonated salts','Etildietanolamina y sus sales protonados',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221969','Outros n-alquil-dietanolamina e seus sais protonados','Other n-alkyl-diethanolamine and its protonated salts','Los dem.n-alquil-dietanolamina y sus sales protonados',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221991','1-p-nitrofenil-2-amino-1, 3-propanodiol','1-p-nitrophenyl-2-amino-1, 3-propanodiol','1-p-nitrofenil-2-amino-1, 3-propanodiol',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221992','Fumaratos de benciclano','Bencyclanefumarate','Fumaratos de benciclano',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221993','Clembuterol ("clenbuterol") e seu cloridrato','Clenbuterol and its hydrochloride','Clembuterol ("clenbuterol") y su clorhidrato',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221994','Mirtecaina','Myrtecaine','Mirtecaína',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221995','Tamoxifen e seu citrato','Tamoxifen and its citrate','Tamoxifeno y su citrato',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221996','Dextropropoxifeno e seus sais protonados','Dextropropoxyphene and its protonated salts','Dextropropoxifeno y sus sales protonados',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29221999','Outros aminoalcoóis, seus éteres, ésteres e sais','Other aminoalcohol, its ethers, esters and salts','Los dem.aminoalcoholes, sus éteres, ésteres y sales',10,'29','2922','292219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29222100','Acido aminonaftolsulfonico e seus sais','Aminonaphtholsulphonic acids and their salts','Ácido aminonaftolsulfonico y sus sales',10,'29','2922','292221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29222210','Dianisidinas e seus sais','Dianisidines and their salts','Dianisidinas y sus sales',10,'29','2922','292222');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29222290','Anisidinas, fenetidinas e seus sais','Anisidines, phenetidines and their salts','Anisidinas, fenetidinas y sus sales',10,'29','2922','292222');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29222911','P-aminofenol','P-aminophenol','P-aminofenol',10,'29','2922','292229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29222919','O-aminofenóis, m-aminofenóis e seus sais','O-aminophenol, m-aminophenol and their salts','O-aminofenoles, m-aminofenoles y sus sales',10,'29','2922','292229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29222920','Nitroanisidinas e seus sais','Nitroanisidines and their salts','Nitroanisidinas y sus sales',10,'29','2922','292229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29222990','Outs.aminonaftois, aminofenóis, seus éteres, ésteres, sais','Other aminonaftol, aminophenol their ethers, esters, salts','Los dem.aminonaftoles, aminofen.sus éteres, ésteres, sales',10,'29','2922','292229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223010','Aminoantraquinonas e seus sais','Aminoantraquinones and its salts','Aminoantraquinonas y sus sales',10,'29','2922','292230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223021','Cloridrato de ketamina','Ketamine chloridrate','Clorhidrato de ketamina',10,'29','2922','292230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223029','Ketamina e seus outros sais','Ketamine and other salts','Ketamina y sus demás sales',10,'29','2922','292230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223030','Dietilpropiona ("amfepramone")','Amfepramone','Dietilpropión ("amfepramone")',10,'29','2922','292230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223031','Dietilpropiona ("amfepramone")','Amfepramone','Dietilpropión ("amfepramone")',10,'29','2922','292230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223032','Metadona','Methadone','Metadona',10,'29','2922','292230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223033','Normetadona','Normethadone','Normetadona',10,'29','2922','292230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223039','Sais de dietilpropiona, metadona ou normetadona','Amfepramone, methadone or normethadone salts','Sales de dietilpropión, metadona o normetadona',10,'29','2922','292230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223090','Outs.aminoaldeídos, aminocetonas, aminoquinonas, seus sais','Oth.amino-aldehydes, amino-ketones, amino-quinones, salts','Los dem.aminoaldehidos, aminocetonas, aminoquin.sus sales',10,'29','2922','292230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223111','Anfepramona','Amfepramone','Anfepramona',10,'29','2922','292231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223112','Sais de anfepramona','Amfepramone salts','Sales de anfepramona',10,'29','2922','292231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223120','Metadona e seus sais','Methadone and its salts','Metadona y sus sales',10,'29','2922','292231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223130','Normetadona e seus sais','Normethadone and its salts','Normetadona y sus sales',10,'29','2922','292231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223910','Aminoantraquinonas e seus sais','Aminoanthraquinones and their salts','Aminoantraquinonas y sus sales',10,'29','2922','292239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223921','Cloridrato de ketamina','Ketamine hydrochloride','Clorhidrato de ketamina',10,'29','2922','292239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223929','Ketamina e outros sais de ketamina','Ketamine and other salts thereof','Ketamina y demás sales de ketamina',10,'29','2922','292239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29223990','Outros aminoaldeídos, aminocetonas, etc.','Other amino-aldehydes, amino-ketones, etc.','Los demás aminoaldehidos, aminocetonas, etc.',10,'29','2922','292239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224110','Lisina','Lysine','Lisina',10,'29','2922','292241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224190','Ésteres e sais, da lisina','Lysine, its esters and salts','Ésteres y sales, de la lisina',10,'29','2922','292241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224210','Ácido glutâmico','Glutamic acid','Ácido glutámico',10,'29','2922','292242');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224220','Sais do ácido glutâmico','Salts of glutamic acid','Sales del ácido glutámico',10,'29','2922','292242');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224300','Ácido antranilico e seus sais','Anthranilic acid and its salts','Ácido antranílico y sus sales',10,'29','2922','292243');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224410','Tilidina','Tilidine','Tilidina',10,'29','2922','292244');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224420','Sais de tilidina','Salts of tilidine','Sales de tilidina',10,'29','2922','292244');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224910','Glicina e seus sais','Glycine and its salts','Glicina y sus sales',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224920','Ácido etilenodiaminotetracético (edta) e seus sais','Ethylenediamine tetraacetic acid (edta) and its salts','Ácido etilendiaminotetracetico (edta) y sus sales',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224931','Ácido iminodiacético','Iminodiacetic acid','Ácido iminodiacético',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224932','Sais do ácido iminodiacético','Salts of iminodiacetic acid','Sales del ácido iminodiacético',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224940','Ácido dietilenotriaminopentacético e seus sais','Diethylenetriamine pentacetic acid and its salts','Ácido dietilentriaminopentacetico y sus sales',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224951','Alfa-fenilglicina','Alpha-phenylglycine','Alfa-fenilglicina',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224952','Cloridrato do cloreto de d(-)alfa-aminobenzenoacetila','D-(-)-a-aminobenzeneacetyl chloride hydrochloride','Clorhidrato del cloruro de d(-)alfa-aminobencenoacetilo',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224959','Outros sais e derivados de alfa-fenilglicina','Other salts and derivatives of alpha-phenylglycine','Los demás sales y derivados de alfa-fenilglicina',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224961','Diclofenaco de sódio','Diclofenac sodium','Diclofenac de sodio',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224962','Diclofenaco de potássio','Diclofenac potassium','Diclofenac de potasio',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224963','Diclofenaco de dietilamônio','Diclofenac diethylamine','Diclofenac de dietilamonio',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224964','Diclofenaco','Diclofenac','Diclofenac',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224969','Outros diclofenacos, seus sais e derivados','Other diclofenac, its salts and its derivatives','Los demás diclofenacos, sus sales y derivados',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224971','Tilidina','Tilidine','Tilidina',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224979','Sais de tilidina','Salts of tilidine','Sales de tilidina',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29224990','Outros aminoácidos, seus ésteres e sais','Other amino acid, its esters and its salts','Los demás aminoácidos, sus ésteres y sales',10,'29','2922','292249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29225011','Cloridrato de fenilefrina','Phenylephrine hydrochloride','Clorhidrato de fenilefrina',10,'29','2922','292250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29225019','Fenilefrina e seus outros sais','Phenylephrine and its others salts','Fenilefrina y sus demás sales',10,'29','2922','292250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29225021','Cloridrato de propafenona','Propaphenone chloride','Clorhidrato de propafenona',10,'29','2922','292250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29225029','Propafenona e seus outros sais','Propaphenone and its others salts','Propafenona y sus demás sales',10,'29','2922','292250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29225031','Levodopa','Levodopa','Levodopa',10,'29','2922','292250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29225032','Metildopa','Metildopa','Metildopa',10,'29','2922','292250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29225039','Outros derivados e sais da tirosina','Other derivatives and salts of tyrosine','Otros derivados y sales de la tirosina',10,'29','2922','292250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29225041','Tartarato de metoprolol','Metoprolol tartrate','Tartrato de metoprolol',10,'29','2922','292250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29225049','Metoprolol e seus outros sais','Metoprolol tartrate and its other salts','Metoprolol y sus sales',10,'29','2922','292250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29225050','Propanolol e seus sais','Propanolol and its salts','Propanolol y sus sales',10,'29','2922','292250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29225091','N(1metoxicarbonil)propen-2il)alfa amino p-etc.(napoh)','Sodium n-[1-(methox.)propen-2-yl]-a-am.-p-hydr.(napoh)','N(1metoxicarbonil)propen-2il) alfa amino p-etc.(napoh)',10,'29','2922','292250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29225099','Outs.aminoalcoóisfenóis, aminoácidosfenóis, etc.func.oxig','Oth.amino-alcohol-phen., amino-acid-phen., etc.oxig.func','Los dem.aminoalcoholesfen.aminoácidosfen.etc.func.oxig',10,'29','2922','292250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29231000','Colina e seus sais','Choline and its salts','Colina y sus sales',10,'29','2923','292310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29232000','Lecitinas e outros fosfoaminolipidios','Lecithins and other phosphoaminolipids','Lecitinas y demás fosfoaminolípidos',10,'29','2923','292320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29239010','Betaina e seus sais','Betaine and its salts','Betaína y sus sales',10,'29','2923','292390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29239020','Derivados da colina','Choline derivatives','Derivados de la colina',10,'29','2923','292390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29239030','Cloreto de 3-cloro-2-hidroxipropiltrimetilamônio','3-chloro-2-hydroxypropyltrimethylammonium chloride','Cloruro de 3-cloro-2-hidroxipropiltrimetilamonio',10,'29','2923','292390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29239040','Halogenetos de alquil-trimetilamônio, c/alquila c6 a c22','Alkyl(c6 to c22) -trimethylammonium halides','Halogenuros de alquil-trimetilamonio, c/alquilo c6 a c22',10,'29','2923','292390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29239050','Halogenetos de dialquil- ou alquil-benzil-dimetilamônio','Dialkyl halides or alkyl - benzyl - dimethylammonium','Halogenuros de dialquil- ou alquil-bencil-dimetilamonio',10,'29','2923','292390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29239060','Halogenetos de pentametil-alquil-propilenodiamônio, etc.','Pentamethylalkyl halog.-alkyil-propylenediammonium, etc','Halogenuros de pentametil-alquil-propilenodiamonio, etc.',10,'29','2923','292390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29239090','Outros sais e hidróxidos de amônio quaternários','Other quaternary ammonium salts and hydroxides','Los demás sales y hidróxidos de amónio cuaternarios',10,'29','2923','292390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241011','2-cloro-n-metilacetoacetamida','2-chloro-n-methylacetoacetamide','2-cloro-n-metilacetoacetamida',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241019','Acetoacetamidas e seus outros derivados e sais','Acetoacetamide and other derivatives and salts','Acetoacetamidas y sus demás derivados y sales',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241021','N-metilformamida','N-methylformamide','N-metilformamida',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241022','N, n-dimetilformamida','N, n-dimethyllformamide','N, n-dimetilformamida',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241029','Outras formamidas e acetamidas','Other formamide and acetoamide','Las demás formamidas y acetamidas',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241031','Acrilamida','Acrylamide','Acrilamida',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241032','Metacrilamidas','Methacrylamides','Metacrilamidas',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241039','Outros derivados das acrilamidas','Other acrylamide derivatives','Los demás derivados de las acrilamidas',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241041','Monocrotofos','Monocrotofos','Monocrotofos',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241042','Dicrotofos','Dicrotofos','Dicrotofós',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241049','Crotonamidas e seus outros derivados','Crotoamides and other derivatives','Crotonamidas y sus demás derivados',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241091','N, n''-dimetiluréia','N, n''-dimethylurea','N, n''-dimetilurea',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241092','Carisoprodol','Carisoprodol','Carisoprodol',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241093','N, n''(diestearoil)etilenodiamina (etilen-bis-estearamida','N, n''-(distearoyl)ethylenediamine (n, n''-ethylenebis(stea','N, n''(diestearoil)etilendiamina (etilen-bis-estearamida)',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241094','Dietanolamidas de acidos graxos de c12 a c18','Diethanolamines of c12 to c18 fatty acids','Dietanolamidas de ácidos grasos de c12 a c18',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241095','Meprobamato','Meprobamate','Meprobamato',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241099','Outras amidas acíclicas, seus derivados e sais','Other acyclic amide, its derivatives','Las dem.amidas acíclicas, sus derivados y sales',10,'29','2924','292410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241100','Meprobamato (dci)','Meprobamate (inn)','Meprobamato (dci)',10,'29','2924','292411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241210','Fluoroacetamida','Fluoroacetamide','Fluoroacetamida',10,'29','2924','292412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241220','Fosfamidona','Phosphamidon','Fosfamidona',10,'29','2924','292412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241230','Monocrotofós','Monocrotophos','Monocrotofos',10,'29','2924','292412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241911','2-cloro-n-metilacetoacetamida','2-chloro-n-methylacetoacetamide','2-cloro-n-metilacetoacetamida',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241919','Acetoacetamida outs.deriv.sais do produto','Acetoacetamide other derivatives product salts','Acetoacetamida y demás deriv.sales del producto',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241921','N-metilformamida','N-methylformamide','N-metilformamida',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241922','N, n-dimetilformamida','N, n-dimethyllformamide','N, n-dimetilformamida',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241923','Fluoroacetamida','Fluoroacetamide','Fluoroacetamida',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241929','Outras formamidas e acetamidas','Other formamide and acetamide','Las demás formamidas y acetamidas',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241931','Acrilamida','Acrylamide','Acrilamida',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241932','Metacrilamidas','Methacrylamides','Metacrilamidas',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241939','Outros derivados da acrilamida','Other derivatives of acrylamide','Los demás derivados de la acrilamida',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241941','Monocrotofos','Monocrotofos','Monocrotofos',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241942','Dicrotofos','Dicrotofos','Dicrotofós',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241949','Crotonamidas e outros derivados deste produto','Crotonamide and its other derivatives','Crotonamidas y demás derivados de este producto',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241991','N, n''-dimetiluréia','N, n''-dimethylurea','N, n''-dimetilurea',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241992','Carisoprodol','Carisoprodol','Carisoprodol',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241993','N, n''-(diestearoil)etilenodiamina (n, n''-etilen','N, n''-(distearoyl)ethylenediamine (n, n''-ethylenebis)','N, n''(diestearoil)etilendiamina (n, n''-etilen-bis-esteam)',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241994','Dietanolamidas de acidos graxos de c12 a c18','Diethanolamines acid of c12 to c18 fatty acids','Dietanolamidas de ácidos grasos de c12 a c18',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29241999','Outs.amidas acíclicas, deriv.e sais deste prod','Other acyclic amides, its derivatives and its salts','Las demás amidas acíclicas,  deriv.y sales de este prod.',10,'29','2924','292419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242111','Hexanitrocarbanilidas','Hexanitrocarbanilides','Hexanitrocarbanilidas',10,'29','2924','292421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242119','Carbanilidas, seus outros derivados e sais','Carbanilides, its derivatives and salts','Carbanilidas,  sus demás derivados y sales',10,'29','2924','292421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242120','Diuron','Diuron','Diuron',10,'29','2924','292421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242190','Outras ureinas, seus derivados e sais','Other ureines, its derivatives and salts','Las demás ureínas,  sus derivados y sales',10,'29','2924','292421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242200','Acido 2-acetamidobenzoico','2-acetamidobenzoic acid','Ácido 2-acetamidobenzoico',10,'29','2924','292422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242300','Acido 2-acetamidobenzoico (acido n-acetilan.','2-acetamidobenz.acid(n-acetylanthranilic acid)and salts','Ácido 2-acetamidobenzoico (ácido n-acetilantranílico)',10,'29','2924','292423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242400','Etinamato (dci)','Ethinamate (inn)','Etinamato (dci)',10,'29','2924','292424');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242911','Acetanilida','Acetanilide','Acetanilida',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242912','4-aminoacetanilida','4-aminoacetanilide','4-aminoacetanilida',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242913','Acetaminofen (paracetamol)','Acetaminophen (paracetamol)','Acetaminofen (paracetamol)',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242914','Lidocaína e seu cloridrato','Lidocaine and its hydrochloride','Lidocaina y su clorhidrato',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242915','2, 5-dimetoxiacetanilida','2, 5-dimethoxyacetanilide','2, 5-dimetoxiacetoanilida',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242919','Outros derivados da acetanilida e seus sais','Other derivatives of acetanilide and its salts','Los demás derivados de la acetanilida y sus sales',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242920','Anilidas dos acidos hidroxinaftoicos, seus derivs.e sais','Anilides of hydroxynaphthoic acids and its deriv./salts','Anilidas de los ác. hidroxinaftoicos, sus derivs.y sales',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242931','Carbaril','Carbaryl','Carbaril',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242932','Propoxur','Propoxur','Propoxur',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242933','Etinamato ("ethinamate")','Ethinamate ("ethinamate")','Etinamato ("ethinamate")',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242939','Outros carbamatos','Other carbamates','Los demás carbamatos',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242941','Teclozam','Teclozan','Teclozán',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242942','Alaclor','Alachlor','Alaclor',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242943','Atenolol, metolaclor','Atenolol, metolachlor','Atenolol, metolaclor',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242944','Ácido ioxáglico','Oxaglic acid','Ácido ioxáglico',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242945','Iodamida','Iodamide','Iodamida',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242946','Cloreto do ácido p-acetamidobenzenossulfônico','P-acetamidobenzenesulphonic acid chloride','Cloruro del ácido p-acetamidobencenosulfónico',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242947','Ácido ioxitalâmico','Ioxitalamic acid','Ácido ioxitalâmico',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242949','Outras acetamidas e seus derivados','Other acetamide and its derivatives','Las demás acetamidas y sus derivados',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242951','Bromoprida','Bromopride','Bromopride',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242952','Metoclopramida e seu cloridrato','Metoclopramide and its hydrochloride','Metoclopramida y su clorhidrato',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242959','Outras metoxibenzamidas, seus derivados e sais','Other metoxybenzamides its derivatives and its salts','Las demás metoxibenzamidas, sus derivados y sales',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242961','Propanil','Propanil','Propanil',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242962','Flutamida','Flutamide','Flutamida',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242963','Prilocaína e seu cloridrato','Prilocaine and its hydrochloride','Prilocaína y su clorhidrato',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242964','Iobitridol','Iobitridol','Iobitridol',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242969','Outras propanamidas, seus derivados e sais','Other propanamides its derivatives and its salts','Las demás propanamidas,  sus derivados y sales',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242991','Aspartame','Aspartam','Aspartamo',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242992','Diflubenzuron','Diflubenzuron','Diflubenzurón',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242993','Metalaxil','Metalaxyl','Metalaxil',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242994','Triflumuron','Triflumuron','Triflumuron',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242995','Buclosamida','Buclosamide','Buclosamida',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242996','Benzoato de denatonio','Denatonium benzoate','Benzoato de denatonio',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29242999','Outras amidas ciclicas, seus derivados e sais','Other cyclic amide, its derivatives and its salts','Las demás amidas cíclicas, sus derivados y sales',10,'29','2924','292429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29251100','Sacarina e seus sais','Saccharin and its salts','Sacarina y sus sales',10,'29','2925','292511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29251200','Glutetimida (dci)','Glutethimide (inn)','Glutetimida (dci)',10,'29','2925','292512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29251910','Talidomida','Thalidomide','Talidomida',10,'29','2925','292519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29251920','Glutetimida','Glutetimide','Glutetimida',10,'29','2925','292519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29251990','Outras imidas, seus derivados e sais','Other imide, its derivatives and its salts','Las demás imidas,  sus derivados y sales',10,'29','2925','292519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252011','Aspartato de l-arginina','L-arginine aspartate','Aspartato de l-arginina',10,'29','2925','292520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252019','Arginina e seus outros sais','L-arginine and its salts','Arginina y sus demás sales',10,'29','2925','292520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252021','Guanidina','Guanidine','Guanidina',10,'29','2925','292520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252022','N, n''-difenilguanidina','N, n''-diphenylguanidine','N, n''-difenilguanidina',10,'29','2925','292520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252023','Clorexidina e seus sais','Chlorhexidine and its salts','Clorhexidina y sus sales',10,'29','2925','292520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252029','Outros derivados da guanidina e seus sais','Other derivatives of guanidine and its salts','Los demás derivados de la guanidina y sus sales',10,'29','2925','292520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252030','Amitraz','Amitraz','Amitraz',10,'29','2925','292520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252040','Isetionato de pentamidina','Pentamidine isethionate','Isetionato de pentamidina',10,'29','2925','292520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252050','N-(3, 7-dimetil-7-hidroxioctilideno)antranilato metila','Methyl n-(3, 7-dimethyl-7-hydroxyoctylidene)anthranilate','N-(3, 7-dimetil-7-hidroxioctiliden)antranilato metilo',10,'29','2925','292520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252060','Clordimeforme','Chlordimeform','Clordimeformo',10,'29','2925','292520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252090','Outras iminas, seus derivados e sais','Other imines, their derivatives and their salts','Las demás iminas,  sus derivados y sales',10,'29','2925','292520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252100','Clordimeforme','Chlordimeform','Clordimeformo',10,'29','2925','292521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252911','Aspartato de l-arginina','L-arginine aspartate','Aspartato de l-arginina',10,'29','2925','292529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252919','Outras argininas e sais','Other l-arginine and its salts','Otras argininas y sus demás sales',10,'29','2925','292529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252921','Guanidina','Guanidine','Guanidina',10,'29','2925','292529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252922','N, n''-difenilguanidina','N, n''-diphenylguanidine','N, n''-difenilguanidina',10,'29','2925','292529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252923','Clorexidina e seus sais','Chlorhexidine and its salts','Clorhexidina y sus sales',10,'29','2925','292529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252929','Outros sais e derivados da guanidina','Other guanidine and its salts','Otras guanidinas y sus sales',10,'29','2925','292529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252930','Amitraz','Amitraz','Amitraz',10,'29','2925','292529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252940','Isetionato de pentamidina','Pentamidine isethionate','Isetionato de pentamidina',10,'29','2925','292529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252950','N-(3, 7-dimetil-7-hidroxioctilideno)antranil.metil.','Methyl n-(3, 7-dimethyl-7-hydroxyoctylidene)anthranilate','N-(3, 7-dimetil-7-hidroxioctiliden)antranilato metilo',10,'29','2925','292529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29252990','Outros iminas,  seus derivados e sais','Other imines, their derivatives and their salts','Las demás iminas,  sus derivados y sales',10,'29','2925','292529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29261000','Acrilonitrila','Acrylonitrile','Acrilonitrilo',10,'29','2926','292610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29262000','1-cianoguanidina (diciandiamida)','1-cyanoguanidine (dicyandiamide)','1-cianoguanidina (diciandiamida)',10,'29','2926','292620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29263011','Fenproporex','Fenproporex','Fenproporex',10,'29','2926','292630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29263012','Sais do fenproporex','Salts of fenproporex','Sales del fenproporex',10,'29','2926','292630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29263020','Intermediario da metadona','Methadone intermediate','Intermediario de la metadona',10,'29','2926','292630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269011','Verapamil','Verampil','Verapamilo',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269012','Cloridrato de verapamil','Verampil hydrochloride','Clorhidrato de verapamilo',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269019','Outros sais de verapamil','Other salts of verampil','Los demás sales de verapamilo',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269021','Álcool alfa-ciano-3-fenoxibenzilico','Alpha-cyano-3-phenoxybenzyl alcohol','Alcohol alfa-ciano-3-fenoxibencílico',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269022','Ciflutrin','Cyfluthrin','Ciflutrin',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269023','Cipermetrina','Cypermethrin','Cipermetrina',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269024','Deltametrina','Deltamethrin','Deltametrina',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269025','Fenvalerato','Fenvalerate','Fenvalerato',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269026','Cialotrin ("cyhalothrin")','Cyhalothrin ("cyhalothrin")','Cialotrin ("cyhalothrin")',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269029','Outs.derivs.ésteres do álcool alfa-ciano-3-fenoxibenzil','Oth.esters derivativ.alpha-cyano-3-phenoxybenzyl alcohol','Los dem.der.ésteres del alcoh.alfa-ciano-3fenoxibencil',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269030','Sais de intermediario da metadona (dci)','Salts of methadone intermediate','Sales de intermediario de la metadona (dci)',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269031','Femproporex ("fenproprorex")','Fenproprorex','Femproporex ("fenproporex")',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269032','4-ciano-2-dimetilamino-4, 4-difenilbutano (int.metadona)','4-cyano-2-dimethylamine-4, 4-diphenylbutane(methad.int.)','4-ciano-2-dimetilamino-4, 4-difenilbutano (int.metadona)',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269039','Sais do femproporex ou 4-ciano-2-dimetilamino-4, 4-etc.','Salts of femproporex /4-cyano-2-dimethylamine-4, 4-etc.','Sales del femproporex o 4-ciano-2-dimetilamino-4, 4-etc.',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269091','Adiponitrila (1, 4-dicianobutano)','Adiponitrile (1, 4-dicyanobutane)','Adiponitrilo (1, 4-dicianobutano)',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269092','Cianidrina de acetona (acetona cianidrina)','Acetone cyanohydrin','Cianhidrina de acetona (acetona cianhidrina)',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269093','Closantel','Closantel','Closantel',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269094','Femproporex ("fenproporex")','Fenproporex','Femproporex ("fenproporex")',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269095','Clorotalonil','Chlorothalonil','Clorotalonil',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269096','Cianoacrilatos de etila','Ethyl cyanoacrylates','Cianoacrilatos de etilo',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29269099','Outros compostos de função nitrila','Other nitrile-function compounds','Los demás compuestos con función nitrilo',10,'29','2926','292690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29270010','Compostos diazóicos','Diazo compounds','Compuestos diazoicos',10,'29','2927','292700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29270021','Azodicarbonamida','Azodicarbonamide','Azodicarbonamida',10,'29','2927','292700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29270029','Outros compostos azóicos','Other azoxy-compounds','Los demás compuestos azoicos',10,'29','2927','292700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29270030','Compostos azoxicos','Azoxy-compounds','Compuestos azoxi',10,'29','2927','292700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29280011','Metiletilacetoxima','Methylethylacetoxime','Metiletilacetoxima',10,'29','2928','292800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29280019','Outras acetoximas, seus derivados e seus sais','Other acetoxime, its derivatives and its salts','Las demás acetoximas,  sus derivados y sus sales',10,'29','2928','292800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29280020','Carbidopa','Carbidopa','Carbidopa',10,'29','2928','292800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29280030','2-hidrazinoetanol','2-hydrazinoethanol','2-hidrazinoetanol',10,'29','2928','292800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29280041','Fenilidrazina','Phenylhydrazine','Fenilhidrazina',10,'29','2928','292800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29280042','Derivados da fenilidrazina','Phenylhydrazine derivatives','Derivados de la fenilhidrazina',10,'29','2928','292800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29280090','Outros derivados orgânicos da hidrazina e hidroxilamina','Oth.organic derivat.of hydrazine or of hydroxylamine','Los dem.derivados orgánic.de hidrazina y hidroxilamina',10,'29','2928','292800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29291010','Diisocianato de difenilmetano','Diphenylmethane diisocyanate','Diisocianato de difenilmetano',10,'29','2929','292910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29291021','Mistura de isômeros de diisocianatos de tolueno','Isomer mixture toluene diisocyanate','Mezcla de isómeros de diisocianatos de tolueno',10,'29','2929','292910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29291029','Outros diisocianatos de tolueno','Other toluene diisocyanate','Los demás diisocianatos de tolueno',10,'29','2929','292910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29291030','Isocianato de 3, 4-diclorofenila','3, 4-dichlorofenyl isocyanate','Isocianato de 3, 4-diclorofenilo',10,'29','2929','292910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29291090','Outros isocianatos','Other isocyanate','Los demás isocianatos',10,'29','2929','292910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29299011','Acido ciclamico de sódio e seus sais','Cyclamic acid of sodium and its salts','Ácido ciclámico de sodio y sus sales',10,'29','2929','292990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29299012','Acido ciclamico de cálcio e seus sais','Cyclamic acid of calcium and its salts','Ácido ciclámico de sodio y sus sales',10,'29','2929','292990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29299019','Outros acidos ciclamicos e seus sais','Other cyclamic acid of calcium and its salts','Otros ácidos ciclámicos y sus sales',10,'29','2929','292990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29299021','Dialogenetos de n, n-dialquil-fósforoamidatos, etc.','N, n-dialkyl(c1 a c3)phosphoroamidate dihalides, etc.','Dihalogenuros de n, n-dialquil-fosforoamidatos, etc.',10,'29','2929','292990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29299022','N, n-dialquil-fósforoamidatos de dialquila, etc.','N, n-dialkyl(c1 to c3)phosphoroamidates, etc.','N, n-dialquil-fosforoamidatos de dialquilo, etc.',10,'29','2929','292990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29299029','Outros n, n-dialquil-fósforoamidatos e seus derivados','Ot.n, n-dialkyl(c1 to c3)phosphoroamidates, their deriv.','Los demás n, n-dialquil-fosforoamidatos y sus derivados',10,'29','2929','292990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29299090','Outros compostos de funcoes nitrogenadas','Other compounds nitrogen fuction','Los demás compuestos con funciones nitrogenadas',10,'29','2929','292990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29301000','Ditiocarbonatos (xantatos e xantogenatos)','Dithiocarbonates (xanthates)','Ditiocarbonatos (xantatos y xantogenatos)',10,'29','2930','293010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29302011','Eptc (tiocarbamato)','Eptc (thiocarbamate)','Eptc (tiocarbamato)',10,'29','2930','293020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29302012','Cartap','Cartap','Cartap',10,'29','2930','293020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29302013','Tiobencarb (dietiltiocarbamato de s-4-clorobenzila)','Hiobencarb (s-4-chlorobenzyl diethylthiocarbamate)','Tiobencarb (dietiltiocarbamato de s-4-clorobencilo)',10,'29','2930','293020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29302019','Outros tiocarbamatos','Other thiocarbamates','Los demás tiocarbamatos',10,'29','2930','293020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29302021','Ziram e dimetilditiocarbamato de sódio','Ziram and sodium dimethyldithiocarbamate','Ziram y dimetilditiocarbamato de sodio',10,'29','2930','293020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29302022','Dietilditiocarbamato de zinco','Zinc diethyldithiocarbamate','Dietilditiocarbamato de cinc',10,'29','2930','293020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29302023','Dibutilditiocarbamato de zinco','Zinc dibutyldithiocarbamate','Dibutilditiocarbamato de cinc',10,'29','2930','293020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29302024','Metam sódio','Metham sodium','Metam sodio',10,'29','2930','293020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29302025','Dimetilditiocarbamato de fenilmercúrio','Phenylmercuric dimethyldithiocarbamate','Dimetilditiocarbamato de fenilmercurio',10,'29','2930','293020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29302029','Outros ditiocarbamatos','Other dithiocarbamates','Los demás ditiocarbamatos',10,'29','2930','293020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29303011','Monossulfeto de tetrametiltiourama','Monosulphides of tetramethylthiuram','Monosulfuro de tetrametiltiourama',10,'29','2930','293030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29303012','Sulfiram','Sulfiram','Sulfiram',10,'29','2930','293030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29303019','Outros monossulfetos de tiourama','Other monosulphides of thiuram','Los demás monosulfuros de tiourama',10,'29','2930','293030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29303021','Thiram','Thiram','Thiram',10,'29','2930','293030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29303022','Dissulfiram','Disulfiram','Disulfiram',10,'29','2930','293030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29303029','Outros dissulfetos de tiourama','Other disulphides of thiuram','Los demás disulfuros de tiourama',10,'29','2930','293030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29303090','Tetrassulfetos de tiourama','Tetrasulphides of thiuram','Tetrasulfuros de tiourama',10,'29','2930','293030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29304010','Dl-metionina, teor de cinzas sulfatadas>0.1% em peso','Dl-methionine, contain.>0.1%b/weight of sulphur ash','Dl-metionina, c/cont.de cenizas sulfatadas>0.1% en peso',10,'29','2930','293040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29304090','Outras metioninas','Other methionine','Las demás metioninas',10,'29','2930','293040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29305010','Captafol','Captafol','Captafol',10,'29','2930','293050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29305020','Metamidofós','Methamidophos','Metamidofós',10,'29','2930','293050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309011','Ácido tioglicólico e seus sais','Thioglycolic acid and its salts','Ácido tioglicólico y sus sales',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309012','Cisteína','Cysteina','Cisteina',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309013','N, n-dialquil-2-aminoetanotiol e seus sais protonados','N, n-dialkyl-2-aminoethanothiols, their protonat.salts','N, n-dialquil-2-aminoetanotiol y sus sales protonados',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309014','Timerosal','Thimerosal','Timerosal',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309019','Outros tióis, seus derivados e sais','Other thiols, its derivates and salts','Los demás tioles,  sus derivados y sales',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309021','Tiouréia','Thiourea','Tiourea',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309022','Tiofanato-metila','Thiophanate-methyl','Tiofanato-metilo',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309023','4-metil-3-tiosemicarbazida','4-methyl-3-thiosemicarbazide','4-metil-3-tiosemicarbazida',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309029','Outras tioamidas, seus derivados e sais','Other thioamides, its derivatives and salts','Las demás tioamidas,  sus derivados y sales',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309031','2-(etiltio)etanol com uma concentração >= 98%','2-(ethylthio)ethanol of a concentration of >=98%','2-(etiltio) etanol con una concentración>=98%',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309032','3-(metiltio)propanal e aldicarb','3-(methylthio)propanol and aldicarb','3-(metiltio) propanal y aldicarb.',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309033','Clorotioformiato de s-etila','S-ethyl chlorothioformate','Clorotioformiato de s-etilo',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309034','Ácido 2-hidroxi-4-(metiltio)butanoico e seu sal calcico','2-hydroxy-4-(methylthio)butyric acid and its calc.salt','Ácido 2-hidroxi-4-(metiltio) butanoico y su sal cálcico',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309035','Metomil','Methomyl','Metomil',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309036','Carbocisteina','Carbocysteine','Carbocisteina',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309037','4-sulfatoetilsulfonil-2, 5-dimetoxianilina, etc.','4-sulphate-ethyl-sulphonyl-2, 5-dimetoxyaniline, etc','4-sulfatoetilsulfonil-2, 5-dimetoxianilina,  etc',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309038','Tiodiglicol (dci) (sulfeto de bis(2-hidroxietila))','Thiodiglycol (inn) (bis(2-hydroxyethyl) sulphide)','Tiodiglicol (sulfuro de bis (2-hidroxietilo))',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309039','Outros tioéteres, tioésteres, seus derivados e sais','Oth.thioethers, thioesters and its derivatives/salts','Los demás tioéteres,  tioésteres,  sus derivados y sales',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309040','Fosforotioatos e seus derivados, sais destes produtos','Phorothioate, its derivatives and its salts','Fósforotioatos y sus derivados, sales de estos productos',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309041','0, 0-dietil-fósforotioato de s-(2-(dietilamino)etila, etc','S-[2-(diethylamino)ethyl] o, o-diethylphosphoroth., etc','0, 0-dietil-fosforotioato de s-(2-(dietilamino)etilo, etc',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309042','Fosforotioato de o, o-dimetila e de s-[2-(1-m','O, o-dimethyl s-[2-(1-methylcarbamoylethylthio)ethyl ph.','Fosforotioato de 0, 0-dimetilo y de s-[2-(1-m.',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309043','Fósforotioato de o-(4-bromo-2-clorofenila), o-etila, etc.','Profen.(o-(4-bromo-2-chlorophenyl)o-ethyl s-propyl phos','Fosforotioato de o-(4-bromo-2-clorofenilo), o-etilo, etc.',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309049','Outs.fósforotioatos e seus derivs.e sais destes prods.','Other phosphorothioate, its derivatives and its salts','Los dem.fosforot.y sus derivs.y sales de estos prods.',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309051','Forato','Phorato','Forato',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309052','Dissulfoton','Disulfoton','Disulfotón',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309053','Etion','Ethion','Etion',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309054','Dimetoato','Dimethoate','Dimetoato',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309055','Vamidotion (fosforoditioato de 0, 0-dimetila s-(etc.)','Vamidothion(phosphorodithioate of o, o-dimethyl s-(etc.)','Vamidotión (fósforoditioato de 0, 0-dimetilo s-(etc.)',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309056','Profenofos','Prophenofos','Profenofós',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309057','Tiometon','Thiometon','Tiometón',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309059','Outros fosforoditioatos, seus derivados e sais','Other phosphorodithioate, its derivatives and salts','Los demás fósforoditioatos,  sus derivados y sales',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309061','Acefato','Acephate','Acefato',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309062','Metamidofos','Methamidophos','Metamidofós',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309069','Outros fosforoamidotioatos, seus derivados e sais','Other phosphorodamidethioate, its derivatives and salts','Los demás fosforoamidotioatos,  sus derivados y sales',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309071','Tiaprida','Thiapride','Tiaprida',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309072','Bicalutamida','Bicalutamide','Bicalutamida',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309079','Outras sulfonas','Other sulphones','Las demás sulfonas',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309081','Sulfeto de 2-cloroetila e de clorometila','2-chloroethyl and chloromethyl sulphide','Sulfuro de 2-cloroetilo y de clorometilo',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309082','Sulfeto de bis(2-cloroetila)','Bis(2-chloroethyl) sulphide','Sulfuro de bis (2-cloroetilo)',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309083','Bis(2-cloroetiltio)metano','Bis(2-chloroethylthio)methane','Bis (2-cloroetiltio) metano',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309084','1, 2-bis(2-cloroetiltio)etano','1, 2-bis(2-chloroethylthio)ethane','1, 2-bis (2-cloroetiltio) etano',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309085','1, 3-bis(2-cloroetiltio)-n-propano','1, 3-bis(2-chloroethylthio)-n-propane','1, 3-bis(2-cloroetiltio)-n-propano',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309086','1, 4-bis(2-cloroetiltio)-n-butano','1, 4-bis(2-chloroethylthio)-n-butane','1, 4-bis(2-cloroetiltio)-n-butano',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309087','1, 5-bis(2-cloroetiltio)-n-pentano','1, 5-bis(2-chloroethylthio)-n-pentane','1, 5-bis(2-cloroetiltio)-n-pentano',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309088','Óxido de bis (2-cloroetiltiometila)','Bis (2-chloroethylthiomethyl) oxide','Óxido de bis (2-cloroetiltiometilo)',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309089','Óxido de bis (2-cloroetiltioetila)','Bis (2-chloroethylthiomethyl) oxide','Óxido de bis (2-cloroetiltioetilo)',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309091','Captan','Captan','Captán',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309092','Captafol','Captafol','Captafol',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309093','Metileno-bis-tiocianato','Methylenebis(thiocyanate)','Metilen-bis-tiocianato',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309094','Dimetiltiofosforamida','Dimethylthiophosphoramide','Dimetiltiofosforoamida',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309095','Etilditiofosfonato de o-etila e de s-fenila (fonofos)','O-ethyl s-phenyl ethylphosphonothiolothionate (fonofos)','Etilditiofosfonato de o-etilo y de s-fenilo (fonofos)',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309096','Hidrogênio alquil (de c1 a c3) fosfonotioatos de ...','Alkyl hydrogen (c1 to c3) phosphonothiolothionate of','Hidrógeno alquil (de c1 a c3) fosfonotioatos de ...',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309097','Outs.compostos c/1 atomo fósforo lig.a 1 grupo alquila','Oth.comp.with 1 atom phosphorus linked one alkyle group','Los dem.compuest.c/1 átomo fósforo unidoa 1grup.alquilo',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309098','Ditiocarbonatos (xantatos e xantogenatos)','Dithiocarbonates (xanthates)','Ditiocarbonatos (xantatos y xantogenatos)',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29309099','Outros tiocompostos orgânicos','Other organic thiocompounds','Los demás tiocompuestos orgánicos',10,'29','2930','293090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310010','Compostos organo-mercuriais','Organo-mercury compounds','Compuestos órgano-mercúricos',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310011','Timerosal','Timerosal','Timerosal',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310019','Outros compostos organo-mercuriais','Other organo-mercury compounds','Los demás compuestos órgano-mercúricos',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310021','Bis (trimetilsilil) uréia','Bis (trimethylsilyl) urea','Bis (trimetilsilil) urea',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310029','Outros compostos organo-silícicos','Other organo-silicon compounds','Los demás compuestos órgano-silícicos',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310031','Etefon, difenilfosfonato (4, 4''-bis[(dimetoxifosfinil...','Ethephon, (4, 4''-bis[(dimethoxyphosphonyl)methyl]diphenyl','Etefón, difenilfosfonato (4, 4''-bis[(dimetoxifosfinil...',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310032','Glifosato e seu sal de monoisopropilamina','Glyphosate and its mono(isopropylamine) salt','Glifosato y su sal de monoisopropilamina',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310033','Etidronato dissódico','Etidronate disodium','Etidronato disódico',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310034','Triclorfon','Trichlorfon','Triclorfon',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310035','Glufozinato de amônio','Glufosinate-ammonium','Glufosinato de amonio',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310036','Hidrogenofosfonato de bis(2-etilexilo)','Bis(2-ethylhexyl) hydrogenphosphonate','Hidrógenofosfonato de bis(2-etilhexilo)',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310037','Ácido fosfonometiliminodiacético e ac.trimetilfosfônico','Phosphonomethyliminodiacetic acid and trimethylph.acid','Ácido fosfonometiliminodiacético y ác.trimetilfosfonico',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310038','Ácido clodrônico e seu sal dissódico, fotemustina','Clodronic acid and its disodium salt, fotemustine','Ácido clodrónico y su sal disódico, fotemustina',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310039','Outros compostos organo-fosforosos','Other organo-phosphorus compounds','Los demás compuestos órgano-fosforados',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310041','Acetato de trifenilestanho','Triphenyltin acetate','Acetato de trifenilestaño',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310042','Tetraoctilestanho','Tetraoctyltin','Tetraoctilestaño',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310043','Ciexatim','Cyhexatin','Cihexatin',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310044','Hidróxido de trifenilestanho','Triphenyltin hydroxide','Hidróxido de trifenilestaño',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310045','Óxido de fembutatin (óxido de "fenbutatin")','Fenbutatin oxide','Óxido de fembutatín (óxido de "fenbutatin")',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310046','Sais de dimetil-estanho, etc.do ácido carboxil/tioglicol','Dimethyltin salt, etc.carboxylic/thioglycolic acids','Sales de dimetilestaño, etc. del ác. carboxil/tioglicol',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310049','Outros compostos organo-metálicos do estanho','Other organo-tin metalic compounds','Los demás compuestos órgano-metálicos del estaño',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310051','Ácido metilarsínico e seus sais','Methylarsinic acid and its salts','Ácido metilarsínico y sus sales',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310052','2-clorovinil-dicloroarsina','2-chlorovinyldichloroarsine','2-clorovinil-dicloroarsina',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310053','Bis(2-clorovinil)cloroarsina','Bis(2-chlorovinyl)chloroarsine','Bis(2-clorovinil)cloroarsina',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310054','Tris(2-clorovinil)arsina','Tris(2-chlorovinyl)arsine','Tris(2-clorovinil)arsina',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310059','Outros compostos organo-arseniais','Other organo-arseniais compounds','Los demás compuestos órgano-arseniados',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310061','Tricloreto de etilalumínio (sesquicloreto etilaluminico','Ethyl aluminium trichloride','Tricloruro de etilaluminio(sesquicloruro etilalumínico)',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310062','Cloreto de dietilalumínio','Diethyl aluminium chloride','Cloruro de dietilaluminio',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310069','Outros compostos organo-alumínicos','Other organo-aluminium compounds','Los demás compuestos órgano-alumínicos',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310071','Alquil (de c1 a c3) fósforo-fluoridato de o-alquila, etc','Alkyl(c1 to c3) phosphonofluoridates of o-alky, etc.','Alquil (de c1 a c3) fosfonofluoridatos de o-alquilo, etc',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310072','Metilfosfonocloridato de o-isopropila','O-isopropyl methylphosphonochloridate','Metilfosfonocloridato de o-isopropilo',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310073','Metilfosfonocloridato de o-pinacolila','O-pinacolyl methylphosphonochloridate','Metilfosfonocloridato de o-pinacolilo',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310074','Difluoreto de alquilfosfonila, c/grup.alquila de c1 a c3','Alkyl group(c1 to c3)phosphonyl difluorides','Difluoruro de alquilfosfonilo, c/grup.alquilo de c1 a c3',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310075','Hidrogênio alquil (de c1 a c3) fosfonitos de, etc.','Alkyl hidrogen (c1 to c3) phosphonits of, etc.','Hidrógeno alquil (de c1 a c3) fosfonitos de, etc.',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310076','Outs.compostos c/1 atomo fósforo lig.1 grup.alquila, etc','Oth.comp.with 1 atom phosph.linked 1 alkyle group, etc','Los dem.comp.c/1 átomo fósforo unidoa1grup.alquilo, etc',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310077','N, n-dialquil fósforoamidocianidatos de o-alquila, etc.','N, n-dialkyl(c1 to c3)phosphoroamidocyan.of o-alkyle, etc','N, n-dialquil fosforoamidocianidatos de o-alquilo,  etc.',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310079','Outros compostos organofosforados','Other organo-phosphorus compounds','Los demás compuestos órgano-fosforados',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310081','Acetato de fenilmercúrio,  de amônio fenilmercúrio, etc.','Phenylmercury acetate of phenylmercury amonium, etc','Acetato de fenilmercurio,  de amonio fenilmercurio, etc.',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29310090','Outros compostos organo-inorgânicos','Other organo-inorganic compounds','Los dem.compuestos órgano-inorgánicos',10,'29','2931','293100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29311000','Chumbo tetrametila e chumbo tetraetileno','Chumbo tetrametila e chumbo tetraetileno','Chumbo tetrametila e chumbo tetraetileno',10,'29','2931','293110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29312000','Compostos de tributilestanho','Compostos de tributilestanho','Compostos de tributilestanho',10,'29','2931','293120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319021','Bis(trimetilsilil)ureia','Bis (trimethylsilyl) urea','Bis (trimetilsilil) urea',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319029','Outros compostos organossilicicos','Outros compostos organossilicicos','Outros compostos organossilicicos',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319031','Etefon; difenilfosfonato(4,4-bis)','Ethephon; difenylphosphonate (4,4-bis)','Etefón; difenilfosfonato (4,4-bis)',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319032','Glifosato e seu sal de monoisopropilamina','Glyphosate and its salt of monoisopropilamine','Glifosato y su sal de monoisopropilamina',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319033','Etidronato dissodico','Etidronate disodium','Etidronato disódico',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319034','Triclorfon','Trichlorfon','Triclorfón',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319035','Glufosinato de amônio','Glufosinate ammonium','Glufosinato de amonio',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319036','Hidrogenofosfonato de bis(2-etilexilo)','Hidrogenophosphonate bis (2-ethylhexyl)','Hidrogenofosfonato de bis (2-etilhexil)',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319037','Acido fosfonometiliminodiacetico;acid trimetilfosfonico','Acido fosfonometiliminodiacetico;acid trimetilfosfonico','Acido fosfonometiliminodiacetico;acid trimetilfosfonico',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319038','Acido clodronico e seu sal dissodico; fotemustina','Clodronic acid and its disodium salt; fotemustine','Ácido clodrónico y su sal disódica; fotemustina',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319041','Acetato de trifenilestanho','Acetato de trifenilestanho','Acetato de trifenilestanho',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319042','Tetraoctilestanho','Tetraoctilestanho','Tetraoctilestanho',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319043','Ciexatin','Ciexatin','Ciexatin',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319044','Hidroxido de trifenilestanho','Hidroxido de trifenilestanho','Hidroxido de trifenilestanho',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319045','Oxido de fembutatin (oxido de fenbutatin)','Oxido de fembutatin (oxido de fenbutatin)','Oxido de fembutatin (oxido de fenbutatin)',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319046','Sais de dimetil-estanho,etc.do ácido carboxil/tioglicol','Sais de dimetil-estanho,etc.do acido carboxil/tioglicol','Sais de dimetil-estanho,etc.do acido carboxil/tioglicol',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319049','Outros compostos organometalicos do estanho','Other organometallic compounds of tin','Otros compuestos organometálicos del estaño',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319051','Acido metilarsínico e seus sais','Methylarsinic acid and its salts','Ácido metilarsínico y sus sales',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319052','2-clorovinil-dicloroarsina','2-clorovinil-dicloroarsina','2-clorovinil-dicloroarsina',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319053','Bis(2-clorovinil)cloroarsina','Bis(2-clorovinil)cloroarsina','Bis(2-clorovinil)cloroarsina',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319054','Tris(2-clorovinil)arsina','Tris (2-chlorevynil) arsine','Tris (2-clorovinil) arsina',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319059','Outros compostos organo-arseniais','Other organo-arsenic compounds','Los demás compuestos órgano-arseniais',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319061','Tricloreto de etialuminio(sesquicloreto de etialuminio)','Tricloreto de etialuminio(sesquicloreto de etialuminio)','Tricloreto de etialuminio(sesquicloreto de etialuminio)',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319062','Cloreto de dietialumínio','Chloride of diethylaluminium','Cloruro de dietialuminio',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319069','Outros compostos organo-alumínicos','Other organic-aluminic compounds','Los demás compuestos órgano-alumínicos',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319071','Alquil(de c1 a c3)fosfonofluoridatos de o-alquila','Alquil(de c1 a c3)fosfonofluoridatos de o-alquila','Alquil(de c1 a c3)fosfonofluoridatos de o-alquila',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319072','Metilfosfonocloridato de o-isopropila','Metilfosfonocloridato de o-isopropila','Metilfosfonocloridato de o-isopropila',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319073','Metilfosfonocloridato de o-pinacolila','Metilfosfonocloridato de o-pinacolila','Metilfosfonocloridato de o-pinacolila',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319074','Difluoreto de alquilfosfonila,c/grupo de c1 a c3','Difluoreto de alquilfosfonila,c/grupo de c1 a c3','Difluoreto de alquilfosfonila,c/grupo de c1 a c3',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319075','Hidrogenio alquil,fosfonitos e seus esteres,sais pro.','Hidrogenio alquil,fosfonitos e seus esteres,sais pro.','Hidrogenio alquil,fosfonitos e seus esteres,sais pro.',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319076','Out.comp.c/ 1 átomo fósforo ligado a grup.alquila','Out.comp.c/ 1 atomo fosforo  ligado a grup.alquila','Out.comp.c/ 1 atomo fosforo  ligado a grup.alquila',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319077','N,n-dialquil(de c1 a c3)fosforoamidocian. de o-alquila','N,n-dialquil(de c1 a c3)fosforoamidocian. de o-alquila','N,n-dialquil(de c1 a c3)fosforoamidocian. de o-alquila',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319079','Outros compostos organofosforados','Other organophosphored compounds','Otros compuestos organofosforados',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29319090','Outros compostos organo-inorganicos','Other organo-inorganic compounds','Los demás compuestos órgano-inorgánicos',10,'29','2931','293190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29321100','Tetraidrofurano','Tetrahydrofuran','Tetrahidrofurano',10,'29','2932','293211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29321200','2-furaldeído (furfural)','2-furaldehyde (furfuraldehyde)','2-furaldehído (furfural)',10,'29','2932','293212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29321300','Álcool furfurilico e álcool tetraidrofurfurilico','Furfuryl alcohol and tetrahydrofurfuryl alcohol','Alcohol furfurílico y alcohol tetrahidrofurfurílico',10,'29','2932','293213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29321310','Álcool furfurílico','Furfuryl alcohol','Alcohol furfurílico',10,'29','2932','293213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29321320','Álcool tetraidrofurfurílico','Tetrahydrofurfuryl alcohol','Alcohol tetrahidrofurfurílico',10,'29','2932','293213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29321910','Ranitidina e seus sais','Ranitidine and its salts','Ranitidina y sus sales',10,'29','2932','293219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29321920','Nafronil','Nafronyl','Nafronil',10,'29','2932','293219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29321930','Nitrovin','Nitrovin','Nitrovín',10,'29','2932','293219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29321940','Bioresmetrina','Bioresmethrin','Bioresmetrina',10,'29','2932','293219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29321950','Diacetato de 5-nitrofurfurilideno (nfda)','5-nitrofurfurylidene diacetate (nfda)','Diacetato de 5-nitrofurfurilideno (nfda)',10,'29','2932','293219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29321990','Outs.compostos heterocicl.c/1 ciclo furano, n/condensado','Heterocyclic compounds with 1 furane cyclice, n/conden.','Los dem.comp.heterocícl.c/1 ciclo furano, s/condensar',10,'29','2932','293219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29322000','Lactonas','Lactones','Lactonas',10,'29','2932','293220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29322110','Cumarina','Coumarin','Cumarina',10,'29','2932','293221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29322190','Metilcumarinas e etilcumarinas','Methylcoumarins and ethylcoumarins','Metilcumarinas y etilcumarinas',10,'29','2932','293221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29322910','Cumafos ("coumaphos")','Coumaphos','Cumafós ("coumaphos")',10,'29','2932','293229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29322920','Fenolftaleina','Phenolphthalein','Fenolftaleina',10,'29','2932','293229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29322930','Espironolactona','Espironolactona','Espironolactona',10,'29','2932','293229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29322931','Ivermectina','Ivermectin','Ivermectina',10,'29','2932','293229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29322932','Abamectina','Abamectin','Abamectina',10,'29','2932','293229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29322933','Moxidectina','Moxidectin','Moxidectina',10,'29','2932','293229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29322990','Outras lactonas','Other lactones','Las demás lactonas',10,'29','2932','293229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329100','Isossafrol','Isosafrole','Isosafrol',10,'29','2932','293291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329200','1-(1, 3-benzodioxol-5-il) propan-2-ona','1-(1, 3-benzodioxol-5-yl)propan-2-one','1-(1, 3-benzodioxol-5-il) propan-2-ona',10,'29','2932','293292');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329300','Piperonal','Piperonal','Piperonal',10,'29','2932','293293');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329400','Safrol','Safrole','Safrol',10,'29','2932','293294');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329500','Tetraidrocanabinois (todos os isômeros)','Tetrahydrocannabinols (all isomers)','Tetrahidrocannabinoles (todos los isómeros)',10,'29','2932','293295');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329911','Eucaliptol','Eucalyptol','Eucaliptol',10,'29','2932','293299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329912','Quercetina','Quercetin','Quercetina',10,'29','2932','293299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329913','Dinitrato de isossorbida','Sosorbide dinitrate','Dinitrato de isosorbide',10,'29','2932','293299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329914','Carbofurano','Carbofuran','Carbofurano',10,'29','2932','293299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329921','Ivermectin','Ivermectin','Ivermectina',10,'29','2932','293299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329922','Abamectina','Abamectin','Abamectina',10,'29','2932','293299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329923','Moxidectina','Moxidectin','Moxidectina',10,'29','2932','293299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329924','Merbromina','Merbromin','Merbromina',10,'29','2932','293299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329991','Cloridrato de amiodarona','Amiodarone hydrochloride','Clorhidrato de amiodarona',10,'29','2932','293299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329992','1, 3, 4, 6, 7, 8-hexaidro-4, 6, 6, 7, 8, 8-hexametilciclopent.etc','1, 3, 4, 6, 7, 8-hexahydro-4, 6, 6, 7, 8, 8-hexamethylcyclop.etc','1, 3, 4, 6, 7, 8-hexahidro4, 6, 6, 7, 8, 8-hexametilciclopent.etc',10,'29','2932','293299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329993','Dibenzilideno-sorbitol','Dibenzylidene-sorbitol','Dibencilideno-sorbitol',10,'29','2932','293299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329994','Carbosulfan ((dibutilaminotio) metilcarbamato de 2, etc.','Carbosulfan(dibutylaminothio)methylcarbamate of 2, etc.','Carbosulfan (dibutilaminotio) metilcarbamato de 2, etc.',10,'29','2932','293299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329995','Tetraidrocanabinol e seus isômeros','Tetrahydrocannabinol and its isomers','Tetrahidrocanabinol y sus isómeros',10,'29','2932','293299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29329999','Outros compostos heterocicl.de heteroatomos de oxigênio','Oth.heterocyclic compounds with oxygen hetero-atoms','Los dem.compuest.heterocicl.de heteroátomos de oxígeno',10,'29','2932','293299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29331111','Dipirona','Dipyrone','Dipirona',10,'29','2933','293311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29331112','Magnopirol ("dipirona magnesica")','Magnopyrol','Magnopirol ("dipirona magnésica")',10,'29','2933','293311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29331119','Outros acidos 1-fenil-2, 3-dimetil-5-pirazolona-4-...','Other acid 1-phenil-2, 3-dimethyl-5-pyrazolone-4-...','Los dem.ácidos 1-fenil-2, 3-dimetil-5-pirazolona-4-...',10,'29','2933','293311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29331120','Metileno-bis (4metilamino-1fenil-2, 3-dimetil)pirazolona','Methylenebis(4-methylamino-1-phenyl-2, 3-dimethyl)pyraz.','Metileno-bis (4metilamino-1fenil-2, 3-dimetil)pirazolona',10,'29','2933','293311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29331190','Outras fenazonas (antipirinas) e seus derivados','Other phenazone (antipyrin) and its derivatives','Las dem.fenazonas (antipirinas) y sus derivados',10,'29','2933','293311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29331911','Fenilbutazona cálcica','Phenylbutazone calcium','Fenilbutazona cálcica',10,'29','2933','293319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29331919','Outras fenilbutazonas e seus sais','Other phenylbutazone, its salts','Las dem.fenilbutazonas y sus sales',10,'29','2933','293319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29331990','Outs.compostos heterocicl.c/1 ciclo pirazol, n/condens.','Oth.heterocyclic compounds with 1 cycle pyrazole, n/cond','Los dem.comp.heterocícl.c/1 ciclo pirazol, s/condensar',10,'29','2933','293319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332110','Iprodiona','Iprodione','Iprodiona',10,'29','2933','293321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332121','Fenitoina e seu sal sódico','Phenytoin and its sodium salt','Fenitoína y su sal sódica',10,'29','2933','293321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332129','Outros sais da fenitoina','Other phenytoin salts','Los demás sales de fenitoína',10,'29','2933','293321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332190','Outras hidantoínas e seus derivados','Other hydantoin and its derivatives','Las demás hidantoínas y sus derivados',10,'29','2933','293321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332911','2-metil-5-nitroimidazol','2-metil-5-nitroimidazol','2-metil-5-nitroimidazol',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332912','Metronidazol e seus sais','Metronidazole and its salts','Metronidazol y sus sales',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332913','Tinidazol','Tinidazole','Tinidazol',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332919','Outs.compostos heterocíclicos com 1 ciclo nitroimidazol','Other heterocyclic compounds with 1 nitroimidazole','Los dem.compuestos heterocícl.c/1 ciclo nitroimidazol',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332921','Econazol e seu nitrato','Econazole and its nitrate','Econazol y su nitrato',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332922','Nitrato de miconazol','Miconazol nitrate','Nitrato de miconazol',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332923','Cloridrato de clonidina','Clonidine hydrochloride','Clorhidrato de clonidina',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332924','Nitrato de isoconazol','Isoconazole nitrate','Nitrato de isoconazol',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332925','Clotrimazol','Clotrimazole','Clotrimazol',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332929','Outros compostos heterocíclicos c/ciclo benzeno clorado','Heterocyclic compounds with cycle chlorinat.benzene','Los dem.compuest.heterocíclicos c/ciclo benceno clorado',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332930','Cimetidina e seus sais','Cimetidine and its salts','Cimetidina y sus sales',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332940','4-metil-5-hidroximetilimidazol e seus sais','4-methyl-5-hydroxymethylimidazole and its salts','4-metil-5-hidroximetilimidazol y sus sales',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332991','Imidazol','Imidazole','Imidazol',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332992','Histidina e seus sais','Histidine and its salts','Histidina y sus sales',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332993','Ondansetron e seus sais','Ondansetron and its salts','Ondansetrón y sus sales',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332994','1-hidroxietil-2-undecanoilimidazolina','1-hydroxyethyl-2-undecanoylimidazoline','1-hidroxietil-2-undecanoilimidazolina',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332995','1-hidroxietil-2-(8-heptadecenoil) imidazolina','1-hydroxyethyl-2-(8-heptadecanoyl)imidazoline','1-hidroxietil-2-(8-heptadecenoil) imidazolina',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29332999','Outs.compostos heterocicl.1 ciclo imidazol n/condensado','Other heterocyclic compounds 1 cycle imidazole n/conden','Los dem.comp.heterocícl.1 ciclo imidazol s/condensar',10,'29','2933','293329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333110','Piridina','Pyridine','Piridina',10,'29','2933','293331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333120','Sais de piridina','Salts of pyridine','Sales de piridina',10,'29','2933','293331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333200','Piperidina e seus sais','Piperidine and its salts','Piperidina y sus sales',10,'29','2933','293332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333311','Alfentanil','Alfentanil','Alfentanil',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333312','Anileridina','Anileridine','Anileridina',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333319','Sais de alfentanil ou de anileridina','Salts of alfentanil or anileridine','Sales de alfentanil o de anileridina',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333321','Bezitramida','Bezitramide','Bezitramida',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333322','Bromazepam','Bromazepam','Bromazepam',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333329','Sais de bezitramida ou de bromazepam','Salts of bezitramida or bromazepam','Sales de bezitramida o de bromazepam',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333330','Cetobemidona e seus sais','Ketobemidone and its salts','Cetobemidona y sus sales',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333341','Difenoxilato','Diphenoxylate','Difenoxilato',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333342','Cloridrato de difenoxilato','Diphenoxylate hydrochloride','Clorhidrato de difenoxilato',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333349','Outros sais de difenoxilato','Other diphenoxylate salts','Los demás sales de difenoxilato',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333351','Difenoxina','Diphenoxin','Difenoxina',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333352','Dipipanona','Dipipanone','Dipipanona',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333359','Sais de difenoxina ou de dipipanona','Salts of difenoxin or dipipanona','Sales de difenoxina ou de dipipanona',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333361','Fenciclidina (pcp)','Phencyclidine','Fenciclidina (pcp)',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333362','Fenoperidina','Phenoperidine','Fenoperidina',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333363','Fentanil','Fentanyl','Fentanil',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333369','Sais de fenciclidina, fenoperidina ou fentanil','Salts of phencyclidine, phenoperidine or fentanyl','Sales de fenciclidina,  fenoperidina o fentanil',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333371','Metilfenidato','Methylphenidate','Metilfenidato',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333372','Pentazocina','Pentazocine','Pentazocina',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333379','Sais de metilfenidato ou de pentazocina','Salts of methylphenidate or pentazocine','Sales de metilfenidato o de pentazocina',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333381','Petidina','Pethidine','Petidina',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333382','Intermediário a da petidina','Pethidine intermediate','Intermediario a de la petidina',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333383','Pipradrol','Pipradrol','Pipradrol',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333384','Cloridrato de petidina','Pethidine hycrochloride','Clorhidrato de petidina',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333389','Outros sais de petidina ou do intermediário a','Other salts of pethidine or of intermediate a','Los demás sales de petidina o del intermediario a',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333391','Piritramida','Piritramide','Piritramida',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333392','Propiram','Propiram','Propiram',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333393','Trimeperidina','Trimeperidine','Trimeperidina',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333399','Sais de piritramida, propiram ou trimeperidina','Other of piritramide or trimeperidine','Sales de piritramida,  propiram o trimeperidina',10,'29','2933','293333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333911','Bromazepam','Bromazepam','Bromazepam',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333912','Droperidol','Droperidol','Droperidol',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333913','Acido niflumico','Niflumic acid','Ácido niflúmico',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333914','Haloxifop (acido (rs)-2-[4-(3-cloro-5-trifluormetil-etc','Haloxifop (rs)-2-[4-(3-chloro-5-trifluoromethyl-etc','Haloxifop (ácido(rs)-2-[4-(3-cloro-5-trifluorometil-etc',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333915','Haloperidol','Haloperidol','Haloperidol',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333919','Outs.compost.heterocicl.c/fluor e/ou bromo, lig.covalent','Oth.heterocyclic comp.w/fluorine and/or br.coval.bond.','Los dem.comp.heterocícl.c/flúor y/o bromo, lig.coval.',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333921','Picloram','Picloram','Picloram',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333922','Clorpirifos','Chlorpyrifos','Clorpirifos',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333923','Malato ácido de cleboprida (malato de cleboprida)','Clebopride malate acid','Malato ácido de cleboprida (malato de cleboprida)',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333924','Cloridrato de cloperamida','Cloperamide hydrochloride','Clorhidrato de cloperamida',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333925','Ácido 2-(2metil-3cloroanilino) nicotinico/sal de lisina','(2-methyl-3-chloroaniline)nicotinic acid/lysine salts','Ácido 2-(2metil-3cloroanilino) nicotínico/sal de lisina',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333929','Outs.compostos heterocicl.c/cloro, sem fluor nem bromo','Other heterocyclic compounds with chlor.n/fluor.n/brom.','Los dem.compuestos heterocícl.c/cloro, s/flúor ni bromo',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333931','Terfenadina','Terfenadine','Terfenadina',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333932','Biperideno e seus sais','Biperiden and its salts','Biperideno y sus sales',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333933','Acido isonicotínico','Isonicotinic acid','Ácido isonicotínico',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333934','5-etil-2, 3-dicarboxipiridina (5-epdc)','5-ethyl-2, 3-dicarboxypyridine (5-epdc)','5-etil-2, 3-dicarboxipiridina (5-epdc)',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333935','Imazetapir (ac.(rs)-5-etil-2-(4-isopropil-4-metil-5-etc','Mazetapir (rs)-5-ethyl-2-(4-isopropyl-4-methyl-5-etc.','Imazetapir (ac.(rs)-5-etil-2-(4-isopropil-4-metil-5-etc',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333936','Quinuclidin-3-ol','Quinuclidine-3-ol','Quinuclidin-3-ol',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333937','Difenoxina e seus sais','Diphenoxine and its salts','Difenoxina y sus sales',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333938','Pentazocina e seus sais','Pentazocine  and its salts','Pentazocina y sus sales',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333939','Fenoperidina e seus sais','Pentazocine and its salts','Fenoperidina y sus sales',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333941','Cloridrato de difenoxilato','Diphenoxylate hydrochloride','Clorhidrato de difenoxilato',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333942','Cloridrato de meperidina (cloridrato de petidina)','Hydrochloride meperidine (pethidine hydrochloride)','Clorhidrato de meperidina (clorhidrato de petidina)',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333943','Nifedipina','Nifedipine','Nifedipina',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333944','Nitrendipina','Nitrendipine','Nitrendipina',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333945','Maleato de pirilamina','Pirilamine maleate','Maleato de pirilamina',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333946','Omeprazol','Omeprazole','Omeprazol',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333947','Benzilato de 3-quinuclidinila','3-quinuclidinyl benzylate','Benzilato de 3-quinuclidinilo',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333948','Nimodipina','Nimodipine','Nimodipina',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333949','Outs.compostos cont.ciclo piridina não condensado','Other compounds cont.cycle piridine n/condensed','Los dem.compuestos cont.ciclo piridina sin condensar',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333951','Pipradrol (pipradol) e seus sais','Pipradrol (pipradol) and its salts','Pipradrol (pipradol) y sus sales',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333952','Petidina (meperidina)','Pethidine','Petidina (meperidina)',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333953','Trimeperidina','Trimeperidine','Trimeperidina',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333954','Difenoxilato','Diphenoxylate','Difenoxilato',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333955','Quinuclidin-3-ol','Quinuclidinyl-3-ol','Quinuclidin-3-ol',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333956','Benzilato de 3-quinuclidinila','3-quinuclidinyle benzylate','Benzilato de 3-quinuclidinilo',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333957','Nimodipina','Nimodipine','Nimodipina',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333959','Outs.compostos heterocicl.func.álcool, acid.carboxil.etc','Other heterocyclic compounds alcohol func.carb.acid etc','Los dem.comp.heterocícl.func.alcohol, ác.carboxíl.etc',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333981','Cloridrato de benzetimida','Benzetamide hydrochloride','Clorhidrato de benzetimida',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333982','Cloridrato de mepivacaina','Mepivacaine hydrochloride','Clorhidrato de mepivacaína',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333983','Cloridrato de bupivacaina','Bupivacaine hydrochloride','Clorhidrato de bupivacaína',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333984','Dicloreto de paraquat','Paraquat dichloride','Dicloruro de paraquat',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333985','4-ciano-1-metil-4-fenilpiperidina e seus sais','4-cyano-1-methyl-4-phenazopyridine and its salts','4-ciano-1-metil-4-fenilpiperidina y sus sales',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333986','Fenciclidina ("phencyclidine") e seus sais','Phencyclidine and its salts','Fenciclidina ("phencyclidine") y sus sales',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333987','Fentanil e seus sais','Phentanyl and its salts','Fentanil y sus sales',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333989','Outs.compostos heterocicl.c/piridina, n- rad.alquila, etc','Oth.heterocyclic comp.with piridine, n/rad.alkyle, etc','Los dem.comp.heterocícl.c/piridina, n- rad.alquilo, etc',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333991','Cloridrato de fenazopiridina','Phenazopyridine hydrochloride','Clorhidrato de fenazopiridina',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333992','Isoniazida','Isoniazid','Isoniazida',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333993','3-cianopiridina','3-cyanopyridine','3-cianopiridina',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333994','4, 4''-bipiridina','4, 4''-bipiridine','4, 4''-bipiridina',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333995','Bezitramida ("bezitramide")','Bezitramide','Becitramida ("bezitramide")',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333996','Dipipanona e seus sais','Dipipanone and its salts','Dipipanona y sus sales',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333997','Piritramida','Piritramide','Piritramida',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333998','Propiram e seus sais','Propiram and its salts','Propiram y sus sales',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29333999','Outs.compostos heterocicl.1 ciclo piridina n/condensado','Other heterocyclic compounds 1 cycle piridine n/conden.','Los dem.comp.heterocícl.1 ciclo piridina s/condensar',10,'29','2933','293339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334011','Acido 2, 3-quinolinodicarboxilico','2, 3-quinolinedicarboxylic acid','Ácido 2, 3-quinolindicarboxílico',10,'29','2933','293340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334012','Rosoxacina','Rosoxacin','Rosoxacín',10,'29','2933','293340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334013','Imazaquin','Imazaquin','Imazaquín',10,'29','2933','293340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334019','Outros derivados do ácido quinolinocarboxilico','Other derivatives of quinolinocarboxylic acid','Los dem.derivados del ácido quinolincarboxílico',10,'29','2933','293340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334020','Oxaminiquina','Oxaminiquine','Oxamniquina',10,'29','2933','293340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334030','Broxiquinolina','Broxyquinoline','Broxiquinolina',10,'29','2933','293340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334041','Levorfanol','Levorphanol','Levorfanol',10,'29','2933','293340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334049','Sais e ésteres de levorfanol','Salts and esters of levorphanol','Sales y ésteres de levorfanol',10,'29','2933','293340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334090','Outs.compostos heterocíclicos c/1 ciclo quinoleina, etc.','Oth.heterocyclic comp.with 1 quinoleine ring, etc','Los dem.comp.heterocíclicos c/1 ciclo quinoleína, etc.',10,'29','2933','293340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334110','Levorfanol','Levorphanol','Levorfanol',10,'29','2933','293341');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334120','Sais de levorfanol','Salts of levorphanol','Sales de levorfanol',10,'29','2933','293341');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334911','Ácido 2, 3-quinolinodicarboxilico','2, 3-quinolinedicarboxylic acid','Ácido 2, 3-quinolindicarboxílico',10,'29','2933','293349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334912','Rosoxacina','Rosoxacin','Rosoxacín',10,'29','2933','293349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334913','Imazaquin','I-mazaquin','Imazaquín',10,'29','2933','293349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334914','Quinolinolato de metilmercúrio','Methylmercuric quinolinolate','Quinolinolato de metilmercurio',10,'29','2933','293349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334915','8-hidroxiquinolinolato de fenilmercúrio','Phenylmercuric 8-hydroxyquinolinolate','8-hidroxiquinolinolato de fenilmercurio',10,'29','2933','293349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334919','Outros derivados do ácido quinolinocarboxílico','Other derivatives of quinolinedicarboxylic acid','Los dem.derivados del ácido quinolincarboxílico',10,'29','2933','293349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334920','Oxaminiquina','Oxamniquine','Oxamniquina',10,'29','2933','293349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334930','Broxiquinolina','Broxyquinoline','Broxiquinolina',10,'29','2933','293349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334940','Ésteres do levorfanol','Esters of levorphanol','Ésteres del levorfanol',10,'29','2933','293349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29334990','Outs.compostos cont.ciclos de quinoleina, etc.','Other compounds cont.quinoleine ring, etc','Los dem.compuestos q.cont.ciclos de quinoleína, etc.',10,'29','2933','293349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335100','Maloniluréia (acido barbiturico), seus derivados e sais','Malonylurea (barbituric acid), its derivatives and salts','Malonilurea (ácido barbitúrico), sus derivados y sales',10,'29','2933','293351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335111','Amobarbital e seus sais','Amobarbital and its salts','Amobarbital y sus sales',10,'29','2933','293351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335112','Barbital e seus sais','Barbital and its salts','Barbital y sus sales',10,'29','2933','293351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335113','Butobarbital ("butethal") e seus sais','Butethal and its salts','Butobarbital ("butethal") y sus sales',10,'29','2933','293351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335114','Ciclobarbital ("cyclobarbital") e seus sais','Cyclobarbital and its salts','Ciclobarbital ("cyclobarbital") y sus sales',10,'29','2933','293351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335115','Metilfenobarbital ("mephobarbital") e seus sais','Mephobarbital and its salts','Metilfenobarbital ("mephobarbital") y sus sales',10,'29','2933','293351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335116','Pentobarbital e seus sais','Pentobarbital and its salts','Pentobarbital y sus sales',10,'29','2933','293351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335117','Fenobarbital ("phenobarbital") e seus sais','Phenobarbital and its salts','Fenobarbital ("phenobarbital") y sus sales',10,'29','2933','293351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335118','Secbutabarbital (acido 5-etil-5-sec-butilbarbiturico)','Secbutabarbital (5-ethyl-5-sec-butilbarbituric acid)','Secbutabarbital (ácido 5-etil-5-sec-butilbarbitúrico)',10,'29','2933','293351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335119','Outs.maloniluréias, com 1 ou 2 grupos etila no carbono 5','Oth.malonylurea, with 1 or 2 ethyle in carbon 5','Los dem.malonilureas, c/1 o 2 grup.etilo en el carbono 5',10,'29','2933','293351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335191','Alobarbital ("allobarbital") e seus sais','Allobarbital and its salts','Alobarbital ("allobarbital") y sus sales',10,'29','2933','293351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335192','Butalbital e seus sais','Butalbital and its salts','Butalbital y sus sales',10,'29','2933','293351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335193','Secobarbital e seus sais','Secobarbital and its salts','Secobarbital y sus sales',10,'29','2933','293351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335194','Vinilbital ("vinylbital") e seus sais','Vinylbital and its salts','Vinilbital ("vinylbital") y sus sales',10,'29','2933','293351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335199','Outras maloniluréias e seus derivados e seus sais','Other derivatives of malonylurea and salts thereof','Las dem.malonilureas y sus derivados y sus sales',10,'29','2933','293351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335200','Maloniluréia (acido barbiturico) e seus sais','Malonylurea (barbituric acid) and its salts','Malonilurea (ácido barbitúrico) y sus sales',10,'29','2933','293352');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335311','Alobarbital e seus sais','Allobarbital and its salts','Alobarbital y sus sales',10,'29','2933','293353');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335312','Amobarbital e seus sais','Amobarbital and its salts','Amobarbital y sus sales',10,'29','2933','293353');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335321','Barbital e seus sais','Barbital and its salts','Barbital y sus sales',10,'29','2933','293353');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335322','Butalbital e seus sais','Butalbital and its salts','Butalbital y sus sales',10,'29','2933','293353');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335323','Butobarbital e seus sais','Butethal and its salts','Butobarbital y sus sales',10,'29','2933','293353');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335330','Ciclobarbital e seus sais','Cyclobarbital and its salts','Ciclobarbital y sus sales',10,'29','2933','293353');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335340','Fenobarbital e seus sais','Phenobarbital and its salts','Fenobarbital y sus sales',10,'29','2933','293353');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335350','Metilfenobarbital e seus sais','Methylphenobarbital and its salts','Metilfenobarbital y sus sales',10,'29','2933','293353');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335360','Pentobarbital e seus sais','Pentobarbital and its salts','Pentobarbital y sus sales',10,'29','2933','293353');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335371','Secbutabarbital e seus sais','Secbutabarbital and its salts','Secbutabarbital y sus sales',10,'29','2933','293353');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335372','Secobarbital e seus sais','Secobarbital and its salts','Secobarbital y sus sales',10,'29','2933','293353');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335380','Venilbital e seus sais','Vinylbital and its salts','Vinilbital y sus sales',10,'29','2933','293353');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335400','Outs.deriv.da manolinuréia (acido barbiturico','Other derivatives of malonylurea (barbituric acid)','Los dem.deriv. de la manolinurea (ácido barbitúrico)',10,'29','2933','293354');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335510','Loprazolam e seus sais','Loprazolam and its salts','Loprazolam y sus sales',10,'29','2933','293355');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335520','Mecloqualona e seus sais','Mecloqualone and its salts','Meclocualona y sus sales',10,'29','2933','293355');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335530','Metaqualona e seus sais','Methaqualone and its salts','Metacualona y sus sales',10,'29','2933','293355');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335540','Zipeprol e seus sais','Zipeprol and its salts','Zipeprol y sus sales',10,'29','2933','293355');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335911','Oxatomida','Oxatomide','Oxatomida',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335912','Praziquantel','Praziquantel','Praziquantel',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335913','Norfloxacina e seu nicotinato','Norfloxacin and its nicotinate','Norfloxacina y su nicotinato',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335914','Flunarizina e seu dicloridrato','Flunarizine and its dihydrochloride','Flunaricina y su diclorhidrato',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335915','Enrofloxacina, sais de piperazina','Enrofloxacin, piperazine salts','Enrofloxacina,  sales de piperazina',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335916','Cloridrato de buspirona','Buspirone hydrochloride','Clorhidrato de buspirona',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335917','Loprazolam e seus sais','Loprazolam and its salts','Loprazolam y sus sales',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335918','Zipeprol e seus sais','Zipeprol and its salts','Zipeprol y sus sales',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335919','Outros compostos heterocíclicos, com ciclo piperazina','Other heterocyclic compounds with piperazine ring','Los dem.compuestos heterocíclicos,  con ciclo piperazina',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335921','Bromacil','Bromacyl','Bromacil',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335922','Terbacil','Terbacil','Terbacil',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335923','Fluorouracil','Fluorouracil','Fluorouracilo',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335924','Mecloqualona e seus sais','Methaqualone and its salts','Meclocualona y sus sales',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335929','Outs.compost.heteroc.ciclo pirimidina, halog.lig.covalen','Other heterocyclic compound, cycle pirim., halog.+++++++','Los dem.comp.heteroc.ciclo pirimidina, halog.lig.cov.',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335931','Propiltiouracil','Propythiouracil','Propiltiouracilo',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335932','Diazinon','Diazinon','Diazinon',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335933','Pirazofos','Pyrazophs','Pirazofós',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335934','Azatioprina','Azathioprine','Azatioprina',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335935','6-mercaptopurina','6-mercaptopurine','6-mercaptopurina',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335939','Outs.compost.heteroc.ciclo pirimidina, enxofre, s/halogen','Other heterocyclic compounds, sulphur, without halog.','Los dem.comp.heteroc.ciclo pirimidina, azufre, s/halogen',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335941','Trimetoprima','Trimethoprim','Trimetoprim',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335942','Aciclovir','Acyclovir','Aciclovir',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335943','Tosilatos de dipiridamol','Dipiridamol tosylates','Tosilatos de dipiridamol',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335944','Nicarbazina','Nicarbazine','Nicarbazina',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335945','Bissulfito de menadiona dimetilpirimidinol','Menadione dimethylpyramidinol bisulphite','Bisulfito de menadiona dimetilpirimidinol',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335949','Outs.comp.heteroc.cicl.pirimidina, func.álcool e/ou eter','Oth.heterocyc.compoun.pyrimidine ring, alc./ether func.','Los dem.comp.heteroc.cicl.pirimid.func.alcohol y/o éter',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335991','Minoxidil','Minoxidil','Minoxidil',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335992','2-aminopirimidina','2-aminopyrimidine','2-aminopirimidina',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335993','Metaqualona ("methaqualone") e seus sais','Methaqualone and its salts','Metacualona ("methaqualone") y sus sales',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29335999','Outs.compostos heterocicl.c/ciclo pirimidina/piperazina','Oth.heterocyc.compoun.with pyrimidine/piperazine ring','Los dem.comp.heterocícl.c/ciclo pirimidina/piperazina',10,'29','2933','293359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29336100','Melamina','Melamine','Melamina',10,'29','2933','293361');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29336911','2, 4, 6-triclorotriazina (cloreto cianurico)','2, 4, 6-trichlorotriazine (cyanuric chloride)','2, 4, 6-triclorotriazina (cloruro cianúrico)',10,'29','2933','293369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29336912','Mercaptodiclorotriazina','Mercaptodichlorotriazine','Mercaptodiclorotriazina',10,'29','2933','293369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29336913','Atrazina','Atrazine','Atrazina',10,'29','2933','293369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29336914','Simazina','Simazine','Simazina',10,'29','2933','293369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29336915','Cianazina','Cyanazine','Cianazina',10,'29','2933','293369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29336916','Anilazina','Anilazine','Anilazina',10,'29','2933','293369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29336919','Outs.compost.heteroc.ciclo triazina, c/cloro lig.covalen','Oth.heteroc.comp.triazine ring with chlorine coval.bond','Los dem.comp.heteroc.ciclo triazina, c/cloro lig.covalen',10,'29','2933','293369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29336921','N, n, n-triidroxietilexaidrotriazina','N, n, n-trihydroxyethylhexahydrotriazine','N, n, n-trihidroxietilhexahidrotriazina',10,'29','2933','293369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29336922','Hexazinona','Hexazinon','Hexazinona',10,'29','2933','293369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29336923','Metribuzim','Metribuzin','Metribuzin',10,'29','2933','293369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29336929','Outs.compost.heteroc.ciclo triazina, s/cloro lig.covalen','Oth.heter.comp.triazine ring without chlorine cov.bond','Los dem.comp.heteroc.ciclo triazina, s/cloro lig.covalen',10,'29','2933','293369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29336991','Ametrina','Ametryn','Ametrina',10,'29','2933','293369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29336992','Metenamina (hexametilenotetramina) e seus sais','Methenamine (hexamethenamine) and its salts','Metenamina (hexametilentetramina) y sus sales',10,'29','2933','293369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29336999','Outs.compostos heterocicl.1 ciclo triazina n/condensado','Oth.heteroc.compounds 1 triazine ring n/condensed','Los dem.comp.heterocícl.1 ciclo triazina s/condensar',10,'29','2933','293369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29337100','6-hexanolactama (epsilon-caprolactama)','6-hexanelactam (epsilon-caprolactam)','6-hexanolactama (epsilon-caprolactama)',10,'29','2933','293371');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29337210','Clobazam','Clobazam','Clobazam',10,'29','2933','293372');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29337220','Metilprilona','Methyprylon','Metilprilona',10,'29','2933','293372');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29337910','Piracetam','Piracetam','Piracetam',10,'29','2933','293379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29337920','Clobazam','Clobazam','Clobazam',10,'29','2933','293379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29337930','Metiprilona ("methyprylon")','Methyprylon','Metiprilona ("methyprylon")',10,'29','2933','293379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29337990','Outras lactamas','Other lactams','Las demás lactamas',10,'29','2933','293379');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339011','Pirazinamida','Pyrazinamide','Pirazinamida',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339012','Cloridrato de amilorida','Amiloride hydrochloride','Clorhidrato de amilorida',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339013','Pindolol','Pindolol','Pindolol',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339019','Outs.compost.heteroc.1 ciclo pirazina n/condensado, etc','Oth.heteroc.compounds 1 triazine ring n/condensed, etc.','Los dem.comp.heteroc.1 ciclo pirazina s/condensar, etc',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339021','Clordiazepóxido ("chlordiazepoxide")','Chlordiazepoxide','Clordiazepóxido ("chlordiazepoxide")',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339022','Diazepam','Diazepam','Diazepam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339023','Oxazepam','Oxazepam','Oxazepam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339024','Alprazolam','Alprazolam','Alprazolam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339025','Triazolam','Triazolam','Triazolam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339026','Camazepam','Camazepam','Camazepam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339027','Clonazepam','Clonazepam','Clonazepam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339028','Clorazepato','Clorazepato','Clorazepato',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339029','Sais e ésteres de compost.heterocicl.c/1ciclo diazepina','Heteroc.compounds salts and esters with diazepine ring','Sales y ésteres de compuest.heteroc.c/1ciclo diazepina',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339031','Dibenzoazepina (iminoestilbeno)','Dibenzoazepine (iminoestilbene)','Dibenzoazepina (iminoestilbeno)',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339032','Carbamazepina','Carbamazepine','Carbamazepina',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339033','Cloridrato de clomipramina','Clomipramine hydrochloride','Clorhidrato de clomipramina',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339034','Molinate (hexaidroazepin-1-carbotioato de s-etila)','Molinate (s-ethyl hexahydroazepin-1-carbothioate)','Molinate (hexahidroazepin-1-carbotioato de s-etilo)',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339035','Hexametilenoimina','Hexamethyleneimine','Hexametilenimina',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339039','Outros compostos heterocíclicos, com 1 ciclo azepina','Other heterocyclic compounds, with 1 azepine ring','Los demás compuestos heterocíclicos, con 1 ciclo azepina',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339041','Clemastina e seus derivados, sais destes produtos','Clemastine and its derivatives, salts thereof','Clemastina y sus derivados,  sales de estos productos',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339042','Amisulprida','Amisulpride','Amisulprida',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339043','Sultoprida','Sultopride','Sultoprida',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339044','Alizaprida','Alizapride','Alizaprida',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339045','Buflomedil e seus derivados, sais destes produtos','Buflomedil and its derivatives, salts thereof','Buflomedil y sus derivados,  sales de estos productos',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339046','Maleato de enalapril','Enalapril maleate','Maleato de enalapril',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339047','Ketorolac trometamina','Ketorolac tromethamine','Ketorolac trometamina',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339048','Pirovalerona ("pyrovalerone") e seus sais','Pyrovalerone and its salts','Pirovalerona ("pyrovalerone") y sus sales',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339049','Outros compostos heterocíclicos, com 1 ciclo pirrol','Other heterocyclic compounds, with pyrrol ring','Los demás comp.heterocíclicos, con 1 ciclo pirrol',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339051','Benomil','Benomyl','Benomil',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339052','Oxifendazol','Oxfendazole','Oxfendazol',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339053','Albendazol e seu sulfóxido','Albendazole and albendazole sulphoxide','Albendazol y su sulfóxido',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339054','Mebendazol','Mebendazole','Mebendazol',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339055','Flubendazol','Flubendazole','Flubendazol',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339056','Fembendazol ("fenbendazole")','Fenbendazole','Fembendazol ("fenbendazole")',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339057','Mazindol','Mazindole','Mazindol',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339058','Midazolam e seus sais','Midazolam and its salts','Midazolam y sus sales',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339059','Outros compostos heterocíclicos, com ciclo imidazol','Other heterocyclic compounds, with imidazole ring','Los demás compuestos heterocíclicos,  con ciclo imidazol',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339061','Triadimenol','Triadimenol','Triadimenol',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339062','Triadimefon','Triadimefon','Triadimefon',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339063','Triazofos (fósforotioato de o, o-dietila-o-(1-fenil-etc.','Triazofos(o, o-diethyl o-(1-phenyl-1h--1, 2, 4-triazol3-yl','Triazofós (fosforotioato de 0, 0-dietilo-0-(1-fenil-etc.',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339069','Outs.compost.heterocicl.c/1 ciclo triazol n/condensado','Oth.heterocyclic compounds with triazol ring','Los dem.comp.heterocícl.c/1 ciclo triazol s/condensar',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339071','Delorazepam (7-cloro-5-(2-clorofenil)-1, 3-diidro-2h-etc','Deloraz.(7-chloro-5-(2-chlorophenyl)-1, 3-diidro-2h-etc','Delorazepam(7-cloro-5-(2-clorofenil)-1, 3-dihidro-2h-etc',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339072','Estazolam','Estazolam','Estazolam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339073','Fludiazepam','Fludiazepam','Fludiazepam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339074','Flunitrazepam','Flunitrazepam','Flunitrazepam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339075','Flurazepam e seus sais','Flurazepam and its salts','Flurazepam y sus sales',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339076','Halazepam','Halazepam','Halazepam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339077','Loflazepato de etila','Ethyle loflazepate','Loflazepato de etilo',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339078','Lorazepam','Lorazepam','Lorazepam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339079','Lormetazepam','Lormetazepam','Lormetazepam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339081','Medazepam e seus sais','Medazepam and its salts','Medazepam y sus sales',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339082','Nimetazepam','Nimetazepam','Nimetazepam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339083','Nitrazepam','Nitrazepam','Nitrazepam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339084','Nordazepam (n-desmetildiazepam)','Nordazepam (n-desmetildiazepam)','Nordazepam (n-desmetildiazepam)',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339085','Pinazepam','Pinazepam','Pinazepam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339086','Prazepam','Prazepam','Prazepam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339087','Temazepam','Temazepam','Temazepam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339088','Tetrazepam','Tetrazepam','Tetrazepam',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339089','Outs.compostos heterocicl.c/1 ciclo diazepina, seus sais','Oth.heterocyclic comp., with 1 diazepine ring, its salts','Los dem.comp.heterocícl.c/1 ciclo diazepina, sus sales',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339091','Azinfos etílico','Azinfos-ethyl','Azinfós etílico',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339092','Acido nalidixico','Nalidixic acid','Ácido nalidíxico',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339093','Clofazimina','Clofazimine','Clofazimina',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339094','Metenamina (hexametilenotetramina) e seus sais','Methenamine (hexamethylenetetramine) its salts','Metenamina (hexametilentetramina) y sus sales',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339095','Metilsulfato de amezinio','Amezinium methyl sulphate','Metilsulfato de amezinio',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339096','Hidrazida maleica e seus sais','Maleic hydrazide and its salts','Hidrazida maleica y sus sales',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339099','Outs.compostos heterocicl.de heteroatomos de nitrogênio','Oth.heterocyclic compounds with nitrogen hetero-atom','Los dem.comp.heterocícl.de heteroátomos de nitrógeno',10,'29','2933','293390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339111','Alprazolam','Alprazolam','Alprazolam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339112','Camazepam','Camazepam','Camazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339113','Clonazepam','Clonazepam','Clonazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339114','Clorazepato','Clorazepate','Clorazepato',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339115','Clorodiazepóxido','Chlordiazapoxide','Clorodiazepóxido',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339119','Sais de alprazolam, camazepam, clonazepam, etc.','Salts of alprazolam, camazepam, chlordiazepoxide, etc','Sales de alprazolam,  camazepam,  clonazepam,  etc.',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339121','Delorazepam','Delorazepam','Delorazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339122','Diazepam','Diazepam','Diazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339123','Estazolam','Estazolam','Estazolam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339129','Sais de delorazepam, diazepam ou estazolam','Salts of delorazepam, diazepam or estazolam','Sales de delorazepam,  diazepam o estazolam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339131','Fludiazepam','Fludiazepam','Fludiazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339132','Flunitrazepam','Flunitrazepam','Flunitrazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339133','Flurazepam','Flurazepam','Flurazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339134','Halazepam','Halazepam','Halazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339139','Sais de fludiazepam, flunitrazepam, etc.','Salts of fludiazepam, flunitrazepam, etc.','Sales de fludiazepam, flunitrazepam, etc.',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339141','Loflazepato de etila','Ethyl loflazepate','Loflazepato de etilo',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339142','Lorazepam','Lorazepam','Lorazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339143','Lormetazepam','Lormetazepam','Lormetazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339149','Sais de loflazepato de etila, lorazepam, etc.','Salts of ethyl loflazepate, lorazepam, etc.','Sales de loflazepato de etilo, lorazepam,  etc.',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339151','Mazindol','Mazindol','Mazindol',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339152','Medazepam','Medazepam','Medazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339153','Midazolam','Midazolam','Midazolam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339159','Sais de mazindol, medazepam ou midazolam','Salts of mazindol, medazepam or midazolam','Sales de mazindol, medazepam o midazolam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339161','Nimetazepam','Nimetazepam','Nimetazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339162','Nitrazepam','Nitrazepam','Nitrazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339163','Nordazepam','Nordazepam','Nordazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339164','Oxazepam','Oxazepam','Oxazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339169','Sais de nimetazepam, nitrazepam, nordazepam, oxazepam','Salts of nimetazepam, nitrazepam, nordazepam, oxazepam','Sales de nimetazepam,  nitrazepam,  nordazepam,  oxazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339171','Pinazepam','Pinazepam','Pinazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339172','Pirovalerona','Pyrovalerone','Pirovalerona',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339173','Prazepam','Prazepam','Prazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339179','Sais de pinazepam, pirovalerona ou prazepam','Salts of pinazepam, pirovalerona or prazepam','Sales de pinazepam,  pirovalerona o prazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339181','Temazepam','Temazepam','Temazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339182','Tetrazepam','Tetrazepam','Tetrazepam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339183','Triazolam','Triazolam','Triazolam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339189','Sais de temazepam, tetrazepam ou triazolam','Salts of temazepam, tetrazepam and triazolam','Sales de temazepam, tetrazepam o triazolam',10,'29','2933','293391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339911','Pirazinamida','Pyrazinamide','Pirazinamida',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339912','Cloridrato de amilorida','Amiloride hydrochloride','Clorhidrato de amilorida',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339913','Pindolol','Pindolol','Pindolol',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339919','Outs.compostos heterocicl.cont.ciclo pirazina','Oth.heterocyclic compounds containing pyrazina ring','Los dem.comp.heterocícl.que cont.ciclo pirazina',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339920','Outs.compostos heterocicl.cont.ciclo diazepina (hidrog.','Oth.heterocyclic compounds cont.diazepine ring (hygrog.','Los dem.comp.heterocícl.cont.ciclo diazepina(hidrog.',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339931','Dibenzoazepina (iminoestilbeno)','Iminostilbene','Dibenzoazepina (iminoestilbeno)',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339932','Carbamazepina','Carbamazepine','Carbamazepina',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339933','Cloridrato de clomipramina','Clomipramine hydrochloride','Clorhidrato de clomipramina',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339934','Molinate (hexaidroazepin-1-carbotioato de s-e','Molinate (s-ethyl hexahydroazepin-1-carbothioate)','Molinate (hexahidroazepin-1-carbotioato de s-e)',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339935','Hexametilenoimina','Hexamethyleneimine','Hexametilenimina',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339939','Outs.compostos heterocicl.cont.ciclo azepina','Oth.heterocyclic compounds cont.azepine ring','Los dem.compuestos heterocícl.que cont.ciclo azepina',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339941','Clemastina e seus derivados;sais destes prod','Clemastine, its derivatives and its salts','Clemastina y sus derivados; sales de estos productos',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339942','Amisulprida','Amisulpride','Amisulprida',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339943','Sultoprida','Sultopride','Sultoprida',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339944','Alizaprida','Alizapride','Alizaprida',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339945','Buflomedil e seus derivados;sais destes prod','Buflomedil its derivatives and its salts','Buflomedil y sus derivados; sales de estos productos',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339946','Maleato de enalapril','Enalapril maleate','Maleato de enalapril',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339947','Ketorolac trometamina','Ketorolac tromethamine salt','Ketorolac trometamina',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339949','Outs.compostos heterocicl.cont.ciclo pirrol','Other heterocyclic compounds cont.pyrrole ring','Los dem.compuestos heterocícl.que cont. ciclo pirrol',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339951','Benomil','Benomyl','Benomil',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339952','Oxifendazol','Oxfendazole','Oxfendazol',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339953','Albendazol e seu sulfóxido','Albendazole and albendazole sulphoxide','Albendazol y su sulfóxido',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339954','Mebendazol','Mebendazole','Mebendazol',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339955','Flubendazol','Flubendazole','Flubendazol',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339956','Fembendazol','Fembendazole','Fembendazol',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339959','Outs.compostos heterocicl.cont.ciclo imidazol','Oth.heterocyclic compounds cont.imidazole ring','Los dem.compuestos heterocícl.que cont.ciclo imidazol',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339961','Triadimenol','Triadimenol','Triadimenol',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339962','Triadimefon','Triadimefon','Triadimefon',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339963','Triazofos (fósforotioato de o, o-dietila o-(1','Triazofos(o, o-diethyl o-(1-pheny, etc.)phosphorothioate','Triazofós (fosforotioato de o, o-dietilo o-(1',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339969','Outs.compostos heterocicl.cont.ciclo triazol','Oth.heterocyclic compounds cont.triazol ring','Los dem.compuestos heterocícl.que cont.ciclo triazol',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339991','Azinfos etílico','Azinfos-ethyl','Azinfós etílico',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339992','Acido nalidixico','Nalidixic acid','Ácido nalidíxico',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339993','Clofazimina','Clofazimine','Clofazimina',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339995','Metilssulfato de amezínio','Amezinium methyl sulphate','Metilsulfato de amezinio',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339996','Hidrazida maleica e seus sais','Maleic hydrazide and its salts','Hidrazida maleica y sus sales',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29339999','Outs.compostos heterocicl.heteroatomo nitrog.','Oth.heterocyclic compounds with nitrogen hetero-atom','Los dem.compuestos heterocícl.heteroátomo de nitrógeno',10,'29','2933','293399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29341010','Fentiazac','Fentiazac','Fentiazac',10,'29','2934','293410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29341020','Cloridrato de tiazolidina','Thiazolidine hydrochloride','Clorhidrato de tiazolidina',10,'29','2934','293410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29341030','Tiabendazol','Thiabendizole','Tiabendazol',10,'29','2934','293410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29341090','Outs.compostos heterocicl.c/1 ciclo tiazol n/condensado','Ot.heterocyclic comp.with 1 thiazole ring n/ condensed','Los dem.comp.heterocícl.c/1 ciclo tiazol s/condensar',10,'29','2934','293410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29342010','2-mercaptobenzotiazol e seus sais','2-mercaptobenzothiazole and its salts','2-mercaptobenzotiazol y sus sales',10,'29','2934','293420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29342020','2, 2''-ditiobis(benzotiazol) (dissulfeto de benzotiazila)','2, 2''-dithiobis(benzothiazole)(benzothiazole disulphide)','2, 2''-ditiobis(benzotiazol) (disulfuro de benzotiazilo)',10,'29','2934','293420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29342031','2-(terbutilaminotio)benzotiazol (n-terbutil-benzot.etc.','3-(tert-butylaminothio)benzothiaz.(n-tert-butylbenz.etc','2-(terbutilaminotio)benzotiazol (n-terbutil-benzot.etc)',10,'29','2934','293420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29342032','2-(cicloexilaminotio)benzotiazol(n-cicloexil-benzot.etc','2-(cyclohexylaminothio)benzothiaz.(n-cyclohexylbenz.etc','2(ciclohexilaminotio)benzotiazol(n-ciclohexil-benzot.',10,'29','2934','293420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29342033','2-(dicicloexilaminotio)benzotiazol (n, n-dicicloexil-etc','2-(dicyclohexylaminothio)benzothiaz.(n, n-dicyclohex.etc','2-(diciclohexilaminotio)benzotiazol (n, n-diciclohexil-',10,'29','2934','293420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29342034','2-(4-morfonilitio)benzotiazol (n-oxidietileno-benz.etc.','2-(4-morpholinylthio)benzothiaz.(n-oxydiethyleneben.etc','2-(4-morfoliniltio)benzotiazol (n-oxidietileno-benz.etc',10,'29','2934','293420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29342039','Outros benzotiazois-sulfenamidas','Other sulphenamide benzothiazole','Los dem.benzotiazoles-sulfenamidas',10,'29','2934','293420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29342040','2-(tiocianometiltio)benzotiazol (tcmtb)','2-(thiocyanomethylthio) benzothiazole (tcmtb)','2-(tiocianometiltio)benzotiazol (tcmtb)',10,'29','2934','293420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29342090','Outs.compostos heterocíclicos com ciclos de benzotiazol','Oth.heterocyclic compounds with benzothiazole ring','Los dem.compuest.heterocíclicos c/ciclos de benzotiazol',10,'29','2934','293420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29343010','Maleato de metotrimeprazina (maleato de levomepromazina','Methotrimeprazine maleate (levomepromazine maleate)','Maleato de metotrimeprazina(maleato de levomepromazina)',10,'29','2934','293430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29343020','Enantato de flufenazina','Fluphenazine enanthate','Enantato de flufenazina',10,'29','2934','293430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29343030','Prometazina','Promethazine','Prometazina',10,'29','2934','293430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29343090','Outs.compostos heterocicl.c/estrut.de ciclo fenotiazina','Oth.heterocyclic comp.with struct.phenotiazine ring','Los dem.comp.heterocícl.c/estrut.de ciclo fenotiazina',10,'29','2934','293430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349011','Morfolina e seus sais','Morpholine and its salts','Morfolina y sus sales',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349012','Pirenoxina sódica (catalino sódico)','Pirenoxine sodium salt (catalin sodium salt)','Pirenoxina sódica (catalín sódico)',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349013','Nimorazol','Nimorazol','Nimorazol',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349014','Anidrido isatoico (2h-3, 1-benzoxazina-2, 4-(1h)-diona)','Isatoic anhydride (2h-3, 1-benzoxazine-2, 4-(1h)-dione)','Anhídrido isatoico (2h-3, 1-benzoxazina-2, 4-(1h)-diona)',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349015','4, 4''-ditiodimorfolina','4, 4''-dithiodimorpholine','4, 4''-ditiodimorfolina',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349016','Ketazolam','Ketazolam','Ketazolam',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349017','Dextromoramida (d-moramida) e seus sais','Dextromoramide (d-moramide) and its salts','Dextromoramida (d-moramida) y sus sales',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349018','Fendimetrazina ("phendimetrazine") e seus sais','Phendimetrazine and its salts','Fendimetrazina ("phendimetrazine") y sus sales',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349019','Outs.compostos heterocíclicos com 1 ciclo oxazina, etc.','Oth.heterocyclic compounds with 1 oxazine ring, etc.','Los dem.compuestos heterocíclicos c/1 ciclo oxazina, etc',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349021','Cloxazolam','Cloxazolam and its salts','Cloxazolam',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349022','Zidovudina (azt)','Zidovudine (azt)','Zidovudina (azt)',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349023','Timidina','Thymidine','Timidina',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349024','Furazolidona','Furazolidone','Furazolidona',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349025','Citarabina','Cytarabine','Citarabina',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349026','Oxadiazona','Oxadiazon','Oxadiazon',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349027','Haloxazolam','Haloxazolam','Haloxazolam',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349028','Oxazolam','Oxazolam','Oxazolam',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349029','Outs.compostos heterocicl.c/3 heteroatom.nitrog.e oxig.','Oth.heteroc.comp.nitrogen and oxygen with 3 hetero-atom','Los dem.comp.heterocícl.c/3 heteroátom.nitróg.y oxig.',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349031','Cetoconazol','Ketoconazole','Ketoconazol',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349032','Cloridrato de prazosina','Prazosin hydrochloride','Clorhidrato de prazosina',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349033','Talniflumato','Talniflumate','Talniflumato',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349034','Acido nucleico e seus sais','Nucleic acids and their salts','Ácido nucleico y sus sales',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349035','Aminorex e seus sais','Aminorex and its salts','Aminorex y sus sales',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349036','Pemolina e seus sais','Pemoline and its salts','Pemolina y sus sales',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349039','Outs.compostos heterocicl.c/heteroatomos de nitrog.oxig','Oth.heteroc.comp.nitrogen and oxygen with hetero-atom','Los dem.comp.heterocícl.c/heteroátomos de nitróg.oxig',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349041','Tiofeno','Thiophene','Tiofeno',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349042','Acido 6-aminopenicilanico','6-aminopennicillanic acid','Ácido 6-aminopenicilánico',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349043','Acido 7-aminocefalosporanico','7-aminocephalsporanic acid','Ácido 7-aminocefalosporánico',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349044','Acido 7-aminodesacetoxifalosporanico','7-aminodesacetoxycephalosporanic acid','Ácido 7-aminodesacetoxicefalosporánico',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349045','Clormezanona','Chlormezanone','Clormezanona',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349046','9-(n-metil-4-piperidinilideno)tioxanteno','9-(n-methyl-4-piperidinylidene)thioxanthene','9-(n-metil-4-piperidiniliden) tioxanteno',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349047','Sufentanil e seus sais','Suphentanil and its salts','Sufentanil y sus sales',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349049','Outs.compost.heteroc.heteroatom<=2 enxofre, incl.nitrog.','Oth.heteroc.comp.hetero-atom<=2 sulphur, incl.nitrogen','Los dem.comp.heteroc.heteroátom<=2 azufre, incl.nitróg.',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349051','Tebutiuron','Tebuthiuron','Tebutiurón',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349052','Tetramisol','Tetramisole','Tetramisol',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349053','Levamisol e seus sais','Levamisole and its salts','Levamisol y sus sales',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349054','Tioconazol','Tioconazole','Tioconazol',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349055','Clotiazepam','Clotiazepam','Clotiazepam',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349059','Outros compost.heterocicl.c/3 heteroatom.enxofre e nitr','Oth.heter.comp.with 3 sulphur and nitrogen hetero-atom','Los dem.comp.heterocícl.c/3 heteroátom.azufre y nitr.',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349061','Cloridrato de tizanidina','Tizanidine hydrochloride','Clorhidrato de tizanidina',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349062','Brotizolam','Brotizolam','Brotizolam',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349069','Outs.compostos heteroc.c/heteroatom.enxofre incl.nitrog','Oth.heter.comp.with hetero-atom sulphur incl.nitrogen','Los dem.comp.heteroc.c/heteroátom.azufre incl.nitrog.',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349071','Fenmetrazina ("phenmetrazine") e seus sais','Phenmetrazine and its salts','Fenmetrazina ("phenmetrazine") y sus sales',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349072','Mesocarb (3(alfa-metilfenetil)-n-(fenilcarbamoil) etc.','Mesocarb(3(alpha-methylphenethyl)-n-(phenylcarbamoil)et','Mesocarb (3(alfa-metilfenetil)-n-(fenilcarbamoil) etc.',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349073','Estavudina','Estavudine','Estavudina',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349091','Timolol','Timolol','Timolol',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349092','Maleato acido de timolol','Timolol acid maleate','Maleato ácido de timolol',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349093','Lamivudina','Lamivudine','Lamivudina',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349099','Outros compostos heterocíclicos','Other heterocyclic compounds','Los demás compuestos heterocíclicos',10,'29','2934','293490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349111','Aminorex e seus sais','Aminorex and its salts','Aminorex y sus sales',10,'29','2934','293491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349112','Brotizolan e seus sais','Brotizolam and its salts','Brotizolam y sus sales',10,'29','2934','293491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349121','Clotiazepam','Clotiazepam','Clotiazepam',10,'29','2934','293491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349122','Cloxazolam','Cloxazolam','Cloxazolam',10,'29','2934','293491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349123','Dextromoramida','Dextromoramide','Dextromoramida',10,'29','2934','293491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349129','Sais de clotiazepam, cloxazolam, dextromoramida','Salts of clotiazepam, cloxazolam, dextromoramide','Sales de clotiazepam,  cloxazolam,  dextromoramida',10,'29','2934','293491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349131','Fendimetrazina e seus sais','Phendimetrazine and its salts','Fendimetrazina y sus sales',10,'29','2934','293491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349132','Fenmetrazina e seus sais','Phendimetrazine and its salts','Fenmetrazina y sus sales',10,'29','2934','293491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349133','Haloxazolam e seus sais','Haloxazolam and its salts','Haloxazolam y sus sales',10,'29','2934','293491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349141','Ketazolam','Ketazolam','Ketazolam',10,'29','2934','293491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349142','Mesocarb','Mesocarb','Mesocarb',10,'29','2934','293491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349149','Sais do ketazolam e mesocarb','Salts of ketazolam and mesocarb','Sales del ketazolam y mesocarb',10,'29','2934','293491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349150','Oxazolam e seus sais','Oxazolam and its salts','Oxazolam y sus sales',10,'29','2934','293491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349160','Pemolina e seus sais','Pemoline and its salts','Pemolina y sus sales',10,'29','2934','293491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349170','Sufentanila e seus sais','Sufentanil and its salts','Sufentanil y sus sales',10,'29','2934','293491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349911','Morfolina e seus sais','Morpholine and its salts','Morfolina y sus sales',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349912','Pirenoxina sódica (catalino sódico)','Pirenoxine sodium salt (catalin sodium)','Pirenoxina sódica (catalín sódico)',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349913','Nimorazol','Nimorazol','Nimorazol',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349914','Anidrido isatoico (2h-3, 1-benzoxazina-2, 4-(1h','Isatoic anhydride (2h-3, 1-benzoxazine-2, 4-(1h)-dione)','Anhídrido isatoico (2h-3, 1-benzoxazina-2, 4-(1h',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349915','4, 4''-ditiodimorfolina','4, 4''-dithiodimorpholine','4, 4''-ditiodimorfolina',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349919','Outs.compostos heterocicl.cont.ciclo oxazina','Other heterocyclic compounds','Los dem.compuestos heterocícl.q.cont.ciclo oxazina',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349922','Zidovudina (azt)','Zidovudine (azt)','Zidovudina (azt)',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349923','Timidina','Thymidine','Timidina',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349924','Furazolidona','Furazolidone','Furazolidona',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349925','Citarabina','Cytarabine','Citarabina',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349926','Oxadiazona','Oxadiazon','Oxadiazon',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349927','Estavudina','Stavudine','Estavudina',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349929','Outs.compostos heterocicl.c/3 heteroat.nitrog','Oth.heterocyclic compounds with 3 nitrogen hetero-atom','Los dem.comp.heterocícl.c/3 heteroát.de nitrógeno',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349931','Cetoconazol','Ketoconazole','Ketoconazol',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349932','Cloridrato de prazosina','Prazosin hydrochloride','Clorhidrato de prazosina',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349933','Talniflumato','Talniflumate','Talniflumato',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349934','Acidos nucleicos e seus sais','Nucleic acids and their salts','Ácidos nucleicos y sus sales',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349935','Propiconazol','Propiconazole','Propiconazol',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349939','Outs.compostos heterocicl.c/heteroat.nitrog.','Oth.heterocyclic compounds with nitrogen hetero-atom','Los dem.compuestos heterocícl.c/heteroát.de nitrógeno',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349941','Tiofeno','Thiophene','Tiofeno',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349942','Acido 6-aminopenicilanico','6-aminopennicillanic acid','Ácido 6-aminopenicilánico',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349943','Acido 7-aminocefalosporanico','7-aminocephalsporanic acid','Ácido 7-aminocefalosporánico',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349944','Acido 7-aminodesacetoxicefalosporanico','7-aminodesacetoxycephalosporanic acid','Ácido 7-aminodesacetoxicefalosporánico',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349945','Clormezanona','Chlormezanone','Clormezanona',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349946','9-(n-metil-4-piperidinilideno)tioxanteno','9-(n-methyl-4-piperidinylidene)thioxanthene','9-(n-metil-4-piperidiniliden)tioxanteno',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349949','Outs.compostos heterocicl.c/heteroat.enxofre','Oth.heterocyclic compounds with sulfur hetero-atom','Los dem.compuestos heterocícl. c/heteroát.azufre',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349951','Tebutiuron','Tebuthiuron','Tebutiurón',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349952','Tetramisol','Tetramisole','Tetramisol',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349953','Levamisol e seus sais','Levamisole and its salts','Levamisol y sus sales',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349954','Tioconazol','Tioconazole','Tioconazol',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349959','Outs.compostos heterocicl.c/3 heteroat.enxofr','Oth.heterocyclic comp.with 3 sulfur hetero-atom','Los dem.compuestos heterocícl.c/3 heteroát.de azufre',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349961','Cloridrato de tizanidina','Tizanidine hydrochloride','Clorhidrato de tizanidina',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349969','Outs.compostos heterocicl.c/heteroat.enxofre','Oth.heterocyclic compounds with sulfur hetero-atom','Los dem.compuestos heterocícl.c/heteroát.de azufre',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349991','Timolol','Timolol','Timolol',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349992','Maleato ácido de timolol','Timolol acid maleate','Maleato ácido de timolol',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349993','Lamivudina','Lamivudine','Lamivudina',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29349999','Outros compostos heterocíclicos','Other heterocyclic compounds','Los demás compuestos heterocíclicos',10,'29','2934','293499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350011','Sulfadiazina e seu sal sódico','Sulfadiazine and its sodium salt','Sulfadiazina y su sal sódica',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350012','Clortalidona','Chlorthalidone','Clortalidona',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350013','Sulpirida','Sulpiride','Sulpirida',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350014','Veraliprida','Veralipride','Veraliprida',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350015','Sulfametazina (4, 6-dimetil-2sulfanilamidopirimidina)etc','Sulfamethazine(4, 6-dimethyl-2-sulphanilamidopyram.)etc','Sulfametazina (4, 6-dimetil-2sulfanilamidopirimidina)etc',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350019','Outras sulfonamidas c/heterociclo(s) c/heteroatomo nitr','Oth.sulphonamides with heter.with nitrogen hetero-atom','Las dem.sulfonamidas c/heterociclo(s) c/heteroátom.nitr',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350021','Furosemida','Furosemide','Furosemida',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350022','Ftalilsulfatiazol','Phthalylsulfathiazole','Ftalilsulfatiasol',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350023','Piroxicam','Piroxicam','Piroxicam',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350024','Tenoxicam','Tenoxicam','Tenoxicam',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350025','Sulfametoxazol','Sulfamethoxazole','Sulfametoxazol',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350029','Outras sulfonamidas com out(s).heterociclo(s)','Other sulphonamides with other heterocyclics','Las demás sulfonamidas con otr(s).heterociclo(s)',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350091','Cloramina-b e cloramina-t','Chloramine-b and chloramine-t','Cloramina-b y cloramina-t',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350092','Gliburida','Gliburide','Gliburida',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350093','Toluenossulfonamidas','Toluenesulphonamides','Toluensulfonamidas',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350094','Nimesulida','Nimesulide','Nimesulida',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350095','Bumetanida','Bumetanide','Bumetanida',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350096','Sulfaguanidina','Sulfaguanidine','Sulfaguanidina',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350097','Sulfluramida','Sulfluramid','Sulfluramida',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29350099','Outras sulfonamidas','Other sulphonamides','Las demás sulfonamidas',10,'29','2935','293500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29361000','Provitaminas, não misturadas','Provitamins, unmixed','Provitaminas,  sin mezclar',10,'29','2936','293610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362111','Vitamina a1 álcool (retinol)','Vitamin a1 alcohol (retinol)','Vitamina a1 alcohol (retinol)',10,'29','2936','293621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362112','Acetato de vitamina a1 álcool','Acetate of vitamin a1 alcohol','Acetato de vitamina a1 alcohol',10,'29','2936','293621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362113','Palmitato de vitamina a1 álcool','Palmitate of vitamin a1 alcohol','Palmitato de vitamina a1 alcohol',10,'29','2936','293621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362119','Outros derivados da vitamina a1 álcool, não misturados','Oth.derivatives of vitamin a1 alcohol, unmixed','Los dem.derivados de la vitamina a1 alcohol, sin mezclar',10,'29','2936','293621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362190','Outras vitaminas a e seus derivados, não misturados','Other vitamin a and their derivatives, unmixed','Las dem.vitaminas a y sus derivados, sin mezclar',10,'29','2936','293621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362210','Cloridrato de vitamina b1 (tiamina), não misturado','Vitamin b1 hydrochloride(thiamine), unmixed','Clorhidrato de vitamina b1 (tiamina),  sin mezclar',10,'29','2936','293622');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362220','Mononitrato de vitamina b1 (tiamina), não misturado','Vitamin b1 mononitrate (thiamine), unmixed','Mononitrato de vitamina b1 (tiamina),  sin mezclar',10,'29','2936','293622');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362290','Outras vitaminas b1 e seus derivados, não misturados','Other vitamin b1 and its derivatives, unmixed','Las dem.vitaminas b1 y sus derivados,  sin mezclar',10,'29','2936','293622');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362310','Vitamina b2 (riboflavina), não misturada','Vitamin b2 (riboflavine), unmixed','Vitamina b2 (riboflavina), sin mezclar',10,'29','2936','293623');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362320','5''-fosfato sódico de vitamina b2 não misturado','5''-phosphate sodium of vitamin b2, unmixed','5''-fosfato sódico de vitamina b2 sin mezclar',10,'29','2936','293623');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362390','Outros derivados da vitamina b2, não misturados','Other derivatives of vitamin b2, unmixed','Los demás derivados de la vitamina b2,  sin mezclar',10,'29','2936','293623');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362410','D-pantotenato de cálcio, não misturado','Calcium d-pantothenate, unmixed','D-pantotenato de calcio,  sin mezclar',10,'29','2936','293624');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362490','Outros acidos d- ou dl-pantotenico (vitam.b3/b5), derivs','Ot.d-or dl-pantothenic acid(vitamin b3/vitamin b5), der','Los dem.ácidos d- o dl-pantoténico(vitam.b3/b5), derivs.',10,'29','2936','293624');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362510','Vitamina b6, não misturada','Vitamin b6, unmixed','Vitamina b6,  sin mezclar',10,'29','2936','293625');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362520','Cloridrato de piridoxina, não misturado','Pyridoxine hydrochloride, unmixed','Clorhidrato de piridoxina, sin mezclar',10,'29','2936','293625');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362590','Outros derivados da vitamina b6, não misturados','Other derivatives of vitamin b6, unmixed','Los dem.derivados de la vitamina b6, sin mezclar',10,'29','2936','293625');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362610','Vitamina b12 (cianocobalamina), não misturada','Vitamin b12 (cyanocobalamin), unmixed','Vitamina b12 (cianocobalamina), sin mezclar',10,'29','2936','293626');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362620','Cobamamida não misturada','Cobamamide, unmixed','Cobamamida sin mezclar',10,'29','2936','293626');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362630','Hidroxocobalamina e seus sais, não misturados','Hydroxocobalamin and its salts, unmixed','Hidroxocobalamina y sus sales, sin mezclar',10,'29','2936','293626');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362690','Outros derivados da vitamina b12, não misturados','Other derivatives of vitamin b12, unmixed','Los demás derivados de la vitamina b12, sin mezclar',10,'29','2936','293626');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362710','Vitamina c (acido l- ou dl-ascorbico), não misturada','Vitamin c (l- or dl-ascorbic acid), unmixed','Vitamina c (ácido l- ou dl-ascórbico), sin mezclar',10,'29','2936','293627');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362720','Ascorbato de sódio, não misturado','Sodium ascorbate, unmixed','Ascorbato de sodio,  sin mezclar',10,'29','2936','293627');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362790','Outros derivados da vitamina c, não misturados','Other derivatives of vitamin c, unmixed','Los demás derivados de la vitamina c, sin mezclar',10,'29','2936','293627');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362811','D- ou dl-alfa-tocoferol, não misturados','L- or dl-a-tocopherol, unmixed','D- o dl-alfa-tocoferol, sin mezclar',10,'29','2936','293628');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362812','Acetato de d- ou dl-alfa-tocoferol, não misturados','D- or dl-a-tocopherol acetate, unmixed','Acetato de d- o dl-alfa-tocoferol, sin mezclar',10,'29','2936','293628');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362819','Outs.derivados de d- ou dl-alfa-tocoferol, n/misturados','Other d- or dl-alpha-tocopherol derivatives, unmixed','Los dem.derivados de d- o dl-alfa-tocoferol, sin mezclar',10,'29','2936','293628');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362890','Outras vitaminas e seus derivados, não misturados','Other vitamin and its derivatives, unmixed','Las demás vitaminas y sus derivados, sin mezclar',10,'29','2936','293628');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362911','Vitamina b9 (acido folico) e seus sais, não misturados','Vitamin b9 (folic acid) and its salts, unmixed','Vitamina b9 (ácido fólico) y sus sales, sin mezclar',10,'29','2936','293629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362919','Outros derivados da vitamina b9, não misturados','Other derivatives of vitamin b9, unmixed','Los demás derivados de la vitamina b9, sin mezclar',10,'29','2936','293629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362921','Vitamina d3 (colecalciferol), não misturada','Vitamin d3 (colecalciferol), unmixed','Vitamina d3 (colecalciferol), sin mezclar',10,'29','2936','293629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362929','Outras vitaminas d e seus derivados, não misturados','Other vitamins d and their derivatives, unmixed','Las demás vitaminas d y sus derivados, sin mezclar',10,'29','2936','293629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362931','Vitamina h (biotina), não misturada','Vitamin h (biotin), unmixed','Vitamina h (biotina), sin mezclar',10,'29','2936','293629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362939','Outros derivados da vitamina H, não misturados','Others drivatives of vitamin H, unmixed','Los demás derivados de la vitamina H, sin mezclar',10,'29','2936','293629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362940','Vitaminas K e seus derivados, não misturados','Vitamins K and their derivatives, unmixed','Vitaminas K y sus derivados,  sin mezclar',10,'29','2936','293629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362951','Ácido nicotínico, não misturado','Nicotinic acid, unmixed','Ácido nicotínico, sin mezclar',10,'29','2936','293629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362952','Nicotinamida não misturada','Nicotinic unmixed','Nicotinamida sin mezclar',10,'29','2936','293629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362953','Nicotinato de sódio, não misturado','Sodium nicotinate, unmixed','Nicotinato de sodio, sin mezclar',10,'29','2936','293629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362959','Outros derivados do ácido nicotínico, não misturados','Sodium nicotinate, unmixed','Los dem.derivados del ácido nicotínico, sin mezclar',10,'29','2936','293629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29362990','Outras vitaminas e seus derivados, não misturados','Other vitamins and their derivatives, unmixed','Las dem.vitaminas y sus derivados, sin mezclar',10,'29','2936','293629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29369000','Provitaminas e vitaminas, misturadas','Provitamins and vitamins, unmixed','Provitaminas y vitaminas, mezcladas',10,'29','2936','293690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29371010','Acth (corticotrofina)','Acth (corticotrophin)','Acth (corticotrofina)',10,'29','2937','293710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29371020','Hcg (gonadotrofina coriônica)','Hgc (chorionic gonadotrophin)','Hcg (gonadotrofina coriónica)',10,'29','2937','293710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29371030','Pmsg (gonadotrofina sérica)','Pmsg (serum gonadotrophin)','Pmsg (gonadotrofina sérica)',10,'29','2937','293710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29371040','Menotropinas','Menotrophins','Menotropinas',10,'29','2937','293710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29371090','Outs.hormônios do lobo anterior da hipofise, etc.derivs.','Oth.horm.of the wolf before of the hypophysis, etc deriv','Los dem.hormonas del lóbulo ant.de hipófisis, etc.deriv',10,'29','2937','293710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29371100','Somatotropina, seus derivados e analogos es','Somatropin, its derivatives and structural analogues','Somatotropina,  sus derivados y análogos estructurales',10,'29','2937','293711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29371200','Insulina e seus sais','Insulin and its salts','Insulina y sus sales',10,'29','2937','293712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29371910','Acth (corticotropina)','Acth (corticotrophin)','Acth (corticotropina)',10,'29','2937','293719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29371920','Hcg (gonadotropina corionica)','Hgc (chorionic gonadotrophin)','Hcg (gonadotropina coriónica)',10,'29','2937','293719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29371930','Pmsg (gonadotropina serica)','Pmsg (serum gonadotrophin)','Pmsg (gonadotropina sérica)',10,'29','2937','293719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29371940','Menotropinas','Menotrophins','Menotropinas',10,'29','2937','293719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29371950','Oxitocina','Oxytocin','Oxitocina',10,'29','2937','293719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29371990','Outs.hormônios polipeptideos, proteicos, etc.','Other hormones polypeptide, proteins, etc','Las demás hormonas polipéptidas,  proteicas,  etc',10,'29','2937','293719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372110','Cortisona','Cortisone','Cortisona',10,'29','2937','293721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372120','Hidrocortisona','Hydrocortisone','Hidrocortisona',10,'29','2937','293721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372130','Prednisona (deidrocortisona)','Prednisone (dehydrocortisone)','Prednisona (dehidrocortisona)',10,'29','2937','293721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372140','Prednisolona (deidroidrocortisona)','Prednisone (dehydrohydrocortisone)','Prednisolona (dehidrohidrocortisona)',10,'29','2937','293721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372210','Dexametasona e seus acetatos','Dexamethasone and its acetates','Dexametasona y sus acetatos',10,'29','2937','293722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372221','Acetonida da triancinolona','Triamcinolone acetonide','Acetónido de triamcinolona',10,'29','2937','293722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372229','Triancinolona e outros derivados','Triamcinolone and other derivatives','Triamcinolona y otros derivados',10,'29','2937','293722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372231','Valerato de diflucortolona','Diflucortolone valerate','Valerato de diflucortolona',10,'29','2937','293722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372239','Fluorcortolona e outros derivados','Flucortolone and its derivatives','Fluorcortolona y demás derivados',10,'29','2937','293722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372290','Outs.derivs.halogen.dos hormônios corticossupra-renais','Other halogenated deriv.corticossupra-renal hormones','Los dem.derivs.halogen.de hormonas corticosuprarrenales',10,'29','2937','293722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372310','Medroxiprogesterona e seus derivados','Medroxyprogesterone and its derivatives','Medroxiprogesterona y sus derivados',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372321','L-norgestrel (levonorgestrel)','L-norgestrel (levonorgestrel)','L-norgestrel (levonorgestrel)',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372322','Dl-norgestrel','Dl-norgestrel','Dl-norgestrel',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372329','Norgestrel e outs.derivados deste produto','L-norgestrel and others derivatives','Norgestrel y demás derivados de este producto',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372331','Estriol e seu succinato','Oestriol and its succinate','Estriol y su succinato',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372339','Derivados e sais do estriol','Derivatives and salts of oestriol','Derivados y sales del estriol',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372341','Hemissuccinato de estradiol','Oestradiol hemisuccinate','Hemisuccinato de estradiol',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372342','Fempropionato de estradiol (17-(3-fenilpropio','Oestradiol fenpropionate(oestradiol 17-(3-phenylpropion','Fempropionato de estradiol (17-(3-fenilpropionato)',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372349','Estradiol, outros ésteres, sais e derivados','Oestradiol, other esteres, salts and derivatives','Estradiol, demás ésteres,  sales y derivados',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372351','Alilestrenol','Allyloestrenol','Alilestrenol',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372359','Ésteres e sais de alilestrenol','Esters and salts of allyloestrenol','Ésteres y sales de alilestrenol',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372360','Desogestrel','Desogestrel','Desogestrel',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372370','Linestrenol','Lynestrenol','Linestrenol',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372391','Acetato de etinodiol','Etynodiol acetate','Acetato de etinodiol',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372392','Gestodeno','Gestodene','Gestodeno',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372399','Outros estrogênios e progestogenios','Other oestrogens and progestogens','Los demás estrógenos y progestógenos',10,'29','2937','293723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372910','Metiliprednisolona e seus derivados','Methylprednisolone and its derivatives','Metilprednisolona y sus derivados',10,'29','2937','293729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372920','21-succinato sódico de hidrocortisona','Hydrocortisone sodium 21-succinate','21-succinato sódico de hidrocortisona',10,'29','2937','293729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372931','Acetato de ciproterona','Cyproterone acetate','Acetato de ciproterona',10,'29','2937','293729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372939','Ciproterona e outs.derivados deste produto','Cyproterone and other its derivatives','Ciproterona y demás derivados de este producto',10,'29','2937','293729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372940','Mesterolona e seus derivados','Mesterolone and its derivatives','Mesterolona y sus derivados',10,'29','2937','293729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372950','Espironolactona','Spironolactone','Espironolactona',10,'29','2937','293729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372960','Deflazacorte','Deflazacort','Deflazacorte',10,'29','2937','293729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29372990','Outros hormônios corticossupra-renais e seus derivados','Oth.hormones corticossupra-renal and its derivatives','Las demás hormonas corticosuprarrenales y sus derivados',10,'29','2937','293729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29373100','Epinefrina','Epinephrine','Epinefrina',10,'29','2937','293731');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29373900','Outros','Outros','Outros',10,'29','2937','293739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29373911','Levodopa','Levodopa','Levodopa',10,'29','2937','293739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29373912','Metildopa','Methyldopa','Metildopa',10,'29','2937','293739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29373919','Tirosina e outros derivados e sais deste produto','Oth.and tyrosine oth.derivatives and its salts','Tirosina y demás derivados y sales de este producto',10,'29','2937','293739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29373990','Outros hormônios de catecolamina','Other hormones catecholamine','Las demás hormonas de catecolamina',10,'29','2937','293739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29374010','Levotiroxina sódica','Levothyroxine sodium','Levotiroxina sódica',10,'29','2937','293740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29374020','Liotironina sódica','Liothyronine sodium','Liotironina sódica',10,'29','2937','293740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29374090','Outros derivados de aminoácidos','Other derivatives of amino-acid','Los demás derivados de los aminoácidos',10,'29','2937','293740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29375000','Prostaglandinas, tromboxanas e leucotrienos','Prostaglandins, thromboxanes and leukotrienes','Prostaglandinas,  tromboxanos y leucotrienos',10,'29','2937','293750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379010','Tiratricol (triac) e seu sal sódico','Tiratricol (triac) and its sodium salt','Tiratricol (triac) y su sal sódica',10,'29','2937','293790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379030','Levotiroxina sodica','Sodium levothyroxine','Levotiroxina sódica',10,'29','2937','293790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379040','Liotironina sodica','Sodium liothyronine','Liotironina sódica',10,'29','2937','293790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379090','Outros hormônios, prostaglandinas, etc.','Other hormones, prostaglandins, etc.','Las demás hormonas,  prostaglandinas,  etc.',10,'29','2937','293790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379100','Insulina e seus sais','Insulin and its salts','Insulina y sus sales',10,'29','2937','293791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379210','Medroxiprogesterona e seus derivados','Medroxyprogesterone and its derivatives','Medroxiprogesterona y sus derivados',10,'29','2937','293792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379221','L-norgestrel (levonorgestrel)','Levonorgestrel','L-norgestrel (levonorgestrel)',10,'29','2937','293792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379222','Dl-norgestrel','Norgestrel','Dl-norgestrel',10,'29','2937','293792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379229','Norgestrel e outros derivados','Norgestrel and other derivatives','Norgestrel y demás derivados',10,'29','2937','293792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379231','Estriol e seu succinato','Estriol succinate','Estriol y su succinato',10,'29','2937','293792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379239','Outros ésteres e sais do estriol','Other esters and estriol salts','Los demás ésteres y sales del estriol',10,'29','2937','293792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379241','Hemissuccinato de estradiol','Estradiol hemisuccinate','Hemisuccinato de estradiol',10,'29','2937','293792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379242','Fempropionato de estradiol (17-(3-fenilpropionato)','Estradiol fempropionate (17-(3-phenylpropionate)','Fempropionato de estradiol (17-(3-fenilpropionato)',10,'29','2937','293792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379249','Estradiol e outros ésteres, sais e derivados','Estradiol and other esters, salts and derivatives','Estradiol y demás ésteres,  sales y derivados',10,'29','2937','293792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379251','Alilestrenol','Allyloestrenol','Alilestrenol',10,'29','2937','293792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379259','Ésteres e sais do alilestrenol','Esters and salts of allyloestrenol','Ésteres y sales del alilestrenol',10,'29','2937','293792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379260','Desogestrel','Desogestrel','Desogestrel',10,'29','2937','293792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379270','Linestrenol','Lynestrenol','Linestrenol',10,'29','2937','293792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379291','Acetato de etinodiol','Etynodiol acetate','Acetato de etinodiol',10,'29','2937','293792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379299','Outros estrogênios e progestogênios','Other estrogens and progestogens','Los demás estrogénos y progestógenos',10,'29','2937','293792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379911','Acetato de ciproterona','Cyproterone acetate','Acetato de ciproterona',10,'29','2937','293799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379919','Ciproterona e outros derivados','Cyproterona and other derivatives','Ciproterona y demás derivados',10,'29','2937','293799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379920','Mesterolona e seus derivados','Mesterolone and its derivatives','Mesterolona y sus derivados',10,'29','2937','293799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379930','Oxitocina','Oxytocin','Oxitocina',10,'29','2937','293799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379940','Levotiroxina sódica','Levothyroxine sodium','Levotiroxina sódica',10,'29','2937','293799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379950','Liotironina sódica','Liothyronine sodium','Liotironina sódica',10,'29','2937','293799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29379990','Outs.hormônios, derivs.e esteroides util.como hormônios','Oth.hormones, derivat.and steroids used hormones','Las dem.hormonas, derivs.y esteroides util.como hormonas',10,'29','2937','293799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29381000','Rutosidio (rutina) e seus derivados','Rutoside (rutin) and its derivatives','Rutosido (rutina) y sus derivados',10,'29','2938','293810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29389010','Deslanosídeo','Deslanoside','Deslanósido',10,'29','2938','293890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29389020','Esteviosídeo','Stevioside','Esteviósido',10,'29','2938','293890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29389090','Outs.heterosideos, seus sais, éteres, ésteres e derivados','Oth.heterosides, its salts, ethers, esters and derivatives','Los dem.heterósidos, sus sales, éteres, ésteres y derivad.',10,'29','2938','293890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391011','Cloridrato e sulfato de morfina','Hydrochloride and morphine sulphate','Clorhidrato y  sulfato de morfina',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391012','Codeína e seus sais','Codeine and its salts','Codeína y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391013','Heroína (diacetilmorfina) e seus sais','Heroine (diacetylmorphine) and its salts','Heroína (diacetilmorfina) y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391014','Hidrocodona ("hydrocodone") e seus sais','Hydrocodone and its salts','Hidrocodona ("hydrocodone") y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391015','Folcodina ("pholcodine") e seus sais','Pholcodine and its salts','Folcodina ("pholcodine") y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391016','Morfina','Morphine','Morfina',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391017','Diidrocodeina e seus sais','Dihydrocodeine and its salts','Dihidrocodeína y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391018','Oxicodona ("oxycodone") e seus sais','Oxycodone and its salts','Oxicodona ("oxycodone") y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391019','Etilmorfina ("ethylmorphine") e seus sais','Ethylmorphine and its salts','Etilmorfina ("ethylmorphine") y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391021','Nicomorfina e seus sais','Nicomorphine and its salts','Nicomorfina y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391022','Oximorfona ("oxymorphone") e seus sais','Oxymorphone and its salts','Oximorfona ("oxymorphone") y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391023','Folcodina ("pholcodine") e seus sais','Pholcodine and its salts','Folcodina ("pholcodine") y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391024','Tebacona ("thebacon") e seus sais','Thebacon and its salts','Tebacona ("thebacon") y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391025','Tebaina ("thebaine") e seus sais','Thebaine and its salts','Tebaina ("thebaine") y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391026','Hidromorfona ("hydromorfone") e seus sais','Hydromorfone and its salts','Hidromorfona ("hydromorfone") y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391029','Outros derivados da morfina e sais destes produtos','Other morphine derivatives and salts thereof','Los dem.deriv.de la morfina y sales de estos product.',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391090','Outros alcalóides do opio, seus derivados e sais','Other opium alkaloids, its derivatives and salts','Los dem.alcaloides del opio, sus derivados y sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391091','Buprenorfina e seus sais','Buprenorphine and its salts','Buprenorfina y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391092','Concentrado de palha de papoula','Poppy straw concentrate','Concentrado de paja de adormidera',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391093','Etorfina e seus sais','Buprenorphine and its salts','Etorfina y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391099','Outros alcalóides do ópio, seus derivados e seus sais','Other opium alkaloids, its derivatives and salts','Los dem.alcaloides del opio,  sus derivados y sus sales',10,'29','2939','293910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391110','Concentrados de palha de papoula','Concentrates of poppy straw','Concentrados de paja de adormidera',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391121','Buprenorfina e seus sais','Buprenorphine and its salts','Buprenorfina y sus sales',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391122','Codeína e seus sais','Codeine and its salts','Codeína y sus sales',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391123','Diidrocodeína e seus sais','Dihydrocodeine and its salts','Dihidrocodeína y sus sales',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391131','Etilmorfina e seus sais','Ethylmorphine and its salts','Etilmorfina y sus sales',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391132','Etorfina e seus sais','Etorphine and its salts','Etorfina y sus sales',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391140','Folcodina e seus sais','Pholcodine and its salts','Folcodina y sus sales',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391151','Heroina e seus sais','Heroin and its salts','Heroína y sus sales',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391152','Hidrocodona e seus sais','Hydrocodone and its salts','Hidrocodona y sus sales',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391153','Hidromorfona e seus sais','Hydromorphone and its salts','Hidromorfona y sus sales',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391161','Morfina','Morphine','Morfina',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391162','Cloridrato e sulfato de morfina','Morphine hydrochloride and morphine sulphate','Clorhidrato y sulfato de morfina',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391169','Outros','Other','Los demás',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391170','Nicomorfina e seus sais','Nicomorphine and its salts','Nicomorfina y sus sales',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391181','Oxicodona e seus sais','Oxycodone and its salts','Oxicodona y sus sales',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391182','Oximorfona e seus sais','Oxymorphone and its salts','Oximorfona y sus sales',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391191','Tebacona e seus sais','Thebacon and its salts','Tebacona y sus sales',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391192','Tebaina e seus sais','Thebaine and its salts','Tebaina y sus sales',10,'29','2939','293911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29391900','Outs.alcalóides do ópio, seus derivs.e sais','Other opium alkaloids, its derivatives and its salts','Los demás alcaloides del opio,  sus derivados y sales',10,'29','2939','293919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29392000','Alcalóides da quina, seus derivados e sais','Cinchona alcaloids, their derivatives and salts','Alcaloides de quina, sus derivados y sales',10,'29','2939','293920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29392100','Quinina e seus sais','Quinine and its salts','Quinina y sus sales',10,'29','2939','293921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29392900','Outros alcalóides da quina, seus derivados e sais','Other alkaloids of quine, its derivatives and its salts','Los demás alcaloides de la quina,  sus derivados y sales',10,'29','2939','293929');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29393010','Cafeína','Caffeine','Cafeina',10,'29','2939','293930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29393020','Sais da cafeína','Salts of caffeine','Sales de la cafeina',10,'29','2939','293930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29394100','Efedrina e seus sais','Ephedrine and its salts','Efedrina y sus sales',10,'29','2939','293941');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29394200','Pseudoefedrina (dci) e seus sais','Pseudoephedrine (inn) and its salts','Pseudoefedrina (dci) y sus sales',10,'29','2939','293942');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29394300','Catina (dci) e seus sais','Cathine (inn) and its salts','Catina (dci) y sus sales',10,'29','2939','293943');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29394400','Norefedrina e seus sais','Norephedrine and its salts','Norefedrina y sus sales',10,'29','2939','293944');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29394900','Outros derivados da efedrina e seus sais','Other derivatives of ephedrine and its salts','Los demás derivados de la efedrina y sus sales',10,'29','2939','293949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29394910','Catina e seus sais','Cathine (inn) and its salts','Catina y sus sales',10,'29','2939','293949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29394990','Outros derivados da efedrina e seus sais','Other derivatives of ephedrine and its salts','Otros derivados de la efedrina y sus sales',10,'29','2939','293949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29395010','Teofilina','Theophylline','Teofilina',10,'29','2939','293950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29395020','Aminofilina','Aminophylline','Aminofilina',10,'29','2939','293950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29395030','Fenetilina e seus sais','Fenetylline and its salts','Fenetilina y sus sales',10,'29','2939','293950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29395090','Derivados e sais da teofilina e aminofilina','Derivatives and salts of theophylline and aminophylline','Derivados y sales de la teofilina y aminofilina',10,'29','2939','293950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29395100','Fenetilina (dci) e seus sais','Fenetylline (inn) and its salts','Fenetilina (dci) y sus sales',10,'29','2939','293951');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29395910','Teofilina','Theophylline','Teofilina',10,'29','2939','293959');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29395920','Aminofilina','Aminophylline','Aminofilina',10,'29','2939','293959');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29395990','Outros derivados e sais de teofilina ou aminofilina','Oth.derivat.and salts of theophylline or aminophylline','Los dem.derivados y sais de la teofilina o aminofilina',10,'29','2939','293959');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396100','Ergometrina (dci) e seus sais','Ergometrine (inn) and its salts','Ergometrina (dci) y sus sales',10,'29','2939','293961');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396200','Ergotamina (dci) e seus sais','Ergotamine (inn) and its salts','Ergotamina (dci) y sus sales',10,'29','2939','293962');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396300','Acido lisergico e seus sais','Lysergic acid and its salts','Ácido lisérgico y sus sales',10,'29','2939','293963');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396911','Maleato de metilergometrina','Methylergometrine maleate','Maleato de metilergometrina',10,'29','2939','293969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396919','Outros derivados da ergometrina (dci) e seus sais','Other derivatives of ergometrine (inn) and its salts','Los dem.derivados de la ergometrina (dci) y sus sales',10,'29','2939','293969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396921','Mesilato de diidroergotamina','Dihydroergotamine mesylate','Mesilato de dihidroergotamina',10,'29','2939','293969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396929','Outros derivados da ergotamina (dci) e seus sais','Other derivatives of ergotamine (inn) and its salts','Los dem.derivados de la ergotamina (dci) y sus sales',10,'29','2939','293969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396931','Mesilato de diidroergocornina','Dihydroergocornine mesylate','Mesilato de dihidroergocornina',10,'29','2939','293969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396939','Ergocornina e outros derivados e sais','Ergocornine and other derivatives and salts','Ergocornina y demás derivados y sales',10,'29','2939','293969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396941','Mesilato de alfa-diidroergocriptina','Alpha-dihydroergocryptine mesylate','Mesilato de alfa-dihidroergocriptina',10,'29','2939','293969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396942','Mesilato de beta-diidroergocriptina','Beta-dihydroergocryptine mesylate','Mesilato de beta-dihidroergocriptina',10,'29','2939','293969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396949','Ergocriptina e outros derivados e sais','Ergocriptine and other derivatives and salts','Ergocriptina y otros derivados y sales',10,'29','2939','293969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396951','Ergocristina','Ergocristine','Ergocristina',10,'29','2939','293969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396952','Metanossulfonato de diidroergocristina','Dihydroergocristine methanesulphonate','Metansulfonato de dihidroergocristina',10,'29','2939','293969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396959','Outros derivados da ergocristina e seus sais','Other derivatives of ergocristine and its salts','Los demás derivados de la ergocristina y sus sales',10,'29','2939','293969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29396990','Outros alcalóides da cravagem do centeio, seus derivados','Other alkaloids of rye ergot, its derivatives','Los dem.alcaloides del cornezuelo del centeno, sus deriv',10,'29','2939','293969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29397000','Nicotina e seus sais','Nicotine and salts','Nicotina y sus sales',10,'29','2939','293970');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399011','Brometo de n-butilescopolamônio','N-butylscopolammonium bromide','Bromuro de n-butilescopolamonio',10,'29','2939','293990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399019','Escopolamina, outros derivados e sais','Escopolamine, other derivatives and salts','Escopolamina,  demás derivados y sales',10,'29','2939','293990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399020','Teobromina, seus derivados e sais','Theobromine and its derivatives and salts thereof','Teobromina,  sus derivados y sales',10,'29','2939','293990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399031','Pilocarpina, seu nitrato ou cloridrato','Pilocarpine its nitrate or hydrochloride','Pilocarpina,  su nitrato o clorhidrato',10,'29','2939','293990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399039','Outros sais da pilocarpina','Other pilocarpine salts','Los demás sales de la pilocarpina',10,'29','2939','293990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399040','Cocaína e seus sais','Cacaine and its salts','Cocaína y sus sales',10,'29','2939','293990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399041','Cocaína e seus sais','Cacaine and its salts','Cocaína y sus sales',10,'29','2939','293990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399042','Ecgonina e seus sais','Ecgonine and its salts','Ecgonina y sus sales',10,'29','2939','293990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399049','Outros derivados da cocaína e seus sais','Other derivatives of cocaine and its salts','Los demás derivados de la cocaína y sus sales',10,'29','2939','293990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399051','Levometanfetamina (1-n, alfa-dimetilfenetilamina) e sais','Levometanfetamine(1-n, alpha-dimethylfenetil.)and salts','Levometanfetamina(1-n, alfa-dimetilfenetilamina) y sales',10,'29','2939','293990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399052','Metanfetamina (d-n, alfa-dimetilfenetilamina) e sais','Metanfetamine(d-n, alpha-dimethylfenetil.)and salts','Metanfetamina (d-n, alfa-dimetilfenetilamina) y sales',10,'29','2939','293990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399053','Racemato de metanfetamina (d1-n, alfa-dimetilfenetil.etc','Metamfetamine racemate(d-n, alpha-dimethylfenet.etc','Racemato de metanfetamina (d1-n, alfa-dimetilfenetil.etc',10,'29','2939','293990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399059','Outs.dimetilfenetilaminas, seus derivados e seus sais','Oth.dimethylfenetilamines, its derivatives ans its salts','Las dem.dimetilfenetilaminas,  sus derivados y sus sales',10,'29','2939','293990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399090','Outros alcalóides vegetais, seus sais, éteres, ésteres, etc','Other vegetable alkaloids, its salts ethers, esters, etc.','Los dem.alcaloides veget.sus sales, éteres, ésteres, etc',10,'29','2939','293990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399111','Cocaína e seus sais','Cocaine and its salts','Cocaína y sus sales',10,'29','2939','293991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399112','Ecgonina e seus sais','Ecgonine and its salts','Ecgonina y sus sales',10,'29','2939','293991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399119','Ésteres e derivados de cocaína ou ecgonina','Esters and derivatives of cocaine or ecgonine','Ésteres y derivados de cocaína o ecgonina',10,'29','2939','293991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399120','Levometanfetamina, seus sais, ésteres e outs.','Levamfetamine, its salts, esters and other','Levometanfetamina,  sus sales,  ésteres y demás',10,'29','2939','293991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399130','Metanfetamina, seus sais, ésteres e outs.de','Metamfetamine, its salts, esters and other derivatives','Metanfetamina,  sus sales,  ésteres y demás deriv.',10,'29','2939','293991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399140','Racemato de metanfetamina, seus sais, ésteres','Metamfetamine racemate, its salts, esters','Racemato de metanfetamina,  sus sales,  ésteres',10,'29','2939','293991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399911','Brometo de n-butilescopolamônio','N-butylscopolammonium bromide','Bromuro de n-butilescopolamonio',10,'29','2939','293999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399919','Escopolamina e outs.derivs.e sais deste prod.','Escopolamine and other  derivatives and its salts','Escopolamina y demás derivados y sales de este producto',10,'29','2939','293999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399920','Teobromina e seus derivados;sais destes prod','Theobromine and its derivatives; salts thereof','Teobromina y sus derivados;sales de estos productos',10,'29','2939','293999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399931','Pilocarpina, seu nitrato e seu cloridrato','Pilocarpine, its nitrate and its hydrochloride','Pilocarpina,  su nitrato y su clorhidrato',10,'29','2939','293999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399939','Outros sais de pilocarpina','Salts of pilocarpine','Los demás sales de pilocarpina',10,'29','2939','293999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399940','Tiocolquicosido','Thiocolchicoside','Tiocolquicósido',10,'29','2939','293999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29399990','Outros alcalóides vegetais, naturais, etc.','Other vegetable alkaloids, natural, etc.','Los demás alcaloides vegetales,  naturales,  etc.',10,'29','2939','293999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29400011','Galactose','Galactose','Galactosa',10,'29','2940','294000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29400012','Arabinose','Arabinose','Arabinosa',10,'29','2940','294000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29400013','Ramnose','Ramnose','Ramnosa',10,'29','2940','294000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29400019','Outros açúcares quimicamente puros','Other sugars, chemically pure','Los demás azúcares químicamente puros',10,'29','2940','294000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29400021','Acido lactobionico','Lactobionic acid','Ácido lactobiónico',10,'29','2940','294000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29400022','Lactobionato de cálcio','Calcium lactobionate','Lactobionato de calcio',10,'29','2940','294000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29400023','Bromolactobionato de cálcio','Calcium bromolactobionate','Bromolactobionato de calcio',10,'29','2940','294000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29400029','Outs.sais, derivs.halogen.sulfon.etc.do ac.lactobionico','Other salts, derivat.sulf.halogenat.etc.lactobionic acid','Los dem.sales, deriv.halog.sulf.etc.del ác.lactobiónico',10,'29','2940','294000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29400091','Tiocolquicosido','Thiocolchicoside','Tiocolchicósido',10,'29','2940','294000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29400092','Frutose-1, 6-difosfato de cálcio ou de sódio','Calcium or sodium fructose-1, 6-diphosphate','Frutosa-1, 6-difosfato de calcio o de sodio',10,'29','2940','294000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29400093','Maltitol','Maltitol','Maltitol',10,'29','2940','294000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29400094','Lactogluconato de cálcio','Calcium lactogluconate','Lactogluconato de calcio',10,'29','2940','294000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29400099','Outros éteres e ésteres de açúcares e seus sais','Other ethers and esters of sugars and its salts','Los dem.éteres y ésteres de azúcares y sus sales',10,'29','2940','294000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29411010','Ampicilina e seus sais','Ampicillin and its salts','Ampicilina y sus sales',10,'29','2941','294110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29411020','Amoxicilina e seus sais','Amoxicillin and its salts','Amoxicilina y sus sales',10,'29','2941','294110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29411031','Penicilina v potassica','Penicillin v potassium','Penicilina v potásica',10,'29','2941','294110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29411039','Outras penicilinas v, derivados e sais','Other penicillin v potassium, derivatives and salts','Las demás penicilinas v, derivados y sales',10,'29','2941','294110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29411041','Penicilina g potássica','Penicillin g potassium','Penicilina g potásica',10,'29','2941','294110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29411042','Penicilina g benzatinica','Penicillin g benzathine','Penicilina g benzatinica',10,'29','2941','294110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29411043','Penicilina g procaínica','Penicillin g procaine','Penicilina g procaínica',10,'29','2941','294110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29411049','Outras penicilinas g, derivados e sais','Other penicillin g, derivatives and salts','Las demás penicilinas g, derivados y sales',10,'29','2941','294110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29411090','Outs.penicilinas, derivs.c/estrut.ac.penicilanico e sais','Oth.penicillins, deriv.w/penicillanic acid struct.salts','Las dem.penicilinas, deriv.c/estr.ác.penicilán.y sales',10,'29','2941','294110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29412010','Sulfatos de estreptomicinas','Streptomycins sulphates','Sulfatos de estreptomicinas',10,'29','2941','294120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29412090','Estreptomicinas, outros derivados e sais','Streptomycins, other derivatives and its salts','Estreptomicinas, demás derivados y sales',10,'29','2941','294120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29413010','Cloridrato de tetraciclina','Tetracycline hydrochloride','Clorhidrato de tetraciclina',10,'29','2941','294130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29413020','Oxitetraciclina','Oxytetracycline','Oxitetraciclina',10,'29','2941','294130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29413031','Minociclina','Minocycline','Minociclina',10,'29','2941','294130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29413032','Sais de minociclina','Salts of minocycline','Sales de minociclina',10,'29','2941','294130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29413090','Tetraciclina, outros derivados e sais','Tetracyclines, other derivatives and salts','Tetraciclina, demás derivados y sales',10,'29','2941','294130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29414011','Cloranfenicol, seu palmitato, succinato ou hemissuccinato','Chloramphenicol, its palmitate, succinate or hemisuccin.','Cloranfenicol,  su palmitato,  succinato o hemisuccinato',10,'29','2941','294140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29414019','Outros ésteres do cloranfenicol','Other esters of chloramphenicol','Los demás ésteres del cloranfenicol',10,'29','2941','294140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29414020','Tianfenicol e seus ésteres','Thiamphenicol and its esters','Tianfenicol y sus ésteres',10,'29','2941','294140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29414090','Outros derivados e sais, do cloranfenicol','Other derivatives and salts of chloramphenicol','Los demás derivados y sales,  del cloranfenicol',10,'29','2941','294140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29415010','Claritromicina','Clarithromycin','Claritromicina',10,'29','2941','294150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29415020','Eritromicina e seus sais','Erythromycin and its salts','Eritromicina y sus sales',10,'29','2941','294150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29415090','Outros derivados da eritromicina e seus sais','Other derivatives of erythromycin and its salts','Los demás derivados de la eritromicina y sus sales',10,'29','2941','294150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419011','Rifamicina s','Rifamycin s','Rifamicina s',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419012','Rifampicina (rifamicina amp)','Rifampicin','Rifampicina (rifamicina amp)',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419013','Rifamicina sv sódica','Rifamycin sv sodium','Rifamicina sv sódica',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419019','Outras rifamicinas, seus derivados e sais destes produtos','Other rifamycin, its derivatives and its salts','Las dem.rifamicinas, sus deriv.y sales de estos product.',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419021','Cloridrato de lincomicina','Lincomycin hydrochloride','Clorhidrato de lincomicina',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419022','Fosfato de clindamicina','Clindamycin phosphate','Fosfato de clindamicina',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419029','Lincomicina, outros derivados e sais destes produtos','Lincomycin, other derivatives and its salts','Lincomicina,  demás derivados y sales de estos productos',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419031','Ceftriaxona e seus sais','Cefadroxil and its salts','Ceftriaxona y sus sales',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419032','Cefoperazona e seus sais, e cefazolina sódica','Cefoperazone and its salts and cefazoline sodium','Cefoperazona y sus sales,  y cefazolina sódica',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419033','Cefaclor e cefalexina monoidratados, e cefalotina sódica','Cefaclor and cefalexin monohydrate;cefalotin sodium','Cefaclor y cefalexina monohidratados,  cefalotina sódica',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419034','Cefadroxil e seus sais','Cefadroxil and its salts','Cefadroxil y sus sales',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419035','Cefotaxima sódica','Cefotaxime sodium','Cefotaxima sódica',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419036','Cefoxitina e seus sais','Cefoxitin and its salts','Cefoxitina y sus sales',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419037','Cefalosporina c','Cephalosporin c','Cefalosporina c',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419039','Outras cefalosporinas e cefamicinas, derivados e sais','Oth.cephalosporin and cephamicin, derivatives and salts','Las dem.cefalosporinas y cefamicinas,  derivados y sales',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419041','Sulfato de neomicina','Neomycin sulphate','Sulfato de neomicina',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419042','Embonato de gentamicina (pamoato de gentamicina)','Gentamycin embonate (gentamycin pamoate)','Embonato de gentamicina (pamoato de gentamicina)',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419043','Sulfato de gentamicina','Gentamycin sulphate','Sulfato de gentamicina',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419049','Outros aminoglucosídeos e seus sais','Other aminoglycosides and its salts','Los demás aminoglucósidos y sus sales',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419051','Embonato de espiramicina (pamoato de espiramicina)','Spiramycin embonate (spiramycin pamoate)','Embonato de espiramicina (pamoato de espiramicina)',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419059','Outros macrolídios e seus sais','Other macrolids and its salts','Los demás macrólidos y sus sales',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419061','Nistatina e seus sais','Nystatine and its salts','Nistatina y sus sales',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419062','Anfotericina b e seus sais','Amphotericin b and its salts','Anfotericina b y sus sales',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419069','Outros polienos e seus sais','Polyenes and its salts','Los demás polienos y sus sales',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419071','Monensina sódica','Monensin sodium','Monensina sódica',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419072','Narasina','Narasin','Narasina',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419073','Avilamicinas','Avilamycins','Avilamicinas',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419079','Outros poliéteres e seus sais','Other polyethers and its salts','Los demás poliéteres y sus sales',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419081','Polimixinas e seus sais','Polymyxins and their salts','Polimixinas y sus sales',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419082','Sulfato de colistina','Colistin sulphate','Sulfato de colistina',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419083','Virgíniamicinas e seus sais','Virginiamycins and their salts','Virginiamicinas y sus sales',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419089','Outros polipeptídios e seus sais','Other polypeptides and its salts','Los demás polipéptidos y sus sales',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419091','Griseofulvina e seus sais','Griseofulvin and its salts','Griseofulvina y sus sales',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419092','Fumarato de tiamulina','Tiamulin fumarate','Fumarato de tiamulina',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29419099','Outros antibióticos','Other antibiotics','Los demás antibióticos',10,'29','2941','294190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29420000','Outros compostos orgânicos','Other organic compounds','Los demás compuestos orgánicos',10,'29','2942','294200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29420010','Acetilacetonato de mercúrio','Mercuric acetylacetonate','Acetilacetonato de mercurio',10,'29','2942','294200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('29420090','Outros compostos orgânicos','Other organic compounds','Los demás compuestos orgánicos',10,'29','2942','294200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30011010','Fígados dessecados, para uso opoterápico','Dried livers, for organo-therapeutic uses','Hígados desecados,  para uso opoterápico',10,'30','3001','300110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30011090','Glândulas e outros órgãos, para uso opoterápico','Glands and other organs, for organo-therapeutic uses','Glándulas y demás órganos,  para uso opoterápico',10,'30','3001','300110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30012010','Extratos de fígados, para uso opoterápico','Extracts of livers, for organo-therapeutic uses','Extractos de hígados,  para uso opoterápico',10,'30','3001','300120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30012090','Extratos de glândulas, outs.orgaos, etc.p/uso opoterápico','Extracts of glands, oth.organs, etc.fororgano-therap.uses','Extractos de glándulas, dem.órganos, etcp/uso opoterápico',10,'30','3001','300120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30019010','Heparina e seus sais','Heparin and its salts','Heparina y sus sales',10,'30','3001','300190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30019020','Pedaços de pericárdio de origem bovina ou suína','Parts of pericardia, of bovine animals or of swine','Trozos de pericardio de origen bovino o porcino',10,'30','3001','300190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30019031','Fígados dissecados, mesmo em pó','Dried livers, whether in powder or not','Hígados desecados, incluso en polvo',10,'30','3001','300190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30019039','Outras glândulas e órgãos, mesmo em pó','Otras glands and organs, whether in powder or not','Otras glándulas y órganos, incluso en polvo',10,'30','3001','300190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30019090','Outras substs.humanas/animais, p/fins terapeut.profilat.','Other human/animal subst.fortherap.prophyl.uses','Las dem.sust.humanas/animales, p/fines terapéut.profilát',10,'30','3001','300190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021011','Soros antiofidicos e outros soros antivenenosos','Antiophidic serums and other sorums anti-poisonous','Sueros antiofídicos y demás sueros antivenenosos',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021012','Soro antitetânico','Antitetanic serum','Suero antitetánico',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021013','Soro anticatarral','Anticatarrh serum','Suero anticatarral',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021014','Soro antipiogênico','Antipyogens serum','Suero antipiógeno',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021015','Soro antidiftérico','Antidiphtheria serum','Suero antidiftérico',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021016','Anti-soros polivalentes','Antiserum polyvalent','Antisueros polivalentes',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021019','Outros anti-soros especif.de animais/pessoas, imunizados','Oth.antiserum specific of animals/humans, immunized','Los dem.antisueros espec.de animales/personas, inmuniz.',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021021','Soroalbumina','Serum albumin','Seroalbúmina',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021022','Imunoglobulina anti-rh','Immunoglobin rho','Inmunoglobulina anti-rh',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021023','Outras imunoglobulinas séricas','Other serum immunoglobins','Las demás inmunoglobulinas séricas',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021024','Concentrado de fator viii','Factor viii concentrate','Concentrado de factor viii',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021025','Soroalbumina em forma de gel, p/ prepar. reagente diagn.','Serum albumin in gel format, for reagent preparations for diagnostics','Seroalbúmina en formato gel, para preparación de reactivos de diagnóstico',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021026','Anticorpos monoclonais em solução  tampão contendo albumina bovina','Monoclonal antibodies in buffer solution containing bovine albumin  ','Anticuerpos monoclonales en solución  tampón que contiene la albúmina bovina  ',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021029','Outs.frações do sangue, prod.imunol.modif.exc.medicament','Other blood fractions, modif.immunol. prod.exc.medicine','Las dem.fracciones de sangr.prod.imunol.modif.exc.medic',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021031','Soroalbumina, exceto a humana','Serum albumin, except human','Seroalbúmina excepto la humana',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021032','Plasmina (fibrinolisina)','Plasmin (fibrinolysin)','Plasmina (fibrinolisina)',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021033','Uroquinase','Urokinase','Uroquinasa',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021034','Imunoglobulina e cloridrato de histamina, associados','Immunoglobin and histamine hydrochloride, in association','Inmunoglobulina y clorhidrato de histamina,  asociados',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021035','Imunoglobulina g, liofilizada ou em solução','Immunoglobin g, lyophilized or in solution','Inmunoglobulina g,  liofilizada o en solución',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021036','Interferon beta','Interferon beta','Interferón beta',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021037','Soroalbumina humana','Human serum albumin','Seroalbúmina humana',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021038','Anticorpo humano c/afin.especif.antigeno transmembranal','Human antibody with specificity trans-membrane antigen','Anticuerpo humano c/afin.específ.antígenotransmembranal',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30021039','Outs.frações do sangue, prod.imunol.modif.(medicamentos)','Oth.blood fractions, modified immunol.products medicine','Las dem.fracciones de sangre, prod.inmun.modif.(medic.)',10,'30','3002','300210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022011','Vacina contra a gripe, exceto em doses','Vaccines against flu, except in doses','Vacuna contra la gripe,  excepto en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022012','Vacina contra a poliomielite, exceto em doses','Vaccines against poliomyelitis, except in doses','Vacuna contra la poliomielitis, excepto en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022013','Vacina contra a hepatite B, exceto em doses','Vaccines against hepatitis B, except in doses','Vacuna contra la hepatitis B, excepto en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022014','Vacina contra o sarampo, exceto em doses','Vaccines against measles, except in doses','Vacuna contra el sarampión, excepto en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022015','Vacina contra a meningite, exceto em doses','Vaccines against meningitis, except in doses','Vacuna contra la meningitis, excepto en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022016','Vacina contra rubeola, sarampo e caxumba, exceto em doses','Vaccines against rubella, measles, mumps, except in doses','Vacuna contra rubeola, sarampión y paperas, exc.en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022017','Outras vacinas tríplices, exceto em doses','Other triple vaccines, except in doses','Las demás vacunas triples, excepto en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022018','Vacinas anticatarral e antipiogênico, exceto em doses','Vaccines anticatarrh and antipyogen, except in doses','Vacunas anticatarral y antipiógena, excepto en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022019','Outras vacinas para medicina humana, exceto em doses','Other vaccines for human medicine, except in doses','Las dem.vacunas para la medicina humana, exc.en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022021','Vacina contra a gripe, em doses','Vaccines against flu, in doses','Vacuna contra la gripe, en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022022','Vacina contra a poliomielite, em doses','Vaccines against poliomyelitis, in doses','Vacuna contra la poliomielitis, en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022023','Vacina contra a hepatite b, em doses','Vaccines against hepatitis b, in doses','Vacuna contra la hepatitis b, en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022024','Vacina contra o sarampo, em doses','Vaccines against measles, in doses','Vacuna contra el sarampión, en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022025','Vacina contra a meningite, em doses','Vaccines against meningitis, in doses','Vacuna contra la meningitis, en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022026','Vacina contra rubéola, sarampo e caxumba, em doses','Vaccines against rubella, measles, mumps, in doses','Vacuna contra la rubeola,  sarampión y paperas,  en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022027','Outras vacinas tríplices, em doses','Other triple vaccines, in doses','Las demás vacunas triples, en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022028','Vacinas anticatarral e antipiogênico, em doses','Vaccines anticatarrh and antipyogen, in doses','Vacunas anticatarral y antipiógena, en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30022029','Outras vacinas para medicina humana, em doses','Other vaccines for human medicine, in doses','Las demás vacunas para la medicina humana, en dosis',10,'30','3002','300220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30023010','Vacina veterinária, contra a raiva','Veterinary vaccines, against rabies','Vacuna veterinaria, contra la rabia',10,'30','3002','300230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30023020','Vacina veterinária, contra a coccidiose','Veterinary vaccines, agaisnt coccidiosis','Vacuna veterinaria, contra la coccidiosis',10,'30','3002','300230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30023030','Vacina veterinária, contra a querato-conjuntivite','Veterinary vaccines, against keratoconjunctivitis','Vacuna veterinaria, contra la queratoconjuntivitis',10,'30','3002','300230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30023040','Vacina veterinária, contra a cinomose','Veterinary vaccines, against distemper','Vacuna veterinaria, contra el distemper',10,'30','3002','300230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30023050','Vacina veterinária, contra a leptospirose','Veterinary vaccines, against leptospirosis','Vacuna veterinaria, contra la leptospirosis',10,'30','3002','300230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30023060','Vacina veterinária, contra a febre aftosa','Veterinary vaccines, against foot-and-mouth','Vacuna veterinaria, contra la fiebre aftosa',10,'30','3002','300230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30023070','Vacina veterin.contra enfermid.newcastle, gumboro, etc.','Veterinary vaccines, against diseases newcastle, gum.etc','Vacuna veterin. contra enfermid.newcastle, gumboro, etc.',10,'30','3002','300230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30023080','Vacina veterin.comb.contra enferm.newcastle, gumboro, etc','Combin.veter.vaccines, against diseas.newcastle, gum.etc','Vacuna veterin. contra enfermid.newcastle, gumboro, etc.',10,'30','3002','300230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30023090','Outras vacinas para medicina veterinária','Other vaccines for veterinary medicine','Las dem.vacunas para la medicina veterinaria',10,'30','3002','300230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30029010','Reagentes de origem microbiana para disgnóstico','Diagnostic reagents of microbial origin','Reactivos de origen microbiano para diagnóstico',10,'30','3002','300290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30029020','Antitoxinas de origem microbiana','Anti-toxins of microbial origin','Antitoxinas de origen microbiano',10,'30','3002','300290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30029030','Tuberculinas','Tuberculins','Tuberculinas',10,'30','3002','300290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30029091','Outras toxinas, culturas de microorganismos, para saúde animal','Other toxic, cultures of microorganisms, for animal medic','Las dem.toxinas, culturas de microorganism.p/salud anim',10,'30','3002','300290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30029092','Outras toxinas, culturas de microorganismos, para saúde humana','Other toxic, cultures of microorganisms, for human medic','Las dem.toxinas, culturas de microorganism.p/salud huma',10,'30','3002','300290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30029093','Saxitoxina','Saxitoxin','Saxitoxina',10,'30','3002','300290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30029094','Ricina','Ricin','Ricina',10,'30','3002','300290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30029099','Outras toxinas, culturas de microorganismos, prods.semelh','Other toxic, cultures of microorganisms, similar products','Las dem.toxinas, culturas de microorganism.prods.semej.',10,'30','3002','300290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30031011','Medicamento cont.ampicilina ou seus sais, exceto em doses','Medicament cont.ampicillin or its salts, exc.in doses','Medicamento q.cont.ampicilina o sus sales, exc.en dosis',10,'30','3003','300310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30031012','Medicamento cont.amoxicilina ou seus sais, exceto em doses','Medicament cont.amoxicillin or its salts, exc.in doses','Medicamento q.cont.amoxicilina o sus sales, exc.en dosis',10,'30','3003','300310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30031013','Medicamento cont.penicilina g benzatinica, exceto em doses','Medicam.cont.penicillin g benzathine, exc.in doses','Medicamento q.cont.penicilina o sus sales, exc.en dosis',10,'30','3003','300310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30031014','Medicamento cont.penicilina g potassica, exceto em doses','Medicam.cont.penicillin g potassium, exc.in doses','Medicamento q.cont.penicilina g potásica, exc.en dosis',10,'30','3003','300310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30031015','Medicamento cont.penicilina g procainica, exceto em doses','Medicam.cont.penicillin g procaine, exc.in doses','Medicamento q.cont.penicilina g procaína, exc.en dosis',10,'30','3003','300310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30031019','Medicamento cont.outs.penicilinas/derivs.exceto em doses','Medicam.cont.ot.penicilins/derivatives, exc.in doses','Medicamento q.cont.dem.penicilinas/derivs, exc.en dosis',10,'30','3003','300310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30031020','Medicamento cont.estreptomicinas/derivados exceto em doses','Medicam.cont.streptomycins/derivatives, exc.in doses','Medicamento cont.estreptomicinas/derivados exc.en dosis',10,'30','3003','300310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032011','Medicamento contendo cloranfenicol, etc.exceto em doses','Medicament containing chloramphenicol, etc.exc.in doses','Medicamento q.cont.cloranfenicol, etc.exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032019','Medicamento cont.anfenicois/outs.derivados exceto em doses','Medicam.cont.amphenicol/oth.derivat., exc.in doses','Medicamento cont.anfenicoles/ots deriv, etc.exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032021','Medicamento cont.eritromicina/seus sais, exceto em doses','Medicament cont.erythromycin/its salts, exc.in doses','Medicamento cont.eritromicina/sus sales, exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032029','Medicamento cont.macrolidios/outs.derivs.exceto em doses','Medicam.cont.macrolids/oth.derivat., exc.in doses','Medicamento cont.macrólidos/dem.derivs.exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032031','Medicamento cont.rifamicina sv sódica, exceto em doses','Medicament cont.rifamycin sv sodium,  exc.in doses','Medicamento cont.rifamicina sv sódica, exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032032','Medicamento contendo rifampicina, exceto em doses','Medicament containing rifamycin, exc.in doses','Medicamento q.cont.rifamicina, exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032039','Medicamento cont.ansamicinas/outs.derivs.exceto em doses','Medicam.cont.ansamycin oth.derivat., exc.in doses','Medicamento cont.ansamicinas/dem.derivs.exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032041','Medicamento cont.cloridrato de lincomicina, exceto em doses','Medicam.cont.lincomycin hydrochloride, exc.in doses','Medicamento cont.clorhidrato de lincomicina, exc.dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032049','Medicamento cont.lincosamidas/outs.derivs.exceto em doses','Medicam.cont.lincosamides/oth.derivat., exc.in doses','Medicamento q.cont.lincosamidas/dem.derivs, exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032051','Medicamento contendo cefalotina sódica, exceto em doses','Medicament containing cephalothin sodium, exc.in doses','Medicamento q.cont.cefalotina sódica, exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032052','Medicamento c/cefaclor/cefalexina monoidratad.exc.doses','Medicam.c/cefaclor/cephalexin monohydrate, exc.in doses','Medicamento c/cefaclor/cefalexina monohidrat,  exc.dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032059','Medicamento c/cefalosporinas/cefamicinas/etc.exc.doses','Medicament c/cefaclor/cephalexin/etc., exc.in doses','Medicamento c/cefalosporinas/cefamicinas/etc,  exc.dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032061','Medicamento cont.sulfato de gentamicina, exceto em doses','Medicament containing gentamycin sulphate, exc.in doses','Medicamento q cont.sulfato de gentamicina,  exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032062','Medicamento cont.daunorubicina, exceto em doses','Medicament containing daunorubicin, exc.in doses','Medicamento q cont.daunorubicina,  exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032063','Medicamento cont.pirarubicina, exceto em doses','Medicament containing pirarubicin, exc.in doses','Medicamento q cont.pirarubicina,  exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032069','Medicamento cont.aminoglicosidios/outs.derivs.exc.doses','Medicam.cont.aminoglycosides/oth.derivat., exc.in doses','Medicamento q.cont.aminoglicósidos/ots.derivs.exc.dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032071','Medicamento contendo vancomicina, exceto em doses','Medicament containing vancomycin, exc.in doses','Medicamento que contenga vancomicina, exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032072','Medicamento contendo actinomicinas, exceto em doses','Medicament containing actinomycins, exc.in doses','Medicamento que contenga actinomicinas,  exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032073','Medicamento c/ciclosporina a, exc.doses','Medicament containing cyclosporin a, exc.in doses','Medicamento c/ciclosporina a,  exc.en doses',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032079','Medicamento cont.polipeptidios/outs.derivs.exceto em doses','Medicament cont.polypeptides /oth.derivat., exc.in doses','Medicamento q cont.polipéptidos/dem.derivs.exc.en doses',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032091','Medicamento contendo mitomicina, exceto em doses','Medicament containing mitomycins, exc.in doses','Medicamento que contengan mitomicina,  exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032092','Medicamento contendo fumarato de tiamulina, exceto em doses','Medicament containing tiamulin fumarate, exc.in doses','Medicamento q cont. fumarato de tiamulina, exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032093','Medicamento cont.bleomicinas ou seus sais, exceto em doses','Medicament c/ bleomycins or their salts, exc.in doses','Medicamento q cont.bleomicinas o sus sales, exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032094','Medicamento contendo imipenem, exceto em doses','Medicament containing imipenem, exc.in doses','Medicamento que contenga imipenem,  exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032095','Meds.c/anfoter.b em lipossomas, ñ doses, ñ rets.','Medicament with amphotericin b in liposome','Medicamento con anfotericina b en liposoma',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30032099','Medicamento contendo outros antibioticos, exceto em doses','Medicament containing other antibiotics, exc.in doses','Medicamento q contenga otros antibióticos,  exc.en dosis',10,'30','3003','300320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033100','Medicamento cont.insulina, n/cont.antibiot.exceto em doses','Medicament cont.insulin, n/cont.antibiot.exc.in doses','Medicamento cont.insulina, s/antibiót.exc.en dosis',10,'30','3003','300331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033911','Medicamento c/hormônio crescim.(somatrofina), exc.doses','Medicament cont.hormone growth(somatropin), exc.doses','Medicamento c/hormona de crec.(somatotrofina), exc.dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033912','Medicamento c/hcg (gonadotrofina corionica), exc.doses','Medicament c/hgc (chorionic gonadotrophin),  exc.doses','Medicamento c/hcg (gonadotrofina coriónica), exc.dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033913','Medicamento cont.menotropinas, n/cont.antibiot.exc.doses','Medicament c/menotrophins, n/cont.antibiotic, exc.doses','Medicamento cont.menotropinas, s/cont.antibiot.exc.doses',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033914','Medicamento contendo acth (corticotrofina), exceto em doses','Medicament c/acth (corticotrophin), except  in doses','Medicamento conteniendo acth (corticotrofina), exc.doses',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033915','Medicamento cont.pmsg (gonadotrofina serica), exc.doses','Medicament c/pmsg (serum gonadotrophin), exc.in doses','Medicamento cont.pmsg (gonadotrofina serica), exc.doses',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033916','Medicamento cont.somatostatina/seus sais, exceto em doses','Medicament c/somatostatin/its salts, exc.in doses','Medicamento q.cont.somatostatina/sus sales, exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033917','Medicamento contendo acetato de buserelina, exceto em doses','Medicament containing buserelin acetate, exc.in doses','Medicamento q.conteng.acetato de buserelina, exc.dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033918','Medicamento cont.triptorelina/seus sais, exceto em doses','Medicament containg triptorelin/its salts, exc.in doses','Medicamento q.cont.triptorelina/sus sales, exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033919','Medicamento cont.leuprolida ou seu acetato, exceto em doses','Medicament contain.leuprolide/its acetate, exc.doses','Medicamento q.cont.leuprolide o su acetato, exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033921','Medicamento contendo lh-rh (gonadorelina), exceto em doses','Medicament contain.lh-rh (gonadorelin), exc.in doses','Medicamento q.cont. lh-rh (gonadorelina), exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033922','Medicamento contendo oxitocina, exceto em doses','Medicament containing oxytocin, exc.in doses','Medicamento q.contenga oxitocina,  exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033923','Medicamento contendo sais de insulina, exceto em doses','Medicament containing insulin salts, exc.in doses','Medicamento q. contenga sales de insulina,  exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033924','Medicamento contendo timosinas, exceto em doses','Medicament containing timosins, exc.in doses','Medicamento que contenga timosinas,  exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033925','Medicamento contendo octretida, exceto em doses','Medicament containing octreotide, exc.in doses','Medicamento que contenga octreotida, exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033926','Medicamento cont.goserelina ou seu acetato, exceto em doses','Medicament contain.goserelin/its acetate, exc.in doses','Medicamento q cont.goserelina o su acetato, exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033927','Medicamento c/nafarelina ou seu acetado, exc.doses','Medicament cont.nafarelin or its acetate, exc.in doses','Medicamento c/nafarelina o su acetado, exc.dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033929','Medicamento c/outs.hormon.polipeptidicos, etc.exc.doses','Medicament c/oth.polypeptides hormon.etc.exc.in doses','Medicamento c/dem.hormon.polipéptidicas, etc.exc.dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033931','Medicamento cont.hemissuccinato de estradiol, exc.doses','Medicament c/oestradiol hemisuccinate, exc.in doses','Medicamento q.cont.hemisuccinato de estradiol, exc.dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033932','Medicamento cont.fempropionato de estradiol, exc.doses','Medicament c/oestradiol fenpropionate, exc.in doses','Medicamento q.cont.fempropionato de estradiol, exc.dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033933','Medicamento cont.estriol ou seu succinato, exceto em doses','Medicament c/oestradiol or its succinate, exc.in doses','Medicamento q.cont. estriol o su succinato, exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033934','Medicamento contendo alilestrenol, exceto em doses','Medicament containing allyloestrenol, exc.in doses','Medicamento que contenga alilestrenol, exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033935','Medicamento contendo linestrenol, exceto em doses','Medicament containing lynestrenol, exc.in doses','Medicamento que contenga linestrenol, exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033936','Medicamento cont.acetato magestrol, formestano, exc.doses','Medicament c/megestrol acetate, formestane, exc.in doses','Medicamento cont.acetato magestrol, formestano, exc.dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033937','Medicamento contendo desogestrel, exceto em doses','Medicament containing desogestrel, exc.in doses','Medicamento que contenga desogestrel, exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033939','Medicamento cont.outs.estrogênios/progestogen.exc.doses','Medicament c/oth.estrogens/progestogenos, exc.in doses','Medicamento cont.dem.estrógenos/progestógen.exc.dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033981','Medicamentos cont.levotiroxina sódica, exceto em doses','Medicament containing levothyroxine sodium, exc.doses','Medicamentos que cont.levotiroxina sódica, exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033982','Medicamentos cont.liotironina sódica, exceto em doses','Medicament containing liothyronine sodium, exc.doses','Medicamentos que cont. liotironina sódica, exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033990','Medicamento cont.outs.hormônios/derivs.etc.exceto em doses','Medicament c/oth.hormone/derivatives, etc.exc.in doses','Medicamento q.cont.dem.hormonas/derivs.etc.exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033991','Medicam.c/sal sódico ac.9, 11, 15..exceto em doses','Medicament containing sodium salt ac 9, 11, 15.exc.doses','Medicam.c/sal sódica ac.9, 11, 15..exc.en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033992','Medicam.c/tiratricol/seu sal sódico, exc.doses','Medicament c/tiratricol/its sodium salt, exc.doses','Medicam.c/tiratricol/su sal sódica, exc.dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033993','Medicamento cont.levodopa, alfa-metildopa, n/apres.doses','Medicament c/levodopa, alpha-methyldopa exc.in doses','Medicamento q cont.levodopa, alfa-metildopa, s/dosificar',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033994','Medicamento cont.espironolactona, nao apresent.em doses','Medicament containing spironolactone, exc.in doses','Medicamento q.cont.espironolactona,  sin dosificar',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033995','Medicamento cont.exemestano, exceto em doses','Medicament containing exemestane, except in doses','Medicamento que contenga exemestano, excepto en dosis',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30033999','Outs.medicamento cont.hormônios, nao apresent.em doses','Other medicament containing hormone, except in doses','Los demás medicamentos q cont.hormonas,  sin dosificar',10,'30','3003','300339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30034010','Medicamento cont.vimblastina, vincristina, etc.exc.doses','Medicament c/vinblastine, vincristine, etc.exc.in doses','Medicamento q.cont.vimblastina, vincristina, etc.exc.dos.',10,'30','3003','300340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30034020','Medicamento cont.pilocarpina/seu nitrato/etc.exc.doses','Medicament c/pilocarpine/its nitrate/etc.exc.doses','Medicamento q.cont.pilocarpina/su nitrato/etc.exc.dosis',10,'30','3003','300340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30034030','Medicamento c/metanossulf.diidroergocristina, exc.doses','Medicament c/dihydroergocristine methanesulph.exc.doses','Medicamento c/metansulf.dihidroergocristina, exc.dosis',10,'30','3003','300340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30034040','Medicamento contendo codeina ou seus sais, exceto em doses','Medicament c/codeine or its salts, exc.in doses','Medicamento q.contenga codeína o sus sales, exc.en dosis',10,'30','3003','300340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30034050','Medicam.cont.granisetron, tropisetrona, etc.exceto em doses','Medicament c/granisetron, tropisetron, etc.exc.doses','Medicam.q.cont.granisetrón, tropisetrona, etc.exc.en dos.',10,'30','3003','300340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30034090','Medicamento cont.outs.alcalóides/derivs.etc.exc.doses','Medicament c/granisetron, tropisetron, etc.exc.doses','Medicamento q.cont.dem.alcaloides/derivs.etc.exc.dosis',10,'30','3003','300340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039011','Medicamento c/folinato cálcio (leucovorina), exc.doses','Medicament c/calcium folinate (leucovorine), exc.doses','Medicamento c/folinato calcio (leucovorina), exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039012','Medicamento cont.acido nicotinico, etc.exc.em doses','Medicament c/nicotinamide acid, etc.exc.in doses','Medicamento que cont.ácido nicotínico, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039013','Medicamento cont.hidroxocobalamina, etc.exc.em doses','Medicament c/hydroxycobalamine, etc.exc.in doses','Medicamento que cont.hidroxocobalamina, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039014','Medicamento cont.vitamina a1 (retinol), etc.exc.em doses','Medicament c/vitamin a1 (retinol), etc.exc.in doses','Medicamento q.cont.vitam.a1(retinol), etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039015','Medicamento cont.d-pantotenato de cálcio, etc.exc.doses','Medicament c/calcium d-pantothenate, etc.exc.in doses','Medicamento q.cont.d-pantotenato de calcio, etc.exc.dos.',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039016','Medicamento c/ésteres das vitaminas a e d, etc.exc.doses','Medicament c/esters of vitamin a and d, etc.exc.in doses','Medicamento c/ésteres de vitaminas a y d, etc.exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039017','Medicamento cont.acido retinoico (tretinoina), exc.doses','Medicament c/retinoic acid (tretinoin).exc.in doses','Medicamento q.cont.ácido retinóico(tretinoína), exc.dos.',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039019','Medicamento c/outs.vitaminas, provitam.derivs.exc.doses','Medicament c/oth.vitamin, provitamin, deriv.exc.in doses','Medicamento c/dem.vitaminas, provitam.derivs.exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039021','Medicamento contendo estreptoquinase, exc.em doses','Medicament containing streptokinases, exc.in doses','Medicamento que contenga estreptoquinase, exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039022','Medicamento contendo l-asparaginase, exc.em doses','Medicament containing l-asparaginase, exc.in doses','Medicamento que contenga l-asparaginasa, exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039023','Medicamento contendo deoximbonuclease, exc.em doses','Medicament containing deoxyribonuclease, exc.in doses','Medicamento q cont.deoxirribonucleasa, exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039029','Medicamento c/outs.enzimas, n/cont.vitams.etc.exc.doses','Medicament cont.enzymes n/cont.vitamins, e, exc.in doses','Medicamento c/dem.enzimas, s/cont.vitams.etc.exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039031','Medicamento contendo permetrina, etc.exc.em doses','Medicament containing permethrin, etc.exc.in doses','Medicamento que contenga permetrina, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039032','Medicamento cont.acido deidrocolico, etc.exc.em doses','Medicament contain.dehydrocholic acid, etc.exc.in doses','Medicamento q cont.ácido dehidrocólico, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039033','Medicamento c/acido gluconico/sais/ésteres, exc.em doses','Medicament c/gluconic acid/salts/esters, exc.in doses','Medicamento c/ácido glucónico/sales/ésteres, exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039034','Medicamento c/acido o-acetilsalicilico/etc.exc.em doses','Medicament c/o-acetylsalicylic acid/etc, exc.in doses','Medicamento c/ácido o-acetilsalicílico/etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039035','Medicamento c/tiratricol/lactofosfato cálcio, exc.doses','Medic.c/tiratricol(triac)/calcium lactophosp.exc.doses','Medicamento c/tiratricol/lactofosfato calcio, exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039036','Medicamento cont.acido lactico/sais/etc.exc.em doses','Medicament cont.lactic acid/salts/etc, exc.in doses','Medicamento q cont.ácido láctico/sales/etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039037','Medicamento cont.acido fumarico/sais/etc.exc.em doses','Medicament cont.fumaric acid/salts/etc, exc.in doses','Medicamento cont.ácido fumárico/sales/etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039038','Medicamento cont.etretinato, miltefosina, etc.exc.doses','Medicament cont.etretinate/miltefosine, etc, exc.in doses','Medicamento cont.etretinato, miltefosina, etc.exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039039','Medicamento c/outs.acidos carboxilicos, etc.exc.em doses','Medicament cont.oth.carboxylic acid, etc, exc.in doses','Medicamento c/dem.ácidos carboxílicos, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039041','Medicamento c/sulfato de tranilcipromina, etc.exc.doses','Medicament c/tranylcypromine sulphate, etc, exc.in doses','Medicamento c/sulfato de tranilcipromina, etc.exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039042','Medicamento c/acido sulfanilico, sais, etc.exc.em doses','Medicament c/sulfanilic acid, salts, etc, exc.in doses','Medicamento c/ácido sulfanílico, sales, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039043','Medicamento c/clembuterol/seu cloridrato, exc.em doses','Medicament c/clenbuterol/its hydrochloride, exc.in doses','Medicamento c/clembuterol/su clorhidrato, exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039044','Medicamento contendo tamoxifen/seu citrato, exc.em doses','Medicament c/tamoxifen/its citrate, exc.in doses','Medicamento q.contenga tamoxifeno/su citrato, exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039045','Medicamento cont.levodopa/alfa-metildopa,exc.em doses','Medicine with levodopa/alfa-metildopa, except in doses','Medicamento con levodopa/alfa-metildopa, exc. in dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039046','Medicamento c/cloridrato de fenilefrina, etc.exc.doses','Medicament c/phenylephrine hydrochloride, etc, exc.doses','Medicamento c/clorhidrato de fenilefrina, etc.exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039047','Medicamento cont.diclofenaco de sódio, etc.exc.em doses','Medicament c/diclofenac sodium, etc, exc.doses','Medicamento q.cont.diclofenaco de sodio, etc.exc. dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039048','Medicamento cont.melfalano, clorambucil, etc.exc.em doses','Medicament c/melfalan, chlorambucil, etc, exc.doses','Medicamento q.cont.melfalano, clorambucil, etc.exc. dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039049','Medicamento c/outs.compostos funcao amina,etc.exc.doses','Medicine with other compounds w/ amine functions, ex.do','Medicamento con otros compuestos función amina, ex dos.',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039051','Medicamento contendo metoclopramida, etc.exc.em doses','Medicament containing metoclopramide, etc, exc.in doses','Medicamento q contenga metoclopramida, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039052','Medicamento cont.atenolol/prilocaina/etc.exc.em doses','Medicament c/atenolol/prilocaine/etc, exc.in doses','Medicamento q.cont.atenolol/prilocaína/etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039053','Medicamento c/lidocaína/seu cloridrato, etc.exc.em doses','Medicament c/lidocaine/its hydrochloride, etc, exc.doses','Medicamento c/lidocaína/su clorhidrato, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039054','Medicamento contendo femproporex, exc.em doses','Medicament containing fenproporex, exc.in doses','Medicamento q.contenga femproporex,  exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039055','Medicamento cont.paracetamol ou bromoprida, exc.em doses','Medicament c/paracetamol or bromopride, exc.in doses','Medicamento qcont.paracetamol o bromoprida, exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039056','Medicamento cont.amitraz ou cipermetrina, exc.em doses','Medicament c/amitraz or cypermethrin, exc.in doses','Medicamento q.cont.amitraz o cipermetrina,  exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039057','Medicamento cont.clorexidina/seus sais, etc.exc.em doses','Medicament c/chlorhexidine/its salts, etc.exc.in doses','Medicam.q.cont.clorhexidina/sus sales, etc, exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039058','Medicamento cont.carmustina/lomustina, etc.exc.em doses','Medicament c/carmustine/lomustine, etc.exc.in doses','Medicament.q.cont.carmustina/lomustina, etc, exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039059','Medicamento c/outs.comp.func.carboxiamida, etc.exc.doses','Medicam.c/oth.carboxyam. function compoun.etc.exc.doses','Medicamento c/dem.comp.func.carboxiamida, etc.exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039061','Medicamento c/dinitrato de isossorbida, etc.exc.em doses','Medicament c/isossorbide dinitrate, etc.exc.doses','Medicamento c/ dinitrato de isosorbide, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039062','Medicamento contendo tiaprida, exc.em doses','Medicament containing tiapride, exc.in doses','Medicamento q.contenga tiaprida,  exc. en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039063','Medicamento contendo etidronato dissódico, exc.em doses','Medicament containing etidronate disodium, exc.in doses','Medicamento q.cont. etidronato disódico,  exc. en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039064','Medicamento cont.cloridrato de amiodarona, exc.em doses','Medicament cont.amiodarone hydrochloride, exc.in doses','Medicamento q.cont.clorhidrato de amiodarona, exc. dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039065','Medicamento cont.nitrovin ou moxidectina, exc.em doses','Medicament cont.nitrovin or moxidectin, exc.in doses','Medicamento q.cont.nitrovin o moxidectina, exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039066','Medicamento contendo espironolactona, exc.em doses','Medicament cont.spironolactone, exc.in doses','Medicamento q.contenga espironolactona, exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039067','Medicamento cont.carbocisteina ou sulfiram, exc.em doses','Medicament cont.carbocisteine or sulfiram, exc.in doses','Medicamento q.cont.carbocisteina o sulfiram, exc.en dos.',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039068','Medicamento contendo etoposido, exc.em doses','Medicament cont.etoposide, exc.in doses','Medicamento q.contenga etopósido, exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039069','Medicamento c/outs.tiocompostos organ.etc.exc.em doses','Medicament c/oth.organic tiocompounds, exc.in doses','Medicamento c/dem.tiocompuestos orgán.etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039071','Medicamento c/terfenadina/talniflumato, etc.exc.em doses','Medicament c/terfenadine/talniflumate, etc.exc.in doses','Medicamento c/terfenadina/talniflumato, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039072','Medicamento c/nifedipina/nitrendipina, etc.exc.em doses','Medicament c/nimodipine/nitrendipine, etc.exc.in doses','Medicamento c/nifedipina/nitrendipina, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039073','Medicamento c/oxifendazol/albendazol, etc.exc.em doses','Medicament c/oxfendazole/albendazole, etc.exc.in doses','Medicamento c/oxfendazol/albendazol, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039074','Medicamento cont.triazolam/alprazolam, etc.exc.em doses','Medicament c/triazolam/alprazolam, etc.exc.in doses','Medicamento q.cont.triazolam/alprazolam, etc.exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039075','Medicamento c/fenitoina/seu sal sódico, etc.exc.em doses','Medicament c/phenytoin/its sodium salt, etc.exc.in doses','Medicamento c/fenitoína/su sal sódica, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039076','Medicam.c/ac.2-(2 metil-3 cloroanilina) nicot.exc.doses','Med.c/2-(2-methyl-3-chloroanilino)nicot.acid exc.doses','Medicam.c/ác.2-(2 metil-3 cloroanilina) nicot.exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039077','Medicamento c/nicarbazina/norfloxacina, etc.exc.em doses','Medicament c/nicarbazine/norfloxacin, etc.exc.in doses','Medicamento c/nicarbazina/norfloxacina, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039078','Medicamento c/ciclosporina a, fluspirileno, etc.exc.doses','Medicament c/cyclosporin, fluspirilene, etc.exc.in doses','Medicamento c/ciclosporina a, fluspirileno, etc.exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039079','Medicam.c/outs.comp.heteroc.heteroat.nitrog.exc.doses','Medicament c/oth.hetero-atom, heterocyc.comp.exc.doses','Medicam.c/dem.comp.heteroc.heteroát.nitrog.exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039081','Medicamento cont.levamisol/seus sais, etc.exc.em doses','Medicament c/levamisole/its salts, etc.exc.in doses','Medicamento q.cont.levamisol/sus sales, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039082','Medicamento c/sulfadiazina/seu sal sódico, etc.exc.doses','Medicament c/sulfadiazine/its sodium salt, etc.exc.doses','Medicamento c/sulfadiazina/su sal sódica, etc.exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039083','Medicamento cont.ketazolam/sulpirida, etc.exc.em doses','Medicament c/ketazolam/sulpiride, etc.exc.doses','Medicamento q.cont.ketazolam/sulpirida, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039084','Medicam.c/ftalilsulfatiazol/bumetanida, etc.exc.em doses','Medicam.c/phthalylsulfathiazol/bumetanid, etc.exc.doses','Medicam.c/ftalilsulfatiazol/bumetanida, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039085','Medicamento c/enantato de flufenazina, etc.exc.em doses','Medicament c/fluphenazine enanthate, etc.exc.doses','Medicamento c/enantato de flufenazina, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039086','Medicamento c/furosemida/clortalidona, etc.exc.em doses','Medicament c/furosemide/chlorthalidone, etc.exc.doses','Medicamento c/furosemida/clortalidona, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039087','Medicamento c/cloridrato de tizanidina, etc.exc.em doses','Medicament c/tizanidine hydrochloride, etc.exc.doses','Medicamento c/clorhidrato de tizanidina, etc.exc. dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039088','Medicamento cont.topotecan, uracil, etc.exc.em doses','Medicament c/topotecan, uracil, etc.exc.doses','Medicamento q.cont.topotecan, uracil, etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039089','Medicamento c/outs.compost.heterocicl.etc.exc.em doses','Medicaments c/oth.heterocyclic compounds, etc.exc.doses','Medicamento c/dem.compuest.heterocícl.etc.exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039091','Medicamento contendo extrato de polen, exc.em doses','Medicament containing pollen extract, exc.in doses','Medicamento q.contenga extracto de polen, exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039092','Medicamento cont.disofenol/crisarobina, etc.exc.em doses','Medicaments c/disophenol/chyrsarobin, etc.exc.doses','Medicamento q.cont.disofenol/crisarobina, etc.exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039093','Medicamento contendo dicoflenaco resinato, exc.em doses','Medicament cont.diclofenac resinate, exc.in doses','Medicamento q.contenga dicloflenaco resinato, exc.dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039094','Medicamento contendo silimarina, exc.em doses','Medicament cont.silymarin group, exc.in doses','Medicamento q.contenga silimarina, exc.en dosis',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039095','Medicamento cont.propofol, busulfano, mitotano, exc.doses','Medicament c/propofol, busulfan, mitotane, exc.in doses','Medicamento q.cont.propofol, busulfano, mitotano, exc.dos.',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039096','Complexo de ferro dextrana','Iron dextran complex','Complejo de hierro dextrana',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30039099','Outs.medicam.cont.prods.misturados, p/fins terapeut.etc.','Oth.medicament con.mixed products, fortherapeutic use etc','Los dem.medic.q.cont.prods.mezclados, p/fines terap.etc',10,'30','3003','300390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30041011','Medicamento contendo ampicilina ou seus sais, em doses','Medicament cont.ampicillin or its salts, in doses','Medicamento q.contenga ampicilina o sus sales, en dosis',10,'30','3004','300410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30041012','Medicamento contendo amoxicilina ou seus sais, em doses','Medicament cont.amoxicillin or its salts, in doses','Medicamento q.contenga amoxicilina o sus sales, en dosis',10,'30','3004','300410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30041013','Medicamento contendo penicilina g benzatinica, em doses','Medicament cont.penicillin g benzathine, in doses','Medicamento q.contenga penicilina g benzatínica, en dos.',10,'30','3004','300410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30041014','Medicamento contendo penicilina g potassica, em doses','Medicament cont.penicillin g potassium, in doses','Medicamento q.contenga penicilina g potásica, en dosis',10,'30','3004','300410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30041015','Medicamento contendo penicilina g procainica, em doses','Medicament cont.penicillin g procaine, in doses','Medicamento q.contenga penicilina g procaínica, en dosis',10,'30','3004','300410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30041019','Medicamento cont.outs.penicilinas/seus derivs.em doses','Medicament cont.oth.penicillin/its derivatives, in doses','Medicamento q.cont.dem.penicilinas/sus derivs.en dosis',10,'30','3004','300410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30041020','Medicamento cont.estreptomicinas/seus derivs.em doses','Medicament cont.streptomycins/its derivatives, in doses','Medicamento q.cont.estreptomicinas/sus derivs.en dosis',10,'30','3004','300410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042011','Medicamento c/cloranfenicol/seu palmitato, etc.em doses','Medicament c/chloramphenicol, its palmitate, etc.in doses','Medicamento c/cloranfenicol/su palmitato, etc.en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042019','Medicamento contendo anfenicóis/outros sais, em doses','Medicament c/amphenicols/other salts, in doses','Medicamento q.contenga anfenicoles/otros sales, en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042021','Medicamento contendo eritromicina ou seus sais, em doses','Medicament c/erythromycin or its salts, in doses','Medicamento q.contenga eritromicina o sus sales, en dos.',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042029','Outros medicamentos cont.macrolideos/derivados, em doses','Oth.medicam.c/macrolides/derivatives, in doses','Los dem.medicamentos q cont.macrólidos/derivs., en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042031','Medicamento contendo rifamicina sv sódica, em doses','Medicament c/rifamycin sv sodium, in doses','Medicamento q contenga rifamicina sv sódica, en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042032','Medicamento contendo rifampicina, em doses','Medicament containig rifampicin, in doses','Medicamento que contenga rifampicina, en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042039','Outros medicamentos cont.ansamicinas/derivados, em doses','Other medicaments cont.ansamycin/deriv., in doses','Los dem.medicamentos q.cont.ansamicinas/derivs.en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042041','Medicamento contendo cloridrato de lincomicina, em doses','Medicament contain.lincomycin hydrochloride, in doses','Medicamento q cont.clorhidrato de lincomicina, en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042049','Outros medicamentos cont.lincosamidas/derivados, em dose','Other medicaments cont.lincosamides/deriv., in doses','Los dem.medicamentos qcont.lincosamidas/derivs.en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042051','Medicamento contendo cafalotina sódica, em doses','Medicament contain.cephalothin sodium, in doses','Medicamento q.contenga cefalotina sódica, en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042052','Medicamento c/cefaclor/cefalexina monoidratads.em doses','Medicam.con.cephalothin/cephalexin monohydrate, in doses','Medicamento c/cefaclor/cefalexina monohidrats.en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042059','Outros medicamentos contendo cefalosporinas, etc.em dose','Other medicaments cont.cephalosporin, etc.in doses','Los dem.medicamentos q.cont.cefalosporinas, etc.dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042061','Medicamento contendo sulfato de gentamicina, em doses','Medicament c/gentamycin sulphate, in doses','Medicamento q.contenga sulfato de gentamicina, en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042062','Medicamento contendo daunorubicina, em doses','Medicament containing daunorubicin, in doses','Medicamento que contenga daunorubicina, en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042063','Medicamento contendo pirarubicina, em doses','Medicament containing pirarubicin, in doses','Medicamento que contenga pirarubicina, en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042069','Outs.medicamentos cont.aminoglucosidios/derivs.em doses','Oth.medicaments c/aminoglycosides/deriv.in doses','Los dem.medicamentos q.cont.aminoglucosidos/deriv.dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042071','Medicamento contendo vancomicina, em doses','Medicament containing vancomycin, in doses','Medicamento que contenga vancomicina,  en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042072','Medicamento contendo actinomicinas, em doses','Medicament containing actinomycins, in doses','Medicamento que contenga actinomicinas,  en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042073','Medicamento contendo ciclosporina a, em doses','Medicament containing cyclosporin a, in doses','Medicamento que contenga ciclosporina a,  en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042079','Outs.medicamentos cont.polipeptideos/derivados, em doses','Other medicament c/polypeptides/derivatives, in doses','Los dem.medicamentos q.cont.polipéptidos/derivad.dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042091','Medicamento contendo mitomicina, em doses','Medicament containing mitomycins, in doses','Medicamento q contenga mitomicina, en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042092','Medicamento contendo fumarato de tiamulina, em doses','Medicament containing tiamulin fumarate, in doses','Medicamento que contenga fumarato de tiamulina, en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042093','Medicamento contendo bleomicinas ou seus sais, em doses','Medicament contain.bleomycins or their salts, in doses','Medicamento q contenga bleomicinas o sus sales, en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042094','Medicamento contendo imipenem, em doses','Medicament containing imipenems, in doses','Medicamento que contenga imipenem,  en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042095','Meds.c/anfoter.b em lipossomas, doses, venda ret.','Medicament with amphotericin b in liposome, doses, retail sale','Medicamento con anfotericina b en liposoma, dosis, venta a menudeo',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30042099','Medicamentos contendo outros antibióticos, em doses','Medicament containing other antibiotics, in doses','Medicamentos que contenga demás antibióticos,  en dosis',10,'30','3004','300420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043100','Medicamento contendo insulina, em doses','Medicament containing insulin, in doses','Medicamento que contenga insulina,  en dosis',10,'30','3004','300431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043200','Medicamento c/hormônios corticossupra-renais, em doses','Medicament c/hormones corticossupra-renal, in doses','Medicamento c/hormonas corticosuprarrenales,  en dosis',10,'30','3004','300432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043210','Medicamento cont.hormônios corticosteroides, em doses','Medicament c/corticosteroid hormones, in doses','Medicamento q cont.hormonas córticosteroides,  en dosis',10,'30','3004','300432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043220','Medicamento contendo espirolactona, em doses','Medicament containing spironolactone, in doses','Medicamento que contenga espirolactona,  en dosis',10,'30','3004','300432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043290','Medicamento cont.outs.deriv.hormônios, analogos, em doses','Medicament c/oth.deriv.hormones, analogues, in doses','Medicamento q cont.dem.deriv.hormonas, análogos, en dosis',10,'30','3004','300432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043911','Medicamento c/hormônio crescim.(somatotrofina), em doses','Medicament c/growth hormones(somatropin)in doses','Medicamento c/hormona crecim.(somatotropina), en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043912','Medicamento cont.hcg (gonadotrofina corionica), em doses','Medicament c/hgc (chorionic gonadotrophin), in doses','Medicamento qcont.hcg(gonadotrofina corionica), en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043913','Medicamento contendo menotropinas, em doses','Medicament containing menotrophins, in doses','Medicamento que contenga menotropinas,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043914','Medicamento contendo acth (corticotrofina), em doses','Medicament containing acth (corticotrophin), in doses','Medicamento que contenga acth (corticotrofina), en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043915','Medicamento cont.pmsg (gonadotrofina serica), em doses','Medicament c/pmsg (serum gonadotrophin), in doses','Medicamento q cont.pmsg (gonadotrofina sérica), en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043916','Medicamento cont.somatostatina ou seus sais, em doses','Medicament c/somatostatin or its salts, in doses','Medicamento q cont.somatostatina o sus sales,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043917','Medicamento contendo acetato de buserelina, em doses','Medicament containing buserelin or its acetate, in doses','Medicamento que contenga acetato de buserelina, en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043918','Medicamento contendo triptorelina ou seus sais, em doses','Medicament containing triptorelin or its salts, in doses','Medicamento qcontenga triptorelina o sus sales, en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043919','Medicamento contendo leuprolide, em doses','Medicament containing leuprolide, in doses','Medicamento que contenga leuprolide,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043921','Medicamento contendo lh-rh (gonadorelina), em doses','Medicament containing lh-rh (gonadorelin), in doses','Medicamento que contenga lh-rh (gonadorelina), en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043922','Medicamento contendo oxitocina, em doses','Medicament containing oxytocin, in doses','Medicamento que contenga oxitocina, en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043923','Medicamento contendo sais de insulina, em doses','Medicament containing insulin salts, in doses','Medicamento que contenga sales de insulina,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043924','Medicamento contendo timosinas, em doses','Medicament containing timosins, in doses','Medicamento que contenga timosinas,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043925','Medicamento contendo calcitonina, em doses','Medicament containing calcitonin, in doses','Medicamento que contenga calcitonina,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043926','Medicamento contendo octreotida, em doses','Medicament containing octreotide, in doses','Medicamento que contenga octreotida,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043927','Medicamento contendo goserelina ou seu acetato, em doses','Medicament containing goserelin or its acetate, in doses','Medicamento q contenga goserelina o su acetato, en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043928','Medicamento cont.nafarelina ou seu acetato, em doses','Medicament containing nafarelin or its acetate, in doses','Medicamento que cont.nafarelina o su acetato, en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043929','Medicam.c/outros hormônios polipeptidicos, etc.em doses','Medicament cont.oth.polypeptides hormones, etc.in doses','Medicam.c/demás hormonas polipéptidos, etc.en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043931','Medicamento cont.hemissuccinato de estradiol, em doses','Medicament contain.oestradiol hemisuccinate, in doses','Medicamento q cont.hemisuccinato de estradiol,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043932','Medicamento cont.fempropionato de estradiol, em doses','Medicament contain.oestradiol fenpropionate, in doses','Medicamento q.cont.fempropionato de estradiol,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043933','Medicamento contendo estriol ou seu succinato, em doses','Medicament contain.oestriol or its succinate, in doses','Medicamento q.contenga estriol o su succinato,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043934','Medicamento contendo alilestrenol, em doses','Medicament containing allyloestrenol, in doses','Medicamento que contenga alilestrenol,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043935','Medicamento contendo linestrenol, em doses','Medicament containing lynestrenol, in doses','Medicamento que contenga linestrenol,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043936','Medicamento cont.acetato megestrol, formestano, em doses','Medicaments cont.megestrol acetate, formestane, in doses','Medicamento q.cont.acetato megestrol, formestano, en dos.',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043937','Medicamento contendo desogestrel, em doses','Medicaments cont.desogestrel, in doses','Medicamento que contenga desogestrel,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043938','Medicamento c/estradiol, p/admin.via percutanea, em doses','Medicamentc/oestradiol, fortransdermal administ.in doses','Medicamento c/estradiol, p/admin.via percutanea, en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043939','Medicamento c/outs.estrogênios/progestogenios, em doses','Medicament cont.oth.estrogens/progestogens, in doses','Medicamento c/dem.estrogenos/progestógenos,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043981','Medicamentos com levotiroxina sódica, em doses','Medicaments cont.levothyroxine sodium, in doses','Medicamentos con levotiroxina sódica,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043982','Medicamentos com liotironina sódica, em doses','Medicaments cont.liothyronine sodium, in doses','Medicamentos con liotironina sódica,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043990','Outs.medicamentos c/hormônios/deriv/asteroides, em doses','Oth.medicaments c/hormone/derivatives/asteroids, doses','Los dem.medicamentos c/hormonas/deriv/asteroides, en dos',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043991','Medicam.c/sal sódico ac.9, 11, 15-trii.em doses','Medicament c/sodium salt ac.9, 11, 15-trihyd, in doses','Medicam.c/sal sódica ác.9, 11, 15-trii.en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043992','Medicam.c/tiratricol/seu sal sódico, em doses','Medicament c/tiratricol and its sodium salt, in doses','Medicam.c/tiratricol/su sal sódica,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043993','Medicamento cont.levodopa, alfa-metildopa, em doses','Medicament c/levodopa, alpha-methyldopa, in doses','Medicamento que cont.levodopa,  alfa-metildopa,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043994','Medicamento cont.espironolactona, em doses','Medicaments cont.spironolactone, in doses','Medicamento que cont.espironolactona,  en dosis',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30043999','Outs.medicamentos cont.hormônios, em doses, etc','Oth.medicaments c/hormones, in doses, etc','Los dem.medicamentos que cont.hormonas,  en dosis,  etc',10,'30','3004','300439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30044010','Medicamento cont.vimblastina, vincristina, etc.em doses','Medicament c/vinblastine, vincristine, etc, in doses','Medicamento q cont.vimblastina, vincristina, etc.en dosis',10,'30','3004','300440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30044020','Medicam.c/pilocarpina/seu nitrato/cloridrato, em doses','Medicam.c/pilocarpine/its nitrate/hydrochloride, doses','Medicam.c/pilocarpina/su nitrato/clorhidrato,  en dosis',10,'30','3004','300440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30044030','Medicam.c/metanossulfonato de diidroergocristina, doses','Medic.c/dihydroergocristine methanesulp., doses','Medicam.c/metansulfonato de dihidroergocristina,  dosis',10,'30','3004','300440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30044040','Medicamento contendo codeina ou seus sais, em doses','Medicament c/codeine or its salts, in doses','Medicamento que contenga codeína o sus sales, en dosis',10,'30','3004','300440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30044050','Medicam.cont.granisetron, tropisetrona, etc.em doses','Medicam.c/granisetron, tropisetron, etc.in doses','Medicam.q cont.granisetrón, tropisetrona, etc.en dosis',10,'30','3004','300440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30044090','Outs.medicamentos c/alcalóides, s/hormônios, etc.em doses','Oth.medicam.c/alkaloids/hormones, etc.in doses','Los dem.medicamentos c/alcaloides, s/hormonas, etc.dosis',10,'30','3004','300440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30045010','Medicamento c/folinato de cálcio (leucovorina), em doses','Medicament c/calcium folinate (leucovorine), in doses','Medicamento c/folinato de calcio(leucovorina),  en dosis',10,'30','3004','300450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30045020','Medicamento c/ac.nicotinico/seu sal sódico, etc.em doses','Medicam.c/nicotinamide ac./its sodium salt, etc.in doses','Medicamento c/ác.nicotínico/su sal sódica, etc.en dosis',10,'30','3004','300450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30045030','Medicamento c/hidroxocovalamina/seus sais, etc.em doses','Medicament c/hydroxycobalamine/its salts, in doses','Medicamento c/hidroxocobalamina/sus sales,  etc.en dosis',10,'30','3004','300450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30045040','Medicamento contendo vitamina a1 (retinol), etc.em doses','Medicament c/vitamina a1 (retinol), etc.in doses','Medicamento q cont. vitamina a1 (retinol),  etc.en dosis',10,'30','3004','300450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30045050','Medicamento cont.d-pantotenato de cálcio/etc.em doses','Medicament c/calcium d-pantothenate, etc.in doses','Medicamento q cont.d-pantotenato de calcio/etc.en dosis',10,'30','3004','300450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30045060','Medicamento cont.acido retinoico (tretinoina), em doses','Medicament c/retinoic acid(tretinoin), in doses','Medicamento q cont.ácido retinoico(tretinoína), en dosis',10,'30','3004','300450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30045090','Medicamento c/outs.vitaminas/provitaminas, etc.em doses','Medicament c/oth.vitamins/provitamins, etc.in doses','Medicamento c/dem.vitaminas/provitaminas, etc.en dosis',10,'30','3004','300450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049011','Medicamento contendo estreptoquinase, em doses','Medicament containing streptokinase, in doses','Medicamento que contenga estreptoquinase, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049012','Medicamento contendo l-asparaginase, em doses','Medicament containing l-asparaginase, in doses','Medicamento que contenga l-asparaginasa, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049013','Medicamento contendo deoxirribonuclease, em doses','Medicament containing deoxyribonuclease, in doses','Medicamento que contenga deoxirribonucleasa,  en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049019','Medicamento contendo outras enzimas, em doses','Medicament containing enzymes, in doses','Medicamento que contenga demás enzimas, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049021','Medicamento c/permetrina/nitrato propatila, etc.em doses','Medicament c/permethrin/propatyl nitrate, etc.in doses','Medicamento c/permetrina/nitrato propatilo, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049022','Medicamento contendo ácido deidrocólico, etc.em doses','Medicament containing deoxycholic acid, etc, in doses','Medicamento q contenga ácido dehidrocólico, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049023','Medicamento cont.acido gluconico/sais/ésteres, em doses','Medicament cont.gluconic acid/salts/esters, in doses','Medicamento q cont.ác.glucónico/sales/ésteres,  en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049024','Medicamento cont.acido o-acetilsalicilico, etc.em doses','Medicament cont.o-acetylsalicylic acid, etc.in doses','Medicamento q cont.ác. o-acetilsalicílico, etc. en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049025','Medicam.cont.tiratricol/lactofosfato cálcio, em doses','Medicament contain.triac/calcium lactophosin doses','Medicam.q cont.tiratricol/lactofosfato calcio, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049026','Medicamento cont.acido lactico/seus sais, etc.em doses','Medicament contain.lactic acid/its salts, etc.in doses','Medicamento q cont.ácido láctico/sus sales, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049027','Medicamento cont.nitroglicerina, em doses, p/via cutanea','Medicam.c/nitroglycerine, in doses, fortrans.administrat.','Medicamento qcont.nitroglicerina, en dosis, p/vía cutánea',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049028','Medicamento cont.etretinato, miltefosina, etc.em doses','Medicament c/etretinate miltefosine, etc.in doses','Medicamento q cont.etretinato, miltefosina, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049029','Outs.medicam.c/ac.monocarboxil.acicl.n/sat.etc.em doses','Oth.medicam.c/monocarboxylic acyclic n/sat.etc.doses','Los dem.medicam.c/ác.monocarboxíl.acícl.s/sat.etc.dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049031','Medicamento c/sulfato de tranilcipromina, etc.em doses','Medicament c/tranylcypromine sulphate, etc.in doses','Medicamento c/sulfato de tranilcipromina, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049032','Medicamento c/acido sulfanilico/seus sais, etc.em doses','Medicament c/tranylcypromine sulphate, etc.in doses','Medicamento c/ácido sulfanílico/sus sales, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049033','Medicamento cont.clembuterol ou seu cloridrato, em doses','Medicament c/clenbuterol or its hydrochloride, in doses','Medicamento qcont.clembuterol o su clorhidrato, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049034','Medicamento contendo tamoxifen ou seu citrato, em doses','Medicament c/tamoxifen or its citrate, in doses','Medicamento q contenga tamoxifeno o su citrato, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049035','Medicamento cont.levodopa ou alfa-metildopa,em doses','Medicine with levodopa/alfa-metildopa, in doses','Medicamento con levodopa/alfa-metildopa, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049036','Medicamento cont.cloridrato de fenilefrina, etc.em doses','Medicament c/phenylephrine hydrochloride, etc.in doses','Medicam.q cont.clorhidrato de fenilefrina, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049037','Medicamento contendo diclofenaco de sódio, etc.em doses','Medicament c/diclofenac sodium, etc.in doses','Medicam. que contenga diclofenaco de sodio, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049038','Medicamento contendo melfalano, clorambucil, etc.em doses','Medicament c/melfalan, chlorambucil, etc.in doses','Medicamento q cont. melfalano, clorambucil, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049039','Outros medicam.c/compostos de funcao amina,etc.em doses','Other medicine with compounds w/ amine functions,doses','Otro medicamento con compuestos función amina, in dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049041','Medicamentos c/metoclopramida/cloridrato, etc.em doses','Medicament c/metoclopramide/hydrochloride, etc.in doses','Medicamentos c/metoclopramida/clorhidrato, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049042','Medicamento cont.atenolol/prilocaina, etc.em doses','Medicament c/atenolol, prilocaine, etc.in doses','Medicamento q cont.atenolol/prilocaína, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049043','Medicamento cont.lidocaína/seu cloridrato, etc.em doses','Medicament c/lidocaine/its hydrochloride, etc.in doses','Medicam. que cont.lidocaína/su clorhidrato, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049044','Medicamento contendo femproporex, em doses','Medicament containing fenproporex, in doses','Medicamento q contenga femproporex, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049045','Medicamento cont.paracetamol ou bromoprida, em doses','Medicament cont.paracetamol or bromopride, in doses','Medicamento q cont.paracetamol o bromoprida,  en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049046','Medicamento contendo amitraz ou cipermetrina, em doses','Medicament cont.amitraz/cypermethrin, in doses','Medicamento q contenga amitraz o cipermetrina,  en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049047','Medicamento contendo clorexidina/seus sais, etc.em doses','Medicament containing chlorhexidine/its salts, in doses','Medicamento q cont.clorhexidina/sus sales, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049048','Medicamento contendo carmustina/lomustina, etc.em doses','Medicament containing carmustine/lomustine, etc.in doses','Medicamento q cont.carmustina/lomustina, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049049','Outs.medicam.c/comp.de função carboxiamida, etc.em doses','Ot.medicam.c/carboxyamide-function compounds, etc.doses','Los dem.medic.c/comp.c/ función carboxiamida, etc.dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049051','Medicamento cont.dinitrato de isossorbida, etc.em doses','Medicament cont.isossorbide dinitrate, etc.in doses','Medicamento q cont.dinitrato de isosorbide, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049052','Medicamento contendo tiaprida, em doses','Medicament containing thiapride, in doses','Medicamento que contenga tiaprida, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049053','Medicamento contendo etidronato dissódico, em doses','Medicament containing etidronate disodium, in doses','Medicamento q contenga etidronato disódico, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049054','Medicamento contendo cloridrato de amiodarona, em doses','Medicament containing amiodarone hydrochloride, in doses','Medicamento q cont.clorhidrato de amiodarona, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049055','Medicamento contendo nitrovin ou moxidectina, em doses','Medicament containing nitrovin, moxidectin, in doses','Medicamento q contenga nitrovin o moxidectina, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049056','Medicamento contendo espironolactona, em doses','Medicament contain.spironolactone, in doses','Medicamento q contenga espironolactona, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049057','Medicamento contendo carbocisteina ou sulfiram, em doses','Medicament containing carbocisteine, sulfiram, in doses','Medicamento que cont.carbocisteína o sulfiram,  en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049058','Medicamento contendo etoposidio, em doses','Medicament containing etoposide, in doses','Medicamento que contenga etopósido, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049059','Outs.medicamentos c/prods.pos.2930 a 2932, etc.em doses','Oth.medicaments c/products pos.2930 to 2932, etc.doses','Los dem.medicamentos c/prods.pos.2930 a 2932, etc.dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049061','Medicamento cont.terfenadina/talniflumato, etc.em doses','Medicament c/terfenadine/talniflumate, etc.in doses','Medicam. que cont.terfenadina/talniflumato, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049062','Medicamento cont.nifedipina/nitrendipina, etc.em doses','Medicament c/nifendipine/nitrendipine, etc.in doses','Medicamento q cont.nifedipina/nitrendipina, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049063','Medicamento cont.oxifendazol/albendazol, etc.em doses','Medicament c/oxfendazole/albendazole, etc.in doses','Medicamento q cont.oxifendazol/albendazol, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049064','Medicamento contendo triazolam/alprazolam, etc.em doses','Medicament c/triazolam/alprazolam, etc.in doses','Medicamento q cont. triazolam/alprazolam,  etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049065','Medicamento cont.fenitoina/seu sal sódico, etc.em doses','Medicament c/phenytoin or its sodium salt, etc.in doses','Medicamento q cont.fenitoína/su sal sódica, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049066','Medicam.c/ac.2-(2-metil-3-cloroanilina) nicot.em doses','Medicament c/2-(2-methyl-3-chloroanilino)nicot. doses','Medicam.c/ác.2-(2-metil-3-cloroanilino) nicot.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049067','Medicamento cont.nicarbazina/norfloxacina, etc.em doses','Medicament c/nicarbazine/norfloxacin, etc.in doses','Medicam.q cont.nicarbazina/norfloxacina,  etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049068','Medicamento c/ciclosporina a, fluspirileno, etc.em doses','Medicament c/cyclosporine a, fluspirilene, etc.in doses','Medicamento c/ciclosporina a, fluspirileno, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049069','Outs.medicam.c/comp.heterocicl.heteroat.nitrog.em doses','Ot.medicaments c/comp.heterocyc.heteroat.nitr.in doses','Los dem.medicam.c/comp.heterocícl.heteroát.nitrog.dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049071','Medicamento c/levamisol/seus sais/tetramisol, em doses','Medicament c/levamisole/its salts/tetramisole, in doses','Medicamento c/levamisol/sus sales/tetramisol, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049072','Medicamento c/sulfadiazina/seu sal sódico, etc.em doses','Medicament c/sulfadiazine/its sodium salt, in doses','Medicamento c/sulfadiazina/su sal sódica, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049073','Medicamento contendo ketazolam/sulpirida, etc.em doses','Medicament c/ketazolam/sulpiride, etc.in doses','Medicamento q contenga ketazolam/sulpirida, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049074','Medicamento c/ftalilsulfatiazol/bumetanida, etc.em doses','Medicament c/phthalylsulfathiazole/butanide, etc.doses','Medicamento c/ftalilsulfatiazol/bumetanida, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049075','Medicamento cont.enantato de flufenazina, etc.em doses','Medicament c/fluphenazine enanthate, etc.in doses','Medicamento q cont.enantato de flufenazina, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049076','Medicamento cont.furosemida/clortalidona, etc.em doses','Medicament c/furosemide/chlorthalidone, etc.in doses','Medicamento q cont.furosemida/clortalidona, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049077','Medicamento cont.cloridrato de tizanidina, etc.em doses','Medicament c/tizanidine hydrochloride, etc.in doses','Medicam. q cont.clorhidrato de tizanidina, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049078','Medicamento cont.topotecan, uracil, tegafur, etc.em doses','Medicament c/topotecan, uracil, tegafur, etc.in doses','Medicam. q cont.topotecan, uracil, tegafur, etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049079','Outros medicamentos c/compostos heterocicl.etc.em doses','Medicament c/compounds heterocyclic, etc.in doses','Los dem.medicamentos c/compuest.heterocícl.etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049091','Medicamento contendo extrato de polen, em doses','Medicament containing pollen extract, in doses','Medicamento que contenga extracto de polen,  en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049092','Medicamento contendo disofenol/crisarobina, etc.em doses','Medicament containing disophenol/chyrsarobin, etc.doses','Medicamento q cont. disofenol/crisarobina,  etc.en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049093','Medicamento contendo diclofenaco resinato, em doses','Medicament containing diclofenac resinate, doses','Medicamento q contenga diclofenaco resinato, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049094','Medicamento contendo silimarina, em doses','Medicament containing silymarin, doses','Medicamento que contenga silimarina,  en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049095','Medicamento cont.propofol, busulfano, mitotano, em doses','Medicament cont.propofol, busulfan, mitotane, doses','Medicamento q cont.propofol, busulfano, mitotano, en dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049096','Complexo de ferro dextrana','Iron dextran complex','Complejo de hierro dextrana',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30049099','Outros medicam.cont.prods.p/fins terapêuticos, etc.doses','Oth.medicament cont.prod.for therapeutic uses, etc.doses','Los dem.medicam.q cont.prods.p/fines terapéut.etc.dosis',10,'30','3004','300490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30051010','Pensos adesivos impregn/recob.subst.farmaceut','Adhesive dressings impregnated/coated pharmaceut.subst.','Apósitos impregn/recub.de subst.farmacéut.',10,'30','3005','300510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30051011','Pensos adesivos cont.nitroglicerina, absorv.via cutanea','Adhesive dressings c/nitroglycerine, fortransdermal adm.','Apósitos q cont.nitroglic., absorb.vía cutánea',10,'30','3005','300510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30051012','Pensos adesivos cont.estradiol, absorção por via cutanea','Adhesive dressings c/oestradiol, fortransdermal adminis.','Apósitos q cont.estradiol, absorc.vía cutánea',10,'30','3005','300510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30051019','Outs.pensos adesivos, impregnados, etc.subst.farmacêutica','Oth.adhesive dressings, impregnated, pharmaceut.etc.subst','Los dem.apósitos, impreg., etc.subst.farmacéutica',10,'30','3005','300510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30051020','Pensos adesivos cirúrgicos de observ.direta de feridas','Surgical dressings allowing direct observ.of the wound','Apósitos quirúrg.q.permitan observ.directa de heridas',10,'30','3005','300510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30051030','Pensos adesivos impermeaveis aplicaveis sobre mucosas','Impermeable dressing for mucous membranes','Apósitos impermeab.aplicables sobre mucosas',10,'30','3005','300510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30051040','Pensos adesivos com obturador, para colostomia','Dressings w/closures, foruse w/colostomies(obtur.cones)','Apósitos con obturador, aptos para colostomía',10,'30','3005','300510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30051050','Pensos adesivos c/fecho de correr, p/fechar ferimentos','Dressings with closure devices, for wound closure','Apósitos c/disp.de cierre, p/cerrar herimiento',10,'30','3005','300510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30051090','Outs.pensos adesivos, artigos analogos c/camada adesiva','Ot.adh.dressings, anal.articles having an adhesive laye','Los dem.apósitos, demás artíc.c/capa adhesiva',10,'30','3005','300510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30059011','Pensos reabsorvíveis, de ácido poliglicólico','Absorbable dressings of polyglycolic acid','Apósitos reabsorbibles,  de ácido poliglicólico',10,'30','3005','300590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30059012','Pensos reabsorvs.de copolim.de ácido glicólico/láctico','Absorbable dres.of glycolic acid-lactic acid copolymers','Apósito reabsorbs.de copolím.de ácido glicólico/láctico',10,'30','3005','300590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30059019','Outros pensos reabsorvíveis','Other dressings absorbable','Los demás apósitos reabsorbibles',10,'30','3005','300590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30059020','Campos cirúrgicos, de falso tecido','Surgical dressings of nonwovens','Campos quirúrgicos,  de telas sin tejer',10,'30','3005','300590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30059090','Outs.pastas, gazes, semelh.p/uso medicinal, cirúrgico, etc.','Oth.wadding, similar foruse medicinal, surgical, etc.','Las dem.guatas, gazas, semej.p/uso medicinal, quirúrg.etc',10,'30','3005','300590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30061010','Materiais para suturas cirúrgicas, de polidiexanona','Material for surgical sutures, of polidiexanona','Materiales para suturas quirúrgicas, de polidiexanona',10,'30','3006','300610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30061011','Materiais para suturas cirúrgicas, de polidiexzanona','Materials for surgical sutures, of polydihexanone','Ligaduras para suturas quirúrgicas, de polidihexanona',10,'30','3006','300610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30061019','Outros materiais para suturas cirúrgicas, sintéticos','Other materials for surgical sutures, synthetic','Otras ligaduras para suturas quirúrgicas, sintéticas',10,'30','3006','300610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30061020','Materiais para suturas cirúrgicas, de aço inoxidável','Materials for surgical sutures, of stainless steel','Ligaduras para suturas quirúrgicas, de acero inoxidable',10,'30','3006','300610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30061090','Outros categutes esterilizados, etc.para suturas cirúrgicas','Other sterile catgut, etc.for surgical sutures','Los dem.catguts esterilizados, etc.p/suturas quirúrgicas',10,'30','3006','300610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30062000','Reagentes para determinação dos grupos/fatores sanguíneos','Reagents fordetermination of the blood-grouping','Reactivos p/determinación de grupos/factores sanguíneos',10,'30','3006','300620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30063011','Preparação opacificante, de loexol, para exame radiográfico','Opacifying preparations based on iohexol, forx-ray exam.','Preparación opacificante, de iohexol, p/examen radiológ.',10,'30','3006','300630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30063012','Pp.opa.de iocarmato dimeglumina ou gadoterato meglumina','Opacif.preparat.of dimeglumine iocarmate, forx-ray exam.','Prepar.opacif.de iocarmato dimeglumina, p/exam.radiológ.',10,'30','3006','300630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30063013','Prepar.opacif de iopamidol/iobitridol p/ex. radiograf.','Opacif.preparat.of iopamidol forx-ray examinattion','Preparación opacificante, de iopamidol, p/examen radiol.',10,'30','3006','300630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30063014','Prepar.opacif.gadopentato dimeglumina, p/exame radiograf','Opacif.preparat.dimeglumine gadop.forx-ray examinattion','Prepar.opacif.gadopentato dimeglumina, p/examen radiol.',10,'30','3006','300630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30063015','Prepar.opacif.dióxido de zircônio, etc.p/exame radiograf','Opacif.preparat.zirconium dioxide, etc.forx-ray examinat.','Prepar.opacif.dióxido de circonio, etc.p/examen radiol.',10,'30','3006','300630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30063016','Prepar.opacif.diatrizoato sódio, etc.p/exame radiograf','Opacif.preparat.sodium diatriazide, etc.forx-ray exam.','Prepar.opacif.diatrizoato sodio, etc.p/examen radiológ.',10,'30','3006','300630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30063017','Prepar.opacif.base ioversol/iopromida, p/exame radiograf','Opacif.preparat.w/base ioversol/iopromide forx-ray exam.','Prepar.opacif.base ioversol/iopromida, p/examen radiol.',10,'30','3006','300630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30063018','Prepar.opacif.iotalamato de sódio, etc.p/exame radiograf','Opacif.preparat.sodium iothalamate, etc.forx-ray exam.','Prepar.opacif.iotalamato de sodio, etc.p/examen radiol.',10,'30','3006','300630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30063019','Outs.preparações opacificantes, para exames radiológicos','Other opacififying preparations, for x-ray examinations','Las dem.preparaciones opacificantes, p/exámenes radiol.',10,'30','3006','300630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30063021','Reagente de diagnost.de somatoliberina, p/admin.paciente','Reagent of diagn.of somatoliberin, foruse in the patient','Reactivo de diagnóst.de somatoliberina, p/usar paciente',10,'30','3006','300630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30063029','Outs.reagentes de diagnóstico, p/ser administr.paciente','Other reagents of diagn. for use in the patient','Los dem.reactivos de diagnóstico, p/usar en el paciente',10,'30','3006','300630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30064011','Cimentos para obturação dentária','Dental cements for filling','Cementos de obturación dental',10,'30','3006','300640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30064012','Outros produtos para obturação dentária','Other dental products for filling','Los demás productos de obturación dental',10,'30','3006','300640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30064020','Cimentos para reconstituição ossea','Bone reconstruction cements','Cementos para refección de los huesos',10,'30','3006','300640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30065000','Estojos e caixas de primeiros-socorros, guarnecidos','First-aid boxes and kits','Botiquines equipados para primeros auxilios',10,'30','3006','300650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30066000','Prepars.quims.contraceptivas, de hormônios/espermicidas','Chemical contraceptive preparat.based on hormone/sperm.','Prepars.químs.anticonceptivas, de hormonas/espermicidas',10,'30','3006','300660');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30067000','Preparações em gel, util.interv.cirúrgica, etc.','Preparations in gel,  used surgical intervention, etc.','Preparaciónes em gel, util.operac.quirúrgica, etc.',10,'30','3006','300670');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30068000','Desperdícios farmacêuticos','Pharmaceuticals waste','Desperdicios farmacéuticos',10,'30','3006','300680');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30069110','Bolsas para uso em colostomia, ileostomia/urostomia','Plastic bags for colostomy, ileostomy, urostomy','Bolsas de plástico, para colostomia, ileostomia o urostomia',10,'30','3006','300691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30069190','Outros equips. identifics. para uso em ostomia','Other identified equipment for use in ostomy','Otros equipos identificados para uso en ostomia',10,'30','3006','300691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('30069200','Desperdícios farmacêuticos','Pharmaceuticals waste','Desperdicios farmacéuticos',10,'30','3006','300692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31010000','Adubos ou fertilizantes de origem animal/vegetal, etc.','Fertilisers obtained animal/vegetable, etc','Abonos de origen animal/vegetal, etc.',10,'31','3101','310100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31021010','Uréia com teor de nitrogênio>45% em peso','Urea containing of nitrogen>45% weighing','Urea con un contenido de nitrógeno>al 45% en peso',10,'31','3102','310210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31021090','Outras uréias, mesmo em solução aquosa','Other urea, whether or not in aqueous solution','Las demás ureas,  incluso en disolución acuosa',10,'31','3102','310210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31022100','Sulfato de amônio','Ammonium sulphate','Sulfato de amonio',10,'31','3102','310221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31022910','Sulfonitrato de amônio','Ammonium sulphonitrate','Sulfonitrato de amonio',10,'31','3102','310229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31022990','Outs.sais duplos/misturas, de sulfato/nitrato de amônio','Oth.double salts/mixtures of sulphate/ammonium nitrate','Los dem.sales dobles/mezclas, de sulfato/nitrat.de amon.',10,'31','3102','310229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31023000','Nitrato de amônio, mesmo em solução aquosa','Ammonium nitrate, whether or not in aqueous solution','Nitrato de amonio,  incluso en disolución acuosa',10,'31','3102','310230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31024000','Misturas de nitrato de amônio c/carbonato de cálcio, etc','Mixtures of ammonium nitrate with calcium carbonate, etc','Mezclas de nitrato de amonio c/carbonato de calcio, etc',10,'31','3102','310240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31025011','Nitrato de sódio, natural, com teor de nitrogênio<=16.3%','Sodium nitrate, natural, containing nitrogen<=16.3%','Nitrato de sodio, natural, con cont.de nitrogéno<=al16.3%',10,'31','3102','310250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31025019','Outros nitratos de sódio, naturais','Other sodium nitrate, natural','Los demás nitratos de sodio,  naturales',10,'31','3102','310250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31025090','Outros nitratos de sódio','Other sodium nitrate','Los demás nitratos de sodio',10,'31','3102','310250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31026000','Sais duplos e misturas de nitratos de cálcio e amônio','Double salts mixtures of calcium nitrate and ammonium','Sales dobles y mezclas de nitratos de calcio y amonio',10,'31','3102','310260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31027000','Cianamida cálcica','Calcium cyanamide','Cianamida cálcica',10,'31','3102','310270');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31028000','Misturas de uréia c/nitrato de amônio, em sol.aquosa, etc','Mixtures of urea w/ammonium nitrate in aqueous sol., etc','Mezclas de urea c/nitrato de amonio, en disol.acuosa, etc',10,'31','3102','310280');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31029000','Outs.adubos ou fertiliz.minerais/químicos, nitrogenados','Oth.fertilizer chemical/minerals, nitrogenous','Los demás abonos minerales/químicos, nitrogenados',10,'31','3102','310290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31031010','Superfosfato, teor de pentóxido de fósforo (p2o5)<=22%','Superphosphates, cont.phosphorus pentoxide(p2o5)<=22%','Superfosfato, c/cont.de pentóxid.de fósforo(p2o5)<=al22%',10,'31','3103','310310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31031020','Superfosfato, teor de pentóxido de fósforo, 22%<p2o5<=45%','Superphosphates, cont.phosphorus pentoxide, 22%<p2o5<=45%','Superfosfato, c/cont.de pentóxido fósforo, 22%<p2o5<=45%',10,'31','3103','310310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31031030','Superfosfato, teor de pentóxido de fósforo (p2o5)>45%','Superphosphates, cont.phosphorus pentoxide (p2o5)>45%','Superfosfato, c/cont.de pentóxido de fósforo(p2o5)>al45%',10,'31','3103','310310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31032000','Escórias de desfosforacao','Basic slag','Escorias de desfosforación',10,'31','3103','310320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31039011','Hidrogeno-ortofosfato de cálcio, teor de p2o5<=46%','Hydrogenorthophosphate calcium cont.p2o5<=46%','Hidrógenoortofosfato de calcio, c/un cont.de p2o5<=al46%',10,'31','3103','310390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31039019','Outros hidrogenos-ortofosfatos de cálcio','Other hydrogenorthophosphate calcium','Los demás hidrógenoortofosfatos de calcio',10,'31','3103','310390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31039090','Outros adubos ou fertilizs.minerais/químicos, fosfatados','Other mineral or chemical fertilisers, phosphatic','Los demás abonos minerales/químicos, fosfatados',10,'31','3103','310390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31041000','Carnalita e outros sais de potássio, naturais, em bruto','Carnalite and other crude natural potassium salts','Carnalita y demás sales de potasio,  naturales,  en bruto',10,'31','3104','310410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31042010','Cloreto de potássio, teor de óxido de potássio(k2o)<=60%','Potassium chloride, containing potassium oxide(k2o)<=60%','Cloruro de potasio, c/cont.de óxido de potasio(k2o)<=60%',10,'31','3104','310420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31042090','Outros cloretos de potássio','Other potassium chloride','Los demás cloruros de potasio',10,'31','3104','310420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31043010','Sulfato de potássio, teor de óxido de potássio(k2o)<=52%','Potassium sulphate, potassium oxide(k2o)<=52%','Sulfato de potasio, c/cont.de óxido de potasio(k2o)<=52%',10,'31','3104','310430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31043090','Outros sulfatos de potássio','Other potassium sulphate','Los demás sulfatos de potasio',10,'31','3104','310430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31049010','Sulfato duplo de potássio e de magnésio, teor de k2o>30%','Sulphate double of potassium and magn., cont.k2o>al30%','Sulfato doble de potasio y magnesio, c/cont.de k2o>al30%',10,'31','3104','310490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31049090','Outros adubos ou fertilizs.minerais/químicos, potássicos','Other mineral or chemical fertilisers, potassic','Los demás abonos minerales/químicos, potásicos',10,'31','3104','310490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31051000','Adubos ou fertilizantes em tabletes/embalagens p<=10kg','Fertilisers in tablets/packages wei.<=10kg','Abonos o fertiliz.en tabletas/envases de un peso<=10kg',10,'31','3105','310510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31052000','Adubos ou fertilizantes c/nitrogênio, fósforo e potássio','Fertilisers contaning nitrogen, phosphorus and potassium','Abonos o fertilizantes c/nitrógeno, fósforo y potasio',10,'31','3105','310520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31053010','Hidrogeno-ortofosfato de diamônio, teor arsênio>=6mg/kg','Diammonium hydrogenorthophosphate arsenic>=6mg/kg','Hidrogenoortofosfato de diamonio, c/cont.arsénic>=6mg/kg',10,'31','3105','310530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31053090','Outros hidrogenos-ortofosfatos de diamônio','Other diammonium hydrogenorthophosphate','Los demás hidrógenoortofosfatos de diamonio',10,'31','3105','310530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31054000','Diidrogeno-ortofosfato de amônio, incl.mist.hidrogen.etc','Ammonium dihydrogenorthophosphate, inc.mixtures hydr.etc','Dihidrógenoortofosfato de amonio, incl.mezcl.hidrog.etc',10,'31','3105','310540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31055100','Adubos ou fertilizantes c/nitrato e fosfato','Fertilisers containing nitrate and phosphate','Abonos o fertilizantes que contengan nitrato y fosfato',10,'31','3105','310551');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31055900','Outs.adubos/fertiliz.miner.quim.c/nitrogênio e fósforo','Other fertilisers cont.mineral/chemical c/nitrate/phosp','Los dem.abonos/fertil.miner.quím.c/nitrógeno y fósforo',10,'31','3105','310559');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31056000','Adubos ou fertilizantes c/fósforo e potássio','Fertilisers containing phosphorus and potassium','Abonos o fertilizantes con fósforo y potasio',10,'31','3105','310560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31059011','Nitrato de sódio potassico, teor de n<=15% e k2o<=15%','Nitrate of sodium potassic, cont.n<=15% and k2o<=15%','Nitrato de sodio potásico, tenor de n<=15% y k2o<=15%',10,'31','3105','310590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31059019','Outros nitratos de sódio potássico','Other nitrate of sodium potassic','Los demás nitratos de sodio potásico',10,'31','3105','310590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('31059090','Outs.adubos/fertiliz.miner.quim.c/nitrogênio e potássio','Other fertilisers min./chem.c/nitrogen and potassium','Los dem.abonos/fertil.miner.quím.c/nitrógeno y potasio',10,'31','3105','310590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32011000','Extrato tanante, de quebracho','Tanning extract, of quebracho','Extracto curtiente, de quebracho',10,'32','3201','320110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32012000','Extrato tanante, de mimosa','Tanning extracts, of wattle','Extracto curtiente, de mimosa',10,'32','3201','320120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32019011','Extrato tanante, de gambir','Tanning extracts, of gambier','Extracto curtiente, de gambir',10,'32','3201','320190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32019012','Extrato tanante, de carvalho ou de castanheiro','Tanning extract, of oak or chestnut','Extracto curtiente, de roble o de castaño',10,'32','3201','320190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32019019','Outros extratos tanantes, de origem vegetal','Tanning extracts of vegetable origin','Los demás extractos curtientes, de origen vegetal',10,'32','3201','320190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32019020','Taninos','Tannins','Taninos',10,'32','3201','320190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32019090','Sais, éteres, ésteres e outros derivados dos taninos','Salts, ethers, esters and other derivatives of tannins','Sales, éteres, ésteres y demás derivados de los taninos',10,'32','3201','320190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32021000','Produtos tanantes orgânicos sintéticos','Products synthetic organic tanning','Productos curtientes orgánicos sintéticos',10,'32','3202','320210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32029011','Produtos tanantes, à base de sais de cromo','Products tanning, with a basis of chromium salts','Productos curtientes, a base de sales de cromo',10,'32','3202','320290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32029012','Produtos tanantes, à base de sais de titânio','Products tanning, with a basis of titanium salts','Productos curtientes, a base de sales de titanio',10,'32','3202','320290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32029013','Produtos tanantes, à base de sais de zircônio','Products tanning, with a basis of zirconium salts','Productos curtientes, a base de sales de circonio',10,'32','3202','320290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32029019','Outros produtos tanantes inorgânicos','Other products inorganic tanning','Los demás productos curtientes inorgánicos',10,'32','3202','320290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32029021','Preparações tanantes, à base de compostos de cromo','Tanning preparations, with a basis of chromium compounds','Preparaciones curtientes,  a base de compuestos de cromo',10,'32','3202','320290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32029029','Outras preparações tanantes','Other tanning preparations','Las demás preparaciones curtientes',10,'32','3202','320290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32029030','Preparações enzimáticas, para a pre-curtimenta','Enzymatic preparations for pre-tanning','Preparaciones enzimáticas, para precurtido',10,'32','3202','320290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32030011','Hemateina (matéria corante)','Hematein (coloring matter)','Hemateína (materia colorante)',10,'32','3203','320300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32030012','Fisetina (matéria corante)','Fisetin (colorin matter)','Fisetina (materia colorante)',10,'32','3203','320300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32030013','Morina (matéria corante)','Morin (cloring matter)','Morina (materia colorante)',10,'32','3203','320300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32030019','Outras matérias corantes, de origem vegetal','Other colouring matter of vegetable origin','Las demás materias colorantes, de origen vegetal',10,'32','3203','320300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32030021','Carmim de cochonilha (matéria corante)','Cochineal(colouring matter)','Carmín de cochinilla (materia colorante)',10,'32','3203','320300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32030029','Outras matérias corantes, de origem animal','Other coloring matter of animal origin','Las demás materias colorantes, de origen animal',10,'32','3203','320300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32030030','Prepars.à base de matérias corantes, orig.vegetal/animal','Prep.with a base colour.matter of veget./animal origin','Prepars.a base de materias colorantes, orig.veg./animal',10,'32','3203','320300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041100','Corantes dispersos e suas preparações','Disperse dyes and its preparations','Colorantes dispersos y sus preparaciones',10,'32','3204','320411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041210','Corantes ácidos, mesmo metalizados e suas preparações','Acid dyes, whether or n/premetallized, and its preparat.','Colorantes ácidos, incluso metalizados y sus preparac.',10,'32','3204','320412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041220','Corantes mordentes e suas preparações','Mordant dyes and its preparations','Colorantes mordientes y sus preparaciones',10,'32','3204','320412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041300','Corantes basicos e suas preparações','Basic dyes and its preparations','Colorantes básicos y sus preparaciones',10,'32','3204','320413');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041400','Corantes diretos e suas preparações','Direct dyes and its preparations','Colorantes directos y sus preparaciones',10,'32','3204','320414');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041510','Corante indigo blue, segundo colour index 73000','Vat blue dye, second colour index 73000','Colorante azul a la tina,  según colour index 73000',10,'32','3204','320415');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041520','Corante dibenzantrona','Dibenzanthrone dye','Colorante dibenzantrona',10,'32','3204','320415');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041530','Corante 12, 12-dimetoxidibenzantrona','12, 12-dimethoxybenzanttrone dye','Colorante 12, 12-dimetoxidibenzantrona',10,'32','3204','320415');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041590','Outros corantes a cuba e suas preparações','Other vat dyes and its preparations','Los demás colorantes a la cuba y sus preparaciones',10,'32','3204','320415');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041600','Corantes reagentes e suas preparações','Other reagents dye and its preparations','Colorantes reactivos y sus preparaciones',10,'32','3204','320416');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041700','Pigmentos e suas preparações','Pigments and its preparations','Colorantes pigmentarios y sus preparaciones',10,'32','3204','320417');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041911','Carotenóides','Carotenoids','Carotenoides',10,'32','3204','320419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041912','Preparações cont.beta-caroteno, etc.p/colorir alimentos','Preparations c/beta-carotene, etc.to color food','Preparaciones q cont.beta-caroteno, etc.p/colorear alim.',10,'32','3204','320419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041913','Outras preparações para colorir alimentos','Other preparations to color food','Las demás preparaciones p/colorear alimentos',10,'32','3204','320419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041919','Outras preparações à base de caratenóides','Other preparations with a base of caratenoids','Las demás preparaciones a base de carotenoides',10,'32','3204','320419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041920','Corantes solúveis em solventes (corantes solventes)','Dyes soluble in solvent (solvent dyes)','Colorantes solubles en disolventes(colorant.solventes)',10,'32','3204','320419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041930','Corantes azóicos','Azo dyes','Colorantes azoicos',10,'32','3204','320419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32041990','Outs.matérias corantes orgânicas sintet.e suas prepars.','Oth.colouring matter organic synthetic and its prepar.','Las dem.mater.colorantes orgánicas sintét.y sus prepar.',10,'32','3204','320419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32042011','Derivs.do ácido 4, 4-bis-(1, 3, 5)triazinil-6-aminoest.etc','4, 4-bis(1, 3, 5)triazinyl-6-amin.-2, 2-disulp.acid der.etc','Derivs.del ácido 4, 4-bis(1, 3, 5)triazinil-6-aminoest.etc',10,'32','3204','320420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32042019','Outs.derivs.do estilbeno, util.agente avivam.fluorescent','Oth.stilbene deriv.used as fluoresc.brightening agents','Los dem.deriv.del estilbeno, util.p/el avivado fluoresc.',10,'32','3204','320420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32042090','Outs.prods.organ.sintet.util.agente avivam.fluorescente','Ot.synt.org.prod.used as fluorescent brightening agents','Los dem.prods.orgán.sintet.util.p/el avivado fluoresc.',10,'32','3204','320420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32049000','Outras matérias corantes organicas sintéticas, etc.','Other synthetic organic colouring matter, etc.','Las dem.materias colorantes orgánicas sintéticas,  etc.',10,'32','3204','320490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32050000','Lacas corantes e suas preparações','Colour lakes and its preparations','Lacas colorantes y sus preparaciones',10,'32','3205','320500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32061111','Pigmento rutilo, particula>=0.6 microns, c/modificadores','Rutile pigments particle size of>=0.6 microns, c/modif.','Pigmento rutilo, partícula>=0.6 microns, c/modificadores',10,'32','3206','320611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32061119','Outs.pigmentos tipo rutilo, c/dióxido titânio>=80% seco','Oth.rutile pigments, c/titanium dioxide>=80% dried','Los dem.pigmentos tip.rutilo, c/dióxido titanio>=80%seco',10,'32','3206','320611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32061120','Outros pigmentos contendo dióxido de titânio>=80% seco','Ot.pigments containing titanium dioxide>=80% dried','Los dem.pigmentos q conteng.dióxido de titanio>=80%seco',10,'32','3206','320611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32061121','Pigmento anatase, contendo dióxido de titânio>=80% seco','Anatase pigments, cont.titanium dioxide>=80% dried','Pigmento anatasa, q contenga dióxido de titanio>=80%seco',10,'32','3206','320611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32061129','Outros pigmentos contendo dióxido de titânio>=80% seco','Other pigments containing titanium dioxide>=80% dried','Los dem.pigmentos q conteng.dióxido de titanio>=80%seco',10,'32','3206','320611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32061130','Preparações à base de dióxido de titânio, peso>=80%','Preparations based on titanium dioxide, weighing>=80%','Preparaciones a base de dióxido de titanio, c/peso>=80%',10,'32','3206','320611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32061910','Pigmento const.por mica revest.pelicula dióxido titânio','Pigment consist.of mica coated w/titanium dioxide','Pigmento const.por mica revest.película dióxido titanio',10,'32','3206','320619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32061990','Outros pigmentos e prepars.à base de dióxido de titânio','Other pigments and prep.with a base of titanium dioxide','Los dem.pigmentos y prepar.a base de dióxido de titanio',10,'32','3206','320619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32062000','Pigmentos e preparações à base de compostos de cromo','Pigments and preparations based on chromium compounds','Pigmentos y preparaciones a base de compuestos de cromo',10,'32','3206','320620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32063000','Pigmentos e preparações à base de compostos de cádmio','Pigments and preparations based on cadmium compounds','Pigmentos y preparaciones a base de compuests.de cadmio',10,'32','3206','320630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32064100','Ultramar e suas preparações','Ultramarine and its preparations','Ultramar y sus preparaciones',10,'32','3206','320641');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32064210','Litopônio','Lithopone','Litópon',10,'32','3206','320642');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32064290','Outs.pigmentos e preparações à base de sulfeto de zinco','Other pigments and preparations based on zinc sulphide','Los dem.pigmentos y preparac.a base de sulfuro de cinc',10,'32','3206','320642');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32064300','Pigmentos e preparações à base de hexacianoferratos','Pigments and preparations based on hexacyanoferrates','Pigmentos y preparaciones a base de hexacianoferratos',10,'32','3206','320643');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32064900','Outras matérias corantes e preparações','Other colouring matter and preparations','Las demás materias colorantes y preparaciones',10,'32','3206','320649');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32064910','Pigmentos prepars. à base d/comps.d/cádmio','Pigments prepared based on cadmium compounds','Pigmentos preparados a base de compuestos de cadmio',10,'32','3206','320649');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32064920','Pigmentos, prep.à base de hexacianoferratos','Pigments, prepared on hexacyanoferrate','Pigmentos preparados a base de hexacianoferratos',10,'32','3206','320649');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32064990','Outras matérias corantes e preparações','Other coloring matter and preparations','Otras materias colorantes y preparados',10,'32','3206','320649');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32065011','Halofosfatos de cálcio, etc.c/subst.radioativ.util.lumin','Calcium halophosp., etc.without subs.rad.used illumin.','Halofosfatos de calcio, etc.c/subst.radioactiv.util.lumi',10,'32','3206','320650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32065019','Outros prods.inorgan.util.luminoforos, c/subst.radioativ','Other inorg.prod.used as luminophores, with radioactive substances','Otros prods.inorg.util.luminóforos, c/sust.radioactiv.',10,'32','3206','320650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32065021','Halofosfatos de cálcio, etc.s/subst.radioativ.util.lumin','Calcium halophosp., etc.without subs.rad.used illumin.','Halofosfatos de calcio, etc.s/sust.radioactiv.util.lumin',10,'32','3206','320650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32065029','Outros prods.inorgan.util.luminoforos, s/subst.radioativ','Ot.inorg.prod.used as luminophores, without radioac.sub.','Los dem.prods.inorg.util.luminóforos, s/sust.radioactiv.',10,'32','3206','320650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32071010','Pigmento, opacificante, etc.à base de zircônio/seus sais','Pigment, opacifier, etc.with a basis of zircon./its salts','Pigmento, opacificante, etc.a base de circonio/sus sales',10,'32','3207','320710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32071090','Outs.pigmentos, opacificantes/cores, preparados e prepars','Oth.pigments, opacifiers/colors, prepareds and prepareds','Los dem.pigment.pacificantes/colores, preparados y prep.',10,'32','3207','320710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32072010','Engobos','Engobes (slips)','Engobes',10,'32','3207','320720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32072090','Composições vitrificáveis e preparações semelhantes','Vitrifiable compounds and similar preparations','Composiciones vitrificables y preparaciones similares',10,'32','3207','320720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32072091','Composições vitrif.e prepar.util.fabr.circuito impresso','Vitrifiable compounds and preparations circuit impres.','Composiciones vitrif.y prep.util.fabr.circuito impreso',10,'32','3207','320720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32072099','Outs.composições vitrificáveis e preparações semelh.','Other vitrifiable compounds and similar preparations','Las dem.composic.vitrificables y preparaciones simil.',10,'32','3207','320720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32073000','Polimentos líquidos e preparações semelhantes','Liquid lustres and similar preparations','Abrillantadores líquidos y preparaciones similares',10,'32','3207','320730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32074010','Fritas de vidro, em pó, em grânulos, em lamelas ou flocos','Glass frit and other glass, in powder, granules or flakes','Fritas de vidrio, en polvo, gránulos, escamillas o copos',10,'32','3207','320740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32074090','Outros vidros em pó, em grânulos, em lamelas ou em flocos','Ot.glass frit and other glass in powder/granules/flakes','Otros vidrios, en polvo, gránulos, escamillas o copos',10,'32','3207','320740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32081010','Tintas de poliésteres, dispersos/dissolv.meio n/aquoso','Paint of polyesters, dispersed/dissolved n/aqueous','Pinturas de poliésteres, dispersos/disuelt.medion/acuoso',10,'32','3208','320810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32081020','Vernizes de poliésteres, dispersos/dissolv.meio n/aquoso','Varnishes of polyesters, dispersed/dissolved n/aqueous','Barnices de poliésteres, dispersos/disuelt.medion/acuoso',10,'32','3208','320810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32081030','Soluções de poliésteres, dispersos/dissolv.meio n/aquoso','Solutions of polyesters, dispersed/dissolved n/aqueous','Disoluc.de poliésteres, dispersos/disuelt.medio n/acuoso',10,'32','3208','320810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32082010','Tintas de polim.acril/vinil.dispersos/dissolv.n/aquoso','Paint of acrylic/vinyl polymers, dispersed/dissol.n/aqueous','Tintas de polím.acr./viníl.dispersos/disuelt.n/acuoso',10,'32','3208','320820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32082011','Tintas d/políms.acríls, p/fabr.d/circs.impres.','Paint of acrylic polymers, for producing printed circuits','Tintas de polímeros acrílicos, para fabricación de circuitos impresos',10,'32','3208','320820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32082019','Outs.tintas à base d/políms.acríls.ou vinílicos','Other paints based on acrylic or vinyl polymers','Otras tintas basadas en polímeros acrílicos o de viníl',10,'32','3208','320820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32082020','Vernizes de polim.acril/vinil.dispers/dissolv.n/aquoso','Varnishes acrylic/vinyl polym., disper./dissol.n/aqueous','Barnices de polím.acríl/vin.dispersos/disuelt.n/acuoso',10,'32','3208','320820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32082030','Soluções de polim.acril/vinil.dispers/dissolv.n/aquoso','Solutions acrylic/vinyl polym., disper./dissol.n/aqueous','Disoluc.de polím.acríl/viníl.dispersos/disuelt.n/acuoso',10,'32','3208','320820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32089010','Tintas de outs.polim.sint.etc.dispers/dissolv.n/aquoso','Paint of ot.syn.polymers, etc, dispersed/dissol.n/aqueous','Pinturas de dem.polím.sint.etc, dispers/disuelt.n/acuoso',10,'32','3208','320890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32089021','Vernizes de derivs.celulose, dispersos/dissolv.n/aquoso','Varnishes of cellulose deriv., dispers./dissol.n/aqueous','Barnices de derivs.celulosa, dispersos/disuelt.n/acuoso',10,'32','3208','320890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32089029','Vernizes de out.polim.sint.etc.dispers/dissolv.n/aquoso','Varnishes of ot.synt.polim.etc, disper./dissol.n/aqueous','Barnices de dem.polím.sint.etc, dispers/disuelt.n/acuoso',10,'32','3208','320890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32089031','Soluções de silicones, dispersos/dissolvs.meio n/aquoso','Solutions of silicones dispersed/dissolved n/aqueous','Disoluc.de siliconas, dispersos/disuelt.medio n/acuoso',10,'32','3208','320890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32089039','Outras soluções polim.sint.etc.dispers/dissolv.n/aquoso','Oth.polym.synt.solutions, etc, dispers./dissolv.n/aqueous','Las dem.dis.polím.sint.etc, disp/disuelt.medio n/acuoso',10,'32','3208','320890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32091010','Tintas de polim.acril/vinil.dispers/dissolv.meio aquoso','Paint acrylic/vinyl polymers, dispersed/dissol.n/aqueous','Pinturas de polím.acríl/viníl.disp/disuelt.medio acuoso',10,'32','3209','320910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32091020','Vernizes de polim.acril/vinil.dispersos/dissolv.aquoso','Varnishes of acrylic/vinyl.polim.disper./dissol.aqueous','Barnices de polím.acríl/viníl.dispersos/disuelt.acuoso',10,'32','3209','320910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32099011','Tintas de politetrafluoretileno, dispers/dissolv.aquoso','Paint of polytetrafluoroethylene, disper./dissol.aqueous','Pinturas de politetrafluoroetileno, disp/disuelt.acuoso',10,'32','3209','320990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32099019','Tintas de outs.polim.sint.etc.dispersos/dissolv.aquoso','Paint of oth.synt.polymers, etc, dispersed/dissol.aqueous','Pinturas de ots.polím.sint.etc.dispersos/disuelt.acuoso',10,'32','3209','320990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32099020','Vernizes de outs.polim.sint.etc.dispers/dissolv.aquoso','Varnishes of oth.synt.polymers, etc, disp./dissol.aqueous','Barnices de ots.polím.sint.etc.dispers/disuelt.acuoso',10,'32','3209','320990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32100010','Outras tintas','Other paints','Las demás pinturas',10,'32','3210','321000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32100020','Outros vernizes','Other varnishes','Los demás barnices',10,'32','3210','321000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32100030','Pigmentos a agua preparados, utiliz.p/acabam.de couros','Prep.water pigments kind used forfinishing leather','Pigmentos al agua preparados, utiliz.p/acabado de cuero',10,'32','3210','321000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32110000','Secantes preparados','Prepared driers','Secativos preparados',10,'32','3211','321100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32121000','Folhas para marcar a ferro','Stamping foils','Hojas para el marcado a fuego',10,'32','3212','321210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32129010','Alumínio em pó, etc.empastado c/solvente hidrocarboneto','Aluminum in powd., etc, pasted with solvent hidrocarbon','Aluminio en polvo, etc.empastado c/solvente hidrocarb.',10,'32','3212','321290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32129090','Outs.pigmentos dispers.meios n/aquosos, est.líquido, etc.','Oth.pigments, dispersed in non-aqueous, liquid, etc.','Los dem.pigmentos dispers.medios n/acuosos, est.líqu.etc',10,'32','3212','321290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32131000','Cores em sortidos, p/pintura artistica, ativid.educat.etc','Colours in sets, forartistic painting, educat.activit, etc','Colores en surtidos, p/pintura artística, enseñanza, etc',10,'32','3213','321310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32139000','Outs.cores p/pintura artistica, atividade educativa, etc.','Other colours, forartistic painting, educat.activit, etc','Los demás colores p/la pintura artística, enseñanza, etc',10,'32','3213','321390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32141010','Mastique de vidraceiro, cimentos de resinas, outs.mastiq.','Grafting putty, resin cements, other mastics','Masilla, cementos de resina y demás mástiques',10,'32','3214','321410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32141020','Indutos utilizados em pintura','Painters'' fillings','Plastes utilizados en pintura',10,'32','3214','321410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32149000','Indutos n/refratrários do tipo utilizados em alvenaria','Fillings non-refractory used in masonry','Plastes n/refractarios del tipo utiliz. en ambañilería',10,'32','3214','321490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32151100','Tintas pretas, de impressão','Black ink, of printing','Tintas negras, de imprenta',10,'32','3215','321511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32151900','Outras tintas de impressão','Other  ink, of printing','Las demás tintas de imprenta',10,'32','3215','321519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('32159000','Tintas de escrever ou de desenhar e outras tintas','Ink od writing or drawing ink and other inks','Tintas p/escribir o dibujar y demás tintas',10,'32','3215','321590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33011100','Óleo essencial, de bergamota','Essential oil, of bergamot','Aceite esencial, de bergamota',10,'33','3301','330111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33011210','Óleo essencial, de "petit grain" de laranja','Essential oil, of petit grain','Aceite esencial,  de "petit grain" de naranja',10,'33','3301','330112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33011290','Outros óleos essenciais, de laranja','Other essential oils, of orange','Los demás aceites esenciales,  de naranja',10,'33','3301','330112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33011300','Óleo essencial, de limão','Essential oil, of lemon','Aceite esencial, de limón',10,'33','3301','330113');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33011400','Óleo essencial, de lima','Essential oil, of lime','Aceite esencial, de lima',10,'33','3301','330114');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33011900','Óleo essencial, de outros cítricos','Essential oil, of other citric','Aceite esencial, de demás agrios',10,'33','3301','330119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33011910','Óleos essenciais de lima','Essential oil, of lime','Aceite esencial, de lima',10,'33','3301','330119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33011990','Outros óleos essenciais de cítricos','Essential oil, of other citric','Aceite esencial, de otros agrios',10,'33','3301','330119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012100','Óleo essencial, de gerânio','Essential oil, of geranium','Aceite esencial, de geranio',10,'33','3301','330121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012200','Óleo essencial, de jasmim','Essential oil, of jasmin','Aceite esencial, de jazmín',10,'33','3301','330122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012300','Óleo essencial, de alfazema ou lavanda','Essential oil, of lavender or of lavandin','Aceite esencial, de lavanda o de lavandín',10,'33','3301','330123');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012400','Óleo essencial, de hortelã-pimenta (Mentha piperita)','Essential oil, of peppermint (Mentha piperita)','Aceite esencial, de menta piperita (Mentha piperita)',10,'33','3301','330124');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012510','Óleo essencial, de menta japonesa (Mentha arvensis)','Essential oil, of japanese mint (Mentha arvensis)','Aceite esencial, de menta japonesa (Mentha arvensis)',10,'33','3301','330125');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012520','Óleo essencial, de "mentha spearmint"(mentha viridis l)','Essential oil,  of "mentha spearmint"(mentha viridis l)','Aceite esencial, de"mentha spearmint"(mentha viridis l)',10,'33','3301','330125');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012590','Óleo essencial, de outras mentas','Essential oil, of other mints','Aceite esencial, de demás mentas',10,'33','3301','330125');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012600','Óleo essencial, de vetiver','Essential oil, of vetiver','Aceite esencial, de espicanardo (vetiver)',10,'33','3301','330126');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012911','Óleo essencial, de citronela','Essential oil, of citronella','Aceite esencial, de citronela',10,'33','3301','330129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012912','Óleo essencial, de cedro','Essential oil, of cedar','Aceite esencial, de cedro',10,'33','3301','330129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012913','Óleo essencial, de pau-santo (bulnesia sarmientol)','Essential oil, of guaiacum (bulnesia sarmientoi)','Aceite esencial, de palo santo (bulnesia sarmientoi)',10,'33','3301','330129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012914','Óleo essencial, de "lemongrass"','Essential oil, of "lemongrass"','Aceite esencial, de lemongrás',10,'33','3301','330129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012915','Óleo essencial, de pau-rosa','Essential oil, of rosewood','Aceite esencial, de palo rosa',10,'33','3301','330129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012916','Óleo essencial, de palma rosa','Essential oil, of palmarosa','Aceite esencial, de palma rosa',10,'33','3301','330129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012917','Óleo essencial, de coriandro','Essential oil, of coriander','Aceite esencial, de coriandro',10,'33','3301','330129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012918','Óleo essencial, de cabreuva','Essential oil, of cabreuva','Aceite esencial, de cabreúva',10,'33','3301','330129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012919','Óleo essencial, de eucalipto','Essential oil, of eucalyptus','Aceite esencial, de eucalipto',10,'33','3301','330129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012921','Óleos essenciais de alfazema ou de lavanda','Other essential oils, of lavender','Otros aceites esenciales, de lavanda',10,'33','3301','330129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012922','Óleos essenciais de vetiver','Essential oil, of vetiver','Aceite esencial, de espicanardo (vetiver)',10,'33','3301','330129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33012990','Outros óleos essenciais','Other essential oils','Los demás aceites esenciales',10,'33','3301','330129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33013000','Resinóides','Resinoids','Resinoides',10,'33','3301','330130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33019010','Soluções concentradas de óleos essenciais do tratam.flores','Concent.of essential oils in fats of treatment of flow.','Disoluc.concentr.de aceites essenciales del tratam.flor',10,'33','3301','330190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33019020','Subprods.terpenicos resids.da desterp.óleos essenciais','Terpenic by-prod.of the deterpenation of essent.oils','Subprods.terpénicos resids.de la desterp.aceites esenc.',10,'33','3301','330190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33019030','Água destilada aromat.e sol.aquosa de óleos essenciais','Aqueous distillates arom./aqueous solut.of essent.oils','Destilados aromát.y disol.acuosa de aceites esenciales',10,'33','3301','330190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33019040','Oleorresinas de extração','Extracted oleoresins','Oleorresinas de extracción',10,'33','3301','330190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33021000','Misturas util.materia básica p/inds.alimentar/de bebida','Mixtures used basic matter forfood or drink industries','Mezclas util.materia básica p/ind.alimentaria/de bebida',10,'33','3302','330210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33029011','Vetiverol para perfumaria','Vetiverol for perfumery','Vetiverol para perfumería',10,'33','3302','330290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33029019','Outras misturas utiliz.como materia básica p/perfumaria','Other mixtures used as basic matter forperfumery','Las dem.mezclas utiliz.como materia básica p/perfumería',10,'33','3302','330290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33029090','Outras misturas utiliz.como materia básica p/industria','Other mixtures used as basic matter forindustry','Las dem.mezclas utiliz.como materia básica p/industria',10,'33','3302','330290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33030010','Perfumes (extratos)','Perfumes (extracts)','Perfumes (extractos)',10,'33','3303','330300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33030020','Água-de-colônia','Cologne water','Agua de tocador',10,'33','3303','330300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33041000','Produtos de maquilagem para os lábios','Lip make-up preparations','Preparaciones para el maquillaje de los labios',10,'33','3304','330410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33042010','Sombra, delineador, lápis para sobrancelhas e rímel','Eyeshadow, liner, pencil forbrows and mascara','Sombra, delineador, lápices para cejas y máscara',10,'33','3304','330420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33042090','Outros produtos de maquilagem para os olhos','Other product of eye make-up','Las demás preparaciones para el maquillaje de los ojos',10,'33','3304','330420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33043000','Preparações para manicuros e pedicuros','Manicure or pedicure preparations','Preparaciones para manicuras y pedicuros',10,'33','3304','330430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33049100','Pós, incluídos os compactos, para maquilagem','Powders, whether or not compressed, for make-up','Polvos, incluidos los compactos, para maquillaje',10,'33','3304','330491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33049910','Cremes de beleza, cremes nutritivos e loções tônicas','Creams of beauty, nutritious creams and tonic lotions','Cremas de belleza, cremas nutritivas y lociones tónicas',10,'33','3304','330499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33049990','Outs.produtos de beleza ou de maquilagem preparados, etc','Other products  of beauty or make-up preparations, etc','Las dem.prep.de belleza o de maquillaje preparadas, etc',10,'33','3304','330499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33051000','Xampus para os cabelos','Shampoos for hair','Champúes para el cabello',10,'33','3305','330510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33052000','Prepars.p/ondulacao/alisamento/permanentes, dos cabelos','Preparations for permanent waving/straightening, of hair','Prepars.p/ondulación/desrizado/permanente, de cabellos',10,'33','3305','330520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33053000','Laques para os cabelos','Hair lacquers','Lacas para el cabello',10,'33','3305','330530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33059000','Outras preparações capilares','Other preparations for use on the hair','Las demás preparaciones capilares',10,'33','3305','330590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33061000','Dentifrícios','Dentifrices','Dentífricos',10,'33','3306','330610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33062000','Fios utilizzados para limpar espaços interdentais (fio dental)','Yarn used to clean between the teeth (dental floss)','Hilo utiliz.p/limpiez.de espacios interdent(hilo dent.)',10,'33','3306','330620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33069000','Outras preparações para higiene bucal ou dentária, etc.','Other preparations for oral or dental hygiene, etc.','Las dem.preparaciones para higiene bucal o dental, etc.',10,'33','3306','330690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33071000','Preparações para barbear (antes, durante ou após)','Pre-shave, shaving or after-shave preparations','Preparaciones para afeitar(p/antes o después del afeit)',10,'33','3307','330710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33072010','Desodorantes corporais e antiperspirantes, líquidos','Personal deodorants and antiperspirants, liquid','Desodorantes corporales y antitranspirantes,  líquidos',10,'33','3307','330720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33072090','Outros desodorantes corporais e antiperspirantes','Other personal deodorants and antiperspirants','Los dem.desodorantes corporales y antitranspirantes',10,'33','3307','330720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33073000','Sais perfumados e outras preparações para banhos','Perfumed bath salts and other bath preparations','Sales perfumadas y demás preparaciones para el baño',10,'33','3307','330730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33074100','Agarbate e outs.prepar.odoriferas que atuem p/combustão','Agarbatti, oth.odoriferous prepar.which operat.b/burning','Agarbatti y dem.prepar.odoríferas q actúan p/combustión',10,'33','3307','330741');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33074900','Outs.preparações para perfumar ou desodorizar ambientes','Other prep.for perfuming/deodorizing ambient','Los dem.preparaciones p/perfumar o desodorizar locales',10,'33','3307','330749');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('33079000','Outros prods.de perfumaria ou toucador, preparados, etc.','Oth.prods.of perfumery or dressing table, prepared, etc','Los demás prods.de perfumería o tocador, preparados, etc.',10,'33','3307','330790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34011110','Sabões medicinais, em barras, pedaços, figura moldada, etc.','Medicinal soaps, in bars, pieces, moulded illustration, etc','Jabones medicin., en barras, trozos, pieza moldeada, etc.',10,'34','3401','340111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34011190','Outros prods/prepars.de toucador, em barras, pedaços, etc.','Other prods/prep.dressing table, in bars, pieces, etc','Los dem.prods/prepars.de tocador, en barras, trozos, etc.',10,'34','3401','340111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34011900','Outs.sabões/produtos/preparações, em barras, pedaços, etc.','Other soaps, prods/preparations, in bars, pieces, etc','Los dem.jabones/prods/prepars., en barras, trozos, etc.',10,'34','3401','340119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34012010','Sabões de toucador, sob outras formas','Soap of dressing table, in other forms','Jabones de tocador, en otras formas',10,'34','3401','340120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34012090','Outros sabões','Other soaps','Otros jabones',10,'34','3401','340120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34013000','Prods.e prepars.organ.tensoativos, p/lav.pele','Organic surface-active prods/prepar.forwashing the skin','Prods.y prepars.orgán.tensoactivos, p/lavado de la piel',10,'34','3401','340130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34021110','Dibutilnaftalenossulfato de sódio (agente organ.superf)','Sodium dibutylnaphthalenesulphonate(org.surf.act.agen.)','Dibutilnaftalensulfato de sodio(agente de superf.orgán)',10,'34','3402','340211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34021120','N-metil-n-oleitaurato de sódio (agente organ.de superf)','Sodium n-methyl-n-oleolyltaurate (org.surf.act.agen.)','N-metil-n-oleoiltaurato de sodio(agente superf.organ)',10,'34','3402','340211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34021130','Alquilsulfonato de sódio, secundário (agente org.superf)','Sodium alkylsulphonates, secondary (org.surf.act.agen.)','Alquilsulfonato de sodio, secundario(agente superf.org)',10,'34','3402','340211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34021140','Mistura de ácidos alquilbenzenossulfonicos','Alquilbenzenossulphonated acid mixing','Mezcla de ácidos alquilbenzenossulfonicos',10,'34','3402','340211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34021190','Outros agentes orgânicos de superfície, anionicos','Other organic surface-active agents, anionic','Los dem.agentes de superficie orgánicos,  aniónicos',10,'34','3402','340211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34021210','Acetato de oleilamina (agente orgânico de superfície)','Oleylamine acetate (organic surface-active agent)','Acetato de oleilamina (agente de superficie orgánico)',10,'34','3402','340212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34021290','Outros agentes orgânicos de superfície, cationicos','Other organic surface-active agents,  cationic','Los dem.agentes de superficie orgánicos,  catiónicos',10,'34','3402','340212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34021300','Agentes orgânicos de superfície, nao ionicos','Organic surface-active agents , non-ionic','Agentes de superficie orgánicos,  no iónicos',10,'34','3402','340213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34021900','Outros agentes orgânicos de superfície','Other organic surface-active agents','Los demás agentes de superficie orgánicos',10,'34','3402','340219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34022000','Preparações tensoativas, para lavagem e limpeza','Surface-active preparations, for wash and cleaning','Preparaciones tensoactivas,  para lavar y de limpieza',10,'34','3402','340220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34029011','Misturas de agente organ.de superf.cont.prods.n/ionicos','Mixtures of surface-active agent cont.non-ionic prods','Mezclas de agente superf.orgán.que cont.prods.n/iónicos',10,'34','3402','340290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34029019','Outras misturas de agentes orgânicos de superfície','Other mixtures of surface-active agents','Las demás mezclas de agente de superf.orgánicos',10,'34','3402','340290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34029020','Soluções ou emulsoes de produtos tensoativos','Solutions or emulsions of surface-active products','Soluciones o emulsiones de productos tensoactivos',10,'34','3402','340290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34029021','Soluções ou emulsoes hidro-alcoólicas de (1-perfluor...','Hydro-alcoholic solutions or emulsions of (1-perfluor..','Soluciones o emulsiones hidroalcohólicas de(1-perfluor.',10,'34','3402','340290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34029022','Soluções, etc.de nonanoiloxibenzenossulfonato','Solutions, etc.a basis of nonanoyloxybenzenesulphonate','Soluciones, etc.de nonanoiloxibencenosulfonato',10,'34','3402','340290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34029023','Soluções, etc.de sulfonatos de perfluoralquiltrimetil...','Solutions, etc.of perfluoroalkyltrimethyl.sulphonates','Soluciones, etc.de sulfonatos de perfluoroalquiltrimet.',10,'34','3402','340290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34029029','Outras soluções ou emulsoes de produtos tensoativos, etc','Other solutions/emulsions of surface-active prods, etc','Las dem.soluciones o emulsiones de prod.tensoactiv.etc',10,'34','3402','340290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34029031','Prepars.de nonilfenol etoxilado (detergente) p/lavagem','Prepar.of ethoxylated nonylphenol(detergents)for wash','Prepars.de nonilfenol etoxilado (detergente) p/lavar',10,'34','3402','340290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34029039','Outras preparações para lavagem (detergentes)','Other preparations for wash (detergents)','Las dem.preparaciones para lavar (detergentes)',10,'34','3402','340290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34029090','Outs.preparações tensoativas e preparações para limpeza','Other surface-active prepar.and prepar.for cleaning','Las dem.preparaciones tensoactivas y prepar.de limpieza',10,'34','3402','340290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34031110','Prepars.cont.óleos de petróleo, etc.p/trat.mater.têxtil','Prep.cont.oils of petrol.etc.treat.of textile materials','Prepars.qcont.aceites de petróleo, etc.p/trat.mat.textil',10,'34','3403','340311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34031120','Prepars.cont.óleos de petróleo, etc.p/trat.couros/peles','Prep.cont.oils of petrol.etc.treat.of leather/furskins','Preps.qcont.aceites de petróleo, etc.p/trat.cueros/piele',10,'34','3403','340311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34031190','Prepars.cont.óleos de petróleo, etc.p/trat.outs.matérias','Prep.cont.oils of petrol.etc.fortreatment of other mat.','Preps.qcont.aceites de petróleo, etc.p/trat.ots.materias',10,'34','3403','340311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34031900','Outs.prepars.cont.óleos de petróleo/miners.betuminosos','Prep.cont.oils of petroleum/bituminous minerals','Las dem.preps.qcont.aceites de petróleo/min.bituminosos',10,'34','3403','340319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34039110','Outras preparações para tratamento de materia têxtil','Other preparations for treatment of textile materials','Las dem.preparaciones p/tratamiento de materia textil',10,'34','3403','340391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34039120','Outras preparações para tratamento de couros e peles','Other preparations for treatment of leather/furskins','Las dem.preparaciones p/tratamiento de cueros y pieles',10,'34','3403','340391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34039190','Outras preparações para tratamento de outras matérias','Other preparations for treatment of other matters','Las dem.preparaciones p/ el tratamiento de ots.materias',10,'34','3403','340391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34039900','Outs.prepars.lubrificantes/antiaderentes/antiferrug.etc','Oth.preparat.of lubricating/anti-adherent/anti-rust, etc','Las dem.prep.lubricantes/antiherrumbre/anticorros.etc',10,'34','3403','340399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34041000','Cera de linhita modificada químicamente','Waxes of chemically modified lignite','Cera de lignito modificado químicamente',10,'34','3404','340410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34042010','Ceras artificiais de polietileno glicóis','Artificial waxes of polyethylene glycol','Ceras artificiales de polietilenglicoles',10,'34','3404','340420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34042020','Ceras preparadas de polietileno glicóis','Prapared waxes of polyethylene glycol','Ceras preparadas de polietilenglicoles',10,'34','3404','340420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34049011','Cera artificial de polietileno, emulsionável','Artificial waxe of polyethylene, emulsifiable','Cera artificial de polietileno,  emulsionable',10,'34','3404','340490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34049012','Outras ceras artificiais, de polietileno','Other artificial waxes, of polyethylene','Las demás ceras artificiales de polietileno',10,'34','3404','340490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34049013','Cera artificial de polipropilenoglicóis','Artificial waxe of poly propylene glycol','Cera artificial de polipropilenglicoles',10,'34','3404','340490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34049014','Ceras artif.de dimero de alquilceteno, etc.em grânulos','Artificial waxes of alkyl ketene dimer, etc.in granules','Ceras artif.de dímero de alquilceteno, etc.en gránulos',10,'34','3404','340490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34049019','Outras ceras artificiais','Other artificial waxes','Las demás ceras artificiales',10,'34','3404','340490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34049021','Cera preparada à base de vaselina e alcoóis de lanolina','Prep.waxe with a basis of vaseline and lanolon alcohols','Cera prep.a base de vaselina y alcoholes de lanolina',10,'34','3404','340490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34049029','Outras ceras preparadas','Other prepared waxes','Las demás ceras preparadas',10,'34','3404','340490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34051000','Pomadas, cremes e prepars.semelhs.p/calçados ou couros','Polishes, creams and similar prep.forfootwear or leather','Betunes, cremas y prepars.similares.p/calzados o cueros',10,'34','3405','340510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34052000','Encáusticas/prepars.p/conservs.de moveis, etc.de madeira','Polishes, creams prep.for mainten.wooden furniture, etc.','Encáusticos/prepars.p/conserv.de muebles, etc.de madera',10,'34','3405','340520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34053000','Preparações p/dar brilho a pintura de carroçarias, etc.','Preparations forcoachwork, other than metal polishes, etc','Abrillantadores y preparac.similares p/carrocerías, etc.',10,'34','3405','340530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34054000','Pastas, pós e outras preparações para arear','Scouring pastes/powders and other scouring preparation','Pastas, polvos y demás preparaciones para fregar',10,'34','3405','340540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34059000','Outs.preparações para dar brilho em vidros, metais, etc.','Other preparations forcoachwork in glass, metal, etc.','Las dem.preparacs.p/dar brillo en vidrios,  metales, etc',10,'34','3405','340590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34060000','Velas, pavios, círios e artigos semelhantes','Candles, tapers and the like','Velas, cirios y artículos similares',10,'34','3406','340600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34070010','Pastas para modelar','Modelling pastes','Pastas para modelar',10,'34','3407','340700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34070020','Ceras para dentistas','Dental wax','Ceras para odontología',10,'34','3407','340700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('34070090','Outras composições para dentistas, à base de gesso','Oth.preparat.foruse in dentistry, with a basis of plaster','Las dem.composiciones para odontología,  a base de yeso',10,'34','3407','340700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35011000','Caseínas','Casein','Caseínas',10,'35','3501','350110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35019011','Caseinato de sódio','Caseinate of sodium','Caseinato de sodio',10,'35','3501','350190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35019019','Outros caseinatos e derivados das caseínas','Other caseinates and other casein derivatives','Los demás caseinatos y derivados de las caseínas',10,'35','3501','350190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35019020','Colas de caseína','Casein glues','Colas de caseína',10,'35','3501','350190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35021100','Ovalbumina seca','Dried egg albumins','Ovoalbúmina seca',10,'35','3502','350211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35021900','Outras ovalbuminas','Other egg albumins','Las demás ovoalbúminas',10,'35','3502','350219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35022000','Lactalbumina, incl.concentrad>=2 proteínas de soro leite','Milk albumin, includ.concent.>=2 proteins of serum milk','Lactoalbúmina, incl.concent.>=2 proteínas del lactosuero',10,'35','3502','350220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35029000','Outs.albuminas, albuminatos e outs.derivs.das albuminas','Other albumins, albuminates and oth.deriv.of albumins','Las dem.albúminas, albuminatos y dem.deriv.de las albúm.',10,'35','3502','350290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35029010','Soroalbumina','Serum albumin','Seroalbúmina',10,'35','3502','350290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35029090','Outras albuminas, albuminatos e outs.deriv.das albuminas','Other albumins, albuminates and oth.deriv.of albumins','Las dem.albúminas, albuminatos y dem.deriv.de las albúm.',10,'35','3502','350290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35030011','Gelatinas de osseina, seus derivs.c/grau pureza>=99.98%','Ossein gelatin, its derivatives, of a purity of >=99, 98%','Gelatinas de oseína, sus derivs.de pureza>=al99.98%, en p',10,'35','3503','350300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35030012','Gelatinas de osseina, seus derivs.c/grau pureza<99.98%','Ossein gelatin, its derivatives, of a purity of <99, 98%','Gelatinas de oseína, sus derivs.de pureza<al99.98%, en pe',10,'35','3503','350300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35030019','Outras gelatinas e seus derivados','Other gelatin and its derivatives','Las demás gelatinas y sus derivados',10,'35','3503','350300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35030090','Ictiocola, outs.colas de orig.animal, exc.cola de caseina','Isinglass, oth.glues of animal origin, excl.casein glues','Ictiocola, dem.colas de orig.animal, exc.cola de caseína',10,'35','3503','350300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35040011','Peptonas e peptonatos','Peptones and peptonates','Peptonas y peptonatos',10,'35','3504','350400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35040019','Outros derivados das peptonas','Other derivatives peptones','Los demás derivados de las peptonas',10,'35','3504','350400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35040020','Proteínas de soja em pó, teor proteína em base seca>=90%','Powdered soya proteins, of a protein content of >=90%','Proteínas de soja polvo, c/cont.prot.en base seca>=90%',10,'35','3504','350400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35040030','Proteínas de batata em pó, teor>=80% peso, em base seca','Powdered potato proteins, of a protein content of >=80%','Proteínas de patata en polvo, c/cont>=80%p., en base seca',10,'35','3504','350400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35040090','Outras matérias proteicas, seus derivados e po de peles','Oth.protein substances, their derivativ.and hide powder','Las dem.mater.proteínicas, sus deriv.y polvo de pieles',10,'35','3504','350400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35051000','Dextrina e outros amidos e féculas modificados','Dextrins and other modified starches','Dextrina y demás almidones y féculas modificados',10,'35','3505','350510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35052000','Colas à base de amidos ou de féculas, de dextrina, etc.','Glues with a basis of starches, of dextrins, etc.','Colas a base de almidones o de féculas, de dextrina, etc.',10,'35','3505','350520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35061010','Prods.util.como colas, adesivos, de cianoacrilatos, p<=1kg','Products used as glue, adhes.of cyanoacrylates, wei<=1kg','Prods.util.como colas, adhesivs, de cianoacrilatos, p<=1kg',10,'35','3506','350610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35061090','Outs.prods.utilizados como colas ou adesivos, peso<=1kg','Oth.prod.used as glue, adhes.of cyanoacrylates, wei<=1kg','Los dem.prods.utiliz.como colas o adhesivos, peso<=1kg',10,'35','3506','350610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35069110','Adesivos à base de borracha','Adhesives based on rubber','Adhesivos a base de caucho',10,'35','3506','350691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35069120','Adesivos à base de plásticos, dispersos, p/dispersar etc.','Adhesives based dispersed plastics, fordispersing, etc','Adhesivos a base de plásticos, dispersos, p/dispersar etc',10,'35','3506','350691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35069190','Outros adesivos à base de plásticos','Other adhesives based on plastics','Los demás adhesivos a base de plásticos',10,'35','3506','350691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35069900','Outras colas e adesivos preparados','Other glue and prepared adhesives','Las demás colas y adhesivos preparados',10,'35','3506','350699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35071000','Coalho e seus concentrados','Rennet and concentrates thereof','Cuajo y sus concentrados',10,'35','3507','350710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35079011','Alfa-amilase (aspergillus oryzae)','Alpha-amylase (aspergillus oryzae)','Alfa amilasa(aspergillus oryzae)',10,'35','3507','350790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35079019','Outras amilases e seus concentrados','Other amylase and concentrates thereof','Las demás amilasas y sus concentrados',10,'35','3507','350790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35079021','Fibrinucleases','Fibronucleases','Fibrinucleasas',10,'35','3507','350790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35079022','Bromelina','Bromelain','Bromelina',10,'35','3507','350790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35079023','Estreptoquinase','Streptokinase','Estreptoquinasa',10,'35','3507','350790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35079024','Estreptodornase','Streptodornase','Estreptodornasa',10,'35','3507','350790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35079025','Mistura de estreptoquinase e estreptodornase','Mixed streptoquinase and streptodornase','Mezcla de estreptoquinasa y estreptodornasa',10,'35','3507','350790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35079026','Papaína','Papain','Papaína',10,'35','3507','350790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35079029','Outras proteases e seus concentrados','Other proteases and its concentrated','Las demás proteasas y sus concentrados',10,'35','3507','350790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35079031','Lisozima e seu cloridrato','Lysozyme and its hydrochloride','Lisozima y su clorhidrato',10,'35','3507','350790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35079032','L-asparaginase','L-asparaginase','L-asparaginasa',10,'35','3507','350790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35079039','Outras enzimas e seus concentrados','Other enzymes and its concentrated','Las demás enzimas y sus concentrados',10,'35','3507','350790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35079041','Enzimas preparadas à base de celulases','Prepared enzymes with a basis of cellulases','Preparaciones enzimáticas a base de celulasas',10,'35','3507','350790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35079042','Enzimas preparadas à base de transglutaminase','Prepared enzymes based on transglutaminase','Preparaciones enzimáticas a base de transglutaminasa',10,'35','3507','350790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('35079049','Outras enzimas preparadas','Other prepared enzymes','Las demás preparaciones enzimáticas',10,'35','3507','350790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('36010000','Pólvoras propulsivas','Propellent powders','Pólvoras propulsivas',10,'36','3601','360100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('36020000','Explosivos preparados, exceto pólvoras propulsivas','Prepared explosives, other than propellent powders','Explosivos preparados,  excepto pólvoras propulsivas',10,'36','3602','360200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('36030000','Estopins/rastilhos, de segurança, cordéis detonantes, etc.','Safety fuses/detonating fuses, percussion, deton.caps, etc','Mechas de seguridad, cordones detonantes, etc.',10,'36','3603','360300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('36041000','Fogos de artifício','Fireworks','Fuegos de artificiales',10,'36','3604','360410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('36049010','Foguetes e cartuchos contra o granizo e semelhantes','Signalling flares, against rain rockets and similars','Cohetes y cartuchos antigranizo y similares',10,'36','3604','360490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('36049090','Outros foguetes de sinalização e artigos de pirotecnia','Other signalling flares and pyrotechnic articles','Los demás cohetes de señales y artículos de pirotecnia',10,'36','3604','360490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('36050000','Fósforos, exceto os artigos de pirotecnia','Matches, other than pyrotechnic articles','Fósforos, excepto los artículos de pirotecnia',10,'36','3605','360500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('36061000','Combustíveis liq.etc.util.p/carreg.isqueiro, cap<=300cm3','Liquid combustible, etc.used for lighter, cap<=300cm3','Combusts.líq.etc.util.p/cargar encendedores, cap<=300cm3',10,'36','3606','360610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('36069000','Ferrocerio e outs.ligas pirofosfóricas, art.mat.inflamav','Ferro-cerium/oth.pyrophoric alloys, artic.of inflam.mat.','Ferrocerio y ots.aleac. pirofóricas, art.de mat.inflam.',10,'36','3606','360690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37011010','Chapas/filmes planos, p/raios x, sensib.1 face, n/impress.','Plates and film in the flat, forx-ray, sensit.1side, unexp.','Placas/películas planas, p/rayos x, sensib.1cara, s/impres',15,'37','3701','370110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37011021','Chapas/film.planos, p/raios x odont.sensib.2 f.n/impress','Plates/film in the flat, forx-ray, odont.sens.1side, unexp.','Placas/pelícs planas, p/rayos x odont.sensib.2c, s/impres',15,'37','3701','370110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37011029','Outs.chapas/film.planos, p/raios x, sensib.2 f.n/impress.','Other plates/film in the flat, forx-ray, sens.1side, unexp.','Las dem.placas/pelíc.planas, p/rayos x, sensib.2 c.s/impr',15,'37','3701','370110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37012010','Filmes planos, revel.instant.sensib.n/impr.p/foto cores','Film in the flat, instant print sen., unex.forcolour phot.','Películas planas, autorrev.sensib.s/imp.p/fotog.colores',10,'37','3701','370120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37012020','Filmes plan.revel.instant.sensib.n/impr.p/foto monocrom','Film in the flat, instant print sen., unex.formonoch.phot.','Películas planas, autorrev.sensib.s/imp.p/fotog.monocrom',10,'37','3701','370120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37013010','Outs.chapas/film.plan.sensib.n/impr.d>255mm, p/fot.cores','Ot.plates/film flat, sen.unex.d>255mm forcolour phothog.','Las dem.placas/pel.plan.sens.s/impr.d>255mm, p/fot.col.',15,'37','3701','370130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37013021','Chapas alumínio, plan.sensib.polim.fotoss.n/impr.d>255mm','Aluminium plates/plane, sen.photos.polymers unex.d>255mm','Placas aluminio, plan.sensib.polim.fotos.s/impr.d.>255mm',15,'37','3701','370130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37013022','Chapas poliéster, plan.sens.polim.fotoss.n/impr.d>255mm','Polyesters plates/plane, sen.photos.polym.unex.d>255mm','Placas poliéster, plan.sens.polim.fotosen.s/impr.d>255mm',15,'37','3701','370130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37013029','Outs.chapas planas, sensib.polim.fotoss.n/impres.d>255mm','Other plane plates, sen.photos.polymers unex.d>255mm','Las dem.placas, plan.sens.polim.fotosen.s/impr.dim>255mm',15,'37','3701','370130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37013031','Chapas alumínio, planas, sensib.out.proc.n/impres.d>255mm','Aluminium plates/plane, sens.oth.proc.unexposed d>255mm','Placas de aluminio, plan.sens.ot.proc.s/impr.dim.>255mm',15,'37','3701','370130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37013039','Outs.chapas planas, sensib.outro proc.n/impres.dim>255mm','Other plane plates, sen.other proc.unex.d>255mm','Las dem.placas planas, sens.otro proc.s/impr.dim.>255mm',15,'37','3701','370130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37013040','Filmes planos, p/artes graficas, sensib.n/impress.d>255mm','Film in the flat, forgraphic arts, sensit.unexpos.d>255mm','Películas planas, p/artes gráficas, sens.s/impres.d>255mm',15,'37','3701','370130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37013050','Filmes plan.heliograf.poliéster, sensib.n/impres.d>255mm','Film in the flat, polyesters heliograp.sens.unex.d>255mm','Películas planas, heliogr, poliéster sens.s/impr.d>255mm',15,'37','3701','370130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37013090','Outs.chapas e filmes planos, sensib.n/impress.dim>255mm','Other plates and film in the flat, sens.unex.d>255mm','Las dem.placas y películas planas, sens.s/impr.dim>255mm',15,'37','3701','370130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37019100','Outs.chapas/filmes, planos, sensib.n/impress.p/foto cores','Ot.plates/film flat, sensit.unexposed forcolour phothog.','Las dem.placas y pelíc.planas, sens.s/impr.p/fot.colores',10,'37','3701','370191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37019900','Outs.chapas/filmes, planos, sensib.n/impr.p/foto monocrom','Oth.plates/film flat, sensitiz.unexposed formonoc.phothog','Las dem.placas/pelíc.planas, sens.s/impr.p/fotog.monocr.',15,'37','3701','370199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37021010','Filmes p/raios x, sensibil.1 face, n/impression.em rolos','Film for x-ray, sensitized 1 side unexposed in rolls','Películas p/rayos x, sens.en 1cara s/impr.en rollos',15,'37','3702','370210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37021020','Filmes p/raios x, sensibil.2 faces, n/impression.em rolos','Film for x-ray, sensitized 2 side unexposed in rolls','Películas p/rayos x, sens.en 2cara s/impr.en rollos',15,'37','3702','370210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37022010','Filmes de revel.instant.n/impres.foto a cores, em rolos','Film instant print, unexp.forcolour photografic, in rolls','Películas autorrevelables s/impr.fot.colores en rollos',15,'37','3702','370220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37022020','Filmes de revel.instant.n/impres.foto monocrom.em rolos','Film instant print, unexp.formonoc.photografic, in rolls','Películas autorrevelables s/impr.fot.monocr. en rollos',15,'37','3702','370220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37023100','Outs.filmes p/foto cores, sensib.n/impres.l<=105mm, rolos','Ot.film forcolour photografic, sens.unex.w<=105mm, rolls','Las dem.pelíc.p/fot.colores, sens.s/impr.a<=105mm rollos',11,'37','3702','370231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37023200','Filmes c/emuls.halog.prata, sensib.n/impr.l<=105mm, rolos','Films, c/silver halide emulsion sens.unex.w<=105mm, rolls','Pelícs c/emuls.halog.plata, sens.s/impr.an<=105mm rollos',15,'37','3702','370232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37023900','Outs.filmes n/perfur.sensib.n/impress.l<=105mm, em rolos','Oth.films, n/perforated sensitized unex.w<=105mm, rolls','Las dem.pelíc.s/perforar, sens.s/impr.an.<=105mm rollos',15,'37','3702','370239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37024100','Filmes p/foto cores, sensib.n/impr.l>610mm, c>200m, rolos','Films forcolour photog., sen.unex.w>610mm, l>200m, rolls','Pelícs p/fot.colores, sens.s/impr.an>610mm, l>200m, rollos',15,'37','3702','370241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37024210','Filmes p/artes grafs.sensib.n/impr.l>610mm, c>200m, rolos','Films forgraphic arts, sen.unex.w>610mm, l>200m, rolls','Pelícs p/artes gráfs, sens.s/impr.a>610mm, l>200m, rollos',15,'37','3702','370242');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37024290','Outs.filmes n/perfur.sensib.n/impr.l>610mm, c>200m, rolos','Oth.films, n/perforated sen.unex.w>610mm, l>200m, rolls','Las dem.pelíc.s/perf.sens.s/impr.a>610mm, l>200m, rollos',15,'37','3702','370242');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37024310','Filmes p/artes graf.sensib.n/impr.l>610mm, c<=200m, rolos','Films forgraphic arts, sen.unex.w>610mm, l>200m, rolls','Pelícs.p/artes gráfs, sens.s/impr.a>610mm, l<=200m, rollos',15,'37','3702','370243');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37024320','Filmes heliogr.poliest.sens.n/impr.l>61cm, c<=200m, rolos','Films polyesters heliog.sens.unex.w>61cm, l<=200m, rolls','Pelícs.heliog.poliést, sens.s/impr.a>61cm, l<=200m, rollos',15,'37','3702','370243');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37024390','Outs.filmes n/perf.sensib.n/impr.l>610mm, c<=200m, rolos','Oth.films, n/perforated sen.unex.w>610mm, l>200m, rolls','Las dem.pelíc.s/perf.sens.s/impr.a>610mm, l<=200m, rollos',15,'37','3702','370243');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37024410','Filmes p/foto cores, sensib.n/impr.105<l<=610mm, em rolos','Films forcolour photog., sen.unex.105<w<=610mm, in rolls','Pelícs p/fot.colores, sens.s/impr.105<an.<=610mm, rollos',15,'37','3702','370244');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37024421','Filmes p/artes graf.monocr.n/impr.105<l<=610mm, em rolos','Films forgraphic arts, monoc.sen.unex.105<w<=610mm, rolls','Pelícs p/artes gráf.monoc.s/impr.105<an<=610mm, rollos',15,'37','3702','370244');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37024422','Filmes .fotopolim.sensi.compost.acrilic .larg.>105mm, <610mm, p/fab.circuitos impress.','Films of photopolymer, acrylic composit.sens.w>105mm, <610mm, for product. print. circuit','Películas de fotopolím.sens.compos.acrilic. anch.>105mm,<610mm, p/ produc. circuito impreso',15,'37','3702','370244');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37024429','Outs.filmes monocrom.sensib.n/impres.105<l<=610mm, rolos','Oth.films monoc.sen.unex.105<w<=610mm, in rolls','Las dem.pelíc.monocrom, sens.s/impr.105<an<=610mm, rollos',15,'37','3702','370244');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37025110','Filmes p/foto cores, n/impress.l<=16mm, c<=14m, em bobinas','Films forcolour photografic, unex.w<=16mm, l<=14m, in rells','Pelícs p/fot.colores, s/impr.a<=16mm, lon<=14m, en encarg.',14,'37','3702','370251');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37025190','Outs.filmes p/foto cores, n/impress.l<=16mm, c<=14m, rolos','Ot.films forcolour photografic, unex.w<=16mm, l<=14m, rolls','Las dem.pelíc.p/fot.color.s/impr.a<=16mm, l<=14m,  rollos',14,'37','3702','370251');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37025200','Filmes p/foto cores, sensib.n/impres.l<=16mm, c>14m, rolos','Films forcolour photografic, sen.unex.w<=16mm, l>14m, rolls','Pelícs.p/fot.colores, sens.s/impr.a<=16mm, l<=14m,  rollos',14,'37','3702','370252');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37025300','Filmes p/diaposit.cores, n/impr.16<l<=35mm, c<=30m, rolos','Films forcolors dispos.unexp.16<w<=35mm, l<=30m, rolls','Pelícs.p/diaposit.colores, s/impr.a<=35mm, l<=30m,  rollos',14,'37','3702','370253');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37025411','Filmes p/foto cores, sensib.n/impr.l=35mm, c<=30m, bobinas','Films forcolour photograf.sens.unexp.w=35mm, l<=30m, reels','Pelícs.p/fot.colores, sens.s/impr.a=35mm, l<=30m, encargs.',14,'37','3702','370254');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37025412','Filmes p/foto cores, n/impress.12, 24 ou 36 exposic.rolos','Films forcolour photograf.unexpos.12, 24 or 36 exib.rolls','Pelícs.p/fot.colores, s/impr.12, 24 o 36 exposic.rollos',14,'37','3702','370254');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37025419','Outs.filmes p/foto cores, n/impress.l=35mm, c<=30m, rolos','Ot.films forcolour photog.unexpos.w=35mm, l<=30m, rolls','Las dem.pelíc.p/fot.colores, s/impr.a=35mm, l<=30m, rollos',14,'37','3702','370254');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37025491','Filmes p/foto cores, n/impr.16<l<35mm, c<=30m, em bobinas','Films forcolour photog.unexp.16<w<35mm, l<=30m, rells','Pelícs.p/fot.colores, s/impr.16<an<35mm, lon<=30, encargs.',14,'37','3702','370254');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37025499','Outs.filmes p/foto cores, n/impr.16<l<35mm, c<=30m, rolos','Ot.films forcolour photog.unexp.16<w<35mm, l<=30m, rolls','Las dem.pelíc.p/fot.col.s/impr.16<a<35mm, l<=30m, rollos',14,'37','3702','370254');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37025510','Filmes p/foto cores, sensib.n/impr.l=35mm, c>30m, em rolos','Films forcolour photog.sen.unexp.w<35mm, l<=30m, rolls','Pelícs p/fot.colores, sens.s/impr.a=35mm, l>30m, rollos',14,'37','3702','370255');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37025590','Filmes p/foto cores, sensib.n/impr.16<l<35mm, c>30m, rolos','Films forcolour photog.sen.unexp.16<w<35mm, l<=30m, rolls','Pelícs p/fot.colores, sens.s/impr.16<a<35mm, l>30m, rollos',14,'37','3702','370255');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37025600','Filmes p/foto cores, sensib.n/impress.l>35mm, em rolos','Films forcolour photografic, sens.unexposed w<35mm, rolls','Las dem.pelícs p/fot.colores, sens.s/impr.an>35mm, rollos',14,'37','3702','370256');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37029100','Outros filmes sensib.n/impress.l<=16mm, c<=14m, em rolos','Other films sensitized unexpos.w<=16mm, l<=14m, in rolls','Las dem.pelícs sensib.s/impr.an<=16mm, l<=14m, en rollos',14,'37','3702','370291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37029200','Outros filmes sensib.n/impress.l<=16mm, c>14m, em rolos','Other films sensitized unexpos.w<=16mm, l>14m, in rolls','Las dem.películas sensib.s/impr.a<=16mm, l>14m, en rollos',14,'37','3702','370292');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37029300','Outros filmes sensib.n/impr.16mm<l<=35mm, c<=30m, em rolo','Other films sensitized unexp.16mm<w<=35mm, l<=30m, rolls','Las dem.pelícs sensib.s/impr.16mm<a<=35mm, l<=30m, rollos',14,'37','3702','370293');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37029400','Outs.filmes sensib.n/impres.16mm<l<=35mm, c>14m, em rolos','Other films sensitized unexp.16mm<w<=35mm, l>14m, rolls','Las dem.películas sens.s/impr.16mm<a<=35mm, l>14m, rollos',14,'37','3702','370294');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37029500','Outros filmes sensib.n/impress.l>35mm, em rolos','Other films sensitized unexposed w>35mm, in rolls','Las demás películas sensib., s/impr.a>35mm, en rollos',14,'37','3702','370295');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37029600','Outros filmes sensib.n/impress.l<=35mm e comp<=30m','Other sensitized films,not printed,wid.<= 35mm,len<=30m','Otras películas sensibilizadas,n/imp.,a.<=35 mm,c.<=30m',14,'37','3702','370296');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37029700','Outros filmes sensib.n/impress.l<=35mm e comp>30m','Other sensitized films,not printed, wid.<= 35mm,len>30m','Otras películas sensibilizadas,n/imp.,a.<=35 mm,com>30m',14,'37','3702','370297');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37029800','Outros filmes sensibilziados,nao impresso,largura >35mm','Other sensitized films, not printed, width> 35mm','Otras películas sensibilizadas,n/impresas,anchura>35 mm',14,'37','3702','370298');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37031010','Papel, etc.p/foto cores, sensib.n/impr.em rolos, l>610mm','Photog.paper, etc.forcolour phot.sen.unex.rolls, w>610mm','Papel, etc.p/fot.colores, sensib.s/impr.en rollos, a>610mm',10,'37','3703','370310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37031021','Papel heliograf.monocrom.sensib.n/impr.em rolos, l>610mm','Paper heliogr.monoc.sen.unex.in rolls, w>610mm','Papel heliográf.monoc.sensib.s/impr.en rollos, a>610mm',10,'37','3703','370310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37031029','Outs.papéis p/foto monocrom.sensib.n/impr.rolos, l>610mm','Other papers formonoc.photog.sen.unex.in rolls, w>610mm','Los dem.papeles monoc.sensib.s/impr.en rollos, a>610mm',10,'37','3703','370310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37032000','Outros papéis p/foto a cores, sensibil.n/impressionados','Other papers forcolour photography, sensitised unexposed','Los dem.papeles p/fotog.en colores, sensib.s/impresionar',10,'37','3703','370320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37039010','Papel p/fotocomposição, sensibilizado, não impressionado','Paper forcolour photocomposition, sensitised unexposed','Papel p/fotocomposición, sensibilizado, sin impresionar',10,'37','3703','370390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37039090','Outs.papéis, cartões e têxteis fotograf.sensib.n/impress','Ot.paper, cards and textiles, sens.unexposed','Los dem.papeles, cartones y textiles fotogr.sens.s/impr.',10,'37','3703','370390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37040000','Chapas, filmes, etc.fotográficos, impress.mas n/revelados','Photographic plates, film, etc.exposed but n/developed','Placas, películas, etc.fotográficas, impres.pero s/revelar',10,'37','3704','370400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37051000','Chapas, filmes fotograf.impress.revelados, p/reprod.ofset','Photographic plates, fotograp.film, expos.foroffset repr.','Placas, películas fotográf.impres.reveladas, p/rep.offset',10,'37','3705','370510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37052000','Microfilmes impressionados e revelados','Microfilms exposed and developed','Microfilmes impresionados y revelados',10,'37','3705','370520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37059010','Fotomáscaras sobre vidro plano, positivas, etc.','Photo masks on glass sheet, positive, etc.','Fotomáscaras sobre vidrio plano, positivas, etc',10,'37','3705','370590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37059090','Outras chapas e filmes fotográficos, impress.e revelados','Other photographic plates and film, exposed/developed','Las dem.placas y películas fotogr.impresion.y reveladas',10,'37','3705','370590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37061000','Filmes cinematográficos impress.e revelados, l>=35mm','Cinematographic film, exposed and developed, w>=35mm','Películas cinematográficas impres.y reveladas, a>=35mm',14,'37','3706','370610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37069000','Outros filmes cinematográficos impress.e revelados','Other cinematographic film exposed and developed','Los dem.películas cinematográficas impres.y reveladas',14,'37','3706','370690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37071000','Emulsoes p/sensibilização de superfs.p/uso fotográfico','Sensitising emulsions for photographic uses','Emulsiones p/sensibilizar superficies p/uso fotográfico',10,'37','3707','370710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37079010','Fixadores para uso fotográfico','Fixers for photographic uses','Fijadores para uso fotográfico',10,'37','3707','370790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37079021','Reveladores à base de negro de fumo, etc.p/reprod.docum.','Developing based on carbon black, etc.fordoc.reproduction','Reveladores a base de negro de humo, etc.p/reprod.docum.',10,'37','3707','370790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37079029','Outros reveladores para uso fotográfico','Other developing for photographic uses','Los demás reveladores para uso fotográfico',10,'37','3707','370790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37079030','Compost.diazóicos fotossens.p/prepar.emulsoes fotograf.','Photosen.diazo compounds forthe prepar.of phot.emulsions','Compuestos diazoicos fotosens.p/prep.emulsiones fotogr.',10,'37','3707','370790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('37079090','Outras preparações químicas p/usos fotográficos, etc.','Other chemical preparations for photographic uses, etc','Las dem.preparaciones químicas p/usos fotográficos, etc.',10,'37','3707','370790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38011000','Grafita artificial','Artificial graphite','Grafito artificial',10,'38','3801','380110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38012010','Suspensão semicoloidal em óleos minerais (grafita)','Semi-colloidal graphite in suspension in mineral oil','Suspensión semicoloidal en aceites minerales (grafito)',10,'38','3801','380120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38012090','Outras grafitas coloidais ou semicoloidais','Other colloidal or semi-colloidal graphite','Los demás grafitos coloidales o semicoloidales',10,'38','3801','380120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38013010','Pasta carbonada para eletrodos','Carbonaceous pastes for electrodes','Pasta carbonosa para electrodos',10,'38','3801','380130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38013090','Pastas semelh.as carbonadas p/revest.interior de fornos','Similar carbonaceous pastes forfurnace linings','Pastas simil.a las carbon.p/revest.interior de hornos',10,'38','3801','380130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38019000','Outs.prepars.base de grafita/outs.carbonos, em pasta, etc','Ot.prep.based on graphite/other carbon, in paste, etc.','Las dem.prep.base de grafito/ots.carbonos, en pasta, etc',10,'38','3801','380190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38021000','Carvões ativados','Activated carbon','Carbones activados',10,'38','3802','380210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38029010','Farinhas silíciosas fósseis (ativadas)','Siliceous fossil meals (activated)','Harinas silíceas fósiles (activadas)',10,'38','3802','380290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38029020','Bentonita (matéria mineral natural ativada)','Bentonita (activated natural mineral)','Bentonita (materia mineral natural activada)',10,'38','3802','380290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38029030','Atapulgita','Atapulgite','Atapulgita',10,'38','3802','380290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38029040','Outras argilas e terras ativadas','Other clays and activated lands','Las demás arcillas y tierras activadas',10,'38','3802','380290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38029050','Bauxita (matéria mineral natural ativada)','Bauxite (activated natural mineral)','Bauxita (materia mineral natural activada)',10,'38','3802','380290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38029090','Outras matérias minerais naturais ativadas, etc.','Other activated natural mineral products, etc','Las dem.materias minerales naturales activadas, etc',10,'38','3802','380290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38030000','Tall-oil mesmo refinado','Tall oil, whether or not refined','Tall oil, incluso refinado',10,'38','3803','380300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38040011','Lixívia residual da fabr.pasta de celulose, ao sulfito','Residual lyes from the manufact.of wood pulp, sulphite','Lejía residual de la fabr.pasta de celulosa, al sulfito',10,'38','3804','380400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38040012','Lixívia residual da fabr.pasta celulose, a soda/sulfato','Residual lyes from the manuf.of wood pulp, soda/sulphate','Lejía residual de la fabr.pasta de cel., a la sosa/sulf.',10,'38','3804','380400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38040020','Lignossulfonatos','Lignin sulphonates','Lignosulfonatos',10,'38','3804','380400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38051000','Essências de terebintina, de pinheiro ou etc.','Turpentine essences, wood or etc.','Esencias de trementina, de madera de pino o etc.',10,'38','3805','380510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38052000','Óleo de pinho','Pine oil','Aceite de pino',10,'38','3805','380520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38059000','Outs.essências terpenicas da destil/tratam.madeiras, etc','Oth.terpenic essen.prod.by the dist./wood treatment, etc','Las dem.esencias terpénicas de destil/trat.maderas, etc',10,'38','3805','380590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38059010','Óleo de pinho','Pine oil','Aceite de pino',10,'38','3805','380590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38059090','Outs.essênc.terpênicas d/fab.d/mad, papel','Other terpenic essences of wood fabrication, paper','Otras esencias terpénicas de fabricación de madera, papel',10,'38','3805','380590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38061000','Colofonias e ácidos resínicos','Rosin and resin acids','Colofonias y ácidos resínicos',10,'38','3806','380610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38062000','Sais de colofonias, acidos resinicos ou de seus derivs.','Salts of rosin, of resin acids or of derivatives','Sales de colofonias, ácidos resínicos o de sus derivados',10,'38','3806','380620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38063000','Gomas ésteres (gomas fundidas)','Ester gums (run gums)','Gomas ésteres (gomas fundidas)',10,'38','3806','380630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38069011','Colofonias oxidadas, hidrogenadas, desidrogenadas, etc.','Rosins, oxidized, hydrogenated, dehydrogenated, etc','Colofonias oxidadas, hidrogenadas, deshidrogenadas, etc',10,'38','3806','380690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38069012','Abietatos de metila ou benzila, hidroabietato de metila','Methyl abietate/benzyl abietate, methyl hydroabietate','Abietatos de metilo o bencilo,  hidroabietato de metilo',10,'38','3806','380690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38069019','Outros derivados de colofonias ou de acidos resinicos','Other rosin derivatives or resin acids','Los dem.derivados de colofonias o de ácidos resínicos',10,'38','3806','380690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38069090','Outras essências de colofonia e óleos de colofonia','Other rosin essences and rosin oils','Las demás esencias de colofonia y aceites de colofonia',10,'38','3806','380690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38070000','Alcatrões de madeira, óleos de alcatrao de madeira, etc.','Wood tar, wood tar oils, wood creosote, etc','Alquitranes de madera, aceites de alquitrán  madera, etc',10,'38','3807','380700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38081010','Inseticidas para uso domissanitario direto','Insecticides or direct household use','Insecticidas para uso domisanitario directo',10,'38','3808','380810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38081021','Inseticida à base de acefato/"bacillus thuringiensis"','Insecticide based on acephate/"bacillus thuringiensis"','Insecticida a base de acefato/"bacillus thuringiensis"',10,'38','3808','380810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38081022','Inseticida à base de cipermetrinas ou de permetrina','Insecticide based on cypermethrins or permethrin','Insecticida a base de cipermetrinas o de permetrina',10,'38','3808','380810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38081023','Inseticida à base de monocrotofos ou de dicrotofos','Insecticide based on monocrotofos or dicrotofos','Insecticida a base de monocrotofos o de dicrotofos',10,'38','3808','380810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38081024','Inseticida à base de dissulfoton ou de endossulfan','Insecticide based on disulfoton or endosulfan','Insecticida a base de disulfotón o de endosulfán',10,'38','3808','380810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38081025','Inseticida à base de fosfeto de alumínio','Insecticide based on aluminium phosphide','Insecticida a base de fosfuro de aluminio',10,'38','3808','380810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38081026','Inseticida à base de triclorfon ou de diclorvos','Insecticide based on trichlorfon or dichlorvos','Insecticida a base de triclorfón o de diclorvós',10,'38','3808','380810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38081027','Inseticida à base de oleo mineral','Insecticide based on mineral oils','Insecticida a base de aceite mineral',10,'38','3808','380810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38081028','Inseticida à base de sulfluramida','Insecticie based on sulfluramid','Insecticida a base de sulfluramida',10,'38','3808','380810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38081029','Outros inseticidas apresentados de outro modo','Other inseticides presented in another way','Los demás insecticidas presentados de otro modo',10,'38','3808','380810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38082010','Fungicidas para uso domissanitario direto','Fungicides for direct household use','Fungicidas para uso domisanitario directo',10,'38','3808','380820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38082021','Fungicida à base de hidróxido de cobre, etc.','Fungicide based on copper hydroxide,  etc','Fungicida a base de hidróxido de cobre, etc',10,'38','3808','380820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38082022','Fungicida à base de ziram ou de enxofre','Fungicide based on ziram or sulphur','Fungicida a base de ziram o de azufre',10,'38','3808','380820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38082023','Fungicida à base de mancozeb ou de maneb','Fungicide based on mancozeb or maneb','Fungicida a base de mancozeb o de maneb',10,'38','3808','380820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38082024','Fungicida à base de sulfiram','Fungicide based on sulfiram','Fungicida a base de sulfiram',10,'38','3808','380820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38082025','Fungicida à base de compostos de cromo/cobre ou arsênio','Fungicide based on chromium, arsenic, copper compounds','Fungicida a base de compuestos de cromo/cobre o arsén.',10,'38','3808','380820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38082026','Fungicida à base de thiram','Fungicide based on thiram','Fungicida a base de thiram',10,'38','3808','380820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38082027','Fungicida à base de propiconazol','Fungicide based on propiconazole','Fungicida a base de propiconazol',10,'38','3808','380820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38082029','Outros fungicidas apresentados de outro modo','Other fungicides presented in another way','Los demás fungicidas presentados de otro modo',10,'38','3808','380820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38083010','Herbicidas para uso domissanitario direto','Herbicides for direct household use','Herbicidas para uso domisanitario directo',10,'38','3808','380830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38083021','Herbicida à base de 2, 4-d/de 2, 4-db/seus derivs/de mcpa','Herbicide based on 2, 4-d, 2, 4-db, its derivatives/ mcpa','Herbicida a base de 2, 4-d/de 2, 4-db/sus derivs/de mcpa',10,'38','3808','380830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38083022','Herbicida à base de atrazina, alaclor, diuron ou ametrina','Herbicide based on atrazine, alachlor, diuron or ametrine','Herbicida a base de atrazina, alaclor, diurón o ametrina',10,'38','3808','380830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38083023','Herbicida a base glifosato, seus sais, de imazaquim, etc','Herbicide based on glyphosate/its salts, imazaquin, etc','Herbicida a base glifosato, sus sales, de imazaquín, etc',10,'38','3808','380830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38083024','Herbicida à base de dicloreto de paraquat, propanil, etc.','Herbicide based on paraquat dichloride, propanil, etc','Herbicida a base de dicloruro de paraquat, propanil, etc',10,'38','3808','380830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38083025','Herbicida à base de pentaclorofenol/seus sais, etc.','Herbicide based on pentachlorophenol/its salts, etc.','Herbicida a base de pentaclorofenol/sus sales, etc',10,'38','3808','380830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38083026','Herbicida à base de imazetapir','Herbicide based on imazethapyr','Herbicida a base de imazetapir',10,'38','3808','380830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38083029','Outros herbicidas apresentados de outro modo','Other herbicides presented in another way','Otros herbicidas presentados de otro modo',10,'38','3808','380830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38083031','Inibidores de germinacao para uso domissanitario direto','Anti-sprouting for direct household use','Inhibidores de germinación p/uso domisanitario directo',10,'38','3808','380830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38083032','Outs.inibidores de germinacao apresentados de out.modo','Other anti-sprouting presented in another way','Los dem.inhibidores de germinación presentad.de ot.modo',10,'38','3808','380830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38083040','Reguladores de crescim.plantas, p/uso domissanit.direto','Plant-growth regulators for direct household use','Reguladores del crecim.plantas, p/uso domisanit.directo',10,'38','3808','380830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38083051','Reguladores de crescim.plantas, base hidrazida maleica','Plant-growth regulators, based on maleic hydrazide','Reguladores del crecim.plantas, base hidrazida maleica',10,'38','3808','380830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38083059','Outs.reguladores de crescim.plantas, apresent.out.modo','Plant-growth regulators, presented in another way','Otros reguladores del crecim.plantas, present.ot.modo',10,'38','3808','380830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38084010','Desinfetantes para uso domissanitario direto','Disinfectants for direct household use','Desinfectantes para uso domisanitario directo',10,'38','3808','380840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38084021','Desinfetante à base de thiram','Disinfectants based on thiram','Desinfectante a base de thiram',10,'38','3808','380840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38084022','Desinfetante à base de 2-(tiocianometiltio)benzotiazol','Desinfectants based on 2-(thiocyanomethylthio)benzoth.','Desinfectante a base de 2-(tiocianometiltio)benzotiazol',10,'38','3808','380840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38084029','Outros desinfetantes apresentados de outro modo','Other desinfectants presented in another way','Otros desinfectantes presentados de otro modo',10,'38','3808','380840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38085010','Inset.rodent.fung.herb.embal.uso domissanit.direto','Inseticides, rodenticides, fungicides, herbicides, packed for houselhod use','Inseticidas, rodenticidas, fungicidas, herbicidas, envasados para utilización doméstica',10,'38','3808','380850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38085021','Insetic. base d/metamidofós ou monocrotofós','Inseticides based on methamidophos or monocrotophos','Insetic. base d/metamidofós ou monocrotofós',10,'38','3808','380850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38085029','Outs.inseticidas, apresentados d/outro modo','Other inseticides presented in another way','Otros insecticidas presentados de otro modo',10,'38','3808','380850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089010','Rodenticidas/outs.prods.semelh.p/uso domissanit.direto','Rodenticides/oth.prods.similar for direct household use','Rodenticidas/dem.prods.similar.p/uso domisanit.directo',10,'38','3808','380890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089021','Acaricidas a base amitraz, clorfenvinfos, metamidofos, etc','Acaricides based on amitraz, chlorfenvinfos, metamid., etc','Acaricidas a base amitraz, clorfenvinfós, metamidofos, etc',10,'38','3808','380890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089022','Acaricidas a base ciexatin, óxido de fembutatin, etc.','Acaricides based on cyhexatin, fenbutatin oxide, etc.','Acaricidas a base de cihexatín, óxido de fembutatin, etc.',10,'38','3808','380890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089023','Outros acaricidas apresentados de outro modo','Other acaricides presented in another way','Los demás acaricidas presentados de otro modo',10,'38','3808','380890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089024','Nematicidas à base de metam sódio, apresentados out.modo','Nematocides based on metham sodium, presented anoth. way','Nematicidas a base de metam sodio,  presentados ot.modo',10,'38','3808','380890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089025','Outros nematicidas apresentados de outro modo','Other nematocides presented another way','Los demás nematicidas presentados de otro modo',10,'38','3808','380890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089026','Raticidas apresentados de outro modo','Raticides presented in another way','Raticidas presentados de otro modo',10,'38','3808','380890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089029','Outros rodenticidas/prods.semelh.apresentados out.modo','Other rodenticides/similar prods.presented an.way','Otrosrodenticidas/prods.semejant.presentados otro modo',10,'38','3808','380890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089110','Inseticidas embal.p/uso domissanitário direto','Inseticides packed for household use','Inseticidas envasados para utilización doméstica',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089111','Inseticida cont.bromometano, etc.p/uso domissanit.direto','Inseticides containing bromomethane, etc, for household use','Inseticidas con bromometano, etc, para utilización doméstica',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089119','Outs.inseticidas em embalagens p/uso domissanit.direto','Other inseticides packed for household use','Otros inseticidas envasados para utilización doméstica',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089120','Inseticida cont.bromometano, etc.apresent.de outro modo','Inseticides containing bromomethane, etc, presented in another way','Inseticidas con bromometano, etc, presentados de otro modo',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089121','Inseticidas à base de acefato','Insecticide based on acephate','Insecticida a base de acefato',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089122','Insetic.base d/cipermetrinas ou permetrina','Insecticide based on cypermethrins or permethrin','Insecticida a base de cipermetrinas o de permetrina',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089123','Inseticidas base  dicrotofós','Insecticide based on dicrotofos, presented in another way','Insecticida a base de dicrotofos, presentados de otro modo',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089124','Insetic.base d/dissulfoton ou endossulfan','Insecticide based on disulfoton or endosulfan','Insecticida a base de disulfotón o de endosulfán',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089125','Inseticida à base d/fosfeto de alumínio','Insecticide based on aluminium phosphide','Insecticida a base de fosfuro de aluminio',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089126','Inseticida à base d/triclorfon ou diclorvós','Insecticide based on trichlorfon or dichlorvos','Insecticida a base de triclorfón o de diclorvós',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089127','Insetic. à base d/óleo mineral ou tiometon','Insecticide based on mineral oils or tiometon','Insecticida a base de aceite mineral o tiometon',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089128','Inseticida á base de sulfluramida','Insecticide based on sulfluramid','Insecticida a base de sulfluramida',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089129','Outros inseticidas, apresentados de outro modo','Other inseticides presented in another way','Otros insecticidas presentados de otro modo',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089191','Inseticida à base de acefato apresentado de outro modo','Insecticide based on acephate presented in another way','Insecticida a base de acefato presentados de otro modo',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089192','Inseticida à base de cipermetrina/permetrina, outro modo','Insecticide based on cypermethrins/permethrin, other way','Insecticida a base de cipermetrinas/permetrina, otro modo',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089193','Inseticida à base de dicrotofos, apresent.de outro modo','Insecticide based on dicrotofos, presented in another way','Insecticida a base de dicrotofos, presentados de otro modo',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089194','Inseticida à base de dissulfoton/endossulfan, outro modo','Insecticide based on disulfoton or endosulfan, presented in another way','Insecticida a base de disulfotón o de endosulfán, presentado de otro modo',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089195','Inseticida à base de fosfeto de alumínio, em outro modo','Insecticide based on aluminium phosphide, presented in another way','Insecticida a base de fosfuro de aluminio, presentados de otro modo',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089196','Inseticida à base de diclorvos/triclorfon, em outro modo','Insecticide based on trichlorfon or dichlorvos, presented in another way','Insecticida a base de triclorfón o de diclorvós, presentado de otro modo',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089197','Inseticida à base de oleo mineral/tiometon, outro modo','Inseticide based on mineral oil/tiometon, in another way','Inseticida a base de aceites minerales/tiometon, en outro modo',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089198','Inseticida à base de sulfluramida, apresent.outro modo','Insecticie based on sulfluramid, presented in another way','Insecticida a base de sulfluramida, presentado de outro modo',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089199','Outs.inseticidas, apresentados de outro modo','Other inseticides, presented in another way','Otros insecticidas, presentados de otro modo',10,'38','3808','380891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089210','Fungicidas embal.p/uso domissanitário direto','Fungicides for direct household use','Fungicidas para uso domisanitario directo',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089211','Fungicida cont.bromometano, etc.p/uso domissanit.direto','Fungicides containing bromomethane, etc, for househol use','Fungicidas con bromometano, para utilización doméstica',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089219','Outs.fungicidas em embalag.p/uso domissanitario direto','Other fungicides packed for household use','Otros fungicidas envasados para utilización doméstica',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089220','Fungicida cont.bromometano, etc.apresent.de outro modo','Fungicides containing bromomethane, etc, presented in another way','Fungicidas con bromometano, presentados de otro modo',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089221','Fungicidas base d/hid.d/cobre, óxido cuproso','Fungicide based on copper hydroxide, cuprous oxide','Fungicida a base de hidróxido de cobre, óxido cuproso',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089222','Fungicida à base de ziram ou d/enxofre','Fungicide based on ziram or sulphur','Fungicida a base de ziram o de azufre',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089223','Fungicida à base d/mancozeb ou maneb','Fungicide based on mancozeb or maneb','Fungicida a base de mancozeb o de maneb',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089224','Fungicida à base d/sulfiram','Fungicide based on sulfiram','Fungicida a base de sulfiram',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089225','Fungic.base d/comp.d/cromo,  cobre,  arsênio','Fungicide based on chromium, arsenic or copper compounds','Fungicida a base de compuestos de cromo, cobre o arsén',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089226','Fungicida à base de thiram','Fungicide based on thiram','Fungicida a base de thiram',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089227','Fungicida à base de propiconazol','Fungicide based on propiconazole','Fungicida a base de propiconazol',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089229','Outs.fungicidas apresentados d/outro modo','Other fungicides presented in another way','Otros fungicidas presentados de otro modo',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089291','Fungicida à base de hidróxido de cobre, etc.outro modo','Fungicide based on copper hydroxide,  etc, presented in anhoter way','Fungicida a base de hidróxido de cobre, etc, presentado de otro modo',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089292','Fungicida à base de enxofre/ziram, apresent.outro modo','Fungicide based on ziram or sulphur, presented in another way','Fungicida a base de ziram o de azufre, presentados de otro modo',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089293','Fungicida à base de mancozeb/maneb, apresent.outro modo','Fungicide based on mancozeb or maneb, presented in another way','Fungicida a base de mancozeb o de maneb, presentado de otro modo',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089294','Fungicida à base de sulfiram, apresent.de outro modo','Fungicide based on sulfiram, presented in another way','Fungicida a base de sulfiram, presentado de otro modo',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089295','Fungic.à base de comp.de arsênio/cobre/cromo, outro modo','Fungicide based on chromium, arsenic, copper compounds, presented in another way','Fungicida a base de compuestos de cromo/cobre o arsénico, presentado de otro modo',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089296','Fungicida à base de thiram, apresentado de outro modo','Fungicide based on thiram, presented in another way','Fungicida a base de thiram, presentado de otro modo',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089297','Fungicida à base de propiconazol, apresent.de outro modo','Fungicide based on propiconazole, presented in another way','Fungicida a base de propiconazol, presentado de otro modo',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089299','Outros fungicidas apresentados de outro modo','Other fungicides presented in another way','Otros fungicidas presentados de otro modo',10,'38','3808','380892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089310','Herbicidas embal.p/uso domissanitário direto','Herbicides packed for direct household use','Herbicidas envasados para uso domisanitario directo',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089311','Herbicida cont.bromometano, etc.p/uso domissanit.direto','Herbicides containing bromometahne, etc, for household use','Herbicidas con bromometano, para utilización doméstica',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089319','Outs.herbicidas em embalag.p/uso domissanitario direto','Other herbicides, packed for household use','Otros herbicidas, envasados para utilización doméstica',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089321','Herbicida cont.bromometano ou bromoclorometano','Herbicide containing bromomethane or bromochloromethane','Herbicida conteniendo bromometano ou bromoclorometano',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089322','Herbicida à base de acido 2, 4-diclorofenoxiacético, etc','Herbicide based on 2, 4-dichlorophenoxiacetic, etc','Herbicida basado en ácido 2, 4-diclorofenoxiacético, etc',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089323','Herbicida à base de alaclor, ametrina, atrazina ou diuron','Herbicide based on atrazine, alachlor, diuron or ametrine','Herbicida a base de atrazina, alaclor, diurón o ametrina',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089324','Herbicida à base de glifosato/sais/imazaquim/lactofen','Herbicide based on glyphosate/its salts, imazaquin, etc','Herbicida a base glifosato, sus sales, de imazaquín, etc',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089325','Herbicida à base de dicloreto paraquat,  propanil,  etc','Herbicide based on paraquat dichloride, propanil, etc','Herbicida a base de dicloruro de paraquat, propanil, etc',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089326','Herbicida à base de trifluralina','Herbicide based on thriphularine','Herbicida a base de trifluralina',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089327','Herbicida à base de imazetapir','Herbicide based on imazethapyr','Herbicida a base de imazetapir',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089329','Outros herbicidas apresentados de outro modo','Other herbicides, presented in another way','Otros herbicidas, presentados de otro modo',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089331','Inibidores de germin.cont.bromometano/bromoclorometano','Anti-sprouting containing bromomethane/bromochloromethane','Inhibidores de germinación conteniendo bromometano/bromoclorometano',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089332','Outs.inibidores de germin.embal.p/uso domissanit.direto','Other anti-sprouting wrapped for sanitary for household use','Otros inhibidores de germinación embalado parautilización doméstica',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089333','Outs.inibidores de germinacao apresent.de outro modo','Other anti-sprouting presented in another way','Otros inhibidores de germinación presentado de otra manera',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089340','Regul.d/cresc.d/plant.emb.p/domissanit.direto','Other regulators for plant growth, packed for household use','Otros reguladores del crecimiento de lasplantas, para utilización doméstica',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089341','Regul.crescim.plant.c/brometo metila.embal.p/domissanit','Regulators for plant growth, with methyl bromide, packed for household use','Reguladores del crecimiento de las plantas, con bromuro de metilo , para utilización doméstica',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089349','Outs.regul.de crescim.de plant.embal.p/domissanit.diret','Other regulators for plant growth, packed for household use','Otros reguladores del crecimiento de lasplantas, para utilización doméstica',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089351','Regul.crescim.plant.cont.bromometano, etc.apres.out.modo','Regulators for plant growth, contain. bromomethane, presented in another way','Reguladores del crecimiento de las plantas, con bromometano , presentados de otro modo',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089352','Regul.crescim.plant.base de hidrazida, apresent.out.modo','Regulators for plant growth bases on hydrazide','Reguladores de crecimiento de plantas basados en hidrazida',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089359','Outs.regulad.de crescim.de plantas, apres.de out.modo','Other regulators for plant growth, presented in another way','Otros reguladores de crecimiento de plantas, presentados de otro modo',10,'38','3808','380893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089410','Desinfetantes embalados p/venda retalho','Desinfectants packed for retail sale','Desinfectantes para venta a menudeo',10,'38','3808','380894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089411','Desinfetante c/brometo metila, embal.p/uso domissan.dir.','Desinfectant containing bromide, packed for household use','Desinfectante con bromuro, envasado para utilización doméstica',10,'38','3808','380894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089419','Outs.desinfetantes em embalag.p/uso domissanit.direto','Other desinfectants packed for household use','Otros desinfectantes para utilización doméstica',10,'38','3808','380894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089421','Desinfet.cont.bromometano/bromoclorometano em out.modo','Desinfectants contain.bromomethane/bromochloromethane, in another way','Desinfectantes cont. bromometano/bromoclorometano, presenteado de otro modo',10,'38','3808','380894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089422','Desinfet.cont.2-(tiocianometiltio)benzotiazol, out.modo','Deseinfectant containing 2-(tiocianometiltio)benzotiazol, other way','Deseinfectante cont.2-(tiocianometiltio )benzotiazol, otro modo',10,'38','3808','380894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089429','Outros desinfetantes apresentados de outro modo','Other desinfectants presented in another way','Otros desinfectantes presentados de otro modo',10,'38','3808','380894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089910','Outros rodenticidas semel.emb.p/domissanitário','Other rodenticides or similars, packed for household use','Otros rodenticidas o similares, envasados para utilización doméstica',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089911','Outs.rodentic.cont.brometo metila, p/uso domissanit.dir.','Other rodenticides, containing methyl bromide, for household uso','Outros rodenticidas, conteniendo brometo metila, para utilización doméstica',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089919','Outs.rodenticidas ou semelh.embal.p/uso domissanit.dir.','Other rodenticides or similars, packed for household use','Otros rodenticidas o similares, envasados para utilización doméstica',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089920','Outs.rodenticidas, cont.brometo metila, apresent.out.modo','Other rodenticides, containing methyl bromide, presented in another way','Outros rodenticidas, conteniendo brometo metila, presentados de otro modo',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089921','Acaricidas base d/amitraz, clorfenvinfós, etc','Acaricides based on amitraz, chlorfenvinfos, metamid., etc','Acaricidas a base amitraz, clorfenvinfós, metamidofos, etc',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089922','Acaricidas base d/ciexatin, óxido fenbut.outs','Acaricides based on cyhexatin, fenbutatin oxide, etc.','Acaricidas a base de cihexatín, óxido de fembutatin, etc.',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089923','Outs.acaricidas ñ apres.venda varejo','Other acaricides not presented for retail sale','Otros acaricidas no presentados par venta a menudeo',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089924','Nematicidas à base de metam sódio','Nematocides based on metham sodium','Nematicidas a base de metam sodio',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089925','Outs.nematicidas ñ apres.venda varejo','Other nematocides not presented for retail sale','Otros nematicidas no presentados para venta a menudeo',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089926','Raticidas ñ apres.venda varejo','Raticides not presented for retail sale','Raticidas no presentados para venta a menudeo',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089929','Outs.rodentic.e prep.sem.ñ apres.venda varejo','Other rodenticides and similar preparations, not presented for retail sale','Otros rodenticidaes y preparaciones similares, no presentadas para venta a menudeo',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089991','Acaricidas a base amitraz, clorfenvinfos, etc.de out.modo','Acaricides based on amitraz, chlorofenvinphos, etc, in another way','Acaricidas basados en amitraz, clorfenvinfos, etc.de outro modo',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089992','Acaricidas a base ciexatin, óxido fenbutatin, de out.modo','Acaricides based on cyhexatin, fenbutatin oxide, in another way','Acaricidas a base de cihexatín, óxido de fembutatin, de outro modo',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089993','Outros acaricidas apresentados de outro modo','Other acaricides presented in another way','Otros acaricidas presentados de otro modo',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089994','Nematicidas à base de metam sódio, apresentados de outro modo','Nematocides based on metham sodium, presented another way','Nematicidas a base de metam sodio, presentados de otro modo',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089995','Outros nematicidas apresentados de outro modo','Other nematocides presented another way','Otros nematicidas presentados de otro modo',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089996','Raticidas apresentados de outro modo','Raticides presented in another way','Raticidas presentados de otro modo',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38089999','Outs.rodenticidas apresentados de outro modo','Other rodenticides presented in another way','Otros rodenticidas presentados de otro modo',10,'38','3808','380899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38091010','Preparações à base de matérias amilaceas p/ind.têxtil','Prep.with a basis of amylaceous substances fortex.indust','Preparaciones a base de materias amiláceas p/ind.textil',10,'38','3809','380910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38091090','Outras preparações à base de matérias amilaceas','Other preparat.with a basis of amylaceous substances','Las demás preparaciones a base de materias amiláceas',10,'38','3809','380910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38099110','Aprestos preparados util.na industria têxtil/semelhante','Finishing agents prepar., used industry text./similar','Aprestos preparados util.en la industria textil/similar',10,'38','3809','380991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38099120','Preparações mordentes p/industria têxtil/inds.semelhs.','Mordants prep.forindustry textile/similar indus.','Preparaciones mordientes p/industria textil/inds.simil.',10,'38','3809','380991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38099130','Prods.ignifugos para industria têxtil ou inds.semelhs.','Fire-retardant prod.forindustry textile/similar indus.','Prods.ignífugos para industria textil o inds.similares',10,'38','3809','380991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38099141','Impermeabilizante à base de parafina, etc.p/ind.têxtil','Water-repelent agen.based on paraffin, etc.fortextile ind','Impermeabilizante a base de parafina, etc.p/ind.textil',10,'38','3809','380991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38099149','Outros impermeabilizantes p/ind.têxtil/inds.semelh','Ot.water-repel.based on paraffin forind.textile/ind.sim.','Los dem.impermeabilizantes p/ind.textil/inds.similares',10,'38','3809','380991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38099190','Outros agentes de apresto/acabamento, etc.p/ind.têxtil','Other finishing agents, etc.fortextil ind.','Los dem.agentes de apresto/acabado, etc.p/ind.textil',10,'38','3809','380991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38099211','Impermeabilizante à base de parafina, etc.p/ind.papel','Water-repelent agen.based on paraffin, etc.forpaper ind','Impermeabilizante a base de parafina, etc.p/ind.papel',10,'38','3809','380992');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38099219','Outros impermeabilizantes p/ind.do papel/inds.semelhs.','Other water-repelent forpaper ind./similar ind.','Los dem.impermeabilizantes p/ind.del papel/ind.simil.',10,'38','3809','380992');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38099290','Outros agentes de apresto/acabamento, etc.p/ind.do papel','Other finishing agents, etc.forpaper ind.','Los dem.agentes de apresto/acabado, etc.p/ind.del papel',10,'38','3809','380992');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38099311','Impermeabilizante à base de parafina, etc.p/ind.couro','Water-repelent agen.based on paraffin, etc.forleather ind','Impermeabilizante a base de parafina, etc.p/ind.cuero',10,'38','3809','380993');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38099319','Outros impermeabilizantes p/ind.do couro ou inds.semelh','Other water-repelent forleather ind./similar ind.','Los dem.impermeabilizantes p/ind.del cuero o ind.simil.',10,'38','3809','380993');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38099390','Outros agentes de apresto/acabamento, etc.p/ind.do couro','Other finishing agents, etc.forleather ind.','Los dem.agentes de apresto/acabado, etc.p/ind.del cuero',10,'38','3809','380993');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38101010','Preparações para decapagem de metais','Pickling preparations for metal surfaces','Preparaciones para el decapado de metal',10,'38','3810','381010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38101020','Pastas e pos para soldar','Soldering, brazing or welding powders and pastes','Pastas y polvos para soldar',10,'38','3810','381010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38109000','Outros fluxos/prepars.auxiliares/varetas, p/soldar, etc.','Oth.fluxes/auxiliary prep./stiks/for soldering, etc','Los dem.flujos/prepars.auxiliares/varillas p/soldar, etc',10,'38','3810','381090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38111100','Prepars.antidetonantes à base de compostos de chumbo','Anti-knock preparations based on lead compounds','Prepars.antidetonantes a base de compuestos de plomo',10,'38','3811','381111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38111900','Outras preparações antidetonantes','Other anti-knock preparations','Las dem.preparaciones antidetonantes',10,'38','3811','381119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38112110','Aditivo melhorad.do índice viscosid.c/oleo petróleo, etc','Addict.forgetting better viscos.improv.c/petrol.oils, etc','Aditivo mejor.del índice viscosid.c/aceite petróleo, etc',10,'38','3811','381121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38112120','Aditivo antidesg/anticorr/antioxid.c/óleo petróleo, etc.','Additives anti-cor./oxidation inhibit.c/petrol.oils, etc','Aditivo antidesg/anticorr/antioxid.c/aceit.petróleo, etc',10,'38','3811','381121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38112130','Aditivo dispersante sem cinzas, contendo óleo petróleo, etc.','Dispersants addit.not containing ash, petroleum oils, etc','Aditivo dispersante sin cenizas, cont.aceit.petróleo, etc',10,'38','3811','381121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38112131','Aditivos dispersantes-deterg.de tbn<170, para óleos lubrificantes','Dispersants-deterg.addictive tbn<170, lubricating oils','Aditivos dispersantes-deterg.de tbn<170, p/aceit.lubric.',10,'38','3811','381121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38112139','Outros aditivos dispersantes-detergentes, p/óleos lubrificantes','Other dispersants-detergents addictive, lubricating oils','Los dem.aditivos dispersantes-detergent.p/aceites lubr.',10,'38','3811','381121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38112140','Aditivo detergente metálico, cont.oleo de petróleo, etc.','Detergents addict.c/metal compounds, c/petroleum oil, etc','Aditivo detergente metálico, cont.aceite de petroleo, etc',10,'38','3811','381121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38112150','Outs.prepars.cont.1 ou mais aditivo c/oleo petróleo, etc','Other prep.cont.1 or more addictive c/petroleum oil, etc','Las dem.prep.cont.1 o más aditivo c/aceite petróleo, etc',10,'38','3811','381121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38112190','Outs.aditivos cont.oleo de petróleo, etc.p/óleos lubrif.','Other addictives c/petroleum oil, etc.forlubricat.oils','Los dem.aditivos cont.aceit.de petr.etc.p/aceites lubr.',10,'38','3811','381121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38112910','Outros aditivos dispersantes sem cinzas','Other addictives dispersants not containing ash','Los demás aditivos dispersantes sin cenizas',10,'38','3811','381129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38112920','Outros aditivos detergentes metálicos','Other addictives detergents containing metal compounds','Los demás aditivos detergentes metálicos',10,'38','3811','381129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38112990','Outros aditivos para óleos lubrificantes','Other addictives lubricating oils','Los demás aditivos para aceites lubricantes',10,'38','3811','381129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38119010','Outs.aditivos dispers.s/cinzas, p/oleo petróleo combust.','Other addictives dispers.n/ash, foroil combust.petroleum','Los dem.aditivos disps.s/cenizas, p/aceite petr.combust.',10,'38','3811','381190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38119090','Outs.aditivos preparados, p/óleos minerais/outs.líquidos','Other addictives prepartions, formineral oils/oth.liquids','Los dem.aditivos preparados, p/aceits.minerales/ots.líq.',10,'38','3811','381190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38121000','Preparações denominadas "aceleradores de vulcanizacao"','Prepared denominated "rubber accelerators"','Prepars.denominadas "aceleradores de vulcanización"',10,'38','3812','381210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38122000','Plastificantes compostos para borracha ou plástico','Compound plasticisers for rubber or plastics','Plastificantes compuestos para caucho o plástico',10,'38','3812','381220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38123011','Prepars.antioxids.p/borracha, derivs.n de p-fenilenodiam','Anti-oxidising preparat.forrubber, deriv.n of p-phenylen.','Prepars.antioxids.p/caucho, derivs.n de p-fenilendiamina',10,'38','3812','381230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38123012','Prepars.antioxids.p/borracha, de fosfitos de alquila, etc','Anti-oxidising prepar.forrubber, alkylarylphosphites, etc','Prepars.antioxids.p/caucho, de fosfitos de alquilo, etc',10,'38','3812','381230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38123013','Prepars.antioxids.p/borracha, de 2, 2, 4-trimetil-1, 2-etc.','Anti-oxidising prepar.forrubber, 2, 2, 4-trimethyl-1, 2-etc.','Prepars.antioxids.p/caucho, de 2, 2, 4-trimetil-1, 2-etc.',10,'38','3812','381230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38123019','Outs.prepars.antioxid/outs.estabil.compostos, p/borracha','Oth.anti-oxidising prepar./oth.comp.stabilis., forrubber','Las dem.prepars.antioxid/ots.estab.compuestos, p/caucho',10,'38','3812','381230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38123021','Prepars.antioxids.p/plástico, derivs.n de p-fenilenodiam','Anti-oxidising forplastic, deriv.n of p-phenylenediamine','Prepars.antioxids.p/plástico, derivs.n de p-fenilendiam.',10,'38','3812','381230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38123029','Outs.prepars.antioxid/outs.estabil.compostos, p/plástico','Oth.anti-oxidising prepar./oth.comp.stabilis., forplastic','Las dem.prepars.antiox/ots.estab.compuestos, p/plástico',10,'38','3812','381230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38130000','Composições e cargas p/apars.extintores, granadas, etc.','Preparations and charges for fire-extinguishers, grenades, etc.','Preparaciones y cargas para extintores de incendio, granadas, etc',10,'38','3813','381300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38130010','Cargas c/bromoclorodifluormetano, etc.p/apars.extintores','Charges with bromochlorodifluoromethane, etc. for fire-extinguishers','Cargas cont. bromoclorodifluorometano, etc. p/ extintores de incendio',10,'38','3813','381300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38130020','Cargas c/hidrobromofluorcarbonetos(hbfc) p/apars.extint','Charges with hydrobromofluorocarbons (hbfc) for fire-extinguishers','Cargas cont. hidrobromofluorocarburo (hbfc), etc. p/ extintores de incendio',10,'38','3813','381300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38130030','Cargas c/hidroclorofluorcarbonetos(hcfc) p/apars.extint','Charges with hydrochlorofluorocarbons (hcfc) for fire-extinguishers','Cargas cont. hidroclorofluorocarburo (hbfc) p/ extintores de incendio',10,'38','3813','381300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38130040','Composições/cargas cont.bromoclorometano p/apars.extint','Preparations and charges con bromochloromethane for fire-extinguishers','Preparaciones y cargas cont.bromoclorometano p/extintores de incendio',10,'38','3813','381300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38130090','Composições e cargas p/apars.extintores, granadas, etc.','Preparations and charges for fire-extinguishers, grenades, etc.','Preparaciones y cargas para extintores de incendio, granadas, etc',10,'38','3813','381300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38140000','Outros solventes e diluentes orgânicos compostos, etc.','Other composite organic solvents and thinners, etc.','Otros disolventes y diluyentes orgánicos compuesos, etc',10,'38','3814','381400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38140010','Outs.solventes/diluentes, cont.clorofluorcarbonetos(cfc)','Other solvents/thinners, containing chlorofluorocarbons (cfc)','Otros disolventes/diluyentes, cont. clorofluorocarburo (cfc)',10,'38','3814','381400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38140020','Outs.solventes/diluentes, cont.hidroclorofluorcar organ.','Other solvents/thinners, containing organic hydrochlorofluorocarbons','Otros disolventes y diluyentes, cont hidroclorofluorocarburo organ. ',10,'38','3814','381400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38140030','Outs.solventes/diluentes, cont.tetracloreto de carbono, ','Other solvents/thinners, containing carbon tetrachloride','Otros disolventes/diluyentes, cont. tetracloruro de carbono',10,'38','3814','381400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38140090','Outs.solventes e diluentes orgânicos compostos, etc.','Other composite organic solvents and thinner, etc','Otros disolventes y diluyentes orgánicos compuestos.etc',10,'38','3814','381400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38151100','Catalisador em suporte, subst.ativa=niquel ou composto','Supported catalysts, active substance=nickel or comp.','Catalizador en soporte, sust.activa=níquel o compuesto',10,'38','3815','381511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38151200','Catalisador em suporte, subst.ativa=metal precioso/comp.','Supported catalysts, active subst.=precious metal/comp.','Catalizador en soporte, sust.activa=metal precioso/comp.',10,'38','3815','381512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38151210','Catalisador em colmeia ceram/metal.p/conv.catal.p/veics','Catalyst ceramic beehive/metallic forcatal.conver.forveh','Catalizador en colmena cerám/metál.p/conv.catal.p/vehíc',10,'38','3815','381512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38151220','Catalisador com tamanho de particulas<500 microns','Catalysts with particles of a size<500 microns','Catalizador con tamaño de partículas<500 microns',10,'38','3815','381512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38151290','Outs.catalisadores, tendo subst.ativa metal precioso','Other catalysts, cont.active substance precious metal','Otros catalizadores, c/metal precioso como sust.activa',10,'38','3815','381512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38151900','Outros catalizadores em suporte','Other supported catalysts','Otros catalizadores sobre soporte',10,'38','3815','381519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38151910','Catalisador em suporte, subst.ativa=pentóxido de vanádio','Supported catalysts, active subst.=vanadium pentoxide','Catalizador en soporte, sust.activa=pentóxido de vanadio',10,'38','3815','381519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38151920','Catalisador em suporte, subst.ativa=cobre/seus compostos','Supported catalysts, active subst.=copper/its compounds','Catalizador en soporte, sust.activa=cobre/sus compuestos',10,'38','3815','381519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38151930','Catalisador em suporte, subst.ativa=molibdénio/compostos','Supported catalysts, active subst.=molybdenium/compounds','Catalizador en soporte, sust.activa=molibdeno/compuestos',10,'38','3815','381519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38151990','Outros catalisadores em suporte','Other supported catalysts','Los demás catalizadores en soporte',10,'38','3815','381519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38159010','Outs.preparações cataliticas p/craqueamento de petróleo','Other supported catalytic for cracking petroleum oils','Las dem.preparaciones catalíticas p/craqueo de petróleo',10,'38','3815','381590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38159091','Outs.prepars.cataliticas, subst.ativa isoprenilalumínio','Other prepar.catalytic, active subst.isoprenyl aluminium','Las dem.preps.catalíticas, sust.activa isoprenilaluminio',10,'38','3815','381590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38159092','Outs.prepars.cataliticas, subst.ativa óxido de zinco','Other preparat.catalytic, active substance zinc oxide','Las dem.prepars.catalíticas, sust.activa óxido de cinc',10,'38','3815','381590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38159099','Outras preparações cataliticas','Other catalytic preparations','Otras preparaciones catalíticas',10,'38','3815','381590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38160011','Cimento/argamassa, a base magnesita calcinada, refratrário','Refract.cements/mortars, with a base of calcinated magn.','Cemento/morteros, a base magnesita calcinada, refractario',10,'38','3816','381600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38160012','Cimento e argamassa, à base de silimanita, refratrários','Refractory cements/mortars, with a base of sillimanite','Cemento y morteros, a base de silimanita, refractarios',10,'38','3816','381600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38160019','Outros cimentos e argamassas, refratrários','Refractory cements and mortars','Los demás cemento y morteros, refractarios',10,'38','3816','381600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38160020','Prepars.a base cromo-magnesita, zircônio, etc.refratrários','Prep.with a base refract.chromo-magnesite, zirconium, etc','Prepars.a base cromo-magnesita, circonio, etc.refractario',10,'38','3816','381600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38160021','Preparações refratárias cont>=50% de corindon e grafita','Prep.with base refractory c>=50%corundum and graphite','Prepars.refractarias q cont>=50% de corindón y grafito',10,'38','3816','381600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38160029','Outs.preparações à base de cromo-magnesita, etc.refrat.','Ot.prep.with a base refract.chromo-magnes.zirconium, etc','Los dem.preparac.a base de cromo-magnesita, etc.refract.',10,'38','3816','381600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38160090','Outros concretos e composições semelhantes, refratrários','Other refract.concretes and similar compositions','Los dem.hormigones y preparaciones similares, refract.',10,'38','3816','381600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38170010','Misturas de alquilbenzenos','Mixed alkylbenzenes','Mezclas de alquilbencenos',10,'38','3817','381700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38170020','Misturas de alquilnaftalenos','Mixed alkylnaphthalenes','Mezclas de alquilnaftalenos',10,'38','3817','381700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38171000','Misturas de alquilbenzenos','Mixed alkylbenzenes','Mezclas de alquilbencenos',10,'38','3817','381710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38172000','Misturas de alquilnaftalenos','Mixed alkylnaphthalene','Mezclas de alquilnaftalenos',10,'38','3817','381720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38180010','Elementos quims.impurifs.de silício, p/util.eletrônica','Chemical elements doped of silicon, foruse in electronics','Elementos químs.dopados de silicio, p/uso en electrónica',10,'38','3818','381800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38180090','Outs.elementos químicos impurificados p/util.eletrônica','Other chemical elements doped foruse in electronics','Los dem.elementos químs.dopados, p/uso en electrónica',10,'38','3818','381800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38190000','Líquidos p/freios hidráulicos, etc.c/óleos petróleo<=70%','Liquids forhydraulic brakes, etc.with petr.oils<=70%','Líquidos p/frenos hidráulicos, etc.c/aceit.petróleo<=70%',10,'38','3819','381900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38200000','Prepars.anticongelantes/líquidos prepar.p/descongelacao','Anti-freezing preparations and prepared de-icing fluids','Prepars.anticongelantes/líquidos prepar.p/descongelar',10,'38','3820','382000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38210000','Meios de cultura prepars.p/desenvolv.de microrganismos','Prepar.culture media for development of micro-organisms','Medios de cultivo prepars.p/desarrollo de microrgs.',10,'38','3821','382100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38220000','Reagentes de disgnóstico/laboratorio, em suporte/prepars','Diagnostic/laboratory reagents on a backing/prepared','Reactivos de diagnóstico/laboratorio, en soporte/prepars',10,'38','3822','382200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38220010','Reagentes determ.compon.sangue/urina, suporte papel, etc','Decisive reagents the compon.blood/urine, paper sup.etc','Reactivos determ.compon.sangre/urina, soporte papel, etc',10,'38','3822','382200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38220090','Outs.reagentes de disgnóstico ou de laboratorio','Other diagnostic or laboratory reagents','Los dem.reactivos de diagnóstico o de laboratorio',10,'38','3822','382200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38231100','Ácido esteárico (ac.graxo monocarboxilico industrial)','Stearic acid (industrial monocarboxylic fatty acids)','Ácido esteárico (ác.graso monocarboxílico industrial)',10,'38','3823','382311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38231200','Ácido oleico (acido graxo monocarboxilico industrial)','Oleic acid (industrial monocarboxylic fatty acids)','Ácido oleico (ác.graso monocarboxílico industrial)',10,'38','3823','382312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38231300','Ácido graxo (gordo) do "tall oil"','Tall oil fatty acids "tall oil"','Ácido graso del tall oil',10,'38','3823','382313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38231900','Outros acidos graxos monocarbox.ind.e óleos acid.refin, ','Oth.industrial monocarboxylic fatty acids/ac.oils.refin','Los dem.ácidos grasos monocarb.ind.y aceites ác.refin.',10,'38','3823','382319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38237010','Álcool esteárico (álcool graxo industrial)','Stearyl alcohol (industrial fatty alcohols)','Alcohol esteárico (alcohol graso industrial)',10,'38','3823','382370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38237020','Álcool láurico (álcool graxo industrial)','Lauryl alcohol (industrial fatty alcohols)','Alcohol láurico (alcohol graso industrial)',10,'38','3823','382370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38237030','Outras misturas de alcoóis primários alifáticos','Other mixtures of primary aliphatic alcohols','Las dem.mezclas de alcoholes primarios alifáticos',10,'38','3823','382370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38237090','Outros alcoóis graxos industriais','Other industrial fatty alcohols','Los dem.alcoholes grasos industriales',10,'38','3823','382370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38241000','Aglutinantes preparados p/moldes ou núcleos de fundicao','Prepared binders for foundry moulds or cores','Prepars.aglutinantes p/moldes o núcleos de fundición',10,'38','3824','382410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38242010','Acido naftênico e seus ésteres','Naphthenic acids and their esters','Ácido nafténico y sus ésteres',10,'38','3824','382420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38242020','Sais dos ácidos naftênicos, insolúveis em água','Naphthenic acids, water-insoluble','Sales de los ácidos nafténicos, insolubles en agua',10,'38','3824','382420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38243000','Carbonetos metálicos n/aglomer.misturados entre si, etc.','Non-agglomerated metal carbides mixed together, etc','Carburos metálicos s/aglomer.mezclados entre sí, etc',10,'38','3824','382430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38244000','Aditivos preparados p/cimentos, argamassas ou concretos','Prepared additives for cements, mortars or concretes','Aditivos preparados p/cementos, morteros o hormigones',10,'38','3824','382440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38245000','Argamassas e concretos, nâo refratrários','Non-refractory mortars and concretes','Morteros y hormigones,  no refractarios',10,'38','3824','382450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38246000','Sorbitol, exceto o poliálcool d-glucitol','Sorbitol, except the polyalcohol d-glucitol','Sorbitol,  excepto el polialcohol d-glucitol',10,'38','3824','382460');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38247110','Misturas contendo triclorotrifluoretanos','Mixtures containing trichlorotrifluoroethane','Mezclas que contengan triclorotrifluoroetanos',10,'38','3824','382471');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38247190','Outs.misturas c/hidrocarb.acicl.peralog.c/fluor e cloro','Ot.mixtures c/acycl.perhalog.hydroc.c/fluorine/chlorine','Las dem.mezclas c/hidroc.acícl.perhal.c/fluor y cloro',10,'38','3824','382471');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38247200','Outs.mist.cont. bromoclorodifluormetano, bromotrifluormetano/dibromotetrafluoretanos','Other mix. cont. bromochlorodifluoromethane,bromotrifluoromethane and dibromotetrafluoroethane','Otras mezclas que contenga bromoclorodifluorometano, bromotrifluorometano y dibromotetrafluoroetano',10,'38','3824','382472');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38247300','Outs.mist.cont. hidrobromofluorcarbs. (hbfc)','Other mixtures contain. hydrobromofluorocarbons (hbfc)','Otras mezclas que contenga hidrobromofluorocarburo (hbfc)',10,'38','3824','382473');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38247410','Prep.à base d/clorodifluor./pentafluor.','Prepared based on chlorodifluoromethane/pentafluoroethane','Preparados a base de clorodifluorometano/pentafluoroetano',10,'38','3824','382474');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38247420','Prep.à base clorodifluormetano/clorotetrafluoretano','Prepared based on chlorodifluoromethane/chlorotetrafluoroethane','Preparados a base de clorodifluorometano/clorotetrafluoroetano',10,'38','3824','382474');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38247490','Outs.prod.prep.à base d/comp.orgânicos','Other products prepared based on organic compounds','Otros productos preparados a base de compuestos orgánicos',10,'38','3824','382474');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38247500','Misturas contendo tetracloreto de carbono','Mixtures containing carbon tetrachloride','Mezclas que contengan tetracloruro de carbono',10,'38','3824','382475');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38247600','Misturas cont.1, 1, 1-tricloroetano(metilclor.)','Mixtures containing 1,1,1-trichloroethane','Mezclas que contengan 1,1,1-tricloroetano',10,'38','3824','382476');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38247700','Mists. cont. bromomet.ou d/bromoclorometano','Mixtures containing bromomethane or bromochloromethane','Mezclas que contengam bromometano o bromoclorometano',10,'38','3824','382477');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38247810','Prep.à base d/tetrafluoretano/ pentafluor.','Prepared based on tetrafluoroethane/pentafluoroethane','Preparados a base de tetrafluoroetano/pentafluoroetano',10,'38','3824','382478');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38247890','Outs.prod.prep.à base de compostos orgânicos','Other products prepared based on organic compounds','Otros productos preparados a base de compuestos orgánicos',10,'38','3824','382478');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38247900','Outs.misturas c/derivs.peralog.hidroc.acicl.2 halog.dif','Oth.mixture c/acycl.perhalog.hydroc.acyclic 2 halog.dif','Las dem.mezclas c/deriv.perhal.hidroc.acícl.2 halog.dif',10,'38','3824','382479');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38248110','Mist.d/óxido d/propileno c/óxido etileno<=30%','Mixture of propylene oxide with ethylene oxide <=30%','Mezcla de óxido de propileno, c/cont.óxido etileno<=30%',10,'38','3824','382481');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38248190','Outs.prod.prep.à base d/comp.orgânicos','Others products prepared based on organic compounds','Otros productos preparados a base de compuestos orgánicos',10,'38','3824','382481');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38248200','Mist.cont. polibromofenilas(pbb),  policloroterfenilas(pct) ou policlorobifenilas (pcb)','Mixture containing polibromofenilas(pbb), policloroterfenilas(pct) ou policlorobifenilas (pcb)','Mist.cont. polibromofenilas(pbb), policloroterfenilas(pct) o policlorobifenilas (pcb)',10,'38','3824','382482');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38248300','Mist. cont. fosf. de tris(2, 3-dibromopropila)','Mmixture containing fosf. de tris(2, 3-dibromopropila)','Mist. cont. fosf. de tris(2, 3-dibromopropila)',10,'38','3824','382483');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249011','Salinomicina micelial','Mycellial salinomycin','Salinomicina micelial',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249012','Prods.intermeds.c/teor de cianocobalamina<=55% em peso','Interm.product.cont.<=55% by weight of cyanocobalamine','Prods.intermeds.c/cont.de cianocobalamina<=55% en peso',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249013','Prods.intermediarios da fabricação da primicina amonica','Interm.product.of the manufacture of primycin ammonium','Prods.intermediarios de la fabric.de primicina amónica',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249014','Senduramicina sódica, da fabricação da senduramicina','Senduramycin sodium, of the manufacture of senduramycin','Senduramicina sódica, de la fabricación de senduramicina',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249015','Maduramicina amonica, em sol.álcool.da fabr.maduramicina','Maduramycin ammonium, in sol.alcohol, of manuf.maduramyc.','Maduramicina amónica, en sol.alcohól.de la fabr.maduram.',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249019','Outs.prods.intermed.da fabr.antibioticos, vitaminas, etc.','Oth.interm.produc.of manuf.antibiotic, vitamin, etc.','Los dem.prods.interm.de fabr.antibióticos, vitaminas, etc',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249021','Acido graxo (gordo) dimerizado','Dimerized fatty acids','Ácido graso dimerizado',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249022','Preparações contendo ácidos graxos (gordos) dimerizados','Preparations containing dimerized fatty acids','Preparacs.que contengan ácidos grasos dimerizados',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249023','Prepars.c/estearoilbenzoilmetano, palmitoilbenzoilmetano','Prepar./stearoylbenzoylmethane/ palmitoylbenzoylmethane','Prepars.c/estearoilbenzoilmetano, palmitoilbenzoilmetano',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249024','Preparações cont.caprilato e caprato de propilenoglicol','Prep.c/propylene glycol caprylate/propylene glycol capr','Prepars.q cont.caprilato y caprato de propilenglicol',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249025','Prepars.c/trigliceridios dos acidos caprilico e caprico','Preparations c/caprylic and capric acid triglycerides','Prepars.c/triglicéridos de ácidos caprílico y cáprico',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249026','Ésteres de alcoóis graxos de c12/c20 do ac.metacrílico','Esters of fatty alcohols c12/c20 with methacrylic acid','Ésteres de alcoh.grasos de c12/c20 de ác.metacrílico',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249027','Ésteres de acidos monocarboxil.de c10 ramifs.c/glicerol','Esters of c10 monocarboxylic acids w/glycerol bran.ch.','Ésteres de ácidos monocarboxíl.de c10 ramifs.c/glicerol',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249028','Misturas de ésteres dimetílicos dos acidos adipico, etc.','Mixtures of dimethyl esters of adipic acid, etc','Mezclas de ésteres dimetílicos de ácidos adípicos, etc',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249029','Outs.derivados de acidos graxos industriais, prepars.etc','Oth.derivatives of industrial fatty acids, prepar.etc','Los dem.derivados de ácid.grasos industriales, prep.etc',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249031','Preparações contendo isocianatos de hexametileno','Preparations containing hexamethylene isocyanates','Preparaciones que contengan isocianatos de hexametileno',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249032','Preparações contendo outros isocianatos','Preparations containing other isocyanates','Preparaciones que contengan otros isocianatos',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249033','Preparações contendo aminas graxas de c8 a c22','Preparations containing fatty amines c8 to c22','Preparaciones que contengan aminas grasas de c8 a c22',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249034','Prepars.c/polietilenoaminas, etc.p/coagulacao do latex','Prepar.cont.polyethylene amines, etc.forcoagulating latex','Prepars.c/polietilenaminas, etc.p/coagulación del látex',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249035','Outras preparações contendo polietilenoaminas','Other preparations containing polyethylamines','Las dem.preparaciones que contengan polietilenaminas',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249036','Misturas de mono-, di- e triisopropanolaminas','Mixtures of mono-,  di- and triisopropanolamines','Mezclas de mono-, di- y triisopropanolaminas',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249037','Reticulantes para silicones','Reticulants for silicons','Reticulantes para siliconas',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249039','Outs.prepars.p/borracha/plásticos, p/endurec.resinas, etc','Oth.prepar.forrubber/plastic, forresin hardened, etc','Las dem.prepar.p/caucho/plásticos, p/endurec.resinas, etc',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249041','Prepars.desincrustantes, anticorrosivas ou antioxidantes','Anti-scaling, anti-rust preparat.or oxidation inhibitors','Prepars.desincrustantes, anticorrosivas o antioxidantes',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249042','Mistura eutética de difenila e óxido de difenila','Eutectic mixture of diphenol and diphenol oxide','Mezcla eutéctica de difenilo y óxido de difenilo',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249043','Preparações contendo trimetil-3, 9-dietildecano','Preparations containing trimethyl-3, 9-diethyldecane','Preparaciones que contengan trimetil-3, 9-dietildecano',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249049','Outros fluidos para transferência de calor','Other fluids for transfer of heat','Los demás fluidos para transferencia de calor',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249051','Antiespumantes c/fosfato tributila, sol.álcool isopropil','Foam inhibitors c/tributyl phosphate sol.in isopr.alcoh','Antiespumantes c/fosfato tributilo, sol.alcoh.isopropil',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249052','Misturas de polietilenoglicóis','Mixed polyethylene glycols','Mezclas de polietilenglicoles',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249053','Polipropilenoglicol líquido','Liquid polypropylene glycol','Polipropilenglicol líquido',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249054','Retardante de chama c/misturas trifenilfosfatos isoprop','Flame-retardants c/mixed isopr.triphenyl phosphates','Retardante de llama c/mezclas trifenilfosfatos isoprop',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249059','Outs.prepars.c/ésteres de acido inorgan/seus derivs.etc','Other prep.c/esters inorg.acid/its derivatives, etc.','Las dem.prepar.c/ésteres de ácido inorgán/sus deriv.etc',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249061','Preparações de tetrafluoretano e pentafluoretano','Prep.based on tetrafluoroethand and pentafluoroethane','Preparaciones de tetrafluoroetano y pentafluoroetano',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249062','Preparações de clorodifluormetano e pentafluoretano','Prep.based on chlorodifluoromethane/pentafluoroethane','Preparaciones de clorodifluorometano y pentafluoroetano',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249063','Prepars.de clorodifluormetano e clorotetrafluoretano','Prep.based on chlorodifluoromethane/chlorotetrafluor.','Prepars.de clorodifluorometano y clorotetrafluoroetano',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249071','Cal sodada e carbonato de cálcio hidrofugo','Soda-lime and water repellent calcium carbonate','Cal sodada y carbonato de calcio hidrófugo',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249072','Preparações à base de silica em suspensao coloidal, etc.','Prep.with a basis of silica in colloidal suspension, etc','Preparacs.a base de sílice en suspensión coloidal, etc.',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249073','Prepars.à base de carbeto volframio, niquel=aglomer.etc.','Prep.with a basis of tungsten carbide nickel=agglom.etc','Prepars.a base de carburo volframio, níquel=aglomer.etc.',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249074','Preparações à base de hidróxido de niquel/cádmio, etc.','Prep.with a basis of hydroxide nickel/cadmium, etc','Preparaciones a base de hidróxido de níquel/cadmio, etc.',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249075','Preparações utilizadas na elab.de meios de cultura, etc.','Preparations used in the prepar.of culture media, etc.','Prepars.utilizadas en la elab.de medios de cultura, etc.',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249076','Compostos absorv.a base metais p/aperf.vácuo nos tubos','Getters for vacuum tubes','Compuestos absorb.a base metales p/perf.vacuo en tubos',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249077','Adubos ou fertilizantes foliares cont.zinco ou manganês','Fertilizers or leaf feeds containing zinc and magnanese','Abonos o fertilizantes foliares q cont.cinc o manganeso',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249078','Preparações à base de óxido de alumínio e de zircônio','Prep.based on aluminium oxide and zirconium oxide','Preparaciones a base de óxido de aluminio y de circonio',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249079','Outros prods.e prepars.à base de elementos químicos, etc','Other prod./prep.based on chemical elements, etc','Los dem.prod.y prepar.a base de elementos químicos, etc',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249081','Prepars.de anidrido poliisobutenilsuccinico, em oleo min','Prep.based on polyisobutenylsuc.anhydride, in min.oil','Prepars.de anhídrido poliisobutenilsuccinico, en ac.min',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249082','Halquinol, misturas de éteres dimetílicos de acidos, etc','Halquinol, esters mixtures of dimethylic acids, etc','Halquinol, mezclas de éteres dimetílicos de ácidos, etc',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249083','Triisocianato de tiofosfato fenila/trifenilm.em sol.etc','Tiophosph.triisocianate phen./triphenylmet.in sol.etc','Triisocianato de tiofosfato fenilo/trifenilm.en sol.etc',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249084','Mistura de óxido de propileno, c/teor óxido etileno<=30%','Propylene oxide mixt.c/<= 30% b/weight of ethyl.oxide','Mezcla de óxido de propileno, c/cont.óxido etileno<=30%',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249085','Metilato de sódio em metanol','Sodium methylate in methanol','Metilato de sodio en metanol',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249086','Maneb, mancozeb e cloreto de benzalconio','Maneb, mancozeb and benzalkonium chloride','Maneb, mancozeb y cloruro de benzalconio',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249087','Dispersão aquosa de microcapsulas de poliuretano, etc.','Aqueous dispers.of micro-capsules of polyurethane, etc','Dispersión acuosa de microcápsulas de poliuretano, etc.',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249088','Misturas de dialogenetos n, n-dialquilfósforoamidico, etc','Mixtures of dihalogenated n, n-dialkyl phosphoroamid.etc','Mezclas de dialogenuros n, n-dihalquilfosforoamidico, etc',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249089','Outros prods.e prepars.à base de compostos orgânicos','Other produc./preparat. based on organic compounds','Los dem.prods.y prepars.a base de compuestos orgánicos',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38249090','Outros prods.e prepars.das inds.quims/inds.conexas, etc.','Other produc./preparat.of chemical ind./allied ind.etc','Los dem.prods.y prepars.de inds.químs/inds.conexas, etc.',10,'38','3824','382490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38251000','Lixos municipais','Municipal waste','Desperdicios urbanos (municipales)',10,'38','3825','382510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38252000','Lamas de tratamento de esgotos','Sewage sludge','Lodos de depuración',10,'38','3825','382520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38253000','Lixos clínicos','Clinical waste','Desechos clínicos',11,'38','3825','382530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38254100','Resíduos halogenados de solventes orgânicos','Wastes halogenated of organic solvents','Halogenados de solventes orgánicos',10,'38','3825','382541');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38254900','Outros resíduos de solventes orgânicos','Other wastes of organic solvents','Los demás desperdicios de solventes orgánicos',10,'38','3825','382549');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38255000','Resíduos de soluções desoxidant.p/metais, etc.','Wastes of deoxidizing solutions formetals, etc.','Desperdicios de soluciones decapantes p/metales, etc.',10,'38','3825','382550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38256100','Resíduos das ind.quim.cont.constituinte organ','Wastes from chemical industries c/organic constituents','Desperdicios de las ind.quím.q cont.constituyente orgán',10,'38','3825','382561');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38256900','Outs.resíduos das industrias químicas/conexas','Other wastes from chemical/allied industries','Desperdicios de las industrias químicas/conexas',10,'38','3825','382569');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38259000','Outros produtos residuais das indústrias químicas, etc.','Other residual products chemical industries, etc.','Otros productos residuales de las industrias químicas, etc.',10,'38','3825','382590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('38260000','Biodiesel e suas misturas,c/>70% peso de pet.ou min.bet','Biodiesel and mixtures thereof, >70% oil','Biodiésel y sus mezclas','16','38','3826','382600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39011010','Polietileno linear, densidade<0.94, em forma primária','Polyethylene linear, density<0.94, in primary forms','Polietileno lineal, densidad< a 0.94, en forma primaria',10,'39','3901','390110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39011091','Polietileno com carga, densidade<0.94, em forma primária','Polyethylene c/fillers, density<0.94, in primary forms','Polietileno c/carga, densidad< a 0.94, en forma primaria',10,'39','3901','390110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39011092','Polietileno sem carga, densidade<0.94, em forma primária','Polyethylene not c/fillers, density<0.94, primary forms','Polietileno s/carga, densidad< a 0.94, en forma primaria',10,'39','3901','390110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39012011','Polietileno c/carga, vulcaniz.d>=1.3, em forma primária','Polyet.c/fillers, vulcanized d>1.3, in primary forms','Polietileno c/carga, vulcaniz.d>=a 1.3, en forma primaria',10,'39','3901','390120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39012019','Outros polietilenos c/carga, d>=0.94, em formas primárias','Oth.polyethyl.c/fillers density>=0.94, in primary forms','Los dem.polietilenos c/carga, d>=0.94, en form.primarias',10,'39','3901','390120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39012021','Polietileno s/carga, vulcaniz.dens>1.3, em forma primária','Polyet.not c/fillers, vulcanized d>1.3, in primary forms','Polietileno s/carga, vulcaniz.dens>1.3, en forma primaria',10,'39','3901','390120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39012029','Outros polietilenos s/carga, d>=0.94, em formas primárias','Oth.polyeth.not c/fillers, density>=0.94, primary forms','Polietileno s/carga, de dens>=a 0.94, en forma primaria',10,'39','3901','390120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39013010','Copolímero de etileno/acetato vinila, em líquidos, pastas','Ethylene-vinyl acetate copolymers, in liquids, pastes','Copolímero de etileno/acetato vinilo, en líquidos, pastas',10,'39','3901','390130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39013090','Copolímero etileno/acetato vinila, em outs.formas primar','Ethylene-vinyl acetate copolymers, in oth.primary forms','Copolímero etileno/acetato vinilo, en ots.formas primar.',10,'39','3901','390130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39019010','Copolímero de etileno/ácido acrílico, em formas primars.','Ethylene copolymers/acrylic acid, in primary forms','Copolímero de etileno/ácido acrílico, en formas primars.',10,'39','3901','390190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39019020','Copolímeros de etileno/monomeros etc.em formas primars.','Ethylene copolymers/monomers etc.in primary forms','Copolímero de etileno/monómeros etc, en formas primars.',10,'39','3901','390190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39019030','Polietileno clorossulfonado, em forma primária','Polyethylene chlorosulphonate, in primary forms','Polietileno clorosulfonado, en forma primaria',10,'39','3901','390190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39019040','Polietileno clorado, em forma primária','Chlorinated polyethylene, in primary forms','Polietileno clorado, en forma primaria',10,'39','3901','390190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39019050','Polímeros de etileno-acid.metacrílico, c/etileno>=60%','Ethylene polymers-metacrilic acid, with ethylene >= 60%','Polímeros de etileno-ácido metacrílico, con etileno >= 60%',10,'39','3901','390190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39019090','Outros polímeros de etileno, em formas primárias','Other polymeric ethylene, in primary forms','Los demás polímeros de etileno, en formas primarias',10,'39','3901','390190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39021010','Polipropileno com carga, em forma primária','Polypropylene c/fillers, in primary forms','Polipropileno con carga, en forma primaria',10,'39','3902','390210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39021020','Polipropileno sem carga, em forma primária','Polypropylene not containing fillers, in primary forms','Polipropileno sin carga, en forma primaria',10,'39','3902','390210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39022000','Poliisobutileno em forma primária','Polyisobutylene in primary forms','Poliisobutileno en forma primaria',10,'39','3902','390220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39023000','Copolímeros de propileno, em formas primárias','Propylene copolymers, in primary forms','Copolímeros de propileno, en formas primarias',10,'39','3902','390230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39029000','Outros polímeros de propileno/olefinas, em formas primar','Other polymers of propylene/olefins, in primary forms','Los dem.polímeros de propileno/olefinas, en formas prim.',10,'39','3902','390290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39031110','Poliestireno expansivel, com carga, em forma primária','Polystyrene expansible, c/fillers, in primary forms','Poliestireno expandible, con carga, en forma primaria',10,'39','3903','390311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39031120','Poliestireno expansivel, sem carga, em forma primária','Polystyrene expansible, not c/fillers, in primary forms','Poliestireno expandible, sin carga, en forma primaria',10,'39','3903','390311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39031900','Outros poliestirenos em formas primárias','Other polystyrene in primary forms','Los demás poliestirenos en formas primarias',10,'39','3903','390319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39032000','Copolímeros de estireno-acrilonitrila, em formas primárias','Styrene-acrylonitrile copolymers, in primary forms','Copolímeros de estireno-acrilonitrilo, en formas primars',10,'39','3903','390320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39033010','Copolímeros de acrilonitrila-butadieno-estireno, com carga','Acrylonitrile-butadiene-styrene cop., prim.forms, c/fil.','Copolímeros de acrilonitrilo-butadieno-estireno, c/carga',10,'39','3903','390330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39033020','Copolímeros de acrilonitrila-butadieno-estireno, sem carga','Acrylonitrile-butadiene-styrene cop., not c/fillers','Copolímeros de acrilonitrilo-butadieno-estireno, s/carga',10,'39','3903','390330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39039010','Copolímeros de metacrilato de metila-butadieno-estireno','Methacrylate-methyl-butadiene-styrene copolymers','Copolímeros de metacrilato de metilbutadieno-estireno',10,'39','3903','390390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39039020','Copolímeros de acrilonitrila-estireno-acrilato butila','Acrylonitrile-styrene-butyl acrylate','Copolímeros de acrilonitrilo-estireno-acrilato butila',10,'39','3903','390390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39039090','Outros polímeros de estireno, em formas primárias','Othe polymers of styrene, in primary forms','Los demás polímeros de estireno, en formas primarias',10,'39','3903','390390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39041010','Policloreto de vinila, obt.proc.suspensao, forma primária','Poly(vinyl chloride)obtained in suspens., primary forms','Policloruro de vinilo, obt.proc.suspensión, forma primar.',10,'39','3904','390410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39041020','Policloreto de vinila, obt.proc.emulsao, forma primária','Poly(vinyl chloride)obtained in emulsion., primary forms','Policloruro de vinilo, obt.proc.emulsión, forma primar.',10,'39','3904','390410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39041090','Outros policloretos de vinila, em formas primárias','Other poly(vinyl chloride), in primary forms','Los demás policloruros de vinilo, en formas primarias',10,'39','3904','390410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39042100','Policloreto de vinila, n/plastificado, em forma primária','Poly(vinyl chloride), non-plasticized, in primary forms','Policloruro de vinilo, s/plastificar, en forma primaria',10,'39','3904','390421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39042200','Policloreto de vinila, plastificado, em forma primária','Poly(vinyl chloride), plasticized, in primary forms','Policloruro de vinilo, plastificado, en forma primaria',10,'39','3904','390422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39043000','Copolímeros de cloreto, acetato de vinila, formas primars','Vinyl chloride-vinyl acetate copolymers, primary forms','Copolímeros de cloruro, acetato de vinilo, formas primars',10,'39','3904','390430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39044010','Copolímeros de cloreto, acetato vinila c/ac.dibasico, etc','Vinyl chloride-vinyl acetatecolumers, c/dibasic acid, etc','Copolímeros de cloruro, acetato vinilo c/ác.dibasico, etc',10,'39','3904','390440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39044090','Outs.copolímeros de cloreto de vinila, formas primárias','Vinyl chloride-vinyl acetate copolymers, primary forms','Los dem.copolímeros de cloruro de vinilo, form.primarias',10,'39','3904','390440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39045010','Copolímeros de cloreto de vinilideno, s/emulsionante, etc','Copolym. of vinylidene chloride, not c/emulsifier, etc','Copolímeros de cloruro de vinilideno, s/emulsionar, etc',10,'39','3904','390450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39045090','Outros polímeros de cloreto vinilideno, formas primárias','Other vinylidene chloride polymers, in primary forms','Los dem.polímeros de cloruro vinilideno, form.primarias',10,'39','3904','390450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39046110','Politetrafluoretileno em líquidos e pastas','Polytetrafluoroethylene in liquids and pastes','Politetrafluoroetileno en líquidos y pastas',10,'39','3904','390461');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39046190','Outros politetrafluoretilenos em formas primárias','Other polytetrafluoroethylene in primary forms','Los dem.politetrafluoroetilenos en formas primarias',10,'39','3904','390461');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39046910','Copolímero de fluoreto de vinilideno, hexafluorpropileno','Vinylidene fluoride-hexafluoropropylene copolymer','Copolímero de fluoruro vinilideno, hexafluoropropileno',10,'39','3904','390469');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39046990','Outros polímeros fluorados, em formas primárias','Other fluoro-polymers, in primary forms','Los demás polímeros fluorados, en formas primarias',10,'39','3904','390469');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39049000','Outs.polim.de cloreto vinila/olefinas halog.formas prim','Oth.polymers of vinyl chloride/halog.olefins, prim.forms','Los dem.polím.de cloruro vinilo/olefin.halog.form.prim',10,'39','3904','390490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39051200','Acetato de polivinila, em dispersão aquosa','Polyvinyl acetate, in aqueous dispersion','Acetato de polivinilo, en dispersión acuosa',10,'39','3905','390512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39051910','Acetato de polivinila, com álcool vinilico, em blocos, etc','Polyvinyl acetate, c/vinyl alcoholin blocks, etc','Acetato de polivinilo, c/alcohol vinílico, en bloques, etc',10,'39','3905','390519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39051990','Outros polímeros de acetato de polivinila, formas primar','Other polymers of polyvinyl acetate, primary forms','Los dem.polímeros de acetato de polivinilo, form.primar.',10,'39','3905','390519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39052100','Copolímeros de acetato de vinila, em dispersão aquosa','Vinyl acetate copolymers, in aqueous dispersion','Copolímeros de acetato de vinilo, en dispersión acuosa',10,'39','3905','390521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39052900','Outros copolímeros de acetato de vinila, formas primárias','Other vinyl acetate copolymers, in primary forms','Los dem.copolímeros de acetato de vinilo, formas primar.',10,'39','3905','390529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39053000','Álcool polivinílico, em forma primária','Poly(vinyl alcohol), in primary forms','Alcohol polivinílico, en forma primaria',10,'39','3905','390530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39059110','Copolímero polivinilformal, em forma primária','Poly(vinyl formal)copolymers, in primary forms','Copolímero polivinilformal, en forma primaria',10,'39','3905','390591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39059120','Copolímero polivinilbutiral, em forma primária','Poly(vinyl butyral)copolymers, in primary forms','Copolímero polivinilbutiral, en forma primaria',10,'39','3905','390591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39059130','Copolímero de vinilpirrolidona/acetato vinila','Poly(vinyl pyrrlidone)copolymers/vinyl acetate','Copolímero de vinilpirrolidona/acetato vinilo',10,'39','3905','390591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39059131','Copolímero polivinilpirrolidona iodada, formas primárias','Iodinated poly(vinyl pyrrlidone)copolymers, prim.forms','Copolímero polivinilpirrolidona iodada, formas primarias',10,'39','3905','390591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39059132','Copolímero de vinilpirrolidona, etc.em solução alcoólica','Poly(vinyl pyrrlidone)copolymers, etc.alcoholic solut.','Copolímero de vinilpirrolidona, etc.en soluc.alcohólica',10,'39','3905','390591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39059139','Outs.copolímeros polivinilpirrolidonas, formas primárias','Other poly(vinyl pyrrlidone)copolymers, in primary forms','Los dem.copolímeros polivinilpirrolidonas, formas prim.',10,'39','3905','390591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39059190','Outros copolímeros de acetato de vinila, etc.formas prim','Other vinyl acetate copolymers, etc.primary forms','Los dem.copolímeros de acetato de vinilo, etc.form.prim.',10,'39','3905','390591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39059900','Outros polímeros de acetato de vinila, etc.formas primar','Other vinyl acetate polymers, etc.primary forms','Los dem.polímeros de acetato de vinilo, etc.formas prim.',10,'39','3905','390599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39059910','Poli (vinilformal)','Poly (vinyl formal)','Poli (vinilformal)',10,'39','3905','390599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39059920','Poli (butiral de vinila)','Poly (vinyl butyral)','Poli (butiral de vinilo)',10,'39','3905','390599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39059930','Poli (vinilpirrolidona) iodada','Iodinated poly (vinyl pyrrlidone)','Poli (vinilpirrolidona) iodada',10,'39','3905','390599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39059990','Outros polímeros de vinila, em formas primárias','Other polymers of vinyl, in primary forms','Otros polímeros de vinilo, en formas primarias',10,'39','3905','390599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39061000','Polimetacrilato de metila, em forma primária','Poly(methyl methacrylate), in primary forms','Polimetacrilato de metilo, en forma primaria',10,'39','3906','390610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069011','Acido poliacrílico e sais, em liq/pasta, soluvel em água','Poly(acrylic acid)/its salts, liq/paste, soluble in water','Ácido poliacrílico y sales, en líq/pasta, soluble en agua',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069012','Sal sódico do ac.poliacrilamidico, em liq.etc.soluv.agua','Water-soluble poly(acrylamidic acid)sodium salt, etc','Sal sódica de ác.poliacrilamídico, en líq.etc.solub.agua',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069019','Outs.polímeros acrílicos, em liq.e pastas, soluv.em água','Oth.water-soluble acrylic polymers, in liquid/paste','Los dem.polímeros acrílic.en líq.y pastas, solub.en agua',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069021','Acido poliacrílico e sais, em liq/pasta, em solvent.organ','Organ.solvent acrylic polymers and salts, in liq/paste','Ácido poliacrílico y sales, en líq/pasta, en solvent.org.',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069022','Copolímero de metacrilato 2-diisopropil.em suspens.etc.','2-diisoprop.methacrylate copolymer, in suspen.etc.','Copolímero de metacrilato 2-diisopropil.en suspens.etc.',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069029','Outs.polímeros acrílicos, em líquido/pasta, em solv.organ','Oth.organic solvent acrylic polymers, in liquid/paste','Los dem.polímeros acrílicos, en líq/pasta, en solv.orgán.',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069031','Acido poliacrílico e sais, em liq/pasta, em outs.solv.etc','Poly(acrylic acid) and its salts, liq/paste, ot.solv.etc','Ácido poliacrílico y sales, en líq/pasta, en ots.solv.etc',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069032','Sal sódico do ac.poliacrilam.em liq.pasta.outs.solv.etc','Poly(acrylamidic acid)sodium salt, liq/paste, ot.solv.etc','Sal sódica del ác.poliacrilam.en líq.pasta.ots.solv.etc',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069039','Outs.polímeros acrílicos, em liq.pasta, em outs.solv.etc.','Other acrylic polymers, liq/paste, oth.solv.etc','Los dem.polímeros acrílic.en líq.pasta, en ots.solv.etc',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069041','Acido poliacrílico e sais, em blocos irregul.pedaços, etc','Poly(acrylic acid) and salts, in blocks, irreg.pieces, etc','Ácido poliacrílico y sales, en bl. irregul.pedazos, etc',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069042','Sal sódico do ac.poliacril.em pedaços, etc.soluv.em água','Poly(acrylamidic acid)sodium, in pieces, etc.sol.in water','Sal sódica de ác.poliacril.en pedazos, etc.solub.en agua',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069043','Carboxipolimetileno, em pó','Carboxypolymethylene, in powder','Carboxipolimetileno, en polvo',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069044','Poliacrilato de sódio, em blocos irregulares, pedaços, etc','Sodium polyacrylate, in irreg.blocks, pieces, etc','Poliacrilato de sodio, en bls.irregulares, pedazos, etc',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069045','Copolímero de poliacrilato de potássio e poliacrilamida','Potassium acrylate-acrylamide copolymer','Copolímero de poliacrilato de potasio y poliacrilamida',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069046','Copolímero de acrilato de metila-etileno, acrilato>=50%','Methyl acrylate copolymer, acrylate >=50%','Copolimero acrilato de metila,  acrilato >50%',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069047','Copolímero acrilato de etila,  acrilato de n-butila, etc','Ethyl acrylate copolymer, n-butyl acrylate, etc','Copolimero acrilato de etila,  acrilato de n-butila, etc',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39069049','Outs.polímeros acrílicos, em blocos irregul.pedaços, etc.','Other acrylic polymers, in irreg.blocks, pieces, etc','Los dem.polímeros acrílicos, en bloq.irreg.pedazos, etc',10,'39','3906','390690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39071010','Poliacetais com carga, em líquidos e pastas','Polyacetals with fillers, in liquid and pastes','Poliacetales con carga, en líquidos y pastas',10,'39','3907','390710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39071011','Poliacetais com carga, em líquidos e pastas','Polyacetals with fillers, in liquid and pastes','Poliacetales con carga, en líquidos y pastas',10,'39','3907','390710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39071019','Poliacetais com carga, em outras formas primárias','Polyacetals with fillers, in other primary forms','Poliacetales con carga, en otras formas primarias',10,'39','3907','390710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39071020','Poliacetais com carga, em outras formas primárias','Polyacetals with fillers, in other primary forms','Poliacetales con carga, en otras formas primarias',10,'39','3907','390710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39071021','Poliacetais sem carga, em líquidos e pastas','Polyacetals with fillers, in liquid and pastes','Poliacetales sin carga, en líquidos y pastas',10,'39','3907','390710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39071022','Poliacetais sem carga, em blocos irregul.etc.n/estabiliz','Polyacetals without fillers, in irreg.blocks etc.n/stab.','Poliacetales sin carga, en bls. irregul.etc.s/estabil.',10,'39','3907','390710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39071029','Poliacetais sem carga, em outras formas primárias','Polyacetals without fillers, in other primary forms','Poliacetales sin carga, en otras formas primarias',10,'39','3907','390710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39071031','Polidextrose sem carga, em líquido e pastas','Polydextrose without fillers, in liquid and pastes','Polydextrose sin carga, en líquidos y pastas',10,'39','3907','390710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39071039','Poliacetais sem carga, em líquido e pastas','Polyacetals without fillers, in liquid and pastes','Poliacetales sin carga, en líquido y pastas',10,'39','3907','390710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39071041','Polidextrose sem carga, em outras formas primárias','Polydextrose without fillers, in other primary forms','Polydextrose sin carga, en otras formas primarias',10,'39','3907','390710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39071042','Outs.poliacetais s/carga, em pó, que passe abert.0, 85mm','Ot.polyacetals without fillers, powd., pas.thro.ap.0, 85mm','Los dem.poliac.s/carga, en polvo, q.pase tam.abert.0, 85mm',10,'39','3907','390710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39071049','Poliacetais sem carga, em outras formas primárias','Polyacetals without fillers, in other primary forms','Poliacetales sin carga, en otras formas primarias',10,'39','3907','390710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39071090','Outros poliacetais','Other polyacetals','Los demás poliacetales',10,'39','3907','390710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39071091','Outs.poliacetais, em grânulos, diametro de particula>2mm','Ot.polyacetals, in granules, of a particle diameter>2 mm','Los dem.poliacetales, en gránulos, diám.de partícula>2mm',10,'39','3907','390710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39071099','Outros poliacetais','Other polyacetals','Los demás poliacetales',10,'39','3907','390710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39072011','Polioxifenileno com carga, em forma primária','Polyoxyphenylene with fillers, in primary forms','Polioxifenileno con carga, en forma primaria',10,'39','3907','390720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39072012','Polioxifenileno sem carga, em forma primária','Polyoxyphenylene without fillers, in primary forms','Polioxifenileno sin carga, en forma primaria',10,'39','3907','390720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39072020','Politetrametilenoeterglicol em forma primária','Poly(tetramethylene ether glycol), in primary forms','Politetrametilenoeterglicol en forma primaria',10,'39','3907','390720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39072031','Polietileno glicol 400, em forma primária','Poly(ethylene glycol) 400, in primary forms','Polietilenglicol 400, en forma primaria',10,'39','3907','390720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39072039','Outros polieterpoliois, em formas primárias','Other polyether polyols, in primary forms','Los demás polieterpolioles, en formas primarias',10,'39','3907','390720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39072041','Poli(epicloridrina)','Poly (epichlorohydrin)','Poli (epicloridrina)',10,'39','3907','390720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39072042','Copolímeros de óxido de etileno','Copolymers of ethylene oxide','Copolimeros de óxido de etileno',10,'39','3907','390720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39072049','Outros','Other','Otros',10,'39','3907','390720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39072090','Outros poliéteres em formas primárias','Other polyethers, in primary forms','Los demás poliéteres en formas primarias',10,'39','3907','390720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39073011','Resinas epoxidas com carga, em líquidos e pastas','Epoxide resins with fillers, in liquid and pastes','Resinas epoxi con carga, en líquidos y pastas',10,'39','3907','390730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39073019','Resinas epoxidas com carga, em outras formas primárias','Epoxide resins with fillers, in other primary forms','Resinas epoxi con carga, en otras formas primarias',10,'39','3907','390730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39073021','Copolímero tetrabromobisfenol a, etc.s/carga, forma prim.','Tetrabromobisphenol a copolymer, etc.without fil.prim.fo','Copolímero tetrabromobisfenol a, etc.s/carga, forma prim.',10,'39','3907','390730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39073022','Resinas epóxidas sem carga, em líq.e pastas','Epoxide resins without fillers, in liquid and pastes','Resinas epoxi sin carga, en líquidos y pastas',10,'39','3907','390730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39073028','Resinas epoxidas sem carga, em líquidos e pastas','Epoxide resins without fillers, in liquid and pastes','Resinas epoxi sin carga, en líquidos y pastas',10,'39','3907','390730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39073029','Outras resinas epoxidas sem carga, em formas primárias','Epoxide resins without fillers, in primary forms','Las dem.resinas epoxi sin carga, en formas primarias',10,'39','3907','390730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39074000','Policarbonatos em formas primárias','Polycarbonates in primary forms','Policarbonatos en formas primarias',10,'39','3907','390740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39074010','Policarbonatos forma primar.60g/10min<=fluidez<=80g/10m','Polycarbonates prim.forms 60g/10min<=fluidity<=80g/10m','Policarbonatos forma primar.60g/10min<=fluidez<=80g/10m',10,'39','3907','390740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39074090','Outs.policarbonatos em formas primárias','Other polycarbonates, in primary forms','Ots.policarbonatos en formas primarias',10,'39','3907','390740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39075010','Resinas alquidicas em líquidos e pastas','Alkyd resins, in liquid and pastes','Resinas alcídicas en líquidos y pastas',10,'39','3907','390750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39075090','Resinas alquidicas em outras formas primárias','Alkyd resins, in other primary forms','Resinas alcídicas en otras formas primarias',10,'39','3907','390750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39076000','Tereftalato de polietileno em forma primária','Poly(ethylene terephthalate) in primary forms','Tereftalato de polietileno en forma primaria',10,'39','3907','390760');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39077000','Poli(ácido láctico) formas primárias','Poly (lactic acid) primary forms','Poli (ácido láctico) formas primarias',10,'39','3907','390770');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39079100','Outros poliéteres não saturados, em formas primárias','Other polyethers unsaturated, in primary forms','Otros poliésteres no saturados, en formas primarias',10,'39','3907','390791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39079911','Tereftalato polibutileno c/carga fibra vidro, forma prim','Polybutyl.terephthalate c/glass fibre filler, prim.form','Tereftalato polibutileno c/carga fibra vidr., forma prim',10,'39','3907','390799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39079912','Poli(tereftalato d/butileno) em líq.e pastas','Poli (butylene terephthalate) in liquid and pastes','Poli (tereftalato d/butileno) en líquidos y pastas',10,'39','3907','390799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39079918','Tereftalato de polibutileno em líquidos e pastas','Polybutyl.terephthalate in liquid and pastes','Tereftalato de polibutileno en líquidos y pastas',10,'39','3907','390799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39079919','Tereftalato de polibutileno em outras formas primárias','Polybutyl.terephthalate in other primary forms','Tereftalato de polibutileno en otras formas primarias',10,'39','3907','390799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39079991','Outros poliésteres em líquidos e pastas','Other polyethers in liquid and pastes','Otros poliésteres en líquidos y pastas',10,'39','3907','390799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39079992','Poli(epsilon caprolactona)','Poly (epsilon caprolactone)','Poli (epsilon caprolactona)',10,'39','3907','390799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39079999','Outros poliésteres em formas primárias','Other polyethers in primary forms','Otros poliésteres en formas primarias',10,'39','3907','390799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39081011','Poliamida-11 em líquidos e pastas','Polyamide-11 liquids and pastes','Poliamida-11 en líquidos y pastas',10,'39','3908','390810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39081012','Poliamida-12 em líquidos e pastas','Polyamide-12 liquids and pastes','Poliamida-12 en líquidos y pastas',10,'39','3908','390810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39081013','Poliamida-6 ou poliamida-6, 6, c/garga, em líquidos, pastas','Polyamide-6/polyamide-6, 6, with load liquids and pastes','Poliamida-6 o poliamida-6, 6, c/garga, en líquidos, pastas',10,'39','3908','390810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39081014','Poliamida-6 ou poliamida-6, 6, s/carga, em líquidos, pastas','Polyamide-6/polyamide-6, 6, without  load liquids, pastes','Poliamida-6 o poliamida-6, 6, s/carga, en líquidos, pastas',10,'39','3908','390810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39081019','Poliamidas-6, 9 ou 6, 10 ou 6-12, em líquidos e pastas','Polyamide-6, 9 or 6, 10 or 6-12, in liquids and pastes','Poliamidas-6, 9 o 6, 10 o 6-12, en líquidos y pastas',10,'39','3908','390810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39081021','Poliamida-11 em blocos irregulares, pedados, grumos, etc.','Polyamide-11 in irreg.blocks, pieces, clots, etc.','Poliamida-11 en bloques irregulares, pedazos, grumos, etc.',10,'39','3908','390810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39081022','Poliamida-12 em blocos irregulares, pedaços, grumos, etc.','Polyamide-12 in irreg.blocks, pieces, clots, etc.','Poliamida-12 en bloques irregulares, pedazos, grumos, etc.',10,'39','3908','390810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39081023','Poliamida-6 ou poliamida-6, 6, com carga, em pedaços, etc.','Polyamide-6 or polyamide-6, 6, with filler, in pieces, etc','Poliamida-6 o poliamida-6, 6, con carga, en pedazos, etc.',10,'39','3908','390810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39081024','Poliamida-6 ou poliamida-6, 6, sem carga, em pedaços, etc.','Polyamide-6/polyamide-6, 6, without filler, in pieces, etc','Poliamida-6 o poliamida-6, 6, con carga, en pedazos, etc.',10,'39','3908','390810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39081029','Poliamidas-6, 9 ou 6, 10 ou 6-12, em blocos irregul.etc.','Polyamide-6, 9 or 6, 10 or 6-12, in bloks irregular, etc.','Poliamida-6, 9 o 6, 10 o 6-12, en bloques irregul., etc.',10,'39','3908','390810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39089010','Copolímero de lauril-lactama, em forma primária','Lauryl-lactam copolymer, in primary forms','Copolímero de lauril-lactama, en forma primaria',10,'39','3908','390890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39089020','Outs.poliamidas obt.condensacao acido graxo dimeriz.etc','Ot.polyamides obt.condensation of dimer.fatty acid etc','Ots.poliamidas obt.condensación ácido graso dimeriz.etc',10,'39','3908','390890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39089090','Outras poliamidas em formas primárias','Other polyamides in primary forms','Otras poliamidas en formas primarias',10,'39','3908','390890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39091000','Resinas ureicas/resinas de tiouréia, em formas primárias','Urea resins, thiourea resins, in primary forms','Resinas ureicas/resinas de tioureia, en formas primarias',10,'39','3909','390910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39092011','Melamina-formaldeído, com carga, em pó','Melamine-formaldehyde, with filler in powder form','Melamina-formaldehído, con carga, en polvo',10,'39','3909','390920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39092019','Outs.resinas melamínicas, com carga, em formas primárias','Other melamine resins, with filler, in primary forms','Ots.resinas melamínicas, con carga, en formas primarias',10,'39','3909','390920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39092021','Melamina-formaldeído, sem carga, em pó','Melamine-formaldehyde, without filler, in powder form','Melamina-formaldehído, sin carga, en polvo',10,'39','3909','390920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39092029','Outs.resinas melamínicas, sem carga, em formas primárias','Other melamine resins, without filler, in primary forms','Ots.resinas melamínicas, sin carga, en formas primarias',10,'39','3909','390920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39093010','Outras resinas amínicas, com carga, em formas primárias','Other amino resins, with filler, in primary forms','Ots.resinas amínicas, con carga, en formas primarias',10,'39','3909','390930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39093020','Outras resinas amínicas, sem carga, em formas primárias','Other amino resins, without filler, in primary forms','Ots.resinas amínicas, sin carga, en formas primarias',10,'39','3909','390930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39094011','Fenol-formaldeído, lipossolúvel, puro ou modificado','Phenol-formaldehyde, liposoluble, pure or modified','Fenol-formaldehído, liposoluble, puro o modificado',10,'39','3909','390940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39094019','Outras resinas fenólicas, lipossolúveis, puras/modificadas','Other phenolic resins, liposoluble, pure or modified','Ots.resinas fenólicas, liposolubles, puras/modificadas',10,'39','3909','390940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39094091','Outros fenóis-formaldeídos em formas primárias','Other phenol-formaldehyde in primary forms','Otros fenoles-formaldehídos en formas primarias',10,'39','3909','390940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39094099','Outras resinas fenólicas em formas primárias','Other phenol-resins in primary forms','Otras resinas fenólicas en formas primarias',10,'39','3909','390940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39095011','Poliuretano em soluções em solventes orgânicos','Polyurethane in solutions in organic solvent','Poliuretano en soluciones en disolventes orgánicos',10,'39','3909','390950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39095012','Poliuretano em dispersão aquosa','Polyurethane in aqueous dispersion','Poliuretano en dispersión acuosa',10,'39','3909','390950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39095019','Outros poliuretanos em líquidos e pastas','Other polyurethanes in aqueous dispersion','Otros poliuretanos en líquidos y pastas',10,'39','3909','390950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39095021','Poliuretano hidroxil.c/propried.adesiva, em pedaços, etc.','Hydroxyl.polyurethane c/propert.adhesive, in pieces, etc','Poliuretano hidroxil.c/propied.adhesiva, en pedazos, etc.',10,'39','3909','390950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39095029','Outros poliuretanos em blocos irregulares, pedaços, pós, etc','Oth.polyurethanes in blocks irregular, pieces, powder, etc','Ots.poliuretanos en bloqs.irregulares, pedazos, polvo, etc',10,'39','3909','390950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39100011','Misturas de pre-polímeros lineares, etc.(silicone óleo)','Lineal pre-polymers mixtures, etc.(oil silicon)','Mezclas de prepolímeros lineales, etc.(silicona aceite)',10,'39','3910','391000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39100012','Polidimetilsiloxano, etc.em dispersão (silicone óleo)','Polydimethylsiloxane, etc.dispersion(oil silicon)','Polidimetilsiloxano, etc.en dispersión (silicona aceite)',10,'39','3910','391000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39100013','Óleos copolímeros de dimetilsiloxano, c/comp.vinil.etc.','Copolymers oil dimethylsiloxane with vinyl compoun.etc','Aceite copolímeros de dimetilsiloxano, c/comp.vinil.etc.',10,'39','3910','391000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39100019','Outros óleos silicones em formas primárias','Other silicones oils in primary forms','Otros aceites siliconas en formas primarias',10,'39','3910','391000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39100020','Elastomeros (silicone)','Elastomer (silicon)','Elastómeros (silicona)',10,'39','3910','391000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39100021','Elastomeros de silicone, de vulcanizacao a quente','Silicon elastomer, heat vulcanized','Elastómeros de silicona, de vulcanización en caliente',10,'39','3910','391000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39100029','Outros elastomeros de silicone','Other silicon elastomer','Otros elastómeros de silicona',10,'39','3910','391000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39100030','Resinas (silicone)','Resin (silicon)','Resinas (silicona)',10,'39','3910','391000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39100090','Silicones em outras formas primárias','Silicones in primary forms','Silicons en otras formas primarias',10,'39','3910','391000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39111010','Resina de petróleo, de cumarona, etc.c/carga, forma primar','Petroleum resin, coumarone, etc.with filler, primary form','Resina de petróleo, de cumarona, etc.c/carga, forma primaria',10,'39','3911','391110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39111020','Resina de petróleo, de cumarona, etc.s/carga, forma primar','Petroleum resin, coumarone, etc.without filler, prim.form','Resina de petróleo, de cumarona, etc.s/carga, forma primaria',10,'39','3911','391110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39111021','Resinas de petróleo s/carga, total/parcial hidrogenada','Other petroleum resins without charge, total or partially hydrogenated','Otras resinas de petróleo sin cargo, total o parcialmente hidrogenadas',10,'39','3911','391110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39111029','Outras resinas de petróleo sem carga','Other petroleum resins without charge','Otras resinas de petróleo sin cargo',10,'39','3911','391110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39119011','Politerpenos modif.químicam.c/carga, em formas primárias','Chemically modified polyterpenes, with filler, prim.forms','Politerpenos cambiados químicamente con carga, en formas primarias',10,'39','3911','391190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39119012','Polieteremidas e seus copolímeros, c/carga, formas primar','Polieteremides and its copolymers, with load, primary forms','Polieteremidas y sus copolímeros, con carga, formas primarias',10,'39','3911','391190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39119013','Polieteremidas e seus copolímeros, c/carga, formas primar','Polieteremides and its copolymers, with load, primary forms','Polieteremidas y sus copolímeros, con carga, formas primarias',10,'39','3911','391190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39119014','Poli(sulfeto de fenileno)','Poli(sulfeto de fenileno)','Poli(sulfeto de fenileno)',10,'39','3911','391190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39119019','Polissulfetos, polissulfonas, etc.c/carga, formas primars.','Polysulph, polysulphones, etc.with filler, primary forms','Polisulfuros, polisulfonas, etc.c/carga, formas primars.',10,'39','3911','391190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39119021','Politerpenos modificados quimicamente sem carga, em formas primárias','Chemically mod.polyterpenes, without filler, prim.foms','Politerpenos modifs.químicam.sin carga, en formas primar',10,'39','3911','391190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39119022','Polissulfeto de fenileno, sem carga, em formas primárias','Poly(phenylene sulphide), with filler, primary forms','Polisulfuro de fenileno, sin carga, en formas primarias',10,'39','3911','391190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39119023','Polietilenaminas, sem carga, em formas primárias','Polyethylamines, with filler, primary forms','Polietilenaminas, sin carga, en formas primarias',10,'39','3911','391190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39119024','Polieteremidas e seus copolímeros, s/carga, formas primar','Polieteremides and its copolymers, without load, primary forms','Polieteremidas y sus copolímeros, sin carga, formas primarias',10,'39','3911','391190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39119025','Polieteremidas e seus copolímeros, s/carga, formas primar','Polieteremides and its copolymers, without load, primary forms','Polieteremidas y sus copolímeros, sin carga, formas primarias',10,'39','3911','391190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39119026','Polissulfonas','Polysulphones','Polisulfonas',10,'39','3911','391190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39119029','Outros politerpenos, etc.sem carga, em formas primárias','Other polyterpenes, etc.without filler, primary forms','Otros politerpenos, etc.sin carga, en formas primarias',10,'39','3911','391190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39121110','Acetato de celulose, nao plastificado, c/carga, forma primária','Cellulose acetate, non-plasticised, with filler, prim.form','Acetato de celulosa, sin plastificar, c/carga, forma prim.',10,'39','3912','391211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39121120','Acetato de celulose, nao plastificado, sem carga, forma primária','Cellulose acetate, non-plastic., without filler, prim.form','Acetato de celulosa, sin plastificar, s/carga, forma prim',10,'39','3912','391211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39121200','Acetato de celulose, plastificado, em forma primária','Cellulose acetate, plasticised, primary form','Acetato de celulosa, plastificado, en forma primaria',10,'39','3912','391212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39122010','Nitrato de celulose, com carga, em forma primária','Cellulose nitrate, with filler, primary form','Nitrato de celulosa, con carga, en forma primaria',10,'39','3912','391220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39122021','Nitrato de celulose, sem carga, em álcool, teor n/volat>=65%','Cellul.nitrate, with fil., in alc.non-volat.content>=65%','Nitrato de celulosa, s/carga, en alc., c/cont.n/volat>=65%',10,'39','3912','391220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39122029','Outros nitratos de celulose, sem carga, em forma primária','Other cellulose nitrate, with filler, in primary form','Los dem.nitratos de celulosa, s/carga, en forma primaria',10,'39','3912','391220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39123111','Carboximetilcelulose com teor>=75%, em formas primárias','Carboxymethylcellulose content>=75%, in primary forms','Carboximetilcelulosa c/cont.>=75%, en formas primarias',10,'39','3912','391231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39123119','Outros carboximetilceluloses em formas primárias','Other carboxymethylcellulose, in primary forms','Los dem.carboximetilcelulosas en formas primarias',10,'39','3912','391231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39123121','Sais de carboximetilcelulose, teor>=75%, em formas primar','Salts of carboxymethylcellulose con.>=75%, primary forms','Sales de carboximetilcelulosa, cont.>=75%en forma primar',10,'39','3912','391231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39123129','Outros sais de carboximetilcelulose, em formas primárias','Other salts of carboxymethylcellulose, in primary forms','Otros sales de carboximetilcelulosa, en formas primarias',10,'39','3912','391231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39123910','Metil-, etil- e propilcelulose, hidroxiladas, forma primar','Hydroxylated methyl-, ethyl-propyl cellul., primary form','Metil-, etil- e propilcelulosa, hidroxiladas, forma primar',10,'39','3912','391239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39123920','Outras metilceluloses, em formas primárias','Other methylcelluloses, in primary forms','Otras metilcelulosas, en formas primarias',10,'39','3912','391239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39123930','Outras etilceluloses, em formas primárias','Other ethylcelluloses, in primary forms','Otras etilcelulosas, en formas primarias',10,'39','3912','391239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39123990','Outros éteres de celulose, em formas primárias','Other eters of cellulose, in primary forms','Otros éteres de celulosa, en formas primarias',10,'39','3912','391239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39129010','Propionato de celulose, em forma primária','Cellulose propionate, in primary forms','Propionato de celulosa, en forma primaria',10,'39','3912','391290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39129020','Acetobutirato de celulose, em forma primária','Cellulose acetobutanoate, in primary forms','Acetobutirato de celulosa, en forma primaria',10,'39','3912','391290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39129031','Celulose microcristalina, em pó','Microcrystalline cellulose, in powder','Celulosa microcristalina, en polvo',10,'39','3912','391290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39129039','Celulose microcristalina, em outras formas primárias','Microcrystalline cellulose, in primary forms','Celulosa microcristalina, en otras formas primarias',10,'39','3912','391290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39129040','Outras celuloses, em pó','Other cellulose, in powder','Otras celulosas, en polvo',10,'39','3912','391290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39129090','Outs.celuloses e derivados químicos, em formas primárias','Ot.cellulose and its chemical derivatives, primary forms','Las dem.celulosas y derivados químic.en formas primar.',10,'39','3912','391290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39131000','Acido alginico, seus sais e ésteres, em forma primária','Alginic acid,  its salts and esters, primary forms','Ácido algínico, sus sales y ésteres, en forma primaria',10,'39','3913','391310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39139011','Borracha clorada ou cloridratada, em pedaços, grumos, etc.','Chlorinated/hydrochloride rubber, in pieces, clots, etc.','Caucho clorado o clorhidratado, en pedazos, grumos, etc.',10,'39','3913','391390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39139012','Borracha clorada em outras formas primárias','Chlorinated rubber, in other forms','Caucho clorado en otras formas primarias',10,'39','3913','391390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39139019','Outs.derivs.quim.da borracha natural, em formas primar.','Ot.natural rubber/its chemical derivatives, prim.forms','Los dem.derivs.quím.del caucho natur.en formas primar.',10,'39','3913','391390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39139020','Goma xantana, em formas primárias','Xanthane gum, in primary forms','Goma xantana, en formas primarias',10,'39','3913','391390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39139030','Dextrana em formas primárias','Dextran, in primary forms','Dextrano en formas primarias',10,'39','3913','391390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39139040','Proteínas endurecidas em formas primárias','Hardened proteins, in primary forms','Proteínas endurecidas en formas primarias',10,'39','3913','391390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39139050','Quitosan, seus sais ou derivados, em formas primárias','Chitosan, its salts/derivatives, in primary forms','Quitosan, sus sales o derivados, en formas primarias',10,'39','3913','391390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39139060','Sulfato de condroitina e seus sais','Chondroitin sulfate and its salts','Sulfato de condroitina y sus sales',10,'39','3913','391390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39139090','Outs.polímeros naturais, incl.modif.em formas primárias','Oth.natural polymers, incl.modified, in primary forms','Ots.polímeros naturales, incl.modif.en formas primarias',10,'39','3913','391390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39140011','Permutad.de ions, base copolim.estireno-divinilbenz.etc.','Ion-exchangers based on copolymers styrene-divinylb.etc','Intercam.de iones, base copolím.estireno-divinilbenc.etc',10,'39','3914','391400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39140019','Outs.permutad.de ions, a base poliestireno/seus copolim.','Oth.ion-exchangers based on polystyrene/its copolymers','Intercam.de iones, a base poliestireno/sus copolímero',10,'39','3914','391400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39140090','Permutad.de ions, à base de outs.polim.em formas primar.','Ion-exchangers based on of oth.copolymers, primary form','Intercam.de iones, a base de ots.polím.en formas primar.',10,'39','3914','391400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39151000','Desperdícios, resíduos e aparas, de polímeros de etileno','Wastem, parings and scrap, of polymers of ethylene','Desechos, desperdics.y recortes, de polímeros de etileno',10,'39','3915','391510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39152000','Desperdícios, resíduos e aparas, de polímeros de estireno','Wastem, parings and scrap, of polymers of styrene','Desechos, desperdics.y recortes, de polímeros de estireno',10,'39','3915','391520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39153000','Desperdícios, resíduos, etc.de polim.de cloreto de vinila','Wastem, parings, etc.of polymers of vinyl chloride','Desechos, despers.y recortes, etc.de polím.cloruro vinilo',10,'39','3915','391530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39159000','Desperdícios, resíduos e aparas, de outros plásticos','Wastem, parings and scrap of other plastics','Desechos, desperdicios y recortes, de otros plásticos',10,'39','3915','391590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39161000','Monofilamentos (monofios), etc.de polímeros de etileno','Monofilaments, etc.of polymers of ethylene','Monofilamentos, etc.de polímeros de etileno',10,'39','3916','391610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39162000','Monofilamentos (monofios), etc.de polim.cloreto vinila','Monofilaments, etc.of polymers of vinyl chloride','Monofilamentos, etc.de polímeros de cloruro de vinilo',10,'39','3916','391620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39169010','Monofilamentos (monofios), de outros plásticos','Monofilaments, of other plastics','Monofilamentos, de otros plásticos',10,'39','3916','391690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39169090','Varas, bastoes e perfis, de outros plásticos','Sticks and profiles, of other plastics','Barras, varillas y perfiles, de otros plásticos',10,'39','3916','391690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39171010','Tripas artificiais de proteínas endurecidas','Artificial guts of hardened protein','Tripas artificiales de proteínas endurecidas',10,'39','3917','391710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39171021','Tripas artifs.fibrosas, de celulose regenerada.d>=150mm','Artificial guts, of regenerate cellulose d>=150mm','Tripas artifs.fibrosas, de celulosa regenerada.d>=150mm',10,'39','3917','391710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39171029','Tripas artificiais de outros plásticos celulosicos','Artificial guts of other cellulosic plastics','Tripas artificiales de otros plásticos celulósicos',10,'39','3917','391710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39172100','Tubo rígido, de polímeros de etileno','Rigid tubes, of polymers of ethylene','Tubo rígido, de polímeros de etileno',10,'39','3917','391721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39172200','Tubo rígido, de polímeros de propileno','Rigid tubes, of polymers of propylene','Tubo rígido, de polímeros de propileno',10,'39','3917','391722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39172300','Tubo rígido, de polímeros de cloreto de vinila','Rigid tubes, of polymers of vinyl chloride','Tubo rígido, de polímeros de cloruro de vinilo',10,'39','3917','391723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39172900','Tubo rígido, de outros plásticos','Rigid tubes, of other plastics','Tubo rígido, de otros plásticos',10,'39','3917','391729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39173100','Tubo flexivel, de plástico, p/suportar pressão>=27.6 mpa','Flexible tubes, of plastic, forsupport pressure>=27.6 mpa','Tubo flexible, de plástico, p/soportar presión>=27.6 mpa',10,'39','3917','391731');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39173210','Tubo de copolímeros de etileno, n/reforcado, s/acessórios','Tubes of copol.of ethylene, n/reinforc., without fittings','Tubo de copolímeros de etileno, s/reforzar, s/accesorios',10,'39','3917','391732');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39173221','Tubo capilar semipermeav.de polipropileno, p/hemodiálise','Semipermeable capillary tube of polypforhemodyalisis','Tubo capilar semipermeab.de polipropileno, p/hemodiálise',10,'39','3917','391732');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39173229','Outs.tubos de polipropileno, n/reforcados, sem acessórios','Other tubes of polypr., n/reinforced, without fittings','Ots.tubos de polipropileno, s/reforzar, sin accesorios',10,'39','3917','391732');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39173230','Tubo de tereftalato de polietileno, n/reforçado, s/acess.','Tube of poly(ethylene terephth.), n/reinf., without fit.','Tubo de tereftalato de polietileno, s/reforzar, s/acces.',10,'39','3917','391732');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39173240','Tubo de silicones, não reforçado, sem acessórios','Tubes of silicones, n/reinforced, without fittings','Tubo de siliconas, sin reforzar, sin accesorios',10,'39','3917','391732');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39173251','Tubo capilar semipermeav.celulose regener.p/hemodiálise','Semipermeable capillary tube reg.cellul.forhemodyalisis','Tubo capilar semipermeab.celulosa regener.p/hemodiálise',10,'39','3917','391732');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39173259','Outs.tubos de celulose regenerada, n/reforcados, s/acess.','Oth.tubes of regenerate, n/reinforced, without fittings','Ots.tubos de celulosa regenerada, s/reforzar, s/acces.',10,'39','3917','391732');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39173290','Outros tubos de plásticos, não reforçados, sem acessórios','Oth.tubes of plastics, n/reinforced, without fittings','Ots.tubos de plásticos, s/reforzar, s/accesorios',10,'39','3917','391732');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39173300','Tubo de plástico, não reforçado, com acessórios','Tubes of plastic, n/reinforced, without fittings','Tubo de plástico, sin reforzar, con accesorios',10,'39','3917','391733');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39173900','Outros tubos de plásticos','Other plastic tubes','Otros tubos de plásticos',10,'39','3917','391739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39174000','Acessórios para tubos, de plásticos','Fittings for tubes, of plastics','Accesorios para tubos, de plásticos',10,'39','3917','391740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39174010','Acessórios para tubos, de plásticos, utilizados em hemodiálise','Fittings for tubes, of plastcis, used in hemodialysis','Accesorios p/tubos, de plásticos, util.en hemodiálise',10,'39','3917','391740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39174090','Outros acessórios para tubos, de plásticos','Other fittings for tubes, of plastics','Otros accesorios para tubos, de plásticos',10,'39','3917','391740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39181000','Revestimentos de pavimentos, etc.de polimer.de cloreto vinila','Floor coverings, etc.of polymers of vinyl chloride','Revestim.de suelos, etc.de polímer.de cloruro de vinilo',10,'39','3918','391810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39189000','Revestim.de pavimentos/paredes/tetos, de outs.plásticos','Floor coverings, walls/roofs, of other plastics','Revestim.de suelos/paredes/techos, de ots.plásticos',10,'39','3918','391890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39191000','Chapas, fls.etc.auto-adesivas, de plásticos, rolos, l<=20cm','Plates, sheets, etc.self-adhes., of plastics, rolls, w<=20cm','Placas, hjs.etc.autoadhesivas, de plásts., rollos, a<=20cm',10,'39','3919','391910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39199000','Outs.chapas, folhas, tiras, etc.auto-adesivas, de plásticos','Oth.plates, sheets, strip, etc.self-adhes.of plastics','Ots.placas, hojas, tiras, etc.autoadhesivas, de plástico',10,'39','3919','391990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39201000','Chapas, etc.de polímeros etileno, s/suporte, n/reforc.etc.','Plates, etc.of polym.of ethylene, without sup.n/reinf.etc','Placas, etc.de polímeros etileno, s/soporte, s/esfuer.etc.',10,'39','3920','392010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39201010','Chapas de polímeros etileno, n/reforcad.etc.rolo l<=66cm','Plates of polymers of ethylene, n/reinf.etc.roll w<=66cm','Placas de polímeros etileno, s/esfuer.etc.rollo.a<=66cm',10,'39','3920','392010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39201090','Outras chapas de polímeros de etileno, n/reforcadas, etc.','Other plates of polymers of ethylene, n/reinf.etc.','Otras placas de polímeros de etileno, s/esfuerzo, etc',10,'39','3920','392010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39201091','Chapas de polim.etileno, n/ref.etc.fabr.separ.acum.eletr','Plates of polymers of ethyl., n/reinf.etc.prod.acum.elec','Placas de polím.etileno, s/esf.etc.fabr.separ.acum.eletr',10,'39','3920','392010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39201099','Outras chapas de polímeros de etileno, n/reforcadas, etc.','Other plates of polymers of ethylene, n/reinforced, etc','Otras placas de polímeros de etileno, s/esfuerzo, etc',10,'39','3920','392010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39202011','Chapas, etc.polim.propileno, biax.orient.metaliz.s/suport','Plates, etc.polym.of prop.biax.orien.metal./without sup','Placas, etc.polím.propileno, biax.orient.metaliz.s/sopor.',10,'39','3920','392020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39202012','Chapas, etc.polim.propileno, biax.orient.metaliz.s/suport','Plates, etc., polym.of prop.biax.orien.metal./without sup','Placas, etc.polím.propileno, biax.orient.metaliz.s/soport',10,'39','3920','392020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39202019','Outras chapas, etc.polim.propileno, biax.orient.s/suporte','Ot.plates, etc.polym.prop.biax.orien.met./without sup','Otras placas, etc.polím.propileno, biax.orient.s/soporte',10,'39','3920','392020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39202090','Outs.chapas, etc.polim.propileno, s/suporte, n/reforc.etc.','Other plates, etc.polym.of propyl.without supp.n/reinf.','Ots.placs, etc.polím.propileno, s/soporte, ni esfuerzo, etc',10,'39','3920','392020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39203000','Chapas, etc.de polímeros estireno, s/suporte, n/reforc.etc','Plates, etc.polym.of styrene without supp.n/reinf.etc','Placas, etc.de polímeros estireno, s/soporte, n/esfuer.etc',10,'39','3920','392030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39204100','Chapas, etc.de polim.cloreto vinila, rígidas, s/suport.etc','Plates, etc.polym.of vinyl chloride without supp.etc','Placas, etc.de polím.cloruro vinilo, rigidas, s/soport.etc',10,'39','3920','392041');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39204210','Chapas, etc.policloreto vinila, flexiv.transpar.s/suporte','Plates, etc.polym.of polyvin.chlor.flex.tran.without sup','Placas, etc.policloruro vinilo, flexib.transpar.s/soporte',10,'39','3920','392042');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39204290','Outs.chapas, etc.policloreto vinila, flexivs.s/suport.etc','Ot.plates, etc.polym.of polyv.chlor.flex.without sup.etc','Ots.placas, etc.policloruro vinilo, flexibs.s/soport.etc',10,'39','3920','392042');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39204310','Chapas poli(cloreto vinila) plast>=6%, transp.','Plates of poly(vinyl chloride) plast>=6%, transp.','Placas poli(cloruro vinilo) plást>=6%, transp.',10,'39','3920','392043');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39204390','Outs.chapas de polim.cloreto vinila, plast>=6%','Other plates of poly(vinyl chloride), plast>=6%','Ots.placas de polím.cloruro vinilo, plást>=6%',10,'39','3920','392043');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39204900','Outs.chapas, fls.etc.de polim.cloreto vinila','Other plates, sheets, etc.of poly(vinyl chloride)','Ots.placas, hojas.etc.de polím.cloruro de vinilo',10,'39','3920','392049');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39205100','Chapas, etc.polimetacrilato metila, s/suport.n/reforc.etc','Plates, etc.of poly(meth.methac.), without sup.n/rein.etc','Placas, etc.polimetacrilato metilo, s/soport.n/esfuer.etc',10,'39','3920','392051');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39205900','Outs.chapas, etc.polímeros acrílicos, s/suporte, n/reforc.','Plates, etc.acrylate polymers, without sup.n/rein.etc','Ots.placas, etc.polímeros acrílicos, s/soporte, n/esfuerzo',10,'39','3920','392059');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39206100','Chapas, etc.de policarbonatos, s/suporte, n/reforcadas, etc','Plates, etc.of polycarbonates, without sup.n/rein.etc','Placas, etc.de policarbonatos, s/soporte, n/esfuerzo, etc',10,'39','3920','392061');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39206211','Chapas, etc.tereftalato polieteno, e<5 micr.s/suporte, etc','Plates, etc.poly(ethyl.tereph.)t<5 micr.without supp.etc','Placas, etc.tereftalato polietil., e<5 micr.s/soporte, etc',10,'39','3920','392062');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39206219','Outs.chapas, etc.tereft.polietileno, e<=40 micr.s/suporte','Ot.plates, etc.poly(ethyl.tereph.)t<=40 micr.without sup','Ots.placas, etc.tereft.polietileno, e<=40 micr.s/soporte',10,'39','3920','392062');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39206291','Chapas, etc.tereftalato polietileno, l>12cm, s/suporte, etc','Plates, etc.poly(ethyl.tereph.)w<=12cm, without supp.etc','Placas, etc.tereftalato polietileno, a>12cm, s/soporte, etc',10,'39','3920','392062');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39206299','Outras chapas, etc.tereftalato polietileno, s/suporte, etc','Oth.plates, etc.poly(ethyl.terephthalate)without sup.etc','Otras placas, etc.tereftalato polietileno, s/soporte, etc',10,'39','3920','392062');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39206300','Chapas, etc.de poliésteres n/saturad.s/suporte, n/reforc.','Plates, etc.unsatur.polyesters without sup.n/reinforced','Placas, etc.de poliésteres n/saturad.s/soporte, n/esfuer.',10,'39','3920','392063');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39206900','Chapas, etc.de outs.poliésteres, s/suporte, n/reforcad.etc','Plates, etc.of ot.polyesters without supp.n/reinfor.etc','Placas, etc.de ots.poliésteres, s/soporte, ni esfuerzo, etc',10,'39','3920','392069');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39207100','Chapas, etc.de celulose regener.s/suporte, n/reforcad.etc','Plates, etc., reg.cellulose without supp.n/reinf.etc','Placas, etc.de celulosa regener.s/soporte, n/esfuerzo, etc',10,'39','3920','392071');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39207210','Chapas, etc.de fibra vulcaniz.e<=1mm, s/suporte, n/reforc.','Plates, etc.of vulcan.fibre t<=1mm, without supp.n/reinf.','Placas, etc.de fibra vulcaniz.e<=1mm, s/soporte, n/esfuer.',10,'39','3920','392072');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39207290','Outs.chapas, etc.de fibra vulcaniz.s/suport.n/reforc.etc','Oth.plates, etc., of vulcan.fibre, without sup.n/reinf.etc','Ots.placas, etc.de fibra vulcaniz.s/soporte, n/esfuer.etc',10,'39','3920','392072');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39207310','Chapas, etc.acetato celulose, e<=0.75mm, s/suport.n/reforc','Plates, etc.cellulos.acet., t<=0.75mm, without sup.n/reinf','Placas, etc.acetato celulosa, e<=0.75mm, s/soport.n/esfuer',10,'39','3920','392073');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39207390','Outs.chapas, etc.de acetato celulose, s/suporte, n/reforc.','Ot.plates, etc.cellulose acetate, without support, n/reinf','Ots.placas, etc.de acetato celulosa, s/soporte, n/esfuerzo',10,'39','3920','392073');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39207900','Chapas, etc.de outs.derivs.celulose, s/suporte, n/reforc.','Plates, etc.oth.cellulose derivat.without supp.n/reinf.','Placas, etc.de ots.derivs.celulosa, s/soporte, n/esfuerzo',10,'39','3920','392079');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39207910','Outs.chapas, fls.d/cel., fibra vulc.esp.=<1mm','Other plates, cellulose sheets, vulcan. fibre thick.=<1mm','Otras placas, hojas de celulosa, fibra vulc. espesura=<1mm',10,'39','3920','392079');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39207990','Outs.chapas, fls, tir.de outs.der.da celulose','Other plates, sheets, ribbons of other cellulose derived','Otras placas, hojas, cintas de otros derivados de celulosa',10,'39','3920','392079');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39209100','Chapas, etc.butiral polivinila, s/suporte, n/reforcad.etc.','Plates, etc.poly(vinyl butyral), without supp.n/rein.etc','Placas, etc.butiral polivinilo, s/soporte, n/esfuerzo, etc',10,'39','3920','392091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39209200','Chapas, etc.de poliamidas, s/suporte, n/reforcadas, etc.','Plates, etc.of polyamides, without support, n/reinf.etc','Placas, etc.de poliamidas, s/soporte, n/esfuerzo, etc.',10,'39','3920','392092');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39209300','Chapas, etc.de resinas amínicas, s/suporte, n/reforcad.etc','Plates, etc.of amino-resins, without support, n/reinf.etc','Placas, etc.de resinas amínicas, s/soporte, n/esfuerzo, etc',10,'39','3920','392093');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39209400','Chapas, etc.de resinas fenólicas, s/suporte, n/reforc.etc.','Plates, etc.of phenolic resins, without supp.n/rein.etc','Placas, etc.de resinas fenólicas, s/soporte, n/esfuer.etc.',10,'39','3920','392094');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39209910','Chapas, etc.de silicones, s/suporte, n/reforcadas, etc.','Plates, etc.of silicones, without support, n/reinf.etc','Placas, etc.de siliconas, s/soporte, n/esfuerzo, etc.',10,'39','3920','392099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39209920','Chapas, etc.de álcool polivinilico, s/suport.n/reforc.etc','Plates, etc.poly(vinyl alcohol), without supp., n/rein.etc','Placas, etc.de alcohol polivinílico, s/soport.n/esf.etc',10,'39','3920','392099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39209930','Chapas, etc.polim.fluoreto vinila, s/suport.n/reforc.etc.','Plates, etc.polym.of vinyl fluor., without sup.n/rein.etc','Placas, etc.polím.fluoruro vinilo, s/soport.n/esfuer.etc.',10,'39','3920','392099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39209940','Chapas, etc.de poliimida, s/suporte, n/reforcadas, etc','Plates, etc.polym.of polyimides, without supp., n/rein.etc','Placas, etc.de poliimida, s/soporte, n/esfuerzo, etc',10,'39','3920','392099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39209950','Chapas, etc.de poli(clorotrifluoroetileno), n/reforc.etc','Plates, etc. of poli(chlorotrifluoroethylene), no reinforce, etc','Placas, etc., de poli(clorotrifluoroetileno), n/esfuerzo, etc.',10,'39','3920','392099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39209990','Outs.chapas, etc.de outs.plásticos, n/alveol.s/suport.etc','Oth.plates, etc.of ot.plastic, n/alveol.without supp.etc','Ots.placas, etc.de ots.plásticos, n/celular, s/soport.etc',10,'39','3920','392099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39211100','Outras chapas, etc.de polímeros de estireno, alveolares','Oth.plates, etc.of polymers of styrene, alveolar','Otras placas, etc.de polímeros de estireno, celulares',10,'39','3921','392111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39211200','Outs.chapas, etc.de polimer.de cloreto vinila, alveolares','Oth.plates, etc.of polymers of vinyl chloride, alveolar','Ots.placas, etc.de polímer.de cloruro vinilo, celulares',10,'39','3921','392112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39211300','Outras chapas, etc.de poliuteranos, alveolares','Oth.plates, etc.of polyurethanes, alveolar','Otras placas, etc.de poliuretanos, celulares',10,'39','3921','392113');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39211310','Outs.chapas, etc.de polester, 24<=poros<=157, 3, 5<=pka<=4','Oth.plates, etc.of polyester, 24<=pores<=157, 3, 5<=pka<=4','Ots.placas, etc.de poliéster, 24<=poros<=157, 3, 5<=pka<=4',10,'39','3921','392113');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39211390','Outs.chapas, etc.de poliuretanos, alveolares','Other plates, etc.of polyurethanes, alveolar','Ots.placas, etc.de poliuretanos, celulares',10,'39','3921','392113');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39211400','Outras chapas, etc.de celulose regenerada, alveolares','Other plates, etc.regenerated cellulose, alveolar','Otras placas, etc.de celulosa regenerada, celulares',10,'39','3921','392114');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39211900','Outras chapas, etc.de outras plásticos, alveolares','Other plates, etc.of other plastics, alveolar','Otras placas, etc.de otros plásticos, celulares',10,'39','3921','392119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39219011','Chapas, etc.de resina melamina-formaldeído, estratificads','Plates, etc.melamine-formaldeh.resin, stratified','Placas, etc.de resina melamina-formaldehído, estratifics.',10,'39','3921','392190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39219012','Outs.chapas etc.d/outs.plásts.c/sup.d/poliet.','Other plates, etc. of other plastics with polyethylene support','Otras placas, etc. de otros plásticos con soporte de polietileno',10,'39','3921','392190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39219019','Outras chapas, etc.de outras plásticos, estratificadas','Other plates, etc.of other plastics, stratified','Otras placas, etc.de otros plásticos, estratificadas',10,'39','3921','392190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39219020','Outs.chapas, etc.de outs.plásticos, c/suporte ou reforco','Other plates, etc.of other plastics, with supp./reinfor.','Ots.placas, etc.de ots.plásticos, c/soporte o refuerzo',10,'39','3921','392190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39219022','Outs.chapas, etc.de polietileno, c/reforco, impregn.resina','Oth.plates, etc.of poly(ethylene) with rein.resin impreg','Ots.placas, etc.de polietileno, c/refuerzo, impregn.resina',10,'39','3921','392190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39219029','Outs.chapas, etc.de outs.plásticos, c/suporte ou reforco','Other plates, etc.of other plastics, with supp./reinfor.','Ots.placas, etc.de ots.plásticos, c/soporte o refuerzo',10,'39','3921','392190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39219030','Outs.chapas, etc.tereftalato polietileno substratad.etc.','Other plates, etc.subst.poly(ethylene terephthalate)etc.','Ots.placas, etc.tereftalato polietileno substratad.etc.',10,'39','3921','392190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39219090','Outs.chapas, folhas, peliculas, tiras, laminas, de plásticos','Other foils, sheets, film, plates and strip, of plastics','Ots.placas, hojas, tiras, laminas, de plásticos',10,'39','3921','392190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39221000','Banheiras, banheiras p/duchas e lavatórios, de plásticos','Baths, shower-baths, sinks and wash-basin, of plastics','Bañeras, duchas y lavabos, de plásticos',10,'39','3922','392210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39222000','Assentos e tampas de sanitarios, de plásticos','Lavatory seats and covers, of plastics','Asientos y tapas de sanitarios, de plásticos',10,'39','3922','392220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39229000','Outs.artigos p/usos sanitarios/higiênicos, de plásticos','Oth.articles forsanitary and hygienic uses, of plastics','Ots.artículos p/usos sanitarios/higiénicos, de plásticos',10,'39','3922','392290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39231000','Caixas, caixotes, engradados, artigos semelhs.de plásticos','Boxes, cases, crates and similar articles, of plastics','Cajas, cajones, jaulas, artículos similares de plásticos',10,'39','3923','392310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39231010','Estojos de plástico, p/acondic.disco leit.raio "laser"','Plast.cases, used forputting up discs for laser read.syst','Estuches de plástico, p/acondic.disco lect.rayo "láser"',10,'39','3923','392310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39231090','Outs.artigos semelh.caixas, engradados, etc.de plástico','Oth.boxes, cases, crates, similar articles, etc.of plastics','Ots.artículos similares, cajas, jaulas, etc.de plástico',10,'39','3923','392310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39232110','Sacos, bolsas, cartuchos, de polim.de etileno, cap<=1000cm3','Sacks, bags, cartridge, of ethylene polymers, cap<=1000cm³','Sacos, bolsit., cucuruchos, de pol.de etileno, cap<=1000cm³',10,'39','3923','392321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39232190','Outros sacos, bolsas e cartuchos, de polímeros de etileno','Other sacks, bags, cartridge, of ethylene polymers','Otros sacos, bolsitas y cucuruchos, de políms.de etileno',10,'39','3923','392321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39232910','Sacos, bolsas e cartuchos, de outs.plásticos, cap<=1000cm3','Sacks, bags, cartridge, of other plastics, cap<=1000cm³','Sacos, bolsitas y cucuruchos, de ots.plásts., cap<=1000cm³',10,'39','3923','392329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39232990','Outros sacos, bolsas e cartuchos, de outros plásticos','Other sacks, bags and cartridge, of other plastics','Otros sacos, bolsitas y cucuruchos, de otros plásticos',10,'39','3923','392329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39233000','Garrafões, garrafas, frascos, artigos semelhs.de plásticos','Carboys, bottles, flasks, similar articles, of plastics','Bombonas, botellas, frascos, artículos simil.de plásticos',10,'39','3923','392330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39234000','Bobinas, carretéis e suportes semelhantes, de plásticos','Spools, cops, bobbins and similar supports, of plastics','Bobinas, carretes y soportes similares, de plásticos',10,'39','3923','392340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39235000','Rolhas, tampas, etc.p/fechar recipientes, de plásticos','Stoppers, lids, caps, etc.forclose recip.of plastics','Tapones, tapas y demás dispositivos de cierre, de plásts.',10,'39','3923','392350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39239000','Outs.artigos de transporte ou de embalagem, de plásticos','Oth.articles for the conveyance or packing, of plastics','Ots.artículos p/transporte o envasado, de plásticos',10,'39','3923','392390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39241000','Serviços de mesa/outs.artigos mesa/cozinha, de plásticos','Tableware, kitchenware, oth.household articles, of plast.','Vajillas/ots.artículos p/serv. mesa/cocina, de plásticos',10,'39','3924','392410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39249000','Outros artigos de higiene ou de toucador, de plástico','Other articles of hygiene/of dressing table, of plastic','Otros artículos de higiene o de tocador, de plástico',10,'39','3924','392490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39251000','Reservatórios, cisternas, cubas, etc.de plásticos, cap>300l','Reservoirs, tanks, vats, etc.of plastics, cap>300l','Depósitos, cisternas, cubas, etc.de plásticos, cap>300l',10,'39','3925','392510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39252000','Portas, janelas, seus caixilhos, alizares, etc.de plásticos','Doors, windows, their frame, thresholds, etc.of plastics','Puertas, ventanas, sus marcos, contramarcos, etc.de plásts.',10,'39','3925','392520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39253000','Postigos, estores, artigos semelhs.e partes, de plásticos','Shutters, blinds, similar articles and parts, of plastics','Contraventanas, persianas, arts.simil.y partes, de plásts.',10,'39','3925','392530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39259000','Outs.artefatos p/apetrecham.de construções, de plásticos','Other builders'' ware of plastics','Ots.artículos para la construcción, de plásticos',10,'39','3925','392590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39259010','Outs.artefatos p/ apetrecham. de construcoes, de poliestireno expandido (eps)','Other artifacts for equipping buildings, of expanded polystyrene','Otros objetos para la construccion, de polistireno expandido',10,'39','3925','392590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39259090','Outros artefatos para apetrechamento de construções','Other artifacts for equipping buildings','Otros objetos para la construccion',10,'39','3925','392590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39261000','Artigos de escritório e artigos escolares, de plásticos','Articles of office or school supplies, of plastics','Artículos de oficina y artículos escolares, de plásticos',10,'39','3926','392610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39262000','Vestuário e seus acessórios, de plásticos, incl.luvas','Articles of apparel/accessories, of plastics, incl.mitts','Prendas y sus complementos, de plásticos, incl.guantes',10,'39','3926','392620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39263000','Guarnições p/moveis, carroçarias e semelhs.de plásticos','Fittings forfurniture, coachwork or the like, of plastics','Guarniciones p/muebles, carrocerías y simil.de plásticos',10,'39','3926','392630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39264000','Estatuetas e outs.objetos de ornamentação, de plásticos','Statuettes and other ornamental articles, of plastics','Estatuillas y demás artículos de adorno, de plásticos',10,'39','3926','392640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39269010','Arruelas (anilhas) de plásticos','Washers of plastics','Tornillos de plásticos',10,'39','3926','392690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39269021','Correias de transmissão, de plásticos','Transmission belts or belting, of plastics','Correas de transmisión, de plásticos',10,'39','3926','392690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39269022','Correias transportadoras, de plásticos','Conveyor or elevator belts or belting, of plastics','Correas transportadoras, de plásticos',10,'39','3926','392690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39269030','Bolsas de plast.p/uso em medicina(colostomia, hemodial.)','Plastic bags for medical use (colostomy, hemodialysis)','Bolsas de plást.p/uso en medicina(colostomia, hemodial.)',10,'39','3926','392690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39269031','Bolsas de plast.,  p/colostomia, ileostomia ou urostomia','Plastic bags for colostomy, ileostomy, urostomy','Bolsas de plástico, para colostomia, ileostomia o urostomia',10,'39','3926','392690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39269032','Bolsas de plast.p/uso em hemodiálise','Plastic bags for use in hemodialysis','Bolsas de plástico para uso en hemodialisis',10,'39','3926','392690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39269039','Outs.bolsas de plast.p/uso em medicina','Other plastic bags for medical use','Otras bolsas de plástico para uso medicinal',10,'39','3926','392690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39269040','Artigos de laboratorio ou de farmacia, de plásticos','Laboratory and pharmaceutical articles, of plastics','Artículos de laboratorio o de farmacia, de plásticos',10,'39','3926','392690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39269050','Outs.acess.de plásticos, util.p/hemodiálise, obturadores','Oth.acces.of plastics, used for hemodialysis, obturators','Ots.acces.de plásticos, util.p/hemodiálisis, obturadores',10,'39','3926','392690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39269061','Aneis de sec.transv.circ.de tetrafluoroetileno e eter.','Rings of circular cross section of tetrafluoroethylene and ether ','Anillos de sección circular transversal de tetrafluoroetileno e éter',10,'39','3926','392690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39269069','Outs.aneis de secao tranversal circular, de plástico','Rings of circular cross section of plastic','Anillos de sección circular transversal de plástico',10,'39','3926','392690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('39269090','Outras obras de plásticos','Other articles of plastics','Otras manufacturas de plásticos',10,'39','3926','392690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40011000','Latex de borracha natural, mesmo pre-vulcanizado','Natural rubber latex, whether or not prevulcanised','Látex de caucho natural, incluso prevulcanizado',10,'40','4001','400110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40012100','Borracha natural em folhas fumadas','Natural rubber in other forms smoked sheets','Caucho natural en hojas ahumadas',10,'40','4001','400121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40012200','Borracha natural técnicam.especif.(tsnr), em outs.formas','Technically specified natural rubber (tsnr), other forms','Caucho natural técnicam.especif.(tsnr), en ots.formas',10,'40','4001','400122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40012910','Borracha natural crepada','Creped natural rubber','Caucho natural crepé',10,'40','4001','400129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40012920','Borracha natural granulada ou prensada','Natural rubber granulated or compressed','Caucho natural granulado o prensado',10,'40','4001','400129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40012990','Borracha natural em outras formas','Natural rubber in other forms','Caucho natural en otras formas',10,'40','4001','400129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40013000','Balata, guta-percha, chicle e gomas naturais analogas','Balata, gutta-percha, guayule, chicle, similar natur.gums','Balata, gutapercha, chicle y gomas naturales análogas',10,'40','4001','400130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40021110','Latex de borracha de estireno-butadieno (sbr)','Rubber of latex of styrene-butadiene (sbr)','Látex de caucho de estireno butadieno (sbr)',10,'40','4002','400211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40021120','Latex de borracha de estireno-butadieno-carboxilada','Rubber of latex of carboxylated styrene-butadiene','Látex de caucho de estireno-butadieno carboxilado(xsbr)',10,'40','4002','400211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40021911','Borracha de estireno-butadieno, em chapas, folhas, tiras','Styrene-butadiene rubber, in foils, sheets, strip','Caucho de estireno butadieno, en placas, hojas, tiras',10,'40','4002','400219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40021912','Borracha de estireno-butadieno, grau alim.forma primária','Styrene-butadiene rubber, food grade, primary form','Caucho de estireno butadieno, grado alim., forma primaria',10,'40','4002','400219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40021919','Borracha de estireno-butadieno, em outs.formas primárias','Styrene-butadiene rubber, in other primary forms','Caucho de estireno butadieno, en otras formas primarias',10,'40','4002','400219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40021920','Borracha de estireno-butadieno-carboxilad.em chapas, etc','Carboxylated styrene-butadiene rubber, in foils, etc.','Caucho de estireno-butadieno carboxilad.en placas, etc',10,'40','4002','400219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40022010','Oleo de borracha de butadieno (br)','Butadiene rubber oil (br)','Aceite de caucho butadieno (br)',10,'40','4002','400220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40022090','Borracha de butadieno (br), em chapas, folhas, tiras, etc.','Butadiene rubber (br), in foil, sheets, strip, etc.','Caucho butadieno (br), en placas, hojas, tiras, etc.',10,'40','4002','400220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40023100','Borracha de isobuteno-isopreno (butila), em chapas, etc.','Isobutene-isoprene (butyl) rubber, in foils, etc.','Caucho isobuteno-isopreno (butilo), en placas, etc.',10,'40','4002','400231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40023900','Borracha de isobuteno-isopreno halogenada, em chapas, etc','Isobutene-isoprene rubber halogenated, in foils, etc','Caucho isobuteno-isopreno halogenado, en placas, etc',10,'40','4002','400239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40024100','Latex de borracha de cloropreno (clorobutadieno)(cr)','Latex of rubber of chloroprene (chlorobutadiene)(cr)','Látex de caucho cloropreno (clorobutadieno)(cr)',10,'40','4002','400241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40024900','Borracha de cloropreno (clorobutadieno), em chapas, etc.','Chloroprene(chlorobutadiene)rubber(cr), in foils, etc.','Caucho cloropreno (clorobutadieno), en placas, etc',10,'40','4002','400249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40025100','Latex de borracha de acrilonitrila-butadieno (nbr)','Latex of rubber of acrylonitrile-butadiene(nbr)','Látex de caucho acrilonitrilo-butadieno (nbr)',10,'40','4002','400251');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40025900','Borracha de acrilonitrila-butadieno em chapas, fls.etc.','Acrylonitrile-butadiene rubber, in foils, sheets, etc.','Caucho acrilonitrilo-butadieno en placas, hojas, etc',10,'40','4002','400259');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40026000','Borracha de isopreno (ir) em chapas, folhas, tiras, etc.','Isoprene rubber (ir) in foils, sheets, strip, etc.','Caucho isopreno (ir) en placas, hojas, tiras, etc.',10,'40','4002','400260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40027000','Borracha de etileno-propileno-dieno n/conjug.em chapas, ','Ethylene-propylene-non-conjugat.diene rubber, in foils, ','Caucho etileno-propileno-dieno n/conjugado en placas',10,'40','4002','400270');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40028000','Misturas de borracha natural com borracha sintética, etc','Mixtures of natural rubber with synthetic rubber, etc','Mezclas de caucho natural con caucho sintético, etc',10,'40','4002','400280');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40029100','Latex de outras borrachas sintéticas ou artificiais','Latex of other synthetic rubber or artificial','Látex de otros cauchos sintéticos o artificiales',10,'40','4002','400291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40029910','Borracha estireno-isopreno-estireno em chapas, fls.etc.','Styrene-isoprene-styrene rubber in foils, sheets, etc.','Caucho estireno-isopreno-estireno en placas, hojas, etc.',10,'40','4002','400299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40029920','Borracha etileno-propileno-dieno n/conjugado-propil.etc','Ethylene-propylene-non-conjugated diene-prop.rubber, etc','Caucho etileno-propileno-dieno n/conjugado-propil.etc',10,'40','4002','400299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40029930','Borracha acrilonitrila-butadieno hidrogenada','Hydrogenated acrylonitrile-butadiene rubber','Caucho acrilonitrilo-butadieno hidrogenado',10,'40','4002','400299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40029990','Outras borrachas sintéticas e artificiais, em chapas, etc','Other synthetic and artificial rubber, in foils, etc','Otros cauchos sintéticos y artificiales, en placas, etc',10,'40','4002','400299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40030000','Borracha regenerada, em formas primárias ou chapas, etc.','Reclaimed rubber in primary forms or in plates, etc.','Caucho regenerado, en formas primarias o placas, etc.',10,'40','4003','400300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40040000','Desperdícios, resíduos, etc.de borracha nao endurecida','Waste,  parings, etc.of rubber n/hardened','Desechos, desperdicios, etc.de caucho sin endurecer',10,'40','4004','400400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40051010','Borracha etileno-propileno-dieno, etc.c/silica, grânulos','Ethylene-propylene-diene rubber, etc.with silica, granul.','Caucho etileno-propileno-dieno, etc.c/sílice, gránulos',10,'40','4005','400510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40051090','Outs.borrachas vulcan.c/negro fumo/silica, em chapas, etc','Oth.vulcan.rubber with carbon black/silica, in foils, etc','Ots.cauchos s/vulcan.c/negro humo/sílice, en placas, etc',10,'40','4005','400510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40052000','Borracha misturada, n/vulcanizada, em soluções, dispersões','Mixtures rubber, unvulcanised, in solution, dispersions','Caucho mezclado, s/vulcan., en disoluciones, dispersiones',10,'40','4005','400520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40059110','Prepars.base borracha, p/fabr.gomas mascar, em chapas, etc','Prep.with base of rubber, forprod.gums forchew.plates, etc','Prepars.base caucho, p/fabr.gomas mascar, en placas, etc',10,'40','4005','400591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40059190','Outs.borrachas misturadas, n/vulcan.em chapas, fls.tiras','Ot.mixtures rubber, unvulcanised, in plastes, sheets, strip','Ots.cauchos mezclados, s/vulcan.en placas, hojas, tiras',10,'40','4005','400591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40059910','Prepars.base borracha, p/fabr.gomas mascar, formas primar','Prep.with a base of rubber, forprod.gums forchew.prim.foms','Prepars.base caucho, p/fabr.gomas mascar, formas primar.',10,'40','4005','400599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40059990','Outs.borrachas misturadas, n/vulcan.em formas primárias','Other mixtured rubbers, unvulcanised, in primary forms','Otros cauchos mezclados, s/vulcan.en formas primarias',10,'40','4005','400599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40061000','Perfis para recauchutagem, de borracha nao vulcanizada','Camel-back'' for retreading, of rubber, unvulcanised','Perfiles para recauchutar, de caucho sin vulcanizar',10,'40','4006','400610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40069000','Outras formas e artigos, de borracha nao vulcanizada','Other forms and articles, of rubber, unvulcanised','Otras formas y artículos, de caucho sin vulcanizar',10,'40','4006','400690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40070000','Fios e cordas, de borracha vulcanizada','Thread and cord, of vulcanised rubber','Hilos y cuerdas, de caucho vulcanizado',10,'40','4007','400700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40070011','Fios de borracha vulcanizada, recobertos com silicone','Vulcanised rubber thread, covered with silicon','Hilos de caucho vulcanizado, recubiertos con silicona',10,'40','4007','400700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40070019','Outros fios de borracha vulcanizada','Other vulcanised rubber thread','Otros hilos de caucho vulcanizado',10,'40','4007','400700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40070020','Cordas de borracha vulcanizada','Vulcanised rubber cord','Cuerdas de caucho vulcanizado',10,'40','4007','400700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40081100','Chapas, folhas, etc.de borracha vulcan.alveolar n/endurec','Plates, sheets, etc.of rubber vulcanised, alveolar n/hard.','Placas, hojas, etc.de caucho vulcan.celular s/endurecer',10,'40','4008','400811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40081900','Varetas e perfis, de borracha vulcan.alveolar n/endurec.','Rods/profiles of rubber vulcanised, alveolar n/hardened','Varillas y perfiles, de caucho vulcan.celular s/endurec.',10,'40','4008','400819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40082100','Chapas, folhas, etc.de borracha vulcan.n/alveol.n/endurec','Plastes, sheets, etc.of rubber n/vulcan., alveol.n/hard.','Placas, hojas, etc.de caucho vulcan.n/celular s/endurecer',10,'40','4008','400821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40082900','Varetas e perfis de borracha vulcan.n/alveol.n/endurec.','Rods/profiles of rubber vulcanis.n/alveolar, n/hardened','Varillas y perfiles, de caucho vulcan.n/celul.s/endurec.',10,'40','4008','400829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40091000','Tubo de borracha vulcan.n/endurec.n/reforcado, s/acess.','Tubes of vulcanised rubber n/hardened, without fittings','Tubo de caucho vulcan.s/endurec.s/reforzar, sus acces.',10,'40','4009','400910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40091100','Tubo borracha vulcan.n/endur.n/reforc.s/acess','Tubes of vulc.rubber, n/hard.n/reinf.without fittin.','Tubo de caucho vulcan.s/endurec.s/reforzar, sus acces.',10,'40','4009','400911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40091210','Tubo borracha vulcan.n/endur.c/acess.rupt>=17','Tubes of vulc.rubber, n/hard.n/reinf.with fittin.rup>=17','Tubo de caucho vulcan.s/endurec., c/acces.rupt>=17',10,'40','4009','400912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40091290','Outs.tubos de borracha vulcan.n/endur.c/acess','Other tubes of vulc.rubber, n/hard.n/reinf.with fittin.','Ots.tubos de caucho vulcan.s/endur.c/acess',10,'40','4009','400912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40092010','Tubo de borracha vulc.n/endur.c/metal, s/acess.p<17.3mpa','Tubes of vulc.rubber, n/hard.with met.with fit.p<17.3mpa','Tubo de caucho vulc.s/endur.c/metal, s/acess.p<17.3mpa',10,'40','4009','400920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40092090','Outros tubos de borracha vulcan.n/endur.c/metal, s/acess','Oth.tubes of vulc.rubber, n/hard.with met.with fittings','Otros tubos de cauchos vulcan., s/endur.c/metal, s/acces.',10,'40','4009','400920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40092110','Tubo borracha vulc.n/end.ref.met.s/aces.r>=17','Tubes of vulc.rubber n/hard.rein.met.without fitt.r>=17','Tubo de caucho vulc.s/end.ref.met.s/acces.r>=17',10,'40','4009','400921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40092190','Outs.tubos borracha vulc.n/end.ref.met.s/aces','Ot.tubes of vul.rub.n/hard.reinfor.met.without fittings','Otros tubos de caucho vulc.s/end.ref.met.s/acces.',10,'40','4009','400921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40092210','Tubo borracha vulc.n/end.ref.met.c/aces.r>=17','Tubes of vul.rub.n/hard.reinfor.met.without fit.rup>=17','Tubo de caucho vulc.s/end.ref.met.c/acces.r>=17',10,'40','4009','400922');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40092290','Outs.tubos borracha vulc.n/end.ref.met.c/aces','Ot.tubes of vulc.rub.n/hard.reinfor.met.without fittin.','Otros tubos de caucho vulc.s/end.ref.met.c/acces.',10,'40','4009','400922');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40093000','Tubo de borracha vulcan.n/endur.c/mater.têxtil, s/acess.','Tubes vulc.rubb.n/hard.reinfor.text.mat.without fit.','Tubos de caucho vulc.s/end.c/mater.textil, s/acces.',10,'40','4009','400930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40093100','Tubo borracha vulc.n/end.ref.mat.text.s/acess','Rubber tube vulc.n/hard.reinfor.text.mat.without fitt.','Tubos de caucho vulc.s/end.c/mater.textil, s/acces.',10,'40','4009','400931');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40093210','Tubo borracha vulc.ref.mat.text.c/acess.r>=17','Rubber tube vulc.reinfor.text.mat.with fitt.r>=17','Tubo de caucho vulc.ref.mat.text.c/acces.r>=17',10,'40','4009','400932');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40093290','Outs.tubos borracha vulc.ref.mat.text.c/acess','Oth.rubber tubes vulc.reinfor.text.mat.with fitt.','Otros tubos de caucho vulc.ref.mat.text.c/acces.',10,'40','4009','400932');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40094000','Tubo de borracha vulcan.n/endur.c/outs.matérias, s/acess','Rubber tube vulc.n/hard.with oth.mater.without fittings','Tubo de caucho vulc.s/endur.c/ots.materias, c/acces.',10,'40','4009','400940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40094100','Tubo borracha vulc.n/end.ref.out.mat.s/acess.','Rubber tubes vulc.n/hard.reinfor.oth.mat.without fitt.','Tubo de caucho vulc.s/endur.ref.c/ot.mat, c/acces.',10,'40','4009','400941');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40094210','Tubo borracha vulc.ref.out.mat.c/acess.r>=17','Rubber tube vulc.reinfor.oth.mat.with fitt.r>=17','Tubo de caucho vulc.ref.c/ot.mat, c/acces.r>=17',10,'40','4009','400942');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40094290','Outs.tubos borracha vulc.ref.out.mat.c/acess.','Oth.rubber tubes vulc.reinfor.oth.mater.with fittings','Otros tubo de caucho vulc.ref.c/ot.mat, c/acces.',10,'40','4009','400942');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40095010','Tubo de borracha vulcan.n/endur.c/acess.pressão<17.3mpa','Rubber tube vulc.n/hard.with fitt.pression<17.3mpa','Tubo de caucho vulc., s/endur, c/acces.pressión<17.3mpa',10,'40','4009','400950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40095090','Outs.tubos de borracha vulcan.n/endurecida, c/acessórios','Oth.rubber tubes vulcanized n/hardened, with fittings','Ots.tubos de caucho vulcan.s/endurecer, c/accesorios',10,'40','4009','400950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40101100','Correia transportad.de borracha vulcan.reforcada metal','Conveyor belt of rubber vulcan.reinfor.only with metal','Correa transportad.de caucho vulcan.reforzado c/metal',10,'40','4010','401011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40101200','Correia transportad.de borracha vulcan.reforc.mat.text.','Conveyor belt of rubber vulcan.reinfor.with text.mater.','Correa transportad.de caucho vulcan.reforzados mat.text',10,'40','4010','401012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40101300','Correia transportad.de borracha vulcan.reforc.plásticos','Conveyor belt of rubber vulcan.reinfor.with plastics','Correa transportad.de caucho vulcan.reforzado mat.text',10,'40','4010','401013');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40101900','Outras correias transportadoras, de borracha vulcanizada','Other conveyor belt, of vulcanised rubber','Otras correas transportadoras, de caucho vulcanizado',10,'40','4010','401019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40102100','Correia transm.s/fim, trapez.6dm<c<=18dm, borracha vulcan','Conveyor belt endless trapez.6dm<c<=18dm, vulcan.rub','Correa transm.s/fin, trapez.6dm<c<=18dm, caucho vulcan.',10,'40','4010','401021');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40102200','Correia transm.s/fim, trapez.18<c<=24dm, borracha vulcan.','Conveyor belt endless trapez.18<c<=24dm, vulcan.rub','Correa transm.s/fin, trapez.6dm<c<=18dm, caucho vulcan.',10,'40','4010','401022');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40102300','Correia transm.s/fim, sincron.6<c<=15dm, borracha vulcan.','Conveyor belt endless synch.6<c<=15dm, vulcan.rub','Correa transm.s/fin, c/muescas, 6<c<=15dm, caucho vulcan.',10,'40','4010','401023');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40102400','Correia transm.s/fim, sincr.150<c<=198cm, borracha vulcan','Conveyor belt endless synch.150<c<=198dm, vulc.rub','Correa transport.s/fin, c/muesc.150<c<=198cm, caucho vulc',10,'40','4010','401024');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40102900','Outras correias de transmissão, de borracha vulcanizada','Other conveyor belt, of vulcanised rubber','Otras correas de transm., de caucho vulcanizado',10,'40','4010','401029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40103100','Correia transm.sec.trapez.estriad.60<c<=180cm','Transmission belts trapez.v-ribbed 60<c<=180cm','Correa transm.sec.trapez.estriada 60<c<=180cm',10,'40','4010','401031');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40103200','Correia transm.sec.trapez.n/estr.60<c<=180cm','Transmission belts trapez.n/ribbed 60<c<=180cm','Correa transm.sec.trapez.s/estriar 60<c<=180cm',10,'40','4010','401032');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40103300','Correia transm.sec.trapez.estria.180<c<=240cm','Transmission belt trapez.v-ribbed 180<c<=240cm','Correa transm.sec.trapez.estriada 180<c<=240cm',10,'40','4010','401033');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40103400','Correia transm.sec.trapez.n/estr.180<c<=240cm','Transmission belt trapez.n/ribbed 180<c<=240cm','Correa transm.sec.trapez.s/estriar 180<c<=240cm',10,'40','4010','401034');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40103500','Correia de transmissão, síncrona, 80<c<=150cm','Transmission belt, synchronous, 80<c<=150cm','Correa de transmisión, c/muescas, 80<c<=150cm',10,'40','4010','401035');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40103600','Correia de transmissão, síncrona, 150<c<=198cm','Transmission belt, synchronous, 150<c<=198cm','Correa de transmisión, c/muescas, 150<c<=198cm',10,'40','4010','401036');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40103900','Outras correias de transmissão','Other transmission belts','Otras correas de transmisión',10,'40','4010','401039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40109900','NCM não existe','No NCM','No hay NCM',10,'40','4010','401099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40111000','Pneus novos para automóveis de passageiros','New tires for automobiles of passengers','Neumáticos nuevos para automóviles de turismo',11,'40','4011','401110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40112010','Pneus novos para onibus ou caminhões, medida=11, 00-24','New tires for bus or trucks, meassured=11, 00-24','Neumáticos nuevos p/autobuses o camiones, med.=11, 00-24',11,'40','4011','401120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40112090','Outros pneus novos para ônibus ou caminhões','Other new tires for bus or trucks','Otros neumáticos nuevos para autobuses o camiones',11,'40','4011','401120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40113000','Pneus novos para aviões','New tires for airplanes','Neumáticos nuevos para aeronaves',11,'40','4011','401130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40114000','Pneus novos para motocicletas','New tires for motocycles','Neumáticos nuevos para motocicletas',11,'40','4011','401140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40115000','Pneus novos para bicicletas','New tires for bycicles','Neumáticos nuevos para bicicletas',11,'40','4011','401150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40116100','Pneus novos, p/veics, maqs.agrícolas/florestais','New tires, for vehicles, agricultural/forest machines','Neumáticos nuevos p/vehículos, máquinas agrícolas/forest',11,'40','4011','401161');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40116200','Pneus novos, p/veics, maqs.constr/ind.aro<=61cm','New tires, for vehicles, construc./indust.ring<=61 cm','Neumáticos nuevos, p/vehículos, máqs.construc/ind, a<=61cm',11,'40','4011','401162');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40116310','Pneus radiais, novos, p/"dumpers", aro>=1448mm','Radial tires, new, for"dumpers", ring>=1448mm','Neumáticos radiales, nuevos, p/"dumpers", aro>=1448mm',11,'40','4011','401163');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40116320','Outros pneus novos, p/veics.constr.aro>=1143mm','Other new tires, forcontruction vehicles ring>=1143mm','Ots.neumáticos nuevos, p/vehícs.construc.aro>=1143mm',11,'40','4011','401163');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40116390','Outros pneus novos, p/veic.constr.aro>61cm, espin','Other new tires, forcontruction vehicles ring>61cm, spine','Ots.neumáticos nuevos, p/vehícs.construc.aro>61cm, espin',11,'40','4011','401163');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40116910','Outros pneus novos, band.espin.peixe, aro>=1143mm','Other new tires, band fish spine, ring>=1143mm','Ots.neumáticos nuevos, band.espin.pescado, aro>=1143mm',11,'40','4011','401169');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40116990','Outros pneus novos, de borracha, band.espin.peixe','Other new tires, of rubber, band fish spine','Otros neumáticos nuevos, de caucho, band.espin.pescado',11,'40','4011','401169');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119110','Pneumat.novos, de borracha, banda espinha, p/maqs.terrapl.','New tires, of rubber, "herring-bone" for bulldozer','Neumát.nuevos, de caucho, banda espina, p/máqs.terrapl.',11,'40','4011','401191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119111','Pneus novos, banda espinha peixe, sec.e diam.aro>=1143mm','New tires, of rubber, band spine forsec.diam.ring>=1143mm','Neumát.nuevos, banda espina pesc., sec.y diám.aro>=1143mm',11,'40','4011','401191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119119','Outros pneus novos, banda de rodagem forma espinha peixe','Other new tires, of rubber, band of wheelwork forms fish sp','Ots. neumát.nuevos, banda de rodaje forma espina pescado',11,'40','4011','401191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119120','Pneus radiais novos, banda espinha peixe, p/"dumpers", etc','New radial tires, band fish spine, for"dumpers", etc.','Neumáts.radiales nuevos, band.espin.pesc, p/"dumpers", etc',11,'40','4011','401191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119190','Outros pneus novos, banda de rodagem forma espinha peixe','Other new tires, band of wheelwork forms fish spine','Ots. neumát.nuevos, banda de rodaje forma espina pescado',11,'40','4011','401191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119210','Outros pneus novos, p/veic.agríc.med:4, 00-15, etc','Other new tires, for agric.vehicles mes.:4, 00-15, etc','Ots. neumát.nuevos, p/vehíc.agríc.med:4, 00-15, etc',11,'40','4011','401192');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119290','Outros pneus novos, p/veics.maqs.agríc.florest.','Other new tires,  for forest/agricultural vehicles','Ots. neumát.nuevos, p/vehíc.máqs.agríc.forestales',11,'40','4011','401192');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119300','Outros pneus novos, p/veics.constr.aro<=61cm','Other new tires, for construction vehicles ring<=61cm','Ots. neumát.nuevos, p/vehícs.construc.aro<=61cm',11,'40','4011','401193');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119410','Outros pneus radiais, novos, "dumpers", aro>=1448','Other radial tires, news, "dumpers", ring>=1448','Ots. neumát.radiales, nuevos, "dumpers", aro>=1448',11,'40','4011','401194');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119420','Outros pneus novos, p/veics.constr.aro>=1143mm','Other new tires, for construction vehicles ring<=1143mm','Ots. neumát.nuevos, p/vehícs.construc.aro>=1143mm',11,'40','4011','401194');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119490','Outros pneus novos, p/veics.constr.aro>=61cm','Other new tires, for construction vehicles ring<=61cm','Ots. neumát.nuevos, p/vehícs.construc.aro>=61cm',11,'40','4011','401194');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119910','Pneus novos, p/tratores/implement.agricolas, divs.medidas','New tires, for tractors/agricultural implem.divid.measures','Neumát.nuevos, p/tractores/implem.agrícolas, divs.medidas',11,'40','4011','401199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119921','Pneus novos, p/maqs.terraplanagem, sec.e diam.aro>=1143mm','New tires for bulldozer sec.diam.ring>=1143mm','Neumát.nuevos, p/máqs.de explanar, sec.y diám.aro>=1143mm',11,'40','4011','401199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119929','Outros pneus novos, para máquinas de terraplanagem, etc.','Other new tires for bulldozer, etc.','Otros neumáticos nuevos, para máquinas de explanar, etc',11,'40','4011','401199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119930','Pneus radiais novos para "dumpers", etc.','New radial tires for "dumpers", etc.','Neumáticos radiales nuevos para "dumpers", etc.',11,'40','4011','401199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40119990','Outros pneus novos de borracha','Other new rubber tires','Otros neumáticos nuevos de caucho',11,'40','4011','401199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40121000','Pneus recauchutados de borracha','Retreaded pneumatic rubber tires','Neumáticos recauchutados de caucho',11,'40','4012','401210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40121100','Pneus recauchutados, de automóveis de passageiros','Retreaded tires, for passenger automobiles','Neumáticos recauchutados, de automóviles de turismo',11,'40','4012','401211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40121200','Pneus recauchutados, de onibus e caminhões','Retreaded tires, of bus and truks','Neumáticos recauchutados, de autobuses y camiones',11,'40','4012','401212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40121300','Pneus recauchutados, de veículos aereos','Retreaded tires, of aerial vehicles','Neumáticos recauchutados, de aeronaves',11,'40','4012','401213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40121900','Outros pneus recauchutados','Other retreaded tires','Otros neumáticos recauchutados',11,'40','4012','401219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40122000','Pneus usados de borracha','Used rubber tires','Neumáticos usados de caucho',11,'40','4012','401220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40129010','Flaps para pneus de borracha','Flaps for rubber tires','Protectores para neumáticos de caucho',10,'40','4012','401290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40129090','Protetores, bandas rodagem, etc.para pneus de borracha','Protecting, bands wheelwork, etc.fortires of rubber','Protectores, bandas rodadura, etc.p/neumáticos de caucho',10,'40','4012','401290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40131010','Câmaras-de-ar borracha, p/pneus de onibus, etc.m=11, 00-24','Inner tubes of rubber, fortires of bus, etc.m=11, 00-24','Cámaras de caucho, p/neumáts.de autobuses, etc.m=11, 00-24',11,'40','4013','401310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40131090','Outras câmaras-de-ar borracha, p/pneus de automóveis, etc','Inner tubes rubber, fortires of automobiles, etc','Otras cámaras de caucho, p/neumáticos de automóviles, etc',11,'40','4013','401310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40132000','Câmaras-de-ar de borracha, para pneus de bicicletas','Inner tubes rubber, fortires of biclycles','Cámaras de caucho, p/neumáticos de bicicletas',11,'40','4013','401320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40139000','Outras câmaras-de-ar de borracha','Other inner tubes, of rubber','Otras cámaras de caucho',11,'40','4013','401390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40141000','Preservativos de borracha vulcanizada, não endurecida','Contraceptives, of vulcanised rubber, no hardened','Preservativos de caucho vulcanizado, sin endurecer',10,'40','4014','401410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40149010','Bolsas p/gelo/agua quente, de borracha vulcan.n/endurec.','Ice-bags and hot-water, of vulcanised rubber, no hardened','Bolsas p/hielo/agua caliente, de caucho vulcan.s/endur.',10,'40','4014','401490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40149090','Outs.artigos de higiene, etc.de borracha vulcan.n/endur.','Ot.hygienic articles, etc.of vulcan.rubber, n/hardened','Ots.artículos de higiene, etc.de caucho vulcan.s/endur.',10,'40','4014','401490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40151100','Luvas p/cirurgia, de borracha vulcanizada, n/endurecida','Gloves forsurgery, of vulcanised rubber, n/hardened','Guantes p/cirugía, de caucho vulcanizado, s/endurecer','13','40','4015','401511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40151900','Outras luvas de borracha vulcanizada, não endurecida','Other gloves, of vulcanised rubber, n/hardened','Otras guantes, de caucho vulcanizado, s/endurecer','13','40','4015','401519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40159000','Outs.vestuários e acessórios, de borracha vulcan.n/endur','Ot.apparel and accessories, of vulcan.rubber, n/hardened','Ots.prendas de vest., acces., de caucho vulc., s/endurecer',10,'40','4015','401590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40161010','Partes de automovs.etc.borracha vulcan.alveol.n/endur.','Parts of automobiles, etc.vulcan.rubber alveol.n/harden.','Partes de automóviles, etc.caucho vulcan.celul.s/endur.',10,'40','4016','401610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40161090','Outras obras de borracha vulcanizada alveolar n/endurec','Oth.works of vulcan.rubber alveol.n/harden.','Otras manufacturas de caucho vulcanizado celul.s/endur.',10,'40','4016','401610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40169100','Revestim.p/pavimentos, etc.de borracha vulcan.n/endurec.','Covering forpavements, etc.of vulcanised rubber n/harden.','Revestim.p/el suelo, etc, de caucho vulcan.celul.s/endur.',10,'40','4016','401691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40169200','Borrachas de apagar','Erasers','Gomas de borrar',10,'40','4016','401692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40169300','Juntas, gaxetas, semelhs.de borracha vulcan.n/endurecida','Gaskets, washers, similars, of vulcan.rubber, n/harden.','Juntas, empaquetaduras, simil.de caucho vulc.s/endurecer',10,'40','4016','401693');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40169400','Defensas p/atracar embarcações, borracha vulcan.n/endur.','Fenders to moor embarkations, of vulcan.rubber, n/harden.','Defensas p/atraque de los barcos, caucho vulcan.s/endur.',10,'40','4016','401694');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40169510','Artigos inflav.de salvamento, de borracha vulcan.n/endur','Inflatable articles of rescue, of vulcan.rubber, n/hard.','Artículos inflab.de salvamento, de caucho vulcan.s/endur',10,'40','4016','401695');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40169590','Outs.artigos infláveis, de borracha vulcan.n/endurecida','Ot.inflatable articles, of vulcanised rubber, n/harden.','Ots.artículos inflables, de caucho vulcan.s/endurecer',10,'40','4016','401695');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40169910','Tampões vedadores p/capacitor, de epdm, c/perf.p/terminal','Stoppers of epdm forcapacitors, perforated formount.term.','Obturadores p/capacitores, de epdm, c/perf.p/terminal',10,'40','4016','401699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40169990','Outras obras de borracha vulcanizada, não endurecida','Oth.articles of vulcanised rubber oth.than hard rubber','Otras manufacturas de caucho vulcanizado, sin endurecer',10,'40','4016','401699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('40170000','Borracha endurecida e obras de borracha endurecida','Hard rubber and other articles of hard rubber','Caucho endurecido y manufacturas de caucho endurecido',10,'40','4017','401700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41011000','Peles em bruto, de bovino, inteiras, qdo.secas<=8kg, etc.','Raw skins of bovine, whole, when dried<=8kg, etc.','Pieles en bruto, de bovino, enteras, cdo.secas<=8kg, etc.',10,'41','4101','410110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41012000','Coruos/peles bru.,int. n/divid.c/ restricao de pes.max.','Raw hides and skins, whole, with weight restriction','Cueros y pieles,enteros,con restricción de peso máximo',10,'41','4101','410120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41012010','Couros/peles, bovinos, inteiros, s/divid.p<=8kg','Whole leathers/skin of bovine, n/divided w<=8kg','Cueros/pieles, bovinos, enteros, s/divid.p<=8kg',10,'41','4101','410120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41012020','Couros/peles, bovinos, int.div.c/a flor, p<=8kg','Divid./whol.leathers/skin, bovine, grain splits, w<=8kg','Cueros/pieles, bovinos, enteros, divid.c/la flor, p<=8kg',10,'41','4101','410120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41012030','Couros/peles, bovinos, int.div.s/a flor, p<=8kg','Divid./whol.leat./skin, bovine, splits(than grain)w<=8kg','Cueros/pieles, bovinos, enteros, divid.s/la flor, p<=8kg',10,'41','4101','410120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41012110','Pele em bruto, de bovino, inteira, n/dividida, fresca, etc.','Raw skins of bovine, whole, n/divided, fresh, etc.','Piel en bruto, bovino, entera, s/dividir, fresca, etc.',10,'41','4101','410121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41012120','Pele em bruto, de bovino, inteira, divid.c/flor, fresca, etc','Raw skins of bovine, whole, grain splits, fresh, etc','Piel en bruto, de bovino, entera, divid.c/flor, fresca, etc.',10,'41','4101','410121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41012130','Pele em bruto, de bovino, inteira, divid.s/flor, fresca, etc','Raw skins of bov.whole, splits(than grain spl.)fresh, etc','Piel en bruto, de bovino, entera, divid.s/flor, fresca, etc.',10,'41','4101','410121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41012210','Pele em bruto, de bovino, (dorsos), n/dividida, fresca, etc.','Raw skins of bovine, (backs), not slipt, fresh, etc','Piel en bruto, de bovino, (dorsos), s/dividir, fresca, etc.',10,'41','4101','410122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41012220','Pele em bruto, de bovino (dorso), divid.c/flor, fresca, etc','Raw skins of bovine, (backs), grain splits, fresh, etc','Piel en bruto, de bovino, (dorso), divid.c/flor, fresca, etc',10,'41','4101','410122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41012230','Pele em bruto, de bovino (dorso), divid.s/flor, fresca, etc','Raw skins of bovine, (backs), slipts(than grain)fresh, etc','Piel en bruto, de bovino, (dorso), divid.s/flor, fresca, etc',10,'41','4101','410122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41012910','Outs.peles em bruto, de bovino, nao divididas, frescas, etc','Oth.raw skins of bov.(backs), n/slipt, fresh, etc','Otras pieles en bruto, de bovino, s/dividir, frescas, etc',10,'41','4101','410129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41012920','Outs.peles em bruto, de bovino, divid.c/flor, frescas, etc.','Oth.raw skins of bovine, (backs), grain splits, fresh, etc','Ots.pieles en bruto, de bovino, divid.c/flor, frescas, etc',10,'41','4101','410129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41012930','Outs.peles em bruto, de bovino, divid.s/flor, frescas, etc.','Ot.raw skins of bovine, slipts(than grain spl.)fresh, etc','Ots.pieles en bruto, de bovino, divid.s/flor, frescas, etc',10,'41','4101','410129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41013010','Pele em bruto, de bovino, conserv.de out.modo, n/dividida','Raw skins of bovine, conser.of another way, not slipt','Piel en bruto, de bovino, conserv.de ot.modo, s/dividir',10,'41','4101','410130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41013020','Pele em bruto, de bovino, conserv.out.modo, divid.c/a flor','Raw skins, of bovine, conser.of another way, grain splits','Piel en bruto, de bovino, conserv.de ot.modo, divid.c/flor',10,'41','4101','410130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41013030','Pele em bruto, de bovino, conserv.out.modo, divid.s/a flor','Raw skins of bovine, cons.another way slipts(than grain)','Piel en bruto, de bovino, conserv.de ot.modo, divid.s/flor',10,'41','4101','410130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41014010','Peles em bruto, de equideos, nao divididas','Raw skins, equine, not split','Pieles en bruto, de equinos, sin dividir',10,'41','4101','410140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41014020','Peles em bruto, de equideos, divididas com a flor','Raw skins, equine, grain splits','Pieles en bruto, de equinos, divididas con la flor',10,'41','4101','410140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41014030','Peles em bfuto, de equideos, divididas sem a flor','Raw skins, equine, splits (other than grain splits)','Pieles en bruto, de equinos, divididas sin la flor',10,'41','4101','410140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41015010','Couros/peles, bovinos, inteiros, s/divid.p>=16kg','Whole leathers/skin of bovine, not split, w<=16kg','Cueros/pieles, bovinos, enteros, s/divid.p>=16kg',10,'41','4101','410150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41015020','Couros/peles, bovinos, int.div.c/a flor, p>=16kg','Whole leathers/skin, bovine, grain splits, w<=16kg','Cueros/pieles, bovinos, enteros, divid.c/la flor, p>=16kg',10,'41','4101','410150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41015030','Couros/peles, bovinos, int.div.s/a flor, p>=16kg','Whole leath./skin, bov.slipts(ot.than grain sp.), w<=16kg','Cueros/pieles, bovinos, enteros, divid.s/la flor, p>=16kg',10,'41','4101','410150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41019010','Outros couros e peles, de bovinos, sem dividir','Other leathers/skin, bovine, not split','Ots.cueros/pieles, de bovinos, sin dividir',10,'41','4101','410190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41019020','Outs.couros/peles, de bovinos, divid.c/a flor','Other leathers/skin, of bovine, grain splits','Ots.cueros/pieles, de bovinos, divid.c/la flor',10,'41','4101','410190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41019030','Outs.couros/peles, de bovinos, divid.s/a flor','Other leathers/skin, of bovine, splits(than grain splits)','Ots.cueros/pieles, de bovinos, divid.s/la flor',10,'41','4101','410190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41021000','Peles em bruto, de ovinos, com lã','Skin in brute, sheep, with wool','Pieles en bruto, de ovinos, con lana',10,'41','4102','410210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41022100','Peles em bruto, de ovinos, "picladas"','Skin in brute, sheep, "pickled"','Pieles en bruto, de ovinos, piqueladas',10,'41','4102','410221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41022900','Outras peles em bruto, de ovinos, depiladas ou sem lã','Other skin in brute, sheep, waxed or without wool','Ots.pieles en bruto, de ovinos, depiladas o sin lana',10,'41','4102','410229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41031000','Peles em bruto, de caprinos','Skin in brute, of goats','Pieles en bruto, de caprino',10,'41','4103','410310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41032000','Peles em bruto, de répteis','Skin in brute, of reptiles','Pieles en bruto, de reptil',11,'41','4103','410320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41033000','Couros e peles, de suínos, em bruto','Leathers/skin, of swine, in brute','Cueros y pieles, de porcino, en bruto',10,'41','4103','410330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41039000','Peles em bruto, de outros animais','Skin in brute, of other animals','Pieles en bruto, de otros animales',10,'41','4103','410390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041011','Couro/pele inteira, de bovino, s<=2.6m2, "wet blue", n/div.','Leathers/skin whole, bovine, s<=2.6m2, "wet blue", n/spl','Cuero/piel entera, de bovino, s<=2.6m2, "wet blue", s/div.',15,'41','4104','410410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041012','Couro/pele inteir.bovina, s<=2.6m2, "wet blue", div.c/flor','Leathers/skin whole, bovine, s<=2.6m2, "wet blue", grain sl','Cuero/piel entera, bovina, s<=2.6m2, "wet blue", div.c/flor',15,'41','4104','410410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041013','Couro/pele inteir.bovina, s<=2.6m2, "wet blue", div.s/flor','Leathers/skin whole, bov.s<=2.6m2, "wet blue", splits(than','Cuero/piel entera, bovina, s<=2.6m2, "wet blue", div.s/flor',15,'41','4104','410410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041020','Couro/pele inteira, de bovino, s<=2.6m2, "box-calf"','Leathers/skin whole, bovine, s<=2.6m2, "box-calf"','Cuero/piel entera, bovina, s<=2.6m2, "box-calf"',15,'41','4104','410410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041090','Outs.couros/peles inteiras, bovinas, s<=2.6m2, preparados','Oth.leathers/skins whole, bovine, s<=2.6m2, prepared','Ots.cueros/pieles enteras, bovinas, s<=2.6m2, preparados',15,'41','4104','410410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041111','Couros int.bovinos, n/div."wet blue", s<=2, 6m2','Whole leathers of bovines, n/split "wet blue", s<=2.6m2','Cueros enteros, bovinos, s/div."wet blue", s<=2.6m2',15,'41','4104','410411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041112','Couros int.bovinos, n/div.um.pena flor<=2, 6m2','Whole leath.of bovines, slipts(than grain split)<=2.6m2','Cueros enteros, bovinos, plena flor s/div., <=2.6m2',15,'41','4104','410411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041113','Outs.couros bovinos, n/div.umid.pre-curt.veg.','Oth.leathers of bovines, n/slipt wet pre-tanned, veg.','Ots.cueros bovinos, s/divid., húmedo, c/precurtido vegetal',15,'41','4104','410411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041114','Outs.couros bovinos, incl.bufalos, n/div.umid.pena flor','Oth.leathers bovines, incl.buffalos, wet split(than grain','Ots.cueros bovinos, incl.búfalo, s/divid., húm., plena flor',15,'41','4104','410411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041119','Couros equideos, n/div.umid.pena flor','Equine leathers, wet state, split(than grain split)','Cueros equinos, plena flor sin dividir, húmedo',15,'41','4104','410411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041121','Couros int.bovinos, divid."wet blue", s<=2, 6m2','Whole leathers of bovine, split"wet blue", s<=2, 6m2','Cueros ent.bovinos, divid."wet blue", s<=2, 6m2',15,'41','4104','410411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041122','Couros int.bovinos, div.um.pena flor, s<=2, 6m2','Whole leathers of bovines, grain splits s<=2, 6m2','Cueros ent.bovinos, divid.con la flor, s<=2, 6m2',15,'41','4104','410411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041123','Outs.couros bovinos, div.umid.pre-curt.veg','Oth.tanned bovine, split, wet, veget pre-tanned','Ots.cueros bovinos, divid.húmedo, c/precurtido vegetal',15,'41','4104','410411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041124','Outs.couros bovinos, incl.bufalos, divid.umid.pena flor','Other leathers bovines, incl.buffalos, wet, grain splits','Ots.cueros bovinos, incl.búfalo, divid.c/la flor, húmedo',15,'41','4104','410411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041129','Couros equideos, divid.umid.pena flor','Other equine leathers, wet, grain splits','Cueros equinos, divid.c/la flor, húmedo',15,'41','4104','410411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041910','Outs.couros int.bovinos, "wet blue", s<=2, 6m2','Other whole leathers of bovines, "wet blue", s<=2, 6m2','Ots.cueros enteros bovinos, "wet blue", s<=2, 6m2',15,'41','4104','410419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041920','Outs.couros/peles, int.bovinos, umid.s<=2, 6m2','Oth.leathers/skins, whole, bovines, wet state s<=2, 6m2','Ots.cueros/pieles enteros bovinos, húmedo, s<=2, 6m2',15,'41','4104','410419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041930','Outs.couros/peles, bovinos, umid.pre-curt.veg.','Oth.leathers/skins, bovines, wet state veg.pre-tanned','Ots.cueros/pieles, bovinos, húmedo, c/precurtido vegetal',15,'41','4104','410419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041940','Outs.couros/peles, bovinos, incl.bufalos, umidos','Other leathers/skins, bovines, including buffalos, wet','Ots.cueros/pieles, bovinos, incl.búfalos, húmedos',15,'41','4104','410419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41041990','Couros/peles, equideos, umidos','Leathers/skins, equine, wet','Cueros/pieles, equinos, húmedos',15,'41','4104','410419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41042100','Couros e peles, de bovinos, com pre-curtimenta vegetal','Leathers/skins, bovines, vegetable pre-tanned','Cueros y pieles, de bovinos, con precurtido vegetal',15,'41','4104','410421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41042211','Couro/pele, inteiro/meio, de bovino, "wet blue", n/dividido','Leathers/skins, whole/half, bovines, wet blue, n/split','Cuero/piel, entero/medio, de bovino, "wet blue", s/dividir',15,'41','4104','410422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41042212','Couro/pele, inteiro/meio, de bovino, "wet blue", div.c/flor','Leathers/skins, whole/half, bovines, wet blue, grain split','Cuero/piel, entero/medio, de bovino, "wet blue", div.c/flor',15,'41','4104','410422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41042213','Couro/pele, inteiro/meio, de bovino, "wet blue", div.s/flor','Leathers/skins, whole/half, bovines, wet blue, split(than g','Cuero/piel, entero/medio, de bovino, "wet blue", div.s/flor',15,'41','4104','410422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41042219','Outros couros e peles, de bovinos, "wet blue"','Other leathers/skins, bovines, "wet blue"','Otros cueros y pieles, de bovinos, "wet blue"',15,'41','4104','410422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41042290','Outs.couros e peles, de bovinos, pre-curtidos de out.modo','Oth.leathers, bovines, pre-tanned of other way','Ots.cueros y pieles, de bovinos, precurtidos de ot.modo',15,'41','4104','410422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41042900','Outs.couros e peles, de bovinos/equideos, curtidos, recurt','Oth.leathers/skins, of bovines/equine, tanned or retanned','Ots.cueros y pieles, de bovinos/equinos, curtidos, recurt.',15,'41','4104','410429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41043111','Couro/pele bovina, curt.ao veg.p/solas, plena flor, s/acab','Leat./skins, bovin.veg.pre-tann.forsoles, grain split n/fi','Cuero/piel bovina, curt.al veg.p/suelas, pl.flor, s/acab.',15,'41','4104','410431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41043119','Outs.couros/peles bovinas, prepar.curt.plena flor, s/acab','Ot.leat./skins, bov.pre-tan.prepar.grain split n/finis.','Ots.cueros/pieles bovina, prepar.curt.plena flor, s/acab.',15,'41','4104','410431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41043120','Couro/pele bovina, prepar.apos curtim.plena flor, c/acab.','Leat./skins, bov.after tann.prepar.grain split n/finis.','Cuero/piel bovina, prepar.después curt.pl.flor, c/acab.',15,'41','4104','410431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41043190','Outs.couros/peles, de bovino/equideo, prepars.plena flor','Ot.leat./skins, bov./equine pre-tan.prepar.grain split','Ots.cueros/pieles de bovino/equino, prepars.plena flor',15,'41','4104','410431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41043911','Outs.couros/peles, de bovino, prepar.apos curtim.s/acabam','Ot.leat./skins, bovine, after-tann.prepar.n/finishing','Ots.cueros/pieles de bovino, preps.después curt.s/acab.',15,'41','4104','410439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41043912','Outs.couros/peles, de bovino, prepar.apos curtim.c/acabam','Ot.leat./skins, bovine, after-tann.prepar.with finishing','Ots.cueros/pieles de bovino, preps.después curt.c/acab.',15,'41','4104','410439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41043990','Outs.couros/peles, de bovino/equideo, apergamins.prepars.','Oth.leath./skins, bovine/equine, parchment-dressed','Ots.cueros/pieles de bovino/equino, apergamins.prepars.',15,'41','4104','410439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41044110','Couros int.bovinos, secos, pena flor, s<=2, 6m2','Whole leath.of bovines, dry state, grain splits s<=2, 6m2','Cueros ent.bovinos, secos, plena flor, s<=2, 6m2',15,'41','4104','410441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41044120','Couros bovinos, secos, pena fl.curt.veg.p/solas','Leat.of bovines, dry state, grain sp.tanned, foruse as sole','Cueros bovinos, secos, plena fl.curt.veg.p/suelas',15,'41','4104','410441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41044130','Outros couros/peles bovinos, secos, pena flor','Other leathers/skins of bovines, dry state, grain slipts','Ots.cueros/pieles bovinos, secos, plena flor',15,'41','4104','410441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41044190','Couros/peles equídeos, secos, pena flor','Leathers/skins equine, dry state, grain splits','Ots.cueros/pieles equinos, secos, plena flor',15,'41','4104','410441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41044910','Outs.couros/peles int.bovinos, secos, s<=2, 6m2','Other leathers/skins, of bovines, dry state, s<=2, 6m2','Ots.cueros/pieles ent.bovinos, secos, s<=2, 6m2',15,'41','4104','410449');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41044920','Outros couros/peles bovinos, secos','Other leathers/skins of bovines, dry state','Ots.cueros/pieles bovinos, secos',15,'41','4104','410449');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41044990','Couros/peles equídeos, secos','Other leathers/skins equine, dry state','Cueros/pieles equinos, secos',15,'41','4104','410449');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41051010','Peles depilad.de ovinos, umid.c/pre-curt.veget','Waxed skins of sheep, wet, vegetable pre-tanned','Pieles depilad.de ovinos, húmid.c/precurt.vegetal',15,'41','4105','410510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41051021','Peles depilad.de ovinos, curt.cromo "wet blue"','Waxed skins of sheep tanned chromo"wet blue"','Pieles depilad.de ovinos, curt.cromo "wet blue"',15,'41','4105','410510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41051029','Outs.peles depiladas, de ovinos, pre-curtidas','Other waxed skins of sheep, pre-tanned','Ots.pieles depiladas, de ovinos, precurtidas',15,'41','4105','410510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41051090','Outs.peles depiladas, de ovinos, curtidas','Other waxed skins of sheep, tanned','Ots.pieles depiladas, de ovinos, curtidas',15,'41','4105','410510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41051100','Peles depiladas, de ovinos, com pre-curtimenta vegetal','Dehaired skins, of sheep, with vegetable pre-tanned','Pieles depiladas, de ovinos, con precurtido vegetal',15,'41','4105','410511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41051210','Peles depiladas, de ovinos, curtid.cromo, umido, "wet blue"','Dehaired skins, of sheep, chromo tanned, wet blue','Pieles depils., de ovinos, curtid.cromo, húmedo, "wet blue"',15,'41','4105','410512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41051290','Peles depiladas, de ovinos, pre-curtidas de outro modo','Dehaired skins, of sheep, pre-tanned of other way','Pieles depiladas, de ovinos, precurtidas de otro modo',15,'41','4105','410512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41051900','Outras peles depiladas, de ovinos, curtidas ou recurtidas','Other dehaired skins, of sheep, tanned or retanned','Otras pieles depiladas, de ovinos, curtidas o recurtidas',15,'41','4105','410519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41052010','Peles depiladas, de ovinos, curtid.ao cromo, seco, "crust"','Dehaired skins, of sheep, chromo tanned, dry state, crust','Pieles depiladas, de ovinos, curtid.al cromo, seco, "crust"',15,'41','4105','410520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41052090','Peles depiladas, de ovinos, apergamins.prepar.apos curtim','Dehaired skins, of sheep, after-tanned parchment-dressed','Pieles depils., de ovinos, apergamins.prepar.después curt',15,'41','4105','410520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41053000','Peles depiladas de ovinos, secas, "crust"','Dehaired skins of sheep, dry state, crust','Pieles depiladas de ovinos, secas, "crust"',15,'41','4105','410530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41061100','Peles depiladas, de caprinos, com pre-curtimenta vegetal','Dehaired skins, of goats, with vegetable pre-tanned','Pieles depiladas, de caprinos, con precurtido vegetal',15,'41','4106','410611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41061210','Peles depiladas, de caprinos, curt.cromo, umido, "wet blue"','Dehaired skins, of goats, chromo tanned, wet, wet blue','Pieles depils., de caprinos, curt.cromo, húmedo, "wet blue"',15,'41','4106','410612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41061290','Peles depiladas, de caprinos, pre-curtidas de outro modo','Dehaired skins, of goats, pre-tanned of other way','Pieles depiladas, de caprinos, precurtidas de otro modo',15,'41','4106','410612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41061900','Outs.peles depiladas, de caprinos, curtidas ou recurtidas','Other dehaired skins, of goats, tanned or retanned','Otras pieles depiladas, de caprinos, curtidas o recurtidas',15,'41','4106','410619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41062010','Peles depiladas, de caprinos, curtidas ao cromo, c/acabam.','Dehaired skins, of goats, chromo tanned, finishing','Pieles depiladas, de caprinos, curtidas al cromo, c/acab.',15,'41','4106','410620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41062090','Outs.peles depiladas, de caprinos, apergam.prepar.curtim.','Oth.dehaired skins, of goats, +++++tanned prepar.','Otras pieles depiladas, de caprinos, apergam.prepar.curtido',15,'41','4106','410620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41062110','Couros/peles caprinos c/pre-curtim.vegetal','Leathers/skins goats vegetable pre-tanned','Cueros/pieles caprinos c/precurtido vegetal',15,'41','4106','410621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41062121','Couros/peles caprinos, umid."wet blue"','Leathers/skins goats in the wet state "wet blue"','Cueros/pieles caprinos, húmedo, "wet blue"',15,'41','4106','410621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41062129','Outs.couros/peles caprinos, umid.pre curtidos','Other leathers/skins goats in the wet state pre-tanned','Ots.cueros/pieles caprinos, húmedo, precurtidos',15,'41','4106','410621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41062190','Outs.couros/peles caprinos, curtidos','Other leathers/skins goats, tanned','Ots.cueros/pieles caprinos, curtidos',15,'41','4106','410621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41062200','Couros/peles caprinos, no estado seco "crust"','Leathers/skins goats, in the dry state "crust"','Cueros/pieles caprinos, en estado seco "crust"',15,'41','4106','410622');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41063110','Couros/peles de suínos curtid.umid."wet blue"','Leathers/skins of swine, tanned, wet state"wet blue"','Cueros/pieles de porcino, curtid.húmedo, "wet blue"',15,'41','4106','410631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41063190','Outs.couros/peles, de suínos, curtid.umid.','Other leathers/skins, of swine, tanned, wet state','Ots.cueros/pieles de porcino, curtidos, húmedo',15,'41','4106','410631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41063200','Couros/peles de suínos, curtid.seco ("crust")','Leathers/skins, of swine, tanned, dry state(crust)','Cueros/pieles, de porcino, curtidos, en est.seco("crust")',15,'41','4106','410632');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41064000','Couros/peles de repteis, curtidos ou "crust"','Leathers/skins, of reptiles, tanned or "crust"','Cueros/pieles, de porcino, curtidos/en est.seco("crust")',15,'41','4106','410640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41069100','Couros/peles de outs.animais, curt.umido','Leathers/skins, of other animals, tanned in the wet state','Cueros/pieles, de ots.animales, curtidos, húmedos',15,'41','4106','410691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41069200','Couros/peles de outs.animais, est.seco "crust"','Leathers/skins, of other animals, dry state "crust"','Cueros/pieles, de ots.animales, en est.seco "crust"',15,'41','4106','410692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41071010','Peles depiladas, de suínos, curtid.cromo, umido, "wet blue"','Split skins, swine, chrome-tanned, wet blue','Pieles depils., de porcino, curt.cromo, húmedo, "wet blue"',15,'41','4107','410710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41071090','Outras peles depiladas, de suínos, preparadas','Other split skins, of swine, prepared','Otrs.pieles depiladas, de porcino, preparadas',15,'41','4107','410710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41071110','Couros int.bovinos, pena flor, prepars.s<=2, 6m2','Whole leathers of bovines, full grains, prepared s<=2, 6m2','Cueros ent.bovinos, plena flor, prepars.s<=2, 6m2',15,'41','4107','410711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41071120','Outs.couros/peles, int.bovinos, pena fl.prepars','Oth.whole leathers/skins of bovines, full grain.prepar.','Ots.cueros/pieles ent.bovinos, plena flor, prepars.',15,'41','4107','410711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41071190','Couros/peles, int.equideos, pena flor, prepars.','Leathers/skins, equine, whole, full grains, prepared','Cueros/pieles, ent.equinos, plena flor, prepars.',15,'41','4107','410711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41071210','Couros/peles, int.bovinos, prepars.s<=2, 6m2','Whole leathers/skins of bovines, prepared s<=2, 6m2','Cueros/pieles, ent.bovinos, prepars.s<=2, 6m2',15,'41','4107','410712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41071220','Outs.couros/peles, int.bovinos, prepars.etc.','Oth.whole leathers/skins of bovines, prepared, etc.','Ots.cueros/pieles, ent.bovinos, prepars.etc',15,'41','4107','410712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41071290','Couros/peles, inteiros.equideos, preparados','Oth.whole leathers/skins, equine, prepared','Cueros/pieles, enteros, equinos, preparados',15,'41','4107','410712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41071910','Couros/peles int.bovinos, prepars.s<=2, 6m2','Whole leathers/skins of bovines, prepared s<=2, 6m2','Cueros/pieles, enteros, bovinos, preparados, s<=2, 6m2',15,'41','4107','410719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41071920','Outs.couros/peles int.bovinos, preparados','Oth.whole leathers/skins of bovines, prepared','Ots.cueros/pieles ent.bovinos, preparados',15,'41','4107','410719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41071990','Couros/peles int.equideos, prepars.após curtim.','Leathers/skins, equine, whole, prepared after tanned','Cueros/pieles ent.equinos, prepars.depués del curtido',15,'41','4107','410719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41072100','Peles de repteis, com pre-curtimenta vegetal','Reptiles skins, with vegetal pre-tanning','Pieles de reptil, con precurtido vegetal',15,'41','4107','410721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41072900','Outras peles de repteis, preparadas','Other reptiles skins, prepared','Otras pieles de reptil, preparadas',15,'41','4107','410729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41079000','Peles depiladas, de outros animais, preparadas','Waxed skin, of other animals, prepared','Pieles depiladas, de otros animales, preparadas',15,'41','4107','410790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41079110','Couros/peles, bovinos, prepars.pena flor, n/div.','Whole skins of bovines, prepar.full grains, unsplit','Cueros/pieles, bovinos, prepars.plena flor, s/dividir',15,'41','4107','410791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41079190','Couros/peles, equídeos, prepars.pena flor, n/div','Leathers/skins, equine, prepared, not split','Cueros/pieles, equinos, prepars.plena flor, s/dividir',15,'41','4107','410791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41079210','Couros/peles, bovinos, prepars.divid.c/a flor','Leathers/skins, bovines, prepared, grain splits','Cueros/pieles, bovinos, prepars.divididos c/la flor',15,'41','4107','410792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41079290','Couros/peles, equídeos, prepars.divid.c/a flor','Leathers/skins, equine, prepared, grain splits','Cueros/pieles, equinos, prepars.divididos c/la flor',15,'41','4107','410792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41079910','Outs.couros/peles, bovinos, preparados','Other leathers/skins, bovines, prepared','Ots.cueros/pieles, bovinos, preparados',15,'41','4107','410799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41079990','Outs.couros/peles, equídeos, preparados','Other leathers/skins, equine, prepared','Ots.cueros/pieles, equinos, preparados',15,'41','4107','410799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41080000','Couros e peles, acamurçados, incl.a camurca combinada','Leathers and skins, chamois, incl.combined chamois','Cueros y pieles, agumuzados, incl.el agumuzado combinado',15,'41','4108','410800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41090010','Couros e peles, envernizados ou revestidos','Leathers and skins, varnishing or covered','Cueros y pieles, charolados o revestidos',15,'41','4109','410900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41090020','Couros e peles, metalizados','Leathers and skins, metallic','Cueros y pieles, metalizados',15,'41','4109','410900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41100000','Aparas e outros desperd.de couros/peles, preparados, etc.','Leathers and skins, chips and other wastes, prepar.etc.','Recortes y demás desperd.de cueros/pieles, prepars., etc',10,'41','4110','411000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41110000','Couro reconstituído em chapas, folhas ou tiras','Leather reconstituted in foils, leaves or strips','Cuero regenerado en placas, hojas o tiras',10,'41','4111','411100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41120000','Couros ovinos, prepars.apos curtimenta, etc.','Leather further prepared after tanning, of sheep, etc.','Cueros de ovinos, prepars.despúes del curtido, etc.',15,'41','4112','411200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41131010','Couros caprinos, curtidos ao cromo, c/acabam.','Goats leathers, chrome-tanned, with finishing','Cueros de caprinos, curtidos al cromo, c/acabam.',15,'41','4113','411310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41131090','Outs.couros caprinos, prepars.apos curtimenta, etc.','Oth.goats leathers, prepared after tanning, etc','Ots.cueros de caprinos, prepars.después del curtido, etc.',15,'41','4113','411310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41132000','Couros suínos, prepars.apos curtimenta, etc.','Swine leathers, prepared after tanning, etc','Cueros de porcino, prepars.despúes del curtido, etc.',15,'41','4113','411320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41133000','Couros de répteis, prepars.apos curtim.etc.','Reptiles leathers, prepared after tanning, etc','Cueros de reptil, prepars.despúes del curtido, etc.',15,'41','4113','411330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41139000','Couros de outs.animais, prepars.apos curt.etc.','Leathers of other animals, prepared after tanning, etc','Cueros de ots.animales, prepars.despúes del curtido, etc.',15,'41','4113','411390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41141000','Couros/peles acamurcados (incl.camurça comb.)','Leathers/skins chamois (incl.combination chamois)','Cueros/pieles agamuzados (incl.el agamuzado comb.)',15,'41','4114','411410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41142010','Couros/peles envernizados ou revestidos','Leathers/skins varnishings or covered','Cueros/pieles charolados o revestidos',15,'41','4114','411420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41142020','Couros/peles metalizados','Leathers and skins metallised','Cueros/pieles metalizados',15,'41','4114','411420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41151000','Couro reconstituído, à base de couro, etc.','Composition leather with a basis of leather, etc.','Cuero regenerado, a base de cuero, etc.',10,'41','4115','411510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('41152000','Aparas e outros desperdícios de couros, etc.','Parings and other waste of leather, etc.','Recortes y demás desperdicios de cueros, etc.',10,'41','4115','411520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42010010','Artigos de seleiro/correeiro, de couro natural/reconstit','Saddlery and harness, of natural leather/reconstit.','Art.de talabartería/guarnicion., de cuero natural/regen.',10,'42','4201','420100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42010090','Artigos de seleiro/correeiro, de outras matérias','Saddlery and harness, of other materials','Art.de talabartería/guarnicionería, de otras materias',10,'42','4201','420100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42021100','Malas, maletas e pastas, de couro natural/reconst/envern.','Trunks, suit-cases, folder, natural leather varn./rebuilt','Baúles, maletas y maletines, de cuero natur./reg./charol.',11,'42','4202','420211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42021210','Malas, maletas e pastas, de plástico','Trunks, suit-cases, folders, of plastics','Baúles, maletas y maletines, de plástico',11,'42','4202','420212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42021220','Malas, maletas e pastas, de matérias têxteis','Trunks, suit-cases, folders, of textile materials','Baúles, maletas y maletines, de materias textiles',11,'42','4202','420212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42021900','Malas, maletas e pastas, de outras matérias','Trunks, suit-cases, folders, of other materials','Baúles, maletas y maletines, de otras materias',11,'42','4202','420219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42022100','Bolsas de couro natural, reconstituído ou envernizado','Purses of natural leather, rebuilt or varnishings','Bolsos de cuero natural, regenerado o charolado',11,'42','4202','420221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42022210','Bolsas de folhas de plástico','Purses of plastic sheeting','Bolsos de hojas de plástico',11,'42','4202','420222');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42022220','Bolsas de matérias têxteis','Purses of textile materials','Bolsos de materias textiles',11,'42','4202','420222');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42022900','Bolsas de outras matérias','Purses of other materials','Bolsos de otras materias',11,'42','4202','420229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42023100','Artigos de bolsos/bolsas, de couro natural/reconstit.etc','Pockets articles/purses of natural leathers/reconst.etc','Arts.de bolsillos/bolsos, de cuero natural/regen.etc',11,'42','4202','420231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42023200','Artigos de bolsos/bolsas, de fls.de plástico/mater.text.','Pockets articles/purses of plastic sheeting/text.mater.','Arts.de bolsillos/bolsos, de hjs.de plástico/mater.text.',10,'42','4202','420232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42023900','Artigos de bolsos/bolsas, de outras matérias','Pockets articles/purses of other materials','Artículos de bolsillos/bolsos, de otras materias',10,'42','4202','420239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42029100','Outs.artefatos de couro natural/reconstituido/enverniz.','Other articles of natural leathers/compos./varnishings','Los dem.artíc.de cuero natural/regenerado/charolado',11,'42','4202','420291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42029200','Outros artefatos, de fls.de plástico ou matérias têxteis','Other articles of plastic sheeting/of textile materials','Los dem.artíc.de hojas de plástico o materias textiles',11,'42','4202','420292');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42029900','Outros artefatos, de outros matérias','Other articles of other materials','Los demás artículos, de otras materias',10,'42','4202','420299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42031000','Vestuário de couro natural ou reconstituido','Apparel of natural leather or composition','Prendas de vestir de cuero natural o regenerado',10,'42','4203','420310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42032100','Luvas, mitemes, etc.p/esportes, de couro natural/reconstit','Gloves, mittens, etc.forsports, of natural leather/composit','Guantes, mitones, etc.p/deportes, de cuero natural/regen.','13','42','4203','420321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42032900','Outras luvas, mitemes, etc.de couro natural/reconstituido','Other gloves, mittens, etc.of natural leather/composit','Ots.guantes, mitones, etc.de cuero natural/regenerados','13','42','4203','420329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42033000','Cintos, cinturoes, bandoleiras, etc.de couro nat/reconstit','Belts and bandoliers, etc.of natural leather/composit.','Cintos, cinturones, bandoleras, etc.de cuero nat/regener.',10,'42','4203','420330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42034000','Outros acessórios de vestuário, de couro natural/reconst','Oth.clothing accessories, of natural leather/composit.','Otros complementos de vestir, de cuero natural/regener.',10,'42','4203','420340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42040010','Correias transportad/de transmiss.de couro nat/reconst.','Conveyor belts, of natural leather/composition','Correas transportad/de transmis.de cuero nat/regener.',10,'42','4204','420400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42040090','Outs.artigos p/usos técnicos, de couro natural/reconstit','Oth.articles fortechnical uses, of natural leather/compos','Otros artículos para usos técnicos, de cuero natural/regen.',10,'42','4204','420400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42050000','Outras obras de couro natural ou reconstituido','Other articles of leather or of composition leather','Otras manufacturas de cuero natural o regenerado',10,'42','4205','420500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42060000','Obras de tripa, ,  de bexiga ou de tendões','Articles of gut, bladder or tendons','Manufacturas de tripa, vejiga o tendones ',10,'42','4206','420600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42061000','Cordas de tripa','Catgut','Cuerdas de tripa',10,'42','4206','420610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('42069000','Outras obras de tripa, "baudruches", bexiga ou de tendoes','Other works of gut, "baudruches", bladder or of tendons','Otras manufacturas de tripa, vejigas o de tendones',10,'42','4206','420690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43011000','Peleteria em bruto, de "vison", inteira','Raw furskins, of mink, whole','Peleteria en bruto, de visón, entera',11,'43','4301','430110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43012000','Peleteria em bruto, de coelho ou de lebre, inteira','Raw furskins, of rabbit or of hare, whole','Peleteria en bruto, de conejo o liebre, entera',11,'43','4301','430120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43013000','Peleteria em bruto, de cordeiros astraca, etc.inteira','Raw furskins, of astrakhan lamb, etc.whole','Peleteria en bruto, de cordero "astracán",  etc, entera',11,'43','4301','430130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43014000','Peleteria em bruto, de castor, inteira','Raw furskins, of beaver, whole','Peleteria en bruto, de castor, entera',11,'43','4301','430140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43015000','Peleteria em bruto, de rato-almiscarado, inteira','Raw furskins, of mouse-musky, whole','Peleteria en bruto, de rata almizclera, entera',11,'43','4301','430150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43016000','Peleteria em bruto, de raposa, inteira','Raw furskins, of fox, whole','Peleteria en bruto, de zorro, entera',11,'43','4301','430160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43017000','Peleteria em bruto, de foca ou de otaria, inteira','Raw furskins, of seal, whole','Peleteria en bruto, de foca u otaria, entera',11,'43','4301','430170');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43018000','Peleteria em bruto, de outros animais, inteira','Raw furskins, of other animals, whole','Peleteria en bruto, de otros animales, entera',11,'43','4301','430180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43019000','Cabeças, caudas, patas, etc.de animais util.na ind.peles','Heads, tails, paws, etc.of animals used in the skins ind.','Cabezas, colas, patas, etc.de animales util.en peletería',11,'43','4301','430190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43021100','Peleteria curtida/acabada, de "vison", inteira, n/reunida','Tanned/dressed furskins, of mink, whole, unassembled','Peleteria curtida/adobada, de visón, entera, s/ensamblar',11,'43','4302','430211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43021200','Peleteria curtida/acab.de coelho/lebre, inteir.n/reunida','Tanned/dressed furskins, rabbit/, whole, unassembled','Peleteria curtida/adobada, de conejo, entera, s/ensamblar',11,'43','4302','430212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43021300','Peleteria curtida/acabada, de cordeiros, inteir.n/reunida','Tanned/dressed furskins, of lamb, whole, unassembled','Peleteria curtida/adobada, de cordero, entera, s/ensamblar',11,'43','4302','430213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43021910','Peleteria curtida/acabada, de ovinos, inteira, n/reunida','Tanned/dressed furskins, of sheep, whole, unassembled','Peleteria curtida/adobada, de ovinos, entera, s/ensamblar',11,'43','4302','430219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43021990','Peleteria curtida/acab.de outs.animais, inteir.n/reunida','Tanned/dressed furskins of ot.animals, whole, unassembled','Peleteria curtida/adob., de ots.anim., entera, s/ensamblar',11,'43','4302','430219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43022000','Cabeças, caudas, etc.curtidas/acabads.inteiras, n/reunidas','Heads, tails, paws, etc.tanned/finish.whole, unassembled','Cabezas, colas, patas, etc.curtidas/adobs., enteras, s/ens.',11,'43','4302','430220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43023000','Peleteria curtida/acabada, inteira/pedaços, etc.reunidos','Tanned/dressed furskins whole/pieces, etc.assembled','Peleteria curtida/adobada, entera/trzos, etc, ensamblados',11,'43','4302','430230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43031000','Vestuário e seus acessórios, de peleteria','Articles of apparel/clothing accessories, of furskin','Prendas de vestir y sus complementos, de peletería',11,'43','4303','430310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43039000','Outros artefatos de peleteria','Other articles of furskin','Otros artículos de peletería',11,'43','4303','430390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('43040000','Peleteria artificial e suas obras','Artificial fur and articles thereof','Peletería artificial y sus manufacturas',15,'43','4304','430400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44011000','Lenha em qualquer estado','Firewood in any state','Leña en cualquier estado',10,'44','4401','440110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44012100','Madeira de coníferas, em estilhas ou em partículas','Coniferous wood, in chips or particles','Madera de coníferas, en plaquitas o en partículas',10,'44','4401','440121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44012200','Madeira de não coníferas, em estilhas ou em partículas','Non-coniferous wood, in chips or particles','Madera distinta de la de coníferas, en plaqs.o en parts.',10,'44','4401','440122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44013000','Serragem, desperdícios e resíduos, de madeira','Sawdust and wood waste and residues','Aserrín, desperdicios y desechos, de madera',10,'44','4401','440130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44013100','Pellets de madeira','Wood pellets','Bolitas de madera',10,'44','4401','440131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44013900','Outras serragens, desperdicios e residuos, de madeira','Other sawdust and waste, of wood','Otros aserrín, desperdicios y chatarra, de madera',10,'44','4401','440139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44020000','Carvão vegetal','Wood charcoal','Carbón vegetal',10,'44','4402','440200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44021000','Carvão vegetal de bambu mesmo aglomerado','Bamboo wood charcoal, even agglomerated','Carbón vegetal de bamboo, mismo aglomerado',10,'44','4402','440210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44029000','Outros carvões vegetal mesmo aglomerado','Other wood charcoal, even agglomerated','Outro carbón vegetal, mismo aglomerado',10,'44','4402','440290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44031000','Madeira em bruto, tratada com tinta, creosoto, etc.','Wood in the rough, treated with paint, creosote, etc.','Madera en bruto, tratada con pintura, creosota, etc.',16,'44','4403','440310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44032000','Madeira de coniferas, em bruto','Coniferous wood, in rough','Madera de coníferas, en bruto',16,'44','4403','440320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44034100','Madeira de dark ou light red meranti, etc.em bruto','Wood of dark or light red meranti, etc.in rough','Madera de dark o light red meranti, etc.en bruto',16,'44','4403','440341');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44034900','Outras madeiras tropicais, em bruto','Other tropical wood, in rough','Otras maderas tropicales, en bruto',16,'44','4403','440349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44039100','Madeira de carvalho (quercus spp), em bruto','Wood oak (quercus spp), in rough','Madera de roble (quercus spp), en bruto',16,'44','4403','440391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44039200','Madeira de faia (fagus spp), em bruto','Wood beech (fagus spp), in rough','Madera de haya (fagus spp), en bruto',16,'44','4403','440392');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44039900','Outras madeiras em bruto','Other wood, in rough','Otras maderas, en bruto',16,'44','4403','440399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44041000','Arcos de madeira, estacas fendidas, etc.de coníferas','Hoopwood, stakes, etc.of coniferous','Flejes de madera, rodrigones hendidos, etc.de coníferas',10,'44','4404','440410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44042000','Arcos de madeira, estacas fendidas, etc.de nao coniferas','Hoopwood, stakes, etc.of non-coniferous','Flejes de madera, rodrigs.hendidos, etc.dist.de coníferas',10,'44','4404','440420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44050000','Lã de madeira e farinha de madeira','Wood wool and wood flour','Lana de madera y harina de madera',10,'44','4405','440500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44061000','Dormentes de madeira, p/vias férreas, etc.não impregnados','Sleepers wood, for railroads, etc.not impregnated','Traviesas de madera, p/vías férreas, etc.sin impregnar',16,'44','4406','440610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44069000','Outras dormentes de madeira, para vias férreas ou semelh','Other wood sleepers,  for railroads or similar','Otras traviesas de madera, p/vías férreas o similares',16,'44','4406','440690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44071000','Madeira de coniferas, serrada/cortada em fls.etc.esp>6mm','Coniferous wood, sawn/cut in sheets etc.thinck.>6mm','Madera de coníferas, aserrada/cortada en hjs.etc.esp>6mm',16,'44','4407','440710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44072100','Madeira mogno serr. long. folhas esp.>6mm','Mahogany wood, lenghtwise sawn, cut in sheeets, thickness.>6mm','Madera de mahogany, aserrada/cortada en hojs.etc.esp>6mm',16,'44','4407','440721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44072200','Virola, imbuia, balsa, serr.long.fls.esp.>6mm','Virola, imbuia,balsa, sawn/cut, lenghtwise, in sheets, thick>6mm','Imbuya, virola, balsa, aserrada/cortada a lo largo, esp>6mm',16,'44','4407','440722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44072410','Madeira de mahogany, serrada/cortada em fls.etc.esp>6mm','Mahogany wood, sawn/cut in sheets etc.thinck.>6mm','Madera de mahogany, aserrada/cortada en hojs.etc.esp>6mm',16,'44','4407','440724');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44072420','Madeira de imbuia, serrada/cortada em folhas, etc.esp>6mm','Imbuia wood, sawn/cut in sheets etc.thinck.>6mm','Madera de imbuya, aserrada/cortada en hojas, etc.esp>6mm',16,'44','4407','440724');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44072490','Madeira de virola/balsa, serrada, cort.em fls.etc.esp>6mm','Virola wood, balsa/sawn/cut in sheets etc.thinck.>6mm','Madera de virola/balsa, aserrada, cort.en hoj.etc.esp>6mm',16,'44','4407','440724');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44072500','Madeira de dark red meranti, etc.serrada, cort.fls.e>6mm','Dark red meranti wood, etc.sawn, cut in sheets thin.>6mm','Madera de dark red meranti, etc.aserrada, cort.hoj.e>6mm',16,'44','4407','440725');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44072600','Madeira de white lauan, etc.serrada, cort.fls.etc.esp>6mm','White lauan wood, etc.sawn, cut in sheets thin.>6mm','Madera de white lauan, etc.aserrada, cort.hoj.etc.esp>6mm',16,'44','4407','440726');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44072700','Mad. sapelli serr. long. folhas espess. >6mm','Sapelli wood, sawn, lenghtwise, thickness>6mm','Madera de sapelli, aserrada, esp>6mm',16,'44','4407','440727');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44072800','Mad. iroco serr. long. folhas espess. >6mm','Iroco wood, sawn, lenghtwise, thickness>6mm','Madera de iroco, aserrada, esp>6mm',16,'44','4407','440728');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44072910','Madeira de cedro, serrada/cortada em folhas, etc.esp>6mm','Cedar wood, sawn/cut in sheets etc.thick.>6mm','Madera de cedro, aserrada/cortada en hojas, etc.esp>6mm',16,'44','4407','440729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44072920','Madeira de ipe, serrada/cortada em folhas, etc.esp>6mm','Ipe wood, sawn/cut in sheets etc.thick.>6mm','Madera de ipé, aserrada/cortada en hojas, etc.esp>6mm',16,'44','4407','440729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44072930','Madeira de pau marfim, serrada/cort.em fls.etc.esp>6mm','Pau marfim wood, sawn/cut in sheets etc.thick.>6mm','Madera de palo marfil, aserrada/cort.en hoj.etc.esp>6mm',16,'44','4407','440729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44072940','Madeira de louro, serrada/cortada em folhas, etc.esp>6mm','Louro wood, sawn/cut in sheets etc.thick.>6mm','Madera de louro, aserrada/cortada en hjs.etc.esp>6mm',16,'44','4407','440729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44072990','Outras madeiras tropicais, serradas/cort.fls.etc.esp>6mm','Other tropical wood, sawn/cut in sheets etc.thick.>6mm','Otras maderas tropicales, aserradas/cort.hjs.etc.esp>6mm',16,'44','4407','440729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44079100','Madeira de carvalho, serrada/cortada em fls.etc.esp>6mm','Oak wood, sawn/cut in sheets, etc.thick.>6mm','Madera de roble, aserrada/cortada en hjs.etc.esp>6mm',16,'44','4407','440791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44079200','Madeira de faia, serrada/cortada em folhas, etc.esp>6mm','Beech wood, sawn/cut in sheets, etc.thick.>6mm','Madera de haya, aserrada/cortada en hjs.etc.esp>6mm',16,'44','4407','440792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44079300','Madeira de ácer serr.long.folhas >6mm','Maple wood, sawn, lenghtwise, thickness>6mm','Madera de arce, aserradalongitudinalmente, esp>6mm',16,'44','4407','440793');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44079400','Madeira de cerejeira serrada long. fls.>6mm','Cherry wood, lenghtwise sawn in sheets, thickness >6mm','Madera de cereza, aserrada/cortada longitudinalmente en hojas, esp>6mm',16,'44','4407','440794');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44079500','Madeira de freixo serrada long.folhas >6mm','Ash wood, lenghtwise sawn in sheets, thickness >6mm','Madera de fresno, aserrada en hojas, esp>6mm',16,'44','4407','440795');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44079910','Madeira de canafístula, serrada/cort.em fls.etc.esp>6mm','Canafistula wood, sawn/cut in sheets, etc.thick.>6mm','Madera de cañafístula, aserrada/cort.en hjs.etc.esp>6mm',16,'44','4407','440799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44079920','Madeira de peroba, serrada/cortada em folhas, etc.esp>6mm','Peroba wood, sawn/cut in sheets, etc.thick.>6mm','Madera de peroba, aserrada/cortada en hjs.etc.esp>6mm',16,'44','4407','440799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44079930','Madeira de guaiuvira, serrada/cortada em fls.etc.esp>6mm','Guayaibi wood, sawn/cut in sheets, etc.thick.>6mm','Madera de guayaibí, aserrada/cort.en hjs.etc.esp>6mm',16,'44','4407','440799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44079940','Madeira de cabreuva parda, serrada/cort.fls.etc.esp>6mm','Incienso wood, sawn/cut in sheets, etc.thick.>6mm','Madera de cabreuva parda, aserr./cort.en hjs.etc.esp>6mm',16,'44','4407','440799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44079950','Madeira de urundei, serrada/cortada em fls.etc.esp>6mm','Urunday wood, sawn/cut in sheets, etc.thick.>6mm','Madera de urunday, aserrada/cort.en hjs.etc.esp>6mm',16,'44','4407','440799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44079960','Madeira de amendoim, serrada/cortada em fls.etc.esp>6mm','Vivaro wood, sawn/cut in sheets, etc.thick.>6mm','Madera de cacahuete, aserrada/cort.en hjs.etc.esp>6mm',16,'44','4407','440799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44079970','Madeira de angico preto, serrada/cort.em fls.etc.esp>6mm','Curupay wood, sawn/cut in sheets, etc, thick.>6mm','Madera de angico negro, aserrada/cort.en hjs.etc.esp>6mm',16,'44','4407','440799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44079990','Outras madeiras serradas/cortadas em folhas, etc.esp>6mm','Other wood, sawn/cut in sheets, etc, thick.>6mm','Otras maderas aserradas/cortadas en hojas, etc.esp>6mm',16,'44','4407','440799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44081010','Folhas de madeira, de pinho brasil, espessura<=6mm','Wood sheets, of pine brazil, thickness<=6mm','Hojas de madera, de pino brasil, espesor<=6mm',16,'44','4408','440810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44081090','Folhas de outras madeiras, de coniferas, espessura<=6mm','Other wood sheets, of coniferous, thickness<=6mm','Hojas de otras maderas, de coníferas, espesor<=6mm',16,'44','4408','440810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44081091','Folhas para folheados, etc.de pinho brasil','Sheets for veneering, etc.of pine brazil','Hojas para chapado, etc.de pino brasil',16,'44','4408','440810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44081099','Folhas para folheados, etc.de outs.mad.coniferas','Sheets for veneering, etc.of other coniferous wood','Hojas para chapado, etc.de ots.mad.coníferas',16,'44','4408','440810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44083100','Folhas de madeira, de dark/light red meranti, etc.e<=6mm','Sheets forveneering, of dark/light red meranti, etc.t<=6mm','Hojas de madera, de dark/light red meranti, etc.e<=6mm',16,'44','4408','440831');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44083110','Folhas p/folhead.etc.de mad.conifera estratif','Sheets forveneering, etc.coniferous wood stratified','Hojas para chapado, etc.de mad.coníferas estratificadas',16,'44','4408','440831');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44083190','Folhas p/folhead.etc.de dark red meranti, etc, ','Sheets forveneering, etc.of dark red meranti, etc','Hojas para chapado, etc.de dark red meranti, etc',16,'44','4408','440831');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44083910','Folhas de madeira, de cedro, espessura<=6mm','Wood sheets, of cedar, thickness<=6mm','Hojas de madera, de cedro, espesor<=6mm',16,'44','4408','440839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44083920','Folhas de madeira, de pau marfim, espessura<=6mm','Wood sheets, of pau marfim, thickness<=6mm','Hojas de madera, de palo marfil, espesor<=6mm',16,'44','4408','440839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44083990','Folhas de outras madeiras tropicais, espessura<=6mm','Sheets of other tropical wood, thickness<=6mm','Hojas de otras maderas tropicales, espesor<=6mm',16,'44','4408','440839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44083991','Folhas p/folhead.compensad.etc.de cedro','Sheets for veneering compensated, etc, of cedar','Hojas para chapado o contrachapado, etc, de cedro',16,'44','4408','440839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44083992','Folhas p/folhead.compensad.etc.de pau-marfim','Sheets for veneering compensated, etc, of pau marfim','Hojas para chapado o contrachapado, etc, de palo marfil',16,'44','4408','440839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44083999','Folhas p/folhead.etc.de outs.madeiras tropic.','Sheets for veneering, etc, of other tropical wood','Hojas para chapado, etc, de ots.maderas tropicales',16,'44','4408','440839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44089000','Folhas de outras madeiras, espessura<=6mm','Sheets of other wood, thickness<=6mm','Hojas de otras maderas, espesor<=6mm',16,'44','4408','440890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44089010','Folhas p/folhead.etc.de outs.mad.estratif.','Sheets for veneering, etc, of other stratified wood','Hojas para chapado, etc, de ots.maderas estratificadas',16,'44','4408','440890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44089090','Folhas p/folhead.etc.de outs.madeiras','Sheets for veneering, etc, of other wood','Hojas para chapado, etc, de ots.maderas',16,'44','4408','440890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44091000','Madeira de coniferas, perfilada','Coniferous wood,  continuously shaped','Madera de coníferas, perfilada longitudinalmente',16,'44','4409','440910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44092000','Madeira de nao coniferas, perfilada','Non-coniferous wood, continuously shaped','Madera de distinta de las coníferas, perfilada long.',16,'44','4409','440920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44092100','De bambu perf. tacos fris. etc., ñ coniferas','Of shaped bamboo, stick, friezes  non-coniferous ','De bambú perfilado, tacos, los frisos, distinta de las coníferas ',16,'44','4409','440921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44092900','Outras madeiras perf. etc., não coniferas','Other shaped wood, etc,. non-coniferous','Otras maderas perfiladas, etc, distintas de las coníferas',16,'44','4409','440929');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44101100','Paineis de madeira denominados "waferboard"','Waferboard','Tableros de madera llamados "waferboard"',16,'44','4410','441011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44101110','Painéis d/mad. em bruto ou simpl. polidos','Wood boards, in rough or simply polished','Tableros de madera, en bruto o simplemente polido',16,'44','4410','441011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44101120','Painéis d/mad. c/papel impreg. d/melamina','Wood boards with melamine-impregnated papers','Tableros de madera com papel impregnado de melamina',16,'44','4410','441011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44101121','Painéis d/partic.mad, recob.pelic.prot.p/pavimento','Wood particle boards, coverd by protec. film for pavement','Tableros de madera cubierto con la película protetora parapavimento  ',16,'44','4410','441011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44101129','Outs.paineis de partic.mad, recob.papel c/melamina','Other wood particle boards, coverd by melamine paper','Otros paneles de partículas de madera, cubierto con papel de melamina',16,'44','4410','441011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44101190','Outros painéis de partículas','Other particle boards','Otros tableros de partículas',16,'44','4410','441011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44101210','Painéis"oriented strand", waferb., bto.polido','"oriented strand" boards, waferboard, brute, polished','Tableros "oriented strand", waferboard, bruto, pulido',16,'44','4410','441012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44101290','Outs.painéis"oriented strand board", waferb.','Other oriented strand boards, waferboard ','Otros tableros "oriented strand", waferboard ',16,'44','4410','441012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44101900','Outros painéis de madeira','Other woodboards','Otros tableros de madera',16,'44','4410','441019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44101911','Painéis "waferboard"','Waferboard','Tableros de madera llamados "waferboard"',16,'44','4410','441019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44101919','Outros painéis "waferboard"','Other waferboard','Otros tableros de madera llamados "waferboard"',16,'44','4410','441019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44101991','Outros painéis de madeira em bruto ou simplesmente polidos','Other wood boards, in rough or simply polished','Otros tableros de madera, en bruto o simplemente polido',16,'44','4410','441019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44101992','Outs.painéis d/mad.c/pap.impreg.d/melamin','Other wood boards, coverd by melamine paper','Otros tableros de madera, cubierto con papel de melamina',16,'44','4410','441019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44101999','Outs.painéis d/mad.rec.sup.c/plac./fls.plást.','Other wood boards, cover. sup. with laminates, sheet of plastic','Otros tableros de madera, cubierto sup. con placas/ hojas de plástico',16,'44','4410','441019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44102100','Paineis de particul."waferboard", etc.em bruto','Particle board "waferboard", etc.unworked','Tableros de partícul.llamados "waferboard", etc.en bruto',16,'44','4410','441021');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44102900','Outs.painéis de particulas "waferboard", etc.','Other particle board"waferboard", etc.','Ots.tableros de partícul.llamados "waferboard", etc.',16,'44','4410','441029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44103100','Outs.painéis de madeira em bruto/simpl.polido','Oth.board wood in brute/simply polished','Ots.tableros de madera en bruto/simplemente lijado',16,'44','4410','441031');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44103200','Outs.painéis de madeira, recob.papel melamina','Other board wood, covered, melanine paper','Ots.tableros de madera, recubiertos c/papel melamina',16,'44','4410','441032');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44103300','Outs.painéis de madeira recob.placas plástico','Other board wood, covered, laminates of plastics','Ots.tableros de madera, recubiertos c/placas de plástico',16,'44','4410','441033');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44103900','Outs.painéis de madeira','Other wood panels','Otros tableros de madera',16,'44','4410','441039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44109000','Paineis de outras matérias lenhosas','Board of other woody matters','Tableros de otras materias leñosas',16,'44','4410','441090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44111100','Paineis de fibras de madeira, n/trab.mecan.d>0.8g/cm3','Fibreboard of wood, n/mechanically worked d>0.8g/cm3','Tableros de fibras de madera, s/trab.mecán.d>0.8g/cm3',16,'44','4411','441111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44111210','Painéis fibras mad., ñ trab.mec.d>5mm','Fibreboards of wood, not mechanically worked t>5mm','Tableros de fibras de madera, s/trab.mecán.a>5mm',16,'44','4411','441112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44111290','Outs.painéis fibr.mad.lenh.den.>5mm','Other fibreboards of wood or ligenous materials t>5mm','Otros tableros de fibra de madera or materia leñosa a>5mm',16,'44','4411','441112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44111310','Painéis fibras mad., ñ trab.mec.d>5mm<9mm','Fibreboards of wood, not mechanically worked t>5mm, t<9mm','Tableros de fibras de madera, sin trab.mecán. a>5mm, a<9mm',16,'44','4411','441113');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44111390','Outs.painéis fibr.mad.lenh.den.>5mm<9mm','Other fibreboards of wood or ligenous materials t>5mm, t<9mm','Otros tableros de fibra de madera or materia leñosa a>5mm, a<9mm',16,'44','4411','441113');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44111391','Paineis de fibra mad.5mm<esp<9mm, recob.pelic.protet','Fibreboards of wood 5mm<thickness<9mm, coverd by protecting film','Tableros de fibra de madera 5mm<anchura<9mm, recubiertos de película de proteción  ',16,'44','4411','441113');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44111399','Outs paineis de fibra mad.5mm<esp<9mm','Other fibreboards of wood, 5mm<thickness<9mm','Otros tableros defibra de madera 5mm<anchura<9mm',16,'44','4411','441113');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44111410','Painéis fibras mad., ñ trab.mec.d>9mm','Fibreboards of wood, not mechanically worked t>9mm','Tableros de fibra de madera, sin trabajo mecánico a>9mm',16,'44','4411','441114');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44111490','Outs.painéis fibr.mad.lenh.den.>9mm','Fibreboards of wood or ligenous materials t>9mm','Tableros de fibra de madera or materia leñosa a>9mm',16,'44','4411','441114');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44111900','Outros paineis de fibras de madeira, densidade>0.8g/cm3','Other fibreboard of wood, density>0.8g/cm3','Ots.tableros de fibras de madera, densidad>0.8g/cm3',16,'44','4411','441119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44112100','Paineis de fibras de madeira, n/trab.mec.0.5<d<=0.8g/cm3','Fibreboard of wood, n/mechan.worked 0.5<d<=0.8g/cm3','Tableros de fibras de mad., s/trab.mecán.0.5<d<=0.8g/cm3',16,'44','4411','441121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44112900','Outs.paineis de fibras de madeira, 0.5g/cm3<d<=0, 8g/cm3','Oth.fibreboard of wood, 0.5g/cm3<d<=0.8g/cm3','Ots.tableros de fibras de madera, 0.5g/cm3<d<=0.8g/cm3',16,'44','4411','441129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44113100','Paineis de fibras madeira, n/trab.mecan.0.35<d<=0.5g/cm3','Fibreboard of wood, n/mechally worked 0.35<d<=0.5g/cm3','Tableros de fibras de mad, s/trab.mecán.0.35<d<=0.5g/cm3',16,'44','4411','441131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44113900','Outs.painéis de fibras de madeira, 0.35g/cm3<d<=0.5g/cm3','Other fibreboard of wood, 0.35<d<=0.5g/cm3','Ots.tableros de fibras de madera, 0.35<d<=0.5g/cm3',16,'44','4411','441139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44119100','Outs.painéis de fibras de madeira, n/trab.mecan.n/recob.','Other fibreboard of wood, n/mechally worked n/coved','Ots.tableros de fibras de madera, s/trab.mecán.ni recubr',16,'44','4411','441191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44119210','Painéis fibras mad., ñ trab.mec.d>0, 8g/cm3','Fibreboards of wood, not mechanically worked d>0.8g/cm3','Tableros de fibra de madera, sin trabajo mecánico d>0.8g/cm3',16,'44','4411','441192');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44119290','Outs.painéis fibr.mad.lenh.den.>0, 8g/cm3','Other fibreboards of wood, not mechanically worked d>0.8g/cm3','Otros tableros de fibra de madera, sin trabajo mecánico d>0.8g/cm3',16,'44','4411','441192');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44119310','Painéis fibras mad., ñ trab.mec.d>0, 5<0, 8g/cm3','Fibreboards of wood, not mechanically worked 0.5<d<0.8 g/cm3','Tableros de fibra de madera, sin trabajo mecánico 0.5<d<0.8g/cm3',16,'44','4411','441193');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44119390','Outs.painéis fibr.mad.lenh.den.>0, 5<0, 8g/cm3','Other fibreboards of wood or ligenous materials 0.5<d<0.8g/cm3','Otros tableros de fibra de madera or materia leñosa, 0.5<d<0.8g/cm3',16,'44','4411','441193');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44119410','Painéis fibras mad., ñ trab.mec.d<0, 5g/cm3','Fibreboards of wood, not mechanically worked d<0.5 g/cm3','Tableros de fibra de madera, sin trabajo mecánico  d<0.5g/cm3',16,'44','4411','441194');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44119490','Outs.painéis fibr.mad.lenh.den.<0, 5g/cm3','Other fibreboards of wood or ligenous materials d<0.5g/cm3','Otros tableros de fibra de madera or materia leñosa, d<0.5g/cm3',16,'44','4411','441194');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44119900','Outros paineis de fibras de madeira','Other fibreboard of wood','Ots.tableros de fibras de madera',16,'44','4411','441199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44121000','Mad.comp.folheada.e estrat.semelh.de bambu','Plywood, veneered panels stratified and similar in bamboo','Madera contrachapada, madera chapada y estratificada, similar de bambu',16,'44','4412','441210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44121300','Madeira compensada c/fls<=6mm, face de madeira tropical','Plywood consist.sheets<=6mm, face of tropical wood','Madera contrachapada c/hjs<=6mm, c/hj.ext.de mad.tropic.',16,'44','4412','441213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44121400','Madeira compensada c/fls<=6mm, face de madeira n/conifer','Plywood consist.sheets<=6mm, face of non-conferous wood','Mad.contrachapada c/hjs<=6mm, c/hj.ext.de mad.dist.coníf',16,'44','4412','441214');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44121900','Outs.madeiras compensadas, com folhas de espessura<=6mm','Other plywood consisting in sheets of thickness<=6mm','Ots.maderas contrachapadas c/hojas<=6mm',16,'44','4412','441219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44122200','Outs.madeiras compens.face mad.n/conif.camada mad.trop.','Oth.plywood, ply of non-conferous wood, layer trop.wood','Ots.mad.contrach.c/hj.ext.de mad.dist.coníf.cam.m.trop.',16,'44','4412','441222');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44122300','Outs.madeiras compens.face mad.n/conif.painel particula','Oth.plywood, ply of non-conferous wood, panel particle','Ots.mads.contrach.c/hj.ext.mad.dist.coníf.tablero part.',16,'44','4412','441223');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44122900','Outs.madeiras compensadas, c/face de madeira n/conifera','Other plywood, with ply of tropical wood n/ coniferous','Ots.maderas contrachapadas c/hj.ext.de mad.dist.coníf.',16,'44','4412','441229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44123100','Mad.compens.c/face d/mad.trop.espess.<6mm','Plywood with ply of tropical wood thickness <6mm ','Maderas contrachapadas con hoja externa de madera tropical < 6mm',16,'44','4412','441231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44123200','Mad.comp.face d/mad.ñ conif, espessura<6mm','Plywood with ply of non-conferous wood thickness <6mm ','Maderas contrachapadas con hoja externa de madera dist. coníf. < 6mm',16,'44','4412','441232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44123900','Outs.mad.comp.folheada, espess.ñ sup.a 6mm','Other plywood, veneered panels, thickness <=6 mm','Otras madeiras contrachapadas, madera chapada, de espesor <= 6 mm',16,'44','4412','441239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44129200','Outs.madeiras compensadas, c/camada de madeira tropical','Other plywood, with layer of tropical wood','Ots.maderas contrachapadas c/una hoja de madera tropic.',16,'44','4412','441292');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44129300','Outras madeiras compensadas, com painel de particulas','Other plywood, with particle board','Ots.maderas contrachapadas c/un tablero de partículas',16,'44','4412','441293');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44129400','Outs.mads. c/alma aglomer. alveolada/lamelada','Other','Otros',16,'44','4412','441294');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44129900','Outras madeiras compensadas, folheadas ou estratificadas','Other plywood, browsed or stratified','Ots.maderas contrachapadas, chapadas o estratificadas',16,'44','4412','441299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44130000','Madeira "densificada", em blocos, pranchas, laminas, perfis','Densified wood, in blocks, plates, strips, profile','Madera densificada, en bloques, tablas, tiras, perfiles',16,'44','4413','441300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44140000','Molduras de madeira, p/quadros, fotografias, espelhos, etc.','Wooden frames, forpaintings, photographs, mirrors, etc','Marcos de madera, p/cuadros, fotografías, espejos, etc.',10,'44','4414','441400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44151000','Caixotes, caixas, engradados, barricas, etc.de madeira','Cases, boxes, crates, drums, etc.of wood','Cajones, cajas, jaulas, tambores, etc.de madera',11,'44','4415','441510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44152000','Paletes simples, paletes-caixas, etc.de madeira','Pallets, box pallets, etc.of wood','Paletas simples, paletas cajas, etc.de madera',11,'44','4415','441520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44160010','Barris, cubas, balsas, dornas, etc.de madeira de carvalho','Casks, barrels, vats, tubs, etc.of oak wood','Barriles, cubas, tinas, tinajas, etc.de madera de roble',10,'44','4416','441600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44160090','Barris, cubas, balsas, dornas, selhas, etc.de outs.madeiras','Casks, barrels, vats, tubs, etc.of other wood','Barriles, cubas, tinas, tinajas, etc.de otras maderas',10,'44','4416','441600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44170010','Ferramentas de madeira','Tools made of wood','Herramientas de madera',11,'44','4417','441700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44170020','Formas, alargadeiras e esticadores, de madeira, p/calçados','Boot or shoe lasts and trees, of wood, forshoes','Hormas, ensanchadores y tensores para el calzado, de mad.',11,'44','4417','441700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44170090','Armações e cabos, de madeira, de ferramentas, escovas, etc.','Tools, tool bodies, tool handles, broom bodies, etc','Monturas y mangos,  de mad., de herramientas, cepillos, etc',11,'44','4417','441700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44181000','Janelas, janelas de sacada, caixilhos, etc.de madeira','Windows, frenchwindows, frames, etc.of wood','Ventanas, puertas vidrieras, marcos, etc de madera',10,'44','4418','441810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44182000','Portas, respect.caixilhos, alizares e soleiras, de madeira','Doors and their frames and thresholds, of wood','Puertas, sus marcos, contramarcos y umbrales, de madera',10,'44','4418','441820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44183000','Painéis de madeira, para soalhos','Wood panels, for parquet','Tableros de madera, para parqués',15,'44','4418','441830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44184000','Armações de madeira, para concreto','Wood shuttering, for concrete','Encofrados de madera, para hormigón',10,'44','4418','441840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44185000','Fasquias de madeira, para telhados','Shingles and shakes of wood, for roofs','Tablillas de madera, para cubierta de tejados o fachadas',10,'44','4418','441850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44186000','Postes e vigas de madeira','Beams and posts made of wood','Postes y vigas de madera',10,'44','4418','441860');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44187100','Painéis para pisos em mosaico','Panels for mosaic floors','Paneles de mosaico para parqués',15,'44','4418','441871');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44187200','Outs.painéis p/soalhos d/camadas múltiplas','Other panels for floors, with multiple layers','Otros paneles para parqués, con varias capas',10,'44','4418','441872');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44187900','Outros painéis montados para soalhos','Other mounted panels to floors','Otros tableros de madera montados, para parqués',10,'44','4418','441879');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44189000','Outras obras de marcenaria ou carpintaria, p/construções','Other works of joinery or carpentry, forconstruction','Otras obras de carpintería, para construcciones',10,'44','4418','441890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44190000','Artefatos de madeira, para mesa ou cozinha','Tableware and kitchenware, of wood','Artículos de mesa o de cocina, de madera',10,'44','4419','441900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44201000','Estatuetas e outros objetos, de madeira, p/ornamentação','Statuettes and other objects, of wood, for ornaments','Estatuillas y demás objetos de adorno, de madera',10,'44','4420','442010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44209000','Madeira marchetada/incrustada, cofres, etc.de madeira','Inlaid wood, incrusted, safes, etc.of wood','Marquetería/taracea, cofrecillos, etc.de madera',10,'44','4420','442090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44211000','Cabides de madeira, para vestuário','Wood hangers, for clothing','Perchas de madera, para prendas de vestir',10,'44','4421','442110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('44219000','Outras obras de madeira','Other articles of wood','Otras manufacturas de madera',10,'44','4421','442190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('45011000','Cortiça natural, em bruto ou simplesmente preparada','Natural cork, raw or simply prepared','Corcho natural en bruto o simplemente preparado',10,'45','4501','450110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('45019000','Desperdícios de cortiça, cortiça triturada, granulada, etc','Wastes of cork, triturated cork, granulated, etc','Desperdicios de corcho, corcho triturado, granulado, etc',10,'45','4501','450190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('45020000','Cortiça natural, sem a crosta/esquadriada/em cubos, etc.','Natural cork, debacked/roughly squared/in rectang.etc','Corcho natural, descortezado/escuadrado/en bloques, etc.',10,'45','4502','450200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('45031000','Rolhas de cortiça natural','Stoppers of natural corks','Tapones de corcho natural',10,'45','4503','450310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('45039000','Outras obras de cortiça natural','Other articles of natural corks','Otras manufacturas de corcho natural',10,'45','4503','450390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('45041000','Cortiça aglomerada, em cubos, blocos, chapas, folhas, etc.','Agglomerated cork, in cubes, blocks, foils, sheets, etc.','Corcho aglomerado, en bloques, placas, hojas, tiras, etc.',10,'45','4504','450410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('45049000','Outras obras de cortiça aglomerada','Other articles of agglomerated cork','Otras manufacturas de corcho aglomerado',10,'45','4504','450490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('46011000','Tranças e artigos semelhs.de matérias para entrançar','Plaits and similar products of plaiting materials','Trenzas y artículos similares de materia trenzable',10,'46','4601','460110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('46012000','Esteiras, capachos e divisórias, de matérias vegetais','Mats, matting and screens, of vegetable materials','Esterillas, esteras y cañizos, de materia vegetal',10,'46','4601','460120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('46012100','Esteiras, capachos, divisórias, de bambu','Mats, matting and screens, of bamboo','Esterillas, esteras y cañizos, de bambu',10,'46','4601','460121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('46012200','Esteiras, capachos, divisórias, de ratã','Mats, matting and screens, of rattan','Esterillas, esteras y cañizos, de ratán',10,'46','4601','460122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('46012900','Outs.esteiras, capachos, divis. d/mat. vegetal','Mats, matting and screens, of vegetable materials','Esterillas, esteras y cañizos, de materia vegetal',10,'46','4601','460129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('46019100','Trancas/etc.de matérias vegetais, tecidas/paralelizadas','Plaits/etc.of vegetable materials, strands/woven','Trenzas/etc.de materia vegetal, tejidas/paralelizadas',10,'46','4601','460191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('46019200','Outras matérias para entrançar, de bambu','Other materials for twisting, of bamboo','Otros materiales para trenzar, de bambu',10,'46','4601','460192');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('46019300','Outras matérias para entrançar, de ratã','Other materials for twisting, of rattan','Otros materiales para trenzar, de ratán',10,'46','4601','460193');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('46019400','Outras matérias para entrançar de matérias vegetais','Other materials for twisting, of vegetable materials','Otros materiales para trenzar, materiales vegetales',10,'46','4601','460194');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('46019900','Trancas/etc.de outras matérias, tecidas ou paralelizadas','Plaits/etc.of other materials, strands or woven','Trenzas/etc.de otras materias, tejidas o paralelizadas',10,'46','4601','460199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('46021000','Obras de cestaria, de matérias vegetais','Basketwork, of vegetable materials','Artículos de cestería de materia vegetal',10,'46','4602','460210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('46021100','Obras de cestaria, de bambu','Basketwork, of bamboo','Artículos de cestería, de bambu',10,'46','4602','460211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('46021200','Obras de cestaria, de ratã','Basketwork, of rattan','Artículos de cestería, de ratán',10,'46','4602','460212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('46021900','Outras obras d/cestaria d/mats.vegetais','Other basketwork, of vegetable materials','Otros artículos de cestería, de materia vegetal',10,'46','4602','460219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('46029000','Obras de cestaria, de outras matérias para entrançar, etc.','Basketwork, of other materials for plait, etc.','Artículos de cestería de otras materias trenzables',10,'46','4602','460290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47010000','Pastas mecânicas de madeira','Mechanical wood pulp','Pastas mecánicas de madera',10,'47','4701','470100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47020000','Pasta química de madeira, para dissolução','Chemical wood pulp, dissolving grades','Pasta química de madera para disolver',10,'47','4702','470200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47031100','Pasta quim.madeira de conifera, a soda ou sulfato, crua','Chemical wood pulp of coniferous, soda or sulphate, raw','Pasta quím.madera de conífera, a la sosa o sulfato, cruda',10,'47','4703','470311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47031900','Pasta quim.madeira de n/conifera, a soda ou sulfato, crua','Chemical wood pulp of n/coniferous, soda or sulphate, raw','Pasta quím.mad.dist.de conífera, a la sosa/sulfato, cruda',10,'47','4703','470319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47032100','Pasta quim.madeira de conifera, a soda/sulfat.semi/branq','Chemical wood pulp of conif., soda/sulphate, semi/bleach','Pasta quím.mad.de conífera, a la sosa/sulfato, semi/blanq',10,'47','4703','470321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47032900','Pasta quim.madeira de n/conif.a soda/sulfato, semi/branq','Chemical wood pulp of n/conif., soda/sulphate, semi/bleac','Pasta quím.mad.dist.de coníf, a la sosa/sulf, semi/blanq',10,'47','4703','470329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47041100','Pasta quim.madeira de conifera, ao bissulfito, crua','Chemical coniferous wood pulp, sulphite, unbleached','Pasta quím.madera de conífera, al sulfito, cruda',10,'47','4704','470411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47041900','Pasta quim.madeira de nao conifera, ao bissulfito, crua','Chemical non-coniferous wood pulp, sulphite, unbleached','Pasta quím.madera distinta de conífera, al sulfito, cruda',10,'47','4704','470419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47042100','Pasta quim.madeira de conifera, ao bissulfito, semi/branq','Chemical coniferous wood pulp, sulphite, semi/bleached','Pasta quím.madera de conífera, al sulfito, semi/blanq',10,'47','4704','470421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47042900','Pasta quim.madeira de n/conif.ao bissulfito, semi/branq.','Chemical wood pulp of n/coniferous, sulphite, semi/bleac','Pasta quím.mad.dist.de conífera, al sulfito, semi/blanq',10,'47','4704','470429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47050000','Pastas semiquímicas de madeira','Wood semi-chemical pulp','Pastas semiquímicas de madera',10,'47','4705','470500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47061000','Pastas de linteres de algodão','Cotton linters pulp','Pastas de línteres de algodón',10,'47','4706','470610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47062000','Pastas de fibras obtidas do papel ou cartão reciclados','Fibres pulps deriv.from recov.(waste/scrap)pap./paperbo','Pastas de fibras obtenidas de papel o cartón reciclados',10,'47','4706','470620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47063000','Outras pastas d/fibras obtidas de bambu','Other pulp of fibers obtained from bamboo','Otras pastas de fibras obtenidas del bambu',10,'47','4706','470630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47069100','Pastas mecânicas de outs.matérias fibrosas celulosicas','Mechanical pulps of other fibrous cellulosic material','Pastas mecánicas de ots.materias fibrosas celulósicas',10,'47','4706','470691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47069200','Pastas químicas de outras matérias fibrosas celulosicas','Chemical pulps of other fibrous cellulosic material','Pastas químicas de ots.materias fibrosas celulósicas',10,'47','4706','470692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47069300','Pastas semiquim.de outras matérias fibrosas celulosicas','Semi-chemical pulps of oth.fibrous cellulosic material','Pastas semiquímic. de ots.materias fibrosas celulósicas',10,'47','4706','470693');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47071000','Papel/cartão kraft, crus ou ondul.de reciclar (desperds)','Unbleached kraft paper/paperb.corr.of recycling(wastes)','Papel/cartón kraft, crudo o corrug.p/reciclar(desperds)',10,'47','4707','470710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47072000','Outs.papéis/cartões obt.da pasta quim.branq.de reciclar','Oth.paper/paperboard, made of bleac.chem.pulp, of recycl.','Ots.papeles/cartones obt.de pasta quím.blanq.p/reciclar',10,'47','4707','470720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47073000','Papel/cartão obtidos da pasta mecânica, de reciclar','Paper/paperboard, made of bleac.mechan.pulp, of recycl.','Papel/cartón obtenidos de pasta mecánica, p/ reciclar',10,'47','4707','470730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('47079000','Outs.papéis ou cartões, de reciclar, incl.n/selecionados','Oth.paper/paperboard, of recycling, incl.n/selected','Ots.papeles o cartones, p/ reciclar, incl.sin clasificar',10,'47','4707','470790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48010010','Papel jornal, em rolos/fls.p<=57g/m2, fibra proc.mec>=65%','Newsprint, rolls/sheets w<=57g/m2, mechan.fibre>=65%','Papel prensa, en bobis/hjs.p<=57g/m2, fibra proc.mec>=65%',10,'48','4801','480100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48010090','Outros papéis jornais, em rolos ou em folhas','Other newsprint, in rolls or sheets','Otros papeles prensa, en bobinas o en hojas',10,'48','4801','480100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48021000','Papel e cartão feitos a mão (folha a folha)','Hand-made paper and paperboard (sheet at sheet)','Papel y cartón hechos a mano (hoja a hoja)',10,'48','4802','480210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48022000','Papel/cartão p/fabr.papel/cartão fotossen.etc.rolos, fls','Pap/paperb.forproduc.photo-sens.pap/paperb.etc.rolls, she','Papel/cartón sop.p/papel/cartón fotosen.etc.bobinas, hjs',10,'48','4802','480220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48022010','Papel p/fabr.papel fotosens.rolos, l<=15cm, fls.l<=360mm','Paper forprod.photo-sen.paper rolls, w<=15cm, sh.w<=360mm','Papel sop.p/papel fotosen.bobinas, l<=15cm, hjs.l<=360mm',10,'48','4802','480220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48022090','Outs.papéis p/fabr.papel fotossensiv.etc.em rolos/fls.','Oth.paper forproduc.photo-sen.paper, etc.in rolls/sheets','Ots.papeles sop.p/papel fotosen.etc.en bobinas, hjs',10,'48','4802','480220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48023010','Papel para fabricação de papel-carbono, p<19g/m2','Paper forproduction of carbonising paper, w<19g/m2','Papel soporte para papel carbón, p<19g/m2',10,'48','4802','480230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48023090','Outros papéis para fabricação de papel-carbono','Other paper for production of carbonising paper','Otros papeles soporte para papel carbón',10,'48','4802','480230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48023091','Papel p/fabr.papel carbono, de pasta branq.etc','Paper forprod.of carbonis.paper, of bleached pulp, etc','Papel soporte para papel carbón, de pasta blanq.etc',10,'48','4802','480230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48023099','Outs.papéis/cartões p/fabr.de papel carbono, rolos/fls','Ot.paper/paperb.forprod.of carbonis.paper, rolls/sheets','Ots.papeles/cartones soporte p/papel carbón, bobinas/hjs',10,'48','4802','480230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48024000','Papel para fabricação de papéis de parede','Paper for production of wallpaper','Papel soporte para papeles de decorar paredes',10,'48','4802','480240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48024010','Papel p/fabr.papéis de parede, rolos l<=15cm','Paper for production of wallpaper, rolls w<=15cm','Papel soporte p/paps.de decorar paredes, bobinas l<=15cm',10,'48','4802','480240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48024090','Outs.papéis p/fabr.de papéis de parede, em rolos/fls.','Other paper for production of wallpaper, rolls/sheets','Ots.papeles soporte p/paps.de decorar paredes, bobs/hjs',10,'48','4802','480240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025100','Papel e cartão c/fibra processo mecânico<=10%, p<40g/m2','Paper/paperboard with fibre obt.mech.proc<=10%, w<40g/m2','Papel y cartón c/fibra obt.proced.mecán.<=10%, p<40g/m2',10,'48','4802','480251');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025210','Papel p/papel moeda, fibra proc.mec<=10%, 40<=p<=150g/m2','Paper forbankn.paper, fibre mec.proc<=10%, 40<=w<=150g/m2','Papel p/papel moneda, fibra proc.mec<=10%, 40<=p<=150g/m2',10,'48','4802','480252');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025220','Papel de desenho, c/fibra proc.mecan<=10%, 40<=p<=150g/m2','Drawing paper, fibre obt.mech.proc<=10%, 40<=w<=150g/m2','Papel de dibujo, c/fibra proc.mecán<=10%, 40<=p<=150g/m2',10,'48','4802','480252');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025230','Papel/cartão kraft, c/fibra proc.mec<=10%, 40<=p<=150g/m2','Kraft paper/paperb.fibre mech.proc<=10%, 40<=w<=150g/m2','Papel/cartón kraft, c/fibra proc.mec<=10%, 40<=p<=150g/m2',10,'48','4802','480252');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025290','Outs.papéis/cartões, fibra proc.mec.<=10%, 40<=p<=150g/m2','Oth.paper/paperboard, fib.mech.proc<=10%, 40<=w<=150g/m2','Ots.papeles/carts., fibra proc.mec.<=10%, 40<=p<=150g/m2',10,'48','4802','480252');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025310','Papel de desenho, c/fibra proc.mecan<=10%, p>150g/m2','Drawing paper, fibre mech.proc<=10%, w>150g/m2','Papel de dibujo, c/fibra proc.mecán<=10%, p>150g/m2',10,'48','4802','480253');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025320','Papel e cartão kraft, c/fibra proc.mecan<=10%, p>150g/m2','Kraft paper/paperb.with fibre mech.proc<=10%, w>150g/m2','Papel y cartón kraft, c/fibra proc.mecán<=10%, p>150g/m2',10,'48','4802','480253');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025390','Outs.papéis/cartões, fibra proc.mecânico<=10%, p>150g/m2','Oth.paper/paperb.with fibre mech.proc<=10%, w>150g/m2','Ots.papeles/cartones, fibra proc.mecánico<=10%, p>150g/m2',10,'48','4802','480253');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025410','Papéis c/fibra mec<=10%, p<40g/m2, rolos l<=15cm, fls, etc','Paper c/fibre mech<=10%, w<40g/m2, rol.w<=15cm, sheets, etc','Papeles c/fibra mec<=10%, p<40g/m2, bobs.l<=15cm, hjs, etc',10,'48','4802','480254');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025490','Outs.papéis/cartões c/fibra obt.proc.mec<=10%, p<40%m/2','Ot.paper/paperb.with fibre obtained<=10%, w<40%m/2','Ots.papeles/cartones c/fibra obt.proc.mec<=10%, p<40%m/2',10,'48','4802','480254');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025491','Papel fabr.d/past.branq.p<19g/m2,  p.carbono','Manufactured paper of bleached pulp w<19g/m2, carbon paper','Papel fabricado de pasta blanca p<19g/m2, p.carbono ',10,'48','4802','480254');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025499','Outs.papéis fab.obt.branq., mecânico','Other manufactured/obtained paper of bleached pulp, mechanic','Otros papeles fabricados/obtenido de pasta blanca, mecánico',10,'48','4802','480254');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025510','Papel fibra mec<=10%, 40g/m2<=p<=150g/m2, rolo l<=15cm','Paper fibre mech.<=10%, 40g/m2<=w<=150g/m2, roll w<=15cm','Papel fibra mec<=10%, 40g/m2<=p<=150g/m2, bobina l<=15cm',10,'48','4802','480255');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025591','Papel de desenho, fibr.mec<=10%, 40g/m2<=p<=150g/m2','Drawing paper, fibre mech<=10%, 40g/m2<=w<=150g/m2','Papel de dibujo, fibr.mec<=10%, 40g/m2<=p<=150g/m2',10,'48','4802','480255');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025592','Papel kraft, fibra proc.mec<=10%, 40g/m2<=p<=150g/m2','Kraft paper, fibre mech<=10%, 40g/m2<=w<=150g/m2','Papel kraft, fibra proc.mec<=10%, 40g/m2<=p<=150g/m2',10,'48','4802','480255');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025599','Outs.papéis/cartões fibra proc.mec<=10%, 40<=p<=150g/m2','Oth.paper/paperboard fibre proc.mec<=10%, 40<=w<=150g/m2','Ots.papeles/cartones fibra proc.mec<=10%, 40<=p<=150g/m2',10,'48','4802','480255');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025610','Papel fibra mec<=10%, 40<=p<=150g/m2, fls.lado<=360mm','Fibre paper mech<=10%, 40<=w<=150g/m2, sheets side<=360mm','Papel fibra mec<=10%, 40<=p<=150g/m2, hjs.lado<=360mm',10,'48','4802','480256');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025691','Papel p/ impr.papel-moeda, fibra mec<=10%, 40<=p<=150g/m2','Paper forimpr.banknote paper, fib.mec<=10%, 40<=w<=150g/m2','Papel p/imp.papel moneda, fibra mec<=10%, 40<=p<=150g/m2',10,'48','4802','480256');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025692','Papel de desenho, fibra<=10%, 40<=p<=150g/m2, l<=435x297mm','Drawing paper, fibre<=10%, 40<=w<=150g/m2, w<=435x297mm','Papel de dibujo, fibra<=10%, 40<=p<=150g/m2, l<=435x297mm',10,'48','4802','480256');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025693','Papel kraft, fibra<=10%, 40<=p<=150g/m2, l<=435x297mm','Kraft paper, fibre<=10%, 40<=w<=150g/m2, w<=435x297mm','Papel kraft, fibra<=10%, 40<=p<=150g/m2, l<=435x297mm',10,'48','4802','480256');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025699','Outs.papéis fibra<=10%, 40<=p<=150g/m2, l<=435x297mm','Oth.fibre paper<=10%, 40<=w<=150g/m2, w<=435x297mm','Ots.papeles fibra<=10%, 40<=p<=150g/m2, l<=435x297mm',10,'48','4802','480256');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025710','Outs.papéis fibra<=10%, 40<=p<=150g/m2, tiras<=15cm, etc.','Other fibre paper<=10%, 40<=w<=150g/m2, belts<=15cm, etc.','Ots.papeles fibra<=10%, 40<=p<=150g/m2, cintas<=15cm, etc.',10,'48','4802','480257');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025791','Papel p/impr.papel-moda, fibra mec<=10%40<=, p<=150g/m2','Paper forimpr.banknote paper, fib.mec<=10%, 40<=w<=150g/m2','Papel p/impr.papel moneda, fibra mec<=10%40<=, p<=150g/m2',10,'48','4802','480257');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025792','Papel de desenho, fibra mec<=10%, 40g/m2<=p<=150g/m2','Drawing paper, fibre mec<=10%, 40g/m2<=w<=150g/m2','Papel de dibujo, fibra mec<=10%, 40g/m2<=p<=150g/m2',10,'48','4802','480257');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025793','Papel kraft, fibra mec<=10%, 40g/m2<=p<=150g/m2','Kraft paper, fibre mec<=10%, 40g/m2<=p<=150g/m2','Papel kraft, fibra mec<=10%, 40g/m2<=p<=150g/m2',10,'48','4802','480257');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025799','Outs.papéis/cartões fibra mec<=10%, 40g/m2<=p<=150g/m2','Oth.paper/paperboard fibre mec<=10%, 40g/m2<=w<=150g/m2','Los dem.papeles/cart.fibra mec<=10%, 40g/m2<=p<=150g/m2',10,'48','4802','480257');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025810','Papel fibra mec<=10%, p>150g/m2, tiras/rolos l<=15cm, etc','Fibre pap.mec<=10%, w>150g/m2, belts/roll w<=150g/m2, etc','Papel fibra mec<=10%p>150g/m2, cint/bobin.p<=150g/m2, etc',10,'48','4802','480258');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025891','Papel de desenho, fibra mec<=10%, p>150g/m2','Drawing paper, fibre mec<=10%, w>150g/m2','Papel de dibujo, fibra mec<=10%, p>150g/m2',10,'48','4802','480258');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025892','Papel kraft, fibra mec<=10%, p>150g/m2','Kraft paper, fibre mec<=10%, w>150g/m2','Papel kraft, fibra mec<=10%, p>150g/m2',10,'48','4802','480258');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48025899','Outs.papéis/cartões fibra mec<=10%, p>150g/m2','Other paper/fibre paperboard mec<=10%, w>150g/m2','Los dem.papeles/cartones fibra mec<=10%, p>150g/m2',10,'48','4802','480258');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48026010','Papel e cartão, kraft, com fibra processo mecânico>10%','Kraft paper and paperboard, with fibre mech.process>10%','Papel y cartón, kraft, con fibra proceso mecánico>10%',10,'48','4802','480260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48026090','Outros papéis e cartões, com fibra processo mecânico>10%','Other paper and paperboard, with fibre mech.process>10%','Los dem.papeles y cartones, c/fibra proceso mecánico>10%',10,'48','4802','480260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48026110','Papel fibra mec>10%, em rolos l<=15cm','Paper with fibra mech.>10%, in rolls w<=15cm','Papel fibra mec>10%, en rollos l<=15cm',10,'48','4802','480261');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48026191','Papel fibra mec>65%, p<=57g/m2, em rolos','Paper with fibra mech.>65%, w<=57g/m2, in rolls','Papel fibra mec>65%, p<=57g/m2, en rollos',10,'48','4802','480261');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48026192','Papel fibra mec>10%, kraft, em rolos','Paper with fibra mech.>10%, kraft, in rolls','Papel fibra mec>10%, kraft, en bobinas',10,'48','4802','480261');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48026199','Outs.papéis/cartões fibra proc.mec>10%, em rolos','Oth.paper/paperboard fibre mech.process>10%, in rolls','Ots.papeles/cartones fibra proc.mec>10%, en bobinas',10,'48','4802','480261');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48026210','Outs.papéis fibra mec>10%, lado<=360mm','Other paper fibre mech.process>10%, side<=360mm','Ots.papeles fibra mec.>10%, lado<=360mm',10,'48','4802','480262');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48026291','Outs.papéis fibra mec>65%, p<=57g/m2','Other paper fibre mech.process>65%, w<=57g/m2','Ots.papeles fibra mec.>65%, p<=57g/m2',10,'48','4802','480262');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48026292','Outs.papéis fibra mec>10%, kraft, fls<=435mmx297mm','Oth.paper fibre mec>10%, kraft, sheets<=435mmx297mm','Ots.papeles fibra mec>10%, kraft, hjs<=435mmx297mm',10,'48','4802','480262');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48026299','Outs.papéis/cartões, fibra mec>10%, fls<=435mmx297mm','Oth.paper/paberboard, fibre mec>10%, sheets<=435mmx297mm','Ots.papeles/cartones, fibra mec>10%, hjs<=435mmx297mm',10,'48','4802','480262');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48026910','Papel fibra mec>10%, tiras l<=15cm, fls.lado<=360mm','Paper fibre mec>10%, belts w<=15cm, sheets side<=360mm','Papel fibra mec>10%, cintas l<=15cm, hjs.lado<=360mm',10,'48','4802','480269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48026991','Outs.papéis fibra mec>=65%, p<=57g/m2','Other paper fibre mech.process>=65%, w<=57g/m2','Ots.papeles fibra mec>=65%, p<=57g/m2',10,'48','4802','480269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48026992','Outs.papéis fibra mec>10%, kraft','Other paper fibre mech.process>10%, kraft','Ots.papeles fibra mec.>10%, kraft',10,'48','4802','480269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48026999','Outs.papéis/cartões, fibra mec>10%','Oth.paper/paberboard, fibre mec>10%','Ots.papeles/cartones, fibra mec.>10%',10,'48','4802','480269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48030010','Pasta de celulose e mantas de fibras de celulose','Cellulose wadding or webs of cellulose fibres','Guata de celulosa y napas de fibras de celulosa',10,'48','4803','480300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48030090','Papel p/fabr.de papel higiênicos ou de toucador, etc.','Paper kind used forhousehold or sanitary purposes.etc','Papel del tipo util.p/papel higiénico o de tocador, etc.',10,'48','4803','480300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48041100','Papel/cartão "kraftliner", p/cobertura, crus, em rolos/fls','Paper/paperb."kraftliner", forcovering, raw, rolls/sheets','Papel/cartón "kraftliner", cubiertas, crudos, en bobs/hjs',10,'48','4804','480411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48041900','Outs.papéis/cartões "kraftliner", p/cobert.em rolos/fls','Oth.paper/paperb."kraftliner", forcover., raw, rolls/sheets','Ots.papeles/cartones "kraftliner", cubiertas, en bobs/hjs',10,'48','4804','480419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48042100','Papel kraft p/sacos de gde.capacidade, cru, em rolos/fls.','Kraft paper forsack of great capacity, raw, rolls/sheets','Papel kraft p/sacos de gran capacidad, crudo, en bobs/hjs',10,'48','4804','480421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48042900','Outros papéis kraft p/sacos gde.capacidade, em rolos/fls','Oth.kraft paper forsack of great capac.raw, rolls/sheets','Otros papeles kraft p/sacos gran capacidad, en bobs/hjs',10,'48','4804','480429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48043110','Papel/cartão kraft, crus, p<=150g/m2, rigid.dieletr>=600v','Paper/kraft paperb., raw, w<=150g/m2, dielet.streng.>=600v','Papel/cartón kraft, crudos, p<=150g/m2, rig.dieléctr>=600v',10,'48','4804','480431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48043190','Outs.papéis/cartões kraft, crus, p<=150g/m2, em rolos/fls.','Oth.paper/kraft paperboard, raw<=150g/m2, rolls/sheets','Ots.papeles/cartones kraft, crudo, p<=150g/m2, en bobs/hjs',10,'48','4804','480431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48043910','Outs.papéis/cartão kraft, p<=150g/m2, rigid.dieletr>=600v','Oth.paper/kraft paperb., w<=150g/m2, dielec.streng.>=600v','Ots.papeles/cartones kraft, p<=150g/m2, rig.dieléct>=600v',10,'48','4804','480439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48043990','Outros papéis/cartões kraft, p<=150g/m2, em rolos ou folh','Oth.paper/kraft paperb., w<=150g/m2, in rolls/sheets','Otros papeles/cartones kraft, p<=150g/m2, en bobs. o hjs',10,'48','4804','480439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48044100','Papel e cartão kraft, crus, 150<p<225g/m2, em rolos/folhas','Paper/paperboard kraft, raw, 150<w<225g/m2, rolls/sheets','Papel y cartón kraft, crudos, 150<p<225g/m2, en bobs/hjs',10,'48','4804','480441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48044200','Papel kraft, branq.fibra proc.quim>95%, 150<p<=225g/m2','Kraft paper, bleach.fibre chem.proc.>95%, 150<w<=225g/m2','Papel kraft, blanq.fibra proc.quim>95%, 150<p<=225g/m2',10,'48','4804','480442');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48044900','Outs.papéis/cartões kraft, 150<p<225g/m2, em rolos/folhas','Oth.paper/kraft paperboard, 150<w<225g/m2, rolls/sheets','Ots.papeles/cartones kraft, 150<p<225g/m2, en bobs./hojas',10,'48','4804','480449');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48045100','Papel e cartão kraft, crus, p>=225g/m2, em rolos ou folhas','Paper/kraft paperb., raw, w>=225g/m2, in rolls/sheets','Papel y cartón kraft, crudos, p>=225g/m2, en bobinas o hjs',10,'48','4804','480451');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48045200','Papel/cartão kraft, branq.fibra proc.quim>95%, p>=225g/m2','Pap./kraft paperb, bleac.fibre chem.proc.>95%, w>=225g/m2','Papel/cartón kraft, blanq.fibra proc.quím>95%, p>=225g/m2',10,'48','4804','480452');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48045900','Outros papéis/cartões kraft, p>=225g/m2, em rolos ou folh','Other paper/kraft paperb.w>=225g/m2, in rolls/sheets','Otros papeles/cartones kraft, p>=225g/m2, en bobs. o hjs',10,'48','4804','480459');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48045910','Papel semibranq.kraft, fibra proc.quim.p>=225g/m2, rolos','Semi-bleached kraft paper, proc. chem. fibre w>=225g/m2,rolls','Papel semiblanc. kraft, fibra proc. quím. p>=225g/m2, en bobinas',10,'48','4804','480459');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48045990','Outros papéis/cartões kraft, p >=225g/m2, em rolos/folhas','Other paper/kraft paperboard, w>=225g/m2, rolls/sheets','Otros papeles/cartones kraft, p>=225g/m2, en bobinas/hojas',10,'48','4804','480459');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48051000','Papel semiquímico p/ondular, nao revestido, em rolos/fls.','Semi-chemical paper forcorrugated, uncoated, rolls/sheets','Papel semiquímico p/acanalar, sin recubrir, en bobs./hjs.',10,'48','4805','480510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48051100','Papel semiquim.p/ondular, n/revest.rolos/fls.','Semi-chemic.paper forcorrugated, uncoated, rolls/sheets','Papel semiquím.p/acanalar, s/recubrir, en bobinas/hjs.',10,'48','4805','480511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48051200','Papel palha p/ondular, n/revest.em rolos/fls.','Straw paper forcorrugated, uncoated, in rolls/sheets','Papel paja p/acanalar, s/recubrir, en bobinas/hjs.',10,'48','4805','480512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48051900','Outs.papéis p/ondular, n/revest.em rolos/fls.','Other paper forcorrugated, uncoated, in rolls/sheets','Ots.papeles p/acanalar, s/recubrir, en bobinas/hjs.',10,'48','4805','480519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48052100','Papel e cartão c/camadas múltiplas, branq.em rolos/fls','Multi-ply paper/paperb., bleached, rolls/sheets','Papel y cartón c/multicapas, blanq.en bobinas/hjs',10,'48','4805','480521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48052200','Papel/cartão c/camadas múltiplas, 1 camada exter.branq.','Multi-ply paper/paperb., 1 external bleached ply','Papel/cartón c/multicapas, una capa exterior blanqueada',10,'48','4805','480522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48052300','Papel/cartão c/camadas múltiplas, 2 camadas exter.branq.','Multi-ply paper/paperb., 2 external bleached ply','Papel/cartón c/multicapas, dos capas exter.blanqueadas',10,'48','4805','480523');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48052400','Papel "testliner", n/rev.rolos/fls.p<=150g/m2','Testliner paper, uncoated, in rolls/sheets, w<=150g/m2','Papel testliner, s/recubrir, bobinas/hjs.p<=150g/m2',10,'48','4805','480524');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48052500','Papel "testliner", n/rev.rolos/fls.p>150g/m2','Testliner paper, uncoated, in rolls/sheets, w>150g/m2','Papel testliner, s/recubrir, bobinas/hjs.p>150g/m2',10,'48','4805','480525');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48052900','Outs.papéis/cartões de camadas multipl.n/rev.rolos/fls.','Oth.paper/paperb.of multiple layers, uncoat.rolls/sheets','Ots.papeles/cartones de multicapas, s/recub.bobinas/hjs.',10,'48','4805','480529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48053000','Papel sulfito p/embalagem, n/revestido, em rolos/folhas','Sulphite wrapping paper, n/covered, in rolls/sheets','Papel sulfito p/envolver, s/recubrir, en bobinas/hojas',10,'48','4805','480530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48054000','Papel-filtro e cartão-filtro, n/revestidos, em rolos/fls.','Filter paper and paperboard, uncoated, in rolls/sheets','Papel y cartón filtro, s/recubrir, en bobinas/hojas',10,'48','4805','480540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48054010','Papel-filtro e cartão-filtro, fibr.copolim.acetat.vinila','Filter paper and paperboard, fibre acetate vin.copolymer','Papel y cartón filtro, fibr.copolim.acetat.vinilo',10,'48','4805','480540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48054090','Outs.papel-filtro e cartão-filtro, n/revest.em rolos/fls','Other filter paper/paperboard, uncoated, in rolls/sheets','Ots.papel y cartón filtro, s/recubrir, en bobinas/hjs',10,'48','4805','480540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48055000','Papel-feltro, cartão-feltro e papel/cartão lanosos, etc.','Felt paper and paperb.and woolly paper and paperb., etc','Papel y cartón fieltro; papel y cartón lana, etc.',10,'48','4805','480550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48056000','Outs.papéis e cartões, n/revest.em rolos/fls.p<=150g/m2','Oth.paper/paperboard, uncoat.rolls/sheets w<=150g/m2','Ots.papeles y cartones, s/recubr.en bobs./fls.p<=150g/m2',10,'48','4805','480560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48057010','Papel/cartão c/fibra de vidro, 150<p<225g/m2, rolos/fls.','Paper/paperboard with fiberglass, 150<w<225g/m2, rolls/sh','Papel/cartón c/fibra de vidrio, 150<p<225g/m2, bobs./hjs.',10,'48','4805','480570');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48057090','Outs.papéis/cartões, n/revest.em rolos/fls.150<p<225g/m2','Oth.paper/paperboard, uncoat.rolls/sheets 150<w<225g/m2','Ots.papeles/cartones, s/recubr.en bobs/hjs.150<p<225g/m2',10,'48','4805','480570');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48058000','Outs.papéis/cartões, p>=225g/m2, n/revest.em rolos/folhas','Oth.paper/paperboard, w<225g/m2, uncoat.rolls/sheets','Ots.papeles/cartones, p>=225g/m2, s/recubr.en bobinas/hjs',10,'48','4805','480580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48059100','Outs.papéis/cartões n/rev.rolos/fls.p<=150g/m2','Oth.paper/paperb.n/covered, in rolls/sheets w<=150g/m2','Ots.papeles/cartones s/recubrir, bobinas/hjs.p<=150g/m2',10,'48','4805','480591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48059210','Papel com fibras de vidro, 150<p<225g/m2','Paper with fiberglass, 150<w<225g/m2','Papel con fibras de vidrio, 150<p<225g/m2',10,'48','4805','480592');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48059290','Outs.papéis n/revest.rolos/fls.150<p<225g/m2, rolos/fls','Oth.paper uncoated rolls/sh.150<w<225g/m2, rolls/sheets','Ots.papeles s/recubr.bobs/hjs.150<p<225g/m2, bobinas/hjs',10,'48','4805','480592');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48059300','Outs.papéis/cartões n/revest.rolos/fls.p>225g/m2','Oth.paper/paperboard uncoated rolls/sheets w>225g/m2','Ots.papeles/cartones s/recubrir, bobinas/hjs.p>225g/m2',10,'48','4805','480593');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48061000','Papel-pergaminho e cartão-pergaminho, em rolos ou folhas','Vegetable parchm.and paperboard parchment, rolls/sheets','Papel y cartón sulfurizados(pergam.veg.), en bobs. o hjs',10,'48','4806','480610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48062000','Papel impermeável a gorduras, em rolos ou em folhas','Greaseproof papers, in rolls or sheets','Papel resistente a las grasas, en bobinas o en hojas',10,'48','4806','480620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48063000','Papel vegetal, em rolos ou em folhas','Tracing papers, in rolls or sheets','Papel vegetal, en bobinas o en hojas',10,'48','4806','480630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48064000','Papel cristal/outs.papéis calandrados, etc.em rolos/fls.','Glassine and other glazed papers, etc.in rolls/sheets','Papel cristal/ots.papeles calandrados, etc.en bobs./hjs.',10,'48','4806','480640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48070000','Papel/cartão obt.colagem fls.sobrepost.n/rev.rolos/fls.','Comp.paper/paperb.(made stick.flat layers)unc.rolls/sh','Papel/cartón obt.por pegado hjs.planas, s/rec.bobs/hjs.',10,'48','4807','480700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48071000','Papel e cartão estratif.c/betume, etc.n/revest.em rolos, ','Stratified paper/paperb.with bitumen, etc.unc.rolls, ','Papel y cartón unidos c/betún, etc.s/recubr.en bobs.',10,'48','4807','480710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48079000','Outs.papéis/cartões da colag.de fls.n/revest.rolos/fls.','Ot.comp.paper/paperb.(made stick.flat layers)unc.rolls, ','Ots.papeles/cartones de pegado de hjs.s/recub.bobs/hjs.',10,'48','4807','480790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48081000','Papel e cartão ondulados, mesmo perfurados, em rolos/fls.','Conr.paper/paperboard, incl.perforated, in rolls/sheets','Papel y cartón corrugs., incluso perforados, en bobs/hjs',10,'48','4808','480810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48082000','Papel kraft p/sacos gde.capac.encrespado, etc.rolos/fls.','Kraft parer forsack great capac.creped, etc.rolls/sheets','Papel kraft p/sacos gran capac.rizado, etc.bobinas/hjs',10,'48','4808','480820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48083000','Outs.papéis kraft, encrespados/plissados, etc.rolos/fls.','Other kraft paper, creped or crinkled, etc.rolls/sheets','Ots.papeles kraft, rizados/plisados, etc.bobinas/hjs.',10,'48','4808','480830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48084000','Papeis kraft,encrespados/plissados,mês.gof.est.ou per.','Kraft paper, creped/crinkled','Papel kraft, rizado/arrugado',10,'48','4808','480840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48089000','Outs.papéis/cartões ondulados/encrespados, etc.rolos/fls','Other paper/paperb.wavy/creped, etc.rolls/sheets','Ots.paps/carts corrugados, rizados/plisados, etc.bobs/hjs',10,'48','4808','480890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48091000','Papel-carbono e semelhs.em rolos ou em folhas','Carbon paper or similar, in rolls and sheets','Papel carbón y similares, en bobinas o en hojas',10,'48','4809','480910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48092000','Papel autocopiativo, em rolos ou em folhas','Self-copy paper, in rolls and sheets','Papel autocopia, en bobinas o en hojas',10,'48','4809','480920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48099000','Outros papéis p/copia ou duplicacao, em rolos ou folhas','Other paper forcopies or duplication, in rolls and sheets','Ots.papeles p/copiar o transferir, en bobinas o en hojas',10,'48','4809','480990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101100','Papel p/escrever, etc.fibra proc.mec<=10%, p<=150g/m2','Paper forwriting, etc.fibre mec.proc.<=10%, w<=150g/m2','Papel p/escribir, etc.fibra proc.mec<=10%, p<=150g/m2',10,'48','4810','481011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101210','Papel/cartão, metaliz.fibra proc.mec<=10%, p>150g/m2, etc.','Metall.paper/paperb.fibre mech.proc<=10%, w>150g/m2, etc','Papel/cartón, metaliz.fibra proc.mec<=10%, p>150g/m2, etc',10,'48','4810','481012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101220','Papel/cartão, baritado, fibra proc.mec<=10%, p>150g/m2, etc','Baryta paper/paperb., fibre mech.proc<=10%, w>150g/m2, etc','Papel/cartón, baritado, fibra proc.mec<=10%, p>150g/m2, etc',10,'48','4810','481012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101290','Outs.papéis p/escrita, etc.fibra proc.mec<=10%, p>150g/m2','Oth.paper forwriting, etc.fibre mech.proc<=10%, w>150g/m2','Ots.papeles p/escrib., etc.fibra proc.mec<=10%, p>150g/m2',10,'48','4810','481012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101310','Papel/cartão p/escrita, etc.fibra<=10%, rolos l<=15cm','Paper/paperboard forwriting, etc.fibre<=10%, rolls w<=15cm','Papel/cartón p/escribir, etc.fibra<=10%, bobinas l<=15cm',10,'48','4810','481013');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101381','Papel/cartão metalizado, fibra<=10%, rolos/fls.p>150g/m2','Metal.paper/paperb., fibre<=10%, rolls/sheets w>150g/m2','Papel/cartón metalizado, fibra<=10%, bobs./hjs.p>150g/m2',10,'48','4810','481013');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101382','Papel/cartão baritado, fibra<=10%, rolos/fls.p>150g/m2','Baryta paper/paperb., fibre<=10%, rolls/sheets w>150g/m2','Papel/cartón baritado, fibra<=10%, bobinas/hjs.p>150g/m2',10,'48','4810','481013');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101389','Outs.papéis p/escrita, etc.fibra<=10%, rolos, p>150g/m2','Other paper forwriting, etc.fibre<=10%, rolls w>150g/m2','Ots.papeles p/escribir, etc.fibra<=10%, bobinas, p>150g/m2',10,'48','4810','481013');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101390','Outs.papéis p/escrita, etc.fibra<=10%, em rolos','Other paper forwriting, etc.fibre<=10%, in rolls','Ots.papeles p/escribir, etc.fibra<=10%, en bobinas',10,'48','4810','481013');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101410','Papel p/escrita, etc.fibra<10%, fls, lado<=360mm','Paper forwriting, etc.fibre<10%, sheets, side<=360mm','Papel p/escribir, etc.fibra<10%, hjs, lado<=360mm',10,'48','4810','481014');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101481','Papel metalizado, fibra<=10%, p>150g/m2, fls<=435x297mm','Metallized paper, fibre<=10%, w>150g/m2, sheets<=435x297mm','Papel metalizado, fibra<=10%, p>150g/m2, hjs<=435x297mm',10,'48','4810','481014');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101482','Papel baritado, fibra<=10%, p>150g/m2, fls.lado<=435x297mm','Baryta paper, fibre<=10%, w>150g/m2, sheet, side<=435x297mm','Papel baritado, fibra<=10%, p>150g/m2, hjs.lado<=435x297mm',10,'48','4810','481014');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101489','Outs.papéis escrit.etc.fibra<=10%, p>150g/m2, fl<=435x297','Oth.paper forwrit.etc.fib.<=10%, w>150g/m2, sheet<=435x297','Ots.papeles escrib.etc.fibra<=10%, p>150g/m2, hj<=435x297',10,'48','4810','481014');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101490','Outs.papéis p/escrita, etc.fibra<=10%, fls<=435x297mm','Oth.paper forwrit.etc.fibre<=10%, sheets<=435x297mm','Ots.papeles p/escribir, etc.fibra<=10%, hjs<=435x297mm',10,'48','4810','481014');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101910','Outs.papéis escrit.etc.fibra<=10%, tira l<=15cm, fl<360mm','Ot.paper forwrit.etc.fibre<=10%, strip w<=15cm, sh.<360mm','Ots.papeles escrib.etc.fibra<=10%, tira a<=15cm, hj<360mm',10,'48','4810','481019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101981','Outs.papéis metalizados, p>150g/m2, fibra<=10%','Oth.metallized paper, w>150g/m2, fibre<=10%','Ots.papeles metalizados, p>150g/m2, fibra<=10%',10,'48','4810','481019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101982','Outs.papéis baritados, p>150g/m2, fibra<=10%','Other baryta paper, w>150g/m2, fibre<=10%','Ots.papeles baritados, p>150g/m2, fibra<=10%',10,'48','4810','481019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101989','Outs.papéis/cartões p/escrita, etc.p>150g/m2, fibra<=10%','Oth.paper/paperb.forwriting etc.w>150g/m2, fibre<=10%','Ots.papeles/cartones p/escrib., etc.p>150g/m2, fibra<=10%',10,'48','4810','481019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48101990','Outs.papéis/cartões p/escrita, etc.fibra mecan<=10%','Oth.paper/paperb.forwriting etc.mechanical fibre<=10%','Ots.papeles/cartones p/escribir, etc.fibra mecán<=10%',10,'48','4810','481019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48102100','Papel cuche leve, util.p/escrita, etc.fibra proc.mec>10%','Light weight coat.paper used forwrit.etc.fib.mec>10%','Papel cuché leve, util.p/escribir, etc.fibra proc.mec>10%',10,'48','4810','481021');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48102210','Papel cuche leve, fibra>10%, tiras/rolos l<=15cm, fls<=360','Light weight coat.paper, fib.>10%, w<=15cm, strip/sh.<=360','Papel cuché lig., fibra>10%, tiras/bobs.a<=15cm, hjs<=360',10,'48','4810','481022');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48102290','Outs.papéis cuche leve, fibra mecan>10%','Other light weight coat.paper, fibre mechan.process>10%','Ots.papeles cuché ligero, fibra mecán.>10%',10,'48','4810','481022');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48102900','Outs.papéis/cartões, p/escrita, etc.fibra proc.mecan>10%','Oth.paper/paperboard, forwriting, etc.fib.mech.proc>10%','Ots.papeles/cartones, p/escrib., etc.fibra proc.mecán>10%',10,'48','4810','481029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48102910','Papel escrita, etc.fibra>10%, tira/rolo l<=15cm, fls<=360m','Paper forwrit.etc.fibre>10%, strip/roll w<=15cm, sh.<=360m','Papel p/escr., etc.fibra>10%, tira/bob.a<=15cm, hjs<=360m',10,'48','4810','481029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48102990','Outs.papéis/cartões p/escrita, etc.fibra mecan>10%, rolos','Oth.paper/paperb.forwriting, etc.fibre mech.>10%, rolls','Ots.papeles/cartones p/escribir, etc.fibra mec>10%, bobs.',10,'48','4810','481029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48103100','Papel/cartão kraft, branq.fibra proc.quim>95%, p<=150g/m2','Kraft paper/paperb, bleac.fibre proc.chem>95%, w<=150g/m2','Papel/cartón kraft, blanq.fibra proc.quím>95%, p<=150g/m2',10,'48','4810','481031');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48103110','Papel kraft branq.p<=150g/m2, fibra quim>95%, rolo l<=15c','Kraft paper, blea.w<=150g/m2, chem.fibre>95%, roll w<=15cm','Papel kraft blanq.p<=150g/m2, fibra quím>95%, bob.a<=15cm',10,'48','4810','481031');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48103190','Outs.papéis kraft, p<=150g/m2, fibra quim>95%, rolo l<=15c','Oth.kraft paper, w<=150g/m2, chem.fibre>95%, roll w<=15cm','Ots.papeles kraft, p<=150g/m2, fibra quím>95%, bob.a<=15cm',10,'48','4810','481031');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48103200','Papel/cartão kraft, branq.fibra proc.quim>95%, p>150g/m2','Paper/kraft card, bleac.proc.fibre chem.>95%, w>150g/m2','Papel/cartón kraft, blanq.fibra proc.quím>95%, p>150g/m2',10,'48','4810','481032');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48103210','Papel kraft branq.p>150g/m2, rolos l<=15cm','Kraft bleac.paper w>150g/m2, rolls w<=15cm','Papel kraft blanq.p>150g/m2, bobinas a<=15cm',10,'48','4810','481032');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48103290','Outs.papéis kraft, p>150g/m2, fibra quim>95%, rolos l<=15c','Oth.kraft papers, w>150g/m2, chem.fibre>95%, rolls w<=15cm','Ots.papeles kraft, p>150g/m2, fibra quím>95%, bobs.a<=15cm',10,'48','4810','481032');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48103900','Outros papéis/cartões kraft, revest.caulim, etc.rolos/fls','Oth.kraft papers/paperb., coated, kaolin, etc.rolls/sheets','Ots.paps./cartones kraft, estucados caolín, etc.bobs/hjs',10,'48','4810','481039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48103910','Outs.papéis/cartões kraft, rolos l<=15cm, fls l<=360mm','Oth.kraft papers/paperb.rolls w<=15cm, sheets w<=360mm','Ots.papeles/cartones kraft, bobinas a<=15cm, hjs l<=360mm',10,'48','4810','481039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48103990','Outs.papéis/cartões kraft, exc.para escrita, etc.','Oth.kraft papers/paperb., exc.for writing, etc.','Ots.papeles/cartones kraft, exc.para escribir, etc.',10,'48','4810','481039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48109100','Outs.papéis/cartões, camadas multipl.revest.em rolos/fls','Oth.papers/paperb.multiple layers, in rolls/sheets','Ots.papeles/cartones, multicapa, estucados, en bobinas/hjs',10,'48','4810','481091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48109210','Papéis de camada multipla, tira/rolo l<=15cm, fls<=360mm','Multi-ply paper, strip/roll w<=15cm, sheet<=360mm','Papeles de multicapa, tira/bobina a<=15cm, hjs<=360mm',10,'48','4810','481092');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48109290','Outs.papéis de camada multipla, revest.caulim, rolos/fls','Oth.multi-ply paper, coated with kaolin, rolls/sheets','Ots.papeles de multicapa, estucado c/caolín, bobinas/hjs',10,'48','4810','481092');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48109900','Outros papéis/cartões, revest.caulim, etc.em rolos/folhas','Other paper/paperb., coated with kaolin, etc.rolls/sheets','Ots.papeles/cartones, estucad.caolín, etc.en bobinas/hjs',10,'48','4810','481099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48109910','Outs.papéis, revest.caulim, tira/rolo l<=15cm, fls<=360mm','Other paper, coated, kaolin, strip/roll<=15cm, sheets<=360mm','Ots.papeles, estucad.caolín, tira/bob.a<=15cm, hjs<=360mm',10,'48','4810','481099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48109990','Outs.papéis/cartões, revest.caulim, em rolos/fls.','Oth.paper/paperboard, coated, kaolin, in rolls/sheets','Ots.papeles/cartones, estucados c/caolín, en bobinas/hjs.',10,'48','4810','481099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48111000','Papel e cartão alcatroados, betuminados, etc.em rolos, fls','Tarred, bituminised, etc.paper/paperboard, in rolls, sheets','Papel y cartón alquitr., embetunados, etc.en bobinas, hjs',10,'48','4811','481110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48111010','Papel de celulose alcatroado, etc.tira/rolo l<=15cm, fls','Paper of cellulose tarred, etc.strip/roll w<=15cm, sheets','Papel de celulosa alquitran., etc.tira/bob.a<=15cm, hjs',10,'48','4811','481110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48111090','Outs.papéis de celulose alcatroados, betumin.etc.rolos/','Other tarred cellulose paper, bitumised, etc.rolls/sheet','Ots.papeles de celulosa alquitranados, embetun.etc.bobs.',10,'48','4811','481110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48112100','Papel e cartão auto-adesivos, em rolos ou em folhas','Paper/paperboard self-adhesive, in rolls or sheets','Papel y cartón autoadhesivos, en bobinas o en hojas',10,'48','4811','481121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48112900','Outs.papéis e cartões gomados/adesivos, em rolos/folhas','Other gummed paper/paperb./self-adhesive, in rolls/sheets','Ots.papeles y cartones engomados/adhesivos, en bobs./hjs',10,'48','4811','481129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48113111','Papel/cartão branq.revest.silicone, p>150g/m2, rolos/fls.','Paper/paperboard bleach.coat.silicon, w>150g/m2, rolls/sh','Papel/cartón blanq.revest.silicona, p>150g/m2, bobs./hjs',10,'48','4811','481131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48113112','Papel branq.rev.polietileno estrat.alum.p>150g/m2, impr.','Paper bleach.coat.stratif.polyet.alum.w>150g/m2, printed','Papel blanq.rev.polietileno estrat.alum.p>150g/m2, impr.',10,'48','4811','481131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48113113','Papel branq.rev.polietileno, etc.p>150g/m2, p/papel foto','Paper bleach.coat.polyeth.w>150g/m2, forphot.base paper','Papel blanq.rev.polietileno, etc.p>150g/m2, p/papel foto',10,'48','4811','481131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48113119','Papel/cartão branq.rev.out.plástico, p>150g/m2, rolos/fls','Paper/paperb.bleach.coat.oth.plastic, w>150g/m2, rolls/sh','Papel/cartón blanq.rev.ot.plástico, p>150g/m2, bobs./hjs',10,'48','4811','481131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48113120','Papel/cartão branq.impregn.plástico, p>150g/m2, rolos/fls','Paper/paperb.bleach.plastic impreg., w>150g/m2, rolls/sh','Papel/cartón blanq.impregn.plástico, p>150g/m2, bobs./hjs',10,'48','4811','481131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48113911','Outs.papéis rev.polietileno, etc.p/papel foto, rolos/fls.','Oth.paper coated, polyeth.etc.forphot.base paper, rolls/sh','Ots.papeles rev.polietileno, etc.p/papel foto, bobs./hjs',10,'48','4811','481139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48113912','Outs.papéis/cartões, revest.de silicone, em rolos/folhas','Oth.paper/paperb.coated of silicon, rolls/sheets','Ots.papeles/cartones, revest.de silicona, en bobinas/hjs',10,'48','4811','481139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48113913','Outs.papéis/cartões, rev.polietileno, estrat.alumin.impr.','Oth.paper/paperb.coated polyeth.strat.alum.printed','Ots.papeles/cartones, rev.polietileno, estrat.alum.impr.',10,'48','4811','481139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48113919','Papel/cartão revest.de outros plásticos, em rolos/folhas','Paper/paperb.coated of oth.plastic, in rolls/sheets','Papel/cartón revest.de otros plásticos, en bobinas/hojas',10,'48','4811','481139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48113920','Outros papéis/cartões impregns.de plástico, em rolos/fls','Oth.paper/paperboard impreg.of plastic, in rolls/sheets','Otros papeles/cartoes impregns.de plástico, en bobs./hjs',10,'48','4811','481139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48114000','Papel/cartão revest/impregn.cera, parafina, etc.rolos/fls','Paper/paperb.coated/impreg.wax, paraf.etc.rolls/sheets','Papel/cartón revest/impregn.cera, parafina, etc.bobs./hjs',10,'48','4811','481140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48114110','Papel/cartão auto-adesiv.tiras/rolo l<=15cm, fls<=360mm','Paper/paperb.self-adhesive strip/roll w<=15cm, sh<=360mm','Papel/cartón autoadhesiv.tiras/bob.a<=15cm, hjs<=360mm',10,'48','4811','481141');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48114190','Outs.papéis/cartões auto-adesivos, em rolos/fls.','Other paper/paperboard self-adhesive, in rolls/sheets','Ots.papeles/cartones autoadhesivos, en bobinas/hjs.',10,'48','4811','481141');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48114910','Outs.papéis/cartões adesiv.tira/rolo l<=15cm','Other paper/paperboard self-adhesive, strip/roll w<=15cm','Ots.papeles/cartones adhesiv.tira/bob. a<=15cm',10,'48','4811','481149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48114990','Outs.papéis/cartões gomados/adesivos, em rolos/fls','Oth.gummed/adhesive paper and paperboard, rolls/sheets','Ots.papeles/cartones engomados/adhesivos, en bobinas/hjs',10,'48','4811','481149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48115110','Papel branq.revest.etc.plast.p>150g/m2, tira l<=15cm, fl','Paper bleac.coat.etc.plast.w>150g/m2, strip w<=15cm, sh','Papel blanq.revest.etc.plást.p>150g/m2, tira a<=15cm, hj',10,'48','4811','481151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48115121','Papel branq.revest.etc.silicone, p>150g/m2, rolos/fls.','Paper bleac.coat.etc.silicone, w>150g/m2, rolls/sheets','Papel blanq.revest.etc.silicona, p>150g/m2, bobinas/hjs',10,'48','4811','481151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48115122','Papel branq.revest.etc.poliet.estrat.alumin.p>150g/m2','Paper bleac.coat.etc. stratif.polyet.alumin.w>150g/m2','Papel blanq.revest.etc.poliet.estrat.alumin.p>150g/m2',10,'48','4811','481151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48115123','Papel branq.revest.etc.polietileno/poliprop, p>150g/m2','Paper bleac.coat.etc.polyethylene/polyprop, w>150g/m2','Papel blanq.revest.etc.polietileno/poliprop, p>150g/m2',10,'48','4811','481151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48115128','Outros papéis gofrados na face recoberta ou revestida','Outros papéis gofrados na face recoberta ou revestida','Outros papéis gofrados na face recoberta ou revestida',10,'48','4811','481151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48115129','Outs.papéis/cartões branq.revest.etc.plast.p>150g/m2','Oth.paper/paperb.bleac.coat.etc.plast.w>150g/m2','Ots.papeles/cartones blanq.revest.etc.plást.p>150g/m2',10,'48','4811','481151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48115130','Outs.papéis/cartões branq.impregn.plástico, p>150g/m2','Oth.paper/paperb.bleac.impregn.plastic, w>150g/m2','Ots.papeles/cartones blanq.impregn.plástico, p>150g/m2',10,'48','4811','481151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48115910','Outs.papéis revest.etc.plast.tiras/rolos l<=150g/m2','Oth.paper coated etc.plast.strips/rolls w<=150g/m2','Ots.papeles revest.etc.plást.tiras/bobinas a<=150g/m2',10,'48','4811','481159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48115921','Outs.papéis revest.etc.polietileno/polipropileno, rolos/','Oth.paper coat.etc.polyethylene/polypropylene, rolls/','Ots.papeles revest.etc.polietileno/polipropileno, bobina',10,'48','4811','481159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48115922','Outs.papéis revest.etc.de silicone, em rolos/fls.','Other paper coated etc.of silicone, in rolls/sheets','Ots.papeles revest.etc.de silicona, en bobs./hjs.',10,'48','4811','481159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48115923','Outs.papéis revest.etc.polietileno, estrat.alumin.rolos/','Oth.paper coat.etc.polyethylene, stratif.alum.rolls/','Ots.papeles revest.etc.polietileno, estrat.alumin.bobina',10,'48','4811','481159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48115929','Outs.papéis/cartões recob/revest.outs.plásticos, rolos/','Oth.paper/paperb.covered/coat.oth.plastics, rolls/','Ots.papeles/cartones recub/revest.ots.plásticos, bobinas',10,'48','4811','481159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48115930','Outs.papéis impregnados de plásticos em rolos/fls.','Other paper impregnated of plastics in rolls/sheets','Ots.papeles impregnados de plásticos en bobinas/hjs.',10,'48','4811','481159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48116010','Papel revest.cera, etc.tiras/rolos l<=15cm, fls<=360mm','Paper coated.wax, etc.strips/rolls w<=15cm, sheets<=360mm','Papel revest.cera, etc.tiras/bobinas a<=15cm, hjs<=360mm',10,'48','4811','481160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48116090','Outs.papéis recob.revest.impregn.cera, etc.em rolos/fls','Oth.paper cover.coat.impreg.wax, etc.in rolls/sheets','Ots.papeles recub.revest.impreg.cera, etc.en bobinas/hjs',10,'48','4811','481160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48119000','Outros papéis/cartões/pasta e mantas de fibras celulose','Oth.paper/paperb./wadding/webs of cellulose fibres','Ots.papeles/cartones/guata y napas de fibras celulosa',10,'48','4811','481190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48119010','Outs.papéis de celulose revest.etc.tiras/rolos l<=15cm','Oth.paper of cellulose covered.etc.strips/rolls w<=15cm','Ots.papeles de celulosa revest.etc.tiras/bobs. a<=15cm',10,'48','4811','481190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48119090','Outs.papéis de celulose revest.impreg.etc.em rolos/fls','Oth.paper of cellulose covered impreg.etc.rolls/sheets','Ots.papeles de celulosa revest.impreg.etc.en bobs./hjs.',10,'48','4811','481190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48120000','Blocos e chapas, filtrantes, de pasta de papel','Filter blocks, slabs and plates, of paper pulp','Bloques y placas, filtrantes, de pasta de papel',10,'48','4812','481200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48131000','Papel para cigarros, em cadernos ou em tubos','Cigarette paper, in the form of booklets or tubes','Papel de fumar, en librillos o en tubos',10,'48','4813','481310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48132000','Papel para cigarros, em rolos de largura<=5cm','Cigarette paper, in rolls of width<=5cm','Papel de fumar, en bobinas de anchura<=5cm',10,'48','4813','481320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48139000','Outros papéis para cigarros','Other papers for cigarettes','Otros papeles para fumar',10,'48','4813','481390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48141000','Papel denominado "ingrain"','"ingrain" paper','Papel granito (ingrain)',10,'48','4814','481410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48142000','Papel de parede, revest.de plástico granida, etc.decorado','Wallpaper, cover.of grained, plast.etc.decoration','Papel p/decorar, revest.de plást.graneada, etc.decorado',10,'48','4814','481420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48143000','Papel de parede, revest.de matérias p/entrançar','Wallpaper, covered with plaiting material','Papel p/decorar, revest.con materias trenzables',10,'48','4814','481430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48149000','Outs.papéis de parede/revestim.paredes, papel p/vitrais','Oth.wallpaper/covered walls, windows transpar.of paper','Ots.papeles de parede/revest.paredes, papel p/vidrieras',10,'48','4814','481490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48150000','Revestimentos p/pavimentos, c/suporte de papel/de cartão','Floor coverings on a base of paper or of paperboard','Cubresuelos con soporte de papel o de cartón',10,'48','4815','481500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48161000','Papel-carbono e semelhs.mesmo em caixas','Carbon paper and similar even in boxes','Papel carbón y papeles similares, incluso en cajas',10,'48','4816','481610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48162000','Papel autocopiativo, mesmo em caixas','Self-copy paper, whether or not in boxes','Papel autocopia, incluso en cajas',10,'48','4816','481620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48163000','Estenceis completos','Duplicator stencils','Clisés de mimeógrafo ("stencils") completos',10,'48','4816','481630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48169000','Outs.papéis p/copia/duplicacao e chapas ofsete, de papel','Oth.paper for copy/duplication and foils  offset, of paper','Ots.papeles p/copia/transf.y planchas offset, de papel',10,'48','4816','481690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48169010','Papel-carbono e semelhantes mmo em caixas','Carbon paper and similar even in boxes','Papel carbón y papeles similares, incluso en cajas',10,'48','4816','481690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48169090','Outs.papéis autocop., estênceis, chap.offset','Oth.paper for copy/duplication and foils  offset','Otros papéis autocop., estênceis, chap.offset',10,'48','4816','481690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48171000','Envelopes de papel ou cartão','Envelopes of paper or paperboard','Sobres de papel o cartao',10,'48','4817','481710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48172000','Aerogramas, bilhetes-postais n/ilustr.cartões p/corresp.','Letter cards, plain postcards n/illust.correspond.cards','Sobrecartas, tarjs.postales s/ilustr.tarjetas p/corresp.',10,'48','4817','481720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48173000','Caixas, etc.de papel/cartão, cont.sortido artig.p/corresp','Boxes, etc.of paper/paperb., c/assort.corresp.articles','Cajas, etc.de papel/cartón, cont.surtido artíc.de corresp',10,'48','4817','481730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48181000','Papel higiênico','Toilet paper','Papel higiénico',10,'48','4818','481810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48182000','Lenços e toalhas de mão, de papel','Handkerchiefs and hand towels, of paper','Pañuelos y toallas de mano, de papel',10,'48','4818','481820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48183000','Toalhas e guardanapos, de papel, de mesa','Tablecloths and serviettes, of paper','Manteles y servilletas, de papel, de mesa',10,'48','4818','481830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48184010','Fraldas de papel','Diapers of paper','Pañales de papel',10,'48','4818','481840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48184020','Tampões higiênicos, de papel','Hygienic tampons, of paper','Tampones higiénicos, de papel',10,'48','4818','481840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48184090','Absorventes e outros artigos higiênicos, de papel','Sanitary towels and other hygienic articles, of paper','Compresas y otros artículos higiénicos, de papel',10,'48','4818','481840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48185000','Vestuário e seus acessórios, de papel','Clothing and their accessories, of paper','Prendas de vestir y sus complementos, de papel',10,'48','4818','481850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48189000','Outs.artigos de papel, p/uso sanitario/doméstico/hospit.','Other articles of paper, for sanitary/domestic/hospital use','Otros artículos de papel, para uso sanitario/doméstico/hospitalar',10,'48','4818','481890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48189010','Almofadas absorv.util.embalagens de prods.alimenticios','Absorbent pads of a kind used in packing foodstuffs','Alfombras absorb.util.envases de prods.alimenticios',10,'48','4818','481890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48189090','Outs.artigos de papel, p/uso sanitario/doméstico/hospit.','Oth.articles of paper, foruse sanitary/domestic/hospit','Ots.artículos de papel, p/uso sanitario/doméstico/hospit',10,'48','4818','481890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48191000','Caixas de papel ou cartão, ondulados (canelados)','Boxes of paper/paperboard, corrugated','Cajas de papel o cartón, corrugados',10,'48','4819','481910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48192000','Caixas e cartonagens, dobraveis, de papel/cartão, n/ondul.','Folding cartons, boxes, of non-corrugated paper/paperb.','Cajas y cartonajes, plegables, de papel/cartón, s/corrug.',10,'48','4819','481920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48193000','Sacos de papel ou cartão, cuja largura da base>=40cm','Sacks of paper/paperb., having a base of a width>=40cm','Sacos de papel o cartón, c/una anchura en la base>=40cm',10,'48','4819','481930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48194000','Outros sacos, bolsas e cartuchos, de papel ou cartão','Other sacks, bags, cones, of paper/paperboard','Otros sacos, bolsitas y cucuruchos, de papel o cartón',10,'48','4819','481940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48195000','Outs.embalagens de papel ou cartão, incl.capas p/discos','Oth.packing contain.of paper/paperb.incl.record sleeves','Ots.envases de papel o cartón, incl.las fundas p/discos',10,'48','4819','481950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48196000','Cartonagens p/escritórios, lojas e estabelecim.semelhs.','Box files/silmilar articl.foroffices, stor.sim.establishm','Cartonajes de oficina, tienda o similares',10,'48','4819','481960');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48201000','Livros de registro, de contabilidade, blocos de notas, etc','Registers, account books, note books, etc','Libros registro, de contabilidad, bloques de notas, etc',10,'48','4820','482010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48202000','Cadernos','Exercise books','Cuadernos',10,'48','4820','482020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48203000','Classificadores, capas p/encadernação, de papel ou cartão','Binders, of paper/paperboard','Clasificadores, encuadernaciones, de papel o cartón',10,'48','4820','482030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48204000','Formularios em blocos "manifold", mesmo c/papel-carbono','Manifold business ("manifold"), even with carbon paper','Formuls.en paquete ("manifold"), aunque lleven p.carbón',10,'48','4820','482040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48205000','Álbuns para amostras ou coleções, de papel ou cartão','Albums for samples or for collections, of paper/paperb.','Álbumes para muestras o colecciones, de papel o cartón',10,'48','4820','482050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48209000','Outs.artigos de papel/cartão, p/escritório/papelaria, etc','Oth.articles of paper/paperb., foroffice/stationery, etc','Ots.artícs.de papel/cartón, de oficina/papelería, etc',10,'48','4820','482090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48211000','Etiquetas de papel ou cartão, impressas','Labels paper or paperboard, printed','Etiquetas de papel o cartón, impresas',10,'48','4821','482110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48219000','Outras etiquetas de papel ou cartão','Other labels of paper or paperboard','Otras etiquetas de papel o cartón',10,'48','4821','482190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48221000','Carreteis, bobinas, etc.de papel/cartão, p/fios têxteis','Bobbins, rolls, etc.of paper/paperb., fortextile yarn','Carretes, bobinas, etc.de papel/cartón, de hilados texts.',10,'48','4822','482210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48229000','Carreteis, bobinas, etc.de papel/cartão, p/outros usos','Bobbins, rolls, etc.of paper/paperb., forother uses','Carretes, bobinas, etc.de papel/cartón, p/otros usos',10,'48','4822','482290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48231100','Papel auto-adesivo, em tiras ou em rolos','Self-adhesive paper, in strips or rolls','Papel autoadhesivo, en tiras o en bobinas',10,'48','4823','482311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48231200','Papel de celulose, auto-adesivo, em tiras/rolos','Cellulose paper, self-adhesive, in strips/rolls','Papel de celulosa, autoadhesivo, en tiras/bobinas',10,'48','4823','482312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48231900','Outros papéis gomados ou adesivos, em tiras ou em rolos','Other gummed or adhesivos paper, in strip/rolls','Otros papeles engomados o adhesivos, en tiras o en bobs.',10,'48','4823','482319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48232000','Papel-filtro e cartão-filtro','Filter paper and paperboard','Papel y cartón filtro',10,'48','4823','482320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48232010','Papel-filtro, etc.15g/m2<p<=25g/m2, fibr.copol.acet.vinil','Filter paper, etc.15g/m2<w<=25g/m2, fibr.copol.acet.vinyl','Papel filtro, etc.15g/m2<p<=25g/m2, fibr.copol.acet.vinil',10,'48','4823','482320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48232090','Outs.papel-filtro e cartão-filtro, em tiras ou em rolos','Oth.filter paper/paperboard, in strips/rolls','Ots.papel y cartón filtro, en tiras o en bobinas',10,'48','4823','482320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48232091','Papel filtro, de celulose, tira/rolo 15<l<=36cm','Filter paper, of cellulose, strip/roll 15<w<=36cm','Papel filtro, de celulosa, tira/bobina 15<l<=36cm',10,'48','4823','482320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48232099','Outs.papéis filtro/cartão filtro, de celulose','Filter paper and paperboard, of cellulose','Ots.papeles/cartón filtro, de celulosa',10,'48','4823','482320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48234000','Papel-diagrama p/apars.registradores, em bobinas/fls, etc','Diagram paper forrecording apparels, in rolls/sheets, etc','Papel diagrama p/apars.registradores, en bobinas/hjs, etc',10,'48','4823','482340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48235100','Papel/cartão p/escrita, etc.impressos/estampados/perfur.','Paper/paperboard forwriting etc.printed/perforated','Papel/cartón p/escrit., etc.impresos/estampados/perfor.',10,'48','4823','482351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48235900','Outros papéis/cartões p/escrita/impressão/fins graficos','Oth.paper/paperb.forwriting etc.printed/graphic uses','Otros papeles/cartones p/escrit./impres./fines graficos',10,'48','4823','482359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48236000','Bandejas, travessas, pratos, xícaras, etc.de papel/cartão','Trays, dishes, plates, cups, etc.of paper/paperboard','Bandejas, fuentes, platos, tazas, etc.de papel/cartón',10,'48','4823','482360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48236100','Bandejas, traves.prat.xíc.etc.de de bambu','Trays, dishes, plates, cups, etc.of bamboo','Bandejas, fuentes, platos, tazas, etc.de bambu',10,'48','4823','482361');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48236900','Outs.bandejas, traves.prat.etc.de pap./cartão','Other trays, dishes, plates, cups, etc.of paper/kraft','Otras bandejas, fuentes, platos, tazas, etc.de papel/cartón',10,'48','4823','482369');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48237000','Artigos moldados ou prensados, de pasta de papel','Moulded or pressed articles of paper pulp','Artículos moldeados o prensados, de pasta de papel',10,'48','4823','482370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48239010','Cartões perfurados para mecanismos "jacquard"','Perforated cards for jacquard machines','Cartones perforados para mecanismos "jacquard"',10,'48','4823','482390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48239020','Papel e cartão, de rigidez dielétrica>=600v, p<=60g/m2','Paper/paperb., of a dieletric strength>=600v, w<=60g/m2','Papel y cartón, de rigidez dieléctrica>=600v, p<=60g/m2',10,'48','4823','482390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48239090','Outros papéis/cartões/pastas/etc.cortados e suas obras','Other paper, paperboard/pulp/etc.cut and their works','Otros papeles/cartones/pastas/etc.cortados y sus manuf.',10,'48','4823','482390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48239091','Outs.papéis, etc.de celulose, rolos 15<l<=36cm','Oth.paper, etc.of cellulose, rolls 15<w<=36cm','Ots.papeles, etc.de celulosa, bobinas 15<l<=36cm',10,'48','4823','482390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('48239099','Outs.papéis, cartões de celulose e outs.obras de papel','Oth.paper, paperb.of cellulose and oth.articles of paper','Ots.papeles, cartones de celulosa y ots.manufac.de papel',10,'48','4823','482390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49011000','Livros, brochuras, impressos semelhantes, em folhas soltas','Books, brochures, similar printed papers, in single sheets','Libros, folletos, impresos similares, en hojas sueltas',10,'49','4901','490110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49019100','Dicionarios e enciclopedias, mesmo em fasciculos','Dictionaries and encyclopaedias, serial instalm.thereof','Diccionarios y enciclopedias, incluso en fascículos',10,'49','4901','490191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49019900','Outros livros, brochuras e impressos semelhantes','Oth.printed books, brochures and similar printed','Otros libros, folletos y impresos similares',10,'49','4901','490199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49021000','Jornais e publicações, impressos, periodo>=4 vezes/semana','Newspapers, journals, printed, periodical>=4 times/week','Diarios y publicaciones, impresos, periodo>=4 vezes/sem.',10,'49','4902','490210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49029000','Outros jornais e publicações periodicas, impressos','Other newspapers and journals, periodicals, printed','Otros diarios y publicaciones periódicas, impresos',10,'49','4902','490290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49030000','Albuns ou livros de ilustracoes, etc.para crianças','Drawing or colouring books, etc.for children','Álbumes o libros de estampas, etc.para niños',10,'49','4903','490300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49040000','Musica manuscrita ou impressa, ilustrada ou nao','Music, printed or in manuscript, whether or not illustrat','Música manuscrita o impresa, incluso con ilustraciones',10,'49','4904','490400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49051000','Globos (obra cartográfica, impressa)','Globes (cartographic work, printed)','Esferas (manufactura cartográfica, impresa)',10,'49','4905','490510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49059100','Obras cartográficas, impressas em livros ou brochuras','Cartographic work, printed in books or brochures','Manufacts.cartográficas, impresas en libros o folletos',10,'49','4905','490591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49059900','Outras obras cartográficas, impressas','Other cartographic work, printed','Otras manufacturas cartográficas, impresas',10,'49','4905','490599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49060000','Planos, plantas, desenhos, de arquitetura, etc.feitos a mão','Plans and drawings for architectural, etc.drawn by hand','Planos, dibujos, de arquitectura, etc.hechos a mano',10,'49','4906','490600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49070010','Papel-moeda','Banknote','Billetes de banco',10,'49','4907','490700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49070020','Cheques de viagem','Travel checks','Cheques de viajero',10,'49','4907','490700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49070030','Titulos de açoes, obrigacoes, etc.convalidados/assinados','Stock, share, bond certificates, etc.of title, compl./valid','Titulos de acciones, obrigs., etc.convalidados/firmados',10,'49','4907','490700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49070090','Selos postais, fiscais, etc.n/obliterados, c/curso legal','Unused postage, revenue, etc.n/obliter.with leg.course','Selos de correos, timbres fisc, etc.s/oblit, c/curso legal',10,'49','4907','490700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49081000','Decalcomanias vitrificáveis','Decalcomanias, vitrifiable','Calcomanías vitrificables',10,'49','4908','490810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49089000','Outras decalcomanias de qq.especie','Other decalcomanias of any species','Otras calcomanías de cualquier clase',10,'49','4908','490890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49090000','Cartões-postais impressos ou ilustrados, etc.','Printed or illustrated postcards','Tarjetas postales impresas o ilustradas, etc',10,'49','4909','490900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49100000','Calendarios impressos, incl.blocos-calendarios p/desfolh','Calendars of any kind, printed, incl.calendar blocks','Calendarios impresos, incluidos los tacos de calendario',10,'49','4910','491000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49111010','Impressos publicit/catalogos comals.(manuais técnicos)','Trade advert.material/commer.catalog(technical manuals)','Impresos publicit/catálogos comercs.(manuales técnicos)',10,'49','4911','491110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49111090','Outros impressos publicitarios/catalogos comerciais, etc','Other trade advertising material/commer.catalogues, etc','Otros impresos publicitarios/catálogos comerciales, etc',10,'49','4911','491110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49119100','Estampas, gravuras e fotografias','Prints, engravings and pictures','Estampas, grabados y fotografías',10,'49','4911','491191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('49119900','Outros impressos','Other printed matter','Otros impresos',10,'49','4911','491199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('50010000','Casulos de bicho-da-seda, próprios para dobar','Silkworm cocoons suitable for reeling','Capullos de seda, aptos para el devanado',10,'50','5001','500100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('50020000','Seda crua (não fiada)','Raw silk (not thrown)','Seda cruda (sin torcer)',10,'50','5002','500200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('50030010','Desperdícios de seda, não cardados, não penteados','Silk waste, not carded or combed','Desperdicios de seda, sin cardar ni peinar',10,'50','5003','500300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('50030090','Outros desperdícios de seda','Other silk wastes','Otros desperdicios de seda',10,'50','5003','500300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('50031000','Desperdícios de seda, não cardados, nem penteados','Silk waste, not carded or combed','Desperdicios de seda, sin cardar ni peinar',10,'50','5003','500310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('50039000','Outros desperdícios de seda','Other silk wastes','Otros desperdicios de seda',10,'50','5003','500390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('50040000','Fios de seda','Silk yarn','Hilados de seda',10,'50','5004','500400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('50050000','Fios de desperdícios de seda','Yarn spun from silk waste','Hilados de desperdicios de seda',10,'50','5005','500500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('50060000','Fios de seda/seus desperds,  pelo messina,  p/vda.retalho','Silk yarn/its waste, by messina, f/retail sale','Hilados de seda/sus desps, pelo mesina, p/vta al p/menor',10,'50','5006','500600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('50071010','Tecidos de "bourrette" de seda,  estampados,  tintos,  etc.','Fabrics of noil silk, printed, dyed, etc.','Tejidos de borrilla de seda, estampados, teñidos, etc.',10,'50','5007','500710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('50071090','Outros tecidos de "bourrette" de seda','Other fabrics of noil silk','Otros tejidos de borrilla de seda',10,'50','5007','500710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('50072010','Tecidos de seda/desperds.(conteudo>=85%),  estampados,  etc','Fabrics of silk/waste(cont.>=85%), printed, etc','Tejidos de seda/despers.(contenido>=85%), estampados, etc',10,'50','5007','500720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('50072090','Outros tecidos de seda/desperds.de seda (conteudo>=85%)','Other fabrics of silk/waste of silk(containing>=85%)','Otros tejidos de seda/desperds.de seda (contenido>=85%)',10,'50','5007','500720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('50079000','Outros tecidos de seda ou de desperdícios de seda','Other fabrics of silk or of waste of silk','Otros tejidos de seda o de desperdicios de seda',10,'50','5007','500790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51011110','Lã de tosquia,  suja,  n/cardada,  etc.22.05<=f<=32.6microns','Shorn wool, dirty, n/carded, etc.22.05<=f<=32.6micr.','Lana esquilada, sucia, s/cardar, etc.22.05<=f<=32.6micr.',10,'51','5101','510111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51011190','Outras lãs de tosquia,  sujas,  não cardadas nem penteadas','Other shorn wool, dirty, n/carded or combed','Otras lanas esquiladas, sucias, sin cardar ni peinar',10,'51','5101','510111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51011900','Outras lãs sujas, não cardadas nem penteadas','Other woll, dirty, neither carded nor combed','Otras lanas sucias, sin cardar ni peinar',10,'51','5101','510119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51012100','Lã de tosquia,  desengord.n/carboniz.n/cardada,  n/penteada','Shorn wool, degreased, n/carbonised, n/carded, n/combed','Lana esquilada, desgrasada, s/carboniz.s/cardar ni peinar',10,'51','5101','510121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51012900','Outras lãs desengord.n/carboniz.n/cardadas,  n/penteadas','Other wool, degreased, n/carbonised, n/carded, n/combed','Otras lanas desgrasadas, s/carboniz.s/cardar n/peinar',10,'51','5101','510129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51013000','Lã desengordurada, carbonizada, não cardada nem penteada','Degreased woll, carbonised, n/carded, n/combed','Lana desgrasada, carbonizada, sin cardar ni peinar',10,'51','5101','510130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51021000','Pêlos finos, não cardados nem penteados','Fine or coarse animal hair, not carded or combed','Pelos finos, sin cardar ni peinar',10,'51','5102','510210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51021100','Pêlos finos,  de cabra de cachemira,  não cardados','Fine animal hair, of kashmir(cashmere)goats n/combed','Pelos finos, de cabra de cachemira, sin cardar',10,'51','5102','510211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51021900','Outros pêlos finos,  não cardados nem penteados','Other fine animal hair, n/combed n/combed','Otros pelos finos, sin cardar ni peinar',10,'51','5102','510219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51022000','Pelos grosseiros,  não cardados nem penteados','Coarse animal hair, n/combed or combed','Pelos ordinarios, sin cardar ni peinar',10,'51','5102','510220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51031000','Desperdícios da penteacao de lã ou de pêlos finos','Waste of combed of woll or of fine animal hair','Borras del peinado de lana o pelo fino',10,'51','5103','510310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51032000','Outros desperdícios de lã ou de pêlos finos','Other waste of woll or of fine animal hair','Los demás desperdicios de lana o pelo fino',10,'51','5103','510320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51033000','Desperdícios de pelos grosseiros','Waste of coarse animal hair','Desperdicios de pelo ordinario',10,'51','5103','510330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51040000','Fiapos de lã ou de pêlos finos ou grosseiros','Garnetted stock or of fine or coarse animal hair','Hilachas de lana o pelo fino u ordinario',10,'51','5104','510400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51051000','Lã cardada','Carded wool','Lana cardada',10,'51','5105','510510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51052100','Lã penteada a granel','Combed wool in fragments','Lana peinada a granel',10,'51','5105','510521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51052910','Tops de lã penteada','Tops of combed wool','Tops de lana peinada',10,'51','5105','510529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51052991','Outras lãs penteadas,  de finura<22.5 micrometros','Other combed wool, of thinness<22.5 micrometers','Otras lanas peinadas, de finura<22.5 micrómetros',10,'51','5105','510529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51052999','Outras lãs penteadas','Other combed wool','Otras lanas peinadas',10,'51','5105','510529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51053000','Pêlos finos, cardados ou penteados','Fine animal hair, carded or combed','Pelos finos, cardados o peinados',10,'51','5105','510530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51053100','Pêlos finos,  de cabra de cachemira,  carcad.pent','Fine animal hair, of kashmir(cashmere)goat, carded/combed','Pelos finos, de cabra de cachemira, cardados o peinados',10,'51','5105','510531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51053900','Outros pêlos finos, cardados ou penteados','Other fine animal hair, carded or combed','Otros pelos finos, cardados o peinados',10,'51','5105','510539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51054000','Pelos grosseiros, cardados ou penteados','Coarse fine animal hair, carded or combed','Pelos ordinarios, cardados o peinados',10,'51','5105','510540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51061000','Fios de lã cardada (conteudo>=85%)','Yarn of carded wool(contaning>=85%)','Hilados de lana cardada (contenido>=85%)',10,'51','5106','510610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51062000','Fios de lã cardada (conteudo<85%)','Yarn of carded wool(contaning>=85%)','Hilados de lana cardada (contenido<85%)',10,'51','5106','510620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51071011','Fios de lã penteada(>=85%),  retorcid.2 cabos,  t<=184.58d','Yarn of combed woll(>=85%), twis.2 cables, t<=184.58d','Hilados de lana pein.(>=85%), retorc.2 cabos, t<=184.58d',10,'51','5107','510710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51071019','Outros fios de lã penteada (conteudo>=85%),  retorcidos','Oth.yarn of combed woll(cont.>=85%), twisted','Otros hilados de lana peinada (cont.>=85%), retorcidos',10,'51','5107','510710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51071090','Outros fios de lã penteada (conteudo>=85%)','Other yarn of combed woll (containig>=85%)','Otros hilados de lana peinada (contenido>=85%)',10,'51','5107','510710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51072000','Fios de lã penteada (conteudo<85%)','Yarn of combed wool (containing<85%)','Hilados de lana peinada (contenido<85%)',10,'51','5107','510720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51081000','Fios de pêlos finos, cardados','Yarn of fine animal hair, carded','Hilados de pelos finos, cardados',10,'51','5108','510810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51082000','Fios de pêlos finos, penteados','Yarn of fine animal hair, combed','Hilados de pelos finos, penteados',10,'51','5108','510820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51091000','Fios de lã/pêlos finos(peso>=85%la/pêlos),  p/vda.retalho','Yarn of wool/fine an.hair(w>=85%wool/an.hair), ret.sale','Hilads.de lana/pelos finos(peso>=85%lana/pelos), v.menor',10,'51','5109','510910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51099000','Fios de lã/pêlos finos(peso< 85%la/pêlos),  p/vda.retalho','Yarn of wool/fine an.hair(w<85%wool/an.hair), ret.sale','Hilads.de lana/pelos finos(peso<85%lana/pelos), v.menor',10,'51','5109','510990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51100000','Fios de pêlos grosseiros ou de crina','Yarn of coarse animal hair or of horsehair','Hilados de pelos ordinarios o de crin',10,'51','5110','511000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51111110','Tecido de lã cardada (conteudo>=85%), peso<=300g/m2','Woven fabrics of carded(containing>=85%), weig.<=300g/m2','Tejidos de lana cardada (contenido>=85%), peso<=300g/m2',10,'51','5111','511111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51111120','Tecidos de pêlos finos (conteudo>=85%), peso<=300g/m2','Fabrics of fine animal hair(com.>=85%), weight<=300g/m2','Tejidos de pelos finaos (contenido>=85%), peso<=300g/m2',10,'51','5111','511111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51111900','Outs.tecido de lã/pêlos finos, cardados (conteudo>=85%)','Oth.fabrics wool/fine animal hair, carded(contain.>=85%)','Ots.tejidos de lana/pelos finos, cardados (cont.>=85%)',10,'51','5111','511119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51112000','Tecido de lã/pêlos finos, cardados,  com filam.sint/artif','Fabric of wool/fine anim.hair, card.c/filam.synt/artif','Tejido de lana/pelos finos, cardados, c/filam.sint/artif',10,'51','5111','511120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51113010','Tecido de lã, card.feltrad.c/fibra sint.etc.p/bola tenis','Fabric of wool, card.afieltr.c/synt.fibre etc.p/pels.tem','Tejido de lana, card.afieltr.c/fibra sint.etc.p/pels.ten',10,'51','5111','511130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51113090','Outs.tecido de lã/pêlos finos,  card.c/fibra sint/artif.','Ot.fabrics of wool/fine animal hair, card.c/fib.syn/art','Ots.tejidos de lana/pelos finos, card.c/fibra sint/artif',10,'51','5111','511130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51119000','Outros tecido de lã ou de pêlos finos,  cardados','Other fabrics of wool or of fine animal hair, carded','Otros tejidos de lana o  pelos finos, cardados',10,'51','5111','511190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51121100','Tecido de lã/pêlos finos,  pentead.(cont>=85%),  p<=200g/m2','Combed fabr.of wool/fine anim.hair(con>=85%), w<=200g/m2','Tejido de lana/pelos finos, pein.(cont>=85%), p<=200g/m2',10,'51','5112','511211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51121910','Outros tecido de lã penteada (conteudo>=85%)','Other fabrics of combed wool (cont>=85%)','Otros tejidos de lana peinada (contenido>=85%)',10,'51','5112','511219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51121920','Outros tecidos de pêlos finos (conteudo>=85%)','Other fabrics of fine animal hair (cont>=85%)','Otros tejidos de pelos finos (contenido>=85%)',10,'51','5112','511219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51122010','Tecido de lã penteada,  com filamentos sintéticos/artif.','Fabric of combed wool, with filaments synthet./artif.','Tejido de lana peinada, con filamentos sintéticos/artif.',10,'51','5112','511220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51122020','Tecido de pêlos finos penteados com filam.sintet/artif.','Fabric combed fine anim.hair, with filaments synt/artif','Tejido de pelos finos peinados con filam.sintét/artif.',10,'51','5112','511220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51123010','Tecido de lã penteada,  com fibras sintet/artif.descont.','Fabric of combed wool, with fibres synt/discont.artif.','Tejido de lana peinada, con fibras sintét/artif.discont.',10,'51','5112','511230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51123020','Tecido de pêlos finos,  com fibras sintet/artif.descont.','Fabric of combed fine anim.hair, with fibres syn/dis.art','Tejido de pelos finos, con fibras sintét/artif.discont.',10,'51','5112','511230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51129000','Outros tecido de lã ou de pêlos finos,  penteados','Oth.fabrics of comb.wool or of combed fine animal hair','Los demás tejidos de lana o pelos finos, peinados',10,'51','5112','511290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51130011','Tecidos de pêlos grosseiros (conteudo>=85%)','Woven fabrics of coarse animal hair(content>=85%)','Tejidos de pelos ordinarios (contenido>=85%)',10,'51','5113','511300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51130012','Tecidos de pêlos grosseiros (conteudo<85%),  com algodão','Woven fabrics of coarse anim.hair(content>=85%)with cot','Tejidos de pelos ordinarios (contenido<85%), con algodón',10,'51','5113','511300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51130013','Tecidos de pêlos grosseiros (conteudo<85%),  sem algodão','Woven fabr.of coarse anim.hair(content>=85%)without cot','Tejidos de pelos ordinarios (contenido<85%), sin algodón',10,'51','5113','511300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('51130020','Tecidos de crina','Fabrics of horsehair','Tejidos de crin',10,'51','5113','511300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52010010','Algodão não debulhado, não cardado nem penteado','Cotton, not carded or combed','Algodón sin desmotar, sin cardar ni peinar','21','52','5201','520100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52010020','Algodão simplesmente debulhado,  não cardado nem penteado','Ginned, not carded or combed','Algodón simplemente desmotado, sin cardar ni peinar','21','52','5201','520100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52010090','Outros tipos de algodão não cardado nem penteado','Other types of cotton, not carded or combed','Los demás tipos de algodón sin cardar ni peinar','21','52','5201','520100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52021000','Desperdícios de fios de algodão','Yarn waste of cotton','Desperdicios de hilados de algodón',10,'52','5202','520210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52029100','Fiapos de algodão','Garnetted stock of cotton','Hilachas de algodón',10,'52','5202','520291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52029900','Outros desperdícios de algodão','Other cotton waste','Otros desperdicios de algodón',10,'52','5202','520299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52030000','Algodão cardado ou penteado','Cotton, carded or combed','Algodón cardado o peinado',10,'52','5203','520300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52041111','Linha para costura, de algodão cru>=85%,  tit<=5000d,  cabo=2','Sewing thread, of raw cotton>=85%, tit.<=5000d, cable=2','Hilo de coser, de algodón crudo>=85%, tít.<=5000d, cabo=2',10,'52','5204','520411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52041112','Linha para costura,  de algodão cru>=85%,  tit<=5000d,  cabo>=3','Sewing thread, of raw cotton>=85%, tit.<=5000d, cable>=3','Hilo de coser, de algodón crudo>=85%, tít.<=5000d, cabo=3',10,'52','5204','520411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52041120','Linha para costura, de algodão cru>=85%,  tit>5000decitex','Sewing thread, of raw cotton>=85%, tit.>5000dec.','Hilo de coser, de algodón crudo>=85%, tít.>5000dec.',10,'52','5204','520411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52041131','Linha para costura, algodão>=85%,  branq/cor,  t<=5000d,  cabo=2','Cotton sewin.thread>=85%, bleac/colours, t<=5000d, cable=2','Hilo coser, de alg.crudo>=85%, blanq/col., t<=5000d, cabo=2',10,'52','5204','520411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52041132','Linha para costura, algodão>=85%,  branq/cor,  t<=5000d,  cabo>=3','Cotton sewin.thread>=85%, bleac/colours, t<=5000d, cable>=','Hilo coser, de alg.crudo>=85%, blanq/col, t<=5000d, cabo>=3',10,'52','5204','520411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52041140','Linha para costura,  de algodão>=85%,  branqueado/cor,  t>5000d','Cotton sewing thread>=85%, bleach./colours, t>5000d','Hilo de coser, de alg.crudo>=85%, blanq/coloreado, t>5000d',10,'52','5204','520411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52041911','Outras linhas p/costura,  algodão cru,  tit<=5000dec.cabo=2','Other sewing thread, of raw cotton, tit<=5000dec.cable=2','Ots.hilos de coser, de algodón crudo, tít<=5000dec.cabo=2',10,'52','5204','520419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52041912','Outs.linhas p/costura,  algodão cru,  tit<=5000dec.cabo>=3','Other sewing thread, of raw cotton, tit<=5000dec.cable>=3','Ots.hilos de coser, de algodón crudo, tít<=5000dec.cabo=3',10,'52','5204','520419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52041920','Outras linhas p/costura,  algodão cru,  tit>5000decitex','Other sewing thread, of raw cotton, tit<=5000dec.','Ots.hilos de coser, de algodón crudo, tít<=5000dec.',10,'52','5204','520419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52041931','Outs.linhas p/costura,  algodão branq/cor,  t<=5000d,  cabo=2','Ot.sewing thread, of cotton bleac/col.t<=5000d, cable=2','Ots.hilos de coser, de algodón blanq/col, t<=5000d, cabo=2',10,'52','5204','520419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52041932','Outs.linhas p/costura,  algod.branq/cor,  t<=5000d,  cabo>=3','Ot.sewing thread, of cotton bleac/col.t<=5000d, cable>=3','Ots.hilos de coser, de algod.blanq/col, t<=5000d, cabo>=3',10,'52','5204','520419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52041940','Outs.linhas p/costura,  de algodão branqueado/cor,  t>5000d','Other sewing thread,  of cotton bleac/col.t>5000d','Ots.hilos de coser, de algodón blanq/coloreado, t<=5000d',10,'52','5204','520419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52042000','Outras linhas p/costura,  de algodão,  para venda a retalho','Ot.sewing thread, of cotton bleac/colours f/retail sale','Ots.hilos de coser, de algodón,  p/la venta al por menor',10,'52','5204','520420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52051100','Fio algodão>=85%, simples, fibra n/pent.tit>=714.29d','Cotton yarn>=85%, simple, fibre n/combed tit>=714.29d','Hilado algodón>=85%, sencillos, fibra s/pein.tít>=714.29d',10,'52','5205','520511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52051200','Fio algodão>=85%,  simples,  fibra n/pent.232.56<=t<714.29d','Cotton yarn>=85%, simple, fibr.n/combed.232.56<=t<714.29d','Hilado algod.>=85%, sencs., fibr.s/pein.232.56<=t<714.29d',10,'52','5205','520512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52051310','Fio algodão>=85%, cru,  simpl.fibra n/pent.192.3<=t<232.5d','Cotton yarn>=85%, raw, simple, fibr.n/com.192.3<=t<232.5d','Hilado alg.>=85%, crudo, sencs, fibr.s/pei.192.3<=t<232.5d',10,'52','5205','520513');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52051390','Outs.fios algod>=85%,  simpl.fibra n/pent.192.3<=t<232.5d','Oth.cotton yarn>=85%, simple, fibr.n/comb.192.3<=t<232.5d','Ots.hilados alg.>=85%, sencs, fibr.s/pein.192.3<=t<232.5d',10,'52','5205','520513');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52051400','Fio algodão>=85%, simples,  fibra n/pent.125d<=tit<192.31d','Cotton yarn>=85%, simple, fibr.n/comb.125d<=tit<192.31d','Hilado alg.>=85%, sencillo, fibr.s/pein.125d<=tít<192.31d',10,'52','5205','520514');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52051500','Fio algodão>=85%,  simples,  fibra n/pent.titulo<125decitex','Cotton yarn>=85%, simple, fibr.n/combed title<125dec.','Hilado algodón>=85%, sencillo, fibr.s/pein.título<125dec.',10,'52','5205','520515');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52052100','Fio algodão>=85%,  simples,  fibra pent.titulo>=714.29decit','Cotton yarn>=85%, single, comb.fibre titles>=714.29decit','Hilado algodón>=85%, sencillo, fibr.s/pein.tít>=714.29dec',10,'52','5205','520521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52052200','Fio algodão>=85%,  simples,  fibra pent.232.56d<=t<714.29d','Cotton yarn>=85%, single, combed fibre.232.56d<=t<714.29d','Hilado alg.>=85%, sencillo, fibr.pein.232.56d<=t<714.29d',10,'52','5205','520522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52052310','Fio algodão>=85%,  cru,  simpl.fibra pent.192.3d<=t<232.56d','Cotton yarn>=85%, raw, sing.combed fibr.192.3d<=t<232.56d','Hilado alg.>=85%, crudo, senc, fibr.pein.192.3d<=t<232.56d',10,'52','5205','520523');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52052390','Outs.fios algod>=85%,  simpl.fibra pent.192.3d<=t<232.56d','Oth.cotton yarn>=85%, sing.combed fib.192.3d<=t<232.56d','Ots.hilados alg.>=85%, senc, fibr.pein.192.3d<=t<232.56d',10,'52','5205','520523');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52052400','Fio algodão>=85%,  simples,  fibra pent.125d<=tit<192.31d','Cotton yarn>=85%, simple, fibr.combed.125d<=tit<192.31d','Hilado alg.>=85%, sencillo, fibr.pein.125d<=tít<192.31d',10,'52','5205','520524');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52052600','Fio algodão>=85%,  simples,  fibra pent.106.38d<=tit<125d','Cotton yarn>=85%, simple, fibr.combed.106.38d<=tit<125d','Hilado alg.>=85%, sencillo, fibr.pein.106.38d<=tít<125d',10,'52','5205','520526');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52052700','Fio algodão>=85%,  simples,  fibra pent.83.33d<=tit<106.38d','Cotton yarn>=85%, simple, fibr.combed.83.33d<=tit<106.38d','Hilado alg.>=85%, sencillo, fibr.pein.83.33d<=tít<106.38d',10,'52','5205','520527');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52052800','Fio algodão>=85%,  simples,  fibra pent.titulo<83.33decitex','Cotton yarn>=85%, simple, fibr.combed.title<83.33dec.','Hilado algodón>=85%, sencillo, fibr.pein.título<83.33dec.',10,'52','5205','520528');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52053100','Fio algodão>=85%,  retorc.fibra n/pent.titulo>=714.29dec.','Cotton yarn>=85%, twisted fibr.n/comb..title>=714.29d','Hilado algodón>=85%, retorc.fibr.s/pein.título>=714.29d',10,'52','5205','520531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52053200','Fio algodão>=85%,  retorc.fibra n/pent.232.56d<=t<714.29d','Cotton yarn>=85%, twisted fibr.n/comb.232.56d<=t<714.29d','Hilado algodón>=85%, retor.fibr.s/pei.232.56d<=t<714.29d',10,'52','5205','520532');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52053300','Fio algodão>=85%,  retorc.fibra n/pent.192.31d<=t<232.56d','Cotton yarn>=85%, twisted fibr.n/comb.192.31d<=t<232.56d','Hilado algodón>=85%, retor.fibr.s/pei.192.31d<=t<232.56d',10,'52','5205','520533');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52053400','Fio algodão>=85%,  retorc.fibra n/pent.125d<=tit<192.31d','Cotton yarn>=85%, twisted fibr.n/comb.125d<=tit<192.31d','Hilado algodón>=85%, retor.fibr.s/pein.125d<=tít<192.31d',10,'52','5205','520534');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52053500','Fio algodão>=85%,  retorc.fibra n/pent.titulo<125decitex','Cotton yarn>=85%, twisted.fibr.n/comb.title<125dec.','Hilado algodón>=85%, retorc.fibr.s/pein.título<125dec.',10,'52','5205','520535');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52054100','Fio algodão>=85%,  retorc.fibra pent.titulo>=714.29decit.','Cotton yarn>=85%, twisted.fibr.combed, title>=714.29decit','Hilado algodón>=85%, retorc.fibr.peinada, título>=714.29d',10,'52','5205','520541');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52054200','Fio algodão>=85%,  retorc.fibra pent.232.56d<=tit<714.29d','Cotton yarn>=85%, twisted.fibr.comb.232.56d<=tit<714.29d','Hilado algodón>=85%, retorc.fibr.pein.232.56d<=t<714.29d',10,'52','5205','520542');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52054300','Fio algodão>=85%,  retorc.fibra pent.192.31d<=tit<232.56d','Cotton yarn>=85%, twisted.fibr.comb.192.31d<=t<232.56d','Hilado algodón>=85%, retorc.fibr.pein.192.31d<=t<232.56d',10,'52','5205','520543');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52054400','Fio algodão>=85%,  retorc.fibra pent.125d<=titulo<192.31d','Cotton yarn>=85%, twisted.fibr.comb125d<=title<192.31d','Hilado algodón>=85%, retorc.fibr.pein.125d<=t<192.31d',10,'52','5205','520544');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52054600','Fio algodão>=85%,  retorc.fibra pent.106.38d<=titulo<125d','Cotton yarn>=85%, twisted.fibr.comb.106.38d<=title<125d','Hilado algodón>=85%, retorc.fibr.pein.106.38d<=t<125d',10,'52','5205','520546');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52054700','Fio algodão>=85%,  retorc.fibra pent.83.33d<=tit<106.38d','Cotton yarn>=85%, twisted.fibr.comb.83.33d<=tit<106.38d','Hilado algodón>=85%, retorc.fibra pein.83.33d<=t<106.38d',10,'52','5205','520547');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52054800','Fio algodão>=85%,  retorc.fibra pent.titulo<83.33decitex','Cotton yarn>=85%, twisted.fibr.comb.title<83.33decitex','Hilado algodón>=85%, retorc.fibr.pein.título<83.33d',10,'52','5205','520548');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52061100','Fio algodão<85%,  simples,  fibra n/pent.titulo>=714.29dec.','Cotton yarn<85%, simple, fibr.n/comb.title>=714.29dec.','Hilado algodón<85%, senc., fibr.s/pein.título>=714.29d',10,'52','5206','520611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52061200','Fio algodão<85%,  simples,  fibra n/pent.232.56d<=t<714.29d','Cotton yarn<85%, simple, fibr.n/comb.232.56d<=t<714.29d','Hilado algodón<85%, senc., fibr.s/pein.232.56d<=t<714.29d',10,'52','5206','520612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52061300','Fio algodão<85%,  simples,  fibra n/pent.192.31d<=t<232.56d','Cotton yarn<85%, simple, fibr.n/comb.192.31d<=t<232.56d','Hilado algodón<85%, senc., fibr.s/pein.192.31d<=t<232.56d',10,'52','5206','520613');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52061400','Fio algodão<85%,  simples,  fibra n/pent.125d<=tit<192.31d','Cotton yarn<85%, simple, fibr.n/comb.125d<=tit<192.31d','Hilado algodón<85%, senc., fibr.s/pein.125d<=tít<192.31d',10,'52','5206','520614');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52061500','Fio algodão<85%,  simples,  fibra n/pent.titulo<125decitex','Cotton yarn<85%, simple, fibr.n/comb.title<125decitex','Hilado algodón<85%, senc., fibr.s/pein.título<125decitex',10,'52','5206','520615');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52062100','Fio algodão<85%,  simples,  fibra pent.titulo>=714.29decit.','Cotton yarn<85%, simple, fibr.comb.title>=714.29decit.','Hilado algodón<85%, senc., fibr.pein.título>=714.29dec.',10,'52','5206','520621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52062200','Fio algodão<85%,  simples,  fibra pent.232.56d<=tit<714.29d','Cotton yarn<85%, simple, fibr.comb.232.56d<=tit<714.29d','Hilado algodón<85%, senc., fibr.pein.232.56d<=tít<714.29d',10,'52','5206','520622');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52062300','Fio algodão<85%,  simples,  fibra pent.192.31d<=tit<232.56d','Cotton yarn<85%, simple, fibr.comb.192.31d<=tit<232.56d','Hilado algodón<85%, senc., fibr.pein.192.31d<=tit<232.56d',10,'52','5206','520623');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52062400','Fio algodão<85%,  simples,  fibra pent.125d<=titulo<192.31d','Cotton yarn<85%, simple, fibr.comb.125d<=title<192.31d','Hilado algodón<85%, senc., fibr.pein.125d<=título<192.31d',10,'52','5206','520624');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52062500','Fio algodão<85%,  simples,  fibra pent.titulo<125decitex','Cotton yarn<85%, simple, fibr.comb.title<125decitex','Hilado algodón<85%, senc., fibr.pein.título<125decitex',10,'52','5206','520625');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52063100','Fio algodão<85%,  retorc.fibra n/pent.titulo>=714.29decit','Cotton yarn<85%, twisted, fibr.n/comb.title>=714.29decit','Hilado algodón<85%, retorc., fibr.s/pein.tít.>=714.29d',10,'52','5206','520631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52063200','Fio algodão<85%,  retorc.fibra n/pent.232.56d<=t<714.29d','Cotton yarn<85%, twisted, fibr.n/comb.232.56d<=t<714.29d','Hilado algod.<85%, retorc, fibr.s/pein.232.56d<=t<714.29d',10,'52','5206','520632');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52063300','Fio algodão<85%,  retorc.fibra n/pent.192.31d<=t<232.56d','Cotton yarn<85%, twisted, fibr.n/comb.192.31d<=t<232.56d','Hilado algod.<85%, retorc, fibr.s/pein.192.31d<=t<232.56d',10,'52','5206','520633');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52063400','Fio algodão<85%,  retorc.fibra n/pent.125d<=tit<192.31d','Cotton yarn<85%, twisted, fibr.n/comb.192.31d<=t<232.56d','Hilado algod.<85%, retorc, fibr.s/pein.125d<=tít<192.31d',10,'52','5206','520634');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52063500','Fio algodão<85%,  retorc.fibra n/pent.titulo<125decitex','Cotton yarn<85%, twisted, fibr.n/comb.title<125decitex','Hilado algod.<85%, retorc., fibr.s/pein.título<125decitex',10,'52','5206','520635');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52064100','Fio algodão<85%,  retorc.fibra pent.titulo>=714.29decitex','Cotton yarn<85%, twisted, fibr.combed tit>=714.29decitex','Hilado algod.<85%, retorc., fibr.pein.título>=714.29dec.',10,'52','5206','520641');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52064200','Fio algodão<85%,  retorc.fibra pent.232.56d<=tit<714.29d','Cotton yarn<85%, twisted, fibr.comb.232.56d<=tit<714.29d','Hilado algod.<85%, retorc, fibr.pein.232.56d<=tít<714.29d',10,'52','5206','520642');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52064300','Fio algodão<85%,  retorc.fibra pent.192.31d<=tit<232.56d','Cotton yarn<85%, twisted, fibr.comb.192.31d<=tit<232.56d','Hilado algod.<85%, retorc, fibr.pein.192.31d<=tít<232.56d',10,'52','5206','520643');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52064400','Fio algodão<85%,  retorc.fibra pent.125d<=titulo<192.31d','Cotton yarn<85%, twisted, fibr.comb.125d<=title<192.31d','Hilado algod.<85%, retorc, fibr.pein.125d<=título<192.31d',10,'52','5206','520644');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52064500','Fio algodão<85%,  retorc.fibra pent.titulo<125decitex','Cotton yarn<85%, twisted, fibr.comb.title<125decitex','Hilado algod.<85%, retorc, fibr.pein.título<125decitex',10,'52','5206','520645');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52071000','Fio algodão>=85%, para venda a retalho','Cotton yarn>=85%, for retail sale','Hilados de algodón>=85%, para la venta al por menor',10,'52','5207','520710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52079000','Outros fios de algodão, para venda a retalho','Other cotton yarns, for retail sale','Ots.hilados de algodón, para la venta al por menor',10,'52','5207','520790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52081100','Tecido de algodão>=85%, cru, ponto tafeta, p<=100g/m2','Fabric of cotton>=85%, raw, point taffeta, w<=100g/m2','Tejido de algodón>=85%, crudo, ligam.tafetán, p<=100g/m2',10,'52','5208','520811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52081200','Tecido de algodão>=85%,  cru,  ponto tafeta,  100<p<=200g/m2','Fabric of cotton>=85%, raw, point taff.100<w<=200g/m2','Tejido de algodón>=85%, crudo, lig.tafetán, 100<p<=200g/m2',10,'52','5208','520812');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52081300','Tecido de algodão>=85%, cru, ponto sarjado, p<=200g/m2','Fabric of cotton>=85%, raw, point twill, w<=200g/m2','Tejido de algodón>=85%, crudo, lig.sarga, p<=200g/m2',10,'52','5208','520813');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52081900','Outros tecidos de algodão>=85%, cru, peso<=200g/m2','Other fabrics of cotton>=85%, raw, weight<=200g/m2','Ots.tejidos de algodón>=85%, crudo, p<=200g/m2',10,'52','5208','520819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52082100','Tecido de algodão>=85%, branq.pto.tafeta, p<=100g/m2','Fabric of cotton>=85%, bleach.point taff.w<=100g/m2','Tejido de algodón>=85%, blanq, lig.tafetán, p<=100g/m2',10,'52','5208','520821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52082200','Tecido de algodão>=85%, branq.pto.tafeta, 100<p<=200g/m2','Fabric of cotton>=85%, bleach.point taff.100<w<=200g/m2','Tejido de algodón>=85%, blanq, lig.tafetán, 100<p<=200g/m2',10,'52','5208','520822');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52082300','Tecido de algodão>=85%, branq.pto.sarjado, p<=200g/m2','Fabric of cotton>=85%, bleach.poin twill, w<=200g/m2','Tejido de algodón>=85%, blanq, lig.sarga, p<=200g/m2',10,'52','5208','520823');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52082900','Outros tecidos de algodão>=85%, branqueado, p<=200g/m2','Other fabrics of cotton>=85%, bleac., w<=200g/m2','Ots.tejidos de algodón>=85%, blanqueados, p<=200g/m2',10,'52','5208','520829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52083100','Tecido de algodão>=85%,  tinto,  pto.tafeta,  p<=100g/m2','Fabric of cotton>=85%, dyed, point taff.w<=100g/m2','Tejidos de algodón>=85%, teñidos, lig.tafetán, p<=100g/m2',10,'52','5208','520831');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52083200','Tecido de algodão>=85%,  tinto,  pto.tafeta,  100<p<=200g/m2','Fabric of cotton>=85%, dyed, point taff.100<w<=200g/m2','Tejidos de alg.>=85%, teñidos, lig.tafetán, 100<p<=200g/m2',10,'52','5208','520832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52083300','Tecido de algodão>=85%,  tinto,  pto.sarjado,  p<=200g/m2','Fabric of cotton>=85%, dyed, point twill, w<=200g/m2','Tejidos de algodón>=85%, teñidos, lig.sarga, p<=200g/m2',10,'52','5208','520833');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52083900','Outros tecidos de algodão>=85%,  tinto,  p<=200g/m2','Other fabrics of cotton>=85%, dyed, w<=200g/m2','Ots.tejidos de algodón>=85%, teñidos, p<=200g/m2',10,'52','5208','520839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52084100','Tecido de algodão>=85%,  fio color.pto.tafeta,  p<=100g/m2','Fabric of cotton>=85%, color.yarn, point taff.w<=100g/m2','Tejido de algodón>=85%, hil.color.lig.tafetán, p<=100g/m2',10,'52','5208','520841');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52084200','Tecido algodão>=85%,  fio color.pto.tafeta,  100<p<=200g/m2','Fabric of cotton>=85%, col.yarn, point taf.100<w<=200g/m2','Tejido de alg.>=85%, hil.color.lig.tafet., 100<p<=200g/m2',10,'52','5208','520842');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52084300','Tecido de algodão>=85%,  fio color.pto.sarjado,  p<=200g/m2','Fabric of cotton>=85%, color.yarn point twill, w<=200g/m2','Tejido de alg.>=85%, hil.color.lig.sarga, p<=200g/m2',10,'52','5208','520843');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52084900','Outros tecidos de algodão>=85%,  fio color.peso<=200g/m2','Oth.other fabrics of cotton>=85%, colour.yarn, w<=200g/m2','Ots.tejidos de alg.>=85%, hil.coloreados, p<=200g/m2',10,'52','5208','520849');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52085100','Tecido de algodão>=85%,  estampado,  pto.tafeta,  p<=100g/m2','Fabric of cotton>=85%, printed, point taffeta, w<=100g/m2','Tejido de alg.>=85%, estampado, lig.tafetán, p<=100g/m2',10,'52','5208','520851');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52085200','Tecido algodão>=85%,  estampado,  pto.tafeta,  100<p<=200g/m2','Fabric of cotton>=85%, printed, point taff.100<w<=200g/m2','Tejido de alg>=85%, estampado, lig.tafetán, 100<p<=200g/m2',10,'52','5208','520852');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52085300','Tecido de algodão>=85%,  estampado,  pto.sarjado,  p<=200g/m2','Fabric of cotton>=85%, printed, point twill, w<=100g/m2','Tejido de algodón>=85%, estampado, lig.sarga, p<=200g/m2',10,'52','5208','520853');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52085900','Outros tecidos de algodão>=85%,  estampado,  peso<=200g/m2','Other fabrics of cotton>=85%, printed, weight<=200g/m2','Ots.tejidos de algodón>=85%, estampado, p<=200g/m2',10,'52','5208','520859');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52085910','Tec.estampados pt.sarj/diag.textura < 4','Other printed fabrics, point twill, diag.texture < 4','Otros tejidos estampados, de ligamento sarga, diag.textura < 4',10,'52','5208','520859');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52085990','Outros tecidos estampados de algodão','Other printed fabrics of cotton','Otros tejidos estampados  de algodón',10,'52','5208','520859');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52091100','Tecido de algodão>=85%,  cru,  ponto de tafeta,  peso>200g/m2','Fabric of cotton>=85%, raw, point taffeta w<=200g/m2','Tejido de algodón>=85%, crudo, lig.tafetán, peso>200g/m2',10,'52','5209','520911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52091200','Tecido de algodão>=85%,  cru,  ponto sarjado,  peso>200g/m2','Fabric of cotton>=85%, raw, point twill, w<=200g/m2','Tejido de algodón>=85%, crudo, lig.sarga, peso>200g/m2',10,'52','5209','520912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52091900','Outros tecidos de algodão>=85%,  cru,  peso>200g/m2','Oth.fabrics of cotton>=85%, raw, weight>200g/m2','Ots.tejidos de algodón>=85%, crudo, peso>200g/m2',10,'52','5209','520919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52092100','Tecido de algodão>=85%,  branqueado,  pto.tafeta,  p>200g/m2','Fabric of cotton>=85%, bleached, point taffeta, w>200g/m2','Tejido de algodón>=85%, blanq, lig.tafetán, peso>200g/m2',10,'52','5209','520921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52092200','Tecido de algodão>=85%,  branqueado,  pto.sarjado,  p>200g/m2','Fabric of cotton>=85%, bleached, point twill, w>200g/m2','Tejido de algodón>=85%, blanq, lig.sarga, peso>200g/m2',10,'52','5209','520922');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52092900','Outros tecidos de algodão>=85%,  branqueado,  peso>200g/m2','Other fabrics of cotton>=85%, bleached, weight>200g/m2','Ots.tejidos de algodón>=85%, blanqueados, peso>200g/m2',10,'52','5209','520929');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52093100','Tecido de algodão>=85%,  tinto,  ponto de tafeta,  p>200g/m2','Fabric of cotton>=85%, dyed, point taffeta, weight>200g/m2','Tejido de algodón>=85%, teñido, lig.tafetán, peso>200g/m2',10,'52','5209','520931');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52093200','Tecido de algodão>=85%,  tinto,  ponto sarjado,  peso>200g/m2','Fabric of cotton>=85%, dyed, point twill, weight>200g/m2','Tejido de algodón>=85%, teñido, lig.sarga, peso>200g/m2',10,'52','5209','520932');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52093900','Outros tecidos de algodão>=85%,  tinto,  peso>200g/m2','Other fabrics of cotton>=85%, dyed, weight>200g/m2','Ots.tejidos de algodón>=85%, teñido, peso>200g/m2',10,'52','5209','520939');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52094100','Tecido de algodão>=85%,  fio color.ponto tafeta,  p>200g/m2','Fabric of cotton>=85%, color.yarn, point taf.w>200g/m2','Tejido de algodón>=85%, hil.colores, lig.tafet., p>200g/m2',10,'52','5209','520941');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52094210','Tecido de algodão>=85%,  fio color.denim,  indigo,  p>200g/m2','Fabric of cotton>=85%, col.yarn denim, indigo, w>200g/m2','Tejido de algodón>=85%, hil.color.mezclilla, peso>200g/m2',10,'52','5209','520942');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52094290','Outs.tecidos de algodão>=85%,  fio color.denin,  p>200g/m2','Other fabric of cot.>=85%, color.yarn denim, w>200g/m2','Ots.tejidos de alg.>=85%, hil.color.mezclilla, p>200g/m2',10,'52','5209','520942');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52094300','Tecido de algodão>=85%,  fio color.pto.sarjado,  p>200g/m2','Fabrics of cotton>=85%, color.yarn, point twill, w>200g/m2','Tejido de algodón>=85%, hil.color.lig.sarga, peso>200g/m2',10,'52','5209','520943');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52094900','Outros tecidos de algodão>=85%,  fio color.peso>200g/m2','Oth.fabrics of cotton>=85%, yarn colored, w>200g/m2','Ots.tejidos de algodón>=85%, hil.dist.colores, p>200g/m2',10,'52','5209','520949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52095100','Tecido de algodão>=85%,  estampado,  pto.tafeta,  p>200g/m2','Fabric of cotton>=85%, printed, point taffeta, w>200g/m2','Tejido de algodón>=85%, estampado, lig.tafetán, p>200g/m2',10,'52','5209','520951');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52095200','Tecido de algodão>=85%,  estampado,  pto.sarjado,  p>200g/m2','Fabric of cotton>=85%, printed, point twill, w>200g/m2','Tejido de algodón>=85%, estampado, lig.sarga, p>200g/m2',10,'52','5209','520952');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52095900','Outros tecidos de algodão>=85%,  estampado,  peso>200g/m2','Other fabrics of cotton>=85%, printed, weight>200g/m2','Ots.tejidos de algodón>=85%, estampado, peso>200g/m2',10,'52','5209','520959');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52101100','Tecido algodão<85%,  cru/fibra sint/art.tafeta,  p<=200g/m2','Fabric of cotton<85%, raw/fibre synt/art.taf., w<=200g/m2','Tejido algodón<85%, crudo/fibra sint/art.taf., p<=200g/m2',10,'52','5210','521011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52101200','Tecido algodão<85%,  cru/fibra sint/art.sarjad.p<=200g/m2','Fabric of cotton<85%, raw/fibre syn/art.twill, w<=200g/m2','Tejido algodón<85%, crudo/fibra sint/art.sar., p<=200g/m2',10,'52','5210','521012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52101900','Outs.tecidos algodão<85%,  cru/fibra sint/art.p<=200g/m2','Oth.fabrics of cotton<85%, raw/fibre synt/art, w<=200g/m2','Ots.tejidos algodón<85%, crudo/fibra sint/art, p<=200g/m2',10,'52','5210','521019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52101910','Tec.alg.cru,  sint.artif.pto.sarj./diag.<200g/m','Fabrics of cotton, raw, synthetic or artificial fibres, point twill, diag. <200g/m2','Tejido algodón, crudo, fibras sintéticas o artificiales, ligamento sarga, diag. <200g/m2',10,'52','5210','521019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52101990','Outs.tec.alg.crus,  sint.artificial peso>200g/m','Other fabrics of cotton, raw, sytnthtic or artifical fibres, w <= 200 g/m2','Otros tejidos de algodón, crudo, con fibras sintéticas o artificiales y de peso <= 200g/m2 ',10,'52','5210','521019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52102100','Tecido algod<85%,  branq/fibra sint/art.tafeta,  p<=200g/m2','Fabric of cot.<85%, bleac/fibre synt/art.taf., w<=200g/m2','Tejido algodón<85%, blanq/fibra sint/art.taf., p<=200g/m2',10,'52','5210','521021');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52102200','Tecido algod<85%,  branq/fibra sint/art.sarjad.p<=200g/m2','Fabric of cot.<85%, bleac/fibr.synt/art.twill, w<=200g/m2','Tejido algodón<85%, blanq/fibra sint/art.sar., p<=200g/m2',10,'52','5210','521022');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52102900','Outs.tecidos algod<85%,  branq/fibra sint/art.p<=200g/m2','Oth.fabrics of cot.<85%, bleach/fibr.synt/art, w<=200g/m2','Ots.tejidos algodón<85%, blanq/fibra sint/art, p<=200g/m2',10,'52','5210','521029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52102910','Tec.alg.branq.sint.artif.pto.sarj.diag.<200g/m','Fabrics of cotton, bleached, synthetic or artificial fibres, point twill, diag. <200g/m2','Tejidos de algodón, blanqueados, con fibras sintéticas o artificiales, ligamento sarga, diag. <200g/m2',10,'52','5210','521029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52102990','Outros tec.alg.branq.sint.artif.peso<200g/m','Other fabrics of cotton, bleached, synthetic or artificial fibres, weight<200g/m2 ','Otros tejidos de algodón, blanqueados, con fibras sintéticas o artificiales, peso<200g/m2 ',10,'52','5210','521029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52103100','Tecido algod<85%,  tinto/fibra sint/art.tafeta,  p<=200g/m2','Fabric of cotton<85%, dyed/fibr.synt/art.taf.w<=200g/m2','Tejido algodón<85%, teñido/fibra sint/art.taf, p<=200g/m2',10,'52','5210','521031');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52103200','Tecido algod<85%,  tinto/fibra sint/art.sarjad.p<=200g/m2','Fabric of cotton<85%, dyed/fib.synt/art.twill, w<=200g/m2','Tejido algodón<85%, teñido/fibr.sint/art.sar., p<=200g/m2',10,'52','5210','521032');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52103900','Outs.tecidos algod<85%,  tinto/fibra sint/art.p<=200g/m2','Ot.fabrics of cotton<85%, dyed/fibr.synt/art, w<=200g/m2','Ots.tejidos algodón<85%, teñido/fibr.sint/art, p<=200g/m2',10,'52','5210','521039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52104100','Tecido algod<85%,  color/fibra sint/art.tafeta,  p<=200g/m2','Fabric of cotton<85%, color./fibr.syn/art.taf, w<=200g/m2','Tejido algodón<85%, color./fibra sint/art.taf, p<=200g/m2',10,'52','5210','521041');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52104200','Tecido algod<85%,  color/fibra sint/art.sarjad.p<=200g/m2','Fabric of cotton<85%, col./fibr.syn/art.twill, w<=200g/m2','Tejido algodón<85%, color./fibr.sint/art.sar., p<=200g/m2',10,'52','5210','521042');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52104900','Outs.tecidos algod<85%,  color/fibra sint/art.p<=200g/m2','Ot.fabrics of cotton<85%, colour/fib.synt/art, w<=200g/m2','Ots.tejidos algodón<85%, color./fibr.sint/art, p<=200g/m2',10,'52','5210','521049');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52104910','Tec.d/alg.div.cor.sint.artif.pto.sarj.<200g/m','Fabrics of cotton, made from yarn of different colours, synthetic or ariticial fibres, point twill, diag. <200g/m2 ','Tejidos de algodón, fabricados con hilos de distintos colores, con fibras sintéticas o artificiales, ligamento sarga, diag. <200g/m2 ',10,'52','5210','521049');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52104990','Outros tec.d/alg.div.cor.sint.artif.<200g/','Other fabrics of cotton, made from yarn of different colours, synthetic or ariticial fibres, weight<200g/m2 ','Otros tejidos de algodón, fabricados con hilos de distintos colores, con fibras sintéticas o artificiales, peso<200g/m2 ',10,'52','5210','521049');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52105100','Tecido algod<85%,  estamp/fibr.sint/art.tafeta,  p<=200g/m2','Fabric cotton<85%, printed/fibre synt/art.taf, w<=200g/m2','Tejido algodón<85%, estamp/fibra sint/art.taf, p<=200g/m2',10,'52','5210','521051');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52105200','Tecido algod<85%,  estamp/fibr.sint/art.sarjad.p<=200g/m2','Fabric cotton<85%, printed/fib.synt/art.twill, w<=200g/m2','Tejido algodón<85%, estamp/fibr.sint/art.sar., p<=200g/m2',10,'52','5210','521052');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52105900','Outs.tecidos algod<85%,  estamp/fibra sint/art.p<=200g/m2','Ot.fabrics of cotton<85%, printed/fib.syn/art, w<=200g/m2','Ots.tejidos algodón<85%, estamp/fibr.sint/art, p<=200g/m2',10,'52','5210','521059');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52105910','Tec.d/alg.est.sint.artif.sarj./diag.<200g/m','Fabrics of printed cotton, synthetic or ariticial fibres, point twill, diag. <200g/m2 ','Tejidos estampados de algodón, con fibras sintéticas o artificiales, ligamento sarga, diag. <200g/m2 ',10,'52','5210','521059');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52105990','Outros tec.d/alg.est.sint.artif.peso <200g/m','Other fabrics of printed cotton, synthetic or ariticial fibres, weight<200g/m2 ','Otros tejidos estampados de algodón, con fibras sintéticas o artificiales, peso<200g/m2 ',10,'52','5210','521059');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52111100','Tecido algodão<85%,  cru/fibra sint/art.tafeta,  p>200g/m2','Fabric of cotton<85%, raw/fibre synt/art.taf., w>200g/m2','Tejido algodón<85%, crudo/fibra sint/art.taf., p>200g/m2',10,'52','5211','521111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52111200','Tecido algodão<85%,  cru/fibra sint/art.sarjado,  p>200g/m2','Fabric of cotton<85%, raw/fibre synt/art.twill, w>200g/m2','Tejido algodón<85%, crudo/fibra sint/art.sar., p>200g/m2',10,'52','5211','521112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52111900','Outros tecidos algodão<85%,  cru/fibra sint/art.p>200g/m2','Ot.fabrics of cotton<85%, raw/fibr.synt/art, w>200g/m2','Ots.tejidos algodón<85%, crudo/fibra sint/art, p>200g/m2',10,'52','5211','521119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52112010','Tec.d/alg.branq.sint.artif.pto.tafetá,  <200g/m','Fabrics of cotton, bleached, synthetic or artificial fibres, point taffeta, weight<200g/m2 ','Tejidos de algodón, blanqueados, con fibras sintéticas o artificiales, de ligamento tafetán, peso<200g/m2 ',10,'52','5211','521120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52112020','Tec.d/alg.branq.sint.artif.sarj.diag.<200g/m','Fabrics of cotton, bleached, synthetic or artificial fibres, point twill, diag. <200g/m2 ','Tejidos de algodón, blanqueados, con fibras sintéticas o artificiales, ligamento sarga, diag. <200g/m2 ',10,'52','5211','521120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52112090','Outs.tec.d/alg.branq.sint.artif.<200g/m','Other fabrics of cotton, bleached, synthetic or artificial fibres, weight<200g/m2 ','Otros tejidos de algodón, blanqueados, con fibras sintéticas o artificiales, peso<200g/m2 ',10,'52','5211','521120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52112100','Tecido algodão<85%,  branq/fibr.sint/art.tafeta,  p>200g/m2','Fabric of cotton<85%, bleac/fibr.synt/art.taf., w>200g/m2','Tejido algodón<85%, blanq/fibra sint/art.taf., p>200g/m2',10,'52','5211','521121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52112200','Tecido algodão<85%,  branq/fibr.sint/art.sarjad.p>200g/m2','Fabric of cotton<85%, bleac/fibr.syn/art.twill, w>200g/m2','Tejido algodón<85%, blanq/fibra sint/art.sar., p>200g/m2',10,'52','5211','521122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52112900','Outs.tecidos algodão<85%,  branq/fibra sint/art.p>200g/m2','Ot.fabrics of cotton<85%, bleac/fibr.synt/art, w>200g/m2','Ots.tejidos algodón<85%, blanq/fibra sint/art, p>200g/m2',10,'52','5211','521129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52113100','Tecido algodão<85%,  tinto/fibr.sint/art.tafeta,  p>200g/m2','Fabric of cotton<85%, dyed/fibre synt/art.taf., w>200g/m2','Tejido algodón<85%, teñido/fibra sint/art.taf., p>200g/m2',10,'52','5211','521131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52113200','Tecido algodão<85%,  tinto/fibr.sint/art.sarjad.p>200g/m2','Fabric of cotton<85%, dyed/fibr.synt/art.twill, w>200g/m2','Tejido algodón<85%, teñido/fibra sint/art.sar., p>200g/m2',10,'52','5211','521132');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52113900','Outs.tecidos algodão<85%,  tinto/fibra sint/art.p>200g/m2','Ot.fabrics of cotton<85%, dyed/fibre synt/art, w>200g/m2','Ots.tejidos algodón<85%, teñido/fibra sint/art, p>200g/m2',10,'52','5211','521139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52114100','Tecido algodão<85%,  color/fibr.sint/art.tafeta,  p>200g/m2','Fabric of cot.<85%, colours/fibre synt/art.taf.w>200g/m2','Tejido algodón<85%, color./fibra sint/art.taf., p>200g/m2',10,'52','5211','521141');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52114210','Tecido algodão<85%,  indigo blue/fibra sint/art.p>200g/m2','Fabric of cot.<85%, indigo blue/fibre synt/art, w>200g/m2','Tejido algodón<85%, indigo blue/fibra sint/art, p>200g/m2',10,'52','5211','521142');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52114290','Outs.tecidos algodão<85%,  denim/fibra sint/art.p>200g/m2','Ot.fabric of cotton<85%, denim/fib.syn/art, w>200g/m2','Ots.tejidos alg.<85%, mezclilla/fibr.sint/art, p>200g/m2',10,'52','5211','521142');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52114300','Tecido algodão<85%,  color/fibr.sint/art.sarjad.p>200g/m2','Fabric of cot<85%, colours/fibre syn/art.twill, w>200g/m2','Tejido algodón<85%, color./fibra sint/art.sar., p>200g/m2',10,'52','5211','521143');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52114900','Outs.tecidos algodão<85%,  color/fibra sint/art.p>200g/m2','Oth.fabrics of cotton<85%, col./fibre syn/art, w>200g/m2','Ots.tejidos algodón<85%, color./fibra sint/art, p>200g/m2',10,'52','5211','521149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52115100','Tecido algod<85%,  estamp/fibra sint/art.tafeta,  p>200g/m2','Fabric of cot.<85%, printed/fibre syn/art.taf., w>200g/m2','Tejido algodón<85%, estamp/fibra sint/art.taf., p>200g/m2',10,'52','5211','521151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52115200','Tecido algod<85%,  estamp/fibra sint/art.sarjad.p>200g/m2','Fabric of cot.<85%, printed/fibr.syn/art.twill, w>200g/m2','Tejido algodón<85%, estamp/fibra sint/art.sar., p>200g/m2',10,'52','5211','521152');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52115900','Outs.tecidos algodão<85%,  estamp/fibr.sint/art.p>200g/m2','Ot.fabrics of cotton<85%, print./fibr.synt/art.w>200g/m2','Ots.tejidos algodón<85%, estamp/fibra sint/art, p>200g/m2',10,'52','5211','521159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52121100','Outros tecidos de algodão,  crus,  peso<=200g/m2','Other fabrics of cotton, raw, weight<=200g/m2','Ots.tejidos de algodón, crudos, peso<=200g/m2',10,'52','5212','521211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52121200','Outros tecidos de algodão,  branqueados,  peso<=200g/m2','Other fabrics of cotton, bleached, weight<=200g/m2','Ots.tejidos de algodón, blanqueados, peso<=200g/m2',10,'52','5212','521212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52121300','Outros tecidos de algodão,  tintos,  peso<=200g/m2','Other fabrics of cotton, dyed, weight<=200g/m2','Ots.tejidos de algodón, teñidos, peso<=200g/m2',10,'52','5212','521213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52121400','Outros tecidos de algodão,  fios divs.cores,  peso<=200g/m2','Ot.fabrics of cotton, yarns of differ.colours, w<=200g/m2','Ots.tejidos de algodón, hilados c/dist.color., p<=200g/m2',10,'52','5212','521214');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52121500','Outros tecidos de algodão,  estampados,  peso<=200g/m2','Other fabrics of cotton, printed, weight<=200g/m2','Ots.tejidos de algodón, estampados, peso<=200g/m2',10,'52','5212','521215');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52122100','Outros tecidos de algodão,  crus,  peso>200g/m2','Other fabrics of cotton, raw, weight>200g/m2','Ots.tejidos de algodón, crudos, peso>200g/m2',10,'52','5212','521221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52122200','Outros tecidos de algodão,  branqueados,  peso>200g/m2','Other fabrics of cotton, bleached, weight>200g/m2','Ots.tejidos de algodón, blanqueados, peso>200g/m2',10,'52','5212','521222');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52122300','Outros tecidos de algodão,  tintos,  peso>200g/m2','Other fabrics of cotton, dyed, weight>200g/m2','Ots.tejidos de algodón, teñidos, peso>200g/m2',10,'52','5212','521223');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52122400','Outros tecidos de algodão,  fios divs.cores,  peso>200g/m2','Ot.fabrics of cotton, yarns of differ.colours, w>200g/m2','Ots.tejidos de algodón, hilados c/dist.colores, p>200g/m2',10,'52','5212','521224');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('52122500','Outros tecidos de algodão,  estampados,  peso>200g/m2','Oth.fabrics of cotton, printed, weight>200g/m2','Ots.tejidos de algodón, estampados, peso>200g/m2',10,'52','5212','521225');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53011000','Linho em bruto ou macerado','Flax, raw or retted','Lino en bruto o enriado',10,'53','5301','530110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53012110','Linho quebrado','Flax broken','Lino agramado',10,'53','5301','530121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53012120','Linho espadelado, mas não fiado','Flax scutched, but not spun','Lino espadado, pero sin hilar',10,'53','5301','530121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53012910','Linho penteado, mas não fiado','Flax combed, but not spun','Lino peinado, pero sin hilar',10,'53','5301','530129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53012990','Linho trabalhado de outra forma, mas não fiado','Flax processed of another form, but not spun','Lino trabajado de otra forma, pero sin hilar',10,'53','5301','530129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53013000','Estopas e desperdícios de linho','Flax tow and waste','Estopas y desperdicios de lino',10,'53','5301','530130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53021000','Canhamo em bruto ou macerado','Rue hemp, raw or retted','Cáñamo en bruto o enriado',10,'53','5302','530210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53029000','Canhamo trabalh.outra forma,  mas n/fiado,  estopas,  desperd','True hemp processed, but not spun, tow, waste','Cáñamo trabaj.otra forma, pero sin hilar, estopas, desperd',10,'53','5302','530290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53031010','Juta','Jute','Yute',10,'53','5303','530310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53031011','Juta em bruto','Raw jute','Yute en bruto',10,'53','5303','530310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53031012','Juta macerada','Retted raw','Yute enriado',10,'53','5303','530310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53031090','Outras fibras têxteis liberianas, em bruto ou maceradas','Other textile bast fibres, raw or retted','Demás fibras textiles del líber, en bruto o enriados',10,'53','5303','530310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53039010','Juta trabalh.de outro modo,  mas n/fiada,  estopas,  desperds','Jute proces.in another form , but n/spun, tow, waste','Yute trabaj.de otro modo, pero s/hilar, estopas, desperds',10,'53','5303','530390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53039090','Outs.fibras têxteis liber.trabalh.out.modo,  estopas,  etc.','Oth.textile bast fibres proces.in another form, tow, etc','Las dem.fibras textiles líber trab.ot.modo, estopas, etc',10,'53','5303','530390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53041000','Sisal/outras fibras têxteis "agave", em bruto','Sisal and other textile fibres of the "agave", raw','Sisal/demás fibras textiles del género agave, en bruto',10,'53','5304','530410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53049000','Sisal/outs.fibras têxteis "agave",  trabalh.n/fiados,  etc.','Sisal/ot.textile fibres of the "agave", proc.n/spun, etc','Sisal/demás fibras textiles agave, trabaj.s/hilar, etc',10,'53','5304','530490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53050010','Abacá (cânhamo de manilha) em bruto','Abaca (manila hemp) raw','Abacá (cáñamo de manila) en bruto ',10,'53','5305','530500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53050090','Outs.fib.têxteis veg.estopas, desperd.trab.','Other vegetable textile fibres, tow and waste, processed ','Otras fibras textiles vegetales, estopas y desperdicios de estas fibras, trabajadas ',10,'53','5305','530500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53051100','Cairo (fibras de coco) em bruto','Coir (fibres of coconut) raw','Fibras de coco en bruto',10,'53','5305','530511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53051900','Cairo (fibras de coco) trabalh.n/fiado,  estopas,  desperds','Coir(fibres of coconut)proces.n/spun, tow, waste','Fibras de coco trabaj.s/hilar, estopas, desperds',10,'53','5305','530519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53052100','Abaca em bruto','Raw abaca','Abacá en bruto',10,'53','5305','530521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53052900','Abaca trabalhado, não fiado, estopas e desperdícios','Abaca process, n/spun, tow and waste','Abacá trabajado, sin hilar, estopas y desperdicios',10,'53','5305','530529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53059011','Rami em bruto','Raw ramie','Ramio en bruto',10,'53','5305','530590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53059012','Rami penteado','Combed ramie','Ramio peinado',10,'53','5305','530590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53059019','Outras fibras de rami','Other fibres of ramie','Otras fibras de ramio',10,'53','5305','530590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53059091','Outras fibras vegetais, em bruto','Other fibres of vegetable, raw','Otras fibras vegetales, en bruto',10,'53','5305','530590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53059099','Outras fibras vegetais','Other fibres of vegetable','Otras fibras vegetales',10,'53','5305','530590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53059110','Rami em bruto','Raw ramie','Ramio en bruto',10,'53','5305','530591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53059190','Outras fibras têxteis vegetais, em bruto','Other vegetal textile fibres, raw','Otras fibras textiles vegetales, en bruto',10,'53','5305','530591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53059911','Rami penteado','Combed ramie','Ramio peinado',10,'53','5305','530599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53059919','Rami trabalhado de outra forma,  estopas e desperdícios','Ramie proces.of other way, noils and waste','Ramio trabajado de otra forma, estopas y desperdicios',10,'53','5305','530599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53059990','Outras fibras têxteis vegetais trabalh.estopas,  desperds','Oth.vegetal textile fibres process noils and waste','Otras fibras textiles vegetales trabaj.estopas, desperds',10,'53','5305','530599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53061000','Fios de linho, simples','Flax yarn, single','Hilados de lino, sencillos',10,'53','5306','530610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53062000','Fios de linho, retorcidos ou retorcidos múltiplos','Flax yarn, multiple (folded) or cabled','Hilados de lino, retorcidos o cableados',10,'53','5306','530620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53071010','Fios de juta, simples','Yarn of jute, single','Hilados de yute, sencillos',10,'53','5307','530710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53071090','Fios de outras fibras têxteis liberianas, simples','Arn of jute or of other textile bast fibres, single','Hilados de otras fibras textiles del líber, sencillos',10,'53','5307','530710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53072010','Fios de juta, retorcidos ou retorcidos múltiplos','Yarn of jute, multiple (folded) or cabled','Hilados de yute, retorcidos o cableados',10,'53','5307','530720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53072090','Fios de outras fibras têxteis liberianas,  retorcidos,  etc','Yarn of other textile bast fibres, folded, etc.','Hilados de otras fibras textiles líber, retorcidos, etc',10,'53','5307','530720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53081000','Fios de cairo (fios de fibras de coco)','Coir yarn (yarns of fibres of coconut)','Hilados de coco (hilados de fibras de coco)',10,'53','5308','530810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53082000','Fios de canhamo','True hemp yarn','Hilados de cáñamo',10,'53','5308','530820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53083000','Fios de papel','Paper yarn','Hilados de papel',10,'53','5308','530830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53089000','Fios de outras fibras têxteis vegetais','Yarn of other vegetable textile fibres','Hilados de otras fibras textiles vegetales',10,'53','5308','530890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53091100','Tecidos de linho (conteudo>=85%),  crus ou branqueados','Fabrics of flax (containing>=85%), raw or bleached','Tejidos de lino (contenido>=85%), crudos o blanqueados',10,'53','5309','530911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53091900','Outros tecidos de linho (conteudo>=85%)','Other fabrics of flax (containing>=85%)','Otros tejidos de lino (contenido>=85%)',10,'53','5309','530919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53092100','Tecidos de linho (conteudo<85%),  crus ou branqueados','Fabrics of flax (containing<85%), raw or bleached','Tejidos de lino (contenido<85%), crudos o blanqueados',10,'53','5309','530921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53092900','Outros tecidos de linho (conteudo<85%)','Other fabrics of flax (containing<85%)','Otros tejidos de lino (contenido<85%)',10,'53','5309','530929');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53101010','Tecidos de aniagem de juta, crus','Fabrics of burlap of jute, raw','Tejidos de arpillera de yute, crudos',10,'53','5310','531010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53101090','Tecidos de outras fibras têxteis liberianas, crus','Fabrics of other textile bast fibres, raw','Tejidos de otras fibras textiles del líber, crudos',10,'53','5310','531010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53109000','Outs.tecidos de juta ou outs.fibras têxteis liberianas','Oth.fabrics of jute or of other textile bast fibres','Ots.tejidos de yute o demás fibras textiles del líber',10,'53','5310','531090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('53110000','Tecidos de outs.fibras têxteis veg.ou de fios de papel','Fabrics of oth.vegetable textile fibres or of paper yar','Tejidos de ots.fibras texts.veg.o de hilados de papel',10,'53','5311','531100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54011011','Linha para costura,  de poliéster,  exc.para venda a retalho','Sewing thread, of polyester, except for retail sale','Hilo de coser, de poliéster, inc.p/la venta al por menor',10,'54','5401','540110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54011012','Linha para costura,  de poliéster, para venda a retalho','Sewing thread, of polyester, for retail sale','Hilo de coser, de poliéster, para la venta al por menor',10,'54','5401','540110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54011090','Linha para costura, de outros filamentos sintéticos','Sewing thread of other synthetic filaments','Hilo de coser, de otros filamentos sintéticos',10,'54','5401','540110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54012011','Linha para costura, raiom viscose, alta tenac.exc.p/retalho','Sewing thread, rayon viscose, high tenac.exc.for retail','Hilo de coser, rayón viscosa, alta tenac.inc.p/vta menor',10,'54','5401','540120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54012012','Linha para costura, raiom viscose, alta tenac.p/vda.retalho','Sewing thread, rayon viscose, high tenacity, f/retail sale','Hilo de coser, rayón viscosa, alta tenac.p/vta al p/menor',10,'54','5401','540120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54012090','Linha para costura, de outros filamentos artificiais','Sewing thread, of other artificial filaments','Hilo de coser, de otros filamentos artificiales',10,'54','5401','540120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54021010','Fio de alta tenacidade, de náilon (poliamida alifatica)','Yarn high tenacity, of nylon (aliphatic polyamide)','Hilados de alta tenac., de nailon (poliamida alifática)',10,'54','5402','540210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54021020','Fio de alta tenacidade, de aramida (poliamida aromática)','Yarn high tenacity, of aramids (aromatic polyamide)','Hilado de alta tenacid., de aramida(poliamida aromática)',10,'54','5402','540210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54021090','Fio de alta tenacidade, de outras poliamidas','Yarn high tenacity, of other polyamides','Hilado de alta tenacidad, de otras poliamidas',10,'54','5402','540210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54021100','Fios de alta tenacidade de aramidas','Yarn high tenacity of aramids ','Hilados de alta tenacidad de aramida',10,'54','5402','540211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54021910','Fios de alta tenacidade de náilon','Yarn high tenacity of nylon','Hilados de alta tenacidad de nailon',10,'54','5402','540219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54021990','Fio de alta tenacidade, de outras poliamidas','Yarn high tenacity, of other polyamides','Hilado de alta tenacidad, de otras poliamidas',10,'54','5402','540219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54022000','Fio de alta tenacidade, de poliésteres','Yarn high tenacity, of polyesters','Hilado de alta tenacidad, de poliésteres',10,'54','5402','540220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54023111','Fio texturizado, de náilon, tinto, título<=50tex','Textured yarn, of nylon, dyed, title<=50tex','Hilado texturado, de nailon, teñido, título<=50tex',10,'54','5402','540231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54023119','Outros fios texturizados, de náilon, título<=50tex','Other textured yarns, of nylon, title<=50tex','Otros hilados texturados, de nailon, título<=50tex',10,'54','5402','540231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54023190','Fio texturizado,  de outs.poliamidas, tinto, título<=50tex','Textured yarns, of other polyamides, dyed, title<=50tex','Hilado texturado, de ots.poliamidas, teñido, título<=50tex',10,'54','5402','540231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54023211','Multifilamento de náilon, efeito antiest.perman.tit>110t','Multifilament of nylon, perm.anti-static.effect, tit>110t','Multifilamento de nailon, efecto antiest.perman.tít>110t',10,'54','5402','540232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54023219','Outros fios texturizados, de náilon, titulo>50tex','Other textured yarns, of nylon, title>50tex','Otros hilados texturados, de nailon, título>50tex',10,'54','5402','540232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54023290','Fio texturizado de outras poliamidas, título>50tex','Textured yarns, of other polyamides, title<=50tex','Hilado texturado de otras poliamidas, título>50tex',10,'54','5402','540232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54023300','Fio texturizado de poliésteres','Textured yarns, of polyesters','Hilado texturado de poliésteres',10,'54','5402','540233');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54023400','Multifilamento d/poliprop.d/título >110tex','Polypropylene multifilament, title>110tex','Multifilamento de polipropileno, título>110tex',10,'54','5402','540234');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54023900','Outros fios texturizados','Other textured yarns','Otros hilados texturados',10,'54','5402','540239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54023910','Multifilamento de polipropileno, título>110tex','Polypropylene multifilament, title>110tex','Multifilamento de polipropileno, título>110tex',10,'54','5402','540239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54023990','Fio texturizado de outros filamentos sintéticos','Textured yarn of other synthetic filament','Hilado texturado de otros filamentos sintéticos',10,'54','5402','540239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54024110','Fio de náilon, simples, torção<=50voltas/metro','Yarn of nylon, single, sprain<=50 turns/meter','Hilado de nailon, sencillo, torsión<=50vueltas/metro',10,'54','5402','540241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54024120','Fio de aramida, simples, torção<=50voltas/metro','Yarn of aramid, single, sprain<=50 turns/meter','Hilado de aramida, sencillo, torsión<=50vueltas/metro',10,'54','5402','540241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54024190','Fio de outras poliamidas,  simples,  torção<=50voltas/metro','Yarn of other polyamides, single, sprain<=50 turns/meter','Hilado de ots.poliam., sencillo, torsión<=50vueltas/metro',10,'54','5402','540241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54024200','Fio de poliésteres,  simples,  parcialm.orient.torc<=50v/m','Yarn of polyesters, single, partial.orient.sprain<=50 t/m','Hilado de poliésteres, senc., parcialm.orient.tor.<=50v/m',10,'54','5402','540242');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54024300','Fio de outs.poliésteres, simples, torção<=50voltas/metro','Yarn of polyesters, single, sprain<=50 turn/meter','Hilado de ots.poliésteres, sencillo, torsión<=50vueltas/m',10,'54','5402','540243');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54024400','Outs.fios elastôms.simp., torção<=50volt./met','Other elastomeric yarn, single, twist <= 50 turns/m ','Otros hilados simples de elastómeros, torsión <= 50 vueltas/m',10,'54','5402','540244');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54024510','Fio de aramida,  simpl.,torção<=50voltas/metro','Yarn of aramid, single, sprain<=50 turns/meter','Hilado de aramida, sencillo, torsión<=50vueltas/metro',10,'54','5402','540245');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54024520','Fios simpl.d/náilon,  c/ou s/torção<50voltas/m','Yarn of nylon, single, twisted or untwisted < 50 turns/m ','Hilados simples de nilón, con o sin torsión < 50 vueltas/m ',10,'54','5402','540245');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54024590','Fios simpl.outs.pol.s/ou c/torção<50voltas/m','Yarn of other polyamides, single, twist or untwisted < 50 turns/m ','Hilados simples, de otras poliamidas, con o sin torsión, < 50 vueltas/m ',10,'54','5402','540245');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54024600','Fios simpl.poliésteres orien.s/c torç.50vol/m','Yarn of polyester orient., single, twist or untwisted < 50 turns/m','Hilados simples de poliésteres orientados, con o sin torsión, < 50 vueltas/m ',10,'54','5402','540246');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54024700','Fios simpl.outs.poliésteres s/c torç.<50vol/m','Yarn of other polyester, single, twist or untwisted < 50 turns/m ','Hilados simples, de otros poliésteres, con o sin torsión < 50 vueltas/m ',10,'54','5402','540247');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54024800','Fios simpl.outs.polipropil. s/c torç.<50vol/m','Yarn of other polypropyline, twist or untwisted < 50 turns/m ','Hilados simples, de otros polipropilenos, con o sin torsión < 50 vueltas/m ',10,'54','5402','540248');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54024910','Fio elastomerico,  de outs.filam.sint.simples,  torc<=50v/m','Elastomeric yarn, of oth.synth.filam.sing.sprain<=50t/m','Hilado elastomérico, de ots.filam.sint.senc, tors<=50v/m',10,'54','5402','540249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54024920','Fio de polietileno, tenacidade>=26cn/tex','Yarn of polyethylene, tenacity >= 26cn/tex','Hilado de polietileno, tenacidad >= 26cn/tex',10,'54','5402','540249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54024990','Fio de outros filam.sint.simples,  torção<=50voltas/metro','Other synthetic filament yarns, single, sprain<=50t/m','Hilado de ots.filam.sint.sencilo, torsión<=50v/m',10,'54','5402','540249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54025110','Fio de aramida, simples, torção>50voltas/metro','Yarn of aramid, single, twist>50 turns/meter','Hilado de aramida, sencillo, torsión>50vueltas/metro',10,'54','5402','540251');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54025190','Fio de náilon/outs.poliamidas,  simples,  torção>50voltas/m','Yarn of nylon/other polyamides, single, twist>50t/m','Hilado de nailon/ots.poliamidas, sencillo, torsión>50v/m',10,'54','5402','540251');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54025200','Fio de poliésteres, simples, torção>50voltas/metro','Yarn of polyesters, single, twist>50turns/meter','Hilado de poliésteres, sencillo, torsión>50vueltas/metro',10,'54','5402','540252');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54025900','Fio de outs.filamentos sintet.simples, torção>50voltas/m','Yarn of other synthetic filament, single, twist>50turns/m','Hilado de ots.filam.sintét.sencillo, torsión>50vueltas/m',10,'54','5402','540259');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54026110','Fio de aramida, retorcido ou retorcido múltiplo','Yarn of aramids, multiple (folded) or cabled','Hilado de aramida, retorcido o cableado',10,'54','5402','540261');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54026190','Fio de náilon/outs.poliamidas,  retorcido/retorc.múltiplo','Yarn of nylon/other polyamides, multiple(folded)/cabled','Hilado de nailon/ots.poliamidas, retorcido o cableado',10,'54','5402','540261');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54026200','Fio de poliésteres, retorcido ou retorcido múltiplo','Yarn of polyesters, multiple(folded) or cabled','Hilado de poliésteres, retorcido o cableado',10,'54','5402','540262');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54026900','Fio de outs.filamentos sintet.retorcido/retorc.múltiplo','Yarn of other synt.filament multiple(folded)/cabled','Hilado de ots.filamentos sintét.retorcido o cableado',10,'54','5402','540269');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54031000','Fio de alta tenacidade, de raiom viscose','High tenacity yarn of viscose rayon','Hilado de alta tenacidad, de rayón viscosa',10,'54','5403','540310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54032010','Fio texturizado, de acetato de celulose','Textured yarn, of cellulose acetate','Hilado texturado, de acetato de celulosa',10,'54','5403','540320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54032090','Fio texturizado, de outros filamentos artificiais','Textured yarn, of other artificial filament','Hilado texturado, de otros filamentos artificiales',10,'54','5403','540320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54033100','Fio de raiom viscose,  simples,  torção<=120voltas/metro','Yarn of viscose rayon, single, twist<=120turns/meter','Hilado de rayón viscosa, sencillo, torsión<=120vueltas/m',10,'54','5403','540331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54033200','Fio de raiom viscose,  simples,  torção>120voltas/metro','Yarn of viscose rayon, single, twist>120turns/meter','Hilado de rayón viscosa, sencillo, torsión>120vueltas/m',10,'54','5403','540332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54033300','Fio de acetato de celulose, simples','Yarn of cellulose acetate, single','Hilado de acetato de celulosa, sencillo',10,'54','5403','540333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54033900','Fio de outros filamentos artificiais, simples','Yarn of other artificial filament, single','Hilado de otros filamentos artificiales, sencillo',10,'54','5403','540339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54034100','Fio de raiom viscose, retorcido ou retorcido múltiplo','Yarn of viscose rayon, multiple(folded) or cabled','Hilado de rayón viscosa, retorcido o cableado',10,'54','5403','540341');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54034200','Fio de acetato de celulose, retorcido ou retorc.múltiplo','Yarn of cellulose acetate, multiple(folded) or cabled','Hilado de acetato de celulosa, retorcido o cableado',10,'54','5403','540342');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54034900','Fio de outs.filamentos artif.retorcidos/retorc.múltiplo','Yarn of artificial filament multiple(folded)/cabled','Hilado de ots.filamentos artif., retorcido o cableado',10,'54','5403','540349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54041011','Imitacoes de categute,  reabsorv.de monofilam.sint.t>=67d','Imitations of catgut, reabs.of synth.monofilam.t>=67d','Imitaciones de catgut, reabsorb.de monofilam.sint.t>=67d',10,'54','5404','540410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54041019','Outs.imitacoes de categute, de monofilam.sint.t>=67decit','Other imitations of catgut, of synt.monofilam.t>=67decit','Ots.imitaciones de catgut, de monofilam.sint.t>=67decit',10,'54','5404','540410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54041090','Outs.monofilamentos sintet.t>=67decitex,  sec.transv<=1mm','Oth.synthetic monofilam.t>=67decitex, traver.sect.<=1mm','Ots.monofilamentos sintét.t>=67decitex, sec.transv<=1mm',10,'54','5404','540410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54041100','Monofilamentos de elastômeros c/larg.<5mm','Elastomeric monofilaments, width<5mm','Monofilamentos de elastómeros, anchura<5mm',10,'54','5404','540411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54041200','Outs.monofilam.de polipropileno c/larg. <5mm','Other polypropylene monofilaments, width<5mm','Otros monofilamentos de polipropileno, anchura<5mm',10,'54','5404','540412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54041911','Imitações de categute','Imitations of catgut','Imitaciones de catgut',10,'54','5404','540419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54041919','Outs.imitações d/categute, de monofilamentos','Imitations of catgut, of monofilaments','Imitaciones de catgut, de monofilamentos',10,'54','5404','540419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54041990','Outs.monofilamentos sintéticos c/larg.<5mm','Other synthetic monofilaments, width<5mm','Otros monofilamentos sintéticos, anchura<5mm',10,'54','5404','540419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54049000','Laminas de matérias têxteis sintéticas,  largura<=5mm','Laminate of synthetic textile matters, width<=5mm','Tiras de materias textiles sintéticas, anchura<=5mm',10,'54','5404','540490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54050000','Monofilamentos artifs.t>=67decitex,  sec.transv<=1mm,  etc.','Artificial monofilam.t>=67 decitex, cross-sect.<=1mm, etc','Monofilamentos artifs.t>=67decitex, sec.transv<=1mm, etc.',10,'54','5405','540500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54060010','Fios d/filamentos sintéticos p/venda retalho','Synthetic filament yarn, for retail sale','Hilados filamentos sintéticos, p/la venta al por menor',10,'54','5406','540600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54060020','Fios d/filamentos artificiais p/venda retalho','Artificial filament yarn, for retail sale','Hilados filamentos artificiales, p/la venta al por menor',10,'54','5406','540600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54061000','Fios de filamentos sintéticos, para venda a retalho','Synthetic filament yarn, for retail sale','Hilados filamentos sintéticos, p/la venta al por menor',10,'54','5406','540610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54062000','Fios de filamentos artificiais, para venda a retalho','Artificial filament yarn, for retail sale','Hilados filamentos artificiales, p/la venta al por menor',10,'54','5406','540620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54071011','Tecido de fios alta tenac.de aramida, s/fio borracha','Fabric ob.from high ten.yarn, aramid, without rubber yarn','Tejido de hilados alta tenac.de aramida, s/hilos caucho',10,'54','5407','540710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54071019','Tecido de fios alta tenac.de náilon,  etc.s/fio borracha','Fabric ob.from high ten.yarn, nylon, etc.with.rubber yarn','Tejido de hilados alta tenac.de nailon, s/hilos caucho',10,'54','5407','540710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54071021','Tecido de fios alta tenac.de aramida, c/fio borracha','Fabric ob.from high ten.yarn, of aramid, with rubber yarn','Tejido de hilados alta tenac.de aramida, c/hilos caucho',10,'54','5407','540710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54071029','Tecido de fios alta tenac.de náilon,  etc.c/fio borracha','Fabric ob.from high ten.yarn, nylon, etc.with rubber yarn','Tej.de hilados alta tenac.de nailon, etc.c/hilos caucho',10,'54','5407','540710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54072000','Tecido obtido a partir de lâminas sintéticas,  etc.','Fabric obtained from laminate synthetic, etc.','Tejido fabricado con tiras sintéticas, etc.',10,'54','5407','540720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54073000','Tecidos mantas de fios de filamento sintético','Fabrics blankets of threads of synthetic filament','Tejidos mantas de hilados de filamento sintético',10,'54','5407','540730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54074100','Tecido de filam.de náilon,  out.poliamida>=85%,  crus/branq','Fabric of nylon filament, oth.polyamide>=85%, raw/bleac','Tejido de filam.de nailon, ot.poliamida>=85%, crudo/blanq',10,'54','5407','540741');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54074200','Tecido de filam.de náilon,  outra poliamida>=85%,  tintos','Fabric of nylon filament, oth.polyamide>=85%, dyed','Tejido de filam.de nailon, otra poliamida>=85%, teñido',10,'54','5407','540742');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54074300','Tecido de filam.de náilon,  out.poliamida>=85%,  divs.cores','Fabric of nylon filam.oth.polyamide>=85%, difer.colours','Tejido de fil.de nailon, ot.poliamida>=85%, hil.dist.col.',10,'54','5407','540743');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54074400','Tecido de filam.de náilon,  out.poliamida>=85%,  estampados','Fabric of nylon filament oth.polyamide>=85%, printed','Tejido de filam.de nailon, ot.poliamida>=85%, estampados',10,'54','5407','540744');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54075100','Tecido de filam.poliéster textur>=85%,  crus/branqueados','Fabric of polyester filament textured>=85%, raw/bleach','Tejido de filam.poliéster textur>=85%, crudo/blanqueado',10,'54','5407','540751');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54075210','Tecido de filam.poliéster textur>=85%,  tintos,  s/borracha','Fabric of polyest.filam.text.>=85%, dyed/without rubber','Tejido de filam.poliéster textur>=85%, teñidos, s/caucho',10,'54','5407','540752');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54075220','Tecido de filam.poliéster textur>=85%,  tintos,  c/borracha','Fabric of polyest.filam.text.>=85%, dyed/with rubber','Tejido de filam.poliéster textur>=85%, teñidos, c/caucho',10,'54','5407','540752');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54075300','Tecido de filam.poliéster textur>=85%,  fios divs.cores','Fabric of polyest.filam.text.>=85%, different colours','Tejido de filam.poliéster textur>=85%, hilados dist.col.',10,'54','5407','540753');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54075400','Tecido de filam.poliéster textur>=85%, estampados','Fabric of polyest.filam.text.>=85%, printed','Tejido de filam.poliéster textur>=85%, estampado',10,'54','5407','540754');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54076100','Tecido de filam.de poliéster nao texturizado>=85%','Fabric of polyester filament no textured>=85%','Tejido de filam.poliéster sin texturar>=85%',10,'54','5407','540761');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54076900','Tecido de outros filamentos de poliéster>=85%','Fabric of other of polyester filament>=85%','Tejido de otros filamentos de poliéster>=85%',10,'54','5407','540769');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54077100','Tecido de filamentos sintéticos>=85%,  crus/branqueados','Fabric of synthetic filament>=85%, raw/bleached','Tejido de filamentos sintéticos>=85%, crudo/branqueado',10,'54','5407','540771');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54077200','Tecido de filamentos sintéticos>=85%, tintos','Fabric of synthetic filament>=85%, dyed','Tejido de filamentos sintéticos>=85%, teñidos',10,'54','5407','540772');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54077300','Tecido de filamentos sintéticos>=85%,  fios divs.cores','Fabric of synthetic filament>=85%, different colours','Tejido de filamentos sintéticos>=85%, hilados dist.col.',10,'54','5407','540773');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54077400','Tecido de filamentos sintéticos>=85%, estampados','Fabric of synthetic filament>=85%, printed','Tejido de filamentos sintéticos>=85%, estampados',10,'54','5407','540774');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54078100','Tecido de filamento sintético<85% c/algodão,  cru/branq.','Fabric of synthetic filament>85%, with cotton, raw/bleac','Tejido de filamento sintético<85% c/algodón, crudo/blanq',10,'54','5407','540781');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54078200','Tecido de filamento sintético<85% c/algodão, tinto','Fabric of synthetic filament<85%, with cotton, dyed','Tejido de filamento sintético<85% c/algodón, teñido',10,'54','5407','540782');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54078300','Tecido de filamento sintético<85% c/algodão,  divs.cores','Fabric of synthetic filament<85%, different colours','Tejido de filamento sintético<85% c/algodón, hil.colores',10,'54','5407','540783');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54078400','Tecido de filamento sintético<85% c/algodão,  estampado','Fabric of synthetic filament<85%, with cotton, printed','Tejido de filamento sintético<85% c/algodón, estampado',10,'54','5407','540784');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54079100','Outros tecidos de filamentos sintéticos<85%,  crus/branq.','Other fabrics of synthetic filament<85%, raw/bleached','Ots.tejidos de filamentos sintéticos<85%, crudo/blanq',10,'54','5407','540791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54079200','Outros tecidos de filamentos sintéticos<85%, tintos','Other fabrics of synthetic filament<85%, dyed','Ots.tejidos de filamentos sintéticos<85%, teñidos',10,'54','5407','540792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54079300','Outros tecidos de filamentos sintéticos<85%,  divs.cores','Oth.fabrics of synthetic filament<85%, different colours','Ots.tejidos de filamentos sintéticos<85%, hil.dist.col.',10,'54','5407','540793');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54079400','Outros tecidos de filamentos sintéticos<85%,  estampados','Other fabrics of synthetic filament<85%, printed','Ots.tejidos de filamentos sintéticos<85%, estampados',10,'54','5407','540794');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54081000','Tecido de fios de alta tenacidade, de raiom viscose','Fabric obtain.from high tenacity yarn, of viscose rayon','Tejido de hilados de alta tenacidad, de rayón viscosa',10,'54','5408','540810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54082100','Tecido de filamentos artificiais>=85%,  cru/branqueado','Fabric of artificial filament>=85%, raw/bleached','Tejido de filamentos artificiales>=85%, crudo/blanqueado',10,'54','5408','540821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54082200','Tecido de filamentos artificiais>=85%, tinto','Fabric of artificial filament>=85%, dyed','Tejido de filamentos artificiales>=85%, teñido',10,'54','5408','540822');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54082300','Tecido de filamentos artificiais>=85%,  fios divs.cores','Fabric of artificial filament>=85%, yarns diff.colours','Tejido de filamentos artificiales>=85%, hil.dist.colores',10,'54','5408','540823');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54082400','Tecido de filamentos artificiais>=85%, estampado','Fabric of artificial filament>=85%, printed','Tejido de filamentos artificiales>=85%, estampado',10,'54','5408','540824');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54083100','Outros tecidos de filamentos artificiais<85%,  crus/branq','Other fabrics of artificial filament<85%, raw/bleached','Ots.tejidos de filam.artificiales<85%, crudo/blanqueado',10,'54','5408','540831');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54083200','Outros tecidos de filamentos artificiais<85%, tintos','Other fabrics of artificial filament<85%, dyed','Ots.tejidos de filam.artificiales<85%, teñidos',10,'54','5408','540832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54083300','Outros tecidos de filamentos artificiais<85%,  divs.cores','Other fabrics of artificial filament<85%, differ.colours','Ots.tejidos de filam.artificiales<85%, hil.dist.colores',10,'54','5408','540833');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('54083400','Outros tecidos de filamentos artificiais<85%,  estampados','Other fabrics of artificial filament<85%, printed','Ots.tejidos de filamentos artificiales<85%, estampados',10,'54','5408','540834');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55011000','Cabos de náilon ou de outras poliamidas','Cables of nylon or other polyamides','Cables de nailon o demás poliamidas',10,'55','5501','550110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55012000','Cabos de poliésteres','Cables of polyesters','Cables de poliésteres',10,'55','5501','550120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55013000','Cabos acrílicos ou modacrílicos','Cables acrylic or modacrylic','Cables acrílicos o modacrílicos',10,'55','5501','550130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55014000','Cabos fil.sintéticos de polipropileno','Cables of synthetic polypropylene filaments','Cables de filamentos sintéticos de polipropileno',10,'55','5501','550140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55019000','Cabos de outros filamentos sintéticos','Cables of other synthetic filament','Cables de otros filamentos sintéticos',10,'55','5501','550190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55020010','Cabos de acetato de celulose','Cellulose acetate tow','Cables de acetato de celulosa',10,'55','5502','550200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55020020','Cabos de raiom viscose','Viscose rayon tow','Cables de rayón viscosa',10,'55','5502','550200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55020090','Cabos de outros filamentos artificiais','Tow of other artificial filament','Cables de otros filamentos artificiales',10,'55','5502','550200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55031010','Fibras de aramida,  não cardadas,  não penteadas,  etc.','Fibres of aramids, no carded, no combed, etc.','Fibras de aramida, sin cardar ni peinar, etc.',10,'55','5503','550310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55031090','Fibras de náilon/outs.poliamidas,  n/cardad.n/pentead.etc','Fibres of nylon/other polyamides, n/carded, n/combed, etc','Fibras de nailon/demás poliamidas, s/cardar n/peinar, etc',10,'55','5503','550310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55031091','Fibras bicompon.náilon/outs.poliamid.n/card.n/pent.etc.','Fibres of nylon bicomp./other polyam., n/card.n/comb.etc','Fibras bicompon.nailon/demás poliam.s/card.n/pein.etc',10,'55','5503','550310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55031099','Fibras de náilon/outs.poliamidas,  n/cardad.n/pentead.etc','Fibres of nylon/other polyamides, n/carded, n/combed, etc','Fibras de nailon/demás poliamidas, s/cardar n/peinar, etc',10,'55','5503','550310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55031100','Fibras de aramida, não cardadas, não penteadas, etc.','Fibres of aramids, no carded, no combed, etc.','Fibras de aramida, sin cardar ni peinar, etc.',10,'55','5503','550311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55031910','Fibras, bicomponentes, d/dif.pontos d/fusão','Bicomponent fibres, of different points of fusion','Fibras bicomponentes, de diferentes puntos de la fusión',10,'55','5503','550319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55031990','Fibras de náilon, outs.poliam., não cardadas, etc.','Fibres of nylon/other polyamides, n/carded, n/combed, etc','Fibras de nailon/demás poliamidas, s/cardar n/peinar, etc',10,'55','5503','550319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55032000','Fibras de poliésteres,  não cardadas,  não penteadas,  etc.','Fibres of polyesters, n/carded, n/combed, etc','Fibras de poliésteres, sin cardar ni peinar, etc.',10,'55','5503','550320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55032010','Bicomponentes, de diferentes pontos de fusão','Bicomponent fibres, of different points of fusion','Fibras bicomponentes, de diferentes puntos de la fusión',10,'55','5503','550320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55032090','Outras','Other fibres','Otras fibras',10,'55','5503','550320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55033000','Fibras acrílicas ou modacrílicas,  não cardadas,  etc.','Acrylic/modacrylic fibres, no carded, etc','Fibras acrílicas o modacrílicas, sin cardar, etc.',10,'55','5503','550330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55034000','Fibras de polipropileno,  não cardadas,  não penteadas,  etc.','Fibres of polypropylene, n/carded, n/combed, etc','Fibras de polipropileno, sin cardar ni peinar, etc.',10,'55','5503','550340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55039000','Outras fibras sintéticas descontinuas,  não cardadas,  etc.','Other synthetic staple fibres, n/carded, etc','Otras fibras sintéticas discontinuas, sin cardar, etc.',10,'55','5503','550390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55039010','Outras fibras bicomponent.sintet.descontin.nao card.etc','Other synthetic bicomponent staple fibres, n/carded, etc','Otras fibras bicomponent.sintét.discontin.sin card.etc',10,'55','5503','550390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55039020','Fibras de poli(álcool vinilico) não cardadas,  etc.','Fibres of poly(vinyl alcohol)no carded, etc.','Fibras de poli(alcohol vinílico) sin cardar, etc',10,'55','5503','550390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55039090','Outras fibras sintéticas descontinuas,  não cardadas,  etc.','Other synthetic bicomponent staple fibres, n/carded, etc','Otras fibras sintéticas discontinuas, sin cardar, etc.',10,'55','5503','550390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55041000','Fibras de raiom viscose,  não cardadas,  não penteadas,  etc.','Fibres of viscose rayon, n/carded, n/combed, etc','Fibras de rayón viscosa, sin cardar ni peinar, etc.',10,'55','5504','550410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55049000','Outras fibras artificiais descontinuas,  não cardadas,  etc','Other artificial staple fibres, n/carded, etc','Otras fibras artificiales discontinuas, sin cardar, etc',10,'55','5504','550490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55049010','Fibra celulosica,  obt.extrusao c/óxido n-metilmorfolina','Cellulosic fibres, obtain.by extrusion with n-methymorp.','Fibra celulósica, obt.extrusión c/óxido n-metilmorfolina',10,'55','5504','550490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55049090','Outras fibras artificiais descontinuas,  não cardadas,  etc','Other artificial staple fibres, no carded, etc','Otras fibras artificiales discontinuas, sin cardar, etc',10,'55','5504','550490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55051000','Desperdícios de fibras sintéticas','Waste of synthetic fibres','Desperdicios de fibras sintéticas',10,'55','5505','550510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55052000','Desperdícios de fibras artificiais','Waste of articificial fibres','Desperdicios de fibras artificiales',10,'55','5505','550520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55061000','Fibras de náilon/outs.poliamidas,  cardadas,  etc.p/fiação','Fibres of nylon/other polyamides, carded, etc.f/spinning','Fibras de nailon/demás poliamidas, cardadas, etc.p/hilat.',10,'55','5506','550610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55062000','Fibras de poliésteres,  cardadas,  penteadas,  etc.p/fiação','Fibres of polyesters, carded, combed, etc.f/spinning','Fibras de poliésteres, cardadas, peinadas, etc.p/hilatura',10,'55','5506','550620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55063000','Fibras acrílicas ou modacrílicas,  cardadas,  etc.p/fiação','Acrylic/modacrylic fibres, carded, combed, etc.f/spinning','Fibras acrílicas o modacrílicas, cardadas, etc.p/hilatura',10,'55','5506','550630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55069000','Outs.fibras sintéticas,  cardadas,  penteadas,  etc.p/fiação','Other synthetic fibres, carded, combed, etc.f/spinning','Ots.fibras sintéticas, cardadas, peinadas, etc.p/hilatura',10,'55','5506','550690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55070000','Fibras artificiais,  cardadas,  penteadas,  etc.p/fiação','Artificial fibres, carded, combed, etc.f/spinning','Fibras artificiales, cardadas, peinadas, etc.p/hilatura',10,'55','5507','550700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55081000','Linha para costura, de fibras sintéticas','Sewing thread, of synthetic fibres','Hilo para coser, de fibras sintéticas',10,'55','5508','550810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55082000','Linha para costura, de fibras artificiais','Sewing thread, of artificial fibres','Hilo para coser, de fibras artificiales',10,'55','5508','550820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55091100','Fio de fibras de náilon/outras poliamidas>=85%,  simples','Yarn of nylon fibres/other polyam.>=85%, single','Hilado de fibras de nailon/demás poliam.>=85%, sencillo',10,'55','5509','550911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55091210','Fio de fibras de aramida>=85%,  retorcido/retorc.múltiplo','Yarn of aramid fibres>=85%, twisted/twisted multiple','Hilado de fibras de aramida>=85%, retorcido/cableado',10,'55','5509','550912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55091290','Fio de fibras de náilon/outs.poliamidas>=85%,  retorc.etc','Yarn of nylon fibres/other polyam.>=85%, twisted, etc.','Hilado de fibras de nailon/demás poliam>=85%, retorc.etc',10,'55','5509','550912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55092100','Fio de fibras de poliésteres>=85%,  simples','Yarn of polyesters fibres>=85%, single','Hilado de fibras de poliésteres>=85%, sencillo',10,'55','5509','550921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55092200','Fio de fibras de poliésteres>=85%,  retorcido/retorc.mult','Yarn of polyesters fibres>=85%, multiple(folded)/cabled','Hilado de fibras de poliésteres>=85%, retorcido/cableado',10,'55','5509','550922');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55093100','Fio de fibras acrílicas/modacrílicas>=85%,  simples','Yarn of acrylics/modacrylics fibres>=85%, single','Hilado de fibras acrílicas/modacrílicas>=85%, sencillo',10,'55','5509','550931');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55093200','Fio de fibras acrílicas/modacrílicas>=85%,  retorcido,  etc','Yarn of acrylics/modacrylics fibres>=85%, folded, etc','Hilado de fibras acrílicas/modacrílicas>=85%, retorc.etc',10,'55','5509','550932');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55094100','Fio de outras fibras sintéticas >= 85%, simples','Yarn of other synthetic fibres>=85%, single','Hilado de otras fibras sintéts.>=85%, sencillo',10,'55','5509','550941');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55094200','Fio de outs.fibras sintets>=85%,  retorcido/retorc.multip','Yarn of oth.synthet.fibres>=85%, multip.(folded)/cabled','Hilado de ots.fibras sintéts.>=85%, retorcido/cableado',10,'55','5509','550942');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55095100','Fio de fibras de poliésteres com fibras artificiais','Yarn of fibres of polyesters with artificial fibres','Hilado de fibras de poliésteres con fibras artificiales',10,'55','5509','550951');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55095200','Fio de fibras de poliésteres com lã ou pêlos finos','Yarn of fibres of polyesters with wool/fine animal hair','Hilado de fibras de poliésteres con lana o pelo fino',10,'55','5509','550952');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55095300','Fio de fibras de poliésteres com algodão','Yarn of fibres of polyesters with cotton','Hilado de fibras de poliésteres con algodón',10,'55','5509','550953');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55095900','Outros fios de fibras de poliésteres','Other yarn of fibres of polyesters','Otros hilados de fibras de poliésteres',10,'55','5509','550959');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55096100','Fio de fibras acrílicas/modacrílicas com la/pêlos finos','Yarn of acrylics/modacr.fibres with wool/fine anim.hair','Hilad.de fibras acrílicas/modacrílicas c/lana/pelo fino',10,'55','5509','550961');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55096200','Fio de fibras acrílicas/modacrílicas com algodão','Yarn of acrylics/modacrylics fibres with cotton','Hilado de fibras acrílicas/modacrílicas con algodón',10,'55','5509','550962');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55096900','Outros fios de fibras acrílicas ou modacrílicas','Other yarn of acrylics/modacrylics fibres','Otros hilados de fibras acrílicas o modacrílicas',10,'55','5509','550969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55099100','Fio de outras fibras sintéticas com lã ou pêlos finos','Yarn of other synth.fibres with wool/fine anim.hair','Hilado de otras fibras sintéticas con lana o pelo fino',10,'55','5509','550991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55099200','Fio de outras fibras sintéticas com algodão','Yarn of other synthetic fibres with cotton','Hilado de otras fibras sintéticas con algodón',10,'55','5509','550992');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55099900','Outros fios de fibras sintéticas','Other yarns of synthetic fibres','Otros hilados de fibras sintéticas',10,'55','5509','550999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55101100','Fio de fibras artificiais>=85%, simples','Yarn of artificial fibres>=85%, single','Hilado de fibras artificiales>=85%, sencillo',10,'55','5510','551011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55101200','Fio de fibras artificiais>=85%,  retorcido/retorc.multipl','Yarn of artificial fibres>=85%, multiple(folded)/cabled','Hilado de fibras artificiales>=85%, retorcido/cableado',10,'55','5510','551012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55102000','Fio de fibras artificiais com la ou pêlos finos','Yarn of artificial fibres with wool or fine animal hair','Hilado de fibras artificiales con lana o pelo fino',10,'55','5510','551020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55103000','Fio de fibras artificiais com algodão','Yarn of artificial fibres with cotton','Hilado de fibras artificiales con algodón',10,'55','5510','551030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55109000','Outros fios de fibras artificiais','Other yarns of artificial fibres','Otros hilados de fibras artificiales',10,'55','5510','551090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55111000','Fio de fibras sintéticas>=85%, para venda a retalho','Yarn of synthetic fibres>=85%, for retail sale','Hilado de fibras sintéticas>=85%, p/la venta por menor',10,'55','5511','551110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55112000','Fio de fibras sintéticas<85%, para venda a retalho','Yarn of synthetic fibres<85%, for retail sale','Hilado de fibras sintéticas<85%, p/la venta al por menor',10,'55','5511','551120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55113000','Fio de fibras artificiais, para venda a retalho','Yarns of artificial fibres, for retail sale','Hilado de fibras artificiales, p/la venta al por menor',10,'55','5511','551130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55121100','Tecido de fibras de poliéster>=85%,  crus ou branqueados','Fabric of polyester fibres>=85%, raw or bleached','Tejido de fibras de poliéster>=85%, crudo o blanqueado',10,'55','5512','551211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55121900','Tecido de outras fibras de poliéster>=85%','Fabric of other polyester fibres>=85%','Tejido de otras fibras de poliéster>=85%',10,'55','5512','551219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55122100','Tecido de fibras acrílicas/modacrílicas>=85%,  cru/branq.','Fabric of acrylics/modacrylics fibres>=85%, raw/bleach.','Tejido fibras acrílicas/modacrílicas>=85%, crudo/branq.',10,'55','5512','551221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55122900','Tecido de outras fibras acrílicas ou modacrílicas>=85%','Fabric of other acrylics/modacrylics fibres>=85%','Tejido de otras fibras acrílicas o modacrílicas>=85%',10,'55','5512','551229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55129110','Tecido de fibras de aramida>=85%, cru ou branqueado','Fabric of aramid fibres>=85%, raw or bleached','Tejido de fibras de aramida>=85%, crudo o blanqueado',10,'55','5512','551291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55129190','Tecido de outs.fibras sint.descont.>=85%,  cru/branqueado','Fabric of other synthetic staple fibres>=85%, raw/bleac.','Tejido de ots.fibras sint.discont.>=85%, crudo/blanq.',10,'55','5512','551291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55129910','Outros tecidos de fibras de aramida>=85%','Other fabrics of other aramid fibres>=85%','Otros tejidos de fibras de aramida>=85%',10,'55','5512','551299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55129990','Outros tecidos de fibras sintéticas descontinuas>=85%','Other fabrics of other synthetic staple fibres>=85%','Otros tejidos de fibras sintéticas discontinuas>=85%',10,'55','5512','551299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55131100','Tecido poliest<85% c/algod.p<=170g/m2,  tafeta,  cru/branq.','Fabric polyest<85% with cot.w<=170g/m2, taf.raw/blec.','Tejido poliést<85% c/alg.p<=170g/m2, tafetán, crudo/branq',10,'55','5513','551311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55131200','Tecido poliest<85% c/algod.p<=170g/m2,  sarjado,  cru/branq','Fabric polyest<85% with cot.w<=170g/m2, twill, raw/blec.','Tejido poliést<85% c/algod.p<=170g/m2, sarga, crudo/blanq',10,'55','5513','551312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55131300','Outs.tecidos poliéster<85% c/algod.p<=170g/m2,  cru/branq','Oth.fabrics polyest<85% with cot.w<=170g/m2, raw/blec.','Ots.tejidos poliéster<85% c/alg.p<=170g/m2, crudo/blanq',10,'55','5513','551313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55131900','Outs.tecidos fibr.sint<85% c/algod.p<=170g/m2,  cru/branq','Oth.fabrics synt.fibr<85% with cot.w<=170g/m2, raw/blec.','Ots.tejidos fibr.sint<85% c/alg.p<=170g/m2, crudo/blanq',10,'55','5513','551319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55132100','Tecido poliéster<85% c/algodão,  p<=170g/m2,  tafeta,  tinto','Fabric polyester<85% with cot.w<=170g/m2, taf.dyed','Tejido poliéster<85% c/algodón, p<=170g/m2, tafet., teñido',10,'55','5513','551321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55132200','Tecido poliéster<85% c/algodão,  p<=170g/m2,  sarjado,  tinto','Fabric polyester<85% with cot.w<=170g/m2, twill, dyed','Tejido poliéster<85% c/algodón, p<=170g/m2, sarga, teñido',10,'55','5513','551322');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55132300','Outs.tecidos poliéster<85% c/algodão,  p<=170g/m2,  tintos','Fabric polyester<85% with cot.w<=170g/m2, dyed','Ots.tejidos poliéster<85% c/algodón, p<=170g/m2, teñidos',10,'55','5513','551323');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55132310','Tecidos tintos -85% fibr.desc.pol.diag.têxt.<4','Fabrics < 85% polyester staple fibres by weight, diag. texture <4, dyed','Tejidos teñidos con un alto contenido de fibras discontinuas de poliéster (<85%), diag. textura <4',10,'55','5513','551323');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55132390','Outs.tec.tintos<85% fibras desc.d/poliéster','Other fabrics < 85% polyester staple fibres by weight, dyed','Otros tejidos teñidos con un alto contenido de fibras discontinuas de poliéster (<85%)',10,'55','5513','551323');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55132900','Outs.tecidos fibra sint<85% c/algodão,  p<=170g/m2,  tintos','Ot.fabric synt.fibres<85% with cot.w<=170g/m2, dyed','Ots.tejidos fibra sint<85% c/algodón, p<=170g/m2, teñidos',10,'55','5513','551329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55133100','Tecido poliest<85% c/algod.p<=170g/m2,  tafeta,  divs.cores','Fabric polyest<85% with cot.w<=170g/m2, taf.dif.colours','Tejido poliést<85% c/algod.p<=170g/m2, tafet.dist.color',10,'55','5513','551331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55133200','Tecido poliest<85% c/algod.p<=170g/m2,  sarjad.divs.cores','Fabric polyest<85% with cot.w<=170g/m2, twill, dif.col.','Tejido poliést<85% c/algod.p<=170g/m2, sarga, dist.color.',10,'55','5513','551332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55133300','Outs.tecidos poliest<85% c/algod.p<=170g/m2,  divs.cores','Oth.fabrics polyest<85% with cot.w<=170g/m2, dif.col.','Ots.tejidos poliést<85% c/algod.p<=170g/m2, dist.colores',10,'55','5513','551333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55133900','Outs.tecidos fibr.sint<85% c/algod.p<=170g/m2,  div.cores','Ot.fabrics synt.fibres<85% with cot.w<=170g/m2, dif.col.','Ots.tejidos fibr.sint<85% c/algod.p<=170g/m2, dist.col.',10,'55','5513','551339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55133911','Tec.div.cores,  <85% fib.desc.pol.diag.têxt.<4','Fabrics made from yarn of different colours, < 85% polyester staple fibres by weight, diag. texture <4','Tejidos fabricados con hilos de distintos colores, con un alto contenido de fibras discontinuas de poliéster (<85%), diag. textura <4',10,'55','5513','551339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55133919','Outs.tec.<85% d/fibras desc.poliéster<170g/m','Other fabrics < 85% polyester staple fibres by weight, w<170g/m2','Otros tejidos con un alto contenido de fibras discontinuas de poliéster (<85%), p<170g/m2',10,'55','5513','551339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55133990','Outs.tec.<85% d/fibras desc.sint.comb.c/alg.','Other fabrics < 85% synthetic staple fibres by weight, mixed with cotton','Otros tejidos con un alto contenido de fibras sintéticas discontinuas (<85%), mezclados con algodón ',10,'55','5513','551339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55134100','Tecido poliéster<85% c/algodão,  p<=170g/m2,  tafeta,  estamp','Fabric polyest<85% with cot.w<=170g/m2, taffeta, printed','Tejido poliéster<85% c/algodón, p<=170g/m2, tafet., estamp',10,'55','5513','551341');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55134200','Tecido poliéster<85% c/algodão,  p<=170g/m2,  sarjad.estamp','Fabric polyest<85% with cot.w<=170g/m2, twill, printed','Tejido poliéster<85% c/algodón, p<=170g/m2, sarga, estamp.',10,'55','5513','551342');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55134300','Outs.tecidos poliéster<85% c/algodão,  p<=170g/m2,  estamp.','Other fabrics polyest<85% with cot.w<=170g/m2, printed','Ots.tejidos poliéster<85% c/algodón, p<=170g/m2, estamp.',10,'55','5513','551343');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55134900','Outs.tecidos fibra sint<85% c/algodão,  p<=170g/m2,  estamp','Other fabrics synt.fibr<85% with cot.w<=170g/m2, printed','Ots.tejidos fibra sint<85% c/algodón, p<=170g/m2, estamp',10,'55','5513','551349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55134911','Tec.est.<85%fibras desc.pol.diag.comb.c/alg.','Printed fabrics < 85% polyester staple fibres by weight, mixed with cotton','Tejidos estampados con un alto contenido de fibras discontinuas de poliéster (<85%), mezclados con algodón',10,'55','5513','551349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55134919','Outs.tec.<85%d/fibras desc.pol.comb.c/alg.','Other fabrics < 85% polyester staple fibres by weight, mixed with cotton','Otros tejidos con un alto contenido de fibras discontinuas de poliéster (<85%), mezclados con algodón',10,'55','5513','551349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55134990','Outs.tec.<85%d/fibras desc.sint.comb.c/alg.','Other fabrics < 85% synthetic staple fibres by weight, mixed with cotton','Otros tejidos con un alto contenido de fibras sintéticas discontinuas (<85%), mezclados con algodón',10,'55','5513','551349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55141100','Tecido poliéster<85% c/algod.p>170g/m2,  tafeta,  cru/branq','Fabric polyester<85% with cot.w>170g/m2, taf.raw/bleac','Tejido poliéster<85% c/alg.p>170g/m2, tafet., crudo/blanq',10,'55','5514','551411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55141200','Tecido poliéster<85% c/algod.p>170g/m2,  sarjad.cru/branq','Fabric polyester<85% with cot.w>170g/m2, twill, raw/bleac','Tejido poliéster<85% c/alg.p>170g/m2, sarga, crudo/blanq',10,'55','5514','551412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55141300','Outs.tecidos poliéster<85% c/algod.p>170g/m2,  cru/branq.','Other fabric polyester<85% with cot.w>170g/m2, raw/bleac','Ots.tejidos poliéster<85% c/algod.p>170g/m2, crudo/blanq',10,'55','5514','551413');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55141900','Outs.tecidos fibra sint<85% c/algod.p>170g/m2,  cru/branq','Oth.fabric synt.fibres<85% with cot.w>170g/m2, raw/bleac','Ots.tejidos fibra sint<85% c/alg.p>170g/m2, crudo/blanq',10,'55','5514','551419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55141910','Outs.tec.<85%fibra desc.pol.cru/branq,  c/alg','Other fabrics < 85% polyester staple fibres by weight, raw/bleached, mixed with cotton','Otros tejidos con un alto contenido de fibras discontinuas de poliéster (<85%), crudos o blanqueados, mezclados con algodón',10,'55','5514','551419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55141990','Outs.tec.<85%fibr.sint.desc.cru/branq,  c/alg.','Other fabrics < 85% synthetic staple fibres by weight, raw/bleached, mixed with cotton','Otros tejidos con un alto contenido de fibras sintéticas discontinuas (<85%), crudos o blanqueados, mezclados con algodón',10,'55','5514','551419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55142100','Tecido poliéster<85% c/algodão,  p>170g/m2,  tafeta,  tinto','Fabric polyest<85% with cot.w>170g/m2, taffeta, dyed','Tejido poliéster<85% c/algodón, p>170g/m2, tafetán, teñido',10,'55','5514','551421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55142200','Tecido poliéster<85% c/algodão,  p>170g/m2,  sarjado,  tinto','Fabric polyest<85% with cot.w>170g/m2, twill, dyed','Tejido poliéster<85% c/algodón, p>170g/m2, sarga, teñido',10,'55','5514','551422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55142300','Outros tecidos poliéster<85% c/algodão,  p>170g/m2,  tintos','Other fabrics polyest<85% with cot.w>170g/m2, dyed','Otros tejidos poliéster<85% c/algodón, p>170g/m2, teñidos',10,'55','5514','551423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55142900','Outs.tecidos fibra sint<85% c/alcodao,  p>170g/m2,  tintos','Other fabrics synth.fibres<85% with cot.w>170g/m2, dyed','Ots.tejidos fibra sint<85% c/algodón, p>170g/m2, teñidos',10,'55','5514','551429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55143011','Tecidos<85% fibr.desc.pol.tafetá comb.c/alg.','Fabrics < 85% polyester staple fibres by weight, point taffeta, mixed with cotton','Tejidos con un alto contenido de fibras discontinuas de poliéster (<85%), de ligamento tafetán, mezclados con algodón',10,'55','5514','551430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55143012','Tec.<85%fibr.desc.cores,  c/alg.ponto sarjado','Fabrics < 85% synthetic staple fibres by weight, made of yarn of different colours, mixed with cotton, point twill','Tejidos con un alto contenido de fibras sintéticas discontinuas (<85%), con hilados de distintos colores, mezclados con algodón, de ligamento sarga',10,'55','5514','551430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55143019','Outs.tec.<85% fibras desc.pol.,  cores,   c/alg.','Other fabrics < 85% polyester staple fibres by weight, made of yarn of different colours, mixed with cotton','Otros tejidos con un alto contenido de fibras discontinuas de poliéster (<85%), con hilados de distintos colores, mezclados con algodón',10,'55','5514','551430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55143090','Outs.tec.<85% fibras desc.sint.,  cores,   c/alg.','Other fabrics < 85% synthetic staple fibres by weight, made of yarn of different colours, mixed with cotton','Otros tejidos con un alto contenido de fibras sintéticas discontinuas (<85%), con hilados de distintos colores, mezclados con algodón',10,'55','5514','551430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55143100','Tecido poliest<85% c/algodão,  p>170g/m2,  tafeta,  div.cores','Fabric polyest<85% with cot.w>170g/m2, taf.difer.colours','Tejido poliést<85% c/algod., p>170g/m2, tafet.dist.color.',10,'55','5514','551431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55143200','Tecido poliest<85% c/algodão,  p>170g/m2,  sarjad.div.cores','Fabric polyest<85% with cot.w>170g/m2, twill, dif.colours','Tejido poliést<85% c/algod., p>170g/m2, sarga, dist.color.',10,'55','5514','551432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55143300','Outs.tecidos poliéster<85% c/algod.p>170g/m2,  div.cores','Oth.fabrics polyest<85% with cot.w>170g/m2, dif.colours','Ots.tejidos poliéster<85% c/algod.p>170g/m2, dist.color.',10,'55','5514','551433');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55143900','Outs.tecidos fibra sint<85% c/algod.p>170g/m2,  div.cores','Other fabrics synt.fibr<85% with cot.w>170g/m2, dif.col.','Ots.tejidos fibra sint<85% c/alg.p>170g/m2, dist.colores',10,'55','5514','551439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55144100','Tecido poliéster<85% c/algodão,  p>170g/m2,  tafeta,  estamp.','Fabric polyest<85% with cotton, w>170g/m2, taf.printed','Tejido poliéster<85% c/algodón, p>170g/m2, tafetán, estamp',10,'55','5514','551441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55144200','Tecido poliéster<85% c/algodão,  p>170g/m2,  sarjado,  estamp','Fabric polyest<85% with cotton, w>170g/m2, twill, printed','Tejido poliéster<85% c/algodón, p>170g/m2, sarga, estamp.',10,'55','5514','551442');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55144300','Outros tecidos poliéster<85% c/algodão,  p>170g/m2,  estamp','Other fabrics polyester<85% with cot.w>170g/m2, printed','Otros tejidos poliéster<85% c/algodón, p>170g/m2, estamp',10,'55','5514','551443');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55144900','Outs.tecidos fibra sint<85% c/algodão,  p>170g/m2,  estamp.','Other fabrics synt.fibr<85% with cot.w>170g/m2, printed','Ots.tejidos fibra sint<85% c/algodón, p>170g/m2, estamp.',10,'55','5514','551449');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55151100','Tecido de fibras de poliéster com raiom viscose','Fabric of polyester fibres with rayon viscose','Tejido de fibras de poliéster con rayón viscosa',10,'55','5515','551511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55151200','Tecido de fibras de poliéster com filamento sint/artif.','Fabric of polyester fibres with filament synt/artif.','Tejido de fibras de poliéster con filamento sint/artif.',10,'55','5515','551512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55151300','Tecido de fibras de poliéster com lã ou pêlos finos','Fabric of polyester fibres with wool/fine anim.hair','Tejido de fibras de poliéster con lana o pelo fino',10,'55','5515','551513');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55151900','Outros tecidos de fibras de poliéster','Other fabrics of polyester fibres','Otros tejidos de fibras de poliéster',10,'55','5515','551519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55152100','Tecido de fibras acrílicas,  etc.com filamento sint/artif','Fabric of acrylic fibres, etc.with filament synt/artif','Tejido de fibras acrílicas, etc.con filamento sint/artif',10,'55','5515','551521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55152200','Tecido de fibras acrílicas,  etc.com lã ou pêlos finos','Fabric of acrylic fibres, etc.with wool/fine anim.hair','Tejido de fibras acrílicas, etc.con lana o pelo fino',10,'55','5515','551522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55152900','Outros tecidos de fibras acrílicas ou modacrílicas','Other fabrics of acrylic/modacrylic fibres','Otros tejidos de fibras acrílicas o modacrílicas',10,'55','5515','551529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55159100','Tecido de outras fibras sintéticas com filam.sint/artif','Fabric of other synthetic fibres with filament synt/art','Tejido de otras fibras sintéticas con filam.sint/artif',10,'55','5515','551591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55159200','Tecido de outs.fibras sintéticas com la ou pêlos finos','Fabric of oth.synthetic fibres with wool/fine anim.hair','Tejido de ots.fibras sintéticas con lana o pelo fino',10,'55','5515','551592');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55159900','Outros tecidos de fibras sintéticas','Other fabrics synthetic fibres','Otros tejidos de fibras sintéticas',10,'55','5515','551599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55159910','Outs.tec.d/fibras sint.desc.c/lã/pêlos finos','Other fabrics of synthetic staple fibres, with wool or fine animal hair ','Otros tejidos de fibras sintéticas discontinuas, con lana o pelo fino ',10,'55','5515','551599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55159990','Outros tecidos de fibras sintéticas descontínuas','Other fabrics of synthetic staple fibres ','Otros tejidos de fibras sintéticas discontinuas ',10,'55','5515','551599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55161100','Tecido de fibras artificiais>=85%, cru ou branqueado','Fabric of artificial fibres>=85%, raw, bleached','Tejido de fibras artificiales>=85%, crudo o blanqueado',10,'55','5516','551611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55161200','Tecido de fibras artificiais>=85%, tinto','Fabric of artificial fibres>=85%, dyed','Tejido de fibras artificiales>=85%, teñido',10,'55','5516','551612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55161300','Tecido de fibras artificiais>=85%,  de fios de divs.cores','Fabric of artificial fibres>=85%, of yarns of difer.col.','Tejido de fibras artifs.>=85%, c/hilados de dist.colores',10,'55','5516','551613');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55161400','Tecido de fibras artificiais>=85%, estampado','Fabric of artificial fibres>=85%, printed','Tejido de fibras artificiales>=85%, estampado',10,'55','5516','551614');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55162100','Tecido de fibras artif<85% c/filam.sint/artif.cru/branq','Fabric of artif.fibres<85%with filam.synt/art.raw/blea','Tejido de fibras artif<85% c/fil.sint/artif.crudo/blanq',10,'55','5516','551621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55162200','Tecido de fibras artif<85% com filam.sint/artif.tinto','Fabric of artif.fibres<85%with filam.synt/artif.dyed','Tejido de fibras artif<85% con filam.sint/artif.teñido',10,'55','5516','551622');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55162300','Tecido de fibras artif<85% com filam.sint/artif.cores','Fabric of artif.fibres<85%with filam.synt/art.colours','Tejido de fibras artif<85% con filam.sint/artif.colores',10,'55','5516','551623');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55162400','Tecido de fibras artif<85% com filam.sint/artif.estamp.','Fabric of artif.fibres<85%with filam.synt/art.printed','Tejido de fibras artif<85% con filam.sint/artif.estamp.',10,'55','5516','551624');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55163100','Tecido de fibras artif<85% com la/pêlos finos,  cru/branq','Fabric of artif.fib<85%with wool/fine anim.hair, raw/ble','Tejido de fibras artif<85% c/lana/pelo fino, crudo/blanq',10,'55','5516','551631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55163200','Tecido de fibras artif<85% com la/pêlos finos, tinto','Fabric of artif.fib<85%with wool/fine anim.hair, dyed','Tejido de fibras artif<85% con lana/pelo fino, teñido',10,'55','5516','551632');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55163300','Tecido de fibras artif<85% com la/pêlos finos,  div.cores','Fabric of artif.fib<85%with wool/fine anim.hair, dif.col','Tejido de fibras artif<85% con lana/pelo fino, dist.col.',10,'55','5516','551633');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55163400','Tecido de fibras artif<85% com la/pêlos finos,  estampado','Fabric of artif.fib<85%with wool/fine anim.hair, printed','Tejido de fibras artif<85% con lana/pelo fino, estampado',10,'55','5516','551634');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55164100','Tecido de fibras artif<85% com algodão,  cru/branqueado','Fabric of artif.fibres<85%with cotton, raw/bleached','Tejido de fibras artif<85% con algodón, crudo/blanqueado',10,'55','5516','551641');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55164200','Tecido de fibras artif<85% com algodão, tinto','Fabric of artif.fibres<85%with cotton, dyed','Tejido de fibras artif<85% con algodón, teñido',10,'55','5516','551642');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55164300','Tecido de fibras artif<85% com algodão, fio divs.cores','Fabric of artif.fibr<85%with cotton, yarn of dif.colours','Tejido de fibras artif<85% con algodón, hil.dist.colores',10,'55','5516','551643');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55164400','Tecido de fibras artif<85% com algodão, estampado','Fabric of artif.fibres<85%with cotton, printed','Tejido de fibras artif<85% con algodón, estampado',10,'55','5516','551644');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55169100','Outs.tecidos de fibras artificiais, crus ou branqueados','Other fabrics of artificial fibres, raw/bleached','Ots.tejidos de fibras artificiales, crudos o blanqueados',10,'55','5516','551691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55169200','Outros tecidos de fibras artificiais, tintos','Other fabrics of artificial fibres, dyed','Otros tejidos de fibras artificiales, teñidos',10,'55','5516','551692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55169300','Outros tecidos de fibras artificiais,  de fios divs.cores','Other fabrics of artificial fibres, of dif.colours','Otros tejidos de fibras artificiales, c/hil.dist.colores',10,'55','5516','551693');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('55169400','Outros tecidos de fibras artificiais, estampados','Other fabrics of artificial fibres, printed','Otros tejidos de fibras artificiales, estampados',10,'55','5516','551694');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56011000','Absorventes e tampões,  etc.de pastas de matérias têxteis','Wadding and tampons, etc.of wadding of textile materials','Comprensas y tampones, etc.de guata de materia textil',10,'56','5601','560110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56012110','Pastas ("ouates") de algodão','Wadding of cotton','Guatas de algodón',10,'56','5601','560121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56012190','Outros artigos de pastas ("ouates") de algodão','Other articles of cotton wadding','Otros artículos de guatas de algodón',10,'56','5601','560121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56012211','Pastas ("ouates") de fibras de aramida','Wadding of aramid fibres','Guatas de fibras de aramida',10,'56','5601','560122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56012219','Pastas ("ouates") de outs.fibras sintéticas/artificiais','Wadding of other fibres synthetic/artificial','Guatas de ots.fibras sintéticas/artificiales',10,'56','5601','560122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56012291','Cilindros para filtro cigarros, de pastas fibras sint/artif','Filter tips for cigarettes, of fibres synt/artif wadding','Cilindros p/filtro cigarrilos, de guatas fibras sint/art',10,'56','5601','560122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56012299','Outs.artigos de pastas de fibras sintéticas/artificiais','Oth.articles of wadding of fibres synth/artificial','Ots.artículos de guatas de fibras sintéticas/artifs.',10,'56','5601','560122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56012900','Pastas/outs.artigos de pastas,  de outs.matérias têxteis','Wadding/oth.wadding articles, of oth.textile materials','Guatas/ots.artículos de guatas, de ots.materias textiles',10,'56','5601','560129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56013010','Tontisses, nós e bolotas, de fibras de aramida','Textile flock and dust, of aramid fibres','Tundiznos, nudos y motas, de fibras de aramida',10,'56','5601','560130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56013090','Tontisses, nós e bolotas, de outras matérias têxteis','Textile flock and dust, of textile materials','Tundiznos, nudos y motas, de otras materias textiles',10,'56','5601','560130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56021000','Feltros agulhados/artefs.da costura por entrelaçamento','Needleloom felt/stitch-bonded fibre fabrics','Fieltros punzonados/prods.obt.mediante cost.porcadeneta',10,'56','5602','560210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56022100','Feltros de lã/pêlos finos, não impregnados, n/revests.etc.','Felt of wool/fine anim.hair, n/impregnated, n/covered, etc','Fieltros de lana/pelo fino, s/impregnar, n/revestir, etc.',10,'56','5602','560221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56022900','Feltros de outras maters.têxteis,  n/impregn.n/revest.etc','Felt of other textile mater.n/impregnat.n/covered, etc','Fieltros de ots.maters.textiles, s/impregn.n/revest.etc',10,'56','5602','560229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56029000','Outs.feltros impregnados/revestidos/recobertos/estratif','Other felt impregnated/covered/coated/laminated','Ots.fieltros impregnados/revestidos/recubiertos/estrat.',10,'56','5602','560290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031110','Falsos tecidos de filamentos de aramida,  peso<=25g/m2','Non-wovens of aramid filaments, weight<=25g/m2','Telas sin tejer de filamentos de aramida, peso<=25g/m2',10,'56','5603','560311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031120','Falsos tecidos de poliester','Falsos tecidos de poliester','Falsos tecidos de poliester',10,'56','5603','560311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031130','Falsos tecidos de polipropileno','Falsos tecidos de polipropileno','Falsos tecidos de polipropileno',10,'56','5603','560311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031140','Falsos tecidos de raiom viscose','Falsos tecidos de raiom viscose','Falsos tecidos de raiom viscose',10,'56','5603','560311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031190','Falsos tecidos de outs.filamentos sint/artif.p<=25g/m2','Non-wovens of other filaments synt/artif, weight<=25g/m2','Telas sin tejer de ots.filamentos sint/artif.p<=25g/m2',10,'56','5603','560311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031210','Falsos tecidos de filam.poliet.alta dens.25<p<=70g/m2','Non-wovens of high densit.polyet.filaments 25<w<=70g/m2','Telas sin tejer de filam.poliet.alta dens.25<p<=70g/m2',10,'56','5603','560312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031220','Falsos tecidos de filamentos de aramida,  25<p<=70g/m2','Non-wovens of aramid filaments 25<w<=70g/m2','Telas sin tejer de filamentos de aramida, 25<p<=70g/m2',10,'56','5603','560312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031230','Falsos tecidos de poliester','Falsos tecidos de poliester','Falsos tecidos de poliester',10,'56','5603','560312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031240','Falsos tecidos de polipropileno','Falsos tecidos de polipropileno','Falsos tecidos de polipropileno',10,'56','5603','560312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031250','Falsos tecidos de raiom viscose','Falsos tecidos de raiom viscose','Falsos tecidos de raiom viscose',10,'56','5603','560312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031290','Falsos tecidos de outros filam.sint/artif.25<p<=70g/m2','Non-wovens of other synth/artif filaments 25<w<=70g/m2','Telas sin tejer de otros filam.sint/artif.25<p<=70g/m2',10,'56','5603','560312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031310','Falsos tecidos de filam.poliet.alta dens.70<p<=150g/m2','Non-wovens of high densit.polyet.filam.70<w<=150g/m2','Telas sin tejer de filam.poliet.alta dens.70<p<=150g/m2',10,'56','5603','560313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031320','Falsos tecidos de filamentos de aramida,  70<p<=150g/m2','Non-wovens of aramid filaments 70<w<=150g/m2','Telas sin tejer de filamentos de aramida, 70<p<=150g/m2',10,'56','5603','560313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031330','Falsos tecidos de poliester','Falsos tecidos de poliester','Falsos tecidos de poliester',10,'56','5603','560313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031340','Falsos tecidos de polipropileno','Falsos tecidos de polipropileno','Falsos tecidos de polipropileno',10,'56','5603','560313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031350','Falsos tecidos de raiom viscose','Falsos tecidos de raiom viscose','Falsos tecidos de raiom viscose',10,'56','5603','560313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031390','Falsos tecidos de outros filam.sint/artif.70<p<=150g/m2','Non-wovens of other synth/artif filaments 70<w<=150g/m2','Telas sin tejer de otros filam.sint/artif.70<p<=150g/m2',10,'56','5603','560313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031410','Falsos tecidos de filamentos de aramida,  peso>150g/m2','Non-wovens of aramid filaments, weight>150g/m2','Telas sin tejer de filamentos de aramida, peso>150g/m2',10,'56','5603','560314');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031420','Falsos tecidos de poliester','Falsos tecidos de poliester','Falsos tecidos de poliester',10,'56','5603','560314');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031430','Falsos tecidos de polipropileno','Falsos tecidos de polipropileno','Falsos tecidos de polipropileno',10,'56','5603','560314');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031440','Falsos tecidos de raiom viscose','Falsos tecidos de raiom viscose','Falsos tecidos de raiom viscose',10,'56','5603','560314');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56031490','Falsos tecidos de outs.filamentos sint/artif.p>150g/m2','Non-wovens of other synth/artif filaments w>150g/m2','Telas sin tejer de ots.filamentos sint/artif.p>150g/m2',10,'56','5603','560314');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039100','Outros falsos tecidos, peso<=25g/m2','Other non-wovens, weight<=25g/m2','Otras telas sin tejer, peso<=25g/m2',10,'56','5603','560391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039110','Outros falsos tecidos de poliester,peso<=25g/m2','Outros falsos tecidos de poliester,peso<=25g/m2','Outros falsos tecidos de poliester,peso<=25g/m2',10,'56','5603','560391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039120','Outros falsos tecidos de polipropileno,peso<=25g/m2','Outros falsos tecidos de polipropileno,peso<=25g/m2','Outros falsos tecidos de polipropileno,peso<=25g/m2',10,'56','5603','560391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039130','Outros falsos tecidos de raiom viscose,peso<=25g/m2','Outros falsos tecidos de raiom viscose,peso<=25g/m2','Outros falsos tecidos de raiom viscose,peso<=25g/m2',10,'56','5603','560391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039190','Outros falsos tecidos,peso<=25g/m2','Outros falsos tecidos,peso<=25g/m2','Outros falsos tecidos,peso<=25g/m2',10,'56','5603','560391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039210','Outs.falsos tecidos,  polietileno alta dens.25<p<=70g/m2','Oth.non-wovens of high densit.polyethylene 25<w<=70g/m2','Ots.telas sin tejer, polietileno alta dens.25<p<=70g/m2',10,'56','5603','560392');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039220','Outros falsos tecidos de poliester,25g/m2<peso<=70g/m2','Outros falsos tecidos de poliester,25g/m2<peso<=70g/m2','Outros falsos tecidos de poliester,25g/m2<peso<=70g/m2',10,'56','5603','560392');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039230','Outros falsos tecidos polipropileno,25g/m2<peso<=70g/m2','Outros falsos tecidos polipropileno,25g/m2<peso<=70g/m2','Outros falsos tecidos polipropileno,25g/m2<peso<=70g/m2',10,'56','5603','560392');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039240','Outros falsos tecidos raiom viscose,25g/m2<peso<=70g/m2','Outros falsos tecidos raiom viscose,25g/m2<peso<=70g/m2','Outros falsos tecidos raiom viscose,25g/m2<peso<=70g/m2',10,'56','5603','560392');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039290','Outros falsos tecidos, 25g/m2<peso<=70g/m2','Other non-wovens, 25g/m2<weight<=70g/m2','Otras telas sin tejer, 25g/m2<peso<=70g/m2',10,'56','5603','560392');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039310','Outs.falsos tecidos,  polietileno alta dens.70<p<=150g/m2','Oth.non-wovens of high density polyethyl.70<p<=150g/m2','Ots.telas sin tejer, polietileno alta dens.70<p<=150g/m2',10,'56','5603','560393');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039320','Outros falsos tecidos de poliester,70g/m2<peso<=150g/m2','Outros falsos tecidos de poliester,70g/m2<peso<=150g/m2','Outros falsos tecidos de poliester,70g/m2<peso<=150g/m2',10,'56','5603','560393');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039330','Outros falsos tecidos polipropilen,70g/m2<peso<=150g/m2','Outros falsos tecidos polipropilen,70g/m2<peso<=150g/m2','Outros falsos tecidos polipropilen,70g/m2<peso<=150g/m2',10,'56','5603','560393');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039340','Outros falsos tecidos raiom viscos,70g/m2<peso<=150g/m2','Outros falsos tecidos raiom viscos,70g/m2<peso<=150g/m2','Outros falsos tecidos raiom viscos,70g/m2<peso<=150g/m2',10,'56','5603','560393');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039390','Outros falsos tecidos, 70g/m2<peso<=150g/m2','Other non-wovens, 70g/m2<weight<=150g/m2','Las dem.telas sin tejer, 70g/m2<peso<=150g/m2',10,'56','5603','560393');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039400','Outros falsos tecidos, peso>150g/m2','Other non-wovens weight>150/m2','Las dem.telas sin tejer, peso>150g/m2',10,'56','5603','560394');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039410','Outros falsos tecidos de poliester,peso>150g/m2','Outros falsos tecidos de poliester,peso>150g/m2','Outros falsos tecidos de poliester,peso>150g/m2',10,'56','5603','560394');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039420','Outros falsos tecidos de polipropileno,peso>150g/m2','Outros falsos tecidos de polipropileno,peso>150g/m2','Outros falsos tecidos de polipropileno,peso>150g/m2',10,'56','5603','560394');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039430','Outros falsos tecidos, de raiom viscose peso>150g/m2','Outros falsos tecidos, de raiom viscose peso>150g/m2','Outros falsos tecidos, de raiom viscose peso>150g/m2',10,'56','5603','560394');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56039490','Outros falsos tecidos, peso>150g/m2','Outros falsos tecidos,peso>150g/m2','Outros falsos tecidos,peso>150g/m2',10,'56','5603','560394');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56041000','Fios e cordas, de borracha, recobertos de têxteis','Rubber thread and cord, textile covered','Hilos y cuerdas, de caucho, revestidos de textiles',10,'56','5604','560410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56042010','Fios de alta tenacidade de poliésteres,  etc.com borracha','High tenacity yarn of polyesters, etc.with rubber','Hilados de alta tenacidad de poliésteres, etc.con caucho',10,'56','5604','560420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56042020','Fios de alta tenacidade de poliésteres,  etc.com plástico','High tenacity yarn of polyesters, etc.with plastic','Hilados de alta tenacidad de poliésteres, etc.c/plástico',10,'56','5604','560420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56049010','Imitacoes de categute constituidas por fios de seda','Imitations of catgut constituted by threads of silk','Imitaciones de catgut constituidas por hilos de seda',10,'56','5604','560490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56049021','Fios alt.ten.pol.náilon outs.pol.rev.c/borr.','High tenacity yarn, of polyesters, nylon, other polyamides, recovered with rubber','Hilados de alta tenacidad, de poliésteres, nailon, otras poliamidas, revestidos de caucho',10,'56','5604','560490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56049022','Fios d/alta ten.d/pol., náilon, rev.c/plástico','High tenacity yarn, of polyesters, nylon, recovered with plastic','Hilados de alta tenacidad, de poliésteres, nailon, revestidos de plástico',10,'56','5604','560490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56049090','Outros fios têxteis/laminas,  etc.com borracha/plástico','Other textile yarn/strip, etc.with rubber/plastic','Otros hilados textiles/tiras, etc.con caucho/plástico',10,'56','5604','560490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56050010','Fios metálicos const.fios text.etc.com metais preciosos','Metallis.yarn, being textile yarn, etc.with precious met.','Hilados metálicos const.hilados tex.etc.con mets.prec.',10,'56','5605','560500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56050020','Fios metálicos const.fios text.etc.revest.c/outs.metais','Metall.yarn, being textile yarn, etc.coat.with oth.metals','Hilados met.const.hilados tex.etc.revest.c/ots.metales',10,'56','5605','560500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56050090','Outs.fios metálicos const.fios text.etc.combin.c/metal','Oth.metall.yarn, being textile yarn, etc.comb.with metal','Ots.hilados metál.const.hilados text.etc.combin.c/metal',10,'56','5605','560500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56060000','Fios revest.por enrolam/laminas/monofilam.sint/art.etc.','Gimped yarnstrip/mono-filament synth/artif, etc.','Hilados entorchados/tiras/monofilam.sint/art.etc.',10,'56','5606','560600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56071000','Cordéis,  cordas e cabos,  de juta/outras fibras text.liber','Cordage, ropes and cable, of jute/oth.textile bast fibres','Cords., cuerdas y cordajes, de yute/ots.fibrs.text.líber',10,'56','5607','560710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56071011','Cordéis,  cordas e cabos,  de juta,  inf.num.metr.075 por fio','Cordage, ropes and cable, of jute/num.meter 075 f/thread','Cordel., cuerdas y cord., de yute, inf.núm.métr.075 p/hilo',10,'56','5607','560710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56071019','Outros cordpeis, cordas e cabos, de juta','Other cordages, ropes and cables, of jute','Ots.cordeles, cuerdas y cordajes, de yute',10,'56','5607','560710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56071090','Cordéis, cordas e cabos, de outs.fibras têxteis liberian.','Lines, ropes and cable, of other textile bast fibres','Cordeles, cuerdas y cordajes, de ots.fibrs.textiles líber',10,'56','5607','560710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56072100','Cordéis de sisal/outs.fibras "agave",  p/atadeiras/enfard','Lines of sisal/oth.agave fibres, binder/baler','Cordeles de sisal/dem.fibras agave, p/atar/engavillar',10,'56','5607','560721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56072900','Outs.cordéis/cordas/cabos,  de sisal/outs.fibras "agave"','Lines, ropes and cable, of sisal/oth."agave"fibres','Ots.cordeles/cuerdas/cordajes, de sisal/ots.fibras agave',10,'56','5607','560729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56073000','Cordéis,  cordas e cabos,  de abaca ou outras fibras duras','Twine, cordage, ropes and cables, of abaca or ot.hard fibr','Cordeles, cuerdas y cordajes, de abacá o ots.fibras duras',10,'56','5607','560730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56074100','Cordéis de polietileno/polipropileno,  p/atadeiras/enfard','Polyethylene lines/polypropylene, binder/baler','Cordeles de polietileno/polipropileno, p/atar/engavillar',10,'56','5607','560741');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56074900','Outros cordéis,  cordas,  etc.de polietileno/polipropileno','Other lines, ropes, etc.polyethylene/polypropylene','Otros cordeles, cuerdas, etc.de polietileno/polipropileno',10,'56','5607','560749');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56075011','Cordéis, cordas e cabos, de fibras de náilon','Lines, ropes, cables, of nylon fibres','Cordeles, cuerdas y cordajes, de fibras de nailon',10,'56','5607','560750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56075019','Cordéis, cordas e cabos, de fibras de outras poliamidas','Lines, ropes and cables, of other polyamides fibres','Cordeles, cuerdas y cordajes, de fibras de ots.poliamidas',10,'56','5607','560750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56075090','Cordéis, cordas e cabos, de outras fibras sintéticas','Lines, ropes and cables, of other synthetic fibres','Cordeles, cuerdas y cordajes, de otras fibras sintéticas',10,'56','5607','560750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56079010','Cordéis, cordas e cabos, de algodão','Lines, ropes and cables, of cotton','Cordeles, cuerdas y cordajes, de algodón',10,'56','5607','560790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56079020','Cordéis, corda, cabo d/juta inf.n}.métrico 0,  75','Cordages, ropes and cables, of jute num.meter 0,75 ','Cordeles., cuerdas y cordajes, de yute, inf.núm.métr.0,75',10,'56','5607','560790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56079090','Cordéis, cordas e cabos, de outras matérias têxteis','Lines, ropes and cables, of other textile materials','Cordeles, cuerdas y cordajes, de otras materias textiles',10,'56','5607','560790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56081100','Redes confeccion.de matérias têxteis sint/artif.p/pesca','Made up fishing nets of textile materials synth/artif','Redes confeccion.de materias textiles sint/art.p/pesca',10,'56','5608','560811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56081900','Outras redes confeccion.de matérias têxteis sint/artif.','Other made nets of textile materials synthetic/artif.','Otras redes confeccion.de materias textiles sint/artif.',10,'56','5608','560819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56089000','Redes de malhas com nós, etc.de outras matérias têxteis','Knotted netting of twine, etc.of other textile materials','Redes de mallas anudadas, etc.de otras materias textiles',10,'56','5608','560890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56090010','Artigos de fios, lâminas, etc.de algodão','Articles of yarn, strip of cotton','Artículos de hilados, tiras, etc.de algodón',10,'56','5609','560900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('56090090','Artigos de fios, lâminas, etc.de outs.mat.text.sint/artif','Articles of yarn, strip, etc.oth.text.material synt/artif','Artículos de hils., tiras, etc.de ots.mat.text.sint/artif',10,'56','5609','560900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57011011','Tapete de lã, de ponto nodado/enrolado, feito à mão','Carpets of wool, hand knotted, coiled','Alfombra de lana, de nudo de materia textil, hecha a mano',15,'57','5701','570110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57011012','Tapete de lã, de ponto nodado/enrolado, feito à máquina','Carpets of wool, machine knotted, coiled','Alfombra de lana, de nudo de mat.textil, hecha a máquina',15,'57','5701','570110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57011020','Tapete de pêlos finos, de ponto nodado ou enrolado','Carpets of fine animal hair, of point knotknotted/coiled','Alfombra de pelo fino, de nudo de materia textil',15,'57','5701','570110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57019000','Tapete de outra matéria têxtil, de ponto nodado/enrolado','Carpets of oth.textile mat., of point knotknotted/coiled','Alfombra de ot.materia textil, de nudo de materia textil',15,'57','5701','570190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57021000','Tapete "kelim", "schumacks", "karamanie", etc.tecido à mão','Carpet "kelim", "schumacks", "karamanie", etc.hand-woven','Alfombra "kelim", "schumacks", "karamanie", etc.tej.a mano',15,'57','5702','570210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57022000','Revestimento para pavimento,  de cairo (fibras de coco)','Covering for pavement, of coir (coconut fibres)','Revestimiento para el suelo de fibras de coco',15,'57','5702','570220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57023100','Tapete,  etc.de la ou pêlos finos,  aveludado,  n/confeccion.','Carpet, etc.of wool/fine animal hair, velvet, n/made-up','Alfombra, etc.de lana o pelo fino, aterciopelado, s/conf.',15,'57','5702','570231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57023200','Tapete,  etc.de mater.têxtil sint/artif.avelud.n/confecc.','Carpet, etc.of textile mater.synt/artif.velvet, n/made-up','Alfombra, etc.de mater.textil sint/artif.aterciop.s/conf',15,'57','5702','570232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57023900','Tapete,  etc.de outs.mater.têxteis,  aveludado,  n/confeccion','Carpet, etc.of other textile materials, velvet, n/made-up','Alfombra, etc.de ots.mater.textil.aterciopelado, s/conf.',15,'57','5702','570239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57024100','Tapete,  etc.de la ou pêlos finos,  aveludado,  confeccionado','Carpet, etc.of fine animal hair, velvet, made-up','Alfombra, etc.de lana o pelo fino, aterciopelado, confecc.',15,'57','5702','570241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57024200','Tapete,  etc.de materia têxtil sint/artif.avelud.confecc.','Carpet, etc.of textile mater.syn/artif.velvet, made-up','Alfombra, etc.de mat.textil sint/artif.aterciop., conf.',15,'57','5702','570242');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57024900','Tapete, etc.de outs.mater.têxteis, aveludado, confeccionado','Carpet, etc.of oth.textile mater., velvet, made-up','Alfombra, etc.de ots.mat.textiles, aterciopelado, confecc.',15,'57','5702','570249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57025010','Tapetes rev.p/pav.ñ avel.ñ confec., lã, p.fino','Carpets floor covering, n/velvet, n/made-up,of wool/fine animal hair','Alfombras revest.p/suelo, s/aterciopelar n/conf., de lana o pelo fino ',15,'57','5702','570250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57025020','Tapetes rev.p/pav.ñ avel.ñ confec., mat.sint.','Carpets floor covering, n/velvet, n/made-up,of synthetic material','Alfombras revest.p/suelo, s/aterciopelar n/conf.,  de material sintético',15,'57','5702','570250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57025090','Tapetes rev.p/pav.ñ avel.ñ confec., out.mat.','Carpets floor covering, n/velvet, n/made-up,of other materials','Alfombras revest.p/suelo, s/aterciopelar n/conf.,  de otras materias',15,'57','5702','570250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57025100','Tapete,  etc.de la ou pêlos finos,  n/aveludado,  n/confecc.','Carpet, etc.of fine animal hair, n/velvet, n/made-up','Alfombra, etc.de lana o pelo fino, s/aterciopelar n/conf.',15,'57','5702','570251');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57025200','Tapete,  etc.de mat.têxtil sint/artif.n/avelud.n/confecc.','Carpet, etc.of textile mat.syn/artif.n/velvet, n/made-up','Alfombra, etc.de mat.textil sint/art.s/aterciop. n/conf.',15,'57','5702','570252');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57025900','Tapete,  etc.de outs.mater.têxteis,  n/aveludado,  n/confecc.','Carpet, etc.of oth.textile materials, n/velvet, n/made-up','Alfombra, etc.de ots.mat.textiles, s/aterciopelar n/conf.',15,'57','5702','570259');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57029100','Tapete,  etc.de la ou pêlos finos,  n/aveludado,  confeccion.','Carpet, etc.of wool/fine anim.hair, n/velvet, made-up','Alfombra, etc.de lana o pelo fino, s/aterciopelar, confecc',15,'57','5702','570291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57029200','Tapete,  etc.de mater.têxtil sint.artif.n/avelud.confecc.','Carpet, etc.of textile mater.syn/art.n/velvet, made-up','Alfombra, etc.de mat.textil sint.art.s/aterciop., confecc',15,'57','5702','570292');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57029900','Tapete,  etc.de outs.mater.têxteis,  n/aveludado,  confeccion','Carpet, etc.of oth.textile materials, n/velvet, made-up','Alfombra, etc.de ots.mat.textiles, s/aterciopelar, confecc',15,'57','5702','570299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57031000','Tapete/revest.p/pavim.de lã ou pêlos finos, tufado','Carpet/cover.f/pavem.of wool/fine animal hair, tufted','Alfombra/revest.p/suelo de lana o pelo fino, mechón ins.',15,'57','5703','570310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57032000','Tapete/revest.p/pavim.de náilon/outra poliamida,  tufado','Carpet/cover.f/pavem.of nylon/other polyamide, tufted','Alfombra/revest.p/suelo de nailon/ot.poliam, mechón ins.',15,'57','5703','570320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57033000','Tapete/revest.p/pavim.de outs.mat.text.sint/art.tufado','Carpet/cover.f/pavem.of oth.text.mat.synth/art.tufted','Alfombra/revest.p/suelo de ots.mat.tex.sint/art., mechón',15,'57','5703','570330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57039000','Tapete/revest.p/pavim.de outras matérias têxteis','Carpet/cover.f/pavement of other textile materials','Alfombra/revest.p/suelo de ots.materias textiles',15,'57','5703','570390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57041000','Ladrilhos de feltro,  p/revestim.de pavim.superf<=0.3m2','Tiles of felt, for cover.pavement superf<=0.3m2','Alfombra de fieltro, p/revestim.de pavim.superf<=0.3m2',15,'57','5704','570410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57049000','Outros tapetes/revestimentos p/pavim.de feltro','Other carpets/coverings for pavement, of felt','Otras alfombras/revestimientos p/el suelo de fieltro',15,'57','5704','570490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('57050000','Outs.tapetes/revestimentos p/pavim.de matérias têxteis','Other carpets and other textile floor coverings','Ots.alfombras/revestimientos p/suelo de mater.textiles',15,'57','5705','570500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58011000','Veludo/pelúcia, tecido, de lã ou pêlos finos','Woven pile, fabric, of wool or fine animal hair','Terciopelo/felpa, tejido, de lana o pelo fino',10,'58','5801','580110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58012100','Veludo/pelúcia,  tecido,  da trama algodão,  nao cortado','Woven pile, fabric, of cotton weft, uncut','Terciopelo/felpa, tejido, por trama, sin cortar',10,'58','5801','580121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58012200','Veludo/pelúcia,  tecido,  da trama algodão,  cortado,  canelado','Woven pile, fabric, of cotton weft, cut, grooved','Terciopelo/felpa, tejido, por trama, cortado, rayado',10,'58','5801','580122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58012300','Outros veludos e pelúcias,  tecidos,  da trama de algodão','Other woven pile, fabrics, of cotton weft','Ots.terciopelos/felpas, tejidos, por trama',10,'58','5801','580123');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58012400','Veludo/pelúcia,  tecido,  da urdidura de algodão,  n/cortado','Woven pile, fabric, of cotton warp, uncut','Terciopelo/felpa, tejido, por urdimbre, sin cortar',10,'58','5801','580124');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58012500','Veludo/pelúcia, tecido, da urdidura de algodão, cortado','Woven pile, fabric, of cotton warp, cut','Terciopelo/felpa, tejido, por urdimbre, cortado',10,'58','5801','580125');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58012600','Tecido de froco ("chenille"), de algodão','Chenille fabric, of cotton','Tejido de chenilla, de algodón',10,'58','5801','580126');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58012700','Veludos e pelúcias obtidos por urdi.,de algodão','Pile fabrics obtained by machinating, cotton','Terciopelo y felpa obtenidos por urdimento, de algodón',10,'58','5801','580127');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58013100','Veludo/pelúcia, tecido, da trama fibra sint/artif.n/cort.','Woven pile, fabric, of cotton weft syn/art.uncut','Terciopelo/felpa, tejido, por trama fibr.sint/art.s/cort.',10,'58','5801','580131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58013200','Veludo/pelúcia, tecido, da trama fibra sint/artif.cortado','Woven pile, fabric, of cotton weft syn/art.cut','Terciopelo/felpa, tejidos, de trama fibra sint/artif.cort',10,'58','5801','580132');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58013300','Outs.veludos/pelúcias, tecidos, da trama fibra sint/artif','Oth.woven pile, fabrics, cotton weft syn/art','Ots.terciopelo/felpa, tejidos, de trama fibra sint/artif.',10,'58','5801','580133');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58013400','Veludo/pelúcia, tecido, da urdidura fibra sint/art.n/cort','Woven pile, fabric, of weft fibr.synt/art.uncut','Terciopelo/felpa, tejidos, de urdimbre sint/artif.s/cort.',10,'58','5801','580134');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58013500','Veludo/pelúcia, tecido, da urdidura fibra sint/art.cortad','Woven pile, fabric, of weft fibre syn/art.cut','Terciopelo/felpa, tejidos, de urdimbre sint/artif.cortado',10,'58','5801','580135');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58013600','Tecido de froco ("chenille") de fibra sintética/artif.','Chenille fabric of fibre synthetic/artificial','Tecido de chenilla de fibra sintética/artif.',10,'58','5801','580136');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58013700','Veludos e pelucias obtidos por urdi.,de fib.sin ou art.','Pile fabrics obtained by machinating, synt. and artf.','Terciopelo y felpa obtenidos por urdimento, sin y art.',10,'58','5801','580137');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58019000','Veludo/pelúcia, tecido, de outras matérias têxteis','Woven pile, fabric, of textile materials','Terciopelo/felpa, tejidos, de otras materias textiles',10,'58','5801','580190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58021100','Tecido atoalhado, de algodão, cru','Towelling fabric, of cotton, raw','Tejido con bucles del tipo toalla, de algodón, crudo',10,'58','5802','580211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58021900','Outros tecidos atoalhados, de algodão','Other towelling fabrics, of cotton','Otros tejidos con bucles del tipo toalla, de algodón',10,'58','5802','580219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58022000','Tecido atoalhado, de outras matérias têxteis','Towelling fabric, of other textile materials','Tejido con bucles del tipo toalla, de otrs.materias text',10,'58','5802','580220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58023000','Tecido tufado','Tufted fabric','Superficies textiles con mechón insertado',10,'58','5802','580230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58030010','Tecidos em ponto de gaze de algodão','Fabric, in point of gauze, of cotton ','Tejido, de gasa de vuelta, de algodón',10,'58','5803','580300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58030090','Tecidos em ponto de gaze de outras matérias têxteis','Fabric, in point of gauze, of other textile materials','Tejido, de gasa de vuelta, de otras materias textiles',10,'58','5803','580300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58031000','Tecido de algodão, em ponto de gaze','Fabric of cotton, in point of gauze','Tejido de algodón, de gasa de vuelta',10,'58','5803','580310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58039000','Tecido de outras matérias têxteis, em ponto de gaze','Fabric of other textile materials, in point of gauze','Tejido de otras materias textiles, de gasa de vuelta',10,'58','5803','580390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58041010','Tules, filo e tecidos de malhas com nós, de algodão','Tulle, crib and woven of meshes knotted, of cotton','Tul, tul-bobinot y tejidos de mallas anudadas, de algodón',10,'58','5804','580410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58041090','Outras tules, filos e tecidos de malhas com nós','Other tulle, crib and woven of meshes knotted','Ots.tules, tules-bobinot y tejidos de mallas anudadas',10,'58','5804','580410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58042100','Renda de fibra sintética/artificial, de fabricação mecânica','Income of fibre synthetic/artific., of mechanically made','Encajes de fibra sintética/artificial, de fabr.a máquina',10,'58','5804','580421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58042910','Renda de algodão, de fabricação mecânica','Income of cotton, of mechanically made','Encaje de algodón, fabricado a máquina',10,'58','5804','580429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58042990','Renda de outras matérias têxteis, de fabricação mecânica','Income of other textile materials, of mechanically made','Encaje de ots.mat.textiles, fabricado a máquina',10,'58','5804','580429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58043010','Renda de algodão, de fabricação manual','Income of cotton, of mechanically made','Encaje de algodón, hecho a mano',10,'58','5804','580430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58043090','Outras rendas de fabricação manual','Other income of mechanically made','Ots.encajes hecho a mano',10,'58','5804','580430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58050010','Tapecarias de algodão, tecidas à mão ou feitas à agulha','Hand-woven tapestrie of cotton','Tapicerías de algodón, tejidas a mano o de aguja',10,'58','5805','580500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58050020','Tapecarias de fibra sintética/artif.tecidas à mão,  etc.','Hand-woven tapestrie of synthetic fibres, etc.','Tapicerías de fibra sintética/artif.tejidas a mano, etc.',10,'58','5805','580500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58050090','Tapecarias de outras matérias têxteis, tecidas à mão,  etc','Hand-woven tapestrie other of textile materials, etc.','Tapicerías de ots.materias textiles, tejidas a mano, etc',10,'58','5805','580500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58061000','Fitas de veludo/pelúcia, de tecido de froco ou atoalhado','Narrow of velvet/plush, of fabric of chenille/towelling','Cintas de terc/felpa, de tejido de chen.o del tipo toal.',10,'58','5806','580610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58062000','Outs.fitas conteudo>=5% de fios de elastomeros/borracha','Oth.narrow contain.>=5% of elastomeric/rubber yarn','Ots.cintas contenido>=5% de hilos de elastómeros/caucho',10,'58','5806','580620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58063100','Fitas de algodão','Narrow of cotton','Cintas de algodón',10,'58','5806','580631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58063200','Fitas de fibras sintéticas ou artificiais','Narrow of synthetic or artificial fibres','Cintas de fibras sintéticas o artificiales',10,'58','5806','580632');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58063900','Fitas de outras matérias têxteis','Narrow of other textile materials','Cintas de otras materias textiles',10,'58','5806','580639');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58064000','Fitas sem trama,  de fios/fibras,  paralelizados e colados','Narrow without warp, of yarn/fib.assembl.adhesive','Cintas sin trama, de hils./fibras, paralelizados y aglut.',10,'58','5806','580640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58071000','Etiquetas, emblemas, etc.de matérias têxteis, tecidos','Labels, badges, etc.of textile materials, woven','Etiquetas, escudos, etc.de materias textiles, tejidos',10,'58','5807','580710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58079000','Outras etiquetas,  emblemas,  etc.de matérias têxteis','Other labels, badges, etc.of textile materials','Otras etiquetas, escudos, etc.de materias textiles',10,'58','5807','580790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58081000','Entrancados em pecas','Braids, in the piece','Trenzas en pieza',10,'58','5808','580810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58089000','Artigos de passamanaria/ornamentais analogos,  borlas,  etc','Goods of lacework, ornamental similar, tassels, etc','Artícs.de pasamanería/ornaments.análogos, bellotas, etc',10,'58','5808','580890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58090000','Tecido de fios de metal, de fios têxteis metalizados, etc','Fabrics of metal thread of textile metallised yarn, etc','Tejido de hilad.de metal, de hilad.textiles metaliz., etc',10,'58','5809','580900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58101000','Bordados químicos/aereos/com fundo recortad.em peça,  etc','Embroid.chem., aerial, with bottom cut out in piece, etc','Bordados químicos/aéreos/con fondo recort.en pieza, etc',10,'58','5810','581010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58109100','Bordados de algodão, em peça, em tiras ou em motivos','Embroider.of cotton in the piece, in strips or in motifs','Bordados de algodón, en pieza, en tiras o en motivos',10,'58','5810','581091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58109200','Bordados de fibra sint/artif.em peça/tiras ou motivos','Embroid.of fibres synt/artif.in pice, in strips/motifs','Bordados de fibra sint/artif.en pieza/tiras o motivos',10,'58','5810','581092');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58109900','Bordados de outs.matérias têxteis, em peça/tiras/motivos','Embroid.of other textile mater., in pice/strips/motifs','Bordados de ots.maters.textiles, en pieza/tiras/motivos',10,'58','5810','581099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('58110000','Artefatos têxteis matelasses em peça, etc.','Quilted textile products in the piece','Productos textiles acolchados en pieza, etc.',10,'58','5811','581100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59011000','Tecido revest.cola/materia amilacea,  para encadernação,  etc.','Fabric coat.gum/amylaceous subst., f/outer cov.book, etc','Telas recub.cola/materia amilácea, p/encuadernación, etc',10,'59','5901','590110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59019000','Telas para decalque, transparente para desenho, para pintura,  etc.','Screens f/tracing, transparent f/drawing, f/painting, etc.','Telas p/calcar, transparente p/dibujar, p/pintar, etc.',10,'59','5901','590190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59021010','Telas p/pneumat.de fios alta tenac.poliamida c/borracha','Tyre cord fabric.high tenac.yarn of polyam.with rubber','Napas tram.p/neumát.c/hilads.alta tenac.poliam.c/caucho',10,'59','5902','590210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59021090','Outras telas p/pneumat.de fios alta tenac.de poliamida','Other tyre cord fabrics high tenac.yarn of polyamide','Ots.napas tram.p/neumát.c/hilados alta tenac.de poliam.',10,'59','5902','590210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59022000','Telas p/pneumáticos,  de fios alta tenac.de poliésteres','Tyre cord fabric high tenac.yarn of polyesters','Napas tram.p/neumáticos, c/hilads.alta tenac.de poliést.',10,'59','5902','590220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59029000','Telas p/pneumáticos,  de fios alta tenac.de raiom viscose','Tyre cord fabric of high tenacity yarn, viscose rayon','Napas tram.p/neumáts., de hils.alta tenac.de rayón visc.',10,'59','5902','590290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59031000','Tecido impregnado/revestido,  etc.c/policloreto de vinila','Fabric impregnat./covered, etc.with poly(vinyl chloride)','Telas impregnadas/recubiert, etc.c/policloruro de vinilo',10,'59','5903','590310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59032000','Tecido impregnado/revestido, etc.c/poliuretano','Fabric impregnated/covered, etc.with polyurethane','Telas impregnadas/recubiertas, etc.c/poliuretano',10,'59','5903','590320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59039000','Tecido impregnado/revestido, etc.c/outros plásticos','Fabric impregnated/covered, etc.with other plastics','Telas impregnadas/recubiertas, etc.c/otros plásticos',10,'59','5903','590390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59041000','Linóleos, mesmo recortados','Linoleum, including cut','Linóleos, incluso cortados',15,'59','5904','590410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59049000','Revestimentos p/pavim.const.induto sobre text','Coverings cons.of a applied on a covering text.backing','Revestimientos p/suelo aplic.sobre un soporte textil',15,'59','5904','590490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59049100','Revestim.p/pavim.c/suporte feltro agulhado/falso tecido','Floor coverings with support holed felt/false fabric','Revestim.p/suelo, c/sop.fieltro punzonado/tela s/tejer',15,'59','5904','590491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59049200','Revestim.p/pavim.c/outros suportes têxteis','Floor coverings with other textile support','Revestim.p/suelo, c/otros soportes textiles',15,'59','5904','590492');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59050000','Revestimento para paredes, de matérias têxteis','Textile wall coverings, of textile material','Revestimiento de materia textil para paredes',15,'59','5905','590500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59061000','Fitas adesivas, tecidas com borracha, de largura<=20cm','Adhesive tape, woven with rubber, width<=20cm','Cintas adhesivas, cauchutadas, de anchura<=20cm',10,'59','5906','590610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59069100','Tecidos de malha, com borracha','Fabrics of mesh, with rubber','Telas cauchutados, de punto',10,'59','5906','590691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59069900','Outros tecidos com borracha','Other fabrics with rubber','Otras telas cauchutadas',10,'59','5906','590699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59070000','Outros tecidos impregnados/revestidos/recobertos,  etc.','Oth.fabrics impregnated/coated/covered, etc','Otras telas impregnadas/revestidas/recubiertas, etc.',10,'59','5907','590700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59080000','Mechas de materia têxtil, tecidas, para candeeiros, velas,  etc','Textile wicks, woven, f/candles, etc.','Mechas de materia textil, tejidas, p/lámparas, velas, etc',10,'59','5908','590800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59090000','Mangueiras e tubos semelhantes, de matérias têxteis','Textile hose-piping and similar textile tubing','Mangueras y tubos similares, de materias textiles',10,'59','5909','590900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59100000','Correias transportadoras/transmissão, de matéria têxtil','Transmission/conveyor belts/belting, of tex.material','Correas transportadoras/transmisión, de materia textil',10,'59','5910','591000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59111000','Tecido e feltro,  c/camada borracha,  etc.util.fabr.cardas','Felt and woven, with rubber layer, etc.used f/comb produc','Tela y fieltro, c/capas de caucho, etc.util.p/fabr.cardas',10,'59','5911','591110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59112010','Gazes e telas p/peneirar, de mat.text.sint/artif.em peca','Gauzes and screens to drizzle, synt/artif.text.mat.piec','Gasas y telas p/cener, de mat.text.sint/artif.en pieza',10,'59','5911','591120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59112090','Gazes e telas p/peneirar, de outras matérias têxteis','Gauzes and screens to drizzle, of oth.textile materials','Gasas y telas p/cener, de otras materias textiles',10,'59','5911','591120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59113100','Tecido e feltro, util.em maqs.p/fabr.de papel, p<650g/m2','Fabric and felt used in mach.f/prod.of paper w<650g/m2','Tela y fieltro, util.en máqs.p/fabr.de papel, p<650g/m2',10,'59','5911','591131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59113200','Tecido e feltro, util.em maqs.p/fabr.de papel, p>=650g/m2','Fabric and felt used in mach.f/prod.of paper w>=650g/m2','Tela y fieltro, util.en máqs.p/fabr.de papel, p>=650g/m2',10,'59','5911','591132');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59114000','Tecidos filtrantes/espessos, util.prensas de óleo,  etc.','Fabrics of filter/thick, used in oil presses, etc.','Capachos y telas gruesas, util.prensas de aceite, etc.',10,'59','5911','591140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('59119000','Outs.prods/artefatos, de matérias têxteis, para uso técnico','Oth.prod/articules, of textile material, f/technical uses','Ots.prods/artículos, de materias textiles, p/uso técnico',10,'59','5911','591190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60011010','Tecido de malha de algodão, denominado "felpa longa"','Fabric of cotton mesh, called "long pile"','Tejido de punto de algodón, de "pelo largo"',10,'60','6001','600110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60011020','Tecido de malha de fibra sint/artif.denom."felpa longa"','Fabric of fibre mesh synt/artif.called "long pile"','Tejido de punto de fibra sint/artif, de "pelo largo"',10,'60','6001','600110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60011090','Tecido de malha de outs.mater.text.denom."felpa longa"','Fabric of fibre mesh synt/artif.called "long pile"','Tejido de punto de ots.maters.textiles, de "pelo largo"',10,'60','6001','600110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60012100','Tecido atoalhado, de malha de algodão','Towelling fabric, fabric of cotton mesh','Tejido con bucles, de punto de algodón',10,'60','6001','600121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60012200','Tecido atoalhado, de malha de fibra sintética/artificial','Towelling fabric, of fibre mesh synthetic/artificial','Tejido con bucles, de punto de fibra sintética/artif.',10,'60','6001','600122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60012900','Tecido atoalhado, de malha de outras matérias têxteis','Towelling fabric, of other textile materials','Tejido con bucles, de punto de otras materias textiles',10,'60','6001','600129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60019100','Veludo e pelúcia, de malha de algodão','Pile fabrics, of cotton mesh','Terciopelo y felpa, de punto de algodón',10,'60','6001','600191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60019200','Veludo e pelúcia,  de malha de fibra sintética/artificial','Pile fabrics, of fibre mesh synthetic/artificial','Terciopelo y felpa, de punto de fibra sintética/artif.',10,'60','6001','600192');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60019900','Veludo e pelúcia,  de malha de outras matérias têxteis','Pile fabrics, of mesh of other textile materials','Terciopelo y felpa, de punto de otras materias textiles',10,'60','6001','600199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60021010','Tecido de malha de algodão,  l<=30cm,  cont.elastomeros,  etc','Mesh fabrics of cotton, w<=30cm, cont.elastomeric, etc','Tejido de punto de algodón, a<=30cm, cont.elastómeros, etc',10,'60','6002','600210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60021020','Tecido de malha de fibra sint/art.l<=30cm,  c/elastom.etc','Mesh fabrics of synt/artif fibre, w<=30cm, c/elastom.etc','Tejido de punto de fibr.sint/art, a<=30cm, cont.elast.etc',10,'60','6002','600210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60021090','Tecido de malha de outs.mat.text.l<=30cm,  c/elastom.etc.','Mesh fabrics of oth.text.mater.w<=30cm, c/elastom.etc','Tejido de punto de ots.mat.text., a<=30cm, cont.elast.etc',10,'60','6002','600210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60022010','Outros tecidos de malha de algodão, l<=30cm','Other mesh fabrics of cotton, w<=30cm','Otros tejidos de punto de algodón, a<=30cm',10,'60','6002','600220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60022020','Outros tecidos de malha de fibra sintet/artif.l<=30cm','Other mesh fabrics of synt/artif fibre, w<=30cm','Otros tejidos de punto de fibra sintét/artif.a<=30cm',10,'60','6002','600220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60022090','Outros tecidos de malha de outs.mater.têxteis,  l<=30cm','Oth.mesh fabrics of oth.text.mater.w<=30cm','Otros tejidos de punto de ots.mater.textiles, a<=30cm',10,'60','6002','600220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60023010','Tecido de malha de algodão,  l>30cm,  cont.elastomeros,  etc.','Mesh fabrics of cotton, w>30cm, c/elastom.etc','Tejido de punto de algodón, a>30cm, cont.elastómeros, etc.',10,'60','6002','600230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60023020','Tecido de malha de fibra sint/art.l>30cm,  c/elastom.etc.','Mesh fabrics of synt/artif fibre, w>30cm, c/elastom.etc','Tejido de punto de fibra sint/art.a>30cm, c/elastóm.etc.',10,'60','6002','600230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60023090','Tecido de malha de outs.mat.text.l>30cm,  c/elastom.etc.','Mesh fabrics of oth.text.mater.w>30cm, c/elastom.etc','Tejido de punto de ots.mat.text.a>30cm, c/elastóm.etc.',10,'60','6002','600230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60024010','Tecidos de malha de algodão,  l<=30cm,  elast>=5%','Fabrics of cotton mesh, w<=30cm, elastomeric>=5%','Tejidos de punto de algodón, a<=30cm, elast>=5%',10,'60','6002','600240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60024020','Tecidos de malha fibra sint/art.l<=30cm,  e>=5%','Fabrics of fibre mesh synt/artif.w<=30cm, e>=5%','Tejidos de punto fibra sint/art.a<=30cm, e>=5%',10,'60','6002','600240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60024090','Tecidos de malha outs.mat.text.l<=30cm,  e>=5%','Fabrics of mesh other textile materials.w<=30cm, e>=5%','Tejidos de punto ots.mat.text.a<=30cm, e>=5%',10,'60','6002','600240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60024100','Tecido de malha-urdidura de la ou de pêlos finos','Mesh-warp fabric of wool or fine animal hair','Tejido de punto por urdimbre de lana o de pelo fino',10,'60','6002','600241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60024200','Tecido de malha-urdidura de algodão','Mesh-warp fabric of cotton','Tejido de punto por urdimbre de algodón',10,'60','6002','600242');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60024300','Tecido de malha-urdidura,  de fibra sintética/artificial','Mesh-warp fabric of synthetic/artificial fibre','Tejido de punto por urdimbre de fibra sintética/artif',10,'60','6002','600243');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60024900','Tecido de malha-urdidura de outras matérias têxteis','Mesh-warp fabric of other textile materials','Tejido de punto por urdimbre de ots.materias textiles',10,'60','6002','600249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60029010','Outros tecidos de malha de algodão,  l<=30cm','Other fabrics of mesh cotton , w<=30cm','Ots.tejidos de punto de algodón, a<=30cm',10,'60','6002','600290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60029020','Outs.tecidos de malha fibra sint/art.l<=30cm','Other fabrics of fibres mesh synt/artif.w<=30cm','Ots.tejidos de punto de fibra sint/artif, a<=30cm',10,'60','6002','600290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60029090','Outs.tecidos de malha outs.mater.text.l<=30cm','Other fabrics of mesh of oth.textile materials w<=30cm','Ots.tejidos de punto ots.mater.text.a<=30cm',10,'60','6002','600290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60029100','Outros tecidos de malha de lã ou de pêlos finos','Other mesh-warp fabric of wool or fine animal hair','Otros tejidos de punto de lana o de pelos finos',10,'60','6002','600291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60029200','Outros tecidos de malha de algodão','Other fabrics of cotton mesh','Otros tejidos de punto de algodón',10,'60','6002','600292');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60029300','Outros tecidos de malha de fibras sintet/artificiais','Other fabrics of fibres mesh synt/artif','Otros tejidos de punto de fibras sintét/artificiales',10,'60','6002','600293');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60029900','Outros tecidos de malha de outros matérias têxteis','Other fabrics of mesh of other textile materials','Otros tejidos de punto de otras materias textiles',10,'60','6002','600299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60031000','Outros tecidos de malha de lã/pelos fino,  l<=30cm','Other fabrics of mesh of wool/fine animal hair w<=30cm','Ots.tejidos de punto de lana/pelos fino, a<=30cm',10,'60','6003','600310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60032000','Outros tecidos de malha de algodão,  l<=30cm','Other fabrics of cotton mesh, w<=30cm','Ots.tejidos de punto de algodón, a<=30cm',10,'60','6003','600320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60033000','Outros tecidos de malha de fibras sintet.l<=30cm','Other fabrics of fibres mesh synthetic w<=30cm','Ots.tejidos de punto de fibras sintét.a<=30cm',10,'60','6003','600330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60034000','Outros tecidos de malha de fibras artif.l<=30cm','Other fabrics of fibres mesh artificial w<=30cm','Ots.tejidos de punto de fibras artif.a<=30cm',10,'60','6003','600340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60039000','Outros tecidos de outros matérias têxteis,  l<=30cm','Other fabrics of other textile materials w<=30cm','Ots.tejidos de ots.materias textiles, a<=30cm',10,'60','6003','600390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041010','Tecidos de malha de algodão,  l>30cm,  elast>=5%','Fabrics of cotton mesh, w>30cm, elast>=5%','Tejidos de punto de algodón, a>30cm, elast>=5%',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041011','Tecidos de malha de algodão crus ou branqueados l>30cm','Tecidos de malha de algodão crus ou branqueados l>30cm','Tecidos de malha de algodão crus ou branqueados l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041012','Tecidos de malha de algodão tintos l>30cm','Tecidos de malha de algodão tintos l>30cm','Tecidos de malha de algodão tintos l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041013','Tecidos de malha de algodão fios diversas cores l>30cm','Tecidos de malha de algodão fios diversas cores l>30cm','Tecidos de malha de algodão fios diversas cores l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041014','Tecidos de malha de algodão estampados l>30','Tecidos de malha de algodão estampados l>30','Tecidos de malha de algodão estampados l>30',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041020','Tecidos de malha fibra sint/artif.l>30cm,  e>=5%','Fabrics fibres mesh synt/artif.w>30cm, e>=5%','Tejidos de punto fibra sint/artif.a>30cm, e>=5%',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041030','Tecidos de malha de fibra sintetica l>30cm','Tecidos de malha de fibra sintetica l>30cm','Tecidos de malha de fibra sintetica l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041031','Tecidos de malha de fibra sint crus/branqueados l>30cm','Tecidos de malha de fibra sint crus/branqueados l>30cm','Tecidos de malha de fibra sint crus/branqueados l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041032','Tecidos de malha de fibra sintetica tintos l>30cm','Tecidos de malha de fibra sintetica tintos l>30cm','Tecidos de malha de fibra sintetica tintos l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041033','Tecidos de malha de fibra sint fios divers cores l>30cm','Tecidos de malha de fibra sint fios divers cores l>30cm','Tecidos de malha de fibra sint fios divers cores l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041034','Tecidos de malha de fibra sintetica estampados l>30cm','Tecidos de malha de fibra sintetica estampados l>30cm','Tecidos de malha de fibra sintetica estampados l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041040','Tecidos de malha de fibra artificiais l>30cm','Tecidos de malha de fibra artificiais l>30cm','Tecidos de malha de fibra artificiais l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041041','Tecidos de malha de fibra artif crus/branqueados l>30cm','Tecidos de malha de fibra artif crus/branqueados l>30cm','Tecidos de malha de fibra artif crus/branqueados l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041042','Tecidos de malha de fibra artificiais tintos l>30cm','Tecidos de malha de fibra artificiais tintos l>30cm','Tecidos de malha de fibra artificiais tintos l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041043','Tecidos de malha de fibra artif fios diver cores l>30cm','Tecidos de malha de fibra artif fios diver cores l>30cm','Tecidos de malha de fibra artif fios diver cores l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041044','Tecidos de malha de fibra artificiais estampados l>30cm','Tecidos de malha de fibra artificiais estampados l>30cm','Tecidos de malha de fibra artificiais estampados l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041090','Tecidos de malha de outros mat.text.l>30cm,  e>=5%','Fabrics of mesh of other textile materials w>30cm, e>=5%','Tejidos de punto de ots.mat.text.a>30cm, e>=5%',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041091','Tecidos de malha de outs.mat.text crus ou branq l>30cm','Tecidos de malha de outs.mat.text crus ou branq l>30cm','Tecidos de malha de outs.mat.text crus ou branq l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041092','Tecidos de malha de outs.mat. texteis tintos l>30cm','Tecidos de malha de outs.mat. texteis tintos l>30cm','Tecidos de malha de outs.mat. texteis tintos l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041093','Tecidos de malha de outs.mat.text fios div.cores l>30cm','Tecidos de malha de outs.mat.text fios div.cores l>30cm','Tecidos de malha de outs.mat.text fios div.cores l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60041094','Tecidos de malha de outs.mat.text estampados l>30cm','Tecidos de malha de outs.mat.text estampados l>30cm','Tecidos de malha de outs.mat.text estampados l>30cm',10,'60','6004','600410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60049010','Outros tecidos de malha de algodão,  l>30cm','Other fabrics of cotton mesh, w>30cm','Ots.tejidos de punto de algodón, a>30cm',10,'60','6004','600490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60049020','Outros tecidos de malha fibras sint/artif,  l>30cm','Other fabrics fibres mesh synt/artif, w>30cm','Ots.tejidos de punto de algodón, a>30cm',10,'60','6004','600490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60049030','Outs.tecidos de malha fibras sinteticas l>30cm','Outs.tecidos de malha fibras sinteticas l>30cm','Outs.tecidos de malha fibras sinteticas l>30cm',10,'60','6004','600490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60049040','Outs.tecidos de malha fibras artificiais l>30cm','Outs.tecidos de malha fibras artificiais l>30cm','Outs.tecidos de malha fibras artificiais l>30cm',10,'60','6004','600490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60049090','Outros tecidos de malha outros mater.text.l>30cm','Other fabrics of mesh of other textile materials w>30cm','Ots.tejidos de punto ots.mater.text.a>30cm',10,'60','6004','600490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60051000','Tecidos de malha-urdidura, de lã/pêlos finos','Fabrics of warp mesh, of wool/fine animal hair','Tejidos de punto por urdimbre, de lana/pelo fino',10,'60','6005','600510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60052100','Tecidos de malha-urdidura, crus ou branqueados','Fabrics of warp mesh, raw or bleached','Tejidos de punto por urdimbre, crudos o blanqueados',10,'60','6005','600521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60052200','Tecidos de malha-urdidura, tingidos','Fabrics of warp mesh, dyed','Tejidos de punto por urdimbre, teñidos',10,'60','6005','600522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60052300','Tecidos de malha-urdidura, c/fios divs.cores','Fabrics of warp mesh, of yarns of different colours','Tejidos de punto por urdimbre, c/hilados de dist.colores',10,'60','6005','600523');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60052400','Tecidos de malha-urdidura, estampados','Fabrics of warp mesh, printed','Tejidos de punto por urdimbre, estampados',10,'60','6005','600524');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60053100','Tecidos de malha-urdidura, crus ou branqueados','Fabrics of warp mesh, raw or bleached','Tejidos de punto por urdimbre, crudos o blanqueados',10,'60','6005','600531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60053200','Tecidos de malha-urdidura, tingidos','Fabrics of warp mesh, dyed','Tejidos de punto por urdimbre, teñidos',10,'60','6005','600532');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60053300','Tecidos de malha-urdidura, c/fios divs.cores','Fabrics of warp mesh, of yarns of different colours','Tejidos de punto por urdimbre, c/hilados de dist.colores',10,'60','6005','600533');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60053400','Tecidos de malha-urdidura, estampados','Fabrics of warp mesh, printed','Tejidos de punto por urdimbre, estampados',10,'60','6005','600534');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60054100','Tecidos de malha-urdidura, crus ou branqueados','Fabrics of warp mesh, raw or bleached','Tejidos de punto por urdimbre, crudos o blanqueados',10,'60','6005','600541');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60054200','Tecidos de malha-urdidura, tingidos','Fabrics of warp mesh, dyed','Tejidos de punto por urdimbre, teñidos',10,'60','6005','600542');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60054300','Tecidos de malha-urdidura, c/fios divs.cores','Fabrics of warp mesh, of yarns of different colours','Tejidos de punto por urdimbre, c/hilados de dist.colores',10,'60','6005','600543');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60054400','Tecidos de malha-urdidura, estampados','Fabrics of warp mesh, printed','Tejidos de punto por urdimbre, estampados',10,'60','6005','600544');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60059000','Outros tecidos de malha-urdidura','Other fabrics of warp mesh','Otros tejidos de punto por urdimbre',10,'60','6005','600590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60059010','Tecidos malha-urdidura de lã ou pêlos finos','Fabrics of warp mesh, of wool or fine animal hair','Tejidos de punto por urdimbre, de lana o de pelo fino',10,'60','6005','600590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60059090','Outros tecidos malha-urdidura','Other fabrics of warp mesh','Otros tejidos de punto por urdimbre',10,'60','6005','600590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60061000','Outros tecidos de malha de lã ou de pêlos finos','Other fabrics of mesh of wool or fine animal hair','Ots.tejidos de punto de lana o de pelo fino',10,'60','6006','600610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60062100','Outros tecidos de malha,  de algodão,  crus ou branqueados','Other fabrics of mesh, of cotton, raw or bleached','Ots.tejidos de punto, de algodón, crudos o blanqueados',10,'60','6006','600621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60062200','Outros tecidos de malha, de algodão, tingidos','Other fabrics of mesh, of cotton, dyed','Ots.tejidos de punto, de algodón, teñidos',10,'60','6006','600622');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60062300','Outros tecidos de malha,  de algodão,  c/fios de divs.cores','Oth.fabrics of mesh, of cotton, of yarn of differ.colours','Ots.tejidos de punto, de algodón, c/hilados dist.colores',10,'60','6006','600623');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60062400','Outros tecidos de malha, de algodão, estampados','Oth.fabrics of mesh, of cotton, printed','Ots.tejidos de punto, de algodón, estampados',10,'60','6006','600624');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60063100','Outros tecidos de malha,  fibras sintet.crus ou branqueados','Other fabrics of mesh, synthetic fibres, raw or bleached','Ots.tejidos de punto, fibras sintét.crudos o blanqueados',10,'60','6006','600631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60063200','Outros tecidos de malha,fibras sintet.tingidos','Other fabrics of mesh, synthetic fibres, dyed','Ots.tejidos de punto, fibras sintét.teñidos',10,'60','6006','600632');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60063300','Outros tecidos de malha, fibras sintet.c/fios divs.cores','Ot.fabrics of mesh, synt.fibr.of yarns of differ.colours','Ots.tejidos de punto, fibras sintét.c/hils.dist.colores',10,'60','6006','600633');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60063400','Outros tecidos de malha, fibras sintet.estampados','Other fabrics of mesh, synthetic fibres, printed','Ots.tejidos de punto, fibras sintét.estampados',10,'60','6006','600634');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60064100','Outros tecidos de malha,  fibras artif.crus ou branqueados','Other fabrics of mesh, artificial fibres, raw or bleached','Ots.tejidos de punto, fibras artif.crudos o blanqueados',10,'60','6006','600641');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60064200','Outros tecidos de malha, fibras artif.tingidos','Other fabrics of mesh, artificial fibres, dyed','Ots.tejidos de punto, fibras artif.teñidos',10,'60','6006','600642');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60064300','Outros tecidos de malha, fibras artif.c/fios divs.cores','Ot.fabrics of mesh, artif.fibres, of yarns of differ.col.','Ots.tejidos de punto, fibras artif.c/hilads.dist.colores',10,'60','6006','600643');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60064400','Outros tecidos de malha, fibras artificiais estampados','Other fabrics of mesh, artificial fibres, printed','Ots.tejidos de punto, fibras artif.estampados',10,'60','6006','600644');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('60069000','Outros tecidos de malha, de outros mater.têxteis','Other fabrics of mesh, artific.fibres, of oth.text.mater.','Ots.tejidos de punto, de ots.mater.textiles',10,'60','6006','600690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61011000','Sobretudos, etc.de malha de lã/pêlos finos, uso masculino','Overcoats, etc.of wool/fine animal hair mesh, mascul.uses','Abrigos, etc.de punto de lana/pelo fino, para hombres',11,'61','6101','610110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61012000','Sobretudos, etc.de malha de algodão, de uso masculino','Overcoats, etc.of cotton mesh, masculine uses','Abrigos, etc.de punto de algodón, para hombres',11,'61','6101','610120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61013000','Sobretudos,  etc.de malha de fibra sint/art.uso masculino','Overcoats, etc.of fibre mesh synt/art.masculine uses','Abrigos, etc.de punto de fibra sint/art.para hombres',11,'61','6101','610130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61019000','Sobretudos,  etc.de malha de outs.mat.text.uso masculino','Overcoats, etc.of mesh of ot.text.material, mascul.uses','Abrigos, etc.de punto de ots.mat.text.para hombres',11,'61','6101','610190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61019010','Casacos/seml.mal.masc.exc.6103 lã/pêlo fino','Mesh jackets and similar articles, masculine uses, except 6103 (of wool or fine animal hair) ','Anoraks de punto y artículos similares, para hombres, exc. 6103 (de lana o pelo fino) ',11,'61','6101','610190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61019090','Casacos/seml.mal.masc.exc.6103 outs.m.têxt.','Mesh jackets and similar articles, masculine uses, except 6103 (of other textile materials) ','Anoraks de punto y artículos similares, para hombres, exc. 6103 (de lana o pelo fino) ',11,'61','6101','610190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61021000','Mantos, etc.de malha de lã ou pêlos finos, uso feminino','Overcoats, etc.of wool/fine anim.hair mesh, feminine uses','Abrigos, etc.de punto de lana o pelo fino, para mujeres',11,'61','6102','610210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61022000','Mantos, etc.de malha de algodão, de uso feminino','Overcoats, etc.of cotton mesh, feminine uses','Abrigos, etc.de punto de algodón, para mujeres',11,'61','6102','610220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61023000','Mantos,  etc.de malha de fibra sint/artif.de uso feminino','Overcoats, etc.of fibre mesh synt/art.feminine uses','Abrigos, etc.de punto de fibra sint/artif.para mujeres',11,'61','6102','610230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61029000','Mantos,  etc.de malha de outs.mater.têxteis, uso feminino','Overcoats, etc.of mesh of ot.text.material, feminine uses','Abrigos, etc.de punto de ots.mater.textiles, ',11,'61','6102','610290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61031010','Ternos malha de lã/pêlos finos, uso masculino','Mesh suits of wool or fine animal hair, masculine uses','Trajes de punto de lana o de pelo fino, para hombres',11,'61','6103','610310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61031020','Ternos malha de fibras sintéticas, uso masculino','Mesh suits of synthetic fibres, masculine uses','Trajes de punto de fibras sintéticas, para hombres',11,'61','6103','610310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61031090','Ternos malha de outs.mats.têxteis, uso masculino','Mesh suits of other textile materials, masculine uses','Trajes de punto de otras materias textiles, para hombres',11,'61','6103','610310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61031100','Ternos (fatos) de malha de lã ou pêlos finos','Men''s or boys'' suits of wool or fine animal hair','Trajes (ambos o ternos) de punto de lana o de pelo fino',11,'61','6103','610311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61031200','Ternos (fatos) de malha de fibras sintéticas','Men''s or boys'' suits of synthetic fibres','Trajes (ambos o ternos) de punto de fibras sintéticas',11,'61','6103','610312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61031900','Ternos (fatos) de malha de outras matérias têxteis','Men''s or boys'' suits of other textile materials','Trajes (ambos o ternos) de punto de ots.maters.textiles',11,'61','6103','610319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61032100','Conjuntos de malha de lã ou pêlos finos, uso masculino','Ensembles of mesh of wool/fine anim.hair, masculine uses','Conjuntos de punto de lana o pelo fino, para hombres',11,'61','6103','610321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61032200','Conjuntos de malha de algodão, de uso masculino','Ensembles of cotton mesh, masculine uses','Conjuntos de punto de algodón, para hombres',11,'61','6103','610322');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61032300','Conjuntos de malha de fibra sint/artif.de uso masculino','Ensembles of mesh of synthet/artif fibres, masculne uses','Conjuntos de punto de fibra sint/artif., para hombres',11,'61','6103','610323');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61032900','Conjuntos de malha de outs.mater.têxteis,  uso masculino','Ensembles of mesh of oth.textile materials, mascul.uses','Conjuntos de punto de ots.mater.textiles, para hombres',11,'61','6103','610329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61032910','Conjuntos malha de lã/pêlos finos, uso masculino','Ensembles of mesh of wool/fine anim.hair, masculine uses','Conjuntos de punto de lana o pelo fino, para hombres',11,'61','6103','610329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61032990','Conjuntos malha outs.mat.têxteis, uso masculino','Ensembles of mesh of oth.textile materials, mascul.uses','Conjuntos de punto de ots.mater.textiles, para hombres',11,'61','6103','610329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61033100','Paletos (casacos) de malha de lã ou de pêlos finos','Jacket (coats) of wool or fine animal hair','Chaquetas (sacos) de punto de lana o de pelo fino',11,'61','6103','610331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61033200','Paletos (casacos) de malha de algodão','Jacket (coats) of cotton mesh','Chaquetas (sacos) de punto de algodón',11,'61','6103','610332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61033300','Paletos (casacos) de malha de fibras sintéticas','Jacket (coats) of synthetic fibres','Chaquetas (sacos) de punto de fibras sintéticas',11,'61','6103','610333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61033900','Paletos (casacos) de malha de outras matérias têxteis','Jacket (coats) of other textile materials','Chaquetas (sacos) de punto de otras materias textiles',11,'61','6103','610339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61034100','Calcas,  etc.de malha de lã ou pêlos finos,  uso masculino','Trousers, etc.of mesh of wool/fine animal hair, masc.uses','Pantalones largos, etc.de punto de lana/p.fino, p/hombres',11,'61','6103','610341');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61034200','Calcas,  etc.de malha de algodão,  de uso masculino','Trousers, etc.of cotton mesh, masculine uses','Pantalones largos, etc.de algodón, para hombres',11,'61','6103','610342');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61034300','Calcas,  etc.de malha de fibras sintéticas,  uso masculino','Trousers, etc.of synthetic fibres mesh, masculine uses','Pantalones largos, etc.de fibras sintéticas, para hombres',11,'61','6103','610343');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61034900','Calcas,  etc.de malha de outs.mater.têxteis,  uso masculino','Trousers, etc.of oth.textile materials, masculine uses','Pantalones largos, etc.de ots.mat.textiles, para hombres',11,'61','6103','610349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61041100','Tailleurs de malha de lã ou de pêlos finos','Suits of mesh of wool or fine animal hair','Trajes sastre de punto de lana o de pelo fino',11,'61','6104','610411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61041200','Tailleurs de malha de algodão','Suits of cotton mesh','Trajes sastre de punto de algodón',11,'61','6104','610412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61041300','Tailleurs de malha de fibras sintéticas','Suits of synthetic fibres mesh','Trajes sastre de punto de fibras sintéticas',11,'61','6104','610413');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61041900','Tailleurs de malha de outras matérias têxteis','Suits of mesh of other textile materials','Trajes sastre de punto de otras materias textiles',11,'61','6104','610419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61041910','Tailleurs malha de lã/pêlos finos, uso feminino','Suits of mesh of wool or fine animal hair, feminine uses','Trajes sastre de punto de lana o de pelo fino, para mujeres',11,'61','6104','610419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61041920','Tailleurs malha de algodão, uso feminino','Suits of cotton mesh, feminine uses','Trajes sastre de punto de algodón, para mujeres',11,'61','6104','610419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61041990','Tailleurs malha de outs.mat.têxteis, uso fem.','Suits of mesh of other textile materials, feminine uses','Trajes sastre de punto de otras materias textiles, para mujeres',11,'61','6104','610419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61042100','Conjuntos de malha de lã ou pêlos finos,  de uso feminino','Ensembles of mesh of wool/fine animal hair, femin.uses','Conjuntos de punto de lana o pelo fino, para mujeres',11,'61','6104','610421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61042200','Conjuntos de malha de algodão, de uso feminino','Ensembles of cotton mesh, feminine uses','Conjuntos de punto de algodón, para mujeres',11,'61','6104','610422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61042300','Conjuntos de malha de fibras sintéticas,  de uso feminino','Ensembles of synthetic fibres mesh, feminine uses','Conjuntos de punto de fibras sintéticas, para mujeres',11,'61','6104','610423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61042900','Conjuntos de malha de outra materia têxtil,  uso feminino','Ensembles of mesh of oth.textile materials, feminin.uses','Conjuntos de punto de ot.mat.textil, para mujeres',11,'61','6104','610429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61042910','Conjuntos malha de lã/pêlos finos, uso feminino','Ensembles of mesh of wool/fine animal hair, femin.uses','Conjuntos de punto de lana o pelo fino, para mujeres',11,'61','6104','610429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61042990','Conjuntos malha d/out.mats.têxteis, uso feminino','Ensembles of mesh of oth.textile materials, feminin.uses','Conjuntos de punto de ot.mat.textil, para mujeres',11,'61','6104','610429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61043100','Blazers de malha de lã ou de pêlos finos, uso feminino','Blazers of mesh of wool/fine animal hair, feminine uses','Chaquetas(sacos) de punto de lana o pelo fino, p/mujeres',11,'61','6104','610431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61043200','Blazers de malha de algodão, de uso feminino','Blazers of cotton mesh, feminine uses','Chaquetas (sacos) de punto de algodón, para mujeres',11,'61','6104','610432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61043300','Blazers de malha de fibras sintéticas, de uso feminino','Blazers of synthetic fibres mesh, feminine uses','Chaquetas(sacos)de punto de fibras sintéticas, p/mujeres',11,'61','6104','610433');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61043900','Blazers de malha de outra matérias têxteis, uso feminino','Blazers of oth. textile materials mesh, feminine uses','Chaquetas(sacos) de punto de ots.mat.textiles, p/mujeres',11,'61','6104','610439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61044100','Vestidos de malha de lã ou pêlos finos, de uso feminino','Dresses of mesh of wool/fine animal hair, feminine uses','Vestidos de punto de lana o pelo fino, para mujeres',11,'61','6104','610441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61044200','Vestidos de malha de algodão','Dresses of cotton mesh','Vestidos de punto de algodón',11,'61','6104','610442');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61044300','Vestidos de malha de fibras sintéticas','Dresses of synthetic fibres mesh','Vestidos de punto de fibras sintéticas',11,'61','6104','610443');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61044400','Vestidos de malha de fibras artificiais','Dresses of synthetic fibres mesh','Vestidos de punto de fibras artificiales',11,'61','6104','610444');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61044900','Vestidos de malha de outras matérias têxteis','Dresses of other textile materials','Vestidos de punto de otras materias textiles',11,'61','6104','610449');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61045100','Saias e saias-calças, de malha de lã ou de pêlos finos','Skirts/divided skirts, of mesh of wool/fine animal hair','Faldas y faldas pantalón, de punto de lana o pelo fino',11,'61','6104','610451');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61045200','Saias e saias-calças, de malha de algodão','Skirts/divided skirts, of cotton mesh','Faldas y faldas pantalón, de punto de algodón',11,'61','6104','610452');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61045300','Saias e saias-calças,  de malha de fibras sintéticas','Skirts/divided skirts, of synthetic fibres mesh','Faldas y faldas pantalón, de punto de fibras sintéticas',11,'61','6104','610453');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61045900','Saias e saias-calças,  de malha de outs.matérias têxteis','Skirts/divided skirts, of oth.textile materials mesh','Faldas y faldas pantalón, de punto de ots.mat.textiles',11,'61','6104','610459');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61046100','Calças,  etc.de malha de lã ou pêlos finos, uso feminino','Trousers, etc.of mesh of wool/fine anim.hair, femin.uses','Pantalones largos, etc.de punto de lana/p.fino, p/mujeres',11,'61','6104','610461');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61046200','Calças,  etc.de malha de algodão, de uso feminino','Trousers, etc.of cotton mesh, feminnine uses','Pantalones largos, etc.de punto de algodón, para mujeres',11,'61','6104','610462');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61046300','Calças,  etc.de malha de fibras sintéticas, uso feminino','Trousers, etc.of synthetic fibres mesh, feminnine uses','Pantalones largos, etc.de punto de fibras sint, p/mujeres',11,'61','6104','610463');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61046900','Calças,  etc.de malha de outs.mater.têxteis, uso feminino','Trousers, etc.of mesh of ot.text.materials, feminn.uses','Pantalones largos, etc.de punto de ots.mat.tex, p/mujeres',11,'61','6104','610469');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61051000','Camisas de malha de algodão, de uso masculino','Shirts, etc.of cotton mesh, masculine uses','Camisas de punto de algodón, para hombres',11,'61','6105','610510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61052000','Camisas de malha de fibra sintética, artif.uso masculino','Shirts, etc.of synth/artific fibres mesh, masculine uses','Camisas de punto de fibra sintética/artif., para hombres',11,'61','6105','610520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61059000','Camisas de malha de outs.matérias têxteis, uso masculino','Shirts, etc.of oth.textile materials mesh, masculine uses','Camisas de punto de ots.mat.textiles, para hombres',11,'61','6105','610590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61061000','Camisas, etc.de malha de algodão, de uso feminino','Shirts, etc.of cotton mesh, feminine uses','Camisas, etc.de punto de algodón, para mujeres',11,'61','6106','610610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61062000','Camisas,  etc.de malha de fibras sint/artif.uso feminino','Shirts, etc.of synth/artific fibres mesh, feminine uses','Camisas, etc.de punto de fibras sint/artif., para mujeres',11,'61','6106','610620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61069000','Camisas,  etc.de malha de outs.mater.têxteis,  uso feminino','Shirts, etc.of oth.textile materials mesh, feminine uses','Camisas, etc.de punto de ots.mat.textiles, para mujeres',11,'61','6106','610690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61071100','Cuecas e ceroulas,  de malha de algodão','Underpants and briefs, of cotton mesh','Calzoncillos y "slips", de punto de algodón',11,'61','6107','610711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61071200','Cuecas e ceroulas,  de malha de fibras sintéticas/artif.','Underpants and briefs, of synth/artif fibres mesh','Calzoncillos y "slips", de punto de fibras sintét/artif.',11,'61','6107','610712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61071900','Cuecas e ceroulas,  de malha de outras matérias têxteis','Underpants and briefs, etc.of oth.textile materials mesh','Calzoncillos y "slips", de punto de ots.mat.textiles',11,'61','6107','610719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61072100','Camisoloes,  etc.de malha de algodão,  de uso masculino','Nightshirts, etc of cotton mesh, masculine uses','Camisones, etc.de punto de algodón, para hombres',11,'61','6107','610721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61072200','Camisoloes,  etc.de malha de fibra sint/art.uso masculino','Nightshirts, etc of synt/artif fibres mesh, masculin.uses','Camisones, etc.de punto de fibra sint/artif, para hombres',11,'61','6107','610722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61072900','Camisoloes,  etc.de malha de outs.mat.text.uso masculino','Big shirts, etc.of mesh of ot.textile materi.masc.uses','Camisones, etc.de punto de ots.mat.textiles, para hombres',11,'61','6107','610729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61079100','Roupões, etc.de malha de algodão, de uso masculino','Robes, etc.of cotton mesh, masculine uses','Albornoces de baño, etc.de punto de algodón, para hombres',11,'61','6107','610791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61079200','Roupões, etc.de malha de fibra sint/artif.uso masculino','Robes, etc.of mesh of synth/artif fibres, masculine uses','Albornoces de baño, etc.de punt.de fib.sint/art, p/hombr.',11,'61','6107','610792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61079900','Roupões,  etc.de malha de outs.mater.text.uso masculino','Robes, etc.of mesh of ot.textile materials, masculin.uses','Albornoces de baño, etc.de punt.de ots.mat.text, p/hombr.',11,'61','6107','610799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61079910','Roupa/banho, robes, etc.masc.malh.f.sint/art.','Dressing gowns, bathrobes, etc., masculine uses, mesh of synthetic or artificial fibres ','Albornoz, bata de baño, etc., para hombres, de punto de fibras sintéticas o artificiales',11,'61','6107','610799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61079990','Roupa/banho, robes, etc.masc.malh./outs.mat.','Dressing gowns, bathrobes, etc., masculine uses, mesh of other textile materials','Albornoz, bata de baño, etc., para hombres, de punto de otras materias textiles',11,'61','6107','610799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61081100','Combinações e anáguas, de malha de fibra sintética/artif','Slips and petticoats of synthetic/artific.fibres mesh','Combinacioes y enaguas, de punto de fibra sintet/artif.',11,'61','6108','610811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61081900','Combinações e anáguas, de malha de outras matérias têxteis','Slips and petticoats, of other textile materials mesh','Combinacioes y enaguas, de punto de ots.mat.textiles',11,'61','6108','610819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61082100','Calcinhas de malha de algodão','Briefs and panties of cotton mesh','Bragas de punto de algodón',11,'61','6108','610821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61082200','Calcinhas de malha de fibras sintéticas ou artificiais','Briefs and panties of synth/artif fibres mesh','Bragas de punto de fibras sintéticas o artificiales',11,'61','6108','610822');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61082900','Calcinhas de malha de outras matérias têxteis','Briefs and panties of oth.textile materials mesh','Bragas de punto de otras materias textiles',11,'61','6108','610829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61083100','Camisolas,  etc.de malha de algodão,  de uso feminino','Nightgowns, etc.of cotton mesh, femine uses','Camisones, etc.de punto de algodón, para mujeres',11,'61','6108','610831');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61083200','Camisolas,  etc.de malha de fibra sint/artif.uso feminino','Nightgowns, etc.of synth/artif fibres, femine uses','Camisones, etc.de punto de fibra sint/artif, para mujeres',11,'61','6108','610832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61083900','Camisolas,  etc.de malha de outs.mater.text.uso feminino','Nightgowns, etc.of oth.textile materials, femine uses','Camisones, etc.de punto de ots.mat.textiles, para mujeres',11,'61','6108','610839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61089100','Roupões,  etc.de malha de algodão, de uso feminino','Robes, etc.of cotton mesh, femine uses','Albornoces de baño, etc.de punto de algodón, para mujeres',11,'61','6108','610891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61089200','Roupões,  etc.de malha de fibras sint/artif.uso feminino','Robes, etc.of synth/artif fibres mesh, femine uses','Albornoces de baño, etc.de punt.de fibr.sint/art, p/muj.',11,'61','6108','610892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61089900','Roupões,  etc.de malha de outs.mater.têxteis, uso feminino','Robes, etc.of oth.textile materials mesh, femine uses','Albornoces de baño, etc.de punto de ots.mat.text., p/muj.',11,'61','6108','610899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61091000','Camisetas "t-shirts", etc.de malha de algodão','T-shirts, etc.of cotton mesh','Camisetas "t-shirts", etc.de punto de algodón',11,'61','6109','610910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61099000','Camisetas "t-shirts",  etc.de malha de outs.mater.têxteis','T-shirts, etc.of other textile materials mesh','Camisetas "t-shirts", etc.de punto de ots.mater.textiles',11,'61','6109','610990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61101000','Suéteres,  puloveres,  etc.de malha de lã ou pêlos finos','Sweaters, pullovers, etc.of mesh of wool/fine anim.hair','Suéteres, pullovers, etc.de punto de lana o pelo fino',11,'61','6110','611010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61101100','Suéteres, etc.de malha de lã','Sweaters, etc.of wool mesh','Suéteres, etc.de punto de lana',11,'61','6110','611011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61101200','Suéteres, etc.de malha de cabra de cachemira','Sweaters, etc.of mesh of kashmir (cashmere) goats','Suéteres, etc.de punto de cabra de cachemira',11,'61','6110','611012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61101900','Suéteres, etc.de malha de outs.mater.têxteis','Sweaters, etc.of other textile materials mesh','Suéteres, etc.de punto de ots.mater.textiles',11,'61','6110','611019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61102000','Suéteres, puloveres, etc.de malha de algodão','Sweaters, pullovers, etc.of cotton mesh','Suéteres, pullovers, etc.de punto de algodón',11,'61','6110','611020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61103000','Suéteres,  puloveres,  etc.de malha de fibras sint/artif.','Sweaters, pullovers, etc.of synth/artif fibres mesh','Suéteres, pullovers, etc.de punto de fibras sint/artif.',11,'61','6110','611030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61109000','Suéteres,  puloveres,  etc.de malha de outra materia têxtil','Sweaters, pullovers, etc.of other textile materials mesh','Suéteres, pullovers, etc.de punto de ot.mater.textil',11,'61','6110','611090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61111000','Vestuário p/bebes e acess.de malha de lã ou pêlos finos','Babies'' garm./cloth.acces.mesh of wool/fine anim.hair','Prendas y complem.p/bebés, de punto de lana/pelo fino',11,'61','6111','611110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61112000','Vestuário p/bebês e acess.de malha de algodão','Babies'' garments/cloth.acces.of cotton mesh','Prendas y complementos p/bebés, de punto de algodón',11,'61','6111','611120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61113000','Vestuário p/bebes e acess.de malha de fibras sintéticas','Babies'' garments/cloth.acces.of synthetic fibres mesh','Prendas y complementos p/bebés, de punto de fibras sint.',11,'61','6111','611130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61119000','Vestuário p/bebes e acess.de malha de outs.mater.text.','Babies'' garments/cloth.acces.of oth.textile mater.mesh','Prendas y complementos p/bebés, de punto de ots.mat.text',11,'61','6111','611190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61119010','Vest./acessórios p/bebê malh.lã/pêlos finos','Babies'' mesh garments/clothing accessories.of wool or fine animal hair','Prendas y complementos p/bebés, de punto de lana o pelo fino',11,'61','6111','611190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61119090','Vest./acessórios p/bebê malha out.mat.têxtil','Babies'' mesh garments/clothing accessories.of other textile materials','Prendas y complementos p/bebés, de punto de ots.mat.text',11,'61','6111','611190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61121100','Abrigos para esportes, de malha de algodão','Track suits, of cotton mesh','Abrigos para deportes, de punto de algodón',11,'61','6112','611211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61121200','Abrigos para esportes,  de malha de fibras sintéticas','Track suits, of synthetic fibres mesh','Abrigos para deportes, de punto de fibras sintéticas',11,'61','6112','611212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61121900','Abrigos para esportes,  de malha de outs.matérias têxteis','Track suits, of other textile materials mesh','Abrigos para deportes, de punto de ots.mat.textiles',11,'61','6112','611219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61122000','Macacoes e conjuntos,  de esqui,  de malha de mater.têxtil','Ski suits, of other textile materials mesh','Monos y conjuntos de esquí, de punto de mater.textil',11,'61','6112','611220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61123100','Shorts e sungas, de banho, de malha de fibra sintética','Men''s or boys'' swimwear, of synthetic fibres mesh','Bañadores para hombres de punto de fibra sintética',11,'61','6112','611231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61123900','Shorts e sungas, de banho, de malha de outras mat.têxteis','Men''s or boys'' swimwear, of oth.textile materials mesh','Bañadores para hombres de punto de ots.mat.textiles',11,'61','6112','611239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61124100','Maiôs e biquínis, de banho, de malha de fibras sintéticas','Women''s or girls'' swimwear, of synthetic fibres mesh','Bañadores para mujeres de punto de fibras sintéticas',11,'61','6112','611241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61124900','Maiôs e biquínis, de banho, de malha de outs.mater.text.','Women''s or girls'' swimwear, of ot.textile materials mesh','Bañadores para mujeres de punto de ots.mat.textiles',11,'61','6112','611249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61130000','Vestuário confecc.de tecidos malha c/plástico/borracha','Garments, made-up of mesh fabrics with plastic/rubber','Prendas de vestir confec.c/tejidos punto c/plást/caucho',11,'61','6113','611300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61141000','Outros vestuários de malha de lã ou de pêlos finos','Other garments of mesh of wool or fine animal hair','Ots.prendas de vestir de punto de lana o de pelo fino',11,'61','6114','611410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61142000','Outros vestuários de malha de algodão','Other garments of cotton mesh','Ots.prendas de vestir de punto de algodón',11,'61','6114','611420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61143000','Outros vestuários de malha de fibra sintet/artificial','Other garments, of synthetic/artificial fibres mesh','Ots.prendas de vestir de punto de fibra sintét/artif.',11,'61','6114','611430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61149000','Outros vestuários de malha de outros matérias têxteis','Other garments, of other textile materials mesh','Ots.prendas de vestir de punto de ots.mat.textiles',11,'61','6114','611490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61149010','Vestuário tecido malha lã/pêlos finos',' garments/fabrics of mesh of wool or fine animal hair','Tejidos y prendas de vestir de punto de lana o de pelo fino',11,'61','6114','611490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61149090','Vestuário tecidos malha d/outs.mats.têxteis','Garments/fabrics, of other textile materials mesh','Tejidos y prendas de vestir de punto de ots.mat.textiles',11,'61','6114','611490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151011','Meias-calças malha fibras sint.<67decitex f/s.','Panty hose of synthetic fibres mesh, <67decitex s/y (measuring per single yarn)','Panty-medias de punto de fibra sintética, <67decitex h/s (por hilo sencillo)',11,'61','6115','611510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151012','Meias-calças malha fibras sint.>67decitex f/s.','Panty hose of synthetic fibres mesh,>67decitex s/y (measuring per single yarn)','Panty-medias de punto de fibra sintética, >67decitex h/s (por hilo sencillo)',11,'61','6115','611510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151013','Meias-calças malha de lã/pêlos finos','Panty hose of mesh of wool or fine animal hair','Panty-medias de punto de lana o de pelo fino',11,'61','6115','611510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151014','Meias-calças malha algodão','Panty hose of cotton mesh','Panty-medias de punto de algodón',11,'61','6115','611510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151019','Outras meias-calças de outras matérias têxteis','Other panty hose of other textile materials','Otras panty-medias de punto de ots.materias textiles',11,'61','6115','611510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151021','Meias fem.até/acima joelho<67dc.sint/art.','Women''s full-length or knee-length hosiery, <67decitex s/y (measuring per single yarn), of synthetic or artificial fibres','Medias de mujer, a altura o por encima de la rodilla, <67decitex h/s (por hilo sencillo), de fibras sintéticas o artificiales',13,'61','6115','611510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151022','Meias fem.ac/at joelho<67dc.f.sim.algodão','Women''s full-length or knee-length hosiery, <67decitex s/y (measuring per single yarn), of cotton or similar fibres','Medias de mujer, a altura o por encima de la rodilla, <67decitex h/s (por hilo sencillo), de algodón y similares',13,'61','6115','611510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151029','Meias fem. ac/at joelho<67dc.outs.mat.têxteis','Women''s full-length or knee-length hosiery, <67decitex s/y (measuring per single yarn), of other textile materials','Medias de mujer, a altura o por encima de la rodilla, <67decitex h/s (por hilo sencillo), de otras materias textiles',13,'61','6115','611510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151091','Outras meias-calças semelh.d/lã/pêlos finos','Other similar panty hose of wool or fine animal hair','Otras panty-medias similares de lana o de pelo fino',13,'61','6115','611510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151092','Outras meias e semelh.malha de algodão','Other stockings of cotton mesh and similar','Otras medias de punto de algodón y similares',13,'61','6115','611510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151093','Outras meias-calças e semel.malha d/fib.sint.','Other panty hose of mesh and similar, of synthetic fibres','Otras panty-medias de punto y similares, de fibras sintéticas',13,'61','6115','611510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151099','Outras meias-calças malha de outras matérias têxteis','Others panty hose of other textile materials','Otras panty-medias de punto de ots.materias textiles',13,'61','6115','611510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151100','Meias-calças de malha de fibra sintética,  tit<67decitex','Panty hose of synthetic fibres mesh, tit<67decitex','Panty-medias de punto de fibra sintética, tít<67decitex',11,'61','6115','611511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151200','Meias-calças de malha de fibra sintética,  tit>=67decitex','Panty hose of synthetic fibres mesh, tit>=67decitex','Panty-medias de punto de fibra sintética, tít>=67decitex',11,'61','6115','611512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151910','Meias-calças de malha de lã ou de pêlos finos','Panty hose of mesh of wool or fine animal hair','Panty-medias de punto de lana o de pelo fino',11,'61','6115','611519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151920','Meias-calças de malha de algodão','Panty hose of cotton mesh','Panty-medias de punto de algodón',11,'61','6115','611519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61151990','Meias-calças de outras matérias têxteis','Panty hose of other textile materials','Panty-medias de punto de ots.materias textiles',11,'61','6115','611519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61152010','Meias de senhora, de malha de fibra sint/artif.tit<67dec','Women''s full-length, of synt/artif. fibre mesh tit<67dec','Medias de mujer, de punto de fibra sint/artif.tít<67dec',13,'61','6115','611520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61152020','Meias de senhora, de malha de algodão,  titulo<67decitex','Women''s full-length, of cotton mesh title<67decitex','Medias de mujer, de punto de algodón, tít<67dec',13,'61','6115','611520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61152090','Meias de senhora, de outras matérias têxteis,  tit<67decitex','Women''s full-length, of oth.text.materials mesh t<67dec','Medias de mujer, de punto de ots.mat.textiles, tít<67dec',13,'61','6115','611520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61152100','Meias-calças malha fibras sint.<67decitex f/s.','Panty hose of synthetic fibres mesh, <67decitex s/y (measuring per single yarn)','Panty-medias de punto de fibra sintética, <67decitex h/s (por hilo sencillo)',11,'61','6115','611521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61152200','Meias-calças malha fibras sint.>67decitex f/s.','Panty hose of synthetic fibres mesh,>67decitex s/y (measuring per single yarn)','Panty-medias de punto de fibra sintética, >67decitex h/s (por hilo sencillo)',11,'61','6115','611522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61152910','Meias-calças malha de lã/pêlos finos','Panty hose of mesh of wool or fine animal hair','Panty-medias de punto de lana o de pelo fino',11,'61','6115','611529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61152920','Meias-calças malha algodão','Panty hose of cotton mesh','Panty-medias de punto de algodón',11,'61','6115','611529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61152990','Outras meias-calças de outras matérias têxteis','Other panty hose of other textile materials','Otras panty-medias de punto de ots.materias textiles',11,'61','6115','611529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61153010','Meias fem.até/acima joelho<67dc.sint/art.','Women''s full-length or knee-length hosiery, <67decitex s/y (measuring per single yarn), of synthetic or artificial fibres','Medias de mujer, a altura o por encima de la rodilla, <67decitex h/s (por hilo sencillo), de fibras sintéticas o artificiales',13,'61','6115','611530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61153020','Meias fem. ac/at joelho<67dc.f.sim.algodão','Women''s full-length or knee-length hosiery, <67decitex s/y (measuring per single yarn), of cotton or similar fibres','Medias de mujer, a altura o por encima de la rodilla, <67decitex h/s (por hilo sencillo), de algodón y similares',13,'61','6115','611530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61153090','Meias fem. ac/at joelho<67dc.outs.mat.têxteis','Women''s full-length or knee-length hosiery, <67decitex s/y (measuring per single yarn), of other textile materials','Medias de mujer, a altura o por encima de la rodilla, <67decitex h/s (por hilo sencillo), de otras materias textiles',13,'61','6115','611530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61159100','Outras meias de malha de lã ou de pêlos finos','Other stockings of mesh of wool/fine animal hair','Otras medias de punto de lana o de pelo fino',13,'61','6115','611591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61159200','Outras meias de malha de algodão','Other stockings of cotton mesh','Otras medias de punto de algodón',13,'61','6115','611592');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61159300','Outras meias de malha de fibras sintéticas','Other stockings of synthetic fibres mesh','Otras medias de punto de fibras sintéticas',13,'61','6115','611593');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61159400','Outs.meias-calças semelh.d/lã/pêlos finos','Other similar panty hose of wool or fine animal hair','Otras panty-medias similares de lana o de pelo fino',13,'61','6115','611594');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61159500','Outras meias e semelh.malha de algodão','Other stockings of cotton mesh and similar','Otras medias de punto de algodón y similares',13,'61','6115','611595');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61159600','Outras meias-calças e semel.malha d/fib.sint.','Other panty hose of mesh and similar, of synthetic fibres','Otras panty-medias de punto y similares, de fibras sintéticas',13,'61','6115','611596');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61159900','Outras meias de malha de outras matérias têxteis','Other stockings of other textile materials mesh','Otras medias de punto de ots.materias textiles',13,'61','6115','611599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61161000','Luvas,  etc.de malha,  impregnadas,  etc.de plástico/borracha','Gloves, etc.of mesh, impregnated, etc.of plastics/rubber','Guantes, etc.de punto, impregnados, etc.de plástico/caucho',13,'61','6116','611610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61169100','Luvas, etc.de malha de lã ou de pêlos finos','Gloves, etc.of mesh of wool or fine animal hair','Guantes, etc.de punto de lana o de pelo fino',13,'61','6116','611691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61169200','Luvas, etc.de malha de algodão','Gloves, etc.of cotton mesh','Guantes, etc.de punto de algodón',13,'61','6116','611692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61169300','Luvas, etc.de malha de fibras sintéticas','Gloves, etc.of synthetic fibres mesh','Guantes, etc.de punto de fibras sintéticas',13,'61','6116','611693');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61169900','Luvas, etc.de malha de outras matérias têxteis','Gloves, etc.of other textile materials mesh','Guantes, etc.de punto de ots.mat.textiles',13,'61','6116','611699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61171000','Xales,  echarpes,  lenços de pescoco,  cachenes,  etc.de malha','Shawls, scarves, mufflers, mantillas, etc.of mesh','Chales, bufandas, pañuelos cuello, mantillas, etc.de punto',11,'61','6117','611710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61172000','Gravatas, gravatas-borboletas e plastrons, de malha','Ties, bow ties and cravats, of mesh','Corbatas y lazos similares, de punto',10,'61','6117','611720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61178000','Outros acessórios de vestuário,  confeccionados,  de malha','Other clothing accessories, made, of mesh','Otros complementos de vestir, confeccionados, de punto',10,'61','6117','611780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61178010','Gravatas, grav.-borb., plastrons, de malha','Ties, bow ties and cravats, of mesh','Corbatas y lazos similares, de punto',10,'61','6117','611780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61178090','Outros acessórios de vest.confec.d/malha','Other clothing accessories, made, of mesh','Otros complementos de vestir, confeccionados, de punto',10,'61','6117','611780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('61179000','Partes de vestuários ou seus acessórios, de malha','Parts of clothings or of their accessories, of mesh','Partes de prendas o sus complementos, de punto',10,'61','6117','611790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62011100','Sobretudos, impermeav.etc.de la/pêlos finos, masculino','Overcoats, impermeab.etc.of wool/fine anim.hair, mascul.','Abrigos, impermeab.etc.de lana/pelo fino, para hombres',11,'62','6201','620111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62011200','Sobretudos, impermeav.etc.de algodão, de uso masculino','Overcoats, impermeab.etc.of cotton, masculine uses','Abrigos, impermeab.etc.de algodón, para hombres',11,'62','6201','620112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62011300','Sobretudos, impermeav.etc.de fibra sint/artif.masculino','Overcoats, impermeab.etc.of synth/artif fibre, masculine','Abrigos, impermeab.etc.de fibra sint/artif., para hombres',11,'62','6201','620113');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62011900','Sobretudos, impermeav.etc.de outs.mater.text.masculino','Overcoats, impermeab.etc.of oth.text.materials, masculine','Abrigos, impermeab.etc.de ots.mat.textiles, para hombres',11,'62','6201','620119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62019100','Outros sobretudos, etc.de la/pêlos finos, uso masculino','Ot.overcoats, etc.of wool/fine animal hair, masculine','Otros abrigos, etc.de lana/pelo fino, para hombres',11,'62','6201','620191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62019200','Outros sobretudos, etc.de algodão, de uso masculino','Other overcoats, etc.of cotton, masculine uses','Otros abrigos, etc.de algodón, para hombres',11,'62','6201','620192');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62019300','Outros sobretudos, etc.de fibras sint/art.uso masculino','Other overcoats, etc.of synthetic fibres, masculine uses','Otros abrigos, etc.de fibras sint/artif., para hombres',11,'62','6201','620193');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62019900','Outros sobretudos,  etc.de outs.mater.text.uso masculino','Oth.overcoats, etc.of oth.textile materials, masculine','Otros abrigos, etc.de ots.mat.textiles, para hombres',11,'62','6201','620199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62021100','Mantos, impermeavs.etc.de la ou pêlos finos, uso feminino','Mantles, impermeab.etc.of wool/fine animal hair, feminine','Abrigos, impermeabs.etc.de lana o pelo fino, para mujeres',11,'62','6202','620211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62021200','Mantos, impermeáveis,etc.de algodão, de uso feminino','Mantles, impermeab.etc.of cotton, feminine uses','Abrigos, impermeabs.etc.de algodón, para mujeres',11,'62','6202','620212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62021300','Mantos,  impermeavs.etc.de fibra sint/artif.uso feminino','Mantles, impermeab.etc.of synth/artif fibres, feminine','Abrigos, impermeabs.etc.de fibra sint/artif, para mujeres',11,'62','6202','620213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62021900','Mantos,  impermeavs.etc.de outs.mater.text.uso feminino','Mantles, impermeab.etc.of oth.textile materials, feminine','Abrigos, impermeabs.etc.de ots.mat.textiles, para mujeres',11,'62','6202','620219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62029100','Outros mantos, etc.de lã ou pêlos finos, de uso feminino','Oth.mantles, imperm.etc.of wool/fine anim.hair, feminine','Ots.abrigos, etc.de lana o pelo fino, para mujeres',11,'62','6202','620291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62029200','Outros mantos, etc.de algodão, de uso feminino','Other mantles, etc.of cotton, feminine uses','Ots.abrigos, etc.de algodón, para mujeres',11,'62','6202','620292');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62029300','Outros mantos,  etc.de fibras sintet/artif.uso feminino','Other mantles, etc.of synth/artif fibres, feminine uses','Ots.abrigos, etc.de fibras sintét/artif, para mujeres',11,'62','6202','620293');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62029900','Outros mantos, etc.de outs.matérias têxteis, uso feminino','Other mantles, etc.of oth.textile materials, feminin.uses','Ots.abrigos, etc.de ots.mat.textiles, para mujeres',11,'62','6202','620299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62031100','Ternos (fatos) de la ou de pêlos finos','Men''s or boys'' suits of wool or fine animal hair','Trajes (ambos o ternos) de lana o pelo fino',11,'62','6203','620311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62031200','Ternos (fatos) de fibras sintéticas','Men''s or boys'' suits of synthetic fibres','Trajes (ambos o ternos) de fibras sintéticas',11,'62','6203','620312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62031900','Ternos (fatos) de outras matérias têxteis','Men''s or boys'' suits of other textile materials','Trajes (ambos o ternos) de otras materias textiles',11,'62','6203','620319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62032100','Conjuntos de la ou de pêlos finos, de uso masculino','Ensembles of wool or fine animal hair, masculine uses','Conjuntos de lana o pelo fino, para hombres',11,'62','6203','620321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62032200','Conjuntos de algodão, de uso masculino','Ensembles of cotton, masculine uses','Conjuntos de algodón, para hombres',11,'62','6203','620322');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62032300','Conjuntos de fibras sintéticas, de uso masculino','Ensembles of synthetic fibres, masculine uses','Conjuntos de fibras sintéticas, para hombres',11,'62','6203','620323');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62032900','Conjuntos de outras matérias têxteis, de uso masculino','Ensembles of other textile materials, masculine uses','Conjuntos de ots.mat.textiles, para hombres',11,'62','6203','620329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62032910','Conjunto de lã ou de pêlos finos, masculino','Ensembles of wool or fine animal hair, masculine uses','Conjuntos de lana o pelo fino, para hombres',11,'62','6203','620329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62032990','Conjuntos de outras matérias têxteis, masculino','Ensembles of other textile materials, masculine uses','Conjuntos de ots.mat.textiles, para hombres',11,'62','6203','620329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62033100','Paletós (casacos) de lã ou de pêlos finos','Ackets (coats) of wool or fine animal hair','Chaquetas (sacos) de lana o pelo fino',11,'62','6203','620331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62033200','Paletós (casacos) de algodão','Ackets (coats) of cotton','Chaquetas (sacos) de algodón',11,'62','6203','620332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62033300','Paletós (casacos) de fibras sintéticas','Ackets (coats) of synthetic fibres','Chaquetas (sacos) de fibras sintéticas',11,'62','6203','620333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62033900','Paletós (casacos) de outras matérias têxteis','Ackets (coats)  of other textile materials','Chaquetas (sacos) de ots.mat.textiles',11,'62','6203','620339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62034100','Calças, jardineiras, etc.de la/pêlos finos, uso masculino','Ensembles, jackets, etc.of wool/fine animal hair, mascul.','Pantalones largos, pants.c/peto, etc.de lana/p.fino, p/hom',11,'62','6203','620341');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62034200','Calças, jardineiras, etc.de algodão, uso masculino','Ensembles, jackets, etc.cotton, use masculine','Pantalones largos, pants.c/peto, etc.de algodón, p/hombres',11,'62','6203','620342');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62034300','Calças, jardineiras, etc.de fibra sintética, uso masculino','Ensembles, jackets, etc.of synthetic fibre, masculine','Pantalones largos, pants.c/peto, etc.de fibra sint, p/hom.',11,'62','6203','620343');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62034900','Calças, jardineiras, etc.de outs.mater.text.uso masculino','Ensembles, jackets, etc.of oth.textile materials, mascul.','Pantalones largos, pant.c/peto, etc.de ots.mat.text, p/hom',11,'62','6203','620349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62041100','Tailleurs (fatos saia-casaco), de lã ou de pêlos finos','Suits (skirt-coat), of wool or fine animal hair','Trajes sastre, de lana o de pelo fino',11,'62','6204','620411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62041200','Tailleurs (fatos de saia-casaco) de algodão','Suits (skirt-coat), of cotton','Trajes sastre, de algodón',11,'62','6204','620412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62041300','Tailleurs (fatos de saia-casaco) de fibras sintéticas','Suits (skirt-coat), of synthetic fibres','Trajes sastre, de fibras sintéticas',11,'62','6204','620413');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62041900','Tailleurs (fatos de saia-casaco) de outras matérias têxteis','Suits (skirt-coat), of other textile materials','Trajes sastre, de ots.mat.textiles',11,'62','6204','620419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62042100','Conjuntos de lã ou de pêlos finos, de uso feminino','Ensembles of wool or fine animal hair, feminine uses','Conjuntos de lana o pelo fino, para mujeres',11,'62','6204','620421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62042200','Conjuntos de algodão, de uso feminino','Ensembles of cotton, feminine uses','Conjuntos de algodón, para mujeres',11,'62','6204','620422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62042300','Conjuntos de fibras sintéticas, de uso feminino','Ensembles of synthetic fibres, feminine uses','Conjuntos de fibras sintéticas, para mujeres',11,'62','6204','620423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62042900','Conjuntos de outras matérias têxteis, de uso feminino','Ensembles of other textile materials, feminine uses','Conjuntos de ots.materias textiles, para mujeres',11,'62','6204','620429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62043100','Blazers de la ou de pêlos finos, de uso feminino','Blazers of wool or fine animal hair, feminine uses','Chaquetas (sacos) de lana o pelo fino, para mujeres',11,'62','6204','620431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62043200','Blazers de algodão, de uso feminino','Blazers of cotton, feminine uses','Chaquetas (sacos) de algodón, para mujeres',11,'62','6204','620432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62043300','Blazers de fibras sintéticas, de uso feminino','Blazers of synthetic fibres, feminine uses','Chaquetas (sacos) de fibras sintéticas, para mujeres',11,'62','6204','620433');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62043900','Blazers de outras matérias têxteis, de uso feminino','Blazers of other textile materials, feminine uses','Chaquetas (sacos) de ots.mat.textiles, para mujeres',11,'62','6204','620439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62044100','Vestidos de lã ou de pêlos finos','Dresses of wool or fine animal hair','Vestidos de lana o pelo fino',11,'62','6204','620441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62044200','Vestidos de algodão','Dresses of cotton','Vestidos de algodón',11,'62','6204','620442');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62044300','Vestidos de fibras sintéticas','Dresses of synthetic fibres','Vestidos de fibras sintéticas',11,'62','6204','620443');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62044400','Vestidos de fibras artificiais','Dresses of artificial fibres','Vestidos de fibras artificiales',11,'62','6204','620444');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62044900','Vestidos de outras matérias têxteis','Dresses of other textile materials','Vestidos de ots.mat.textiles',11,'62','6204','620449');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62045100','Saias e saias-calças, de lã ou de pêlos finos','Skirts, divided skirts, of wool or fine animal hair','Faldas y faldas pantalón, de lana o pelo fino',11,'62','6204','620451');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62045200','Saias e saias-calças, de algodão','Skirts, divided skirts, of cotton','Faldas y faldas pantalón, de algodón',11,'62','6204','620452');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62045300','Saias e saias-calças, de fibras sintéticas','Skirts, divided skirts, of synthetic fibres','Faldas y faldas pantalón, de fibras sintéticas',11,'62','6204','620453');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62045900','Saias e saias-calças, de outras matérias têxteis','Skirts, divided skirts, of other textile materials','Faldas y faldas pantalón, de ots.mat.textiles',11,'62','6204','620459');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62046100','Calças, jardineiras, etc.de lã/pêlos finos, uso feminino','Ensembles, jacket, etc.of wool/fine animal hair, feminine','Pantalones largos, pants.c/peto, etc.de lana/p.fino, p/muj',11,'62','6204','620461');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62046200','Calças, jardineiras, etc.de algodão, de uso feminino','Ensembles, jacket, etc.of cotton, feminine','Pantalones largos, pants.c/peto, etc.de algodón, p/mujeres',11,'62','6204','620462');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62046300','Calças, jardineiras, etc.de fibra sintética, uso feminino','Ensembles, jacket, etc.of synthetic fibre, feminine','Pantalones largos, pants.c/peto, etc.de fibra sint, p/muj.',11,'62','6204','620463');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62046900','Calças, jardineiras, etc.de outs.mater.text.uso feminino','Ensembles, jacket, etc.of oth.textile materials, feminine','Pantalones largos, pants.c/peto, etc.ots.mat.text., p/muj',11,'62','6204','620469');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62051000','Camisas de lã ou de pêlos finos, de uso masculino','Shirts of wool or fine animal hair, masculine uses','Camisas de lana o pelo fino, para hombres',11,'62','6205','620510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62052000','Camisas de algodão, de uso masculino','Shirts of cotton, masculine uses','Camisas de algodón, para hombres',11,'62','6205','620520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62053000','Camisas de fibras sintéticas/artificiais, uso masculino','Shirts of synthetic/artificial fibres, masculine uses','Camisas de fibras sint/artif, para hombres',11,'62','6205','620530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62059000','Camisas de outras matérias têxteis, de uso masculino','Shirts of other textile materials, masculine uses','Camisas de ots.mat.textiles, para hombres',11,'62','6205','620590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62059010','Camisas de lã ou de pêlos finos, masculino','Shirts of wool or fine animal hair, masculine uses','Camisas de lana o pelo fino, para hombres',11,'62','6205','620590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62059090','Camisas de outras matérias têxteis, uso masculino','Shirts of other textile materials, masculine uses','Camisas de ots.mat.textiles, para hombres',11,'62','6205','620590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62061000','Camisas, blusas, etc.de seda/desperds.de uso feminino','Blouses, shirts, etc.of silk or silk waste, feminine uses','Camisas, blusas, etc.de seda/desperds.para mujeres',11,'62','6206','620610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62062000','Camisas, blusas, etc.de la ou pêlos finos, de uso feminino','Blouses, shirts, etc.of wool/fine animal hair, feminine','Camisas, blusas, etc.de lana o pelo fino, para mujeres',11,'62','6206','620620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62063000','Camisas, blusas, etc.de algodão, de uso feminino','Blouses, shirts, etc.of cotton, feminine uses','Camisas, blusas, etc.de algodón, para mujeres',11,'62','6206','620630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62064000','Camisas, blusas, etc.de fibras sint/artif.de uso feminino','Blouses, shirts, etc.of synth/artif fibres, feminine uses','Camisas, blusas, etc.de fibras sint/artif, para mujeres',11,'62','6206','620640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62069000','Camisas, blusas, etc.de outra materia têxtil, uso feminino','Blouses, shirts, etc.of other textile materials, feminine','Camisas, blusas, etc.de ot.mat.textil, para mujeres',11,'62','6206','620690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62071100','Cuecas e ceroulas, de algodão','Underpants and briefs, of cotton','Calzonillos y "slips", de algodón',11,'62','6207','620711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62071900','Cuecas e ceroulas, de outras matérias têxteis','Underpants and briefs, of other textile materials','Calzonillos y "slips", de ots.mat.textiles',11,'62','6207','620719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62072100','Camisolões e pijamas, de algodão, de uso masculino','Nightshirts and pyjamas, of cotton, masculine uses','Camisones y pijamas, de algodón, para hombres',11,'62','6207','620721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62072200','Camisolões e pijamas, de fibra sint/artif.uso masculino','Nightshirts and pyjamas, of synt/artif fibre, masculine','Camisones y pijamas, de fibra sint/artif, para hombres',11,'62','6207','620722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62072900','Camisolões e pijamas, de outs.mater.text.uso masculino','Nightshirts and pyjamas, of oth.text.materials, masculine','Camisones y pijamas, de ots.mat.textiles, para hombres',11,'62','6207','620729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62079100','Camisetas interiores, etc.de algodão, de uso masculino','Singlets, etc.of cotton, masculine uses','Camisetas interiores, etc.de algodón, para hombres',11,'62','6207','620791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62079200','Camisetas interiores, etc.de fibras sint/artif.masculino','Singlets, etc.of synth/artific fibres, feminine uses','Camisetas interiores, etc.de fibras sint/artif, p/hombres',11,'62','6207','620792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62079900','Camisetas interiores,  etc.de outs.mater.text.masculino','Singlets, etc.of other textile materials, masculine','Camisetas interiores, etc.de ots.mat.textiles, p/hombres',11,'62','6207','620799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62079910','Outs.(camisetas,  rob.,  sem.)fibr.sint/art masc.','Others (singlets, bathrobes, similar articles), of synthentic or artificial fibres, masculine uses ','Otras (camisetas interiores, albornoces de baño y articulos similares), de fibras sint/artif., para hombres ',11,'62','6207','620799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62079990','Outs.(camisetas,  rob.,  sem.)outs.m.têxt.masc.','Others (singlets, bathrobes, similar articles), of other textile materials masculine uses ','Otras (camisetas interiores, albornoces de baño y articulos similares), de otras materias textiles, para hombres ',11,'62','6207','620799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62081100','Combinações e anáguas, de fibras sint/artif.uso feminino','Slips and petticoats, of synt/artif fibres, feminine uses','Combinaciones y enaguas, de fibras sint/artif, p/mujeres',11,'62','6208','620811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62081900','Combinações e anáguas, de outs.mater.text.uso feminino','Slips and petticoats, of oth.textile materials, feminine','Combinaciones y enaguas, de ots.mat.textiles, p/mujeres',11,'62','6208','620819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62082100','Camisolas e pijamas, de algodão, de uso feminino','Nightdresses and pyjamas, of cotton, feminine uses','Camisones y pijamas, de algodón, para mujeres',11,'62','6208','620821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62082200','Camisolas e pijamas, de fibras sint/artif.uso feminino','Nightdresses and pyjamas, of synt/artif fibres, feminine','Camisones y pijamas, de fibras sint/artif, para mujeres',11,'62','6208','620822');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62082900','Camisolas e pijamas, de outs.mater.têxteis, uso feminino','Nightdresses and pyjamas, of oth.text.materials, feminine','Camisones y pijamas, de ots.mat.textiles, para mujeres',11,'62','6208','620829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62089100','Corpetes, calcinhas, penhoares, etc., de algodão','Bodices, pants, robes, etc.of cotton','Camisetas, bragas, saltos de cama, etc.de algodón',11,'62','6208','620891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62089200','Corpetes, calcinhas, penhoares, etc.de fibras sint/artif.','Bodices, pants, robes, etc.of synt/artif fibres','Camisetas, bragas, saltos de cama, etc.de fibras sint/art.',11,'62','6208','620892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62089900','Corpetes, calcinhas, penhoares, etc.de outs.mater.têxteis','Bodices, pants, robes, etc.of other textile materials','Camisetas, bragas, saltos de cama, etc.de ots.mat.textiles',11,'62','6208','620899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62091000','Vestuário p/bebes e acessórios,  de la ou de pêlos finos','Babies'' garments/clothing acces.of wool/fine anim.hair','Prendas y complementos para bebés, de lana o pelo fino',11,'62','6209','620910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62092000','Vestuário para bebês e acessórios, de algodão','Babies'' garments/clothing accessories, of cotton','Prendas y complementos para bebés, de algodón',11,'62','6209','620920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62093000','Vestuário para bebês e acessórios,  de fibras sintéticas','Babies'' garments/clothing acces., of synthetic fibres','Prendas y complementos para bebés, de fibras sintéticas',11,'62','6209','620930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62099000','Vestuário para bebês e acessórios,  de outs.matérias têxteis','Babies'' garments/clothing acces., of oth.text.materials','Prendas y complementos para bebés, de ots.mat.textiles',11,'62','6209','620990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62099010','Vest.e acessórios para bebês de lã/pêlos finos','Babies'' garments/clothing acces.of wool/fine anim.hair','Prendas y complementos para bebés, de lana o pelo fino',11,'62','6209','620990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62099090','Vest.e acessórios para bebês d/outs.mat.têxteis','Babies'' garments/clothing acces., of oth.text.materials','Prendas y complementos para bebés, de ots.mat.textiles',11,'62','6209','620990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62101000','Vestuário confeccionado com feltros ou falsos tecidos','Clothing made with felts or false fabrics','Prendas de vestir confecc.con fieltros o telas s/tejer',11,'62','6210','621010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62102000','Sobretudos, impermeav.etc.de mat.têxtil c/plast/borracha','Overcoats, imperm.etc.text.materials with plastic/rubber','Abrigos, impermeabs.etc.de mat.textil c/plástico/caucho',11,'62','6210','621020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62103000','Mantos, impermeav.etc.de mat.têxtil c/plástico/borracha','Mantle, imperm.etc.text.materials with plastic/rubber','Abrigos, impermeabs.etc.de mat.textil c/plástico/caucho',11,'62','6210','621030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62104000','Outros vestuários confecc.c/plástico/borracha,  masculino','Other garment made with plastic and rubber, masculine','Las demás prendas confec.c/plástico/caucho, para hombres',11,'62','6210','621040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62105000','Outros vestuários confecc.c/plástico/borracha,  feminino','Other garment made with plastic and rubber, feminine','Las demás prendas confec.c/plástico/caucho, para mujeres',11,'62','6210','621050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62111100','Shorts e sungas, de banho, exceto de malha','Swimwear, except of mesh','Bañadores para hombres, excepto de punto',11,'62','6211','621111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62111200','Maiôs e biquínis, de banho, exceto de malha','Swimwear, except of mesh','Bañadores para mujeres, excepto de punto',11,'62','6211','621112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62112000','Macacões e conjuntos, de esqui, exceto de malha','Ski suits, except of mesh','Monos y conjuntos, de esquí, excepto de punto',11,'62','6211','621120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62113100','Outros vestuários de la ou pêlos finos, de uso masculino','Other garments of wool or fine animal hair, masculine uses','Otras prendas de vestir de lana/pelo fino, para hombres',11,'62','6211','621131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62113200','Outros vestuários de algodão, de uso masculino','Other garments of cotton, masculine uses','Otras prendas de vestir de algodón, para hombres',11,'62','6211','621132');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62113300','Outros vesturaios de fibras sint/artif.de uso masculino','Other garments of synth/artific.fibres, masculine uses','Otras prendas de vestir de fibras sint/art, para hombres',11,'62','6211','621133');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62113900','Outros vestuários de outs.mater.têxteis, uso masculino','Other garments of other textile materials, masculine uses','Otras prendas de vestir de ots.mat.text., para hombres',11,'62','6211','621139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62113910','Outro vestuário, uso masc.d/lã / pêlos finos','Other garments of wool or fine animal hair, masculine uses','Otras prendas de vestir de lana/pelo fino, para hombres',11,'62','6211','621139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62113990','Outro vestuário masc.d/outs.mats.têxteis','Other garments of other textile materials, masculine uses','Otras prendas de vestir de ots.mat.text., para hombres',11,'62','6211','621139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62114100','Outros vestuários de la ou pêlos finos, de uso feminino','Other garments of wool or fine animal hair, masculine','Otras prendas de vestir de lana/pelo fino, para mujeres',11,'62','6211','621141');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62114200','Outros vestuários de algodão, de uso feminino','Other garments use cotton, masculine uses','Otras prendas de vestir de algodón, para mujeres',11,'62','6211','621142');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62114300','Outros vestuários de fibras sint/artif.de uso feminino','Other garments of synth/artific.fibres, feminine uses','Otras prendas de vestir de fibras sint/art, para mujeres',11,'62','6211','621143');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62114900','Outros vestuários de outs.matérias têxteis,  uso feminino','Other garments of other textile materials, feminine uses','Otras prendas de vestir de ots.mat.text., para mujeres',11,'62','6211','621149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62121000','Sutias e "bustiers" ("soutiens" de cos alto)','Brassières','Sostenes (corpiño)',11,'62','6212','621210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62122000','Cintas e cintas-calças','Girdles and panty-girdles','Fajas y fajas braga',11,'62','6212','621220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62123000','Modeladores de torso inteiro (cintas "soutiens")','For modeling whole torso corselettes','Fajas sostén (fajas corpiño)',11,'62','6212','621230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62129000','Espartilhos,  suspensórios,  ligas,  artefs.semelhs.e partes','Corsets, suspenders, gart.similar articles and parts ther','Corsés, tirantes, ligas, artículos similares y sus partes',11,'62','6212','621290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62131000','Lenços de assoar e de bolso, de seda/desperds.de seda','Handkerchiefs of silk/silk waste','Pañuelos de bolsillo de seda/desperds.de seda',11,'62','6213','621310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62132000','Lenços de assoar e de bolso, de algodão','Handkerchiefs, of cotton','Pañuelos de bolsillo de algodón',11,'62','6213','621320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62139000','Lenços de assoar e de bolso, de outras matérias têxteis','Handkerchiefs, of other textile materials','Pañuelos de bolsillo de otras materias textiles',11,'62','6213','621390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62139010','Lenços de assoar e de bolso, seda/desp.seda','Pocket handkerchiefs,  silk/silk waste','Panuelos de bolsillo de seda,  desperdicios de seda',11,'62','6213','621390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62139090','Lenços de assoar e de bolso, outs.mats.têxteis','Pocket handkerchiefs,  other frabrics','Pañuelos de bolsillo de otras materias textiles',11,'62','6213','621390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62141000','Xales,  echarpes,  cachecois,  etc.de seda/desperds.de seda','Shawls, scarves, mufflers, mantillas, etc.silk/silk waste','Chales, pañs.de cuello, bufandas, etc.de seda/desps.seda',11,'62','6214','621410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62142000','Xales,  echarpes,  cachecois,  etc.de la ou de pêlos finos','Shawls, scarves, mufflers, mantil.etc.wool/fine anim.hair','Chales, pañuelos de cuello, bufandas, etc.de lana/p.fino',11,'62','6214','621420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62143000','Xales,  echarpes,  cachecois,  etc.de fibras sintéticas','Shawls, scarves, mufflers, mantil.etc.of synthetic fibres','Chales, pañuelos de cuello, bufandas, etc.de fibras sint.',11,'62','6214','621430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62144000','Xales,  echarpes,  cachecois,  etc.de fibras artificiais','Shawls, scarves, mufflers, mantil.etc.of synthetic fibres','Chales, pañuelos de cuello, bufandas, etc.de fibras artif.',11,'62','6214','621440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62149010','Xales, echarpes, cachecóis, etc.de algodão','Shawls, scarves, mufflers, mantil.etc.of cotton','Chales, pañuelos de cuello, bufandas, etc.de algodón',11,'62','6214','621490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62149090','Xales, echarpes, cachecóis,  etc.de outras matérias têxteis','Shawls, scarves, mufflers, mantil.etc.oth.text.materials','Chales, pañuelos de cuello, bufandas, etc.de ots.mat.text.',11,'62','6214','621490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62151000','Gravatas,  plastrons,  etc.de seda ou desperdícios de seda','Ties, cravats, etc.of silk/silk waste','Corbatas, lazos similares, etc.de seda o desperds.de seda',11,'62','6215','621510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62152000','Gravatas,  plastrons,  etc.de fibras sintéticas/artificiais','Ties, cravats, etc.of synthetic/artificial fibres','Corbatas, lazos similares, etc.de fibras sintéticas/artif',11,'62','6215','621520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62159000','Gravatas,  plastrons,  etc.de outras matérias têxteis','Ties, cravats, etc.of other textile materials','Corbatas, lazos similares, etc.de otras materias textiles',11,'62','6215','621590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62160000','Luvas,  mitenes e semelhantes','Gloves, mittens and mitts','Guantes, mitones y manoplas',13,'62','6216','621600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62171000','Outros acessórios de vestuário, confeccionados','Other made-up clothing accessories','Otros complementos de vestir, confeccionados',10,'62','6217','621710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('62179000','Outras partes de vestuário ou dos seus acessórios','Other parts of made-up clothing or its accessories','Otras partes de prendas de vestir o de sus complementos',10,'62','6217','621790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63011000','Cobertores e mantas, elétricos','Electric blankets','Mantas eléctricas',11,'63','6301','630110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63012000','Cobertores e mantas, de lã ou pêlos finos, não elétricos','Blankets and travel.rugs, of wool/fine anim.hair, n/elec.','Mantas de lana o pelo fino, excepto las eléctricas',10,'63','6301','630120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63013000','Cobertores e mantas, de algodão, não elétricos','Blankets and travel.rugs, of cotton, n/electric','Mantas de algodón, excepto las eléctricas',10,'63','6301','630130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63014000','Cobertores e mantas, de fibras sintéticas,não elétricos','Blankets and travel.rugs, of synthetic fibres, n/elec.','Mantas de fibras sintéticas, excepto las eléctricas',10,'63','6301','630140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63019000','Outros cobertores e mantas','Other blankets and travelling rugs','Las demás mantas',10,'63','6301','630190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63021000','Roupas de cama, de malha','Bed linen, knitted or crocheted','Ropas de cama, de punto',10,'63','6302','630210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63022100','Roupas de cama, de algodão, estampadas','Bed linen,  of cotton,  printed','Ropas de cama,  de algodón,  estampadas',10,'63','6302','630221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63022200','Roupas de cama, de fibras sintéticas ou artif.estampadas','Bed linen, of synth/artific fibres, printed','Ropas de cama, de fibras sintéticas o artif., estampadas',10,'63','6302','630222');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63022900','Roupas de cama, de outras matérias têxteis, estampadas','Bed linen, of other textile materials, printed','Ropas de cama, de ots.materias textiles, estampadas',10,'63','6302','630229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63023100','Outras roupas de cama, de algodão','Other bed linen, of cotton','Las demás ropas de cama, de algodón',10,'63','6302','630231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63023200','Outras roupas de cama, de fibras sintéticas/artificiais','Other bed linen, of synth/artific fibres','Otras ropas de cama, de fibras sintéticas/artificiales',10,'63','6302','630232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63023900','Outras roupas de cama, de outras matérias têxteis','Other bed linen, of other textile materials','Otras ropas de cama, de otras materias textiles',10,'63','6302','630239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63024000','Roupas de mesa, de malha','Table linen, knitted or crocheted','Ropas de mesa, de punto',10,'63','6302','630240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63025100','Roupas de mesa, de algodão, exceto de malha','Table linen, of cotton, except knitted or crocheted','Ropas de mesa, de algodón, exc.de punto',10,'63','6302','630251');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63025200','Roupas de mesa, de linho, exceto de malha','Table linen, of flax, except knitted or crocheted','Ropas de mesa, de lino, exc.de punto',10,'63','6302','630252');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63025300','Roupas de mesa,  de fibras sintéticas/artif.exc.de malha','Table linen, of synth/artific fibres, exc.mesh','Ropas de mesa, de fibras sintéticas/artif.exc.de punto',10,'63','6302','630253');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63025900','Roupas de mesa, de outras matérias têxteis','Table linen, of other textile materials','Ropas de mesa, de otras materias textiles',10,'63','6302','630259');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63025910','Roupas de mesa de linho, exceto de malha','Table linen, of flax, except knitted or crocheted','Ropas de mesa, de lino, exc.de punto',10,'63','6302','630259');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63025990','Outras roupas de mesa de outs.mat.têxteis','Other table linen, of other textile materials','Otras ropas de mesa, de otras materias textiles',10,'63','6302','630259');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63026000','Roupas de toucador/cozinha,  de tecidos atoalh.de algodão','Toilet linen/kitchen linen, of terry towelling, of cotton','Ropas de tocador/cocina, de tejs.c/bucl.tip.toal.de alg.',10,'63','6302','630260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63029100','Outras roupas de toucador ou de cozinha,  de algodão','Other toilet linen/kitchen linen, of cotton','Ots.ropas de tocador o cocina, de algodón',10,'63','6302','630291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63029200','Roupas de toucador/cozinha,  de linho','Toilet linen/kitchen linen, of flax','Ropas de tocador o cocina, de lino',10,'63','6302','630292');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63029300','Roupas de toucador/cozinha, de fibras sintéticas/artif.','Toilet linen/kitchen linen, of synthetic/artificial','Ropas de tocador o cocina, de fibras sintéticas/artif.',10,'63','6302','630293');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63029900','Roupas de toucador/cozinha, de outras matérias têxteis','Toilet linen/kitchen linen, of other textile materials','Ropas de tocador o cocina, de ots.mat.textiles',10,'63','6302','630299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63029910','Outs.roupas/cama/coz/touc/mesa, linho','Other bed linen/kitchen linen/toilet linen/table linen, of flax','Otras ropas de cama/cocina/tocador/mesa, de lino',10,'63','6302','630299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63029990','Outs.roupas/cam/coz/touc/mesa outs.m.têxt.','Other bed linen/kitchen linen/toilet linen/table linen, of other textile materials','Otras ropas de cama/cocina/tocador/mesa, de otras materias textiles',10,'63','6302','630299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63031100','Cortinas, sanefas, etc.de malha de algodão','Curtains, valances, etc.of cotton mesh','Cortinas, guardamalletas, etc.de punto de algodón',10,'63','6303','630311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63031200','Cortinas,  sanefas,  etc.de malha de fibras sintéticas','Curtains, valances, etc.of synthetic fibres mesh','Cortinas, guardamalletas, etc.de punto de fibras sintét.',10,'63','6303','630312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63031900','Cortinas,  sanefas,  etc.de malha de outs.matérias têxteis','Curtains, valances, etc.of oth.textile materials mesh','Cortinas, guardamalletas, etc.de punto de ots.mat.text.',10,'63','6303','630319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63031910','Cortinados, cort.est, sanefas, semelh.m.d/alg.','Veil, printed curtains, valances, cotton mesh and similar materials','Velo, cortinas estampadas, guardamalletas, de punto de algodón y materia similar',10,'63','6303','630319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63031990','Cortinados, cort.est, sanef.malh.out.m.têxtil','Veil, printed curtains, valances, mesh, of other textile materials','Velo, cortinas estampadas, guardamalletas, de punto, de otras materias textiles',10,'63','6303','630319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63039100','Cortinas, sanefas, etc.de algodão, exc.de malha','Curtains, valances, etc.of cotton, exc.mesh','Cortinas, guardamalletas, etc.de algodón, exc.de punto',10,'63','6303','630391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63039200','Cortinas,  sanefas,  etc.de fibras sintéticas,  exc.de malha','Curtains, valances, etc.of synthetic fibres, exc.mesh','Cortinas, guardamalletas, etc.de fibras sint, exc.de punto',10,'63','6303','630392');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63039900','Cortinas,  sanefas,  etc.de outs.mater.têxteis,  exc.de malha','Curtains, valances, etc.of oth.textile materials, exc.mesh','Cortinas, guardamalletas, etc.de ots.mat.tex, exc.de punto',10,'63','6303','630399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63041100','Colchas de malha','Mesh bespreads','Colchas de punto',10,'63','6304','630411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63041910','Colchas de algodão, exceto de malha','Cotton bedspreads, except mesh','Colchas de algodón, exc.de punto',10,'63','6304','630419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63041990','Colchas de outras matérias têxteis','Bedspreads of other textile materials','Colchas de ots.materias textiles',10,'63','6304','630419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63049100','Outros artefs.guarn.interior, de malha','Other f/interior furnishing articles, of mesh','Los demás artículos de tapicería, de punto',10,'63','6304','630491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63049200','Outros artefs.guarn.interior,  de algodão,  exc.de malha','Other f/interior furnishing articles, of cotton, exc.mesh','Los demás artícs.de tapicería, de algodón, exc.de punto',10,'63','6304','630492');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63049300','Outros artefs.guarn.interior,  de fibra sint.exc.de malha','Oth.f/interior furnish.articles, of synt.fibres, exc.mesh','Los demás arts.de tapicería, de fibra sint., exc.de punto',10,'63','6304','630493');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63049900','Outros artefs.guarn.interior,  de outs.mat.text.exc.malha','Oth.f/interior furnish.articles, of oth.tex.mat.exc.mesh','Los demás artícs.de tapicería, de ots.mat.text, exc.punto',10,'63','6304','630499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63051000','Sacos p/embalagem,  de juta/outra fibra têxtil liberiana','Sacks f/packing, of jute/oth.textile bast fibres','Sacos p/envasar, de yute/otra fibra textil del líber',10,'63','6305','630510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63052000','Sacos para embalagem, de algodão','Sacks for packing, of cotton','Sacos para envasar, de algodón',10,'63','6305','630520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63053200','Conteiner flexiv.p/prods.granel, de mat.text.sint/artif.','Flexible intermed.bulk containers, of tex.mat.synt/artif','Continente flexib.p/prods.granel,  de mat.text.sint/art.',10,'63','6305','630532');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63053310','Sacos para embalagem, de malha de polietileno/polipropileno','Sacks f/packing, of polyethylene/polypropylen mesh','Sacos p/envasar, de punto de polietileno o polipropileno',10,'63','6305','630533');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63053390','Outros sacos p/embalagem, de lâminas de polietileno,  etc.','Other sacks f/packing, of strip polyethylene, etc.','Otros sacos para envasar,  de tiras de polietileno, etc.',10,'63','6305','630533');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63053900','Sacos para embalagem,  de outras matérias têxteis sint/artif','Sacks f/packing, of oth.textile materials synth/artif','Sacos para envasar, de ots.mat.textiles sint/artif.',10,'63','6305','630539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63059000','Outros sacos para embalagem','Other sacks for packing','Otros sacos para envasar',10,'63','6305','630590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63061100','Encerados e toldos, de algodão','Tarpaulins and awnings, of cotton','Toldos de cualquier clase, de algodon',10,'63','6306','630611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63061200','Encerados e toldos, de fibras sintéticas','Tarpaulins and awnings, of synthetic fibres','Toldos de cualquier clase, de fibras sintéticas',10,'63','6306','630612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63061900','Encerados e toldos, de outras matérias têxteis','Tarpaulins and awnings, of other textile materials','Toldos de cualquier clase, de ots.mat.textiles',10,'63','6306','630619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63061910','Encerados e toldos de algodão','Tarpaulins and awnings, of cotton','Toldos de cualquier clase, de algodon',10,'63','6306','630619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63061990','Encerados e toldos de outras matérias têxteis','Tarpaulins and awnings, of other textile materials','Toldos de cualquier clase, de ots.mat.textiles',10,'63','6306','630619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63062100','Tendas de algodão','Cotton tents','Tiendas de algodón',10,'63','6306','630621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63062200','Tendas de fibras sintéticas','Tents of synthetic fibres','Tiendas de fibras sintéticas',10,'63','6306','630622');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63062900','Tendas de outras matérias têxteis','Tents of other textile materials','Tiendas de otras mat.textiles',10,'63','6306','630629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63062910','Tendas de algodão','Cotton tents','Tiendas de algodón',10,'63','6306','630629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63062990','Tendas de outras matérias têxteis','Tents of other textile materials','Tiendas de ots.mat.textiles',10,'63','6306','630629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63063010','Velas de fibras sintéticas, para embarcações, etc.','Sails for boats, etc, of synthetic fibers','Velas para embarcaciones, etc.de fibras sintéticas',10,'63','6306','630630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63063090','Velas d/outs.matér.têxteis, p/embarc.etc.','Sials for boats, etc, of other textile materials','Velas para embarcaciones, etc.de ots.mat.textiles',10,'63','6306','630630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63063100','Velas para embarcações, etc.de fibras sintéticas','Sails for boats, etc, of synthetic fibers','Velas para embarcaciones, etc.de fibras sintéticas',10,'63','6306','630631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63063900','Velas para embarcações,  etc.de outras matérias têxteis','Sials for boats, etc, of other textile materials','Velas para embarcaciones, etc.de ots.mat.textiles',10,'63','6306','630639');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63064010','Colchões pneumáticos de algodão','Pneumatic mattresses of cotton','Colchones neumáticos, de algodon',10,'63','6306','630640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63064090','Colchões pneumáticos de outras mat.têxteis','Pneumatic mattresses, of other textile materials','Colchones neumáticos, de ots.mat.textiles',10,'63','6306','630640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63064100','Colchões pneumáticos, de algodão','Pneumatic mattresses of cotton','Colchones neumáticos, de algodon',10,'63','6306','630641');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63064900','Colchões pneumáticos, de outras matérias têxteis','Pneumatic mattresses, of other textile materials','Colchones neumáticos, de ots.mat.textiles',10,'63','6306','630649');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63069000','Out.art.p/ acampamento, out.encer.e toldos','Other items for camping; others tarpaulins and awnings','Otros productos para camping; otras lonas y toldos',10,'63','6306','630690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63069100','Artigos para acampamento, de algodão','Camping goods, of cotton','Artículos para acampar, de algodón',10,'63','6306','630691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63069900','Artigos para acampamento, de outras matérias têxteis','Camping goods, of other textile materials','Artículos para acampar, de ots.mat.textiles',10,'63','6306','630699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63071000','Rodilhas, esfregões e outs.artefatos confecc.de limpeza','Dish-cloths, dusters and similar cleaning cloths','Paños p/fregar/lavar y ots.artículos confecc.p/limpieza',10,'63','6307','630710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63072000','Cintos e coletes salva-vidas','Life-jackets and life-belts','Cinturones y chalecos salvavidas',10,'63','6307','630720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63079010','Outros artefatos confeccionados, de falso tecido','Other made-up articles, of nonwovens','Los demás artículos confeccionados, de telas sin tejer',10,'63','6307','630790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63079020','Artefatos tubulares c/trat.ignif.p/saída emerg.pessoas','Fire-proofed sleeves f/emerg.evacuation of persons','Manga c/tratam.ignífugo apta p/salida de emerg.personas',10,'63','6307','630790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63079090','Outros artefatos têxteis confeccionados','Other made-up textile articles','Los demás artículos textiles confeccionados',10,'63','6307','630790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63080000','Sortidos de cortes de tecido/fios,  p/confecc.tapetes,  etc','Sets consist.of fabric/yarn, f/making up into rugs, etc.','Juegos consts.por piezas de tej./hilados, p/conf.alf.etc',10,'63','6308','630800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63090010','Vestuário, seus acessórios e suas partes, usados','Worn clothing, their accessories and their parts','Prendas, sus complementos y sus partes, usados',10,'63','6309','630900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63090090','Outros artefatos de matérias têxteis, usados','Other worn articles of textile materials','Los demás artículos de materias textiles, usados',10,'63','6309','630900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63101000','Trapos,  cordéis,  etc.de matérias têxteis,  escolhidos','Rags, cordage, etc.of textile materials, sorted','Trapos, cordeles, etc.de materias textiles, clasificados',10,'63','6310','631010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('63109000','Outs.trapos,  cordéis,  etc.de matérias têxteis,  em desperds','Oth.rags, cordage, etc.of textile materials, waste','Ots.trapos, cordeles, etc.de materias textiles, en desperd',10,'63','6310','631090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64011000','Calçados impermeav.de borracha/plast.c/biq.prot.metal','Waterproof footw.of rubber/plastic c/prot.metal toecap','Calzados impermeab.de caucho/plást.c/puntera met.prot.',13,'64','6401','640110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64019100','Calçados impermeav.de borracha/plast.cobrindo joelho','Waterproof footwear of rubber/plast.covering the knee','Calzados impermeab.de caucho/plást.q cubran la rodilla',13,'64','6401','640191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64019200','Calçados impermeav.de borracha/plast.cobrindo tornozelo','Waterproof footwear of rubber/plast.covering the ankle','Calzados impermeab.de caucho/plást.q cubran el tobillo',13,'64','6401','640192');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64019900','Outros calçados impermeav.de borracha/plast.sem costura','Oth.waterproof footw.of rubber/plastic, seamless','Calzados impermeab.de caucho/plást.sin costura',13,'64','6401','640199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64019910','Outs.calç.cobr.joelho sola ext.borr., plást.','Other footwear covering the knee, with outer soles of rubber or plastic','Otros calzados que cubran la rodilla, con suela de caucho o plástico',13,'64','6401','640199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64019990','Outs.calçados imperm.d/borr./plást.s/const.','Oth.waterproof footw.of rubber/plastic, seamless','Calzados impermeab.de caucho/plást.sin costura',13,'64','6401','640199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64021200','Calçados p/esqui e p/surfe de neve,  de borracha/plástico','Ski-boots and snowboard boots, of rubber/plastic','Calzados de esquí y de snowboard, de caucho/plástico',13,'64','6402','640212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64021900','Calçados para outros esportes, de borracha ou plástico','Footwear for other sports, of rubber or plastic','Calzados para otros deportes, de caucho/plástico',13,'64','6402','640219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64022000','Calçados de borracha/plast.c/parte super.em tiras,  etc.','Footwear with upper straps, of rubber/plastic, etc','Calzados de caucho/plástico, c/parte super.en tiras, etc.',13,'64','6402','640220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64023000','Outros calçados de borracha/plástico, c/biq.prot.de meta','Oth.footwear of rubber/plastic c/prot.metal toecap','Ots.calzados de caucho/plást, c/puntera metál.protección',13,'64','6402','640230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64029100','Outros calçados de borracha/plástico,  cobrindo tornozelo','Oth.waterproof footwear of rubber/plast.covering the ankle','Ots.calzados de caucho/plástico, que cubran el tobillo',13,'64','6402','640291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64029110','Outs.calç.cobr.torn.c/biqueir.protet.d/metal','Other footwear, covering the ankle, with a protective metal toecap','Otros calzados, que cubran el tobillo, c/puntera met.de protecc. ',13,'64','6402','640291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64029190','Outs.calç.cobr.tornoz.part.sup.borr.,  plást.','Other footwear, covering the ankle, uppers of rubber or plastic ','Otros calzados, que cubran el tobillo y parte superior de caucho o plástico',13,'64','6402','640291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64029900','Outros calçados de borracha ou plástico','Other footwear of rubber/plastic','Ots.calzados de caucho o plástico',13,'64','6402','640299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64029910','Outs.calç.cobr.torn.c/biqueir.protet.d/metal','Other footwear, covering the ankle, with a protective metal toecap','Otros calzados, que cubran el tobillo, c/puntera met.de protecc. ',13,'64','6402','640299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64029990','Outs.calç.cobr.tornoz.part.sup.borr.,  plást.','Other footwear, covering the ankle, uppers of rubber or plastic ','Otros calzados, que cubran el tobillo y parte superior de caucho o plástico',13,'64','6402','640299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64031200','Calçados para esqui e para surfe de neve, de couro natural','Ski-boots and snowboard boots, of leather','Calzados de esquí y de snowboard, de cuero natural',13,'64','6403','640312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64031900','Calçados para outros esportes, de couro natural','Footwear for other sports, of leather','Calzados para otros deportes, de cuero natural',13,'64','6403','640319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64032000','Calçados de couro natural,  c/parte super.em tiras,  etc.','Footwear of leather, with upper straps, etc','Calzados de cuero natural, c/parte super.en tiras, etc.',13,'64','6403','640320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64033000','Calçados de couro natural,  c/sola madeira,  s/palmilha,  etc','Footw.of leather, made on base of wood, n/inner sole, etc','Calzados de cuero nat.c/palm.de madera, s/plantilla, etc',13,'64','6403','640330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64034000','Outros calçados de couro natural, c/biqueira prot.de metal','Oth.footwear of leather, c/protective metal toecap','Ots.calzados de cuero natural, c/puntera met.de protecc.',13,'64','6403','640340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64035100','Calçados de couro natural,  sola couro,  cobrindo tornozelo','Footwear of leather, leather sole, covering the ankle','Calzados de cuero nat., suela cuero, q cubran el tobillo',13,'64','6403','640351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64035110','Calçados com sola madeira, s/palm.e biq.prot.d/metal','Footwear with outer soles of wood, no inner sole, with a protective metal toecap','Calzados con suela de madera, sin plantilla, c/puntera met.de protecc.',13,'64','6403','640351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64035190','Outros calçads.sola ext./cour.nat.cobr.torn.','Oth.footwear of leather and outer soles of leather, covering the ankle','Calzados de cuero natural, suela de cuero, q cubran el tobillo',13,'64','6403','640351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64035900','Outros calçados de couro natural e sola exterior de couro','Oth.footwear of leather and outer soles of leather','Ots.calzados de cuero natural, suela de cuero',13,'64','6403','640359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64035910','Calç. c/sola mad.s/palm.,   e biq.prot.d/metal','Footwear with outer soles of wood, no inner sole, with a protective metal toecap','Calzados con suela de madera, sin plantilla, c/puntera met.de protecc.',13,'64','6403','640359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64035990','Outs.calçads.sola ext./cour.nat.cobr.torn.','Oth.footwear of leather and outer soles of leather, covering the ankle','Ots.calzados de cuero natural, suela de cuero, q cubran el tobillo',13,'64','6403','640359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64039100','Outros calçados de couro natural,  cobrindo o tornozelo','Oth.footwear of eather, covering the ankle','Ots.calzados de cuero natural, q cubran el tobillo',13,'64','6403','640391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64039110','Calçados c/sola mad.s/palm., e biq.prot.d/metal','Footwear with outer soles of wood, no inner sole, with a protective metal toecap','Calzados con suela de madera, sin plantilla, c/puntera met.de protecc.',13,'64','6403','640391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64039190','Outs.calçads.sola ext./cour.nat.cobr.torn.','Oth.footwear of leather and outer soles of leather, covering the ankle','Ots.calzados de cuero natural, suela de cuero, q cubran el tobillo',13,'64','6403','640391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64039900','Outros calçados de couro natural','Other footwear made of leather','Otros calzados de cuero natural',13,'64','6403','640399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64039910','Calçado c/sola mad.s/palm., biq. protet.d/metal','Footwear with outer soles of wood, no inner sole, with a protective metal toecap','Calzados con suela de madera, sin plantilla, c/puntera met.de protecc.',13,'64','6403','640399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64039990','Outs.calçads.sol.ext.borr./plást.couro/nat.','Other footwear of leather with outer soles of rubber or plastic','Otros calzados de cuero natural con suela de caucho o plástico ',13,'64','6403','640399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64041100','Calçados p/esportes,  etc.de mat.text.sola borracha/plast','Sports footwear, etc.of text.mat.soles of rubber/plastic','Calzados p/deportes, etc.de mat.text., suela caucho/plást',13,'64','6404','640411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64041900','Outs.calçados de materia têxtil,  sola de borracha/plast.','Oth.footwear of text.materials, soles of rubber/plastic','Ots.calzados de mat.textil, suela caucho/plást',13,'64','6404','640419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64042000','Calçados de materia têxtil,  com sola exterior de couro','Footwear of text.materials, with outer soles of leather','Calzados de mat.textil, con suela exterior de caucho',13,'64','6404','640420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64051010','Calçados de couro reconst.sola exter.de borracha/plast.','Footwear composition leather, soles of rubber/plastic','Calzados de cuero regener.suela exter.de caucho/plást.',13,'64','6405','640510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64051020','Calçados de couro reconst.sola exter.de couro','Footwear composit.leather, with outer soles of leather','Calzados de cuero regener.suela exter.de cuero',13,'64','6405','640510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64051090','Outros calçados de couro natural ou reconstituido','Other footwear of leather or composition leather','Los demás calzados de cuero natural o regenerado',13,'64','6405','640510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64052000','Outros calçados de matérias têxteis','Other footwear of textile materials','Los demás calzados de materias textiles',13,'64','6405','640520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64059000','Outros calçados','Other footwear','Otros calzados',13,'64','6405','640590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64061000','Partes superiores de calçados e seus componentes','Uppers and parts of footwear','Partes superiores de calzados y sus partes',13,'64','6406','640610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64062000','Solas exteriores e saltos, de borracha ou plástico','Outer soles and heels, of rubber or plastics','Suelas y tacones, de caucho o plástico',10,'64','6406','640620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64069010','Solas exteriores e saltos, de couro natural ou recons.','Outer soles of heels, leather or composition leather','Suela de los talones, cuero natural o regenerado',10,'64','6406','640690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64069020','Palmilhas','Insoles','Plantillas',10,'64','6406','640690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64069090','Outras partes de calçados, etc','Other parts of footwear, etc.','Otras partes de calzados, etc',10,'64','6406','640690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64069100','Outras partes de calçados, de madeira','Other parts of footwear, of wood','Las demás partes de calzados, de madera',10,'64','6406','640691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64069910','Sola exterior e salto,  de calçados,  de couro nat/reconst.','Outer soles and heels, of footwear, of leather/composit.','Suela y tacón, de calzados, de cuero nat/regenerado',10,'64','6406','640699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64069920','Palmilhas de outras matérias','Inner soles of other materials','Plantillas de las demás materias',10,'64','6406','640699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('64069990','Outras partes de calçados, etc.de outras matérias','Other parts of footwear, etc.of other materials','Otras partes de calzados, etc.de las demás materias',10,'64','6406','640699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65010000','Esbocos n/enformados,  discos,  etc.de feltro,  p/chapeus','Hat-forms, plateaux, etc.of felt, f/hat','Cascos sin forma, platos, etc.de fieltro, p/sombreros',10,'65','6501','650100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65020010','Esboços de chapeus, entrançados, etc.de palha fina','Hat-shapes, plaited, etc.fine straw','Cascos p/sombreros, trenzados, etc.de paja toquilla',10,'65','6502','650200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65020090','Esboços de chapéus, entrançados, etc.de outras matérias','Hat-shapes, plaited, etc. of other materials','Cascos p/sombreros, trenzados, etc.de ots.materias',10,'65','6502','650200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65030000','Chapéus e outs.artefs.de feltro,  obtidos dos esbocos,  etc','Felt hats and oth.felt headgear, obt. hat bodies, etc','Sombreros y demás tocados de fieltro, fabric.cascos, etc',11,'65','6503','650300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65040010','Chapéus e outros artefs.entrançados,  etc.de palha fina','Hats and other headgear, plaited, etc.of fine straw','Sombreros y demás tocados trenzados, etc.paja toquilla',10,'65','6504','650400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65040090','Chapeus e outs.artefs.entrancados,  etc.de outs.matérias','Hats and other headgear, plaited, etc.of other materials','Sombreros y demás tocados trenzados, etc.de ots.materias',10,'65','6504','650400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65050011','Bonés de algodão','Cotton caps','Caps of algodón',10,'65','6505','650500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65050012','Bonés de fibras sintéticas ou artificiais','Caps of synthetic or artificial fibers','Caps de fibras sintéticas o artificiales',10,'65','6505','650500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65050019','Bonés de outras matérias têxteis','Caps of other textile materials','Caps de otras materias textiles',10,'65','6505','650500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65050021','Gorros de algodão','Cotton caps','Gorras de algodón',10,'65','6505','650500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65050022','Gorros de fibras sintéticas ou artificiais','Beanies of synthetic or artificial fibers','Gorras de fibras sintéticas o artificiales',10,'65','6505','650500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65050029','Gorros de outras matérias têxteis','Beanies of other textile materials','Gorras de otras materias textiles',10,'65','6505','650500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65050031','Chapéus de algodão','Hats of cotton','Sombreros de algodón',10,'65','6505','650500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65050032','Chapéus de fibras sintéticas ou artificiais','Hats of synthetic or artificial fibers','Sombreros de fibras sintéticas o artificiales',10,'65','6505','650500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65050039','Chapéus de outras matérias têxteis','Hats of other textile materials','Sombreros de las demás materias textiles',10,'65','6505','650500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65050090','Art.de uso semelh.a chapéu; coifas e rede p/cabelo','Articles for using like hats; hair nets, hoods','Artículos como sombreros; redecillas para el cabello',10,'65','6505','650500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65051000','Coifas e redes, para o cabelo','Hairnets','Redecillas para el cabello',10,'65','6505','650510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65059000','Chapéus e outros artefs.de malha/confecc.com rendas,  etc','Hats and other headgear of mesh/made-up from lace, etc','Sombreros y demás tocados de punto/confecc.c/encaje, etc',10,'65','6505','650590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65059011','Bonés de algodão','Cotton caps','Gorra de algodon',10,'65','6505','650590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65059012','Bonés de fibras sintéticas ou artificiais','Caps of synthetic or artificial fibres','Gorras de fibras sintéticas o artificiales',10,'65','6505','650590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65059019','Bonés de outras matérias têxteis','Caps of other textile materials','Gorras de otras materias textiles',10,'65','6505','650590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65059021','Gorros de algodao','Cotton caps','Gorras de algodón',10,'65','6505','650590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65059022','Gorros de fibras sintéticas ou artificiais','Caps of synthetic or artificial fibers','Gorras de fibras sintéticas o artificiales',10,'65','6505','650590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65059029','Gorros de outras matérias têxteis','Beanies of other textile materials','Gorros de las demás materias textiles',10,'65','6505','650590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65059031','Chapéus de algodao','Hats of cotton','Sombreros de algodón',10,'65','6505','650590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65059032','Chapéus de fibras sintéticas ou artificiais','Hats of synthetic or artificial fibers','Sombreros de fibras sintéticas o artificiales',10,'65','6505','650590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65059039','Chapéus de outras matérias têxteis','Hats of other textile materials','Sombreros de las demás materias textiles',10,'65','6505','650590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65059090','Outros artefs de malha/confeccionados com rendas, etc','Other knit fabric artefacts/made with lace, etc.','Otros artefactos de malla/hechos con rendas, etc.',10,'65','6505','650590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65061000','Capacetes e outros artefatos, de proteção','Safety headgear','Cascos de seguridad',11,'65','6506','650610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65069100','Chapéus e outros artefs.de borracha ou de plástico','Other headgear of rubber or plastic','Sombreros y demás tocados de caucho o de plástico',10,'65','6506','650691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65069200','Chapéus e outros artefatos de peleteria natural','Other headgear of furskin','Sombreros y demás tocados de peletería natural',10,'65','6506','650692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65069900','Chapéus e outros artefs.de outros matérias,  exc.de malha','Other headgear of other materials, exc.mesh','Sombreros y demás tocados de ots.materias, exc.de punto',10,'65','6506','650699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('65070000','Tiras p/guarn.interior,  forros,  etc.p/chapéus/outs.artefs','Strips f/interior garrison, linings, etc.f/headgear','Desudadores, forros, etc.para sombreros y demás tocados',10,'65','6507','650700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('66011000','Guarda-sóis de jardim e artefatos semelhantes','Garden or similar umbrellas','Quitasoles toldo y artículos similares',11,'66','6601','660110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('66019110','Guarda-chuvas de haste/cabo telescop.c/tecido seda/etc.','Umbrellas of stem/telescop.shaft with silk fabric','Paraguas c/astil o mango telescóp.c/tejido seda/etc',11,'66','6601','660191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('66019190','Outros guarda-chuvas,  sombrinhas,  de haste/cabo telescop.','Other umbrellas of stem/telescopic shaft','Los demás paraguas, sombrillas, c/astil o mango telescóp.',11,'66','6601','660191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('66019900','Outros guarda-chuvas, sombrinhas e guarda-sóis','Other umbrellas and sun umbrellas','Los demás paraguas, sombrillas y quitasoles',11,'66','6601','660199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('66020000','Bengalas, bengalas-assentos, chicotes e artefatos semelhantes','Walking-sticks, seat-sticks, whips and the like','Bastones, bastones asiento, látigos y artículos similares',11,'66','6602','660200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('66031000','Punhos, cabos e castões para guarda-chuvas, sombrinhas,  etc.','Handles and knobs f/umbrellas, etc.','Puños y pomos p/paraguas, sombrillas, etc.',10,'66','6603','660310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('66032000','Armações montadas p/guarda-chuvas, sombrinhas, guarda-sóis','Umbrella frames','Monturas ensambladas p/paraguas, sombrillas, quitasoles',10,'66','6603','660320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('66039000','Outras partes, guarnições e acess.p/guarda-chuvas, etc.','Other parts, trimmings and accessor.f/umbrella, etc','Las demás partes, guarniciones y acces.p/paraguas, etc',10,'66','6603','660390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('67010000','Peles/outras partes de aves, com suas penas, etc.trabalhados','Skins/oth.parts of birds with their feathers, etc.worked','Pieles/demás partes de aves, c/sus plumas, etc.trabajados',10,'67','6701','670100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('67021000','Flores, folhagem, frutos, artifs.e partes, de plástico','Artific.flowers, foliage, fruit and parts thereof, plastic','Flores, follaje, frutos, artifs.y partes, de plástico',10,'67','6702','670210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('67029000','Flores, folhagem,  frutos, artifs.e partes, de outras matérias','Artific.flowers, foliag.fruit and parts thereof, oth.mat.','Flores, follaje, frutos, artifs.y partes, de ots.materias',10,'67','6702','670290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('67030000','Cabelos, lã e outs.mater.têxteis prepars.p/fabr.perucas','Human hair, wool and oth.textile mat.prep.f/wigs produc.','Cabellos, lana y ots.mater.text.prepars.p/fabr.pelucas',10,'67','6703','670300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('67041100','Perucas completas, de matérias têxteis sintéticas','Complete wigs, of textile synthetic materials','Pelucas q cubran toda la cabeza, de mat.textiles sintét.',10,'67','6704','670411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('67041900','Barbas, sobrancelhas, etc.de matérias têxteis sintéticas','False beards, eyebrows, etc.of textile synth.materials','Barbas, cejas, etc.de materias textiles sintéticas',10,'67','6704','670419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('67042000','Perucas, barbas, sobrancelhas, etc.de cabelo','Wigs, false beards, eyebrows, etc.of hair','Pelucas, barbas, cejas, etc.de cabello',10,'67','6704','670420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('67049000','Perucas,  barbas,  sobrancelhas,  etc.de outras mater.têxteis','Wigs, false beards, eyebrows, etc.of oth.textile materials','Pelucas, barbas, cejas, etc.de ots.mat.textiles',10,'67','6704','670490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68010000','Pedra para calcetar meio-fio e placa p/pavim.de pedra nat.','Setts, curbstones and flagstones, f/pav.of natural stone','Adoquines, encitado y losa p/pavimentos de piedra natur.',10,'68','6801','680100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68021000','Ladrilhos, etc.de pedra natural, lado<7cm','Tiles, etc.of natural stone, side< 7cm','Losetas, etc.de piedra natural, lado< a 7cm',10,'68','6802','680210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68022100','Mármore, travertino, etc.talhada/serrad.superf.plana/lisa','Marble, travertine, etc.slice/sawed planed/flat surface','Mármol, travertino, etc.tallada/aserrad.superf.plana/lisa','15','68','6802','680221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68022200','Outs.pedras calcárias, talhadas/serrad.superf.plana/lisa','Oth.calcareous stone, slice/sawed planed/flat surface','Ots.piedras calizas, talladas/aserrad.superf.plana/lisa','15','68','6802','680222');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68022300','Granito talhado ou serrado, de superfície plana ou lisa','Granite slice or sawed, planed or flat of surface','Granito tallado o aserrado, de superficie plana o lisa','15','68','6802','680223');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68022900','Outs.pedras de cantaria, talhad/serrad.superf.plana/lisa','Oth.worked monumental, slice/sawed, planed/flat surface','Ots.piedras de talla, tallad/aserrad.superf.plana/lisa','15','68','6802','680229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68029100','Mármore,  travertino,  etc.trabalhado de outro modo e obras','Worked marble, travertine, etc.oth.wise proces.and artic.','Mármol, travertino, etc.trabajado de ot.modo y manufact.',10,'68','6802','680291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68029200','Outras pedras calcárias,  trabalhadas de out.modo e obras','Oth.worked calcareous stone, oth.wise proces.and artic.','Otras piedras calizas, trabajadas de ot.modo y manufact.',10,'68','6802','680292');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68029310','Esferas para moinho, de granito','Spheres for mill, of granite','Bolas para molinos, de granito',10,'68','6802','680293');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68029390','Outros granitos trabalhados de outro modo e suas obras','Oth.worked granite, oth.wise proces.and articles','Otros granitos trabajados de otro modo y sus manufact.',10,'68','6802','680293');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68029910','Esferas para moinho,  de outras pedras de cantaria,  etc.','Spheres for mill, of oth.worked monumental, etc.','Bolas para molinos, de ots.piedras de talla, etc.',10,'68','6802','680299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68029990','Outras pedras de cantaria,  etc.trabalhad.out.modo e obra','Oth.worked monumental, etc.oth.wise proces.and articles','Otras piedras de talla, etc.trabajad.ot.modo y manufact.',10,'68','6802','680299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68030000','Ardósia natural trabalhada e obras de ardósia nat/aglom','Worked slate and articles of slate/agglomerated slate','Pizarra natural trabajada y manuf.de pizarra nat/aglom',10,'68','6803','680300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68041000','Mos para moer ou desfibrar','Millstones and grindst.f/milling, grinding or pulping','Muelas para moler o desfibrar',10,'68','6804','680410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68042111','Mos de diamante nat/sint.aglomerados c/resina,  d<53.34cm','Millston.of agglom.synt./nat.diamond with res.d<53.34cm','Muelas de diamante nat/sint.aglomer.c/resina, d<53.34cm',10,'68','6804','680421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68042119','Outros mos de diamante natural/sint.aglomerad.d<53.34cm','Oth.millston.of agglom.synt./nat.diamond d<53.34cm','Ots.muelas de diamante natural/sint.aglomerad.d<53.34cm',10,'68','6804','680421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68042190','Outros mos de diamante natural/sint.aglomerados','Oth.millston.of agglomer.synthetic/natural diamond','Ots.muelas de diamante natural/sintét.aglomerados',10,'68','6804','680421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68042211','Mos de outs.abrasivos aglomerados com resina,  d<53.34cm','Millston.of oth.agglomer.abrasives with resin, d<53.34cm','Muelas de los demás abrasivos aglom.c/resina, d<53.34cm',10,'68','6804','680422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68042219','Outs.mos/semelh.de abrasivos aglomer/cerâmica,  d<53.34cm','Oth.millston./sim.of agglomer.abrasives/ceram.d<53.34cm','Ots.muelas/simil.de abrasivos aglomer/cerám., d<53.34cm',10,'68','6804','680422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68042290','Outros mos de outros abrasivos aglomer/cerâmica','Oth.millstones of oth.agglomer.abrasives/ceramic','Ots.muelas de ots.abrasivos aglomerados/cerámica',10,'68','6804','680422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68042300','Outros mos e artefatos semelhantes','Other millstones and similar articles','Las demás muelas y artículos similares',10,'68','6804','680423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68043000','Pedras p/amolar/polir,  manualmente,  de pedra natural,  etc.','Hand sharpening/polishing stones, of natural stones, etc','Piedras de afilar/pulir, a mano, de piedra natural, etc',10,'68','6804','680430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68051000','Abrasivos nat/artif.em pó/grao,  aplic.em tecido mat.text','Natur/artific.abrasive powder/grain, base of text.mater','Abrasivos nat/art.en polvo/grán.c/sop.de tej.mat.textil',10,'68','6805','680510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68052000','Abrasivos nat/artif.em pó/grao,  aplic.em papel/cartão','Natur/artific.abrasive powder/grain, base paperboard','Abrasivos nat/art.en polvo/grán, c/sop.const.papel/cart.',10,'68','6805','680520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68053010','Abrasivos nat/artif.c/suporte papel/cartão c/mat.têxtil','Natur/artif.abrasive on a base paper/paperb.c/text.mat.','Abrasivos nat/artif.c/soporte papel/cartón c/mat.textil',10,'68','6805','680530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68053020','Discos abrasivos de fibra vulcan.recob.óxido alumin.etc','Abras.discs of vulcan.fibre covered with alum.oxid.etc','Discos de fibra vulcanizada recubier.óxido aluminio, etc',10,'68','6805','680530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68053090','Outros abrasivos nat/artif.em pó/graos aplic.out.mater.','Oth.natur/artif.abrasive powder/grain, base oth.material','Otros abrasivos nat/artif.en pol/grán.c/soporte ot.mat.',10,'68','6805','680530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68061000','Lãs de escórias de alto-fornos,  etc.em massa,  fls.ou rolo','Slag wool of high-oven, etc.in bulk, etc.sheets/rolls','Lanas de escorias, etc.en masa, hojas/enrolladas',10,'68','6806','680610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68062000','Vermiculita e argilas,  expandidas,  espuma de escórias,  etc','Vermiculite and clays, expanded clays, foamed slag, etc','Vermiculita y arcilas, dilatadas, espuma de escorias, etc',10,'68','6806','680620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68069010','Produtos minerais aluminosos ou silicoaluminos','Aluminous or silico-aluminous mineral products','Productos minerales aluminosos o sílicoaluminosos',10,'68','6806','680690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68069090','Outras obras de mater.minerais p/isolam.calor, som,  etc.','Oth.articles of mineral mater.f/isolat.heat/sound, etc.','Otras manuf.de mater.minerales p/aislam.térm/acúst.etc',10,'68','6806','680690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68071000','Obras de asfalto ou de produtos semelhantes, em rolos','Articles of asphalt or of similar material, in rolls','Manufact.de asfalto o de productos similares, en rollos',10,'68','6807','680710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68079000','Outras obras de asfalto ou de produtos semelhantes','Other articles of asphalt or of similar material','Otras manufacturas de asfalto o de productos similares',10,'68','6807','680790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68080000','Paineis e semelh.de fibra veget/palha aglom.cimento,  etc','Panels and simil.of veget.fibre/straw, agglom.cemen.etc','Paneles y similar.de fibra veget/paja aglom.cemento, etc',10,'68','6808','680800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68091100','Chapas,  etc.n/ornamentadas,  de gesso revest.papel/cartão','Boards, etc.n/ornam.of plaster coated paper/paperboard','Placas, etc.s/adornos, de yeso revest.papel/cartón',10,'68','6809','680911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68091900','Outras chapas,  placas,  paineis,  etc.n/ornamentados,  de gess','Other boards, sheets, panels, etc.n/ornam.of plaster','Ots.placas, hojas, paneles, etc.s/adornos, de yeso',10,'68','6809','680919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68099000','Outras obras de gesso ou de composições à base de gesso','Articles of plaster or of compositions based on plaster','Otras manufact.de yeso o de preparacioes a base de yeso',10,'68','6809','680990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68101100','Blocos e tijolos p/construção,  de cimento,  concreto,  etc.','Building blocks and bricks, of cement, concrete, etc','Bloques y ladrillos p/construc.de cemento, hormigón, etc',10,'68','6810','681011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68101900','Outras telhas,  ladrilhos,  semelhs.de cimento,  concreto,  etc','Other roofs, tiles, similar of cement, concrete, etc','Ots.tejas, losetas, simiares de cemento, hormigón, etc',10,'68','6810','681019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68109100','Elementos pre-fabr.p/construção,  de cimento,  concreto,  etc','Prefabric.structural compon.f/building, cement, concr.etc','Elementos prefabr.p/construc.de cemento, hormigón, etc',10,'68','6810','681091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68109900','Outras obras de cimento, concreto ou de pedra artificial','Oth.articles of cement, of concrete/of artificial stone','Otras manuf.de cemento, hormigón o de piedra artificial',10,'68','6810','681099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68111000','Chapas onduladas de fibrocimento,  cimento-celulose,  etc.','Corrugated sheets, of cellulose fibre-cement, etc','Placas onduladas de amiantocemento, celulosacemento, etc',10,'68','6811','681110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68112000','Outras chapas e semelh.de fibrocimento, cimento-celulose','Other sheets and similar, of cellulose fibre-cement','Ots.placas y similar.de amiantocemento, celulosacemento',10,'68','6811','681120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68113000','Tubo, conduto e acess.de fibrocimento, cimento-celulose','Tubes, pipes and tube or pipe fit.of cellul.fibre-cement','Tubos, fundas y acces.de amiantocemento, celulosacemento',10,'68','6811','681130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68114000','Obras fibrocim., cim-celul.sem.cont.amianto','Articles of cellulose fibre-cement or similar containing asbestos','Obras em amiantocemento, celulosacemento o similares, que contengan amianto (asbesto) ',10,'68','6811','681140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68118100','Chapas ondulads.fibrocim., cim-celul.sem.','Corrugated sheets, of cellulose fibre-cement, and similar','Placas onduladas de amiantocemento, celulosacemento y similar',10,'68','6811','681181');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68118200','Outs.chapas/sem.fibrocimento, cimento-celul.','Other sheets and similar, of cellulose fibre-cement','Ots.placas y similar.de amiantocemento, celulosacemento',10,'68','6811','681182');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68118300','Tubos, condutos, acess.fibrocim.cim-cel;sem.','Tubes, pipes and tube or pipe fit.of cellul.fibre-cement','Tubos, fundas y acces.de amiantocemento, celulosacemento',10,'68','6811','681183');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68118900','Outs.obras fibrocimen.cimen-cel.prod.sem.','Other articles of cellulose fibre-cement and similar','Ots.manufact.de amiantocemento, celulosacemento y simil.',10,'68','6811','681189');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68119000','Outras obras de fibrocimento,  cimento-celulose e semelh.','Other articles of cellulose fibre-cement and similar','Ots.manufact.de amiantocemento, celulosacemento y simil.',10,'68','6811','681190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68121010','Amianto (arbesto) em fibras,  trabalhado','Fabricated asbestos fibres','Amianto (asbesto) en fibras, trabajado',10,'68','6812','681210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68121020','Misturas de amianto ou amianto e carbonato de magnésio','Mixtures with a basis of asbestos and magnes.carbonate','Mezclas de amianto o amianto y carbonato de magnesio',10,'68','6812','681210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68122000','Fios de amianto ou das misturas','Yarn of asbestos or mixtures','Hilados de amianto o de las mezclas',10,'68','6812','681220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68123000','Cordas e cordoes,  de amianto ou das misturas','Cord and strings, of asbestos or mixtures','Cuerdas y cordones, de amianto o de las mezclas',10,'68','6812','681230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68124000','Tecidos e tecidos de malha,  de amianto ou das misturas','Fabris and mesh fabrics, of asbestos or mixtures','Tejidos y tejidos de punto, de amianto o de las mezclas',10,'68','6812','681240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68125000','Vestuário e acess.calçados,  etc.de amianto/das misturas','Clothing and access.footwear, etc.of asbestos/mixtures','Prendas y compl.de vest.calzad., etc.de amian/de mezclas',10,'68','6812','681250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68126000','Papéis, cartões e feltros, de amianto ou das misturas','Paper, millboard and felt, of asbestos or mixtures','Papeles, cartones y fieltros, de amianto o de las mezclas',10,'68','6812','681260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68127000','Folhas de amianto e elastomeros,  comprimidos,  para juntas','Compressed asbestos sheets and elastom.f/gaskets','Hojas de amianto y elastómeros, comprimidos, para juntas',10,'68','6812','681270');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68128000','Obras de/crocidolita (amianto)ou em fibras','Articles of crocidolite (asbestos) or in fibres','Manufacturas de crocidolita (amianto) o en fibras',10,'68','6812','681280');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68129010','Juntas e outros elementos, de amianto, com função de vedação','Gaskets and oth.elem.of asbestos, with function to ban','Juntas y demás elementos, de amianto, c/func.de estanq.',10,'68','6812','681290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68129020','Amianto trabalhado, em fibras','Fabricated asbestos fibres','Amianto trabajado, en fibras',10,'68','6812','681290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68129030','Misturas à base de amianto ou de amianto','Mixtures with basis of asbestos or with basis of asbestos and magnesium carbonate','Mezclas a base de amianto o de amianto y carb.de magn.',10,'68','6812','681290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68129090','Outras obras de amianto ou das misturas','Other articles of asbestos or mixtures','Otras manufacturas de amianto o de las mezclas',10,'68','6812','681290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68129100','Vest,  acess.calçados,  etc.de amianto/das mist.','Clothing and access.footwear, etc.of asbestos/mixtures','Prendas y compl.de vest.calzad., etc.de amian/de mezclas',10,'68','6812','681291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68129200','Papéis, cartões, feltros, de amianto/das mist.','Paper, millboard and felt, of asbestos or mixtures','Papeles, cartones y fieltros, de amianto o de las mezclas',10,'68','6812','681292');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68129300','Folhas d/amianto/elastôm.p/junts.mesmo apresentadas em rolos','Compressed asbestos sheets and elastom.f/gaskets, in rolls included','Hojas de amianto y elastómeros, comprimidos, para juntas, incluso presentado em rodillos',10,'68','6812','681293');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68129910','Outs.juntas e elem.função semel.d/vedação','Other gaskets and elements of asbestos and similar, with function to ban','Otras juntas y elementos de amianto y similares, c/func.de estanq.',10,'68','6812','681299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68129920','Amianto trabalhado, em fibras','Fabricated asbestos fibres','Amianto trabajado, en fibras',10,'68','6812','681299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68129930','Mist.à bas.d/amianto/amianto c/carb.magnésio','Mixtures with basis of asbestos/with basis of asbestos and magnesium carbonate','Mezclas a base de amianto o de amianto y carb.de magn.',10,'68','6812','681299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68129990','Outs.obr.d/amian.trab.fib.mist.am.c/carb.mag.','Other articles of fabricated asbestos fibres or mixtures with basis of asbestos and magnesium carbonate','Otras manufacturas de amianto trabajado, en fibras o de las mezclas a base de amianto y carbonato de magnesio',10,'68','6812','681299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68131010','Pastilhas não montadas, para freios, de amianto,  etc.','Pads not mounted, for brakes, of asbestos, etc.','Pastillas sin montar, para frenos, de amianto, etc.',10,'68','6813','681310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68131090','Outras guarnições não montadas, para freios, de amianto,  etc.','Other linings not mounted, for brakes, of asbestos, etc.','Otras guarniciones sin montar, p/frenos, de amianto, etc.',10,'68','6813','681310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68132000','Guarniçao de fricção contendo amianto','Friction lining, containing asbestos ','Guarniciones de fricción, que contengan amianto ',10,'68','6813','681320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68138110','Pastilhas p/freios (travões)cont.amianto','Brake pads, containing asbestos ','Pastillas de freno, que contengan amianto',10,'68','6813','681381');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68138190','Outs.guarniç.p/freios (travões)cont.amianto','Other linings for brakes, containing asbestos ','Otras guarniciones p/frenos, que contengan amianto ',10,'68','6813','681381');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68138910','Disco de fricção para embreagens, de amianto','Friction discs, for clutches, of asbestos','Discos de fricción, para embragues, de amianto',10,'68','6813','681389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68138990','Outs.guarnições.ñ mont.p/emb.etc.d/amianto','Other linings not mounted, f/clutches, etc.of asbestos','Ots.guarniciones, s/montar, p/embragues, etc, de amianto',10,'68','6813','681389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68139010','Discos de fricção, n/montad.p/embreagens, de amianto,  etc.','Friction discs, n/mounted, f/clutches, of asbestos, etc.','Discos de fricción, s/montar, p/embragues, de amianto, etc',10,'68','6813','681390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68139090','Outs.guarnições n/montadas, para embreagens, etc.de amianto,  ','Other linings not mounted, f/clutches, etc.of asbestos','Ots.guarniciones, s/montar, p/embragues, etc, de amianto',10,'68','6813','681390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68141000','Placas/folhas ou tiras, de mica aglomerada/reconstituida','Plates/sheets or strips of agglomer./reconstituted mica','Placas/hojas o tiras, de mica aglomerada/reconstituida',10,'68','6814','681410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68149000','Outras obras de mica ou mica trabalhada','Other worked mica and articles of mica','Otras manufacturas de mica ou mica trabajada',10,'68','6814','681490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68151010','Fibras de carbono, para uso não elétrico','Carbon fibres, for non-electrical uses','Fibras de carbono, para uso distinto del eléctrico',10,'68','6815','681510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68151020','Tecidos de fibras de carbono, para uso não elétrico','Fabric of carbon fibres, for non-electrical uses','Tejidos de fibras de carb., para uso dist.del eléctrico',10,'68','6815','681510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68151090','Outras obras de grafita/outras carbonos,  p/uso nao eletr','Oth.articles of graph./oth.cabon, f/non-electrical uses','Otras manuf.de grafito/otros carbonos, p/uso dist.eléctr',10,'68','6815','681510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68152000','Obras de turfa','Articles of peat','Manufacturas de turba',10,'68','6815','681520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68159110','Obras cont.magnesita, etc.crus, aglomer.c/aglutin.quim.','Articles c/magnesite, etc.raw, agglom.with chemic.agglut','Manuf.q cont.magnesita, etc.crudos, aglomer.c/aglut.quím.',10,'68','6815','681591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68159190','Outras obras contendo magnesita, dolomita ou cromita','Other articles c/magnesite, dolomite or chromite','Otras manufact.q contengan magnesita, dolomita o cromita',10,'68','6815','681591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68159910','Obras de pedras/outras matérias minerais,  eletrofundidas','Articles of stone/of oth.mineral substan.electro-melted','Manuf.de piedras/ots.materias minerales, electrofundidas',10,'68','6815','681599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68159911','Obras de pedras eletrofundidas, com teor de alumina>=90%','Electro-melted articles of stone, content alumina>=90%','Manuf.de piedras electrofundidas, c/cont.de alúmina>=90%',10,'68','6815','681599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68159912','Obras de pedras eletrofundidas, com teor de silica>=90%','Electro-melted articles of stone, content silica>=90%','Manuf.de piedras electrofundidas, c/cont.de sílice>=90%',10,'68','6815','681599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68159913','Obras de pedras eletrofund.teor óxido zircônio>=50%,  etc','Electro-mel.articl.of stone, c/zirconium oxide>=50%, etc','Manuf.de piedras electrofundidas, c/cont.de óx.circ>=90%',10,'68','6815','681599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68159914','Obras de pedras eletrofund.alumina+silica+oxid.zircônio','Electro-mel.articl.of stone, alumina+silica+zirc.ox','Manuf.de piedras electrofundidas, alúmina+sílice+óx.circ',10,'68','6815','681599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68159919','Outs.obras de pedras/matérias minerais, eletrofundidas','Oth.articles of stone/mineral substances, electro-melted','Ots.manuf.de piedras/materias minerales, electrofundidas',10,'68','6815','681599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('68159990','Outras obras de pedras ou de outras matérias minerais','Other articles of stone or of other mineral substances','Otras manufact.de piedras o de otras materias minerales',10,'68','6815','681599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69010000','Tijolos/outs.pecas ceram.de farinhas silíciosas fosseis','Brincks/oth.pieces ceramic of fossil siliceous meals','Ladrillos/ots.piezas cerám.de harinas silíceas fósiles',10,'69','6901','690100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69021011','Tijolos ou placas refrat.peso>90% de trióxido dicromo','Refractory bricks.weight>90% dichrome trioxide','Ladrillos o placas refract.peso>90% de trióxido dicromo',10,'69','6902','690210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69021018','Outros tijolos refrat.magnésianos ou de óxido de cromo','Oth.refractory bricks of magnesite or chrome oxide','Ots.ladrillos refract.magnesianos o de óxido de cromo',10,'69','6902','690210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69021019','Outras peças ceram.refrat.magnésianos ou de óxido cromo','Oth.pieces refractory ceramic of magnesite/chrome oxide','Otras piezas cerám.refract.magnesianos o de óxido cromo',10,'69','6902','690210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69021090','Outras peças ceram.refrat.com magnésio/cálcio/cromo>50%','Oth.pieces ceramic with magnesium/calcium/chrome>50%','Otras piezas cerám.refract.c/magnesio/calcio/cromo>50%',10,'69','6902','690210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69022010','Tijolos refratrários, silico-aluminosos','Refractory bricks, silico-aluminous','Ladrillos refractarios, sílicoaluminosos',10,'69','6902','690220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69022091','Outras peças ceram.refratar.silico-aluminosos','Other pieces refractory ceramic, silico-aluminous','Otras piezas cerám.refractar.sílicoaluminosos',10,'69','6902','690220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69022092','Outras peças ceram.refrat.silicosa/semi-silicosa/silica','Oth.pieces refract.ceramic, selic./semi-siliceous/silica','Otras piezas cerám.refract.silíceo/semisilíceo/sílice',10,'69','6902','690220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69022093','Outras peças ceram.refrat.silimanita/carboneto silício','Oth.pieces refract.ceram.sillimanite/silicon carbide','Otras piezas cerám.refract.silimanita/carburo silicio',10,'69','6902','690220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69022099','Outras peças ceram.refratar.com alumina e/ou silica>50%','Oth.pieces refract.ceram.with alumina/silica>50%','Otras piezas cerám.refract.con alúmina y/o sílice>50%',10,'69','6902','690220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69029010','Tijolos e outras peças ceram.refratar.de grafita','Refractory bricks and similar refract.ceramic of graph.','Ladrillos y otras piezas cerám.refractar.de grafito',10,'69','6902','690290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69029020','Tijolos e outras peças ceram.refrat.n/fundidos,  zro2>25%','Refractory bricks and sim.refrac.ceram.n/fused, zro2>25%','Ladrillos y ots.piezas cerám.refract.s/fundir, zro2>25%',10,'69','6902','690290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69029030','Pecas ceram.refrat.c>85%,  diam<=5microns,  util.alto-forno','Refract.ceram.pieces c>85%diam<=5microns, used high-oven','Piezas cerám.refract.c>85%, d<=5microns, util.alto horno',10,'69','6902','690290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69029040','Outs.tijolos, placas /sem.d/carboneto silício','Other refractory bricks, blocks and similar, of silicon carbide ','Otros ladrillos, placas y similares, de carburo silicio',10,'69','6902','690290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69029090','Outros tijolos e pecas cerâmicas p/construção,  refratar.','Oth.refractory bricks and sim.refr.ceram. f/construct.','Ots.ladrillos y piezas cerámicas de construc., refract.',10,'69','6902','690290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69031011','Cadinhos refratrários, de grafita','Refractory crucibles, of graphite','Crisoles refractarios, de grafito',10,'69','6903','690310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69031012','Cadinhos refratrários,  de grafita c/carboneto de silício','Refractory crucibles, of graphite c/silicon carbide','Crisoles refractarios, de grafito c/carburo de silicio',10,'69','6903','690310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69031019','Outros cadinhos refratrários,  de grafita/out.carbono>50%','Oth.refractory crucibles, of graphite/oth.carbon>50%','Ots.crisoles refractarios, de grafito/ot.carburo>50%',10,'69','6903','690310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69031020','Retortas refratárias,  de grafita c/carboneto de silício','Refractory retorts, of graphite c/silicon carbide','Retortas refractarias, de grafito c/carburo de silicio',10,'69','6903','690310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69031030','Tampas/tampões,  refratar.de grafita ou outro carbono>50%','Refractory lids, of graphite or other carbon>50%','Tapas/tapones, refractar.de grafito u otro carbono>50%',10,'69','6903','690310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69031040','Tubo refratrário,  de grafita/outro carbono ou mistura>50%','Refractory tube, of graphite/oth.carbon or mixtures>50%','Tubo refractario, de grafito/otro carbono o mezcla>50%',10,'69','6903','690310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69031090','Outros prods.ceram.refrat.de grafita ou out.carbono>50%','Oth.refractory ceramic goods, of graphite/oth.carbon>50%','Otros prods.cerám.refract.de grafito u ot.carbono>50%',10,'69','6903','690310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69032010','Cadinhos refratrários, de alumina ou alumina c/silica>50%','Refractory crucibles, of alumina or alumina c/silica>50%','Crisoles refractarios, de alúmina o alúmina c/sílice>50%',10,'69','6903','690320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69032020','Tampas/tampões,  refratar.de alumina/alumina c/silica>50%','Refractory lids, of alumina or alumina c/silica>50%','Tapas/tapones, refractar.de alúmina/alúmina c/sílice>50%',10,'69','6903','690320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69032030','Tubo refratrário,  de alumina ou alumina com silica>50%','Refractory tube, of alumina or alumina c/silica>50%','Tubo refractario, de alúmina o alúmina con sílice>50%',10,'69','6903','690320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69032090','Outs.prods.ceram.refrat.de alumina/alumina c/silica>50%','Oth.refrac.ceram.goods, of alumina/alumina c/silica>50%','Ots.prods.cerám.refract.de alúmina/alúmina c/sílice>50%',10,'69','6903','690320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69039011','Tubo refratrário, de carboneto de silício','Refractory tube, silicon carbide','Tubo refractario, de carburo de silicio',10,'69','6903','690390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69039012','Tubo refratrário, de compostos de zircônio','Refractory tube, zirconium compounds','Tubo refractario, de compuestos de circonio',10,'69','6903','690390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69039019','Outros tubos cerâmicos refratrários','Other refractory ceramic tube','Otros tubos cerámicos refractarios',10,'69','6903','690390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69039091','Outros produtos ceram.refrat.de carboneto de silício','Other refractory ceramic goods of silicon carbide','Otros productos cerám.refract.de carburo de silicio',10,'69','6903','690390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69039092','Outros produtos ceram.refrat.de compostos de zircônio','Oth.refractory ceramic goods, zirconium compounds','Otros productos cerám.refract.de compuestos de circonio',10,'69','6903','690390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69039099','Outros produtos cerâmicos refratrários','Other refractory ceramic goods','Otros productos cerámicos refractarios',10,'69','6903','690390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69041000','Tijolos de cerâmica','Ceramic bricks','Ladrillos de construcción','12','69','6904','690410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69049000','Tijoleiras e outros prods.p/construção, de cerâmica','Ceramic building bricks, flooring blocks and like','Bovedillas y otros prods.de construcción, de cerámica',10,'69','6904','690490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69051000','Telhas de cerâmica','Roofing tiles','Tejas de cerámica',10,'69','6905','690510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69059000','Outros produtos cerâmicos para construção','Other ceramic building goods','Otros productos cerámicos para construcción',10,'69','6905','690590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69060000','Tubos,  calhas/algerozes e acess.p/canaliz.de cerâmica','Ceramic pipes, conduits, guttering/pipe fittings','Tubos, canalones y acces.de tubería de cerámica',10,'69','6906','690600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69071000','Ladrilhos,  etc.de cerâmica,  n/vidrados,  n/esmalt.lado<7cm','Tiles, etc.of ceramic, unglazed, n/enameled, side<7cm','Placas, etc.de cerámica, s/barnizar n/esmaltar, lado<7cm','15','69','6907','690710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69079000','Outros ladrilhos,  etc.de cerâmica,  n/vidrados,  n/esmaltad.','Other tiles, etc.of ceramic, unglazed, n/enameled','Otras placas, etc.de cerámica, s/barnizar n/esmaltar','15','69','6907','690790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69081000','Ladrilhos,  etc.de cerâmica,  vidrados,  esmaltados,  lado<7cm','Tiles, etc.of ceramic, glazed, enameled, side<7cm','Placas, etc.de cerámica, barnizados, esmaltados, lado<7cm','15','69','6908','690810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69089000','Outros ladrilhos,  etc.de cerâmica,  vidrados,  esmaltados','Other tiles, etc.of ceramic, glazed, enameled','Otras placas, etc.de cerámica, barnizados, esmaltados','15','69','6908','690890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69091100','Aparelhos e artefatos de porcelana,  p/uso quim/técnico','Porcelain wares and articles, f/chemical/technical uses','Aparatos y artículos de porcelana, p/uso quím/técnico',10,'69','6909','690911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69091210','Guia-fios p/maqs.text.dureza>=9mohs,  de outs.cerâmicas','Thread guides f/tex.mach.hardness>=9mohs, oth.ceramics','Guiahilos p/maquin.text.dureza>=9mohs, de ots.cerámicas',10,'69','6909','690912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69091220','Guias de agulhas,  p/cabeças impr.d>=9mohs,  de outs.ceram.','Pin guides, f/printing heads.h>=9mohs, oth.ceramics','Guías de agujas, p/cabezales impr.d>=9mohs, de ots.cerám.',10,'69','6909','690912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69091230','Aneis de carboneto de silício p/ junta de vedação mecan','Rings of silicon carbide for mechanical seals ','Anillos de carburo silicio, para juntas mecánicas de estanqueidad',10,'69','6909','690912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69091290','Outs.artefatos de cerâmica,  exc.porcelana,  dureza>=9mohs','Oth.ceramic articles, exc.porcelain, hardness>=9mohs','Ots.artículos de cerámica, exc.porcelana, dureza>=9mohs',10,'69','6909','690912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69091910','Outros guia-fios p/maqs.text.de cerâmica exc.porcelana','Oth.thread guides f/tex.mach.of ceramic, exc.porcelain','Otros guiahilos p/maq.text.de cerámica exc.porcelana',10,'69','6909','690919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69091920','Outs.guias de agulhas p/cabeças impressão,  de outs.ceram','Other pin guides, f/printing heads, of oth.ceramics','Ots.guías de agujas p/cabezales impresión, de ots.cerám',10,'69','6909','690919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69091930','Colmeia de ceram.de alumina, silica e óxido magnésio, etc','Ceram.beehive, of alumina, silica and magnesio oxide, etc','Colmena de cerám.de alúmina, sílice y óxido magnesio, etc',10,'69','6909','690919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69091990','Outros aparelhos e artefatos de cerâmica, para uso quimíco/técnico','Ot.ceramic wares and articles, f/chemical/technical uses','Otros aparatos y artíc.de cerámica, p/uso quím/técnico',10,'69','6909','690919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69099000','Alguidares e outros recip.de cerâmica p/uso rural,  etc.','Ceramic troughs and oth.recep.used in agriculture, etc','Abrevaderos y otros recip.de cerámica p/uso rural, etc',10,'69','6909','690990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69101000','Pias, lavatórios, etc.,para sanitarários, de porcelana','Sinks, wash basins, etc.f/sanitary, of porcelain','Fregaderos, lavabos, etc.p/uso sanitario, de porcelana',11,'69','6910','691010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69109000','Pias,  lavatórios,  etc.p/sanitar.de cerâmica,  exc.porcelana','Ceramic sinks, wash basins, etc.f/sanitary, exc.porcelain','Fregaderos, lavabos, etc.p/sanit., de cerámica, exc.porcel.',11,'69','6910','691090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69111010','Conjunto p/jantar/cafe/cha,  de porcelana,  embalagem comum','Assembl.f/table/coffe/tea, of porcelain, common container','Juego p/mesa/café/té, de porcelana, present.envase común',10,'69','6911','691110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69111090','Outros artigos p/serviços de mesa/cozinha, de porcelana','Oth.articles f/tableware/kitchenware serv.of porcelain','Otros artículos p/servicio de mesa/cocina, de porcelana',10,'69','6911','691110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69119000','Outs.artigos de uso doméstico, higiene, etc.de porcelana','Oth.household articles, toilet, etc.of porcelain','Ots.artículos de uso doméstico, higiene, etc.de porcelana',10,'69','6911','691190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69120000','Loucas/outs.artigos,  uso doméstico,  etc.de outs.cerâmicas','Ceramic tableware/oth.household articles, etc.','Vajillas/ots.artículos, uso domést., etc.de ots.cerámicas',10,'69','6912','691200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69131000','Estatuetas/outros objetos ornament.de porcelana','Statuettes and other ornamental porcelain article','Estatuillas/demás artículos para adorno, de porcelana',10,'69','6913','691310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69139000','Estatuetas/outs.objetos ornament.de ceram.exc.porcelana','Statuettes/oth.ornamental ceramic article, exc.porcelain','Estatuillas/demás artículos p/adorno, de cerám.exc.porc.',10,'69','6913','691390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69141000','Outras obras de porcelana','Other porcelain articles','Las demás manufacturas de porcelana',10,'69','6914','691410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('69149000','Outras obras de cerâmica,  exceto porcelana','Other ceramic articles, exc.porcelain','Las demás manufacturas de cerámica, excepto porcelana',10,'69','6914','691490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70010000','Cacos/outros resids.de vidro e vidro em blocos/massas','Cullet/oth.waste and scrap of glass/glass in the mass','Desperdicios y desechos de vidrio y vidrio en masas',10,'70','7001','700100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70021000','Esferas de vidro, não trabalhado','Glass in balls, unworked','Bolas de vidrio, sin trabajar',10,'70','7002','700210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70022000','Barras ou varetas, de vidro, não trabalhado','Rods, of glass, unworked','Barras o varillas, de vidrio, sin trabajar',10,'70','7002','700220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70023100','Tubos de vidro,  de quartzo/out.silica,  fundidos,  n/trabalh','Glass tubes, of fused quartz/oth.fused silica, unworked','Tubos de vidrio, de cuarzo/ot.sílice, fundidos, s/trab.',10,'70','7002','700231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70023200','Tubos de outs.vidros,  dilat.lin<=0.000005/kelv.n/trabalh','Glass of oth.tubes, linear expan<=0.000005/kelv.unworked','Tubos de ots.vidrios, dilat.lin<=0.000005/kelv.s/trabaj.',10,'70','7002','700232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70023900','Tubos de outros vidros, não trabalhados','Tubes of other glass, unworked','Tubos de otros vidrios, sin trabajar',10,'70','7002','700239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70031200','Chapas/fls.n/armadas,  de vidro vazado/lamin.coradas,  etc.','N/wired sheets, etc.of cast glass/colour.throug.roll.etc','Placas/hjs.s/armar, de vidrio colado/lam.coloreadas, etc',15,'70','7003','700312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70031900','Outs.chapas e folhas,  não armadass,  de vidro vazado/lamin.','Oth.n/wired sheets, of cast glass/rolled glass','Ots.placas y hojas, sin armar, de vidrio colado/lamin.',15,'70','7003','700319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70032000','Chapas/fls.armadas, de vidro vazado/lamin.','Wired sheets, of cast glass/rolled glass','Placas/hjs.armadas, de vidrio colado/laminado',15,'70','7003','700320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70033000','Perfis de vidro vazado ou laminado','Profiles, of cast glass/rolled glass','Perfiles de vidrio colado o laminado',15,'70','7003','700330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70042000','Folhas de vidro estirado/soprado, corado na massa, etc.','Drawn glas.in sheets/blown glass, colour.throug.mass, etc','Hojas de vidrio estirado/soplado, coloreado en masa, etc',15,'70','7004','700420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70049000','Outras folhas de vidro estirado ou soprado','Other drawn glass sheets or blown glass','Otras hojas de vidrio estirado o soplado',15,'70','7004','700490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70051000','Chapas/fls.de vidro flotado, etc.n/armadas, camada absorv','Float glass, in sheets, etc.non-wired, hav.absorbent','Placas/hjs.de vidro flotado, etc.s/armar, capa absorb.',15,'70','7005','700510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70052100','Chapas/fls.de vidro flotado, etc.n/armadas, corado,  etc.','Float glass, in sheets, etc.non-wire, coloured, etc.','Placas/hjs.de vidrio flotado, etc.s/armar, coloreado, etc',15,'70','7005','700521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70052900','Outs.chapas/fls.de vidro flotado,  desbastado,  etc.n/armad','Oth.float glass, in sheets, etc.surfac.ground, etc.n/wire','Ots.placas/hjs.de vidrio flotado, desbastado, etc.s/armar',15,'70','7005','700529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70053000','Chapas/fls.de vidro flotado e desbastado/polido, armadas','Float glass, in sheets, etc.surface ground, polished/wire','Placas/hjs.de vidrio flotado y desbast./pulido, armadas',15,'70','7005','700530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70060000','Vidro vazado, estirado, flotado ou desbastado, trabalhado','Cast glass/drawn, float or surface ground, worked','Vidrio vazado, estirado, flotado o desbastado, trabajado',10,'70','7006','700600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70071100','Vidros de segurança, temperados, para automóveis/outs.veics.','Safety glass, tempered, f/automobiles/oth.vehicles','Vidrios de seguridad, templados, p/automóviles/ots.vehícs',11,'70','7007','700711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70071900','Outros vidros de segurança, temperados','Other safety glass, tempered','Ots.vidrios de seguridad, templados',15,'70','7007','700719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70072100','Vidros de segurança,  de fls.contracoladas,  p/automovs.etc','Laminated safety glass, f/automobiles, etc','Vidrios de seguridad, de hjs.encoladas, p/automóviles, etc',11,'70','7007','700721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70072900','Outros vidros de segurança, de folhas contracoladas','Other laminated safety glass','Ots.vidrios de seguridad, de hjs.encoladas',15,'70','7007','700729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70080000','Vidros isolantes de paredes múltiplas','Multiple-walled insulating units of glass','Vidrieras aislantes de paredes múltiples',10,'70','7008','700800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70091000','Espelhos retrovisores para veículos','Rear-view mirrors for vehicles','Espejos retrovisores para vehículos',10,'70','7009','700910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70099100','Espelhos de vidro, não emoldurados','Glass mirrors, unframed','Espejos de vidrio, sin enmarcar',10,'70','7009','700991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70099200','Espelhos de vidro, emoldurados','Glass mirrors, framed','Espejos de vidrio, enmarcados',10,'70','7009','700992');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70101000','Ampolas de vidro, para transporte ou embalagem','Glass ampoules, for the conveyance or packing','Ampollas de vidrio, para el transporte o envasado',10,'70','7010','701010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70102000','Rolhas, tampas e dispositivos semelhantes, de vidro','Stoppers, lids and dispositives similar, of glass','Tapones, tapas y dispositivos de cierre de vidrio',10,'70','7010','701020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70109011','Garrafões e garrafas, de vidro, cap > 1L','Carboys, bottles, of glass, cap > 1L','Bombonas y botellas, de vidrio, cap>1L',10,'70','7010','701090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70109012','Frascos, boiões, vasos, etc.de vidro, cap > 1L','Flasks, jars, pots, etc.of glass, cap>1L','Frascos, bocales, tarros, etc.de vidrio, cap>1L',10,'70','7010','701090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70109021','Garrafoes e garrafas, de vidro, 0.33l<cap<=1L','Carboys and bottles, of glass, 0.33l<cap<=1L','Bombonas y botellas, de vidrio, 0.33l<cap<=1L',10,'70','7010','701090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70109022','Frascos, boiões, vasos, etc.de vidro, 0.33<cap<1L','Flasks, jars, pots, etc.of glass, 0.33<cap<1L','Frascos, bocales, tarros, etc.de vidrio, 0.33<cap<1L',10,'70','7010','701090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70109090','Outs.garrafões, garrafas, frascos, etc.de vidro','Oth.carboys, bottles, flasks, etc.of glass','Ots.bombonas, botellas, frascos, etc.de vidrio',10,'70','7010','701090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70109110','Garrafões e garrafas, de vidro, capacidade > 1 litro','Carboys, bottles, of glass, capacity>1 liter','Bombonas y botellas, de vidrio, capacidad>1 litro',10,'70','7010','701091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70109120','Frascos,  boioes,  vasos,  etc.de vidro,  capacidade>1l','Flasks, jars, pots, etc.of glass, capacity>1 l','Frascos, bocales, tarros, etc.de vidrio, capacidad>1l',10,'70','7010','701091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70109210','Garrafões e garrafas, de vidro, 0.33l<capacidade<=1L','Carboys and bottles, of glass, 0.33l<capacity<=1 l','Bombonas y botellas, de vidrio, 0.33l<capacidad<=1l',10,'70','7010','701092');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70109220','Frascos, boiões, vasos, etc.de vidro, 0.33l<capacidade<=1l','Flasks, jars, pots, etc.of glass, 0.33l<capacity<=1l','Frascos, bocales, tarros, etc.de vidrio, 0.33l<capacid.<=1L',10,'70','7010','701092');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70109300','Garrafões,  garrafas,  frascos,  etc.de vidro,  0.15l<c<=0.33l','Carboys, bottles, flasks, etc.of glass, 0.15l<c<=0.33l','Bombonas, botellas, frascos, etc.de vidrio, 0.15l<c<=0.33l',10,'70','7010','701093');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70109400','Garrafões, garrafas, frascos, etc.de vidro, capacid<=0.15l','Carboys, bottles, flasks, etc.of glass, capacity<=0.15l','Bombonas, botellas, frascos, etc.de vidrio, capacid.<=0.15l',10,'70','7010','701094');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70111010','Ampolas de vidro,  etc.para lâmpadas ou tubos de descarga','Glass envelopes, etc.for lamps or discharge tubes','Ampollas de vidrio, etc.p/lámparas o tubos de descarga',10,'70','7011','701110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70111021','Bulbos de vidro,  diam<=90mm,  p/lâmpadas de incandescência','Glass bulbs, d<=90mm, f/lamps of incandescence','Bulbos de vidrio, d<=90mm, p/lámparas de incandescencia',10,'70','7011','701110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70111029','Ampolas de vidro,  etc.para lâmpadas de incandescência','Glass envelopes, etc.f/lamps of incandescence','Ampollas de vidrio, etc.para lámparas de incandescencia',10,'70','7011','701110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70111090','Outras ampolas, etc.de vidro, para iluminação elétrica','Other glass envelopes, etc.for electric lighting','Otras ampollas, etc.de vidrio, para alumbrado eléctrico',10,'70','7011','701110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70112000','Ampolas de vidro, etc.para tubos catódicos','Glass envelopes, etc.for cathode-ray tubes','Ampollas de vidrio, etc.para tubos catódicos',10,'70','7011','701120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70119000','Outras ampolas/involucros, abertos, de vidro,  suas partes','Ot.glass env.(inc.bulbs/tubes), open, glass parts thereof','Otras ampollas/envolturas, abiertos, de vidrio, sus partes',10,'70','7011','701190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70120000','Ampolas de vidro, p/garrafas térmicas, etc.isolam.a vácuo','Glass inners f/vacuum flask, etc.vacuum vessels','Ampollas de vidrio, p/botellas térmicas, etc.aisl.p/vacío',11,'70','7012','701200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70131000','Objetos de vitrocerâmica, para serviços de mesa, cozinha,  etc.','Glassware of glass-ceramics, used f/table, kitchen, etc','Artícs.de vitrocerámica, p/servicio de mesa, cocina, etc',10,'70','7013','701310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70132100','Recipientes para beber, de cristal de chumbo','Drinking glasses, of lead crystal','Recipientes para beber, de cristal al plomo',10,'70','7013','701321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70132200','Copos d/cristal d/chumbo, exc.d/vitrocer.c/pé','Drinking glasses, stemware, of lead crystal, excluding of glass ceramics','Vasos con pie de cristal al plomo, exc. de vitrocerámica',10,'70','7013','701322');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70132800','Outs.copos d/crist./chumbo, exc.vitrocer.c/pé','Other drinking glasses, stemware, of lead crystal, excluding of glass ceramics','Otros vasos con pie de cristal al plomo, exc. de vitrocerámica',10,'70','7013','701328');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70132900','Outros recipientes para beber, de vidro','Other drinking glasses, of glass','Los demás recipientes para beber, de vidrio',10,'70','7013','701329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70133100','Objetos de cristal de chumbo,  p/serviços de mesa/cozinha','Glassware of lead crystal, used f/table/kitchen','Artícs.de cristal al plomo, p/servicio de mesa/cocina',10,'70','7013','701331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70133210','Cafeteiras/chaleiras,  de vidro,  dilat.lin<=0.000005kelvin','Coffee-pots/teapots, of glass, linear exp<=0.000005kelvin','Cafeteras/teteras, de vidrio, dilat.lin<=0.000005kelvin',10,'70','7013','701332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70133290','Outs.objs.de vidro,  p/serv.mesa/cozinha,  dilat<=0.000005k','Oth.glassware, used f/table, kitchen, exp<=0.000005k','Ots.arts.de vidrio, p/serv.mesa/cocina, dilat<=0.000005k',10,'70','7013','701332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70133300','Outs.copos d/cristal d/chumbo, exc.d/vitrocerâm.','Other drinking glasses of lead crystal, excluding of glass ceramics','Otros vasos de cristal al plomo, exc. de vitrocerámica',10,'70','7013','701333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70133700','Outs.cops vidro exc.de vitrocerâmica','Other drinking glasses, excluding of glass ceramics','Otros vasos de vidrio, exc. de vitrocerámica',10,'70','7013','701337');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70133900','Outros objetos de vidro,  p/serviços de mesa/cozinha','Oth.glassware of a kind used f/table, kitchen','Los demás artícs.de vidrio, p/servicio de mesa/cocina',10,'70','7013','701339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70134100','Obj.mesa,  coz,  (exc.cops)ex.vitr,  d/crist.chumbo','Glassware of lead crystal, of a kind used for table or kitchen purposes, excluding drinking glasses and glass ceramics ','Artículos para servicio de mesa o de cocina (exc. vasos), de cristal aol plomo, exc. de vitrocerámica',10,'70','7013','701341');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70134210','Cafet.,  chaleiras vid.coef.dil.lin.ñ sup.5x10-6k','Coffee-pots/teapots, of glass, coefficient of expansion <= 5x10-6k','Cafeteras/teteras, de vidrio, con un coeficiente de dilatación <= 5x10-6k',10,'70','7013','701342');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70134290','Out.obj.vidro,  serv.mesa/coz.,  dil.ñ sup.5x10-6k','Other glassware for table or kitchen purposes, coefficient of expansion <= 5x10-6k','Otros artículos de vidrio, para servicio de mesa o de cocina, con un coeficiente de dilatación <= 5x10-6k ',10,'70','7013','701342');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70134900','Outs.obj.serv.mesa/cozinha, exc.cit.anterior','Other glassware for table or kitchen purposes, excluding before mentioned','Otros artículos de vidrio, para servicio de mesa o de cocina, exc. los mencionados anteriormente',10,'70','7013','701349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70139110','Objetos de cristal de chumbo,  p/ornament.de interiores','Articules of lead crystal, f/interior decoration','Artículos de cristal al plomo, para adorno de interiores',10,'70','7013','701391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70139190','Outros objs.de cristal de chumbo, para toucador/escritório','Oth.articules of lead crystal, f/toilet/office','Los demás artícs.de cristal al plomo, p/tocador/oficina',10,'70','7013','701391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70139900','Outros objetos de vidro, para toucador, escritório,  etc.','Other glassware, f/toilet/office, etc.','Los demás artículos de vidrio, p/tocador, oficina, etc',10,'70','7013','701399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70140000','Artefatos de vidro para sinalização, etc.','Signalling glassware, etc','Artículos de vidrio para señalización, etc',10,'70','7014','701400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70151010','Vidro p/lentes corretivas,  fotocromat.n/trabalh.ópticam.','Glasses f/corrective spectacles, photochr.n/optic.worked','Cristal corrector p/gafas, fotocromát.s/trabaj.ópticam.',10,'70','7015','701510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70151091','Vidro p/lentes corretivas,  branco,  n/trabalh.ópticamente','Glasses f/corrective spectacles, white, n/optic.worked','Cristal corrector p/gafas, blanco, s/trabaj.ópticam.',10,'70','7015','701510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70151092','Vidro p/lentes corretivas,  colorido,  n/trabalh.ópticam.','Glasses f/corrective spectacles, coloured, n/optic.worked','Cristal corrector p/gafas, coloreado, s/trabaj.ópticam.',10,'70','7015','701510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70159010','Vidro para relógios','Clock glasses','Cristal para relojes',10,'70','7015','701590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70159020','Vidro para máscaras,  óculos ou anteparos,  protetores','Glasses for safety masks or goggles','Cristal para caretas, gafas o antipares, protectores',10,'70','7015','701590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70159030','Vidro para os demais óculos','Glass for other glasses','Cristal para las demás gafas',10,'70','7015','701590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70159090','Outs.vidros p/apars.semelh.relógio,  esferas de vidro,  etc','Oth.glass f/sim.glasses f/clock, glass spheres, etc','Ots.crist.p/apars.simil.reloje, esferas de vidrio, etc',10,'70','7015','701590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70161000','Cubos, pastilhas, etc.de vidro, para mosaicos e decorações','Glass cubes, etc., f/mosaics and decorative purposes','Cubos, dados, etc.de vidrio, p/mosaicos e decoraciones',10,'70','7016','701610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70169000','Blocos,  etc.de vidro prensado/moldado,  p/construção,  etc.','Paving blocks, etc.of pressed/mould.glass, f/building, etc','Bloques, etc.de vidrio prensado/moldeado, p/constr., etc',10,'70','7016','701690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70171000','Artefatos de quartzo/outras silicas fund.p/laborat.etc.','Articles of fused quartz/oth.fus.silica, f/laborat.etc','Artículos de cuarzo/demás sílices fund.p/laborat.etc',10,'70','7017','701710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70172000','Artefatos de outs.vidros,  dilat<=0.000005k,  p/laborat.etc','Articles of other glass, expan<=0.000005k, f/laborat.etc','Artículos de ots.vidrios, dilat<=0.000005k, p/laborat.etc',10,'70','7017','701720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70179000','Outros artefs.de vidro,  p/laboratorio,  higiene e farmacia','Other laboratory, hygienic, pharmaceutical glassware','Ots.artícs.de vidrio, p/laboratorio, higiene y farmacia',10,'70','7017','701790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70181010','Contas de vidro','Glass beads','Cuentas de vidrio',10,'70','7018','701810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70181020','Imitacoes de perolas,  pedras preciosas/semi,  de vidro','Imitation pearls, semi/precious stone, of glass','Imitaciones de perlas, piedras preciosas/semi, de vidrio',10,'70','7018','701810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70181090','Outros artefs.de vidro semelh.imitacao pédras preciosas','Oth.articles of glass similar, imitation precious stones','Otros artícs.de vidrio sim.imitación piedras preciosas',10,'70','7018','701810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70182000','Microesferas de vidro, de diametro<=1mm','Glass microspheres, in diameter<=1mm','Microesferas de vidrio, de diámetro<=1mm',10,'70','7018','701820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70189000','Outras obras e objetos de ornamentação, de vidro','Other articles of ornamentation, of glass','Otras manufacturas y artículos de adorno, de vidrio',10,'70','7018','701890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70191100','Fios de fibras de vidro,  cortados,  de comprimento<=50mm','Glass fibres yarns, cut, lengths<=50mm','Hilados de fibras de vidrio, cortados, de longitud<=50mm',10,'70','7019','701911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70191200','Mechas ligeiram.torcidas ("rovings") de fibras de vidro','Rovings of glass fibres','Mechas c/ligera torsion ("rovings") de fibras de vidrio',10,'70','7019','701912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70191210','Mechas de vidro, impregn/recob.resina poliuret','Glass wicks, impregnated/coated with polyureth.resin','Mechas de vidrio, impregn/recub.resina poliuret',10,'70','7019','701912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70191290','Outras mechas de vidro, ligeiramente torcidas','Other rovings of glass','Las demás mechas de vidrio, con una ligera torsion',10,'70','7019','701912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70191900','Outras mechas e fios, de fibras de vidro','Other wicks and yarn, of glass fibres','Las demás mechas e hilados, de fibras de vidrio',10,'70','7019','701919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70192000','Ncm nao existe - tecidos e fitas de vidro','Woven and ribbons of glass','Ncm no existe - tejidos y cintas de vidrio',10,'70','7019','701920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70193100','Esteiras "mats" de fibras de vidro, não tecidos','Mats of glass fibres, non-wovens','"mats" de fibras de vidrio, sin tejer',10,'70','7019','701931');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70193200','Veus de fibras de vidro, não tecidos','Thin sheets (voiles) of glass fibres, non-wovens','Velos de fibras de vidrio, sin tejer',10,'70','7019','701932');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70193900','Mantas,  colchoes,  etc.de fibras de vidro, não tecidos','Blankets,  mattresses, etc.of glass fibres,  non-wovens','Napas,  colchones,  etc. de fibras de vidrio,  sin tejer',10,'70','7019','701939');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70194000','Tecidos de mechas ligeiram.torcidas de fibras de vidro','Woven fabrics of rovings,  of glass fibres','Tejidos de roving de fibras de vidrio',10,'70','7019','701940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70195100','Tecidos de fibras de vidro, de largura<=30cm','Woven fabrics of glass fibres, of width<=30cm','Tejidos de fibras de vidrio, de anchura<=30cm',10,'70','7019','701951');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70195200','Tecidos de fibras de vidro,  l>30cm,  pto.tafeta,  p<250g/m2','Fabrics of glass fibres, w>30cm, plain weave, w<250g/m2','Tejidos de fibras de vidrio, a>30cm, lig.tafet., p<250g/m2',10,'70','7019','701952');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70195210','Tecidos de fibras de vidro,  p/fabr.placas circuito eletr','Fabric of glass fibres, f/produc.plates of electric circ','Tejidos de fibras de vidrio, p/fabr.placas circuit.eléct',10,'70','7019','701952');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70195290','Outros tecidos fibras vidro,  l>30cm,  pto.tafeta,  p<250g/m2','Oth.fabric glass fibres, w>30cm, plain weave, w<250g/m2','Ots.tejidos fibras vidrio, a>30cm, lig.tafetán, p<250g/m2',10,'70','7019','701952');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70195900','Outros tecidos de fibras de vidro','Other woven fabric of glass fibres','Los demás tejidos de fibras de vidrio',10,'70','7019','701959');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70199000','Outras fibras de vidro e suas obras','Other glass fibres and articles thereof','Las demás fibras de vidrio y sus manufacturas',10,'70','7019','701990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70199010','Out.fib.c/fios paral.e superp.ang90º 3>=d<=7 fios cm2','Out.fib.c/fios paral.e superp.ang90º 3>=d<=7 fios cm2','Out.fib.c/fios paral.e superp.ang90º 3>=d<=7 fios cm2',10,'70','7019','701990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70199090','Outras fibras de vidro e suas obras','Outras fibras de vidro e suas obras','Outras fibras de vidro e suas obras',10,'70','7019','701990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70200000','Outras obras de vidro','Other articles of glass','Otras manufacturas de vidrio',10,'70','7020','702000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70200010','Ampolas de vidro p/ garr.térmica, outs.recip.isotérm.','Glass inners for vacuum flask, other vaccum vessels ','Ampollas de vidrio, p/botellas térmicas, otros recipientes isotérmicos.',10,'70','7020','702000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('70200090','Outras obras de vidro não especificadas','Other articles of glass not stated','Otros artículos de vidrio no indicados',10,'70','7020','702000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71011000','Pérolas naturais, não montadas, nem engastadas','Natural pearls, not mounted or set','Perlas naturales, sin montar ni engarzar','22','71','7101','710110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71012100','Pérolas cultivadas, em bruto, não montadas, nem engastadas','Pearls, cultured, unworked, n/mounted or set','Perlas cultivadas, en bruto, sin montar ni engarzar','22','71','7101','710121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71012200','Pérolas cultivadas, trabalhadas, n/montadas, n/engastadas','Pearls, cultured, unworked, n/mounted or set','Perlas cultivadas, trabajadas, sin montar ni engarzar','22','71','7101','710122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71021000','Diamantes nao selecionados,  não montados,  nem engastados','Diamonds, unsorted, unworked, n/mounted or set','Diamantes sin clasificar, montar ni engarzar','19','71','7102','710210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71022100','Diamantes industriais,  em bruto ou serrados,  clivados,  etc','Industrial diamonds, simply sawn or bruted, cleaved, etc.','Diamantes industriales, bruto/aserrados, exfoliados, etc','19','71','7102','710221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71022900','Outros diamantes industriais, não montados, nem engastad.','Industrial diamonds, n/mounted or set','Ots.diamantes industriales, sin montar ni engarzar','19','71','7102','710229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71023100','Diamantes n/industriais,  em bruto/serrados/clivados,  etc.','Diamonds, n/industr.simply sawn or bruted, cleaved, etc.','Diamantes n/industriales, bruto/aserrados, exfoliados, etc','19','71','7102','710231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71023900','Outros diamantes nao industriais,  n/montados,  n/engastad.','Other diamonds, n/industrial, n/mounted or set','Ots.diamantes no industriales, sin montar ni engarzar','19','71','7102','710239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71031000','Pedras preciosas/semi,  em bruto,  serradas ou desbastadas','Precious stones/semi, unwork.simply sawn/roughly shaped','Piedras preciosas/semi, en bruto, aserradas o desbastadas',10,'71','7103','710310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71039100','Rubis,  safiras e esmeraldas,  trabalhadas de outro modo','Rubies, sapphires and emeralds, otherwise worked','Rubíes, zafiros y esmeraldas, trabajadas de otro modo','19','71','7103','710391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71039900','Outras pedras preciosas/semi,  trabalhadas de outro modo','Other precious stones/semi, otherwise worked','Las demás piedras preciosas/semi, trabajadas de otr.modo','19','71','7103','710399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71041000','Quartzo piezoelétrico','Piezo-electric quartz','Cuarzo piezoeléctrico',10,'71','7104','710410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71042010','Diamantes sint/reconstit.em bruto/serrados/desbastados','Diam.synt/recons.unwork./simply sawn/roug.shaped','Diamantes sint/reconstit.en bruto/aserrados/desbastados',10,'71','7104','710420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71042090','Outras pedras sint/reconst.em bruto/serrados/desbastad.','Oth.stone synt/recons.unwork./simply sawn/roug.shaped','Otras piedras sintéticas o reconstituidas, en bruto o aserradas o desbastadas ',10,'71','7104','710420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71049000','Outras pedras sint/reconst.mesmo trabalhadas/combinadas','Oth.stone synth/reconstruted wether or n/worked/graded','Otras piedras sintéticas o reconstituidas, mismo trabajadas/combinadas ',10,'71','7104','710490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71051000','Pó de diamantes','Powder of diamonds','Polvo de diamante','19','71','7105','710510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71059000','Pó de pedras preciosas, semipreciosas ou sintéticas','Powder of precious stone, semi-precious/synthetic stones','Polvo de piedras preciosas, semipreciosas o sintéticas',10,'71','7105','710590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71061000','Pó de prata','Powder of silver','Polvo de plata',10,'71','7106','710610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71069100','Prata em formas brutas','Unwrought silver','Plata en formas brutas',10,'71','7106','710691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71069210','Prata em barras, fios e perfis de seção maciça','Silver in bars, wire and profiles of solid cross-section','Plata en barras, alambres y perfiles sección maciza',10,'71','7106','710692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71069220','Prata em chapas, lâminas, folhas e tiras','Silver in plates, sheets and strip','Plata en chapas, láminas, hojas y tiras',10,'71','7106','710692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71069290','Prata em outras formas semimanufaturadas','Silver of otherwise forms semi-manufactured','Plata semilabrada',10,'71','7106','710692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71070000','Metais comuns folheados, etc.de prata, em bruto, semimanufaturado','Base metals clad, etc.of silver, unwrought, semi-manuf.','Chapado de plata sobre metal común, en bruto, semilabrado',10,'71','7107','710700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71081100','Pó de ouro','Powder of gold','Polvo de oro',10,'71','7108','710811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71081200','Ouro em outras formas brutas, para uso não monetário','Gold of other unwrought form, f/n/monetary uses','Oro en las demás formas en bruto, para uso no monetario',10,'71','7108','710812');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71081210','Bulhão dourado, para uso não monetário','Gold bullion, for non monetary uses','Bullón dorado, para uso no monetario',10,'71','7108','710812');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71081290','Ouro em outras formas brutas, para uso não monetário','Gold other unwrought forms, f/n/monetary uses','Oro en las demás formas en bruto, para uso no monetario',10,'71','7108','710812');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71081310','Ouro em barras,  fios,  perfis de sec.macica,  bulhão dourado','Gold, bars, yarn, profiles of solid cross-sec.gold bullion','Oro en barras, alambres, perfiles sec.maciza, bullón dor.',10,'71','7108','710813');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71081311','Ouro em barras,  fios,  etc.de bulhão dourado,  p/uso n/monet','Gold, bars, yarns, etc.of gold bullion, f/n/monetary uses','Oro en barras, alambres, perfs.de bullón dor.p/uso n/mon.',10,'71','7108','710813');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71081319','Outras barras, fios,  etc.de ouro, para uso n/monetário','Other bars, yarns, etc.of gold, f/n/monetary uses','Otras barras, alambres, etc.de oro, para uso n/monetario',10,'71','7108','710813');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71081390','Ouro em outs.formas semimanufat.bulhão dourado,  uso n/mo','Gold, oth.semi-manufact.forms of gold bullion, f/n/mon','Oro en ots.formas semilabradas.bullón dorado, uso n/mon.',10,'71','7108','710813');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71081391','Ouro em out.forma semimanuf.bulhão dourado,  uso n/monet.','Gold, oth.semi-manufact.forms of gold bullion, f/n/mon','Oro en ot.forma semilabrada bullón dorado, uso n/mon.',10,'71','7108','710813');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71081399','Ouro em outra forma semimanuf.p/uso não monetário','Gold, other semi-manufact.forms, f/n/monetary uses','Oro en otra forma semilabrada.p/uso no monetario',10,'71','7108','710813');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71082000','Ouro em formas brutas/semimanufaturadas,  p/uso monetário','Gold, unwrought/semi-manufact.forms, f/n/monetary','Oro en bruto/semilabrado, p/uso monetario',10,'71','7108','710820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71090000','Metais comuns/prata,  folheado/chapeado ouro,  em bruto,  etc','Base metals/silver, clad with gold n/further worked, etc','Metales comunes/plata/chapado oro, en bruto, etc',10,'71','7109','710900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71101100','Platina em formas brutas ou em pó','Platinum, unwrought or in powder form','Platino en bruto o en polvo',10,'71','7110','711011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71101910','Platina em barras, fios e perfis de seção maciça','Platinum, bars, yarns and profiles of solid cross-section','Platino en barras, alambres y perfiles de sección maciza',10,'71','7110','711019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71101990','Platina em outras formas semimanufaturadas','Platinum, other semi-manufactured forms','Platino en otras formas semilabrados',10,'71','7110','711019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71102100','Paladio em formas brutas ou em pó','Palladium, unwrought or in powder form','Paladio en  bruto o en polvo',10,'71','7110','711021');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71102900','Paladio em formas semimanufaturadas','Palladium in semi-manufactured forms','Paladio semilabrado',10,'71','7110','711029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71103100','Ródio em formas brutas ou em pó','Rhodium, unwrought or in powder form','Rodio en bruto o en polvo',10,'71','7110','711031');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71103900','Ródio em formas semimanufaturadas','Rhodium in semi-manufactured forms','Rodio semilabrado',10,'71','7110','711039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71104100','Irídio, ósmio e rutênio, em formas brutas ou em pó','Iridium, osmium and ruthen.unwrought or in powder form','Iridio, osmio y rutenio, en bruto o en polvo',10,'71','7110','711041');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71104900','Irídio, ósmio e rutênio, em formas semimanufaturadas','Iridium, osmium and ruthenium, in semi-manufactured form','Iridio, osmio y rutenio, semilabrados',10,'71','7110','711049');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71110000','Metais comuns/prata/ouro, folh/chap.platina, em bruto, etc','Base metals/silver/gold, clad with platinum, n/worked, etc','Chapado de platino sobr.metal común/plata/oro, bruto, etc',10,'71','7111','711100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71121000','Desperds/resid.de ouro/metais folheado/chapeado de ouro','Waste and scrap of gold/metal clad/plated of gold','Desperds/desec.de oro/chapado de metal/chapado de oro',10,'71','7112','711210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71122000','Desperds/resid.de platina/metais folhd/chapd.de platina','Waste/scrap of platinum/metal clad/plated of platinum','Desperds/desec.de platino/chapado de metal y de platino',10,'71','7112','711220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71123010','Cinzas contendo ouro, mas não cont.outs.met.prec.','Ash containing gold, but not contain.oth.precious metal','Cenizas q cont.oro, excepto las q cont.ots.met.prec.',10,'71','7112','711230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71123020','Cinzas cont.platina, não cont.outs.metais prec','Ash cont.platinum, but not contain.oth.precious metal','Cenizas q cont.platina, excepto las q cont.ots.met.prec.',10,'71','7112','711230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71123090','Cinzas cont.outs.metais prec.seus compostos','Ash containing other precious metal and its compounds','Cenizas q cont.ots.metales prec. o sus compuestos',10,'71','7112','711230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71129000','Desperds/resid.de outs.met.prec/met.folh/chap.met.prec.','Waste/scrap of oth.prec.met, /metal clad/plat.prec.metal','Despers/desec.de ots.met.prec/de met./chap.de met.prec.',10,'71','7112','711290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71129100','Outs.resid/desperd.de ouro/met.folhead.chap.','Other waste/scrap of gold/metal clad or plated','Ots.despers/desechos de oro/de chapado de metal',10,'71','7112','711291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71129200','Outs.resid/desperd, de platina/met.folhead.cha','Other waste/scrap of platinum/metal clad or plated','Ots.despers/desechos de platino/de chapado de metal',10,'71','7112','711292');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71129900','Outs.resid/desperd.de outs.metais prec.etc','Other waste/scrap of other precious metal, etc.','Ots.despers/desechos de ots.metales preciosos, etc',10,'71','7112','711299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71131100','Artefatos de joalharia,  de prata,  mesmo folh.de met.prec.','Articles of jewellery, silver, wheter or n/plated/clad pr','Artículos de joyería, de plata, incl.revest.de met.prec.',10,'71','7113','711311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71131900','Artefatos de joalharia, de outros metais preciosos,  etc.','Articles of jewellery, silver, of oth.precious metal, etc','Artículos de joyería, de otros met.preciosos, etc',10,'71','7113','711319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71132000','Artefatos de joalharia, de metais comuns folh.metal prec','Articles of jewellery, of base metal clad with prec.met.','Artículos de joyería, de chap.de met.prec.sobre met.prec',10,'71','7113','711320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71141100','Artefatos de ourivesaria, de prata, mesmo folh.met.prec.','Articl.of goldsmiths'', silver, wheth.or n/clad prec.met','Artículos de orfebrería, de plata, incl.chap.de met.prec.',10,'71','7114','711411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71141900','Artefatos de ourivesaria,  de outros metais preciosos,  etc','Articles of goldsmiths'', of other precious metal, etc','Artículos de orfebrería, de ots.metales preciosos, etc',10,'71','7114','711419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71142000','Artefatos de ourivesaria,  de metais comuns folh.met.prec','Articles of goldsmiths'', base metal clad precious metal','Artícs.de orfebrería, de chap.de met.prec.sobr.met.común',10,'71','7114','711420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71151000','Telas ou grades catalisadoras, de platina','Catalysts in the form of wire cloth/grill, of platinum','Catalizadores de platino en forma de tela o enrejado',10,'71','7115','711510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71159000','Outras obras de metais prec/metais folh/chap.metal prec','Oth.articles of precious metal/met.clad/plated prec.met','Las demás manuf.de met.prec./de chapado de metal prec.',10,'71','7115','711590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71161000','Obras de perolas naturais ou cultivadas','Articles of natural or cultured pearls','Manufacturas de perlas finas (naturales) o cultivadas',10,'71','7116','711610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71162010','Obras de diamantes sintéticos','Articles of sythetic diamonds','Manufacturas de diamantes sintéticos',10,'71','7116','711620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71162020','Guias de agulhas, de rubi, para cabeças de impressão','Needles-guides, of ruby,  for heads of printed','Guías de agujas, de rubí, para cabezales de impresión',10,'71','7116','711620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71162090','Outras obras de pedras preciosas/semi,  sintet/reconst.','Ot.articles of prec./semi-precious stones, synt/reconst.','Las demás manuf.de piedras preciosas/semi, sint/reconst.',10,'71','7116','711620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71171100','Abotoaduras e outros botões, de metais comuns','Cufflinks and other buttons, of base metal','Gemelos y pasadores similares, de metales comunes',10,'71','7117','711711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71171900','Outras bijuterias de metais comuns','Other imitation jewellery of  base metal','Las demás bisuterías de metales comunes',10,'71','7117','711719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71179000','Outras bijuterias','Other imitation jewellery','Las demás bisuterías',10,'71','7117','711790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71181000','Moedas sem curso legal, exceto de ouro','Coin (other than gold coin), not being legal tender','Monedas sin curso legal, excepto las de oro',10,'71','7118','711810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71181010','Moedas destinadas a ter curso legal no país importador','Intended f/use as legal tender in the importing country','Monedas dest.a tener curso legal en el país importador',10,'71','7118','711810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71181090','Outras moedas sem curso legal, exceto de ouro','Other coin(other than gold coin), not being legal tender','Otras monedas sin curso legal, excepto las de oro',10,'71','7118','711810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('71189000','Outras moedas','Other coin','Las demás monedas',10,'71','7118','711890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72011000','Ferro fundido bruto não ligado,  c/peso<=0.5% de fósforo','Non-alloy pig iron cont.by weight<=0.5%phosphorus','Fundición en bruto sin alear, c/cont.de fósf.<=0.5%peso',10,'72','7201','720110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72012000','Ferro fundido bruto não ligado,  c/peso>0.5% de fósforo','Non-alloy pig iron cont.by weight>=0.5%phosphorus','Fundición en bruto sin alear, c/cont.de fósf.>0.5%peso',10,'72','7201','720120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72015000','Ligas de ferro fundido bruto, ferro "spiegel"(especular)','Alloy pig iron(bruted), spiegeleisen','Fundición en bruto aleada, fundición especular',10,'72','7201','720150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72021100','Ferromanganês contendo, em peso>2% de carbono','Ferro-manganese containing by weight>2% of carbon','Ferromanganeso c/un contenido de carbono>2% en peso',10,'72','7202','720211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72021900','Outras ligas de ferromanganês','Other ferro-manganese alloys','Las demás aleaciones de ferromanganeso',10,'72','7202','720219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72022100','Ferrossilício contendo peso>55% de silício','Ferro-silico containing by weight>55% of silicon','Ferrosilicio c/un contenido de silicio>55%en peso',10,'72','7202','720221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72022900','Outras ligas de ferrossilício','Other ferro-silico alloys','Las demás aleaciones de ferrosilicio',10,'72','7202','720229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72023000','Ferrossilício-manganês','Ferro-silico-manganese','Ferro-sílico-manganeso',10,'72','7202','720230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72024100','Ferrocromo contendo peso>4% de carbono','Ferro-chromium containing by weight>4% of carbon','Ferrocromo c/un contenido de carbono>4% en peso',10,'72','7202','720241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72024900','Outras ligas de ferrocromo','Other ferro-chromium alloys','Las demás aleaciones de ferrocromo',10,'72','7202','720249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72025000','Ferrossilício-cromo','Ferro-silico-chromium','Ferro-sílico-cromo',10,'72','7202','720250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72026000','Ferroníquel','Ferro-nickel','Ferroníquel',10,'72','7202','720260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72027000','Ferromolibdénio','Ferro-molybdenum','Ferromolibdeno',10,'72','7202','720270');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72028000','Ferrotungstênio e ferrossilício-tungstênio','Ferro-tungsten and ferro-silico-tungsten','Ferrovolframio y ferro-sílico-volframiio',10,'72','7202','720280');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72029100','Ferrotitânio e ferrossilício-titânio','Ferro-titanium and ferro-silico-titanium','Ferrotitanio y ferro-sílico-titanio',10,'72','7202','720291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72029200','Ferrovanádio','Ferro-vanadium','Ferrovanadio',10,'72','7202','720292');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72029300','Ferronióbio','Ferro-niobium','Ferroniobio',10,'72','7202','720293');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72029910','Ferrofósforos','Ferro-phosphorus','Ferrofósforos',10,'72','7202','720299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72029990','Outros ferroligas','Other ferro-alloys','Las demás ferroaleaciones',10,'72','7202','720299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72031000','Prods.ferrosos da redução direta dos minérios de ferro','Ferrous products obtain.by direct reduction of iron ore','Prods.férreos obt.por reduc.directa de miner.de hierro',10,'72','7203','720310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72039000','Outros prods.ferrosos esponjosos,  em pedaços,  esferas,  etc','Other spongy ferrous products, in lumps, pellets, etc','Otros prods.férreos esponjosos, en trozos, pellets, etc',10,'72','7203','720390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72041000','Desperdícios e resíduos de ferro fundido','Waste and scrap of cast iron','Desperdicios y desechos de fundición',10,'72','7204','720410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72042100','Desperdícios e resíduos de aços inoxidáveis','Waste and scrap of stainless steel','Desperdicios y desechos de aceros inoxidables',10,'72','7204','720421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72042900','Desperdícios e resíduos de outras ligas de aço','Waste and scrap of other alloy steel','Desperdicios y desechos de otras aleaciones de acero',10,'72','7204','720429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72043000','Desperdícios e resíduos de ferro ou aço estanhados','Waste and scrap of tinned iron or steel','Desperdicios y desechos de hierro o acero estañados',10,'72','7204','720430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72044100','Resíduos do torno, da fresa, aparas, lascas, limalhas,  etc.','Turnings, shavings, chips, milling waste, etc','Residuos de torneaduras, virutas, esquirlas, limaduras, etc',10,'72','7204','720441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72044900','Outros desperdícios e resíduos de ferro ou aço','Other waste and scrap of iron or steel','Los demás desperdicios y desechos de hierro o acero',10,'72','7204','720449');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72045000','Desperdícios de ferro ou aço em lingotes','Remelting scrap ingots of iron or steel','Lingotes de chatarra de hierro o acero',10,'72','7204','720450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72051000','Granalhas de ferro fundido bruto, "spiegel", ferro ou aço','Granules of pig iron, spiegeleisen, iron or steel','Granallas de fund.en bruto, fund.especular, hierro/acero',10,'72','7205','720510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72052100','Pós de ligas de aço','Powders of alloy steel','Polvos de aleaciones de acero',10,'72','7205','720521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72052910','Pós de ferro esponjoso, teor em peso >= 98% de ferro','Spongy ferrous powders containing by weight>=98%of iron','Polvos de hierro esponja, c/cont.de hierro>=98%en peso',10,'72','7205','720529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72052920','Outs pós de ferro revest.resina c/teor fe=>98% em peso','Outs pos de ferro revest.resina c/teor fe=>98% em peso','Outs pos de ferro revest.resina c/teor fe=>98% em peso',10,'72','7205','720529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72052990','Outs.pós de ferro fundido bruto,"spiegel", ferro ou aço','Other powders of pig iron, spiegeleisen, iron or steel','Ots.polvos de fund.en bruto, fund.especular, hierro/acero',10,'72','7205','720529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72061000','Ferro e aços, em lingotes','Iron or steel, in ingots','Lingotes de hierro y acero',10,'72','7206','720610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72069000','Ferro e aços não ligados ou em outras formas primárias','Iron and non-alloy steel in ingots or oth.primary forms','Hierro y acero sin alear o en otras formas primarias',10,'72','7206','720690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72071110','Billets de ferro/aço,  c<0.25%,  sec.transv.quad/ret.l<2e','Billets of iron/steel, c<0.25%, rect.squar.cross-sec.w<2e','Palanq.de hierro/acero, c<0.25%, sec.transv.cuad/ret.a<2e',10,'72','7207','720711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72071190','Outs.prods.semimanuf.ferro/aço,  c<0.25%,  sec.transv.l<2e','Ot.semi-finis.prod.of iron/steel, c<0.25%, cross-sec.w<2e','Ots.prod.intermed.hierro/acero, c<0.25%, sec.transv.a<2e',10,'72','7207','720711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72071200','Outros prods.semimanuf.ferro/aço,  c<0.25%,  sec.transv.ret','Ot.semi-finis.prod.iron/steel, c<0.25%, rec.sq.cross-sec','Ots.prods.intermed.hierro/acero, c<0.25%, sec.transv.ret',10,'72','7207','720712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72071900','Outs.prods.semimanuf.ferro/aço,  n/ligados,  carbono<0.25%','Ot.semi-finis.prod.iron/steel, non-alloy, carbon<0.25%','Ots.prods.intermed.hierro/acero, s/alear, carbono<0.25%',10,'72','7207','720719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72072000','Prods.semimanufat.de ferro/aço,  n/ligados,  carbono>=0.25%','Semi-finished prod.iron/steel, non-alloy, carbon>=0.25%','Prods.intermed.de hierro/acero, s/alear, carbono>=0.25%',10,'72','7207','720720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72081000','Lamin.ferro/aço, quente,  l>=60cm,  rolo, motivo em relevo','Hot-rolled iron/steel, w>=60cm, coils, with patter.relief','Lamin.hierro/acero, calien., a>=60cm, enrol.mot.en relieve',10,'72','7208','720810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72082500','Lamin.ferro/aço, quente,  l>=60cm,  rolo,  decap.e>=4.75mm','Hot-rolled iron/steel, w>=60cm, coils, pickled t>=4.75mm','Lamin.hierro/acero, calien.a>=60cm, enrol.decap.e>=4.75mm',10,'72','7208','720825');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72082610','Lamin.ferro/aço,  quente,  l>=60cm,  rolo,  decap.e>=3mm,  355mpa','Hot-rolled iron/steel, w>=60cm, coils, pickl.t>=3mm, 355mpa','Lamin.hier./acer.calien.a>=60cm, enrol.dec.e>=3mm, 355mpa',10,'72','7208','720826');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72082690','Outs.lamin.ferro/aço,  l>=6dm,  quente,  rolos,  decap.3<=e<4mm','Oth.hot-rolled iron/steel, w>=6dm, coils, pickled 3<=t<4mm','Ots.lamin.hier./acer.a>=6dm, calien.enrol.decap.3<=e<4mm',10,'72','7208','720826');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72082710','Lamin.ferro/aço,  quente,  l>=60cm,  rolo,  decap.e<3mm,  275mpa','Hot-rolled iron/steel, w>=60cm, coils, pickl.t<3mm, 275mpa','Lamin.hier./acer.calien.a>=60cm, enrol.dec.e<3mm, 275mpa',10,'72','7208','720827');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72082790','Outros lamin.ferro/aço,  l>=6dm,  quente,  rolos,  decap.e<3mm','Oth.hot-rolled iron/steel, w>=6dm, coils, pickled t<3mm','Ots.lamin.hier./acer.a>=6dm, calien., enrol., decap.e<3mm',10,'72','7208','720827');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72083610','Lamin.ferro/aço,  quente,  l>=60cm,  rolo,  e>10mm,  elast.355mpa','Hot-rolled iron/steel, w>=60cm, coils t>10mm, elast.355mpa','Lam.hier./acer.calien.a>=60cm, enr.e>10mm, elast>=355mpa',10,'72','7208','720836');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72083690','Outros lamin.ferro/aço,  l>=6dm,  quente,  rolos,  e>10mm','Other hot-rolled iron/steel, w>=60cm, coils, t>10mm','Ots.lam.hier./acero, a>=60cm, calien., enrollados, e>10mm',10,'72','7208','720836');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72083700','Lamin.ferro/aço,  quente,  l>=60cm,  rolo,  4.75mm<e<=10mm','Hot-rolled iron/steel, w>=60cm, coils, 4.75mm<t<=10mm','Lamin.hier./acero, calien., a>=60cm, enrol., 4.75mm<e<=10mm',10,'72','7208','720837');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72083810','Lamin.ferro/aço,  quente,  l>=60cm,  rolo,  3<=e<4.75mm,  355mpa','Hot-rolled iron/steel, w>=60cm, coils 3<=t<4.75mm, 355mpa','Lam.hier./acero, calien.a>=60cm, enrol.3<=e<4.75mm, 355mpa',10,'72','7208','720838');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72083890','Outs.lamin.ferro/aço,  l>=6dm,  quente,  rolos,  3mm<=e<=4.75mm','Oth.hot-rolled iron/steel, w>=6dm, coils, 3mm<=t<=4.75mm','Ots.lam.hier./acero, a>=6dm, calien., enrol.3mm<=e<=4.75mm',10,'72','7208','720838');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72083910','Lamin.ferro/aço,  quente,  l>=60cm,  rolo,  e<3mm,  elast.275mpa','Hot-rolled iron/steel, w>=60cm, coils, t<3mm, elast.275mpa','Lam.hier./acero, calien.a>=60cm, enrol.e<3mm, elast.275mpa',10,'72','7208','720839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72083990','Outros lamin.ferro/aço,  l>=6dm,  quente,  rolos,  e<3mm','Oth.hot-rolled iron/steel, w>=6dm, coils, t<3mm','Ots.lamin.hier./acero, a>=6dm, calien., enrol., e<3mm',10,'72','7208','720839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72084000','Lamin.ferro/aço,  quente,  l>=60cm,  n/enrolado,  motivo relevo','Hot-rolled iron/steel, w>=60cm, coils, patterns in relief','Lamin.hier./acero, calien., a>=60cm, enrol., mot.en relieve',10,'72','7208','720840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72085100','Lamin.ferro/aço,  quente,  l>=60cm,  n/enrolado,  e>10mm','Hot-rolled iron/steel, w>=60cm, n/coils, e>10mm','Lamin.hier./acero, calien., a>=60cm, s/enrollar, e>10mm',10,'72','7208','720851');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72085200','Lamin.ferro/aço,  quente,  l>=60cm,  n/enrolado,  4.75<=e<=10mm','Hot-rolled iron/steel, w>=60cm, n/coils, 4.75<=t<=10mm','Lamin.hier./acero, calien., a>=60cm, s/enrol.4.75<=e<=10mm',10,'72','7208','720852');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72085300','Lamin.ferro/aço,  quente,  l>=60cm,  n/enrolado,  3mm<=e<4.75mm','Hot-rolled iron/steel, w>=60cm, n/coils, 3mm<=t<4.75mm','Lamin.hier./acero, calien., a>=60cm, s/enrol.3mm<=e<4.75mm',10,'72','7208','720853');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72085400','Lamin.ferro/aço,  quente,  l>=60cm,  n/enrolado,  e<3mm','Hot-rolled iron/steel, w>=60cm, n/coils, t<3mm','Lamin.hierro/acero, caliente, a>=60cm, s/enrollar, e<3mm',10,'72','7208','720854');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72089000','Outs.lamin.ferro/aço,  l>=6dm,  quente,  n/folheados/chap.etc','Hot-rolled iron/steel, w>=6dm, n/clad/plated, etc','Ots.lamin.hier./acero, a>=6dm, calien.s/chap.n/revest.etc',10,'72','7208','720890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72091500','Lamin.ferro/aço, a frio, l>=6dm, em rolos, e>=3mm','Cold-rolled iron/steel, w>=6dm, coils, t>=3mm','Lamin.hierro/acero, en frío, a>=6dm, enrollado, e>=3mm',10,'72','7209','720915');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72091600','Lamin.ferro/aço,  a frio,  l>=6dm,  em rolos,  1mm<e<3mm','Cold-rolled iron/steel, w>=6dm, in coils, 1mm<t<3mm','Lamin.hierro/acero, en frío, a>=6dm, enrollado, 1mm<e<3mm',10,'72','7209','720916');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72091700','Lamin.ferro/aço,  a frio,  l>=6dm,  em rolos,  0.5mm<=e<=1mm','Cold-rolled iron/steel, w>=6dm, coils, 0.5mm<=t<=1mm','Lamin.hierro/acero, en frío, a>=6dm, enrol., 0.5mm<=e<=1mm',10,'72','7209','720917');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72091800','Lamin.ferro/aço,  a frio,  l>=6dm,  em rolos,  e<0.5mm','Cold-rolled iron/steel, w>=6dm, coils, w<0.5mm','Lamin.hierro/acero, en frío, a>=6dm, enrollado, e<0.5mm',10,'72','7209','720918');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72092500','Lamin.ferro/aço,  a frio,  l>=6dm,  n/enrolado,  e>=3mm','Cold-rolled iron/steel, w>=6dm, n/coils, t>=3mm','Lamin.hierro/acero, en frío, a>=6dm, s/enrollar, e>=3mm',10,'72','7209','720925');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72092600','Lamin.ferro/aço,  a frio,  l>=6dm,  n/enrolado,  1mm<e<3mm','Cold-rolled iron/steel, w>=6dm, in coils, 1mm<t<3mm','Lamin.hierro/acero, en frío, a>=6dm, s/enrollar, 1mm<e<3mm',10,'72','7209','720926');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72092700','Lamin.ferro/aço,  a frio,  l>=6dm,  n/enrolado,  0.5mm<=e<=1mm','Cold-rolled iron/steel, w>=6dm, n/coils, 0.5mm<=t<=1mm','Lamin.hier./acero, en frío, a>=6dm, s/enrol., 0.5mm<=e<=1mm',10,'72','7209','720927');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72092800','Lamin.ferro/aço,  a frio,  l>=6dm,  n/enrolado,  e<0.5mm','Cold-rolled iron/steel, w>=6dm, n/coils, t<0.5mm','Lamin.hierro/acero, en frío, a>=6dm, s/enrollar, e<0.5mm',10,'72','7209','720928');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72099000','Outs.lamin.ferro/aço,  l>=6dm,  a frio,  n/folheados/chap.etc','Other cold-rolled iron/steel, w>=6dm, n/clad/plated, etc','Ots.lam.hierro/acero, l>=6dm, en frío, s/chap.n/reves.etc',10,'72','7209','720990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72101100','Lamin.ferro/aço, l>=6dm, estanhado, e>=0.5mm','Rolled iron/steel, w>=6dm, tin, t>=0.5mm','Lamin.hierro/acero, a>=6dm, estañado, e>=0.5mm',10,'72','7210','721011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72101200','Lamin.ferro/aço, l>=6dm, estanhado, e<0.5mm','Rolled iron/steel, w>=6dm, tin, t<0.5mm','Lamin.hierro/acero, a>=6dm, estañado, e<0.5mm',10,'72','7210','721012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72102000','Lamin.ferro/aço,  l>=6dm,  revest.chumbo,  incl.chumboestanho','Rolled iron/steel, w>=6dm, coat.lead, incl.lead-tin','Lamin.hierro/acero, a>=6dm, emplomado, incl.plomo y estaño',10,'72','7210','721020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72103010','Lamin.ferro/aço,  l>=6dm,  galvan.eletroliticam.e<4.75mm','Rolled prod.iron/steel, w>=6dm, elect.galvanized t<4.75mm','Lamin.hierro/acero, a>=6dm, cincad.electrolític.e<4.75mm',10,'72','7210','721030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72103090','Outros lamin.ferro/aço,  l>=6dm,  galvan.eletroliticamente','Rolled prod.iron/steel, w>=6dm, electrolycally galvanized','Ots.lamin.hierro/acero, a>=6dm, cincado electrolíticam.',10,'72','7210','721030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72104110','Lamin.ferro/aço,  l>=6dm,  galvan.out.proc.ondulado,  e<4.7mm','Rolled prod.iron/steel, w>=6dm, galv.oth.proc.cor.t<4.7mm','Lamin.hierro/acero, a>=6dm, cinc.ot.modo, ondulado, e<4.7mm',10,'72','7210','721041');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72104190','Outros lamin.ferro/aço,  l>=6dm,  galvan.out.proc.ondulados','Oth.rolled prod.iron/steel, w>=6dm, galv.oth.proc.corrug.','Ots.lamin.hierro/acero, a>=6dm, cinc.ot.modo, ondulado',10,'72','7210','721041');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72104910','Lamin.ferro/aço, l>=6dm, galvan.outro proc.e<4.75mm','Rolled prod.iron/steel, w>=6dm, galv.oth.proc.e<4.75mm','Lamin.hierro/acero, a>=6dm, cinc.ot.modo, ondul, e<4.75mm',10,'72','7210','721049');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72104990','Outros lamin.ferro/aço, l>=6dm, galvan.outro proc.','Oth.rolled prod.iron/steel, w>=6dm, galv.oth.process','Ots.lamin.hierro/acero, a>=6dm, cincado ot.modo',10,'72','7210','721049');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72105000','Lamin.ferro/aço,  l>=6dm,  revest.óxido de cromo e/ou cromo','Rolled prod.iron/steel, coat.with chrome oxides/chrom.','Lamin.hierro/acero, a>=6dm, revest.óxido de cromo/cromo',10,'72','7210','721050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72106100','Lamin.ferro/aço,  l>=6dm,  revest.ligas de alumínio-zinco','Rolled iron/steel, w>=6dm, coated with aluminium-zinc','Lamin.hierro/acero, a>=6dm, revest.aleac.de aluminio/cinc',10,'72','7210','721061');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72106900','Outros lamin.ferro/aço, l>=6dm, revest.alumínio','Other rolled iron/steel, w>=6dm, coated with aluminium','Otros lamin.hierro/acero, a>=6dm, revest.aluminio',10,'72','7210','721069');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72106911','Outs.lamin.ferro/aço,  revest.alumínio silício,  p>=120g/m2','Oth.rolled iron/steel, coat.with alumin.silic.w>=120g/m2','Ots.lamin.hierro/acero, revest.alumin.silicio, p>=120g/m2',10,'72','7210','721069');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72106919','Outs.lamin.ferro/aço, revest.de alumínio silício','Oth.rolled iron/steel, coated with aluminium silicon','Ots.lamin.hierro/acero, revest.de aluminio silicio',10,'72','7210','721069');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72106990','Outros laminados ferro/aço','Other rolled iron/steel','Ots.lamin.hierro/acero',10,'72','7210','721069');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72107010','Lamin.ferro/aço, l>=6dm, pintados ou envernizados','Rolled iron/steel, w>=6dm, painted or varnished','Lamin.hierro/acero, a>=6dm, pintados o barnizados',10,'72','7210','721070');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72107020','Lamin.ferro/aço, l>=6dm, revest.plásticos','Rolled iron/steel, w>=6dm, coated with plastic','Lamin.hierro/acero, a>=6dm, revestidos de plásticos',10,'72','7210','721070');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72109000','Outs.lamin.ferro/aço,  l>=6dm,  folheados/chapeados/revest.','Oth.rolled iron/steel, w>=6dm, clad/plated/coated','Ots.lamin.hierro/acero, a>=6dm, chapados/revestidos',10,'72','7210','721090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72111300','Lamin.ferro/aço,  quente,  15<l<60cm,  e>=4mm,  n/enrolado,  etc','Hot-rolled iron/steel, 15<t<60cm, t>=4mm, n/coils, etc','Lamin.hierro/acero, calien., 15<a<60cm, e>=4mm, s/enrol.etc',10,'72','7211','721113');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72111400','Outros lamin.ferro/aço,  l<6dm,  quente,  e>=4.75mm','Other hot-rolled iron/steel, w<6dm, t>=4.75mm','Otros lamin.hierro/acero, a<6dm, caliente, e>=4.75mm',10,'72','7211','721114');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72111900','Outros lamin.ferro/aço,  l<6dm,  quente,  n/folheados,  etc.','Other hot-rolled iron/steel, w<6dm, n/clad, etc','Otros lamin.hierro/acero, a<6dm, caliente, s/chapar, etc',10,'72','7211','721119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72112300','Lamin.ferro/aço,  a frio,  l<6dm,  teor<0.25% de carbono','Cold-rolled iron/steel, w<6dm, containing<0.25% of carbon','Lamin.hierro/acero, en frío, a<6dm, c/cont.carb.<0.25%peso',10,'72','7211','721123');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72112910','Lamin.ferro/aço,  a frio,  l<6dm,  teor 0.25%<=carbono<0.6%','Cold-rolled iron/steel, w<6dm, contain.0.25%<=carb.<0.6%','Lamin.hierro/acero, frío, a<6dm, c/cont.0.25%<=carb.<0.6%',10,'72','7211','721129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72112920','Lamin.ferro/aço,  a frio,  l<6dm,  teor>=0.6% de carbono','Cold-rolled iron/steel, w<6dm, containing>=0.6% of carbon','Lamin.hierro/acero, en frío, a<6dm, c/cont.carbono>=0.6%',10,'72','7211','721129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72119010','Outros lamin.ferro/aço,  l<6dm,  teor>=0.6% de carbono','Oth.cold-rolled iron/steel, w<6dm, containing>=0.6%carbon','Ots.lamin.hierro/acero, a<6dm, c/cont.de carbono>=0.6%',10,'72','7211','721190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72119090','Outros lamin.ferro/aço,  l<6dm,  n/folheados/chapeados,  etc.','Oth.rolled iron/steel, w<6dm, n/clad/plated, etc.','Otros lamin.hierro/acero, a<6dm, s/chapar n/rev., etc.',10,'72','7211','721190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72121000','Lamin.ferro/aço, l<6dm, estanhado','Rolled iron/steel, w<6dm, tin','Lamin.hierro/acero, a<6dm, estañado',10,'72','7212','721210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72122010','Lamin.ferro/aço, l<6dm, galvan.eletrolit.e<4.75mm','Rolled iron/steel, w<6dm, electrolyt.galvanized t<4.75mm','Lamin.hierro/acero, a<6dm, cincados electrolít.e<4.75mm',10,'72','7212','721220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72122090','Outros lamin.ferro/aço, l<6dm, galvan.eletrolit.','Other rolled iron/steel, w<6dm, electrolyt.galvanized','Otros lamin.hierro/acero, a<6dm, cincados electrolíticam.',10,'72','7212','721220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72123000','Lamin.ferro/aço, l<6dm, galvan.outro processo','Rolled iron/steel, w<6dm, otherwise galvanized','Lamin.hierro/acero, a<6dm, cincado de otro modo',10,'72','7212','721230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72124010','Lamin.ferro/aço, l<6dm, pintado ou envernizado','Rolled iron/steel, w<6dm, painted or varnished','Lamin.hierro/acero, a<6dm, pintado o barnizado',10,'72','7212','721240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72124020','Lamin.ferro/aço,l<6dm, revestido de plásticos','Rolled iron/steel, w<6dm, coated with plastics','Lamin.hierro/acero, a<6dm, revestido de plásticos',10,'72','7212','721240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72124021','Lamin.ferro/aço.l<6dm,  revest.plast.c/liga cobre-estanho','Rolled iron/steel, w<6dm, coated with plastics, copper-tin alloys','Lamin.hierro/acero, a<6dm, revestido de plásticos, con aleaciones de cobre-estaño',10,'72','7212','721240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72124029','Outs.lamin de ferro/aço, l<6dm, revest.de plástico','Other rolled iron/steel, w<6dm, coated with plastics','Otras lamin.hierro/acero, a<6dm, revestido de plásticos',10,'72','7212','721240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72125000','Lamin.ferro/aço,  l<6dm,  revestido de outras matérias','Rolled iron/steel, w<6dm, otherwise coated','Lamin.hierro/acero, a<6dm, revestido de otro modo',10,'72','7212','721250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72125010','Lamin.ferro/aço,  l<6dm,  camada bronze,  revest.metal-plast.','Rolled iron/steel, w<6dm, bronze layer, coat.with plastics','Lamin.hierro/acero, a<6dm, cap.bronce, revest.metal-plást.',10,'72','7212','721250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72125090','Outs.lamin.ferro/aço,  l<6dm,  revestido de outs.matérias','Other rolled iron/steel, w<6dm, otherwise coated','Ots.lamin.hierro/acero, a<6dm, revestidos de otro modo',10,'72','7212','721250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72126000','Laminado ferro/aço, l<6dm, folheado ou chapeado','Rolled iron/steel, w<6dm, clad or plated','Lamin.hierro/acero, a<6dm, chapado o revestido',10,'72','7212','721260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72131000','Fio-máquina de ferro/aço,  dentado,  c/nervura,  sulco,  revelo','Thread-mach.iron/steel, cont.indent.ribs, grooves, relief','Alambrón de hierro/acero, c/muescas, cord., surco, relieves',10,'72','7213','721310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72132000','Fio-máquina de aços para tornear','Thread-machine of free-cutting steel','Alambrón de aceros de fácil mecanización',10,'72','7213','721320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72139110','Fio-máquina de ferro/aço,  sec.circ.d<14mm,  carbono>=0.6%','Thread-mach.iron/steel, circular sec.d<14mm, carbon>=0.6%','Alambrón de hierro/acero, sec.circ.d<14mm, carbono>=0.6%',10,'72','7213','721391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72139190','Outs.fio-máquinas de ferro/aço,  n/ligado,  sec.circ.d<14mm','Oth.thread-mach.iron/steel, n/alloy, circ.sec.d<14mm','Ots.alambrones de hierro/acero, s/alear, sec.circ.d<14mm',10,'72','7213','721391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72139910','Outros fio-máquinas de ferro/aço,  n/ligado,  carbono>=0.6%','Oth.thread-mach.iron/steel, non-alloy, carbon>=0.6%','Ots.alambrones de hierro/acero, s/alear, carbono>=0.6%',10,'72','7213','721399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72139990','Outros fio-máquinas de ferro/aço, não ligado','Other thread-machine of iron/steel, non-alloy','Otros alambrones de hierro/acero, s/alear',10,'72','7213','721399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72141010','Barras de ferro/aço,  forjadas,  quente,  carbono<=0.60%','Bars of iron/steel, forged, hot, carbon<=0.60%','Barras de hierro/acero, forjadas, caliente, carbono<=0.60%',10,'72','7214','721410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72141090','Outras barras de ferro/aço, n/lig.forjada, quente','Other bars of iron/steel, non-alloy, forged, hot','Ots.barras de hierro/acero, s/alear, forjadas, caliente',10,'72','7214','721410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72142000','Barras de ferro/aço, lamin.quente, dentadas, etc.','Bars of iron/steel, hot-rolled, contain.indetations, etc','Barras de hierro/acero, lamin., caliente, c/muescas, etc',10,'72','7214','721420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72143000','Barras de aços para tornear,  laminadas,  etc.a quente','Bars of free-cutting steel, hot-rolled, etc','Barras de aceros de fácil mecan., lamin., etc.en caliente',10,'72','7214','721430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72149100','Barras de ferro/aço,  lamin.etc.quente,  sec.transv.retang.','Bars of iron/steel, hot-rolled, etc.rectan.squar.cross-se','Barras de hierro/acero, lam.etc.calien., sec.transv.rect.',10,'72','7214','721491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72149910','Barras de ferro/aço, lamin.etc.quente, sec.circular','Bars of iron/steel, hot-rolled, etc.circular section','Barras de hierro/acero, lamin.etc.caliente, sec.circular',10,'72','7214','721499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72149990','Outras barras de ferro/aço, n/lig.lamin.etc.quente','Other bars of iron/steel, non-alloy, hot-rolled, etc.','Otras barras de hierro/acero, s/alear, lamin.etc.caliente',10,'72','7214','721499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72151000','Barras de aços para tornear, obtidas/acabadas a frio','Bars of free-cutting steel, obtained/cold-finished','Barras de aceros de fácil mecan.obten./acabadas en frío',10,'72','7215','721510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72155000','Outs.barras de ferro/aço,  n/lig.obtidas/acabadas a frio','Oth.bars of iron/steel, n/alloy, obtained/cold-finished','Ots.barras de hierro/acero, s/alear, obt/acabadas en frío',10,'72','7215','721550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72159010','Outras barras de ferro/aço, n/lig.carbono<=0.60%','Oth.bars of iron/steel, n/alloy, carbon<=0.60%','Otras barras de hierro/acero, s/alear, carbono<=0.60%',10,'72','7215','721590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72159090','Outras barras de ferro/aço, n/lig.','Other bars of iron/steel, n/alloy','Otras barras de hierro/acero, s/alear',10,'72','7215','721590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72161000','Perfis de ferro/aço,  em u,  i,  h,  lamin.etc.quente,  h<8cm','Profiles of iron/steel, u, i, h, hot-rolled, etc.h<8cm','Perfiles de hierro/acero, en u, i, h, lamin.etc.calie.h<8cm',10,'72','7216','721610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72162100','Perfis de ferro/aço,  em l,  lamin.etc.a quente,  h<8cm','Profiles of iron/steel, l, hot-rolled, etc.h<8cm','Perfiles de hierro/acero, en l, lamin.etc.caliente, h<8cm',10,'72','7216','721621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72162200','Perfis de ferro/aço,  em t,  lamin.etc.a quente,  h<8cm','Profiles of iron/steel, t, hot-rolled, h<8cm','Perfiles de hierro/acero, en t, lamin.etc.caliente, h<8cm',10,'72','7216','721622');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72163100','Perfis de ferro/aço,  em u,  lamin.etc.a quente,  h>=8cm','Profiles of iron/steel, u, hot-rolled, etc.h<8cm','Perfiles de hierro/acero, en u, lamin.etc.caliente, h<8cm',10,'72','7216','721631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72163200','Perfis de ferro/aço,  em i,  lamin.etc.a quente,  h>=8cm','Profiles of iron/steel, i, hot-rolled, etc.h<8cm','Perfiles de hierro/acero, en i, lamin.etc.caliente, h<8cm',10,'72','7216','721632');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72163300','Perfis de ferro/aço,  em h,  lamin.etc.a quente,  h>=8cm','Profiles of iron/steel, h, hot-rolled, etc.h<8cm','Perfiles de hierro/acero, en h, lamin.etc.caliente, h<8cm',10,'72','7216','721633');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72164010','Perfis de ferro/aço,  em l,  t,  lamin.etc.quente,  8<=h<=20cm','Profiles of iron/steel, l, t, hot-rolled, etc.8<=h<=20cm','Perfiles de hier./acero, en l, t, lam.etc.calie.8<=h<=20cm',10,'72','7216','721640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72164090','Perfis de ferro/aço,  em l,  t,  lamin.etc.quente,  h>=8cm','Profiles of iron/steel, l, t, hot-rolled, etc.h>=8cm','Perfiles de hierro/acero, en l, t, lam.etc.calien., h>=8cm',10,'72','7216','721640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72165000','Outros perfis de ferro/aço,  n/lig.lamin.etc.quente','Oth.profiles of iron/steel, non-alloy, hot-rolled, etc.','Ots.perfiles de hierro/acero, s/alear, lamin.etc.caliente',10,'72','7216','721650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72166110','Perfis de ferro/aço,  obt/acab.de prods.lamin.frio,  h<8cm','Profiles of iron/steel, obtained/cold-finished, h<8cm','Perfiles de hierro/acero, obt/acab.prods.lam.frío, h<8cm',10,'72','7216','721661');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72166190','Outs.perfis de ferro/aço,  obt/acab.frio,  lam.plano,  h>=8cm','Ot.profil.of iron/steel, obt/cold-finish.flat-rol.h>=8cm','Ots.perfs.de hierro/acero, obt/acab.frío, lam.pl., h>=8cm',10,'72','7216','721661');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72166910','Outros perfis de ferro/aço, obt/acab.a frio,  h<8cm','Oth.profiles of iron/steel, obt/cold-finished, h>=8cm','Ots.perfiles de hierro/acero, obt/acab.en frío, h>=8cm',10,'72','7216','721669');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72166990','Outros perfis de ferro/aço, obt/acab.a frio','Other profiles of iron/steel, obt/cold-finished','Ots.perfiles de hierro/acero, obt/acab.en frío',10,'72','7216','721669');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72169100','Outros perfis de ferro/aço, obt/acab.frio,  lamin.plano','Oth.profiles of iron/steel, obt/cold-finish.flat-rolled','Ots.perfiles de hierro/acero, obt/acab.en frío, lam.plano',10,'72','7216','721691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72169900','Outros perfis de ferro/aço, não ligados','Other profiles of iron/steel, non-alloy','Otros perfiles de hierro/acero, sin alear',10,'72','7216','721699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72171010','Fios de ferro/aço,  n/ligados,  n/revestidos,  carbono>=0.6%','Wire of iron/steel, non-alloy, n/coated, carbon>=0.6%','Alambre de hierro/acero, s/alear n/revestir, carb.>=0.6%',10,'72','7217','721710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72171011','Fios de ferro/aço n/lig.n/rev.c>=0.6%,  f e s<0.035%,  etc.','Wire iron/steel, n/alloy, n/coat.c>=0.6%, f, s<0.035%, etc','Alamb.de hier./acero, s/ale.n/rev.c>=0.6%, f, s<0.035%, etc',10,'72','7217','721710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72171019','Outs.fios de ferro/aço n/ligados,  n/revest.carbono>=0.6%','Oth.wire of iron/steel, non-alloy, n/coated, carbon>=0.6%','Ots.alambres de hierro/acero, s/alear n/rev., carb.>=0.6%',10,'72','7217','721710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72171090','Outros fios de ferro/aço, não ligados, não revestidos','Other wire of iron/steel, non-alloy, n/coated','Ots.alambres de hierro/acero, s/alear n/revestir',10,'72','7217','721710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72172010','Fios de ferro/aço,  n/ligados,  galvanizados,  carbono>=0.6%','Wire of iron/steel, non-alloy, galvenized, carbon>=0.6%','Alambre de hierro/acero, s/alear, cincado, carbono>=0.6%',10,'72','7217','721720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72172090','Outros fios de ferro/aço, não ligados, galvanizados','Other wire of iron/steel, non-alloy, galvenized','Ots.alambres de hierro/acero, s/alear, cincados',10,'72','7217','721720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72173010','Fios de ferro/aço,  revest.outs.met.comuns,  carbono>=0.6%','Wire of iron/steel, coated, oth.base metal, carbon>=0.6%','Alambre de hierro/acero, revest.ot.met.común, carb.>=0.6%',10,'72','7217','721730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72173090','Outs.fios de ferro/aço,  n/lig.revest.outs.metais comuns','Other wire of iron/steel, coated, oth.base metal','Ots.alambres de hierro/acero, revest.ot.met.común',10,'72','7217','721730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72179000','Outros fios de ferro/aço, não ligados','Other wire of iron/steel, non-alloy','Ots.alambres de hierro/acero, sin alear',10,'72','7217','721790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72181000','Acos inoxidáveis,  em lingotes e outras formas primárias','Stainless steel in ingots or other primary forms','Aceros inoxidables, en lingotes o demás formas primarias',10,'72','7218','721810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72189100','Prods.semimanufaturados,  de aços inox.sec.transv.retang.','Semi-manufactured prod.stainless steel cross-section','Prods.intermedios, de aceros inox.sec.transv.rectang.',10,'72','7218','721891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72189900','Outros produtos semimanufaturados,  de aços inoxidáveis','Oth.semi-manufactured prod., of stainless steel','Los demás prods.intermedios, de aceros inoxidables',10,'72','7218','721899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72191100','Lamin.aços inox.quente, l>=600mm, rolos, e>10mm','Hot-rolled stainless steel, w>=600mm, rolls, t>10mm','Lamin.aceros inox.caliente, a>=600mm, enrollados, e>10mm',10,'72','7219','721911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72191200','Lamin.aços inox.quente,  l>=600mm,  rolos,  4.75mm<=e<=10mm','Hot-rolled stainl.steel, w>=600mm, rolls, 4.75mm<=t<=10mm','Lam.aceros inox.caliente, a>=600mm, enrol.4.75mm<=e<=10mm',10,'72','7219','721912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72191300','Lamin.aços inox.quente,  l>=600mm,  rolos,  3mm<=e<4.75mm','Hot-rolled stainl.steel, w>=600mm, rolls, 3mm<=t<4.75mm','Lam.aceros inox.caliente, a>=600mm, enrol.3mm<=e<4.75mm',10,'72','7219','721913');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72191400','Lamin.aços inox.quente, l>=600mm, rolos, e<3mm','Hot-rolled stainless steel, w>=600mm, rolls, t<3mm','Lam.aceros inox.caliente, a>=600mm, enrollados, e<3mm',10,'72','7219','721914');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72192100','Lamin.aços inox.quente, l>=600mm, n/enrol.e>10mm','Hot-rolled stainless steel, w>=600mm, n/coils, t>10mm','Lam.aceros inox.caliente, a>=600mm, s/enrollar, e>10mm',10,'72','7219','721921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72192200','Lamin.aços inox.quente,  l>=600mm,  n/enrol.4.75mm<=e<=10mm','Hot-rolled stain.steel, w>=600mm, n/coils 4.75mm<=t<=10mm','Lam.aceros inox.calien.a>=600mm, s/enrol.4.75mm<=e<=10mm',10,'72','7219','721922');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72192300','Lamin.aços inox.quente,  l>=600mm,  n/enrol.3mm<=e<4.75mm','Hot-rolled stain.steel, w>=600mm, n/coils 3mm<=t<4.75mm','Lam.aceros inox.caliente, a>=600mm, s/enrol.3mm<=e<4.75mm',10,'72','7219','721923');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72192400','Lamin.aços inox.quente, l>=600mm, e<3mm','Hot-rolled prod.of stainless steel, w>=600mm, t<3mm','Lamin.aceros inox.caliente, a>=600mm, e<3mm',10,'72','7219','721924');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72193100','Lamin.aços inox.a frio, l>=600mm, e>=4.75mm','Cold-rolled prod.of stainless steel, w>=600mm, t>=4.75mm','Lamin.aceros inox.en frío, a>=600mm, e>=4.75mm',10,'72','7219','721931');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72193200','Lamin.aços inox.a frio, l>=600mm, 3mm<=e<4.75mm','Cold-rolled stain.steel, w>=600mm, 3mm<=t<4.75mm','Lamin.aceros inox.en frío, a>=600mm, 3mm<=e<4.75mm',10,'72','7219','721932');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72193300','Lamin.aços inox.a frio, l>=600mm, 1mm<e<3mm','Cold-rolled prod.of stain.steel, w>=600mm, 1mm<t<3mm','Lamin.aceros inox.en frío, a>=600mm, 1mm<e<3mm',10,'72','7219','721933');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72193400','Lamin.aços inox.a frio, l>=600mm, 0.5mm<=e<=1mm','Cold-rolled prod.of stain.steel, w>=600mm, 0.5mm<=t<=1mm','Lamin.aceros inox.en frío, a>=600mm, 0.5mm<=e<=1mm',10,'72','7219','721934');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72193500','Lamin.aços inox.a frio, l>=600mm, e<0.5mm','Cold-rolled prod.of stain.steel, w>=600mm, t<0.5mm','Lamin.aceros inox.en frío, a>=600mm, e<0.5mm',10,'72','7219','721935');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72199010','Outros lamin.aços inox.l>=600mm,  e<4.75mm,  dureza>=42hrc','Oth.rolled stain.steel, w>=600mm, t<4.75mm, hardn.>=42hrc','Ots.lamin.aceros inox.a>=600mm, e<4.75mm, dureza>=42hrc',10,'72','7219','721990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72199090','Outros lamin.aços inox.l>=600mm','Other rolled stainless steel, w>=600mm','Ots.lamin.aceros inoxidables, a>=600mm',10,'72','7219','721990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72201100','Lamin.aços inox.quente, l<600mm, e>=4.75mm','Hot-rolled stainless steel, w<600mm, t>=4.75mm','Lamin.aceros inoxidables, caliente, a<600mm, e>=4.75mm',10,'72','7220','722011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72201210','Lamin.aços inox.quente, l<600mm, e<=1.5mm','Hot-rolled stainless steel, w<600mm, t<=1.5mm','Lamin.aceros inoxidables, caliente, a<600mm, e<=1.5mm',10,'72','7220','722012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72201220','Lamin.aços inox.quente, l<600mm, 1.5mm<e<=3mm','Hot-rolled stainless steel<600mm, 1.5mm<t<=3mm','Lamin.aceros inoxidables, caliente, a<600mm, 1.5mm<e<=3mm',10,'72','7220','722012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72201290','Outros lamin.aços inox.quente, l<600mm','Other hot-rolled stainless steel<600mm','Ots.lamin.aceros inoxidables, caliente, a<600mm',10,'72','7220','722012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72202010','Prods.lamin.planos de aços inox.a frio,  l<=23mm,  e<=0.1mm','Flat-rolled prod.stain.steel, cold-roll.w<=23mm, t<=0.1mm','Prods.lam.planos de aceros inox.frío, a<=23mm, e<=0.1mm',10,'72','7220','722020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72202090','Outros prods.lamin.planos de aços inox.a frio,  l<600mm','Oth.flat-rolled prod.stain.steel, cold-rolled, w<600mm','Ots.prods.lamin.planos de aceros inox.en frío, a<600mm',10,'72','7220','722020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72209000','Outros lamin.aços inox.l<600mm','Other rolled prod.of stainlless steel, w<600mm','Ots.lamin.de aceros inox., a<600mm',10,'72','7220','722090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72210000','Fio-máquina de aços inoxidáveis','Thread-machine of stainless steel','Alambrón de aceros inoxidables',10,'72','7221','722100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72221100','Barras de aços inox.lamin.etc.quente, sec.circular','Bars of stainless steel, hot-rolled, etc.circular section','Barras de aceros inox.lamin.etc, caliente, sec.circular',10,'72','7222','722211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72221910','Barras de aços inox.lamin.etc.quente,  sec.transv.retang.','Bars of stain.steel, hot-rolled, etc.rect.squar.cross-sec','Barras de aceros inox.lamin.etc, caliente, sec.trans.rect',10,'72','7222','722219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72221990','Outras barras de aços inoxidáveis,  lamin.etc.a quente','Other bars of stain.steel, hot-rolled, etc.','Ots.barras de aceros inox.lamin.etc, caliente',10,'72','7222','722219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72222000','Barras de aços inox.obtidas/completam.acabadas a frio','Bars of stainless steel, obtained/cold-finished','Barras de aceros inox.obten./acabadas en frío',10,'72','7222','722220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72223000','Outras barras de aços inoxidáveis','Other bars of stainless steel','Las demás barras de aceros inoxidables',10,'72','7222','722230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72224010','Perfis de aços inoxidáveis, altura>=80mm','Profiles of stainless steel, height>=80mm','Perfiles de aceros inoxidables, altura>=80mm',10,'72','7222','722240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72224090','Outros perfis de aços inoxidáveis','Other profiles of stainless steel','Ots.perfiles de aceros inoxidables',10,'72','7222','722240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72230000','Fios de aços inoxidáveis','Wire of stainless steel','Alambre de aceros inoxidables',10,'72','7223','722300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72241000','Outs.ligas de aços,  em lingotes e outs.formas primárias','Other alloy steel in ingots or other primary forms','Los demás aceros aleados, en ling.u ots.formas primarias',10,'72','7224','722410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72249000','Produtos semimanufaturados, de outras ligas de aços','Semi-manufactured products, of other alloy steel','Productos intermedios, de outros aceros aleados',10,'72','7224','722490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72251100','Lamin.ligas de aços ao silício,  l>=600mm,  graos orient.','Rolled alloy of silicon steel, w>=600mm, grain-oriented','Lam.de aceros alead.al silicio, a>=600mm, granos orient.',10,'72','7225','722511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72251900','Outros lamin.de ligas de aços ao silício, l>=600mm','Other rolled alloy steel silicon, w>=600mm','Ots.lamin.de aceros alead.al silicio, a>=600mm',10,'72','7225','722519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72252000','Lamin.ligas de aços de corte rapido, l>=600mm','Rolled produc.of alloy of high speed steel, w>=600mm','Lamin.de acero rápido, a>=600mm',10,'72','7225','722520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72253000','Lamin.de outras ligas aços,  quente,  l>=600mm,  rolos','Hot-rolled of oth.alloy steel, w>=600mm, in colis','Lamin.de los demás aceros, en calien.a>=600mm, enrollados',10,'72','7225','722530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72254010','Lamin.de outs.ligas aços,  quente,  l>=600mm,  n/enrol.e<=7mm','Hot-rolled of oth.alloy steel, w>=600mm, n/coils t<=7mm','Lamin.de los demás aceros, calien.a>=600mm, enrol.e<=7mm',10,'72','7225','722540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72254020','Laminados planos aço corte rápido l=>600mm','Flat-rolled of high-speed steel, width => 600 mm','Lamin. plana de acero rápido, anchura =>600mm',10,'72','7225','722540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72254090','Outros lamin.de outs.ligas aços,  quente,  l>=600mm,  n/enrol','Oth.hot-rolled of oth.alloy steel, w>=600mm, n/coils','Ots.lamin.de los demás aceros, calien.a>=600mm, s/enrol.',10,'72','7225','722540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72255000','Laminados de outras ligas aços, a frio, l>=600mm','Cold-rolled of other alloy steel, w>=600mm','Lamin.de los demás aceros aleados, en frío, a>=600mm',10,'72','7225','722550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72255010','Outs.lam.plan.frio aços corte ráp.l=>600mm','Other cold fat-rolled of high-speed steel, width => 600 mm','Otras lamin.planos de acero rápido,  em frío, anchura =>600mm',10,'72','7225','722550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72255090','Out.lam.plan.frio d/outs ligas aço l=>600mm','Other cold fat-rolled of other alloy steel, width => 600 mm','Otras lamin.planos de otros aceros aleados,  em frío, anchura =>600mm',10,'72','7225','722550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72259100','Lamin.de outras ligas aços,  l>=600mm,  galvan.eletrolit.','Rolled of other alloy steel, w>=600mm, electr.galvanized','Lam.de los demás aceros aleados, a>=600mm, cincados elect',10,'72','7225','722591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72259200','Lamin.de outras ligas aços,  l>=600mm,  galvan.por out.proc','Rolled of other alloy steel, w>=600mm, otherwise galvan.','Lam.de los demás acer.aleados, a>=600mm, cinc.de ot.modo',10,'72','7225','722592');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72259900','Outros lamin.de outros ligas aços, l>=600mm','Other rolled of other alloy steel, w>=600mm','Ots.lam.de los demás aceros aleados, a>=600mm',10,'72','7225','722599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72259910','Outros laminados planos aço corte rápido l=>600mm','Other flat-rolled of high-speed steel, width => 600 mm','Otras lamin. planos de acero rápido, anchura =>600mm',10,'72','7225','722599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72259990','Outs.prod.lam.planos de aço, largura >= 600mm','Other flat-rolled of steel, width => 600 mm','Otras lamin. planos de acero, anchura =>600mm',10,'72','7225','722599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72261100','Lamin.de ligas aços ao silício,  l<600mm,  graos orient.','Rolled of silicon alloy steel, w<600mm, grain-oriented','Lamin.de acero al silicio, a<600mm, de grano orientado',10,'72','7226','722611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72261900','Outros lamin.de ligas aços ao silício, l<600mm','Other rolled of silicon alloy steel, w<600mm','Los demás lamin.de acero al silicio, a<600mm',10,'72','7226','722619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72262010','Lamin.de ligas aços de corte rapido,  l<600mm,  1mm<=e<=4mm','Rolled of alloy of high-speed steel, w<600mm, 1mm<=t<=4mm','Lamin.de acero rápido, a<600mm, 1mm<=e<=4mm',10,'72','7226','722620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72262090','Outs.prods.lamin.de ligas aços de corte rapido,  l<600mm','Other rolled of alloy of high-speed steel, w<600mm','Los demás lamin.de acero rápido, a<600mm',10,'72','7226','722620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72269100','Laminados de outras ligas de aços, a quente, l<600mm','Hot-rolled of other alloy steel, w<600mm','Lamin.de los demás aceros aleados, en caliente, a<600mm',10,'72','7226','722691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72269200','Laminados de outras ligas de aços, a frio, l<600mm','Cold-rolled of other alloy steel, w<600mm','Lamin.de los demás aceros aleados, en frío, a<600mm',10,'72','7226','722692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72269300','Lamin.de outras ligas de aços,  l<600mm,  galvan.eletrolit.','Rolled of other alloy steel, w<600mm, electr.galvan.','Lamin.de los demás aceros aleados, a<600mm, cinc.elect.',10,'72','7226','722693');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72269400','Lamin.de outs.ligas de aços,  l<600mm,  galvan.por out.proc','Rolled of other alloy steel, w<600mm, otherw.galvan.','Lam.de los demás aceros aleados, a<600mm, cinc.de ot.modo',10,'72','7226','722694');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72269900','Outros laminados de outras ligas de aços, l<600mm','Other rolled of other alloy steel, w<600mm','Los demás lamin.de los demás aceros aleados, a<600mm',10,'72','7226','722699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72271000','Fio-máquina de ligas de aços de corte rápido','Thread-machine of alloy of high-speed steel','Alambrón de acero rápido',10,'72','7227','722710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72272000','Fio-máquina de ligas de aços silício-manganês','Thread-machine of alloy of silico-manganese steel','Alambrón de acero silicomanganoso',10,'72','7227','722720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72279000','Outros fio-máquinas de outras ligas de aços','Other thread-machine of other alloy steel','Los demás alambrones de los demás aceros aleados',10,'72','7227','722790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72281010','Barras de ligas aços de corte rapido,  lamin.etc.a quente','Bars of alloy of high-speed steel, hot-rolled, etc','Barras de acero rápido, lamin.etc.en caliente',10,'72','7228','722810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72281090','Outras barras de ligas aços de corte rápido','Other bars of alloys of high-speed steel','Las demás barras de acero rápido',10,'72','7228','722810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72282000','Barras de ligas de aços silício-manganês','Bars of alloy of silico-manganese steel','Barras de acero silicomanganoso',10,'72','7228','722820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72283000','Barras de outras ligas de aços, lamin.etc.a quente','Bars of other alloy steel, hot-rolled, etc.','Barras de los demás aceros aleados, lamin.etc.caliente',10,'72','7228','722830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72284000','Barras de outras ligas de aços, forjadas','Bars of other alloy steel, forged','Barras de los demás aceros aleados, forjadas',10,'72','7228','722840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72285000','Barras de outras ligas de aços,  obtidas/acabadas a frio','Bars of other alloy steel, obtained/cold-finished','Barras de los demás aceros aleados, obt/acabadas en frío',10,'72','7228','722850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72286000','Outras barras de outras ligas de aços','Other bars of other alloy steel','Las demás barras de los demás aceros aleados',10,'72','7228','722860');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72287000','Perfis de outras ligas de aços','Profiles of other alloy steel','Perfiles de los demás aceros aleados',10,'72','7228','722870');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72288000','Barras ocas de ligas de aços, para perfuração','Hollow drill bars of alloy steel','Barras huecas de aceros aleados, para perforación',10,'72','7228','722880');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72291000','Fios de ligas de aços de corte rápido','Wire of other alloy of high-speed steel','Alambre de acero rápido',10,'72','7229','722910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72292000','Fios de ligas de aços silício-manganês','Wire of other alloy of silico-manganese steel','Alambre de acero silicomanganoso',10,'72','7229','722920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('72299000','Fios de outras ligas de aços','Wire of other alloy steel','Alambre de los demás aceros aleados',10,'72','7229','722990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73011000','Estacas-pranchas de ferro ou aço','Sheet piling of iron or steel','Tablestacas de hierro o acero',10,'73','7301','730110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73012000','Perfis de ferro ou aço, obtidos por soldadura','Profiles of iron or steel, obtained by welded','Perfiles de hierro o acero, obtenidos por soldadura',10,'73','7301','730120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73021010','Trilhos de aço,  de peso linear super.ou igual 44.5 kg/m','Rails of steel, wighing 44.5 kg/m or more p/linear metre','Carriles de acero, de peso lineal super.o igual44.5 kg/m',10,'73','7302','730210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73021020','Trilhos de ferro fundido/ferro/aço,  67.5<=p<=68.5kg/m','Rails of cast iron/iron/steel, 67.5<=w<=68.5kg/m','Carriles de fundición/hierro/acero, 67.5<=p<=68.5kg/m',10,'73','7302','730210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73021090','Outs.trilhos de vias férreas, de ferro fundido/ferro/aço','Other rails of railway, of cast iron/iron/steel','Ots.carriles p/vías férreas, de fundición/hierro/acero',10,'73','7302','730210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73022000','Dormentes de ferro fundido, ferro ou aço','Sleepers of cast iron/iron/steel','Traviesas(durmientes), de fundición, hierro o acero',10,'73','7302','730220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73023000','Agulhas e outs.elem.cruzam/desvio,  de ferro fundido,  etc.','Switch blades and oth.crossing pieces, cast iron, etc','Agujas y ots.elem.p/cruze/cambio de vías, de fundic., etc',10,'73','7302','730230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73024000','Talas de juncao/placa apoio,  etc.de ferro fund/ferro/aço','Fish-plates/sole plates, etc.of cast iron/iron/steel','Bridas y placas de asiento, etc.de fundic./hierro/acero',10,'73','7302','730240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73029000','Outs.elementos de vias férreas,  de ferro fund/ferro/aço','Other railway elements, etc.of cast iron/iron/steel','Los demás elem.p/vías férreas, de fundic./hierro/acero',10,'73','7302','730290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73030000','Tubos e perfis ocos, de ferro fundido','Tubes, pipes and hollow profiles, of cast iron','Tubos y perfiles huecos, de fundición',10,'73','7303','730300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73041010','Tubos de aços inox.sem costura,  p/oleodutos/gasodutos','Pipe of stainless steel, seamless f/pipelines/gas pipel.','Tubos de aceros inox.s/costura, en oleoductos/gasoductos',10,'73','7304','730410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73041090','Outs.tubos de ferro/aço,  s/costura,  p/oleodutos/gasodutos','Oth.pipe of iron/steel, seamless f/pipelines/gas pip.','Ots.tubos de hier./acero, s/cost., oleoductos/gasoductos',10,'73','7304','730410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73041100','Tubos ocos aço inox.p/oleodutos/gasodutos','Hollow pipes of stainless steel, of a kind used for oil or gas pipelines','Tubos huecos de acero inoxidable, de los tipos utilizados en oleoductos o gasoductos ',10,'73','7304','730411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73041900','Outs tubos ocos fer/aço p/oleod./gasodut.','Other hollow pipes iron/steel, of a kind used for oil or gas pipelines','Otros tubos huecos de hierro o acero, de los tipos utilizados en oleoductos o gasoductos ',10,'73','7304','730419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73042110','Tubos de aços n/lig.s/cost.p/perfur.extrac.petróleo/gas','Drill pipe of n/alloy steel, seamless f/petr.gas extrat.','Tubos de aceros, s/alear n/cost., p/perfor/extrac.pet/gas',10,'73','7304','730421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73042190','Outs.tubos de ferro/aço,  s/cost.p/perf.extr.petróleo/gas','Ot.drill pipe of n/alloy steel, seaml.f/petr.gas extrat.','Ots.tubos de hierro, s/cost., p/perfor./extrac.petr./gas',10,'73','7304','730421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73042200','Tubos d/perf.d/aços inox.extr.d/petrol./gás','Drill pipes of stainless steel, of a kind used for drilling for oil or gas','Tubos de acero inoxidable, de los tipos utilizados para la extracción de petróleo o gas',10,'73','7304','730422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73042310','Tubos d/perfuração s/cost.d/aços ñ ligados','Drill pipe, seamless, of non-alloy steel','Tubos de perforación, sin soldadura, de acero sin alear',10,'73','7304','730423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73042390','Outs.tubos d/perfuração s/cost.d/ferro,  aço','Other drill pipe, seamless, of iron or steel','Otros tubos de perforación, sin soldadura, de hierro o acero',10,'73','7304','730423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73042400','Outs.tub.util.ext.petrol.d/aços-inoxidáveis','Other pipes of stainless steel, of a kind used for drilling for oil','Otros tubos de acero inoxidable, de los tipos utilizados para la extracción de petróleo',10,'73','7304','730424');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73042910','Tubos de aços n/lig.s/cost.p/revestim.de pocos,  etc.','Pipes of n/alloy steel, seamless, f/coated of wells, etc','Tubos de aceros, s/alear n/cost., p/revestim.de pocos, etc',10,'73','7304','730429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73042920','Tubos de aços inox.s/cost.p/revestim.de pocos,  etc.','Pipes of stainless steel, seamless, f/coated of wells, etc','Tubos de aceros inox., s/cost., p/revestim.de pocos, etc',10,'73','7304','730429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73042931','Tubos de ligas aços,  s/cost.p/revest.pocos,  etc.d<=229mm','Pipes of alloy steel, seam.f/coated of well, etc, d<=229mm','Tubos de acer.alead.s/cost.p/rev.de pocos, etc, d<=229mm',10,'73','7304','730429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73042939','Outros tubos ligas aços,  n/rev.s/cost.p/revest.pocos,  etc','Ot.pipes of alloy steel, n/coat.seam.f/coat.of wells, etc','Tubos de acer.alead.s/revest.n/cost.p/revest.pocos, etc',10,'73','7304','730429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73042990','Outs.tubos ferro fund/ferro/aço,  s/cost.p/rev.pocos,  etc.','Ot.pipes of cast iron/iron/steel, seam.f/coat.wells, etc','Ots.tubos de fund./hier./acero, s/cost.p/reves.pocos, etc',10,'73','7304','730429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73043110','Tubos de ferro/aço n/lig.s/cost.sec.circ.lam.frio,  n/rev','Pipes iron/steel/n/alloy, seam.circ.cr.sec.cold-rol.n/co','Tubos hier./acer.s/alear n/cost.sec.circ.lam.frío, s/rev',10,'73','7304','730431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73043190','Outs.tubos de ferro/aço n/lig.s/cost.sec.circ.lam.frio','Oth.pipes iron/steel/n/alloy, seam.circ.cr.sec.cold-rol.','Ots.tubos hier./acer.s/alear n/cost.sec.circ.lam.frío',10,'73','7304','730431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73043910','Tubos de ferro/aço n/lig.s/cost.sec.circ.n/rev.d<=229mm','Pip.ir/st/n/al.seam.circ.cr.sec.cold-rol.n/co.d<=229mm','Tubos hier./acer.s/alear n/cost.sec.circ.s/rev.d<=229mm',10,'73','7304','730439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73043920','Tubos de ferro/aço n/lig.s/cost.sec.circ.rev.d<=229mm','Pip.iron/steel/n/al.seam.circ.cr.sec.n/coated, d<=229mm','Tubos hier./acer.s/alear n/cost.sec.circ.rev.d<=229mm',10,'73','7304','730439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73043990','Outros tubos de ferro/aço n/lig.s/cost.sec.circ.','Oth.pipes of iron/steel/n/alloy, seam.circ.cross-section','Ots.tubos hierro/acero, s/alear n/cost.sec.circ.',10,'73','7304','730439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73044100','Tubos de aços inox.s/cost.sec.circ.lamin.a frio','Pipes of stainless steel, seam.circ.cr.sec.cold-rol.','Tubos de aceros inoxid.s/costura, sec.circ.lamin.en frío',10,'73','7304','730441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73044110','Tubos capilares diametro ext <= 3mm e diam int <= 0,2mm','Tubos capilares diametro ext <= 3mm e diam int <= 0,2mm','Tubos capilares diametro ext <= 3mm e diam int <= 0,2mm',10,'73','7304','730441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73044190','Outros tubos capilares estirados/laminados a frio','Outros tubos capilares estirados/laminados a frio','Outros tubos capilares estirados/laminados a frio',10,'73','7304','730441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73044900','Outros tubos de aços inox.s/cost.sec.circ.','Oth.pipes of stainless steel, seamles.circ.cross-section','Ots.tubos de aceros inoxid.s/costura, sec.circ.',10,'73','7304','730449');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73045110','Tubos outs.ligas aços,  s/cost.sec.circ.lam.frio,  d<=229mm','Pipes ot.alloy steel, seam.circ.cr.sec.cold-rol.d<=229mm','Tub.de los dem.acer.al.s/cost.sec.circ.lam.frí.d<=229mm',10,'73','7304','730451');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73045111','Tubos capilares diametro ext <= 3mm e diam int <= 0,2mm','Tubos capilares diametro ext <= 3mm e diam int <= 0,2mm','Tubos capilares diametro ext <= 3mm e diam int <= 0,2mm',10,'73','7304','730451');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73045119','Outros tubos de diametro ext <= 229 mm','Outros tubos de diametro ext <= 229 mm','Outros tubos de diametro ext <= 229 mm',10,'73','7304','730451');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73045190','Outs.tubos de outs.ligas aços,  s/cost.sec.circ.lam.frio','Oth.pipes oth.alloy steel, seam.circ.cross-sec.cold-rol.','Ots.tubos de los dem.acer.alea.s/cost.sec.circ.lam.frío',10,'73','7304','730451');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73045910','Outs.tubos de outs.ligas aços,  s/cost.sec.circ.d<=229mm','Oth.pipes ot.alloy steel, seam.circ.cross-sec.d<=229mm','Ots.tubos de los dem.acer.alea.s/cost.sec.circ.d<=229mm',10,'73','7304','730459');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73045911','Tubos de out.liga aço,  s/cost.sec.circ.d<=229mm,  c>=0,  98%','Pipes ot.alloy steel, seamless, of circular cross-section.d<=229mm, c>=0,98%','Tubos de otros aceros aleados.s/cost.sec.circ.d<=229mm, c>=0,98%',10,'73','7304','730459');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73045919','Outs.tubos de outs.ligas aços,   s/cost.sec.circ.d<=229mm','Other pipes of other alloy steel, seamless, of circular cross-section.d<=229mm','Otros tubos de otros aceros aleados.s/cost.sec.circ.d<=229mm',10,'73','7304','730459');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73045990','Outros tubos de outras ligas aços,  s/cost.sec.circ.','Oth.pipes oth.alloy steel, seamless, circul.cross-section','Ots.tubos de los demás aceros aleados, s/cost.sec.circ.',10,'73','7304','730459');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73049011','Outros tubos/perfis ocos, de aços inox.s/cost.d<=229mm','Oth.pipes/hollow profiles, stainless steel, seam.d<=229mm','Ots.tubos/perfiles huecos, de acero inox.s/cost.d<=229mm',10,'73','7304','730490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73049019','Outros tubos/perfis ocos, de ferro/aço,  s/cost.d<=229mm','Oth.pipes/hollow profiles, of iron/steel, seam.d<=229mm','Ots.tubos/perf.huecos, de hierro/acero, s/cost.d<=229mm',10,'73','7304','730490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73049090','Outros tubos/perfis ocos, de ferro/aço, sem costura','Oth.pipes/hollow profiles, of iron/steel, seamless','Ots.tubos/perfiles huecos, de hierro/acero, s/cost.',10,'73','7304','730490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73051100','Tubos ferro/aço,  sold.long.arco,  sec.circ.d>406mm,  p/oleod','Pipes iron/steel, lon.sub.arc wel.cir.cr.d>406mm, f/pipel','Tubos hier./ac., sold.long.arco, sec.circ.d>406mm, p/oleod',10,'73','7305','730511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73051200','Outs.tubos ferro/aço,  sold.long.sec.circ.d>406mm,  p/oleod','Ot.pip.iron/st.lon.sub.arc wel.cir.cr.d>406mm, f/pipel','Ots.tub.hier.ac.sold.long.arco, sec.circ.d>406mm, p/oleod',10,'73','7305','730512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73051900','Outs.tubos ferro/aço,  sold.etc.sec.circ.d>406mm,  p/oleod.','Oth.pipes iron/steel, welded, etc.cir.cr.d>406mm, f/pipel','Ots.tubos hier./acero, sold.etc, sec.circ.d>406mm, p/oleod',10,'73','7305','730519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73052000','Tubos ferro/aço,  sold.etc.sec.circ.d>406mm,  p/rev.pocos','Pipes iron/steel, welded, etc.cir.cr.d>406mm, f/coat.well','Tubos hier./acero, sold.etc, sec.circ.d>406mm, p/rev.pocos',10,'73','7305','730520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73053100','Outros tubos ferro/aço, sold.longit.sec.circ.d>406mm','Oth.pipes iron/steel, weld.circ.cross-section d>406mm','Ots.tubos hier./acero, sold.long.sec.circ.d>406mm',10,'73','7305','730531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73053900','Outros tubos ferro/aço, sold.sec.circ.d>406mm','Oth.pipes iron/steel, weld.circ.cross-section d>406mm','Ots.tubos hierro/acero, sold.sec.circ.d>406mm',10,'73','7305','730539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73059000','Outros tubos ferro/aço, rebitados, sec.circ.d>406mm','Oth.pipes iron/steel, riveted, circ.cross-section d>406mm','Ots.tubos hierro/acero, remachados, sec.circ.d>406mm',10,'73','7305','730590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73061000','Tubos ferro/aço,  sold/rebitad/agrafad.p/oleoduto/gasod.','Pipes iron/steel, weld/rivet/similar/pipeline/gas pipel.','Tubos hierro/acero, remachados, grapado, en oleod./gasod.',10,'73','7306','730610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73061100','Tubos ferro/aço utiliz.p/oleod./gasodutos','Pipes iron/steel, of a kind used for oil or gas pipelines','Tubos hierro/acero, de los tipos utilizados en oleoductos o gasoductos ',10,'73','7306','730611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73061900','Outs.tubos d/tipos utiliz.em oleodutos/gasodutos','Other pipes of a kind used for oil or gas pipelines','Otros tubos de los tipos utilizados en oleoductos o gasoductos ',10,'73','7306','730619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73062000','Tubos ferro/aço,  sold/rebitad/agrafad.p/revest.pocos,  etc','Pipes iron/steel, weld/rivet/similar/f/coat.weels, etc','Tubos hierro/acero, sold.remach.grap.p/reves.pocos, etc',10,'73','7306','730620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73062100','Tub.fer/aço p/poç.supr.prod.extr.petról/gás','Pipes iron/steel for casing and tubing of a kind used in drilling for oil or gas ','Tubos hierro/acero, de entubación o de producción, de los tipos utilizados para la extracción de petróleo o gas',10,'73','7306','730621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73062900','Outs.tub.fer/aço p/poç.supr.prod.extr.petr/gás','Other pipes iron/steel for casing and tubing of a kind used in drilling for oil or gas ','Otros tubos hierro/acero, de entubación o de producción, de los tipos utilizados para la extracción de petróleo o gas',10,'73','7306','730629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73063000','Outros tubos de ferro/aço n/lig.sold.sec.circ.','Oth.pipes of iron/steel, n/alloy, welded cir.cross-sect.','Otros tubos de hierro/acero s/alear, sold.sec.circ.',10,'73','7306','730630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73064000','Outros tubos de aços inox.sold.sec.circ.','Oth.pipes of stainless steel, welded cir.cross-section','Otros tubos de aceros inox.sold.sec.circ.',10,'73','7306','730640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73065000','Outros tubos de outros ligas aços,  sold.etc.sec.circ.','Oth.pipes of oth.alloy steel, welded, etc.circ.cross-sec.','Ots.tubos de los demás aceros aleados, sold.etc.sec.circ',10,'73','7306','730650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73066000','Outros tubos de ferro/aço,  sold.sec.n/circ.','Other pipes of iron/steel, welded, n/circular','Otros tubos de hierro/acero, sold.excep.sec.circ.',10,'73','7306','730660');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73066100','Outs.tubos sold.d/seção quadrada/retangular','Other welded pipes, of square or rectangular cross-section','Otros tubos soldados, de sección cuadrada o rectangular',10,'73','7306','730661');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73066900','Outros tubos soldados de seção não circular','Other welded pipes, of non-circular cross-section','Otros tubos soldados, de sección no circular',10,'73','7306','730669');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73069010','Outros tubos e perfis ocos, de ferro/aço n/lig.sold.etc.','Oth.pipes and hollow, of iron/steel, n/alloy, welded, etc.','Ots.tubos/perfiles huecos, de hier./acero, s/ale.sold.etc',10,'73','7306','730690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73069020','Outs.tubos e perfis ocos, de aços inox.sold/rebitad.etc.','Oth.pipes and hollow, stainl.steel, welded/riveted, etc.','Ots.tubos/perfiles huecos, de acero inox.sold/remach.etc',10,'73','7306','730690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73069090','Outs.tubos e perfis ocos,  de ferro/aço,  sold/rebitad.etc.','Oth.pipes and hollow, stainl.steel, welded/riveted, etc.','Ots.tubos y perfiles huecos, de acero, sold/remach.etc',10,'73','7306','730690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73071100','Acessórios moldados para tubos de ferro fundido não maleável','Moulded fittings f/pipes of non-malleable cast iron','Accesorios moldeados de tubería de fund.n/maleab.',10,'73','7307','730711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73071910','Acessórios moldados p/tubos de ferro fund.maleav.d>50mm','Moulded fittings f/pipes of malleab.cast iron d>50mm','Accesorios moldeados de tubería de fund.n/maleab.d>50mm',10,'73','7307','730719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73071920','Acessórios moldados para tubos de aço','Moulded fittings f/pipes of steel','Accesorios moldeados de tubería de acero',10,'73','7307','730719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73071990','Outros acessórios para tubos moldados de ferro fundido, etc','Oth.mould.fittings f/pipes of malleable cast iron, etc.','Ots.accesorios moldeados de tubería de fundición, etc',10,'73','7307','730719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73072100','Flanges para tubos, de aços inoxidáveis','Flanges for pipes of stainless steel','Bridas de tubería, de aceros inoxidables',10,'73','7307','730721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73072200','Cotovelos,  curvas e luvas,  roscados,  p/tubos,  de aços inox.','Threaded elbows, bends and sleeves, f/pipes, stain.steel','Codos, curvas y manguitos, roscados, de tub., de acer.inox.',10,'73','7307','730722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73072300','Acessórios para soldar topo a topo, tubos de aços inoxidável','Threaded elbows, bends and sleeves, f/pipes, stain.steel','Accesorios para soldar a tope, tubos de aceros inox.',10,'73','7307','730723');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73072900','Outros acessórios para tubos, de aços inoxidáveis','Other tube or pipe fittings, of stainless steel','Otros accesorios de tubería, de aceros inoxidables',10,'73','7307','730729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73079100','Outras flanges p/tubos, de ferro fundido/ferro ou aço','Other flanges f/pipes, cast iron/iron or steel','Otras bridas de tubería, de fundición/hierro o acero',10,'73','7307','730791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73079200','Outs.cotovelos,  curvas,  etc.roscados,  p/tubos de ferro/aço','Other threaded elbows, bends, etc.f/pipes of iron/steel','Ots.codos, curvas, etc, roscados, de tub.de hierro/acero',10,'73','7307','730792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73079300','Outros acessórios p/soldar topo/topo,  tubos de ferro/aço','Other butt welding fittings, pipes of iron/steel','Otros accesorios p/soldar a tope, tubos de hierro/acero',10,'73','7307','730793');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73079900','Outros acessórios p/tubos de ferro fundido,  ferro ou aço','Other fittings f/pipes of cast iron, iron or steel','Otros accesorios p/tubería de fundición, hierro o acero',10,'73','7307','730799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73081000','Pontes e elementos de pontes,  de ferro fundido/ferro/aço','Bridges and bridge-sections, of cast iron/iron/steel','Puentes y elementos de puentes, de fundic./hierro/acero',10,'73','7308','730810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73082000','Torres e pórticos, de ferro fundido, ferro ou aço','Towers and lattice masts, of cast iron/iron/steel','Torres y castilletes, de fundición, hierro o acero',10,'73','7308','730820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73083000','Portas e janelas,  etc.de ferro fundido,  ferro ou aço','Doors, windows, etc.of cast iron/iron/steel','Puertas y ventanas, etc.de fundición, hierro o acero',10,'73','7308','730830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73084000','Material p/andaimes,  armações,  etc.ferro fund/ferro/aço','Equipm.f/scaffolding, frames, etc.fused iron/iron/steel','Material p/andamiaje, armazones, etc.fund/hierro/acero',10,'73','7308','730840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73089010','Chapas,  barras,  etc.p/construções,  de ferro fund/ferro/aço','Foils, bars, etc.f/structures, of fused iron/iron/steel','Chapas, barras, etc.p/construcción, de fund/hierro/acero',10,'73','7308','730890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73089090','Outs.construções e suas partes,  de ferro fund/ferro/aço','Oth.structures and their parts, of fused iron/iron/steel','Ots.construcciones y sus partes, de fund/hierro/acero',10,'73','7308','730890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73090010','Reservatórios,  etc.ferro/aço,  c>300l,  p/armaz.graos,  solid.','Reservoirs, etc.iron/steel, cap>300l, f/grains, solid stor.','Depósitos, etc.hierro/acero, c>300l, p/almac.granos, solid.',10,'73','7309','730900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73090020','Recip.isotermico refrig.nitrog.liq.p/semen,  etc.cap>300l','Isotherm.contain.cool.liqu.nitrog.f/semen, etc.cap>300l','Recip.isotérmico refrig.nitróg.líq.p/semen, etc.cap>300l',10,'73','7309','730900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73090090','Outs.reservatórios,  etc.de ferro/aço,  c>300l,  s/disp.term.','Oth.reservoirs, etc.iron/steel, c>300l, without ther.equip','Ots.depósitos, etc.de hierro/acero, c>300l, s/disp.térm.',10,'73','7309','730900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73101000','Reservatórios,  etc.de ferro/aço,  50<=c<=300l,  s/disp.term.','Reserv.etc.iron/steel, 50<=c<=300l, without ther.equip','Depósitos, etc.de hierro/acero, 50<=c<=300l, s/disp.térm.',10,'73','7310','731010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73101010','Recip.isoterm.refrig.nitrog.liq.50l<=cap<=300l,  p/semen,  ','Isothermic cont.cooled liq.nitr.50l<=cap<=300l, f/semen, ','Recip.isotérm.refrig.nitróg.líq.50l<=cap<=300l, p/semen, ',10,'73','7310','731010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73101090','Outs.reservat.de ferro/aço,  50l<=cap<=300l,  s/disp.term.','Oth.tanks of iron/steel, 50l<=c<=300l, n/thermal disp.','Ots.depósitos de hierro/acero, 50l<=c<=300l, s/disp.térm.',10,'73','7310','731010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73102110','Latas de ferro/aço, fecham.p/sold.crav.c<50l,  p/prod.alim','Cans of iron/steel, closed sold.crimp.c<50l, f/food prod','Latas de hier./acero, p/cer.p/sold.reb.c<50l, p/prod.alim',10,'73','7310','731021');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73102190','Outras latas de ferro/aço, echam.p/sold.crav.c<50l','Oth.cans of iron/steel, closed f/sold.crimp.c<50l','Ots.latas de hier./acero, p/cer.p/sold.reb.c<50l',10,'73','7310','731021');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73102910','Outs.reservatórios,  etc.de ferro/aço,  c<50l,  p/prods.alim.','Other tanks, etc.of iron/steel, c<50l, f/food production','Ots.depósitos, etc.de hierro/acero, c<50l, p/prods.alim.',10,'73','7310','731029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73102920','Recip.isoterm.refrig.nitrogênio liq.cap<50l,  p/semen,  etc','Isothermic cont.cooled liq.nitr.cap<50l, f/semen, etc','Recip.isotérm.refrig.nitrógeno líq.cap<50l, p/semen, etc',10,'73','7310','731029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73102990','Outros reservatórios, etc.de ferro/aço, c<50l','Other tanks, etc.of iron/steel, c<50l','Otros depósitos, etc.de hierro/acero, c<50l',10,'73','7310','731029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73110000','Recipientes de ferro/aço,  p/gases comprimidos/liquefeit.','Containers f/compressed/liquefied gas, of iron/steel','Recipientes de hierro/acero, p/gas comprimido/licuado',10,'73','7311','731100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73121010','Cordas e cabos, de fios aço, revest.bronze/latão, p/eletr.','Ropes and cables, of steel wire, bronze/brass coat.f/elec','Cables, de alambres acero, revest.bronce/latón, p/electr.',10,'73','7312','731210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73121090','Outras cordas e cabos,  de ferro/aço,  n/isol.p/uso eletr.','Oth.ropes and cables, of iron/steel, insulat.f/electric','Ots.cables, de hierro/acero, s/aislar p/electr.',10,'73','7312','731210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73129000','Trancas/lingas,  etc.de ferro/aço,  n/isol.p/uso eletr.','Plaited bands/slings, etc.of iron/steel, insulat.f/elect.','Trenzas/eslingas, etc.de hierro/acero, s/aislar p/electr.',10,'73','7312','731290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73130000','Arame farpado e outros de ferro ou aço,  util.em cercas','Barbed wire of other iron or steel, used f/fencing','Alambre de púas y otros de hierro o acero, util.p/cercar',10,'73','7313','731300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73141200','Tela metálica tecida,  de aços inox.continua,  s/fim.p/maqs','Woven cloth, of stainless steel, endless bands f/machin.','Tela metálica tejida, de acer.inox.continua, s/fin.p/maqs',10,'73','7314','731412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73141300','Outs.telas metal.tecid.de ferro/aço,  contin.s/fim,  p/maqs','Oth.woven cloth, of iron/steel, endless bands f/machin.','Ots.telas met.tejidas, de hierro/acer.cont., s/fin.p/maqs',10,'73','7314','731413');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73141400','Outras telas metal.tecid.de aços inoxidáveis','Other woven cloth, of stainless steel','Ots.telas metálicas tejidas, de acero inoxidable',10,'73','7314','731414');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73141900','Outras telas metal.tecid.de ferro ou aço','Other woven cloth, of iron or steel','Ots.telas metálicas tejidas, de acero inoxidable',10,'73','7314','731419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73142000','Grades/redes,  de fios ferro/aço,  sold.pto.inters.s>=100m2','Grill/netting, of iron/steel wire, weld.intersec.s>=100m2','Redes/rejas, de alamb.hier/acero, sold.pto.cruce.s>=100m2',10,'73','7314','731420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73143100','Grades/redes,  de fios ferro/aço,  sold.pto.inters.galvan.','Grill/netting, of iron/steel wire, weld.intersec.galvanis','Redes/rejas, de alamb.hier/acero, sold.pto.cruce, cinc.',10,'73','7314','731431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73143900','Outras grades/redes,  de fios ferro/aço,  sold.pto.intersec','Oth.grill/netting, of iron/steel wire, weld.intersection','Ots.redes/rejas, de alamb.hier./acero, sold.pto.cruce',10,'73','7314','731439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73144100','Outras telas metals.etc.de fios ferro/aço, galvanizada','Other woven cloth, etc.of iron/steel wire, galvanised','Otras telas metál.etc.de alambre hierro/acero, cinc.',10,'73','7314','731441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73144200','Outs.telas metals.etc.de fios ferro/aço,  recob.plásticos','Other woven cloth, etc.of iron/steel wire, cover.plastics','Ots.telas metál.etc.de alambre hierro/acero, rev.plást.',10,'73','7314','731442');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73144900','Outras telas metals.etc.de fios ferro/aço','Other woven cloth, etc.of iron/steel wire','Otras telas metál.etc.de alambre hierro/acero',10,'73','7314','731449');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73145000','Chapas e tiras, distendidas, de ferro/aço','Foils and strips, expand.metal of iron/steel','Chapas y tiras, extendidas, de hierro/acero',10,'73','7314','731450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73151100','Corrente de rolos, de ferro fundido, ferro ou aço','Roller chain, of cast iron, iron/steel','Cadena de rodillos, de fundición, hierro o acero',10,'73','7315','731511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73151210','Corrente de transmissão,  de ferro fundido,  ferro ou aço','Transmission chain, of cast iron, iron or steel','Cadena de transmisión, de fundición, hierro o acero',10,'73','7315','731512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73151290','Outras correntes de elos articulados,  de ferro ou aço','Oth.articulate links chain, iron or steel','Otras cadenas de elos articulados, de hierro o acero',10,'73','7315','731512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73151900','Partes de correntes de elos articulados,  de ferro ou aço','Parts of articulate links chain, iron or steel','Partes de cadenas de eslabones artic.de hierro o acero',10,'73','7315','731519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73152000','Correntes antiderrapantes,  de ferro fundido,  ferro ou aço','Skid chain, of cast iron, iron or steel','Cadenas antideslizantes, de fundición, hierro o acero',10,'73','7315','731520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73158100','Correntes de elos com suporte, de ferro fundido/ferro/aço','Stud-link chain, of cast iron, iron or steel','Cadenas de eslabones c/travesaño, de fundic/hierro/acero',10,'73','7315','731581');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73158200','Correntes de elos soldados, de ferro fundido/ferro/aço','Welded link chain, of cast iron, iron or steel','Cadenas de eslabones soldados, de fundición/hierro/acero',10,'73','7315','731582');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73158900','Outras correntes e cadeias, de ferro fundido/ferro/aço','Other chains, of cast iron, iron/steel','Las demás cadenas, de fundición/hierro/acero',10,'73','7315','731589');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73159000','Partes de outras correntes e cadeias, de ferro ou aço','Parts of other chains, of iron/steel','Partes de otras cadenas, de hierro o acero',10,'73','7315','731590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73160000','Âncoras e fateixas e suas partes, de ferro fundido,  etc.','Anchors, grapnels and parts thereof, of cast iron, etc.','Anclas y rezones y sus partes, de fundición, etc',10,'73','7316','731600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73170010','Tachas de ferro fundido/ferro/aço,  incl.cabeça out.mater','Tack nails, of cast iron/iron/steel, incl.heads oth.mater','Chinchetas de fundic/hierro/acero, incl.cabeza ot.mater.',10,'73','7317','731700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73170020','Grampos de fio curvado, de ferro fundido, ferro ou aço','Curved wire staples, of cast iron, iron or steel','Grapas de alambre curvado, de fundición, hierro o acero',10,'73','7317','731700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73170030','Pontas ou dentes,  de ferro fund/ferro/aço,  p/maqs.têxteis','Carding tacks, of cast iron/iron/steel, f/tex.car.machin.','Puntas o dientes, de fund/hierro/acero, p/máqs.textiles',10,'73','7317','731700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73170090','Pregos,  percevejos,  artefs.semelh.de ferro fund/ferro/aço','Nails, thumb-tacks, similar articles, cast iron/iron/steel','Clavos, chinchetas, artícs.simil.de fund/hierro/acero',10,'73','7317','731700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73181100','Tira-fundos (roscados), de ferro fundido, ferro ou aço','Coach screws, cast iron/iron/steel','Tirafondos (roscados), de fundición, hierro o acero',10,'73','7318','731811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73181200','Outros parafusos de ferro fundido/ferro/aço, para madeira','Other wood screws, of cast iron/iron/steel','Los demás tornillos de fundición/hierro/acero, p/madera',10,'73','7318','731812');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73181300','Ganchos e armelas (pitoes), de ferro fundido/ferro/aço','Hooks and rings, of cast iron/iron/steel','Escarpias y armellas, de fundición/hierro/acero',10,'73','7318','731813');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73181400','Parafusos perfurantes, de ferro fundido,  ferro ou aço','Self-tapping screws, of cast iron, iron or steel','Tornillos taladradores, de fundición, hierro o acero',10,'73','7318','731814');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73181500','Outs.parafusos/pinos/pernos, de ferro fundido/ferro/aço','Other screws/bolts/nuts, of cast iron/iron/steel','Los demás tornillos/pernos, de fundición/hierro/acero',10,'73','7318','731815');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73181600','Porcas de ferro fundido, ferro ou aço','Nuts, of cast iron, iron or steel','Tuercas de fundición, hierro o acero',10,'73','7318','731816');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73181900','Outros artefatos roscados,  de ferro fundido,  ferro ou aço','Other threaded articles, of cast iron, iron or steel','Los demás artículos roscados, de fundición, hierro, acero',10,'73','7318','731819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73182100','Arruelas de pressão ou segurança, de ferro fundido, etc.','Pressure or safety washers, of cast iron, etc','Arandelas de muelle y de seguridad, de fundición, etc',10,'73','7318','731821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73182200','Outras arruelas de ferro fundido, ferro ou aço','Other iron washers, of cast iron, iron/steel','Las demás arandelas de fundición, hierro o acero',10,'73','7318','731822');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73182300','Rebites de ferro fundido, ferro ou aço','Rivets of cast iron, iron or steel','Remaches de fundición, hierro o acero',10,'73','7318','731823');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73182400','Chavetas/cavilhas, etc.de ferro fundido, ferro ou aço','Cotters/cotter-pins, etc.of cast iron, iron or steel','Pasadores/clavijas, etc.de fundición, hierro o acero',10,'73','7318','731824');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73182900','Outros artefatos n/roscados, de ferro fundido/ferro/aço','Other non-threaded articles, of cast iron/iron/steel','Los demás artículos s/roscar, de fundición/hierro/acero',10,'73','7318','731829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73191000','Agulhas de costura, cerzir ou bordar, de ferro ou aço','Sewing, darning or embroidery needles, of iron or steel','Agujas de coser, zurcir o bordar, de hierro o acero',10,'73','7319','731910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73192000','Alfinetes de segurança, de ferro ou aço','Safety pins, of iron or steel','Alfileres de gancho, de hierro o acero',10,'73','7319','731920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73193000','Outros alfinetes de uso manual, de ferro ou aço','Oth.pins for use in the hand, of iron or steel','Los demás alfileres de uso manual, de hierro o acero',10,'73','7319','731930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73194000','Alfinetes de seguranca e outros alfinetes','Safety pins and other pins','Imperdibles y otros alfileres',10,'73','7319','731940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73199000','Outras agulhas/artefatos semelh.uso manual,  de ferro/aço','Ot.needles/similar articl.f/use in the hand, iron/steel','Las demás agujas/artíc.simil.uso man., de hierro/acero',10,'73','7319','731990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73201000','Molas de folhas e suas folhas, de ferro ou aço','Leaf-springs and leaves therefor, of iron or steel','Ballestas y sus hojas, de hierro o acero',10,'73','7320','732010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73202010','Molas helicoidais cilíndricas, de ferro ou aço','Cylindrical helical springs, of iron or steel','Muelles helicoidales cilíndricas, de hierro o acero',10,'73','7320','732020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73202090','Outras molas helicoidais de ferro ou aço','Other helical springs, of iron or steel','Los demás muelles helicoidales, de hierro o acero',10,'73','7320','732020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73209000','Outras molas de ferro ou aço','Other springs of iron or steel','Los demás muelles de hierro o acero',10,'73','7320','732090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73211100','Aparelhos p/cozinhar/aquecer,  de ferro,  etc.combustiv.gas','Cooking/warmers appliances, of iron, etc.gaseous fuel','Aparatos p/cocción/calefac., de hierro, etc.combust.gas.',11,'73','7321','732111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73211200','Aparelhos p/cozinhar/aquecer,  de ferro,  etc.combustiv.liq','Cooking/warmers appliances, of iron, etc.liquid fuel','Aparatos p/cocción/calefac., de hierro, etc.combust.líq.',11,'73','7321','732112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73211300','Aparelhos p/cozinhar/aquecer,  de ferro,  etc.combustiv.sol','Cooking/warmers appliances, of iron, etc.solid fuels','Aparatos p/cocción/calefac., de hierro, etc.combust.sól.',11,'73','7321','732113');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73211900','Outs.ap.p/coz.e aquec.pratos a comb.sólidos','Other appliances for cooking and plate warmers, for solid fuels','Los demás aparatos de cocción y calientaplatos de combustibles sólidos',11,'73','7321','732119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73218100','Outros aquecedores,  etc.de ferro/aço,  a gas/outs.combust.','Other heaters, etc.of iron/steel, gas/oth.fuels','Los dem.calent.etc.de hierro/acero, de gas/ots.combust.',11,'73','7321','732181');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73218200','Outros aquecedores,  etc.de ferro/aço,  a combustiv.líquido','Other heaters, etc.of iron/steel, for liquid fuel','Los dem.calent.etc.de hierro/acero, de combust.líq.',11,'73','7321','732182');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73218300','Outros aquecedores,  etc.de ferro/aço,  a combustiv.sólidos','Other heaters, etc.of iron/steel, for solid fuels','Los dem.calent.etc.de hierro/acero, de combustib.sól',11,'73','7321','732183');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73218900','Outros aparelhos de combustível sólido','Other appliances of solid fuel','Los demás aparatos de combustible sólido',11,'73','7321','732189');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73219000','Partes de aparelhos p/cozinhar,  etc.de ferro/aço,  n/eletr','Parts of domestic appliances, etc.of iron/steel, n/electr','Partes de aparatos p/cocción, etc.de hierro/aceo, n/eléct',10,'73','7321','732190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73221100','Radiadores p/aquec.central, n/eletr.partes, de ferro fundido','Radiators for central heating, n/elec.parts, of cast iron','Radiadores p/la calef.central, n/eléctr.partes, de fund.',10,'73','7322','732211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73221900','Radiadores p/aquec.central,  n/eletr.partes,  de ferro/aço','Radiators f/central heating, n/elec.parts, of iron/steel','Radiadores p/la calef.central, n/eléct.partes, hier/acero',10,'73','7322','732219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73229000','Geradores,  etc.n/eletr.e partes,  de ferro fund/ferro/aço','Generators, etc, n/elec.parts of cast iron/iron/steel','Generadores, etc.n/eléctr.y partes, de fund/hierro/acero',10,'73','7322','732290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73229010','Geradores de ar quente a comb.liq.util.veic.automóveis','Generators of hot air for liq.fuel used in vehic.autom.','Generadores de aire caliente a comb.líq.util.veh.autom.',10,'73','7322','732290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73229090','Outs.geradores,  etc.n/eletr.de ferro fundido,  ferro,  aco','Oth.generators, etc.n/elec.cast iron, iron/steel','Ots.generadores, etc.n/eléctr.de fundición, hierro, acero',10,'73','7322','732290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73231000','Palhas,  esponjas,  etc.de ferro/aço,  p/limpeza/polimento','Wool, sponge, etc.of iron/steel, f/cleaning/polishing','Lanas, esponjas, etc.de hierro/acero, p/fregar/lustrar',10,'73','7323','732310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73239100','Outs.artefs.domésticos,  de ferro fund.n/esmalt.e partes','Other household articles, of cast iron, n/enamelled, parts','Ots.artícs.domésticos, de fund.s/esmalt.y partes',10,'73','7323','732391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73239200','Outs.artefs.domésticos,  de ferro fund.esmaltad.e partes','Other household articles, of cast iron, enamelled, parts','Ots.artícs.domésticos, de fund.esmalt.y partes',10,'73','7323','732392');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73239300','Outs.artefs.domésticos,  de aços inoxidáveis,  e partes','Other household articles, of stainless steel, and parts','Ots.artícs.domésticos, de aceros inoxidables, y partes',10,'73','7323','732393');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73239400','Outs.artefs.domésticos,  de ferro/aço,  esmaltados,  e partes','Other household articles, of iron/steel, enamelled, parts','Ots.artícs.domésticos, de hierro/acero, esmalt., y partes',10,'73','7323','732394');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73239900','Outs.artefs.domésticos,  de ferro fund/ferro/aço,  e partes','Other household articles, of cast iron/iron/steel, parts','Ots.artícs.domésticos, de fund/hierro/acero, y partes',10,'73','7323','732399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73241000','Pias e lavatórios, de aços inoxidáveis','Sinks and lavatories, of stainless steel','Fregaderos y lavabos, de aceros inoxidables',10,'73','7324','732410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73242100','Banheiras de ferro fundido, mesmo esmaltadas','Bathtubs of cast iron, whether/not enamelled','Bañeras de fundición, incluso esmaltadas',10,'73','7324','732421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73242900','Outras banheiras de ferro ou aço','Other bathtubs of iron or steel','Las demás bañeras de hierro y acero',10,'73','7324','732429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73249000','Outros artefs.de higiene/toucador,  de ferro/aço,  e partes','Oth.hygiene artic./personal toilet, of iron/steel, parts','Los dem.artícs.de higiene/toc., de hierro/acero, y partes',10,'73','7324','732490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73251000','Outras obras moldadas de ferro fundido, não maleável','Other moulded articles of non-malleable cast iron','Las demás manufact.moldeadas de fundición, no maleable',10,'73','7325','732510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73259100','Esferas, etc.moldadas, de ferro fund/ferro/aço, para moinhos','Grind.balls, etc.moulded, cast iron/iron/steel, f/mills','Bolas, etc.moldeadas, de fundición/hierro/acero, p/molinos',10,'73','7325','732591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73259910','Outras obras moldadas, de aço','Other moulded articles, of steel','Las demás manufacturas moldeadas, de acero',10,'73','7325','732599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73259990','Outras obras moldadas, de ferro fundido ou ferro','Other moulded articles, of cast iron or iron','Las demás manufacturas moldeadas, de fundición o hierro',10,'73','7325','732599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73261100','Esferas,  etc.forjadas/estampadas,  de ferro/aço,  p/moinhos','Grin.balls, etc.forged/stam.cast iron/iron/steel, f/mills','Bolas, etc.forjadas/estampadas, de hierro/acero, p/molinos',10,'73','7326','732611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73261900','Outras obras forjadas/estampadas, de ferro ou aço','Other forged/stamped articles, of iron or steel','Las demás manufac.forjadas/estampadas, de hierro o acero',10,'73','7326','732619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73262000','Obras de fios de ferro ou aço','Articles of iron or steel wire','Manufacturas de alambre de hierro o acero',10,'73','7326','732620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73269000','Outras obras de ferro ou aço','Other articles of iron or steel wire','Las demás manufacturas de hierro o acero',10,'73','7326','732690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73269010','Calotas elipticas de aço ao níquel util.na fab.recip.','Elliptical steel with nickel hubcaps used to produce recipients','Calotas elípticas de acero al níquel, utilizadas para producir recipientes ',10,'73','7326','732690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('73269090','Outras obras de ferro ou aço','Other articles of iron or steel','Otros artículos de hierro o acero',10,'73','7326','732690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74010000','Mates d/cobre;cobre d/cement.(precip.d/cobre)','Copper mattes; cement copper (precipitated copper)','Matas de cobre; cobre de cementación (cobre precipitado)',10,'74','7401','740100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74011000','Mates de cobre','Copper mattes','Matas de cobre',10,'74','7401','740110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74012000','Cobre de cementacao (precipitado de cobre)','Cement copper (precipitated copper)','Cobre de cementación (cobre precipitado)',10,'74','7401','740120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74020000','Cobre n/refinado e anodos de cobre p/refin.eletrolitica','Unrefined copper  and anodes cop.f/electr.refining','Cobre s/refinar y ánodos de cobre p/refin.electrolítico',10,'74','7402','740200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74031100','Catodos de cobre refinado/seus elementos,  em forma bruta','Refined copper cathodes/its sections, unwrought','Cátodos de cobre refinado/sus secciones, en bruto','21','74','7403','740311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74031200','Barras de cobre refinado,  p/obtenção fios,  em forma bruta','Refined copper in bars, for obtaining wire, unwrought','Barras de cobre refinado, p/alambrón, en bruto','21','74','7403','740312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74031300','Palanquilhas de cobre refinado, em forma bruta','Billets of refined copper, unwrought','Tochos de cobre refinado, en bruto','21','74','7403','740313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74031900','Outros produtos de cobre refinado, em forma bruta','Other products of refined copper, unwrought','Los demás productos de cobre refinado, en bruto','21','74','7403','740319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74032100','Ligas de cobre-zinco (latão), em forma bruta','Copper-zinc base alloys (brass), unwrought','Aleaciones de cobre-cinc (latón), en bruto',10,'74','7403','740321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74032200','Ligas de cobre-estanho (bronze), em forma bruta','Copper-tin base alloys (bronze), unwrought','Aleaciones de cobre-estaño (bronce), en bruto',10,'74','7403','740322');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74032300','Ligas de cobre-niquel/cobre-niquel-zinco,  em forma bruta','Copper-nickel base alloys/copper-nickel-zinc, unwrought','Aleaciones de cobre-níquel/cobre-níquel-cinc, en bruto',10,'74','7403','740323');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74032900','Outras ligas de cobre, em forma bruta','Other copper alloys, unwrought','Las demás aleaciones de cobre, en bruto',10,'74','7403','740329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74040000','Desperdícios e resíduos, de cobre','Copper waste and scrap','Desperdicios y desechos, de cobre',10,'74','7404','740400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74050000','Ligas-mães de cobre','Master alloys of copper','Aleaciones madre de cobre',10,'74','7405','740500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74061000','Pós de cobre, de estrutura não lamelar','Copper powders, of non-lamellar structure','Polvos de cobre, de estructura no laminar',10,'74','7406','740610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74062000','Pós de cobre, de estrutura lamelar e escamas de cobre','Copper powders and flakes, of non-lamellar structure','Polvos de cobre, de estruc.laminar y escamillas de cobre',10,'74','7406','740620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74071010','Barras de cobre refinado','Bars of refined copper','Barras de cobre refinado',10,'74','7407','740710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74071021','Perfis ocos de cobre refinado','Profiles hollow of refined copper','Perfiles huecos de cobre refinado',10,'74','7407','740710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74071029','Outros perfis de cobre refinado','Other profiles of refined copper','Los demás perfiles de cobre refinado',10,'74','7407','740710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74072110','Barras de ligas de cobre-zinco (latão)','Bars of copper-zinc base alloys (brass)','Barras de aleaciones de cobre-cinc (latón)',10,'74','7407','740721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74072120','Perfis de ligas de cobre-zinco (latão)','Profiles of copper-zinc base alloys (brass)','Perfiles de aleaciones de cobre-cinc (latón)',10,'74','7407','740721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74072210','Barras de ligas de cobre-níquel ou cobre-níquel-zinco','Bars of copper-nickel base alloys/copper-nickel-zinc','Barras de aleaciones de cobre-níquel/cobre-níquel-cinc',10,'74','7407','740722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74072220','Perfis de ligas de cobre-níquel ou cobre-níquel-zinco','Profiles of copper-nickel base alloys/cop.-nickel-zinc','Perfil.de aleaciones de cobre-níquel/cobre-níquel-cinc',10,'74','7407','740722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74072910','Outras barras de cobre','Other copper bars','Las demás barras de cobre',10,'74','7407','740729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74072921','Outros perfis ocos de cobre','Other profiles hollow of refined copper','Los demás perfiles huecos de cobre',10,'74','7407','740729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74072929','Outros perfis de cobre','Other profiles of copper','Los demás perfiles de cobre',10,'74','7407','740729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74081100','Fios de cobre refinado, maior dimensão da sec.transv>6mm','Refined copper wire, max.cross-sectional dimension>6mm','Alambre de cobre refin.c/mayor dimens.de sec.transv>6mm',10,'74','7408','740811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74081900','Outros fios de cobre refinado','Other refined copper wire','Los demás alambres de cobre refinado',10,'74','7408','740819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74082100','Fios de ligas de cobre-zinco (latão)','Wire of copper-zinc base alloys (brass)','Alambres de aleaciones de cobre-cinc (latón)',10,'74','7408','740821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74082200','Fios de ligas de cobre-niquel ou cobre-niquel-zinco','Wire of copper-nickel base alloys or copper-nickel-zinc','Alambres de aleacion.de cobre-níquel/cobre-níquel-cinc',10,'74','7408','740822');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74082911','Fios de ligas de cobre-estanho (bronze) fósforoso','Wire of copper-tin base alloys (bronze) phosphor','Alambres de aleaciones de cobre-estaño(bronce)fosforoso',10,'74','7408','740829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74082919','Outros fios de ligas de cobre-estanho (bronze)','Other wires of copper-tin base alloys (bronze)','Los demás alambres de aleacion.de cobre-estaño(bronce)',10,'74','7408','740829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74082990','Outros fios de ligas de cobre','Other wires of copper alloys','Los demás alambres de aleaciones de cobre',10,'74','7408','740829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74091100','Chapas e tiras, de cobre refinado, esp>0.15mm, em rolos','Plates, strips, of refined copper thickn>0.15mm, in coils','Chapas y tiras, de cobre refinado, esp>0.15mm, enrolladas',10,'74','7409','740911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74091900','Outras chapas e tiras, de cobre refinado, esp>0.15mm','Other plates, strips, of refined copper thickn>0.15mm','Las demás chapas y tiras, de cobre refinado, esp>0.15mm',10,'74','7409','740919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74092100','Chapas e tiras de ligas cobre-zinco, esp>0.15mm,  em rolos','Plates, strips, of copper-zinc alloys th>0.15mm, in coils','Chapas y tiras, de aleac.cobre-cinc, esp>0.15mm, enrollad.',10,'74','7409','740921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74092900','Outs.chapas e tiras,  de ligas de cobre-zinco,  esp>0.15mm','Oth.plates and strips, of copper-zinc alloys, thin>0.15mm','Las demás chapas y tiras, de aleac.cobre-cinc, esp>0.15mm',10,'74','7409','740929');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74093100','Chapas e tiras de ligas cobre-estanho,  e>0.15mm,  em rolos','Plates, strips, of copper-tin alloys th>0.15mm, in coils','Chapas y tiras, de aleac.cobre-est., esp>0.15mm, enrollad.',10,'74','7409','740931');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74093111','Chapas de ligas de bronze,   e>o,  15mm,  rolos,  revest.plast.','Plates of bronze alloys, thickness > 0,15mm, in coils, coated with plastic ','Chapas de aleaciones de bronce, de espesor > 0,15mm, enrolladas, revestidas de plástico',10,'74','7409','740931');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74093119','Outs chapas de ligas de bronze,  e>0,  15mm,  rolos,  rev.plast','Other plates of bronze alloys, thickness > 0,15mm, in coils, coated with plastic ','Otras chapas de aleaciones de bronce, de espesor > 0,15mm, enrolladas, revestidas de plástico',10,'74','7409','740931');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74093190','Outs chapas de ligas de bronze,  e>0,  15mm,  em rolos','Other plates of bronze alloys, thickness > 0,15mm, in coils ','Otras chapas de aleaciones de bronce, de espesor > 0,15mm, enrolladas',10,'74','7409','740931');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74093900','Outs.chapas e tiras,  de ligas de cobre-estanho,  e>0.15mm','Oth.plates and strips, of copper-tin alloys, thin>0.15mm','Las demás chapas y tiras, de aleac.cobre-est., esp>0.15mm',10,'74','7409','740939');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74094010','Chapas e tiras de ligas cobre-niquel,  etc,  e>0.15mm,  rolos','Plates, strips, copper-nickel alloys, etc.t>0.15mm, coils','Chapas y tiras, de aleac.cobre-níq.etc, e>0.15mm, enroll.',10,'74','7409','740940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74094090','Outs.chapas e tiras,  de ligas de cobre-niquel,  esp>0.15mm','Oth.plates, strips, of copper-nickel alloys, etc.t>0.15mm','Las demás chapas y tiras, de aleac.cobre-níq., esp>0.15mm',10,'74','7409','740940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74099000','Chapas e tiras,  de outras ligas de cobre,  esp>0.15mm','Plates and strips, of other copper alloys, thin>0.15mm','Chapas y tiras, de las demás aleac.de cobre, esp>0.15mm',10,'74','7409','740990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74101110','Folha de cobre ref.s/suport.e<=0.07mm,  pureza>=99.85%','Sheet of refined copper, n/back.t<=0.07mm, purity>=99.85%','Hoja de cobre ref.s/soport.e<=0.07mm, pureza>=99.85%',10,'74','7410','741011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74101111','Folha de cobre ref.s/suport.e<=0.04mm,  pureza>=99.85%','Sheet of refined copper, n/back.t<=0.04mm, purity>=99.85%','Hoja de cobre ref.s/soport.e<=0.04mm, pureza>=99.85%',10,'74','7410','741011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74101112','Folha de cobre e<=0.04mm e rest.ele.<=0,  017241ohm.mm2/m','Sheet of  copper, t<=0.04mm, electrical resistance <=0, 017241ohm.mm2/m','Hoja de cobre, e<=0.04mm, resistencia eléctrica <=0, 017241ohm.mm2/m',10,'74','7410','741011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74101113','Outras folhas de cobre e<=0.04 mm','Other sheets of copper t<=0.04mm','Las demás hojas de cobre e<=0.04mm',10,'74','7410','741011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74101119','Folha de cobre ref.s/suport.0.04mm,  puro>=99.85%','Sheet of refined copper, n/back.t<=0.04mm, purity>=99.85%','Hoja de cobre ref.s/soport.e<=0.04mm, pureza>=99.85%',10,'74','7410','741011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74101190','Outras folhas/tiras,  de cobre refin.s/suporte,  e<=0.15mm','Other sheets/strips, of refined copper, n/back., t<=0.15mm','Las demás hojas/tiras, de cobre ref.s/soporte, e<=0.15mm',10,'74','7410','741011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74101200','Folha e tira,  de ligas de cobre,  s/suporte,  e<=0.15mm','Sheets/strips, of copper alloy, n/backed, t<=0.15mm','Hoja/tiras, de aleaciones de cobre, s/soporte, e<=0.15mm',10,'74','7410','741012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74102110','Folha de cobre ref.c/suport.p/circuit.impress.e<=0.15mm','Sheet of refined copper, back.f/circuit print.t<=0.15mm','Hoja de cobre ref.c/soport.p/circuit.impres.e<=0.15mm',10,'74','7410','741021');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74102120','Folha de cobre ref.c/suport.poliest.etc.0.012<e<=0.15mm','Sheet of refin.copper, polyes.back.etc.0.012<et<=0.15mm','Hoja de cobre ref.c/soport.poliest.etc.0.012<e<=0.15mm',10,'74','7410','741021');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74102130','Folha de cobre c/suporte,  do tipo p/circuitos impressos','Sheets of copper, backed, for printed circuits','Hoja de cobre con soport para circuitos impresos',10,'74','7410','741021');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74102190','Outras folhas/tiras,  de cobre refin.c/suporte,  e<=0.15mm','Other sheets/strip, of refined copper, backed, t<=0.15mm','Las dem.hojas/tiras, de cobre refin.c/soporte, e<=0.15mm',10,'74','7410','741021');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74102200','Folha e tira,  de ligas de cobre,  c/suporte,  e<=0.15mm','Sheets/strip, of copper alloy, backed, t<=0.15mm','Hoja y tira, de aleaciones de cobre, c/soporte, e<=0.15mm',10,'74','7410','741022');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74111010','Tubos de cobre refinado, não aletados nem ranhurados','Tubes of refined copper, not finned or grooved','Tubos de cobre refinado, sin aletas ni ranuras',10,'74','7411','741110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74111090','Outros tubos de cobre refinado','Other tubes of refined copper','Los demás tubos de cobre refinado',10,'74','7411','741110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74112110','Tubos de ligas de cobre-zinco,  n/aletados n/ranhurados','Tubes of copper-zinc alloys, not finned or grooved','Tubos de aleaciones de cobre-cinc, s/aletas n/ranuras',10,'74','7411','741121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74112190','Outros tubos de ligas de cobre-zinco','Other tubes of copper-zinc alloys','Los demás tubos de aleaciones de cobre-cinc',10,'74','7411','741121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74112210','Tubos de ligas cobre-niquel,  etc.n/aletados n/ranhurados','Tubes of copper-nickel alloys, etc.not finned or grooved','Tubos de aleaciones de cobre-níquel, etc.s/aletas n/ran.',10,'74','7411','741122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74112290','Outs.tubos de ligas de cobre-niquel/cobre-niquel-zinco','Other tubes of copper-nickel alloys/copper-nickel-zinc','Los demás tubos de aleac.cobre-níquel/cobre-níquel-cinc',10,'74','7411','741122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74112910','Tubos de outras ligas de cobre,  não aletados não ranhurados','Tubes of other copper alloys, etc.not finned or grooved','Tubos de las dem.aleaciones de cobre, s/aletas n/ranuras',10,'74','7411','741129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74112990','Tubos de outras ligas de cobre','Tubes of other copper alloys','Tubos de las demás aleaciones de cobre',10,'74','7411','741129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74121000','Acessórios para tubos de cobre refinado','Fittings for tubes of refined copper','Accesorios de tubería de cobre refinado',10,'74','7412','741210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74122000','Acessórios para tubos de ligas de cobre','Fittings for tubes of copper alloys','Accesorios de tubería de aleaciones de cobre',10,'74','7412','741220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74130000','Cordas,  cabos,  trancas,  etc.de cobre,  n/isolad.p/uso eletr.','Stranded wire, cabl.plaited bands, etc.n/electr.insulated','Cables, trenzas, etc.de cobre, s/aislar, p/electr.',10,'74','7413','741300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74142000','Telas metálicas, de fios de cobre','Cloth, of copper wires','Telas metálicas, de alambre de cobre',10,'74','7414','741420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74149000','Grades e redes, de fios de cobre, chapas e tiras, de cobre','Grill and netting, of copper wire, plastes, strips, copper','Redes y rejas, de alamb.de cobre, chapas y tiras, de cobre',10,'74','7414','741490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74151000','Tachas,  pregos,  etc.de cobre/ferro/aço,  c/cabeça de cobre','Nails, tacks, etc.copper/iron/steel, with heads of copper','Puntas, clavos, etc.de cobre/hierro/acero, c/cabeza cobre',10,'74','7415','741510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74152100','Arruelas de cobre','Washers of copper','Arandelas de cobre',10,'74','7415','741521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74152900','Outros artefatos não roscados, de cobre','Other non-threaded articles, of copper','Los demás artículos sin roscar, de cobre',10,'74','7415','741529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74153100','Parafusos de cobre, para madeira','Screws of copper, for wood','Tornillos de cobre, para madera',10,'74','7415','741531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74153200','Outros parafusos, pinos ou pernos e porcas, de cobre','Other screws, bolts and nuts, of copper','Los demás tornillos, pernos y tuercas, de cobre',10,'74','7415','741532');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74153300','Parafusos, pinos/pernos e porcas, de cobre','Screws, bolts and nuts, of cotton','Tornillos, pernos y tuercas, de cobre',10,'74','7415','741533');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74153900','Outros artefatos roscados, de cobre','Other threaded articles, of cotton','Los demás artículos roscados, de cobre',10,'74','7415','741539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74160000','Molas de cobre','Copper springs','Muelles de cobre',10,'74','7416','741600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74170000','Aparelhos para cozinhar/aquecer, de cobre, n/eletr.doméstico','Cooking/heating apparatus, of copper, n/electric domestic','Aparatos p/cocción/calefac., de cobre, n/eléctr.doméstico',10,'74','7417','741700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74181000','Art.uso dom.e part.;esponjas,esfregao,luva,etc.p/lim.cob.','Household articles and parts thereof, of copper','Artículos de uso doméstico y sus partes, de cobre',10,'74','7418','741810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74181100','Esponjas, esfregões, etc.de cobre, para limpeza/polimento','Sponges, scrubbers, etc.of copper, f/cleaning/polishing','Esponjas, estropajos, etc.de cobre, p/fregar/lustrar',10,'74','7418','741811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74181900','Outros artefatos de cobre, uso doméstico e suas partes','Other articles of copper, use domestic and its parts','Los demás artículos de cobre, uso doméstico y sus partes',10,'74','7418','741819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74182000','Artefatos de cobre, de higiene/toucador e suas partes','Artic.of copper, of hygiene/pers.toilet and its parts','Artículos de cobre, de higiene/tocador y sus partes',10,'74','7418','741820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74191000','Correntes e cadeias, de cobre, e suas partes','Chains, of copper, and its parts','Cadenas, de cobre, y sus partes',10,'74','7419','741910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74199100','Outras obras de cobre,  vazadas,  moldadas,  estampad.forjad.','Other articles of copper, cast, moulded, stamped or forged','Las dem.manuf.de cobre, coladas, moldeadas, estamp.forjad.',10,'74','7419','741991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74199900','Outras obras de cobre','Other articles of copper','Las demás manufacturas de cobre',10,'74','7419','741999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74199910','Telas metálicas de fios de cobre','Metalic screens of copper yarn','Pantallas de metal de hilados de cobre',10,'74','7419','741999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74199920','Grad.e redes,  d/ fios d/cobre;chap.e tiras,  distend.','Grill and netting, of copper wire, plastes, strips, distended','Redes y rejas, de alamb.de cobre, chapas y tiras, distendidas',10,'74','7419','741999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74199930','Molas de cobre','Copper springs','Muelles de cobre',10,'74','7419','741999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('74199990','Aparelhos p/cozinhar/aquecer,  de cobre,  n/eletr.doméstico','Cooking/heating apparatus, of copper, n/electric domestic','Aparatos p/cocción/calefac., de cobre, n/eléctr.doméstico',10,'74','7419','741999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75011000','Mates de niquel','Nickel mattes','Matas de níquel',10,'75','7501','750110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75012000','Sinters de óxido niquel/prods.interm.metal.do niquel','Nickel oxide sinters/interm.produc.of nickel metallurgy','Sinters de óxido níquel/prods.interm.metalur.del níquel',10,'75','7501','750120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75021010','Catodos de niquel não ligado, em forma bruta','Cathodes of nickel not alloyed, unwrought','Cátodos de níquel sin alear, en bruto','21','75','7502','750210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75021090','Outras formas brutas de niquel, não ligado','Other unwrought of nickel, not alloyed','Los demás níqueles en  bruto, sin alear','21','75','7502','750210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75022000','Ligas de níquel, em forma bruta','Nickel alloys, unwrought','Aleaciones de níquel, en bruto',10,'75','7502','750220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75030000','Desperdícios e resíduos, de níquel','Nickel waste and scrap','Desperdicios y desechos, de níquel',10,'75','7503','750300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75040010','Pós e escamas, de níquel não ligado','Powders and flakes, of nickel not alloyed','Polvos y escamillas, de níquel sin alear',10,'75','7504','750400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75040090','Outros pós e escamas, de níquel','Other powders and flakes, of nickel','Los demás polvos y escamillas, de níquel',10,'75','7504','750400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75051110','Barras de níquel não ligado','Bars of nickel not alloyed','Barras de níquel sin alear',10,'75','7505','750511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75051121','Perfis ocos de níquel não ligado','Hollow profiles of nickel not alloyed','Perfiles huecos de níquel sin alear',10,'75','7505','750511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75051129','Outros perfis de níquel não ligado','Other profiles of nickel not alloyed','Los demás perfiles de níquel sin alear',10,'75','7505','750511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75051210','Barras de ligas de níquel','Bars of nickel alloys','Barras de aleaciones de níquel',10,'75','7505','750512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75051221','Perfis ocos de ligas de níquel','Hollow profiles of nickel alloyed','Perfiles huecos de aleaciones de níquel',10,'75','7505','750512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75051229','Outros perfis de ligas de níquel','Other profiles of nickel alloyed','Los demás perfiles de aleaciones de níquel',10,'75','7505','750512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75052100','Fios de níquel não ligado','Wire of nickel not alloyed','Alambre de níquel sin alear',10,'75','7505','750521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75052200','Fios de ligas de níquel','Wire of nickel alloyed','Alambre de aleaciones de níquel',10,'75','7505','750522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75061000','Chapas, tiras e folhas, de níquel não ligado','Plates, strip and sheets, of nickel not alloyed','Chapas, tiras y hojas, de níquel sin alear',10,'75','7506','750610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75062000','Chapas, tiras e folhas, de ligas de níquel','Plates, strip and sheets, of nickel alloyed','Chapas, tiras y hojas, de aleaciones de níquel',10,'75','7506','750620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75071100','Tubos de níquel não ligado','Tubes of nickel not alloyed','Tubos de níquel sin alear',10,'75','7507','750711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75071200','Tubos de ligas de níquel','Tubes of nickel alloyed','Tubos de aleaciones de níquel',10,'75','7507','750712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75072000','Acessórios para tubos de níquel','Accessories for tubes of nickel','Accesorios de tubería de níquel',10,'75','7507','750720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75081000','Telas metálicas e grades, de fios de níquel','Cloth and grill, of nickel wire','Telas metálicas y redes, de alambre de níquel',10,'75','7508','750810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75089000','Outras obras de níquel','Other articles of nickel','Las demás manufacturas de níquel',10,'75','7508','750890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75089010','Cilindros ocos sec.var.p/centrif.p/reform.esteq.gas nat','Hollow cylinder with var. sec. for centrif. for esteq. reform. nat. gas ','Cilindro hueco de sección variable p/ centrif.p / reform.esteq. gas nat',10,'75','7508','750890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('75089090','Outras obras de níquel','Other articles of nickel','Otros artículos de níquel',10,'75','7508','750890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76011000','Alumínio não ligado em forma bruta','Aluminium, not alloyed, unwrought','Aluminio sin alear en bruto','21','76','7601','760110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76012000','Ligas de alumínio em forma bruta','Aluminium alloys, unwrought','Aleaciones de aluminio en bruto',10,'76','7601','760120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76020000','Desperdícios e resíduos, de alumínio','Aluminium waste and scrap','Desperdicios y desechos, de aluminio',10,'76','7602','760200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76031000','Pós de alumínio, de estrutura não lamelar','Powders of aluminium, of non-lamellar structure','Polvos de aluminio, de estruct.no laminar',10,'76','7603','760310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76032000','Pós de alumínio, de estrut.lamelar/escamas de alumínio','Powders and flakes of aluminium, of lamellar structure','Polvos de alum., de estruct.laminar/escamillas de alum.',10,'76','7603','760320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76041010','Barras de alumínio não ligado','Bars of aluminium, not alloyed','Barras de aluminio sin alear',10,'76','7604','760410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76041021','Perfis ocos de alumínio não ligado','Hollow profiles of aluminium, not alloyed','Perfiles huecos de aluminio sin alear',10,'76','7604','760410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76041029','Outros perfis de alumínio não ligado','Other profiles of aluminium, not alloyed','Los demás perfiles de aluminio sin alear',10,'76','7604','760410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76042100','Perfis ocos de ligas de alumínio','Hollow profiles of aluminium, alloyed','Perfiles huecos de aleaciones de aluminio',10,'76','7604','760421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76042911','Barra de liga alumínio, forj.sec.transv.circ.40<=d<=76cm','Bars of alumin.alloyed, forg.circ.cross-sect.40<=d<=76cm','Barra de aleac.alumin., forj.sec.transv.circ.40<=d<=76cm',10,'76','7604','760429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76042919','Outras barras de ligas de alumínio','Other bars of aluminium alloyed','Las demás barras de aleaciones de aluminio',10,'76','7604','760429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76042920','Outros perfis de ligas de alumínio','Other profiles aluminium alloyed','Los demás perfiles de aleaciones de aluminio',10,'76','7604','760429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76051110','Fios de alumínio n/lig.sec.transv>7mm, re<=0.0283ohm.mm2','Alumin.wire n/alloyed, cros.sec.>7mm, res<=0.0283ohm.mm2','Alambre de alum.s/alear, sec.trans>7mm, re<=0.0283ohm.mm2',10,'76','7605','760511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76051190','Outros fios de alumínio n/lig.dim.sec.transv>7mm','Oth.wire of alumin.n/alloyed cross-sect.dim.>7mm','Los demás alambres de alumin.s/alear, dim.sec.transv>7mm',10,'76','7605','760511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76051910','Outs.fios de alumínio n/lig.resist.eletr<=0.283 ohm.mm2','Ot.wires of alumin.n/alloyed elec.resist<=0.283 ohm.mm2','Los dem.alambr.de alum.s/al.resis.eléct<=0.283 ohm.mm2',10,'76','7605','760519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76051990','Outros fios de alumínio, n/lig.','Other aluminium wires, not alloyed','Los demás alambres de aluminio, s/alear',10,'76','7605','760519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76052110','Fios de ligas alumínio, sec.transv>7mm, re<=0.0328ohm.mm2','Wires of alum.alloyed, cross-sec.d>7mm, re<=0.0328ohm.mm2','Alambres de aleac.alum.sec.transv>7mm, re<=0.0328ohm.mm2',10,'76','7605','760521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76052190','Outros fios de ligas alumínio, dim.sec.transv>7mm','Other wires of alumin.alloyed, cross-sec.dim>7mm','Los dem.alambres de aleaciones alum.dim.sec.transv>7mm',10,'76','7605','760521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76052910','Outs.fios de ligas alumínio, resist.eletr<=0.0328ohm.mm2','Ot.wires of alumin.allowyed elect.resis.<=0.0328ohm.mm2','Los dem.alamb.de aleac.alum.res.eléctr<=0.0328ohm.mm2',10,'76','7605','760529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76052990','Outros fios de ligas alumínio','Other wires of aluminium alloys','Los demás alambres de aleaciones de aluminio',10,'76','7605','760529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76061100','Chapas/tiras, de alumínio n/lig.e>0.2mm, quadradas/retang','Plastes/strips, of alumin.n/alloys t>0.2mm, square/rect','Chapas/tiras, de alum.s/alear, e>0.2mm, cuadradas/rectang',10,'76','7606','760611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76061110','Chapas de alumínio n/lig.e>0.2mm, quadr.teor silício, etc','Plast.of alum.n/alloys t>0.2mm, squar.tenor silicon, etc','Chapas de alum.s/alear.e>0.2mm, cuadr.c/cont.silicio, etc',10,'76','7606','760611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76061190','Outs.chapas/tiras, de alumínio n/lig.e>0.2mm, quadr/retan','Ot.plastes/strips, alumin.n/alloys t>0.2mm, squar/rect','Las dem.chapas/tiras, de alum.s/alear, e>0.2mm, cuadr/rect',10,'76','7606','760611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76061210','Chapas de ligas alumínio, 0.2<e<=0.3mm, l>=1468mm, envern.','Plastes of alumin.alloys, 0.2<t<=0.3mm, w>=1468mm, polish.','Chapas de aleacion.alum.0.2<e<=0.3mm, l>=1468mm, enbarn.',10,'76','7606','760612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76061220','Outs.chapas de alumínio n/lig.e>0.2mm, quadr.teor silic.','Ot.plastes of alum.n/alloys t>0.2mm, squar.tenor silic.','Las dem.chapas de alum.s/al.e>0.2mm, cuadr.c/cont.silic',10,'76','7606','760612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76061290','Outras chapas e tiras, de ligas alumínio, esp>0.2mm','Oth.plates and strips, of alluminium alloys, th>0.2mm','Las dem.chapas y tiras, de aleaciones aluminio, esp>0.2mm',10,'76','7606','760612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76069100','Outras chapas e tiras, de alumínio não ligado, esp>0.2mm','Oth.plates and strips, of alluminium n/alloyed, th>0.2mm','Las dem.chapas y tiras, de aluminio sin alear, esp>0.2mm',10,'76','7606','760691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76069200','Outras chapas e tiras, de ligas de alumínio, esp>0.2mm','Oth.plates and strips, of alluminium alloys, th>0.2mm','Las demás chapas y tiras, de aleac.de aluminio, esp>0.2mm',10,'76','7606','760692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76071100','Folhas/tiras, de alumínio, s/suporte, laminadas, e<=0.2mm','Foils/strips, of allum.without support, laminat.t<=0.2mm','Hojas/tiras, de aluminio, s/soporte, laminadas, e<=0.2mm',10,'76','7607','760711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76071110','Folhas de alumínio s/suporte, lamin.e<=0.2mm, teor silic.','Alumin.foils, without support, lam.t<=0.2mm, tenor silicon','Hojas de alumin.s/soporte, lamin.e<=0.2mm, c/cont.silic.',10,'76','7607','760711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76071190','Outs.folhas/tiras, de alumínio s/suporte, lamin.e<=0.2mm','Ot.foils/strips, of allum.without support, lamin.t<=0.2mm','Las dem.hojas/tiras, de alumin.s/soporte, lamin.e<=0.2mm',10,'76','7607','760711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76071910','Folhas/tiras, de alumínio, s/suporte, gravad.e<=110microns','Foils/strips, of allum.without support, etch.t<=110micr.','Hojas/tiras, de aluminio, s/soporte, grabad.e<=110microns',10,'76','7607','760719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76071990','Outras folhas e tiras, de alumínio, s/suporte, esp<=0.2mm','Oth.foils/strips, of allum.without support, th<=0.2mm','Las dem.hojas y tiras, de aluminio, s/soporte, esp<=0.2mm',10,'76','7607','760719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76072000','Folhas/tiras, de alumínio, c/suporte, esp<=0.2mm','Foils/strips, of alluminium with support, th<=0.2mm','Hojas/tiras, de aluminio, c/soporte, esp<=0.2mm',10,'76','7607','760720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76081000','Tubos de alumínio não ligado','Aluminium tubes, not alloyed','Tubos de aluminio sin alear',10,'76','7608','760810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76082000','Tubos de ligas de alumínio','Tubes of aluminium alloys','Tubos de aleaciones de aluminio',10,'76','7608','760820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76082010','Tubos de ligas de alumínio, sem cost.extrud.a frio, etc.','Tubes of aluminium alloys.seamless, cold-drawn, etc','Tubos de aleaciones de alumin.s/cost.extrud.en frío, etc',10,'76','7608','760820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76082090','Outros tubos de ligas de alumínio','Other tubes of aluminium alloys','Los demás tubos de aleaciones de aluminio',10,'76','7608','760820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76090000','Acessórios para tubos de alumínio','Accessories for tubes of aluminum','Accesorios de tuberías de aluminio',10,'76','7609','760900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76101000','Portas, janelas, seus caixilhos, alizares, etc.de alumínio','Doors, windows, their frames, thresholds, etc.of aluminium','Puertas, ventanas, sus marcos, contramarcos, etc.de alumin.',10,'76','7610','761010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76109000','Construções/outras partes, chapas, barras, etc.de alumínio','Constructions/other parts, plastes, bars, etc.of aluminium','Construcciones/dem.partes, chapas, barras, etc.de aluminio',10,'76','7610','761090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76110000','Reservatórios, etc.de alumínio, c>300l, s/disp.mecan/term.','Reservoirs, etc.of alumin.c>300l, n/fitted mechan/therm','Depósitos, etc.de aluminio, c>300l, s/disp.mecán. n//térm.',10,'76','7611','761100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76121000','Recipientes tubul.flexiv.de alumínio, c<=300l, s/disp.mec','Collapsible tubular containers, c<=300l, n/fitted mechan.','Envases tubul.flexib.de aluminio, c<=300l, s/disp.méc',10,'76','7612','761210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76129011','Recipientes tubul.de alumínio, c<=700cm3, p/aerossois','Tubular containers of aluminium, c<=700cm3, for aerosols','Envases tubul.de aluminio, c<=700cm3, p/aerosoles',10,'76','7612','761290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76129012','Recip.tubul.alumínio, isoterm.refrig.nitrog.liq.c<=300l','Tubular containers alum.isorth.cooled liq.nitrog.<=300l','Env.tubul.aluminio, isotérm.refrig.nitróg.líq.c<=300l',10,'76','7612','761290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76129019','Outros recipientes tubulares, de alumínio, c<=300l','Other tubular containers, of aluminium, c<=300l','Los demás envases tubulares, de aluminio, c<=300l',10,'76','7612','761290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76129090','Outs.reservator.etc.de alumínio, c<=300l, s/disp.mec.term','Oth.casks, etc.of aluminium c<=300l, n/fitted mechan.','Los dem.depósitos, etc.de alum.c<=300l, s/disp.mec.n/térm',10,'76','7612','761290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76130000','Recipientes p/gases comprimidos/liquefeitos, de alumínio','Aluminium containers for compressed or liquefied gas','Envases p/gas comprimido/licuado, de aluminio',10,'76','7613','761300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76141010','Cordas e cabos, de alumínio, c/alma de aço, n/isol.p/eletr','Wires/cables, of aluminium, with steel core, n/elec.insul.','Cables de aluminio, c/alma de acero, s/aislar, p/electr.',10,'76','7614','761410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76141090','Trancas, etc.de alumínio, c/alma de aço, n/isol.p/eletr.','Plaited bands, etc.alumin., with steel core, n/elec.insul.','Trenzas, etc.de aluminio, c/alma de acero, s/aisl.p/elect.',10,'76','7614','761410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76149010','Outros cabos de alumínio, n/isol.p/uso eletr.','Plaited bands, etc.alumin., with steel core, n/elec.insul.','Los demás cables de aluminio, s/aislar, p/uso electr.',10,'76','7614','761490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76149090','Outras cordas, trancas, etc.n/isol.p/uso eletr.','Other cables, plaited bands, etc.n/electrically insulated','Las demás cuerdas, trenzas, etc.s/aislar, p/uso electr.',10,'76','7614','761490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76151000','Art.uso dom.e part.;esponjas,esfregao,luva.p/lim.alu.','Household articles and parts thereof, of aluminum','Artículos de uso doméstico y sus partes, de aluminio',10,'76','7615','761510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76151100','Esponjas, esfregões, etc.de alumínio, p/limpeza/polimento','Sponges, scrubbers, etc.of aluminium, f/cleaning/polishing','Esponjas, estropajos, etc.de aluminio, p/fregar/lustrar',10,'76','7615','761511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76151900','Outs.artefatos de alumínio, uso doméstico e suas partes','Oth.articles of aluminium, use domestic and their parts','Los demás artículos de alum., uso doméstico y sus partes',10,'76','7615','761519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76152000','Artefatos de alumínio, de higiene/toucador e suas partes','Articles of aluminium, sanitary ware and parts thereof','Artículos de aluminio, de higiene/tocador y sus partes',10,'76','7615','761520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76161000','Tachas, pregos, escápulas, parafusos, pinos, etc.de alumínio','Tacks, nails, staples, screw, bolts, etc.of aluminium','Puntas, clavos, escarpias, tornillos, pernos, etc.de alum.',10,'76','7616','761610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76169100','Telas metálicas, grades e redes, de fios de alumínio','Cloth, grill and netting, of aluminium wire','Telas metálicas, redes y rejas, de alambre de aluminio',10,'76','7616','761691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('76169900','Outras obras de alumínio','Other articles of aluminium','Las demás manufacturas de aluminio',10,'76','7616','761699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('78011011','Chumbo refinado, eletrolítico, em lingotes','Refined lead, electrolytic, in ingots','Plomo refinado, electrolítico, en lingotes','21','78','7801','780110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('78011019','Outras formas brutas de chumbo refinado, eletrolítico','Other unwrought of refined lead, electrolytic','Las dem.formas en bruto de plomo refinado, electrolítico','21','78','7801','780110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('78011090','Outras formas brutas de chumbo refinado','Other unwrought of refined lead','Las demás formas en bruto de plomo refinado','21','78','7801','780110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('78019100','Chumbo c/antimônio como seg.elem.predom.em forma bruta','Lead with antimony as second predom.element, unwrought','Plomo c/antimonio como el otro elem.predom.en bruto','21','78','7801','780191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('78019900','Outras formas brutas de chumbo','Other unwrought lead','Las demás formas en bruto de plomo','21','78','7801','780199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('78020000','Desperdícios e resíduos, de chumbo','Lead waste and scrap','Desperdicios y desechos, de plomo',10,'78','7802','780200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('78030000','Barras, perfis e fios, de chumbo','Lead bars, rods, profiles and wire','Barras, perfiles y alambre, de plomo',10,'78','7803','780300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('78041100','Folhas e tiras, de chumbo, espessura<=0.2mm','Sheets, strip of lead, of a thickness<=0.2mm','Hojas y tiras, de plomo, espesor<=0.2mm',10,'78','7804','780411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('78041900','Chapas e outras folhas e tiras, de chumbo','Plates, and other sheets and strip, of lead','Chapas y demás hojas y tiras, de plomo',10,'78','7804','780419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('78042000','Pós e escamas de chumbo','Leads powders and flakes','Polvos y escamillas de plomo',10,'78','7804','780420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('78050000','Tubos e seus acessórios, de chumbo','Lead tubes and its accessories','Tubos y accesorios de tubería, de plomo',10,'78','7805','780500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('78060000','Outras obras de chumbo','Other articles of lead','Otras manufacturas de plomo',10,'78','7806','780600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('78060010','Barras, perfis e fios de chumbo','Bars, rods, profiles and wire, of lead','Barras, perfiles y alambre de plomo',10,'78','7806','780600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('78060020','Tubos e acessórios (uniões, luvas, etc) chumbo','Tubes and accessories, of lead','Accesorios y tubería de plomo',10,'78','7806','780600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('78060090','Outras obras de chumbo','Other articles of lead','Otras manufacturas de plomo',10,'78','7806','780600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79011111','Zinco n/lig.cont.zinco>=99.99%, eletrolítico, em lingotes','Zinc n/alloyed cont.zinc>=99.99%, electrolytic, in ingots','Cinc s/al.c/cont.cinc>=99.99%, electrolítico, en lingotes','21','79','7901','790111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79011119','Outs.formas brutas de zinco n/lig.zinco>=99.99%, eletrol','Other unwrought zinc of n/al.zinc>=99.99%, electrolytic','Las dem.formas en bruto de cinc s/al.cinc>=99.99%, elect','21','79','7901','790111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79011191','Outros lingotes de zinco n/lig.cont.zinco>=99.99%','Other ingots of zinc n/alloyed, cont.zinc>=99.99%','Los demás lingotes de cinc s/alear, c/cont.cinc>=99.99%','21','79','7901','790111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79011199','Outras formas brutas de zinco n/lig.cont.zinco>=99.99%','Other unwrought zinc n/alloyed, cont.zinc>=99.99%','Las dem.formas en bruto de cinc s/al., cont.cinc>=99.99%','21','79','7901','790111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79011210','Zinco n/lig.cont.zinco<99.99%, em lingotes','Zinc n/alloyed , cont.zinc<99.99%, in ingoats','Cinc s/alear, c/cont.cinc<99.99%, en lingotes','21','79','7901','790112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79011290','Outras formas brutas de zinco n/lig.cont.zinco<99, 99%','Other unwrought zinc of zinc n/al.cont.zinc<99, 99%','Las dem.formas en bruto de cinc s/al.c/cont.cinc<99, 99%','21','79','7901','790112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79012010','Ligas de zinco, em lingotes','Zinc alloys, in ingots','Aleaciones de cinc, en lingotes','21','79','7901','790120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79012090','Outras formas brutas de ligas de zinco','Other unwrought of zinc alloys','Las demás formas en bruto de aleaciones de cinc','21','79','7901','790120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79020000','Desperdícios e resíduos, de zinco','Zinc waste and scrap','Desperdicios y desechos, de cinc',10,'79','7902','790200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79031000','Poeiras de zinco','Zinc dust','Polvo de cinc',10,'79','7903','790310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79039000','Pós e escamas, de zinco','Zinc powders and flakes','Polvo y escamillas, de cinc',10,'79','7903','790390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79040000','Barras, perfis e fios, de zinco','Zinc bars, rods, profiles and wire','Barras, perfiles y alambre, de cinc',10,'79','7904','790400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79050000','Chapas, folhas e tiras, de zinco','Zinc plates, sheets and strips','Chapas, hojas y tiras,  de cinc',10,'79','7905','790500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79060000','Tubos e seus acessórios, de zinco','Zinc tubes and its accessories','Tubos y accesorios de tubería, de cinc',10,'79','7906','790600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79070000','Outras obras de zinco','Other articles of zinc','Otras manufacturas de cinc',10,'79','7907','790700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79070010','Tubos e seus acessórios (uniões, luvas, etc)zinco','Zinc tubes and its accessories','Tubos y accesorios de tubería, de cinc',10,'79','7907','790700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('79070090','Outras obras de zinco','Other articles of zinc','Otras manufacturas de cinc',10,'79','7907','790700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('80011000','Estanho não ligado, em forma bruta','Tin not alloyed, unwrought','Estaño sin alear, en bruto','21','80','8001','800110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('80012000','Ligas de estanho, em forma bruta','Tin alloys, unwrought','Aleaciones de estaño, en bruto',10,'80','8001','800120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('80020000','Desperdícios e resíduos, de estanho','Tin waste and scrap','Desperdicios y desechos, de estaño',10,'80','8002','800200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('80030000','Barras, perfis e fios, de estanho','Tin bars, rods, profiles and wire','Barras, perfiles y alambre, de estaño',10,'80','8003','800300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('80040000','Chapas, folhas e tiras, de estanho, espessura>0.2mm','Tin plates, sheets and strip, of a thickness>0.2mm','Chapas, hojas y tiras, de estaño, espesor>0.2mm',10,'80','8004','800400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('80050010','Folhas e tiras, delgadas, de estanho, espessura<=0.2mm','Tin sheets and strips, of a thicknes<=0.2mm','Hojas y tiras, delgadas, de estaño, espesor<=0.2mm',10,'80','8005','800500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('80050020','Pós e escamas, de estanho','Tin waste and scrap,  of tin','Polvos y escamillas, de estaño',10,'80','8005','800500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('80060000','Tubos e seus acessórios, de estanho','Tin tubes and its accessories','Tubos y accesorios de tubería, de estaño',10,'80','8006','800600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('80070000','Outras obras de estanho','Other articles of tin','Otras manufacturas de estaño',10,'80','8007','800700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('80070010','Chapas, folhas, tiras, de estanho','Tin plates, sheets and strips','Chapas, hojas y tiras de estaño',10,'80','8007','800700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('80070020','Pós e escamas de estanho','Tin waste and scrap,  of tin','Polvos y escamillas, de estaño',10,'80','8007','800700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('80070030','Tubos de estanho, seus acessórios (uniões, luvas)','Tin tubes and its accessories','Tubos y accesorios de tubería,  de estaño',10,'80','8007','800700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('80070090','Outras obras de estanho','Other articles of tin','Otras manufacturas de estaño',10,'80','8007','800700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81011000','Pós de tungstênio (volframio)','Tungsten powders (wolfram)','Polvos de volframio (tungsteno)',10,'81','8101','810110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81019100','Tungstênio em forma bruta, incl.barra sinter.desperd.etc','Unwrought tungsten, incl.bars obt.by sinter.waste, etc','Volframio en bruto, incl.barra obt.sinter.desperd.etc',10,'81','8101','810191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81019200','Outs.barras e perfis/chapas/tiras/folhas, de tungstênio','Oth.bars and profiles/plastes/strips/sheets, of tungsten','Las dem.barras y perfiles/chapas/tiras/hojas, de tungst.',10,'81','8101','810192');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81019300','Fios de tungstênio','Wires of tungsten','Alambre de tungsteno',10,'81','8101','810193');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81019400','Tungstênio em formas brutas, barras da sinter.','Unwrought tungsten, bars obtained by sintering','Tungsteno en bruto, barras obt.por sinter.',10,'81','8101','810194');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81019500','Barras, perfis, chapas, folhas, etc.de tungstênio','Bars/profiles/plastes/strips/sheets, etc.of tungsten','Barras, perfiles, chapas, hojas, etc.de tungsteno',10,'81','8101','810195');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81019600','Fios de tungstênio','Wires of tungsten','Alambre de tungsteno',10,'81','8101','810196');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81019700','Desperdícios e resíduos de tungstênio','Tungsten waste and scrap','Desperdicios y desechos de tungsteno',10,'81','8101','810197');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81019910','Obras de tungstênio, util.p/fabr.de contatos eletr.','Tungsten articles, used f/production of eletric contacts','Manufact.de tungsteno, util.p/fabr.de contactos eléctr.',10,'81','8101','810199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81019990','Outras obras de tungstênio','Other tungsten articles','Las demás manufacturas de tungsteno',10,'81','8101','810199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81021000','Pós de molibdênio','Molybdenum powders','Polvo de molibdeno',10,'81','8102','810210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81029100','Molibdénio em forma bruta, incl.barra sinter.desperd.etc','Unwrought molybdenum, incl.bars obt.by sinter.waste, etc','Molibdeno en bruto, incl.barra obt.sinter.desperd.etc',10,'81','8102','810291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81029200','Outs.barras e perfis/chapas/tiras/folhas, de molibdénio','Oth.bars/profiles/plastes/strips/sheets, of molybdenum','Las dem.barras y perf./chapas/tiras/hojas, de molibdeno',10,'81','8102','810292');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81029300','Fios de molibdénio','Molybdenum wires','Alambre de molibdeno',10,'81','8102','810293');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81029400','Molibdénio em formas brutas, barras da sinter.','Unwrought molybdenum, bars obtained by sintering','Molibdeno en bruto, barras obt.por sinterizado',10,'81','8102','810294');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81029500','Barras, perfis, chapas, folhas, etc.de molibdénio','Bars/profiles/plastes/strips/sheets, etc.of molybdenum','Barras, perfiles, chapas, hojas, etc.de molibdeno',10,'81','8102','810295');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81029600','Fios de molibdénio','Molybdenum wires','Alambre de molibdeno',10,'81','8102','810296');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81029700','Desperdícios e resíduos de molibdénio','Molybdenum waste and scrap','Desperdicios y desechos de molibdeno',10,'81','8102','810297');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81029900','Outras obras de molibdénio','Other articles of molybdenum','Las demás manufacturas de molibdeno',10,'81','8102','810299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81031000','Tântalo em forma bruta, incl.barra sinter.desperd.resid.','Unwrought tantalum, incl.bars obt.by sinter.waste scrap','Tántalio en brut, incl.barra obt.sinter.desperd.desech.',10,'81','8103','810310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81032000','Tântalo em formas brutas, barras da sinter.po','Unwrought tantalum, bars obt.by sinter.powder','Tántalio en bruto, barras obt.por sinter.polvo',10,'81','8103','810320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81033000','Desperdícios e resíduos de tântalo','Tantalum waste and scrap','Desperdicios y desechos de tántalio',10,'81','8103','810330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81039000','Outras obras de tântalo','Other articles tantalum','Las demás manufacturas de tántalio',10,'81','8103','810390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81041100','Magnésio em forma bruta, cont.magnésio>=99.80%','Unwrought magnesium, cont.magnesium>=99.80%','Magnesio en bruto, c/cont.magnesio>=99.80%',10,'81','8104','810411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81041900','Outras formas brutas de magnésio','Other unwrought magnesium','Las demás formas en bruto de magnesio',10,'81','8104','810419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81042000','Desperdícios e resíduos, de magnésio','Magnesium waste and scrap','Desperdicios y desechos, de magnesio',10,'81','8104','810420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81043000','Resíduos de torno, grânulos calibrados e pos de magnésio','Rasp.turn.and gran.graded accord.to size;powders magn.','Torneaduras, gránulos calibrados y polvo de magnesio',10,'81','8104','810430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81049000','Outras obras de magnésio','Other magnesium articles','Las demás manufacturas de magnesio',10,'81','8104','810490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81051010','Pós de cobalto','Cobalt in powders','Polvo de cobalto',10,'81','8105','810510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81051020','Cobalto em bruto','Cobalt in brute','Cobalto en bruto',10,'81','8105','810510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81051090','Mates de cobalto, outros prod.intermed.metal.cobalto, etc','Cobalt mattes, other intermed.prod.of cobalt metal.etc','Matas de cobalto, demás prod.intermed.metal.cobalto, etc',10,'81','8105','810510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81052010','Cobalto em formas brutas','Unwrought cobalt','Cobalto en bruto',10,'81','8105','810520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81052020','Cobalto em pós','Cobalt in powders','Cobalto en polvo',10,'81','8105','810520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81052021','Pó de ligas a base de cobalto-cromo-tungstênio','Po de ligas a base de cobalto-cromo-tungstenio','Po de ligas a base de cobalto-cromo-tungstenio',10,'81','8105','810520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81052029','Outros pós','Outros pos','Outros pos',10,'81','8105','810520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81052090','Mates de cobalto e outs.prods.intermed.metal.','Cobalt mattes, other interm.products of cobalt metal.','Matas de cobalto y dem.prods.intermed.de la metalurgia',10,'81','8105','810520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81053000','Desperdícios e resids.da metalurg.do cobalto','Cobalt waste and scrap','Desperdicios y desechos de la metalurgia del cobalto',10,'81','8105','810530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81059010','Chapas, folhas, tiras, fios, hastes, etc.de cobalto','Foil, sheets, strip, threads, stems, etc.of cobalt','Chapas, hojas, tiras, hilos, astas, etc.de cobalto',10,'81','8105','810590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81059090','Outras obras de cobalto','Other articles of cobalt','Las demás manufacturas de cobalto',10,'81','8105','810590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81060010','Bismuto em bruto','Bismuth in brute','Bismuto en bruto',10,'81','8106','810600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81060090','Obras de bismuto, desperdícios e resíduos, de bismuto','Bismuth articles, including waste and scrap, of bismuth','Manufact.de bismuto, desperdicios y desechos, de bismuto',10,'81','8106','810600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81071010','Cádmio em bruto','Cadmium in brute','Cadmio en bruto',10,'81','8107','810710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81071090','Pos de cádmio, desperdícios e resíduos de cádmio','Cadmium powders, including waste and scrap','Polvo de cadmio, desperdicios y desechos de cadmio',10,'81','8107','810710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81072010','Cádmio em formas brutas','Unwrought cadmium','Cadmio en bruto',10,'81','8107','810720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81072020','Cádmio em pós','Cadmium in powders','Cadmio en polvo',10,'81','8107','810720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81073000','Desperdícios e resíduos do cádmio','Waste and scrap cadmium','Desperdicios y desechos del cadmio',10,'81','8107','810730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81079000','Obras de cádmio','Articles of cadium','Manufacturas de cadmio',10,'81','8107','810790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81081000','Titânio em forma bruta, desperd.resid.e pos de titânio','Unwrought titanium, waste, scrap and powders of titanium','Titanio en bruto, desperd.desech.y polvo de titanio',10,'81','8108','810810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81082000','Titânio em formas brutas, e titânio em pós','Unwrought titanium and in powders','Titanio en bruto, y titanio en polvo',10,'81','8108','810820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81083000','Desperdícios e resíduos do titânio','Waste and scrap titanium','Desperdicios y desechos de titanio',10,'81','8108','810830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81089000','Obras de titânio','Articles of titanium','Manufacturas de titanio',10,'81','8108','810890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81091000','Zircônio em forma bruta, desperd.resid.e pos de zircônio','Unwrought zirconium, waste, scrap and powders of zircon.','Circonio en bruto, desperd.desech.y polvo de circonio',10,'81','8109','810910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81092000','Zircônio em formas brutas, e zircônio em pós','Unwrought zirconium, and zirconium in powders','Circonio en bruto, y circonio en polvo',10,'81','8109','810920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81093000','Desperdícios e resíduos do zircônio','Waste and scrap of zirconium','Desperdicios y desechos de circonio',10,'81','8109','810930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81099000','Obras de zircônio','Articles of zirconium','Manufacturas de circonio',10,'81','8109','810990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81100010','Antimônio em bruto','Antimony in brute','Antimonio en bruto',10,'81','8110','811000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81100090','Obras de antimônio, desperdícios e resíduos, de antimônio','Antimony articles, including waste and scrap','Manuf.de antimonio, desperdicios y desechos, de antimonio',10,'81','8110','811000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81101010','Antimônio em formas brutas','Unwrought antimony','Antimonio en bruto',10,'81','8110','811010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81101020','Antimônio em pós','Antimony powders','Antimonio en polvo',10,'81','8110','811010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81102000','Desperdícios e resíduos do antimônio','Antimony waste and scrap','Desperdicios y desechos de antimonio',10,'81','8110','811020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81109000','Obras e outs.prods.do antimônio','Articles and other products of antimony','Manufacturas y demás prods.de antimonio',10,'81','8110','811090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81110010','Manganês em bruto','Manganese in brute','Manganeso en bruto',10,'81','8111','811100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81110020','Chapas, folhas, tiras, fios, hastes, etc.de manganês','Plastes/strips/sheets/wires, etc.of manganese','Chapas, hojas, tiras, hilos, astas, etc.de manganeso',10,'81','8111','811100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81110090','Outras obras de manganês, desperd.e resíduos de mangane','Manganese articles, including waste and scrap','Las dem.manuf.de manganeso, desperd.y desechos de mang.',10,'81','8111','811100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81121100','Berílio em forma bruta, desperd.resid.e pos de berílio','Unwrought beryllium, including waste, scrap and powders','Berilio en bruto, desperd.desech.y polvo de berilio',10,'81','8112','811211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81121200','Berílio em formas brutas, e berílio em pós','Unwrought beryllium, including in powders','Berilio en bruto, y berilio en polvo',10,'81','8112','811212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81121300','Desperdícios e resíduos do berílio','Beryllium waste and scrap','Desperdicios y desechos de berilio',10,'81','8112','811213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81121900','Obras de berílio','Beryllium articles','Manufacturas de berilio',10,'81','8112','811219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81122010','Cromo em bruto','Chromium in brute','Cromo en bruto',10,'81','8112','811220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81122090','Obras de cromo, desperdícios e resíduos, de cromo','Chromium articles, including waste and scrap','Manufacturas de cromo, desperdicios y desechos, de cromo',10,'81','8112','811220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81122110','Cromo em formas brutas','Unwrought chromium','Cromo en bruto',10,'81','8112','811221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81122120','Cromo em pós','Chromium in powders','Cromo en polvo',10,'81','8112','811221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81122200','Desperdícios e resíduos do cromo','Chromium waste and scrap','Desperdicios y desechos de cromo',10,'81','8112','811222');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81122900','Obras e outros produtos do cromo','Articles and other products of chromium','Manufacturas y demás prods.de cromo',10,'81','8112','811229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81123000','Germânio e suas obras, desperd.e resíduos, de germânio','Germanium and its articles, including waste and scrap','Germanio y sus manufact., desperd.y desechos, de germanio',10,'81','8112','811230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81124000','Vanádio e suas obras, desperdícios e resíduos, de vanádio','Vanadium and its articles, including waste and scrap','Vanadio y sus manuf., desperdicios y desechos, de vanadio',10,'81','8112','811240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81125100','Tálio em formas brutas, e tálio em pós','Unwrought thallium, including in powders','Talio en bruto, y talio en polvo',10,'81','8112','811251');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81125200','Desperdícios e resíduos do tálio','Thalium waste and scrap','Desperdicios y desechos de talio',10,'81','8112','811252');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81125900','Obras e outros produtos do tálio','Articles and other products of thallium','Manufacturas y demás prods.de talio',10,'81','8112','811259');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81129100','Gálio, hafnio, indio, nióbio, etc.em bruto, desperd.resid.po','Gallium, hafnium, indium, niobium, etc.brute, wast.scrap, pow','Galio, hafnio, indio, niobio, etc.en bruto, desper.des.polvo',10,'81','8112','811291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81129200','Gálio, nióbio, etc.em formas brutas, desperd.etc','Gallium, hafnium, indium, niobium, etc.unwrought, waste, etc.','Galio, niobio, etc.en bruto, desperd.etc',10,'81','8112','811292');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81129900','Obras de gálio, hafnio, índio, nióbio, renio e tálio','Articles of gallium, hafnium, indium, niobium, rhen.thal.','Manufacturas de galio, hafnio, indio, niobio, renio y talio',10,'81','8112','811299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81130010','Chapas, folhas, tiras, fios, hastes.etc.de ceramais','Plastes/strips/sheets/wires, etc.of cermets','Chapas, hojas, tiras, hilos, astas.etc.de cermet',10,'81','8113','811300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('81130090','Outras obras de ceramais, desperd.e resíduos de ceramais','Other cerments articles, including waste and scrap','Las demás manuf.de cermet, desperd.y desechos de cermet',10,'81','8113','811300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82011000','Pás de metais comuns','Spades of common metals','Palas de metales comunes',10,'82','8201','820110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82012000','Forcados e forquilhas, de metais comuns','Forks of common metals','Horcas de labranza, de metales comunes',10,'82','8201','820120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82013000','Alviões, picaretas, enxadas, sachos, etc.de metais comuns','Mattocks, picks, hoes, etc.of common metals','Azadas, picos, binaderas, rastrillos, etc.de met.comunes',10,'82','8201','820130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82014000','Machados, podões e outras ferramentas com gume, de metais comuns','Axes, bill hooks and other hewing tools, of common metals','Hachas, hocinos y otras herram.c/filo, de metales comunes',10,'82','8201','820140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82015000','Tesouras de podar, manipuladas c/1 mao, de metais comuns','Scissors of pruning,  manipul.with 1 hand, common metals','Tijeras de podar, p/usar c/1 sola mano, de met.comunes',10,'82','8201','820150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82016000','Tesouras p/sebes, etc.manipul.c/2 maos, de metais comuns','Hedge shears, etc.manipul.with 2 hands, of common metals','Cizallas p/setos, etc.p/usar c/2 manos, de met.comunes',10,'82','8201','820160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82019000','Outs.ferram.manuais, p/agricultura, etc.de metais comuns','Ot.hand tools of a kind used in agric.etc.common metals','Las demás herram.de mano agrícolas, etc.de met.comunes',10,'82','8201','820190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82021000','Serras manuais, de metais comuns','Hand saws, of common metals','Sierras de mano, de metales comunes',10,'82','8202','820210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82022000','Folha de serras de fita, de metais comuns','Band saw blades, of common metals','Hojas de sierras de cinta, de metales comunes',10,'82','8202','820220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82023100','Folha de serras circ.de metais comuns, parte operant.aco','Circ.saws blade, com.metals, with working part of steel','Hoja de sierras circ.de met.comunes, parte operant.acero',10,'82','8202','820231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82023900','Outs.folhas de serras circ.de metais comuns, incl.partes','Other circular saws blade, of common metals, incl.parts','Las dem.hjs.de sierras circ.de met.comunes, incl.partes',10,'82','8202','820239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82024000','Correntes cortantes de serras, de metais comuns','Chain saw blades, of common metals','Cadenas cortantes de sierras, de metales comunes',10,'82','8202','820240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82029100','Folha de serras retil.de metais comuns, p/trabalh.metais','Straig.saws blades, of base metals, for working metals','Hoja de sierras rectil.de met.comunes, p/trabaj.metales',10,'82','8202','820291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82029910','Folha de serras, reta, n/dent.de met.comuns, p/serr.pedras','Straigh.saws blade, toothless, bas.met., f/saws stone','Hoja de sierras, recta, s/dent.de met.com., p/aser.piedr.',10,'82','8202','820299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82029990','Outras folhas de serras, de metais comuns','Other blades saws, of base metals','Las demás hojas de sierras, de metales comunes',10,'82','8202','820299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82031010','Limas e grosas, de metais comuns','Files and rasps, of base metals','Limas y escofinas, de metales comunes',10,'82','8203','820310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82031090','Outras ferramentas manuais, de metais comuns, igual limas','Other hand tools, of base metals, equal files','Las dem.herramientas de mano, de met.comunes, igual limas',10,'82','8203','820310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82032010','Alicates de metais comuns','Pliers of base metals','Alicates de metales comunes',10,'82','8203','820320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82032090','Tenazes, pincas, ferram.manuais semelh.de metais comuns','Pincers, tweezers, similar hand tools, of common metals','Tenazas, pinzas, herram.de mano simil.de metales comunes',10,'82','8203','820320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82033000','Cisalhas p/metais, ferram.manuais semelh.de met.comuns','Metal cutting shears, similar hand tools, of base metals','Cizallas p/metales, herram.de mano simil.de met.comunes',10,'82','8203','820330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82034000','Corta-tubos e ferram.manuais semelh.de metais comuns','Pipe-cutters, similar hand tools, of base metals','Cortatubos y herram.de mano simil.de metales comunes',10,'82','8203','820340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82041100','Chaves de porcas, manuais, de abert.fixa, de metais comuns','Hand-operated spanners, non-adjustable, of base metals','Llaves de ajuste de mano, de boca fija, de met.comunes',10,'82','8204','820411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82041200','Chaves de porcas, manuais, de abert.variav.de met.comuns','Hand-operated spanners, adjustable, of base metals','Llaves de ajuste de mano, de boca variab., de met.comunes',10,'82','8204','820412');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82042000','Chaves de caixa intercambiav.incl.c/cabos, de met.comuns','Interchang.spanner sockets, incl.handles, of base metals','Llaves de ajuste intercamb.incl.c/mango, de met.comunes',10,'82','8204','820420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82051000','Ferramentas manuais de furar/roscar, de metais comuns','Drilling, threading or tapping tools, of base metals','Herramientas de mano de taladrar/roscar, de met.comunes',10,'82','8205','820510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82052000','Martelos e marretas, manuais, de metais comuns','Hammers and sledge hammers, manuals, of base metals','Martillos y mazas, de mano, de metales comunes',10,'82','8205','820520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82053000','Plaina/ferram.manuais cort.de met.comuns, p/trab.madeira','Planes, hand tools sim.cutt.tools, base metal, f/work.wood','Cepillos/herr.de mano cort.de met.comunes, p/trab.madera',10,'82','8205','820530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82054000','Chaves de fenda, manuais, de metais comuns','Screwdrivers, manuals, of base metals','Destornilladores, de mano, de metales comunes',10,'82','8205','820540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82055100','Outras ferramentas manuais, de metais comuns, uso domest.','Other hand tools, of base metals, use domestic','Las dem.herramientas de mano, de met.comunes, uso domést.',10,'82','8205','820551');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82055900','Outras ferramentas manuais, de metais comuns, nao domest.','Other hand tools, of base metals, not domestic uses','Las demás herramientas de mano, de met.comunes, n/domést.',10,'82','8205','820559');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82056000','Lamparinas/lâmpadas de soldar, e semelh.de metais comuns','Blow-lamps, and similar of base metals','Lámparas de soldar, y simil.de metales comunes',10,'82','8205','820560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82057000','Tornos de apertar, sargentos e semelh.de metais comuns','Vices,  clamps and the like, of base metals','Tornillos de banco, prensas de carp.y simil.de met.com.',10,'82','8205','820570');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82058000','Bigornas, forjas-portat.mos c/armacao, uso manual/pedal','Anvils, port.forges hand/pedal-oper.grid.wheel.framework','Yunques, fragas portát.muellas c/bast.uso de mano/pedal',10,'82','8205','820580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82059000','Sortido de torno, bigorna, etc.manual/pedal, de met.comuns','Sets of lathe, anvils, etc.hand/pedal, of base metals','Juego de artíc., yunque, etc.de mano/pedal, de met.comunes',10,'82','8205','820590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82060000','Sortido de serras, limas, etc.uso manual, de metais comuns','Sets of saws, lime, etc.use manual, of base metals','Juego de sierras, limas, etc.uso de mano, de met.comunes',10,'82','8206','820600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82071300','Ferramentas de perfur.de met.comuns, parte oper.ceramais','Tools of perforat.basemetals, working parts of cerments','Útiles de perfor.de met.comunes, parte oper.cermet',10,'82','8207','820713');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82071900','Outs.ferramentas de perfur.etc.de met.comuns.incl.parte','Ot.tools of perforat., etc.of base metals, incl.parts','Útiles de perfor.etc.de met.comunes.incl.parte',10,'82','8207','820719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82072000','Fieiras de met.comuns, de estiragem/extrusão p/metais','Dies of base metals, of drawing/extruding f/metals','Hileras de met.comunes, de extrudir metal',10,'82','8207','820720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82073000','Ferramentas de embutir/estampar/puncionar, de met.comuns','Tools for pressing/stamping/punc, of base metals','Útiles de embutir/estampar/punzonar, de met.comunes',10,'82','8207','820730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82074010','Ferramentas de roscar interiormente, de metais comuns','Tools for internal threading, of base metals','Útiles de roscar interiormente, de metales comunes',10,'82','8207','820740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82074020','Ferramentas de roscar exteriormente, de metais comuns','Tools for external threading, of base metals','Útiles de roscar exteriormente, de metales comunes',10,'82','8207','820740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82075011','Brocas helicoidais, d<=52mm, de met.comuns, incl.diamantad','Helicoidals drills, d<=52mm, base metals, diamond-coated','Brocas helicoidales, d<=52mm, de met.com., incl.diamantad.',10,'82','8207','820750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82075019','Outras brocas de metais comuns, mesmo diamantadas','Other drills of base metals, incl.diamond-coated','Las demás brocas de metales comunes, incluso diamantadas',10,'82','8207','820750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82075090','Outras ferramentas de furar, de metais comuns','Other tools for drilling, of base metals','Los demás útiles de taladrar, de metales comunes',10,'82','8207','820750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82076000','Ferramentas de mandrilar ou de brochar, de metais comuns','Tools for boring or broaching, of base metals','Útiles de escariar o brochar, de metales comunes',10,'82','8207','820760');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82077010','Ferramentas de fresar de topo, de metais comuns','Face-milling tools, of base metals','Útiles de fresar frontales, de metales comunes',10,'82','8207','820770');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82077020','Ferramentas para cortar engrenagens, de metais comuns','Gear cutting hobs, of base metals','Útiles para tallar engranajes, de metales comunes',10,'82','8207','820770');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82077090','Outras ferramentas de fresar, de metais comuns','Other tools for milling, of base metals','Los demás útiles de fresar, de metales comunes',10,'82','8207','820770');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82078000','Ferramentas de tornear, de metais comuns','Tools for turning, of base metals','Útiles de tornear, de metales comunes',10,'82','8207','820780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82079000','Outras ferramentas intercambiaveis, de metais comuns','Other interchangeable tools, of base metals','Los demás útiles intercambiables, de metales comunes',10,'82','8207','820790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82081000','Facas/lâminas cort.de metais comuns, p/trab.metais','Knives/cutting blades of base metals, f/metal working','Cuchillas/hojas cort.de metales comunes, p/trab.metal',10,'82','8208','820810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82082000','Facas/lâminas cort.de metais comuns, p/trab.madeira','Knives/cutting blades of base metals, f/wood working','Cuchillas/hojas cort.de metales comunes, p/trab.madera',10,'82','8208','820820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82083000','Facas/lâminas cort.de metais comuns, p/apars.cozinha, etc','Knives/cut.blades of base metals, f/kitchen applian.etc','Cuchillas/hojas cort.de met.comunes, p/aparat.cocina, etc',10,'82','8208','820830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82084000','Facas/lâminas cort.de met.comuns, p/maqs.agricultura, etc','Knives/cutting blades of base metals, f/agricultural, etc','Cuchillas/hojas cort.de metales comunes, p/máq.agríc.etc',10,'82','8208','820840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82089000','Outs.facas/lâminas cort.de met.comum, p/maqs.apars.mecan','Oth.knives/cut.blades of base metals, f/mach.appl.mechan','Las dem.cuchillas/hojas cort.de met.com.p/máq.apar.mec.',10,'82','8208','820890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82090011','Plaquetas/pastilhas, intercamb.de ceramais, p/ferramentas','Plates/tabletes, interchangeable of cermets, f/tools','Plaquitas/pastillas, intercamb.de cermet, p/útiles',10,'82','8209','820900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82090019','Outs.plaquetas/pastilhas, de ceramais, n/montad.p/ferram.','Oth.plates/tabletes, of cermets, unmounted for tools','Las dem.plaquit./pastillas, inter.de cermet, s/mont.p/út.',10,'82','8209','820900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82090090','Varetas, pontas, etc.de ceramais, n/montados, p/ferramentas','Plastes, tips, etc.of cerments, unmouted, for tools','Varillas, puntas, etc.de cermet, s/montar, p/útiles',10,'82','8209','820900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82100010','Moinhos mecan.de acion.manual, p<=10kg, p/alimentos, etc.','Hand-operated mechanical mills, p<=10kg, f/foods, etc.','Molinos mecán.accion.a mano, p<=10kg, p/alimentos, etc',10,'82','8210','821000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82100090','Outs.apars.mecan.acion.manual, p<=10kg, p/alimentos, etc.','Oth.hand-operated mechanical appl., p<=10kg, f/foods, etc','Los dem.apars.mecán.accion.mano, p<=10kg, p/alimentos, etc',10,'82','8210','821000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82111000','Facas de lâmina cortante/serrilhad.e lâminas, em sortido','Knives with cutting blades/serrated and blades, assorted','Cuchillos c/hoja cortante/dentada y hojas, surtidos',11,'82','8211','821110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82119100','Facas de mesa, de lâmina fixa, de metais comuns','Table knives, having fixed blades, of base metals','Cuchillos de mesa, de hoja fija, de metales comunes',11,'82','8211','821191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82119210','Facas de cozinha/acougue, de lâmina fixa, de met.comuns','Kitc.kniv./butcher''s knives, hav.fixed blades, base met.','Cuchillos p/cocina/carnic.de hoja fija, de met.comunes',11,'82','8211','821192');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82119220','Facas para caça, de lâmina fixa, de metais comuns','Hunting knives, having fixed blades, of base metals','Cuchillos para caza, de hoja fija, de met.comunes',11,'82','8211','821192');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82119290','Outras facas de lâmina fixa, de metais comuns','Other knives having fixed blades, of base metals','Los demás cuchillos, de hoja fija, de met.comunes',11,'82','8211','821192');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82119310','Facas podadeiras e suas partes, de metais comuns','Folding knives and parts thereof, of base metals','Navajas de podar y sus partes, de met.comunes',11,'82','8211','821193');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82119320','Canivetes c/uma/varias laminas/outs.pecas, de met.comuns','Penknives with one blades/other parts, of base metals','Cortaplumas c/una/varias hojas/ots.piezas, de met.com.',11,'82','8211','821193');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82119390','Outras facas exc.de lâmina fixa, de metais comuns','Other knives except fixed blades, of base metals','Los dem.cuchillos, exc.de hoja fija, de metales comunes',11,'82','8211','821193');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82119400','Lâminas para facas, de metais comuns','Blades for knives, of base metals','Hojas para cuchillos, de metales comunes',10,'82','8211','821194');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82119500','Cabos de metais comuns para facas de metais comuns','Handles of base metal for knives of base metals','Mangos de metal común p/cuchillos de metales comunes',10,'82','8211','821195');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82121010','Navalhas de barbear, de metais comuns','Razors, of base metals','Navajas de afeitar, de metales comunes',11,'82','8212','821210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82121020','Aparelhos de barbear, não elétricos','Razor blades, non electric','Maquinillas de afeitar',11,'82','8212','821210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82122010','Lâminas de barbear, de segurança, de metais comuns','Safety razor blades, of safety, of base metals','Hojas para maquinillas de afeitar, de metales comunes',11,'82','8212','821220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82122020','Esboços de lâminas, em tiras, de metais comuns','Sketches blades, in strips, of base metals','Esbozos de hojas, en fleje, de metales comunes',11,'82','8212','821220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82129000','Outs.partes de navalhas/apars.de barbear, de met.comuns','Oth.parts of razors/razor blades, of base metals','Las dem.partes de navajas/apars.de afeitar, de met.com.',10,'82','8212','821290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82130000','Tesouras e suas lâminas, de metais comuns','Scissors and its blades, of base metals','Tijeras y sus hojas, de metales comunes',10,'82','8213','821300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82141000','Espátulas, abre-cartas, etc.e suas laminas, de met.comuns','Paper knives, letter openers, etc.its blades, base metals','Cortapapeles, abrecartas, etc.y sus cuchillas, de met.com.',10,'82','8214','821410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82142000','Utensil/sortido utensil.manicuro/pedicuro, de met.comuns','Manicure/pedicure sets and instruments, base metals','Herram./juegos herram.manicura/pedicura, de met.comunes',10,'82','8214','821420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82149010','Máquinas de tosquiar e suas partes, de metais comuns','Shearing machines and its parts, of base metals','Máquinas de esquilar y sus partes, de metales comunes',10,'82','8214','821490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82149090','Outros artigos de cutelaria de met.comuns, e suas partes','Oth.articles of cutlery of base metals and its parts','Los dem.art.de cuchillería de met.comunes, y sus partes',10,'82','8214','821490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82151000','Sortido de colher, etc.de met.comuns, c>=1 prat/dour/plat','Assortment spoon, etc.base metals, c>=1 silv/gold/platin.','Juego de cuchara, etc.de met.com., c>=1 plat/dor/platin.',10,'82','8215','821510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82152000','Outs.sortidos de colher, garfo, concha, etc.de met.comuns','Oth.assortment spoon, fork, ladle, etc.of base metals','Los dem.juegos de cuchara, tened., cuchar.etc.de met.com.',10,'82','8215','821520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82159100','Colher, garfo, concha, etc.de met.comuns, pratead/dour/plat','Spoon, fork, ladle, etc.of base metals, silv/gold/platin','Cuchara, tened., cuchar.etc.de met.com., platead/dor/plat',10,'82','8215','821591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82159910','Colheres, garfos, conchas, escumadeiras, etc.de aços inox.','Spoons, forks, ladles, skimmers, etc.of stainless steel','Cuchara, tened., cuchar., espum.etc de acero inox.',10,'82','8215','821599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('82159990','Outras colheres, garfos, conchas, etc.de metais comuns','Other spoons, forks, ladles, skimmers, etc.of base metals','Las dem.cuchara, tened., cuchar., etc de metales comunes',10,'82','8215','821599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83011000','Cadeados de metais comuns','Padlocks of base metals','Candados de metales comunes',10,'83','8301','830110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83012000','Fechaduras de metais comuns, para veículos automóveis','Locks of base metals, for motor vehicles','Cerraduras de metal común, para vehículos de motor',10,'83','8301','830120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83013000','Fechaduras de metais comuns, para móveis','Locks of base metals, for furniture','Cerraduras de metal común, para muebles',10,'83','8301','830130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83014000','Outras fechaduras e ferrolhos, de metais comuns','Other locks of base metals','Las dem.cerraduras y cerrojos, de metales comunes',10,'83','8301','830140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83015000','Fechos e armações c/fecho, c/fechadura, de metais comuns','Clasps/frames with clasps, incorpor.locks, of base metals','Cierres y monturas cierre, c/cerradura, de met.comunes',10,'83','8301','830150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83016000','Partes de cadeados, fechaduras, etc.de metais comuns','Padlocks parts, locks, etc.of base metals','Partes de candados, cerraduras, etc.de metales comunes',10,'83','8301','830160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83017000','Chaves de metais comuns, apresentadas isoladamente','Keys of base metals, presented separately','Llaves de metales comunes, presentadas aisladamente',10,'83','8301','830170');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83021000','Dobradiças de metais comuns, de qualquer tipo','Hinges of base metals, of any type','Bisagras de metales comunes, de cualquier clase',10,'83','8302','830210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83022000','Rodízios com armação, de metais comuns','Castors with frame, of base metals','Ruedas con montura, de metales comunes',10,'83','8302','830220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83023000','Outs.guarnições, etc.de metais comuns, p/veics.automóveis','Other mountings, etc.of base metals, f/motor vehicle','Las dem.guarniciones, etc.de met.comunes, p/vehícs.autom.',10,'83','8302','830230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83024100','Outras guarnições, etc.de metais comuns, p/construções','Other mountings, etc.of base metals, f/constructions','Las demás guarniciones, etc.de met.comunes, p/edificios',10,'83','8302','830241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83024200','Outras guarnições, etc.de metais comuns, para moveis','Other mountings, etc.of base metals, for furniture','Las demás guarniciones, etc.de met.comunes, p/muebles',10,'83','8302','830242');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83024900','Outras guarnições, etc.de metais comuns','Other mountings, etc.of base metals','Las demás guarniciones, etc.de metales comunes',10,'83','8302','830249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83025000','Pateras, porta-chapéus, cabides, etc.de metais comuns','Hat-racks, hat-pegs, brackets, etc.of base metals','Colgadores, perchas, soportes, etc.de metales comunes',10,'83','8302','830250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83026000','Fechos automáticos de metais comuns, p/portas','Automatic door closers of base metals','Cierrapuertas automáticos de metales comunes',10,'83','8302','830260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83030000','Cofres-fortes, portas blindadas, etc.de metais comuns','Reinforced safes, armored doors, etc.of base metals','Cajas de caudales, puertas blindadas, etc.de met.comunes',10,'83','8303','830300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83040000','Classificadores/outs.artefs.de escritório, de met.comuns','Classifiers/other articles of office, of base metals','Clasificadores/material simil.de oficina, de met.comunes',10,'83','8304','830400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83051000','Ferragens p/encadern.de fls.moveis, etc.de metais comuns','Fittinin.f/loose-leaf binders, files, etc.of base metals','Mecanismos p/encuad.de hjs.inter.etc.de metales comunes',10,'83','8305','830510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83052000','Grampos em barretas, de metais comuns','Staples in strips, of base metals','Grapas en tiras, de metales comunes',10,'83','8305','830520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83059000','Molas p/papéis, outs.objs.de escritório, de metais comuns','Springs for papers, oth.objects of office, of base metals','Molas p/papeis, outs.objs.de escritorio, de met.comunes',10,'83','8305','830590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83061000','Sinos, campainhas, gongos, etc.de metais comuns, n/eletr.','Bells, gongs, etc.of base metals, non-electric','Campanas, campan.gongos, etc.de met.com., q n/sean eléct.',10,'83','8306','830610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83062100','Estatuetas/obj.ornament.de met.comuns, pratead/dour/plat','Statuettes/oth.obj.of ornamentation, silv/gold/platin','Estatuillas/art.adorno, de met.comunes, platead/dor/plat.',10,'83','8306','830621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83062900','Outras estatuetas/objetos de ornament.de metais comuns','Oth.statuettes/oth.obj.of ornament.of base metals','Las demás estatuillas/art.adorno, de met.comunes',10,'83','8306','830629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83063000','Molduras p/fotografia, gravura, espelhos, de metais comuns','Frames f/photograph, picture, mirrors, of base metals','Marcos p/fotografía, grabados, espejos, de metales comunes',10,'83','8306','830630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83071000','Tubos flexiveis de ferro ou aço, mesmo com acessórios','Flexible tubing of iron or steel, including fittings','Tubos flexibles de hierro o acero, incluso c/accesorios',10,'83','8307','830710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83071010','Tubos flexíveis de aço, p/explot.submar.de petróleo/gas','Flexib.tubingof steel, f/submarine explor.of petrol./gas','Tubos flexibles de acero, p/expl.submar.de petróleo/gas',10,'83','8307','830710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83071090','Outros tubos flexíveis de ferro ou aço','Other flexible tubing of iron or steel','Los demás tubos flexibles de hierro o acero',10,'83','8307','830710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83079000','Tubos flexíveis de outros metais comuns','Other flexible tubing of other base metal','Tubos flexibles de los demás metales comunes',10,'83','8307','830790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83081000','Grampos/colchetes/ilhoses, de met.comuns, p/vestuário, etc','Clasps/brackets/eyelets, of base metals, f/clothing, etc','Ganchos/corchetes/anillos, de met.com., p/pren.vestir, etc',10,'83','8308','830810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83082000','Rebites tubulares ou de haste fendida, de metais comuns','Tubular or bifurcated rivets, of base metals','Remaches tubulares o c/espiga hendida, de metales comun.',10,'83','8308','830820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83089010','Fivelas de metais comuns','Buckles of base metals','Hebillas de metales comunes',10,'83','8308','830890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83089020','Contas e lantejoulas, de metais comuns','Beads and spangles, of base common','Cuentas y lentejuelas, de metales comunes',10,'83','8308','830890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83089090','Outs.fechos, etc.de met.comuns, p/vestuário, calçados, etc.','Oth.clasps, etc.of base metals, f/clothing, footwear, etc','Los dem.cierres, etc.de met.com.p/prend.vestir, calz.etc',10,'83','8308','830890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83091000','Capsulas de coroa, de metais comuns, p/embalagem','Crown corks, of base metals, for packing','Tapas corona, de metales comunes, p/envases',10,'83','8309','830910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83099000','Rolhas, outs.tampas e acess.p/embalagem, de metais comuns','Stoppers, oth.covers and acces.f/packing, of base metals','Tapones, dem.tapas y acces.p/envases, de metales comunes',10,'83','8309','830990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83100000','Placas indicadoras, sinaliz.etc.de metais comuns, n/eletr','Sign-plates, name-plates, etc.of base metals, non-eletric','Placas indicadoras, sinaliz.etc.de met.com.q n/sean eléc',10,'83','8310','831000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83111000','Eletrodos revest.exter.p/soldar a arco, de metais comuns','Coated electrodes of base metal, f/electric arc-welding','Electrodos recub.exter.p/soldadura de arco, de met.común',10,'83','8311','831110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83112000','Fios revest.interiorm.p/soldar a arco, de metais comuns','Cored wire of base metal, for electric arc-welding','Alambre rellen.interiorm.p/soldad.de arco, de met.común',10,'83','8311','831120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83113000','Varetas e fios, revest.p/soldar a chama, de metais comuns','Coat.rod and cored wire, of base metal, f/solder.by flame','Varillas rec.y alamb.rell.p/sold.al soplete, de met.com.',10,'83','8311','831130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('83119000','Outros fios, varetas, tubos, chapas, etc.de metais comuns','Other wire, rods, tubes, plates, etc.of base metals','Los dem.alambres, varillas, tubos, placas, etc.de met.com.',10,'83','8311','831190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84011000','Reatores nucleares','Nuclear reactors','Reactores nucleares',11,'84','8401','840110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84012000','Máquinas e aparelhos p/separação de isotopos, e partes','Machinery and apparatus f/isotopic separ., and its parts','Máquinas y aparatos p/separación isotópica, y partes',10,'84','8401','840120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84013000','Elementos combustiv.n/irradiados, para reatores nucleares','Fuel elements, non-irradiated, f/nuclear reactors','Elementos combustib.s/irradiar, p/reactores nucleares',10,'84','8401','840130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84014000','Partes de reatores nucleares','Parts of nuclear reactors','Partes de reactores nucleares',10,'84','8401','840140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84021100','Caldeiras aquatubulares, com produção de vapor>45t/hora','Watertube boilers with a steam production>45t/hora','Calderas acuotubulares, con producción de vapor>45t/hora',11,'84','8402','840211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84021200','Caldeiras aquatubulares, com produção de vapor<=45t/hora','Watertube boilers with a steam production<=45t/hora','Calderas acuotubulares, con producción de vap.<=45t/hora',11,'84','8402','840212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84021900','Outras caldeiras p/produção de vapor, incl.caldeira mist','Other vapour generating boilers, incl.hybrid boilers','Las dem.calderas p/produc.de vapor, incl.caldera mixt.',11,'84','8402','840219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84022000','Caldeiras denominadas "de agua superaquecida"','"super-heated" water boilers','Calderas denominadas de agua sobrecalentada',11,'84','8402','840220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84029000','Partes de caldeiras de vapor e "de agua superaquecida"','Parts of vapour boilers and " of super-heated water"','Partes de calderas de vapor y agua sobrecalentada',10,'84','8402','840290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84031010','Caldeiras p/aquecimento central, cap<=200000 kcal/hora','Central heating boilers, cap<=200000 kcal/hour','Calderas p/calefacción central, cap<=200000 kcal/hora',11,'84','8403','840310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84031090','Outras caldeiras p/aquecimento central','Other boilers for central heating','Las demás calderas p/calefacción central',11,'84','8403','840310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84039000','Partes de caldeiras p/aquecimento central','Other boilers for central heating','Partes de calderas p/calefacción central',10,'84','8403','840390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84041010','Aparelhos auxil.p/caldeiras de vapor/"agua superaquec."','Auxiliary plant f/vapour boilers/"super-heated water"','Las demás calderas p/calefacción central',11,'84','8404','840410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84041020','Aparelhos auxiliares p/caldeiras de aquecimento central','Auxiliary plant for central heating boilers','Aparatos auxiliares p/calderas de calefacción central',11,'84','8404','840410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84042000','Condensadores para máquinas a vapor','Condensers for steam machines','Condensadores p/máquinas a vapor',11,'84','8404','840420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84049010','Partes de aparelhos auxiliares p/caldeiras de vapor, etc','Parts of auxiliary plant for vapour boilers, etc','Partes de aparatos auxiliares p/calderas de vapor, etc',10,'84','8404','840490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84049090','Partes de aparelhos auxil.p/caldeiras aquecim.central','Parts of auxiliary plant for central heating boilers','Partes de aparatos aux.p/calderas de calef.central, etc',10,'84','8404','840490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84051000','Geradores de gas de ar/gas de agua/de acetileno, etc.','Producer gas/water gas generators, of acetylene, etc','Generadores de gas de aire/gas de agua/de acetileno, etc',11,'84','8405','840510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84059000','Partes de geradores de gas de ar/gas de agua, etc.','Parts of producer gas/water gas generators, etc','Partes de generadores de gas de aire/gas de agua, etc',10,'84','8405','840590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84061000','Turbinas a vapor, p/propulsao de embarcações','Vapour turbines, for marine propulsion','Turbinas a vapor, p/la propulsión de barcos',11,'84','8406','840610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84068100','Outras turbinas a vapor, de potência > 40 mw','Other vapour turbines, of potency>40mw','Las demás turbinas a vapor, de potencia>40mw',11,'84','8406','840681');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84068200','Outras turbinas a vapor, de potência <= 40 mw','Other vapour turbines, of potency<=40mw','Las demás turbinas a vapor, de potencia<=40mw',11,'84','8406','840682');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84069000','Partes de turbinas a vapor','Parts of vapour turbines','Partes de turbinas de vapor',10,'84','8406','840690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84069011','Rotores de turbinas a reacao, a vapor, de multipl.estag.','Rotors of turbines reaction, vapour, of multiple stages','Rotores de turbinas a reac.de vapor, de multipl.estag.',10,'84','8406','840690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84069019','Outros rotores de turbinas a vapor','Other rotors of vapour turbines','Los demás rotores de turbinas de vapor',10,'84','8406','840690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84069021','Palhetas fixas (de estator) de turbinas a vapor','Fixed slats (of stators) of vapour turbines','Paletas fijas (de estator) de turbinas de vapor',10,'84','8406','840690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84069029','Outras palhetas de turbinas a vapor','Other slats of vapour turbines','Las demás paletas de turbinas de vapor',10,'84','8406','840690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84069090','Outras partes de turbinas a vapor','Other parts of vapour turbines','Las demás partes de turbinas de vapor',10,'84','8406','840690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84071000','Motores de explosão, para aviação','Combustion engines, for aviation','Motores de explosión, de aviación',11,'84','8407','840710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84072110','Motores de explosão, p/embarcação, "outboard", monocil.','Combustion engines, f/embarkation, "outboard", single cyl.','Motores de explosión, p/prop.barcos, "outboard", monocil.',11,'84','8407','840721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84072190','Outros motores de explosão, para embarcação, "outboard"','Other combustion engines, f/embarkation, "outboard"','Los demás motores de explosión, p/prop.barcos, "outboard"',11,'84','8407','840721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84072910','Outros motores de explosão, p/embarcação, monocilíndricos','Other combustion engines, f/embarkation, single cylinder','Los demás motores de explosión, p/prop.barcos, monocilín.',11,'84','8407','840729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84072990','Outros motores de explosão, para embarcação','Other combustion engines, for embarkation','Los demás motores de explosión, p/la prop.barcos',11,'84','8407','840729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84073110','Motores de explosão, p/veic.do cap.87, ate 50cm3, monocil','Combust.engin., f/vehic.of ca.87, n/exc.50cm3, single cyl.','Motores de explosión, p/vehíc.del c.87, hasta 50cm3, monoc',11,'84','8407','840731');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84073190','Outros motores de explosão.p/veic.do cap.87, ate 50cm3','Oth.combustion engin.f/vehic.of c.87, n/exc.50cm3','Los dem.motores de explos.p/vehíc.del c.87, hasta 50cm3',11,'84','8407','840731');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84073200','Motores de explosão, p/veic.cap.87, sup.50cm3 ate 250cm3','Combustion engin.f/vehic.of c.87, ex>50cm3 n/exc<=250cm3','Motores de explos.p/vehíc.del c.87, >50cm3 pero<=250cm3',11,'84','8407','840732');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84073310','Motores de explosão, p/veic.cap.87, 250<cm3<=1000, monocil','Combust.engin.f/vehic.of c.87, 250<cm3<=1000, single cyl.','Motores de explos.p/vehíc.del c.87, 250<cm3<=1000, monoc.',11,'84','8407','840733');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84073390','Outros motores de explosão, p/veic.cap.87,  250<cm3<=1000','Oth.combust.engines, f/vehic.of cap.87, 250<cm3<=1000','Los dem.motores de explos.p/vehíc.cap.87,  250<cm3<=1000',11,'84','8407','840733');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84073410','Motores de explosão, p/veic.cap.87, sup.1000cm3, monocil.','Combust.engines, f/vehic.of c.87, exc.1000cm3, single cyl.','Motores de explos.p/vehíc.cap.87, sup.1000cm3, monocil.',11,'84','8407','840734');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84073490','Outros motores de explosão, p/veic.cap.87, sup.1000cm3','Oth.combust.engines, f/vehic.of c.87, exc.1000cm3','Los demás motores de explos.p/vehíc.cap.87, sup.1000cm3',11,'84','8407','840734');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84079000','Outros motores de explosão','Other combustion engines','Los demás motores de explosión',11,'84','8407','840790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84081010','Motores diesel/semidiesel, p/embarcação, tipo "outboard"','Diesel engines/semi-diesel, f/embarkat., type "outboard"','Motores diesel/semidiesel, p/prop.barcos, tipo "outboard"',11,'84','8408','840810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84081090','Outros motores diesel/semidiesel, para embarcação','Other diesel engines/semi-diesel, for embarkation','Los demás motores diesel/semi-diesel, p/prop.de barcos',11,'84','8408','840810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84082010','Motores diesel/semidiesel, p/veic.do cap.87, ate 1500cm3','Diesel engines/semi-diesel, f/vehic.cap.87, n/exc.1500cm3','Motores diesel/semi-diesel, p/vehíc.cap.87, hasta 1500cm3',11,'84','8408','840820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84082020','Motores diesel/semidiesel, p/veic.cap.87,  1500<cm3<=2500','Diesel engines/semi-diesel, f/vehic.c.87, 1500<cm3<=2500','Motores diesel/semidiesel, p/vehíc.cap.87, 1500<cm3<=2500',11,'84','8408','840820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84082030','Motores diesel/semidiesel, p/veic.cap.87,  2500<cm3<=3500','Diesel engines/semi-diesel, f/vehic.c.87, 2500<cm3<=3500','Motores diesel/semidiesel, p/vehíc.cap.87, 2500<cm3<=3500',11,'84','8408','840820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84082090','Outros motores diesel/semidiesel, p/veic.do cap.87','Other diesel engines/semi-diesel, f/vehic.of cap.87','Los demás motores diesel/semi-diesel, p/vehíc.del cap.87',11,'84','8408','840820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84089010','Outs.motores diesel, estacionarios, pot>=337.5kw, rpm>1000','Other diesel engines, stationary, p>=337.5kw, rpm>1000','Los demás motores diesel, estacionar.p>=337.5kw, rpm>1000',11,'84','8408','840890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84089090','Outros motores diesel/semidiesel','Other diesel engines/semi-diesel','Los demás motores diesel/semi-diesel',11,'84','8408','840890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84091000','Partes de motores para aviação','Parts for aircraft engines','Partes de motores de aviación',10,'84','8409','840910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099111','Bielas para motores de explosão','Connecting rods for combustion engines','Bielas para motores de explosión',11,'84','8409','840991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099112','Blocos de cilindros, cabeçotes, etc.p/motores de explosão','Cylinder blocks, cylinder heads, etc.f/combustion engines','Bloques de cilindros, culatas, etc.p/motores de explosión',11,'84','8409','840991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099113','Carburadores para motores de explosão','Carburetors for combustion engines','Carburadores para motores de explosión',11,'84','8409','840991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099114','Válvulas de admissao ou de escape, p/motores de explosão','Valves of admission or of escape, for combustion engines','Válvulas de admisión o de escape, p/motores de explosión',11,'84','8409','840991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099115','Coletores de admissao ou escape, p/motores de explosão','Collect.of admission or of escape, f/combustion engines','Tubos múlt.de admisión o escape, p/motores de explosión',11,'84','8409','840991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099116','Anéis de segmento, para motores de explosão','Rings of segment, for combustion engines','Aros de émbolo, para motores de explosión',11,'84','8409','840991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099117','Guias de válvulas, para motores de explosão','Valve guides, for combustion engines','Guías de válvulas, para motores de explosión',11,'84','8409','840991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099118','Outros carburadores para motores de pistão','Other carburetors for motors of piston','Los demás carburadores p/motores de pistón',11,'84','8409','840991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099120','Pistões ou embolos, para motores de explosão','Pistons, for combustion engines','Pistones o embolos p/motores de explosión',11,'84','8409','840991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099130','Camisas de cilindro, para motores de explosão','Cylinder liners, for combustion engines','Camisas de cilindro, p/motores de explosión',11,'84','8409','840991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099140','Injeção eletrônica, para motores de explosão','Electronic injection, for combustion engines','Inyección electrónica, p/motores de explosión',11,'84','8409','840991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099190','Outras partes para motores de explosão','Other parts for combustion engines','Las demás partes para motores de explosión',10,'84','8409','840991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099911','Bielas para motores diesel ou semidiesel','Connecting rods f/diesel engines or semi-diesel','Bielas para motores diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099912','Blocos de cilindros, cabecotes, etc.p/motores diesel/semi','Cylinder blocks, cylin.heads, etc.f/diesel engines/semi','Bloques de cilindros, culatas, etc.p/motores diesel/semi',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099913','Injetores para motores diesel ou semidiesel','Fuel nozzles for diesel or semi-diesel engines','Inyectores para motores diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099914','Válvulas de admissao ou de escape, p/motores diesel/semi','Valves of admission or of escape, f/diesel engines/semi','Válvulas de admisión o de escape, p/motores diesel/semi',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099915','Coletores de admissão ou escape, p/motores diesel/semi','Collect.of admission or of escape,  for diesel and semi-diesel engines','Tubos múlt.de admis.o de escape,  para motores diesel/semi',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099916','Anéis de segmento, para motores a diesel ou semidiesel','Rings of segment, for diesel engines or semidiesel','Aros de embolo, para motores a diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099917','Guias de válvulas, para motores diesel ou semidiesel','Valve guides,  for diesel or semi-diesel engines','Guías de válvulas,  para motores diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099920','Pistões ou embolos, para motores diesel ou semidiesel','Pistons,  for diesel or semi-diesel engines','Pistones o embolos,  para motores diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099921','Pistões/embolos,  d>=200mm, p/motores diesel/semidiesel','Other pistons,d>=200mm, for diesel or semi-diesel engines','Otros pistones o embolos, d>200mm, p/ motores diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099929','Outros pistoes ou embolos, p/motores diesel/semidiesel','Other pistons,  for diesel or semi-diesel engines','Otros pistones o embolos,  para motores diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099930','Camisas de cilindro, p/motores diesel ou semidiesel','Cylinder liners,  for diesel/semi-diesel engines','Camisas de cilindro,  para motores diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099941','Bielas com peso >=30k para motores diesel/semidiesel','Connecting rods, weight>=30kg, for diesel/semi-diesel engines','Bielas com peso >=30kg para motores diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099949','Outras bielas, para motores diesel/semidiesel','Other connecting rods for diesel/semi-diesel engines','Otras bielas para motores diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099951','Cabeçotes, com d>=200mm, para motores/semidiesel','Cylinder heads, with d>=200mm for diesel/semi-diesel engines','Culatas, com d>=200mm para motores diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099959','Outros cabeçotes para motores diesel/semidiesel','Other cylinder heads for diesel/semi-diesel engines','Otras culatas para motores diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099961','Injetores/bicos injet.c/d>=20mm p/motores diesel/semidi','Fuel injectors/nozzle, d>=20mm for diesel/semi-diesel engines','Inyectores/boquillas,  para motores diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099969','Outros injetores para motores diesel/semidiesel','Other fuel nozzles for diesel or semi-diesel engines','Otros inyectores para motores diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099971','Aneis de segmento, c/d>=200mm para motores diesel/semidi','Rings of segment,d>=200mm for diesel engines or semidiesel','Aros de embolo, c/d>=200mm, para motores a diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099979','Outros anéis de segmento,  p/motores diesel/semidiesel','Other rings of segmentf or diesel engines or semidiesel','Otros aros de embolo para motores a diesel o semi-diesel',11,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099990','Outras partes para motores diesel ou semidiesel','Other parts for diesel engines or semi-diesel','Las demás partes p/motores diesel o semi-diesel',10,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099991','Camisas de cilindro soldados a cabecote com d>=200mm','Cylinder welded shirts by head with a diameter>=200mm','Camisas de cilindro soldadas con la culata diametro>=200mm',10,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84099999','Outras partes para motores diesel e semidiesel','Other parts for diesel and half diesel engines','Otras partes para motores diesel y semidiesel',10,'84','8409','840999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84101100','Turbinas e rodas hidráulicas, de potência <= 1000kw','Hydraulic turbines and water wheels, potency<=1000kw','Turbinas y ruedas hidráulicas, de potencia<=1000kw',11,'84','8410','841011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84101200','Turbinas e rodas hidráulicas, 1000kw<potencia<=10000kw','Hydraulic turbines and water wheels, 1000kw<pot<=10000kw','Turbinas y ruedas hidráulicas, 1000kw<potencia<=10000kw',11,'84','8410','841012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84101300','Turbinas e rodas hidráulicas, de potência > 10000kw','Hydraulic turbines and water wheels, potency>10000kw','Turbinas y ruedas hidráulicas, de potencia>10000kw',11,'84','8410','841013');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84109000','Partes de turbinas e rodas hidráulicas, incl.reguladores','Parts of hydraulic turbines/water wheels, incl.regulat.','Partes de turbinas y ruedas hidráulic., incl.reguladores',10,'84','8410','841090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84111100','Turborreatores de empuxo <= 25kn','Turbo-jets of a thrust <= 25kn','Turborreactores de empuje <= 25kn',11,'84','8411','841111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84111200','Turborreatores de empuxo > 25kn','Turbo-jets of a thrust > 25kn','Turborreactores de empuje > 25kn',11,'84','8411','841112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84112100','Turbopropulsores de potência <= 1100kw','Turbo-propellers of potency <= 1100kw','Turbopropulsores de potencia <= 1100kw',11,'84','8411','841121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84112200','Turbopropulsores de potência > 1100kw','Turbo-propellers of potency > 1100kw','Turbopropulsores de potencia > 1100kw',11,'84','8411','841122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84118100','Outras turbinas a gás, de potência <= 5000kw','Other gas turbines, of potency <= 5000kw','Las demás turbinas de gas, de potencia <= 5000kw',11,'84','8411','841181');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84118200','Outras turbinas a gás, de potência > 5000kw','Other gas turbines, of potency > 5000kw','Las demás turbinas de gas, de potencia > 5000kw',11,'84','8411','841182');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84119100','Partes de turborreatores ou de turbopropulsores','Parts of turbo-jets or of turbo-propellers','Partes de turborreactores o de turbopropulsores',10,'84','8411','841191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84119900','Partes de outras turbinas a gás','Parts of other gas turbines','Partes de demás turbinas de gas',10,'84','8411','841199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84121000','Propulsores a reação, exc.os turborreatores','Reaction engines, except turbo-jets','Propulsores a reacción, exc.los turborreactores',11,'84','8412','841210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84122110','Cilindros hidráulicos','Hydraulic cylinders','Cilindros hidráulicos',11,'84','8412','841221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84122190','Outros motores hidráulicos, de movimento retilíneo','Ot.hydr.power eng.motors, with linear acting cylinders','Los demás motores hidráulicos, de movimiento rectilíneo',11,'84','8412','841221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84122900','Outros motores hidráulicos','Other hydraulic power motors','Los demás motores hidráulicos',11,'84','8412','841229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84123110','Cilindros pneumáticos','Hydraulic cylinders','Cilindros neumáticos',11,'84','8412','841231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84123190','Outros motores pneumáticos, de movimento retilíneo','Ot.pneumatic power motors, with linear acting cylinders','Los demás motores neumáticos, de movimiento rectilíneo',11,'84','8412','841231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84123900','Outros motores pneumáticos','Other pneumatic power motors','Los demás motores neumáticos',11,'84','8412','841239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84128000','Outros motores e máquinas motrizes','Other engines and motors','Los demás motores y máquinas motrices',11,'84','8412','841280');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84129010','Partes de propulsores à reação','Parts of reaction propellers','Partes de propulsores a reacción',10,'84','8412','841290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84129020','Partes de máquinas a vapor, de movimento retilíneo','Parts of vapour machines, with linear acting cylinders','Partes de máquinas de vapor, de movimiento rectilíneo',10,'84','8412','841290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84129080','Partes de motores hidraul/pneumat.de movim.retilíneo','Parts of hydraulic/pneumatic power motors, +++++movement','Partes de motores hidrául/neumát.de movim.rectilíneo',10,'84','8412','841290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84129090','Partes de outros motores e máquinas motrizes','Parts of other engines and motors','Partes de demás motores y máquinas motrices',10,'84','8412','841290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84131100','Bombas p/distrib.combustiv/lubrif.em póstos serviços, etc','Pumps f/dispensing fuel/lubric.in filling-stations, etc','Bombas p/distrib.combustib/lubrif.en puest.servicio, etc',11,'84','8413','841311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84131900','Outs.bombas p/líquidos c/disp.medidor/conceb.p/comport.','Pumps f/liquids with a measuring device/made f/sustain','Las dem.bombas p/líqu.c/disp.medidor/proy.p/llevarlo',11,'84','8413','841319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84132000','Bombas para líquidos, manuais','Hand pumps for liquids','Bombas para líquidos, manuales',11,'84','8413','841320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84133010','Bombas para gasolina/álcool, para motor a explosão','Pumps for gasoline/alcohol, for combustion engine','Bombas p/gasolina/alcohol, p/motor de explosión',11,'84','8413','841330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84133020','Bombas injetoras de combustível p/motor diesel/semi','Fuel injectors for diesel/semidiesel engine','Bombas inyectoras de combustible p/motor diesel/semi',11,'84','8413','841330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84133030','Bombas p/oleo lubrificante, p/motor explosão/diesel/semi','Pumps for lubric.oil, f/combustion engine diesel/semidie','Bombas p/aceite lubricante, p/motor explos./diesel/semi',11,'84','8413','841330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84133090','Outs.bombas p/combustíveis, etc.p/motor explosão/diesel/','Oth.pumps for fuels, etc.f/combustion engine diesel/semi','Las dem.bombas p/combustib.etc.p/motor explos./diesel/',11,'84','8413','841330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84134000','Bombas para concreto (betao)','Concrete pumps','Bombas para hormigón',11,'84','8413','841340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84135010','Bombas volumétricas alternativas,5hp<potencia<=600hp','Reciprocat.posit.displacement pumps, 5hp<potency<=600hp','Bombas volumétricas alternativas, 5hp<potencia<=600hp',11,'84','8413','841350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84135090','Outras bombas volumétricas alternativas','Other reciprocating positive displacement pumps','Las demás bombas volumétricas alternativas',11,'84','8413','841350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84136011','Bombas volumetr.rotativas, vazao<=300l/min.de engrenagem','Rotary positive displac.pumps, flow<=300l/min.of gear','Bombas volumétr.rotativas, caudal<=300l/min.de engranaje',11,'84','8413','841360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84136019','Outras bombas volumetricas rotativas, de vazao<=300l/min','Other rotary pos.displac.pumps, flow<=300l/min','Las dem.bomb.volumétricas rotativas, de caudal<=300l/min',11,'84','8413','841360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84136090','Outras bombas volumétricas rotativas','Other rotary positive displacement pumps','Las demás bombas volumétricas rotativas',11,'84','8413','841360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84137010','Eletrobombas submersíveis','Submersible electric pumps','Electrobombas sumergibles',11,'84','8413','841370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84137080','Outras bombas centrífugas, de vazão<=300litros/minuto','Other centrifugal pumps, flow<=300 liters/minutes','Las dem.bombas centrífugas, de caudal<=300litros/minuto',11,'84','8413','841370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84137090','Outras bombas centrífugas','Other centrifugal pumps','Las demás bombas centrífugas',11,'84','8413','841370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84138100','Outras bombas para líquidos','Other pumps for liquids','Las demás bombas p/líquidos',11,'84','8413','841381');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84138200','Elevadores de líquidos','Liquid elevators','Elevadores de líquidos',11,'84','8413','841382');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84139100','Partes de bombas para líquidos','Parts of pumps for liquids','Partes de bombas p/líquidos',10,'84','8413','841391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84139110','Hastes de bombeamento para extração de petróleo','Rods of pumping for extraction of oil','Astas de bombeo para extracción del petróleo',10,'84','8413','841391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84139190','Outras partes de bombas para líquidos','Other parts of pumps for liquids','Otras partes de bombas para líquidos',10,'84','8413','841391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84139200','Partes de elevadores de líquidos','Parts of elevators of liquids','Partes de elevadores de líquidos',10,'84','8413','841392');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84141000','Bombas de vácuo','Vacuum pumps','Bombas de vacío',11,'84','8414','841410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84142000','Bombas de ar, de mão ou de pé','Hand or foot-operated air pumps','Bombas de aire, de mano o pedal',11,'84','8414','841420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84143011','Motocompressor hermetico, capacidade<4700 frigorias/hora','Hermetic moto-compressor, capacity<4700 calories/hour','Motocompresor hermético, capacidad<4700 frigorias/hora',11,'84','8414','841430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84143019','Outs.motocompressores hermeticos p/equipam.frigoríficos','Oth.hermetic moto-compressors refrigerating equipment','Motocompresores herméticos p/equipos frigoríficos',11,'84','8414','841430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84143091','Compressor p/equipam.frigorífico, cap<=16000 frigorias/h','Compressor f/refrigerating equipm.cap<=16000 calories/h','Compresor p/equipo frigorífico, cap<=16000 frigorias/h',11,'84','8414','841430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84143099','Outros compressores para equipamentos frigoríficos','Other compressors for refrigerating equipment','Otros compresores para equipos frigoríficos',11,'84','8414','841430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84144010','Compressor de ar, de deslocamento alternativo','Air compressors, of alternative displacement','Compresor de aire, de desplazamiento alternativo',11,'84','8414','841440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84144020','Compressor de ar, de parafuso, mont.chassis/rebocáveis','Air compressor, of screw, moun.wheeled chassis f/towing','Compresor de aire, de tornillo, mont.chasis remolcable',11,'84','8414','841440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84144090','Outs.compressores de ar, mont.chassis c/rodas/rebocaveis','Oth.air compressors, mount.on a wheeled chassis f/towing','Compresores de aire, mont.chasis remolcable de ruedas',11,'84','8414','841440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84145110','Ventilador de mesa, c/motor elétrico, de potencia<=125w','Table fan, with electric motor, of potency<=125w','Ventilador de mesa, c/motor eléctrico, de potencia<=125w',11,'84','8414','841451');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84145120','Ventilador de teto, c/motor elétrico, de potencia<=125w','Celling fan, with electric motor, of potency<=125w','Ventilador de techo, c/motor eléctrico, de potencia<=125w',11,'84','8414','841451');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84145190','Outros ventiladores c/motor elétrico, de potencia<=125w','Other fans with electric motor, of potency<=125w','Los dem.ventiladores c/motor eléctrico, de pot<=125w',11,'84','8414','841451');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84145910','Microventiladores com área de carcaça < 90cm2','Micro-fans with bodies of a surface area<90cm2','Microventiladores c/área de carcaza<90cm2',11,'84','8414','841459');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84145990','Outros ventiladores','Other fans','Los demás ventiladores',11,'84','8414','841459');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84146000','Coifas com dimensão horizontal máxima <= 120cm','Hoods having a maximum horizontal side <= 120cm','Campanas en las q el mayor lado horizontal sea <=120cm',11,'84','8414','841460');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84148011','Outros compressores de ar, estacionários, de pistão','Other air compressors, stationary, of piston','Los dem.compresores de aire, estacionarios, de émbolo',11,'84','8414','841480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84148012','Outros compressores de ar, de parafuso','Other air compressors, of screw','Los compresores de aire, de tornillo',11,'84','8414','841480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84148013','Outs.compressores de ar, de lobulos paralelos ("roots")','Other air compressors, of parallel lobes ("roots")','Los dem.compres.de aire, de lóbulos paralelos ("roots")',11,'84','8414','841480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84148019','Outros compressores de ar','Other air compressors','Los demás compresores de aire',11,'84','8414','841480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84148021','Outs.turboaliment.de ar, p<=50kg, p/motor explosão/diesel','Oth.superchargers, w<=50kg, f/motor explosion/diesel','Los dem.turboalim.de aire, p<=50kg, p/motor explos/diesel',11,'84','8414','841480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84148022','Outs.turboaliment.de ar, p>50kg, p/motor explosão/diesel','Other superchargers, w>50kg, f/motor explosion/diesel','Los dem.turboalim.de aire, p<=50kg, p/motor explos/diesel',11,'84','8414','841480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84148029','Outros turbocompressores de ar','Other air tube compressors','Los demás turbocompresores de aire',11,'84','8414','841480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84148031','Outros compressores de gases, de pistão','Other compressors of gas, of piston','Los demás compresores de gases, de émbolo',11,'84','8414','841480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84148032','Outros compressores de gases, de parafuso','Other compressors of gas, of screw','Otros compresores de gases,  de tornillo',11,'84','8414','841480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84148033','Outs.compressores de gases, centrif.vazao max<22000 m3/h','Oth.compres.of gas, centrifugal, flow max<22000 m3/h','Otros compresesores de gases, centríf.caudal máx<22000 m3/h',11,'84','8414','841480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84148038','Outros compressores de gases, centrífugos','Other compressors of gas,  centrifugal','Los demás compresores de gases, centrífugos',11,'84','8414','841480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84148039','Outros compressores de gases','Other compressors of gas','Los demás compresores de gases',11,'84','8414','841480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84148090','Outs.bombas de ar/coifas aspirantes p/extração/reciclag','Other air pumps/extractor hoods f/extraction/recycling','Las dem.bombas de aire/campanas aspir.p/extrac/recicl.',11,'84','8414','841480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84149010','Partes de bombas de ar ou de vácuo','Parts of air or vacuum pumps','Partes de bombas de aire o de vacío',10,'84','8414','841490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84149020','Partes de ventiladores ou coifas aspirantes','Parts of fans or extractor hoods','Partes de ventiladores o campanas aspirantes',10,'84','8414','841490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84149031','Pistoes ou embolos, de compressores de ar/outros gases','Piston, of air compressors/other gas','Émbolos (pistones), de compresores de aire/demás gases',11,'84','8414','841490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84149032','Aneis de segmento, para compressores de ar ou outs.gases','Piston rings, for air compressors/other gas','Aros de émbolo, para compresores de aire o dem.gases',11,'84','8414','841490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84149033','Blocos de cilindros/cabecotes/carteres, p/compressores','Cylinder blocks/cylinder heads/sumps, f/compressors','Bloques de cilindros/culatas/carteres, p/compresores',11,'84','8414','841490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84149034','Válvulas de compressores de ar/outros gases','Valves of air compressors/other gas','Válvulas de compresores de aire/otros gases',11,'84','8414','841490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84149039','Outras partes de compressores de ar/outras gases','Other parts of air compressors/other gas','Las demás partes de compresores de aire/otros gases',10,'84','8414','841490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84151010','Apars.de ar condicion.cap<=30000 frig/h, p/janelas, etc.','Air-conditioning mac.cap<=30000 calories/h, f/window, etc','Apars.p/acondicion.cap<=30000 frig/h, p/ventanas, etc',11,'84','8415','841510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84151011','Apars.ar condic."split system", c<=30000frig/h, p/janelas','Air-condit.mac."split system", c<=30000 cal/h, f/window','Apars.acondic."split system", c<=30000frig/h, p/ventanas',11,'84','8415','841510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84151019','Outs.apars.de ar condicion.cap<=30000 frig/h, p/janelas','Oth.air-condition. mach.cap<=30000 cal/h, f/window','Apars.p/acondicion.cap<=30000 frig/h, p/ventanas',11,'84','8415','841510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84151090','Outros aparelhos de ar condicionado, p/janelas, etc.','Other air-conditioning machines, f/window, etc','Los demás aparatos p/acondicion., p/ventanas, etc',11,'84','8415','841510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84152010','Apars.de ar-condicionado, c<=30000f/h, p/veics.automóveis','Air-condition.mach., c<=30000 cal/h, f/motor vehicles','Apars.p/acondicion., c<=30000f/h, p/vehícs.automóviles',11,'84','8415','841520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84152090','Outros aparelhos de ar condicionado, p/veics.automóveis','Other air-conditioning machines, f/motor vehicles','Los dem.aparatos p/acondicion., p/vehícs.automóviles',11,'84','8415','841520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84158110','Outs.apars.de ar cond.c/disp.refrig.valv.inv.<=30000f/h','Ot.air-condition.mac.incor.refr.val.f/rever.<=30000 c/h','Los dem.apars.p/acond.c/equipo enfr.válv.inv.<=30000f/h',11,'84','8415','841581');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84158190','Outs.apars.de ar cond.c/disp.refrig.valv.inv.ciclo term','Oth.air-condit.mach.incor.refr.val.f/rever.heat cycle','Los dem.apars.p/acond.c/equipo enfr.válv.inv.ciclo térm',11,'84','8415','841581');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84158210','Outs.apars.de ar condicionado, c/disp.refrig.c<=30000f/h','Oth.air-condition.mach.incorp.refrig.unit c<=30000 c/h','Los dem.apars.p/acond.c/equipo enfriam.c<=30000f/h',11,'84','8415','841582');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84158290','Outs.aparelhos de ar condicionado, c/dispositivos refrig','Oth.air-condition.mach.incorporat.refrigerating unit','Los demás aparatos p/acondicion.c/equipo de enfriam.',11,'84','8415','841582');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84158300','Outs.aparelhos de ar condicionado, s/dispositivos refrig','Oth.air-condition.mach.n/incorp.refrigerating unit','Aparatos p/acondicion., s/equipo de enfriamiento',11,'84','8415','841583');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84159000','Partes de máquinas e aparelhos de ar condicionado','Parts of air-conditioning machines','Partes de máquinas y aparatos p/acondicion.',10,'84','8415','841590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84159010','Unid.evap.interna ar cond. split c/ cap<=30k frig/hora','Internal evaporating air conditioning unit','Unidade interna evaporadora de aire condicionado',10,'84','8415','841590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84159020','Unid.cond.externa ar cond. split c/ cap<=30k frig/hora','External air conditioning unit,split, cap<= 30 frig/h','Unidade externa de aire condicionado,split,cap. <=30f/h',10,'84','8415','841590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84159090','Outras unidades de ar condicionado','Other air conditioning units','Otras unidades de aire acondicionado',10,'84','8415','841590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84161000','Queimadores p/aliment.fornalhas, de combustiv.líquidos','Furnace burners for liquid fuel','Quemadores p/la aliment.hogares, de combustib.líquidos',11,'84','8416','841610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84162010','Queimadores p/aliment.fornalhas, de gases','Furnace burners for gas','Quemadores p/la alimentación de hogares, de gases',11,'84','8416','841620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84162090','Outs.queimadores p/aliment.de fornalhas, incl.os mistos','Other furnace burners, including combination burners','Los dem.quemadores p/aliment.de hogares, incl.los mixtos',11,'84','8416','841620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84163000','Fornalhas automáticas, incl.as antefornalhas, etc.','Mechanical stokers, includ.their mechanical grates, etc.','Aliment.mecán.de hogares, incl.los antehogares, etc',11,'84','8416','841630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84169000','Partes de queimadores, fornalhas automativas, etc.','Parts of burners, mechanical stokers, etc.','Partes de quemadores, aliment.mecán.de hogares, etc',10,'84','8416','841690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84171010','Fornos industriais, n/eletr.p/fusão de metais','Industrial furnaces, non-electric for melting of metals','Hornos industriales, q.n/sean eléctr.p/fusión de metales',11,'84','8417','841710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84171020','Fornos industriais, n/eletr.p/tratam.térmico de metais','Industrial furnaces, n/electric f/heat-treatm.of metals','Hornos industriales, q.n/sean eléctr.p/trat.térm.de met.',11,'84','8417','841710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84171090','Outs.fornos n/eletr.p/ustulacao, etc.de minérios/metais','Ot.furnaces, n/electric f/roasting, etc.of ores/metals','Los dem.hornos q.n/sean eléc.p/tost.etc de min.met./met',11,'84','8417','841710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84172000','Fornos industriais, n/eletr.de padaria, pastelaria, etc.','Industrial furnaces, n/electr.of bakery, pastry shop, etc.','Hornos indust.q.n/sean eléct.de panadería, pastelar., etc',11,'84','8417','841720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84178010','Fornos industriais, não elétricos, para cerâmica','Industrial furnaces, non electric, for ceramic','Hornos industriales, q.n/sean eléctr.p/cerámica',11,'84','8417','841780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84178020','Fornos industriais, não elétricos, para fusão de vidro','Industrial furnaces, non electric, for glass-melting','Hornos industriales, q.n/sean eléctr.p/fusión de vidrio',11,'84','8417','841780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84178090','Outros fornos industriais ou de laboratório, não elétricos','Other industrial or laboratory furnaces, n/electric','Los dem.hornos industriales o laborat.q.n/sean eléctr',11,'84','8417','841780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84179000','Partes de fornos industriais ou de laboratório, não elétricos','Parts of industrial or laboratory furnaces, n/electric','Partes de hornos industriales o de laborat.q.n/eléctr.',10,'84','8417','841790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84181000','Refrigeradores combin.c/congeladores, porta ext.separada','Refrigerators combin.with freezers, sepap.external doors','Combin.de refrigerador c/congelad.c/puerta ext.separada',11,'84','8418','841810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84182100','Refrigeradores de compressão, de uso doméstico','Refrigerators of compression, household type','Refrigeradores de compresión, de uso doméstico',11,'84','8418','841821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84182200','Refrigeradores de absorção, elétricos, de uso doméstico','Refrigerators of absorption, electrical, household type','Refrigeradores de absorción, eléctricos, de uso doméstico',11,'84','8418','841822');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84182900','Outros refrigeradores de uso doméstico','Other refrigerators of household type','Los demás refrigeradores de uso doméstico',11,'84','8418','841829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84183000','Congeladores (freezers) tipo cofre, capacidade<=800l','Freezers of the chest type, capacity<=800l','Congeladores (freezers) tipo arcón, capacidad<=800l',11,'84','8418','841830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84184000','Congeladores (freezers) tipo armario, capacidade<=900l','Freezers of the upright type, capacity<=900l','Congeladores (freezers) del tipo armario, capacid.<=900l',11,'84','8418','841840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84185010','Outros congeladores ("freezers")','Other freezers','Los demás congeladores ("freezers")',11,'84','8418','841850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84185090','Outs.refrigeradores, vitrinas, balcoes, etc.p/prod.de frio','Ot.refrigerating, cabinets, display coun.etc.f/freez.furn','Los dem.refrig., vitrinas, mostradores, etc.p/prod.de frío',11,'84','8418','841850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84186100','Outs.mats.máqs.apar.prod.frio, bomb.d/calor','Ot.mat.,mach.,appl.prod.cold,pump of heat ','Otr.mats.maqs.apar.prod.frío,bomb.d/calor',11,'84','8418','841861');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84186110','Equipamentos p/refrigeração/ar condicion.cap<=30000f/h','Equipments f/cooling/air-condition.cap<=30000 c/h','Equipos p/refrigeración/aire acondicion.cap<=30000f/h',11,'84','8418','841861');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84186190','Outs.grupos de compressão, condensador/trocador de calor','Oth.groups of compres.condenser/heat exchangers','Los dem.grupos de compres.condensador/intercam.de calor',11,'84','8418','841861');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84186910','Máquinas para preparação de sorvetes, não domésticas','Ice making machines, not of household type','Máquinas para fabricación de helados, no domésticas',11,'84','8418','841869');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84186920','Resfriadores de leite','Milk coolers','Enfriadores de leche',11,'84','8418','841869');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84186931','Unidades fornecedoras de água ou sucos','Cold water or fruit juice fountains','Unidades surtidoras de agua o jugos',11,'84','8418','841869');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84186932','Unidades fornecedoras de bebidas carbonatadas','Aerated beverage fountains','Unidades surtidoras de bebidas carbonatadas',11,'84','8418','841869');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84186940','Equip.p/refr/ar-cond.cap=<30.000 frigorias/h.','Equip. for cooling/air-cond.cap<=30000 c/h','Equipos p/refrigeración/aire acondicion.cap<=30000f/h',11,'84','8418','841869');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84186990','Outs.materiais/maqs.apars.p/prod.frio, e bombas de calor','Ot.mater./machinery f/freezing furniture, and heat pumps','Los dem.mater.máqs.apars.p/prod.frío, y bombas de calor',11,'84','8418','841869');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84186991','Resfriadores de água, de absorção por brometo de litio','Water coolers, with lithium bromide absorber','Enfriadores de agua, de absorción por bromuro de litio',11,'84','8418','841869');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84186999','Outs.materiais/maqs.apars.p/prod.frio, e bombas de calor','Ot.mater./machinery f/freezing furniture, and heat pumps','Los dem.mater.máqs.apars.p/prod.frío, y bombas de calor',11,'84','8418','841869');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84189100','Gabinetes/móveis p/receber equipamento p/prod.de frio','Furniture designed to receive refriger./freez.equipm.','Muebles conceb.p/incorporarles equipo p/prod.de frío',11,'84','8418','841891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84189900','Outras partes de refrigeradores, congeladores, etc.','Other parts of refrigerators, freezers, etc.','Las demás partes de refrigeradores, congeladores, etc',10,'84','8418','841899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84191100','Aquecedores de água, de aquecimento instantâneo, a gás','Instantaneous gas water heaters','Calentadores de agua, de calentamiento instantáneo, a gas',11,'84','8419','841911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84191910','Aquecedores solares de água','Solar powered water heaters','Calentadores solares de agua',11,'84','8419','841919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84191990','Outs.aquecedores de água, n/eletr.de aquecim.instant.etc','Other instantaneous water heaters, n/electric, etc','Los dem.calent.de agua, q.n/sean eléc.de calent.inst.etc',11,'84','8419','841919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84192000','Esterilizadores médico-cirúrgicos ou de laboratório','Medical, surgical or laboratory sterilisers','Esterilizadores médico, quirúrgicos o de laboratorio',11,'84','8419','841920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84193100','Secadores para produtos agrícolas','Dryers for agricultural products','Secadores para productos agrícolas',11,'84','8419','841931');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84193200','Secadores p/madeiras, pastas de papel, papéis ou cartões','Dryers for wood, paper pulp, paper or paperboard','Secadores p/maderas, pastas de papel, papeles o cartones',11,'84','8419','841932');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84193900','Outros secadores','Other dryers','Los demás secadores',11,'84','8419','841939');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84194010','Aparelhos de destilação de água','Machinery for distilling water','Aparatos de destilación de agua',11,'84','8419','841940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84194020','Aparelhos de destilação ou retificação, de alcoóis, etc.','Machinery for distilling or rectifying alcohols, etc','Aparatos de destilación/rectificación, de alcoholes, etc',11,'84','8419','841940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84194090','Outros aparelhos de destilação ou de retificação','Other distilling or rectifying plant','Los demás aparatos de destilación o rectificación',11,'84','8419','841940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84195010','Trocadores (permutadores) de calor, de placas','Heat exchange units, plate type','Intercambiadores de calor, de placas',11,'84','8419','841950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84195021','Trocadores (permutadores) de calor, tubulares, metálicos','Heat exchange units, tubular, metallic','Intercambiadores de calor, tubulares, metálicos',11,'84','8419','841950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84195022','Trocadores (permutadores) de calor, tubulares, de grafite','Heat exchange units, tubular, of graphite','Intercambiadores de calor, tubulares, de grafito',11,'84','8419','841950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84195029','Outros trocadores (permutadores) de calor, tubulares','Other heat exchange units, tubular','Los demás intercambiadores de calor, tubulares',11,'84','8419','841950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84195090','Outros trocadores (permutadores) de calor','Other heat exchange units','Los demás intercambiadores de calor',11,'84','8419','841950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84196000','Aparelhos e dispositivos p/liquefacao do ar/outs.gases','Machinery for liquefying air or other gases','Aparatos y dispositivos p/licuefac.de aire/ots.gases',11,'84','8419','841960');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84198110','Autoclaves p/prepar.de bebida quente/aquec.de alimento','Autoclaves for making hot drinks or for heating food','Autoclaves p/prepar.de bebida caliente/calent.alimento',11,'84','8419','841981');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84198190','Outs.aparelhos/disposit.p/prepar.de bebidas quentes, etc','Other machinery for making hot drinks, etc.','Los dem.aparatos/disposit.p/prepar.de beb.calientes, etc',11,'84','8419','841981');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84198910','Outros esterilizadores','Other sterilizers','Los demás esterilizadores',11,'84','8419','841989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84198911','Esterilizadores de aliment.uht, inj.vapor, cap>=6500 l/h','Food sterilizers.uht, vapour injection, cap>=6500 l/h','Esterilizadores de aliment.uht, inj.vapor, cap>=6500 l/h',11,'84','8419','841989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84198919','Outros esterilizadores','Other sterilizers','Los demás esterilizadores',11,'84','8419','841989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84198920','Estufas','Ovens','Estufas',11,'84','8419','841989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84198930','Torrefadores','Roasting plant','Tostadores',11,'84','8419','841989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84198940','Evaporadores','Evaporators','Evaporadores',11,'84','8419','841989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84198991','Recipiente refrigerador, c/disposit.circul.fluido refrig','Refrigerated container, with disp.refrigerant circulator','Recipiente refrigerador, c/disposit.circul.fluido refrig',11,'84','8419','841989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84198999','Outs.aparelhos e dispositiv.p/trat.mater.modif.temperat','Other machinery/dispositive f/treatm.mater.modif.temper','Los dem.aparatos y disposit.p/trat.mater.cambio temper.',11,'84','8419','841989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84199010','Partes de aquecedores de agua, n/eletr.aquecim.inst.etc.','Parts of instantaneous water heaters, non-eletric, etc.','Partes de calent.de agua, q.n/sean eléct.calent.inst.etc',10,'84','8419','841990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84199020','Partes de colunas de destilação ou de retificação','Parts of distilling or of rectifying columns','Partes de columnas de destilación o de retificación',10,'84','8419','841990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84199031','Placa corrugada, de aço inox/alumínio, troca term.s>0.4m2','Corrug.plate, of stainless steel/alumin.heat-excha>0.4m2','Placa corrugada, de acero inox./alum., camb.term.s>0.4m2',11,'84','8419','841990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84199039','Outras placas de trocadores (permutadores) de calor','Other plates of heat exchange units','Las demás placas de intercambiadores de calor',10,'84','8419','841990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84199040','Partes de aparelhos/disposit.p/prepar.bebida quente, etc','Other parts of machinery for making hot drinks, etc.','Partes de aparatos/disposit.p/prep.bebida caliente, etc',10,'84','8419','841990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84199090','Outs.partes de aparelhos/disposit.p/trat.modif.temperat','Oth.parts of machinery/disposit.f/treatm.modif.temperat','Las dem.partes de aparatos/disposit.p/trat.camb.temper.',10,'84','8419','841990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84201010','Calandras e laminadores, para papel ou cartão','Calendering/other rolling machines, for paper or paperb.','Calandrias y laminadores, para papel o cartón',11,'84','8420','842010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84201011','Calandras para papel ou cartão','Calendering, for paper or paperboard','Calandrias, para papel o cartón',11,'84','8420','842010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84201019','Outras calandras','Other calendering','Las demás calandrias',11,'84','8420','842010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84201021','Laminadores para papel ou cartão','Rolling machines f/paper or paperboard','Laminadores p/papel o cartón',11,'84','8420','842010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84201029','Outros laminadores','Other rolling machines','Los demás laminadores',11,'84','8420','842010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84201090','Outras calandras e laminadores','Other calendering or rolling machines','Las demás calandrias y laminadores',11,'84','8420','842010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84209100','Cilindros para calandras e laminadores','Cylinders for calendering or rolling machines','Cilindros para calandrias y laminadores',11,'84','8420','842091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84209900','Outras partes para calandras e laminadores','Other parts of calendering or rolling machines','Las demás partes p/calandrias y laminadores',10,'84','8420','842099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84211110','Desnatadeira centrífuga, cap.processam.leite>30000l/hora','Centrifuges cream separation, cap.proc.milk>30000l/hour','Desnatadora centrífuga, cap.procesam.leche>30000l/hora',11,'84','8421','842111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84211190','Outras desnatadeiras centrífugas','Other centrifuges cream separation','Las demás desnatadoras centrífugas',11,'84','8421','842111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84211210','Secador de roupa, centrífugo, cap.de roupa seca<=6kg','Clothes-dryers, centrifuge, cap.of dry clothes<=6kg','Secadora de ropa, centrífuga, cap.de ropa seca<=6kg',11,'84','8421','842112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84211290','Outros secadores de roupa, centrífugos','Other clothes-dryers, centrifuges','Las demás secadoras de ropa, centrífugas',11,'84','8421','842112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84211910','Centrífugador p/laborat.de analise, ensaio, pesq.cientif.','Laboratory centrifuges, f/analysis, scientific research','Centrifugador p/laborat.de anál., ensayo, inv.cientif.',11,'84','8421','842119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84211990','Outros centrífugadores','Other centrifuges','Otras centrifugadoras',11,'84','8421','842119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84212100','Aparelhos para filtrar ou depurar água','Machinery for filtering or purifying water','Aparatos para filtrar o depurar agua',11,'84','8421','842121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84212200','Aparelhos para filtrar ou depurar bebidas, exceto água','Machinery f/filtering or purifying beverages, exc.water','Aparatos para filtrar o depurar otras bebidas',11,'84','8421','842122');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84212300','Apars.p/filtrar óleos minerais nos motores explosao, etc','Machin.oil/ petrol-filters f/internal comb.engines, etc','Apars.p/filtrar lubricantes en los motores explos., etc',11,'84','8421','842123');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84212911','Hemodialisador tipo capilar','Dialysers capillary type','Hemodializador tipo capilar',11,'84','8421','842129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84212919','Outros hemodialisadores','Other dialysers','Los demás hemodializadores',11,'84','8421','842129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84212920','Aparelhos de osmose inversa','Reverse osmosis modules','Equipos de ósmosis inversa',11,'84','8421','842129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84212930','Filtros-prensas para líquidos','Filter presses for liquid','Filtros prensa para líquidos',11,'84','8421','842129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84212990','Outros aparelhos para filtrar ou depurar líquidos','Other machinery for filtering or purifying liquid','Los demás aparatos p/filtrar o depurar líquidos',11,'84','8421','842129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84213100','Filtros de entrada de ar para motores a explosão/diesel','Intake air filters f/internal combustion engines/diesel','Filtros de entrada de aire p/motores a explosión/diesel',11,'84','8421','842131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84213910','Filtros eletrostáticos para gases','Electrostatic filters for gases','Filtros electrostáticos para gases',11,'84','8421','842139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84213920','Depurador por convers.catalitica de gases de escap.veic','Purif.f/catalyt.convers.of motor vehicle exhaust gases','Depurador por convers.catalít.de gases de escap.vehíc.',11,'84','8421','842139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84213930','Concentrador de oxigênio por depuracao do ar, c<=6l/min','Oxygen concentrators for purifying air, c<=6l/min','Concentrador de oxígeno p/depuración de aire, c<=6l/min',11,'84','8421','842139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84213990','Outros aparelhos para filtrar ou depurar gases','Other machinary for filtering or purifying gases','Los demás aparatos para filtrar o depurar gases',11,'84','8421','842139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84219110','Partes de secadores de roupa, centrífugos, cap.roupa<=6kg','Parts of clothes-dryers, centrifuges, cap.clothes<=6kg','Partes de secadoras de ropa, centrifugas, cap.ropa<=6kg',10,'84','8421','842191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84219191','Tambores rotativos c/pratos/discos separadores, p>300kg','Rotative drums with plates/disks, w>300kg','Tambores rotativos c/platos/discos separadores, p>300kg',11,'84','8421','842191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84219199','Outras partes de centrífugadores','Other parts of centrifuges','Las demás partes de centrifugadoras',10,'84','8421','842191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84219910','Partes de outros aparelhos p/filtrar ou depurar gases','Parts of machinary f/filtering or purifying gases','Partes de otros aparatos p/filtrar o depurar gases',10,'84','8421','842199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84219920','Partes de apars.p/util.linhas de sangue p/hemodiálise','Mach.parts of a kind used as blood car.tube f/hemodial.','Partes de apars.util.en líneas de sangre p/hemodiálisis',10,'84','8421','842199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84219990','Partes de aparelhos para filtrar ou depurar líquidos, etc.','Machinery parts f/filtering or purifying liquid, etc.','Partes de aparatos p/filtrar o depurar líquidos, etc',10,'84','8421','842199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84219991','Cartuchos de membrana de aparelhos de osmose inversa','Membrane cartridges for reverse osmosis machinery','Cartuchos de membrana de apars.de ósmosis inversa',10,'84','8421','842199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84219999','Outs.partes de apars.p/filtrar ou depurar líquidos, etc.','Oth.machinery parts f/filtering or purifying liquid, etc','Las dem.partes de apars.p/filtrar o depurar líquid., etc',10,'84','8421','842199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84221100','Máquinas de lavar louça, do tipo doméstico','Dishwashing machines, of the household type','Máquinas de lavar vajilla, de tipo doméstico',11,'84','8422','842211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84221900','Outras máquinas de lavar louça','Other dishwashing machines','Las demás máquinas de lavar vajilla',11,'84','8422','842219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84222000','Máquinas e apars.p/limpar/secar garrafas/outs.recipient','Machinery f/cleaning/drying bottles/oth.containers','Máquinas y apars.p/limpiar/secar botellas/dem.recipient',11,'84','8422','842220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84223010','Máquinas e apars.p/encher/fechar/arrolhar, etc.garrafas','Machinery f/filling/closing/sealing, etc.bottles','Máquinas y apars.p/llenar/cerrar, tapar, etc botellas',11,'84','8422','842230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84223021','Máquinas e aparelhos p/encher caixas/sacos com po/graos','Machinery f/filling boxes/bags with powder/granules','Máquinas y apars.p/llenar cajas/sacos con polvo/granos',11,'84','8422','842230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84223022','Máquinas e apars.p/encher/fechar embalagem "tetra pack"','Machinery for  filling, closing packing "tetra pack"','Máquinas y apars.p/llenar/cerrar envases "tetra pack"',11,'84','8422','842230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84223023','Maqs.e apars.p/encher/fechar bisnagas, cap>=100 unid/min','Machinery for filling, closing tubes, cap>=100 unit/min','Máqs.y apars.p/llenar/cerrar bisnagas, cap>=100 unid/min',11,'84','8422','842230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84223029','Maqs.e apars.p/encher/fechar latas, capsular vasos, etc.','Machinery f/filling/closing/sealing cans, caps.vases, etc','Máqs.y apars.p/llenar/cerrar latas, capsular botel., etc',11,'84','8422','842230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84223030','Máquinas e aparelhos para gaseificar bebidas','Machinery to gasify drinks','Máquinas y aparatos para gasear bebidas',11,'84','8422','842230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84224010','Maqs.e apars.horizont.p/empacotar massa alim.longa, etc.','Machinery horiz.f/packing of long nutritious masses, etc','Máqs.y apars.horizont.p/empaquetar pasta alim.longa, etc',11,'84','8422','842240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84224020','Maqs.e apars.automat.p/embalar tubo/barra de metal, etc.','Automatic machinary f/packing tube/metal bar, etc','Máqs.y apars.automát.p/envolver tubo/barra de metal, etc',11,'84','8422','842240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84224030','Maqs.e apars.p/empacot.embalag.papel/cartão, cap>=5000/h','Machinary f/packing paper/paperboard, cap>=5000/h','Máqs.y apars.p/empaq.envolv.papel/cartón, cap>=5000/h',11,'84','8422','842240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84224090','Outs.máquinas e apars.p/empacotar/embalar mercadorias','Other machinery f/packing or wrapping goods','Máquinas y apars.p/empaquetar/envolver mercancías',11,'84','8422','842240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84229010','Partes de máquinas para lavar louças, de uso doméstico','Parts of dishwashing machines, domestic type','Partes de máquinas para lavar vajillas, uso doméstico',10,'84','8422','842290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84229090','Partes de maqs.e apars.p/limpar/secar/encher/fechar, etc','Machinery parts f/cleaning/drying/filling/closing, etc.','Partes de máqs.y apars.p/limp./secar/llenar/cerrar, etc',10,'84','8422','842290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84231000','Balanças para pessoas, incl.p/bebês e de uso doméstico','Person.weig.machines, incl.baby scales, household sclales','Balanzas para personas, incl.p/bebés y de uso doméstico',11,'84','8423','842310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84232000','Básculas de pesagem contínua em transportadores','Scales for continuous weighing of goods on conveyors','Básculas p/pesada continua sobre transportador',11,'84','8423','842320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84233011','Básculas dosadoras c/apars.periféricos c/unid.funcional','Functinoal units consist.of scales peripheral equipment','Básculas dosifidoras c/equip.periféricos c/unid.func.',11,'84','8423','842330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84233019','Outras básculas dosadoras','Other hopper scales','Las demás básculas dosifidoras',11,'84','8423','842330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84233090','Básculas de pesagem constante e básculas ensacadoras','Constant weighting scales/scales f/disc.pred.weig.mat.','Básculas p/pesada constante y las de descarg.en sacos',11,'84','8423','842330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84238110','Apars.e instrum.pesagem, de mesa, c<=30kg, c/disp.reg.etc.','Weighing machin., of table, c<=30kg, regist.devices, etc','Apars.y instrum.de pesar, de mesa, c<=30kg, c/disp.reg.etc',11,'84','8423','842381');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84238190','Outros aparelhos e instrumentos de pesagem, capac<=30kg','Other weighing machinery, cap<=30kg','Los demás apars.y instrum.de pesar, cap<=30kg',11,'84','8423','842381');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84238200','Aparelhos e instrumentos pesagem, 30kg<capac<=5000kg','Weighing machinery, 30kg<capacity<=5000kg','Aparatos y instrum.de pesar, 30kg<capacidad<=5000kg',11,'84','8423','842382');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84238900','Outros aparelhos e instrumentos de pesagem','Other weighing machinery','Los demás aparatos y instrum.de pesar',11,'84','8423','842389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84239010','Pesos para balanças','Weights for scales','Pesas para balanzas',10,'84','8423','842390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84239021','Partes de balancas p/pessoas, incl.p/bebes/uso doméstico','Parts of personal weig.mach., incl.baby/household','Partes de balanzas p/personas, incl.p/bebés/uso domést.',10,'84','8423','842390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84239029','Partes de outs.aparelhos e instrum.pesagem, incl.bascula','Parts of weighing machinery, incl.scale','Partes de dem.aparatos y instrum.de pesar, incl.báscula',10,'84','8423','842390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84241000','Extintores, mesmo carregados','Fire extinguishers, whether or not charged','Extintores, incluso cargados',11,'84','8424','842410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84242000','Pistolas aerográficas e aparelhos semelhantes','Spray guns and similar appliances','Pistolas aerográficas y aparatos similares',11,'84','8424','842420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84243010','Maqs.e apars.p/desobstrucao tubulacao, etc.de jato agua','Water jet projecting machinery for unblocking, etc.','Máqs.y apars.p/desobstruc.de cañerías, etc.p/chorro agua',11,'84','8424','842430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84243020','Maqs.e apars.p/desgaste localiz.vestuário, de jato areia','Sand blasting mach.f/produc.worn areas in apparel artic','Máqs.y apars.de chorro arena p/desg.localiz.prend.vest.',11,'84','8424','842430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84243030','Maqs.e apars.perfuradoras por jato agua, pressão>=10mpa','Water jet boring machines, pression>=10mpa','Máqs.y apars.perforadoras por chorro agua, pres.>=10mpa',11,'84','8424','842430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84243090','Outs.maqs.e apars.de jato de areia/jato de vapor, etc.','Other steam or sandblasting machines, etc','Las demás máqs.y apars.de chorro de arena/de vapor, etc',11,'84','8424','842430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84248111','Apars.manuais p/projetar, etc.prods.p/combate a pragas','Hand-operated to project, etc.for combat prague','Apars.manuales p/proyectar, etc.prods.p/fungicidas',11,'84','8424','842481');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84248119','Outs.aparelhos p/pulverizar fungicidas/inseticidas, etc.','Ot.mechanical appliances to spray fungicides/insec., etc','Los dem.apars.p/pulverizar fungicidas/insecticidas, etc',11,'84','8424','842481');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84248121','Irrigadores e sistemas de irrigação, por aspersão','Sprinklers and irrigations systems, for aspersion','Irrigadores y sistemas de riego, por aspersión',11,'84','8424','842481');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84248129','Outros aparelhos irrigadores e sistemas de irrigação','Other appliances sprinklers and system irrigations','Los demás aparatos irrigadores y sistemas de riego',11,'84','8424','842481');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84248190','Outros aparelhos para agrigultura ou horticultura','Other appliances for agricultural or horticultural','Los demás aparatos p/agrigultura u horticultura',11,'84','8424','842481');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84248900','Outros aparelhos mecânicos, p/projetar, etc.líquidos/pós','Other mechanical appl., f/projecting, etc.liquid/powders','Los demás aparatos mecanicos, p/proyectar, etc, líq/polvos',11,'84','8424','842489');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84248910','Apars.de pulveriz.c/bot.press.p/projet.liq.pos, espumas','Mach.sprayin.press.butt.f/project.liquid/powders, foams','Apars.de pulver.c/bot.pres.p/proyect.líq.polvos, espumas',11,'84','8424','842489');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84248920','Apars.automat.p/projetar lubrif.sobre pneus secag.a','Autom.appliances for projecting lubric. on pneum. with drying system by hot air','Apars.automat.p/proyect.lubrif.sobre pneum. com sistema de sec. c/ ar caliente',11,'84','8424','842489');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84248990','Outs.aparelhos mecânicos, p/projetar, etc.líquidos, pós','Oth.mechanic.appliances, f/projecting, etc.liquid, powders','Aparatos mecánicos, p/proyectar, etc.líquidos, polvos',11,'84','8424','842489');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84249010','Partes de extintores/aparelhos p/pulverizar, etc.manuais','Parts of fire extinguis./mach.f/spraying, etc.hand oper.','Partes de extintores/aparatos p/pulverizar, etc.manuales',10,'84','8424','842490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84249090','Partes de outs.apars.mecan.p/projetar, etc.liquid/po, etc','Parts of oth.mech.appliances f/projec., etc.liq/pow., etc','Partes de dem.apars.mecán.p/proyectar, etc.líq/polvo, etc',10,'84','8424','842490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84251100','Talhas, cadernais e moitões, de motor elétrico','Pulley tackle and hoists, powered by electric motor','Polipastos, con motor eléctrico',11,'84','8425','842511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84251910','Talhas, cadernais e moitões, manuais','Pulley tackle and hoists, hand-operated','Polipastos, manuales',11,'84','8425','842519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84251990','Outras talhas, cadernais e moitões','Other pulley tackle and hoists','Los demás polipastos',11,'84','8425','842519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84252000','Guinchos p/elevação/descida de gaiolas em minas, etc.','Pit-head wind.gear, winches spec.desig.f/use under.etc','Tornos p/ascenso/descenso de jaulas en pozos minas, etc',11,'84','8425','842520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84253110','Guinchos e cabrestantes, de motor elétrico, cap<=100t','Pit-head/capstans, powered by electric motor, cap<=100t','Tornos y cabrestantes, c/motor eléctrico, cap<=100t',11,'84','8425','842531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84253190','Outros guinchos e cabrestantes, de motor elétrico','Other pit-head/capstans, powered by electric motor','Los demás tornos y cabrestantes, c/motor eléctrico',11,'84','8425','842531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84253910','Outros guinchos e cabrestantes, cap<=100t','Other pit-head and capstans, cap<=100t','Los demás tornos y cabrestantes, cap<=100t',11,'84','8425','842539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84253990','Outros guinchos e cabrestantes','Other pit-head and capstans','Los demás tornos y cabrestantes',11,'84','8425','842539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84254100','Macacos elevadores fixos de veículos, p/garagens','Built-in jacking systems of a type used in garages','Gatos elevadores fijos de vehículos, en talleres',11,'84','8425','842541');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84254200','Macacos hidráulicos','Jacks and hoists, hydraulic','Gatos hidráulicos',11,'84','8425','842542');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84254910','Macacos manuais','Jacks and hoists, hand-operated','Gatos manuales',11,'84','8425','842549');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84254990','Outros macacos','Other jacks and hoists','Los demás gatos',11,'84','8425','842549');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84261100','Pontes e vigas, rolantes, de suportes fixos','Bridges and beams, rolling, of fixed supports','Puentes y vigas, rodantes, de soportes fijos',11,'84','8426','842611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84261200','Porticos moveis de pneumáticos e carros-pórticos','Mobile lifting frames on tyres and straddle carriers','Pórticos móviles sobre neumáticos y carretillas puente',11,'84','8426','842612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84261900','Outros pórticos e pontes-guindastes','Other porches and bridge-cranes','Los demás pórticos móviles y carretillas puente',11,'84','8426','842619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84262000','Guindastes de torre','Tower cranes','Grúas de torre',11,'84','8426','842620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84263000','Guindastes de pórtico','Portal or pedestal jib cranes','Grúas de pórtico',11,'84','8426','842630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84264100','Máquinas e aparelhos autopropulsores, de pneumáticos','Self-propelled machinery, on tyre','Máquinas y aparatos autopropulsados, sobre neumáticos',11,'84','8426','842641');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84264110','Maqs.apars.autopropulsados, de pneumáticos, cap>=60t','Machinery self-propelled, on tyre, cap>=60t','Máquinas y aparatos autopropuls.sobre neumáticos, c>=60t',11,'84','8426','842641');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84264190','Outs.maqs.e apars.autopropulsados, de pneumáticos','Other self-propelled machinery, on tyre','Las dem.máquinas y aparatos autopropul.sobre neumáticos',11,'84','8426','842641');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84264900','Outras máquinas e aparelhos autopropulsores','Other self-propelled machinery','Las dem.máquinas y aparatos autopropul.sobre neumáticos',11,'84','8426','842649');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84264910','Maqs.apars.autopropulsados, de esteiras, cap.elev>=70t','Self-propelled machinery track-laying, lifting capacity.>=70t','Máquinas y aparatos autopropul.de esteras, c>=70t',11,'84','8426','842649');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84264990','Outras máquinas e aparelhos autopropulsados','Other self-propelled machinery','Las demás máquinas y aparatos autopropulsados',11,'84','8426','842649');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84269100','Máquinas e aparelhos p/montagem em veículos rodoviários','Machinery of designed for mounting on road vehicles','Máquinas y aparatos p/montarlos sobre vehíc.carretera',11,'84','8426','842691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84269900','Cabreas e outros guindastes','Ships'' derricks and other cranes','Grúas y los demás aparatos de elevación sobre cable aér',11,'84','8426','842699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84271011','Empilhadeiras autopropulsoras, de motor eletr.cap>6.5t','Self-prop.fork-lift trucks, power.by electr.motor c>6.5t','Carret.apiladoras autopropuls.c/motor eléctr.cap>6.5t',11,'84','8427','842710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84271019','Outras empilhadeiras autopropulsoras, de motor elétrico','Oth.fork-lift trucks self-propelled, of electric motor','Las demás carret.apiladoras autopropuls.c/motor eléctr.',11,'84','8427','842710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84271090','Outros veículos p/movim.carga, autopropuls.c/motor eletr','Other vehic.f/movem.load, self-propelled, of electr.motor','Los dem.vehículos manip.c/disp., autoprop.c/motor eléct',11,'84','8427','842710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84272010','Outras empilhadeiras autopropulsoras, capacidade >6.5t','Other self-propelled fork-lift trucks, c>6.5t','Las demás carretillas apiladoras autopropuls., cap>6.5t',11,'84','8427','842720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84272090','Outros veículos para movimentar carga, autopropulsores','Oth.works trucks fitted handling equipm.self-propelled','Los demás vehículos de manip.c/dispos., autopropulsadas',11,'84','8427','842720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84279000','Outs.empilhadeiras/veics.p/movim.carga, c/disp.elevação','Ot.fork-lift trucks fitted with lifting/handling equipm','Las dem.carret.apil.vehículos de manip.c/disp.elevación',11,'84','8427','842790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84281000','Elevadores e monta-cargas','Lifts and skip hoists','Ascensores y montacargas',11,'84','8428','842810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84282010','Transportadores pneumat.tubulares moveis de motor>120hp','Pneumatic conveyors mobile appar.with engines>120hp','Trasvasadores neumát.tubulares móviles de motor>120hp',11,'84','8428','842820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84282090','Outros aparelhos elevadores/transportadores, pneumáticos','Other pneumatic elevators and conveyors','Otros aparatos elevadores/transportadores, neumáticos',11,'84','8428','842820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84283100','Apars.elevadores/transp.de mercadorias, p/uso subterran.','Machin.elevators/conveyors of goods, f/underground use','Apars.elevadores/transp.p/mercancías, p/trab.subterrán.',11,'84','8428','842831');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84283200','Aparelhos elevadores/transp.de mercadorias, de caçamba','Machin.elevators/conveyors of goods, bucket type','Aparatos elevadores/transp.de mercancías, de cangilones',11,'84','8428','842832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84283300','Apars.elevadores/transp.de mercadorias, de tira/correia','Machin.elevators/conveyors of goods, belt type','Apars.elevadores/transp.de mercancías, de banda/correa',11,'84','8428','842833');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84283910','Aparelhos elevadores/transp.de mercadorias, de correntes','Machin.elevators/conveyors of goods, chain type','Aparatos elevadores/transp.de mercancías, de cadenas',11,'84','8428','842839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84283920','Apars.elevadores/transp.de mercadorias, de rolos motores','Machin.elevators/conveyors of goods, motoriz.roller type','Apars.elevadores/transp.de mercanc.de rodillos motores',11,'84','8428','842839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84283930','Aparelhos de pinças laterais para transporte de jornais','Machin.of lateral tweezers f/transport of newspaper','Aparatos de pinzas laterales p/eltransporte de diarios',11,'84','8428','842839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84283990','Outs.apars.elevadores/transportadores de mercadorias','Other machinery elevators/conveyors of goods','Los dem.apars.elevadores/transportadores de mercancías',11,'84','8428','842839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84284000','Escadas e tapetes, rolantes','Escalators and moving walkways','Escaleras mecánicas y pasillos móviles',11,'84','8428','842840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84285000','Apars.p/empurrar vagonetas de minas e manip.veic.ferrov','Mine wagon pushers, locomot.and railway wagon hand.equip','Empujadores de vagonet.de minas/manip.mat.móv.carriles',11,'84','8428','842850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84286000','Teleféricos e mecanismos de tração para funiculares','Telefer.chair-lifts, ski-draglin.traction mechan.f/funic','Teleféricos y mecanismos de tracción p/funiculares',11,'84','8428','842860');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84289010','Máquinas e apars.p/desembarque de botes salva-vidas, etc','Machinery for disembarkation of lifeboats, etc','Máquinas y apars.p/desembarco de botes salva-vidas, etc',11,'84','8428','842890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84289020','Transportadores-elevadores automat.de deslocam.horiz.','Automat.transporter-elevators, with horizontal movement','Transportadores-elevadores automat.de desplazam.horiz.',11,'84','8428','842890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84289030','Máquina p/formação de pilhas de jornais, cap>=80000/hora','Machines f/piling periodicals top-to-tail, c>=80000/hour','Máquina p/formación de pilas de periód., cap>=80000/hora',11,'84','8428','842890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84289090','Outs.maqs.e apars.de elevação, de carga, de descarga, etc.','Other elevators machinery of loading or unloading, etc','Las dem.máqs.y apars.de elevación, carga, descarga, etc',11,'84','8428','842890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84291110','"Bulldozers" e "angledozers", de lagartas, de pot.>=520hp','Bulldozers and angledozers, of a flywheel power>=520hp','Topadoras frontales y angulares, de oruga, de p.>=520hp',11,'84','8429','842911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84291190','Outros "bulldozers" e "angledozers", de lagartas','Other bulldozers and angledozers, of a flywheel','Las demás topadoras frontales y angulares, de oruga',11,'84','8429','842911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84291910','Outros "bulldozers" de potência no volante>=315hp','Other bulldozers, of a flywheel power>=315hp','Las dem.topadoras frontales de pot.en el volante>=315hp',11,'84','8429','842919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84291990','Outros "bulldozers" e "angledozers"','Other bulldozers and angledozers','Las demás topadoras frontales y angulares',11,'84','8429','842919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84292010','Motoniveladores articulados, potencia no volante>=275hp','Articul.levellers with engin.of a flywheel power>=275hp','Motoniveladores articulados, potenc.en el volante>=275hp',11,'84','8429','842920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84292090','Outros niveladores','Other graders and levellers','Las demás niveladoras',11,'84','8429','842920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84293000','Raspo-transportadores, autopropulsores','Scrapers, self-propelled','Traíllas,  autopropulsoras',11,'84','8429','842930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84294000','Compactadores e rolos/cilindros compressores, autopropul','Tamping machines/road rollers, self-propelled','Compactadoras y apisionadoras, autopropulsadas',11,'84','8429','842940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84295111','Carregadoras-transportadoras, util.minas substerraneas','Loaders-carriers,  of a kind used in mines','Cargadoras transportadoras, util.en minas subterráneas',11,'84','8429','842951');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84295119','Outras carregadoras-transportadoras de carregam.frontal','Loaders-carriers,  of a kind used in mines','Las dem.cargadoras transportadoras de carga frontal',11,'84','8429','842951');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84295121','Infraestrutura motora, p/receber carregadoras, p>=609hp','Motive infrastructure, f/receiving loaders, w>=609hp','Infraestructura motriz apta p/mont.cargadoras, p>=609hp',11,'84','8429','842951');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84295129','Infraestrutura motora, para receber outras carregadoras','Motive infrastructure, for receiving other loaders','Infraestructura motriz apta p/mont.otrs.cargad.p>=609hp',11,'84','8429','842951');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84295190','Outs.carregadoras/pas-carregadoras, de carregam.frontal','Oth.loaders/shovel loaders, of front-end shovel loaders','Las demás cargadoras/palascargadoras, de carga frontal',11,'84','8429','842951');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84295191','Carregadoras/pas-carregadoras, de pot.no volante>=399hp','Loaders/shovel loaders, of a flywheel power>=399hp','Cargadoras/palas cargadoras, de pot.en el volante>=399hp',11,'84','8429','842951');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84295192','Carregadoras/pas-carregadoras, de pot.no volante<=59hp','Loaders/shovel loaders, of a flywheel power<=59hp','Cargadoras/palas cargadoras, de pot.en el volante<=59hp',11,'84','8429','842951');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84295199','Outs.carregadoras/pas-carregadoras, de carregam.frontal','Oth.loaders/shovel loaders, of front-end shovel loaders','Las demás cargadoras/palas cargadoras, de carga frontal',11,'84','8429','842951');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84295210','Escavadeiras cap.efet.rotacao=360graus, cap.carga>=19m3','Diggers with a 360° revolving superstructure c>=19m3','Excavad.cuya superestr.pueda girar360º, cap.carga>=19m3',11,'84','8429','842952');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84295211','Escavadoras capacid.carga>=19m3, pot.no volante>=650hp','Diggers capacity load>=19m3, flywheel power>=650hp','Excavadoras capac.carga>=19m3, pot.en el volante>=650hp',11,'84','8429','842952');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84295212','Escavadoras capacid.carga>=19m3, pot.no volante<=54hp','Diggers capacity load>=19m3, flywheel power<=54hp','Escavadoras capacid.carga>=19m3, pot.en el volante<=54hp',11,'84','8429','842952');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84295219','Outras escavadoras com capacidade de carga >=19m3','Other diggers with capacity load>=19m3','Las demás escavadoras con capacid.carga>=19m3',11,'84','8429','842952');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84295220','Infraestrut.motora, p/receb.equip.perfur.compact.escav.','Motive infrastructure, f/receiv.perfor.compact.excavat.','Infraestruct.motriz, p/recib.equip.perfor.compact.excav.',11,'84','8429','842952');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84295290','Outs.máquinas escavadoras, etc.cap.efet.rotacao=360graus','Oth.diggers mach.etc.with a 360° revolv.superstruture','Máquinas excavadoras, etc.cuya superestr.pueda girar360°',11,'84','8429','842952');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84295900','Outras pás mecânicas, escavadores, carregadoras, etc.','Other bulldozers, excavators, loaders, etc','Las demás palas mecánicas, excavadoras, cargadoras, etc',11,'84','8429','842959');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84301000','Bate-estacas e arranca-estacas','Piledrivers and pile-extractors','Matinetes y máquinas p/arrancar pilotes, estacas o sim.',11,'84','8430','843010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84302000','Limpa-neves','Snowploughs and snow-blowers','Quitanieves',11,'84','8430','843020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84303110','Cortadores de carvão ou de rochas, autopropulsores','Coal or rock cutters, self-propelled','Cortadoras de carbón o de rocas, autopropulsadas',11,'84','8430','843031');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84303190','Maqs.p/perfuração de túneis e galerias, autopropulsoras','Mach.f/perforat.of tunnels and galleries, self-propelled','Máqs.p/hacer túneles o galerías, autopropulsadas',11,'84','8430','843031');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84303910','Outros cortadores de carvão ou de rochas','Other coal or rock cutters','Las demás cortadoras de carbón o de rocas',11,'84','8430','843039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84303990','Outras máquinas p/perfuração de túneis e galerias','Oth.machines f/perforating of tunnels and galleries','Las demás máqs.p/hacer túneles o galerías',11,'84','8430','843039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84304110','Perfuratriz de percussão, autopropulsora','Percussion type cutters, self-propelled','Perforadora de percusión, autopropulsada',11,'84','8430','843041');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84304120','Perfuratriz rotativa, autopropulsora','Rotary drilling machinery, self-propelled','Perforadora rotativa, autopropulsada',11,'84','8430','843041');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84304130','Máquinas de sondagem, rotativas, autopropulsoras','Rotary boring machinery, self-propelled','Máquinas p/sondeo, rotativas, autopropulsadas',11,'84','8430','843041');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84304190','Outras máquinas de sondagem/perfuração, autopropulsoras','Other rotary boring or sinking machinery, self-propelled','Las demás máquinas p/sondeo/perforación, autopropulsadas',11,'84','8430','843041');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84304910','Outras perfuratrizes de percussão','Other drilling of percussion','Las demás perforadoras de percusión',11,'84','8430','843049');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84304920','Outras máquinas de sondagem, rotativas','Other rotary boring machinery','Las demás máquinas p/sondeo, rotativas',11,'84','8430','843049');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84304990','Outras máquinas de sondagem/perfuração','Other boring machinery/perforation','Las demás máquinas p/sondeo/perforación',11,'84','8430','843049');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84305000','Outs.maqs.e apars.de terraplanagem, etc.autopropulsores','Other self-propelled earth-moving, etc.','Las demás máqs.y apars.p/explanar, etc.autopropulsados',11,'84','8430','843050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84306100','Maqs.de comprimir/compactar terra, etc.exc.autopropuls.','Tamping or compacting machinery, etc.exc.self-propelled','Máqs.p/compactar/apisonar, etc.exc.autopropuls.',11,'84','8430','843061');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84306200','Outs.raspo-transportadores de terra, etc.exc.autopropuls','Ot.scraping-transpor.of earth, etc.exc.self-propelled','Traíllas, etc.exc.autopropulsadas',11,'84','8430','843062');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84306911','Equipamentos frontais p/escavo-carregadoras, etc.cap>4m3','Front equipments f/dig-loaders, etc.cap>4m3','Equipamientos frontales p/palas excav.carg., etc.cap>4m3',11,'84','8430','843069');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84306919','Outs.equipamentos frontais p/carregad.etc.exc.autopuls.','Other front equipments, etc.exc.self-propelled','Los dem.equipam.front.p/palas excav.carg.etc.exc.autopr',11,'84','8430','843069');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84306990','Outs.maqs.e apars.de terraplanagem, etc.exc.autopropuls.','Oth.levelling machinery, etc.exc.self-propelled','Las dem.máqs.y apars.p/explanar, etc.exc.autopropuls.',11,'84','8430','843069');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84311010','Partes de talhas, cadernais, moitoes manuais, guinchos, etc','Parts of pulley tackles, hoists, winches, etc','Partes de polipastos, tornos, cabrestantes, etc',10,'84','8431','843110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84311090','Partes de outras talhas, cadernais, moitoes, guinchos, etc.','Parts of oth.pulley tackles, hoists, winches, , etc','Partes de otros polipastos, tornos, cabrestantes, etc',10,'84','8431','843110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84312011','Partes de empilhadeiras, autopropulsoras','Parts of self-propelled fork-lift trucks','Partes de apiladoras, autopropulsoras',10,'84','8431','843120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84312019','Partes de outras empilhadeiras','Parts of other fork-lift trucks','Partes de las demás apiladoras, autopropulsoras',10,'84','8431','843120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84312090','Partes de outros veic.p/movim.carga, c/disposit.elevação','Parts of oth.vehic.f/mov.load, with lifts dispostive','Partes de los dem. vehíc.de manip.c/disp.elevación',10,'84','8431','843120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84313110','Partes de elevadores','Parts of lifts','Partes de ascensores',10,'84','8431','843131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84313190','Partes de monta-cargas/escadas rolantes','Parts of skip hoists/escalators','Partes de montacargas/escaleras mecánicas',10,'84','8431','843131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84313900','Partes de outs.maqs.e apars.de elevação de carga, etc.','Parts of machnery of elevation of load, etc','Partes de ots.máqs.y apars.de elevación de carga, etc',10,'84','8431','843139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84314100','Caçambas, pás, ganchos, etc.p/máquinas e apars.terraplanag','Buckets, shovels, grabs, etc.f/levelling machinery','Cangilones, palas, cuch., etc.p/máqs.y apars.explanar',11,'84','8431','843141');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84314200','Lâminas para "bulldozers" ou "angledozers"','Bulldozer or angledozer blades blades','Hojas de topadoras frontales o angulares',11,'84','8431','843142');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84314310','Partes das máquinas de sondagem rotativas','Parts for rotary boring machinery','Partes das máquinas de sondeo rotativas',10,'84','8431','843143');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84314390','Partes de outras máquinas de sondagem/perfuração','Parts of others boring machinery/perforation','Partes de las demás máquinas de sondeo/perforación',10,'84','8431','843143');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84314900','Partes de outs.máquinas e apars.de terraplanagem, etc.','Parts of other levelling machinery, etc','Partes de las dem.máquinas y apars.de explanar, etc',10,'84','8431','843149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84314910','Partes de guindastes, outs.maqs.apars.de carga/descarga','Parts of cranes, other machinery of load/discharge','Partes de grúas, las dem.máqs.apars.de carga/descarga',10,'84','8431','843149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84314920','Partes de outs.maqs.e aparelhos de terraplanagem, etc.','Parts of other levelling machinery, etc','Partes de las dem.máqs.y aparatos de explanar, etc',10,'84','8431','843149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84314921','Cabinas p/máquinas e aparelhos de terraplanagem e etc.','Booths for levelling machinery/appliance, etc','Cabinas de otras máqs.y aparatos de explanar, etc',10,'84','8431','843149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84314922','Lagartas de maquinas/aparelhos das posic. 8429 ou 8430','Lagartas de maquinas/aparelhos das posic. 8429 ou 8430','Lagartas de maquinas/aparelhos das posic. 8429 ou 8430',10,'84','8431','843149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84314929','Outs partes de maqs.e aparelhos de terraplanagem e etc.','Other parts of levelling machinery, etc','Otras partes de máqs.y aparatos de explanar, etc',10,'84','8431','843149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84321000','Arados e charruas','Ploughs','Arados',11,'84','8432','843210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84322100','Grades de discos, uso agricola, etc.p/prepar.do solo','Disc harrows, used agricultural, etc.f/soil preparation','Gradas de discos, uso agrícola, etc.p/prep.del suelo',11,'84','8432','843221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84322900','Outras grades, escarificadores, cultivadores, enxadas, etc.','Oth.harrows, scarifiers, cultivators, weeders, hoes, etc.','Las dem.gradas, escarificadores, cultivadores, binad., etc',11,'84','8432','843229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84323010','Semeadores-adubadores','Seeders-fertilizantes','Sembradoras abonadoras',11,'84','8432','843230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84323090','Outros semeadores, plantadores e transplantadores','Other seeders, planters and transplanters','Las dem.sembradoras, plantadoras y trasplantadoras',11,'84','8432','843230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84324000','Espalhadores de estrume/distribuid.de adubos/fertiliz.','Manure spreaders/fertiliser distributors','Esparcidores de estiércol/distribuidores de abonos',11,'84','8432','843240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84328000','Outs.máquinas e apars.agricolas, etc.p/prepar.do solo','Other machinery, etc.for soil preparation','Las dem.máquinas y apars.agrícolas, etc.p/prep.del suelo',11,'84','8432','843280');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84329000','Partes de maqs.e apars.agricolas, etc.p/prepar.do solo','Parts of machinery, etc.for soil preparation','Partes de máqs.y apars.agrícolas, etc.p/prepar.del suelo',10,'84','8432','843290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84331100','Cortadores de grama, motoriz.disp.corte num plano horiz.','Lawn mowers, motorized device cuts in a horizontal plan','Cortadoras de césped, c/motor.disp.corte en plano horiz.',11,'84','8433','843311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84331900','Outros cortadores de grama','Other lawn mowers','Las demás cortadoras de césped',11,'84','8433','843319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84332010','Ceifeiras c/disp.acond.em fileiras, rotor de dedos/pente','Mowers with row cond.device consit.fingered rotor/comb','Guadañadoras c/disp.acond.en hiler.rotor de dedos/peine',11,'84','8433','843320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84332090','Outs.ceifeiras, incl.barras de corte p/montag.em trator','Other mowers, includ.cutter bars for tractor mounting','Las dem.guadañadoras, incl.barras corte p/mont.sob.tract',11,'84','8433','843320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84333000','Outras máquinas e aparelhos para colher e dispor o feno','Other haymaking machinery','Las dem.máquinas y aparatos de henificar',11,'84','8433','843330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84334000','Enfardadeiras de palha/forragem, incl.com apanhadeiras','Straw or fodder balers, including pick-up balers','Prensas para paja/forraje, incl.las prensas recogedoras',11,'84','8433','843340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84335100','Ceifeiras-debulhadoras','Combine harvester-threshers','Cosechadoras-trilladoras',11,'84','8433','843351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84335200','Outras máquinas e aparelhos para debulha','Other threshing machinery','Las demás máquinas y aparatos de trillar',11,'84','8433','843352');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84335300','Máquinas para colheita de raízes ou tubérculos','Root or tuber harvesting machine','Máquinas de cosechar raíces o tubérculos',11,'84','8433','843353');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84335910','Desfibradoras de algodão','Shredding machinery for cotton','Desmotadoras de algodón',11,'84','8433','843359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84335911','Colheitadeira de algodão, cap.2 sulcos, pot.no vol.80hp','Harv.mac.f/cotton, cap.2 rows, flywheel power n/exc.80hp','Cosechadora de algodón, cap.2 surcos, pot.en vol.80hp',11,'84','8433','843359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84335919','Outras colheitadeiras de algodão','Other harvesting machinery for cotton','Las demás cosechadoras de algodón',11,'84','8433','843359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84335990','Outras máquinas e aparelhos para colheita','Other machinery for threshing','Las demás máquinas y aparatos para cosecha',11,'84','8433','843359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84336010','Selecionadores de frutas','Selectors of fruits','Clasificadoras de frutos',11,'84','8433','843360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84336021','Máquinas p/limpar ou selecionar ovos, cap>=36000/hora','Machines for cleaning, sorting or grading eggs, c>=36000/hour','Máquinas p/limpieza o clasific.huevos, cap>=36000/hora',11,'84','8433','843360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84336029','Outras máquinas para limpar ou selecionar ovos','Other machines for cleaning, sorting or grading eggs','Las demás máquinas p/limpieza o clasificación de huevos',11,'84','8433','843360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84336090','Maqs.p/limpar/selecionar ovos e outs.prods.agricolas','Machin.f/cleaning/sorting/grading eggs and agric.prod.','Máqs.p/limpieza/clasific.huevos y dem.prods.agrícolas',11,'84','8433','843360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84339010','Partes de cortadores de grama','Parts of lawn mowers','Partes de cortadoras de césped',10,'84','8433','843390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84339090','Partes de outs.máquinas e apars.p/colheita, debulha, etc.','Parts of lawn mowers f/harvesting/threshing, etc','Partes de dem.máquinas y apars.p/cosechar, trillar, etc',10,'84','8433','843390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84341000','Máquinas de ordenhar','Milking machines','Máquinas de ordeñar',11,'84','8434','843410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84342010','Máquinas e aparelhos para tratamento do leite','Machinery for processing milk','Máquinas y aparatos p/el tratamiento de la leche',11,'84','8434','843420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84342090','Outras máquinas e aparelhos para ind.de laticinios','Other dairy machineries','Las dem.máquinas y aparatos p/la ind.lechera',11,'84','8434','843420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84349000','Partes de maqs.e apars.de ordenhar/ind.de laticínios','Parts of milking machines and dairy machinery','Partes de máqs.y aparatos de ordeñar, p/la ind.lechera',10,'84','8434','843490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84351000','Máquinas e apars.p/fabr.vinho, sidra, suco de frutas, etc.','Machinery f/production of wine, cider, fruit juice, etc','Máquinas y apars.p/prod.vino, sidra, jugo de frutas, etc',11,'84','8435','843510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84359000','Partes de máquinas e apars.p/fabr.de vinho, sidra, etc.','Parts of machin.f/production of wine, cider, etc','Partes de máquinas y apars.p/prod.de vino, sidra, etc',10,'84','8435','843590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84361000','Máquinas e apars.p/prepar.de alimentos/rações p/animais','Machinery for preparing animal feedingstuffs','Máquinas y apars.p/prep.alimentos/piensos p/animales',11,'84','8436','843610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84362100','Chocadeiras e criadeiras','Poultry incubators and brooders','Incubadoras y criadoras',11,'84','8436','843621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84362900','Outras máquinas e aparelhos para avicultura','Other machinery for aviculture','Las demás máquinas y aparatos p/la avicultura',11,'84','8436','843629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84368000','Outras máquinas e aparelhos p/agricultura, horticult.etc','Other machinery for agricultural, horticultural, etc.','Las dem.máquinas y aparatos p/agricultura, horticult.etc',11,'84','8436','843680');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84369100','Partes de máquinas e aparelhos para avicultura','Parts of machinery for aviculture','Partes de máquinas y aparatos para la avicultura',10,'84','8436','843691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84369900','Partes de maqs.e apars.p/agricultura, horticultura, etc.','Parts of machinery for agricultural, horticultural, etc.','Partes de máqs.y apars.p/agricultura, horticultura, etc',10,'84','8436','843699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84371000','Maqs.p/limpeza, selecao, etc.de graos, prods.hortic.secos','Machines f/clean.sorting, etc.of grains, dried legum.veg.','Máqs.p/limpieza, clasif.etc.de granos, hort.de vaina sec.',11,'84','8437','843710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84378010','Máquinas e aparelhos para trituração ou moagem de grãos','Machinery for trituration or grinding of grains','Máquinas y aparatos p/trituración o molienda de granos',11,'84','8437','843780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84378090','Outs.maqs.e apars.p/ind.de moagem, tratam.de cereais, etc','Oth.machinery f/grinding industry, treatm.of cereals, etc','Las dem.máqs.y aparatos p/ind.molienda, trat.de cereales',11,'84','8437','843780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84379000','Partes de maqs.e apars.p/limpeza, seleção, etc.de grãos','Parts of machines f/cleaning, sorting, etc.of grains','Partes de máqs.y apars.p/limpieza, clasif, etc.de granos',10,'84','8437','843790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84381000','Máquinas e apars.p/ind.de panificação, pastelaria, etc.','Bakery mach.and mach.f/manufact.of macaroni, etc','Máquinas y apars.p/ind.de panadería, pastelaría, etc',11,'84','8438','843810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84382010','Máquinas e aparelhos para indústria de confeitaria','Machinery for the manufacture of confectionery','Máquinas y aparatos para confitería',11,'84','8438','843820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84382011','Maqs.e apars.p/fabr.bombons de chocolate, cap>=150 kg/h','Machinery for production of chocolates, cap>=150 kg/h','Máqs.y apars.p/la fabr.de chocolate, cap>=150 kg/h',11,'84','8438','843820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84382019','Outs.máquinas e aparelhos p/indústrias de confeitaria','Other machinery for the manufacture of confectionery','Las demás máquinas y aparatos para confitería',11,'84','8438','843820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84382090','Máquinas e aparelhos p/ind.de cacau ou de chocolate','Machinery for the manufacture cocoa or chocolate','Máquinas y aparatos p/elab.de cacao o la fabr.chocolate',11,'84','8438','843820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84383000','Máquinas e aparelhos para indústria de açúcar','Machinery for sugar manufacture','Máquinas y aparatos para la industria azucarera',11,'84','8438','843830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84384000','Máquinas e aparelhos para indústria cervejeira','Brewery machinery','Máquinas y aparatos para la industria cervecera',11,'84','8438','843840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84385000','Máquinas e aparelhos para preparação de carnes','Machinery for the preparation of meat','Máquinas y aparatos p/la prepar.de carne',11,'84','8438','843850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84386000','Máquinas e apars.p/prepar.de frutas/prods.hortícolas','Machinery for the preparation of fruits/vegetables','Máquinas y apars.p/prepar.de frutos/hortalizas',11,'84','8438','843860');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84388010','Máquinas para extração de óleo essencial de cítricos','Machin.f/extracting essential oils from citrus fruit','Máquinas para extracción de aceite esencial de cítricos',11,'84','8438','843880');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84388020','Maqs.e apars.automat.p/descabeçar, etc.pescado, c>350unid','Mach.f/cutting off of heads, etc.fish, c>350unit','Máqs.y apars.automát.p/descabezar, etc.pescado, c>350unid',11,'84','8438','843880');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84388090','Outs.maqs.e apars.p/prepar/fabr.indal.de alimentos, etc.','Oth.machinery f/industrial produc.of food, etc','Las dem.máqs.y apars.p/prep/fabr.ind.de alimentos, etc',11,'84','8438','843880');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84389000','Partes de maqs.e apars.p/prepar.fabr.de alimentos, etc.','Parts of machinery for production of foods, etc','Partes de máqs.y apars.p/prepar.fabr.de alimentos, etc',10,'84','8438','843890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84391010','Maqs.e apars.p/trat.materia-prima, p/fabr.pasta celulose','Machin.f/treatment raw materials, f/cellulosic pulp','Máqs.y apars.p/trat.materia prima, p/fabr.pasta celulós.',11,'84','8439','843910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84391020','Classificadoras e depuradoras da pasta de celulose','Classifying and purifying of cellulose pulp','Clasificadoras y depuradoras da pasta de celulosa',11,'84','8439','843910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84391030','Refinadoras p/fabr.pasta de materia celulósica','Refiners f/production pulp of cellulosic material','Refinadores p/la fabr.pasta de materia celulósica',11,'84','8439','843910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84391090','Outs.máquinas e apars.p/fabr.pasta de mater.celulosica','Oth.machinery f/production pulp of cellulosic material','Las demás máqs.y apars.p/fabr.pasta de mater.celulósica',11,'84','8439','843910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84392000','Máquinas e aparelhos para fabricação de papel ou cartão','Machinery f/production of paper/paperboard','Máquinas y aparatos p/la fabr.de papel o cartón',11,'84','8439','843920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84393010','Bobinadoras-esticadoras p/acabamento de papel ou cartão','Reeler-tensioners f/finishing paper or paperboard','Bobinadoras estiradoras p/acabado de papel o cartón',11,'84','8439','843930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84393020','Máquinas e aparelhos para impregnar papel ou cartão','Impregnating machines for paper or paperboard','Máquinas y aparatos para impregnar papel o cartón',11,'84','8439','843930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84393030','Máquinas e aparelhos para ondular papel ou cartão','Machinery for making corrugated paper or paperboard','Máquinas y aparatos para ondular papel o cartón',11,'84','8439','843930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84393090','Outs.máquinas e aparelhos p/acabamento de papel/cartão','Other machinery for finishing paper or paperboard','Las demás máquinas y aparatos p/acabado de papel/cartón',11,'84','8439','843930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84399100','Partes de maqs.e apars.p/fabr.pasta de mater.celulosica','Parts of machin.f/product.pulp of cellulosic material','Partes de máqs.y apars.p/fabr.pasta de mater.celulósica',10,'84','8439','843991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84399900','Partes de maqs.e apars.p/fabr/acabam.de papel ou cartão','Parts of machin.f/produc./finishing paper or paperboard','Partes de máqs.y apars.p/fabr./acabado de papel/cartón',10,'84','8439','843999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84399910','Rolos, corrugad/pressão, de maqs.ondular papel, l>=2500 mm','Corrugat./pressing rollers, of mach.f/cor.pap.w>=2500 mm','Rollos, corrugad/pres., de máqs.ondular papel, l>=2500 mm',10,'84','8439','843999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84399990','Outs.partes de maqs.apars.p/fabr/acabam.de papel/cartão','Other parts of machin.f/produc./finish.paper/paperboard','Las dem.partes de máqs.apars.p/fabr/acab.de papel/cart.',10,'84','8439','843999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84401011','Máquinas e apars.de costurar cadernos, c/aliment.automat','Book-sewing machines, with automatic feed','Máquinas y apars.de coser pliegos, c/aliment.automát.',11,'84','8440','844010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84401019','Outras máquinas e aparelhos de costurar cadernos','Other book-sewing machines','Las demás máquinas y aparatos de coser pliegos',11,'84','8440','844010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84401020','Maqs.p/fabr.capas papelao, disp.colag.cap.prod>60un/min','Mach.f/prod.paperb.covers, gluing dev.prod.cap.>60un/min','Máqs.p/fabr.tapas papelón, disp.col.cap.prod>60un/min',11,'84','8440','844010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84401090','Outras máquinas e aparelhos p/brochura ou encadernação','Other book-binding machinery','Las demás máquinas y aparatos para encuadernación',11,'84','8440','844010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84409000','Partes de máquinas e aparelhos p/brochura/encadernação','Parts of book-binding machinery','Partes de máquinas y aparatos para encuadernación',10,'84','8440','844090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84411010','Cortadeiras bobinadoras p/papel, cartão, etc.v>2000m/min','Cutter-reelers f/paper, paperboard, etc.s>2000m/min','Cortadoras-bobinadoras p/papel, cartón, etc.v>2000m/min',11,'84','8441','844110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84411090','Outras cortadeiras para pasta de papel, papel ou cartão','Other cuttings f/paper pulp, paper or paperboard','Las demás cortadoras p/pasta de papel, papel o cartón',11,'84','8441','844110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84412000','Máquinas p/fabr.de sacos ou envelopes de papel, etc.','Machines f/making sacks or envelopes of paper, etc.','Máquinas p/fabr.de sacos o sobres de papel, etc',11,'84','8441','844120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84413010','Máquinas de dobrar e colar, p/fabr.de caixas de papel','Machines of bending and necklace, f/making cartons','Plegadoras y encoladoras p/la fabr.de cajas de papel',11,'84','8441','844130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84413090','Outs.maqs.p/fabr.de caixas, tubos, tambores, de papel, etc.','Machines f/making cartons, tubes, drums, of paper, etc.','Las dem.máq.p/fabr.de cajas, tubos, tambores, de papel, etc',11,'84','8441','844130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84414000','Maqs.de moldar artigos de pasta de papel/papel/cartão','Machines f/moulding articles in paper pulp/paper/paperb','Máqs.p/moldear artículos de pasta de papel/papel/cartón',11,'84','8441','844140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84418000','Outs.maqs.e apars.p/trab.da pasta de papel/papel/cartão','Other machinery f/making paper pulp/paper/paperboard','La dem.máqs.y apars.p/trab.de pasta de papel/pap./cart.',11,'84','8441','844180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84419000','Partes de maqs.e apars.p/trab.pasta de papel, papel, etc.','Parts of machinery f/making paper pulp, paper, etc.','Partes de máqs.y apars.p/trab.pasta de papel, papel, etc',10,'84','8441','844190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84421000','Maqs.de compor caracteres tipograf.por proc.fotográfico','Machinery for phototype-setting f/process photogr.','Máqs.p/componer caracteres imprent.por proc.fotográfico',11,'84','8442','844210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84422000','Outs.maqs.apars.e material p/compor caracteres tipograf','Other mach./appl. for composing phototype-setting','Las dem.máqs.apars.y mat.p/componer caracteres imprenta',11,'84','8442','844220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84423000','Outs.maqs.apars.e material p/prepar/fabr.de cliches, etc','Oth. mach./appl. for produc.of cliches, etc.','Las dem.máqs.apars.y mater.p/prepar/fabr.de clisés, etc',11,'84','8442','844230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84423010','Máquinas de compor por processo fotográfico','Machinery to compos. by photographic process','Máquinas de  comp. el processo  fotográfico',11,'84','8442','844230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84423020','Máqs.apars.mat.p/comp.caract.tipográficos','Machinery/appliances for composing phototype-setting','Máqs.apars.y mat.p/componer caracteres imprenta',11,'84','8442','844230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84423090','Outs.máqs.ap. e material ñ cit.anteriormente','Other machinery/appliances/mat., didnt metion before','Otras máqs.apars y mat. no cit. anteriormente',11,'84','8442','844230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84424010','Partes de maqs.de compor caract.tipograf.proc.fotograf.','Parts of machin.f/phototype-setting f/process photog.','Partes de máqs.de comp.caract.imprenta.proc.fotográf.',10,'84','8442','844240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84424020','Partes de outs.maqs.apars.etc.p/compor caract.tipograf.','Parts of ot.mach.appliances.etc.f/compos.phototype-setting','Partes de ots.máqs.apars.etc.p/compon.caract.tipográf.',10,'84','8442','844240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84424030','Partes de outs.maqs.apars.etc.p/prepar/fabr.cliches, etc','Parts of oth.mach.appl., etc.f/produc.of cliches, etc.','Partes de ots.máqs.apars.etc.p/prepar/fabr.clisés, etc',10,'84','8442','844240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84424090','Part.out.máqs.apars.p/prepar/fabr.clichês','Parts of oth.mach/appl. for produc.of cliches, etc.','Partes de ots.máqs.apars.p/prepar/fabr.clisés, etc',10,'84','8442','844240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84425000','Caracteres tipograficos e outros elementos de impressão','Typographic characters and other elements of impression','Caracteres de imprenta y demás elementos p/la impresión',10,'84','8442','844250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431100','Máquinas e aparelhos impressão ofsete, alim.por bobinas','Offset printing machinery, reel fed','Máquinas y aparatos p/imprimir offset, alim.con bobinas',11,'84','8443','844311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431110','Maqs.apars.p/impress.multicol.jornais, alim.por bobinas','Machinery for multicol.newspapers printing, reel fed','Máqs.y apars.p/imprimir multicol.period., alim.c/bobinas',11,'84','8443','844311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431190','Outs.maqs.e apars.p/impressão ofsete, alim.por bobinas','Other offset printing machinery, reel fed','Las dem.máqs.y apars.p/imprimir offset, alim.con bobinas',11,'84','8443','844311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431200','Maqs.e apars.impressão ofsete, alim.fls.formato<=22x36cm','Offset printing machinery, sheet fed, offic.type<=22x36cm','Máqs.y apars.p/imprimir offset, alim.hjs.form<=22x36cm',11,'84','8443','844312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431310','Máqs.ap.impress.ofset, multic.mat.plásticas','Offset printing machinery, multicolor with plastic material, etc','Máqs.y apars.p/imprimir offset, multicolor c/mat. plásticas, etc',11,'84','8443','844313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431321','Máqs.ap.ofset, alim.bobinas v>=12000folhas/h','Offset printing machinery, reels fed, s>=12000 sheets/h','Máqs.apars.p/imprim.offset, alim.bobinas, v>=12000 hjs/h',11,'84','8443','844313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431329','Outs.máqs.aps.ofset form.<=37, 5x51cm','Other offset print. machinery/appliances, form.<= 37, 5 x 51 cm','Otras máqs.apars.p/imprim.offset, form. <= 37, 5 x 51 cm',11,'84','8443','844313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431390','Outs.máqs.aparelhos d/impressão p/ofset','Other offset print. machinery/appliances','Otras máqs.apars.para imprimir offset',11,'84','8443','844313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431400','Máqs.ap.impres.tipog.exc.flexg., alim.bobinas','Tipograf. impress. mach./appl., reel fed, excepition flexogr.','Máq./apar. impress., tipográf., alim. c/ bobinas, excepto flexogr.',11,'84','8443','844314');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431500','Outs.máqs.ap.impres., tipog., exc.máq.flexogr.','Other tipograf. impress. mach./appl., reel fed, except flexogr.','Otras máq./apar. impress., tipográf., alim. c/ bobinas, excepto flexogr.',11,'84','8443','844315');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431600','Máqs., aparelhos d/impressão, flexográficos','Flexographic impress machinery/appl.','Máqs., aparelhos de impresión  flexográficos',11,'84','8443','844316');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431710','Máquinas rotativas p/heliogravura','Gravure printing rotary machinery','Máquinas rotativas para huecograbado',11,'84','8443','844317');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431790','Outs.máqs.ap.de impressão, heliográficos','Other gravure printing machinery/aplliances','Otras máquinas y apars.p/imprimir, heliográficos',11,'84','8443','844317');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431910','Maqs.e apars.impressão ofsete, multicol.de mat.plast.etc','Offset printing machinery, multic.of plastic mater.etc','Máqs.y apars.p/imprimir offset, multic.de mat.plást.etc',11,'84','8443','844319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431921','Maqs.apars.impressão ofsete, alim.bobinas, v>=12000 fls/h','Offset printing machinery, reels fed, s>=12000 sheets/h','Máqs.apars.p/imprim.offset, alim.bobinas, v>=12000 hjs/h',11,'84','8443','844319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431929','Outs.maqs.apars.impress.ofsete, alim.bobinas, fl<=37x51cm','Oth.offset printing machinery, reels fed, sheets<=37x51cm','Las dem.máqs.apars.p/impr.offset, alim.bobin.hj<=37x51cm',11,'84','8443','844319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84431990','Outras máquinas e aparelhos de impressão por offset','Other offset printing machinery','Las demás máquinas y aparatos p/imprimir offset',11,'84','8443','844319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84432100','Máquinas e apars.impressão, tipograf.alim.por bobinas','Printing machinery, typographic, reel fed','Máquinas y apars.p/imprimir, tipográf., alim.con bobinas',11,'84','8443','844321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84432900','Outras máquinas e aparelhos de impressão, tipograficos','Other printing machinery, typographic','Las dem.máquinas y aparatos p/imprimir, tipográficos',11,'84','8443','844329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433000','Máquinas e aparelhos de impressão, flexograficos','Flexographic printing machinery','Máquinas y aparatos p/imprimir, flexográficos',11,'84','8443','844330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433100','Máq.p/impress.transm.d/fax, conect.p/process.','Fax transm. print. machinery, conect by process.','Máq.p/imprim.transm.de fax, conect.p/process.',11,'84','8443','844331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433111','Impressora jato de tinta líquida largura <=420mm','Inkjet printer widht<=420mm','Impresora de inyección, anchura <=420mm',11,'84','8443','844331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433112','Impressora transferencia termica de cera solida','Thermal transfer printer (solid wax)','Impresora de transferencia térmica de cera sólida',11,'84','8443','844331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433113','Impressora a laser,  led ou lcs monocrom. larg <=280mm','Laser printer, led or lcs monocrom, width<=280mm ','Impresora a laser,  led ou lcs monocrom. anchura <=280mm',11,'84','8443','844331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433114','Impressora a laser, led/lcs monocrom.larg >280 e <=420mm','Laser printer, led or lcs monocrom, width >280mm and <=420mm','Impresora a laser, led/lcs monocrom. anchura >280mm  e <=420mm',11,'84','8443','844331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433115','Impressora a laser, led ou lcs policromaticas','Laser printer, led or lcs policromatic','Impresora a laser, led ou lcs policromáticas ',11,'84','8443','844331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433116','Outras impressoras com largura de impressão >420mm','Other printers with widht of printing >420mm','Otras impresoras c/ anchura de impresión >420mm',11,'84','8443','844331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433119','Outras impressoras com capacidade impr.<=45ppm','Other printers with capacity of printing <=45 ppm ','Otras impresoras com capacidad de impresión <=45 ppm',11,'84','8443','844331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433191','Outras impressoras com impressão para sistema termico','Other printers with printing by thermal system','Otras impresoras com impresión para sistema térmico ',11,'84','8443','844331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433199','Outras impressoras multifuncionais','Other multifunction printers','Otras impresoras multifunción',11,'84','8443','844331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433211','Telecopiadores(fax), c/impress.p/sist.térmico','Fax machines, with printing by thermal system','Faxes com impresión para sistema térmico',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433212','Telecopiadores(fax), c/impress.p/sist."laser"','Fax machines, with printing by laser system','Faxes com impresión para sistema a laser',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433213','Telecopiadores(fax), c/impress.p/jato d/tinta','Fax machines, with inkjet printing','Faxes com impresión  para sistema de inyección',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433219','Outros telecopiadores (fax)','Other fax machines','Otros faxes',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433221','Impressoras de impacto, de linha','Line impact printers','Impresora de impacto de línea',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433222','Impressoras de impacto, de caracteres braille','Impact printer with braille characters','Impresora de impacto de caracteres braille',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433223','Impressoras de impacto, matriciais (por pontos)','(dot) matrix impact printer','Impresora matricial de impacto (por puntos)',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433229','Outeas impressoras de impacto','Other impact printers','Otras impresoras de impacto',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433231','Impressoras jato de tinta líquida larg.imp.<=420mm','Inkjet printer with printing widht<=420mm','Impresora de inyección, anchura <=420mm',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433232','Impressoras d/transf.térmica d/cera sólida','Thermal transfer printer (solid wax)','Impresora de transferencia térmica de cera sólida',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433233','Impress.laser.led, lcs, monocromatica l<=280mm','Laser printer, led or lcs monocrom, width<=280mm ','Impresora a laser,  led ou lcs monocrom. anchura <=280mm',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433234','Impress.laser.led, lcs, monocromatica l>280 e <=420mm','Laser printer, led or lcs monocrom, width >280mm and <=420mm','Impresora a laser, led/lcs monocrom. anchura >280mm  e <=420mm',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433235','Impress.laser.led, lcs, policromatica.vel.impr.<=20ppm','Laser printer, led or lcs monocrom, print. speed <=20ppm','Impresora a laser,  led ou lcs monocrom. veloc. de impresión <= 20ppm',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433236','Impress.laser.led, lcs, policromatica.vel.impr.>20ppm','Laser printer, led or lcs monocrom, print. speed > 20ppm','Impresora a laser,  led ou lcs monocrom. veloc. de impresión > 20ppm',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433237','Térmicas p/ impr.imagem diag.medico c/ termosensivel','Thermal, image printing medic diagnostic','Térmica, de impresión de imágenes diagnótstico médico',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433238','Outras com largura impressão > 420mm','Others, with printing width> 420mm','Demás, con ancho de impresión> 420 mm',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433239','Outs.impress.c/veloc.d/impressão<30pág/m','Other printers with  printing speed <30ppm','Otras impresoras c/ veloc. de impreción < 30 ppm',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433240','Outras impressoras alimentadas por folhas','Other printers by sheet fed','Otras impresoras alimentadas por hojas',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433251','Traçadores gráficos por meio de penas','Pen plotter','Trazador gráfico por meio de plumas (plóter)',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433252','Outras impressoras com largura de impressão >580mm','Other printers with printing widht >580mm','Otras impresoras c/ anchura de impresión >580mm',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433259','Outros traçadores gráficos','Other plotters','Otros trazadores gráficos',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433291','Impress.barr.post.3em5, jat.fluor.vl.<4, 5m/s','Postal bar code  printer,3in5,fluor.ink.,veloc.<=4,5m/s,step 1,4mm','Impres.cod.bar.post .3em5,tinta fluor.veloc<=4, 5m/s, passo 1,4mm',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433299','Outs.unids.d/entr./saída, p/máqs.proc.dados','Other input/output units, f/autom.data-proces.machines','Outs.unids.d/entr./saída, p/máqs.proc.datos',11,'84','8443','844332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433910','Máquinas de impressão por jato de tinta','Inkjet printing machinery','Máquinas de impresión por inyección',11,'84','8443','844339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433921','Aprs.d/repr.ind.d/fotocop.monocr.eletrost.','Indirect reproducing fotocop appliance by monocr. eletrost.','Aparatos d/reprod.ind.de fotocop.monocr.eletrost.',11,'84','8443','844339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433928','Outs.aprs.d/fotocópia, eletr.repr.indireta','Other indirect reprod. eletrost. fotocop.appliance.','Otros aparatos repr. ind.de fotocop eletrost.',11,'84','8443','844339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433929','Outs.apars.reprod.dir.d/fotocóp.eletrost.','Other direct reprod. eletrost. fotocop. appliance ','Otros aparatos repr. direc.de fotocop eletrost.',11,'84','8443','844339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433930','Aparelhos de fotocópia, por sistema óptico','Photocopy appliance by optical system','Aparatos de fotocópia por sistema óptico ',11,'84','8443','844339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84433990','Outras máquinas de impressão jato de tinta','Other inkjet printing machinery','Otras máquinas de impresión por inyección',11,'84','8443','844339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84434010','Máquinas e apars.de impressão, rotativas p/heliogravura','Gravure printing machinery, rotary','Máquinas y apars.p/imprimir, rotativas p/huecograbado',11,'84','8443','844340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84434090','Outras máquinas e aparelhos de impressão, heliograficos','Other gravure printing machinery','Las demás máquinas y apars.p/imprimir, heliográficos',11,'84','8443','844340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84435100','Máquinas de impressão de jato de tinta','Inkjet printing machines','Máquinas p/imprimir por chorro de tinta',11,'84','8443','844351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84435910','Máquinas de impressão para serigrafia','Screen printing machines','Máquinas de imprimir para serigrafía',11,'84','8443','844359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84435990','Outras máquinas de impressão','Other printing machinery','Las demás máquinas p/imprimir',11,'84','8443','844359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84436010','Máquinas auxiliares de impressão, dobradoras','Machines for uses ancillary to printing, folding','Máquinas auxiliares p/imprimir, plegadoras',11,'84','8443','844360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84436020','Máquinas auxiliares de mpressão, numeradores automáticos','Mach.f/uses ancillary to printing, autom.page numbering','Máquinas auxiliares p/imprimir, numeradores automáticos',11,'84','8443','844360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84436090','Outras máquinas auxiliares de impressão','Other machines for uses ancillary to printing','Las demás máquinas auxiliares p/imprimir',11,'84','8443','844360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439010','Partes de maqs.apars.impressão ofset, alim.fls<=22x36cm','Parts of offset printing machinery, sheets fed<=22x36cm','Partes de máqs.apars.imprimir offset, alim.hjs<=22x36cm',10,'84','8443','844390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439090','Partes de outs.maqs.apars.de impressão, incl.auxiliares','Parts of printing machinery, incl.auxiliary','Partes de demás máqs.apars.p/imprimir, incl.auxiliares',10,'84','8443','844390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439110','Part.d/máq.aps.impr.offset, alim.fls<=22x36cm','Parts of offset printing machinery, sheets fed<=22x36cm','Partes de máqs.apars.imprimir offset, alim.hjs<=22x36cm',10,'84','8443','844391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439191','Máquinas auxiliares de impressão, dobradoras','Auxiliar printing machine (bending) ','Máquinas auxiliares de impresión, dobladora',11,'84','8443','844391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439192','Máqs.auxiliares d/impressão numerad.autom.','Auxiliar printing machine (autom. numerator) ','Máquionas auxiliares de impresión, numeradora autom.',11,'84','8443','844391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439199','Outras máquinas auxiliares para impressão','Other auxiliary machinery for printing','Las demás máquinas auxiliares p/imprimir',11,'84','8443','844391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439911','Outros mecan.impressão, mesmo s/cabeça impressão incorp.','Other printing mechanism, even without print head ','Otros mecanismos de impresión, mismo sem cabeza de impresión ',11,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439912','Outros mecanismos de impressão, com cabeça de impressão','Other printing mechanism, with print head ','Otros mecanismos de impresión, com cabeza de impresión ',11,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439913','Bastidores/armações p/apar.d/telef./telegr.','Backstage, frames for telephone and telegraph equipments','Bastidores y armazones p/aparatos p/telefonía/telegraf',11,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439919','Outros mecanismos de impressão por impacto','Other mechanisms for impact print','Otros mecanismos de incidencia de impresión',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439921','Outros mecan.impress.jato de tinta,  mesmo s/cabeça inc.','Other printing mechanism, even without print head inc. ','Otros mecanismos de impresión, mismo sem cabeza de impresión inc.',11,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439922','Outras cabeças de impress.p/mecan.impress.jato de tinta','Other print head for inkjet mechanism','Otras cabezas de impres. por mecan. de impresión por inyección',11,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439923','Outros cartuchos de tinta','Other ink cartridges','Otros cartuchos de tinta',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439924','Outras cabeças de impressão, para impressoras','Other print head, for printers','Otras cabezas de impresión, para impresoras',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439925','Cabeças d/impres.terms/jato tinta, p/impress.','Thermal print heads without inkjet, for printer ','Cabezas de impresión sem inyección, p/ impresoras',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439926','Cintas de caracteres, para impressoras','Ribbon of characters to printers','Cintas de caracteres para impresora',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439927','Cartuchos de tinta, para impressoras','Ink cartridges, for printers','Cartuchos de tinta, para impresoras',11,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439929','Outs.partes/acess.impress./traçad./gráficos','Other parts/acess.for printers/plotters','Otras partes/acces.impres./trazadores gráficos',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439931','Outros mecan.impress, mesmo s/cilindro fotossen.incorp.','Other printing mechanism, even without fotosen. cylinder incorp. ','Otros mecan. de impres., mismo sin el cilindro fotosens. incorporado',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439932','Outros cilind recobertos de materia semic.fotoeletrica','Other cylinder corvered by semic. photoeletric material','Otros cilind. recobiertos de material semic. fotoeletr.',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439933','Outros cartuchos revelador/produtos p/viragem "toners"','Others cartridges discloser/products to turning toners  ','Otros cartuchos revelador/productos  p/ viragem "toners"',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439939','Outs.partes.aces.p/apar.fotoc.letrostático','Other parts, aces. to appl. photocop. eletrostatic.','Otras partes/acces.p/ aparatos fotocop. eletrostático ',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439941','Outros mecan.impressão, mesmo s/cabeça impr.incorp.','Other printing mechanism, even without print head ','Otros mecanismos de impresión, mismo sem cabeza de impresión ',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439942','Outras cabeças de impressão','Other print heads','Otros cabezales de impresión',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439949','Outros mecan.impress.laser, led, lcs, partes e acessórios','Other laser, led, lcs printing mechanism, parts and accessories','Otros mecan. impres.laser, led, lcs, partes e accesorios',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439950','Outros mecan.impressão, suas partes e acessórios','Other printing mechanism, its parts and accessories','Otros mecan. de impresión, partes e accesorios',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439960','Outros circuitos impr.c/compon.eletri./eletron.montados','Other printing circuits with assembl. eletron./eletric.components ','Otros circuitos de impresión c/ compon. eletr./eletron. montados',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439970','Outras bandejas e gavetas, suas partes e acessórios','Other trays and drawers, their parts and accessories','Otras bandejas y cajones, sus partes y accesorios',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439980','Outros mecan.alimen./triagem, papéis/doc.part/acessórios','Other mechan. of feed./ selec. of papers, doc., parts and  accessories  ','Otros mecan. de alimen. selecc. de papel., docum., partes y accesorios    ',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84439990','Outras partes e acessórios para impressão','Other parts and accessories for printing','Otras partes y accesorios para imprimir',10,'84','8443','844399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84440010','Máquinas p/extrudar matérias têxteis sintet/artificiais','Machines f/extruding material textile synthetic/artific','Máquinas p/extrudir materia textil sintét/artificial',11,'84','8444','844400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84440020','Máquinas p/corte/ruptura de fibras têxteis sintet/artif','Machines f/cutting/rupture of textile fibres synt/artif','Máquinas p/corte/rotura de fibras textiles sintét/artif',11,'84','8444','844400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84440090','Outs.máquinas p/estirar, etc.matérias text.sintet/artif.','Oth.machines f/drawing, etc.material textile synt/artif','Las dem.máquinas p/estirar, etc.mater.text.sintét/artif.',11,'84','8444','844400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451110','Cardas para lã','Carding for wool','Cardas para lanas',11,'84','8445','844511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451120','Cardas para preparação de fibras têxteis vegetais','Carding for preparing of textile fibres vegetables','Cardas p/prepar.de fibras textiles vegetales',11,'84','8445','844511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451190','Cardas para preparação de outras matérias têxteis','Carding for preparing of other textile materials','Cardas p/prepar.de demás materias textiles',11,'84','8445','844511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451200','Penteadoras de matérias têxteis','Combing machines of textile materials','Peinadoras de materias textiles',11,'84','8445','844512');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451300','Bancas de estiramento de matérias têxteis','Drawing or roving machines of textile materials','Mecheras p/la prep.de materias textiles',11,'84','8445','844513');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451310','Bancas de estiramento para lã','Drawing or roving machines for wool','Mecheras para lana',11,'84','8445','844513');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451390','Bancas de estiramento para outras matérias têxteis','Drawing or roving machines for other textile materials','Mecheras p/la prep.de otras materias textiles',11,'84','8445','844513');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451910','Máquinas para preparação da seda','Machines for preparing silk','Máquinas para la preparación de la seda',11,'84','8445','844519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451921','Maqs.p/recuper.cordas, etc.transform.fibras p/cardagem','Mach.f/recovery of strings, etc.tranform.fibr.f/carding','Máqs.p/recuper.cuerdas, etc.transform.fibras p/cardaje',11,'84','8445','844519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451922','Descaroçadeiras e deslintadeiras de algodão','Machines for separating cotton fibres from the seeds','Desmotadoras y deslintadoras de algodón',11,'84','8445','844519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451923','Maqs.p/desengordurar, lavar, etc.fibras têxteis em massa','Machines f/degreasing, wash.etc.textile fibres mass','Máqs.p/desgrasar, lavar, etc.fibras textiles en masa',11,'84','8445','844519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451924','Abridoras de fibras de lã','Wool fibre working machines','Abridoras de fibras de lana',11,'84','8445','844519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451925','Abridoras de outras fibras têxteis vegetais','Fibre working machines of oth.fibres textile vegetables','Abridoras de demás fibras textiles vegetales',11,'84','8445','844519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451926','Máquinas de carbonizar a lã','Wool carbonizing machines','Máquinas de carbonizar lana',11,'84','8445','844519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451927','Máquinas para estirar a lã','Wool drawing machines','Máquinas para el estirado de lana',11,'84','8445','844519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84451929','Outras máquinas p/prepar.de materia têxtil','Other machines for preparing of material textile','Las demás máquinas p/prepar.de materia textil',11,'84','8445','844519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84452000','Máquinas para fiação de matérias têxteis','Textile spinning machine','Máquinas para hilar materia textil',11,'84','8445','844520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84452010','Filatorios intermitentes para fiação de materia têxtil','Intermittent frames for textile spinning','Hiladoras intermitentes para hilar materia textil',11,'84','8445','844520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84452020','Máquinas tipo "tow-to-yarn" p/fiação de materia têxtil','Machines of kind "tow-to-yarn" f/textile spinning','Máquinas del tipo "tow-to-yarn" p/hilar materia textil',11,'84','8445','844520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84452030','Máquinas a jato de ar para fiação de matéria têxtil','Machines jet of air for textile spinning','Maquinas a chorro de aire p/hilar materia textil',11,'84','8445','844520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84452040','Fiadeira-bobinadora automat.p/fiação de matéria têxtil','Automatic reeling mach.f/textile spinning','Hiladora-bobinadora automát.p/hilar materia textil',11,'84','8445','844520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84452070','Outras máquinas para fiação de lã','Other wool spinning machines','Las demás máquinas para hilar lana',11,'84','8445','844520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84452080','Outras máquinas para fiação de fibra têxtil vegetal','Other spinning machines f/fibres textile vegetables','Las demás máquinas para hilar fibra textil vegetal',11,'84','8445','844520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84452090','Outras máquinas para fiação de matéria têxtil','Other textile spinning machines','Las demás máquinas para hilar materia textil',11,'84','8445','844520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84453010','Retorcedeiras de matéria têxtil','Twisting machines of textile material','Retorcedoras de materia textil',11,'84','8445','844530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84453090','Outras máquinas p/dobragem ou torção de materia têxtil','Other textile doubling or twisting machines','Las demás máquinas p/doblar o retorcer materia textil',11,'84','8445','844530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84454011','Bobinadeiras de trama de materia têxtil, automáticas','Reeling machines of weft of textile material, automatic','Canilleras de materia textil, automáticas',11,'84','8445','844540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84454012','Bobinadeiras p/fios elastanos, automáticas','Reeling machines for elastomeric yarns, automatic','Bobinadoras p/hilados elastoméricos, automáticas',11,'84','8445','844540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84454018','Outras bobinadeiras de materia têxtil, c/atador automat.','Ot.reeling machin.of textile material, with tyers autom.','Las dem.bobinadoras de mat.textil, c/anudador automát.',11,'84','8445','844540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84454019','Outras bobinadeiras de materia têxtil, automática','Ot.reeling machin.of textile material, automatic','Las demás bobinadoras de materia textil, automática',11,'84','8445','844540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84454021','Bobinadeiras de materia têxtil, n/automat.v>=4000m/min','Reeling machin.of textile mater, n/automat.s>=4000m/min','Bobinadoras de materia textil, n/automát.v>=4000m/min',11,'84','8445','844540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84454029','Outras bobinadeiras de materia têxtil, n/automat.','Other reeling machin.of textile mater, n/automatic','Las demás bobinadoras de materia textil, n/automát.',11,'84','8445','844540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84454031','Meadeiras de matéria têxtil, c/controle/atador automat.','Machines f/making hanks, with control/automatic knotting','Madejadoras de mat.textil, c/control/anudador automát.',11,'84','8445','844540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84454039','Outras meadeiras de matéria têxtil','Other machines for making hanks','Las demás madejadoras de materia textil',11,'84','8445','844540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84454040','Noveleiras de matéria têxtil, automáticas','Automatic ball winding machines of textile material','Ovilladoras de materia textil, automáticas',11,'84','8445','844540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84454090','Outras máquinas de bobinar ou de dobar, matéria têxtil','Other textile winding or reeling machines','Las dem.máquinas p/bobinar o p/doblar, materia textil',11,'84','8445','844540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84459010','Urdideiras de matéria têxtil','Warpers of textile material','Urdidoras de materia textil',11,'84','8445','844590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84459020','Passadeiras para lico e pente, de matéria têxtil','Drawing-in and reeling machine for textile material','Urdidoras para lizos y peine, de materia textil',11,'84','8445','844590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84459030','Máquinas para amarrar urdideiras de matéria têxtil','Warp tying-in or twisting machines of textile material','Máquinas para anudar la urdimbre de materia textil',11,'84','8445','844590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84459040','Máquinas p/colocar lamelas de materia têxtil, automat.','Automat.heddle-positioning mach.of textile material','Máquinas p/colocar laminillas de mater.textil, automát.',11,'84','8445','844590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84459090','Outs.máquinas e aparelhos p/fabr/prepar.de fios têxteis','Other machin.f/product./preparat.of textile yarns','Las dem.máqs.y apars.p/fabr/prepar.de hilados textiles',11,'84','8445','844590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84461010','Teares p/tecido de lãrg<=30cm, c/mecanismo "jacquard"','Looms f/fabric of width<=30cm, jacquard mech.','Telares p/tejido de anch<=30cm, c/mecanismo "jacquard"',11,'84','8446','844610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84461090','Outros teares p/tecido de lãrg<=30cm','Other looms f/fabric of width<=30cm','Los demás telares p/tejido de anchura<=30cm',11,'84','8446','844610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84462100','Teares p/tecido de l>30cm, de lançadeira, a motor','Looms f/fabric of w>30cm, shuttleless type, engine','Telares p/tejido de a>30cm, de lanzadera, con motor',11,'84','8446','844621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84462900','Outros teares p/tecido de l>30cm, de lançadeira','Other looms f/fabric of w>30cm, shuttleless type','Los demás telares p/tejido de a>30cm, de lanzadera',11,'84','8446','844629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84463010','Teares p/tecido de l>30cm, s/lancadeira, a jato de ar','Looms f/fabric of w>30cm, without shuttl., air jet','Telares p/tejido de a>30cm, s/lanzadera, a chorro de aire',11,'84','8446','844630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84463020','Teares p/tecido de l>30cm, s/lancadeira, a jato de agua','Looms f/fabric of w>30cm, without shuttl., water jet','Telares p/tejido de a>30cm, s/lanzadera, a chorro de agua',11,'84','8446','844630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84463030','Teares p/tecido de l>30cm, s/lançadeira, de projetil','Looms f/fabric of w>30cm, without shuttl., projectile','Telares p/tejido de a>30cm, s/lanzadera, de proyectil',11,'84','8446','844630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84463040','Teares de pincas, p/tecido, l>30cm, s/lançadeira','Gripper looms f/fabric of w>30cm, shuttless type','Telares de pinzas, p/tejido, a>30cm, s/lanzadera',11,'84','8446','844630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84463041','Teares p/tecido atoalhado, l>30cm, s/lancadeira, de pincas','Looms f/towelling fabric w>30cm, shuttleless, gripper','Telares p/tejido c/bucles, a>30cm, s/lanzadera, de pinzas',11,'84','8446','844630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84463042','Teares p/tapetes, l>30cm, s/lançadeira, de pinças','Looms f/rug w>30cm, shuttleless, gripper','Telares p/alfombras, a>30cm, s/lanzadera, de pinzas',11,'84','8446','844630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84463049','Outros teares p/tecido, l>30cm, s/lançadeira, de pinças','Oth.looms f/fabric, w>30cm, shuttleless type, gripper','Los dem.telares p/tejidos, a>30cm, s/lanzadera, de pinzas',11,'84','8446','844630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84463090','Outros teares para tecido, l>30cm, sem lançadeira','Oth.looms f/fabric, w>30cm, shuttleless type','Los demás telares p/tejido, a>30cm, s/lanzadera',11,'84','8446','844630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84471100','Teares circulares, p/malhas, c/cilindro, diâmetro<=165mm','Circular looms, f/mesh, with cylinder, diameter<=165mm','Telares de punto circul.p/tej.punto, c/cilin.diám<=165mm',11,'84','8447','844711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84471200','Teares circulares, p/malhas, c/cilindro, diâmetro>165mm','Circular looms, f/mesh, with cylinder, diameter>165mm','Telares de punto circul.p/tej.punto, c/cilin.diám>165mm',11,'84','8447','844712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84472010','Teares retilíneos, para malhas, manuais','Manual flat knitting machines for mesh','Telares rectilíneos, p/tejidos de punto, manuales',11,'84','8447','844720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84472021','Teares retilíneos, motorizados, p/fabr.malha de urdidura','Flat knitting, motorized, f/production of warp mesh','Telares rectilíneos, c/motor, p/fabr.tej.punt.de urdimbre',11,'84','8447','844720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84472029','Outros teares retilíneos, motorizados, para malhas','Other flat knitting, motorized, for mesh','Los demás telares rectilíneos, c/motor, p/tej.de punto',11,'84','8447','844720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84472030','Máquinas de costura por entrelaçamento','Stitch-bonding machines','Máquinas de coser por cadeneta',11,'84','8447','844720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84479010','Máquinas para fabricação de redes, tules ou filos','Mach.f/making knotted netting/tulle/bobinot tulle','Máquinas p/fabr.de redes, tules o encajes',11,'84','8447','844790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84479020','Máquinas para bordar, automáticas','Automatic embroidery machines','Máquinas p/bordar, automáticas',11,'84','8447','844790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84479090','Outs.maqs.p/fabr.guipuras, rendas, etc.e inserir tufos','Oth.machin.f/making gimped, yarn, turlle, etc.f/tufting','Las dem.máqs.p/fabr.tules, bord., etc.y insertar mechones',11,'84','8447','844790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84481110','Ratieras para teares','Dobbies for looms','Maquinitas p/telares',11,'84','8448','844811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84481120','Mecanismos "jacquard" para teares','Jacquards dobbies for looms','Mecanismos "jacquard" p/telares',11,'84','8448','844811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84481190','Redutores, perfuradores e copiadores de cartões, etc.','Reducers, perforators and copiers of cards, etc','Reductores, perforadores y copiadores de cartones, etc',11,'84','8448','844811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84481900','Outs.maqs.e apars.auxiliares p/trab.etc.materia têxtil','Other auxiliary machinery f/work.etc.material textile','Las demás máqs.y apars.auxiliares p/trab.etc.mat.textil',11,'84','8448','844819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84482010','Fieiras p/extrusão de matéria têxtil sintética/artif.','Extruding nipples of material textile synthet/artif','Hileras p/extrusión de materia textil sintética/artif.',11,'84','8448','844820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84482020','Outs.partes e acess.de maqs.p/extrusão de mater.têxtil','Ot.parts/acces.of mach.extruding nipples of mat.textile','Las dem.partes y acces.de máqs.p/extrusión mat.textil',10,'84','8448','844820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84482030','Partes e acess.de maqs.p/corte/ruptura de fibra têxtil','Ot.parts/acces.of mach.f/cut and rupture of text.fibre','Partes y acces.de máqs.p/corte/rotura de fibra textil',10,'84','8448','844820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84482090','Outs.partes e acess.de maqs.p/estirar, etc.mater.têxtil','Oth.parts/acces.of mach.f/drawing, etc.text.fibre','Las dem.partes y acces.de máqs.p/estirar, etc.mat.textil',10,'84','8448','844820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483100','Guarnições de cardas','Card clothing','Guarniciones de cardas',11,'84','8448','844831');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483211','Chapeus ("flats") de cardas','Card flats','Chapones ("flats") de cardas',11,'84','8448','844832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483219','Outras partes e acessórios de cardas','Other parts and accessory of card','Las demás partes y accesorios de cardas',10,'84','8448','844832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483220','Partes e acess.de penteadoras de matéria têxtil','Parts and accessory of card of material textile','Partes y acces.de peinadoras de materia textil',10,'84','8448','844832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483230','Bancas de estiramento de matéria têxtil','Drawing or roving machines of material textile','Mecheras de materia textil',11,'84','8448','844832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483240','Partes e acess.de máquinas p/prepar.da seda','Parts and accessor.of machines f/preparing silk','Partes y acces.de máquinas p/prepar.de la seda',10,'84','8448','844832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483250','Partes e acess.de máquinas p/carbonizar lã','Parts and acces.of wool carbonizing machines','Partes y acces.de máquinas p/carbonizar lana',10,'84','8448','844832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483290','Outs.partes e acess.de maqs.p/prepar.de matéria têxtil','Oth.parts and acces.of mach.f/material textile produc.','Las demás partes y acces.de máqs.p/prepar.de mat.textil',10,'84','8448','844832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483310','Cursores de fusos p/máquinas prepar.matéria têxtil','Cursors of spindles f/mach.f/material textile product.','Cursores de husos p/máquinas prepar.materia textil',11,'84','8448','844833');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483390','Fusos, suas aletas e anéis, p/maqs.prepar.matéria têxtil','Spindles, flyers and rings, f/mach.material textile prod.','Husos, sus aletas y anillos, p/máqs.prepar.materia textil',10,'84','8448','844833');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483911','Partes e acess.de filatorios intermitentes','Parts and access.of intermittent spinning frames','Partes y acces.de hiladoras intermitentes',10,'84','8448','844839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483912','Partes e acess.de maqs."tow-to-yarn" p/fiação mat.text.','Parts/access.of mach.tow-to-yar f/spin.textile mater.','Partes y acces.de máqs."tow-to-yarn" p/hilar mat.text.',10,'84','8448','844839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483917','Partes e acess.de outs.filatorios p/fiação mater.têxtil','Parts and acces.of other spinning machines f/text. mat','Partes y acces.de demás hiladoras p/hilar mater.textil',10,'84','8448','844839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483919','Partes e acess.de maqs.p/dobragem, torção de mat.têxtil','Parts and acces.of machin.f/doubling/twisting text.mat.','Partes y acces.de máqs.p/doblado, retorc.de mat.textil',10,'84','8448','844839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483921','Partes e acessórios de bobinadeiras de trama','Parts and accessories of weft-winding machines','Partes y accessorios de canilleras',10,'84','8448','844839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483922','Partes e acess.de bobinadeiras automat.p/fios elastanos','Parts/acces.of automatic winding mach.f/elastom.yarns','Partes y acces.de bobinadoras automát.p/hilad.elastom.',10,'84','8448','844839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483923','Partes e acessórios de outras bobinadeiras automáticas','Parts and access.of oth.automatic winding machines','Partes y acces.de demás bobinadoras automáticas',10,'84','8448','844839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483929','Partes e acess.de outs.máquinas de bobinar ou de dobar','Parts and access.of oth.reeling/spinning machines','Partes y acces.de dem.máquinas de bobinar o devanar',10,'84','8448','844839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483991','Partes e acessórios de urdideiras','Parts and accessory of warpers','Partes y acces.de urdidoras',10,'84','8448','844839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483992','Partes e acess.de passadeiras p/lico e pente','Parts and access.of drawing-in or reeding machines','Partes y acces.de p/el enhebrado de lizo y peine',10,'84','8448','844839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84483999','Partes e acess.de outs.maqs.e apars.p/trab.mater.têxtil','Parts/acces.of oth.mach.f/working textile material','Partes y acces.de dem.máqs.y apars.p/trab.mater.textil',10,'84','8448','844839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84484100','Lançadeiras de teares para tecidos','Shuttles of looms, for fabric','Lanzaderas de telares para tejidos',11,'84','8448','844841');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84484200','Pentes, licos e quadros de licos, de teares p/ tecidos','Reeds f/looms, healds and heald-frames, of looms f/fabric','Peines, lizos y cuadros de lizos, de telares p/tejidos',11,'84','8448','844842');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84484910','Partes e acess.de máquinas e apars.auxiliares de teares','Parts and access.of auxiliary machinery for looms','Partes y acces.de máqs.y apars.auxiliares de telares',10,'84','8448','844849');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84484920','Partes e acess.de teares p/tecido l>30cm, jato agua, etc.','Parts and access.of looms f/fabr.w>30cm, water-jet, etc.','Partes y acces.de telares p/tej.a>30cm, chorro agua, etc',10,'84','8448','844849');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84484990','Outras partes e acess.de teares p/tecidos','Other parts and accessory of looms f/fabric','Las demás partes y acces.de telares p/tejido',10,'84','8448','844849');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84485100','Platinas, agulhas, etc.util.na formacao de malhas','Sinkers, needles, etc.used in forming stitches','Platinas, agujas, etc.q.participen en formación de mallas',10,'84','8448','844851');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84485910','Partes e acess.de teares circulares p/fabr.de malhas','Parts and access.of circular looms f/fabric of stitch.','Partes y acces.de telares circulares p/fabr.de mallas',10,'84','8448','844859');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84485921','Partes e acess.de teares retilin.manuais, p/fabr.malhas','Parts/acces.flat knitting hand-oper.f/fabric of stit.','Partes y acces.de telares rectil.manuales, p/fabr.mallas',10,'84','8448','844859');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84485922','Partes e acess.de teares retilin.p/fabr.malhas urdidura','Parts and acces.of flat looms, f/fabric warpers stit.','Partes y acces.de telares rect.p/fabr.tej.punto urdimb.',10,'84','8448','844859');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84485929','Outras partes e acess.de outras teares retilíneos','Other parts and acces.of other flat knitting','Las demás partes y acces.de demás telares rectilíneos',10,'84','8448','844859');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84485930','Partes e acess.de maqs.p/fabr.de redes, tules, filos, etc.','Parts and acces.of mach.f/making knot.netting, tulle, etc','Partes y acces.de máqs.p/fabr.de redes, tules, etc',10,'84','8448','844859');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84485940','Partes e acess.de máquinas p/fabr.guipuras, rendas, etc.','Parts and acces.of mach.f/making gimped yarn, turlle, etc','Partes y acces.de máquinas p/la fabr.bordados, etc',10,'84','8448','844859');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84485990','Outs.partes e acess.de outs.teares, maqs.costura entrel.','Oth.parts/acces.of oth.knitting, stitch-bonding mach.','Las dpartes y acces.de dem.telares, máqs.coser p/caden.',10,'84','8448','844859');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84490010','Máquinas e aparelhos p/fabricação/acabamento de feltros','Machinery for the manufacture or finishing of felt','Máquinas y aparatos p/fabricación/acabado del fieltro',11,'84','8449','844900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84490020','Máquinas e aparelhos p/fabr.de falsos tecidos','Machinery for the manufacture of nonwovens','Máquinas y aparatos p/fabr.de tejidos sin tejer',11,'84','8449','844900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84490080','Outs.maqs.e apars.p/fabr/acabam.de chapeus de feltros','Oth.machinery f/the manufacture/finishing of felt hat','Las demmáqs.y apars.p/fabr/acabad.de sombr.de fieltros',11,'84','8449','844900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84490091','Partes de máquinas e aparelhos p/fabr.de falsos tecidos','Other machinery for the manufacture of nonwovens','Partes de máquinas y aparatos p/fabr.de tejidos s/tejer',10,'84','8449','844900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84490099','Partes de máquinas e apars.p/fabr/acabam.de feltros, etc','Parts and acces.machinery f/manuf./finish.of felt, etc.','Partes de máquinas y apars.p/fabr/acab.del fieltro, etc',10,'84','8449','844900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84501100','Máquinas de lavar roupa, cap<=10kg, inteiramente automat.','Washing machines, cap<=10kg, fully automatic machin.','Máquinas de lavar ropa, cap<=10kg, totalmente automát.',11,'84','8450','845011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84501200','Maqs.de lavar roupa, cap<=10kg, c/secad.centrífugo incorp','Washing machines, cap<=10kg, with built-in centrif.drier','Máqs.p/lavar ropa, cap<=10kg, c/secad.centrífuga incorp.',11,'84','8450','845012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84501900','Outs.máquinas de lavar roupa, capac<=10kg de roupa seca','Oth.washing machines, capac<=10kg of dry clothes','Las dem.máquinas p/lavar ropa, capac<=10kg de ropa seca',11,'84','8450','845019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84502010','Tuneis continuos de lavar roupa, cap>10kg de roupa seca','Continuous tunnel of washing mach., cap>10kg dry clothes','Túneles continuos de lavar ropa, cap>10kg de ropa seca',11,'84','8450','845020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84502090','Outs.máquinas de lavar roupa, capacid>10kg de roupa seca','Oth.washing machines, capacity>10kg of dry clothes','Las dem.máquinas p/lavar ropa, capacid>10kg de ropa seca',11,'84','8450','845020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84509010','Partes de maqs.de lavar roupa, cap>10kg de roupa seca','Parts of washing machines, cap>10kg of dry clothes','Partes de máqs.p/lavar ropa, cap>10kg de ropa seca',10,'84','8450','845090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84509090','Partes de maqs.de lavar roupa, cap<=10kg de roupa seca','Parts of washing machines, cap<=10kg of dry clothes','Partes de máqs.de lavar ropa, cap<=10kg de ropa seca',10,'84','8450','845090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84511000','Máquinas para lavar roupa, a seco','Dry-cleaning machines','Máquinas para la limpieza en seco',11,'84','8451','845110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84512100','Máquinas p/secar roupa, capacidade<=10kg de roupa seca','Machines f/dry clothes, cap<=10kg of dry clothes','Máquinas p/secar ropa, capacidad<=10kg de ropa seca',11,'84','8451','845121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84512900','Outras máquinas para secar roupa','Other machines for dry clothes','Las demás máquinas para secar ropa',11,'84','8451','845129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84512910','Outs.maqs.p/secar roupa, por microondas, prod>=120 kg/h','Oth.machines f/dry clothes f/microwaves, prod>=120 kg/h','Las dem.máqs.p/secar ropa, por microondas, prod>=120 kg/h',11,'84','8451','845129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84512990','Outras máquinas para secar roupa','Other machines for dry clothes','Las demás máquinas para secar ropa',11,'84','8451','845129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84513010','Máquinas e prensas para passar roupa, automáticas','Ironing machines and presses f/clothes, automatics','Máquinas y prensas p/planchar ropa, automáticas',11,'84','8451','845130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84513090','Outs.maqs.e prensas p/passar roupa, incl.as fixadoras','Ot.iron.mach.and presses f/clothes, incl.fusing presses','Las dem.máqs.y prensas p/planchar ropa, incl.las p/fijar',11,'84','8451','845130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84513091','Prensas para passar roupa, de peso<=14kg','Ironing presses for clothers, weighing<=14kg','Prensas para planchar ropa, de peso<=14kg',11,'84','8451','845130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84513099','Outs.maqs.e prensas p/passar roupa, incl.as fixadoras','Oth.ironing machines and presses, incl.fusing presses','Las dem.máqs.y prensas p/planchar ropa, incl.las p/fijar',11,'84','8451','845130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84514010','Máquinas p/lavar fios/tecidos/obras de matérias têxteis','Machines f/washing yarns/fabric/artic.of textile mater.','Máquinas p/lavar hilados/tejidos/manuf.de mat.textiles',11,'84','8451','845140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84514021','Maqs.p/tingir tecidos em rolos, por pressão estatica, etc','Machines f/dyeing cylindrical fabrics, static presur.etc','Máqs.p/teñir tejidos en cuerda, a presión estática, etc',11,'84','8451','845140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84514029','Outras máquinas p/tingir ou branquear fios ou tecidos','Oth.machines f/dyeing or bleaching yarns or fabrics','Las dem.máquinas p/teñir o blanquear hilados o tejidos',11,'84','8451','845140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84514090','Máquinas branquear ou tingir outras matérias têxteis','Machines f/dyeing or bleaching oth.textile materials','Máquinas p/blanquear o teñir demás materias textiles',11,'84','8451','845140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84515010','Máquinas para inspecionar tecidos','Inspection machines for fabrics','Máquinas para inspeccionar tejidos',11,'84','8451','845150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84515020','Máquinas para enfestar ou cortar tecidos, automáticas','Automatic machines, f/stacking or cutting fabrics','Máquinas p/apilar o cortar tejidos, automáticas',11,'84','8451','845150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84515090','Outs.maqs.p/enrolar, desenrolar, dobrar, dentear tecidos','Oth.machin., f/reeling, unreeling, folding, pinking fabrics','Las dem.máqs.p/enrollar, desenr., plegar, dentar las telas',11,'84','8451','845150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84518000','Outs.máquinas e aparelhos p/trabalhar matérias têxteis','Oth.machinery f/work textile materials','Las dem.máquinas y aparatos p/trabaj.materias textiles',11,'84','8451','845180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84519010','Partes de máquinas de secar, capacid<=10kg de roupa seca','Parts of machines of drying, cap<=10kg of dry clothes','Partes de máquinas de secar, capacid<=10kg de ropa seca',10,'84','8451','845190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84519090','Partes de outs.máquinas e aparelhos p/trab.mater.têxtil','Parts of oth.machinery f/work textile materials','Partes de dem.máquinas y aparatos p/trab.mater.textil',10,'84','8451','845190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84521000','Máquinas de costura de uso doméstico','Sewing machines of the household type','Máquinas de coser de domésticas',11,'84','8452','845210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84522110','Máquinas para costurar couros ou peles, automáticas','Machines for sewing leather or skins, automatics','Máquinas p/coser cueros o pieles, automáticas',11,'84','8452','845221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84522120','Máquinas para costurar tecidos, automáticas','Machines for sewing fabrics, automatics','Máquinas para coser tejidos, automáticas',11,'84','8452','845221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84522190','Máquinas para costurar outras matérias, automáticas','Machines f/sewing other materials, automatics','Máquinas para coser demás materias, automáticas',11,'84','8452','845221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84522910','Máquinas para costurar couros ou peles, não automáticas','Machines for sewing leather or skins, no automatics','Máquinas para coser cueros o pieles, no automáticas',11,'84','8452','845229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84522921','Remalhadeiras para costurar tecidos, não automáticas','Mach.f/sewing toget.parts of knitt.garments, n/autom.','Remalladoras paracoser tejidos, no automáticas',11,'84','8452','845229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84522922','Máquinas para casear tecidos, não automáticas','Machines for button-hole sewing, no automatics','Máquinas para ribetear ojales, no automáticas',11,'84','8452','845229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84522923','Maqs.p/inserir elastico em tecido, zigue-zague, n/automat','Zig-zag machines, f/inserting elastic, no automatics','Máqs.p/insertar elástico en tejido, zig-zag, n/automát.',11,'84','8452','845229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84522924','Máquinas p/costurar tec., de costura reta,  não automatic','Machines for sewing fabrics, of straight seam, no automatics','Máquinas p/ coser tejidos, de costura recta, no automátcas',11,'84','8452','845229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84522925','Máquinas p/costurar tec., galoneiras, não automáticas','Machines for sewing fabrics, ribbon (sash) border, no automatics','Máquinas p/ coser tejidos, galoneiras, no automáticas',11,'84','8452','845229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84522929','Outras máquinas p/costurar tecidos, não automáticas','Other machines for sewing fabrics, no automatics','Las demás máquinas p/coser tejidos, no automáticas',11,'84','8452','845229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84522990','Outras máquinas de costura, não automáticas','Other machines for sewing, no automatics','Las demás máquinas de coser, no automáticas',11,'84','8452','845229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84523000','Agulhas para máquinas de costura','Sewing machine needles','Agujas para máquinas de coser',10,'84','8452','845230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84524000','Moveis, bases e tampas, p/máquinas de costura, suas partes','Furniture, bases and covers f/sewing mach., parts thereof','Muebles, basamentos y tapas, p/máqs.de coser, sus partes',10,'84','8452','845240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84529011','Guia-fios, lancadeiras, etc.p/maqs.de costura, domésticas','Thread-guides, shuttles, etc.f/sewing mach., domestic','Guía hilos, lanzaderas, etc.p/máqs.de coser, domésticas',10,'84','8452','845290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84529019','Outras partes de máquinas de costura, de uso doméstico','Other parts of sewing machines, domestic','Las dem.partes de máquinas de coser, doméstica',10,'84','8452','845290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84529020','Moveis,bases e tampas,p/maquinas de costura,suas partes','Furniture,bases and covers f/ sewing machines;its parts','Muebles, basamentos y tapas p/ máquinas de coser',10,'84','8452','845290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84529081','Guia-fios, lançadeiras e porta-bobinas p/maq.costura','Thread guides,shuttles and door-to-reels,sewing machine','Lanzaderas y puerta a los carretes, p/ máquina de coser',10,'84','8452','845290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84529089','Outras partes de máquinas de costura de uso doméstico','Other parts of sewing machines for home use','Las demás partes de máquinas de coser domésticas',10,'84','8452','845290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84529091','Guia-fios, lancadeiras, etc.p/outras máquinas de costura','Thread-guides, shuttles, etc.f/other sewing machines','Guía hilos, lanzaderas, etc.p/demás máquinas de coser',10,'84','8452','845290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84529092','Partes para remalhadeiras','Parts of mach.f/sewing toget.parts of knitted garments','Partes para remalladoras',10,'84','8452','845290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84529093','Lançadeiras rotativas de máquinas de costurar','Rotary shuttles of sewing machines','Lanzaderas rotativas de máquinas de coser',11,'84','8452','845290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84529094','Corpos moldados por fundição','Moulded bodies by foundry  ','Cuerpos amoldados por fundición    ',11,'84','8452','845290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84529099','Partes de outras máquinas de costurar','Parts of other sewing machines','Partes de las demás máquinas de coser',10,'84','8452','845290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84531010','Máquinas p/dividir couros c/l<=3m, lamina s/fim, eletron.','Mach.f/divide leathers c/w<=3m, endless lamin.electron.','Máquinas p/dividir cueros c/a<=3m, lámina s/fin, electr.',11,'84','8453','845310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84531090','Outs.máquinas e apars.p/prepar/curtir/trab.couros/peles','Other machines f/produc./tan/work leathers/skins','Las dem.máqs.y apars.p/prep/curtido/trab.cueros/pieles',11,'84','8453','845310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84532000','Máquinas e aparelhos p/fabr/conserto calçados','Machinery for making or repairing footwear','Máquinas y aparatos p/la fabric/reparación de calzados',11,'84','8453','845320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84538000','Maqs.e apars.p/fabr/conserto outs.obras de couros/peles','Mach.f/making/repair.footwear ot.artic.of lathers/skins','Máqs.y apars.p/fabr/reparac.dem.manuf.de cueros/pieles',11,'84','8453','845380');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84539000','Partes de maqs.e apars.p/prepar/curtir, etc.couros/peles','Parts of machines f/produc./tan, etc.leathers/skins','Partes de máqs.y apars.p/prep/curtido, etc.cueros/pieles',10,'84','8453','845390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84541000','Conversores para metalurgia, aciaria ou fundição','Converters of kind used metallurgy/in metal foundries','Convertidores para metalurgia, acerías o fundiciones',11,'84','8454','845410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84542010','Lingoteiras de fundição','Ingot moulds of foundry','Lingotes de fundición',11,'84','8454','845420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84542090','Cadinhos ou colheres de fundição','Ladles of foundry','Cucharas de colada',11,'84','8454','845420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84543010','Máquinas de vazar (moldar) sob pressão','Machines for casting under pressure','Máquinas de colar (moldear) a presión',11,'84','8454','845430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84543020','Máquinas de vazar (moldar) por centrífugação','Centrifugal casting machines','Máquinas de colar (moldear) por centrifugación',11,'84','8454','845430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84543090','Outs.maqs.de vazar (moldar), p/metalurgia, aciaria, etc.','Ot.casting mach.of kind used metal./metal foundries, etc','Las dem.máqs.de colar(moldear), p/metalurgia, acerías, etc',11,'84','8454','845430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84549010','Partes de máquinas de vazar (moldar) por centrífugação','Parts of centrifugal casting machines','Partes de máquinas de colar(moldear) por centrifugación',10,'84','8454','845490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84549090','Partes de conversores, etc.p/metalurgia/aciaria/fundição','Parts of conver.etc.of kind used metallurgy/foundries','Partes de convertidores, etc.p/metalurgia/acerías/fundic',10,'84','8454','845490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84551000','Laminador de metais, de tubo','Tube mills, of metal','Laminador de metales, de tubo',11,'84','8455','845510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84552110','Laminador a quente e/ou frio, de metais, de cilindro liso','Mills combi.hot and/or cold, metal, with smooth rollers','Laminador en caliente y/o frío, de met., de cilindro liso',11,'84','8455','845521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84552190','Outros laminadores a quente e/ou frio, de metais','Other mills combin.hot and/or cold, of metal','Los dem.laminadores en caliente y/o en frío, de metales',11,'84','8455','845521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84552210','Laminador a frio de metais, de cilindro liso','Cold-rolling mills for metal, with smooth rolls','Laminador en frío de metales, de cilindro liso',11,'84','8455','845522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84552290','Outros laminadores a frio de metais','Other cold-rolling mills for metal','Los demás laminadores en frío de metales',11,'84','8455','845522');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84553010','Cilindros de laminadores, fundidos, de aço/ferro nodular','Rolls for rolling mills, melted, of steel/nodular iron','Cilindros de laminadores, fundidos, de acero/fund.nodular',11,'84','8455','845530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84553020','Cilindro de lamin.forjad.de aço corte rap.c>=0.80%, etc.','Rolls f/roll.mills wroug.of steel cut fast c>=0.80%, etc','Cilindro de lamin.forj.de acero corte rap.c>=0.80%, etc',11,'84','8455','845530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84553090','Outros cilindros de laminadores de metais','Other rolls for rolling mills of metal','Los demás cilindros de laminadores de metales',11,'84','8455','845530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84559000','Outras partes de laminadores de metais','Other parts of metal mills','Las demás partes de laminadores de metales',10,'84','8455','845590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84561011','Maqs.ferram.a "laser", cmd.num.p/corte chapa metal.e>8mm','Machine-tools, num.com.f/cut plates metal.e>8mm','Máqs.herram.a láser, cmd.num.p/corte chapa metal.e>8mm',11,'84','8456','845610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84561019','Outs.máquinas ferram.oper.por "laser", etc.de cmd.numer.','Oth.machine-tools oper.by laser, etc.of num.controlled','Las dem.máqs.herram.q.oper.med.láser, etc.de cont.numér.',11,'84','8456','845610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84561090','Outras máquinas ferram.oper.por "laser", etc.','Other machine-tools operated by laser, etc.','Las demás máquinas herram.q.oper.mediante láser, etc',11,'84','8456','845610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84562010','Máquinas ferram.a ultra-som, de comando numérico','Machine-tools by ultrasonic, of numeric controlled','Máquinas herram.q.operen p/ultrasonido, de cont.numérico',11,'84','8456','845620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84562090','Outras máquinas ferram.oper.por ultra-som','Other machine-tools operated by ultrasonic processes','Las demás máquinas herram.q.oper.por ultrasonido',11,'84','8456','845620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84563010','Máquinas ferram.a eletro-erosao, de comando numerico','Mach.tools by electrodischarge, of numeric controlled','Máquinas herram.por electroerosión, de control numérico',11,'84','8456','845630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84563011','Maqs.ferram.eletroerosão, cmdo num.p/textur.sup.cilindr','Mach.tools by electrodisch., num.com.f/textur.cylin.surf','Máqs.herram.electroerosió, cont.num.p/textur.sup.cilindr',11,'84','8456','845630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84563019','Outs.máquinas ferram.a eletroerosão, de comando numer.','Oth.mach.tools by electrodischarge, of numer.controlled','Las dem.máqs.herram.p/electroerosión, de control numér.',11,'84','8456','845630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84563090','Outras máquinas ferram.oper.por eletroerosão','Oth.machine-toolsoperated by electrodischarge','Las demás máquinas herram.q.oper.por eletroerosión',11,'84','8456','845630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84569000','Outs.máqs.-ferr.que trab.p/elim.d/qq.matéria','Other mach./tools that work. to remov. any material ','Otras máquinas/herram. q/ trab. p/elim.de qq mat.',11,'84','8456','845690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84569100','Maqs.ferram.p/grav.a seco do traco em mater.semicondut.','Mach.tools f/dry-etching patterns on semicond.mater.','Máqs.herram.p/grab.en seco la traza en mater.semicond.',11,'84','8456','845691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84569900','Outras máquinas ferram.oper.por proc.eletroquímicos, etc','Oth.mach.tools oper.by process eletro-chemical, etc','Las dem.máqs.herram.q.oper.por proc.electroquímicos, etc',11,'84','8456','845699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84571000','Centros de usinagem, para trabalhar metais','Machining centres, for working metals','Centros de usinaje, para trabajar metales',11,'84','8457','845710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84572010','Maqs.de sistema monostatico, p/trab.metais, de cmdo.numer','Unit construction mach., f/working metals, of num.control','Máqs.de puesto fijo, p/trab.metales, de cont.numér.',11,'84','8457','845720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84572090','Outras máquinas de sistema monostatico, p/trab.metais','Other unit construction machines, f/working metals','Las demás máquinas de puesto fijo, p/trab.metales',11,'84','8457','845720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84573010','Maqs.de estacoes múltiplas, p/trab.metais, de cmdo.numer.','Multi-station transfer mach., f/work.metals, of num.con.','Máqs.de puestos múltiples, p/trab.metales, de cont.numér.',11,'84','8457','845730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84573090','Outras máquinas de estacoes múltiplas, p/trabalh.metais','Other multi-station transfer machines, f/work.metals','Las dem.máquinas de puestos múltiples, p/trabaj.metales',11,'84','8457','845730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84581110','Tornos horiz.p/trab.metais, c/cmdo.numer.tipo revólver','Horizon.lathes, f/work.metals, with num.com.type  revolve','Tornos horiz.p/trab.metales, c/cont.numér., revólver',11,'84','8458','845811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84581190','Outros tornos horiz.p/trab.metais, c/cmdo.numer.','Ot.horizontal lathes, f/work.metals, with numeric control','Los demás tornos horiz.p/trab.metales, c/cont.numér.',11,'84','8458','845811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84581191','Tornos horiz.p/trab.metais, 6 ou mais fusos porta-pecas','Horiz.lathes, f/work.metals, 6 or more work holder spind.','Tornos horiz.p/trab.metales, 6 o más husos portapiezas',11,'84','8458','845811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84581199','Outros tornos horiz.p/trab.metais, c/cmdo.numer.','Ot.horizontal lathes, f/work.metals, with numeric control','Los demás tornos horiz.p/trab.metales, c/cont.numér.',11,'84','8458','845811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84581910','Tornos horiz.p/trab.metais, s/cmdo.numer.tipo revólver','Horizon.lathes, f/work.metals, with num.com.type  revolve','Tornos horiz.p/trab.metales, s/cont.numér., revólver',11,'84','8458','845819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84581990','Outros tornos horiz.p/trab.metais, s/cmdo.numer.','Other horiz.lathes f/working metals, without num.control','Los demás tornos horiz.p/trab.metales, s/cont.numér.',11,'84','8458','845819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84589100','Outros tornos p/trab.metais, c/comando numerico','Other horizont.lathes f/working metals, with num.control','Los demás tornos p/trab.metales, c/control numérico',11,'84','8458','845891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84589900','Outros tornos p/trab.metais, s/comando numerico','Other lathes f/working metals, without num.controlled','Los demás tornos p/trab.metales, s/control numérico',11,'84','8458','845899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84591000','Maqs.ferram.p/furar, mandrilar, etc.metais, cabeça desliz.','Way-type unit head machines for drilling, boring, etc.met','Máqs.herram.de taladr, escariar, etc.metal., mecan.corred.',11,'84','8459','845910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84592110','Máquinas ferram.p/furar metais, cmd.num.radiais','Machinery f/drilling metals, radial numeric.controlled','Máquinas herram.de taladrar metales, cont.num.radiales',11,'84','8459','845921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84592191','Maqs.ferram.p/furar metais, cmd.num.cabecote>=1mono/mult','Machinery f/drilling metals, hedst.num.contr>=1mono/mult','Máqs.herram.p/taladrar met.con.num.cabez.>=1mono/mult',11,'84','8459','845921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84592199','Outras máquinas ferramentas p/furar metais, c/cmdo.numer','Other machinery f/drilling metals, with num.controlled','Las dem.máquinas herram.p/taladrar met.c/cont.numér',11,'84','8459','845921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84592900','Outras máquinas ferramentas para furar metais','Other machine-tools for drilling metals','Las demás máquinas herramientas para taladrar metales',11,'84','8459','845929');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84593100','Outras mandriladoras-fresadoras de metais, c/cmdo.numer.','Oth.boring-milling machines of met., with num.controlled','Las dem.mandrinadoras-fresadoras de met., c/cont.numér.',11,'84','8459','845931');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84593900','Outras mandriladoras-fresadoras de metais, s/cmdo.numer.','Oth.boring-milling machines of met., without num.contr.','Las dem.mandrinadoras-fresadoras de met., s/cont.numér.',11,'84','8459','845939');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84594000','Outras máquinas ferram.p/mandrilar metais','Other boring machines f/metals','Las demás máquinas herram.p/mandrilar metales',11,'84','8459','845940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84595100','Máquinas ferram.p/fresar metais, c/console, c/cmdo.numer.','Milling machines, f/metals, knee-type, with num.controlled','Máquinas herram.de fresar met., de consola, c/cont.numér.',11,'84','8459','845951');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84595900','Máquinas ferram.p/fresar metais, c/console, s/cmdo.numer.','Milling machines, f/metals, knee-type, without num.contr.','Máquinas herram.de fresar met., de consola, s/cont.numér.',11,'84','8459','845959');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84596100','Máquinas ferram.p/fresar metais, s/console, c/cmdo.numer.','Milling mach., f/metals, without knee-type, with num.cont.','Máquinas herram.de fresar met., s/consola, c/cont.numér.',11,'84','8459','845961');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84596900','Máquinas ferram.p/fresar metais, s/console, s/cmdo.numer.','Milling mac.f/metals without knee-type, without num.con.','Máquinas herram.de fresar met., s/consola, s/cont.numér.',11,'84','8459','845969');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84597000','Outs.maqs.ferram.p/roscar interior/exteriormente metal','Other threading or tapping machines, metals','Las dem.máqs.herr.de roscar interiores/exteriores met.',11,'84','8459','845970');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84601100','Maqs-ferram.p/retif.superf.plana de metais, c/cmd.num.','Grinding mach.surface glides of metals, with num.control','Máqs herram.de rect.superf.plana de metales, c/con.num.',11,'84','8460','846011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84601900','Outs.máquinas ferram.p/retif.superf.plana de metais, etc','Other grinding machines surface glides of metals, etc.','Las dem.máqs.herram.p/rectif.superf.plana de met., etc',11,'84','8460','846019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84602100','Outs.maqs.ferram.p/retif.metais, prec>=0.01mm, c/cmd.num.','Ot.mach.tools f/gridin.metals, prec>=0.01mm, with num.com','Las dem.máqs.herram.p/rectif.met.pr>=0.01mm, c/con.num.',11,'84','8460','846021');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84602900','Outs.maqs.ferram.p/retif.metais/ceramais, prec>=0.01mm','Ot.mach.tools f/griding/cermets, precision>=0.01mm','Las dem.máqs.herram.p/rectif.met./cermets, prec>=0.01mm',11,'84','8460','846029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84603100','Máquinas ferram.p/afiar metais/ceramais, c/cmdo.numerico','Mach.tools f/sharpening/cermets, with num.controlled','Máquinas herram.de afilar met./cermets, c/cont.numérico',11,'84','8460','846031');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84603900','Outras máquinas/ferramentas para afiar metais/ceramais','Other machines-tools f/sharpening/cermets','Las demás máquinas herram.de afilar metales/cermets',11,'84','8460','846039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84604011','Brunidoras p/cilindros de metais, d<=312mm, c/cmdo.numer.','Honning f/cylinders of metals, d<=312mm, with num.control','Bruñidoras p/cilindros de metales, d<=312mm, c/con.numér.',11,'84','8460','846040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84604019','Outs.maqs.ferram.p/brunir metais/ceramais, c/cmdo.numer.','Machine-tools f/honing metals/cermets, with num.control.','Las dem.máqs.herram.de bruñir met./cermets, c/con.numér.',11,'84','8460','846040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84604091','Outs.brunidoras p/cilindros de metais/ceramais, d<=312mm','Oth.honing f/cylinders of metals/cermets, d<=312mm','Las dem.bruñidoras p/cilindros de met./cermets, d<=312mm',11,'84','8460','846040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84604099','Outras máquinas ferram.p/brunir metais/ceramais','Other machine-tools f/honing metals/cermets','Las demás máquinas herram.de bruñir metales/cermets',11,'84','8460','846040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84609010','Outs.maqs.ferram.p/amolar, etc.metais/ceramais, c/cmd.num','Ot.mach.tools f/sharp.etc.metals/cermets, with num.cont.','Las dem.máqs.herram.p/amolar, etc.met./cermets, c/con.num',11,'84','8460','846090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84609011','Outs.maqs.ferram.polir, metais/ceramais, c/cmd.num.rotat.','Ot.mach.tools f/polish.metals/cermets, with num.cont.rot','Las dem.máqs.herr.p/pulir, etc.met/cermets, c/con.num.rot',11,'84','8460','846090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84609012','Maqs.ferram.de esmerilhar, cabeças>=2, porta-peca rotat.','Grinding mach.tools , heads>=2, rotary work holder','Máqs.herram.de esmerilar, cabez.>=2, portapieza rotat.',11,'84','8460','846090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84609019','Outs.maqs.ferram.p/amolar, etc.metais/ceramais, c/cmd.num','Ot.mach.tools f/sharp.etc.metals/cermets, with num.cont.','Las dem.máqs.herram.p/amolar, etc.met./cermets, c/con.num',11,'84','8460','846090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84609090','Outras máquinas ferram.p/amolar, etc.metais/ceramais','Ot.mach.tools f/sharpening, etc.metals/cermets','Las dem.máquinas herram.p/amolar, etc.metales/cermets',11,'84','8460','846090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84611000','Máquinas ferramentas para aplainar engrenagens','Machine-tools for planing gears','Máquinas herram.de cepillar engrenajes',11,'84','8461','846110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84612010','Máquinas ferramentas para escatelar engrenagens','Machine-tools for slotting gears','Máquinas herram.de mortajar engrenajes',11,'84','8461','846120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84612090','Plainas-limadoras de engrenagens','Machine-tools for shaping gears','Máquinas de limar engrenajes',11,'84','8461','846120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84613010','Máquinas ferram.p/brochar engrenagens, c/cmdo.numer.','Broaching machines for gears, with num.controlled','Máquinas herram.de brochar engrenajes, c/cont.numér.',11,'84','8461','846130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84613090','Outras máquinas ferram.p/brochar engrenagens','Other broaching machines for gears','Las demás máquinas herram.de brochar engrenajes',11,'84','8461','846130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84614010','Denteadoras de engrenagens, com comando numerico','Tooth-cutting machine, with num.control.','Dentadoras de engrenajes, con control numérico',11,'84','8461','846140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84614011','Denteadoras de engrenagens, tipo "pfauter", c/cmdo.numer.','Tooth-cutting machine, "pfaut''er" type, with num.control.','Dentadoras de engrenajes, tipo "pfauter", c/cont.numérico',11,'84','8461','846140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84614012','Redondeadoras de dentes de engrenagens, c/cmdo.numer.','Machines f/rounding-off gear teeth, with num.contr.','Redondeadoras de dientes de engrenajes, c/cont.numér.',11,'84','8461','846140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84614019','Outs.maqs.ferram.p/cortar/acabar engrenagens, c/cmd.num.','Oth.gear-cutting, gear-finishing machines, with num.contr','Las dem.máqs.herram.de tallar/acabar engren.c/cont.num.',11,'84','8461','846140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84614091','Outras redondeadoras de dentes de engrenagens','Other machines for rounding-off gear teeth','Las demás redondeadoras de dientes de engrenajes',11,'84','8461','846140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84614099','Outras máquinas ferram.p/cortar/acabar engrenagens','Other gear-cutting, gear-finishing machines','Las demás máquinas herram.p/tallar/acabar engrenajes',11,'84','8461','846140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84615010','Maqs.ferram.p/serrar/seccionar metais, de fitas sem fim','Sawing or cutting-off machines for metals, bandsaws','Máqs.herram.de aserrar/trocear metales, de cintas s/fin',11,'84','8461','846150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84615020','Máquinas ferram.p/serrar/seccionar metais, circulares','Sawing or cutting-off machines for metals, circular saws','Máquinas herram.de aserrar/trocear metales, circulares',11,'84','8461','846150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84615090','Outras máquinas ferram.p/serrar/seccionar metais','Other sawing or cutting-off machines f/metals','Las demás máquinas herram.de aserrar/trocear metales',11,'84','8461','846150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84619010','Outs.maqs.ferram.oper.por elim.metal, etc.c/cmdo.numer.','Ot.machin.tools operate f/elimin.met.etc.with num.cont','Las dem.máqs.herr.q.trab.p/arranq.metal, etc.c/con.num.',11,'84','8461','846190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84619090','Outras máquinas ferram.oper.por elim.metal, etc.','Ot.machin.tools operate f/elimination of metal, etc.','Las demás máquinas herram.q.trab.por arranque metal, etc',11,'84','8461','846190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84621011','Máquinas ferram.p/estampar metais, c/comando numerico','Die-stamping machines f/metals, with num.controlled','Máquinas herram.p/estampar metales, c/control numérico',11,'84','8462','846210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84621019','Maqs.ferram.p/forjar metais, martelos, etc.c/cmdo.numer.','Forging mach.toolsf/metals, hammers, etc.with num.contr','Máqs.herram.p/forjar metales, martillos, etc.c/con.numér.',11,'84','8462','846210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84621090','Outs.maqs.ferram.p/forjar/estampar metais, martelos, etc.','Oth.mach.tools f/forging/die-stamp.metals, hammers, etc.','Las dem.máqs.herram.p/forjar/estampar met.martillos, etc',11,'84','8462','846210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84622100','Maqs-ferram.p/enrolar, arquear, etc.metais, c/cmdo.numer.','Rolling, arching, etc.mach.tools f/metals, with num.contr','Máqs.herram.p/enrollar, curvar, etc.metales, c/cont.numér.',11,'84','8462','846221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84622900','Outras máquinas ferram.p/enrolar, arquear, etc.metais','Other rolling, arching, etc.machines-tools f/metals','Las demás máquinas herram.p/enrollar, curvar, etc.metales',11,'84','8462','846229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84623100','Máquinas ferram.p/cisalhar metais, c/comando numerico','Machines-tools f/shearing metals, with num.contr','Máquinas herram.de cizallar metales, c/cont.numérico',11,'84','8462','846231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84623910','Maqs-ferram.p/cisalhar metais, tipo guilhotina','Machines-tools for shearing metals, guillotine type','Máqs.herram.de cizallar metales, tipo guillotina',11,'84','8462','846239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84623990','Outras máquinas/ferramentas para cisalhar metais','Other machines-tools for shearing metals','Las demás máquinas herram.de cizallar metales',11,'84','8462','846239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84624100','Maqs.ferram.p/puncionar/chanfrar metais, c/cmdo.numer.','Machin.-tools f/punching/notching metals, with num.contr','Máqs.herram.p/punzonar/entallar metales, c/cont.numér.',11,'84','8462','846241');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84624900','Outras máquinas ferram.p/puncionar/chanfrar metais','Ot.mach.-tools f/punching/notching metals, with num.cont','Las demás máqs.herram.p/punzonar/entallar metales',11,'84','8462','846249');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84629111','Prensas hidraul.p/moldag.po metal.por sinter.c<=35000kn','Hydraulic pres.f/mould.met.powders by sinter.c<=35000kn','Prensas hidrául.p/mold.polvo metal.por sint.c<=35000kn',11,'84','8462','846291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84629119','Outras prensas hidraul.p/metais/carbon.metal.c<=35000kn','Oth.hydraulic pres.f/metals/metal.carbid.c<=35000kn','Las dem.prensas hidrául.p/met./carbon.metal.c<=35000kn',11,'84','8462','846291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84629191','Outras prensas hidraul.p/moldag.po metal.por sinter.','Other hydraulic pres.f/mould.met.powders by sintering','Las demás prensas hidrául.p/mold.polvo metal.por sint.',11,'84','8462','846291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84629199','Outras prensas hidraul.p/metais/carbon.metal.','Oth.hydraulic pres.f/metals/metallic carbides','Las demás prensas hidrául.p/metales/carbon.metal.',11,'84','8462','846291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84629910','Outras prensas p/moldag.de po metal.por sinter.','Other presses f/mould.met.powders by sintering','Las demás prensas p/mold.polvo metal.por sinteriz.',11,'84','8462','846299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84629920','Outs.prensas p/extrusao de metais/carbonetos metálicos','Oth.presses f/extrusion of metals/metallic carbides','Las dem.prensas p/extrusión de metales/carbon.metálicos',11,'84','8462','846299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84629990','Outras prensas p/trabalhar metais/carbonetos metálicos','Oth.presses f/working metals/metallic carbides','Las dem.prensas p/trabajar metales/carbon.metálicos',11,'84','8462','846299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84631010','Bancas para estirar tubos de metais/ceramais','Drawbenches for tubes of metals/cermets','Bancos de estirar tubos de metales/cermets',11,'84','8463','846310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84631090','Bancas p/estirar barras, perfis, fios de metais/ceramais','Drawbenches for tubes, profiles, wires of metals/cermets','Bancos de estirar barras, perf., alambres de met./cermets',11,'84','8463','846310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84632010','Maqs.ferram.p/fazer roscas por lamin.metais, c/cmd.numer','Thread-rolling machines, f/metals mills, with num.contr','Máqs.herram.de hacer roscas por lamin.met., c/con.num.',11,'84','8463','846320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84632090','Outs.maqs.ferram.p/fazer roscas por lamin.de metais, etc','Other thread-rolling machines, f/metals mills, etc.','Las dem.máqs.herram.p/hacer roscas por lamin.de met.etc',11,'84','8463','846320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84632091','Outs.maqs.ferram.de pente plano, cap>=160 roscas/min.','Oth.mach.tools of flat combs, cap>=160 threads/min.','Las dem.máqs.herram.de peine plano, cap>=160 roscas/min.',11,'84','8463','846320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84632099','Outs.maqs.ferram.p/fazer roscas por lamin.de metais, etc','Other thread-rolling machines, f/metals mills, etc.','Llas dem.máqs.herram.p/hacer roscas p/lamin.de met.etc',11,'84','8463','846320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84633000','Máquinas ferram.p/trabalhar arames e fios de metal','Machines for working wire threads of metal','Máquinas herram.p/trabajar alambres de metal',11,'84','8463','846330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84639010','Outs.maqs.ferram.p/trab.metais, s/elim.mater.c/cmd.numer','Oth.mach.f/working metals, without rem.mat.with num.com','Las dem.máq.herr.p/tr.met.q.n/trab.arranq.mat.c/con.num',11,'84','8463','846390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84639090','Outras máquinas ferram.p/trab.metais, s/elim.mater.','Ot.mach.tools f/working metals, without rem.material','Las demás máqs.herram.p/trab.met., q.n/trab.arranq.mat.',11,'84','8463','846390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84641000','Maqs.ferram.p/serrar pedra, prods.cerâmicos, concreto, etc','Mach.tools f/sawing stones, ceramics, concrete, etc','Máqs.herram.de aserrar piedra, cerámica, hormigón, etc',11,'84','8464','846410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84642010','Máquinas ferram.p/esmerilar/polir vidro','Machines-tools f/grinding or polishing glass','Máquinas herram.de amolar/pulir vidrio',11,'84','8464','846420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84642021','Maqs.ferram.p/polir placas, pavim.revestim.de cerâmica','Mach.tools f/polish.floor, wall tiles, slabs of ceramic','Máqs.herram.p/pulir placas, pavim.revestim.de cerámica',11,'84','8464','846420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84642029','Outs.máquinas ferram.p/esmerilar/polir cerâmica','Oth.machines-tools f/grinding or polishing ceramic','Las demás máquinas herram.p/amollar/pulir cerámica',11,'84','8464','846420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84642090','Máquinas ferram.p/esmerilar/polir pedra, etc.','Machines-tools f/grinding or polishing stone, etc','Máquinas herram.p/amolar/pulir piedra, etc',11,'84','8464','846420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84649011','Outs.maqs.ferram.p/retif.fresar, etc.vidro, c/cmd.numer.','Ot.mach.tools f/mil.grind.metals, etc.glass, with num.com','Las dem.máqs.herram.p/rect.fresar, etc.vidrio, c/con.num.',11,'84','8464','846490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84649019','Outras máquinas ferram.p/trab.a frio do vidro','Other machines tools for cold-working glass','Las demás máquinas herram.p/trab.el vidrio en frío',11,'84','8464','846490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84649090','Outras máquinas ferram.p/trab.pedra, prods.cerâmicos, etc','Other machines-tools f/working tools, ceramics, etc.','Las dem.máquinas herram.p/trab.piedra, cerámica, etc',11,'84','8464','846490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84651000','Maqs.ferram.p/trab.madeira, etc.c/difer.operac.s/trocar','Mach.tools f/working wood, etc.differ.oper.without tool','Máqs.herram.p/trab.madera, etc.c/dist.operac.s/cambio',11,'84','8465','846510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84659110','Maqs.ferram.de serrar madeira, cortiça, etc.de fita s/fim','Machine-tools f/sawing wood, cork, etc.bandsaws','Máqs.herram.de aserrar madera, corcho, etc.de cinta s/fin',11,'84','8465','846591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84659120','Maqs.ferram.de serrar madeira, cortiça, etc.circulares','Machine-tools f/sawing wood, cork, etc.circular saws','Máqs.herram.de aserrar madera, corcho, etc.circulares',11,'84','8465','846591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84659190','Outs.máquinas ferram.de serrar madeira, cortiça, osso, etc','Oth.machine-tools f/sawing wood, cork, bone, etc.','Las dem.máqs.herram.de aserrar madera, corcho, hueso, etc',11,'84','8465','846591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84659211','Fresadoras de madeira, cortiça, osso, etc.c/cmdo.numer.','Milling of wood, cork, bone, etc.with numer.controlled','Fresadoras de madera, corcho, hueso, etc.c/con.numér.',11,'84','8465','846592');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84659219','Maqs.ferram.p/desbastar, etc.madeira, etc.c/cmdo.numer.','Mach.tools f/planing, etc.wood, etc.with num.controlled','Máqs.herram.de cepillar, etc.madera, etc.c/con.numér.',11,'84','8465','846592');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84659290','Outs.maqs.ferram.p/desbastar, etc.madeira, cortiça, etc.','Oth.machine-tools f/planing, etc.wood, cork, etc.','Las demás máqs.herram.de cepillar, etc.madera, corcho, etc',11,'84','8465','846592');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84659310','Lixadeiras p/madeira, cortiça, osso, borracha endurec.etc.','Sanding machines wood, cork, bone, hard rubber.etc','Lixadeiras p/madera, corcho, hueso, caucho endurec.etc',11,'84','8465','846593');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84659390','Outs.maqs.ferram.p/esmerilar/polir madeira, cortiça, etc.','Oth.machine-tools f/grinding/polishing wood, cork, etc.','Las demás máqs.herram.de amolar/pulir madera, corcho, etc',11,'84','8465','846593');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84659400','Maqs.ferram.p/arquear/reunir madeira, cortiça, osso, etc.','Machine-tools f/bending/assembling wood, cork, bone, etc.','Máqs.herram.de curvar/ensamblar madera, corcho, hueso, etc',11,'84','8465','846594');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84659511','Maqs.ferram.p/furar madeira, cortiça, etc.c/cmdo.numer.','Machine-tools f/drilling wood, cork, etc.with num.contr.','Máqs.herram.p/taladrar madera, corcho, etc.c/con.numér.',11,'84','8465','846595');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84659512','Maqs.ferram.p/escatelar madeira, cortiça, etc.c/cmdo.num.','Machine-tools f/morticing wood, cork, etc.with num.contr','Máqs.herram.de mortajar madera, corcho, etc.c/cont.num.',11,'84','8465','846595');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84659591','Outs.máquinas ferram.p/furar madeira, cortiça, osso, etc.','Other machine-tools f/drilling wood, cork, bone, etc.','Las dem.máqs.herram.de taladrar madera, corcho, hueso, etc',11,'84','8465','846595');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84659592','Outs.maqs.ferram.p/escatelar madeira, cortiça, osso, etc.','Other machine-tools f/morticing wood, cork, bone, etc.','Las dem.máqs.herram.de mortajar madera, corcho, hueso, etc',11,'84','8465','846595');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84659600','Maqs.ferram.p/fender/seccionar/desenrolar madeira, etc.','Machine-tools f/splitting/slicing/paring wood, etc.','Máqs.herram.de hendir/rebanar/desenrollar madera, etc',11,'84','8465','846596');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84659900','Outras máquinas ferram.p/trab.madeira, cortiça, osso, etc.','Other machine-tools f/working wood, cork, bone, etc.','Las dem.máquinas herram.p/trab.madera, corcho, hueso, etc',11,'84','8465','846599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84661000','Porta-ferramentas e fieiras de abertura automática','Tool holders and self-opening dieheads','Portaútiles y disposit.de roscar de apertura automática',10,'84','8466','846610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84662010','Porta-peças para tornos','Work holders for lathes','Portapiezas para tornos',10,'84','8466','846620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84662090','Porta-peças para outras máquinas ferram.','Work holders for other machines and tools','Portapiezas para demás máquinas herram.',10,'84','8466','846620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84663000','Dispositivos divisores/especiais p/máquinas ferram.','Dividing heads/special attachments f/machines-tools','Dispositivos divisores/especiales p/máquinas herram.',10,'84','8466','846630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84669100','Partes e acess.de maqs.ferram.p/trab.pedra, concreto, etc','Parts and acces.mach.tools f/working stone, concrete, etc','Partes y acces.de máqs.herram.p/trab.piedra, hormig., etc',10,'84','8466','846691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84669200','Partes e acess.de maqs.ferram.p/trab.madeira, osso, etc.','Parts and acces.mach.tools f/working wood, bone, etc','Partes y acces.de máqs.herram.p/trab.madera, hueso, etc',10,'84','8466','846692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84669311','Partes e acess.de máquinas ferram.oper.por ultra-som','Parts and acces.mach.tools f/oper.by ultrasound','Partes y acces.de máquinas herram.q.oper.p/ultrasonido',10,'84','8466','846693');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84669319','Partes e acess.de máquinas ferram.oper.por "laser", etc.','Parts and acces.mach.tools f/oper.by lazer, etc.','Partes y acces.de máquinas herram.q.oper.por láser, etc',10,'84','8466','846693');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84669320','Partes e acess.de centros de usinagem, etc.p/trab.metais','Parts and acces.of machin.centers, etc.f/working metals','Partes y acces.de centros de usinaje, etc.p/trab.metales',10,'84','8466','846693');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84669330','Partes e acessórios de tornos para metais','Parts and accessories of lathes for metals','Partes y accessorios de tornos para metales',10,'84','8466','846693');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84669340','Partes e acess.de maqs.ferram.p/furar, fresar, etc.metais','Parts and acces.mac.tools f/drilling, milling, etc.metals','Partes y acces.de máqs.herram.de taldr., fresar, etc.met.',10,'84','8466','846693');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84669350','Partes e acess.de maqs.ferram.p/afiar, amolar, etc.metais','Parts and acces.mach.tools f/sharpening, etc.metals','Partes y acces.de máqs.herram.p/afilar, amolar, etc.met.',10,'84','8466','846693');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84669360','Partes e acess.de maqs.ferram.p/aplainar, etc.engrenagem','Parts and acces.mach.tools f/planing, etc.gear','Partes y acess.de máqs.herram.de cepillar, etc.engrenaje',10,'84','8466','846693');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84669410','Partes e acess.de máquinas ferram.p/forjar, etc.metais','Parts and acces.mach.tools f/forging, etc.metals','Partes y acces.de máquinas herram.p/forjar, etc.metales',10,'84','8466','846694');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84669420','Partes e acess.de máquinas ferram.p/enrolar, etc.metais','Parts and acces.mach.tools f/rolling, etc.metals','Partes y acces.de máquinas herram.p/enrollar, etc.met.',10,'84','8466','846694');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84669430','Partes e acessórios de prensas para extrusão de metais','Parts and acces.mach.tools f/extrusion of metals','Partes y acces.p/prensas p/extrusión de metales',10,'84','8466','846694');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84669490','Partes e acess.de outs.maqs.ferram.p/trab.metais, etc.','Parts and acces.of oth.mach.tools f/working metals, etc.','Partes y acces.de demás máqs.herram.p/trab.metales, etc',10,'84','8466','846694');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84671110','Furadeiras pneumáticas rotativas, de uso manual','Rotary pneumatic drills, for working in the hand','Taladradoras neumáticas rotativas, de uso manual',11,'84','8467','846711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84671190','Outras ferramentas pneumaticas rotativas, de uso manual','Other rotary pneumatic tools, f/working in the hand','Las dem.herramientas neumáticas rotativas, de uso manual',11,'84','8467','846711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84671900','Outras ferramentas pneumáticas, de uso manual','Other pneumatic tools, for working in the hand','Las dem.herramientas neumáticas, de uso manual',11,'84','8467','846719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84672100','Furadeiras com motor elétrico incorporado','Drills with self-contained electric motor','Taladros con motor eléctrico incorporado',11,'84','8467','846721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84672200','Serras com motor elétrico incorporado','Saws with self-contained electric motor','Sierras con motor eléctrico incorporado',11,'84','8467','846722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84672910','Tesouras com motor elétrico incorporado','Shears with self-contained electric motor','Tijeras con motor eléctrico incorporado',11,'84','8467','846729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84672991','Cortadoras de tecidos, com motor elétrico incorporado','Cutters for textiles, with self-contained electric motor','Cortadoras de tejidos, con motor eléctr.incorp.',11,'84','8467','846729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84672992','Parafusadeiras e rosqueadeiras, com motor elétrico','Screwdrivers and tapping mach.with self-cont.elec.motor','Parafusadeiras e rosqueadeiras, con motor eléctrico',11,'84','8467','846729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84672993','Martelos com motor elétrico incorporado','Hammers with self-contained electric motor','Martillos con motor eléctrico incorporado',11,'84','8467','846729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84672999','Outras ferramentas com motor elétrico incorporado','Other tools with self-contained electric motor','Las demás herramientas con motor eléctr.incorp.',11,'84','8467','846729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84678100','Serras de corrente, de uso manual','Chain saws, for working in the hand','Sierras de cadena, de uso manual',11,'84','8467','846781');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84678900','Outs.ferramentas hidraul/de motor n/eletr.de uso manual','Oth.tools f/work.hand, hydraulic eletr.motor/non-eletr','Las demás herram.hidrául/de motor n/eléct.de uso manual',11,'84','8467','846789');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84679100','Partes de serras de corrente, de uso manual','Parts of chain saws, f/working in the hand','Partes de sierras de cadena, de uso manual',10,'84','8467','846791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84679200','Partes de ferramentas pneumaticas, de uso manual','Parts of pneumatic tools, f/working in the hand','Partes de herramientas neumáticas, de uso manual',10,'84','8467','846792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84679900','Partes de ferramentas hidraul/de motor n/eletr.manuais','Parts of tools f/work.hand, hydra.eletr.motor/non-eletr','Partes de herramientas hidrául/de motor n/eléct.man.',10,'84','8467','846799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84681000','Maçaricos de uso manual','Hand-held blow pipes','Sopletes manuales',11,'84','8468','846810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84682000','Outras máquinas e aparelhos a gás,p/tempera superficial','Oth.gas-operated machin.and apparat., f/surface temper.','Las demás máquin.y aparatos de gas, p/temple superficial',11,'84','8468','846820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84688010','Máquinas e aparelhos para soldar por fricção','Machine-tools for friction welding','Máquinas y aparatos para soldar por fricción',11,'84','8468','846880');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84688090','Outras máquinas e aparelhos para soldar','Machine-tools for welding','Las demás máquinas y aparatos para soldar',11,'84','8468','846880');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84689010','Partes de maçaricos de uso manual','Parts of hand-held blow pipes','Partes de sopletes de uso manual',10,'84','8468','846890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84689020','Partes de máquinas e aparelhos para soldar por fricção','Pats of machine-tools for friction welding','Partes de máquinas y aparatos p/soldar por fricción',10,'84','8468','846890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84689090','Partes de outs.maqs.e apars.p/soldar, maqs.e apars.a gas','Pats of oth.machinery f/welding, gas-operat.mach.appl.','Partes de dem.máqs.y apars.p/soldar, máqs.y apars.de gas',10,'84','8468','846890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84690010','Máquinas de tratamento de textos','Word-processing machines','Máquinas de procesamiento de textos',11,'84','8469','846900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84690021','Maqs.escr.eletrôn.veloc.impr.<=40caract./seg','Electronic typewriters, print. speed <=40 char./sec.','Máquinas de escribir electrônicas, vel. impresión <= 40 caracteres/s',11,'84','8469','846900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84690029','Outs.máquinas d/escrever automáticas','Other automatic typewriters','Otras máquinas de escribir automáticas',11,'84','8469','846900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84690031','Máqs.d/estenotipar, ñ elétrica, p<=12kg','Stenotypes, non-electric w<=12kg','Máquinas de estenotipia, q.n/sean eléctr.p<=12kg',11,'84','8469','846900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84690039','Outras máquinas de escrever, não elétricas','Other typewriters, non-electric','Otras máquinas de escribir, que no sean eléctricas',11,'84','8469','846900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84691100','Máquinas de tratamento de textos','Word-processing machines','Máquinas p/tratamiento de textos',11,'84','8469','846911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84691210','Máquinas de escrever, automat.eletron.v<=40caracteres/s','Automatic typewriters, electric s<=40characters/s','Máquinas de escribir, automát.electrón.v<=40caracteres/s',11,'84','8469','846912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84691290','Outras máquinas de escrever, automáticas','Other automatic typewriters','Las demás máquinas de escribir, automáticas',11,'84','8469','846912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84692000','Máquinas de escrever, elétricas','Automatic typewriters, electric','Máquinas de escribir, eléctricas',11,'84','8469','846920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84693010','Máquinas de estenotipar, n/eletr.p<=12kg','Stenotypes, non-electric w<=12kg','Máquinas de estenotipia, q.n/sean eléctr.p<=12kg',11,'84','8469','846930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84693090','Outras máquinas de escrever, não elétricas','Other automatic typewriters, non-electric','Las demás máquinas de escribir, que no sean eléctricas',11,'84','8469','846930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84701000','Calculadoras eletron.c/func.s/fonte ext.energ.eletr.etc','Elect.calc.c/of oper.without ext.source  elec.power, etc','Calculadoras electr.func.s/fuente ext.energ.eléct.etc',11,'84','8470','847010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84702100','Máquinas de calcular, eletron.c/disposit.impress.incorp.','Calculating machines, elec.with disp.incorporate printer','Máquinas de calcular, electrón.c/disposit.impres.incorp.',11,'84','8470','847021');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84702900','Outras máquinas de calcular, eletrônicas','Other calculating machines, electronic','Las demás máquinas de calcular, electrónicas',11,'84','8470','847029');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84703000','Outras máquinas de calcular','Other calculating machines','Las demás máquinas de calcular',11,'84','8470','847030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84704000','Máquinas de contabilidade','Accounting machines','Máquinas de contabilidad',11,'84','8470','847040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84705011','Caixas registradoras, eletron.capac.comun.computador, etc','Cash registers, elec.comunic.with computer, etc.','Cajas registradoras, electrón.capac.comun.computador, etc',11,'84','8470','847050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84705019','Outras caixas registradoras eletrônicas','Other cash registers electronic','Las demás cajas registradoras electrónicas',11,'84','8470','847050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84705090','Outras caixas registradoras','Other cash registers','Las demás cajas registradoras',11,'84','8470','847050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84709010','Máquinas de franquear correspondência','Postage-franking machines','Máquinas de franquear correspondencia',11,'84','8470','847090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84709090','Outs.maqs.de franquear, emitir tiquetes e maqs.semelh.','Other franking machines, emit tickets and similar mach.','Las dem.máqs.de franquear, expedir boletos y máqs.simil.',11,'84','8470','847090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84711000','Máquinas p/processam.de dados, analogicas/hibridas','Machines f/data-processing, analogue/ hybrid','Máquinas p/procesam.de datos, analógicas/híbridas',11,'84','8471','847110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84713011','Maqs.dig.proc.dados, bater/eletr.portat.p<350g, t<=140cm2','Portab.dig.autom.data-proc.batt./elect.w<350g, s<=140cm2','Máqs.dig.proc.datos, bat./electr.portát.p<350g, t<=140cm2',11,'84','8471','847130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84713012','Maqs.dig.proc.dados, bater/eletr.portat.p<3.5kg, t<560cm2','Portab.dig.aut.data-proc.mach.bat/elec.w<3.5kg, s<560cm2','Máqs.dig.proc.datos, bat./electr.portát.p<3.5kg, t<560cm2',11,'84','8471','847130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84713019','Outs.maqs.digit.p/proc.dados, bater/eletr.portat.p<=10kg','Ot.port.dig.autom.data-proces.mach. bat/elec.w<=10kg','Las dem.máqs.dig.proc.datos, bat./electr.portát.p<=10kg',11,'84','8471','847130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84713090','Outs.maqs.automat.digit.p/proc.dados, portat.p<=10kg, etc','Oth.portable digital autom.data-proc.machin.w<=10kg, etc','Las dem.máqs.dig.proc.datos, portát.p<=10kg, etc',11,'84','8471','847130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714110','Maqs.dig.proc.dados, p<750g, entr.dados/cmdo.tela<280cm2','Dig.data-proc.mach.w<750g, entr.data/command, scr <280cm2','Máqs.dig.proc.datos, p<750g, entr.datos/con.tela<280cm2',11,'84','8471','847141');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714190','Outs.máquinas digit.p/proc.dados, c/ucp, mesmo c/unid.e/s','Ot.dig.mach.f/data-proc.with/cpu, incl.input/output unt.','Las dem.máqs.digit.p/proc.datos, c/ucp, incl.c/unid.e/s',11,'84','8471','847141');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714900','Outs.maqs.aut.proc.dados sob forma d/sistemas','Other aut. proces. dig. machine by form of system','Otras máq. autom. proc. datos, sob forma de sistemas',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714911','Sistema de unid.proc.digit.peq.cap.etc.fob<=us$12500','System of unit proces.dig.small cap.etc.fob<=us$12500','Sistema de unid.proc.digit.peq.cap.etc.fob<=us$12500',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714912','Sistema de unid.proc.digit.med.cap.etc.fob<=us$46000','System of unit proces.dig.medium cap.etc.fob<=us$46000','Sistema de unid.proc.digit.med.cap.etc.fob<=us$46000',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714913','Sistema de unid.proc.digit.gde.cap.etc.fob<=us$100000','System of unit proces.dig.big cap.etc.fob<=us$100000','Sistema de unid.proc.digit.gr.cap.etc.fob<=us$100000',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714914','Sistema de unid.proc.digit.muito gde.cap.fob>us$100000','System of unit proc.dig.very big cap.etc.fob<=us$100000','Sistema de unid.proc.dig.muy gde.cap.etc.fob<=us$100000',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714915','Sistema de outras unid.proc.digit.c/unid.memo e/ou e/s','System of ot.unit proc.dig.with unit of mem.input/outp.','Sistema de demás unid.proc.digit.c/unid.memo y/o e/s',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714921','Sistema de impressora de impacto, de linha','System of printer of impact, of line','Sistema de impresora de impacto, de linea',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714922','Sistema de impressora de impacto, de caracteres braille','System of printer of impact, braille','Sistema de impresora de impacto, de caracteres braille',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714923','Sistema de outs.impressoras de impacto, matric.por ponto','System of oth.printers of impact, dot matrix printers','Sistema de demás impresoras de impacto, matric.por punto',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714924','Sistema de outs.impressoras de impacto','System of other printers of impact','Sistema de demás impresoras de impacto',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714925','Sistema de impressora, de velocidade de impressão>=30ppm','System of printer, of speed of impression>=30ppm','Sistema de impresora, de velocidad de impresión>=30ppm',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714931','Sistema de impressora, v<30ppm, a jato tinta, li<=420mm','System of printer, s<30ppm, paint jet, wi<=420mm','Sistema de impresora, v<30ppm, a chorro tinta, ai<=420mm',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714932','Sistema de impressora, v<30ppm, transfer.term.cera solida','System of printer, s<30ppm, transfer thermal solid wax','Sistema de impresora, v<30ppm, transfer.térm.cera sólida',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714933','Sistema de impressora, v<30ppm, "laser", monocrom.li>230mm','System of printer, s<30ppm, laser, monochr.wi>230mm','Sistema de impresora, v<30ppm, láser, monocrom.li>230mm',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714934','Sistema de impressora, v<30ppm, "laser", etc.policrom.','System of printer, s<30ppm, laser, etc.poli-crhome','Sistema de impresora, v<30ppm, láser, etc.policrom.',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714935','Sistema de impressora, v<30ppm, "laser", monocr.li<=420mm','System of printer, s<30ppm, laser, monochrome wi<=420mm','Sistema de impresora, v<30ppm, láser, monocr.ai<=420mm',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714936','Sistema de outras impressoras, v<30ppm, li>420mm','System of other printers, s<30ppm, wi>420mm','Sistema de las demás impresoras, v<30ppm, ai>420mm',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714937','Sistema de outras impressoras, v<30ppm','System of other printers, s<30ppm','Sistema de las demás impresoras, v<30ppm',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714941','Sistema de traçadores gráficos, por meio de penas','System of tracer graphs, through feathers','Sistema de trazadores gráficos, por medio de penas',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714942','Sistema de outros traçadores gráficos, li>580mm','System of other tracer graphs, wi>580mm','Sistema de los demás trazadores gráficos, ai>580mm',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714943','Sistema de outros traçadores gráficos','System of other tracer graphs','Sistema de los demás trazadores gráficos',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714944','Sistema de digitalizadores de imagens, p/maqs.proc.dados','System digitizing of images, f/data-proces.machines','Sistema de digitalizadores de imágen., p/máqs.proc.datos',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714945','Sistema de teclados, para máquinas proces. de dados','System of keyboards, f/data-proces.machines','Sistema de teclados, p/máquinas proc.datos',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714946','Sistema de indicadores/apontadores,p/maqs.de proc.dados','System of indicative, f/data-proces.machines','Sistema de indicadores/apuntadores, p/máqs.de proc.datos',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714947','Sistema de mesas digitalizadoras, p/máquinas proc.dados','System of digitizing tables, f/data-proces.machines','Sistema de mesas digitalizadoras, p/máquinas proc.datos',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714948','Sistema de outs.unidades de entrada, p/maqs.proc.dados','System of oth.entrance unit, f/data-proces.machines','Sistem.de las dem.unidades de entrada, p/máqs.proc.datos',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714951','Sistema de aparelhos terminais c/teclado, vídeo monocrom','System of terminal appar.with keyboard, video monochrome','Sistema de aparatos terminales c/teclado, video monocr.',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714952','Sistema de aparelhos terminais c/teclado, video policrom','System of termin.appar.with keyboard, video poli-chrom.','Sistema de aparatos terminales c/teclado, video policrom',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714953','Sistema de unid.saida video, c/tubo raio catod.monocrom.','System of unit of video exit, cathode-ray tube monochr.','Sistema de unid.salida video, c/tubo rayo catód.monocr.',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714954','Sistema de unid.saida video, c/tubo raio catod.policrom.','System of unit of video exit, cathod.ray tube poli-chr.','Sistema de unid.salida video, c/tubo rayo catód.policr.',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714955','Sistema de outras unid.saida por video, monocromat.','System of other unit of video for exit, monochrome','Sistema de las demás unid.salida por video, monocrom.',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714956','Sistema de outras unid.saida por video, policromat.','System of other unit of video for exit, poli-chrome','Sistema de las demás unid.salida por video, policrom.',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714957','Sistema de terminais de auto-atendimento bancario','System of terminals of bank self-service','Sistema de terminales de autoatención bancaria',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714958','Sistema de impressora codigo barras postais, 3 em 5, etc.','System of printer code postal bars, 3 in 5, etc','Sistema de impresora código barras postales, 3 en 5, etc',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714959','Sistema de outras unidades de e/s, mesmo c/unid.memo','System of other units of input/output, incl.storag.units','Sistema de las demás unidades de e/s, incl.c/unid.mem.',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714961','Sistema de unidade de memória, p/disco magnet.flexiv.','System of unit of memory, f/flexible magnetic disk','Sistema de unidad de memoria, p/disco magnét.flexib.',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714962','Sistema de unidade de memória, p/disco magnet.rígido, etc','System of unit of memory, f/hard magnetic disk, etc.','Sistema de unidad de memoria, p/disco magnét.rígido, etc',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714963','Sistema de outras unidades de discos magnéticos','System of other units of magnetic disks','Sistema de las demás unidades de discos magnéticos',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714964','Sistema de unidade de disco óptico','Optical system of disk drive','Sistema de unidad de disco óptico',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714965','Sistema de unidade de fitas magnéticas, p/fitas em rolos','System of unit of magnetic ribbons, f/ribbons in rolls','Sistema de unidad de cintas magnéticas, p/cint.en rollos',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714966','Sistema de unidade de fitas magnéticas, p/cartuchos','System of unit of magnetic ribbons, f/cartridges','Sistema de unidad de cintas magnéticas, p/cartuchos',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714967','Sistema de unidade de fitas magnéticas, p/cassetes','System of unit of magnetic ribbons, f/cassette','Sistema de unidad de cintas magnéticas, p/casetes',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714968','Sistema de outras unidades de fitas magnéticas','System of other units of magnetic ribbons','Sistema de las demás unidades de cintas magnéticas',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714969','Sistema de outras unidades de memória','System of other storage units','Sistema de las demás unidades de memoria',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714971','Sistema de unidade controladora de terminais','System of controlling unit of terminals','Sistema de unidad controladora de terminales',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714972','Sistema de unidade controladora de comunicações','System of controlling unit of communications','Sistema de unidad controladora de comunicaciones',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714973','Sistema de unidade tradutora protocol.p/intercon.redes','System of unit translators f/intercon.networks','Sistema de unidad traductora protocol.p/intercon.redes',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714974','Sistema de unidade distribuidora de conexões p/redes','System of distributing unit of connections f/netsworks','Sistema de unidad distribuidora de conexiones p/redes',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714975','Sistema de outras unidades de controle, etc.de sinais','System of other units of control, etc.of signs','Sistema de las demás unidades de control, etc.de sinales',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714976','Sistema de outs.unidades de máquinas automat.proc.dados','System of other units of autom.data-proces.machines','Sistema de ots.unidades de máquinas automát.proc.datos',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714991','Sistema de leitores/gravadores de cartões magnet.','System of readers and recording of magnetic cards','Sistema de lectores/grabadores de tarjetas magnét.',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714992','Sistema de leitores de código de barras','System of readers of bars code','Sistema de lectores de código de barras',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714993','Sistema de leitores de caracteres magnetizaveis','System of readers of characters magnetized','Sistema de lectores de caracteres magnetizables',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714994','Sistema de outs.leitores/gravadores, p/maqs.proc.dados','System of readers and recording, f/data-proces.machines','Sistema de ots.lectores/grabadores, p/máqs.proc.datos',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714995','Sistema de outras máquinas automat.p/proc.dados','System of other autom.data-proces.machines','Sistema de otras máquinas automát.p/proc.datos',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84714996','Sistema de digitalizadores de imagens ("scanners")','System of digitizing of images ("scanners")','Sistema de digitalizadores de imágenes ("scanners")',11,'84','8471','847149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84715010','Unid.proc.digit.peq.cap.base microprocess.fob<=us$12500','Digital proces.unit small cap.microproces.fob<=us$12500','Unid.proc.digit.peq.cap.base microproces.fob<=us$12500',11,'84','8471','847150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84715020','Unid.proc.digit.med.cap.etc.us$12500<fob<=us$46000','Digital proces.unit med.cap.etc.us$12500<fob<=us$46000','Unid.proc.digit.med.cap.etc.us$12500<fob<=us$46000',11,'84','8471','847150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84715030','Unid.proc.digit.gde.cap.etc.us$46000<fob<=us$100000','Digital proces.unit big cap.etc.us$46000<fob<=us$100000','Unid.proc.digit.gran.cap.etc.us$46000<fob<=us$100000',11,'84','8471','847150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84715040','Unid.proc.digit.muito gde.cap.etc.fob>us$100000','Digital proces.unit very big cap.etc.fob>us$100000','Unid.proc.digit.muy gde.cap.etc.fob>us$100000',11,'84','8471','847150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84715090','Outras unidad.proc.digit.com unid.memo e/ou 1 unid.e/s','Ot.units digital proces.stor.unit input/1 input/output','Las dem.unidad.proc.digit.con unid.memo e/o 1 unid.e/s',11,'84','8471','847150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716011','Impressoras de impacto, de linha','Printers of impact, line','Impresoras de impacto, de línea',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716012','Impressoras de impacto, matriciais (por pontos)','Printers of impact, (dot matrix printers)','Impresoras de impacto, matriciales (por puntos)',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716013','Impressoras de impacto, de caracteres braille','Printers of impact, (braille printer)','Impresoras de impacto, de caracteres braille',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716014','Outs.impressoras de impacto, matriciais (por pontos)','Other printers of impact, (dot matrix printers)','Las dem.impresoras de impacto, matriciales (por puntos)',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716019','Outras impressoras de impacto','Other printers of impact','Las demás impresoras de impacto',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716021','Impressoras c/vi<30ppm, a jato de tinta liq.li<=420mm','Printers with si<30pbm, ink-jet printers wi<=420mm','Impresoras c/vi<30ppm, a chorro de tinta líq.ai<=420mm',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716022','Impressoras c/vi<30ppm, de transfer.termica cera solida','Printers with si<30pvm, of transfer thermal solid wax','Impresoras c/vi<30ppm, de transfer.térmica cera sólida',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716023','Impressoras c/vi<30ppm, a "laser", etc.monocrom.li>230mm','Printers with si<30pbm, by laser, etc.monochrome wi>230mm','Impresoras c/vi<30ppm, a laser, etc.monocrom.ai>230mm',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716024','Impressoras c/vi<30ppm, a "laser", etc.policrom.','Printers with si<30ppm, by laser, etc.poli-chromatic','Impresoras c/vi<30ppm, a laser, etc.policrom.',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716025','Impressoras c/vi<30ppm, a "laser", etc.monocrom.li<=420mm','Printer with si<30ppm, by laser, etc.monochrom. wi<=420mm','Impresoras c/vi<30ppm, a laser, etc.monocrom.ai<=420mm',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716026','Outras impressoras c/vi<30ppm, li>420mm','Other printers with si<30ppm, wi>420mm','Las demás impresoras c/vi<30ppm, ai>420mm',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716029','Outras impressoras c/vi<30ppm','Other printers with si<30ppm','Las demás impresoras c/vi<30ppm',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716030','Outras impressoras c/vi>=30ppm','Other printers with si>=30ppm','Las demás impresoras c/vi>=30ppm',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716041','Tracadores graficos ("ploters"), por meio de penas','Tracer graphs("plotters"), dot matrix plotters','Trazadores gráficos ("ploters"), por medio de penas',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716042','Outros tracadores graficos ("ploters"), li>580mm','Other tracer graphs("plotters"), wi>580mm','Los demás trazadores gráficos ("ploters"), ai>580mm',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716049','Outros tracadores graficos ("ploters")','Other tracer graphs ("plotters")','Los demás trazadores gráficos ("ploters")',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716051','Digitalizador de imagens, p/máquinas automat.proc.dados','Digitizing of images, f/autom.data-proces.machines','Digitalizador de imágenes, p/máquinas automát.proc.datos',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716052','Teclados p/máquinas automat.proc.dados','Keyboard f/autom.data-proces.machines','Teclados p/máquinas automát.proc.datos',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716053','Indicadores/apontadores, p/máquinas automat.proc.dados','Indicators f/autom.data-proces.machines','Indicadores/apuntadores, p/máquinas automát.proc.datos',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716054','Mesas digitalizadoras, p/máquinas automat.proc.dados','Digitizing tables, f/autom.data-proces.machines','Mesas digitalizadoras, p/máquinas automát.proc.datos',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716059','Outs.unidades de entrada, p/máquinas automat.proc.dados','Other input units, f/autom.data-proces.machines','Las dem.unidades de entr., p/máquinas automát.proc.datos',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716061','Aparelhos terminais c/teclado alfanum.video monocromat.','Terminal apparatus with keyboard alphanumeric mon.video','Aparatos terminales c/teclado alfanum.video monocromát.',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716062','Aparelhos terminais c/teclado alfanum.video policromat.','Terminal apparatus with keyboard alphan.poli-chr.video','Aparatos terminales c/teclado alfanum.video policromát.',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716071','Unidade de saida por video, c/tubo raios catod.monocrom.','Output unit by video, cathode-ray tubes monochrome','Unidad de salida por video, c/tubo rayos catód.monocrom.',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716072','Unidade de saida por video, c/tubo raios catod.policrom.','Output unit by video, cathode-ray tubes poli-chrome','Unidad de salida por video, c/tubo rayos catód.policrom.',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716073','Outras unidades de saida por video, monocromaticas','Other output units by video, cathode-ray tube monochrome','Las demás unidades de salida por video, monocromáticas',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716074','Outras unidades de saida por video, policromaticas','Other output units by video, poli-chrome','Las demás unidades de salida por video, policromáticas',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716080','Terminais de auto-atendimento bancario','Terminals of bank self-service','Terminales de autoatención bancaria',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716090','Outs.unids.d/entr./saída, p/máqs.proc.dados','Other input/output units for data-proces.machines','Unidad. de entrada e salida p/ máquin.proc.datos',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716091','Impressoras de codigo de barras postais, 3 em 5, etc.','Postal printers of bars code, 3 in 5, etc','Impresoras de código de barras postales, 3 en 5, etc',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84716099','Outras unidades de entrada/saida, p/máquinas proc.dados','Other input/output units, f/autom.data-proces.machines','Las dem.unidades de entrada/salida, p/máquins.proc.datos',11,'84','8471','847160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84717011','Unidades de discos magnéticos, para discos flexíveis','Units of magnetic disks, f/flexible disks','Unidades de discos magnéticos, p/discos flexibles',11,'84','8471','847170');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84717012','Unidades de discos magnéticos, para discos rígidos','Units of magnetic disks, f/hard disks','Unidades de discos magnéticos, p/discos rígidos',11,'84','8471','847170');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84717019','Outras unidades de discos magnéticos','Other units of magnetic disks','Las demás unidades de discos magnéticos',11,'84','8471','847170');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84717021','Unidades de discos ópticos, para leitura de dados','Units of optical disks, f/reader of data','Unidades de discos ópticos, p/lectura de datos',11,'84','8471','847170');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84717029','Outras unidades de discos ópticos','Other units of optical disks','Las demás unidades de discos ópticos',11,'84','8471','847170');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84717031','Unidades de fitas magnéticas, para fitas em rolos','Units of magnetic ribbons, f/ribbons in rolls','Unidades de cintas magnéticas, p/cintas en rollos',11,'84','8471','847170');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84717032','Unidades de fitas magnéticas, para cartuchos','Units of magnetic ribbons, f/cartridges','Unidades de cintas magnéticas, p/cartuchos',11,'84','8471','847170');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84717033','Unidades de fitas magnéticas, para cassetes','Units of magnetic ribbons, f/cassette','Unidades de cintas magnéticas, p/casetes',11,'84','8471','847170');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84717039','Outras unidades de fitas magnéticas','Other units of magnetic ribbons','Las demás unidades de cintas magnéticas',11,'84','8471','847170');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84717090','Outras unidades de memória','Other storage units','Las demás unidades de memoria',11,'84','8471','847170');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84718000','Outs.unidades d/máq.autom.p/proc.dados','Other autom. units of  machines to data-processing','Otras unidad. de máquin.autom. p/ proc.datos',11,'84','8471','847180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84718011','Unidades controladoras de terminais de processamento de dados','Controlling units of terminals of data-processing','Unidades controladoras de terminales de proc.datos',11,'84','8471','847180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84718012','Unidades controladoras de comunicações de proc.dados','Controlling units of terminals of data-processing','Unidades controladoras de comunicaciones de proc.datos',11,'84','8471','847180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84718013','Unidades tradutoras de protocolos p/interconex.de redes','Protocol translators(converters)f/intercon.networks','Unidades tradutoras de protocolos p/intercon.de redes',11,'84','8471','847180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84718014','Unidades distribuidoras de conexões para redes','Network connection distributors','Unidades distribuidoras de conexiones p/redes',11,'84','8471','847180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84718019','Outras unidades de controle, adaptação, conversão de sinal','Oth.units of control, adaptation, conversion of fate','Las dem.unidades de control, adaptación, convers.de señ.',11,'84','8471','847180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84718090','Outras unidades de máquinas automats.p/processamento de','Other units of automatic data-processing machines','Las demás unidades de máqs.automáts.p/procesamiento de',11,'84','8471','847180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84719011','Leitores ou gravadores de cartões magnéticos','Readers or tape recorders of magnetic cards type','Lectores o grabadores de tarjetas magnéticas',11,'84','8471','847190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84719012','Leitores de codigos de barras','Bar-code readers','Lectores de códigos de barras',11,'84','8471','847190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84719013','Leitores de caracteres magnetizaveis','Magnetizable type readers','Lectores de caracteres magnetizables',11,'84','8471','847190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84719014','Digitalizadores de imagens ("scanners")','Scanners','Digitalizadores de imágenes ("scanners")',11,'84','8471','847190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84719019','Outros leitores ou gravadores, de processamento de dados','Other readers or tape recorders, of data-processing','Los dem.lectores o grabadores, de procesamiento de datos',11,'84','8471','847190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84719090','Outs.máquinas automat.p/process.de dados, suas unidades','Other automatic data-processing machines, its units''','Las dem.máquinas automát.p/proces.de datos, sus unidades',11,'84','8471','847190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84721000','Duplicadores hectograficos ou a estencil, p/escritório','Hectograph or stencil duplicating machines, f/office','Copiadoras hectográficas o de stencils, de oficina',11,'84','8472','847210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84722000','Maqs.p/imprimir enderecos, p/estampar placa de enderecos','Addressing machines/address plate embossing machine','Máqs.de imprimir direcciones, p/estampar placa de direc.',11,'84','8472','847220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84723010','Máquinas automat.p/obliterar selos postais','Automatic postage-stamp cancelling machine','Máquinas automát.p/obliterar sellos postales',11,'84','8472','847230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84723020','Maqs.automat.p/selecao correspond.leit.opt.cod.post.etc','Autom.machines f/sorting, optical post code reader, etc','Máqs.automát.p/selecc.correspond.lect.ópt.cód.post.etc',11,'84','8472','847230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84723030','Maqs.automat.p/selecao encomendas, leit.opt.cod.post.etc','Mach.f/select orders, optical post code reader, etc','Máqs.automát.p/selecc.encomiendas, lect.ópt.cód.post.etc',11,'84','8472','847230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84723090','Outs.maqs.p/selecionar, dobrar, abrir, etc.correspondencia','Machines f/sorting, folding, opening, etc.correspondence','Las dem.máqs.p/clasificar, plegar, abrir, etc.correspond.',11,'84','8472','847230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84729010','Distribuidores automat.papel-moeda, incl.efet.outs.oper.','Automatic banknote dispensers, inc.makes oth.operations','Distribuidores autom.billet.de bco.incl.efet.dem.oper.',11,'84','8472','847290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84729021','Maqs.eletron.bancarias de autent.comun.c/computador, etc','Banking electronics mach.authen.commun.with comput., etc','Máqs.electr.bancarias de autent.comun.c/computador, etc',11,'84','8472','847290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84729029','Outras máquinas bancarias, c/dispositivos p/autenticar','Oth.banking electronics mach.with disp.f/authenticating','Las dem.máquinas bancarias, c/dispositivos p/autenticar',11,'84','8472','847290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84729030','Máquinas p/selecionar e contar moedas ou papel-moeda','Machines f/sorting and f/counting coins or banknote','Máquinas p/clasificar y contar monedas o billet',11,'84','8472','847290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84729040','Máquinas de apontar lapis, perfuradores, grampeadores, etc','Pencil-sharpening machines, perforating, stapling, etc.','Máquinas de sacapuntas, perforadoras, grapadoras, etc',11,'84','8472','847290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84729051','Classificadoras automat.docum.c/leit/grav.c>400doc/min','Classifying autom.of doc.with reader/record.c>400 p/min','Clasificadoras automát.docum.c/lect/grab.c>400doc/min',11,'84','8472','847290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84729059','Outras classificadoras automat.docum.c/leit/grav.','Other classifying autom.of doc.with reader/recording','Las demás clasificadoras automát.docum.c/lect/grab.',11,'84','8472','847290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84729090','Outras máquinas e aparelhos de escritório, bancario, etc.','Other machinery and apparatus of office, bank, etc.','Las dem.máquinas y aparatos de oficina, bancario, etc',11,'84','8472','847290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84729091','Máqs.impr.ender., p/estamp.placa d/enders.','Machines to print address, to print plates of address','Máq.de impr. dirección, p/ estampar platos de dirección',11,'84','8472','847290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84729099','Outs.máqs.apars.d/escritório, bancário, etc.','Other machin./appl. of office, bank, etc.','Otras máq. / apar. de oficina , banco, etc.',11,'84','8472','847290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84731010','Partes e acess.de máquinas de tratamento de textos','Parts and accessories of texts treatment','Partes y acces.de máquinas de procesamiento de textos',10,'84','8473','847310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84731090','Partes e acess.de máquinas de escrever','Parts and accessories of writing machines','Partes y acces.de máquinas de escribir',10,'84','8473','847310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84732100','Partes e acess.de máquinas de calcular eletrônicas','Parts and acces.electronic calculating of machines','Partes y acces.de máquinas de calcular electrónicas',10,'84','8473','847321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84732910','Circuito impresso montado p/caixa registradora','Printed circuits mounted, for cash registers','Circuito impreso c/comp.p/caja registradora',10,'84','8473','847329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84732920','Partes e acess.de outs.maqs.de calcular/contabilidade','Parts and acces.calculating of machines/accounting','Partes y acces.de demás máqs.de calcular/contabilidad',10,'84','8473','847329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84732990','Partes e acess.de maqs.de franquear, emitir tiquetes, etc','Parts and acces. of machines emit tickets, etc','Partes y acces.de máqs.de franquear, expedir boletos, etc',10,'84','8473','847329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733011','Gabinete c/fonte de aliment.p/maqs.automat.proc.dados','Cabinet with source supply, f/automatic data-proces.mac.','Gabinete c/fuente de aliment.p/máqs.automát.proc.datos',11,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733019','Outros gabinetes p/máquinas automat.proc.dados','Other cabinet, f/automatic data-proces.machines','Los demás gabinetes p/máquinas automát.proc.datos',11,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733021','Mecanismos de impressora matricial, etc.jato tinta, mont.','Mechanisms of matrix printers, etc.ink-jat, mounted','Mecanismos de impresora matric., etc.chorro tinta, mont.',11,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733022','Mecanismos de impressora a "laser", led ou lcs, montados','Mechanisms of printer by laser, led or lcs, mouted','Mecanismos de impresora a láser, led o lcs, montados',11,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733023','Martelo de impressão e bancos de martelos, p/impressoras','Hammer of impression and banks of hammers, for printers','Martillo de impresión y bancos de martillos, p/impres.',10,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733024','Cabeça de impressão, exc.termica/jato tinta, p/impressora','Printing heads, exc.thermal/ink-jet, for printer','Cabezal de impresión, exc.térmico/chorro tinta, p/impres.',10,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733025','Cabeça de impressão termica/jato de tinta, p/impressora','Printing heads, thermal/ink-jet, for printer','Cabezal de impresión térmico/chorro de tinta, p/impres.',10,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733026','Cintas de caracteres, para impressoras','Type ribbon, thermal/ink-jet, for printer','Cintas de caracteres, p/impresoras',10,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733027','Cartuchos de tinta, para impressoras','Ink cartridge, thermal/ink-jet, for printer','Cartuchos de tinta, p/impresoras',11,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733029','Outs.partes e acess.de impressoras/tracadores graficos','Oth.parts and acces.of printers/tracer graphs','Las demás partes y acces.de impres./trazadores gráficos',10,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733031','Conjuntos cabeça-disco de unid.de disco rígido, montados','Groups head-disk of hard disk unit, mounted','Conjuntos cabeza disco de unid.de disco rígido, montados',10,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733032','Bracos posicion.de cabeça magnet.p/unid.de discos/fitas','Position.arms of magnetic head f/unit of disks/tape','Brazos posic.de cabeza magnét.p/unid.de discos/cintas',10,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733033','Cabeças magnéticas para unidades de discos ou de fitas','Magnetic head for unit of disks or of tape','Cabezas magnéticas para unidades de discos o de cintas',10,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733034','Mecanismo bobinador para unidades de fitas magnéticas','Reeling mechanism for units of magnetic tape','Mecanismo bobinador p/unidades de cintas magnéticas',10,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733039','Outs.partes e acess.de unid.de discos/fitas magnéticos','Oth.parts and accessor.of disk units/magnetic tape','Las dem.partes y acces.de unid.de discos/cintas magnét.',10,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733041','Placas-mae montad.p/maqs.proc.dados (circuito impresso)','Motherboards mounted f/data-proc.mach.(circuit printed)','Placas-madre mont.p/máqs.proc.datos(circuito impreso)',11,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733042','Placas de memória, montadas, s<=50cm2, p/maqs.proc.dados','Plates of memory, mounted, s<=50cm2 f/data-proc.mach.','Placas de memoria, montadas, s<=50cm2, p/máqs.proc.datos',11,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733043','Placas de microprocessam.c/disposit.dissipacao de calor','Plates of micropr.with dispositive dissipation of heat','Placas de microprocesam.c/disposit.disipación de calor',11,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733049','Outs.circuitos impressos p/máquinas automat.proc.dados','Oth.circuits printed for autom.data-processing appart.','Los demás circuitos impresos p/máqs.automát.proc.datos',11,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733050','Cartões de memória p/máquinas automat.proc.dados','Cards of memory f/autom.data-processing apparatus','Tarjetas de memoria p/máquinas automát.proc.datos',11,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733091','Tela p/microcomputadores portateis, monocromatica','Screen for microcomputers portable, monochrome','Pantalla p/microcomputadores portátiles, monocromática',11,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733092','Tela p/microcomputadores portateis, policromatica','Screen for microcomputers portable, poli-chrome','Pantalla p/microcomputadores portatiles, policromática',11,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84733099','Outras partes e acess.p/máquinas automat.proc.dados','Cards of memory f/autom.data-processing apparatus','Las demás partes y acces.p/máquinas automát.proc.datos',10,'84','8473','847330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84734010','Circuito impresso montado p/máquinas e apars.escritório','Circuit printed mounted f/office machines/apparatus','Circuito impreso montado p/máquinas y apars.de oficina',11,'84','8473','847340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84734070','Outs.partes e acess.p/maqs.bancaria, distrib.papel-moeda','Oth.parts and acces.f/banking mach.banknote dispensers','Las dem.partes y acces.p/máqs.banc.distr.billetes banco',10,'84','8473','847340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84734090','Outs.partes e acess.p/maqs.e apars.de escritório, etc.','Oth.parts and acces.f/office machines and apparatus, etc','Las dem.partes y acces.p/máqs.y apars.de oficina, etc',10,'84','8473','847340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84735010','Circuito impresso montado util.em 2/mais dif.máquinas','Circuit printed mounted used in 2/more differ.machines','Circuito impreso montado util.y 2/más dist.máquinas',11,'84','8473','847350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84735020','Cartões de memória, util.2/mais dif.máquinas','Cards of memory used in two/more different machines','Tarjetas de memoria, util.2/más dist.máquinas',10,'84','8473','847350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84735031','Martelo de impressão, etc.util.2/mais dif.máquinas','Hammer of printer, etc.used in 2/more different machines','Martillo de impresión, etc.util.2/más dist.máquinas',10,'84','8473','847350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84735032','Outras cabeças de impressão, util.2/mais dif.máquinas','Oth.head of printer.used in 2/more differ.machines','Los dem.cabezales de impresión, util.2/más dist.máquinas',10,'84','8473','847350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84735033','Cabeças de impressão termicas, etc.util.2/mais dif.maqs.','Head of thermal printer, used in 2/more dif.machines','Cabezales de impresión térmic.etc.util.2/más dist.máqs.',10,'84','8473','847350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84735034','Cintas de caracteres p/impressão, util.2/mais dif.maqs.','Belts of characters f/print.used in 2/more dif.machines','Cintas de caracteres p/impresión, util.2/más dist.máqs.',10,'84','8473','847350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84735035','Cartuchos de tintas p/impressão, util.2/mais dif.maqs.','Cartrid.of paints f/print.used in 2/more dif.machines','Cartuchos de tintas p/impres., util.2/más dist.máqs.',11,'84','8473','847350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84735039','Outs.partes e acess.de impressão, util.2/mais dif.maqs.','Oth.parts and acces.f/print.used in 2/more dif.machines','Las dem.partes y acces.de impres., util.2/más dist.máqs.',10,'84','8473','847350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84735040','Cabeças magnéticas, util.2/mais dif.máquinas','Magnetic heads, used in 2/more dif.machines','Cabezales magnéticos, util.2/más dist.máquinas',10,'84','8473','847350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84735050','Placas de memória, superf<=50cm2, util.2/mais dif.maqs.','Plates of memory, surf<=50cm2, used 2/more dif.machines','Placas de memoria, superf<=50cm2, util.2/más dist.máqs.',11,'84','8473','847350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84735090','Outras partes e acess.util.2/mais dif.máquinas','Other parts and accessories, used in 2/more dif.machines','Las demás partes y acces.util.2/más dist.máquinas',10,'84','8473','847350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84741000','Máquinas e apars.p/selecionar, etc.subst.miner.solida','Machinery f/sorting, etc.substances solid mineral','Máquinas y apars.p/clasificar, etc.sust.miner.sólida',11,'84','8474','847410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84742010','Maqs.e apars.p/esmagar, etc.subst.miner.solida, de bolas','Machinery f/grinding, etc.subst. solid min., ball mills','Máqs.y apars.p/quebrantar, etc.sust.min.sólida, de bolas',11,'84','8474','847420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84742090','Outs.máquinas e apars.p/esmagar, etc.subst.miner.solida','Other machinery f/grinding, etc.substances solid min.','Las dem.máqs.y apars.p/quebrantar, etc.sust.miner.sólida',11,'84','8474','847420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84743100','Betoneiras e aparelhos para amassar cimento','Cement mixers and apparatus for kneading cement','Hormigoneras y aparatos de amasar mortero',11,'84','8474','847431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84743200','Máquinas para misturar matérias minerais com betume','Machines for mixing mineral substances with bitumen','Máquinas p/mezclar materia mineral c/asfalto',11,'84','8474','847432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84743900','Outs.maqs.e apars.p/misturar/amassar subst.miner.solida','Oth.machinery f/mixing/kneading subst. solid mineral','Las dem.máqs.y apars.p/mezclar/amasar sust.miner.sólida',11,'84','8474','847439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84748010','Máquinas e apars.p/fabr.de moldes de areia p/fundicao','Machinery f/production of molds of sand for foundry','Máquinas y apars.p/hacer moldes de arena p/fundición',11,'84','8474','847480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84748090','Máquinas p/aglomerar/moldar combustiv.miner.sólidos, etc','Machin.f/agglomerating/molding solid mineral fuels, etc','Máquinas p/aglomerar/moldear combust.miner.sólidos, etc',11,'84','8474','847480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84749000','Partes de maqs.e apars.p/selecionar, etc.subst.minerais','Parts of machinery f/screening, etc.mineral substances','Partes de máqs.y apars.p/clasificar, etc.sust.minerales',10,'84','8474','847490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84751000','Máquinas p/montag.de lâmpadas/tubos/válvulas, eletr.etc.','Machines f/assembling electric lamps, tubes, valves, etc.','Máquinas p/montar lámparas/tubos/válvulas, electr., etc',11,'84','8475','847510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84752100','Máquinas para fabr.de fibras ópticas e seus esboços','Machines for making optical fibres and its sketches','Máquinas p/fabr.fibras ópticas y sus esbozos',11,'84','8475','847521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84752910','Máquinas p/fabr.de recipientes de vidro, exc.ampolas','Machines for making glass containers, exc.flasks','Máquinas p/fabr.recipientes de vidrio, exc.ampollas',11,'84','8475','847529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84752990','Outs.máquinas p/fabr/trab.a quente, de vidro/suas obras','Ot.machines f/manufac./hot working, of glass/its articl.','Las dem.máqs.p/fabr/trab.en calient.el vidrio/sus manuf',11,'84','8475','847529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84759000','Partes de maqs.p/fabr/trab.a quente, de vidro/suas obras','Parts of mach.f/manuf./hot working, of glass/its artic.','Partes máqs.p/fabr/trab.en calient.el vidrio/sus manuf',10,'84','8475','847590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84762100','Maqs.automat.de venda de bebidas, c/disp.aquec/refrig.','Autom.machin.of sale of drinks, with disp.heating/refrig','Máqs.automát.p/venta de bebidas, c/disp.calent/refrig.',11,'84','8476','847621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84762900','Outras máquinas automáticas de venda de bebidas','Other automatic machines of sale of drinks','Las demás máquinas automáticas p/la venta de bebidas',11,'84','8476','847629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84768100','Maqs.automat.de venda de alimentos, c/disp.aquec/refrig.','Autom.machin.of sale of food, with disp.heating/refrig.','Máqs.automát.p/venta de alimentos, c/disp.calen/refrig.',11,'84','8476','847681');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84768910','Máquinas automátiacs de venda de selos postais','Other automatic machines of sale of postal stamps','Máquinas automát.p/la venta de sellos postales',11,'84','8476','847689');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84768990','Máquinas automáticas de venda de outros produtos','Other automatic machines of sale of other products','Máquinas automát.p/la venta de demás productos',11,'84','8476','847689');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84769000','Partes de máquinas automáticas de venda de produtos','Parts of automatic machines of sale of products','Partes de máquinas automát.p/la venta de productos',10,'84','8476','847690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84771011','Maqs.de moldar termopl.p/inj<=5kg, horiz.cmd.num.monocol','Moulding mach.f/inj<=5kg, numer.control.mono-color','Máqs.de moldear termopl.p/iny<=5kg, horiz.cont.num.monoc',11,'84','8477','847710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84771019','Outs.maqs.de moldar borracha/plast.p/inj.horiz.cmd.num.','Ot.moulding mach.f/rubber/plastic f/hor.inj.num.contr.','Las dem.máqs.p/moldear cauch/plást.p/iny.horiz.cont.num',11,'84','8477','847710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84771021','Outs.maqs.de moldar termopl.p/inj<=5kg, horiz.monocol.','Oth.moulding mach.f/inj<=5kg, horizontal, mono-color','Las dem.máqs.p/moldear termopl.p/iny<=5kg, horiz.monoc.',11,'84','8477','847710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84771029','Outras máquinas de moldar borracha/plast.p/inj.horiz.','Oth.moulding machines f/rubber/plastic f/horiz.inject.','Las dem.máquinas p/moldear caucho/plást.p/iny.horiz.',11,'84','8477','847710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84771091','Outras máquinas de moldar borracha/plast.p/inj.cmd.num.','Oth.moulding machines f/rubber/plastic f/inj.num.cont.','Las dem.máquinas p/moldear caucho/plást.p/iny.cont.num',11,'84','8477','847710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84771099','Outras máquinas de moldar borracha/plast.p/injeção','Oth.moulding machines f/rubber/plastic f/injection','Las demás máquinas p/moldear caucho/plást.p/inyección',11,'84','8477','847710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84772010','Extrusoras p/materiais termoplásticos, diam.rosca<=300mm','Extruders f/thermoplastics materials, screw diam.<=300mm','Extrusoras p/materiales termoplásticos, diam.tor.<=300mm',11,'84','8477','847720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84772090','Outras extrusoras para borracha ou plástico','Other extruders for rubber or plastic','Las demás extrusoras para caucho o plástico',11,'84','8477','847720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84773010','Maqs.p/fabr.recip.termopl.c<=5l, prod<=1000u/h, p/insufl.','Blow-moul.mach.f/manuf.term-plastic c<=5l, prod<=1000u/h','Máqs.p/fabr.env.termopl.c<=5l, prod<=1000u/h, p/soplado',11,'84','8477','847730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84773090','Outras máquinas de moldar borracha/plast.por insuflação','Other blow-moulding machines f/rubber/plastic','Las dem.máquinas p/moldear caucho/plást.por soplado',11,'84','8477','847730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84774000','Maqs.de moldar borracha/plast.a vácuo, maqs.termoformar','Vaccum-moulding mach.f/rubber/plastic, thermoform.mach.','Máqs.p/moldear caucho/plást.en vacío, máqs.p/termoform.',11,'84','8477','847740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84774010','Maqs.de moldar a vácuo poliestireno expand/polipropilen','Vaccum-moulding mach.expansible polystyrene/polypropyl.','Máqs.p/moldear en vacío poliestireno expand/polipropil.',11,'84','8477','847740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84774090','Outras máquinas de moldar a vácuo ou de termoformar','Oth.vacuum-moulding machines or thermoforming machines','Las dem.máquinas p/moldear en vacío o p/termoformado',11,'84','8477','847740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84775100','Máquinas p/moldar/recauchutar pneus, moldar câmara-de-ar','Mach.f/moulding/retreading pneum.tyres, mould.inner tube','Máquinas p/moldear/recauchutar neum., moldear cámaras',11,'84','8477','847751');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84775911','Prensas para moldar borracha/plast.cap<=30000kn','Presses for moulding rubber/plastic cap<=30000kn','Prensas p/moldear caucho/plást.cap<=30000kn',11,'84','8477','847759');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84775919','Outras prensas para moldar borracha/plast.','Other presses for moulding rubber/plastic','Las demás prensas p/moldear caucho/plást.',11,'84','8477','847759');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84775990','Outras máquinas e aparelhos p/moldar borracha/plast.','Other machinery f/moulding rubber/plastic','Las demás máquinas y aparatos p/moldear caucho/plást.',11,'84','8477','847759');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84778000','Outs.maqs.e apars.p/trab.borracha/plast.fabr.seus prods','Oth.machinery f/working rubber/plastic f/manuf.its prod','Las dem.máqs.y apars.p/trab.caucho/plást.fabr.sus prods',11,'84','8477','847780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84778010','Maqs.unir lamina de borracha c/tecido, p/fabr.pneumáticos','Mach.join rubber sheets with fabric, f/manuf.pneum.tyre','Máqs.unir lamina de caucho c/tejido, p/fabr.neumático',11,'84','8477','847780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84778090','Outs.maqs.e apars.p/trab.borracha/plast.fabr.seus prods','Oth.machinery f/working rubber/plastic f/manuf.its prod','Las dem.máqs.y apars.p/trab.caucho/plást.fabr.sus prods',11,'84','8477','847780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84779000','Partes de maqs.e apars.p/trab.borracha/plast.fabr.prods','Parts of mach.f/working rubber/plastic f/manuf.its prod','Partes máqs.y apars.p/trab.caucho/plást.fabr.sus prods',10,'84','8477','847790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84781010','Batedoras-separadoras automat.de talos/folhas de fumo','Autom.machin.f/separating stems from leaves of tabacco','Batidoras-separadoras automát.de tallos/hojas de tabaco',11,'84','8478','847810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84781090','Outras máquinas e aparelhos p/preparar/transformar fumo','Other machinery f/preparing/making up tabacco','Las dem.máquinas y aparatos p/preparar/elaborar tabaco',11,'84','8478','847810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84789000','Partes de máquinas e apars.p/preparar/transformar fumo','Parts of machinery f/preparing/making uptabacco','Partes de máquinas y aparats.p/preparar/elaborar tabaco',10,'84','8478','847890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84791010','Maqs.e apars.automotrizes p/espalhar, etc.pavim.betumin.','Self-propelled mach.f/laying, etc.bituminous road cover.','Máqs.y apars.autopropuls.p/esparcir, etc.pavim.bitumin.',11,'84','8479','847910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84791090','Outs.maqs.e apars.p/obras publicas, construção civil, etc','Oth.machinery f/public works, building, etc.','Las dem.máqs.y apars.p/obras públicas, constr.civil, etc',11,'84','8479','847910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84792000','Maqs.e apars.p/extração, etc.de oleo/gordura animal/veg.','Machinery f/extraction, etc.oil/fat vegetable/animal','Máqs.y apars.p/extrac., etc.de aceit./grasas animal/veg.',11,'84','8479','847920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84793000','Prensas p/fabr.painel de particulas, fibras madeira, etc.','Presses f/making panel of particles, wood fibres, etc.','Prensas p/fabr.tablero de partículas, fibras madera, etc',11,'84','8479','847930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84794000','Máquinas para fabricação de cordas/cabos','Rope or cable-making machines','Máquinas de cordelería o cablería',11,'84','8479','847940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84795000','Robôs industriais','Industrial robots','Robotes industriales',11,'84','8479','847950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84796000','Aparelhos de evaporação para arrefecimento do ar','Apparatus of evaporation for cooling of the air','Aparatos de evaporación para refrigerar el aire',11,'84','8479','847960');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84797100','Pontes de embarque para passag.,utilizado em aeroportos','Boarding bridges for passengers, airport use','Puentes de embarque para pasajeros, uso en aeropuerto',11,'84','8479','847971');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84797900','Outras pontes de embarque','Other boarding bridges','Otras puentes de embarque',11,'84','8479','847979');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84798100','Máquinas e aparelhos para tratamento de metais','Machines and apparatus for treating metal','Máquinas y aparatos para trabajar metales',11,'84','8479','847981');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84798110','Diferenciadores das tensoes p/instal.de galvanoplastia','Tension differentiators f/instal.of galvaniz.treatm.','Diferenciadores de tensiones p/instal.de galvanoplastia',11,'84','8479','847981');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84798190','Outras máquinas e aparelhos para tratamento de metais','Oth.machines and mechanical appliances f/treating metal','Las demás máquinas y aparatos para trabajar metales',11,'84','8479','847981');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84798210','Outros misturadores','Other mixers','Los demás mezcladores',11,'84','8479','847982');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84798290','Outs.maqs.e apars.p/amassar, esmagar, moer, separar, etc.','Oth.machinery f/kneading, crushing, grinding, separat.etc','Las dem.máqs.y apars.p/amasar, quebrant., trit., pulv., etc',11,'84','8479','847982');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84798911','Outras prensas','Other presses','Las demás prensas',11,'84','8479','847989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84798912','Outros distribuidores/doseadores de sólidos/líquidos','Other machines f/measuring/dispensing solids/liquids','Los demás distribuidores/dosificadores de sólidos/líq.',11,'84','8479','847989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84798921','Máquinas e aparelhos p/cestaria/espartaria','Basketware and wickerwork machinery','Máquinas y aparatos p/cestería/espartería',11,'84','8479','847989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84798922','Máquinas e aparelhos p/fabr.de pincéis/broxas/escovas','Brush-making machinery','Máquinas y aparatos p/fabr.de pinceles/brochas/cepillos',11,'84','8479','847989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84798931','Limpadores de para-brisas elétricos, p/aeronaves','Electric windshield wipers, for aircrafts','Limpiaparabrisas eléctricos, p/aeronaves',11,'84','8479','847989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84798932','Acumuladores hidráulicos p/aeronaves','Hydraulic accumulators for aircrafts','Acumuladores hidráulicos p/aeronaves',11,'84','8479','847989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84798940','Silos metálicos p/cereais, fixos, incl.as baterias, etc.','Metal silos for cereals, fixed, including batteries, etc','Silos metálicos p/cereales, fijos, incl.las baterias, etc',11,'84','8479','847989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84798991','Aparelhos para limpar peças por ultra-som','Ultrasonic cleaning equipment','Aparatos para limpiar piezas por ultrasonido',11,'84','8479','847989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84798992','Máquinas de leme para embarcações','Machines of rudder for embarkations','Máquinas para timonear',11,'84','8479','847989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84798999','Outras máquinas e aparelhos mecânicos c/função propria','Other machines and mechan.appl.with own foundry','Las dem.máquinas y aparatos mecánicos c/función propia',11,'84','8479','847989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84799010','Partes de limpadores de para-brisas, etc.p/aeronaves','Parts of windshield wipers, etc.for aircrafts','Partes de limpiaparabrisas, etc.p/aeronaves',10,'84','8479','847990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84799090','Outs.partes de máquinas e apars.mecan.c/função propria','Oth.parts of machines and mechan.appl.with own foundry','Las dem.partes de máquinas y apars.mecán.c/func.propia',10,'84','8479','847990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84801000','Caixas de fundição','Moulding boxes for metal foundry','Cajas de fundición',11,'84','8480','848010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84802000','Placas de fundo para moldes','Mould bases','Placas de fondo para moldes',11,'84','8480','848020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84803000','Modelos para moldes','Moulding patterns','Modelos para moldes',11,'84','8480','848030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84804100','Moldes p/moldagem de metais, etc.por injecao/compressão','Molds f/ molding of metals, etc.by injection/compression','Moldes p/moldeo de metales, etc.por inyección/compresión',11,'84','8480','848041');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84804910','Coquilhas para metais/carbonetos metálicos','Moulds for metal/metal carbides','Coquillas para metales/carburos metálicos',11,'84','8480','848049');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84804990','Outros moldes para metais/carbonetos metálicos','Other moulds for metal/metal carbides','Los demás moldes p/metales/carburos metálicos',11,'84','8480','848049');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84805000','Moldes para vidros','Moulds for glass','Moldes para vidrios',11,'84','8480','848050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84806000','Moldes para matérias minerais','Moulds for mineral materials','Moldes para materia mineral',11,'84','8480','848060');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84807100','Moldes p/moldagem de borrracha/plástico, por injecao, etc','Molds for molding rubber/plastic, by injection, etc','Moldes p/moldeo p/caucho/plástico, por inyección, etc',11,'84','8480','848071');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84807900','Outros moldes para borracha/plástico','Other molds for rubber/plastic','Los demás moldes p/caucho/plástico',11,'84','8480','848079');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84811000','Válvulas redutoras de pressão','Pressure-reducing valves','Válvulas reductoras de presión',11,'84','8481','848110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84812010','Válvulas rotativas, de caixas de direção hidráulica','Rotative valves, of boxes of hydraulic direction','Válvulas rotativas, de cajas de dirección hidráulica',11,'84','8481','848120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84812011','Rotativas, de caixas de direção hidráulica, com pinhão','Rotative valves, of boxes of hydraulic direction, with pinion','Válvulas rotativas, de cajas de dirección hidráulica, con piñones',11,'84','8481','848120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84812019','Rotativas, de caixas de direção hidráulica - outras','Rotative valves, of boxes of hydraulic direction - other','Válvulas rotativas, de cajas de dirección hidráulica - otras',11,'84','8481','848120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84812090','Outs.válvulas p/transmissoes oleo-hidráulicas/pneumat.','Other valves f/oleohydraulic or pneumatic transmissions','Las dem.válvulas p/transmisiones oleohidráulicas/neumát',11,'84','8481','848120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84813000','Válvulas de retenção','Check (non-return) valves','Válvulas de retención',11,'84','8481','848130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84814000','Válvulas de segurança ou de alívio','Safety or relief valves','Válvulas de seguridad o de alivio',11,'84','8481','848140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84818011','Válvulas para escoamento, util.em banheiros/cozinhas','Evacuation valves, used in bathroom and kitchen','Válvulas p/evacuación, util.en cuartos de baño/cocinas',11,'84','8481','848180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84818019','Outros dispositivos util.em banheiros/cozinhas','Other appliances, used in bathroom and kitchen','Los demás dispositivos util.en cuartos de baño/cocinas',11,'84','8481','848180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84818021','Válvulas de expansão termostáticas/pressostáticas','Thermostatic or pressure sensitive expansion valves','Válvulas de expansión termostáticas/presostáticas',11,'84','8481','848180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84818029','Outros dispositivos utilizados em refrigeração','Other dispositives used in cooling','Los demás dispositivos utilizados en refrigeración',11,'84','8481','848180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84818031','Outs.válvulas, p/eq.gas, p<=50mbar, c/disp.segur.termoelet','Oth.valves, f/eq.gas, w<=50mbar, with thermoelet.safety','Las dem.válvulas, p/eq.gas, p<=50mbar, c/disp.seg.termoel.',11,'84','8481','848180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84818039','Outras válvulas para utilização em equipamentos a gás','Other valves used in equipment by gas','Las dem.válvulas p/utilización en equip.a gas',11,'84','8481','848180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84818091','Válvulas tipo aerosol','Aerosol valves','Válvulas tipo aerosol',11,'84','8481','848180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84818092','Válvulas solenoides','Solenoid valves','Válvulas solenoides',11,'84','8481','848180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84818093','Válvulas tipo gaveta','Sluice valves','Válvulas exclusas',11,'84','8481','848180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84818094','Válvulas tipo globo','Globe valves','Válvulas de globo',11,'84','8481','848180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84818095','Válvulas tipo esfera','Spherical valves','Válvulas esféricas',11,'84','8481','848180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84818096','Válvulas tipo macho','Male valves','Válvulas tipo macho',11,'84','8481','848180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84818097','Válvulas tipo borboleta','Butterfly valves','Válvulas tipo mariposa',11,'84','8481','848180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84818099','Torneiras e outros dispositivos para canalizações, etc.','Taps and other appliances for pipes, etc','Art.de grifería y demás órganos similares p/tubería, etc',11,'84','8481','848180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84819010','Partes de válvulas tipo aerosol/disp.util.banheiros, etc','Parts of aerosol valves, /applian.used bathrooms, etc','Partes de válvulas tipo aerosol/órg.util.baños, etc',10,'84','8481','848190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84819090','Partes de torneiras, outs.dispositiv.p/canalizações, etc.','Parts of taps, other appliances for canalizations, etc','Partes de grif.y demás órganos similares p/tubería, etc',10,'84','8481','848190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84821010','Rolamentos de esferas, de carga radial','Ball bearings, radial','Rodamientos de bolas, de carga radial',11,'84','8482','848210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84821090','Outros rolamentos de esferas','Other ball bearings','Los demás rodamientos de bolas',11,'84','8482','848210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84822010','Rolamentos de roletes conicos, de carga radial','Tapered roller bearings, radial','Rodamientos de rodillos cónicos, de carga radial',11,'84','8482','848220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84822090','Outros rolamentos de roletes conicos','Other tapered roller bearings','Los demás rodamientos de rodillos cónicos',11,'84','8482','848220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84823000','Rolamentos de roletes em forma de tonel','Spherical roller bearings','Rodamientos de rodillos en forma de tonel',11,'84','8482','848230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84824000','Rolamentos de agulhas','Needle roller bearings','Rodamientos de agujas',11,'84','8482','848240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84825010','Rolamentos de roletes cilíndricos, de carga radial','Cylindrical roller bearings, radial','Rodamientos de rodillos cilíndricos, radiales',11,'84','8482','848250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84825090','Outros rolamentos de roletes cilíndricos','Other cylindrical roller bearings','Los demás rodamientos de rodillos cilíndricos',11,'84','8482','848250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84828000','Outros rolamentos de roletes, incl.rolamentos combinados','Oth.roller bearings,  incl.combined ball/roller bearings','Los dem.rodamient.de rodillos, incl.rodamient.combinados',11,'84','8482','848280');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84829111','Esferas de aço calibradas p/carga de canetas esferograf','Balls of gaged steel for ballpoint pens','Bolas de acero calibradas p/bolígrafos',10,'84','8482','848291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84829119','Outras esferas de aço calibradas, para rolamentos','Other balls of gaged steel for rollers bearings','Las demás bolas de acero calibradas, p/rodamientos',10,'84','8482','848291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84829120','Roletes cilíndricos para rolamentos','Cylindrical rollers for rollers bearings','Rodillos cilíndricos para rodamientos',10,'84','8482','848291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84829130','Roletes conicos para rolamentos','Conical rollers for rollers bearings','Rodillos cónicos para rodamientos',10,'84','8482','848291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84829190','Outras esferas, roletes e agulhas, para rolamentos','Other balls, needles and rollers, for rollers bearings','Las demás bolas, rodillos y agujas p/rodamientos',10,'84','8482','848291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84829900','Outras partes de rolamentos','Other parts of rollers bearings','Las demás partes de rodamientos',10,'84','8482','848299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84829910','Outros selos, capas e porta-esferas de aço','Other seals, covers and holder-spheres of steel','Otros lacres, capas e apoyo de esferas de acero ',10,'84','8482','848299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84829990','Outras partes de rolamentos','Other parts of rollers bearings','Las demás partes de rodamientos',10,'84','8482','848299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84831010','Virabrequins (cambotas)','Crankshafts','Cigueñales',11,'84','8483','848310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84831011','Virabrequins forjados, de peso=>900k e comp=>2.000mm','Forged crankshafts, weight=>900 kg e lenght=>2000mm','Cigueñales forjados, peso=>900 kg e long.=>2000mm',11,'84','8483','848310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84831019','Outros virabrequins (cambotas)','Other crankshafts','Otros cigueñales',11,'84','8483','848310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84831020','Árvores de "cames" para comando de válvulas','Cam shafts for controlling valves','Árboles de levas para comando de válvulas',11,'84','8483','848310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84831030','Veios flexíveis de transmissão','Flexible shafts of transmission','Árboles flexibles de transmisión',11,'84','8483','848310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84831040','Manivelas','Cranks','Manivelas',11,'84','8483','848310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84831050','Árvores de transmissão, provido de açoplam.dentado, etc.','Transmission shafts, with of toothed couplings, etc','Árboles de transmisión, prov.de acoplamiento dentado, etc',11,'84','8483','848310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84831090','Outras árvores (veios) de transmissão','Other transmission shafts','Las demás árboles de transmisión',11,'84','8483','848310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84832000','Mancais (chumaceiras) com rolamentos incorporados','Bearing housings, incorporating ball or roller bearings','Cajas de cojinetes con rodamientos incorporados',11,'84','8483','848320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84833010','Mancais s/rolam.montados c/bronzes de metal antifricção','Bear.hous.n/rol.bear.moun.plain shaft bear.of antif.met','Cajas de cojinet./rodam.mont.c/cojin.de metal antifric.',11,'84','8483','848330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84833020','Bronzes','Plain shaft bearings','Cojinetes',11,'84','8483','848330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84833021','Bronzes com diametro interno =>200mm','Plain shaft bearings with internal diameter =>200mm','Cojinetes com diámetro interior =>200mm',11,'84','8483','848330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84833029','Outros bronzes','Other plain shaft bearings','Otros cojinetes',11,'84','8483','848330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84833090','Outros mancais sem rolamentos','Bearing housings, n/incorporat.ball or roller bearings','Las demás cajas de cojinetes sin rodamientos',11,'84','8483','848330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84834010','Caixas de transmissão, redutores, etc.de velocidade','Transmission boxes, reducers, etc.of speed','Cajas de transmisión, reductores, etc.de velocidad',11,'84','8483','848340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84834090','Engrenagens e rodas de fricção, eixos de esferas/roletes','Gears and wheels of friction, ball/roller screws','Engranajes y ruedas de fric.hus.filet.de bolas/rodillos',11,'84','8483','848340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84835010','Polias, exceto as de rolamentos reguladores de tensão','Pulleys exc.rollers bearings of tension regulators','Poleas, excepto las tensoras a rodamientos',11,'84','8483','848350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84835090','Volantes e outras polias','Flywheels and other pulleys','Volantes y las demás poleas',11,'84','8483','848350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84836011','Embreagens de fricção','Clutches of friction','Embragues de fricción',11,'84','8483','848360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84836019','Outras embreagens','Other clutches','Las demás embragues',11,'84','8483','848360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84836090','Dispositivos de acoplamento, incl.juntas de articulação','Joining dispositive, including universal joints','Dispositivos de acoplamiento, incl.juntas de articul.',11,'84','8483','848360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84839000','Partes de árvores de transmissão, manivelas, mancais, etc.','Parts of transmis.shafts, cranks, bearings housing, etc.','Partes de árboles transm, manivelas, cajas de cojinet.etc',10,'84','8483','848390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84841000','Juntas metaloplásticas','Gaskets/sim.joints of met.sheet.comb.ot.mat.layer metal','Juntas metaloplásticas',10,'84','8484','848410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84842000','Juntas de vedação, mecânicas','Mechanical seals','Juntas mecánicas de estanqueidad',10,'84','8484','848420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84849000','Jogos/sortidos de juntas, em bolsas, envelopes, etc.','Games/assortments of joints, in bags, envelopes, etc','Surtidos/empaquetadura de juntas, en bolsitas, sobres, etc',10,'84','8484','848490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84849990','NCM não existe - possivelmente ncm = 84849000','No NCM there - possibly ncm = 84849000','NCM no hay - posiblemente ncm = 84849000',10,'84','8484','848499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84851000','Hélices para embarcações e suas pás','Ships'' or boats'' propellers and blades therefor','Hélices para barcos y sus paletas',11,'84','8485','848510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84859000','Partes de outs.máquinas ou apars.sem conexões eletr.etc','Parts of other mach.n/contain.electrical connectors, etc','Partes de dem.máquinas o apars.s/conexiones eléctr.etc',10,'84','8485','848590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84861000','Máquinas e aparelhos para fabricação esferas/plaquetas','Machinery for production of spheres and plaques','Máquinas e apar. p/ fabricación d/esferas/plaquetas',11,'84','8486','848610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84862000','Máqs.apar.fabr.dispos.sem.circ.integr.eletr.','Machinery for produc. of devices without eletron. integr. circuit ','Máquinas e apar. p/ fabric. de disp. sin los circuitos integr.',11,'84','8486','848620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84863000','Máqs.apar.fabr.dispos.visualiz.de tela plana','Machinery for produc. of devices to visualization of plane screen','Máquinas e apar. p/ fabric. de disp. de visualización en pantalla plana',11,'84','8486','848630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84864000','Máqs.apar.especif.nota 9 c)presente capítulo','Machinery specif. note 9 c) present. chapter','Máqs.apar.especif.nota 9 c) este capítulo',11,'84','8486','848640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84869000','Partes acess.maqs.apar.fab.esferas/plaquetas','Parts, accessor.,machinery for prod. of spheres and plaques','Part., acces.,máq.,apar.p/ fab.esferas/plaquetas',10,'84','8486','848690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84871000','Hélices para embarcações e suas pás','Helixes for embarkations and their shovels','Hélices para buques e cuchillas',11,'84','8487','848710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('84879000','Parts.outs.máqs.apars.s/conexão elétr.etc.','Parts of others machinnery without electric connection ','Partes de otras máq., apar.sin la conexión eléctrica   ',10,'84','8487','848790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85011011','Motor eletr.de corrente contínua, pot<=37.5w, passo<=1.8g','Electr.motor of contin.current, pot<=37.5w, step<=1.8g','Motor eléctr.de corrient.continua, pot<=37.5w, paso<=1.8g',11,'85','8501','850110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85011019','Outros motores eletr.de corrente contínua, p<=37.5w','Other electric motor of continuous current, p<=37.5w','Los demás motores eléctr.de corriente continua, p<=37.5w',11,'85','8501','850110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85011021','Motor eletr.de corrente alternada, pot<=37.5w, sincrono','Electr.motor of alternating current, pot<=37.5w, synchor.','Motor eléctr.de corriente alterna, pot<=37.5w, síncrono',11,'85','8501','850110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85011029','Outros motores eletr.de corrente alternada, pot<=37.5w','Other electr.motor of alternating current, p<=37.5w','Los demás motores eléctr.de corriente alterna, p<=37.5w',11,'85','8501','850110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85011030','Motor elétrico universal, potência <= 37.5w','Universal electric motor, potency < =37.5w','Motor eléctrico universal, pot <= 37.5w',11,'85','8501','850110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85011090','Outros motores elétricos, potência <= 37.5w','Other electric motor potency <= 37.5w','Los demás motores eléctricos, pot <= 37.5w',11,'85','8501','850110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85012000','Motor elétrico universal, potência > 37.5w','Universal electric motor, potency > 37.5w','Motor eléctrico universal, potencia > 37.5w',11,'85','8501','850120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85013110','Motor elétrico de corrente contínua, 37.5w<pot<=750w','Electric motor of continuous current, 37.5w<pot<=750w','Motor eléctr.de corriente continua, 37.5w<pot<=750w',11,'85','8501','850131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85013120','Gerador elétrico de corrente contínua, pot<=750w','Electric generators of continuous current, pot<=750w','Generador eléctr.de corriente continua, pot<=750w',11,'85','8501','850131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85013210','Motor elétrico de corrente contínua, 750w<pot<=75kw','Electric motor of continuous current, 750w<pot<=75kw','Motor eléctr.de corriente continua, 750w<pot<=75kw',11,'85','8501','850132');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85013220','Gerador eletr.de corrente contínua, 750w<pot<=75kw','Electric generators of contin.current, 750w<pot<=75kw','Generador eléctr.de corriente continua, 750w<pot<=75kw',11,'85','8501','850132');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85013310','Motor elétrico de corrente contínua, 75kw<pot<=375kw','Electric motor of continuous current, 75kw<pot<=375kw','Motor eléctr.de corriente continua, 75kw<pot<=375kw',11,'85','8501','850133');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85013320','Gerador elétrico de corrente contínua, 75kw<pot<=375kw','Electric generators of contin.current, 75kw<pot<=375kw','Generador eléctr.de corriente continua, 75kw<pot<=375kw',11,'85','8501','850133');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85013411','Motor elétrico de corrente contínua, 375kw<pot<=3000kw','Electric motor of contin.current, 375kw<pot<=3000kw','Motor eléctr.de corriente continua, 375kw<pot<=3000kw',11,'85','8501','850134');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85013419','Outros motores elétricos de corrente contínua, pot>375kw','Other electric motors of continuous current, p>375kw','Los demás motores eléctr.de corriente continua, p>375kw',11,'85','8501','850134');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85013420','Geradores elétricos de corrente contínua, potência >375kw','Electric generators of continuous current, pot>375kw','Generador eléctr.de corriente continua, pot>375kw',11,'85','8501','850134');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85014011','Motor eletr.de corr.altern.monof.37.5w<p<=15kw, sincrono','Eletr.motor of altern.curr.single-ph.37.5w<p<=15kw, sync','Motor eléctr.de corr.altern.monof.37.5w<p<=15kw, síncr.',11,'85','8501','850140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85014019','Outros motores eletr.de corr.altern.monof.37.5w<p<=15kw','Ot.eletr.motor of altern.curr.single-phas.37.5w<p<=15kw','Los dem.motores eléctr.de corr.alt.monof.37.5w<p<=15kw',11,'85','8501','850140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85014021','Motor eletr.de corr.altern.monof.pot>15kw, sincrono','Eletr.motor of altern.cur.single-p.pot>15kw, synchronous','Motor eléctr.de corr.altern.monof.pot>15kw, síncrono',11,'85','8501','850140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85014029','Outros motores eletr.de corr.altern.monof.pot>15kw','Ot.eletr.motor of altern.curr.single-phase pot>15kw','Los dem.motores eléctr.de corr.altern.monof.pot>15kw',11,'85','8501','850140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85015110','Motor eletr.corr.altern.trif.37.5w<p<=750w, rotor gaiola','Elect.motor alter.cur.sin.ph.37.5<p<=750w, squirrel-cage','Motor eléct.corr.alt.trif.37.5<p<=750w, rot.tip.jaul.ard',11,'85','8501','850151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85015120','Motor eletr.corr.altern.trif.37.5w<p<=750w, rotor aneis','Elec.motor alt.cur.sing.ph.37.5w<p<=750w, slip-ring','Motor eléct.corr.altern.trif.37.5w<p<=750w, rotor bobin.',11,'85','8501','850151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85015190','Outros motores eletr.de corr.altern.polif.37.5w<p<=750w','Ot.elect.motor altern.curr.sin.phase 37.5<p<=750w','Los dem.motores eléctr.de corr.alter.polif.37.5<p<=750w',11,'85','8501','850151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85015210','Motor eletr.corr.altern.trif.750w<p<=75kw, rotor gaiola','Elec.motor alter.cur.mult.ph.750w<p<=75kw, squirrel-cage','Motor eléct.cor.alt.trif.750w<p<=75kw, rot.tip.jaula ard',11,'85','8501','850152');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85015220','Motor eletr.corr.altern.trif.750w<p<=75kw, rotor aneis','Elec.motor alter.cur.multi-phas.750w<p<=75kw, slip-ring','Motor eléctr.corr.alter.trif.750w<p<=75kw, rotor bobin.',11,'85','8501','850152');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85015290','Outs.motores eletr.de corr.altern.polif.750w<pot<=75kw','Ot.elect.motor altern.cur.poli-phase750w<p<=75kw','Los dem.motores eléctr.de corr.alter.polif.750w<p<=75kw',11,'85','8501','850152');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85015310','Motor eletr.corr.altern.trif.75kw<pot<=7500kw','Elect.motor altern.cur.multi-phase 75kw<pot<=7500kw','Motor eléctr.corr.altern.trif.75kw<pot<=7500kw',11,'85','8501','850153');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85015320','Motor eletr.corr.altern.trif.7.500kw<pot<=30.000kw','Elec.motor alter.cur.multi-phase 7.500kw<pot<=30.000kw','Motor eléctr.corr.altern.trif.7.500kw<pot<=30.000kw',11,'85','8501','850153');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85015390','Outs.motores eletr.corr.altern.polifasicos, pot>30.000kw','Ot.elect.motor alternative current poli-ph.pot>30.000kw','Los dem.motores eléctr.corr.alter.polifás., pot>30.000kw',11,'85','8501','850153');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85016100','Geradores de corrente alternada, pot<=75kva','Generators of alternative current, pot<=75kva','Generadores de corriente alterna, pot<=75kva',11,'85','8501','850161');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85016200','Geradores de corrente alternada, 75kva<pot<=375kva','Generators of alternative current, 75kva<pot<=375kva','Generadores de corriente alterna, 75kva<pot<=375kva',11,'85','8501','850162');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85016300','Geradores de corrente alternada, 375kva<pot<=750kva','Generators of alternative current, 375kva<pot<=750kva','Generadores de corriente alterna, 375kva<pot<=750kva',11,'85','8501','850163');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85016400','Geradores de corrente alternada, pot>750kva','Generators of alternative current, pot>750kva','Generadores de corriente alterna, pot>750kva',11,'85','8501','850164');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85021110','Grupo eletrog.p/motor diesel, p<=75kva, corr.altern.','Electric gener.sets f/diesel engine, p<=75kva, alt.curr.','Grupo electróg.c/motor diesel, p<=75kva, corr.alter.',11,'85','8502','850211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85021190','Outros grupos eletrog.p/motor diesel, pot<=75kva','Oth.electric generat.sets f/diesel engine, pot<=75kva','Los demás grupos electróg.p/motor diesel, pot<=75kva',11,'85','8502','850211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85021210','Grupo eletrog.p/motor diesel, 75<p<=375kva, corr.altern.','Electric gener.sets f/diesel eng.75<p<=375kva, alt.curr.','Grupos electróg.p/motor diesel, 75<p<=375kva, corr.alter.',11,'85','8502','850212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85021290','Outros grupos eletrog.p/motor diesel, 75kva<p<375kva','Ot.electric generat.sets f/diesel engine, 75kva<p<375kva','Los demás grupos electróg.p/motor diesel, 75kva<p<375kva',11,'85','8502','850212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85021311','Grupo eletrog.p/motor diesel, 375<p<=430kva, corr.altern.','Elect.gener.sets f/diesel eng., 375<p<=430kva, alt.curr.','Grupos electróg.p/motor diesel, 375<p<=430kva, cor.alter.',11,'85','8502','850213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85021319','Outs.grupos eletrog.p/motor diesel, p>375kva, corr.altern','Oth.elect.gener.sets f/diesel engine, p>375kva, alt.curr.','Los dem.grupos electr.p/mot.diesel, p>375kva, cor.alter.',11,'85','8502','850213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85021390','Outros grupos eletrogeradores p/motor diesel, p>375kva','Oth.electric generating sets f/diesel engine, p>375kva','Los demás grupos electróg.p/motor diesel, p>375kva',11,'85','8502','850213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85022011','Grupo eletrog.p/motor explosão, corr.altern.p<=210kva','Elect.gener.sets f/diesel engine, alt.current p<=210kva','Grupo electróg.p/motor explosión, corr.altern.p<=210kva',11,'85','8502','850220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85022019','Outros grupos eletrog.p/motor explosão, corr.altern.','Other electric generat.sets f/diesel engine, alt.current','Los demás grupos electr.p/motor explosión, corr.altern.',11,'85','8502','850220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85022090','Outros grupos eletrogeradores para motor explosão','Other electric generating sets for diesel engine','Los demás grupos electróg.p/motor explosión',11,'85','8502','850220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85023100','Outros grupos eletrogeradores de energia eólica','Other electric generating sets of wind-powered','Los demás grupos electróg.de energía eólica',11,'85','8502','850231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85023900','Outros grupos eletrogeradores','Other electric generating sets','Los demás grupos electrógenos',11,'85','8502','850239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85024010','Conversores rotativos elétricos, de frequência','Electric rotary converters, of frequency','Convertidores rotativos eléctricos, de frecuencia',11,'85','8502','850240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85024090','Outros conversores rotativos elétricos','Other electric rotary converters','Los demás convertidores rotativos eléctricos',11,'85','8502','850240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85030010','Partes de motores/geradores de potência <=75kva','Parts of motors/generators of potency<=75kva','Partes de motores/generadores de pot<=75kva',10,'85','8503','850300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85030090','Partes de outros motores/geradores/grupos eletrog.etc.','Parts of oth.motors/generators/electric gener.sets, etc.','Partes de demás motores/generadores/grupos electróg.etc',10,'85','8503','850300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85041000','Reatores para lâmpadas/tubos de descargas','Reactors for lamps/tubes of discharges','Balastos para lámparas/tubos de descargas',11,'85','8504','850410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85042100','Transformador de dielétrico líquido, pot<=650kva','Transformers of liquid dielectric, pot<=650kva','Transformador de dieléctrico líquido, pot<=650kva',11,'85','8504','850421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85042200','Transformador de dielétrico líquido, 650<pot<=10000kva','Transformers of liquid dielectric, 650<pot<=10000kva','Transformador de dieléctrico líquido, 650<pot<=10000kva',11,'85','8504','850422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85042300','Transformador de dielétrico líquido, pot>10000kva','Transformers of liquid dielectric, pot>10000kva','Transformador de dieléctrico líquido, pot>10000kva',11,'85','8504','850423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85043111','Transformador eletr.pot<=1kva, p/freq<=60hz, de corrente','Electrical transform.pot<=1kva, f/freq<=60hz, of current','Transformador eléct.pot<=1kva, p/frec<=60hz, de corriente',11,'85','8504','850431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85043119','Outros transformadores eletr.pot<=1kva, p/freq<=60hz','Other electrical transformers pot<=1kva, f/freq<=60hz','Los demás transformadores eléctr.pot<=1kva, p/frec<=60hz',11,'85','8504','850431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85043191','Transformador eletr.pot<=1kva, saida horiz.t>18kv, etc.','Electrical transform.pot<=1kva, horiz.sweept >18kv, etc','Transformador eléctr.pot<=1kva, salida horiz.t>18kv, etc',11,'85','8504','850431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85043192','Transformador eletr.pot<=1kva, de fi, deteccao, foco, etc.','Fi electrical transform.pot<=1kva, detect.focusing, etc','Transformador eléctr.pot<=1kva, de fi, detección, rel., etc',11,'85','8504','850431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85043199','Outros transformadores elétricos potência <= 1 KVA','Other electrical transformers potency <= 1 KVA','Los demás transformadores eléctr.pot<=1kva',11,'85','8504','850431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85043211','Transformador eletr.1kva<pot<=3kva, p/freq<=60hz','Electrical transform.1kva<pot<=3kva, f/freq<=60hz','Transformador eléctr.1kva<pot<=3kva, p/frec<=60hz',11,'85','8504','850432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85043219','Outros transformadores eletr.1kva<pot<=3kva','Other electrical transformers 1kva<pot<=3kva','Los demás transformadores eléctr.1kva<pot<=3kva',11,'85','8504','850432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85043221','Transformador eletr.3kva<pot<=16kva, p/freq<=60hz','Electrical transformers 3kva<pot<=16kva, f/freq<=60hz','Transformador eléctr.3kva<pot<=16kva, p/frec<=60hz',11,'85','8504','850432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85043229','Outros transformadores eletr.3kva<pot<=16kva','Other electrical transformers 3kva<pot<=16kva','Los demás transformadores eléctr.3kva<pot<=16kva',11,'85','8504','850432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85043300','Transformador elétrico 16kva<pot<=500kva','Electrical transformers 16kva<pot<=500kva','Transformador eléctr.16kva<pot<=500kva',11,'85','8504','850433');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85043400','Transformador elétrico potência > 500 KVA','Electrical transformers potency > 500 KVA','Transformador eléctricos potencia > 500 KVA',11,'85','8504','850434');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85044010','Carregadores de acumuladores (conv.eletr.)','Accumulator chargers (electric converters)','Cargadores de acumuladores (conv.eléctr.)',11,'85','8504','850440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85044021','Retificadores de cristal (semicondutores) (conv.eletr.)','Crystal rectifiers(semiconductor)(electric converters)','Rectificadores de cristal(semiconductores)(conv.eléct.)',11,'85','8504','850440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85044022','Retificador eletrolítico (conversor eletr.)','Electrolytic rectifiers(electric converters)','Rectificador eletrolítico (conversor eléctr.)',11,'85','8504','850440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85044029','Outros retificadores (conv.eletr.)','Other rectifiers(electric converters)','Los demás rectificadores (conv.eléctr.)',11,'85','8504','850440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85044030','Conversores elétricos de corrente contínua','Electric converters of continuous current','Convertidores eléctricos de corriente continua',11,'85','8504','850440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85044040','Equipamento de aliment.ininterrupta de energia eletr.','Ups (uninterrupted power supplies) equipment','Equipo de aliment.ininterrumpida de energía eléctr.',11,'85','8504','850440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85044050','Conversores eletrônicos de freq.p/var.vel.motor eletr.','Elect.freq.converters f/varying speed of electr.motors','Convertidores electrón., de frec.p/var.vel.motor eléctr.',11,'85','8504','850440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85044060','Aparelhos eletron.de aliment.de energia p/ilumin.emerg.','Electronic power supplies apparatus f/emerg.lighting','Aparatos electrón.de aliment.de energía p/ilumin.emerg.',11,'85','8504','850440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85044090','Outros conversores elétricos estáticos','Other static converters electric','Los demás convertidores eléctricos estáticos',11,'85','8504','850440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85045000','Outras bobinas de reatância e de auto-indução','Other inductors','Las demás bobinas de reactancia (autoinducción)',11,'85','8504','850450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85049010','Núcleos de pó ferromagnético','Ferromagnetic powder cores','Núcleos de polvo ferromagnético',10,'85','8504','850490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85049020','Partes de reatores para lâmpadas/tubos de descarga','Parts of reactors for lamps/tubes of discharges','Partes de balastos p/lámparas/tubos de descarga',10,'85','8504','850490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85049030','Partes de transformadores de dieletr.liq.ou pot>16kva','Parts of transformers of liquid dielectric or pot>16kva','Partes de transformadores de dieléctr.liq.o pot>16kva',10,'85','8504','850490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85049040','Partes de conversores elétricos estáticos','Parts of static converters electric','Partes de convertidores eléctricos estáticos',10,'85','8504','850490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85049090','Outras partes de outras transformadores, conversores, etc','Other parts of oth.transformers, converters, etc.','Las dem.partes de dem.transformadores, convertidores, etc',10,'85','8504','850490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85051100','Imas permanentes de metal, e artefs.magnetizav.p/imas','Perman.magnets of metal, artic.magnetis.for magnets','Imanes permanentes de metal, y artícs.dest.imant.p/iman.',10,'85','8505','850511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85051910','Imas permanentes de ferrita, e artefs.magnetizav.p/imas','Perman.magnets of ferrite, artic.magnetis.for magnets','Imanes permanentes de ferrita, y arts.dest.imant.p/iman.',10,'85','8505','850519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85051990','Outros imas permanentes e artefs.magnetizav.p/imas','Oth.perman.magnets and artic.magnetis.for magnets','Los dem.imanes permanentes, y artícs.dest.imant.p/iman.',10,'85','8505','850519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85052010','Freios eletromagnet.por corr.foucaut, p/veic.automóveis','Elec.magnetic brakes, foucault current, f/vehicl.automob.','Frenos electromagnét.por corr.foucault, p/vehíc.automóv.',11,'85','8505','850520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85052090','Acoplamentos, embreagens, etc.eletromagnéticos','Electro-magnetic couplings, clutches, etc.','Acoplamientos, embragues, etc.electromagnéticos',10,'85','8505','850520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85053000','Cabeças de elevação eletromagnéticas','Electro-magnetic lifting heads','Cabezas elevadoras electromagnéticas',11,'85','8505','850530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85059010','Eletroímãs','Electro-magnets','Electroimanes',11,'85','8505','850590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85059080','Placas, mandris e dispositivos magnéticos, etc.de fixação','Plates, broach, dispositive magnetic, etc.of fixation','Platos, mandriles y disposits.magnéticos, etc.de sujeción',10,'85','8505','850590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85059090','Partes de aclopamentos, embreagens, etc.eletromagnéticos','Parts of electro-magnetic couplings, clutches, etc.','Partes de aclopamientos, embragues, etc.eletromagnéticos',10,'85','8505','850590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85061010','Pilhas elétricas, de bióxido de manganês, alcalinas','Electric piles, of manganese dioxide, alkaline','Pilas eltricas, de dióxido de manganeso, alcalinas',11,'85','8506','850610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85061020','Outras pilhas elétricas, de bióxido de manganês','Other electric piles, of manganese dioxide','Las demás pilas eléctricas, de dióxido de manganeso',11,'85','8506','850610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85061030','Baterias de pilhas, elétricas, de bióxido de manganês','Other electric piles, of manganese dioxide','Baterías de pilas, eléctricas, de dióxido de manganeso',11,'85','8506','850610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85063010','Pilhas/baterias eletr.de óxido de mercúrio, vol<=300cm3','Piles/electric batteries of mercuric oxide, vol<=300cm3','Pilas/baterías eléctr.de óxido de mercurio, vol<=300cm3',11,'85','8506','850630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85063090','Outras pilhas/baterias eletr.de óxido de mercúrio','Other piles/electric batteries of mercuric oxide','Las demás pilas/baterías eléctr.de óxido de mercurio',11,'85','8506','850630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85064010','Pilhas/baterias eletr.de óxido de prata, vol<=300cm3','Piles/electric batteries of silver oxide, vol<=300cm3','Pilas/baterías eléctr.de óxido de plata, vol<=300cm3',11,'85','8506','850640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85064090','Outras pilhas/baterias elétricas, de óxido de prata','Other piles/electric batteries, of silver oxide','Las demás pilas/baterías eléctricas, de óxido de plata',11,'85','8506','850640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85065010','Pilhas/baterias eletr.de litio, vol<=300cm3','Piles/electric batteries of lithium, vol<=300cm3','Pilas/baterías eléctr.de litio, vol<=300cm3',11,'85','8506','850650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85065090','Outras pilhas/baterias eletr.de lítio','Other piles/electric batteries of lithium','Las demás pilas/baterías eléctr.de litio',11,'85','8506','850650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85066010','Pilhas/baterias eletr.de ar-zinco, vol<=300cm3','Piles/electric batteries air-zinc, vol<=300cm3','Pilas/baterías eléctr.de aire-cinc, vol<=300cm3',11,'85','8506','850660');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85066090','Outras pilhas/baterias eletr.de ar-zinco','Other piles/electric batteries air-zinc','Las demás pilas/baterías eléctr.de aire-cinc',11,'85','8506','850660');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85068010','Outras pilhas/baterias eletr.vol<=300cm3','Other piles/electric batteries vol<=300cm3','Las demás pilas/baterías eléctr.vol<=300cm3',11,'85','8506','850680');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85068090','Outras pilhas/baterias elétricas','Other piles/electric batteries','Las demás pilas/baterías eléctr.',11,'85','8506','850680');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85069000','Partes de pilhas/baterias de pilhas, elétricas','Parts of piles/batteries of piles, electric','Partes de pilas/baterías de pilas, eléctricas',10,'85','8506','850690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85071000','Acumuladores eletr.de chumbo, p/arranque de motor pistão','Elect.accumulators of lead, for starting piston engines','Acumuladores eléctr.de plomo, p/arranque de motor émbolo',11,'85','8507','850710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85071010','Acumuladores elet de chumbo,capac <= 20ah e t<= 12v','Electric accumulators of lead, capacity <= 20Ah and t <= 12v','Acumuladores eléctricos de plomo, capacidad <= 20Ah y t <= 12v',11,'85','8507','850710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85071090','Outros acumuladores elétricos de chumbo','Other electric accumulators, of lead','Otros acumuladores eléctricos, de plomo',11,'85','8507','850710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85072010','Outros acumuladores elétricos, de chumbo, peso<=1000kg','Other elect.accumulators, of lead, weig<=1000kg','Los dem.acumuladores eléctricos, de plomo, peso<=1000kg',11,'85','8507','850720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85072090','Outros acumuladores elétricos, de chumbo','Other electric accumulators, of lead','Los demás acumuladores eléctricos, de plomo',11,'85','8507','850720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85073011','Acumuladores eletr.de níquel-cádmio, p<=2500kg, cap<=15ah','Electric accumul.of nickel-cadmium, w<=2500kg, c<=15ah','Acumuladores eléctr.de níquel-cadmio, p<=2500kg, c<=15ah',11,'85','8507','850730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85073019','Outs.acumuladores elétricos, de níquel-cádmio, p<=2500kg','Other elect.accumulators, of nickel-cadmium, w<=2500kg','Los dem.acumuladores eléctr., de níquel-cadmio, p<=2500kg',11,'85','8507','850730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85073090','Outros acumuladores elétricos, de níquel-cádmio','Other elect.accumulators, of nickel-cadmium','Los demás acumuladores eléctricos, de níquel-cadmio',11,'85','8507','850730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85074000','Acumuladores eletrétricos de níquel-ferro','Elect.accumulators of nickel-iron','Acumuladores eléctr.de níquel-hierro',11,'85','8507','850740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85075000','Acumuladores eletricos de niquel-hidreto metalico','Electric accumulator nickel-hydride metallic','Acumuladores eléctricos de níquel-hidruro metálico',11,'85','8507','850750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85076000','Acumuladores eletricos de ion de litio','Electric storage batteries lithium ion','Acumuladores eléctricos de ion de litio',11,'85','8507','850760');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85078000','Outros acumuladores elétricos','Other electric accumulators','Los demás acumuladores eléctricos',11,'85','8507','850780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85079010','Separadores para acumuladores elétricos','Separators for electric accumulators','Separadores para acumuladores eléctricos',11,'85','8507','850790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85079020','Recipientes para acumuladores elétricos de plástico, tampas, etc','Containers f/electric accumul.of plastic, covers, etc','Recipientes p/acumuladores eléctr.de plástico, tapas, etc',10,'85','8507','850790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85079090','Outras partes para acumuladores elétricos','Other parts of electric accumulators','Las demás partes p/acumuladores eléctr.',10,'85','8507','850790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85081000','Perfuradoras com motor eletr.incorporado, de uso manual','Perforators with incorp.electric motor, of manual use','Perforadoras con motor eléctr.incorporado, de uso manual',11,'85','8508','850810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85081100','Aspiradores de pó eletromecânicos - uso doméstico','Electromechanical vacuum cleaners, household use','Aspiradoras electromecánicas, uso de la casa',11,'85','8508','850811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85081900','Outros aspiradores >1.500w vol.reserv.>200l','Other vacuum cleaners >1500w , vol. of the reservoir >200l','Otras aspiradoras > 1500w vol.del depos. >200l',11,'85','8508','850819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85082000','Serras com motor eletr.incorporado, de uso manual','Saws with incorp.electric motor, for manual use','Sierras con motor eléctr.incorporado, de uso manual',11,'85','8508','850820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85086000','Outs.aspirads.eletr.c/motor elétr.uso domést.','Other electric vacuum cleaners with electric. motor, household use','Otras aspiradoras eléctr. c/ motor eléctr., uso de la casa',11,'85','8508','850860');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85087000','Partes/aps.eletrom.c/motor elétr.uso doms.','Parts of appl.electrom. with elect. motor, household use','Partes de apar. electrom.c/motor eléctr., uso de la casa',10,'85','8508','850870');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85088010','Tesouras com motor eletr.incorporado, de uso manual','Scissors with incorp.electric motor, of manual use','Tijeras con motor eléctr.incorporado, de uso manual',11,'85','8508','850880');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85088091','Cortadoras de tecidos, com motor elétr.de uso manual','Fabric cutters with incorp.electric motor, of manual use','Cortadoras de tejidos c/motor eléc.incorp.de uso manual',11,'85','8508','850880');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85088092','Parafusadeiras/rosqueadeiras, c/motor eletr.uso manual','Screwdrivers/thread.mach.with elec.motor, f/manual use','Destornilladores/roscadoras, c/motor eléctr.uso manual',11,'85','8508','850880');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85088093','Martelos com motor elétrico incorporado, de uso manual','Hammers with incorp.electric motor, f/manual use','Martillos con motor eléctrico incorporado, de uso manual',11,'85','8508','850880');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85088099','Outras ferramentas eletromecan.c/motor eletr.uso manual','Ot.eletro-mechan.tools with electric motor, manual use','Las dem.herramientas electrom.c/motor eléctr.uso manual',11,'85','8508','850880');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85089000','Partes de ferramentas eletromecan.c/motor eletr.manual','Parts of electromech.tools with electric motor, manual','Partes de herramientas electromec.c/motor eléct.manual',10,'85','8508','850890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85091000','Aspiradores de pó, com motor elétrico, de uso doméstico','Vacuum cleaners, with electric motor, domestic use','Aspiradoras de polvo, c/motor eléctrico, de uso doméstico',11,'85','8509','850910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85092000','Enceradeiras de piso, com motor elétrico, uso doméstico','Floor polishers, with electric motor, domestic use','Enceradoras de piso, c/motor eléctr.uso doméstico',11,'85','8509','850920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85093000','Triturador de restos de cozinha, c/motor eletr.doméstico','Kitchen waste disposers, with electric motor, domestic','Triturador de desper.de cocina, c/motor eléctr.doméstico',11,'85','8509','850930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85094010','Liquidificador de alimentos, c/motor eletr.uso doméstico','Blender of foods, with electric motor, domestic','Licuador de alimentos, c/motor eléctr.uso doméstico',11,'85','8509','850940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85094020','Batedeiras de alimentos, c/motor eletr.uso doméstico','Mixers of foods, with electric motor, domestic','Batidoras de alimentos, c/motor eléctr.uso doméstico',11,'85','8509','850940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85094030','Moedores de carne, c/motor eletr.uso doméstico','Mincers, with electric motor, domestic use','Picadoras de carne, c/motor eléctr.uso doméstico',11,'85','8509','850940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85094040','Extrator centrífugo de sucos, c/motor eletr.doméstico','Extractor centrif.of juices, with elect.motor, domest.','Extractora centrífuga de jugos, c/motor eléctr.doméstico',11,'85','8509','850940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85094050','Apars.de funcoes múltiplas, p/process.alim.c/motor eletr','Multiple funct.appl., f/proces.food with electric motor','Apars.de func.múltiples, p/proces.alim.c/motor eléctr',11,'85','8509','850940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85094090','Outros trituradores, etc.p/alim.c/motor eletr.doméstico','Other mixers, etc.f/food with electric motor, domestic','Las dem.trituradoras, etc.p/alim.c/motor eléct.doméstico',11,'85','8509','850940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85098000','Outs.aparelhos eletromecan.c/motor eletr.uso doméstico','Oth.electromech.appl.with electric motor, domestic','Los dem.apar..electromecán.c/motor eléctr.uso doméstico',11,'85','8509','850980');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85098010','Enceradeiras de piso eletromecânicas - uso doméstico','Floor polishers, with electromec. motor, domestic use','Enceradoras de piso, c/motor eléctromec.uso doméstico',11,'85','8509','850980');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85098090','Outs.apars.eletrom.c/mot.elétr., doméstico','Other electrom.appl.with eléctr. motor, household use','Otros apar.electrom.c/motor elétr., uso doméstico',11,'85','8509','850980');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85099000','Partes de apars.eletromecan.c/motor eletr.uso doméstico','Parts of electromech.appar.with electric motor, domestic','Partes de apars.electromec.c/motor eléctr.uso doméstico',10,'85','8509','850990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85101000','Aparelhos ou máquinas de barbear, com motor elétrico','Shavers, with electric motor','Afeitadoras, con motor eléctrico',11,'85','8510','851010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85102000','Máquinas de cortar o cabelo/tosquiar, com motor elétrico','Hair clippers, with electric motor','Máquinas de cortar el pelo/esquilar, c/motor eléctr.',11,'85','8510','851020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85103000','Aparelhos de depilar, com motor elétrico','Hair-removing appliances, with electric motor','Aparatos de depilar, con motor eléctrico',11,'85','8510','851030');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85109011','Lâminas de aparelhos ou maqs.de barbear, c/motor eletr.','Laminates of shavers, with electric motor','Cuchillas de aparatos o afeitadoras, c/motor eléctr.',11,'85','8510','851090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85109019','Outs.partes de apars.ou maqs.de barbear, c/motor eletr.','Other parts of shavers, with electric motor','Las dem.partes de apars.o afeitadoras, c/motor eléctr.',10,'85','8510','851090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85109020','Pentes e contrapentes para máquinas de tosquiar','Combs and blades for shearing machines','Cuchillas de aparatos para esquillar',10,'85','8510','851090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85109090','Partes de maqs.de cortar cabelo/tosquiar, c/motor eletr.','Parts of hair-removing appliances, with electric motor','Partes de máqs.de cortar pelo/esquilar, c/motor eléctr.',10,'85','8510','851090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85111000','Velas de ignição para motor explosão/diesel','Sparking plugs for motor explosion/diesel','Bujías de encendido p/motor explosión/diesel',11,'85','8511','851110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85112010','Magnetos para motor explosão/diesel','Ignition magnetos for motor explosion/diesel','Magnetos p/motor explosión/diesel',11,'85','8511','851120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85112090','Dinamos-magnetos/volante magnet.p/motor explosão/diesel','Magneto-dynamos/magnetic flywheels f/motor expl./dies.','Dinamomagnetos/volante magnét.p/motor explosión/diesel',11,'85','8511','851120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85113010','Distribuidores para motor explosão/diesel','Distributors for motor explosion/diesel','Distribuidores p/motor explosión/diesel',11,'85','8511','851130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85113020','Bobinas de ignição para motor explosão/diesel','Ignition coils for motor explosion/diesel','Bobinas de encendido p/motor explosión/diesel',11,'85','8511','851130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85114000','Motores de arranque para motor explosão/diesel','Starter motors for motor explosion/diesel','Motores de arranque p/motor explosión/diesel',11,'85','8511','851140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85115010','Dínamos e alternadores para motor explosão/diesel','Dynamos and alternators f/motor explosion/diesel','Dínamos y alternadores p/motor explosión/diesel',11,'85','8511','851150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85115090','Outros geradores para motor explosão/diesel','Other generators for motor explosion/diesel','Los demás generadores p/motor explosión/diesel',11,'85','8511','851150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85118010','Velas de aquecimento para motor explosão/diesel','Glow plugs for motor explosion/diesel','Bujías de encendido para motor explosión/diesel',11,'85','8511','851180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85118020','Regulador de voltagem para motor explosão/diesel','Cut-outs comb.with regulators f/motor explos./dies.','Regulador de voltaje para motor explosión/diesel',11,'85','8511','851180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85118030','Ignição eletrônica digital p/motor explosão/diesel','Digital electronic ignition f/motor explosion/diesel','Disposit.electr.de enced.digital p/motor explos./diesel',11,'85','8511','851180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85118090','Outs.apars.e disposit.eletr.de ignição, etc.p/motor expl','Oth.electrical ignition equipm.etc.f/motor explos./dies','Los dem.apars.y disp.electr.de encend.etc.p/motor expl',11,'85','8511','851180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85119000','Partes de apars.disposit.eletr.ignição, etc.p/motor expl','Parts of electrical ignition, etc.f/motor explos./diesel','Partes de apars.dispos.elect.de encend.etc.p/motor expl',10,'85','8511','851190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85121000','Apars.de iluminação/sinaliz.visual util.em bicicletas','Lighting/visual signalling equipment, used on bicycles','Apars.de alumbrado/señaliz.visual util.en bicicletas',11,'85','8512','851210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85122011','Farois para automóveis e outros ciclos','Headlamps for automobiles and other cycles','Faros para automóviles y demás velocípedos',11,'85','8512','851220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85122019','Outs.apars.eletr.de iluminação p/automóveis/outs.ciclos','Oth.electr.lighting equipment f/automobiles/oth.cycles','Los dem.apars.eléctr.de alumbrado p/automóv./dem.veloc.',11,'85','8512','851220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85122021','Luzes fixas para automóveis e outros ciclos','Fixed lights for automobiles and other cycles','Luces fijas para automóviles y demás velocípedos',11,'85','8512','851220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85122022','Luzes indicadoras de manobras p/automóveis/outs.ciclos','Direction indication lights f/automobiles/oth.cycles','Luces indicadoras de maniobras p/automóviles/dem.veloc.',11,'85','8512','851220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85122023','Caixas de luzes combinadas p/automóveis/outros ciclos','Boxes of combined lights f/automobiles/oth.cycles','Cajas combinadas de señaliz.vis.p/automóv./dem.velocíp.',11,'85','8512','851220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85122029','Outs.aparelhos eletr.de sinaliz.visual p/automóveis, etc','Oth.electr.visual signalling equipm.f/automobiles, etc.','Los dem.aparatos electr.de señaliz.visual p/automóv.etc',11,'85','8512','851220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85123000','Apars.de sinalização acustica util.em ciclos/automóveis','Oth.sound signalling equip. used in cycles/automobiles','Apars.de señalización acústica util.en velocíp/automóv.',11,'85','8512','851230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85124010','Limpadores de pára-brisas para automóveis','Windscreen wipers for automobiles','Limpiaparabrisas para automóviles',11,'85','8512','851240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85124020','Degeladores e desembaçaadores, util.automóveis','Defrosters and demisters, used automobiles','Eliminadores de escarcha o vaho, util.automóviles',11,'85','8512','851240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85124090','Degeladores e desembaçadores para automóveis','Defrosters and demisters for automobiles','Eliminadores de escarcha o vaho para automóviles',11,'85','8512','851240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85129000','Partes de apars.eletr.ilumin/sinaliz.p/automóveis, etc.','Parts of electr.lighting/signalling equipm.f/autom.etc.','Partes de apars.electr.alumbrado/señaliz.p/automóv.etc',10,'85','8512','851290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85131010','Lanternas manuais','Hand lamps','Lámparas manuales',11,'85','8513','851310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85131090','Outras lanternas eletr.portateis, de pilhas, etc.','Other portable electric lamps, of piles, etc','Las demás lámparas eléctr.portatiles, de pilhas, etc',11,'85','8513','851310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85139000','Partes de lanternas eletr.portateis, de pilhas, etc.','Parts of portable electric lanterns, of piles, etc.','Partes de lámparas eléctr.portatiles, de pilas, etc',10,'85','8513','851390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85141010','Fornos de resistencia, industriais (aquecim.indireto)','Resistance heated furnaces and ovens, industrial','Hornos de resistencia, industriales (calentam.indirecto)',11,'85','8514','851410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85141090','Fornos de resistencia, de laboratorio (aquecim.indireto)','Resistance heated furnaces and ovens, of laboratory','Hornos de resistencia, de laboratório (calent.indirecto)',11,'85','8514','851410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85142011','Fornos de indução, industriais','Ovens of induction, industrial','Hornos por inducción, industriales',11,'85','8514','851420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85142019','Fornos de indução, de laboratório','Ovens of induction, laboratory','Hornos de inducción, de laboratorio',11,'85','8514','851420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85142020','Fornos de perdas dielétricas, industriais/de laboratório','Ovens of dielectric loss, industrial/of laboratory','Hornos de pérdidas dieléctr.industriales/de laborat.',11,'85','8514','851420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85143011','Fornos de resistência, industriais (aquecimento direto)','Resistance ovens, industrial (direct heating)','Hornos de resistencia, industriales (calent.directo)',11,'85','8514','851430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85143019','Fornos de resistencia, de laboratorio (aquecim.direto)','Resistance ovens, of laboratory (direct heating)','Hornos de resistencia, de laboratorio (calent.directo)',11,'85','8514','851430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85143021','Fornos de arco voltaico, industriais','Ovens of electric arc, industrial','Hornos de arco voltaico, industriales',11,'85','8514','851430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85143029','Fornos de arco voltaico, de laboratório','Ovens of electric arc, of laboratory','Hornos de arco voltaico, de laboratorio',11,'85','8514','851430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85143090','Outros fornos elétricos industriais ou de laboratório','Other industrial or laboratory electric furnaces/ovens','Los demás hornos eléctr.industriales o de laboratorio',11,'85','8514','851430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85144000','Outs.apars.de indução/perdas dieletr.p/trat.term.mater.','Oth.equip.heat treatm.mater.induction/dielectric loss','Los dem.apars.de induc/pérdidas dieléc.p/trat.term.mat.',11,'85','8514','851440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85149000','Partes de fornos eletr.industriais/de laboratorio, etc.','Parts of industrial/laborat.electric furnaces/ovens, etc','Partes de hornos eléctr.industriales/de laboratorio, etc',10,'85','8514','851490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85151100','Ferros e pistolas para soldadura forte ou fraca','Iron and pistols for soldering strong or weak','Soldadores y pistolas para soldar fuerte o flaco',11,'85','8515','851511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85151900','Outras máquinas e aparelhos p/soldadura forte ou fraca','Oth.machin.and apparatus f/welding strong or weak','Los demás soldadores y pistolas p/soldar fuerte o flaco',11,'85','8515','851519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85152100','Máquinas e apars.p/soldar metais, de resistencia, automat','Machin.and appar.f/welding metals, of resistance, autom.','Máquinas y apars.p/soldar metal, de resistencia, automát.',11,'85','8515','851521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85152900','Outs.máquinas e apars.p/soldar metais, de resistência','Oth.machin.and appar.f/welding metals, of resistance','Las dem.máquinas y apars.p/soldar metal, de resistencia',11,'85','8515','851529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85153100','Maqs.e apars.p/soldar metais, de arco/jato plasma, autom.','Mach.and appar.f/arc/plasma arc weld.of metals, autom.','Máqs.y apars.p/soldar metal, de arco/chorro plasma, autom',11,'85','8515','851531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85153110','Robos p/soldar, por arco, metais, int/parc.autom.cmdo.num.','Robots f/ weld.f/arc, metals, fully /part.aut.num.contr.','Robotes p/soldar, por arco, met., tot/parc.autom.cont.num.',11,'85','8515','851531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85153190','Outs.maqs.apars.soldar metais, de arco/jato plasma, autom','Oth.mach.and appar.f/arc/plasma arc weld.of metals, aut.','Las dem.máqs.apars.sold.met.de arco/chorro plasma, autom',11,'85','8515','851531');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85153900','Outs.maqs.e apars.p/soldar metais, de arco/jato plasma','Oth.mach.and appar.f/arc/plasma arc welding of metals','Las dem.máqs.y apars.p/sold.metal, de arco/chorro plasma',11,'85','8515','851539');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85158010','Máquinas e aparelhos para soldar a "laser"','Machines and apparatus for welding by laser','Máquinas y aparatos para soldar por láser',11,'85','8515','851580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85158090','Outs.máquinas e apars.p/soldar, eletr.por outs.processos','Oth.machin.and appar.f/soldering, eletr.f/other proces.','Las máquinas y apars.p/soldar, eléctr.por los dem.proc.',11,'85','8515','851580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85159000','Partes de máquinas e aparelhos p/soldar, eletr.','Parts and acces.machinery and appar.f/soldering, electr.','Partes de máquinas y aparatos p/soldar, eléctr.',10,'85','8515','851590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85161000','Aquecedores eletr.de agua, incl.de imersao, uso doméstico','Electric water heaters, inc.of immersion, domestic','Calentadores eléctr.de agua, incl.inmersión, uso domést.',11,'85','8516','851610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85162100','Radiadores de acumulacao, p/aquec.ambiente, uso doméstico','Radiators of accumulation, f/space-heating, domestic','Radiadores de acumulación, p/calef.espacios, uso domést.',11,'85','8516','851621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85162900','Outs.apars. eletr.p/aquecim.de ambientes, uso doméstico','Oth.electric apparatus, f/space-heating, domestic','Los dem.apars. eléctr.p/calef.de espacios, uso doméstico',11,'85','8516','851629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85163100','Secadores de cabelo, eletrotérmicos, uso doméstico','Hair dryers, electrothermic, for domestic purposes','Secadores p/el cabello, electrotérmicos, uso doméstico',11,'85','8516','851631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85163200','Outs.apars.p/arranjos cabelo, eletroterm.uso doméstico','Oth.electroth.hair-dressing apparatus, domestic','Los dem.apars.p/cuidado cabello, eletrotér.uso doméstico',11,'85','8516','851632');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85163300','Aparelhos p/secar as maos, eletrotermicos, uso doméstico','Electrothermic hand-drying apparatus, domestic','Aparatos p/secar las manos, electrotérmicos, uso domést.',11,'85','8516','851633');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85164000','Ferros elétricos de passar, uso doméstico','Electric smoothing irons, for domestic purposes','Planchas eléctricas, uso doméstico',11,'85','8516','851640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85165000','Fornos de microondas, uso doméstico','Microwave ovens, for domestic purposes','Hornos de microondas, uso doméstico',11,'85','8516','851650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85166000','Outs.fornos, fogoes cozinha, etc.eletroterm.uso doméstico','Oth.electrothermic ovens, cookers, etc.f/domestic purpos.','Los dem.hornos, cocinas, etc.electrotérm.uso domést.',11,'85','8516','851660');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85167100','Aparelhos p/prepar.cafe ou cha, eletroterm.uso doméstico','Electrothermic mach.for making coffee or tea, domestic','Aparatos p/prepar.café o té, electrotérm.uso doméstico',11,'85','8516','851671');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85167200','Torradeiras de pão, eletrotérmicas, uso doméstico','Electrotermics toasters, domestic','Tostadoras de pan, electrotérmicas, uso doméstico',11,'85','8516','851672');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85167910','Panelas eletrotérmicas, uso doméstico','Electrotermics pots, domestic','Cacerolas electrotérmicas, uso doméstico',11,'85','8516','851679');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85167920','Fritadoras eletrotérmicas, uso doméstico','Electrotermics frying pans, domestic','Freidoras electrotérmicas, uso doméstico',11,'85','8516','851679');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85167990','Outros aparelhos eletrotérmicos, uso doméstico','Other electrotermics apparatus, domestic','Los demás aparatos electrotérmicos, uso doméstico',11,'85','8516','851679');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85168010','Resistências aquecim.p/apars.eletroterm.uso doméstico','Oth.electric heating resistors f/electr.appar.domestic','Resistencias calent.p/apars.electrotérm.uso doméstico',11,'85','8516','851680');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85168090','Outras resistências de aquecimento, uso doméstico','Other electric heating resistors, domestic','Las demás resistencias calentadoras, uso doméstico',11,'85','8516','851680');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85169000','Partes de aquecedores/apars.eletr.p/aquecim.uso domest.','Parts of heating f/electr.appar.f/heating, domestic','Partes de calentadores/apars.eléctr.p/calent.uso domést',10,'85','8516','851690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171100','Apars.telefon.por fio conjug.c/apar.telef.portat.s/fio','Line telep.sets appar.conj.with cordless handsets appar','Teléfon.de usuar.de auricular inalámbr.combin.c/micróf.',11,'85','8517','851711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171211','Ap.radiotel., portátil ex:walkie/handle-talkie','Portable appliance of radio-telecom. ex:walkie/handle-talkie','Apar.de radio telecom.ex:walkie/handle-talkie',11,'85','8517','851712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171212','Term.fixo s/fonte próp.energia, monocanais','Fixed terminals without own source of energy, mono-chanels','Terminales fijos sin la propia fuente de energía, mono-canais',11,'85','8517','851712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171213','Term.móveis analóg.utiliz.veíc.automóveis','Analogical movable terminals used in vehicles automobiles','Terminales móviles analóg. util. vehículos/automóviles',11,'85','8517','851712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171219','Outs.ap.radiotelefonia, radiotelegr., analóg.','Other appliances of radio-telecom, radio-telegraph, analog.','Otros apar./equip. de radio-telecom, radio-telégrafo, analógico',11,'85','8517','851712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171221','Ap.sist.troncalizado, terminal portátil','Apparatus/equip. of trunk system,portable terminal ','Apar./equip. de sistema de tronco, terminal portátil',11,'85','8517','851712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171222','Terminais fixos d/sist.troncal., s/font.energia','Fixed terminals of trunk system, without energy source','Termiales fijos de sistema de tronco, sin la fuente de energía',11,'85','8517','851712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171223','Term.móveis sist.tronc.term., util.veíc.autom.','Mobile terminals of trunk system term., used in vehicles /automobiles','Terminales móviles de sistema de tronco, util vehículos/automóviles',11,'85','8517','851712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171229','Outs.apars.transm./rec.d/sist.troncalizado','Other apparatus/equip. of transm./recep. of trunk system','Otros apar./equip. transm./recep. de sistema de tronco',11,'85','8517','851712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171231','Terminais portáteis de telefonia celular','Portable terminals of cellular telephony','Terminales portáteis de telefonía celular',11,'85','8517','851712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171232','Terminais fixos d/telef.cel., s/fonte energia','Fixed terminals of cellular telephony without own source of energy','Terminales fijos de telefonía celular sin la propia fuente de energía',11,'85','8517','851712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171233','Terminais móveis, do tipo utiliz.veíc.automóveis','Mobile terminals of the  type used in vehicles/automobiles  ','Terminales móviles del tipo util. vehículo/automóviles',11,'85','8517','851712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171239','Outs.apar.transmiss.recept.d/telef.celular','Other appar/equip. of transm./recep. of cellular telephony','Otros apar./equip. transm./recep. de telefonía celular',11,'85','8517','851712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171241','Apar.digitais operando banda c,  ku,  l ou s','Digital appar/equip. operating in band c, ku, l or s','Digital apar./equip. operando banda c, ku, l ou s',11,'85','8517','851712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171249','Outs.ap.transmiss.recept.d/telec.p/satélite','Other appar/equip. of transm./recep. of telec. by satellite','Otros apar./equip. transm./recep. de telec. por satélite',11,'85','8517','851712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171290','Outs.apar.transm.c/receptor incorporado','Other appar/equip. of transm./recep. incorpor.','Otros apar./equip. transm./recep. de telec. incorpor.',11,'85','8517','851712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171810','Interfones','Interphones','Interfonos',11,'85','8517','851718');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171820','Aparelhos telefônicos públicos','Public telephones','Apar./equip. telefónicos públicos',11,'85','8517','851718');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171891','Outros telefones não combinados com outros aparelhos','Other phone appar/equip. , n/combined with oth.appar./equip.','Otros apar./equip. telefónicos, s/combinar c/otros apar./equip.',11,'85','8517','851718');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171899','Outs.aparelhos telefônicos, inc.videofones','Other phone and video-phone appar/equip. incorp.','Otros apar./equip. telefónicos y videófonos incorp.',11,'85','8517','851718');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171910','Interfones','Interphones','Interfonos',11,'85','8517','851719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171920','Aparelhos telefonicos publicos','Public telephones','Aparatos telefónicos públicos',11,'85','8517','851719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171991','Outros aparelhos telefonicos, n/combinados c/outs.apars.','Other phone apparatus, n/combined with oth.apparatus','Los dem.aparatos telefónicos, s/combinar c/otrs.apars.',11,'85','8517','851719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85171999','Outros aparelhos telefonicos e videofones','Other phone and video-phone apparatus','Los demás aparatos telefónicos y videófonos',11,'85','8517','851719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85172110','Telecopiadores (fax), com impressão por sistema térmico','Fax machines, with thermal printing system','Telecopiadoras (fax), c/impresión por sistema térmico',11,'85','8517','851721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85172120','Telecopiadores (fax), com impressão por sistema "laser"','Fax machines, with laser printing system','Telecopiadoras (fax), c/impresión por sistema láser',11,'85','8517','851721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85172130','Telecopiadores (fax), com impressão por jato de tinta','Fax machines, with ink-jet printing system','Telecopiadoras (fax), c/impresión por sist.chorro tinta',11,'85','8517','851721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85172190','Outros telecopiadores (fax)','Other fax machines','Las demás telecopiadoras (fax)',11,'85','8517','851721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85172210','Aparelhos de transmissão e recepcao automáticas (telex)','Automatic transmission and reception apparatus','Aparatos p/emissión y recepción automáticos (telex)',11,'85','8517','851722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85172290','Outros teleimpressores','Other teleprinters','Los demás teletipos',11,'85','8517','851722');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85173011','Centrais automat.comut.eletrônica linha telef.publica','Autom.central electronic commutation of teleph.line pub','Centrales automát.conmut.electrónica de línea, públicas',11,'85','8517','851730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85173012','Centrais automat.comut.eletromec.linha telef.publica','Autom.central electrom.commut.of teleph.line public','Centrales automát.conmut.electromec.de línea, públicas',11,'85','8517','851730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85173013','Centrais automat.comut.linha telef.privada, c<=25ramais','Autom.cent.commut.of line priv.teleph.c<=25inter.lines','Centrales automát.comut.línea, privadas, c<=25ramales',11,'85','8517','851730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85173014','Centrais automat.comut.linha telef.privada, 25/200ramais','Autom.cent.commut.of line priv.telephone, 25/inter.lines','Centrales automát.comut.línea, privadas, 25/200ramales',11,'85','8517','851730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85173015','Centrais automat.comut.linha telef.privada, c>200ramais','Autom.cent.commut.of line priv.teleph., c>200inter.lines','Centrales automát.comut.línea, privadas, c>200ramales',11,'85','8517','851730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85173019','Outras centrais automat.comut.linha telef.','Other autom.cent.commut.of line privatetelephone','Las demás centrales automát.comut.línea telef.',11,'85','8517','851730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85173020','Centrais automatáticas de videotexto','Automatic central of videotext','Centrales automáticas de videotexto',11,'85','8517','851730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85173030','Centrais automáticas de telex','Central automatic of telex','Centrales automáticas de telex',11,'85','8517','851730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85173041','Centrais automat.comut.pacotes>3600/s, vel>72kbits/s','Autom.cent.commut.package>3600/s, spe>72kbits/s','Centrales automát.conmut.paquetes>3600/s, vel>72kbits/s',11,'85','8517','851730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85173049','Outs.centrais automat.comut.de pacotes p/telefonia, etc.','Oth.autom.cent.commut.package f/telephony, etc.','Las dem.centrales autom.conmut.de paquetes p/telef.etc',11,'85','8517','851730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85173050','Centrais automat.sistema troncalizado p/telefonia, etc.','Autom.central networking system f/telephonic, etc.','Centrales automát.sistema troncalizado p/telefonía, etc',11,'85','8517','851730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85173061','Roteadores digitais "crossconect", granularid>=2mbits/s','Dig. routers crossconect, granularity>=2mbits/s','Ruteadores digitales "crossconect", granularid>=2mbits/s',11,'85','8517','851730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85173062','Roteadores digitais, vel.interface serial>4mbits/s, etc.','Crossconect, serial connection speed>4mbits/s, etc','Ruteadores digitales, vel.interfase serial>4mbits/s, etc',11,'85','8517','851730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85173069','Outros roteadores digitais eletr.p/telefonia/telegrafia','Other eletr. dig.routers crossconect to teleph./telegraph.','Los dem.ruteadores digit.eléctr.p/telefonía/telegrafía',11,'85','8517','851730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85173090','Outs.aparelhos eletr.de comutacao p/telefonia/telegraf.','Oth.apparatus electr.of commut.f/telephonic/telegraphic','Los dem.apars.eléct.de conmutacao p/telefonía/telegraf.',11,'85','8517','851730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175010','Moduladores/demoduladores (modens)','Modems','Moduladores/demoduladores (modems)',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175011','Moduladores/demoduladores digitais (banda base)','Digital modems(band base)','Moduladores/demoduladores digitales (banda base)',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175012','Moduladores/demoduladores analogicos, vel<=9600bits/s','Analogical modems, speed<=9600bits/s','Moduladores/demoduladores analógicos, vel<=9600bits/s',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175013','Moduladores/demoduladores analogicos, 9600<v<=28800bit/s','Analogical modems, 9600<s<=28800bit/s','Moduladores/demoduladores analógicos, 9600<v<=28800bit/s',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175019','Outros moduladores/demoduladores (modens)','Other modems','Los demás moduladores/demoduladores (modem)',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175021','Equipam.terminal/repetidor em linhas metálicas','Terminal equipment/repeater on metal line','Equipam.terminal/repetidor sobre líneas metálicas',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175022','Equipam.terminal/repetidor, em fibra óptica, v>2.5gbits/s','Terminal equipm./repeater, on fibr.optic, s>2.5gbits/s','Equip.terminal/repet.sob.línea fibr.óptica, v>2.5gbits/s',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175029','Outros equipamentos terminais ou repetidores','Other terminal equipments or repeaters','Los demás equipamientos terminales o repetidores',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175030','Multiplexador por divisao de frequência','Multiplexers operating by frequency sharing','Multiplexor por división de frecuencia',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175041','Multiplexador por divisao de tempo, digit.sincronos, etc.','Multiplexers oper.by time sharing, synchronous dig., etc','Multiplexor p/división de tiempo, digit.síncronos, etc',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175049','Outros multiplexadores por divisao de tempo','Other multiplexers operating by time sharing','Los demás multiplexores por división de tiempo',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175050','Conversores de sinais sincronos/assincronos, etc.','Converters of synchronous/asynchronous signs, etc.','Conversores de señales síncronos/asíncronos, etc',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175061','Concentradores de linhas de assinantes','Centralizing of subscriber lines','Concentradores de líneas abonados',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175062','Concentradores de circuitos digitais','Centralizing digital circuits','Concentradores de circuitos digitales',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175069','Outs.concentradores para telecomunicação','Other centralizing for telecommunication','Los demás concentradores de telecomunicación',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175090','Outs.apars.p/telecom.corrente portadora/telecom.digital','Ot.appar.f/carrier-current line systems /dig.line syst.','Los dem.apars.de telecom.corrient.portad./telecom.digit',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175091','Terminais de texto, oper.c/cod.de transmissão baudot, etc','Terminals of text oper.with transmis.baudot code, etc','Termins.de texto, oper.c/cod.de transmisión baudot, etc',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85175099','Outs.apars.p/telecom.corrente portadora/telecom.digital','Ot.appar.f/carrier-current line systems /dig.line syst.','Los dem.apars.de telecom.corrien.portad./telecom.digit.',11,'85','8517','851750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176111','Ap.p/est.d/sist.bidirec.rad.trans.<=112kbts/s','Appar./equip. for station of transm.rad.bidir.sys <=112kbts/s','Apar./equip. p/est. de sist. bidirec.rad.transm. <=112kbt/s',11,'85','8517','851761');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176119','Outs.apar.transm.rec.dig.p/radiotel.f<15ghz','Other dig.transm.rec.appar./equip for radiotel.freq<15ghz','Otros apar./equip. transm.recep.dig. p/radiotel. f<15ghz',11,'85','8517','851761');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176120','Ap.sist.troncalizado p/estação central','Appar./equip. of trunk system for central station','Apar/equip. de sistema de tronco p/ estación central',11,'85','8517','851761');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176130','Ap.transm.telefonia celular p/estação base','Appar./equip. of cellular telephony for base station','Apar/equip. de telefonía celular p/ estación base',11,'85','8517','851761');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176141','Ap.trans.telec.satél.est.prin.ter.fix.s/antena','Appar/equip.transm.telec.sat.main stat.fix.term.without antenna','Apar./equip.transm.telec.satél.est.princ.term.fijo s/ antena',11,'85','8517','851761');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176142','Estações vsat, s/conjunto antena-refletor','Vsat station, without reflector antenna set','Estación vsat, sin el conjunto de antena-reflector',11,'85','8517','851761');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176143','Apar.digitais operando banda c,  ku,  l ou s','Digital appar/equip. operating in band c, ku, l or s','Digital apar./equip. operando banda c, ku, l ou s',11,'85','8517','851761');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176149','Outs.ap.transmiss.recept.d/telec.p/satélite','Other appar/equip. of transm./recep. of telec. by satellite','Otros apar./equip. transm./recep. de telec. por satélite',11,'85','8517','851761');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176191','Outs.ap.rad., dig.freq.<=23ghz, tax.<=8mbits/s','Other appar/equip dig.radio, freq.<=23ghz,rate<=8mbits/s','Otros apar./equip. dig.freq.<=23ghz, tax<=8mbits/s',11,'85','8517','851761');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176192','Outs.apar.d/radiotelef.radioteleg., digitais','Other appar/equip. of radio-teleph., radio-telegraph, digital','Otros apar./equip. de radio-telef., radio-telégr, digital',11,'85','8517','851761');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176199','Outs.apar.transm.c/receptor incorporado','Other transm. appar/equip. with incorp. recep.','Otros apar./equip. transm. c/recep. incorp.',11,'85','8517','851761');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176211','Multiplexadores por divisão de freqüência','Multiplexers by frequency sharing','Multiplexores por división de frecuencia',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176212','Multip.div.temp.dig.síncr.transm.>=155mbits/s','Dig. multiplexers by time shar., síncr. transm.>=155mbits/s','Multplexores p/ div. de tiempo dig. síncr.transm. >=155mbits/s',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176213','Outros multiplexadores para divisão de tempo','Other multiplexers operating by time sharing','Otros multplexores p/ div. de tiempo ',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176214','Concent.linhas assinantes(term.cent./remot.)','Centralizing of lines of subscribers (centr/remot.term.)','Concentradores de líneas de abonados (centr./remot.term.)',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176219','Outros concentradores','Other centralizing appar/equip','Otros concentradores',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176221','Centr.públ.;comut.eltrônica incl.d/trânsito','Public central, eletron. commutator, includ. traffic','Central pública, commutador electron.incluid.los de tráfico',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176222','Central automática privada, capacidade <= 25 ramais','Private autom.central, capac.<=25 internal lines','Central autom.priv., cap.<=25 ramales',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176223','Central automática privada, cap>25ramais <=200 ramais','Priv. autom.central, capac.>25 intern. lines and <=200 intern. lines','Central autom.priv., cap.>25 ramales y <=200 ramales',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176224','Central automática privada, capacidade > 200 ramais','Private autom.central, capac.>200 internal lines','Central automática privada, capacidade>200 ramales',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176229','Outs.centr.aut.comut.linh.tel.exc.videotexto','Other commut. aut. centr. for teleph.line excep. videotext','Otros centr.aut..commut.línea telef. except. videotexto',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176231','Cent.auto.comut.pacs.vel.tronco>72kbits/s','Commut.auto.centr. of pack. trunk speed>72kbits/s','Centr.autom.commut.paquet.veloc.tronco>72kbits/s',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176232','Outras centrais automáticas comutação para pacotes','Other commut. aut. centr. for packages','Otras centrais autom. commutación p/paquetes',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176233','Centrais automáticas de sistema troncalizado','Automatics central of trunk system','Centrales autom. de sistema de tronco',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176239','Outs.ap.comutação p/telefonia e telegrafia','Other commut. appar./equip. for teleph./telegraph.','Otros apar.commutación p/telefon./telegraf.',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176241','Roteadores digitais c/capacid. d/conexão s/fio','Digital routers with capac.by wireless connection','Ruteadores digitales c/ capacid de conexión inalámbrico',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176248','Rotead.dig.vel.interface serial 4mbits/seg.','Digital routers with serial interface speed 4mbits/sec','Ruteadores digitales c/vel.interf.serial 4mbits/seg',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176249','Outros roteadores digitais','Other digital routers','Otros ruteadores digitales',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176251','Equip.terminais/repetid.em linhas metálicas','Equip.of term./ repeat. in metalic lines','Equip. de term./repet.en línea de metal',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176252','Equip.term./rep.fib.óticas.veloc.>2, 5gbits/s.','Equip. of term./repeat.optic fiber with speed>2,5gbits/s','Equip.de term./repet.fibra optica vel>2,5gbits/s',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176253','Terms.d/texto q.operem c/cód.transm.baudot','Text terminals that oper.with baudots code transm.','Terminales de texto, q.oper.c/cód.de transm.baudot, etc',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176254','Distribuidores de conexões para redes ("hubs")','Hubs','Concentrador (hub) de la red',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176255','Modulad./demodul.(modens)p/telec.(port.dig)','Modems for telecom. (dig.port)','Moduladores/demoduladores (modems) p/telec.(puertos dig.)',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176259','Outs.equipamentos terminais ou repetidores','Other equip. of term. or repeat.','Otros equip.terminales o repetidores',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176261','Apars.transm./rec.d/sist.troncalizado','Transm./recep. appar/equip.of trunk system','Otros apar. transm./recep. d/ sist. de tronco',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176262','Apar.transmiss.recept.d/telef.celular','Transm./recep. appar/equip.of cellular telephony','Apar.transm./recep. de telef.celular',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176263','Apar.transmiss.recept.d/telec.p/satélite','Transm./recep. appar/equip.of telec.by satellite','Apar.transm.recep.de telec.p/satélite',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176264','Apar.transmiss.recept.p/satélite, digit.oper banda c, ku','Transm./recep. appar/equip.for  sat . dig. oper. band c, ku','Apar.transm.recep.p/ sat., dig. oper banda c, ku',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176265','Outros apar.transmiss.recept.p/satélite','Other transm./recep. appar./equip.for satellite','Apar. transm.recep.p/ satélite',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176271','Term.port.d/sist.d/radiom.d/trans.<=112kbts/s','Portable.term.of amateur radio (ham) system, transm.<=112kbits/s','Term.port.de sist. de radioafición de transm. <=112kbits/s',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176272','Apar.d/radiotelefon. dig.f<15ghz, t<=34mbits/s','Radio/teleph. appar/equip.dig. freq<15ghz, rate<=34mbits/s','Apar. de radio/telef.dig. f<15ghz, t<=34mbits/s',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176277','Apar.transm.rec.dig.p/radiotel.f<15ghz','Transm/.recep.appar./equip.dig.p/radiotel.freq<15ghz','Apar. transm./recep. dig. p/ radiotel.freq<15ghz',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176278','Apar.rad., dig.freq.<=23ghz, tax.<=8mbits/s','Rad. appar./equip., dig.freq. <=23ghz, rate <=8mbits/s','Apar.rad., dig.freq.<=23ghz, tax<=8mbits/s',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176279','Outs.apar.d/radiotelef.radioteleg., digitais','Other appar./equip. of digital radioteleph./radiotelegr.','Otros apar. de radiotelef.radioteleg.,dig.',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176291','Ap.transmis.radiotelefonia/radiotelegrafia','Appar./equip. transm.radioteleph./radiotelegr.','Otros apar transm.radiotelef./radiotelegr.',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176292','Recept.pessoais d/radiom.c/apres.alfa-num.','Person.recept. of amateur radio with alfa-num presentation','Recept.person. de radioafición c/ presentación alfa-num',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176293','Outs.ap.receps.pessoais d/radiomensagens','Other person. recep.appar./equip.of radiomessages','Otros apar.recep.person.d/ radiomesajes',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176294','Tradut.d/protocolos p/interconexão d/redes','Protocol translators for intercon.networks','Traduct.de protocolos p/ interconecxión de red',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176295','Term.fixo s/fonte próp.energia, monocanais','Fixed terminals without own source of energy, mono-chanels','Terminales fijos sin la propia fuente de energía, mono-canais',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176296','Outs.ap.radiotelefonia, radiotelegr., analóg.','Other appliances of radio-telecom, radio-telegraph, analog.','Otros apar./equip. de radio-telecom, radio-telégrafo, analógico',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176299','Outs.ap.rec.radiotelef./radioteleg./radiof.','Other appar/equip. of radio-teleph., radio-telegraph','Otros apar./equip. de radio-telef., radio-telégr.',11,'85','8517','851762');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85176900','Outs.aparelhos elétr.p/telefon.teleg.p/fio','Other eletric. appar./equip.for teleph./telegr. by wire','Otros apar. elétr.p/telef./telegraf.por hilos ',11,'85','8517','851769');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85177010','Circuitos impr.c/comp.elétr./eletr.montados','Printed circuits with assembled eletr./eletron. components','Circuitos impr. con electr.electron. componentes montados',11,'85','8517','851770');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85177021','Antena próp.p/tel.celular, exc.telescópicas','Specif.antenna for cellular telephone, except.telescopic','Antena para teléfono celular, excepción p/ telescópica',11,'85','8517','851770');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85177029','Outs.antenas exc.p/telefones celulares','Other antennas except.for used in cellular telephone','Otras antenas, excepción p/ de teléfono celular',11,'85','8517','851770');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85177091','Gabinetes, bastid.armaç.p/aps.transm./recpts.','Cabinets, backstages and  framework f/transm./rec. appar.','Gabinetes y bastidores p/aparatos transm./recept.',11,'85','8517','851770');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85177092','Registrads./selets.p/centrs.autom.telef.etc.','Recorders/select.for autom. central of telef. etc.','Registr./select. p/ centrales autom. telef. etc.',11,'85','8517','851770');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85177099','Outs.parts.p/apars.d/telefonia/telegrafia','Other parts for appar./equip. of teleph./telegr.','Otras part.p/ apar. de telefonía./telegrafía.',10,'85','8517','851770');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85178000','Outs.apars.p/telefonia, telegrafia, telecom.','Oth.telephonic or telegraphic apparatus, telecommunic.','Ls demás apars.p/telefonía, telegrafía, telecom.',11,'85','8517','851780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85178010','Aparelhos de gerenciamento de redes (tmn)','Apparatus of administration of nets (tmn)','Aparatos de control y mando de redes (tmn)',11,'85','8517','851780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85178021','Concentradores de linhas de assinantes','Centralizing of lines of subscribers','Concentradores de líneas de abonados',11,'85','8517','851780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85178022','Concentradores de circuitos digitais (dcme)','Centralizing digital circuits (dcme)','Concentradores de circuitos digitales (dcme)',11,'85','8517','851780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85178029','Outros concentradores eletr.p/telefonia/telegrafia','Oth.telephonic/telegraphic electr.centralizing','Los demás concentradores eléctr.p/telefonía/telegrafía',11,'85','8517','851780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85178090','Outros aparelhos elétricos para telefonia/telegrafia','Oth.electrical apparatus f/telephony/telegraphy','Los demás aparatos eléctricos p/telefonía/telegrafía',11,'85','8517','851780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85179010','Circuito impresso montado para telefonia, etc.','Printed circuits mounted f/telephonic, etc.','Circuito impreso montado p/telefonía, etc',11,'85','8517','851790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85179091','Mecanismo de impressão a "laser", etc.p/apars.fac-simile','Laser printing mechanisms, etc.f/facsimile apparatus','Mecanismo de impresión a láser, etc.p/apars.facsímile',11,'85','8517','851790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85179092','Bastidores e armações p/aparelhos de telefonia/telegraf','Furniture and framew.f/telephonic/telegraphic apparatus','Bastidores y armazones p/aparatos p/telefonía/telegraf',11,'85','8517','851790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85179093','Registradores/seletores p/centrais automat.telefon.etc','Registrars/selectors f/central automatic phone, etc.','Registradores/selectores p/centrales automát.telef.etc',11,'85','8517','851790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85179094','Transdutores piezoelétricos para aparelhos telefônicos','Piezo-electric transducers for telephone set','Transductores piezoeléctricos para aparatos telefónicos',11,'85','8517','851790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85179099','Outras partes para aparelhos de telefonia/telegrafia','Other parts of apparatus for telephony/telegraphy','Demás partes para aparatos de telefonía/telegrafía',10,'85','8517','851790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85181000','Microfones e seus suportes','Microphones and their supports','Micrófonos y sus soportes',11,'85','8518','851810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85181010','Piezelétricos próprios para aparelhos telefônicos','Specific piezo-eletric for appar./equip.of telephony','Piezoelétrico próprio para aparatos telefónicos',11,'85','8518','851810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85181090','Outros microfones e seus suportes','Other microphones and their supports','Otros micrófonos y sus soportes',11,'85','8518','851810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85182100','Alto-falante único montado no seu próprio receptáculo','Single loudspeakers, mounted in their enclosures','Altavoz único montado en su caja',11,'85','8518','851821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85182200','Alto-falantes múltiplos montados no mesmo receptáculo','Multiple loudspeakers, mounted in the same enclosure','Varios altavoces montado en una misma caja',11,'85','8518','851822');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85182900','Outros alto-falantes','Other loudspeakers','Los demás altavoces',11,'85','8518','851829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85182910','Piezelétricos próprios para aparelhos telefônicos','Specific piezo-eletric for appar./equip.of telephony','Piezoelétrico próprio para aparatos telefónicos',11,'85','8518','851829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85182990','Outros próprios para aparelhos telefônicos','Other specific for teleph. appar./equip. ','Otros próprios para aparatos telefónicos',11,'85','8518','851829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85183000','Fones de ouvido (auscultadores), mesmo com microfone','Earphones, including with microphones','Auriculares, incluso combinados con micrófono',11,'85','8518','851830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85184000','Amplificador elétrico de audiofrequência','Audio-frequency electric amplifiers','Amplificador eléctrico de audiofrecuencia',11,'85','8518','851840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85185000','Aparelhos eletr.de amplificação de som','Electric sound amplifier sets','Aparatos eléctrico para amplificación de sonido',11,'85','8518','851850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85189010','Partes de alto-falantes','Parts of loudspeakers','Partes de altavoces',10,'85','8518','851890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85189090','Partes de microfones, fones de ouvido, amplificadores, etc','Parts of microphones, earphones, amplifiers, etc','Partes de micrófonos, auriculares, amplificadores, etc',10,'85','8518','851890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85191000','Eletrofones comandados por moeda ou ficha','Coin- or token-operated record-players','Tocadiscos que funcionen por ficha o moneda',11,'85','8519','851910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85192000','Eletrofones comandados por moeda ou ficha','Coin- or token-operated record-players','Tocadiscos que funcionen por ficha o moneda',11,'85','8519','851920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85192100','Eletrofones sem alto-falante','Record-players without loudspeaker','Electrófonos sin altavoces',11,'85','8519','851921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85192900','Outros eletrofones','Other record-players','Los demás electrófonos',11,'85','8519','851929');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85193000','Toca-discos s/dispositivos d/amplific.de som','Turntables without devices to amplify sound','Tocadiscos sin dispositivo de amplificar sonido',11,'85','8519','851930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85193100','Toca-discos com permutador automático de discos','Turntables with automatic exchanging  of disks','Giradiscos con cambiador automático de discos',11,'85','8519','851931');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85193900','Outros toca-discos','Other turntables','Los demás giradiscos',11,'85','8519','851939');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85194000','Máquinas de ditar sem dispositivo de gravação de som','Transcribing mach.without dispos.of sound recording','Aparatos p/reprod.dictados s/disposit.de grab.de sonido',11,'85','8519','851940');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85195000','Secretárias eletrônicas (atendimento automático)','Telephone answering machines','Contestadores telefónicos',11,'85','8519','851950');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85198110','Apar.repr.som c/sist.leitura óptica p/"laser"','Sound reproduc.appar./equip., with laser optical readin.system','Aparatos de reprod.de sonido, c/sist.lect.óptica a láser',11,'85','8519','851981');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85198120','Gravadores d/som d/cabines d/aeronaves','Sound recorders for aircraft cabin','Grabadores de sonido para cabina de aeronave',11,'85','8519','851981');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85198190','Outs.grav.de sup.magnét.s/disp.reprod.som','Other recorders with magnet.suppor., without device sound reprod','Otros de grab.de sonido c/ sopor. magnét., s/disposit.repr.sonido',11,'85','8519','851981');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85198900','Outros apar.d/gravação e de reprodução de som','Other appar./equip. of sound record./reprod.','Otros apar. de grab. y de reprod. de sonido',11,'85','8519','851989');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85199200','Toca-fitas (leitores de cassetes), de bolso','Pocket-size cassette-players','Tocacasetes (lectores de casetes), de bolsillo',11,'85','8519','851992');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85199300','Outros toca-fitas (leitores de cassetes)','Other cassette-players','Los demás tocacasetes (lectores de casetes)',11,'85','8519','851993');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85199910','Aparelhos de reprod.de som, c/sist.leit.óptica a "laser"','Sound reproduc.appar., with laser optical readin.system','Aparatos de reprod.de sonido, c/sist.lect.óptica a láser',11,'85','8519','851999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85199990','Outros aparelhos de reprodução do som','Other apparatus for sound reproduction','Los demás aparatos para reproducción de sonido',11,'85','8519','851999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85201000','Maqs.de ditar c/disposit.de grav.som, fonte ext.energia','Dictating mac.with disp.of sound recor.ext.source power','Apars.p/dictar c/disp.de grab.sonido, fuente energía ext',11,'85','8520','852010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85202000','Secretarias eletrônicas (atendedores automáticos)','Telephone answering machines','Contestadores telefónicos',11,'85','8520','852020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85203200','Apars.digitais de gravacao/reprod.de som, de fita magnet','Digital of recor.appar./reprod.of sound, of magn.tape','Apars.digitales de grabac/repr.de sonido, de cinta magn',11,'85','8520','852032');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85203300','Apars.de gravacao/reprod.som, de fitas magnet.de cassete','Recor.appar./reprod.of sound, of magn.tape, of cassette','Apars.de grab/repr.de sonido, de cinta magnét.de casete',11,'85','8520','852033');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85203900','Outros aparelhos de gravacao/reprod.som, de fitas magnet','Other recor.appar./reprod.of sound, of magnetic tape','Los dem.aparatos de grab/reprod.sonido, de cintas magnét',11,'85','8520','852039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85209011','Gravadores de dados de voo, sem dispositiv.de reprod.som','Flight data recorders, without device of sound reproduct','Grabadores de datos de vuelo, s/disposit.de repr.sonido',11,'85','8520','852090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85209019','Outs.apars.de gravacao do som, sem dispositiv.reprod.som','Oth.sound recording appar., without device sound reprod','Los dem.apars.de grab.de sonido, s/disposit.repr.sonido',11,'85','8520','852090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85209020','Outs.aparelhos de gravacao do som, c/disposit.reprod.som','Oth.sound recording appar., with device sound reproduc.','Los dem.apars.de grab.de sonido, c/disposit.repr.sonido',11,'85','8520','852090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85211010','Gravador-reprodutor de fita magnet.s/sintonizador','Recording-reprod.of magnetic tape-type without tuner','Grabador-reproductor de cinta magnét.s/sintonizador',11,'85','8521','852110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85211081','Apars.videofon.de grav/reprod.p/fitas cassetes, l=12mm','Video recording/reproducing appar.f/casset.type, w=12mm','Apars.videófon.de grab/reprod.p/cintas casetes, a=12mm',11,'85','8521','852110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85211089','Outs.apars.videofon.grav/reprod.fita magnet.l<19.05mm','Oth.video record./reprod.appar.magn.tape-type w<19.05mm','Las dem.apars.videófon.grab/repr.cinta magnét.a<19.05mm',11,'85','8521','852110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85211090','Outs.apars.videofon.grav/reprod.fita magnet.l>=19.05mm','Oth.video recor./reprod.appar.magn.tape-type w>=19.05mm','Las dem.apars.videóf.grab/repr.cinta magnét.a>=19.05mm',11,'85','8521','852110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85219010','Gravador-reprodutor e editor imag/som, em discos magnet.','Record./reproduc.and image/sound editor, magnetic disks','Grabador-reprod.y editor imag/sonido, en discos magnét.',11,'85','8521','852190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85219090','Outros aparelhos videofonicos de gravação/reprodução','Other video recording or reproducing apparatus','Los dem.aparatos de grabación/reproducción de imag/son.',11,'85','8521','852190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85221000','Fonocaptores para aparelhos de gravação/reprodução','Pick-up cartridges f/recording or reproducing apparatus','Cápsulas fonocaptoras p/apars.de grabación/reproducción',10,'85','8522','852210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85229010','Agulhas c/ponta de pedra preciosa, p/apars.de reprodução','Needles with points of precious ston.f/reproduc.appar.','Agujas c/punta de piedra preciosa, p/apars.de reprod.',10,'85','8522','852290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85229020','Gabinetes p/aparelhos de gravação/reprodução','Cabinets f/recording/reproducing apparatus','Gabinetes p/aparatos de grabación/reproducción',10,'85','8522','852290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85229030','Chassis ou suportes p/aparelhos de gravação/reprodução','Frames and bases f/recording/reproducing apparatus','Chasis o soportes p/aparatos de grabación/reproducción',10,'85','8522','852290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85229040','Leitores de som, magnéticos p/aparelhos de reprodução','Magnetic sound readers, f/recording/reproducing apparat.','Lectores de sonido, magnéticos p/apars.de reproducción',10,'85','8522','852290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85229050','Mecanismos toca-discos, mesmo c/cambiador, p/apars.reprod','Disc turning mech.incor.disc changers, f/reprod.apparat.','Mecanismos giradiscos, incluso c/cambiador, p/apars.repr.',10,'85','8522','852290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85229090','Outs.partes e acess.p/aparelhos de gravação/reprodução','Oth.parts and access.f/recording/reproducing apparatus','Las dem.partes y acces.p/aparatos de grab./reproducción',10,'85','8522','852290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85231110','Fitas magnet.n/grav.l<=4mm, em cassetes','Magnetic tape-type n/recorded w<=4mm, in cassettes','Cintas magnét.s/grabar, a<=4mm, en casetes',11,'85','8523','852311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85231190','Outras fitas magnet.n/grav.l<=4mm','Other magnetic tape-type n/recorded w<=4mm','Las demás cintas magnét.s/grabar, a<=4mm',11,'85','8523','852311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85231200','Fitas magnet.n/grav.4mm<l<=6.5mm','Magnetic tape-type n/recorded 4mm<w<=6.5mm','Cintas magnét.s/grabar, 4mm<l<=6.5mm',11,'85','8523','852312');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85231310','Fitas magnet.n/grav.6.5<l<=50.8mm, em rolos/carreteis','Magnetic tape-type n/record.6.5<w<=50.8mm, on reels/cas.','Cintas magnét.s/grab.6.5<a<=50.8mm, en rollos/carretes',11,'85','8523','852313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85231320','Fitas magnet.l>6.5mm, em cassetes, p/grav.de video','Magnetic tape-type w>6.5mm, on cassettes, f/video record.','Cintas magnét.a>6.5mm, en casetes, p/grab.de video',11,'85','8523','852313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85231390','Outras fitas magnet.n/grav.l>6.5mm','Oth.magnetic tape-type n/recorded w>6.5mm','Las demás cintas magnét.s/grabar, a>6.5mm',11,'85','8523','852313');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232010','Discos magnéticos n/gravad.p/unidades de discos rígidos','Magnetic discs n/recording f/units of hard disks','Discos magnéticos s/grab.en unidades de discos rígidos',11,'85','8523','852320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232090','Outros discos magnéticos não gravados','Other magnetic discs not recorded','Los dem.discos magnéticos sin grabar',11,'85','8523','852320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232110','Cartôes magnéticos não gravados','Cards incorporating a magnetic stripe, not recorded','Tarjetas con tira magnét.incorporadas, no grab.',11,'85','8523','852321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232120','Cartões magnéticos gravados','Cards incorporating a magnetic stripe, recorded','Tarjetas con tira magnét.incorporadas',11,'85','8523','852321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232911','Discos magnét.ñ grav.p/unid.d/discos rígidos','Magnetic discs n/recording f/units of hard disks','Discos magnéticos s/grab.en unidades de discos rígidos',11,'85','8523','852329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232919','Outros discos magnéticos não gravados','Other magnetic discs no recorded','Los dem.discos magnéticos sin grabar',11,'85','8523','852329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232921','Fitas magnéticas ñ grav.l<=4mm, em cassetes','Magnetic tape-type n/recorded w<=4mm, in cassettes','Cintas magnét.s/grabar, a<=4mm, en casetes',11,'85','8523','852329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232922','Fitas magnéticas ñ grav.l >4mm<=6, 5mm','Magnetic tape-type n/recorded 4mm<w<=6.5mm','Cintas magnét.s/grabar, 4mm<l<=6.5mm',11,'85','8523','852329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232923','Fitas magnéticas ñ grav.l<50.8mm, rolos/carr.','Magnetic tapes-type n/record. w<50.8mm, on reels/cas.','Cintas magnét.s/grab.   a<50.8mm, en rollos/carretes',11,'85','8523','852329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232924','Fitas magnéticas k7 p/grav.vídeo larg>6, 5mm','Magnetic tapes  cassette  for video rec. w>6.5mm','Cintas magnét.casete p/grab.de video a>6.5mm',11,'85','8523','852329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232929','Outras fitas magnéticas não gravadas','Other magnetic tapes, no recorded','Otras cintas magnét., no grabadas',11,'85','8523','852329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232931','Fitas magnet.p/repr.diferen. d/som/imag.grav.','Magnetic tapes for reprod.dif.of sound./record.imag.','Cintas magnét.p/ reprod.dif.de son./imag.grab.',11,'85','8523','852329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232932','Fitas magnét.cart.casset.larg.<4mm, grav.','Magnetic tapes type cassette/cartridges w<4mm, record.','Cintas magnét.cartucho/casete ancho<4mm, grab.',11,'85','8523','852329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232933','Fitas magnéticas d/larg.>6, 5mm, gravadas','Magnetic tapes, w>6.5mm,record.','Cintas magnét. de a>6.5mm, grab.',11,'85','8523','852329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232939','Fitas magnéticas d/larg.>4mm, <6, 5mm, grav.','Magnetic tapes, w>4mm, <6.5mm,record.','Cintas magnét. de a>6.5mm, grab.',11,'85','8523','852329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85232990','Outs.discos, fitas, sup.p/grav.d/som, sem.grav.','Other discs,tapes,suport. for sound record.,without record.','Otros discos, cintas, sopor.p/ grab.de sonido, sin grab.',11,'85','8523','852329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85233000','Cartões magnéticos, não gravados','Cards incorporating a magnetic stripe, no recorded','Tarjetas con tira magnét.incorporadas, no grab.',11,'85','8523','852330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85234011','Discos p/leit.p/laser pod.ser grav.1única vez','Discs for read.by laser, can be writ.only time','Discos p/ lect.p/ laser, pued.sir grab. sólo una vez',11,'85','8523','852340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85234019','Outs.suportes prep./grav.som/semelhantes','Other support. prep./sound record./similar','Otros soport.prep/grab. de son./semejantes',11,'85','8523','852340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85234021','Disco grav., p/leit.raio laser, repr.só do som','Writ. disc,for laser read., only sound reprod.','Disco grab., p/lect.p/laser, reprod. sólo de sonido',11,'85','8523','852340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85234022','Discos p/sist."laser", p/rep.dif.d/som/imagem','Discs for laser system, for dif.reprod. of sound/image','Discos p/sist. laser, p/repr.dif./son./imag.',11,'85','8523','852340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85234029','Outs.discos p/sist.d/leitura p/raio "laser"','Other discs for  read. by laser system ','Otros discos p/sist. d/lectur. p/ laser',11,'85','8523','852340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85234110','Discos p/sis.lei.raios laser,gravad.uma única vez','Discs for reading system by laser, recorded only once','Discos para leitura por raio laser, sólo una grabación',11,'85','8523','852341');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85234190','Outros discos para sistema de leitura por raio laser','Other discs for reading system by laser','Otros discos para leitura por raio laser',11,'85','8523','852341');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85234910','Discos p/leit.p/laser apenas para reprodução de som','Discs by laser reading for reproducing sound only','Discos lectura laser sólo para reproducción del sonido',11,'85','8523','852349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85234920','Discos para rep.de fenomenos.dif.de som ou imagem','Discs for uses other than reproducing sound and image','Discos para lectura que no sea de sonido o imagen',11,'85','8523','852349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85234990','Outros suportes ópticos','Other optical media','Otros soportes ópticos',11,'85','8523','852349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85235100','Armaz.não-volátil dados à base d/semicondut.','No-volatile data-storage based on semiconductors','Armazenador no-volátil de datos a la base de semiconductores',11,'85','8523','852351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85235110','Cartões de memória memory cards','Memory cards','Tarjetas de memoria (memory card)',11,'85','8523','852351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85235190','Outros disposit. de armazenamento nao volat.de dados','Other devices of no-volatile data-storage ','Otros disposit.de armazen. no-volátil de datos',11,'85','8523','852351');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85235200','Cartões inteligentes smart cards','Smart cards','Tarjetas inteligentes (smart cards)',11,'85','8523','852352');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85235910','Cartões e etiquetas de acionamento por aproximação','Cards and labels of activated for approach','Tarjetas y etiquetas de activación por aproxim.',11,'85','8523','852359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85235990','Outros','Other','Otros',11,'85','8523','852359');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85238000','Outs.suportes prep./grav.som/semelhantes','Other support. prep./sound record./similar','Otros soport.prep/grab. de son./semejantes',11,'85','8523','852380');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85239000','Outros suportes p/gravação de som/semelhs.n/gravados','Oth.unrecorded media f/sound recording/similar','Los dem.soportes prep.p/grabar sonido/análogas, s/grabar',11,'85','8523','852390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85239010','Discos p/sist.leit.raio laser, possib.grav.1 vez (cd-r)','Discs f/laser read.syst.which may be record.once(cd-r)','Discos p/sist.lect.rayo láser, posib.grab.1 vez (cd-r)',11,'85','8523','852390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85239090','Outs.suportes p/gravação de som/semelhs.n/gravados','Oth.prepar.unrecorded media f/sound recording/similar','Los dem.soportes prep.p/grabar sonido/análogas, s/grabar',11,'85','8523','852390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85241000','Discos fonográficos, gravados','Gramophone records, recorded','Discos para tocadiscos, grabados',11,'85','8524','852410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85243100','Discos gravad.p/leit.raio "laser", de fenom.dif.som/imag','Record.disks f/laser reading, of difer.phen.sound/image','Discos grabad.p/lect.rayo láser, de fenóm.dist.son./imag',11,'85','8524','852431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85243200','Discos gravad.p/leit.raio "laser", reprod.apenas do som','Record.disks f/laser reading, reproducing sound only','Discos grabad.p/lect.rayo láser, p/reprod.únic.sonido',11,'85','8524','852432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85243900','Outros discos gravados, para leitura por raio "laser"','Other recorded disks, for laser reading','Los demás discos grabados, p/lectura por rayo láser',11,'85','8524','852439');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85244000','Fitas magnet.gravadas, p/reprod.de fenom.dif.som/imagem','Magnetic tapes recorded, f/reprod.dif.phen.sound/image','Cintas magnét.grabadas, p/repr.de fenóm.dist.sonido/imag',11,'85','8524','852440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85245110','Fitas magnet.gravadas, l<=4mm, em cartuchos/cassetes','Magnetic tapes recorded, w<=4mm, in cartridges/cassettes','Cintas magnét.grabadas, l<=4mm, en cartuchos/casetes',11,'85','8524','852451');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85245190','Outras fitas magnéticas gravadas, l<=4mm','Other magnetic tapes recorded, w<=4mm','Las demás cintas magnét.grabadas, a<=4mm',11,'85','8524','852451');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85245200','Outras fitas magnéticas gravadas, 4mm<l<=6.5mm','Other magnetic tapes recorded, 4mm<w<=6.5mm','Las demás cintas magnét.grabadas, 4mm<a<=6.5mm',11,'85','8524','852452');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85245300','Outras fitas magnéticas gravadas, l>6.5mm','Other magnetic tapes recorded, w>6.5mm','Las demás cintas magnét.grabadas, a>6.5mm',11,'85','8524','852453');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85246000','Cartões magnet.gravados','Cards incorporating a magnetic stripe, recorded','Tarjetascon tira magnét.incorporadas',11,'85','8524','852460');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85249100','Outs.suportes gravados, p/reprod.de fenom.dif.som/imagem','Oth.prepar.recorded media f/reprod.dif.phen.sound/image','Los dem.soportes grabados, p/repr.de fen.dist.son./imag',11,'85','8524','852491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85249900','Outros suportes p/grav.de som/semelhs.gravados, etc.','Oth.prepar.recorded media f/sound recording/similar, etc','Los dem.soportes p/grab.som./análogas, grabados, etc',11,'85','8524','852499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85251010','Aparelhos transm.de radiotelefonia ou radiotelegrafia','Transmis.appar.f/radio-telephony or radio-telegraphy','Aparatos emisores de radiotelefonía o radiotelegrafía',11,'85','8525','852510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85251021','Apars.transm.de radio am, modul.cod/larg.pulso, pot>10kw','Am radium, pot>10kw, cod.modul../wid.pulse, transmis.appar','Apars.de radiodifusión am, modul.cód/anc.pulso, pot>10kw',11,'85','8525','852510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85251022','Apars.transm.de radio em fm, c/etapa saida valv.pot>30kw','Fm radium, with output stage, pot>10kw, transmis.appar.','Apars.de radiodifusión fm, c/etapa salida valv.pot>30kw',11,'85','8525','852510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85251029','Outros aparelhos transmissores de radiodifusão','Other transmission apparatus of radio-broadcasting','Los demás aparatos emisores de radiodifusión',11,'85','8525','852510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85251031','Aparelhos transmissores de televisão, frequência > 7ghz','Transmission apparatus of television, frequency>7ghz','Aparatos emisores de televisión, frecuencia>7ghz',11,'85','8525','852510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85251032','Apars.transm.de televisão, banda uhf 2/2.7ghz, 10w<p<100w','Transmis.appar.of televis., band uhf 2/2.7ghz, 10w<p<100w','Apars.emisores televisión, banda uhf 2/2.7ghz, 10w<p<100w',11,'85','8525','852510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85251033','Aparelhos transm.de televisão, banda UHF, pot>10kw','Transmis.appar.of television, band UHF, pot>10kw','Aparatos emisores de televisión, banda UHF, pot>10kw',11,'85','8525','852510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85251034','Aparelhos transm.de televisão, banda VHF, pot>=20kw','Transmis.appar.of television, band VHF, pot>=20kw','Aparatos emisores de televisión, banda VHF, pot>=20kw',11,'85','8525','852510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85251039','Outros aparelhos transmissores de televisão','Other transmission apparatus of television','Los demás aparatos emisores de televisión',11,'85','8525','852510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252011','Apars.transm/recep.de telecom.satelite, p/estacao terren','Transm.appar./recep.satellite telecom.f/station terres.','Apars.emis./recep.de telecom.satélite, p/estación terres',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252012','Apars.transm/recep.de telecom.satelite, p/estacao vsat','Transm.appar./recep.satellite telecom.f/stations vsat','Apars.emisores/recep.de telecom.satélite, p/estac.vsat',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252013','Apars.transm.digit.de voz/dados, oper.banda c, ku, l ou s','Digit.trans.appar.f/voice/data, oper.c, ku, l or s band','Apars.emisor.digit.de voz/datos, oper.banda c, ku, l o s',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252019','Outros aparelhos transmiss.recept.de telecom.satélite','Ot.transmission appar. inc.recep.of satellite telecom.','Los dem.aparatos emisores/recept.de telecom.satélite',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252021','Apars.transm/recep.de telefonia celular, p/estação base','Transmis.appar./recep.of cellul.telefhon.f/base station','Apars.emisor./recep.de telefonía celular, p/estac.base',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252022','Terminais portateis de telefonia celular','Portable apparatus of cellular telephonic','Terminales portátiles de telefonía celular',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252023','Terminais fixos de telefonia celular, s/fonte energia','Fixed appar.of cellul.teleph.without inter.power source','Terminales fijas de telefonía celular, s/fuente energía',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252024','Terminais moveis de telefonia celular, p/veic.automóveis','Portable apparatus of cellular teleph., f/motor vehicles','Terminales móviles de telefonía celular, p/vehíc.autom.',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252029','Outros aparelhos transmiss.recept.de telefonia celular','Oth.transmis.appar.recep.of cellulartelefhonic','Los dem.aparatos emisores/recept.de telefonía celular',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252030','Aparelhos transm/recep.do tipo modulador-demodulador','Transm.appar./recep.of type modems','Aparatos emisores/recep.del tipo modulador-demodulador',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252041','Aparelhos transm/recep.de radiodifusão','Transm.appar./recep.of radio-broadcasting','Aparatos emisores/recep.de radiodifusión',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252042','Aparelhos transm/recep.de televisão, frequência>7ghz','Transm.appar./recep.of television, frequency>7ghz','Aparatos emisores/recep.de televisión, frecuencia>7ghz',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252049','Outros aparelhos transmiss.recept.de televisão','Oth.transm.appar./recep.of television','Los demás aparatos emisores/recept.de televisión',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252051','Apars.transm/recep.de sistema troncal.p/estacao central','Transm.appar./recep.of trunking syst.f/switchboard','Apars.emis./recep.de sistema troncal.p/estación central',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252052','Terminais portateis de sistema troncalizado','Portable apparatus of trunking system','Terminales portátiles de sistema troncalizado',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252053','Terminais fixos de sistema troncalizado, s/fonte energia','Fixed appar.trunking system, without inter.power source','Terminales fijas de sist.troncalizado, s/fuente energía',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252054','Terminais moveis de sistema troncaliz.p/veic.automóveis','Portable apparatus trunking system, f/motor vehicles','Terminales móviles de sist.troncalizado, p/vehíc.autom.',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252059','Outs.aparelhos transmiss.recept.de sistema troncalizado','Other transm.appar./recep.of trunking system','Los dem.aparatos emisores/recept.de sistem.troncalizado',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252061','Aparelhos transm/recep.de radiotelef.analog.portat.etc.','Transm.appar./recep.of radio-teleph.anal.portable, etc.','Aparatos emisores/recep.de radiotelef.análog.portát.etc',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252062','Terminais fixos, analog.portat.monocanais p/radiotelef.','Fixed appar., analog.portabl.single-chan.f/radio-teleph.','Terminales fijas, análog.portát.monocanales p/radiotel.',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252063','Terminais móveis, analog.p/radiotelef.de veic.automóveis','Portab.appar., analog.f/radio-teleph.of motor vehicles','Terminales móviles, análog.p/radiotelef.de vehíc.autom.',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252069','Outs.aparelhos transmiss.recept.analog.p/radiotelef.etc','Oth.transmission appar.analog.recep.f/radio-teleph.etc','Los dem.aparatos emisor./recept.análog.p/radiotelef.etc',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252071','Apars.transm/recep.radiotelef.digit.f<15ghz, t<=8mbit/s','Transm.appar./recep.dig.radio-teleph.f<15ghz, t<=8mbit/s','Apars.emisor./recep.radiotelef.digit.f<15ghz, t<=8mbit/s',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252072','Apars.transm/recep.radiotelef.digit.f<15ghz, t<=34mbit/s','Transm.appar./recep.dig.radio-telep.f<15ghz, t<=34mbit/s','Apars.emisor/recep.radiotelef.digit.f<15ghz, t<=34mbit/s',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252073','Apars.p/estac.base sist.bidirec.radiomens.t<=112kbits/s','Appar.bidirectional radiop.base stations.t<=112kbits/s','Apars.p/estac.base sist.bidirec.radiomens.t<=112kbits/s',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252074','Terminais portat.sist.bidirec.radiomens.t<=112kbits/s','Portable appar.bidirec.radiopaging t<=112kbits/s','Terminales portát.sist.bidirec.radiomens.t<=112kbits/s',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252079','Outs.apars.transm/recep.radiotelef/telegr.digit.f<15ghz','Oth.transm.appar./radio-telep/digit.radioteleg.f<15ghz','Los dem.apars.emis./recep.radiotelef/telegr.dig.f<15ghz',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252080','Outs.aparelhos transmiss.recept.digit.p/radiotelef.etc.','Oth.transm.appar.digit.recep.f/radiotelegraphy, etc.','Los dem.aparatos emis.recept.digit.p/radiotelef.etc',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252081','Apars.transm/recep.radiotelef.digit.f<=23ghz, t<=8mbit/s','Transm.appar./recep.dig.radiotelep.f<=23ghz, t<=8mbit/s','Apars.emis./recep.radiotelef.digit.f<=23ghz, t<=8mbit/s',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252089','Outs.apars.transm/recep.radiotelef.radiotelegraf.digit.','Oth.transm.appar./radio-telep/digit.radiotelegraphy','Los dem.apars.emis./recep.radiotelef.radiotelegr.digit.',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85252090','Outs.apars.transmissores c/aparelho recept.incorporado','Oth.transmis.apparatus incorpor.reception apparatus','Los dem.apars.emisores c/aparato recept.incorporado',11,'85','8525','852520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85253010','Câmeras de televisão com 3 ou mais captadores de imagem','Television cameras with 3 or more image recorders','Cámaras de televisión c/3 o más captores de imagen',11,'85','8525','852530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85253020','Câmeras de televisão c/sensor imag.ccd, etc.ilum<0.20lux','Television cameras with image cdd type, etc.ilum<0.20lux','Cámaras de televis.c/sensor imag.ccd, etc.ilum<0.20lux',11,'85','8525','852530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85253030','Outs.câmaras tv, p/captar imagens no espectro infraverm.','Oth.television cameras f/capturing infrared spectrum','Las dem.cámaras tv, p/captar imag.en espectro infrarrojo',11,'85','8525','852530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85253090','Outras câmeras de televisão','Other television cameras','Otras cámaras de televisión',11,'85','8525','852530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85254000','Câmeras de video de imagens fixas e outs.cameras video','Still image video cameras and oth.video camera','Videocámaras de imágenes fijas y demás videocámaras',11,'85','8525','852540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85254010','Câmeras de video com tres ou mais captadores de imagem','Video camera with 3 or more image recorders','Videocámaras con tres o más captores de imagen',11,'85','8525','852540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85254020','Outs. câmaras video p/captar imagens no espectro infrav','Oth.video cameras f/capturing infrared spectrum','Las dem.videocámaras p/captar imág.en espect.infrarrojo',11,'85','8525','852540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85254090','Outras câmeras de vídeo','Other video cameras','Las demás videocámaras',11,'85','8525','852540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85255011','Aparelho de radiofusão em AM','Apparatus for broadcasting on AM','Aparato para la radiodifusión en AM',11,'85','8525','852550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85255012','Aparelho de radiodifusão em FM','Apparatus for broadcasting on FM','Aparato para la radiodifusión en FM',11,'85','8525','852550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85255019','Outs.apar.transmissão p/radiodifusão','Other transm. appar./equip. for radio-broadcasting ','Otros apar.transm. p/ radiodifusión',11,'85','8525','852550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85255021','Aparelho de televisão c/freqüência >7ghz','Appar. of television, with freq.>7ghz ','Apar.de televisión c/ freq.>7ghz',11,'85','8525','852550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85255022','Ap.d/telev.banda uhf, 2.0 a 2.7ghz, pot.10 a 100w','Appar. of telev., uhf band, 2.0 to 2.7 ghz, pot. 10 to 100w','Apar. de telev., banda uhf, 2.0 a 2.7 ghz, pot. 10 a 100w',11,'85','8525','852550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85255023','Apar.d/telev.banda uhf, pot.de saída >10kw','Appar. of telev., uhf band, output pot.>10kw ','Apar. de telev., banda uhf, pot. de salida>10kw',11,'85','8525','852550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85255024','Apar.d/telev.banda uhf, pot.de saída >= 20kw','Appar. of telev., uhf band, output pot.>=20kw ','Apar. de telev., banda uhf, pot. de salida>=20kw',11,'85','8525','852550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85255029','Outros aparelhos transmissores de televisão','Other television transmitter apparatus','Otros apar. transm. de televisión',11,'85','8525','852550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85256010','Apar.transmissor/receptor d/radiodifusão','Transm./recept.appar. of radio-broadcasting','Apar. transm./recept. de radiodifusión',11,'85','8525','852560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85256020','Apar.transm./recep.d/televisão, freq.>7ghz','Transm./recept.appar. of television, freq.>7ghz','Apar. transm./recept. de televisión, freq.>7ghz',11,'85','8525','852560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85256090','Outros apars.transmiss.c/receptor de tv','Other transm.appar.with recept. of telev.','Otros apar. transm. on recept. de telev.',11,'85','8525','852560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85258011','Câmeras TV com três ou mais captadores de imagem','TV cameras with 3 or more image pickups (captivators)','Cámaras de TV c/ 3 o + captadores de imagen ',11,'85','8525','852580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85258012','Câmeras TV, c/sens.imag.ccd.etc.ilum.<0, 20lux','Tv cameras with ccd imag. sensor, etc. light.< 0, 20 lux','Cámaras de TV, c/sens.imag.ccd, etc. ilum.< 0,20 lux',11,'85','8525','852580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85258013','Outs.câmeras TV, p/imags.no espectro infrav.','Other tv cameras, for imag. within infrav. spectr.','Otras cámarasde tv, p/ imag. no espectro infrarrojo',11,'85','8525','852580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85258019','Outras câmeras de televisão','Other television cameras','Otras cámaras de televisión',11,'85','8525','852580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85258021','Câms.d/vídeo d/imags.fixas c/ 3 ou+cap.imags.','Fix. imag. video camera with 3 or more imag. pickup (captivators) ','Cámaras de video de imag.fija c/ 3 o + cap. imag. ',11,'85','8525','852580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85258022','Outs.câmeras vídeo/imags.n/espectro infrav.','Other video cameras, for imag. within infrav. spectr.','Otras cámaras de video, p/ imag. no espectro infrarrojo',11,'85','8525','852580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85258029','Outs.câmeras de vídeo de imagens fixas','Other video cameras of fixed images','Otras video cámaras de imágenes fijas',11,'85','8525','852580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85261000','Aparelhos de radiodeteccao e de radiossondagem (radar)','Radar apparatus','Aparatos de radiodetección y radiosondeo (radar)',11,'85','8526','852610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85269100','Aparelhos de radionavegação','Radio navigational apparatus','Aparatos de radionavegación',11,'85','8526','852691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85269200','Aparelhos de radiotelecomando','Radio remote control apparatus','Aparatos de radiotelemando',11,'85','8526','852692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85271200','Rádio toca-fitas (rádio-cassete), de bolso','Pocket-size radio cassette-players','Radiocasetes de bolsillo',11,'85','8527','852712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85271310','Outs.apars.recept.radiodif.comb.toca-fitas, pilha/eletr.','Oth.recep.appar.radio-broad.comb.cass.players, pile/elec','Los dem.apars.recept.radiodif.comb.repr.cint.pila/eléc.',11,'85','8527','852713');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85271320','Apars.recept.rádio comb.toca-fitas/grav.a pilha/eletr.','Oth.recep.appar.radio comb.cass.players/recor.pile/elec','Apars.recept.radio comb.c/repr.cinta/grab.,  pila/eléctr',11,'85','8527','852713');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85271330','Apars.recept.rádio comb.toca-discos/fitas/grav.a pilha, ','Recep.appar.radio comb.cass.players/casset.recor.pile, ','Apars.recept.radio comb.repr./grab.cintas, giradisc.pila',11,'85','8527','852713');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85271390','Outs.apars.recept.radiodif.comb.apars.som, pilha/eletr.','Oth.recep.appar.radio-broad.comb.sound appar., pile/elec','Los dem.apars.recept.radiodif.comb.apars.son.pila/eléc.',11,'85','8527','852713');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85271910','Aparelhos recept.de rádio c/relógio, a pilha/eletricid.','Recep.appar.of radio with clock, by pile/electricity','Aparatos recept.de radio c/reloj, a pila/electricid.',11,'85','8527','852719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85271990','Outros aparelhos recept.de radiodif.a pilha/eletr.etc.','Oth.recep.appar.radio-broadcasting  by pile/electr.etc.','Los dem.aparatos recept.de radiodif.a pila/electr.etc',11,'85','8527','852719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85272110','Apars.recept.de radio c/toca-fitas, p/veics.automóveis','Recep.appar.radio casset.players, f/motor vehicles','Apars.recept.de radio c/repr.cintas, p/vehícs.automóv.',11,'85','8527','852721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85272190','Outs.apars.recep.radiodif.c/apars.som, p/veic.automóveis','Ot.recep.appar.radio-br.with sound appar.f/motor vehic.','Los dem.apars.recep.radiodif.c/apars.son.p/vehíc.autom.',11,'85','8527','852721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85272900','Outs.aparelhos recept.de radiodif.p/veic.automóveis, etc','Oth.recep.appar.radio-broadcasting f/motor vehicles, etc','Los dem.aparatos recept.de radiodif.p/vehíc.autom., etc',11,'85','8527','852729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85273110','Outros aparelhos recep.radiodif.c/toca-fitas e gravador','Oth.recep.appar.radio-br.with casset.players/recorded','Los dem.apars.recep.radiodif.c/repr.cintas y grabador',11,'85','8527','852731');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85273120','Outs.apars.recep.radiodif.c/toca-discos/fitas/gravador','Oth.recep.appar.radio-br.with cass.players/cass./recor.','Los dem.apars.recep.radiodif.c/giradisc/cintas/grabador',11,'85','8527','852731');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85273190','Outs.apars.recept.de radiodif.c/apars.grav/reprod.som','Oth.recep.appar.radio-br.with recor.appar./sound reprod','Los dem.apars.recept.de radiodif.c/apars.grab/repr.son.',11,'85','8527','852731');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85273200','Aparelhos recept.de radio c/relógio, a eletricidade','Recep.appar.of radio with clock, by electricity','Aparatos recept.de radio c/reloj, a electricidad',11,'85','8527','852732');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85273910','Amplificador com sintonizador (receiver)','Tuning amplifiers (receiver)','Amplificador con sintonizador (receiver)',11,'85','8527','852739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85273990','Outros aparelhos recept.de radiodif.etc.','Oth.reception apparatus for radio-broadcasting, etc.','Los demás aparatos recept.de radiodif.etc',11,'85','8527','852739');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85279011','Apars.recept.pessoais de radimensagem em tela ("ecran")','Reception appar.personal of radium-mes.in screen(ecran)','Apars.recept.personales de radimens.en pantalla(ecran)',11,'85','8527','852790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85279019','Outros aparelhos recept.pessoais de radiomensagens','Other reception appar.personal of radium-message','Los dem.aparatos recept.personales de radiomensajes',11,'85','8527','852790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85279090','Outs.apars.recep.radiotelef/radiotelegraf/radiodif.etc.','Ot.recep.app.radio-telep./radio-telegr./radio-broad.etc','Los dem.apars.recep.radiotelef/radiotelegr/radiodif.etc',11,'85','8527','852790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85279110','Outs.ap.rec.radiodif.comb.c/t-fitas e gravad.','Other radio-broad.recep.appar/equip. comb. with cass.play. and rec.','Otros apar.recep.radiodif.comb.c/ toca-casete y grab.',11,'85','8527','852791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85279120','Outs.ap.rec.radiodif-comb.c/t-fitas/disc, grav.','Other radio-broad.recep.appar/equip. comb. with disc./cass.play. and rec.','Otros apar.recep.radiodif.comb.c/ toca-casete/disc. y grab.',11,'85','8527','852791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85279190','Outs.ap.rec.comb.ap.grav./reprod.de som','Other recep.appar.comb.with appar. sound. reprod./grab.','Otros apar. recep.comb. apar.grab./reprod. de son.',11,'85','8527','852791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85279200','Outs.rec.ñ com.c/ap.grav/rep, comb.c/relógio','Other no commerc.recep.with rep./rec.apar/equip., comb. with clock','Otros rec. no com.c/apar. grab./rep., comb.c/ reloj',11,'85','8527','852792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85279910','Amplificador com sintonizador ("receiver")','Tuning amplifiers (receiver)','Amplificador con sintonizador (receiver)',11,'85','8527','852799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85279990','Outs.ap.recp.radiodif.c/radiotel.-radioteleg.','Other radio-broad.recep.appar./equip. with radiotel./radioteleg.','Otros apar.recep.radiodif. c/radiotel/radioteleg.',11,'85','8527','852799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85281210','Receptor-decodif.integr.sinais digit.video codif.cores','Integ.receiver-decoder of dig.signs codif.videos colour','Receptor-decod.integr.señales digit.video codif.colores',11,'85','8528','852812');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85281211','Receptor-decodif.integr.s/saida radiofreq.c/saida audio','Integr.receiv.-decod.without exit radio-freq.audio exit','Receptor-decodif.integr.s/salid.radiofrec.c/salid.audio',11,'85','8528','852812');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85281219','Outs.receptor-decodif.integr.sinais dig.video cod.cores','Oth.integ.receiver-decod.of dig.signs cod.videos colour','Los dem.receptor-decod.integ.señ.dig.video cod.colores',11,'85','8528','852812');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85281290','Outs.apars.recep.televisão cores, mesmo c/apars.som/imag','Oth.recep.appar.f/col.telev.incl.sound/image apparatus','Los dem.apars.recep.televis.cores, incl.c/apars.son/imag',11,'85','8528','852812');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85281300','Apars.recept.de tv em preto/branco, mesmo c/radio, etc.','Recep.appar.f/blakc/white telev.incl.radio, etc.','Apars.recept.de tv en blanco/negro, incl.c/radio, etc',11,'85','8528','852813');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85282100','Monitores de video, a cores','Video monitors, colour','Videomonitores, en colores',11,'85','8528','852821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85282110','Monitores de video, em cores, c/disposit.de varredura, etc','Video monit., colour, with sweeping disposit.etc','Videomonitores, en colores, c/disp.de selec.barrido, etc',11,'85','8528','852821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85282190','Outros monitores de video, em cores','Other video monitors, colour','Los demás videomonitores, en colores',11,'85','8528','852821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85282200','Monitores de video, em preto e branco ou outs.monocromos','Video monitors, black and white or oth.monochrome','Videomonitores, en blanco y negro o demás monocromos',11,'85','8528','852822');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85283000','Projetores de vídeo','Video projectors','Proyectores de video',11,'85','8528','852830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85284110','Unid.d/saída p/vídeo, c/tubo raios catód.mon.','Output unit for video, with monocr. crt (cathode ray tube)','Unid. de salida p/video, c/ tubo de rayos catód. monocr.',11,'85','8528','852841');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85284120','Unid.d/saída p/vídeo, c/tubo raios cat/policr.','Output unit for video, with policr. crt (cathode ray tube)','Unid. de salida p/video, c/ tubo de rayos catód. policr.',11,'85','8528','852841');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85284910','Monitores c/tubo d/raios catód. monocromáticos.','Monitors with monocr. crt (cathode ray tube)','Monitores c/ tubo de rayos catód.monocr.',11,'85','8528','852849');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85284921','Monitores de vídeo, cores, c/sel.varredura','Video monitors, colour, with sweep selec.','Videomonitores, en colores, c/ selec.de barredura',11,'85','8528','852849');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85284929','Monitores c/tubo d/raios catód. policromáticos','Monitors with policr. crt (cathode ray tube)','Monitores c/ tubo de rayos catód.policr.',11,'85','8528','852849');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85285110','Outs.monit.utiliz.excl.c/1máq.aut.d/pos.84.71, monocromá','Other monit. used exclusively. with auto. machin. of  84.71 posi., monocr.','Otros monit.utiliz.excl.c/máq.aut.de posi.8471, monocr.',11,'85','8528','852851');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85285120','Outs.monit.utiliz.excl.c/1máq.aut.d/pos.84.71, policromá','Other monit. used exclusively. with auto. machin. of  84.71 posi., policr.','Otros monit.utiliz.excl.c/máq.aut.de posi.8471, policr.',11,'85','8528','852851');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85285129','Outras unidades de saida por video,  policromaticas','Other video output unit, policr.','Otras unid.de salida por vídeo, policr.',11,'85','8528','852851');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85285910','Outros monitores monocromáticos','Other monochrome monitors','Otros monitores monocromáticos',11,'85','8528','852859');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85285920','Outros monitores policromáticos','Other monitors polychromatic','Otros monitores policromáticos',11,'85','8528','852859');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85286100','Outs.unids.d/entr./saída, p/máqs.proc.dados','Other input/output units for data proc.mach.','Otras unid. de entr./salida, p/máq.proc.datos',11,'85','8528','852861');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85286900','Outros projetores de vídeo','Other vídeo projectors','Otros proyectores de video',11,'85','8528','852869');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85286910','Com tecnologia de dispositivo digital microespelhos-dmd','With technology dmd (digital micromirror device)','Con tecnología dmd (digital micromirror device)',11,'85','8528','852869');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85286990','Outros projetores','Other projectors','Otros proyectores',11,'85','8528','852869');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85287111','Rec.dec.integ., s/saída radiofr.c/saída áudio','Other integ.dec.rec., without radiofreq.output, with audio input ','Rec.dec.integ.,sin salida radiofreq. c/salida de áudio',11,'85','8528','852871');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85287119','Outs.rec.dec.integ.sin.dig.d/vídeo cod., cores','Other dig.sign integr.rec.dec. of cod. video, colour','Otros rec.dec.integ.señal dig.d/vídeo cod., en colores',11,'85','8528','852871');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85287190','Outs.apar.rec.d/telev.mm.comb.c/outs.cores','Other rec. appar.of mm telev.comb. with other colour','Otros apar. rec. de telev.mm. comb. c/ otras en colores ',11,'85','8528','852871');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85287200','Outros apar.rec.d/telev. em cores','Other rec. appar./equip.of telev., colour','Otros apar. rec. de telev.en colores',11,'85','8528','852872');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85287300','Outs.apar. rec.d/tv.preto/branco/monocromos','Other monocr./black & white/ tv rec. appar./equip.','Otros apar. rec. de tv negro/blanco/monocr.',11,'85','8528','852873');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85291011','Antenas com refletor parabolico, exc.p/telefone celular','Aerials with parabolic reflectors, exc.f/phone cellular','Antenas con reflector parabólico, exc.p/teléfono celular',11,'85','8529','852910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85291019','Outras antenas, exceto para telefones celulares','Other aerials, except for phone cellular','Las demás antenas, excepto para teléfonos celulares',11,'85','8529','852910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85291020','Antenas p/telefones celulares portat.exc.telescópicas','Aerials for cellular phone portable, exc.telescopic','Antenas p/teléfonos celulares portát.exc.telescópicas',11,'85','8529','852910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85291090','Outras antenas e refletores de antenas, e suas partes','Other aerials and aerial reflectors, its parts','Las dem.antenas y reflectores de antenas, y sus partes',10,'85','8529','852910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85299011','Gabinetes e bastidores p/aparelhos transmissores/recept','Cabinets and framework f/transmis./receivers apparatus','Gabinetes y bastidores p/aparatos emisores/recept',10,'85','8529','852990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85299012','Circuito impresso montado p/aparelhos transmiss.recept.','Cabinets and framework f/transmis./receivers apparatus','Circuito impreso montado p/aparatos emisores/recept.',11,'85','8529','852990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85299019','Outras partes p/aparelhos transmissores/receptores','Other parts f/transmission/receivers apparatus','Las demás partes p/aparatos emisores/receptores',10,'85','8529','852990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85299020','Outs.partes p/aparelhos recept.radiodif.televisão, etc.','Other parts receivers apparatus radio-broad.televis.etc','Las dem.partes p/aparatos recept.radiodif.telev.etc',10,'85','8529','852990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85299030','Outs.partes p/aparelhos radiodeteccao e radiossondagem','Oth.parts f/radar apparatus','Las dem.partes p/aparatos radiodetección y radiosondeo',10,'85','8529','852990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85299040','Outras partes p/aparelhos radionavegação','Other parts for radio navigational apparatus','Las demás partes p/aparatos radionavegación',10,'85','8529','852990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85299090','Outs.partes p/apars.radiotelecomando/cameras tv/video','Oth.parts f/radio remote control appar/tv cameras/video','Las dem.partes p/apars.radiotelemando/cámaras tv/video',10,'85','8529','852990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85301010','Apars.eletr.digit.p/controle de trafego de vias férreas','Digital elec.appar.f/control of railways traffic','Apars.eléctr.digit.p/control de tráfico de vías férreas',11,'85','8530','853010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85301090','Outs.aparelhos eletr.de sinalização, etc.p/vias férreas','Oth.electrical signalling appar.etc.for railways','Los dem.aparatos eléctr.de señaliz., etc.p/vías férreas',11,'85','8530','853010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85308010','Apars.eletr.digit.p/controle de trafego de automotores','Digital elec.appar.f/control of self-driven traffic','Apars.eléctr.digit.p/control de tráfico de automotores',11,'85','8530','853080');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85308090','Outs.apars.eletr.sinalização, etc.p/vias terrestres, etc.','Oth.electrical signalling appar.etc.f/terrest.roads, etc','Los dem.apars.eléctr.señaliz.etc.p/vías terrestres, etc',11,'85','8530','853080');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85309000','Partes de apars.eletr.de sinaliz.etc.p/vias férreas, etc','Parts of electrical signalling appar.etc.f/railways, etc','Partes de apars.eléct.de señaliz.etc.p/vías férreas, etc',10,'85','8530','853090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85311010','Alarmes contra incêndio ou sobreaquecimento','Fire-alarms and overheating alarms','Alarmas contra incendio o sobrecalentamiento',11,'85','8531','853110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85311090','Outs.aparelhos eletr.de alarme, p/proteção contra roubo','Other electric alarms, f/protect.against robbery','Los dem.avisad.eléctr.de protección contra roubo',11,'85','8531','853110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85312000','Paineis indicad.c/disp.cristais liq/diodos emiss.luz','Indicator panels incor.liquid crystal/light emit.diodes','Tableros indicad.c/disp.cristal líq/diodos emis.luz',11,'85','8531','853120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85318000','Outros aparelhos eletr.de sinalização acustica/visual','Other electric sound or visual signalling apparatus','Los demás apars.eléctr.de señalización acústica/visual',11,'85','8531','853180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85319000','Partes de aparelhos eletr.de sinaliz.acustica/visual','Parts of electric sound or visual signalling apparatus','Partes de apars.eléctr.de señalización acústica/visual',10,'85','8531','853190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85321000','Condensador fixo p/linha eletr.50/60hz, pot>=0.5kvar','Fixed capacitors, f/elect.line 50/60hz, pot>=0.5kvar','Condensador fijo conc.p/rede eléct.50/60hz, pot>=0.5kvar',11,'85','8532','853210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85322110','Condensador fixo eletr.de tântalo, p/montag.em superf','Elect.capacit., fixed of tantalus, f/surf.mounted device','Condensador fijo eléctr.de tántalo, p/montaj.en superf',11,'85','8532','853221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85322111','Condensador fixo eletr.de tântalo, montag.superf.t<=125v','Electr.capacit., fixed of tantalus, surf.moun.dev.t<=125v','Condensador fijo eléct.de tántalo, montaj.superf.t<=125v',11,'85','8532','853221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85322119','Outs.condensad.fixos eletr.de tântalo, p/montag.superf.','Oth.elec.capacit., fixed of tantalus, f/surf.mount.device','Los dem.condensad.fijos eléct.de tántalo, mont.superf.',11,'85','8532','853221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85322190','Outros condensadores fixos eletr.de tântalo','Other electrical capacitors, fixed of tantalus','Los demás condensadores fijos eléctr.de tántalo',11,'85','8532','853221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85322200','Condensador fixo eletrolítico, de alumínio','Electrolytic fixed capacitors, of aluminium','Condensador fijo electrolítico, de aluminio',11,'85','8532','853222');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85322310','Condensador fixo c/dieletr.ceram.1 camada, montag.superf','Fixed capacitors with ceram.diel.single layer, surf.moun','Condensador fijo c/dieléct.cerám.c/1sola capa, mont.sup.',11,'85','8532','853223');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85322390','Outros condensadores fixos c/dieletr.ceram.1 camada','Oth.fixed capacitors with ceram.diel.single layer','Los dem.condensadores fijos c/dieléctr.cerám.1sola capa',11,'85','8532','853223');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85322410','Outs.condensadores fixos c/dieletr.ceram.montag.superf.','Oth.fixed capacit.with ceram.diel.surf.moun.device','Los dem.condensad.fijos c/dieléctr.cerám.mont.superf.',11,'85','8532','853224');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85322490','Outros condensadores fixos c/dieletr.ceram.','Oth.fixed capacitors with ceram.dielectric','Los demás condensadores fijos c/dieléctr.cerám.',11,'85','8532','853224');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85322510','Condensador fixo c/dieletr.papel/plast.p/montag.superf.','Fixed capacit.with diel.paper/plast.f/surf.moun.device','Condensador fixo c/dieléctr.papel/plást.p/mont.superf.',11,'85','8532','853225');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85322590','Outros condensadores fixos c/dieletr.papel/plast.','Other fixed capacit.with dielec.paper/plastic','Los demás condensadores fijos c/dieléctr.papel/plást.',11,'85','8532','853225');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85322910','Outros condensadores fixos eletr.p/montag.em superf.','Oth.elec.capacitors, fixed, f/surf.moun.device','Los dem.condensadores fijos eléctr.p/montaj.en superf.',11,'85','8532','853229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85322990','Outros condensadores fixos elétricos','Other electrical capacitors, fixed','Los demás condensadores fijos eléctricos',11,'85','8532','853229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85323010','Condensadores variaveis/ajustav.eletr.p/montag.superf.','Electr.capacit., variable/adjustable f/surf.moun.device','Condensadores variables/ajustab.eléctr.p/montaj.superf.',11,'85','8532','853230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85323090','Outros condensadores variaveis/ajustav.eletr.','Other electrical capacitors, variable/adjustable','Los demás condensadores variables/ajustab.eléctr.',11,'85','8532','853230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85329000','Partes de condensadores eletr.fixos/variaveis/ajustav.','Parts of electric.capacitors, fixed/variable/adjustable','Partes de condensadores eléctr.fijos/variables/ajustab.',10,'85','8532','853290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85331000','Resistências eletr.fixas, de carbono, aglomeradas/camada','Electrical resistors, fixed, carbon, agglom./layers','Resistencias eléctr.fijas, de carbono, aglomeradas/capa',11,'85','8533','853310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85332110','Resistências elétricas fixas, p/pot<=20w, de fio','Electrical resistors, fixed, f/pot<=20w, of thread','Resistencias eléctricas fijas, p/pot<=20w, de alambre',11,'85','8533','853321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85332120','Resistências eletr.fixas, p/pot<=20w, p/montag.em superf.','Electric.resistors, fixed, f/pot<=20w, f/surf.moun.device','Resistencias eléctr.fijas, p/pot<=20w, p/mont.en superf.',11,'85','8533','853321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85332190','Outras resistências elétricas fixas, para pot<=20w','Other electric.resistors, fixed, f/pot<=20w','Las demás resistencias eléctricas fijas, p/pot<=20w',11,'85','8533','853321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85332900','Outras resistências elétricas fixas','Other electric.resistors, fixed','Las demás resistencias eléctricas fijas',11,'85','8533','853329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85333110','Potenciômetros para potência <= 20w','Potentiometers for potencyu <= 20w','Potenciómetros para potencia <= 20w',11,'85','8533','853331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85333190','Outs.resistências eletr.variaveis bobinadas p/pot<=20w','Oth.wirewound variable resistors(electrical)/pot<=20w','Las dem.resistencias eléctr.variab.bobinadas p/pot<=20w',11,'85','8533','853331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85333910','Outros potenciômetros','Other potentiometers','Los demás potenciómetros',11,'85','8533','853339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85333990','Outras resistências elétricas variáveis bobinadas','Other wirewound variable resistors (electrical)','Las demás resistencias eléctricas variables bobinadas',11,'85','8533','853339');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85334011','Termistores','Thermistors','Termistores',11,'85','8533','853340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85334012','Varistores','Varistors','Varistores',11,'85','8533','853340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85334019','Outras resistências eletr.variav.n/lineares semicondut.','Oth.electric.resistors, variable, n/lineal semiconductors','Las dem.resistencias eléctr.variab.n/lineales semicond.',11,'85','8533','853340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85334091','Potenciômetro de carvão, util.sistema inj.de combustív.','Potentiom.of coal, used in system of fuel injection','Potenciómetro de carbón, util.sistema iny.de combustib.',11,'85','8533','853340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85334092','Outros potenciômetros de carvão','Other potentiometers of coal','Los demás potenciómetros de carbón',11,'85','8533','853340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85334099','Outras resistências elétricas variaveis','Other electrical resistors, variable','Las demás resistencias eléctricas variables',11,'85','8533','853340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85339000','Partes de resistências elétricas','Parts of electrical resistors','Partes de resistencias eléctricas',10,'85','8533','853390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85340000','Circuito impresso','Printed circuits','Circuito impreso',11,'85','8534','853400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85340011','Ci simples face rig.c/isolante res.fenol./papel celulos','Ci simples face rig.c/isolante res.fenol./papel celulos','Ci simples face rig.c/isolante res.fenol./papel celulos',11,'85','8534','853400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85340012','Ci simples face rig.c/isolante res.epoxi./papel celulos','Ci simples face rig.c/isolante res.epoxi./papel celulos','Ci simples face rig.c/isolante res.epoxi./papel celulos',11,'85','8534','853400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85340013','Ci simples face rig.c/isolante res.expox./tec.fib.vidro','Ci simples face rig.c/isolante res.expox./tec.fib.vidro','Ci simples face rig.c/isolante res.expox./tec.fib.vidro',11,'85','8534','853400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85340019','Outros ci simples face rigidos','Other integrated circuits single face, hard','Demás cis de disco duro de una sola cara',11,'85','8534','853400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85340020','Ci simples face flexíveis','Integrated circuit single-sided, flexible','Circuitos integrados de una sola cara, flexibles',11,'85','8534','853400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85340031','Ci dupla face rig.c/isolante res.fenol./papel celulos','Ci dupla face rig.c/isolante res.fenol./papel celulos','Ci dupla face rig.c/isolante res.fenol./papel celulos',11,'85','8534','853400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85340032','Ci dupla face rig.c/isolante res.epoxi./papel celulos','Ci dupla face rig.c/isolante res.epoxi./papel celulos','Ci dupla face rig.c/isolante res.epoxi./papel celulos',11,'85','8534','853400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85340033','Ci dupla face rig.c/isolante res.epoxi./tec.fib.vidro','Ci dupla face rig.c/isolante res.epoxi./tec.fib.vidro','Ci dupla face rig.c/isolante res.epoxi./tec.fib.vidro',11,'85','8534','853400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85340039','Outros CI dubla face rigidos','Other integrated circuits of double-sided, rigid','Otros circuitos integrados de doble cara, rígidos',11,'85','8534','853400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85340040','CI dupla face flexiveis','Integrated circuit double face, flexible','Circuito integrado de doble cara, flexibles',11,'85','8534','853400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85340051','Ci multicamada c/ isolante res.epoxida/tec fibra vidro','Ci multicamada c/ isolante res.epoxida/tec fibra vidro','Ci multicamada c/ isolante res.epoxida/tec fibra vidro',11,'85','8534','853400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85340059','Outros cis multicamada','Other multilayer integrated circuit','Otros circuitos integrados multicapa',11,'85','8534','853400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85351000','Fusiveis/corta-circuito de fusiveis, p/tensao>1000 volts','Fuses/cut-circuit of fuses, f/tension>1000volts','Fusibles/cortacircuito de fusible, p/tensión>1000voltios',11,'85','8535','853510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85352100','Disjuntores, p/tensao sup.1 kv e inferior a 72, 5 kv','Autom.circ.break.f/tens.sup.1 kv and less than 72, 5 kv','Disyuntores, p/tensión sup.1 kv y inferior a 72, 5 kv',11,'85','8535','853521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85352900','Outros disjuntores p/tensao igual ou superior a 72, 5 kv','Oth.autom.circ.break.f/tension equal or super.72, 5 kv','Los dem.disyuntores p/tensión igual o super.a 72, 5 kv',11,'85','8535','853529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85353011','Seccionadores/interrupt.t>1kv, corrente<=1600a, n/automat','Isol.swit./make-and-break sw.t>1kv, current<=1600a, n/aut','Seccionadores/interrupt.t>1kv, corriente<=1600a, n/autom.',11,'85','8535','853530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85353012','Seccionadores/interrupt.t>1kv, corrente<=1600a, automat.','Isol.swit./make-and-break sw.t>1kv, current<=1600a, aut','Seccionadores/interrupt.t>1kv, corriente<=1600a, automát.',11,'85','8535','853530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85353013','Interrup.vácuo s/disp.acionamento automático <=1600a','Vacuum swifts without autom. activ. device <=1600a','Interrupt.vacío s/disp. de activación autom. <=1600a',11,'85','8535','853530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85353017','Outros interrup c/disp.acionam. nao automático <=1600a','Other swifts with no autom. activ. device <=1600a','Otros interrup.c/disp. de activación autom.<=1600a',11,'85','8535','853530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85353018','Outros interrup, exc.cont.imersos m/liq. <=1600a','Other swifts , except.contain. submerg. in liquid<=1600a','Otros interrupt.except.conten. submerg. en el líquido <=1600a  ',11,'85','8535','853530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85353019','Outs.seccionadores/interruptores, t>1kv, corrente<=1600a','Ot.isol.swit./make-and-break sw.t>1kv, current<=1600a','Los dem.seccionadores/interrupt.t>1kv, corriente<=1600a',11,'85','8535','853530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85353021','Seccionadores/interrupt.t>1kv, corrente>1600a, n/automat.','Isol.swit./make-and-break sw.t>1kvcurrent>1600a, n/aut','Seccionadores/interrupt.t>1kv, corriente>1600a, n/autom.',11,'85','8535','853530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85353022','Seccionadores/interrupt.t>1kv, corrente>1600a, automat.','Isol.swit./make-and-break sw.t>1kv, current>1600a, aut','Seccionadores/interrupt.t>1kv, corriente>1600a, automát.',11,'85','8535','853530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85353023','Interrup.vácuo s/disp.acionamento automático >1600a','Vacuum swifts without autom. activ. device >1600a','Interrupt.vacío s/disp. de activación autom. >1600a',11,'85','8535','853530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85353027','Outros interrup.c/disp.acionam.nao aut. >1600a','Other swifts with no autom. activ. device >1600a','Otros interrup.c/disp. de activación autom.>1600a',11,'85','8535','853530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85353028','Outros interrup., exceto cont.imersos m/lig >1600a','Other swifts , except.contain. submerg. in liquid>1600a','Otros interrupt.except.conten. submerg. en el líquido >1600a  ',11,'85','8535','853530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85353029','Outros seccionadores/interruptores, t>1kv, corrente>1600a','Ot.isol.swit./make-and-break sw.t>1kv, current>1600a','Los dem.seccionadores/interrupt.t>1kv, corriente>1600a',11,'85','8535','853530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85354010','Pára-raios p/prot.linhas transmiss.eletricidade, t>1kv','Lightning arres.f/protec.elec.transm.lines, t>1kv','Pararrayos p/prot.líneas transmis.electricidad, t>1kv',11,'85','8535','853540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85354090','Limitadores de tensao/eliminadores de onda eletr.t>1kv','Voltage limiters/surge suppressors electr.t>1kv','Limitadores de tensión/supres.de sobretens.trans.t>1kv',11,'85','8535','853540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85359000','Outs.apars.p/interrupcao, etc.de circuitos eletr.t>1kv','Oth.appar.f/interruption, etc.of electric circuits t>1kv','Los dem.apars.p/interrup., etc.de circuitos eléctr.t>1kv',11,'85','8535','853590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85361000','Fusíveis e corta-circuitos de fusíveis, p/tensão<=1kv','Fuses and cut-cicuits of fuses, f/tension<=1kv','Fusibles y cortacircuitos de fusibles, p/tensión<=1kv',11,'85','8536','853610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85362000','Disjuntores p/tensao<=1kv','Automatic circuit breakers f/tension<=1kv','Disyuntores p/tensión<=1kv',11,'85','8536','853620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85363000','Outs.apars.p/proteção de circuitos eletr.p/tensao<=1kv','Other apparatus f/protec.electr.circuits f/tension<=1kv','Los dem.apars.p/protec.de circuitos eléctr.p/tens.<=1kv',11,'85','8536','853630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85364100','Reles para tensão <= 60volts','Relays for tension <= 60volts','Réles para una tensión <=60 voltios',11,'85','8536','853641');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85364900','Outros reles, 60volts<tensao<=1000volts','Other relays, 60volts<tension<=1000volts','Los demás réles, 60volts<tensión<=1000voltios',11,'85','8536','853649');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85365010','Unidade chavead.de conversor p/telecom.satelite, t<=1kv','Switching units converters f/satel.telec.system, t<=1kv','Unidad conmutadora de convers.p/telecom.satélite, t<=1kv',11,'85','8536','853650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85365020','Unidade chavead.de amplif.hpa p/telecom.satelite, t<=1kv','High-power amplifier switc.units f/satel.telecom.t<=1kv','Unidad conmutadora de amplif.hpa p/telecom.satél.t<=1kv',11,'85','8536','853650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85365030','Comutadores codificad.digitais, p/montag.circuit.impress','Digital encoder-switches, f/mounting in printed circuit','Conmutadores codificad.digitales, p/mont.circuit.impreso',11,'85','8536','853650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85365090','Outs.interruptores, etc.de circuitos eletr.p/tensao<=1kv','Other switches, etc.of electrical circuit f/tens.<=1kv','Los dem.interruptores, etc.de circuit.eléct.p/tens.<=1kv',11,'85','8536','853650');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85366100','Suporte para lâmpadas, para tensão <= 1 Kv','Lamp-holders, for tension <= 1 Kv','Portalámparas, para tensión <= 1 Kv',11,'85','8536','853661');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85366910','Tomada polarizada e tomada blindada, para tensão <=1kv','Sockets, polarized and armoured, for tension<=1kv','Tomacorrientes polarizados o blindados, p/tensión<=1kv',11,'85','8536','853669');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85366990','Outras tomadas de corrente, para tensão <= 1 Kv','Other socket of current, for tension <= 1 Kv','Los demás tomacorrientes, para tensión <= 1kv',11,'85','8536','853669');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85367000','Conectores feixes ou cabos de fibra óptica','Connectors of bunches or cables of optic fibers ','Conectores de haz o cable de fibras ópticas',11,'85','8536','853670');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85369010','Conectores p/cabos planos de condutor paralelo, t<=1kv','Connectors f/flat cables parallel conductors, t<=1kv','Conectores p/cables planos de conductor paralelo, t<=1kv',11,'85','8536','853690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85369020','Tomadas de contato deslizante em condutor aéreo, t<=1kv','Sliding sockets for aerial conductors, t<=1kv','Tomas de contacto deslizante en conductor aéreo, t<=1kv',11,'85','8536','853690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85369030','Soquetes p/microestruturas eletrônicas, p/tensão<=1kv','Sockets f/electronic microstructures,f/tension<=1kv','Zócalos p/microestructuras electrónicas, p/tensión<=1kv',11,'85','8536','853690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85369040','Conectores para circuito impresso, para tensão <= 1 Kv','Connectors for printed circuits,f/tension<=1kv','Conectores p/circuito impreso, p/tensión<=1kv',11,'85','8536','853690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85369050','Terminais de conexão p/capacitor, mesmo mont.sup.isol.','Connectors for printed circuits,incl.mount.insul.backin','Terminales de conexión p/capacitor, incl.mont.sup.isol.',11,'85','8536','853690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85369090','Outs.apars.p/interrupcao, etc.p/circuitos eletr.t<=1kv','Oth.appar.f/interruption,etc.f/elect.circuits t<=1kv','Los dem.apars.p/interrup.etc.p/circuitos eléctr.t<=1kv',11,'85','8536','853690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85371011','Suportes c/apars.de cnc,t<=1kv c/process/barram>=32bits','Support with apparatus of cnc,t<=1kv,c/proc/bus>=32bits','Soportes c/apars.de cnc, t<=1kv, c/proc/bus>=32bits',10,'85','8537','853710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85371019','Outs.quadros, painéis,etc.c/apars.cmd.num.comput.t<=1kv','Oth.boards,panels,etc.with appar.com.num.comp.t<=1kv','Los dem.cuadros, paneles, etc.c/apars.con.num.comp.t<=1kv',10,'85','8537','853710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85371020','Quadros c/aparelhos control.programáveis, t<=1kv','Boards with programmable control apparatus,t<=1kv','Cuadros c/aparatos control.programables, t<=1kv',11,'85','8537','853710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85371030','Quadros c/apars.control.demanda de energia eletr.t<=1kv','Boards with control of elect.power demand appar.t<=1kv','Cuadros c/apars.control.demanda de energía eléct.t<=1kv',11,'85','8537','853710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85371090','Outs.quadros,etc.c/apars.interrup.circuito eletr.t<=1kv','Oth.boards,etc.with elect.circuit switches appar.t<=1kv','Los dem.cuadros, etc.c/apars.interrup.circ.eléctr.t<=1kv',10,'85','8537','853710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85372000','Quadros, etc.c/aparelhos interrup.circuito eletr.t>1kv','Boards,etc.with elect.circuit switches appar.t>1kv','Cuadros, etc.c/aparatos interrup.circuito eléctr.t>1kv',10,'85','8537','853720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85372010','Substações isoladas a gás("gis" ou "his"),p/tensão>52kv','Substacoes isoladas a gas("gis" ou "his"),p/tensao>52kv','Substacoes isoladas a gas("gis" ou "his"),p/tensao>52kv',10,'85','8537','853720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85372090','Outs quadros etc.c/apar interrup circuito eletr t>52kv','Outs quadros etc.c/apar interrup circuito eletr t>52kv','Outs quadros etc.c/apar interrup circuito eletr t>52kv',10,'85','8537','853720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85381000','Quadros,painéis,etc.s/aparelhos interrup.circuito elétr','Boards,panels,etc.without elect.circuit switches appar.','Cuadros, paneles, etc.s/aparatos interrup.circuito eléctr',10,'85','8538','853810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85389010','Circuito impresso montado p/apars.interrup.circ.elétr.','Mounted printed circuits f/elec.circuit switches appar.','Circuito impreso montado p/apars.interrup.circ.eléctr.',11,'85','8538','853890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85389020','Outs.partes p/apars.interrup.proteção de circuito eletr','Oth.parts f/switches appar.elec.circuit protection','Las dem.partes p/apars.interrup.prot.de circuito eléctr',11,'85','8538','853890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85389090','Outras partes p/aparelhos interrup.circuito elétr.','Oth.parts f/elec.circuit switches apparatus','Las demás partes p/aparatos interrup.circuito eléctr.',10,'85','8538','853890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85391010','Faróis e projetores em unidades seladas, p/tensão<=15v','Sealed beam lamp units,f/tension<=15v','Faros/elementos ilum.en unidades sellados, p/tens.<=15v',11,'85','8539','853910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85391090','Outros farois e projetores em unidades seladas','Other sealed beam lamp units','Los dem.faros y elementos ilumin.en unidades sellados',11,'85','8539','853910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85392110','Lâmpadas/tubos incandesc.halogenos, de tungstênio, t<=15v','Lamps/halogenic incandescent tubes,of tungsten,t<=15v','Lámparas/tubos incandesc.halógenos, de volframio, t<=15v',11,'85','8539','853921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85392190','Outras lâmpadas/tubos incandesc.halogenos, de tungstênio','Other lamps/halogenic incandescent tubes,of tungsten','Las dem.lámparas/tubos incandesc.halógenos, de volframio',11,'85','8539','853921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85392200','Outras lâmpadas/tubos incandesc.pot<=200w, t>100v','Other lamps/incandesc.tubes pot<=200w,t>100v','Las dem.lámparas/tubos incandesc.pot<=200w, t>100v',11,'85','8539','853922');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85392910','Outras lâmpadas/tubos incandescentes tensão <= 15 V','Other lamps/incandesc.tubest<=15v','Las dem.lámparas/tubos incandesc.t<=15v',11,'85','8539','853929');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85392990','Outras lâmpadas/tubos incandesc.','Other lamps/incandesc.tubes','Las demás lámparas/tubos incandesc.',11,'85','8539','853929');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85393100','Lâmpadas/tubos descarga, fluorescente, de catodo quente','Lamps/tubes discharge,fluorescent,hot cathode','Lámparas/tubos descarga, fluorescente, de cátodo caliente',11,'85','8539','853931');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85393200','Lâmpadas de vapor de mercúrio/sódio ou halogeneto metal','Mercury/sodium vapour lamps; metal halide lamps','Lámparas de vapor de mercurio/sodio o halogenuro metál.',11,'85','8539','853932');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85393900','Outras lâmpadas/tubos de descarga','Other lamps/tubes discharge','Las demás lámparas/tubos de descarga',11,'85','8539','853939');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85394100','Lâmpadas de arco','Arc-lamps','Lámparas de arco',11,'85','8539','853941');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85394110','Lâmpadas de arco de potencia =>1.000w','Arc lamps with power => 1000w','Lámparas de arco con potencia => 1000 x',11,'85','8539','853941');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85394190','Outras lâmpadas de arco','Other arc lamps','Otras lámparas de arco',11,'85','8539','853941');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85394900','Lâmpadas/tubos de raios ultravioleta ou infravermelhos','Lamps/ultraviolet or infrared tubes of rays','Lámparas/tubos de rayos ultravioleta o infrarrojos',11,'85','8539','853949');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85399010','Eletrodos p/lâmpadas/tubos eletr.de incandescência, etc.','Electrodes f/lamps/electron.tubes of incandescence,etc','Electrodos p/lámparas/tubos eléctr.de incandescenc.etc',10,'85','8539','853990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85399020','Bases p/lâmpadas/tubos eletr.de incandescência, etc.','Bases f/lamps/electron.tubes of incandescence,etc','Bases p/lámparas/tubos eléctr.de incandescencia, etc',10,'85','8539','853990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85399090','Outras partes p/lâmpadas/tubos eletr.incandescência, etc','Oth.parts f/lamps/electron.tubes of incandescence,etc','Las dem.partes p/lámparas/tubos eléctr.incandescenc.etc',10,'85','8539','853990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85401100','Tubos catódicos p/recept.de televisão em cores, etc.','Cathode-ray tubes f/receivers of colour television,etc','Tubos catódicos p/apars.recept.de telev.en colores, etc',11,'85','8540','854011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85401200','Tubos catódicos p/recept.televisão em preto/branco, etc.','Cathode-ray tubes f/receivers black/white telev.,etc','Tubos catódicos p/apars.recep.telev.en blanco/negro, etc',11,'85','8540','854012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85402011','Tubos p/câmeras de televisão em preto e branco, etc.','Tubes f/cameras of black/white television,etc','Tubos p/cámaras de televisión en blanco y negro, etc',11,'85','8540','854020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85402019','Outros tubos para câmeras de televisão','Other tubes for cameras of television','Los demás tubos p/cámaras de televisión',11,'85','8540','854020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85402020','Tubos conversores/intensificadores imagens, de raios x','Converters tubes/image intensifiers,of rays x','Tubos convertidores/intensificadores imagen, de rayos x',11,'85','8540','854020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85402090','Outs.tubos conversores/intensificadores de imagens, etc.','Other converters tubes/image intensifiers,etc.','Los dem.tubos convertidores/intensificadores imagen, etc',11,'85','8540','854020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85404000','Tubos de visualiz.dados graf.em cores, tela fosforica, ','Data/graphic display tubes,colour,phosphor screen','Tubos p/visualiz.datos gráf.en colores, pantalla fosf.',11,'85','8540','854040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85405010','Tubo de visual.dado graf.preto/branco, tela<33, 56cm(14")','Data/graphic display tubes,black/white,scr<33,56cm(14")','Tubo p/visual.dato gráf.blanco/negro, pant.<33, 56cm(14")',11,'85','8540','854050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85405020','Tubo de visual.dado graf.preto/branco, tela>=33, 56cm(14"','Data/graphic display tubes,black/white,scr>=33,56cm(14"','Tubo p/visual.dato gráf.blanco/negro, pant.>=33, 56cm(14"',11,'85','8540','854050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85406010','Outs.tubos catódicos, de visualiz.dados graf.em cores, ','Oth.cathode-ray tubes','Los dem.tubos catódicos, p/visual.datos gráf.en colores',11,'85','8540','854060');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85406090','Outros tubos catódicos','Other cathode-ray tubes','Los demás tubos catódicos',11,'85','8540','854060');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85407100','Tubos para microondas, magnetrons','Tubes for microwaves, magnetrons','Tubos para hiperfrecuencias, magnetrones',11,'85','8540','854071');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85407200','Tubos para microondas, clistrons','Tubes for microwaves, klystrons','Tubos para hiperfrecuencias, klistrones',11,'85','8540','854072');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85407900','Outros tubos para microondas','Other tubes for microwaves','Los demás tubos para hiperfrecuencias',11,'85','8540','854079');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85408100','Tubos de recepção ou de amplificação','Receiver or amplifier tubes','Tubos de receptores o amplificadores',11,'85','8540','854081');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85408910','Válvulas de potência para transmissores','Potency valves for transmissions','Válvulas de potencia para transmisores',11,'85','8540','854089');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85408990','Outras lâmpadas, tubos e válvulas, eletrônicos, etc.','Other lamps,tubes,valves,electronic,etc','Las dem.lámparas, tubos y válvulas, electrónicos, etc',11,'85','8540','854089');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85409110','Bobinas de deflexao (yokes) para tubos catódicos','Deflection coils (yokes) for cathode-ray tubes','Bobinas de deflexión (yugos) para tubos catódicos',11,'85','8540','854091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85409120','Núcleos de pó ferromagnético p/bobinas de deflexão','Ferrite cores for deflection coils','Núcleos de ferrita para bobinas de deflexión',11,'85','8540','854091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85409130','Canhoes eletrônicos para tubos catódicos','Electronic guns for cathode-ray tubes','Cañones electrónicos para tubos catódicos',11,'85','8540','854091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85409140','Painel de vidro, máscara, etc.reunidos, p/tubos tricromát.','Assem.cons.of glass panel in grid,etc.f/trichrom.tubes','Panel de vidrio, grilla, etc.ensamblad.p/tubos tricromát.',11,'85','8540','854091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85409190','Outras partes para tubos catódicos','Other parts for cathode-ray tubes','Las demás partes para tubos catódicos',10,'85','8540','854091');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85409900','Partes p/lâmpadas, outros tubos e válvulas, eletron.etc.','Parts of lamps,other tubes and valves,electron.etc.','Partes p/lámparas, demás tubos y válvulas, electrón.etc',10,'85','8540','854099');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85411011','Diodos não montados, zener','Diodes not mounted, zener','Diodos sin montar, zener',11,'85','8541','854110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85411012','Diodos não montados, de intensidade de corrente<=3a','Diodes not mounted, of current intensity<=3a','Diodos sin montar, de intensidad de corriente<=3a',11,'85','8541','854110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85411019','Outros diodos não montados','Other diodes not mounted','Los demás diodos sin montar',11,'85','8541','854110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85411021','Diodos zener montados p/montagem em superfície ("smd")','Zener diodes mounted f/surface mounted device("smd")','Diodos zener montados p/montaje en superficie ("smd")',11,'85','8541','854110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85411022','Diodos montados p/montag.superf.intensid.corrente<=3a','Diodes mounted,f/surf.moun.dev.of current intensity<=3a','Diodos montados p/montaj.superf.intensid.corriente<=3a',11,'85','8541','854110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85411029','Outros diodos montados p/montagem em superfície ("smd")','Other diodes mounted f/surface mounted device("smd")','Los dem.diodos montados p/montaje en superficie ("smd")',11,'85','8541','854110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85411091','Outros diodos zener','Other zener diodes','Los demás diodos zener',11,'85','8541','854110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85411092','Outros diodos de intensidade de corrente<=3a','Other diodes of current intensity<=3a','Los demás diodos de intensidad de corriente<=3a',11,'85','8541','854110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85411099','Outros diodos exc.fotodiodos e diodos emissores de luz','Oth.diodes,oth.than photo-diodes/ light-emitting diodes','Los dem.diodos exc.fotodiodos y diodos emisores de luz',11,'85','8541','854110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85412110','Transistores c/cap.dissip.<1w, não montados','Transistors with dissipation capacity<1w,not mounted','Transistores c/cap.disip.<1w, sin montar',11,'85','8541','854121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85412120','Transistores c/cap.dissip.<1w, montados, p/montag.superf.','Transistors with dissip.cap.<1w,mounted,f/surf.mout.dev','Transistores c/cap.disip.<1w, montados, p/montaje superf.',11,'85','8541','854121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85412190','Outs.transistores c/cap.dissip<1w, exc.os fototransistor','Oth.transis.with dissip.cap.<1w,oth.than photo-transis','Los dem.transistores c/cap.disip<1w, exc.fototransist.',11,'85','8541','854121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85412191','Transistores c/capacid.dissip.<1w, c/juncao heterogenea','Transist.with dissip.cap.<1w,with heterojunction','Transistores c/capacid.disip.<1w, c/juntura heterogenea',11,'85','8541','854121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85412199','Outs.transistores c/cap.dissip<1w, exc.os fototransistor','Oth.transis.with dissip.cap.<1w,oth.than photo-transis','Transistores c/cap.disip<1w, exc.los fototransistores',11,'85','8541','854121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85412910','Outs.transistores, não montados, exc.os fototransistores','Oth.transis.with dissip.cap.n/moun.ot.than photo-trans.','Los dem.transistores, sin montar, exc.fototransistores',11,'85','8541','854129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85412920','Outros transistores, montados, exc.os fototransistores','Oth.transis.with dissip.cap.moun.,oth.than photo-trans.','Los dem.transistores, montados, exc.los fototransistores',11,'85','8541','854129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85413011','Tiristores, "diacs", etc.n/montados, intensid.corrente<=3a','Thyristors,"diacs",etc.n/mounted,current intesity<=3a','Tiristores, "diacs", etc.s/montar, intensid.corriente<=3a',11,'85','8541','854130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85413019','Outros tiristores, "diacs", "triacs", n/montados','Other thyristors,"diacs","triacs",n/mounted','Los demás tiristores, diacs, triacs, s/montar',11,'85','8541','854130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85413021','Tiristores, "diacs", etc.montados, intensid.corrente<=3a','Thyristors,"diacs",etc.mounted,current intesity<=3a','Tiristores, diacs, etc.montados, intensid.corriente<=3a',11,'85','8541','854130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85413029','Outros tiristores, "diacs", "triacs", montados','Other thyristors,"diacs","triacs",mounted','Los demás tiristores, diacs, triacs, montados',11,'85','8541','854130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414011','Diodos emissores de luz (led) n/montados, exc."laser"','Light-emitting diodes (led) n/mounted,exc.laser','Diodos emisores de luz (led) s/montar, exc.láser',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414012','Diodos "laser" não montados','Laser diodes n/mounted','Diodos láser sin montar',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414013','Fotodiodos não montados','Photo-diodes not mounted','Fotodiodos sin montar',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414014','Fototransitores não montados','Photo-transistors not mounted','Fototransitores sin montar',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414015','Fototiristores não montados','Photo-thyristors not mounted','Fototiristores sin montar',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414016','Celulas solares não montadas','Solar cells not mounted','Células solares sin montar',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414019','Outs.dispositivos fotossensiveis semicondut.n/montados','Oth.photosensitive semiconductor devices n/mounted','Los dem.dispositivos fotosensibles semiconduct.s/montar',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414021','Diodos emissores de luz (led) montados, p/montag.superf.','Light-emitting diodes (led) mounted,f/surf.mount.device','Diodos emisores de luz (led) montados, p/montaje superf.',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414022','Outs.diodos emissores de luz (led) exc.diodos "laser"','Oth.light-emitting diodes (led) n/mounted,exc.laser','Los dem.diodos emisores de luz (led) exc.diodos láser',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414023','Diodos "laser" c/comprim.onda de 1300mm ou 1500mm','Laser diodes with wavelength 1300mm or 1500mm','Diodos láser c/comprim.onda de 1300mm o 1500mm',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414024','Outros diodos "laser"','Other laser diodes','Los demás diodos láser',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414025','Fotodiodos, fototransistores e fototiristores montados','Photo-diodes/photo-transistors/photo-thyristors mounted','Fotodiodos, fototransistores y fototiristores montados',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414026','Fotorresistores montados','Photo-resistors mounted','Fotorresistores montados',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414027','Acopladores oticos, para montagem em superfície (smd)','Optic couplers,for surface mounted device (smd)','Acopladores ópticos, para montaje en superficie (smd)',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414029','Outros dispositivos fotossensiveis semicondut.montados','Oth.photosensitive semiconductor device mounted','Los dem.dispositivos fotosensibles semiconduct.montados',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414031','Fotodiodos em modulos ou paineis','Photo-diodes in modules or panels','Fotodiodos en módulos o paneles',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414032','Celulas solares em modulos ou paineis','Solar cells in modules or panels','Células solares en módulos o paneles',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85414039','Outras celulas fotovoltaicas em modulos ou paineis','Other photovoltaic cells in modules or panels','Las dem.células fotovoltaicas en módulos o paneles',11,'85','8541','854140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85415010','Outros dispositivos semicondutores não montados','Other semiconductor devices not mounted','Los dem.dispositivos semiconductores sin montar',11,'85','8541','854150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85415020','Outros dispositivos semicondutores montados','Other semiconductor devices mounted','Los dem.dispositivos semiconductores montados',11,'85','8541','854150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85416010','Cristais piezoeletr.montados, de quartzo, 1<=freq<=100mhz','Mount.piezo-electr.crystals,of quartzo,1<=freq<=100mhz','Cristales piezoeléctr.mont.de cuarzo, 1<=frec<=100mhz',11,'85','8541','854160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85416090','Outros cristais piezoelétricos montados','Other mounted piezo-electric crystals','Los dem.cristales piezoeléctricos montados',11,'85','8541','854160');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85419010','Suporte-conector em tiras, diodos, etc.semicondutores','Support-connector in strips,diodes,etc.semiconductor','Soporte conector en tiras, diodos, etc.semiconductores',10,'85','8541','854190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85419020','Coberturas p/encapsulamento (capsulas)','Coverings for making capsules','Cubiertas p/encapsulamiento (cápsulas)',10,'85','8541','854190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85419090','Outras partes de diodos, transistores, etc.semicondutores','Oth.parts of diodes,transistors,etc.semiconduct.','Las dem.partes de diodos, transistores, etc.semiconduct.',10,'85','8541','854190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421000','Cartões munidos de um circuito integr.eletron','Cards incorporating an electronic integrated circuit','Tarjetas provistas de un circuito integrado electrónico',11,'85','8542','854210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421200','Cartões incorporando 1 circuito integrado eletrônico','Cards incorporating 1 electronic integrated circuit','Tarjetas provistas de un circuito integrado electrónico',11,'85','8542','854212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421310','Semicondutores de óxido metálico, tecn.mos, não montados','Metallic oxide  semiconductors,mos tech.,n/mounted','Semiconductores de óxido metálico, tecn.mos, sin montar',11,'85','8542','854213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421321','Memórias rom, prom, etc.tecn.mos, montadas, p/montag.superf','Rom, prom,etc.memoirs mos tech.,mounted,f/surf.moun.dev','Memorias rom, prom, etc.tecn.mos, montadas, p/mont.superf',11,'85','8542','854213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421322','Microprocessadores, tecn.mos, montados, p/montag.em superf','Microprocessors,mos tech.,mounted,f/surf.moun.dev.','Microprocesadores, tecn.mos, montados, p/montaje en superf',11,'85','8542','854213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421323','Microcontroladores, tecn.mos, montados, p/montag.em superf','Microcontrollers mos tech.,mounted,f/surf.moun.dev.','Microcontroladores, tecn.mos, montados, p/mont.en superf',11,'85','8542','854213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421324','Co-processadores, tecn.mos, montados, p/montag.em superf.','Co-processors,mos tech,mounted,f/surf.moun.dev.','Coprocesadores, tecn.mos, montados, p/montaje en superf.',11,'85','8542','854213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421325','Semicondutor."chip-set", tecn.mos, montad.p/montag.superf','Semiconduc."chip-set",mos tech.,mounted,f/surf.moun.dev','Semiconductor."chipset", tecn.mos, montad.p/mont.superf',11,'85','8542','854213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421328','Outs.memórias, tecnolog.mos, montadas, p/montag.em superf.','Other memories,mos tech.,mounted,f/surf.moun.dev','Las dem.memorias, tecnol.mos, montadas, p/mont.en superf.',11,'85','8542','854213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421329','Outs.semicondutores, tecnolog.mos, montad.p/montag.superf','Other semiconductors,mos tech.,mounted,f/surf.moun.dev','Los dem.semiconductores, tecnol.mos, montad.p/mont.superf',11,'85','8542','854213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421391','Outs.memórias rom, prom, etc.tecnologia mos, acesso<=25ns','Other rom,prom,etc.memories mos tech.,acess<=25ns','Las dem.memorias rom, prom, etc.tecnol.mos, acceso<=25ns',11,'85','8542','854213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421392','Outs.microprocessadores, de óxido metálico, tecnolog.mos','Oth.microprocessors,of metallic oxide,mos technol.','Las dem.microprocesadores, de óxido metálico, tecnol.mos',11,'85','8542','854213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421393','Outs.microcontroladores, de óxido metálico, tecnolog.mos','Oth.microcontrollers,of metallic oxide,mos technol.','Los dem.microcontroladores, de óxido metálico, tecnol.mos',11,'85','8542','854213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421394','Outs.co-processadores, de óxido metálico, tecnologia mos','Other co-processors,of metallic oxide,mos technol.','Los dem.coprocesadores, de óxido metálico, tecnología mos',11,'85','8542','854213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421395','Outs.semicondutores "chip-set", de óxido metal.tecn.mos','Ot.semiconductors "chip set",of metallic oxide,mos tec.','Los dem.semiconductores "chipset", de óxido met.tecn.mos',11,'85','8542','854213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421398','Outs.memórias de óxido metálico, tecnologia mos','Oth. metallic oxide memoirs,mos technology','Las demás memorias de óxido metálico, tecnología mos',11,'85','8542','854213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421399','Outros semicondutores de óxido metálico, tecnologia mos','Oth.semiconductors,of metallic oxide,mos techn.','Los dem.semiconductores de óxido metál., tecnología mos',11,'85','8542','854213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421410','Circuito obtido tecnol.bipolar, não montados','Circuit obtain.bipolar technology,not mounted','Circuito de tecnología bipolar, sin montar',11,'85','8542','854214');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421420','Circuito obtido tecnol.bipolar, montados, p/montag.superf','Circuit obtain.bipolar techn.mounted,f/surf.moun.dev','Circuito de tecnología bipolar, montados, p/mont.superf.',11,'85','8542','854214');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421490','Outs.circuitos digitais, obtidos por tecnologia bipolar','Oth.circuit digital obtain.bipolartechnology','Los dem.circuitos digitales de tecnología bipolar',11,'85','8542','854214');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421910','Outs.circuitos integrados monolit.digitais, não montados','Oth.digital monolithic integrated circuits,n/mounted','Los dem.circuitos integrados monolít.digitales, s/montar',11,'85','8542','854219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421921','Outs.memórias rom, prom, etc.montadas, p/montag.em superf.','Oth.rom, prom,etc.memoirs,mounted,f/surf.moun.dev.','Las dem.memorias rom, prom, etc.montadas, p/mont.en superf',11,'85','8542','854219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421928','Outs.memórias, montadas, para montagem em superfície','Oth.memories,mounted,f/surface mounted device','Las dem.memorias, montadas, para montaje en superficie',11,'85','8542','854219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421929','Outs.circuitos integr.monolit.dig.mont.p/montag.superf.','Oth.dig.monolithic integ.circuits,moun.,f/surf.moun.dev','Circuitos integr.monolít.dig.mont.p/montaje superf.',11,'85','8542','854219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421991','Outs.memórias rom, prom, etc.montadas','Other rom,prom,etc.memories,mounted','Las dem.memorias rom, prom, etc.montadas',11,'85','8542','854219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421998','Outs.memórias, montadas','Other mounted memories','Las demás memorias, montadas',11,'85','8542','854219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85421999','Outros circuitos integr.monolit.digit.montados','Other digital monolithic integrated circuits,mounted','Los dem.circuitos integr.monolít.digit.montados',11,'85','8542','854219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422110','Circuitos integrados, monolit.digit.n/montados','Digital monolithic integrated circuits,n/mounted','Circuitos integrados, monolít.digit.s/montar',11,'85','8542','854221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422121','Memórias tipos ram estat.c/tempo<=25ns, montad','Static memories (sram) with time<=25ns,mounted','Memorias tipos ram estát.c/tiempo<=25ns, montadas',11,'85','8542','854221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422122','Microprocessadores montados p/montag.superf.','Microprocessors,mounted,f/surface mounted device','Microprocesadores montados p/montaje superf.',11,'85','8542','854221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422123','Microcontroladores montados p/montag.superf.','Microcontrollers,mounted,f/surface mounted device','Microcontroladores montados p/montaje superf.',11,'85','8542','854221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422124','Co-processadores  montados p/montag.superf.','Co-processors,mounted,f/surface mounted device','Coprocesadores montados p/montaje superf.',11,'85','8542','854221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422125','Circuitos integrad.monolit.montad."chipset"','Monolithic integrated circuits,mounted,"chipset"','Circuitos integrad.monolít.montad."chipset"',11,'85','8542','854221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422128','Outs.memórias montadas p/montag.superf.','Other mounted memories,f/surface mounted device','Las dem.memorias montadas p/montaje superf.',11,'85','8542','854221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422129','Outs.circuitos integrad.monolit.digit.montad.','Other digital monolithic integrated circuits,mounted','Los dem.circuitos integrad.monolít.digit.montad.',11,'85','8542','854221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422191','Outs.memórias tipos ram estaticas tempo<=25ns','Other static memories with an access time<=25ns','Las dem.memorias tipos ram estáticas tiempo<=25ns',11,'85','8542','854221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422192','Outs.microprocessadores','Other microprocessors','Los dem.microprocesadores',11,'85','8542','854221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422193','Outs.microcontroladores','Other microcontrollers','Los dem.microcontroladores',11,'85','8542','854221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422194','Outs.co-processadores','Other co-processors','Los dem.coprocesadores',11,'85','8542','854221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422195','Outs.circuitos integr.monolit.digit."chipset"','Other digital monolithic integrated circuits "chipset"','Los dem.circuitos integr.monolít.digit."chipset"',11,'85','8542','854221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422198','Outs.memórias','Other memories','Las demás memorias',11,'85','8542','854221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422199','Outs.circuitos integrados monolit.digitais','Other digital monolithic integrated circuits','Los dem.circuitos integrados monolít.digitales',11,'85','8542','854221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422910','Outs.circuitos integrados monolit.nao montad.','Other monolithic integrated circuits,not mounted','Los dem.circuitos integrados monolít.sin montar',11,'85','8542','854229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422921','Outs.circuitos integrad.digitais-analogicos','Other digital analogical integrated circuits','Los dem.circuitos integrad.digitales-analógicos',11,'85','8542','854229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85422929','Outs.circuitos integrados monolit.montados','Other monolithic integrated circuits,mounted','Los demás circuitos integrados monolít.montados',11,'85','8542','854229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423010','Outros circuitos integr.monolit.não montados','Other monolithic integrated circuits,no mounted','Los demás circuitos integr.monolít.sin montar',11,'85','8542','854230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423021','Outs.circuitos integr.monolit.digitais-analog.montados','Oth.digital-analog.monolithic integr.circuits,mounted','Los dem.circuitos integr.monolít.digitales-analóg.mont.',11,'85','8542','854230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423029','Outros circuitos integr.monolit.montados','Other monolithic integr.circuits,mounted','Los demás circuitos integr.monolít.montados',11,'85','8542','854230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423110','Circuitos integ.monolít.digitais ñ montados','Digit.monolithic integrated circuits,no mounted','Circuitos integr.monolít.digit.sin montar',11,'85','8542','854231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423120','Microprocessadores mont.p/superf.(smd)','Microcontrollers,mounted,f/surface mounted device (smd)','Microcontroladores montados p/montaje superf.(smd)',11,'85','8542','854231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423190','Outros circuitos integrados','Other integrated circuits','Otros circuitos integrados',11,'85','8542','854231');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423210','Circuitos integ.monolít.digitais ñ montados','Digit.monolithic integrated circuits, no mounted','Circuitos integr.monolít.digit.sin montar',11,'85','8542','854232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423221','M.ram <=25ns, eprom, eeprom, prom, rom, flash','Ram memories <=25ns,eprom,eeprom,prom,rom,flash','Memórias ram <=25ns, eprom, eeprom, prom, rom, flash',11,'85','8542','854232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423229','Outras memórias digitais montadas','Other digital digital memories','Otras memorias digitales montadas',11,'85','8542','854232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423291','Outs.m.ram<25ns, eprom, eeprom, prom, flash','Other ram memories <25ns,eprom,eeprom,prom,flash','Otras memórias ram <25ns, eprom, eeprom, prom, flash',11,'85','8542','854232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423299','Outras memórias ram <25ns','Other ram memories <25ns','Otras memórias ram <25ns',11,'85','8542','854232');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423311','Circ.integ.híbrido esp<1mícron freq.>800mhz','Hybrid.integrat.circuit. thick.<1micron, freq>800mhz','Circ.integ.híbrido esp<1mícron freq.>800mhz',11,'85','8542','854233');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423319','Outs.circ.integ.híbridos esp<=1mícron','Other hybrid. integrat. circuit. thick<=1 micron','Otros circ.integ.híbridos esp<=1mícron',11,'85','8542','854233');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423320','Outs.circuitos integr.monolít. não montados','Other monolithic integr.circuits, no mounted','Los demás circuitos integr.monolít.no montados',11,'85','8542','854233');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423390','Outros circuitos montados','Other mounted circuits','Otros circuitos montados',11,'85','8542','854233');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423911','Circ.integ.híbrido esp<1mícron freq.>800mhz','Hybrid.integrat.circuit. thick.<1micron, freq>800mhz','Circ.integ.híbrido esp<1mícron freq.>800mhz',11,'85','8542','854239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423919','Outs.circ.integ.híbridos esp<=1mícron','Other hybrid. integrat. circuit. thick<=1 micron','Otros circ.integ.híbridos esp<=1mícron',11,'85','8542','854239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423920','Outs.circuitos integr.monolít. não montados','Other monolithic integrated circuits,no mounted','Otros circuitos integr.monolít.sin montar',11,'85','8542','854239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423931','Circuito integ.monolítico "chipset", mont.smd','Monolithic integrated circuits,"chipset", mounted smd','Circuito integr.monolit. "chipset", mont. smd',11,'85','8542','854239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423939','Outros circuitos integrados monolíticos','Other monolithic integr.circuits','Otros circuitos integr.monolít.',11,'85','8542','854239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423991','Outs.circuitos integr.monolíticos "chipset"','Other monolithic integr.circuits "chipset"','Otros circuitos integr.monolít. "chipset"',11,'85','8542','854239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85423999','Outros circuitos integrados monolít.digitais','Other monolithic integr.circuits dig.','Otros circuitos integr.monolít. dig.',11,'85','8542','854239');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85424010','Circuito integrado híbrido, espessura de camada<=1micron','Hybrid integrated circuit,thickness of layer<=1micron','Circuito integrado híbrido, de espesor de capa<=1micron',11,'85','8542','854240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85424011','Circuito integr.híbrido, esp.camad<=1micron, freq>=800mhz','Hybr.integ.circuit thick.of layer<=1micron,freq>=800mhz','Circuito integr.híbrido, esp.capa<=1micron, frec>=800mhz',11,'85','8542','854240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85424019','Outs.circuitos integrados híbridos, esp.camad<=1micron','Oth.hybr.integ.circuit thick.of layer<=1micron','Los dem.circuitos integrados híbridos, esp.capa<=1micron',11,'85','8542','854240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85424090','Outros circuitos integrados híbridos','Other hybrid integrated circuits','Los demás circuitos integr.híbridos',11,'85','8542','854240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85425000','Microconjuntos eletrônicos','Electronic microassemblies','Microestructuras electrónicas',11,'85','8542','854250');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85426011','Circuitos integr.híbridos, e<=1micron f>=800mh','Hybrid integrated circuits,t<=1micron f>=800mh','Circuitos integr.híbridos, e<=1micron f>=800mh',11,'85','8542','854260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85426019','Outs.circuitos integrad.híbridos, e<=1micron','Other hybrid integrated circuits,t<=1micron','Los dem.circuitos integrad.híbridos, e<=1micron',11,'85','8542','854260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85426090','Outros circuitos integrados híbridos','Other hybrid integrated circuits','Los demás circuitos integrados híbridos',11,'85','8542','854260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85427000','Microconjuntos eletrônicos','Electronic microassemblies','Microestructuras electrónicas',11,'85','8542','854270');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85429010','Suporte-conector em tiras, p/circuito integr.etc.eletron','Support-connector in strips,f/integ.circuits,etc.electr','Soporte conector en tiras, p/circuito integr.etc.electr.',10,'85','8542','854290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85429020','Coberturas p/encapsulamento, p/circuito integr.eletron.','Coverings f/making capsules,f/integ.circuits,etc.electr','Cubiertas p/encapsulamiento, p/circuito integr.electrón.',10,'85','8542','854290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85429090','Outras partes p/circuito integr.e microconj.eletron.','Oth.parts f/integ.circuits and electr.microassemblies','Las demás partes p/circuito integr.y microestr.electr.',10,'85','8542','854290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85431000','Aceleradores de partículas','Particle accelerators','Aceleradores de particulas',11,'85','8543','854310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85431100','Apars.de implantacao ionica, p/impurif.mater.semicondut.','Ion implanters for doping semiconductor materials','Apars.de implantación iónica, p/dopar mater.semiconduct.',11,'85','8543','854311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85431900','Outros aceleradores de particulas, elétricos','Other electric particle accelerators','Los demás aceleradores de partículas, eléctricos',11,'85','8543','854319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85432000','Geradores de sinais, elétricos','Electric signal generators','Generadores de señales, eléctricos',11,'85','8543','854320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85433000','Maqs.e apars.de galvanoplastia, eletrolise, eletroforese','Mach.appar.f/electroplat.electrolysis,electrophoresis','Máqs.y apars.galvanotecnia, electrólisis, electroforesis',11,'85','8543','854330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85434000','Eletrificadores de cercas','Electric fence energisers','Electrificadores de cercas',11,'85','8543','854340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437011','Amplif.d/radiofr.p/microond.pot.>2, 7kw v.twt','Radio-freq. amplifier for microwave pot>2.7kw v.twt','Amplificador de radiofrec.p/microondas pot.>2.7kw v.twt',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437012','Ampl.d/radiof.p/microond.bx.ruído temp.<55k','Radio-freq. amplifier for microwave with low noise temp.<55k','Amplificador de radiofrec.p/microondas bajo ruido temp.<55k',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437013','Amplific.d/radiofr.p/distr.d/sinais d/televisão','Radio-freq. amplifier for distribution of signs for television','Amplificador de radiofrec.p/ distribución de señales de televisión',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437014','Outs.amplif.d/radiofr.p/rec.sin.d/microondas','Other radio-freq amplifier for microwave sign recept.','Otros amplificadores de radio frec.p/ rec. de señales de microondas',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437015','Outs.amplif.d/radiofr.p/transm.sin.d/microon.','Other radio-freq amplifier for microwave sign transm.','Otros amplificadores de radio frec.p/ transm. de señales de microondas',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437019','Outs.amplificadores d/radiofrequência','Other radio-freq. amplifiers','Otros  amplificadores de radiofrec.',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437020','Aparelhos para eletrocutar insetos','Apparatus to electrocute insects','Aparatos para electrocutar los insectos',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437031','Ger.efeit.esp.man.2 ou 3 dimensões +d/10 ent.','Gener.of special effects with man.2 or 3 dimen. +d/10 inputs','Generad.de efectos espec.manip.2 o 3 dimens.+ =d/10 ent.',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437032','Geradores de caracteres digitais','Digital character generators','Generadores de caracteres, digitales',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437033','Sincroniz.d/quad.armaz./corr.d/base d/tempo','Frame synchroniz/curr. time base recorders','Sincronizador de cuadro almacen.corr.de base tiempo',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437034','Controladores de edição para vídeo','Controllers of edition for video','Controles de edición para video',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437035','Mistur.digital, em tempo real, c/8 ou + entradas','Real time digital mixers with 8 or more inputs','Mezclador digital, en tiempo real de entrada c/8 o más',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437036','Roteador-comutador +d/20 entradas +16 saídas','Routing switches for  more than 20 inputs  and more than 16 outputs','Ruteador-conmutador +de 20  entradas , + de 16 salidas',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437039','Outras máquinas e aparelhos auxiliares para vídeo','Other aux. machinery for video','Otras máq. y apar. aux. p/ video',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437040','Transcodific. convers.d/padrões de televisão','Television standard transcoders or converter','Transcodificador o convertidor de normas de televisión',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437050','Simulador d/antenas p/transm.c/pot.>=25kw','Aerial simulators for transmitters,pot>=25kw','Simulador de antenas p/transmisores, c/pot>=25kw',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437091','Terms.d/texto q.oper.c/cód.d/transm.baudot','Text terminals,oper.with baudots code transm.,etc','Terminales de texto, q.oper.c/cód.de transm.baudot, etc',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437092','Eletrificadores de cercas','Electric fence energisers','Electrificadores de cercas',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85437099','Outs.máqs.apar.elétr.c/função própria, ñ cit.','Other eletric.machinery with sel function, not mentioned ','Otras máq. y apar. elétr. c/ func. próp., no menc.',11,'85','8543','854370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438100','Cartões e etiquetas de acionam.por aproxim.','Proximity cards and tags','Tarjetas y etiquetas de activación por proxim.',11,'85','8543','854381');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438911','Amplificador radiofreq.p/transm.sinal microonda, hpa, etc','Radio-freq.amplifier f/transmit.microwave sign,hpa,etc','Amplificador radiofrec.p/transm.señal.microonda, hpa, etc',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438912','Amplificador radiofreq.p/recep.sinal microonda, lna, etc','Radio-freq.amplifier f/receiving microwave sign,lna,etc','Amplificador radiofrec.p/recep.señal.microondas, lna, etc',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438913','Amplificador radiofreq.p/distrib.de sinais de televisão','Radio-freq.amplifier f/broadcasting television signals','Amplificador radiofrec.p/distrib.de señales televisión',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438914','Outs.amplificad.de radiofreq.p/recep.sinais microondas','Other radio-freq.amplifier f/receiv.microwave signals','Los dem.amplificad.de radiofrec.p/recep.señ.microondas',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438915','Outs.amplificad.de radiofreq.p/transm.sinais microondas','Oth.radio-freq.amplifier f/transmit.microwave signals','Los dem.amplificad.de radiofrec.p/transm.señ.microondas',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438919','Outros amplificadores de radiofrequência','Other radio-frequency amplifiers','Los demás amplificadores de radiofrecuencia',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438920','Aparelhos para eletrocutar insetos','Appliances for electrocuting insects','Aparatos para electrocutar insectos',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438931','Geradores de efeitos espec.manip.2/3 dimens.etc.p/video','Gener.of special effects with man.2/3 dimen.etc.f/video','Generad.de efectos espec.manip.2/3 dimens.etc.p/video',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438932','Geradores de caracteres, digitais, para vídeo','Digital character generators, for video','Generadores de caracteres, digitales, para video',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438933','Sincronizador de quadro armazen.etc.base tempo, p/vídeo','Frame synchronizer,etc.time base recorders,f/video','Sincronizador de cuadro almacen.etc.base tiempo, p/video',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438934','Controladores de edição, para vídeo','Editing controller, for video','Controladores de edición, para video',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438935','Misturador digital, em tempo real de entrada>=8, p/video','Real time digital mixers>=8 input,f/video','Mezclador digital, en tiempo real de entrada>=8, p/video',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438936','Roteador-comutador de entrada>20, saída>16, p/vídeo','Routing switches 20<input,16<output,f/video','Ruteador-conmutador de entrada>20, salida>16, p/video',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438939','Outras máquinas e aparelhos auxiliares, para vídeo','Other machines and auxiliary apparels,for video','Las demás máquinas y aparatos auxiliares, p/video',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438940','Transcodificador ou conversor de padrões de televisão','Television standard transcoders or converter','Transcodificador o convertidor de normas de televisión',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438950','Simulador de antenas para transmissores, pot >= 25 Kw','Aerial simulators for transmitters, pot>=25kw','Simulador de antenas p/transmisores, c/pot>=25kw',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438990','Outras máquinas e aparelhos elétricos c/função propria','Oth.electric.mach.apparatus,having individual functions','Las dem.máquinas y aparatos eléctricos c/función propia',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438991','Terminais de texto, oper.c/cod.de transmissão baudot, etc','Text terminals,oper.with baudots code transm.,etc','Terminales de texto, q.oper.c/cód.de transm.baudot, etc',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85438999','Outs.máquinas e aparelhos elétricos com função propria','Oth.electric.mach.apparatus,having individual functions','Las dem.máquinas y aparatos eléctricos c/función propia',11,'85','8543','854389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85439010','Partes de maqs.e apars.amplificad.radiofreq.video, etc.','Parts of video radio-freq.amplifier mach.appar.etc.','Partes de máqs.y apars.amplificad.radiofrec.video, etc',10,'85','8543','854390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85439090','Partes de outs.máquinas e apars.eletr.c/função própria','Parts of oth.electr.mach.apparatus,having indiv.funct.','Partes de dem.máquinas y apars.eléctr.c/función propia',10,'85','8543','854390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85441100','Fios de cobre para bobinar, isolados p/uso eletr.','Insulated coppe wire f/winding,f/elect.use','Alambres de cobre p/bobinar, aislados p/uso eléctr.',10,'85','8544','854411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85441910','Fios de alumínio para bobinar, isolados p/uso eletr.','Insulated alluminium wire f/winding,f/elect.use','Alambres de aluminio p/bobinar, aislados p/uso eléctr.',10,'85','8544','854419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85441990','Outros fios para bobinar, isolados p/uso eletr.','Other insulated wires f/winding,f/elect.use','Los dem.alambres p/bobinar, aislados p/uso eléctr.',10,'85','8544','854419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85442000','Cabos coaxiais e outros condutores eletr.coaxiais','Co-axial cables and oth.co-axial electr.conductors','Cables coaxiales y demás conductores eléctr.coaxiales',10,'85','8544','854420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85443000','Jogos de fios p/velas de ignição e outs.fios p/veículos','Ignition wiring sets and other wiring sets used in veh.','Juegos de cab.p/bujías de encend.y dem.cab.p/med.transp',10,'85','8544','854430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85444100','Outs.condutores eletr.munidos pecas conexão, tensao<=80v','Oth.electr.conductors with connection fitting,tens<=80v','Los dem.conduct.eléctr.prov.piezas conexión, tens<=80v',10,'85','8544','854441');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85444200','Outs.cond.elét.ten.<=100v, c/peças de conexão','Other electric conductors f/tension<=100v, with pieces of connection','Otros conductores eléctricos p/ tension <=100v, con las piezas de conexión,  ',10,'85','8544','854442');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85444900','Outros condutores eletr.p/tensao<=80v','Other electric conductors f/tension<=80v','Los dem.conductores eléctr.p/tens.<=80v',10,'85','8544','854449');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85445100','Outs.condutores eletr.munidos pecas conexão, 80<t<=1000v','Oth.elect.conductors with connect.fittngs,80<t<=1000v','Los dem.conductores eléct.prov.piezas conex.80<t<=1000v',10,'85','8544','854451');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85445900','Outros condutores eletr.80v<tensao<=1.000v','Other electric conductors 80v<tension<=1.000v','Los demás conductores eléctr.80v<tensión<=1.000v',10,'85','8544','854459');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85446000','Outros condutores eletr.p/tensao>1000v','Other electric conductors f/tension>1000v','Los demás conductores eléctr.p/tensión>1000v',10,'85','8544','854460');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85447010','Cabos de fibras ópticas rev.ext.de material dieletr.','Optical fibre cables ext.coated dielectric material','Cables de fibras ópticas rev.ext.de material dieléctr.',10,'85','8544','854470');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85447020','Cabos de fibras ópticas rev.ext.de aço p/inst.submarina','Optical fibre cables ext.coated steel f/submarine','Cables de fibras ópticas rev.ext.de acero p/inst.subm.',10,'85','8544','854470');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85447030','Cabos de fibras ópticas rev.ext.de alumínio','Optical fibre cables externally coated with aluminium','Cables de fibras ópticas rev.ext.de aluminio',10,'85','8544','854470');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85447090','Outros cabos de fibras ópticas','Other optical fibre cables','Los demás cables de fibras ópticas',10,'85','8544','854470');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85451100','Eletrodos de carvão para uso em fornos elétricos','Carbon electrodes of a kind used for furnaces','Electrodos de carbón p/uso en los hornos eléctr.',10,'85','8545','854511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85451910','Eletrodos de grafita, teor carbono>=99.9%, p/uso eletr.','Graphite electrodes,contain.carbon>=99.9%f/electr.use','Electrodos de grafito, c/cont.carbono>=99.9%p/uso eléctr',10,'85','8545','854519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85451920','Blocos grafite tipos utiliz c/ catodos em cubas eletrol','Blocos grafite tipos utiliz c/ catodos em cubas eletrol','Blocos grafite tipos utiliz c/ catodos em cubas eletrol',10,'85','8545','854519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85451990','Outros eletrodos de carvão, para uso elétrico','Other carbon electrodes, for electric use','Los demás electrodos de carbón, para uso eléctrico',10,'85','8545','854519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85452000','Escovas de carvão, para uso elétrico','Carbon brushes, for electric use','Escobillas de carbón, para uso eléctrico',10,'85','8545','854520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85459010','Carvões para pilhas elétricas','Electrics battery carbons','Carbones para pilas eléctricas',10,'85','8545','854590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85459020','Resistências aquecedoras desprov.de revestim/terminais','Heating resistors,n/coated or fitted with terminals','Resistencias calentadoras desprov.de revest/terminales',10,'85','8545','854590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85459030','Suporte de conexão ("nipples") para eletrodos','Connection bases for electrodes ("nipples")','Soporte conectores para electrodos',10,'85','8545','854590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85459090','Outros carvões e artigos de grafita/carvão p/uso eletr.','Oth.carbon and articles of graphite/carbon f/electr.use','Los dem.carbon.y artícs.de grafito/carbón p/uso eléctr.',10,'85','8545','854590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85461000','Isoladores de vidro para uso elétrico','Glass insulators for electric use','Aisladores de vidrio para uso eléctrico',10,'85','8546','854610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85462000','Isoladores de cerâmica para uso elétrico','Ceramics insulators for electric use','Aisladores de cerámica para uso eléctrico',10,'85','8546','854620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85469000','Isoladores de outras matérias para uso elétrico','Insulators of other matters for electric use','Aisladores de demás materias para uso eléctrico',10,'85','8546','854690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85471000','Pecas isolantes de cerâmica p/maqs.apars.e instal.eletr','Insulating fittings of ceramics f/mach.appar.elect.inst','Piezas aislantes de cerámica p/máqs.apars.y inst.eléctr',10,'85','8547','854710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85472000','Pecas isolantes de plástico p/maqs.apars.e instal.eletr','Insulating fittings of plastics f/mach.appar.elect.inst','Piezas aislantes de plástico p/máqs.apars.y inst.eléctr',10,'85','8547','854720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85472010','Tampões vedadores p/capacit.c/perfur.p/terminais eletr','Stoppers f/capacitors,perfor.f/mount.electr.terminals','Obturadores p/capac.c/perfor.p/terminales eléctr',10,'85','8547','854720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85472090','Outs.pecas isol.de plástico p/maqs.apars.instal.eletr.','Oth.insul.fittings of plastics f/mach.appar.elect.inst','Las dem.piezas aisl.de plást.p/máqs.apars.instal.eléct.',10,'85','8547','854720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85479000','Outs.pecas/tubos isolantes p/maqs.apars.e instal.eletr.','Oth.insulat.fittings of tubes f/mach.appar.elect.inst','Las dem.piezas/tubos aislant.p/máqs.apars.y inst.eléctr',10,'85','8547','854790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85481010','Desperdícios/resids.de acumuladores eletr.de chumbo, etc','Waste/scrap of electric accumulators of lead,etc.','Desperds./desechos de acumuladores eléctr.de plomo, etc',10,'85','8548','854810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85481090','Desperdícios/resids.de pilhas/bateria pilhas eletr.etc.','Waste/scrap of primary cells/elec.primary batteries,etc','Desperdicios/desechos de pilas/batería pilas eléctr.etc',10,'85','8548','854810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85489000','Partes eletr.de outras máquinas e aparelhos','Parts electric of other machines and apparatus','Partes eléctr.de demás máquinas y aparatos',10,'85','8548','854890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85489010','Termopares utiliz.em dispos.termele.de apar.a gás','Thermocouples used in thermoelectric gas devices','Termopares utiliz.em dispos. termele. de apar. a gas',10,'85','8548','854890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('85489090','Partes elétricas de outras máquinas e aparelhos','Parts of other electrical machinery and apparatus','Partes de otras máquinas y aparatos eléctricos',10,'85','8548','854890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86011000','Locomotivas e locotratores, de fonte ext.de eletricidade','Rail locomot.powered from an exter.source of electr.','Locomotoras y locotractores, de fuente ext.de electric.',11,'86','8601','860110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86012000','Locomotivas e locotratores, de acumuladores elétricos','Rail locomotives, of electric accumulators','Locomotoras y locotractores, de acumuladores eléctricos',11,'86','8601','860120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86021000','Locomotivas diesel-elétricas','Diesel-electric locomotives','Locomotoras diesel-eléctricas',11,'86','8602','860210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86029000','Outras locomotivas e locotratores, e tenderes','Other rail locomotives and locomotive tenders','Las demás locomotoras y locotractores, y ténderes',11,'86','8602','860290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86031000','Litorinas (automotoras), de fonte ext.de eletricidade','Self-propelled,powered from an exter.source of elec.','Automotores, de fuente ext.de electricidad',11,'86','8603','860310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86039000','Outras litorinas (automotoras)','Other self-propelled','Los demás automotores',11,'86','8603','860390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86040000','Veículos p/inspecao/manutencao de vias férreas/semelhs.','Vehicles f/inspection/maintenance of railway/similar','Vehículos p/mantenimiento/serv.de vías férreas/simils.',11,'86','8604','860400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86040010','Veics.autopropuls.batedor balastro, alinhad.vias férreas','Self-propelled vehicles,ballast tampers,railway alig.','Vehícs.autopropuls.p/apison.balastro, alinear v.férreas',11,'86','8604','860400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86040090','Outs.veículos p/inspecao/manutencao de vias férreas, etc','Oth.vehicles f/inspection/maintenance of railway,etc.','Los dem.vehículos p/manten./serv.de vías férreas, etc',11,'86','8604','860400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86050010','Vagões de passageiros p/vias férreas/semelhs.','Passengers wagons for railway/similar','Coches de viajeros p/vías férreas/simils.',11,'86','8605','860500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86050090','Furgões p/bagagem,vagões-postais,etc.p/vias férreas','Luggage vans,post office coaches,etc.f/railway','Furgones de equipajes, coches correo, etc.p/vías férreas',11,'86','8605','860500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86061000','Vagões-tanques/semelhs.p/transp.mercad.em vias férreas','Tank wagons/similar f/transp.goods by railway','Vagones cisterna/simils.p/transp.mercanc.sobre carriles',11,'86','8606','860610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86062000','Vagões isotermicos, refrigeradores, etc.p/vias férreas','Insulated or refrigerated vans and wagons,etc.f/railway','Vagones isotérmicos, refrigerantes, etc.sobre carriles',11,'86','8606','860620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86063000','Vagões de descarga automat.mercadorias em vias férreas','Autom.self-discharging wagons f/trans.goods by railway','Vagones de descarga automát.de mercancías sob.carriles',11,'86','8606','860630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86069100','Vagões cobertos/fechados, p/transp.mercad.vias férreas','Covered and closed wagons f/trans.goods by railway','Vagones cubiertos/cerrados, p/transp.merc.sob.carriles',11,'86','8606','860691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86069200','Vagões abertos/paredes fixas, altura>60cm p/vias férreas','Open/non-remov.sides wagons,height>60cm f/railway','Vagones abiertos/pared.fijas, altura>60cm sobre carriles',11,'86','8606','860692');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86069900','Outs.vagões p/transporte de mercadorias em vias férreas','Other wagons f/transporting goods by railway','Los dem.vagones p/transp.de mercancías sobre carriles',11,'86','8606','860699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86071110','Truques (bogies) de tração de veículos p/vias férreas','Bogies of vehicles traction for railway','Bojes de tracción de vehículos p/vías férreas',10,'86','8607','860711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86071120','Bisseis de tracao de veículos p/vias férreas/semelhs.','Bissel-bogies of vehicles traction for railway/similar','Bissels de tracción de vehículos p/vías férreas/simils.',10,'86','8607','860711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86071200','Outros "bogies" e bisseis de veículos para vias férreas','Oth.bogies and bissel-bog.of vehic.traction f/railway','Los dem.bojes y bissels de vehículos para vías férreas',10,'86','8607','860712');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86071910','Mancais de veículos para vias férreas','Bearing boxes of vehicles f/railway','Cajas de cojinetes de vehículos p/vías férreas',10,'86','8607','860719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86071911','Mancais c/rolam.diam.ext>190mm, p/eixo roda vagao ferrov','Bear.boxes c/ext.diam.>190mm,f/wheels axi ofrailw.wagon','Cajas coj.c/rolam.diam.ext>190mm, p/eje rueda vag.ferrov',10,'86','8607','860719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86071919','Outros mancais de veículos p/vias férreas','Other bearing boxes of vehicles for railway','Las dem.cajas de cojinetes de vehículos p/vías férreas',10,'86','8607','860719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86071990','Eixos, rodas e suas partes de veículos p/vias férreas','Axis,wheels and parts thereof of vehicles f/railway','Ejes, ruedas y sus partes de vehículos p/vías férreas',10,'86','8607','860719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86072100','Freios a ar comprim.suas partes de veic.p/vias férreas','Brakes and parts thereof of vehicles f/railway','Frenos a aire compr.sus partes de vehíc.p/vías férreas',10,'86','8607','860721');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86072900','Outros freios e suas partes, de veículos p/vias férreas','Other brakes and parts thereof,of vehicles f/railway','Los dem.frenos y sus partes, de vehículos p/vías férreas',10,'86','8607','860729');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86073000','Ganchos, pára-choques, etc.de veículos p/vias férreas','Hooks,buffers,etc.of vehicles f/railway','Ganchos, topes, etc.de vehículos p/vías férreas',10,'86','8607','860730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86079100','Outras partes de locomotivas ou de locotratores','Othter parts of locomotives','Las demás partes de locomotoras o locotractores',10,'86','8607','860791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86079900','Outras partes de veículos p/vias férreas','Other parts of vehicles f/railway','Las demás partes de vehículos p/vías férreas',10,'86','8607','860799');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86080011','Aparelhos mecânicos de sinaliz.etc.p/vias férreas, etc.','Signalling mechanical apparatus f/railway,etc.','Aparatos mecánicos de señaliz.etc.p/vías férreas, etc',10,'86','8608','860800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86080012','Aparelhos eletromecan.de sinaliz.etc.p/vias férreas, etc','Signalling electro-mechanical apparatus f/railway,etc.','Aparatos electromecán.de señaliz.etc.p/vías férreas, etc',10,'86','8608','860800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86080090','Material fixo de vias férreas/semelhs.e suas partes','Fixed material of railway/similar and its parts','Material fijo de vías férreas/simils.y sus partes',10,'86','8608','860800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('86090000','Conteineres (contentores) incl.de transp.fluidos, etc.','Containers includ.the transport of fluids,etc.','Contenedores incl.de transp.fluidos, etc',11,'86','8609','860900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87011000','Tratores motocultores','Pedestrian-controlled tractors','Tractores motocultores',11,'87','8701','870110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87012000','Tratores rodoviários para semi-reboques','Road tractors for semi-trailer','Tractores de carretera p/semirremolques',11,'87','8701','870120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87013000','Tratores de lagartas','Track-laying tractors','Tractores de orugas',11,'87','8701','870130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87019000','Outros tratores','Other tractors','Los demás tractores',11,'87','8701','870190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87019010','Tratores para arrastar troncos ("log skidders")','Log-skidding tractors','Tractores para arrastrar troncos ("log skidders")',11,'87','8701','870190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87019090','Outros tratores','Other tractors','Los demás tractores',11,'87','8701','870190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87021000','Veículos automóveis p/transp>=10 pessoas, c/motor diesel','Motor vehicles f/transp.>=10 persons,with diesel engine','Vehículos automóv.p/transp>=10 personas, c/motor diesel',11,'87','8702','870210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87029010','Trolebus para transporte >= 10 pessoas','Trolleybuses for the transport >= 10 person','Trolebuses para transporte >= 10 personas',11,'87','8702','870290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87029090','Outros veículos automóveis para transporte>=10 pessoas','Other motor vehicles for the transport>=10 person','Los demás vehículos automóviles p/transp>=10 personas',11,'87','8702','870290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87031000','Veículos automóveis p/deslocam.na neve, campo golfe, etc.','Motor vehicles desig.f/travel.on snow,golf cars,etc','Vehículos automóvs.p/desplaz.sobre nieve, campo golf, etc',11,'87','8703','870310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87032100','Automóveis c/motor explosão, cil<=1000cm3','Automobiles with motor explosion,cyl<=1000cm3','Vehíc.automóviles c/motor explosión, cil<=1000cm3',11,'87','8703','870321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87032210','Automóveis c/motor explosão, 1000<cm3<=1500, ate 6 passag','Autom.with motor explosion,1000<cm3<=1500,up to 6 pass','Vehíc.autom.c/motor explos.1000<cm3<=1500, hasta 6 pers.',11,'87','8703','870322');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87032290','Automóveis c/motor explosão, 1000<cm3<=1500, sup.6 passag','Autom.with motor explos.1000<cm3<=1500,more than 6 pass','Vehíc.automóv.c/motor expl.1000<cm3<=1500, sup.6 pers.',11,'87','8703','870322');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87032310','Automóveis c/motor explosão, 1500<cm3<=3000, ate 6 passag','Autom.with motor explosion,1500<cm3<=3000,up to 6 pass','Vehíc.autom.c/motor explos.1500<cm3<=3000, hasta 6 pers.',11,'87','8703','870323');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87032390','Automóveis c/motor explosão, 1500<cm3<=3000, sup.6 passag','Autom.with motor explos.1500<cm3<=3000,more than 6 pass','Vehíc.automóv.c/motor explos.1500<cm3<=3000, sup.6 pers.',11,'87','8703','870323');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87032410','Automóveis c/motor explosão, cm3>3000, ate 6 passageiros','Autom.with motor explosion,cm3>3000,up to 6 passengers','Vehíc.automóv.c/motor explos.cm3>3000, hasta 6 personas',11,'87','8703','870324');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87032490','Automóveis c/motor explosão, cm3>3000, sup.6 passageiros','Autom.with motor explos.cm3>3000,more than 6 passengers','Vehíc.automóv.c/motor explos.cm3>3000, sup.6 personas',11,'87','8703','870324');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87033110','Automóveis c/motor diesel, cm3<=1500, ate 6 passageiros','Autom.with diesel engine,cm3<=1500,up to 6 passengers','Vehíc.automóv.c/motor diesel, cm3<=1500, hasta 6 personas',11,'87','8703','870331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87033190','Automóveis c/motor diesel, cm3<=1500, sup.6 passageiros','Autom.with diesel engine cm3<=1500,more than 6 passen.','Vehíc.automóv.c/motor diesel, cm3<=1500, sup.6 personas',11,'87','8703','870331');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87033210','Automóveis c/motor diesel, 1500<cm3<=2500, ate 6 passag.','Autom.with diesel engine,1500<cm3<=2500,up to 6 passen.','Vehíc.automóv.c/motor diesel, 1500<cm3<=2500, hasta 6pers',11,'87','8703','870332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87033290','Automóveis c/motor diesel, 1500<cm3<=2500, sup.6 passag.','Autom.with diesel engine,1500<cm3<=2500,more than 6 pas','Vehíc.automóv.c/motor diesel, 1500<cm3<=2500, sup.6 pers.',11,'87','8703','870332');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87033310','Automóveis c/motor diesel, cm3>2500, ate 6 passageiros','Autom.with diesel engine,cm3>2500,up to 6 passengers','Vehíc.automóv.c/motor diesel, cm3>2500, hasta 6 pers.',11,'87','8703','870333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87033390','Automóveis c/motor diesel, cm3>2500, sup.6 passageiros','Autom.with diesel engine,cm3>2500,more than 6 passeng.','Vehíc.automóv.c/motor diesel, cm3>2500, sup.6 pers.',11,'87','8703','870333');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87039000','Outros automóveis de passageiros, incl.de uso misto, etc.','Oth.passengers automobiles,incl.of mixed use,etc.','Los dem.automóv.de turismo, incl.del tipo familiar, etc',11,'87','8703','870390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87041000','Dumpers p/transp.de mercadoria, util.fora de rodovias','Dumpers f/the transp.of goods,for off-highway use','Volq.autom.p/transp.de merc, util.fuera de red carret.',11,'87','8704','870410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87041010','Dumpers p/transp.mercadoria>=85t, util.fora de rodovias','Dumpers f/the transp.of goods>=85t,f/off-highway use','Volq.aut.p/transp.de merc>=85t, util.fuera de red carret',11,'87','8704','870410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87041090','Outs.dumpers p/transp.mercadoria, util.fora de rodovias','Oth.dumpers f/the transp.of goods,f/off-highway use','Los dem.volq.aut.p/trans.de merc, util.fuera red carret.',11,'87','8704','870410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87042110','Chassis com motor diesel e cabina, para carga <= 5t','Chassis fitted with dies.engine/cab,of gross weight<=5t','Chasis c/motor diesel y cabina, p/carga<=5t',11,'87','8704','870421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87042120','Veic.automov.c/motor diesel/caixa bascul.p/carga<=5t','Motor vehicles with diesel engine/tipping body weig<=5t','Vehíc.automóv.c/motor diesel/caja bascul.p/carga<=5t',11,'87','8704','870421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87042130','Veic.automov.frigorif.etc.c/motor diesel, carga<=5t','Motor vehicles refriger.etc.with diesel engineweig<=5t','Vehíc.automóv.frigoríf.etc.c/motor diesel, carga<=5t',11,'87','8704','870421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87042190','Outros veículos automóveis c/motor diesel, p/carga<=5t','Other motor vehicles with diesel engine,weigh<=5t','Los dem.vehículos automóv.c/motor diesel, p/carga<=5t',11,'87','8704','870421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87042210','Chassis c/motor diesel e cabina, 5t<carga<=20t','Chassis fitted with dies.engine and cab,5t<weig<=20t','Chasis c/motor diesel y cabina, 5t<carga<=20t',11,'87','8704','870422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87042220','Veic.automov.c/motor diesel/caixa bascul.5t<carga<=20t','Motor vehic.with diesel engine/tipp.body 5t<weig<=20t','Vehíc.automóv.c/motor diesel/caja bascul.5t<carga<=20t',11,'87','8704','870422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87042230','Veic.automov.frigorif.etc.c/motor diesel, 5t<carga<=20t','Motor vehic.refrig.etc.with diesel engine,5t<wei<=20t','Vehíc.automóv.frigorif.etc.c/motor diesel, 5t<carga<=20t',11,'87','8704','870422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87042290','Outros veículos automóveis c/motor diesel, 5t<carga<=20t','Oth.motor vehicles with diesel engine,5t<wei<=20t','Los dem.vehículos automóv.c/motor diesel, 5t<carga<=20t',11,'87','8704','870422');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87042310','Chassis com motor diesel e cabina, carga > 20t','Chassis fitted with dies.engine and cab,wei>20t','Chasis c/motor diesel y cabina, carga>20t',11,'87','8704','870423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87042320','Veic.automov.c/motor diesel/caixa bascul.carga>20t','Motor vehicles with diesel engine/tipp.body wei>20t','Vehíc.automóv.c/motor diesel/caja bascul.carga>20t',11,'87','8704','870423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87042330','Veic.automov.frigorif.etc.c/motor diesel, carga>20t','Motor vehic.refriger.etc.with diesel engine,wei>20t','Vehíc.automóv.frigoríf.etc.c/motor diesel, carga>20t',11,'87','8704','870423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87042390','Outros veículos automóveis c/motor diesel, carga>20t','Oth.motor vehicles with diesel engine,wei>20t','Los dem.vehículos automóviles c/motor diesel, carga>20t',11,'87','8704','870423');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87043110','Chassis com motor a explosão e cabina, carga <= 5t','Chassis fitted with motor explosion and cab,wei<=5t','Chasis c/motor explosión y cabina, carga<=5t',11,'87','8704','870431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87043120','Veic.automov.c/motor explosão/caixa bascul.carga<=5t','Motor vehicles with motor explosion/tipp.body wei<=5t','Vehíc.automóv.c/motor explosión/caja bascul.carga<=5t',11,'87','8704','870431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87043130','Veic.automov.frigorif.etc.c/motor explosão, carga<=5t','Motor vehic.refriger.etc.with motor explosion,wei<=5t','Vehíc.automóv.frigoríf.etc.c/motor explosión, carga<=5t',11,'87','8704','870431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87043190','Outros veículos automóveis c/motor explosão, carga<=5t','Oth.motor vehicles with motor explosion,wei<=5t','Los dem.vehículos automóv.c/motor explos.carga<=5t',11,'87','8704','870431');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87043210','Chassis com motor explosão e cabina, carga>5t','Chassis fitted with motor explosion and cab,wei>5t','Chasis c/motor explosión y cabina, carga>5t',11,'87','8704','870432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87043220','Veic.automov.c/motor explosão/caixa bascul.carga>5t','Motor vehicles with motor explosion/tipp.body wei>5t','Vehíc.automóv.c/motor explosión/caja bascul.carga>5t',11,'87','8704','870432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87043230','Veic.automov.frigorif.etc.c/motor explosão, carga>5t','Motor vehic.refriger.etc.with motor explosion,wei>5t','Vehíc.automóv.frigoríf.etc.c/motor explosión, carga>5t',11,'87','8704','870432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87043290','Outros veículos automóveis c/motor explosão, carga>5t','Oth.motor vehicles with motor explosion,wei>5t','Los dem.vehículos automóviles c/motor explos.carga>5t',11,'87','8704','870432');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87049000','Outros veículos automóveis para transporte de mercadorias','Other motor vehicles for the transport of goods','Los dem.vehículos automóv.p/transporte de mercancías',11,'87','8704','870490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87051000','Caminhões-guindastes','Crane lorries','Camiones grúa',11,'87','8705','870510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87051010','Caminhões-guindastes cap.max.de elev.>=60t, haste telesc','Crane lorries max.capac.of elevat.>=60t,telescopic stem','Camiones grúa cap.máx.de elev.>=60t, espiga telesc.',11,'87','8705','870510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87051090','Outros caminhões-guindastes','Other crane lorries','Los demás camiones grúa',11,'87','8705','870510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87052000','Torres (derricks) automóveis, p/sondagem/perfuração','Mobile drilling derricks','Camiones automóviles, p/sondeo/perforación',11,'87','8705','870520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87053000','Veículos automóveis de combate a incêndios','Fire-fighting-vehicles','Camiones de bomberos',11,'87','8705','870530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87054000','Caminhões-betoneiras','Concrete-mixer lorries','Camiones hormigonera',11,'87','8705','870540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87059000','Outros veículos automóveis p/usos especiais','Other motor vehicles for special use','Los demás vehículos automóviles p/usos especiales',11,'87','8705','870590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87059010','Caminhões para perfilagem de pocos petroliferos','Lorries for profiling petroleum wells','Camiones p/ perfilar pozos de petróleo',11,'87','8705','870590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87059090','Outros veículos automóveis para usos especiais','Other motor vehicles for special use','Los demás vehículos automóviles para usos especiales',11,'87','8705','870590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87060010','Chassis c/motor p/veics.automóveis transp.pessoas>=10','Chassis with engines f/motor vehicles trans.persons>=10','Chasis c/motor p/vehícs.automóviles transp.personas>=10',11,'87','8706','870600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87060020','Chassis c/motor p/"dumpers" e tratores exc.rodoviários','Chassis with engines f/dumpers and tractors exc.road','Chasis c/motor p/volq.autom.y tractores exc.rodoviarios',11,'87','8706','870600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87060090','Outs.chassis c/motor p/automóveis de passag/mercadorias','Oth.chassis with engines f/automobiles of passeng/goods','Los dem.chasis c/motor p/automóv.de turismo/mercancías',11,'87','8706','870600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87071000','Carroçarias p/automóveis de passageiros, incl.as cabinas','Bodies (including cabs),for automobiles of passengers','Carrocerías p/automóviles de turismo, incl.las cabinas',11,'87','8707','870710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87079010','Carroçarias p/"dumpers"/tratores exc.rodov.incl.cabinas','Bodies (incl.cabs) f/dumpers/tractors exc.road','Carrocerías p/volq.aut./tractores exc.rodov.incl.cabin.',11,'87','8707','870790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87079090','Carroçarias p/veic.automov.transp>=10pessoas ou p/carga','Bodies f/motor vehic.transp>=10persons or f/load','Carrocerías p/vehíc.autom.transp>=10personas o p/carga',11,'87','8707','870790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87081000','Pára-choques e suas partes p/veículos automóveis','Bumpers and parts thereof f/motor vehicles','Parachoques y sus partes para vehículos automóviles',11,'87','8708','870810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87082100','Cintos de segurança para veículos automóveis','Seatbelts for motor vehicles','Cinturones de seguridad para vehículos automóviles',11,'87','8708','870821');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87082911','Para-lamas para "dumpers" e tratores exc.os rodoviários','Mudguards f/dumpers and tractors exc.road','Guardabarros para volq.aut.y tractores exc.rodoviarios',11,'87','8708','870829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87082912','Grades de radiadores para "dumpers"/tratores exc.rodov.','Radiator cowlings for dumpers/tractors exc.road','Parrillas de radiadores p/volq.aut./tractores exc.rod.',11,'87','8708','870829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87082913','Portas para "dumpers" e tratores exceto os rodoviários','Doors for dumpers and tractors except road','Puertas p/volq.autom.y tractores excepto los rodov.',11,'87','8708','870829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87082914','Paineis de instrumentos p/"dumpers"/tratores exc.rodov.','Dashboards for dumpers/tractors except road','Paneles de instrumentos p/volq.aut./tractores exc.rodov',11,'87','8708','870829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87082919','Outs.partes/acess.de carroçarias p/"dumpers" e tratores','Other parts/acess.of bodies f/dumpers and tractors','Los dem.partes/acces.de carroc.p/volq.aut.y tractores',11,'87','8708','870829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87082991','Pára-lamas para veículos automóveis','Mudguards for motor vehicles','Guardabarros para vehículos automóviles',11,'87','8708','870829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87082992','Grades de radiadores para veículos automóveis','Radiator cowlings for motor vehicles','Parrillas de radiadores para vehículos automóviles',11,'87','8708','870829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87082993','Portas para veículos automóveis','Doors for motor vehicles','Puertas para vehículos automóviles',11,'87','8708','870829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87082994','Painéis de instrumentos para veículos automóveis','Dashboards for motor vehicles','Paneles de instrumentos p/vehículos automóviles',11,'87','8708','870829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87082995','Inflador de bolsa de ar p/disposit.segurança p/automov.','Gas gener.to inflate airbags/activ.safety belt ratract.','Inflador de bolsa de aire p/disp.seguridad p/automóv.',11,'87','8708','870829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87082996','Bolsas infláveis para "airbag" de automóveis','Inflatable bags for automobiles airbags','Bolsas inflables para "airbag" de automóviles',11,'87','8708','870829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87082999','Outras partes e acess.de carroçarias p/veic.automóveis','Other parts/access.of bodies f/motor vehicles','Las dem.partes y acces.de carrocerías p/vehíc.automóv.',11,'87','8708','870829');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87083011','Guarnições de freios, monts.p/trat.e "dumpers"','Mounted brakes and servo-brakes for dumpers and tractors','Guarniciones de frenos montad.p/volq.autom.y tractores',11,'87','8708','870830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87083019','Guarnições d/freios, monts.p/veícs.automs.','Mounted brakes and servo-brakes for vehicles/automob.','Guarniciones de frenos montad.p/dem.vehíc/automóv.',11,'87','8708','870830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87083090','Outros freios e partes, para tratores/veícs.auts.','Other brakes and its parts,f/tractors/vehicles/automob.','Otros frenos y sus partes, p/tractores/vehíc./automóv.',11,'87','8708','870830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87083110','Guarnições de freios montadas para "dumpers" e tratores','Brakes and servo-brakes for dumpers and tractors','Guarniciones de frenos montad.p/volq.autom.y tractores',11,'87','8708','870831');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87083190','Guarnições de freios montadas p/outros veics.automóveis','Brakes and servo-brakes f/other motor vehicles','Guarniciones de frenos montad.p/dem.vehíc.autom.',11,'87','8708','870831');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87083900','Outros freios e suas partes, p/tratores/veic.automóveis','Other brakes and its parts,f/tractors/motor vehicles','Los dem.frenos y sus partes, p/tractores/vehíc.automóv.',11,'87','8708','870839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87084010','Caixas de marchas p/"dumpers"/tratores exc.rodoviários','Gear boxes f/dumpers/tractors except road','Cajas de cambio p/volq.autom./tractores exc.',11,'87','8708','870840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87084011','Servo-assistidas p/torque>=750nm de tratores/"dumpers"','Power-assisted f/torques>=750nm of tractors/dumpers','Servoasistidas p/torque>=750nm de tractores/volq.aut.',11,'87','8708','870840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87084019','Outras caixas de marchas para tratores ou "dumpers"','Other gear boxes for tractors or dumpers','Las dem.cajas de cambio para tractores o volq.autom.',11,'87','8708','870840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87084080','Outras caixas de marchas','Other gearboxes','Otras cajas de cambio',11,'87','8708','870840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87084090','Partes de caixas de marchas','Parts of gearboxes','Partes de cajas de cambio',11,'87','8708','870840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87085010','Eixos de transmissão c/diferencial p/"dumpers"/tratores','Drive-axles with differential f/dumpers/tractors','Ejes de transm.c/diferencial p/volq.autom./tractores',11,'87','8708','870850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87085011','Eixos de transmissão c/diferenc.p/"dumpers", carga>=14t','Drive-axles with differential f/dumpers,load>=14t','Ejes de transmis.c/diferenc.p/volq.autom., carga>=14t',11,'87','8708','870850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87085012','Eixos e part., exc.transm p/trat./"dumpers"','Axles and parts except. drive/trac./dumpers ','Ejes y part., excep.transm. p/trac./dumpers',11,'87','8708','870850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87085019','Eixos de transmissão c/diferencial p/"dumpers"/tratores','Drive-axles with differential f/dumpers/tractors','Ejes de transmisión c/diferencial p/volq.aut./tractores',11,'87','8708','870850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87085080','Eixos d/transm.c/diferencial p/veícs.automs.','Drive-axles with differential f/motor vehicles','Ejes de transmisión c/diferencial p/vehíc.automóviles',11,'87','8708','870850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87085090','Eixos de transmissão c/diferencial p/veic.automóveis','Drive-axles with differential f/motor vehicles','Ejes de transmisión c/diferencial p/vehíc.automóviles',11,'87','8708','870850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87085091','Eixos e part., exc.transm p/trat./"dumpers"','Axles and parts except. drive/trac./dumpers ','Ejes y part., excep.transm. p/trac./dumpers',11,'87','8708','870850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87085099','Outs.eixos e partes, p/veículos automóveis','Other axels and its parts,f/motor vehicles','Otros ejes y sus partes, p/vehículos automóviles',10,'87','8708','870850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87086010','Outs.eixos e suas partes, p/"dumpers"/tratores exc.rodov','Oth.axels and its parts,f/dumpers/tractors exc.road','Los dem.ejes y sus partes, p/volq.aut./tractores exc.rod',11,'87','8708','870860');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87086090','Outros eixos e suas partes, p/veículos automóveis','Other axels and its parts,f/motor vehicles','Los demás ejes y sus partes, p/vehículos automóviles',11,'87','8708','870860');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87087010','Rodas de eixos propulsor.s/partes, p/"dumpers"/tratores','Wheels of propellers axels its parts,f/dumpers/tractors','Ruedas de ejes propulsor.s/partes, p/volq.aut./tractores',11,'87','8708','870870');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87087090','Outras rodas, suas partes e acess.p/veículos automóveis','Other wheels,its parts and acess.f/motor vehicles','Las dem.ruedas, sus partes y acces.p/vehículos automóv.',11,'87','8708','870870');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87088000','Amortecedores de suspensao p/tratores e veic.automóveis','Suspension shock-absorbers f/tractors and motor vehic.','Amortiguadores de suspensión p/tractores y vehíc.autom.',11,'87','8708','870880');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089100','Radiadores para tratores e veículos automóveis','Radiators f/tractors and motor vehicles','Radiadores p/tractores y vehículos automóviles',11,'87','8708','870891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089200','Silenciosos e tubos de escape p/tratores/veic.automov.','Silencers and exhaust pipes f/tractors and motor vehic.','Silenciadores y tubos de escape p/tractores/vehíc.autom',11,'87','8708','870892');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089300','Embreagens e suas partes para tratores/veículos automóveis','Clutches and parts thereof f/tractors and motor vehic.','Embragues y sus partes p/tractores/vehículos automóv.',11,'87','8708','870893');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089411','Volante de direção para "dumpers" e tratores exc.rodov.','Steering wheel  f/dumpers/tractors exc.road','Volante de dirección p/volq.aut.y tractores exc.rodov.',11,'87','8708','870894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089412','Barra de direção p/"dumpers" e tratores exc.rodoviários','Steering columns f/dumpers/tractors exc.road','Columna de dirección p/volq.aut.y tractores exc.rodov.',11,'87','8708','870894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089413','Caixa de direção p/"dumpers" e tratores exc.rodoviários','Steering boxes f/dumpers/tractors exc.road','Caja de dirección p/volq.autom.y tractores exc.rodov.',11,'87','8708','870894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089481','Volantes de direção para veículos automóveis','Steering wheels for motorized vehicles','Volantes de dirección para vehículos automóviles',11,'87','8708','870894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089482','Barras de direção para veículos automóveis','Steering columns for motor vehicles','Columna de dirección p/ vehículos automóviles',11,'87','8708','870894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089483','Caixas de direção para veículos automóveis','Steering boxes for motor vehicles','Caja de dirección para  vehículos automóviles',11,'87','8708','870894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089490','Outs.partes, acess.p/tratores e veícs.autos.','Other parts and access.f/tractors and motor vehicles','Otras partes y acces.p/tractores y vehículos automóv.',10,'87','8708','870894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089491','Volantes de direção para veículos automóveis','Steering wheels for motorized vehicles','Volantes de dirección para vehículos automóviles',11,'87','8708','870894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089492','Barras de direção para veículos automóveis','Steering columns for motor vehicles','Columnas de dirección p/vehículos automóviles',11,'87','8708','870894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089493','Caixas de direção para veículos automóveis','Steering boxes for motor vehicles','Cajas de dirección p/vehículos automóviles',11,'87','8708','870894');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089510','Bolsas infláv.d/segur.c/sist.insufl.("airbags")','Inflatable bags of safety with system of inflating ("airbags")  ','Bolsas inflables de segur. c/ sist. infl. ("airbags")',11,'87','8708','870895');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089521','Bolsas infláveis para "airbags"','Inflatable bags for "airbags"','Bolsas inflables para "airbags"',11,'87','8708','870895');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089522','Infl.d/bolsa d/ar p/disposts.d/seg.("airbag")','Airbag inflator for device of safety','Infl.de bolsa de aire p/ disposit. de segur. ("airbag")',11,'87','8708','870895');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089529','Outs.parts.acess.d/carroçarias p/veícs.auto','Outras partes e acess.de carrocarias p/veic.automoveis','Other parts/access.of bodies f/motor vehicles',11,'87','8708','870895');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089900','Outras partes e acess.p/tratores e veículos automóveis','Other parts and access.f/tractors and motor vehicles','Las dem.partes y acces.p/tractores y vehículos automóv.',10,'87','8708','870899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089910','Dispositivo p/cmdo.acelerador, freio, etc.p/veic.automov.','Device f/command,acceler.,brake,etc.f/motor vehicles','Dispositivo p/cmdo.acelerador, freio, etc.p/vehíc.autom.',10,'87','8708','870899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87089990','Outras partes e acess.p/tratores e veículos automóveis','Other parts and access.f/tractors and motor vehicles','Las dem.partes y acces.p/tractores y vehículos automóv.',10,'87','8708','870899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87091100','Veículos automov.eletr.s/disp.elev.util.em fábricas, etc','Elect.works trucks,n/fitted with lift.equip.in fact.etc','Carretillas autom.eléctr.s/disp.elev.util.fábricas, etc',11,'87','8709','870911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87091900','Outs.veículos automov.s/disp.elev.util.em fábricas, etc.','Oth.works trucks,n/fitted with lift.equipm.in fact.etc','Las dem.carretillas autom.s/disp.elev.util.fábricas, etc',11,'87','8709','870919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87099000','Partes de veic.automov.s/disp.elev.util.em fábricas, etc','Parts of works trucks,n/fitted with lift.equip.fact.etc','Partes de carretillas autom.s/disp.elev.util.fábric.etc',10,'87','8709','870990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87100000','Veículos e carros blindados de combate e suas partes','Vehicles and cars armored of combat and its parts','Tanques y dem.vehíc.aut.blindad.de combate y sus partes',11,'87','8710','871000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87111000','Motocicletas, etc.c/motor pistao alternat.cil<=50cm3','Motorcyc.etc.with recip.int.comb.pist.engine cyl<=50cm3','Motocicletas, etc.c/motor émbolo alternat.cil<=50cm3',11,'87','8711','871110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87112010','Motocicletas c/motor pistao alternat.50cm3<cil<=125cm3','Motorcyc.with recip.int.comb.pist.eng.50cm3<cyl<=125cm3','Motocicletas c/motor émbolo alternat.50cm3<cil<=125cm3',11,'87','8711','871120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87112020','Motocicletas c/motor pistao alternat.125cm3<cil<=250cm3','Motorc.with recip.int.comb.pist.eng.125cm3<cyl<=250cm3','Motocicletas c/motor émbolo alternat.125cm3<cil<=250cm3',11,'87','8711','871120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87112090','Outros ciclos c/motor pistao alternat.50cm3<cil<=250cm3','Oth.cycles with recip.int.comb.pist.eng.50<cyl<=250cm3','Los dem.velocíp.c/motor émbolo alternat.50<cil<=250cm3',11,'87','8711','871120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87113000','Motocicletas, etc.c/motor pistao alternat.250<c<=500cm3','Motorcyc.etc.with recip.int.comb.pist.eng.250<c<=500cm3','Motocicletas, etc.c/motor émbolo alternat.250<c<=500cm3',11,'87','8711','871130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87114000','Motocicletas, etc.c/motor pistao alternat.500<c<=800cm3','Motorcyc.etc.with recip.int.comb.pist.eng.500<c<=800cm3','Motocicletas, etc.c/motor émbolo alternat.500<c<=800cm3',11,'87','8711','871140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87115000','Motocicletas, etc.c/motor pistão alternat.cil>800cm3','Motorcycles,etc.with recip.int.comb.pist.eng.cyl>800cm3','Motocicletas, etc.c/motor émbolo alternat.cil>800cm3',11,'87','8711','871150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87119000','Outs.motocicletas/ciclos c/motor auxil.carros laterais','Oth.motorcyc./cycles with auxil.motor of lateral cars','Las dem.motocicletas/velocíp.c/motor auxil.sidecares',11,'87','8711','871190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87120010','Bicicletas sem motor','Bikes without engine','Bicicletas sin motor',11,'87','8712','871200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87120090','Outros ciclos sem motor, inclusive triciclos','Other cycles without engine, including tricycles','Los demás velocípedos sin motor, incl.triciclos',11,'87','8712','871200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87131000','Cadeiras de rodas, etc.sem mecanismo de propulsao','Carriages for disabled,etc.n/mechanically propelled','Sillones de ruedas, etc.sin mecanismo de propulsión',11,'87','8713','871310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87139000','Outras cadeiras de rodas e outras veículos p/invalidos','Other carriages for disabled and other vehicles','Los dem.sillones de ruedas y dem.vehículos p/inválidos',11,'87','8713','871390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87141000','Partes e acessorios de motocicletas(inclu.ciclomotores)','Parts and accessories of motorcycles (including mopeds)','Partes y accesorios de motocicletas',10,'87','8714','871410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87141100','Selins para motocicletas, inclusive ciclomotores','Saddles for motor-cycles (including mopeds)','Sillines p/motocicletas incl.ciclomotores',10,'87','8714','871411');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87141900','Outras partes e acess.p/motocicletas incl.ciclomotores','Other parts and access.f/motor-cycles incl.mopeds','Las dem.partes y acces.p/motocicletas incl.ciclomotores',10,'87','8714','871419');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87142000','Partes e acess.p/cadeiras de rodas/outs.veic.p/inválido','Parts and access.of carriag.f/disabled/oth.vehic.inval.','Partes y acces.de sillones de ruedas/dem.vehíc.p/inv.',10,'87','8714','871420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87149100','Quadros, garfos e suas partes p/bicicletas e outs.ciclos','Frames,forks and parts thereof f/bicycles and oth.cycl.','Cuadros, horquillas, sus partes p/bicicletas y dem.veloc.',10,'87','8714','871491');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87149200','Aros e raios para bicicletas e outros ciclos','Wheel rims and spokes f/bicycles and other cycles','Llantas y radios para bicicletas y demás velocíp.',10,'87','8714','871492');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87149300','Outros cubos e pinhoes de rodas livres p/bicibletas, etc','Oth.hubs and sprocket-wheels f/bicycles,etc','Los dem.bujes s/freno y piñones libres p/bicicletas, etc',10,'87','8714','871493');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87149310','Cubos, exc.de freios (travoes) p/bicibletas e out.ciclos','Hubs,exc.of brakes(coaster brak.)p/bicyc.and oth.cycles','Bujes, exc.de frenos p/bicibletas y dem.veloc.',10,'87','8714','871493');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87149320','Pinhões de rodas livres p/bicibletas e outs.ciclos','Free-wheel sprocket-wheels p/bicyc.and oth.cycles','Piñones libres p/bicicletas y demás velocípedos',10,'87','8714','871493');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87149410','Cubos de freios para bicicletas e outros ciclos','Coaster braking hubs p/bicycles and other cycles','Bujes c/frenos p/bicicletas y demás velocíped.',10,'87','8714','871494');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87149490','Outros freios e suas partes para bicicletas e outros ciclos','Oth.brakes and parts thereof f/bicycles and oth.cycles','Los dem.frenos y sus partes p/bicicletas y dem.velocíp.',10,'87','8714','871494');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87149500','Selins de bicicletas e outros ciclos','Saddles of bicycles and other cycles','Sillines de bicicletas y demás velocípedos',11,'87','8714','871495');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87149600','Pedais, pedaleiros e suas partes, para bicicletas, etc.','Pedals,crank-gear and parts thereof,f/bicycles,etc.','Pedales, mecanismos de pedal y sus partes, p/biciclet.etc',10,'87','8714','871496');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87149900','Outras partes e acess.p/bicicletas e outras ciclos','Oth.parts and access.f/bicycles and other cycles','Las demás partes y acces.p/bicicletas y demás velocíp.',10,'87','8714','871499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87149910','Câmbio de velocidades p/bicicletas e outras ciclos','Speed changers f/bicycles and other cycles','Cambio de velocidades p/bicicletas y demás velocíp.',10,'87','8714','871499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87149990','Outras partes e acess.p/bicicletas e outras ciclos','Other parts and access.f/bicycles and other cycles','Las demás partes y acces.p/bicicletas y demás velocíp.',10,'87','8714','871499');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87150000','Carrinhos, veic.semelh.e suas partes, p/transp.crianças','Baby carriages,similar vehicles and parts thereof','Coches, vehíc.simil.y sus partes, p/transp.de niños',10,'87','8715','871500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87161000','Reboques/semi-reboques p/habitação/acampar "trailer"','Trailers/semi-trailers f/housing or camping','Remolques/semirremolques p/vivienda/acampada, tipo carav',11,'87','8716','871610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87162000','Reboques/semi-reboques autocarregáveis, etc.uso agrícola','Trailers/self-unload.semi-trailers,etc.f/agricul.purp.','Remolques/semirremolques autocargadores, etc.uso agríc.',11,'87','8716','871620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87163100','Reboques-cisternas para transporte de mercadorias','Tanker trailers for the transport of goods','Remolques cisternas para transporte de mercancías',11,'87','8716','871631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87163900','Outros reboques e semi-reboques p/transp.de mercadorias','Oth.tanker trailers semi-trailers f/the transp.of goods','Los dem.remolques y semirremolques p/transp.de merc.',11,'87','8716','871639');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87164000','Outros reboques e semi-reboques','Other tanker trailers semi-trailers','Los demás remolques y semirremolques',11,'87','8716','871640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87168000','Outros veículos não autopropulsores','Other vehicles no no self-propellers','Los demás vehículos no automóviles',11,'87','8716','871680');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87169010','Chassis de reboques e semi-reboques','Chassis for trailers and semi-trailers','Chasis de remolques y semirremolques',11,'87','8716','871690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('87169090','Outs.partes de reboques/semi-reboques/veic.n/autopropul','Oth.parts of trailers/semi-trailers/vehicl.n/self-prop.','Las dem.partes de remolques/semirremolques/vehíc.n/aut.',10,'87','8716','871690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88010000','Planadores e asas voadoras','Gliders and hang gliders','Planeadores y alas planeadoras',11,'88','8801','880100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88011000','Planadores e asas voadoras','Gliders and hang gliders','Planeadores y alas planeadoras',11,'88','8801','880110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88019000','Balões, dirigíveis e outs.veículos aéreos n/motorizados','Balloons,dirigibles and other aircraft n/motorized','Globos, dirigibles y demás aeronaves s/motor',11,'88','8801','880190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88021100','Helicópteros de peso<=2000kg, vazios','Helicopters of weight<=2000kg,empty','Helicópteros de peso en vacío<=2000kg',11,'88','8802','880211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88021210','Helicópteros de 2000kg<peso<=3500kg, vazios','Helicopters 2000kg<weight<=3500kg,empty','Helicópteros de 2000kg<peso en vacío<=3500kg',11,'88','8802','880212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88021290','Outros helicópteros de peso>3500kg, vazios','Other helicopters of weight>3500kg,empty','Los dem.helicópteros de peso en vacío>3500kg',11,'88','8802','880212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88022010','Aviões a hélice, etc.peso<=2000kg, vazios','Propeller-driven aeroplanes,etc.weight<=2000kg,empty','Aviones a hélice, etc.peso en vacío<=2000kg',11,'88','8802','880220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88022021','Aviões a turboélice, etc.monomotores, p<=2000kg, vazios','Airplanes,turboprop,etc.single-engine<=2000kg,empty','Aviones a turbohélice, etc.monomotores, p.en vac.<=2000kg',11,'88','8802','880220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88022022','Aviões a turboélice, etc.multimotores, p<=2000kg, vazios','Airplanes,turboprop,etc,etc.multi-engine<=2000kg,empty','Aviones a turbohélice, etc.multimotores, p.vacío<=2000kg',11,'88','8802','880220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88022090','Outros aviões/veículos aéreos, peso<=2000kg, vazios','Other aeroplanes/aircraft,weight<=2000kg,empty','Los demás aviones/aeronaves, peso en vacío<=2000kg',11,'88','8802','880220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88023010','Aviões a hélice, etc.2000kg<peso<=15000kg, vazios','Propeller-driven aeropl.etc.2000kg<weight<=15000,empty','Aviones a hélice, etc.2000kg<peso en vacío<=15000kg',11,'88','8802','880230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88023021','Aviões a turboélice, etc.multimotores, 2t<peso<=7t, vazios','Airplanes,turbopr.etc.multi-engine,2t<weight<=7t,empty','Aviones a turbohélice, etc.multimotores, 2t<p en vac.<=7t',11,'88','8802','880230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88023029','Outros aviões a turboélice, etc.7t<peso<=15t, vazios','Oth.airplanes,turboprop,etc.2t<weight<=7t,empty','Los dem.aviones a turbohélice, etc.7t<peso en vacío<=15t',11,'88','8802','880230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88023031','Aviões a turbojato, etc.2000kg<peso<=7000kg, vazios','Airplanes,turbojet,etc.2000kg<weight<=7000kg,empty','Aviones a turborreac.etc.2000kg<peso en vacío<=7000kg',11,'88','8802','880230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88023039','Outs.aviões a turbojato, etc.7000kg<peso<=15000kg, vazios','Oth.airplan. turbojet,etc.7000kg<weight<=15000kg,empty','Los dem.aviones a turborreac.etc.7000kg<p.vac.<=15000kg',11,'88','8802','880230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88023090','Outs.aviões/veículos aereos, 2000kg<peso<=15000kg, vazios','Oth.airplan./aircraft,2000kg<weight<=15000kg,empty','Los dem.aviones/aeronaves, 2000kg<peso en vacío<=15000kg',11,'88','8802','880230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88024010','Aviões a turbohélice, etc.peso>15000kg, vazios','Airplanes,turboprop,etc,weight>15000kg,empty','Aviones a turbohélice, etc.peso en vacío>15000kg',11,'88','8802','880240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88024090','Outros aviões/veículos aéreos, peso > 15000 Kg, vazios','Oth.airplanes/aircraft,weight>15000kg,empty','Los demás aviones/aeronaves, peso en vacío>15000kg',11,'88','8802','880240');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88026000','Veículos espaciais e seus veículos de lançamento, etc.','Spacecraft and its spacecraft launch vehicles,etc.','Vehículos espaciales y sus vehículos de lanzamiento, etc',11,'88','8802','880260');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88031000','Hélices, rotores e suas partes, p/veículos aéreos, etc.','Propellers,rotors and parts thereof f/aircraft,etc.','Hélices, rotores y sus partes, p/aeronaves, etc',10,'88','8803','880310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88032000','Trens de aterrissagem e suas partes, p/veic.aéreos, etc.','Under-carriages and parts thereof f/aircraft,etc.','Trenes de aterrizaje y sus partes, p/aeronaves, etc',10,'88','8803','880320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88033000','Outras partes para aviões ou helicópteros','Other parts of aeroplanes or helicopters','Las demás partes p/aviones o helicópteros',10,'88','8803','880330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88039000','Outras partes para veículos aéreos/espaciais','Other parts for aircraft/space','Las demás partes p/aeronaves/vehíc.espaciales',10,'88','8803','880390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88040000','Pára-quedas/pára-quedas giratórios, suas partes e acess.','Parachutes/rotochutes,its parts and access.','Paracaídas/de aspas giratorias, sus partes y acces.',10,'88','8804','880400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88051000','Aparelhos e disposit.p/lancam.de veic.aereo, etc.partes','Apparatus and devices f/aircraft launching,etc.parts','Aparatos y disposit.p/lanzam.de aeronaves, etc.partes',10,'88','8805','880510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88052000','Aparelhos simuladores de voo em terra e suas partes','Flight simulators apparatus and parts thereof','Aparatos entrenamiento de vuelo en tierra y sus partes',10,'88','8805','880520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88052100','Simuladores de combate aéreo e suas partes','Air combat simulators and parts thereof','Simuladores de combate aéreo y sus partes',10,'88','8805','880521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('88052900','Outs.apars.de treinamento de voo em terra, etc','Other ground flight training apparatus,etc','Los dem.apars.de entrenamiento de vuelo en tierra, etc',10,'88','8805','880529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89011000','Transatlânticos, barcos de cruzeiro, "ferry-boats", etc.','Cruise ships, excursion boats, ferry-boats,etc','Transatlánticos, barcos para excursión, transbordadores, etc',11,'89','8901','890110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89012000','Navios-tanque','Tankers ships','Barcos cisterna',11,'89','8901','890120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89013000','Barcos frigoríficos, exceto os navios-tanque','Refrigerated vessels, excluding tankers','Barcos frigoríficos, excluídos los barcos cisterna',11,'89','8901','890130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89019000','Outs.embarcações p/transp.mercadorias ou pessoas/mercad','Oth.vessels f/the transp.of goods or persons/goods','Los dem.barcos p/transp.mercancías o personas/merc.',11,'89','8901','890190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89020010','Barcos de pesca, navios-fábricas, etc.comprimento>=35m','Fishing vessels,factory ships,etc.length>=35m','Barcos de pesca, barcos factoría, etc.c/eslora>=35m',11,'89','8902','890200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89020090','Outros barcos de pesca, navios-fábricas, etc.','Other fishing vessels,factory ships,etc.','Los demás barcos de pesca, barcos factoría, etc',11,'89','8902','890200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89031000','Barcos infláveis','Inflatable boats','Embarcaciones inflables',11,'89','8903','890310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89039100','Barcos a vela, mesmo com motor auxiliar','Sailboats,with or without auxiliary motor','Barcos de vela, incluso con motor auxiliar',11,'89','8903','890391');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89039200','Barcos a motor, exceto com motor fora-de-borda','Motor-boats, other than outboard motor-boats','Barcos de motor, excepto con motor fueraborda',11,'89','8903','890392');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89039900','Outs.barcos/embarcações de recreio/esporte, incl.canoas','Other vessels for pleasure or sports,incl.canoes','Los demás barcos/embarc.de recreo/deporte, incl.canoas',11,'89','8903','890399');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89040000','Rebocadores e barcos para empurrar outras embarcações','Tugs and pusher craft','Remolcadores y barcos empujadores',11,'89','8904','890400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89051000','Dragas','Dredgers','Dragas',11,'89','8905','890510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89052000','Plataformas de perfuração/exploração, flutuantes, etc.','Floating/submersible drilling or product.platforms,etc.','Plataformas de perforación/explotación, flotantes, etc',11,'89','8905','890520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89059000','Barcos-farois/quindastes/docas/diques flutuantes, etc.','Light-vessels/floating cranes/docks/flotation dikes,etc','Barcos faro/guindastes/diques flotantes, etc',11,'89','8905','890590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89060000','Outras embarcações','Other vessels','Los demás barcos',11,'89','8906','890600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89061000','Navios de guerra','Warships','Navíos de guerra',11,'89','8906','890610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89069000','Outras embarcações, inclusive barco salva-vidas','Other vessels, including lifeboats','Los demás barcos, incluso barcos de salvamento',11,'89','8906','890690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89071000','Balsas infláveis','Inflatable rafts','Balsas inflables',11,'89','8907','890710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89079000','Outras estruturas flutuantes','Other floating structures','Los demás artefactos flotantes',11,'89','8907','890790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('89080000','Embarcações e outras estruturas flutuantes p/demolicao','Vessels and other floating structures f/breaking up','Barcos y demás artefactos flotantes p/desguace',11,'89','8908','890800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90011011','Fibras ópticas, diâmetro de núcleo<11microns','Optical fibres,nucleus diam.<11micron','Fibras ópticas, diámetro de núcleo<11micrómetros',10,'90','9001','900110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90011019','Outras fibras ópticas','Other optical fibres','Las demás fibras ópticas',10,'90','9001','900110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90011020','Feixes e cabos de fibras ópticas','Optical fibre bundles and cables','Haces y cables de fibras ópticas',10,'90','9001','900110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90012000','Matérias polarizantes, em folhas e placas','Sheets and plates of polarising material','Hojas y placas de materia polarizante',10,'90','9001','900120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90013000','Lentes de contato','Contact lenses','Lentes de contacto',11,'90','9001','900130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90014000','Lentes de vidro, para óculos','Spectacle lenses of glasses','Lentes de vidrio p/gafas',11,'90','9001','900140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90015000','Lentes de outras matérias, para óculos','Spectacle lenses of other materials','Lentes de otras materias p/gafas',11,'90','9001','900150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90019010','Outras lentes não montadas','Other lenses, not mounted','Las demás lentes s/montar',10,'90','9001','900190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90019090','Prismas, espelhos e outs.elementos de óptica, não montados','Prisms,mirrors and other optical elements, not mounted','Prismas, espejos y dem.elementos de óptica, s/montar',10,'90','9001','900190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90021110','Lentes objetiv.montadas, p/cameras fotograf.projetor, etc','Mounted object.lenses,f/photog.cameras or f/project.etc','Lentes objetivos, montad., p/cámaras fotogr.proyector, etc',11,'90','9002','900211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90021120','Lentes objetivas montadas, "zoom">=20, p/camera televisão','Mounted object.lenses,zoom>=20,f/television cameras','Lentes objetivos montad.de aproxim.>=20, p/cámara telev.',11,'90','9002','900211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90021190','Outs.lentes objetiv.montadas, p/cameras, apars.fotograf.','Oth.mounted object.lenses f/cameras,photogr.apparatus','Los dem.lentes objetivos, montad.p/cámaras, apars.fotogr.',11,'90','9002','900211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90021900','Outras lentes objetivas montadas','Other mounted objective lenses','Los demás lentes objetivos, montados',11,'90','9002','900219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90022010','Filtros polarizantes, montados','Mounted polarizing filters','Filtros polarizantes, montados',10,'90','9002','900220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90022090','Outros filtros ópticos, montados','Mounted  optical filters','Los demás filtros ópticos, montados',10,'90','9002','900220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90029000','Outras lentes, prismas e elementos de óptica, montados','Oth.lenses,prisms,mirrors and oth.optical elemen.mount.','Los dem.lentes, prismas y elementos de óptica, montados',10,'90','9002','900290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90031100','Armações de plásticos, para óculos','Frames of plastics, for glasses','Monturas de plásticos, para gafas',11,'90','9003','900311');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90031910','Armações de metais comuns, p/óculos, mesmo folheado, etc.','Frames of base metal,f/glass,incl.veneer,etc','Monturas de metales comunes, de gafas, incl.chapados, etc',11,'90','9003','900319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90031990','Armações de outras matérias, para óculos','Frames of other materials,for glasses','Monturas de otras materias, de gafas',11,'90','9003','900319');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90039010','Charneiras para armações de óculos','Hinges for frames of glasses','Bisagras para monturas de gafas',10,'90','9003','900390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90039090','Outras partes p/armações de óculos e artigos semelhs.','Other parts for frames of glasses and similar articles','Las dem.partes p/monturas de gafas y artículos simil.',10,'90','9003','900390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90041000','Óculos de sol','Sunglasses','Gafas de sol',11,'90','9004','900410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90049010','Óculos para correção','Corrective spectacles','Gafas correctoras',11,'90','9004','900490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90049020','Óculos de segurança','Safety glasses','Gafas de seguridad',11,'90','9004','900490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90049090','Outs.óculos p/proteção ou outros fins e artigos semelh.','Oth.goggles/oth.and the like and similar articles','Las dem.gafas protectoras u otras y artículos simil.',11,'90','9004','900490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90051000','Binóculos','Binoculars','Binoculares',11,'90','9005','900510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90058000','Lunetas e outs.instrumentos de astronomia, suas armações','Monoculars other astronomy instrumets,its mountings','Catalejos y dem.instrument.de astronomía, sus armazones',11,'90','9005','900580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90059010','Partes e acessórios de binóculos','Parts and accessories of binoculars','Partes y accesorios de binoculares',10,'90','9005','900590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90059090','Partes e acessórios de lunetas e outros instrumentos de astronomia','Parts and access.of monoculars and oth.astron.instrum.','Partes y acces.de catalejos y dem.instrum.de astronomía',10,'90','9005','900590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90061000','Apars.fotograf.p/prepar.de cliches/cilindros de impress','Photogr.cameras f/preparing printing plates/cylinders','Cámar.fotogr.util.p/prepar.clisés/cilindros de imprenta',11,'90','9006','900610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90061010','Fotocompositoras a laser para preparacao de cliches','Fotocompositoras a laser para preparacao de cliches','Fotocompositoras a laser para preparacao de cliches',11,'90','9006','900610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90061090','Outras cameras fotog p/ prep cliches/cilindros impressa','Outras cameras fotog p/ prep cliches/cilindros impressa','Outras cameras fotog p/ prep cliches/cilindros impressa',11,'90','9006','900610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90062000','Apars.fotograf.p/registro de docum.em microfilmes, etc.','Photog.cameras f/recording documents on microfilm,etc','Cám.fotográf.p/registrar docum.en microfilmes, etc',11,'90','9006','900620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90063000','Aparelhos fotograf.p/fotografia submarina, aerea, etc.','Phot.cam.designed f/a kind used f/underwater,aerial,etc','Cámaras especiales p/fotografía submarina, aérea, etc',11,'90','9006','900630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90064000','Aparelhos fotograf.p/filmes de revelacao/copiag.instant','Instant print photographic cameras','Cámaras fotográficas c/autorrevelado',11,'90','9006','900640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90065100','Apars.fotograf.c/visor reflex.p/filmes, em rolos, l<=35mm','Phot.cam.with through-the-lens view.f/roll film,w<=35mm','Cám.fotogr.c/visor reflex.p/películas en rollo, a<=35mm',11,'90','9006','900651');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90065200','Outs.aparelhos fotográficos, p/filmes, em rolos, l<35mm','Other photographic cameras f/roll film,w<35mm','Las dem.cámaras fotográficas, p/pelíc en rollo, a<35mm',11,'90','9006','900652');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90065310','Apars.fotograf.de foco fixo, p/filmes, em rolos, l=35mm','Fixed focus photographic cameras,f/roll film,w=35mm','Cám.fotográf.de foco fijo, p/películas en rollo, a=35mm',11,'90','9006','900653');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90065320','Apars.fotograf.de foco ajustav.p/filmes, em rolos, l=35mm','Adjustable focus photograph.cameras,f/roll film,w=35mm','Cám.fotográf.de foco ajustab.p/pelíc.en rollo, a=35mm',11,'90','9006','900653');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90065910','Outros aparelhos fotográficos, de foco fixo','Other fixed focus photographic cameras','Las demás cámaras fotográficas, de foco fijo',11,'90','9006','900659');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90065920','Outros aparelhos fotográficos, de foco ajustável','Other adjustable focus photographic cameras','Las demás cámaras fotográficas, de foco ajustable',11,'90','9006','900659');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90065921','Apars.fotográficos, de foco ajustável, p/negat>=45mmx60mm','Adjustable focus photogr.cameras,f/negatives>=45mmx60mm','Cám.fotográficas, de foco ajustable, p/negat>=45mmx60mm',11,'90','9006','900659');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90065929','Outros aparelhos fotográficos, de foco ajustável','Other adjustable focus photographic cameras','Las demás cámaras fotográficas, de foco ajustable',11,'90','9006','900659');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90066100','Apars.de tubo de descarga, p/produção de luz-relampago','Discharge tube apparatus f/production of flashlight','Apars.de tubo de descarga, p/la producción de destellos',11,'90','9006','900661');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90066200','Lâmpadas, cubos e semelh.de luz relampago p/fotografia','Flashbulbs,flashcubes and the like f/picture','Lámparas, cubos de destello p/fotografía',11,'90','9006','900662');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90066900','Outros aparelhos e dispositivos para fotografia','Other apparatus and devices for picture','Los demás aparatos y dispositivos para fotografía',11,'90','9006','900669');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90069110','Corpos para aparelhos fotográficos','Cases for photographic apparatus','Cuerpos para cámaras fotográficas',10,'90','9006','900691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90069190','Outras partes e acess.p/aparelhos fotográficos','Other parts and accessories f/photographic apparatus','Las demás partes y acces.p/cámaras fotográficas',10,'90','9006','900691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90069900','Outs.partes e acess.p/aparelhos e disposit.p/fotografia','Other parts and acces.f/picture apparatus and devices','Las dem.partes y acces.p/aparatos y disp.p/fotografía',10,'90','9006','900699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90071000','Câmeras','Cameras','Cámaras',11,'90','9007','900710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90071100','CÂmeras cinematograf.p/filmes de l<16mm ou "duplo-8mm"','Cinematog.cameras f/ film of w<16mm or f/double 8mm','Cámaras cinematográf.p/película de a<16mm o doble 8mm',11,'90','9007','900711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90071900','Outras câmeras cinematográficas','Other cinematographic cameras','Las demás cámaras cinematográficas',11,'90','9007','900719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90072010','Projetores cinematográficos, p/filmes de l<16mm','Cinematographic projectors,f/film of w<16mm','Proyectores cinematográficos, p/películas de a<16mm',11,'90','9007','900720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90072020','Projetores para filmes, largura>=35mm, mas <=70mm','Projectors for movies, width >=35 mm, but <=70 mm','Proyectores de películas, ancho >= 35mm, pero <=70mm',11,'90','9007','900720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90072090','Outros projetores cinematográficos','Other cinematographic projectors','Los demás proyectores cinematográficos',11,'90','9007','900720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90072091','Outs.projetores cinematograf.p/filmes 35mm<=larg<=70mm','Oth.cinematog.projectors f/film 35mm<=w<=70mm','Los dem.proyectores cinematogr.p/pelíc.35mm<=anch<=70mm',11,'90','9007','900720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90072099','Outros projetores cinematográficos','Other cinematographic projectors','Los demás proyectores cinematográficos',11,'90','9007','900720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90079100','Partes e acessórios para câmeras cinematográficas','Parts and accessories for cinematographic camaras','Partes y acces.para cámaras cinematográficas',10,'90','9007','900791');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90079200','Partes e acessprios para projetores cinematográficos','Parts of access.f/cinematographic projectors','Partes y acces.p/proyectores cinematográficos',10,'90','9007','900792');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90081000','Projetores de diapositivos','Slide projectors','Proyectores de diapositivas',11,'90','9008','900810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90082010','Leitoras de microfilmes','Microfilm readers','Lectores de microfilmes',11,'90','9008','900820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90082090','Leitoras de microfichas/outros microformatos, etc.','Microfiche readers/other microform,etc.','Lectores de microfichas/otros microformatos, etc',11,'90','9008','900820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90083000','Outros projetores de imagens fixas','Other image projectors','Los demás proyectores de imagen fija',11,'90','9008','900830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90084000','Aparelhos fotograf.de ampliacao ou de reducao','Photographic (oth.than cinemat.)enlargers and reducers','Ampliadoras o reductoras fotográficas',11,'90','9008','900840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90085000','Projetores e aparelhos de ampliacao ou reducao','Projectors and apparatus for enlarging or reducing','Proyectores y aparatos p/ la ampliación o la reducción',11,'90','9008','900850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90089000','Partes e acess.p/aparelhos de projeção fixa, etc.','Parts and access.f/image projectors,etc','Partes y acces.p/proyectores de imagen fija, etc',10,'90','9008','900890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90091100','Aparelhos de reprod.direta de fotocopia, eletrostatico','Appar.f/repr.original image direc.onto copy,electr.','Aparatos por proced.directo de fotocopia, electrostático',11,'90','9009','900911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90091210','Apars.de reprod.indir.de fotocopia monocrom.eletrostat.','Appar.f/indirec.reprod.of photocopy monochrom.electr.','Apars.por proced.indir.de fotocopia monocrom.electrost.',11,'90','9009','900912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90091290','Outs.aparelhos de fotocopia, eletrostat.proc.indireto','Oth.photocopying appar.,electr.(indirec.proces.)','Los dem.aparatos de fotocopia, electrost.proc.indirecto',11,'90','9009','900912');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90092100','Aparelhos de fotocópia, por sistema óptico','Photocopying apparatus,incorporating an optical system','Aparatos de fotocopia, por sistema óptico',11,'90','9009','900921');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90092200','Aparelhos de fotocópia, por contato','Photocopying apparatus,of the contact type','Aparatos de fotocopia, de contacto',11,'90','9009','900922');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90093000','Aparelhos de termocópia','Thermo-copying apparatus','Aparatos de termocopia',11,'90','9009','900930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90099010','Cilindro recob.selenio p/apars.fotocopia, reprod.indir.','Cylinder covered of selenium f/photoc.appar.ind.reprod.','Tambor recub.selenio p/apars.fotocopia, proced.indir.',10,'90','9009','900990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90099090','Partes e acess.p/outs.aparelhos de fotocopia/termocopia','Parts and access.f/oth.photoc.appar./thermo-copying','Partes y acces.p/ots.aparatos de fotocopia/termocopia',10,'90','9009','900990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90099100','Dispositiv.automat.alim.docum.p/apars.fotocop','Automatic document feeders f/photocopyng apparatus','Alimentadores automát.docum.p/apars.fotocop.',10,'90','9009','900991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90099200','Dispositiv.aliment.de papel p/apars.fotocopia','Paper feeders f/photocopyng apparatus','Alimentadores de papel p/apars.fotocopia',10,'90','9009','900992');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90099300','Dispositivos de triagem p/apars.fotocopia','Sorters f/photocopyng apparatus','Clasificadores p/apars.fotocopia',10,'90','9009','900993');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90099910','Cilindros recob.mat.semicondut.p/apars.fotoc.','Cylinder covered semiconduc.mater.f/photocop.apparatus','Tambor recub.mat.semiconduct.p/apars.fotoc.',10,'90','9009','900999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90099990','Outs.partes e acess.p/apars.fotocopia','Oth.parts of access.f/photocopying apparatus','Las demás partes y acces.p/apars.fotocopia',10,'90','9009','900999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90101010','Cubas e cubetas automat.progr.eletron.p/revel.filmes','Tanks/trays autom.electr.program.f/developing photogr.','Cubas y cubetas automát.progr.electrón.p/revel.pelíc.',11,'90','9010','901010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90101020','Ampliadoras-copiadoras automat.p/papel fotograf>1000c/h','Enlarging and printing mach.autom.f/phot.paper>1000c/h','Ampliadoras-copiadoras automát.p/papel fotográf>1000c/h',11,'90','9010','901010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90101090','Outs.apars.e mater.p/revel.automat.filmes fotograf.etc.','Other appar./equipment f/autom.devel.photographic,etc','Los dem.apars.y mater.p/revelado autom.pelíc.fotogr.etc',11,'90','9010','901010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90104100','Aparelhos para inscrição em disco ("wafers")','Direct write-on-wafer apparatus','Aparatos p/trazado directo sobre obleas ("wafers")',11,'90','9010','901041');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90104200','Fotorrepetidores','Step and repeat aligners','Fotorrepetidores',11,'90','9010','901042');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90104900','Outs.apars.p/projeção, etc.de tracados de circuitos, etc.','Oth.appar.f/projection,etc of circuits patterns,etc.','Los dem.apars.p/proyectar, etc.esquemas de circuitos, etc',11,'90','9010','901049');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90105010','Equipamento processad.fotograf.p/tratam.eletron.imagens','Proc.equipment f/electronic treatment of images','Equipo procesador fotogr.p/el tratam.electrón.imágenes',11,'90','9010','901050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90105020','Apar p/ revel autom chapas de fotopol c/ suport metalic','Apar p/ revel autom chapas de fotopol c/ suport metalic','Apar p/ revel autom chapas de fotopol c/ suport metalic',11,'90','9010','901050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90105090','Outs.apars.e mater.p/laborat.fotograf.cinematograf.etc.','Oth.appar.and equip.f/photog.(incl.cinem.)labor.etc.','Los dem.apars.y mater.p/laborat.fotogr.cinematográf.etc',11,'90','9010','901050');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90106000','Telas p/projeção fotográfica/cinematografica','Projection screens f/photographic/cinematographic','Pantallas de proyección fotográfica/cinematográfica',11,'90','9010','901060');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90109010','Partes e acess.p/apars.revel.automat.pelic.fotograf.etc','Parts and access.f/autom.developed photographic,etc','Partes y acces.p/apars.revelado autom.pelíc.fotogr.etc',10,'90','9010','901090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90109090','Partes e acess.p/outs.apars.util.laborat.fotograf.etc.','Parts and access.f/autom.developed photographic,etc','Partes y acces.p/ots.apars.util.laborat.fotográf.etc',10,'90','9010','901090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90111000','Microscópios ópticos estereoscópicos','Stereoscopic optical microscopes','Microscopios ópticos estereoscópicos',11,'90','9011','901110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90112010','Microscópios para fotomicrografia','Microscopes for photomicrography','Microscopios para fotomicrografía',11,'90','9011','901120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90112020','Microscópios para cinefotomicrografia','Microscopes for cinephotomicrography','Microscopios para cinefotomicrografía',11,'90','9011','901120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90112030','Microscópios para microprojeção','Microscopes for microprojection','Microscopios para microproyección',11,'90','9011','901120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90118010','Microscópios ópticos binoculares de platina movel','Binocular microscopes with mobile specimen stage','Microscopios ópticos binoculares de platina móvil',11,'90','9011','901180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90118090','Outros microscópios ópticos','Other optical microscopes','Los demás microscopios ópticos',11,'90','9011','901180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90119010','Partes e acess.p/microscópios p/fotomicrografia, etc.','Parts of access.f/microscopes for photomicrography,etc','Partes y acces.p/microscopios p/fotomicrografía, etc',10,'90','9011','901190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90119090','Partes e acessórios para microscópios ópticos','Parts and accessories for optical microscopes','Partes y accesorios para microscopios ópticos',10,'90','9011','901190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90121010','Microscópios eletrônicos','Electronic microscopes','Microscopios electrónicos',11,'90','9012','901210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90121090','Outros microscópios e difratógrafos','Other microscopes and diffraction','Los demás microscopios y difractógrafos',11,'90','9012','901210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90129010','Partes e acessórios para microscópios eletrônicos','Parts and accessories for electronic microscopes','Partes y acces.para microscopios electrónicos',10,'90','9012','901290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90129090','Partes e acess.p/outros microscópios e difratógrafos','Parts and access.f/oth.microscopes and diffraction','Partes y acces.p/otros microscopios y difractógrafos',10,'90','9012','901290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90131010','Miras telescópicas para armas','Telescopic sights for fitting to arms','Miras telescópicas para armas',11,'90','9013','901310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90131090','Periscópios, lunetas p/máquinas apars.e instrum.ópticos','Periscopes,telescopes f/optical mach.appl.instruments','Periscopios, visores p/máquinas, apars.y instrum.ópticos',11,'90','9013','901310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90132000','"Lasers", exceto os diodos "laser"','Lasers, other than laser diodes','Láseres, excepto los diodos láser',11,'90','9013','901320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90138010','Dispositivos de cristais líquidos (lcd)','Liquid crystal devices (lcd)','Dispositivos de cristal líquido (lcd)',11,'90','9013','901380');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90138090','Outros dispositivos, aparelhos e instrumentos ópticos','Other devices,optical appliances and instruments','Los dem.dispositivos, aparatos y instrumentos ópticos',11,'90','9013','901380');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90139000','Partes e acess.de miras telescópicas, periscópios, etc.','Parts and access.of telescopic sights,periscopes,etc.','Partes y acces.de miras telescópicas, periscopios, etc',10,'90','9013','901390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90141000','Bússolas, inclusive as agulhas de marear','Direction finding compasses','Brújulas, incl.los compases de navegación',11,'90','9014','901410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90142010','Altimetros para navegação aérea ou espacial','Height measure for aeronautical or space navigation','Altímetros para navegación aérea o espacial',11,'90','9014','901420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90142020','Pilotos automáticos para navegação aérea/espacial','Automat.pilots f/aeronautical or space navigation','Pilotos automáticos p/navegación aérea/espacial',11,'90','9014','901420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90142030','Inclinômetros para navegação aérea/espacial','Inclinometers for aeronautical or space navigation','Inclinómetros p/navegación aérea/espacial',11,'90','9014','901420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90142090','Outs.instrumentos e apars.p/navegação aerea/espacial','Oth.instrum.and applian.f/aeronautical/space navigation','Los dem.instrumentos y apars.p/naveg.aérea/espacial',11,'90','9014','901420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90148010','Sondas acústicas ou de ultra-sons para navegação','Echo sounding or ultrasonic sounding f/navigation','Sondas acústicas o de ultrasonido p/navegación',11,'90','9014','901480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90148090','Outros aparelhos e instrumentos para navegação','Other instruments and appliances f/navigation','Los demás aparatos y instrumentos p/navegación',11,'90','9014','901480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90149000','Partes e acess.p/instrumentos e aparelhos p/navegação','Parts and acess.f/instrum.and appliances f/navigation','Partes y acces.p/instrumentos y aparatos p/navegación',10,'90','9014','901490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90151000','Telêmetros','Rangefinders','Telémetros',11,'90','9015','901510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90152010','Teodolitos e taqueômetros, leit.por prisma, etc.prec=1seg','Theodolites and tachymeters,with prism,etc.prec=1sec','Teodolitos y taquímetros, lect.por prisma, etc.prec=1seg',11,'90','9015','901520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90152090','Outros teodolitos e taqueômetros','Other theodolites and tachymeters','Los demás teodolitos y taquímetros',11,'90','9015','901520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90153000','Níveis','Levels','Niveles',11,'90','9015','901530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90154000','Instrumentos e aparelhos de fotogrametria','Photogrammetrical,surveying instruments and appliances','Instrumentos y aparatos de fotogrametría',11,'90','9015','901540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90158010','Molinetes hidrométricos','Bucket-wheel current meters/hydrometric paddle wheels','Molinetes hidrométricos',11,'90','9015','901580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90158090','Outs.instrumentos e apars.de geodesia, topografia, etc.','Oth.instrum.and applian.used in geodesy,topography,etc','Los dem.instrumentos y apars.de geodesia, topografía, etc',11,'90','9015','901580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90159010','Partes e acess.de instrumentos e apars.de fotogrametria','Parts and acess.of photogrammetric.instrum.and applian.','Partes y acces.de instrumentos y apars.de fotogrametría',10,'90','9015','901590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90159090','Partes e acess.de instrumentos e apars.de geodesia, etc.','Parts/acess.of instrum./applian.used geodesy,topog.etc.','Partes y acces.de instrumentos y apars.de geodesia, etc',10,'90','9015','901590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90160010','Balanças sensíveis a pesos <= 0.2mg','Balances of a sensitivity of weight<=0.2mg','Balanzas sensibles a un peso<=0.2mg',11,'90','9016','901600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90160090','Balanças sensíveis a 0.2mg<pesos<=50mg, com/sem pesos','Balances of sensit.of 0.2mg<w<=50mg,with/without weig.','Balanzas sensibles a 0.2mg<pesos<=50mg, incl.con pesas',11,'90','9016','901600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90171010','Mesas e máquinas de desenhar, automáticas','Drafting tables and machines,automatic','Mesas y máquinas de dibujar, automáticas',11,'90','9017','901710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90171090','Outras mesas e máquinas de desenhar','Other drafting tables and machines','Las demás mesas y máquinas de dibujar',11,'90','9017','901710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90172000','Outros instrumentos de desenho, de tracado ou de calculo','Oth.drawing marking-out or mathemat.calcul.intruments','Los dem.instrumentos de dibujo, trazado o cálculo',11,'90','9017','901720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90173010','Micrômetros (instrumento de medida manual de distancia)','Micrometers(instrument of manual distances measure)','Micrómetros (instrumento manual de medida de longitud)',11,'90','9017','901730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90173020','Paquimetros (instrumento de medida manual de distancia)','Micrometers(instrument of manual distances measure)','Pies de rey (instrumento manual de medida de longitud)',11,'90','9017','901730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90173090','Calibres e semelhs.(instrum.medida manual de distancia)','Callipers and similar(instrum.of manual distan.measure)','Calibradores y simil(instrum.man.de medida de longitud)',11,'90','9017','901730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90178010','Metros (instrumentos de medida manual de distancias)','Meters(instrument of manual distances measure)','Metros (instrumento manual de medida de longitud)',11,'90','9017','901780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90178090','Outros instrumentos de medida manual de distancias','Other instrument of manual distances measure','Los demás instrumentos manuales de medida de longitud',11,'90','9017','901780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90179010','Partes e acess.de mesas e máquinas de desenhar, automat.','Parts and acces.of autom.drafting tables and machines','Partes y acces.de mesas y máquinas de dibujar, automát.',10,'90','9017','901790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90179090','Partes e acess.de outs.instrum.de desenho, medida, etc.','Parts and acces.of oth.drawing intruments,measured,etc','Partes y acces.de ots.instrum.de dibujo, medida, etc',10,'90','9017','901790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90181100','Eletrocardiógrafos','Electrocardiographs','Electrocardiógrafos',11,'90','9018','901811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90181210','Ecógrafos com análise espectral doppler','Echographs with doppler spectrum analysis','Ecógrafos con análisis espectral doppler',11,'90','9018','901812');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90181290','Outs.aparelhos de eletrodiagnost.varredura ultra-sonica','Other appar. of eletrodiag. by ultrasonic scanning ','Los dem.aparatos de electrodiagnóst.explor.ultrasónica',11,'90','9018','901812');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90181300','Aparelhos de diagnost.por visualiz.ressonancia magnet.','Magnetic resonance imaging apparatus','Aparatos de diagnóst.de visualiz.resonancia magnét.',11,'90','9018','901813');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90181400','Aparelhos de cintilografia','Scintigraphic apparatus','Aparatos de centellografía',11,'90','9018','901814');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90181410','"Scanner" de tomografia por emissão de positrons','Positron emission tomography scanner','Scanner de tomografía por emisión de positrones',11,'90','9018','901814');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90181420','Câmaras gama','Gamma chambers','Cámaras gamma',11,'90','9018','901814');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90181490','Outros aparelhos de cintilografia','Other scintigraphic apparatus','Los demás aparatos de centellografía',11,'90','9018','901814');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90181910','Endoscópios','Endoscopy','Endoscopios',11,'90','9018','901819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90181920','Audiômetros','Audiometers','Audiómetros',11,'90','9018','901819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90181930','Câmaras gama','Gamma chambers','Cámaras gamma',11,'90','9018','901819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90181980','Outros aparelhos de eletrodiagnóstico','Other electro-diagnostic apparatus','Los demás aparatos de electrodiagnóstico',11,'90','9018','901819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90181990','Partes de aparelhos de eletrodiagnóstico','Parts of electro-diagnostic apparatus','Partes de aparatos de electrodiagnóstico',11,'90','9018','901819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90182000','Aparelhos de raios ultravioleta ou infravermelhos','Ultraviolet or infrared ray apparatus','Aparatos de rayos ultravioletas o infrarrojos',11,'90','9018','901820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90182010','Aparelhos para cirurgia, que operem por "laser"','Surgery apparatus,laser type','Aparatos para cirugía, que operen por láser',11,'90','9018','901820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90182020','Outs.apars.p/tratam.bucal, que oper.a "laser"','Other apparatus f/oral treatment,laser type','Los dem.apars.p/tratam.bucal, que operen por láser',11,'90','9018','901820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90182090','Outros aparelhos de raios ultravioleta ou infravermelho','Other ultraviolet or infrared ray apparatus','Los dem.aparatos de rayos ultravioletas o infrarrojos',11,'90','9018','901820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183111','Seringas de plástico, mesmo c/agulhas, capacidade<=2cm3','Syringes of plastic,with or without needles,cap<=2cm3','Jeringas de plástico, incluso c/agujas, capacidad<=2cm3',11,'90','9018','901831');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183119','Outras seringas de plástico, mesmo com agulhas','Other syringes of plastic,with or without needles','Las demás jeringas de plástico, incluso c/agujas',11,'90','9018','901831');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183190','Seringas de outras matérias, mesmo com agulhas','Syringes of other material,with or without needles','Jeringas de otras materias, incluso c/agujas',11,'90','9018','901831');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183211','Agulhas tubulares de metal, gengivais','Tubular metal needles, gums','Agujas tubulares de metal, gingivales',10,'90','9018','901832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183212','Agulhas tubulares de aço cromo-níquel/bisel trifacetado','Tubul.needles,of steel chrome-niquel/three-sided bisel','Agujas tubulares de acero cromo-níquel/bisel tres caras',10,'90','9018','901832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183219','Outras agulhas tubulares de metal','Other tubular metal needles','Las demás agujas tubulares de metal',10,'90','9018','901832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183220','Agulhas para suturas','Needles for sutures','Agujas de sutura',10,'90','9018','901832');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183910','Outras agulhas','Other needles','Las demás agujas',11,'90','9018','901839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183921','Sondas, catéteres e canulas, de borracha','Probes, catheters and stems, of rubber','Sondas, catéteres y cánulas, de caucho',11,'90','9018','901839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183922','Cateter de policloreto vinila, p/embolectomia arterial','Arterial embolectomy catheters of poly(vinyl chloride)','Catéter de policloruro vinilo, p/embolectomía arterial',11,'90','9018','901839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183923','Cateter de policloreto vinila, para termodiluição','Thermodilution catheters of poly(vinyl chloride)','Catéter de policloruro vinilo, p/termodilución',11,'90','9018','901839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183924','Catéteres intravenosos periféricos de poliuretano, etc.','Peripheral intravenous catheters  of poliuretano','Catéteres intravenosos periféricos de poliuretano',11,'90','9018','901839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183929','Outras sondas, catéteres e cânulas','Other probes, catheters and stems','Las demás sondas, catéteres y cánulas',11,'90','9018','901839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183930','Lancetas para vacinação e cautérios','Lancets for vaccination and cauterising','Lancetas p/vacunación y cauterios',11,'90','9018','901839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183990','Outs.instrumentos semelh.seringas, agulhas, catéteres, etc','Oth.syringes,needles,catheters,etc.similar instruments','Los dem.instrums.simil.jeringas, agujas, catéteres, etc',11,'90','9018','901839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183991','Artigo p/fístula arteriovenosa, cont.agulha, base, etc.','Article f/arteriovenous fistula,comp.needle,base,etc.','Artículo p/fistula arteriovenosa, cont.aguja, base, etc',11,'90','9018','901839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90183999','Outs.instrumentos semelh.seringas, agulhas, catéteres, etc','Oth.syringes,needles,catheters,etc.similar instruments','Los dem.instrums.simil.jeringas, agujas, catéteres, etc',11,'90','9018','901839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90184100','Apars.dentários de brocar mesmo c/outs.equip.dentários','Dental drill engines,incl.other dental equipment','Tornos dentales, incluso con otros equipos dentales',11,'90','9018','901841');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90184911','Brocas para odontologia, de carboneto de tungstênio','Dental drill engines, of tungsten carbide','Fresas para odontología, de carburo de tungsteno',11,'90','9018','901849');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90184912','Brocas para odontologia, de aço-vanádio','Dental drill engines, of vanadium steel','Fresas para odontología, de acero al vanadio',11,'90','9018','901849');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90184919','Brocas para odontologia, de outras matérias','Dental drill engines, of other material','Fresas para odontología, de otras materias',11,'90','9018','901849');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90184920','Limas para odontologia','Files for dentistry','Limas para odontología',11,'90','9018','901849');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90184930','Aparelhos operando por "laser" para tratamento bucal','Operating by laser apparatus for use in the mouth','Aparatos que operen por láser p/tratamiento bucal',11,'90','9018','901849');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90184940','Apars.operando por proj.cinet.de partic.p/tratam.bucal','Operat.by kinetic part.projection f/use in the mouth','Apars.q.operen por proy.cinét.de partíc.p/tratam.bucal',11,'90','9018','901849');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90184991','Apars.p/desenho/constr.peca ceram.dentária, computadoriz','Appar.f/build.ceramic parts f/dental use,computadorized','Apars.p/diseño/constr.pieza cerámic.dent., computadoriz.',11,'90','9018','901849');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90184999','Outros instrumentos e aparelhos para odontologia','Other instruments and appliances for dentistry','Los demás instrumentos y aparatos de odontología',11,'90','9018','901849');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90185000','Instrumentos e aparelhos para oftalmologia','Other ophthalmic instruments and appliances','Instrumentos y aparatos de oftalmología',11,'90','9018','901850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90185010','Microscópios binoculares, util.cirurgia oftalmologica','Binocular microsc.of a kind used in ophthalmic surgery','Microscopios binoculares, util.cirugía oftalmologica',11,'90','9018','901850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90185090','Outs.instrumentos e aparelhos de oftalmologia','Other ophthalmic instruments and appliances','Los dem.instrumentos y aparatos de oftalmología',11,'90','9018','901850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90189010','Instrumentos e aparelhos p/transfusão de sangue, etc.','Instruments and appliances,f/blood transfusions,etc','Instrumentos y aparatos p/transfusión de sangre, etc',11,'90','9018','901890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90189021','Bisturis elétricos','Electric bistouries','Bisturíes eléctricos',11,'90','9018','901890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90189029','Outros bisturis','Other bistouries','Los demás bisturíes',11,'90','9018','901890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90189031','Litotritores por onda de choque','Lithotriptors using shock waves','Litotritores por onda de choque',11,'90','9018','901890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90189039','Litotomos e outros litotritores','Lithotomes and other lithotriptors','Litotomos y demás litotritores',11,'90','9018','901890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90189040','Rins artificiais','Artificial kidney','Riñones artificiales',11,'90','9018','901890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90189050','Aparelhos de diatermia','Diathermy apparatus','Aparatos de diatermia',11,'90','9018','901890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90189091','Incubadora para bebês','Artificial incubators for babies','Incubadora para bebés',11,'90','9018','901890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90189092','Aparelhos para medida da pressão arterial','Apparatus for measuring arterial pressure','Aparatos para medida de la presión arterial',11,'90','9018','901890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90189093','Apars.p/terapia intra-uretral p/microondas, computadoriz','Microwave intra-urethral therapy equipment,computer.','Equipos p/terapia intrauretral p/microondas, computad.',11,'90','9018','901890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90189094','Endoscópio','Endoscope','Endocoscopio',11,'90','9018','901890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90189095','Grampos, clipes, aplicador, extrator p/apars.medicina, etc.','Clips,applicators ,extractors f/appar.used medical,etc','Grampas, clipes, aplicador, extractor p/apars.medicina, etc',11,'90','9018','901890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90189096','Desfibriladores externos automáticos','Automatic external defibrillators','Desfibriladores externos automáticos',11,'90','9018','901890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90189099','Outros instrumentos e aparelhos p/medicina,cirurgia,etc','Oth.instrum.and appliances used in medical,surgery,etc','Los dem.instrumentos y aparatos de medicina, cirugía, etc',11,'90','9018','901890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90191000','Aparelhos de mecanoterapia, de massagem/de psicotécnica','Mechano-therapy appl.of massage/of psych.aptitude-testi','Aparatos de mecanoterapia, p/ masajes/de sicotecnia',10,'90','9019','901910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90192010','Aparelhos de oxigenoterapia','Oxygen therapy apparatus','Aparatos de oxigenoterapia',10,'90','9019','901920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90192020','Aparelhos de aerossolterapia','Aerosol therapy apparatus','Aparatos de aerosolterapia',10,'90','9019','901920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90192030','Respiratórios de reanimação','Artificial respiration apparatus','Respiratorios de reanimación',10,'90','9019','901920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90192040','Respiradores automáticos (pulmões de aço)','Appliances known as "iron lungs"','Respiradores automáticos (pulmones de acero)',10,'90','9019','901920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90192090','Apars.de ozonoterapia e outs.de terapia respiratoria','Ozone therapy apparatus and oth.of therapeutic respir.','Apars.de ozonoterapia y dem.apars.terapia respiratoria',10,'90','9019','901920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90200010','Máscaras contra gases','Gas masks','Máscaras antigás',10,'90','9020','902000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90200090','Outros aparelhos respiratórios','Other respiration apparatus','Los demás aparatos respiratorios',10,'90','9020','902000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90211010','Artigos e aparelhos ortopédicos','Articles and orthopaedic appliances','Artículos y aparatos de ortopedia',10,'90','9021','902110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90211020','Artigos e aparelhos para fraturas','Articles and fracture appliances','Artículos y aparatos para fracturas',10,'90','9021','902110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90211091','Partes/acess.de artig/apars.ortopedia, articul','Parts/access.of articles/orthopaedic appliances,articul','Partes/acces.de artícs./apars.ortopedia, articul.',10,'90','9021','902110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90211099','Outs.partes/acess.de apars.ortopedia/fraturas','Other parts/access.of orthopaedic/fracture','Las dem.partes/acces.de apars.ortopedia/fracturas',10,'90','9021','902110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90211110','Próteses articulares, femurais','Prostheses articulate,femoral','Prótesis articulares, femorales',10,'90','9021','902111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90211120','Próteses articulares, miolétricas','Prostheses articulate,myoelectric','Prótesis articulares, mioeléctricas',10,'90','9021','902111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90211190','Outras próteses articulares','Other prostheses articulate','Las demás prótesis articulares',10,'90','9021','902111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90211910','Artigos e aparelhos ortopédicos','Articles and orthopaedic appliances','Artículos y aparatos de ortopedia',10,'90','9021','902119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90211920','Artigos e aparelhos para fraturas','Articles and fracture appliances','Artículos y aparatos para fracturas',10,'90','9021','902119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90211991','Partes e acess.de artigos e apars.ortopedia, articulares','Parts and access.of articles and orthopaed.appl.artic.','Partes y acces.de artícs.y apars.ortopedia, articulares',10,'90','9021','902119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90211999','Outs.partes e acess.de próteses articul/apars.ortoped.','Parts and access.of prostheses articulate/orthop.appl.','Las dem.partes y acces.de prótesis artic./apars.ortop.',10,'90','9021','902119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90212110','Dentes artificiais de acrílico','Acrylic artificial teeth','Dientes artificiales de acrílico',10,'90','9021','902121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90212190','Outros dentes artificiais, exceto de acrílico','Other artificial teeth, except of acrylic','Los dem.dientes artificiales exc.de acrílico',10,'90','9021','902121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90212900','Outros artigos e aparelhos de prótese dentária','Other articles and dental fittings appliances','Los demás artículos y aparatos de prótesis dental',10,'90','9021','902129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213011','Válvulas cardíacas mecânicas','Mechanical heart valves','Válvulas cardíacas mecánicas',10,'90','9021','902130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213019','Válvulas cardíacas, exceto as mecânicas','Heart valves exc.mechanical','Válvulas cardíacas excepto las mecánicas',10,'90','9021','902130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213020','Lentes intraoculares','Intra-ocular lenses','Lentes intraoculares',10,'90','9021','902130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213030','Próteses de artérias vasculares revestidas','Prostheses of covered vascular arteries','Prótesis de arterias vasculares revestidas',10,'90','9021','902130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213040','Próteses mamárias não implantáveis','Mammary prostheses n/implant','Prótesis mamarias no implantables',10,'90','9021','902130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213080','Outros artigos e aparelhos de prótese','Other articles and prostheses apparatus','Los demás artículos y aparatos de prótesis',10,'90','9021','902130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213091','Partes de próteses modulares subst.membros super.infer.','Parts of prostheses modul.subst.infer.super.members','Partes de prót.modulares q.reemplaz.miembros super.inf.',10,'90','9021','902130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213099','Partes e acess.de outros artigos e aparelhos de prótese','Parts and access.of oth.articles and prostheses appar.','Partes y acces.de dem.artículos y aparatos de prótesis',10,'90','9021','902130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213110','Próteses articulares femurais','Prostheses articulate,femoral','Prótesis articulares femorales',10,'90','9021','902131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213120','Próteses articulares mioelétricas','Prostheses articulate,myoelectric','Prótesis articulares mioeléctricas',10,'90','9021','902131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213190','Outros artigos e aparelhos de prótese','Other artificial parts of the body','Los demás artículos y apars.de prótesis',10,'90','9021','902131');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213911','Válvulas cardiacas mecânicas','Mechanical heart valves','Válvulas cardíacas mecánicas',10,'90','9021','902139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213919','Outras válvulas cardíacas','Other heart valves','Las demás válvulas cardíacas',10,'90','9021','902139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213920','Lentes intraoculares','Intra-ocular lenses','Lentes intraoculares',10,'90','9021','902139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213930','Próteses de artérias vasculares revestidas','Coated artificial vascular arteries','Prótesis de arterias vasculares revestidas',10,'90','9021','902139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213940','Próteses mamárias não implantáveis','Non-implantable artificial breasts','Prótesis mamarias no implantables',10,'90','9021','902139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213980','Outros artigos e aparelhos de prótese','Other artificial parts of the body appliances','Los demás artículos y apars.de prótesis',10,'90','9021','902139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213991','Partes de próteses modulares substit.membros','Parts for the upper or lower artificial limbs','Partes de prótesis modulares q.reemplazan miembros',10,'90','9021','902139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90213999','Outs.partes/acess.de artigos e apars.prótese','Other parts/access.of artif.parts of the body apliances','Los dem.partes/acces.de artículos y apars.prótesis',10,'90','9021','902139');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90214000','Apars.p/facilitar a audição de surdos, exc.partes/acess.','Hearing aids,excluding parts and accessories','Audífonos, excepto sus partes/accesorios',11,'90','9021','902140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90215000','Marca-passos cardíacos, exceto partes e acessórios','Pacemakers f/stimulating heart muscles,excl.parts/acces','Estimuladores cardíacos, exc.sus partes y acces.',11,'90','9021','902150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90219011','Cardiodesfibrilador automático','Automatic cardiac defibrillators','Cardiodesfibrilador automático',10,'90','9021','902190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90219019','Outs.apars.implant.organ.p/compensar defeito/incapacid.','Oth.appar.implant.organism f/compens.defect/incapacity','Los dem.apars.implant.org.p/compensar defecto/incapac.',10,'90','9021','902190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90219080','Outs.aparelhos p/compensar deficiências ou enfermidades','Oth.apparatus f/compensating deficiencies/illnesses','Los dem.apars.p/compensar un defecto/incapacidad',10,'90','9021','902190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90219081','Implantesd expansíveis("stents), mesmo montados sobre catéter de balão','Stainless steel stents,for dilating arteries','Implantes expandibles, de acero inox.p/dilatar arterias',10,'90','9021','902190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90219082','Oclusores interauriculares const.malha fios niquel, etc.','Atrial septal defect cons.wire mesh made of nickel,etc','Oclusores interauriculares const.malla alamb.níquel, etc',10,'90','9021','902190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90219089','Outros aparelhos para compensar deficiências ou enfermidades','Oth.apparatus f/compensating deficiencies/illnesses','Los dem.aparatos p/compensar defecto o incapacidad',10,'90','9021','902190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90219091','Partes e acessórios de marca-passos cardíacos','Parts/access.of pacemakers f/stimulating heart muscles','Partes y acces.de estimuladores cardíacos',10,'90','9021','902190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90219092','Partes e acess.de apars.p/facilitar audição dos surdos','Parts and access.of hearing aids apparatus','Partes y accesorios de audífonos',10,'90','9021','902190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90219099','Partes e acess.de artigos/apars.p/compensar deficiência','Parts and acces.of articles/appar.f/compens.deficiency','Partes y acces.de arts/apars.p/compensar un defecto',10,'90','9021','902190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90221200','Aparelhos de tomografia computadorizada','Tomography apparatus, program controlled','Aparatos de tomografía computadorizada',11,'90','9022','902212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90221311','Apars.de raios x, de diagnost.de tomada maxilar panoram.','Appar.of x-rays,f/panoramic photographs of the jaw','Apars.de rayos x, de diagnóst.de tomas maxilares panor.',11,'90','9022','902213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90221319','Outros aparelhos de raios x, para disgnóstico odontológico','Other appar.of x-rays,f/dental diagnostic','Los dem.aparatos de rayos x, p/diagnóstico odontológico',11,'90','9022','902213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90221390','Outros aparelhos de raios X, para odontologia','Other apparatus of x-rays,f/dentistry','Los dem.aparatos de rayos x, para uso odontológico',11,'90','9022','902213');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90221411','Aparelhos de raios X, de diagnóstico para mamografia','Apparatus of x-rays,of f/mammography diagnostic','Aparatos de rayos x, de diagnóst.p/mamografía',11,'90','9022','902214');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90221412','Aparelhos de raios X, de diagnóstico para angiografia','Apparatus of x-rays,for diagnostic angiography','Aparatos de rayos x, de diagnóst.p/angiografía',11,'90','9022','902214');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90221413','Apars.computadoriz.de disgnóstico, p/densitometria ossea','Diagnostic appararus,for measuring bone density,progr.','Apars.computadoriz.de diagnóstico, p/densitometría ósea',11,'90','9022','902214');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90221419','Outs.aparelhos de raios x, p/diagnost.médico, cirúrg.etc.','Other apparatus of x-rays,f/medical diagn.surgical,etc.','Los dem.apars.de rayos x, p/diagnóst.médico, quirúrg.etc',11,'90','9022','902214');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90221490','Outs.apars.de raios x, p/uso medico, cirúrgico, veterinar.','Other apparatus of x-rays,f/medical,surgical,veter.uses','Los dem.apars.de rayos x, p/uso médico, quirúrg., veterin.',11,'90','9022','902214');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90221910','Espectrômetros ou espectrógrafos, de raios x','X-ray spectrometers or spectrographs','Espectrómetros o espectrógrafos, de rayos x',11,'90','9022','902219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90221990','Outs.aparelhos de raios x, p/radiofotografia/radioterap.','Oth.appar.of x-rays,f/radiography or radiotherapy','Los dem.aparatos de rayos x, p/radiografía/radioterapia',11,'90','9022','902219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90221991','Apars.raios x, p/insp.bagag.tunel, h<=4dm, l<=6dm, c<=1, 2m','Appar.of x-rays,lugg.inspec.,h<=4dm,a<=6dm,c<=1,2m','Apars.rayos x, p/insp.equip.tunel, h<=4dm, a<=6dm, c<=1, 2m',11,'90','9022','902219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90221999','Outs.aparelhos de raios x, p/radiofotografia/radioterap.','Oth.appar.of x-rays,f/radiography or radiotherapy','Los dem.apars.de rayos x, p/radiografía/radioterapia',11,'90','9022','902219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90222110','Apars.de radiocobalto (bomba de cobalto), uso medico, etc','Radiocobalt apparatus(cobalt bombs),medical uses,etc','Apars.de radiocobalto (bomba de cobalto), uso médico, etc',11,'90','9022','902221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90222120','Aparelhos de gamaterapia p/uso médico, cirúrgico, etc.','Gamma therapy apparatus f/medical,surgical,etc.','Aparatos de gamaterapia p/uso médico, quirúrgico, etc',11,'90','9022','902221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90222190','Outs.apars.de radiacao alfa/beta/gama, p/uso medico, etc.','Oth.radiation appar.alpha/beta/gama,f/medical uses,etc.','Los dem.apars.de radiac.alfa/beta/gamma, p/uso méd., etc',11,'90','9022','902221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90222900','Outros aparelhos de radiação alfa, beta ou gama','Other radiation apparatus alpha, beta or gama','Los dem.aparatos de radiación alfa, beta o gamma',11,'90','9022','902229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90222910','Apars.raios gama, p/detec.nivel enchim/tampa lata bebida','Gamma rays,f/detect.stuffing level/cover of drink can','Apars.rayos gamma, p/detec.nivel enchim/tapa lata bebida',11,'90','9022','902229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90222990','Outros aparelhos de radiação alfa, beta ou gama','Other radiation apparatus alpha, beta or gama','Los dem.aparatos de radiación alfa, beta o gamma',11,'90','9022','902229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90223000','Tubos de raios x','X-ray tubes','Tubos de rayos x',11,'90','9022','902230');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90229011','Geradores de tensão, p/apars.de raios x/outras radiações','Voltage generators,f/x-rays appar./other radiations','Generadores de tensión, p/apars.de rayos x/otras radiac.',11,'90','9022','902290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90229012','Telas radiológicas para aparelhos de raios x/outras radiações','X-ray screens,f/x-rays apparatus/other radiations','Pantallas radiológicas p/apars.de rayos x/otras radiac.',11,'90','9022','902290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90229019','Outros aparelhos geradores de raios x','Other x-rays generators apparatus','Los demás aparatos generadores de rayos x',11,'90','9022','902290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90229080','Outros dispositivos geradores de raios x','Other x-rays generators devices','Los demás dispositivos generadores de rayos x',11,'90','9022','902290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90229090','Partes e acess.p/apars.de raios x/outras radiações, etc.','Parts and access.f/x-rays appar./other radiations,etc.','Partes y acces.p/apars.de rayos x/otras radiaciones, etc',10,'90','9022','902290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90230000','Instrumentos, apars.e modelos p/demonstracao ensino, etc.','Instrum.appar.and models f/demonstrat.in education,etc.','Instrum., apars.y modelos conc.p/demonstr.enseñanza, etc',10,'90','9023','902300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90241010','Máquinas e aparelhos para ensaios de tração/compressão de metais','Mach.appl.f/testing tensile strength/metals compress.','Máqs.y apars.p/ensayo de tracción/compresión de metales',11,'90','9024','902410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90241020','Máquinas e aparelhos pra ensaios de dureza de metais','Machines and appliances f/testing hardness','Máquinas y aparatos para ensayos de dureza de metais',11,'90','9024','902410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90241090','Máquinas e aparelhos para outros ensaios de metais','Machines and appliances for testing other metals','Maquinaria y equipo para ensayos de otros metales',11,'90','9024','902410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90248011','Máquinas e aparelhos para ensaio de fios têxteis, automáticas','Mach.and appliances f/testing yarn,automatic','Máquinas y apars.p/ensayo para hilados textiles,  automáticas',11,'90','9024','902480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90248019','Outras máquinas e aparelhos para ensaios de têxteis','Other machines and appliances for testing textile','Las demás máquinas y aparatos para ensayo de textiles',11,'90','9024','902480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90248020','Máquinas e apars.p/ensaios de papéis, cartão, linoleo, etc','Machin.and appl.f/testing paper,paperb.linoleum,etc','Máquinas y apars.p/ensayos de papeles, cart., linóleo, etc',11,'90','9024','902480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90248021','Máquinas para ensaios de pneumáticos','Machines for testing tires','Maquinas para la verificación de neumáticos',11,'90','9024','902480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90248029','Outs.maqs e apars.p/ensaios de papel, cartão, linoleo, etc','Other machin.and appl.f/testing paper,paperb.linoleum,etc','Otras máquinas y apars.p/ensayos de papeles, cart., linóleo, etc',11,'90','9024','902480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90248090','Outs.maqs.e apars.p/ensaios de dureza, etc.de materiais','Oth.machin.and appl.f/testing hardness,etc.of materials','Las dem.máqs.y apars.p/ensayos de dureza, etc.de mat.',11,'90','9024','902480');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90249000','Partes e acess.de maqs.e apars.p/ensaios de dureza, etc.','Parts and acces.of mach.and appl.f/testing hardness,etc','Partes y acces.de máqs.y apars.p/ensayos de dureza, etc',10,'90','9024','902490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90251110','Termômetros clínicos, de líquido, de leitura direta','Clinical thermometers,of liquid,of direct reading','Termómetros clínicos, de líquido, con lectura directa',11,'90','9025','902511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90251190','Outros termometros e pirometros, de líquido, leitura dire','Oth.thermometers and pyrom.of liquid,of direct reading','Los dem.termómetros y pirómetros, de líquido, lect.direct',11,'90','9025','902511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90251910','Pirômetros ópticos','Optical pyrometers','Pirómetros ópticos',11,'90','9025','902519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90251990','Outros termômetros e pirômetros','Other thermometers and pyrometers','Los demás termómetros y pirómetros',11,'90','9025','902519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90258000','Densímetros, areômetros, higrômetros e outros instrumentos','Hydrometers,areometers and other floating instruments','Densímetros, areómetros, higrómetros y ots.instrumentos',11,'90','9025','902580');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90259010','Partes e acessórios de termómetros','Parts and accessories of thermometers','Partes y acces.de termómetros',10,'90','9025','902590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90259090','Partes e acess.de densímetros e outros instrumentos','Parts and access.of hydrometers and oth.instruments','Partes y acces.de densímetros y otros instrumentos',10,'90','9025','902590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90261011','Medidor-transmissor eletron.induc.eletromagnet.de vazão','Electr.measuring transmitters,operat.by electrom.induct','Medidor-transmisor electrón.induc.electromag.del caudal',11,'90','9026','902610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90261019','Outros instrumentos e apars.p/medida/controle de vazão','Oth.instrum.and applian.f/measuring/checking the flow','Los dem.instrumentos y apars.p/medida/control de caudal',11,'90','9026','902610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90261020','Instrumentos e aparelhos para medida/controle do nível','Instruments and applian.f/measuring/checking the level','Instrumentos y aparatos p/medida/control del nivel',11,'90','9026','902610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90261021','Instrum.e apars.p/medida/controle do nivel, de metais','Instrum.and appl.f/measuring/checking the level,metals','Instrum.y apars.p/medida/control del nivel, de metales',11,'90','9026','902610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90261029','Outros .instrumentos e aparelhos para medida/controle do nível','Oth.instruments and appl.f/measuring/checking the level','Los dem.instrumentos y apars.p/medida/control del nivel',11,'90','9026','902610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90262010','Manômetros','Manometers','Manómetros',11,'90','9026','902620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90262090','Outs.instrumentos e apars.p/medida/controle da pressão','Oth.instrum.and appl.f/measuring/checking the pressure','Los dem.instrum.y apars.p/medida/control de presión',11,'90','9026','902620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90268000','Outs.instrumentos e apars.p/medida/controle de liq.etc.','Oth.instrum.and appl.f/measuring/checking  liquid,etc','Los dem.instrumentos y apars.p/medida/contr.de líq.etc',11,'90','9026','902680');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90269010','Partes e acess.p/instrum.e apars.medida/controle nivel','Parts of access.instr.and appl.f/measur./checking level','Partes y acces.p/instrum.y apars.medida/control nivel',10,'90','9026','902690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90269020','Partes e acessórios para manômetros','Parts and accessories for manometers','Partes y accesorios para manómetros',10,'90','9026','902690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90269090','Partes e acess.p/outs.instrum.e apars.de medida/control','Parts of access.f/oth.instr.and appl.f/meas./checking','Partes y acces.p/ots.instrum.y apars.de medida/control',10,'90','9026','902690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90271000','Analisadores de gases ou de fumaça (fumo)','Gas or smoke analysis apparatus','Analizadores de gases o humos',11,'90','9027','902710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90272011','Cromatógrafos de fase gasosa','Chromatographs of gaseous phase','Cromatógrafos de fase gaseosa',11,'90','9027','902720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90272012','Cromatógrafos de fase líquida','Chromatographs of liquid phase','Cromatógrafos de fase líquida',11,'90','9027','902720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90272019','Outros cromatógrafos','Other chromatographs','Los demás cromatógrafos',11,'90','9027','902720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90272020','Aparelhos de eletroforese','Electrophoresis instruments','Aparatos de electroforesis',11,'90','9027','902720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90272021','Sequenciadores automat.de adn por eletroforese capilar','Automatic dna sequencing by means of capil.electrop.','Secuenciadores automát.de adn por electrofor.capilar',11,'90','9027','902720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90272029','Outros aparelhos de eletroforese','Other electrophoresis instruments','Los demás instrumentos de electroforesis',11,'90','9027','902720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90273011','Espectrometros de emissao óptica (emissao atomica)','Spectrometers of optical emission (atomic emission )','Espectrómetros de emisión óptica (emisión atomica)',11,'90','9027','902730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90273019','Outros espectrômetros','Other spectrometers','Los demás espectrómetros',11,'90','9027','902730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90273020','Espectrofotõmetros','Spectrophotometers','Espectrofotómetros',11,'90','9027','902730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90273021','Espectrofotômetros de radiações uv, visiveis e iv','Spectrophotometers of uv radiations,visible and ir','Espectrofotómetros de radiaciones uv, visibles y iv',11,'90','9027','902730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90273022','Espectrofotômetros de absorção atomica','Spectrophotometers of atomic absorption','Espectrofotómetros de absorción atómica',11,'90','9027','902730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90273023','Espectrofotômetros de emissao óptica (emissao atômica)','Spectrophotometers of optical emission(atomic emission)','Espectrofotómetros de emisión óptica (emisión atómica)',11,'90','9027','902730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90273029','Outros espectrofotômetros','Other spectrophotometers','Los demás espectrofotómetros',11,'90','9027','902730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90273031','Espectrógrafos de emissão óptica (emissão atômica)','Spectrographs of optical emission(atomic emission)','Espectrógrafos de emisión óptica (emisión atómica)',11,'90','9027','902730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90273039','Outros espectrógrafos','Other spectrographs','Los demás espectrógrafos',11,'90','9027','902730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90274000','Indicadores de tempo de exposição','Exposure meters','Exposímetros',11,'90','9027','902740');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90275010','Colorímetros','Colorimeters','Colorímetros',11,'90','9027','902750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90275020','Fotômetros','Photometers','Fotómetros',11,'90','9027','902750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90275030','Refratômetros','Refractometers','Refractómetros',11,'90','9027','902750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90275040','Sacarímetros','Saccharimeters','Sacarímetros',11,'90','9027','902750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90275050','Citômetro de fluxo','Flow cytometers','Citómetro de flujo',11,'90','9027','902750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90275090','Outs.instrumentos e apars.que utiliz.radiações ópticas','Oth.instr.and appar.using optical radiations','Los dem.instrumentos y apars.que utilic.radiac.ópticas',11,'90','9027','902750');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90278011','Calorímetros','Calorimeters','Calorímetros',11,'90','9027','902780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90278012','Viscosímetros','Viscosimeters','Viscosímetros',11,'90','9027','902780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90278013','Densitômetros','Densitometers','Densitómetros',11,'90','9027','902780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90278014','Aparelhos medidores de ph','Ph-meters apparatus','Aparatos medidores de ph',11,'90','9027','902780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90278020','Espectrômetros de massa','Mass spectrometers','Espectrómetros de masa',11,'90','9027','902780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90278030','Polarógrafos','Polarographs','Polarógrafos',11,'90','9027','902780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90278090','Outros instrumentos e aparelhos para análise/ensaio/medida, etc','Oth.instrum.and appl.f/analysis/testing/measuring,etc','Instrumentos y apars.p/análisis/ensayo/medida, etc',11,'90','9027','902780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90278091','Exposímetros','Light meter ','Exposímetros',11,'90','9027','902780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90278099','Outros instrumentos e aparelhos para análise/ensaio/medida','Other instrum.and appl.for analysis/testing/measuring,etc','Instrumentos y apars.p/análisis/ensayo/medida',11,'90','9027','902780');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90279010','Microtomos','Microtomes','Micrótomos',11,'90','9027','902790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90279091','Partes e acess.p/espectrômetros de emissão óptica','Parts and access.f/spectrometers of optical emission','Partes y acces.de espectrómetros de emisión óptica',10,'90','9027','902790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90279092','Partes e acess.p/espectrógrafos de emissão óptica','Parts and access.f/spectrographs of optical emission','Partes y acces.de espectrógrafos de emisión óptica',10,'90','9027','902790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90279093','Partes e acessórios para polarógrafos','Parts and accessories of polarographs','Partes y accesorios de polarógrafos',10,'90','9027','902790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90279099','Partes e acess.p/outs.instrum.e apars.p/analise, etc.','Parts and access.f/oth.instrum.and appl.f/analysis,etc','Partes y acces.p/ots.instrum.y apars.p/análisis, etc',10,'90','9027','902790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90281010','Contadores de gás natural comprimido, eletrônicos','Compressed natural gas meters, electronic','Contadores de gas natural comprimido, electrónicos',11,'90','9028','902810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90281011','Contadores de gás natural comprim.eletron.p/postos serv','Compressed natural gas meters,electronic,f/gas stations','Contadores de gas natural comprim.electr.util.est.serv.',11,'90','9028','902810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90281019','Outs.contadores de gás natural comprimido, eletrônicos','Other compressed natural gas meters, electronic','Los dem.contadores de gas natural comprim., electrónicos',11,'90','9028','902810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90281090','Outros contadores de gases','Other gas meters','Los demás contadores de gas',11,'90','9028','902810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90282010','Contadores de líquidos, peso <= 50kg','Liquid meters, weight <= 50kg','Contadores de líquido, peso <= 50kg',11,'90','9028','902820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90282020','Contadores de líquidos, peso > 50kg','Liquid meters, weight > 50kg','Contadores de líquido, peso > 50kg',11,'90','9028','902820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90283011','Contadores monofasicos, p/corr.eletr.alternada, digitais','Monophase meters,p/alter.elec.current,digital','Contadores monofásicos, p/corr.eléctr.altern., digitales',11,'90','9028','902830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90283019','Outros contadores monofasicos, p/corr.eletr.alternada','Other monophase meters,p/alter.elec.current','Los demás contadores monofásicos, p/corr.eléctr.altern.',11,'90','9028','902830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90283021','Contadores bifásicos de eletricidade, digitais','Electricity two-phase meters,digital','Contadores bifásicos de electricidad, digitales',11,'90','9028','902830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90283029','Outros contadores bifásicos de eletricidade','Other electricity two-phase meters','Los demás contadores bifásicos de electricidad',11,'90','9028','902830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90283031','Contadores trifásicos de eletricidade, digitais','Electricity triphases meters,digital','Contadores trifásicos de electricidad, digitales',11,'90','9028','902830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90283039','Outros contadores trifásicos de eletricidade','Other electricity triphases meters','Los demás contadores trifásicos de electricidad',11,'90','9028','902830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90283090','Outros contadores de eletricidade','Other electricity meters','Los demás contadores de electricidad',11,'90','9028','902830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90289010','Partes e acessórios para contadores de eletricidade','Parts and accessories electricity meters','Partes y acces.p/contadores de electricidad',10,'90','9028','902890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90289090','Partes e acessórios para contadores de gases/líquidos','Parts and accessories f/gas/liquid meters','Partes y acces.p/contadores de gas/líquido',10,'90','9028','902890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90291010','Contadores de voltas ou de produção/horas de trabalho','Revolution counters or product.counters/hour meters','Cuentarrevoluciones o contad.de produc./horas de trab',11,'90','9029','902910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90291090','Taxímetros, totalizadores de caminho percorrido, etc.','Taximeters,totalizers of traveled road,etc','Taxímetros, totalizadores de camino recorrido, etc',11,'90','9029','902910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90292010','Indicadores de velocidade e tacômetros','Speed indicators and tachometers','Velocímetros y tacómetros',11,'90','9029','902920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90292020','Estroboscópios','Stroboscopes','Estroboscopios',11,'90','9029','902920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90299010','Partes e acess.p/indicadores de velocidade/tacômetros','Parts and access.f/speed indicators/tachometers','Partes y acces.de velocímetros/tacómetros',10,'90','9029','902990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90299090','Partes e acessórios e outros contadores/estroboscópios','Parts and access.f/other counters/stroboscopes','Partes y acces.de otros contadores/estroboscopios',10,'90','9029','902990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90301010','Medidores de radioatividade','Instruments and apparatus for measuring radioactivity','Medidores de radioactividad',11,'90','9030','903010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90301090','Outros instrumentos e aparelhos para medida radiações ionizantes','Oth.instr.and apparatus f/measuring ionising radiations','Los dem.instrumentos y apars.p/medida radiac.ionizantes',11,'90','9030','903010');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90302010','Olciloscópios catódicos, digitais','Cathode-ray oscilloscopes,digital','Osciloscopios catódicos, digitales',11,'90','9030','903020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90302021','Olciloscópios catódicos analogicos, frequência>=60mhz','Analogical cathode-ray oscilloscopes,frequency>=60mhz','Osciloscopios catódicos analógicos, frecuencia>=60mhz',11,'90','9030','903020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90302022','Vetorscópios (osciloscópios analógicos catódicos)','Vectorscope (analogical cathode-ray oscilloscopes)','Vectorscopios (osciloscopios analógicos catódicos)',11,'90','9030','903020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90302029','Outros olciloscópios catódicos analógicos','Other analogical cathode-ray oscilloscopes','Los demás osciloscopios catódicos analógicos',11,'90','9030','903020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90302030','Oscilógrafos catódicos','Cathode-ray oscillographs','Oscilógrafos catódicos',11,'90','9030','903020');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90303100','Multímetros sem dispositivo registrador','Multimeters without recording device','Multímetros sin dispositivo registrador',11,'90','9030','903031');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90303200','Multímetros com dispositivo registrador','Multimeters with recording device','Multímetros con dispositivo registrador',11,'90','9030','903032');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90303311','Voltímetros digitais','Digital voltmeters ','Voltímetros digitales',11,'90','9030','903033');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90303319','Qualquer outro voltímetro','Any other voltmeters','Cualquier otro voltímetro',11,'90','9030','903033');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90303321','Amperímetros s/disp.registr., p/veíc.autsms.','Ammeters without recording device f/motor vehicles','Amperimetros sin disposit.registrador, en vehíc.automot.',11,'90','9030','903033');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90303329','Outros amperímetros s/disposit.registrador','Other ammeters without recording device','Otros amperimetros sin dispositivo registrador',11,'90','9030','903033');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90303390','Outros aparelhos e instrumentos sem dispositivo registrador','Other instruments and appliances without a recording device','Otros instrumentos y aparatos sin un dispositivo de grabación',11,'90','9030','903033');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90303910','Inst.ap.c/disp.reg.d/teste d/circuitos impres.','Instr./appar. with test. reg.dev. of print.circuit.','Instr./apar. c/disp. reg.de prueb. de circ. impreso',11,'90','9030','903039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90303911','Voltímetros digitais, sem dispositivo registrador','Digital voltmeters without recording device','Voltímetros digitales, sin dispositivo registrador',11,'90','9030','903039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90303919','Outros voltímetros sem dispositivo registrador','Other voltmeters without recording device','Los demás voltímetros sin dispositivo registrador',11,'90','9030','903039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90303921','Amperímetros sem dispositivo registrador, para veículos automóveis','Ammeters without recording device f/motor vehicles','Amperimetros sin disposit.registrador, en vehíc.automot.',11,'90','9030','903039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90303929','Outros amperímetros sem dispositivo registrador','Other ammeters without recording device','Los demás amperimetros sin dispositivo registrador',11,'90','9030','903039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90303990','Outros aparelhos e instrum.p/medida/controle tensão, etc','Oth.appar.and instrum.f/measuring/checking tension,etc','Los dem.aparatos y instrum.p/medida/control tensión, etc',11,'90','9030','903039');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90304010','Analisadores de protocolo, para telecomunicação','Protocol analysers,for telecommunications','Analizadores de protocolo, para telecomunicación',11,'90','9030','903040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90304020','Analisadores de nivel seletivo, para telecomunicação','Selective level analysers,for telecommunications','Analizadores de nivel selectivo, para telecomunicación',11,'90','9030','903040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90304030','Analisadores digitais de transmissão, para telecomunicação','Selective level analysers,for telecommunications','Analizadores digitales de transmisión, p/telecomunicac.',11,'90','9030','903040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90304090','Outros instrumentos e aparelhos para telecomunicação','Other instruments and apparatus,for telecommunications','Los demás instrumentos y aparatos p/telecomunicación',11,'90','9030','903040');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90308210','Instrumentos e apars.p/testes de circuitos integrados','Instruments and apparatus,f/testing integrated circuits','Instrumentos y apars.de prueba de circuitos integrados',11,'90','9030','903082');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90308290','Outs.instrumentos e apars.p/medida/controle discos, etc.','Oth.instrum.and appar.f/measuring/checking(wafers),etc','Los dem.instrumentos y apars.p/medida/contr.obleas, etc',11,'90','9030','903082');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90308310','Apars.de teste de contin.de circuit.impresso, c/disp.reg','Appar.f/continuity testers f/printed circuits,rec.dev.','Apars.de prueba de contin.de circuit.impreso, c/disp.reg',11,'90','9030','903083');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90308320','Apars.de teste automat.circuit.impresso, mont.c/disp.reg','Appar.f/autom.testers of printed circuits,moun.rec.dev.','Apars.de prueba automát.circuit.impreso, mont.c/disp.reg',11,'90','9030','903083');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90308330','Apars.de medida de param.de sinais de tv, etc.c/disp.reg','Appar.f/meas.charac.param.tv/video signal.etc.rec.dev','Apars.de medida de parám.de señales tv, etc.c/disp.reg',11,'90','9030','903083');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90308390','Outs.instrum.e apars.p/medida/controle eletr.c/disposit','Oth.instr.and appar.f/measuring/checking elect.rec.dev.','Los dem.instrum.y apars.p/medida/control eléctr.c/disp',11,'90','9030','903083');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90308410','Inst.ap.c/disp.reg.d/teste aut./circ.impresso','Instr./appar. with autom. test. reg.dev. of print.circuit.','Instr./apar. c/disp. reg.de prueb. autom. de circ. impreso',11,'90','9030','903084');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90308420','Inst.ap.disp.reg.d/med.parâmetr.sin.tv, vídeo','Instr./appar.with parameters measur. reg. dev. of tv/video sign','Instr./apar. c/disp.reg. de med. parám.sint.tv.,vídeo',11,'90','9030','903084');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90308490','Outros instrumentos, com dispositivo registrador','Other instruments, with recording device','Otros instrumentos, con dispositivo de grabación',11,'90','9030','903084');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90308910','Analisadores lógicos de circuitos digitais','Logic analysers for digital circuit','Analizadores lógicos de circuitos digitales',11,'90','9030','903089');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90308920','Analisadores de espectro de frequência','Frequency spectrum analyser','Analizadores de espectro de frecuencia',11,'90','9030','903089');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90308930','Frequencímetros','Frequency meters','Frecuencímetros',11,'90','9030','903089');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90308940','Fasímetros','Phase meters','Fasímetros',11,'90','9030','903089');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90308990','Outros instrumentos e apars.p/medida/controle eletr.etc','Oth.instrumen.and appar.f/measuring/checking elect.etc.','Los dem.instrumentos y apars.p/medida/contr.electr.etc',11,'90','9030','903089');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90309010','Partes e acess.p/apars.de medida, etc.radiacao ionizante','Parts and acces.f/measur.appar.etc.ionising radiations','Partes y acces.p/apars.de medida, etc.radiac.ionizante',10,'90','9030','903090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90309020','Partes e acess.p/apars.de medida, etc.eletr.sem disp.reg','Parts and access.f/measuring appar.etc.electr.rec.dev.','Partes y acces.p/apars.de medida, etc.electr.s/disp.reg',10,'90','9030','903090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90309030','Partes e acess.p/apars.de medida, etc.semicond/disp.reg.','Parts and access.f/measuring appar.etc.electr.rec.dev.','Partes y acces.p/apars.de medida, etc.semicond/disp.reg.',10,'90','9030','903090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90309090','Partes e acess.p/osciloscópios, oscilógrafos, etc.','Parts and access.f/oscilloscopes,oscillographs,etc.','Partes y acces.p/osciloscopios, oscilógrafos, etc',10,'90','9030','903090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90311000','Máquinas de equilibrar pecas mecânicas','Machines for balancing mechanical parts','Máquinas para equilibrar piezas mecánicas',11,'90','9031','903110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90312010','Bancos de ensaio para motores','Test benches for engines and motors','Bancos de pruebas p/motores',11,'90','9031','903120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90312090','Outros bancos de ensaio, exceto para motores','Other test benches,except for engines and motors','Los demás bancos de pruebas, exc.p/motores',11,'90','9031','903120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90313000','Projetores de perfis','Profile projectors','Proyectores de perfiles',11,'90','9031','903130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90314100','Instrumentos e aparelhos ópticos, para controle de discos, etc.','Optical instruments and apparat.f/checking(wafers),etc','Instrumentos y apars.ópticos, p/control de discos, etc',11,'90','9031','903141');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90314900','Outros instrumentos e aparelhos ópticos','Other optical instruments and apparatus','Los demás instrumentos y aparatos ópticos',11,'90','9031','903149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90314910','Instrums.e apars.raios laser, p/medir dim.fibra celulose','Laser instr.and appar.f/measur.dim.param.cellul.fibres','Instrums.y apars.rayos láser, p/medida dim.fibr.celulosa',11,'90','9031','903149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90314920','Instrums.e apars.raios laser, p/medir esp.pneumáticos','Laser instr.and appar.f/measur.thickn.motor vehic.tyres','Instrums.y apars.rayos láser, p/medida esp.neumáticos',11,'90','9031','903149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90314990','Outros instrumentos e aparelhos ópticos','Other optical instruments and apparatus','Los demás instrumentos y aparatos ópticos',11,'90','9031','903149');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90318011','Dinamômetros','Dynamometers','Dinamómetros',11,'90','9031','903180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90318012','Rugosímetros','Surface-finish testing instruments','Rugosímetros',11,'90','9031','903180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90318020','Máquinas para medição tridimensional','Machines for taking three-dimensional measurements','Máquinas p/medición tridimensional',11,'90','9031','903180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90318030','Metros padrões','Standard metres','Metros patrones',11,'90','9031','903180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90318040','Apars.digitais util.em automóveis (computador de bordo)','Digital appar.used in motor vehicles (onboard computer)','Apars.digitales de uso.en vehíc.autom.(comput.de bordo)',11,'90','9031','903180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90318050','Aparelhos para analise de têxteis, computadorizados','Appar.f/analyzes of textile,contr.autom.data proces.mac','Aparatos para análisis de textiles, computarizados',11,'90','9031','903180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90318060','Células de carga','Load cells','Celdas de carga',11,'90','9031','903180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90318090','Outros instrumentos, aparelhos e maqs.de medida/controle','Oth.instruments,applian.and mach.of measured/checking','Los dem.instrumentos, aparatos y máqs.p/medida/control',11,'90','9031','903180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90318091','Instrums.apars e maqs.p/controle dimen.pneumat.em carga','Instr.applian.and mach.f/checking pneum.tyres,load cond','Instrums.apars y máqs.p/control dimen.neumát.en carga',11,'90','9031','903180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90318099','Outs.instrumentos, aparelhos e maqs.de medida/controle','Oth.instr.applian.and mach.of measuring/checking','Los dem.instrumentos, aparatos y máqs.p/medida/control',11,'90','9031','903180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90319010','Partes e acessórios para bancos de ensaio','Parts and accessories f/test benches','Partes y acces.de bancos de pruebas',10,'90','9031','903190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90319090','Partes e acess.p/outros instrum.e apars.medida/controle','Parts and acces.f/oth.instr.appl.and mach.meas./check.','Partes y acces.p/otros instrum.y apars.medida/control',10,'90','9031','903190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90321010','Termostatos automáticos, de expansão de fluidos','Automatic thermostats,expansion of fluids','Termostatos automáticos, de expansión de fluidos',11,'90','9032','903210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90321090','Outros termostatos automáticos','Other automatic thermostats','Los demás termostatos automáticos',11,'90','9032','903210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90322000','Manostatos automáticos (pressostatos)','Automatic manostats','Manostatos automáticos (presostatos)',11,'90','9032','903220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328100','Instrumentos e aparelhos hidráulicos/pneumáticos, automáticos','Automatic hydraulic/pneumatic instruments and appar.','Instrumentos y apars.hidráulicos/neumáticos, automát.',11,'90','9032','903281');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328911','Reguladores eletrônicos, de voltagem, automáticos','Automatic electronic regulators,of voltage','Reguladores electrónicos, de voltaje, automáticos',11,'90','9032','903289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328919','Outros reguladores de voltagem, automáticos','Other automatic electronic regulators,of voltage','Los dem.reguladores de voltaje, automáticos',11,'90','9032','903289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328921','Controladores eletron.p/sist.antibloq.de freio, automat.','Autom.electronic controllers f/anti-lock braking syst.','Controladores electrón.p/sist.antibloq.de freno, autom.',11,'90','9032','903289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328922','Controladores eletron.p/sist.de suspensao, automáticos','Autom.electronic controllers f/suspension systems','Controladores electrón.p/sist.de suspensión, automáticos',11,'90','9032','903289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328923','Controladores eletron.p/sist.de transmissão, automáticos','Autom.electronic controllers f/transmission systems','Controladores electrón.p/sist.de transmisión, automát.',11,'90','9032','903289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328924','Controladores eletrônicos para sistema de ignição, automáticos','Autom.electronic controllers f/ignition systems','Controladores electrón.p/sist.de ignición, automáticos',11,'90','9032','903289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328925','Controladores eletrônicos para sistema de injeção, automáticos','Autom.electronic controllers f/injection systems','Controladores electrón.p/sist.de inyección, automáticos',11,'90','9032','903289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328929','Outros controladores eletron.automat.p/veic.automóveis','Other autom.electronic controllers f/motor vehicles','Los dem.controladores electrón.autom.p/vehíc.autom.',11,'90','9032','903289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328930','Equipamento digital automat.p/controle de veic.ferrov.','Automatic digital equipment f/checking railway vehicles','Equipamiento digital automát.p/control de vehíc.ferrov.',11,'90','9032','903289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328981','Instrumentos e aparelhos automat.p/controle de pressão','Automatic instruments and apparatus f/checking pressure','Instrumentos y aparatos automát.p/control de presión',11,'90','9032','903289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328982','Instrumentos e apars.automat.p/controle de temperatura','Autom.instruments and apparatus f/checking temperature','Instrumentos y apars.automát.p/control de temperatura',11,'90','9032','903289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328983','Instrumentos e aparelhos automat.p/controle de umidade','Autom.instruments and apparatus f/checking humidity','Instrumentos y aparatos automát.p/control de humedad',11,'90','9032','903289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328984','Instrumentos e apars.automat.p/controle velocid.motores','Autom.instruments and apparatus f/checking speed motors','Instrumentos y apars.automát.p/control velocid.motores',11,'90','9032','903289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328989','Outs.instrum.e apars.automat.p/controle grandez.n/eletr','Oth.autom.instrum.and apparatus f/great.checking n/elec','Los dem.instr.y apars.autom.p/control grandez.n/eléctr',11,'90','9032','903289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90328990','Outs.instrumentos e apars.automat.p/regulacao/controle','Oth.autom.regulating/controlling instrum.and apparatus','Los dem.instrumentos y apars.automát.p/regulac./control',11,'90','9032','903289');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90329010','Circuito impresso montado, p/apars.automat.regulação, etc','Circuit printed mounted,f/autom.regulating appar.etc','Circuito impreso montado, p/apars.automát.regulación, etc',10,'90','9032','903290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90329091','Partes e acessórios para termostatos automáticos','Parts and accessories f/automatic thermostats','Partes y acces.p/termostatos automáticos',10,'90','9032','903290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90329099','Partes e acess.p/outs.aparelhos automat.p/regulacao, etc','Parts and access.f/other autom.regulating apparatus,etc','Partes y acces.p/ots.aparatos automát.p/regulación, etc',10,'90','9032','903290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('90330000','Partes e acess.p/outs.maqs.apars.instrum.de óptica, etc.','Parts and acess.f/oth.optical mach.appar.instrumen.etc.','Partes y acces.p/ots.máqs.apars.instrum.de óptica, etc',10,'90','9033','903300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91011100','Relógio de pulso, cx.met.prec.func.eletr.mostr.mecan.','Wrist watches,prec.met.case electr.func.mechanic.display','Relojes de pulsera, caja met.prec.eléctr.c/indic.mecán.',11,'91','9101','910111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91011200','Relógio de pulso, cx.met.prec.func.eletr.mostr.optoeletr','Wrist watches,prec.met.case elec.func.opto-elect.display','Relojes de pulsera, caja met.prec.eléctr.ind.optoeléctr',11,'91','9101','910112');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91011900','Outs.relógios de pulso, cx.de metal prec.etc.func.eletr.','Oth.wristwatches,prec.met.case,etc.electr.function','Relojes de pulsera, caja.de metal prec.etc.eléctr.',11,'91','9101','910119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91012100','Relógio de pulso, cx.met.prec.etc.corda automat.','Wristwatches,prec.met.case,etc.automatic winding','Reloj de pulsera, caja met.prec.etc.automático',11,'91','9101','910121');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91012900','Outros relógios de pulso, cx.metal prec.etc.','Other wristwatches,prec.metal case,etc.','Los demás relojes de pulsera, caja de metal prec.etc',11,'91','9101','910129');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91019100','Relógio de bolso, semelh.cx.met.prec.etc.func.eletr.','Pocket-watches,and oth.prec.metal case,etc.elec.oper.','Reloj de bolsillo, simil.caja met.prec.etc.eléctr.',11,'91','9101','910191');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91019900','Outros relógios de bolso, semelh.cx.metal prec.etc.','Other pocket-watches,and oth.prec.metal case,etc.','Los demás relojes de bolsillo, simil.caja metal prec.etc',11,'91','9101','910199');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91021110','Relógio de pulso, cx.met.comum, func.eletr.mostr.mecan.','Wristwatches,base metal case,elect.operat.mech.disp','Reloj de pulsera, caja met.común, eléctr.indic.mecán.',11,'91','9102','910211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91021190','Outros relógios de pulso, func.eletr.mostr.mecan.','Oth.wristwatches,elect.operat.mechanical display','Los dem.relojes de pulsera, eléctr.indic.mecán.',11,'91','9102','910211');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91021210','Relógio de pulso, cx.met.comum, func.eletr.mostr.optoelet','Wristwatches,metal base case,elect.oper.opto-elec.disp','Reloj de pulsera, caja met.común, eléctr.indic.optoelectr',11,'91','9102','910212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91021220','Relógio de pulso, cx.plástico, func.eletr.mostr.optoeletr','Wristwatches,plastic case,elect.oper.opto-elec.disp','Reloj de pulsera, caja plástico, eléctr.indic.optoelectr.',11,'91','9102','910212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91021290','Outros relógios de pulso, func.eletr.mostr.optoeletr.','Oth.wristwatches,plast.case,elect.oper.opto-elec.displ','Los dem.relojes de pulsera, eléctr.ind.optoelectr.',11,'91','9102','910212');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91021900','Outros relógios de pulso, func.eletr.','Other wristwatches, electrically operated','Los demás relojes de pulso, eléctrico',11,'91','9102','910219');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91022100','Relógio de pulso, de corda automático','Wristwatches, with automatic winding','Reloj de pulsera, automático',11,'91','9102','910221');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91022900','Outros relógios de pulso','Other wristwatches','Los demás relojes de pulsera',11,'91','9102','910229');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91029100','Relógio de bolso, semelh.func.eletr.','Pocket-watches,electrically operated and other watches','Reloje de bolsillo, simil.eléctr.',11,'91','9102','910291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91029900','Outros relógios de bolso, semelh.','Other pocket-watches and other watches','Los demás relojes de bolsillo, similares',11,'91','9102','910299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91031000','Despertadores e outs.relógios, maquin.peq.vol.func.eletr','Clocks with watch movements','Despertadores y dem.relojes, mecan.peq.vol.eléctr.',11,'91','9103','910310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91039000','Outros despertadores/outros relógios, maquin.peq.vol.','Oth.colocks with watch movements','Los dem.despertadores/demás relojes, mecan.peq.vol.',11,'91','9103','910390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91040000','Relógios p/paineis de instrum.p/automóveis e outs.veics','Instrum.panel clocks f/motor vehicles and oth.vehicles','Relojes de tablero de instr.p/automóviles y ots.vehícs',11,'91','9104','910400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91051100','Outros despertadores func.eletr.exc.maquin.peq.vol.','Oth.clocks,electrically operat.exc.watch movements','Los dem.despertadores, eléctr.exc.mecan.peq.vol.',11,'91','9105','910511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91051900','Outros despertadores exc.maquin.peq.vol.','Other clocks,except watch movements','Los demás despertadores exc.mecan.peq.vol.',11,'91','9105','910519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91052100','Pendulas/relógios parede, func.eletr.exc.maquin.peq.vol.','Wall clocks,electrically operat.exc.watch movements','Relojes de pared, eléctr.exc.mecan.peq.vol.',11,'91','9105','910521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91052900','Outras pêndulas e relógios de parede, exc.maquin.peq.vol','Oth.wall clocks,electric.operat.exc.watch movements','Las dem.péndulas y relojes de pared, exc.mecan.peq.vol',11,'91','9105','910529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91059100','Outros aparelhos de relojoaria, func.eletr.exc.maquin.peq.vol.','Ot.watchmak.appar.electr.operat.exc.watch movements','Los dem.relojes, eléctr.exc.mecan.peq.vol.',11,'91','9105','910591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91059900','Outros aparelhos de relojoaria, exc.c/maquinismo de peq.volume','Oth.watchmak.apparatus exc.watch movements','Los demás relojes, exc.c/mecanismo de peq.vol.',11,'91','9105','910599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91061000','Relógios de ponto, relog.datadores e contadores de horas','Time-registers and time-recorders','Registradores asist, registr.fechadores y reg.contadores',11,'91','9106','910610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91062000','Parquímetros','Parking meters','Parquímetros',11,'91','9106','910620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91069000','Outros aparelhos de controle/contadores de tempo, etc.','Time of day recording appar.and appar.f/measuring,etc.','Los dem.aparatos de control/contadores de tiempo, etc',11,'91','9106','910690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91070010','Interruptores horários','Time switches','Interruptores horarios',11,'91','9107','910700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91070090','Outs.apars.p/acionar mecanismo em tempo determinado, etc','Oth.apparatus f/working mechan.in certain time,etc','Los dem.apars.q.perm.accionar disp.en un mom.dado, etc',11,'91','9107','910700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91081110','Maquinismo montado p/relog.pulso, func.eletr.mostr.mecan','Watch movem.f/wristwatches,elect.operat.mech.display','Mecanismo montado de reloj pulsera, eléctr.ind.mecán',11,'91','9108','910811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91081190','Maquinismo montado p/outs.relog.peq.vol.f.eletr.m.mecan','Watch movem.f/oth.watch movements elect.oper.m.disp.','Mecanismo montado p/dem.relojes, peq.vol.eléct.ind.mecán',11,'91','9108','910811');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91081200','Maquinismo montado para relógio de pulso, func.eletr.mostr.optoe','Watch movem.f/oth.wristw.electr.operat.opto-elect.disp.','Mecanismo montado p/reloj pulsera, eléctr.ind.optoelectr',11,'91','9108','910812');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91081900','Maquinismo montado p/outs.relog.peq.vol.f.eletr.m.optoe','Watch movem.f/ot.watch movements elect.oper.op.elec.dis','Mecanismo montado p/dem.reloj, peq.vol.eléctr.ind.optoel',11,'91','9108','910819');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91082000','Maquinismo montado p/relógio peq.vol.de corda automat.','Watch movem.f/watch movements with autom.winding','Mecanismo montado p/reloj, peq.vol., automáticos',11,'91','9108','910820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91089000','Outs.maquinismos de peq.vol.para relógios, montados','Other watch movements for watches,assembled','Los dem.mecanismos de peq.vol.p/relojes, montados',11,'91','9108','910890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91089100','Outros maquinismos montados med<=33.8mm, p/outs.relógios','Oth.watch movements meas.<=33.8mm,f/oth.watches','Los dem.mecanismos montados q.mid<=33.8mm, p/dem.relojes',11,'91','9108','910891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91089900','Outs.maquinismos montados peq.vol.compl.p/outs.relógios','Oth.watch movements, assembled for other watches','Los dem.mecanismos montados peq.vol.compl.p/dem.relojes',11,'91','9108','910899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91091000','Maquinismo de art.relojoaria, funcionando eletricamente','Machinery of clocks and watches, electrically operated','Maquinaria de relojes, accionamiento eléctrico',11,'91','9109','910910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91091100','Maquinismo montado exc.peq.vol.p/despertador, func.eletr','Clock movements, assembled f/of alarm clocks,oper.elect.','Mecanismo montado exc.peq.vol.p/despertador, eléctr',11,'91','9109','910911');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91091900','Maquinismo montado exc.peq.vol.p/outs.relog.func.eletr.','Clock movements, assembled f/oth.watches,oper.elect.','Mecanismo montado exc.peq.vol.p/dem.reloj.eléctr.',11,'91','9109','910919');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91099000','Maquinismo montado exc.peq.vol.p/outs.apars.relojoaria','Clock movements, assembled f/oth.watch apparatus','Mecanismo montado exc.peq.vol.p/dem.mecan.relojería',11,'91','9109','910990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91101110','Maquinismo completo, n/montado, p/relógio pulso, bolso, etc','Complete watch, unassembled,w ristwatches,pocket,etc','Mecanismo complet.s/montar, p/reloj pulsera, bolsillo, etc',11,'91','9110','911011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91101190','Maquinismo compl.n/montado, p/outs.relógios de peq.vol.','Complete watch unassembled,f/oth.watch movements','Mecanismo compl.s/montar, p/dem.relojes de peq.vol.',11,'91','9110','911011');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91101200','Maquinismo incompl.montado, p/apars.relojoaria peq.vol.','Incomplete movements assemb.f/watch movements appar.','Mecanismo incompl.montado, p/mecan.relojería peq.vol.',10,'91','9110','911012');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91101900','Esbocos de maquinismos p/apars.relojoaria de peq.vol.','Rough movements,f/watch movements apparatus','Mecanismos "en blanco"p/mecan.relojeráa de peq.vol.',10,'91','9110','911019');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91109000','Maquinismo n/montado compl.p/apars.relojoar.exc.peq.vol','Complete watch unassembled f/watch movements appar.','Mecanismo s/montar compl.p/mecan.relojer.exc.peq.vol',10,'91','9110','911090');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91111000','Caixas para relógio de pulso/bolso, de metal precioso, etc.','Cases f/wristwatches/pocket,of precious metal,etc.','Cajas de reloj de pulsera/bolsillo, de met.precioso, etc',11,'91','9111','911110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91112010','Caixas para relógio de pulso/bolso, de latão, em esboço','Cases f/wristwatches/pocket,alloy copp.and zinc,sketch','Cajas de reloj de pulsera/bolsillo, de latón, en esbozos',11,'91','9111','911120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91112090','Caixas para relógio de pulso/bolso, de outros metais comuns','Cases f/wristwatches/pocket,of other base metal','Cajas de reloj de pulsera/bolsillo, de dem.met.comunes',11,'91','9111','911120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91118000','Caixas para relógio de pulso/bolso, de outras matérias','Cases f/wristwatches/pocket,of other material','Cajas de reloj de pulsera/bolsillo, de demás materias',11,'91','9111','911180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91119010','Fundos para caixa de relógio de pulso/bolso, de metal comum','Bottoms f/wristwatches/pocket,of base metal','Fondos p/caja de reloj de pulsera/bolsillo, de met.común',10,'91','9111','911190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91119090','Outras partes para caixa de relógio de pulso/bolso','Other parts f/wristwatches/pocket cases','Las dem.partes p/caja de reloj de pulsera/bolsillo',10,'91','9111','911190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91121000','Caixas e semelh.p/aparelhos de relojoaria, de metal','Cases and similar for watch apparatus,of metal','Cajas y simil.p/mecanismos de relojería, de metal',11,'91','9112','911210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91122000','Caixas e semelhantes de apars.de relojoaria','Cases and similar of watch apparatus','Cajas y similares de mecan.de relojería',11,'91','9112','911220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91128000','Caixas e semelh.p/apars.de relojoaria, de outs.matérias','Cases and similar f/watch apparatus,of other material','Cajas y simil.p/mecan.de relojería, de dem.materias',11,'91','9112','911280');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91129000','Partes para caixas e semelhantes p/aparelhos de relojoaria','Parts f/cases and similar f/watch apparatus','Partes p/cajas y simil.p/aparatos de relojería',10,'91','9112','911290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91131000','Pulseiras para relógios, de metal precioso, folheado, etc.','Bracelets f/watches,of prec.metal,veneer,etc','Pulseras p/reloj, de metal precioso, chapado, etc',10,'91','9113','911310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91132000','Pulseiras para relógios, de metal comum','Bracelets for watches, of base metal','Pulseras para reloj, de metal común',10,'91','9113','911320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91139000','Pulseiras para relógios, de outs.mater.e partes p/pulseiras','Bracelets f/watches,of oth.material and parts thereof','Pulseras p/reloj, de dem.mater.y partes p/pulseras',10,'91','9113','911390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91141000','Molas para aparelhos de relojoaria, inclusive as espirais','Springs f/watch apparatus,incl.hair-springs','Muelles p/aparatos de relojería, incl.las espirales',10,'91','9114','911410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91142000','Pedras para aparelhos de relojoaria','Jewels for watch apparatus','Piedras para aparatos de relojería',10,'91','9114','911420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91143000','Quadrantes para aparelhos de relojoaria','Dials for watch apparatus','Cuadrantes para aparatos de relojería',10,'91','9114','911430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91144000','Platinas e pontes para aparelhos de relojoaria','Plates and bridges for watch apparatus','Platinas y puentes para aparatos de relojería',10,'91','9114','911440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91149010','Coroas para aparelhos de relojoaria','Crowns for watch apparatus','Coronas para aparatos de relojería',10,'91','9114','911490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91149020','Ponteiros para aparelhos de relojoaria','Hands for watch apparatus','Agujas para aparatos de relojería',10,'91','9114','911490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91149030','Hastes para aparelhos de relojoaria','Stems for watch apparatus','Tijas para aparatos de relojería',10,'91','9114','911490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91149040','Básculas para aparelhos de relojoaria','Yokes for watch apparatus','Básculas para aparatos de relojería',10,'91','9114','911490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91149050','Eixos e pinhões para aparelhos de relojoaria','Balance staffs and pinions f/watch apparatus','Ejes y piñones para aparatos de relojería',10,'91','9114','911490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91149060','Rodas para aparelhos de relojoaria','Wheels fpr watch apparatus','Ruedas para aparatos de relojería',10,'91','9114','911490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91149070','Rotores para aparelhos de relojoaria','Rotors for watch apparatus','Rotores para aparatos de relojería',10,'91','9114','911490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('91149090','Outras partes e acess.p/aparelhos de relojoaria','Other parts and access.f/watch apparatus','Las demás partes y acces.p/aparatos de relojería',10,'91','9114','911490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92011000','Pianos verticais','Upright pianos','Pianos verticales',11,'92','9201','920110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92012000','Pianos de cauda','Grand pianos','Pianos de cola',11,'92','9201','920120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92019000','Outros pianos, cravos e outs.instrum.de cordas, com teclado','Oth.pianos,harpsich.and oth.keyboard stringed instrum.','Los dem.pianos, clavecines y dem.instr.de cuerdas, c/tecl',11,'92','9201','920190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92021000','Instrumentos musicais de cordas, tocados com auxílio de arco','Other string musical instruments,played with a bow','Instrumentos musicales de cuerda, de arco',11,'92','9202','920210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92029000','Outros instrumentos musicais de cordas','Other string musical instruments','Los demás instrumentos musicales de cuerda',11,'92','9202','920290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92030000','Órgãos de tubos e de teclado, harmônios e instrum.semelhantes','Keyboard pipe organs,harmon.and similar keyboard instr.','Órganos de tubos y teclado, armonios y instrum.simil.',11,'92','9203','920300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92041000','Acordeoes e instrumentos semelhantes','Accordions and similar instruments','Acordeones y instrumentos similares',11,'92','9204','920410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92042000','Harmônicas (gaitas) de boca','Mouth harmonics','Armónicas',11,'92','9204','920420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92051000','Instrumentos musicais de sopro denominados "metais"','Brass-wind musical instruments','Instrumentos musicales de viento llamados "metales"',11,'92','9205','920510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92059000','Outros instrumentos musicais de sopro','Other wind musical instruments','Los demás instrumentos musicales de viento',11,'92','9205','920590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92060000','Instrumentos musicais de percussão (tambores, etc.)','Percussion musical instruments(drums,etc.)','Instrumentos musicales de percusión (tambores, etc)',11,'92','9206','920600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92071010','Sintetizadores (instrumentos musicais de teclado)','Synthesizers (musical instruments of keyboard)','Sintetizadores (instrumentos musicales de teclado)',11,'92','9207','920710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92071090','Outros instrumentos musicais de teclado','Other keyboard musical instruments','Los demás instrumentos musicales de teclado',11,'92','9207','920710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92079010','Guitarra e contrabaixo','Guitar and bass guitar','Guitarra y contrabajo',11,'92','9207','920790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92079090','Outros instrumentos musicais c/som amplif.por meio elet','Musical instruments with sound amplified,electrically','Los dem.instr.musicales en los q.sonido amplif.eléctr.',11,'92','9207','920790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92081000','Caixas de música','Music boxes','Cajas de música',11,'92','9208','920810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92089000','Órgãos mecânicos de feira e outros instrumentos musicais','Fairground organs and other musical instruments','Orquestriones y dem.instrumentos musicales',11,'92','9208','920890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92091000','Metrônomos e diapasões para instrumentos musicais','Metronomes,tuning forks and pitc.pip.f/musical instrum.','Metrónomos y diapasones p/instrumentos musicales',10,'92','9209','920910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92092000','Mecanismo de caixas de música','Mechanisms for musical boxes','Mecanismo de cajas de música',10,'92','9209','920920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92093000','Cordas para instrumentos musicais','Strings for musical instruments','Cuerdas para instrumentos musicales',10,'92','9209','920930');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92099100','Partes e acessórios para pianos','Parts and accessories for pianos','Partes y accesorios de pianos',10,'92','9209','920991');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92099200','Partes e acessórios para instrumentos musicais de cordas','Parts and access for string musical instruments','Partes y acces.p/instrumentos musicales de cuerdas',10,'92','9209','920992');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92099300','Partes e acessórios para órgãos de tubos e de teclados, etc.','Parts and access f/organs of tubes and of keyboards,etc','Partes y acces.p/órganos de tubos y teclados, etc',10,'92','9209','920993');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92099400','Partes e acessórios para instrum.musicais som amplif.meio eletr','Parts and acces.f/musical instr.with sound ampl.elect.','Partes y acces.de instr.music.en q.sonido amplif.eléct.',10,'92','9209','920994');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('92099900','Partes e acessórios para outros instrumentos musicais','Parts and access. for other musical instruments','Partes y acces.p/demás instrumentos musicales',10,'92','9209','920999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93010000','Armas de guerra, exceto revólveres, pistolas e armas brancas','Military weapons,exc.revolvers,pitols and the arms','Armas de guerra, exc.revólveres, pistolas y armas blancas',11,'93','9301','930100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93011000','Peças de artilharia(exemplo:canhões,obuses,morteiros)','Artillery weapons (eg guns, howitzers, mortars)','Piezas de artillería (cañones, obuses, morteros)',11,'93','9301','930110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93011100','Peças de artilharia, autopropulsadas','Artillery weapons, self-propelled','Piezas de artillería, autopropulsadas',11,'93','9301','930111');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93011900','Outras peças de artilharia','Other artillery weapons','Las demás piezas de artillería',11,'93','9301','930119');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93012000','Lança-foguetes, lança-chamas, lança-granada, etc','Rocket launchers,flame-throwers,grenade launcher,etc','Lanzacohetes, lanzallamas, lanzagranada, etc',11,'93','9301','930120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93019000','Outras armas de guerra','Other military weapons','Las demás armas de guerra',11,'93','9301','930190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93020000','Outros revólveres e pistolas','Other revolvers and pistols','Los demás revólveres y pistolas',11,'93','9302','930200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93031000','Armas de fogo carregáveis exclusivamente pela boca','Muzzle-loading firearms','Armas de avancarga',11,'93','9303','930310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93032000','Espingardas/carabinas para caça/tiro-ao-alvo, cano liso>=1','Sporting/hunting/target-shooting shotguns,smoot.barr>=1','Armas largas de caza/tiro deportivo, cañón lisa>=1',11,'93','9303','930320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93033000','Outras espingardas/carabinas para caça/tiro-ao-alvo','Other sporting/hunting/target-shooting shotguns','Las demás armas largas de caza/tiro deportivo',11,'93','9303','930330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93039000','Outras armas de fogo que utilizzam deflagração da pólvora, etc.','Oth.firearms which oper.by firing of an expl.charge,etc','Las dem.armas de fuego q.util.deflagr.de pólvora, etc',11,'93','9303','930390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93040000','Outras armas (espingardas/carabinas/pistolas/cassetetes)','Oth.arms (shotguns/carbines/pistols /truncheons)','Las dem.armas (armas largas/carabinas/pistolas/porras)',11,'93','9304','930400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93051000','Partes e acessórios para revólveres/pistolas','Parts and accessories for revolvers/pistols','Partes y acces.p/revólveres/pistolas',10,'93','9305','930510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93052000','Partes e acess.de espingardas ou carabinas da pos. 9303','Parts and accessories of shotguns or rifles (9303)','Partes y accesorios de escopetas o rifles de 9303',10,'93','9305','930520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93052100','Partes e acessórios para espingarda/carabina de fogo, cano liso','Parts and acces.f/shotguns/carbines,smooth barrel','Partes y acces.p/armas larga/rifle caza, can.ánima lisa',10,'93','9305','930521');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93052900','Partes e acessórios para outras espingardas/carabinas de fogo','Parts and acces.f/other shotguns/carbines','Partes y acces.p/demás armas larga/rifles caza',10,'93','9305','930529');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93059010','Partes e acessórios para armas de guerra','Parts and accessories for military weapons','Partes y accesorios para armas de guerra',10,'93','9305','930590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93059090','Partes e acessórios para outras armas','Parts and accessories for other arms','Partes y accesorios para demás armas',10,'93','9305','930590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93059100','Partes/acessórios de armas de guerra, etc.','Parts/accessorries of military weapons,etc','Partes/accesorios de armas de guerra, etc',10,'93','9305','930591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93059900','Partes/acessórios de outras armas','Parts/accessories of other arms','Partes/accesorios de demás armas',10,'93','9305','930599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93061000','Cartuchos para pistolas de rebitar/embolo para abater animais','Cartridges for riveting/captive-bolt humane killers','Cartuchos p/pistolas de remachar/usos simil/de matarife',10,'93','9306','930610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93062100','Cartuchos para espingardas/carabinas de cano liso','Cartridges shotguns/carbines of smooth barrel','Cartuchos p/escopetas/carabinas c/cañón ánima lisa',10,'93','9306','930621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93062900','Chumbos para carabinas de ar comprimido, partes para cartuchos','Lead f/carbines of compressed air,parts f/cartridges','Balines p/armas de aire comprimido, partes p/cartuchos',10,'93','9306','930629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93063000','Outros cartuchos e suas partes','Other cartridges and parts thereof','Los demás cartuchos y sus partes',10,'93','9306','930630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93069000','Bombas, granadas, outs.muniçõeses e projéteis e suas partes','Bombs,grenades,oth.munitions of war and parts thereof','Bombas, granadas, dem.municiones y proyectiles y sus part',10,'93','9306','930690');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('93070000','Sabres, espadas, baionetas, outs.armas brancas, suas partes','Swords,cutlasses,bayonets,oth.arms and parts thereof','Sables, espadas, bayonetas, dem.armas blancas, sus partes',10,'93','9307','930700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94011010','Assentos ejetáveis, para veículos aéreos','Ejector seats, for aircraft','Asientos expulsables, para aeronaves',11,'94','9401','940110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94011090','Outros assentos para veículos aéreos, exceto ejetáveis','Other seats for aircraft, except ejector seats','Los demás asientos p/aeronaves, exc.expulsables',11,'94','9401','940110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94012000','Assentos para veículos automóveis','Seats for motor vehicles','Asientos para vehículos automóviles',11,'94','9401','940120');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94013010','Assentos giratórios, de altura ajustável, de madeira','Swivel seats with variable height adjustment,of wood','Asientos giratorios, de altura ajustab.de madera',11,'94','9401','940130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94013090','Assentos giratórios, de altura ajustável, de outras matérias','Swivel seats with variab.height adjustm.of oth.material','Asientos giratorios, de altura ajustab.de dem.materias',11,'94','9401','940130');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94014010','Assentos transformáveis em camas, de madeira','Seats convertible into beds, of wood','Asientos transformables en cama, de madera',11,'94','9401','940140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94014090','Assentos transformáveis em camas, de outras matérias','Seats convertible into beds,of oth.materials','Asientos transformables en cama, de dem.materias',11,'94','9401','940140');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94015000','Assentos de cana, vime, bambu ou de matérias semelhantes','Seats of cane,osier,bamboo or similar materials','Asientos de roten, mimbre, bambú o materias similares',11,'94','9401','940150');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94015100','Assentos de ratâ, bambu/matérias semelhantes','Seats of rattan, bamboo or similar materials','Asientos de ratán, bambú o materias similares',11,'94','9401','940151');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94015900','Outros assentos de ratã, bambu, matérias semelhantes','Other seats of rattan, bamboo or similar materials','Otros asientos de ratán, bambú o materias similares',11,'94','9401','940159');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94016100','Assentos estofados, com armação de madeira','Upholstered seats, with wooden frames','Asientos con relleno, con armazón de madera',11,'94','9401','940161');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94016900','Outros assentos com armação de madeira','Other seats, with wooden frames','Los demás asientos con armazón de madera',11,'94','9401','940169');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94017100','Assentos estofados, com armação de metal','Upholstered seats, with metal frames','Asientos con relleno, con armazón de metal',11,'94','9401','940171');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94017900','Outros assentos com armação de metal','Other seats, with metal frames','Los demás asientos con armazón de metal',11,'94','9401','940179');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94018000','Outros assentos','Other seats','Los demás asientos',11,'94','9401','940180');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94019010','Partes para assentos, de madeira','Parts for seats, of wood','Partes para asientos, de madera',10,'94','9401','940190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94019090','Partes para assentos, de outras matérias','Parts for seats, of other materials','Partes para asientos, de demás materias',10,'94','9401','940190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94021000','Cadeiras de dentista/salões de cabeleireiro, etc.partes','Dentists'', barbers'', or similar chairs and parts thereof','Sillones de dentista/de peluquería, etc.sus partes',10,'94','9402','940210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94029010','Mesas para operação cirúrgica','Tables for surgical operation','Tablas para la intervención quirúrgica',10,'94','9402','940290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94029020','Camas dotadas de mecanismos para usos clínicos','Hospital beds with mechanical fittings','Camas con mecanismos p/uso clínico',10,'94','9402','940290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94029090','Outros mobiliários para medicina, cirurgia, odontologia, etc.','Other furnitures for medicine,surgery,dentistry,etc.','Los dem.mobiliarios p/medicina, cirugía, odontología, etc',10,'94','9402','940290');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94031000','Móveis de metal para escritórios','Metal furniture for offices','Muebles de metal para oficinas',11,'94','9403','940310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94032000','Outros móveis de metal','Other metal furniture','Los demás muebles de metal',11,'94','9403','940320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94033000','Móveis de madeira para escritórios','Wooden furniture for offices','Muebles de madera para oficinas',11,'94','9403','940330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94034000','Móveis de madeira para cozinhas','Wooden furniture for kitchen','Muebles de madera para cocinas',11,'94','9403','940340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94035000','Móveis de madeira para quartos de dormir','Wooden furniture for bedroom','Muebles de madera para dormitorios',11,'94','9403','940350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94036000','Outros móveis de madeira','Other wooden furniture','Los demás muebles de madera',11,'94','9403','940360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94037000','Moveis de plásticos','Furniture of plastics','Muebles de plásticos',11,'94','9403','940370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94038000','Moveis de outras matérias, incl.rotim, vime, bambu, etc.','Furniture of oth.materials,incl.cane,osier,bamboo,etc.','Muebles de otras materias, incl.roten, mimbre, bambú, etc',11,'94','9403','940380');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94038100','Movéis de bambu ou ratã','Bamboo furniture','Muebles de bamboo o ratán',11,'94','9403','940381');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94038900','Móveis outs.mat, incl.ratã, vime, bambu, semel.','Furniture of oth.materials,incl.rattan,osier,bamboo,simil. mat.','Muebles de otras materias, incl.ratán, mimbre, bambú y simil.',11,'94','9403','940389');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94039010','Partes para móveis, de madeira','Parts for wooden furniture','Partes para muebles, de madera',10,'94','9403','940390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94039090','Partes para móveis, de outras matérias','Parts for furniture, of other materials','Partes para muebles, de otras materias',10,'94','9403','940390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94041000','Suporte elástico para camas','Mattress supports','Somieres',10,'94','9404','940410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94042100','Colchões de borracha/plásticos alveolares, mesmo rocob.','Rubber mattresses/alveolar plastics, including covered ones','Colchones de caucho/plásticos alveolares,  incluso cubiertos',11,'94','9404','940421');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94042900','Colchões de outras matérias','Mattresses of other materials','Colchones de otras materias',11,'94','9404','940429');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94043000','Sacos de dormir','Sleeping bags','Sacos de dormir',11,'94','9404','940430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94049000','Edredões, almofadas, pufes, travesseiros e artigos semelhantes','Eiderdowns, cushions, pouffes, pillows and simil.articles','Edredones, cojines, pufes, almohadas y arts.simil.',10,'94','9404','940490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94051010','Lâmpadas escialíticas','Scyalitic lamps','Lámparas escialíticas',10,'94','9405','940510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94051091','Lustres e aparelhos ilumin.eletr.de pedra, para teto/parede','Chand.and elect.lamps ligh.fittin.of stone,f/ceil/wall','Lámparas y apars.de alumbr.eléctr.de pied.p/techo/pared',10,'94','9405','940510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94051092','Lustres e aparelhos ilumin.eletr.de vidro, para teto/parede','Chand.and elect.lamps ligh.fittin.of glass,f/ceil/wall','Lámparas y apars.de alumbr.eléctr.de vidr.p/techo/pared',10,'94','9405','940510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94051093','Lustres e apars.ilumin.eletr.de met.comum, para teto/parede','Chand.and elect.lamps ligh.fittin.base met.f/ceil/wall','Lámparas y apars.de alumb.eléct.de met.com./techo/pared',10,'94','9405','940510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94051099','Lustres e apars.ilumin.eletr.de outs.mater.para teto/parede','Chand.and elect.lamps ligh.fittin.oth.mat.f/ceil/wall','Lámparas y apars.de alumb.eléct.de dem.mat./techo/pared',10,'94','9405','940510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94052000','Abajures de cabeceira ou de escritório, etc.elétricos','Bedside or office electric lamps,etc','Lámparas eléctricas de cabecera o oficina, etc',10,'94','9405','940520');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94053000','Guirlandas elétricas para árvores de natal','Lighting sets for christmas trees','Guirnaldas eléctricas para árboles de navidad',10,'94','9405','940530');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94054010','Outros aparelhos elétricos de iluminação, de metais comuns','Oth.electric lamps and lighting fittings,of base metal','Los dem.aparatos eléctricos de alumbrado, de met.comunes',10,'94','9405','940540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94054090','Outros aparelhos elétricos de iluminação, de outras matérias','Oth.electric lamps and light.fittings,of oth.materials','Los dem.aparatos eléctricos de alumbrado, de dem.mat.',10,'94','9405','940540');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94055000','Aparelhos não-elétricos de iluminação','Non-electrical lamps and lighting fittings','Aparatos de alumbrado no eléctricos',10,'94','9405','940550');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94056000','Anúncios, cartazes e placas indicadoras, luminosos, etc.','Illuminated signs,illuminated name-plates,etc.','Anuncios, letreros y placas indicadoras, luminosos, etc',10,'94','9405','940560');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94059100','Partes para aparelhos de iluminação, de vidro','Parts f/lamps and lighting fittings,of glass','Partes p/aparatos de iluminación, de vidrio',10,'94','9405','940591');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94059200','Partes para aparelhos de iluminação, de plásticos','Parts f/lamps and lighting fittings,of plastic','Partes p/aparatos de iluminación, de plástico',10,'94','9405','940592');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94059900','Partes para aparelhos de iluminação, de outras matérias','Parts f/lamps and lighting fittings,of other materials','Partes p/aparatos de iluminación, de demás materias',10,'94','9405','940599');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94060010','Estufas pré-fabricadas','Prefabricated greenhouses','Invernaderos prefabricados',10,'94','9406','940600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94060091','Outras construções pré-fabricadas, de madeira','Other prefabricated buildings, of wood','Las demás construcciones prefabricadas, de madera',10,'94','9406','940600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94060092','Outras construções pré-fabricadas, de ferro ou aço','Other prefabricated buildings, of iron or steel','Las dem.construcciones prefabricadas, de hierro o acero',10,'94','9406','940600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('94060099','Outras construções pré-fabricadas, de outras matérias','Other prefabricated buildings, of other materials','Las dem.construcciones prefabricadas, de otras materias',10,'94','9406','940600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95010000','Brinquedos de rodas para crianças e carrinhos para bonecos','Wheeled toys for children and dolls'' carriages','Juguetes de ruedas p/niños y coches de ruedas p/muñecos',10,'95','9501','950100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95021010','Bonecos de figura humana, com mecanismo à corda/elétrico','Dolls represent.human beings,with mechan./electric','Muñecos q.repr.seres humanos, c/mecan.a cuerda/eléctr.',11,'95','9502','950210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95021090','Outros bonecos de figura humana, mesmo vestidos','Other dolls repres.human beings,whether or not dressed','Los demás muñecos q.repr.seres humanos, incl.vestidos',11,'95','9502','950210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95029100','Vestuário e seus acess.etc.para bonecos de figura humana','Garments and acces.therefor f/dolls repres.human beings','Prendas de vest.y sus compl.etc.p/muñec.q.repr.ser.hum.',10,'95','9502','950291');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95029900','Outras partes e acess.p/bonecos de figura humana','Other parts and access.f/dolls repres.human beings','Las demás partes y acces.p/muñecos q.repr.seres humanos',10,'95','9502','950299');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95030010','Brinq.d/roda p/criança/carrinhos p/bonecos','Wheeled toys f/children and dolls'' carriages','Juguetes de ruedas p/niños y coches de ruedas p/muñecos',10,'95','9503','950300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95030021','Bonecos acionados por mecanismo de corda/elétrico','Dolls activated by mechanism of rope or electric','Muñecos activ. p/ mecan.a cuerda/eléctr.',11,'95','9503','950300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95030022','Outros bonecos, mesmo vestidos','Other puppets, even dressed','Otros muñecos, incluso vestidos',11,'95','9503','950300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95030029','Outras partes e acessórios de bonecos','Other parts and accessories for dolls ','Otras partes y acces.para muñecos ',10,'95','9503','950300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95030031','Brinq.repres.animais criat.ñ hum.c/enchim','Filled toys repres.animals, no hum. criatu. ','Otros jugetes rellenos, que repr. animales, ciat. no human.',11,'95','9503','950300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95030039','Outs.brinq.repres.anim., criaturas não humanas','Other toys repres.animals, no hum. criatu. ','Otros jugetes, que repr. animales, ciat. no human.',11,'95','9503','950300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95030040','Trens elétricos de brinquedo, inclusive trilhos, sinais, acessórios','Eletric trains of toy, includ. rail tracks, signs, accessories ','Trenes electricos de juguete inclu. señales,  accesorios ',10,'95','9503','950300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95030050','Modelo reduzido de brinquedo, em conjunto para montagem','Reduced-size, of toy, for assembly kits','Modelos reducidos, de juguete, para ensamblar',10,'95','9503','950300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95030060','Outros conjuntos e brinquedos, para construção','Other kits and toys for construction','Otros juegos y juguetes de construcción',10,'95','9503','950300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95030070','Quebra-cabeças ("puzzles")','Puzzles','Rompecabezas',11,'95','9503','950300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95030080','Outros brinquedos apresentados em sortidos ou panóplias','Other toys, put up in sets or outfits','Los dem.juguetes en juegos o surtidos o en panoplias',11,'95','9503','950300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95030091','Instrumentos e aparelhos musicais de brinquedo','Toy musical instruments and apparatus','Instrumentos y aparatos musicales, de juguete',11,'95','9503','950300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95030097','Outros brinquedos com motor elétrico','Other toys with electric motor','Otros juguetes con motor eléctrico',11,'95','9503','950300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95030098','Outros brinquedos de fricção, de corda ou de mola','Other toys of friction,mechanical or spring-operated','Los demás juguetes a fricción, a cuerda o a resorte',11,'95','9503','950300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95030099','Outros brinquedos de qualquer tipo','Other toys of any kind','Otros juguetes de cualquier tipo',11,'95','9503','950300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95031000','Trens elétricos de brinquedo, inclusive trilhos, sinais, outros acessórios','Electr.trains of toy.incl.tracks/signals/acces.therefor','Trenes eléctr.de juguet.incl.carriles/señales/dem.acces',10,'95','9503','950310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95032000','Outros modelos reduzidos, de brinquedo, em conj. para montagem','Oth.reduced-size,of toy,f/assembly kits','Los demás modelos reducidos, de juguete, p/ensamblar',10,'95','9503','950320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95033000','Outros conjuntos e brinquedos, para construção','Other kits and toys for construction','Los demás juegos y juguetes de construcción',10,'95','9503','950330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95034100','Brinquedos com enchimento, de figura animal ou não-humana','Filled toys representing animals or non-human creatures','Juguetes rellenos, q.repr.animales o seres no humanos',11,'95','9503','950341');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95034900','Outros brinquedos de figura animal ou não humana','Other toys representing animals or non-human creatures','Los dem.juguetes q.repr.animales o seres no humanos',11,'95','9503','950349');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95035000','Instrumentos e aparelhos musicais, de brinquedo','Toy musical instruments and apparatus','Instrumentos y aparatos musicales, de juguete',11,'95','9503','950350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95036000','Quebra-cabeças ("puzzles")','Puzzles','Rompecabezas',11,'95','9503','950360');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95037000','Outros brinquedos em sortidos ou em panóplias','Other toys, put up in sets or outfits','Los dem.juguetes en juegos o surtidos o en panoplias',11,'95','9503','950370');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95038010','Outros brinquedos e modelos, motorizados, elétricos','Other toys and models,incorporating a motor,electric','Los demás juguetes y modelos, c/motor, eléctricos',11,'95','9503','950380');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95038020','Brinquedos de fricção, corda ou mola, motorizados','Toys of friction,mechan.orspring-operat.incorp.motor','Juguetes a fricción, cuerda o resorte, c/motor',11,'95','9503','950380');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95038090','Outros brinquedos e modelos, motorizados','Other toys and models,incorporating a motor','Los demás juguetes y modelos, c/motor',11,'95','9503','950380');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95039000','Outros brinquedos, etc. para divertimento','Other toys, etc. for entertainment','Los demás juguetes,  etc,  para entretenimiento',11,'95','9503','950390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95039010','Outros brinquedos de fricção, de corda ou de mola','Other toys of friction,mechanical or spring-operated','Los demás juguetes a fricción, a cuerda o a resorte',11,'95','9503','950390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95039090','Outros brinquedos','Other toys','Los demás juguetes',11,'95','9503','950390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95041010','Jogos de vídeo para utilização em aparelhos receptores de televisão','Video games used with a television receiver','Videojuegos de los tipos util.c/receptor de televisión',11,'95','9504','950410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95041091','Cartuchos para jogos de vídeo','Cartridges for video games','Cartuchos p/videojuegos',11,'95','9504','950410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95041099','Outras partes e acessórios para jogos de vídeo','Other parts and access.f/video games','Las demás partes y acces.p/videojuegos',10,'95','9504','950410');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95042000','Bilhares e seus acessórios','Articles and accessories for billiards','Billares y sus accesorios',10,'95','9504','950420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95043000','Outros jogos acionados por ficha/moeda, exceto jogos balizas','Oth.games,operated by coins/banknotes,exc.mark games','Los dem.juegos activ.c/monedas, exc.juegos bolos autom.',11,'95','9504','950430');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95044000','Cartas de jogar','Playing cards','Naipes',11,'95','9504','950440');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95045000','Consoles e maq.de jogos de video(exc.da subpos.9504.30)','Consoles and video game machines (ex. 9504.30)','Consolas y máquinas de videojuegos (ex. 9504.30)',11,'95','9504','950450');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95049000','Outros artigos para jogos de salão','Other articles for funfair','Los demás artícs.p/salas de juegos',11,'95','9504','950490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95049010','Boliches automáticos','Automatic bowling','Juegos de bolos automáticos',11,'95','9504','950490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95049090','Outros artigos para jogos de salão','Other articles for funfair','Los demás artículos p/salas de juegos',11,'95','9504','950490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95051000','Artigos para festas de natal','Articles for christmas festivities','Artículos para fiestas de navidad',10,'95','9505','950510');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95059000','Artigos para outras festas, carnaval ou outros divertimentos','Festive carnival or other entertainment articles','Artículos p/otras fiestas, carnaval o ots.diversiones',10,'95','9505','950590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95061100','Esquis para neve','Skis for snow','Esquís para nieve','13','95','9506','950611');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95061200','Fixadores para esquis','Ski fastenings','Fijadores de esquís',10,'95','9506','950612');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95061900','Outros equipamentos para esquiar na neve','Other articles and equipment f/skiing in the snow','Los demás artículos p/práctica del esquí de nieve',10,'95','9506','950619');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95062100','Pranchas à vela','Sailboards','Deslizadores de vela',11,'95','9506','950621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95062900','Esquis aquáticos e outros equipam.p/esportes aquáticos','Aquatic skis and oth.equipment f/aquatic sports','Esquís acuáticos y demás artículos p/deportes acuáticos',11,'95','9506','950629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95063100','Tacos completos para golfe','Complete clubs for golf','Palos de golf completos',11,'95','9506','950631');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95063200','Bolas para golfe','Balls for golf','Pelotas para golf',11,'95','9506','950632');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95063900','Outros equipamentos para golfe','Other equipment for golf','Los demás artículos p/golf',10,'95','9506','950639');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95064000','Artigos e equipamentos para tênis de mesa','Articles and equipment f/table-tennis','Artículos y material p/tenis de mesa',10,'95','9506','950640');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95065100','Raquetes de tênis, mesmo não encordoadas','Tennis rackets,whether or not strung','Raquetas de tenis, incluso sin cordaje',11,'95','9506','950651');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95065900','Raquetes de "badminton" e raquetes semelhantes','Tennis,badminton or similar rackets','Raquetas de "badminton" y raquetas simil.',11,'95','9506','950659');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95066100','Bolas para tênis, exceto tênis de mesa','Balls for tennis, except for table-tennis','Pelotas de tenis, excep.las de tenis de mesa',11,'95','9506','950661');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95066200','Bolas infláveis','Inflatable balls','Pelotas inflables',11,'95','9506','950662');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95066900','Outras bolas','Other balls','Las demás pelotas',11,'95','9506','950669');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95067000','Patins para gelo e patins de rodas, inclusive fixados em calçado','Ice skates and roller skates,incl.skates attached','Patin.p/hielo y pat.de ruedas, incl.calzado c/pat.fijos','13','95','9506','950670');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95069100','Artigos e equipamentos p/cultura fisica, ginastica, etc.','Articles and equip.f/general physical exercise,gymn.etc','Artículos y material p/cultura física, gimnasia, etc',10,'95','9506','950691');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95069900','Artigos e equipamentos para outros esportes e piscinas','Articles and equip.f/other sports and swimming pools','Artículos y material p/demás deportes y piscinas',11,'95','9506','950699');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95071000','Varas (canas) de pesca','Fishing rods','Cañas de pescar',11,'95','9507','950710');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95072000','Anzóis, mesmo montados em sedelas (terminais)','Fish-hooks, whether or not snelled','Anzuelos, incluso montados en sedal',10,'95','9507','950720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95073000','Molinetes (carretos) de pesca','Fishing reels','Carretes de pesca',11,'95','9507','950730');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95079000','Outros artigos para pesca à linha, pucas, redes, iscas, caca, etc','Other itens for fishing with line, nets, etc','Los dem.arts.p/pesca c/caña, redes, señuelos, etc',11,'95','9507','950790');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95080000','Carrosséis/balanços/outras diversões para parques, circos, etc','Roundabouts,swings/oth.fairground amusemen.circuses,etc','Tiovivos/columpios/dem.atracciones de feria, circos, etc',10,'95','9508','950800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95081000','Circos e coleções de animais ambulantes','Circuses and travelling menageries','Circos y zoológicos ambulantes',10,'95','9508','950810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95089000','Carrosséis, balanços e outras diversões','Roundabouts, swings and other amusements','Tiovivos, columpios y demás atracciones',10,'95','9508','950890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95089010','Montanha-russa, com percurso superior ou igual a 300m','Roller coaster with a course of 300 m or more','Montaña rusa, con trayecto superior o igual a 300m',10,'95','9508','950890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95089020','Carrosséis, com diâmetro superior ou igual a 16 metros','Carrousels, with a diameter of 16 m or more','Tiovivos, con diámetro superior ou igual a 16m',10,'95','9508','950890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95089030','Vagonetes utiliz.em montanha-russa capacid>=6pessoas','Wagons of the type used in roller coasters c>=6passeng.','Coches de los util.en montaña rusa capacid>=6personas',10,'95','9508','950890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('95089090','Outros carrosséis, balanços e outras diversões','Other roundabouts,swings and oth.amusements','Los demás tiovivos, columpios y demás atracciones',10,'95','9508','950890');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96011000','Marfim trabalhado e obras de marfim','Worked ivory and articles of ivory','Marfil trabajado y sus manufacturas',10,'96','9601','960110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96019000','Outras matérias animais para entalhar, trabalhados e obras','Oth.animal carving mater.,articles incl.art.obt.b/mould','Las dem.materias animales p/tallar, trabajadas y manuf.',10,'96','9601','960190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96020010','Cápsulas de gelatinas digeríveis','Gelatin capsules,edible','Cápsulas de gelatinas digeribles',10,'96','9602','960200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96020020','Colméias artificiais','Artificial honeycombs','Colmenas artificiales',10,'96','9602','960200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96020090','Outs.matérias veget/miner.de entalhar, trabalh.obras, etc','Ot.worked vegetable/mineral carving,artic.of these mat','Las dem.materias veget/miner.p/tallar, trabaj.manuf.etc',10,'96','9602','960200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96031000','Vassouras e escovas, de matérias vegetais em feixes','Brooms and brushes,of vegetable material bound together','Escobas y escobillas, de materias vegetales en haces',11,'96','9603','960310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96032100','Escovas de dentes, inclusive as escovas para dentaduras','Toothbrushes,including brushes for dentures','Cepillos de dientes, incl.los cepillos p/dentaduras post',11,'96','9603','960321');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96032900','Escovas e pincéis de barba, escovas para cabelos, cílios, etc','Brushes of beard,brushes f/hair,eyelashes,etc','Cepillos e brochas de afeit., cepillos p/cab., pestañ.etc',11,'96','9603','960329');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96033000','Pincéis e escovas para artistas, p/prods.cosméticos, etc.','Artists'' brushes,f/cosmetics products,etc.','Pinceles y brochas p/pint.artíst., p/cosméticos, etc',11,'96','9603','960330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96034010','Rolos para pintura','Rollers for paint','Rodillos para pintar',11,'96','9603','960340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96034090','Escovas e pincéis p/pintar, caiar, envernizar, etc.bonecas','Paint,distemper,varnish or similar brushes,pain pads','Pinceles y broch.p/pintar, enlucir, barnizar, etc.muñecas',11,'96','9603','960340');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96035000','Outras escovas constit.partes de maqs.apars.ou veículos','Oth.brushes constituting parts of mach.applian/vehicles','Los dem.cepillos q.const.partes de máqs.apars.o vehícs.',11,'96','9603','960350');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96039000','Outras vassouras, escovas, pincéis, espanadores, rodos, etc.','Oth.brooms,brushes,dusters,rakes,etc','Las dem.escobas, cepillos, pinceles, plumeros, rasquet., etc',11,'96','9603','960390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96040000','Peneiras e crivos, manuais','Hand sieves and hand riddles','Tamices, cedazos y cribas, de mano',11,'96','9604','960400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96050000','Sortidos de viagem, p/toucador, p/costura/limpeza roupas','Travel sets,f/personal toilet,f/sewing/clothes cleaning','Surtidos de viaje, p/aseo pers.p/cost./limp.prendas vest',11,'96','9605','960500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96061000','Botões de pressão e suas partes','Button,press-fast.snap-fast.press-studs and parts ther.','Botones de presión y sus partes',10,'96','9606','960610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96062100','Botões de plástico, n/recob.de matérias têxteis','Buttons of plastics,n/covered with textile material','Botones de plástico, s/forrar c/materias textiles',10,'96','9606','960621');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96062200','Botões de metais comuns, n/recob.de matérias têxteis','Buttons of base metal,n/covered with textile material','Botones de metal común, s/forrar c/materias textiles',10,'96','9606','960622');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96062900','Outros botões','Other buttons','Los demás botones',10,'96','9606','960629');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96063000','Formas e outras partes de botoes e esbocos de botoes','Button moulds and ot.parts of buttons and button blanks','Formas y demás partes de botones y esbozos de botones',10,'96','9606','960630');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96071100','Fechos ecler com grampos de metal comum','Slide fasteners with staples of base metal','Cierres de cremallera con dientes de metal comúm',10,'96','9607','960711');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96071900','Outros fechos ecler','Other slide fasteners','Los demás cierres de cremallera',10,'96','9607','960719');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96072000','Partes de fechos ecler','Parts of slide fasteners','Partes de cierres de cremallera',10,'96','9607','960720');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96081000','Canetas esferográficas','Ballpoint pens','Bolígrafos',11,'96','9608','960810');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96082000','Canetas e marcadores, com ponta de feltro/pontas porosas','Felt tipped/porous-tipped pens and markers','Rotuladores y marcadores, c/punta de fielt./punta porosa',11,'96','9608','960820');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96083000','Canetas-tinteiro e outras canetas','Fountain pens and other pens','Estilográficas y otras plumas',11,'96','9608','960830');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96083100','Canetas para desenhar com nanquim','Indian ink drawing pens','Plumas estilogr.p/dibujar c/tinta china',11,'96','9608','960831');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96083900','Outras canetas-tinteiro','Other fountain pens','Las demás estilográficas',11,'96','9608','960839');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96084000','Lapiseiras','Propelling or sliding pencils','Portaminas',11,'96','9608','960840');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96085000','Sortidos de canetas com lapiseiras','Assortments of pens with propelling or sliding pencils','Juegos de bolígrafos con portaminas',11,'96','9608','960850');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96086000','Cargas com ponta, para canetas esferográficas','Refills f/ball point pens,compr.ball point ink-reserv.','Cartuchos de repuesto, c/su ponta p/bolígrafo',11,'96','9608','960860');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96089100','Penas (aparos) e suas pontas, para canetas-tinteiro','Pen nibs and nib points, for fountain pens','Plumillas y puntas para plumillas',11,'96','9608','960891');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96089981','Pontas porosas, para canetas e marcadores','Porous-tipped pens and markers','Puntas porosas, p/canetas y marcadores',10,'96','9608','960899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96089989','Outras partes para canetas, lapiseiras, etc.','Other parts of pens,propelling or sliding pencils,etc.','Las demás partes p/bolígrafos, portaminas, etc',10,'96','9608','960899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96089990','Estiletes para duplicadores, porta-lápis e artigos semelhantes','Duplicating stylos,pencil-holders and similar articles','Estiletes p/clisés de mimeóg, portalápices y arts.simil.',10,'96','9608','960899');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96091000','Lápis','Pencils','Lápices',10,'96','9609','960910');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96092000','Minas para lápis/lapiseiras','Crayons for pencil/mechanical pencils','Minas para lápices/portaminas',10,'96','9609','960920');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96099000','Pasteis, carvões, gizes p/escrever/desenhar e de alfaiate','Pastels,draw.charc.writing/drawing chalks and tailors''','Past.carboncillos, tizas p/escr/dibuj.y jabonc.de sastre',10,'96','9609','960990');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96100000','Lousas e quadros p/escrever/desenhar, mesmo emoldurados','Slates and boards,with writing/drawing surf.incl.framed','Pizarras y tableros p/escribir/dibujar, incl.enmarcados',10,'96','9610','961000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96110000','Carimbos, datadores, numeradores, sinetes e artigos semelhantes','Date,sealing,numbering stamps,signets and the like','Fechadores, sellos, numeradores, timbradores y arts.simil.',10,'96','9611','961100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96121011','Fitas de plástico, c/tinta magnetiz.p/impressão caracter','Plastics ribbons with.magnetiz.dye f/printing','Cintas de plástico, c/tinta magnet.p/impresión caracter',11,'96','9612','961210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96121012','Fitas de plástico, corretivas, para máquinas de escrever','Plastics ribbons,correctors f/typewriters','Cintas de plástico, correctoras, p/máquinas de escribir',11,'96','9612','961210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96121013','Outras fitas de plástico, em cartuchos, paramáquinas de escrever','Other plastics ribbons,in cartridges f/typewriters','Las dem.cintas de plást.en cartuchos, p/máqs.de escribir',11,'96','9612','961210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96121019','Outras fitas impressoras de plástico','Other plastics ribbons','Las demás cintas de plástico',11,'96','9612','961210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96121090','Outras fitas impressoras de outras matérias','Other ribbons of other materials','Las demás cintas de demás materias',11,'96','9612','961210');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96122000','Almofadas de carimbo','Ink-pads','Tampones',11,'96','9612','961220');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96131000','Isqueiros de bolso, a gás, não recarregáveis','Pocket lighters, gas fuelled, non-refillable','Encendedores de gas, n/recargables, de bolsillo',11,'96','9613','961310');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96132000','Isqueiros de bolso, a gás, recarregáveis','Pocket lighters, gas fuelled, refillable','Encendedores de gas recargables,  de bolsillo',11,'96','9613','961320');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96133000','Isqueiros de mesa','Table lighters','Encendedores de mesa',11,'96','9613','961330');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96138000','Outros isqueiros e acendedores','Other lighters','Los demás encendedores y mecheros',11,'96','9613','961380');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96139000','Partes de isqueiros e outros acendedores','Parts of cigarette lighters and other lighters','Partes de encendedores y demás mecheros',10,'96','9613','961390');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96140000','Cachimbos, piteiras para cigarro, suas partes','Pipes, cigarette holders and their parts','Pipas y sus partes',10,'96','9614','961400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96142000','Cachimbos e seus fornilhos','Pipes and pipe bowls','Pipas y cazoletas',11,'96','9614','961420');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96149000','Piteiras (boquilhas) e suas partes','Cigarette-holders (mouthpieces) and parts thereof','Boquillas para cigarros y sus partes',10,'96','9614','961490');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96151100','Pentes e travessas para cabelo, de borracha endur/plástico','Combs and hair-slides,of hard rubber/plastics','Peines, peinetas y pasadores, de caucho endur/plástico',10,'96','9615','961511');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96151900','Outros pentes e travessas para cabelo, de outros matérias','Other combs and hair-slides,of other materials','Los dem.peines, peinetas y pasadores, de demás materias',10,'96','9615','961519');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96159000','Grampos para cabelo, pinças e outros artigos para penteados','Hairpins, tweezers and other articles for hairdos','Horquillas, rizadores y artículos simil.p/el peinado',10,'96','9615','961590');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96161000','Vaporizadores de toucador, armações e suas cabeças','Scent sprays and sim.toilet spr.mounts and heads ther.','Pulverizadores de tocador, monturas y cabezas de mont.',10,'96','9616','961610');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96162000','Borlas/esponjas p/pos/outs.cosmeticos/prods.de toucador','Powder-puffs and pads/oth.comestics/toilet preparations','Borlas/simil.p/aplic.de polvos/ots.cosmét.prods.de toc.',10,'96','9616','961620');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96170010','Garrafa térmica/outs.recip.isoterm.montados, isol.vácuo','Vacuum flasks/other vacuum vessels,complete with cases','Termos/dem.recip.isotérm.montados, aisl.por vacío',10,'96','9617','961700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96170020','Partes de garrafas térmicas e outros recipientes isotérmicos','Parts of thermos flasks and oth.vacuum vessels','Partes de termos y demás recips.isotérmicos',10,'96','9617','961700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96180000','Manequim, automato e cenas animadas p/vitrine/mostruario','Mannequin,autom.and anim.displays f/shop window/dress.','Maniquíes, autómatas y escenas animadas p/escaparates',10,'96','9618','961800');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('96190000','Absorventes e tampoes higienicos,cueiro e fralda p/bebe','Sanitary towels and tampons, diapers, baby diapers','Compresas y tampones higiénicos, pañales para los bebés',10,'96','9619','961900');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('97011000','Quadros, pinturas e desenhos, feitos à mão','Paintings, drawings and pastels, executed by hand','Pinturas y dibujos, hechos a mano',11,'97','9701','970110');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('97019000','Colagens e quadros decorativos semelhantes','Collages and similar ornamental paintings','Collages y cuadros similares',10,'97','9701','970190');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('97020000','Gravuras, estampas e litografias, originais','Original engravings,prints and lithographs','Grabados, estampas y litografías, originales',11,'97','9702','970200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('97030000','Produções originais de arte estatuária ou de escultura','Original sculptures and statuary','Obras originales de estatuaria o escultura',11,'97','9703','970300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('97040000','Selos postais, selos fiscais, marcas postais, etc.','Postage or revenue stamps,stamp-postmarks,etc','Sellos de correo, timbres fiscales, marcas postales, etc',10,'97','9704','970400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('97050000','Coleções e espécime para coleções zoológicas, botânicas, etc','Collections and collectors'' pieces of zoolog.botan.etc.','Colecciones/especímenes p/col.de zoología, botánica, etc',10,'97','9705','970500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('97060000','Antiguidades com mais de 100 anos','Antiques over 100 years old','Antigüedades de más de cien años',10,'97','9706','970600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99900000','Zonas francas (free-shop)','Free-shop','Zonas francas (free-shop)',10,'99','9990','999000');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99910000','Encomendas postais','Parcel post','Encomiendas postales',10,'99','9991','999100');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99920000','Amostras','Samples','Muestras',10,'99','9992','999200');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99930000','Comércio de combustíveis de panol, apetrechos, etc.','Trade of panol fuels, equipments, etc.','Comércio de combustibles de panol, pertrechos, etc',10,'99','9993','999300');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99940000','Mercadorias em devolução','Goods in devolution','Mercancías en devolución',10,'99','9994','999400');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99950000','Mercadorias em arrendamento não financeiro','Goods in leasing no financial','Mercaderias en arriendo',10,'99','9995','999500');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99960000','Bagagem (provenientes de mudanças)','Luggage (coming of changes)','Equipaje (provenientes de mudanzas)',10,'99','9996','999600');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99970000','Mercadorias doadas','Donated goods','Mercancías donadas',10,'99','9997','999700');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99980101','Consumo de bordo - combustíveis e lubrificantes para embarcações','Onboard consump.fuels and lubrication f/embarkations','Consumo de bordo - combustibles y lubric.p/embarcac.',10,'99','9998','999801');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99980102','Consumo de bordo - combustíveis e lubrificantes para aeronaves','Onboard consump.fuels and lubrication f/aircrafts','Consumo de bordo - combustibles y lubric.p/aeronaves',10,'99','9998','999801');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99980201','Consumo de bordo - qualquer outra mercadoria para embarcações','Onboard consump.any other merchandise f/embarkations','Consumo de bordo - cualq.otra mercaderia p/embarcac.',10,'99','9998','999802');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99980202','Consumo de bordo - qualquer outra mercadoria para aeronaves','Onboard consump.any other merchandise f/aircrafts','Consumo de bordo - cualq.otra mercaderia p/aeronaves',10,'99','9998','999802');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99997101','Pedras em bruto do capítulo 71 da NCM','Stones in brute of the  capitulate 71 of NCM','Piedras en bruto del capítulo 71 de la NCM',10,'99','9999','999971');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99997102','Pedras lapidadas/trabalhadas do capítulo 71 da NCM','Cut stones/worked of the  capitulate 71 of NCM','Piedras lapidadas/trabajadas del capítulo 71 de la NCM',10,'99','9999','999971');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99997103','Joalheria de ouro do capitulo 71 da NCM','Jewelry store of gold of the capitulate 71 of NCM','Joyería de oro del capítulo 71 de la NCM',10,'99','9999','999971');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99997104','Outros artigos do capitulo 71 da NCM','Other articles of the capitulate 71 of NCM','Los demás artículos del capítulo 71 de la NCM',10,'99','9999','999971');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99999900','Qualquer outra mercadoria sem cobertura cambial','Any other merchandise without exchange covering','Cualquier otra mercaderia sin cobertura cambiaria',10,'99','9999','999999');
INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('99999960','Reexportação','Reexport','Reexportación',10,'99','9999','999999');
-- INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('XXXXXXXX','Demais produtos','Other products','Los demás productos','XX','XX','XXXX','XXXXXX');
-- INSERT INTO migra_digito (id, dig_portugues, dig_ingles, dig_espanhol, id_unidade, id_capitulo, id_posicao, id_sub_posicao) VALUES ('ZZZZZZZZ','Não declarada / não disponível / Não se aplica','Not stated / not available / not applicable','No se indica / no disponible / no se aplica','ZZ','ZZ','ZZZZ','ZZZZZZ');




INSERT INTO administracao.unidade_medida (cod_unidade, cod_grandeza, nom_unidade, simbolo) VALUES (1, 6, 'Milhões de Kilowatt por Hora', 'mkw/h');
INSERT INTO administracao.unidade_medida (cod_unidade, cod_grandeza, nom_unidade, simbolo) VALUES (5, 3, 'Quilate(s)'                  , 'ql'   );
INSERT INTO administracao.unidade_medida (cod_unidade, cod_grandeza, nom_unidade, simbolo) VALUES (6, 3, 'Tonelada Métrica lìquida'    , 'tml'  );


ALTER TABLE almoxarifado.catalogo_classificacao ALTER COLUMN descricao           TYPE VARCHAR(400);
ALTER TABLE almoxarifado.catalogo_classificacao ADD   COLUMN descricao_ing            VARCHAR(400);
ALTER TABLE almoxarifado.catalogo_classificacao ADD   COLUMN descricao_esp            VARCHAR(400);
ALTER TABLE almoxarifado.catalogo_classificacao ADD   COLUMN estrutural_mercosul      VARCHAR(160);

ALTER TABLE almoxarifado.catalogo_item ALTER COLUMN cod_item_externo   TYPE VARCHAR(160);
ALTER TABLE almoxarifado.catalogo_item ALTER COLUMN descricao_resumida TYPE VARCHAR(150);
ALTER TABLE almoxarifado.catalogo_item ADD   COLUMN descricao_ing           VARCHAR(150);
ALTER TABLE almoxarifado.catalogo_item ADD   COLUMN descricao_esp           VARCHAR(150);


INSERT
  INTO almoxarifado.catalogo
     ( cod_catalogo
     , descricao
     , permite_manutencao
     )
VALUES
     ( (SELECT COALESCE(MAX(cod_catalogo),0) + 1 FROM almoxarifado.catalogo)
     , 'Nomenclatura Comum do Mercosul'
     , TRUE
     );
     
INSERT INTO almoxarifado.catalogo_niveis (nivel, cod_catalogo, mascara, descricao) VALUES (1, (SELECT MAX(cod_catalogo) FROM almoxarifado.catalogo), '99', 'Capitulo'  );
INSERT INTO almoxarifado.catalogo_niveis (nivel, cod_catalogo, mascara, descricao) VALUES (2, (SELECT MAX(cod_catalogo) FROM almoxarifado.catalogo), '99', 'Posição'   );
INSERT INTO almoxarifado.catalogo_niveis (nivel, cod_catalogo, mascara, descricao) VALUES (3, (SELECT MAX(cod_catalogo) FROM almoxarifado.catalogo), '99', 'Subposição');
     
     
CREATE OR REPLACE FUNCTION migra_catalogo() RETURNS VOID AS $$
DECLARE
    inCatalogo          INTEGER;
    inClassificacao     INTEGER;
    idSub               VARCHAR;
    inUnidade           INTEGER;
    inGrandeza          INTEGER;
    stSQL               VARCHAR;
    reRecord            RECORD;
BEGIN

    SELECT MAX(cod_catalogo)
      INTO inCatalogo
      FROM almoxarifado.catalogo
         ;
    
    SELECT COALESCE(MAX(cod_classificacao),0)
      INTO inClassificacao
      FROM almoxarifado.catalogo_classificacao
     WHERE cod_catalogo = inCatalogo
         ;

    RAISE NOTICE '-- CAPITULO --';
    stSQL := '
                SELECT *
                  FROM migra_capitulo
                     ;
             ';
    FOR reRecord IN EXECUTE stSQL LOOP

        inClassificacao := inClassificacao + 1;
    
        INSERT
          INTO almoxarifado.catalogo_classificacao
             ( cod_classificacao
             , cod_catalogo
             , cod_estrutural
             , estrutural_mercosul
             , descricao
             , descricao_ing
             , descricao_esp
             )
        VALUES
             ( inClassificacao
             , inCatalogo
             , LPAD(reRecord.id::VARCHAR,2,'0') || '.00.00'
             , LPAD(reRecord.id::VARCHAR,2,'0')
             , reRecord.cap_portugues
             , reRecord.cap_ingles
             , reRecord.cap_espanhol
             );
             
        INSERT
          INTO almoxarifado.classificacao_nivel
             ( cod_catalogo
             , nivel
             , cod_classificacao
             , cod_nivel
             )
        VALUES
             ( inCatalogo
             , 1
             , inClassificacao
             , LPAD(reRecord.id::VARCHAR,2,'0')::INTEGER
             );

        INSERT
          INTO almoxarifado.classificacao_nivel
             ( cod_catalogo
             , nivel
             , cod_classificacao
             , cod_nivel
             )
        VALUES
             ( inCatalogo
             , 2
             , inClassificacao
             , 0
             );

        INSERT
          INTO almoxarifado.classificacao_nivel
             ( cod_catalogo
             , nivel
             , cod_classificacao
             , cod_nivel
             )
        VALUES
             ( inCatalogo
             , 3
             , inClassificacao
             , 0
             );

    END LOOP;


    RAISE NOTICE '-- POSICAO --';
    stSQL := '
                SELECT *
                  FROM migra_posicao
                     ;
             ';
    FOR reRecord IN EXECUTE stSQL LOOP
    
        inClassificacao := inClassificacao + 1;

        INSERT
          INTO almoxarifado.catalogo_classificacao
             ( cod_classificacao
             , cod_catalogo
             , cod_estrutural
             , estrutural_mercosul
             , descricao
             , descricao_ing
             , descricao_esp
             )
        VALUES
             ( inClassificacao
             , inCatalogo
             , LPAD(reRecord.id_capitulo::VARCHAR,2,'0') || '.' || SUBSTR(LPAD(reRecord.id::VARCHAR,4,'0'),3,2) || '.00'
             , LPAD(reRecord.id::VARCHAR,4,'0')
             , reRecord.pos_portugues
             , reRecord.pos_ingles
             , reRecord.pos_espanhol
             );
             
        INSERT
          INTO almoxarifado.classificacao_nivel
             ( cod_catalogo
             , nivel
             , cod_classificacao
             , cod_nivel
             )
        VALUES
             ( inCatalogo
             , 1
             , inClassificacao
             , LPAD(reRecord.id_capitulo::VARCHAR,2,'0')::INTEGER
             );

        INSERT
           INTO almoxarifado.classificacao_nivel
             ( cod_catalogo
             , nivel
             , cod_classificacao
             , cod_nivel
             )
        VALUES
             ( inCatalogo
             , 2
             , inClassificacao
             , SUBSTR(LPAD(reRecord.id::VARCHAR,4,'0'),3,2)::INTEGER
             );

        INSERT
          INTO almoxarifado.classificacao_nivel
             ( cod_catalogo
             , nivel
             , cod_classificacao
             , cod_nivel
             )
        VALUES
             ( inCatalogo
             , 3
             , inClassificacao
             , 0
             );

    END LOOP;


    RAISE NOTICE '-- SUBPOSICAO --';
    stSQL := '
                SELECT *
                  FROM migra_sub_posicao
                     ;
             ';
    FOR reRecord IN EXECUTE stSQL LOOP
        
        IF SUBSTR(LPAD(reRecord.id::VARCHAR,6,'0'),5,2) = '00' THEN
            idSub := '01';
        ELSE
            idSub := SUBSTR(LPAD(reRecord.id::VARCHAR,6,'0'),5,2);
        END IF;
        
        inClassificacao := inClassificacao + 1;
    
        INSERT
          INTO almoxarifado.catalogo_classificacao
             ( cod_classificacao
             , cod_catalogo
             , cod_estrutural
             , estrutural_mercosul
             , descricao
             , descricao_ing
             , descricao_esp
             )
        VALUES
             ( inClassificacao
             , inCatalogo
             , LPAD(reRecord.id_capitulo::VARCHAR,2,'0') || '.' || SUBSTR(LPAD(reRecord.id_posicao::VARCHAR,4,'0'),3,2) || '.' || idSub
             , LPAD(reRecord.id::VARCHAR,6,'0')
             , reRecord.sub_portugues
             , reRecord.sub_ingles
             , reRecord.sub_espanhol
             );
             
        INSERT
          INTO almoxarifado.classificacao_nivel
             ( cod_catalogo
             , nivel
             , cod_classificacao
             , cod_nivel
             )
        VALUES
             ( inCatalogo
             , 1
             , inClassificacao
             , LPAD(reRecord.id_capitulo::VARCHAR,2,'0')::INTEGER
             );

        INSERT
          INTO almoxarifado.classificacao_nivel
             ( cod_catalogo
             , nivel
             , cod_classificacao
             , cod_nivel
             )
        VALUES
             ( inCatalogo
             , 2
             , inClassificacao
             , SUBSTR(LPAD(reRecord.id_posicao::VARCHAR,4,'0'),3,2)::INTEGER
             );

        INSERT
          INTO almoxarifado.classificacao_nivel
             ( cod_catalogo
             , nivel
             , cod_classificacao
             , cod_nivel
             )
        VALUES
             ( inCatalogo
             , 3
             , inClassificacao
             , idSub::INTEGER
             );

    END LOOP;
    
    stSQL := '
                SELECT *
                  FROM migra_digito
                 WHERE id NOT IN (''ZZZZZZZZ'',''XXXXXXXX'')
                     ;
             ';
    FOR reRecord IN EXECUTE stSQL LOOP
        
        SELECT cod_classificacao
          INTO inClassificacao
          FROM almoxarifado.catalogo_classificacao
         WHERE cod_catalogo = inCatalogo
           AND estrutural_mercosul = SUBSTR(reRecord.id,1,6)
             ;

           IF reRecord.id_unidade = 10 THEN
                inUnidade  := 2;
                inGrandeza := 3;
        ELSIF reRecord.id_unidade = 11 THEN
                inUnidade  := 1;
                inGrandeza := 7;
        ELSIF reRecord.id_unidade = 12 THEN
                inUnidade  := 13;
                inGrandeza := 7;
        ELSIF reRecord.id_unidade = 13 THEN
                inUnidade  := 10;
                inGrandeza := 7;
        ELSIF reRecord.id_unidade = 14 THEN
                inUnidade  := 3;
                inGrandeza := 4;
        ELSIF reRecord.id_unidade = 15 THEN
                inUnidade  := 1;
                inGrandeza := 2;
        ELSIF reRecord.id_unidade = 16 THEN
                inUnidade  := 2;
                inGrandeza := 5;
        ELSIF reRecord.id_unidade = 17 THEN
                inUnidade  := 1;
                inGrandeza := 5;
        ELSIF reRecord.id_unidade = 18 THEN
                inUnidade  := 1;
                inGrandeza := 6;
        ELSIF reRecord.id_unidade = 19 THEN
                inUnidade  := 5;
                inGrandeza := 3;
        ELSIF reRecord.id_unidade = 20 THEN
                inUnidade  := 4;
                inGrandeza := 7;
        ELSIF reRecord.id_unidade = 21 THEN
                inUnidade  := 6;
                inGrandeza := 3;
        ELSIF reRecord.id_unidade = 22 THEN
                inUnidade  := 1;
                inGrandeza := 3;
        END IF;
             
        INSERT
          INTO almoxarifado.catalogo_item
             ( cod_item
             , cod_catalogo
             , cod_classificacao
             , cod_tipo
             , cod_unidade
             , cod_grandeza
             , descricao
             , descricao_ing
             , descricao_esp
             , descricao_resumida
             , ativo
             , cod_item_externo
             )
        VALUES
             ( reRecord.id::integer
             , inCatalogo
             , inClassificacao
             , 0
             , inUnidade
             , inGrandeza
             , reRecord.dig_portugues
             , reRecord.dig_ingles
             , reRecord.dig_espanhol
             , SUBSTR(reRecord.dig_portugues,1,100)
             , TRUE
             , reRecord.id
             );
        
    END LOOP;

END;
$$ LANGUAGE 'plpgsql';

SELECT        migra_catalogo();
DROP FUNCTION migra_catalogo();

DROP TABLE migra_digito;
DROP TABLE migra_sub_posicao;
DROP TABLE migra_posicao;
DROP TABLE migra_capitulo;


----------------
-- Ticket #19926
----------------

CREATE OR REPLACE FUNCTION manutencao() RETURNS VOID AS $$
DECLARE

BEGIN
    PERFORM 1
       FROM pg_type
      WHERE typname ILIKE '%colunasDepreciacaoAcumulada%'
          ;
    IF NOT FOUND THEN
        CREATE TYPE colunasDepreciacaoAcumulada AS ( cod_bem            INTEGER
                                                   , vl_acumulado       NUMERIC(14,2)
                                                   , vl_atualizado      NUMERIC(14,2)
                                                   , vl_bem             NUMERIC(14,2)
                                                   , min_competencia    VARCHAR
                                                   , max_competencia    VARCHAR
                                                   , timestamp          TIMESTAMP
                                                   );
    END IF;
END;
$$ LANGUAGE 'plpgsql';

SELECT        manutencao();
DROP FUNCTION manutencao();
